package com.itopview.wm.cm.formplugin.dynamic;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.sys.utils.RuleSettingsHelper;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.serialization.SerializationUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.filter.FilterCondition;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.control.FilterGrid;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 合同模板调用条件 -动态表单插件
 * @Author LinRui
 * @Date 2024/2/28 11:59
 */
public class ConCallcondEdit extends AbstractFormPlugin {
    private static final String KEY_VCHECK = "tpv_tpl_versioncheckrule";//【校验规则】的单据标识

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"tpv_callcond"});
    }
    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "tpv_callcond" ://调用条件
                int index = this.getModel().getEntryCurrentRowIndex("tpv_entryentity"); //选择当行索引
                DynamicObject tpvApplybill = (DynamicObject) this.getView().getModel().getValue("tpv_applybill",index);//适用单据
                if (null != tpvApplybill){
                    String formkey=tpvApplybill.getString("number");
                    RuleSettingsHelper.showRuleSettings(this, formkey, "tpv_entryentity", "tpv_callcond", "tpv_checkjson");
                }else {
                    this.getView().showTipNotification("请先选择：第" + (index + 1) + "当行【适用单据】！");
                }
                break;
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        String name = e.getProperty().getName();
        int rowIndex = this.getModel().getEntryCurrentRowIndex("tpv_entryentity");
        switch (name) {
            case "tpv_callcond":
                this.getModel().setValue("tpv_checkjson",null, rowIndex);
                break;
            default:
                break;
        }
    }

    @Override
    public void afterCreateNewData(EventObject evt) {
        super.afterCreateNewData(evt);
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        FormShowParameter showParameter = view.getFormShowParameter();
        JSONObject data = JSONObject.parseObject(showParameter.getCustomParam("data"));
        if(data != null) {
            JSONArray listCallcond = data.getJSONArray("listCallcond");
            if(listCallcond.size() > 0) {
                //查询对应的单据主实体,过滤条件-标识跟单据主实体编号
                DynamicObject[] billName = BusinessDataServiceHelper.load("bos_entityobject", "number"
                        , null); //new QFilter[]{new QFilter("number", QCP.in, new String[]{"tpv_dt_purchase","tpv_dt_salescontract"})}
                Map<String, DynamicObject> billMap = new HashMap<>();
                if (null != billName && billName.length > 0) {
                    for (DynamicObject dynamicObject : billName) {
                        billMap.put(dynamicObject.getString("number"),dynamicObject);
                    }
                }
                DynamicObjectCollection tpv_entryentity = model.getDataEntity().getDynamicObjectCollection("tpv_entryentity");
                tpv_entryentity.clear();
                DynamicObject addNew = tpv_entryentity.addNew();
                for (Object object : listCallcond) {
                    JSONObject jsonObject = (JSONObject) object;
                    for (String key : jsonObject.keySet()) {
                        addNew.set("tpv_applybill", billMap.containsKey(key) ? billMap.get(key) : 0l);
                        JSONObject value = (JSONObject) jsonObject.get(key);
                        for (String v_key : value.keySet()) {
                            if ("tpv_type".equals(v_key)) {
                                addNew.set("tpv_type", value.getString(v_key)); //条件类型
                            } else {
                                addNew.set("tpv_callcond", v_key);
                                addNew.set("tpv_checkjson", value.get(v_key));
                            }
                        }
                    }
                }
                this.getView().updateView("tpv_entryentity");
            }
        }

    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String operateKey = e.getOperateKey();
        switch (operateKey) {
            case "ok":
                this.afterDoOK();
                break;
        }
    }

    /**
     * 点击确定回传数据
     */
    private void afterDoOK() {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        JSONArray jsonArray = new JSONArray();
        DynamicObject dataEntity = model.getDataEntity();
        if (null != dataEntity) {
            DynamicObjectCollection dynamicObjects = dataEntity.getDynamicObjectCollection("tpv_entryentity");
            if (dynamicObjects.size() > 0) {
                for (DynamicObject dynamicObject : dynamicObjects) {
                    JSONObject jsonObA = new JSONObject();
                    JSONObject jsonObB = new JSONObject();
                    DynamicObject tpvApplybill = dynamicObject.getDynamicObject("tpv_applybill");
                    if (null != tpvApplybill) {
                        String tpvType = dynamicObject.getString("tpv_type");
                        String tpvCallcond = dynamicObject.getString("tpv_callcond");
                        String tpvCheckjson = dynamicObject.getString("tpv_checkjson");
                        jsonObB.put("tpv_type",tpvType);
                        jsonObB.put(tpvCallcond,tpvCheckjson);
                        jsonObA.put(tpvApplybill.getString("number"),jsonObB);
                        jsonArray.add(jsonObA);
                    }
                }
            }
        }
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("listCallcond",jsonArray);
        view.returnDataToParent(jsonObject);
        view.close();
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);
        String key = e.getActionId();
        switch (key) {
            case KEY_VCHECK :
                this.callBack4CheckRule(e);
                break;
        }
    }

    private void callBack4CheckRule(ClosedCallBackEvent e) {
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        if(actionId != null && returnData != null) {
            IDataModel model = this.getModel();
            JSONObject jsonObj = (JSONObject) returnData;
            int rowIndex = model.getEntryCurrentRowIndex("tpv_entryentity");
            model.beginInit();
            model.setValue("tpv_callcond", jsonObj.getString("tpv_desc"), rowIndex);
            model.endInit();
            model.setValue("tpv_checkjson", jsonObj.toJSONString(), rowIndex);
        }
    }
}
