package com.itopview.wm.cm.formplugin.dynamic;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.MessageTypes;
import kd.bos.form.control.Control;
import kd.bos.form.control.events.BeforeClickEvent;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.plugin.AbstractListPlugin;
import org.apache.commons.lang3.StringUtils;

import java.util.Date;
import java.util.EventObject;
import java.util.HashMap;

/**
 * 诉讼案件
 */
public class LawSuitFillingBacking extends AbstractBillPlugIn {
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        //this.addItemClickListeners("tbmain");
        this.addClickListeners("btncancel", "btnok"); // 监听确认和取消按钮
    }

    @Override
    public void beforeClick(BeforeClickEvent evt) {
        super.beforeClick(evt);
        // 获取被点击的控件对象
        Control source = (Control) evt.getSource();
        // 点击确认按钮
        if (StringUtils.equals(source.getKey(), "btnok")) {
            HashMap<String, Object> hashMap = new HashMap<>();
            // 如果被点击控件为确认，则获取页面相关控件值，组装数据传入returnData返回给父页面，最后关闭页面
            //获取记录日期
            //Date time = (Date) this.getModel().getValue("tpv_jldatetime");
            // 获取记录人
            //DynamicObject recordpeopl = (DynamicObject) this.getModel().getValue("tpv_recordpeopl");
            //获取描述
            String description = (String) this.getModel().getValue("tpv_description");
            //获取单据体
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection entryEntity = dataEntity.getDynamicObjectCollection("tpv_entryentity");

            //判断单据体是否为空
            if (entryEntity.size() > 0) {
                //将单据体的数据包返回给父单据页面,关闭动态表单
                hashMap.put("tpv_entryentity", entryEntity);
                this.getView().returnDataToParent(hashMap);


            }

            }else if (StringUtils.equals(source.getKey(), "btncancel")) {
            // 被点击控件为取消则设置返回值为空并关闭页面（在页面关闭回调方法中必须验证返回值不为空，否则会报空指针）
            this.getView().returnDataToParent(null);
            this.getView().close();
        }
    }


}
