package com.itopview.wm.cm.formplugin.form;

import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.CloseCallBack;
import kd.bos.form.IFormView;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;

/**
 * ClassName: AltimeterVerificateFormPluugin
 * Description: 高低计核销单
 * date: 2023/11/15 10:30
 *
 * @author: Guo jiaChen
 */
public class AltimeterVerificationFormPlugin extends AbstractFormPlugin {

    private static final String VerificationEntryDetail = "tpv_verificatedetail";
    private static final String SettleEntryDetail = "tpv_settledetail";

    /**
     * 监听事件
     *
     * @param e
     */
    @Override
    public void registerListener(EventObject e) {
        this.addItemClickListeners("tpv_toolbarap", "tpv_toolbarap_p");//工具栏
    }


    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();
        if ("tpv_chooseverificate".equals(key)) {
            openDyForm();
        }
        if ("tpv_delete".equals(key)){
            amountta();
        }
//        this.getView().invokeOperation("save");
    }

    /**
     * @Title: openDyForm
     * @Description: 打开动态表单
     */
    private void openDyForm() {
        if (getSettleCurIndex() != -1) {
            DynamicObject value = (DynamicObject) this.getModel().getValue("tpv_cleariparty");
            Long id = value == null ? 0L : value.getLong("id");
            String highorlow = (String) this.getModel().getValue("tpv_highorlow", 0);

            List<Long> list = new ArrayList<>();
            DynamicObjectCollection tpvSettledetail = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_settledetail");
            for (DynamicObject dynamicObject : tpvSettledetail) {
                DynamicObjectCollection tpvVerificatedetails = dynamicObject.getDynamicObjectCollection("tpv_verificatedetail");
                for (int i = 0; i < tpvVerificatedetails.size(); i++) {

                    list.add(Long.valueOf( tpvVerificatedetails.get(i).getString("tpv_srcbillno1")));
                }
            }
            QFilter qFilter = new QFilter("billstatus", QCP.equals, "C");
//            qFilter.and(new QFilter("tpv_unevened", QCP.not_equals, highorlow));
//            qFilter.and(new QFilter("tpv_cleariparty.id", QCP.equals, id));
            if (list.size()!=0){
                qFilter.and(new QFilter("id", QCP.not_in, list));
            }
            ListShowParameter parameter = ShowFormHelper.createShowListForm("tpv_cm_uneven", true);
            parameter.getListFilterParameter().getQFilters()
                    .add(qFilter);
            parameter.setCloseCallBack(new CloseCallBack(this, "verification"));
            this.getView().showForm(parameter);
        } else {
            this.getView().showTipNotification("请先选择结算明细分录中的一行数据");
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
        String key = closedCallBackEvent.getActionId();
        IDataModel model = this.getModel();
        Object returnData = closedCallBackEvent.getReturnData();
        if ("verification".equals(key) && null != returnData) {
            ListSelectedRowCollection rows = ((ListSelectedRowCollection) returnData);
            ArrayList<Long> pkIdList = new ArrayList<>();
            if (rows.size() > 0) {
                for (ListSelectedRow row : rows) {
                    Long primaryKeyValue = (Long) row.getPrimaryKeyValue();
                    pkIdList.add(primaryKeyValue);
                }
                setInvoiceData(pkIdList);//分录赋值
                calculateTaxAmount(getSettleCurIndex());//更新含税金额
            }
        }
        this.getView().invokeOperation("save", YEM.getOptionNoMsg());
    }

    /**
     * @Title: setInvoiceData
     * @Description: 分录填充数据
     * @param:
     * @return: a
     */
    private void setInvoiceData(ArrayList<Long> pkIdList) {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        IDataModel parentModel = view.getParentView().getModel();
        DynamicObjectCollection entity = model.getEntryEntity(VerificationEntryDetail);
        ArrayList<QFilter> filters = new ArrayList<>();
        filters.add(new QFilter("id", QCP.in, pkIdList));//已审核

        BigDecimal amountTaxSum = BigDecimal.ZERO;

        String tpvCmUneven = DynamicObjectUtil.getSelectfields("tpv_cm_uneven", false);
        String tpvAdvconap = DynamicObjectUtil.getEntrySelectfields(tpvCmUneven, "tpv_cm_uneven", "tpv_advconap");
        DynamicObject[] plainDynamicObjectCollection = BusinessDataServiceHelper.load("tpv_cm_uneven",
                tpvAdvconap
                , filters.toArray(new QFilter[0]));
        int index = getSettleCurIndex();
        if (index == -1) {
            return;
        }
        for (DynamicObject rows : plainDynamicObjectCollection) {
//            int i = this.getModel().createNewEntryRow(VerificationEntryDetail);
            this.getModel().setEntryCurrentRowIndex(SettleEntryDetail, index);
            DynamicObjectCollection tpv_advconap = rows.getDynamicObjectCollection("tpv_advconap");

            for (DynamicObject row : tpv_advconap) {
                DynamicObjectCollection settles = this.getModel().getDataEntity(true).getDynamicObjectCollection(SettleEntryDetail);

                BigDecimal tpvUnmtax = settles.get(index).getBigDecimal("tpv_unm");
                BigDecimal tpvAmounttax1 = BigDecimal.ZERO;
                DynamicObjectCollection veri = settles.get(index).getDynamicObjectCollection(VerificationEntryDetail);
                for (DynamicObject dynamicObject : veri) {
                    tpvAmounttax1 = tpvAmounttax1.add(dynamicObject.getBigDecimal("tpv_amountnotax1"));
                }

                BigDecimal tpvUnwtax = row.getBigDecimal("tpv_unw");//未核销金额（含税）
                BigDecimal taxAmounts = row.getBigDecimal("tpv_taxamounts");
                BigDecimal vatrates = row.getBigDecimal("tpv_vatrates");
                amountTaxSum = amountTaxSum.add(taxAmounts);

                DynamicObjectCollection entity1 = model.getEntryEntity(SettleEntryDetail);
                DynamicObject object = entity1.get(index);
                DynamicObjectCollection collection = object.getDynamicObjectCollection(VerificationEntryDetail);
                DynamicObject addNew = collection.addNew();
                addNew.set("tpv_altimeternum1", rows.get("billno"));//高低计单号
                addNew.set("tpv_salecontract1", row.get("tpv_saleconums"));//销售合同号
                addNew.set("tpv_purcontract1", row.get("tpv_purconums"));//采购合同号
                addNew.set("tpv_salenums1", row.getDynamicObject("tpv_saleconums") != null ? row.getDynamicObject("tpv_saleconums").get("tpv_name") : "");//销售合同号(文本)
                addNew.set("tpv_purconnum1", row.getDynamicObject("tpv_purconums") != null ? row.getDynamicObject("tpv_purconums").get("tpv_name") : "");//采购合同号(文本)
                addNew.set("tpv_highorlow1", rows.get("tpv_unevened"));//高计/低计
                addNew.set("tpv_customer1", rows.get("tpv_cleariparty"));//结算方
                addNew.set("tpv_material1", row.get("tpv_itemcodes"));//商品编码
                addNew.set("tpv_businesstype1", row.get("tpv_businesstype"));//业务类型
                addNew.set("tpv_prodname1", row.get("tpv_conprodname"));//品名
                addNew.set("tpv_description1", row.get("tpv_description"));//商品描述
                addNew.set("tpv_tradepropertys1", row.get("tpv_tradepropertys"));//贸易性质

                BigDecimal intaxrat = vatrates.divide(new BigDecimal(100));
                if (tpvUnmtax.compareTo(tpvAmounttax1) > 0) {
                    BigDecimal tpvUnmAmount = tpvUnmtax.subtract(tpvAmounttax1);
                    if (tpvUnwtax.compareTo(tpvUnmAmount) > 0) {
                        addNew.set("tpv_amountnotax1", tpvUnmAmount);//核销金额不含税
                        BigDecimal multiply = tpvUnmAmount.multiply(BigDecimal.ONE.add(row.getBigDecimal("tpv_vatrates").divide(new BigDecimal(100))));
                        addNew.set("tpv_amounttax1", multiply);//核销金额含税
                        addNew.set("tpv_amountintax1",multiply.subtract(tpvUnmAmount));//增值税额
                    } else {
                        addNew.set("tpv_amountnotax1", tpvUnwtax);//核销金额不含税
                        BigDecimal multiply = tpvUnwtax.multiply(BigDecimal.ONE.add(row.getBigDecimal("tpv_vatrates").divide(new BigDecimal(100))));
                        addNew.set("tpv_amounttax1",multiply );//核销金额含税
                        addNew.set("tpv_amountintax1",multiply.subtract(tpvUnwtax));//增值税额
                    }

                } else {
                    addNew.set("tpv_amountnotax1", BigDecimal.ZERO);//核销金额不含税
                    addNew.set("tpv_amounttax1", BigDecimal.ZERO);//核销金额含税
                }

                addNew.set("tpv_intaxrate1", row.get("tpv_vatrates"));//增值税率
//                addNew.set("tpv_amountintax1", row.get("tpv_amountincrea"));//增值税额
//                addNew.set("tpv_amountnotax1", row.get("tpv_notaxamounts"));//不含税金额
                addNew.set("tpv_dept1", row.get("tpv_departmet"));//部门
                addNew.set("tpv_user1", row.get("tpv_crew"));//人员
                addNew.set("tpv_firm1", row.get("tpv_firm"));//公司
                addNew.set("tpv_altverunmtax", row.get("tpv_unwtax"));//未核销金额（含税）
                addNew.set("tpv_altverunm", row.get("tpv_unw"));//未核销金额（不含税）
                addNew.set("tpv_srcbillentryid1", row.getLong("id"));//来源单据分录id
                addNew.set("tpv_srcbillno1", rows.getLong("id"));//来源单据id
            }

        }
//        DynamicObjectCollection tpvSettledetails = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_settledetail");
//        for (DynamicObject tpvSettledetail : tpvSettledetails) {
//            BigDecimal tpvUnm = tpvSettledetail.getBigDecimal("tpv_unmtax");//未核销金额（含税）  结算明细
//            DynamicObjectCollection tpvVerificatedetail = tpvSettledetail.getDynamicObjectCollection("tpv_verificatedetail");
//            for (int i = 0; i < tpvVerificatedetail.size(); i++) {
//                BigDecimal tpvAltverunmtax = tpvVerificatedetail.get(i).getBigDecimal("tpv_altverunmtax");//未核销金额（含税）  核销明细
//                BigDecimal amounttax = BigDecimal.ZERO;
//                if (tpvUnm.subtract(tpvAltverunmtax).compareTo(BigDecimal.ZERO) <= 0) {
//                    amounttax = BigDecimal.ZERO;
//                } else {
//                    amounttax = tpvUnm.subtract(tpvAltverunmtax);
//                }
//                this.getModel().setValue("tpv_amounttax", amounttax, i);
//            }
//        }
        this.getView().updateView(SettleEntryDetail);
        this.getView().updateView(VerificationEntryDetail);
        EntryGrid control = this.getControl(SettleEntryDetail);
        control.selectRows(index);
    }


    private Map<String, Object> setInfo() {
        HashMap<String, Object> map = new HashMap<>();
        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_settledetail");
        if (entity.get(0) != null) {
            DynamicObject value = (DynamicObject) this.getModel().getValue("tpv_customer", 0);
            long id = value.getLong("id");
            map.put("customer", id);
            map.put("highorlow", (DynamicObject) this.getModel().getValue("tpv_highorlow", 0));
            return map;
        } else {
            return null;
        }
    }

    private int getSettleCurIndex() {
        EntryGrid control = this.getControl(SettleEntryDetail);
        int[] selectRows = control.getSelectRows();
        int index = -1;
        if (selectRows.length > 0) {
            index = selectRows[0];
        }
        return index;
    }

    /**
     * 值更新事件
     *
     * @param e
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData[] changeData = e.getChangeSet();
        int index = changeData[0].getParentRowIndex();
        switch (name) {
            case "tpv_amountnotax1":
            case "tpv_intaxrate1":
            case "tpv_amounttax1":
                amountta();
                calculateTaxAmount(index);
                break;
            case "tpv_amountintax1":
                DynamicObjectCollection tpvSettledetail = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_settledetail");
                for (DynamicObject dynamicObject : tpvSettledetail) {
                    DynamicObjectCollection tpvVerificatedetails = dynamicObject.getDynamicObjectCollection("tpv_verificatedetail");
                    for (int i = 0; i < tpvVerificatedetails.size(); i++) {
                        BigDecimal tpvAmountintax1 = tpvVerificatedetails.get(i).getBigDecimal("tpv_amountintax1");//核销金额（增值税额）
                        BigDecimal tpvAmountnotax1 = tpvVerificatedetails.get(i).getBigDecimal("tpv_amountnotax1");//核销金额（不含税）
                        this.getModel().beginInit();
                        this.getModel().setValue("tpv_amounttax1",tpvAmountintax1.add(tpvAmountnotax1),i);
                        this.getModel().endInit();
                    }
                }
                this.getView().updateView("tpv_verificatedetail");
                break;
            default:
                break;
        }
    }

    private void amountta() {
        DynamicObjectCollection tpvSettledetails = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_settledetail");
        for (DynamicObject tpvSettledetail : tpvSettledetails) {
            DynamicObjectCollection tpvVerificatedetails = tpvSettledetail.getDynamicObjectCollection("tpv_verificatedetail");
            for (int i = 0; i < tpvVerificatedetails.size(); i++) {
                BigDecimal tpvAltverunm = BigDecimal.ZERO;//核销金额（不含税）
                BigDecimal tpvAmounttax1 = tpvVerificatedetails.get(i).getBigDecimal("tpv_amounttax1");//核销金额（含税）
                BigDecimal tpvIntaxrate1 = tpvVerificatedetails.get(i).getBigDecimal("tpv_intaxrate1");//增值税率
                BigDecimal tpvAmountintax1 = tpvVerificatedetails.get(i).getBigDecimal("tpv_amountintax1");//核销金额（增值税额）

                BigDecimal intaxrat = tpvIntaxrate1.divide(new BigDecimal(100));
                tpvAltverunm=tpvAmounttax1.divide(BigDecimal.ONE.add(intaxrat),2,RoundingMode.HALF_UP).multiply(intaxrat).setScale(2,RoundingMode.HALF_UP);
                this.getModel().beginInit();
                this.getModel().setValue("tpv_amountintax1",tpvAltverunm,i);

                this.getModel().setValue("tpv_amountnotax1",tpvAmounttax1.subtract(tpvAltverunm),i);
                this.getModel().endInit();
            }

        }
        DynamicObjectCollection tpvSettledetail = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_settledetail");

        for (int i = 0; i < tpvSettledetail.size(); i++) {
            DynamicObjectCollection tpvVerificatedetail = tpvSettledetail.get(i).getDynamicObjectCollection("tpv_verificatedetail");
            BigDecimal amounttax = BigDecimal.ZERO;
            BigDecimal altveramt = BigDecimal.ZERO;
            BigDecimal amountintax1 = BigDecimal.ZERO;
            for (DynamicObject dynamicObject : tpvVerificatedetail) {
                amounttax = amounttax.add(dynamicObject.getBigDecimal("tpv_amounttax1"));
                altveramt = altveramt.add(dynamicObject.getBigDecimal("tpv_amountnotax1"));
                amountintax1 = amountintax1.add(dynamicObject.getBigDecimal("tpv_amountintax1"));
            }
            this.getModel().setValue("tpv_amounttax",amounttax,i);
            this.getModel().setValue("tpv_altveramt",altveramt,i);
            this.getModel().setValue("tpv_amountintax", amountintax1);
        }

    }

    private void calculateTaxAmount(int index) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvSettledetails = dataEntity.getDynamicObjectCollection("tpv_settledetail");
        for (DynamicObject tpvSettledetail : tpvSettledetails) {
            BigDecimal tpvUnm = tpvSettledetail.getBigDecimal("tpv_unm");//未核销金额（不含税） 结算明细
            BigDecimal decimal = BigDecimal.ZERO;
            DynamicObjectCollection tpvVerificatedetails = tpvSettledetail.getDynamicObjectCollection("tpv_verificatedetail");
            for (int i = 0; i < tpvVerificatedetails.size(); i++) {
                BigDecimal tpvAmounttax1 = tpvVerificatedetails.get(i).getBigDecimal("tpv_amountnotax1").setScale(0, RoundingMode.DOWN);//核销金额（不含税） 核销明细
                BigDecimal tpvAltverunm = tpvVerificatedetails.get(i).getBigDecimal("tpv_altverunm");//未核销金额（不含税） 核销明细
                if (tpvAmounttax1.compareTo(tpvAltverunm) > 0) {
//                    this.getView().showTipNotification("核销金额（不含税）大于未核销金额（不含税）！");
//                    this.getModel().setValue("tpv_amounttax1", BigDecimal.ZERO, i);
                }
            }
            for (DynamicObject tpvVerificatedetail : tpvVerificatedetails) {
                decimal = decimal.add(tpvVerificatedetail.getBigDecimal("tpv_amountnotax1"));
            }
            if (tpvUnm.compareTo(decimal) < 0) {
//                this.getView().showTipNotification("核销明细的核销金额不含税的汇总大于结算明细的未核销金额不含税！");
//                this.getModel().setValue("tpv_amounttax1", BigDecimal.ZERO, index);
            }
            BigDecimal amounttax = BigDecimal.ZERO;
            BigDecimal altveramt = BigDecimal.ZERO;
            BigDecimal amountintax1 = BigDecimal.ZERO;
            for (DynamicObject tpvVerificatedetail : tpvVerificatedetails) {
                amounttax = amounttax.add(tpvVerificatedetail.getBigDecimal("tpv_amounttax1"));
                altveramt = altveramt.add(tpvVerificatedetail.getBigDecimal("tpv_amountnotax1"));
                amountintax1 = amountintax1.add(tpvVerificatedetail.getBigDecimal("tpv_amountintax1"));
            }
            tpvSettledetail.set("tpv_amounttax", amounttax);
            tpvSettledetail.set("tpv_altveramt", altveramt);
            tpvSettledetail.set("tpv_amountintax", amountintax1);
        }
        this.getView().updateView(SettleEntryDetail);
        this.getView().updateView(VerificationEntryDetail);
    }

}
