package com.itopview.wm.cm.formplugin.form;

import com.alibaba.nacos.common.utils.StringUtils;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.math.BigDecimal;
import java.util.EventObject;

/**
 * @author: He
 * @Project: JavaLaity
 * @Package: com.itopview.wm.cm.formplugin.dynamic.ApplierCarryOrg
 * @Date: 2023年08月25日 15:10
 * @Description: 申请人带出申请部门
 **/
public class ApplierCarryOrgFormPlugin extends AbstractBillPlugIn {
    //用户名标识
    private static final String KEY_APPLIER = "tpv_operator";

    //所属部门
    private static final String DEPARTMENT = "tpv_department";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tbmain");
        //过滤字段监听
        BasedataEdit applier = this.getControl("tpv_operator");
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();
        switch (key) {
            case "tpv_apforwordquotabtn":
                BigDecimal tpvApforwordquota = (BigDecimal) this.getModel().getValue("tpv_apforwordquota");
                this.getView().getPageCache().put("tpv_apforwordquota",tpvApforwordquota.toString());
                matchInvoice("tpv_apforworddy", "tpv_apforwordquota");//批复远期实付额度
                break;
            case "tpv_apspotpayquotabtn":
                BigDecimal tpvApspotpayquota = (BigDecimal) this.getModel().getValue("tpv_apspotpayquota");
                this.getView().getPageCache().put("tpv_apspotpayquota",tpvApspotpayquota.toString());
                matchInvoice("tpv_apspotpaydy", "tpv_apspotpayquota");//批复现货实付额度
                break;
        }
//        if ("tpv_apforwordquotabtn".equals(key) || "tpv_apspotpayquotabtn".equals(key)) {
//            DynamicObject dataEntity = this.getModel().getDataEntity(true);
//            OperationServiceHelper.executeOperate("save", "tpv_bd_supticket",
//                    new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
//            this.getView().updateView();
//        }
    }
    private void matchInvoice(String name, String actionID) {
        //创建动态表达页面对象
        FormShowParameter showParameter = new FormShowParameter();
        //设置页面ID
        showParameter.setFormId(name);
        //状态
        showParameter.setStatus(OperationStatus.ADDNEW);
        //设置回调
        showParameter.setCloseCallBack(new CloseCallBack(this, actionID));
        // 设置弹出页面打开方式
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        // 打开动态表单
        this.getView().showForm(showParameter);

    }

    @Override
    public void closedCallBack(ClosedCallBackEvent evt) {
        super.closedCallBack(evt);
        Object returnData = evt.getReturnData();
        if (StringUtils.equals(evt.getActionId(), "tpv_apforwordquota")) {
            String apforwordquota = this.getView().getPageCache().get("tpv_apforwordquota");
            BigDecimal tpvApforwordquota = (BigDecimal) this.getModel().getValue("tpv_apforwordquota");
            if (!tpvApforwordquota.toString().equals(apforwordquota)) {
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                OperationServiceHelper.executeOperate("save", "tpv_bd_supticket",
                        new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
                this.getView().updateView();
            }
        }
        if (StringUtils.equals(evt.getActionId(), "tpv_apspotpayquota")) {
            String apspotpayquota = this.getView().getPageCache().get("tpv_apspotpayquota");
            BigDecimal tpvApspotpayquota = (BigDecimal) this.getModel().getValue("tpv_apspotpayquota");
            if (!tpvApspotpayquota.toString().equals(apspotpayquota)) {
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                OperationServiceHelper.executeOperate("save", "tpv_bd_supticket",
                        new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
                this.getView().updateView();
            }
        }
    }

    //值更新事件
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        //获取名称
        String name = e.getProperty().getName();
//        if (name.equals(KEY_APPLIER)) {
//            this.getOrgByApplier();
//        }
    }

    //根据申请人获取申请部门
    private void getOrgByApplier() {
        DynamicObject applier = (DynamicObject) this.getModel().getValue(KEY_APPLIER);
        if (applier != null) {
            //根据其id查询组织
            long userMainOrgId = UserServiceHelper.getUserMainOrgId(applier.getLong("id"));
            this.getModel().setValue(DEPARTMENT, userMainOrgId);
        }
    }
}
