package com.itopview.wm.cm.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;

import java.math.BigDecimal;
import java.math.RoundingMode;

/**
 * 市场底价值改变
 * WangShuGuang
 */
public class BazaarPriceFormPlugin extends AbstractBillPlugIn {

    @Override
    public void propertyChanged(PropertyChangedArgs e) {//触发时机：表单模型某个字段值改变的时候就会触发此事件//
        String propertyName = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        //监听单价字段
        if (propertyName.equals("tpv_unitprice")) {
            decimals(cd);//原料成品对应关系改变计算方式改变
        }
    }

    private void decimals(ChangeData cd) {
        BigDecimal tpvUnitprice = (BigDecimal) this.getModel().getValue("tpv_unitprice");
        BigDecimal result = tpvUnitprice.setScale(2, RoundingMode.HALF_UP);
        this.getModel().setValue("tpv_unitprice", result);
        //this.getView().updateView();
    }
}
