package com.itopview.wm.cm.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
/**
 * 条款类型：给名称赋值
 * @author zhangh
 *
 */
public class ClauseTypeFormPlugin extends AbstractBillPlugIn {
	@Override
	public void propertyChanged(PropertyChangedArgs e) {
		String name = e.getProperty().getName();
		switch (name) {
		case "tpv_chinanum":
		case "tpv_clausename":
		case "tpv_english":
			this.setClauseName();
			break;

		default:
			break;
		}
	}

	/**
	 * 给标准名称赋值
	 */
	private void setClauseName() {
		String tpv_chinanum = (String) this.getModel().getValue("tpv_chinanum");
		String tpv_clausename = (String) this.getModel().getValue("tpv_clausename");
		String tpv_english = (String) this.getModel().getValue("tpv_english");
		
		if (StringUtils.isNotEmpty(tpv_english)) {
			LocaleString locStr = new LocaleString();
			locStr.setLocaleValue_zh_CN(tpv_chinanum + "、" + tpv_clausename);
			locStr.setLocaleValue_en(tpv_english);
			this.getModel().setValue("name", locStr);
		}else {
			this.getModel().setValue("name", tpv_chinanum + "、" + tpv_clausename);
		}
	}
}
