package com.itopview.wm.cm.formplugin.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.list.IListView;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * ClassName: FlexiblelimitBaseListPlugin
 * Description:弹性额度设置(列表插件)
 * date: 2023/8/29 14:38
 *
 * @author: chen
 * @version:
 * @since JDK 1.8
 */
public class FlexiblelimitedBaseListPlugin extends AbstractListPlugin {

    /**
     * 点击事件
     *
     * @param evt
     */
    @Override
    public void beforeItemClick(BeforeItemClickEvent evt) {
        super.beforeItemClick(evt);
        String key = evt.getItemKey();
        IListView listview = (IListView) this.getView();
        String formId = ((IListView) this.getView()).getBillFormId();// 获取单据标识
        ListSelectedRowCollection rows = listview.getCurrentListAllRowCollection();//获取所有行
        ListSelectedRowCollection selectedRows = listview.getSelectedRows();//获取选中行
        if ("tblenable".equals(key)) {
            if (selectedRows.size() != 1) {
                this.getView().showTipNotification("当前只允许一条数据生效,请选择单条数据!");
                evt.setCancel(true);
            } else {
                this.setOtherEnables(rows, formId);//修改其他单据的使用状态=禁用
                this.setEnable(selectedRows, formId);//启用选中该的单据
                //更新字段
                ((IListView) this.getView()).updateView("enable");
                // ((IListView) this.getView()).refresh();
            }
        }
    }


    /**
     * @param selectedRows
     * @param formId
     */
    private void setEnable(ListSelectedRowCollection selectedRows, String formId) {
        if (selectedRows != null && selectedRows.size() > 0) {
            // 创建用于保存新数据的集合
            List<DynamicObject> updatedRowData = new ArrayList<DynamicObject>();

            for (ListSelectedRow listSelectedRow : selectedRows) { // 遍历选中数据的单据
                Object primaryKeyValue = listSelectedRow.getPrimaryKeyValue(); // 获取单据pkid
                // 获取单据信息
                DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(primaryKeyValue, formId);
                // 修改采购信息为是
                loadSingle.set("enable", 1);
                // 将修改后的数据存入集合
                updatedRowData.add(loadSingle);
            }
            if (updatedRowData.size() > 0) {
                // 保存修改后的数据
                SaveServiceHelper.update(updatedRowData.toArray(new DynamicObject[]{}));

            }
        }
    }


    /**
     * 修改其他单据的使用状态
     *
     * @param rows
     * @param formId
     */
    private void setOtherEnables(ListSelectedRowCollection rows, String formId) {

        if (rows != null && rows.size() > 0) {
            // 创建用于保存新数据的集合
            List<DynamicObject> updatedRowData = new ArrayList<DynamicObject>();

            for (ListSelectedRow row : rows) { // 遍历选中数据的单据
                Object primaryKeyValue = row.getPrimaryKeyValue(); // 获取单据pkid
                // 获取单据信息
                DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(primaryKeyValue, formId);
                // 修改使用状态为禁用
                if (loadSingle.getInt("enable") == 1) {
                    loadSingle.set("enable", 0);
                }
                // 将修改后的数据存入集合
                updatedRowData.add(loadSingle);
            }
            if (updatedRowData.size() > 0) {
                // 保存修改后的数据
                SaveServiceHelper.update(updatedRowData.toArray(new DynamicObject[]{}));

            }
        }
    }
}
