package com.itopview.wm.cm.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;

import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.EntryProp;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.Toolbar;
import kd.bos.form.control.events.CellClickListener;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;


import java.math.BigDecimal;
import java.util.*;

/**
 * 高低计规划单
 *
 * @author LiuHB
 * @version 1.0
 */
public class PlannedFormPlugin extends AbstractBillPlugIn {
    //规划明细子分录
    private static String TPE = "tpv_programme";
    private final static String KEY_MBAR = "tbmain";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        // 侦听单据体表格事件
        EntryGrid entryGrid = this.getView().getControl(TPE);
        Toolbar mbar = this.getView().getControl(KEY_MBAR); //toobar工具栏
    }


    /**
     * 单据体新增行
     *
     * @param e
     */
    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        if (StringUtils.equals(TPE, e.getEntryProp().getName())) {
            long tpvCustomerfid = 0L;
            long tpvCurrencyfid = 0L;
            long tpvUserid = 0L;
            long tpvDepartmentfid = 0L;
            int index = this.getModel().getEntryCurrentRowIndex("tpv_settlement");
            DynamicObject selectedData = this.getModel().getEntryRowEntity("tpv_settlement", index);
            DynamicObject tpvCustomerf = selectedData.getDynamicObject("tpv_customerf");
            if (tpvCustomerf != null) {
                tpvCustomerfid = tpvCustomerf.getLong("id");
            }
            DynamicObject tpvCurrencyf = selectedData.getDynamicObject("tpv_currencyf");
            if (tpvCurrencyf != null) {
                tpvCurrencyfid = tpvCurrencyf.getLong("id");
            }
            DynamicObject tpvUser = selectedData.getDynamicObject("tpv_user");
            if (tpvUser != null) {
                tpvUserid = tpvUser.getLong("id");
            }
            DynamicObject tpvDepartmentf = selectedData.getDynamicObject("tpv_departmentf");
            if (tpvDepartmentf != null) {
                tpvDepartmentfid = tpvDepartmentf.getLong("id");
            }
            long tpvEntryids = selectedData.getLong("tpv_entryids");
            //如果规划明细子分录新增行对规划采购/销售合同号进行锁定解锁
            DynamicObjectCollection tpvProgramme = this.getView().getModel().getEntryEntity(TPE);
            for (DynamicObject dynamicObject : tpvProgramme) {
                int rowIndex = tpvProgramme.indexOf(dynamicObject);
                amout(rowIndex);
                this.getModel().setValue("tpv_planforcustomers", tpvCustomerfid, rowIndex);
                this.getModel().setValue("tpv_currencyed", tpvCurrencyfid, rowIndex);
                this.getModel().setValue("tpv_personnel", tpvUserid, rowIndex);
                this.getModel().setValue("tpv_departmento", tpvDepartmentfid, rowIndex);
                this.getModel().setValue("tpv_entryidup", tpvEntryids, rowIndex);
            }
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData[] changeData = e.getChangeSet();
        //获取分录的行下标
        int rowIndex = changeData[0].getRowIndex();
        //监听单据类型修改
        if ("tpv_documenttype".equals(name)) {

            amout(rowIndex);

        }

    }

    /**
     * 根据单据类型锁定解锁规划采购/销售合同号
     * A/B锁定规划采购合同号解锁规划销售合同号
     * C规划销售合同号解锁规划采购合同号
     *
     * @param rowIndex
     */
    private void amout(int rowIndex) {
        String tpvDocumenttype = (String) this.getModel().getValue("tpv_documenttype");//单据类型
        BasedataEdit purchasecontr = this.getView().getControl("tpv_purchasecontr");//规划采购合同号
        BasedataEdit contractnu = this.getView().getControl("tpv_contractnu");//规划销售合同号
        if (tpvDocumenttype == null) {
            contractnu.setEnable("", false, rowIndex);
            purchasecontr.setEnable("", false, rowIndex);
        } else if ("A".equals(tpvDocumenttype) || "B".equals(tpvDocumenttype)) {
            contractnu.setEnable("", true, rowIndex);
            purchasecontr.setEnable("", false, rowIndex);
            this.getModel().setValue("tpv_purchasecontr", "", rowIndex);
        } else if (tpvDocumenttype.equals("C")) {
            purchasecontr.setEnable("", true, rowIndex);
            contractnu.setEnable("", false, rowIndex);
            this.getModel().setValue("tpv_contractnu", "", rowIndex);
        }
    }

    /**
     * 单据打开锁定分录规划采购/销售合同号字段
     *
     * @param e
     */
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        DynamicObjectCollection tpvProgramme = this.getView().getModel().getEntryEntity(TPE);
        BasedataEdit purchasecontr = this.getView().getControl("tpv_purchasecontr");
        BasedataEdit contractnu = this.getView().getControl("tpv_contractnu");
        for (DynamicObject dynamicObject : tpvProgramme) {
            int rowIndex = tpvProgramme.indexOf(dynamicObject);
            String tpvDocumenttype = dynamicObject.getString("tpv_documenttype");
            if (tpvDocumenttype == null) {
                contractnu.setEnable("", false, rowIndex);
                purchasecontr.setEnable("", false, rowIndex);
            }
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);

    }
}
