package com.itopview.wm.cm.formplugin.form;

import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.RefBillProp;
import kd.bos.entity.property.TextProp;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.RefBillEdit;
import kd.bos.form.field.TextEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.EventObject;
import java.util.List;

/**
 * @author ljw
 * @date 2023/9/22 15:54
 * @className PlanningBillPlugIn
 * @description 规划单表单插件
 * ljwxj
 */
public class PlanningBillPlugIn extends AbstractBillPlugIn implements BeforeF7SelectListener {
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();//获取分录的行下标
        DynamicObject dataEntity = changeData[0].getDataEntity();//获取值
        String propertyName = e.getProperty().getName();
        switch (name) {
            //高计单号
            case "tpv_highcoun":
                setIsFreeze(rowIndex);
                break;
            case "tpv_contractnu":
                contractnu(rowIndex);
                break;
            case  "tpv_documenttype":
                amout(rowIndex);
                break;
        }
    }

    /**
     *
     * @param rowIndex 设置必录
     */
    private void amout(int rowIndex) {
        String tpv_documenttype = (String) this.getModel().getValue("tpv_documenttype");
        if (tpv_documenttype.equals("A")){
            RefBillEdit  textEdits = this.getView().getControl("tpv_purchasecontrs");
            textEdits.setMustInput(true);
            RefBillProp textProps = (RefBillProp ) textEdits.getProperty();
            textProps.setMustInput(true);
            RefBillEdit  textEdit = this.getView().getControl("tpv_contractnus");
            textEdit.setMustInput(false);
            RefBillProp textProp = (RefBillProp ) textEdit.getProperty();
            textProp.setMustInput(false);
        }else {
            RefBillEdit  textEdit = this.getView().getControl("tpv_contractnus");
            textEdit.setMustInput(true);
            RefBillProp textProp = (RefBillProp ) textEdit.getProperty();
            textProp.setMustInput(true);
            RefBillEdit  textEdits = this.getView().getControl("tpv_purchasecontrs");
            textEdits.setMustInput(false);
            RefBillProp textProps = (RefBillProp ) textEdits.getProperty();
            textProps.setMustInput(false);
        }

    }
    /**
     *
     * @param rowIndex 规划分录赋值
     */
    private void contractnu(int rowIndex) {
        DynamicObject tpv_contractnu = (DynamicObject) this.getModel().getValue("tpv_contractnu");
        String string = tpv_contractnu.getString("billno");
        String selectfields = DynamicObjectUtil.getSelectfields("tpv_dt_salescontract", false);
        //高低计单
        DynamicObject[] salescontract = BusinessDataServiceHelper.load("tpv_dt_salescontract", selectfields
                , new QFilter[]{new QFilter("billno",QCP.equals,string)});
        if (salescontract.length > 0) {
            for (int i = 0; i < salescontract.length; i++) {
                DynamicObject tp_freigro = salescontract[i];
                DynamicObject tpv_department = tp_freigro.getDynamicObject("tpv_department");//部门
                DynamicObject tpv_customer = tp_freigro.getDynamicObject("tpv_customer");//客户
                DynamicObject tpv_currency = tp_freigro.getDynamicObject("tpv_currency");//币别
                DynamicObject tpv_operator = tp_freigro.getDynamicObject("tpv_operator");//人员
                this.getModel().setValue("tpv_planforcustomers",tpv_customer,rowIndex);
                this.getModel().setValue("tpv_currencyed",tpv_currency,rowIndex);
                this.getModel().setValue("tpv_departmento",tpv_department,rowIndex);
                this.getModel().setValue("tpv_personnel",tpv_operator,rowIndex);
            }
        }
    }

    /**
     *
     * @param rowIndex 结算分录赋值
     */
    private void setIsFreeze(int rowIndex) {
        DynamicObject tpv_highcoun = (DynamicObject) this.getModel().getValue("tpv_highcoun");
        String string = tpv_highcoun.getString("billno");
        QFilter qFilter = new QFilter("billno", QCP.equals, string);
        qFilter.and("tpv_highjlowj", QCP.equals, "A");
        String selectfields = DynamicObjectUtil.getSelectfields("tpv_dt_highlowj", false);
        String entrySelectfields = DynamicObjectUtil.getEntrySelectfields(selectfields, "tpv_dt_highlowj", "tpv_dt_highlowj_si", false);
        //高低计单
        DynamicObject[] purchases = BusinessDataServiceHelper.load("tpv_dt_highlowj", entrySelectfields
                , new QFilter[]{qFilter});
        if (purchases.length > 0) {
            for (int i = 0; i < purchases.length; i++) {
                DynamicObject tp_freigro = purchases[i];
                DynamicObjectCollection tpvMaterialentry = tp_freigro.getDynamicObjectCollection("tpv_dt_highlowj_si");
                for (DynamicObject dynamicObject : tpvMaterialentry) {
//                    int entryRow = this.getModel().createNewEntryRow("tpv_cm_planning_js");
                    BigDecimal tpv_quantity=BigDecimal.ZERO;//卷号数量合计
                    String tpv_businesstype = dynamicObject.getString("tpv_businesstype");//业务类型
                    DynamicObject tpv_salescontract = dynamicObject.getDynamicObject("tpv_salescontract");//销售合同
                    DynamicObject tpv_purchasecontract = dynamicObject.getDynamicObject("tpv_purchasecontract");//采购合同
                    DynamicObject tpv_clientele = dynamicObject.getDynamicObject("tpv_clientele");//客户
                    DynamicObject tpv_currency = tp_freigro.getDynamicObject("tpv_currency");//币种
                    BigDecimal tpv_nocavamount = dynamicObject.getBigDecimal("tpv_nocavamount");//未核销金额
                    DynamicObjectCollection tpv_cm_planning_gh= (DynamicObjectCollection) this.getModel().getValue("tpv_cm_planning_gh");//分录数据
                    tpv_quantity=BigDecimal.ZERO;
                    for (DynamicObject subentrty:tpv_cm_planning_gh){
                        tpv_quantity=tpv_quantity.add(subentrty.getBigDecimal("tpv_amount"));
                    }
                    BigDecimal tpv_plannedjssj = BigDecimal.ZERO;
                    if (tpv_quantity.compareTo(BigDecimal.ZERO) == 1) {
                        tpv_plannedjssj = tpv_nocavamount.subtract(tpv_quantity);
                    } else {
                        tpv_plannedjssj = tpv_nocavamount;
                    }
                    Date tpv_bizdate = tp_freigro.getDate("tpv_bizdate");//结算日期
                    DynamicObject tpv_operator = tp_freigro.getDynamicObject("tpv_operator");//业务员
                    DynamicObject tpv_department = tp_freigro.getDynamicObject("tpv_department");//部门
                    this.getModel().setValue("tpv_businesstypes", tpv_businesstype,rowIndex);
                    this.getModel().setValue("tpv_contractnumber", tpv_salescontract,rowIndex);//销售合同
                    this.getModel().setValue("tpv_purchasecontract", tpv_purchasecontract,rowIndex);
                    this.getModel().setValue("tpv_customerf", tpv_clientele,rowIndex);
                    this.getModel().setValue("tpv_currencyf", tpv_currency,rowIndex);
                    this.getModel().setValue("tpv_writtenoffs", tpv_nocavamount,rowIndex);
                    this.getModel().setValue("tpv_plannedjssj", tpv_plannedjssj,rowIndex);
                    this.getModel().setValue("tpv_datef", tpv_bizdate,rowIndex);
                    this.getModel().setValue("tpv_user", tpv_operator,rowIndex);
                    this.getModel().setValue("tpv_departmentf", tpv_department,rowIndex);
                }
            }
        }
    }

    /**
     *
     * @param e 字段过滤
     */
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        RefBillEdit tpv_contractnu = (RefBillEdit) this.getView().getControl("tpv_contractnus");  //基础资料字段标识
        if (tpv_contractnu!=null){
            tpv_contractnu.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        }
        RefBillEdit tpv_purchasecontr = (RefBillEdit) this.getView().getControl("tpv_purchasecontrs");  //基础资料字段标识
        if (tpv_purchasecontr!=null){
            tpv_purchasecontr.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        }
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpv_departments = dataEntity.getDynamicObject("tpv_departments");//部门
        DynamicObject org = dataEntity.getDynamicObject("org");//公司
        DynamicObject tpv_currency = (DynamicObject) this.getModel().getValue("tpv_currency");//币种
        DynamicObject tpv_tradeproperty = (DynamicObject) this.getModel().getValue("tpv_tradeproperty");//贸易性质
        if (tpv_departments != null) {
            String deparments = tpv_departments.getString("name");
            QFilters.add(new QFilter("tpv_department.name", QCP.equals, deparments));
        }
        if (org != null) {
            String string = org.getString("number");
            QFilters.add(new QFilter("org.number", QCP.equals, string));
        }
        if (tpv_tradeproperty != null) {
            String number = tpv_tradeproperty.getString("number");
            QFilters.add(new QFilter("tpv_tradeproperty.number",QCP.equals,number));
        }
        if(tpv_currency!=null){
            String number = tpv_currency.getString("number");
            QFilters.add(new QFilter("tpv_currency.number",QCP.equals,number));
        }
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }
}
