package com.itopview.wm.cm.formplugin.form;

import com.itopview.wm.cm.customplugin.YemFactory;
import com.itopview.wm.cm.customplugin.YemInterface;
import com.itopview.wm.utils.BigDecimalUtils;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.math.BigDecimal;
import java.util.*;

/**
 * 采购价格测算 表单插件
 */
public class PurPriceCalculationEdit extends AbstractBillPlugIn implements Plugin {

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String key = e.getOperateKey();
        switch (key) {
            case "refreshdata":
                refreshdata();
                break;
            default:
                break;
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
    }

    public void refreshdata() {
        IDataModel model = this.getModel();
        model.deleteEntryData("tpv_ppc_entry");

        //获取所有已审核的采购合同
        QFilter qFilter = new QFilter("billstatus", QCP.equals, "C");
        DynamicObject[] tpv_dt_purchase_s = BusinessDataServiceHelper.load("tpv_dt_purchase",
                "id,tpv_supplier,tpv_currency,tpv_postpricingrules,tpv_materialentry,tpv_materialentry.tpv_material," +
                        "tpv_materialentry.tpv_unit,tpv_materialentry.tpv_qty",
                new QFilter[]{qFilter});
        List con_id_s = new ArrayList();
        if (null != tpv_dt_purchase_s && tpv_dt_purchase_s.length > 0) {
            for (int i = 0; i < tpv_dt_purchase_s.length; i++) {
                DynamicObject tpv_dt_purchase = tpv_dt_purchase_s[i];
                con_id_s.add(tpv_dt_purchase.getLong("id"));
            }
        }

        //根据采购合同查询货物流转单
        Map tpv_dt_freigroambill_map = new HashMap();
        qFilter = new QFilter("billstatus", QCP.equals, "C");
        qFilter.and(new QFilter("tpv_materialentry.tpv_cobillid", QCP.in, con_id_s));
        DynamicObject[] tpv_dt_freigroambill_s = BusinessDataServiceHelper.load("tpv_dt_freigroambill",
                "id,tpv_materialentry,tpv_materialentry.tpv_qty,tpv_materialentry.tpv_cobillid,tpv_materialentry.tpv_coentryid",
                new QFilter[]{qFilter});
        if (null != tpv_dt_freigroambill_s && tpv_dt_freigroambill_s.length > 0) {
            for (int i = 0; i < tpv_dt_freigroambill_s.length; i++) {
                DynamicObject tpv_dt_freigroambill = tpv_dt_freigroambill_s[i];
                DynamicObjectCollection tpv_materialentry_s = tpv_dt_freigroambill.getDynamicObjectCollection("tpv_materialentry");
                for (int j = 0; j < tpv_materialentry_s.size(); j++) {
                    DynamicObject tpv_materialentry = tpv_materialentry_s.get(j);
                    long tpv_materialentry_id = tpv_materialentry.getLong("id");
                    BigDecimal tpv_qty = tpv_materialentry.getBigDecimal("tpv_qty");
                    long tpv_cobillid = tpv_materialentry.getLong("tpv_cobillid");
                    long tpv_coentryid = tpv_materialentry.getLong("tpv_coentryid");
                    if (tpv_dt_freigroambill_map.containsKey(tpv_cobillid)) {
                        List list = (List) tpv_dt_freigroambill_map.get(tpv_cobillid);
                        List val = new ArrayList();
                        val.add(tpv_dt_freigroambill);
                        val.add(tpv_coentryid);
                        val.add(tpv_qty);
                        val.add(tpv_materialentry_id);
                        list.add(val);
                        tpv_dt_freigroambill_map.put(tpv_cobillid, list);
                    } else {
                        List list = new ArrayList();
                        List val = new ArrayList();
                        val.add(tpv_dt_freigroambill);
                        val.add(tpv_coentryid);
                        val.add(tpv_qty);
                        val.add(tpv_materialentry_id);
                        list.add(val);
                        tpv_dt_freigroambill_map.put(tpv_cobillid, list);
                    }
                }
            }
        }

        //根据采购合同查询采购入库单
        Map im_purinbill_map = new HashMap();
        qFilter = new QFilter("billstatus", QCP.equals, "C");
        qFilter.and(new QFilter("billentry.mainbillid", QCP.in, con_id_s));
        DynamicObject[] im_purinbill_s = BusinessDataServiceHelper.load("im_purinbill",
                "id,billentry,billentry.qty,billentry.srcbillid,billentry.srcbillentryid",
                new QFilter[]{qFilter});
        if (null != im_purinbill_s && im_purinbill_s.length > 0) {
            for (int i = 0; i < im_purinbill_s.length; i++) {
                DynamicObject im_purinbill = im_purinbill_s[i];
                DynamicObjectCollection billentry_s = im_purinbill.getDynamicObjectCollection("billentry");
                for (int j = 0; j < billentry_s.size(); j++) {
                    DynamicObject billentry = billentry_s.get(j);
                    BigDecimal qty = billentry.getBigDecimal("qty");
                    long srcbillid = billentry.getLong("srcbillid");
                    long srcbillentryid = billentry.getLong("srcbillentryid");
                    if (im_purinbill_map.containsKey(srcbillid)) {
                        List list = (List) im_purinbill_map.get(srcbillid);
                        List val = new ArrayList();
                        val.add(billentry);
                        val.add(srcbillentryid);
                        val.add(qty);
                        list.add(val);
                        im_purinbill_map.put(srcbillid, list);
                    } else {
                        List list = new ArrayList();
                        List val = new ArrayList();
                        val.add(billentry);
                        val.add(srcbillentryid);
                        val.add(qty);
                        list.add(val);
                        im_purinbill_map.put(srcbillid, list);
                    }
                }
            }
        }

        if (null != tpv_dt_purchase_s && tpv_dt_purchase_s.length > 0) {
            for (int i = 0; i < tpv_dt_purchase_s.length; i++) {
                DynamicObject tpv_dt_purchase = tpv_dt_purchase_s[i];
                tpv_dt_purchase = BusinessDataServiceHelper.loadSingle(tpv_dt_purchase.getPkValue(), tpv_dt_purchase.getDynamicObjectType().getName());
                String tpv_dt_purchase_type = tpv_dt_purchase.getDynamicObjectType().getName();
                long tpv_dt_purchase_id = tpv_dt_purchase.getLong("id");
                DynamicObject tpv_supplier = tpv_dt_purchase.getDynamicObject("tpv_supplier");//
                DynamicObject tpv_currency = tpv_dt_purchase.getDynamicObject("tpv_currency");//结算币别
                DynamicObject tpv_pricingstrategy = tpv_dt_purchase.getDynamicObject("tpv_postpricingrules");//价格策略
                //根据价格策略获取结果
                String tpv_plugin = "";
                Map map = new HashMap();
                if (null != tpv_pricingstrategy) {
                    tpv_pricingstrategy = BusinessDataServiceHelper.loadSingle(tpv_pricingstrategy.getPkValue(), tpv_pricingstrategy.getDynamicObjectType().getName());
                    tpv_plugin = tpv_pricingstrategy.getString("tpv_plugin");//插件
                    DynamicObject tpv_srcbill = tpv_pricingstrategy.getDynamicObject("tpv_srcbill");
                    if (null != tpv_srcbill) {
                        String tpv_srcbill_type = tpv_srcbill.getDynamicObjectType().getName();
                        if (null != tpv_dt_purchase_type && null != tpv_srcbill_type && tpv_dt_purchase_type.equals(tpv_srcbill_type)) {
                            DynamicObjectCollection tpv_ps_entry_s = tpv_pricingstrategy.getDynamicObjectCollection("tpv_ps_entry");
                            for (int j = 0; j < tpv_ps_entry_s.size(); j++) {
                                DynamicObject tpv_ps_entry = tpv_ps_entry_s.get(j);
                                DynamicObject tpv_bill = tpv_ps_entry.getDynamicObject("tpv_bill");
                                String tpv_bill_number = tpv_bill.getString("number");
                                String tpv_srcfield = tpv_ps_entry.getString("tpv_srcfield");
                                QFilter qFilter1 = new QFilter(tpv_srcfield, QCP.equals, tpv_dt_purchase_id);
                                //查询价格策略
                                DynamicObject[] bill_s = BusinessDataServiceHelper.load(tpv_bill_number, "id",
                                        new QFilter[]{qFilter1});
                                if (null != bill_s && bill_s.length > 0) {
                                    map.put(tpv_bill_number, bill_s);
                                }
                            }
                        }
                    }
                }
                map.put("tpv_dt_purchase", tpv_dt_purchase);

                DynamicObjectCollection tpv_materialentry_s = tpv_dt_purchase.getDynamicObjectCollection("tpv_materialentry");
                for (int j = 0; j < tpv_materialentry_s.size(); j++) {
                    DynamicObject tpv_materialentry = tpv_materialentry_s.get(j);
                    long tpv_materialentry_id = tpv_materialentry.getLong("id");
                    DynamicObject tpv_material = tpv_materialentry.getDynamicObject("tpv_material");
                    DynamicObject tpv_unit = tpv_materialentry.getDynamicObject("tpv_unit");
                    BigDecimal tpv_qty = tpv_materialentry.getBigDecimal("tpv_qty");
                    if (tpv_dt_freigroambill_map.containsKey(tpv_dt_purchase_id)) {
                        List list = (List) tpv_dt_freigroambill_map.get(tpv_dt_purchase_id);
                        for (int m = 0; m < list.size(); m++) {
                            List val = (List) list.get(m);
                            long tpv_coentryid = (long) val.get(1);
                            if (tpv_materialentry_id == tpv_coentryid) {
                                DynamicObject tpv_dt_freigroambill = (DynamicObject) val.get(0);
                                long tpv_dt_freigroambill_id = tpv_dt_freigroambill.getLong("id");
                                BigDecimal qty1 = BigDecimalUtils.toBigDecimal(val.get(2));
                                long entry_id = (long) val.get(3);
                                if (im_purinbill_map.containsKey(tpv_dt_freigroambill_id)) {
                                    List list2 = (List) im_purinbill_map.get(tpv_dt_freigroambill_id);
                                    for (int n = 0; n < list2.size(); n++) {
                                        List val2 = (List) list2.get(n);
                                        long srcbillentryid = (long) val2.get(1);
                                        if (entry_id == srcbillentryid) {
                                            DynamicObject billentry = (DynamicObject) val2.get(0);

                                            map.put("tpv_dt_freigroambill", tpv_dt_freigroambill);
                                            map.put("tpv_im_purinbill", billentry);
                                            YemInterface yemInterface = YemFactory.getImplementation(tpv_plugin);
                                            Map map2 = yemInterface == null ? new HashMap() : yemInterface.getMap(map);
                                            BigDecimal tpv_purprice = map2.containsKey("tpv_purprice") ? BigDecimalUtils.toBigDecimal(map2.get("tpv_purprice")) : BigDecimal.ZERO;
                                            BigDecimal tpv_marketprice = map2.containsKey("tpv_marketprice") ? BigDecimalUtils.toBigDecimal(map2.get("tpv_marketprice")) : BigDecimal.ZERO;

                                            BigDecimal qty2 = BigDecimalUtils.toBigDecimal(val2.get(2));
                                            tpv_qty = BigDecimalUtils.sub(tpv_qty, qty2, 10);
                                            int rowIndex = model.createNewEntryRow("tpv_ppc_entry");
                                            model.setValue("tpv_dt_purchase", tpv_dt_purchase, rowIndex);
                                            model.setValue("tpv_dt_freigroambill", tpv_dt_freigroambill, rowIndex);
                                            model.setValue("tpv_im_purinbill", billentry, rowIndex);
                                            model.setValue("tpv_supplier", tpv_supplier, rowIndex);
                                            model.setValue("tpv_materiel", tpv_material, rowIndex);
                                            model.setValue("tpv_pricingstrategy", tpv_pricingstrategy, rowIndex);
                                            model.setValue("tpv_unit", tpv_unit, rowIndex);
                                            model.setValue("tpv_currency", tpv_currency, rowIndex);
                                            model.setValue("tpv_qty", qty2, rowIndex);
                                            model.setValue("tpv_purprice", tpv_purprice, rowIndex);
                                            model.setValue("tpv_marketprice", tpv_marketprice, rowIndex);
                                        }
                                    }
                                } else {
                                    map.put("tpv_dt_freigroambill", tpv_dt_freigroambill);
                                    YemInterface yemInterface = YemFactory.getImplementation(tpv_plugin);
                                    Map map2 = yemInterface == null ? new HashMap() : yemInterface.getMap(map);
                                    BigDecimal tpv_purprice = map2.containsKey("tpv_purprice") ? BigDecimalUtils.toBigDecimal(map2.get("tpv_purprice")) : BigDecimal.ZERO;
                                    BigDecimal tpv_marketprice = map2.containsKey("tpv_marketprice") ? BigDecimalUtils.toBigDecimal(map2.get("tpv_marketprice")) : BigDecimal.ZERO;

                                    tpv_qty = BigDecimalUtils.sub(tpv_qty, qty1, 10);
                                    int rowIndex = model.createNewEntryRow("tpv_ppc_entry");
                                    model.setValue("tpv_dt_purchase", tpv_dt_purchase, rowIndex);
                                    model.setValue("tpv_dt_freigroambill", tpv_dt_freigroambill, rowIndex);
                                    model.setValue("tpv_supplier", tpv_supplier, rowIndex);
                                    model.setValue("tpv_materiel", tpv_material, rowIndex);
                                    model.setValue("tpv_pricingstrategy", tpv_pricingstrategy, rowIndex);
                                    model.setValue("tpv_unit", tpv_unit, rowIndex);
                                    model.setValue("tpv_currency", tpv_currency, rowIndex);
                                    model.setValue("tpv_qty", qty1, rowIndex);
                                    model.setValue("tpv_purprice", tpv_purprice, rowIndex);
                                    model.setValue("tpv_marketprice", tpv_marketprice, rowIndex);
                                }
                            }
                        }
                    }

                    if (tpv_qty.compareTo(BigDecimal.ZERO) > 0) {
                        if (im_purinbill_map.containsKey(tpv_dt_purchase_id)) {
                            List list2 = (List) im_purinbill_map.get(tpv_dt_purchase_id);
                            for (int n = 0; n < list2.size(); n++) {
                                List val2 = (List) list2.get(n);
                                long srcbillentryid = (long) val2.get(1);
                                if (tpv_materialentry_id == srcbillentryid) {
                                    DynamicObject billentry = (DynamicObject) val2.get(0);

                                    map.put("tpv_im_purinbill", billentry);
                                    YemInterface yemInterface = YemFactory.getImplementation(tpv_plugin);
                                    Map map2 = yemInterface == null ? new HashMap() : yemInterface.getMap(map);
                                    BigDecimal tpv_purprice = map2.containsKey("tpv_purprice") ? BigDecimalUtils.toBigDecimal(map2.get("tpv_purprice")) : BigDecimal.ZERO;
                                    BigDecimal tpv_marketprice = map2.containsKey("tpv_marketprice") ? BigDecimalUtils.toBigDecimal(map2.get("tpv_marketprice")) : BigDecimal.ZERO;

                                    BigDecimal qty2 = BigDecimalUtils.toBigDecimal(val2.get(2));
                                    tpv_qty = BigDecimalUtils.sub(tpv_qty, qty2, 10);
                                    int rowIndex = model.createNewEntryRow("tpv_ppc_entry");
                                    model.setValue("tpv_dt_purchase", tpv_dt_purchase, rowIndex);
                                    model.setValue("tpv_im_purinbill", billentry, rowIndex);
                                    model.setValue("tpv_supplier", tpv_supplier, rowIndex);
                                    model.setValue("tpv_materiel", tpv_material, rowIndex);
                                    model.setValue("tpv_pricingstrategy", tpv_pricingstrategy, rowIndex);
                                    model.setValue("tpv_unit", tpv_unit, rowIndex);
                                    model.setValue("tpv_currency", tpv_currency, rowIndex);
                                    model.setValue("tpv_qty", qty2, rowIndex);
                                    model.setValue("tpv_purprice", tpv_purprice, rowIndex);
                                    model.setValue("tpv_marketprice", tpv_marketprice, rowIndex);
                                }
                            }
                        }
                    }
                    if (tpv_qty.compareTo(BigDecimal.ZERO) > 0) {
                        YemInterface yemInterface = YemFactory.getImplementation(tpv_plugin);
                        Map map2 = yemInterface == null ? new HashMap() : yemInterface.getMap(map);
                        BigDecimal tpv_purprice = map2.containsKey("tpv_purprice") ? BigDecimalUtils.toBigDecimal(map2.get("tpv_purprice")) : BigDecimal.ZERO;
                        BigDecimal tpv_marketprice = map2.containsKey("tpv_marketprice") ? BigDecimalUtils.toBigDecimal(map2.get("tpv_marketprice")) : BigDecimal.ZERO;

                        int rowIndex = model.createNewEntryRow("tpv_ppc_entry");
                        model.setValue("tpv_dt_purchase", tpv_dt_purchase, rowIndex);
                        model.setValue("tpv_supplier", tpv_supplier, rowIndex);
                        model.setValue("tpv_materiel", tpv_material, rowIndex);
                        model.setValue("tpv_pricingstrategy", tpv_pricingstrategy, rowIndex);
                        model.setValue("tpv_unit", tpv_unit, rowIndex);
                        model.setValue("tpv_currency", tpv_currency, rowIndex);
                        model.setValue("tpv_qty", tpv_qty, rowIndex);
                        model.setValue("tpv_purprice", tpv_purprice, rowIndex);
                        model.setValue("tpv_marketprice", tpv_marketprice, rowIndex);
                    }
                }
            }
        }
    }
}