package com.itopview.wm.cm.formplugin.form;

import com.itopview.wm.cm.customplugin.YemFactory;
import com.itopview.wm.cm.customplugin.YemInterface;
import com.itopview.wm.utils.BigDecimalUtils;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.math.BigDecimal;
import java.util.*;

/**
 * 销售价格测算 表单插件
 */
public class SalePriceCalculationEdit extends AbstractBillPlugIn implements Plugin {

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String key = e.getOperateKey();
        switch (key) {
            case "refreshdata":
                refreshdata();
                break;
            default:
                break;
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
    }

    public void refreshdata() {
        IDataModel model = this.getModel();
        model.deleteEntryData("tpv_spc_entry");

        //销售合同
        QFilter qFilter = new QFilter("billstatus", QCP.equals, "C");
        DynamicObject[] tpv_dt_salescontract_s = BusinessDataServiceHelper.load("tpv_dt_salescontract",
                "id,tpv_customer,tpv_currency,tpv_postpricingrule,tpv_materialentry,tpv_materialentry.tpv_material," +
                        "tpv_materialentry.tpv_unit,tpv_materialentry.tpv_qty",
                new QFilter[]{qFilter});
        List con_id_s = new ArrayList();
        if (null != tpv_dt_salescontract_s && tpv_dt_salescontract_s.length > 0) {
            for (int i = 0; i < tpv_dt_salescontract_s.length; i++) {
                DynamicObject tpv_dt_salescontract = tpv_dt_salescontract_s[i];
                con_id_s.add(tpv_dt_salescontract.getLong("id"));
            }
        }

        //销售发货单
        Map tpv_dt_salesshipping_map = new HashMap();
        qFilter = new QFilter("billstatus", QCP.equals, "C");
        qFilter.and(new QFilter("tpv_materialentry.tpv_srcbillid", QCP.in, con_id_s));
        DynamicObject[] tpv_dt_salesshipping_s = BusinessDataServiceHelper.load("tpv_dt_salesshipping",
                "id,tpv_materialentry,tpv_materialentry.tpv_qty,tpv_materialentry.tpv_srcbillid,tpv_materialentry.tpv_srcentryid",
                new QFilter[]{qFilter});
        if (null != tpv_dt_salesshipping_s && tpv_dt_salesshipping_s.length > 0) {
            for (int i = 0; i < tpv_dt_salesshipping_s.length; i++) {
                DynamicObject tpv_dt_salesshipping = tpv_dt_salesshipping_s[i];
                DynamicObjectCollection tpv_materialentry_s = tpv_dt_salesshipping.getDynamicObjectCollection("tpv_materialentry");
                for (int j = 0; j < tpv_materialentry_s.size(); j++) {
                    DynamicObject tpv_materialentry = tpv_materialentry_s.get(j);
                    long tpv_materialentry_id = tpv_materialentry.getLong("id");
                    BigDecimal tpv_qty = tpv_materialentry.getBigDecimal("tpv_qty");
                    long tpv_srcbillid = tpv_materialentry.getLong("tpv_srcbillid");
                    long tpv_srcentryid = tpv_materialentry.getLong("tpv_srcentryid");
                    if (tpv_dt_salesshipping_map.containsKey(tpv_srcbillid)) {
                        List list = (List) tpv_dt_salesshipping_map.get(tpv_srcbillid);
                        List val = new ArrayList();
                        val.add(tpv_dt_salesshipping);
                        val.add(tpv_srcentryid);
                        val.add(tpv_qty);
                        val.add(tpv_materialentry_id);
                        list.add(val);
                        tpv_dt_salesshipping_map.put(tpv_srcbillid, list);
                    } else {
                        List list = new ArrayList();
                        List val = new ArrayList();
                        val.add(tpv_dt_salesshipping);
                        val.add(tpv_srcentryid);
                        val.add(tpv_qty);
                        val.add(tpv_materialentry_id);
                        list.add(val);
                        tpv_dt_salesshipping_map.put(tpv_srcbillid, list);
                    }
                }
            }
        }

        //销售出库单
        Map im_saloutbill_map = new HashMap();
        qFilter = new QFilter("billstatus", QCP.equals, "C");
        qFilter.and(new QFilter("billentry.mainbillid", QCP.in, con_id_s));
        DynamicObject[] im_saloutbill_s = BusinessDataServiceHelper.load("im_saloutbill",
                "id,billentry,billentry.qty,billentry.srcbillid,billentry.srcbillentryid",
                new QFilter[]{qFilter});
        if (null != im_saloutbill_s && im_saloutbill_s.length > 0) {
            for (int i = 0; i < im_saloutbill_s.length; i++) {
                DynamicObject im_saloutbill = im_saloutbill_s[i];
                DynamicObjectCollection billentry_s = im_saloutbill.getDynamicObjectCollection("billentry");
                for (int j = 0; j < billentry_s.size(); j++) {
                    DynamicObject billentry = billentry_s.get(j);
                    BigDecimal qty = billentry.getBigDecimal("qty");
                    long srcbillid = billentry.getLong("srcbillid");
                    long srcbillentryid = billentry.getLong("srcbillentryid");
                    if (im_saloutbill_map.containsKey(srcbillid)) {
                        List list = (List) im_saloutbill_map.get(srcbillid);
                        List val = new ArrayList();
                        val.add(billentry);
                        val.add(srcbillentryid);
                        val.add(qty);
                        list.add(val);
                        im_saloutbill_map.put(srcbillid, list);
                    } else {
                        List list = new ArrayList();
                        List val = new ArrayList();
                        val.add(billentry);
                        val.add(srcbillentryid);
                        val.add(qty);
                        list.add(val);
                        im_saloutbill_map.put(srcbillid, list);
                    }
                }
            }
        }

        if (null != tpv_dt_salescontract_s && tpv_dt_salescontract_s.length > 0) {
            for (int i = 0; i < tpv_dt_salescontract_s.length; i++) {
                DynamicObject tpv_dt_salescontract = tpv_dt_salescontract_s[i];
                tpv_dt_salescontract = BusinessDataServiceHelper.loadSingle(tpv_dt_salescontract.getPkValue(), tpv_dt_salescontract.getDynamicObjectType().getName());
                String tpv_dt_salescontract_type = tpv_dt_salescontract.getDynamicObjectType().getName();
                long tpv_dt_salescontract_id = tpv_dt_salescontract.getLong("id");
                DynamicObject tpv_customer = tpv_dt_salescontract.getDynamicObject("tpv_customer");
                DynamicObject tpv_currency = tpv_dt_salescontract.getDynamicObject("tpv_currency");
                DynamicObject tpv_pricingstrategy = tpv_dt_salescontract.getDynamicObject("tpv_postpricingrule");//价格策略
                //根据价格策略获取结果
                String tpv_plugin = "";
                Map map = new HashMap();
                if (null != tpv_pricingstrategy) {
                    tpv_pricingstrategy = BusinessDataServiceHelper.loadSingle(tpv_pricingstrategy.getPkValue(), tpv_pricingstrategy.getDynamicObjectType().getName());
                    tpv_plugin = tpv_pricingstrategy.getString("tpv_plugin");//插件
                    DynamicObject tpv_srcbill = tpv_pricingstrategy.getDynamicObject("tpv_srcbill");
                    if (null != tpv_srcbill) {
                        String tpv_srcbill_type = tpv_srcbill.getDynamicObjectType().getName();
                        if (null != tpv_dt_salescontract_type && null != tpv_srcbill_type && tpv_dt_salescontract_type.equals(tpv_srcbill_type)) {
                            DynamicObjectCollection tpv_ps_entry_s = tpv_pricingstrategy.getDynamicObjectCollection("tpv_ps_entry");
                            for (int j = 0; j < tpv_ps_entry_s.size(); j++) {
                                DynamicObject tpv_ps_entry = tpv_ps_entry_s.get(j);
                                DynamicObject tpv_bill = tpv_ps_entry.getDynamicObject("tpv_bill");
                                String tpv_bill_number = tpv_bill.getString("number");
                                String tpv_srcfield = tpv_ps_entry.getString("tpv_srcfield");
                                QFilter qFilter1 = new QFilter(tpv_srcfield, QCP.equals, tpv_dt_salescontract_id);
                                DynamicObject[] bill_s = BusinessDataServiceHelper.load(tpv_bill_number, "id",
                                        new QFilter[]{qFilter1});
                                if (null != bill_s && bill_s.length > 0) {
                                    map.put(tpv_bill_number, bill_s);
                                }
                            }
                        }
                    }
                }
                map.put("tpv_dt_salescontract", tpv_dt_salescontract);

                DynamicObjectCollection tpv_materialentry_s = tpv_dt_salescontract.getDynamicObjectCollection("tpv_materialentry");
                for (int j = 0; j < tpv_materialentry_s.size(); j++) {
                    DynamicObject tpv_materialentry = tpv_materialentry_s.get(j);
                    long tpv_materialentry_id = tpv_materialentry.getLong("id");
                    DynamicObject tpv_material = tpv_materialentry.getDynamicObject("tpv_material");
                    DynamicObject tpv_unit = tpv_materialentry.getDynamicObject("tpv_unit");
                    BigDecimal tpv_qty = tpv_materialentry.getBigDecimal("tpv_qty");
                    if (tpv_dt_salesshipping_map.containsKey(tpv_dt_salescontract_id)) {
                        List list = (List) tpv_dt_salesshipping_map.get(tpv_dt_salescontract_id);
                        for (int m = 0; m < list.size(); m++) {
                            List val = (List) list.get(m);
                            long tpv_srcentryid = (long) val.get(1);
                            if (tpv_materialentry_id == tpv_srcentryid) {
                                DynamicObject tpv_dt_salesshipping = (DynamicObject) val.get(0);
                                long tpv_dt_salesshipping_id = tpv_dt_salesshipping.getLong("id");
                                BigDecimal qty1 = BigDecimalUtils.toBigDecimal(val.get(2));
                                long entry_id = (long) val.get(3);
                                if (im_saloutbill_map.containsKey(tpv_dt_salesshipping_id)) {
                                    List list2 = (List) im_saloutbill_map.get(tpv_dt_salesshipping_id);
                                    for (int n = 0; n < list2.size(); n++) {
                                        List val2 = (List) list2.get(n);
                                        long srcbillentryid = (long) val2.get(1);
                                        if (entry_id == srcbillentryid) {
                                            DynamicObject billentry = (DynamicObject) val2.get(0);
                                            map.put("tpv_dt_salesshipping", tpv_dt_salesshipping);
                                            map.put("tpv_im_saloutbill", billentry);
                                            YemInterface yemInterface = YemFactory.getImplementation(tpv_plugin);
                                            map = yemInterface == null ? new HashMap() : yemInterface.getMap(map);
                                            BigDecimal tpv_saleprice = map.containsKey("tpv_saleprice") ? BigDecimalUtils.toBigDecimal(map.get("tpv_saleprice")) : BigDecimal.ZERO;
                                            BigDecimal tpv_marketprice = map.containsKey("tpv_marketprice") ? BigDecimalUtils.toBigDecimal(map.get("tpv_marketprice")) : BigDecimal.ZERO;

                                            BigDecimal qty2 = BigDecimalUtils.toBigDecimal(val2.get(2));
                                            tpv_qty = BigDecimalUtils.sub(tpv_qty, qty2, 10);
                                            int rowIndex = model.createNewEntryRow("tpv_spc_entry");
                                            model.setValue("tpv_dt_salescontract", tpv_dt_salescontract, rowIndex);
                                            model.setValue("tpv_dt_salesshipping", tpv_dt_salesshipping, rowIndex);
                                            model.setValue("tpv_im_saloutbill", billentry, rowIndex);
                                            model.setValue("tpv_customer", tpv_customer, rowIndex);
                                            model.setValue("tpv_materiel", tpv_material, rowIndex);
                                            model.setValue("tpv_unit", tpv_unit, rowIndex);
                                            model.setValue("tpv_currency", tpv_currency, rowIndex);
                                            model.setValue("tpv_qty", qty2, rowIndex);
                                            model.setValue("tpv_saleprice", tpv_saleprice, rowIndex);
                                            model.setValue("tpv_marketprice", tpv_marketprice, rowIndex);
                                        }
                                    }
                                } else {
                                    tpv_qty = BigDecimalUtils.sub(tpv_qty, qty1, 10);
                                    map.put("tpv_dt_salesshipping", tpv_dt_salesshipping);
                                    YemInterface yemInterface = YemFactory.getImplementation(tpv_plugin);
                                    map = yemInterface == null ? new HashMap() : yemInterface.getMap(map);
                                    BigDecimal tpv_saleprice = map.containsKey("tpv_saleprice") ? BigDecimalUtils.toBigDecimal(map.get("tpv_saleprice")) : BigDecimal.ZERO;
                                    BigDecimal tpv_marketprice = map.containsKey("tpv_marketprice") ? BigDecimalUtils.toBigDecimal(map.get("tpv_marketprice")) : BigDecimal.ZERO;
                                    int rowIndex = model.createNewEntryRow("tpv_spc_entry");
                                    model.setValue("tpv_dt_salescontract", tpv_dt_salescontract, rowIndex);
                                    model.setValue("tpv_dt_salesshipping", tpv_dt_salesshipping, rowIndex);
                                    model.setValue("tpv_customer", tpv_customer, rowIndex);
                                    model.setValue("tpv_materiel", tpv_material, rowIndex);
                                    model.setValue("tpv_unit", tpv_unit, rowIndex);
                                    model.setValue("tpv_currency", tpv_currency, rowIndex);
                                    model.setValue("tpv_qty", qty1, rowIndex);
                                    model.setValue("tpv_saleprice", tpv_saleprice, rowIndex);
                                    model.setValue("tpv_marketprice", tpv_marketprice, rowIndex);
                                }
                            }
                        }
                    }

                    if (tpv_qty.compareTo(BigDecimal.ZERO) > 0) {
                        YemInterface yemInterface = YemFactory.getImplementation(tpv_plugin);
                        map = yemInterface == null ? new HashMap() : yemInterface.getMap(map);
                        BigDecimal tpv_saleprice = map.containsKey("tpv_saleprice") ? BigDecimalUtils.toBigDecimal(map.get("tpv_saleprice")) : BigDecimal.ZERO;
                        BigDecimal tpv_marketprice = map.containsKey("tpv_marketprice") ? BigDecimalUtils.toBigDecimal(map.get("tpv_marketprice")) : BigDecimal.ZERO;
                        int rowIndex = model.createNewEntryRow("tpv_spc_entry");
                        model.setValue("tpv_dt_salescontract", tpv_dt_salescontract, rowIndex);
                        model.setValue("tpv_customer", tpv_customer, rowIndex);
                        model.setValue("tpv_materiel", tpv_material, rowIndex);
                        model.setValue("tpv_unit", tpv_unit, rowIndex);
                        model.setValue("tpv_currency", tpv_currency, rowIndex);
                        model.setValue("tpv_qty", tpv_qty, rowIndex);
                        model.setValue("tpv_saleprice", tpv_saleprice, rowIndex);
                        model.setValue("tpv_marketprice", tpv_marketprice, rowIndex);
                    }
                }
            }
        }
    }
}