package com.itopview.wm.cm.formplugin.form;

import com.alibaba.nacos.common.utils.StringUtils;
import com.grapecity.documents.excel.L;
import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.algo.DataSet;
import kd.bos.bill.AbstractBillPlugIn;

import java.math.BigDecimal;
import java.sql.Array;
import java.util.*;

import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.IEntryOperate;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.*;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.epm.eb.ebSpread.common.util.StringUtil;

/**
 * 高低计单
 *
 * @author LiuHB
 * @version 1.0
 */
public class UnevenFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener,RowClickEventListener {

    private static String TAD = "tpv_advconap";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("tpv_contractgoods");
        // 侦听单据体事件
        EntryGrid entryGrid = this.getView().getControl(TAD);
        //F7过滤监听
        BasedataEdit unit = (BasedataEdit) this.getView().getControl("tpv_parallelismpur");
        unit.addBeforeF7SelectListener(this);
        //单据行点击
        EntryGrid entry = this.getView().getControl(TAD);
        entryGrid.addRowClickListener(this);
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        Control source = (Control) evt.getSource();
        if (StringUtils.equals(TAD, source.getKey())){

        query(new Long(0L));


        }
    }    /**
     * 单据体新增行
     *
     * @param e
     */
    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        if (kd.bos.dataentity.utils.StringUtils.equals(TAD, e.getEntryProp().getName())) {
            //如果规划明细子分录新增行对规划采购/销售合同号进行锁定解锁
            DynamicObjectCollection tpvProgramme = this.getModel().getEntryEntity(TAD);
            for (DynamicObject dynamicObject : tpvProgramme) {
                int rowIndex = tpvProgramme.indexOf(dynamicObject);
                amout(rowIndex);
            }
        }
    }

    /**
     * 业务类型值改变监听
     * @param e
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData[] changeData = e.getChangeSet();
        //获取分录的行下标
        int rowIndex = changeData[0].getRowIndex();
        //监听单据类型修改
        switch (name){
            case "tpv_businesstype":
                amout(rowIndex);
                break;
            case "tpv_taxamounta":
                calculateTaxAmount( rowIndex);
                break;

            default:
                break;
        }

    }
    /**
     * 根据单据类型解锁返利对应采购合同号，对应供应商
     *  B解锁返利对应采购合同号，对应供应商
     *
     * @param rowIndex
     */
    private void amout(int rowIndex) {
        String tpvDocumenttype = (String) this.getModel().getValue("tpv_businesstype");//业务类型
        BasedataEdit purchasecontr = this.getView().getControl("tpv_parallelismpur");//返利对应采购合同号
        BasedataEdit contractnu = this.getView().getControl("tpv_parallelismsup");//对应供应商
        if (tpvDocumenttype == null) {
            contractnu.setEnable("", false, rowIndex);
            purchasecontr.setEnable("", false, rowIndex);
        } else if ("B".equals(tpvDocumenttype)) {
            purchasecontr.setEnable("", true, rowIndex);
            contractnu.setEnable("", true, rowIndex);
        }else {
            contractnu.setEnable("", false, rowIndex);
            purchasecontr.setEnable("", false, rowIndex);
        }
    }
    /**
     * 单据打开锁定返利对应采购合同号,对应供应商
     * @param e
     */
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        String tpvSourcebillno = (String) this.getModel().getValue("tpv_sourcebillno");
        if("".equals(tpvSourcebillno)){
            this.getView().setEnable(true,"tpv_unevened");
        }else{
            this.getView().setEnable(false,"tpv_unevened");
        }
        DynamicObjectCollection tpvProgramme = this.getView().getModel().getEntryEntity(TAD);
        BasedataEdit purchasecontr = this.getView().getControl("tpv_parallelismpur");//返利对应采购合同号
        BasedataEdit contractnu = this.getView().getControl("tpv_parallelismsup");//对应供应商
        for (DynamicObject dynamicObject : tpvProgramme) {
            int rowIndex = tpvProgramme.indexOf(dynamicObject);
            String tpvDocumenttype = (String) this.getModel().getValue("tpv_businesstype");//业务类型
            if(rowIndex == 0 ){
                Long advconappkValue = (Long) dynamicObject.getPkValue();
                query(advconappkValue);
            }
            if (tpvDocumenttype == null) {
                contractnu.setEnable("", false, rowIndex);
                purchasecontr.setEnable("", false, rowIndex);
            }

        }
    }

    /**
     * 根据结算方类型决定弹框
     * @param evt
     */
    @Override
    public void click(EventObject evt) {
        super.click(evt);
        // 获取被点击的控件对象
        Control source = (Control) evt.getSource();
        String key = source.getKey();
        switch (key) {
            case "tpv_contractgoods":
                String tpvClearparty = (String) this.getModel().getValue("tpv_clearparty");
                if ("bd_customer".equals(tpvClearparty)) {
                    passwd("tpv_cm_contractgoodxs", "tpv_contractgoodxs_xs");

                } else if ("bd_supplier".equals(tpvClearparty)) {
                    passwda("tpv_cm_contractgoodcg", "tpv_contractgoodxs_cg");
                }else if("".equals(tpvClearparty)){
                    this.getView().showTipNotification("请先选择结算方类型！");
                }
                break;
        }
    }

    /**
     * 打开动态表单
     * @param dynamicform
     * @param button
     */
    public void passwd(String dynamicform, String button) {
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId(dynamicform);
        Map<String,Object> map=this.showInfoForm();
        showParameter.setCustomParams(map);
        showParameter.setCloseCallBack(new CloseCallBack(this, button));
        this.getView().showForm(showParameter);
    }
    public void passwda(String dynamicform, String button) {
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId(dynamicform);
        Map<String,Object> map=this.showInfoForm();
        showParameter.setCustomParams(map);
        showParameter.setCloseCallBack(new CloseCallBack(this, button));
        this.getView().showForm(showParameter);
    }

    private Map<String, Object> showInfoForm() {
        Map<String, Object> map = new HashMap<>();
        long billunitid = 0L;
        ArrayList<Object> objects = new ArrayList<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection tpvMatecost = dataEntity.getDynamicObjectCollection(TAD);
            for (DynamicObject dynamicObject : tpvMatecost) {
                Long tpvEntryid = dynamicObject.getLong("tpv_entryid");
                objects.add(tpvEntryid);
            }
            map.put("tpv_entryid",objects);
            return map;
    }

    /**
     * 动态表单关闭回调事件
     * @param e
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);
        Object returnData = e.getReturnData();
        if (StringUtils.equals(e.getActionId(), "tpv_contractgoodxs_xs") && null != e.getReturnData()) {
            List<Map<String, Object>> value = (List<Map<String, Object>>) returnData;
            this.setInwardInfob(value);
            return;
        }
        if (StringUtils.equals(e.getActionId(), "tpv_contractgoodxs_cg") && null != e.getReturnData()) {
            List<Map<String, Object>> value = (List<Map<String, Object>>) returnData;
            this.setInwardInfoa(value);
            return;
        }

    }

    /**
     * 回填单据体(采购 )
     * @param value
     */
    private void setInwardInfoa(List<Map<String, Object>> value) {
        int rowIndex = this.getModel().getEntryCurrentRowIndex("tpv_advconap");
        DynamicObject selectedData = this.getModel().getEntryRowEntity("tpv_advconap", rowIndex);
        for (Map<String, Object> values : value) {
            DynamicObjectCollection tpvMatecost = this.getModel().getEntryEntity("tpv_advconap");
            this.getModel().setValue("tpv_itemcodes", values.get("tpv_itemcodes"), rowIndex);
            this.getModel().setValue("tpv_tradepropertys", values.get("tpv_tradepropertys"), rowIndex);
            this.getModel().setValue("tpv_conprodname", values.get("tpv_conprodname"), rowIndex);
            this.getModel().setValue("tpv_departmet", values.get("tpv_departmet"), rowIndex);
            this.getModel().setValue("tpv_firm", values.get("tpv_firm"), rowIndex);
            this.getModel().setValue("tpv_crew", values.get("tpv_crew"), rowIndex);
            this.getModel().setValue("tpv_purconum", values.get("tpv_saleconum"), rowIndex);
            this.getModel().setValue("tpv_isquantitys", values.get("tpv_isquantitys"), rowIndex);
            this.getModel().setValue("tpv_taxamounts", values.get("tpv_taxamounts"), rowIndex);
            this.getModel().setValue("tpv_amountincrea", values.get("tpv_amountincrea"), rowIndex);
            this.getModel().setValue("tpv_vatrates", values.get("tpv_vatrates"), rowIndex);
            this.getModel().setValue("tpv_notaxamounts", values.get("tpv_notaxamounts"), rowIndex);
            this.getModel().setValue("tpv_entryid", values.get("tpv_entryid"), rowIndex);
            this.getModel().setValue("tpv_contractgoods", "采购合同", rowIndex);
        }
    }

    /**
     * 回填单据体(销售)
     * @param value
     */
    private void setInwardInfob(List<Map<String, Object>> value) {
        int rowIndex = this.getModel().getEntryCurrentRowIndex("tpv_advconap");
        DynamicObject selectedData = this.getModel().getEntryRowEntity("tpv_advconap", rowIndex);
            for (Map<String, Object> values : value) {
                DynamicObjectCollection tpvMatecost = this.getModel().getEntryEntity("tpv_advconap");
                this.getModel().setValue("tpv_itemcodes", values.get("tpv_itemcodes"), rowIndex);
                this.getModel().setValue("tpv_tradepropertys", values.get("tpv_tradepropertys"), rowIndex);
                this.getModel().setValue("tpv_conprodname", values.get("tpv_conprodname"), rowIndex);
                this.getModel().setValue("tpv_departmet", values.get("tpv_departmet"), rowIndex);
                this.getModel().setValue("tpv_firm", values.get("tpv_firm"), rowIndex);
                this.getModel().setValue("tpv_crew", values.get("tpv_crew"), rowIndex);
                this.getModel().setValue("tpv_saleconum", values.get("tpv_saleconum"), rowIndex);
                this.getModel().setValue("tpv_isquantitys", values.get("tpv_isquantitys"), rowIndex);
                this.getModel().setValue("tpv_taxamounts", values.get("tpv_taxamounts"), rowIndex);
                this.getModel().setValue("tpv_amountincrea", values.get("tpv_amountincrea"), rowIndex);
                this.getModel().setValue("tpv_vatrates", values.get("tpv_vatrates"), rowIndex);
                this.getModel().setValue("tpv_notaxamounts", values.get("tpv_notaxamounts"), rowIndex);
                this.getModel().setValue("tpv_entryid", values.get("tpv_entryid"), rowIndex);
                this.getModel().setValue("tpv_contractgoods", "销售合同", rowIndex);
            }
    }

    /**
     * 监听返利对应采购合同号进行过滤
     * @param evt
     */
    @Override
    public void beforeF7Select(BeforeF7SelectEvent evt) {
        String name = evt.getProperty().getName();
        switch (name) {
            case "tpv_parallelismpur":
                qFilterThisbilltype(evt);
                break;
        }
    }

    /**
     * 根据对应供应商进行过滤利对应采购合同号
     * @param evt
     */
    private void qFilterThisbilltype(BeforeF7SelectEvent evt) {
        ListShowParameter showParameter = (ListShowParameter) evt.getFormShowParameter();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        int rowIndex = this.getModel().getEntryCurrentRowIndex("tpv_advconap");
        DynamicObject dabilltype = this.getModel().getEntryRowEntity("tpv_advconap", rowIndex);
                String number = "";
                DynamicObject billts = dabilltype.getDynamicObject("tpv_parallelismsup");
                if (billts != null) {
                    number = billts.getString("number");
                    showParameter.getListFilterParameter().setFilter(new QFilter("tpv_supplier.number", QCP.equals, number));
                }
            }

    /**
     * 点击单据体行后查询核销单数据返回
     */
    private void query(Long advconappkValue) {
        long customerdid = 0L;
        long materialdid = 0L;
        long prodnamedid = 0L;
        long deptdid = 0L;
        this.getModel().deleteEntryData("tpv_verifications");
        List<Map<String,Object>> verificationlist = new ArrayList<>();
        Map<String,Object> map = new HashMap<>();
        if(advconappkValue == 0) {
            int index = this.getModel().getEntryCurrentRowIndex("tpv_advconap");
            DynamicObject selectedData = this.getModel().getEntryRowEntity("tpv_advconap", index);
            advconappkValue = (Long) selectedData.getPkValue();
        }
        String billno = (String) this.getModel().getValue("billno");
        QFilter qFilter = new QFilter("billstatus", QCP.equals, "C");//已审核
        qFilter.and("tpv_sourcebillno",QCP.equals,billno);
        String selectStrxs = DynamicObjectUtil.getSelectfields("tpv_cm_altverification", false);
         selectStrxs = DynamicObjectUtil.getEntrySelectfields(selectStrxs,"tpv_cm_altverification","tpv_settledetail","tpv_verificatedetail");
        selectStrxs = DynamicObjectUtil.getEntrySelectfields(selectStrxs,"tpv_cm_altverification","tpv_settledetail");
        DynamicObject[] load = BusinessDataServiceHelper.load("tpv_cm_altverification", selectStrxs, qFilter.toArray());
        for (DynamicObject dynamicObject : load) {
            DynamicObjectCollection tpvSettledetail = dynamicObject.getDynamicObjectCollection("tpv_settledetail");
            String billnod = dynamicObject.getString("billno");
            String verificationtype = dynamicObject.getString("tpv_verificationtype");//核销类型
            for (DynamicObject settledetail : tpvSettledetail) {
                String srcbillentryid = settledetail.getString("tpv_srcbillentryid");

                if(srcbillentryid.equals(String.valueOf(advconappkValue))){
                    DynamicObjectCollection tpvVerificatedetail = settledetail.getDynamicObjectCollection("tpv_verificatedetail");
                    for (DynamicObject verificatedetail : tpvVerificatedetail) {
                        String altimeternumd = verificatedetail.getString("tpv_altimeternum1");//高低计号
                        String salenumsd = verificatedetail.getString("tpv_salenums1");//销售合同号
                        String purconnumd = verificatedetail.getString("tpv_purconnum1");//采购合同号
                        DynamicObject customerd = verificatedetail.getDynamicObject("tpv_customer1");
                        if(customerd!= null) {
                             customerdid = customerd.getLong("id");//客户
                        }
                        DynamicObject materiald = verificatedetail.getDynamicObject("tpv_material1");
                        if(materiald != null) {
                             materialdid = materiald.getLong("id");//物料
                        }
                        DynamicObject prodnamed = verificatedetail.getDynamicObject("tpv_prodname1");
                        if(prodnamed != null) {
                             prodnamedid = prodnamed.getLong("id");//品名
                        }
                        DynamicObject deptd = verificatedetail.getDynamicObject("tpv_dept1");
                        if(deptd != null){
                             deptdid = deptd.getLong("id");//部门
                        }
                        BigDecimal tpvVerificatenumd = verificatedetail.getBigDecimal("tpv_verificatenum1");//核销数量
                        BigDecimal tpvAmounttaxd = verificatedetail.getBigDecimal("tpv_amounttax1");//含税金额
                        BigDecimal tpvIntaxrated = verificatedetail.getBigDecimal("tpv_intaxrate1");//增值税率
                        BigDecimal tpvAmountintaxd = verificatedetail.getBigDecimal("tpv_amountintax1");//增值税额
                        BigDecimal tpvAmountnotaxd = verificatedetail.getBigDecimal("tpv_amountnotax1");//不含税金额
                        map.put("tpv_verificationbill",billnod);
                        map.put("tpv_unevennum",altimeternumd);
                        map.put("tpv_saleconumsd",salenumsd);
                        map.put("tpv_purconumsd",purconnumd);
                        map.put("tpv_customer",customerdid);
                        map.put("tpv_canceltype",verificationtype);
                        map.put("tpv_conprodnames",prodnamedid);
                        map.put("tpv_itemcoded",materialdid);
                        map.put("tpv_departments",deptdid);
                        map.put("tpv_cancelqtyda",tpvVerificatenumd);
                        map.put("tpv_taxamounta",tpvAmounttaxd);
                        map.put("tpv_amountincad",tpvIntaxrated);
                        map.put("tpv_amountinc",tpvAmountintaxd);
                        map.put("tpv_cancelqtyd",tpvAmountnotaxd);
                        verificationlist.add(map);
                    }

                }
            }
        }
        int rowIndex = this.getModel().createNewEntryRow("tpv_verifications");
        for (Map<String, Object> verificalist : verificationlist) {
            this.getModel().setValue("tpv_verificationbill", verificalist.get("tpv_verificationbill"), rowIndex);
            this.getModel().setValue("tpv_unevennum", verificalist.get("tpv_unevennum"), rowIndex);
            this.getModel().setValue("tpv_saleconumsd", verificalist.get("tpv_saleconumsd"), rowIndex);
            this.getModel().setValue("tpv_purconumsd", verificalist.get("tpv_purconumsd"), rowIndex);
            this.getModel().setValue("tpv_customer", verificalist.get("tpv_customer"), rowIndex);
            this.getModel().setValue("tpv_canceltype", verificalist.get("tpv_canceltype"), rowIndex);
            this.getModel().setValue("tpv_conprodnames", verificalist.get("tpv_conprodnames"), rowIndex);
            this.getModel().setValue("tpv_itemcoded", verificalist.get("tpv_itemcoded"), rowIndex);
            this.getModel().setValue("tpv_departments", verificalist.get("tpv_departments"), rowIndex);
            this.getModel().setValue("tpv_cancelqtyda", verificalist.get("tpv_cancelqtyda"), rowIndex);
            this.getModel().setValue("tpv_taxamounta", verificalist.get("tpv_taxamounta"), rowIndex);
            this.getModel().setValue("tpv_amountincad", verificalist.get("tpv_amountincad"), rowIndex);
            this.getModel().setValue("tpv_amountinc", verificalist.get("tpv_amountinc"), rowIndex);
            this.getModel().setValue("tpv_cancelqtyd", verificalist.get("tpv_cancelqtyd"), rowIndex);
        }
        this.getView().getControl("save");

    }


    private void calculateTaxAmount(int index) {
        IEntryOperate entryOperate = this.getModel();
        entryOperate.setEntryCurrentRowIndex("tpv_advconap", index);	// 必须先指定父行号
        DynamicObjectCollection entity = entryOperate.getEntryEntity("tpv_verifications");// 取分录数据包
        BigDecimal amountTaxSub = BigDecimal.ZERO;
        BigDecimal amountTax = BigDecimal.ZERO;
        amountTax = (BigDecimal) this.getModel().getValue("tpv_taxamounts",index);
        for (DynamicObject object : entity) {
            amountTaxSub = amountTaxSub.add(object.getBigDecimal("tpv_taxamounta"));
        }
        //子分录含税金额之和大于父分录含税金额,以小值为准
        this.getModel().beginInit();
        if (amountTaxSub.compareTo(amountTax) > 0){
            BigDecimal subtract = amountTaxSub.subtract(amountTax);
            for (int i = entity.size() - 1; i >= 0; i--) {
                BigDecimal lastAmount = entity.get(i).getBigDecimal("tpv_taxamounta");
                if (lastAmount.compareTo(subtract) < 0){
                    this.getModel().setValue("tpv_taxamounts",new BigDecimal(0),i,index);
                    subtract = subtract.subtract(lastAmount);
                }else {
                    this.getModel().setValue("tpv_taxamounta",lastAmount.subtract(subtract),i,index);
                    break;
                }
            }
        }else {
            this.getModel().setValue("tpv_taxamounts",amountTaxSub,index);
        }
        this.getModel().endInit();
        this.getView().updateView("tpv_advconap");
        this.getView().updateView("tpv_verifications");
    }

}


