package com.itopview.wm.cm.opplugin.convert;

import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;

/**
 * ClassName: AltimeterConvert
 * Description:
 * date: 2023/11/17 9:58
 *
 * @author: Guo jiaChen
 */
public class AltimeterConvert  extends AbstractConvertPlugIn {
    private static final String targetName = "tpv_cm_altverification";
    private static final String VerificationEntryDetail = "tpv_verificatedetail";
    private static final String SettleEntryDetail = "tpv_settledetail";
    @Override
    public void afterConvert(AfterConvertEventArgs e) {

        OperateOption option = this.getOption();
        boolean has = option.containsVariable("type");
        if (has){
            ExtendedDataEntity[] entryentitiess = e.getTargetExtDataEntitySet().FindByEntityKey(targetName);
            for (ExtendedDataEntity dataEntity : entryentitiess) {
                //目标单
                DynamicObject targetBill = dataEntity.getDataEntity();
                String type = option.getVariableValue("type");
                targetBill.set("tpv_verificationtype",type);
                if (!type.equals("A")){
                    DynamicObjectCollection collection = targetBill.getDynamicObjectCollection(SettleEntryDetail);
                    for (int i = 0; i < collection.size(); i++) {
                        DynamicObject object = collection.get(i);
                        DataEntityPropertyCollection properties = object.getDynamicObjectType().getProperties();
                        DynamicObjectCollection subCollection = object.getDynamicObjectCollection(VerificationEntryDetail);
                        DataEntityPropertyCollection properties2 = subCollection.getDynamicObjectType().getProperties();
                        DynamicObject addNew = subCollection.addNew();
                        for (IDataEntityProperty property : properties) {
                            String key = property.getName();
                            if (!"tpv_altimeternum".equals(key)){
                                if (properties2.containsKey(key + "1")) {
                                    addNew.set(key + "1", object.get(key));
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
