package com.itopview.wm.cm.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

/**
 * 四大合同源单反审核将合同条款中的是否调整改为否
 * @author zhangh
 *
 */
public class ContractClauseUnAuditOp extends AbstractOperationServicePlugIn {
	@Override
	public void afterExecuteOperationTransaction(AfterOperationArgs e) {
		if (this.getOperationResult().isSuccess()) {
			DynamicObject[] dataEntity = e.getDataEntities();
			for (DynamicObject data : dataEntity) {
				data = BusinessDataServiceHelper.loadSingleFromCache(data.getPkValue(), data.getDataEntityType().getName());
				updateChangenum(data);
			}
		}
	}

	private void updateChangenum(DynamicObject data) {
		DynamicObjectCollection tpv_clauseimport = data.getDynamicObjectCollection("tpv_clauseimport");
		for (int i = 0; i < tpv_clauseimport.size(); i++) {
			DynamicObject clauseimport = tpv_clauseimport.get(i);
			clauseimport.set("tpv_change", false);
			clauseimport.set("tpv_changenum", 0);
		}
		SaveServiceHelper.save(new DynamicObject[] {data});		
	}
}
