package com.itopview.wm.cm.opplugin.validator;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.formula.FormulaEngine;

/**
 * 保证金策略 保存操作校验插件
 */
public class MarginStrategySaveValidator extends AbstractValidator {
    @Override
    public void validate() {
        ExtendedDataEntity[] dataEntities = this.dataEntities;
        for (int i = 0; i < dataEntities.length; i++) {
            ExtendedDataEntity extend = dataEntities[i];
            DynamicObject entity = extend.getDataEntity();
            check(entity,extend);
        }
    }

    public void check(DynamicObject entity,ExtendedDataEntity extend){
        DynamicObjectCollection tpv_ms_elementsentry_s = entity.getDynamicObjectCollection("tpv_ms_elementsentry");
        DynamicObjectCollection tpv_ms_formulaentry_s = entity.getDynamicObjectCollection("tpv_ms_formulaentry");
        for(int i=0;i<tpv_ms_formulaentry_s.size();i++){
            DynamicObject tpv_ms_formulaentry = tpv_ms_formulaentry_s.get(i);
            String tpv_formula = tpv_ms_formulaentry.getString("tpv_formula");
            for(int j=0;j<tpv_ms_elementsentry_s.size();j++){
                DynamicObject tpv_ms_elementsentry = tpv_ms_elementsentry_s.get(j);
                DynamicObject tpv_marginelements = tpv_ms_elementsentry.getDynamicObject("tpv_marginelements");
                String tpv_marginelements_name = tpv_marginelements.getString("name");
                tpv_formula = tpv_formula.replaceAll("\\{"+tpv_marginelements_name+"\\}","1");
            }
            try {
                FormulaEngine.execExcelFormula(tpv_formula);
            }catch (Exception ex){
                ex.printStackTrace();
                this.addMessage(extend, "第"+(i+1)+"行公式不正确，请检查！");
            }
        }

    }
}
