package com.itopview.wm.cm.report;

import com.itopview.wm.crm.report.SupCreditConRptDataPlugin;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.sdk.plugin.Plugin;
import kd.taxc.common.util.StringUtil;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * @Description: 成本处理可红冲数量查询表
 * @Author LinRui
 * @Date 2023/11/16 20:02
 */
public class CostdisposeredRptQuery extends AbstractReportListDataPlugin implements Plugin {

    private static final String algoKey = SupCreditConRptDataPlugin.class.getName();

    @Override
    public DataSet query(ReportQueryParam reportQueryParam, Object o) throws Throwable {
        FilterInfo filter = reportQueryParam.getFilter();
        String whereFilter = createWhereStr(reportQueryParam);
        DataSet instockDataSet = query(whereFilter);
        return instockDataSet;
    }

    public static DataSet query(String whereFilter) {
        DataSet mainDataSet = mainDataSet(whereFilter);
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        for (DynamicObject col : col_s) {

        }

        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(CostdisposeredRptQuery.class.getName()).createDataSet(inputs);
        return createDataSet.orderBy(new String[]{"tpv_bizdate desc"});
    }

    private static DataSet mainDataSet(String whereFilter) {
        QFilter[] qFilters = new QFilter[]{new QFilter("billstatus", QCP.equals, "C")};
        DataSet tpvCmCostdispose = ORM.create().queryDataSet(algoKey, "tpv_cm_costdispose",
                "id,billno,tpv_itemcode,tpv_itemcode.name,tpv_conprodname,tpv_conorigin,tpv_conspecation,tpv_bizdate," +
                        "tpv_conshader,createtime,modifytime,tpv_bluered,tpv_costdirec,tpv_tentauth," +
                        "tpv_costype,tpv_currency,tpv_origprice,tpv_rate,tpv_origampintax,tpv_origampnotax," +
                        "tpv_origamptax,tpv_basampintax,tpv_basampnotax,tpv_basamptax,tpv_dollarintax," +
                        "tpv_dollarnotax,tpv_dollartax,tpv_soudocumtype,tpv_soudocumnum,tpv_soudocumid," +
                        "tpv_tiggdoutype,tpv_tiggdounum,tpv_tiggdouid,tpv_storagenum,tpv_storageid,tpv_supstoragenum," +
                        "tpv_supstorageid,tpv_movegoodsnum,tpv_movegoodsid,tpv_msungoodsid,tpv_quantity," +
                        "tpv_elimination,tpv_purconnum,tpv_combinbun,tpv_vendor,tpv_logserpro,tpv_saleconnum," +
                        "tpv_client,tpv_tradeproperty,tpv_drawback,tpv_refundrate",
                qFilters);
        DataSet tpvEliminationId = tpvCmCostdispose.copy();  //id = tpv_elimination
        List<String> tpvElimination_s = new ArrayList<>();
        for (Row row : tpvEliminationId) {
            String tpvElimination = row.getString("tpv_elimination");
            if (StringUtils.isNotBlank(tpvElimination)) {
                tpvElimination_s.add(tpvElimination);
            }
        }
        DataSet redQty = tpvCmCostdispose.copy();
        if (tpvElimination_s.size() > 0) {
            redQty = redQty.where(String.format("id in (%s)", StringUtil.strip(tpvElimination_s.toString(), "[]")))
                    .groupBy(new String[]{"id", "tpv_elimination"})
                    .sum("tpv_quantity").finish().select("id", "tpv_quantity redQty");
        } else {
            redQty = redQty.select("id", "0 redQty");
        }

        DataSet dataSet = tpvCmCostdispose.where("tpv_bluered = 'A'").leftJoin(redQty).on("id", "id")
                .select("id tpv_id", "billno tpv_billno", "tpv_itemcode", "tpv_conprodname", "tpv_conorigin", "tpv_conspecation", "tpv_bizdate",
                        "tpv_conshader", "createtime tpv_createtime", "modifytime tpv_modifytime", "tpv_bluered", "tpv_costdirec", "tpv_tentauth",
                        "tpv_costype", "tpv_currency", "tpv_origprice", "tpv_rate", "tpv_origampintax", "tpv_origampnotax",
                        "tpv_origamptax", "tpv_basampintax", "tpv_basampnotax", "tpv_basamptax", "tpv_dollarintax", "tpv_dollarnotax",
                        "tpv_dollartax", "tpv_soudocumtype", "tpv_soudocumnum", "tpv_soudocumid", "tpv_tiggdoutype", "tpv_tiggdounum",
                        "tpv_tiggdouid", "tpv_storagenum", "tpv_storageid", "tpv_supstoragenum", "tpv_supstorageid", "tpv_movegoodsnum",
                        "tpv_movegoodsid", "tpv_msungoodsid", "tpv_quantity + redQty tpv_redqty", "tpv_elimination", "tpv_purconnum",
                        "tpv_combinbun", "tpv_vendor", "tpv_logserpro", "tpv_saleconnum", "tpv_client", "tpv_tradeproperty", "tpv_drawback",
                        "tpv_refundrate").finish();

        if (YEM.isNotEmpty(whereFilter)) {
            dataSet = dataSet.where(whereFilter);
        }
        return dataSet;
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        // 蓝/红
        String tpv_bluered_f = filterInfo.getString("tpv_bluered_f");
        if (YEM.isNotEmpty(tpv_bluered_f)) {
            whereFilter = String.format("%s and tpv_bluered = '%s'", whereFilter, tpv_bluered_f);
        }
        // 成本方向
        String tpv_costdirec_f = filterInfo.getString("tpv_costdirec_f");
        if (YEM.isNotEmpty(tpv_costdirec_f)) {
            whereFilter = String.format("%s and tpv_costdirec = '%s'", whereFilter, tpv_costdirec_f);
        }
//        // 是否已点价
//        String tpv_ispointpriceed_f = filterInfo.getString("tpv_ispointpriceed_f");
//        if (YEM.isNotEmpty(tpv_ispointpriceed_f)) {
//            whereFilter = String.format("%s and tpv_ispointpriceed = '%s'", whereFilter, tpv_ispointpriceed_f);
//        }
        return whereFilter;
    }
}
