package com.itopview.wm.crm.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.field.ComboEdit;
import kd.bos.form.field.ComboItem;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * @author ljw
 * @version 1.0
 * 2@date 2023/8/25 10:52
 * 客户额度维护表单插件
 * ljwxj
 */
public class CustmainliFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {
    @Override
    public void propertyChanged(PropertyChangedArgs evt) {// 值更新事件
        super.propertyChanged(evt);
        ChangeData cd = evt.getChangeSet()[0];
        String name = evt.getProperty().getName();
        switch (name) {
            case "tpv_quotaplcanum":
                quotaplcanum(evt);
                break;
            case "tpv_limitamt":
                amount(evt);
                break;
            case "tpv_custom":
                customer(cd);
                break;
            case "tpv_quotatype":
                custonum(cd);
        }
    }

    /**
     * 客户类型重复
     * @param cd
     */
    private void custonum(ChangeData cd) {
        String custo = (String) cd.getNewValue();//获取改变的值
        int Index = cd.getRowIndex();
        DynamicObjectCollection entrys = this.getModel().getEntryEntity("tpv_crm_cuslimit");
        DynamicObject custom = (DynamicObject) this.getModel().getValue("tpv_custom", Index);//获取改变的行的客户
        for (DynamicObject entry : entrys) {
            DynamicObject tpv_custom = entry.getDynamicObject("tpv_custom");
            String tpv_quotatype = entry.getString("tpv_quotatype");
            int row = entry.getInt("Seq") - 1;
            if (row == Index) {
                return;
            }
            if (tpv_custom != null && tpv_custom.equals(custom)) {
                if (tpv_quotatype.equals(custo) && tpv_custom == custom) {
                    this.getView().showMessage("该客户类型重复，请修改！！！");
                }
            }
        }
    }

    /**
     * 客户重复
     * @param cd
     */
    private void customer(ChangeData cd) {
        DynamicObject custom = (DynamicObject) cd.getNewValue();
        int a = cd.getRowIndex();
        DynamicObjectCollection entrys = this.getModel().getEntryEntity("tpv_crm_cuslimit");
        int i = 0;
        for (DynamicObject entry : entrys) {
            DynamicObject tpv_custom = entry.getDynamicObject("tpv_custom");
            if (custom == tpv_custom) {
                i = i + 1;
            }
            if (i > 2) {
                this.getView().showMessage("该客户已增加，请更改客户！！！");
                this.getModel().setValue("tpv_custom", null, a);
            }
        }
    }

    /**
     * 分录金额超出表头金额
     * @param evt
     */
    private void amount(PropertyChangedArgs evt) {
//        DynamicObjectCollection entrys = this.getModel().getEntryEntity("tpv_crm_cuslimit");
//        BigDecimal tpv_groupconamt = (BigDecimal) this.getModel().getValue("tpv_groupconamt");//签约金额
//        BigDecimal tpv_groupdelim = (BigDecimal) this.getModel().getValue("tpv_groupdelim");//送货金额
//        BigDecimal groupconamt = BigDecimal.ZERO;
//        BigDecimal groupdelim = BigDecimal.ZERO;
//        for (DynamicObject entry : entrys) {
//            // 获取单据体里金额的字段
//            String tpv_quotatype = entry.getString("tpv_quotatype");
//            if (tpv_groupconamt.compareTo(BigDecimal.ZERO) == 1) {
//                groupconamt = tpv_groupconamt.multiply(new BigDecimal(10000));
//            }
//            if (tpv_groupconamt.compareTo(BigDecimal.ZERO) == 1) {
//                groupdelim = tpv_groupdelim.multiply(new BigDecimal(10000));
//            }
//            if (tpv_quotatype != null && "A".equals(tpv_quotatype)) {
//                BigDecimal amount = entry.getBigDecimal("tpv_limitamt");//签约额度
//                if (amount.compareTo(groupconamt) == 1) {
//                    this.getView().showMessage("分录签约总金额已超出表头签约金额，请检查！！！");
//                }
//            } else if (tpv_quotatype != null && tpv_quotatype.equals("B")) {
//                BigDecimal limitamt = entry.getBigDecimal("tpv_limitamt");//送货额度
//                if (limitamt.compareTo(groupdelim) == 1) {
//                    this.getView().showMessage("分录送货总金额已超出表头送货金额，请检查！！！");
//                }
//            }
//        }
    }


    private void quotaplcanum(PropertyChangedArgs evt) {
        DynamicObject tpv_quotaplcanum = (DynamicObject) this.getModel().getValue("tpv_quotaplcanum");//客户额度申请
        String billno = tpv_quotaplcanum.getString("billno");
        QFilter qFilter = new QFilter("billno", QCP.equals, billno);
        DynamicObject[] vatinvoice = BusinessDataServiceHelper.load("tpv_bd_custtions", "id,billno,tpv_client"
                , new QFilter[]{qFilter}, null);
        if (vatinvoice.length > 0) {
            for (int i = 0; i < vatinvoice.length; i++) {
                DynamicObject custmain = vatinvoice[i];
                DynamicObject tpv_client = custmain.getDynamicObject("tpv_client");
                String client = tpv_client.getString("name");
                if (null != client) {
                    this.getModel().setValue("tpv_cusgroup", client);
                }
            }
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
//        BasedataEdit tpv_org = (BasedataEdit) this.getView().getControl("tpv_organization");  //基础资料字段标识
//        tpv_org.addBeforeF7SelectListener((BeforeF7SelectListener) this);
//        RefBillEdit tpv_guaranums = (RefBillEdit) this.getView().getControl("tpv_guaranums");
//        tpv_guaranums.addBeforeF7SelectListener((BeforeF7SelectListener) this);
    }

    /**
     * \
     * 根据所选择的类型进行过滤
     *
     * @param e
     */
    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_guaranums":
                qFilterThisOrgName(e);  //过滤当前组织
                break;

        }

    }


    private void qFilterThisOrgName(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject org = dataEntity.getDynamicObject("tpv_organization");
        if (org == null) {
            return;
        }
        Long id = (Long) org.get("id");
        QFilters.add(new QFilter("tpv_organization", "=", id)); //设置过滤条件：组织
        QFilters.add(new QFilter("billstatus", "=", "C")); //单据状态：已审核
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    /**
     * 单据打开或刷新
     * 下推后根据单据类型来决定下拉列表的值
     * 根据当前时间判断是否失效的值
     *
     * @param e
     */
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        IDataModel model = this.getModel();
        OperationStatus status = this.getView().getFormShowParameter().getStatus();
        String documentype = (String) this.getModel().getValue("tpv_documentype");
        if (null != documentype) {
            if ("B".equals(documentype)) {
                if (OperationStatus.ADDNEW == status) {
                    this.getView().setEnable(false, "tpv_documentype");
                }
                //设置下拉列表显示标题
                Map<String, Object> map = new HashMap<String, Object>();
                map.put("定期有效", "B");
                map.put("依存担保", "C");
                fillEntityCombo(map);
            }
            if ("A".equals(documentype)) {
                this.getModel().setValue("tpv_validtype", "A");
            }
        }
        Date date = new Date();
        Date tpv_startdates = (Date) this.getModel().getValue("tpv_startdates");//开始时间
        Date tpv_deadlines = (Date) this.getModel().getValue("tpv_deadlines");//结束时间
        if (tpv_deadlines != null) {
//            if (date.compareTo(tpv_deadlines) < 0) {
            if ((tpv_startdates.before(date) || tpv_startdates.equals(date)) && (tpv_deadlines.after(date) || tpv_deadlines.equals(date))) {
                this.getModel().setValue("tpv_invalids", false);
            } else {
                this.getModel().setValue("tpv_invalids", true);
            }
        }
    }

    /**
     * @param map 下拉项值
     */
    private void fillEntityCombo(Map<String, Object> map) {
        ComboEdit mainentry = (ComboEdit) this.getView().getControl("tpv_validtype");
        if (map.size() > 0) {
            List<ComboItem> entryItems = this.buildEntryComboItems(map);
            mainentry.setComboItems(entryItems);
        } else {
            mainentry.setComboItems(null);
        }
    }

    /**
     * @param entitys
     * @return
     */
    private List<ComboItem> buildEntryComboItems(Map<String, Object> entitys) {
        ArrayList<ComboItem> entryItems = new ArrayList<>();
        ComboItem blankItem = new ComboItem();
        blankItem.setValue("");
        blankItem.setCaption(new LocaleString());
        entryItems.add(blankItem);
        if (null != entitys && entitys.size() > 0) {
            for (Map.Entry entry : entitys.entrySet()) {
                String mapKey = (String) entry.getKey();
                String mapValue = (String) entry.getValue();
                ComboItem entryItem = new ComboItem();
                entryItem.setValue(mapValue);
                entryItem.setCaption(new LocaleString(mapKey));
                entryItems.add(entryItem);
//                this.getView().updateView();
            }
        }
        return entryItems;
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs afterDoOperationEventArgs) {
        super.afterDoOperation(afterDoOperationEventArgs);
        String operateKey = afterDoOperationEventArgs.getOperateKey();
        if ("save".equals(operateKey)) {
//            this.getView().invokeOperation("refresh");
            this.getView().updateView("tpv_crm_cuslimit.tpv_frozenstate");
        }
    }
}


