package com.itopview.wm.crm.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

import static com.itopview.wm.utils.DateUtil.countDays;

/**
 * @author ljw
 * @date 2023/8/26 17:15
 * 客户额度维护
 * @className CustmainServicePlugIn
 * @description 保存事件的效验
 */
public class CustmainServicePlugIn extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("org");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() {
                ExtendedDataEntity[] bills = this.getDataEntities();
                if ("save".equals(this.getOperateKey()) && null != e.getDataEntities()) {
                    for (int i = 0; i < bills.length; ++i) {
                        ExtendedDataEntity bill = bills[i];
                        onsubmitDate(bill);
                        cuslimit(bill);
                    }
                }
                if ("submit".equals(this.getOperateKey()) && null != e.getDataEntities()) {
                    for (int i = 0; i < bills.length; ++i) {
                        ExtendedDataEntity bill = bills[i];
                        Updatecombofield(bill);
                    }
                }
            }
            private void Updatecombofield(ExtendedDataEntity dataEntities) {
                DynamicObject dataEntity = dataEntities.getDataEntity();
                String tpv_validtype = dataEntity.getString("tpv_validtype");//单据类型为长期的
                if ("A".equals(tpv_validtype)) {

                    String tpv_orgcredit = dataEntity.getString("tpv_orgcredit");//公司/部门
                    String billno = dataEntity.getString("billno");
                    String tpv_cusgroup = dataEntity.getString("tpv_cusgroup");//客户集团
                    BigDecimal tpv_groupconamts = dataEntity.getBigDecimal("tpv_groupconamt");
                    BigDecimal tpv_groupdelims = dataEntity.getBigDecimal("tpv_groupdelim");
                    DynamicObjectCollection entrys = dataEntity.getDynamicObjectCollection("tpv_crm_cuslimit");
                    for (DynamicObject entry : entrys) {
                        int row = entry.getInt("Seq");//可以加减
                        String tpv_quotatype = entry.getString("tpv_quotatype");
                        if (tpv_quotatype != null && "A".equals(tpv_quotatype)) {
                            BigDecimal amount = entry.getBigDecimal("tpv_limitamt");//签约额度
                            if (amount.compareTo(tpv_groupconamts) == 1) {
                                this.addMessage(dataEntities, "分录第" + row + "行签约金额已超出表头签约金额，请检查！！！");
                            }
                        } else if (tpv_quotatype != null && "B".equals(tpv_quotatype)) {
                            BigDecimal limitamt = entry.getBigDecimal("tpv_limitamt");//送货额度
                            if (limitamt.compareTo(tpv_groupdelims) == 1) {
                                this.addMessage(dataEntities, "分录第" + row + "行送货金额已超出表头送货金额，请检查！！！");
                            }
                        }
                    }
                    QFilter qFilter = new QFilter("tpv_cusgroup", QCP.equals, tpv_cusgroup);
                    qFilter.and("tpv_orgcredit", QCP.equals, tpv_orgcredit);
                    qFilter.and("billno", QCP.not_equals, billno);
                    DynamicObject[] tpv_crm_custmain = BusinessDataServiceHelper.load("tpv_crm_custmain", "id,billno,tpv_orgcredit,tpv_cusgroup"
                            , new QFilter[]{qFilter}, null);
                    if (tpv_crm_custmain.length > 0) {
                        for (int i = 0; i < tpv_crm_custmain.length; i++) {
                            DynamicObject custmain = tpv_crm_custmain[i];
                            String orgcredit = custmain.getString("tpv_orgcredit");
                            if ("A".equals(orgcredit)) {
                                this.addMessage(dataEntities, "同一公司，同一【客户集团】下只能有一个长期有效的《客户额度维护》！！！");
                                return;

                            } else if ("B".equals(orgcredit)) {
                                this.addMessage(dataEntities, "同一部门，同一【客户集团】下只能有一个长期有效的《客户额度维护》！！！");
                                return;
                            }
                        }
                    }
                    if ("B".equals(tpv_orgcredit)) {
                        BigDecimal a = BigDecimal.ZERO;
                        BigDecimal b = BigDecimal.ZERO;
                        BigDecimal c = BigDecimal.ZERO;
                        BigDecimal d = BigDecimal.ZERO;
                        QFilter qFilters = new QFilter("tpv_cusgroup", QCP.equals, tpv_cusgroup);
                        qFilters.and("tpv_orgcredit", QCP.equals, "A");
                        DynamicObject[] tpv_custmain = BusinessDataServiceHelper.load("tpv_crm_custmain", "id,billno,tpv_orgcredit,tpv_cusgroup"
                                , new QFilter[]{qFilters}, null);
                        if (tpv_custmain.length == 0) {
                            this.addMessage(dataEntities, "必须先有【公司】授信才能建立【部门】授信");
                            return;
                        }

                        QFilter qFiltere = new QFilter("tpv_cusgroup", QCP.equals, tpv_cusgroup);
                        qFiltere.and("tpv_orgcredit", QCP.equals, "A");
//                        qFiltere.and("billno", QCP.not_equals, billno);
                        DynamicObject[] tpvcustmain = BusinessDataServiceHelper.load("tpv_crm_custmain", "id,billno,tpv_orgcredit,tpv_cusgroup,tpv_groupconamt,tpv_groupdelim"
                                , new QFilter[]{qFiltere}, null);
                        if (tpvcustmain.length > 0) {
                            for (int j = 0; j < tpvcustmain.length; j++) {
                                DynamicObject custmain = tpvcustmain[j];
                                BigDecimal tpv_groupconamt = custmain.getBigDecimal("tpv_groupconamt");//签约额度
                                BigDecimal tpv_groupdelim = custmain.getBigDecimal("tpv_groupdelim");//送货额度
                                a = a.add(tpv_groupconamt);
                                b = b.add(tpv_groupdelim);
                            }
                        }
                        BigDecimal tpv_groupconamt = dataEntity.getBigDecimal("tpv_groupconamt");//签约额度
                        BigDecimal tpv_groupdelim = dataEntity.getBigDecimal("tpv_groupdelim");//送货额度
                        String tpv_documentype = dataEntity.getString("tpv_validtype");//单据类型
                        if (tpv_documentype.equals("A")) {
                            c = c.add(tpv_groupconamt);
                            d = d.add(tpv_groupdelim);
//                                }
//                            }
                        }
                        if (a.compareTo(c) == -1) {
                            this.addMessage(dataEntities, "【部门】总签约额度不能大于【公司】总签约额度！！！");
                        }
                        if (b.compareTo(d) == -1) {
                            this.addMessage(dataEntities, "【部门】总送货额度不能大于【公司】总送货额度！！！");
                        }
                    }
                }
            }
            /**
             * 保存是检查赊销账期和内部额外宽限期是否一致
             */
            private void onsubmitDate(ExtendedDataEntity dataEntities) {
                // 获取实体
                DynamicObject entity = dataEntities.getDataEntity();
                //获取赊销账期(天）的值
                DynamicObject org = entity.getDynamicObject("org");//部门
                int icreditperiod = entity.getInt("tpv_icreditperiod");//赊销账期
                int intadditgraces = entity.getInt("tpv_intadditgraces");//内部额外宽限期
                DynamicObjectCollection entry = entity.getDynamicObjectCollection("tpv_crm_cuslimit");//单据体
                if (org == null) {
                    return;
                }
                if (!entry.equals(null) && !entry.isEmpty()) {
                    for (DynamicObject entitys : entry) {
                        DynamicObject custom = entitys.getDynamicObject("tpv_custom");//客户
                        if (custom != null) {
                            QFilter qFilter = new QFilter("tpv_crm_cuslimit.tpv_custom", QCP.equals, custom.getLong("id"));//查询相同的
                            qFilter.and(new QFilter("org.id", QCP.equals, org.getLong("id")));
                            qFilter.and(new QFilter("id", QCP.not_equals, entity.getLong("id")));
                            DynamicObject[] vatinvoice = BusinessDataServiceHelper.load("tpv_crm_custmain", "id,billno,tpv_icreditperiod,tpv_intadditgraces"
                                    , new QFilter[]{qFilter}, null);
                            if (vatinvoice.length > 0) {
                                for (int i = 0; i < vatinvoice.length; i++) {
                                    DynamicObject custmain = vatinvoice[i];
                                    int tpv_icreditperiod = custmain.getInt("tpv_icreditperiod");//赊销账期
                                    int tpv_intadditgraces = custmain.getInt("tpv_intadditgraces");//内部额外宽限期
                                    if (icreditperiod != tpv_icreditperiod) {//赊销账期
//                                            e.setCancel(true);
                                        this.addMessage(dataEntities, "同一部门下同一客户的【赊销账期】必须一致!");
                                        return;
                                    }
                                    if (intadditgraces != tpv_intadditgraces) {
//                                            e.setCancel(true);
                                        this.addMessage(dataEntities, "同一部门下同一客户的【内部额外宽限期】必须一致!");
                                        return;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            public void cuslimit(ExtendedDataEntity bill) {
                ExtendedDataEntity[] dataEntities = this.getDataEntities();
                for (ExtendedDataEntity dataEntitie : dataEntities) {
                    DynamicObject dataEntity = dataEntitie.getDataEntity();
                    DynamicObject org = dataEntity.getDynamicObject("org");//部门
                    int integerfields = dataEntity.getInt("tpv_icreditperiod");//赊销账期
                    int intadditgraces = dataEntity.getInt("tpv_intadditgraces");//内部额外宽限期
                    DynamicObjectCollection entry = dataEntity.getDynamicObjectCollection("tpv_crm_cuslimit");//单据体
                    if (entry!=(null) && !entry.isEmpty()) {
                        for (DynamicObject entitys : entry) {
                            DynamicObject custom = entitys.getDynamicObject("tpv_custom");//客户
                            if (custom != null) {
                                QFilter qFilter = new QFilter("tpv_custom.id", QCP.equals, custom.getLong("id"));//查询相同的
                                qFilter.and(new QFilter("org.id", QCP.equals, org.getLong("id")));
                                qFilter.and(new QFilter("id", QCP.not_equals, dataEntity.getLong("id")));
                                DynamicObject[] vatinvoice = BusinessDataServiceHelper.load("tpv_crm_custmain", "id,billno,tpv_icreditperiod,tpv_intadditgraces"
                                        , new QFilter[]{qFilter}, null);
                                //1、保存校验同一部门下有多张存在同客户的《客户额度维护》时【赊销账期(天）】必须一致；
                                if (vatinvoice.length > 0) {
                                    for (int i = 0; i < vatinvoice.length; i++) {
                                        DynamicObject custmain = vatinvoice[i];
                                        int tpv_integerfields = custmain.getInt("tpv_icreditperiod");//赊销账期
                                        int tpv_intadditgraces = custmain.getInt("tpv_intadditgraces");//内部额外宽限期
                                        if (integerfields != tpv_integerfields) {//赊销账期
                                            this.addErrorMessage(dataEntitie,String.format("【赊销账期】超过申请期限，请联系客户服务部!"));
                                        }
                                        if (intadditgraces != tpv_intadditgraces) {
                                            this.addErrorMessage(dataEntitie,String.format("同一部门下同一客户的【内部额外宽限期】必须一致!"));
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        });
    }
    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        String key = e.getOperationKey();
        if ("save".equals(key)) {
            Updatecombofield(e);
        }
    }

    /**
     * 180天没有该【客户】已审核的《销售出库单》则自动更新为“是”，根据《销售出库单》【业务日期】判断
     *
     * @param e 上下文擦参数
     */
    public void Updatecombofield(BeforeOperationArgs e) {

        DynamicObject[] dataEntities = e.getDataEntities();
        for (DynamicObject dataEntity : dataEntities) {
            DynamicObjectCollection tpv_crm_cuslimit = dataEntity.getDynamicObjectCollection("tpv_crm_cuslimit");
            if (tpv_crm_cuslimit.size() > 0) {
                for (int i = 0; i < tpv_crm_cuslimit.size(); i++) {
                    DynamicObject cuslimit = tpv_crm_cuslimit.get(i);
                    DynamicObject tpv_custom = cuslimit.getDynamicObject("tpv_custom");
                    if (tpv_custom != null) {
                        QFilter qFilter = new QFilter("customer.id", QCP.equals, tpv_custom.getLong("id"));
//                        qFilter.and(new QFilter("org.id", QCP.equals, orgid));
                        qFilter.and(new QFilter("billstatus", QCP.equals, "C"));
                        DynamicObject[] im_saloutbill = BusinessDataServiceHelper.load("im_saloutbill", "id,billno,biztime"
                                , new QFilter[]{qFilter}, "biztime desc");
                        if (im_saloutbill.length == 0) {
                            cuslimit.set("tpv_frozenstate", "A");//是
                        }
                        if (im_saloutbill.length > 0) {
                            for (int j = 0; j < im_saloutbill.length; j++){
                                DynamicObject saloutbill = im_saloutbill[j];
                                if (saloutbill != null) {
                                    Date biztime = saloutbill.getDate("biztime");//销售出库业务日期
                                    if (countDays(biztime, new Date()) >= 180) {
                                        cuslimit.set("tpv_frozenstate", "A");//是
                                    } else {
                                        cuslimit.set("tpv_frozenstate", "B");//否
                                    }
                                }
                            }
                        }

                    }
                }
            }
        }
    }
}
