package com.itopview.wm.crm.opplugin.op;

import kd.bd.gmc.common.enums.EnableStatusEnum;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import javax.xml.crypto.Data;
import java.util.Date;

/**
 * @author ljw
 * @date 2023/8/29 20:08
 * @className GuaranteeFormPlugin
 * @description 担保登记单的值更新后更改引用本单数据的客户额度维护（客户临时额度维护）的有效限期的值
 * ljwxj
 */
public class GuaranteeServicePlugIn extends AbstractOperationServicePlugIn {
    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        //获取操作对象
        String key = e.getOperationKey();
        //判断具体操作
        switch (key) {
            case "save":
                //监控按钮保存
                this.clickSave(e);
                this.update(e);
                break;
        }
    }

    private void clickSave(BeforeOperationArgs e) {
        DynamicObject[] entities = e.getDataEntities();
        for (DynamicObject entity : entities) {
            String billno = entity.getString("billno");//单据编码
            Date startdate = entity.getDate("tpv_startdate");//
            Date deadline = entity.getDate("tpv_deadline");
            QFilter qFilter = new QFilter("tpv_guaranums.billno", QCP.equals, billno);//过滤担保登记单
            DynamicObject[] vatinvoice = BusinessDataServiceHelper.load("tpv_crm_custmain", "id,billno,tpv_deadlines,tpv_startdates,tpv_invalids"
                    , new QFilter[]{qFilter}, null);
            if (vatinvoice.length > 0) {
                for (int i = 0; i < vatinvoice.length; i++) {
                    DynamicObject custmain = vatinvoice[i];
                    Date deadlines = custmain.getDate("tpv_deadlines");
                    Date startdates = custmain.getDate("tpv_startdates");
                    if (deadline != deadlines) {
                        vatinvoice[i].set("tpv_deadlines", deadline);
                    }
                    if (startdate != startdates) {
                        vatinvoice[i].set("tpv_startdates", startdate);
                    }
                    if (new Date().before(startdate)) {
                        vatinvoice[i].set("tpv_invalids", true);
                    } else {
                        vatinvoice[i].set("tpv_invalids", false);
                    }
                    SaveServiceHelper.update(vatinvoice);
                }
            }
        }
    }
        private void update(BeforeOperationArgs e) {
            DynamicObject[] entities = e.getDataEntities();
            for (DynamicObject entity : entities) {
                String billno = entity.getString("billno");//单据编码
                Date startdate = entity.getDate("tpv_startdate");//
                Date deadline = entity.getDate("tpv_deadline");
                QFilter qFilter = new QFilter("tpv_guarantynums.billno", QCP.equals, billno);//过滤担保登记单
                DynamicObject[] vatinvoice = BusinessDataServiceHelper.load("tpv_bd_supplierlimits", "id,billno,tpv_enddate,tpv_startdatete,tpv_ifeffective"
                        , new QFilter[]{qFilter}, null);
                if (vatinvoice.length > 0) {
                    for (int i = 0; i < vatinvoice.length; i++) {
                        DynamicObject custmain = vatinvoice[i];
                        Date deadlines = custmain.getDate("tpv_enddate");
                        Date startdates = custmain.getDate("tpv_startdatete");
                        if (deadline != deadlines) {
                            vatinvoice[i].set("tpv_enddate", deadline);
                        }
                        if (startdate != startdates) {
                            vatinvoice[i].set("tpv_startdatete", startdate);
                        }
                        if (new Date().before(startdate)) {
                            vatinvoice[i].set("tpv_ifeffective", true);
                        } else {
                            vatinvoice[i].set("tpv_ifeffective", false);
                        }
                        SaveServiceHelper.update(vatinvoice);
                    }
                }
            }
        }
}
