package com.itopview.wm.crm.opplugin.validator;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;

/**
 * @author ljw
 * @date 2023/8/26 18:46
 * @className CustmainSaveOpvalidator
 * @description 客户额度维护保存校验插件
 */
public class CustmainSaveOpvalidator  extends AbstractValidator {
    @Override
    public void validate() {
        ExtendedDataEntity[] dataEntities = this.getDataEntities();
        for (ExtendedDataEntity dataEntitie : dataEntities) {
            DynamicObject dataEntity = dataEntitie.getDataEntity();
            DynamicObject org = dataEntity.getDynamicObject("org");//部门
            int integerfields = dataEntity.getInt("tpv_icreditperiod");//赊销账期
            int intadditgraces = dataEntity.getInt("tpv_intadditgraces");//内部额外宽限期
            DynamicObjectCollection entry = dataEntity.getDynamicObjectCollection("tpv_crm_cuslimit");//单据体
            if (!entry.equals(null) && !entry.isEmpty()) {
                for (DynamicObject entitys : entry) {
                    DynamicObject custom = entitys.getDynamicObject("tpv_custom");//客户
                    if (custom != null) {
                        QFilter qFilter = new QFilter("tpv_custom.id", QCP.equals, custom.getLong("id"));//查询相同的
//                    qFilter.and(new QFilter("tpv_integerfields",QCP.not_equals,integerfields));
//                    qFilter.and(new QFilter("tpv_integerfields",QCP.is_notnull,null));
                        qFilter.and(new QFilter("org.id", QCP.equals, org.getLong("id")));
                        qFilter.and(new QFilter("id", QCP.not_equals, dataEntity.getLong("id")));
                        DynamicObject[] vatinvoice = BusinessDataServiceHelper.load("tpv_crm_custmain", "id,billno,tpv_icreditperiod,tpv_intadditgraces"
                                , new QFilter[]{qFilter}, null);
                        //1、保存校验同一部门下有多张存在同客户的《客户额度维护》时【赊销账期(天）】必须一致；
                        if (vatinvoice.length > 0) {
                            for (int i = 0; i < vatinvoice.length; i++) {
                                DynamicObject custmain = vatinvoice[i];
                                int tpv_integerfields = custmain.getInt("tpv_icreditperiod");//赊销账期
                                int tpv_intadditgraces = custmain.getInt("tpv_intadditgraces");//内部额外宽限期
                                if (integerfields != tpv_integerfields) {//赊销账期
                                    this.addErrorMessage(dataEntitie,String.format("【赊销账期】超过申请期限，请联系客户服务部!"));
                                }
                                if (intadditgraces != tpv_intadditgraces) {
                                    this.addErrorMessage(dataEntitie,String.format("同一部门下同一客户的【内部额外宽限期】必须一致!"));
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
