package com.itopview.wm.dt.api.AgriculturalelApi;

import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

import java.io.Serializable;
import java.util.List;

/**
 * 审批结果反馈
 * @author LiuHB
 * @version 1.0
 */
@ApiModel
public class AgriculApprovalModel  implements Serializable {
   
    @ApiParam(value = "产品编码", required = true)
    private String productId;
  
    @ApiParam(value = "商圈编码", required = true)
    private String busiGroupCode;
   
    @ApiParam(value = "核心企业组织机构代码", required = true)
    private String coreOrgCode;
   
    @ApiParam(value = "平台编码", required = true)
    private String sysCode;
  
    @ApiParam(value = "贷款申请编号（融资流水号）", required = true)
    private String loanApplyNo;
 
    @ApiParam(value = "融资申请编号", required = false)
    private String outApplyNo;
   
    @ApiParam(value = "审批结果", required = true)
    private String code;

    @ApiParam(value = "拒绝原因", required = true)
    private String msg;

    @ApiParam(value = "审批日期", required = true)
    private String appvDate	;
  
    @ApiParam(value = "合同内容（审批通过的时候有）", required = false)
    private String contContent	;
 
    @ApiParam(value = "融资放款账户名称", required = true)
    private String recvName	;
 
    @ApiParam(value = "融资放款账户号码", required = true)
    private String recvAcc	;
 
    @ApiParam(value = "订单信息", required = true)
    private  List<OrderModel> orderList;



    public String getProductId() {
        return productId;
    }

    public void setProductId(String productId) {
        this.productId = productId;
    }

    public String getBusiGroupCode() {
        return busiGroupCode;
    }

    public void setBusiGroupCode(String busiGroupCode) {
        this.busiGroupCode = busiGroupCode;
    }

    public String getCoreOrgCode() {
        return coreOrgCode;
    }

    public void setCoreOrgCode(String coreOrgCode) {
        this.coreOrgCode = coreOrgCode;
    }

    public String getSysCode() {
        return sysCode;
    }

    public void setSysCode(String sysCode) {
        this.sysCode = sysCode;
    }

    public String getLoanApplyNo() {
        return loanApplyNo;
    }

    public void setLoanApplyNo(String loanApplyNo) {
        this.loanApplyNo = loanApplyNo;
    }

    public String getOutApplyNo() {
        return outApplyNo;
    }

    public void setOutApplyNo(String outApplyNo) {
        this.outApplyNo = outApplyNo;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public String getAppvDate() {
        return appvDate;
    }

    public void setAppvDate(String appvDate) {
        this.appvDate = appvDate;
    }

    public String getContContent() {
        return contContent;
    }

    public void setContContent(String contContent) {
        this.contContent = contContent;
    }

    public String getRecvName() {
        return recvName;
    }

    public void setRecvName(String recvName) {
        this.recvName = recvName;
    }

    public String getRecvAcc() {
        return recvAcc;
    }

    public void setRecvAcc(String recvAcc) {
        this.recvAcc = recvAcc;
    }

    public List<OrderModel> getOrderList() {
        return orderList;
    }

    public void setOrderList(List<OrderModel> orderList) {
        this.orderList = orderList;
    }
}
