package com.itopview.wm.dt.api.AgriculturalelApi;

import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

/**
 * @author LiuHB
 * @version 1.0
 */
@ApiModel
public class AgriculRepaymentModel implements Serializable {
    @NotBlank
    @ApiParam(value = "还款流水号", required = true)
    private String repayNo;
    @NotBlank
    @ApiParam(value = "产品编码", required = true)
    private String productId;
    @NotBlank
    @ApiParam(value = "商圈编码", required = true)
    private String busiGroupCode;
    @NotBlank
    @ApiParam(value = "核心企业组织机构代码", required = true)
    private String coreOrgCode;
    @NotBlank
    @ApiParam(value = "平台编码", required = true)
    private String sysCode;
    @NotBlank
    @ApiParam(value = "贷款申请编号（融资流水号）", required = true)
    private String loanApplyNo;
    @NotBlank
    @ApiParam(value = "凭证编号", required = true)
    private String vchno;
    @NotBlank
    @ApiParam(value = "凭证状态", required = true)
    private String vchState;

    @ApiParam(value = "融资金额", required = true)
    private BigDecimal expectLoanAmt;

    @ApiParam(value = "融资利息", required = true)
    private BigDecimal interest;
    @NotBlank
    @ApiParam(value = "融资起息日期", required = true)
    private String startDate;
    @NotBlank
    @NotBlank
    @ApiParam(value = "企业融资申请编号", required = true)
    private String outApplyNo;
    @ApiParam(value = "已还款金额", required = true)
    private BigDecimal paidAmt;
    @NotBlank
    @ApiParam(value = "还款日期", required = true)
    private String repayDate;
    @NotBlank
    @ApiParam(value = "到期日期", required = true)
    private String dueDate;
    @ApiParam(value = "本次还款本金", required = true)
    private BigDecimal thisPayCapAmt;
    @ApiParam(value = "本次还款利息", required = true)
    private BigDecimal thisPayIntAmt;
    @ApiParam(value = "本次还款银行手续费", required = true)
    private BigDecimal thisPayFeeAmt;
    @ApiParam(value = "本次还款平台费", required = true)
    private BigDecimal thisPayPlatFeeAmt;
    @ApiParam(value = "已还款本金", required = true)
    private BigDecimal paidCapAmt;
    @ApiParam(value = "已还款利息", required = true)
    private BigDecimal paidIntAmt;
    @ApiParam(value = "已还款平台费", required = true)
    private BigDecimal paidPlatFeeAmt;
    @ApiParam(value = "已还银行手续费", required = true)
    private BigDecimal paidFeeAmt;
    @ApiParam(value = "未还款本金", required = true)
    private BigDecimal remainCapAmt;
    @ApiParam(value = "未还款利息", required = true)
    private BigDecimal remainIntAmt;
    @ApiParam(value = "未还款平台费", required = true)
    private BigDecimal remainPlatFeeAmt;
    @ApiParam(value = "未还款银行手续费", required = true)
    private BigDecimal remainFeeAmt;
    @NotBlank
    @ApiParam(value = "还款结果", required = true)
    private String repayResult;
    @ApiParam(value = "订单列表", required = true)
    private List<OrderModel> orderList;

    public List<OrderModel> getOrderList() {
        return orderList;
    }

    public void setOrderList(List<OrderModel> orderList) {
        this.orderList = orderList;
    }

    public String getRepayNo() {
        return repayNo;
    }

    public void setRepayNo(String repayNo) {
        this.repayNo = repayNo;
    }

    public String getProductId() {
        return productId;
    }

    public void setProductId(String productId) {
        this.productId = productId;
    }

    public String getBusiGroupCode() {
        return busiGroupCode;
    }

    public void setBusiGroupCode(String busiGroupCode) {
        this.busiGroupCode = busiGroupCode;
    }

    public String getCoreOrgCode() {
        return coreOrgCode;
    }

    public void setCoreOrgCode(String coreOrgCode) {
        this.coreOrgCode = coreOrgCode;
    }

    public String getSysCode() {
        return sysCode;
    }

    public void setSysCode(String sysCode) {
        this.sysCode = sysCode;
    }

    public String getLoanApplyNo() {
        return loanApplyNo;
    }

    public void setLoanApplyNo(String loanApplyNo) {
        this.loanApplyNo = loanApplyNo;
    }

    public String getVchno() {
        return vchno;
    }

    public void setVchno(String vchno) {
        this.vchno = vchno;
    }

    public String getVchState() {
        return vchState;
    }

    public void setVchState(String vchState) {
        this.vchState = vchState;
    }

    public BigDecimal getExpectLoanAmt() {
        return expectLoanAmt;
    }

    public void setExpectLoanAmt(BigDecimal expectLoanAmt) {
        this.expectLoanAmt = expectLoanAmt;
    }

    public BigDecimal getInterest() {
        return interest;
    }

    public void setInterest(BigDecimal interest) {
        this.interest = interest;
    }

    public String getStartDate() {
        return startDate;
    }

    public void setStartDate(String startDate) {
        this.startDate = startDate;
    }

    public String getOutApplyNo() {
        return outApplyNo;
    }

    public void setOutApplyNo(String outApplyNo) {
        this.outApplyNo = outApplyNo;
    }

    public BigDecimal getPaidAmt() {
        return paidAmt;
    }

    public void setPaidAmt(BigDecimal paidAmt) {
        this.paidAmt = paidAmt;
    }

    public String getRepayDate() {
        return repayDate;
    }

    public void setRepayDate(String repayDate) {
        this.repayDate = repayDate;
    }

    public String getDueDate() {
        return dueDate;
    }

    public void setDueDate(String dueDate) {
        this.dueDate = dueDate;
    }

    public BigDecimal getThisPayCapAmt() {
        return thisPayCapAmt;
    }

    public void setThisPayCapAmt(BigDecimal thisPayCapAmt) {
        this.thisPayCapAmt = thisPayCapAmt;
    }

    public BigDecimal getThisPayIntAmt() {
        return thisPayIntAmt;
    }

    public void setThisPayIntAmt(BigDecimal thisPayIntAmt) {
        this.thisPayIntAmt = thisPayIntAmt;
    }

    public BigDecimal getThisPayFeeAmt() {
        return thisPayFeeAmt;
    }

    public void setThisPayFeeAmt(BigDecimal thisPayFeeAmt) {
        this.thisPayFeeAmt = thisPayFeeAmt;
    }

    public BigDecimal getThisPayPlatFeeAmt() {
        return thisPayPlatFeeAmt;
    }

    public void setThisPayPlatFeeAmt(BigDecimal thisPayPlatFeeAmt) {
        this.thisPayPlatFeeAmt = thisPayPlatFeeAmt;
    }

    public BigDecimal getPaidCapAmt() {
        return paidCapAmt;
    }

    public void setPaidCapAmt(BigDecimal paidCapAmt) {
        this.paidCapAmt = paidCapAmt;
    }

    public BigDecimal getPaidIntAmt() {
        return paidIntAmt;
    }

    public void setPaidIntAmt(BigDecimal paidIntAmt) {
        this.paidIntAmt = paidIntAmt;
    }

    public BigDecimal getPaidPlatFeeAmt() {
        return paidPlatFeeAmt;
    }

    public void setPaidPlatFeeAmt(BigDecimal paidPlatFeeAmt) {
        this.paidPlatFeeAmt = paidPlatFeeAmt;
    }

    public BigDecimal getPaidFeeAmt() {
        return paidFeeAmt;
    }

    public void setPaidFeeAmt(BigDecimal paidFeeAmt) {
        this.paidFeeAmt = paidFeeAmt;
    }

    public BigDecimal getRemainCapAmt() {
        return remainCapAmt;
    }

    public void setRemainCapAmt(BigDecimal remainCapAmt) {
        this.remainCapAmt = remainCapAmt;
    }

    public BigDecimal getRemainIntAmt() {
        return remainIntAmt;
    }

    public void setRemainIntAmt(BigDecimal remainIntAmt) {
        this.remainIntAmt = remainIntAmt;
    }

    public BigDecimal getRemainPlatFeeAmt() {
        return remainPlatFeeAmt;
    }

    public void setRemainPlatFeeAmt(BigDecimal remainPlatFeeAmt) {
        this.remainPlatFeeAmt = remainPlatFeeAmt;
    }

    public BigDecimal getRemainFeeAmt() {
        return remainFeeAmt;
    }

    public void setRemainFeeAmt(BigDecimal remainFeeAmt) {
        this.remainFeeAmt = remainFeeAmt;
    }

    public String getRepayResult() {
        return repayResult;
    }

    public void setRepayResult(String repayResult) {
        this.repayResult = repayResult;
    }


}
