package com.itopview.wm.dt.api.AgriculturalelApi;

import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.util.List;

/**
 * 历史订单信息获取
 * @author LiuHB
 * @version 1.0
 */
@ApiModel
public class AgriculdetailsModel implements Serializable {

    @NotBlank
    @ApiParam(value = "产品编码", required = true)
    private String productId;

    @ApiParam(value = "商圈编号", required = true)
    private String busiGroupCode;

    @ApiParam(value = "核心企业组织机构代码", required = true)
    private String coreOrgCode;

    @ApiParam(value = "平台编码", required = true)
    private String sysCode;
  
    @ApiParam(value = "融资申请人组织机构代码、社信码", required = true)
    private String orgCode;

    @ApiParam(value = "经销商编码", required = true)
    private String srcId;
 
    @ApiParam(value = "每页数量", required = true)
    private String pageSize;

    @ApiParam(value = "页码", required = true)
    private String pageNo;

    @ApiParam(value = "数据开始时间", required = true)
    private String startDate;

    @ApiParam(value = "数据结束时间", required = true)
    private String endDate;

    @ApiParam(value = "个性化信息",required = false)
    private List<EntSpecialInfoModel> entSpecialInfoList;

    public List<EntSpecialInfoModel> getEntSpecialInfoList() {
        return entSpecialInfoList;
    }

    public void setEntSpecialInfoList(List<EntSpecialInfoModel> entSpecialInfoList) {
        this.entSpecialInfoList = entSpecialInfoList;
    }

    public String getProductId() {
        return productId;
    }

    public void setProductId(String productId) {
        this.productId = productId;
    }

    public String getBusiGroupCode() {
        return busiGroupCode;
    }

    public void setBusiGroupCode(String busiGroupCode) {
        this.busiGroupCode = busiGroupCode;
    }

    public String getCoreOrgCode() {
        return coreOrgCode;
    }

    public void setCoreOrgCode(String coreOrgCode) {
        this.coreOrgCode = coreOrgCode;
    }

    public String getSysCode() {
        return sysCode;
    }

    public void setSysCode(String sysCode) {
        this.sysCode = sysCode;
    }

    public String getOrgCode() {
        return orgCode;
    }

    public void setOrgCode(String orgCode) {
        this.orgCode = orgCode;
    }

    public String getSrcId() {
        return srcId;
    }

    public void setSrcId(String srcId) {
        this.srcId = srcId;
    }

    public String getPageSize() {
        return pageSize;
    }

    public void setPageSize(String pageSize) {
        this.pageSize = pageSize;
    }

    public String getPageNo() {
        return pageNo;
    }

    public void setPageNo(String pageNo) {
        this.pageNo = pageNo;
    }

    public String getStartDate() {
        return startDate;
    }

    public void setStartDate(String startDate) {
        this.startDate = startDate;
    }

    public String getEndDate() {
        return endDate;
    }

    public void setEndDate(String endDate) {
        this.endDate = endDate;
    }


}
