package com.itopview.wm.dt.api.AgriculturalelApi;
import com.alibaba.nacos.shaded.com.google.gson.Gson;
import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.openapi.common.custom.annotation.*;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import net.sf.json.JSONObject;
import org.jetbrains.annotations.NotNull;
import javax.validation.Valid;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author LiuHB
 * @version 1.0
 */

@ApiController(value = "Agriculturale", desc = "农行e贷")
@ApiMapping("/v2/tpv/tpv_dt/Agriculturale")

@ApiErrorCodes({
        @ApiErrorCode(code = "99", desc = "准入请求失败"),
        @ApiErrorCode(code = "11", desc = "冻结")

})
public class AgriculturaleloanController implements Serializable {
    @ApiPostMapping(value = "/AgriculturaleloanPage", desc = "历史订单信息分页获取")
    public CustomApiResult<Map> AgriculturaleloanPage(@NotNull @Valid @ApiRequestBody(value = "输入") AgricultModel data) {

        String pageSize = data.getPageSize();
        BigDecimal bigDecimal = new BigDecimal(pageSize);
        QFilter filters = new QFilter("status", QCP.equals, "C");
        filters.and("enable", QCP.equals, "1");
        String selectproperties = "societycreditcode," + "createorg.number," + "number";
        DynamicObject[] dynamicObject =
                BusinessDataServiceHelper.load("bd_customer", selectproperties, new QFilter[]{filters});
        BigDecimal count = BigDecimal.ZERO;
        for (DynamicObject object : dynamicObject) {
            count = count.add(new BigDecimal(1));
            String societycreditcode = object.getString("societycreditcode");
            String createorg = object.getString("createorg.number");
            String number = object.getString("number");
            data.setCoreOrgCode(createorg);
            data.setSrcId(number);
            data.setOrgCode(societycreditcode);
        }
        data.setSysCode("ZHKC");
        data.setProductId("A020101");
        data.setBusiGroupCode("00S3320009");
        Gson gson = new Gson();
        JSONObject agricultModel = JSONObject.fromObject(data);
        BigDecimal base = count.divide(bigDecimal, BigDecimal.ROUND_UP);
        String pageNum = base.toString();
        agricultModel.put("pageNum", pageNum);
        return CustomApiResult.success(agricultModel);
    }

    @ApiPostMapping(value = "/Agriculdetails", desc = "历史订单信息获取")
    public CustomApiResult<Map> Agriculdetails(@NotNull @Valid @ApiRequestBody(value = "输入") AgriculdetailsModel data) {

        data.setSysCode("ZHKC");
        data.setProductId("A020101");
        data.setBusiGroupCode("00S3320009");
        QFilter qFilter = new QFilter("status", QCP.equals, "C");
        qFilter.and("enable", QCP.equals, "1");
        String select = "societycreditcode," + "createorg.number," + "number";
        DynamicObject[] load =
                BusinessDataServiceHelper.load("bd_customer", select, new QFilter[]{qFilter});
        for (DynamicObject object : load) {
            String societycreditcode = object.getString("societycreditcode");
            String createorg = object.getString("createorg.number");
            String number = object.getString("number");
            data.setCoreOrgCode(createorg);
            data.setSrcId(number);
            data.setOrgCode(societycreditcode);
        }
        JSONObject agriculdetails = JSONObject.fromObject(data);//讲data转换为map格式
        QFilter filters = new QFilter("billstatus", QCP.equals, "C");
        String entrySelectfields = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_salescontract", "tpv_materialentry");
        DynamicObject[] dynamicObject = BusinessDataServiceHelper.load("tpv_dt_salescontract", entrySelectfields, new QFilter[]{filters});
        for (DynamicObject object : dynamicObject) {
            DynamicObjectCollection materialentry = object.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject dynamic : materialentry) {
                String materialentryId = dynamic.getString("id");
                BigDecimal tpvTaxprice = dynamic.getBigDecimal("tpv_taxprice");
                String taxprice = tpvTaxprice.toString();
                String qty = dynamic.getString("tpv_qty");
                String goodsName = dynamic.getString("tpv_material.name");
                String unit = dynamic.getString("tpv_unit.name");
                agriculdetails.put("orderDetailNo", materialentryId);
                agriculdetails.put("goodsPrice", taxprice);
                agriculdetails.put("goodsCount", qty);
                agriculdetails.put("goodsName", goodsName);
                agriculdetails.put("goodsUnit", unit);
            }
            String billno = object.getString("billno");
            String remarkm = object.getString("tpv_remarkm");
            String amountbase = object.getString("tpv_amountbase");
            String contractstatus = object.getString("tpv_contractstatus");
            String bizdate = object.getString("tpv_bizdate");
            String customerId = object.getString("tpv_customer.id");
            String customerName = object.getString("tpv_customer.name");
            agriculdetails.put("orderNo", billno);
            agriculdetails.put("orderDsc", remarkm);
            agriculdetails.put("orderAmt", amountbase);
            agriculdetails.put("orderStatus", contractstatus);
            agriculdetails.put("createDate", bizdate);
            agriculdetails.put("supEntNo", customerId);
            agriculdetails.put("supEntName", customerName);
        }
        List<EntSpecialInfoModel> entSpecialInfoList = data.getEntSpecialInfoList();
        for (EntSpecialInfoModel specialInfoModel : entSpecialInfoList) {
            agriculdetails.put("key", specialInfoModel.getKey());
            agriculdetails.put("value", specialInfoModel.getValue());
        }
        return CustomApiResult.success(agriculdetails);
    }

    @ApiPostMapping(value = "/AgriculAccess", desc = "客户准入结果通知")
    public CustomApiResult<Map> AgriculAccess(@NotNull @Valid @ApiRequestBody(value = "输入") AgriculAccessModel data) {
        DynamicObject dynamicObject = BusinessDataServiceHelper.newDynamicObject("tpv_dt_cusaccinform");
        dynamicObject.set("billstatus", "A");
        dynamicObject.set("tpv_productid", data.getProductId());
        dynamicObject.set("tpv_busigroupCode", data.getBusiGroupCode());
        dynamicObject.set("tpv_coreorgCode", data.getCoreOrgCode());
        dynamicObject.set("tpv_syscode", data.getSysCode());
        dynamicObject.set("tpv_clientcode", data.getClientCode());
        dynamicObject.set("tpv_srcid", data.getSrcId());
        dynamicObject.set("tpv_entname", data.getEntName());
        dynamicObject.set("tpv_orgcode", data.getOrgCode());
        dynamicObject.set("tpv_code", data.getCode());
        dynamicObject.set("tpv_msg", data.getMsg());
        dynamicObject.set("tpv_startdate", data.getStartDate());
        dynamicObject.set("tpv_enddate", data.getEndDate());
        dynamicObject.set("tpv_grade", data.getGrade());
        dynamicObject.set("tpv_recvname", data.getRecvName());
        dynamicObject.set("tpv_recvacc", data.getRecvAcc());
        dynamicObject.set("tpv_limitamt", data.getLimitAmt());
        dynamicObject.set("tpv_execrate", data.getExecRate());
        SaveServiceHelper.save(new DynamicObject[]{dynamicObject});
        HashMap<String, String> agriculAccess = new HashMap<>();
        agriculAccess.put("code", "00");
        agriculAccess.put("msg", "请求成功");
        return CustomApiResult.success(agriculAccess);
    }

    @ApiPostMapping(value = "/AgriculApproval", desc = "审批结果反馈")
    public CustomApiResult<Map> AgriculApproval(@NotNull @Valid @ApiRequestBody(value = "输入") AgriculApprovalModel data) {
        DynamicObject dynamicObject = BusinessDataServiceHelper.newDynamicObject("tpv_dt_appresultfeed");
        dynamicObject.set("billstatus", "A");
        dynamicObject.set("tpv_productId", data.getProductId());
        dynamicObject.set("tpv_busiGroupCode", data.getBusiGroupCode());
        dynamicObject.set("tpv_coreOrgCode", data.getCoreOrgCode());
        dynamicObject.set("tpv_sysCode", data.getSysCode());
        dynamicObject.set("tpv_loanApplyNo", data.getLoanApplyNo());
        dynamicObject.set("tpv_outApplyNo", data.getOutApplyNo());
        dynamicObject.set("tpv_code", data.getCode());
        dynamicObject.set("tpv_msg", data.getMsg());
        dynamicObject.set("tpv_appvDate", data.getAppvDate());
        dynamicObject.set("tpv_contContent", data.getContContent());
        dynamicObject.set("tpv_recvName", data.getRecvName());
        dynamicObject.set("tpv_recvAcc", data.getRecvAcc());
        List<OrderModel> orderList = data.getOrderList();
        for (OrderModel orderModel : orderList) {
            for (OrderModel model : orderList) {
                dynamicObject.set("tpv_orderno", model.getOrderNo());
            }
        }
        Object[] save = SaveServiceHelper.save(new DynamicObject[]{dynamicObject});
        HashMap<String, String> agriculApproval = new HashMap<>();
        agriculApproval.put("code", "00");
        agriculApproval.put("msg", "请求成功");
        return CustomApiResult.success(agriculApproval);
    }

    @ApiPostMapping(value = "/AgriculLoan", desc = "放款结果反馈")
    public CustomApiResult<Map> AgriculLoan(@NotNull @Valid @ApiRequestBody(value = "输入") AgriculLoanModel data) {
        String code = data.getCode();
        DynamicObject dynamicObject = BusinessDataServiceHelper.newDynamicObject("tpv_dt_feedoaresults");
        dynamicObject.set("billstatus", "A");
        dynamicObject.set("tpv_productId", data.getProductId());
        dynamicObject.set("tpv_busiGroupCode", data.getBusiGroupCode());
        dynamicObject.set("tpv_sysCode", data.getSysCode());
        dynamicObject.set("tpv_coreOrgCOde", data.getCoreOrgCOde());
        dynamicObject.set("tpv_loanApplyNo", data.getLoanApplyNo());
        dynamicObject.set("tpv_outApplyNo", data.getOutApplyNo());
        dynamicObject.set("tpv_code", data.getCode());
        dynamicObject.set("tpv_msg", data.getMsg());
        if (code.equals("21")) {
            dynamicObject.set("tpv_amount", data.getAmount());
            dynamicObject.set("tpv_startDate", data.getStartDate());
            dynamicObject.set("tpv_loanEndDate", data.getLoanEndDate());
            dynamicObject.set("tpv_recvAcc", data.getRecvAcc());
            dynamicObject.set("tpv_execRate", data.getExecRate());
            dynamicObject.set("tpv_interest", data.getInterest());
            dynamicObject.set("tpv_entName", data.getEntName());
        }
        List<OrderModel> orderList = data.getOrderList();
        for (OrderModel orderModel : orderList) {
            dynamicObject.set("tpv_orderno", orderModel.getOrderNo());
        }

        Object[] save = SaveServiceHelper.save(new DynamicObject[]{dynamicObject});
        HashMap<String, String> agriculLoan = new HashMap<>();
        agriculLoan.put("code", "00");
        agriculLoan.put("msg", "请求成功");
        return CustomApiResult.success(agriculLoan);
    }

    @ApiPostMapping(value = "/AgriculRepayment", desc = "还款结果反馈")
    public CustomApiResult<Map> AgriculRepayment(@NotNull @Valid @ApiRequestBody(value = "输入") AgriculRepaymentModel data) {
        DynamicObject dynamicObject = BusinessDataServiceHelper.newDynamicObject("tpv_dt_reparesult");

        dynamicObject.set("billstatus", "A");
        dynamicObject.set("tpv_repayNo", data.getRepayNo());
        dynamicObject.set("tpv_productId", data.getProductId());
        dynamicObject.set("tpv_busiGroupCode", data.getBusiGroupCode());
        dynamicObject.set("tpv_coreOrgCode", data.getCoreOrgCode());
        dynamicObject.set("tpv_sysCode", data.getSysCode());
        dynamicObject.set("tpv_loanApplyNo", data.getLoanApplyNo());
        dynamicObject.set("tpv_vchno", data.getVchno());
        dynamicObject.set("tpv_vchState", data.getVchState());
        dynamicObject.set("tpv_expectLoanAmt", data.getExpectLoanAmt());
        dynamicObject.set("tpv_interest", data.getInterest());
        dynamicObject.set("tpv_startDate", data.getStartDate());
        dynamicObject.set("tpv_outApplyNo", data.getOutApplyNo());
        dynamicObject.set("tpv_paidAmt", data.getPaidAmt());
        dynamicObject.set("tpv_repayDate", data.getRepayDate());
        dynamicObject.set("tpv_dueDate", data.getDueDate());
        dynamicObject.set("tpv_thisPayCapAmt", data.getThisPayCapAmt());
        dynamicObject.set("tpv_thisPayIntAmt", data.getThisPayIntAmt());
        dynamicObject.set("tpv_thisPayFeeAmt", data.getThisPayFeeAmt());
        dynamicObject.set("tpv_thisPayPlatFeeAmt", data.getThisPayPlatFeeAmt());
        dynamicObject.set("tpv_paidCapAmt", data.getPaidCapAmt());
        dynamicObject.set("tpv_paidIntAmt", data.getPaidIntAmt());
        dynamicObject.set("tpv_paidPlatFeeAmt", data.getPaidPlatFeeAmt());
        dynamicObject.set("tpv_paidFeeAmt", data.getPaidFeeAmt());
        dynamicObject.set("tpv_remainCapAmt", data.getRemainCapAmt());
        dynamicObject.set("tpv_remainIntAmt", data.getRemainIntAmt());
        dynamicObject.set("tpv_remainPlatFeeAmt", data.getRemainPlatFeeAmt());
        dynamicObject.set("tpv_remainFeeAmt", data.getRemainFeeAmt());
        dynamicObject.set("tpv_repayResult", data.getRepayResult());
        List<OrderModel> orderList = data.getOrderList();
        for (OrderModel orderModel : orderList) {
            for (OrderModel model : orderList) {
                dynamicObject.set("tpv_orderno", model.getOrderNo());
            }
        }
        String repayResult = data.getRepayResult();
        Object[] save = SaveServiceHelper.save(new DynamicObject[]{dynamicObject});
        HashMap<String, String> agriculRepayment = new HashMap<>();
        if (repayResult.equals("1")) {
            agriculRepayment.put("code", "00");
            agriculRepayment.put("msg", "请求成功");
        } else {
            agriculRepayment.put("loanApplyNo", data.getLoanApplyNo());
            agriculRepayment.put("productId", data.getProductId());
            agriculRepayment.put("busiGroupCode", data.getBusiGroupCode());
            agriculRepayment.put("sysCode", data.getSysCode());
            agriculRepayment.put("coreOrgCode", data.getCoreOrgCode());
            agriculRepayment.put("repayNo", data.getRepayNo());
            agriculRepayment.put("repayResult", data.getRepayResult());
            agriculRepayment.put("code", "00");
            agriculRepayment.put("msg", "还款失败");
            for (OrderModel orderModel : orderList) {
                for (OrderModel model : orderList) {
                    agriculRepayment.put("tpv_orderno", model.getOrderNo());
                }
            }
        }
        return CustomApiResult.success(agriculRepayment);
    }
}
