package com.itopview.wm.dt.formplugin.dynamic;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;
import java.math.BigDecimal;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * @author GX
 * 预付款占用-动态表单插件
 */
public class AdvanbillFormPlugin extends AbstractBillPlugIn {

    /**
     * 获取到父页面（装箱单）传来的数据放入动态表单
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = new HashMap<>();
        maps = showParameter.getCustomParams();
        BigDecimal tpv_prepoccupancy = (BigDecimal) maps.get("tpv_prepoccupancy");//预付款占用调整
        this.getModel().setValue("tpv_prepoccupancy", tpv_prepoccupancy);
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok","btncancel"});
    }

    /**
     * 点击事件，点击确认回填数据
     */
    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok" :
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                BigDecimal paypercent=dataEntity.getBigDecimal("tpv_prepoccupancy");//预付款占用调整
                Map<String, BigDecimal> paypercentmap=new HashMap<String, BigDecimal>();
                paypercentmap.put("tpv_prepoccupancy", paypercent);
                this.getView().returnDataToParent(paypercentmap);
                this.getView().close();
                break;
            case "btncancel":
                this.getView().close();
                break;
        }
    }
}
