package com.itopview.wm.dt.formplugin.dynamic;

import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import org.apache.commons.lang3.StringUtils;

import java.util.*;


/**
 * @ClassName 回填到达时间
 * @Description TODO
 * @Author yhj
 * @Date 2023/8/26 17:49
 * @Version 1.0
 */
public class ArrivalTimeFormPlugin extends AbstractBillPlugIn {
    private static final String STATEMENWORKENTITY = "tpv_circulationgoodentity";  //费用结算工作台分录

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        // 侦听文本字段按钮点击事件
        this.addClickListeners("tpv_updatetime");
    }
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String key = e.getProperty().getName();
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();
        switch (key) {
            case "tpv_finishdate"://本次流转数量
                QFilter[] qFilter = new QFilter[]{new QFilter("billstatus", QCP.equals, "C"),
                        new QFilter("billno", QCP.equals, this.getModel().getValue("tpv_transfernumber"))};
                String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_freigroambill", "tpv_materialentry");
                IFormView view = this.getView();
                DynamicObject[] queryHW = BusinessDataServiceHelper.load("tpv_dt_freigroambill", selectfieldsFast, qFilter);
                EntryGrid entry = view.getControl(STATEMENWORKENTITY);
                int selectRows[] = entry.getSelectRows();
                DynamicObjectCollection entity = this.getModel().getEntryEntity(STATEMENWORKENTITY);//单据体
                if (null != selectRows && selectRows.length > 0) {
                    for (int selectRow : selectRows) {
                        DynamicObject dynamicObject = entity.get(selectRow);
                        for (DynamicObject obj : queryHW) {
                            obj.set("tpv_finishdate", dynamicObject.getDate("tpv_finishdate"));
                            SaveServiceHelper.update(obj);

                        }
                    }
                }
                break;
            default:
                break;
        }
    }
    @Override
    public void click(EventObject evt) {
        super.click(evt);
        IFormView view = this.getView();
        Control source = (Control) evt.getSource();
        EntryGrid entry = view.getControl(STATEMENWORKENTITY);
        int selectRows[] = entry.getSelectRows();
        DynamicObjectCollection entity = this.getModel().getEntryEntity(STATEMENWORKENTITY);//单据体
        if (selectRows.length == 1) {
            if (null != selectRows && selectRows.length > 0) {
                for (int selectRow : selectRows) {
                    DynamicObject dynamicObject = entity.get(selectRow);
                    DynamicObject values = dynamicObject.getDynamicObject("tpv_sourcebillkey");
                    if (values != null) {
                        String numbers = values.getString("number");
                        // 判断是否为回填按钮
                        if (StringUtils.equals("tpv_updatetime", source.getKey())) {
                            if (numbers.equals("tpv_dt_freigroambill")) {
                                // 创建弹出动态表单页面对象
                                FormShowParameter showParameter = new FormShowParameter();
                                // 设置弹出页面的标识
                                showParameter.setFormId("tpv_dt_arrivaltime");
                                Map<String, Object> map = this.showInfoForm();
                                // 存入获取到的动态表单数据
                                showParameter.setCustomParams(map);
                                // 状态
                                showParameter.setStatus(OperationStatus.ADDNEW);
                                // 设置页面关闭回调方法
                                // CloseCallBack参数：回调插件，回调标识
                                showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_updatetime"));
                                // 设置弹出页面打开方式
                                showParameter.getOpenStyle().setShowType(ShowType.Modal);
                                // 打开动态表单
                                this.getView().showForm(showParameter);
                            } else {
                                view.showTipNotification("请选择源单据为货物流转单");
                            }
                        }
                    }
                }
            } else {
                view.showTipNotification("未选择数据。");
            }
        }else {
            view.showTipNotification("请选择一行数据");
        }

    }


    /**
     * 动表单获取原单据字段
     */
    private Map<String, Object> showInfoForm() {
        // 获取单据体
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        int rowIndex = this.getModel().getEntryCurrentRowIndex("tpv_materialentry");
        // 创建集合保存需要获取的字段值
        Map<String, Object> map = new HashMap<>();
        // 获取到达时间
        Date applyOrg = (Date) this.getModel().getValue("tpv_finishdate", rowIndex + 1);
//        Date applyOrg = dataEntity.getDate("tpv_finishdate");
        // 判断获得的各项数据
        if (applyOrg != null) {
            map.put("tpv_finishdate", applyOrg);
        }
        return map;
    }

    /**
     * 动态表单回填单据字段
     */
    private void setInwardInfo(Map<String, Object> values) {
        IDataModel model = this.getModel();
//        IFormView view = this.getView();
//        EntryGrid entry = view.getControl(STATEMENWORKENTITY);
//        int selectRows[] = entry.getSelectRows();
//        DynamicObjectCollection entity = this.getModel().getEntryEntity(STATEMENWORKENTITY);//单据体
//        if (null != selectRows && selectRows.length > 0) {
//            for (int selectRow : selectRows) {
//            }
//        }
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        // 回填动态表单的预计走访时间
        model.setValue("tpv_finishdate", values.get("tpvSignatory"));
    }

    /**
     * 动态表单关闭回调事件
     */

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        // super.closedCallBack(closedCallBackEvent);
        Object returnData = closedCallBackEvent.getReturnData();
        // 判断标识是否匹配，并验证返回值不为空，不验证返回值可能会报空指针
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_updatetime")
                && null != closedCallBackEvent.getReturnData()) {
            // 这里返回对象为Object，可强转成相应的其他类型，
            // 单条数据可用String类型传输，返回多条数据可放入map中，也可使用json等方式传输
            HashMap<String, Object> values = (HashMap<String, Object>) returnData;
            this.setInwardInfo(values);
        }
    }


}
