package com.itopview.wm.dt.formplugin.dynamic;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.plugin.AbstractFormPlugin;
import org.apache.commons.lang3.StringUtils;

import java.util.Date;
import java.util.EventObject;
import java.util.HashMap;

/**
 * @ClassName BackfillTimeEdit
 * @Description TODO
 * @Author yhj
 * @Date 2023/11/10 10:46
 * @Version 1.0
 */
public class BackfillTimeEdit extends AbstractFormPlugin {
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IFormView parentView = this.getView().getParentView();
        IDataModel parentModel = parentView.getModel();
        IDataModel model = this.getModel();
        DataEntityPropertyCollection properties = model.getDataEntityType().getProperties();
        for (IDataEntityProperty property : properties) {
            String propName = property.getName();
            if (parentModel.getProperty(propName) != null) {
                Object propValue = parentModel.getValue(propName);
                if (propValue instanceof DynamicObject) {
                    DynamicObject obj = (DynamicObject) propValue;
                    model.setValue(propName, obj.getPkValue());
                } else {
                    model.setValue(propName, propValue);
                }
            }
        }
    }

    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addClickListeners("btncancel", "btnok");  //监听取消和确定按钮
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        IDataModel model = this.getModel();
        Control source = (Control) evt.getSource();
        if (StringUtils.equals(source.getKey(), "btnok")) {
            HashMap<String, Object> hashMap = new HashMap<>();
            //如果被点击控件为确认，则获取页面相关控件值，组装数据传入returnData返回给父页面，最后关闭页面
            Date tpvSignatory = (Date) model.getValue("tpv_finishdate");
            //到达时间
            if (tpvSignatory != null) {
                hashMap.put("tpvSignatory", tpvSignatory);
            }
            this.getView().returnDataToParent(hashMap);//将数据传给父页面
            this.getView().close();
        } else if (StringUtils.equals(source.getKey(), "btncancel")) {
            //被点击控件为取消则设置返回值为空并关闭页面（在页面关闭回调方法中必须验证返回值不为空，否则会报空指针）
            this.getView().returnDataToParent(null);
            this.getView().close();
        }
    }
}
