package com.itopview.wm.dt.formplugin.dynamic;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.druid.util.StringUtils;
import com.itopview.wm.dt.report.DispatchRptQuery;
import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @ClassName DispatchEdit
 * @Description TODO
 * @Author yhj
 * @Date 2023/10/9 18:08
 * @Version 1.0
 */
public class DispatchEdit extends AbstractFormPlugin implements RowClickEventListener {
    private final static String KEY_ENTRYENTITY = "tpv_dispatchentity";//发送分录
    private final static String STATEMENWORKENTITY = "tpv_circulationgoodentit";//附件分录

    @Override
    public void registerListener(EventObject e) {

        super.registerListener(e);
        EntryGrid entryGrid = this.getView().getControl(KEY_ENTRYENTITY);
        entryGrid.addRowClickListener(this);
        this.addClickListeners("tpv_deleteattachment");//删除附件
        this.addClickListeners("tpv_sendfax");//发送传真
        this.addClickListeners("tpv_sendmail");//发送传真
        this.addClickListeners("tpv_query");//查询
    }

    @Override
    public void click(EventObject evt) {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        super.click(evt);
        List<Integer> list = new ArrayList<>();
        Control source = (Control) evt.getSource();
        DynamicObjectCollection entity = this.getModel().getEntryEntity(STATEMENWORKENTITY);//获取分录数据
        if (StringUtils.equals("tpv_deleteattachment", source.getKey())) { //删除附件
            extracted(view, model, list, entity);
        }
        if (StringUtils.equals("tpv_query", source.getKey())) { //删除附件
            initData();
        }
//        if (StringUtils.equals("tpv_sendfax", source.getKey())) { //发送传真
//
//        }
//        if (StringUtils.equals("tpv_sendmail", source.getKey())) { //发送邮件
//
//        }
    }

    private static void extracted(IFormView view, IDataModel model, List<Integer> list, DynamicObjectCollection entity) {
        EntryGrid entry = view.getControl(STATEMENWORKENTITY);//获取分录控件
        int selectRows[] = entry.getSelectRows();//获取工作台的指定行
        if (null != selectRows && selectRows.length > 0) {
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = entity.get(selectRow);  //获取选中行的单据体数据
                if (dynamicObject.getBoolean("tpv_lock") == false) {
                    list.add(selectRow);
                } else {
                    view.showTipNotification("请删除锁定为否的数据");
                }
            }
            int[] res = new int[list.size()];
            int i = 0;
            for (Integer num : list) {
                res[i++] = num;
            }
            model.deleteEntryRows(STATEMENWORKENTITY, res);
//            for (int select : selectRows) {
//                DynamicObject dynamicObject = entity.get(select);  //获取选中行的单据体数据
//                SaveServiceHelper.update(dynamicObject);
//            }
        } else {
            view.showTipNotification("未选择数据。");
        }
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        EntryGrid entryGrid = (EntryGrid) evt.getSource();
        int entryCurrentRowIndex = this.getModel().getEntryCurrentRowIndex(KEY_ENTRYENTITY);
        DynamicObjectCollection entity = this.getModel().getEntryEntity(STATEMENWORKENTITY);//获取分录数据
        if (StringUtils.equals(KEY_ENTRYENTITY, entryGrid.getKey())) {
            //int row = evt.getRow();
            this.getModel().deleteEntryData("tpv_circulationgoodentit");
            String attachmentcon = (String) this.getModel().getValue("tpv_attachmentcon", entryCurrentRowIndex);
            JSONObject object = JSONObject.parseObject(attachmentcon);
            if (object != null) {
                Set<String> strings = object.keySet();
                if (strings.size() > 0 && null != strings) {
                    for (String key : strings) {
                        if (object != null) {
                            JSONObject tpv_sourcebillkey = object.getJSONObject(key);
                            if (tpv_sourcebillkey != null) {
                                int newEntryRow = this.getModel().createNewEntryRow("tpv_circulationgoodentit");//附件分录
                                this.getModel().setValue("tpv_attachmentname", tpv_sourcebillkey.get("name"), newEntryRow);
                            }
                        }
                    }
                }
            }
            String sendingpath = (String) model.getValue("tpv_sendingpath", entryCurrentRowIndex);//发送途径
            String sendstate = (String) model.getValue("tpv_sendstate", entryCurrentRowIndex);//发送状态
            //校验发送传真
            if ("B".equals(sendingpath) || "D".equals(sendingpath) && ("B".equals(sendstate) || "E".equals(sendstate))) {
                view.setVisible(true, "tpv_sendfax");
            } else {
                view.setVisible(false, "tpv_sendfax");
            }
            //校验发送邮件
            if ("C".equals(sendingpath) || "D".equals(sendingpath) && ("B".equals(sendstate) || "E".equals(sendstate))) {
                view.setVisible(true, "tpv_sendmail");
            } else {
                view.setVisible(false, "tpv_sendmail");
            }
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        initData();
        this.getModel().deleteEntryData("tpv_circulationgoodentit");
        int entryCurrentRowIndex = this.getModel().getEntryCurrentRowIndex(KEY_ENTRYENTITY);
        String attachmentcon = (String) this.getModel().getValue("tpv_attachmentcon", entryCurrentRowIndex);
        JSONObject object = JSONObject.parseObject(attachmentcon);
        int newEntryRow = this.getModel().createNewEntryRow("tpv_circulationgoodentit");//附件分录
        this.getModel().setValue("tpv_attachmentname", object.get("name"), newEntryRow);
        //System.out.println(document);
    }

    private void initData() {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        String whereFilter = "1=1";
        String faxstatu = dataEntity.getString("tpv_faxstatu");//传真状态
        if (YEM.isNotEmpty(faxstatu)) {
            whereFilter = String.format("%s and tpv_faxstatus = '%s'", whereFilter, faxstatu);
        }
        String statusapi = dataEntity.getString("tpv_statusapi");//API状态
        if (YEM.isNotEmpty(statusapi)) {
            whereFilter = String.format("%s and tpv_statusapi = '%s'", whereFilter, statusapi);
        }
        String contractnosf = dataEntity.getString("tpv_contractnosf");//单据号
        if (YEM.isNotEmpty(contractnosf)) {
            whereFilter = String.format("%s and tpv_document = '%s'", whereFilter, contractnosf);
        }
        DynamicObject client = dataEntity.getDynamicObject("tpv_client");//客户
        if (YEM.isNotEmpty(client)) {
            whereFilter = String.format("%s and tpv_client = %s", whereFilter, client.getPkValue());
        }
        DynamicObject branch = dataEntity.getDynamicObject("tpv_branch");//部门
        if (YEM.isNotEmpty(branch)) {
            whereFilter = String.format("%s and tpv_department = %s", whereFilter, branch.getPkValue());
        }
        String sendingpaths = dataEntity.getString("tpv_sendingpaths");//发送途径
        if (YEM.isNotEmpty(sendingpaths)) {
            whereFilter = String.format("%s and tpv_sendingpath = %s", whereFilter, sendingpaths);
        }
        String mailstates = dataEntity.getString("tpv_mailstates");//邮件状态
        if (YEM.isNotEmpty(mailstates)) {
            whereFilter = String.format("%s and tpv_mailstate = %s", whereFilter, mailstates);
        }
        DynamicObject warehouse = dataEntity.getDynamicObject("tpv_warehouse");//仓库
        if (YEM.isNotEmpty(warehouse)) {
            whereFilter = String.format("%s and tpv_entrepot = %s", whereFilter, warehouse.getPkValue());
        }
        DynamicObject prepared = dataEntity.getDynamicObject("tpv_prepared");//制单人
        if (YEM.isNotEmpty(prepared)) {
            whereFilter = String.format("%s and tpv_creator = %s", whereFilter, prepared.getPkValue());
        }
        DynamicObject billtype = dataEntity.getDynamicObject("tpv_billtype");//单据类型
        if (YEM.isNotEmpty(billtype)) {
            whereFilter = String.format("%s and tpv_billtypes = %s", whereFilter, billtype.getPkValue());
        }
        //业务日期从
        Date datefrom = dataEntity.getDate("tpv_datefrom");
        Date dayStartTime = getDayStartTime(datefrom);
        SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        if (YEM.isNotEmpty(datefrom)) {
            String format = str.format(dayStartTime);
            whereFilter = String.format("%s and tpv_biztime >= to_date('"+format+"','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        //业务日期到
        Date tpv_servicedue = dataEntity.getDate("tpv_servicedue");
        Date dayEndTime = getDayEndTime(tpv_servicedue);
        SimpleDateFormat strs = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        if (YEM.isNotEmpty(tpv_servicedue)) {
            String formats = strs.format(dayEndTime);
            whereFilter = String.format("%s and tpv_biztime <= to_date('"+formats+"','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        model.deleteEntryData("tpv_dispatchentity");
        DataSet query = DispatchRptQuery.query(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity("tpv_dispatchentity").getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow("tpv_dispatchentity");
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    /**
     * 获取日期的结束时间
     */
    public static Date getDayEndTime(Date date) {
        if (date == null) {
            return null;
        } else {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(date);
            calendar.set(calendar.get(1), calendar.get(2), calendar.get(5), 23, 59, 59);
            calendar.set(14, 999);
            return calendar.getTime();
        }
    }

    /**
     * 获取该日期的开始时间
     */
    public static Date getDayStartTime(Date date) {
        if (date == null) {
            return null;
        } else {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(date);
            calendar.set(calendar.get(1), calendar.get(2), calendar.get(5), 0, 0, 0);
            calendar.set(14, 0);
            return calendar.getTime();
        }
    }
}
