package com.itopview.wm.dt.formplugin.dynamic;

import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;

import java.math.BigDecimal;
import java.util.EventObject;
import java.util.Map;

/**
 * @author GX
 * 批量录入费用动态表单插件
 */
public class DulkentryFormPlugin extends AbstractBillPlugIn {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok", "btncancel"});
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        FormShowParameter formShowParameter = this.getView().getFormShowParameter();
        Map<String, Object> customParams = formShowParameter.getCustomParams();
        if (customParams.size() > 0) {
            if (customParams.containsKey("tpv_inventorytype")) {
                String object = (String) customParams.get("");
                if (YEM.isNotEmpty(object)) {
                    if ("B".equals(object)) {
                        this.getView().setEnable(true, "tpv_isbringinwarehouse");
                    } else {
                        this.getView().setEnable(false, "tpv_isbringinwarehouse");
                    }
                } else {
                    this.getView().setEnable(false, "tpv_isbringinwarehouse");
                }
            }
        }
    }

    /**
     * 点击事件，点击确认回填数据
     */
    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                DynamicObjectCollection dataEntitys = dataEntity.getDynamicObjectCollection("tpv_entryentity");
				StringBuilder builder = new StringBuilder();
				for (DynamicObject entity : dataEntitys) {
                    DynamicObject tpvExpenseitems = entity.getDynamicObject("tpv_expenseitems");//费用项目
					if (tpvExpenseitems==null){
						stringBuilder(builder,"费用项目");
					}
                    DynamicObject tpvSupplierf = entity.getDynamicObject("tpv_supplierf");//供应商
					if (tpvSupplierf==null){
						stringBuilder(builder,"供应商");
					}
                    DynamicObject tpvCostcurrencys = entity.getDynamicObject("tpv_costcurrencys");//费用币别
					if(tpvCostcurrencys==null){
						stringBuilder(builder,"费用币别");
					}
                    BigDecimal tpvUnitprices = entity.getBigDecimal("tpv_unitprices");//单价
					if (tpvUnitprices.compareTo(BigDecimal.ZERO)==0){
						stringBuilder(builder,"单价");
					}
                    BigDecimal tpvTaxrates = entity.getBigDecimal("tpv_taxrates");//税率%
//					if (tpvTaxrates.compareTo(BigDecimal.ZERO)==0){
//						stringBuilder(builder,"税率%");
//					}
					if (builder.length()!=0){
						this.getView().showTipNotification("请填写："+builder);
						return;
					}
                }
                this.getView().returnDataToParent(dataEntitys);
                this.getView().close();
                break;
            case "btncancel":
                this.getView().close();
                break;
        }
    }

    public void stringBuilder(StringBuilder stringBuilder, String basePrice) {
        if (stringBuilder.length() == 0) {
            stringBuilder.append(basePrice);
        } else {
            stringBuilder.append("，" + basePrice);
        }
    }
}
