package com.itopview.wm.dt.formplugin.dynamic;

import com.itopview.wm.dt.report.InventoryRptQuery;
import com.itopview.wm.dt.report.PickShipsRptQuery;
import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.earlywarn.kit.StringUtil;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.MessageTypes;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;

import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 拣配-表单插件
 *
 * @author longh
 * @description
 * @date 2023年8月16日
 */
public class PickShipsEdit extends AbstractFormPlugin implements RowClickEventListener {

    private final String TPV_DT_SALESSHIPPING = "tpv_dt_salesshipping";//销售发货1

    private final String MULTIBILL = "multibill";//其他出库单 || 分步调出单2

    private final String TPV_DT_NOCONFIGURATION = "tpv_dt_noconfiguration";//库存免拣配业务底表3

    private final String TPV_DT_INVENTORYCONFIGURA = "tpv_dt_inventoryconfigura";//库存拣配业务实提工作台5
    private final String IM_PURINBILL = "im_purinbill";//采购入库单6

    private final String TPV_DT_RELEVANCEDEALGS = "tpv_dt_relevancedealgs";//关联交易转货单7

    private final String TPV_DT_CONFIGURANEW = "tpv_dt_configuranew";//库存拣配业务实提工作台(新)
    private final String TPV_DT_PROCESS = "tpv_dt_process";//加工指令单
    private static final String entryKey_1 = "tpv_treeentryentity";
    private static final String entryKey_2 = "tpv_entryentity";
    private static final String entryKey_3 = "tpv_materialentrynew";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok", "tpv_query", "tpv_deleteentry"});
        this.addItemClickListeners(new String[]{"tpv_advcontoolbarap"});
        EntryGrid entryGridThree = this.getView().getControl(entryKey_3);
        entryGridThree.addRowClickListener(this);
        EntryGrid entryGridOne = this.getView().getControl(entryKey_1);
        entryGridOne.addRowClickListener(this);
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        RowClickEventListener.super.entryRowClick(evt);
        String source = ((Control) evt.getSource()).getKey();
        if ("tpv_materialentrynew".equals(source)) {
            EntryGrid entryGrid = this.getControl(entryKey_3);//商品明细分录
            int[] selectRows = entryGrid.getSelectRows();//获取选中的行号
            if (selectRows.length == 1) {
                String checkCache = this.getPageCache().get("checkCache");
                boolean flag = true;
                if (!"no".equals(checkCache)) {
                    if (Integer.valueOf(this.getPageCache().get("oldIndex")) == selectRows[0]) {
                        return;
                    }
                    flag = checkPickOk(Integer.valueOf(this.getPageCache().get("oldIndex")));

                } else {
                    this.getPageCache().put("checkCache", "yes");
                }
                if (!flag) {
                    entryGrid.selectRows(Integer.valueOf(this.getPageCache().get("oldIndex")), true);
                    return;
                }
                this.getPageCache().put("oldIndex", String.valueOf(selectRows[0]));
                int row = evt.getRow();
                DynamicObject rowData = this.getModel().getEntryRowEntity(entryKey_3, row);
                Long saleId = rowData.getLong("tpv_saleentryid");
                Long tpv_material = YEM.isNotEmpty(rowData.getDynamicObject("tpv_materialnew"))
                        ? rowData.getDynamicObject("tpv_materialnew").getLong("id") : 0L;
                String tpv_specation = rowData.getString("tpv_specationnew");
                String tpv_shader = rowData.getString("tpv_shadernew");
                Long tpv_origin = YEM.isNotEmpty(rowData.getDynamicObject("tpv_originnew"))
                        ? rowData.getDynamicObject("tpv_originnew").getLong("id") : 0L;
                String tpv_customtags = rowData.getString("tpv_customtagsnew");
                Long tpv_prodname = YEM.isNotEmpty(rowData.getDynamicObject("tpv_prodnamenew"))
                        ? rowData.getDynamicObject("tpv_prodnamenew").getLong("id") : 0L;
                this.getModel().setValue("tpv_specation_f", tpv_specation);
                this.getModel().setValue("tpv_shader_f", tpv_shader);
                this.getModel().setValue("tpv_origin_f", tpv_origin);
                this.getModel().setValue("tpv_material_f", tpv_material);
//            this.getModel().setValue("tpv_prodname_f", tpv_prodname);
                this.getModel().setValue("tpv_customtags_f", tpv_customtags);
                initData(true);
            } else if (selectRows.length == 0) {
                this.getPageCache().remove("oldIndex");
                this.getPageCache().put("checkCache", "no");
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                dataEntity.getDynamicObjectCollection(entryKey_1).clear();
                dataEntity.getDynamicObjectCollection(entryKey_2).clear();
                this.getModel().setValue("tpv_combination_f", null);
                this.getModel().setValue("tpv_warehouse_f", null);
                this.getModel().setValue("tpv_inventorytype_f", null);
                this.getModel().setValue("tpv_material_f", null);
                this.getModel().setValue("tpv_specation_f", null);
                this.getModel().setValue("tpv_shader_f", null);
                this.getModel().setValue("tpv_origin_f", null);
                this.getModel().setValue("tpv_customtags_f", null);
                this.getModel().setValue("tpv_prodname_f", null);
                this.getView().updateView(entryKey_1);
                this.getView().updateView(entryKey_2);
            }
        }
        if ("tpv_treeentryentity".equals(source)) {
            int index = this.getModel().getEntryCurrentRowIndex("tpv_treeentryentity");
            boolean tpvCheckbox = (boolean) this.getModel().getValue("tpv_focus", index);
            if (!tpvCheckbox) {
                this.getModel().setValue("tpv_focus", true, index);
            }
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        FormShowParameter parameter = view.getFormShowParameter();
        String picktype = parameter.getCustomParam("picktype");
        if (StringUtils.equals(picktype, TPV_DT_SALESSHIPPING)) {
            Long billid = toLong(parameter.getCustomParam("billid"));
            if (YEM.isNotEmpty(billid)) {
                DynamicObject entity = BusinessDataServiceHelper.loadSingle(billid, TPV_DT_SALESSHIPPING);
                DynamicObjectCollection entryEntity = this.getModel().getEntryEntity(entryKey_3);
                DynamicObjectType dyType1 = entryEntity.getDynamicObjectType();
                DataEntityPropertyCollection properties1 = dyType1.getProperties();
                DynamicObjectCollection tpvMaterialentry = entity.getDynamicObjectCollection("tpv_materialentry");
                DynamicObjectType dyType2 = tpvMaterialentry.getDynamicObjectType();
                DataEntityPropertyCollection properties2 = dyType2.getProperties();
                for (DynamicObject dynamicObject : tpvMaterialentry) {
                    DynamicObject addNew = entryEntity.addNew();
                    for (IDataEntityProperty property : properties2) {
                        String proKey = property.getName();
                        if (properties1.containsKey(proKey + "new")) {
                            addNew.set(proKey + "new", dynamicObject.get(proKey));
                        }
                    }
                    addNew.set("tpv_saleentryid", dynamicObject.getLong("id"));
                }
                this.getView().updateView(entryKey_3);
                this.getPageCache().put("checkCache", "no");
            }
            this.getView().setVisible( false, "tpv_flexpanelap");
            this.getView().setVisible( true, "tpv_advconap1");
        } else {
            this.getView().setVisible( true, "tpv_flexpanelap");
            this.getView().setVisible( false, "tpv_advconap1");
            initData(true);
        }
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
                pickOk();
                break;
            case "tpv_query":
                initData(false);
                break;
            default:
                break;
        }
    }

    /**
     * 拣配确认 通过校验并反写
     */
    private void pickOk() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        FormShowParameter parameter = view.getFormShowParameter();
        String picktype = parameter.getCustomParam("picktype");
        Long saleId = 0L;
        Long tpv_material = 0L;
        BigDecimal tpv_qty = BigDecimal.ZERO;
        BigDecimal tpv_packnum = BigDecimal.ZERO;
        EntryGrid entryGrid = this.getControl(entryKey_3);//商品明细分录
        int[] selectRows = entryGrid.getSelectRows();//获取选中的行号
        if (selectRows.length == 1 && TPV_DT_SALESSHIPPING.equals(picktype)) {
            DynamicObject rowData = this.getModel().getEntryRowEntity(entryKey_3, selectRows[0]);
            saleId = rowData.getLong("tpv_saleentryid");
            tpv_qty = BigDecimalUtils.toBigDecimal(rowData.getBigDecimal("tpv_qtynew"));// 销售发货数量
            tpv_packnum = BigDecimalUtils.toBigDecimal(rowData.getBigDecimal("tpv_packnumnew"));// 销售发货包装数量
            tpv_material = toLong(rowData.getLong("tpv_materialnew.id"));
        }
        Long org = toLong(parameter.getCustomParam("org"));
        if (!TPV_DT_SALESSHIPPING.equals(picktype)) {
            saleId = toLong(parameter.getCustomParam("pkid"));
            tpv_qty = BigDecimalUtils.toBigDecimal(parameter.getCustomParam("tpv_qty"));// 销售发货数量
            tpv_packnum = BigDecimalUtils.toBigDecimal(parameter.getCustomParam("tpv_packnum"));// 销售发货包装数量
            tpv_material = toLong(parameter.getCustomParam("tpv_material"));
        }
        DynamicObjectCollection entryEntity = model.getEntryEntity(entryKey_2);
        String according = null;
        /**
         * 校验
         */
        /*
         * if (entryEntity.size() == 0) { view.showTipNotification("无配货信息。"); return; }
         */
        DynamicObject dataEntity = model.getDataEntity(true);
        if (StringUtils.equals(picktype, TPV_DT_SALESSHIPPING)) {
            according = parameter.getCustomParam("tpv_yesnoinseries"); //是否串拣配
        }
        String whereFilter = "tpv_qty > 0";
        // 物料
        if (YEM.isNotEmpty(tpv_material)) {
            whereFilter = String.format("%s and tpv_material = %s", whereFilter, tpv_material);
        }
        // 公司
        if (YEM.isNotEmpty(org)) {
            whereFilter = String.format("%s and tpv_org = %s", whereFilter, org);
        }
        // 组合号
        if (StringUtils.isNotEmpty(according)) {
            DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
            if (YEM.isNotEmpty(tpv_combination_f)) {
                whereFilter = String.format("%s and tpv_combination != %s", whereFilter, tpv_combination_f.getPkValue());
            }
        } else {
            DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
            if (YEM.isNotEmpty(tpv_combination_f)) {
                whereFilter = String.format("%s and tpv_combination = %s", whereFilter, tpv_combination_f.getPkValue());
            }
        }
        // 库存/直运
        String tpv_inventorytype_f = dataEntity.getString("tpv_inventorytype_f");
        if (YEM.isNotEmpty(tpv_inventorytype_f)) {
            whereFilter = String.format("%s and tpv_inventorytype = '%s'", whereFilter, tpv_inventorytype_f);
        }
        DataSet query = PickShipsRptQuery.query(whereFilter, picktype, saleId);
        DynamicObjectCollection data = ORM.create().toPlainDynamicObjectCollection(query);

        BigDecimal sumQty = BigDecimal.ZERO;
        BigDecimal sumPackQty = BigDecimal.ZERO;
        List<String> tips = new ArrayList<>();
        for (DynamicObject row : entryEntity) {
            long tpv_fentryid1 = row.getLong("tpv_fentryid1");
            long tpv_vid1 = row.getLong("tpv_vid1");
            String tpv_pickbill1 = row.getString("tpv_pickbill1");
            BigDecimal tpv_pickqty1 = row.getBigDecimal("tpv_pickqty1");//本次配货数量
            BigDecimal tpv_qtypacknum1 = row.getBigDecimal("tpv_qtypacknum1");//本次配货包装数量
            sumQty = sumQty.add(tpv_pickqty1);
            sumPackQty = sumPackQty.add(tpv_qtypacknum1);
            int seq = row.getInt("seq");
            if (tpv_pickqty1.compareTo(BigDecimal.ZERO) <= 0) {
                tips.add(String.format("配货处理第【%s】行，本次配货数量为零。", seq));
                continue;
            }
            DynamicObject tpvQtypacknum1 = row.getDynamicObject("tpv_packagingunit1");//本次配货包装单位
            BigDecimal qtypacknum1 = row.getBigDecimal("tpv_qtypacknum1");//本次配货包装数量
            if (tpvQtypacknum1 != null) {
                if (qtypacknum1.compareTo(BigDecimal.ZERO) == 0) {
                    tips.add(String.format("配货处理第【%s】行，本次包装单位不为空，请填写本次配货包装数量！", seq));
                }
                continue;
            }
            Map<Long, List<DynamicObject>> map = data.stream()
                    .filter(x -> tpv_pickbill1.equals(x.getString("tpv_pickbill")))
                    .collect(Collectors.groupingBy(x -> x.getLong("tpv_fentryid")));
            List<DynamicObject> dyObjs = map.get(tpv_fentryid1);
            BigDecimal canPickQty = BigDecimal.ZERO;//可配数量
            BigDecimal canPickPackQty = BigDecimal.ZERO;//可配包装数量
            if (dyObjs != null) {
                for (DynamicObject obj : dyObjs) {
                    long tpv_vid = obj.getLong("tpv_vid");
                    if (tpv_vid == tpv_vid1) {
                        canPickQty = obj.getBigDecimal("tpv_maxqty");
                        canPickPackQty = obj.getBigDecimal("tpv_maxpacknumqty");
                    }
                }
            }
            if (tpv_pickqty1.compareTo(canPickQty) > 0 || tpv_qtypacknum1.compareTo(canPickPackQty) > 0) {
                tips.add(String.format("配货处理第【%s】行，本次配货数量大于最大可配数量，或者本次本次配货包装数量大于可配包装数量。", seq));
            }
        }
        if (!IM_PURINBILL.equals(picktype) && !MULTIBILL.equals(picktype) && !TPV_DT_CONFIGURANEW.equals(picktype)
                && entryEntity.size() != 0 && sumQty.compareTo(tpv_qty) == 1) {
            if (TPV_DT_SALESSHIPPING.equals(picktype)) {
                Boolean tpv_pickamtbox = parameter.getCustomParam("tpv_pickamtbox");
                Boolean tpv_pickqtybox = parameter.getCustomParam("tpv_pickqtybox");
                if (!tpv_pickqtybox) {
                    tips.add("本次配货总数量大于销售数量。");
                }
            } else {
                tips.add("本次配货总数量大于销售数量。");
            }
        }
        if (!IM_PURINBILL.equals(picktype) && !MULTIBILL.equals(picktype) && !TPV_DT_CONFIGURANEW.equals(picktype)
                && entryEntity.size() != 0 && sumPackQty.compareTo(tpv_packnum) == 1) {
            if (TPV_DT_SALESSHIPPING.equals(picktype)) {
                Boolean tpv_pickamtbox = parameter.getCustomParam("tpv_pickamtbox");
                Boolean tpv_pickqtybox = parameter.getCustomParam("tpv_pickqtybox");
                if (!tpv_pickqtybox) {
                    tips.add("本次配货包装总数量大于销售包装数量。");
                }
            } else {
                tips.add("本次配货包装总数量大于销售包装数量。");
            }
        }
        if (tips.size() > 0) {
            String errMsg = "";
            int msgSeq = 1;
            for (String tip : tips) {
                errMsg += String.format("%s、%s%s", msgSeq++, tip, "\r\n");
            }
            view.showMessage("配货信息有误，请检查。", errMsg, MessageTypes.Default);
            return;
        }
        /**
         * 销售发货反写
         */
        OperationResult saveOperate = null;
        IFormView parentView = view.getParentView();
        IDataModel parentModel = parentView.getModel();
        String entityId = parentView.getEntityId();
        dataEntity = parentModel.getDataEntity(true);
        String name = null;
        int pitchOn = 0;
        if (TPV_DT_SALESSHIPPING.equals(picktype)) {
            Boolean tpv_pickamtbox = parameter.getCustomParam("tpv_pickamtbox");
            Boolean tpv_pickqtybox = parameter.getCustomParam("tpv_pickqtybox");
            String tpv_inventorytype = parameter.getCustomParam("tpv_inventorytype");
            BigDecimal tpv_qtyrecord = BigDecimal.ZERO;
            BigDecimal tpv_qtynumrecord = BigDecimal.ZERO;
            DynamicObject entryRowEntity = null;
            if (selectRows.length == 1) {
                DynamicObject rowData = this.getModel().getEntryRowEntity(entryKey_3, selectRows[0]);
                tpv_qtynumrecord = BigDecimalUtils.toBigDecimal(rowData.getBigDecimal("tpv_qtynumrecordnew"));// 销售发货包装数量(开单)
                tpv_qtyrecord = BigDecimalUtils.toBigDecimal(rowData.getBigDecimal("tpv_qtyrecordnew"));// 销售发货数量(开单)
                DynamicObjectCollection tpvMaterialentry = parentModel.getEntryEntity("tpv_materialentry");
                for (DynamicObject dynamicObject : tpvMaterialentry) {
                    long aLong = dynamicObject.getLong("id");
                    if (aLong == saleId.longValue()) {
                        pitchOn = Integer.valueOf(dynamicObject.getString("seq"));
                        pitchOn = pitchOn - 1;
                        entryRowEntity = dynamicObject;
                    }
                }
            }
            String subEnd = "A".equals(tpv_inventorytype_f) ? "_in" : "_zy";
            if (YEM.isEmpty(entryRowEntity)) {
                view.sendFormAction(parentView);
                this.getPageCache().remove("oldIndex");
                this.getPageCache().remove("checkCache");
                view.close();
                return;
            }
            DynamicObjectCollection subEntry = entryRowEntity.getDynamicObjectCollection("tpv_dt_salepick" + subEnd);
            DataEntityPropertyCollection properties = subEntry.getDynamicObjectType().getProperties();
            DynamicObjectType dyType2 = entryEntity.getDynamicObjectType();
            DataEntityPropertyCollection properties2 = dyType2.getProperties();
            subEntry.clear();
            BigDecimal pickQtySum = BigDecimal.ZERO;
            BigDecimal packNumSum = BigDecimal.ZERO;
            BigDecimal pickAmtSum = BigDecimal.ZERO;
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);

                BigDecimal amount = BigDecimal.ZERO;
                pickQtySum = pickQtySum.add(BigDecimalUtils.toBigDecimal(row.get("tpv_pickqty1")));
                packNumSum = packNumSum.add(BigDecimalUtils.toBigDecimal(row.get("tpv_qtypacknum1")));
                amount = BigDecimalUtils.toBigDecimal(row.get("tpv_taxprice1"))
                        .multiply(BigDecimalUtils.toBigDecimal(row.get("tpv_pickqty1")));
                pickAmtSum = pickAmtSum.add(amount);

                DynamicObject addNew = subEntry.addNew();
                for (IDataEntityProperty property : properties2) {
                    String proKey = property.getName();
                    String key = YEM.substringBeforeLast(proKey, "1");
                    if (properties.containsKey(key + subEnd)) {
                        addNew.set(key + subEnd, row.get(proKey));
                        if (subEnd.equals("_in")) {
                            addNew.set("tpv_pickqtyrecord_in", row.get("tpv_pickqty1"));
                            addNew.set("tpv_picknumrecord_in", row.get("tpv_qtypacknum1"));
                            addNew.set("tpv_packnum_in", row.get("tpv_qtypacknum1"));
                            addNew.set("tpv_priceokqty", entryRowEntity.getBigDecimal("tpv_cargobatchqty"));
                            addNew.set("tpv_measure", entryRowEntity.getDynamicObject("tpv_unit"));
                            if (!tpv_pickamtbox) {
                                addNew.set("tpv_taxprice_in", entryRowEntity.get("tpv_taxprice"));
                                addNew.set("tpv_taxpricerecord_in", entryRowEntity.get("tpv_taxprice"));
                                addNew.set("tpv_taxpramount_in", entryRowEntity.getBigDecimal("tpv_taxprice").multiply(row.getBigDecimal("tpv_pickqty1")));
                            } else {
                                addNew.set("tpv_taxpricerecord_in", row.get("tpv_taxprice1"));
                                addNew.set("tpv_taxpramount_in", amount);
                            }
                            addNew.set("tpv_contractmark", row.get("tpv_purcontnum1"));
                            addNew.set("tpv_specation_in", row.get("tpv_specation1"));
                            addNew.set("tpv_customtags_in", row.get("tpv_customtags1"));
                            addNew.set("tpv_shader_in", row.get("tpv_shader1"));
                            addNew.set("tpv_origin_in", row.get("tpv_origin1"));
                            if (StringUtils.isNotEmpty(according)) {
                                addNew.set("tpv_loansign", true);
                            }
                            //addNew.set("tpv_pickqtyrecord_in",row.get("tpv_pickqty1"));
                        } else if (subEnd.equals("_zy")) {
                            addNew.set("tpv_pickqtyrecord_zy", row.get("tpv_pickqty1"));
                            addNew.set("tpv_picknumrecord_zy", row.get("tpv_qtypacknum1"));
                            addNew.set("tpv_packnum_zy", row.get("tpv_qtypacknum1"));
                            addNew.set("tpv_ofmeasure", entryRowEntity.getDynamicObject("tpv_unit"));
                            if (!tpv_pickamtbox) {
                                addNew.set("tpv_taxprice_zy", entryRowEntity.get("tpv_taxprice"));
                                addNew.set("tpv_taxpricerecord_zy", entryRowEntity.get("tpv_taxprice"));
                                addNew.set("tpv_taxpramount_zy", entryRowEntity.getBigDecimal("tpv_taxprice").multiply(row.getBigDecimal("tpv_pickqty1")));

                            } else {
                                addNew.set("tpv_taxpricerecord_zy", row.get("tpv_taxprice1"));
                                addNew.set("tpv_taxpramount_zy", amount);
                            }
                            //addNew.set("tpv_pickqtyrecord_zy",row.get("tpv_pickqty1"));
                            addNew.set("tpv_origin_zy", entryRowEntity.getDynamicObject("tpv_origin"));
                            addNew.set("tpv_shader_zy", entryRowEntity.get("tpv_shader"));
                            addNew.set("tpv_specation_zy", entryRowEntity.get("tpv_specation"));
                            addNew.set("tpv_customtags_zy", entryRowEntity.get("tpv_customtags"));
                            addNew.set("tpv_specation_zy", row.get("tpv_specation1"));
                            addNew.set("tpv_contractmark_zy", row.get("tpv_purcontnum1"));
                            addNew.set("tpv_customtags_zy", row.get("tpv_customtags1"));
                            addNew.set("tpv_shader_zy", row.get("tpv_shader1"));
                            addNew.set("tpv_origin_zy", row.get("tpv_origin1"));
                        }
                    }
                }
                addNew.set("seq", i + 1);
            }
            if (tpv_pickqtybox) {
                if (pickQtySum.compareTo(BigDecimal.ZERO) != 0) {
                    parentModel.setValue("tpv_qty", pickQtySum, pitchOn);
                    parentModel.setValue("tpv_packnum", packNumSum, pitchOn);
                    parentModel.setValue("tpv_pickqty", BigDecimal.ZERO, pitchOn);
                    parentModel.setValue("tpv_pickpackqty", BigDecimal.ZERO, pitchOn);
                } else {
                    parentModel.setValue("tpv_pickqty", tpv_qty, pitchOn);
                    parentModel.setValue("tpv_pickpackqty", tpv_packnum, pitchOn);
                }
            }
            if ("A".equals(tpv_inventorytype) && !tpv_pickqtybox) {
                parentModel.setValue("tpv_pickqty", tpv_qty.subtract(pickQtySum), pitchOn);
                parentModel.setValue("tpv_pickpackqty", tpv_packnum.subtract(packNumSum), pitchOn);
            } else if ("B".equals(tpv_inventorytype) && !tpv_pickqtybox) {
                parentModel.setValue("tpv_pickqty", tpv_qtyrecord.subtract(pickQtySum), pitchOn);
                parentModel.setValue("tpv_pickpackqty", tpv_qtynumrecord.subtract(packNumSum), pitchOn);
            }
            if (tpv_pickamtbox) {
                if (pickQtySum.compareTo(BigDecimal.ZERO) != 0) {
                    BigDecimal taxprice = pickAmtSum.divide(pickQtySum, 10, BigDecimal.ROUND_HALF_UP);
                    parentModel.setValue("tpv_taxprice", taxprice, pitchOn);
                }
            }
            saveOperate = OperationServiceHelper.executeOperate("save", entityId, new DynamicObject[]{dataEntity},
                    YEM.getOptionNoMsg());
        } else if (TPV_DT_NOCONFIGURATION.equals(picktype)) {
            BigDecimal tpv_cargobatchqty = BigDecimalUtils.toBigDecimal(parameter.getCustomParam("tpv_cargobatchqty"));// 销售发货数量
            String subEnd = "A".equals(tpv_inventorytype_f) ? "_in" : "_zy";
            DynamicObjectCollection tpvSonentryentity = parentModel.getEntryEntity("tpv_sonentryentity");
            DataEntityPropertyCollection properties = tpvSonentryentity.getDynamicObjectType().getProperties();
            DynamicObjectType threeType = entryEntity.getDynamicObjectType();
            DataEntityPropertyCollection properties2 = threeType.getProperties();
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                DynamicObject addNew = tpvSonentryentity.addNew();
                for (IDataEntityProperty property : properties2) {
                    String proKey = property.getName();
                    String key = YEM.substringBeforeLast(proKey, "1");
                    if (properties.containsKey(key + subEnd)) {
                        addNew.set(key + subEnd, row.get(proKey));
                        Object object = row.get("tpv_fid1");
                        addNew.set("tpv_fatherid", row.get("tpv_fid1"));
                        addNew.set("tpv_material_in", row.getDynamicObject("tpv_material1"));// 商品
                        addNew.set("tpv_prodname_in", row.getDynamicObject("tpv_prodname1"));// 品名
                        addNew.set("tpv_shader_in", row.get("tpv_shader1"));// 材质
                        addNew.set("tpv_origin_in", row.get("tpv_origin1"));// 产地
                        addNew.set("tpv_volumenumber_in", row.get("tpv_volumenumber1"));// 卷号
                        addNew.set("tpv_pickbill_in", row.get("tpv_pickbill1"));// 父配货单据
                        addNew.set("tpv_billno_in", row.get("tpv_billno1"));// 父配货单据编号
                        addNew.set("tpv_sonbill", row.get("tpv_pickbill1"));// 子配货单据
                        addNew.set("tpv_sonbillnos", row.get("tpv_billno1"));// 子配货单据编号
                        addNew.set("tpv_fid_in", row.get("tpv_fid1"));// 采购单据ID
                        addNew.set("tpv_vid_in", row.get("tpv_vid1"));//卷号分录ID
                        addNew.set("tpv_pickqtyrecord_in", row.get("tpv_pickqty1"));
                        addNew.set("tpv_destroyquantity", row.get("tpv_pickqty1"));
                        addNew.set("tpv_priceokqty", tpv_cargobatchqty);
                        addNew.set("tpv_fpackagereal", row.get("tpv_qtypacknum1"));
                        addNew.set("tpv_packnum_in", row.get("tpv_qtypacknum1"));
                        addNew.set("tpv_measure", row.getDynamicObject("tpv_unit1"));
                    }
                }
                addNew.set("seq", i + 1);
            }
            saveOperate = OperationServiceHelper.executeOperate("save", entityId, new DynamicObject[]{dataEntity},
                    YEM.getOptionNoMsg());
        } else if (MULTIBILL.equals(picktype)) {
            parentModel.deleteEntryData("billentry");
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                int index = parentModel.createNewEntryRow("billentry");
                parentModel.setValue("tpv_prodname", row.get("tpv_prodname1"), index);// 品名
                DynamicObject tpv_material1 = row.getDynamicObject("tpv_material1");
                if (tpv_material1 != null) {
                    tpv_material1 = BusinessDataServiceHelper.loadSingle("bd_materialinventoryinfo",
                            new QFilter("masterid", QCP.equals, tpv_material1.getPkValue()).toArray());
                }
                parentModel.setValue("material", tpv_material1, index);// 商品编码
                parentModel.setValue("tpv_combination", row.get("tpv_combination1"), index);// 组合号
                parentModel.setValue("tpv_specation", row.get("tpv_specation1"), index);// 规格
                parentModel.setValue("tpv_shader", row.get("tpv_shader1"), index);// 材质
                parentModel.setValue("tpv_origin", row.get("tpv_origin1"), index);// 产地
                parentModel.setValue("unit", row.get("tpv_unit1"), index);// 计量单位
                parentModel.setValue("qty", row.get("tpv_pickqty1"), index);// 数量
                parentModel.setValue("baseunit", row.get("tpv_unit1"), index);// 基本单位
                parentModel.setValue("baseqty", row.get("tpv_pickqty1"), index);// 基本数量
                parentModel.setValue("tpv_packagingunit", row.get("tpv_packagingunit1"), index);// 包装单位
                parentModel.setValue("tpv_packnum", row.get("tpv_qtypacknum1"), index);//包装数量
                parentModel.setValue("im_transdirbill".equals(entityId) ? "outwarehouse" : "warehouse",
                        row.get("tpv_warehouse1"), index);// 仓库
                parentModel.setValue("tpv_pickbill_in", row.get("tpv_pickbill1"), index);// 配货单据
                parentModel.setValue("tpv_billno_in", row.get("tpv_billno1"), index);// 单据编号
                parentModel.setValue("tpv_volumenumber_in", row.get("tpv_volumenumber1"), index);// 卷号
                parentModel.setValue("tpv_fid_in", row.get("tpv_fid1"), index);// 采购单据ID
                parentModel.setValue("tpv_fentryid_in", row.get("tpv_fentryid1"), index);// 采购分录行ID
                parentModel.setValue("tpv_fcoentryid_in", row.get("tpv_fcoentryid1"), index);// 采购合同行ID
                parentModel.setValue("tpv_fcoid_in", row.get("tpv_fcoid1"), index);// 采购合同id
                parentModel.setValue("tpv_contractnumber", row.get("tpv_fcoid1"), index);// 采购合同号
                parentModel.setValue("tpv_vid_in", row.get("tpv_vid1"), index);//卷号分录ID
                saveOperate = parentView.invokeOperation("save", YEM.getOptionNoMsg());
            }
        } else if (TPV_DT_INVENTORYCONFIGURA.equals(picktype)) {
            //库存拣配业务实提工作台
            int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_entryentity");
            DynamicObject entryRowEntity = parentModel.getEntryRowEntity("tpv_entryentity", entryCurrentRowIndex);
            String tpvSrcentryid = entryRowEntity.getString("tpv_srcentryid");
            long srcentryid = Long.parseLong(tpvSrcentryid);
            QFilter qFilter = new QFilter("tpv_materialentry", QCP.equals, srcentryid);
            String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
            DynamicObject billHead = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
            ;//需查询
            billHead = BusinessDataServiceHelper.loadSingle(billHead.getPkValue(),
                    billHead.getDynamicObjectType().getName());
            DynamicObject rowS = null;
            DynamicObjectCollection objectCollection = billHead.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject dynamicObject : objectCollection) {
                long id = (Long) dynamicObject.get("id");
                if (id == srcentryid) {
                    rowS = dynamicObject;
                }
            }
            String subEnd = "A".equals(tpv_inventorytype_f) ? "_in" : "_zy";
            DynamicObjectCollection subEntry = rowS.getDynamicObjectCollection("tpv_dt_salepick" + subEnd);
            DataEntityPropertyCollection properties = subEntry.getDynamicObjectType().getProperties();
            DynamicObjectType dyType2 = objectCollection.getDynamicObjectType();
            DataEntityPropertyCollection properties2 = dyType2.getProperties();
            //subEntry.clear();
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                DynamicObject addNew = subEntry.addNew();
                for (IDataEntityProperty property : properties2) {
                    String proKey = property.getName();
                    String key = YEM.substringBeforeLast(proKey, "1");
                    if (properties.containsKey(key + subEnd)) {
                        //addNew.set(key + subEnd, row.get(proKey));
                        //addNew.set("tpv_fatherid", row.get("tpv_fid1"));
                        addNew.set("tpv_material_in", row.getDynamicObject("tpv_material1"));// 商品
                        addNew.set("tpv_specation_in", row.get("tpv_specation1"));// 规格
                        addNew.set("tpv_prodname_in", row.getDynamicObject("tpv_prodname1"));// 品名
                        addNew.set("tpv_shader_in", row.get("tpv_shader1"));// 材质
                        addNew.set("tpv_origin_in", row.get("tpv_origin1"));// 产地
                        addNew.set("tpv_volumenumber_in", row.get("tpv_volumenumber1"));// 卷号
                        addNew.set("tpv_pickbill_in", row.get("tpv_pickbill1"));// 父配货单据
                        addNew.set("tpv_billno_in", row.get("tpv_billno1"));// 父配货单据编号
                        addNew.set("tpv_measure", row.get("tpv_unit1"));// 计量单位
                        addNew.set("tpv_pickqty_in", row.get("tpv_pickqty1"));// 数量
                        addNew.set("tpv_pickqtyrecord_in", row.get("tpv_pickqty1"));// 数量记录
                        addNew.set("tpv_priceokqty", rowS.get("tpv_cargobatchqty"));// 数量价格确认
                        //addNew.set("tpv_packagingunit", row.get("tpv_packagingunit1"));// 包装单位
                        addNew.set("im_transdirbill".equals(entityId) ? "outwarehouse" : "tpv_warehouse_in",
                                row.get("tpv_warehouse1"));// 仓库
                        addNew.set("tpv_fid_in", row.get("tpv_fid1"));// 采购单据ID
                        addNew.set("tpv_fentryid_in", row.get("tpv_fentryid1"));// 采购分录行ID
                        addNew.set("tpv_fcoentryid_in", row.get("tpv_fcoentryid1"));// 采购合同行ID
                        addNew.set("tpv_contractnumber", row.get("tpv_fcoid1"));// 采购合同号
                        addNew.set("tpv_vid_in", row.get("tpv_vid1"));//卷号分录ID
                        addNew.set("tpv_department_in", row.get("tpv_department1"));// 部门
                        addNew.set("tpv_supplier_in", row.get("tpv_supplier1"));// 供应商
                        addNew.set("tpv_tradeproperty_in", row.get("tpv_tradeproperty1"));// 贸易性质
                        addNew.set("tpv_combination_in", row.get("tpv_combination1"));//组合号
                        addNew.set("tpv_strategy_in", row.get("tpv_strategy1"));//策略号
                        addNew.set("tpv_pickbilltype_in", row.get("tpv_pickbilltype1"));//单据类型
                    }
                }
                addNew.set("seq", i + 1);
            }
            saveOperate = OperationServiceHelper.executeOperate("save", entityId, new DynamicObject[]{billHead},
                    YEM.getOptionNoMsg());
            //LinRui begin -确认回填后，只刷新分录部分
            workBackDynamicView(parentView);
            //LinRui end
        } else if (IM_PURINBILL.equals(picktype)) {
            //采购入库
            //parentModel.deleteEntryData("billentry");
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                int index = parentModel.createNewEntryRow("billentry");
                parentModel.setValue("tpv_prodname", row.get("tpv_prodname1"), index);// 品名
                DynamicObject tpv_material1 = row.getDynamicObject("tpv_material1");
                if (tpv_material1 != null) {
                    tpv_material1 = BusinessDataServiceHelper.loadSingle("bd_materialinventoryinfo",
                            new QFilter("masterid", QCP.equals, tpv_material1.getPkValue()).toArray());
                }
                BigDecimal object = (BigDecimal) row.get("tpv_pickqty1");
                BigDecimal tpv_pickqty1 = object.negate();
                //row.set("tpv_pickqty1",tpv_pickqty1);
                parentModel.setValue("material", tpv_material1, index);// 商品编码
                parentModel.setValue("tpv_specation", row.get("tpv_specation1"), index);// 规格
                parentModel.setValue("tpv_shader", row.get("tpv_shader1"), index);// 材质
                parentModel.setValue("tpv_origin", row.get("tpv_origin1"), index);// 产地
                parentModel.setValue("unit", row.get("tpv_unit1"), index);// 计量单位
                parentModel.setValue("qty", row.get("tpv_pickqty1"), index);// 数量
                parentModel.setValue("baseunit", row.get("tpv_unit1"), index);// 基本单位
                parentModel.setValue("baseqty", row.get("tpv_pickqty1"), index);// 基本数量
                parentModel.setValue("tpv_packagingunit", row.get("tpv_packagingunit1"), index);//包装单位
                parentModel.setValue("tpv_packnum", row.get("tpv_qtypacknum1"), index);//包装数量
                parentModel.setValue("im_transdirbill".equals(entityId) ? "outwarehouse" : "warehouse",
                        row.get("tpv_warehouse1"), index);// 仓库
                parentModel.setValue("tpv_corebillid", row.get("tpv_fcoid1"), index);//合同号id
                parentModel.setValue("tpv_pickbill_in", row.get("tpv_pickbill1"), index);// 配货单据
                parentModel.setValue("tpv_billno_in", row.get("tpv_billno1"), index);// 单据编号
                parentModel.setValue("tpv_volumenumber_in", row.get("tpv_volumenumber1"), index);// 卷号
                parentModel.setValue("tpv_fid_in", row.get("tpv_fid1"), index);// 采购单据ID
                parentModel.setValue("tpv_fentryid_in", row.get("tpv_fentryid1"), index);// 采购分录行ID
                parentModel.setValue("tpv_fcoentryid_in", row.get("tpv_fcoentryid1"), index);// 采购合同行ID
                parentModel.setValue("tpv_fcoid_in", row.get("tpv_fcoid1"), index);// 采购合同id
                parentModel.setValue("tpv_contractnumber", row.get("tpv_fcoid1"), index);// 采购合同号
                parentModel.setValue("tpv_vid_in", row.get("tpv_vid1"), index);//卷号分录ID
                saveOperate = parentView.invokeOperation("save", YEM.getOptionNoMsg());
            }
        } else if (TPV_DT_RELEVANCEDEALGS.equals(picktype)) {
            //关联交易转货单
            int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_dt_goodstransfe_zh");
            DynamicObject entryRowEntity = dataEntity.getDynamicObjectCollection("tpv_dt_goodstransfe_zh")
                    .get(entryCurrentRowIndex);
            DynamicObjectCollection subEntry = entryRowEntity.getDynamicObjectCollection("tpv_dt_transferdist_ph");
            DataEntityPropertyCollection properties = subEntry.getDynamicObjectType().getProperties();
            DynamicObjectType dyType2 = entryEntity.getDynamicObjectType();
            DataEntityPropertyCollection properties2 = dyType2.getProperties();
            subEntry.clear();
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                DynamicObject addNew = subEntry.addNew();
                for (IDataEntityProperty property : properties2) {
                    addNew.set("tpv_prodnames", row.get("tpv_prodname1"));// 品名
                    DynamicObject tpv_material1 = row.getDynamicObject("tpv_material1");
                    if (tpv_material1 != null) {
                        tpv_material1 = BusinessDataServiceHelper.loadSingle("bd_materialinventoryinfo",
                                new QFilter("masterid", QCP.equals, tpv_material1.getPkValue()).toArray());
                    }
                    addNew.set("tpv_contractmark", row.get("tpv_purcontnum1"));//合同号
                    addNew.set("tpv_materials", row.get("tpv_material1"));// 商品编码
                    addNew.set("tpv_specations", row.get("tpv_specation1"));// 规格
                    addNew.set("tpv_shaders", row.get("tpv_shader1"));// 材质
                    addNew.set("tpv_origins", row.get("tpv_origin1"));// 产地
                    addNew.set("tpv_ofmeasure", row.get("tpv_unit1"));// 计量单位
                    addNew.set("tpv_departments", row.get("tpv_department1"));//部门
                    addNew.set("tpv_suppliers", row.get("tpv_supplier1"));//供应商
                    addNew.set("tpv_tradepropertys", row.get("tpv_tradeproperty1"));//贸易性质
                    addNew.set("tpv_combinations", row.get("tpv_combination1"));//组合号
                    addNew.set("tpv_strategys", row.get("tpv_strategy1"));//策略号
                    addNew.set("tpv_pickbilltypes", row.get("tpv_pickbilltype1"));//单据类型
                    addNew.set("tpv_pickqty", row.get("tpv_pickqty1"));// 本次配货数量
                    addNew.set("tpv_packagingunit", row.get("tpv_packagingunit1"));// 包装单位
                    addNew.set("tpv_qtypacknum", row.get("tpv_qtypacknum1"));// 本次配货包装数量
                    addNew.set("tpv_warehouse", row.get("tpv_warehouse1.id"));// 仓库
                    //parentModel.setValue("tpv_corebillid", row.get("tpv_fcoid1"), index);//合同号id
                    addNew.set("tpv_pickbill", row.get("tpv_pickbill1"));// 配货单据
                    addNew.set("tpv_billnos", row.get("tpv_billno1"));// 单据编号
                    addNew.set("tpv_volumenumber", row.get("tpv_volumenumber1"));// 卷号
                    addNew.set("tpv_fids", row.get("tpv_fid1"));// 采购单据ID
                    addNew.set("tpv_fentryids", row.get("tpv_fentryid1"));// 采购分录行ID
                    addNew.set("tpv_fcoentryids", row.get("tpv_fcoentryid1"));// 采购合同行ID
                    addNew.set("tpv_fcoids", row.get("tpv_fcoid1"));// 采购合同ID
                    addNew.set("tpv_vids", row.get("tpv_vid1"));//卷号分录ID
                }
                addNew.set("seq", i + 1);
            }
            saveOperate = OperationServiceHelper.executeOperate("save", entityId, new DynamicObject[]{dataEntity},
                    YEM.getOptionNoMsg());
        } else if (TPV_DT_CONFIGURANEW.equals(picktype)) {
            BigDecimal tpv_cargobatchqty = BigDecimalUtils.toBigDecimal(parameter.getCustomParam("tpv_cargobatchqty"));// 销售发货数量
            String subEnd = "A".equals(tpv_inventorytype_f) ? "_in" : "_zy";
            DynamicObject configuranewData = parentModel.getDataEntity(true);
            DynamicObjectCollection tpvSonentryentity = parentModel.getEntryEntity("tpv_sonentryentity");
            DataEntityPropertyCollection properties = tpvSonentryentity.getDynamicObjectType().getProperties();
            DynamicObjectType threeType = entryEntity.getDynamicObjectType();
            DataEntityPropertyCollection properties2 = threeType.getProperties();
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                DynamicObject addNew = tpvSonentryentity.addNew();
                for (IDataEntityProperty property : properties2) {
                    String proKey = property.getName();
                    String key = YEM.substringBeforeLast(proKey, "1");
                    if (properties.containsKey(key + subEnd)) {
                        addNew.set(key + subEnd, row.get(proKey));
                        addNew.set("tpv_fatherid", row.get("tpv_fid1"));
                        addNew.set("tpv_material_in", row.getDynamicObject("tpv_material1"));// 商品
                        addNew.set("tpv_prodname_in", row.getDynamicObject("tpv_prodname1"));// 品名
                        addNew.set("tpv_shader_in", row.get("tpv_shader1"));// 材质
                        addNew.set("tpv_origin_in", row.get("tpv_origin1"));// 产地tpv_pickqty_in
                        addNew.set("tpv_volumenumber_in", row.get("tpv_volumenumber1"));// 卷号
                        addNew.set("tpv_pickbill_in", row.get("tpv_pickbill1"));// 父配货单据
                        addNew.set("tpv_billno_in", row.get("tpv_billno1"));// 父配货单据编号
                        addNew.set("tpv_sonbill", row.get("tpv_pickbill1"));// 子配货单据
                        addNew.set("tpv_sonbillnos", row.get("tpv_billno1"));// 子配货单据编号
                        addNew.set("tpv_fid_in", row.get("tpv_fid1"));// 采购单据ID
                        addNew.set("tpv_vid_in", row.get("tpv_vid1"));//卷号分录ID
                        addNew.set("tpv_pickqtyrecord_in", row.get("tpv_pickqty1"));
                        addNew.set("tpv_destroyquantity", row.get("tpv_pickqty1"));
                        addNew.set("tpv_picknumrecord_in", row.get("tpv_qtypacknum1"));
                        addNew.set("tpv_fpackagereal", row.get("tpv_qtypacknum1"));
                        addNew.set("tpv_priceokqty", tpv_cargobatchqty);
                        addNew.set("tpv_fillpicksign", row.get("tpv_fillpicksign1"));
                        addNew.set("tpv_packnum_in", row.get("tpv_qtypacknum1"));
                        addNew.set("tpv_measure", row.getDynamicObject("tpv_unit1"));
                        boolean tpvPracticalok = configuranewData.getBoolean("tpv_practicalok");
                        if (tpvPracticalok) {
                            addNew.set("tpv_practicalok_in", true);
                        }
                    }
                }
                addNew.set("seq", i + 1);
            }
            saveOperate = OperationServiceHelper.executeOperate("save", entityId, new DynamicObject[]{dataEntity},
                    YEM.getOptionNoMsg());
        } else if (TPV_DT_PROCESS.equals(picktype)) {
            //加工指令单
            int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_materialentry");
            DynamicObject entryRowEntity = dataEntity.getDynamicObjectCollection("tpv_materialentry")
                    .get(entryCurrentRowIndex);
            DynamicObjectCollection subEntry = entryRowEntity.getDynamicObjectCollection("tpv_pickinginformaentity");
            DataEntityPropertyCollection properties = subEntry.getDynamicObjectType().getProperties();
            DynamicObjectType dyType2 = entryEntity.getDynamicObjectType();
            DataEntityPropertyCollection properties2 = dyType2.getProperties();
            subEntry.clear();
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                DynamicObject addNew = subEntry.addNew();
                for (IDataEntityProperty property : properties2) {
                    addNew.set("tpv_prodnames", row.get("tpv_prodname1"));// 品名
                    DynamicObject tpv_material1 = row.getDynamicObject("tpv_material1");
                    if (tpv_material1 != null) {
                        tpv_material1 = BusinessDataServiceHelper.loadSingle("bd_materialinventoryinfo",
                                new QFilter("masterid", QCP.equals, tpv_material1.getPkValue()).toArray());
                    }
                    addNew.set("tpv_ordercontractmark", row.get("tpv_purcontnum1"));//合同号
                    addNew.set("tpv_materials", row.get("tpv_material1"));// 商品编码
                    addNew.set("tpv_specations", row.get("tpv_specation1"));// 规格
                    addNew.set("tpv_shaders", row.get("tpv_shader1"));// 材质
                    addNew.set("tpv_origins", row.get("tpv_origin1"));// 产地
                    addNew.set("tpv_units", row.get("tpv_unit1"));// 计量单位
                    addNew.set("tpv_packagingunits", row.get("tpv_packagingunit1"));// 包装单位
                    addNew.set("tpv_departments", row.get("tpv_department1"));//部门
                    addNew.set("tpv_suppliers", row.get("tpv_supplier1"));//供应商
                    addNew.set("tpv_natureoftrade", row.get("tpv_tradeproperty1"));//贸易性质
                    addNew.set("tpv_combinationcode", row.get("tpv_combination1"));//组合号
                    addNew.set("tpv_policycode", row.get("tpv_strategy1"));//策略号
                    addNew.set("tpv_billtypes", row.get("tpv_pickbilltype1"));//单据类型
                    addNew.set("tpv_distributioncount", row.get("tpv_pickqty1"));// 本次配货数量
                    addNew.set("tpv_packagingcount", row.get("tpv_qtypacknum1"));// 本次配货包装数量
                    addNew.set("tpv_warehouse", row.get("tpv_warehouse1.id"));// 仓库
                    //parentModel.setValue("tpv_corebillid", row.get("tpv_fcoid1"), index);//合同号id
                    addNew.set("tpv_pickbill", row.get("tpv_pickbill1"));// 配货单据
                    addNew.set("tpv_pickbillno", row.get("tpv_billno1"));// 单据编号
                    addNew.set("tpv_volumenumber", row.get("tpv_volumenumber1"));// 卷号
                    addNew.set("tpv_orderfid", row.get("tpv_fid1"));// 采购单据ID
                    addNew.set("tpv_orderfentryid", row.get("tpv_fentryid1"));// 采购分录行ID
                    addNew.set("tpv_orderfcoentryid", row.get("tpv_fcoentryid1"));// 采购合同行ID
                    addNew.set("tpv_orderfcoid", row.get("tpv_fcoid1"));// 采购合同ID
                    addNew.set("tpv_ordervid", row.get("tpv_vid1"));//卷号分录ID
                }
                addNew.set("seq", i + 1);
            }
            saveOperate = OperationServiceHelper.executeOperate("save", entityId, new DynamicObject[]{dataEntity},
                    YEM.getOptionNoMsg());
        }
        if (saveOperate == null || !saveOperate.isSuccess()) {
            view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
            return;
        }
        //LinRui 外加if条件，工作台不需要刷新整个页面
        if (!TPV_DT_INVENTORYCONFIGURA.equals(picktype)) {
            parentView.invokeOperation("refresh");
        }
        String entityId1 = parentView.getEntityId();//杰伟代码优化，需要表单插件写
        if (entityId1.equals("tpv_dt_salesshipping")) {
            String billno = (String) parentModel.getValue("billno");
            if (billno.length() > 4) {
                String substring = billno.substring(0, 4);
                if ("XSFH".equals(substring)) {
//                    parentView.setEnable(false, "tpv_entrepot");
                    parentView.setEnable(false, pitchOn, "tpv_origin");  //锁定分录字段
                    parentView.setEnable(false, pitchOn, "tpv_shader");  //锁定分录字段
                    parentView.setEnable(false, pitchOn, "tpv_specation");  //锁定分录字段
                }
            }
        }
        view.sendFormAction(parentView);
        this.getPageCache().remove("oldIndex");
        this.getPageCache().remove("checkCache");
        view.close();
    }

    private Boolean checkPickOk(int selectRow) {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        FormShowParameter parameter = view.getFormShowParameter();
        String picktype = parameter.getCustomParam("picktype");
        Long saleId = 0L;
        Long tpv_material = 0L;
        BigDecimal tpv_qty = BigDecimal.ZERO;
        BigDecimal tpv_packnum = BigDecimal.ZERO;
        if (TPV_DT_SALESSHIPPING.equals(picktype)) {
            DynamicObject rowData = this.getModel().getEntryRowEntity(entryKey_3, selectRow);
            saleId = rowData.getLong("tpv_saleentryid");
            tpv_qty = BigDecimalUtils.toBigDecimal(rowData.getBigDecimal("tpv_qtynew"));// 销售发货数量
            tpv_packnum = BigDecimalUtils.toBigDecimal(rowData.getBigDecimal("tpv_packnumnew"));// 销售发货包装数量
            tpv_material = toLong(rowData.getLong("tpv_materialnew.id"));
        }
        Long org = toLong(parameter.getCustomParam("org"));
        DynamicObjectCollection entryEntity = model.getEntryEntity(entryKey_2);
        String according = null;
        /**
         * 校验
         */
        /*
         * if (entryEntity.size() == 0) { view.showTipNotification("无配货信息。"); return; }
         */
        DynamicObject dataEntity = model.getDataEntity(true);
        if (StringUtils.equals(picktype, TPV_DT_SALESSHIPPING)) {
            according = parameter.getCustomParam("tpv_yesnoinseries"); //是否串拣配
        }
        String whereFilter = "tpv_qty > 0";
        // 物料
        if (YEM.isNotEmpty(tpv_material)) {
            whereFilter = String.format("%s and tpv_material = %s", whereFilter, tpv_material);
        }
        // 公司
        if (YEM.isNotEmpty(org)) {
            whereFilter = String.format("%s and tpv_org = %s", whereFilter, org);
        }
        // 组合号
        if (StringUtils.isNotEmpty(according)) {
            DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
            if (YEM.isNotEmpty(tpv_combination_f)) {
                whereFilter = String.format("%s and tpv_combination != %s", whereFilter, tpv_combination_f.getPkValue());
            }
        } else {
            DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
            if (YEM.isNotEmpty(tpv_combination_f)) {
                whereFilter = String.format("%s and tpv_combination = %s", whereFilter, tpv_combination_f.getPkValue());
            }
        }
        // 库存/直运
        String tpv_inventorytype_f = dataEntity.getString("tpv_inventorytype_f");
        if (YEM.isNotEmpty(tpv_inventorytype_f)) {
            whereFilter = String.format("%s and tpv_inventorytype = '%s'", whereFilter, tpv_inventorytype_f);
        }
        DataSet query = PickShipsRptQuery.query(whereFilter, picktype, saleId);
        DynamicObjectCollection data = ORM.create().toPlainDynamicObjectCollection(query);

        BigDecimal sumQty = BigDecimal.ZERO;
        BigDecimal sumPackQty = BigDecimal.ZERO;
        List<String> tips = new ArrayList<>();
        for (DynamicObject row : entryEntity) {
            long tpv_fentryid1 = row.getLong("tpv_fentryid1");
            long tpv_vid1 = row.getLong("tpv_vid1");
            String tpv_pickbill1 = row.getString("tpv_pickbill1");
            BigDecimal tpv_pickqty1 = row.getBigDecimal("tpv_pickqty1");//本次配货数量
            BigDecimal tpv_qtypacknum1 = row.getBigDecimal("tpv_qtypacknum1");//本次配货包装数量
            sumQty = sumQty.add(tpv_pickqty1);
            sumPackQty = sumPackQty.add(tpv_qtypacknum1);
            int seq = row.getInt("seq");
            if (tpv_pickqty1.compareTo(BigDecimal.ZERO) <= 0) {
                tips.add(String.format("配货处理第【%s】行，本次配货数量为零。", seq));
                continue;
            }
            DynamicObject tpvQtypacknum1 = row.getDynamicObject("tpv_packagingunit1");//本次配货包装单位
            BigDecimal qtypacknum1 = row.getBigDecimal("tpv_qtypacknum1");//本次配货包装数量
            if (tpvQtypacknum1 != null) {
                if (qtypacknum1.compareTo(BigDecimal.ZERO) == 0) {
                    tips.add(String.format("配货处理第【%s】行，本次包装单位不为空，请填写本次配货包装数量！", seq));
                }
                continue;
            }
            Map<Long, List<DynamicObject>> map = data.stream()
                    .filter(x -> tpv_pickbill1.equals(x.getString("tpv_pickbill")))
                    .collect(Collectors.groupingBy(x -> x.getLong("tpv_fentryid")));
            List<DynamicObject> dyObjs = map.get(tpv_fentryid1);
            BigDecimal canPickQty = BigDecimal.ZERO;//可配数量
            BigDecimal canPickPackQty = BigDecimal.ZERO;//可配包装数量
            if (dyObjs != null) {
                for (DynamicObject obj : dyObjs) {
                    long tpv_vid = obj.getLong("tpv_vid");
                    if (tpv_vid == tpv_vid1) {
                        canPickQty = obj.getBigDecimal("tpv_maxqty");
                        canPickPackQty = obj.getBigDecimal("tpv_maxpacknumqty");
                    }
                }
            }
            if (tpv_pickqty1.compareTo(canPickQty) > 0 || tpv_qtypacknum1.compareTo(canPickPackQty) > 0) {
                tips.add(String.format("配货处理第【%s】行，本次配货数量大于最大可配数量，或者本次本次配货包装数量大于可配包装数量。", seq));
            }
        }
        if (TPV_DT_SALESSHIPPING.equals(picktype) && entryEntity.size() != 0 && sumQty.compareTo(tpv_qty) == 1) {
            boolean tpv_pickamtbox = parameter.getCustomParam("tpv_pickamtbox");
            boolean tpv_pickqtybox = parameter.getCustomParam("tpv_pickqtybox");
            if (!tpv_pickqtybox) {
                tips.add("本次配货总数量大于销售数量。");
            }
        }
        if (TPV_DT_SALESSHIPPING.equals(picktype) && entryEntity.size() != 0 && sumPackQty.compareTo(tpv_packnum) == 1) {
            boolean tpv_pickamtbox = parameter.getCustomParam("tpv_pickamtbox");
            boolean tpv_pickqtybox = parameter.getCustomParam("tpv_pickqtybox");
            if (!tpv_pickqtybox) {
                tips.add("本次配货包装总数量大于销售包装数量。");
            }
        }
        if (tips.size() > 0) {
            String errMsg = "";
            int msgSeq = 1;
            for (String tip : tips) {
                errMsg += String.format("%s、%s%s", msgSeq++, tip, "\r\n");
            }
            view.showMessage("配货信息有误，请检查。", errMsg, MessageTypes.Default);
            return false;
        }
        /**
         * 销售发货反写
         */
        OperationResult saveOperate = null;
        IFormView parentView = view.getParentView();
        IDataModel parentModel = parentView.getModel();
        String entityId = parentView.getEntityId();
        dataEntity = parentModel.getDataEntity(true);
        String name = null;
        int pitchOn = 0;
        if (TPV_DT_SALESSHIPPING.equals(picktype)) {
            Boolean tpv_pickamtbox = parameter.getCustomParam("tpv_pickamtbox");
            Boolean tpv_pickqtybox = parameter.getCustomParam("tpv_pickqtybox");
            String tpv_inventorytype = parameter.getCustomParam("tpv_inventorytype");
            BigDecimal tpv_qtyrecord = BigDecimal.ZERO;
            BigDecimal tpv_qtynumrecord = BigDecimal.ZERO;
            DynamicObject entryRowEntity = null;
            DynamicObject rowData = this.getModel().getEntryRowEntity(entryKey_3, selectRow);
            tpv_qtynumrecord = BigDecimalUtils.toBigDecimal(rowData.getBigDecimal("tpv_qtynumrecordnew"));// 销售发货包装数量(开单)
            tpv_qtyrecord = BigDecimalUtils.toBigDecimal(rowData.getBigDecimal("tpv_qtyrecordnew"));// 销售发货数量(开单)
            DynamicObjectCollection tpvMaterialentry = parentModel.getEntryEntity("tpv_materialentry");
            for (DynamicObject dynamicObject : tpvMaterialentry) {
                long aLong = dynamicObject.getLong("id");
                if (aLong == saleId.longValue()) {
                    pitchOn = Integer.valueOf(dynamicObject.getString("seq"));
                    pitchOn = pitchOn - 1;
                    entryRowEntity = dynamicObject;
                }
            }
            String subEnd = "A".equals(tpv_inventorytype_f) ? "_in" : "_zy";
            if (YEM.isEmpty(entryRowEntity)) {
                return false;
            }
            DynamicObjectCollection subEntry = entryRowEntity.getDynamicObjectCollection("tpv_dt_salepick" + subEnd);
            DataEntityPropertyCollection properties = subEntry.getDynamicObjectType().getProperties();
            DynamicObjectType dyType2 = entryEntity.getDynamicObjectType();
            DataEntityPropertyCollection properties2 = dyType2.getProperties();
            subEntry.clear();
            BigDecimal pickQtySum = BigDecimal.ZERO;
            BigDecimal packNumSum = BigDecimal.ZERO;
            BigDecimal pickAmtSum = BigDecimal.ZERO;
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);

                BigDecimal amount = BigDecimal.ZERO;
                pickQtySum = pickQtySum.add(BigDecimalUtils.toBigDecimal(row.get("tpv_pickqty1")));
                packNumSum = packNumSum.add(BigDecimalUtils.toBigDecimal(row.get("tpv_qtypacknum1")));
                amount = BigDecimalUtils.toBigDecimal(row.get("tpv_taxprice1"))
                        .multiply(BigDecimalUtils.toBigDecimal(row.get("tpv_pickqty1")));
                pickAmtSum = pickAmtSum.add(amount);

                DynamicObject addNew = subEntry.addNew();
                for (IDataEntityProperty property : properties2) {
                    String proKey = property.getName();
                    String key = YEM.substringBeforeLast(proKey, "1");
                    if (properties.containsKey(key + subEnd)) {
                        addNew.set(key + subEnd, row.get(proKey));
                        if (subEnd.equals("_in")) {
                            addNew.set("tpv_pickqtyrecord_in", row.get("tpv_pickqty1"));
                            addNew.set("tpv_picknumrecord_in", row.get("tpv_qtypacknum1"));
                            addNew.set("tpv_packnum_in", row.get("tpv_qtypacknum1"));
                            addNew.set("tpv_priceokqty", entryRowEntity.getBigDecimal("tpv_cargobatchqty"));
                            addNew.set("tpv_measure", entryRowEntity.getDynamicObject("tpv_unit"));
                            if (!tpv_pickamtbox) {
                                addNew.set("tpv_taxprice_in", entryRowEntity.get("tpv_taxprice"));
                                addNew.set("tpv_taxpricerecord_in", entryRowEntity.get("tpv_taxprice"));
                                addNew.set("tpv_taxpramount_in", entryRowEntity.getBigDecimal("tpv_taxprice").multiply(row.getBigDecimal("tpv_pickqty1")));
                            } else {
                                addNew.set("tpv_taxpricerecord_in", row.get("tpv_taxprice1"));
                                addNew.set("tpv_taxpramount_in", amount);
                            }
                            addNew.set("tpv_contractmark", row.get("tpv_purcontnum1"));
                            addNew.set("tpv_specation_in", row.get("tpv_specation1"));
                            addNew.set("tpv_customtags_in", row.get("tpv_customtags1"));
                            addNew.set("tpv_shader_in", row.get("tpv_shader1"));
                            addNew.set("tpv_origin_in", row.get("tpv_origin1"));
                            if (StringUtils.isNotEmpty(according)) {
                                addNew.set("tpv_loansign", true);
                            }
                            //addNew.set("tpv_pickqtyrecord_in",row.get("tpv_pickqty1"));
                        } else if (subEnd.equals("_zy")) {
                            addNew.set("tpv_pickqtyrecord_zy", row.get("tpv_pickqty1"));
                            addNew.set("tpv_picknumrecord_zy", row.get("tpv_qtypacknum1"));
                            addNew.set("tpv_packnum_zy", row.get("tpv_qtypacknum1"));
                            addNew.set("tpv_ofmeasure", entryRowEntity.getDynamicObject("tpv_unit"));
                            if (!tpv_pickamtbox) {
                                addNew.set("tpv_taxprice_zy", entryRowEntity.get("tpv_taxprice"));
                                addNew.set("tpv_taxpricerecord_zy", entryRowEntity.get("tpv_taxprice"));
                                addNew.set("tpv_taxpramount_zy", entryRowEntity.getBigDecimal("tpv_taxprice").multiply(row.getBigDecimal("tpv_pickqty1")));

                            } else {
                                addNew.set("tpv_taxpricerecord_zy", row.get("tpv_taxprice1"));
                                addNew.set("tpv_taxpramount_zy", amount);
                            }
                            //addNew.set("tpv_pickqtyrecord_zy",row.get("tpv_pickqty1"));
                            addNew.set("tpv_origin_zy", entryRowEntity.getDynamicObject("tpv_origin"));
                            addNew.set("tpv_shader_zy", entryRowEntity.get("tpv_shader"));
                            addNew.set("tpv_specation_zy", entryRowEntity.get("tpv_specation"));
                            addNew.set("tpv_customtags_zy", entryRowEntity.get("tpv_customtags"));
                            addNew.set("tpv_specation_zy", row.get("tpv_specation1"));
                            addNew.set("tpv_contractmark_zy", row.get("tpv_purcontnum1"));
                            addNew.set("tpv_customtags_zy", row.get("tpv_customtags1"));
                            addNew.set("tpv_shader_zy", row.get("tpv_shader1"));
                            addNew.set("tpv_origin_zy", row.get("tpv_origin1"));
                        }
                    }
                }
                addNew.set("seq", i + 1);
            }
            if (tpv_pickqtybox) {
                 if (pickQtySum.compareTo(BigDecimal.ZERO) != 0) {
                     parentModel.setValue("tpv_qty", pickQtySum, pitchOn);
                     parentModel.setValue("tpv_packnum", packNumSum, pitchOn);
                     parentModel.setValue("tpv_pickqty", pickQtySum, pitchOn);
                     parentModel.setValue("tpv_pickpackqty", packNumSum, pitchOn);
                     this.getModel().setValue("tpv_qtynew", pickQtySum, selectRow);
                     this.getModel().setValue("tpv_packnumnew", packNumSum, selectRow);
                     this.getModel().setValue("tpv_pickqtynew", pickQtySum, selectRow);
                     this.getModel().setValue("tpv_pickpackqtynew", packNumSum, selectRow);
                 } else {
                     parentModel.setValue("tpv_pickqty", tpv_qty, pitchOn);
                     parentModel.setValue("tpv_pickpackqty", tpv_packnum, pitchOn);
                     this.getModel().setValue("tpv_pickqtynew", tpv_qty, selectRow);
                     this.getModel().setValue("tpv_pickpackqtynew", tpv_packnum, selectRow);
                 }
            }
            if ("A".equals(tpv_inventorytype) && !tpv_pickqtybox) {
                parentModel.setValue("tpv_pickqty", tpv_qty.subtract(pickQtySum), pitchOn);
                parentModel.setValue("tpv_pickpackqty", tpv_packnum.subtract(packNumSum), pitchOn);
                this.getModel().setValue("tpv_pickqtynew", tpv_qty.subtract(pickQtySum), selectRow);
                this.getModel().setValue("tpv_pickpackqtynew", tpv_packnum.subtract(packNumSum), selectRow);
            } else if ("B".equals(tpv_inventorytype) && !tpv_pickqtybox) {
                parentModel.setValue("tpv_pickqty", tpv_qtyrecord.subtract(pickQtySum), pitchOn);
                parentModel.setValue("tpv_pickpackqty", tpv_qtynumrecord.subtract(packNumSum), pitchOn);
                this.getModel().setValue("tpv_pickqtynew", tpv_qtyrecord.subtract(pickQtySum), selectRow);
                this.getModel().setValue("tpv_pickpackqtynew", tpv_qtynumrecord.subtract(packNumSum), selectRow);
            }
            if (tpv_pickamtbox) {
                if (pickQtySum.compareTo(BigDecimal.ZERO) != 0) {
                    BigDecimal taxprice = pickAmtSum.divide(pickQtySum, 10, BigDecimal.ROUND_HALF_UP);
                    parentModel.setValue("tpv_taxprice", taxprice, pitchOn);
                    this.getModel().setValue("tpv_taxpricenew", taxprice, selectRow);
                }
            }
            saveOperate = OperationServiceHelper.executeOperate("save", entityId, new DynamicObject[]{dataEntity},
                    YEM.getOptionNoMsg());
        }
        if (saveOperate == null || !saveOperate.isSuccess()) {
            view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
            return false;
        }
        parentView.invokeOperation("refresh");
        view.sendFormAction(parentView);
        return true;
    }

    private void workBackDynamicView(IFormView parentView) {
        IDataModel models = parentView.getModel();
        DynamicObject dataEntitys = models.getDataEntity(true);
        String whereFilters = "1=1";
        models.deleteEntryData("tpv_entryentity");
        //库存为直运
        String tpv_filternumber = dataEntitys.getString("tpv_filternumber");//单据编号
        String tpv_marketnumber = dataEntitys.getString("tpv_marketnumber");//销售合同号
        Boolean tpv_practical = dataEntitys.getBoolean("tpv_practical");//实提完毕
        String tpv_blending = dataEntitys.getString("tpv_blending");//是否免拣配
        DynamicObject tpvCustomerup = dataEntitys.getDynamicObject("tpv_customerup");//客户
        if (null != tpvCustomerup) {
            long id = tpvCustomerup.getLong("id");
            whereFilters = String.format("%s and tpv_customer = %s", whereFilters, id);
        }
        if (StringUtil.isNotEmpty(tpv_filternumber)) {
            whereFilters = String.format("%s and tpv_shipments like %s", whereFilters, "'%" + tpv_filternumber + "%'");
        }
        if (StringUtil.isNotEmpty(tpv_marketnumber)) {
            whereFilters = String.format("%s and tpv_market like %s", whereFilters, "'%" + tpv_marketnumber + "%'");
        }
        if (tpv_practical) {
            whereFilters = String.format("%s and tpv_realsubmit = %s", whereFilters, false);
        }
        if (StringUtil.isNotEmpty(tpv_blending)) {
            if (tpv_blending.equals("A")) {
                whereFilters = String.format("%s and tpv_nopicking = %s", whereFilters, true);
            } else {
                whereFilters = String.format("%s and tpv_nopicking = %s", whereFilters, false);
            }
        }
        whereFilters = String.format("%s and tpv_inventorytype = %s", whereFilters, "'A'");
        whereFilters = String.format("%s and tpv_nopicking = %s", whereFilters, "false");
        whereFilters = String.format("%s and tpv_sourceid != %s", whereFilters, 0);
        DataSet querys = InventoryRptQuery.query(whereFilters);
        DynamicObjectType enrtyTypes = models.getEntryEntity("tpv_entryentity").getDynamicObjectType();
        DataEntityPropertyCollection propertiess = enrtyTypes.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(querys);
        for (Row row : querys) {
            int index = models.createNewEntryRow("tpv_entryentity");
            for (IDataEntityProperty property : propertiess) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    models.setValue(key, row.get(key), index);
                }
            }
        }
        int tpvEntryentity = parentView.getModel().getEntryCurrentRowIndex("tpv_entryentity");
        if (tpvEntryentity >= 0) {
            DynamicObjectCollection entity = parentView.getModel().getEntryEntity("tpv_entryentity");//商品明细
            if (entity.size() > 0) {
                DynamicObject dynamicObject = entity.get(tpvEntryentity);//数据
                dynamicObject.getLong("tpv_sourceid");
                BillShowParameter showParameter = new BillShowParameter();
                showParameter.setCustomParam("tpv_srcentryid", dynamicObject.getString("tpv_seleid"));
                showParameter.setStatus(OperationStatus.EDIT);
                showParameter.getOpenStyle().setShowType(ShowType.InContainer);
                //容器表示
                showParameter.getOpenStyle().setTargetKey("tpv_flexpanelap");
                showParameter.setSendToClient(true);
                //单据标识
                showParameter.setFormId("tpv_dt_configurabottom");
                //主键
                showParameter.setPkId(dynamicObject.getLong("tpv_sourceid"));
                parentView.showForm(showParameter);
            }
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        switch (itemKey) {
            case "tpv_deleteentry":
                deleteEntry();
                break;
            default:
                break;
        }
    }

    /**
     * 配货记录撤销
     */
    private void deleteEntry() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        EntryGrid entry = view.getControl(entryKey_2);
        int selectRows = entry.getSelectRows().length;
        if (selectRows < 1) {
            view.showTipNotification("未选择数据。");
        } else {
            int[] indexs = entry.getSelectRows();
            for (int index : indexs) {
                int tpv_seq1 = (int) model.getValue("tpv_seq1", index);
                if (tpv_seq1 > 0) {
                    model.beginInit();
                    model.setValue("tpv_focus", false, tpv_seq1 - 1);
                    model.endInit();
                    view.updateView("tpv_focus", tpv_seq1 - 1);
                }
            }
            model.deleteEntryRows(entryKey_2, indexs);
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();
        String key = e.getProperty().getName();
        switch (key) {
            case "tpv_focus":
                pickFocus(rowIndex);
                break;
            case "tpv_pickqtyone":
            case "tpv_qtypacknumone":
                IDataModel model = this.getModel();
                BigDecimal value = BigDecimalUtils.toBigDecimal(this.getModel().getValue(key, rowIndex));
                DynamicObject row = model.getEntryRowEntity(entryKey_1, rowIndex);
                DynamicObjectCollection entry2 = model.getEntryEntity(entryKey_2);
                int seq = row.getInt("seq");
                if (row.getBoolean("tpv_focus")) {
                    List<Integer> seqs = entry2.stream().map(x -> x.getInt("tpv_seq1")).collect(Collectors.toList());
                    if (seqs.contains(seq)) {
                        if (entry2.size() > 0) {
                            for (int i = 0; i < entry2.size(); i++) {
                                DynamicObject dynamicObject = entry2.get(i);
                                int seq1 = dynamicObject.getInt("tpv_seq1");
                                if (seq1 == seq) {
                                    dynamicObject.set(YEM.substringBeforeLast(key, "one") + "1", value);
                                    this.getView().updateView(YEM.substringBeforeLast(key, "one") + "1", i);
                                }
                            }
                        }
                    }
                }
                break;
            default:
                break;
        }
    }

    /**
     * 选中调整配货信息
     */
    private void pickFocus(int rowIndex) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvEntryentity = dataEntity.getDynamicObjectCollection("tpv_entryentity");

        if (tpvEntryentity.size() == 0) {
            pickFocus(rowIndex, null, null);
        } else {
            DynamicObject dynamicObject = tpvEntryentity.get(0).getDynamicObject("tpv_combination1");
            DynamicObjectCollection tpvTreeentryentitys = dataEntity.getDynamicObjectCollection("tpv_treeentryentity");
            for (int i = 0; i < tpvTreeentryentitys.size(); i++) {
                boolean aBoolean = tpvTreeentryentitys.get(i).getBoolean("tpv_focus");
                DynamicObject rowObject = tpvTreeentryentitys.get(i);
                if (aBoolean) {
                    DynamicObject tpvCombination = tpvTreeentryentitys.get(i).getDynamicObject("tpv_combination");
                    if (dynamicObject != tpvCombination) {
                        this.getView().showTipNotification("可配信息选择行的组合号要相同！");
                        this.getModel().setValue("tpv_focus", false, i);
                        return;
                    }
                } else {
                    rowObject.set("tpv_pickqtyone", BigDecimal.ZERO);
                    rowObject.set("tpv_qtypacknumone", BigDecimal.ZERO);
                    this.getView().updateView("tpv_pickqtyone", i);
                    this.getView().updateView("tpv_qtypacknumone", i);
                }
            }
            pickFocus(rowIndex, null, null);

        }
    }

    private void pickFocus(int rowIndex, BigDecimal tpv_pickqty, BigDecimal tpv_pickpacknum) {
        IFormView view = this.getView();
        FormShowParameter parameter = view.getFormShowParameter();
        IFormView parentView = view.getParentView();
        IDataModel parentModel = parentView.getModel();
        IDataModel model = this.getModel();
        DynamicObject row = model.getEntryRowEntity(entryKey_1, rowIndex);
        DataEntityPropertyCollection properties = row.getDynamicObjectType().getProperties();
        DynamicObjectCollection entry2 = model.getEntryEntity(entryKey_2);
        DataEntityPropertyCollection properties2 = entry2.getDynamicObjectType().getProperties();
        String entityId = parentView.getEntityId();
        String just = null;
        int seq = row.getInt("seq");
        if (row.getBoolean("tpv_focus")) {
            List<Integer> seqs = entry2.stream().map(x -> x.getInt("tpv_seq1")).collect(Collectors.toList());
            if (!seqs.contains(seq)) {
                int index = model.createNewEntryRow(entryKey_2);
                for (IDataEntityProperty property : properties) {
                    String key = property.getName();
                    if (properties2.containsKey(key + "1")) {
                        model.setValue(key + "1", row.get(key), index);
                    }
                }
                model.setValue("tpv_seq1", seq, index);
                if (entityId.equals("tpv_dt_salesshipping")) {
                    Boolean tpv_pickamtbox = parameter.getCustomParam("tpv_pickamtbox");
                    Boolean tpv_pickqtybox = parameter.getCustomParam("tpv_pickqtybox");
                    int entryCurrentRowIndex = this.getModel().getEntryCurrentRowIndex(entryKey_3);
//                    DynamicObject dataEntity = parentModel.getDataEntity(true);
//                    DynamicObject entryRowEntity = dataEntity.getDynamicObjectCollection("tpv_materialentry")
//                            .get(entryCurrentRowIndex);
                    DynamicObject entryRowEntity = this.getModel().getEntryRowEntity(entryKey_3, entryCurrentRowIndex);
                    DynamicObjectCollection entryEntity = this.getModel().getEntryEntity("tpv_entryentity");
                    just = entityId;
                    //拣配下方分录得本次配货数量
                    BigDecimal total = BigDecimal.ZERO;
                    BigDecimal sumTal = BigDecimal.ZERO;
                    //拣配下方分录得本次配货包装数量
                    BigDecimal packTotal = BigDecimal.ZERO;
                    //获取销售发货商品分录数量
                    BigDecimal tpvQty = entryRowEntity.getBigDecimal("tpv_qtynew");
                    //获取销售发货商品分录包装数量
                    BigDecimal tpvPacknum = entryRowEntity.getBigDecimal("tpv_packnumnew");
                    //获取拣配上方分录可配数量
                    BigDecimal tpvQty1 = row.getBigDecimal("tpv_qty");
                    //获取拣配上方分录可配包装数量
                    BigDecimal tpvPacknum1 = row.getBigDecimal("tpv_packnum");
                    DynamicObjectCollection tpvSalepickZy = parentModel.getEntryEntity("tpv_dt_salepick_zy");
                    if (entry2.size() > 0) {
                        for (DynamicObject dynamicObject : tpvSalepickZy) {
                            total = total.add(dynamicObject.getBigDecimal("tpv_pickqty_zy"));
                            packTotal = packTotal.add(dynamicObject.getBigDecimal("tpv_packnum_zy"));
                        }
                    }
                    DynamicObject dataEntity1 = this.getModel().getDataEntity(true);
                    DynamicObjectCollection entryEntity1 = dataEntity1.getDynamicObjectCollection("tpv_entryentity");
//                    if (total.compareTo(BigDecimal.ZERO) == 0) {
                    if (!tpv_pickqtybox) {
                        if (entryEntity1.size() == 1) {
                            int message = tpvQty.compareTo(tpvQty1);
                            int messagePack = tpvPacknum.compareTo(tpvPacknum1);
                            if (message > 0) {
                                model.setValue("tpv_pickqty1", tpvQty1, index);
                                model.setValue("tpv_pickqtyone", tpvQty1, rowIndex);
                            } else {
                                model.setValue("tpv_pickqty1", tpvQty, index);
                                model.setValue("tpv_pickqtyone", tpvQty, rowIndex);
                            }
                            if (messagePack > 0) {
                                model.setValue("tpv_qtypacknum1", tpvPacknum1, index);
                                model.setValue("tpv_qtypacknumone", tpvPacknum1, rowIndex);
                            } else {
                                model.setValue("tpv_qtypacknum1", tpvPacknum, index);
                                model.setValue("tpv_qtypacknumone", tpvPacknum, rowIndex);
                            }
                        }
//                    else if (total.compareTo(BigDecimal.ZERO) != 0) {
                        //用销售发货商品分录数量减去拣配下方分录得本次配货数量
//                        DynamicObjectCollection entryEntity1 = model.getEntryEntity("tpv_entryentity");
                        BigDecimal sum = BigDecimal.ZERO;
                        BigDecimal sumPack = BigDecimal.ZERO;
                        if (entryEntity1.size() > 1) {
                            for (DynamicObject dynamicObject : entryEntity1) {
                                sum = sum.add(dynamicObject.getBigDecimal("tpv_pickqty1"));
                                sumPack = sumPack.add(dynamicObject.getBigDecimal("tpv_qtypacknum1"));
                            }
                            int message = tpvQty.subtract(sum).compareTo(tpvQty1);
                            int messagePack = tpvPacknum.subtract(sumPack).compareTo(tpvPacknum1);
                            if (message > 0) {
                                model.setValue("tpv_pickqty1", tpvQty1, index);
                                model.setValue("tpv_pickqtyone", tpvQty1, rowIndex);
                            } else {
                                model.setValue("tpv_pickqty1", tpvQty.subtract(sum), index);
                                model.setValue("tpv_pickqtyone", tpvQty.subtract(sum), rowIndex);
                            }
                            if (messagePack > 0) {
                                model.setValue("tpv_qtypacknum1", tpvPacknum1, index);
                                model.setValue("tpv_qtypacknumone", tpvPacknum1, rowIndex);
                            } else {
                                model.setValue("tpv_qtypacknum1", tpvPacknum.subtract(sumPack), index);
                                model.setValue("tpv_qtypacknumone", tpvPacknum.subtract(sumPack), rowIndex);
                            }
                        } else {
                            BigDecimal subtract = tpvQty.subtract(total);
                            BigDecimal subtractPack = tpvPacknum.subtract(packTotal);
                            int messageOne = subtract.compareTo(tpvQty1);
                            int messagePackOne = subtractPack.compareTo(tpvPacknum1);
                            if (messageOne > 0) {
                                model.setValue("tpv_pickqty1", tpvQty1, index);
                                model.setValue("tpv_pickqtyone", tpvQty1, rowIndex);
                            } else {
                                model.setValue("tpv_pickqty1", tpvQty, index);
                                model.setValue("tpv_pickqtyone", tpvQty, rowIndex);
                            }
                            if (messagePackOne > 0) {
                                model.setValue("tpv_qtypacknum1", tpvPacknum1, index);
                                model.setValue("tpv_qtypacknumone", tpvPacknum1, rowIndex);
                            } else {
                                model.setValue("tpv_qtypacknum1", tpvPacknum, index);
                                model.setValue("tpv_qtypacknumone", tpvPacknum, rowIndex);
                            }
                        }

//                    }
                    } else {
                        model.setValue("tpv_pickqty1", tpvQty1, index);
                        model.setValue("tpv_qtypacknum1", tpvPacknum1, index);
                        model.setValue("tpv_pickqtyone", tpvQty1, rowIndex);
                        model.setValue("tpv_qtypacknumone", tpvPacknum1, rowIndex);
                    }
                }
                if (entityId.equals("tpv_dt_inventoryconfigura")) {
                    model.setValue("tpv_pickqty1", BigDecimal.ZERO, index);
                }
                if (entityId.equals("tpv_dt_relevancedealgs")) {
                    int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_dt_goodstransfe_zh");
                    DynamicObject dataEntity = parentModel.getDataEntity(true);
                    DynamicObject entryRowEntity = dataEntity.getDynamicObjectCollection("tpv_dt_goodstransfe_zh")
                            .get(entryCurrentRowIndex);
                    DynamicObjectCollection entryEntity = this.getModel().getEntryEntity("tpv_entryentity");
                    just = entityId;
                    //拣配下方分录得本次配货数量
                    BigDecimal total = BigDecimal.ZERO;
                    BigDecimal sumTal = BigDecimal.ZERO;
                    //获取转货单发货商品分录转货数量
                    BigDecimal tpvQty = entryRowEntity.getBigDecimal("tpv_transferqty");
                    //获取拣配上方分录可配数量
                    BigDecimal tpvQty1 = row.getBigDecimal("tpv_qty");
                    DynamicObjectCollection tpvSalepickZy = parentModel.getEntryEntity("tpv_dt_transferdist_ph");
                    if (entry2.size() > 0) {
                        for (DynamicObject dynamicObject : tpvSalepickZy) {
                            total = total.add(dynamicObject.getBigDecimal("tpv_pickqty"));
                        }
                    }
                    DynamicObject dataEntity1 = this.getModel().getDataEntity(true);
                    DynamicObjectCollection entryEntity1 = dataEntity1.getDynamicObjectCollection("tpv_entryentity");
//                    if (total.compareTo(BigDecimal.ZERO) == 0) {
                    if (entryEntity1.size() == 1) {
                        int message = tpvQty.compareTo(tpvQty1);
                        if (message > 0) {
                            model.setValue("tpv_pickqty1", tpvQty1, index);
                        } else {
                            model.setValue("tpv_pickqty1", tpvQty, index);
                        }
                    }
                    BigDecimal sum = BigDecimal.ZERO;
                    if (entryEntity1.size() > 1) {
                        for (DynamicObject dynamicObject : entryEntity1) {
                            sum = sum.add(dynamicObject.getBigDecimal("tpv_pickqty1"));
                        }
                        int message = tpvQty.subtract(sum).compareTo(tpvQty1);
                        if (message > 0) {
                            model.setValue("tpv_pickqty1", tpvQty1, index);
                        } else {
                            model.setValue("tpv_pickqty1", tpvQty.subtract(sum), index);
                        }
                    } else {
                        BigDecimal subtract = tpvQty.subtract(total);
                        int messageOne = subtract.compareTo(tpvQty1);
                        if (messageOne > 0) {
                            model.setValue("tpv_pickqty1", tpvQty1, index);
                        } else {
                            model.setValue("tpv_pickqty1", tpvQty, index);
                        }
                    }
                }
                if (entityId.equals("tpv_dt_process")) {
                    int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_materialentry");
                    DynamicObject dataEntity = parentModel.getDataEntity(true);
                    DynamicObject entryRowEntity = dataEntity.getDynamicObjectCollection("tpv_materialentry")
                            .get(entryCurrentRowIndex);
                    DynamicObjectCollection entryEntity = this.getModel().getEntryEntity("tpv_entryentity");
                    just = entityId;
                    //拣配下方分录得本次配货数量
                    BigDecimal total = BigDecimal.ZERO;
                    BigDecimal sumTal = BigDecimal.ZERO;
                    //拣配下方分录得本次配货包装数量
                    BigDecimal packTotal = BigDecimal.ZERO;
                    //获取商品分录数量
                    BigDecimal tpvQty = entryRowEntity.getBigDecimal("tpv_qty");
                    //获取商品分录包装数量
                    BigDecimal tpvPacknum = entryRowEntity.getBigDecimal("tpv_packnum");
                    //获取拣配上方分录可配数量
                    BigDecimal tpvQty1 = row.getBigDecimal("tpv_qty");
                    //获取拣配上方分录可配包装数量
                    BigDecimal tpvPacknum1 = row.getBigDecimal("tpv_packnum");
                    DynamicObjectCollection tpvSalepickZy = parentModel.getEntryEntity("tpv_pickinginformaentity");
                    if (entry2.size() > 0) {
                        for (DynamicObject dynamicObject : tpvSalepickZy) {
                            total = total.add(dynamicObject.getBigDecimal("tpv_distributioncount"));
                            packTotal = packTotal.add(dynamicObject.getBigDecimal("tpv_packagingcount"));
                        }
                    }
                    DynamicObject dataEntity1 = this.getModel().getDataEntity(true);
                    DynamicObjectCollection entryEntity1 = dataEntity1.getDynamicObjectCollection("tpv_entryentity");
//                    if (total.compareTo(BigDecimal.ZERO) == 0) {
                    if (entryEntity1.size() == 1) {
                        int message = tpvQty.compareTo(tpvQty1);
                        int messagePack = tpvPacknum.compareTo(tpvPacknum1);
                        if (message > 0) {
                            model.setValue("tpv_pickqty1", tpvQty1, index);
                        } else {
                            model.setValue("tpv_pickqty1", tpvQty, index);
                        }
                        if (messagePack > 0) {
                            model.setValue("tpv_qtypacknum1", tpvPacknum1, index);
                        } else {
                            model.setValue("tpv_qtypacknum1", tpvPacknum, index);
                        }
                    }
                    BigDecimal sum = BigDecimal.ZERO;
                    BigDecimal sumPack = BigDecimal.ZERO;
                    if (entryEntity1.size() > 1) {
                        for (DynamicObject dynamicObject : entryEntity1) {
                            sum = sum.add(dynamicObject.getBigDecimal("tpv_pickqty1"));
                            sumPack = sumPack.add(dynamicObject.getBigDecimal("tpv_qtypacknum1"));
                        }
                        int message = tpvQty.subtract(sum).compareTo(tpvQty1);
                        int messagePack = tpvPacknum.subtract(sumPack).compareTo(tpvPacknum1);
                        if (message > 0) {
                            model.setValue("tpv_pickqty1", tpvQty1, index);
                        } else {
                            model.setValue("tpv_pickqty1", tpvQty.subtract(sum), index);
                        }
                        if (messagePack > 0) {
                            model.setValue("tpv_qtypacknum1", tpvPacknum1, index);
                        } else {
                            model.setValue("tpv_qtypacknum1", tpvPacknum.subtract(sumPack), index);
                        }
                    } else {
                        BigDecimal subtract = tpvQty.subtract(total);
                        BigDecimal subtractPack = tpvPacknum.subtract(packTotal);
                        int messageOne = subtract.compareTo(tpvQty1);
                        int messagePackOne = subtractPack.compareTo(tpvPacknum1);
                        if (messageOne > 0) {
                            model.setValue("tpv_pickqty1", tpvQty1, index);
                        } else {
                            model.setValue("tpv_pickqty1", tpvQty, index);
                        }
                        if (messagePackOne > 0) {
                            model.setValue("tpv_qtypacknum1", tpvPacknum1, index);
                        } else {
                            model.setValue("tpv_qtypacknum1", tpvPacknum, index);
                        }
                    }
                }
                if (entityId.equals("tpv_dt_configuranew")) {
                    model.setValue("tpv_fillpicksign1", true, index);
                }
//                if (null == just) {
                if (YEM.isNotEmpty(tpv_pickqty)) {
                    model.setValue("tpv_pickqty1", tpv_pickqty, index);
                    model.setValue("tpv_pickqtyone", tpv_pickqty, rowIndex);

                }
                if (YEM.isNotEmpty(tpv_pickpacknum)) {
                    model.setValue("tpv_qtypacknum1", tpv_pickpacknum, index);
                    model.setValue("tpv_qtypacknumone", tpv_pickpacknum, rowIndex);
                }
//                }
            }
        } else {
            for (int i = 0; i < entry2.size(); i++) {
                DynamicObject row2 = entry2.get(i);
                if (seq == row2.getInt("tpv_seq1")) {
                    model.deleteEntryRow(entryKey_2, i);
                }
            }
        }
    }

    /**
     * 加载拣配数据
     *
     * @param b
     */
    private void initData(boolean b) {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        FormShowParameter parameter = view.getFormShowParameter();
        String picktype = parameter.getCustomParam("picktype");
        Long tpv_warehouse = 0L;
        String juge = "3";
        if (MULTIBILL.equals(picktype)) {
            juge = parameter.getCustomParam("juge");
            if (StringUtils.equals(juge, "2")) {
                Long tpvEntrepot = toLong(parameter.getCustomParam("tpv_warehouse"));
                if (tpvEntrepot != null) {
                    tpv_warehouse = tpvEntrepot;
                }
//                tpv_warehouse = toLong(parameter.getCustomParam("tpv_warehouse"));
            }
        }
        String tpv_inventorytype = parameter.getCustomParam("tpv_inventorytype");
        if ((TPV_DT_SALESSHIPPING.equals(picktype) && "A".equals(tpv_inventorytype)) ||
                TPV_DT_CONFIGURANEW.equals(picktype) || TPV_DT_NOCONFIGURATION.equals(picktype)) {
            Long tpvEntrepot = toLong(parameter.getCustomParam("tpv_entrepot"));
            if (tpvEntrepot != null) {
                tpv_warehouse = tpvEntrepot;
            }
//            tpv_warehouse = toLong(parameter.getCustomParam("tpv_entrepot"));
        }
        Long saleId = 0L;
        Long tpv_material = 0L;
        String tpv_specation = "";
        String tpv_shader = "";
        Long tpv_origin = 0L;
        String tpv_customtags = "";
        Long tpv_prodname = 0L;
        if (TPV_DT_SALESSHIPPING.equals(picktype)) {
            EntryGrid entryGrid = this.getControl(entryKey_3);//商品明细分录
            int[] selectRows = entryGrid.getSelectRows();//获取选中的行号
            if (selectRows.length == 1) {
                DynamicObject rowData = this.getModel().getEntryRowEntity(entryKey_3, selectRows[0]);
                saleId = rowData.getLong("tpv_saleentryid");
                tpv_material = YEM.isNotEmpty(rowData.getDynamicObject("tpv_materialnew"))
                        ? rowData.getDynamicObject("tpv_materialnew").getLong("id") : 0L;
                tpv_specation = rowData.getString("tpv_specationnew");
                tpv_shader = rowData.getString("tpv_shadernew");
                tpv_origin = YEM.isNotEmpty(rowData.getDynamicObject("tpv_originnew"))
                        ? rowData.getDynamicObject("tpv_originnew").getLong("id") : 0L;
                tpv_customtags = rowData.getString("tpv_customtagsnew");
                tpv_prodname = YEM.isNotEmpty(rowData.getDynamicObject("tpv_prodnamenew"))
                        ? rowData.getDynamicObject("tpv_prodnamenew").getLong("id") : 0L;
            }
        } else {
            saleId = toLong(parameter.getCustomParam("pkid"));
            tpv_material = toLong(parameter.getCustomParam("tpv_material"));
            tpv_specation = parameter.getCustomParam("tpv_specation");
            tpv_shader = parameter.getCustomParam("tpv_shader");
            tpv_origin = toLong(parameter.getCustomParam("tpv_origin"));
            tpv_customtags = parameter.getCustomParam("tpv_customtags");
            tpv_prodname = toLong(parameter.getCustomParam("tpv_prodname"));
        }
        Long org = toLong(parameter.getCustomParam("org"));
        Long tpv_combina = toLong(parameter.getCustomParam("tpv_combina"));
        String panduan = null;

        // 查询是否变更单
        // DynamicObject parentDataEntity =
        // view.getParentView().getModel().getDataEntity(true);
        // IDataEntityType dataEntityType = parentDataEntity.getDataEntityType();
        // String entityNumber = dataEntityType.getName();// 源单标识
        // NewVersionHelper vHelper = new NewVersionHelper(entityNumber);
        // if (vHelper.isChanged()) {
        //
        // }

        model.setValue("tpv_inventorytype_f", tpv_inventorytype);
        if (b) {
            if (StringUtils.equals(juge, "2") && tpv_warehouse != 0L) {
                model.setValue("tpv_warehouse_f", tpv_warehouse);
            }
            if ((TPV_DT_SALESSHIPPING.equals(picktype) || TPV_DT_CONFIGURANEW.equals(picktype)
                    || TPV_DT_NOCONFIGURATION.equals(picktype)) && tpv_warehouse != 0L) {
                model.setValue("tpv_warehouse_f", tpv_warehouse);
            }
//            if (!TPV_DT_SALESSHIPPING.equals(picktype)) {
                model.setValue("tpv_specation_f", tpv_specation);
                model.setValue("tpv_shader_f", tpv_shader);
                model.setValue("tpv_origin_f", tpv_origin);
                model.setValue("tpv_material_f", tpv_material);
//            model.setValue("tpv_prodname_f", tpv_prodname);
                model.setValue("tpv_customtags_f", tpv_customtags);
//            }
            model.setValue("tpv_combination_f", tpv_combina);
        }

        model.deleteEntryData(entryKey_1);
        model.deleteEntryData(entryKey_2);

        DynamicObject dataEntity = model.getDataEntity(true);
        if (StringUtils.equals(picktype, TPV_DT_SALESSHIPPING)) {
            panduan = parameter.getCustomParam("tpv_yesnoinseries");
        }
        String whereFilter = "tpv_qty > 0";
        // 物料
        if (YEM.isNotEmpty(tpv_material)) {
            whereFilter = String.format("%s and tpv_material = %s", whereFilter, tpv_material);
        }
        // 公司
        if (YEM.isNotEmpty(org)) {
            whereFilter = String.format("%s and tpv_org = %s", whereFilter, org);
        }
        if (MULTIBILL.equals(picktype)) {
            Long outdept = toLong(parameter.getCustomParam("outdept"));
            if (null != outdept) {
                whereFilter = String.format("%s and bizdept = %s", whereFilter, outdept);
            }
        }
        // 组合号
        if (StringUtils.isNotEmpty(panduan)) {
            DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
            if (YEM.isNotEmpty(tpv_combination_f)) {
                whereFilter = String.format("%s and tpv_combination != %s", whereFilter, tpv_combination_f.getPkValue());
            }
        } else {
            DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
            if (YEM.isNotEmpty(tpv_combination_f)) {
                whereFilter = String.format("%s and tpv_combination = %s", whereFilter, tpv_combination_f.getPkValue());
            }
        }
        /*// 组合号
        DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
        if (YEM.isNotEmpty(tpv_combination_f)) {
            whereFilter = String.format("%s and tpv_combination = %s", whereFilter, tpv_combination_f.getPkValue());
        }*/
        if (TPV_DT_PROCESS.equals(picktype)) {
            Long tpv_supplier = toLong(parameter.getCustomParam("tpv_supplier"));
            QFilter qFilter = new QFilter("tpv_vendor.id", QCP.equals, tpv_supplier);
            DynamicObject[] load = BusinessDataServiceHelper.load("bd_warehouse", "id", qFilter.toArray());
            if (load.length > 0) {
                List<String> longList = Arrays.stream(load).map(x -> String.valueOf(x.getLong("id"))).collect(Collectors.toList());
                whereFilter = String.format("%s and tpv_warehouse in ('%s')", whereFilter, String.join("','", longList));
            } else {
                this.getView().showTipNotification("根据供应商查询，暂无匹配到供应商对应仓库数据！(仓库未维护该供应商)");
                return;
            }
        } else {
            // 仓库
            DynamicObject tpv_warehouse_f = dataEntity.getDynamicObject("tpv_warehouse_f");
            if (YEM.isNotEmpty(tpv_warehouse_f)) {
                whereFilter = String.format("%s and tpv_warehouse = %s", whereFilter, tpv_warehouse_f.getPkValue());
            }
        }
        // 库存/直运
        String tpv_inventorytype_f = dataEntity.getString("tpv_inventorytype_f");
        if (YEM.isNotEmpty(tpv_inventorytype_f)) {
            whereFilter = String.format("%s and tpv_inventorytype = '%s'", whereFilter, tpv_inventorytype_f);
            if ("B".equals(tpv_inventorytype_f)) {
                String salecon = parameter.getCustomParam("salecon");
                if (YEM.isNotEmpty(salecon.trim()) && StringUtils.equals(picktype, TPV_DT_SALESSHIPPING)) {
                    DynamicObjectCollection purchaseCons = QueryServiceHelper.query("tpv_dt_purchase", "id", new QFilter[]{new QFilter("tpv_projectcon.id", QCP.equals, Long.valueOf(salecon))});
                    if (purchaseCons.size() > 0) {
                        whereFilter = String.format("%s and tpv_fid in (%s)", whereFilter, String.join(",", RptUtil.getBaseDataPkIdStrList(purchaseCons)));
                    } else {
                        return;
                    }
                }
            }
        }
        // 品名
//        DynamicObject tpv_prodname_f = dataEntity.getDynamicObject("tpv_prodname_f");
//        if (YEM.isNotEmpty(tpv_prodname_f)) {
//            whereFilter = String.format("%s and tpv_prodname = %s", whereFilter, tpv_prodname_f.getPkValue());
//        }
        // 规格
        String tpv_specation_f = dataEntity.getString("tpv_specation_f");
        if (YEM.isNotEmpty(tpv_specation_f)) {
            whereFilter = String.format("%s and tpv_specation = '%s'", whereFilter, tpv_specation_f);
        }
        // 材质
        String tpv_shader_f = dataEntity.getString("tpv_shader_f");
        if (YEM.isNotEmpty(tpv_shader_f)) {
            whereFilter = String.format("%s and tpv_shader = '%s'", whereFilter, tpv_shader_f);
        }
        // 产地
        DynamicObject tpv_origin_f = dataEntity.getDynamicObject("tpv_origin_f");
        if (YEM.isNotEmpty(tpv_origin_f)) {
            whereFilter = String.format("%s and tpv_origin = %s", whereFilter, tpv_origin_f.getPkValue());
        }
        //配货单据为采购入库
        String mes = "im_purinbill";
        if (IM_PURINBILL.equals(picktype)) {
            Long tpv_supplier = toLong(parameter.getCustomParam("tpv_supplier"));
            whereFilter = String.format("%s and tpv_pickbill = '%s'", whereFilter, mes);
            whereFilter = String.format("%s and tpv_supplier = %s", whereFilter, tpv_supplier);
            saleId = 0L;
        }
        //LinRui begin
        Object tpvDepartment = parameter.getCustomParam("tpv_department");
        if (null != tpvDepartment) {
            Long tpv_department = toLong(parameter.getCustomParam("tpv_department"));
            if (tpv_department > 0l) {
                whereFilter = String.format("%s and tpv_department = %s", whereFilter, tpv_department);
            }
        }
        // 自定标签
        String tpv_customtags_f = dataEntity.getString("tpv_customtags_f");
        if (StringUtils.isNotEmpty(tpv_customtags_f)) {
            whereFilter = String.format("%s and tpv_customtags like %s", whereFilter, "'%" + tpv_customtags_f + "%'");
        }
        //LingRui end
        DataSet query = PickShipsRptQuery.query(whereFilter, picktype, saleId);

        IFormView parentView = view.getParentView();
        IDataModel parentModel = parentView.getModel();
        String subEnd = "A".equals(tpv_inventorytype_f) ? "_in" : "_zy";
        DynamicObjectCollection subEntry = new DynamicObjectCollection();
        if (TPV_DT_SALESSHIPPING.equals(picktype)) {
            DynamicObjectCollection tpvMaterialentry = parentModel.getEntryEntity("tpv_materialentry");
            for (DynamicObject dynamicObject : tpvMaterialentry) {
                long aLong = dynamicObject.getLong("id");
                if (aLong == saleId.longValue()) {
                    subEntry = dynamicObject.getDynamicObjectCollection("tpv_dt_salepick" + subEnd);
                }
            }
        } else if (TPV_DT_NOCONFIGURATION.equals(picktype)) {
            subEntry = parentModel.getEntryEntity("tpv_sonentryentity");
        } else if (TPV_DT_INVENTORYCONFIGURA.equals(picktype)) {
            int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_entryentity");
            DynamicObject entryRowEntity = parentModel.getEntryRowEntity("tpv_entryentity", entryCurrentRowIndex);
            String tpv_srcentryid = entryRowEntity.getString("tpv_srcentryid");
            long srcentryid = Long.parseLong(tpv_srcentryid);
            QFilter qFilter = new QFilter("tpv_materialentry", QCP.equals, srcentryid);
            String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
            DynamicObject billHead = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
            ;//需查询
            billHead = BusinessDataServiceHelper.loadSingle(billHead.getPkValue(),
                    billHead.getDynamicObjectType().getName());
            DynamicObject rowS = null;
            DynamicObjectCollection objectCollection = billHead.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject dynamicObject : objectCollection) {
                long id = (Long) dynamicObject.get("id");
                if (id == srcentryid) {
                    rowS = dynamicObject;
                }
            }
            subEntry = rowS.getDynamicObjectCollection("tpv_dt_salepick" + subEnd);
        } else if (TPV_DT_RELEVANCEDEALGS.equals(picktype)) {
            subEntry = parentModel.getEntryEntity("tpv_dt_transferdist_ph");
        } else if (TPV_DT_CONFIGURANEW.equals(picktype)) {
            subEntry = parentModel.getEntryEntity("tpv_sonentryentity");
        } else if (TPV_DT_PROCESS.equals(picktype)) {
            int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_materialentry");
            DynamicObject entryRowEntity = parentModel.getEntryRowEntity("tpv_materialentry", entryCurrentRowIndex);
            subEntry = entryRowEntity.getDynamicObjectCollection("tpv_pickinginformaentity");
        } else {
            subEntry = parentModel.getEntryEntity("billentry");
        }
        DynamicObjectType enrtyType = model.getEntryEntity(entryKey_1).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            String tpv_pickbill = row.getString("tpv_pickbill");
            long tpv_fentryid = row.getLong("tpv_fentryid");
            long tpv_vid = row.getLong("tpv_vid");
            int index = model.createNewEntryRow(entryKey_1);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
            if (IM_PURINBILL.equals(picktype) || TPV_DT_CONFIGURANEW.equals(picktype) || TPV_DT_NOCONFIGURATION.equals(picktype)) {
                continue;
            }
            for (DynamicObject subRow : subEntry) {
                if (TPV_DT_RELEVANCEDEALGS.equals(picktype)) {
                    //关联交易转货单拣配
                    if (tpv_pickbill.equals(subRow.getString("tpv_pickbill"))
                            && tpv_fentryid == subRow.getLong("tpv_fentryids")
                            && tpv_vid == subRow.getLong("tpv_vids")) {
                        model.beginInit();
                        model.setValue("tpv_focus", true, index);
                        model.endInit();
                        view.updateView("tpv_focus", index);
                        pickFocus(index, subRow.getBigDecimal("tpv_pickqty"), subRow.getBigDecimal("tpv_qtypacknum"));
                    }
                } else if (TPV_DT_PROCESS.equals(picktype)) {
                    //关联交易转货单拣配
                    if (tpv_pickbill.equals(subRow.getString("tpv_pickbill"))
                            && tpv_fentryid == subRow.getLong("tpv_orderfentryid")
                            && tpv_vid == subRow.getLong("tpv_ordervid")) {
                        model.beginInit();
                        model.setValue("tpv_focus", true, index);
                        model.endInit();
                        view.updateView("tpv_focus", index);
                        pickFocus(index, subRow.getBigDecimal("tpv_distributioncount"), subRow.getBigDecimal("tpv_packagingcount"));
                    }
                } else {
                    if (tpv_pickbill.equals(subRow.getString("tpv_pickbill" + subEnd))
                            && tpv_fentryid == subRow.getLong("tpv_fentryid" + subEnd)
                            && tpv_vid == subRow.getLong("tpv_vid" + subEnd)) {
                        model.beginInit();
                        model.setValue("tpv_focus", true, index);
                        model.endInit();
                        view.updateView("tpv_focus", index);
                        if (TPV_DT_INVENTORYCONFIGURA.equals(picktype) || TPV_DT_NOCONFIGURATION.equals(picktype)) {
                            pickFocus(index, subRow.getBigDecimal(TPV_DT_INVENTORYCONFIGURA.equals(picktype) ? "tpv_pickqty" + subEnd : "tpv_pickqty_in"),
                                    subRow.getBigDecimal(TPV_DT_INVENTORYCONFIGURA.equals(picktype) ? "tpv_packnum" + subEnd : "tpv_packnum_in"));
                        } else {
                            pickFocus(index, subRow.getBigDecimal(TPV_DT_SALESSHIPPING.equals(picktype) ? "tpv_pickqty" + subEnd : "qty"),
                                    subRow.getBigDecimal(TPV_DT_SALESSHIPPING.equals(picktype) ? "tpv_packnum" + subEnd : "tpv_packnum"));
                        }
                    }
                }
            }
        }
    }

    public Long toLong(Object longObj) {
        if (longObj == null) {
            return null;
        } else if (longObj instanceof Long) {
            return (Long) longObj;
        } else {
            return Long.valueOf(String.valueOf(longObj));
        }
    }

}
