package com.itopview.wm.dt.formplugin.dynamic;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;
import kd.bos.servicehelper.user.UserServiceHelper;
import org.apache.commons.lang3.StringUtils;

import java.util.Date;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * 动态表单（更新保险状态）回填销售合同
 */
public class SalescontractBacking extends AbstractBillPlugIn {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("btncancel", "btnok"); // 监听确认和取消按钮
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        // 获取被点击的控件对象
        Control source = (Control) evt.getSource();
        // 点击确认按钮
        if (StringUtils.equals(source.getKey(), "btnok")) {
            HashMap<String, Object> hashMap = new HashMap<>();
            // 如果被点击控件为确认，则获取页面相关控件值，组装数据传入returnData返回给父页面，最后关闭页面
            // 获取操作时间
            Date applyOrgs = (Date) this.getModel().getValue("tpv_updatetime");//更新保险操作时间(隐藏)
            // 获取保险状态操作人
            DynamicObject applyOrg = (DynamicObject) this.getModel().getValue("tpv_statusoperators");//保险状态操作人(隐藏)
            //获取保险状态
            String status = (String) this.getModel().getValue("tpv_insurancestatus");//保险状态

            if (applyOrg != null) {
                hashMap.put("tpv_statusoperators", applyOrg.getLong("id"));
            }
            if (applyOrgs != null) {
                hashMap.put("tpv_updatetime", applyOrgs);
            }
            if (status != null) {
                hashMap.put("tpv_insurancestatus", status);
            }
            this.getView().returnDataToParent(hashMap);
            this.getView().close();
        } else if (StringUtils.equals(source.getKey(), "tpv_cancel")) {
            // 被点击控件为取消则设置返回值为空并关闭页面（在页面关闭回调方法中必须验证返回值不为空，否则会报空指针）
            this.getView().returnDataToParent(null);
            this.getView().close();
        }
    }

    /**
     * 打开动态表单之后获取原单数据
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        // 打开动态表单
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = new HashMap<>();
        maps = showParameter.getCustomParams();
        Long applyorg = (Long) maps.get("tpv_statusoperators");//保险状态操作人(隐藏)
        String basedatafield = (String) maps.get("tpv_updatetime");//更新保险操作时间(隐藏)
        String insurancestatus = (String) maps.get("tpv_insurancestatus");//保险状态
        this.getModel().setValue("tpv_statusoperators", applyorg);
        this.getModel().setValue("tpv_updatetime", basedatafield);
        this.getModel().setValue("tpv_insurancestatus", insurancestatus);
    }
}
