package com.itopview.wm.dt.formplugin.dynamic;

import kd.bos.ais.model.action.ShowBillFormParam;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.newdevportal.domaindefine.sample.operation.ShowF7Parameter;
import kd.bos.servicehelper.user.UserServiceHelper;
import org.apache.commons.lang3.StringUtils;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * 销售合同 打开动态表单（更新保险状态按钮）
 */
public class SalescontractFormPlugin extends AbstractBillPlugIn {

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();
        if (StringUtils.equals("tpv_updatestatus", key)) {  //更新保险状态按钮
            // 创建弹出动态表单页面对象
            FormShowParameter showParameter = new FormShowParameter();

            // 设置弹出页面的标识
            showParameter.setFormId("tpv_salebackfillng"); //更新保险状态

            Map<String, Object> map = this.showInfoForm();

            // 存入获取到的动态表单数据
            showParameter.setCustomParams(map);
            // 状态
            showParameter.setStatus(OperationStatus.ADDNEW);
            // 设置页面关闭回调方法
            // CloseCallBack参数：回调插件，回调标识
            showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_updatestatus"));
            // 设置弹出页面打开方式
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            // 打开动态表单
            this.getView().showForm(showParameter);
        }

    }

    /**
     * 动表单获取原单据字段
     */
    private Map<String, Object> showInfoForm() {
        // 获取单据体
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        // 创建集合保存需要获取的字段值
        Map<String, Object> map = new HashMap<>();
        // 获取预计走访人
//        DynamicObject applier = dataEntity.getDynamicObject("tpv_statusoperators");//保险状态操作人(隐藏)

        DynamicObject appliers = dataEntity.getDynamicObject("tpv_operator");//tpv_operator

        Date applyOrg = dataEntity.getDate("tpv_updatetime");//更新保险操作时间(隐藏)

        String status = dataEntity.getString("tpv_insurancestatus");//保险状态

        if (applyOrg != null) {
            map.put("tpv_updatetime", applyOrg);
        }
        if (status != null) {
            map.put("tpv_insurancestatus", status);
        }

        if (appliers != null) {
            long userID = UserServiceHelper.getCurrentUserId();
            map.put("tpv_statusoperators", userID);
        }
        return map;
    }

    /**
     * 动态表单回填单据字段
     */
    private void setInwardInfo(Map<String, Object> values) {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        model.setValue("tpv_statusoperators", values.get("tpv_statusoperators"));//保险状态操作人(隐藏)
        // 回填动态表单的预计走访时间
        model.setValue("tpv_updatetime", values.get("tpv_updatetime"));
        model.setValue("tpv_insurancestatus", values.get("tpv_insurancestatus"));
        this.getView().invokeOperation("save");
    }

    /**
     * 动态表单关闭回调事件
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        // super.closedCallBack(closedCallBackEvent);
        Object returnData = closedCallBackEvent.getReturnData();
        // 判断标识是否匹配，并验证返回值不为空，不验证返回值可能会报空指针
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_updatestatus")
                && null != closedCallBackEvent.getReturnData()) {
            // 这里返回对象为Object，可强转成相应的其他类型，
            // 单条数据可用String类型传输，返回多条数据可放入map中，也可使用json等方式传输
            if (returnData instanceof HashMap){
                HashMap<String, Object> values = (HashMap<String, Object>) returnData;
                this.setInwardInfo(values);
            }
        }
    }
}
