package com.itopview.wm.dt.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.field.ComboEdit;
import kd.bos.form.field.ComboItem;

import java.util.*;

/**
 * @Description 供应商协议视图 新增赋默认值
 * @Author LinRui
 * Date 2023/8/17 12:44
 **/
public class AgreementPusFormPlugin extends AbstractBillPlugIn {
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        IDataModel model = this.getModel();
        OperationStatus status = this.getView().getFormShowParameter().getStatus();
        if(OperationStatus.ADDNEW == status){
            this.getModel().setValue("tpv_asstacttype","0"); //往来类型为 供应商
            //this.getView().setEnable(false,"单据体标识","字段标识");  //锁定分录字段
            this.getView().setEnable(false,"tpv_asstacttype");  //锁定字段
        }
        //设置下拉列表显示标题
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("采购年协", "A");
        map.put("采购月协", "C");
        fillEntityCombo(map);
    }

    /**
     * @param map 下拉项值
     */
    private void fillEntityCombo(Map<String, Object> map) {
        ComboEdit mainentry = (ComboEdit) this.getView().getControl("tpv_protocoltype"); //协议类型
        if (map.size() > 0) {
            List<ComboItem> entryItems = this.buildEntryComboItems(map);
            mainentry.setComboItems(entryItems);
        } else {
            mainentry.setComboItems(null);
        }
    }

    /**
     * @param entitys
     * @return
     */
    private List<ComboItem> buildEntryComboItems(Map<String, Object> entitys) {
        ArrayList<ComboItem> entryItems = new ArrayList<>();
        ComboItem blankItem = new ComboItem();
        blankItem.setValue("");
        blankItem.setCaption(new LocaleString());
        entryItems.add(blankItem);
        if (null != entitys && entitys.size() > 0) {
            for (Map.Entry entry : entitys.entrySet()) {
                String mapKey = (String) entry.getKey();
                String mapValue = (String) entry.getValue();
                ComboItem entryItem = new ComboItem();
                entryItem.setValue(mapValue);
                entryItem.setCaption(new LocaleString(mapKey));
                entryItems.add(entryItem);
            }
        }
        return entryItems;
    }
}
