package com.itopview.wm.dt.formplugin.form;

import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;

import java.math.BigDecimal;
import java.util.Date;
import java.util.EventObject;

/**
 * @ClassName 分步调入单-表单插件
 * @Description TODO
 * @Author yhj
 * @Date 2023/10/28 17:06
 * @Version 1.0
 */
public class CalloutFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"tpv_tbmainentry", "tpv_advcontoolbarap1"});
        ((BasedataEdit) this.getControl("tpv_operator")).addBeforeF7SelectListener(this);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        this.getModel().setValue("dept",null);
    }

    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        String name = e.getEntryProp().getName();
        int i = 0;
        RowDataEntity[] rowdata = e.getRowDataEntities();
        for (RowDataEntity rdata : rowdata) {
            i = rdata.getRowIndex();
        }
        switch (name) {
            case "tpv_dt_transinbill_f"://费用分录
                BigDecimal tpv_billablequantitys=BigDecimal.ZERO;
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                DynamicObjectCollection tpv_materialentry=dataEntity.getDynamicObjectCollection("billentry");//商品分录
                for(DynamicObject materialentry:tpv_materialentry){
                   // BigDecimal tpv_qty=materialentry.getBigDecimal("qty");//数量
                    DynamicObjectCollection tpv_dt_freigroambill_f=materialentry.getDynamicObjectCollection("tpv_dt_transinbill_f");//费用分录
                    for(DynamicObject freigroambill_f:tpv_dt_freigroambill_f){
                        tpv_billablequantitys=tpv_billablequantitys.add(freigroambill_f.getBigDecimal("tpv_chargequantity"));//计费数量
                        //@Author LinRui begin
                        DynamicObject tpv_currency = freigroambill_f.getDynamicObject("tpv_reimbursement");  //结算币别
                        if (null != tpv_currency) {
                            Object tpv_exratetable = this.getModel().getValue("tpv_exratetable");
                            Object tpv_currencybase = this.getModel().getValue("settlescurrency"); //本位币
                            Date tpv_exratedate = (Date) this.getModel().getValue("tpv_exratedate");
                            BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
                            BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
                            BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
                            this.getModel().setValue("tpv_costrate", exchangeRate,i);
                        }
                        //@Author LinRui end
                    }
                   // this.getModel().setValue("tpv_chargequantity",tpv_qty.subtract(tpv_billablequantitys),i);
                }
                break;
            default:
                break;
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String key = e.getProperty().getName();
        switch (key) {
            case "tpv_reimbursement" :
                this.setExchangeRate();
                break;
            case "tpv_exratetable" :
            case "tpv_exratedate" :
            case "settlescurrency" :
                setSubEntryExchangeRate();
                break;
        }
    }

    /**
     * 汇率获取
     */
    private void setExchangeRate() {
        int index = this.getModel().getEntryCurrentRowIndex("tpv_reimbursement");
        Object tpv_exratetable = this.getModel().getValue("tpv_exratetable");
        Object tpv_currency = this.getModel().getValue("tpv_reimbursement",index);  //结算币别
        Object tpv_currencybase = this.getModel().getValue("settlescurrency"); //本位币
        Date tpv_exratedate = (Date) this.getModel().getValue("tpv_exratedate");
        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
        BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
        this.getModel().setValue("tpv_costrate", exchangeRate,index);
    }

    private void setSubEntryExchangeRate() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection billentry = dataEntity.getDynamicObjectCollection("billentry");
        if (billentry.size() > 0) {
            for (int i = 0; i < billentry.size(); i++) {
                DynamicObject dynamicObject = billentry.get(i);
                DynamicObjectCollection tpvDtPurinbillF = dynamicObject.getDynamicObjectCollection("tpv_dt_transinbill_f");
                if (tpvDtPurinbillF.size() > 0) {
                    this.getModel().setEntryCurrentRowIndex("billentry",i);
                    for (int i1 = 0; i1 < tpvDtPurinbillF.size(); i1++) {
                        DynamicObject object = tpvDtPurinbillF.get(i1);
                        DynamicObject tpv_currency = object.getDynamicObject("tpv_reimbursement");
                        if (null != tpv_currency) {
                            Object tpv_exratetable = this.getModel().getValue("tpv_exratetable");
                            Object tpv_currencybase = this.getModel().getValue("settlescurrency"); //本位币
                            Date tpv_exratedate = (Date) this.getModel().getValue("tpv_exratedate");
                            BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
                            BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
                            BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
                            this.getModel().setValue("tpv_costrate", exchangeRate,i1);
                        }
                    }
                }
            }
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        switch (itemKey) {
            case "tpv_bulkentrybutton": //客户额度使用情况查询
                showInfoForm(this.getView());
                break;
            default:
                break;
        }
    }
    /**
     * 设置打开批量录入金额动态表单
     */
    private void showInfoForm(IFormView view) {
        // 获取单据体
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId("tpv_bulkentryexpenses");
        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_bulkentrybutton"));
        view.showForm(showParameter);
    }

    /**
     * @param e 回调，接收子页面传来的值。
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        switch (actionId) {
            case "tpv_bulkentrybutton":
                DynamicObjectCollection data = (DynamicObjectCollection) returnData;
                setValue(data);
                break;
            case "tpv_operator":
                operatorCallBack(e);
                break;
            default:
                break;
        }
    }

    private void setValue(DynamicObjectCollection data) {
        if (data != null && data.size() > 0) {
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("billentry");//商品明细分录
            for (int i = 0; materialentry.size() > i; i++) {
                DynamicObject dynamicObject = materialentry.get(i);
                BigDecimal tpvQty = dynamicObject.getBigDecimal("qty");
                DynamicObjectCollection dynamicObjects = dynamicObject.getDynamicObjectCollection("tpv_dt_transinbill_f");
                for (DynamicObject freigroambill : data) {
                    DynamicObject addNewDy = dynamicObjects.addNew();
                    addNewDy.set("tpv_costitem",freigroambill.getDynamicObject("tpv_expenseitems"));
                    addNewDy.set("tpv_supplier",freigroambill.getDynamicObject("tpv_supplierf"));
                    addNewDy.set("tpv_reimbursement",freigroambill.getDynamicObject("tpv_costcurrencys"));
                    addNewDy.set("tpv_chargequantity",tpvQty);
                    addNewDy.set("tpv_univalence",freigroambill.getBigDecimal("tpv_unitprices"));
                    BigDecimal tpvMoneys= tpvQty.multiply(freigroambill.getBigDecimal("tpv_unitprices"));
                    addNewDy.set("tpv_amt",tpvMoneys.setScale(2, BigDecimal.ROUND_HALF_UP));
                    addNewDy.set("tpv_taxrate",freigroambill.getBigDecimal("tpv_taxrates"));
                    addNewDy.set("tpv_desc",freigroambill.getString("tpv_comments"));
                    DynamicObject tpv_currency = freigroambill.getDynamicObject("tpv_costcurrencys");
                    if (YEM.isNotEmpty(tpv_currency)) {
                        Object tpv_exratetable = this.getModel().getValue("tpv_exratetable");
                        Object tpv_currencybase = this.getModel().getValue("settlescurrency"); //本位币
                        Date tpv_exratedate = (Date) this.getModel().getValue("tpv_exratedate");
                        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
                        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
                        BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
                        addNewDy.set("tpv_costrate",exchangeRate);
                    }
                }
            }
            this.getView().updateView("tpv_dt_transinbill_f");
        }
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_operator":
                operatorF7(e, name);
                break;
            default:
                break;
        }
    }

    private void operatorF7(BeforeF7SelectEvent e, String key) {
        FormShowParameter showParameter = e.getFormShowParameter();
        CloseCallBack closeCallBack = new CloseCallBack(this, key);
        showParameter.setCloseCallBack(closeCallBack);
    }

    private void operatorCallBack(ClosedCallBackEvent e) {
        IDataModel model = this.getModel();
        ListSelectedRowCollection selectedRows = (ListSelectedRowCollection) e.getReturnData();
        if(selectedRows != null && selectedRows.size() > 0){
            ListSelectedRow selectedRow = selectedRows.get(0);
            long userId = (long) selectedRow.getPrimaryKeyValue();//人员id
            long userEntryId = (long) selectedRow.getEntryPrimaryKeyValue();//部门分录id
            model.beginInit();
            model.setValue("tpv_operator", userId);
            DynamicObjectCollection entry = getUserDepts(userId);
            for (DynamicObject row : entry) {
                if(userEntryId == row.getLong("id")){
                    model.setValue("dept", row.get("org"));
                }
            }
            model.endInit();
            this.getView().updateView("tpv_operator");
            this.getView().updateView("dept");
        }
    }

    private static DynamicObjectCollection getUserDepts(long userId) {
        QFilter qFilter = new QFilter("user", QCP.equals, userId);
//        qFilter.and(new QFilter("org.orgpattern.number", QCP.equals, "Orgform06"));
        return QueryServiceHelper.query("bos_userposition", "id,org", qFilter.toArray());
    }
}
