package com.itopview.wm.dt.formplugin.form;

import com.alibaba.nacos.common.utils.StringUtils;
import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.Toolbar;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.EventObject;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 费用发票
 * @author LiuHB
 * @version 1.0
 */
public class CostbillmatFormPlugin extends AbstractBillPlugIn {
    private final static String KEY_MBAR = "tbmain";
    private static BigDecimal taxnoinclamt = BigDecimal.ZERO;
    private static BigDecimal vatamt = BigDecimal.ZERO;
    private static BigDecimal rate = BigDecimal.ZERO;
    private static BigDecimal taxinclamt = BigDecimal.ZERO;

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        Toolbar ambar = this.getView().getControl(KEY_MBAR); //toobar工具栏
        Toolbar bmbar = this.getView().getControl("tpv_advcontoolbarap2"); //toobar工具栏
        Toolbar cmbar = this.getView().getControl("tpv_advcontoolbarap3"); //toobar工具栏
        ambar.addItemClickListener(this);    //检测点击事件
        bmbar.addItemClickListener(this);
        cmbar.addItemClickListener(this);

    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey();
        switch (itemKey) {
            case "tpv_matchinvoicebtn"://匹配发票
                matchInvoice("tpv_dt_matchbill", "invoce", true);
                break;
            case "tpv_matedegression"://匹配成本
                FormShowParameter showParameter = new FormShowParameter();
                showParameter.setStatus(OperationStatus.ADDNEW);
                showParameter.getOpenStyle().setShowType(ShowType.Modal);
                showParameter.setFormId("tpv_dt_matccost");
                Map<String, Object> cos = this.costapproach();
                showParameter.setCustomParams(cos);
                showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_matedegression"));
                this.getView().showForm(showParameter);
                break;
            case "tpv_matestorage"://匹配入库
                FormShowParameter showParameters = new FormShowParameter();
                showParameters.setStatus(OperationStatus.ADDNEW);
                showParameters.getOpenStyle().setShowType(ShowType.Modal);
                showParameters.setFormId("tpv_dt_matcentry");
                Map<String, Object> maps = this.journalizing();
                showParameters.setCustomParams(maps);
                showParameters.setCloseCallBack(new CloseCallBack(this, "tpv_matestorage"));
                this.getView().showForm(showParameters);
                break;
            case "tpv_baritemap"://分摊含税
                FormShowParameter showParameterz = new FormShowParameter();
                showParameterz.setStatus(OperationStatus.ADDNEW);
                showParameterz.getOpenStyle().setShowType(ShowType.Modal);
                showParameterz.setFormId("tpv_dt_entertaxinc");
                Map<String, Object> map = this.showInfoForm();
                showParameterz.setCustomParams(map);
                showParameterz.setCloseCallBack(new CloseCallBack(this, "tpv_baritemap"));
                this.getView().showForm(showParameterz);
                break;
        }
    }

    /**
     * @Title: matchInvoice
     * @Description: 匹配发票信息
     * @param:
     * @return: a
     */
    private void matchInvoice(String name, String actionID, boolean b) {
        //创建动态表达页面对象
        FormShowParameter showParameter = new FormShowParameter();
        //设置页面ID
        showParameter.setFormId(name);
        //状态
        showParameter.setStatus(OperationStatus.ADDNEW);
        //传参
        showParameter.setCustomParams(setInfo(b));
        //设置回调
        showParameter.setCloseCallBack(new CloseCallBack(this, actionID));
        // 设置弹出页面打开方式
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        // 打开动态表单
        this.getView().showForm(showParameter);

    }

    /**
     * @Title: setInfo
     * @Description:
     * @param:
     * @return: a
     */
    private Map<String, Object> setInfo(boolean b) {
        HashMap<String, Object> map = new HashMap<>();
        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_invoiceinfoentry");
        String sourceId = "";
        for (DynamicObject object : entity) {
            sourceId += object.getString("tpv_sourceid") + ",";
        }
        map.put("sourceID", sourceId);
        map.put("supplier", this.getModel().getValue("tpv_billunit"));
        if (b) {
            DynamicObjectCollection invoiceinfoentry = this.getModel().getEntryEntity("tpv_invoiceinfoentry");
            map.put("invoiceEntry", invoiceinfoentry);
        }
        return map;
    }

    /**
     * 动态表单回填单据字段
     */
    //分摊含税
    private void setInwardInfoc(Map<String, Object> values) {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        taxinclamt = (BigDecimal) values.get("tpv_taxinclamt");
        rate = (BigDecimal) values.get("tpv_rate");
        taxnoinclamt = (BigDecimal) values.get("tpv_taxnoinclamt");
        vatamt = (BigDecimal) values.get("tpv_vatamt");
        sumtotal();
    }

    //匹配入库
    private void setInwardInfob(List<Map<String, Object>> value) {//入库
        IDataModel model = this.getModel();
        model.deleteEntryData("tpv_matecost");//清空分录
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        for (Map<String, Object> values : value) {
            DynamicObjectCollection tpvMatecost = this.getModel().getEntryEntity("tpv_matecost");
            int rowIndex = this.getModel().createNewEntryRow("tpv_matecost");
            this.getModel().setValue("tpv_matchtype", "A", rowIndex);
            this.getModel().setValue("tpv_taxmatamt", values.get("tpv_taxmatamt"), rowIndex);
            this.getModel().setValue("tpv_rated", values.get("tpv_rate"), rowIndex);
            this.getModel().setValue("tpv_taxnomatamt", values.get("tpv_taxnomatamt"), rowIndex);
            this.getModel().setValue("tpv_vatnomatamt", values.get("tpv_vatnomatamt"), rowIndex);
            this.getModel().setValue("tpv_departmet", values.get("tpv_departmet"), rowIndex);//部门
            this.getModel().setValue("tpv_purchnumd", values.get("tpv_purchnumd"), rowIndex);//采购合同号
            this.getModel().setValue("tpv_inbordnum", values.get("tpv_inbordnum"), rowIndex);//入库单号
            this.getModel().setValue("tpv_vendors", values.get("tpv_vendors"), rowIndex);//供应商
            this.getModel().setValue("tpv_itemcode", values.get("tpv_itemcode"), rowIndex);//物料编码
//       this.getModel().setValueue("tpv_itemname",values.get("tpv_itemname"),rowIndex);//物料名称
            this.getModel().setValue("tpv_conprodname", values.get("tpv_conprodname"), rowIndex);//品名
            this.getModel().setValue("tpv_conshader", values.get("tpv_conshader"), rowIndex);//材质
            this.getModel().setValue("tpv_conorigin", values.get("tpv_conorigin"), rowIndex);//产地
            this.getModel().setValue("tpv_conspecation", values.get("tpv_conspecation"), rowIndex);//规格
            this.getModel().setValue("tpv_conqty", values.get("tpv_conqty"), rowIndex);//数量
            this.getModel().setValue("tpv_contractamo", values.get("tpv_contractamo"), rowIndex);//金额
            this.getModel().setValue("tpv_currency", values.get("tpv_currency"), rowIndex);//币别
            this.getModel().setValue("tpv_exraterate", values.get("tpv_exraterate"), rowIndex);//汇率表
            this.getModel().setValue("tpv_exchangerate", values.get("tpv_exchangerate"), rowIndex);//汇率
            this.getModel().setValue("tpv_inboentid", values.get("tpv_inboentid"), rowIndex);//入库分录id
        }
    }

    //匹配成本
    private void setInwardInfoa(List<Map<String, Object>> value) {//成本
        IDataModel model = this.getModel();
        model.deleteEntryData("tpv_matecost");//清空分录
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        for (Map<String, Object> values : value) {
            DynamicObjectCollection tpvMatecost = this.getModel().getEntryEntity("tpv_matecost");
            int rowIndex = this.getModel().createNewEntryRow("tpv_matecost");
            this.getModel().setValue("tpv_matchtype", "A", rowIndex);
            this.getModel().setValue("tpv_taxmatamt", values.get("tpv_taxmatamt"), rowIndex);
            this.getModel().setValue("tpv_rated", values.get("tpv_rate"), rowIndex);
            this.getModel().setValue("tpv_taxnomatamt", values.get("tpv_taxnomatamt"), rowIndex);
            this.getModel().setValue("tpv_vatnomatamt", values.get("tpv_vatnomatamt"), rowIndex);
            this.getModel().setValue("tpv_department", values.get("tpv_department"), rowIndex);//部门
            this.getModel().setValue("tpv_purchnumd", values.get("tpv_purchnumd"), rowIndex);//采购合同号
            this.getModel().setValue("tpv_inbordnum", values.get("tpv_inbordnum"), rowIndex);//入库单号
            this.getModel().setValue("tpv_vendors", values.get("tpv_vendors"), rowIndex);//供应商
            this.getModel().setValue("tpv_itemcode", values.get("tpv_itemcode"), rowIndex);//物料编码
//       this.getModel().setValueue("tpv_itemname",values.get("tpv_itemname"),rowIndex);//物料名称
            this.getModel().setValue("tpv_conprodname", values.get("tpv_conprodname"), rowIndex);//品名
            this.getModel().setValue("tpv_conshader", values.get("tpv_conshader"), rowIndex);//材质
            this.getModel().setValue("tpv_conorigin", values.get("tpv_conorigin"), rowIndex);//产地
            this.getModel().setValue("tpv_conspecation", values.get("tpv_conspecation"), rowIndex);//规格
            this.getModel().setValue("tpv_conqty", values.get("tpv_conqty"), rowIndex);//数量
            this.getModel().setValue("tpv_contractamo", values.get("tpv_contractamo"), rowIndex);//金额
            this.getModel().setValue("tpv_currency", values.get("tpv_currency"), rowIndex);//币别
//            this.getModel().setValue("tpv_exraterate",values.get("tpv_exraterate"),rowIndex);//汇率表
//            this.getModel().setValue("tpv_exchangerate",values.get("tpv_exchangerate"),rowIndex);//汇率
            this.getModel().setValue("tpv_inboentid", values.get("tpv_inboentid"), rowIndex);//入库分录id
            this.getModel().setValue("tpv_costbreaid", values.get("tpv_cosbreakid"), rowIndex);//成本明细分录id
//            this.getModel().setValue("");

        }
    }

    /**
     * 动态表单关闭回调事件
     */

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
        Object returnData = closedCallBackEvent.getReturnData();
        // 判断标识是否匹配，并验证动态表单返回数据不为空，不验证返回值可能会报空指针
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_baritemap")
                && null != closedCallBackEvent.getReturnData()) {
            // 这里返回对象为Object，可强转成相应的其他类型，
            HashMap<String, Object> values = (HashMap<String, Object>) returnData;
            this.setInwardInfoc(values);
            return;
        }
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_matestorage")
                && null != closedCallBackEvent.getReturnData()) {
            // 这里返回对象为Object，可强转成相应的其他类型，
            List<Map<String, Object>> value = (List<Map<String, Object>>) returnData;
            this.setInwardInfob(value);
            return;
        }
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_matedegression")
                && null != closedCallBackEvent.getReturnData()) {
            // 这里返回对象为Object，可强转成相应的其他类型，
            List<Map<String, Object>> value = (List<Map<String, Object>>) returnData;
            this.setInwardInfoa(value);
            return;
        }
        HashMap<String, DynamicObjectCollection> returnDatas = (HashMap<String, DynamicObjectCollection>) closedCallBackEvent.getReturnData();
        if (com.alibaba.druid.util.StringUtils.equals(closedCallBackEvent.getActionId(), "invoce") && (returnDatas != null && returnDatas.get("cols").size() > 0)) {
            invoice(returnDatas);
        }


    }

    private void invoice(HashMap<String, DynamicObjectCollection> data) {
        this.getModel().getDataEntity(true);
        DynamicObjectCollection collection = this.getModel().getEntryEntity("tpv_invoiceinfoentry");
        DataEntityPropertyCollection properties = collection.getDynamicObjectType().getProperties();
        DynamicObjectCollection collections = data.get("cols");
        DataEntityPropertyCollection selectedProperties = collections.getDynamicObjectType().getProperties();
        this.getModel().deleteEntryData("tpv_invoiceinfoentry");
        int[] ints = this.getModel().batchCreateNewEntryRow("tpv_invoiceinfoentry", collections.size());
        for (int i = 0; i < collections.size(); i++) {
            DynamicObject row = collections.get(i);
            for (IDataEntityProperty property : selectedProperties) {
                String proKey = property.getName();
                String subKey = subKey(proKey);
                if ("tpv_taxrate".equals(proKey)) {
                    this.getModel().setValue(proKey, row.get(proKey), ints[i]);
                }
                if (properties.containsKey(subKey)) {
                    this.getModel().setValue(subKey, row.get(proKey), ints[i]);
                }
            }
        }
        this.getView().updateView("tpv_invoiceinfoentry");
    }

    /**
     * @Title: subKey
     * @Description:
     * @param: 截取字符串
     * @return: a
     */
    private String subKey(String proKey) {
        if (null != proKey && proKey.length() > 0) {
            return proKey.substring(0, proKey.length() - 1);
        } else {
            return "";
        }
    }

    /**
     * 单据值更新
     *
     * @param e
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String propertyName = e.getProperty().getName();
        String departmentid = "";
        String supplierid = "";
        String customerid = "";
        BigDecimal taxinclamt = (BigDecimal) this.getModel().getValue("tpv_amtatch");//含税金额
        BigDecimal rate = (BigDecimal) this.getModel().getValue("tpv_ratea");//税率%
        Boolean finetaxamt = (Boolean) this.getModel().getValue("tpv_taxfinetuning");//税额微调
        if ("tpv_purconum".equals(propertyName)) {

            DynamicObject tpvPurconum = (DynamicObject) this.getModel().getValue("tpv_purconum");
            String id = tpvPurconum.getString("tpv_name");
            String selectfields = DynamicObjectUtil.getSelectfields("tpv_bd_purcontrnum", false);
            QFilter qFilter = new QFilter("tpv_name", QCP.equals, id);
            DynamicObject[] load = BusinessDataServiceHelper.load("tpv_bd_purcontrnum", selectfields, qFilter.toArray());
            for (DynamicObject dynamicObject : load) {
                DynamicObject department = dynamicObject.getDynamicObject("tpv_department");
                DynamicObject supplier = dynamicObject.getDynamicObject("tpv_supplier");
                if (department != null) {
                    departmentid = department.getString("id");
                }
                if (supplier != null) {
                    supplierid = supplier.getString("id");
                }
                this.getModel().setValue("tpv_departme", departmentid);
                this.getModel().setValue("tpv_vendor", supplierid);
            }
        }
        if ("tpv_saleconum".equals(propertyName)) {

            String selectfields = DynamicObjectUtil.getSelectfields("tpv_bd_salescontract", false);
            QFilter qFilter = new QFilter("billno", QCP.equals, "tpv_saleconum");
            DynamicObject[] load = BusinessDataServiceHelper.load("tpv_bd_salescontract", selectfields, null);
            for (DynamicObject dynamicObject : load) {
                DynamicObject department = dynamicObject.getDynamicObject("tpv_department");
                DynamicObject customer = dynamicObject.getDynamicObject("tpv_customer");
                if (department != null) {
                    departmentid = department.getString("id");
                }
                if (customer != null) {
                    customerid = customer.getString("id");
                }
                this.getModel().setValue("tpv_departme", departmentid);
                this.getModel().setValue("tpv_client", customerid);
            }
        }
        if ("tpv_natfees".equals(propertyName)) {
            String natfees = (String) this.getModel().getValue("tpv_natfees");
            if ("B".equals(natfees)) {
                int index = this.getModel().getEntryCurrentRowIndex("tpv_pactmessage");

                this.getView().setEnable(true, index, "tpv_invotitle");
            }
            if ("A".equals(natfees) || "C".equals(natfees)) {
                int index = this.getModel().getEntryCurrentRowIndex("tpv_pactmessage");
                this.getModel().setValue("tpv_invotitle", "A");
                this.getView().setEnable(false, index, "tpv_invotitle");
            }
        }
        if ("tpv_taxfinetun".equals(propertyName) || "tpv_vatnomatamt".equals(propertyName)) {
            int index = this.getModel().getEntryCurrentRowIndex("tpv_matecost");
            this.getView().setEnable(true, index, "tpv_vatnomatamt");
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection matecost = dataEntity.getDynamicObjectCollection("tpv_matecost");
            for (DynamicObject dynamicObject : matecost) {
                BigDecimal tpvTaxmatamt = dynamicObject.getBigDecimal("tpv_taxmatamt");
                BigDecimal tpvVatnomatamt = dynamicObject.getBigDecimal("tpv_vatnomatamt");
                BigDecimal subtract = tpvTaxmatamt.subtract(tpvVatnomatamt);
                this.getModel().setValue("tpv_taxnomatamt", subtract);
            }

        }
        if ("tpv_taxmatamt".equals(propertyName) || "tpv_vatnomatamt".equals(propertyName) || "tpv_taxnomatamt".equals(propertyName)) {
            DynamicObjectCollection entrys = this.getModel().getEntryEntity("tpv_matecost");
            BigDecimal taxmatamt = BigDecimal.ZERO;
            BigDecimal vatnomatamt = BigDecimal.ZERO;
            BigDecimal taxnomatamt = BigDecimal.ZERO;
            for (DynamicObject entry : entrys) {
                taxmatamt.add(entry.getBigDecimal("tpv_taxmatamt"));
                vatnomatamt.add(entry.getBigDecimal("tpv_vatnomatamt"));
                taxnomatamt.add(entry.getBigDecimal("tpv_taxnomatamt"));
            }

        }
        //合同明细分录
        if ("tpv_amtatch".equals(propertyName) || "tpv_ratea".equals(propertyName) || "tpv_vatmatamt".equals(propertyName)) {
            if (taxinclamt.compareTo(BigDecimal.ZERO) == 0 || rate.compareTo(BigDecimal.ZERO) == 0) {
                return;
            } else {
                if (finetaxamt.equals(false)) {
                    int i = 100;
                    int b = 1;
                    BigDecimal bigDecimalb = new BigDecimal(b);
                    BigDecimal bigDecimali = new BigDecimal(i);
                    BigDecimal divide = rate.divide(bigDecimali);//【税率】/100
                    BigDecimal add = divide.add(bigDecimalb);//（1+【税率】/100)
                    BigDecimal divide1 = taxinclamt.divide(add, 11, BigDecimal.ROUND_HALF_UP);//【含税金额】/（1+【税率】/100）
                    BigDecimal vatamt = divide1.multiply(divide);//增值税额
                    vatamt = vatamt.setScale(2, BigDecimal.ROUND_HALF_UP);
                    BigDecimal taxnoinclamts = taxinclamt.subtract(vatamt);//不含税金额
                    this.getModel().setValue("tpv_vatmatamt", vatamt);
                    this.getModel().setValue("tpv_vatamtmatch", taxnoinclamts);
                } else {
                    BigDecimal vatamt = (BigDecimal) this.getModel().getValue("tpv_vatmatamt");
                    BigDecimal taxnoinclamts = taxinclamt.subtract(vatamt);//不含税金额
                    this.getModel().setValue("tpv_vatamtmatch", taxnoinclamts);
                }
            }

        }
    }

    //向分摊弹框传值
    private Map<String, Object> showInfoForm() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Map<String, Object> map = new HashMap<>();
        boolean tpvTaxfinetun = dataEntity.getBoolean("tpv_taxfinetun");
        map.put("tpv_taxfinetun", tpvTaxfinetun);
        return map;
    }

    //向匹配入库弹框传值
    public Map<String, Object> journalizing() {
        Map<String, Object> map = new HashMap<>();
        DynamicObject billunit = null;
        long billunitid = 0L;
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        billunit = dataEntity.getDynamicObject("tpv_billunit");
        if (billunit != null) {
            billunitid = billunit.getLong("id");
            map.put("tpv_billunit", billunitid);
            DynamicObjectCollection tpvMatecost = dataEntity.getDynamicObjectCollection("tpv_matecost");
            for (DynamicObject dynamicObject : tpvMatecost) {

                String tpvInbordnum = dynamicObject.getString("tpv_inbordnum");
                map.put(tpvInbordnum, dynamicObject);
            }
            return map;
        }
        this.getView().showTipNotification("请选择开票单位");
        DynamicObjectCollection tpvMatecost = dataEntity.getDynamicObjectCollection("tpv_matecost");
        for (DynamicObject dynamicObject : tpvMatecost) {

            String tpvInbordnum = dynamicObject.getString("tpv_inbordnum");
            map.put(tpvInbordnum, dynamicObject);
        }
        return map;

    }

    //向匹配成本弹框传值
    public Map<String, Object> costapproach() {
        Map<String, Object> map = new HashMap<>();
        DynamicObject billunit = null;
        long billunitid = 0L;
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        billunit = dataEntity.getDynamicObject("tpv_billunit");
        if (billunit != null) {
            billunitid = billunit.getLong("id");
            map.put("tpv_billunit", billunitid);
            DynamicObjectCollection tpvMatecost = dataEntity.getDynamicObjectCollection("tpv_matecost");
            for (DynamicObject dynamicObject : tpvMatecost) {

                String tpvInbordnum = dynamicObject.getString("tpv_inbordnum");
                map.put(tpvInbordnum, dynamicObject);
            }
            return map;
        }
        this.getView().showTipNotification("请选择开票单位");
        DynamicObjectCollection tpvMatecost = dataEntity.getDynamicObjectCollection("tpv_matecost");
        for (DynamicObject dynamicObject : tpvMatecost) {

            String tpvInbordnum = dynamicObject.getString("tpv_inbordnum");
            map.put(tpvInbordnum, dynamicObject);
        }
        return map;
    }

    /**
     * 分摊含税金额
     */
    private void sumtotal() {
        BigDecimal tpvDecimall = (BigDecimal) this.getModel().getValue("tpv_decimall");
        DynamicObjectCollection tpvMatecost = this.getModel().getEntryEntity("tpv_matecost");
        BigDecimal tpvConqty = BigDecimal.ZERO;
        BigDecimal taxmatamt = BigDecimal.ZERO;
        BigDecimal vatnomatamt = BigDecimal.ZERO;
        BigDecimal taxnomatamt = BigDecimal.ZERO;
        for (int i = 0; i < tpvMatecost.size(); i++) {
            if (i == tpvMatecost.size() - 1) {
                this.getModel().setValue("tpv_taxmatamt", taxinclamt.subtract(tpvConqty), i);
                this.getModel().setValue("tpv_vatnomatamt", vatamt.subtract(vatnomatamt), i);
                this.getModel().setValue("tpv_taxnomatamt", taxnoinclamt.subtract(taxnomatamt), i);
            }
            tpvConqty = (BigDecimal) this.getModel().getValue("tpv_conqty", i);
            BigDecimal divide = tpvConqty.divide(tpvDecimall, 10, BigDecimal.ROUND_HALF_DOWN);
            BigDecimal taxmatamts = divide.multiply(taxinclamt);
            BigDecimal taxnomatamts = divide.multiply(taxnoinclamt);
            BigDecimal vatnomatamts = divide.multiply(vatamt);
            this.getModel().setValue("tpv_taxmatamt", taxmatamts, i);
            this.getModel().setValue("tpv_vatnomatamt", vatnomatamts, i);
            this.getModel().setValue("tpv_taxnomatamt", taxnomatamts, i);
            taxmatamt = taxmatamt.add(taxmatamts);
            taxnomatamt = taxnomatamt.add(taxnomatamts);
            vatnomatamt = vatnomatamt.add(vatnomatamts);
        }
    }


}
