package com.itopview.wm.dt.formplugin.form;

import com.itopview.wm.dt.report.DomSettcRptQuery;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.BeforeDeleteRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.IFormView;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.scm.common.util.DynamicObjectUtil;

import java.math.BigDecimal;
import java.util.*;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * @author GX
 * 内贸结算单（客户）-表单插件
 */
public class DomSettcFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        for (int i = 0; i < 3; i++) {
            this.getView().setEnable(false, i, "tpv_project");//项目
            this.getModel().setValue("tpv_sources", "A", i);
            this.getView().setEnable(false, i, "tpv_sources");//来源
            this.getView().setEnable(false, i, "tpv_amounts");//金额
            this.getView().setEnable(false, i, "tpv_remark");//备注
        }
        String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_bd_settlitems", false);// 获取单据头所有字段标识
        DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_bd_settlitems", selectFieid2, new QFilter[]{});
        for (DynamicObject bill : bills) {
            Long id = bill.getLong("id");
            String name = bill.getString("name");
            if ("货款".equals(name)) {
                this.getModel().setValue("tpv_project", id, 0);
            }
            if ("费用".equals(name)) {
                this.getModel().setValue("tpv_project", id, 1);
            }
            if ("计息".equals(name)) {
                this.getModel().setValue("tpv_project", id, 2);
            }
        }
    }


    /**
     * @param e 删除行事件
     */
    @Override
    public void beforeDeleteRow(BeforeDeleteRowEventArgs e) {
        super.beforeDeleteRow(e);
        String name = e.getEntryProp().getName();
        int[] row = e.getRowIndexs();
        switch (name) {
            case "tpv_dt_settdc_m"://总结分录
                for (int i : row) {
                    if (i < 3) {
                        e.setCancel(true);
                        this.getView().showErrorNotification("总结分录前3行不能删除，请重新选择！");
                    }
                }
                break;
            default:
                break;
        }
    }

    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        String name = e.getEntryProp().getName();
        int i = 0;
        RowDataEntity[] rowdata = e.getRowDataEntities();
        for (RowDataEntity rdata : rowdata) {
            i = rdata.getRowIndex();
        }
        switch (name) {
            case "tpv_dt_settdc_m"://总结分录
                this.getModel().setValue("tpv_sources", "B", i);
                this.getView().setEnable(false, i, "tpv_sources");//来源
                break;
            default:
                break;
        }
    }


    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        ChangeData cd = e.getChangeSet()[0];
        switch (name) {
            case "tpv_checkbox"://货款自动-开关
            case "tpv_checkbo": //费用自动开关
            case "tpv_checkboxs"://计息单-开关
            case "tpv_purchasecontracts"://销售合同号
                setData(dataEntity);
                break;
            case "tpv_invoicesnum"://开票数量
                limitInvoicesnum(dataEntity);//限制开票数量
                break;
            case "tpv_thisinvoicemount"://本次开票金额
            case "tpv_thisinvoicesnum"://本次开票数量
                limitthisinvoicemount(dataEntity);//限制本次开票金额；本次开票数量
                break;
            case "tpv_adjustamount"://确认金额
                limitAdjustamount(cd);
                break;
            case "tpv_yuinvoicesnum"://原开票数量（隐藏）
                setYuinvoicesnum(dataEntity);
                break;
            case "tpv_entrtyid"://来源分录id
            case "tpv_billonid"://来源单据id
                setyjinvoicesnum(dataEntity);
                break;
            default:
                break;
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_advcontoolbarap5");
        BasedataEdit tpv_longtermag = (BasedataEdit) this.getView().getControl("tpv_purchasecontracts");
        tpv_longtermag.addBeforeF7SelectListener((BeforeF7SelectListener) this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        // TODO Auto-generated method stub
        String name = e.getProperty().getName();
        IFormView view = this.getView();
        IDataModel model = view.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        List<String> notInputs = new ArrayList<>();
        switch (name) {
            case "tpv_purchasecontracts"://销售合同号
                notInputs = new ArrayList<>();
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_company");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_department");
                if (notInputs.size() > 0) {
                    view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
                    e.setCancel(true);
                } else {
                    qFilterContracts(e);  //过滤当前组织
                }
                break;
            default:
                break;
        }
    }

    private void qFilterContracts(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject thiscustomer = dataEntity.getDynamicObject("tpv_customer");//客户
        DynamicObject tpv_company = dataEntity.getDynamicObject("tpv_company");//公司
        DynamicObject tpv_department = dataEntity.getDynamicObject("tpv_department");//部门
//        if (thiscustomer == null) {
//            return;
//        }
        if (YEM.isNotEmpty(tpv_company)) {
            QFilters.add(new QFilter("tpv_company.id", "=", tpv_company.getLong("id"))); //设置过滤条件：公司
        }
        if (YEM.isNotEmpty(tpv_department)) {
            QFilters.add(new QFilter("tpv_department.id", "=", tpv_department.getLong("id"))); //设置过滤条件：部门
        }
        if (YEM.isNotEmpty(thiscustomer)) {
            QFilters.add(new QFilter("tpv_customer.id", "=", thiscustomer.getLong("id"))); //设置过滤条件：客户
        }
        QFilters.add(new QFilter("billstatus", "=", "C")); //单据状态：已审核
        QFilters.add(new QFilter("tpv_settlementstatus", QCP.not_equals, "B")); //结算状态不等于已结算
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        String key = evt.getItemKey();
        if (StringUtils.equals("tpv_baritemap", key)) {//重取
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            setData(dataEntity);
        }
        if (StringUtils.equals("tpv_apportionment", key)) {//分摊
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            limitData(dataEntity);
        }
    }


    private void setyjinvoicesnum(DynamicObject dataEntity) {
        DynamicObjectCollection tpv_entryentity = dataEntity.getDynamicObjectCollection("tpv_dt_settdc_kp");//开票分录
        for (DynamicObject entrty : tpv_entryentity) {
            Long billonid = entrty.getLong("tpv_billonid");//来源单据id
            Long ebtrtyid = entrty.getLong("tpv_entrtyid");//来源分录id
            BigDecimal tpv_yjinvoicesnum = BigDecimal.ZERO;
            String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_dt_domsettc", false);// 获取单据头所有字段标识
            selectFieid2 = DynamicObjectUtil.getEntrySelectfields(selectFieid2, "tpv_dt_domsettc", "tpv_dt_settdc_kp",
                    false);// 获取分录所有字段标识
            DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_dt_domsettc", selectFieid2, new QFilter[]{
                    new QFilter("id", QCP.equals, billonid), new QFilter("tpv_dt_settdc_kp.id", QCP.equals, ebtrtyid)});
            for (DynamicObject bill : bills) {
                DynamicObjectCollection tpv_materialentry = bill.getDynamicObjectCollection("tpv_dt_settdc_kp");//商品分录
                for (DynamicObject materialentry : tpv_materialentry) {
                    tpv_yjinvoicesnum = tpv_yjinvoicesnum.add(materialentry.getBigDecimal("tpv_invoicesnum"));//开票数量
                }
            }
            this.getModel().setValue("tpv_yjinvoicesnum", tpv_yjinvoicesnum);
        }
    }

    private void setYuinvoicesnum(DynamicObject dataEntity) {
        DynamicObjectCollection tpv_entryentity = dataEntity.getDynamicObjectCollection("tpv_dt_settdc_kp");//开票分录
        for (int i = 0; i < tpv_entryentity.size(); i++) {
            BigDecimal yuinvoicesnum = (BigDecimal) this.getModel().getValue("tpv_yuinvoicesnum", i);//原开票数量（隐藏）
            this.getModel().setValue("tpv_numberinvoices", yuinvoicesnum, i);
            this.getModel().setValue("tpv_invoicesnum", yuinvoicesnum, i);
        }
    }

    private void limitData(DynamicObject dataEntity) {
        BigDecimal tpv_invoicesnum = BigDecimal.ZERO;
        BigDecimal tpv_thisinvoicemount = (BigDecimal) this.getModel().getValue("tpv_thisinvoicemount");//本次开票金额
        DynamicObjectCollection tpv_entryentity = dataEntity.getDynamicObjectCollection("tpv_dt_settdc_kp");//开票分录
        for (DynamicObject entryentity : tpv_entryentity) {
            tpv_invoicesnum = tpv_invoicesnum.add(entryentity.getBigDecimal("tpv_invoicesnum"));//开票数量
        }
        if (tpv_invoicesnum.compareTo(BigDecimal.ZERO) > 0 && tpv_thisinvoicemount.compareTo(BigDecimal.ZERO) > 0) {
            BigDecimal[] invoicespricecy = tpv_thisinvoicemount.divideAndRemainder(tpv_invoicesnum);//开票单价
            BigDecimal invoicespricecys = tpv_thisinvoicemount.divide(tpv_invoicesnum, 2, BigDecimal.ROUND_HALF_UP);//单价向上舍入
            BigDecimal suminvoicesamount = BigDecimal.ZERO;
            if (tpv_entryentity.size() > 1) {
                if (invoicespricecy[0].compareTo(BigDecimal.ZERO) > 0 && !invoicespricecy[0].equals(new BigDecimal("0E-10"))) {
                    for (int i = 0; i < tpv_entryentity.size() - 1; i++) {
                        this.getModel().setValue("tpv_invoicesprice", invoicespricecy[0], i);
                        BigDecimal invoicesnum = (BigDecimal) this.getModel().getValue("tpv_invoicesnum", i);
                        this.getModel().setValue("tpv_invoicesamount", invoicesnum.multiply(invoicespricecy[0]), i);
                        BigDecimal icesamountthis = (BigDecimal) this.getModel().getValue("tpv_invoicesamount", i);
                        suminvoicesamount = suminvoicesamount.add(icesamountthis);
                    }
                } else {
                    for (int i = 0; i < tpv_entryentity.size() - 1; i++) {
                        this.getModel().setValue("tpv_invoicesprice", invoicespricecys, i);
                        BigDecimal invoicesnum = (BigDecimal) this.getModel().getValue("tpv_invoicesnum", i);
                        this.getModel().setValue("tpv_invoicesamount", invoicesnum.multiply(invoicespricecys), i);
                        BigDecimal icesamountthis = (BigDecimal) this.getModel().getValue("tpv_invoicesamount", i);
                        suminvoicesamount = suminvoicesamount.add(icesamountthis);
                    }
                }
                BigDecimal subtractinvoice = tpv_thisinvoicemount.subtract(suminvoicesamount);//剩余金额
                this.getModel().setValue("tpv_invoicesamount", subtractinvoice, tpv_entryentity.size() - 1);//最后一行金额
                BigDecimal endinvoicesamount = (BigDecimal) this.getModel().getValue("tpv_invoicesamount", tpv_entryentity.size() - 1);//最后一行金额
                BigDecimal endinvoicesnum = (BigDecimal) this.getModel().getValue("tpv_invoicesnum", tpv_entryentity.size() - 1);//最后一行数量
                BigDecimal endinvoicesprice = endinvoicesamount.divide(endinvoicesnum, 2, BigDecimal.ROUND_HALF_UP);//单价向上舍入
                this.getModel().setValue("tpv_invoicesprice", endinvoicesprice, tpv_entryentity.size() - 1);
            } else {
                this.getModel().setValue("tpv_invoicesprice", invoicespricecys);
                BigDecimal invoicesprices = (BigDecimal) this.getModel().getValue("tpv_invoicesprice");
                BigDecimal startinvoicesnum = (BigDecimal) this.getModel().getValue("tpv_invoicesnum");
                this.getModel().setValue("tpv_invoicesamount", invoicesprices.multiply(startinvoicesnum));
            }
        } else {
            this.getView().showTipNotification("本次开票金额或开票数量为0！");
        }
        this.getView().updateView();
    }


    private void limitthisinvoicemount(DynamicObject dataEntity) {
        BigDecimal tpv_winvoiceamount = dataEntity.getBigDecimal("tpv_winvoiceamount");//未开销项总额
        BigDecimal tpv_thisinvoicemount = dataEntity.getBigDecimal("tpv_thisinvoicemount");//本次开票金额
        BigDecimal tpv_unspentquantity = dataEntity.getBigDecimal("tpv_unspentquantity");//未开销项数量
        BigDecimal tpv_thisinvoicesnum = dataEntity.getBigDecimal("tpv_thisinvoicesnum");//本次开票数量
        if (tpv_thisinvoicemount.compareTo(tpv_winvoiceamount) > 0) {
            this.getModel().setValue("tpv_thisinvoicemount", tpv_winvoiceamount);
            this.getView().showTipNotification("本次开票金额不能大于未开销项总额！");
        }
        if (tpv_thisinvoicesnum.compareTo(tpv_unspentquantity) > 0) {
            this.getModel().setValue("tpv_thisinvoicesnum", tpv_unspentquantity);
            this.getView().showTipNotification("本次开票数量不能大于未开销项数量！");
        }
    }

    private void limitAdjustamount(ChangeData cd) {
        BigDecimal tpv_amountreceived = cd.getDataEntity().getBigDecimal("tpv_amountreceived");//收款金额
        BigDecimal tpv_adjustamount = cd.getDataEntity().getBigDecimal("tpv_adjustamount");//确认金额
        int row = cd.getRowIndex();
        if (tpv_adjustamount.compareTo(tpv_amountreceived) != 0) {
            this.getModel().setValue("tpv_ifadjust", true, row);//是否有调整
        } else {
            this.getModel().setValue("tpv_ifadjust", false, row);//是否有调整
        }
    }

    private void limitInvoicesnum(DynamicObject dataEntity) {
        DynamicObjectCollection tpv_entryentity = dataEntity.getDynamicObjectCollection("tpv_dt_settdc_kp");//开票分录
        for (DynamicObject entryentity : tpv_entryentity) {
            BigDecimal yuinvoicesnum = entryentity.getBigDecimal("tpv_yuinvoicesnum");//原开票数量（隐藏）
            BigDecimal invoicesnum = entryentity.getBigDecimal("tpv_invoicesnum");//开票数量
            int row = entryentity.getInt("Seq");
            if (invoicesnum.compareTo(yuinvoicesnum) > 0) {
                this.getModel().setValue("tpv_invoicesnum", yuinvoicesnum, row - 1);//设置开票数量
                this.getView().showTipNotification("更改的开票数量不能大于原开票数量!");
            } else {
                this.getModel().setValue("tpv_invoicesnum", invoicesnum, row - 1);//设置开票数量
            }
        }
    }

    private void setData(DynamicObject dataEntity) {
        BigDecimal tpv_amounts = BigDecimal.ZERO;//总结-金额
        BigDecimal tpv_amountoverhead = BigDecimal.ZERO;//应开销项数量
        String tpv_purchasecontracts = dataEntity.getString("tpv_purchasecontracts.number");//销售合同号单据编号
        String tpv_purchasecontract = dataEntity.getString("tpv_purchasecontracts.tpv_name");//销售合同号
        Boolean tpv_checkbox = dataEntity.getBoolean("tpv_checkbox");//货款自动-开关
        Boolean tpv_checkboxs = dataEntity.getBoolean("tpv_checkboxs");//计息单-开关
        Boolean tpvCheckbo = dataEntity.getBoolean("tpv_checkbo");//费用自动——开关

        Map<Integer, BigDecimal> map = new HashMap<>();
        AtomicInteger index = new AtomicInteger();
        DynamicObjectCollection collection = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_dt_settdc_c");

        // 多线程流（stream()）遍历集合并更新 map。由于 map 不是线程安全的，因此当多个线程同时尝试更新 map 时，
        // 需要同步对 map 的访问。在流中使用 synchronized 块
        collection.stream()
                .map(single -> single.getBigDecimal("tpv_confirmamount"))
                .forEach(single -> {
                    synchronized (map) {
                        map.put(index.getAndIncrement(), single);
                    }
                });
        //费用自动
        if (tpvCheckbo) {
            this.getModel().deleteEntryData("tpv_dt_settdc_c");
            initDatad(tpv_purchasecontracts, "tpv_dt_settdc_c", map);
        } else {
            this.getModel().deleteEntryData("tpv_dt_settdc_c");

        }

        //Begin
        //货款自动
        if (tpv_checkbox) {
            this.getModel().deleteEntryData("tpv_dt_settdc_p");
            initData(tpv_purchasecontracts, "tpv_dt_settdc_p");
            DynamicObjectCollection settdc_p = dataEntity.getDynamicObjectCollection("tpv_dt_settdc_p");//货款自动
            for (DynamicObject sett : settdc_p) {
                tpv_amounts = tpv_amounts.add(sett.getBigDecimal("tpv_money"));//金额
                String source = sett.getString("tpv_source");//来源
//                if ("A".equals(source)) {
                    tpv_amountoverhead = tpv_amountoverhead.add(sett.getBigDecimal("tpv_count"));//数量
//                }
            }
            this.getModel().setValue("tpv_amounts", tpv_amounts, 0);
            this.getModel().setValue("tpv_amountoverhead", tpv_amountoverhead);
        } else {
            this.getModel().deleteEntryData("tpv_dt_settdc_p");
            this.getModel().setValue("tpv_amounts", BigDecimal.ZERO, 0);
            this.getModel().setValue("tpv_amountoverhead", BigDecimal.ZERO);
        }
        //end

        //Begin
        //计息单
        if (tpv_checkboxs) {
            this.getModel().deleteEntryData("tpv_dt_settdc_o");
            initData1(tpv_purchasecontracts, "tpv_dt_settdc_o");
            DynamicObjectCollection settdc_o = dataEntity.getDynamicObjectCollection("tpv_dt_settdc_o");//计息
            tpv_amounts = BigDecimal.ZERO;
            for (DynamicObject sett : settdc_o) {
                tpv_amounts = tpv_amounts.add(sett.getBigDecimal("tpv_accramount"));//计息金额
            }
            this.getModel().setValue("tpv_amounts", tpv_amounts, 2);
        } else {
            this.getModel().deleteEntryData("tpv_dt_settdc_o");
            this.getModel().setValue("tpv_amounts", BigDecimal.ZERO, 2);
        }
        //end
        if (tpv_purchasecontracts != null && !tpv_purchasecontracts.isEmpty()) {
            this.getModel().deleteEntryData("tpv_dt_settdc_pi");
            this.getModel().deleteEntryData("tpv_dt_settdc_kp");
            initData2(tpv_purchasecontracts, "tpv_dt_settdc_pi");//已收分录
            initData3(tpv_purchasecontract, "tpv_dt_settdc_kp");//开票分录
        } else {
            this.getModel().deleteEntryData("tpv_dt_settdc_pi");
            this.getModel().deleteEntryData("tpv_dt_settdc_kp");
        }
    }


    /**
     * 加载数据
     */
    private void initDatad(String billno, String bill, Map<Integer, BigDecimal> map) {
        IDataModel model = this.getModel();
        DynamicObject tpvCombinationnumber = (DynamicObject) this.getModel().getValue("tpv_combinationnumber");
        if (tpvCombinationnumber != null) {
            Long combinationnumber = tpvCombinationnumber.getLong("id");

            QFilter queryHt = new QFilter("billstatus", QCP.equals, "C")
                    .and("tpv_pactmessage.tpv_purconum.tpv_groupnum.id", QCP.equals, combinationnumber);
            DynamicObjectCollection tpvDtCostbillmatHt = QueryServiceHelper.query("tpv_dt_costbillmat",
                    "tpv_costitem.id tpv_costitem,tpv_pactmessage,tpv_pactmessage.tpv_ratea tpv_ratea," +
                            "tpv_pactmessage.tpv_vatmatamt tpv_vatmatamt,tpv_pactmessage.tpv_vatamtmatch tpv_vatamtmatch," +
                            "tpv_pactmessage.tpv_amtatch tpv_amtatch", queryHt.toArray());
            QFilter queryRk = new QFilter("billstatus", QCP.equals, "C")
                    .and("tpv_matecost.tpv_purchnumds.tpv_groupnum.id", QCP.equals, combinationnumber);
            DynamicObjectCollection tpvDtCostbillmatRk = QueryServiceHelper.query("tpv_dt_costbillmat",
                    "tpv_costitem.id tpv_costitem,tpv_matecost,tpv_matecost.tpv_rated tpv_rated," +
                            "tpv_matecost.tpv_vatnomatamt tpv_vatnomatamt,tpv_matecost.tpv_taxnomatamt tpv_taxnomatamt," +
                            "tpv_matecost.tpv_taxmatamt tpv_taxmatamt", queryRk.toArray());
            if (tpvDtCostbillmatHt.size() > 0) {
                for (DynamicObject dynamicObject : tpvDtCostbillmatHt) {
                    int indexof = this.getModel().createNewEntryRow(bill);
                    this.getModel().setValue("tpv_costitem", dynamicObject.getLong("tpv_costitem"), indexof);
                    this.getModel().setValue("tpv_taxrate", dynamicObject.getBigDecimal("tpv_ratea"), indexof);
                    this.getModel().setValue("tpv_tax", dynamicObject.getBigDecimal("tpv_vatmatamt"), indexof);
                    this.getModel().setValue("tpv_nottaxamount", dynamicObject.getBigDecimal("tpv_vatamtmatch"), indexof);
                    this.getModel().setValue("tpv_plusdutyamount", dynamicObject.getBigDecimal("tpv_amtatch"), indexof);
                    this.getModel().setValue("tpv_confirmamount",
                            map.getOrDefault(indexof, BigDecimal.ZERO), indexof);

                }
            }
            if (tpvDtCostbillmatRk.size() > 0) {
                for (DynamicObject dynamicObject : tpvDtCostbillmatRk) {
                    int indexof = this.getModel().createNewEntryRow(bill);
                    this.getModel().setValue("tpv_costitem", dynamicObject.getLong("tpv_costitem"), indexof);
                    this.getModel().setValue("tpv_taxrate", dynamicObject.getBigDecimal("tpv_rated"), indexof);
                    this.getModel().setValue("tpv_tax", dynamicObject.getBigDecimal("tpv_vatnomatamt"), indexof);
                    this.getModel().setValue("tpv_nottaxamount", dynamicObject.getBigDecimal("tpv_taxnomatamt"), indexof);
                    this.getModel().setValue("tpv_plusdutyamount", dynamicObject.getBigDecimal("tpv_taxmatamt"), indexof);
                    this.getModel().setValue("tpv_confirmamount",
                            map.getOrDefault(indexof, BigDecimal.ZERO), indexof);
                }
            }
        }
    }

    /**
     * 加载数据
     */
    private void initData(String billno, String bill) {
        IDataModel model = this.getModel();
        String whereFilter = "1=1";
        if (YEM.isNotEmpty(billno)) {
            whereFilter = String.format("%s and tpv_corebillno = '%s'", whereFilter, billno);
        }
        whereFilter = String.format("%s and tpv_billstatus = '%s'", whereFilter, "C");
        model.deleteEntryData(bill);
        DataSet query = DomSettcRptQuery.query(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity(bill).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow(bill);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    /**
     * 加载数据
     */
    private void initData1(String billno, String bill) {
        IDataModel model = this.getModel();
        String whereFilter = "1=1";
        if (YEM.isNotEmpty(billno)) {
            whereFilter = String.format("%s and tpv_dt_salescontracts = '%s'", whereFilter, billno);
        }
        model.deleteEntryData(bill);
        DataSet query = DomSettcRptQuery.query1(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity(bill).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow(bill);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    /**
     * 加载数据
     */
    private void initData2(String billno, String bill) {
        IDataModel model = this.getModel();
        String whereFilter = "1=1";
        if (YEM.isNotEmpty(billno)) {
            whereFilter = String.format("%s and tpv_purchasecontracts = '%s'", whereFilter, billno);
        }
        model.deleteEntryData(bill);
        DataSet query = DomSettcRptQuery.query2(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity(bill).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow(bill);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    /**
     * 加载数据
     */
    private void initData3(String billno, String bill) {
        IDataModel model = this.getModel();
        String whereFilter = "1=1";
        if (YEM.isNotEmpty(billno)) {
            whereFilter = String.format("%s and tpv_purchasecontracts = '%s'", whereFilter, billno);
        }
        model.deleteEntryData(bill);
        DataSet querys = DomSettcRptQuery.query3(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity(bill).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(querys);
        for (Row row : querys) {
            int index = model.createNewEntryRow(bill);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

}
