package com.itopview.wm.dt.formplugin.form;

import com.itopview.wm.dt.report.DomSettlsRptQuery;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.BeforeDeleteRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.scm.common.util.DynamicObjectUtil;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * @author GX
 * 内贸结算单（供应商）-表单插件
 */
public class DomSettlsFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        for (int i = 0; i < 3; i++) {
            this.getView().setEnable(false, i, "tpv_project");//项目
            this.getModel().setValue("tpv_sources", "A", i);
            this.getView().setEnable(false, i, "tpv_sources");//来源
            this.getView().setEnable(false, i, "tpv_amounts");//金额
            this.getView().setEnable(false, i, "tpv_remark");//备注
        }
        String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_bd_settlitems", false);// 获取单据头所有字段标识
        DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_bd_settlitems", selectFieid2, new QFilter[]{});
        for (DynamicObject bill : bills) {
            Long id = bill.getLong("id");
            String name = bill.getString("name");
            if ("货款".equals(name)) {
                this.getModel().setValue("tpv_project", id, 0);
            }
            if ("费用".equals(name)) {
                this.getModel().setValue("tpv_project", id, 1);
            }
            if ("计息".equals(name)) {
                this.getModel().setValue("tpv_project", id, 2);
            }
        }
    }


    /**
     * @param e 删除行事件
     */
    @Override
    public void beforeDeleteRow(BeforeDeleteRowEventArgs e) {
        super.beforeDeleteRow(e);
        String name = e.getEntryProp().getName();
        int[] row = e.getRowIndexs();
        switch (name) {
            case "tpv_dt_settldtrs_o"://总结分录
                for (int i : row) {
                    if (i < 3) {
                        e.setCancel(true);
                        this.getView().showErrorNotification("总结分录前3行不能删除，请重新选择！");
                    }
                }
                break;
            default:
                break;
        }
    }

    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        String name = e.getEntryProp().getName();
        int i = 0;
        RowDataEntity[] rowdata = e.getRowDataEntities();
        for (RowDataEntity rdata : rowdata) {
            i = rdata.getRowIndex();
        }
        switch (name) {
            case "tpv_dt_settldtrs_o"://总结分录
                this.getModel().setValue("tpv_sources", "B", i);
                this.getView().setEnable(false, i, "tpv_sources");//来源
                break;
            default:
                break;
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_advcontoolbarap3");
        BasedataEdit tpv_longtermag = (BasedataEdit) this.getView().getControl("tpv_purcontractno");
        tpv_longtermag.addBeforeF7SelectListener((BeforeF7SelectListener) this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        // TODO Auto-generated method stub
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_purcontractno"://采购合同号
                qFilterContracts(e);  //过滤当前供应商
                break;
            default:
                break;
        }
    }

    private void qFilterContracts(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject thiscustomer = dataEntity.getDynamicObject("tpv_supplier");//供应商
        if (thiscustomer == null) {
            return;
        }
        Object id = thiscustomer.get("id");
        QFilters.add(new QFilter("tpv_supplier.id", "=", id)); //设置过滤条件：供应商
        QFilters.add(new QFilter("billstatus", "=", "C")); //单据状态：已审核
        QFilters.add(new QFilter("tpv_settlementstatus", QCP.not_equals, "B")); //结算状态不等于已结算
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        if (StringUtils.equals("tpv_baritemap", key)) {//重取
            setData(dataEntity);
        }
//        if (StringUtils.equals("bar_audit", key)) {//审核
//            verifyaudit(dataEntity, "B");
//        }
//        if (StringUtils.equals("bar_unaudit", key)) {//反审核
//            verifyaudit(dataEntity, "A");
//        }
    }

    private void verifyaudit(DynamicObject dataEntities, String b) {
        Long tpv_purcontractno = dataEntities.getLong("tpv_purcontractno.id");//核心单据id
        String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_dt_purchase", false);// 获取单据头所有字段标识
        DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_dt_purchase", selectFieid2, new QFilter[]{
                new QFilter("id", QCP.equals, tpv_purcontractno)});
        if (bills.length > 0) {
            for (DynamicObject pubill : bills) {
                pubill.set("tpv_settlementstatus", b);
                SaveServiceHelper.save(new DynamicObject[]{pubill});
            }
        }
    }


    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        ChangeData[] changeData = e.getChangeSet();
        ChangeData cd = e.getChangeSet()[0];
        int rowIndex = changeData[0].getRowIndex();
        switch (name) {
            case "tpv_checkbox"://应付-代销业务销售指导价-开关
            case "tpv_checkboxsx"://利息扣减项自动-开关
                setData(dataEntity);
                bringOutmaterial(dataEntity);
                break;
            case "tpv_adjustamount"://确认金额
                limitAdjustamount(cd);
                break;
            case "tpv_purcontractno"://采购合同号
                setData(dataEntity);
                bringOutmaterial(dataEntity);
                this.bringOut();
                break;
            default:
                break;
        }
    }

    private void bringOut() {
        DynamicObject tpvPurcontractno = (DynamicObject) this.getModel().getValue("tpv_purcontractno");
        if (tpvPurcontractno != null) {
            DynamicObject purchase = BusinessDataServiceHelper.loadSingle(tpvPurcontractno.getPkValue(), "tpv_dt_purchase");
            this.getModel().setValue("tpv_projectedprofits", purchase.getBigDecimal("tpv_projectedprofits"));
            return;
        }
        this.getModel().setValue("tpv_projectedprofits", null);
    }

    private void bringOutmaterial(DynamicObject cd) {
        DynamicObject tpv_purcontractno = cd.getDynamicObject("tpv_purcontractno");//采购合同号
        if (tpv_purcontractno != null) {
            String billon = tpv_purcontractno.getString("number");//单据编号
            List<Long> mids = new ArrayList<>();
            List<Long> materids = new ArrayList<>();
            String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_dt_purchase", false);// 获取单据头所有字段标识
            selectFieid2 = DynamicObjectUtil.getEntrySelectfields(selectFieid2, "tpv_dt_purchase", "tpv_materialentry",
                    false);// 获取分录所有字段标识
            DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_dt_purchase", selectFieid2, new QFilter[]{new QFilter("billno", QCP.equals, billon)});
            for (DynamicObject bill : bills) {
                DynamicObjectCollection tpv_materialentry = bill.getDynamicObjectCollection("tpv_materialentry");//商品分录
                for (DynamicObject materialentry : tpv_materialentry) {
                    DynamicObject materia = materialentry.getDynamicObject("tpv_material");//物料
                    Long mid = materia.getLong("id");
                    mids.add(mid);
                }
            }
            for (Long str : mids) {
                if (!materids.contains(str)) {
                    materids.add(str);
                }
            }
            this.getModel().setValue("tpv_itemname", materids.toArray());
        }
    }

    private void limitAdjustamount(ChangeData cd) {
        BigDecimal tpv_amountreceived = cd.getDataEntity().getBigDecimal("tpv_amountreceived");//付款金额
        BigDecimal tpv_adjustamount = cd.getDataEntity().getBigDecimal("tpv_adjustamount");//确认金额
        int row = cd.getRowIndex();
        if (tpv_adjustamount.compareTo(tpv_amountreceived) != 0) {
            this.getModel().setValue("tpv_adjustment", true, row);//是否有调整
        } else {
            this.getModel().setValue("tpv_adjustment", false, row);//是否有调整
        }
    }

    private void setData(DynamicObject dataEntity) {
        BigDecimal tpv_amounts = BigDecimal.ZERO;//总结-金额
        BigDecimal tpv_amountoverhead = BigDecimal.ZERO;//应开销项数量
        String tpv_purchasecontracts = dataEntity.getString("tpv_purcontractno.tpv_name");//采购合同号的合同号
        List<String> list = new ArrayList<>();
        String selectFieid2 = DynamicObjectUtil.getSelectfields("im_purinbill", false);// 获取单据头所有字段标识
        DynamicObject[] bills = BusinessDataServiceHelper.load("im_purinbill", selectFieid2, new QFilter[]{
                new QFilter("billentry.conbillnumber", QCP.equals, tpv_purchasecontracts)});
        for (DynamicObject bill : bills) {
            list.add(bill.getString("billno"));//采购入库单据编号
        }
        Boolean tpv_checkbox = dataEntity.getBoolean("tpv_checkbox");//应付-代销业务销售指导价-开关
        Boolean tpv_checkboxs = dataEntity.getBoolean("tpv_checkboxsx");//利息扣减项自动-开关
        //Begin
        //应付-代销业务销售指导价
        if (tpv_checkbox) {
            this.getModel().deleteEntryData("tpv_dt_settldtrs_m");//应付-代销业务销售指导价
            initData3(list, "tpv_dt_settldtrs_m");
            DynamicObjectCollection settdc_m = dataEntity.getDynamicObjectCollection("tpv_dt_settldtrs_m");//应付-代销业务销售指导价
            for (DynamicObject sett : settdc_m) {
                tpv_amounts = tpv_amounts.add(sett.getBigDecimal("tpv_guideamount"));//金额
                tpv_amountoverhead = tpv_amountoverhead.add(sett.getBigDecimal("tpv_guideprice"));//数量
            }
            this.getModel().setValue("tpv_amounts", tpv_amounts, 0);
            this.getModel().setValue("tpv_settlementquantity", tpv_amountoverhead);
        } else {
            this.getModel().deleteEntryData("tpv_dt_settldtrs_m");
            this.getModel().setValue("tpv_amounts", BigDecimal.ZERO, 0);
        }
        //end

        //Begin
        //利息扣减项自动
        if (tpv_checkboxs) {
            this.getModel().deleteEntryData("tpv_dt_domsettls_zd");
            initData1(tpv_purchasecontracts, "tpv_dt_domsettls_zd");
            DynamicObjectCollection settdc_o = dataEntity.getDynamicObjectCollection("tpv_dt_domsettls_zd");//利息扣减项自动
            tpv_amounts = BigDecimal.ZERO;
            for (DynamicObject sett : settdc_o) {
                tpv_amounts = tpv_amounts.add(sett.getBigDecimal("tpv_bearingamount"));//计息金额
            }
            this.getModel().setValue("tpv_amounts", tpv_amounts, 2);
        } else {
            this.getModel().deleteEntryData("tpv_dt_domsettls_zd");
            this.getModel().setValue("tpv_amounts", BigDecimal.ZERO, 2);
        }
        //end
        if (tpv_purchasecontracts != null && !tpv_purchasecontracts.isEmpty()) {
            this.getModel().deleteEntryData("tpv_dt_settldtrs_p");
            initData2(tpv_purchasecontracts, "tpv_dt_settldtrs_p");//已收分录
        } else {
            this.getModel().deleteEntryData("tpv_dt_settldtrs_p");
        }
    }

    /**
     * 加载数据
     */
    private void initData2(String billno, String bill) {
        IDataModel model = this.getModel();
        String whereFilter = "1=1";
        if (YEM.isNotEmpty(billno)) {
            whereFilter = String.format("%s and tpv_purchasecontracts = '%s'", whereFilter, billno);
        }
        model.deleteEntryData(bill);
        DataSet query = DomSettlsRptQuery.query2(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity(bill).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow(bill);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    /**
     * 加载数据
     */
    private void initData3(List<String> list, String bill) {
        IDataModel model = this.getModel();
        String whereFilter = "1=1";
        if (!list.isEmpty()) {
            for (String List : list) {
                whereFilter = String.format("%s and tpv_purchasecontracts = '%s'", whereFilter, List);
            }
            whereFilter = String.format("%s and tpv_billstatus = '%s'", whereFilter, "C");
        }
        model.deleteEntryData(bill);
        DataSet querys = DomSettlsRptQuery.query3(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity(bill).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(querys);
        for (Row row : querys) {
            int index = model.createNewEntryRow(bill);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }


    /**
     * 加载数据
     */
    private void initData1(String billno, String bill) {
        IDataModel model = this.getModel();
        String whereFilter = "1=1";
        if (YEM.isNotEmpty(billno)) {
            whereFilter = String.format("%s and tpv_dt_salescontracts = '%s'", whereFilter, billno);
        }
        model.deleteEntryData(bill);
        DataSet query = DomSettlsRptQuery.query1(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity(bill).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow(bill);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

}
