package com.itopview.wm.dt.formplugin.form;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DateUtil;
import kd.bos.algo.DataSet;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.sql.Array;
import java.util.*;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * @Description: 进口物流工作台
 * @Auther: zbh
 */
public class EntworkBenchEdit extends AbstractFormPlugin implements RowClickEventListener {
    //分录下标
    private HashMap<String, Integer> entryIndex = new HashMap<>();//分录下标
    private static String basedatanum = null;  //组合号
    BigDecimal total = BigDecimal.ZERO;//到单数量


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_advcontoolbarap", "tpv_advcontoolbarap2");
        EntryGrid entryGrid = this.getView().getControl("tpv_logworkbench");//进口物流
        entryGrid.addRowClickListener(this);
    }


    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String name = evt.getItemKey();
        switch (name) {
            case "tpv_addmark":
                if (isSelect()) {
                    addMark(); //判断是否有选中数据
                }
                break;
        }
    }

    /*
      单击行事件
     */
    @Override
    public void entryRowClick(RowClickEvent evt) {
        this.getModel().deleteEntryData("tpv_purchases");     //采购装运情况
        this.getModel().deleteEntryData("tpv_arrivaldetais"); //到单情况
        List billnos = new ArrayList<>();  //单据编码
        List<String> cnumber = new ArrayList<>();  //采购合同号
        HashMap<Object, String> map = new HashMap<>();
        int row = evt.getRow();
        if (row < 0) {
            return;
        }
        circulationgoods(row, billnos, map);
        arrivaldetai(billnos, cnumber, map);
        openContainerFrom(row);
        calculateNum(row);
    }

    /*
     中间单货物流转
     */
    private void circulationgoods(int row, List billnos, HashMap<Object, String> map) {
        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_logworkbench");
        DynamicObject dynamicObject = entity.get(row);
        basedatanum = dynamicObject.getString("tpv_basedatanum");
        DynamicObject[] load = BusinessDataServiceHelper.load("tpv_dt_purchase", "billno,tpv_contractnumber,tpv_whetheitisshipped,tpv_supplier,createtime", new QFilter[]{new QFilter("tpv_combinationnumber.name", QCP.equals, basedatanum), new QFilter("billstatus", QCP.equals, "C")});
        if (load.length <= 0) {
            return;
        }
        for (DynamicObject purchasestate : load) {
            String contractnumber = purchasestate.getString("tpv_contractnumber");
            Object billno = purchasestate.get("billno");
            billnos.add(billno);
            map.put(billno, contractnumber);
        }
    }

    /*
     到单情况分录填充
     */
    private void arrivaldetai(List billnos, List<String> cnumber, HashMap<Object, String> map) {
        List<String> srcbillno = new ArrayList<>();
        HashMap<Object, String> maps = new HashMap<>();

        //货物流转单编号
        for (Object billno : billnos) {
            DynamicObject[] sales = BusinessDataServiceHelper.load("tpv_dt_freigroambill", "billno,tpv_materialentry,tpv_srcbillno", new QFilter[]{new QFilter("tpv_materialentry.tpv_srcbillno", QCP.equals, billno), new QFilter("billstatus", QCP.equals, "C")});
            for (DynamicObject sale : sales) {
                String tpvSrcbillno = sale.getString("billno");
                srcbillno.add(tpvSrcbillno);
                maps.put(tpvSrcbillno, map.get(billno));
            }
        }
        for (Object billno : srcbillno) {
            int i = 0;
            BigDecimal count = BigDecimal.ZERO;//到单数量
            DynamicObject[] arrivaldetais = BusinessDataServiceHelper.load("tpv_is_arrivaldetais", "tpv_materialentry,tpv_srcbillno,tpv_qty,tpv_supplier,tpv_amount,tpv_singledate,tpv_billladno,billno", new QFilter[]{new QFilter("tpv_materialentry.tpv_srcbillno", QCP.equals, billno), new QFilter("billstatus", QCP.equals, "C")});
            if (arrivaldetais.length <= 0) {
                continue;
            }
            int[] tpvArrivaldetais = this.getModel().batchCreateNewEntryRow("tpv_arrivaldetais", arrivaldetais.length);
            for (DynamicObject sale : arrivaldetais) {
                DynamicObjectCollection maters = sale.getDynamicObjectCollection("tpv_materialentry");
                if (maters.size() != 0) {
                    for (DynamicObject mater : maters) {
                        BigDecimal tpyQty = mater.getBigDecimal("tpv_qty");//数量
                        if (BigDecimal.ZERO.compareTo(tpyQty) != 0) {
                            count = tpyQty.add(count);
                        }
                    }
                }
                count = total.add(count);
                DynamicObject supplier = sale.getDynamicObject("tpv_supplier");
                BigDecimal amount = sale.getBigDecimal("tpv_amount");
                Date singledate = sale.getDate("tpv_singledate");
                String billladno = sale.getString("tpv_billladno");
                String number = sale.getString("billno");
                this.getModel().setValue("tpv_purchasenumbers", maps.get(billno), tpvArrivaldetais[i]);//采购合同号
                this.getModel().setValue("tpv_suppliers", supplier, tpvArrivaldetais[i]);//供应商
                this.getModel().setValue("tpv_textfield", number, i);//到单单据文本
                this.getModel().setValue("tpv_anumber", sale, tpvArrivaldetais[i]);//到单单据号
                this.getModel().setValue("tpv_aamount", count, tpvArrivaldetais[i]);//到单数量
                this.getModel().setValue("tpv_amoney", amount, tpvArrivaldetais[i]);//到单金额
                this.getModel().setValue("tpv_adatetime", singledate, tpvArrivaldetais[i]);//到单日期
                this.getModel().setValue("tpv_anumericallink", billladno, tpvArrivaldetais[i]);//提单号
                i++;
            }
        }
    }

    /*
    内嵌进口物流工作台采购装运情况分录
     */
    private void openContainerFrom(int index) {

        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_logworkbench");
        String groupNum = entity.get(index).getString("tpv_basedatanum");//获取组合号

        BillShowParameter showParameter = new BillShowParameter();
        showParameter.setStatus(OperationStatus.EDIT);
        showParameter.getOpenStyle().setShowType(ShowType.InContainer);
        showParameter.getOpenStyle().setTargetKey("tpv_flexpanelap1");
        showParameter.setSendToClient(true);
        showParameter.setFormId("tpv_wms_entworkent");
        DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle("tpv_bd_combination", "id",
                new QFilter[]{new QFilter("name", QCP.equals, groupNum)});
        showParameter.setPkId(loadSingle.getPkValue());
        this.getView().showForm(showParameter);
    }

    /*
     累计到单数
   */
    public void calculateNum(int index) {
        AtomicInteger arrivalNum = new AtomicInteger();
        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_arrivaldetais");
        entity.stream().forEach(arrival -> {
            arrivalNum.addAndGet(arrival.getInt("tpv_aamount"));
        });
        //赋值
        this.getModel().setValue("tpv_accsingular", arrivalNum, index);
    }

    /*
    进口物流分录数据填充
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        List<String> listnum = new ArrayList<>();//存放组合号编码
        List<String> nlist = new ArrayList<>();//存放组合号名称
        List<String> remark = new ArrayList<>();//备注

        bdBustypes(listnum, nlist, remark); //组合号查询

        if (listnum.size() == 0) {
            return;
        }
        this.getModel().batchCreateNewEntryRow("tpv_logworkbench", listnum.size());
        dtSalescontract(nlist, remark, listnum);  //进口物流分录的填充
        calculateNum(0); //到单数
        openContainerFrom(0);  //内嵌填充
    }

    /*
     业务类型,组合号编码,组合号名称查询
     */
    private void bdBustypes(List<String> listnum, List<String> nlist, List<String> remark) {
        List<String> stringArrayList = new ArrayList<>();
        //业务类型
        DynamicObject[] bustypes = BusinessDataServiceHelper.load("tpv_bd_bustypes", "name", new QFilter[]{new QFilter("group.name", QCP.equals, "进口"), new QFilter("status", QCP.equals, "C")});
        for (DynamicObject dynamicObject : bustypes) {
            String string = dynamicObject.getString("name");
            stringArrayList.add(string);
        }

        DynamicObject[] load = BusinessDataServiceHelper.load("tpv_bd_combination", "name,number,tpv_remarkreent", new QFilter[]{new QFilter("tpv_businesstype.name", QCP.in, stringArrayList)});

        for (DynamicObject object : load) {
            String number = object.getString("number");
            listnum.add(number); //组合号编码
            String name = object.getString("name");
            nlist.add(name);   //组合号名称
            String remarkree = object.getString("tpv_remarkreent");
            remark.add(remarkree);  //备注
        }
    }

    /*
    采购合同
     */
    private void dtSalescontract(List<String> nlist, List<String> remark, List<String> listnum) {

        int i = 0;
        //组合号下的采购合同
        DynamicObject[] purchases = BusinessDataServiceHelper.load("tpv_dt_purchase", "billno,tpv_contractnumber,tpv_tradeproperty.name,tpv_countryoforigin.name,tpv_supplier,tpv_documentarys.name,tpv_priceterms.name,tpv_currency.name,tpv_dt_purchase_yq,tpv_overduedefinition,tpv_paymentstatus,tpv_whetheitisshipped,tpv_bizdate,tpv_durationofthecontr,tpv_materialentry,tpv_qty,tpv_prodname,tpv_combinationnumber",
                new QFilter[]{new QFilter("tpv_combinationnumber.name", QCP.in, nlist), new QFilter("billstatus", QCP.equals, "C")});
        //组合号下的销售合同
        DynamicObject[] sale = BusinessDataServiceHelper.load("tpv_dt_salescontract", "tpv_customer.name,tpv_contractnos,tpv_tradeproperty,tpv_combinationnumber",
                new QFilter[]{new QFilter("tpv_combinationnumber.name", QCP.in, nlist), new QFilter("billstatus", QCP.equals, "C")});

        for (String num : listnum) {

            List<DynamicObject> purlist = new ArrayList(); //采购
            List<DynamicObject> salelist = new ArrayList(); //销售
            List arrayList = new ArrayList<>();

            this.getModel().setValue("tpv_remark", remark.get(i), i);  //备注
            this.getModel().setValue("tpv_basedatanum", nlist.get(i), i);  //组合号

            for (DynamicObject purchase : purchases) {
                String purchasenumber = purchase.getString("tpv_combinationnumber.number");
                if (num.equals(purchasenumber)) {
                    Object billno = purchase.get("billno");
                    arrayList.add(billno);
                    purlist.add(purchase);
                }
            }
            countryoforigin(purlist, i);  //原产地
            suppliersfjtnbqy(purlist, i);//原始采购商  价格条款  商品  数量 币别  装运完结
            documentarys(purlist, i);  //跟单内勤
            tpaycaluse(purlist, i);//回款期条款
            ismoney(purlist, i);  //是否款齐
            lastpay(purlist, i);//最迟回款期
            tradeproperty(purlist, i);  //转采,进采

            for (DynamicObject salenum : sale) {
                String salenumber = salenum.getString("tpv_combinationnumber.number");
                if (num.equals(salenumber)) {
                    salelist.add(salenum);
                }
            }
            fincustomer(salelist, i);  //最终客户
            tradepropertysale(salelist, i); //转销,进销

            BigDecimal cumsingular = cumsingular(arrayList, i);//累计开单数
            BigDecimal totalstorage = totalstorage(arrayList, i);//累计入库数
            if (cumsingular.compareTo(totalstorage) > 0) {
                this.getModel().setValue("tpv_requantity", 0, i);
            } else {
                this.getModel().setValue("tpv_requantity", totalstorage.subtract(cumsingular), i);
            }
            i++;
        }
    }

    /*
    累计入库数
     */
    private BigDecimal totalstorage(List load, int i) {
        BigDecimal sunnum = BigDecimal.ZERO;//总数量
        List<String> srcbillno = new ArrayList<>();
        List list = new ArrayList<>();
        for (int j = 0; j < load.size(); j++) {
            Object id = load.get(j);
            list.add(id);
        }
        DynamicObject[] salels = BusinessDataServiceHelper.load("tpv_dt_freigroambill", "billno,tpv_materialentry,tpv_srcbillno",
                new QFilter[]{new QFilter("tpv_materialentry.tpv_srcbillno", QCP.in, list), new QFilter("billstatus", QCP.equals, "C")});

        for (DynamicObject sale : salels) {
            String tpvSrcbillno = sale.getString("billno");//单据编号
            srcbillno.add(tpvSrcbillno);
        }

        DynamicObject[] salers = BusinessDataServiceHelper.load("im_purinbill", "billentry,srcbillnumber,qty",
                new QFilter[]{new QFilter("billentry.srcbillnumber", QCP.in, srcbillno), new QFilter("billstatus", QCP.equals, "C")});
        for (DynamicObject sale : salers) {
            DynamicObjectCollection materialentry = sale.getDynamicObjectCollection("billentry");
            if (materialentry.size() != 0) {
                for (DynamicObject mater : materialentry) {
                    sunnum = sunnum.add(mater.getBigDecimal("qty"));//数量
                }
            }
        }

        if (srcbillno.size() != 0) {
            this.getModel().setValue("tpv_totalstorage", sunnum, i);
            return sunnum;
        }
        this.getModel().setValue("tpv_totalstorage", BigDecimal.ZERO, i);
        return BigDecimal.ZERO;
    }

    /*
    累计开单数 110
     */
    private BigDecimal cumsingular(List load, int i) {
        BigDecimal sunnum = BigDecimal.ZERO;//总数量
        List<String> srcbillno = new ArrayList<>();

        //销售合同
        DynamicObject[] salesnum = BusinessDataServiceHelper.load("tpv_dt_salescontract", "billno,tpv_materialentry,tpv_srcbillno",
                new QFilter[]{new QFilter("tpv_materialentry.tpv_srcbillno", QCP.in, load), new QFilter("billstatus", QCP.equals, "C")});

        for (DynamicObject sale : salesnum) {
            String tpvSrcbillno = sale.getString("billno");//编码
            srcbillno.add(tpvSrcbillno);
        }

        DynamicObject[] salesship = BusinessDataServiceHelper.load("tpv_dt_salesshipping", "tpv_materialentry,tpv_qty,tpv_customer,tpv_sourcebillkey",
                new QFilter[]{new QFilter("tpv_materialentry.tpv_srcbillno", QCP.in, srcbillno),
                        new QFilter("billstatus", QCP.equals, "C")});

        for (DynamicObject sales : salesship) {
            DynamicObjectCollection materialentry = sales.getDynamicObjectCollection("tpv_materialentry");
            boolean salesBoolean = sales.getBoolean("tpv_customer.tpv_enterprise");
            if (!salesBoolean && materialentry.size() != 0) {
                for (DynamicObject mater : materialentry) {
                    sunnum = sunnum.add(mater.getBigDecimal("tpv_qty"));//数量
                }
            }

        }

        if (srcbillno.size() != 0) {
            this.getModel().setValue("tpv_cumsingular", sunnum, i);
            return sunnum;
        }
        this.getModel().setValue("tpv_cumsingular", BigDecimal.ZERO, i);
        return BigDecimal.ZERO;
    }

    /*
    最终客户
     */
    private void fincustomer(List<DynamicObject> sales, int i) {
        if (sales.size() == 0) {
            return;
        }
        StringBuilder fincustomer = new StringBuilder();
        for (DynamicObject last : sales) {
            String customer = last.getString("tpv_customer.name");
            boolean lastBoolean = last.getBoolean("tpv_customer.tpv_enterprise");
            if (!lastBoolean && customer != null) {
                fincustomer.append(customer).append(",");
            }
        }
        clearcomma(fincustomer);
        this.getModel().setValue("tpv_fincustomer", fincustomer, i);
    }


    /*
    最迟回款期
     */
    private void lastpay(List<DynamicObject> load, int i) {
        StringBuilder lastpay = new StringBuilder();
        for (DynamicObject last : load) {
            String contractnumber = last.getString("tpv_contractnumber");
            Date bizdate = last.getDate("tpv_durationofthecontr");
            String formatDate = DateUtil.formatDate(bizdate);
            if ("".equals(formatDate)) {
                continue;
            }
            String lasttime = contractnumber + ":" + formatDate;
            lastpay.append(lasttime).append(",");
        }
        clearcomma(lastpay);
        this.getModel().setValue("tpv_lastpay", lastpay, i);
    }

    /*
    是否款齐
     */
    private void ismoney(List<DynamicObject> load, int i) {
        int isFlag = 0;
        for (DynamicObject ismoney : load) {
            String paymentstatus = ismoney.getString("tpv_paymentstatus");
            if (paymentstatus != "B") {
                isFlag++;
            }
        }
        if (isFlag == 0) {
            this.getModel().setValue("tpv_ismoney", "是", i);//是否款齐
            return;
        }
        this.getModel().setValue("tpv_ismoney", "否", i);//是否款齐
    }

    /*
   回款期条款
    */
    private void tpaycaluse(List<DynamicObject> load, int i) {
        StringBuilder overduedefinitionname = new StringBuilder();
        for (DynamicObject cumsingular : load) {
            DynamicObjectCollection entrys = cumsingular.getDynamicObjectCollection("tpv_dt_purchase_yq");
            for (DynamicObject entity : entrys) {
                String overduedefinition = entity.getString("tpv_overduedefinition.name");
                overduedefinitionname.append(overduedefinition).append(",");
            }
        }
        clearcomma(overduedefinitionname);
        this.getModel().setValue("tpv_paycaluse", overduedefinitionname, i);//原产地
    }

    /*
    原始采购商  价格条款  币别  商品
     */
    private void suppliersfjtnbqy(List<DynamicObject> load, int i) {
        int isFlagship = 0;   // 装运完结
        List whetheitisshipped = new ArrayList();  // 装运完结
        BigDecimal sunnum = BigDecimal.ZERO;//总数量
        StringBuilder suppliername = new StringBuilder();//原产地
        StringBuilder pricetermsname = new StringBuilder();//价格条款
        StringBuilder currencyname = new StringBuilder();//币别
        StringBuilder commodity = new StringBuilder();//商品
        for (DynamicObject purchase : load) {
            DynamicObject supplier = purchase.getDynamicObject("tpv_supplier");  //供应商
            String priceterms = purchase.getString("tpv_priceterms.name");  //价格条款
            String currency = purchase.getString("tpv_currency.name");  //币别
            DynamicObjectCollection materialentry = purchase.getDynamicObjectCollection("tpv_materialentry");
            if (supplier != null) {
                String sname = supplier.getString("name");
                boolean tpvSfjtnbqy = supplier.getBoolean("tpv_sfjtnbqy");  //是否集团内部企业
                if (!tpvSfjtnbqy) {
                    boolean aBoolean = purchase.getBoolean("tpv_whetheitisshipped");  //是否装运齐
                    for (DynamicObject entity : materialentry) {
                        String prodname = entity.getString("tpv_prodname.group.name");//商品
                        commodity.append(prodname).append(",");
                        sunnum = sunnum.add(entity.getBigDecimal("tpv_qty"));//数量
                    }
                    if (!aBoolean) {
                        whetheitisshipped.add(1);
                    }
                    if (sname != null) {
                        suppliername.append(sname).append(",");
                    }
                    if (priceterms != null) {
                        pricetermsname.append(priceterms).append(",");
                    }
                    if (currency != null) {
                        currencyname.append(currency).append(",");
                    }
                }
            }
        }
        clearcomma(suppliername);
        clearcomma(pricetermsname);
        clearcomma(currencyname);
        clearcomma(commodity);
        this.getModel().setValue("tpv_amount", sunnum, i);//数量
        this.getModel().setValue("tpv_commodity", commodity, i);//商品
        this.getModel().setValue("tpv_oripurchaser", suppliername, i);//原产地
        this.getModel().setValue("tpv_priceclause", pricetermsname, i);//价格条款
        this.getModel().setValue("tpv_currency", currencyname, i);//币别

        if (whetheitisshipped.size() == 0) {
            this.getModel().setValue("tpv_shipmented", "A", i);//完结
            return;
        }
        this.getModel().setValue("tpv_shipmented", "B", i);//装运中
    }

    /*
    跟单内勤
     */
    private void documentarys(List<DynamicObject> load, int i) {
        StringBuilder nbasedata = new StringBuilder();
        for (DynamicObject countryoforigin : load) {
            String documentarys = countryoforigin.getString("tpv_documentarys.name");
            if (documentarys != null) {
                nbasedata.append(documentarys).append(",");
            }
        }
        clearcomma(nbasedata);
        this.getModel().setValue("tpv_people", nbasedata, i);//原产地
    }

    /*
    原产地
     */
//    private void countryoforigin(DynamicObject[] load, int i) {
    private void countryoforigin(List<DynamicObject> load, int i) {
        StringBuilder nbasedata = new StringBuilder();
        for (DynamicObject countryoforigin : load) {
            String country = countryoforigin.getString("tpv_countryoforigin.name");
            if (country != null) {
                nbasedata.append(country).append(",");
            }
        }
        clearcomma(nbasedata);
        this.getModel().setValue("tpv_sourcearea", nbasedata, i);//原产地
    }

    /*
     转采,进采
     */
    private void tradeproperty(List<DynamicObject> load, Integer i) {
        StringBuilder nload = new StringBuilder();  //转采
        StringBuilder mload = new StringBuilder();  //进采
        // 转采  进采
        for (DynamicObject object : load) {
            String tname = object.getString("tpv_tradeproperty.name");
            String contractnumber = object.getString("tpv_contractnumber");
            if (tname != null) {
                if (tname.equals("转口业务")) {
                    nload.append(contractnumber).append(",");
                }
                if (tname.equals("进口业务")) {
                    mload.append(contractnumber).append(",");
                }
            }
        }
        clearcomma(nload);
        clearcomma(mload);
        this.getModel().setValue("tpv_diversion", nload, i);//转采
        this.getModel().setValue("tpv_oversampling", mload, i);//进采
    }

    /*
   转销,进销
   */
    private void tradepropertysale(List<DynamicObject> sales, Integer i) {
        StringBuilder nsale = new StringBuilder();  //转销
        StringBuilder msale = new StringBuilder();  //进销
        //转销 进销
        for (DynamicObject sale : sales) {
            String tname = sale.getString("tpv_tradeproperty.name");
            String contractnumber = sale.getString("tpv_contractnos");

            if (tname != null) {
                if (tname.equals("转口业务")) {
                    nsale.append(contractnumber).append(",");
                }
                if (tname.equals("进口业务")) {
                    msale.append(contractnumber).append(",");
                }
            }
        }
        clearcomma(nsale);
        clearcomma(msale);
        this.getModel().setValue("tpv_resell", nsale, i);//转销
        this.getModel().setValue("tpv_purchase", msale, i);//进销
    }

    /*
    去除最后的,
     */
    public void clearcomma(StringBuilder builder) {
        //去除最后的，
        if (0 != builder.length()) {
            builder.deleteCharAt(builder.lastIndexOf(","));
        }
    }

    /**
     * 添加备注
     */
    private void addMark() {

        HashMap<String, Object> map = new HashMap<>();
        Integer integer = entryIndex.get("tpv_logworkbench");
        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_logworkbench");
        String groupNum = entity.get(integer).getString("tpv_basedatanum");//获取组合号
        Object value = this.getModel().getValue("tpv_remark");
        map.put("index", integer);
        map.put("groupNum", groupNum);
        map.put("beMark", value);
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setCloseCallBack(new CloseCallBack(this, "mark"));
        showParameter.setSendToClient(true);
        showParameter.setCustomParams(map);
        showParameter.setFormId("tpv_wms_marks");
        this.getView().showForm(showParameter);
    }

    /**
     * 是否已选择数据
     *
     * @return
     */
    private boolean isSelect() {
        //获取分录选中行
        EntryGrid entryGrid = this.getControl("tpv_logworkbench");
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length == 0) {
            this.getView().showTipNotification("请先选择一条数据!");
            return false;
        } else {
            entryIndex.put("tpv_logworkbench", selectRows[0]);
            return true;
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
        JSONObject returnData = (JSONObject) closedCallBackEvent.getReturnData();
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "mark") && null != returnData) {
            this.getModel().setValue("tpv_remark", returnData.get("mark"), (Integer) returnData.get("index"));
            //保存数据到数据库
            DynamicObject remarkr = BusinessDataServiceHelper.loadSingle("tpv_bd_combination", "tpv_remarkreent",
                    new QFilter[]{new QFilter("name", QCP.equals, returnData.get("groupNum"))});
            remarkr.set("tpv_remarkreent", returnData.get("mark"));
            SaveServiceHelper.update(remarkr);
        }
    }
}

