package com.itopview.wm.dt.formplugin.form;

import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.*;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.DateEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.scm.common.util.DynamicObjectUtil;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.EventObject;
import java.util.List;

/**
 * @author GX
 * 货物流转单-表单插件
 */
public class FreigroamFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

    /**
     * 打开事件
     */
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        ifdelivBill();
//        dateRange();
    }


    /**
     * 是否交货单据锁定
     */
    public void ifdelivBill() {
        DynamicObject tpv_transportstyles = (DynamicObject) this.getModel().getValue("tpv_transportstyles");//运输方式
//        if (tpv_transportstyles != null) {
//            this.getView().setEnable(false, "tpv_transportstyles");//运输方式锁定
//        } else {
//            this.getView().setEnable(true, "tpv_transportstyles");//运输方式取消锁定
//        }
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        if (dataEntity != null) {
            DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");
//            this.getView().setEnable(false, "tpv_ifdelivbill");//是否交货单据锁定
            for (DynamicObject mater : materialentry) {
                Long mid = mater.getLong("tpv_coentryid");//核心分录id
                String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_dt_freigroambill", false);// 获取单据头所有字段标识
                selectFieid2 = DynamicObjectUtil.getEntrySelectfields(selectFieid2, "tpv_dt_freigroambill", "tpv_materialentry", false);// 获取单据头所有字段标识
                DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_dt_freigroambill", selectFieid2, new QFilter[]{
                        new QFilter("tpv_materialentry.tpv_coentryid", QCP.equals, mid).and(new QFilter("billstatus", QCP.equals, "C"))});
                if (bills.length > 0) {
                    for (DynamicObject bill : bills) {
                        String tpv_sourcebillkey = bill.getString("tpv_sourcebillkey");//来源单据标识
                        Boolean tpv_ifdelivbill = bill.getBoolean("tpv_ifdelivbill");//是否交货单据
                        if (!"tpv_dt_purinbill".equals(tpv_sourcebillkey) && !tpv_ifdelivbill) {
//                            this.getView().setEnable(true, "tpv_ifdelivbill");//是否交货单据锁定
                            return;
                        }
                    }
                }
            }
        }
    }


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_advcontoolbarap1");
        BasedataEdit tpv_costitem = (BasedataEdit) this.getView().getControl("tpv_expenseitems");
        tpv_costitem.addBeforeF7SelectListener(this);
        BasedataEdit tpv_prodname = (BasedataEdit) this.getView().getControl("tpv_prodname");
        tpv_prodname.addBeforeF7SelectListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent evt) {
        String name = evt.getProperty().getName();
        switch (name) {
            case "tpv_expenseitems":
                expenseitems(evt);
                break;
            case "tpv_prodname":
                prodName(evt);
                break;
        }
    }

    private void prodName(BeforeF7SelectEvent e) {
        EntryGrid entryGridHt = this.getControl("tpv_materialentry");//商品明细分录
        int[] selectRowsHt = entryGridHt.getSelectRows();//获取选中的行号
        if (selectRowsHt.length == 1) {
            DynamicObject tpvMaterial = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_materialentry").get(selectRowsHt[0]).getDynamicObject("tpv_material");
            if (tpvMaterial != null) {
                ListShowParameter showMaterial = (ListShowParameter) e.getFormShowParameter();
                List<QFilter> QMaterial = new ArrayList<QFilter>();
                QMaterial.add(new QFilter("group", QCP.equals, tpvMaterial.getPkValue()));
                showMaterial.getListFilterParameter().setQFilters(QMaterial);
            }
        }
    }

    private void expenseitems(BeforeF7SelectEvent evt) {
        String entityName = this.getModel().getDataEntityType().getName();
        QFilter qFilterEr = new QFilter("enable", QCP.equals, "1");
        qFilterEr.and(new QFilter("billtype.number", QCP.equals, entityName));
        DynamicObject[] load = BusinessDataServiceHelper.load("er_expenseitembill", "expenseitem,billtype", qFilterEr.toArray());
        List<Long> ids = new ArrayList<>();
        if (load.length > 0) {
            for (DynamicObject dynamicObject : load) {
                DynamicObject expenseitem = dynamicObject.getDynamicObject("expenseitem");
                if (YEM.isNotEmpty(expenseitem)) {
                    ids.add(expenseitem.getLong("id"));
                }
            }
        }
        QFilter qFilter = new QFilter("enable", QCP.equals, "1");
        if (ids.size() > 0) {
            qFilter.and(new QFilter("id", QCP.in, ids));
        } else {
            qFilter.and(new QFilter("id", QCP.less_than, 0l));
        }
        ListShowParameter showParameter = (ListShowParameter) evt.getFormShowParameter();
        showParameter.getTreeFilterParameter().getQFilters().add(qFilter);
        showParameter.getListFilterParameter().getQFilters().add(qFilter);
    }

    /**
     * @param evt 监听费用信息-批量录入金额按钮
     */
    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        super.itemClick(evt);
        String key = evt.getItemKey();
        String billstatus = (String) this.getModel().getValue("billstatus");
        if (StringUtils.equals("tpv_bulkentrybutton", key)) {
            showInfoForm(this.getView());
        }
        if (StringUtils.equals("bar_unsubmit", key) || StringUtils.equals("bar_unaudit", key)) {//撤销，反审核
            if ("A".equals(billstatus)) {
                ifdelivBill();
            }
        }
    }


    /**
     * 设置打开批量录入金额动态表单
     */
    private void showInfoForm(IFormView view) {
        // 获取单据体
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId("tpv_bulkentryexpenses");
        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_bulkentrybutton"));
        view.showForm(showParameter);
    }

    /**
     * @param e 回调，接收子页面传来的值。
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        switch (actionId) {
            case "tpv_bulkentrybutton":
                DynamicObjectCollection data = (DynamicObjectCollection) returnData;
                setValue(data);
                break;
            default:
                break;
        }
    }

    private void setValue(DynamicObjectCollection data) {
        if (data != null && data.size() > 0) {
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品明细分录
            for (int i = 0; materialentry.size() > i; i++) {
                DynamicObject dynamicObject = materialentry.get(i);
                BigDecimal tpvQty = dynamicObject.getBigDecimal("tpv_qty");
                DynamicObjectCollection dynamicObjects = dynamicObject.getDynamicObjectCollection("tpv_dt_freigroambill_f");
                for (DynamicObject freigroambill : data) {
                    DynamicObject addNewDy = dynamicObjects.addNew();
                    addNewDy.set("tpv_expenseitems", freigroambill.getDynamicObject("tpv_expenseitems"));
                    addNewDy.set("tpv_providers", freigroambill.getDynamicObject("tpv_supplierf"));
                    addNewDy.set("tpv_costcurrency", freigroambill.getDynamicObject("tpv_costcurrencys"));
                    addNewDy.set("tpv_billablequantitys", tpvQty);
                    addNewDy.set("tpv_unitprices", freigroambill.getBigDecimal("tpv_unitprices"));
                    BigDecimal tpvMoneys = tpvQty.multiply(freigroambill.getBigDecimal("tpv_unitprices"));
                    addNewDy.set("tpv_moneys", tpvMoneys.setScale(2, BigDecimal.ROUND_HALF_UP));
                    addNewDy.set("tpv_taxrates", freigroambill.getBigDecimal("tpv_taxrates"));
                    addNewDy.set("tpv_comments", freigroambill.getString("tpv_comments"));
                    DynamicObject tpv_currency = freigroambill.getDynamicObject("tpv_costcurrencys");
                    if (YEM.isNotEmpty(tpv_currency)) {
                        Object tpv_exratetable = this.getModel().getValue("tpv_exratetable");
                        Object tpv_currencybase = this.getModel().getValue("tpv_currencybase"); //本位币
                        Date tpv_exratedate = (Date) this.getModel().getValue("tpv_exratedate");
                        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
                        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
                        BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
                        addNewDy.set("tpv_costrate", exchangeRate);
                    }
                }
            }
            this.getView().updateView("tpv_dt_freigroambill_f");
        }
    }

//	@Override
//	public void afterAddRow(AfterAddRowEventArgs e) {
//		String name = e.getEntryProp().getName();
//		int i = 0;
//		RowDataEntity[] rowdata = e.getRowDataEntities();
//		for (RowDataEntity rdata : rowdata) {
//			i = rdata.getRowIndex();
//		}
//		switch (name) {
//			case "tpv_dt_freigroambill_f"://费用分录
//				EntryGrid entryGrid = this.getControl("tpv_materialentry");//商品明细
//				int selectRows[] = entryGrid.getSelectRows();//获取选中的行号
//				BigDecimal tpv_billablequantitys=BigDecimal.ZERO;
//				DynamicObject dataEntity = this.getModel().getDataEntity(true);
//				DynamicObjectCollection tpv_materialentrys=dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品分录
//				int entryCurrentRowIndex = this.getModel().getEntryCurrentRowIndex("tpv_dt_freigroambill_f");
//				for (int row : selectRows) {
//					DynamicObject tpv_materialentry=tpv_materialentrys.get(row);
//					BigDecimal tpv_qty=tpv_materialentry.getBigDecimal("tpv_qty");//数量
//					DynamicObjectCollection tpv_dt_freigroambill_f=tpv_materialentry.getDynamicObjectCollection("tpv_dt_freigroambill_f");//费用分录
//					for(DynamicObject freigroambill_f:tpv_dt_freigroambill_f){
//						//@Author LinRui begin
//						DynamicObject tpv_currency = freigroambill_f.getDynamicObject("tpv_costcurrency");  //结算币别
//						if (null != tpv_currency) {
//							Object tpv_exratetable = this.getModel().getValue("tpv_exratetable");
//							Object tpv_currencybase = this.getModel().getValue("tpv_currencybase"); //本位币
//							Date tpv_exratedate = (Date) this.getModel().getValue("tpv_exratedate");
//							BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
//							BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
//							BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
//							this.getModel().setValue("tpv_costrate", exchangeRate,i);
//						}
//						//@Author LinRui end
//						tpv_billablequantitys=tpv_billablequantitys.add(freigroambill_f.getBigDecimal("tpv_billablequantitys"));//计费数量
//					}
//					BigDecimal decimal = tpv_qty.subtract(tpv_billablequantitys);
//					if (decimal.compareTo(BigDecimal.ZERO) < 0) {
//						this.getModel().deleteEntryRow("tpv_dt_freigroambill_f",entryCurrentRowIndex);
//					} else {
//						this.getModel().setValue("tpv_billablequantitys",tpv_qty.subtract(tpv_billablequantitys),i);
//					}
//				}
//				break;
//			default:
//				break;
//		}
//	}


    /**
     * @param e 值改变事件
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();
        switch (name) {
            case "tpv_arrpreno"://到单单号
                arrivalDate();//带出到单日期
                break;
            case "tpv_begindate"://开始日期
            case "tpv_finishdate"://结束日期
//                verificationDate("tpv_begindate", "tpv_finishdate", "开始日期", "结束日期");//日期校验
                break;
            case "tpv_boatdestartdate"://船板控货开始日期
            case "tpv_boatdeenddate"://船板控货结束日期
                verificationDate("tpv_boatdestartdate", "tpv_boatdeenddate", "船板控货开始日期", "船板控货结束日期");//日期校验
                break;
            case "tpv_shipdate"://装船日期
            case "tpv_etadate"://预计到港日期
                verificationDate("tpv_shipdate", "tpv_etadate", "装船日期", "预计到港日期");//日期校验
                break;
//           case "tpv_quantity"://卷号分录-数量
//        	   verificationVolume();//校验卷号数量
//        	   break;

            //@Author LinRui begin
            case "tpv_costcurrency":
                this.setExchangeRate();
                break;
            case "tpv_exratetable":
            case "tpv_exratedate":
            case "tpv_currencybase":
                setSubEntryExchangeRate();
                break;
            //@Author LinRui end
            case "tpv_warehouses":
            case "tpv_directstorage":
                tpvWarehouses();
            default:
                break;
        }
    }

    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        super.afterAddRow(e);
        String name = e.getEntryProp().getName();
        switch (name) {
            case "tpv_materialentry":
                tpvWarehouses();
                break;
            case "tpv_dt_freigroambill_f":
//                tpvDtDreigroambill();
                break;
        }
    }

    private void tpvDtDreigroambill() {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObject tpvCustcarrier = (DynamicObject) model.getValue("tpv_custcarrier");//保管/承运方
        DynamicObjectCollection tpvMaterialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品分录
        for (DynamicObject dynamicObject : tpvMaterialentry) {
            DynamicObjectCollection tpvDtFreigroambillF = dynamicObject.getDynamicObjectCollection("tpv_dt_freigroambill_f");//费用信息分录
            if (tpvDtFreigroambillF.size() != 0) {
                tpvDtFreigroambillF.get(tpvDtFreigroambillF.size() - 1).set("tpv_providers", tpvCustcarrier);//物流服务商
                this.getView().updateView("tpv_dt_freigroambill_f");
            }
        }
    }

    private void tpvWarehouses() {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObject tpvWarehouses = null;
        Boolean tpvDirectstorage = (Boolean) model.getValue("tpv_directstorage");
        if (tpvDirectstorage) {
            tpvWarehouses = (DynamicObject) model.getValue("tpv_warehouses");
        } else {
            model.setValue("tpv_warehouses", null);
        }
        DynamicObjectCollection tpvMaterialentrys = dataEntity.getDynamicObjectCollection("tpv_materialentry");
        for (int i = 0; i < tpvMaterialentrys.size(); i++) {
            model.setValue("tpv_warehouse", tpvWarehouses, i);
        }
    }

    /**
     * @Author LinRui
     * 费用分录 -子分录，根据费用币别获取子分录对应行汇率
     */
    private void setExchangeRate() {
        int index = this.getModel().getEntryCurrentRowIndex("tpv_dt_freigroambill_f");
        Object tpv_exratetable = this.getModel().getValue("tpv_exratetable");
        Object tpv_currency = this.getModel().getValue("tpv_costcurrency", index);  //结算币别
        Object tpv_currencybase = this.getModel().getValue("tpv_currency"); //本位币
        Date tpv_exratedate = (Date) this.getModel().getValue("tpv_exratedate");
        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
        BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
        this.getModel().setValue("tpv_costrate", exchangeRate, index);
    }

    /**
     * @Author LinRui
     * 费用分录 -子分录，根据费用币别获取子分录对应行汇率
     */
    private void setSubEntryExchangeRate() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvMaterialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");
        if (tpvMaterialentry.size() > 0) {
            for (int i = 0; i < tpvMaterialentry.size(); i++) {
                DynamicObject dynamicObject = tpvMaterialentry.get(i);
                DynamicObjectCollection tpvDtFreigroambillF = dynamicObject.getDynamicObjectCollection("tpv_dt_freigroambill_f");
                if (tpvDtFreigroambillF.size() > 0) {
                    this.getModel().setEntryCurrentRowIndex("tpv_materialentry", i);
                    for (int i1 = 0; i1 < tpvDtFreigroambillF.size(); i1++) {
                        DynamicObject object = tpvDtFreigroambillF.get(i1);
                        DynamicObject tpv_currency = object.getDynamicObject("tpv_costcurrency");
                        if (null != tpv_currency) {
                            Object tpv_exratetable = this.getModel().getValue("tpv_exratetable");
                            Object tpv_currencybase = this.getModel().getValue("tpv_currencybase"); //本位币
                            Date tpv_exratedate = (Date) this.getModel().getValue("tpv_exratedate");
                            BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
                            BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
                            BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
                            this.getModel().setValue("tpv_costrate", exchangeRate, i1);
                        }
                    }
                }
            }
        }
    }

    /**
     * 带出到单日期
     */
    private void arrivalDate() {
        DynamicObject arrpreno = (DynamicObject) this.getModel().getValue("tpv_arrpreno");//到单
        String billno = arrpreno.getString("billno");//到单日期
        Date arrivaldate = new Date();
        String selectFieid2 = DynamicObjectUtil.getSelectfields("lc_arrival", false);// 获取单据头所有字段标识
        DynamicObject[] bills = BusinessDataServiceHelper.load("lc_arrival", selectFieid2, new QFilter[]{new QFilter("billno", QCP.equals, billno)});
        if (bills.length > 0) {
            for (DynamicObject bill : bills) {
                arrivaldate = bill.getDate("arrivaldate");
            }
            this.getModel().setValue("tpv_singledate", arrivaldate);
        }
    }

    /**
     * 校验日期
     */
    private void verificationDate(String start, String end, String startname, String endname) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Date tpv_begindate = dataEntity.getDate(start);//开始日期
        Date tpv_finishdate = dataEntity.getDate(end);//结束日期
        if (tpv_begindate != null && tpv_finishdate != null && tpv_begindate.getTime() > tpv_finishdate.getTime()) {
            FieldTip fieldTip = new FieldTip();
            fieldTip.setFieldKey(end);
            fieldTip.setLevel(FieldTip.FieldTipsLevel.Info);
            fieldTip.setSuccess(false);
            fieldTip.setTipsType(FieldTip.FieldTipsTypes.others);
            fieldTip.setTip(endname + "不能小于" + startname + "!");
            this.getView().showFieldTip(fieldTip);
            this.getModel().setValue(end, tpv_begindate);
        }
    }


    /**
     * 日期范围
     */
    private void dateRange() {
        DateEdit begindate = this.getView().getControl("tpv_begindate");//开始日期
        DateEdit finishdate = this.getView().getControl("tpv_finishdate");//结束日期
        DateEdit aogdate = this.getView().getControl("tpv_aogdate");//到货日期
        DateEdit actarrdate = this.getView().getControl("tpv_actarrdate");//实际到港日期
        DateEdit delivdate = this.getView().getControl("tpv_delivdate");//交货日期
        DateEdit boatdestartdate = this.getView().getControl("tpv_boatdestartdate");//船板控货开始日期
        DateEdit boatdeenddate = this.getView().getControl("tpv_boatdeenddate");//船板控货结束日期
        Date tpv_bizdate = (Date) this.getModel().getValue("tpv_bizdate");//业务日期
        begindate.setMinDate(tpv_bizdate);
        finishdate.setMinDate(tpv_bizdate);
        aogdate.setMinDate(tpv_bizdate);
        actarrdate.setMinDate(tpv_bizdate);
        delivdate.setMinDate(tpv_bizdate);
        boatdestartdate.setMinDate(tpv_bizdate);
        boatdeenddate.setMinDate(tpv_bizdate);
    }

    /**
     * @param e 校验卷号
     */
    private void verificationVolume() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        int rowIndex = this.getModel().getEntryCurrentRowIndex("tpv_materialentry");
        BigDecimal tpv_qty = (BigDecimal) this.getModel().getValue("tpv_qty", rowIndex);//商品分录数量
        BigDecimal tpv_quantity = BigDecimal.ZERO;//卷号数量合计
        DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品明细
        for (DynamicObject matertrty : materialentry) {
            DynamicObjectCollection subentryentity = matertrty.getDynamicObjectCollection("tpv_subentryentity");//卷号管理
            int row = matertrty.getInt("Seq");
            if ((rowIndex + 1) == row && subentryentity.size() > 0) {
                for (DynamicObject subentrty : subentryentity) {
                    tpv_quantity = tpv_quantity.add(subentrty.getBigDecimal("tpv_quantity"));
                }
                if (tpv_quantity.compareTo(tpv_qty) > 0) {
                    this.getModel().setValue("tpv_quantity", null);
                    this.getView().showErrorNotification("卷号总数量不能大于商品数量!");
                }
            }
        }
    }
}
