package com.itopview.wm.dt.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.control.EntryGrid;

import java.math.BigDecimal;

/**
 * @author yhj
 * @version 1.0
 * @description: 卷号总数量不能大于商品数量
 * @date 2023/8/8 11:32
 */
public class IinsuranceFormPlugin extends AbstractBillPlugIn {
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();
        switch (name) {
            case "tpv_quantity"://卷号分录-数量
                verificationVolume();//校验卷号数量
                break;
            default:
                break;
        }
    }



    private void verificationVolume() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        int rowIndex = this.getModel().getEntryCurrentRowIndex("billentry");
        BigDecimal tpvQty = (BigDecimal) this.getModel().getValue("qty", rowIndex);//商品分录数量
        BigDecimal tpvQuantity = BigDecimal.ZERO;//卷号数量合计
        DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("billentry");//商品明细
        for (DynamicObject matertrty : materialentry) {
            DynamicObjectCollection subentryentity = matertrty.getDynamicObjectCollection("tpv_dt_purinbill_j");//卷号管理
            int row = matertrty.getInt("Seq");
            if ((rowIndex + 1) == row && subentryentity.size() > 0) {
                for (DynamicObject subentrty : subentryentity) {
                    tpvQuantity = tpvQuantity.add(subentrty.getBigDecimal("tpv_quantity"));
                }
                if (tpvQuantity.compareTo(tpvQty) > 0) {
                    this.getModel().setValue("tpv_quantity", null);
                    this.getView().showErrorNotification("卷号总数量不能大于商品数量!");
                }
            }
        }
    }
}
