package com.itopview.wm.dt.formplugin.form;

import java.math.BigDecimal;
import java.util.*;

import com.itopview.wm.utils.DynamicObjectUtil;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.FormOperate;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

public class PublicBillFromPlug extends AbstractBillPlugIn implements RowClickEventListener {
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String key = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();
        switch (key) {
            case "tpv_material"://物料编码
            case "tpv_specation"://规格
            case "tpv_shader"://材质
            case "tpv_origin"://产地
            case "tpv_richardinput"://按理计输入
            case "tpv_packnum"://包装数量
            case "tpv_coefficients"://系数
                changeCoefficient();
                break;
            case "tpv_coefficient"://商品明细表头-系数
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                BigDecimal tpv_coefficient = dataEntity.getBigDecimal("tpv_coefficient");//表头系数
                EntryGrid entryGrid = this.getControl("billentry");//商品明细
                int selectRows[] = entryGrid.getSelectRows();//获取选中的行号
                for (int row : selectRows) {
                    this.getModel().setValue("tpv_coefficients", tpv_coefficient, row);
                }
                break;
            default:
                break;
        }
    }

//    /**
//     * 按钮操作执行前监听
//     * 阻止复制行
//     *
//     * @param args
//     */
//    @Override
//    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
//        super.beforeDoOperation(args);
//        FormOperate operate = (FormOperate) args.getSource();
//        String key = operate.getOperateKey();
//        if (key.equals("newentry2")) {
//            //获取单据体控件  校验
//            EntryGrid entryGrid = this.getControl("billentry");//商品明细
//            int selectRows[] = entryGrid.getSelectRows();//获取选中的行号
//            BigDecimal tpv_billablequantitys = BigDecimal.ZERO;
//            DynamicObject dataEntity = this.getModel().getDataEntity(true);
//            DynamicObjectCollection tpv_materialentry = dataEntity.getDynamicObjectCollection("billentry");//商品分录
//            int entryCurrentRowIndex = this.getModel().getEntryCurrentRowIndex("tpv_dt_purinbill_f");
//            for (int row : selectRows) {
//                DynamicObject tpv_materialentrys = tpv_materialentry.get(row);
//                BigDecimal tpv_qtys = tpv_materialentrys.getBigDecimal("qty");//数量
//                DynamicObjectCollection tpv_dt_purinbill_f = tpv_materialentrys.getDynamicObjectCollection("tpv_dt_purinbill_f");//费用分录
//                for (DynamicObject purinbill_f : tpv_dt_purinbill_f) {
//                    tpv_billablequantitys = tpv_billablequantitys.add(purinbill_f.getBigDecimal("tpv_chargequantity"));//计费数量
//                }
//                BigDecimal decimal = tpv_qtys.subtract(tpv_billablequantitys);
//                if (decimal.compareTo(BigDecimal.ZERO) < 0) {
//                    decimal = BigDecimal.ZERO;
//                    this.getView().showMessage("增行操作取消");
//                    this.getModel().setValue("tpv_chargequantity", decimal, entryCurrentRowIndex);
//                } else {
//                    this.getModel().setValue("tpv_chargequantity", tpv_qtys.subtract(tpv_billablequantitys));
//                }
//            }
//            args.setCancel(true);
//        }
//    }

//    /**
//     * @param e 新增行表头系数赋值到分录
//     */
//    @Override
//    public void afterAddRow(AfterAddRowEventArgs e) {
//        super.afterAddRow(e);
//        int i = 0;
//
//        String name = e.getEntryProp().getName();
//        RowDataEntity[] rowIndex = e.getRowDataEntities();
//        if (StringUtils.equals("billentry", name)) {
//            outCoefficient(rowIndex);
//        }
//        for (RowDataEntity rdata : rowIndex) {
//            i = rdata.getRowIndex();
//        }
//        EntryGrid entryGrid = this.getControl("billentry");//商品明细
//        int selectRows[] = entryGrid.getSelectRows();//获取选中的行号
//        int insertRow = e.getInsertRow();
//        BigDecimal tpv_billablequantitys = BigDecimal.ZERO;
//        DynamicObject dataEntity = this.getModel().getDataEntity(true);
//        DynamicObjectCollection tpv_materialentry = dataEntity.getDynamicObjectCollection("billentry");//商品分录
//        int entryCurrentRowIndex = this.getModel().getEntryCurrentRowIndex("tpv_dt_purinbill_f");
//        switch (name) {
//            case "tpv_im_otherinbill_f"://其他入库单费用分录
//                for (int row : selectRows) {
//                    DynamicObject tpv_materialentrys = tpv_materialentry.get(row);
//                    //BigDecimal tpv_qty = tpv_materialentrys.getBigDecimal("qty");//数量
//                    DynamicObjectCollection tpv_dt_freigroambill_f = tpv_materialentrys.getDynamicObjectCollection("tpv_im_otherinbill_f");//费用分录
//                    for (DynamicObject freigroambill_f : tpv_dt_freigroambill_f) {
//                        tpv_billablequantitys = tpv_billablequantitys.add(freigroambill_f.getBigDecimal("tpv_chargequantity"));//计费数量
//                    }
//                   // BigDecimal decimal = tpv_qty.subtract(tpv_billablequantitys);
//                    if (decimal.compareTo(BigDecimal.ZERO) < 0) {
//                        this.getModel().deleteEntryRow("tpv_dt_purinbill_f",entryCurrentRowIndex);
//                    } else {
//                        this.getModel().setValue("tpv_chargequantity", tpv_qty.subtract(tpv_billablequantitys), i);
//                    }
//                }
//                break;
//            case "tpv_dt_transinbill_f"://分步调入单费用分录
//                for (int row : selectRows) {
//                    DynamicObject tpv_materialentrys = tpv_materialentry.get(row);
//                    BigDecimal tpv_qtys = tpv_materialentrys.getBigDecimal("qty");//数量
//                    DynamicObjectCollection tpv_dt_transinbill_f = tpv_materialentrys.getDynamicObjectCollection("tpv_dt_transinbill_f");//费用分录
//                    for (DynamicObject transinbill_f : tpv_dt_transinbill_f) {
//                        tpv_billablequantitys = tpv_billablequantitys.add(transinbill_f.getBigDecimal("tpv_chargequantity"));//计费数量
//                    }
//                    BigDecimal decimal = tpv_qtys.subtract(tpv_billablequantitys);
//                    if (decimal.compareTo(BigDecimal.ZERO) < 0) {
//                        this.getModel().deleteEntryRow("tpv_dt_purinbill_f",entryCurrentRowIndex);
//                    } else {
//                        this.getModel().setValue("tpv_chargequantity",  tpv_qtys.subtract(tpv_billablequantitys), i);
//                    }
//                }
//                break;
//            case "tpv_dt_purinbill_f"://采购入库费用分录
//                for (int row : selectRows) {
//                    DynamicObject tpv_materialentrys = tpv_materialentry.get(row);
//                    BigDecimal tpv_qtys = tpv_materialentrys.getBigDecimal("qty");//数量
//                    DynamicObjectCollection tpv_dt_purinbill_f = tpv_materialentrys.getDynamicObjectCollection("tpv_dt_purinbill_f");//费用分录
//                    for (DynamicObject purinbill_f : tpv_dt_purinbill_f) {
//                        tpv_billablequantitys = tpv_billablequantitys.add(purinbill_f.getBigDecimal("tpv_chargequantity"));//计费数量
//                    }
//                    BigDecimal decimal = tpv_qtys.subtract(tpv_billablequantitys);
//                    if (decimal.compareTo(BigDecimal.ZERO) < 0) {
//                        this.getModel().deleteEntryRow("tpv_dt_purinbill_f",entryCurrentRowIndex);
//                    } else {
//                        this.getModel().setValue("tpv_chargequantity",  tpv_qtys.subtract(tpv_billablequantitys), i);
//                    }
//                }
//                break;
//            case "tpv_dt_transdirbill_f"://直接调拨单分录
//                for (int row : selectRows) {
//                    DynamicObject tpv_materialentrys = tpv_materialentry.get(row);
//                    BigDecimal tpv_qtys = tpv_materialentrys.getBigDecimal("qty");//数量
//                    DynamicObjectCollection tpv_dt_transdirbill_f = tpv_materialentrys.getDynamicObjectCollection("tpv_dt_transdirbill_f");//费用分录
//                    for (DynamicObject transdirbill_f : tpv_dt_transdirbill_f) {
//                        tpv_billablequantitys = tpv_billablequantitys.add(transdirbill_f.getBigDecimal("tpv_chargequantity"));//计费数量
//                    }
//                    BigDecimal decimal = tpv_qtys.subtract(tpv_billablequantitys);
//                    if (decimal.compareTo(BigDecimal.ZERO) < 0) {
//                        this.getModel().deleteEntryRow("tpv_dt_purinbill_f",entryCurrentRowIndex);
//                    } else {
//                        this.getModel().setValue("tpv_chargequantity",  tpv_qtys.subtract(tpv_billablequantitys), i);
//                    }
//                }
//                break;
//            case "tpv_dt_transoutbill_f"://分步调出单分录
//                for (int row : selectRows) {
//                    DynamicObject tpv_materialentrys = tpv_materialentry.get(row);
//                    BigDecimal tpv_qtys = tpv_materialentrys.getBigDecimal("qty");//数量
//                    DynamicObjectCollection tpv_dt_transoutbill_f = tpv_materialentrys.getDynamicObjectCollection("tpv_dt_transoutbill_f");//费用分录
//                    for (DynamicObject transoutbill_f : tpv_dt_transoutbill_f) {
//                        tpv_billablequantitys = tpv_billablequantitys.add(transoutbill_f.getBigDecimal("tpv_chargequantity"));//计费数量
//                    }
//                    BigDecimal decimal = tpv_qtys.subtract(tpv_billablequantitys);
//                    if (decimal.compareTo(BigDecimal.ZERO) < 0) {
//                        this.getModel().deleteEntryRow("tpv_dt_purinbill_f",entryCurrentRowIndex);
//                    } else {
//                        this.getModel().setValue("tpv_chargequantity",  tpv_qtys.subtract(tpv_billablequantitys), i);
//                    }
//                }
//                break;
//            default:
//                break;
//        }
//    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        EntryGrid entryGrid = this.getView().getControl("billentry");//商品明细
        entryGrid.addRowClickListener(this);
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        EntryGrid entryGrid = (EntryGrid) evt.getSource();
        if (StringUtils.equals("billentry", entryGrid.getKey())) {
            int row = evt.getRow();//选中行数
            if (row >= 0) {
                DynamicObjectCollection entity = this.getModel().getEntryEntity("billentry");//商品明细
                DynamicObject dynamicObject = entity.get(row);//数据
                Boolean tpv_richardinputsx = dynamicObject.getBoolean("tpv_richardinputsx");
                String tpv_sourceofcoeffsx = dynamicObject.getString("tpv_sourceofcoeffsx");
                this.getModel().setValue("tpv_richardinput", tpv_richardinputsx);
                this.getModel().setValue("tpv_sourceofcoeff", tpv_sourceofcoeffsx);
            }
        }
    }

    /**
     * 增行时表头系数赋值到分录
     */
    private void outCoefficient(RowDataEntity[] dataentuty) {
        for (RowDataEntity rowdata : dataentuty) {
            int row = rowdata.getRowIndex();
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            String sourceofcoeff = (String) this.getModel().getValue("tpv_sourceofcoeff");//系数来源
            BigDecimal tpv_coefficient = dataEntity.getBigDecimal("tpv_coefficient");
            DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("billentry");//商品明细
            Boolean richardinput = dataEntity.getBoolean("tpv_richardinput");//按理计输入
            this.getModel().setValue("tpv_richardinputsx", richardinput, row);
            this.getModel().setValue("tpv_sourceofcoeffsx", sourceofcoeff, row);
            this.getModel().setValue("tpv_coefficients", tpv_coefficient, row);
            Long mid = 0l;//商品明细物料
            Long oid = 0l;//商品明细产地
            if (richardinput) {
                this.getView().setEnable(false, row, "qty"); //数量
                this.getView().setEnable(false, row, "tpv_coefficients"); //系数
            } else {
                this.getView().setEnable(true, row, "qty"); //数量
                this.getView().setEnable(true, row, "tpv_coefficients"); //系数
            }
            if ("A".equals(sourceofcoeff) && materialentry.size() > 0) {
                DynamicObject material = (DynamicObject) this.getModel().getValue("material", row);//物料
                if (material != null) {
                    mid = material.getLong("id");
                }
                String specation = (String) this.getModel().getValue("tpv_specation", row);//规格
                String shader = (String) this.getModel().getValue("tpv_shader", row);//材质
                DynamicObject origin = (DynamicObject) this.getModel().getValue("tpv_origin", row);//产地
                if (origin != null) {
                    oid = origin.getLong("id");
                }
                if (mid != 0 && specation != null && shader != null && oid != 0) {
                    String selectFieid = DynamicObjectUtil.getSelectfields("tpv_rationalization", false);// 获取单据头所有字段标识
                    selectFieid = DynamicObjectUtil.getEntrySelectfields(selectFieid, "tpv_rationalization", "tpv_rationalization_lj",
                            false);// 获取分录所有字段标识
                    DynamicObject[] suitUsers = BusinessDataServiceHelper.load("tpv_rationalization", selectFieid, new QFilter[]{
                            (new QFilter("tpv_rationalization_lj.tpv_material.id", QCP.equals, mid)
                                    .and(new QFilter("tpv_rationalization_lj.tpv_specation", QCP.equals, specation))
                                    .and(new QFilter("tpv_rationalization_lj.tpv_shader", QCP.equals, shader))
                                    .and(new QFilter("tpv_rationalization_lj.tpv_origin.id", QCP.equals, oid)))
                    });
                    if (suitUsers.length > 0) {
                        for (DynamicObject entrty : suitUsers) {
                            DynamicObjectCollection rationalization = entrty.getDynamicObjectCollection("tpv_rationalization_lj");
                            for (DynamicObject entity : rationalization) {
                                Long mater = entity.getLong("tpv_material.id");
                                String speca = entity.getString("tpv_specation");
                                String shade = entity.getString("tpv_shader");
                                Long orig = entity.getLong("tpv_origin.id");
                                if (mater.equals(mid) && speca.equals(specation) && shade.equals(shader) && orig.equals(oid)) {
                                    BigDecimal coefficients = entity.getBigDecimal("tpv_tonnum");
                                    this.getModel().setValue("tpv_coefficients", coefficients, row);
                                } else {
                                    this.getModel().setValue("tpv_coefficients", null, row);
                                }
                            }
                        }
                    } else {
                        this.getModel().setValue("tpv_coefficients", null, row);
                    }
                } else {
                    this.getModel().setValue("tpv_coefficients", null, row);
                }
            }
//            if ("B".equals(sourceofcoeff) && materialentry.size() > 0) {
//                BigDecimal coefficient = dataEntity.getBigDecimal("tpv_coefficient");//系数
//                if (coefficient.compareTo(BigDecimal.ZERO) > 0) {
//                    this.getModel().setValue("tpv_coefficients", coefficient, row);
//                } else {
//                    this.getModel().setValue("tpv_coefficients", null, row);
//                }
//            }
        }
    }


    /**
     * 表头系数，物料，规格，材质，改变时赋值分录系数
     */
    private void changeCoefficient() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        String sourceofcoeff = (String) this.getModel().getValue("tpv_sourceofcoeff");//系数来源
        DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("billentry");//商品明细
        Boolean richardinput = dataEntity.getBoolean("tpv_richardinput");//按理计输入
        EntryGrid entryGrid = this.getControl("billentry");//商品明细
        int selectRows[] = entryGrid.getSelectRows();//获取选中的行号
        if (materialentry.size() > 0) {
            int row = this.getModel().getEntryCurrentRowIndex("billentry");
            this.getModel().setValue("tpv_richardinputsx", richardinput, row);
            this.getModel().setValue("tpv_sourceofcoeffsx", sourceofcoeff, row);
        }
        Long mid = 0l;//商品明细物料
        Long oid = 0l;//商品明细产地
        if (selectRows != null && selectRows.length > 0) {
            for (int rowIndex : selectRows) {
                Boolean richardinputs = (Boolean) this.getModel().getValue("tpv_richardinputsx", rowIndex);////按理计输入
                String sourceofcoeffs = (String) this.getModel().getValue("tpv_sourceofcoeffsx", rowIndex);//系数来源
                if (richardinput) {
                    this.getView().setEnable(false, rowIndex, "qty"); //数量
                    this.getView().setEnable(false, rowIndex, "tpv_coefficients"); //系数
                    BigDecimal packnum = (BigDecimal) this.getModel().getValue("tpv_packnum", rowIndex);//包装数量
                    BigDecimal coefficients = (BigDecimal) this.getModel().getValue("tpv_coefficients", rowIndex);//系数
                    if (packnum.compareTo(BigDecimal.ZERO) > 0 && coefficients.compareTo(BigDecimal.ZERO) > 0) {
                        this.getModel().setValue("qty", packnum.multiply(coefficients), rowIndex);
                    } else {
                        this.getModel().setValue("qty", BigDecimal.ZERO, rowIndex);
                    }
                } else {
                    this.getView().setEnable(true, rowIndex, "qty"); //数量
                    this.getView().setEnable(true, rowIndex, "tpv_coefficients"); //系数
                }
                if ("A".equals(sourceofcoeff) && materialentry.size() > 0) {
                    DynamicObject material = (DynamicObject) this.getModel().getValue("material", rowIndex);//物料
                    if (material != null) {
                        mid = material.getLong("id");
                    }
                    String specation = (String) this.getModel().getValue("tpv_specation", rowIndex);//规格
                    String shader = (String) this.getModel().getValue("tpv_shader", rowIndex);//材质
                    DynamicObject origin = (DynamicObject) this.getModel().getValue("tpv_origin", rowIndex);//产地
                    if (origin != null) {
                        oid = origin.getLong("id");
                    }
                    if (mid != 0 && specation != null && shader != null && oid != 0) {
                        String selectFieid = DynamicObjectUtil.getSelectfields("tpv_rationalization", false);// 获取单据头所有字段标识
                        selectFieid = DynamicObjectUtil.getEntrySelectfields(selectFieid, "tpv_rationalization", "tpv_rationalization_lj",
                                false);// 获取分录所有字段标识
                        DynamicObject[] suitUsers = BusinessDataServiceHelper.load("tpv_rationalization", selectFieid, new QFilter[]{
                                (new QFilter("tpv_rationalization_lj.tpv_material.id", QCP.equals, mid)
                                        .and(new QFilter("tpv_rationalization_lj.tpv_specation", QCP.equals, specation))
                                        .and(new QFilter("tpv_rationalization_lj.tpv_shader", QCP.equals, shader))
                                        .and(new QFilter("tpv_rationalization_lj.tpv_origin.id", QCP.equals, oid)))
                        });
                        if (suitUsers.length > 0) {
                            for (DynamicObject entrty : suitUsers) {
                                DynamicObjectCollection rationalization = entrty.getDynamicObjectCollection("tpv_rationalization_lj");
                                for (DynamicObject entity : rationalization) {
                                    Long mater = entity.getLong("tpv_material.id");
                                    String speca = entity.getString("tpv_specation");
                                    String shade = entity.getString("tpv_shader");
                                    Long orig = entity.getLong("tpv_origin.id");
                                    if (mater.equals(mid) && speca.equals(specation) && shade.equals(shader) && orig.equals(oid)) {
                                        BigDecimal coefficients = entity.getBigDecimal("tpv_tonnum");
                                        this.getModel().setValue("tpv_coefficients", coefficients, rowIndex);
                                    } else {
                                        this.getModel().setValue("tpv_coefficients", null, rowIndex);
                                    }
                                }
                            }
                        } else {
                            this.getModel().setValue("tpv_coefficients", null, rowIndex);
                        }
                    } else {
                        this.getModel().setValue("tpv_coefficients", null, rowIndex);
                    }
                }
//                if ("B".equals(sourceofcoeff) && materialentry.size() > 0) {
//                    BigDecimal coefficient = dataEntity.getBigDecimal("tpv_coefficient");//系数
//                    DynamicObjectCollection tpv_materialentry = dataEntity.getDynamicObjectCollection("billentry");//明细分录
//                    if (tpv_materialentry.size() > 0) {
//                        if (coefficient.compareTo(BigDecimal.ZERO) > 0) {
//                            this.getModel().setValue("tpv_coefficients", coefficient, rowIndex);
//                        } else {
//                            this.getModel().setValue("tpv_coefficients", null, rowIndex);
//                        }
//                    }
//                }
            }
        }
    }
}
