package com.itopview.wm.dt.formplugin.form;

import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.AfterDeleteRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.RefBillProp;
import kd.bos.entity.report.CellStyle;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.form.*;
import kd.bos.form.control.AbstractGrid;
import kd.bos.form.control.AttachmentPanel;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.UploadEvent;
import kd.bos.form.control.events.UploadListener;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.events.MessageBoxClosedEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.DateTimeEdit;
import kd.bos.form.field.RefBillEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.report.ReportShowParameter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.scm.common.util.DynamicObjectUtil;

import java.math.BigDecimal;
import java.util.*;

/**
 * @author GX
 * 采购合同-表单插件
 */
public class PurChaseFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener, UploadListener {

    /**
     * 打开事件
     */
    @Override
    public void afterBindData(EventObject e) {
        super.afterCreateNewData(e);
        // LinRui begin 描述，带出提交类型的名称
        DynamicObject tpvTypeofreward = (DynamicObject) this.getModel().getValue("tpv_typeofreward");
        if (null != tpvTypeofreward) {
            this.getModel().setValue("tpv_typeofrewardname", tpvTypeofreward.getString("name"));
        } else {
            this.getModel().setValue("tpv_typeofrewardname", null);
        }
        // LinRui end
    }


    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        addYearDay();
        tradecountry();
    }

    @Override
    public void afterCopyData(EventObject e) {
        super.afterCopyData(e);
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvMaterialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");
        if (tpvMaterialentry.size() > 0) {
            for (int i = 0; i < tpvMaterialentry.size(); i++) {
                DynamicObject dynamicObject = tpvMaterialentry.get(i);
                this.getModel().setValue("tpv_effectiveqty", dynamicObject.getBigDecimal("tpv_qty"), i);
                this.getModel().setValue("tpv_uncirculated", dynamicObject.getBigDecimal("tpv_qty"), i);
            }
        }
    }

    private void tradecountry() {
        DynamicObject value = (DynamicObject) this.getModel().getValue("tpv_document");
        if (value != null) {
            String number = value.getString("number");
            switch (number) {
                case "tpv_dt_purchase_BT":
                    this.getModel().setValue("tpv_tradeproperty", BusinessDataServiceHelper.loadSingle("tpv_bd_tradeproperty", new QFilter[]{new QFilter("number", "=", "001")}));
                    this.getModel().setValue("tpv_paymentmethod", "B");
                    break;
                case "tpv_dt_purchase_JK":
                    this.getModel().setValue("tpv_tradeproperty", BusinessDataServiceHelper.loadSingle("tpv_bd_tradeproperty", new QFilter[]{new QFilter("number", "=", "002")}));
                    break;
                case "tpv_dt_purchase_CK":
                    this.getModel().setValue("tpv_tradeproperty", BusinessDataServiceHelper.loadSingle("tpv_bd_tradeproperty", new QFilter[]{new QFilter("number", "=", "003")}));
                    break;
                case "tpv_dt_purchase_ZK":
                    this.getModel().setValue("tpv_tradeproperty", BusinessDataServiceHelper.loadSingle("tpv_bd_tradeproperty", new QFilter[]{new QFilter("number", "=", "004")}));
                    break;
            }
        }
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs afterDoOperationEventArgs) {
        // TODO Auto-generated method stub
        super.afterDoOperation(afterDoOperationEventArgs);
        String name = afterDoOperationEventArgs.getOperateKey();
        if (StringUtils.equals("audit", name)) {
            Boolean tpv_contrtermin = (Boolean) this.getModel().getValue("tpv_contrtermin");//合同解除
            if (tpv_contrtermin) {
                this.getModel().setValue("tpv_contractstatusx", "E");//合同状态
            } else {
                this.getModel().setValue("tpv_contractstatusx", "D");//合同状态
            }
        }
        if (StringUtils.equals("unaudit", name)) {
            Boolean tpv_contrtermin = (Boolean) this.getModel().getValue("tpv_contrtermin");//合同解除
            if (tpv_contrtermin) {
                this.getModel().setValue("tpv_contractstatusx", "B");//合同状态
            }
        }
    }


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"tbmain"});
        BasedataEdit tpv_longtermag = (BasedataEdit) this.getView().getControl("tpv_longtermag");
        tpv_longtermag.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        BasedataEdit tpv_pointpricecontract = (BasedataEdit) this.getView().getControl("tpv_pointpricecontract");
        tpv_pointpricecontract.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        BasedataEdit tpv_combinationnumber = (BasedataEdit) this.getView().getControl("tpv_combinationnumber");
        tpv_combinationnumber.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        BasedataEdit tpv_typeofreward = (BasedataEdit) this.getView().getControl("tpv_typeofreward");
        tpv_typeofreward.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        BasedataEdit tpv_projectcon = (BasedataEdit) this.getView().getControl("tpv_projectcon");
        tpv_projectcon.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        AttachmentPanel attachmentPanel = this.getView().getControl("attachmentpanel");
        attachmentPanel.addUploadListener(this);
        RefBillEdit tpv_applicationform = (RefBillEdit) this.getView().getControl("tpv_applicationform");
        tpv_applicationform.addBeforeF7SelectListener((BeforeF7SelectListener) this);
    }

    @Override
    public void afterRemove(UploadEvent evt) {
        outdoublesignature();
    }

    /**
     * @param evt 监听保存
     */
    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        super.itemClick(evt);
        String key = evt.getItemKey();
        if (StringUtils.equals("tpv_updatestatus", key)) {//更新保险状态
            showInfoForm(this.getView());
        }
//        if (StringUtils.equals("tpv_modify", key)) {//修改是否轮库
//            showForm("tpv_tm_modify","tpv_modify");
//        }
//        if (StringUtils.equals("tpv_curfactor", key)) {//期现要素修正
//            showForm("tpv_tm_curfactor","tpv_curfactor");
//        }
        if (StringUtils.equals("tpv_baritemap", key)) {//货权齐
            this.getModel().setValue("tpv_cargostatus", "B");
            this.getView().invokeOperation("save");
        }
        if (StringUtils.equals("tpv_baritemapf", key)) {//反货权齐
            this.getModel().setValue("tpv_cargostatus", "A");
            this.getView().invokeOperation("save");
        }
        if (StringUtils.equals("tpv_payadjustbtn", key)) {//可付款金额调整
            showForm("tpv_dt_payadjustprice", "tpv_payadjustbtn");
        }
        if (StringUtils.equals("tpv_void", key)) {//作废
            //作废操作前让用户选择是否继续作废操作，在用户点击确认框上的按钮后，系统会调用confirmCallBack方法
            ConfirmCallBackListener confirmCallBackListener = new ConfirmCallBackListener("tpv_void", this);
            //设置页面确认框，参数为：标题，选项框类型，回调监听
            this.getView().showConfirm("是否确认作废？", MessageBoxOptions.YesNo, confirmCallBackListener);
        }
        if (StringUtils.equals("tpv_unvoid", key)) {//反作废
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            String tpvContractstatus = dataEntity.getString("tpv_contractstatusx");
            if ("H".equals(tpvContractstatus)) {
                //反作废操作前让用户选择是否继续反作废操作，在用户点击确认框上的按钮后，系统会调用confirmCallBack方法
                ConfirmCallBackListener confirmCallBackListener = new ConfirmCallBackListener("tpv_unvoid", this);
                //设置页面确认框，参数为：标题，选项框类型，回调监听
                this.getView().showConfirm("是否确认反作废？", MessageBoxOptions.YesNo, confirmCallBackListener);
            } else {
                this.getView().showTipNotification("合同状态为作废情况下，才允许点击此按钮操作！");
            }
        }
        if (StringUtils.equals("tpv_advanceoccupation", key)) {//预付款占用调整
            FormShowParameter showParameter = new FormShowParameter();
            showParameter.setStatus(OperationStatus.ADDNEW);
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            showParameter.setFormId("tpv_dt_advanceoccupation");
            showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_advanceoccupation"));
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            Map<String, Object> map = new HashMap<>();
            BigDecimal status = dataEntity.getBigDecimal("tpv_prepoccupancy");
            if (status != null) {
                map.put("tpv_prepoccupancy", status);
            }
            showParameter.setCustomParams(map);
            this.getView().showForm(showParameter);
        }
        //LinRui begin
        String rpt = "";
        Long supId = 0L;
        Long deptId = 0L;
        DynamicObject tpv_supplier = (DynamicObject) this.getModel().getValue("tpv_supplier");
        if (null != tpv_supplier) {
            supId = tpv_supplier.getLong("id");
        }
        DynamicObject tpv_department = (DynamicObject) this.getModel().getValue("tpv_department");
        if (null != tpv_department) {
            deptId = tpv_department.getLong("id");
        }
        if (StringUtils.equals("tpv_supplierinquiries", key)) {//查询供应商额度使用情况表
            rpt = "tpv_crm_suplimitusage";
            QFilter qFilter = new QFilter("enable", QCP.equals, "1");
            if (YEM.isNotEmpty(tpv_department)) {
                qFilter.and(new QFilter("id", QCP.equals, tpv_department.getLong("id")));
            }
            DynamicObject bosAdminorgs = BusinessDataServiceHelper.loadSingle("bos_adminorg", qFilter.toArray());
            if (YEM.isNotEmpty(bosAdminorgs) & YEM.isNotEmpty(tpv_department)) {
                DynamicObject orgpattern = bosAdminorgs.getDynamicObject("orgpattern");
                if (YEM.isNotEmpty(orgpattern)) {
                    String deptNumber = orgpattern.getString("number");
                    if ("OF-01".equals(deptNumber)) {
                        DynamicObjectCollection dynamicObjects = bosAdminorgs.getDynamicObjectCollection("structure");
                        if (dynamicObjects.size() > 0) {
                            for (DynamicObject dynamicObject : dynamicObjects) {
                                DynamicObject viewparent = dynamicObject.getDynamicObject("viewparent");
                                if (YEM.isNotEmpty(viewparent)) {
                                    deptId = viewparent.getLong("id");
                                }
                                break;
                            }
                        }
                    }
                }
            }
            supCreditRptDataSet(rpt, supId, deptId);
        }
        if (StringUtils.equals("tpv_supadvanceonequiries", key)) { //查询供应商单票额度报表
            rpt = "tpv_crm_supadvanceoneup";
            supCreditRptDataSet(rpt, supId, deptId);
        }
        //LinRui end
    }

    /**
     * 选择框回调函数
     */
    @Override
    public void confirmCallBack(MessageBoxClosedEvent messageBoxClosedEvent) {
        super.confirmCallBack(messageBoxClosedEvent);
        //判断是否是对应确认框的点击回调事件
        if (StringUtils.equals("tpv_void", messageBoxClosedEvent.getCallBackId())) {
            if (MessageBoxResult.Yes.equals(messageBoxClosedEvent.getResult())) {
                //如果点击确认按钮，则把当前页面相关值清空
                String bilno = (String) this.getModel().getValue("billno");//采购合同编码
                String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_dt_freigroambill", false);// 获取单据头所有字段标识
                DynamicObject[] frebills = BusinessDataServiceHelper.load("tpv_dt_freigroambill", selectFieid2, new QFilter[]{
                        new QFilter("tpv_corebillno", QCP.equals, bilno)});
                String selectFieid3 = DynamicObjectUtil.getSelectfields("tpv_tm_kyoping", false);// 获取单据头所有字段标识
                DynamicObject[] kybills = BusinessDataServiceHelper.load("tpv_tm_kyoping", selectFieid3, new QFilter[]{
                        new QFilter("tpv_corebillno", QCP.equals, bilno)});
                if (frebills.length < 1 && kybills.length < 1) {
                    String tpvContractstatusx = (String) this.getModel().getValue("tpv_contractstatusx");
                    this.getModel().setValue("tpv_oldcontractstatus", tpvContractstatusx);//合同状态-废除前数据
                    this.getModel().setValue("tpv_contractstatusx", "H");//合同状态-废除
                } else {
                    this.getView().showTipNotification("存在下游货物流转单或者协评单，不允许作废！");
                }
                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
            } else if (MessageBoxResult.No.equals(messageBoxClosedEvent.getResult())) {
                // 点击否的相关处理逻辑。。。。
            }
        }
        if (StringUtils.equals("tpv_unvoid", messageBoxClosedEvent.getCallBackId())) {
            if (MessageBoxResult.Yes.equals(messageBoxClosedEvent.getResult())) {
                String tpvOldcontractstatus = (String) this.getModel().getValue("tpv_oldcontractstatus");
                this.getModel().setValue("tpv_contractstatusx", tpvOldcontractstatus);//合同状态-废除前数据
                this.getModel().setValue("tpv_oldcontractstatus", null);
                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
            } else if (MessageBoxResult.No.equals(messageBoxClosedEvent.getResult())) {
                // 点击否的相关处理逻辑。。。。
            }
        }
    }

    private void supCreditRptDataSet(String rptbill, Long tpvSupplierId, Long tpvDepartmentId) {
        //打开报表页面
        ReportShowParameter reportShowParameter = new ReportShowParameter();
        reportShowParameter.getOpenStyle().setShowType(ShowType.Modal);
        reportShowParameter.setFormId(rptbill);
        StyleCss styleCss = new StyleCss();
        styleCss.setHeight("720");
        styleCss.setWidth("1200");
        //设置弹出表单的样式，宽，高等
        reportShowParameter.getOpenStyle().setInlineStyleCss(styleCss);
        // 设置报表过滤条件
        ReportQueryParam reportQueryParam = new ReportQueryParam();
        FilterInfo filterInfo = new FilterInfo();
        filterInfo.addFilterItem("tpv_supplier_f", tpvSupplierId);
        filterInfo.addFilterItem("tpv_dep_f", tpvDepartmentId);
        reportQueryParam.setFilter(filterInfo);
        reportShowParameter.setQueryParam(reportQueryParam);
        getView().showForm(reportShowParameter);
    }


    private void showForm(String a, String b) {//a:动态表单标识，b:回调标识
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId(a);
        showParameter.setCloseCallBack(new CloseCallBack(this, b));
        this.getView().showForm(showParameter);
    }

    /**
     * 设置打开动态表单
     */
    private void showInfoForm(IFormView view) {
        // 获取单据体
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId("tpv_salebackfillng");
        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_updatestatus"));
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Map<String, Object> map = new HashMap<>();
        String status = dataEntity.getString("tpv_insurancestatus");
        if (status != null) {
            map.put("tpv_insurancestatus", status);
        }
        long userID = UserServiceHelper.getCurrentUserId();
        map.put("tpv_statusoperators", userID);
        showParameter.setCustomParams(map);
        view.showForm(showParameter);
    }

    /**
     * 动态表单关闭回调事件
     */

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        HashMap<String, Object> values = (HashMap<String, Object>) e.getReturnData();
        if (StringUtils.equals(e.getActionId(), "tpv_updatestatus") && null != e.getReturnData()) {
            this.setInwardInfo(values);
        }
        if (StringUtils.equals(e.getActionId(), "tpv_modify")){
            this.getView().invokeOperation("save");
        }
        if (StringUtils.equals(e.getActionId(), "tpv_paypercebutton") && null != e.getReturnData()) {
            this.getModel().setValue("tpv_paypercent", values.get("tpv_paypercent"));
            this.getView().invokeOperation("save");
        }
        if (StringUtils.equals(e.getActionId(), "tpv_advanceoccupation") && null != e.getReturnData()) {
            IDataModel model = this.getModel();
            model.setValue("tpv_prepoccupancy", values.get("tpv_prepoccupancy"));
            this.getView().invokeOperation("save");
        }
        if (StringUtils.equals(e.getActionId(), "tpv_payadjustbtn")) {
            IDataModel model = this.getModel();
            model.setValue("tpv_payadjustamt", model.getValue("tpv_payadjustamt"));
            this.getView().invokeOperation("save");
        }
    }

    /**
     * 动态表单回填单据字段
     */
    private void setInwardInfo(Map<String, Object> values) {
        IDataModel model = this.getModel();
        model.setValue("tpv_statusoperators", values.get("tpv_statusoperators"));
        model.setValue("tpv_updatetime", values.get("tpv_updatetime"));
        model.setValue("tpv_insurancestatus", values.get("tpv_insurancestatus"));
        this.getView().invokeOperation("save");
    }

    /**
     * 日期范围
     */
    private void dateRange() {
        DateTimeEdit agreeddeliverydead = this.getView().getControl("tpv_agreeddeliverydeas");//约定交货期限
        DateTimeEdit paymentdate = this.getView().getControl("tpv_paymentdate");//预计付款日期
        Date tpv_bizdate = (Date) this.getModel().getValue("tpv_bizdate");//业务日期
        agreeddeliverydead.setMinDate(tpv_bizdate);
        paymentdate.setMinDate(tpv_bizdate);
    }


    /**
     * @param e 值改变事件
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        switch (name) {
            case "tpv_commoditygroup"://商品组距价差规则
                outPriceDifference();//带出组距价差分录
                break;
            case "tpv_paymentmethod"://付佣方式
            case "tpv_commissionunitpric"://佣金单价
            case "tpv_qty"://数量
                countCommission();//计算佣金
                volumeunp();//汇总未头寸业务数量
                break;
            case "tpv_payoodsrela"://款货关系
            case "tpv_useasingleticket"://使用单票额度
                paymentContract();
                controlPayment();//控制是否预付款合同
                isPayment();//是否货到付款
                break;
            case "tpv_loadingperiodfrom"://装期从
            case "tpv_loadingperiodto"://装期至
            case "tpv_latestshipmentdate"://最迟装运日期
                dateCheck();//日期校验
                break;
            case "tpv_businesstype"://业务类型
                verifybusinesstype();
                break;
            case "tpv_hbsptype_apt"://合并审批
                saveDate();
                break;
            case "tpv_contractnumber"://合同号
                gotoSpace();
                break;
            case "tpv_confirmpricediff"://确认差价
                verifyPricediff();
                break;
            case "tpv_salesarea"://销售大区
//                outBasePriceitems();
                break;
            case "tpv_estimatedplace":// 预计销售地
                this.getSuperior();
                break;
            case "tpv_attachmenttype"://附件类型
                outdoublesignature();//带出双签状态
                break;
            case "tpv_pricingtype"://定价类型
            case "tpv_rationtype"://定量方式
            case "tpv_amount"://合同金额
            case "tpv_paymentamount"://付款金额
                paymentState();//带出货款状态
                break;
            case "tpv_dateofcontracting"://签约日期
                addYearDay();//带出合同有效日期（年+1，天-1）
                break;
            case "tpv_settlementstatus"://结算状态=已结算，合同状态=业务完结
                String tpv_settlementstatus = (String) this.getModel().getValue("tpv_settlementstatus");//结算状态
                if ("B".equals(tpv_settlementstatus)) {
                    this.getModel().setValue("tpv_contractstatusx", "F");//合同状态=业务完结
                } else {
                    this.getModel().setValue("tpv_contractstatusx", "D");//合同状态=审核中
                }
            case "tpv_figure"://付款计划-金额
            case "tpv_payment"://付款方式
            case "tpv_proportion"://比例
                totalMoneyKz();
            case "tpv_urgentpayment"://付款计划-紧急付款
                sumFigure(cd);//汇总付款计划为紧急付款的金额至隐藏字段紧急付款金额
                break;
            case "tpv_operator"://业务员
                purgeDepartment();//业务员存在多个部门则清空。
                break;
            case "tpv_deliverydatetype":
                deliverydateType();
                break;
            case "tpv_policynumber": //策略号
                setPositionQty(name, "tpv_positionnums", "tpv_openposition");
                break;
            default:
                break;
        }
    }

    private void setPositionQty(String name, String positionnumsKey, String openpositionKey) {
        DynamicObject tpvStrategynum = (DynamicObject) this.getModel().getValue(name);
        if (YEM.isNotEmpty(tpvStrategynum)) {
            long id = tpvStrategynum.getLong("id");
            DataSet purchase = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_purchase", "id,tpv_contractnumber,tpv_policynumber.id policyid," +
                            "tpv_policynumber.number policynumber,tpv_materialentry,tpv_materialentry.tpv_qty qty",
                    new QFilter[]{new QFilter("tpv_contractstatusx", QCP.in, new String[]{"A", "B", "C", "D", "F", "G"})
                            .and(new QFilter("tpv_policynumber.id", QCP.in, id))}).select("policyid policyid","qty purqty","0.0 saleqty");
            DataSet salescontract = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_salescontract", "id,tpv_contractnos,tpv_strategynum.id strategyid," +
                            "tpv_strategynum.number strategynum,tpv_materialentry,tpv_materialentry.tpv_qty qty",
                    new QFilter[]{new QFilter("tpv_contractstatus", QCP.in, new String[]{"A","B","C","D","G","H"})
                            .and(new QFilter("tpv_strategynum.id", QCP.in, id))}).select("strategyid policyid","qty saleqty","0.0 purqty");
            DataSet dataSet = purchase.union(salescontract).groupBy(new String[]{"policyid"}).sum("saleqty").sum("purqty").finish();
            dataSet = RptUtil.zeroNullNums(dataSet);
            dataSet = dataSet.addField("(purqty - saleqty) qty", "qty");
            BigDecimal qty = BigDecimal.ZERO;
            if (!dataSet.isEmpty()) {
                for (Row row : dataSet) {
                    qty = row.getBigDecimal("qty").setScale(2, BigDecimal.ROUND_HALF_UP).abs();
                }
            }
            BigDecimal tpvReplylimit = BigDecimalUtils.toBigDecimal(tpvStrategynum.getBigDecimal("tpv_replylimit")).setScale(2, BigDecimal.ROUND_HALF_UP);
            this.getModel().setValue(positionnumsKey,qty);
            this.getModel().setValue(openpositionKey,tpvReplylimit.subtract(qty));
        } else {
            this.getModel().setValue(positionnumsKey, BigDecimal.ZERO);
            this.getModel().setValue(openpositionKey, BigDecimal.ZERO);
        }
    }

    private void volumeunp() {
        DynamicObjectCollection tpvMaterialentry = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_materialentry");
        BigDecimal decimal = BigDecimal.ZERO;
        for (DynamicObject dynamicObject : tpvMaterialentry) {
            decimal = decimal.add(dynamicObject.getBigDecimal("tpv_qty"));
        }
        this.getModel().setValue("tpv_volumeunp",decimal);
    }

    /**
     * @author: Heisenberg
     * @date: 2024/5/6 17:30
     * @description: 预计销售地带出销售大区
     */
    private void getSuperior() {
        DynamicObject tpvSaleslocation = (DynamicObject) this.getModel().getValue("tpv_estimatedplace");
        if (YEM.isNotEmpty(tpvSaleslocation)) {
            DynamicObject bdAdmindivision = BusinessDataServiceHelper.loadSingle(tpvSaleslocation.getPkValue(), "bd_admindivision");
            if (YEM.isNotEmpty(bdAdmindivision)) {
                String number = "";
                DynamicObject basedatafield = bdAdmindivision.getDynamicObject("basedatafield");
                if (YEM.isNotEmpty(basedatafield)) {
                    int level = basedatafield.getInt("level");
                    if (level > 0) {
                        if (level == 1) {
                            number = bdAdmindivision.getString("number");
                        } else {
                            DynamicObject parent = bdAdmindivision.getDynamicObject("parent");
                            for (int i = level; i > 2; i--) {
                                parent = parent.getDynamicObject("parent");
                            }
                            number = parent.getString("number");
                        }
                    }
                    if (YEM.isNotEmpty(number)) {
                        DynamicObject[] parents = BusinessDataServiceHelper.load("tpv_tm_region",
                                "tpv_province,number,name",
                                new QFilter[]{new QFilter("enable", QCP.equals, "1")
                                        .and(new QFilter("tpv_province.fbasedataid.number", QCP.equals, number))});
                        if (parents.length == 1) {
                            this.getModel().setValue("tpv_salesarea", parents[0].getPkValue());
                            return;
                        }
                    }
                }
            }
        }
        this.getModel().setValue("tpv_salesarea", null);
    }

    private void deliverydateType() {
        String tpvDeliverydatetype = (String) this.getModel().getValue("tpv_deliverydatetype");
        if ("A".equals(tpvDeliverydatetype)) {
            this.getModel().createNewEntryRow("tpv_dt_purchase_jhqb");
        } else {
            this.getModel().deleteEntryData("tpv_dt_purchase_jhqb");
        }
    }

    /**
     * 付款计划-分录中任意一行【款货关系】≠“货到付款”时=“是”，【款货关系】全部=“货到付款”时=“否”，付款计划-分录值发生改变则重新判断；
     */
    private void paymentContract() {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity();
        DynamicObjectCollection dtPurchaseUs = dataEntity.getDynamicObjectCollection("tpv_dt_purchase_u");
        if (dtPurchaseUs.size() == 0) {
            model.setValue("tpv_paymentcontract", false);
        }
        for (DynamicObject dtPurchaseU : dtPurchaseUs) {
            String tpvPayoodsrela = dtPurchaseU.getString("tpv_payoodsrela");
            if (!"D".equals(tpvPayoodsrela)) {
                model.setValue("tpv_paymentcontract", true);
                return;
            } else {
                model.setValue("tpv_paymentcontract", false);
            }
        }
    }

    private void totalMoneyKz() {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObjectCollection dtPurchaseUs = dataEntity.getDynamicObjectCollection("tpv_dt_purchase_u");
        BigDecimal decimal = BigDecimal.ZERO;//可开证金额
        for (DynamicObject dtPurchaseU : dtPurchaseUs) {
            String payMent = dtPurchaseU.getString("tpv_payment.number");
            if ("JSFS13".equals(payMent) || "JSFS12".equals(payMent)) {
                BigDecimal tpvFigure = dtPurchaseU.getBigDecimal("tpv_figure");
                decimal = decimal.add(tpvFigure);
            }
        }
        model.setValue("tpv_moneykzed", decimal);
    }


    private void purgeDepartment() {
        DynamicObject tpv_operator = (DynamicObject) this.getModel().getValue("tpv_operator");//业务员
        if (tpv_operator != null) {
            Long oid = tpv_operator.getLong("id");
            String selectFieid2 = DynamicObjectUtil.getSelectfields("bos_user", false);// 获取单据头所有字段标识
            selectFieid2 = DynamicObjectUtil.getEntrySelectfields(selectFieid2, "bos_user", "entryentity", false);// 获取单据头所有字段标识
            DynamicObject[] bills = BusinessDataServiceHelper.load("bos_user", selectFieid2, new QFilter[]{
                    new QFilter("id", QCP.in, oid)});
            if (bills.length > 0) {
                for (DynamicObject bill : bills) {
                    DynamicObjectCollection entryentity = bill.getDynamicObjectCollection("entryentity");//部门分录
                    if (entryentity.size() > 1) {
                        this.getModel().setValue("tpv_department", null);//部门赋空
                    }
                }
            }
        }
    }

    private void verifybusinesstype() {
        DynamicObject tpv_businesstype = (DynamicObject) this.getModel().getValue("tpv_businesstype");//业务类型
        if (tpv_businesstype != null) {
            Long id = tpv_businesstype.getLong("id");
            String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_bd_extracttype", false);// 获取单据头所有字段标识
            DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_bd_extracttype", selectFieid2, new QFilter[]{
                    new QFilter("tpv_usebusinesstype.fbasedataid.id", QCP.in, id)});
            if (bills.length == 1) {
                for (DynamicObject bill : bills) {
                    Long exid = bill.getLong("id");
                    this.getModel().setValue("tpv_typeofreward", exid);
                }
            } else {
                this.getModel().setValue("tpv_typeofreward", null);
            }
        }
    }

    private void sumFigure(ChangeData cd) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        int row = cd.getRowIndex();
        BigDecimal tpv_amount = dataEntity.getBigDecimal("tpv_amount");//合同金额原币
        BigDecimal figure = (BigDecimal) this.getModel().getValue("tpv_figure", row);//金额
        if (null != figure && null != tpv_amount) {
            if (figure.compareTo(BigDecimal.ZERO) > 0 && tpv_amount.compareTo(BigDecimal.ZERO) > 0) {
                BigDecimal proportion = figure.divide(tpv_amount, 4, BigDecimal.ROUND_HALF_UP).multiply(new BigDecimal("100"));
                this.getModel().setValue("tpv_proportion", proportion, row);//比例
            }
        } else {
            this.getModel().setValue("tpv_proportion", BigDecimal.ZERO, row);//比例
        }
        DynamicObjectCollection purchase_u = dataEntity.getDynamicObjectCollection("tpv_dt_purchase_u");//付款分录
        BigDecimal tpv_urgentpayamount = BigDecimal.ZERO;//紧急付款金额
        for (DynamicObject purchase : purchase_u) {
            Boolean tpv_urgentpayment = purchase.getBoolean("tpv_urgentpayment");//紧急付款
            if (tpv_urgentpayment) {
                this.getModel().setValue("tpv_urgentpayments", true);//紧急付款(隐藏)
                tpv_urgentpayamount = tpv_urgentpayamount.add(purchase.getBigDecimal("tpv_figure"));//金额
            } else {
                this.getModel().setValue("tpv_urgentpayments", false);//紧急付款(隐藏)
                this.getModel().setValue("tpv_urgentpayamount", BigDecimal.ZERO);//金额
            }
        }
        this.getModel().setValue("tpv_urgentpayamount", tpv_urgentpayamount);//设置紧急付款金额
    }


    private void addYearDay() {
        Date bizdate = (Date) this.getModel().getValue("tpv_dateofcontracting");//签约日期
        if (bizdate != null) {
            Date date = DateUtil.addDays(bizdate, -1);
            int year = date.getYear() + 1;
            date.setYear(year);
            this.getModel().setValue("tpv_durationofthecontr", date);//合同有效日期
        } else {
            this.getModel().setValue("tpv_durationofthecontr", null);//合同有效日期
        }
    }

    private void paymentState() {// 货款状态
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvDtPurchase = dataEntity.getDynamicObjectCollection("tpv_dt_purchase_jhqb");//交货期表
        String tpvPricingtype = dataEntity.getString("tpv_pricingtype"); //定价类型
        String tpvRationtype = dataEntity.getString("tpv_rationtype");//定量方式
        BigDecimal tpvAmount = dataEntity.getBigDecimal("tpv_amount");//合同金额
        String tpv_cargostatus = dataEntity.getString("tpv_cargostatus");//货物状态
        BigDecimal paymentCollet = BigDecimal.ZERO;//定义付款总金额
        if (tpvDtPurchase.size() > 0 && tpvPricingtype != null && tpvRationtype != null) {
            for (DynamicObject purjhqd : tpvDtPurchase) {
                paymentCollet = paymentCollet.add(purjhqd.getBigDecimal("tpv_paymentamount"));//交货期表-付款金额
            }
            if (tpvPricingtype.equals("A") && tpvRationtype.equals("A") && paymentCollet.compareTo(tpvAmount) >= 0) {
                this.getModel().setValue("tpv_paymentstatus", "B");//款齐
                return;
            }
            if (tpvPricingtype.equals("A") && !tpvRationtype.equals("A") && tpv_cargostatus.equals("B") && paymentCollet.compareTo(tpvAmount) >= 0) {
                this.getModel().setValue("tpv_paymentstatus", "B");//款齐
            } else {
                this.getModel().setValue("tpv_paymentstatus", "A");
            }
        } else {
            this.getModel().setValue("tpv_paymentstatus", "A");
        }
    }

    private void verifyPricediff() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection purchase_zjc = dataEntity.getDynamicObjectCollection("tpv_dt_purchase_zjc");//组距差
        for (DynamicObject purentrtry : purchase_zjc) {
            BigDecimal defaultpricediff = purentrtry.getBigDecimal("tpv_defaultpricediff");//默认价差
            BigDecimal confirmpricediff = purentrtry.getBigDecimal("tpv_confirmpricediff");//确认价差
            if (defaultpricediff.compareTo(confirmpricediff) != 0) {
                int row = purentrtry.getInt("Seq");
                AbstractGrid grid = this.getView().getControl("tpv_dt_purchase_zjc");//获取分录表体
                ArrayList<CellStyle> csList = new ArrayList<CellStyle>();
                CellStyle cs = new CellStyle();
                cs.setForeColor("#ff0000");//字体颜色
                cs.setFieldKey("tpv_confirmpricediff");//列标识
                cs.setRow(row - 1);//行索引
                csList.add(cs);
                grid.setCellStyle(csList);//设置单元格样式
                this.getView().updateView("tpv_dt_purchase_zjc");
            } else {
                int row = purentrtry.getInt("Seq");
                AbstractGrid grid = this.getView().getControl("tpv_dt_purchase_zjc");//获取分录表体
                ArrayList<CellStyle> csList = new ArrayList<CellStyle>();
                CellStyle cs = new CellStyle();
                cs.setForeColor("#000000");//字体颜色
                cs.setFieldKey("tpv_confirmpricediff");//列标识
                cs.setRow(row - 1);//行索引
                csList.add(cs);
                grid.setCellStyle(csList);//设置单元格样式
                this.getView().updateView("tpv_dt_purchase_zjc");
            }
        }
    }


    private void outPriceDifference() {
        DynamicObject ditygroup = (DynamicObject) this.getModel().getValue("tpv_commoditygroup");//获取商品组距价差规则
        if (ditygroup != null) {
            Long ditygroupid = ditygroup.getLong("id");
            DynamicObjectCollection strategypice = new DynamicObjectCollection();
            String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_bd_strategypice", false);// 获取单据头所有字段标识
            selectFieid2 = DynamicObjectUtil.getEntrySelectfields(selectFieid2, "tpv_bd_strategypice", "tpv_bd_strategypice_a",
                    false);// 获取分录所有字段标识
            DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_bd_strategypice", selectFieid2, new QFilter[]{new QFilter("id", QCP.equals, ditygroupid)});
            for (DynamicObject bill : bills) {
                strategypice = bill.getDynamicObjectCollection("tpv_bd_strategypice_a");
            }
            this.getModel().deleteEntryData("tpv_dt_purchase_zjc");
            for (DynamicObject entity : strategypice) {
                int index = this.getModel().createNewEntryRow("tpv_dt_purchase_zjc");//组距差
                this.getModel().setValue("tpv_isbasepricegoods", entity.getBoolean("tpv_baseprice"), index);//是否基价商品
                this.getModel().setValue("tpv_productname", entity.getLong("tpv_comcoding.id"), index);//商品
                this.getModel().setValue("tpv_originas", entity.getLong("tpv_productlands.id"), index);//产地
                this.getModel().setValue("tpv_materialquality", entity.getString("tpv_texture"), index);//材质
                this.getModel().setValue("tpv_specifica", entity.getString("tpv_specification"), index);//规格
                this.getModel().setValue("tpv_defaultpricediff", entity.getBigDecimal("tpv_diffprice"), index);//默认价差
            }
        } else {
            this.getModel().setValue("tpv_isbasepricegoods", null);//是否基价商品
            this.getModel().setValue("tpv_productname", null);//商品
            this.getModel().setValue("tpv_originas", null);//产地
            this.getModel().setValue("tpv_materialquality", null);//材质
            this.getModel().setValue("tpv_specifica", null);//规格
            this.getModel().setValue("tpv_defaultpricediff", null);//默认价差
            this.getModel().setValue("tpv_confirmpricediff", null);//确认价差
        }
    }

//    private void controlLC(){
//    	DynamicObject dataEntity = this.getModel().getDataEntity(true);
//    	DynamicObjectCollection purchase_u=dataEntity.getDynamicObjectCollection("tpv_dt_purchase_u");//付款计划
//    	if(purchase_u!=null) {
//    		for(DynamicObject purentrty:purchase_u) {
//        		String tpv_payment=purentrty.getString("tpv_payment.name");
//        		if(tpv_payment!=null) {
//        		if(tpv_payment.equals("国内信用证")||tpv_payment.equals("国际信用证")) {
//        			DateTimeEdit edit=this.getView().getControl("tpv_dateofissuance");//预计开证
//        			edit.setMustInput(true);
//        			DateTimeProp property = (DateTimeProp)edit.getProperty();
//        			property.setMustInput(true);
//        		}else {
//        			DateTimeEdit edit=this.getView().getControl("tpv_dateofissuance");
//        			edit.setMustInput(false);
//        			DateTimeProp property = (DateTimeProp)edit.getProperty();
//        			property.setMustInput(false);
//        		}
//        	 }
//          }
//    	}
//    }

    public void saveDate() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        String tpv_hbspconsolidated = dataEntity.getString("tpv_hbsptype_apt");//合并审批
        if (tpv_hbspconsolidated.equals("B")) {
            String billnum = dataEntity.getString("billno");
//			 BillEntityType  entitype = (BillEntityType)dataEntity.getDataEntityType();
            this.getModel().setValue("tpv_mainbillkey_apt", "tpv_dt_purchase");
            this.getModel().setValue("tpv_mainbillno_apt", billnum);//审批主题单据号
        } else {
            this.getView().getModel().setValue("tpv_mainbillkey_apt", null);
            this.getModel().setValue("tpv_mainbillno_apt", null);//审批主题单据号
        }
        this.getView().updateView();
    }

    private void countCommission() {
        DynamicObjectCollection entrys = this.getModel().getEntryEntity("tpv_materialentry");//获取商品明细分录
        if (entrys.size() > 0) {
            BigDecimal sunnum = BigDecimal.ZERO;//总数量
            for (DynamicObject entity : entrys) {
                sunnum = sunnum.add(entity.getBigDecimal("tpv_qty"));
            }
            String paymentmethod = (String) this.getModel().getValue("tpv_paymentmethod");//付佣方式
            if (paymentmethod != null && paymentmethod.equals("C")) {
                BigDecimal commissionunitpric = (BigDecimal) this.getModel().getValue("tpv_commissionunitpric");//佣金单价
                if (commissionunitpric.compareTo(BigDecimal.ZERO) != 0 && sunnum.compareTo(BigDecimal.ZERO) != 0) {
                    this.getModel().setValue("tpv_commission", sunnum.multiply(commissionunitpric));
                } else {
                    this.getModel().setValue("tpv_commission", BigDecimal.ZERO);
                }
            }
        }
    }

    private void controlPayment() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection purchase_u = dataEntity.getDynamicObjectCollection("tpv_dt_purchase_u");//付款计划
        if (purchase_u.size() > 0) {
            for (DynamicObject entrty : purchase_u) {
                String tpv_payoodsrela = entrty.getString("tpv_payoodsrela");//款货关系
                Boolean useasingleticket = (Boolean) this.getModel().getValue("tpv_useasingleticket");//使用单票额度
                if (tpv_payoodsrela != null) {
                    if ("".equals(tpv_payoodsrela)) {
                        this.getModel().setValue("tpv_paymentcontract", false);//是否预付款合同
                        this.getModel().setValue("tpv_useasingleticket", false);
                        RefBillEdit edit = this.getView().getControl("tpv_applicationform");//单票额度申请单
                        edit.setMustInput(false);
                        RefBillProp property = (RefBillProp) edit.getProperty();
                        property.setMustInput(false);
                    }
                    if (tpv_payoodsrela.equals("D")) {
                        this.getModel().setValue("tpv_paymentcontract", false);//是否预付款合同
                        this.getModel().setValue("tpv_useasingleticket", false);
                        RefBillEdit edit = this.getView().getControl("tpv_applicationform");//单票额度申请单
                        edit.setMustInput(false);
                        RefBillProp property = (RefBillProp) edit.getProperty();
                        property.setMustInput(false);
                    }
                    if (!tpv_payoodsrela.equals("D") && !"".equals(tpv_payoodsrela)) {
                        this.getModel().setValue("tpv_paymentcontract", true);
                        if (useasingleticket) {
                            RefBillEdit edit = this.getView().getControl("tpv_applicationform");//单票额度申请单
                            edit.setMustInput(true);
                            RefBillProp property = (RefBillProp) edit.getProperty();
                            property.setMustInput(true);
                        } else {
                            RefBillEdit edit = this.getView().getControl("tpv_applicationform");//单票额度申请单
                            edit.setMustInput(false);
                            RefBillProp property = (RefBillProp) edit.getProperty();
                            property.setMustInput(false);
                        }
                        return;
                    }
                }
            }
        } else {
            this.getModel().setValue("tpv_paymentcontract", false);
            this.getModel().setValue("tpv_useasingleticket", false);
            RefBillEdit edit = this.getView().getControl("tpv_applicationform");//单票额度申请单
            edit.setMustInput(false);
            RefBillProp property = (RefBillProp) edit.getProperty();
            property.setMustInput(false);
        }
    }

    private void dateCheck() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Date loadingperiodfrom = dataEntity.getDate("tpv_loadingperiodfrom");//装期从
        Date loadingperiodto = dataEntity.getDate("tpv_loadingperiodto");//装期至
        Date latestshipmentdate = dataEntity.getDate("tpv_latestshipmentdate");//最迟装运日期
        if (loadingperiodfrom != null && loadingperiodto != null && loadingperiodfrom.getTime() > loadingperiodto.getTime()) {
            FieldTip fieldTip = new FieldTip();
            fieldTip.setFieldKey("tpv_loadingperiodto");
            fieldTip.setLevel(FieldTip.FieldTipsLevel.Info);
            fieldTip.setSuccess(false);
            fieldTip.setTipsType(FieldTip.FieldTipsTypes.others);
            fieldTip.setTip("装期至不能小于装期从!");
            this.getView().showFieldTip(fieldTip);
            this.getModel().setValue("tpv_loadingperiodto", null);
        }
        if (loadingperiodfrom != null && latestshipmentdate != null && loadingperiodfrom.getTime() > latestshipmentdate.getTime()) {
            FieldTip fieldTip = new FieldTip();
            fieldTip.setFieldKey("tpv_latestshipmentdate");
            fieldTip.setLevel(FieldTip.FieldTipsLevel.Info);
            fieldTip.setSuccess(false);
            fieldTip.setTipsType(FieldTip.FieldTipsTypes.others);
            fieldTip.setTip("最迟装运日期不能小于装期从!");
            this.getView().showFieldTip(fieldTip);
            this.getModel().setValue("tpv_latestshipmentdate", null);
        }
    }

    private void outBasePriceitems() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject salesarea = dataEntity.getDynamicObject("tpv_salesarea");//销售大区
        if (salesarea != null) {
            DynamicObjectCollection majorbasepro = salesarea.getDynamicObjectCollection("tpv_majorbasepro");//主营基价商品
            if (majorbasepro.size() > 0 && majorbasepro.size() == 1) {
                for (DynamicObject major : majorbasepro) {
                    Long masterid = major.getLong("fbasedataid.id");
                    this.getModel().setValue("tpv_basepriceitems", masterid);//基价商品
                }
            } else {
                this.getModel().setValue("tpv_basepriceitems", null);
            }
        } else {
            this.getModel().setValue("tpv_basepriceitems", null);
        }
    }

    private void gotoSpace() {
        String contractnumber = (String) this.getModel().getValue("tpv_contractnumber");
        String replaceAll = contractnumber.replace(" ", "");//去除空格
        this.getModel().setValue("tpv_contractnumber", replaceAll);
    }


    private void outdoublesignature() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection attachmentdetail = dataEntity.getDynamicObjectCollection("tpv_attachmentdetail");//附件分录
        if (attachmentdetail.size() > 0) {
            for (DynamicObject attachment : attachmentdetail) {
                String tpv_attachmenttype = attachment.getString("tpv_attachmenttype.name");
                if (tpv_attachmenttype != null && tpv_attachmenttype.contains("双签")) {
                    this.getModel().setValue("tpv_doublesignature", "B");//双签状态
                } else {
                    this.getModel().setValue("tpv_doublesignature", "A");
                }
            }
        } else {
            this.getModel().setValue("tpv_doublesignature", "A");
        }
    }


    /**
     * @param e 删除行事件
     */
    @Override
    public void afterDeleteRow(AfterDeleteRowEventArgs e) {
        super.afterDeleteRow(e);
        String name = e.getEntryProp().getName();
        switch (name) {
            case "tpv_materialentry"://数量
                countCommission();//计算佣金
                volumeunp();//汇总未头寸业务数量
                break;
            case "tpv_dt_purchase_u"://款货关系
                controlPayment();//控制是否预付款合同
                totalMoneyKz();
                break;
            default:
                break;
        }
    }


    /**
     * @param e 新增行事件
     */
    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        String name = e.getEntryProp().getName();
        int i = 0;
        RowDataEntity[] rowdata = e.getRowDataEntities();
        for (RowDataEntity rdata : rowdata) {
            i = rdata.getRowIndex();
        }

        switch (name) {
            case "tpv_dt_purchase_jhqb"://交货期表
                BigDecimal qty = BigDecimal.ZERO;//总数量
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品分录
                if (materialentry.size() > 0) {
                    for (DynamicObject mater : materialentry) {
                        qty = qty.add(mater.getBigDecimal("tpv_qty"));//分录数量
                    }
                    this.getModel().setValue("tpv_agreeddeliveryqty", qty, i);//交货期表
                }
                break;
            case "tpv_materialentry":
                volumeunp();
                break;
            default:
                break;
        }
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        // TODO Auto-generated method stub
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_longtermag"://协议号
                qFilterThisOrgName(e);  //过滤当前组织
                break;
            case "tpv_pointpricecontract"://点价合约
                qFilterThisdate(e);  //过滤有效期限大于业务日期的数据
                break;
            case "tpv_combinationnumber"://组合号
                qFilterThisOrgCombin(e);  //过滤组织为当前组织
                break;
            case "tpv_typeofreward"://提奖类型
                qFiltertypeofreward(e);  //根据业务类型过滤
                break;
            case "tpv_applicationform"://单票额度申请
                qFilterSupticket(e);
                break;
            case "tpv_projectcon"://项目建档
                qFilterProjectabrefs(e);
                break;
            default:
                break;
        }
    }

    private void qFilterProjectabrefs(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject tpvDepartment = (DynamicObject) this.getModel().getValue("tpv_department");
        QFilters.add(new QFilter("tpv_documenttypes.number", QCP.equals, "tpv_dt_salescontract_PGYW"));
        if (tpvDepartment != null) {
            QFilters.add(new QFilter("tpv_department", QCP.equals, tpvDepartment.getPkValue()));
        } else {
            QFilters.add(new QFilter("tpv_department", QCP.equals, 0));
        }
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    private void qFilterSupticket(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        showParameter.getListFilterParameter().getQFilters().clear();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        QFilters.add(new QFilter("tpv_proconnum", QCP.equals, "")); //
        QFilters.add(new QFilter("billstatus", QCP.in, new String[]{"B", "C"})); //单据状态：已提交、已审核
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    //过滤当前组织
    private void qFilterThisOrgName(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Date bizdate = dataEntity.getDate("tpv_bizdate");
        DynamicObject tpvCompany = dataEntity.getDynamicObject("tpv_company");
        DynamicObject tpvDepartment = dataEntity.getDynamicObject("tpv_department");
        DynamicObject tpvSupplier = dataEntity.getDynamicObject("tpv_supplier");
        IFormView view = this.getView();
        List<String> notInputs = new ArrayList<>();
        YEM.getNotNull(view, notInputs, dataEntity, "tpv_company");
        YEM.getNotNull(view, notInputs, dataEntity, "tpv_department");
        YEM.getNotNull(view, notInputs, dataEntity, "tpv_supplier");

        if (notInputs.size() > 0) {
            view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
            e.setCancel(true);
        } else {
            Object id = tpvCompany.get("id");
            QFilters.add(new QFilter("org", "=", id)); //设置过滤条件：组织
            QFilters.add(new QFilter("tpv_department", "=", tpvDepartment.getPkValue())); //设置过滤条件：部门
            QFilters.add(new QFilter("tpv_supplier", "=", tpvSupplier.getPkValue())); //设置过滤条件：部门
            QFilters.add(new QFilter("tpv_protocoltype", "=", "A")); //设置过滤条件：部门
            QFilters.add(new QFilter("billstatus", "=", "C")); //单据状态：已审核
            QFilters.add(new QFilter("tpv_ctvaliddate", ">", bizdate)); //设置过滤日期
            showParameter.getListFilterParameter().setQFilters(QFilters);
        }
    }

    private void qFilterThisdate(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Date bizdate = dataEntity.getDate("tpv_bizdate");
        QFilters.add(new QFilter("tpv_effectivedate", ">", bizdate)); //设置过滤日期
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    private void qFilterThisOrgCombin(BeforeF7SelectEvent e) {
        DynamicObject department = (DynamicObject) this.getModel().getValue("tpv_department");
        if (department == null) {
            this.getView().showTipNotification("请先选择部门！");
            e.setCancel(true);
            return;
        }
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject org = dataEntity.getDynamicObject("tpv_department");//部门
        if (org == null) {
            return;
        }
        Object id = org.get("id");
        QFilters.add(new QFilter("tpv_departments", "=", id)); //设置过滤条件：组织
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    private void qFiltertypeofreward(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject businesstype = dataEntity.getDynamicObject("tpv_businesstype");//业务类型
        if (businesstype == null) {
            return;
        }
        Object id = businesstype.get("id");
        QFilters.add(new QFilter("tpv_usebusinesstype.fbasedataid.id", QCP.in, id)); //设置过滤条件：业务类型
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    /**
     * 是否货到付款
     */
    private void isPayment() {
        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_dt_purchase_u");//付款计划分录
        for (DynamicObject object : entity) {
            String pay = (String) object.get("tpv_payoodsrela");
            if ("A".equals(pay) || "B".equals(pay) || "C".equals(pay)) {
                this.getModel().setValue("tpv_ispayment", true);//是否货到付款(隐藏)
            }
        }
    }
}
