package com.itopview.wm.dt.formplugin.form;

import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.BillOperationStatus;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.form.events.PreOpenFormEventArgs;
import kd.bos.list.ListShowParameter;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;

import java.util.EventObject;

import static kd.imc.rim.common.invoice.fpzs.FpzsMainService.getCustomParam;

/**
 * @author LiuHB
 * @version 1.0
 * 采购合同布局
 */
public class PurchaseDomList extends AbstractBillPlugIn  {

    @Override
    public void preOpenForm(PreOpenFormEventArgs e) {
        String domestictradeid = null;
        String entrance = null;
        String export = null;
        String transit = null;
        BillShowParameter bsp = (BillShowParameter) e.getFormShowParameter();
        OperationStatus status = bsp.getStatus();//获取单据状态
        String select = "billformid,"+"number,"+"mesterid";
        QFilter qFilter = new QFilter("billformid",QCP.equals,"tpv_dt_purchase");
        DynamicObject[] load = BusinessDataServiceHelper.load("bos_billtype", select, qFilter.toArray());
        for (DynamicObject dynamicObject : load) {
            String number = dynamicObject.getString("number");
            if(number.equals("tpv_dt_purchase_BT")){
                domestictradeid = dynamicObject.getString("masterid");
            }
            if(number.equals("tpv_dt_purchase_JK")){
                entrance = dynamicObject.getString("masterid");
            }
            if(number.equals("tpv_dt_purchase_CK")){
                export = dynamicObject.getString("masterid");
            }
            if(number.equals("tpv_dt_purchase_ZK")){
                transit = dynamicObject.getString("masterid");
            }
        }
        //如果打开过往单据直接跳过
        if(OperationStatus.ADDNEW.equals(status)){
            //获取单据标识
            String formId = bsp.getFormId();
                 switch (formId) {
                     case "tpv_dt_purchase_dom":
                         bsp.setBillTypeId(domestictradeid);
                         break;
                     case "tpv_is_purchase_fois":
                         bsp.setBillTypeId(entrance);
                         break;
                     case "tpv_es_purchase_domes":
                         bsp.setBillTypeId(export);
                         break;
                     case "tpv_et_purchase_fotet":
                         bsp.setBillTypeId(transit);
                         break;
                 }
        }
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        String btid="";
        String ckid="";
        String jkid="";
        String zkid="";
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject document = dataEntity.getDynamicObject("tpv_document");
        String number = document.getString("number");
        String selectStrxs = DynamicObjectUtil.getSelectfields("tpv_bd_tradeproperty", false);
        switch (number) {
            case "tpv_dt_purchase_BT":
                QFilter qFilterbt = new QFilter("number",QCP.equals,"JKYW");
                DynamicObject[] loadbt = BusinessDataServiceHelper.load("tpv_bd_tradeproperty", selectStrxs, qFilterbt.toArray());
                for (DynamicObject dynamicObject : loadbt) {

                        btid = dynamicObject.getString("id");
                    if (!btid.isEmpty()) {
                        this.getModel().setValue("tpv_tradeproperty", btid);
                    }
                }
                break;
            case "tpv_dt_purchase_CK":
                QFilter qFilterck = new QFilter("number",QCP.equals,"JKYW");
                DynamicObject[] loadck = BusinessDataServiceHelper.load("tpv_bd_tradeproperty", selectStrxs, qFilterck.toArray());
                for (DynamicObject dynamicObject : loadck) {
                    ckid = dynamicObject.getString("id");
                    if (ckid != "") {
                        this.getModel().setValue("tpv_tradeproperty", ckid);
                    }
                }
                break;
            case "tpv_dt_purchase_ZK":
                QFilter qFilterzk = new QFilter("number",QCP.equals,"JKYW");
                DynamicObject[] loadzk = BusinessDataServiceHelper.load("tpv_bd_tradeproperty", selectStrxs, qFilterzk.toArray());
                for (DynamicObject dynamicObject : loadzk) {
                    zkid = dynamicObject.getString("id");
                    if (zkid != "") {
                        this.getModel().setValue("tpv_tradeproperty", zkid);
                    }
                }
                break;
            case "tpv_dt_purchase_JK":
                QFilter qFilterjk = new QFilter("number",QCP.equals,"JKYW");
                DynamicObject[] loadjk = BusinessDataServiceHelper.load("tpv_bd_tradeproperty", selectStrxs, qFilterjk.toArray());
                for (DynamicObject dynamicObject : loadjk) {
                    jkid = dynamicObject.getString("id");
                    if (jkid != "") {
                        this.getModel().setValue("tpv_tradeproperty", jkid);
                    }
                }
                break;
        }

    }
}


