package com.itopview.wm.dt.formplugin.form;


import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * @author GX
 * 关联交易单-表单插件
 */
public class ReleTradeFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {
    @Override
    public void afterBindData(EventObject e) {
        super.afterCreateNewData(e);
//        Long currentUserId = UserServiceHelper.getCurrentUserId();
//        Long mainOrgId = UserServiceHelper.getUserMainOrgId(currentUserId);
//        this.getModel().setValue("tpv_orgs",mainOrgId);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        reletradeType();
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        switch (name) {
            case "tpv_uppurchasenum"://采购合同
                uppurchasenum();//带出采购合同分录
                break;
            case "tpv_upsalechasenum"://销售合同
                upsalechasenum();//带出销售合同分录
                break;
            case "tpv_thisreleqty"://本次关联交易数量
                thisreleqQty();//【本次关联交易数量】不能大于【可关联交易数量】
                break;
            case "tpv_reletradetype"://关联交易类型
            case "tpv_department"://部门
                this.getModel().setValue("tpv_uppurchasenum", null);
                this.getModel().setValue("tpv_upsalechasenum", null);
            case "tpv_company"://公司
                reletradeType();
                break;
            case "tpv_policynums": //采购策略号
                setPositionQty(name, "tpv_positionnumspur", "tpv_openpositionpur");
                break;
            case "tpv_policynumsele": //销售策略号
                setPositionQty(name, "tpv_positionnumssale", "tpv_openpositionsale");
                break;
            default:
                break;
        }
    }

    private void setPositionQty(String name, String positionnumsKey, String openpositionKey) {
        DynamicObject tpvStrategynum = (DynamicObject) this.getModel().getValue(name);
        if (YEM.isNotEmpty(tpvStrategynum)) {
            long id = tpvStrategynum.getLong("id");
            DataSet purchase = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_purchase", "id,tpv_contractnumber,tpv_policynumber.id policyid," +
                            "tpv_policynumber.number policynumber,tpv_materialentry,tpv_materialentry.tpv_qty qty",
                    new QFilter[]{new QFilter("tpv_contractstatusx", QCP.in, new String[]{"A", "B", "C", "D", "F", "G"})
                            .and(new QFilter("tpv_policynumber.id", QCP.in, id))}).select("policyid policyid","qty purqty","0.0 saleqty");
            DataSet salescontract = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_salescontract", "id,tpv_contractnos,tpv_strategynum.id strategyid," +
                            "tpv_strategynum.number strategynum,tpv_materialentry,tpv_materialentry.tpv_qty qty",
                    new QFilter[]{new QFilter("tpv_contractstatus", QCP.in, new String[]{"A","B","C","D","G","H"})
                            .and(new QFilter("tpv_strategynum.id", QCP.in, id))}).select("strategyid policyid","qty saleqty","0.0 purqty");
            DataSet dataSet = purchase.union(salescontract).groupBy(new String[]{"policyid"}).sum("saleqty").sum("purqty").finish();
            dataSet = RptUtil.zeroNullNums(dataSet);
            dataSet = dataSet.addField("(purqty - saleqty) qty", "qty");
            BigDecimal qty = BigDecimal.ZERO;
            if (!dataSet.isEmpty()) {
                for (Row row : dataSet) {
                    qty = row.getBigDecimal("qty").setScale(2, BigDecimal.ROUND_HALF_UP).abs();
                }
            }
            BigDecimal tpvReplylimit = BigDecimalUtils.toBigDecimal(tpvStrategynum.getBigDecimal("tpv_replylimit")).setScale(2, BigDecimal.ROUND_HALF_UP);
            this.getModel().setValue(positionnumsKey,qty);
            this.getModel().setValue(openpositionKey,tpvReplylimit.subtract(qty));
        } else {
            this.getModel().setValue(positionnumsKey, BigDecimal.ZERO);
            this.getModel().setValue(openpositionKey, BigDecimal.ZERO);
        }
    }

    public void reletradeType() {
        String tpvReletradetype = (String) this.getModel().getValue("tpv_reletradetype");
        DynamicObject tpvCompany = (DynamicObject) this.getModel().getValue("tpv_company");
        if ("E".equals(tpvReletradetype)) {
//            this.getModel().setValue("tpv_orgs",tpvCompany);//组织 采购
            this.getModel().setValue("tpv_orgsele", tpvCompany);//组织 销售
            this.getView().setEnable(false, "tpv_orgsele");
            this.getView().setEnable(true, "tpv_orgs");
        } else {
            this.getModel().setValue("tpv_orgs", tpvCompany);//组织 采购
            this.getModel().setValue("tpv_orgsele", tpvCompany);//组织 销售
            this.getView().setEnable(false, "tpv_orgsele");
            this.getView().setEnable(false, "tpv_orgs");
        }
    }

    public void thisreleqQty() {
        DynamicObjectCollection tpv_materialentry = this.getView().getModel().getEntryEntity("tpv_dt_reletrade_sh");//商品分录
        for (DynamicObject dynamicObject : tpv_materialentry) {
            int seq = dynamicObject.getInt("Seq");
            BigDecimal tpv_releqty = dynamicObject.getBigDecimal("tpv_releqty");//可关联交易数量
            BigDecimal tpv_thisreleqty = dynamicObject.getBigDecimal("tpv_thisreleqty");//本次关联交易数量
            if (tpv_thisreleqty.compareTo(tpv_releqty) > 0) {
                this.getView().showTipNotification("商品信息分录第" + seq + "行,【本次关联交易数量】不能大于【可关联交易数量】,请重新填写!");
                this.getModel().setValue("tpv_thisreleqty", null, seq - 1);
            }
        }
    }

    public void uppurchasenum() {
        this.getModel().deleteEntryData("tpv_dt_reletrade_sh");
        DynamicObject tpv_uppurchasenum = (DynamicObject) this.getModel().getValue("tpv_uppurchasenum");//采购合同号
        if (tpv_uppurchasenum != null) {
            String billon = tpv_uppurchasenum.getString("tpv_name"); //单据编号给为合同号
            String selectfield = com.itopview.wm.utils.DynamicObjectUtil.getSelectfields("tpv_dt_purchase", false);
            selectfield = DynamicObjectUtil.getEntrySelectfields(selectfield, "tpv_dt_purchase", "tpv_materialentry", false);
            DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_dt_purchase", selectfield, new QFilter[]{
                    new QFilter("tpv_contractnumber", QCP.equals, billon)});
            for (DynamicObject bill : bills) {
                DynamicObjectCollection materialentry = bill.getDynamicObjectCollection("tpv_materialentry");
                for (DynamicObject material : materialentry) {
                    DynamicObject tpvProdname = material.getDynamicObject("tpv_prodname");
                    DynamicObject tpvPackagingunit = material.getDynamicObject("tpv_packagingunit");//包装单位
                    BigDecimal tpvPacknum = material.getBigDecimal("tpv_packnum");//包装数量
                    String tpvSpecation = material.getString("tpv_specation");//规格
                    String tpv_shader = material.getString("tpv_shader");//材质
                    Long tpvOrigin = material.getLong("tpv_origin.id");//产地
                    BigDecimal tpv_vatrates = material.getBigDecimal("tpv_vatrates");//增值税率%
                    BigDecimal effectiveqty = material.getBigDecimal("tpv_effectiveqty");//有效数量
                    BigDecimal pickedquantity = material.getBigDecimal("tpv_pickedquantity");//已拣配数量
                    BigDecimal tpv_releqty = effectiveqty.subtract(pickedquantity);
                    if (tpv_releqty.compareTo(BigDecimal.ZERO) > 0) {
                        int row = this.getModel().createNewEntryRow("tpv_dt_reletrade_sh");
                        this.getModel().setValue("tpv_prodname", tpvProdname, row);
                        this.getModel().setValue("tpv_specation", tpvSpecation, row);
                        this.getModel().setValue("tpv_shader", tpv_shader, row);
                        this.getModel().setValue("tpv_origin", tpvOrigin, row);
                        this.getModel().setValue("tpv_releqty", tpv_releqty, row);
                        this.getModel().setValue("tpv_vatrates", tpv_vatrates, row);
                        this.getModel().setValue("tpv_packagingunit", tpvPackagingunit, row);
                        this.getModel().setValue("tpv_packnum", tpvPacknum, row);
                    }

                }
            }
        } else {
            this.getModel().deleteEntryData("tpv_dt_reletrade_sh");
        }
    }

    public void upsalechasenum() {
        this.getModel().deleteEntryData("tpv_dt_reletrade_sh");
        DynamicObject tpv_upsalechasenum = (DynamicObject) this.getModel().getValue("tpv_upsalechasenum");//销售合同号
        if (tpv_upsalechasenum != null) {
            String billon = tpv_upsalechasenum.getString("tpv_name");
            String selectfield = com.itopview.wm.utils.DynamicObjectUtil.getSelectfields("tpv_dt_salescontract", false);
            selectfield = DynamicObjectUtil.getEntrySelectfields(selectfield, "tpv_dt_salescontract", "tpv_materialentry", false);
            DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_dt_salescontract", selectfield, new QFilter[]{
                    new QFilter("tpv_contractnos", QCP.equals, billon)});
            for (DynamicObject bill : bills) {
                DynamicObjectCollection materialentry = bill.getDynamicObjectCollection("tpv_materialentry");
                for (DynamicObject material : materialentry) {
                    DynamicObject tpvProdname = material.getDynamicObject("tpv_prodname");
                    DynamicObject tpvPackagingunit = material.getDynamicObject("tpv_packagingunit");//包装单位
                    BigDecimal tpvPacknum = material.getBigDecimal("tpv_packnum");//包装数量
                    String tpvSpecation = material.getString("tpv_specation");//规格
                    String tpv_shader = material.getString("tpv_shader");//材质
                    Long tpvOrigin = material.getLong("tpv_origin.id");//产地
                    BigDecimal tpv_vatrates = material.getBigDecimal("tpv_vatrates");//增值税率%
                    BigDecimal tpv_releqty = material.getBigDecimal("tpv_unshippedquantity");//未发货数量
                    if (tpv_releqty.compareTo(BigDecimal.ZERO) > 0) {
                        int row = this.getModel().createNewEntryRow("tpv_dt_reletrade_sh");
                        this.getModel().setValue("tpv_prodname", tpvProdname, row);
                        this.getModel().setValue("tpv_specation", tpvSpecation, row);
                        this.getModel().setValue("tpv_shader", tpv_shader, row);
                        this.getModel().setValue("tpv_origin", tpvOrigin, row);
                        this.getModel().setValue("tpv_releqty", tpv_releqty, row);
                        this.getModel().setValue("tpv_vatrates", tpv_vatrates, row);
                        this.getModel().setValue("tpv_packagingunit", tpvPackagingunit, row);
                        this.getModel().setValue("tpv_packnum", tpvPacknum, row);
                    }
                }
            }
        } else {
            this.getModel().deleteEntryData("tpv_dt_reletrade_sh");
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit tpv_pointpricecontract = this.getView().getControl("tpv_uppurchasenum");//上级采购合同
        tpv_pointpricecontract.addBeforeF7SelectListener(this);
        BasedataEdit tpv_upsalechasenum = this.getView().getControl("tpv_upsalechasenum");//上级销售合同
        tpv_upsalechasenum.addBeforeF7SelectListener(this);
        BasedataEdit tpvComnumbers = this.getView().getControl("tpv_comnumbers");//组合号-采
        tpvComnumbers.addBeforeF7SelectListener(this);
        BasedataEdit tpvOperator = this.getView().getControl("tpv_operator");//业务员
        tpvOperator.addBeforeF7SelectListener(this);
        ((BasedataEdit) this.getControl("tpv_puroperator")).addBeforeF7SelectListener(this);
        ((BasedataEdit) this.getControl("tpv_puroperator")).addBeforeF7SelectListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_uppurchasenum":
                qFilterThisBusinessCombin(e);
                break;
            case "tpv_puroperator":
                operatorF7(e, name);
                break;
            case "tpv_upsalechasenum":
                tpvUpsalechasenum(e);
                break;
            case "tpv_comnumbers":
                tpvComnumbers(e);
                break;
            case "tpv_operator":
                ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
                CloseCallBack closeCallBack = new CloseCallBack(this, name);
                showParameter.setCloseCallBack(closeCallBack);
                showParameter.getListFilterParameter();
                break;
        }
    }

    private void tpvComnumbers(BeforeF7SelectEvent e) {
        List<QFilter> QFilters = new ArrayList<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpvDepartment = dataEntity.getDynamicObject("tpv_department");
        if (tpvDepartment != null) {
            Object id = tpvDepartment.get("id");
            QFilters.add(new QFilter("tpv_departments", "=", id));
        }
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    private void tpvUpsalechasenum(BeforeF7SelectEvent e) {
        List<QFilter> QFilters = new ArrayList<>();

        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpvCompany = dataEntity.getDynamicObject("tpv_company");
        DynamicObject tpvDepartment = dataEntity.getDynamicObject("tpv_department");
        if (tpvCompany != null) {
            Object id = tpvCompany.get("id");
//            QFilters.add(new QFilter("org", "=", id));
        }
        if (tpvDepartment != null) {
            Object id = tpvDepartment.get("id");
            QFilters.add(new QFilter("tpv_department", "=", id));
        }
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    private void operatorF7(BeforeF7SelectEvent e, String key) {
        FormShowParameter showParameter = e.getFormShowParameter();
        CloseCallBack closeCallBack = new CloseCallBack(this, key);
        showParameter.setCloseCallBack(closeCallBack);
    }

    private void qFilterThisBusinessCombin(BeforeF7SelectEvent e) {
        List<QFilter> QFilters = new ArrayList<>();

        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpvCompany = dataEntity.getDynamicObject("tpv_company");
        DynamicObject tpvDepartment = dataEntity.getDynamicObject("tpv_department");
        if (tpvCompany != null) {
            Object id = tpvCompany.get("id");
//            QFilters.add(new QFilter("org", "=", id));
        }
        if (tpvDepartment != null) {
            Object id = tpvDepartment.get("id");
            QFilters.add(new QFilter("tpv_department", "=", id));
        }
        QFilters.add(new QFilter("tpv_billkey.number", "=", "tpv_dt_purchase"));
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    /**
     * @param e 回调，接收子页面传来的值。
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        switch (actionId) {
            case "tpv_puroperator":
                operatorCallBack(e);
                break;
            case "tpv_operator":
                operatorCallB(e);
                break;
            default:
                break;
        }
    }

    private void operatorCallB(ClosedCallBackEvent e) {
        IDataModel model = this.getModel();
        ListSelectedRowCollection selectedRows = (ListSelectedRowCollection) e.getReturnData();
        if (selectedRows != null && selectedRows.size() > 0) {
            ListSelectedRow selectedRow = selectedRows.get(0);
            long userId = (long) selectedRow.getPrimaryKeyValue();//人员id
            long userEntryId = (long) selectedRow.getEntryPrimaryKeyValue();//部门分录id
            model.beginInit();
            model.setValue("tpv_operator", userId);
            DynamicObjectCollection entry = getUserDepts(userId);
            for (DynamicObject row : entry) {
                if (userEntryId == row.getLong("id")) {
                    model.setValue("tpv_department", row.get("org"));
                }
            }
            model.endInit();
            model.setValue("tpv_uppurchasenum", null);
            model.setValue("tpv_upsalechasenum", null);
            this.getView().updateView("tpv_operator");
            this.getView().updateView("tpv_department");
        }
    }

    private void operatorCallBack(ClosedCallBackEvent e) {
        IDataModel model = this.getModel();
        ListSelectedRowCollection selectedRows = (ListSelectedRowCollection) e.getReturnData();
        if (selectedRows != null && selectedRows.size() > 0) {
            ListSelectedRow selectedRow = selectedRows.get(0);
            long userId = (long) selectedRow.getPrimaryKeyValue();//人员id
            long userEntryId = (long) selectedRow.getEntryPrimaryKeyValue();//部门分录id
            model.beginInit();
            model.setValue("tpv_puroperator", userId);
            DynamicObjectCollection entry = getUserDepts(userId);
            for (DynamicObject row : entry) {
                if (userEntryId == row.getLong("id")) {
                    model.setValue("tpv_purdepart", row.get("org"));
                }
            }
            model.endInit();
            this.getView().updateView("tpv_puroperator");
            this.getView().updateView("tpv_purdepart");
        }
    }

    private static DynamicObjectCollection getUserDepts(long userId) {
        QFilter qFilter = new QFilter("user", QCP.equals, userId);
//        qFilter.and(new QFilter("org.orgpattern.number", QCP.equals, "Orgform06"));
        return QueryServiceHelper.query("bos_userposition", "id,org", qFilter.toArray());
    }
}
