package com.itopview.wm.dt.formplugin.form;

import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.AfterDeleteRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.report.CellStyle;
import kd.bos.form.ConfirmCallBackListener;
import kd.bos.form.MessageBoxOptions;
import kd.bos.form.MessageBoxResult;
import kd.bos.form.control.AbstractGrid;
import kd.bos.form.control.AttachmentPanel;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.UploadEvent;
import kd.bos.form.control.events.UploadListener;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.MessageBoxClosedEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.FieldEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.scm.common.util.DynamicObjectUtil;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.EventObject;
import java.util.List;

/**
 * @Description:销售合同：值更新，基础资料过滤
 * @Auther: zbh
 */
public class SalescontractFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener, UploadListener {

    private static final String BAR_SAVE = "bar_save"; //保存
    private static final String BAR_SUBMIT = "bar_submit"; //提交
    private static final String TBMAIN = "tbmain";//工具栏

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();

        ChangeData cd = e.getChangeSet()[0];
        int rowIndex = cd.getRowIndex();

        switch (name) {
            case "tpv_startinstallation"://装期从
            case "tpv_startinstallations"://装期至
                judgeTime();
                break;
            case "tpv_estimateddeparture"://预计开船日期
            case "tpv_esticustomertime"://预计客户收货时间
                judgeTimes();
                break;
            case "tpv_proportion"://比例（%）
            case "tpv_natureofpayment"://款项性质
//                blBituDate();
                proportion();
            case "tpv_taxpramount"://含税金额
                proportionChanged();
//                money();
                break;
            case "tpv_contractnos"://合同号
                trim();
                break;
            case "tpv_customername"://客户名称
                custom();
                break;
            case "tpv_rule"://商品组距价差规则
                distanceDifference();//带出分录
                break;
            case "tpv_signingdate"://签约日期
                addBizdate();
                break;
            case "tpv_bizdate": //业务日期
                addYearDay();
                break;
            case "tpv_saleslocation"://预计销售地
                getSuperior();
                break;
            case "tpv_salesregion"://销售大区
//                salesregion();
                break;
            case "tpv_yesdifference"://默认差价
                redYesdifference();
                break;
            case "tpv_attachmenttype":  //附件类型
                attachmentName();
                break;
            case "tpv_overloadingrates"://溢装率(%)
            case "tpv_qty"://数量
            case "tpv_salescontractnums"://已第三方销售合同数量
                salesContractnums();
                volumeunp();
            case "tpv_paymentmethod"://付佣方法
            case "tpv_commissionprice"://佣金单价
                commission();
                break;
            case "tpv_combinationnumber": //组合号
            case "tpv_businesstype":  //业务类型
                awardtype();
                break;
            case "tpv_operator": //业务员
                operator();
                break;
            case "tpv_settlementstatus"://结算状态
            case "tpv_cargostatus"://货物状态
                incomingStatus();
            case "tpv_rationtype":   //定量方式
            case "tpv_pricetype":   //定价类型
            case "tpv_amount":     //合同金额
            case "tpv_totalamount"://付款金额
                paymentStatus();
                break;
//            case "tpv_daytype"://保证金应收日类型
//                dayTypeBl();
//                break;
            case "tpv_beforeandafter"://货前后
                tpvBeforeandafter();
                break;
            case "tpv_strategynum"://策略号
                setPositionQty(name, "tpv_positionnums", "tpv_openposition");
                break;
            default:
                break;
        }
    }

    private void setPositionQty(String name, String positionnumsKey, String openpositionKey) {
        DynamicObject tpvStrategynum = (DynamicObject) this.getModel().getValue(name);
        if (YEM.isNotEmpty(tpvStrategynum)) {
            long id = tpvStrategynum.getLong("id");
            DataSet purchase = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_purchase", "id,tpv_contractnumber,tpv_policynumber.id policyid," +
                            "tpv_policynumber.number policynumber,tpv_materialentry,tpv_materialentry.tpv_qty qty",
                    new QFilter[]{new QFilter("tpv_contractstatusx", QCP.in, new String[]{"A", "B", "C", "D", "F", "G"})
                            .and(new QFilter("tpv_policynumber.id", QCP.in, id))}).select("policyid policyid","qty purqty","0.0 saleqty");
            DataSet salescontract = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_salescontract", "id,tpv_contractnos,tpv_strategynum.id strategyid," +
                            "tpv_strategynum.number strategynum,tpv_materialentry,tpv_materialentry.tpv_qty qty",
                    new QFilter[]{new QFilter("tpv_contractstatus", QCP.in, new String[]{"A","B","C","D","G","H"})
                            .and(new QFilter("tpv_strategynum.id", QCP.in, id))}).select("strategyid policyid","qty saleqty","0.0 purqty");
            DataSet dataSet = purchase.union(salescontract).groupBy(new String[]{"policyid"}).sum("saleqty").sum("purqty").finish();
            dataSet = RptUtil.zeroNullNums(dataSet);
            dataSet = dataSet.addField("(purqty - saleqty) qty", "qty");
            BigDecimal qty = BigDecimal.ZERO;
            if (!dataSet.isEmpty()) {
                for (Row row : dataSet) {
                    qty = row.getBigDecimal("qty").setScale(2, BigDecimal.ROUND_HALF_UP).abs();
                }
            }
            BigDecimal tpvReplylimit = BigDecimalUtils.toBigDecimal(tpvStrategynum.getBigDecimal("tpv_replylimit")).setScale(2, BigDecimal.ROUND_HALF_UP);
            this.getModel().setValue(positionnumsKey,qty);
            this.getModel().setValue(openpositionKey,tpvReplylimit.subtract(qty));
        } else {
            this.getModel().setValue(positionnumsKey, BigDecimal.ZERO);
            this.getModel().setValue(openpositionKey, BigDecimal.ZERO);
        }
    }

    private void volumeunp() {
        DynamicObjectCollection tpvMaterialentry = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_materialentry");
        BigDecimal decimal = BigDecimal.ZERO;
        for (DynamicObject dynamicObject : tpvMaterialentry) {
            decimal = decimal.add(dynamicObject.getBigDecimal("tpv_qty"));
        }
        this.getModel().setValue("tpv_volumeunp", decimal);
    }

    private void getSuperior() {
        DynamicObject tpvSaleslocation = (DynamicObject) this.getModel().getValue("tpv_saleslocation");
        if (YEM.isNotEmpty(tpvSaleslocation)) {
            DynamicObject bdAdmindivision = BusinessDataServiceHelper.loadSingle(tpvSaleslocation.getPkValue(), "bd_admindivision");
            if (YEM.isNotEmpty(bdAdmindivision)) {
                String number = "";
                DynamicObject basedatafield = bdAdmindivision.getDynamicObject("basedatafield");
                if (YEM.isNotEmpty(basedatafield)) {
                    int level = basedatafield.getInt("level");
                    if (level > 0) {
                        if (level == 1) {
                            number = bdAdmindivision.getString("number");
                        } else {
                            DynamicObject parent = bdAdmindivision.getDynamicObject("parent");
                            for (int i = level; i > 2; i--) {
                                parent = parent.getDynamicObject("parent");
                            }
                            number = parent.getString("number");
                        }
                    }
                    if (YEM.isNotEmpty(number)) {
                        DynamicObject[] parents = BusinessDataServiceHelper.load("tpv_tm_region",
                                "tpv_province,number,name",
                                new QFilter[]{new QFilter("enable", QCP.equals, "1")
                                        .and(new QFilter("tpv_province.fbasedataid.number", QCP.equals, number))});
                        if (parents.length == 1) {
                            this.getModel().setValue("tpv_salesregion", parents[0].getPkValue());
                            return;
                        }
                    }
                }
            }
        }
        this.getModel().setValue("tpv_salesregion", null);
    }

    public void tpvBeforeandafter() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvPaymentplans = dataEntity.getDynamicObjectCollection("tpv_paymentplans");
        if (tpvPaymentplans.size() == 0) {
            this.getModel().setValue("tpv_isselloncredit", false);
        }
        for (DynamicObject tpvPaymentplan : tpvPaymentplans) {
            String tpvBeforeandafter = tpvPaymentplan.getString("tpv_beforeandafter");
            if ("B".equals(tpvBeforeandafter)) {
                this.getModel().setValue("tpv_isselloncredit", true);
                return;
            } else if ("A".equals(tpvBeforeandafter)) {
                this.getModel().setValue("tpv_isselloncredit", false);
            }
        }
    }

    public void dayTypeBl() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        FieldEdit daytype = this.getView().getControl("tpv_collectiondate");
        DynamicObjectCollection tpvPaymentplans = dataEntity.getDynamicObjectCollection("tpv_paymentplans");
        if (tpvPaymentplans.size() == 0) {
            daytype.setMustInput(false);
        }
        for (DynamicObject tpvPaymentplan : tpvPaymentplans) {

            String natureofpayment = tpvPaymentplan.getString("tpv_daytype");
            if ("A".equals(natureofpayment)) {
                daytype.setMustInput(true);
            } else {
                daytype.setMustInput(false);
            }
        }
    }

    public void blBituDate() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        FieldEdit daytype = this.getView().getControl("tpv_daytype");
        DynamicObjectCollection tpvPaymentplans = dataEntity.getDynamicObjectCollection("tpv_paymentplans");
        if (tpvPaymentplans.size() == 0) {
            daytype.setMustInput(false);
        }
        for (DynamicObject tpvPaymentplan : tpvPaymentplans) {
            String natureofpayment = tpvPaymentplan.getString("tpv_natureofpayment");
            if ("A".equals(natureofpayment)) {
                daytype.setMustInput(true);
            } else {
                daytype.setMustInput(false);
            }
        }
    }

    /*
    开始日期（装期从、装期至）不能大于结束日期；
     */
    public void judgeTime() {
        Date startDate = (Date) this.getModel().getValue("tpv_startinstallation");
        Date endDate = (Date) this.getModel().getValue("tpv_startinstallations");
        if (startDate != null && endDate != null) {
            boolean before = endDate.before(startDate);
            if (before) {
                this.getView().showMessage("注意装期从不能大于装期至，请重新填写");
                this.getModel().setValue("tpv_startinstallations", null);
            }
        }
    }

    /*
       开始日期（装期从、装期至）不能大于客户收货时间；
        */
    public void judgeTimes() {
        Date startDate = (Date) this.getModel().getValue("tpv_estimateddeparture");
        Date endDate = (Date) this.getModel().getValue("tpv_esticustomertime");
        if (startDate != null && endDate != null) {
            boolean before = endDate.before(startDate);
            if (before) {
                this.getView().showMessage("注意预计开船日期不能大于预计客户收货时间，请重新填写");
                this.getModel().setValue("tpv_esticustomertime", null);
            }
        }
    }

    /*
    组商品组距价差规则带出组距差（分录信息）
     */
    public void distanceDifference() {
        DynamicObject ditygroup = (DynamicObject) this.getModel().getValue("tpv_rule");//获取商品组距价差规则
        if (null != ditygroup) {
            DynamicObjectCollection strategypice = new DynamicObjectCollection();
            String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_bd_strategypice", false);// 获取单据头所有字段标识
            selectFieid2 = DynamicObjectUtil.getEntrySelectfields(selectFieid2, "tpv_bd_strategypice", "tpv_bd_strategypice_a", false);// 获取供应商分录所有字段标识
            Long ditygroupid = ditygroup.getLong("id");
            DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_bd_strategypice", selectFieid2, new QFilter[]{new QFilter("id", QCP.equals, ditygroupid)});
            for (DynamicObject bill : bills) {
                strategypice = bill.getDynamicObjectCollection("tpv_bd_strategypice_a");//品组距价差规则的明细信息
            }
            this.getModel().deleteEntryData("tpv_dt_salescontract_z");//组距差
            for (DynamicObject entity : strategypice) {
                int index = this.getModel().createNewEntryRow("tpv_dt_salescontract_z");//组距差
                this.getModel().setValue("tpv_baseprice", entity.getBoolean("tpv_baseprice"), index);//是否基价商品
                this.getModel().setValue("tpv_goodsname", entity.getLong("tpv_comcoding.id"), index);//商品
                this.getModel().setValue("tpv_producers", entity.getDynamicObject("tpv_productlands"), index);//产地
                this.getModel().setValue("tpv_materialqualitys", entity.getString("tpv_texture"), index);//材质
                this.getModel().setValue("tpv_specifications", entity.getString("tpv_specification"), index);//规格
                this.getModel().setValue("tpv_defaultdifferences", entity.getBigDecimal("tpv_diffprice"), index);//默认价差
            }
        } else {
            this.getModel().deleteEntryData("tpv_dt_salescontract_z");   //清除组距差分录
        }
    }

    /*
    当付佣方法为单品佣金，计算佣金
     */
    public void commission() {
        DynamicObjectCollection entrys = this.getModel().getEntryEntity("tpv_materialentry");//获取商品明细分录
        BigDecimal sunnum = BigDecimal.ZERO;//总数量
        for (DynamicObject entity : entrys) {
            sunnum = sunnum.add(entity.getBigDecimal("tpv_qty"));
        }
        String paymentmethod = (String) this.getModel().getValue("tpv_paymentmethod");//付佣方式
        if (null != paymentmethod && paymentmethod != "" && "C".equals(paymentmethod)) {
            BigDecimal commissionunitpric = (BigDecimal) this.getModel().getValue("tpv_commissionprice");//佣金单价
            if (BigDecimal.ZERO.compareTo(commissionunitpric) != 0 && BigDecimal.ZERO.compareTo(sunnum) != 0) {
                this.getModel().setValue("tpv_commission", sunnum.multiply(commissionunitpric));
            } else {
                this.getModel().setValue("tpv_commission", 0);
            }
        }
    }

    /*
      计算收款计划的金额
     */
    public void proportionChanged() {
        BigDecimal count = BigDecimal.ZERO;
        int row = getModel().getEntryRowCount("tpv_materialentry"); //商品明细
        for (int i = 0; i < row; i++) {
            BigDecimal num = (BigDecimal) this.getModel().getValue("tpv_taxpramount", i);//含税金额
//            商品信息分录含税金额总和
            if (BigDecimal.ZERO.compareTo(num) != 0) {
                count = num.add(count);
            }
        }
//        int rows = getModel().getEntryRowCount("tpv_paymentplans"); //收款计划
//        for (int i = 0; i < rows; i++) {
//            if (BigDecimal.ZERO.compareTo(count) != 0) {
////                收款计划分录比例
//                BigDecimal num = (BigDecimal) this.getModel().getValue("tpv_proportion", i);
//                if (BigDecimal.ZERO.compareTo(num) != 0) {
//                    BigDecimal res = count.multiply(num);
//                    BigDecimal resTotal = res.divide(new BigDecimal(100), 2, BigDecimal.ROUND_HALF_UP);
//                    this.getModel().setValue("tpv_totalamount", resTotal, i);
//                }
//            } else {
//                this.getModel().setValue("tpv_totalamount", BigDecimal.ZERO, i);
//            }
//        }
        DynamicObjectCollection tpvPaymentplans = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_paymentplans");
        if (tpvPaymentplans.size() > 0) {
            for (int i = 0; i < tpvPaymentplans.size(); i++) {
                if (BigDecimal.ZERO.compareTo(count) != 0) {
//                收款计划分录比例
                    DynamicObject dynamicObject = tpvPaymentplans.get(i);
                    BigDecimal num = dynamicObject.getBigDecimal("tpv_proportion");
                    if (BigDecimal.ZERO.compareTo(num) != 0) {
                        BigDecimal res = count.multiply(num);
                        BigDecimal resTotal = res.divide(new BigDecimal(100), 2, BigDecimal.ROUND_HALF_UP);
                        this.getModel().setValue("tpv_totalamount", resTotal, i);
                    }
                } else {
                    this.getModel().setValue("tpv_totalamount", BigDecimal.ZERO, i);
                }
            }
        }
    }

    /*
     根据比例和金额计算约定保比
     */
    public void money() {
        int row = getModel().getEntryRowCount("tpv_paymentplans");
        BigDecimal count = new BigDecimal(0);
        for (int i = 0; i < row; i++) {
            String nature = (String) this.getModel().getValue("tpv_natureofpayment", i);//款项性质
            BigDecimal proportion = (BigDecimal) this.getModel().getValue("tpv_proportion", i);//比例
            if (nature != null && BigDecimal.ZERO.compareTo(proportion) != 0) {
                if ("A".equals(nature)) {
                    count = count.add(proportion);
                }
            }
        }
        this.getModel().setValue("tpv_appointmarginrate", count);
    }

    /*
    去除合同号中的空格
     */
    public void trim() {
        String oldName = (String) this.getModel().getValue("tpv_contractnos");
        String newName = oldName.replace(" ", "");//将合同号中的" "替换为""
        this.getModel().setValue("tpv_contractnos", newName);
    }

    /*
    销售推销售，判断是否第三方销售
     */
    public void custom() {
        String bianMa = (String) this.getModel().getValue("tpv_sourcebillno");//获取来源单据编码
        String downCustomName = (String) this.getModel().getValue("tpv_customername");//客户姓名
        if (null != bianMa && "" != bianMa) {
            DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("tpv_dt_salescontract", new QFilter[]{new QFilter("billno", QCP.equals, bianMa)});
            if (null != dynamicObject) {
                String upCustomername = dynamicObject.getString("tpv_customername");
                if (downCustomName.equals(upCustomername)) {
                    this.getModel().setValue("tpv_thirdparty", false);//是否第三方销售
                } else {
                    this.getModel().setValue("tpv_thirdparty", true);
                }
            }
        }
    }

    /*
    根据【业务日期】进行更新赋值，年份+1，日-1；（年月日）
     */
    public void addYearDay() {
        Date bizdate = (Date) this.getModel().getValue("tpv_bizdate");//业务日期
        if (bizdate != null) {
            this.getModel().setValue("tpv_signingdate", bizdate);//签约日期
            Date signingdate = (Date) this.getModel().getValue("tpv_signingdate");
            if (signingdate != null) {
                Date date = DateUtil.addDays(signingdate, -1);
                int year = date.getYear() + 1;
                date.setYear(year);
                this.getModel().setValue("tpv_usedate", date);//合同有效期限
            }
        }
    }

    /*
      根据【签约日期】进行更新赋值，年份+1，日-1；（年月日）
      */
    public void addBizdate() {
        Date signingdate = (Date) this.getModel().getValue("tpv_signingdate");//签约日期
        if (signingdate != null) {
            Date date = DateUtil.addDays(signingdate, -1);
            int year = date.getYear() + 1;
            date.setYear(year);
            this.getModel().setValue("tpv_usedate", date);//合同有效期限
        }
    }

    /*
    默认差价修改变为红色
     */
    public void redYesdifference() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection purchase_zjc = dataEntity.getDynamicObjectCollection("tpv_dt_salescontract_z");//组距差
        for (DynamicObject purentrtry : purchase_zjc) {
            BigDecimal defaultpricediff = purentrtry.getBigDecimal("tpv_defaultdifferences");//默认价差
            BigDecimal confirmpricediff = purentrtry.getBigDecimal("tpv_yesdifference");//确认价差
            if (defaultpricediff.compareTo(confirmpricediff) != 0) {
                int row = purentrtry.getInt("Seq");
                AbstractGrid grid = this.getView().getControl("tpv_dt_salescontract_z");//获取分录表体
                ArrayList<CellStyle> csList = new ArrayList();
                CellStyle cs = new CellStyle();
                cs.setForeColor("#ff0000");//字体颜色
                cs.setFieldKey("tpv_yesdifference");//列标识
                cs.setRow(row - 1);//行索引
                csList.add(cs);
                grid.setCellStyle(csList);//设置单元格样式
                this.getView().updateView("tpv_dt_salescontract_z");
            } else {
                int row = purentrtry.getInt("Seq");
                AbstractGrid grid = this.getView().getControl("tpv_dt_salescontract_z");//获取分录表体
                ArrayList<CellStyle> csList = new ArrayList();
                CellStyle cs = new CellStyle();
                cs.setForeColor("#000000");//字体颜色
                cs.setFieldKey("tpv_yesdifference");//列标识
                cs.setRow(row - 1);//行索引
                csList.add(cs);
                grid.setCellStyle(csList);//设置单元格样式
                this.getView().updateView("tpv_dt_salescontract_z");
            }
        }
    }

    /*
    当销售大区的主营基价商品为一种的时候，自动带出基价商品
     */
    public void salesregion() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject salesarea = dataEntity.getDynamicObject("tpv_salesregion");//销售大区
        if (salesarea != null) {
            DynamicObject tmRegion = BusinessDataServiceHelper.loadSingle(salesarea.getPkValue(), "tpv_tm_region");
            DynamicObjectCollection majorbasepro = tmRegion.getDynamicObjectCollection("tpv_majorbasepro");//主营基价商品
            if (majorbasepro.size() > 0 && majorbasepro.size() == 1) {
                for (DynamicObject major : majorbasepro) {
                    Long masterid = major.getLong("fbasedataid.id");
                    this.getModel().setValue("tpv_basegoods", masterid);//基价商品
                }
            } else {
                this.getModel().setValue("tpv_basegoods", null);
            }
        } else {
            this.getModel().setValue("tpv_basegoods", null);
        }
    }

    /*
   如果分录【协同审批】全部未勾选，则=“无”；
   如果分录【协同审批】有勾选的，将【协同审批】的【部门】拼接起来，中间用逗号隔开；
  */
    public void depJion() {
//        StringBuilder builder = new StringBuilder();
//        DynamicObjectCollection entryEntity = this.getModel().getEntryEntity("tpv_approvalsetting");//合并审批（分录）
//        int isFlag = 0;  //记录协同审批的数量
//        if (entryEntity != null) {
//            for (DynamicObject entry : entryEntity) {
//                boolean collaborativeappr = entry.getBoolean("tpv_collaborative");//协同审批
//                String department = entry.getString("tpv_department_aps.name");//部门
//                if (collaborativeappr) {
//                    if (department != null && department != "") {
//                        builder.append(department).append(",");
//                    }
//                } else {
//                    isFlag++;
//                }
//            }
//            if (isFlag == entryEntity.size() || 0 == builder.length()) {
//                this.getModel().setValue("tpv_approvaldepts", "无");
//            } else {
//                //去除最后的，
//                builder.deleteCharAt(builder.lastIndexOf(","));
//                this.getModel().setValue("tpv_approvaldepts", builder);
//            }
//        }
    }

    /*
     数量+溢装率不能小于已第三方销售合同数量
     */
    public void salesContractnums() {
        BigDecimal overloadingrates = (BigDecimal) this.getModel().getValue("tpv_overloadingrates");//溢装率(%)
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品明细
        List<String> messageList = new ArrayList<>();
        for (int i = 0; i < materialentry.size(); i++) {
            DynamicObject dynamicObject = materialentry.get(i);
            BigDecimal qty = dynamicObject.getBigDecimal("tpv_qty");
            BigDecimal salescontractnums = dynamicObject.getBigDecimal("tpv_salescontractnums");//已第三方销售合同数量
            if (BigDecimal.ZERO.compareTo(salescontractnums) != 0 && BigDecimal.ZERO.compareTo(qty) != 0 && BigDecimal.ZERO.compareTo(overloadingrates) != 0) {
                if (qty.add(overloadingrates).compareTo(salescontractnums) < 0) {
                    messageList.add("数量+溢装率");
                    this.getView().showTipNotification(String.format("商品明细第%S行:%S不能小于已第三方销售合同数量", String.valueOf(i + 1), String.join(",", messageList)));
                    this.getModel().setValue("tpv_qty", BigDecimal.ZERO, i);
                }
                messageList.clear();
            }
        }
    }

    /*
      是否双签件
     */
    public void attachmentName() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection attachmentdetail = dataEntity.getDynamicObjectCollection("tpv_attachmentdetail");//附件分录
        boolean isFlag = true;
        if (attachmentdetail.size() != 0) {
            for (DynamicObject dynamicObject : attachmentdetail) {
                DynamicObject attachmenttype = dynamicObject.getDynamicObject("tpv_attachmenttype");//附件类型
                if (attachmenttype != null) {
                    String string = attachmenttype.getString("name");
                    if (string != null && string.contains("双签")) {
                        this.getModel().setValue("tpv_doublestatus", "B");//双签状态
                        isFlag = false;
                    }
                }
            }
        }
        if (isFlag) {
            this.getModel().setValue("tpv_doublestatus", "A");
        }
    }

    /*
    《销售合同》{收款计划-分录}【比例%】汇总值不能>“100”
    */
    public void proportion() {
        BigDecimal sunnum = BigDecimal.ZERO;//比例
        BigDecimal sum = BigDecimal.ZERO;//约定保比
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection paymentplans = dataEntity.getDynamicObjectCollection("tpv_paymentplans");//收款计划

        for (int i = 0; i < paymentplans.size(); i++) {
            DynamicObject paymnet = paymentplans.get(i);
            BigDecimal tpvProportion = paymnet.getBigDecimal("tpv_proportion");//比例
            String natureofpayment = paymnet.getString("tpv_natureofpayment");//款项性质
            sunnum = sunnum.add(tpvProportion);
            if ("A".equals(natureofpayment)) {
                sum = sum.add(tpvProportion);
            }
        }
        if (sunnum.compareTo(BigDecimalUtils.one_handred) > 0) {
            for (int i = 0; i < paymentplans.size(); i++) {
                this.getModel().setValue("tpv_proportion", 0, i);
            }
            this.getView().showTipNotification("比例%汇总值不能大于100");
        } else if (sum.compareTo(BigDecimal.ZERO) > 0) {
            this.getModel().setValue("tpv_appointmarginrate", sum);
        }
    }

    /*
      选择【业务类型】对《提奖类型》基础资料进行过滤显示；如果《提奖类型》中【适用业务类型】多选基础资料，只存在一条数据则自动赋值；
     */
    public void awardtype() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject salesarea = dataEntity.getDynamicObject("tpv_businesstype");//业务类型
        if (salesarea != null) {
            Object id = salesarea.get("id");
            DynamicObject[] loadSingle = BusinessDataServiceHelper.load("tpv_bd_extracttype", "tpv_usebusinesstype", new QFilter[]{new QFilter("tpv_usebusinesstype.fbasedataid.id", QCP.equals, id)});
            if (loadSingle.length > 0 && loadSingle.length == 1) {
                DynamicObject majorbasepro = loadSingle[0];
                DynamicObjectCollection major = majorbasepro.getDynamicObjectCollection("tpv_usebusinesstype");//适用业务类型
                if (major.size() > 0 && major.size() == 1) {
                    for (DynamicObject load : loadSingle) {
                        long masterid = load.getLong("id");
                        this.getModel().setValue("tpv_awardtype", masterid);//适用业务类型
//                        this.getView().setEnable(false, "tpv_awardtype");
                    }
                }
            } else {
//                this.getModel().setValue("tpv_awardtype", null);
//                this.getView().setEnable(true, "tpv_awardtype");
            }
        } else {
//            this.getModel().setValue("tpv_awardtype", null);
//            this.getView().setEnable(true, "tpv_awardtype");
        }
    }

    /*

     */
    public void saleStatus() {
        String billStatus = (String) this.getModel().getValue("billstatus"); //单据状态
        String settlementStatus = (String) this.getModel().getValue("tpv_settlementstatus"); //单据状态
        switch (billStatus) {
            case "A":
                this.getModel().setValue("tpv_contractstatus", "A");
                break;
            case "B":
                this.getModel().setValue("tpv_contractstatus", "B");
                break;
            case "C":
                if ("B".equals(settlementStatus)) {
                    this.getModel().setValue("tpv_contractstatus", "G");
                }
                this.getModel().setValue("tpv_contractstatus", "D");
                break;
        }
    }

    /*
    (1)默认=空；
    (2)票数量齐：【货物状态】=“出库齐”且《销售合同》向下所有货值发票（含红字发票）货物数量=出库数量-退货数量；
    (3)票金额齐：【结算状态】=“已结算”且【货物状态】=“出库齐”的前提下，《销售合同》向下所有货值发票（含红字发票）货物金额=销售合同结算金额；
     */
    public void incomingStatus() {
        String cargostatus = (String) this.getModel().getValue("tpv_cargostatus");//货物状态
        String settlementstatus = (String) this.getModel().getValue("tpv_settlementstatus");//结算状态
        if (cargostatus == null || settlementstatus == null) {
            return;
        }
        if ("C".equals(cargostatus)) {
            this.getModel().setValue("tpv_cometicketstatus", "C");
            return;
        }
        if ("C".equals(cargostatus) && "B".equals(settlementstatus)) {
            this.getModel().setValue("tpv_cometicketstatus", "D");
            this.getModel().setValue("tpv_contractstatus", "G");//合同状态
        }
    }

    /*
    枚举
    (1)默认=空；
    (2)款齐
    ①《销售合同》【定价类型】=固定价且【定量方式】等于“表列数量”：收款总金额≥合同金额触发；
    ②《销售合同》【定价类型】=固定价且【定量方式】不等于“表列数量”且货齐时：判定收款总金额≥货值；
    ③《销售合同》【定价类型】=后定价且货齐后且《作价工作台》所有【销售价格类型】=“已确认”或“最终发票”时：收款总金额≥总货值触发；
    */
    public void paymentStatus() {
        BigDecimal amountTotal = BigDecimal.ZERO; //收款总金额
        String rationtype = (String) this.getModel().getValue("tpv_rationtype");//定量方式
        String pricetype = (String) this.getModel().getValue("tpv_pricetype"); //定价类型
        if (pricetype == null || rationtype == null) {
            return;
        }
        DynamicObjectCollection paymentplans = this.getModel().getEntryEntity("tpv_paymentplans");  //收款计划分录
        BigDecimal amount = (BigDecimal) this.getModel().getValue("tpv_amount");  //总金额
        if (paymentplans.size() > 0) {
            for (DynamicObject paymentplan : paymentplans) {
                BigDecimal tpvTotalamount = paymentplan.getBigDecimal("tpv_totalamount");
                amountTotal = amountTotal.add(tpvTotalamount);
            }
            if ("A".equals(rationtype) && "A".equals(pricetype) && amountTotal.compareTo(amount) >= 0 && amount.compareTo(BigDecimal.ZERO) != 0) {
                this.getModel().setValue("tpv_paymentstatus", "B");
                return;
            }
            String cargostatus = (String) this.getModel().getValue("tpv_cargostatus"); //货物状态
            if (!"A".equals(rationtype) && "A".equals(pricetype) && "B".equals(cargostatus)) {
                this.getModel().setValue("tpv_paymentstatus", "B");
                return;
            }
            if ("B".equals(pricetype) && "B".equals(cargostatus) && "B".equals(cargostatus)) {
                this.getModel().setValue("tpv_paymentstatus", "B");
                return;
            }
            this.getModel().setValue("tpv_paymentstatus", "A");
        }

    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners(TBMAIN);
        this.addItemClickListeners("tpv_tbmainentry1");
        BasedataEdit tpv_combinationnumber = this.getView().getControl("tpv_combinationnumber");//组合号
        tpv_combinationnumber.addBeforeF7SelectListener(this);
        BasedataEdit tpv_awardtype = this.getView().getControl("tpv_awardtype");//提奖类型
        tpv_awardtype.addBeforeF7SelectListener(this);
        BasedataEdit tpv_longtermag = this.getView().getControl("tpv_longtermag");//协议号
        tpv_longtermag.addBeforeF7SelectListener(this);
        BasedataEdit tpv_pointpricecontract = this.getView().getControl("tpv_pointpricecontract");//合约池
        tpv_pointpricecontract.addBeforeF7SelectListener(this);
        AttachmentPanel attachmentPanel = this.getView().getControl("attachmentpanel");//附件
        attachmentPanel.addUploadListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_combinationnumber"://组合号
                qFilterThisOrgCombin(e);//过滤当前组织
                break;
            case "tpv_awardtype":     //提奖类型
                qFilterThisBusinessCombin(e);
                break;
            case "tpv_longtermag":  //协议号
                qFilterThislongtermagCombin(e);
                break;
            case "tpv_pointpricecontract":  //协议号
                qFilterThispointpriceCombin(e);
                break;
        }
    }

    /*
       《合约池》时只允许选择《合约池》中【有效期】＞【业务日期】的数据；
     */
    private void qFilterThispointpriceCombin(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Date bizdate = dataEntity.getDate("tpv_bizdate");
        if (null == bizdate) {
            return;
        }
        QFilters.add(new QFilter("tpv_effectivedate", ">", bizdate)); //合约池
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    /*
     根据部门对组合号进行过滤
     */
    private void qFilterThisOrgCombin(BeforeF7SelectEvent e) {
        DynamicObject department = (DynamicObject) this.getModel().getValue("tpv_department");
        if (department == null) {
            this.getView().showTipNotification("请先选择部门！");
            e.setCancel(true);
            return;
        }
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject org = dataEntity.getDynamicObject("tpv_department");
        if (null == org) {
            return;
        }
        Object id = org.get("id");
        QFilters.add(new QFilter("tpv_departments", "=", id)); //设置过滤条件：组织
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    /*
   【提奖类型】根据【业务类型】进行过滤
    */
    private void qFilterThisBusinessCombin(BeforeF7SelectEvent e) {
        List<QFilter> QFilters = new ArrayList<>();

        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject org = dataEntity.getDynamicObject("tpv_businesstype");
        if (null == org) {
            return;
        }
        Object id = org.get("id");  //tpv_awardtype
        QFilters.add(new QFilter("tpv_usebusinesstype.fbasedataid", "=", id)); //tpv_usebusinesstype多选基础资料 tpv_usebusinesstype.fbasedataid得到基础资料
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    /*
       《协议号》过滤当前组织单据
        【协议号】【协议号列表】只展示协议【有效期】>【业务日期】的数据；
        《销售合同》{业务模式}【协议号】中的协议号列表只允许显示《客户协议》
     */
    private void qFilterThislongtermagCombin(BeforeF7SelectEvent e) {
        List<QFilter> QFilters = new ArrayList();
        List Qmag = new ArrayList();
        Qmag.add("B");
        Qmag.add("D");
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject org = dataEntity.getDynamicObject("org");
        Date bizdate = dataEntity.getDate("tpv_bizdate");
        if (null == org) {
            return;
        }
        Object id = org.get("id");
        QFilters.add(new QFilter("org", "=", id));
        QFilters.add(new QFilter("tpv_ctvaliddate", ">", bizdate));
        QFilters.add(new QFilter("tpv_protocoltype", "in", Qmag));
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    @Override
    public void beforeItemClick(BeforeItemClickEvent evt) {
        super.beforeItemClick(evt);
        String itemKey = evt.getItemKey();
        switch (itemKey) {
            case BAR_SAVE:
                saveContractnos(evt);
                break;
            case BAR_SUBMIT:
                proportionSub(evt);
                break;
            case "tpv_arrall":  //发货齐
            case "tpv_noarrall":  //取消发货齐
                arrall(itemKey);
                break;
        }
    }

    private void proportionSub(BeforeItemClickEvent evt) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvPaymentplans = dataEntity.getDynamicObjectCollection("tpv_paymentplans");
        BigDecimal decimal = BigDecimal.ZERO;
        if (tpvPaymentplans.size() == 0) {
            this.getView().showErrorNotification("收款计划“比例(%)”不允许为空！");
            evt.setCancel(true);
            return;
        }
        for (DynamicObject tpvPaymentplan : tpvPaymentplans) {
            BigDecimal proportion = tpvPaymentplan.getBigDecimal("tpv_proportion");
            decimal = decimal.add(proportion);
        }
        if (decimal.compareTo(BigDecimalUtils.one_handred) != 0) {
            this.getView().showErrorNotification("收款计划“比例(%)”必须等于100");
            evt.setCancel(true);
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey();
        switch (itemKey) {
            case "tpv_newentry_11":
                addProportion();
                break;
            case "tpv_void":
                voidUpdateContratstatus("tpv_void", "是否确认作废？");
                break;
            case "tpv_unvoid":
                //反作废操作前让用户选择是否继续反作废操作，在用户点击确认框上的按钮后，系统会调用confirmCallBack方法
                voidUpdateContratstatus("tpv_unvoid", "是否确认反作废？");
                break;
        }
    }

    private void voidUpdateContratstatus(String tpv_void, String s) {
        if ("tpv_unvoid".equals(tpv_void)) {
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            String tpvContractstatus = dataEntity.getString("tpv_contractstatus");
            if ("F".equals(tpvContractstatus)) {
                //作废操作前让用户选择是否继续作废操作，在用户点击确认框上的按钮后，系统会调用confirmCallBack方法
                ConfirmCallBackListener confirmCallBackListener = new ConfirmCallBackListener(tpv_void, this);
                //设置页面确认框，参数为：标题，选项框类型，回调监听
                this.getView().showConfirm(s, MessageBoxOptions.YesNo, confirmCallBackListener);
            } else {
                this.getView().showTipNotification("合同状态为作废情况下，才允许点击此按钮操作！");
                return;
            }
        }
        //作废操作前让用户选择是否继续作废操作，在用户点击确认框上的按钮后，系统会调用confirmCallBack方法
        ConfirmCallBackListener confirmCallBackListener = new ConfirmCallBackListener(tpv_void, this);
        //设置页面确认框，参数为：标题，选项框类型，回调监听
        this.getView().showConfirm(s, MessageBoxOptions.YesNo, confirmCallBackListener);
    }

    /**
     * 选择框回调函数
     */
    @Override
    public void confirmCallBack(MessageBoxClosedEvent messageBoxClosedEvent) {
        super.confirmCallBack(messageBoxClosedEvent);
        //判断是否是对应确认框的点击回调事件
        if (StringUtils.equals("tpv_void", messageBoxClosedEvent.getCallBackId())) {
            if (MessageBoxResult.Yes.equals(messageBoxClosedEvent.getResult())) {
                //如果点击确认按钮，则把当前页面相关值清空
                String bilno = (String) this.getModel().getValue("billno");//采购合同编码
                String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping", false);// 获取单据头所有字段标识
                DynamicObject[] saleshippbills = BusinessDataServiceHelper.load("tpv_dt_salesshipping", selectFieid2, new QFilter[]{
                        new QFilter("tpv_corebillno", QCP.equals, bilno)});
                String selectFieid3 = DynamicObjectUtil.getSelectfields("tpv_tm_kyoping", false);// 获取单据头所有字段标识
                DynamicObject[] kybills = BusinessDataServiceHelper.load("tpv_tm_kyoping", selectFieid3, new QFilter[]{
                        new QFilter("tpv_corebillno", QCP.equals, bilno)});
                String selectFieid4 = DynamicObjectUtil.getSelectfields("tpv_dt_salepricebill", false);// 获取单据头所有字段标识
                DynamicObject[] salepricebills = BusinessDataServiceHelper.load("tpv_dt_salepricebill", selectFieid4, new QFilter[]{
                        new QFilter("tpv_corebillno", QCP.equals, bilno)});
                if (saleshippbills.length < 1 && kybills.length < 1 && salepricebills.length < 1) {
                    String tpvContractstatus = (String) this.getModel().getValue("tpv_contractstatus");
                    this.getModel().setValue("tpv_oldcontractstatus", tpvContractstatus);//合同状态-废除前数据
                    this.getModel().setValue("tpv_contractstatus", "F");//合同状态-废除
                } else {
                    this.getView().showTipNotification("存在下游销售发货单、销售价格确认单，或者协评单，不允许作废！");
                }
                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
            } else if (MessageBoxResult.No.equals(messageBoxClosedEvent.getResult())) {
                // 点击否的相关处理逻辑。。。。
            }
        }
        if (StringUtils.equals("tpv_unvoid", messageBoxClosedEvent.getCallBackId())) {
            if (MessageBoxResult.Yes.equals(messageBoxClosedEvent.getResult())) {
                String tpvOldcontractstatus = (String) this.getModel().getValue("tpv_oldcontractstatus");
                this.getModel().setValue("tpv_contractstatus", tpvOldcontractstatus);//合同状态-废除前数据
                this.getModel().setValue("tpv_oldcontractstatus", null);
                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
            } else if (MessageBoxResult.No.equals(messageBoxClosedEvent.getResult())) {
                // 点击否的相关处理逻辑。。。。
            }
        }
    }

    /*
    收款计划，新增行时，比例自动赋值100-已存在行比例之和；
    */
    private void addProportion() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvPaymentplans = dataEntity.getDynamicObjectCollection("tpv_paymentplans");
        if (tpvPaymentplans.size() == 1) {
            this.getModel().setValue("tpv_proportion", BigDecimalUtils.one_handred, tpvPaymentplans.size() - 1);
            return;
        }
        BigDecimal decimal = BigDecimal.ZERO;
        for (DynamicObject tpvPaymentplan : tpvPaymentplans) {
            BigDecimal proportion = tpvPaymentplan.getBigDecimal("tpv_proportion");
            decimal = decimal.add(proportion);
        }
        if (decimal.compareTo(BigDecimal.ZERO) > 0) {
            this.getModel().setValue("tpv_proportion", BigDecimalUtils.one_handred.subtract(decimal), tpvPaymentplans.size() - 1);
        }
    }

    /*
    {合并审批-分录}存在任意一行的【供应商】与本《销售合同》【客户】重名时，单据不允许提交，阻止语“采销两端存在同一客商，不允许同时提交审批，请检查。”；
     */
    private void cutomerNameSup(BeforeItemClickEvent evt) {
        boolean isFlag = false;
        this.getModel().getDataEntity(true);
        DynamicObject customer = (DynamicObject) this.getModel().getValue("tpv_customer");
        if (customer == null) {
            return;
        }
        String cusname = customer.getString("name");
        DynamicObjectCollection approvaltogether = this.getModel().getEntryEntity("tpv_approvaltogether");
        for (DynamicObject approval : approvaltogether) {
            String supname = "";
            DynamicObject supplier = approval.getDynamicObject("tpv_supplier_apt");
            if (supplier != null) {
                supname = supplier.getString("name");
            }
            if (cusname.equals(supname)) {
                isFlag = true;
            }
        }
        if (isFlag) {
            this.getView().showTipNotification("采销两端存在同一客商，不允许同时提交审批，请检查。");
            evt.setCancel(true);
        }
    }

    /*
    增加【发货齐】按钮，点击后将【货物状态】更新为“发货齐”；反向操作将【货物状态】置为“空”；
     */
    private void arrall(String itemKey) {
        if ("tpv_arrall".equals(itemKey)) {
            this.getModel().setValue("tpv_cargostatus", "B");
            this.getView().invokeOperation("save");
        }
        if ("tpv_noarrall".equals(itemKey)) {
            this.getModel().setValue("tpv_cargostatus", "A");
            this.getView().invokeOperation("save");
        }
    }

    /*
    是否第三方销售时，校验《第三方客户备案》中是否存在当前【部门】对本【客户】的生效状态的单据，如无，则不允许提交，
     */
    private void subThirdparty(BeforeItemClickEvent evt) {
        Boolean thirdparty = (Boolean) this.getModel().getValue("tpv_thirdparty"); //是否第三方销售
        if (thirdparty) {
            DynamicObject customer = (DynamicObject) this.getModel().getValue("tpv_customer");//客户
            if (customer == null) {
                return;
            }
            Object id = customer.get("id");
            DynamicObject[] load = BusinessDataServiceHelper.load("tpv_cm_thirdclirecor", "", new QFilter[]{new QFilter("billstatus", QCP.equals, "C"), new QFilter("tpv_customer.id", QCP.equals, id)});
            if (0 == load.length) {
                this.getView().showTipNotification("当前客户在贵部门未进行第三方客户备案，请先申请备案。");
                evt.setCancel(true);
            }
        }
    }

    /*
     【是否供应链金融】=“是”时，校验《链捷贷客户合作审批单》中是否存在当前【客户】的生效状态的单据，如无，则不允许提交，
     */
    private void submitSupplychain(BeforeItemClickEvent evt) {
        Boolean supplychain = (Boolean) this.getModel().getValue("tpv_supplychain");//是否供应链金融
        if (supplychain) {
            DynamicObject customer = (DynamicObject) this.getModel().getValue("tpv_customer");//客户
            if (customer == null) {
                return;
            }

            Object id = customer.get("id");
            DynamicObject[] load = BusinessDataServiceHelper.load("tpv_dt_chaijieloancus", "billstatus", new QFilter[]{new QFilter("billstatus", QCP.equals, 'C'), new QFilter("tpv_customer.id", QCP.equals, id)});
            if (0 == load.length) {
                this.getView().showTipNotification("供应链金融业务下，客户必须先通过《链捷贷客户合作审批单》备案。");
                evt.setCancel(true);
            }

        }
    }

    /*
     校检合同号是否为空
     */
    private void saveContractnos(BeforeItemClickEvent evt) {
        Object value = this.getModel().getValue("tpv_contractnos");//合同号
        if (YEM.isEmpty(value)) {
            this.getView().showTipNotification("请按要求填写“合同号”");
            evt.setCancel(true);
        }
    }

    /*
      根据【签约日期】进行更新赋值，年份+1，日-1；（年月日）
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        addDate();
        tradecountry();
        awardtype();
        setProportion();
    }

    @Override
    public void afterCopyData(EventObject e) {
        super.afterCopyData(e);
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvMaterialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");
        if (tpvMaterialentry.size() > 0) {
            for (int i = 0; i < tpvMaterialentry.size(); i++) {
                DynamicObject dynamicObject = tpvMaterialentry.get(i);
                this.getModel().setValue("tpv_effectivequantity", dynamicObject.getBigDecimal("tpv_qty"), i);
                this.getModel().setValue("tpv_unshippedquantity", dynamicObject.getBigDecimal("tpv_qty"), i);
            }
        }
    }

    private void setProportion() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvPaymentplans = dataEntity.getDynamicObjectCollection("tpv_paymentplans");
        for (int i = 0; i < tpvPaymentplans.size(); i++) {
            this.getModel().setValue("tpv_proportion", 100, i);
        }
    }

    private void tradecountry() {
        DynamicObject value = (DynamicObject) this.getModel().getValue("tpv_documenttypes");
        if (value != null) {
            String number = value.getString("number");
            switch (number) {
                case "tpv_dt_salescontract_NMXS":
                    this.getModel().setValue("tpv_tradeproperty", BusinessDataServiceHelper.loadSingle("tpv_bd_tradeproperty", new QFilter[]{new QFilter("number", "=", "001")}));
                    break;
                case "tpv_dt_salescontract_JKXS":
                    this.getModel().setValue("tpv_tradeproperty", BusinessDataServiceHelper.loadSingle("tpv_bd_tradeproperty", new QFilter[]{new QFilter("number", "=", "002")}));
                    break;
                case "tpv_dt_salescontract_CKXS":
                    this.getModel().setValue("tpv_tradeproperty", BusinessDataServiceHelper.loadSingle("tpv_bd_tradeproperty", new QFilter[]{new QFilter("number", "=", "003")}));
                    break;
                case "tpv_dt_salescontract_ZKXS":
                    this.getModel().setValue("tpv_tradeproperty", BusinessDataServiceHelper.loadSingle("tpv_bd_tradeproperty", new QFilter[]{new QFilter("number", "=", "004")}));
                    break;
            }
        }
    }

    /*
    打开合同给签约日期和业务日期赋值
    */
    private void addDate() {
        Date bizdate = (Date) this.getModel().getValue("tpv_bizdate");//业务日期
        this.getModel().setValue("tpv_signingdate", bizdate);//签约日期
        Date signingdate = (Date) this.getModel().getValue("tpv_signingdate");
        Date date = DateUtil.addDays(signingdate, -1);
        int year = date.getYear() + 1;
        date.setYear(year);
        this.getModel().setValue("tpv_usedate", date);//合同有效期限
    }

    /*
   业务员有多个部门，将部门设置为空
    */
    private void operator() {
//        DynamicObject value = (DynamicObject) this.getModel().getValue("tpv_operator"); //业务员
//        if (value == null) {
//            return;
//        }
//        String status = (String) this.getModel().getValue("tpv_contractnos"); //合同号
//        Object number = value.get("number");
//        DynamicObject single = BusinessDataServiceHelper.loadSingle("bos_user", "entryentity,dpt", new QFilter[]{new QFilter("number", QCP.equals, number)});
//        DynamicObjectCollection entryentity = single.getDynamicObjectCollection("entryentity");
//        if (entryentity.size() > 1 && "".equals(status)) {
//            this.getModel().setValue("tpv_department", null);
//        }
    }

    /*
      删除行
     */
    @Override
    public void afterDeleteRow(AfterDeleteRowEventArgs e) {
        super.afterDeleteRow(e);
        String name = e.getEntryProp().getName();
        switch (name) {
            case "tpv_materialentry":  //商品分录
                commission();
                volumeunp();
            case "tpv_paymentplans":  //收款计划
                proportionChanged();
//                blBituDate();
//                dayTypeBl();
                tpvBeforeandafter();
                break;
            case "tpv_approvalsetting"://协同审批
                depJion();
                break;
        }
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        operator();
        redYesdifference();
        // LinRui begin 描述，带出提交类型的名称
        DynamicObject tpvAwardtype = (DynamicObject) this.getModel().getValue("tpv_awardtype");
        if (null != tpvAwardtype) {
            this.getModel().setValue("tpv_awardtypename", tpvAwardtype.getString("name"));
        } else {
            this.getModel().setValue("tpv_awardtypename", null);
        }
        // LinRui end
    }

    /*
        移除附件
         */
    @Override
    public void afterRemove(UploadEvent evt) {
        attachmentName();
    }

    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        super.afterAddRow(e);
        String name = e.getEntryProp().getName();
        switch (name) {
            case "tpv_materialentry":
                volumeunp();
                break;
            default:
                break;
        }
    }

    /*
        操作之后调用redYesdifference方法
         */
    @Override
    public void afterDoOperation(AfterDoOperationEventArgs afterDoOperationEventArgs) {
        super.afterDoOperation(afterDoOperationEventArgs);
        String key = afterDoOperationEventArgs.getOperateKey();
        OperationResult result = afterDoOperationEventArgs.getOperationResult();
        if (result != null) {
            boolean success = result.isSuccess();
            if (success) {
                redYesdifference();
            }
        }
//        String value = (String)this.getModel().getValue("billstatus");
//        if (value.equals("C")) {
//            this.getModel().setValue("tpv_contractstatus", "D");//合同状态
//        }
//        if (StringUtils.equals("unaudit", key)) {
//            this.getModel().setValue("tpv_contractstatus", "A");//合同状态
//        }
//        if (StringUtils.equals("submit", key)) {
//            this.getModel().setValue("tpv_contractstatus", "B");//合同状态
//        }
//        if (StringUtils.equals("unsubmit", key)) {
//            this.getModel().setValue("tpv_contractstatus", "A");//合同状态
//        }
    }
}

