package com.itopview.wm.dt.formplugin.form;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

/**
 * @Description: 进口物流工作台采购装运情况分录填充
 * @Auther: zbh
 */
public class TransformPlugin extends AbstractBillPlugIn {
    private static final String ENTRY_PURCHASE = "tpv_entryentity";//采购装运情况分录

    private String pageId = "";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        String[] itemListener = {"tpv_advcontoolbarap31", "tpv_advcontoolbarap4,tpv_arrall"};
        this.addItemClickListeners("tpv_advcontoolbarap31");
    }


    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();

        switch (key) {
            case "tpv_addentry"://采购增行
                purchaseQuery();
                break;
            case "tpv_noarrball": // 取消装运齐
            case "tpv_arrball":  //装运齐
                arrall(key);
                break;
            default:
                break;
        }
    }

    private void arrall(String key) {

        List<String> list = new ArrayList<>();
//        List<DynamicObject[]> load = new ArrayList<>();

        //获取单据体控件
        EntryGrid entryGrid = this.getControl("tpv_entryentity");
        //获取选中行，数组为行号，从0开始int[]
        int selectRows[] = entryGrid.getSelectRows();
        //获取单据体数据集合
        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_entryentity");
        if (selectRows != null && selectRows.length > 0) {
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = entity.get(selectRow);  //获取选中行的单据体数据
                String number = dynamicObject.getString("tpv_purnumber");
                list.add(number);
            }
        }

        for (int i = 0; i < list.size(); i++) {
            DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", "tpv_cargostatus", new QFilter[]{new QFilter("tpv_contractnumber", QCP.equals, list.get(i))});
            if ("tpv_noarrball".equals(key)) {
                loadSingle.set("tpv_cargostatus", "A");
            }
            if ("tpv_arrball".equals(key)) {
                loadSingle.set("tpv_cargostatus", "B");
            }
            SaveServiceHelper.update(loadSingle);
        }

        if (selectRows.length>0){
            if ("tpv_noarrball".equals(key)) {
                this.getView().showSuccessNotification("取消装运齐成功!");
            }
            if ("tpv_arrball".equals(key)) {
                this.getView().showSuccessNotification("装运齐成功!");
            }
            purchaseQuery();
        }else {
            this.getView().showTipNotification("请先选择一条数据!");
        }
    }

    /**
     * 采购合同
     */
    private void purchaseQuery() {
        Object value = this.getModel().getValue("number");
        QFilter[] qFilter = new QFilter[]{new QFilter("billstatus", QCP.equals, "C"),
                new QFilter("tpv_combinationnumber.number", QCP.equals, this.getModel().getValue("number")),
                new QFilter("tpv_supplier.tpv_sfjtnbqy", QCP.equals,false)};
        DynamicObject[] queryCG = BusinessDataServiceHelper.load("tpv_dt_purchase", "tpv_supplier,tpv_contractnumber,tpv_whetheitisshipped", qFilter);
        IDataModel model = this.getModel();
        if (queryCG.length > 0) {
            int[] ints = this.getModel().batchCreateNewEntryRow(ENTRY_PURCHASE, queryCG.length);//货物流转分录
            int i = 0;
            for (DynamicObject obj : queryCG) {
                DynamicObject supplier = obj.getDynamicObject("tpv_supplier");//供应商
                String contractnumber = obj.getString("tpv_contractnumber");  //采购合同号
                boolean whetheitisshipped = obj.getBoolean("tpv_whetheitisshipped"); //是否装运成功
                model.setValue("tpv_shipment", whetheitisshipped, ints[i]);//是否装运成功
                model.setValue("tpv_purnumber", contractnumber, ints[i]);//采购合同号
                model.setValue("tpv_psupplier", supplier, ints[i]);//供应商
                ++i;
            }
        }
    }

}
