package com.itopview.wm.dt.opplugin.convert;

import java.text.SimpleDateFormat;
import java.util.Date;

import com.itopview.wm.utils.DateUtil;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
/**
 * @author GX
 * 协议下推采购合同-转换插件
 */
public class AgrPurConvert extends AbstractConvertPlugIn{
	@Override
    public void afterConvert(AfterConvertEventArgs e) {
			ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
			ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
			String name=this.getSrcMainType().getName();
			for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
				DynamicObject dataEntity = extendedDataEntity.getDataEntity();
				loadData(dataEntity);
			}
		}
		
		public void loadData(DynamicObject dataEntity) {
				Date bizdate = dataEntity.getDate("tpv_dateofcontracting");//签约日期
				if (bizdate != null) {  
	                Date date = DateUtil.addDays(bizdate, -1);
	                int year = date.getYear() + 1;
	                date.setYear(year);
	                dataEntity.set("tpv_durationofthecontr", date);//合同有效日期
	            }else {
	        	dataEntity.set("tpv_durationofthecontr", null);//合同有效日期
	            }
		}
}
