package com.itopview.wm.dt.opplugin.convert;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * @Description: 加工协议下推加工指令单 下推根据组织带出汇率表
 * @Author LinRui
 * @Date 2023/9/15 19:04
 */
public class AgreementConvert  extends AbstractConvertPlugIn {
    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        String name=this.getSrcMainType().getName();
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();

            DynamicObject org = dataEntity.getDynamicObject("org");
            if(org != null) {
                DynamicObject bd_accountingsys_base = BusinessDataServiceHelper.loadSingle("bd_accountingsys_base",
                        "id,basecurrrency,exratetable", new QFilter[] {new QFilter("baseacctorg", QCP.equals, org.getPkValue())});
                if(bd_accountingsys_base != null) {
                    DynamicObject basecurrrency = bd_accountingsys_base.getDynamicObject("basecurrrency");
                    DynamicObject exratetable = bd_accountingsys_base.getDynamicObject("exratetable");
                    dataEntity.set("tpv_currencybase", basecurrrency);
                    dataEntity.set("tpv_exratetable", exratetable);
                }
            }
        }
    }
}
