package com.itopview.wm.dt.opplugin.convert;

import com.itopview.wm.utils.DateUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.Date;

/**
 * @ClassName: FilingSalescontractConvertPlugin
 * @Description: 建档管理下推销售合同结算 签约日，年+1 天数减1
 * @author: zbh
 * @date: 2024-05-14
 */
public class FilingSalescontractConvertPlugin  extends AbstractConvertPlugIn {
    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        String name=this.getSrcMainType().getName();
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            Date date = new Date();
            Date signingdate = DateUtil.addDays(date, -1);
            int year = signingdate.getYear() + 1;
            signingdate.setYear(year);
            dataEntity.set("tpv_usedate",signingdate);
        }
    }
}
