package com.itopview.wm.dt.opplugin.convert;

import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicProperty;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterBuildQueryParemeterEventArgs;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.entity.botp.plugin.args.AfterGetSourceDataEventArgs;

import java.math.BigDecimal;
import java.util.*;


/**
 * @ClassName 标准下推改数量
 * @Description TODO
 * @Author yhj
 * @Date 2023/8/28 16:14
 * @Version 1.0
 */
public class FlowConvert extends AbstractConvertPlugIn {
    @Override
    public void afterBuildQueryParemeter(AfterBuildQueryParemeterEventArgs e) {
        e.addSrcField("tpv_baseqty");
    }
    @Override
    public void afterGetSourceData(AfterGetSourceDataEventArgs e) {
        super.afterGetSourceData(e);
        OperateOption option = this.getOption();
        boolean contains = option.containsVariable("longList");
        //e.getFldProperties();
        List<DynamicObject> sourceEntryData = e.getSourceRows();
        String name = this.getSrcMainType().getName();
        if (contains) {
            String List = this.getOption().getVariableValue("longList");
            JSONObject jsonObjects = JSONObject.parseObject(List);
            Set<String> strings = jsonObjects.keySet();
            for (String key : strings) {
                for (DynamicObject putStorage : sourceEntryData) {
                    Long pkId = (Long) e.getFldProperties().get("tpv_materialentry.id").getValue(putStorage);
                    String pkIds = String.valueOf(pkId);
                    if (pkIds.equals(key)) {
                        if (jsonObjects.getBigDecimal(String.valueOf(pkId)) != null && jsonObjects.getBigDecimal(String.valueOf(pkId)).compareTo(BigDecimal.ZERO) > 0) {
                            if (name.equals("tpv_dt_freigroambill")) {//货物流转
                                if (e.getFldProperties().get("tpv_baseqty") != null || e.getFldProperties().get("tpv_qty") != null) {
                                    BigDecimal tinnum = (BigDecimal) e.getFldProperties().get("tpv_tinnum").getValue(putStorage);
                                    BigDecimal alreroamnum = (BigDecimal) e.getFldProperties().get("tpv_alreroamnum").getValue(putStorage);
                                    e.getFldProperties().get("tpv_qty").setValue(putStorage, jsonObjects.getBigDecimal(String.valueOf(pkId))
                                            .add(tinnum).add(alreroamnum));
                                    e.getFldProperties().get("tpv_baseqty").setValue(putStorage, jsonObjects.getBigDecimal(String.valueOf(pkId))
                                            .add(tinnum).add(alreroamnum));
                                }
                            }else {
                                if (e.getFldProperties().get("tpv_baseqty") != null || e.getFldProperties().get("tpv_qty") != null) {
                                    BigDecimal flowedquantity = (BigDecimal) e.getFldProperties().get("tpv_flowedquantity").getValue(putStorage);
                                    e.getFldProperties().get("tpv_qty").setValue(putStorage, jsonObjects.getBigDecimal(String.valueOf(pkId))
                                            .add(flowedquantity));
                                    e.getFldProperties().get("tpv_baseqty").setValue(putStorage, jsonObjects.getBigDecimal(String.valueOf(pkId))
                                            .add(flowedquantity));
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        //String name = "im_purinbill";
        String nameOne = "tpv_dt_freigroambill";//货物流转
        //String tpvQty = this.getOption().getVariableValue("tpv_qty");
        boolean tpvZjVariable = this.getOption().containsVariable("tpvZj");
        boolean tpvHwVariable = this.getOption().containsVariable("tpvHw");
        //String tpvDate = this.getOption().getVariableValue("tpvDate");//货物流转到达日期
        if (tpvZjVariable && tpvHwVariable) {
            String tpvZj = this.getOption().getVariableValue("tpvZj");//直接入库按钮
            String tpvHw = this.getOption().getVariableValue("tpvHw");//货物流转按钮
            // ExtendedDataEntity[] entryentities = e.getTargetExtDataEntitySet().FindByEntityKey(name);
            //JSONObject jsonObject = JSONObject.parseObject(tpvQty);

            //目标单为采购入库
//            if (name.equals("im_purinbill")) {
//                for (ExtendedDataEntity entryentity : entryentities) {
//                    //目标单
//                    DynamicObject targetBill = entryentity.getDataEntity();
//                    //获取目标单单据体集合
//                    DynamicObjectCollection targetEntryentity = targetBill.getDynamicObjectCollection("billentry");
//                    for (DynamicObject targetEntry : targetEntryentity) {
//                        targetEntry.set("qty", jsonObject.getBigDecimal("tpv_qty"));
//                        targetEntry.set("baseqty", jsonObject.getBigDecimal("tpv_qty"));
//                    }
//                }
//            }
            //目标单为货物流转
            ExtendedDataEntity[] entryentitiess = e.getTargetExtDataEntitySet().FindByEntityKey(nameOne);
            if (nameOne.equals("tpv_dt_freigroambill")) {
                for (ExtendedDataEntity entryentity : entryentitiess) {
                    //目标单
                    DynamicObject targetBill = entryentity.getDataEntity();
                    //JSONObject jsonObjecteDate = JSONObject.parseObject(tpvDate);
                    //targetBill.set("tpv_finishdate", jsonObjecteDate.getDate("tpvDate"));
                    if (null != tpvZj) {
                        JSONObject jsonObjects = JSONObject.parseObject(tpvZj);
                        JSONObject jsonObjectes = JSONObject.parseObject(tpvHw);
                        if (jsonObjects.getBigDecimal("tpvZj").compareTo(BigDecimal.TEN) == 0) {
                            targetBill.set("tpv_directstorage", true);
                            targetBill.set("tpv_roamaction", "I");
                            targetBill.set("tpv_makeway", "B");//自动下推
                        }
                        if (jsonObjectes.getBigDecimal("tpvHw").compareTo(BigDecimal.ONE) == 0) {
                            targetBill.set("tpv_directstorage", false);
                        }

                        //获取目标单单据体集合
//                        DynamicObjectCollection targetEntryentity = targetBill.getDynamicObjectCollection("tpv_materialentry");
//                        if (jsonObject.getBigDecimal("tpv_qty").compareTo(BigDecimal.ZERO) == 1) {
//                            for (DynamicObject targetEntry : targetEntryentity) {
//                                targetEntry.set("tpv_qty", jsonObject.getBigDecimal("tpv_qty"));
//                                targetEntry.set("tpv_baseqty", jsonObject.getBigDecimal("tpv_qty"));
//                            }
//                        }
                    }
                }
            }
        }
    }
}

