package com.itopview.wm.dt.opplugin.convert;


import java.text.SimpleDateFormat;
import java.util.Date;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.scm.common.util.DynamicObjectUtil;
/**
 * @author GX
 * 采购合同下推货物流转单-转换插件
 * 将采购合同【交货期分录】字段拼接下推。
 */
public class PurFreigConvert extends AbstractConvertPlugIn {

	@Override
	public void afterConvert(AfterConvertEventArgs e) {
		ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
		ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
		String name=this.getSrcMainType().getName();
		for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
			DynamicObject dataEntity = extendedDataEntity.getDataEntity();
			loadData(name, dataEntity);
		}
	}
	
	public void loadData(String name, DynamicObject dataEntity) {
		String tpv_mindelitime="";
	    String id=dataEntity.get("tpv_purcontnum").toString();
	    String selectFieid2 = DynamicObjectUtil.getSelectfields(name, false);// 获取单据头所有字段标识
        selectFieid2 = DynamicObjectUtil.getEntrySelectfields(selectFieid2,name, "tpv_dt_purchase_jhqb",
                false);// 获取供应商分录所有字段标识
		DynamicObject[] bills = BusinessDataServiceHelper.load(name, selectFieid2, new QFilter[] {new QFilter("tpv_contractnumber",QCP.equals,id)});
		for(DynamicObject datey:bills) {
			DynamicObjectCollection entrys = datey.getDynamicObjectCollection("tpv_dt_purchase_jhqb");
			for(DynamicObject row : entrys) {
				Date agreed=row.getDate("tpv_agreeddeliverydead");
				if(agreed!=null) {
					SimpleDateFormat formater = new SimpleDateFormat("yyyy-MM-dd");
					String date=formater.format(agreed);
					if(tpv_mindelitime=="") {
						tpv_mindelitime=date;
					}else {
						tpv_mindelitime=tpv_mindelitime+";"+date;
					}
				}
			} 
			 String document=datey.getString("tpv_document.number");
			 if(!document.equals("tpv_dt_purchase_JK")) {
//				 dataEntity.set("tpv_transportstyles", null);
			 }
		}
		dataEntity.set("tpv_mindetime", tpv_mindelitime);
	}
}
