package com.itopview.wm.dt.opplugin.convert;

import com.itopview.wm.utils.DateUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.scm.common.util.DynamicObjectUtil;

import java.util.Date;

/**
 * @author GX
 * 协议下推采购合同-转换插件
 */
public class ReleTradeConvert extends AbstractConvertPlugIn {

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            loadData(dataEntity);
        }
    }

    public void loadData(DynamicObject dataEntity) {
            String newselechase= dataEntity.getString("tpv_newselechase");//新销售合同号
            String newpurchase = dataEntity.getString("tpv_newpurchases");//新采购合同号
            DynamicObjectCollection tpvDtGoodstransfeZh = dataEntity.getDynamicObjectCollection("tpv_dt_goodstransfe_zh");//转货分录
            String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_dt_salescontract", false);// 获取单据头所有字段标识
            selectFieid2=DynamicObjectUtil.getEntrySelectfields(selectFieid2,"tpv_dt_salescontract","tpv_materialentry",false);
            DynamicObject[] salescontrbills= BusinessDataServiceHelper.load("tpv_dt_salescontract", selectFieid2, new QFilter[] {
                    new QFilter("tpv_contractnos",QCP.equals,newselechase)});
            for (DynamicObject salescontrbill : salescontrbills) {
                Long saleid=salescontrbill.getLong("id");
                dataEntity.set("tpv_marketid",saleid);//销售合同id
                DynamicObjectCollection tpvMaterialentry = salescontrbill.getDynamicObjectCollection("tpv_materialentry");
                for (DynamicObject dynamicObject : tpvMaterialentry) {
                    int seq = dynamicObject.getInt("Seq");
                    long id = dynamicObject.getLong("id");
                    tpvDtGoodstransfeZh.get(seq-1).set("tpv_marketenertyid",id);
                }
            }
            String selectFieid = DynamicObjectUtil.getSelectfields("tpv_dt_purchase", false);// 获取单据头所有字段标识
            selectFieid = DynamicObjectUtil.getEntrySelectfields(selectFieid,"tpv_dt_purchase", "tpv_materialentry",false);// 获取单据头所有字段标识
            DynamicObject[] purchasebills = BusinessDataServiceHelper.load("tpv_dt_purchase", selectFieid, new QFilter[]{
                    new QFilter("tpv_contractnumber", QCP.equals, newpurchase)});
            for (DynamicObject salescontrbill : purchasebills) {
                Long saleid=salescontrbill.getLong("id");
                dataEntity.set("tpv_purchaseid",saleid);//采购合同id
                DynamicObjectCollection tpvMaterialentry = salescontrbill.getDynamicObjectCollection("tpv_materialentry");
                for (DynamicObject dynamicObject : tpvMaterialentry) {
                    int seq = dynamicObject.getInt("Seq");
                    long id = dynamicObject.getLong("id");
                    tpvDtGoodstransfeZh.get(seq-1).set("tpv_purchaseenertyid",id);
                }
            }
    }
}
