package com.itopview.wm.dt.opplugin.convert;

import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicProperty;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.entity.botp.plugin.args.AfterGetSourceDataEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * @Description: 销售合同下推销售发货 -下推插件
 * @Author LinRui
 * @Date 2023/9/20 20:56
 */
public class SaleConToShippConvert extends AbstractConvertPlugIn {

    @Override
    public void afterGetSourceData(AfterGetSourceDataEventArgs e) {
        super.afterGetSourceData(e);
        List<DynamicObject> sourceRows = e.getSourceRows();
        Map<String, DynamicProperty> fldProperties = e.getFldProperties();
        //写法1  String id = sourceData.getString(fldProperties.get("id"));
        //写法2  Object id1 = fldProperties.get("id").getValue(sourceData);

        List<Long> srcentryidlist = new ArrayList();
        Long id = null;
        for (DynamicObject putStorage : sourceRows) {
            id = (Long) fldProperties.get("id").getValue(putStorage);
            Long pkId = (Long) fldProperties.get("tpv_materialentry.id").getValue(putStorage);
            srcentryidlist.add(pkId); //分录ID
        }
        if (sourceRows.size() == 0) {
            return;
        }
        //下推是，剩余数量如果来自价格确认单且是最后一个单子，不存在其他单还有未价格确认的数量，则更改含税单价
        QFilter qFilterSrcbillid = new QFilter("tpv_sourcebillid", QCP.equals, id);
        DynamicObject[] tpvDtSalepricebills = BusinessDataServiceHelper.load("tpv_dt_salepricebill",
                "id,billno,tpv_materialentry,tpv_materialentry.tpv_taxprice_final,tpv_materialentry.tpv_qty_final," +
                        "tpv_materialentry.tpv_cargobatchqty,tpv_materialentry.tpv_srcbillid,tpv_materialentry" +
                        ".tpv_srcentryid",
                new QFilter[]{qFilterSrcbillid});
        //利用hashmap键不能重复，覆盖赋值
        Map<Long, BigDecimal> mapPriceSum = new HashMap<>(); //计算下游所有价格确认数量（价格确认数-已关联发货确认数）
        Map<Long, List<String>> mapIsPriceCount = new HashMap<>();  //有且只有一张价格确认单有剩余数量
        BigDecimal zero = BigDecimal.ZERO;
        List<String> listPriceBillno = new ArrayList<>();
        Map<String, HashMap<Long, BigDecimal>> taxpriceMapSrcbillno = new HashMap<>();
        HashMap<Long, BigDecimal> taxpriceMap = new HashMap<>();  //确认含税单价
        //遍历合同关联下游价格确认单数据
        for (DynamicObject tpvDtSalepricebill : tpvDtSalepricebills) {
            String billno = tpvDtSalepricebill.getString("billno"); //单据编号
            DynamicObjectCollection materialentryRowBill = tpvDtSalepricebill.getDynamicObjectCollection(
                    "tpv_materialentry");
            for (DynamicObject materialentryRowData : materialentryRowBill) {
                Long tpvSrcentryid = materialentryRowData.getLong("tpv_srcentryid"); //来源单据分录ID
                BigDecimal tpvTaxpriceFinal = materialentryRowData.getBigDecimal("tpv_taxprice_final");//确认含税单价
                if (srcentryidlist.contains(tpvSrcentryid)) {
                    BigDecimal tpvQtyFinal = materialentryRowData.getBigDecimal("tpv_qty_final"); //确认数量
                    BigDecimal tpvCargobatchqty = materialentryRowData.getBigDecimal("tpv_cargobatchqty"); //发货关联价格确认数量
                    BigDecimal divide = tpvQtyFinal.subtract(tpvCargobatchqty); //剩余价格确认数量
                    if (!mapPriceSum.containsKey(tpvSrcentryid)) { //判断所有价格确认单分录行来源分录ID是否一致
                        zero = BigDecimal.ZERO;
                        zero = zero.add(divide);
                        mapPriceSum.put(tpvSrcentryid, zero);  //合计剩余价格确认数量
                    } else {
                        BigDecimal decimal = mapPriceSum.get(tpvSrcentryid);
                        zero = decimal.add(divide);
                        mapPriceSum.put(tpvSrcentryid, zero);
                    }
                    if (divide.compareTo(BigDecimal.ZERO) > 0) { //剩余价格确认数量大于零
                        if (!mapIsPriceCount.containsKey(tpvSrcentryid)) {
                            listPriceBillno = new ArrayList<>();
                            listPriceBillno.add(billno);
                            mapIsPriceCount.put(tpvSrcentryid, listPriceBillno);
                        } else {
                            for (Long aLong : mapIsPriceCount.keySet()) {
                                if (aLong.equals(tpvSrcentryid)) {
                                    List<String> strings = mapIsPriceCount.get(tpvSrcentryid);
                                    strings.add(billno);
                                }
                            }

                        }
                    }
                }

                if (!taxpriceMapSrcbillno.containsKey(billno)) {
                    taxpriceMap = new HashMap<>();
                    taxpriceMap.put(tpvSrcentryid, tpvTaxpriceFinal);
                    taxpriceMapSrcbillno.put(billno, taxpriceMap);
                } else {
                    for (String s : taxpriceMapSrcbillno.keySet()) {
                        if (s.equals(billno)) {
                            taxpriceMap.put(tpvSrcentryid, tpvTaxpriceFinal);
                        }
                    }
                }
            }
        }
        Map<Long, BigDecimal> entryids = new HashMap<>();
        DynamicObject tpvDtSalescontract = BusinessDataServiceHelper.loadSingle(id, "tpv_dt_salescontract");
        for (DynamicObject tpvMaterialentry : tpvDtSalescontract.getDynamicObjectCollection("tpv_materialentry")) {
            Long entryid = tpvMaterialentry.getLong("id");
            BigDecimal tpv_conprice = tpvMaterialentry.getBigDecimal("tpv_conprice"); //已价格确认数量
            BigDecimal tpv_iscargobatchqty = tpvMaterialentry.getBigDecimal("tpv_iscargobatchqty"); //价格确认被发货关联数量
            BigDecimal tpv_shippedquantity = tpvMaterialentry.getBigDecimal("tpv_shippedquantity"); //已发货数量
            BigDecimal tpv_unshippedquantity = BigDecimalUtils.toBigDecimal(tpvMaterialentry.getBigDecimal(
                    "tpv_unshippedquantity")); //未发货数量
            if (mapPriceSum.containsKey(entryid)) {
                if (tpv_unshippedquantity.subtract(mapPriceSum.get(entryid)).compareTo(BigDecimal.ZERO) <= 0) {
                    if (mapIsPriceCount.containsKey(entryid)) {
                        if (mapIsPriceCount.get(entryid).size() == 1) {
                            String docuBillno = mapIsPriceCount.get(entryid).get(0);
                            if (taxpriceMapSrcbillno.containsKey(docuBillno)) {
                                for (Map.Entry<Long, BigDecimal> longBigDecimalEntry :
                                        taxpriceMapSrcbillno.get(docuBillno).entrySet()) {
                                    if (longBigDecimalEntry.getKey().equals(entryid)) {
                                        BigDecimal value = longBigDecimalEntry.getValue();
                                        entryids.put(entryid, value);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        for (DynamicObject putStorage : sourceRows) {
            Long pkId = (Long) e.getFldProperties().get("tpv_materialentry.id").getValue(putStorage);
            if (entryids.size() > 0) {
                for (Long aLong : entryids.keySet()) {
                    if (aLong.equals(pkId)) {
                        BigDecimal decimal = entryids.get(aLong);
                        fldProperties.get("tpv_taxprice").setValue(putStorage, decimal); //含税单价
                    }
                }
            }

        }

    }

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        String name = this.getSrcMainType().getName();
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");
            long tpvSourcebillid = dataEntity.getLong("tpv_sourcebillid");
            Date tpvBizdate = dataEntity.getDate("tpv_bizdate");
            String tpvInventorytype = dataEntity.getString("tpv_inventorytype");
            List<Long> srcentryidlist = new ArrayList();
            List<Long> srcContractnoslist = new ArrayList();
            //遍历目标单分录
            for (DynamicObject materialentryRowData : materialentry) {
                //String tpvSrcbillno = materialentryRowData.getString("tpv_srcbillno"); //来源单据编号
                //long tpvSrcbillid = materialentryRowData.getLong("tpv_srcbillid"); //来源单据ID
                long tpvSrcentryid = materialentryRowData.getLong("tpv_srcentryid"); //来源单据分录ID
                srcentryidlist.add(tpvSrcentryid); //下推销售发货单分录的来源分录ID
                Long tpvSrccontractnos = materialentryRowData.getLong("tpv_srcbillid"); //来源单据id
                srcContractnoslist.add(tpvSrccontractnos);
            }
            setDocument(tpvSourcebillid, srcentryidlist, materialentry); //给配货单据赋值
            setFeesInfoSubEntry(tpvBizdate, srcContractnoslist, materialentry, tpvInventorytype); //给费用自分录赋值，将【物流指令/合同】数据携带
        }
    }

    private static void setFeesInfoSubEntry(Date tpvBizdate, List<Long> srcContractnoslist, DynamicObjectCollection materialentry, String tpvInventorytype) {
        if (null != tpvBizdate && srcContractnoslist.size() > 0) {
            QFilter qFilterSrcbillCon = new QFilter("tpv_wms_wlzlhe_goods.tpv_sapunum.id", QCP.in, srcContractnoslist);
            qFilterSrcbillCon.and(new QFilter("tpv_wms_wlzlhe_goods.tpv_docnum", QCP.equals, "tpv_bd_salescontract"));
            qFilterSrcbillCon.and(new QFilter("tpv_costship", QCP.equals, true)); //自动估入发货费用
            qFilterSrcbillCon.and(new QFilter("tpv_billtype.number", QCP.not_equals, "")); //单据类型不为空
            qFilterSrcbillCon.and(new QFilter("tpv_validfrom", QCP.less_equals, tpvBizdate)); //有效期从
            qFilterSrcbillCon.and(new QFilter("tpv_validuntil", QCP.large_equals, tpvBizdate)); //有效期至
            qFilterSrcbillCon.and(new QFilter("billstatus", QCP.equals, "C")); //已审核
            DynamicObjectCollection tpvWmsWlzlhe = QueryServiceHelper.query("tpv_wms_wlzlhe", "id,billno, " +
                            "tpv_billtype.number tpv_billtypenumber, tpv_expenseitems, tpv_costprice, tpv_taxrate.taxrate taxrate, tpv_carrier, tpv_vendor , tpv_costcurrency, " +
                            "tpv_costdescribe, tpv_wms_wlzlhe_goods, tpv_wms_wlzlhe_goods.tpv_sapunum.id tpv_thedocument"
                    , new QFilter[]{qFilterSrcbillCon});
            Map<Long, List<DynamicObject>> map = new HashMap<>();
            for (DynamicObject dynamicObject : tpvWmsWlzlhe) {
                Long tpvThedocument = dynamicObject.getLong("tpv_thedocument"); //合同号
                if (!map.containsKey(tpvThedocument)) {
                    List<DynamicObject> objectList = new ArrayList<>();
                    objectList.add(dynamicObject);
                    map.put(tpvThedocument, objectList);
                } else {
                    List<DynamicObject> objectList = map.get(tpvThedocument);
                    objectList.add(dynamicObject);
                    map.put(tpvThedocument, objectList);
                }
            }
            QFilter qFilter = new QFilter("enable", QCP.equals, "1");
            DynamicObject[] er_expenseitemedit = BusinessDataServiceHelper.load("er_expenseitemedit", "id", qFilter.toArray());
            DynamicObject[] bd_supplier = BusinessDataServiceHelper.load("bd_supplier","id", qFilter.toArray());
            DynamicObject[] bd_currency = BusinessDataServiceHelper.load("bd_currency","id", qFilter.toArray());
            Map<Long, DynamicObject> mapExpenseitem = new HashMap<>();
            if (er_expenseitemedit.length > 0) {
                for (DynamicObject dynamicObject : er_expenseitemedit) {
                    mapExpenseitem.put(dynamicObject.getLong("id"), dynamicObject);
                }
            }
            Map<Long, DynamicObject> mapSupplier = new HashMap<>();
            if (bd_supplier.length > 0) {
                for (DynamicObject dynamicObject : bd_supplier) {
                    mapSupplier.put(dynamicObject.getLong("id"), dynamicObject);
                }
            }
            Map<Long, DynamicObject> mapCurrency = new HashMap<>();
            if (bd_currency.length > 0) {
                for (DynamicObject dynamicObject : bd_currency) {
                    mapCurrency.put(dynamicObject.getLong("id"), dynamicObject);
                }
            }

            if (map.size() > 0) {
                //再次遍历目标单分录
                for (DynamicObject materialentryRowData : materialentry) {
                    Long tpvContractnos = materialentryRowData.getLong("tpv_srcbillid"); //来源单据id
                    BigDecimal tpvQty = materialentryRowData.getBigDecimal("tpv_qty");
                    if (map.containsKey(tpvContractnos)) {
                        DynamicObjectCollection dcostinformFSubEntry = materialentryRowData.getDynamicObjectCollection("tpv_dt_dcostinform_f");
                        List<DynamicObject> objectList = map.get(tpvContractnos);
                        for (DynamicObject dynamicObject : objectList) {
                            DynamicObject addNew = dcostinformFSubEntry.addNew();
                            addNew.set("tpv_expenseitems", mapExpenseitem.containsKey(dynamicObject.getLong("tpv_expenseitems"))
                                    ? mapExpenseitem.get(dynamicObject.getLong("tpv_expenseitems")) : null); //费用项目
                            String tpvBilltypenumber = dynamicObject.getString("tpv_billtypenumber");
                            if ("tpv_wms_wlzlhe_HT".equals(tpvBilltypenumber)) {
                                addNew.set("tpv_providers", mapSupplier.containsKey(dynamicObject.getLong("tpv_vendor"))
                                        ? mapSupplier.get(dynamicObject.getLong("tpv_vendor")) : null); //物流服务商
                            } else if ("tpv_wms_wlzlhe_ZL".equals(tpvBilltypenumber)) {
                                addNew.set("tpv_providers", mapSupplier.containsKey(dynamicObject.getLong("tpv_carrier"))
                                        ? mapSupplier.get(dynamicObject.getLong("tpv_carrier")) : null); //物流服务商
                            }

                            addNew.set("tpv_costcurrencyes", mapCurrency.containsKey(dynamicObject.getLong("tpv_costcurrency"))
                                    ? mapCurrency.get(dynamicObject.getLong("tpv_costcurrency")) : null); //费用币别
                            if (YEM.isNotEmpty(tpvInventorytype)) {
                                if ("B".equals(tpvInventorytype)) {
                                    addNew.set("tpv_isbringinwarehouse", true); //是否带入入库
                                }
                            }
                            addNew.set("tpv_comtype","B");//来源类型
                            addNew.set("tpv_comewl",BusinessDataServiceHelper.loadSingle(dynamicObject.getLong("id"), "tpv_bd_wlzlhe"));//来源物流指令/合同
                            addNew.set("tpv_billablequantitys", tpvQty); //计费数量
                            addNew.set("tpv_unitprices", dynamicObject.getBigDecimal("tpv_costprice")); //单价
                            addNew.set("tpv_moneys",tpvQty.multiply(dynamicObject.getBigDecimal("tpv_costprice"))); //金额
                            addNew.set("tpv_taxrate", dynamicObject.getBigDecimal("taxrate")); //税率
                            addNew.set("tpv_desc", dynamicObject.getString("tpv_costdescribe")); //备注
                        }
                    }
                }
            }
        }
    }

    private static void setDocument(long tpvSourcebillid, List<Long> srcentryidlist, DynamicObjectCollection materialentry) {
        QFilter qFilterSrcbillid = new QFilter("tpv_sourcebillid", QCP.equals, tpvSourcebillid);
        DynamicObject[] tpvDtSalepricebills = BusinessDataServiceHelper.load("tpv_dt_salepricebill",
                "id,billno,tpv_materialentry,tpv_materialentry.tpv_taxprice_final,tpv_materialentry" +
                        ".tpv_qty_final,tpv_materialentry.tpv_cargobatchqty,tpv_materialentry.tpv_srcbillid," +
                        "tpv_materialentry.tpv_srcentryid",
                new QFilter[]{qFilterSrcbillid});
        //利用hashmap键不能重复，覆盖赋值
        Map<Long, BigDecimal> mapPriceSum = new HashMap<>(); //计算下游所有价格确认数量（价格确认数-已关联发货确认数）
        Map<Long, List<String>> mapIsPriceCount = new HashMap<>();  //有且只有一张价格确认单有剩余数量
        BigDecimal zero = BigDecimal.ZERO;
        List<String> listPriceBillno = new ArrayList<>();
        //遍历合同关联下游价格确认单数据
        for (DynamicObject tpvDtSalepricebill : tpvDtSalepricebills) {
            String billno = tpvDtSalepricebill.getString("billno"); //单据编号
            DynamicObjectCollection materialentryRowBill = tpvDtSalepricebill.getDynamicObjectCollection(
                    "tpv_materialentry");
            for (DynamicObject materialentryRowData : materialentryRowBill) {
                Long tpvSrcentryid = materialentryRowData.getLong("tpv_srcentryid"); //来源单据分录ID
                if (srcentryidlist.contains(tpvSrcentryid)) {
                    BigDecimal tpvQtyFinal = materialentryRowData.getBigDecimal("tpv_qty_final"); //确认数量
                    BigDecimal tpvCargobatchqty = materialentryRowData.getBigDecimal("tpv_cargobatchqty");
                    //发货关联价格确认数量
                    BigDecimal divide = tpvQtyFinal.subtract(tpvCargobatchqty); //剩余价格确认数量
                    if (!mapPriceSum.containsKey(tpvSrcentryid)) { //判断所有价格确认单分录行来源分录ID是否一致
                        zero = BigDecimal.ZERO;
                        zero = zero.add(divide);
                        mapPriceSum.put(tpvSrcentryid, zero);  //合计剩余价格确认数量
                    } else {
                        BigDecimal decimal = mapPriceSum.get(tpvSrcentryid);
                        zero = decimal.add(divide);
                        mapPriceSum.put(tpvSrcentryid, zero);
                    }
                    if (divide.compareTo(BigDecimal.ZERO) > 0) { //剩余价格确认数量大于零
                        if (!mapIsPriceCount.containsKey(tpvSrcentryid)) {
                            listPriceBillno = new ArrayList<>();
                            listPriceBillno.add(billno);
                            mapIsPriceCount.put(tpvSrcentryid, listPriceBillno);
                        } else {
                            for (Long aLong : mapIsPriceCount.keySet()) {
                                if (aLong.equals(tpvSrcentryid)) {
                                    List<String> strings = mapIsPriceCount.get(tpvSrcentryid);
                                    strings.add(billno);
                                }
                            }

                        }
                    }
                }
            }
        }

        //再次遍历目标单分录
        for (DynamicObject materialentryRowData : materialentry) {
            String tpvSrcbillno = materialentryRowData.getString("tpv_srcbillno"); //来源单据编号
            String tpvContractnos = materialentryRowData.getString("tpv_srccontractnos"); //来源合同号
            //long tpvSrcbillid = materialentryRowData.getLong("tpv_srcbillid"); //来源单据ID
            long tpvSrcentryid = materialentryRowData.getLong("tpv_srcentryid"); //来源单据分录ID
            BigDecimal tpvQty = materialentryRowData.getBigDecimal("tpv_qty"); //数量
            if (mapPriceSum.containsKey(tpvSrcentryid)) {
                if (tpvQty.subtract(mapPriceSum.get(tpvSrcentryid)).compareTo(tpvQty) == 0) {
                    materialentryRowData.set("tpv_document", "A"); //销售合同
                    materialentryRowData.set("tpv_selectiondocu", tpvContractnos); //销售合同号
                } else if (tpvQty.subtract(mapPriceSum.get(tpvSrcentryid)).compareTo(BigDecimal.ZERO) <= 0) {
                    if (mapIsPriceCount.containsKey(tpvSrcentryid)) {
                        if (mapIsPriceCount.get(tpvSrcentryid).size() == 1) {
                            String docuBillno = mapIsPriceCount.get(tpvSrcentryid).get(0);
                            materialentryRowData.set("tpv_document", "B"); //销售价格确认单
                            materialentryRowData.set("tpv_cargobatchqty", tpvQty); //价格确认货物批次数量
                            materialentryRowData.set("tpv_selectiondocu", docuBillno); //销售价格确认单编号
                        }
                    }
                }
            } else {
                materialentryRowData.set("tpv_document", "A"); //销售合同
                materialentryRowData.set("tpv_selectiondocu", tpvContractnos); //销售合同号
            }
        }
    }
}
