package com.itopview.wm.dt.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.Date;

/**
 * @author
 * ljw
 * @date 2023/9/13 18:41
 * @className ChaijieloancusServicePlugins
 * @description 《链捷贷客户合作审批单》审核后将对应《客户》的【是否供应链金融客户】复选框选中为“是”
 *  20231212
 */
public class ChaijieloancusAuditOp extends AbstractOperationServicePlugIn {
    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        //获取操作对象
        String key = e.getOperationKey();
        //判断具体操作
        switch (key) {
            case "audit":
                //监控按钮
                this.clickSave(e);
                break;
        }
    }

    private void clickSave(BeforeOperationArgs e) {
        DynamicObject[] entities = e.getDataEntities();
        //获取表单数据包
        for (DynamicObject entity : entities) {
            DynamicObject tpv_customer = entity.getDynamicObject("tpv_customer");//客户
            if (tpv_customer != null) {
                QFilter qFilter = new QFilter("id", QCP.equals, tpv_customer.getLong("id"));
                DynamicObject[] customer = BusinessDataServiceHelper.load("bd_customer", "id,tpv_financecustomers"
                        , new QFilter[]{qFilter}, null);
                if (customer.length > 0) {
                    for (int i = 0; i < customer.length; i++) {
                        DynamicObject custmain = customer[i];
                        custmain.set("tpv_financecustomers", true);
                    }
                    SaveServiceHelper.update(customer);
                }
            }

        }
    }
}
