package com.itopview.wm.dt.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.sdk.plugin.Plugin;
import java.math.BigDecimal;
import java.util.List;

/**
 * @author GX
 * 结算单（客户）-服务插件
 */
public class DomSettcOp extends AbstractOperationServicePlugIn implements Plugin {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("tpv_thisinvoicesnum");
        keys.add("tpv_dt_settdc_kp");
        keys.add("tpv_dt_settdc_kp.tpv_invoicesnum");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() {
                ExtendedDataEntity[] bills = this.getDataEntities();
                if ("submit".equals(this.getOperateKey()) && null != e.getDataEntities()) {
                    for (int i = 0; i < bills.length; ++i) {
                        ExtendedDataEntity bill = bills[i];
                        onsubmitDate(bill);
                    }
                }
            }

            public void onsubmitDate(ExtendedDataEntity dataEntities) {
                DynamicObject dy = dataEntities.getDataEntity();
                BigDecimal tpv_invoicesnum=BigDecimal.ZERO;//开票数量
                BigDecimal tpv_invoicesamount=BigDecimal.ZERO;//开票金额
                BigDecimal tpv_thisinvoicesnum=dy.getBigDecimal("tpv_thisinvoicesnum");//本次开票数量
                BigDecimal tpv_thisinvoicemount=dy.getBigDecimal("tpv_thisinvoicemount");//本次开票金额
                DynamicObjectCollection entry = dy.getDynamicObjectCollection("tpv_dt_settdc_kp");//开票明细
                if(entry.size()>0){
                    for(DynamicObject entr:entry){
                        tpv_invoicesnum=tpv_invoicesnum.add(entr.getBigDecimal("tpv_invoicesnum"));//开票数量
                        tpv_invoicesamount=tpv_invoicesamount.add(entr.getBigDecimal("tpv_invoicesamount"));//开票金额
                    }
                }
                if(tpv_thisinvoicesnum.compareTo(tpv_invoicesnum)!=0){
                    this.addMessage(dataEntities, "开票明细中开票数量合计不等于本次开票数量！");
                }
                if(tpv_invoicesamount.compareTo(tpv_thisinvoicemount)!=0){
                    this.addMessage(dataEntities, "开票明细中开票金额合计不等于本次开票金额！");
                }
            }
        });
    }
}
