package com.itopview.wm.dt.opplugin.op;

import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.EndOperationTransactionArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.fi.arapcommon.util.JsonUtils;

import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * 财务应付单审核指定发票
 */

public class FinAutomatPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        Collections.addAll(fieldKeys,"sourcebillno","isinvoicematch","uninvoicedamt","tax","e_uninvoicedamt","e_invoicedamt","inventry.seq","inventry.i_canuseamt","inventry.i_usedamt","inventry.i_invoicetype","inventry.i_invoicetypef7","inventry.i_invoicecode","inventry.i_invoiceno","inventry.i_invoicedate","inventry.i_pricetaxtotal","inventry.i_taxrate","inventry.i_tax","inventry.i_amount","inventry.i_asstactname","inventry.i_buyername","inventry.i_istaxdeduction","inventry.i_remark","inventry.i_srctype","inventry.i_issupplement","inventry.i_currency");
    }

    @Override
    public void endOperationTransaction(EndOperationTransactionArgs e) {
        super.endOperationTransaction(e);
        Set<Long> invPks = new HashSet(64);

        DynamicObject[] dataEntities = e.getDataEntities();
        for (DynamicObject dataEntity : dataEntities) {
            //源单类型
            String sourcebilltype = dataEntity.get("sourcebilltype").toString();
            //源单编码
            String sourcebillno = dataEntity.get("sourcebillno").toString();

            //源单类型为资产发票匹配单
            if (sourcebilltype.equals("shkd_invoicemat")) {
                QFilter q1 = new QFilter("billno", QCP.equals, sourcebillno);
                DynamicObject matnumber = BusinessDataServiceHelper.loadSingle("shkd_invoicemat", q1.toArray());
                DynamicObjectCollection invoentry = matnumber.getDynamicObjectCollection("shkd_invoentry");
                for (DynamicObject d : invoentry) {
                    String number = d.get("shkd_receiptnumber").toString();
                    QFilter q2 = new QFilter("billno", QCP.equals, number);
                    DynamicObject invnumber = BusinessDataServiceHelper.loadSingle("ap_invoice", q2.toArray());
                    Long pkValue = (Long) invnumber.getPkValue();
                    invPks.add(pkValue);
                }
            }
            //源单编类型为采购发票匹配单
            if (sourcebilltype.equals("tpv_dt_purinvomater")) {
                QFilter q1 = new QFilter("billno", QCP.equals, sourcebillno);
                DynamicObject purinvomater = BusinessDataServiceHelper.loadSingle("tpv_dt_purinvomater", q1.toArray());
                DynamicObjectCollection invoiceinfoentry = purinvomater.getDynamicObjectCollection("tpv_invoiceinfoentry");
                for (DynamicObject d : invoiceinfoentry) {
                    String number = d.get("tpv_invoicebillno").toString();
                    QFilter q2 = new QFilter("billno", QCP.equals, number);
                    DynamicObject invnumber = BusinessDataServiceHelper.loadSingle("ap_invoice", q2.toArray());
                    Long pkValue = (Long) invnumber.getPkValue();
                    invPks.add(pkValue);
                }
            }
        }

        //创建空操作
        OperateOption operate = OperateOption.create();
        operate.setVariableValue("invPks", JsonUtils.objToJson(invPks));
        OperationServiceHelper.executeOperate("assign", "ap_invoice", dataEntities, operate);

    }
}
