package com.itopview.wm.dt.opplugin.op;

import java.math.BigDecimal;
import java.util.List;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

/**
 * @author GX
 * 货物流转单-服务插件
 */
public class FreigroamOp extends AbstractOperationServicePlugIn implements Plugin {
	@Override
	public void onPreparePropertys(PreparePropertysEventArgs e) {
		super.onPreparePropertys(e);
		List<String> keys = e.getFieldKeys();
		keys.add("tpv_materialentry");
		keys.add("tpv_subentryentity");
		keys.add("tpv_materialentry.seq");
		keys.add("tpv_materialentry.tpv_qty");
		keys.add("tpv_subentryentity.tpv_quantity");
		keys.add("tpv_sourcebillid");
		keys.add("tpv_materialentry.tpv_direcroomtqty");
		keys.add("tpv_dt_freigroambill_f.tpv_billablequantitys");
		keys.add("tpv_dt_freigroambill_f.seq");
		keys.add("tpv_dt_freigroambill_f.tpv_expenseitems");
		keys.add("tpv_dt_freigroambill_f.tpv_moneys");
		keys.add("tpv_corebillid");
		keys.add("tpv_sourcebillno");
		keys.add("tpv_delivery");
		keys.add("tpv_materialentry.tpv_qty");
	}

	@Override
	public void onAddValidators(AddValidatorsEventArgs e) {
		super.onAddValidators(e);
		e.addValidator(new AbstractValidator() {
			@Override
			public void validate() {
				ExtendedDataEntity[] bills = this.getDataEntities();
				if ("submit".equals(this.getOperateKey()) ) {
					for (int i = 0; i < bills.length; ++i) {
						ExtendedDataEntity bill = bills[i];
						onsubmitDate(bill);
						 submitDate(bill);
					}
				}
				if ("unaudit".equals(this.getOperateKey()) && null != e.getDataEntities()) {
					for (int i = 0; i < bills.length; ++i) {
						ExtendedDataEntity bill = bills[i];
						onunauditDate(bill);
					}
				}
				if ("audit".equals(this.getOperateKey()) && null != e.getDataEntities()) {
					for (int i = 0; i < bills.length; ++i) {
						ExtendedDataEntity bill = bills[i];
					}
				}
			}

			public void submitDate(ExtendedDataEntity data) {
				DynamicObject dy = data.getDataEntity();
				BigDecimal contractqty = BigDecimal.ZERO;//合同数量
				BigDecimal overfillrate = BigDecimal.ZERO;//溢装率
				BigDecimal flowedquantity=BigDecimal.ZERO;//分录已流转数量
				BigDecimal one = BigDecimal.ONE;//1
				BigDecimal million = BigDecimal.valueOf(100);//100
				BigDecimal selectsum = BigDecimal.ZERO;//已流转数量
				BigDecimal sumpurqty=BigDecimal.ZERO;//合同分录未流转数量汇总
				BigDecimal sumflowstoc=BigDecimal.ZERO;//已入库加已流转数量汇总
				Long conbillid = dy.getLong("tpv_corebillid");//合同id
				Long sourcebillid = dy.getLong("tpv_sourcebillid");//来源单据id
				String sourcebillkey=dy.getString("tpv_sourcebillkey");//来源单据标识
				String billno = dy.getString("billno");//单据编号
				String sourcebillno=dy.getString("tpv_sourcebillno");//来源单据id
				String tpv_delivery = dy.getString("tpv_delivery");//交货标识
				BigDecimal sumqty = BigDecimal.ZERO;//数量汇总
				BigDecimal sumqtys = BigDecimal.ZERO;//数量汇总
				QFilter[] qFilter = new QFilter[]{new QFilter("id", QCP.equals, conbillid)};
				QFilter[] qFilters = new QFilter[]{new QFilter("id", QCP.equals, sourcebillid)};
				String selectfieldsFast = com.itopview.wm.utils.DynamicObjectUtil.getSelectfieldsFast("tpv_dt_purchase", "tpv_materialentry");
				DynamicObject[] queryHW = BusinessDataServiceHelper.load("tpv_dt_purchase", selectfieldsFast, qFilter);//采购合同
				if (queryHW != null) {
					for (DynamicObject obj : queryHW) {
						contractqty = obj.getBigDecimal("tpv_contractqty");//合同数量
						overfillrate = obj.getBigDecimal("tpv_overfillrate");//溢装率
					}
				}
				if ("A".equals(tpv_delivery)) {
					DynamicObjectCollection materialentry = dy.getDynamicObjectCollection("tpv_materialentry");//商品分录
					for (DynamicObject materia : materialentry) {
						sumqty = sumqty.add(materia.getBigDecimal("tpv_qty"));
					}
				}
				DynamicObjectCollection materialentry = dy.getDynamicObjectCollection("tpv_materialentry");//商品分录
				for (DynamicObject materia : materialentry) {
					sumqtys = sumqtys.add(materia.getBigDecimal("tpv_qty"));
				}

				String freselectfields = com.itopview.wm.utils.DynamicObjectUtil.getSelectfieldsFast("tpv_dt_freigroambill", "tpv_materialentry");
				DynamicObject[] queryfre = BusinessDataServiceHelper.load("tpv_dt_freigroambill", freselectfields,
						new QFilter[]{new QFilter("tpv_sourcebillno","=",sourcebillno).and("billstatus","=","C")});//货物流转
				for (DynamicObject fredata:queryfre){
					DynamicObjectCollection billentry=fredata.getDynamicObjectCollection("tpv_materialentry");//商品分录
					for (DynamicObject frebill:billentry){
						flowedquantity=frebill.getBigDecimal("tpv_qty");//分录已流转数量
					}
				}
				if ("tpv_dt_purinbill".equals(sourcebillkey)){//入库单
					String selectfieldsFasts = com.itopview.wm.utils.DynamicObjectUtil.getSelectfieldsFast("im_purinbill", "billentry");
					DynamicObject[] querypur = BusinessDataServiceHelper.load("im_purinbill", selectfieldsFasts, qFilters);//采购入库
					for (DynamicObject qur:querypur){
						DynamicObjectCollection billentry=qur.getDynamicObjectCollection("billentry");//商品分录
						for (DynamicObject materi:billentry){
							BigDecimal qty=materi.getBigDecimal("qty");//分录数量
							sumflowstoc=sumflowstoc.add(flowedquantity.add(qty)).setScale(4,BigDecimal.ROUND_HALF_UP);
							sumpurqty=sumpurqty.add(qty.subtract(flowedquantity));
						}
					}
					if (sumpurqty.compareTo(sumqtys)<0){
						this.addWarningMessage(data,"当前累计流转/入库已达"+sumflowstoc.add(sumqtys)+"吨，大于原货物流转单数量，是否继续？");
					}
				}if ("tpv_dt_freigroambill".equals(sourcebillkey)){//货物流转单
					String selectfieldsFasts = com.itopview.wm.utils.DynamicObjectUtil.getSelectfieldsFast("tpv_dt_freigroambill", "tpv_materialentry");
					DynamicObject[] queryfreigr = BusinessDataServiceHelper.load("tpv_dt_freigroambill", selectfieldsFasts, qFilters);//采购合同
					for (DynamicObject qur:queryfreigr){
						DynamicObjectCollection billentry=qur.getDynamicObjectCollection("tpv_materialentry");//商品分录
						for (DynamicObject materi:billentry){
							BigDecimal qty=materi.getBigDecimal("tpv_qty");//分录数量
							BigDecimal tinnum=materi.getBigDecimal("tpv_tinnum");//分录已入库数量
							sumflowstoc=sumflowstoc.add(flowedquantity.add(tinnum)).setScale(4,BigDecimal.ROUND_HALF_UP);
							sumpurqty=sumpurqty.add(qty.subtract(flowedquantity).subtract(tinnum));
						}
					}
					if (sumpurqty.compareTo(sumqtys)<0){
						this.addWarningMessage(data,"当前累计流转/入库已达"+sumflowstoc.add(sumqtys)+"吨，大于原货物流转单数量"+sumpurqty+"吨，是否继续？");
					}
				}

				QFilter[] qFilter1 = new QFilter[]{new QFilter("tpv_corebillid", QCP.equals, conbillid),
						new QFilter("tpv_delivery", QCP.equals, "A"),
						new QFilter("billno", QCP.not_equals, billno)
				};
				String selectfieldsFasts = com.itopview.wm.utils.DynamicObjectUtil.getSelectfieldsFast("tpv_dt_freigroambill", "tpv_materialentry");
				DynamicObject[] query = BusinessDataServiceHelper.load("tpv_dt_freigroambill", selectfieldsFasts, qFilter1);//采购合同
				if (query != null) {
					for (DynamicObject obj : query) {
						DynamicObjectCollection tpv_materialentry = obj.getDynamicObjectCollection("tpv_materialentry");
						for (DynamicObject mater : tpv_materialentry) {
							selectsum = selectsum.add(mater.getBigDecimal("tpv_qty"));//已流转数量
						}
					}
				}
				BigDecimal dive = overfillrate.divide(million);
				BigDecimal add = dive.add(one);
				BigDecimal sum = contractqty.multiply(add);
				if (sum.compareTo(selectsum.add(sumqty)) == -1) {
					this.addMessage(data, "当前累计已流转数量" + selectsum.add(sumqty) + ",大于合同【数量】*（1+溢装率）,超出溢装！");
				}
			}

			public void onsubmitDate(ExtendedDataEntity dataEntities) {
				DynamicObject dy = dataEntities.getDataEntity();
				BigDecimal tpv_quantity = BigDecimal.ZERO;//卷号数量合计
				BigDecimal tpv_billablequantitys = BigDecimal.ZERO;//费用子分录数量
				DynamicObjectCollection materialentry = dy.getDynamicObjectCollection("tpv_materialentry");//商品明细
				BigDecimal contractqty = BigDecimal.ZERO;//合同数量
				BigDecimal overfillrate = BigDecimal.ZERO;//溢装率
				BigDecimal one = BigDecimal.ONE;//1
				BigDecimal million = BigDecimal.valueOf(100);//100
				Long conbillid = dy.getLong("tpv_corebillid");//合同id
				QFilter[] qFilter = new QFilter[]{new QFilter("id", QCP.equals, conbillid)};
				String selectfieldsFast = com.itopview.wm.utils.DynamicObjectUtil.getSelectfieldsFast("tpv_dt_purchase", "tpv_materialentry");
				DynamicObject[] queryHW = BusinessDataServiceHelper.load("tpv_dt_purchase", selectfieldsFast, qFilter);//采购合同
				if (queryHW != null) {
					for (DynamicObject obj : queryHW) {
						overfillrate = obj.getBigDecimal("tpv_overfillrate");//溢装率
					}
				}
				for (DynamicObject mater:materialentry){
					DynamicObjectCollection freigroambill_f = mater.getDynamicObjectCollection("tpv_dt_freigroambill_f");//费用明细
					if(freigroambill_f.size()>0) {
						for(DynamicObject purchase:freigroambill_f) {
							DynamicObject tpv_expenseitems = purchase.getDynamicObject("tpv_expenseitems");//费用项目
							BigDecimal tpv_moneys = purchase.getBigDecimal("tpv_moneys");//金额
							int row = purchase.getInt("Seq");
							if (tpv_expenseitems != null && tpv_moneys.compareTo(BigDecimal.ZERO) == 0) {
								this.addMessage(dataEntities, "费用信息分录第" + row + "行金额不能为空!");
							}
						}
					}

				}
				if (materialentry.size() > 0) {
					for (DynamicObject matertrty : materialentry) {
						DynamicObjectCollection subentryentity = matertrty.getDynamicObjectCollection("tpv_subentryentity");//卷号管理
						DynamicObjectCollection tpv_dt_freigroambill_f = matertrty.getDynamicObjectCollection("tpv_dt_freigroambill_f");//费用信息
						int row = matertrty.getInt("Seq");
						BigDecimal tpv_qty = matertrty.getBigDecimal("tpv_qty");//商品分录数量
//								if(subentryentity.size()>0) {
//									tpv_quantity=BigDecimal.ZERO;
//									for(DynamicObject subentrty:subentryentity) {
//								    	tpv_quantity=tpv_quantity.add(subentrty.getBigDecimal("tpv_quantity"));
//								    }
//								    if(tpv_quantity.compareTo(tpv_qty)<0) {
//								    	this.addMessage(dataEntities,"商品明细第"+row+"行（{卷号管理}子分录【数量】之和应等于{商品信息}分录行【数量】）!");
//						            }
//								    if(tpv_quantity.compareTo(tpv_qty)>0) {
//								    	this.addMessage(dataEntities,"商品明细第"+row+"行（{卷号管理}子分录【数量】之和应等于{商品信息}分录行【数量】）!");
//								    }
//								}
						if (tpv_dt_freigroambill_f.size() > 0) {
							for (DynamicObject freigroambill : tpv_dt_freigroambill_f) {
								tpv_billablequantitys = freigroambill.getBigDecimal("tpv_billablequantitys");
							}
							BigDecimal dive = overfillrate.divide(million);
							BigDecimal add = dive.add(one);
							BigDecimal sum = tpv_qty.multiply(add);
							if (tpv_billablequantitys.compareTo(sum) > 0) {
								this.addMessage(dataEntities, "商品明细第" + row + "行（{费用信息}子分录【计费数量】之和不能大于{商品分录}【数量】*（1+溢装率）!");
							}
						}
					}
				}
			}

			public void onunauditDate(ExtendedDataEntity dataEntities) {
				DynamicObject dy = dataEntities.getDataEntity();
				DynamicObjectCollection entry = dy.getDynamicObjectCollection("tpv_materialentry");//商品分录
				if (entry.size() > 0) {
					for (DynamicObject mater : entry) {
						BigDecimal pickedquantity = mater.getBigDecimal("tpv_direcroomtqty");//已拣配数量
						if (pickedquantity.compareTo(BigDecimal.ZERO) != 0) {
							int row = mater.getInt("Seq");
							this.addMessage(dataEntities, "商品分录第" + row + "行“已拣配数量”大于0，不可以反审核！");
						}
					}
				}
			}
		});
	}
}
