package com.itopview.wm.dt.opplugin.op;

import com.itopview.wm.cm.customplugin.YemFactory;
import com.itopview.wm.cm.customplugin.YemInterface;
import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DateUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.serialization.SerializationUtils;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.filter.FilterBuilder;
import kd.bos.entity.filter.FilterCondition;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.exception.KDBizException;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.MetadataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.util.StringUtils;

import java.math.BigDecimal;
import java.util.*;

/**
 * @ClassName: InterestBearingRenCalOp
 * @Description: 计息单更新数据和计算
 * @author: zbh
 * @date: 2024-05-22
 */
public class InterestBearingRenCalOp extends AbstractOperationServicePlugIn {

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        DynamicObject[] entities = e.getDataEntities();
        for (DynamicObject entity : entities) {
            renewdata(BusinessDataServiceHelper.loadSingle(entity.getPkValue(), "tpv_interestbearing"));
        }
    }

    public static void renewdata(DynamicObject entity) {
        init_tpv_ib_receivableentry(entity);//初始化 应收项目
        init_tpv_ib_receivedentry(entity);//初始化 已收项目
        calculate(entity);//计算
    }

    /**
     * 初始化 应收项目
     */
    public static void init_tpv_ib_receivableentry(DynamicObject entity) {
        DynamicObject bill = entity;
        DynamicObject contract = bill.getDynamicObject("tpv_dt_purcontracts");//采购合同号
        DynamicObject tpv_strateg = bill.getDynamicObject("tpv_strateg");//计息策略
        if (null != contract && null != tpv_strateg) {
            contract = BusinessDataServiceHelper.loadSingle(contract.getPkValue(), "tpv_dt_purchase");
            long contract_id = contract.getLong("id");
            long tpv_srcentryid = bill.getLong("tpv_srcentryid");//来源单据分录ID
            int tpv_numberofdaysx = 0;//天数x
            DynamicObjectCollection tpv_accrueinte_s = contract.getDynamicObjectCollection("tpv_accrueinte_jx");//计息
            for (int i = 0; i < tpv_accrueinte_s.size(); i++) {//查找计息对应合同的天数X
                DynamicObject tpv_accrueinte = tpv_accrueinte_s.get(i);
                long tpv_accrueinte_id = tpv_accrueinte.getLong("id");
                if (tpv_srcentryid == tpv_accrueinte_id) {
                    tpv_numberofdaysx = tpv_accrueinte.getInt("tpv_numberofdaysx");
                }
            }

            //已更新应收项目
            Map tpv_ablebillid_map = new HashMap();
            DynamicObjectCollection tpv_ib_receivableentry_s = bill.getDynamicObjectCollection("tpv_ib_receivableentry");//应收项目
            for (int i = 0; i < tpv_ib_receivableentry_s.size(); i++) {
                DynamicObject tpv_ib_receivableentry = tpv_ib_receivableentry_s.get(i);
                long tpv_ablebillid = tpv_ib_receivableentry.getLong("tpv_ablebillid");
                String tpv_ablebill = tpv_ib_receivableentry.getString("tpv_ablebill");
                //根据单据标识将应收单据分类
                if (tpv_ablebillid_map.containsKey(tpv_ablebill)) {
                    List list = (List) tpv_ablebillid_map.get(tpv_ablebill);
                    list.add(tpv_ablebillid);
                    tpv_ablebillid_map.put(tpv_ablebill, list);
                } else {
                    List list = new ArrayList();
                    list.add(tpv_ablebillid);
                    tpv_ablebillid_map.put(tpv_ablebill, list);
                }
            }

            tpv_strateg = BusinessDataServiceHelper.loadSingle(tpv_strateg.getPkValue(), tpv_strateg.getDynamicObjectType().getName());//获取计息策略
            DynamicObjectCollection tpv_ibs_receivableentry_s = tpv_strateg.getDynamicObjectCollection("tpv_ibs_receivableentry");//计息策略上的应收项目
            //计息策略应收项目-分录
            for (int i = 0; i < tpv_ibs_receivableentry_s.size(); i++) {
                DynamicObject tpv_ibs_receivableentry = tpv_ibs_receivableentry_s.get(i);
                DynamicObject tpv_ablebill = tpv_ibs_receivableentry.getDynamicObject("tpv_ablebill");//单据
                String billType = tpv_ablebill.getString("number");
                String billName = tpv_ablebill.getString("name");
                String tpv_ablesrcfield = tpv_ibs_receivableentry.getString("tpv_ablesrcfield");//合同关联字段标识
                String tpv_abledatefield = tpv_ibs_receivableentry.getString("tpv_abledatefield");//日期字段标识
                String tpv_abledatatype = tpv_ibs_receivableentry.getString("tpv_abledatatype");//取值类型
                String tpv_ablecurrencyfield = tpv_ibs_receivableentry.getString("tpv_ablecurrencyfield");//币别字段标识
                String tpv_ableamtfield = tpv_ibs_receivableentry.getString("tpv_ableamtfield");//金额字段标识
                String tpv_ableplugin = tpv_ibs_receivableentry.getString("tpv_ableplugin");//取值插件
                String tpv_ablefiltersjson = tpv_ibs_receivableentry.getString("tpv_ablefiltersjson");//过滤条件
                QFilter qFilter = new QFilter("id", QCP.equals, contract_id);
                //TODO
                if (null != tpv_ablesrcfield && !"".equals(tpv_ablesrcfield)) {
                    qFilter = new QFilter(tpv_ablesrcfield, QCP.equals, contract_id);
                }
                List<QFilter> filter_s = conditionJsonToFilter(tpv_ablefiltersjson, billType);
                if (null != filter_s && filter_s.size() > 0) {
                    for (int j = 0; j < filter_s.size(); j++) {
                        qFilter.and(filter_s.get(j));
                    }
                }
                //不在应收分录中的单据
                if (tpv_ablebillid_map.containsKey(billName)) {
                    List list = (List) tpv_ablebillid_map.get(billName);
                    qFilter.and(new QFilter("id", QCP.not_in, list));
                }
                DynamicObject[] obj_s = BusinessDataServiceHelper.load(billType, "id,tpv_name", new QFilter[]{qFilter});
                if (null != obj_s && obj_s.length > 0) {
                    for (int j = 0; j < obj_s.length; j++) {
                        DynamicObject obj = obj_s[j];
                        obj = BusinessDataServiceHelper.loadSingle(obj.getPkValue(), obj.getDynamicObjectType().getName());
                        DynamicObjectCollection tpvIbReceivableentry = bill.getDynamicObjectCollection("tpv_ib_receivableentry");
                        DynamicObject addNew = tpvIbReceivableentry.addNew();
                        //单据内码
                        addNew.set("tpv_ablebillid", obj.getLong("id"));
                        //单据编号
                        if (obj.containsProperty("billno")) {
                            addNew.set("tpv_ablebillno", obj.getString("billno"));
                        } else if (obj.containsProperty("tpv_billno")) {
                            addNew.set("tpv_ablebillno", obj.getString("tpv_billno"));
                        } else {
                            addNew.set("tpv_ablebillno", obj.getString("tpv_name"));
                        }
                        //单据
                        addNew.set("tpv_ablebill", billName);
                        //单据类型
                        if (obj.containsProperty("billtype")) {
                            DynamicObject billtype = obj.getDynamicObject("billtype");
                            if (null != billtype) {
                                addNew.set("tpv_ablebilltype", billtype.getString("name"));
                            }
                        } else if (obj.containsProperty("tpv_document")) {
                            DynamicObject tpv_document = obj.getDynamicObject("tpv_document");
                            if (null != tpv_document) {
                                addNew.set("tpv_ablebilltype", tpv_document.getString("name"));
                            }
                        }
                        //币别
                        if (obj.containsProperty(tpv_ablecurrencyfield)) {
                            try {
                                addNew.set("tpv_ablebillcurrency", obj.getDynamicObject(tpv_ablecurrencyfield));
                            } catch (KDBizException e) {
                                throw new KDBizException("计息策略-应收项目-币别字段配置错误，请检查！");
                            }
                        }
                        //日期
                        if (obj.containsProperty(tpv_abledatefield)) {
                            try {
                                Date tpv_ablebilldate = obj.getDate(tpv_abledatefield);
                                Calendar calendar = Calendar.getInstance();
                                calendar.setTime(tpv_ablebilldate);
                                calendar.add(Calendar.DAY_OF_MONTH, tpv_numberofdaysx);
                                tpv_ablebilldate = calendar.getTime();
                                addNew.set("tpv_ablebilldate", tpv_ablebilldate);
                            } catch (KDBizException e) {
                                throw new KDBizException("计息策略-应收项目-日期字段配置错误，请检查！");
                            }
                        }
                        if ("A".equals(tpv_abledatatype)) {
                            //金额
                            if (obj.containsProperty(tpv_ableamtfield)) {
                                try {
                                    addNew.set("tpv_ablebillamt", obj.getBigDecimal(tpv_ableamtfield));
                                    addNew.set("tpv_ablebilluseamt", obj.getBigDecimal(tpv_ableamtfield));
                                } catch (KDBizException e) {
                                    throw new KDBizException("计息策略-应收项目-金额字段配置错误，请检查！");
                                }
                            }
                        } else if ("B".equals(tpv_abledatatype)) {
                            int index = tpv_ableplugin.lastIndexOf(".");
                            String path = tpv_ableplugin.substring(0, index);
                            String key = tpv_ableplugin.substring(index + 1, tpv_ableplugin.length());
                            YemInterface yemInterface = new YemFactory(path).getImplementation(key);
                            if (null != yemInterface) {
                                Map map = new HashMap();
                                map.put("contract_id", contract_id);
                                map.put("tpv_strateg_id", tpv_strateg.getLong("id"));
                                BigDecimal amt = yemInterface.getBigDecimal(map);
                                addNew.set("tpv_ablebillamt", amt);
                                addNew.set("tpv_ablebilluseamt", amt);
                            } else {
                                throw new KDBizException("计息策略-应收项目-取值插件字段配置错误，请检查！");
                            }
                        }
                    }
                }
            }
        }
    }

    /**
     * 初始化 已收项目
     */
    public static void init_tpv_ib_receivedentry(DynamicObject entity) {
        DynamicObject bill = entity;
        DynamicObject contract = bill.getDynamicObject("tpv_dt_salescontracts");
        DynamicObject tpv_strateg = bill.getDynamicObject("tpv_strateg");//计息策略
        if (null != contract && null != tpv_strateg) {
            //已更新应收项目
            Map tpv_edbillid_map = new HashMap();
            DynamicObjectCollection tpv_ib_receivedentry_s = bill.getDynamicObjectCollection("tpv_ib_receivedentry");//已收项目
            for (int i = 0; i < tpv_ib_receivedentry_s.size(); i++) {
                DynamicObject tpv_ib_receivedentry = tpv_ib_receivedentry_s.get(i);
                long tpv_edbillid = tpv_ib_receivedentry.getLong("tpv_edbillid");
                String tpv_edbill = tpv_ib_receivedentry.getString("tpv_edbill");
                if (tpv_edbillid_map.containsKey(tpv_edbill)) {
                    List list = (List) tpv_edbillid_map.get(tpv_edbill);
                    list.add(tpv_edbillid);
                    tpv_edbillid_map.put(tpv_edbill, list);
                } else {
                    List list = new ArrayList();
                    list.add(tpv_edbillid);
                    tpv_edbillid_map.put(tpv_edbill, list);
                }
            }

            contract = BusinessDataServiceHelper.loadSingle(contract.getPkValue(), contract.getDynamicObjectType().getName());
            long contract_id = contract.getLong("id");

            tpv_strateg = BusinessDataServiceHelper.loadSingle(tpv_strateg.getPkValue(), tpv_strateg.getDynamicObjectType().getName());
            DynamicObjectCollection tpv_ibs_receivedentry_s = tpv_strateg.getDynamicObjectCollection("tpv_ibs_receivedentry");
            for (int i = 0; i < tpv_ibs_receivedentry_s.size(); i++) {
                DynamicObject tpv_ibs_receivedentry = tpv_ibs_receivedentry_s.get(i);
                DynamicObject tpv_edbill = tpv_ibs_receivedentry.getDynamicObject("tpv_edbill");//单据
                String billType = tpv_edbill.getString("number");
                String billName = tpv_edbill.getString("name");
                String tpv_edsrcfield = tpv_ibs_receivedentry.getString("tpv_edsrcfield");//合同关联字段标识
                String tpv_eddatefield = tpv_ibs_receivedentry.getString("tpv_eddatefield");//日期字段标识
                String tpv_eddatatype = tpv_ibs_receivedentry.getString("tpv_eddatatype");//取值类型
                String tpv_edcurrencyfield = tpv_ibs_receivedentry.getString("tpv_edcurrencyfield");//币别字段标识
                String tpv_edamtfield = tpv_ibs_receivedentry.getString("tpv_edamtfield");//金额字段标识
                String tpv_edplugin = tpv_ibs_receivedentry.getString("tpv_edplugin");//取值插件
                String tpv_edfiltersjson = tpv_ibs_receivedentry.getString("tpv_edfiltersjson");//过滤条件
                QFilter qFilter = new QFilter("id", QCP.equals, contract_id);
                if (null != tpv_edsrcfield && !"".equals(tpv_edsrcfield)) {
                    qFilter = new QFilter(tpv_edsrcfield, QCP.equals, contract_id);
                }
                List<QFilter> filter_s = conditionJsonToFilter(tpv_edfiltersjson, billType);
                if (null != filter_s && filter_s.size() > 0) {
                    for (int j = 0; j < filter_s.size(); j++) {
                        qFilter.and(filter_s.get(j));
                    }
                }
                if (tpv_edbillid_map.containsKey(billName)) {
                    List list = (List) tpv_edbillid_map.get(billName);
                    qFilter.and(new QFilter("id", QCP.not_in, list));
                }
                DynamicObject[] obj_s = BusinessDataServiceHelper.load(billType, "id,tpv_documenttypes,tpv_name", new QFilter[]{qFilter});
                if (null != obj_s && obj_s.length > 0) {
                    for (int j = 0; j < obj_s.length; j++) {
                        DynamicObject obj = obj_s[j];
                        obj = BusinessDataServiceHelper.loadSingle(obj.getPkValue(), obj.getDynamicObjectType().getName());
                        DynamicObjectCollection tpvIbReceivedentry = bill.getDynamicObjectCollection("tpv_ib_receivedentry");
                        DynamicObject addNew = tpvIbReceivedentry.addNew();
//                        int rowIndex = model.createNewEntryRow("tpv_ib_receivedentry");
                        //单据内码
                        addNew.set("tpv_edbillid", obj.getLong("id"));
                        //单据编号
                        if (obj.containsProperty("billno")) {
                            addNew.set("tpv_edbillno", obj.getString("billno"));
                        } else if (obj.containsProperty("tpv_billno")) {
                            addNew.set("tpv_edbillno", obj.getString("tpv_billno"));
                        }else {
                            addNew.set("tpv_edbillno", obj.getString("tpv_name"));//合同号
                        }
                        //单据
                        addNew.set("tpv_edbill", billName);
                        //单据类型
                        if (obj.containsProperty("billtype")) {
                            DynamicObject billtype = obj.getDynamicObject("billtype");
                            if (null != billtype) {
                                addNew.set("tpv_edbilltype", billtype.getString("name"));
                            }
                        } else if (obj.containsProperty("tpv_documenttypes")) {
                            DynamicObject tpv_document = obj.getDynamicObject("tpv_documenttypes");
                            if (null != tpv_document) {
                                addNew.set("tpv_edbilltype", tpv_document.getString("name"));
                            }
                        }
                        //币别
                        if (obj.containsProperty(tpv_edcurrencyfield)) {
                            try {
                                addNew.set("tpv_edbillcurrency", obj.getDynamicObject(tpv_edcurrencyfield));
                            } catch (KDBizException e) {
//                                this.getView().showMessage("计息策略-已收项目-币别字段配置错误，请检查！");
                                throw new KDBizException("计息策略-应收项目-币别字段配置错误，请检查！");
                            }
                        }
                        //日期
                        if (obj.containsProperty(tpv_eddatefield)) {
                            try {
                                addNew.set("tpv_edbilldate", obj.getDate(tpv_eddatefield));
                            } catch (KDBizException e) {
//                                this.getView().showMessage("计息策略-已收项目-日期字段配置错误，请检查！");
                                throw new KDBizException("计息策略-已收项目-日期字段配置错误，请检查！");
                            }
                        }
                        if ("A".equals(tpv_eddatatype)) {
                            //金额
                            if (obj.containsProperty(tpv_edamtfield)) {
                                try {
                                    addNew.set("tpv_edbillamt", obj.getBigDecimal(tpv_edamtfield));
                                    addNew.set("tpv_edbilluseamt", obj.getBigDecimal(tpv_edamtfield));
                                } catch (KDBizException e) {
//                                    this.getView().showMessage("计息策略-已收项目-金额字段配置错误，请检查！");
                                    throw new KDBizException("计息策略-已收项目-金额字段配置错误，请检查！");
                                }
                            }
                        } else if ("B".equals(tpv_eddatatype)) {
                            int index = tpv_edplugin.lastIndexOf(".");
                            String path = tpv_edplugin.substring(0, index);
                            String key = tpv_edplugin.substring(index + 1, tpv_edplugin.length());
                            YemInterface yemInterface = new YemFactory(path).getImplementation(key);
                            if (null != yemInterface) {
                                Map map = new HashMap();
                                map.put("contract_id", contract_id);
                                map.put("tpv_strateg_id", tpv_strateg.getLong("id"));
                                BigDecimal amt = yemInterface.getBigDecimal(map);
                                addNew.set("tpv_edbillamt", amt);
                                addNew.set("tpv_edbilluseamt", amt);
                            } else {
//                                this.getView().showMessage("计息策略-已收项目-取值插件字段配置错误，请检查！");
                                throw new KDBizException("计息策略-已收项目-取值插件字段配置错误，请检查！");
                            }
                        }
                    }
                }
            }
        }

    }

    /**
     * 计算
     */
    public static void calculate(DynamicObject entity) {
        DynamicObject bill = entity;

        DynamicObject tpv_dt_purchase = bill.getDynamicObject("tpv_dt_purcontracts");
        if (tpv_dt_purchase==null){
            return;
        }
        tpv_dt_purchase = BusinessDataServiceHelper.loadSingle(tpv_dt_purchase.getPkValue(), "tpv_dt_purchase");
        long tpv_srcentryid = bill.getLong("tpv_srcentryid");
        int tpv_accrueinterest = 0;//最小计息天数
        DynamicObjectCollection tpv_accrueinte_s = tpv_dt_purchase.getDynamicObjectCollection("tpv_accrueinte_jx");
        for (int i = 0; i < tpv_accrueinte_s.size(); i++) {
            DynamicObject tpv_accrueinte = tpv_accrueinte_s.get(i);
            long tpv_accrueinte_id = tpv_accrueinte.getLong("id");
            if (tpv_srcentryid == tpv_accrueinte_id) {
                tpv_accrueinterest = tpv_accrueinte.getInt("tpv_accrueinterest");
            }
        }

        //收集已收项目分录的数据
        List list = new ArrayList();
//        int rowCount = model.getEntryRowCount("tpv_ib_receivedentry");//已收项目
        DynamicObjectCollection tpvIbReceivedentry = entity.getDynamicObjectCollection("tpv_ib_receivedentry");

        for (int i = 0; i < tpvIbReceivedentry.size(); i++) {
            long tpv_edbillid = (long) tpvIbReceivedentry.get(i).get("tpv_edbillid");
            String tpv_edbillno = (String)tpvIbReceivedentry.get(i).get("tpv_edbillno");
            String tpv_edbill = (String)tpvIbReceivedentry.get(i).get("tpv_edbill");
            String tpv_edbilltype = (String)tpvIbReceivedentry.get(i).get("tpv_edbilltype");
            DynamicObject tpv_edbillcurrency = (DynamicObject)tpvIbReceivedentry.get(i).get("tpv_edbillcurrency");
            Date tpv_edbillusedate = (Date)tpvIbReceivedentry.get(i).get("tpv_edbillusedate");
            BigDecimal tpv_edbilluseamt = (BigDecimal)tpvIbReceivedentry.get(i).get("tpv_edbilluseamt");
            Map map = new HashMap();
            map.put("tpv_edbillid", tpv_edbillid);
            map.put("tpv_edbillno", tpv_edbillno);
            map.put("tpv_edbill", tpv_edbill);
            map.put("tpv_edbilltype", tpv_edbilltype);
            map.put("tpv_edbillcurrency", tpv_edbillcurrency);
            map.put("tpv_edbillusedate", tpv_edbillusedate);
            map.put("tpv_edbilluseamt", tpv_edbilluseamt);
            list.add(map);
        }

        DynamicObjectCollection tpv_ib_receivableentry_s = bill.getDynamicObjectCollection("tpv_ib_receivableentry");//应收项目
        for (int i = 0; i < tpv_ib_receivableentry_s.size(); i++) {
            DynamicObject tpv_ib_receivableentry = tpv_ib_receivableentry_s.get(i);
            BigDecimal tpv_ablebilluseamt = tpv_ib_receivableentry.getBigDecimal("tpv_ablebilluseamt");//应收应用金额
            Date tpv_ablebillusedate = tpv_ib_receivableentry.getDate("tpv_ablebillusedate");
            DynamicObjectCollection tpv_ib_detailentry_s = tpv_ib_receivableentry.getDynamicObjectCollection("tpv_ib_detailentry");
            tpv_ib_detailentry_s.clear();//清空计息明细
            for (int j = 0; j < list.size(); j++) {
                Map map = (Map) list.get(j);
                BigDecimal tpv_edbilluseamt = BigDecimalUtils.toBigDecimal(map.get("tpv_edbilluseamt"));//已收应用金额
                if (tpv_edbilluseamt.compareTo(BigDecimal.ZERO) != 0 && tpv_ablebilluseamt.compareTo(BigDecimal.ZERO) != 0) {//已收和应收应用金额都 != 0
                    Date tpv_edbillusedate = (Date) map.get("tpv_edbillusedate");
                    BigDecimal tpv_writeoffamt = BigDecimal.ZERO;
                    if (tpv_edbilluseamt.compareTo(tpv_ablebilluseamt) <= 0) {//已收 <= 应收 已收
                        tpv_writeoffamt = tpv_edbilluseamt;
                        map.put("tpv_edbilluseamt", BigDecimal.ZERO);
                    } else if (tpv_edbilluseamt.compareTo(tpv_ablebilluseamt) > 0) {//已收 > 应收    应收
                        tpv_writeoffamt = tpv_ablebilluseamt;
                        map.put("tpv_edbilluseamt", BigDecimalUtils.sub(tpv_edbilluseamt, tpv_ablebilluseamt, 10));//计算应用金额
                    }
                    //计算利息
                    if (null != tpv_ablebillusedate && null != tpv_edbillusedate) {
                        list.set(j, map);
                        tpv_ablebilluseamt = BigDecimalUtils.sub(tpv_ablebilluseamt, tpv_writeoffamt, 10);

                        int difDays = DateUtil.countDays(tpv_ablebillusedate, tpv_edbillusedate);//计算相差天数
                        if (difDays < 0) {
                            continue;
                        }
                        //如果计息天数 小于 最小计息天数 则使用 最小计息天数
                        if (difDays < tpv_accrueinterest) {
                            difDays = tpv_accrueinterest;
                        }
                        //阶梯利率
                        DynamicObjectCollection tpv_ib_tieredinterestrate_s = bill.getDynamicObjectCollection("tpv_ib_tieredinterestrate");
                        for (int m = 0; m < tpv_ib_tieredinterestrate_s.size(); m++) {
                            DynamicObject tpv_ib_tieredinterestrate = tpv_ib_tieredinterestrate_s.get(m);
                            int tpv_daystostart = tpv_ib_tieredinterestrate.getInt("tpv_daystostart");//起始天数
                            int tpv_asofdays = tpv_ib_tieredinterestrate.getInt("tpv_asofdays");//截止天数
                            BigDecimal tpv_agencyrate = tpv_ib_tieredinterestrate.getBigDecimal("tpv_agencyrate");//代理费率%（月化含税）
                            boolean tpv_penaltyinterestsig = tpv_ib_tieredinterestrate.getBoolean("tpv_penaltyinterestsig");
                            if (0 == tpv_asofdays) {
                                tpv_asofdays = 2147483647;
                            }
                            boolean isinterest = false;
                            int tpv_days = 0;
                            if (tpv_asofdays < difDays) {
                                tpv_days = tpv_asofdays - tpv_daystostart + 1;
                                isinterest = true;
                            } else if (tpv_daystostart <= difDays && difDays <= tpv_asofdays) {
                                tpv_days = difDays - tpv_daystostart + 1;
                                isinterest = true;
                            }
                            if (isinterest) {
                                DynamicObject tpv_ib_detailentry = tpv_ib_detailentry_s.addNew();
                                tpv_ib_detailentry.set("tpv_detailbillid", map.get("tpv_edbillid"));
                                tpv_ib_detailentry.set("tpv_detailbillno", map.get("tpv_edbillno"));
                                tpv_ib_detailentry.set("tpv_detailbill", map.get("tpv_edbill"));
                                tpv_ib_detailentry.set("tpv_detailbilltype", map.get("tpv_edbilltype"));
                                tpv_ib_detailentry.set("tpv_detailbillcurrency", map.get("tpv_edbillcurrency"));
                                tpv_ib_detailentry.set("tpv_detailbilldate", tpv_edbillusedate);
                                tpv_ib_detailentry.set("tpv_writeoffamt", tpv_writeoffamt);
                                BigDecimal tpv_interest = BigDecimal.ZERO;
                                tpv_interest = BigDecimalUtils.multiply(tpv_writeoffamt, new BigDecimal(tpv_days), 10);
                                tpv_interest = BigDecimalUtils.multiply(tpv_interest, BigDecimalUtils.div(tpv_agencyrate, BigDecimalUtils.one_handred, 10), 10);
                                tpv_interest = BigDecimalUtils.div(tpv_interest, new BigDecimal("30"), 4);
                                tpv_ib_detailentry.set("tpv_days", tpv_days);
                                tpv_ib_detailentry.set("tpv_interestrate", tpv_agencyrate);
                                tpv_ib_detailentry.set("tpv_interest", tpv_interest);
                                tpv_ib_detailentry.set("tpv_beoverdue", tpv_penaltyinterestsig);
                            }
                        }
                    }
                }
            }
        }
        SaveServiceHelper.save(new DynamicObject[]{entity});
    }

    /**
     * 文本字段转通用过滤
     *
     * @param conditionJson
     */
    public static List<QFilter> conditionJsonToFilter(String conditionJson, String billType) {
        List<QFilter> qFilters = null;
        FilterCondition condition = StringUtils.isEmpty(conditionJson) ? null : SerializationUtils.fromJsonString(conditionJson, FilterCondition.class);
        if (condition != null) {
            MainEntityType entityType = MetadataServiceHelper.getDataEntityType(billType);
            FilterBuilder filterBuilder = new FilterBuilder(entityType, condition);
            filterBuilder.buildFilter();
            qFilters = filterBuilder.getQFilters();
        }
        return qFilters;
    }
}
