package com.itopview.wm.dt.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.List;

/**
 * @author ljw
 * @version 1.0
 * @description: 物料
 * 物料分录增行赋值
 * @date 2023/8/10 11:32
 * ljwxj
 */
public class MaterialServicePlugIn extends AbstractOperationServicePlugIn {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_bd_material_ext_c");
        fieldKeys.add("tpv_aliasname");
        fieldKeys.add("tpv_enable");
        fieldKeys.add("tpv_status");
    }
    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        // TODO Auto-generated method stub
        super.beginOperationTransaction(e);
        DynamicObject[] dataEntities = e.getDataEntities();
        //对单据体进行循环
        for (DynamicObject dynamicObject : dataEntities) {
            String status = dynamicObject.getString("name");
            // 对每一条单据
            Boolean lool = true;
            //循环数据
            for (DynamicObject dataEntity : dataEntities) {
                //获取到单据体的数据
                DynamicObjectCollection entryEntity = dataEntity.getDynamicObjectCollection("tpv_bd_material_ext_c");
                //查询单据体中是否有和名称相同的字段
                QFilter qFilter = new QFilter("tpv_bd_material_ext_c.tpv_aliasname", QCP.equals, status);//查询相同的
                //查询其他单中是否有相同的数据
                DynamicObject[] sim_vatinvoice = BusinessDataServiceHelper.load("bd_material", "id,billno,tpv_bd_material_ext_c.tpv_aliasname"
                        , new QFilter[]{qFilter}, null);
                //单据体中的数据大于0
                if (entryEntity.size() > 0) {
                    //循环得到值
                    for (int i = 0; i < entryEntity.size(); i++) {
                        //判断是否有数据
                        if (null != sim_vatinvoice && sim_vatinvoice.length > 0) {
                            lool = false;
                            return;
                        }
                        DynamicObject rowentry = entryEntity.get(i);
                        //获取到别名名称
                        String aliasname = rowentry.getString("tpv_aliasname");
                        //判断值是否相等
                        if (aliasname.equals(status)) {
                            lool = false;
                        } else {
                            lool = true;
                        }
                    }
                } else {
                    //判断相同的数据有没有大于0则进入
                    if (null != sim_vatinvoice && sim_vatinvoice.length > 0) {
                        lool = false;
                        return;
                    }
                    lool = true;
                }
                //赋值给品名，fstatus，fenable
                if (lool) {
                    DynamicObject rowentrys = entryEntity.addNew();
                    rowentrys.set("tpv_aliasname", status);
                    rowentrys.set("tpv_enable", "1");
                    rowentrys.set("tpv_status", "C");
                }
            }

        }
    }


}
