package com.itopview.wm.dt.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.EndOperationTransactionArgs;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.Date;

/**
 * 采购合同 审核操作插件
 * 审核生成计息单
 */
public class PurChaseAuditOp extends AbstractOperationServicePlugIn implements Plugin {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
    }

    @Override
    public void endOperationTransaction(EndOperationTransactionArgs e) {
        super.endOperationTransaction(e);
        if ("audit".equals(e.getOperationKey()) && null != e.getDataEntities()) {
            DynamicObject[] bills = e.getDataEntities();
            for (int i = 0; i < bills.length; ++i) {
                DynamicObject bill = bills[i];
                create_tpv_interestbearing(bill);
            }
        }
    }

    /**
     * 生成计息单
     * @param bill
     */
    public void create_tpv_interestbearing(DynamicObject bill){
        bill = BusinessDataServiceHelper.loadSingle(bill.getPkValue(),bill.getDynamicObjectType().getName());
        DynamicObjectCollection tpv_accrueinte_s = bill.getDynamicObjectCollection("tpv_accrueinte_jx");
        for(int i=0;i<tpv_accrueinte_s.size();i++){
            DynamicObject tpv_accrueinte = tpv_accrueinte_s.get(i);
            DynamicObject tpv_interestbearing = ORM.create().newDynamicObject("tpv_interestbearing");
            tpv_interestbearing.set("billno",bill.getString("billno")+"_"+(i+1));
            tpv_interestbearing.set("billstatus","A");
            tpv_interestbearing.set("creator", UserServiceHelper.getCurrentUserId());
            tpv_interestbearing.set("createtime", new Date());
            tpv_interestbearing.set("org",bill.get("org"));
            tpv_interestbearing.set("tpv_dt_purcontracts",bill);
            tpv_interestbearing.set("tpv_strateg",tpv_accrueinte.get("tpv_strateg"));
            tpv_interestbearing.set("tpv_srcbillid",bill.get("id"));
            tpv_interestbearing.set("tpv_srcentryid",tpv_accrueinte.get("id"));

            QFilter qFilter = new QFilter("number", QCP.equals, "tpv_interestbearing_BT");
            DynamicObject [] bos_billtype_s = BusinessDataServiceHelper.load("bos_billtype","id,name,number",
                    new QFilter[] { qFilter });
            if(null != bos_billtype_s && bos_billtype_s.length>0){
                tpv_interestbearing.set("tpv_billtype",bos_billtype_s[0]);
            }

            DynamicObjectCollection tpv_ib_tieredinterestrate_s = tpv_interestbearing.getDynamicObjectCollection("tpv_ib_tieredinterestrate");
            DynamicObjectCollection tpv_tieredinterestrate_s = tpv_accrueinte.getDynamicObjectCollection("tpv_tieredinterestrate");
            for(int j=0;j<tpv_tieredinterestrate_s.size();j++){
                DynamicObject tpv_tieredinterestrate = tpv_tieredinterestrate_s.get(j);
                DynamicObject tpv_ib_tieredinterestrate = tpv_ib_tieredinterestrate_s.addNew();
                tpv_ib_tieredinterestrate.set("tpv_daystostart",tpv_tieredinterestrate.get("tpv_daystostart"));
                tpv_ib_tieredinterestrate.set("tpv_asofdays",tpv_tieredinterestrate.get("tpv_asofdays"));
                tpv_ib_tieredinterestrate.set("tpv_agencyrate",tpv_tieredinterestrate.get("tpv_agencyrate"));
                tpv_ib_tieredinterestrate.set("tpv_penaltyinterestsig",tpv_tieredinterestrate.get("tpv_penaltyinterestsig"));
            }
            SaveServiceHelper.save(new DynamicObject[]{tpv_interestbearing});
        }
    }
}