package com.itopview.wm.dt.opplugin.op;

import com.itopview.wm.sys.utils.NewVersionHelper;
import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.scm.common.util.DynamicObjectUtil;
import kd.sdk.plugin.Plugin;

import java.math.BigDecimal;
import java.time.DayOfWeek;
import java.time.LocalDate;
import java.time.temporal.TemporalAdjusters;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * @author GX
 * 采购合同-服务插件
 */
public class PurChaseOp extends AbstractOperationServicePlugIn implements Plugin{
	
	 @Override
	 public void onPreparePropertys(PreparePropertysEventArgs e) {
	        super.onPreparePropertys(e);
	        List<String> keys = e.getFieldKeys();
	        keys.add("tpv_dt_purchase_jhqb");
	        keys.add("tpv_deliverydatetype");
	        keys.add("tpv_dt_purchase_jhqb.tpv_agreeddeliverydeas");
	        keys.add("tpv_dt_purchase_jhqb.tpv_agreeddeliveryqty");
	        keys.add("tpv_dt_purchase_u");
		    keys.add("tpv_dt_purchase");
		 	keys.add("tpv_settlementstatus");
		    keys.add("tpv_approvaltogether.tpv_customer_apt");
		    keys.add("tpv_dt_purchase_u.seq");
		    keys.add("tpv_dt_purchase_u.tpv_payment");
		    keys.add("tpv_dt_purchase_u.tpv_dateofissuance");
	        keys.add("tpv_dt_purchase_u.tpv_proportion");
	        keys.add("tpv_department");
			keys.add("billstatus");
	        keys.add("tpv_dt_purchase.org");
	        keys.add("tpv_dt_purchase_u.tpv_urgentpayment");
	        keys.add("tpv_materialentry");
	        keys.add("tpv_materialentry.tpv_pickedquantity");
	        keys.add("tpv_materialentry.Seq");
			keys.add("tpv_contractstatusx");
		    keys.add("tpv_suppliername");
		    keys.add("tpv_sourcebillno");
		    keys.add("tpv_dateofcontracting");
			keys.add("tpv_policynumber");
			keys.add("tpv_positionnums");
			keys.add("tpv_openposition");
	    }

	@Override
	public void onAddValidators(AddValidatorsEventArgs e) {
	        super.onAddValidators(e);
	        e.addValidator(new AbstractValidator() {
	        @Override
            public void validate() {
                ExtendedDataEntity[] bills = this.getDataEntities();
                if ("submit".equals(this.getOperateKey())) {
                	for (int i = 0; i < bills.length; ++i) {
						ExtendedDataEntity bill = bills[i];
						onsubmitDate(bill);
   	                }
                }
                if ("unaudit".equals(this.getOperateKey())) {
                	for (int i = 0; i < bills.length; ++i) {
						ExtendedDataEntity bill = bills[i];
						onunauditDate(bill);
   	                }
                }
            }
	        
	        public void onsubmitDate(ExtendedDataEntity dataEntities) {
				int tpv_urgentpayment=0;
				Date date = new Date();
	        	DynamicObject dy = dataEntities.getDataEntity();
				String entityName = dataEntities.getDataEntity().getDataEntityType().getName();
				NewVersionHelper helper = new NewVersionHelper(entityName);//查找变更单

				String tpv_suppliername=dy.getString("tpv_suppliername");//供应商名称
	        	DynamicObjectCollection entry = dy.getDynamicObjectCollection("tpv_dt_purchase_jhqb");//交货期表
				DynamicObjectCollection purchase_u = dy.getDynamicObjectCollection("tpv_dt_purchase_u");//付款分录
				DynamicObjectCollection tpv_approvaltogether=dy.getDynamicObjectCollection("tpv_approvaltogether");//合并审批

				if (helper.isChanged()){
					//变更单提交时,跳过此逻辑
					return;
				}else {
					for(DynamicObject approvaltogether:tpv_approvaltogether){
						String tpv_customer_apt=approvaltogether.getString("tpv_customer_apt.name");//客户
						if(tpv_customer_apt!=null){
							if(tpv_customer_apt.equals(tpv_suppliername)){
								this.addMessage(dataEntities,"采销两端存在同一客商，不允许同时提交审批，请检查!");
							}
						}
					}
				}
				String tpv_deliverydatetype=dy.getString("tpv_deliverydatetype");
				BigDecimal sumproportion=BigDecimal.ZERO;//比例总和
//				if(tpv_deliverydatetype!=null) {
//					if(tpv_deliverydatetype.equals("A")) {
//						if(entry.size()<1) {
//							this.addMessage(dataEntities, "“交货期类型”=固定日期时，交货期表至少存在一行分录值;");
//						}else {
//							for(DynamicObject entity:entry) {
//								Date a=entity.getDate("tpv_agreeddeliverydeas");
//								BigDecimal b=entity.getBigDecimal("tpv_agreeddeliveryqty");
//								if(a==null||b.compareTo(BigDecimal.ZERO)==0) {
//									this.addMessage(dataEntities,"“约定交货期限”或“约定交货数量”不能为空");
//								}
//							}
//						}
//					}
//				}
				if(purchase_u.size()>0) {
					for(DynamicObject purchase:purchase_u) {
						String tpv_payment=purchase.getString("tpv_payment.name");
						int row=purchase.getInt("Seq");
						Date tpv_dateofissuance=purchase.getDate("tpv_dateofissuance");//预计开证日期
						if(tpv_payment!=null) {
							if(tpv_payment.equals("国内信用证")||tpv_payment.equals("国际信用证")){
								if(tpv_dateofissuance==null) {
									this.addMessage(dataEntities,"请填写付款分录第"+row+"行【预计开证日期】!");
								}
							}
						}
						if (purchase.getBoolean("tpv_urgentpayment")){
							tpv_urgentpayment++;
						}
						sumproportion=sumproportion.add(purchase.getBigDecimal("tpv_proportion"));//付款比例
					}
					if(sumproportion.compareTo(new BigDecimal("100"))!=0) {
						this.addMessage(dataEntities,"付款分录“比例(%)”必须等于100");
					}
				}else {
					this.addMessage(dataEntities,"付款分录“比例(%)”必须等于100");
				}
		    	Long org=dy.getLong("org.id");//公司
		    	Long dpt=dy.getLong("tpv_department.id");//部门
				// 将 Date 转换为 LocalDate
				LocalDate localDate = date.toInstant().atZone(java.time.ZoneId.systemDefault()).toLocalDate();
				LocalDate firstDayOfWeek = localDate.with(TemporalAdjusters.previousOrSame(DayOfWeek.MONDAY));//本周第一天
				Date dates = Date.from(firstDayOfWeek.atStartOfDay(java.time.ZoneId.systemDefault()).toInstant());
				String strdate=DateUtil.formatDate(dates);

				Calendar cal = Calendar.getInstance();
				int dayWeek = cal.get(Calendar.DAY_OF_WEEK);// 获得当前日期是一个星期的第几天
				if (Calendar.SUNDAY == dayWeek) {
					cal.add(Calendar.DAY_OF_MONTH, -1);
				}
				cal.set(Calendar.DAY_OF_WEEK, Calendar.SATURDAY);//最后一天周六
				cal.set(Calendar.HOUR_OF_DAY, 23);
				cal.set(Calendar.MINUTE, 59);
				cal.set(Calendar.SECOND, 59);
				cal.add(Calendar.DAY_OF_WEEK, 1);//加一天得到周天
				Date datexs=cal.getTime();
				String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_dt_purchase", false);// 获取单据头所有字段标识
				selectFieid2 = DynamicObjectUtil.getEntrySelectfields(selectFieid2,"tpv_dt_purchase", "tpv_dt_purchase_u",false);// 获取单据头所有字段标识
				DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_dt_purchase", selectFieid2, new QFilter[] {
						new QFilter("tpv_bizdate",">=",dates).and(new QFilter("tpv_bizdate","<=",datexs)
								.and(new QFilter("org.id", QCP.equals,org).and(new QFilter("tpv_department.id", QCP.equals,dpt)
								.and(new QFilter("tpv_urgentpayments", QCP.equals,true)
										.and(new QFilter("billstatus", QCP.equals,"C"))))))
				});
				if(bills.length>0){
					for(DynamicObject bill:bills){
						DynamicObjectCollection tpv_dt_purchase_u=bill.getDynamicObjectCollection("tpv_dt_purchase_u");//付款分录
						for(DynamicObject pur_u:tpv_dt_purchase_u){
							if(pur_u.getBoolean("tpv_urgentpayment")){
								tpv_urgentpayment++;
							}
						}
					}
				}
				if(tpv_urgentpayment>5) {
					this.addMessage(dataEntities,"紧急付款一周最多只能有5个！");
				}
				Date tpvDateofcontracting = dy.getDate("tpv_dateofcontracting");
				Date dateTract = new Date();
				if (dateTract.before(tpvDateofcontracting)){
					this.addMessage(dataEntities,"签约日期大于系统日期！");
				}
			}


	        public void onunauditDate(ExtendedDataEntity dataEntities) {
	        	DynamicObject dy = dataEntities.getDataEntity();
		    	DynamicObjectCollection entry = dy.getDynamicObjectCollection("tpv_materialentry");//商品分录
		    	if(entry.size()>0) {
		    		for(DynamicObject mater:entry) {
						BigDecimal pickedquantity=mater.getBigDecimal("tpv_pickedquantity");//已拣配数量
						if(pickedquantity.compareTo(BigDecimal.ZERO)!=0) {
							int row=mater.getInt("Seq");
							this.addMessage(dataEntities,"商品分录第"+row+"行“已拣配数量”大于0，不可以反审核！");
						}
					}
		    	}
		    }
	        });      
	    }


	@Override
	public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
		String name=e.getOperationKey();
		if("unaudit".equals(name) || "unsubmit".equals(name)){
			DynamicObject[] date=e.getDataEntities();
			date[0].set("tpv_contractstatusx","A");//合同状态-暂存
			SaveServiceHelper.save(date);
		}if("audit".equals(name)){
			DynamicObject[] date=e.getDataEntities();
			date[0].set("tpv_contractstatusx","D");//合同状态-执行中
			SaveServiceHelper.save(date);
		}
		if("submit".equals(name)){
			DynamicObject[] date=e.getDataEntities();
//			setSettlementstatus(date[0]);
			date[0].set("tpv_contractstatusx","B");//合同状态-审核中
			SaveServiceHelper.save(date);
		}
		if ("save".equals(name)){
//			DynamicObject[] date=e.getDataEntities();
//			setSettlementstatus(date[0]);
//			SaveServiceHelper.update(date[0]);
		}
	}

	@Override
	public void afterExecuteOperationTransaction(AfterOperationArgs e) {
		super.afterExecuteOperationTransaction(e);
		DynamicObject[] bills = e.getDataEntities();
		String key = e.getOperationKey();
		switch (key) {
			case "submit":
				for (int i = 0; i < bills.length; ++i) {
					DynamicObject bill = bills[i];
					setPositionQty("tpv_policynumber", "tpv_positionnums", "tpv_openposition", bill);
					OperationServiceHelper.executeOperate("save", bill.getDataEntityType().getName(),
							new DynamicObject[]{bill}, YEM.getOptionNoMsg());
				}
				break;
			default:
				break;
		}
	}

	private void setPositionQty(String name, String positionnumsKey, String openpositionKey, DynamicObject bill) {
		DynamicObject tpvStrategynum = bill.getDynamicObject(name);
		if (YEM.isNotEmpty(tpvStrategynum)) {
			long id = tpvStrategynum.getLong("id");
			DataSet purchase = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_purchase", "id,tpv_contractnumber,tpv_policynumber.id policyid," +
							"tpv_policynumber.number policynumber,tpv_materialentry,tpv_materialentry.tpv_qty qty",
					new QFilter[]{new QFilter("tpv_contractstatusx", QCP.in, new String[]{"A", "B", "C", "D", "F", "G"})
							.and(new QFilter("tpv_policynumber.id", QCP.in, id))}).select("policyid policyid", "qty purqty", "0.0 saleqty");
			DataSet salescontract = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_salescontract", "id,tpv_contractnos,tpv_strategynum.id strategyid," +
							"tpv_strategynum.number strategynum,tpv_materialentry,tpv_materialentry.tpv_qty qty",
					new QFilter[]{new QFilter("tpv_contractstatus", QCP.in, new String[]{"A", "B", "C", "D", "G", "H"})
							.and(new QFilter("tpv_strategynum.id", QCP.in, id))}).select("strategyid policyid", "qty saleqty", "0.0 purqty");
			DataSet dataSet = purchase.union(salescontract).groupBy(new String[]{"policyid"}).sum("saleqty").sum("purqty").finish();
			dataSet = RptUtil.zeroNullNums(dataSet);
			dataSet = dataSet.addField("(purqty - saleqty) qty", "qty");
			BigDecimal qty = BigDecimal.ZERO;
			if (!dataSet.isEmpty()) {
				for (Row row : dataSet) {
					qty = row.getBigDecimal("qty").setScale(2, BigDecimal.ROUND_HALF_UP).abs();
				}
			}
			BigDecimal tpvReplylimit = BigDecimalUtils.toBigDecimal(tpvStrategynum.getBigDecimal("tpv_replylimit")).setScale(2, BigDecimal.ROUND_HALF_UP);
			bill.set(positionnumsKey, qty);
			bill.set(openpositionKey, tpvReplylimit.subtract(qty));
		} else {
			bill.set(positionnumsKey, BigDecimal.ZERO);
			bill.set(openpositionKey, BigDecimal.ZERO);
		}
	}

	/**
	 * 作废
	 * */
	private void setSettlementstatus(DynamicObject date){
		String tpv_sourcebillno = date.getString("tpv_sourcebillno");//来源单据编号
		String[] list = tpv_sourcebillno.split(",");
		String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_dt_salescontract", false);// 获取单据头所有字段标识
		DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_dt_salescontract", selectFieid2, new QFilter[]{
				new QFilter("billno", QCP.in, list).and(new QFilter("billstatus", QCP.equals, "C"))});
		if (bills.length > 0) {
			for (DynamicObject bill : bills) {
				String settlementstatus = bill.getString("tpv_settlementstatus");//结算状态
				if ("A".equals(settlementstatus)) {
					return;
				}
			}
			date.set("tpv_settlementstatus", "B");//结算状态
		} else {
			date.set("tpv_settlementstatus", "A");//结算状态
		}
	}
}

