package com.itopview.wm.dt.opplugin.op;

import com.itopview.wm.dt.opplugin.validator.PurChaseUnAuditValidator;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.EndOperationTransactionArgs;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.DeleteServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.Date;

/**
 * 采购合同 反审核操作插件
 * 反审核删除计息单
 */
public class PurChaseUnAuditOp extends AbstractOperationServicePlugIn implements Plugin {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new PurChaseUnAuditValidator());
    }

    @Override
    public void endOperationTransaction(EndOperationTransactionArgs e) {
        super.endOperationTransaction(e);
        if ("unaudit".equals(e.getOperationKey()) && null != e.getDataEntities()) {
            DynamicObject[] bills = e.getDataEntities();
            for (int i = 0; i < bills.length; ++i) {
                DynamicObject bill = bills[i];
                delete_tpv_interestbearing(bill);
            }
        }
    }

    /**
     * 生成计息单
     * @param bill
     */
    public void delete_tpv_interestbearing(DynamicObject bill){
        QFilter qFilter = new QFilter("tpv_srcbillid", QCP.equals, bill.getPkValue());
        DeleteServiceHelper.delete("tpv_interestbearing",new QFilter[] { qFilter });
    }
}