package com.itopview.wm.dt.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;

import java.math.BigDecimal;
import java.util.List;

/**
 * ClassName: PurchaseInvoiceMatchOp
 * Description: 采购发票匹配单校验插件
 * date: 2023/11/4 15:22
 *
 * @author: Guo jiaChen
 */
public class PurchaseInvoiceMatchOp extends AbstractOperationServicePlugIn {
    private final static String INVOICE_Entry = "tpv_invoiceinfoentry";//发票
    private final static String CONTRACT_Entry = "tpv_continformation";//合同
    private final static String WAREHOUSE_Entry = "tpv_wareiformation";//入库

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() {
                ExtendedDataEntity[] dataEntities = this.dataEntities;
                //提交校验
                if ("submit".equals(this.getOperateKey())) {
//                    for (int i = 0; i < dataEntities.length; i++) {
//                        ExtendedDataEntity extend = dataEntities[i];
//                        DynamicObject entity = extend.getDataEntity();
//                        BigDecimal invoiceNum = new BigDecimal("0");
//                        BigDecimal contractNum = new BigDecimal("0");
//                        BigDecimal warehouseNum = new BigDecimal("0");
//                        DynamicObjectCollection invoiceEntry = entity.getDynamicObjectCollection(INVOICE_Entry);
//                        for (DynamicObject object : invoiceEntry) {
//                            invoiceNum = invoiceNum.add(object.getBigDecimal("tpv_curmactchqtys"));
//                        }
//                        DynamicObjectCollection contractEntry = entity.getDynamicObjectCollection(CONTRACT_Entry);
//                        for (DynamicObject object : contractEntry) {
//                            contractNum = contractNum.add(object.getBigDecimal("tpv_curmatchqty"));
//                        }
//                        DynamicObjectCollection warehouseEntry = entity.getDynamicObjectCollection(WAREHOUSE_Entry);
//                        for (DynamicObject object : warehouseEntry) {
//                            warehouseNum = warehouseNum.add(object.getBigDecimal("tpv_rkcurmatchqty"));
//                        }
//                        if (invoiceNum.compareTo(contractNum.add(warehouseNum)) != 0){
//                            this.addMessage(extend,"发票信息本次匹配数量不等于合同和入库的本次匹配数量之和,请检查!!!");
//                        }
//                    }
                }
                //审核校验
                if ("audit".equals(this.getOperateKey())){

                }
            }
        });
    }

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();

        keys.add("tpv_invoiceinfoentry");
        keys.add("tpv_continformation");
        keys.add("tpv_wareiformation");
        keys.add("tpv_curmactchqtys");
        keys.add("tpv_curmatchqty");
        keys.add("tpv_rkcurmatchqty");

        e.setFieldKeys(keys);
    }
}
