package com.itopview.wm.dt.opplugin.op;

import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.math.BigDecimal;
import java.util.List;

/**
 * @ClassName 计费数量校验
 * @Description TODO
 * @Author yhj
 * @Date 2023/12/21 20:19
 * @Version 1.0
 */
public class ShipmentOp  extends AbstractOperationServicePlugIn implements Plugin {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("tpv_overfillrate");
        keys.add("tpv_contractqty");
        keys.add("tpv_selectsum");
        keys.add("tpv_contract");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() {
                ExtendedDataEntity[] dataEntities = this.getDataEntities();
                if ("submit".equals(this.getOperateKey()) && null != e.getDataEntities()) {
                    onSumbit(dataEntities);
                }
            }

            private void onSumbit(ExtendedDataEntity[] dataEntities) {
                ExtendedDataEntity bill=null;
                for (int i = 0; i < dataEntities.length; ++i) {
                     bill = dataEntities[i];
                }
                for (ExtendedDataEntity data : dataEntities) {
                    DynamicObject dy = data.getDataEntity();
                    BigDecimal contractqty = BigDecimal.ZERO;//合同数量
                    BigDecimal overfillrate = BigDecimal.ZERO;//溢装率
                    BigDecimal one = BigDecimal.ONE;//1
                    BigDecimal tpv_billablequantitys = BigDecimal.ZERO;//费用子分录数量
                    BigDecimal million = BigDecimal.valueOf(100);//100
                    BigDecimal selectsum = BigDecimal.ZERO;//入库数量
                    Long conbillid = dy.getLong("tpv_corebillid");//合同id
                    String billno =dy.getString("billno");//单据编号
                    DynamicObjectCollection materialentry=dy.getDynamicObjectCollection("billentry");//商品分录
                    QFilter[] qFilter = new QFilter[]{new QFilter("tpv_dt_purchase.id", QCP.equals, conbillid)};
                    String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_purchase", "tpv_materialentry");
                    DynamicObject[] queryHW = BusinessDataServiceHelper.load("tpv_dt_purchase", selectfieldsFast, qFilter);//采购合同
                    if (queryHW != null) {
                        for (DynamicObject obj : queryHW) {
                            overfillrate = obj.getBigDecimal("tpv_overfillrate");//溢装率
                        }
                    }
                    for (DynamicObject materia:materialentry){
                        DynamicObjectCollection tpv_dt_freigroambill_f = materia.getDynamicObjectCollection("tpv_dt_purinbill_f");//费用信息
                        int row = materia.getInt("Seq");
                        BigDecimal qty = materia.getBigDecimal("qty");//商品分录数量
                        if (tpv_dt_freigroambill_f.size() > 0) {
                            for (DynamicObject freigroambill : tpv_dt_freigroambill_f) {
                                tpv_billablequantitys = freigroambill.getBigDecimal("tpv_chargequantity");
                            }
                            BigDecimal dive = overfillrate.divide(million);
                            BigDecimal add = dive.add(one);
                            BigDecimal sum = qty.multiply(add);
                            if (tpv_billablequantitys.compareTo(sum) > 0) {
                                this.addErrorMessage(bill, "商品明细第" + row + "行（{费用信息}子分录【计费数量】之和不能大于{商品分录}【数量】*（1+溢装率）!");
                            }
                        }
                    }
                }
            }

        });
    }
}
