package com.itopview.wm.dt.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;

import java.math.BigDecimal;
import java.util.List;

/**
 * @ClassName 分步调出费用数量、金额提交校验
 * @Description TODO
 * @Author yhj
 * @Date 2023/11/7 18:26
 * @Version 1.0
 */
public class SubstepSubmitOP extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("billentry");
        fieldKeys.add("tpv_dt_transoutbill_f.seq");
        fieldKeys.add("tpv_dt_transoutbill_f.tpv_costitem");
        fieldKeys.add("tpv_dt_transoutbill_f.tpv_amt");
        fieldKeys.add("tpv_dt_transoutbill_f.tpv_billablequantitys");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() {
                if ("submit".equals(this.getOperateKey())) {
                    ExtendedDataEntity[] bills = this.getDataEntities();
                    for (int i = 0; i < bills.length; ++i) {
                        ExtendedDataEntity bill = bills[i];
                        onsubmitDate(bill);
                    }
                }
            }

            private void onsubmitDate(ExtendedDataEntity dataEntities) {
                DynamicObject dy = dataEntities.getDataEntity();
                BigDecimal tpvBillablequantitys = BigDecimal.ZERO;//费用子分录数量合计
                DynamicObjectCollection billentry = dy.getDynamicObjectCollection("billentry");//商品明细
                if (billentry.size() > 0) {
                    for (DynamicObject mater : billentry) {
                        int rows = mater.getInt("Seq");
                        tpvBillablequantitys = BigDecimal.ZERO;
                        BigDecimal tpvQty = mater.getBigDecimal("qty");//商品分录数量
                        DynamicObjectCollection tpvDtTransoutbill_f = mater.getDynamicObjectCollection("tpv_dt_transoutbill_f");//费用明细
                        if (tpvDtTransoutbill_f.size() > 0) {
                            for (DynamicObject purchase : tpvDtTransoutbill_f) {
                                DynamicObject tpvCostitem = purchase.getDynamicObject("tpv_costitem");//费用项目
                                BigDecimal tpvAmt = purchase.getBigDecimal("tpv_amt");//金额
                                int row = purchase.getInt("Seq");
                                if (tpvCostitem != null && tpvAmt.compareTo(BigDecimal.ZERO) == 0) {
                                    this.addMessage(dataEntities, "费用信息分录第" + row + "行金额不能为空!");
                                }
                                tpvBillablequantitys = tpvBillablequantitys.add(purchase.getBigDecimal("tpv_chargequantity"));
                            }
                            if (tpvBillablequantitys.compareTo(tpvQty) > 0) {
                                this.addMessage(dataEntities, "商品明细第" + rows + "行（{费用信息}子分录【计费数量】之和不能大于{商品信息}分录行【数量】）!");
                            }
                        }
                    }
                }
            }
        });
    }
}
