package com.itopview.wm.dt.opplugin.validator;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * 销售合同 反审核操作校验插件
 */
public class SalesContractUnAuditValidator extends AbstractValidator {
    @Override
    public void validate() {
        ExtendedDataEntity[] dataEntities = this.dataEntities;
        for (int i = 0; i < dataEntities.length; i++) {
            ExtendedDataEntity extend = dataEntities[i];
            DynamicObject entity = extend.getDataEntity();
            check(entity,extend);
        }
    }

    public void check(DynamicObject entity,ExtendedDataEntity extend){
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(),entity.getDynamicObjectType().getName());
        QFilter qFilter = new QFilter("tpv_srcbillid", QCP.equals, entity.getPkValue());
        qFilter.and(new QFilter("billstatus", QCP.not_equals, "A"));
        DynamicObject [] tpv_interestbearing_s = BusinessDataServiceHelper.load("tpv_interestbearing","id,billno",
                new QFilter[] { qFilter });
        if(null != tpv_interestbearing_s && tpv_interestbearing_s.length>0){
            this.addMessage(extend, "下游计息单已提交/已审核，无法反审核！");
        }
    }
}
