package com.itopview.wm.dt.report;

import kd.bos.algo.DataSet;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author LiuHB
 * @version 1.0
 * 查询客户历史订单分页
 */
public class CusthisorderPlugin extends AbstractReportListDataPlugin {
    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        FilterInfo filterInfo = param.getFilter();//获取所有的过滤条件
        Date datestatime = filterInfo.getDate("tpv_datestatime");//开始时间
        Date dateovertime = filterInfo.getDate("tpv_dateovertime");//结束时间
        DynamicObject custom = filterInfo.getDynamicObject("tpv_custom");//客户
        String quantitpage = filterInfo.getString("tpv_quantitpage");//每页数量
        String pagenum = filterInfo.getString("tpv_pagenum");//页数
        int pageNo = Integer.parseInt(quantitpage);
        int page = Integer.parseInt(pagenum);
        QFilter QFilter = new QFilter("tpv_signingdate" ,QCP.large_equals, datestatime);
        QFilter.and( "tpv_usedate",QCP.less_equals, dateovertime);
        QFilter.and("tpv_customer.name",QCP.equals,custom.getString("name"));

        String selelctFiles =
                "tpv_approvaltogether.tpv_supplier_apt.number   tpv_suppcode,"+
                "tpv_approvaltogether.tpv_supplier_apt.societycreditcode  tpv_socredcode,"+
                "tpv_signingdate tpv_datastartime,"+
                "tpv_usedate tpv_dataovertime,"+
                "billno  tpv_quanpages,"+
                "billno  tpv_page";;
        DataSet dataSet = QueryServiceHelper.queryDataSet(this.getClass().getName(), "tpv_dt_salescontract", selelctFiles,
                null, null)
                .updateField("tpv_quanpages",quantitpage)
                .updateField("tpv_page",pagenum)
                .limit(Integer.valueOf("" + page + ""), Integer.valueOf("" + pageNo + ""));
        return dataSet;
    }
}
