package com.itopview.wm.dt.report;

import com.itopview.wm.sys.report.function.GroupConcatFunction;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.*;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * @ClassName DispatchRptQuery
 * @Description TODO
 * @Author yhj
 * @Date 2023/10/9 16:17
 * @Version 1.0
 */
public class DispatchRptQuery extends AbstractReportListDataPlugin {
    //主表
    private static List<String> fieldKeys_transdir = new ArrayList<>();// 直接调拨
    private static List<String> fieldKeys_purin = new ArrayList<>();// 采购入库
    private static List<String> fieldKeys_transgo = new ArrayList<>();// 分步调出
    private static List<String> fieldKeys_ship = new ArrayList<>();// 销售发货
    //平均单价、总数量、总包装数量、平均件重
    private static List<String> fieldKeys_transdirs = new ArrayList<>();// 直接调拨
    private static List<String> fieldKeys_purins = new ArrayList<>();// 采购入库
    private static List<String> fieldKeys_transgos = new ArrayList<>();// 分步调出
    private static List<String> fieldKeys_ships = new ArrayList<>();// 销售发货
    //品名
    private static List<String> fieldKeys_transdirus = new ArrayList<>();// 直接调拨
    private static List<String> fieldKeys_purinus = new ArrayList<>();// 采购入库
    private static List<String> fieldKeys_transgous = new ArrayList<>();// 分步调出
    private static List<String> fieldKeys_shipus = new ArrayList<>();// 销售发货

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        String whereFilter = createWhereStr(param);
        DataSet instockDataSet = query(whereFilter);
        return instockDataSet;
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        return whereFilter;
    }

    public static DataSet query(String whereFilter) {
        DataSet mainDataSet = mainDataSet(whereFilter);
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(DispatchRptQuery.class.getName()).createDataSet(inputs);
        return createDataSet.where("tpv_qty > 0").orderBy(new String[]{"tpv_biztime desc"});
    }

    private static DataSet mainDataSet(String whereFilter) {
        initAllFields();
        initAllField();
        initAllFieldus();
        QFilter[] qFilters = new QFilter[]{new QFilter("billstatus", QCP.equals, "C")};
        //拼接品名
        DataSet tpv_dt_salesshippinges = ORM.create().queryDataSet(DispatchRptQuery.class.getName(), "tpv_dt_salesshipping",
                String.join(",", fieldKeys_shipus), qFilters).select(new String[]{"tpv_document", "tpv_prodname"}).groupBy(new String[]{"tpv_document"}).agg(new GroupConcatFunction(), "tpv_prodname", "tpv_prodname").finish();
        DataSet im_transoutbilles = ORM.create().queryDataSet(DispatchRptQuery.class.getName(), "im_transoutbill",
                String.join(",", fieldKeys_transgous), qFilters).select(new String[]{"tpv_document", "tpv_prodname"}).groupBy(new String[]{"tpv_document"}).agg(new GroupConcatFunction(), "tpv_prodname", "tpv_prodname").finish();
        DataSet im_purinbilles = ORM.create().queryDataSet(DispatchRptQuery.class.getName(), "im_purinbill",
                String.join(",", fieldKeys_purinus), qFilters).select(new String[]{"tpv_document", "tpv_prodname"}).groupBy(new String[]{"tpv_document"}).agg(new GroupConcatFunction(), "tpv_prodname", "tpv_prodname").finish();
        DataSet im_transdirbilles = ORM.create().queryDataSet(DispatchRptQuery.class.getName(), "im_transdirbill",
                String.join(",", fieldKeys_transdirus), qFilters).select(new String[]{"tpv_document", "tpv_prodname"}).groupBy(new String[]{"tpv_document"}).agg(new GroupConcatFunction(), "tpv_prodname", "tpv_prodname").finish();
        //平均单价、平均件数
        DataSet tpv_dt_salesshippings = ORM.create().queryDataSet(DispatchRptQuery.class.getName(), "tpv_dt_salesshipping",
                String.join(",", fieldKeys_ships), qFilters);
        tpv_dt_salesshippings = tpv_dt_salesshippings.groupBy(new String[]{"tpv_document"}).sum("tpv_qty").sum("tpv_packnum").sum("tpv_amount").finish();
        DataSet im_transoutbills = ORM.create().queryDataSet(DispatchRptQuery.class.getName(), "im_transoutbill",
                String.join(",", fieldKeys_transgos), qFilters);
        im_transoutbills = im_transoutbills.groupBy(new String[]{"tpv_document"}).sum("tpv_qty").sum("tpv_packnum").sum("tpv_amount").finish();
        DataSet im_purinbills = ORM.create().queryDataSet(DispatchRptQuery.class.getName(), "im_purinbill",
                String.join(",", fieldKeys_purins), qFilters);
        im_purinbills = im_purinbills.groupBy(new String[]{"tpv_document"}).sum("tpv_qty").sum("tpv_packnum").sum("tpv_amount").finish();
        DataSet im_transdirbills = ORM.create().queryDataSet(DispatchRptQuery.class.getName(), "im_transdirbill",
                String.join(",", fieldKeys_transdirs), qFilters);
        im_transdirbills = im_transdirbills.groupBy(new String[]{"tpv_document"}).sum("tpv_qty").sum("tpv_packnum").sum("tpv_amount").finish();
        //主表
        DataSet tpv_dt_salesshipping = ORM.create().queryDataSet(DispatchRptQuery.class.getName(), "tpv_dt_salesshipping",
                String.join(",", fieldKeys_ship), qFilters);
        DataSet im_transoutbill = ORM.create().queryDataSet(DispatchRptQuery.class.getName(), "im_transoutbill",
                String.join(",", fieldKeys_transgo), qFilters);
        DataSet im_purinbill = ORM.create().queryDataSet(DispatchRptQuery.class.getName(), "im_purinbill",
                String.join(",", fieldKeys_purin), qFilters);
        DataSet im_transdirbill = ORM.create().queryDataSet(DispatchRptQuery.class.getName(), "im_transdirbill",
                String.join(",", fieldKeys_transdir), qFilters);
        //计算总数量后连接主表
        JoinDataSet join = tpv_dt_salesshipping.leftJoin(tpv_dt_salesshippings);
        tpv_dt_salesshipping = join.on("tpv_document", "tpv_document")
                .select(RptUtil.getDataSetFiledAlias(tpv_dt_salesshipping), new String[]{
                        "tpv_packnum", "tpv_qty", "tpv_amount"}).finish();
        JoinDataSet joinOne = im_transoutbill.leftJoin(im_transoutbills);
        im_transoutbill = joinOne.on("tpv_document", "tpv_document")
                .select(RptUtil.getDataSetFiledAlias(im_transoutbill), new String[]{
                        "tpv_packnum", "tpv_qty", "tpv_amount"}).finish();
        JoinDataSet joinTwo = im_purinbill.leftJoin(im_purinbills);
        im_purinbill = joinTwo.on("tpv_document", "tpv_document")
                .select(RptUtil.getDataSetFiledAlias(im_purinbill), new String[]{
                        "tpv_packnum", "tpv_qty", "tpv_amount"}).finish();
        JoinDataSet joinThree = im_transdirbill.leftJoin(im_transdirbills);
        im_transdirbill = joinThree.on("tpv_document", "tpv_document")
                .select(RptUtil.getDataSetFiledAlias(im_transdirbill), new String[]{
                        "tpv_packnum", "tpv_qty", "tpv_amount"}).finish();
        //计算循环分录品名拼接后连接主表
        JoinDataSet joins = tpv_dt_salesshipping.leftJoin(tpv_dt_salesshippinges);
        tpv_dt_salesshipping = joins.on("tpv_document", "tpv_document")
                .select(RptUtil.getDataSetFiledAlias(tpv_dt_salesshipping), new String[]{
                        "tpv_prodname"}).finish();
        JoinDataSet joinOnes = im_transoutbill.leftJoin(im_transoutbilles);
        im_transoutbill = joinOnes.on("tpv_document", "tpv_document")
                .select(RptUtil.getDataSetFiledAlias(im_transoutbill), new String[]{
                        "tpv_prodname"}).finish();
        JoinDataSet joinTwos = im_purinbill.leftJoin(im_purinbilles);
        im_purinbill = joinTwos.on("tpv_document", "tpv_document")
                .select(RptUtil.getDataSetFiledAlias(im_purinbill), new String[]{
                        "tpv_prodname"}).finish();
        JoinDataSet joinThrees = im_transdirbill.leftJoin(im_transdirbilles);
        im_transdirbill = joinThrees.on("tpv_document", "tpv_document")
                .select(RptUtil.getDataSetFiledAlias(im_transdirbill), new String[]{
                        "tpv_prodname"}).finish();
        DataSet dataSet = tpv_dt_salesshipping.union(im_transoutbill, im_purinbill, im_transdirbill);
        dataSet = dataSet.select("tpv_document", "tpv_billtypes", "tpv_sendingpath", "tpv_sendstate"
                , "tpv_entrepot", "tpv_biztime", "tpv_department"
                , "tpv_creator", "tpv_faxstatus", "tpv_fax",
                "tpv_mailstate", "tpv_eaddress", "tpv_expirydate"
                , "tpv_pushstatus", "tpv_lockstate", "tpv_packnum", "tpv_qty"
                , "tpv_amount", "case when tpv_packnum > 0 then tpv_qty / tpv_packnum  else 0 end tpv_units"
                , "case when tpv_qty > 0 then tpv_amount / tpv_qty  else 0 end tpv_unitcost", "tpv_prodname", "tpv_attachmentcon");
        if (YEM.isNotEmpty(whereFilter)) {
            dataSet = dataSet.where(whereFilter);
        }
//        for (Row row : dataSet) {
//            String b = row.getString("tpv_document");
//            String a = row.getString("tpv_attachmentcon");
//            if (b.equals("CGRK-231007-000004")) {
//                System.out.println(a);
//            }
//        }
        return dataSet;
    }

    private static void initAllFieldus() {
        fieldKeys_shipus.clear();
        fieldKeys_transgous.clear();
        fieldKeys_purinus.clear();
        fieldKeys_transdirus.clear();
        addFieldu("tpv_document", "billno");// 单据编号
        addFieldu("tpv_prodname", "tpv_materialentry.tpv_prodname.number", "billentry.tpv_prodname.number", "billentry.tpv_prodname.number", "billentry.tpv_prodname.number");// 品名
    }

    private static void initAllField() {
        fieldKeys_ships.clear();
        fieldKeys_transgos.clear();
        fieldKeys_purins.clear();
        fieldKeys_transdirs.clear();
        addField("tpv_document", "billno");// 单据编号
        addField("tpv_unitcost", "tpv_materialentry.tpv_price", "billentry.price", "billentry.price", "billentry.price");// 平均单价
        addField("tpv_qty", "tpv_materialentry.tpv_qty", "billentry.qty", "billentry.qty", "billentry.qty");// 数量
        addField("tpv_amount", "tpv_materialentry.tpv_nottaxamount", "billentry.amount", "billentry.amount", "billentry.amount");// 金额
        addField("tpv_packnum", "tpv_materialentry.tpv_packnum"
                , "billentry.tpv_packnum", "billentry.tpv_packnum", "billentry.tpv_packnum");// 包装数量

    }

    private static void initAllFields() {
        fieldKeys_ship.clear();
        fieldKeys_transgo.clear();
        fieldKeys_purin.clear();
        fieldKeys_transdir.clear();
        addFields("tpv_document", "billno");// 单据编号
        addFields("tpv_billtypes", "tpv_billtype", "billtype", "billtype", "billtype");// 单据类型
        addFields("tpv_sendingpath", "tpv_sendingpath");// 发送途径
        addFields("tpv_sendstate", "tpv_sendstate");// 发送状态
        addFields("tpv_entrepot", "tpv_entrepot");// 仓库
        addFields("tpv_biztime", "tpv_bizdate", "biztime", "biztime", "biztime");// 业务日期
        addFields("tpv_department", "tpv_department", "org", "bizdept", "outdept");// 部门
        addFields("tpv_creator", "creator");// 制单人
        addFields("tpv_faxstatus", "tpv_faxstatus");// 传真状态
        addFields("tpv_fax", "tpv_fax");// 传真号
        addFields("tpv_mailstate", "tpv_mailstate");// 邮件状态
        addFields("tpv_eaddress", "tpv_eaddress");// 邮件地址
        addFields("tpv_expirydate", "tpv_expirydate");// 有效期限（升华）
        addFields("tpv_pushstatus", "tpv_pushstatus");// 推送状态
        addFields("tpv_lockstate", "tpv_lockstate");// 锁定状态（升华）
        addFields("tpv_attachmentcon", "tpv_attachmentcon_tag");// 附件表格内容
        //addFields("tpv_automaticcount","tpv_materialentry.tpv_price","AVG(billentry.price)","billentry.price","billentry.price");// 自动签次数
        //addFields("tpv_ready","tpv_materialentry.tpv_price","AVG(billentry.price)","billentry.price","billentry.price");// 自动签就绪
    }

    private static void addFields(String fieldKey, String fieldKey_bill) {
        fieldKeys_ship.add(fieldKey_bill + " " + fieldKey);//销售发货
        fieldKeys_transgo.add(fieldKey_bill + " " + fieldKey);//分步调出
        fieldKeys_purin.add(fieldKey_bill + " " + fieldKey);//采购入库
        fieldKeys_transdir.add(fieldKey_bill + " " + fieldKey);//直接调拨
    }


    private static void addFields(String fieldKey, String a, String b, String c, String d) {
        fieldKeys_ship.add(a + " " + fieldKey);
        fieldKeys_transgo.add(b + " " + fieldKey);
        fieldKeys_purin.add(c + " " + fieldKey);
        fieldKeys_transdir.add(d + " " + fieldKey);
    }

    private static void addField(String fieldKey, String fieldKey_bill) {
        fieldKeys_ships.add(fieldKey_bill + " " + fieldKey);//销售发货
        fieldKeys_transgos.add(fieldKey_bill + " " + fieldKey);//分步调出
        fieldKeys_purins.add(fieldKey_bill + " " + fieldKey);//采购入库
        fieldKeys_transdirs.add(fieldKey_bill + " " + fieldKey);//直接调拨
    }


    private static void addField(String fieldKey, String a, String b, String c, String d) {
        fieldKeys_ships.add(a + " " + fieldKey);
        fieldKeys_transgos.add(b + " " + fieldKey);
        fieldKeys_purins.add(c + " " + fieldKey);
        fieldKeys_transdirs.add(d + " " + fieldKey);
    }

    private static void addFieldu(String fieldKey, String fieldKey_bill) {
        fieldKeys_shipus.add(fieldKey_bill + " " + fieldKey);//销售发货
        fieldKeys_transgous.add(fieldKey_bill + " " + fieldKey);//分步调出
        fieldKeys_purinus.add(fieldKey_bill + " " + fieldKey);//采购入库
        fieldKeys_transdirus.add(fieldKey_bill + " " + fieldKey);//直接调拨
    }


    private static void addFieldu(String fieldKey, String a, String b, String c, String d) {
        fieldKeys_shipus.add(a + " " + fieldKey);
        fieldKeys_transgous.add(b + " " + fieldKey);
        fieldKeys_purinus.add(c + " " + fieldKey);
        fieldKeys_transdirus.add(d + " " + fieldKey);
    }

}
