package com.itopview.wm.dt.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QFilter;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * 结算单（客户）-报表插件
 * @description 查询插件
 * @author GX
 */
public class DomSettcRptQuery extends AbstractReportListDataPlugin{	
	private static List<String> fieldKeys_sale = new ArrayList<>();// 销售发货
//	private static List<String> fieldKeys_salepick = new ArrayList<>();// 销售发货子分录
	private static List<String> fieldKeys_saleprice = new ArrayList<>();// 销售价格确认

	@Override
	public DataSet query(ReportQueryParam param, Object obj) throws Throwable {
		DataSet instockDataSet = query("1 = 1");
		return instockDataSet;
	}
	
	public static DataSet query(String whereFilter) {
		DataSet mainDataSet = mainDataSet(whereFilter);
		DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
		for (DynamicObject col : col_s) {
			String tpv_source = col.getString("tpv_source");//来源
		}

		RowMeta rowMeta = mainDataSet.getRowMeta();
		int fieldCount = rowMeta.getFieldCount();
		Collection<Object[]> collection = new ArrayList<>();
		for (int i = 0; i < col_s.size(); i++) {
			DynamicObject col = col_s.get(i);
			Object[] obj = new Object[fieldCount];
			for (int j = 0; j < fieldCount; j++) {
				obj[j] = col.get(j);
			}
			collection.add(obj);
		}
		CollectionInput inputs = new CollectionInput(rowMeta, collection);
		DataSet createDataSet = Algo.create(PurPriceRptQuery.class.getName()).createDataSet(inputs);
		return createDataSet.orderBy(new String[] { "tpv_deliveryordernos desc" });
	}
	
	public static DataSet query1(String whereFilter) {
		DataSet mainDataSet = mainDataSet1(whereFilter);
		return mainDataSet.where("tpv_billstatus = 'C'").orderBy(new String[] { "tpv_accrnum desc" });
	}

	public static DataSet query2(String whereFilter) {
		DataSet mainDataSet = mainDataSet2(whereFilter);
		return mainDataSet.where("tpv_billstatus = 'C'").orderBy(new String[] { "tpv_businessdate desc" });
	}

	public static DataSet query3(String whereFilter) {
		DataSet mainDataSet = mainDataSet3(whereFilter);
		return mainDataSet.where("tpv_billstatus = 'C' and tpv_commodity != null and tpv_yuinsnum > 0");
//		return mainDataSet;
	}
	public static DataSet queryd(String whereFilter) {
		DataSet mainDataSet = mainDataSetd(whereFilter);
//		return mainDataSet.where("billstatus = 'C'");
		return mainDataSet;
	}

//	public static DataSet query4(String whereFilter) {
//		DataSet domsetDataSet = domsettcDataSet(whereFilter);
//		return domsetDataSet.where("tpv_bills = 'C' and tpv_yjinvoicesnum != 0");
//	}

	
	private static DataSet mainDataSet(String whereFilter) {
		initAllFields();
		QFilter[] qFilters = null;
//		DataSet salesshipping = ORM.create().queryDataSet(PurPriceRptQuery.class.getName(), "tpv_dt_salesshipping",
//				String.join(",", fieldKeys_sale), qFilters);
//		DataSet tpv_dt_salesshipping = ORM.create().queryDataSet(PurPriceRptQuery.class.getName(), "tpv_dt_salesshipping",
//				String.join(",", fieldKeys_salepick),qFilters);
		DataSet salepricebill = ORM.create().queryDataSet(PurPriceRptQuery.class.getName(), "tpv_dt_salepricebill",
				String.join(",", fieldKeys_saleprice),new QFilter[]{new QFilter("tpv_sourcebillkey","=","tpv_dt_salesshipping")});
//		DataSet dataSet = salesshipping.union(salepricebill);
		if (YEM.isNotEmpty(whereFilter)) {
//			dataSet = dataSet.where(whereFilter);
			salepricebill = salepricebill.where(whereFilter);
		}
//		return dataSet.where("tpv_count != 0 and tpv_productname != null").distinct();
		return salepricebill.where("tpv_count != 0 and tpv_productname != null").distinct();
	}
	
	
	private static DataSet mainDataSet1(String whereFilter) {
		QFilter[] qFilters = null;
		String selectFiles =//计息单
				"billno tpv_accrnum,"//计息单号
			   +"tpv_strateg tpv_accrtactics,"//计息策略
			   +"billstatus tpv_billstatus,"//单据状态
			   +"tpv_dt_salescontracts.tpv_name tpv_dt_salescontracts,"//销售合同号
			   +"tpv_ib_receivableentry.tpv_ablebillamt tpv_accramount";//计息金额
		DataSet salepricebill = ORM.create().queryDataSet(PurPriceRptQuery.class.getName(), "tpv_interestbearing",
				selectFiles, qFilters);//计息单
		if (YEM.isNotEmpty(whereFilter)) {
			salepricebill = salepricebill.where(whereFilter);
		}
		return salepricebill;
	}

	private static DataSet mainDataSet2(String whereFilter) {
		QFilter[] qFilters = null;
		String selectFiles =//收款处理
				"billno tpv_collectionnum,"//收款单号
						+"bizdate tpv_businessdate,"//业务日期
						+"billstatus tpv_billstatus,"//单据状态
						+"entry,"
						+"entry.shkd_salecontract.number tpv_purchasecontracts," //销售合同号
						+"entry.e_receivableamt tpv_amountreceived";//付款金额
		DataSet salepricebill = ORM.create().queryDataSet(PurPriceRptQuery.class.getName(), "cas_recbill",
				selectFiles, qFilters);//收款处理
		if (YEM.isNotEmpty(whereFilter)) {
			salepricebill = salepricebill.where(whereFilter);
		}
		return salepricebill;
	}

	private static DataSet mainDataSet3(String whereFilter) {
		QFilter[] qFilters = null;
		String selectFiles =//销售发货单
				         "billno tpv_invoicenumber,"//发货单号
						+"tpv_contractcus tpv_clients,"//客户
						+"tpv_bizdate tpv_shipdate,"//发货日期
						+"billstatus tpv_billstatus,"//单据状态
						+"tpv_contractnumber tpv_purchasecontracts,"//销售合同号
						+"tpv_materialentry.tpv_dt_salepick_in.tpv_material_in tpv_commodity,"//商品
		                +"tpv_materialentry.tpv_dt_salepick_in.tpv_origin_in tpv_origins,"//产地
		                +"tpv_materialentry.tpv_dt_salepick_in.tpv_shader_in tpv_shaders,"//材质
						+"tpv_materialentry.tpv_dt_salepick_in.tpv_specation_in tpv_specations,"//规格
						+"tpv_materialentry.tpv_dt_salepick_in.tpv_measure tpv_unit,"//计量单位
						+"tpv_materialentry.tpv_dt_salepick_in.tpv_pickqty_in tpv_yuinsnum,"//原开票数量（隐藏）
						+"tpv_materialentry.tpv_dt_salepick_in.id tpv_entrtyid,"//拣配库存子分录id
						+"tpv_materialentry.tpv_dt_salepick_in.tpv_pickbill_in tpv_pickbill_in,"//配货单据
						+"tpv_materialentry.tpv_dt_salepick_in.tpv_fid_in tpv_billonid,"//配货单据id
						+"tpv_materialentry.tpv_dt_salepick_in.tpv_fentryid_in tpv_billonentryid,"//配货单据分录id
//						+"100 tpv_yuinvoicesnum,"//开票数量
						+"tpv_materialentry.id tpv_srcinparenentrytid,"//来源库存子分录对应父分录id
						+"id tpv_srcbillid,"//来源库存子分录对应父分录id
						+"tpv_materialentry.tpv_prodname tpv_prodname,"//品名
		                +"tpv_materialentry.tpv_vatrates tpv_rate";//税率
		DataSet salepricebill = ORM.create().queryDataSet(PurPriceRptQuery.class.getName(), "tpv_dt_salesshipping",
				selectFiles, qFilters);//销售发货单
		if (YEM.isNotEmpty(whereFilter)) {
			salepricebill = salepricebill.where(whereFilter);
		}
		return salepricebill;
	}

	private static DataSet mainDataSetd(String whereFilter) {
		QFilter[] qFilters = null;
		String selectFiles =//费用发票匹配
							"tpv_costitem tpv_costitem,"
							+"tpv_matecost.tpv_rated tpv_taxrate,"
//							+"tpv_pactmessage.tpv_ratea tpv_taxrate,"
							+"tpv_matecost.tpv_vatnomatamt tpv_tax,"
//							+"tpv_pactmessage.tpv_vatmatamt tpv_tax,"
//							+"tpv_pactmessage.tpv_vatamtmatch tpv_nottaxamount,"
							+"tpv_matecost.tpv_taxnomatamt tpv_nottaxamount,"
							+"tpv_matecost.tpv_taxmatamt tpv_plusdutyamount";
//							+"tpv_pactmessage.tpv_amtatch tpv_plusdutyamount";
		DataSet salepricebill = ORM.create().queryDataSet(PurPriceRptQuery.class.getName(), "tpv_dt_costbillmat", selectFiles, qFilters);//费用发票匹配
		if (YEM.isNotEmpty(whereFilter)) {
			salepricebill = salepricebill.where(whereFilter);
		}
		return salepricebill;
	}

	private static DataSet domsettcDataSet(String whereFilter) {
		QFilter[] qFilters = null;
		String selectFiles =//结算单（客户）
						"billstatus tpv_bills,"//单据状态
						+"tpv_purchasecontracts tpv_purchasecontracts,"//销售合同号
						+"tpv_dt_settdc_kp.tpv_numberinvoices tpv_yjinvoicesnum";//已结算开票数量(隐藏)
		DataSet salepricebill = ORM.create().queryDataSet(PurPriceRptQuery.class.getName(), "tpv_dt_domsettc",
				selectFiles, qFilters);//销售发货单
		if (YEM.isNotEmpty(whereFilter)) {
			salepricebill = salepricebill.where(whereFilter);
		}
		return salepricebill;
	}
	
	private static void initAllFields() {
		fieldKeys_sale.clear();
//		fieldKeys_salepick.clear();
		fieldKeys_saleprice.clear();
		addFields("tpv_source", "'A'", "'C'");// 来源
		addFields("tpv_deliveryordernos", "billno","null");//发货单号
		addFields("tpv_priceconfnum", "null","billno");//价格确认单号
		addFields("tpv_clientxs", "tpv_customername");//客户
		addFields("tpv_operdate", "tpv_bizdate","null");//发货日期
		addFields("tpv_productname", "tpv_materialentry.tpv_material","tpv_materialentry.tpv_material");//商品
		addFields("tpv_specation", "tpv_materialentry.tpv_specation","tpv_materialentry.tpv_specation");//规格
		addFields("tpv_shader", "tpv_materialentry.tpv_shader","tpv_materialentry.tpv_shader");//材质
		addFields("tpv_origin", "tpv_materialentry.tpv_origin","tpv_materialentry.tpv_origin");//产地
		addFields("tpv_measuringunit", "tpv_materialentry.tpv_unit","tpv_materialentry.tpv_unit");//计量单位
		addFields("tpv_count", "tpv_materialentry.tpv_qty - tpv_materialentry.tpv_confirmed",
				"tpv_materialentry.tpv_qty_final");//数量
		addFields("tpv_basicunits", "tpv_materialentry.tpv_packagingunit","tpv_materialentry.tpv_packagingunit");//包装单位
		addFields("tpv_baseqtys", "(CASE WHEN tpv_materialentry.tpv_document = 'A' THEN tpv_materialentry.tpv_packnum - tpv_materialentry.tpv_confirmed ELSE tpv_materialentry.tpv_packnum END)",
				"tpv_materialentry.tpv_packnum");//包装数量
		addFields("tpv_unitprice", "tpv_materialentry.tpv_taxprice","tpv_materialentry.tpv_taxprice_final");//单价
		addFields("tpv_money", "tpv_materialentry.tpv_taxpramount","tpv_materialentry.tpv_taxamt_final");//金额
		addFields("tpv_corebillno", "tpv_corebillno");//核心单据编码
		addFields("tpv_sourcebillkey", "tpv_sourcebillkey");//来源单据标识
		addFields("tpv_billstatus","billstatus");//单据状态
	}
	
	private static void addFields(String fieldKey, String fieldKey_bill) {
		fieldKeys_sale.add(fieldKey_bill + " " + fieldKey);
		fieldKeys_saleprice.add(fieldKey_bill + " " + fieldKey);
	}

	private static void addFields(String fieldKey, String a,String c) {
		fieldKeys_sale.add(a+" "+fieldKey);
		fieldKeys_saleprice.add(c+" "+fieldKey);
	}

}
