package com.itopview.wm.dt.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QFilter;

/**
 * 结算单（供应商）-报表插件
 * @description 查询插件
 * @author GX
 */
public class DomSettlsRptQuery extends AbstractReportListDataPlugin {

    @Override
    public DataSet query(ReportQueryParam reportQueryParam, Object o) throws Throwable {
        return null;
    }

    public static DataSet query1(String whereFilter) {
        DataSet mainDataSet = mainDataSet1(whereFilter);
        return mainDataSet.where("tpv_billstatus = 'C'").orderBy(new String[] { "tpv_slipnumber desc" });
    }

    public static DataSet query2(String whereFilter) {
        DataSet mainDataSet = mainDataSet2(whereFilter);
        return mainDataSet.where("tpv_billstatus = 'C'").orderBy(new String[] { "tpv_businessdate desc" });
    }

    public static DataSet query3(String whereFilter) {
        DataSet mainDataSet = mainDataSet3(whereFilter);
		return mainDataSet;
    }

    private static DataSet mainDataSet1(String whereFilter) {
        QFilter[] qFilters = null;
        String selectFiles =//计息单
                "billno tpv_slipnumber,"//计息单号
                        +"tpv_strateg tpv_strategies,"//计息策略
                        +"billstatus tpv_billstatus,"//单据状态
                        +"tpv_dt_purcontracts.tpv_name tpv_dt_salescontracts,"//销售合同号
                        +"tpv_ib_receivableentry.tpv_ablebillamt tpv_bearingamount";//计息金额
        DataSet salepricebill = ORM.create().queryDataSet(PurPriceRptQuery.class.getName(), "tpv_interestbearing",
                selectFiles, qFilters);//计息单
        if (YEM.isNotEmpty(whereFilter)) {
            salepricebill = salepricebill.where(whereFilter);
        }
        return salepricebill;
    }

    private static DataSet mainDataSet2(String whereFilter) {
        QFilter[] qFilters = null;
        String selectFiles =//收款处理
                "billno tpv_paymentno,"//收款单号
                        +"bizdate tpv_businessdate,"//业务日期
//                        +" tpv_paymenttype,"//付款类型
                        +"billstatus tpv_billstatus,"//单据状态
                        +"entry,"
                        +"entry.shkd_purcontract.tpv_name tpv_purchasecontracts," //采购合同号
                        +"entry.e_receivableamt tpv_amountreceived";//付款金额
        DataSet salepricebill = ORM.create().queryDataSet(PurPriceRptQuery.class.getName(), "cas_recbill",
                selectFiles, qFilters);//收款处理
        if (YEM.isNotEmpty(whereFilter)) {
            salepricebill = salepricebill.where(whereFilter);
        }
        return salepricebill;
    }

    private static DataSet mainDataSet3(String whereFilter) {
        QFilter[] qFilters = null;
        String selectFiles =//销售发货单
                "billno tpv_invoicenumber,"//发货单号
                        +"tpv_contractcus tpv_customer,"//客户
                        +"tpv_contractnumber tpv_saleconno,"//销售合同号
                        +"tpv_materialentry.tpv_dt_salepick_in.tpv_billno_in tpv_purchasecontracts,"//采购合同号
                        +"tpv_bizdate tpv_operdate,"//业务日期
                        +"tpv_materialentry.tpv_dt_salepick_in.tpv_material_in tpv_productname,"//商品
                        +"tpv_materialentry.tpv_dt_salepick_in.tpv_origin_in tpv_origin_zy,"//产地
                        +"tpv_materialentry.tpv_dt_salepick_in.tpv_shader_in tpv_shader_zy,"//材质
                        +"tpv_materialentry.tpv_dt_salepick_in.tpv_specation_in tpv_specifications,"//规格
                        +"tpv_materialentry.tpv_dt_salepick_in.tpv_measure tpv_measuringunit,"//计量单位
                        +"tpv_materialentry.tpv_dt_salepick_in.tpv_pickqty_in tpv_count,"//数量
                        +"tpv_materialentry.tpv_dt_salepick_in.tpv_packnum_in tpv_packnum,"//包装数量
                        +"tpv_materialentry.tpv_packagingunit tpv_packagingunit,"//包装单位
                        +"tpv_materialentry.tpv_thirdpartyprice tpv_guideprice,"//销售指导价
                        +"billstatus tpv_billstatus";//单据状态
        DataSet salepricebill = ORM.create().queryDataSet(PurPriceRptQuery.class.getName(), "tpv_dt_salesshipping",
                selectFiles, qFilters);//销售发货单
        if (YEM.isNotEmpty(whereFilter)) {
            salepricebill = salepricebill.where(whereFilter);
        }
        return salepricebill;
    }

}
