package com.itopview.wm.dt.report;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.report.plugin.AbstractReportFormPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;

/**
 * 可拣配查询
 *
 * @author LinRui
 * @description 表单插件 -公司赋默认值
 * @date 2024年8月16日
 */
public class PickShipsRptFormPlugin extends AbstractReportFormPlugin {

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IDataModel model = this.getModel();
        DynamicObject[] bosOrg = BusinessDataServiceHelper.load("bos_org", "id,number",
                new QFilter[]{new QFilter("enable", QCP.equals, "1")
                        .and(new QFilter("number", QCP.in, new String[]{"Org-00003","Org-00002","Org-00001"}))}
        );
        DynamicObjectCollection mulOrg = new DynamicObjectCollection();
        DynamicObjectType dynamicObjectType = model.getDataEntity(true).getDynamicObjectCollection("tpv_org_f").getDynamicObjectType();
        for (DynamicObject bosAdminorg : bosOrg) {
            DynamicObject newDepartAdm = new DynamicObject(dynamicObjectType);
            newDepartAdm.set("fbasedataId", bosAdminorg);
            mulOrg.add(newDepartAdm);
        }
        this.getModel().setValue("tpv_org_f", mulOrg);
    }

}
