package com.itopview.wm.dt.report;

import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.math.BigDecimal;
import java.util.*;


/**
 * 直运实提工作台
 *
 * @author WaangShuGuang
 * @description 查询插件
 * @date 2023年9月15日
 */
public class PracticalRptQuery extends AbstractReportListDataPlugin {
    private static final String algoKey = PracticalRptQuery.class.getName();
    private static List<String> fieldKeys_ship = new ArrayList<>();// 销售发货

    @Override
    public DataSet query(ReportQueryParam param, Object obj) throws Throwable {
        String whereFilter = createWhereStr(param);
        DataSet instockDataSet = query(whereFilter);
        return instockDataSet;
    }

    public static DataSet query(String whereFilter) {
        DataSet mainDataSet = mainDataSet(whereFilter);
//        List<Long> materialids = new ArrayList<>();
//        DataSet copy = mainDataSet.copy();
//        for (Row row : copy) {
//            if (!materialids.contains(row.getLong("tpv_material"))) {
//                materialids.add(row.getLong("tpv_material"));
//            }
//        }
//        Map<Long, HashMap<String, BigDecimal>> matersidData = matersidData(materialids);// //查询物料数据
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        for (DynamicObject col : col_s) {
//            if (matersidData.containsKey(col.getLong("tpv_material"))) {
//                BigDecimal tpv_destroyquantitysum = col.getBigDecimal("tpv_destroyquantitysum");
//                BigDecimal tpv_qtyrecord = col.getBigDecimal("tpv_qtyrecord");
//                BigDecimal qty = tpv_qtyrecord.compareTo(BigDecimal.ZERO) != 0 ? tpv_qtyrecord : BigDecimal.ONE;
//                HashMap<String, BigDecimal> bigDecimalMap = matersidData.get(col.getLong("tpv_material"));
//                BigDecimal shkdQuantitystart = bigDecimalMap.get("shkd_quantitystart");
//                BigDecimal shkdQuantityend = bigDecimalMap.get("shkd_quantityend");
//                BigDecimal shkdFloatpercentage = bigDecimalMap.get("shkd_floatpercentage");
//                BigDecimal subtract = tpv_destroyquantitysum.subtract(tpv_qtyrecord);
//                BigDecimal absqty = subtract.divide(qty, 2, RoundingMode.HALF_UP).abs();
//                BigDecimal startqty = absqty.subtract(shkdQuantitystart);
//                BigDecimal endqty = absqty.subtract(shkdQuantityend);
//                if (startqty.compareTo(BigDecimal.ZERO) >= 0 && endqty.compareTo(BigDecimal.ZERO) < 0) {
//                    if (absqty.compareTo(shkdFloatpercentage) > 0) {
//                        col.set("tpv_islogistics","true");
//                    }
//                }
//
//            }
//            BigDecimal tpv_ofpackages = col.getBigDecimal("tpv_ofpackages");
//            BigDecimal tpv_fpackagerealsum = col.getBigDecimal("tpv_fpackagerealsum");
//            if (tpv_ofpackages.compareTo(tpv_fpackagerealsum) != 0) {
//                col.set("tpv_islogistics","true");
//            }
        }
        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        return createDataSet.where("tpv_qty > 0 and tpv_danjutype = 'C'").orderBy(new String[]{"tpv_shipmentsdate desc","tpv_srcentryid asc","tpv_sourceid asc"});
    }

    private static DataSet mainDataSet(String whereFilter) {
        initAllFields();
        QFilter qFilters = new QFilter("billstatus",QCP.in,new String[]{"B","C"});
        DataSet tpv_dt_salesshipping = ORM.create().queryDataSet(algoKey, "tpv_dt_salesshipping",
                String.join(",", fieldKeys_ship), qFilters.toArray());
        if (YEM.isNotEmpty(whereFilter)) {
            tpv_dt_salesshipping = tpv_dt_salesshipping.where(whereFilter);
        }
        //查询直运业务实提底表，将分录销提数量和采提数量汇总
        DataSet copy = tpv_dt_salesshipping.copy();
        List<Long> zyids = new ArrayList<>();
        for (Row row : copy) {
            if (!zyids.contains(row.getLong("tpv_sourceid"))) {
                zyids.add(row.getLong("tpv_sourceid"));
            }
        }
        QFilter qFilterBlend = new QFilter("id", QCP.in,zyids);
        qFilterBlend.and(new QFilter("tpv_sonentryentity.id",QCP.large_than,0));
        DataSet tpv_dt_blendingepibenthic = ORM.create().queryDataSet(algoKey, "tpv_dt_blendingepibenthic",
                "id blendid,tpv_sonentryentity,tpv_sonentryentity.id blendentryid, tpv_sonentryentity.tpv_destroyquantity destsalesqty," +
                        "tpv_sonentryentity.tpv_purchasequantity destordersqty,tpv_sonentryentity.tpv_fpackagereal tpv_fpackagereal",
                qFilterBlend.toArray());

        DataSet copyBlend = tpv_dt_blendingepibenthic.copy();
        List<Long> blendids = new ArrayList<>();
        for (Row row : copyBlend) {
            if (!blendids.contains(row.getLong("blendentryid"))) {
                blendids.add(row.getLong("blendentryid"));
            }
        }
        //查询销售出库和其他出库数量，根据直运业务实提底表分录行id，将出库数量汇总
        QFilter qFilterSalout = new QFilter("billentry.tpv_directconsignmentid", QCP.in,blendids);
        qFilterSalout.and(new QFilter("billentry.id",QCP.large_than,0));
        DataSet im_saloutbill = ORM.create().queryDataSet(algoKey, "im_saloutbill",
                "id,billentry,billentry.qty outqty,billentry.tpv_directconsignmentid tpv_directid", qFilterSalout.toArray());
        im_saloutbill = im_saloutbill.groupBy(new String[]{"tpv_directid"}).sum("outqty").finish();
//        QFilter qFilteOtherout = new QFilter("billentry.tpv_directconsignmentid", QCP.in,blendids);
//        qFilteOtherout.and(new QFilter("billentry.id",QCP.large_than,0));
//        DataSet tpv_im_otheroutbill = ORM.create().queryDataSet(algoKey, "im_otheroutbill",
//                "id,billentry,billentry.qty outqty,billentry.tpv_directconsignmentid  tpv_directid", qFilteOtherout.toArray());
//        tpv_im_otheroutbill = tpv_im_otheroutbill.groupBy(new String[]{"tpv_directid"}).sum("outqty").finish();
//        DataSet outbillData = im_saloutbill.union(tpv_im_otheroutbill).groupBy(new String[]{"tpv_directid"}).sum("outqty").finish();
        DataSet outbillData = im_saloutbill;
        tpv_dt_blendingepibenthic = tpv_dt_blendingepibenthic.leftJoin(outbillData).on("blendentryid","tpv_directid")
                .select("blendid","destsalesqty","destordersqty","tpv_fpackagereal","outqty").finish();
        tpv_dt_blendingepibenthic = tpv_dt_blendingepibenthic.groupBy(new String[]{"blendid"})
                .sum("destsalesqty").sum("destordersqty").sum("tpv_fpackagereal").sum("outqty").finish();
        DataSet dataSet = tpv_dt_salesshipping.leftJoin(tpv_dt_blendingepibenthic).on("tpv_sourceid","blendid")
                .select(RptUtil.getDataSetFiledAlias(tpv_dt_salesshipping),new String[]{"destsalesqty tpv_destroyquantitysum",
                        "destordersqty tpv_purchasequantitysum","tpv_fpackagereal tpv_fpackagerealsum",
                        "outqty tpv_issuedquantitys"}).finish();
        dataSet = RptUtil.zeroNullNums(dataSet);
        dataSet = dataSet.addField("tpv_destroyquantitysum - tpv_issuedquantitys tpv_unissuedquanti","tpv_unissuedquanti");
        dataSet = dataSet.addField("tpv_qty - tpv_fpackagerealsum tpv_unfpackagerealsum","tpv_unfpackagerealsum");
        dataSet = RptUtil.zeroNullNums(dataSet);
        dataSet = dataSet.addField("false tpv_islogistics","tpv_islogistics");
        return dataSet;
    }

    private static Map matersidData(List<Long> materialids) {
        Map<Long, HashMap<String, BigDecimal>> map = new HashMap<>();
        QFilter qFilterMater = new QFilter("shkd_floatingentry.id",QCP.large_than,0);
        if (materialids.size() > 0) {
            qFilterMater.and(new QFilter("id", QCP.in, materialids));
        }
        DataSet bd_material = ORM.create().queryDataSet(algoKey, "bd_material", "id matersid,shkd_floatingentry," +
                        "shkd_floatingentry.shkd_quantitystart shkd_quantitystart,shkd_floatingentry.shkd_quantityend shkd_quantityend," +
                        "(shkd_floatingentry.shkd_floatpercentage * 0.01) shkd_floatpercentage",
                qFilterMater.toArray());
        bd_material = RptUtil.zeroNullNums(bd_material);
        DataSet copy = bd_material.copy();
        for (Row row : copy) {
            HashMap<String, BigDecimal> bigDecimalMap = new HashMap<>();
            bigDecimalMap.put("shkd_quantitystart",row.getBigDecimal("shkd_quantitystart"));
            bigDecimalMap.put("shkd_quantityend",row.getBigDecimal("shkd_quantityend"));
            bigDecimalMap.put("shkd_floatpercentage",row.getBigDecimal("shkd_floatpercentage"));
            map.put(row.getLong("matersid"),bigDecimalMap);
        }
        return map;
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        return whereFilter;
    }

    private static void initAllFields() {
        fieldKeys_ship.clear();
        addFields("tpv_seleid", "id");// 来源单据ID
        addFields("tpv_sourceid", "tpv_materialentry.tpv_dt_salepick_zy");// 来源单据ID
        addFields("tpv_srcentryid", "tpv_materialentry");// 来源单据分录ID
        addFields("tpv_source", "'B'");// 来源单据
        addFields("tpv_shipments", "billno");// 发货单号
        addFields("tpv_shipmentsdate", "tpv_bizdate");// 发货日期
        addFields("tpv_market", "tpv_contractnumber");// 销售合同号
        addFields("tpv_customer", "tpv_customer");// 客户
        addFields("tpv_customers", "tpv_customers");// 本家客户（第三方销售原客户）
        addFields("tpv_partysales", "tpv_partysales");// 本家销售合同（第三方销售原合同）
        addFields("tpv_projectname", "(case when " +
                "tpv_project is not null or tpv_project != '' then tpv_project " +
                "else tpv_abbreviation end)");// 配供项目简称(不确定)
        addFields("tpv_inventorytype", "tpv_inventorytype");// 库存/直运
        addFields("tpv_nopicking", "tpv_nopicking");// 是否免拣配
        addFields("tpv_material", "tpv_materialentry.tpv_dt_salepick_zy.tpv_material_zy");// 商品
        addFields("tpv_prodname", "tpv_materialentry.tpv_dt_salepick_zy.tpv_prodname_zy");// 品名
        addFields("tpv_shader", "tpv_materialentry.tpv_dt_salepick_zy.tpv_shader_zy");// 材质
        addFields("tpv_origin", "tpv_materialentry.tpv_dt_salepick_zy.tpv_origin_zy");// 产地
        addFields("tpv_specation", "tpv_materialentry.tpv_dt_salepick_zy.tpv_specation_zy");// 规格
        addFields("tpv_pickbill_zy", "tpv_materialentry.tpv_dt_salepick_zy.tpv_pickbill_zy");// 配货单据
        addFields("tpv_billno_zy", "tpv_materialentry.tpv_dt_salepick_zy.tpv_billno_zy");// 单据编号
        addFields("tpv_contract", "tpv_materialentry.tpv_dt_salepick_zy.tpv_contractmark_zy");// 配货合同号
        addFields("tpv_supplier_zy", "tpv_materialentry.tpv_dt_salepick_zy.tpv_supplier_zy");// 供应商
        addFields("tpv_volumenumber_zy", "tpv_materialentry.tpv_dt_salepick_zy.tpv_volumenumber_zy");// 卷号
        addFields("tpv_qty", "tpv_materialentry.tpv_dt_salepick_zy.tpv_pickqty_zy");// 数量
        addFields("tpv_packnum", "tpv_materialentry.tpv_dt_salepick_zy.tpv_packnum_zy");// 包装数量
//        addFields("tpv_ofpackages", "tpv_materialentry.tpv_dt_salepick_zy.tpv_packnum_zy");// 包装数量
        addFields("tpv_ofmeasure", "tpv_materialentry.tpv_dt_salepick_zy.tpv_ofmeasure");// 计量单位
        addFields("tpv_ofpackagingunit", "tpv_materialentry.tpv_dt_salepick_zy.tpv_packagingunit_zy");// 包装单位
        addFields("tpv_realsubmit", "tpv_materialentry.tpv_dt_salepick_zy.tpv_practicalok_zy");// 实提完毕
        addFields("tpv_danjutype", "billstatus");//单据状态
        addFields("tpv_packagingunit", "tpv_materialentry.tpv_packagingunit");// 包装单位
        addFields("tpv_unit", "tpv_materialentry.tpv_unit");// 计量单位
        addFields("tpv_qtyrecord", "tpv_materialentry.tpv_qtyrecord");//数量(记录)
        addFields("tpv_qtynumrecord", "tpv_materialentry.tpv_qtynumrecord");//包装数量(记录)
        addFields("tpv_rationtype", "tpv_rationtype");//定量方式
        addFields("tpv_isautoinorder", "tpv_isautoinorder");//自动带入采提
        addFields("tpv_isautoinsales", "tpv_isautoinsales");//自动带入销提
        addFields("tpv_isautosalesout", "tpv_isautosalesout");//自动销售出库
        addFields("tpv_customtags", "tpv_materialentry.tpv_dt_salepick_zy.tpv_customtags_zy");// 自定标签
        addFields("tpv_currency", "tpv_currency");// 结算币别
        addFields("tpv_taxprice", "tpv_materialentry.tpv_taxprice");// 父分录含税单价
        addFields("tpv_taxprice_zy", "tpv_materialentry.tpv_dt_salepick_zy.tpv_taxprice_zy");// 直运合同分录含税单价
        addFields("tpv_department", "tpv_department");//部门
        //addFields("tpv_ofmeasure", "true");// 计量单位
    }

    static {

    }

    private static void addFields(String fieldKey, String fieldKey_bill) {
        fieldKeys_ship.add(fieldKey_bill + " " + fieldKey);
    }
}
