package com.itopview.wm.dt.utils;

import com.itopview.wm.sys.utils.MetaPropertyHelper;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.earlywarn.kit.StringUtil;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.EntryGrid;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 拣配发货-帮助类
 *
 * @author longh
 * @description
 * @date 2023年9月21日
 */
public class PickShipsHelper {

    private final String TPV_DT_RELEVANCEDEALGS = "tpv_dt_relevancedealgs";//关联交易转货单

    /**
     * 拣配
     *
     * @param view
     */
    public static void pickClick(IFormView view) {
        String entityId = view.getEntityId();
        switch (entityId) {
            case "tpv_dt_salesshipping":
                saleShipPick(view);
                break;
            case "tpv_dt_process":
                processPick(view);
                break;
            case "im_otheroutbill":
            case "im_transoutbill":
            case "im_transdirbill":
                saleOutPick(view);
                break;
            case "tpv_dt_noconfiguration":
                deskPick(view);
                break;
            case "tpv_dt_inventoryconfigura"://库存拣配业务实提工作台
                deskPickIn(view);
                break;
            case "im_purinbill":
                purinBill(view);
                break;
            case "tpv_dt_relevancedealgs":
                relevanceShipPick(view);
                break;
            case "tpv_dt_configuranew"://库存拣配业务实提工作台(新)
                deskPickInNew(view);
                break;
            default:
                break;
        }
    }

    private static void deskPick(IFormView view) {
        IDataModel model = view.getModel();
        OperationResult saveOperate = view.invokeOperation("save", YEM.getOptionNoMsg());
        if (!saveOperate.isSuccess()) {
            view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
            return;
        }
        DynamicObject dataEntity = model.getDataEntity(true);
        QFilter qFilter = new QFilter("tpv_materialentry", QCP.equals, dataEntity.getPkValue());
        String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
        DynamicObject billHead = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
        ;//需查询
        List<String> notInputs = new ArrayList<>();
        Map<String, Object> param = new HashMap<>();
        param.put("picktype", "tpv_dt_noconfiguration");//库存免拣配工作台
        param.put("pkid", dataEntity.getPkValue());
        param.put("org", getNotNull(view, notInputs, billHead, "org"));
        param.put("tpv_inventorytype", getNotNull(view, notInputs, billHead, "tpv_inventorytype"));
        param.put("tpv_combina", getNotNull(view, notInputs, billHead, "tpv_combina"));
        param.put("tpv_material", getNotNull(view, notInputs, dataEntity, "tpv_material"));
        param.put("tpv_qty", getNotNull(view, notInputs, dataEntity, "tpv_qty"));
        param.put("tpv_packnum", dataEntity.getBigDecimal("tpv_packnum"));
        param.put("tpv_prodname", getNotNull(view, notInputs, dataEntity, "tpv_prodname"));
        // param.put("tpv_specation", getNotNull(notInputs, row, "tpv_specation"));
        // param.put("tpv_shader", getNotNull(notInputs, row, "tpv_shader"));
        // param.put("tpv_origin", getNotNull(notInputs, row, "tpv_origin"));
        param.put("tpv_specation", dataEntity.get("tpv_specation"));
        param.put("tpv_shader", dataEntity.get("tpv_shader"));
        param.put("tpv_origin", dataEntity.get("tpv_origin.id"));
        param.put("tpv_cargobatchqty", dataEntity.get("tpv_cargobatchqty"));
        param.put("tpv_entrepot", getNotNull(view, notInputs, dataEntity, "tpv_entrepotfl"));//仓库
        if (notInputs.size() > 0) {
            view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
        } else {
            showPickForm(view, param);
        }
    }

    private static void saleOutPick(IFormView view) {
        IDataModel model = view.getModel();
        OperationResult saveOperate = view.invokeOperation("save", YEM.getOptionNoMsg());
        if (!saveOperate.isSuccess()) {
            view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
            return;
        }
        DynamicObject dataEntity = model.getDataEntity(true);
        List<String> notInputs = new ArrayList<>();
        Map<String, Object> param = new HashMap<>();
        param.put("picktype", "multibill");
        param.put("pkid", dataEntity.getPkValue());
        if (dataEntity.getDynamicObjectType().getName().equals("im_transdirbill")) {
            //如果是直接调拨单根据调出部门过滤
            param.put("org", getNotNull(view, notInputs, dataEntity, "org"));//调出组织
            param.put("outdept", getNotNull(view, notInputs, dataEntity, "outdept"));//调出部门
            param.put("tpv_warehouse", getNotNull(view, notInputs, dataEntity, "tpv_entrepot"));//仓库
            param.put("juge", "2");
        } else if (dataEntity.getDynamicObjectType().getName().equals("im_transoutbill")) {
            //如果是分步调出单根据调出部门过滤
            param.put("org", getNotNull(view, notInputs, dataEntity, "org"));
            param.put("tpv_warehouse", getNotNull(view, notInputs, dataEntity, "tpv_entrepot"));//仓库
            param.put("juge", "2");
        } else {
            param.put("org", getNotNull(view, notInputs, dataEntity, "org"));
            param.put("juge", "1");
        }
        param.put("tpv_inventorytype", "A");
        if (notInputs.size() > 0) {
            view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
        } else {
            showPickForm(view, param);
        }
    }


    /**
     * 采购入库单拣配操作
     *
     * @param view
     */
    private static void purinBill(IFormView view) {
        IDataModel model = view.getModel();
        OperationResult saveOperate = view.invokeOperation("save", YEM.getOptionNoMsg());
        if (!saveOperate.isSuccess()) {
            view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
            return;
        }
        DynamicObject dataEntity = model.getDataEntity(true);
        List<String> notInputs = new ArrayList<>();
        Map<String, Object> param = new HashMap<>();
        param.put("picktype", "im_purinbill");
        param.put("pkid", dataEntity.getPkValue());
        param.put("org", getNotNull(view, notInputs, dataEntity, "org"));
        param.put("tpv_inventorytype", "A");
        param.put("tpv_supplier", getNotNull(view, notInputs, dataEntity, "supplier"));
        DynamicObject tpvDepartment = dataEntity.getDynamicObject("bizdept");
        param.put("tpv_department", tpvDepartment != null ? (long) tpvDepartment.getPkValue() : 0l);
        if (notInputs.size() > 0) {
            view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
        } else {
            showPickForm(view, param);
        }
    }

    private static void deskPickIn(IFormView view) {
        IDataModel model = view.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        EntryGrid entry = view.getControl("tpv_entryentity");
        int selectRows = entry.getSelectRows().length;
        if (selectRows > 1) {
            view.showTipNotification("只能选择一行数据进行操作。");
        }
        if (selectRows == 0) {
            view.showTipNotification("未选择数据。");
        }
        if (selectRows == 1) {
            int index = entry.getSelectRows()[0];
            DynamicObject row = model.getEntryRowEntity("tpv_entryentity", index);
            //获取到父分录id
            String tpv_srcentryid = row.getString("tpv_srcentryid");
            long srcentryid = Long.parseLong(tpv_srcentryid);
            QFilter qFilter = new QFilter("tpv_materialentry", QCP.equals, srcentryid);
            String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
            DynamicObject billHead = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
            ;//需查询
            billHead = BusinessDataServiceHelper.loadSingle(billHead.getPkValue(),
                    billHead.getDynamicObjectType().getName());
            DynamicObject rowS = null;
            DynamicObjectCollection objectCollection = billHead.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject dynamicObject : objectCollection) {
                long id = (Long) dynamicObject.get("id");
                if (id == srcentryid) {
                    rowS = dynamicObject;
                }
            }
            OperationResult saveT = OperationServiceHelper.executeOperate("save", "tpv_dt_salesshipping",
                    new DynamicObject[]{billHead}, YEM.getOptionNoMsg());
            //OperationResult saveOperate = view.invokeOperation("save", YEM.getOptionNoMsg());
            if (!saveT.isSuccess()) {
                view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveT));
                return;
            }
            List<String> notInputs = new ArrayList<>();
            Map<String, Object> param = new HashMap<>();
            param.put("picktype", "tpv_dt_inventoryconfigura");//库存拣配业务实提工作台
            param.put("pkid", srcentryid);
            param.put("org", getNotNull(view, notInputs, billHead, "org"));
            param.put("tpv_inventorytype", getNotNull(view, notInputs, billHead, "tpv_inventorytype"));
            param.put("tpv_combina", getNotNull(view, notInputs, billHead, "tpv_combina"));
            param.put("tpv_material", getNotNull(view, notInputs, rowS, "tpv_material"));
            param.put("tpv_qty", getNotNull(view, notInputs, rowS, "tpv_qty"));
            param.put("tpv_prodname", getNotNull(view, notInputs, rowS, "tpv_prodname"));
            param.put("tpv_specation", rowS.get("tpv_specation"));
            param.put("tpv_shader", rowS.get("tpv_shader"));
            param.put("tpv_origin", rowS.get("tpv_origin.id"));
            param.put("tpv_cargobatchqty", rowS.get("tpv_cargobatchqty"));
            if (notInputs.size() > 0) {
                view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
            } else {
                showPickForm(view, param);
            }
        }
    }

    private static void deskPickInNew(IFormView view) {
        IDataModel model = view.getModel();
        //OperationResult saveOperate = view.invokeOperation("save", YEM.getOptionNoMsg());
        /*if (!saveOperate.isSuccess()) {
            view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
            return;
        }*/
        DynamicObject dataEntity = model.getDataEntity(true);
        QFilter qFilter = new QFilter("tpv_materialentry", QCP.equals, dataEntity.getPkValue());
        String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
        DynamicObject billHead = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
        ;//需查询
        List<String> notInputs = new ArrayList<>();
        Map<String, Object> param = new HashMap<>();
        param.put("picktype", "tpv_dt_configuranew");//库存拣配工作台(新)
        param.put("pkid", dataEntity.getPkValue());
        param.put("org", getNotNull(view, notInputs, billHead, "org"));
        param.put("tpv_inventorytype", getNotNull(view, notInputs, billHead, "tpv_inventorytype"));
        param.put("tpv_combina", getNotNull(view, notInputs, billHead, "tpv_combina"));
        param.put("tpv_material", getNotNull(view, notInputs, dataEntity, "tpv_material"));
        param.put("tpv_qty", getNotNull(view, notInputs, dataEntity, "tpv_qty"));
        param.put("tpv_packnum", dataEntity.getBigDecimal("tpv_packnum"));
        param.put("tpv_prodname", getNotNull(view, notInputs, dataEntity, "tpv_prodname"));
        param.put("tpv_specation", dataEntity.get("tpv_specation"));
        param.put("tpv_shader", dataEntity.get("tpv_shader"));
        param.put("tpv_origin", dataEntity.get("tpv_origin.id"));
        param.put("tpv_cargobatchqty", dataEntity.get("tpv_cargobatchqty"));
        param.put("tpv_entrepot", getNotNull(view, notInputs, dataEntity, "tpv_entrepotfl"));//仓库
        if (notInputs.size() > 0) {
            view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
        } else {
            showPickForm(view, param);
        }
    }

    /**
     * 关联交易转货单拣配
     *
     * @param view
     */
    private static void relevanceShipPick(IFormView view) {
        IDataModel model = view.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        EntryGrid entry = view.getControl("tpv_dt_goodstransfe_zh");
        int selectRows = entry.getSelectRows().length;
        if (selectRows > 1) {
            view.showTipNotification("只能选择一行数据进行操作。");
        }
        if (selectRows == 0) {
            view.showTipNotification("未选择数据。");
        }
        if (selectRows == 1) {
            OperationResult saveOperate = view.invokeOperation("save", YEM.getOptionNoMsg());
            if (!saveOperate.isSuccess()) {
                view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
                return;
            }
            int index = entry.getSelectRows()[0];
            DynamicObject row = model.getEntryRowEntity("tpv_dt_goodstransfe_zh", index);
            List<String> notInputs = new ArrayList<>();
            Map<String, Object> param = new HashMap<>();
            param.put("picktype", "tpv_dt_relevancedealgs");//关联交易转货单拣配
            param.put("pkid", row.getPkValue());
            param.put("org", getNotNull(view, notInputs, dataEntity, "org"));
            //param.put("tpv_entrepot", getNotNull(view, notInputs, dataEntity, "tpv_entrepot"));//仓库
            param.put("tpv_combina", getNotNull(view, notInputs, dataEntity, "tpv_newmarket"));//新销售组合号
            param.put("tpv_material", getNotNull(view, notInputs, row, "tpv_material"));//商品编码
            param.put("tpv_qty", getNotNull(view, notInputs, row, "tpv_transferqty"));//转货数量
            param.put("tpv_inventorytype", "A");//库存
            param.put("tpv_prodname", getNotNull(view, notInputs, row, "tpv_prodname"));//品名
            param.put("tpv_specation", row.get("tpv_specation"));//规格
            param.put("tpv_shader", row.get("tpv_shader"));//材质
            param.put("tpv_origin", row.get("tpv_origin.id"));//产地
            DynamicObject tpvDepartment = dataEntity.getDynamicObject("tpv_department");
            param.put("tpv_department", tpvDepartment != null ? (long) tpvDepartment.getPkValue() : 0l);
            if (notInputs.size() > 0) {
                view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
            } else {
                showPickForm(view, param);
            }
        }
    }

    private static void processPick(IFormView view) {
        IDataModel model = view.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        EntryGrid entry = view.getControl("tpv_materialentry");
        int selectRows = entry.getSelectRows().length;
        if (selectRows > 1) {
            view.showTipNotification("只能选择一行数据进行操作。");
        }
        if (selectRows == 0) {
            view.showTipNotification("未选择数据。");
        }
        if (selectRows == 1) {
            OperationResult saveOperate = view.invokeOperation("save", YEM.getOptionNoMsg());
            if (!saveOperate.isSuccess()) {
                view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
                return;
            }
            int index = entry.getSelectRows()[0];
            DynamicObject row = model.getEntryRowEntity("tpv_materialentry", index);
            List<String> notInputs = new ArrayList<>();
            Map<String, Object> param = new HashMap<>();
            param.put("picktype", "tpv_dt_process");
            param.put("pkid", row.getPkValue());
            param.put("org", getNotNull(view, notInputs, dataEntity, "org"));
            param.put("tpv_specation", row.get("tpv_specation"));
            param.put("tpv_shader", row.get("tpv_shader"));
            param.put("tpv_origin", row.get("tpv_origin.id"));
            param.put("tpv_customtags", row.get("tpv_customtags"));
            param.put("tpv_inventorytype", "A");
            param.put("tpv_combina", getNotNull(view, notInputs, dataEntity, "tpv_combinationnumber"));
            param.put("tpv_material", getNotNull(view, notInputs, row, "tpv_material"));
            param.put("tpv_qty", getNotNull(view, notInputs, row, "tpv_qty"));
            param.put("tpv_packnum", row.getBigDecimal("tpv_packnum"));
            param.put("tpv_prodname", getNotNull(view, notInputs, row, "tpv_prodname"));
            DynamicObject tpvDepartment = dataEntity.getDynamicObject("tpv_department");
            param.put("tpv_department", tpvDepartment != null ? (long) tpvDepartment.getPkValue() : 0l);
            param.put("tpv_supplier", getNotNull(view, notInputs, dataEntity, "tpv_supplier"));
            if (notInputs.size() > 0) {
                view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
            } else {
                showPickForm(view, param);
            }
        }
    }

    private static void saleShipPick(IFormView view) {
        IDataModel model = view.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        EntryGrid entry = view.getControl("tpv_materialentry");
        int selectRows = entry.getSelectRows().length;
        String tpv_inventorytype = (String) model.getValue("tpv_inventorytype");//库存/直运
        Boolean tpv_nopicking = (Boolean) model.getValue("tpv_nopicking");//是否免拣配
        //如果库存直运为库存并且是否免拣配为是的时候不让拣配
        if ("A".equals(tpv_inventorytype) && tpv_nopicking) {
            view.showTipNotification("库存/直运为库存并且是否免拣配为是时不可拣配");
        } else {
//            if (selectRows > 1) {
//                view.showTipNotification("只能选择一行数据进行操作。");
//            }
//            if (selectRows == 0) {
//                view.showTipNotification("未选择数据。");
//            }
//            if (selectRows == 1) {
            OperationResult saveOperate = view.invokeOperation("save", YEM.getOptionNoMsg());
            if (!saveOperate.isSuccess()) {
                view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
                return;
            }
//                int index = entry.getSelectRows()[0];
//                DynamicObject row = model.getEntryRowEntity("tpv_materialentry", index);
            List<String> notInputs = new ArrayList<>();
            Map<String, Object> param = new HashMap<>();
            String tpvYesnoinseries = dataEntity.getString("tpv_yesnoinseries");
            if (StringUtil.isNotEmpty(tpvYesnoinseries)) {
                param.put("tpv_yesnoinseries", "1");
            } else {
                param.put("tpv_yesnoinseries", null);
            }
            dataEntity.set("tpv_yesnoinseries", null);
            SaveServiceHelper.update(dataEntity);// 写入数据库
            param.put("picktype", "tpv_dt_salesshipping");
            param.put("billid", dataEntity.getPkValue());
            DynamicObject tpvBusiness = dataEntity.getDynamicObject("tpv_business");
            if (YEM.isNotEmpty(tpvBusiness)) {
                if ("YWLX-240325-0007".equals(tpvBusiness.getString("number"))) {
                    param.put("salecon", String.valueOf(dataEntity.getLong("tpv_sourcebillid")));
                } else {
                    param.put("salecon", "");
                }
            } else {
                param.put("salecon", "");
            }
//                param.put("pkid", row.getPkValue());
            param.put("org", getNotNull(view, notInputs, dataEntity, "org"));
//                if ("A".equals(tpv_inventorytype)) {
            param.put("tpv_entrepot", getNotNull(view, notInputs, dataEntity, "tpv_entrepot"));//仓库
//                param.put("tpv_specation", row.get("tpv_specation"));
//                param.put("tpv_shader", row.get("tpv_shader"));
//                param.put("tpv_origin", row.get("tpv_origin.id"));
//                param.put("tpv_customtags", row.get("tpv_customtags"));
//            }
//                if ("B".equals(tpv_inventorytype)) {
//                    param.put("tpv_specation", "");
//                    param.put("tpv_shader", "");
//                    param.put("tpv_origin", 0L);
//                    param.put("tpv_customtags", "");
//                }
            param.put("tpv_inventorytype", getNotNull(view, notInputs, dataEntity, "tpv_inventorytype"));
            DynamicObject tpvBilltype = dataEntity.getDynamicObject("tpv_billtype");
            if (!"tpv_dt_salesshipping_LS".equals(tpvBilltype.getString("number"))) {
                param.put("tpv_combina", getNotNull(view, notInputs, dataEntity, "tpv_combina"));
            } else {
                DynamicObject tpvCombina = dataEntity.getDynamicObject("tpv_combina");
                long tpvCombinaId = tpvCombina != null ? tpvCombina.getLong("id") : 0l;
                param.put("tpv_combina", tpvCombinaId);
            }
//            param.put("tpv_material", getNotNull(view, notInputs, row, "tpv_material"));
            dataEntity = model.getDataEntity(true);
            boolean tpvPickqtybox = dataEntity.getBoolean("tpv_pickqtybox"); //按拣配反写数量
            param.put("tpv_pickqtybox", tpvPickqtybox);
            if (tpvPickqtybox) {
//                param.put("tpv_qty", row.getBigDecimal("tpv_qty"));
            } else {
//                param.put("tpv_qty", getNotNull(view, notInputs, row, "tpv_qty"));
            }
            boolean tpvPickamtbox = dataEntity.getBoolean("tpv_pickamtbox");
            param.put("tpv_pickamtbox", tpvPickamtbox);
//            param.put("tpv_packnum", row.getBigDecimal("tpv_packnum"));
//            param.put("tpv_qtynumrecord", row.getBigDecimal("tpv_qtynumrecord"));
//            param.put("tpv_qtyrecord", row.getBigDecimal("tpv_qtyrecord"));
//            param.put("tpv_prodname", getNotNull(view, notInputs, row, "tpv_prodname"));
            // param.put("tpv_specation", getNotNull(notInputs, row, "tpv_specation"));
            // param.put("tpv_shader", getNotNull(notInputs, row, "tpv_shader"));
            // param.put("tpv_origin", getNotNull(notInputs, row, "tpv_origin"));
            DynamicObject tpvDepartment = dataEntity.getDynamicObject("tpv_department");
            param.put("tpv_department", tpvDepartment != null ? (long) tpvDepartment.getPkValue() : 0l);
            if (notInputs.size() > 0) {
                view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
            } else {
                showPickForm(view, param);
            }
//        }
        }

    }

    private static void showPickForm(IFormView view, Map<String, Object> param) {
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId("tpv_dt_pickships");
        showParameter.setCustomParams(param);
        view.showForm(showParameter);
    }

    public static Object getNotNull(IFormView view, List<String> list, DynamicObject dt, String fieldKey) {
        String name = MetaPropertyHelper.getEntityLangName(view.getEntityId(), fieldKey);
        Object propValue = dt.get(fieldKey);
        if (propValue == null) {
            list.add(name);
        } else if (propValue instanceof BigDecimal && ((BigDecimal) propValue).compareTo(BigDecimal.ZERO) == 0) {
            list.add(name);
        } else if (propValue instanceof String && ((String) propValue).isEmpty()) {
            list.add(name);
        } else if (propValue instanceof Integer && ((Integer) propValue).intValue() == 0) {
            list.add(name);
        } else if (propValue instanceof Long && ((Long) propValue).longValue() == 0L) {
            list.add(name);
        } else if (propValue instanceof DynamicObjectCollection && ((DynamicObjectCollection) propValue).size() == 0) {
            list.add(name);
        }
        if (propValue instanceof DynamicObject) {
            propValue = ((DynamicObject) propValue).getPkValue();
        }
        return propValue;
    }

}
