package com.itopview.wm.sc.formplugin.dynamic;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.plugin.AbstractFormPlugin;

import java.util.EventObject;

/**
 * @Description: 期货公司过滤银行账户弹框 -动态表单
 * @Author LinRui
 * @Date 2024/8/9 17:53
 */
public class BanknoEdit extends AbstractFormPlugin {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok"});
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IDataModel parentModel = this.getView().getParentView().getModel();
        DynamicObject futurescompanies = (DynamicObject) parentModel.getValue("tpv_futurescompanies");//获取期货公司
        if (futurescompanies != null) {
            DynamicObjectCollection entrys = futurescompanies.getDynamicObjectCollection("entry_bank");// 获取银行信息的单据体
            for (DynamicObject entry : entrys) {// 循环单据体
                int newEntryRow = this.getModel().createNewEntryRow("tpv_entryentity");
                DynamicObject bank = entry.getDynamicObject("bank");
                String bankaccount = entry.getString("bankaccount");
                this.getModel().setValue("tpv_bankaccount", bankaccount, newEntryRow);
                this.getModel().setValue("tpv_bank", bank, newEntryRow);
            }
        }
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
                EntryGrid entryGrid = (EntryGrid) this.getView().getControl("tpv_entryentity");
                int[] selectRows = entryGrid.getSelectRows();
                if (selectRows.length == 1) {
                    IFormView parentView = this.getView().getParentView();
                    int index = this.getModel().getEntryCurrentRowIndex("tpv_entryentity");
                    DynamicObject dynamicObject = this.getModel().getEntryRowEntity("tpv_entryentity", index);
                    parentView.getModel().setValue("tpv_theotherbank", dynamicObject.getString("tpv_bankaccount"));
                    this.getView().sendFormAction(parentView);
                    this.getView().close();
                    break;
                } else {
                    this.getView().showTipNotification("必须选择一行数据！");
                }
            default:
                break;
        }
    }
}
