package com.itopview.wm.sc.formplugin.dynamic;

/**
 * @ClassName HairFormPlugin
 * @Description TODO
 * @Author yhj
 * @Date 2023/9/26 17:07
 * @Version 1.0
 */
import com.itopview.wm.utils.YEM;
import org.apache.commons.lang3.StringUtils;
import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

public class HairFormPlugin extends AbstractBillPlugIn {

    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addClickListeners("btncancel","btnok");  //监听取消和确定按钮
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        IDataModel model = this.getModel();
        Control source = (Control) evt.getSource();
        if (StringUtils.equals(source.getKey(), "btnok")) {
            HashMap<String,Object> hashMap = new HashMap<>();
            //如果被点击控件为确认，则获取页面相关控件值，组装数据传入returnData返回给父页面，最后关闭页面
            String sendingpaths = (String) model.getValue("tpv_sendingpaths");
            DynamicObject apis = (DynamicObject) model.getValue("tpv_interface");
            String faxs = (String) model.getValue("tpv_faxs");
            String eaddresss = (String) model.getValue("tpv_eaddresss");
            String specifications = (String) model.getValue("tpv_specifications");
            Boolean defaults = (Boolean) model.getValue("tpv_defaults");
            // 判断获得的各项数据
            if (sendingpaths != null) {
                hashMap.put("tpv_sendingpaths",sendingpaths);
            }
            if (apis != null) {
                hashMap.put("tpv_interface", String.valueOf(apis.getLong("id")));
            }
            if (faxs != null) {
                hashMap.put("tpv_faxs",faxs);
            }
            if (eaddresss != null) {
                hashMap.put("tpv_eaddresss", eaddresss);
            }
            if (specifications != null) {
                hashMap.put("tpv_specifications", specifications);
            }
            if (defaults != null) {
                hashMap.put("tpv_defaults", defaults);
            }
            this.getView().returnDataToParent(hashMap);//将数据传给父页面
            this.getView().close();
        } else if (StringUtils.equals(source.getKey(),"btncancel")) {
            //被点击控件为取消则设置返回值为空并关闭页面（在页面关闭回调方法中必须验证返回值不为空，否则会报空指针）
            this.getView().returnDataToParent(null);
            this.getView().close();
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IDataModel model = this.getModel();
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String,Object> map = new HashMap<>();
        map = showParameter.getCustomParams();//获取map表
        Long entrepot = (Long) map.get("tpv_entrepot");//仓库
        QFilter[] qFiltere = new QFilter[]{new QFilter("id", QCP.equals, entrepot)};
        String selectfieldes = DynamicObjectUtil.getSelectfieldsFast("bd_warehouse", "tpv_sendmode");//过滤来源单据编码的采购合同
        DynamicObject[] queryCK = BusinessDataServiceHelper.load("bd_warehouse", selectfieldes, qFiltere);
        for (DynamicObject obj:queryCK) {
            DynamicObjectCollection tpvSendmode = obj.getDynamicObjectCollection("tpv_sendmode");
            for (DynamicObject obs:tpvSendmode) {
                int newEntryRow = this.getModel().createNewEntryRow("tpv_advconaps");//分录
                model.setValue("tpv_sendingpaths",obs.getString("tpv_sendingpath"),newEntryRow);//发送途径
                model.setValue("tpv_interface", YEM.isNotEmpty(obs.getDynamicObject("tpv_interface"))
                        ? obs.getDynamicObject("tpv_interface") : null ,newEntryRow);//API
                model.setValue("tpv_faxs",obs.getString("tpv_fax"),newEntryRow);//传真号
                model.setValue("tpv_eaddresss",obs.getString("tpv_eaddress"),newEntryRow);//邮箱地址
                model.setValue("tpv_defaults",obs.getBoolean("tpv_default"),newEntryRow);//设置默认
                model.setValue("tpv_specifications",obs.getString("tpv_specification"),newEntryRow);//途径说明
            }
        }
    }


}
