package com.itopview.wm.sc.formplugin.form;

import com.itopview.wm.utils.DateUtil;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.property.ComboProp;
import kd.bos.form.IFormView;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.scm.common.util.DynamicObjectUtil;

import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.EventObject;

/**
 * @ClassName FundsusedFormPlugin
 * @Description 资金占用
 * @Author yhj
 * @Date 2023/9/20 17:14
 * @Version 1.0
 */
public class FundsusedFormPlugin extends AbstractBillPlugIn {
    private static DateFormat format = new SimpleDateFormat("yyyy");
    private static DateFormat formats = new SimpleDateFormat("yyyy-MM-dd");

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_advcontoolbarap");
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        super.itemClick(evt);
        String key = evt.getItemKey();
        if (StringUtils.equals("tpv_advconbaritemap", key)) {//生成部门资金占用明细
            this.getModel().deleteEntryData("tpv_sc_fundsused_aa");
            utilize();
        }
        if (StringUtils.equals("tpv_advconbaritemaps", key)) {//删除部门资金占用明细
            this.getModel().deleteEntryData("tpv_sc_fundsused_aa");
        }
    }

    private void utilize() {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        DynamicObject org = (DynamicObject) model.getValue("org");
        Date year = (Date) model.getValue("tpv_year");
        String month = (String) model.getValue("tpv_month");
        String bizdate = formatDate(year);
        String joint = bizdate + "-" + month + "-" + "01";
        Date years = parseDate(joint);
        Date time = DateUtil.getMonthFirstDay(years);
        Date times = DateUtil.getMonthEndDay(years);
        QFilter qFilter1 = new QFilter("enable", QCP.equals, "1");
        if (org != null) {
            long id = org.getLong("id");
            qFilter1.and(new QFilter("createorg.id", QCP.equals, id));
            if (year != null) {
                qFilter1.and(new QFilter("tpv_enddate", QCP.large_equals, time));
                qFilter1.and(new QFilter("tpv_lastdate", QCP.less_equals, times));
            }
            BigDecimal interest = BigDecimal.ZERO;
            BigDecimal income = BigDecimal.ZERO;
            BigDecimal percent = BigDecimal.valueOf(100);
            BigDecimal period = BigDecimal.ZERO;
            QFilter[] array = qFilter1.toArray();
            String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_zjzyll", false);
            DynamicObject[] queryHW = BusinessDataServiceHelper.load("tpv_zjzyll", selectFieid2, array);////资金利用
            String selectfieldsFast = com.itopview.wm.utils.DynamicObjectUtil.getSelectfieldsFast("tpv_sc_voucher", "tpv_sc_voucher_aa");
            DynamicObject[] queryZZ = BusinessDataServiceHelper.load("tpv_sc_voucher", selectfieldsFast, null);//总账
            for (DynamicObject billus : queryHW) {  //《资金占用调整》中【计息类别】相对应的【资金收入】
                DynamicObject tpvDepertment = billus.getDynamicObject("tpv_depertment");
                QFilter[] qFilters = new QFilter[]{new QFilter("tpv_sc_adjustment.tpv_depertment", QCP.equals, tpvDepertment.getLong("id")),
                        new QFilter("createorg.id", QCP.equals, id),//创建组织和公司一致
                        new QFilter("tpv_category.number", QCP.not_equals, null)};//计息类别不等于空
                String selectFieids = DynamicObjectUtil.getSelectfields("tpv_sc_adjustment", false);
                DynamicObject[] queryZY = BusinessDataServiceHelper.load("tpv_sc_adjustment", selectFieids, qFilters);//资金调整
                for (DynamicObject var : queryZY) {
                    DynamicObject tpvCategory = var.getDynamicObject("tpv_category");
                    if ("01".equals(tpvCategory.getString("number"))) {  //计息类别等于现款
                        income = income.add(var.getBigDecimal("tpv_income"));
                    }
                    if ("02".equals(tpvCategory.getString("number"))) {  //计息类别等于应收票据（银承）
                        income = income.add(var.getBigDecimal("tpv_income"));
                    }
                    if ("03".equals(tpvCategory.getString("number"))) {  //计息类别等于应付票据（银承）
                        income = income.add(var.getBigDecimal("tpv_income"));
                    }
                    if ("04".equals(tpvCategory.getString("number"))) {  //计息类别等于应收票据（商票）
                        income = income.add(var.getBigDecimal("tpv_income"));
                    }
                    if ("05".equals(tpvCategory.getString("number"))) {  //计息类别等于应付票据（商票）
                        income = income.add(var.getBigDecimal("tpv_income"));
                    }
                    if ("06".equals(tpvCategory.getString("number"))) {  //计息类别等于供应链票据
                        income = income.add(var.getBigDecimal("tpv_income"));
                    }
                }
                for (DynamicObject bill : queryZZ) {
                    DynamicObjectCollection voucher = bill.getDynamicObjectCollection("tpv_sc_voucher_aa");
                    for (DynamicObject bills : voucher) {
                        if (bills.getDynamicObject("tpv_dept").getString("number").equals(tpvDepertment.getString("number"))) {
                            BigDecimal debitlocal = bills.getBigDecimal("tpv_debitlocal");//借方
                            BigDecimal creditlocal = bills.getBigDecimal("tpv_creditlocal");//贷方
                            int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_fundsused_aa");//财务分录
                            model.setValue("tpv_add", debitlocal, newEntryRow);
                            model.setValue("tpv_reduce", creditlocal, newEntryRow);
                            model.setValue("tpv_company", bill.getDynamicObject("tpv_orgs").getLong("id"), newEntryRow);
                            BigDecimal ccupied = period.add(debitlocal).subtract(creditlocal).add(income);
                            for (DynamicObject vars : queryZY) {  //特殊利息，先算占用金额
                                DynamicObject tpvCategorys= vars.getDynamicObject("tpv_category");
                                if ("03".equals(tpvCategorys.getString("number")) || "05".equals(tpvCategorys.getString("number"))) {    //计息类别等于应付票据（银承）
                                    ccupied=period.add(creditlocal).subtract(debitlocal).add(income);
                                    model.setValue("tpv_occupied", ccupied, newEntryRow);
                                }
                            }
                                BigDecimal dayrate = billus.getBigDecimal("tpv_dayrate");//日利率
                                dayrate = dayrate.divide(percent);
                                BigDecimal deoccupyrate = billus.getBigDecimal("tpv_deoccupyrate");//负占用利率(%)
                                deoccupyrate = deoccupyrate.divide(percent);
                                if (ccupied.compareTo(BigDecimal.ZERO) > 0) {
                                    interest = ccupied.multiply(dayrate);
                                    model.setValue("tpv_interest", interest, newEntryRow);
                                }
                                if (ccupied.compareTo(BigDecimal.ZERO) < 0) {
                                    interest = ccupied.multiply(deoccupyrate);
                                    model.setValue("tpv_interest", interest, newEntryRow);
                                }
                            model.setValue("tpv_occupied", ccupied, newEntryRow);
                            model.setValue("tpv_businessdate", bill.getDate("tpv_bizdate"), newEntryRow);
                            model.setValue("tpv_depertment", bills.getDynamicObject("tpv_dept").getLong("id"), newEntryRow);
                        }
                    }
                }
            }
        }
    }

    public static String formatDate(Date date) {
        String datestr = "";
        if (date != null) {
            datestr = format.format(date);
        }
        return datestr;
    }

    /**
     * @description: 获取下拉列表的标题
     * @author yhj
     * @date 2023/9/4 10:51
     * @version 1.0
     * obs 标识
     * obj 标识所在单据或分录的数据包
     */
    private static String extracted(DynamicObject obj, String obs) { //获取下拉列表v,获取标题方法
        MainEntityType mainEntityType = (MainEntityType) obj.getDataEntityType();//获取主实体
        DataEntityPropertyCollection properties = mainEntityType.getProperties();//获取属性
        ComboProp comboUnitProp = (ComboProp) properties.get(obs);//获取字段的数据模型
        String comb = comboUnitProp.getItemByName(obj.getString(obs));//根据value获取key（标题）
        return comb;
    }

    /**
     * 字符串转时间 格式yyyy-MM-dd
     *
     * @param datestr
     * @return
     */
    public static Date parseDate(String datestr) {
        Date date = null;
        if (datestr != null && !datestr.isEmpty() && !"null".equals(datestr)) {
            try {
                date = formats.parse(datestr);
            } catch (ParseException e) {
                e.printStackTrace();
            }
        }
        return date;
    }
}
