package com.itopview.wm.sc.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.IFormView;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;

import java.util.EventObject;

import com.itopview.wm.utils.YEM;

/**
 * @Description 内部费率 内部费用项目带出单据类型，过滤当前内部费用项目
 * @Author LinRui
 * @Date 2023/8/30 11:29
 **/
public class InFeesRateFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

	@Override
	public void afterBindData(EventObject e) {
		super.afterBindData(e);
		this.getView().setEnable(false,"tpv_billtype"); //锁定字段
	}

	@Override
	public void propertyChanged(PropertyChangedArgs e) {
		super.propertyChanged(e);
		ChangeData[] changeData = e.getChangeSet();
		int rowIndex = changeData[0].getRowIndex();
		String key = e.getProperty().getName();
		switch (key) {
		case "tpv_interiorfeeitem":
			IFormView view = this.getView();
			IDataModel model = this.getModel();
			
//			DynamicObject dataEntity = model.getDataEntity(true);
//			dataEntity.set("tpv_billtype", 1762288739012373504L);
//			this.getView().updateView("tpv_billtype");

			DynamicObject tpv_interiorfeeitem = (DynamicObject)this.getModel().getValue("tpv_interiorfeeitem");
			DynamicObject tpv_itemtype = (DynamicObject)tpv_interiorfeeitem.getDynamicObject("tpv_itemtype");
			model.beginInit();
			model.setValue("tpv_billtype", tpv_itemtype);//1762288739012373504L
			model.endInit();
			 this.getView().updateView("tpv_billtype");
//			view.updateView();
			view.invokeOperation("save", YEM.getOptionNoMsg());
//			view.invokeOperation("refresh");

			break;
		default:
			break;
		}
	}

	@Override
	public void registerListener(EventObject e) {
		super.registerListener(e);
	}

	@Override
	public void beforeF7Select(BeforeF7SelectEvent beforeF7SelectEvent) {

	}

}
