package com.itopview.wm.sc.formplugin.list;

import com.alibaba.druid.util.StringUtils;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.list.BillList;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.coderule.CodeRuleServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import java.text.SimpleDateFormat;
import java.util.*;
/**
 * @author LiuHB
 * @version 1.0
 *  点击生成结算按钮生成手续费结算单
 */
public class InterExpensesPlugin extends AbstractListPlugin {

    private final static String KEY_MBAR = "tbmain";//工具栏

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tbmain", "advcontoolbarap");
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey();
        if (StringUtils.equals("tpv_settinfor", itemKey)) {
            // 创建弹出动态表单页面对象
            FormShowParameter showParameter = new FormShowParameter();
            // 设置弹出页面的标识
            showParameter.setFormId("tpv_sc_backfillplugin");
            // 状态
            showParameter.setStatus(OperationStatus.ADDNEW);
            // 设置页面关闭回调方法
            showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_settinfor"));
            // 设置弹出页面打开方式
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            // 打开动态表单
            this.getView().showForm(showParameter);
        }
    }

    public void sethandfeeset(ArrayList<HashMap<String, Object>> list) {
        for (HashMap<String, Object> hashMap : list) {
            //新建一条单据
            DynamicObject data = BusinessDataServiceHelper.newDynamicObject("tpv_sc_handfeeset");
            String number = CodeRuleServiceHelper.getNumber("tpv_sc_handfeeset", data, null);
            Long currentUserId = UserServiceHelper.getCurrentUserId();
            //日期
            //时间格式
            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd ");
            //获取当前时间
            Date date = new Date(System.currentTimeMillis());
            //当前用户所属组织
            Long mainOrgId = UserServiceHelper.getUserMainOrgId(currentUserId);
            data.set("billstatus", "A");
            data.set("billno", number);
            //原单单据
            data.set("tpv_oridocument", hashMap.get("tpv_oridocument"));
            //原单单据编号
            data.set("tpv_oribillno", hashMap.get("tpv_oribillno"));
            //公司
            data.set("org", mainOrgId);
            //部门
            data.set("tpv_department", hashMap.get("tpv_department"));
            //原单据业务员
            data.set("tpv_operator", hashMap.get("tpv_operator"));
            //内部费用项目
            data.set("tpv_interexpitem", hashMap.get("tpv_interexpitem"));
            //类型
            data.set("tpv_typesof","A");
            //银行
            data.set("tpv_bank", hashMap.get("tpv_bank"));
            //币种
            data.set("tpv_currency", hashMap.get("tpv_currency"));
            //金额
            data.set("tpv_amt", hashMap.get("tpv_amt"));
            //溢短装率
            data.set("tpv_overshortrate",hashMap.get("tpv_overshortrate"));
            //溢短装金额
            data.set("tpv_excshortamt",hashMap.get("tpv_excshortamt"));
            //信用证号
            data.set("tpv_lettercredno", hashMap.get("tpv_lettercredno"));
            //是否代开
            data.set("tpv_makeoutinvoices",hashMap.get("tpv_makeoutinvoices"));
            //日期
            data.set("tpv_date", date);
            //信用证类型
            data.set("tpv_typelettercredits", hashMap.get("tpv_typelettercredits"));
            //远期天数
            data.set("tpv_longdays", hashMap.get("tpv_longdays"));
            //合同号
            data.set("tpv_contractnum", hashMap.get("tpv_contractnum"));
            //费率
            data.set("tpv_rate",hashMap.get("tpv_rate"));
            //收费
            data.set("tpv_charge",hashMap.get("tpv_charge"));
            //汇率
            data.set("tpv_exchrate",hashMap.get("tpv_exchrate"));
            //费用（CNY）
            data.set("tpv_cost",hashMap.get("tpv_cost"));
            //受益人
            data.set("tpv_beneficiarya", hashMap.get("tpv_beneficiarya"));
            //快递费
            data.set("tpv_expressfee",hashMap.get("tpv_expressfee"));
            //凭证号
            data.set("tpv_voucherno", hashMap.get("tpv_voucherno"));
            //保存
            SaveServiceHelper.save(new DynamicObject[]{data});
            ((BillList) this.getControl("billlistap")).refresh();

        }
    }

    /**
     * 动态表单关闭回调事件
     */

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        // super.closedCallBack(closedCallBackEvent);
        Object returnData = closedCallBackEvent.getReturnData();
        // 判断标识是否匹配，并验证动态表单返回数据不为空，不验证返回值可能会报空指针
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_settinfor")
                && null != closedCallBackEvent.getReturnData()) {
            // 这里返回对象为Object，可强转成相应的其他类型，
            ArrayList<HashMap<String, Object>> list = (ArrayList<HashMap<String, Object>>) returnData;

                    this.sethandfeeset(list);
                }
            }
        }
