package com.itopview.wm.sc.formplugin.list;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.EventObject;
import java.util.List;
import com.alibaba.druid.util.StringUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.list.BillList;
import kd.bos.list.IListView;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;


/**
 * @author LiuHB
 * @version 1.0
 * 手续费结算单、押汇融资结算单列表按钮点击填值
 */
public class ListPlugin extends AbstractListPlugin {


    @Override
    public void itemClick(ItemClickEvent evt) {
            super.itemClick(evt);
            //获取列表界面绑定的数据
            String formId = ((IListView) this.getView()).getBillFormId();
            String itemKey = evt.getItemKey();

            //资金专员确认
            if (StringUtils.equalsIgnoreCase(itemKey, "tpv_contrespecia")) {
                //获取列表控件
                BillList billList = this.getControl("billlistap");
                //获取选中行数据，主键和Id
                ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();

                if (ListSelectedRow1 != null && ListSelectedRow1.size() > 0) {
                    List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
                    //单据数据
                    DynamicObject tempRowData = null;
                    for (ListSelectedRow tempRowDataId : ListSelectedRow1) {
                        //tempRowDataId.getPrimaryKeyValue()获取选中行数据
                        tempRowData = BusinessDataServiceHelper.
                                loadSingle(tempRowDataId.getPrimaryKeyValue(), formId);
                        String billno = tempRowData.getString("billno");
                        DynamicObject treaspecia = tempRowData.getDynamicObject("tpv_treaspecia");
                        if(treaspecia==null) {
                            //获取凭证号
                            String voucherno = tempRowData.getString("tpv_voucherno");
                            //获取当前操作人
                            long userID = UserServiceHelper.getCurrentUserId();
                            //时间格式
                            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd ");
                            //获取当前时间
                            Date date = new Date(System.currentTimeMillis());
                            tempRowData.set("tpv_treaspecia", userID);
                            tempRowData.set("tpv_treaspeciadate", date);
                            ListSelectedRow2.add(tempRowData);
                        }else{
                            this.getView().showErrorNotification("请检查单据"+billno+"资金专员是否为空");
                        }
                    }
                    if (ListSelectedRow2.size() > 0) {
                        //更新列表
                        Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[]{}));
                        //刷新列表
                        ((IListView) this.getView()).refresh();
                    }
                }
            }
            //取消资金专员确认
            if (StringUtils.equalsIgnoreCase(itemKey, "tpv_cantrespecia")) {
                BillList billList = this.getControl("billlistap");//获取列表
                ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();//获取选中行
                if (ListSelectedRow1 != null && ListSelectedRow1.size() > 0) {
                    List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
                    DynamicObject tempRowData = null;
                    for (ListSelectedRow tempRowDataId : ListSelectedRow1) {
                        tempRowData = BusinessDataServiceHelper.
                                loadSingle(tempRowDataId.getPrimaryKeyValue(), formId);
                        String billno = tempRowData.getString("billno");
                        DynamicObject treaspecia = tempRowData.getDynamicObject("tpv_treaspecia");
                        String voucherno = tempRowData.getString("tpv_voucherno");
                        if(treaspecia!=null && voucherno.isEmpty() ) {
                            tempRowData.set("tpv_treaspecia", null);
                            tempRowData.set("tpv_treaspeciadate", null);
                            ListSelectedRow2.add(tempRowData);
                        }
                        else{
                            this.getView().showErrorNotification("请检查单据"+billno+"资金专员是否不为空或者凭证号是否为空");
                        }
                    }
                    if (ListSelectedRow2.size() > 0) {
                        Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[]{}));
                        ((IListView) this.getView()).refresh();
                    }
                }
            }
//            ================================================
            //业务员确认
            if (StringUtils.equalsIgnoreCase(itemKey, "tpv_consalesman")) {
                //获取列表控件
                BillList billList = this.getControl("billlistap");
                //获取选中行数据，主键和Id
                ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();

                if (ListSelectedRow1 != null && ListSelectedRow1.size() > 0) {
                    List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
                    //单据数据
                    DynamicObject tempRowData = null;
                    for (ListSelectedRow tempRowDataId : ListSelectedRow1) {
                        //tempRowDataId.getPrimaryKeyValue()获取选中行数据
                        tempRowData = BusinessDataServiceHelper.
                                loadSingle(tempRowDataId.getPrimaryKeyValue(), formId);
                        String billno = tempRowData.getString("billno");
                        DynamicObject treaspecia = tempRowData.getDynamicObject("tpv_salesman");
                        if(treaspecia==null) {
                            //获取凭证号
                            String voucherno = tempRowData.getString("tpv_voucherno");
                            //获取当前操作人
                            long userID = UserServiceHelper.getCurrentUserId();
                            //时间格式
                            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd ");
                            //获取当前时间
                            Date date = new Date(System.currentTimeMillis());
                            tempRowData.set("tpv_salesman", userID);
                            tempRowData.set("tpv_salesmandate", date);
                            ListSelectedRow2.add(tempRowData);
                        }else{
                            this.getView().showErrorNotification("请检查单据"+billno+"业务员是否为空");
                        }
                    }
                    if (ListSelectedRow2.size() > 0) {
                        //更新列表
                        Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[]{}));
                        //刷新列表
                        ((IListView) this.getView()).refresh();
                    }
                }
            }
            //取消业务员确认
            if (StringUtils.equalsIgnoreCase(itemKey, "tpv_cansalesman")) {
                BillList billList = this.getControl("billlistap");//获取列表
                ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();//获取选中行
                if (ListSelectedRow1 != null && ListSelectedRow1.size() > 0) {
                    List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
                    DynamicObject tempRowData = null;
                    for (ListSelectedRow tempRowDataId : ListSelectedRow1) {
                        tempRowData = BusinessDataServiceHelper.
                                loadSingle(tempRowDataId.getPrimaryKeyValue(), formId);
                        String billno = tempRowData.getString("billno");
                        DynamicObject treaspecia = tempRowData.getDynamicObject("tpv_salesman");
                        String voucherno = tempRowData.getString("tpv_voucherno");
                        if(treaspecia!=null && voucherno.isEmpty() ) {
                            tempRowData.set("tpv_salesman", null);
                            tempRowData.set("tpv_salesmandate", null);
                            ListSelectedRow2.add(tempRowData);
                        }
                        else{
                            this.getView().showErrorNotification("请检查单据"+billno+"业务员是否不为空或者凭证号是否为空");
                        }
                    }
                    if (ListSelectedRow2.size() > 0) {
                        Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[]{}));
                        ((IListView) this.getView()).refresh();
                    }
                }
            }
        //责任人确认
        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_conperespon")) {
            //获取列表控件
            BillList billList = this.getControl("billlistap");
            //获取选中行数据，主键和Id
            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();

            if (ListSelectedRow1 != null && ListSelectedRow1.size() > 0) {
                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
                //单据数据
                DynamicObject tempRowData = null;
                for (ListSelectedRow tempRowDataId : ListSelectedRow1) {
                    //tempRowDataId.getPrimaryKeyValue()获取选中行数据
                    tempRowData = BusinessDataServiceHelper.
                            loadSingle(tempRowDataId.getPrimaryKeyValue(), formId);
                    String billno = tempRowData.getString("billno");
                    DynamicObject treaspecia = tempRowData.getDynamicObject("tpv_personrespon");
                    if(treaspecia==null) {
                        //获取凭证号
                        String voucherno = tempRowData.getString("tpv_voucherno");
                        //获取当前操作人
                        long userID = UserServiceHelper.getCurrentUserId();
                        //时间格式
                        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd ");
                        //获取当前时间
                        Date date = new Date(System.currentTimeMillis());
                        tempRowData.set("tpv_personrespon", userID);
                        tempRowData.set("tpv_personrespondate", date);
                        ListSelectedRow2.add(tempRowData);
                    }else{
                        this.getView().showErrorNotification("请检查单据"+billno+"责任人是否为空");
                    }
                }
                if (ListSelectedRow2.size() > 0) {
                    //更新列表
                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[]{}));
                    //刷新列表
                    ((IListView) this.getView()).refresh();
                }
            }
        }
        //取消责任人确认
        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_canperespon")) {
            BillList billList = this.getControl("billlistap");//获取列表
            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();//获取选中行
            if (ListSelectedRow1 != null && ListSelectedRow1.size() > 0) {
                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
                DynamicObject tempRowData = null;
                for (ListSelectedRow tempRowDataId : ListSelectedRow1) {
                    tempRowData = BusinessDataServiceHelper.
                            loadSingle(tempRowDataId.getPrimaryKeyValue(), formId);
                    String billno = tempRowData.getString("billno");
                    DynamicObject treaspecia = tempRowData.getDynamicObject("tpv_personrespon");
                    String voucherno = tempRowData.getString("tpv_voucherno");
                    if(treaspecia!=null && voucherno.isEmpty() ) {
                        tempRowData.set("tpv_personrespon", null);
                        tempRowData.set("tpv_personrespondate", null);
                        ListSelectedRow2.add(tempRowData);
                    }
                    else{
                        this.getView().showErrorNotification("请检查单据"+billno+"责任人是否不为空或者凭证号是否为空");
                    }
                }
                if (ListSelectedRow2.size() > 0) {
                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[]{}));
                    ((IListView) this.getView()).refresh();
                }
            }
        }
        //资金负责人确认
        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_confinperespon")) {
            //获取列表控件
            BillList billList = this.getControl("billlistap");
            //获取选中行数据，主键和Id
            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();

            if (ListSelectedRow1 != null && ListSelectedRow1.size() > 0) {
                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
                //单据数据
                DynamicObject tempRowData = null;
                for (ListSelectedRow tempRowDataId : ListSelectedRow1) {
                    //tempRowDataId.getPrimaryKeyValue()获取选中行数据
                    tempRowData = BusinessDataServiceHelper.
                            loadSingle(tempRowDataId.getPrimaryKeyValue(), formId);
                    String billno = tempRowData.getString("billno");
                    DynamicObject treaspecia = tempRowData.getDynamicObject("tpv_fundmanager");
                    if(treaspecia==null) {
                        //获取凭证号
                        String voucherno = tempRowData.getString("tpv_voucherno");
                        //获取当前操作人
                        long userID = UserServiceHelper.getCurrentUserId();
                        //时间格式
                        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd ");
                        //获取当前时间
                        Date date = new Date(System.currentTimeMillis());
                        tempRowData.set("tpv_fundmanager", userID);
                        tempRowData.set("tpv_fundmanagerdate", date);
                        ListSelectedRow2.add(tempRowData);
                    }else{
                        this.getView().showErrorNotification("请检查单据"+billno+"资金负责人是否为空");
                    }
                }
                if (ListSelectedRow2.size() > 0) {
                    //更新列表
                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[]{}));
                    //刷新列表
                    ((IListView) this.getView()).refresh();
                }
            }
        }
        //取消资金负责人确认
        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_canfinperespon")) {
            BillList billList = this.getControl("billlistap");//获取列表
            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();//获取选中行
            if (ListSelectedRow1 != null && ListSelectedRow1.size() > 0) {
                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
                DynamicObject tempRowData = null;
                for (ListSelectedRow tempRowDataId : ListSelectedRow1) {
                    tempRowData = BusinessDataServiceHelper.
                            loadSingle(tempRowDataId.getPrimaryKeyValue(), formId);
                    String billno = tempRowData.getString("billno");
                    DynamicObject treaspecia = tempRowData.getDynamicObject("tpv_fundmanager");
                    String voucherno = tempRowData.getString("tpv_voucherno");
                    if(treaspecia!=null && voucherno.isEmpty() ) {
                        tempRowData.set("tpv_fundmanager", null);
                        tempRowData.set("tpv_fundmanagerdate", null);
                        ListSelectedRow2.add(tempRowData);
                    }
                    else{
                        this.getView().showErrorNotification("请检查单据"+billno+"资金负责人是否不为空或者凭证号是否为空");
                    }
                }
                if (ListSelectedRow2.size() > 0) {
                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[]{}));
                    ((IListView) this.getView()).refresh();
                }
            }
        }
    }
}


//        //业务员确认
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_consalesman")) {
//            //获取列表控件
//            BillList billList =this.getControl("billlistap");
//            //获取选中行数据，主键和Id
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();
//            Boolean flag = false;
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    //tempRowDataId.getPrimaryKeyValue()获取选中行数据
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    long userID = UserServiceHelper.getCurrentUserId();
//                    SimpleDateFormat formatter= new SimpleDateFormat("yyyy-MM-dd ");
//                    Date date = new Date(System.currentTimeMillis());
//                    tempRowData.set("tpv_salesman",userID);
//                    tempRowData.set("tpv_salesmandate",date);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno == "") {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    //更新列表
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    //刷新列表
//                    ((IListView)this.getView()).refresh();
//                    //当业务员不为空锁定确认业务员员按钮
//                    this.getView().setEnable(false,"tpv_consalesman");
//                    if (flag) {
//                        //当业务员不为空凭证号为空解锁取消业务员按钮
//                        this.getView().setEnable(true,"tpv_cansalesman");
//                    }
//                }
//            }
//        }
//        //取消业务员确认
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_cansalesman")) {
//            BillList billList =this.getControl("billlistap");//获取列表
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();//获取选中行
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//                Boolean flag = false;
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    tempRowData.set("tpv_salesman",null);
//                    tempRowData.set("tpv_salesmandate",null);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno != null) {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    ((IListView)this.getView()).refresh();
//                    //当业务员为空时解锁确认业务员按钮
//                    this.getView().setEnable(true,"tpv_consalesman");
//                    if (flag) {
//                        //当业务员为空且凭证号不为空锁定取消业务员确认按钮
//                        this.getView().setEnable(false,"tpv_cansalesman");
//                    }
//                }
//            }
//        }
//        //责任人确认
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_conperespon")) {
//            //获取列表控件
//            BillList billList =this.getControl("billlistap");
//            //获取选中行数据，主键和Id
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();
//            Boolean flag = false;
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    //tempRowDataId.getPrimaryKeyValue()获取选中行数据
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    long userID = UserServiceHelper.getCurrentUserId();
//                    SimpleDateFormat formatter= new SimpleDateFormat("yyyy-MM-dd ");
//                    Date date = new Date(System.currentTimeMillis());
//                    tempRowData.set("tpv_personrespon",userID);
//                    tempRowData.set("tpv_personrespondate",date);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno == "") {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    //更新列表
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    //刷新列表
//                    ((IListView)this.getView()).refresh();
//                    //当责任人不为空锁定确认责任人按钮
//                    this.getView().setEnable(false,"tpv_conperespon");
//                    if (flag) {
//                        //当责任人不为空凭证号为空解锁取消责任人按钮
//                        this.getView().setEnable(true,"tpv_canperespon");
//                    }
//                }
//            }
//        }
//        //取消责任人确认
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_canperespon")) {
//            BillList billList =this.getControl("billlistap");//获取列表
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();//获取选中行
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//                Boolean flag = false;
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    tempRowData.set("tpv_personrespon",null);
//                    tempRowData.set("tpv_personrespondate",null);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno != null) {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    ((IListView)this.getView()).refresh();
//                    //当责任人为空时解锁确认责任人按钮
//                    this.getView().setEnable(true,"tpv_conperespon");
//                    if (flag) {
//                        //当责任人为空且凭证号不为空锁定取消责任人确认按钮
//                        this.getView().setEnable(false,"tpv_canperespon");
//                    }
//                }
//            }
//        }
//        //tpv_confinperespon资金确认专员按钮
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_confinperespon")) {
//            //获取列表控件
//            BillList billList =this.getControl("billlistap");
//            //获取选中行数据，主键和Id
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();
//            Boolean flag = false;
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    //tempRowDataId.getPrimaryKeyValue()获取选中行数据
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    long userID = UserServiceHelper.getCurrentUserId();
//                    SimpleDateFormat formatter= new SimpleDateFormat("yyyy-MM-dd ");
//                    Date date = new Date(System.currentTimeMillis());
//                    tempRowData.set("tpv_fundmanager",userID);
//                    tempRowData.set("tpv_fundmanagerdate",date);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno == "") {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    //更新列表
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    //刷新列表
//                    ((IListView)this.getView()).refresh();
//                    //当资金确认专员不为空时锁定确认资金确认专员按钮
//                    this.getView().setEnable(false,"tpv_confinperespon");
//                    if (flag) {
//                        //当资金确认专员不为空凭证号为空时解锁取消资金确认专员按钮
//                        this.getView().setEnable(true,"tpv_canfinperespon");
//                    }
//                }
//            }
//        }
//        //tpv_canfinperespon取消资金确认专员按钮
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_canfinperespon")) {
//            BillList billList =this.getControl("billlistap");//获取列表
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();//获取选中行
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//                Boolean flag = false;
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    tempRowData.set("tpv_fundmanager",null);
//                    tempRowData.set("tpv_fundmanagerdate",null);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno != null) {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    ((IListView)this.getView()).refresh();
//                    //当资金确认专员为空时解锁确认资金确认专员按钮
//                    this.getView().setEnable(true,"tpv_confinperespon");
//                    if (flag) {
//                        //当资金确认专员为空且凭证号不为空锁定取消资金确认专员确认按钮
//                        this.getView().setEnable(false,"tpv_canfinperespon");
//                    }
//                }
//            }
//        }
//    }
//    @Override
//    public void itemClick(ItemClickEvent evt) {
//        super.itemClick(evt);
//        //获取列表界面绑定的数据
//        String formId = ((IListView) this.getView()).getBillFormId();
//        String itemKey = evt.getItemKey();
//
//        //资金专员确认
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_contrespecia")) {
//           //获取列表控件
//            BillList billList =this.getControl("billlistap");
//            //获取选中行数据，主键和Id
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();
//
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                //单据数据
//                DynamicObject tempRowData = null;
//                Boolean flag = false;
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    //tempRowDataId.getPrimaryKeyValue()获取选中行数据
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    //获取凭证号
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    //获取当前操作人
//                    long userID = UserServiceHelper.getCurrentUserId();
//                    //时间格式
//                    SimpleDateFormat formatter= new SimpleDateFormat("yyyy-MM-dd ");
//                    //获取当前时间
//                    Date date = new Date(System.currentTimeMillis());
//                    tempRowData.set("tpv_treaspecia",userID);
//                    tempRowData.set("tpv_treaspeciadate",date);
//
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno == "") {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    //更新列表
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    //刷新列表
//                    ((IListView)this.getView()).refresh();
//                    //当资金专员不为空锁定资金专员按钮
//                    this.getView().setEnable(false,"tpv_contrespecia");
//                    //当资金专员不为空凭证号为空解锁取消资金专员按钮
//                    if (flag ) {
//                        this.getView().setEnable(true,"tpv_cantrespecia");
//                    }
//                }
//            }
//        }
//        //取消资金专员确认
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_cantrespecia")) {
//            BillList billList =this.getControl("billlistap");//获取列表
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();//获取选中行
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//                Boolean flag = false;
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    tempRowData.set("tpv_treaspecia",null);
//                    tempRowData.set("tpv_treaspeciadate",null);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno !=  null) {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    ((IListView)this.getView()).refresh();
//                         //当资金专员为空时解锁确认资金专员按钮
//                        this.getView().setEnable(true,"tpv_contrespecia");
//                    if (flag) {
//                        //当资金专员为空且凭证号不为空锁定取消资金专员确认按钮
//                        this.getView().setEnable(false,"tpv_cantrespecia");
//                    }
//                }
//            }
//        }
//        //业务员确认
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_consalesman")) {
//            //获取列表控件
//            BillList billList =this.getControl("billlistap");
//            //获取选中行数据，主键和Id
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();
//            Boolean flag = false;
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    //tempRowDataId.getPrimaryKeyValue()获取选中行数据
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    long userID = UserServiceHelper.getCurrentUserId();
//                    SimpleDateFormat formatter= new SimpleDateFormat("yyyy-MM-dd ");
//                    Date date = new Date(System.currentTimeMillis());
//                    tempRowData.set("tpv_salesman",userID);
//                    tempRowData.set("tpv_salesmandate",date);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno == "") {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    //更新列表
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    //刷新列表
//                    ((IListView)this.getView()).refresh();
//                    //当业务员不为空锁定确认业务员员按钮
//                    this.getView().setEnable(false,"tpv_consalesman");
//                    if (flag) {
//                        //当业务员不为空凭证号为空解锁取消业务员按钮
//                        this.getView().setEnable(true,"tpv_cansalesman");
//                    }
//                }
//            }
//        }
//        //取消业务员确认
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_cansalesman")) {
//            BillList billList =this.getControl("billlistap");//获取列表
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();//获取选中行
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//                Boolean flag = false;
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    tempRowData.set("tpv_salesman",null);
//                    tempRowData.set("tpv_salesmandate",null);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno != null) {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    ((IListView)this.getView()).refresh();
//                    //当业务员为空时解锁确认业务员按钮
//                    this.getView().setEnable(true,"tpv_consalesman");
//                    if (flag) {
//                        //当业务员为空且凭证号不为空锁定取消业务员确认按钮
//                        this.getView().setEnable(false,"tpv_cansalesman");
//                    }
//                }
//            }
//        }
//        //责任人确认
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_conperespon")) {
//            //获取列表控件
//            BillList billList =this.getControl("billlistap");
//            //获取选中行数据，主键和Id
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();
//            Boolean flag = false;
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    //tempRowDataId.getPrimaryKeyValue()获取选中行数据
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    long userID = UserServiceHelper.getCurrentUserId();
//                    SimpleDateFormat formatter= new SimpleDateFormat("yyyy-MM-dd ");
//                    Date date = new Date(System.currentTimeMillis());
//                    tempRowData.set("tpv_personrespon",userID);
//                    tempRowData.set("tpv_personrespondate",date);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno == "") {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    //更新列表
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    //刷新列表
//                    ((IListView)this.getView()).refresh();
//                    //当责任人不为空锁定确认责任人按钮
//                    this.getView().setEnable(false,"tpv_conperespon");
//                    if (flag) {
//                        //当责任人不为空凭证号为空解锁取消责任人按钮
//                        this.getView().setEnable(true,"tpv_canperespon");
//                    }
//                }
//            }
//        }
//        //取消责任人确认
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_canperespon")) {
//            BillList billList =this.getControl("billlistap");//获取列表
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();//获取选中行
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//                Boolean flag = false;
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    tempRowData.set("tpv_personrespon",null);
//                    tempRowData.set("tpv_personrespondate",null);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno != null) {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    ((IListView)this.getView()).refresh();
//                    //当责任人为空时解锁确认责任人按钮
//                    this.getView().setEnable(true,"tpv_conperespon");
//                    if (flag) {
//                        //当责任人为空且凭证号不为空锁定取消责任人确认按钮
//                        this.getView().setEnable(false,"tpv_canperespon");
//                    }
//                }
//            }
//        }
//        //tpv_confinperespon资金确认专员按钮
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_confinperespon")) {
//            //获取列表控件
//            BillList billList =this.getControl("billlistap");
//            //获取选中行数据，主键和Id
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();
//            Boolean flag = false;
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    //tempRowDataId.getPrimaryKeyValue()获取选中行数据
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    long userID = UserServiceHelper.getCurrentUserId();
//                    SimpleDateFormat formatter= new SimpleDateFormat("yyyy-MM-dd ");
//                    Date date = new Date(System.currentTimeMillis());
//                    tempRowData.set("tpv_fundmanager",userID);
//                    tempRowData.set("tpv_fundmanagerdate",date);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno == "") {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    //更新列表
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    //刷新列表
//                    ((IListView)this.getView()).refresh();
//                    //当资金确认专员不为空时锁定确认资金确认专员按钮
//                    this.getView().setEnable(false,"tpv_confinperespon");
//                    if (flag) {
//                        //当资金确认专员不为空凭证号为空时解锁取消资金确认专员按钮
//                        this.getView().setEnable(true,"tpv_canfinperespon");
//                    }
//                }
//            }
//        }
//        //tpv_canfinperespon取消资金确认专员按钮
//        if (StringUtils.equalsIgnoreCase(itemKey, "tpv_canfinperespon")) {
//            BillList billList =this.getControl("billlistap");//获取列表
//            ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();//获取选中行
//            if(ListSelectedRow1 != null && ListSelectedRow1.size()>0) {
//                List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
//                DynamicObject tempRowData = null;
//                Boolean flag = false;
//                for(ListSelectedRow tempRowDataId : ListSelectedRow1) {
//                    tempRowData = BusinessDataServiceHelper.
//                            loadSingle(tempRowDataId.getPrimaryKeyValue(),formId);
//                    String voucherno = tempRowData.getString("tpv_voucherno");
//                    tempRowData.set("tpv_fundmanager",null);
//                    tempRowData.set("tpv_fundmanagerdate",null);
//                    ListSelectedRow2.add(tempRowData);
//                    if (voucherno != null) {
//                        flag = true;
//                    }
//                }
//                if(ListSelectedRow2.size()>0) {
//                    Object[] result = SaveServiceHelper.save(ListSelectedRow2.toArray(new DynamicObject[] {}));
//                    ((IListView)this.getView()).refresh();
//                    //当资金确认专员为空时解锁确认资金确认专员按钮
//                    this.getView().setEnable(true,"tpv_confinperespon");
//                    if (flag) {
//                        //当资金确认专员为空且凭证号不为空锁定取消资金确认专员确认按钮
//                        this.getView().setEnable(false,"tpv_canfinperespon");
//                    }
//                }
//            }
//        }
//    }

