package com.itopview.wm.sc.formplugin.list;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.list.BillList;
import kd.bos.list.IListView;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * @author LiuHB
 * @version 1.0
 * @date 2023/8/22 9:31
 * 根据业务员带出部门
 */
public class ProcurePlugin extends AbstractBillPlugIn {

    @Override
    public void propertyChanged(PropertyChangedArgs e) {// 值更新事件
        super.propertyChanged(e);
        // 获取改变的数据名
        String propertyName = e.getProperty().getName();
        //获取列表界面绑定的数据
        String formId = ((IListView) this.getView()).getBillFormId();
        //获取列表控件
        BillList billList = this.getControl("billlistap");
        //获取选中行数据，主键和Id
        ListSelectedRowCollection ListSelectedRow1 = billList.getSelectedRows();

        if (ListSelectedRow1 != null && ListSelectedRow1.size() > 0) {
            List<DynamicObject> ListSelectedRow2 = new ArrayList<DynamicObject>();
            //单据数据
            DynamicObject tempRowData = null;
            for (ListSelectedRow tempRowDataId : ListSelectedRow1) {
                //tempRowDataId.getPrimaryKeyValue()获取选中行数据
                tempRowData = BusinessDataServiceHelper.
                        loadSingle(tempRowDataId.getPrimaryKeyValue(), formId);
                if ("tpv_operator".equals(propertyName) ||
                        "tpv_department".equals(propertyName)) {
                    DynamicObject operator = tempRowData.getDynamicObject("tpv_operator");
                    DynamicObject department = tempRowData.getDynamicObject("tpv_department");
                    Long operatorId = operator.getLong("Id");
                    Long departmentId = operator.getLong("Id");
                    if (!UserServiceHelper.getOrgsUserJoin(operatorId).contains(operatorId)) {
                        this.getModel().setValue("tpv_department", UserServiceHelper.getUserMainOrgId(operatorId));
                    }else {
                        return;
                    }
                }
            }
        }
    }
}