package com.itopview.wm.sc.formplugin.list;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.list.IListView;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * @author: He Wenbei
 * @Project: zhkc
 * @Package: com.itopview.wm.sc.formplugin.list.UniqueCientBeginYearListPlugin
 * @Date: 2023/08/29 15:10
 * @Description: 年初系数只允许存在一条启用的数据，启用一条数据时更新其他数据为禁用状态
 **/
public class UniqueCientBeginYearListPlugin extends AbstractListPlugin {
    @Override
    public void beforeItemClick(BeforeItemClickEvent evt) {
        super.beforeItemClick(evt);
        //获取按标识名
        String key = evt.getItemKey();
        //获取所有选中单据
        List<Long> billId = this.getListBillId();
        if (!billId.isEmpty()) {
            //如果按钮为启用按钮，执行以下流程
            if ("tblenable".equals(key)) {
                if (billId.size() == 1) {
                    //加载选中的单据
                    DynamicObject selected = BusinessDataServiceHelper.loadSingle(billId.get(0), "tpv_sc_ybegincoff", "enable");
                    //加载遍历所有其他单据，将状态为启用的改为禁用
                    DynamicObject[] load = BusinessDataServiceHelper.load("tpv_sc_ybegincoff", "enable", null);
                    for (DynamicObject single : load) {
                        String enable = (String) single.get("enable");
                        if ("1".equals(enable)) {
                            single.set("enable", 0);
                            SaveServiceHelper.update(single);
                        }
                    }
                    selected.set("enable", 1);
                    SaveServiceHelper.update(selected);
                } else {
                    this.getView().showErrorNotification("请只选择一条数据!");
                    evt.setCancel(true);
                }
                ((IListView) this.getView()).refresh();
            }
        }
    }

    private List<Long> getListBillId() {
        IListView view = (IListView) this.getView();
        //查询列表所勾选的数据
        ListSelectedRowCollection selectedRows = view.getSelectedRows();
        List<Long> billId = new ArrayList<>();
        for (ListSelectedRow row : selectedRows) {
            //获取没条数据的内码
            Long pkId = (Long) row.getPrimaryKeyValue();
            if (!billId.contains(pkId)) {
                billId.add(pkId);
            }
        }
        return billId;
    }
}
