package com.itopview.wm.sc.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * @author ljw
 * @date 2023/9/6 14:35
 * @className SupplieServicePlugin
 * @description 供应商保存效验是否重名
 */
public class SupplieServicePlugin extends AbstractOperationServicePlugIn {

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        //获取操作对象
        String key = e.getOperationKey();
        //判断具体操作
        switch (key) {
            case "save":
                //监控按钮保存
                this.clickSave(e);
                break;
        }
    }

    private void clickSave(BeforeOperationArgs e) {
        // 获取实体
        DynamicObject[] entities = e.getDataEntities();
        //获取表单数据包
        for (DynamicObject entity : entities) {
            String name = entity.getString("name");//名称
            String sourcebillno = entity.getString("tpv_sourcebillno");//来源单据编码
            String id = entity.getString("number");
            if ("" == sourcebillno) {
                if (name != null) {
                    QFilter qFilter = new QFilter("name", QCP.equals, name);//查询相同的
                    qFilter.and("tpv_sourcebillno",QCP.not_equals,id);
                    DynamicObject[] vatinvoice = BusinessDataServiceHelper.load("bd_customer", "id,billno,name"
                            , new QFilter[]{qFilter}, null);
                    if (vatinvoice.length > 0) {
                        e.setCancel(true);
                        e.setCancelMessage("客户中有相同的名称，请修改后保存！");
                    }
                }
            }
        }
    }
}