package com.itopview.wm.sys.api;

import java.io.Serializable;
import java.util.Map;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;

import kd.bos.openapi.common.custom.annotation.ApiController;
import kd.bos.openapi.common.custom.annotation.ApiMapping;
import kd.bos.openapi.common.custom.annotation.ApiParam;
import kd.bos.openapi.common.custom.annotation.ApiPostMapping;
import kd.bos.openapi.common.custom.annotation.ApiRequestBody;
import kd.bos.openapi.common.result.CustomApiResult;

/**
 * 查询接口Demo
 * 
 * @description
 * @author longh
 * @date 2023年9月20日
 */
@ApiController(value = "tpv_demo", desc = "Demo")
@ApiMapping("/tpv/demo")
public class DemoController implements Serializable {

	@ApiPostMapping(value = "queryDemo", desc = "查询Demo")
	public CustomApiResult<DemoModel> queryDemo(@NotNull @Valid @ApiParam(value = "demo模型") DemoModel data) {
		DemoModel demoModel = new DemoModel();
		demoModel.setReqStr1("1");
		demoModel.setReqStr2("2");
		return CustomApiResult.success(demoModel);
	}

	@ApiPostMapping(value = "queryDemo2", desc = "查询Demo2")
	public CustomApiResult<Map<String, Object>> queryDemo2(
			@Valid @ApiRequestBody(value = "demo模型2") Map<String, Object> map) {

		return CustomApiResult.success(map);
	}

}
