package com.itopview.wm.sys.api.yargonpdfapi;

import com.enrobot.pin.PdfReportListPlugin;
import com.enrobot.util.ActionResult;
import com.enrobot.vo.PdfReportInputVo;
import com.itopview.wm.sys.api.yargonpdfapi.model.*;
import com.itopview.wm.sys.utils.Api;
import com.itopview.wm.sys.utils.ApiHelper;
import com.itopview.wm.sys.utils.ApiLog;
import com.itopview.wm.utils.HttpHelper;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.IBillWebApiPlugin;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.MainEntityType;
import kd.bos.logging.Log;
import kd.bos.logging.LogFactory;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.orm.ORM;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.coderule.CodeRuleServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import net.sf.json.JSONObject;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * 易氩接口
 * @author LiuHB
 * @version 1.0
 */
public class PdfFileController implements IBillWebApiPlugin {
    /**
     * 1API-Y1向易氩传递原附件并要求生成PDF
     * @param pdfFileModel
     * @return
     */
    public static CustomApiResult<Map> pdfFile(PdfFileModel pdfFileModel) {
        String code = "";
        String message = "";
        Object data = null;
        DynamicObject yataskinfo = BusinessDataServiceHelper.newDynamicObject("tpv_iscb_yataskinfo");
        String number = CodeRuleServiceHelper.getNumber("tpv_iscb_yataskinfo", yataskinfo, null);
        yataskinfo.set("billno", number);

        String scodeText = pdfFileModel.getScode_text();
//        long sealapplyid = yataskinfo.getLong("id");
        long sealapplyid = ORM.create().genLongId("tpv_iscb_yataskinfo");
        yataskinfo.set("tpv_sealapplyid", sealapplyid);
        yataskinfo.set("tpv_attachmentid", pdfFileModel.getAttachment_id());
        yataskinfo.set("tpv_operate", pdfFileModel.getTpv_operate());
        yataskinfo.set("tpv_attacname", pdfFileModel.getFile_name());
        yataskinfo.set("tpv_sourcebillscode", pdfFileModel.getTpv_sourcebillscode());
        Date currentDate = new Date();
        yataskinfo.set("tpv_bizdate", currentDate);
        yataskinfo.set("tpv_sourcebills", pdfFileModel.getSrcEntity().getDataEntityType().getName());
        yataskinfo.set("tpv_billsid", pdfFileModel.getSrcEntity().getLong("id"));
        String tpvAppid = ((MainEntityType) pdfFileModel.getSrcEntity().getDataEntityType()).getAppId();
        yataskinfo.set("tpv_appid", tpvAppid);
        yataskinfo.set("tpv_curruserid", pdfFileModel.getCurruserid());
        yataskinfo.set("tpv_status", pdfFileModel.getStatus());
        yataskinfo.set("tpv_serialnumber", pdfFileModel.getQr_text());
        yataskinfo.set("tpv_digitnumber", scodeText);
        yataskinfo.set("tpv_asynchronousid", pdfFileModel.getAsynchronousid());
        yataskinfo.set("tpv_asynchronousrow", pdfFileModel.getAsynchronousrow());
        yataskinfo.set("tpv_method", pdfFileModel.getMethod());
        try {

            PdfReportInputVo pdfReportInputVo = new PdfReportInputVo();
            //源文件
            pdfReportInputVo.setFile_b64(pdfFileModel.getFile_b64());
            //源文件名
            pdfReportInputVo.setFile_name(pdfFileModel.getFile_name());
            //客户名称
            pdfReportInputVo.setCcode(pdfFileModel.getCode());
            //我司抬头
            pdfReportInputVo.setCorpbcode(pdfFileModel.getCorpbcode());
            //附件ID
            pdfReportInputVo.setAttachment_id(pdfFileModel.getAttachment_id());
            //单据编号
            pdfReportInputVo.setContract_no(pdfFileModel.getContract_no());
            //大部门
            pdfReportInputVo.setDepartment_id(pdfFileModel.getDepartment_id());
            //批准用印人
            pdfReportInputVo.setGrantor_uid(pdfFileModel.getGrantor_uid());
            //纸张方向
            pdfReportInputVo.setOrientation(pdfFileModel.getOrientation());
            //二维码坐标
            pdfReportInputVo.setQr_location(pdfFileModel.getQr_location());
            //二维码坐标(像素)
            pdfReportInputVo.setQr_locationx(pdfFileModel.getQr_locationx());
            //二维码页面
            pdfReportInputVo.setQr_page(pdfFileModel.getQr_page());
            //二维码尺寸
            pdfReportInputVo.setQr_size(pdfFileModel.getQr_size());
            //二维码内容
            pdfReportInputVo.setQr_text(pdfFileModel.getQr_text());
            //备注
            pdfReportInputVo.setRemark(pdfFileModel.getRemark());
            //缩放比率
            pdfReportInputVo.setResize_percent(pdfFileModel.getResize_percent());
            //自动翻转
            pdfReportInputVo.setRotate(pdfFileModel.getRotate());
            //字符码坐标
            pdfReportInputVo.setScode_location(pdfFileModel.getScode_location());
            //字符码页面
            pdfReportInputVo.setScode_page(pdfFileModel.getScode_page());
            //第二套字符码坐标
            pdfReportInputVo.setScode_locationx(pdfFileModel.getScode_locationx());
            //字符码尺寸
            pdfReportInputVo.setScode_size(pdfFileModel.getScode_size());
            //字符码
            pdfReportInputVo.setScode_text(scodeText);
            //用印申请ID
            pdfReportInputVo.setSealapply_id(String.valueOf(sealapplyid));
            //制单人
            pdfReportInputVo.setVprepare_uid(pdfFileModel.getVprepare_uid());
            //印章id
            pdfReportInputVo.setSeal_ids(pdfFileModel.getSeal_ids());
            PdfReportListPlugin pdfReportListPlugin = new PdfReportListPlugin();
            ActionResult actionResult = pdfReportListPlugin.insertQrCode(pdfReportInputVo);
            code = actionResult.getCode();
            message = actionResult.getMessage();
            data = actionResult.getData();
        } catch (Exception e) {
            e.printStackTrace();
            Log log = LogFactory.getLog(PdfFileController.class.getName());
            log.error("易氩接口异常；", e);
        } finally {
            if ("000".equals(code)) {

                yataskinfo.set("tpv_taskstatus", "B");
                yataskinfo.set("tpv_filestatus", "A");
//                SaveServiceHelper.save(new DynamicObject[]{yataskinfo});//保存
                Map<String, Object> resultData = new HashMap<>();
                Map<String, Object> datas = new HashMap<>();
                resultData.put("resultCode", code);
                resultData.put("resultMsg", message);
                datas.put("tpv_sealapplyid", sealapplyid);
                resultData.put("data", datas);
                SaveServiceHelper.save(new DynamicObject[]{yataskinfo});//保存
                return CustomApiResult.success(resultData);
            } else {
                yataskinfo.set("tpv_taskstatus", "A");
                SaveServiceHelper.save(new DynamicObject[]{yataskinfo});//保存
                return CustomApiResult.fail("500", message);
            }
        }
    }

    /**
     * 文本PDF→图片PDF接口
     * @param imagePdfModel
     * @return
     */
    public static CustomApiResult<Map> imagepdf(ImagePdfModel imagePdfModel) {
        String code = "";
        String message = "";
        Object data = null;
        try {
            String pdfFileName = imagePdfModel.getPdfFileName();
            String pdfBase64 = imagePdfModel.getPdfBase64();
            PdfReportListPlugin pdfReportListPlugin = new PdfReportListPlugin();
            ActionResult actionResult = pdfReportListPlugin.txtToImg(pdfFileName, pdfBase64);
            code = actionResult.getCode();
            message = actionResult.getMessage();
            data = actionResult.getData();
            data = data.toString();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if ("000".equals(code)) {
                Map<String, Object> resultData = new HashMap<>();
                resultData.put("resultCode", code);
                resultData.put("resultMsg", message);
                resultData.put("data", data);
                return CustomApiResult.success(resultData);
            } else {

                return CustomApiResult.fail("500", message);
            }
        }
    }


    /**
     * 合同比对接口
     * @param pactContrastModel
     * @return
     */

    public static CustomApiResult<Map> actContrast(PactContrastModel pactContrastModel) {
        ApiHelper apiHelper = new ApiHelper("hwapp.enrobot");
        JSONObject pactContrast = null;
        String code = "";
        if (apiHelper.isExist()) {
            Api api = apiHelper.getApi("actContrast");
            if (api.isExist()) {
                String url = api.getUrl();
                ApiLog log = apiHelper.log(api);
                HashMap<String, String> headers = new HashMap<>();
                headers.put("Message-Reference", "a");
                headers.put("Message-Reference-Date", "");
                headers.put("Accept-Language", "chi");
                headers.put("Authorization", "a");
                String httpPost = "";
                try {
                    httpPost = HttpHelper.httpPost(url, headers, pactContrastModel.toString());
                    // 解析json数据
                    pactContrast = JSONObject.fromObject(httpPost);
                    // 获取状态码
                    code = pactContrast.getString("code");

                } catch (Exception e) {
                    e.printStackTrace();
                    log.setErrorMsg(YEM.exceptionToStr(e));
                } finally {
                    if ("000".equals(code)) {
                        log.setRequestData(pactContrastModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(true);
                        log.write();
                        return CustomApiResult.success(pactContrast);
                    } else {
                        log.setRequestData(pactContrastModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(false);
                        log.write();
                        return CustomApiResult.fail("500", "FALL");
                    }
                }
            }
        }
        return CustomApiResult.fail("500", "接口未登记");
    }


    /**
     * 添加用户接口
     * @param addUserModel
     * @return
     */
    public static CustomApiResult<Map> addUserByCode(AddUserModel addUserModel) {
        ApiHelper apiHelper = new ApiHelper("hwapp.enrobot");
        JSONObject addUser = null;
        String code = "";
        if (apiHelper.isExist()) {
            Api api = apiHelper.getApi("addUserByCode");
            if (api.isExist()) {
                String url = api.getUrl();
                ApiLog log = apiHelper.log(api);
                HashMap<String, String> headers = new HashMap<>();
                headers.put("Message-Reference", "a");
                headers.put("Message-Reference-Date", "");
                headers.put("Accept-Language", "chi");
                headers.put("Authorization", "a");
                String httpPost = "";
                try {
                    httpPost = HttpHelper.httpPost(url, headers, addUserModel.toString());
                    // 解析json数据
                    addUser = JSONObject.fromObject(httpPost);
                    // 获取状态码
                    code = addUser.getString("code");
//                    if ("000".equals("code")) {
//                        String pdfFileName = addUser.getString("pdfFileName");
//                        String pdfBase64 = addUser.getString("pdfBase64");
//
//                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    log.setErrorMsg(YEM.exceptionToStr(e));
                } finally {
                    if ("000".equals(code)) {
                        log.setRequestData(addUserModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(true);
                        log.write();
                        return CustomApiResult.success(addUser);
                    } else {
                        log.setRequestData(addUserModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(false);
                        log.write();
                        return CustomApiResult.fail("500", "FALL");
                    }
                }
            }
        }
        return CustomApiResult.fail("500", "调用失败");
    }

    /**
     * 禁用用户接口
     * @param invalidUserModel
     * @return
     */
    public static CustomApiResult<Map> invalidUser(InvalidUserModel invalidUserModel) {
        ApiHelper apiHelper = new ApiHelper("hwapp.enrobot");
        JSONObject invalidUser = null;
        String code = "";
        if (apiHelper.isExist()) {
            Api api = apiHelper.getApi("invalidUser");
            if (api.isExist()) {
                String url = api.getUrl();
                ApiLog log = apiHelper.log(api);
                HashMap<String, String> headers = new HashMap<>();
                headers.put("Message-Reference", "a");
                headers.put("Message-Reference-Date", "");
                headers.put("Accept-Language", "chi");
                headers.put("Authorization", "a");
                String httpPost = "";
                try {
                    httpPost = HttpHelper.httpPost(url, headers, invalidUserModel.toString());
                    // 解析json数据
                    invalidUser = JSONObject.fromObject(httpPost);
                    // 获取状态码
                    code = invalidUser.getString("code");
//                    if ("000".equals("code")) {
//                        String pdfFileName = invalidUser.getString("pdfFileName");
//                        String pdfBase64 = invalidUser.getString("pdfBase64");
//                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    log.setErrorMsg(YEM.exceptionToStr(e));
                } finally {
                    if ("000".equals(code)) {
                        log.setRequestData(invalidUserModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(true);
                        log.write();
                        return CustomApiResult.success(invalidUser);
                    } else {
                        log.setRequestData(invalidUserModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(false);
                        log.write();
                        return CustomApiResult.fail("500", "FALL");
                    }
                }
            }
        }
        return CustomApiResult.fail("500", "接口未登记");
    }


    /**
     * 抓取回传接口(开放)
     * @param grabPostbackModel
     * @return
     */
    public static CustomApiResult<Map> GrabPostback(GrabPostbackModel grabPostbackModel) {

        return CustomApiResult.fail("500", "接口未登记");
    }

}


