package com.itopview.wm.sys.formplugin.dynamic;

import java.util.EventObject;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * 添加银行信息-动态表单插件
 * @description:
 * @author longh
 * @date 2022年6月20日 下午8:25:12
 */
public class AddBankInfoEdit extends AbstractFormPlugin implements RowClickEventListener {

	@Override
	public void afterCreateNewData(EventObject e) {
		super.afterCreateNewData(e);
		IDataModel model = this.getModel();
		IFormView view = this.getView();
		FormShowParameter fsp = view.getFormShowParameter();
		String billKey = fsp.getCustomParam("bill");
		Object pk = fsp.getCustomParam("pk");
		DynamicObject bdInfo = BusinessDataServiceHelper.loadSingleFromCache(pk, billKey,
				"entry_bank,bankaccount,accountname,bank,iban,currency,isdefault_bank");
		if(bdInfo != null) {
			model.deleteEntryData("entry_bank");
			DynamicObjectCollection bankEntry = bdInfo.getDynamicObjectCollection("entry_bank");
			for (DynamicObject row : bankEntry) {
				int rowIndex = model.createNewEntryRow("entry_bank");
				model.setValue("bankaccount", row.get("bankaccount"), rowIndex);
				model.setValue("accountname", row.get("accountname"), rowIndex);
				model.setValue("iban", row.get("iban"), rowIndex);
				model.setValue("bank", row.get("bank"), rowIndex);
				model.setValue("currency", row.get("currency"), rowIndex);
				model.setValue("isdefault_bank", row.get("isdefault_bank"), rowIndex);
			}
		}
	}
	
	@Override
	public void registerListener(EventObject e) {
		super.registerListener(e);
		this.addClickListeners(new String[]{"btnok"});
		((EntryGrid) this.getControl("entry_bank")).addRowClickListener(this);;
	}
	
	@Override
	public void click(EventObject evt) {
		super.click(evt);
		String key = ((Control) evt.getSource()).getKey();
		switch (key) {
		case "btnok" :
			this.btnOk();
		}
	}
	
	@Override
	public void entryRowDoubleClick(RowClickEvent evt) {
		RowClickEventListener.super.entryRowDoubleClick(evt);
		this.btnOk();
	}
	
	private void btnOk() {
		IFormView view = this.getView();
		IDataModel model = this.getModel();
		int rowIndex = model.getEntryCurrentRowIndex("entry_bank");
		DynamicObject focusRow = model.getEntryRowEntity("entry_bank", rowIndex);
		view.returnDataToParent(focusRow);
		view.close();
	}
	
}
