package com.itopview.wm.sys.formplugin.dynamic;

import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import java.util.Date;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * 修改密码
 * @author LiuHB
 * @version 1.0
 */
public class AmendFormPlugin extends AbstractFormPlugin {


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        addClickListeners("btnok", "btncancel");
    }


    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control c = (Control) evt.getSource();
        String key = c.getKey().toLowerCase();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);

        switch (key) {
            case "btnok":
                HashMap<String,Object> hashMap = new HashMap<>();
                String newcode = dataEntity.getString("tpv_newcode");
                Date revampdate = dataEntity.getDate("tpv_revampdate");
                hashMap.put("tpv_newcode",newcode);
                hashMap.put("tpv_revampdate",revampdate);
                this.getView().returnDataToParent(hashMap);
                this.getView().close();
                break;
            case "btncancel":
                this.getView().close();
                break;
        }
    }

    /**
     * 旧密码比对解锁新密码字段
     * @param e
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = new HashMap<>();
        maps = showParameter.getCustomParams();
        String amcipher =(String) maps.get("tpv_amcipher");
        String propertyName = e.getProperty().getName();
        if ("tpv_worncode".equals(propertyName)) {
                String worncode = (String) this.getModel().getValue("tpv_worncode");
                if (worncode.equals(amcipher)) {
                    this.getView().setEnable(true, "tpv_newcode");
                }else{
                    this.getView().showErrorNotification("密码输入不一致，请重新输入");
                }
            }
        }


    /**
     * 判断是否为新用户，字段控制
     * @param e
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = new HashMap<>();
        maps = showParameter.getCustomParams();
        String name = (String) maps.get("tpv_staff");

            if (name == null) {
                    this.getView().setVisible(false, "tpv_worncode");
                } else {
                    this.getView().setVisible(true, "tpv_worncode");
                    this.getView().setEnable(false, "tpv_newcode");
                }
            }
}

