package com.itopview.wm.sys.formplugin.dynamic;

import java.util.EventObject;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Stack;

import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.YEM;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.entity.ValueMapItem;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.property.AmountProp;
import kd.bos.entity.property.BasedataProp;
import kd.bos.entity.property.BooleanProp;
import kd.bos.entity.property.ComboProp;
import kd.bos.entity.property.DateProp;
import kd.bos.entity.property.DateTimeProp;
import kd.bos.entity.property.DecimalProp;
import kd.bos.entity.property.IntegerProp;
import kd.bos.entity.property.MuliLangTextProp;
import kd.bos.entity.property.PictureProp;
import kd.bos.entity.property.PriceProp;
import kd.bos.entity.property.TextProp;
import kd.bos.form.CloseCallBack;
import kd.bos.form.IFormView;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.control.Control;
import kd.bos.form.control.RichTextEditor;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * 合并审批消息测试
 * 
 * @description
 * @author longh
 * @date 2023年9月21日
 */
public class ApptoSetsTestEdit extends AbstractFormPlugin {

	@Override
	public void afterCreateNewData(EventObject e) {
		super.afterCreateNewData(e);
		IFormView view = this.getView();
		IFormView parentView = view.getParentView();
		RichTextEditor richTextEditor_p = parentView.getControl("tpv_richtexteditorap");
		RichTextEditor richTextEditor = view.getControl("tpv_richtexteditorap");
		richTextEditor.setText(richTextEditor_p.getText());
	}

	@Override
	public void registerListener(EventObject e) {
		super.registerListener(e);
		this.addClickListeners(new String[] { "tpv_billno" });
	}

	@Override
	public void click(EventObject evt) {
		super.click(evt);
		String key = ((Control) evt.getSource()).getKey();
		switch (key) {
		case "tpv_billno":
			this.billnoClick();
		}
	}

	private void billnoClick() {
		IFormView view = this.getView();
		IFormView parentView = view.getParentView();
		IDataModel parentModel = parentView.getModel();
		DynamicObject tpv_requirebill = (DynamicObject) parentModel.getValue("tpv_requirebill");
		if (tpv_requirebill != null) {
			String billkey = tpv_requirebill.getString("number");
			ListShowParameter createShowListForm = ShowFormHelper.createShowListForm(billkey, false, 0);
			createShowListForm.setCloseCallBack(new CloseCallBack(this, "billnoClick"));
			view.showForm(createShowListForm);
		}
	}

	@Override
	public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
		String actionId = closedCallBackEvent.getActionId();
		Object returnData = closedCallBackEvent.getReturnData();
		switch (actionId) {
		case "billnoClick":
			billF7CallBack(returnData);
			break;
		default:
			break;
		}
	}

	private void billF7CallBack(Object returnData) {
		IFormView view = this.getView();
		IDataModel model = this.getModel();
		IFormView parentView = view.getParentView();
		IDataModel parentModel = parentView.getModel();

		DynamicObject tpv_requirebill = (DynamicObject) parentModel.getValue("tpv_requirebill");

		if (returnData instanceof ListSelectedRowCollection) {
			ListSelectedRowCollection selectRows = (ListSelectedRowCollection) returnData;
			if (selectRows != null && selectRows.size() > 0) {

				String billkey = tpv_requirebill.getString("number");

				String billNo = selectRows.get(0).getBillNo();
				Object pkId = selectRows.get(0).getPrimaryKeyValue();
				DynamicObject setsBill = parentModel.getDataEntity(true);

				String newText = bulidRichText(setsBill, pkId,billkey);

				DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(billkey, "tpv_additional,tpv_join_tag,tpv_additional_tag", new QFilter[]{new QFilter("billno", QCP.equals, billNo)});
				String tpvAdditional = loadSingle.getString("tpv_additional"); //附加审批信息
				String tpvAdditionalTag = loadSingle.getString("tpv_additional_tag"); //附加审批信息
				String joinTag = loadSingle.getString("tpv_join_tag");  //字段拼接
				StringBuilder builder = new StringBuilder();

				builder.append(newText);
				builder.append("附加审批信息：");
				builder.append(tpvAdditional).append(tpvAdditionalTag).append("<br>");
				builder.append(joinTag);
				String builderString = builder.toString();

				RichTextEditor richTextEditor = view.getControl("tpv_richtexteditorap");
				richTextEditor.setText(builderString);
				model.setValue("tpv_billno", billNo);
			}
		}
	}



	/**
	 * 加载富文本
	 * 
	 * @param setsBill
	 *            合并审批消息方案实体
	 * @param pkId
	 *            单据ID
	 * @return
	 */
	public static String bulidRichText(DynamicObject setsBill, Object pkId,String billkey) {
		StringBuilder newText = new StringBuilder();
		String text = setsBill.getString("tpv_data_tag");
		DynamicObject tpv_requirebill = setsBill.getDynamicObject("tpv_requirebill");
		DynamicObjectCollection tpv_colsmap = setsBill.getDynamicObjectCollection("tpv_colsmap");
		if (tpv_requirebill != null) {
//			String billkey = tpv_requirebill.getString("number");
			DynamicObject bill = BusinessDataServiceHelper.loadSingle(pkId, billkey);
			if (bill != null) {
				Map<String, String> map = new HashMap<>();
				for (DynamicObject row : tpv_colsmap) {
					String seq = row.getString("seq");
					String tpv_billcolno = row.getString("tpv_billcolno");
					if (YEM.isNotEmpty(tpv_billcolno)) {
						map.put("{" + seq + "}", getBillText(bill, tpv_billcolno));
					}
				}
				Stack<Integer> stack = new Stack<>();
				for (int i = 0; i < text.length(); i++) {
					char c = text.charAt(i);
					if (c == '{') {
						if (stack.size() > 0) {
							Integer begin = stack.pop();
							String str = text.substring(begin, i);
							newText.append(str);
						}
						stack.add(i);
					} else if (c == '}') {
						if (stack.size() > 0) {
							Integer begin = stack.pop();
							String indexStr = text.substring(begin, i + 1);
							if (map.containsKey(indexStr)) {
								newText.append(map.get(indexStr));
							} else {
								newText.append(indexStr);
							}
						} else {
							newText.append(c);
						}
					} else if (stack.size() == 0) {
						newText.append(c);
					}
				}
				if (stack.size() > 0) {
					Integer begin = stack.pop();
					String str = text.substring(begin);
					newText.append(str);
				}
			}
		}
		return newText.toString();
	}

	private static String getBillText(DynamicObject bill, String key) {
		String str = "";
		DataEntityPropertyCollection properties = bill.getDynamicObjectType().getProperties();
		if (properties.containsKey(key)) {
			IDataEntityProperty prop = properties.get(key);
			Object propValue = bill.get(key);
			if (propValue == null) {
				return str;
			}
			if (prop instanceof TextProp) {
				if (prop instanceof MuliLangTextProp) {
					str = bill.getLocaleString(key).getLocaleValue();// 多语言文本
				}else {
					str = bill.getString(key);// 文本
				}
			} else if (prop instanceof DecimalProp) {
				if (prop instanceof PriceProp) {
					str = BigDecimalUtils.setScale(propValue, 2).toString();// 单价
				} else if (prop instanceof AmountProp) {
					str = BigDecimalUtils.setScale(propValue, 2).toString();// 金额
				} else if (prop instanceof IntegerProp) {
					str = bill.getString(key);// 整数
				} else {
					str = BigDecimalUtils.setScale(propValue, 2).toString();// 小数
				}
			} else if (prop instanceof DateTimeProp) {
				if (prop instanceof DateProp) {
					str = DateUtil.formatDate(bill.getDate(key));// 日期
				} else {
					str = DateUtil.formatDate(bill.getDate(key));// 长日期
				}
			} else if (prop instanceof BooleanProp) {
				str = bill.getBoolean(key) ? "是" : "否";// 复选框
			} else if (prop instanceof ComboProp) {
				// 下拉列表
				List<ValueMapItem> comboItems = ((ComboProp) prop).getComboItems();
				for (ValueMapItem item : comboItems) {
					String value = item.getValue();
					if(value != null && value.equals(bill.getString(key))) {
						str = item.getName().getLocaleValue();
						break;
					}
				}
			} else if (prop instanceof PictureProp) {
				// 图片
			} else if (prop instanceof BasedataProp) {
				str = bill.getDynamicObject(key).getString("name");// 基础资料
			} else {
				str = bill.get(key).toString();// 文本
			}
		}
		return str;
	}

}
