package com.itopview.wm.sys.formplugin.dynamic;

import java.util.Arrays;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.container.Container;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.metadata.form.container.FlexPanelAp;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * 业务卷宗明细容器-动态表单插件
 * @description:
 * @author longh
 * @date 2021年11月5日 上午12:37:05
 */
public class BizFileContainerEdit extends AbstractFormPlugin {

	private final static String KEY_DATAFLEX = "tpv_dataflex";
	private final static String KEY_DATACHILD = "tpv_cm_bizfilepanel";
	
	@Override
	public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        
        IFormView view = this.getView();
        FormShowParameter showForm = view.getFormShowParameter();
        Map<String, Object> customParam = (Map<String, Object>)showForm.getCustomParams();
        
        Object fid = customParam.get("fid");
        if(fid != null) {
        	DynamicObject[] lv2s = BusinessDataServiceHelper.load("tpv_cm_bizfiletemplate",
        			"id,name,parent", new QFilter[] { new QFilter("parent", QCP.equals, fid.toString()) });
            
        	Container dataflex = view.getControl(KEY_DATAFLEX);
        	
            int index = 1;
        	for (DynamicObject lv2 : lv2s) {
        		String flexKey = "flex" + lv2.getPkValue().toString();
        		
        		FlexPanelAp flex = new FlexPanelAp();
                flex.setKey(flexKey);
                flex.setGrow(0);
                flex.setShrink(0);
                
                dataflex.addControls(Arrays.asList(flex.createControl()));
        		
                
        		FormShowParameter showParameter = new FormShowParameter();
        		showParameter.setStatus(OperationStatus.EDIT);
        		showParameter.getOpenStyle().setShowType(ShowType.InContainer);
        		showParameter.getOpenStyle().setTargetKey(flexKey);
        		showParameter.setFormId(KEY_DATACHILD);
        		Map<String, Object> customParams = new HashMap<>();
        		customParams.put("index", index);
        		customParams.put("fid", lv2.getPkValue());
        		customParams.put("title", lv2.getString("name"));
        		customParams.put("nodeId", customParam.get("nodeId"));
        		customParams.put("uuid", customParam.get("uuid"));
            	showParameter.setCustomParams(customParams);
        		view.showForm(showParameter);
        		index++;
			}
        }
		
    }
	
}
