package com.itopview.wm.sys.formplugin.dynamic;

import java.util.EventObject;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import com.itopview.wm.sys.utils.BizFileBuildHelper;
import com.itopview.wm.utils.DynamicObjectUtil;

import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.dynamicobject.DynamicComplexProperty;
import kd.bos.dataentity.metadata.dynamicobject.DynamicSimpleProperty;
import kd.bos.entity.EntryType;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.datamodel.events.BizDataEventArgs;
import kd.bos.entity.datamodel.events.GetEntityTypeEventArgs;
import kd.bos.entity.property.BasedataProp;
import kd.bos.entity.property.DateTimeProp;
import kd.bos.entity.property.DecimalProp;
import kd.bos.entity.property.FieldProp;
import kd.bos.entity.property.TextProp;
import kd.bos.exception.ErrorCode;
import kd.bos.exception.KDException;
import kd.bos.form.ClientProperties;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.Button;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.form.events.LoadCustomControlMetasArgs;
import kd.bos.form.events.OnGetControlArgs;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.metadata.form.control.EntryAp;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * 业务卷宗表体-动态表单插件
 * @description:
 * @author longh
 * @date 2021年9月23日 下午7:07:07
 */
public class BizFilePanelChildEdit extends AbstractFormPlugin implements HyperLinkClickListener{
	private final static String KEY_ENTRYENTITY = "tpv_entryentity";
	private final static String KEY_ID = "fid";
	private final static String KEY_TITLE = "title";
	private final static String KEY_NODE = "nodeId";
	private final static String KEY_UUID = "uuid";
	private final static String KEY_REQENTITY = "tpv_selectentity";
	private final static String KEY_COLMAP = "tpv_colmap";
	private final static String KEY_RELATION = "tpv_relation";
	private final static String KEY_FILTERGIRD = "tpv_filtergird";
	private final static String KEY_REQBILL = "tpv_requirebill";
	private final static String KEY_RELBILL = "tpv_relationbill";
	private static Map<String, BizFileBuildHelper> buildHelpers = new HashMap<>();
	
	/**
	 * 界面显示前，触发此事件：向前端界面输出动态添加的字段、控件
	 * 
	 * @remark 这个事件只能向前端界面添加字段、控件；后台的视图模型、数据模型，均没有改变
	 */
	@Override
	public void loadCustomControlMetas(LoadCustomControlMetasArgs e) {
		super.loadCustomControlMetas(e);
		// 动态添加单据头字段、按钮
//		FlexPanelAp headPanelAp = new FlexPanelAp();
//		headPanelAp.setKey("headAp");
//		// 动态添加一个按钮
//		ButtonAp buttonAp = new ButtonAp();
//		buttonAp.setId("autobutton1");
//		buttonAp.setKey("autobutton1");
//		buttonAp.setName(new LocaleString("自动添加的按钮"));
//		headPanelAp.getItems().add(buttonAp);
//		Map<String, Object> mapHead = new HashMap<>();
//		mapHead.put(ClientProperties.Id, "tpv_flexpanelap");
//		mapHead.put(ClientProperties.Items, headPanelAp.createControl().get(ClientProperties.Items));
//		e.getItems().add(mapHead);
		
		FormShowParameter showForm = (FormShowParameter) e.getSource();
        Map<String, Object> customParam = (Map<String, Object>)showForm.getCustomParams();
        BizFileBuildHelper buildHelper = this.initBuildHelper(customParam);
        
		EntryAp entryAp = buildHelper.getEntryAp();
		Map<String, Object> mapEntry = new HashMap<>();
		mapEntry.put(ClientProperties.Id, KEY_ENTRYENTITY);
		mapEntry.put(ClientProperties.Columns, entryAp.createControl().get(ClientProperties.Columns));
		e.getItems().add(mapEntry);
	}
	
	private BizFileBuildHelper initBuildHelper(Map<String, Object> customParam) {
		String fid = customParam.get(KEY_ID).toString();
        String title = customParam.get(KEY_TITLE).toString();
        String nodeId = customParam.get(KEY_NODE).toString();
        String uuid = customParam.get(KEY_UUID).toString();
        String tpv_selectentity = customParam.get(KEY_REQENTITY).toString();
        String tpv_colmap = customParam.get(KEY_COLMAP).toString();
        String tpv_relation = customParam.get(KEY_RELATION).toString();
        String tpv_filtergird = customParam.get(KEY_FILTERGIRD).toString();
        String tpv_requirebill = customParam.get(KEY_REQBILL).toString();
        String tpv_relationbill = customParam.get(KEY_RELBILL).toString();
        BizFileBuildHelper buildHelper = new BizFileBuildHelper(title, nodeId, uuid, tpv_selectentity, tpv_colmap, tpv_relation, tpv_filtergird, tpv_requirebill, tpv_relationbill);
        buildHelpers.put(fid, buildHelper);
        
		return buildHelper;
	}

	/**
	 * 此事件在系统要用到表单主实体模型时触发
	 * 
	 * @param e
	 * @remark 插件修改原始主实体，注册自定义属性，返回新的主实体给系统
	 */
	@Override
	public void getEntityType(GetEntityTypeEventArgs e) {
		// 取原始的主实体
		MainEntityType oldMainType = e.getOriginalEntityType();
		// 复制主实体
		MainEntityType newMainType = null;
		try {
			newMainType = (MainEntityType) oldMainType.clone();
		} catch (CloneNotSupportedException exp) {
			throw new KDException(exp, new ErrorCode("LoadCustomControlMetasSample", exp.getMessage()));
		}
		newMainType.setDbIgnore(false);
		// 为自定义的字段，向主实体注册字段属性
		this.registDynamicProps(newMainType);
		// 回传主实体给系统
		e.setNewEntityType(newMainType);
	}
	
	/**
	 * 向主实体注册动态添加的属性
	 */
	private void registDynamicProps(MainEntityType newMainType) {
		// 向单据体动态注册一个新的文本属性
		EntryType entryType = (EntryType) newMainType.getAllEntities().get(KEY_ENTRYENTITY);
		for (IDataEntityProperty prop : this.getBuildHelper().getSelectedProp()) {
			IDataEntityProperty propClone = null;
			// 把新字段，注册到单据体
			if(prop instanceof DynamicSimpleProperty) {
				//对字段的复杂实体做简化，用于规避构造的实体字段较多后出现的冲突问题
				FieldProp fieldProp = prop instanceof TextProp ? new TextProp() : 
										prop instanceof DecimalProp ? new DecimalProp() : 
										prop instanceof DateTimeProp ? new DateTimeProp() : null;
				if(fieldProp == null) {
					//未重新定义字段的克隆后注册，有错误风险
					try {
						propClone = (IDataEntityProperty) prop.clone();
					} catch (CloneNotSupportedException e) {
						throw new KDException(e, new ErrorCode("LoadCustomControlMetasSample", e.getMessage()));
					}
					entryType.registerSimpleProperty((DynamicSimpleProperty) propClone);
				}else {
					fieldProp.setName(prop.getName());
					entryType.registerSimpleProperty(fieldProp);
				}
			}else if(prop instanceof DynamicComplexProperty){
				DynamicComplexProperty fieldProp = prop instanceof BasedataProp ? new BasedataProp() : null;
				if(fieldProp == null) {
					try {
						propClone = (IDataEntityProperty) prop.clone();
					} catch (CloneNotSupportedException e) {
						throw new KDException(e, new ErrorCode("LoadCustomControlMetasSample", e.getMessage()));
					}
					entryType.registerComplexProperty((DynamicComplexProperty) propClone);
				}else {
					fieldProp.setName(prop.getName());
					fieldProp.setComplexType(((DynamicComplexProperty) prop).getComplexType());
					entryType.registerComplexProperty(fieldProp);
				}
			}
		}
	}
	
	private BizFileBuildHelper getBuildHelper() {
        Map<String, Object> customParam = this.getView().getFormShowParameter().getCustomParams();
        String fid = customParam.get(KEY_ID).toString();
        String uuid = customParam.get(KEY_UUID).toString();
        BizFileBuildHelper buildHelper = buildHelpers.get(fid);
        if(buildHelper == null || !uuid.equals(buildHelper.getUuid())) {
        	return this.initBuildHelper(customParam);
        }
        
		return buildHelper;
	}
	
	/**
	 * 此事件在表单创建界面数据包时触发
	 * 
	 * @remark 由插件自行创建界面数据包，包含自定义字段
	 */
	@Override
	public void createNewData(BizDataEventArgs e) {
		BizFileBuildHelper buildHelper = this.getBuildHelper();
		String requireBillKey = buildHelper.getRequireBillKey();
		DynamicObject[] requireBills = buildHelper.getRequireBills();
		Map<String, List<IDataEntityProperty>> entityProp = buildHelper.getEntityProp();
		
		DynamicObject dataEntity = new DynamicObject(this.getModel().getDataEntityType());
		DynamicObjectCollection rows = dataEntity.getDynamicObjectCollection(KEY_ENTRYENTITY);
		int pageSize = 0;
//		List<String> createDateKeys = new ArrayList<>();
		if(requireBills != null) {
			for (DynamicObject bill : requireBills) {
				DynamicObject newRow = new DynamicObject(rows.getDynamicObjectType());
				for (IDataEntityProperty prop : entityProp.get(requireBillKey)) {
//					if(prop instanceof CreateDateProp) {
//						createDateKeys.add(prop.getName());
//					}
					newRow.set(prop.getName(), bill.get(prop.getName()));
				}
				boolean hasNotEntry = true;
				for (Entry<String, List<IDataEntityProperty>> props : entityProp.entrySet()) {
					String entityName = props.getKey();
					if(buildHelper.getSelectedEntity().contains(entityName)) {
						DynamicObjectCollection entry = bill.getDynamicObjectCollection(entityName);
						if(entry.size() > 0) {
							hasNotEntry = false;
							boolean firstRow = true;
							for (DynamicObject obj : entry) {
								DynamicObject newEntryRow = new DynamicObject(newRow.getDynamicObjectType());
//								for (String createDateKey : createDateKeys) {
//									newEntryRow.set(createDateKey, "1");
//								}
								if(firstRow) {
									DynamicObjectUtil.copyDynamicObject(newRow, newEntryRow);
									firstRow = false;
								}
								for (IDataEntityProperty prop : props.getValue()) {
									newEntryRow.set(prop.getName(), obj.get(prop.getName()));
								}
								rows.add(newEntryRow);
							}
						}
					}
				}
				if(hasNotEntry) {
					rows.add(newRow);
				}
			}
			pageSize = requireBills.length;
		}
		e.setDataEntity(dataEntity);
		
		Map<String, Object> param = new HashMap<>();
        Map<String, Object> textMap = new HashMap<>();
        textMap.put("zh_CN", buildHelper.getTitle().toString() + "【" + pageSize + "】条记录");
        param.put(ClientProperties.Text, textMap);
        this.getView().updateControlMetadata(KEY_ENTRYENTITY, param );
	}

	/**
	 * 此事件在把数据绑定到界面之前触发： 系统会调用FormDataBinder对象，把字段值输出给前端字段编辑控件；
	 * 
	 * @param e
	 * @remark 动态添加的字段，在FormDataBinder中并没有记录，因此，默认不会绑定动态添加的字段值；
	 *         必须在此事件，向FormDataBinder中注册动态添加的字段
	 */
	@Override
	public void beforeBindData(EventObject e) {
		// 单据头添加的字段、控件，注入到容器面板的控件编程模型中
//		FlexPanelAp headPanelAp = new FlexPanelAp();
//		headPanelAp.setKey("headAp");
//		// 动态添加一个按钮
//		ButtonAp buttonAp = new ButtonAp();
//		buttonAp.setId("autobutton1");
//		buttonAp.setKey("autobutton1");
//		buttonAp.setName(new LocaleString("自动添加的按钮"));
//		headPanelAp.getItems().add(buttonAp);
//		Container myFldPanel = (Container)this.getView().getControl("tpv_flexpanelap");
//		myFldPanel.getItems().addAll(headPanelAp.buildRuntimeControl().getItems());
//		this.getView().createControlIndex(myFldPanel.getItems());
		
		// 单据体添加的字段，注入到单据体表格的控件编程模型中
		EntryAp dynamicEntryAp = this.getBuildHelper().getEntryAp();
		EntryGrid entryGrid = this.getView().getControl(KEY_ENTRYENTITY);
		List<Control> fieldEdits = dynamicEntryAp.buildRuntimeControl().getItems();
		for (Control fieldEdit : fieldEdits) {
			fieldEdit.setView(this.getView());
			entryGrid.getItems().add(fieldEdit);
		}
	}

	/**
	 * 用户与自定义的控件进行交互时，会触发此事件
	 * 
	 * @remark 插件在此事件中，创建自定义控件的编程模型，并侦听其事件
	 */
	@Override
	public void onGetControl(OnGetControlArgs e) {
		String key = e.getKey();
		List<IDataEntityProperty> selectedProp = this.getBuildHelper().getSelectedProp();
		for (IDataEntityProperty prop : selectedProp) {
			if(key.equals(prop.getName()) && prop instanceof BasedataProp) {
				BasedataEdit basedataEdit = new BasedataEdit();
				basedataEdit.setKey(key);
				basedataEdit.setEntryKey(key);
				basedataEdit.setView(this.getView());
				e.setControl(basedataEdit);
			}
		}
		if (key.equals("autobutton1")) {
			// 用户点击按钮时，会触发此事件：创建按钮的控件编程模型Button实例返回
			Button button = new Button();
			button.setKey("autobutton1"); // 必须
			button.setView(this.getView()); // 必须
			button.addClickListener(this);
			e.setControl(button);
		} 
	}
	
	@Override
	public void registerListener(EventObject e) {
		super.registerListener(e);
		EntryGrid grid = (EntryGrid) this.getControl(KEY_ENTRYENTITY);// 分录超链接监听
		grid.addHyperClickListener(this);
	}
	
	@Override
	public void click(EventObject evt) {
		super.click(evt);
		String key = ((Control) evt.getSource()).getKey();
		if (key.equals("autobutton1")) {
//			DynamicObject bill = BusinessDataServiceHelper.loadSingle("tpv_bd_tradeproperty", "id", new QFilter[] {new QFilter("name", QCP.equals, "代理出口")});
//			this.getModel().setValue("tpv_tradeproperty", bill, 0);
			DynamicObject obj1 = (DynamicObject) this.getModel().getValue("tpv_tradeproperty", 0);
			String text1 = (String) this.getModel().getValue("billno", 0);
			this.getView().showMessage("此时的值是：" + text1 + " and " + (obj1 == null ? "null" : obj1.toString()));
		}
	}

	@Override
	public void hyperLinkClick(HyperLinkClickEvent hyclick) {
		String name = hyclick.getFieldName();
		int rowIndex = hyclick.getRowIndex();
		BizFileBuildHelper buildHelper = this.getBuildHelper();
		switch (name) {
		case "billno":   
		case "number": 
			String requireBillKey = buildHelper.getRequireBillKey();
			String billno = (String) this.getModel().getValue(name, rowIndex);
			DynamicObject bill = BusinessDataServiceHelper.loadSingle(requireBillKey, "id", new QFilter[] {new QFilter(name, QCP.equals, billno)});
			BillShowParameter showParameter = new BillShowParameter();
			showParameter.setFormId(requireBillKey);
			showParameter.setPkId(bill.getPkValue());
			showParameter.setStatus(OperationStatus.VIEW);
			showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
			this.getView().showForm(showParameter);
			break;
		default:
			break;
		}
	}
	
}
