package com.itopview.wm.sys.formplugin.dynamic;

import java.util.Arrays;
import java.util.EventObject;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.itopview.wm.sys.utils.BizFileBuildHelper;

import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.container.Container;
import kd.bos.form.control.Label;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.metadata.form.container.FlexPanelAp;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * 业务卷宗表头-动态表单插件
 * @description:
 * @author longh
 * @date 2021年9月23日 下午7:07:07
 */
public class BizFilePanelEdit extends AbstractFormPlugin {

	private final static String KEY_DATAFLEX = "tpv_dataflex";
	private final static String KEY_DATACHILD = "tpv_cm_bizfilepanelchild";
	
	@Override
	public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        
        IFormView view = this.getView();
        Container dataflex = view.getControl(KEY_DATAFLEX);
        
        FormShowParameter showForm = view.getFormShowParameter();
        Map<String, Object> customParam = (Map<String, Object>)showForm.getCustomParams();
        
        int index = (int) customParam.get("index");
        Label tpv_labelap = this.getControl("tpv_labelap");
        tpv_labelap.setText("" + index);
        
        Object fid = customParam.get("fid");
        Object title = customParam.get("title");
        Object nodeId = customParam.get("nodeId");
        Label tpv_titlelabel = this.getControl("tpv_titlelabel");
        tpv_titlelabel.setText(title.toString());
        	
        boolean ispass = true;
        int size = 0;
        
        DynamicObject[] lv3s = BusinessDataServiceHelper.load("tpv_cm_bizfiletemplate",
    			"id,name,tpv_selectentity,tpv_colmap,tpv_relation,tpv_filtergird,tpv_requirebill,tpv_relationbill", 
    				new QFilter[] { new QFilter("parent", QCP.equals, fid.toString()) });
        for (DynamicObject lv3 : lv3s) {
        	String flexKey = "flex" + lv3.getPkValue().toString();
        	FlexPanelAp flex = new FlexPanelAp();
            flex.setKey(flexKey);
            flex.setOverflow("hidden");
            
            dataflex.addControls(Arrays.asList(flex.createControl()));
            
    		
    		FormShowParameter showParameter = new FormShowParameter();
    		showParameter.setStatus(OperationStatus.EDIT);
    		showParameter.getOpenStyle().setShowType(ShowType.InContainer);
    		showParameter.getOpenStyle().setTargetKey(flexKey);
    		showParameter.setFormId(KEY_DATACHILD);
    		Map<String, Object> customParams = new HashMap<>();
    		customParams.put("fid", lv3.getPkValue());
    		customParams.put("title", lv3.getString("name"));
    		customParams.put("nodeId", nodeId);
    		customParams.put("uuid", customParam.get("uuid"));
    		customParams.put("tpv_selectentity", lv3.getString("tpv_selectentity"));
    		customParams.put("tpv_colmap", lv3.getString("tpv_colmap"));
    		customParams.put("tpv_relation", lv3.getString("tpv_relation"));
    		customParams.put("tpv_filtergird", lv3.getString("tpv_filtergird"));
    		if(lv3.getDynamicObject("tpv_requirebill") != null && lv3.getDynamicObject("tpv_relationbill") != null) {
    			
    			BizFileBuildHelper bizFileBuildHelper = new BizFileBuildHelper(nodeId.toString(), 
    					lv3.getString("tpv_colmap"), lv3.getString("tpv_relation"), lv3.getString("tpv_filtergird"), 
    					lv3.getDynamicObject("tpv_requirebill").getString("number"), lv3.getDynamicObject("tpv_relationbill").getString("number"));
    			DynamicObject[] requireBills = bizFileBuildHelper.getRequireBills();
    			List<String> selectedField = bizFileBuildHelper.getSelectedField();
    			if(requireBills != null) {
    				for (DynamicObject bill : requireBills) {
    					if(selectedField.contains("billstatus") && !"C".equals(bill.getString("billstatus"))) {
    						ispass = false;
    					}
    					if(selectedField.contains("status") && !"C".equals(bill.getString("status"))) {
    						ispass = false;
    					}
    				}
        			size += requireBills.length;
    			}
    			
    			customParams.put("tpv_requirebill", lv3.getDynamicObject("tpv_requirebill").getString("number"));
    			customParams.put("tpv_relationbill", lv3.getDynamicObject("tpv_relationbill").getString("number"));
    			showParameter.setCustomParams(customParams);
        		view.showForm(showParameter);
    		}
    		
		}
        
        if(size > 0) {
        	if(ispass) {
        		this.setPassedVisible(0);
        	}else {
        		this.setPassedVisible(1);
        	}
        }else {
        	this.setPassedVisible(2);
        }
		
    }

	private void setPassedVisible(int num) {
		//0：已通过，1：等待中，2：未开始
		String[] passFlexs = {"tpv_passed", "tpv_waited", "tpv_unstarted"};
		for (int i = 0; i < passFlexs.length; i++) {
			boolean visible = i == num ? true : false;
			this.getView().setVisible(visible, passFlexs[i]);
		}
	}
	
	
	
}
