package com.itopview.wm.sys.formplugin.dynamic;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.dataentity.serialization.SerializationUtils;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.filter.FilterBuilder;
import kd.bos.entity.filter.FilterCondition;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.container.TabPage;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * 业务卷宗-动态表单插件
 * tpv_cm_bizfilequick
 * @description:用于单据便捷跳转
 * @author longh
 * @date 2022年1月10日 下午12:16:47
 */
public class BizFileQuickEdit extends AbstractFormPlugin {
	
	@Override
	public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        int pageNo = 0;
        IFormView view = this.getView();
        FormShowParameter showForm = view.getFormShowParameter();
        Map<String, Object> customParam = (Map<String, Object>)showForm.getCustomParams();
        String entityNumber = (String) customParam.get("entityNumber");
        String billno = (String) customParam.get("billno");
        
		@SuppressWarnings("unchecked")
		List<String> nodeIds = (List<String>) customParam.get("nodeId");
		
		MainEntityType billType  = EntityMetadataCache.getDataEntityType(entityNumber); 
        //查询涉及单据方案并筛选符合数据范围的方案
        List<Object> masterids = new ArrayList<>();
        QFilter qFilter1 = new QFilter("tpv_requirebill.number", QCP.equals, entityNumber);
        qFilter1.and(new QFilter("enable", QCP.equals, "1"));
		DynamicObject[] lv3s = BusinessDataServiceHelper.load("tpv_cm_bizfiletemplate",
    			"id,name,parent,parent.parent.id,tpv_requirebill.modeltype,tpv_filtergird", 
    			qFilter1.toArray());
        for (DynamicObject lv3 : lv3s) {
        	List<QFilter> qFilters = new ArrayList<>();
        	String tpv_filtergird = lv3.getString("tpv_filtergird");
			if(!StringUtils.isBlank(tpv_filtergird)) {
				FilterCondition filterCondition = SerializationUtils.fromJsonString(tpv_filtergird, FilterCondition.class);
				if (filterCondition != null){
       			 	FilterBuilder fBuilder = new FilterBuilder(billType, filterCondition); 
       			 	fBuilder.buildFilter(); 
       			 	qFilters.addAll(fBuilder.getQFilters());
			    }
			}
			if(qFilters.size() > 0) {
				String noKey = "BaseFormModel".equals(lv3.getString("tpv_requirebill.modeltype")) ? "number" : "billno";
				qFilters.add(new QFilter(noKey, QCP.equals, billno));
				DynamicObject bill = BusinessDataServiceHelper.loadSingle(entityNumber, "id", qFilters.toArray(new QFilter[0]));
				if(bill == null) {
					continue;
				}
			}
        	masterids.add(lv3.get("parent.parent.id"));
		}
        if(masterids.size() > 0) {
        	//查询核心单据方案并筛选符合数据范围的方案
    		QFilter qFilter = new QFilter("tpv_iscorebill", QCP.equals, true);
    		qFilter.and(new QFilter("parent.parent.id", QCP.in, masterids));
    		qFilter.and(new QFilter("enable", QCP.equals, "1"));
    		DynamicObject[] coreTemps = BusinessDataServiceHelper.load("tpv_cm_bizfiletemplate", 
    				"id,parent,parent.parent,tpv_requirebill,tpv_requirebill.modeltype,tpv_filtergird", qFilter.toArray());
            for (DynamicObject coreTemp : coreTemps) {
            	String coreEntityNumber = coreTemp.getString("tpv_requirebill.number");
            	MainEntityType coreBillType  = EntityMetadataCache.getDataEntityType(coreEntityNumber);
        		
            	List<QFilter> qFilters = new ArrayList<>();
            	String tpv_filtergird = coreTemp.getString("tpv_filtergird");
    			if(!StringUtils.isBlank(tpv_filtergird)) {
    				FilterCondition filterCondition = SerializationUtils.fromJsonString(tpv_filtergird, FilterCondition.class);
    				if (filterCondition != null){
           			 	FilterBuilder fBuilder = new FilterBuilder(coreBillType, filterCondition); 
           			 	fBuilder.buildFilter(); 
           			 	qFilters.addAll(fBuilder.getQFilters());
    			    }
    			}
    			List<String> coreIds = new ArrayList<>();
    			boolean isCore = entityNumber.equals(coreEntityNumber);
    			if(isCore) {
    				coreIds.add(billno);
    			}else {
    				coreIds.addAll(nodeIds);
    			}
    			for (String nodeId : coreIds) {
        			if(!isCore || qFilters.size() > 0) {
        				String coreNoKey = "BaseFormModel".equals(coreTemp.getString("tpv_requirebill.modeltype")) ? "number" : "billno";
        				List<QFilter> qFilters2 = new ArrayList<>();
        				qFilters2.addAll(qFilters);
        				qFilters2.add(new QFilter(coreNoKey, QCP.equals, nodeId));
        				DynamicObject bill = BusinessDataServiceHelper.loadSingle(coreEntityNumber, "id", qFilters2.toArray(new QFilter[0]));
        				if(bill == null) {
        					continue;
        				}
        			}
        			DynamicObject core = coreTemp.getDynamicObject("parent.parent");
        			String tabpageapKey = "tpv_tabpageap" + pageNo++;
        			TabPage tabPage = view.getControl(tabpageapKey);
        			tabPage.setText(new LocaleString(core.getString("name")));
        			view.setVisible(true, tabpageapKey);
                	BizFileQueryEdit.active2Form(view, core.getPkValue(), nodeId, ShowType.InContainer, tabpageapKey);
    			}
    		}
        }
        if(pageNo == 0) {
        	view.showTipNotification("未查询到符合条件的业务卷宗方案！");
        }
    }
	
}
