package com.itopview.wm.sys.formplugin.dynamic;

import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.IFormView;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.control.Control;
import kd.bos.form.control.Search;
import kd.bos.form.control.events.SearchEnterEvent;
import kd.bos.form.control.events.SearchEnterListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.Collections;
import java.util.EventObject;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * 文档检索-动态表单插件
 *
 * @author longh
 * @description:
 * @date 2024年2月19日
 */
public class FileSearchEdit extends AbstractFormPlugin implements Plugin, SearchEnterListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("tpv_search");
        final Search search = this.getControl("tpv_searchap");
        search.addEnterListener(this);
    }

    public void click(EventObject evt) {
        super.click(evt);
        Control c = (Control) evt.getSource();
        String key = c.getKey();
        if ("tpv_search".equals(key)) {
            Search search = this.getControl("tpv_searchap");
            this.infor(search.getSearchKey());
        }
    }

    @Override
    public void search(SearchEnterEvent arg0) {
        this.infor(arg0.getText());
    }

    @Override
    public List<String> getSearchList(SearchEnterEvent evt) {
        String text = evt.getText();
        if (YEM.isEmpty(text)) {
            return Collections.emptyList();
        } else {
            QFilter qFilter = new QFilter("fattachmentname", QCP.like, "%" + text + "%");
            String selectfields = DynamicObjectUtil.getSelectfields("tpv_fileview");
            DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_fileview", selectfields, qFilter.toArray(), "fcreatetime desc");
            return Stream.of(bills).map(x -> x.getString("fattachmentname")).collect(Collectors.toList());
        }
    }

    private void infor(String searchKey) {
        IFormView view = this.getView();
        if (YEM.isEmpty(searchKey)) {
            view.showTipNotification("请输入要搜索的文件名称。");
            return;
        }
        ListShowParameter listShowParameter = ShowFormHelper.createShowListForm("tpv_fileview", true, 1, false);
        listShowParameter.getListFilterParameter().setFilter(new QFilter("fattachmentname", QCP.like, "%" + searchKey + "%"));
        this.getView().showForm(listShowParameter);

        Search search = this.getControl("tpv_searchap");
        search.setSearchKey(searchKey);
    }

}