package com.itopview.wm.sys.formplugin.dynamic;

import java.math.BigDecimal;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

import com.alibaba.druid.util.StringUtils;
import com.grapecity.documents.excel.B;

import kd.bos.bec.service.formplugin.EvtHttpPlugin;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.BeforeClickEvent;
import kd.bos.form.control.events.CellClickEvent;
import kd.bos.form.control.events.CellClickListener;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

//额度测算单附件回填
public class IndexNumEdit extends AbstractBillPlugIn implements CellClickListener{
	
	@Override
	public void registerListener(EventObject e) {
		// TODO Auto-generated method stub
		super.registerListener(e);
		EntryGrid eg = this.getView().getControl("tpv_entryentity");
		eg.addCellClickListener(this);
	}
	@Override
	public void cellClick(CellClickEvent arg0) {
		String billstatus =(String)this.getModel().getValue("billstatus");
		if (!billstatus.equals("A")) {
			return;
		}
		// TODO Auto-generated method stub
		int row = arg0.getRow();
		DynamicObject dataEntity = this.getModel().getDataEntity(true);
		DynamicObjectCollection tpv_cmetrictype1 = this.getView().getModel().getEntryEntity("tpv_entryentity");
		//获取指标类型
		DynamicObject tpvindex = tpv_cmetrictype1.get(row).getDynamicObject("tpv_index");

		String rating = (String) this.getModel().getValue("tpv_metrictype");
		//获取点击单元格的字段及值
		
		String fieldKey = arg0.getFieldKey();
		if (!StringUtils.isEmpty(fieldKey) &&!StringUtils.isEmpty(rating)  &&  fieldKey.equals("tpv_metrics_rat") && rating.equals("B")) {
		
		FormShowParameter showParameter = new FormShowParameter();
		
		// 设置弹出页面的标识
		showParameter.setFormId("tpv_metrics_rat");
		Map<String,Object> map  = this.showInfoForm(row);
		
		// 存入获取到的动态表单数据
		showParameter.setCustomParams(map);
		// 状态
		showParameter.setStatus(OperationStatus.ADDNEW);
        //CloseCallBack参数：回调插件，回调标识
        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_bd_advcontoolbarap"));
        // 设置弹出页面打开方式
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        
        // 打开动态表单
        this.getView().showForm(showParameter);
		}
		
	}

	   private Map<String, Object> showInfoForm(int row) {
		   
			// 获取单据体
			DynamicObject dataEntity = this.getModel().getDataEntity(true);
			DynamicObjectCollection tpv_cmetrictype1 = this.getView().getModel().getEntryEntity("tpv_entryentity");
			
			//创建DynamicObjectCollection 保存字段值
			Map<String, Object> map = new HashMap<String, Object>();
			//获取指标
			DynamicObject tpvindex = tpv_cmetrictype1.get(row).getDynamicObject("tpv_index");
			String index = (String) tpvindex.getString("name");
			//获取测算模型
			Object measure = this.getModel().getValue("tpv_measurethemodel");
			String measurethemode = "";
			if (measure != null) {
				measurethemode = this.getModel().getValue("tpv_measurethemodel").toString();
			}
			// 根据指标 和测算模型 指标类型 获取 相对应的 指标分级分级关系表
			DynamicObject aCollection1 = BusinessDataServiceHelper.loadSingle("tpv_bd_metricrating",
					"desc modifytime,tpv_interval,tpv_fillinglimits_minimum,tpv_fillinglimits_maximum",
					new QFilter[] { new QFilter("tpv_modeltype", QCP.equals, measurethemode),			
							new QFilter("tpv_cmetrictype1",  QCP.equals, "B"),
							new QFilter("tpv_basedatafield.name", QCP.equals, index) });
			DynamicObjectCollection entry1 = aCollection1.getDynamicObjectCollection("tpv_entryentity");
			int i = 0;
			for (DynamicObject dynamicObject : entry1) {
				
				//获取区间描述
				String interval = dynamicObject.getString("tpv_interval");

				// 获取得分从 tpv_fillinglimits_minimum
				BigDecimal scorefrom1 = (BigDecimal) dynamicObject.getBigDecimal("tpv_fillinglimits_minimum");
				// 获取得分到（含） tpv_fillinglimits_maximum
				BigDecimal scorearrive1 = (BigDecimal)dynamicObject.getBigDecimal("tpv_fillinglimits_maximum");
				
				
				if (interval != null) {
					map.put("tpv_interval"+i, interval);
				}

				if (scorefrom1 != null) {
					map.put("tpv_fillinglimits_minimum"+i, scorefrom1);
				}
				if (scorearrive1 != null) {
					map.put("tpv_fillinglimits_maximum"+i, scorearrive1);
				}
				i++;
			}

		   return map;
	   }
	   
	   
	   /**
		 * 动态表单回填单据字段
		 */
		private void setInwardInfo (Map<String, Object> values) {
			IDataModel model = this.getModel();

			
			//获取行数
			model.setValue("tpv_metrics_rat", values.get("tpv_interval"));
			// 回填动态表单的区间描述
			//SaveServiceHelper.update( dataEntity );//写入数据库
		}
	   
	   @Override
		public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
			
			Object returnData = closedCallBackEvent.getReturnData();
			
			//判断标识是否匹配，并验证返回值不为空，不验证返回值可能会报空指针
	        if (StringUtils.equals(closedCallBackEvent.getActionId(),"tpv_bd_advcontoolbarap") && null != closedCallBackEvent.getReturnData()) {
	            //这里返回对象为Object，可强转成相应的其他类型，
	            // 单条数据可用String类型传输，返回多条数据可放入map中，也可使用json等方式传输
	            HashMap<String, Object> values = (HashMap<String,Object>) returnData;
	            this.setInwardInfo(values);
	        }
		}
	@Override
	public void cellDoubleClick(CellClickEvent arg0) {
		// TODO Auto-generated method stub
		
	}

}
