package com.itopview.wm.sys.formplugin.form;

import java.math.BigDecimal;
import java.util.EventObject;
import java.util.LinkedHashMap;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.parser.Feature;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.itopview.wm.utils.YEM;

import kd.bos.form.IFormView;
import kd.bos.form.control.CodeEdit;
import kd.bos.form.plugin.AbstractFormPlugin;

/**
 * 接口日志
 * 
 * @description 表单插件
 * @author longh
 * @date 2023年9月7日
 */
public class ApiLogFormPlugin extends AbstractFormPlugin {

	@Override
	public void afterBindData(EventObject e) {
		super.afterBindData(e);
		initData();
	}

	private void initData() {
		IFormView view = this.getView();
		String tpv_source_data = (String) this.getModel().getValue("tpv_source_data_tag");
		String tpv_target_data = (String) this.getModel().getValue("tpv_target_data_tag");
		CodeEdit tpv_sourceedit = view.getControl("tpv_sourceedit");
		CodeEdit tpv_targetedit = view.getControl("tpv_targetedit");
		tpv_sourceedit.setText(getPrettyTag(tpv_source_data));
		tpv_targetedit.setText(getPrettyTag(tpv_target_data));
	}

	private String getPrettyTag(String encryptData) {
		String str;
		try {
			Object obj = null;
			if (encryptData == null) {
				obj = null;
			} else if (encryptData.startsWith("{")) {
				obj = JSONObject.parseObject(encryptData, LinkedHashMap.class, new Feature[] { Feature.OrderedField });
			} else if (encryptData.startsWith("[")) {
				obj = JSONObject.parseArray(encryptData);
			} else {
				str = s(encryptData);
			}

			str = JSON.toJSONString(obj,
					new SerializerFeature[] { SerializerFeature.PrettyFormat, SerializerFeature.WriteMapNullValue });
		} catch (Exception e) {
			str = s(encryptData);
		}
		return subStringAndConcatTip(str);
	}

	private String subStringAndConcatTip(String param) {
		if (YEM.isNotEmpty(param) && param.length() > 102400) {
			param = param.substring(0, 102400);
			StringBuilder sb = new StringBuilder();
			// 请下载日志用文本编辑器查看
			sb.append(param).append("\n\n\n\n请注意：因内容太长，后续部分被自动截断，请联系管理员去后台查看...");
			return sb.toString();
		}
		return param;
	}

	private String s(Object o) {
		if (o == null) {
			return null;
		} else if (o instanceof BigDecimal) {
			return ((BigDecimal) o).toPlainString();
		} else {
			String s = o.toString();
			if (s == null) {
				return null;
			} else {
				s = s.trim();
				return s.length() == 0 ? null : s;
			}
		}
	}

}
