package com.itopview.wm.sys.formplugin.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.IFormView;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.FormOperate;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;

/**
 * @author ljw
 * @date 2023/9/6 14:21
 * @className ClientFormPlugin
 * @description 客户银行分录删行是效验付款申请单是否引用改行数据
 * 已移至tpv
 */
public class ClientFormPlugin extends AbstractFormPlugin {

    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
    super.beforeDoOperation(args);
    FormOperate formOperate = (FormOperate) args.getSource();
    switch (formOperate.getOperateKey()) {//操作类型
        case "deleteentry_bank"://删除分录
            this.showExchangerate(args);
            break;
    }
}

    private void showExchangerate(BeforeDoOperationEventArgs args) {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        DynamicObjectCollection accountname = (DynamicObjectCollection) this.getModel().getEntryEntity("entry_bank");//单据体分录
        if (accountname.size() > 0) {
            for (DynamicObject dynamicObject : accountname) {
                String bankaccount = dynamicObject.getString("bankaccount");//银行账号
                if ( "" != bankaccount) {
                    QFilter qFilter = new QFilter("entry.e_assacct", QCP.equals, bankaccount);//往来账户
                    qFilter.and(new QFilter("billstatus", QCP.equals, "C"));
                    DynamicObjectCollection query = QueryServiceHelper.query("ap_payapply", "id,billno"
                            , qFilter.toArray());
                    if (query.size() > 0) {
                        args.setCancel(true);//阻断删行
                        view.showTipNotification("付款申请单已引用该银行账号相关信息,该客商的这笔银行账户信息不允许删除；");
                    }
                }
            }
        }
    }
}
