package com.itopview.wm.sys.formplugin.form;

import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.BasedataProp;
import kd.bos.entity.property.TextProp;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.TextEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import org.apache.commons.lang3.StringUtils;

import java.math.BigDecimal;
import java.util.*;

/**
 * 动态表单
 */
public class PrintingFunctionFormPlugin extends AbstractFormPlugin implements BeforeF7SelectListener {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        // 侦听文本字段按钮点击事件
        this.addClickListeners("btnok", "btncancel");
        BasedataEdit fieldEdit = this.getView().getControl("tpv_selectstamp");
        fieldEdit.addBeforeF7SelectListener(this);

    }


    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        IDataModel model = this.getModel();
        String propertyName = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        ChangeData changeData = e.getChangeSet()[0];
        int rowIndex = changeData.getRowIndex();
        switch (propertyName) {
            case "tpv_sealstatus":
                // 获取用印方式
                String sealstatus = (String) model.getValue("tpv_sealstatus");
                if (sealstatus != null) {
                    if (!"F".equals(sealstatus)) {
                        BasedataEdit edit = this.getView().getControl("tpv_selectstamp");//印章
                        edit.setMustInput(true);
                        BasedataProp property = (BasedataProp) edit.getProperty();
                        property.setMustInput(true);
                    } else {
                        BasedataEdit edit = this.getView().getControl("tpv_selectstamp");//印章
                        edit.setMustInput(false);
                        BasedataProp property = (BasedataProp) edit.getProperty();
                        property.setMustInput(false);
                    }
                    //对方企业名称
                    if ("C".equals(sealstatus) || "D".equals(sealstatus) || "E".equals(sealstatus)) {
                        this.getView().setVisible(true, "tpv_othercompanyname", "tpv_othersignatory");
                        TextEdit edit = this.getView().getControl("tpv_othercompanyname");
                        edit.setMustInput(true);
                        TextProp property = (TextProp) edit.getProperty();
                        property.setMustInput(true);
                        BasedataEdit edits = this.getView().getControl("tpv_othersignatory");
                        edits.setMustInput(true);
                        BasedataProp propertys = (BasedataProp) edits.getProperty();
                        propertys.setMustInput(true);
                        IDataModel ParentModel = this.getView().getParentView().getModel();
                        //ParentModel.getValue("");
                    } else {
                        TextEdit edit = this.getView().getControl("tpv_othercompanyname");
                        edit.setMustInput(false);
                        TextProp property = (TextProp) edit.getProperty();
                        property.setMustInput(false);
                        BasedataEdit edits = this.getView().getControl("tpv_othersignatory");
                        edits.setMustInput(false);
                        BasedataProp propertys = (BasedataProp) edits.getProperty();
                        propertys.setMustInput(false);
                        this.getView().setVisible(false, "tpv_othercompanyname", "tpv_othersignatory");
                    }

                }
                break;
            default:
                break;
        }
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        IDataModel model = this.getModel();
        Control source = (Control) evt.getSource();
        if (StringUtils.equals("btnok", source.getKey())) {
            // 获取用印方式
            IFormView parentView = this.getView().getParentView(); //父视图
            IDataModel parentModel = parentView.getModel(); //父模型
            int index = parentModel.getEntryCurrentRowIndex("tpv_materialentry");  //获取选中行索引（传参携带）
            String attachmentname = (String) parentModel.getValue("tpv_attachmentname", index);
            String sealstatus = (String) model.getValue("tpv_sealstatus");//用印方式
            FormShowParameter showParameter = this.getView().getFormShowParameter();
            Integer tpv_assist = new Integer(0);
            Map<String, Object> maps = new HashMap<>();
            maps = showParameter.getCustomParams();//获取map表
            JSONObject tpv_personinfor = (JSONObject) maps.get("entryRowEntity");
            if (tpv_personinfor != null) {
                tpv_assist = tpv_personinfor.getInteger("seq") - 1;
            }
            HashMap<String, Object> hashMap = new HashMap<>();
            // 获取选择印章
            DynamicObject selectstamp = (DynamicObject) model.getValue("tpv_selectstamp");
            // 获取对方企业名称
            String othercompanyname = (String) model.getValue("tpv_othercompanyname");
            // 获取预审码位置
            String precencodelocation = (String) model.getValue("tpv_precencodelocation");
            // 获取选择印章
            DynamicObject othersignatory = (DynamicObject) model.getValue("tpv_othersignatory");
            // 获取内容缩放%
            BigDecimal contentscaling = (BigDecimal) model.getValue("tpv_contentscaling");
            Boolean substitute = (Boolean) model.getValue("tpv_substitute");

            if (sealstatus != null) {
                hashMap.put("sealstatus", sealstatus);
            }
            if (selectstamp != null) {
                hashMap.put("selectstamp", selectstamp.getLong("id"));
                hashMap.put("selectstampname", selectstamp.getString("name"));
                hashMap.put("selectstampfddid", selectstamp.getString("tpv_fddid"));
                hashMap.put("selectstampzgjid", selectstamp.getString("tpv_zgjid"));
            }

            if (othercompanyname != null) {
                hashMap.put("othercompanyname", othercompanyname);
            }
            if (precencodelocation != null) {
                hashMap.put("precencodelocation", precencodelocation);
            }
            if (othersignatory != null) {
                hashMap.put("precencodelocation", othersignatory.getLong("id"));
            }
            if (contentscaling.compareTo(BigDecimal.ZERO) > 0) {
                hashMap.put("contentscaling", contentscaling);
            }
            if (tpv_assist != null) {
                hashMap.put("aLong", tpv_assist);
            }
            if (substitute) {
                hashMap.put("substitute", substitute);
            } else {
                hashMap.put("substitute", substitute);
            }
            if (attachmentname != null) {
                hashMap.put("attachmentname", attachmentname);
            }
            hashMap.put("tpv_sealstatus", "B");
            this.getView().returnDataToParent(hashMap);//将数据传给父页面
            this.getView().close();
        } else if (StringUtils.equals(source.getKey(), "btncancel")) {
            this.getView().returnDataToParent(null);
            this.getView().close();
        }
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        System.out.println(name);
        switch (name) {
            case "tpv_selectstamp": {
                ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
                List<QFilter> QFilters = new ArrayList<QFilter>();
                String value = (String) this.getModel().getValue("tpv_sealstatus");
                if (value.equals("A")) {
                    QFilters.add(new QFilter("tpv_sealuse", QCP.equals, "B"));
                } else {
                    QFilters.add(new QFilter("tpv_sealuse", QCP.equals, "A"));
                }
                showParameter.getListFilterParameter().setQFilters(QFilters);
                break;
            }
        }
    }
}