package com.itopview.wm.sys.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.StyleCss;
import kd.bos.form.control.Control;
import kd.bos.form.control.Label;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.list.ListFilterParameter;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;

/**
 * @author zhouc
 * @date 2024/2/22 15:27
 * @className RequirApplyFormPlugIn
 * @description 洛钼需求申请风格一表单插件
 */
public class RequirApplyFormPlugIn extends AbstractBillPlugIn {
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject bizuser = dataEntity.getDynamicObject("bizuser");
        if (bizuser != null) {
            this.getView().getModel().setValue("kdtest_applierpic", bizuser.getString("picturefield"));
            String name = bizuser.getString("name");
            ((Label) this.getControl("kdtest_applierv")).setText(name);
            DynamicObjectCollection entryentity = bizuser.getDynamicObjectCollection("entryentity");
            if (entryentity.size() > 0) {
                DynamicObject dynamicObject = entryentity.get(0);
                DynamicObject dpt = dynamicObject.getDynamicObject("dpt");
                if (dpt != null) {
                    ((Label) this.getControl("kdtest_orgv")).setText(dpt.getString("name"));
                }
                ((Label) this.getControl("kdtest_applierpositionv")).setText(dynamicObject.getString("position"));
            }
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IDataModel model = this.getModel();
        FormShowParameter fsp = this.getView().getFormShowParameter();
        OperationStatus status = fsp.getStatus();
        String formId = fsp.getFormId();
        if (OperationStatus.ADDNEW == status) {
            if ("kdtest_reqdemo1".equals(formId)) {
                QFilter qFilter  = new QFilter("number", QCP.equals, "pm_requirapplybill1_BT");
                DynamicObject billType = BusinessDataServiceHelper.loadSingle("bos_billtype", "id", qFilter.toArray());
                this.getModel().setValue("billtype", billType);
            }
        }
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control c = (Control) evt.getSource();
        String key = c.getKey().toLowerCase();
        IDataModel model = this.getModel();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        if (key.equals("kdtest_changeapplier")) {
            ListShowParameter listpara = new ListShowParameter();
            listpara.setBillFormId("bos_user");
            listpara.setParentPageId(this.getView().getPageId());
            listpara.setMultiSelect(false);
            listpara.setStatus(OperationStatus.VIEW);
            listpara.getOpenStyle().setShowType(ShowType.Modal);
            ListFilterParameter listFilterParameter = new ListFilterParameter();
            QFilter qFilter = new QFilter("status", QCP.equals, "C");
            qFilter.and(new QFilter("enable", QCP.equals, "1"));
            listFilterParameter.setFilter(qFilter);
            listpara.setListFilterParameter(listFilterParameter);
            listpara.getOpenStyle().setCacheId(listpara.getPageId());
            listpara.setLookUp(true);

            //设置弹出子单据页面的样式
            StyleCss inlineStyleCss = new StyleCss();
            inlineStyleCss.setHeight("800");
            inlineStyleCss.setWidth("1400");
            listpara.getOpenStyle().setInlineStyleCss(inlineStyleCss);
            CloseCallBack closeCallBack = new CloseCallBack(this.getClass().getName(), "bos_user");
            listpara.setCloseCallBack(closeCallBack);
//            listpara.setCaption("暂估应收单");
            this.getView().showForm(listpara);
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);
        String actionId = e.getActionId();
        IDataModel model = this.getModel();
        if ("bos_user".equals(actionId)) {
            ListSelectedRowCollection listData = (ListSelectedRowCollection) e.getReturnData();
            if (listData != null && listData.size() > 0) {
                long arbusbillid = (long) listData.get(0).getPrimaryKeyValue();
                DynamicObject bizuser = BusinessDataServiceHelper.loadSingle(arbusbillid,"bos_user");
                if (bizuser != null) {
                    this.getView().getModel().setValue("bizuser",bizuser);
                    this.getView().getModel().setValue("kdtest_applierpic", bizuser.getString("picturefield"));
                    String name = bizuser.getString("name");
                    ((Label) this.getControl("kdtest_applierv")).setText(name);
                    DynamicObjectCollection entryentity = bizuser.getDynamicObjectCollection("entryentity");
                    if (entryentity.size() > 0) {
                        DynamicObject dynamicObject = entryentity.get(0);
                        DynamicObject dpt = dynamicObject.getDynamicObject("dpt");
                        if (dpt != null) {
                            ((Label) this.getControl("kdtest_orgv")).setText(dpt.getString("name"));
                        }
                        ((Label) this.getControl("kdtest_applierpositionv")).setText(dynamicObject.getString("position"));
                    }
                }
            }
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"kdtest_changeapplier"});
    }
}
