package com.itopview.wm.sys.formplugin.form;
import com.alibaba.nacos.common.utils.StringUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.form.control.Control;
import kd.bos.form.ShowType;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.orm.query.QFilter;

import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * 修改密码回填印章管理员
 * @author LiuHB
 * @version 1.0
 */
public class SealmanPlugin extends AbstractBillPlugIn {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        addClickListeners("tpv_replacement","tpv_password");
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control c = (Control)evt.getSource();
        String key = c.getKey().toLowerCase();
        switch (key) {
            case "tpv_replacement":
                //重置用印密码错误次数
                this.getView().getModel().setValue("tpv_passwordprints",0);
                break;
            case "tpv_password":
                //修改密码弹窗
                passwd("tpv_iscb_amend","tpv_password");
                break;
        }
    }

    private Map<String, Object> showInfoForm() {
        // 获取单据体
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Map<String, Object> map = new HashMap<>();
        DynamicObject staff = dataEntity.getDynamicObject("tpv_staff");
        String amcipher = dataEntity.getString("tpv_amcipher");
        if(staff!=null&&!amcipher.isEmpty()) {
            map.put("tpv_staff", staff.getString("name"));
            map.put("tpv_amcipher", amcipher);
        }
        return map;
    }
    /**
     * 动态表单回填单据字段
     */
    private void setInwardInfo(Map<String, Object> values) {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        model.setValue("tpv_amcipher",values.get("tpv_newcode"));
        model.setValue("tpv_amcipherdate",values.get("tpv_revampdate"));

    }

    /**
     * 动态表单关闭回调事件
     */

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        // super.closedCallBack(closedCallBackEvent);
        Object returnData = closedCallBackEvent.getReturnData();
        // 判断标识是否匹配，并验证动态表单返回数据不为空，不验证返回值可能会报空指针
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_password")
                && null != closedCallBackEvent.getReturnData()) {
            // 这里返回对象为Object，可强转成相应的其他类型，
            HashMap<String, Object> values = (HashMap<String, Object>) returnData;
            this.setInwardInfo(values);
        }
    }

    public void passwd(String dynamicform,String button){
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId(dynamicform);
        Map<String,Object> map=this.showInfoForm();
        showParameter.setCustomParams(map);
        showParameter.setCloseCallBack(new CloseCallBack(this, button));
        this.getView().showForm(showParameter);
    }

}


