package com.itopview.wm.sys.formplugin.form;

import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.AfterDeleteRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.control.AttachmentPanel;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.control.events.UploadListener;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * 外贸通用模板3基类
 *
 * @author longh
 * @description:1、分录原币金额汇总
 * @date 2022年6月16日 下午2:30:41
 */
public class Tpl3BillPlugIn extends AbstractBillPlugIn implements RowClickEventListener, UploadListener {
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        IDataModel model = this.getModel();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpv_materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品分录
//        if (tpv_materialentry.size() > 0) {
//            for (int i = 0; i < tpv_materialentry.size(); i++) {
//                DynamicObject dynamicObject = tpv_materialentry.get(i);
//                Boolean tpv_richardinputsx = dynamicObject.getBoolean("tpv_richardinputsx");//按理计输入
//                if(tpv_richardinputsx){
//                    this.getView().setEnable(false,i,"tpv_qty");
//                }
//            }
//        }

        boolean tpvRichardinput = (boolean) model.getValue("tpv_richardinput");
        String tpv_sourceofcoeff = (String) model.getValue("tpv_sourceofcoeff");
        if (tpvRichardinput) {
            this.getView().setEnable(true,"tpv_countthetable");
            this.getView().setEnable(true,"tpv_customization");
            this.getView().setEnable(true,"tpv_coefficients");
            if (tpv_materialentry.size() > 0) {
                for (int i = 0; i < tpv_materialentry.size(); i++) {
//                    this.getView().setEnable(false, i,"tpv_qty");
                    this.getView().setEnable(true, i, "tpv_coefficients"); //系数
                }
            }
        } else {
            this.getView().setEnable(false,"tpv_countthetable");
            this.getView().setEnable(false,"tpv_customization");
            this.getView().setEnable(false,"tpv_coefficients");
            if (tpv_materialentry.size() > 0) {
                for (int i = 0; i < tpv_materialentry.size(); i++) {
//                    this.getView().setEnable(true, i, "tpv_qty"); //数量
                    this.getView().setEnable(false, i, "tpv_coefficients"); //系数
                }
            }
        }
        if (!"B".equals(tpv_sourceofcoeff)) {
            this.getView().setEnable(false,"tpv_coefficient");
        } else if ("B".equals(tpv_sourceofcoeff)) {
            this.getView().setEnable(true,"tpv_coefficient");
        }

//        EntryGrid entryGrid = this.getControl("tpv_materialentry");//商品明细
//        int selectRows[] = entryGrid.getSelectRows();//获取选中的行号
//        if (selectRows.length <= 0) {
//            this.getModel().beginInit();
//            this.getModel().setValue("tpv_richardinput", false);
//            this.getModel().setValue("tpv_sourceofcoeff", "NULL");
//            this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
//            this.getModel().endInit();
//            this.getView().setEnable(false,"tpv_countthetable");
//            this.getView().setEnable(false,"tpv_customization");
//            this.getView().setEnable(false,"tpv_coefficient");
//        }
        DynamicObjectCollection entryRows = this.getModel().getEntryEntity("tpv_attachmentdetail");
        int entryCurrentRowIndex = model.getEntryCurrentRowIndex("tpv_attachmentdetail");
        if (entryRows.size() > 0) {
            afterData(entryRows, entryCurrentRowIndex);
        }
    }


    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String key = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();
        IDataModel model = this.getModel();
        switch (key) {
            case "tpv_drytonsnum"://干吨数量
            case "tpv_qty"://干吨数量
                verifydrytonsnum();//干吨数量不能大于数量
                break;
            case "tpv_price"://商品明细-单价

                break;
            case "tpv_amt"://商品明细-金额原币

                break;
            case "tpv_taxpramount"://商品明细-含税金额
                taxpramountSum();//计算表头金额原币、金额本位币等
                break;
            case "tpv_material"://物料编码
            case "tpv_specation"://规格
            case "tpv_shader"://材质
            case "tpv_origin"://产地
            case "tpv_richardinput"://按理计输入
            case "tpv_packnum"://包装数量
            case "tpv_sourceofcoeff"://系数来源
//                changeCoefficient(cd,key);
                changeCoefficientNew(cd,key);
                break;
            case "tpv_coefficient"://商品明细表头-系数
            case "tpv_coefficients"://商品明细-系数
//                setRowsCoefficient(cd);
                setRowsCoefficientNew(cd,key);
                break;
            default:
                break;
        }
    }

    private void setRowsCoefficient(ChangeData cd) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        BigDecimal tpv_coefficient = dataEntity.getBigDecimal("tpv_coefficient");//表头系数
        EntryGrid entryGrid = this.getControl("tpv_materialentry");//商品明细
        int selectRows[] = entryGrid.getSelectRows();//获取选中的行号
        if (selectRows.length >0) {
            List<String> seqFalse = new ArrayList<>();
            List<String> seqtrue = new ArrayList<>(); //按理计表
            List<String> seqtrueA = new ArrayList<>(); //按理计表
            List<String> seqtrueB = new ArrayList<>(); //自定义
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = this.getModel().getEntryRowEntity("tpv_materialentry", selectRow);
                boolean tpvRichardinputsx = dynamicObject.getBoolean("tpv_richardinputsx"); //按理计输入
                String tpv_sourceofcoeffsx = dynamicObject.getString("tpv_sourceofcoeffsx"); //系数来源
                if (!tpvRichardinputsx) {
                    seqFalse.add(dynamicObject.getString("seq"));
                }
                if (tpvRichardinputsx) {
                    seqtrue.add(dynamicObject.getString("seq"));
                }
                if ("A".equals(tpv_sourceofcoeffsx)) {
                    seqtrueA.add(dynamicObject.getString("seq"));
                }
                if ("B".equals(tpv_sourceofcoeffsx)) {
                    seqtrueB.add(dynamicObject.getString("seq"));
                }
            }
            if (seqFalse.size() > 0 & seqtrue.size() > 0) {
                this.getView().showTipNotification("选择行存在按理输入行和不按理计输入行！请重新选中行！");
                this.getModel().beginInit();
                this.getModel().setValue("tpv_coefficient", cd.getOldValue());
                this.getModel().endInit();
                this.getView().updateView("tpv_coefficient");
                return;
            }
            else if (seqtrueA.size() > 0 & seqtrueB.size() > 0) {
                this.getView().showTipNotification("选择行存在按理计表计算和按自定义计算！请重新选中行！");
                this.getModel().beginInit();
                this.getModel().setValue("tpv_coefficient", cd.getOldValue());
                this.getModel().endInit();
                this.getView().updateView("tpv_coefficient");
                return;
            }
        }
        for (int row : selectRows) {
            this.getModel().setValue("tpv_coefficients", tpv_coefficient, row);
        }
    }
    private void setRowsCoefficientNew(ChangeData cd, String keyName) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        BigDecimal tpv_coefficient = dataEntity.getBigDecimal("tpv_coefficient");//表头系数
        DynamicObjectCollection tpvMaterialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");
        if ("tpv_coefficient".equals(keyName)) {
            if (tpvMaterialentry.size() > 0) {
                for (int i = 0; i < tpvMaterialentry.size(); i++) {
                    this.getModel().setValue("tpv_coefficients", tpv_coefficient, i);
                    BigDecimal tpvPacknum = tpvMaterialentry.get(i).getBigDecimal("tpv_packnum");
                    BigDecimal qty = tpv_coefficient.multiply(tpvPacknum);
                    this.getModel().setValue("tpv_qty", qty, i);
                    this.getView().updateView("tpv_qty", i);
                }
            }
        }
        if ("tpv_coefficients".equals(keyName)) {
            int index = this.getModel().getEntryCurrentRowIndex("tpv_materialentry");
            BigDecimal tpvCoefficients = (BigDecimal) this.getModel().getValue("tpv_coefficients", index);
            BigDecimal tpvPacknum = tpvMaterialentry.get(index).getBigDecimal("tpv_packnum");
            BigDecimal qty = tpvCoefficients.multiply(tpvPacknum);
            this.getModel().setValue("tpv_qty", qty, index);
            this.getView().updateView("tpv_qty", index);
        }
    }

    private void taxpramountSum() {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        BigDecimal tpv_amount = BigDecimal.ZERO;
        DynamicObjectCollection tpvMaterialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");
        for (DynamicObject dynamicObject : tpvMaterialentry) {
            tpv_amount = tpv_amount.add(dynamicObject.getBigDecimal("tpv_taxpramount").setScale(2, BigDecimal.ROUND_DOWN));
        }
        model.setValue("tpv_amount", tpv_amount);//金额原币
    }


    public void verifydrytonsnum() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpv_materialentry=dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品分录
        for(DynamicObject materialentry:tpv_materialentry){
            BigDecimal tpv_qty=materialentry.getBigDecimal("tpv_qty");//数量
            BigDecimal tpv_drytonsnum=materialentry.getBigDecimal("tpv_drytonsnum");//干吨数量
            int row=materialentry.getInt("Seq");//行号
            if(tpv_drytonsnum.compareTo(tpv_qty)>0){
                this.getView().showTipNotification("商品分录第"+row+"行，干吨数量不能大于数量，请重新填写！");
            }
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        EntryGrid entryGrid = this.getView().getControl("tpv_materialentry");//商品明细
        if (entryGrid != null) {
            entryGrid.addRowClickListener(this);
        }
        AttachmentPanel attachmentPanel = this.getView().getControl("attachmentpanel");
        attachmentPanel.addUploadListener(this);
        EntryGrid entryGrids = this.getView().getControl("tpv_attachmentdetail");
        entryGrids.addRowClickListener(this);
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        EntryGrid entryGrid = (EntryGrid) evt.getSource();
        if (StringUtils.equals("tpv_materialentry", entryGrid.getKey())) {
//            selectRowChangecoeffic(entryGrid);
        }

        if (StringUtils.equals("tpv_attachmentdetail", entryGrid.getKey())) {
            DynamicObjectCollection entryRows = this.getModel().getEntryEntity("tpv_attachmentdetail");
            int row = evt.getRow();//选中行数
            if (row >= 0) {
                afterData(entryRows, row);
            }
        }
    }

    private void selectRowChangecoeffic(EntryGrid entryGrid) {
        // 获取选中行，数组为行号，从0开始
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length >0) {
            if (selectRows.length == 1) {
                DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_materialentry");//商品明细
                DynamicObject dynamicObject = entity.get(selectRows[0]);//数据
                Boolean tpv_richardinputsx = dynamicObject.getBoolean("tpv_richardinputsx");//按理计（分录隐藏）
                String tpv_sourceofcoeffsx = dynamicObject.getString("tpv_sourceofcoeffsx");//系数来源（隐藏）
                BigDecimal tpv_coefficient = dynamicObject.getBigDecimal("tpv_coefficients");//系数
                if(tpv_richardinputsx && tpv_sourceofcoeffsx.equals("B")){
                    this.getModel().beginInit();
                    this.getModel().setValue("tpv_richardinput", tpv_richardinputsx);
                    this.getModel().setValue("tpv_sourceofcoeff", tpv_sourceofcoeffsx);
                    this.getModel().setValue("tpv_coefficient", tpv_coefficient);
                    this.getModel().endInit();
                    this.getView().setEnable(true,"tpv_countthetable");
                    this.getView().setEnable(true,"tpv_customization");
                    this.getView().setEnable(true,"tpv_coefficient");
                }
                if(tpv_richardinputsx && tpv_sourceofcoeffsx.equals("A")){
                    this.getModel().beginInit();
                    this.getModel().setValue("tpv_richardinput", tpv_richardinputsx);
                    this.getModel().setValue("tpv_sourceofcoeff", tpv_sourceofcoeffsx);
                    this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
                    this.getModel().endInit();
                    this.getView().setEnable(true,"tpv_countthetable");
                    this.getView().setEnable(true,"tpv_customization");
                    this.getView().setEnable(false,"tpv_coefficient");
                }
                if(!tpv_richardinputsx){
                    this.getModel().beginInit();
                    this.getModel().setValue("tpv_richardinput", tpv_richardinputsx);
                    this.getModel().setValue("tpv_sourceofcoeff", "NULL");
                    this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
                    this.getModel().endInit();
                    this.getView().setEnable(false,"tpv_countthetable");
                    this.getView().setEnable(false,"tpv_customization");
                    this.getView().setEnable(false,"tpv_coefficient");
                }
            }
        } else {
            this.getModel().beginInit();
            this.getModel().setValue("tpv_richardinput", false);
            this.getModel().setValue("tpv_sourceofcoeff", "NULL");
            this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
            this.getModel().endInit();
            this.getView().setEnable(false,"tpv_countthetable");
            this.getView().setEnable(false,"tpv_customization");
            this.getView().setEnable(false,"tpv_coefficient");
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection tpv_materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品分录
            if (tpv_materialentry.size() > 0) {
                for (int i = 0; i < tpv_materialentry.size(); i++) {
                    DynamicObject dynamicObject = tpv_materialentry.get(i);
                    Boolean tpv_richardinputsx = dynamicObject.getBoolean("tpv_richardinputsx");//按理计输入
                    if(tpv_richardinputsx){
//                        this.getView().setEnable(false,i,"tpv_qty");
                    }
                }
            }
        }
        this.getView().updateView("tpv_richardinput");
        this.getView().updateView("tpv_sourceofcoeff");
        this.getView().updateView("tpv_coefficient");
    }

    /**
     * @param e 新增行表头系数赋值到分录
     */
    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        super.afterAddRow(e);
        String name = e.getEntryProp().getName();
        RowDataEntity[] rowIndex = e.getRowDataEntities();
        if (StringUtils.equals("tpv_materialentry", name)) {
            outCoefficient(rowIndex);
            taxpramountSum();
        }
    }

    @Override
    public void afterDeleteRow(AfterDeleteRowEventArgs e) {
        super.afterDeleteRow(e);
        String name = e.getEntryProp().getName();
        if (StringUtils.equals("tpv_materialentry", name)) {
            taxpramountSum();
        }
    }

    /**
     * 增行时表头系数赋值到分录
     */
    private void outCoefficient(RowDataEntity[] dataentuty) {
        for (RowDataEntity rowdata : dataentuty) {
            int row = rowdata.getRowIndex();
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            String sourceofcoeff = (String) this.getModel().getValue("tpv_sourceofcoeff");//系数来源
            BigDecimal tpv_coefficient = dataEntity.getBigDecimal("tpv_coefficient");
            DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品明细
            Boolean richardinput = dataEntity.getBoolean("tpv_richardinput");//按理计输入
            this.getModel().setValue("tpv_richardinputsx", richardinput, row);
            this.getModel().setValue("tpv_sourceofcoeffsx", sourceofcoeff, row);
            this.getModel().setValue("tpv_coefficients", tpv_coefficient, row);
            Long mid = 0l;//商品明细物料
            Long oid = 0l;//商品明细产地
            if (richardinput) {
//                this.getView().setEnable(false, row, "tpv_qty"); //数量
                this.getView().setEnable(true, row, "tpv_coefficients"); //系数
            } else {
//                this.getView().setEnable(true, row, "tpv_qty"); //数量
                this.getView().setEnable(false, row, "tpv_coefficients"); //系数
            }
            if ("A".equals(sourceofcoeff) && materialentry.size() > 0) {
                DynamicObject material = (DynamicObject) this.getModel().getValue("tpv_material", row);//物料
                if (material != null) {
                    mid = material.getLong("id");
                }
                String specation = (String) this.getModel().getValue("tpv_specation", row);//规格
                String shader = (String) this.getModel().getValue("tpv_shader", row);//材质
                DynamicObject origin = (DynamicObject) this.getModel().getValue("tpv_origin", row);//产地
                if (origin != null) {
                    oid = origin.getLong("id");
                }
                if (mid != 0 && specation != null && shader != null && oid != 0) {
                    String selectFieid = DynamicObjectUtil.getSelectfields("tpv_rationalization", false);// 获取单据头所有字段标识
                    selectFieid = DynamicObjectUtil.getEntrySelectfields(selectFieid, "tpv_rationalization", "tpv_rationalization_lj",
                            false);// 获取分录所有字段标识
                    DynamicObject[] suitUsers = BusinessDataServiceHelper.load("tpv_rationalization", selectFieid, new QFilter[]{
                            (new QFilter("tpv_rationalization_lj.tpv_material.id", QCP.equals, mid)
                                    .and(new QFilter("tpv_rationalization_lj.tpv_specation", QCP.equals, specation))
                                    .and(new QFilter("tpv_rationalization_lj.tpv_shader", QCP.equals, shader))
                                    .and(new QFilter("tpv_rationalization_lj.tpv_origin.id", QCP.equals, oid)))
                    });
                    if (suitUsers.length > 0) {
                        for (DynamicObject entrty : suitUsers) {
                            DynamicObjectCollection rationalization = entrty.getDynamicObjectCollection("tpv_rationalization_lj");
                            for (DynamicObject entity : rationalization) {
                                Long mater = entity.getLong("tpv_material.id");
                                String speca = entity.getString("tpv_specation");
                                String shade = entity.getString("tpv_shader");
                                Long orig = entity.getLong("tpv_origin.id");
                                if (mater.equals(mid) && speca.equals(specation) && shade.equals(shader) && orig.equals(oid)) {
                                    BigDecimal coefficients = entity.getBigDecimal("tpv_tonnum");
                                    this.getModel().setValue("tpv_coefficients", coefficients, row);
                                    break;
                                } else {
                                    this.getModel().setValue("tpv_coefficients", BigDecimal.ZERO, row);
                                }
                            }
                        }
                    } else {
                        this.getModel().setValue("tpv_coefficients", BigDecimal.ZERO, row);
                    }
                } else {
                    this.getModel().setValue("tpv_coefficients", BigDecimal.ZERO, row);
                }
            }
        }
    }


    /**
     * 表头系数，物料，规格，材质，改变时赋值分录系数
     */
    private void changeCoefficient(ChangeData cd, String keyName) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        String sourceofcoeff = (String) this.getModel().getValue("tpv_sourceofcoeff");//系数来源
        DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品明细
        Boolean richardinput = dataEntity.getBoolean("tpv_richardinput");//按理计输入
        EntryGrid entryGrid = this.getControl("tpv_materialentry");//商品明细
        int selectRows[] = entryGrid.getSelectRows();//获取选中的行号
        if (selectRows.length >0) {
            List<String> seqFalse = new ArrayList<>();
            List<String> seqtrue = new ArrayList<>(); //按理计表
            List<String> seqtrueA = new ArrayList<>(); //按理计表
            List<String> seqtrueB = new ArrayList<>(); //自定义
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = this.getModel().getEntryRowEntity("tpv_materialentry", selectRow);
                boolean tpvRichardinputsx = dynamicObject.getBoolean("tpv_richardinputsx"); //按理计输入
                String tpv_sourceofcoeffsx = dynamicObject.getString("tpv_sourceofcoeffsx"); //系数来源
                if (!tpvRichardinputsx) {
                    seqFalse.add(dynamicObject.getString("seq"));
                }
                if (tpvRichardinputsx) {
                    seqtrue.add(dynamicObject.getString("seq"));
                }
                if ("A".equals(tpv_sourceofcoeffsx)) {
                    seqtrueA.add(dynamicObject.getString("seq"));
                }
                if ("B".equals(tpv_sourceofcoeffsx)) {
                    seqtrueB.add(dynamicObject.getString("seq"));
                }
            }
            if (seqFalse.size() > 0 & seqtrue.size() > 0) {
                this.getView().showTipNotification("选择行存在按理输入行和不按理计输入行！请重新选中行！");
                this.getModel().beginInit();
                this.getModel().setValue(keyName,cd.getOldValue());
                this.getModel().endInit();
                this.getView().updateView(keyName);
                return;
            }
            else if (seqtrueA.size() > 0 & seqtrueB.size() > 0) {
                this.getView().showTipNotification("选择行存在按理计表计算和按自定义计算！请重新选中行！");
                this.getModel().beginInit();
                this.getModel().setValue(keyName,cd.getOldValue());
                this.getModel().endInit();
                this.getView().updateView(keyName);
                return;
            }
            for (int selectRow : selectRows) {
                if (richardinput & "tpv_richardinput".equals(keyName)) {
                    this.getModel().beginInit();
                    this.getModel().setValue("tpv_sourceofcoeff","A");
                    this.getModel().setValue("tpv_coefficient",BigDecimal.ZERO);
                    this.getModel().endInit();
                    this.getModel().setValue("tpv_sourceofcoeffsx","A",selectRow);
                    this.getModel().setValue("tpv_richardinputsx",richardinput,selectRow);
                    this.getModel().setValue("tpv_coefficients",BigDecimal.ZERO,selectRow);
                    this.getView().setEnable(true,"tpv_countthetable");
                    this.getView().setEnable(true,"tpv_customization");
//                    this.getView().setEnable(false,selectRow,"tpv_qty");
                    this.getView().updateView("tpv_sourceofcoeff");
                }
                if (!richardinput & "tpv_richardinput".equals(keyName))  {
                    this.getModel().beginInit();
                    this.getModel().setValue("tpv_sourceofcoeff","NULL");
                    this.getModel().setValue("tpv_coefficient",BigDecimal.ZERO);
                    this.getModel().endInit();
                    this.getModel().setValue("tpv_sourceofcoeffsx",null,selectRow);
                    this.getModel().setValue("tpv_richardinputsx",richardinput,selectRow);
                    this.getModel().setValue("tpv_coefficients",BigDecimal.ZERO,selectRow);
                    this.getView().setEnable(false,"tpv_countthetable");
                    this.getView().setEnable(false,"tpv_customization");
//                    this.getView().setEnable(true,selectRow,"tpv_qty");
                    this.getView().updateView("tpv_sourceofcoeff");
                }
                if (!"tpv_richardinput".equals(keyName)) {
                    this.getModel().setValue("tpv_sourceofcoeffsx",sourceofcoeff,selectRow);
                    if ("B".equals(sourceofcoeff)) {
                        this.getView().setEnable(true,"tpv_coefficient");
                    }
                    if ("A".equals(sourceofcoeff)) {
                        this.getModel().setValue("tpv_coefficient",BigDecimal.ZERO);
                        this.getView().setEnable(false,"tpv_coefficient");
                    }
                }
            }
        } else {
            if (richardinput & "tpv_richardinput".equals(keyName)) {
                this.getModel().beginInit();
                this.getModel().setValue("tpv_sourceofcoeff","A");
                this.getModel().setValue("tpv_coefficient",BigDecimal.ZERO);
                this.getModel().endInit();
                this.getView().setEnable(true,"tpv_countthetable");
                this.getView().setEnable(true,"tpv_customization");
                this.getView().setEnable(false,"tpv_coefficient");
            }
            if (!richardinput & "tpv_richardinput".equals(keyName)) {
                this.getModel().beginInit();
                this.getModel().setValue("tpv_sourceofcoeff","NULL");
                this.getModel().setValue("tpv_coefficient",BigDecimal.ZERO);
                this.getModel().endInit();
                this.getView().setEnable(false,"tpv_countthetable");
                this.getView().setEnable(false,"tpv_customization");
                this.getView().setEnable(false,"tpv_coefficient");
            }
            if ("tpv_sourceofcoeff".equals(keyName)) {
                if ("A".equals(sourceofcoeff)) {
                    this.getModel().beginInit();
                    this.getModel().setValue("tpv_coefficient",BigDecimal.ZERO);
                    this.getModel().endInit();
                    this.getView().setEnable(false,"tpv_coefficient");
                }
                if ("B".equals(sourceofcoeff)) this.getView().setEnable(true,"tpv_coefficient");
            }
            this.getView().updateView("tpv_sourceofcoeff");
            this.getView().updateView("tpv_coefficient");
        }
        Long mid = 0l;//商品明细物料
        Long oid = 0l;//商品明细产地
        if (selectRows != null && selectRows.length > 0) {
            for (int rowIndex : selectRows) {
                Boolean richardinputs = (Boolean) this.getModel().getValue("tpv_richardinputsx", rowIndex);////按理计输入
                String sourceofcoeffs = (String) this.getModel().getValue("tpv_sourceofcoeffsx", rowIndex);//系数来源
                if (richardinputs) {
//                    this.getView().setEnable(false, rowIndex, "tpv_qty"); //数量
                    this.getView().setEnable(false, rowIndex, "tpv_coefficients"); //系数
                    BigDecimal packnum = (BigDecimal) this.getModel().getValue("tpv_packnum", rowIndex);//包装数量
                    BigDecimal coefficients = (BigDecimal) this.getModel().getValue("tpv_coefficients", rowIndex);//系数
                    if (packnum.compareTo(BigDecimal.ZERO) > 0 && coefficients.compareTo(BigDecimal.ZERO) > 0) {
                        this.getModel().setValue("tpv_qty", packnum.multiply(coefficients), rowIndex);
                    } else {
                        this.getModel().setValue("tpv_qty", BigDecimal.ZERO, rowIndex);
                    }
                } else {
//                    this.getView().setEnable(true, rowIndex, "tpv_qty"); //数量
                    this.getView().setEnable(true, rowIndex, "tpv_coefficients"); //系数
                }
                if ("A".equals(sourceofcoeffs) && materialentry.size() > 0) {
                    DynamicObject material = (DynamicObject) this.getModel().getValue("tpv_material", rowIndex);//物料
                    if (material != null) {
                        mid = material.getLong("id");
                    }
                    String specation = (String) this.getModel().getValue("tpv_specation", rowIndex);//规格
                    String shader = (String) this.getModel().getValue("tpv_shader", rowIndex);//材质
                    DynamicObject origin = (DynamicObject) this.getModel().getValue("tpv_origin", rowIndex);//产地
                    if (origin != null) {
                        oid = origin.getLong("id");
                    }
                    if (mid != 0 && specation != null && shader != null && oid != 0) {
                        String selectFieid = DynamicObjectUtil.getSelectfields("tpv_rationalization", false);// 获取单据头所有字段标识
                        selectFieid = DynamicObjectUtil.getEntrySelectfields(selectFieid, "tpv_rationalization", "tpv_rationalization_lj",
                                false);// 获取分录所有字段标识
                        DynamicObject[] suitUsers = BusinessDataServiceHelper.load("tpv_rationalization", selectFieid, new QFilter[]{
                                (new QFilter("tpv_rationalization_lj.tpv_material.id", QCP.equals, mid)
                                        .and(new QFilter("tpv_rationalization_lj.tpv_specation", QCP.equals, specation))
                                        .and(new QFilter("tpv_rationalization_lj.tpv_shader", QCP.equals, shader))
                                        .and(new QFilter("tpv_rationalization_lj.tpv_origin.id", QCP.equals, oid)))
                        });
                        if (suitUsers.length > 0) {
                            for (DynamicObject entrty : suitUsers) {
                                DynamicObjectCollection rationalization = entrty.getDynamicObjectCollection("tpv_rationalization_lj");
                                for (DynamicObject entity : rationalization) {
                                    Long mater = entity.getLong("tpv_material.id");
                                    String speca = entity.getString("tpv_specation");
                                    String shade = entity.getString("tpv_shader");
                                    Long orig = entity.getLong("tpv_origin.id");
                                    if (mater.equals(mid) && speca.equals(specation) && shade.equals(shader) && orig.equals(oid)) {
                                        BigDecimal coefficients = entity.getBigDecimal("tpv_tonnum");
                                        this.getModel().setValue("tpv_coefficients", coefficients, rowIndex);
                                        break;
                                    } else {
                                        this.getModel().setValue("tpv_coefficients", null, rowIndex);
                                    }
                                }
                            }
                        } else {
                            this.getModel().setValue("tpv_coefficients", null, rowIndex);
                        }
                    } else {
                        this.getModel().setValue("tpv_coefficients", null, rowIndex);
                    }
                }
            }
        }
    }
    private void changeCoefficientNew(ChangeData cd, String keyName) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        String sourceofcoeff = (String) this.getModel().getValue("tpv_sourceofcoeff");//系数来源
        DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品明细
        Boolean richardinput = dataEntity.getBoolean("tpv_richardinput");//按理计输入
        if (richardinput & "tpv_richardinput".equals(keyName)) {
            this.getModel().beginInit();
            this.getModel().setValue("tpv_sourceofcoeff","NULL");
            this.getModel().setValue("tpv_coefficient",BigDecimal.ZERO);
            this.getModel().endInit();
            this.getView().setEnable(true,"tpv_countthetable");
            this.getView().setEnable(true,"tpv_customization");
            this.getView().setEnable(false,"tpv_coefficient");
        }
        if (!richardinput & "tpv_richardinput".equals(keyName)) {
            this.getModel().beginInit();
            this.getModel().setValue("tpv_sourceofcoeff","NULL");
            this.getModel().setValue("tpv_coefficient",BigDecimal.ZERO);
            this.getModel().endInit();
            this.getView().setEnable(false,"tpv_countthetable");
            this.getView().setEnable(false,"tpv_customization");
            this.getView().setEnable(false,"tpv_coefficient");
        }
        if ("tpv_sourceofcoeff".equals(keyName)) {
            if (!"B".equals(sourceofcoeff)) {
                this.getModel().beginInit();
                this.getModel().setValue("tpv_coefficient",BigDecimal.ZERO);
                this.getModel().endInit();
                this.getView().setEnable(false,"tpv_coefficient");
            } else if ("B".equals(sourceofcoeff)) {
                this.getView().setEnable(true,"tpv_coefficient");
            }
        }
        if ("tpv_sourceofcoeff".equals(keyName) || "tpv_richardinput".equals(keyName)) {
            this.getView().updateView("tpv_sourceofcoeff");
            this.getView().updateView("tpv_coefficient");
        }
        if (materialentry.size() > 0) {
            for (int i = 0; i < materialentry.size(); i++) {
                int rowIndex = i;
                if (!"tpv_sourceofcoeff".equals(keyName) & !"tpv_richardinput".equals(keyName)) {
                    int index = this.getModel().getEntryCurrentRowIndex("tpv_materialentry");
                    if (index != rowIndex) {
                        continue;
                    }
                }
                Long mid = 0l;//商品明细物料
                Long oid = 0l;//商品明细产地
                if (richardinput) {
//                    this.getView().setEnable(false, rowIndex, "tpv_qty"); //数量
                    this.getView().setEnable(true, rowIndex, "tpv_coefficients"); //系数
                    BigDecimal packnum = (BigDecimal) this.getModel().getValue("tpv_packnum", rowIndex);//包装数量
                    BigDecimal coefficients = (BigDecimal) this.getModel().getValue("tpv_coefficients", rowIndex);//系数
                    if (packnum.compareTo(BigDecimal.ZERO) > 0 || coefficients.compareTo(BigDecimal.ZERO) > 0) {
                        this.getModel().setValue("tpv_qty", packnum.multiply(coefficients), rowIndex);
                    } else {
                        this.getModel().setValue("tpv_qty", BigDecimal.ZERO, rowIndex);
                    }
                    this.getModel().setValue("tpv_richardinputsx", richardinput, rowIndex);
                } else {
//                    this.getView().setEnable(true, rowIndex, "tpv_qty"); //数量
                    this.getView().setEnable(false, rowIndex, "tpv_coefficients"); //系数
                    this.getModel().setValue("tpv_richardinputsx", richardinput, rowIndex);
                    this.getModel().setValue("tpv_coefficients", BigDecimal.ZERO, rowIndex);
                    this.getModel().setValue("tpv_sourceofcoeffsx", null, rowIndex);
                    continue;
                }
                if ("A".equals(sourceofcoeff)) {
                    DynamicObject material = (DynamicObject) this.getModel().getValue("tpv_material", rowIndex);//物料
                    if (material != null) {
                        mid = material.getLong("id");
                    }
                    String specation = (String) this.getModel().getValue("tpv_specation", rowIndex);//规格
                    String shader = (String) this.getModel().getValue("tpv_shader", rowIndex);//材质
                    DynamicObject origin = (DynamicObject) this.getModel().getValue("tpv_origin", rowIndex);//产地
                    if (origin != null) {
                        oid = origin.getLong("id");
                    }
                    if (mid != 0 && specation != null && shader != null && oid != 0) {
                        String selectFieid = DynamicObjectUtil.getSelectfields("tpv_rationalization", false);// 获取单据头所有字段标识
                        selectFieid = DynamicObjectUtil.getEntrySelectfields(selectFieid, "tpv_rationalization", "tpv_rationalization_lj",
                                false);// 获取分录所有字段标识
                        DynamicObject[] suitUsers = BusinessDataServiceHelper.load("tpv_rationalization", selectFieid, new QFilter[]{
                                (new QFilter("tpv_rationalization_lj.tpv_material.id", QCP.equals, mid)
                                        .and(new QFilter("tpv_rationalization_lj.tpv_specation", QCP.equals, specation))
                                        .and(new QFilter("tpv_rationalization_lj.tpv_shader", QCP.equals, shader))
                                        .and(new QFilter("tpv_rationalization_lj.tpv_origin.id", QCP.equals, oid)))
                        });
                        if (suitUsers.length > 0) {
                            for (DynamicObject entrty : suitUsers) {
                                DynamicObjectCollection rationalization = entrty.getDynamicObjectCollection("tpv_rationalization_lj");
                                for (DynamicObject entity : rationalization) {
                                    Long mater = entity.getLong("tpv_material.id");
                                    String speca = entity.getString("tpv_specation");
                                    String shade = entity.getString("tpv_shader");
                                    Long orig = entity.getLong("tpv_origin.id");
                                    if (mater.equals(mid) && speca.equals(specation) && shade.equals(shader) && orig.equals(oid)) {
                                        BigDecimal coefficients = entity.getBigDecimal("tpv_tonnum");
                                        this.getModel().setValue("tpv_coefficients", coefficients, rowIndex);
                                        break;
                                    } else {
                                        this.getModel().setValue("tpv_coefficients", null, rowIndex);
                                    }
                                }
                            }
                        } else {
                            this.getModel().setValue("tpv_coefficients", null, rowIndex);
                        }
                    } else {
                        this.getModel().setValue("tpv_coefficients", null, rowIndex);
                    }
                    this.getModel().setValue("tpv_sourceofcoeffsx", sourceofcoeff, rowIndex);
                } else if ("B".equals(sourceofcoeff)) {
                    this.getModel().setValue("tpv_sourceofcoeffsx", sourceofcoeff, rowIndex);
                } else {
                    this.getModel().setValue("tpv_sourceofcoeffsx", null, rowIndex);
                }
            }
        }
    }


    /**
     * 表头金额汇总
     */
    private void sumAmounts(DynamicObjectCollection entryentity) {
        IDataModel model = this.getModel();
        BigDecimal tpv_amount = BigDecimal.ZERO;
        BigDecimal tpv_amountbase = BigDecimal.ZERO;
        BigDecimal tpv_amountrmb = BigDecimal.ZERO;
        BigDecimal tpv_amountusd = BigDecimal.ZERO;
        for (DynamicObject row : entryentity) {
            tpv_amount = tpv_amount.add(row.getBigDecimal("tpv_amt"));
            tpv_amountbase = tpv_amountbase.add(row.getBigDecimal("tpv_amtbase"));
            tpv_amountrmb = tpv_amountrmb.add(row.getBigDecimal("tpv_amtrmb"));
            tpv_amountusd = tpv_amountusd.add(row.getBigDecimal("tpv_amtusd"));
        }
        model.setValue("tpv_amount", tpv_amount.setScale(2, BigDecimal.ROUND_DOWN));//金额原币
        model.setValue("tpv_amountbase", tpv_amountbase.setScale(2, BigDecimal.ROUND_DOWN));//金额本位币
        model.setValue("tpv_amountrmb", tpv_amountrmb.setScale(2, BigDecimal.ROUND_DOWN));//折RMB金额
        model.setValue("tpv_amountusd", tpv_amountusd.setScale(2, BigDecimal.ROUND_DOWN));//折USD金额
    }


    public void afterData(DynamicObjectCollection entryRows, int row) {
        DynamicObject dynamicObject = entryRows.get(row);  //获取选中行的单据体数据
        String tpvSealstatus = dynamicObject.getString("tpv_sealstatus");//用印状态
        String tpvInquiry = dynamicObject.getString("tpv_inquiry");//预审情况
        String tpvPrintingmethod = dynamicObject.getString("tpv_printingmethod");//用印方式
        String tpvSignaturestatus = dynamicObject.getString("tpv_signaturestatus");//签章情况
        Boolean tpvLock = dynamicObject.getBoolean("tpv_lock");//锁定
        //进入线上签
        if (("B".equals(tpvSignaturestatus) | "D".equals(tpvSignaturestatus) | YEM.isEmpty(tpvSignaturestatus) ) && ("B".equals(tpvPrintingmethod) |
                "D".equals(tpvPrintingmethod) | "E".equals(tpvPrintingmethod))) {
            this.getView().setVisible(true, "tpv_bsignonline");
        } else {
            this.getView().setVisible(false, "tpv_bsignonline");
        }
        if ("G".equals(tpvSealstatus) | "B".equals(tpvSealstatus)) {
            this.getView().setVisible(false, "tpv_bsignonline");
        }
        if ("E".equals(tpvSealstatus)) {//邀请签署
            this.getView().setVisible(true, "tpv_invitationsign");
        } else {
            this.getView().setVisible(false, "tpv_invitationsign");
        }
        //预审 /撤回申请
        if ("B".equals(tpvSealstatus) && "A".equals(tpvInquiry) | YEM.isEmpty(tpvInquiry)) {
            this.getView().setVisible(true, "tpv_prelim", "tpv_quashprint");
        } else {
            this.getView().setVisible(false, "tpv_prelim", "tpv_quashprint");
        }
        //撤销预审
        if ("B".equals(tpvSealstatus) && "B".equals(tpvInquiry)) {
            this.getView().setVisible(true, "tpv_quashprelim");
        } else {
            this.getView().setVisible(false, "tpv_quashprelim");
        }
        //申请用印
        if (null == (tpvSealstatus) || "".equals(tpvSealstatus) ||"A".equals(tpvSealstatus)) {
            this.getView().setVisible(true, "tpv_applyforprint");
        } else {
            this.getView().setVisible(false, "tpv_applyforprint");
        }
        //批准印控
        if (null != tpvSealstatus && tpvSealstatus.equals("C") ) {
            this.getView().setVisible(true, "tpv_approvalprinting");
        } else {
            this.getView().setVisible(false, "tpv_approvalprinting");
        }
        //撤回批准
        if (null != tpvSealstatus && tpvSealstatus.equals("P")) {
            this.getView().setVisible(true, "tpv_withdrawal");
        } else {
            this.getView().setVisible(false, "tpv_withdrawal");
        }
        //撤回签署
        if (YEM.isNotEmpty(tpvSealstatus)  && ("F".equals(tpvSealstatus) || "D".equals(tpvSealstatus) || "G".equals(tpvSealstatus))) {
            this.getView().setVisible(true, "tpv_withdraw");
        } else {
            this.getView().setVisible(false, "tpv_withdraw");
        }
        if (tpvLock) { //锁定文件不显示按钮
            this.getView().setVisible(false, "tpv_applyforprint","tpv_quashprint","tpv_prelim","tpv_quashprelim","tpv_approvalprinting",
                    "tpv_withdrawal","tpv_invitationsign","tpv_bsignonline");
        }
    }

}