package com.itopview.wm.sys.formplugin.form;

import java.util.EventObject;

import com.itopview.wm.sys.formplugin.dynamic.TplCallBackEdit;
import com.itopview.wm.sys.utils.BothCardHelper;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;

/**
 * 外贸通用模板4基类
 *
 * @author longh
 * @description:1、抬头功能
 * @date 2022年6月16日 下午2:30:41
 */
public class Tpl4BillPlugIn extends AbstractBillPlugIn {

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        OperationStatus status = this.getView().getFormShowParameter().getStatus();
        DynamicObject org = (DynamicObject) this.getModel().getValue("org");
        if (status.equals(OperationStatus.ADDNEW) && org != null) {
			/*QFilter[] qFilters = new QFilter[]{new QFilter("orgpattern", "in", OrgHelper.getOrgPattern()),
					new QFilter("id", "=", org.getPkValue())};
			if (QueryServiceHelper.exists("bos_org", qFilters)) {
				
			}*/
//			BothCardHelper.fillCoInfo(this.getModel(), org);
        }
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        BothCardHelper.setCoLabel(this);
        BothCardHelper.setSupplierLabel(this);
        BothCardHelper.setCustomerLabel(this);
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"tpv_card_addgys", "tpv_addgys1", "tpv_addgys2",
                "tpv_card_addco", "tpv_addco1", "tpv_addco2",
                "tpv_card_addkh", "tpv_addpayer", "tpv_addpayer1",
                "tpv_changegys", "tpv_changeco", "tpv_changepayer"});
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "tpv_card_addco":
            case "tpv_addco1":
            case "tpv_addco2":
            case "tpv_changeco":
                BothCardHelper.showChangePage(this, "tpv_tpl_addcompany");
                break;
            case "tpv_card_addgys":
            case "tpv_addgys1":
            case "tpv_addgys2":
            case "tpv_changegys":
                BothCardHelper.showChangePage(this, "tpv_tpl_addsupplier");
                break;
            case "tpv_card_addkh":
            case "tpv_addpayer":
            case "tpv_addpayer1":
            case "tpv_changepayer":
                BothCardHelper.showChangePage(this, "tpv_tpl_addcustomer");
                break;
            default:
                break;
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);
        String id = e.getActionId();
        switch (id) {
            case "tpv_tpl_addcompany":
                BothCardHelper.setCoLabel(this);
                break;
            case "tpv_tpl_addsupplier":
                BothCardHelper.setSupplierLabel(this);
                break;
            case "tpv_tpl_addcustomer":
                BothCardHelper.setCustomerLabel(this);
                break;
        }
    }

    /**
     * @param e:
     * @return void
     * @author: chen
     * @date: 2023/12/18 15:28
     * @description: 标头公司字段选择时, 带出抬头信息
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        String name = e.getProperty().getName();
        if ("tpv_company".equals(name)) {
            String key = this.getView().getPageCache().get(TplCallBackEdit.PAGEKEY);
            if (!"true".equals(key)) {
                DynamicObject tpvOrg = (DynamicObject) this.getModel().getValue("tpv_company");
                this.getModel().beginInit();
                if (null != tpvOrg) {
                    this.getModel().setValue("tpv_companyname", tpvOrg.getString("name"));
                    BothCardHelper.fillCoInfo(this.getModel(), tpvOrg);
                } else {
                    this.getModel().setValue("tpv_companyname", "");
                }
                this.getModel().endInit();
                BothCardHelper.setCoLabel(this);
            }
        }
    }
}