package com.itopview.wm.sys.formplugin.form;

import com.alibaba.druid.util.StringUtils;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.entity.OrmLocaleValue;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.IFormView;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.ShowType;
import kd.bos.form.container.Tab;
import kd.bos.form.control.events.TabSelectEvent;
import kd.bos.form.control.events.TabSelectListener;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

public class supplierBillPlugIn extends AbstractBillPlugIn implements BeforeF7SelectListener, TabSelectListener {
    private final static String KEY_ENTRYENTITY = "entry_linkman";

    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        // (3)【我司可见部门】字段默认勾中新建人所在部门。
        if (StringUtils.equals(KEY_ENTRYENTITY, e.getEntryProp().getName())) {
            QFilter filter3 = new QFilter("id", QCP.equals, UserServiceHelper.getCurrentUserId());
            DynamicObject simpleBill3 = BusinessDataServiceHelper.loadSingle("bos_user", "dpt",
                    new QFilter[]{filter3});
            DynamicObjectCollection cols = simpleBill3.getDynamicObjectCollection("entryentity");
            ArrayList<String> tpv_departmentQFilters = new ArrayList<String>();

            for (DynamicObject col : cols) {
                DynamicObject user = col.getDynamicObject("dpt");
                // user.getString("orgpattern.number");

                tpv_departmentQFilters.add(user.getString("id"));
            }
            RowDataEntity[] aa = e.getRowDataEntities();
            this.getModel().setValue("tpv_department",
                    (String[]) tpv_departmentQFilters.toArray(new String[tpv_departmentQFilters.size()]),
                    aa[0].getRowIndex());
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        IDataModel model = this.getModel();
        String name = e.getProperty().getName();
        switch (name) {
            ////// (5)存在不同页签存在相同字段的情况，修改一次之后同步修改另外一个。（分页工商信息【上市类型】同步更新钢厂信息【上市情况】）
            case "tpv_availability1":
                this.getModel().setValue("tpv_availability", (String) model.getValue("tpv_availability1"));
                break;
            case "tpv_availability":
                this.getModel().setValue("tpv_availability1", (String) model.getValue("tpv_availability"));
                break;
            case "name":
                country();//名称变化
                break;
            case "societycreditcode": //统一社会信用代码
                trimAllSpace("societycreditcode");
                break;
            case "tx_register_no": //纳税人识别号
                trimAllSpace("tx_register_no");
                break;
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit applier = (BasedataEdit) this.getControl("tpv_department");// 过滤字段监听
        if (applier != null) {
            applier.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        }

        Tab tab = (Tab) this.getView().getControl("tabap");
        if (tab != null) {
            tab.addTabSelectListener(this);
        }

    }


    /**
     * 过滤
     */
    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        // TODO Auto-generated method stub
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_department": {
                // (2)绑定行政组织基础资料（进行过滤，只显示部门）
                ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
                List<QFilter> QFilters = new ArrayList<QFilter>();
                QFilters.add(new QFilter("orgpattern.number", QCP.equals, "Orgform06")); // 设置过滤条件
                showParameter.getListFilterParameter().setQFilters(QFilters);
                break;
            }
        }
    }

    /**
     * @param targetKey 容器Key
     * @param formkey   单据标识
     */
    private void showBill(String targetKey, String formkey) {
        // 获取当前单据内码
//		long userId = 0;
//		List<Object> userId =new List<Object>();
        List userId = new ArrayList<>();
        List departmentid = new ArrayList<>();
//		Object departmentid = 0;
        long currentUserId = UserServiceHelper.getCurrentUserId();
        DynamicObject bos_user = BusinessDataServiceHelper.loadSingle(currentUserId, "bos_user");
        if (bos_user != null) {
            DynamicObjectCollection cols = bos_user.getDynamicObjectCollection("entryentity");
            for (DynamicObject col : cols) {
                DynamicObject dpt = col.getDynamicObject("dpt");
                //根据组织内码获取组织属性
                dpt = BusinessDataServiceHelper.loadSingleFromCache(dpt.getPkValue(),
                        dpt.getDataEntityType().getName());
                DynamicObject orgpattern = dpt.getDynamicObject("orgpattern");
                if (orgpattern != null) {
                    userId.add(dpt.getLong("id"));
                    String orgpatternName = orgpattern.getString("Name");
                    if (orgpatternName.equals("部门")) {
                        departmentid.add(dpt.getLong("id"));
                    }
                }
            }
        }
        long currentUser = YEM.getCurrentUserId();

        DynamicObject bosUser = BusinessDataServiceHelper.loadSingleFromCache(currentUser, "bos_user");

        List<Long> dept = new ArrayList<>();
        DynamicObjectCollection entryentity = bosUser.getDynamicObjectCollection("entryentity");
        for (DynamicObject row : entryentity) {
            dept.add(row.getDynamicObject("dpt").getLong("id"));
            DynamicObject bosAdminorg = BusinessDataServiceHelper.loadSingle(row.getDynamicObject("dpt").getPkValue(), "bos_adminorg");
            DynamicObjectCollection structures =bosAdminorg.getDynamicObjectCollection("structure");
            for (DynamicObject structure : structures) {
                DynamicObject viewparent = structure.getDynamicObject("viewparent");
                if (YEM.isNotEmpty(viewparent)) {
                    dept.add(viewparent.getLong("id"));
                }
            }
        }

        IFormView view = this.getView();
        ListShowParameter listShowParameter = ShowFormHelper.createShowListForm(formkey, false, 1, false);
        listShowParameter.setStatus(OperationStatus.EDIT);
        listShowParameter.getOpenStyle().setShowType(ShowType.InContainer);
        listShowParameter.getOpenStyle().setTargetKey(targetKey);
        listShowParameter.setSendToClient(true);
        String string = this.getModel().getDataEntity().getPkValue().toString();
        List<QFilter> filters = new ArrayList<>();
        filters.add(new QFilter("tpv_supplier", QCP.equals, this.getModel().getDataEntity().getPkValue().toString()));
//        filters.add(new QFilter("tpv_customer",QCP.equals,"0"));
        filters.add(new QFilter("tpv_entryentity.tpv_basedata", QCP.in, dept));
//        filters.add(new QFilter("departmentid",QCP.equals,departmentid));
//        listShowParameter.setCustomParam("tpv_supplierid", this.getModel().getDataEntity().getPkValue().toString());
//        listShowParameter.setCustomParam("tpv_customerid", "0");//客户id
//        listShowParameter.setCustomParam("tpv_basedataid", userId);//人员全部部门（过滤）
//        listShowParameter.setCustomParam("departmentid", departmentid);//形态是部门
        listShowParameter.getListFilterParameter().setQFilters(filters);

        view.showForm(listShowParameter);
    }

    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        showBill("tpv_advsubconchildpan", "tpv_bd_contactin_ext");
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        String operateKey = e.getOperateKey();
        switch (operateKey) {
            case "save":
//			if (StringUtils.isNotBlank(downloadUrl)) {
//			    this.getView().openUrl(downloadUrl);
//			 }
//			boolean ss =  e.getOperationResult().isSuccess();
//			if(ss)
//			{
                showBill("tpv_advsubconchildpan", "tpv_bd_contactin_ext");
//			}			
                break;
            default:
                break;
        }
    }

    public void tabSelected(TabSelectEvent arg0) {
        String tabKey = arg0.getTabKey();
        if (StringUtils.equals(tabKey, "tpv_contactcreditgra")) {
            String fid = this.getModel().getDataEntity().getPkValue().toString();
            if (fid.equals("0")) {
                this.getView().invokeOperation("save");
            }
        }
    }

    /**
     * 当名称为中文时，默认为中国。否则为空。
     */
    private void country() {
        OrmLocaleValue names = (OrmLocaleValue) this.getView().getModel().getValue("name");
        if (names.toString().matches("[\u4E00-\u9FA5]+")) {
            QFilter supplier = new QFilter("number", QCP.equals, "001");
            DynamicObject country = BusinessDataServiceHelper.loadSingle("bd_country", "id", supplier.toArray());
            this.getView().getModel().setValue("country", country.getPkValue());
        } else {
            this.getView().getModel().setValue("country", null);
        }
    }

    private void trimAllSpace(String tx_register_no) {
        String oldName = (String) this.getModel().getValue(tx_register_no);
        String newName = oldName.replace(" ", "");//将合同号中的" "替换为""
        this.getModel().setValue(tx_register_no, newName);
    }
}
