package com.itopview.wm.sys.formplugin.list;

import java.util.EventObject;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.sys.formplugin.form.AbstractVersionBillPlugIn;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.list.plugin.AbstractListPlugin;

/**
 * 创建新版本功能基类
 * @description:
 * @author longh
 * @date 2021年11月17日 上午11:42:08
 */
public class AbstractVersionListPlugin extends AbstractListPlugin {
	//定义变更功能的列表可见控件标识
	private static final String[] VCTRLS = {"tpv_versionhistory", "tpv_version"};
	//定义变更功能的仅需求单据列表可见控件标识
	private static final String[] S = {"tpv_newversion"};
	//定义变更功能的仅变更单据列表可见控件标识
	private static final String[] V = {"tpv_effective"};
	//定义变更功能的仅变更单据列表不可见控件标识
	private static final String[] UNV = {"tblnew", "tblprint", "tblpush", "tbltrack", "baritemap"};
	
	@Override
	public void afterBindData(EventObject e) {
		super.afterBindData(e);
		this.initNewVersionSetting();
	}
	
	/**
	 * 设置新版本界面字段属性
	 */
	private void initNewVersionSetting() {
		IFormView view = this.getView();
		FormShowParameter formShowParameter = view.getFormShowParameter();
		JSONObject formId = JSON.parseObject(formShowParameter.toString());
		String entityNumber = formId.getString("BillFormId");
		DynamicObject tplObj = AbstractVersionBillPlugIn.queryTemplate(entityNumber);
		//设置配置变更功能的单据列表控件可见性
		view.setVisible(false, AbstractVersionBillPlugIn.key_effectchange);
		if(tplObj != null) {
			String tpv_requirebill = tplObj.getString("tpv_requirebill.number");
			String tpv_changebill = tplObj.getString("tpv_changebill.number");
			if(entityNumber.equals(tpv_requirebill)) {
				//设置控件可见性（非变更单）
				view.setVisible(false, V);
			}else if(entityNumber.equals(tpv_changebill)) {
				//设置控件可见性（变更单）
				view.setVisible(false, S);
				view.setVisible(false, UNV);
				String effectOption = tplObj.getString("tpv_effectoption");
				if(!"audit".equals(effectOption)) {
					view.setVisible(true, AbstractVersionBillPlugIn.key_effectchange);
				}
			}
		}//设置未配置变更功能的单据列表控件可见性
		else {
			view.setVisible(false, S);
			view.setVisible(false, V);
			view.setVisible(false, VCTRLS);
		}
	}
	
	@Override
	public void afterDoOperation(AfterDoOperationEventArgs e) {
		super.afterDoOperation(e);
		IFormView view = this.getView();
		String operateKey = e.getOperateKey();
		switch (operateKey) {
		case "newversion":
			AbstractVersionBillPlugIn.viewNewVersion(e, view);
			break;
		case "versionhistory":
			AbstractVersionBillPlugIn.viewVersionHistory(e, view);
			break;
		default:
			break;
		}
	}
	
}
