package com.itopview.wm.sys.formplugin.list;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

import com.alibaba.druid.util.StringUtils;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.exception.KDBizException;
import kd.bos.filter.FilterColumn;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.FilterContainerInitArgs;
import kd.bos.form.events.SetFilterEvent;
import kd.bos.list.ListShowParameter;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

/**
*
* 联系人信息列表插件
* @author zhouc:
* @data ：2023年4月1日 下午3:23:08
*/
public class ContactinListPluginin extends AbstractListPlugin {

	public void afterBindData(EventObject e) {
		super.afterBindData(e);
	}

	public void setFilter(SetFilterEvent e) {
		Integer condition = 0;
		ListShowParameter formShowParameter = (ListShowParameter) this.getView().getFormShowParameter();
		Object customParam = formShowParameter.getCustomParam("tpv_supplierid");
		if (null != formShowParameter.getCustomParam("tpv_customerid")){
			condition = 1;
			customParam = formShowParameter.getCustomParam("tpv_customerid");
		}
		List tpv_basedata =formShowParameter.getCustomParam("tpv_basedata");
		List<QFilter> qFilters = e.getCustomQFilters();
		qFilters.clear();
		if(customParam==null)
		{
			//此处为列表直接进入，过滤当前登录人所在部门联系人信息
			long currentUserId = UserServiceHelper.getCurrentUserId();
			DynamicObject bos_user = BusinessDataServiceHelper.loadSingle(currentUserId, "bos_user");
			if (bos_user != null) {
				DynamicObjectCollection cols = bos_user.getDynamicObjectCollection("entryentity");
				for (DynamicObject col : cols) {
					DynamicObject dpt = col.getDynamicObject("dpt");
					qFilters.add(new QFilter("tpv_entryentity.tpv_basedata", QCP.not_in, dpt.getLong("id")));
				}
			}
		}
		else {
			if (condition == 0){
				qFilters.add(((new QFilter("tpv_supplier", QCP.in, customParam))
						.and(new QFilter("tpv_entryentity.tpv_basedata", QCP.in, tpv_basedata))));
			} else {
				qFilters.add(((new QFilter("tpv_customer", QCP.in, customParam))
						.and(new QFilter("tpv_entryentity.tpv_basedata", QCP.in, tpv_basedata))));
			}
		}


	}

	@Override
	public void itemClick(ItemClickEvent evt) {
		//新增
		String operationKey = evt.getOperationKey();
		if(StringUtils.equals("new", operationKey)) {
			ListShowParameter formShowParameter = (ListShowParameter) this.getView().getFormShowParameter();
			Object customParam = formShowParameter.getCustomParam("tpv_supplierid");
			Object tpvCustomerid = formShowParameter.getCustomParam("tpv_customerid");
			if(customParam.equals("0") && tpvCustomerid.equals("0")) {
				throw new KDBizException("请先保存供应商或客户后再新增联系人信息");
			}
		}
	}

	@Override
	public void registerListener(EventObject e) {

	}

	@Override
	public void afterDoOperation(AfterDoOperationEventArgs e) {
		String operateKey = e.getOperateKey();
		switch (operateKey) {
		case "new":
			ListShowParameter formShowParameter = (ListShowParameter) this.getView().getFormShowParameter();
			Object customParam = formShowParameter.getCustomParam("tpv_supplierid");
			Object tpvCustomerid = formShowParameter.getCustomParam("tpv_customerid");
			formShowParameter.setClientParam("tpv_supplierid", customParam);
			formShowParameter.setClientParam("tpv_customerid", tpvCustomerid);
			break;

		default:
			break;
		}
	}
}
