package com.itopview.wm.sys.formplugin.list;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.events.HyperLinkClickArgs;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.list.BillList;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.url.UrlService;

/**
 * 日志归档-列表插件
 * @description:归档日志文件预览、下载
 * @author longh
 * @date 2022年5月27日 上午10:56:11
 */
public class LogFileListPlugin extends AbstractListPlugin {

	@Override
	public void billListHyperLinkClick(HyperLinkClickArgs args) {
		super.billListHyperLinkClick(args);
		HyperLinkClickEvent clickEvent = args.getHyperLinkClickEvent();
		BillList billList = (BillList) clickEvent.getSource();
		Object focusRowPkId = billList.getFocusRowPkId();
		String billFormId = billList.getBillFormId();
		String fieldName = clickEvent.getFieldName();
		
		switch (fieldName) {
		case "tpv_attachmentfield_name":
			args.setCancel(true);
			DynamicObject bill = BusinessDataServiceHelper.loadSingle(focusRowPkId, billFormId);
			DynamicObjectCollection atts = bill.getDynamicObjectCollection("tpv_attachmentfield");
			for (DynamicObject att : atts) {
				String url = att.getDynamicObject("fBasedataId").getString("url");
				if(url.indexOf("download.do") > -1) {
					url = url.replace("download.do","preview.do");
				}else {
					url = UrlService.getAttachmentPreviewUrl(url);
				}
				this.getView().openUrl(url);
			}
			break;
		default:
			break;
		}
	}
	
}
