package com.itopview.wm.sys.opplugin.op;

import com.itopview.wm.sys.utils.PrintHelper;
import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.sdk.plugin.Plugin;

import java.math.BigDecimal;
import java.util.List;


/**
 * @author GX
 * 基类自动签署-服务插件
 */
public class Tpl1ServicOp extends AbstractOperationServicePlugIn implements Plugin {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("tpv_automaticoff");//自动签就绪
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() {
                ExtendedDataEntity[] bills = this.getDataEntities();
                if ("submit".equals(this.getOperateKey()) && null != e.getDataEntities()) {
                    for (int i = 0; i < bills.length; ++i) {
                        ExtendedDataEntity bill = bills[i];
                        onunauditDate(bill);
                    }
                }
            }

            public void onunauditDate(ExtendedDataEntity dataEntities) {
                DynamicObject dy = dataEntities.getDataEntity();
                DynamicObjectCollection entry = dy.getDynamicObjectCollection("tpv_materialentry");//商品分录
                if(entry.size()>0) {
                    for(DynamicObject mater:entry) {
                        BigDecimal tpv_qty=mater.getBigDecimal("tpv_qty");//数量
                        BigDecimal tpv_drytonsnum=mater.getBigDecimal("tpv_drytonsnum");//干吨数量
                        int row=mater.getInt("Seq");//行号
                        if(tpv_drytonsnum.compareTo(tpv_qty)>0){
                            this.addMessage(dataEntities,"商品分录第"+row+"行，干吨数量不能大于数量，请重新填写！");
                        }
                    }
                }
            }
            });
        }


    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        String name=e.getOperationKey();
        DynamicObject[] bills = e.getDataEntities();
        if ("audit".equals(name)) {
            for (int i = 0; i < bills.length; ++i) {
                DynamicObject bill = bills[i];
                auditDate(bill);
            }
        }if ("unaudit".equals(name)){
            for (int i = 0; i < bills.length; ++i) {
                DynamicObject bill = bills[i];
                unauditDate(bill);
            }
        }
    }

    public void auditDate(DynamicObject e) {
        String name=e.getDataEntityType().getName();
        switch(name) {//结算单，采购合同，销售合同，特殊合同，协平单，交易关联单，销售发货单，收货/开票确认函，货物流转单，物流合同/指令
            case "tpv_dt_domsettc"://结算单客户
            case "tpv_dt_domsettls"://结算单供应商
            case "tpv_dt_purchase"://采购合同
            case "tpv_dt_salesshipping"://销售发货
            case "tpv_dt_salescontract"://销售合同
            case "tpv_cm_tsht"://特殊合同
            case "tpv_tm_kyoping"://协平单
            case "tpv_dt_reletrade"://关联交易单
            case "tpv_dt_confirmation"://收货/开票确认函
            case "tpv_dt_freigroambill"://货物流转单
            case "tpv_wms_wlzlhe"://物流合同/指令
            case "tpv_dt_transdirbill"://直接调拨单
            case "tpv_dt_transoutbill"://分布调出单
                e.set("tpv_automaticoff",true);//自动签就绪
                SaveServiceHelper.update(e);
                break;
            default:
                break;
        }
    }

    public void unauditDate(DynamicObject e){
        String name=e.getDataEntityType().getName();
        switch(name) {//结算单，采购合同，销售合同，特殊合同，协平单，交易关联单，销售发货单，收货/开票确认函，货物流转单，物流合同/指令
            case "tpv_dt_domsettc"://结算单客户
            case "tpv_dt_domsettls"://结算单供应商
            case "tpv_dt_purchase"://采购合同
            case "tpv_dt_salesshipping"://销售发货
            case "tpv_dt_salescontract"://销售合同
            case "tpv_cm_tsht"://特殊合同
            case "tpv_tm_kyoping"://协平单
            case "tpv_dt_reletrade"://关联交易单
            case "tpv_dt_confirmation"://收货/开票确认函
            case "tpv_dt_freigroambill"://货物流转单
            case "tpv_wms_wlzlhe"://物流合同/指令
                e.set("tpv_automaticoff",false);//自动签就绪
                SaveServiceHelper.update(e);
                break;
            default:
                break;
        }
    }
}
