package com.itopview.wm.sys.opplugin.validator;


import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeforeOperationArgs;

/** 
* 
* 客户提交服务插件
* @author LinRui
* @data ：2024年6月3日 上午11:33:33
*/
public class ClientSubmitOp extends AbstractOperationServicePlugIn{

	public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
		super.beforeExecuteOperationTransaction(e);
		String key = e.getOperationKey();
		switch (key) {	
		case "submit":
			this.checkoutDeclar(e);
			break;

		default:
			break;
		}
	}
	
	private void checkoutDeclar(BeforeOperationArgs e) 
	{
		DynamicObject[] dataEntities = e.getDataEntities();
		for (DynamicObject dataEntity : dataEntities) 
		{
			String dataEntityType = dataEntity.getDataEntityType().toString();
			String name = dataEntity.getString("name");//名称
			if (name.equals("")) {
				e.setCancel(true);
				e.setCancelMessage("当前单据【名称】字段必录！");
			}
			String partnertype = dataEntity.getString("type");//伙伴类型
			String societycreditcode = dataEntity.getString("societycreditcode");//统一社会信用代码
			DynamicObject country = dataEntity.getDynamicObject("country");
			if (YEM.isNotEmpty(country)) {
				String number = country.getString("number");
				if ("001".equals(number)) {
					if(partnertype.equals("1") || partnertype.equals("2") || partnertype.equals("3"))
					{
						if(societycreditcode.equals(""))
						{
							e.setCancel(true);
							e.setCancelMessage("伙伴类型为法人企业、非法人企业或者非企业单位时,【统一社会信用代码必录！】");
						}

					}
				}
			}
		}
	}
}
