package com.itopview.wm.sys.opplugin.validator;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * 规格解析表保存校验插件
 * @author 86173
 *
 */
public class ModelnumAnalysisSaveValidator extends AbstractValidator{

	@Override
	public void validate() {
		ExtendedDataEntity[] dataEntities = this.dataEntities;
		for (int i = 0; i < dataEntities.length; i++) {
			ExtendedDataEntity extend = dataEntities[i];
			DynamicObject entity = extend.getDataEntity();
			check(extend, entity);
		}
	}

	public void check(ExtendedDataEntity extend,DynamicObject entity) {
		DynamicObjectCollection tpv_entryentity_s = entity.getDynamicObjectCollection("tpv_entryentity");
		for(int i=0;i<tpv_entryentity_s.size();i++) {
			DynamicObject tpv_entryentity = tpv_entryentity_s.get(i);
			DynamicObject tpv_material = tpv_entryentity.getDynamicObject("tpv_material");
			String tpv_modelnum = tpv_entryentity.getString("tpv_modelnum");
			QFilter qFilter = new QFilter("tpv_entryentity.tpv_modelnum", QCP.equals, tpv_modelnum);
			qFilter.and(new QFilter("id", QCP.not_equals, entity.getPkValue()));
			if(null != tpv_material) {
				qFilter.and(new QFilter("tpv_entryentity.tpv_material", QCP.equals, tpv_material.getPkValue()));
			}else {
				qFilter.and(new QFilter("tpv_entryentity.tpv_material", QCP.is_null, tpv_material.getPkValue())
						.or(new QFilter("tpv_entryentity.tpv_material", QCP.equals, 0L)));
			}
			DynamicObject [] tpv_bd_modelnumanalysis_s = BusinessDataServiceHelper.load("tpv_bd_modelnumanalysis", 
					"id,name,number", new QFilter[] { qFilter });
			if(null != tpv_bd_modelnumanalysis_s && tpv_bd_modelnumanalysis_s.length>0) {
				DynamicObject tpv_bd_modelnumanalysis = tpv_bd_modelnumanalysis_s[0];
				this.addMessage(extend, "明细信息第"+(i+1)+"行，物料名称+规格在单据编号："+tpv_bd_modelnumanalysis.getString("number")+"中已存在，不允许重复！");
			}
		}
	}
}
