package com.itopview.wm.sys.opplugin.validator;


import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;

import java.util.List;

/** 
* 
* 供应商提交服务插件
* @author zhouc
* @data ：2023年4月3日 上午11:33:33 
*/
public class SupplierSubmitOp extends AbstractOperationServicePlugIn{

	@Override
	public void onPreparePropertys(PreparePropertysEventArgs e) {
		List<String> fieldKeys = e.getFieldKeys();
		fieldKeys.add("name");
		fieldKeys.add("type");
		fieldKeys.add("country");
		fieldKeys.add("societycreditcode");
	}

	@Override
	public void onAddValidators(AddValidatorsEventArgs e) {
		super.onAddValidators(e);
		e.addValidator(new AbstractValidator() {
			@Override
			public void validate() {
				ExtendedDataEntity[] bills = this.getDataEntities();
				if ("submit".equals(this.getOperateKey())) {
					for (int i = 0; i < bills.length; ++i) {
						ExtendedDataEntity bill = bills[i];
						//监控按钮保存
						this.clickSubmit(bill);
					}
				}
			}
			private void clickSubmit(ExtendedDataEntity dataEntities) {
				DynamicObject dataEntity = dataEntities.getDataEntity();
				String name = dataEntity.getString("name");//名称
				if (name.equals("")) {
					this.addMessage(dataEntities, "当前单据【名称】字段必录！");
				}
				String partnertype = dataEntity.getString("type");//伙伴类型
				String societycreditcode = dataEntity.getString("societycreditcode");//统一社会信用代码
				DynamicObject country = dataEntity.getDynamicObject("country");
				if (YEM.isNotEmpty(country)) {
					String number = country.getString("number");
					if ("001".equals(number)) {
						if(partnertype.equals("1") || partnertype.equals("2") || partnertype.equals("3"))
						{
							if(societycreditcode.equals(""))
							{
								this.addMessage(dataEntities, "伙伴类型为法人企业、非法人企业或者非企业单位时,【统一社会信用代码必录！】");
							}
						}
					}
				}
			}
		});
	}

}
