package com.itopview.wm.sys.utils;

import java.util.Map;
import java.util.stream.Collectors;

import com.itopview.wm.utils.YEM;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.ILocaleString;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * 接口信息获取
 * 
 * @description
 * @author longh
 * @date 2023年9月7日
 */
public class ApiHelper {
	private boolean exist;
	private String thirdKey;
	private ILocaleString thirdName;
	private Map<String, String> params;
	private Map<String, Api> apis;

	public boolean isExist() {
		return exist;
	}

	public String getThirdKey() {
		return thirdKey;
	}

	public ILocaleString getThirdName() {
		return thirdName;
	}

	public Map<String, String> getParams() {
		return params;
	}

	public String getParam(String paramKey) {
		return params.getOrDefault(paramKey, "");
	}

	public Map<String, Api> getApis() {
		return apis;
	}

	public Api getApi(String apiKey) {
		return apis.getOrDefault(apiKey, new Api(null));
	}

	public ApiLog log(Api api) {
		return new ApiLog(api);
	}

	public ApiHelper(String thirdKey) {
		DynamicObject app = BusinessDataServiceHelper.loadSingleFromCache("tpv_iscb_app",
				new QFilter("number", QCP.equals, thirdKey).toArray());
		if (app != null) {
			this.params = app.getDynamicObjectCollection("tpv_params").stream()
					.collect(Collectors.toMap(x -> x.getString("tpv_paramkey"), y -> y.getString("tpv_paramvalue")));

			QFilter qFilter = new QFilter("group", QCP.equals, app.getPkValue());
			qFilter.and(new QFilter("enable", QCP.equals, "1"));
			Map<Object, DynamicObject> datas = BusinessDataServiceHelper.loadFromCache("tpv_iscb_api",
					qFilter.toArray());
			apis = datas.values().stream().filter(x -> YEM.isNotEmpty(x.getString("number")))
					.collect(Collectors.toMap(x -> x.getString("number"), y -> {
						return new Api(y);
					}));
			this.thirdName = app.getLocaleString("name");
			this.exist = true;
		}
		this.thirdKey = thirdKey;
	}

}
