package com.itopview.wm.sys.utils;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.CloseCallBack;
import kd.bos.form.IFormView;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassName: LinkManHeplper
 * @Description: 抬头信息选择联系人
 * @author: zbh
 * @date: 2024-04-22
 */
public class LinkManHeplper {

    public static void orderFilter(IFormView view, String name, String linkman) {
        ListShowParameter listpara = ShowFormHelper.createShowListForm("tpv_bd_contactin_ext", false);
        List<QFilter> filters = new ArrayList<>();
        DynamicObject tpvDepartment = (DynamicObject) view.getParentView().getModel().getValue("tpv_department");


        long currentUser = YEM.getCurrentUserId();
        DynamicObject bosUser = BusinessDataServiceHelper.loadSingleFromCache(currentUser, "bos_user");
        List<Long> dept = new ArrayList<>();
        DynamicObjectCollection entryentity = bosUser.getDynamicObjectCollection("entryentity");
        for (DynamicObject row : entryentity) {
            dept.add(row.getDynamicObject("dpt").getLong("id"));
            DynamicObject bosAdminorg = BusinessDataServiceHelper.loadSingle(row.getDynamicObject("dpt").getPkValue(), "bos_adminorg");
            DynamicObjectCollection structures =bosAdminorg.getDynamicObjectCollection("structure");
            for (DynamicObject structure : structures) {
                DynamicObject viewparent = structure.getDynamicObject("viewparent");
                dept.add(viewparent.getLong("id"));
            }
        }
//        if(dept.size()!=0){
//            DynamicObject[] adminOrgs = BusinessDataServiceHelper.load("bos_adminorg", "", new QFilter[]{new QFilter("structure.viewparent", "in", dept)});
//            for (DynamicObject adminOrg : adminOrgs) {
//                dept.add(adminOrg.getLong("id"));
//            }
//        }

        if (tpvDepartment != null) {
            filters.add(new QFilter("tpv_entryentity.tpv_basedata.id", QCP.in, dept));
        }else if (tpvDepartment == null){
            filters.add(new QFilter("tpv_entryentity.tpv_basedata.id", QCP.equals,null));
        }
        if ("tpv_supplierlinkman".equals(linkman)){//供应商
            DynamicObject tpvSupplier = (DynamicObject) view.getModel().getValue("tpv_supplier");
            filters.add(new QFilter("tpv_supplier", QCP.equals,tpvSupplier==null?"":tpvSupplier.getPkValue().toString()));
        }else if ("tpv_customerlinkman".equals(linkman)){//客户
            DynamicObject tpvCustomer = (DynamicObject) view.getModel().getValue("tpv_customer");
            filters.add(new QFilter("tpv_customer", QCP.equals,tpvCustomer==null?"":tpvCustomer.getPkValue().toString()));
        }
        listpara.getListFilterParameter().setQFilters(filters);
        CloseCallBack closeCallBack = new CloseCallBack(name, linkman);
        listpara.setCloseCallBack(closeCallBack);
        view.showForm(listpara);
    }

    public static void closeBack(ClosedCallBackEvent e, IDataModel model) {
        ListSelectedRowCollection listData = (ListSelectedRowCollection) e.getReturnData();
        if (listData != null && listData.size() > 0) {
            Object primaryKeyValue = listData.get(0).getPrimaryKeyValue();
            DynamicObject tpvBdContactin = BusinessDataServiceHelper.loadSingle(primaryKeyValue, "tpv_bd_contactin");
            Map<String, String> fieldName = entryFieldName(model.getDataEntityType().getName());
            model.setValue(fieldName.get("linkman"), tpvBdContactin.get("name"));//联系人
            model.setValue(fieldName.get("tel"), tpvBdContactin.get("tpv_phone"));//电话
            model.setValue(fieldName.get("addr"), tpvBdContactin.get("tpv_address"));//地址
            model.setValue(fieldName.get("email"), tpvBdContactin.get("tpv_mailbox"));//E-Mail
        }
    }

    public static Map<String, String> entryFieldName(String entityName) {
        Map<String, String> map = new HashMap<>();
        String linkman = "";//联系人
        String tel = "";//电话
        String addr = "";//地址
        String email = "";//email
        switch (entityName) {
            case "tpv_tpl_addcustomer": //客户
                linkman = "tpv_customerlinkman";
                tel = "tpv_customertel";
                addr = "tpv_customeraddr";
                email = "tpv_customeremail";
                break;
            case "tpv_tpl_addcompany": //公司
                linkman = "tpv_companylinkman";
                tel = "tpv_companytel";
                addr = "tpv_companyaddr";
                email = "tpv_companyemail";
                break;
            case "tpv_tpl_addsupplier": //供应商
                linkman = "tpv_supplierlinkman";
                tel = "tpv_suppliertel";
                addr = "tpv_supplieraddr";
                email = "tpv_supplieremail";
                break;
            default:
                break;
        }
        map.put("linkman", linkman); //联系人
        map.put("tel", tel);//电话
        map.put("addr", addr); //地址
        map.put("email", email); //email
        return map;
    }
}
