package com.itopview.wm.sys.utils;

import java.util.HashMap;
import java.util.Map;

import kd.bos.context.RequestContext;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.property.BasedataProp;

public class MultiLangUtils {
	
	@SuppressWarnings({ "unchecked", "rawtypes" })
	public static Map<String, String> getEntityKeyWithLang(String langName, MainEntityType dt, String... fieldKeys) {
		HashMap maps = new HashMap(fieldKeys.length);
		String[] arg3 = fieldKeys;
		int arg4 = fieldKeys.length;

		for (int arg5 = 0; arg5 < arg4; ++arg5) {
			String fieldKey = arg3[arg5];
			String name = getEntityKeyWithLang(langName, dt, fieldKey);
			maps.put(fieldKey, name);
		}

		return maps;
	}

	public static String getEntityKeyWithLang(String langName, MainEntityType dt, String fieldKey) {
		String[] splitKey = fieldKey.split("\\.");
		StringBuilder builder = new StringBuilder();

		for (int i = 0; i < splitKey.length; ++i) {
			String curSplitKey = splitKey[i];
			String name = curSplitKey;
			if (builder.length() != 0) {
				builder.append('.');
			}

			IDataEntityProperty property = dt.findProperty(curSplitKey);
			if (property == null && i > 0) {
				IDataEntityProperty preProperty = dt.findProperty(splitKey[i - 1]);
				if (preProperty instanceof BasedataProp) {
					BasedataProp prop = (BasedataProp) preProperty;
					MainEntityType baseDt = EntityMetadataCache.getDataEntityType(prop.getBaseEntityId());
					IDataEntityProperty baseProperty = baseDt.findProperty(curSplitKey);
					name = (String) baseProperty.getDisplayName().get(langName);
				}
			} else if (property != null) {
				name = (String) property.getDisplayName().get(langName);
			}

			builder.append(name);
		}

		return builder.toString();
	}

	public static String getEntityKeyWithLang(String entityName, String fieldKey) {
		String langName = RequestContext.get().getLang().name();
		MainEntityType dt = EntityMetadataCache.getDataEntityType(entityName);
		return getEntityKeyWithLang(langName, dt, fieldKey);
	}

	public static Map<String, String> getEntityKey(String entityName, String... fieldKeys) {
		String langName = RequestContext.get().getLang().name();
		MainEntityType dt = EntityMetadataCache.getDataEntityType(entityName);
		return getEntityKeyWithLang(langName, dt, fieldKeys);
	}

	public static Map<String, String> getEntityKey(MainEntityType dt, String... fieldKeys) {
		String langName = RequestContext.get().getLang().name();
		return getEntityKeyWithLang(langName, dt, fieldKeys);
	}
}