package com.itopview.wm.sys.utils;

import java.util.HashMap;
import java.util.Map;

import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.plugin.AbstractFormPlugin;

/**
 * 条件设置帮助类
 * 
 * @Description:
 * @author: longh
 * @date: 2023年11月8日
 */
public class RuleSettingsHelper {

	public static void showRuleSettings(AbstractFormPlugin plugin, String formKey, String colDesc, String colJson) {
		IDataModel model = plugin.getView().getModel();
		String filterDesc = (String) model.getValue(colDesc);
		String filterGridJson = (String) model.getValue(colJson);
		showForm(plugin, formKey, null, null, colDesc, colJson, filterDesc, filterGridJson);
	}

	public static void showRuleSettings(AbstractFormPlugin plugin, String formKey, String entryKey, String colDesc,
			String colJson) {
		IDataModel model = plugin.getView().getModel();
		int entryRowIndex = model.getEntryCurrentRowIndex(entryKey);
		String filterDesc = (String) model.getValue(colDesc, entryRowIndex);
		String filterGridJson = (String) model.getValue(colJson, entryRowIndex);
		showForm(plugin, formKey, entryKey, null, colDesc, colJson, filterDesc, filterGridJson);
	}

	public static void showRuleSettings(AbstractFormPlugin plugin, String formKey, String entryKey, String subEntryKey,
			String colDesc, String colJson) {
		IDataModel model = plugin.getView().getModel();
		int entryRowIndex = model.getEntryCurrentRowIndex(entryKey);
		int subEntryRowIndex = model.getEntryCurrentRowIndex(subEntryKey);
		String filterDesc = (String) model.getValue(colDesc, subEntryRowIndex, entryRowIndex);
		String filterGridJson = (String) model.getValue(colJson, subEntryRowIndex, entryRowIndex);
		showForm(plugin, formKey, entryKey, subEntryKey, colDesc, colJson, filterDesc, filterGridJson);
	}

	private static void showForm(AbstractFormPlugin plugin, String formKey, String entryKey, String subEntryKey,
			String colDesc, String colJson, String filterDesc, String filterGridJson) {
		Map<String, Object> customParams = new HashMap<>();
		customParams.put("filterDesc", filterDesc);
		customParams.put("filterGridJson", filterGridJson);
		customParams.put("colDesc", colDesc);
		customParams.put("colJson", colJson);
		customParams.put("formKey", formKey);
		customParams.put("entryKey", entryKey);
		customParams.put("subEntryKey", subEntryKey);
		FormShowParameter fsp = new FormShowParameter();
		fsp.getOpenStyle().setShowType(ShowType.Modal);
		fsp.setFormId("tpv_tpl_rulesettings");
		fsp.setCustomParams(customParams);
		plugin.getView().showForm(fsp);
	}

}