package com.itopview.wm.utils;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;

/**
 * @Description: 单据视图公共类 -根据配置的单据类型编码及绑定视图赋默认值(注意：单据类型编码和单据标识一致，不区分大小写)
 * @Author LinRui
 * @Date 2024/4/23 15:47
 */
public class FormShowBillTypeView extends AbstractBillPlugIn {
    /**
     * 根据布局标识更新单据类型
     * @param e
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        BillShowParameter showParameter = (BillShowParameter) this.getView().getFormShowParameter();
        OperationStatus status = showParameter.getStatus(); //获取单据状态
        String formId = showParameter.getFormId(); //获取单据标识
//        ISVInfo isvInfo = ISVServiceHelper.getISVInfo();
//        String infoName = isvInfo.getName(); //开发商标识
        String entityName = this.getModel().getDataEntityType().getName();
        QFilter qFilterPC = new QFilter("number", QCP.equals, entityName);
        qFilterPC.and(new QFilter("tpv_formshowbill", QCP.equals, formId));
        qFilterPC.and(new QFilter("enable", QCP.equals, "1"));
        //维护PC布局单据类型，查询改单据是否维护过
        DynamicObject viewpc = BusinessDataServiceHelper.loadSingle("tpv_bd_viewpc", qFilterPC.toArray());
        if (YEM.isEmpty(viewpc)) {
            this.getView().showTipNotification("请先维护PC布局单据类型！才可正常使用布局功能！\r\n 请前往维护【开发平台】-> 贸易云 -> 【基础资料】应用 " +
                    "-> 功能分组列表【PC布局】 -> 【维护PC布局单据类型】(tpv_bd_viewpc)",10);
            return;
        }
        //如果打开过往单据直接跳过
        if (OperationStatus.ADDNEW.equals(status)) {
            String tpvBilltypePC = viewpc.getString("tpv_billtype"); //单据类型标识
            String tpv_valuetypePC = viewpc.getString("tpv_valuetype"); //参数类型
            String tpvFormshowbillPC = viewpc.getString("tpv_formshowbill"); //单据布局标识
            boolean tpvIsspecial = viewpc.getBoolean("tpv_isspecial");
            boolean tpvIsbilltypepc = viewpc.getBoolean("tpv_isbilltypepc");
            String tpvBilltypenumber = viewpc.getString("tpv_billtypenumber"); //单据类型编码
            if (!tpvIsspecial) {
                String select = "billformid,number,mesterid";
                QFilter qFilter = new QFilter("billformid", QCP.equals, entityName);
                DynamicObject[] load = BusinessDataServiceHelper.load("bos_billtype", select, qFilter.toArray());
                for (DynamicObject dynamicObject : load) {
                    String number = dynamicObject.getString("number");
                    String numberLow = dynamicObject.getString("number").toLowerCase();
                    if (tpvIsbilltypepc & formId.equals(tpvFormshowbillPC)) {
                        QFilter qFilter2 = new QFilter("number", QCP.equals, tpvBilltypenumber);
                        DynamicObject billType = BusinessDataServiceHelper.loadSingle("bos_billtype", "id", qFilter2.toArray());
                        this.getModel().setValue(tpvBilltypePC, billType);
                        break;
                    } else if (formId.equals(numberLow) & "LongStr".equals(tpv_valuetypePC)) {
                        QFilter qFilter2 = new QFilter("number", QCP.equals, number);
                        DynamicObject billType = BusinessDataServiceHelper.loadSingle("bos_billtype", "id", qFilter2.toArray());
                        this.getModel().setValue(tpvBilltypePC, billType);
                        break;
                    }
                }
            } else {
                String tpvBilltypevaluePC = viewpc.getString("tpv_billtypevalue"); //单据类型赋值
                if (tpvFormshowbillPC.equals(formId)) {
                    if ("LongStr".equals(tpv_valuetypePC)) {
                        this.getModel().setValue(tpvBilltypePC, Long.valueOf(tpvBilltypevaluePC));
                    } else if ("StringStr".equals(tpv_valuetypePC)) {
                        this.getModel().setValue(tpvBilltypePC, tpvBilltypevaluePC);
                    } else if ("BooleanStr".equals(tpv_valuetypePC)) {
                        this.getModel().setValue(tpvBilltypePC, Boolean.valueOf(tpvBilltypevaluePC));
                    }
                }
            }
        }
    }
}
