package tpv.fi.tpv_ap_ext.opplugin.op;

import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.fi.ap.validator.FinApInvoiceSubmitAmountValidator;
import kd.fi.ap.validator.InvoiceSrcCollectValidator;
import kd.fi.ap.validator.InvoiceSubmitValidator;
import kd.fi.arapcommon.helper.SystemParameterHelper;
import kd.fi.arapcommon.opplugin.BaseDataEnableValidator;
import kd.fi.arapcommon.opplugin.MustInputValidator;
import tpv.fi.tpv_ap_ext.opplugin.validator.BillPriceValidator;

/**
 * @ClassName: InvoiceSubmitOp
 * @Description:
 * @date: 2024/1/16 16:29
 * @author: chen
 */
public class InvoiceSubmitOp extends kd.fi.ap.opplugin.InvoiceSubmitOp {
    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        InvoiceSubmitValidator v = new InvoiceSubmitValidator();
        v.setEntityKey("ap_invoice");
        e.addValidator(v);
        e.addValidator(new BillPriceValidator());
        e.addValidator(new InvoiceSrcCollectValidator());
        if (SystemParameterHelper.isForceValidateAmt()) {
            e.addValidator(new FinApInvoiceSubmitAmountValidator());
        }

        e.addValidator(new BaseDataEnableValidator());
        e.addValidator(new MustInputValidator());
    }
}
