package tpv.imc.sim.java.opplugin.op;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.List;

/**
 * @Description: 开票申请单 -服务插件 购买方携带客户赋值给【客户(生成成本携带)】字段
 * @Author LinRui
 * @Date 2024/7/22 17:50
 */
public class TpvInvoiceBillServiceOp extends AbstractOperationServicePlugIn {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("buyername");
        keys.add("tpv_customer");
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        String operationKey = e.getOperationKey();
        if ("save".equals(operationKey)) {
            DynamicObject[] bills = e.getDataEntities();
            for (int i = 0; i < bills.length; ++i) {
                DynamicObject bill = bills[i];
                String buyername = bill.getString("buyername");
                QFilter qFilter = new QFilter("enable", QCP.equals, "1");
                if (YEM.isNotEmpty(buyername)) {
                    qFilter.and(new QFilter("name", QCP.equals, buyername));
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("bdm_invice_title_strate", qFilter.toArray());
                    if (YEM.isNotEmpty(dynamicObject)) {
                        DynamicObjectCollection objectCollection = dynamicObject.getDynamicObjectCollection("cust");
                        for (DynamicObject object : objectCollection) {
                            DynamicObject custom = object.getDynamicObject("custom");
                            if (YEM.isNotEmpty(custom)) {
                                bill.set("tpv_customer", custom);
                                SaveServiceHelper.save(new DynamicObject[] { bill });
                                break;
                            }
                        }
                    }
                }
            }
        }
    }

}
