package tpv.scmc.im.java.formplugin.form;

import com.itopview.wm.dt.utils.PickShipsHelper;
import com.itopview.wm.sys.formplugin.form.Tpl1BillPlugIn;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;

import java.util.EventObject;

/**
 * @ClassName OtherInFormPlugin
 * @Description TODO
 * @Author yhj
 * @Date 2023/12/21 19:11
 * @Version 1.0
 */
public class OtherInFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"tpv_advcontoolbarap1"});
        ((BasedataEdit) this.getControl("tpv_approvalprocess")).addBeforeF7SelectListener(this);
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        switch (itemKey) {
            case "tpv_bulkentrybutton": //客户额度使用情况查询
                showInfoForm(this.getView());
                break;
            default:
                break;
        }
    }
    /**
     * 设置打开批量录入金额动态表单
     */
    private void showInfoForm(IFormView view) {
        // 获取单据体
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId("tpv_bulkentryexpenses");
        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_bulkentrybutton"));
        view.showForm(showParameter);
    }

    /**
     * @param e 回调，接收子页面传来的值。
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        switch (actionId) {
            case "tpv_bulkentrybutton":
                DynamicObjectCollection data = (DynamicObjectCollection) returnData;
                setValue(data);
                break;
            default:
                break;
        }
    }

    private void setValue(DynamicObjectCollection data) {
        if (data != null && data.size() > 0) {
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("billentry");//商品明细分录
            for (int i = 0; materialentry.size() > i; i++) {
                this.getModel().setEntryCurrentRowIndex("billentry", i);//设置给那一行父分录添加子分录
                for (DynamicObject freigroambill : data) {
                    int index = this.getModel().createNewEntryRow("tpv_im_otherinbill_f");
                    this.getModel().setValue("tpv_costitem", freigroambill.getLong("tpv_expenseitems.id"), index, i);//费用项目
                    this.getModel().setValue("tpv_supplier", freigroambill.getLong("tpv_supplierf.id"), index, i);//供应商
                    this.getModel().setValue("tpv_reimbursement", freigroambill.getDynamicObject("tpv_costcurrencys"), index, i);//费用币别
                    this.getModel().setValue("tpv_univalence", freigroambill.getBigDecimal("tpv_unitprices"), index, i);//单价
                    this.getModel().setValue("tpv_taxrate", freigroambill.getBigDecimal("tpv_taxrates"), index, i);//税率
                    this.getModel().setValue("tpv_desc", freigroambill.getString("tpv_comments"), index, i);//备注
                }
            }
            this.getView().updateView("tpv_im_otherinbill_f");
        }
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        String entityId = this.getModel().getDataEntityType().getName();
        switch (name) {
            case"tpv_approvalprocess":
                Tpl1BillPlugIn.whethertopublish(e,entityId);
                break;
            default:
                break;
        }
    }
}
