package tpv.sys.basedata.java.formplugin.dynamic;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.Search;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.control.events.SearchEnterEvent;
import kd.bos.form.control.events.SearchEnterListener;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;
import tpv.tpv_wm.tpv_iscb.java.api.ant.GetPublicSentimentList;

import java.util.*;
import java.util.stream.Collectors;

/**
 * 供应商列比奥录入动态表单插件
 * WangShuGuang
 */
public class SupplierPopupEdit extends AbstractBillPlugIn implements Plugin, RowClickEventListener, SearchEnterListener {

    private final String ONE = "1";//系统供应商

    private final String TWO = "2";//系统客户

    private static String TPV_ENTRYENTITY = "tpv_entryentity";

    private static String BD_CUSTOMER = "bd_customer";//客户

    private static String BD_SUPPLIER = "bd_supplier";//供应商

    /**
     * 注册按钮
     */
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok", "btncancel", "tpv_buttonap", "tpv_buttonap1", "tpv_buttonap2", "tpv_buttonap3", "tpv_labelap6"});
        //单据行点击
        EntryGrid entry = this.getView().getControl(TPV_ENTRYENTITY);
        entry.addRowClickListener(this);
        Search search = this.getControl("tpv_suppliernameormark");
        search.addEnterListener(this);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        this.getView().setVisible(false, "tpv_buttonap1");//下一步-已有供应商，直接打开
        this.getView().setVisible(false, "tpv_buttonap2");//下一步-已有供应商，直接打开
        this.getView().setVisible(false, "tpv_buttonap3");//下一步-已有供应商，直接打开
    }

    @Override
    public void click(EventObject evt) {
        // TODO Auto-generated method stub
        super.click(evt);
        Map<String, Object> map = this.getView().getFormShowParameter().getCustomParams();
        String key = ((Control) evt.getSource()).getKey();
        if (key.equals("tpv_buttonap")) {
            //检索按钮
            buttonapDate();
        }
        if (key.equals("tpv_buttonap1")) {
            //下一步-已有供应商，直接打开
            directOpen();
        }
        if (key.equals("tpv_buttonap2")) {
            //下一步-将本客户复制为供应商
            copyClient();
        }
        if (key.equals("tpv_buttonap3")) {
            addNewWeb(true);
        }
        if (key.equals("tpv_labelap6")) {
            addNewWeb(false);
        }
    }

    public void addNewWeb(Boolean juge) {
        Map<String, Object> closedMap = new HashMap<>();
        //下一步-新增选中供应商
        DynamicObjectCollection entryEntity = this.getModel().getEntryEntity(TPV_ENTRYENTITY);
        if (juge) {
            int entryCurrentRowIndex = this.getModel().getEntryCurrentRowIndex(TPV_ENTRYENTITY);
            DynamicObject dynamicObject = entryEntity.get(entryCurrentRowIndex);
            closedMap.put("sign", "1");
            closedMap.put("name", dynamicObject.getString("tpv_name"));
            try {
                String response = GetPublicSentimentList.enterPrise(dynamicObject.getString("tpv_name"));
                JSONObject jsonObject = JSONObject.parseObject(response);
                if (null != jsonObject) {
                    JSONArray constituentTags = jsonObject.getJSONArray("constituent_tags");//企业性质
                    JSONArray listed_types = jsonObject.getJSONArray("listed_types");//上市类型
                    if (!constituentTags.isEmpty()) {
                        closedMap.put("tpv_enterprisenature", constituentTags.toJSONString());//企业性质
                        closedMap.put("constituentTags", constituentTags);//企业性质
                    }
                    closedMap.put("societycreditcode", jsonObject.getString("uc_code"));//统一社会信用代码
                    closedMap.put("artificialperson", jsonObject.getString("legal_representative"));//法人代表
                    closedMap.put("tpv_industrialyphon", jsonObject.getString("org_tel"));//工商登记电话
                    String rec_cap_currency = jsonObject.getString("rec_cap_currency");
                    closedMap.put("curegcapital", jsonObject.getString("rec_cap_currency"));//注册资本币种
                    closedMap.put("regcapital", jsonObject.getString("register_capital_value"));//注册资本
                    closedMap.put("businessterm", jsonObject.getString("oprt_end_date"));//营业期限
                    closedMap.put("establishdate", jsonObject.getDate("register_date"));//成立日期
                    closedMap.put("bizpartner_address", jsonObject.getString("register_place"));//注册地址
                    closedMap.put("tpv_registrationstatus", jsonObject.getString("org_state"));//登记状态
                    closedMap.put("tpv_paidupcapital", jsonObject.getString("org_rec_cptl_rmb"));//实缴资本
                    closedMap.put("tpv_businesstype", jsonObject.getString("org_type"));//企业类型
                    //closedMap.put("tpv_insured", jsonObject.getString("employee_num"));//参保人数
                    closedMap.put("tpv_listed", jsonObject.getString("latetype"));//是否上市
                    if (!listed_types.isEmpty()) {
                        closedMap.put("tpv_typeoflisting", null);//上市类型
                    } else {
                        closedMap.put("tpv_typeoflisting", listed_types.toJSONString());//上市类型
                    }
                    closedMap.put("tpv_stocksymbol1", jsonObject.getString("stock_code"));//股票代码
                    closedMap.put("tpv_businessscope", jsonObject.getString("oprt_scope"));//经营范围
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                String employeeNumResponse = GetPublicSentimentList.employeeNum(dynamicObject.getString("tpv_name"));
                JSONObject employeeNumJson = JSONObject.parseObject(employeeNumResponse);
                Map<String, JSONObject> sourceMap = new HashMap<>();
                if (null != employeeNumJson) {
                    // 获取"hits"数组
                    JSONArray hitsArray = employeeNumJson.getJSONObject("hits").getJSONArray("hits");
                    if (!hitsArray.isEmpty()) {
                        // 遍历数组，提取每个元素中的"_source"字段
                        for (int i = 0; i < hitsArray.size(); i++) {
                            JSONObject hit = hitsArray.getJSONObject(i);
                            JSONObject source = hit.getJSONObject("_source");
                            sourceMap.put(source.getString("report_year"), source);
                        }
                    }
                    if (!sourceMap.isEmpty()) {
                        // 使用Stream找到最大的年份键
                        Optional<String> maxYearKey = sourceMap.keySet().stream()
                                .max(String::compareTo);
                        if (maxYearKey.isPresent()) {
                            // 获取对应的JSONObject
                            JSONObject valueForMaxYear = sourceMap.get(maxYearKey.get());
                            JSONObject socialInsurance = valueForMaxYear.getJSONObject("social_insurance");
                            Integer maximum = maxCount(socialInsurance);
                            if (null != maximum) {
                                closedMap.put("tpv_insured", maximum.toString());//参保人数
                            }
                        }
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                String responseYear = GetPublicSentimentList.enterPriseYear(dynamicObject.getString("tpv_name"));
                // 将 JSON 字符串转换为 JSONObject 对象
                JSONObject jsonObject = JSON.parseObject(responseYear);
                // 从 JSONObject 中提取数据
                if (jsonObject != null) {
                    JSONObject hits = jsonObject.getJSONObject("hits");
                    if (hits != null) {
                        JSONArray hitsArray = hits.getJSONArray("hits");
                        if (hitsArray != null && hitsArray.size() > 0) {
                            JSONObject firstHit = hitsArray.getJSONObject(0);
                            if (firstHit != null) {
                                JSONObject source = firstHit.getJSONObject("_source");
                                if (source != null) {
                                    String year = source.getString("YEAR");
                                    closedMap.put("tpv_aptitude", year);
                                }
                            }
                        }
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        } else {
            Search search = this.getControl("tpv_suppliernameormark");
            Search tpv_suppliernameormark = this.getControl("tpv_suppliernameormark");
            tpv_suppliernameormark.setSearchKey(search.getSearchKey());
            String tpvSuppliernameormarkthis = tpv_suppliernameormark.getSearchKey();//供应商名称/税号
            closedMap.put("sign", "1");
            closedMap.put("name", tpvSuppliernameormarkthis);
        }
        //弹出页面对象赋值给父页面
        //弹出页面对象赋值给父页面
        this.getView().returnDataToParent(closedMap);
        this.getView().close();
        //this.getView().showForm(showParameter);
    }

    public Integer maxCount(JSONObject jsonObject) {
        String endowmentInsurance = jsonObject.getString("endowmentInsurance");//城镇职⼯基本养⽼保险⼈数
        endowmentInsurance = endowmentInsurance.replace("人", "");
        String medicalInsurance = jsonObject.getString("medicalInsurance");//职⼯基本医疗保险⼈数
        medicalInsurance = medicalInsurance.replace("人", "");
        String maternityInsurance = jsonObject.getString("maternityInsurance");//⽣育保险⼈数
        maternityInsurance = maternityInsurance.replace("人", "");
        String unemploymentInsurance = jsonObject.getString("unemploymentInsurance");//失业保险⼈数
        unemploymentInsurance = unemploymentInsurance.replace("人", "");
        String employmentInjuryInsurance = jsonObject.getString("employmentInjuryInsurance");//⼯商保险
        employmentInjuryInsurance = employmentInjuryInsurance.replace("人", "");
        try {
            // 假设字符串只包含数字
            int endowmentInsuranceCount = Integer.parseInt(endowmentInsurance);
            int medicalInsuranceCount = Integer.parseInt(medicalInsurance);
            int maternityInsuranceCount = Integer.parseInt(maternityInsurance);
            int unemploymentInsuranceCount = Integer.parseInt(unemploymentInsurance);
            int employmentInjuryInsuranceCount = Integer.parseInt(employmentInjuryInsurance);
            int maxCount = Math.max(endowmentInsuranceCount,
                    Math.max(medicalInsuranceCount,
                            Math.max(maternityInsuranceCount,
                                    Math.max(unemploymentInsuranceCount, employmentInjuryInsuranceCount))));
            return maxCount;
        } catch (NumberFormatException e) {
            e.printStackTrace();
        }
        return null;
    }

    public void copyClient() {
        Map<String, Object> closedMap = new HashMap<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        int index = this.getModel().getEntryCurrentRowIndex(TPV_ENTRYENTITY); //获取选中行索引
        DynamicObjectCollection objectCollection1 = dataEntity.getDynamicObjectCollection(TPV_ENTRYENTITY);
        if (objectCollection1.size() > 0) {
            DynamicObject dynamicObject = objectCollection1.get(index);
            long id = dynamicObject.getLong("tpv_bigintfield");
            //客户下推供应商
            closedMap.put("sign", "3");
            closedMap.put("id", id);
            this.getView().returnDataToParent(closedMap);
            this.getView().close();
            /*List<ListSelectedRow> selectedRowsTwo = new ArrayList<>();
            ListSelectedRow listSelectedRowTwo = new ListSelectedRow(id);//来源单据ID
            selectedRowsTwo.add(listSelectedRowTwo);
            PushArgs pushArgs = new PushArgs();
            pushArgs.setSourceEntityNumber(BD_CUSTOMER); // 必选，源单标识
            pushArgs.setTargetEntityNumber(BD_SUPPLIER); // 必选，目标单标识
            pushArgs.setAutoSave(true);//是否保存
            pushArgs.setRuleId("1768197727562287104"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
            pushArgs.setBuildConvReport(true); // 是否输出详细错误报告
            pushArgs.setSelectedRows(selectedRowsTwo); // 必选，设置需要下推的源单及分录内码
            ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
            if (pushResult.isSuccess()) {
                Push.showTargetBill(this.getView(), pushArgs, pushResult, false);
            } else {
                Push.showReport(this.getView(), pushArgs, pushResult);
            }*/
        }
    }

    /**
     * 分录行点击事件
     *
     * @param evt
     */
    @Override
    public void entryRowClick(RowClickEvent evt) {
        Control source = (Control) evt.getSource();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        if (StringUtils.equals(TPV_ENTRYENTITY, source.getKey())) {
            //选中行
            int row = evt.getRow();
            if (row != -1) {
                DynamicObjectCollection objectCollection1 = dataEntity.getDynamicObjectCollection(TPV_ENTRYENTITY);
                DynamicObject dynamicObject = objectCollection1.get(row);
                String tpvSearch = dynamicObject.getString("tpv_search");
                if (StringUtils.equals(tpvSearch, "A")) {
                    //系统供应商
                    this.getView().setVisible(true, "tpv_buttonap1");//下一步-已有供应商，直接打开
                    this.getView().setVisible(false, "tpv_buttonap2");//下一步-已有供应商，直接打开
                    this.getView().setVisible(false, "tpv_buttonap3");//下一步-已有供应商，直接打开
                } else if (StringUtils.equals(tpvSearch, "B")) {
                    this.getView().setVisible(false, "tpv_buttonap1");//下一步-已有供应商，直接打开
                    this.getView().setVisible(true, "tpv_buttonap2");//下一步-已有供应商，直接打开
                    this.getView().setVisible(false, "tpv_buttonap3");//下一步-已有供应商，直接打开
                } else {
                    this.getView().setVisible(false, "tpv_buttonap1");//下一步-已有供应商，直接打开
                    this.getView().setVisible(false, "tpv_buttonap2");//下一步-已有供应商，直接打开
                    this.getView().setVisible(true, "tpv_buttonap3");//下一步-已有供应商，直接打开
                }
            } else {
                this.getView().setVisible(false, "tpv_buttonap1");//下一步-已有供应商，直接打开
                this.getView().setVisible(false, "tpv_buttonap2");//下一步-已有供应商，直接打开
                this.getView().setVisible(false, "tpv_buttonap3");//下一步-已有供应商，直接打开
            }
        }
    }

    private void setButtonVisibility(boolean isVisible1, boolean isVisible2, boolean isVisible3) {
        this.getView().setVisible(isVisible1, "tpv_buttonap1");
        this.getView().setVisible(isVisible2, "tpv_buttonap2");
        this.getView().setVisible(isVisible3, "tpv_buttonap3");
    }

    public void directOpen() {
        Map<String, Object> closedMap = new HashMap<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        int index = this.getModel().getEntryCurrentRowIndex(TPV_ENTRYENTITY); //获取选中行索引
        DynamicObjectCollection objectCollection1 = dataEntity.getDynamicObjectCollection(TPV_ENTRYENTITY);
        DynamicObject dynamicObject = objectCollection1.get(index);
        long id = dynamicObject.getLong("tpv_bigintfield");
        if (id != 0L) {
            //skipMethod("bd_supplier", id);
            closedMap.put("sign", "2");
            closedMap.put("FormId", "bd_supplier");
            closedMap.put("PkId", id);
            this.getView().returnDataToParent(closedMap);
            this.getView().close();
        }
    }

    public void skipMethod(String formId, Object object) {
        BillShowParameter showParameter = new BillShowParameter();
        showParameter.setFormId(formId);
        showParameter.setPkId(object);
        showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
        showParameter.setStatus(OperationStatus.VIEW);
        this.getView().showForm(showParameter);
    }

    /**
     * 供应商和客户去重
     *
     * @return
     */

    public List<Long> deWeight(DynamicObject[] bdSupplierName) {
        Map<String, Long> bdSupplierNameMap = Arrays.stream(bdSupplierName)
                .collect(Collectors.toMap(
                        dynamicObject -> dynamicObject.getString("name") + dynamicObject.getString("societycreditcode"),
                        dynamicObject -> dynamicObject.getLong("id"),
                        (existing, replacement) -> existing
                ));

        return bdSupplierNameMap.values().stream().collect(Collectors.toList());
    }
    /*public List<Long> deWeight(DynamicObject[] bdSupplierName) {
        Map<String, Long> bdSupplierNameMap = new HashMap<>();
        for (DynamicObject dynamicObject : bdSupplierName) {
            if (bdSupplierNameMap.isEmpty()) {
                bdSupplierNameMap.put(dynamicObject.getString("name") + dynamicObject.getString("societycreditcode"), dynamicObject.getLong("id"));
            } else {
                if (!bdSupplierNameMap.containsKey(dynamicObject.getString("name") + dynamicObject.getString("societycreditcode"))) {
                    bdSupplierNameMap.put(dynamicObject.getString("name") + dynamicObject.getString("societycreditcode"), dynamicObject.getLong("id"));
                }
            }
        }
        //供应商过滤后的数据id
        List<Long> bdSupplierId = new ArrayList<>();
        if (!bdSupplierNameMap.isEmpty()) {
            for (Map.Entry<String, Long> entry : bdSupplierNameMap.entrySet()) {
                bdSupplierId.add(entry.getValue());
            }
        }
        return bdSupplierId;
    }*/

    public void buttonapDate() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        this.getModel().deleteEntryData(TPV_ENTRYENTITY);
        Search search = this.getControl("tpv_suppliernameormark");
        Search tpv_suppliernameormark = this.getControl("tpv_suppliernameormark");
        tpv_suppliernameormark.setSearchKey(search.getSearchKey());
        String tpvSuppliernameormarkthis = tpv_suppliernameormark.getSearchKey();//供应商名称/税号
        if (tpvSuppliernameormarkthis==null){
            return;
        }
        String selectCondition = tpvSuppliernameormarkthis.replaceAll("[^\\p{L}\\p{N}]", "");
        DynamicObjectCollection tpvEntryentity = dataEntity.getDynamicObjectCollection("tpv_entryentity");
        if (StringUtils.isNotEmpty(tpvSuppliernameormarkthis)) {
            ArrayList<DynamicObject> dynamicObjectCustomer = new ArrayList<>();//客户数据List
            ArrayList<DynamicObject> completeList = new ArrayList<>();//客户和供应商数据List
            //查询系统中供应商和客户
//            DynamicObject[] bdSupplierName = BusinessDataServiceHelper.load("bd_supplier", "id,name,societycreditcode",
//                    new QFilter("name", QCP.ILIKE, "%" + selectCondition + "%").toArray());
            DynamicObject[] bdSupplierName = BusinessDataServiceHelper.load("bd_supplier", "id,name,societycreditcode",
                   null);
            List<DynamicObject> list = Arrays.stream(bdSupplierName)
                    .filter(object -> {
                        String name = object.getString("name");
                        return name != null && name.replaceAll("[^\\p{L}\\p{N}]", "").contains(selectCondition);
                    })
                    .collect(Collectors.toList());
            DynamicObject[] array = list.toArray(new DynamicObject[0]);
            if (bdSupplierName.length > 0) {
                List<Long> longs = deWeight(array);
                if (!longs.isEmpty()) {
                    DynamicObject[] bdSupplierNameT = BusinessDataServiceHelper.load("bd_supplier", "id,name,societycreditcode",
                            new QFilter("id", QCP.in, longs).toArray());
                    if (bdSupplierNameT.length > 0) {
                        addNew(bdSupplierNameT, ONE);
                    }
                }
            }
            DynamicObject[] bdCustomerName = BusinessDataServiceHelper.load("bd_customer", "id,name,societycreditcode",
                    new QFilter("name",QCP.ILIKE, "%" + selectCondition + "%").toArray());
            if (bdSupplierName.length > 0 || bdCustomerName.length > 0) {
                if (bdSupplierName.length > 0 && bdCustomerName.length > 0) {
                    Map<String, Long> idNameMap = new HashMap<>();
                    Map<String, Long> idSocietycreditcodeMap = new HashMap<>();
                    for (DynamicObject dynamicObject : bdSupplierName) {
                        completeList.add(dynamicObject);
                        idNameMap.put(dynamicObject.getString("name"), dynamicObject.getLong("id"));
                        idSocietycreditcodeMap.put(dynamicObject.getString("societycreditcode"), dynamicObject.getLong("id"));
                    }
                    for (DynamicObject object : bdCustomerName) {
                        if (!idNameMap.containsKey(object.getString("name")) && !idSocietycreditcodeMap.containsKey(object.getString("societycreditcode"))) {
                            dynamicObjectCustomer.add(object);
                            completeList.add(object);
                        }
                    }
                } else if (bdSupplierName.length > 0) {
                    for (DynamicObject dynamicObject : bdSupplierName) {
                        completeList.add(dynamicObject);
                    }
                } else {
                    for (DynamicObject object : bdCustomerName) {
                        dynamicObjectCustomer.add(object);
                        completeList.add(object);
                    }
                }
            }
            if (!dynamicObjectCustomer.isEmpty()) {
                bdCustomerName = dynamicObjectCustomer.toArray(new DynamicObject[0]);
                List<Long> longs1 = deWeight(bdCustomerName);
                if (!longs1.isEmpty()) {
                    DynamicObject[] bdCustomerNameT = BusinessDataServiceHelper.load("bd_customer", "id,name,societycreditcode",
                            new QFilter("id", QCP.in, longs1).toArray());
                    if (null != bdCustomerNameT) {
                        addNew(bdCustomerNameT, TWO);
                    }
                }
            }
            try {
                String response = GetPublicSentimentList.testFunc(selectCondition);
                JSONObject jsonObject = JSONObject.parseObject(response);
                if (null != jsonObject) {
                    JSONArray itemsJsonArray = jsonObject.getJSONArray("items");
                    if (itemsJsonArray.size() > 0) {
                        for (int i1 = 0; i1 < itemsJsonArray.size(); i1++) {
                            String name = "";
                            String dynasty = "";
                            List<String> nameList = new ArrayList<>();
                            List<String> societycreditcodeList = new ArrayList<>();
                            if (i1 < 10) {
                                JSONObject itemsJsonObject = itemsJsonArray.getJSONObject(i1);
                                String companyName = itemsJsonObject.getString("companyName");
                                String ucCode = itemsJsonObject.getString("ucCode");//统代
                                if (!completeList.isEmpty()) {
                                    for (DynamicObject dynamicObject : completeList) {
                                        if (StringUtils.equals(companyName, dynamicObject.getString("name"))) {
                                            nameList.add(companyName);
                                        } else {
                                            name = companyName;
                                        }
                                        if (StringUtils.equals(ucCode, dynamicObject.getString("societycreditcode"))) {
                                            societycreditcodeList.add(ucCode);
                                        } else {
                                            dynasty = ucCode;
                                        }
                                    }
                                    if (!StringUtils.equals("", name) && nameList.isEmpty() && !StringUtils.equals("", dynasty) && societycreditcodeList.isEmpty()) {
                                        DynamicObject dynamicObject1 = tpvEntryentity.addNew();
                                        dynamicObject1.set("tpv_societycreditcode", ucCode);
                                        dynamicObject1.set("tpv_name", companyName);
                                        dynamicObject1.set("tpv_search", "C");//搜索来源外部
                                    }
                                } else {
                                    DynamicObject dynamicObject1 = tpvEntryentity.addNew();
                                    dynamicObject1.set("tpv_societycreditcode", ucCode);
                                    dynamicObject1.set("tpv_name", companyName);
                                    dynamicObject1.set("tpv_search", "C");//搜索来源外部
                                }
                            }
                        }
                        this.getView().updateView("tpv_entryentity");//刷新单据体
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            this.getView().setVisible(false, "tpv_buttonap1");//下一步-已有供应商，直接打开
            this.getView().setVisible(false, "tpv_buttonap2");//下一步-已有供应商，直接打开
            this.getView().setVisible(false, "tpv_buttonap3");//下一步-已有供应商，直接打开
        } else {
            this.getView().showErrorNotification("请先输入供应商名称再点击检索");
        }
    }

    //单据体赋值
    public void addNew(DynamicObject[] bdSupplierName, String judge) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvEntryentity = dataEntity.getDynamicObjectCollection("tpv_entryentity");
        for (DynamicObject dynamicObject : bdSupplierName) {
            DynamicObject tpvEntryentityNew = tpvEntryentity.addNew();
            tpvEntryentityNew.set("tpv_name", dynamicObject.getString("name"));//名称
            tpvEntryentityNew.set("tpv_societycreditcode", dynamicObject.getString("societycreditcode"));//统一社会信用代码
            if (judge.equals(ONE)) {
                tpvEntryentityNew.set("tpv_search", "A");//搜索来源系统供应商
                tpvEntryentityNew.set("tpv_bigintfield", dynamicObject.getString("id"));//id
            } else if (judge.equals(TWO)) {
                tpvEntryentityNew.set("tpv_search", "B");//搜索来源系统客户
                tpvEntryentityNew.set("tpv_bigintfield", dynamicObject.getString("id"));//id
            } else {
                tpvEntryentityNew.set("tpv_search", "C");//搜索来源外部
            }
        }
        this.getView().updateView("tpv_entryentity");//刷新单据体
    }

    @Override
    public void search(SearchEnterEvent e) {
        Search search = (Search) e.getSource();
        String key = search.getKey();
        String searchText = e.getText();
        if (key.equals("tpv_suppliernameormark")) {//资源号搜索
            if (StringUtils.isNotEmpty(searchText)) {
                searchapSearch(searchText);
            }
        }
    }

    /**
     * 资源号搜索
     *
     * @param key 用户输入内容
     */
    public void searchapSearch(String key) {
        IFormView view = this.getView();
        DynamicObject dataEntity = view.getModel().getDataEntity(true);
        String selectCondition = key.replaceAll("[^\\p{L}\\" + "p{N}]", "");
        DynamicObjectCollection tpvEntryentity = dataEntity.getDynamicObjectCollection("tpv_entryentity");
        if (StringUtils.isNotEmpty(key)) {
            ArrayList<DynamicObject> dynamicObjectCustomer = new ArrayList<>();//客户数据List
            ArrayList<DynamicObject> completeList = new ArrayList<>();//客户和供应商数据List
            //查询系统中供应商和客户
            DynamicObject[] bdSupplierName = BusinessDataServiceHelper.load("bd_supplier", "id,name,societycreditcode",
                    new QFilter("name", QCP.ILIKE, "%" + selectCondition + "%").toArray());
            if (bdSupplierName.length > 0) {
                List<Long> longs = deWeight(bdSupplierName);
                if (!longs.isEmpty()) {
                    DynamicObject[] bdSupplierNameT = BusinessDataServiceHelper.load("bd_supplier", "id,name,societycreditcode",
                            new QFilter("id", QCP.in, longs).toArray());
                    if (bdSupplierNameT.length > 0) {
                        addNew(bdSupplierNameT, ONE);
                    }
                }
            }
            DynamicObject[] bdCustomerName = BusinessDataServiceHelper.load("bd_customer", "id,name,societycreditcode",
                    new QFilter("name", QCP.ILIKE, "%" + selectCondition + "%").toArray());
            if (bdSupplierName.length > 0 || bdCustomerName.length > 0) {
                if (bdSupplierName.length > 0 && bdCustomerName.length > 0) {
                    Map<String, Long> idNameMap = new HashMap<>();
                    Map<String, Long> idSocietycreditcodeMap = new HashMap<>();
                    for (DynamicObject dynamicObject : bdSupplierName) {
                        completeList.add(dynamicObject);
                        idNameMap.put(dynamicObject.getString("name"), dynamicObject.getLong("id"));
                        idSocietycreditcodeMap.put(dynamicObject.getString("societycreditcode"), dynamicObject.getLong("id"));
                    }
                    for (DynamicObject object : bdCustomerName) {
                        if (!idNameMap.containsKey(object.getString("name")) && !idSocietycreditcodeMap.containsKey(object.getString("societycreditcode"))) {
                            dynamicObjectCustomer.add(object);
                            completeList.add(object);
                        }
                    }
                } else if (bdSupplierName.length > 0) {
                    for (DynamicObject dynamicObject : bdSupplierName) {
                        completeList.add(dynamicObject);
                    }
                } else {
                    for (DynamicObject object : bdCustomerName) {
                        dynamicObjectCustomer.add(object);
                        completeList.add(object);
                    }
                }
            }
            if (!dynamicObjectCustomer.isEmpty()) {
                bdCustomerName = dynamicObjectCustomer.toArray(new DynamicObject[0]);
                List<Long> longs1 = deWeight(bdCustomerName);
                if (!longs1.isEmpty()) {
                    DynamicObject[] bdCustomerNameT = BusinessDataServiceHelper.load("bd_customer", "id,name,societycreditcode",
                            new QFilter("id", QCP.in, longs1).toArray());
                    if (null != bdCustomerNameT) {
                        addNew(bdCustomerNameT, TWO);
                    }
                }
            }
            try {
                String response = GetPublicSentimentList.testFunc(selectCondition);
                JSONObject jsonObject = JSONObject.parseObject(response);
                if (null != jsonObject) {
                    JSONArray itemsJsonArray = jsonObject.getJSONArray("items");
                    if (itemsJsonArray.size() > 0) {
                        for (int i1 = 0; i1 < itemsJsonArray.size(); i1++) {
                            String name = "";
                            String dynasty = "";
                            List<String> nameList = new ArrayList<>();
                            List<String> societycreditcodeList = new ArrayList<>();
                            if (i1 < 10) {
                                JSONObject itemsJsonObject = itemsJsonArray.getJSONObject(i1);
                                String companyName = itemsJsonObject.getString("companyName");
                                String ucCode = itemsJsonObject.getString("ucCode");//统代
                                if (!completeList.isEmpty()) {
                                    for (DynamicObject dynamicObject : completeList) {
                                        if (StringUtils.equals(companyName, dynamicObject.getString("name"))) {
                                            nameList.add(companyName);
                                        } else {
                                            name = companyName;
                                        }
                                        if (StringUtils.equals(ucCode, dynamicObject.getString("societycreditcode"))) {
                                            societycreditcodeList.add(ucCode);
                                        } else {
                                            dynasty = ucCode;
                                        }
                                    }
                                    if (!StringUtils.equals("", name) && nameList.isEmpty() && !StringUtils.equals("", dynasty) && societycreditcodeList.isEmpty()) {
                                        DynamicObject dynamicObject1 = tpvEntryentity.addNew();
                                        dynamicObject1.set("tpv_societycreditcode", ucCode);
                                        dynamicObject1.set("tpv_name", companyName);
                                        dynamicObject1.set("tpv_search", "C");//搜索来源外部
                                    }
                                } else {
                                    DynamicObject dynamicObject1 = tpvEntryentity.addNew();
                                    dynamicObject1.set("tpv_societycreditcode", ucCode);
                                    dynamicObject1.set("tpv_name", companyName);
                                    dynamicObject1.set("tpv_search", "C");//搜索来源外部
                                }
                            }
                        }
                        this.getView().updateView("tpv_entryentity");//刷新单据体
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            this.getView().setVisible(false, "tpv_buttonap1");//下一步-已有供应商，直接打开
            this.getView().setVisible(false, "tpv_buttonap2");//下一步-已有供应商，直接打开
            this.getView().setVisible(false, "tpv_buttonap3");//下一步-已有供应商，直接打开
        } else {
            view.showErrorNotification("根据内容，未能找到对应的数据！");
        }
    }
}
