package tpv.sys.basedata.java.formplugin.form;

import com.alibaba.druid.util.StringUtils;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.IFormView;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.ShowType;
import kd.bos.form.container.Tab;
import kd.bos.form.control.events.TabSelectEvent;
import kd.bos.form.control.events.TabSelectListener;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * 客户联系人信息表单插件
 */
public class CustomerBillPlugin extends AbstractBillPlugIn implements TabSelectListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        Tab tab = (Tab) this.getView().getControl("tabap");
        if (tab != null) {
            tab.addTabSelectListener(this);
        }

    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        String operateKey = e.getOperateKey();
        switch (operateKey) {
            case "save":
//			if (StringUtils.isNotBlank(downloadUrl)) {
//			    this.getView().openUrl(downloadUrl);
//			 }
//			boolean ss =  e.getOperationResult().isSuccess();
//			if(ss)
//			{
                showBill("tpv_advsubconchildpan", "tpv_bd_contactin_ext");
//			}
                break;
            default:
                break;
        }
    }

    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        showBill("tpv_advsubconchildpan", "tpv_bd_contactin_ext");
    }

    /**
     * @param targetKey 容器Key
     * @param formkey   单据标识
     */
    private void showBill(String targetKey, String formkey) {
        // 获取当前单据内码
//		long userId = 0;
//		List<Object> userId =new List<Object>();
        List userId = new ArrayList<>();
        List departmentid = new ArrayList<>();
//		Object departmentid = 0;
        long currentUserId = UserServiceHelper.getCurrentUserId();
        DynamicObject bos_user = BusinessDataServiceHelper.loadSingle(currentUserId, "bos_user");
        if (bos_user != null) {
            DynamicObjectCollection cols = bos_user.getDynamicObjectCollection("entryentity");
            for (DynamicObject col : cols) {
                DynamicObject dpt = col.getDynamicObject("dpt");
                //根据组织内码获取组织属性
                dpt = BusinessDataServiceHelper.loadSingleFromCache(dpt.getPkValue(),
                        dpt.getDataEntityType().getName());
                DynamicObject orgpattern = dpt.getDynamicObject("orgpattern");
                if (orgpattern != null) {
                    userId.add(dpt.getLong("id"));
                    String orgpatternName = orgpattern.getString("Name");
                    if (orgpatternName.equals("部门")) {
                        departmentid.add(dpt.getLong("id"));
                    }
                }
            }
        }


        long currentUser = YEM.getCurrentUserId();

        DynamicObject bosUser = BusinessDataServiceHelper.loadSingleFromCache(currentUser, "bos_user");

        List<Long> dept = new ArrayList<>();
        DynamicObjectCollection entryentity = bosUser.getDynamicObjectCollection("entryentity");
        for (DynamicObject row : entryentity) {
            dept.add(row.getDynamicObject("dpt").getLong("id"));
            DynamicObject bosAdminorg = BusinessDataServiceHelper.loadSingle(row.getDynamicObject("dpt").getPkValue(), "bos_adminorg");
            DynamicObjectCollection structures =bosAdminorg.getDynamicObjectCollection("structure");
            for (DynamicObject structure : structures) {
                DynamicObject viewparent = structure.getDynamicObject("viewparent");
                if (YEM.isNotEmpty(viewparent)) {
                    dept.add(viewparent.getLong("id"));
                }
            }
        }

//        if(dept.size()!=0){
//            DynamicObject[] adminOrgs = BusinessDataServiceHelper.load("bos_adminorg", "", new QFilter[]{new QFilter("structure.viewparent", "in", dept)});
//            for (DynamicObject adminOrg : adminOrgs) {
//                dept.add(adminOrg.getLong("id"));
//            }
//        }

        IFormView view = this.getView();
        ListShowParameter listShowParameter = ShowFormHelper.createShowListForm(formkey, false, 1, false);
        listShowParameter.setStatus(OperationStatus.EDIT);
        listShowParameter.getOpenStyle().setShowType(ShowType.InContainer);
        listShowParameter.getOpenStyle().setTargetKey(targetKey);
        listShowParameter.setSendToClient(true);
        List<QFilter> filters = new ArrayList<>();
        filters.add(new QFilter("tpv_customer", QCP.equals, this.getModel().getDataEntity().getPkValue().toString()));
//        filters.add(new QFilter("tpv_supplier",QCP.equals,"0"));
        filters.add(new QFilter("tpv_entryentity.tpv_basedata",QCP.in,dept));
//        listShowParameter.setCustomParam("tpv_customerid", this.getModel().getDataEntity().getPkValue().toString());
//        listShowParameter.setCustomParam("tpv_supplierid","0"); //供应商id
//        listShowParameter.setCustomParam("tpv_basedata", userId);//人员全部部门（过滤）
//        listShowParameter.setCustomParam("departmentid", departmentid);//形态是部门

        listShowParameter.getListFilterParameter().setQFilters(filters);
        view.showForm(listShowParameter);
    }

    @Override
    public void tabSelected(TabSelectEvent arg0) {
        String tabKey = arg0.getTabKey();
        if (StringUtils.equals(tabKey, "tpv_contactcreditgra"))
        {
            String fid = this.getModel().getDataEntity().getPkValue().toString();
            if(fid.equals("0"))
            {
                this.getView().invokeOperation("save");
            }
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        switch (name) {
            case "societycreditcode": //统一社会信用代码
                trimAllSpace("societycreditcode");
                break;
            case "tx_register_no": //纳税人识别号
                trimAllSpace("tx_register_no");
                break;
        }
    }

    private void trimAllSpace(String tx_register_no) {
        String oldName = (String) this.getModel().getValue(tx_register_no);
        String newName = oldName.replace(" ", "");//将合同号中的" "替换为""
        this.getModel().setValue(tx_register_no, newName);
    }
}
