package tpv.sys.basedata.java.formplugin.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.FormOperate;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * @author l jw
 * @date 2023/10/30 22:22
 * @className MaterialOp
 * @description 物料表单插件
 * 点击删行时检测是否有单据引用如果引用不允许删除
 */
public class MaterialFormPlugin extends AbstractFormPlugin {
    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate formOperate = (FormOperate) args.getSource();
        switch (formOperate.getOperateKey()) {//操作类型
            case "deleteentry_bank"://删除分录
                this.showExchangerate(args);
                break;
        }
    }

    private void showExchangerate(BeforeDoOperationEventArgs args) {
        DynamicObjectCollection accountname = (DynamicObjectCollection) this.getModel().getEntryEntity("tpv_bd_material_ext_c");//单据体分录
        List del_id_s = new ArrayList();
        for (DynamicObject dynamicObject : accountname) {
            String tpv_aliasname = dynamicObject.getString("tpv_aliasname");//别名
            del_id_s.add(tpv_aliasname);
        }
        QFilter qFilter = new QFilter("tpv_materialentry.tpv_prodname.number", QCP.in, del_id_s);
        //协议
        DynamicObject[] tpv_dt_agreement = BusinessDataServiceHelper.load("tpv_dt_agreement", "id,number", new QFilter[]{qFilter});
        if (tpv_dt_agreement.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //委托销售函
        DynamicObject[] tpv_dt_letterofcon = BusinessDataServiceHelper.load("tpv_dt_letterofcon", "id,number", new QFilter[]{qFilter});
        if (tpv_dt_letterofcon.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //采购合同
        DynamicObject[] tpv_dt_purchase = BusinessDataServiceHelper.load("tpv_dt_purchase", "id,number", new QFilter[]{qFilter});
        if (tpv_dt_purchase.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //销售合同
        DynamicObject[] tpv_dt_salescontract = BusinessDataServiceHelper.load("tpv_dt_salescontract", "id,number", new QFilter[]{qFilter});
        if (tpv_dt_salescontract.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //货物流转单
        DynamicObject[] tpv_dt_freigroambill = BusinessDataServiceHelper.load("tpv_dt_freigroambill", "id,number", new QFilter[]{qFilter});
        if (tpv_dt_freigroambill.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //收货/开票确认函
        DynamicObject[] tpv_dt_confirmation = BusinessDataServiceHelper.load("tpv_dt_confirmation", "id,number", new QFilter[]{qFilter});
        if (tpv_dt_confirmation.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //销售价格确认单
        DynamicObject[] tpv_dt_salepricebill = BusinessDataServiceHelper.load("tpv_dt_salepricebill", "id,number", new QFilter[]{qFilter});
        if (tpv_dt_salepricebill.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //销售发货
        DynamicObject[] tpv_dt_salesshipping = BusinessDataServiceHelper.load("tpv_dt_salesshipping", "id,number", new QFilter[]{qFilter});
        if (tpv_dt_salesshipping.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //验收单
        DynamicObject[] tpv_dt_acceptbill = BusinessDataServiceHelper.load("tpv_dt_acceptbill", "id,number", new QFilter[]{qFilter});
        if (tpv_dt_acceptbill.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //加工指令单
        DynamicObject[] tpv_dt_process = BusinessDataServiceHelper.load("tpv_dt_process", "id,number", new QFilter[]{qFilter});
        if (tpv_dt_process.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //借货单
//        DynamicObject[] tpv_dt_debitnote = BusinessDataServiceHelper.load("tpv_dt_debitnote", "id,number", new QFilter[]{qFilter});
//        if (tpv_dt_debitnote.length > 0) {
//            this.getView().showMessage("“借货单”引用该数据，不能删除！！！");
//        }
        //还货单
//        DynamicObject[] tpv_dt_returnorder = BusinessDataServiceHelper.load("tpv_dt_returnorder", "id,number", new QFilter[]{qFilter});
//        if (tpv_dt_returnorder.length > 0) {
//            this.getView().showMessage("“还货单”引用该数据，不能删除！！！");
//        }
        //回购单
//        DynamicObject[] tpv_dt_repurchaseorder = BusinessDataServiceHelper.load("tpv_dt_repurchaseorder", "id,number", new QFilter[]{qFilter});
//        if (tpv_dt_repurchaseorder.length > 0) {
//            this.getView().showMessage("“回购单”引用该数据，不能删除！！！");
//        }
        //进口合同（作废）
        DynamicObject[] tpv_is_impcontract = BusinessDataServiceHelper.load("tpv_is_impcontract", "id,number", new QFilter[]{qFilter});
        if (tpv_is_impcontract.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //进口报关单
        DynamicObject[] tpv_is_impclearance = BusinessDataServiceHelper.load("tpv_is_impclearance", "id,number", new QFilter[]{qFilter});
        if (tpv_is_impclearance.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //进口到货
        DynamicObject[] tpv_is_arrivaldetailbill = BusinessDataServiceHelper.load("tpv_is_arrivaldetailbill", "id,number", new QFilter[]{qFilter});
        if (tpv_is_arrivaldetailbill.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //进口到单
        DynamicObject[] tpv_is_arrivaldetais = BusinessDataServiceHelper.load("tpv_is_arrivaldetais", "id,number", new QFilter[]{qFilter});
        if (tpv_is_arrivaldetais.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //外销合同（作废）
        DynamicObject[] tpv_es_salecontract = BusinessDataServiceHelper.load("tpv_es_salecontract", "id,number", new QFilter[]{qFilter});
        if (tpv_es_salecontract.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //储运托单
        DynamicObject[] tpv_es_storagetrans = BusinessDataServiceHelper.load("tpv_es_storagetrans", "id,number", new QFilter[]{qFilter});
        if (tpv_es_storagetrans.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //出口报关单
        DynamicObject[] tpv_es_declaredoc = BusinessDataServiceHelper.load("tpv_es_declaredoc", "id,number", new QFilter[]{qFilter});
        if (tpv_es_declaredoc.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //出口交单
        DynamicObject[] tpv_es_exportdelivery = BusinessDataServiceHelper.load("tpv_es_exportdelivery", "id,number", new QFilter[]{qFilter});
        if (tpv_es_exportdelivery.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //退税申请
        DynamicObject[] tpv_es_refund = BusinessDataServiceHelper.load("tpv_es_refund", "id,number", new QFilter[]{qFilter});
        if (tpv_es_refund.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //配供送货单
//        DynamicObject[] tpv_pw_pgshd = BusinessDataServiceHelper.load("tpv_pw_pgshd", "id,number", new QFilter[]{qFilter});
//        if (tpv_pw_pgshd.length > 0) {
//            this.getView().showMessage("“配供送货单”引用该数据，不能删除！！！");
//        }
        //配供物流费用结算单
//        DynamicObject[] tpv_pw_pgwlfyjsd = BusinessDataServiceHelper.load("tpv_pw_pgwlfyjsd", "id,number", new QFilter[]{qFilter});
//        if (tpv_pw_pgwlfyjsd.length > 0) {
//            this.getView().showMessage("“配供物流费用结算单”引用该数据，不能删除！！！");
//        }
        //物流商品分类标准单
        DynamicObject[] tpv_wms_logistics = BusinessDataServiceHelper.load("tpv_wms_logistics", "id,number", new QFilter[]{qFilter});
        if (tpv_wms_logistics.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //对外物流服务合同
        DynamicObject[] tpv_wms_extcont = BusinessDataServiceHelper.load("tpv_wms_extcont", "id,number", new QFilter[]{qFilter});
        if (tpv_wms_extcont.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //仓单质押
        DynamicObject[] tpv_tm_storagepledge = BusinessDataServiceHelper.load("tpv_tm_storagepledge", "id,number", new QFilter[]{qFilter});
        if (tpv_tm_storagepledge.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //仓单解押
        DynamicObject[] tpv_tm_storagerelmort = BusinessDataServiceHelper.load("tpv_tm_storagerelmort", "id,number", new QFilter[]{qFilter});
        if (tpv_tm_storagerelmort.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //货物解押单（未增加前缀）
        DynamicObject[] tpv_cargodecompression = BusinessDataServiceHelper.load("tpv_cargodecompression", "id,number", new QFilter[]{qFilter});
        if (tpv_cargodecompression.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
        //质押收货单（未增加前缀）
        DynamicObject[] tpv_pledgereceipt = BusinessDataServiceHelper.load("tpv_pledgereceipt", "id,number", new QFilter[]{qFilter});
        if (tpv_pledgereceipt.length > 0) {
            this.getView().showMessage(" 该数据已被引用，不能删除！！！");
            args.setCancel(true);
        }
    }
}
