package tpv.sys.basedata.java.formplugin.form;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.itopview.wm.utils.YEM;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.IFormView;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.FormOperate;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.basedata.BaseDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import tpv.tpv_wm.tpv_iscb.java.api.ant.GetPublicSentimentList;

import java.util.*;


/**
 * @author l jw
 * @date 2023/9/5 15:06
 * @className SupplierFormPlugin
 * @description 供应商银行分录删行是效验付款申请单是否引用改行数据
 */
public class SupplierFormPlugin extends AbstractFormPlugin {
    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate formOperate = (FormOperate) args.getSource();
        switch (formOperate.getOperateKey()) {//操作类型
            case "deleteentry_bank"://删除分录
                this.showExchangerate(args);
                break;
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"tbmain"});
    }

    /**
     * WangShuGuang
     * 添加功能
     *
     * @param
     */
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        //获取隐藏分录数据
        Map<Integer, String> screeningresultsMAP = new HashMap<>();//初筛结果存放map
        Map<Integer, Date> updateTimeMAP = new HashMap<>();//更新时间存放map
        DynamicObjectCollection tpvAuxiliaryentrie = dataEntity.getDynamicObjectCollection("tpv_auxiliaryentrie");
        DynamicObjectCollection entryGroupstandard = dataEntity.getDynamicObjectCollection("entry_groupstandard");//获取分类标准分录
        if (!tpvAuxiliaryentrie.isEmpty() && !entryGroupstandard.isEmpty()) {
            for (DynamicObject dynamicObject : tpvAuxiliaryentrie) {
                int Seq = dynamicObject.getInt("Seq");
                screeningresultsMAP.put(Seq, dynamicObject.getString("tpv_screeningresults1"));
                updateTimeMAP.put(Seq, dynamicObject.getDate("tpv_updatetime1"));
            }
            if (screeningresultsMAP.size() > 0) {
                for (DynamicObject dynamicObject : entryGroupstandard) {
                    int tpvPreliminaryrulrld = dynamicObject.getInt("Seq");
                    if (screeningresultsMAP.containsKey(tpvPreliminaryrulrld)) {
                        dynamicObject.set("tpv_screeningresults", screeningresultsMAP.get(tpvPreliminaryrulrld));
                        this.getView().updateView("entry_groupstandard");
                    }
                    if (updateTimeMAP.containsKey(tpvPreliminaryrulrld)) {
                        dynamicObject.set("tpv_updatetime", updateTimeMAP.get(tpvPreliminaryrulrld));
                        this.getView().updateView("entry_groupstandard");
                    }
                }
            }
        }
    }

    /**
     * 监听保存按钮之后
     *
     * @param e
     */
    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String key = e.getOperateKey();
        if (key.equals("save")) {
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            //获取隐藏分录数据
            Map<Integer, String> screeningresultsMAP = new HashMap<>();//初筛结果存放map
            Map<Integer, Date> updateTimeMAP = new HashMap<>();//更新时间存放map
            DynamicObjectCollection tpvAuxiliaryentrie = dataEntity.getDynamicObjectCollection("tpv_auxiliaryentrie");
            DynamicObjectCollection entryGroupstandard = dataEntity.getDynamicObjectCollection("entry_groupstandard");//获取分类标准分录
            if (!tpvAuxiliaryentrie.isEmpty() && !entryGroupstandard.isEmpty()) {
                for (DynamicObject dynamicObject : tpvAuxiliaryentrie) {
                    int Seq = dynamicObject.getInt("Seq");
                    screeningresultsMAP.put(Seq, dynamicObject.getString("tpv_screeningresults1"));
                    updateTimeMAP.put(Seq, dynamicObject.getDate("tpv_updatetime1"));
                }
                if (screeningresultsMAP.size() > 0) {
                    for (DynamicObject dynamicObject : entryGroupstandard) {
                        int tpvPreliminaryrulrld = dynamicObject.getInt("Seq");
                        if (screeningresultsMAP.containsKey(tpvPreliminaryrulrld)) {
                            dynamicObject.set("tpv_screeningresults", screeningresultsMAP.get(tpvPreliminaryrulrld));
                            this.getView().updateView("entry_groupstandard");
                            this.getModel().setDataChanged(false);
                        }
                        if (updateTimeMAP.containsKey(tpvPreliminaryrulrld)) {
                            dynamicObject.set("tpv_updatetime", updateTimeMAP.get(tpvPreliminaryrulrld));
                            this.getView().updateView("entry_groupstandard");
                            this.getModel().setDataChanged(false);
                        }
                    }
                }
            }
        }
    }

    /**
     * WangShuGuang
     * 添加功能
     *
     * @param
     */
    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        if (StringUtils.equals(itemKey, "tpv_baritemap1")) {
            //更新工商数据
            String number = dataEntity.getString("number");//供应商编码
            String tpv_sourcebillno = dataEntity.getString("tpv_sourcebillno");//来源单据编码
            DynamicObject bdCustomer = null;
            if (StringUtils.isEmpty(tpv_sourcebillno)) {
                //查询所关联的客户
                bdCustomer = BusinessDataServiceHelper.loadSingle("bd_customer", "tpv_sourcebillno,id,name,societycreditcode,tpv_qichachaman,tpv_qichachadate",
                        new QFilter("tpv_sourcebillno", QCP.equals, number).toArray());
            } else {
                bdCustomer = BusinessDataServiceHelper.loadSingle("bd_customer", "number,id,name,societycreditcode,tpv_qichachaman,tpv_qichachadate",
                        new QFilter("number", QCP.equals, tpv_sourcebillno).toArray());
            }
            //供应商名称
            String name = dataEntity.getLocaleString("name").getLocaleValue();
            //统一社会信用代码 NEW: 如果统一社会信用代码有值则为入参，否则以名称为入参
            String societycreditcode = dataEntity.getString("societycreditcode");
            if (YEM.isNotEmpty(societycreditcode)) {
                name = societycreditcode;
            }
            //客户名称/统一社会信用代码  NEW: 如果统一社会信用代码有值则为入参，否则以名称为入参
            String bdCustomerName = null;
            if (YEM.isNotEmpty(bdCustomer)) {
                bdCustomer = BusinessDataServiceHelper.loadSingle(bdCustomer.getPkValue(),
                        bdCustomer.getDynamicObjectType().getName());
                String bdCustomerCreditcode = bdCustomer.getString("societycreditcode");
                if (YEM.isNotEmpty(bdCustomerCreditcode)) {
                    bdCustomerName = bdCustomerCreditcode;
                } else {
                    bdCustomerName = bdCustomer.getLocaleString("name").getLocaleValue();
                }

            }
            String responseCustomer = null;//客户
            JSONObject jsonObjectCustomer = new JSONObject();//客户
            try {
                if (StringUtils.isNotEmpty(bdCustomerName)) {
                    //有对应的客户
                    responseCustomer = GetPublicSentimentList.enterPrise(bdCustomerName);
                    jsonObjectCustomer = JSONObject.parseObject(responseCustomer);
                }
                if (!jsonObjectCustomer.isEmpty()) {
                    //客户赋值
                    JSONArray constituentTags = jsonObjectCustomer.getJSONArray("constituent_tags");//企业性质
                    JSONArray listed_types = jsonObjectCustomer.getJSONArray("listed_types");//上市类型
                    if (!constituentTags.isEmpty()) {
//                        String tpv_enterprisenature = constituentTags.toJSONString();
//                        String stringWithoutBrackets = tpv_enterprisenature.replace("[", "").replace("]", "");
//                        String finalString = stringWithoutBrackets.replace("\"", "");

                        String finalString = findShortestString(constituentTags);
                        bdCustomer.set("tpv_enterprisenature", finalString);//企业性质
                        if (StringUtils.equals(finalString, "民营控股")) {
                            bdCustomer.set("tpv_natureoftheenterpr2", "MY");//企业性质
                        } else if (StringUtils.equals(finalString, "")) {
                            bdCustomer.set("tpv_natureoftheenterpr2", null);//企业性质
                        } else {
                            bdCustomer.set("tpv_natureoftheenterpr2", "GY");//企业性质
                        }
                    }
                    bdCustomer.set("artificialperson", jsonObjectCustomer.getString("legal_representative"));//法人代表
                    bdCustomer.set("tpv_industrialyphon", jsonObjectCustomer.getString("org_tel"));//工商登记电话
                    String curegcapital = jsonObjectCustomer.getString("register_capital_currency");
                    if (StringUtils.equals("人民币", curegcapital)) {
                        //人民币
                        DynamicObject bd_currency = BusinessDataServiceHelper.loadSingle("bd_currency", "id",
                                new QFilter("name", QCP.equals, "人民币").toArray());
                        bdCustomer.set("curegcapital", bd_currency.getLong("id"));//注册资本币种
                    } else if (StringUtils.equals("港元", curegcapital)) {
                        //港元
                        DynamicObject bd_currency = BusinessDataServiceHelper.loadSingle("bd_currency", "id",
                                new QFilter("name", QCP.equals, curegcapital).toArray());
                        bdCustomer.set("curegcapital", bd_currency.getLong("id"));//注册资本币种
                    } else {
                        DynamicObject bd_currency = BusinessDataServiceHelper.loadSingle("bd_currency", "id",
                                new QFilter("name", QCP.equals, curegcapital).toArray());
                        if (null != bd_currency) {
                            bdCustomer.set("curegcapital", bd_currency.getLong("id"));//注册资本币种
                        }
                    }
                    bdCustomer.set("societycreditcode", jsonObjectCustomer.getString("uc_code"));//统一社会信用代码
                    bdCustomer.set("tx_register_no", jsonObjectCustomer.getString("uc_code"));//纳税人识别号
                    bdCustomer.set("regcapital", jsonObjectCustomer.getString("register_capital_value"));//注册资本
                    bdCustomer.set("businessterm", jsonObjectCustomer.getString("oprt_end_date"));//营业期限
                    bdCustomer.set("establishdate", jsonObjectCustomer.getDate("register_date"));//成立日期
                    bdCustomer.set("bizpartner_address", jsonObjectCustomer.getString("register_place"));//注册地址
                    bdCustomer.set("tpv_registrationstatus", jsonObjectCustomer.getString("org_state"));//登记状态
                    bdCustomer.set("tpv_paidupcapital", jsonObjectCustomer.getString("org_rec_cptl_rmb"));//实缴资本
                    bdCustomer.set("tpv_businesstype", jsonObjectCustomer.getString("org_type"));//企业类型
                    bdCustomer.set("tpv_insured", jsonObjectCustomer.getString("employee_num"));//参保人数
                    bdCustomer.set("tpv_province", jsonObjectCustomer.get("register_province"));//省
                    bdCustomer.set("tpv_city", jsonObjectCustomer.get("register_city"));//市
                    bdCustomer.set("tpv_county", jsonObjectCustomer.get("register_county"));//县
                    if (StringUtils.isNotEmpty(jsonObjectCustomer.getString("latetype"))) {
                        this.getModel().setValue("tpv_listed", true);//是否上市
                        bdCustomer.set("tpv_listed", true);//是否上市
                    } else {
                        bdCustomer.set("tpv_listed", false);//是否上市
                    }
                    if (listed_types.isEmpty()) {
                        bdCustomer.set("tpv_typeoflisting", null);//上市类型
                    } else {
                        String jsonString = listed_types.toJSONString();
                        String stringWithoutBrackets = jsonString.replace("[", "").replace("]", "");
                        String finalString = stringWithoutBrackets.replace("\"", "");
                        bdCustomer.set("tpv_typeoflisting", finalString);//上市类型
                    }
                    bdCustomer.set("tpv_stocksymbol1", jsonObjectCustomer.getString("stock_code"));//股票代码
                    bdCustomer.set("businessscope", jsonObjectCustomer.getString("oprt_scope"));//经营范围
                    SaveServiceHelper.update(bdCustomer);
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                String response = GetPublicSentimentList.enterPrise(name);
                JSONObject jsonObject = JSONObject.parseObject(response);
                if (null != jsonObject) {
                    JSONArray constituentTags = jsonObject.getJSONArray("constituent_tags");//企业性质
                    JSONArray listed_types = jsonObject.getJSONArray("listed_types");//上市类型
                    if (!constituentTags.isEmpty()) {
//                        String tpv_enterprisenature = constituentTags.toJSONString();
//                        String stringWithoutBrackets = tpv_enterprisenature.replace("[", "").replace("]", "");
//                        String finalString = stringWithoutBrackets.replace("\"", "");

                        String finalString = findShortestString(constituentTags);
                        dataEntity.set("tpv_enterprisenature", finalString);//企业性质
                        if (StringUtils.equals(finalString, "民营控股")) {
                            dataEntity.set("tpv_natureoftheenterpr2", "MY");//企业性质
                        } else if (StringUtils.equals(finalString, "")) {
                            dataEntity.set("tpv_natureoftheenterpr2", null);//企业性质
                        } else {
                            dataEntity.set("tpv_natureoftheenterpr2", "GY");//企业性质
                        }
                    }
                    dataEntity.set("artificialperson", jsonObject.getString("legal_representative"));//法人代表
                    dataEntity.set("tpv_industrialyphon", jsonObject.getString("org_tel"));//工商登记电话
                    String curegcapital = jsonObject.getString("register_capital_currency");
                    if (StringUtils.equals("人民币", curegcapital)) {
                        //人民币
                        DynamicObject bd_currency = BusinessDataServiceHelper.loadSingle("bd_currency", "id",
                                new QFilter("name", QCP.equals, "人民币").toArray());
                        dataEntity.set("curegcapital", bd_currency.getLong("id"));//注册资本币种
                    } else if (StringUtils.equals("港元", curegcapital)) {
                        //港元
                        DynamicObject bd_currency = BusinessDataServiceHelper.loadSingle("bd_currency", "id",
                                new QFilter("name", QCP.equals, curegcapital).toArray());
                        dataEntity.set("curegcapital", bd_currency.getLong("id"));//注册资本币种
                    } else {
                        DynamicObject bd_currency = BusinessDataServiceHelper.loadSingle("bd_currency", "id",
                                new QFilter("name", QCP.equals, curegcapital).toArray());
                        if (null != bd_currency) {
                            dataEntity.set("curegcapital", bd_currency.getLong("id"));//注册资本币种
                        }
                    }
                    dataEntity.set("societycreditcode", jsonObject.getString("uc_code"));
                    dataEntity.set("tx_register_no", jsonObject.getString("uc_code"));
                    dataEntity.set("regcapital", jsonObject.getString("register_capital_value"));
                    dataEntity.set("businessterm", jsonObject.getString("oprt_end_date"));
                    dataEntity.set("establishdate", jsonObject.getDate("register_date"));
                    dataEntity.set("bizpartner_address", jsonObject.getString("register_place"));
                    dataEntity.set("tpv_registrationstatus", jsonObject.getString("org_state"));
                    dataEntity.set("tpv_paidupcapital", jsonObject.getString("org_rec_cptl_rmb"));
                    dataEntity.set("tpv_businesstype", jsonObject.getString("org_type"));//企业类型
                    dataEntity.set("tpv_insured", jsonObject.getString("employee_num"));//参保人数
                    dataEntity.set("tpv_province", jsonObject.get("register_province"));//省
                    dataEntity.set("tpv_city", jsonObject.get("register_city"));//市
                    dataEntity.set("tpv_county", jsonObject.get("register_county"));//县

                    if (StringUtils.isNotEmpty(jsonObject.getString("latetype"))) {
                        dataEntity.set("tpv_listed", true);//是否上市
                    } else {
                        dataEntity.set("tpv_listed", false);//是否上市
                    }
                    if (listed_types.isEmpty()) {
                        dataEntity.set("tpv_typeoflisting", null);//上市类型
                    } else {
                        String jsonString = listed_types.toJSONString();
                        String stringWithoutBrackets = jsonString.replace("[", "").replace("]", "");
                        String finalString = stringWithoutBrackets.replace("\"", "");
                        dataEntity.set("tpv_typeoflisting", finalString);
                    }
                    dataEntity.set("tpv_stocksymbol1", jsonObject.getString("stock_code"));
                    dataEntity.set("businessscope", jsonObject.getString("oprt_scope"));
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                String employeeNumResponse = GetPublicSentimentList.employeeNum(name);
                JSONObject employeeNumJson = JSONObject.parseObject(employeeNumResponse);
                Map<String, JSONObject> sourceMap = new HashMap<>();
                if (null != employeeNumJson) {
                    // 获取"hits"数组
                    JSONArray hitsArray = employeeNumJson.getJSONObject("hits").getJSONArray("hits");
                    if (!hitsArray.isEmpty()) {
                        // 遍历数组，提取每个元素中的"_source"字段
                        for (int i = 0; i < hitsArray.size(); i++) {
                            JSONObject hit = hitsArray.getJSONObject(i);
                            JSONObject source = hit.getJSONObject("_source");
                            sourceMap.put(source.getString("report_year"), source);
                        }
                    }
                    if (!sourceMap.isEmpty()) {
                        // 使用Stream找到最大的年份键
                        Optional<String> maxYearKey = sourceMap.keySet().stream()
                                .max(String::compareTo);
                        if (maxYearKey.isPresent()) {
                            // 获取对应的JSONObject
                            JSONObject valueForMaxYear = sourceMap.get(maxYearKey.get());
                            JSONObject socialInsurance = valueForMaxYear.getJSONObject("social_insurance");
                            Integer maximum = maxCount(socialInsurance);
                            if (null != maximum) {
                                dataEntity.set("tpv_insured", maximum.toString());//参保人数
                            }
                        }
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                if (StringUtils.isNotEmpty(bdCustomerName)) {
                    responseCustomer = GetPublicSentimentList.enterPriseYear(name);
                    JsonObject jsonObject = JsonParser.parseString(responseCustomer).getAsJsonObject();
                    if (jsonObject != null) {
                        String tpvAptitude = jsonObject.getAsJsonObject("hits").getAsJsonArray("hits").get(0).getAsJsonObject().getAsJsonObject("_source").get("YEAR").getAsString();
                        if (null != tpvAptitude && !StringUtils.equals(tpvAptitude, "0")) {
                            bdCustomer.set("tpv_aptitude", "A级纳税人");//纳税人资质
                        }
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                if (StringUtils.isNotEmpty(bdCustomerName)) {
                    String employeeNumResponse = GetPublicSentimentList.employeeNum(name);
                    JSONObject employeeNumJson = JSONObject.parseObject(employeeNumResponse);
                    Map<String, JSONObject> sourceMap = new HashMap<>();
                    if (null != employeeNumJson) {
                        // 获取"hits"数组
                        JSONArray hitsArray = employeeNumJson.getJSONObject("hits").getJSONArray("hits");
                        if (!hitsArray.isEmpty()) {
                            // 遍历数组，提取每个元素中的"_source"字段
                            for (int i = 0; i < hitsArray.size(); i++) {
                                JSONObject hit = hitsArray.getJSONObject(i);
                                JSONObject source = hit.getJSONObject("_source");
                                sourceMap.put(source.getString("report_year"), source);
                            }
                        }
                        if (!sourceMap.isEmpty()) {
                            // 使用Stream找到最大的年份键
                            Optional<String> maxYearKey = sourceMap.keySet().stream()
                                    .max(String::compareTo);
                            if (maxYearKey.isPresent()) {
                                // 获取对应的JSONObject
                                JSONObject valueForMaxYear = sourceMap.get(maxYearKey.get());
                                JSONObject socialInsurance = valueForMaxYear.getJSONObject("social_insurance");
                                Integer maximum = maxCount(socialInsurance);
                                if (null != maximum) {
                                    bdCustomer.set("tpv_insured", maximum.toString());//参保人数
                                }
                            }
                        }
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                String responseYear = GetPublicSentimentList.enterPriseYear(name);
                JsonObject jsonObject = JsonParser.parseString(responseYear).getAsJsonObject();
                if (jsonObject != null) {
                    String tpvAptitude = jsonObject.getAsJsonObject("hits").getAsJsonArray("hits").get(0).getAsJsonObject().getAsJsonObject("_source").get("YEAR").getAsString();
                    if (null != tpvAptitude && !StringUtils.equals(tpvAptitude, "0")) {
                        dataEntity.set("tpv_aptitude", "A级纳税人");//纳税人资质
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            //对应客户
            String userNameCustomer = RequestContext.get().getUserName();
            if (null != bdCustomer) {
                bdCustomer.set("tpv_qichachaman", userNameCustomer);//工商数据最新更新人
                Date currentDateCustomer = new Date();
                bdCustomer.set("tpv_qichachadate", currentDateCustomer);//工商数据最新更新日
                SaveServiceHelper.update(bdCustomer);
            }
            //供应商
            String userName = RequestContext.get().getUserName();
            dataEntity.set("tpv_qichachaman", userName);
            Date currentDate = new Date();
            dataEntity.set("tpv_qichachadate", currentDate);
            OperateOption option = YEM.getOption();
            //写入数据库
            SaveServiceHelper.update(dataEntity);
            //调用整单刷新功能
            this.getView().invokeOperation("refresh");
            this.getView().updateView();
            OperationResult saveT = OperationServiceHelper.executeOperate("save", "bd_supplier",
                    new DynamicObject[]{dataEntity}, option);
            this.getView().showSuccessNotification("更新工商数据成功");
        }
        if (StringUtils.equals(itemKey, "bar_save")) {
            DynamicObjectCollection objectCollection1 = this.getModel().getEntryEntity("tpv_auxiliaryentrie");//获取隐藏分录
            String userNameS = characterSet(objectCollection1);
            if (StringUtils.isNotEmpty(userNameS)) {
                this.getModel().setValue("tpv_signaturecharacter", userNameS);
                dataEntity.set("tpv_signaturecharacter", userNameS);
                SaveServiceHelper.update(dataEntity);//写入数据库
            }
        }
        if (StringUtils.equals(itemKey, "bar_submit") || StringUtils.equals(itemKey, "tpv_baritemap2")) {
            String name = dataEntity.getLocaleString("name").getLocaleValue();
            if (StringUtils.isNotEmpty(name)) {
                //获取隐藏分录数据
                DynamicObjectCollection tpvAuxiliaryentrie = dataEntity.getDynamicObjectCollection("tpv_auxiliaryentrie");
                tpvAuxiliaryentrie.clear();
                DynamicObjectCollection entryGroupstandard = dataEntity.getDynamicObjectCollection("entry_groupstandard");//获取分类标准分录
                if (!entryGroupstandard.isEmpty()) {
                    //将分类标准的数据插入隐藏分录中
                    for (DynamicObject dynamicObject : entryGroupstandard) {
                        DynamicObject standardid = dynamicObject.getDynamicObject("standardid");//分类标准
                        DynamicObject groupid = dynamicObject.getDynamicObject("groupid");//分类
                        if (null != standardid && null != groupid) {
                            DynamicObject tpv_auxiliaryentrie = tpvAuxiliaryentrie.addNew();
                            tpv_auxiliaryentrie.set("Seq", dynamicObject.get("Seq"));
                            tpv_auxiliaryentrie.set("tpv_standardid", dynamicObject.getDynamicObject("standardid"));//分类标准
                            tpv_auxiliaryentrie.set("tpv_groupid", dynamicObject.getDynamicObject("groupid"));//分类
                            SaveServiceHelper.save(new DynamicObject[]{dataEntity});
                            //SaveServiceHelper.update(tpv_auxiliaryentrie);//写入数据库
                            this.getView().updateView("tpv_auxiliaryentrie");
                        }
                    }
                }
                if (!tpvAuxiliaryentrie.isEmpty()) {
                    //循环隐藏分录数据调用蚂蚁接口
                    for (DynamicObject dynamicObject : tpvAuxiliaryentrie) {
                        DynamicObject tpv_groupid = dynamicObject.getDynamicObject("tpv_groupid");//分类
                        String tpvPreliminaryrulrld = tpv_groupid.getString("tpv_preliminaryrulrld");//初筛ruleld\
                        //调用接口
                        try {
                            String response = GetPublicSentimentList.enterpriseAdmittance(name, tpvPreliminaryrulrld);
                            if (StringUtils.equals("NO", response)) {
                                //更新时间
                                Date updateTime = new Date();
                                dynamicObject.set("tpv_screeningresults1", "OBTAIN");//获取失败
                                dynamicObject.set("tpv_updatetime1", updateTime);//更新时间
                                int row = dynamicObject.getInt("Seq") - 1;
                                this.getModel().setValue("tpv_screeningresults", "OBTAIN", row);
                                this.getModel().setValue("tpv_updatetime", updateTime, row);
                                SaveServiceHelper.save(new DynamicObject[]{dataEntity});
                                this.getView().updateView("tpv_auxiliaryentrie");
                            } else {
                                if (StringUtils.isNotEmpty(response)) {
                                    Date updateTime = new Date();
                                    dynamicObject.set("tpv_updatetime1", updateTime);//更新时间
                                    int row = dynamicObject.getInt("Seq") - 1;
                                    dynamicObject.set("tpv_screeningresults1", response);//获取失败
                                    this.getModel().setValue("tpv_screeningresults", response, row);
                                    this.getModel().setValue("tpv_updatetime", updateTime, row);
                                    SaveServiceHelper.save(new DynamicObject[]{dataEntity});
                                    this.getView().updateView("tpv_auxiliaryentrie");
                                }
                            }
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                    String userNameS = characterSet(tpvAuxiliaryentrie);
                    if (StringUtils.isNotEmpty(userNameS)) {
                        this.getModel().setValue("tpv_signaturecharacter", userNameS);
                        dataEntity.set("tpv_signaturecharacter", userNameS);
                        SaveServiceHelper.update(dataEntity);//写入数据库
                    } else {
                        this.getModel().setValue("tpv_signaturecharacter", null);
                        dataEntity.set("tpv_signaturecharacter", null);
                        SaveServiceHelper.update(dataEntity);//写入数据库
                    }
                    if (StringUtils.equals(itemKey, "tpv_baritemap2")) {
                        this.getView().showSuccessNotification("准入成功");
                    }
                    OperateOption option = YEM.getOption();
                    OperationResult saveT = OperationServiceHelper.executeOperate("save", "bd_supplier",
                            new DynamicObject[]{dataEntity}, option);
                    this.getModel().setDataChanged(false);
                }
            }
        }
    }

    public Integer maxCount(JSONObject jsonObject) {
        String endowmentInsurance = jsonObject.getString("endowmentInsurance");//城镇职⼯基本养⽼保险⼈数
        endowmentInsurance = endowmentInsurance.replace("人", "");
        String medicalInsurance = jsonObject.getString("medicalInsurance");//职⼯基本医疗保险⼈数
        medicalInsurance = medicalInsurance.replace("人", "");
        String maternityInsurance = jsonObject.getString("maternityInsurance");//⽣育保险⼈数
        maternityInsurance = maternityInsurance.replace("人", "");
        String unemploymentInsurance = jsonObject.getString("unemploymentInsurance");//失业保险⼈数
        unemploymentInsurance = unemploymentInsurance.replace("人", "");
        String employmentInjuryInsurance = jsonObject.getString("employmentInjuryInsurance");//⼯商保险
        employmentInjuryInsurance = employmentInjuryInsurance.replace("人", "");
        try {
            // 假设字符串只包含数字
            int endowmentInsuranceCount = Integer.parseInt(endowmentInsurance);
            int medicalInsuranceCount = Integer.parseInt(medicalInsurance);
            int maternityInsuranceCount = Integer.parseInt(maternityInsurance);
            int unemploymentInsuranceCount = Integer.parseInt(unemploymentInsurance);
            int employmentInjuryInsuranceCount = Integer.parseInt(employmentInjuryInsurance);

            int maxCount = Math.max(endowmentInsuranceCount,
                    Math.max(medicalInsuranceCount,
                            Math.max(maternityInsuranceCount,
                                    Math.max(unemploymentInsuranceCount, employmentInjuryInsuranceCount))));
            return maxCount;
        } catch (NumberFormatException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 向单据头角色集赋值
     * WangShuGuang
     *
     * @param dynamicObjects
     * @return
     */
    public String characterSet(DynamicObjectCollection dynamicObjects) {
        if (!dynamicObjects.isEmpty()) {
            List<String> nameList = new ArrayList<>();
            for (DynamicObject dynamicObject : dynamicObjects) {
                String tpvPreliminaryresult = dynamicObject.getString("tpv_screeningresults1");//初筛结果
                if (null != tpvPreliminaryresult) {
                    if (StringUtils.equals(tpvPreliminaryresult, "REJECT")) {
                        //未通过
                        DynamicObject groupid = dynamicObject.getDynamicObject("tpv_groupid");//分类
                        if (null != groupid) {
                            DynamicObjectCollection tpv_preliminaryuser = groupid.getDynamicObjectCollection("tpv_preliminaryuser");
                            if (!tpv_preliminaryuser.isEmpty()) {
                                for (DynamicObject tpvPreliminarynouser : tpv_preliminaryuser) {
                                    DynamicObject dynamicObject1 = tpvPreliminarynouser.getDynamicObject("fbasedataId");
                                    nameList.add(dynamicObject1.getString("name"));
                                }
                            }
                        }
                    }
                }
            }
            if (!nameList.isEmpty()) {
                // 使用HashSet去除重复元素
                Set<String> uniqueSet = new HashSet<>(nameList);
                // 将去重后的List转换为逗号分隔的字符串
                String result = String.join(",", uniqueSet);
                return result;
            }
        }
        return "";
    }

    /**
     * wangshuguang添加功能
     *
     * @param e
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        Map<String, Object> map = this.getView().getFormShowParameter().getCustomParams();
        if (!map.isEmpty()) {
            long currentOrgId = YEM.getCurrentOrgId();
            long currentUserId = YEM.getCurrentUserId();
            this.getModel().setValue("createorg", currentOrgId);
            this.getModel().setValue("employee", currentUserId);//员工
            String bdCtrlStrgy = BaseDataServiceHelper.getBdCtrlStrgy("bd_supplier", String.valueOf(currentOrgId));
            this.getModel().setValue("ctrlstrategy", bdCtrlStrgy);//控制策略
            if (map.size() > 1) {
                this.getModel().setValue("societycreditcode", map.get("societycreditcode"));//统一社会信用代码
                this.getModel().setValue("tx_register_no", map.get("societycreditcode"));//纳税人识别号
                this.getModel().setValue("name", map.get("name"));//名称
//                if (null != map.get("tpv_enterprisenature")) {
                if (null != map.get("constituentTags")) {
//                    String tpv_enterprisenature = map.get("tpv_enterprisenature").toString();
//                    String stringWithoutBrackets = tpv_enterprisenature.replace("[", "").replace("]", "");
//                    String finalString = stringWithoutBrackets.replace("\"", "");
                    if (map.get("constituentTags") instanceof JSONArray){
                        JSONArray constituentTags = (JSONArray) map.get("constituentTags");
                        String finalString = findShortestString(constituentTags);
                        this.getModel().setValue("tpv_enterprisenature", finalString);//企业性质
                        if (StringUtils.equals(finalString, "民营控股")) {
                            this.getModel().setValue("tpv_natureoftheenterpr2", "MY");//企业性质
                        } else if (StringUtils.equals(finalString, "")) {
                            this.getModel().setValue("tpv_natureoftheenterpr2", null);//企业性质
                        } else {
                            this.getModel().setValue("tpv_natureoftheenterpr2", "GY");//企业性质
                        }
                    }


                }
                this.getModel().setValue("artificialperson", map.get("artificialperson"));//法人代表
                this.getModel().setValue("tpv_industrialyphon", map.get("tpv_industrialyphon"));//工商登记电话
                if (null != map.get("curegcapital")) {
                    String curegcapital = map.get("curegcapital").toString();
                    if (StringUtils.equals("元", curegcapital)) {
                        //人民币
                        DynamicObject bd_currency = BusinessDataServiceHelper.loadSingle("bd_currency", "id",
                                new QFilter("name", QCP.equals, "人民币").toArray());
                        this.getModel().setValue("curegcapital", bd_currency.getLong("id"));//注册资本币种
                    } else if (StringUtils.equals("港元", curegcapital)) {
                        //港元
                        DynamicObject bd_currency = BusinessDataServiceHelper.loadSingle("bd_currency", "id",
                                new QFilter("name", QCP.equals, curegcapital).toArray());
                        this.getModel().setValue("curegcapital", bd_currency.getLong("id"));//注册资本币种
                    } else {
                        DynamicObject bd_currency = BusinessDataServiceHelper.loadSingle("bd_currency", "id",
                                new QFilter("name", QCP.equals, curegcapital).toArray());
                        if (null != bd_currency) {
                            this.getModel().setValue("curegcapital", bd_currency.getLong("id"));//注册资本币种
                        }
                    }
                }
                this.getModel().setValue("regcapital", map.get("regcapital"));//注册资本
                this.getModel().setValue("businessterm", map.get("businessterm"));//营业期限
                this.getModel().setValue("establishdate", map.get("establishdate"));//成立日期
                this.getModel().setValue("bizpartner_address", map.get("bizpartner_address"));//注册地址
                this.getModel().setValue("tpv_registrationstatus", map.get("tpv_registrationstatus"));//登记状态
                this.getModel().setValue("tpv_paidupcapital", map.get("tpv_paidupcapital"));//实缴资本
                this.getModel().setValue("tpv_businesstype", map.get("tpv_businesstype"));//企业类型
                this.getModel().setValue("tpv_insured", map.get("tpv_insured"));//参保人数
                if (null != map.get("tpv_listed")) {
                    String tpvListed = map.get("tpv_listed").toString();
                    if (!StringUtils.equals(tpvListed, "")) {
                        this.getModel().setValue("tpv_listed", true);//是否上市
                    }
                } else {
                    this.getModel().setValue("tpv_listed", false);//是否上市
                }
                Object tpv_typeoflisting = map.get("tpv_typeoflisting");
                if (null != tpv_typeoflisting) {
                    String jsonString = tpv_typeoflisting.toString();
                    String stringWithoutBrackets = jsonString.replace("[", "").replace("]", "");
                    String finalString = stringWithoutBrackets.replace("\"", "");
                    this.getModel().setValue("tpv_typeoflisting", finalString);//上市类型
                }
                this.getModel().setValue("tpv_stocksymbol1", map.get("tpv_stocksymbol1"));//股票代码
                this.getModel().setValue("businessscope", map.get("tpv_businessscope"));//经营范围
                Object tpv_aptitude = map.get("tpv_aptitude");
                if (null != tpv_aptitude) {
                    String tpvAptitude = tpv_aptitude.toString();
                    if (!StringUtils.equals(tpvAptitude, "0")) {
                        this.getModel().setValue("tpv_aptitude", "A级纳税人");//纳税人资质
                    }
                }
            }
            this.getModel().setValue("name", map.get("name"));
            DynamicObject currency = BusinessDataServiceHelper.loadSingle("bd_currency", new QFilter[]{new QFilter("number", QCP.equals, "CNY")});
            DynamicObject country = BusinessDataServiceHelper.loadSingle("bd_country", new QFilter[]{new QFilter("number", QCP.equals, "001")});
            this.getModel().setValue("country", country);//国家/地区默认中国
            this.getModel().setValue("curegcapital", currency);//注册资本币种默认CNY
        }
    }

    private void showExchangerate(BeforeDoOperationEventArgs args) {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        DynamicObjectCollection accountname = (DynamicObjectCollection) this.getModel().getEntryEntity("entry_bank");//单据体分录
        if (accountname.size() > 0) {
            for (DynamicObject dynamicObject : accountname) {
                String bankaccount = dynamicObject.getString("bankaccount");//银行账号
                if ("" != bankaccount) {
                    QFilter qFilter = new QFilter("entry.e_assacct", QCP.equals, bankaccount);//往来账户
                    qFilter.and(new QFilter("billstatus", QCP.equals, "C"));
                    DynamicObjectCollection query = QueryServiceHelper.query("ap_payapply", "id,billno"
                            , qFilter.toArray());
                    if (query.size() > 0) {
                        args.setCancel(true);//阻断删行
                        view.showTipNotification("付款申请单已引用该银行账号相关信息,该客商的这笔银行账户信息不允许删除；");
                    }
                }
            }
        }
    }

    public static String findShortestString(JSONArray jsonArray) {
        String shortest = null;
        int shortestLength = Integer.MAX_VALUE;
        for (int i = 0; i < jsonArray.size(); i++) {
            String str = jsonArray.getString(i);
            if (str.length() <= shortestLength) {
                shortest = str;
                shortestLength = str.length();
            }
        }

        return shortest;
    }
}
