package tpv.sys.basedata.java.opplugin.op;

import com.itopview.wm.sys.opplugin.validator.ClientServiceValidator;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Date;

/**
 * @author l jw
 * @date 2023/9/13 16:26
 * @className ClientServicePlugIn
 * @description 客户 计算合作日期
 */
public class ClientDonothingOp extends AbstractOperationServicePlugIn {
    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new ClientServiceValidator());
    }

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        //获取操作对象
        String key = e.getOperationKey();
        //判断具体操作
        switch (key) {
            case "donothing-khzl":
                //监控按钮
                this.clickSave(e);
                break;
        }
    }

    private void clickSave(BeforeOperationArgs e) {
        // 获取实体
        DynamicObject[] entities = e.getDataEntities();
        //获取表单数据包
        for (DynamicObject entity : entities) {
            Date tpvCollaboration = entity.getDate("tpv_collaboration");
            if (null != tpvCollaboration){
                int daysBetween = calculateDaysBetween(tpvCollaboration, new Date());
                int result = daysBetween / 365;
                BigDecimal divide = BigDecimal.valueOf(daysBetween).divide(BigDecimal.valueOf(365), 0, RoundingMode.HALF_UP);
                entity.set("tpv_cooperation",divide);
            }
        }
        SaveServiceHelper.save(entities);

    }

    private int calculateDaysBetween(Date date1, Date date2) {
        long time1 = date1.getTime();
        long time2 = date2.getTime();

        // 计算两个日期之间的天数
        long diffInMilliseconds = Math.abs(time2 - time1);
        long diffInDays = diffInMilliseconds / (24 * 60 * 60 * 1000);

        return (int) diffInDays;
    }

}
