package tpv.sys.basedata.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.List;

/**
 * @author l jw
 * @version 1.0
 * @description: 物料
 * 物料分录增行赋值
 * @date 2023/8/10 11:32
 */
public class MaterialAdditionalOp extends AbstractOperationServicePlugIn {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_bd_material_ext_c");
        fieldKeys.add("tpv_aliasname");
        fieldKeys.add("tpv_enable");
        fieldKeys.add("tpv_status");
    }

    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        super.beginOperationTransaction(e);
        DynamicObject[] dataEntities = e.getDataEntities();
        for (DynamicObject dataEntity : dataEntities) {
            String materialName = dataEntity.getString("name");
            Boolean lool = true;
            DynamicObjectCollection entryEntity = dataEntity.getDynamicObjectCollection("tpv_bd_material_ext_c");
            //查询单据体中是否有和名称相同的字段
            QFilter qFilter = new QFilter("tpv_bd_material_ext_c.tpv_aliasname", QCP.equals, materialName);//查询相同的
            //查询其他单中是否有相同的数据
            DynamicObject[] sim_vatinvoice = BusinessDataServiceHelper.load("bd_material", "id,billno,tpv_bd_material_ext_c.tpv_aliasname", new QFilter[]{qFilter});
            if (sim_vatinvoice.length > 0) {
                lool = false;
            } else {
                for (DynamicObject rowentry : entryEntity) {
                    String aliasname = rowentry.getString("tpv_aliasname");
                    if (aliasname.equals(materialName)) {
                        lool = false;
                    }
                }
            }
            if (lool) {
                DynamicObject rowentrys = entryEntity.addNew();
                rowentrys.set("tpv_aliasname", materialName);
                rowentrys.set("tpv_enable", "1");
                rowentrys.set("tpv_status", "A");
            }

        }
    }


}
