package tpv.sys.basedata.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.Arrays;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 *@Description: 同步单据转基础资料中 famasterid  = fid
 *@Project: zhck
 *@Package: tpv.sys.basedata.java.opplugin.op.SynchronizeMasteridOp
 *@Date: 2024/05/08 17:14
 *@Author: Heisenberg Wenbei He
 *@Version: 1.0
 */
public class SynchronizeMasteridOp extends AbstractOperationServicePlugIn {
    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        String operationKey = e.getOperationKey();
        if (!("save".equals(operationKey) || "submit".equals(operationKey))) {
            return;
        }
        List<DynamicObject> collect = Arrays.stream(e.getDataEntities())
                .map(single ->
                        BusinessDataServiceHelper.loadSingle(single.getPkValue(), single.getDynamicObjectType().getName()))
                .filter(Objects::nonNull)
                .peek(single -> single.set("masterid", single.getPkValue()))
                .collect(Collectors.toList());
        SaveServiceHelper.save(collect.toArray(new DynamicObject[0]));
    }
}
