package tpv.sys.basedata.java.opplugin.op;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description: 物料 -服务插件 审核/反审核后改变别名状态
 * @Author LinRui
 * @Date 2024/3/22 22:01
 */
public class TpvMaterialAuditOp extends AbstractOperationServicePlugIn implements Plugin {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("tpv_bd_material_ext_c");
        keys.add("tpv_aliasname");
        keys.add("tpv_enable");
        keys.add("tpv_status");
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        if (null != e.getDataEntities()) {
            DynamicObject[] bills = e.getDataEntities();
            for (int i = 0; i < bills.length; ++i) {
                DynamicObject bill = bills[i];
                if ("audit".equals(e.getOperationKey())) changeAliasname(bill);
            }
        }
    }

    private void changeAliasname(DynamicObject bill) {
        bill = BusinessDataServiceHelper.loadSingle(bill.getPkValue(), bill.getDynamicObjectType().getName());
        if (YEM.isNotEmpty(bill)) {
            DynamicObjectCollection tpvBdMaterialExtC = bill.getDynamicObjectCollection("tpv_bd_material_ext_c");
            List<String> aliasnameList = new ArrayList<>();
            //遍历别名分录
            if (tpvBdMaterialExtC.size() > 0) {
                for (DynamicObject dynamicObject : tpvBdMaterialExtC) {
                    String tpvAliasname = dynamicObject.getString("tpv_aliasname");
                    aliasnameList.add(tpvAliasname);
                }
            }
            if (aliasnameList.size() > 0) {
                DynamicObject[] load = BusinessDataServiceHelper.load("tpv_bd_material", "number,status",
                        new QFilter[]{new QFilter("number", QCP.in, aliasnameList)});
                if (load.length > 0) {
                    for (DynamicObject dynamicObject : load) {
                        dynamicObject.set("status","C");
                    }
                    SaveServiceHelper.save(load);
                }
            }
        }
    }
}
