package tpv.sys.basedata.java.opplugin.op;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * @className SupplieEnableOp
 * @description 供应商启用效验是否重名
 */
public class TpvSupplieEnableOp extends AbstractOperationServicePlugIn {

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        //获取操作对象
        String key = e.getOperationKey();
        //判断具体操作
        switch (key) {
            case "enable":
                //监控启用按钮
                this.clickEnable(e);
                break;
        }
    }

    private void clickEnable(BeforeOperationArgs e) {
        // 获取实体
        DynamicObject[] entities = e.getDataEntities();
        //获取表单数据包
        for (DynamicObject entity : entities) {
            String name = entity.getString("name");//名称
            String societycreditcode = entity.getString("societycreditcode");//统一社会信用代码
            long tpv_sourcebillid = entity.getLong("tpv_sourcebillid");
            if (YEM.isNotEmpty(name)) {
                QFilter qFilter = new QFilter("name", QCP.equals, name);//查询相同的
                qFilter.and(new QFilter("enable", QCP.equals, "1"));
                DynamicObject[] vatinvoiceCus = BusinessDataServiceHelper.load("bd_customer", "id,billno,name"
                        , new QFilter[]{qFilter}, null);
                DynamicObject[] vatinvoiceSup = BusinessDataServiceHelper.load("bd_supplier", "id,billno,name"
                        , new QFilter[]{qFilter,new QFilter("id", QCP.not_equals, entity.getLong("id"))}, null);
                if (vatinvoiceCus.length > 0 && tpv_sourcebillid <= 0l) {
                    e.setCancel(true);
                    e.setCancelMessage("客户中有相同的名称，请先禁用后，再次启用！");
                }
                if (vatinvoiceSup.length > 0) {
                    e.setCancel(true);
                    e.setCancelMessage("供应商中有相同的名称，请先禁用后，再次启用！");
                }
            }
            if (YEM.isNotEmpty(societycreditcode)) {
                QFilter qFilterTwo = new QFilter("societycreditcode", QCP.equals, societycreditcode);//查询相同的
                qFilterTwo.and(new QFilter("enable", QCP.equals, "1"));
                DynamicObject[] vatinvoiceCodeCus = BusinessDataServiceHelper.load("bd_customer", "id,billno,name,societycreditcode"
                        , new QFilter[]{qFilterTwo}, null);
                DynamicObject[] vatinvoiceCodeSup = BusinessDataServiceHelper.load("bd_supplier", "id,billno,name,societycreditcode"
                        , new QFilter[]{qFilterTwo, new QFilter("id", QCP.not_equals, entity.getLong("id"))}, null);
                if (vatinvoiceCodeCus.length > 0 && tpv_sourcebillid <= 0l) {
                    e.setCancel(true);
                    e.setCancelMessage("客户中有相同的统一社会信用代码，请先禁用后，再次启用！");
                }
                if (vatinvoiceCodeSup.length > 0) {
                    e.setCancel(true);
                    e.setCancelMessage("供应商中有相同的统一社会信用代码，请先禁用后，再次启用！");
                }
            }
        }
    }
}