package tpv.sys.basedata.java.opplugin.validator;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.validate.AbstractValidator;

import java.util.Date;

/**
 * @author l j w
 * @date 2023/9/13 17:07
 * @className ClientServiceValidator
 * @description 客户效验字段是否填写
 */
public class ClientServiceValidator extends AbstractValidator {
    @Override
    public void validate() {
        ExtendedDataEntity[] dataEntities = this.dataEntities;
        for (int i = 0; i < dataEntities.length; i++) {
            ExtendedDataEntity extend = dataEntities[i];
            DynamicObject entity = extend.getDataEntity();
            check(entity, extend);
        }
    }

    public void check(DynamicObject entity, ExtendedDataEntity extend) {
        String name = entity.getString("name");//客户名称
        String simplename = entity.getString("simplename");//简称
        String societycreditcode = entity.getString("societycreditcode");//统一社会信用代码
        String tpv_registered = entity.getString("tpv_registered");//注册地址
        String artificialperson = entity.getString("artificialperson");//法人代表
        String tpv_representative = entity.getString("tpv_representative");//法人代表身份证号
        String tpv_reviewer = entity.getString("tpv_reviewer");//复核员姓名
        String tpv_authorized = entity.getString("tpv_authorized");//复核员身份证号
        String tpv_mobilephone = entity.getString("tpv_mobilephone");//复核员手机号码
        String number = entity.getString("number");//编码
        Date tpv_collaboration = entity.getDate("tpv_collaboration");//第一次合作日期
        if (null == name) {
            this.addMessage(extend, "客户名称未填写，请填写！！");
        }
        if (null == simplename) {
            this.addMessage(extend, "客户简称未填写，请填写！！");
        }
        if (YEM.isEmpty(societycreditcode)) {
            this.addMessage(extend, "统一社会信用代码未填写，请填写！！");
        }
        if (YEM.isEmpty(tpv_registered)) {
            this.addMessage(extend, "注册地址未填写，请填写！！");
        }

        if (null == artificialperson) {
            this.addMessage(extend, "法人代表未填写，请填写！！");
        }
        if (YEM.isEmpty(tpv_representative)) {
            this.addMessage(extend, "法人代表身份证号未填写，请填写！！");
        }
        if (YEM.isEmpty(tpv_reviewer)) {
            this.addMessage(extend, "复核员姓名未填写，请填写！！");
        }
        if (YEM.isEmpty(tpv_authorized)) {
            this.addMessage(extend, "复核员身份证号未填写，请填写！！");
        }
        if (YEM.isEmpty(tpv_mobilephone)) {
            this.addMessage(extend, "复核员手机号码未填写，请填写！！");
        }
        if (YEM.isEmpty(number)) {
            this.addMessage(extend, "编码未填写，请填写！！");
        }
        if (YEM.isEmpty(tpv_collaboration)) {
            this.addMessage(extend, "第一次合作日期未填写，请填写！！");
        }
    }
}
