package tpv.sys.basedata.java.task;

import com.itopview.wm.utils.YEM;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.exception.KDException;
import kd.bos.orm.query.QFilter;
import kd.bos.schedule.executor.AbstractTask;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import tpv.sys.basedata.java.opplugin.op.SupplieSaveOp;

import java.util.Map;

/**
 * @ClassName: ClientVetorTask
 * @Description: 客户，供应商隐藏名称赋值
 * @author: zbh
 * @date: 2024-06-27
 */
public class ClientVetorTask extends AbstractTask {
    @Override
    public void execute(RequestContext requestContext, Map<String, Object> map) throws KDException {
        DynamicObject[] bdSuppliers = BusinessDataServiceHelper.load("bd_supplier", "name,tpv_specname", new QFilter[]{new QFilter("tpv_specname", "=", "")});
        for (DynamicObject bdSupplier : bdSuppliers) {
            String name = bdSupplier.getString("name");
            if (YEM.isNotEmpty(name)){
                String removed = SupplieSaveOp.removeSpecialCharacters(name);
                bdSupplier.set("tpv_specname",removed);
            }
        }
        SaveServiceHelper.save(bdSuppliers);

        DynamicObject[] bdCustomers = BusinessDataServiceHelper.load("bd_customer", "name,tpv_specname", new QFilter[]{new QFilter("tpv_specname", "=", "")});
        for (DynamicObject bdCustomer : bdCustomers) {
            String name = bdCustomer.getString("name");
            if (YEM.isNotEmpty(name)){
                String removed = SupplieSaveOp.removeSpecialCharacters(name);
                bdCustomer.set("tpv_specname",removed);
            }
        }
        SaveServiceHelper.save(bdCustomers);
    }
}
