package tpv.sys.sbd.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.Save;
import kd.bos.form.events.BeforeDoOperationEventArgs;

/**
 * @Description: 仓库 -表单插件
 * @Author LinRui
 * @Date 2024/3/4 16:15
 */
public class WarehouseTpvFormPlugin extends AbstractBillPlugIn {
    private final String KEY_BTN_SAVE = "save";
    private final String KEY_ENTRY_SENDMODE = "tpv_sendmode";
    private final String KEY_FIELD_SENDPATH = "tpv_sendingpath";
    
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        int index = this.getModel().getEntryCurrentRowIndex("tpv_sendmode");
        switch (name) {
            case "tpv_default":
                Boolean tpv_default = (Boolean) this.getModel().getValue("tpv_default", index);
                if (tpv_default) {
                    DynamicObject dataEntity = this.getModel().getDataEntity(true);
                    DynamicObjectCollection dynamicObjects = dataEntity.getDynamicObjectCollection("tpv_sendmode");
                    if (dynamicObjects.size() > 0) {
                        for (int i = 0; i < dynamicObjects.size(); i++) {
                            DynamicObject dynamicObject = dynamicObjects.get(i);
                            if (index != i) {
                                dynamicObject.set("tpv_default",false);
                            }
                        }
                        this.getView().updateView("tpv_sendmode");
                    }
                }

                break;
        }
    }

    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        Object source = args.getSource();
        if (source instanceof Save && KEY_BTN_SAVE.equals(((Save) source).getOperateKey())) {
            DynamicObjectCollection tpvSendmode = this.getModel().getEntryEntity(KEY_ENTRY_SENDMODE);
            checkInterfaceCount(tpvSendmode, args);
        }
    }

    private void checkInterfaceCount(DynamicObjectCollection tpvSendmode, BeforeDoOperationEventArgs args) {
        int interCount = 0;
        for (DynamicObject dynamicObject : tpvSendmode) {
            String tpvSendingpath = dynamicObject.getString(KEY_FIELD_SENDPATH);
            if ("A".equals(tpvSendingpath)) {
                interCount++;
            }
        }
        if (interCount > 1) {
            this.getView().showErrorNotification("【接口】类型的发送途径最多存在一行！");
            args.setCancelMessage("接口类型的发送途径最多存在一行！");
            args.setCancel(true);
        }
    }
}
