package tpv.sys.sbd.java.opplugin.validator;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.validate.AbstractValidator;

/**
 * @Description: 仓库 -提交校验
 * @Author LinRui
 * @Date 2024/3/4 15:41
 */
public class WarehouseTpvSubmitValidator extends AbstractValidator {
    @Override
    public void validate() {
        ExtendedDataEntity[] dataEntities = this.dataEntities;
        for (int i = 0; i < dataEntities.length; i++) {
            ExtendedDataEntity extend = dataEntities[i];
            DynamicObject entity = extend.getDataEntity();
            check(entity, extend);
        }
    }

    public void check(DynamicObject entity, ExtendedDataEntity extend) {
        //entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(),entity.getDynamicObjectType().getName());
        DynamicObjectCollection tpv_sendingpath = entity.getDynamicObjectCollection("tpv_sendmode");
        if (tpv_sendingpath.size() > 0) {
            for (int i = 0; i < tpv_sendingpath.size(); i++) {
                DynamicObject dynamicObject = tpv_sendingpath.get(i);
                int seq = i + 1;
                String tpvSendingpath = dynamicObject.getString("tpv_sendingpath");
                String tpvFax = dynamicObject.getString("tpv_fax");
                String tpvEaddress = dynamicObject.getString("tpv_eaddress");
                switch (tpvSendingpath) {
                    case "B":
                        if (YEM.isEmpty(tpvFax))  this.addMessage(extend,"第" + seq +"行，【发送途径】为传真时，传真号必填");
                        break;
                    case "C":
                        if (YEM.isEmpty(tpvEaddress))  this.addMessage(extend,"第" + seq +"行，【发送途径】为邮件时，邮箱地址必填");
                        break;
                    case "D":
                        if (YEM.isEmpty(tpvFax))  this.addMessage(extend,"第" + seq +"行，【发送途径】为 传真+邮件 时，传真号必填");
                        if (YEM.isEmpty(tpvEaddress))  this.addMessage(extend,"第" + seq +"行，【发送途径】为 传真+邮件 时，邮箱地址必填");
                        break;
                }
            }
        }
    }
}
