package tpv.tmc.lc.java.formplugin.dynamic;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import org.apache.commons.lang3.StringUtils;

import java.math.BigDecimal;
import java.util.EventObject;
import java.util.Map;
import java.util.Optional;

/**
 * @ClassName: ShowCreditBizTypeEdit
 * @Description: 手工选择该信用证向下的{分录-即期远期列表}，单选
 * @author: zbh
 * @date: 2024-04-26
 */
public class ShowCreditBizTypeEdit extends AbstractFormPlugin {

    private static final String SPOT_FORWARD = "tpv_spotforward"; // 即期远期列表

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("btncancel", "btnok"); // 监听确认和取消按钮
    }
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        this.init();
    }
    private void init() {
        Map<String, Object> customParams = this.getView().getFormShowParameter().getCustomParams();
        String billId = (String) customParams.get("number");
        DynamicObject bill = BusinessDataServiceHelper.loadSingle("lc_receipt",new QFilter[]{new QFilter("creditno","=",billId)});
        if (bill != null) {
            DynamicObjectCollection collection = bill.getDynamicObjectCollection("tpv_spotforward");
            DynamicObjectCollection currentForm = this.getModel().getDataEntity(true).getDynamicObjectCollection(SPOT_FORWARD);
            if (collection != null) {
                for (DynamicObject currentRow : collection) {
                    DynamicObject newRow = currentForm.addNew();
                    newRow.set("tpv_letcre", currentRow.get("tpv_letcre"));//信用证类型
                    newRow.set("tpv_furlook", currentRow.get("tpv_furlook"));//远期天数
                    newRow.set("tpv_furlookhk", currentRow.get("tpv_furlookhk"));//远期天数起算日方式
                    newRow.set("tpv_wedoor", currentRow.get("tpv_wedoor"));//是否按顺序交单
                }
            }
        }
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control source = (Control) evt.getSource();
        // 点击确认按钮
        if (StringUtils.equals(source.getKey(), "btnok")) {
            EntryGrid entryGrid = this.getControl(SPOT_FORWARD);
            int[] selectRows = entryGrid.getSelectRows();
            DynamicObjectCollection dataEntity = this.getModel().getEntryEntity(SPOT_FORWARD);
            Optional.ofNullable(selectRows)
                    .filter(selectItems -> selectItems.length > 0)
                    .ifPresent(selectItems -> this.getView().returnDataToParent(dataEntity.get(selectItems[0])));
            this.getView().close();
        } else if (StringUtils.equals(source.getKey(), "btncancel")) {
            // 被点击控件为取消则设置返回值为空并关闭页面（在页面关闭回调方法中必须验证返回值不为空，否则会报空指针）
            this.getView().returnDataToParent(null);
            this.getView().close();
        }
    }
}
