package tpv.tmc.lc.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.property.RefBillProp;
import kd.bos.form.FormShowParameter;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.FieldEdit;
import kd.bos.form.field.RefBillEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @ClassName: certificate
 * @Description: 改证申请布局
 * @author: zbh
 * @date: 2023-11-07
 */
public class ApplicationChangeCertificateFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        FormShowParameter fsp = this.getView().getFormShowParameter();
        String formId = fsp.getFormId();
        Map<String, Object> customParams = fsp.getCustomParams();
        if (customParams != null) {
            if (customParams.containsKey("tpv_isnot")) {
                boolean tpvIsnot = (boolean) customParams.get("tpv_isnot");
                boolean can = (boolean) customParams.get("tpv_parentchange");
                this.setMustInput("tpv_modifybill", tpvIsnot && !can);
                this.getModel().setValue("tpv_isnot", tpvIsnot);
            }
        }

        FieldEdit tpvOriisspro = this.getView().getControl("tpv_oriisspro");
        OperationStatus status = fsp.getStatus();

        this.getModel().setValue("applyreason", null);
        this.getModel().setValue("tpv_bustype", "B");
        this.getModel().setValue("biztype", "edit_card");
        this.getView().setEnable(true, "credittype");
//        this.getModel().setValue("tpv_billtype", BusinessDataServiceHelper.loadSingle("bos_billtype", "", new QFilter[]{new QFilter("number", "=", "lc_bizapply_GZ")}));
        tpvOriisspro.setMustInput(true);
    }

    private void setMustInput(String sign, boolean flag) {
        RefBillEdit tpvQuotaforms = this.getView().getControl(sign);
        tpvQuotaforms.setMustInput(flag);
        RefBillProp property = (RefBillProp) tpvQuotaforms.getProperty();
        property.setMustInput(flag);
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        RefBillEdit tpvModifybill = this.getView().getControl("tpv_modifybill");
        tpvModifybill.addBeforeF7SelectListener(this);
        BasedataEdit lettercredit = this.getView().getControl("lettercredit");
        lettercredit.addBeforeF7SelectListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_modifybill":
                DynamicObject tpvOriisspro = (DynamicObject) this.getModel().getValue("tpv_oriisspro");
                if (tpvOriisspro == null) {
                    return;
                }
                long id = tpvOriisspro.getLong("id");
                DynamicObject lcLettercredit = BusinessDataServiceHelper.loadSingle(id, "lc_lettercredit");
                String creditNumber = lcLettercredit.getString("creditno");
                DynamicObject[] load = BusinessDataServiceHelper.load("lc_bizapply"
                        , "tpv_modifybill,biztype,tpv_poweroff,lettercredit,billstatus,tpv_isnot"
                        , new QFilter[]{new QFilter("biztype", "=", "edit_card")
                                , new QFilter("tpv_poweroff", "=", false)
                                , new QFilter("lettercredit.number", "=", creditNumber)
                                , new QFilter("tpv_isnot", "=", false)
                                , new QFilter("billstatus", "=", "C")});

                DynamicObject[] used = BusinessDataServiceHelper.load("lc_bizapply"
                        , "tpv_modifybill,biztype,tpv_poweroff,lettercredit,billstatus,tpv_isnot"
                        , new QFilter[]{new QFilter("biztype", "=", "edit_card")
                                , new QFilter("tpv_poweroff", "=", false)
                                , new QFilter("lettercredit.number", "=", creditNumber)
                                , new QFilter("tpv_isnot", "=", true)
                                , new QFilter("billstatus", "=", "C")});

                List<Object> list = Arrays.stream(load)
                        .map(single -> single.getPkValue())
                        .distinct()
                        .collect(Collectors.toList());

                List<Object> usedList = Arrays.stream(used)
                        .filter(single -> single.getDynamicObject("tpv_modifybill") != null)
                        .map(single -> single.getDynamicObject("tpv_modifybill").getPkValue())
                        .distinct()
                        .collect(Collectors.toList());

                list.removeAll(usedList);

                ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
                DynamicObject lettercredit = (DynamicObject) this.getModel().getValue("lettercredit");
                List<QFilter> QFilters = new ArrayList<>();
                if (lettercredit != null) {
                    String number = lettercredit.getString("number");
                    QFilters.add(new QFilter("lettercredit.number", "=", number));
                }

                QFilters.add(new QFilter("id", "in", list));
                QFilters.add(new QFilter("tpv_isnot", "=", false));
                QFilters.add(new QFilter("biztype", "=", "edit_card"));
                showParameter.getListFilterParameter().setQFilters(QFilters);
                break;
            case"lettercredit":
                ListShowParameter parameter = (ListShowParameter) e.getFormShowParameter();
                DynamicObject org = (DynamicObject) this.getModel().getValue("org");
                DynamicObject tpvDepartment = (DynamicObject) this.getModel().getValue("tpv_department");
                List<QFilter> qFilters = new ArrayList<>();
                QFilter qFilter =new QFilter("billstatus", "=", "C");
                if (org != null) {
                    qFilter.and(new QFilter("org.id", "=", org.getPkValue()));
                }
                if (tpvDepartment != null) {
                    qFilter.and(new QFilter("tpv_department.id", "=", tpvDepartment.getPkValue()));
                }
                List<String> strings = new ArrayList<>();
                DynamicObject[] lcLettercredits = BusinessDataServiceHelper.load("lc_lettercredit", "creditno", qFilter.toArray());
                for (DynamicObject dynamicObject : lcLettercredits) {
                    strings.add(dynamicObject.getString("creditno"));
                }
                qFilters.add(new QFilter("number", "in",strings));
                parameter.getListFilterParameter().setQFilters(qFilters);
                break;
        }
    }
}
