package tpv.tmc.lc.java.formplugin.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.EntryProp;
import kd.bos.form.IPageCache;
import kd.bos.form.field.ComboEdit;
import kd.bos.form.field.ComboItem;
import kd.bos.login.actions.SerializationUtils;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.tmc.fbp.common.helper.GuaranteeUseHelper;
import kd.tmc.fbp.common.helper.TmcAttachmentHelper;
import kd.tmc.fbp.common.helper.TmcDataServiceHelper;
import kd.tmc.fbp.common.helper.TmcViewInputHelper;
import kd.tmc.fbp.common.util.EmptyUtil;
import kd.tmc.lc.common.enums.LetterBizTypeEnum;
import kd.tmc.lc.common.helper.LcParameterHelper;
import kd.tmc.lc.common.property.LetterCreditProp;
import kd.tmc.lc.formplugin.apply.BizApplyEdit;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @ClassName: BizLetterCreditChgFormPlugin
 * @Description: 继承标准BizApplyEdit 改证申请
 * @author: zbh
 * @date: 2024-04-19
 */
public class BizLetterCreditChgFormPlugin extends BizApplyEdit {

    @Override
    public void propertyChanged(PropertyChangedArgs e) {

        switch (e.getProperty().getName()) {
            case "lettercredit":
                this.LetterCreditChgEvt();
                break;
            case "biztype":
                this.initSetCreditAndReason();
                this.setInfoEnable(true);
                break;
            case "org":
                this.setBizTypeEnable();
                break;
            case "currency":
            case "credittype":
            case "bank":
                this.clearCreditLimit();
                break;
            case "amountscaleupper":
            case "amount":
                String bizType = (String) this.getModel().getValue("biztype");
                if (LetterBizTypeEnum.OPEN_CARD.getValue().equals(bizType)) {
                    this.clearCreditLimit();
                } else {
                    this.getPageCache().put("CREDITCHOOSE", "CREDITCHOOSE");
                }
        }

    }

    public void LetterCreditChgEvt() {
        DynamicObject letterCredit_f7 = (DynamicObject) this.getModel().getValue("lettercredit");
        if (EmptyUtil.isNoEmpty(letterCredit_f7)) {
            this.getModel().deleteEntryData("entrys");
            DynamicObject letterCredit = TmcDataServiceHelper.loadSingle(letterCredit_f7.getLong("id"), "lc_lettercredit");
            DataEntityPropertyCollection propertys = letterCredit.getDataEntityType().getProperties();
            DataEntityPropertyCollection props = this.getModel().getDataEntityType().getProperties();
            Iterator var5 = propertys.iterator();

            String bizType;
            oriisspro();
//            while(var5.hasNext()) {
//                IDataEntityProperty prop = (IDataEntityProperty)var5.next();
//                if (!(prop instanceof EntryProp)) {
//                    bizType = prop.getName();
//                    if (!NO_COPYP_ROPERTYS.contains(bizType) && props.containsKey(bizType)) {
//                        if (bizType.equals(GuaranteeUseHelper.getBizPropName(this.getModel().getDataEntityType().getName(), "head_creditlimit"))) {
//                            TmcViewInputHelper.setValWithoutPropChgEvt(this.getView(), this.getModel(), bizType, letterCredit.get(bizType));
//                        } else {
//                            this.getModel().setValue(bizType, letterCredit.get(bizType));
//                        }
//                    }
//                }
//            }

            DynamicObjectCollection entrys = letterCredit.getDynamicObjectCollection("entrys");
            propertys = this.getModel().getEntryEntity("entrys").getDynamicObjectType().getProperties();
            Iterator var13 = entrys.iterator();

            while (var13.hasNext()) {
                DynamicObject entry = (DynamicObject) var13.next();
                int index = this.getModel().createNewEntryRow("entrys");
                Iterator var9 = propertys.iterator();

                while (var9.hasNext()) {
                    IDataEntityProperty prop = (IDataEntityProperty) var9.next();
                    if (!NO_COPYP_ROPERTYS.contains(prop.getName()) && entry.getDataEntityType().getProperties().containsKey(prop.getName())) {
                        this.getModel().setValue(prop.getName(), entry.get(prop.getName()), index);
                    }
                }

                this.getModel().setValue("entrys.id", (Object) null, index);
            }

            List<Map<String, Object>> attachments = AttachmentServiceHelper.getAttachments("lc_lettercredit", letterCredit_f7.getLong("id"), "attachmentpanel");
            if (attachments.size() > 0) {
                List<Map<String, Object>> attaList = TmcAttachmentHelper.copyAttachment(attachments, "lc_bizapply");
                Map<String, Object> attachementInfo = new HashMap(16);
                attachementInfo.put("attachmentpanel", attaList);
                IPageCache pageCache = this.getView().getPageCache();
                pageCache.put("TampAttCache" + this.getView().getPageId(), SerializationUtils.toJsonString(attachementInfo));
                this.getView().updateView("attachmentpanel");
            }

            bizType = (String) this.getModel().getValue("biztype");
            if (LetterBizTypeEnum.EDIT_CARD.getValue().equals(bizType)) {
//                this.setInfoEnable(false);
                this.fillbackLetterOfGuaranteeData();
            } else if (LetterBizTypeEnum.REPEAL_CARD.getValue().equals(bizType) || LetterBizTypeEnum.CLOSE_CARD.getValue().equals(bizType)) {
                this.loadFeeDetail(letterCredit.getLong("id"));
            }
        } else {
            this.getView().invokeOperation("refresh");
            String bizType = this.getPageCache().get("biztype");
            this.getModel().setValue("biztype", bizType);
            if (LetterBizTypeEnum.EDIT_CARD.getValue().equals(bizType)) {
//                this.setInfoEnable(true);
            }
        }
    }


    public void oriisspro() {
        Object bustype = this.getModel().getValue("biztype");
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        if ("B".equals(bustype) || "C".equals(bustype)|| "edit_card".equals(bustype)) {
            IDataModel model = this.getModel();
            DynamicObject billno = (DynamicObject) model.getValue("lettercredit");
            if (billno != null) {
                String number = billno.getString("number");
                DynamicObject oriissPro = BusinessDataServiceHelper.loadSingle("lc_lettercredit",new QFilter[]{new QFilter("creditno","=",number)});
                if (oriissPro==null){
                    return;
                }
                String creditstatus = oriissPro.getString("creditstatus");
                model.deleteEntryData("tpv_spotforward");
                model.deleteEntryData("tpv_collaborasetting");
                model.deleteEntryData("tpv_changeversion");
                model.deleteEntryData("tpv_contractdetail");
                model.deleteEntryData("tpv_agebusiness");
//                model.setValue("org", oriissPro.getDynamicObject("org"));//开证申请人
                model.setValue("tpv_supplier", oriissPro.getDynamicObject("tpv_supplier"));//供应商
                model.setValue("tpv_typetrade", oriissPro.getDynamicObject("tpv_typetrade"));//贸易类型
                model.setValue("isnationalcard", oriissPro.getBoolean("isnationalcard"));//是否国际证
                model.setValue("benefiter", oriissPro.getDynamicObject("benefiter"));//受益人
                model.setValue("benefitcountry", oriissPro.getDynamicObject("benefitcountry"));//受益人国别
                model.setValue("tpv_isnottsyr", oriissPro.getBoolean("tpv_isnottsyr"));//受益人是否为供应商
                model.setValue("tpv_notbank", oriissPro.getDynamicObject("tpv_notbank"));//通知行
                model.setValue("tpv_financing", oriissPro.getBoolean("tpv_financing"));//融资（买方付息）
                model.setValue("tpv_openfs", oriissPro.getString("tpv_openfs"));//开证方式
                model.setValue("tpv_isnotyy", oriissPro.getBoolean("tpv_isnotyy"));//是否关联额度预约单
                model.setValue("tpv_quotaforms", oriissPro.getDynamicObject("tpv_quotaforms"));//额度预约单
                model.setValue("tpv_quotaformmon", oriissPro.getBigDecimal("tpv_quotaformmon"));//额度预约单可用额度
                model.setValue("tpv_kzbank", oriissPro.getDynamicObject("tpv_kzbank"));//开证银行
                model.setValue("tpv_kzdate", oriissPro.getDate("tpv_kzdate"));//开证日期
                model.setValue("tpv_isnotsx", oriissPro.getBoolean("tpv_isnotsx"));//是否协同占用授信
                model.setValue("currency", oriissPro.getDynamicObject("currency"));//开证币种
                model.setValue("amount", oriissPro.getBigDecimal("amount"));//开证金额
                model.setValue("tpv_overfillrate", oriissPro.getBigDecimal("tpv_overfillrate"));//金额溢装率
                model.setValue("tpv_shorate", oriissPro.getBigDecimal("tpv_shorate"));//金额短装率
                model.setValue("tpv_vailddate", oriissPro.getDate("tpv_vailddate"));//有效日期
                model.setValue("tpv_lettercty", oriissPro.getString("tpv_lettercty"));//信用证类型
                model.setValue("forwarddays", oriissPro.getBigDecimal("forwarddays"));//远期天数
                model.setValue("tpv_forwardsway", oriissPro.getString("tpv_forwardsway"));//远期天数起算方式
                model.setValue("ismakeover", oriissPro.getBoolean("ismakeover"));//是否可转让
                model.setValue("tpv_isnotgur", oriissPro.getBoolean("tpv_isnotgur"));//是否保兑
                model.setValue("validaddress", oriissPro.getLocaleString("validaddress"));//到期地点
                model.setValue("tpv_latedate", oriissPro.getDate("tpv_latedate"));//最迟装期
                model.setValue("tpv_pertime", oriissPro.getBigDecimal("tpv_pertime"));//交单期限
                model.setValue("tpv_metper", oriissPro.getString("tpv_metper"));//交单期起算方式
                model.setValue("tpv_otsot", oriissPro.getString("tpv_otsot"));//其他声明
                model.setValue("tpv_redmodty", oriissPro.getString("tpv_redmodty"));//兑用方式
                model.setValue("tpv_assbank", oriissPro.getDynamicObject("tpv_assbank"));//指定银行
                model.setValue("tpv_validdate", oriissPro.getDate("tpv_validdate"));//有效期
                model.setValue("tpv_ratetable", oriissPro.getDynamicObject("tpv_ratetable"));//汇率表
                model.setValue("tpv_gradename", oriissPro.getString("tpv_gradename"));//商品名称
                model.setValue("tpv_pritem", oriissPro.getDynamicObject("tpv_pritem"));//价格条款
                model.setValue("tpv_transport", oriissPro.getDynamicObject("tpv_transport"));//运输方式
                model.setValue("tpv_tosum", oriissPro.getBigDecimal("tpv_tosum"));//数量
                model.setValue("tpv_contrate", oriissPro.getBigDecimal("tpv_contrate"));//数量溢装率
                model.setValue("tpv_decimalfield", oriissPro.getBigDecimal("tpv_decimalfield"));//数量短装率
                model.setValue("tpv_portloading", oriissPro.getDynamicObject("tpv_portloading"));//装运港
                model.setValue("tpv_discharport", oriissPro.getDynamicObject("tpv_discharport"));//卸货港
                model.setValue("tpv_poiori", oriissPro.getDynamicObject("tpv_poiori"));//启运地
                model.setValue("tpv_destination", oriissPro.getDynamicObject("tpv_destination"));//目的地
                model.setValue("isbatch", oriissPro.getBoolean("isbatch"));//是否分批
                model.setValue("istransfer", oriissPro.getBoolean("istransfer"));//是否转船
                model.setValue("tpv_docreqt", oriissPro.getString("tpv_docreqt"));//单证要求
                model.setValue("tpv_docreqf", oriissPro.getString("tpv_docreqf"));//单证要求
                model.setValue("tpv_markdz", oriissPro.getString("tpv_markdz"));//单证要求描述
                model.setValue("tpv_remark", oriissPro.getString("tpv_remark"));//备注
                DynamicObjectCollection tpvSpotforward = oriissPro.getDynamicObjectCollection("tpv_spotforward");
                for (DynamicObject dynamicObject : tpvSpotforward) {
                    int row = this.getModel().createNewEntryRow("tpv_spotforward");
                    model.setValue("tpv_letcre", dynamicObject.getString("tpv_letcre"), row);
                    model.setValue("tpv_furlook", dynamicObject.getBigDecimal("tpv_furlook"), row);
                    model.setValue("tpv_furlookhk", dynamicObject.getString("tpv_furlookhk"), row);
                    model.setValue("tpv_wedoor", dynamicObject.getBoolean("tpv_wedoor"), row);
                }
                DynamicObjectCollection tpvCollaborasetting = oriissPro.getDynamicObjectCollection("tpv_collaborasetting");
                for (DynamicObject dynamicObject : tpvCollaborasetting) {
                    int row = this.getModel().createNewEntryRow("tpv_collaborasetting");
                    model.setValue("tpv_xtdepartment", dynamicObject.getDynamicObject("tpv_xtdepartment"), row);
                    model.setValue("tpv_synergy", dynamicObject.getBigDecimal("tpv_synergy"), row);
                    model.setValue("tpv_xtremark", dynamicObject.getString("tpv_xtremark"), row);
                }
                DynamicObjectCollection tpvContractdetail = oriissPro.getDynamicObjectCollection("tpv_contractdetail");
                for (DynamicObject dynamicObject : tpvContractdetail) {
                    int row = this.getModel().createNewEntryRow("tpv_contractdetail");
                    model.setValue("tpv_purnumbers", dynamicObject.getString("tpv_purnumbers"), row);
                    model.setValue("tpv_kzappmon", dynamicObject.getBigDecimal("tpv_kzappmon"), row);
                    model.setValue("tpv_tjtype", dynamicObject.getDynamicObject("tpv_tjtype"), row);
                    model.setValue("tpv_combinationnum", dynamicObject.getDynamicObject("tpv_combinationnum"), row);
                    model.setValue("tpv_naturetrade", dynamicObject.getDynamicObject("tpv_naturetrade"), row);
                    model.setValue("tpv_businesstype", dynamicObject.getDynamicObject("tpv_businesstype"), row);
                    model.setValue("tpv_purmoney", dynamicObject.getBigDecimal("tpv_purmoney"), row);
                    model.setValue("tpv_purcurrency", dynamicObject.getDynamicObject("tpv_purcurrency"), row);
                    model.setValue("tpv_purdepartment", dynamicObject.getDynamicObject("tpv_purdepartment"), row);
                    model.setValue("tpv_pruper", dynamicObject.getDynamicObject("tpv_pruper"), row);
                    model.setValue("tpv_apprmbmon", dynamicObject.getBigDecimal("tpv_apprmbmon"), row);
                    model.setValue("tpv_appusdrate", dynamicObject.getBigDecimal("tpv_appusdrate"), row);
                    model.setValue("tpv_appusdmon", dynamicObject.getBigDecimal("tpv_appusdmon"), row);
                }
                DynamicObjectCollection tpvAgebusiness = oriissPro.getDynamicObjectCollection("tpv_entryentity3");
                for (DynamicObject dynamicObject : tpvAgebusiness) {
                    int row = this.getModel().createNewEntryRow("tpv_entryentity3");
                    model.setValue("tpv_gatnumber", dynamicObject.getString("tpv_gatnumber"), row);
                    model.setValue("tpv_salenumber", dynamicObject.getString("tpv_salenumber"), row);
                    model.setValue("tpv_patcurreny", dynamicObject.getDynamicObject("tpv_patcurreny"), row);
                    model.setValue("tpv_promoney", dynamicObject.getBigDecimal("tpv_promoney"), row);
                    model.setValue("tpv_brmonrmb", dynamicObject.getBigDecimal("tpv_brmonrmb"), row);
                    model.setValue("tpv_purnumbzj", dynamicObject.getString("tpv_purnumbzj"), row);
                }
            } else {
                model.setValue("tpv_supplier", null);//供应商
                model.setValue("tpv_typetrade", null);//贸易类型
                model.setValue("isnationalcard", false);//是否国际证
                model.setValue("benefiter", null);//受益人
                model.setValue("benefitcountry", null);//受益人国别
//            model.setValue("tpv_isnottsyr", null);//受益人是否为供应商
                model.setValue("tpv_notbank", null);//通知行
                model.setValue("tpv_financing", null);//融资（买方付息）
                model.setValue("tpv_openfs", null);//开证方式
                model.setValue("tpv_isnotyy", false);//是否关联额度预约单
                model.setValue("tpv_quotaform", null);//额度预约单
                model.setValue("tpv_quotaformmon", null);//额度预约单可用额度
                model.setValue("tpv_kzbank", null);//开证银行
                model.setValue("tpv_kzdate", null);//开证日期
                model.setValue("tpv_isnotsx", false);//是否协同占用授信
                model.setValue("currency", null);//开证币种
                model.setValue("amount", null);//开证金额
                model.setValue("tpv_overfillrate", null);//金额溢装率
                model.setValue("tpv_shorate", null);//金额短装率
                model.setValue("tpv_vailddate", null);//有效日期
                model.setValue("tpv_lettercty", null);//信用证类型
                model.setValue("forwarddays", null);//远期天数
                model.setValue("tpv_forwardsway", null);//远期天数起算方式
                model.setValue("ismakeover", false);//是否可转让
                model.setValue("tpv_isnotgur", false);//是否保兑
                model.setValue("validaddress", null);//到期地点
                model.setValue("tpv_latedate", null);//最迟装期
                model.setValue("tpv_pertime", null);//交单期限
                model.setValue("tpv_metper", null);//交单期起算方式
                model.setValue("tpv_otsot", null);//其他说明
                model.setValue("tpv_redmodty", null);//兑用方式
                model.setValue("tpv_assbank", null);//指定银行
                model.setValue("tpv_ratetable", null);//汇率表
                model.setValue("tpv_validdate", null);//有效期
                model.setValue("tpv_gradename", null);//商品名称
                model.setValue("tpv_pritem", null);//价格条款
                model.setValue("tpv_transport", null);//运输方式
                model.setValue("tpv_tosum", null);//数量
                model.setValue("tpv_contrate", null);//数量溢装率
                model.setValue("tpv_decimalfield", null);//数量短装率
                model.setValue("tpv_portloading", null);//装运港
                model.setValue("tpv_discharport", null);//卸货港
                model.setValue("tpv_poiori", null);//启运地
                model.setValue("tpv_destination", null);//目的地
                model.setValue("isbatch", false);//是否分批
                model.setValue("istransfer", false);//是否转船
                model.setValue("tpv_docreqt", null);//单证要求
                model.setValue("tpv_docreqf", null);//单证要求
                model.setValue("tpv_markdz", null);//单证要求描述
                model.setValue("tpv_remark", null);//备注
                model.deleteEntryData("tpv_spotforward");
                model.deleteEntryData("tpv_collaborasetting");
                model.deleteEntryData("tpv_changeversion");
                model.deleteEntryData("tpv_contractdetail");
                model.deleteEntryData("tpv_agebusiness");
            }
        }
    }

    private void setInfoEnable(boolean flag) {
        this.getView().setEnable(flag, new String[]{"bank", "credittype", "org", "benefitertype", "benefiter", "benefiterother"});
    }


    private void initSetCreditAndReason() {
        String bizType = (String) this.getModel().getValue("biztype");
        if (LetterBizTypeEnum.OPEN_CARD.getValue().equals(bizType)) {
            this.getView().setVisible(false, new String[]{"lettercredit"});
            TmcViewInputHelper.registerMustInput(this.getView(), false, new String[]{"applyreason", "lettercredit"});
            TmcViewInputHelper.setValWithoutDataChanged(this.getModel(), "applyreason", LetterBizTypeEnum.OPEN_CARD.getName());
            DynamicObject letterCredit = (DynamicObject) this.getModel().getValue("lettercredit");
            if (EmptyUtil.isNoEmpty(letterCredit)) {
                this.getView().invokeOperation("refresh");
            }
        } else {
            this.getPageCache().put("biztype", bizType);
            this.getView().setVisible(true, new String[]{"lettercredit"});
            TmcViewInputHelper.registerMustInput(this.getView(), true, new String[]{"applyreason", "lettercredit"});
            TmcViewInputHelper.setValWithoutDataChanged(this.getModel(), "applyreason", "");
            this.getModel().setValue("lettercredit", (Object) null);
        }
    }

    private void setBizTypeEnable() {
        DynamicObject org = (DynamicObject) this.getModel().getValue("org");
        if (EmptyUtil.isNoEmpty(org) && !this.getView().getFormShowParameter().getCustomParams().containsKey("lettercredit")) {
            boolean isApplyRepeal = LcParameterHelper.getAppBoolParameter(org.getLong("id"), LetterCreditProp.IS_APPLY_REPEAL);
            boolean isApplyClose = LcParameterHelper.getAppBoolParameter(org.getLong("id"), LetterCreditProp.IS_APPLY_CLOSE);
            List<ComboItem> items = new ArrayList();
            this.getView().setEnable(true, new String[]{"biztype"});
            items.add(new ComboItem(new LocaleString(LetterBizTypeEnum.OPEN_CARD.getName()), LetterBizTypeEnum.OPEN_CARD.getValue()));
            items.add(new ComboItem(new LocaleString(LetterBizTypeEnum.EDIT_CARD.getName()), LetterBizTypeEnum.EDIT_CARD.getValue()));
            this.setBizTypeItems(items, isApplyRepeal, LetterBizTypeEnum.REPEAL_CARD);
            this.setBizTypeItems(items, isApplyClose, LetterBizTypeEnum.CLOSE_CARD);
            ComboEdit property = (ComboEdit) this.getControl("biztype");
            property.setComboItems(items);
            Set<String> bizTypes = (Set) items.stream().map((o) -> {
                return o.getValue();
            }).collect(Collectors.toSet());
            String bizType = (String) this.getModel().getValue("biztype");
            if (!bizTypes.contains(bizType)) {
                this.getModel().setValue("biztype", LetterBizTypeEnum.OPEN_CARD.getValue());
            }
        }
    }

    private void setBizTypeItems(List<ComboItem> items, boolean isApply, LetterBizTypeEnum bizTypeEnum) {
        if (isApply) {
            items.add(new ComboItem(new LocaleString(bizTypeEnum.getName()), bizTypeEnum.getValue()));
        }
    }

    private void clearCreditLimit() {
        DynamicObject creditLimit = (DynamicObject) this.getModel().getValue("creditlimit");
        if (EmptyUtil.isNoEmpty(creditLimit)) {
            this.getModel().setValue("creditlimit", (Object) null);
        }
    }
}
