package tpv.tmc.lc.java.formplugin.form;

import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.RefBillProp;
import kd.bos.form.FormShowParameter;
import kd.bos.form.field.RefBillEdit;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;

/**
 * @ClassName: BizapplyCertificateFormPlugin
 * @Description: 撤证申请布局
 * @author: zbh
 * @date: 2023-11-08
 */
public class BizapplyCertificateFormPlugin extends BizapplyOpapyFormPlugin {
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        DynamicObject tpvOriisspro = (DynamicObject) this.getModel().getValue("tpv_oriisspro");
        if (tpvOriisspro != null) {
            return;
        }
        long operate = this.getView().getFormShowParameter().getCustomParam("id");
        DynamicObject single = BusinessDataServiceHelper.loadSingle(operate, "lc_lettercredit");
        if (single != null) {
            String creditno = single.getString("creditno");
            DynamicObject lcLettercredit = BusinessDataServiceHelper.loadSingle("lc_lettercredit_f7", "", new QFilter[]{new QFilter("number", "=", creditno)});
            if (lcLettercredit != null) {
                this.getModel().setValue("tpv_lettercredit", lcLettercredit);
            }
            this.getModel().setValue("tpv_bustype", "C");
            this.getModel().setValue("tpv_oriisspro", single);
//            this.getModel().setValue("tpv_bustype", "edit_card");
        }
        this.getModel().setValue("applyreason", null);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        FormShowParameter fsp = this.getView().getFormShowParameter();
        String formId = fsp.getFormId();
        OperationStatus status = fsp.getStatus();
        this.getModel().setValue("tpv_bustype", "C");
        this.getModel().setValue("biztype", "open_card");
    }

    @Override
    public void oriisspro() {
        super.oriisspro();
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        switch (e.getProperty().getName()) {
            case "tpv_isnotyy":
                boolean flag = (boolean) this.getModel().getValue("tpv_isnotyy");
                this.setMustInput("tpv_quotaforms", flag);
                break;
            default:
                break;
        }
    }

    private void setMustInput(String sign, boolean flag) {
        RefBillEdit tpvQuotaforms = this.getView().getControl(sign);
        tpvQuotaforms.setMustInput(flag);
        RefBillProp property = (RefBillProp) tpvQuotaforms.getProperty();
        property.setMustInput(flag);
    }
}
