package tpv.tmc.lc.java.formplugin.form;

import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.BeforeDeleteRowEventArgs;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.RefBillProp;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.field.FieldEdit;
import kd.bos.form.field.RefBillEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.EventObject;
import java.util.List;

/**
 * @ClassName: BizapplyOpapyFromPlugin
 * @Description: 开证申请
 * @author: zbh
 * @date: 2023-11-05
 */
public class BizapplyOpapyFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener, RowClickEventListener {

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        this.getModel().setValue("applyreason", null);
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        int row = evt.getRow();
        if (row >= 0) {
            clickAgebusiness(row);
        }
    }

    public void clickAgebusiness(int rowIndex) {
        this.getModel().deleteEntryData("tpv_agebusiness");
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObjectCollection tpvContractdetail = dataEntity.getDynamicObjectCollection("tpv_contractdetail");
        DynamicObjectCollection tpvAgebusiness = dataEntity.getDynamicObjectCollection("tpv_agebusiness");
        DynamicObject tpvRateTable = dataEntity.getDynamicObject("tpv_ratetable");
        String tpvPurnumbers = tpvContractdetail.get(rowIndex).getString("tpv_purnumbers");
        DynamicObject[] load = BusinessDataServiceHelper.load("cas_recbill", "billno,tpv_purchasecontracts,currency,actrecamt",
                new QFilter[]{new QFilter("billstatus", "=", "C"),
//                        new QFilter("tpv_purchasecontractxs.tpv_name", "=", tpvPurnumbers),
                        new QFilter("entry.e_expenseitem.name", "=", "开证保证金")});
        for (DynamicObject dynamicObject : load) {
            DynamicObject aNew = tpvAgebusiness.addNew();
            aNew.set("tpv_gatnumber", dynamicObject.getString("billno"));//收款登记号
//            aNew.set("tpv_salenumber", dynamicObject.getString("tpv_purchasecontracts.tpv_name"));//销售合同号
            aNew.set("tpv_patcurreny", dynamicObject.getDynamicObject("currency"));//收款币种
            aNew.set("tpv_promoney", dynamicObject.getBigDecimal("actrecamt"));//保证金金额
            BigDecimal exchangeRateCny = YEM.getExchangeRate(tpvRateTable, dynamicObject.getDynamicObject("currency"), 1L, new Date());
            aNew.set("tpv_brmonrmb", exchangeRateCny.subtract(dynamicObject.getBigDecimal("actrecamt")));//折RMB金额
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_advcontoolbarap2", "tpv_advcontoolbarap1", "tpv_withdrawcer");
        this.addClickListeners("tpv_advcontoolbarap2", "tpv_advcontoolbarap1");
        RefBillEdit tpvOriisspro = this.getView().getControl("tpv_oriisspro");
        tpvOriisspro.addBeforeF7SelectListener(this);
        RefBillEdit tpv_quotaforms = this.getView().getControl("tpv_quotaforms");
        tpv_quotaforms.addBeforeF7SelectListener(this);
        RefBillEdit modifybill = this.getView().getControl("tpv_modifybill");
        modifybill.addBeforeF7SelectListener(this);
        EntryGrid entryGrid = this.getView().getControl("tpv_contractdetail");
        entryGrid.addRowClickListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();

        List<QFilter> QFilters = new ArrayList<>();
        QFilters.add(new QFilter("billstatus", "=", "C"));

        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpvOriisspro = dataEntity.getDynamicObject("org");
        DynamicObject department = dataEntity.getDynamicObject("tpv_department");
        List<Object> ids = new ArrayList<>();

        if (null == tpvOriisspro) {
            this.getView().showTipNotification("请先选择公司！");
            e.setCancel(true);
            return;
        }
        if (department == null) {
            this.getView().showTipNotification("请先选择部门！");
            e.setCancel(true);
            return;
        }

        ids.add(department.getPkValue());
        department = BusinessDataServiceHelper.loadSingle(department.getPkValue(), "bos_adminorg");
        String orgpattern = department.getDynamicObject("orgpattern").getString("number");
        if ("OF-01".equals(orgpattern)) {

            DynamicObjectCollection collection = department.getDynamicObjectCollection("structure");

            collection.stream()
                    .filter(row -> row.getDynamicObject("viewparent") != null)
                    .map(row -> BusinessDataServiceHelper.loadSingle(row.getDynamicObject("viewparent").getPkValue(), "bos_adminorg"))
                    .filter(row -> "Orgform06".equals(row.getDynamicObject("orgpattern").getString("number")))
                    .parallel()
                    .forEach(row -> ids.add(row.getPkValue()));
        }

        switch (e.getProperty().getName()) {
            case "tpv_oriisspro":
                QFilters.add(new QFilter("org.id", "=", tpvOriisspro.get("id"))); //组织过滤
                QFilters.add(new QFilter("creditstatus", "=", "done_register"));
                break;
            case "tpv_quotaforms":
                QFilters.add(new QFilter("shkd_dept", "in", ids));
                break;
            case "tpv_modifybill":
//                DynamicObject lettercredit = (DynamicObject) this.getModel().getValue("lettercredit");
//                if (lettercredit == null) {
//                    return;
//                }
//                QFilters.add(new QFilter("lettercredit", "=", lettercredit.getPkValue()));
                break;
            default:
                break;
        }
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey();
        switch (itemKey) {
            case "tpv_advconbaritemap2":
                setDepartment();
                break;
        }
    }

    /**
     * @Title: setDepartment
     * @Description: 第一行默认当前“部门”可修改，
     * @return: void
     */
    private void setDepartment() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpvApplicant = (DynamicObject) this.getModel().getValue("tpv_people");
        DynamicObjectCollection tpvCollaborasetting = dataEntity.getDynamicObjectCollection("tpv_collaborasetting");
        if (tpvCollaborasetting.size() == 1) {
            if (tpvApplicant != null) {
                long applierId = (long) tpvApplicant.getPkValue();
                this.getModel().setValue("tpv_xtdepartment", this.getModel().getValue("tpv_department"), 0);
            }
        }
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        FormShowParameter fsp = this.getView().getFormShowParameter();
        String formId = fsp.getFormId();
        FieldEdit tpvOriisspro = this.getView().getControl("tpv_oriisspro");
        OperationStatus status = fsp.getStatus();
        if (OperationStatus.ADDNEW == status) {
            String biztype = (String) this.getModel().getValue("biztype");
            switch (biztype) {
                case "open_card":   //开证申请
                    this.getModel().setValue("tpv_bustype", "A");
                    break;
                case "edit_card":  //改证申请
                    this.getModel().setValue("tpv_bustype", "B");
                    tpvOriisspro.setMustInput(true);
                    break;
                case "repeal_card":  //撤证申请
                    this.getModel().setValue("tpv_bustype", "C");
                    tpvOriisspro.setMustInput(true);
                    break;
            }
        }
        DynamicObject lettercredit = (DynamicObject) this.getModel().getValue("lettercredit");

        if (lettercredit != null) {
            String number = (String) lettercredit.get("number");
            DynamicObject oriisspro = (DynamicObject) this.getModel().getValue("tpv_oriisspro");
            DynamicObject creditno = BusinessDataServiceHelper.loadSingle("lc_lettercredit", "", new QFilter[]{new QFilter("creditno", "=", number)});
            if (creditno != null && oriisspro == null) {
                this.getModel().setValue("tpv_oriisspro", creditno);
            }
        }

        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObjectCollection tpvContractdetail = dataEntity.getDynamicObjectCollection("tpv_contractdetail");
        if (tpvContractdetail.size() > 0) {
            clickAgebusiness(0);
        }
    }

    @Override
    public void beforeDeleteRow(BeforeDeleteRowEventArgs e) {
        super.beforeDeleteRow(e);
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        List<String> listNum = new ArrayList();
        String name = e.getEntryProp().getCompareProp().getName();
        if ("tpv_contractdetail".equals(name)) {
            DynamicObjectCollection tpvContractdetail = dataEntity.getDynamicObjectCollection("tpv_contractdetail");
            int[] eRowIndexs = e.getRowIndexs();
            for (int eRowIndex : eRowIndexs) {
                String tpvPurnumbers = tpvContractdetail.get(eRowIndex).getString("tpv_purnumbers");
                listNum.add(tpvPurnumbers);
            }
            List<Integer> listRow = new ArrayList();
            DynamicObjectCollection tpvAgebusiness = dataEntity.getDynamicObjectCollection("tpv_agebusiness");
            for (int i = 0; i < tpvAgebusiness.size(); i++) {
                String tpvPurnumbzj = tpvAgebusiness.get(i).getString("tpv_purnumbzj");
                if (listNum.contains(tpvPurnumbzj)) {
                    listRow.add(i);
                }
            }
            int[] res = listRow.stream().mapToInt(Integer::intValue).toArray();
            this.getModel().deleteEntryRows("tpv_agebusiness", res);
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        IDataModel model = this.getModel();
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_bustype":
                busType();
                break;
            case "isnationalcard":
            case "tpv_docreqt":
            case "tpv_docreqf":
                isNationalCard();
                break;
            case "tpv_ratetable":
            case "amount":
                rateTable();
                break;
            case "tpv_oriisspro":
                oriisspro();
                break;
            case "tpv_lettercty":
                tpvLettercty();
                break;
            case "tpv_isnotsx":
                tpvIsnotsx();
            case "tpv_isnotyy":
                boolean flag = (boolean) this.getModel().getValue("tpv_isnotyy");
                this.setMustInput("tpv_quotaforms", flag);
                break;
            case "tpv_credittype":
                DynamicObject credittype = (DynamicObject) this.getModel().getValue("tpv_credittype");
                this.getModel().setValue("credittype", credittype);
                break;
            default:
                break;
        }
    }

    private void setMustInput(String sign, boolean flag) {
        RefBillEdit tpvQuotaforms = this.getView().getControl(sign);
        tpvQuotaforms.setMustInput(flag);
        RefBillProp property = (RefBillProp) tpvQuotaforms.getProperty();
        property.setMustInput(flag);
    }

    /**
     * @Title: tpvIsnotsx
     * @Descriptin: 是否协同占用授信为否的时候清空协同设置分录
     * @retrn: a
     */
    private void tpvIsnotsx() {
        Boolean tpvIsnotsx = (Boolean) this.getModel().getValue("tpv_isnotsx");
        if (!tpvIsnotsx) {
            this.getModel().deleteEntryData("tpv_collaborasetting");
        }
    }

    /**
     * @Title: tpvLettercty
     * @Descriptin: 选择的信用证类型不等于混合的时候清空即期远期列表分录
     * @retrn: a
     */
    private void tpvLettercty() {
        String tpvLettercty = (String) this.getModel().getValue("tpv_lettercty");
        if (!"D".equals(tpvLettercty)) {
            this.getModel().deleteEntryData("tpv_spotforward");
        }
    }

    /**
     * @Title: oriisspro
     * @Descriptin: 开证处理单携带数据
     * @retrn: a
     */
    public void oriisspro() {
        Object bustype = this.getModel().getValue("tpv_bustype");
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        if ("B".equals(bustype) || "C".equals(bustype)) {
            IDataModel model = this.getModel();
            DynamicObject billno = (DynamicObject) model.getValue("tpv_oriisspro");
            if (billno != null) {
                Object pkValue = billno.getPkValue();
                DynamicObject oriissPro = BusinessDataServiceHelper.loadSingle(pkValue, "lc_lettercredit");
                String creditstatus = oriissPro.getString("creditstatus");
                model.deleteEntryData("tpv_spotforward");
                model.deleteEntryData("tpv_collaborasetting");
                model.deleteEntryData("tpv_changeversion");
                model.deleteEntryData("tpv_contractdetail");
                model.deleteEntryData("tpv_agebusiness");
//                model.setValue("org", oriissPro.getDynamicObject("org"));//开证申请人
                model.setValue("tpv_supplier", oriissPro.getDynamicObject("tpv_supplier"));//供应商
                model.setValue("tpv_typetrade", oriissPro.getDynamicObject("tpv_typetrade"));//贸易类型
                model.setValue("isnationalcard", oriissPro.getBoolean("isnationalcard"));//是否国际证
                model.setValue("benefiter", oriissPro.getDynamicObject("benefiter"));//受益人
                model.setValue("benefitcountry", oriissPro.getDynamicObject("benefitcountry"));//受益人国别
                model.setValue("tpv_isnottsyr", oriissPro.getBoolean("tpv_isnottsyr"));//受益人是否为供应商
                model.setValue("tpv_notbank", oriissPro.getDynamicObject("tpv_notbank"));//通知行
                model.setValue("tpv_financing", oriissPro.getBoolean("tpv_financing"));//融资（买方付息）
                model.setValue("tpv_openfs", oriissPro.getString("tpv_openfs"));//开证方式
                model.setValue("tpv_isnotyy", oriissPro.getBoolean("tpv_isnotyy"));//是否关联额度预约单
                model.setValue("tpv_quotaform", oriissPro.getDynamicObject("tpv_quotaform"));//额度预约单
                model.setValue("tpv_quotaformmon", oriissPro.getBigDecimal("tpv_quotaformmon"));//额度预约单可用额度
                model.setValue("tpv_kzbank", oriissPro.getDynamicObject("tpv_kzbank"));//开证银行
                model.setValue("tpv_kzdate", oriissPro.getDate("tpv_kzdate"));//开证日期
                model.setValue("tpv_isnotsx", oriissPro.getBoolean("tpv_isnotsx"));//是否协同占用授信
                model.setValue("currency", oriissPro.getDynamicObject("currency"));//开证币种
                model.setValue("amount", oriissPro.getBigDecimal("amount"));//开证金额
                model.setValue("tpv_overfillrate", oriissPro.getBigDecimal("tpv_overfillrate"));//金额溢装率
                model.setValue("tpv_shorate", oriissPro.getBigDecimal("tpv_shorate"));//金额短装率
                model.setValue("tpv_vailddate", oriissPro.getDate("tpv_vailddate"));//有效日期
                model.setValue("tpv_lettercty", oriissPro.getString("tpv_lettercty"));//信用证类型
                model.setValue("forwarddays", oriissPro.getBigDecimal("forwarddays"));//远期天数
                model.setValue("tpv_forwardsway", oriissPro.getString("tpv_forwardsway"));//远期天数起算方式
                model.setValue("ismakeover", oriissPro.getBoolean("ismakeover"));//是否可转让
                model.setValue("tpv_isnotgur", oriissPro.getBoolean("tpv_isnotgur"));//是否保兑
                model.setValue("validaddress", oriissPro.getLocaleString("validaddress"));//到期地点
                model.setValue("tpv_latedate", oriissPro.getDate("tpv_latedate"));//最迟装期
                model.setValue("tpv_pertime", oriissPro.getBigDecimal("tpv_pertime"));//交单期限
                model.setValue("tpv_metper", oriissPro.getString("tpv_metper"));//交单期起算方式
                model.setValue("tpv_otsot", oriissPro.getString("tpv_otsot"));//其他声明
                model.setValue("tpv_redmodty", oriissPro.getString("tpv_redmodty"));//兑用方式
                model.setValue("tpv_assbank", oriissPro.getDynamicObject("tpv_assbank"));//指定银行
                model.setValue("tpv_validdate", oriissPro.getDate("tpv_validdate"));//有效期
                model.setValue("tpv_ratetable", oriissPro.getDynamicObject("tpv_ratetable"));//汇率表
                model.setValue("tpv_gradename", oriissPro.getString("tpv_gradename"));//商品名称
                model.setValue("tpv_pritem", oriissPro.getDynamicObject("tpv_pritem"));//价格条款
                model.setValue("tpv_transport", oriissPro.getDynamicObject("tpv_transport"));//运输方式
                model.setValue("tpv_tosum", oriissPro.getBigDecimal("tpv_tosum"));//数量
                model.setValue("tpv_contrate", oriissPro.getBigDecimal("tpv_contrate"));//数量溢装率
                model.setValue("tpv_decimalfield", oriissPro.getBigDecimal("tpv_decimalfield"));//数量短装率
                model.setValue("tpv_portloading", oriissPro.getDynamicObject("tpv_portloading"));//装运港
                model.setValue("tpv_discharport", oriissPro.getDynamicObject("tpv_discharport"));//卸货港
                model.setValue("tpv_poiori", oriissPro.getDynamicObject("tpv_poiori"));//启运地
                model.setValue("tpv_destination", oriissPro.getDynamicObject("tpv_destination"));//目的地
                model.setValue("isbatch", oriissPro.getBoolean("isbatch"));//是否分批
                model.setValue("istransfer", oriissPro.getBoolean("istransfer"));//是否转船
                model.setValue("tpv_docreqt", oriissPro.getString("tpv_docreqt"));//单证要求
                model.setValue("tpv_docreqf", oriissPro.getString("tpv_docreqf"));//单证要求
                model.setValue("tpv_markdz", oriissPro.getString("tpv_markdz"));//单证要求描述
                model.setValue("tpv_remark", oriissPro.getString("tpv_remark"));//备注
                DynamicObjectCollection tpvSpotforward = oriissPro.getDynamicObjectCollection("tpv_spotforward");
                for (DynamicObject dynamicObject : tpvSpotforward) {
                    int row = this.getModel().createNewEntryRow("tpv_spotforward");
                    model.setValue("tpv_letcre", dynamicObject.getString("tpv_letcre"), row);
                    model.setValue("tpv_furlook", dynamicObject.getBigDecimal("tpv_furlook"), row);
                    model.setValue("tpv_furlookhk", dynamicObject.getString("tpv_furlookhk"), row);
                    model.setValue("tpv_wedoor", dynamicObject.getBoolean("tpv_wedoor"), row);
                }
                DynamicObjectCollection tpvCollaborasetting = oriissPro.getDynamicObjectCollection("tpv_collaborasetting");
                for (DynamicObject dynamicObject : tpvCollaborasetting) {
                    int row = this.getModel().createNewEntryRow("tpv_collaborasetting");
                    model.setValue("tpv_xtdepartment", dynamicObject.getDynamicObject("tpv_xtdepartment"), row);
                    model.setValue("tpv_synergy", dynamicObject.getBigDecimal("tpv_synergy"), row);
                    model.setValue("tpv_xtremark", dynamicObject.getString("tpv_xtremark"), row);
                }
                DynamicObjectCollection tpvContractdetail = oriissPro.getDynamicObjectCollection("tpv_contractdetail");
                for (DynamicObject dynamicObject : tpvContractdetail) {
                    int row = this.getModel().createNewEntryRow("tpv_contractdetail");
                    model.setValue("tpv_purnumbers", dynamicObject.getString("tpv_purnumbers"), row);
                    model.setValue("tpv_kzappmon", dynamicObject.getBigDecimal("tpv_kzappmon"), row);
                    model.setValue("tpv_tjtype", dynamicObject.getDynamicObject("tpv_tjtype"), row);
                    model.setValue("tpv_combinationnum", dynamicObject.getDynamicObject("tpv_combinationnum"), row);
                    model.setValue("tpv_naturetrade", dynamicObject.getDynamicObject("tpv_naturetrade"), row);
                    model.setValue("tpv_businesstype", dynamicObject.getDynamicObject("tpv_businesstype"), row);
                    model.setValue("tpv_purmoney", dynamicObject.getBigDecimal("tpv_purmoney"), row);
                    model.setValue("tpv_purcurrency", dynamicObject.getDynamicObject("tpv_purcurrency"), row);
                    model.setValue("tpv_purdepartment", dynamicObject.getDynamicObject("tpv_purdepartment"), row);
                    model.setValue("tpv_pruper", dynamicObject.getDynamicObject("tpv_pruper"), row);
                    model.setValue("tpv_apprmbmon", dynamicObject.getBigDecimal("tpv_apprmbmon"), row);
                    model.setValue("tpv_appusdrate", dynamicObject.getBigDecimal("tpv_appusdrate"), row);
                    model.setValue("tpv_appusdmon", dynamicObject.getBigDecimal("tpv_appusdmon"), row);
                }
                DynamicObjectCollection tpvAgebusiness = oriissPro.getDynamicObjectCollection("tpv_entryentity3");
                for (DynamicObject dynamicObject : tpvAgebusiness) {
                    int row = this.getModel().createNewEntryRow("tpv_entryentity3");
                    model.setValue("tpv_gatnumber", dynamicObject.getString("tpv_gatnumber"), row);
                    model.setValue("tpv_salenumber", dynamicObject.getString("tpv_salenumber"), row);
                    model.setValue("tpv_patcurreny", dynamicObject.getDynamicObject("tpv_patcurreny"), row);
                    model.setValue("tpv_promoney", dynamicObject.getBigDecimal("tpv_promoney"), row);
                    model.setValue("tpv_brmonrmb", dynamicObject.getBigDecimal("tpv_brmonrmb"), row);
                    model.setValue("tpv_purnumbzj", dynamicObject.getString("tpv_purnumbzj"), row);
                }
            } else {
                model.setValue("tpv_supplier", null);//供应商
                model.setValue("tpv_typetrade", null);//贸易类型
                model.setValue("isnationalcard", false);//是否国际证
                model.setValue("benefiter", null);//受益人
                model.setValue("benefitcountry", null);//受益人国别
//            model.setValue("tpv_isnottsyr", null);//受益人是否为供应商
                model.setValue("tpv_notbank", null);//通知行
                model.setValue("tpv_financing", null);//融资（买方付息）
                model.setValue("tpv_openfs", null);//开证方式
                model.setValue("tpv_isnotyy", false);//是否关联额度预约单
                model.setValue("tpv_quotaform", null);//额度预约单
                model.setValue("tpv_quotaformmon", null);//额度预约单可用额度
                model.setValue("tpv_kzbank", null);//开证银行
                model.setValue("tpv_kzdate", null);//开证日期
                model.setValue("tpv_isnotsx", false);//是否协同占用授信
                model.setValue("currency", null);//开证币种
                model.setValue("amount", null);//开证金额
                model.setValue("tpv_overfillrate", null);//金额溢装率
                model.setValue("tpv_shorate", null);//金额短装率
                model.setValue("tpv_vailddate", null);//有效日期
                model.setValue("tpv_lettercty", null);//信用证类型
                model.setValue("forwarddays", null);//远期天数
                model.setValue("tpv_forwardsway", null);//远期天数起算方式
                model.setValue("ismakeover", false);//是否可转让
                model.setValue("tpv_isnotgur", false);//是否保兑
                model.setValue("validaddress", null);//到期地点
                model.setValue("tpv_latedate", null);//最迟装期
                model.setValue("tpv_pertime", null);//交单期限
                model.setValue("tpv_metper", null);//交单期起算方式
                model.setValue("tpv_otsot", null);//其他说明
                model.setValue("tpv_redmodty", null);//兑用方式
                model.setValue("tpv_assbank", null);//指定银行
                model.setValue("tpv_ratetable", null);//汇率表
                model.setValue("tpv_validdate", null);//有效期
                model.setValue("tpv_gradename", null);//商品名称
                model.setValue("tpv_pritem", null);//价格条款
                model.setValue("tpv_transport", null);//运输方式
                model.setValue("tpv_tosum", null);//数量
                model.setValue("tpv_contrate", null);//数量溢装率
                model.setValue("tpv_decimalfield", null);//数量短装率
                model.setValue("tpv_portloading", null);//装运港
                model.setValue("tpv_discharport", null);//卸货港
                model.setValue("tpv_poiori", null);//启运地
                model.setValue("tpv_destination", null);//目的地
                model.setValue("isbatch", false);//是否分批
                model.setValue("istransfer", false);//是否转船
                model.setValue("tpv_docreqt", null);//单证要求
                model.setValue("tpv_docreqf", null);//单证要求
                model.setValue("tpv_markdz", null);//单证要求描述
                model.setValue("tpv_remark", null);//备注
                model.deleteEntryData("tpv_spotforward");
                model.deleteEntryData("tpv_collaborasetting");
                model.deleteEntryData("tpv_changeversion");
                model.deleteEntryData("tpv_contractdetail");
                model.deleteEntryData("tpv_agebusiness");
            }
        }
    }

    /**
     * @Title: rateTable
     * @Descriptin: 根据汇率表带出汇率，计算金额
     * @retrn: a
     */
    private void rateTable() {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObject tpvRateTable = dataEntity.getDynamicObject("tpv_ratetable");
        BigDecimal amount = dataEntity.getBigDecimal("amount");
        Date date = new Date();
        Object tpvCurrency = model.getValue("currency");
        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpvRateTable, tpvCurrency, 1L, date);
        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpvRateTable, tpvCurrency, 6L, date);
        DynamicObjectCollection tpvContractdetail = dataEntity.getDynamicObjectCollection("tpv_contractdetail");
        if (tpvRateTable == null) {
            model.setValue("tpv_rate", null);
            model.setValue("tpv_kzembrate", null);
            model.setValue("tpv_kzsqusdrate", null);
            model.setValue("tpv_amountfields", null);
            model.setValue("tpv_kzsqusdmon", null);
            for (int i = 0; i < tpvContractdetail.size(); i++) {
                model.setValue("tpv_apprmbmon", null, i);
                model.setValue("tpv_appusdrate", null, i);
                model.setValue("tpv_appusdmon", null, i);
            }
        } else {
            model.setValue("tpv_rate", exchangeRateCny);
            model.setValue("tpv_kzembrate", exchangeRateCny);
            model.setValue("tpv_kzsqusdrate", exchangeRateUsd);
            model.setValue("tpv_amountfields", exchangeRateCny.multiply(amount));
            model.setValue("tpv_kzsqusdmon", exchangeRateUsd.multiply(amount));
            for (int i = 0; i < tpvContractdetail.size(); i++) {
                BigDecimal tpvKzappmon = tpvContractdetail.get(i).getBigDecimal("tpv_kzappmon");
                model.setValue("tpv_apprmbmon", tpvKzappmon.multiply(exchangeRateCny), i);
                model.setValue("tpv_appusdrate", exchangeRateUsd, i);
                model.setValue("tpv_appusdmon", tpvKzappmon.multiply(exchangeRateUsd), i);
            }
        }

    }

    /**
     * @Title: docReq
     * @Descriptin: 根据交单期起算方式给其他说明设置必录
     * @retrn: a
     */
    private void isNationalCard() {
        FieldEdit tpvDocreqt = this.getView().getControl("tpv_docreqt");
        FieldEdit tpvDocreqf = this.getView().getControl("tpv_docreqf");
        FieldEdit tpvMarkDz = this.getView().getControl("tpv_markdz");
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Boolean isNationalCard = dataEntity.getBoolean("isnationalcard");
        String docreQt = dataEntity.getString("tpv_docreqt");
        String docreQf = dataEntity.getString("tpv_docreqf");
        if (isNationalCard) {
            tpvDocreqt.setMustInput(true);
            tpvDocreqf.setMustInput(false);
        } else {
            tpvDocreqt.setMustInput(false);
            tpvDocreqf.setMustInput(true);
        }
        if (YEM.isNotEmpty(docreQt)) {
            if (docreQt.contains("G")) {
                tpvMarkDz.setMustInput(true);
            } else {
                tpvMarkDz.setMustInput(false);
            }
        }
        if (YEM.isNotEmpty(docreQf)) {
            if (docreQf.contains("D")) {
                tpvMarkDz.setMustInput(true);
            } else {
                tpvMarkDz.setMustInput(false);
            }
        }
    }

    /**
     * @Title: busType
     * @Descriptin: 根据业务类型来给原开证处理单设置必录
     * @retrn: a
     */
    private void busType() {
        String tpvBustype = (String) this.getModel().getValue("tpv_bustype");
        FieldEdit tpvOriisspro = this.getView().getControl("tpv_oriisspro");
        if ("A".equals(tpvBustype)) {
            tpvOriisspro.setMustInput(false);
        } else {
            tpvOriisspro.setMustInput(true);
        }
    }
}
