package tpv.tmc.lc.java.formplugin.form;

import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.math.BigDecimal;
import java.util.Date;
import java.util.EventObject;

/**
 * @ClassName: LcBizforfaitingFormPlugin
 * @Description: 福费廷申请
 * @author: zbh
 * @date: 2023-11-22
 */
public class LcForFaitingFormPlugin extends AbstractBillPlugIn {

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        DynamicObject tpvApplicant = (DynamicObject) this.getModel().getValue("tpv_people");
        if (tpvApplicant != null) {
            long applierId = (long) tpvApplicant.getPkValue();
            this.getModel().setValue("tpv_department", UserServiceHelper.getUserMainOrgId(applierId), 0);
        }
    }
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        switch (name){
            case"buyoutcurrency":
            case"buyoutamount":
            case"tpv_ratetable":
                rateTable();
                break;
            case"tpv_org":
                String key = this.getModel().getDataEntity(true).getDataEntityType().getName();
                if ("tpv_lc_forfaiting_copy".equals(key)){
                    DynamicObject tpvOrg = (DynamicObject) this.getModel().getValue("tpv_org");
                    if (tpvOrg!=null){
                        this.getModel().setValue("org",tpvOrg);
                    }
                }
                break;
        }
    }

    /**
     * @Title: rateTable
     * @Descriptin: 根据汇率表带出汇率，计算金额
     * @retrn: a
     */
    private void rateTable() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpvRateTable = dataEntity.getDynamicObject("tpv_ratetable");
        BigDecimal amount = dataEntity.getBigDecimal("tpv_amountpre");
        Date date = new Date();
        Object tpvCurrency = this.getModel().getValue("tpv_currencyjd");
        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpvRateTable, tpvCurrency, 1L, date);
        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpvRateTable, tpvCurrency, 6L, date);
        if (tpvRateTable == null) {
            this.getModel().setValue("tpv_ratej", null);
            this.getModel().setValue("tpv_usdrate", null);
            this.getModel().setValue("tpv_rmbmoney", null);
            this.getModel().setValue("tpv_usdmoney", null);
        } else {
            this.getModel().setValue("tpv_ratej", exchangeRateCny);
            this.getModel().setValue("tpv_usdrate", exchangeRateUsd);
            this.getModel().setValue("tpv_rmbmoney", exchangeRateCny.multiply(amount));
            this.getModel().setValue("tpv_usdmoney", exchangeRateUsd.multiply(amount));
        }

    }
}
