package tpv.tmc.lc.java.formplugin.form;

import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.RefBillProp;
import kd.bos.entity.property.TextProp;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.RefBillEdit;
import kd.bos.form.field.TextEdit;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * @ClassName: LcPresentInhFormPlugin
 * @Description: 交单申请
 * @author: zbh
 * @date: 2023-12-08
 */
public class LcPresentInhFormPlugin extends AbstractBillPlugIn {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("tpv_spotfor"); // 监听确认和取消按钮
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control source = (Control) evt.getSource();
        switch (source.getKey()) {
            case "tpv_spotfor":
                FormShowParameter parameter = new FormShowParameter();
                Map<String, Object> map = new HashMap<>();
                DynamicObject lettercredit = (DynamicObject) this.getModel().getValue("lettercredit");
                if (lettercredit == null) {
                    return;
                }
                String number = lettercredit.getString("number");
                map.put("number", number);
                parameter.setFormId("tpv_advconaptml");
                parameter.setStatus(OperationStatus.ADDNEW);
                parameter.setCustomParams(map);
                parameter.setCloseCallBack(new CloseCallBack(this, "tpv_advconaptml"));
                parameter.getOpenStyle().setShowType(ShowType.Modal);
                this.getView().showForm(parameter);
                break;
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
        switch (closedCallBackEvent.getActionId()) {
            case "tpv_advconaptml":
                DynamicObject type = (DynamicObject) closedCallBackEvent.getReturnData();
                if (type != null) {
                    // 信用证类型
                    String letcre = type.getString("tpv_letcre");
                    switch (letcre) {
                        case "A":
                            letcre = "即期";
                            break;
                        case "B":
                            letcre = "远期";
                            break;
                        case "C":
                            letcre = "假远期";
                            break;
                        default:
                            break;
                    }
                    this.getModel().setValue("tpv_spotfor", letcre);
                    // 远期天数
                    Optional.ofNullable(type.getBigDecimal("tpv_furlook"))
                            .ifPresent(furlook -> this.getModel().setValue("tpv_forwarddayss", furlook.setScale(4)));
                    // 远期天数计算方式
                    Optional.ofNullable(type.getString("tpv_furlookhk"))
                            .ifPresent(lookhk -> this.getModel().setValue("tpv_forwardsway", lookhk));
                }
                break;
        }
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObjectCollection tpvDetainfo = dataEntity.getDynamicObjectCollection("tpv_detainfojdsq");
        BigDecimal tpvAmoverrate = BigDecimal.ZERO;//金额
        BigDecimal tpvAmountship = BigDecimal.ZERO;//金额
        if (tpvDetainfo.size() != 0) {
            tpvAmoverrate = tpvDetainfo.get(0).getBigDecimal("tpv_amoverrate");
            tpvAmountship = tpvDetainfo.get(0).getBigDecimal("tpv_amountship");
        }
        DynamicObject tpvApplicant = (DynamicObject) model.getValue("tpv_people");
        DynamicObject lettercredit = (DynamicObject) model.getValue("lettercredit");
        BigDecimal tpvBalanceletter = (BigDecimal) model.getValue("tpv_balanceletter");
        if (lettercredit != null) {
            Object pkValue = lettercredit.getPkValue();
            DynamicObject lcReceipt = BusinessDataServiceHelper.loadSingle(pkValue, "lc_receipt");
            BigDecimal tpvChangetimes = lcReceipt.getBigDecimal("tpv_version");//改证次数
            String tpvLettercty = lcReceipt.getString("tpv_credittype");//信用证类型
            boolean isnationalcard = lcReceipt.getBoolean("isnationalcard");//是否国际证
            BigDecimal forwardDays = lcReceipt.getBigDecimal("forwarddays");//远期天数
            String tpvForwardsway = lcReceipt.getString("tpv_forwardsway");//远期天数起算方式
            Date validDate = lcReceipt.getDate("validdate");//信用证有效期
            Date lastDate = lcReceipt.getDate("lastdate");//最迟装期
            BigDecimal tpvPredays = lcReceipt.getBigDecimal("tpv_handdays");//交单天数
            String billno = lcReceipt.getString("billno");//单据编号
            String tpvCredittype = lcReceipt.getString("tpv_credittype");//即期/远期
            if ("D".equals(tpvCredittype)) {
                this.getView().setVisible(false, "tpv_credittype");
            } else {
                this.getView().setVisible(false, "tpv_spotfor");
            }
            Object creditType = lcReceipt.get("credittype");//信用证类型
            BigDecimal amount = BigDecimal.ZERO;//下游金额
            DynamicObject[] lcPresents = BusinessDataServiceHelper.load("lc_present", "tpv_amountpre,amount,tpv_credittype", new QFilter[]{new QFilter("lettercredit.billno", "=", billno), new QFilter("billstatus", "=", "C")});
            for (DynamicObject lcPresent : lcPresents) {
                amount = amount.add(lcPresent.getBigDecimal("tpv_amountpre"));
            }

            model.setValue("tpv_balanceletter", tpvAmountship.multiply(BigDecimal.ONE.add(tpvAmoverrate.divide(new BigDecimal(100)))).subtract(amount));
            model.setValue("tpv_reformcredit", (tpvChangetimes.compareTo(BigDecimal.ZERO) == 0) ? false : true);//是否改证
            model.setValue("tpv_cortimes", tpvChangetimes);//改证次数
            model.setValue("tpv_letterctys", tpvLettercty);//信用证类型
            model.setValue("tpv_isnationalcard", isnationalcard);//是否国际证
            model.setValue("tpv_forwarddayss", forwardDays);//远期天数
            model.setValue("tpv_forwardsway", tpvForwardsway);//远期天数起算方式
            model.setValue("tpv_vailddates", validDate);//信用证有效期
            model.setValue("tpv_latedates", lastDate);//最迟装期
            model.setValue("tpv_pertimes", tpvPredays);//交单天数
            model.setValue("tpv_credittype", tpvCredittype);//即期/远期
            model.setValue("credittype", creditType);//信用证类型
        }
        if (tpvApplicant != null) {
            long applierId = (long) tpvApplicant.getPkValue();
            this.getModel().setValue("tpv_department", UserServiceHelper.getUserMainOrgId(applierId), 0);
        }
        DynamicObject currency = (DynamicObject) this.getModel().getValue("currency");
        DynamicObject tpvRatetable = (DynamicObject) this.getModel().getValue("tpv_ratetable");
        Date recorddate = (Date) this.getModel().getValue("recorddate");
        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpvRatetable, currency, 1L, recorddate);
        this.getModel().setValue("tpv_rate", exchangeRateCny);
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_billladingdate":
            case "tpv_vailddates":
            case "tpv_pertimes":
                dateAddDay();
                break;
            case "tpv_ratetable":
            case "tpv_amountpre":
                rateTable();
                break;
            case "tpv_docopresentat":
                String falag = (String) this.getModel().getValue("tpv_docopresentat");
                if (YEM.isEmpty(falag)) {
                    this.setMustInput("tpv_other", false);
                } else {
                    if (falag.contains("G")) {
                        this.setMustInput("tpv_other", true);
                    } else {
                        this.setMustInput("tpv_other", false);
                    }
                }
                break;
        }
    }

    private void setMustInput(String sign, boolean flag) {
        TextEdit tpvQuotaforms = this.getView().getControl(sign);
        tpvQuotaforms.setMustInput(flag);
        TextProp property = (TextProp) tpvQuotaforms.getProperty();
        property.setMustInput(flag);
    }

    /**
     * @Title: dateAddDay
     * @Descriptin:（提单日+交单天数）小于等于信用证有效期，则交单截止日=（提单日+交单天数）；（提单日+交单天数）大于信用证有效期，则交单截止=信用证有效期。
     * @retrn: a
     */
    public void dateAddDay() {
        Integer tpvPertimes = (Integer) this.getModel().getValue("tpv_pertimes");
        Date tpvBillladingdate = (Date) this.getModel().getValue("tpv_billladingdate");
        Date tpvVailddates = (Date) this.getModel().getValue("tpv_vailddates");
        Date billladingdate = DateUtil.addDays(tpvBillladingdate, tpvPertimes);
        if (tpvVailddates != null && billladingdate != null) {
            if (tpvVailddates.before(billladingdate)) {
                this.getModel().setValue("tpv_presentations", tpvVailddates);
            } else {
                this.getModel().setValue("tpv_presentations", billladingdate);
            }
        } else if (tpvVailddates == null && tpvBillladingdate != null) {
            this.getModel().setValue("tpv_presentations", tpvBillladingdate);
        }
    }

    /**
     * @Title: rateTable
     * @Descriptin: 根据汇率表带出汇率，计算金额
     * @retrn: a
     */
    private void rateTable() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpvRateTable = dataEntity.getDynamicObject("tpv_ratetable");
        BigDecimal amount = dataEntity.getBigDecimal("tpv_amountpre");
        Date date = new Date();
        Object tpvCurrency = this.getModel().getValue("currency");
        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpvRateTable, tpvCurrency, 1L, date);
        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpvRateTable, tpvCurrency, 6L, date);
        if (tpvRateTable == null) {
            this.getModel().setValue("tpv_rate", null);//汇率
            this.getModel().setValue("tpv_kzsqusdrate", null);//折usd金额
            this.getModel().setValue("tpv_amountfields", null);//折rmb金额
            this.getModel().setValue("tpv_kzsqusdmon", null);//折usd金额
        } else {
            this.getModel().setValue("tpv_rate", exchangeRateCny);//汇率
            this.getModel().setValue("tpv_kzsqusdrate", exchangeRateUsd);//折usd金额
            this.getModel().setValue("tpv_amountfields", exchangeRateCny.multiply(amount));//折rmb金额
            this.getModel().setValue("tpv_kzsqusdmon", exchangeRateUsd.multiply(amount));//折usd金额
        }

    }

}
