package tpv.tmc.lc.java.formplugin.form;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.plugin.AbstractFormPlugin;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description: 《收证处理》金额币别只更新
 * @Project: zhck
 * @Package: com.itopview.wm.sc.formplugin.form.LcReceiptFormPlugin
 * @Date: 2023/12/09 14:47
 * @Author: Heisenberg Wenbei He
 * @Version: 1.0
 */
public class LcReceiptFormPlugin extends AbstractFormPlugin {
    private static final String RATE_DATE = "bizdate"; // 汇率日期
    private static final String AMOUNT = "amount"; // 金额
    private static final String RMBRATE = "tpv_exchangerate"; // 汇率
    private static final String RATE_TABLE = "tpv_exchangetable"; // 汇率表
    private static final String USDRATE = "tpv_tousdrate"; // 折USD汇率


    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        switch (e.getProperty().getName()) {
            case "tpv_totalamount":
            case RATE_TABLE:
            case "arrivaldate":
                this.calcuAmount();
                break;
            default:
                break;
        }
    }

    /**
     * @author: Heisenberg
     * @date: 2023/12/7 21:59
     * @description: 来单金额改变动态修改其他金额信息
     */
    private void calcuAmount() {
        BigDecimal amount = (BigDecimal) this.getModel().getValue(AMOUNT); // 来单金额
        DynamicObject tpvRatetable = (DynamicObject) this.getModel().getValue(RATE_TABLE); // 汇率表
        Date arrivaldate = (Date) this.getModel().getValue(RATE_DATE); // 汇率日期
        DynamicObject arrivalcurrency = (DynamicObject) this.getModel().getValue("currency"); // 来单币别
        // 开证折RMB汇率
        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpvRatetable, arrivalcurrency, 1L, arrivaldate);
        // 开证折USD汇率
        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpvRatetable, arrivalcurrency, 6L, arrivaldate);
        // 开证转RMB汇率
        this.getModel().setValue(RMBRATE, exchangeRateCny);
        // 赋值转USD汇率
        this.getModel().setValue(USDRATE, exchangeRateUsd);
        // 开证折RMB金额
        this.getModel().setValue("tpv_kzsqrmbrates", amount.multiply(exchangeRateCny));
        // 开证折USD金额
        this.getModel().setValue("tpv_usdamount", amount.multiply(exchangeRateUsd));
    }
}
