package tpv.tmc.lc.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.control.events.BeforeClickEvent;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;

/**
 * @author: He Wenbei
 * @Project: zhkc
 * @Package: com.itopview.wm.sc.formplugin.form.UniqueCientBeginYearBillPlugin
 * @Date: 2023年08月28日 14:55
 * @Description: 《年初系数》只允许存在一条启用的数据，启用当前数据时，自动将之前已启用的数据禁用；
 **/
public class UniqueCientBeginYearBillPlugin extends AbstractBillPlugIn {
    //保存按钮
    private static final String BUTTON_SAVE = "tpv_btnsave";
    //保存并新增按钮
    private static final String BUTTON_SAVEANDNEW = "tpv_btnsaveandnew";


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        //监听俩个按钮
        this.addClickListeners(BUTTON_SAVE, BUTTON_SAVEANDNEW);
    }

    @Override
    public void beforeClick(BeforeClickEvent evt) {
        super.beforeClick(evt);
        //获取新建系数的使用状态
        String enable = (String) this.getModel().getValue("enable");
        //禁用使用状态为1的其他系数
        if ("1".equals(enable)) {
            if (this.disableOthers()) {
                evt.setCancel(true);
            }
        }
    }

    private boolean disableOthers() {
        boolean result = false;
        //获取列表中所有系数集合
        DynamicObject[] load = BusinessDataServiceHelper.load("tpv_sc_ybegincoff", "enable", null);
        //遍历集合
        for (DynamicObject dynamicObject : load) {
            String enable = (String) dynamicObject.get("enable");
            if ("1".equals(enable)) {
                this.getView().showErrorNotification("当前存在已启用的系数，请禁用后新增！");
                result = true;
                /*
                //设置其使用状态为禁用
                dynamicObject.set("enable", 0);
                //更新数据库
                SaveServiceHelper.update(dynamicObject);
                 */
            }
        }
        return result;
    }
}
