package tpv.tmc.lc.java.formplugin.list;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.list.IListView;
import kd.bos.list.events.ListRowClickEvent;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

/**
 * @ClassName: LcLettercreditExtListPlugin
 * @Description:
 * @author: zbh
 * @date: 2024-01-17
 */
public class LcLettercreditExtListPlugin extends AbstractListPlugin {

    private static DynamicObject currentBill;

    private static final String EXPORT_BUSINESS = "repeal_card";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        addItemClickListeners("tblrepeal");
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        this.getView().setEnable(false, "tblrepeal");
        this.getView().invokeOperation("refresh");
    }
    @Override
    public void listRowClick(ListRowClickEvent evt) {
        super.listRowClick(evt);
        lockButton();
        ListSelectedRow selectedRow = evt.getCurrentListSelectedRow();
        if (selectedRow != null) {
            lockButton();
            getCurrentBill(selectedRow.getPrimaryKeyValue());
        }
        Optional.ofNullable(currentBill)
                .filter(single -> "C".equals(single.get("billstatus")))
                .filter(single -> single.getString("biztype") != null)
                .filter(single -> EXPORT_BUSINESS.equals(single.getString("biztype")))
                .map(single -> {
                    this.getView().setEnable(true, "tblrepeal");
                    return single;
                })
                .orElseGet(() -> {
                    this.getView().setEnable(false, "tblrepeal");
                    return null;
                });
    }

    private static void getCurrentBill(Object primaryKeyValue) {
        currentBill = BusinessDataServiceHelper.loadSingle(primaryKeyValue, "lc_lettercredit");
    }

    private List<Long> getListBillId() {
        IListView view = (IListView) this.getView();
        ListSelectedRowCollection selectedRows = view.getSelectedRows();// 查询列表所勾选的数据
        return selectedRows.stream()
                .map(listSelectedRow -> (Long) listSelectedRow.getPrimaryKeyValue())
                .distinct()
                .collect(Collectors.toList());
    }

    private void lockButton() {
        List<Long> billId = this.getListBillId();
        if (billId.size() != 1) {
            this.getView().setEnable(false, "tblrepeal");
        }
    }
}
