package tpv.tmc.lc.java.formplugin.list;

import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.resource.ResManager;
import kd.bos.dataentity.serialization.DataEntitySerializer;
import kd.bos.dataentity.serialization.SerializationUtils;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.db.tx.TX;
import kd.bos.db.tx.TXHandle;
import kd.bos.entity.AppMetadataCache;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.cache.IAppCache;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.operate.result.OperateErrorInfo;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.exception.KDBizException;
import kd.bos.form.*;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.events.HyperLinkClickArgs;
import kd.bos.form.events.MessageBoxClosedEvent;
import kd.bos.list.BillList;
import kd.bos.logging.Log;
import kd.bos.logging.LogFactory;
import kd.bos.mvc.list.ListView;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.parameter.SystemParamServiceHelper;
import kd.tmc.cdm.business.service.LockDraftHelper;
import kd.tmc.cdm.common.enums.ClaimAuthorityEnum;
import kd.tmc.cdm.common.enums.ClaimStatusEnum;
import kd.tmc.cdm.common.enums.DraftBillStatusEnum;
import kd.tmc.cdm.common.helper.*;
import kd.tmc.fbp.common.enums.BillStatusEnum;
import kd.tmc.fbp.common.helper.TmcAppCache;
import kd.tmc.fbp.common.helper.TmcOperateServiceHelper;
import kd.tmc.fbp.common.util.EmptyUtil;
import kd.tmc.fbp.formplugin.list.AbstractTmcBillBaseList;

import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @ClassName: NoticeReceiptBillListPlugin
 * @Description: 收证处理下推认领通知
 * @author: zbh
 * @date: 2024-05-10
 */
public class NoticeReceiptBillListPlugin extends AbstractTmcBillBaseList {
    private static final Log logger = LogFactory.getLog(NoticeReceiptBillListPlugin.class);
    private static IAppCache cache = TmcAppCache.get("cas", "intelrec", "claim");
    private static final String SYSTEMTYPE = "tmc-cdm-formplugin";

    public NoticeReceiptBillListPlugin() {
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_noticeclaim","tpv_cancelnotice");
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String operateKey = evt.getItemKey();
        BillList list = (BillList) this.getControl("billlistap");
        ListSelectedRowCollection selectedRows = list.getSelectedRows();
        Object[] selectids = selectedRows.getPrimaryKeyValues();
        if (!EmptyUtil.isEmpty(selectids)) {
            switch (operateKey) {
                case "tpv_noticeclaim":
                    this.noticeClaim(selectids);
                    break;
                case "tpv_cancelnotice":
                    this.cancelNotice(selectids);
            }

        }
    }


    private void cancelNotice(Object[] selectids) {
        DynamicObject[] recvingBills = this.getSelectRow(selectids);//数据查询
        this.checkOpPerm("tpv_cancelnotice", ResManager.loadKDString("取消通知认领", "RecClaimBillList_8", "tmc-cdm-formplugin", new Object[0]), recvingBills);
        OperationResult result = new OperationResult();
        result.setBillCount(recvingBills.length);
        Set<String> noticeNos = new HashSet();
        Map<String, Set<String>> billNoMap = new HashMap();
        DynamicObject[] var6 = recvingBills;
        int var7 = recvingBills.length;

        String claimBillno;
        String recvingBillString;
        String billno;
        for (int var8 = 0; var8 < var7; ++var8) {
            DynamicObject recvingBill = var6[var8];
            claimBillno = recvingBill.getString("tpv_claimnoticebillno");
            recvingBillString = recvingBill.getString("billno");
            if (CasHelper.isNotEmpty(claimBillno)) {
                billno = recvingBill.getString("tpv_claimnoticebillno");
                noticeNos.add(billno);
                if (billNoMap.containsKey(billno)) {
                    ((Set) billNoMap.get(billno)).add(recvingBillString);
                } else {
                    Set<String> billnoSet = new HashSet();
                    billnoSet.add(recvingBillString);
                    billNoMap.put(billno, billnoSet);
                }
            } else {
                result.addErrorInfo(CasHelper.getOperateErrorInfo(recvingBill.getPkValue(), String.format(ResManager.loadKDString("只有已发起收款认领通知，且处于“待认领”状态的，才能取消通知认领！应收票据（单据编号：%s）取消通知认领失败", "RecClaimBillList_9", "tmc-cdm-formplugin", new Object[0]), recvingBill.getString("billno")), ResManager.loadKDString("取消通知认领", "RecClaimBillList_8", "tmc-cdm-formplugin", new Object[0])));
            }
        }

        Set<Object> claimIds = new HashSet();
        Set<Object> detailIds = new HashSet();
        Set<Object> eleSignIds = new HashSet();
        Map<Object, Map<String, List<Object>>> claimType = new HashMap(claimIds.size());
        claimBillno = null;
        recvingBillString = null;
        billno = null;
        StringBuilder message = new StringBuilder();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-M-dd");
        DynamicObject[] execOperate;
        if (noticeNos.size() > 0) {
            execOperate = BusinessDataServiceHelper.load("cas_claimcenterbill", "id,billno,claimstatus,sourceid,sourcetype,currency,mergestatus,isunclaim,reamount,oppunit,description,tradetime,tradedetailno,claimnoticebillno,receredtype,entryentity1.claimtype,entryentity1.claimtypeid", new QFilter[]{new QFilter("billno", "in", noticeNos)});
            DynamicObject[] var16 = execOperate;
            int var17 = execOperate.length;

            for (int var18 = 0; var18 < var17; ++var18) {
                DynamicObject noticeBill = var16[var18];
                String mergestatus = noticeBill.getString("mergestatus");
                Set recBillNos;
                Iterator var73;
                String recBillNo;
                if (!"0".equals(mergestatus)) {
                    recBillNos = (Set) billNoMap.get(noticeBill.getString("billno"));
                    var73 = recBillNos.iterator();

                    while (var73.hasNext()) {
                        recBillNo = (String) var73.next();
                        result.addErrorInfo(CasHelper.getOperateErrorInfo(noticeBill.getPkValue(), String.format(ResManager.loadKDString("只有未合并状态的收款认领单，才能取消通知认领！单据编号：%s取消通知认领失败", "RecClaimBillList_9", "tmc-cdm-formplugin", new Object[0]), recBillNo), ResManager.loadKDString("取消通知认领", "RecClaimBillList_8", "tmc-cdm-formplugin", new Object[0])));
                    }
                } else if (noticeBill.getBoolean("isunclaim")) {
                    recBillNos = (Set) billNoMap.get(noticeBill.getString("billno"));
                    var73 = recBillNos.iterator();

                    while (var73.hasNext()) {
                        recBillNo = (String) var73.next();
                        result.addErrorInfo(CasHelper.getOperateErrorInfo(noticeBill.getPkValue(), String.format(ResManager.loadKDString("通知单已经进行了未认领入账操作，单据编号：%s取消通知认领失败", "RecClaimBillList_24", "tmc-cdm-formplugin", new Object[0]), recBillNo), ResManager.loadKDString("取消通知认领", "RecClaimBillList_8", "tmc-cdm-formplugin", new Object[0])));
                    }
                } else {
                    QFilter qFilter = new QFilter("claimno", "=", noticeBill.getString("billno"));
                    DynamicObject[] ids = BusinessDataServiceHelper.load("cas_claimbill", "id", new QFilter[]{qFilter});
                    Set recBillNos1;
                    Iterator var24;
                    String recBillNo2;
                    if (ids.length > 0) {
                        recBillNos1 = (Set) billNoMap.get(noticeBill.getString("billno"));
                        var24 = recBillNos1.iterator();

                        while (var24.hasNext()) {
                            recBillNo2 = (String) var24.next();
                            result.addErrorInfo(CasHelper.getOperateErrorInfo(noticeBill.getPkValue(), String.format(ResManager.loadKDString("只有已发起收款认领通知，且不存在未处理的认领单，才能取消通知认领！应收票据（单据编号：%s）取消通知认领失败", "ClaimRecWorkbenchPlugin_9", "fi-cas-formplugin", new Object[0]), recBillNo2), ResManager.loadKDString("取消通知认领", "ClaimRecWorkbenchPlugin_8", "fi-cas-formplugin", new Object[0])));
                        }
                    } else if (!ClaimStatusEnum.WAIT.getValue().equals(noticeBill.getString("claimstatus"))) {
                        recBillNos1 = (Set) billNoMap.get(noticeBill.getString("billno"));
                        var24 = recBillNos1.iterator();

                        while (var24.hasNext()) {
                            recBillNo2 = (String) var24.next();
                            result.addErrorInfo(CasHelper.getOperateErrorInfo(noticeBill.getPkValue(), String.format(ResManager.loadKDString("只有已发起收款认领通知，且处于“待认领”状态的，才能取消通知认领！单据编号：%s取消通知认领失败", "RecClaimBillList_25", "tmc-cdm-formplugin", new Object[0]), recBillNo2), ResManager.loadKDString("取消通知认领", "RecClaimBillList_8", "tmc-cdm-formplugin", new Object[0])));
                        }
                    } else {
                        claimIds.add(noticeBill.getPkValue());

                        if ("lc_receipt".equals(noticeBill.get("sourcetype"))) {
                            detailIds.add(noticeBill.get("sourceid"));
                        } else if ("cdm_electronic_sign_deal".equals(noticeBill.get("sourcetype"))) {
                            eleSignIds.add(noticeBill.get("sourceid"));
                        }

                        DynamicObjectCollection dycoll = noticeBill.getDynamicObjectCollection("entryentity1");
                        Map<String, List<Object>> typeValue = new HashMap();
                        typeValue.put("userids", dycoll.stream().filter((dy) -> {
                            return StringUtils.equals(ClaimAuthorityEnum.USER.getValue(), dy.getString("claimtype"));
                        }).map((dy) -> {
                            return dy.get("claimtypeid");
                        }).collect(Collectors.toList()));
                        typeValue.put("usergroupids", dycoll.stream().filter((dy) -> {
                            return StringUtils.equals(ClaimAuthorityEnum.USERGROUP.getValue(), dy.getString("claimtype"));
                        }).map((dy) -> {
                            return dy.get("claimtypeid");
                        }).collect(Collectors.toList()));
                        typeValue.put("orgids", dycoll.stream().filter((dy) -> {
                            return StringUtils.equals(ClaimAuthorityEnum.USERORG.getValue(), dy.getString("claimtype"));
                        }).map((dy) -> {
                            return dy.get("claimtypeid");
                        }).collect(Collectors.toList()));
                        typeValue.put("roleids", dycoll.stream().filter((dy) -> {
                            return StringUtils.equals(ClaimAuthorityEnum.ROLER.getValue(), dy.getString("claimtype"));
                        }).map((dy) -> {
                            return dy.get("claimtypeid");
                        }).collect(Collectors.toList()));
                        message.setLength(0);
                        List<Object> noticeMes = new ArrayList();
                        message.append(ResManager.loadKDString("1笔收款（金额：", "RecClaimBillList_15", "tmc-cdm-formplugin", new Object[0]));
                        message.append(noticeBill.getDynamicObject("currency").getString("sign"));
                        message.append(CasHelper.formatDecimal(noticeBill.getBigDecimal("reamount"), 2));
                        message.append(ResManager.loadKDString("）已取消通知认领。", "RecClaimBillList_16", "tmc-cdm-formplugin", new Object[0]));
                        noticeMes.add(message.toString());
                        typeValue.put("title", noticeMes);
                        message.setLength(0);
                        noticeMes = new ArrayList();
                        message.append(ResManager.loadKDString("以下收款已取消通知认领。", "RecClaimBillList_17", "tmc-cdm-formplugin", new Object[0]));
                        message.append("\r\n");
                        message.append(ResManager.loadKDString("收款金额：", "RecClaimBillList_18", "tmc-cdm-formplugin", new Object[0]));
                        message.append(noticeBill.getDynamicObject("currency").getString("sign"));
                        message.append(CasHelper.formatDecimal(noticeBill.getBigDecimal("reamount"), 2));
                        message.append("\r\n");
                        message.append(ResManager.loadKDString("对方户名：", "RecClaimBillList_19", "tmc-cdm-formplugin", new Object[0])).append(noticeBill.getString("oppunit"));
                        message.append("\r\n");
                        message.append(ResManager.loadKDString("摘要：", "RecClaimBillList_20", "tmc-cdm-formplugin", new Object[0])).append(noticeBill.getString("description"));
                        message.append("\r\n");
                        if (EmptyUtil.isNoEmpty(noticeBill.getDate("tradetime"))) {
                            message.append(ResManager.loadKDString("交易时间：", "RecClaimBillList_21", "tmc-cdm-formplugin", new Object[0])).append(sdf.format(noticeBill.getDate("tradetime")));
                            message.append("\r\n");
                        }

                        message.append(ResManager.loadKDString("应收票据单据编号 ：", "RecClaimBillList_22", "tmc-cdm-formplugin", new Object[0])).append(noticeBill.getString("tradedetailno"));
                        noticeMes.add(message.toString());
                        typeValue.put("content", noticeMes);
                        claimType.put(noticeBill.getPkValue(), typeValue);
                    }
                }
            }
        }

        if (claimIds.size() > 0) {
            logger.info("will open two tx");
            execOperate = null;
            Set<String> recClaimnoticebillnoSet = this.getClaimBillno(detailIds, false);
            Set<String> souClaimnoticebillnoSet = this.getClaimBillno(eleSignIds, true);
            TXHandle tx = TX.requiresNew();
            Throwable var67 = null;

            OperationResult execOperate1;
            try {
                execOperate1 = TmcOperateServiceHelper.execOperateWithoutThrow("delete", "cas_claimcenterbill", claimIds.toArray(), OperateOption.create());
                if (!execOperate1.isSuccess() && execOperate1.getAllErrorInfo().size() > 0) {
                    result.addErrorInfo((OperateErrorInfo) execOperate1.getAllErrorInfo().get(0));
                } else {
                    TXHandle tx2 = TX.requiresNew();
                    Throwable var72 = null;

                    try {
                        try {
                            RecClaimBillHelper.cancelWriteClaimNo(detailIds.toArray(), eleSignIds.toArray(), recClaimnoticebillnoSet, souClaimnoticebillnoSet);
                        } catch (Exception var49) {
                            logger.error("second tx exception :", var49);
                            tx2.markRollback();
                            tx.markRollback();
                            execOperate1.getSuccessPkIds().clear();
                        }
                    } catch (Throwable var50) {
                        var72 = var50;
                        throw var50;
                    } finally {
                        if (tx2 != null) {
                            if (var72 != null) {
                                try {
                                    tx2.close();
                                } catch (Throwable var48) {
                                    var72.addSuppressed(var48);
                                }
                            } else {
                                tx2.close();
                            }
                        }

                    }
                }
            } catch (Throwable var52) {
                var67 = var52;
                throw var52;
            } finally {
                if (tx != null) {
                    if (var67 != null) {
                        try {
                            tx.close();
                        } catch (Throwable var47) {
                            var67.addSuppressed(var47);
                        }
                    } else {
                        tx.close();
                    }
                }

            }

            Map<Object, Map<String, List<Object>>> claimTypeTemp = new HashMap(claimIds.size());
            List<Object> successPkid = execOperate1.getSuccessPkIds();
            Iterator var70 = claimType.entrySet().iterator();

            while (var70.hasNext()) {
                Map.Entry<Object, Map<String, List<Object>>> claim = (Map.Entry) var70.next();
                if (successPkid.contains(claim.getKey())) {
                    claimTypeTemp.put(claim.getKey(), claim.getValue());
                }
            }

            if (null != claimTypeTemp && claimTypeTemp.size() > 0) {
                RecClaimHelper.sendClaimNoticeMessage(claimTypeTemp, "cancel");
            }
        }

        if (result.getAllErrorInfo().size() > 0) {
            ((ListView) this.getView()).refresh();
            this.getPageCache().put("operationresult", DataEntitySerializer.serializerToString(result));
            CasHelper.showOperationResultMulti(result, ResManager.loadKDString("取消通知认领", "RecClaimBillList_8", "tmc-cdm-formplugin", new Object[0]), this.getView());
        } else {
            ((ListView) this.getView()).refresh();
            this.getView().showSuccessNotification(ResManager.loadKDString("操作成功", "RecClaimBillList_2", "tmc-cdm-formplugin", new Object[0]));
        }

    }

    private Set<String> getClaimBillno(Set<Object> detailIds, boolean isSource) {
        List<Long> longRecBillIds = new ArrayList(8);
        Iterator qFilter = detailIds.iterator();

        while (true) {
            while (qFilter.hasNext()) {
                Object recvingId = qFilter.next();
                if (recvingId instanceof String && !StringUtils.isBlank(recvingId)) {
                    longRecBillIds.add(Long.valueOf(recvingId.toString()));
                } else {
                    assert recvingId instanceof Long;

                    longRecBillIds.add((Long) recvingId);
                }
            }

            qFilter = null;
            QFilter qFilter1;
            if (isSource) {
                qFilter1 = new QFilter("sourcebillid", "in", longRecBillIds);
            } else {
                qFilter1 = new QFilter("id", "in", longRecBillIds);
            }

            DynamicObject[] recvings = BusinessDataServiceHelper.load("gm_receiveletter", "id,claimnoticebillno", new QFilter[]{qFilter1});
            Set<String> claimnoticebillnoSet = new HashSet();
            DynamicObject[] var7 = recvings;
            int var8 = recvings.length;

            for (int var9 = 0; var9 < var8; ++var9) {
                DynamicObject recving = var7[var9];
                String claimnoticebillno = recving.getString("claimnoticebillno");
                if (EmptyUtil.isNoEmpty(claimnoticebillno)) {
                    claimnoticebillnoSet.add(claimnoticebillno);
                }
            }

            return claimnoticebillnoSet;
        }
    }

    @Override
    public void billListHyperLinkClick(HyperLinkClickArgs args) {
//        super.billListHyperLinkClick(args);
//        String fieldName = args.getHyperLinkClickEvent().getFieldName();
//        if ("claimnoticebillno".equals(fieldName)) {
//            args.setCancel(true);
//            BillList list = (BillList) this.getControl("billlistap");
//            Object focusRowPkId = list.getFocusRowPkId();
//            DynamicObject recving = BusinessDataServiceHelper.loadSingle(focusRowPkId, "gm_receiveletter", "id,claimnoticebillno");
//            String recBillNo = recving.getString("claimnoticebillno");
//            if (!StringUtils.isEmpty(recBillNo)) {
//                QFilter filter = new QFilter("billno", "=", recBillNo);
//                DynamicObject recbillDo = BusinessDataServiceHelper.loadSingle("gm_receiveletter", "id,billstatus", new QFilter[]{filter});
//                if (!CasHelper.isEmpty(recbillDo)) {
//                    BillShowParameter showParameter = new BillShowParameter();
//                    showParameter.setStatus(OperationStatus.VIEW);
//                    showParameter.setFormId("cas_claimcenterbill");
//                    showParameter.setPkId(recbillDo.getPkValue());
//                    showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
//                    this.getView().showForm(showParameter);
//                }
//            }
//        }

    }

    private void noticeClaim(Object[] ids) {
        long startTimeTobook = System.currentTimeMillis();
        logger.info("noticeClaim is start :" + SerializationUtils.toJsonString(ids) + ",startTimeTobook:" + startTimeTobook);
        DynamicObject[] receivablebills = this.getSelectRow(ids);
        this.checkOpPerm("tpv_noticeclaim", ResManager.loadKDString("通知认领", "RecClaimBillList_7", "tmc-cdm-formplugin", new Object[0]), receivablebills);
        List<DynamicObject> noticeds = new ArrayList(10);
        List<DynamicObject> unnotices = new ArrayList(10);
        Set<Long> orgSet = new HashSet(10);
        boolean isMoreBills = receivablebills.length > 1;
        List<String> errorMsg = new ArrayList();
        logger.info("curr bill is start");
        String appId = AppMetadataCache.getAppInfo("cdm").getId();

        Set<Long> companyIdSet = (Set) Arrays.stream(receivablebills).map((e) -> {
            return e.getDynamicObject("org").getLong("id");
        }).collect(Collectors.toSet());
        logger.info("orgIdSet size:" + SerializationUtils.toJsonString(companyIdSet));
        Map<Long, String> companyIdAndSysMap = new HashMap(6);
        Iterator var13 = companyIdSet.iterator();

        while (var13.hasNext()) {
            Long companyId = (Long) var13.next();
            String noticeClaimAllowStatus = (String) SystemParamServiceHelper.getAppParameter(appId, "08", companyId, "noticeclaimallowstatus");
            companyIdAndSysMap.put(companyId, noticeClaimAllowStatus);
        }

        Map<Long, Boolean> billIdAndExsitMap = DraftHelper.existsRecBillByBatch(ids);
        DynamicObject[] var31 = receivablebills;
        int var34 = receivablebills.length;

        for (int var16 = 0; var16 < var34; ++var16) {
            DynamicObject receivablebill = var31[var16];
            if (!StringUtils.equals(BillStatusEnum.AUDIT.getValue(), receivablebill.getString("billstatus"))) {
                if (!isMoreBills) {
                    this.getView().showErrorNotification(ResManager.loadKDString("未审核或已退票的的数据不能通知认领", "RecClaimBillList_10", "tmc-cdm-formplugin", new Object[0]));
                    return;
                }

                errorMsg.add(String.format("%s:" + ResManager.loadKDString("未审核或已退票的的数据不能通知认领", "RecClaimBillList_10", "tmc-cdm-formplugin", new Object[0]), receivablebill.get("billno")));
            }

            if (billIdAndExsitMap.containsKey(receivablebill.getLong("id"))) {
                if (!isMoreBills) {
                    this.getView().showErrorNotification(ResManager.loadKDString("票据已生成收款单并确认收款，不可发起通知认领", "RecClaimBillList_26", "tmc-cdm-formplugin", new Object[0]));
                    return;
                }

                errorMsg.add(String.format("%s:" + ResManager.loadKDString("票据已生成收款单并确认收款，不可发起通知认领", "RecClaimBillList_26", "tmc-cdm-formplugin", new Object[0]), receivablebill.get("billno")));
            }
            orgSet.add(receivablebill.getDynamicObject("org").getLong("id"));
            if (orgSet.size() > 1) {
                if (!isMoreBills) {
                    this.getView().showErrorNotification(ResManager.loadKDString("不支持多个资金组织的应收票据批量通知认领", "RecClaimBillList_14", "tmc-cdm-formplugin", new Object[0]));
                    return;
                }

                errorMsg.add(String.format("%s:" + ResManager.loadKDString("不支持多个资金组织的应收票据批量通知认领", "RecClaimBillList_14", "tmc-cdm-formplugin", new Object[0]), receivablebill.get("billno")));
            }

            Set<Long> draftIds = new HashSet(8);
            draftIds.add(receivablebill.getLong("id"));
            Set<Long> longSet = LockDraftHelper.draftIsQuoteRecs(draftIds);
            if (!EmptyUtil.isEmpty(longSet)) {
                String showErrorMsg = ResManager.loadKDString("该票据已经关联收款处理，无需通知认领", "RecClaimBillList_34", "tmc-cdm-formplugin", new Object[0]);
                if (!isMoreBills) {
                    this.getView().showErrorNotification(showErrorMsg);
                    return;
                }

                errorMsg.add(String.format("%s:" + showErrorMsg, receivablebill.get("billno")));
            }

//            if (EmptyUtil.isEmpty((String)receivablebill.get("claimnoticebillno"))){
//                QFilter qFilter = new QFilter("claimnoticebillno", QFilter.equals,receivablebill.get("claimnoticebillno"));
//                DynamicObject[] dynamicObjects = BusinessDataServiceHelper.load("gm_receiveletter", "id,claimnoticebillno", new QFilter[]{qFilter});
//                if (dynamicObjects!=null&&dynamicObjects.length>0){
//                    //不等于空说明进行了索赔申请，那么要清空收款单号字段
//                    dynamicObjects[0].set("claimnoticebillno",null);
//                    //更新为0
//                    SaveServiceHelper.update(dynamicObjects[0]);
//                }
//
//            }
            if (EmptyUtil.isEmpty((String) receivablebill.get("tpv_claimnoticebillno"))) {

                unnotices.add(receivablebill);
            } else {
                String showErrorMsg = ResManager.loadKDString("该收证处理已经通知认领过，无需通知认领", "RecClaimBillList_34", "tmc-cdm-formplugin", new Object[0]);
                if (!isMoreBills) {
                    this.getView().showErrorNotification(showErrorMsg);
                    return;
                }
                errorMsg.add(String.format("%s:" + showErrorMsg, receivablebill.get("billno")));
                noticeds.add(receivablebill);
            }
            //查询是否已经通知认领
//
//            QFilter qFilter = new QFilter("billno", QFilter.equals,receivablebill.get("billno"));
//                // DynamicObject dynamicObject = QueryServiceHelper.queryOne("tk_shkd_claimapplication1", "billno,shkd_receipt", new QFilter[]{qFilter});
//                DynamicObject[] dynamicObjects = BusinessDataServiceHelper.load("cas_claimcenterbill", "id,billno", new QFilter[]{qFilter});
//                if (dynamicObjects!=null&&dynamicObjects.length>0){
//                    String showErrorMsg = ResManager.loadKDString("该单据已经通知认领，无需通知认领", "RecClaimBillList_34", "tmc-cdm-formplugin", new Object[0]);
//                    noticeds.add(receivablebill);
//                    if (!isMoreBills) {
//                        this.getView().showErrorNotification(showErrorMsg);
//                        return;
//                    }
//
//                    errorMsg.add(String.format("%s:" + showErrorMsg, receivablebill.get("billno")));
//
//
//                }else {
//                    unnotices.add(receivablebill);
//                }

        }


        logger.info("curr bill is end");
        if (errorMsg.size() > 0 && isMoreBills) {
            StringBuilder stringBuilder = new StringBuilder();
            Iterator var36 = errorMsg.iterator();

            while (var36.hasNext()) {
                String str = (String) var36.next();
                stringBuilder.append(str).append(";").append("\r\n");
            }

            this.batchInputTip("", stringBuilder.toString());
        } else {
            List<DynamicObject> failIds = new ArrayList(10);
            List<DynamicObject> successIds = new ArrayList(10);
            StringBuilder recPayRuleFailMessage = new StringBuilder();
            Map<String, String> ruleNotice = new HashMap();
            logger.info("will unnotices is start");

            if (EmptyUtil.isNoEmpty(unnotices)) {
                logger.info("unnotices size is:" + unnotices.size());
                Set<Long> comapnySet = (Set)unnotices.stream().map((e) -> {
                    return e.getDynamicObject("org").getLong("id");
                }).collect(Collectors.toSet());
                Set<Long> unnoticeIdSet = (Set)unnotices.stream().map((e) -> {
                    return e.getLong("id");
                }).collect(Collectors.toSet());
                //------------------------------------以上代码没问题--------------------------

                //下面两行是单据匹配规则
                Map<Long, DynamicObject> companyIdAndRuleMap = RecClaimRuleHelper.getMatchingRuleBatch(comapnySet, "pay", true);
                Map<Long, DynamicObject> billIdAnMatchMap = RecClaimRuleHelper.isMatchRuleBatch(companyIdAndRuleMap, unnoticeIdSet);
                logger.info("curr unnotices is start");
                Iterator var51 = unnotices.iterator();
                while (true) {
                    while (var51.hasNext()) {
                        DynamicObject unnotice = (DynamicObject) var51.next();
                        Long id = unnotice.getLong("id");
                        long orgId = unnotice.getDynamicObject("org").getLong("id");
                        DynamicObject ruleResult = null;
                        if (null != companyIdAndRuleMap.get(orgId)) {
                            ruleResult = (DynamicObject) billIdAnMatchMap.get(id);
                        }

                        if (EmptyUtil.isEmpty(ruleResult)) {
                            logger.info("ruleResult is null");
                            failIds.add(unnotice);
                        } else if (ruleResult != null) {
                            Object tag = ruleResult.get("e_savenotifi_TAG");
                            if ("ticket".equals(ruleResult.get("e_handlescheme")) && !EmptyUtil.isEmpty(tag)) {
                                successIds.add(unnotice);
                                String idStr = id.toString();
                                cache.put(idStr, tag);
                                ruleNotice.put(idStr, tag.toString());
                            } else {
                                failIds.add(unnotice);
                            }

                            if ("ticket".equals(ruleResult.get("e_handlescheme")) && !EmptyUtil.isEmpty(ruleResult.get("e_rulesname"))) {
                                successIds.add(unnotice);
                                cache.put(id.toString() + "rulesname", ruleResult.get("e_rulesname"));
                            }
                        }
                    }
                    logger.info("curr unnotices is end");
                    break;
                }
            }

            OperationResult result = null;
            if (!successIds.isEmpty()) {
                Object[] successPkIds = successIds.stream().map((e) -> {
                    return e.get("id");
                }).toArray();

                logger.info("successPkIds is:" + SerializationUtils.toJsonString(successPkIds));
                long beginPushTime = System.currentTimeMillis();
                result = TmcOperateServiceHelper.execOperateWithoutThrow("pushandsave", "gm_receiveletter", successPkIds, OperateOption.create());
                logger.info("pushandsave is end" + (System.currentTimeMillis() - beginPushTime));
                this.getPageCache().put("successIds", String.join(",", (Iterable) successIds.stream().map((e) -> {
                    return e.get("id").toString();
                }).collect(Collectors.toList())));
            }

            if (!failIds.isEmpty()) {
                logger.info("failIds is not emtry");
                ConfirmCallBackListener confirmCallBacks = new ConfirmCallBackListener("claimconfirm", this);
                String confirmMessage = "";
                noticeds.stream().forEach((detail) -> {
                    recPayRuleFailMessage.append(String.format(ResManager.loadKDString("%s：已发起过收款认领通知，无需再通知认领。\r\n", "RecClaimBillList_4", "tmc-cdm-formplugin", new Object[0]), detail.get("billno")));
                });
                successIds.stream().forEach((detail) -> {
                    recPayRuleFailMessage.append(String.format(ResManager.loadKDString("%s：通知认领操作成功。\r\n", "RecClaimBillList_5", "tmc-cdm-formplugin", new Object[0]), detail.get("billno")));
                });
                failIds.stream().forEach((detail) -> {
                    recPayRuleFailMessage.append(String.format(ResManager.loadKDString("%s：无法按方案通知认领，可能是未进行规则设置，或未适配到方案。可指定参与认领用户信息后发起通知。\r\n", "RecClaimBillList_1", "tmc-cdm-formplugin", new Object[0]), detail.get("billno")));
                });
                if (noticeds.isEmpty()) {
                    confirmMessage = String.format(ResManager.loadKDString("共%1$s条记录，已按规则通知认领%2$s条，需指定参与认领用户信息%3$s条，确认是否继续？", "RecClaimBillList_0", "tmc-cdm-formplugin", new Object[0]), ids.length, successIds.size(), failIds.size());
                } else {
                    confirmMessage = String.format(ResManager.loadKDString("共%1$s条记录，无需通知%2$s条，已按规则通知认领%3$s条，需指定参与认领用户信息%4$s条，确认是否继续？", "RecClaimBillList_6", "tmc-cdm-formplugin", new Object[0]), ids.length, noticeds.size(), successIds.size(), failIds.size());
                }

                this.getView().showConfirm(confirmMessage, recPayRuleFailMessage.toString(), MessageBoxOptions.OKCancel, ConfirmTypes.Default, confirmCallBacks);
                List<String> failIdsList = (List) failIds.stream().map((e) -> {
                    return e.get("id").toString();
                }).collect(Collectors.toList());
                logger.info("failIdsList is:" + SerializationUtils.toJsonString(failIdsList));
                this.getPageCache().put("failids", String.join(",", failIdsList));
            } else {
                if (noticeds.isEmpty()) {
                    logger.info("noticeds is empty");
                    this.getView().showSuccessNotification(ResManager.loadKDString("操作成功", "RecClaimBillList_2", "tmc-cdm-formplugin", new Object[0]));
                } else {
                    List<String> noticedsList = (List) noticeds.stream().map((e) -> {
                        return e.get("id").toString();
                    }).collect(Collectors.toList());
                    logger.info("noticedsList is:" + SerializationUtils.toJsonString(noticedsList));
                    noticeds.stream().forEach((detail) -> {
                        recPayRuleFailMessage.append(String.format(ResManager.loadKDString("%s：已发起过收款认领通知，无需再通知认领。\r\n", "RecClaimBillList_4", "tmc-cdm-formplugin", new Object[0]), detail.get("billno")));
                    });
                    unnotices.stream().forEach((detail) -> {
                        recPayRuleFailMessage.append(String.format(ResManager.loadKDString("%s：通知认领操作成功。\r\n", "RecClaimBillList_5", "tmc-cdm-formplugin", new Object[0]), detail.get("billno")));
                    });
                    this.getView().showMessage(String.format(ResManager.loadKDString("共%1$s条记录，已通知认领%2$s条，无需通知%3$s条", "RecClaimBillList_3", "tmc-cdm-formplugin", new Object[0]), receivablebills.length, unnotices.size(), noticeds.size()), recPayRuleFailMessage.toString(), MessageTypes.Default);
                }

                if (result != null) {
                    this.noticeMessage(ruleNotice);
                    this.getPageCache().remove("successIds");
                }

                ((ListView) this.getView()).refresh();
            }

            logger.info("noticeClaim is end :" + (System.currentTimeMillis() - startTimeTobook));
        }
    }

    //根据资金组织校验权限
    private void checkOpPerm(String operKey, String operKeyName, DynamicObject[] receivablebills) {
        if (!CasHelper.isEmpty(receivablebills)) {
            Map<String, Object> operateMetaMap = EntityMetadataCache.getDataEntityOperate("lc_receipt", operKey);
            Object permission = operateMetaMap.get("permission");
            boolean hasPerm = true;
            Set<Long> orgIds = new HashSet(receivablebills.length);
            DynamicObject[] var8 = receivablebills;
            int var9 = receivablebills.length;

            for (int var10 = 0; var10 < var9; ++var10) {
                DynamicObject receivablebill = var8[var10];
                orgIds.add(receivablebill.getDynamicObject("org").getLong("id"));
            }

            logger.info("checkOpPerm is start :" + SerializationUtils.toJsonString(orgIds));
            Iterator var12 = orgIds.iterator();

            while (var12.hasNext()) {
                Long org = (Long) var12.next();
                hasPerm = PermissionHelper.checkCurrentUserPermission(org, "lc_receipt", permission + "");
                if (!hasPerm) {
                }
            }

            if (!hasPerm) {
                logger.info(String.format(ResManager.loadKDString("当前用户没有%s的权限！", "RecWorkbenchPlugin_5", "tmc-cdm-formplugin", new Object[0]), operKeyName));
                throw new KDBizException(String.format(ResManager.loadKDString("当前用户没有%s的权限！", "RecWorkbenchPlugin_5", "tmc-cdm-formplugin", new Object[0]), operKeyName));
            }
        }
    }


    private String getErrorTips(String noticeClaimAllowStatus) {
        List<String> allowStatusList = Arrays.asList(noticeClaimAllowStatus.split(","));
        StringBuilder errorTips = new StringBuilder();
        Iterator var4 = allowStatusList.iterator();

        while (var4.hasNext()) {
            String allowStatus = (String) var4.next();
            if (StringUtils.equals(allowStatus, DraftBillStatusEnum.REGISTERED.getValue())) {
                errorTips.append(DraftBillStatusEnum.REGISTERED.getName()).append(ResManager.loadKDString("或", "RecClaimBillList_30", "tmc-cdm-formplugin", new Object[0]));
            } else if (StringUtils.equals(allowStatus, DraftBillStatusEnum.PLEDGED.getValue())) {
                errorTips.append(DraftBillStatusEnum.PLEDGED.getName()).append(ResManager.loadKDString("或", "RecClaimBillList_30", "tmc-cdm-formplugin", new Object[0]));
            } else if (StringUtils.equals(allowStatus, DraftBillStatusEnum.COLLOCATED.getValue())) {
                errorTips.append(DraftBillStatusEnum.COLLOCATED.getName()).append(ResManager.loadKDString("或", "RecClaimBillList_30", "tmc-cdm-formplugin", new Object[0]));
            } else if (StringUtils.equals(allowStatus, DraftBillStatusEnum.ENDORSED.getValue())) {
                errorTips.append(DraftBillStatusEnum.ENDORSED.getName()).append(ResManager.loadKDString("或", "RecClaimBillList_30", "tmc-cdm-formplugin", new Object[0]));
            } else if (StringUtils.equals(allowStatus, DraftBillStatusEnum.DISCOUNTED.getValue())) {
                errorTips.append(DraftBillStatusEnum.DISCOUNTED.getName()).append(ResManager.loadKDString("或", "RecClaimBillList_30", "tmc-cdm-formplugin", new Object[0]));
            } else if (StringUtils.equals(allowStatus, DraftBillStatusEnum.COLLECTED.getValue())) {
                errorTips.append(DraftBillStatusEnum.COLLECTED.getName()).append(ResManager.loadKDString("或", "RecClaimBillList_30", "tmc-cdm-formplugin", new Object[0]));
            }
        }

        return errorTips.substring(0, errorTips.length() - 1);
    }


    private void batchInputTip(String title, String content) {
        FormShowParameter parameters = new FormShowParameter();
        parameters.getOpenStyle().setShowType(ShowType.Modal);
        parameters.setFormId("bos_operationresult");
        parameters.setShowTitle(false);
        parameters.setCustomParam("title", title);
        StringBuilder buf = new StringBuilder();
        buf.append("<div style='overflow:auto;word-wrap:break-word;word-break:break-all;width:100%'>");
        parameters.setCustomParam("errorMsg", buf.append(content));
        this.getView().showForm(parameters);
    }


    private void noticeMessage(Map<String, String> ruleNotice) {
        Map<Object, Map<String, List<Object>>> claimTypeMap = new HashMap(ruleNotice.size());
        Map<String, List<Object>> typeValue = null;
        Iterator var4 = ruleNotice.entrySet().iterator();

        while (var4.hasNext()) {
            Map.Entry<String, String> rule = (Map.Entry) var4.next();
            Map<String, Object> map = (Map) SerializationUtils.fromJsonString((String) rule.getValue(), Map.class);
            typeValue = new HashMap();
            typeValue.put("usergroupids", (List) map.get("usergroupids"));
            typeValue.put("orgids", (List) map.get("orgids"));
            typeValue.put("roleids", (List) map.get("roleids"));
            typeValue.put("userids", (List) map.get("userids"));
            claimTypeMap.put(rule.getKey(), typeValue);
        }

        RecClaimHelper.sendClaimNoticeMessage(claimTypeMap, "notice");
    }


    @Override
    public void confirmCallBack(MessageBoxClosedEvent e) {
        super.confirmCallBack(e);
        if (e.getCallBackId().equals("claimconfirm") && e.getResult() == MessageBoxResult.Yes) {
            FormShowParameter formParameter = new FormShowParameter();
            formParameter.setFormId("cas_noticeclaim");
            formParameter.getOpenStyle().setShowType(ShowType.Modal);
            formParameter.setCloseCallBack(new CloseCallBack(this, "noticetype"));
            BillList list = (BillList) this.getControl("billlistap");
            ListSelectedRowCollection selectedRows = list.getSelectedRows();
            DynamicObject[] receivablebills = BusinessDataServiceHelper.load("gm_receiveletter", "id, billno, claimnoticebillno , receredtype , org", new QFilter[]{new QFilter("id", "in", selectedRows.getPrimaryKeyValues())});
            if (EmptyUtil.isNoEmpty(receivablebills)) {
                formParameter.setCustomParam("orgId", receivablebills[0].getDynamicObject("org").getPkValue());
            }

            this.getView().showForm(formParameter);
        } else {
            String successString = this.getPageCache().get("successIds");
            if (EmptyUtil.isNotEmpty(successString)) {
                String[] successIds = successString.split(",");
                Map<String, String> ruleNotice = new HashMap(successIds.length);

                for (int i = 0; i < successIds.length; ++i) {
                    ruleNotice.put(successIds[i], cache.get(successIds[i], String.class));
                }

                this.noticeMessage(ruleNotice);
            }

            this.getPageCache().remove("successIds");
            ((ListView) this.getView()).refresh();
        }

    }


    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
        if ("noticetype".equals(closedCallBackEvent.getActionId())) {
            Object returnData = closedCallBackEvent.getReturnData();
            if (EmptyUtil.isEmpty(returnData)) {
                return;
            }

            Map<String, Object> noticeData = (Map) returnData;
            String jsonString = SerializationUtils.toJsonString(noticeData);
            String failidString = this.getPageCache().get("failids");
            String[] failids = failidString.split(",");
            Map<String, String> ruleNotice = new HashMap(failids.length);

            for (int i = 0; i < failids.length; ++i) {
                cache.put(failids[i], jsonString);
                ruleNotice.put(failids[i], jsonString);
            }

            Long[] ids = (Long[]) Arrays.stream(failids).mapToLong(Long::valueOf).boxed().toArray((x$0) -> {
                return new Long[x$0];
            });
            logger.info("closedCallBack ids is:" + SerializationUtils.toJsonString(ids));
            OperationResult result = TmcOperateServiceHelper.execOperateWithoutThrow("pushandsave", "lc_receipt", ids, OperateOption.create());
            this.getView().showSuccessNotification(ResManager.loadKDString("操作成功", "RecClaimBillList_2", "tmc-cdm-formplugin", new Object[0]));
            String successString = this.getPageCache().get("successIds");
            if (EmptyUtil.isNotEmpty(successString)) {
                String[] successIds = successString.split(",");

                for (int i = 0; i < successIds.length; ++i) {
                    ruleNotice.put(successIds[i], cache.get(successIds[i], String.class));
                }
            }

            this.noticeMessage(ruleNotice);
            this.getPageCache().remove("successIds");
            ((ListView) this.getView()).refresh();
        }

    }


    //收证登记源页面查数据
    public DynamicObject[] getSelectRow(Object[] ids) {
        String lcReceipt = DynamicObjectUtil.getSelectfields("lc_receipt");
        DynamicObject[] receivablebills = BusinessDataServiceHelper.load("lc_receipt",lcReceipt, new QFilter[]{new QFilter("id", "in", ids)});

        return receivablebills;
    }
}
