package tpv.tmc.lc.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.DeleteServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.scm.common.util.DynamicObjectUtil;

import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @ClassName: BizapplyOpapyAuditOp
 * @Description: 开证申请，改证申请审核后修改采购合同可开证金额和已开证金额
 * @author: zbh
 * @date: 2023-11-22
 */
public class BizapplyOpapyAuditOp extends AbstractOperationServicePlugIn {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("tpv_contractdetail");
        keys.add("tpv_purnumbers");
        keys.add("tpv_kzappmon");
        keys.add("tpv_bustype");
        keys.add("tpv_spotforward");
        keys.add("tpv_letcre");
        keys.add("tpv_furlook");
        keys.add("tpv_furlookhk");
        keys.add("tpv_wedoor");
        keys.add("tpv_collaborasetting");
        keys.add("tpv_xtdepartment");
        keys.add("tpv_synergy");
        keys.add("tpv_xtremark");
        keys.add("tpv_purnumbers");
        keys.add("tpv_kzappmon");
        keys.add("tpv_tjtype");
        keys.add("tpv_combinationnum");
        keys.add("tpv_naturetrade");
        keys.add("tpv_businesstype");
        keys.add("tpv_purmoney");
        keys.add("tpv_purcurrency");
        keys.add("tpv_purdepartment");
        keys.add("tpv_pruper");
        keys.add("tpv_apprmbmon");
        keys.add("tpv_appusdrate");
        keys.add("tpv_appusdmon");
        keys.add("tpv_appusdmon");
        keys.add("tpv_collaborasetting");
        keys.add("tpv_xtdepartment");
        keys.add("tpv_synergy");
        keys.add("tpv_xtremark");
        keys.add("tpv_spotforward");
        keys.add("tpv_letcre");
        keys.add("tpv_furlook");
        keys.add("tpv_furlookhk");
        keys.add("tpv_wedoor");
        keys.add("tpv_oriisspro");
        keys.add("lettercredit");
        keys.add("tpv_isnot");
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        String key = e.getOperationKey();
        DynamicObject[] entities = e.getDataEntities();
        switch (key) {
            case "audit":
                audit(entities);
                break;
            case "unaudit":
                unAudit(entities,e);
                break;
        }

    }

    /**
     * @Title: audit
     * @Description: 审核将开证金额反写到采购合同对应的金额
     * @return: void
     */
    private void audit(DynamicObject[] entities) {

        for (DynamicObject data : entities) {
            String tpvBustype = data.getString("biztype");
            if ("edit_card".equals(tpvBustype)) {//改证
                DynamicObject tpvOriisspro = data.getDynamicObject("lettercredit");
                DynamicObject lcLettercreditF7 = BusinessDataServiceHelper.loadSingle(tpvOriisspro.getPkValue(), "lc_lettercredit_f7");
                String number = lcLettercreditF7.getString("number");
                DynamicObjectCollection tpvSpotforwardSq = data.getDynamicObjectCollection("tpv_spotforward");
                DynamicObjectCollection tpvCollaborasettingSq = data.getDynamicObjectCollection("tpv_collaborasetting");
                DynamicObjectCollection tpvContractdetailSq = data.getDynamicObjectCollection("tpv_contractdetail");
                Date applydate = data.getDate("applydate");
                Boolean istransfer = data.getBoolean("istransfer");
                DynamicObject lcLettercredit = BusinessDataServiceHelper.loadSingle("lc_lettercredit",new QFilter[]{new QFilter("creditno","=",number)});
                lcLettercredit.set("applydate", applydate);//申请日期
                lcLettercredit.set("tpv_istransfer", istransfer);//是否转船
                DynamicObjectCollection tpvSpotforwardCL = lcLettercredit.getDynamicObjectCollection("tpv_spotforward");
                tpvSpotforwardCL.clear();
                DynamicObjectCollection tpvCollaborasettingCL = lcLettercredit.getDynamicObjectCollection("tpv_collaborasetting");
                tpvCollaborasettingCL.clear();
                DynamicObjectCollection tpvContractdetailCL = lcLettercredit.getDynamicObjectCollection("tpv_contractdetail");
                tpvContractdetailCL.clear();
                for (DynamicObject dynamicObject : tpvSpotforwardSq) {
                    DynamicObject aNew = tpvSpotforwardCL.addNew();
                    aNew.set("tpv_letcre", dynamicObject.getString("tpv_letcre"));
                    aNew.set("tpv_furlook", dynamicObject.getBigDecimal("tpv_furlook"));
                    aNew.set("tpv_furlookhk", dynamicObject.getString("tpv_furlookhk"));
                    aNew.set("tpv_wedoor", dynamicObject.getBoolean("tpv_wedoor"));
                }
                for (DynamicObject dynamicObject : tpvCollaborasettingSq) {
                    DynamicObject aNew = tpvCollaborasettingCL.addNew();
                    aNew.set("tpv_xtdepartment", dynamicObject.getDynamicObject("tpv_xtdepartment"));
                    aNew.set("tpv_synergy", dynamicObject.getBigDecimal("tpv_synergy"));
                    aNew.set("tpv_xtremark", dynamicObject.getString("tpv_xtremark"));
                }
                for (DynamicObject dynamicObject : tpvContractdetailSq) {
                    DynamicObject aNew = tpvContractdetailCL.addNew();
                    aNew.set("tpv_purnumbers", dynamicObject.getString("tpv_purnumbers"));
                    aNew.set("tpv_kzappmon", dynamicObject.getBigDecimal("tpv_kzappmon"));
                    aNew.set("tpv_tjtype", dynamicObject.getDynamicObject("tpv_tjtype"));
                    aNew.set("tpv_combinationnum", dynamicObject.getDynamicObject("tpv_combinationnum"));
                    aNew.set("tpv_naturetrade", dynamicObject.getDynamicObject("tpv_naturetrade"));
                    aNew.set("tpv_businesstype", dynamicObject.getDynamicObject("tpv_businesstype"));
                    aNew.set("tpv_purmoney", dynamicObject.getBigDecimal("tpv_purmoney"));
                    aNew.set("tpv_purcurrency", dynamicObject.getDynamicObject("tpv_purcurrency"));
                    aNew.set("tpv_purdepartment", dynamicObject.getDynamicObject("tpv_purdepartment"));
                    aNew.set("tpv_pruper", dynamicObject.getDynamicObject("tpv_pruper"));
                    aNew.set("tpv_apprmbmon", dynamicObject.getBigDecimal("tpv_apprmbmon"));
                    aNew.set("tpv_appusdrate", dynamicObject.getBigDecimal("tpv_appusdrate"));
                    aNew.set("tpv_appusdmon", dynamicObject.getBigDecimal("tpv_appusdmon"));
                }
                SaveServiceHelper.save(new DynamicObject[]{lcLettercredit});
                //审核后向资金额度底表增加一条数据
                Map<Long, Long> map = Arrays.stream(entities).collect(Collectors.toMap(dynamicObject -> (Long) dynamicObject.getPkValue(), dynamicObject -> dynamicObject.getLong("tpv_oriisspro.id")));
                CapitalLimitServiceOp.changeCredit(map, "edit_card", data, "del");
            }

            if ("open_card".equals(tpvBustype)) {
                DynamicObjectCollection tpv_contractdetail = data.getDynamicObjectCollection("tpv_contractdetail"); // 合同明细
                for (DynamicObject contractdetail : tpv_contractdetail) {
                    String tpv_purnumbers = contractdetail.getString("tpv_purnumbers"); // 采购合同号
                    BigDecimal tpv_kzappmon = contractdetail.getBigDecimal("tpv_kzappmon"); // 开证申请金额
                    String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_dt_purchase", false); // 获取单据头所有字段标识
                    selectFieid2 = DynamicObjectUtil.getEntrySelectfields(selectFieid2, "tpv_dt_purchase", "tpv_dt_purchase_u", false);// 获取单据头所有字段标识
                    DynamicObject bill = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", selectFieid2, new QFilter[]{
                            new QFilter("tpv_contractnumber", QCP.equals, tpv_purnumbers)});
                    if (bill != null) {//采购合同
                        DynamicObjectCollection tpv_dt_purchase_u = bill.getDynamicObjectCollection("tpv_dt_purchase_u");//付款分录
                        for (DynamicObject tpv_dt_purchase : tpv_dt_purchase_u) {
                            if (tpv_dt_purchase.getString("tpv_payment.name").equals("国内信用证") || tpv_dt_purchase.getString("tpv_payment.name").equals("国际信用证")) {
                                tpv_dt_purchase.set("tpv_issuedamount", tpv_dt_purchase.getBigDecimal("tpv_issuedamount").add(tpv_kzappmon));//已开证金额
                            }
                        }
                        bill.set("tpv_kzminey", bill.getBigDecimal("tpv_kzminey").add(tpv_kzappmon));//已开证金额(隐)
                        bill.set("tpv_moneykzed", bill.getBigDecimal("tpv_moneykzed").subtract(tpv_kzappmon));//可开证金额(隐)
                        SaveServiceHelper.update(bill);
                        //审核后向资金额度底表增加一条数据
                        Map<Long, Long> map = Arrays.stream(entities).collect(Collectors.toMap(dynamicObject -> (Long) dynamicObject.getPkValue(), dynamicObject -> dynamicObject.getLong("tpv_oriisspro.id")));
                        CapitalLimitServiceOp.changeCredit(map, "open_card", data, "del");
                        CapitalLimitServiceOp.changeCredit(map, "open_card", data, "add");
                    }
                }
            }
        }
    }

    /**
     * @Title: unAudit
     * @Description: 反审核将开证金额反写到采购合同对应的金额
     * @return: void
     */
    private void unAudit(DynamicObject[] entities, AfterOperationArgs e) {
        for (DynamicObject data : entities) {
            String tpvBustype = data.getString("biztype");
            if ("open_card".equals(tpvBustype)) {
                DynamicObjectCollection tpv_contractdetail = data.getDynamicObjectCollection("tpv_contractdetail");//合同明细
                for (DynamicObject contractdetail : tpv_contractdetail) {
                    String tpv_purnumbers = contractdetail.getString("tpv_purnumbers");//采购合同号
                    BigDecimal tpv_kzappmon = contractdetail.getBigDecimal("tpv_kzappmon");//开证申请金额
                    String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_dt_purchase", false);// 获取单据头所有字段标识
                    selectFieid2 = DynamicObjectUtil.getEntrySelectfields(selectFieid2, "tpv_dt_purchase", "tpv_dt_purchase_u", false);// 获取单据头所有字段标识
                    DynamicObject bill = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", selectFieid2, new QFilter[]{
                            new QFilter("tpv_contractnumber", QCP.equals, tpv_purnumbers)});
                    if (bill != null) {//采购合同
                        DynamicObjectCollection tpv_dt_purchase_u = bill.getDynamicObjectCollection("tpv_dt_purchase_u");//付款分录
                        for (DynamicObject tpv_dt_purchase : tpv_dt_purchase_u) {
                            if (tpv_dt_purchase.getString("tpv_payment.name").equals("国内信用证") || tpv_dt_purchase.getString("tpv_payment.name").equals("国际信用证")) {
                                tpv_dt_purchase.set("tpv_issuedamount", tpv_dt_purchase.getBigDecimal("tpv_issuedamount").subtract(tpv_kzappmon));//已开证金额
                            }
                        }
                        bill.set("tpv_kzminey", bill.getBigDecimal("tpv_kzminey").subtract(tpv_kzappmon));//已开证金额(隐)
                        bill.set("tpv_moneykzed", bill.getBigDecimal("tpv_moneykzed").add(tpv_kzappmon));//可开证金额(隐)
                        SaveServiceHelper.update(bill);
                    }
                }
                //开证申请反审核删除资金部门额度底表的数据
                List<ExtendedDataEntity> selectedRows = e.getSelectedRows();
                ArrayList<Long> deleteDataID = new ArrayList<>();
                selectedRows.stream().forEach(row -> {
                    deleteDataID.add(row.getDataEntity().getLong("id"));
                });
                ArrayList<QFilter> filters = new ArrayList<>();
                filters.add(new QFilter("tpv_triggerbillid", QCP.in, deleteDataID));//单据编号
                DeleteServiceHelper.delete("tpv_sc_capitallimit", filters.toArray(new QFilter[0]));
            }
        }
    }
}
