package tpv.tmc.lc.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import tpv.tmc.lc.java.opplugin.validator.BizapplyOpapySubmitValidator;

import java.util.List;


public class BizapplyOpapySubmitOP extends AbstractOperationServicePlugIn  {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("tpv_oriisspro");
        keys.add("tpv_collaborasetting");
        keys.add("tpv_collaborasetting.tpv_synergy");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
//        e.addValidator(new BizapplyOpapySubmitValidator());
    }

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        DynamicObject[] entities = e.getDataEntities();
        String key = e.getOperationKey();
        switch (key){
            case"audit-kz":
                for (DynamicObject entity : entities) {
                    DynamicObject tpvOriisspro = entity.getDynamicObject("tpv_oriisspro");
                    if(tpvOriisspro!=null){
                        Object pkValue = tpvOriisspro.getPkValue();
                        DynamicObject lcLettercredit = BusinessDataServiceHelper.loadSingle(pkValue, "lc_lettercredit");
                        lcLettercredit.set("biztype","repeal_card");
                        SaveServiceHelper.save(new DynamicObject[]{lcLettercredit});
                    }
                }
                break;
            case"unaudit-cz":
                for (DynamicObject entity : entities) {
                    DynamicObject tpvOriisspro = entity.getDynamicObject("tpv_oriisspro");
                    if(tpvOriisspro!=null){
                        Object pkValue = tpvOriisspro.getPkValue();
                        DynamicObject lcLettercredit = BusinessDataServiceHelper.loadSingle(pkValue, "lc_lettercredit");
                        lcLettercredit.set("biztype","open_card");
                        SaveServiceHelper.save(new DynamicObject[]{lcLettercredit});
                    }
                }
                break;
        }
    }
}
