package tpv.tmc.lc.java.opplugin.op;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import tpv.tmc.lc.java.opplugin.validator.ReferenceShutDownValidator;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

/**
 *@Description: 改证申请 关闭校验
 *@Project: zhck
 *@Package: tpv.tmc.lc.java.opplugin.op.CreditLimitShutDownOp
 *@Date: 2024/04/22 11:11
 *@Author: Heisenberg Wenbei He
 *@Version: 1.0
 */
public class CreditLimitShutDownOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("lettercredit");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new ReferenceShutDownValidator());
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        if (e.getOperationKey().equals("shutdown")) {
            List<DynamicObject> list = new ArrayList<>();
            Arrays.stream(e.getDataEntities())
                    .forEach(single -> {
                        single.set("tpv_poweroff", true);
                        single.set("tpv_offuser", YEM.getCurrentUserId());
                        single.set("tpv_offtime", new Date());
                        list.add(single);
                    });

            SaveServiceHelper.save(list.toArray(new DynamicObject[0]));
        }
    }
}
