package tpv.tmc.lc.java.opplugin.op;

import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import tpv.tmc.lc.java.opplugin.validator.EntryExistenceSubmitValidator;

import java.util.List;

/**
 *@Description: 【即期/远期】=“混合”时，判断{即期远期列表}分录必须存在一条数据
 *@Project: zhck
 *@Package: tpv.tmc.lc.java.opplugin.op.EntryExistenceSubmitOp
 *@Date: 2024/04/28 18:12
 *@Author: Heisenberg Wenbei He
 *@Version: 1.0
 */
public class EntryExistenceSubmitOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_lettercty");
        fieldKeys.add("tpv_spotforward");
        fieldKeys.add("tpv_credittype");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        e.addValidator(new EntryExistenceSubmitValidator());
    }
}
