package tpv.tmc.lc.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.List;

/**
 * @ClassName: LcArrivalSubmitOp
 * @Description:
 * @author: zbh
 * @date: 2024-05-10
 */
public class LcArrivalSubmitOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("tpv_overfillrate");
        keys.add("tpv_contractqty");
        keys.add("tpv_selectsum");
        keys.add("tpv_contract");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() {
                ExtendedDataEntity[] dataEntities = this.getDataEntities();
                String key = this.getOperateKey();
                switch (key) {
                    case "submit":
                        onSumbit(dataEntities);
                        break;
                }
            }
            private void onSumbit(ExtendedDataEntity[] dataEntities) {
                for (ExtendedDataEntity dataEntity : dataEntities) {
                    DynamicObject entity = dataEntity.getDataEntity();
                    Object pkValue = entity.getPkValue();
                    DynamicObject lcArrival = BusinessDataServiceHelper.loadSingle(pkValue, "lc_arrival");
                    String tpvLettercredit = lcArrival.getString("tpv_lettercredit");
                    DynamicObject lcLettercredit = BusinessDataServiceHelper.loadSingle("lc_lettercredit", new QFilter[]{new QFilter("creditno", "=", tpvLettercredit)});
                    BigDecimal amount = lcLettercredit.getBigDecimal("amount");
                    BigDecimal tpvOverfillrate = lcLettercredit.getBigDecimal("tpv_overfillrate");
                    DynamicObject[] lcArrivalS = BusinessDataServiceHelper.load("lc_arrival", "isdiscrepancy,arrivalamount", new QFilter[]{new QFilter("tpv_lettercredit", "=", "tpvLettercredit")});
                    BigDecimal arrivalMoney = BigDecimal.ZERO;
                    Boolean isFlag = false;
                    for (DynamicObject arrival : lcArrivalS) {
                        BigDecimal arrivalamount = arrival.getBigDecimal("arrivalamount");
                        boolean isdiscrepancy = arrival.getBoolean("isdiscrepancy");
                        arrivalMoney = arrivalMoney.add(arrivalamount);
                        if (!isdiscrepancy) {
                            isFlag = true;
                        }
                    }
                    arrivalMoney = arrivalMoney.add(lcArrival.getBigDecimal("arrivalamount"));
                    if (arrivalMoney.compareTo(amount.multiply(BigDecimal.ONE.add(tpvOverfillrate.divide(new BigDecimal(100), 2, BigDecimal.ROUND_HALF_UP)))) > 0 && isFlag) {
                        this.addMessage(dataEntity, "累计来单金额超出信用证溢装金额。纯在不符点，请检查！");
                    }
                }
            }
        });
    }
}
