package tpv.tmc.lc.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.exception.KDException;
import kd.bos.logging.Log;
import kd.bos.logging.LogFactory;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.operation.DeleteServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.tmc.fbp.common.enums.ProductTypeEnum;
import kd.tmc.fbp.common.helper.TmcDataServiceHelper;
import kd.tmc.fbp.common.util.EmptyUtil;
import kd.tmc.lc.business.opservice.arrival.ArrivalBillUnArrConfirmService;
import kd.tmc.lc.common.enums.ArrivalStatusEnum;
import kd.tmc.lc.common.helper.LcFeeDetailHelper;
import kd.tmc.lc.common.helper.LetterCreditHelper;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 *@Description: 继承标准插件
 *@Project: zhck
 *@Package: tpv.tmc.lc.java.opplugin.op.MyArrivalBillUnArrConfirmService
 *@Date: 2024/04/24 15:50
 *@Author: Heisenberg Wenbei He
 *@Version: 1.0
 */
public class MyArrivalBillUnArrConfirmService extends ArrivalBillUnArrConfirmService {
    private static final Log logger = LogFactory.getLog(ArrivalBillUnArrConfirmService.class);
    private static final String[] NO_SAVE = new String[]{"feedetail", "entrys", "id", "seq", "billno"
            , "billstatus", "billhead_lk", "creator", "creatortime", "modifier", "modifytime", "auditor"
            , "auditdate", "multilanguagetext", "your_excluded_property", "tpv_contractdetails", "FEntryId", "fentryid"
            , "pk_tpv_contractdetails", "FSeq", "tpv_purnumbers", "tpv_tjtype", "tpv_combinationnum"
            , "tpv_naturetrade", "tpv_strategynum", "FId", "tpv_purcurrency", "tpv_contractdetail", "tpv_purdepartment"};

    @Override
    public void process(DynamicObject[] dataEntities) throws KDException {
        Map<Long, BigDecimal> lettArrMap = new HashMap(dataEntities.length);
        DynamicObject[] var3 = dataEntities;
        int var4 = dataEntities.length;

        for (int var5 = 0; var5 < var4; ++var5) {
            DynamicObject arrivalBill = var3[var5];
            String billNo = arrivalBill.getString("billno");
            QFilter filter = new QFilter("billNo", "=", billNo);
            DynamicObject history = TmcDataServiceHelper.loadSingle("lc_arrival_h", "id", filter.toArray());
            DynamicObject arrival = TmcDataServiceHelper.loadSingle(arrivalBill.getLong("id"), "lc_arrival");
            logger.info("history=======================" + EmptyUtil.isNoEmpty(history));
            if (!EmptyUtil.isNoEmpty(history)) {
                logger.info("update=======================");
                arrival.set("arrivalstatus", ArrivalStatusEnum.ARRIVAL_REGISTER.getValue());
                arrival.set("configtime", (Object) null);
                logger.info("status=======================" + arrival.getString("arrivalstatus"));
                SaveServiceHelper.update(arrival);
            } else {
                history = TmcDataServiceHelper.loadSingle(history.getPkValue(), history.getDynamicObjectType().getName());
                LcFeeDetailHelper.updateFeeDetailBill(history, arrival, ProductTypeEnum.LC_ARRIVAL);
                Iterator var11 = arrival.getDataEntityType().getProperties().iterator();

                while (var11.hasNext()) {
                    IDataEntityProperty property = (IDataEntityProperty) var11.next();
                    String prop = property.getName();
                    if (history.getDataEntityType().getProperties().containsKey(prop) && !Arrays.asList(NO_SAVE).contains(prop) && !prop.endsWith("_id")) {
                        arrival.set(prop, history.get(prop));
                    }
                }

                SaveServiceHelper.save(new DynamicObject[]{arrival});
                DeleteServiceHelper.delete("lc_arrival_h", filter.toArray());
            }

            DynamicObject letterCredit = arrivalBill.getDynamicObject("lettercredit");
            if (EmptyUtil.isNoEmpty(letterCredit)) {
                BigDecimal arrAmt = (BigDecimal) lettArrMap.getOrDefault(letterCredit.getLong("id"), BigDecimal.ZERO);
                lettArrMap.put(letterCredit.getLong("id"), arrAmt.subtract(arrivalBill.getBigDecimal("arrivalamount")));
            }
        }

        LetterCreditHelper.updateLetterArr("lc_lettercredit", lettArrMap);
    }
}
