package tpv.tmc.lc.java.opplugin.validator;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.resource.ResManager;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.exception.KDBizException;
import kd.tmc.fbp.common.util.EmptyUtil;
import kd.tmc.lc.common.enums.LetterBizTypeEnum;
import kd.tmc.lc.common.enums.LetterCreditStatusEnum;

/**
 * @ClassName: BizLetterCreditApplyUnAuditValidator
 * @Description: 继承标准
 * @author: zbh
 * @date: 2024-04-24
 */
public class BizLetterCreditApplyUnAuditValidator extends AbstractOperationServicePlugIn {

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        DynamicObject[] entities = e.getDataEntities();
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() throws KDBizException {
                ExtendedDataEntity[] var2 = dataEntities;
                int var3 = dataEntities.length;

                for (int var4 = 0; var4 < var3; ++var4) {
                    ExtendedDataEntity dataEntity = var2[var4];
                    DynamicObject applyBill = dataEntity.getDataEntity();

                    String bizType = applyBill.getString("biztype");
                    DynamicObject letterCredit = applyBill.getDynamicObject("lettercredit");
                    if (EmptyUtil.isNoEmpty(letterCredit) && !LetterCreditStatusEnum.DONE_REGISTER.getValue().equals(letterCredit.getString("creditstatus"))) {
                        this.addErrorMessage(dataEntity, ResManager.loadKDString("信用证状态非已登记，不能反审核。", "LetterCreditApplyUnAuditValidator_5", "tmc-lc-business", new Object[0]));
                    }
                    if (LetterBizTypeEnum.REPEAL_CARD.getValue().equals(bizType)) {
                        this.addErrorMessage(dataEntity, ResManager.loadKDString("%s的业务申请，不允许再做反审核。", "LetterCreditApplyUnAuditValidator_2", "tmc-lc-business", new Object[]{LetterBizTypeEnum.REPEAL_CARD.getName()}));
                    } else if (LetterBizTypeEnum.CLOSE_CARD.getValue().equals(bizType)) {
                        this.addErrorMessage(dataEntity, ResManager.loadKDString("%s的业务申请，不允许再做反审核。", "LetterCreditApplyUnAuditValidator_2", "tmc-lc-business", new Object[]{LetterBizTypeEnum.CLOSE_CARD.getName()}));
                    }
                }
            }
        });
    }
}
