package tpv.tmc.lc.java.opplugin.validator;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.validate.AbstractValidator;

import java.math.BigDecimal;

public class BizapplyOpapySubmitValidator extends AbstractValidator {
    @Override
    public void validate() {
        ExtendedDataEntity[] dataEntities = this.dataEntities;
        for (int i = 0; i < dataEntities.length; i++) {
            ExtendedDataEntity extend = dataEntities[i];
            DynamicObject entity = extend.getDataEntity();
            check(entity, extend);
        }
    }

    public void check(DynamicObject entity, ExtendedDataEntity extend) {
        //entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(),entity.getDynamicObjectType().getName());
        DynamicObjectCollection dynamicObjects = entity.getDynamicObjectCollection("tpv_collaborasetting");
        BigDecimal zero = BigDecimal.ZERO;
        for (DynamicObject dynamicObject : dynamicObjects) {
            BigDecimal tpvSynergy = dynamicObject.getBigDecimal("tpv_synergy");
            zero = zero.add(tpvSynergy);
        }
        if (zero.compareTo(new BigDecimal("100")) != 0 && dynamicObjects.size() > 0) {
            this.addErrorMessage(extend, "协同设置分录【协同占比】汇总值必须等于100%");
        }
    }
}
