package tpv.tmc.lc.java.opplugin.validator;


import kd.bos.entity.validate.AbstractValidator;

import java.util.Arrays;


/**
 *@Description: 【即期/远期】=“混合”时，判断{即期远期列表}分录必须存在一条数据
 *@Project: zhck
 *@Package: tpv.tmc.lc.java.opplugin.validator.EntryExistenceSubmitValidator
 *@Date: 2024/04/28 18:17
 *@Author: Heisenberg Wenbei He
 *@Version: 1.0
 */
public class EntryExistenceSubmitValidator extends AbstractValidator {

    private static final String WARNING_MESSAGE = "【即期/远期】=“混合”时，{即期远期列表}分至少存在一条数据！";

    @Override
    public void validate() {
        if (!"submit".equals(this.getOperateKey())) {
            return;
        }
        String sign = "";
        switch (this.getEntityKey()) {
            case "lc_bizapply":
            case "lc_lettercredit":
                sign = "tpv_lettercty";
                break;
            case "lc_receipt":
                sign = "tpv_credittype";
                break;
            default:
                break;
        }
        if (!sign.isEmpty()) {
            this.judge(sign, "tpv_spotforward");
        }
    }

    private void judge(String sign, String tpvSpotforward) {
        Arrays.stream(this.getDataEntities())
                .filter(single -> "D".equals(single.getValue(sign)))
                .filter(single -> single.getDataEntity().getDynamicObjectCollection(tpvSpotforward).size() == 0)
                .forEach(single -> this.addMessage(single, WARNING_MESSAGE));
    }
}
