package tpv.tmc.lc.java.opplugin.validator;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 *@Description: 是否被开证处理引用
 *@Project: zhck
 *@Package: tpv.tmc.lc.java.opplugin.validator.ReferenceShutDownValidator
 *@Date: 2024/04/22 11:18
 *@Author: Heisenberg Wenbei He
 *@Version: 1.0
 */
public class ReferenceShutDownValidator extends AbstractValidator {
    @Override
    public void validate() {
        DynamicObject[] load = BusinessDataServiceHelper.load("lc_bizapply", "tpv_modifybill,biztype,billstatus"
                , new QFilter[]{new QFilter("biztype", "=", "edit_card")
                        , new QFilter("billstatus", "=", "C")});
        List<Object> list = Arrays.stream(load)
                .filter(single -> single.getDynamicObject("tpv_modifybill") != null)
                .map(single -> single.getDynamicObject("tpv_modifybill").getPkValue())
                .collect(Collectors.toList());
        Arrays.stream(this.getDataEntities())
                .filter(single -> list.contains(single.getBillPkId()))
                .forEach(single -> this.addMessage(single, "只能关闭未被改证处理选择过的改证申请单据！"));
        Arrays.stream(this.getDataEntities())
                .filter(single -> !list.contains(
                        single.getBillPkId()))
                .forEach(single -> this.addWarningMessage(single, "是否确认关闭？"));
    }
}
