package tpv.tmc.lc.java.opplugin.validator;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @ClassName: ReferenceUnauditValidator
 * @Description: 是否被开证处理引用
 * @author: zbh
 * @date: 2024-04-23
 */
public class ReferenceUnauditValidator extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("biztype");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        DynamicObject[] entities = e.getDataEntities();
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() {
                ExtendedDataEntity[] bills = this.getDataEntities();
                String key = this.getOperateKey();
                for (int i = 0; i < bills.length; i++) {
                    switch (key) {
                        case "unaudit":
                            synergySup(bills[i]);
                            break;
                        default:
                            break;
                    }
                }
            }


            private void synergySup(ExtendedDataEntity extendedDataEntity) {
                DynamicObject dataEntity = extendedDataEntity.getDataEntity();
                String biztype = dataEntity.getString("biztype");
                if (!"edit_card".equals(biztype)) {
                    return;
                }
                DynamicObject[] load = BusinessDataServiceHelper.load("lc_bizapply", "tpv_modifybill,biztype,billstatus"
                        , new QFilter[]{new QFilter("biztype", "=", "edit_card")
                                , new QFilter("billstatus", "=", "C"), new QFilter("tpv_isnot", "=", true)});
                if (load.length != 0) {
                    this.addMessage(extendedDataEntity, "只能反审核未被改证处理选择过的改证申请单据！");
                }
            }
        });
    }
}
