package tpv.tmc.lc.java.utils;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.*;

/**
 *@Description: 更新额度预约状态
 *@Project: zhck
 *@Package: tpv.tmc.lc.java.utils.CreditLimitHelper
 *@Date: 2024/04/18 16:15
 *@Author: Heisenberg Wenbei He
 *@Version: 1.0
 */
public class CreditLimitHelper {

    private CreditLimitHelper() {
        // private constructor to prevent instantiation
    }

    /**
     * @param e:
     * @param flag: true 对应 保存、提交，flase 对应删除操作
     * @author: Heisenberg
     * @date: 2024/4/18 下午4:18
     * @description: 开证申请  保存 、提交、删除 后 ，更新对应 额度预约单状态
     */
    public static void updateCreditLimit(AfterOperationArgs e, boolean flag) {
        List<DynamicObject> list = new ArrayList<>();
        Arrays.stream(e.getDataEntities())
                .map(single -> single.getDynamicObject("tpv_quotaforms"))
                .filter(Objects::nonNull)
                .map(single -> BusinessDataServiceHelper.loadSingle
                        (single.getPkValue(), "shkd_creditsubscribe"))
                .filter(Objects::nonNull)
                .forEach(single -> {
                    single.set("shkd_beginend", flag);
                    single.set("shkd_beginenddate", flag ? new Date() : null);
                    list.add(single);
                });
        SaveServiceHelper.save(list.toArray(new DynamicObject[0]));
    }
}
