package tpv.tpv_wm.tpv_cm.java.formplugin.dynamic;

import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.data.BusinessDataReader;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.IRefrencedataProvider;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.operate.botp.Push;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.permission.PermissionServiceHelper;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @ClassName: AltimeterBenchEdit
 * @Description: 高低计核销工作台
 * @date: 2023/11/14 16:01
 * @author: Guo jiaChen
 */
public class AltimeterBenchEdit extends AbstractFormPlugin implements BeforeF7SelectListener {
    private final String algoKey = this.getClass().getName();
    private final String ENTRY_KEY = "tpv_circulationgoodentity";//分录标识


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        // 侦听文本字段按钮点击事件
        this.addClickListeners("tpv_createdxform", "tpv_createkpform", "tpv_createzjform", "tpv_createwyform", "tpv_query");
        EntryGrid entryGrid = this.getView().getControl("tpv_circulationgoodentity");
        BasedataEdit tpv_muldepartment = this.getView().getControl("tpv_muldepartment");//部门
        tpv_muldepartment.addBeforeF7SelectListener(this);
    }


    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_muldepartment"://部门
                PersonnelDepUtils.departmentF(e);
                break;
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        PersonnelDepUtils.departmentDef(this.getModel(), "tpv_muldepartment");
        query();
    }


    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control source = (Control) evt.getSource();
        String key = source.getKey();
        String type = "";
        switch (key) {
            case "tpv_query":
                query();
                break;
            case "tpv_createdxform":
                if (validator()) {
                    type = "A";
                    push(type);
                }
                break;
            case "tpv_createkpform":
                if (validator()) {
                    type = "B";
                    push(type);
                }
                break;
            case "tpv_createzjform":
                if (validator()) {
                    type = "C";
                    push(type);
                }
                break;
            case "tpv_createwyform":
                if (validator()) {
                    type = "D";
                    push(type);
                }
                break;
            default:
                break;
        }

    }

    /**
     * @param type:
     * @author: chen
     * @date: 2023/11/18 22:48
     * @description: 下推
     */

    private void push(String type) {
        DynamicObjectCollection entryEntity = this.getModel().getEntryEntity(ENTRY_KEY);
        DynamicObjectCollection entryEntities = new DynamicObjectCollection();
        EntryGrid control = this.getControl(ENTRY_KEY);
        int[] selectRows = control.getSelectRows();
        ArrayList<Integer> integers = new ArrayList<>();
        String company = null;
        String settleAccount = null;
        String currency = null;

        for (int i = 0; i < selectRows.length; i++) {
            DynamicObject object = entryEntity.get(selectRows[i]);
            entryEntities.add(object);
            if (i == 0) {
                DynamicObject settlecus = object.getDynamicObject("tpv_settlecus");//结算方
                DynamicObject firm = object.getDynamicObject("tpv_firm");//公司
                DynamicObject currency1 = object.getDynamicObject("tpv_currency");//币别
                if (null != settlecus) {
                    settleAccount = settlecus.getPkValue().toString();
                }
                if (null != firm) {
                    company = firm.getPkValue().toString();
                }
                if (null != currency1) {
                    currency = currency1.getPkValue().toString();
                }
            }
        }


        List<ListSelectedRow> selectedRows = new ArrayList<>();//设置需要下推的单据，或分录行
        if (entryEntity != null) {
            for (DynamicObject row : entryEntities) {
                ListSelectedRow listSelectedRow = new ListSelectedRow(row.getLong("tpv_sourcebillno"));//单据id
                listSelectedRow.setEntryEntityKey("tpv_advconap");
                listSelectedRow.setEntryPrimaryKeyValue(row.getLong("tpv_srcentryid"));
                selectedRows.add(listSelectedRow);
            }
        }
        //数据校验通过后下推
        if (entryValidity()) {
            IFormView view = this.getView();
            // 创建下推参数
            PushArgs pushArgs = new PushArgs();
            // 源单标识，必填
            pushArgs.setSourceEntityNumber("tpv_cm_uneven");
            // 目标单据标识，必填
            pushArgs.setTargetEntityNumber("tpv_cm_altverification");
            pushArgs.addCustomParam("type", type);
            pushArgs.addCustomParam("settleAccount", settleAccount);
            pushArgs.addCustomParam("company", company);
            pushArgs.addCustomParam("currency", currency);

            // 生成转换结果报告，必填
            pushArgs.setBuildConvReport(true);
            //传入下推使用的转换规则id，不填则使用默认规则
            pushArgs.setRuleId("1822568071814976512");//1822568071814976512
            //下推默认保存，必填
            pushArgs.setAutoSave(false);
            // 设置源单选中的数据包，必填
            pushArgs.setSelectedRows(selectedRows);
            // 执行下推操作
            ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
            //获取下推目标单id
            Set<Object> targetBillIds = pushResult.getTargetBillIds();
            if (pushResult.isSuccess()) {
                // 获取生成的目标单数据包
                MainEntityType targetMainType = EntityMetadataCache.getDataEntityType("tpv_cm_altverification");
                List<DynamicObject> targetBillObjs = pushResult.loadTargetDataObjects(new IRefrencedataProvider() {
                    @Override
                    public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                        BusinessDataReader.loadRefence(objs, dType);
                    }
                }, targetMainType);
                if (targetBillObjs.size() > 0) {
                    DynamicObject targetBillObj = targetBillObjs.get(0);
                    targetBillObj.set("tpv_verificationtype", type);
                }
                Push.showTargetBill(view, pushArgs, pushResult, false);
            } else {
                Push.showReport(view, pushArgs, pushResult);
            }
        }
    }

    /**
     * @param :
     * @return boolean
     * @author: chen
     * @date: 2023/11/18 22:52
     * @description: 下推数据合法性校验
     */
    private boolean entryValidity() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        EntryGrid entry = view.getControl(ENTRY_KEY);//获取分录控件
        int[] selectRows = entry.getSelectRows();
        List<Integer> selectIndex = Arrays.stream(selectRows).boxed().collect(Collectors.toList());
        if (selectRows.length == 0) {
            view.showTipNotification("请至少选则一条数据进行下推!");
            return false;
        } else {
            Long customerIDs = 0L;
            String highOrLows = "";
            DynamicObjectCollection entity = model.getEntryEntity(ENTRY_KEY);
            for (int i = 0; i < entity.size(); i++) {
                if (selectIndex.contains(i)) {
                    DynamicObject entryRow = entity.get(i);
                    DynamicObject customer = (DynamicObject) entryRow.get("tpv_settlecus");//客户
                    Long customerID = 0L;
                    if (customer != null) {
                        customerID = customer.getLong("id");
                    }
                    String highOrLow = (String) entryRow.get("tpv_highorlow");//高低计
                    if (!highOrLows.isEmpty() && (!customerIDs.equals(customerID) || !highOrLows.equals(highOrLow))) {
                        view.showTipNotification("所选数据的结算方和对应的高低计类型必须一致!");
                        return false;
                    } else {
                        customerIDs = customerID;
                        highOrLows = highOrLow;
                    }
                }
            }
        }
        return true;
    }

    /**
     * @author: chen
     * @date: 2023/11/18 22:54
     * @description: 根据过滤条件查询
     */
    private void query() {
        IDataModel model = this.getModel();
        model.deleteEntryData(ENTRY_KEY);
        ArrayList<QFilter> filters = new ArrayList<>();
        filters.add(new QFilter("billstatus", QCP.equals, "C"));//已生效
        DynamicObject customer = (DynamicObject) model.getValue("tpv_customer");
        DynamicObject department = (DynamicObject) model.getValue("tpv_department");
        DynamicObject company = (DynamicObject) model.getValue("tpv_company");
        DynamicObject saleNum = (DynamicObject) model.getValue("tpv_salenum");//销售合同号
        DynamicObject purchaseNum = (DynamicObject) model.getValue("tpv_purchasenum");//采购合同号
        Date startDate = (Date) model.getValue("tpv_begindate");//起始日期
        Date endDate = (Date) model.getValue("tpv_enddate");//截至日期
        String tpvUneven = (String) model.getValue("tpv_uneven");//高低计单号
        if (null != customer) {
            long supID = customer.getLong("id");//
            filters.add(new QFilter("tpv_cleariparty", QCP.equals, supID));//客户
        }
        if (null != company) {
            long supID = company.getLong("id");//
            filters.add(new QFilter("tpv_advconap.tpv_firm", QCP.equals, supID));//公司
        }
        if (null != department) {
            long supID = department.getLong("id");
            filters.add(new QFilter("tpv_advconap.tpv_departmet", QCP.equals, supID));//部门
        }
        if (null != saleNum) {
            long saleNumLong = saleNum.getLong("id");
            filters.add(new QFilter("tpv_advconap.tpv_saleconums", QCP.equals, saleNumLong));//销售合同号
        }
        if (null != purchaseNum) {
            long purchaseNumLong = purchaseNum.getLong("id");
            filters.add(new QFilter("tpv_advconap.tpv_purconums", QCP.equals, purchaseNumLong));//采购合同号
        }
        if (null != startDate) {
            filters.add(new QFilter("tpv_bizdated", QCP.large_equals, DateUtil.getStartOfDay(startDate)));//结算日期起始
        }
        if (null != endDate) {
            filters.add(new QFilter("tpv_bizdated", QCP.less_equals, DateUtil.getEndOfDay(endDate)));//结算日期截至
        }
        if (YEM.isNotEmpty(tpvUneven)) {
            filters.add(new QFilter("billno", QCP.ftlike, "%" + tpvUneven + "%"));
        }
        QFilter qFilter = PersonnelDepUtils.departmentQFilter(model, "tpv_muldepartment", "tpv_advconap.tpv_departmet");
        if (qFilter!=null){
            filters.add(qFilter);
        }
        DataSet queryDataSet = ORM.create().queryDataSet(algoKey, "tpv_cm_uneven",
                "id,billno,billstatus,tpv_cleariparty,tpv_unevened,tpv_advconap,tpv_bizdated,tpv_currency" +
                        ",tpv_advconap.tpv_saleconums,tpv_advconap.tpv_purconums,tpv_advconap.tpv_businesstype,tpv_advconap.tpv_vatrates,tpv_advconap.tpv_isquantitys" +
                        ",tpv_advconap.tpv_itemcodes,tpv_advconap.tpv_conprodname,tpv_advconap.tpv_taxamounts,tpv_advconap.tpv_amountincrea,tpv_advconap.tpv_notaxamounts" +
                        ",tpv_advconap.tpv_departmet,tpv_advconap.tpv_cancelqtys,tpv_advconap.tpv_crew,tpv_advconap.tpv_firm,tpv_clearparty,tpv_advconap.tpv_unwtax" +
                        ",tpv_advconap.tpv_origin.name tpv_origin,tpv_advconap.tpv_shader tpv_shader,tpv_advconap.tpv_specation tpv_specation,tpv_advconap.tpv_unw tpv_amouni" +
                        ",tpv_advconap.tpv_tradepropertys tpv_tradepropertys"
                , filters.toArray(new QFilter[0]));
        DataSet selected = queryDataSet.select("id", "billno", "tpv_cleariparty", "tpv_unevened", "tpv_bizdated", "tpv_currency", "tpv_advconap.tpv_saleconums saleconum", "tpv_advconap srcEntryId"
                , "tpv_advconap.tpv_purconums purconum", "tpv_advconap.tpv_businesstype businesstype", "tpv_advconap.tpv_itemcodes itemcodes", "tpv_advconap.tpv_vatrates vatrates"
                , "tpv_advconap.tpv_conprodname conprodname", "tpv_advconap.tpv_taxamounts taxamounts", "tpv_advconap.tpv_amountincrea amountincrea", "tpv_advconap.tpv_isquantitys isquantitys"
                , "tpv_advconap.tpv_notaxamounts notaxamounts", "tpv_advconap.tpv_cancelqtys cancelqtys", "tpv_advconap.tpv_unwtax unwrittenqtys", "tpv_advconap.tpv_departmet departmet"
                , "tpv_advconap.tpv_crew crew", "tpv_advconap.tpv_firm firm", "tpv_clearparty", "tpv_specation", "tpv_shader", "tpv_origin","tpv_amouni","tpv_tradepropertys");

        for (Row row : selected) {
            int i = this.getModel().createNewEntryRow(ENTRY_KEY);
            BigDecimal taxAmounts = row.getBigDecimal("taxamounts");
            model.setValue("tpv_altimeternum", row.getString("billno"), i);//销售合同号
            model.setValue("tpv_salenums", row.getLong("saleconum"), i);//采购合同号
            model.setValue("tpv_purconnum", row.getLong("purconum"), i);//采购合同号
            model.setValue("tpv_highorlow", row.getString("tpv_unevened"), i);//高计/低计
            model.setValue("tpv_deadline", row.getDate("tpv_bizdated"), i);//结算日期
            model.setValue("tpv_settlenum", row.getBigDecimal("isquantitys"), i);//结算数量
            model.setValue("tpv_currency", row.getLong("tpv_currency"), i);//币别
            model.setValue("tpv_material", row.getLong("itemcodes"), i);//商品编码
            model.setValue("tpv_businesstypes", row.getString("businesstype"), i);//业务类型
            model.setValue("tpv_prodname", row.getLong("conprodname"), i);//品名
            model.setValue("tpv_amounttax", taxAmounts, i);//含税金额
            model.setValue("tpv_intaxrate", row.getBigDecimal("vatrates"), i);//增值税率
            model.setValue("tpv_amountintax", row.getBigDecimal("amountincrea"), i);//增值税额
            model.setValue("tpv_amountnotax", row.getBigDecimal("notaxamounts"), i);//不含税金额
            model.setValue("tpv_amountverificate", row.getBigDecimal("cancelqtys"), i);//核销金额
            model.setValue("tpv_amounificate", row.getBigDecimal("unwrittenqtys"), i);//未核销金额
            model.setValue("tpv_amouni", row.getBigDecimal("tpv_amouni"), i);//未核销金额（不含税）
            model.setValue("tpv_dept", row.getLong("departmet"), i);//部门
            model.setValue("tpv_user", row.getLong("crew"), i);//人员
            model.setValue("tpv_firm", row.getLong("firm"), i);//公司
            model.setValue("tpv_srcentryid", row.getLong("srcEntryId"), i);//来源分录id
            model.setValue("tpv_sourcebillno", row.getLong("id"), i);//来源单据id
            model.setValue("tpv_clearparty", row.get("tpv_clearparty"), i);//结算方类型
            model.setValue("tpv_tradepropertys", row.get("tpv_tradepropertys"), i);//结算方类型
            if (!"".equals(row.getString("tpv_clearparty"))) {
                model.setValue("tpv_cleariparty", row.get("tpv_cleariparty"), i);//结算方
            }
            String tpvOrigin = row.getString("tpv_origin");
            String tpvShader = row.getString("tpv_shader");
            String tpvSpecation = row.getString("tpv_specation");
            StringBuilder builder = new StringBuilder();
            if (YEM.isNotEmpty(tpvOrigin)){
                stringBuilder(builder, tpvOrigin);
            }
            if (YEM.isNotEmpty(tpvShader)){
                stringBuilder(builder, tpvShader);
            }
            if (YEM.isNotEmpty(tpvSpecation)){
                stringBuilder(builder, tpvSpecation);
            }
            model.setValue("tpv_description", builder, i);//结算方
        }
        this.getView().updateView(ENTRY_KEY);
    }


    public Boolean validator() {
        EntryGrid entryGridHt = this.getControl("tpv_circulationgoodentity");//商品明细
        int[] selectRowsHt = entryGridHt.getSelectRows();//高低计明细分录
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvCirculationgoodentity = dataEntity.getDynamicObjectCollection("tpv_circulationgoodentity");
        for (int row : selectRowsHt) {
            DynamicObject tpvFirm = tpvCirculationgoodentity.get(row).getDynamicObject("tpv_firm");//公司
            DynamicObject tpvDept = tpvCirculationgoodentity.get(row).getDynamicObject("tpv_dept");//部门
            DynamicObject tpvCurrency = tpvCirculationgoodentity.get(row).getDynamicObject("tpv_currency");//币种
            DynamicObject tpvSettlecus = tpvCirculationgoodentity.get(row).getDynamicObject("tpv_settlecus");//结算方
            String tpvClearparty = tpvCirculationgoodentity.get(row).getString("tpv_clearparty");//结算方类型
            for (int select : selectRowsHt) {
                StringBuilder builderNum = new StringBuilder();
                DynamicObject firm = tpvCirculationgoodentity.get(select).getDynamicObject("tpv_firm");//公司
                DynamicObject dept = tpvCirculationgoodentity.get(select).getDynamicObject("tpv_dept");//部门
                DynamicObject currency = tpvCirculationgoodentity.get(select).getDynamicObject("tpv_currency");//币种
                DynamicObject settlecus = tpvCirculationgoodentity.get(select).getDynamicObject("tpv_settlecus");//结算方
                String cearparty = tpvCirculationgoodentity.get(row).getString("tpv_clearparty");
                if (tpvFirm != firm) {
                    stringBuilder(builderNum, "公司");
                }
                if (tpvDept != dept) {
                    stringBuilder(builderNum, "部门");
                }
                if (currency != tpvCurrency) {
                    stringBuilder(builderNum, "币种");
                }
                if (!tpvClearparty.equals(cearparty)) {
                    stringBuilder(builderNum, "结算方类型");
                }
                if (tpvSettlecus != settlecus) {
                    stringBuilder(builderNum, "结算方");
                }
                if (builderNum.length() != 0) {
                    this.getView().showTipNotification(builderNum + "不同不允许合并生成！");
                    return false;
                }

            }
        }
        return true;
    }

    public void stringBuilder(StringBuilder stringBuilder, String basePrice) {
        if (stringBuilder.length() == 0) {
            stringBuilder.append(basePrice);
        } else {
            stringBuilder.append("，" + basePrice);
        }
    }
}
