package tpv.tpv_wm.tpv_cm.java.formplugin.dynamic;

import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.math.BigDecimal;
import java.util.*;

/**
 * 合同明细（销售）
 *
 * @author LiuHB
 * @version 1.0
 */
public class ContractgoodxsEdit extends AbstractFormPlugin {
    private static final String contractenxs = "tpv_contractenxs";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        addClickListeners("btnok", "btncancel");
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control c = (Control) evt.getSource();
        String key = c.getKey().toLowerCase();
        this.getModel().getDataEntity(true);

        switch (key) {
            case "btnok"://点击确认按钮
                returnmessage();
                this.getView().close();
                break;
            case "btncancel"://点击取消按钮
                this.getView().close();
                break;
        }

    }

    /**
     * 返回到单据的信息
     */
    public void returnmessage() {
        List<Map<String, Object>> list = new ArrayList<>();
        DynamicObjectCollection tpvAdvconap = this.getModel().getEntryEntity("tpv_contractenxs");
        int index = this.getModel().getEntryCurrentRowIndex("tpv_contractenxs");
        DynamicObject selectedData = this.getModel().getEntryRowEntity("tpv_contractenxs", index);
        HashMap<String, Object> hashMap = new HashMap<>();
        long tpvItemcodesid = 0L;
        long tpvTradepropertysid = 0L;
        long tpvConprodnameid = 0L;
        long tpvDepartmetid = 0L;
        long tpvFirmid = 0L;
        long tpvCrewid = 0L;
        long saleconum = 0L;
        long origin = 0L;
        long unit = 0L;
        DynamicObject saleconumid = null;
        BigDecimal tpvIsquantitys = BigDecimal.ZERO;
        BigDecimal tpvTaxamounts = BigDecimal.ZERO;
        BigDecimal tpvAmountincrea = BigDecimal.ZERO;
        BigDecimal tpvNotaxamounts = BigDecimal.ZERO;
        BigDecimal tpvVatrates = BigDecimal.ZERO;
        Long tpvEntryid = 0L;
        DynamicObject tpvItemcodes = selectedData.getDynamicObject("tpv_itemcodes");//物料编码
        if (tpvItemcodes != null) {
            tpvItemcodesid = tpvItemcodes.getLong("id");
        }
        DynamicObject tpvTradepropertys = selectedData.getDynamicObject("tpv_tradepropertys");
        if (tpvTradepropertys != null) {
            tpvTradepropertysid = tpvTradepropertys.getLong("id");//贸易性质
        }
        DynamicObject tpvConprodname = selectedData.getDynamicObject("tpv_conprodname");
        if (tpvConprodname != null) {
            tpvConprodnameid = tpvConprodname.getLong("id");
        }
        DynamicObject tpvDepartmet = selectedData.getDynamicObject("tpv_departmet");
        if (tpvDepartmet != null) {
            tpvDepartmetid = tpvDepartmet.getLong("id");
        }
        DynamicObject tpvFirm = selectedData.getDynamicObject("tpv_firm");
        if (tpvFirm != null) {
            tpvFirmid = tpvFirm.getLong("id");
        }
        DynamicObject tpvCrew = selectedData.getDynamicObject("tpv_crew");
        if (tpvCrew != null) {
            tpvCrewid = tpvCrew.getLong("id");
        }
        tpvEntryid = selectedData.getLong("tpv_entryid");

        saleconumid = selectedData.getDynamicObject("tpv_saleconum");
        if (saleconumid != null) {
            saleconum = saleconumid.getLong("id");
        }
        DynamicObject tpvOrigin = selectedData.getDynamicObject("tpv_origin");
        if (tpvOrigin!=null){
            origin=tpvOrigin.getLong("id");
        }
        DynamicObject tpvUnit = selectedData.getDynamicObject("tpv_unit");
        if (tpvUnit!=null){
            unit=tpvUnit.getLong("id");
        }
        tpvIsquantitys = selectedData.getBigDecimal("tpv_isquantitys");
        tpvTaxamounts = selectedData.getBigDecimal("tpv_taxamounts");
        tpvAmountincrea = selectedData.getBigDecimal("tpv_amountincrea");
        tpvNotaxamounts = selectedData.getBigDecimal("tpv_notaxamounts");
        tpvVatrates = selectedData.getBigDecimal("tpv_vatrates");

        hashMap.put("tpv_itemcodes", tpvItemcodesid);
        hashMap.put("tpv_tradepropertys", tpvTradepropertysid);
        hashMap.put("tpv_conprodname", tpvConprodnameid);
        hashMap.put("tpv_departmet", tpvDepartmetid);
        hashMap.put("tpv_firm", tpvFirmid);
        hashMap.put("tpv_crew", tpvCrewid);
        hashMap.put("tpv_saleconum", saleconum);
        hashMap.put("tpv_isquantitys", tpvIsquantitys);
        hashMap.put("tpv_taxamounts", tpvTaxamounts);
        hashMap.put("tpv_amountincrea", tpvAmountincrea);
        hashMap.put("tpv_notaxamounts", tpvNotaxamounts);
        hashMap.put("tpv_vatrates", tpvVatrates);
        hashMap.put("tpv_entryid", tpvEntryid);
        hashMap.put("tpv_origin",origin);
        hashMap.put("tpv_shader",selectedData.getString("tpv_shader"));
        hashMap.put("tpv_specation",selectedData.getString("tpv_specation"));
        hashMap.put("tpv_unit",unit);
        list.add(hashMap);

        this.getView().returnDataToParent(list);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = showParameter.getCustomParams();
        List<Long> entryid = (List) maps.get("tpv_entryid");
        initData(entryid);
    }

    private void initData(List<Long> entryid) {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        IDataModel parentModel = view.getParentView().getModel();
        DynamicObject tpvCompany = (DynamicObject) parentModel.getValue("tpv_company");//公司
        DynamicObject tpvDepartment = (DynamicObject) parentModel.getValue("tpv_department");//部门

        ArrayList<QFilter> filters = new ArrayList<>();
        filters.add(new QFilter("billstatus", QCP.equals, "C"));//已审核
        filters.add(new QFilter("tpv_materialentry.id", QCP.not_in, entryid));
        if (tpvCompany != null) {
            filters.add(new QFilter("tpv_company", QCP.equals, tpvCompany.getPkValue()));
        }
        if (tpvDepartment != null) {
            filters.add(new QFilter("tpv_department", QCP.equals, tpvDepartment.getPkValue()));
        }
        DataSet queryDataSet = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_salescontract", "id,billno,billstatus,tpv_materialentry,tpv_materialentry.id" +
                ",tpv_materialentry.tpv_material,tpv_materialentry.tpv_prodname,tpv_materialentry.tpv_qty,tpv_materialentry.tpv_taxpramount," +
                "tpv_materialentry.tpv_vatrates,tpv_materialentry.tpv_vatmoney,tpv_materialentry.tpv_nottaxamount," +
                "tpv_contractnos,org,tpv_department,tpv_operator,tpv_tradeproperty,tpv_materialentry.tpv_origin,tpv_materialentry.tpv_shader,tpv_materialentry.tpv_specation,tpv_materialentry.tpv_unit tpv_unit", filters.toArray(new QFilter[0]));
        DataSet selected = queryDataSet.select
                ("id", "billno", "tpv_contractnos contractnos", "org",
                        "tpv_department department", "tpv_operator operator", "tpv_materialentry entry", "tpv_materialentry.tpv_qty qty", "tpv_materialentry.tpv_taxpramount taxpramount",
                        "tpv_materialentry.tpv_vatrates vatrates", "tpv_materialentry.tpv_vatmoney vatmoney", "tpv_materialentry.tpv_nottaxamount nottaxamount",
                        "tpv_tradeproperty tradeproperty", "tpv_materialentry.tpv_material material", "tpv_materialentry.id entryID",
                        "tpv_materialentry.tpv_prodname prodname", "tpv_materialentry.tpv_origin tpv_origin", "tpv_materialentry.tpv_shader tpv_shader", "tpv_materialentry.tpv_specation tpv_specation",
                        "tpv_unit");
        selected.print(true);
        if (selected.isEmpty()) {
            this.getModel().deleteEntryData(contractenxs);
            return;
        }
        this.getModel().deleteEntryData(contractenxs);
        setInvoiceData(selected);

    }

    /**
     * 获取单据数据填值
     *
     * @param queryDataSet
     */
    private void setInvoiceData(DataSet queryDataSet) {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        IDataModel parentModel = view.getParentView().getModel();
        Long id = (Long) parentModel.getDataEntity().getPkValue();
        DynamicObjectCollection entity = model.getEntryEntity(contractenxs);
        for (Row row : queryDataSet) {
            int i = this.getModel().createNewEntryRow(contractenxs);
            String entryID = row.getString("entry");//商品明细分录
            model.setValue("tpv_entryid", row.getLong("entryID"), i);//分录id
            model.setValue("tpv_departmet", row.getLong("department"), i);//部门
            model.setValue("tpv_saleconum", row.getString("id"), i);//合同号
            model.setValue("tpv_firm", row.getLong("org"), i);//公司
            model.setValue("tpv_crew", row.getLong("operator"), i);//业务员
            model.setValue("tpv_tradepropertys", row.getLong("tradeproperty"), i);//贸易类型
            model.setValue("tpv_itemcodes", row.getLong("material"), i);//物料编码
            model.setValue("tpv_conprodname", row.getLong("prodname"), i);//品名
            model.setValue("tpv_isquantitys", row.getLong("qty"), i);//数量
            model.setValue("tpv_taxamounts", row.getLong("taxpramount"), i);//含税金额
            model.setValue("tpv_amountincrea", row.getLong("vatmoney"), i);//增值税额
            model.setValue("tpv_vatrates", row.getLong("vatrates"), i);//增值税率
            model.setValue("tpv_notaxamounts", row.getLong("nottaxamount"), i);//不含税金额
            model.setValue("tpv_origin", row.get("tpv_origin"), i);//产地
            model.setValue("tpv_shader", row.get("tpv_shader"), i);//材质
            model.setValue("tpv_specation", row.get("tpv_specation"), i);//规格
            model.setValue("tpv_unit", row.get("tpv_unit"), i);//计量单位

        }
        this.getView().updateView(contractenxs);
    }
}