package tpv.tpv_wm.tpv_cm.java.formplugin.dynamic;


import com.itopview.wm.cm.report.PlacemenRptQuery;
import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.RptUtil;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.math.BigDecimal;
import java.util.*;

import static kd.macc.aca.algox.costcalc.action.AbstractActSingleCheckAction.algoKey;


/**
 * 串拣配成本置换工作台-表单插件
 *
 * @author WangShuGuang
 * @description
 * @date 2023年11月17日
 */
public class InseriesreFormPlugin extends AbstractFormPlugin implements RowClickEventListener {

    private static final String entryKey_1 = "tpv_entryentity";


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");//商品明细
        this.addItemClickListeners("tpv_toolbarap");
        entryGrid.addRowClickListener(this);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        initData();
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        //
        super.itemClick(evt);
        String key = evt.getItemKey();
        if (StringUtils.equals("tpv_select", key)) {
            initData();
        }
        if (StringUtils.equals("tpv_costfunction", key)) {
            costFunction();
        }
    }

    /**
     * +成本置换功能
     */
    private void costFunction() {
        //获取单据体控件
        EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");
        //获取选中行，数组为行号，从0开始int[]
        int selectRows[] = entryGrid.getSelectRows();
        DynamicObjectCollection tpvEntryentity = this.getModel().getEntryEntity("tpv_entryentity");
        List<DynamicObject> advocateDate = new ArrayList<>();//主数据
        List<Long> comBination = new ArrayList<>();//组合号
        List<Long> distriButioncombinati = new ArrayList<>();//配货组合号
        List<BigDecimal> qty = new ArrayList<>();
        for (int selectRow : selectRows) {
            DynamicObject dynamicObject = tpvEntryentity.get(selectRow);
            qty.add(dynamicObject.getBigDecimal("tpv_qty"));
            advocateDate.add(dynamicObject);
            DynamicObject tpvCombination = dynamicObject.getDynamicObject("tpv_combination");
            comBination.add(tpvCombination.getLong("id"));//组合号
            DynamicObject tpvDistributioncombinati = dynamicObject.getDynamicObject("tpv_distributioncombinati");
            distriButioncombinati.add(tpvDistributioncombinati.getLong("id"));//配货组合号
        }
        //拿到最小数量
        BigDecimal minValue = Collections.min(qty);
        //判断list中是否存在重复数据
        boolean hasDuplicates = hasDuplicates(comBination);
        boolean distriBut = hasDuplicates(distriButioncombinati);
        if (!hasDuplicates && !distriBut){
            //判断两个组合号数据是否闭环
            boolean isSame = isListEqual(comBination, distriButioncombinati);
            if (isSame){
                //新增串拣配成本置换单
                DynamicObject costrePlacement = BusinessDataServiceHelper.newDynamicObject("tpv_cm_costreplacement");
                long currentUserId = UserServiceHelper.getCurrentUserId();
                Long mainOrgld = UserServiceHelper.getUserMainOrgId(currentUserId);
                costrePlacement.set("org",mainOrgld);//公司
                costrePlacement.set("tpv_company",mainOrgld);//公司
                Date currentDate = new Date();
                costrePlacement.set("tpv_bizdate",currentDate);//业务日期
                costrePlacement.set("billstatus","A");//单据状态
                DynamicObjectCollection entryEntity = costrePlacement.getDynamicObjectCollection("tpv_materialentry");
                for (DynamicObject dynamicObject : advocateDate) {
                    DynamicObject addNew = entryEntity.addNew();
                    addNew.set("tpv_companys",dynamicObject.getDynamicObject("tpv_company"));//公司
                    addNew.set("tpv_departments",dynamicObject.getDynamicObject("tpv_department"));//部门
                    addNew.set("tpv_salesman",dynamicObject.getDynamicObject("tpv_salesman"));//业务员
                    addNew.set("tpv_delivergoodsid",dynamicObject.getString("tpv_delivergoodsid"));//销售发货单拣配库存子分录id
                    addNew.set("tpv_shipments",dynamicObject.getString("tpv_shipments"));//销售发货单号
                    addNew.set("tpv_salescontract",dynamicObject.getString("tpv_salescontract"));//销售合同
                    addNew.set("tpv_correspondent",dynamicObject.getDynamicObject("tpv_correspondent"));//客户
                    addNew.set("tpv_combination",dynamicObject.getDynamicObject("tpv_combination"));//组合号
                    addNew.set("tpv_strategy",dynamicObject.getDynamicObject("tpv_strategy"));//策略号
                    addNew.set("tpv_tradenature",dynamicObject.getDynamicObject("tpv_tradenature"));//贸易性质
                    addNew.set("tpv_prodname",dynamicObject.getDynamicObject("tpv_prodname"));//品名
                    addNew.set("tpv_material",dynamicObject.getDynamicObject("tpv_material"));//商品编码
                    addNew.set("tpv_specation",dynamicObject.getString("tpv_specation"));//规格
                    addNew.set("tpv_shader",dynamicObject.getString("tpv_shader"));//材质
                    addNew.set("tpv_origin",dynamicObject.getDynamicObject("tpv_origin"));//产地
                    addNew.set("tpv_unit",dynamicObject.getDynamicObject("tpv_ofmeasure"));//计量单位
                    addNew.set("tpv_qty",minValue);//数量
                    addNew.set("tpv_volumenumber",dynamicObject.getString("tpv_volumenumber"));//卷号
                    addNew.set("tpv_pickbill",dynamicObject.getString("tpv_pickbill"));//配货单据
                    addNew.set("tpv_billno",dynamicObject.getString("tpv_billno"));//配货单据编号
                    addNew.set("tpv_fentryid",dynamicObject.getLong("tpv_fentryid"));//配货单据分录id
                    addNew.set("tpv_distribution",dynamicObject.getDynamicObject("tpv_distribution"));//配货部门
                    addNew.set("tpv_supplier",dynamicObject.getDynamicObject("tpv_supplier"));//配货供应商
                    addNew.set("tpv_distributionnature",dynamicObject.getDynamicObject("tpv_distributionnature"));//配货贸易性质
                    addNew.set("tpv_contractdistribution",dynamicObject.getString("tpv_contractdistribution"));//配货合同号
                    addNew.set("tpv_distributioncombinati",dynamicObject.getDynamicObject("tpv_distributioncombinati"));//配货组合号
                    addNew.set("tpv_distributionstrategy",dynamicObject.getDynamicObject("tpv_distributionstrategy"));//配货策略号
                }
                SaveServiceHelper.save(new DynamicObject[]{costrePlacement});//写入数据库
                this.getView().showMessage("成本置换单生成成功");
            } else {
                this.getView().showMessage("所选择数据并非闭环,不可生成成本置换单");
            }
        } else {
            this.getView().showMessage("所选择数据并非闭环,不可生成成本置换单");
        }
    }

    /**
     * 判断list中是否有重复值
     * @param list
     * @return
     */
    public static boolean hasDuplicates(List<Long> list) {
        Set<Long> set = new HashSet<>(list);
        return set.size() < list.size();
    }

    /**
     * 判断两个数据是否闭环
     * @param list1
     * @param list2
     * @return
     */
    public static  boolean isListEqual(List<Long> list1, List<Long> list2) {
        Set<Long> set1 = new HashSet<>(list1);
        Set<Long> set2 = new HashSet<>(list2);

        return set1.equals(set2);
    }
    /**
     * 加载数据
     */
    private void initData() {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        String whereFilter = "1=1";
        model.deleteEntryData(entryKey_1);
        //库存为直运
        DynamicObject tpvCompanycondition = dataEntity.getDynamicObject("tpv_companycondition");//公司
        DynamicObject tpvDepartmentcondition = dataEntity.getDynamicObject("tpv_departmentcondition");//部门
        DynamicObject tpvSalesmancondition = dataEntity.getDynamicObject("tpv_salesmancondition");//业务员
        DynamicObjectCollection tpvCombinationcondition = dataEntity.getDynamicObjectCollection("tpv_combinationcondition");//组合号
        String tpvMarketcondition = dataEntity.getString("tpv_marketcondition");//销售合同号
        DynamicObjectCollection tpvClientcondition = dataEntity.getDynamicObjectCollection("tpv_clientcondition");//客户
        String tpvShipmentscondition = dataEntity.getString("tpv_shipmentscondition");//发货单号
        String tpvPickcondition = dataEntity.getString("tpv_pickcondition");//拣配采购合同号
        String tpvPickgodowncondition = dataEntity.getString("tpv_pickgodowncondition");//拣配入库单号
        DynamicObject tpvCommoditycondition = dataEntity.getDynamicObject("tpv_commoditycondition");//商品
        Date tpvDatestart = dataEntity.getDate("tpv_datestart");//业务日期从
        Date tpvDateend = dataEntity.getDate("tpv_dateend");//业务日期至
        if (null != tpvCompanycondition){
            //公司
            whereFilter = String.format("%s and tpv_company = %s", whereFilter, tpvCompanycondition.getLong("id"));
        }
        if (null != tpvDepartmentcondition){
            //部门
            whereFilter = String.format("%s and tpv_department = %s", whereFilter, tpvDepartmentcondition.getLong("id"));
        }
        if (null != tpvSalesmancondition){
            //业务员
            whereFilter = String.format("%s and tpv_salesman = %s", whereFilter, tpvSalesmancondition.getLong("id"));
        }
        if (tpvCombinationcondition.size() > 0){
            List<String> idS = new ArrayList<>();
            for (DynamicObject dynamicObject : tpvCombinationcondition) {
                DynamicObject dynamicObject1 = dynamicObject.getDynamicObject("fbasedataId");
                idS.add(dynamicObject1.getString("id"));
            }
            //组合号
            whereFilter = String.format("%s and (tpv_combination in (%s) or tpv_distributioncombinati in (%s))", whereFilter, String.join(",",idS),String.join(",",idS));
        }
        //销售合同号
        if (StringUtils.isNotEmpty(tpvMarketcondition)){
            whereFilter = String.format("%s and LOWER(tpv_marketcontract) LIKE LOWER(%s)", whereFilter, "'%" +tpvMarketcondition + "%'");
        }
        //客户
        if (tpvClientcondition.size() > 0){
            List<String> idS = new ArrayList<>();
            for (DynamicObject dynamicObject : tpvClientcondition) {
                DynamicObject dynamicObject1 = dynamicObject.getDynamicObject("fbasedataId");
                idS.add(dynamicObject1.getString("id"));
            }
            whereFilter = String.format("%s and tpv_correspondent in (%s)", whereFilter, String.join(",",idS));
        }
        //发货单号
        if (StringUtils.isNotEmpty(tpvShipmentscondition)){
            whereFilter = String.format("%s and tpv_shipments like %s", whereFilter, "'%" +tpvShipmentscondition + "%'");
        }
        //配货单据编号
        if (StringUtils.isNotEmpty(tpvPickgodowncondition)){
            whereFilter = String.format("%s and tpv_billno like %s", whereFilter, "'%" +tpvPickgodowncondition + "%'");
        }
        //拣配采购合同号
        if (StringUtils.isNotEmpty(tpvPickcondition)){
            whereFilter = String.format("%s and LOWER(tpv_contractdistribution) LIKE LOWER(%s)", whereFilter, "'%" +tpvPickcondition + "%'");
        }
        if (null != tpvCommoditycondition){
            //商品
            whereFilter = String.format("%s and tpv_material = %s", whereFilter, tpvCommoditycondition.getLong("id"));
        }
        //发货日期
        if (null != tpvDatestart && null != tpvDateend){
            whereFilter = String.format("%s and tpv_shipmentsdate >= to_date('%s','yyyy-MM-dd') and tpv_shipmentsdate <= to_date('%s','yyyy-MM-dd')",whereFilter, DateUtil.formatDate(DateUtil.getStartOfDay(tpvDatestart)),
                    DateUtil.formatDate(DateUtil.addDays(DateUtil.getEndOfDay(tpvDateend), 1)));
        }
        DataSet query = PlacemenRptQuery.query(whereFilter);
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(query);
        RowMeta rowMeta = query.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            BigDecimal tpvAlreadycost = col.getBigDecimal("tpv_alreadycost");//已成本置换数量
            BigDecimal tpvPickqty = col.getBigDecimal("tpv_pickqty");//本次配货数量
            BigDecimal tpvInvoiceqty = col.getBigDecimal("tpv_invoiceqty");//已开票数量
            int message = tpvInvoiceqty.compareTo(tpvPickqty);//比较本次配货数量与已开票数量两者大大小
            if (message > 0){
                //本次配货数量小
                col.set("tpv_qty",null);
                BigDecimal subtract = tpvPickqty.subtract(tpvAlreadycost);
                col.set("tpv_qty",subtract);
            } else {
                //已开票数量小
                col.set("tpv_qty",null);
                BigDecimal subtract = tpvInvoiceqty.subtract(tpvAlreadycost);
                col.set("tpv_qty",subtract);
            }
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        DynamicObjectType enrtyType = model.getEntryEntity(entryKey_1).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(createDataSet);
        for (Row row : createDataSet) {
            int index = model.createNewEntryRow(entryKey_1);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }
}
