package tpv.tpv_wm.tpv_cm.java.formplugin.dynamic;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;
import org.apache.commons.lang3.StringUtils;

import java.util.Date;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * WangShuGuang
 * 走访计划单动态回填
 */
public class PlanBackfillFormPlugin extends AbstractBillPlugIn {
    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addClickListeners("tpv_cancel", "tpv_affirm"); // 监听确认和取消按钮
    }

    @Override
    public void click(EventObject evt) {
        // TODO Auto-generated method stub
        super.click(evt);
        // 获取被点击的控件对象
        Control source = (Control) evt.getSource();
        // 点击确认按钮
        if (StringUtils.equals(source.getKey(), "btnok")) {
            HashMap<String, Object> dataBaseMap = new HashMap<>();
            // 如果被点击控件为确认，则获取页面相关控件值，组装数据传入returnData返回给父页面，最后关闭页面
            // 获取预计走访时间
            Date tpvBizdate = (Date) this.getModel().getValue("tpv_bizdate");
            // 获取预计走访人
            DynamicObject tpvExpectedvisitors = (DynamicObject) this.getModel().getValue("tpv_expectedvisitors");

            if (tpvExpectedvisitors != null) {
                dataBaseMap.put("tpv_expectedvisitors", tpvExpectedvisitors.getLong("id"));
            }
            if (tpvBizdate != null) {
                dataBaseMap.put("tpv_bizdate", tpvExpectedvisitors);
            }
            this.getView().returnDataToParent(dataBaseMap);
            this.getView().close();
        } else if (StringUtils.equals(source.getKey(), "tpv_cancel")) {
            // 被点击控件为取消则设置返回值为空并关闭页面（在页面关闭回调方法中必须验证返回值不为空，否则会报空指针）
            this.getView().returnDataToParent(null);
            this.getView().close();
        }
    }

    /**
     * 打开动态表单之后获取原单数据
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        // TODO Auto-generated method stub
        super.afterCreateNewData(e);
        // 打开动态表单
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> gainDataMap = new HashMap<>();
        gainDataMap = showParameter.getCustomParams();
        Long tpvExpectedvisitors = (Long) gainDataMap.get("tpv_expectedvisitors");//
        String tpvBizdate = (String) gainDataMap.get("tpv_bizdate");//
        this.getModel().setValue("tpv_expectedvisitors", tpvExpectedvisitors);
        this.getModel().setValue("tpv_bizdate", tpvBizdate);
    }
}
