package tpv.tpv_wm.tpv_cm.java.formplugin.dynamic;

import kd.bos.form.control.Control;
import kd.bos.list.IListView;
import kd.bos.list.plugin.AbstractListPlugin;
import org.apache.commons.lang3.StringUtils;

import java.util.EventObject;
import java.util.Map;

/**
 * @author: Heisenberg
 * @date: 2023/11/4 14:09
 * @description: 动态表单回填备注
 */
public class RemarkRewriteEdit extends AbstractListPlugin {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tbmain");
        this.addClickListeners("btncancel", "btnok"); // 监听确认和取消按钮
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        // 获取被点击的控件对象
        Control source = (Control) evt.getSource();
        // 点击确认按钮
        if (StringUtils.equals(source.getKey(), "btnok")) {
            //获取备注
            String remake = (String) this.getModel().getValue("tpv_renote");
            this.getView().returnDataToParent(remake);
            this.getView().close();
        } else if (StringUtils.equals(source.getKey(), "tpv_cancel")) {
            // 被点击控件为取消则设置返回值为空并关闭页面（在页面关闭回调方法中必须验证返回值不为空，否则会报空指针）
            this.getView().returnDataToParent(null);
            this.getView().close();
            ((IListView) this.getView()).refresh();
        }
    }

    /**
     * 获取到父页面（装箱单）传来的数据放入动态表单
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        Map<String, Object> map = this.getView().getFormShowParameter().getCustomParams();
        this.getModel().setValue("tpv_renote", map.get("tpv_renote"));
    }
}