package tpv.tpv_wm.tpv_cm.java.formplugin.dynamic;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import org.apache.commons.lang3.StringUtils;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * WangShuGuang
 * 走访计划单动态回填
 */
public class VisitscheduleFormPlugin extends AbstractBillPlugIn {
    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        //
        super.itemClick(evt);
        String key = evt.getItemKey();
        // 判断是否为回填按钮
        if (StringUtils.equals("tpv_designate", key)) {
            // 创建弹出动态表单页面对象
            FormShowParameter showParameter = new FormShowParameter();
            // 设置弹出页面的标识
            showParameter.setFormId("tpv_bd_planbackfill");
            Map<String, Object> map = this.showInfoForm();
            // 存入获取到的动态表单数据
            showParameter.setCustomParams(map);
            // 状态
            showParameter.setStatus(OperationStatus.ADDNEW);
            // 设置页面关闭回调方法
            // CloseCallBack参数：回调插件，回调标识
            showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_designate"));
            // 设置弹出页面打开方式
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            // 打开动态表单
            this.getView().showForm(showParameter);
        }
        //监听作废按钮
        if (StringUtils.equals("tpv_cancellation", key)) {
            this.getModel().setValue("tpv_void", true);
        }
        if (StringUtils.equals("nocancellation", key)) {
            this.getModel().setValue("tpv_void", false);
        }
    }

    /**
     * 动表单获取原单据字段
     */
    private Map<String, Object> showInfoForm() {
        // 获取单据体
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        // 创建集合保存需要获取的字段值
        Map<String, Object> map = new HashMap<>();
        // 获取预计走访人
        DynamicObject applier = dataEntity.getDynamicObject("tpv_expectedvisitors");
        // 获取预计走访时间
        Date applyOrg = dataEntity.getDate("tpv_bizdate");
        // 判断获得的各项数据
        if (applier != null) {
            map.put("tpv_expectedvisitors", applier.getLong("id"));
        }
        if (applyOrg != null) {
            map.put("tpv_bizdate", applyOrg);
        }
        return map;
    }

    /**
     * 动态表单回填单据字段
     */
    private void setInwardInfo(Map<String, Object> values) {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        // 回填动态表单的预计走访人
        model.setValue("tpv_expectedvisitors", values.get("tpv_expectedvisitors"));
        // 回填动态表单的预计走访时间
        model.setValue("tpv_bizdate", values.get("tpv_bizdate"));
        this.getView().invokeOperation("save");
        //SaveServiceHelper.update(dataEntity);// 写入数据库
    }

    /**
     * 动态表单关闭回调事件
     */

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        // super.closedCallBack(closedCallBackEvent);
        Object returnData = closedCallBackEvent.getReturnData();
        // 判断标识是否匹配，并验证返回值不为空，不验证返回值可能会报空指针
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_designate")
                && null != closedCallBackEvent.getReturnData()) {
            // 这里返回对象为Object，可强转成相应的其他类型，
            // 单条数据可用String类型传输，返回多条数据可放入map中，也可使用json等方式传输
            HashMap<String, Object> values = (HashMap<String, Object>) returnData;
            this.setInwardInfo(values);
        }
    }
}
