package tpv.tpv_wm.tpv_cm.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.field.BasedataEdit;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.util.EventObject;

/**
 * @author: He
 * @Project: JavaLaity
 * @Package: com.itopview.wm.cm.formplugin.dynamic.ApplierCarryOrg
 * @Date: 2023年08月25日 15:10
 * @Description: 申请人带出申请部门
 **/
public class ApplierCarryOrgFormPlugin extends AbstractBillPlugIn {
    //用户名标识
    private static final String KEY_APPLIER = "tpv_operator";

    //所属部门
    private static final String DEPARTMENT = "tpv_department";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        //过滤字段监听
        BasedataEdit applier = this.getControl("tpv_operator");
    }

    //值更新事件
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        //获取名称
        String name = e.getProperty().getName();
        if (name.equals(KEY_APPLIER)) {
            this.getOrgByApplier();
        }
    }

    //根据申请人获取申请部门
    private void getOrgByApplier() {
        DynamicObject applier = (DynamicObject) this.getModel().getValue(KEY_APPLIER);
        if (applier != null) {
            //根据其id查询组织
            long userMainOrgId = UserServiceHelper.getUserMainOrgId(applier.getLong("id"));
            this.getModel().setValue(DEPARTMENT, userMainOrgId);
        }
    }
}
