package tpv.tpv_wm.tpv_cm.java.formplugin.form;

import java.util.EventObject;

import com.itopview.wm.sys.utils.MetaPropertyHelper;
import com.itopview.wm.utils.YEM;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
/**
 * 条款对照
 * 1、选择字段标识带出字段名称和显示格式
 * @author zhangh
 *
 */
public class ClauseContrastFormPlugin extends AbstractBillPlugIn{

	@Override
	public void registerListener(EventObject e) {
		this.addClickListeners(new String[]{"tpv_fieldkey"});
	}
	
	@Override
	public void click(EventObject evt) {
		String key = ((Control) evt.getSource()).getKey();
		switch (key) {
		case "tpv_fieldkey":
			this.clickBillCol(evt, key, "tpv_billkey", "number");
			break;
		}
	}

	private void clickBillCol(EventObject evt, String key, String baseCol, String childCol) {
		DynamicObject requireBill = MetaPropertyHelper.getAndCheckF7Value(this.getView(), baseCol);
		if(requireBill != null) {
			String formKey = requireBill.getString(childCol);
			MetaPropertyHelper.showPropertySelect(this, key, formKey, false);
		}
	}
	
	@Override
	public void closedCallBack(ClosedCallBackEvent e) {
		String key = e.getActionId();
		switch (key) {
		case "tpv_fieldkey":
			this.callBackEntryData(e);
			break;

		default:
			break;
		}
	}

	/**
	 * 将数据返回条款对照
	 * @param e
	 */
	private void callBackEntryData(ClosedCallBackEvent e) {
		DynamicObjectCollection data = (DynamicObjectCollection) e.getReturnData();
		if (YEM.isNotEmpty(data)) {
			for (int i = 0; i < data.size(); ++i) {
				DynamicObject info = data.get(i);
				String fullnumber = info.getString("tpv_number");
				String fullname = info.getString("tpv_name");
				String classSimpleName = info.getString("tpv_datatype");
				this.getModel().setValue("tpv_fieldkey", fullnumber);
				this.getModel().setValue("name", fullname);
				this.getModel().setValue("tpv_format", classSimpleName);
				this.getModel().setValue("tpv_field", info.getString("tpv_fullnumber"));
			}
		}
	}
	
	@Override
	public void afterBindData(EventObject e) {
		this.mustInputFieldType();
	}
	
	private void mustInputFieldType() {
		String tpv_fieldkey = (String) this.getModel().getValue("tpv_fieldkey");
		BasedataEdit tpv_fieldtype = this.getControl("tpv_fieldtype");
		if (StringUtils.isNotEmpty(tpv_fieldkey)) {
			tpv_fieldtype.setMustInput(false);
		}else {
			tpv_fieldtype.setMustInput(true);
		}
	}

	@Override
	public void propertyChanged(PropertyChangedArgs e) {
		String name = e.getProperty().getName();
		switch (name) {
		case "tpv_fieldkey":
			this.mustInputFieldType();
			break;

		case "tpv_billkey":
			this.getModel().setValue("tpv_fieldkey", "");
			this.getModel().setValue("tpv_format", "");
			this.getModel().setValue("tpv_field", "");
		default:
			break;
		}
	}

}
