package tpv.tpv_wm.tpv_cm.java.formplugin.form;

import java.util.EventObject;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.LargeTextEdit;
import kd.bos.form.field.TextEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
/**
 * 合同条款库
 * 1、部门根据所属团队进行过滤
 * @author zhangh
 *
 */
public class ContractLibraryFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener{

	@Override
	public void beforeF7Select(BeforeF7SelectEvent e) {
		String name = e.getProperty().getName();
		switch (name) {
		case "tpv_org":
			this.setOrgF7Filter(e);
			break;
		case "tpv_dept":
		case "tpv_sharedscope":
//			this.setDeptF7Filter(e);
			break;

		default:
			break;
		}
	}

	/**
	 * 部门根据所属团队进行过滤
	 * @param e
	 */
	public void setDeptF7Filter(BeforeF7SelectEvent e) {
		ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
		showParameter.getListFilterParameter().getQFilters().clear();
		DynamicObject tpv_dept = (DynamicObject) this.getModel().getValue("tpv_org");
		if (tpv_dept != null) {
			showParameter.getListFilterParameter().setFilter(new QFilter("structure.viewparent.name", QCP.equals, tpv_dept.getString("name")));
		}
	}

	/**
	 * 所属团队过滤
	 * @param e
	 */
	private void setOrgF7Filter(BeforeF7SelectEvent e) {
		ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
		showParameter.getListFilterParameter().getQFilters().clear();
		showParameter.getListFilterParameter().setFilter(new QFilter("orgpattern.name", QCP.in, new String[] {"事业部","公司"}));
	}
	
	@Override
	public void registerListener(EventObject e) {
		((BasedataEdit) this.getControl("tpv_org")).addBeforeF7SelectListener(this);
		((BasedataEdit) this.getControl("tpv_dept")).addBeforeF7SelectListener(this);
	}
	
	@Override
	public void propertyChanged(PropertyChangedArgs e) {
		String name = e.getProperty().getName();
		ChangeData[] changeSet = e.getChangeSet();
		int rowIndex = changeSet[0].getRowIndex();
		switch (name) {
		case "tpv_clausecontentchina":
			String tpv_clausescontent = (String) this.getModel().getValue("tpv_clausecontentchina", rowIndex);
			this.getModel().setValue("tpv_clausecontentchina_tag", tpv_clausescontent, rowIndex);
			setChangeValue("tpv_changechina", tpv_clausescontent, rowIndex);
			break;

		case "tpv_clausecontentchina_tag":
			String tpv_clausecontentchina_tag = (String) this.getModel().getValue("tpv_clausecontentchina_tag", rowIndex);
			this.getModel().setValue("tpv_clausecontentchina", tpv_clausecontentchina_tag, rowIndex);
			setChangeValue("tpv_changechina", tpv_clausecontentchina_tag, rowIndex);
			break;
		
		case "tpv_clausecontentenglish":
			String tpv_clausecontentenglish = (String) this.getModel().getValue("tpv_clausecontentenglish", rowIndex);
			this.getModel().setValue("tpv_clausecontentenglish_tag", tpv_clausecontentenglish, rowIndex);
			setChangeValue("tpv_changeenglish", tpv_clausecontentenglish, rowIndex);
			break;
			
		case "tpv_clausecontentenglish_tag":
			String tpv_clausecontentenglish_tag = (String) this.getModel().getValue("tpv_clausecontentenglish_tag", rowIndex);
			this.getModel().setValue("tpv_clausecontentenglish", tpv_clausecontentenglish_tag, rowIndex);
			setChangeValue("tpv_changeenglish", tpv_clausecontentenglish_tag, rowIndex);
			break;
		case "tpv_foreigntrade":
//			setMustInput();
			break;
		default:
			break;
		}
	}
	
	private void setChangeValue(String key, String tpv_clausescontent, int rowIndex) {
		Integer tpv_version = (Integer) this.getModel().getValue("tpv_version");
		if (tpv_version == 1) {
			this.getModel().setValue(key, tpv_clausescontent, rowIndex);
			this.getModel().setValue(key + "_tag", tpv_clausescontent, rowIndex);
		}		
	}

	@Override
	public void afterBindData(EventObject e) {
//		setMustInput();
	}

	/**
	 * 【条款名称(英文)】、【条款内容(英文)】根据【贸易类型】进行必录
	 * 中航废弃
	 */
	public void setMustInput() {
		String tpv_foreigntrade = (String) this.getModel().getValue("tpv_foreigntrade");
		TextEdit tpv_clauseenglish = this.getControl("tpv_clauseenglish");
		LargeTextEdit tpv_clausecontentenglish = this.getControl("tpv_clausecontentenglish");
		if ("A".equals(tpv_foreigntrade)) {
			tpv_clauseenglish.setMustInput(true);
			tpv_clausecontentenglish.setMustInput(true);
		}else {
			tpv_clauseenglish.setMustInput(false);
			tpv_clausecontentenglish.setMustInput(false);
		}
	}

}
