package tpv.tpv_wm.tpv_cm.java.formplugin.form;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.EventObject;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.itopview.wm.cm.utils.ClauseContractUtil;
import com.itopview.wm.sys.formplugin.dynamic.VersionResumeBillInfoEdit;
import com.itopview.wm.sys.utils.NewVersionHelper;
import com.itopview.wm.utils.NumberChineseUtil;
import com.itopview.wm.utils.YEM;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.TextEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

/**
 * 采购合同和销售合同(合同条款库插件)
 * @author zhangh
 *
 */
public class ContractTermsFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

	@Override
	public void propertyChanged(PropertyChangedArgs e) {
		String key = e.getProperty().getName();
		ChangeData[] changeSet = e.getChangeSet();
		int rowIndex = changeSet[0].getRowIndex();
		switch (key) {
		case "tpv_template":
			updateBeforeTemplateColor("#FFFFFF");
			buildDynamicEntry();// 构建动态挖空字段分录
			buildDynamicBillEntry();// 构建本单挖空字段分录
			this.bringOutContractTerm(key);//
			break;
		case "tpv_updatebefore":
			this.changAdjustTrue(e, rowIndex);
			String tpv_updatebefore = (String) this.getModel().getValue("tpv_updatebefore", rowIndex);
			this.getModel().setValue("tpv_updatebefore_tag", tpv_updatebefore, rowIndex);
			updateBeforeValue(rowIndex, tpv_updatebefore);
			break;
		case "tpv_updatebefore_tag":
			String tpv_updateafter_tag = (String) this.getModel().getValue("tpv_updatebefore_tag", rowIndex);
			this.getModel().setValue("tpv_updatebefore", tpv_updateafter_tag, rowIndex);
			break;

		case "tpv_change":
			this.changeColourSetting(rowIndex);
			break;
		case "tpv_contentvalue":
			this.updateAfterValue(rowIndex);
			break;
		case "tpv_fieldtype":
			this.setLockContent(rowIndex);
			break;
		case "tpv_clausetype":
			changeClauseType(rowIndex);
			break;
		default:
			break;
		}

		DynamicObjectCollection tpv_billentrykey = this.getModel().getEntryEntity("tpv_billentrykey");
		for (DynamicObject billentrykey : tpv_billentrykey) {
			String tpv_bill = billentrykey.getString("tpv_bill");
			Object bill = this.getModel().getValue(tpv_bill);
			if (YEM.isNotEmpty(bill)) {
				ClauseContractUtil.getFieldValue2UpdateAfter(tpv_bill, billentrykey, this.getView());
			}
			ClauseContractUtil.backgroundColor(billentrykey, VersionResumeBillInfoEdit.HighLightColor, this.getView());
		}
	}

	/**
	 * 新增行添加合同条款携带相关信息
	 * 
	 * @param rowIndex
	 */
	private void changeClauseType(int rowIndex) {
		DynamicObject tpv_clausetype = (DynamicObject) this.getModel().getValue("tpv_clausetype", rowIndex);
		if (tpv_clausetype != null) {
			tpv_clausetype = BusinessDataServiceHelper.loadSingleFromCache(tpv_clausetype.getPkValue(),
					tpv_clausetype.getDynamicObjectType().getName());
			DynamicObject clausetype = tpv_clausetype.getDynamicObject("tpv_clausetype");// 条款类型
			String tpv_clausecontentchina = tpv_clausetype.getString("tpv_clausecontentchina_tag");// 条款内容(中文)
			String entityId = this.getView().getEntityId();
			NewVersionHelper newVersionHelper = new NewVersionHelper(entityId);
			if (newVersionHelper.isChanged()) {
				entityId = newVersionHelper.getRequireKey();
			}

			String content = tpv_clausecontentchina;
			List<String> scoopField = new ArrayList<>();// 获取所有的挖空字段
			String hollowField = content;
			if (StringUtils.isNotEmpty(hollowField)) {
				for (int i = 0; i < hollowField.length(); i++) {
					if (hollowField.contains("【")) {
						hollowField = ClauseContractUtil.cutOutString(hollowField, scoopField);
					}
				}
			}

			// 获取动态挖空字段集合
			List<String> scoopFieldNew = new ArrayList<>();
			DynamicObjectCollection tpv_dynamicfield = this.getModel().getEntryEntity("tpv_dynamicfield");
			List<String> tpv_fieldkey = tpv_dynamicfield.stream().map(x -> x.getString("tpv_fieldkey"))
					.collect(Collectors.toList());
			if (scoopField.size() > 0) {
				for (String field : scoopField) {
					ClauseContractUtil.hollowFieldHasOrNo(field, scoopFieldNew, this.getView());
				}
			}

			if (scoopFieldNew.size() > 0) {
				for (String field : scoopFieldNew) {
					if (!tpv_fieldkey.contains(field)) {
						ClauseContractUtil.createHollowEntry(field, this.getView());// 构建动态挖空字段
					}
				}
			}

			// 遍历所有的挖空字段
			Map<String, DynamicObject> map = new HashMap<>();
			for (String field : scoopField) {
				if (!scoopFieldNew.contains(field)) {// 判断动态挖空字段集合中是否存在此次挖空字段，如果不存在，说明是本单挖空字段
					List<QFilter> qFilters = new ArrayList<>();
					qFilters.add(new QFilter("tpv_clausekey", QCP.equals, field));
					qFilters.add(new QFilter("tpv_billkey.number", QCP.equals, this.getView().getEntityId()));
					DynamicObject bd_clausecontrast = BusinessDataServiceHelper.loadSingle("tpv_bd_clausecontrast",
							"id,tpv_fieldkey,tpv_field", qFilters.toArray(new QFilter[] {}));
					if (bd_clausecontrast != null) {
						map.put(field, bd_clausecontrast);
					}
				}
			}

			DynamicObjectCollection tpv_billentrykey = this.getModel().getEntryEntity("tpv_billentrykey");
			List<String> tpv_bill = tpv_billentrykey.stream().map(x -> x.getString("tpv_bill"))
					.collect(Collectors.toList());
			if (map.size() > 0) {
				for (String key : map.keySet()) {
					if (!tpv_bill.contains(key)) {
						ClauseContractUtil.setEntryBillkey(map, key, this.getView());
					}
				}
			}

			String name = clausetype.getString("name");
			String format = NumberChineseUtil.format(rowIndex + 2, false, false);
			name = format + "、" + tpv_clausetype.getString("tpv_clausechina");
			this.getModel().beginInit();
			this.getModel().setValue("tpv_termtype", name, rowIndex);
			this.getModel().setValue("tpv_clausename", tpv_clausetype.getString("tpv_clausechina"), rowIndex);
			this.getModel().setValue("tpv_clausenameeng", name + clausetype.getLocaleString("name").getLocaleValue_en(),
					rowIndex);
			this.getModel().setValue("tpv_printclause", content, rowIndex);
			this.getModel().setValue("tpv_printclause_tag", content, rowIndex);
			this.getModel().setValue("tpv_updatebefore", content, rowIndex);
			this.getModel().setValue("tpv_updatebefore_tag", content, rowIndex);
			this.getModel().setValue("tpv_updateafter", content, rowIndex);
			this.getModel().setValue("tpv_updateafter_tag", content, rowIndex);
			this.getModel().endInit();
			this.getView().updateView("tpv_clauseimport");

			DynamicObjectCollection billentrykey = this.getModel().getEntryEntity("tpv_billentrykey");
			for (DynamicObject entrykey : billentrykey) {
				String bill = entrykey.getString("tpv_bill");
				ClauseContractUtil.getFieldValue2UpdateAfter(bill, entrykey, this.getView());
			}
		}
	}

	/**
	 * 合同动态中的【字段类型】基础资料为基础资料、下拉列表、日期等字段类型，锁定内容值
	 * 
	 * @param rowIndex
	 */
	private void setLockContent(int rowIndex) {
		DynamicObject tpv_fieldtype = (DynamicObject) this.getModel().getValue("tpv_fieldtype", rowIndex);
		if (tpv_fieldtype != null) {
			String tpv_keytype = tpv_fieldtype.getString("tpv_keytype");
			List<String> keytype = Arrays.asList(new String[] { "ComboProp", "BasedataProp", "UnitProp", "UserProp",
					"OrgProp", "CurrencyProp", "MulBasedataProp", "DateTimeProp" });
			if (keytype.contains(tpv_keytype)) {
				this.getView().setEnable(false, rowIndex, "tpv_contentvalue");
			} else {
				this.getView().setEnable(true, rowIndex, "tpv_contentvalue");
			}
		}
	}

	/**
	 * 改变合同动态中的内容值
	 * 
	 * @param rowIndex
	 */
	private void updateAfterValue(int rowIndex) {
		DynamicObject dataEntity = this.getModel().getDataEntity(true);
		DynamicObject tpv_dynamicfield = this.getModel().getEntryRowEntity("tpv_dynamicfield", rowIndex);
		String tpv_content = tpv_dynamicfield.getLocaleString("tpv_contentvalue").getLocaleValue_zh_CN();
		String tpv_fieldkey = tpv_dynamicfield.getString("tpv_fieldkey");
		DynamicObjectCollection tpv_clauseimport = this.getModel().getEntryEntity("tpv_clauseimport");
		for (int i = 0; i < tpv_clauseimport.size(); i++) {
			DynamicObject clauseimport = tpv_clauseimport.get(i);
			String tpv_updatebefore = clauseimport.getString("tpv_updatebefore");
			if (tpv_updatebefore.contains(tpv_fieldkey)) {
				List<String> list = new ArrayList<>();
				Map<String, DynamicObject> map = ClauseContractUtil.getKey(this.getModel());
				Map<String, DynamicObject> dynamicKey = ClauseContractUtil.getDynamicKey(this.getModel());
				String updatebefore = tpv_updatebefore;
				for (int j = 0; j < updatebefore.length(); j++) {
					updatebefore = ClauseContractUtil.cutOutString(updatebefore, list);
				}

				String context = tpv_updatebefore;
				context = ClauseContractUtil.setValue(list, map, dynamicKey, this.getView(), context);
				tpv_updatebefore = ClauseContractUtil.setupdateValue(tpv_content, context, tpv_fieldkey, dataEntity);

				this.getModel().setValue("tpv_updateafter", context, i);
				this.getModel().setValue("tpv_updateafter_tag", context, i);
			}
		}
	}

	/**
	 * 是否调整为true之后，行改变背景颜色
	 * 
	 * @param rowIndex
	 */
	private void changeColourSetting(int rowIndex) {
		Boolean tpv_change = (Boolean) this.getModel().getValue("tpv_change", rowIndex);
		List<String> fieldList = Arrays.asList(
				new String[] { "tpv_termtype", "tpv_updatebefore", "tpv_updateafter", "tpv_change", "tpv_clausename" });
		for (String field : fieldList) {
			if (tpv_change) {
				YEM.changeCellColor(this.getView(), "tpv_clauseimport", field, rowIndex, "#FFFFCC");
			} else {
				YEM.changeCellColor(this.getView(), "tpv_clauseimport", field, rowIndex, "rgba(240,232,229,0.8)");
			}
		}
	}

	/**
	 * 修改前条款内容发生改变，将值赋给修改后内容
	 * 
	 * @param rowIndex
	 * @param tpv_updatebefore
	 */
	private void updateBeforeValue(int rowIndex, String tpv_updatebefore) {
		List<String> list = new ArrayList<>();
		Map<String, DynamicObject> map = ClauseContractUtil.getKey(this.getModel());
		String updatebefore = tpv_updatebefore;
		DynamicObjectCollection tpv_dynamicfield = this.getModel().getEntryEntity("tpv_dynamicfield");
		Map<String, DynamicObject> collect = tpv_dynamicfield.stream()
				.collect(Collectors.toMap(x -> x.getString("tpv_fieldkey"), y -> y));
		for (int j = 0; j < updatebefore.length(); j++) {
			updatebefore = ClauseContractUtil.cutOutString(updatebefore, list);
		}
		tpv_updatebefore = ClauseContractUtil.setValue(list, map, collect, this.getView(), tpv_updatebefore);
		this.getModel().setValue("tpv_updateafter", tpv_updatebefore, rowIndex);
		this.getModel().setValue("tpv_updateafter_tag", tpv_updatebefore, rowIndex);
	}

	/**
	 * 调整修改后条款之后，是否调整改为true
	 * 
	 * @param e
	 * @param rowIndex
	 */
	private void changAdjustTrue(PropertyChangedArgs e, int rowIndex) {
		String tpv_updatebefore = (String) this.getModel().getValue("tpv_updatebefore", rowIndex);
		String tpv_printclause = (String) this.getModel().getValue("tpv_printclause", rowIndex);
		if (tpv_updatebefore.equals(tpv_printclause)) {
			this.getModel().setValue("tpv_change", false, rowIndex);
		} else {
			this.getModel().setValue("tpv_change", true, rowIndex);
		}
	}

	/**
	 * 根据合同模板带出合同条款,构建条款内容分录
	 * 
	 * @param key
	 */
	private void bringOutContractTerm(String key) {
		DynamicObject tpv_template = (DynamicObject) this.getModel().getValue("tpv_template");

		// 构建条款内容分录之前，先清空条款内容分录
		this.getModel().deleteEntryData("tpv_clauseimport");
		if (tpv_template != null) {
			tpv_template = BusinessDataServiceHelper.loadSingleFromCache(tpv_template.getPkValue(),
					"tpv_cm_contracttemplate");
			DynamicObjectCollection tpv_contractterms = tpv_template.getDynamicObjectCollection("tpv_contractterms");
			for (DynamicObject contractterms : tpv_contractterms) {
				this.getModel().beginInit();
				int row = this.getModel().createNewEntryRow("tpv_clauseimport");
				this.getModel().setValue("tpv_termtype", contractterms.getString("tpv_termbillno"), row);
				this.getModel().setValue("tpv_clausenameeng", contractterms.getString("tpv_termbillno")
						+ contractterms.getDynamicObject("tpv_clausetype").getLocaleString("name").getLocaleValue_en(),
						row);
				this.getModel().setValue("tpv_clausetype", contractterms.getDynamicObject("tpv_termname"), row);
				this.getModel().setValue("tpv_updatebefore", contractterms.getString("tpv_clausescontent"), row);
				DynamicObject tpv_termname = contractterms.getDynamicObject("tpv_termname");
				if (tpv_termname != null) {
					tpv_termname = BusinessDataServiceHelper.loadSingleFromCache(tpv_termname.getPkValue(),
							"tpv_cm_contractterms");
					String tpv_clausechina = tpv_termname.getString("tpv_clausechina");
					String tpv_clauseenglish = tpv_termname.getString("tpv_clauseenglish");
					LocaleString locStr = new LocaleString();
					locStr.setLocaleValue_en(tpv_clauseenglish);
					locStr.setLocaleValue_zh_CN(tpv_clausechina);
					this.getModel().setValue("tpv_clausename", locStr, row);
				}

				this.getModel().setValue("tpv_updatebefore_tag", contractterms.getString("tpv_clausescontent"), row);
				this.getModel().setValue("tpv_updateafter", contractterms.getString("tpv_clausescontent"), row);
				this.getModel().setValue("tpv_updateafter_tag", contractterms.getString("tpv_clausescontent"), row);
				this.getModel().setValue("tpv_printclause", contractterms.getString("tpv_clausescontent"), row);
				this.getModel().setValue("tpv_printclause_tag", contractterms.getString("tpv_clausescontent"), row);
				this.getModel().endInit();
				this.getView().updateView("tpv_clauseimport");
			}
		}
	}

	private void buildDynamicBillEntry() {
		String name = this.getModel().getDataEntityType().getName();
		// 获取到所有的挖空字段，包括本单挖空字段和动态挖空字段
		List<String> scoopField = ClauseContractUtil.getHollowFieldList(this.getView());

		// 获取动态挖空字段集合
		List<String> scoopFieldNew = new ArrayList<>();
		if (scoopField.size() > 0) {
			for (String field : scoopField) {
				ClauseContractUtil.hollowFieldHasOrNo(field, scoopFieldNew, this.getView());
			}
		}

		// 遍历所有的挖空字段
		Map<String, DynamicObject> map = new HashMap<>();
		for (String field : scoopField) {
			if (!scoopFieldNew.contains(field)) {// 判断动态挖空字段集合中是否存在此次挖空字段，如果不存在，说明是本单挖空字段
				List<QFilter> qFilters = new ArrayList<>();
				qFilters.add(new QFilter("tpv_clausekey", QCP.equals, field));
				qFilters.add(new QFilter("tpv_billkey.number", QCP.equals, name));
				DynamicObject bd_clausecontrast = BusinessDataServiceHelper.loadSingle("tpv_bd_clausecontrast",
						"id,tpv_fieldkey,tpv_field", qFilters.toArray(new QFilter[] {}));
				if (bd_clausecontrast != null) {
					map.put(field, bd_clausecontrast);
				}
			}
		}

		// 在构建本单挖空字段之前先清空本单挖空字段分录
		this.getModel().deleteEntryData("tpv_billentrykey");
		if (map.size() > 0) {
			for (String key : map.keySet()) {
				ClauseContractUtil.setEntryBillkey(map, key, this.getView());
			}
		}
	}

	/**
	 * 根据合同模板构建合同动态字段分录
	 */
	private void buildDynamicEntry() {
		// 获取到所有的挖空字段，包括本单挖空字段和动态挖空字段
		List<String> scoopField = ClauseContractUtil.getHollowFieldList(this.getView());

		// 获取动态挖空字段集合
		List<String> scoopFieldNew = new ArrayList<>();
		if (scoopField.size() > 0) {
			for (String field : scoopField) {
				ClauseContractUtil.hollowFieldHasOrNo(field, scoopFieldNew, this.getView());
			}
		}

		// 在构建分录之前，先清空动态挖空字段分录
		this.getModel().deleteEntryData("tpv_dynamicfield");
		if (scoopFieldNew.size() > 0) {
			for (String field : scoopFieldNew) {
				ClauseContractUtil.createHollowEntry(field, this.getView());
			}
		}
	}

	/**
	 * 在修改之前对上次选择的合同模板所对应的挖空字段背景颜色还原
	 * 
	 * @param color
	 */
	private void updateBeforeTemplateColor(String color) {
		DynamicObjectCollection tpv_billentrykey = this.getModel().getEntryEntity("tpv_billentrykey");
		for (DynamicObject billentrykey : tpv_billentrykey) {
			ClauseContractUtil.backgroundColor(billentrykey, color, this.getView());
		}
	}

	@Override
	public void afterBindData(EventObject e) {
		this.changeBillEmptyAdjust();
		DynamicObjectCollection tpv_clauseimport = this.getModel().getEntryEntity("tpv_clauseimport");
		for (int i = 0; i < tpv_clauseimport.size(); i++) {
			DynamicObject clauseimport = tpv_clauseimport.get(i);
			if (clauseimport.getBoolean("tpv_change")) {
				changeColourSetting(i);
			}
		}

		DynamicObjectCollection tpv_dynamicfield = this.getModel().getEntryEntity("tpv_dynamicfield");
		for (int rowIndex = 0; rowIndex < tpv_dynamicfield.size(); rowIndex++) {
			this.setLockContent(rowIndex);
		}
	}

	/**
	 * 变更单清空合同条款中的是否调整字段
	 */
	private void changeBillEmptyAdjust() {
		String name = this.getModel().getDataEntityType().getName();
		NewVersionHelper newVersionHelper = new NewVersionHelper(name);
		String billstatus = (String) this.getModel().getValue("billstatus");
		if (newVersionHelper.isChanged() && "A".equals(billstatus)) {
			DynamicObjectCollection tpv_clauseimport = this.getModel().getEntryEntity("tpv_clauseimport");
			for (int i = 0; i < tpv_clauseimport.size(); i++) {
				this.getModel().setValue("tpv_change", false, i);
			}
		}
	}

	@Override
	public void registerListener(EventObject e) {
		((TextEdit) this.getControl("tpv_content")).addButtonClickListener(this);
		((BasedataEdit) this.getControl("tpv_template")).addBeforeF7SelectListener(this);
	}

	@Override
	public void beforeF7Select(BeforeF7SelectEvent e) {
		String name = e.getProperty().getName();
		switch (name) {
		case "tpv_template":
		case "tpv_templateother":
//			trmplateF7Filter(e);
			break;
		default:
			break;
		}
	}

	/**
	 * 对我方合同模板根据部门进行过滤
	 * 
	 * @param e
	 */
	public void trmplateF7Filter(BeforeF7SelectEvent e) {
		ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
		showParameter.getListFilterParameter().getQFilters().clear();
		long currentUserId = UserServiceHelper.getCurrentUserId();
		DynamicObject bos_user = BusinessDataServiceHelper.loadSingleFromCache(currentUserId, "bos_user");
		if (bos_user != null) {
			List<Long> dept = new ArrayList<>();
			DynamicObjectCollection entryentity = bos_user.getDynamicObjectCollection("entryentity");
			for (DynamicObject row : entryentity) {
				dept.add(row.getDynamicObject("dpt").getLong("id"));
			}

			if (dept.size() > 0) {
				QFilter qFilter = new QFilter("tpv_dept", QCP.in, dept)
						.or(new QFilter("tpv_sharedscope.fbasedataid.id", QCP.in, dept));
				showParameter.getListFilterParameter().setFilter(qFilter);
			}
		}
	}

	@Override
	public void click(EventObject e) {
		String key = ((Control) e.getSource()).getKey();
		switch (key) {
		case "tpv_content":
			this.skipControlForm(e);
			break;

		default:
			break;
		}
	}

	/**
	 * 根据合同动态中的字段类型跳转动态表单
	 * 
	 * @param e
	 */
	private void skipControlForm(EventObject e) {
		ClauseContractUtil.showForm(this.getView(), this);
	}

	@Override
	public void closedCallBack(ClosedCallBackEvent e) {
		ClauseContractUtil.backValue(this.getView(), e);
	}
}
