package tpv.tpv_wm.tpv_cm.java.formplugin.form;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import com.itopview.wm.sys.utils.MetaPropertyHelper;
import com.itopview.wm.sys.utils.RuleSettingsHelper;
import com.itopview.wm.utils.YEM;

import kd.bos.base.AbstractBasePlugIn;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import static tpv.tpv_wm.tpv_cm.java.utils.CostHelper.getCostColKeys;

public class CostSettingsFormPlugin extends AbstractBasePlugIn {

	@Override
	public void registerListener(EventObject e) {
		super.registerListener(e);
		this.addClickListeners(new String[] { "tpv_opname", "tpv_partbillentry", "tpv_rule", "tpv_oprule", "tpv_billcol" });
		this.addItemClickListeners(new String[] { "tpv_advcontoolbarap", "tpv_advcontoolbarap1" });
	}

	@Override
	public void click(EventObject evt) {
		super.click(evt);
		String key = ((Control) evt.getSource()).getKey();
		switch (key) {
		case "tpv_rule":
			clickRule();
			break;
		case "tpv_oprule":
			clickOpRule();
			break;
		case "tpv_billcol":
			clickBillCol(key);
			break;
		}
	}

	private void clickRule() {
		IDataModel model = this.getModel();
		DynamicObject group = (DynamicObject) model.getValue("group");
		if (group != null) {
			DynamicObject tpv_requirebill = group.getDynamicObject("tpv_requirebill");
			if (tpv_requirebill != null) {
				RuleSettingsHelper.showRuleSettings(this, tpv_requirebill.getString("number"), "tpv_rule",
						"tpv_rulejson");
			}
		}
	}

	private void clickOpRule() {
		IFormView view = this.getView();
		DynamicObject tpv_partbill = MetaPropertyHelper.getAndCheckF7Value(view, "tpv_cm_costset_op", "tpv_partbill");
		if (tpv_partbill != null) {
			RuleSettingsHelper.showRuleSettings(this, tpv_partbill.getString("number"), "tpv_cm_costset_op",
					"tpv_oprule", "tpv_oprulejson");
		}
	}

	private void clickBillCol(String key) {
		IDataModel model = this.getModel();
		int index = model.getEntryCurrentRowIndex("tpv_cm_costset_op");
		DynamicObject tpv_partbill = (DynamicObject) model.getValue("tpv_partbill", index);
		if (tpv_partbill != null) {
			String entityKey = tpv_partbill.getString("number");
			List<String> entityKeys = new ArrayList<>();
			entityKeys.add(entityKey);

			String tpv_partbillentry = (String) model.getValue("tpv_partbillentry", index);
			if (YEM.isNotEmpty(tpv_partbillentry)) {
				for (String entryKey : tpv_partbillentry.split("\\.")) {
					entityKeys.add(entryKey);
				}
			}
			MetaPropertyHelper.showPropertySelect(this, key, entityKey, false, entityKeys);
		}
	}

	@Override
	public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
		String actionId = closedCallBackEvent.getActionId();
		if (actionId != null) {
			switch (actionId) {
			case "tpv_billcol":
				MetaPropertyHelper.callBackEntryData(getModel(), closedCallBackEvent, "tpv_cm_costset_op",
						"tpv_cm_costset_cols", "tpv_billcolno", "tpv_billcol", true);
				break;
			default:
				break;
			}
		}
	}

	@Override
	public void itemClick(ItemClickEvent evt) {
		super.itemClick(evt);
		String itemKey = evt.getItemKey();
		switch (itemKey) {
		case "tpv_updatecols":
			clickUpdateCols();
			break;
		default:
			break;
		}
	}

	private void clickUpdateCols() {
		IDataModel model = this.getModel();
		IFormView view = this.getView();
		view.invokeOperation("save", YEM.getOptionNoMsg());
		List<String> costColKeys = getCostColKeys();
		String langName = RequestContext.get().getLang().name();
		MainEntityType dt = EntityMetadataCache.getDataEntityType("tpv_cm_costdispose");
		DynamicObject dataEntity = model.getDataEntity(true);
		DynamicObjectCollection tpv_cm_costset_op = dataEntity.getDynamicObjectCollection("tpv_cm_costset_op");
		for (DynamicObject row : tpv_cm_costset_op) {
			DynamicObjectCollection tpv_cm_costset_cols = row.getDynamicObjectCollection("tpv_cm_costset_cols");
			Map<String, DynamicObject> entryMap = tpv_cm_costset_cols.stream()
					.collect(Collectors.toMap(x -> x.getString("tpv_tokey"), y -> y));
			Set<String> keySet = entryMap.keySet();
			for (int i = 0; i < costColKeys.size(); i++) {
				String key = costColKeys.get(i);
				DynamicObject thisRow;
				if (keySet.contains(key)) {
					thisRow = entryMap.get(key);
					keySet.remove(key);
				} else {
					thisRow = tpv_cm_costset_cols.addNew();
					thisRow.set("tpv_coltype", "B");
				}
				thisRow.set("seq", i + 1);
				thisRow.set("tpv_tokey", key);
				thisRow.set("tpv_toname", MetaPropertyHelper.getEntityLangName(langName, dt, key));
				thisRow.set("tpv_fieldtype", MetaPropertyHelper.getFieldtype(dt, key));
			}
			for (String key : keySet) {
				tpv_cm_costset_cols.remove(entryMap.get(key));
			}
		}
		SaveServiceHelper.save(new DynamicObject[] { dataEntity });
		view.invokeOperation("refresh");
	}
}
