package tpv.tpv_wm.tpv_cm.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;

import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 成本调整单 回填成本明细数据
 * @Author LinRui
 * @Date 2023/12/7 16:34
 */
public class CostadjustFormPlugin extends AbstractBillPlugIn {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"tpv_tbmainentry", "tbmain","tpv_advcontoolbarap"});
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        switch (itemKey) {
            case "tpv_selectbreakdown": // 成本选择
                cancelCostClick();
                break;
            default:
                break;
        }
    }

    private void cancelCostClick() {
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId("tpv_cm_costadjustform"); //选择成本明细弹出框
        Map<String, Object> param = new HashMap<>();
        String tpv_adjustvalue = (String) this.getModel().getValue("tpv_adjustvalue");
        DynamicObject tpv_billtype = (DynamicObject) this.getModel().getValue("tpv_billtype");
        if (null != tpv_adjustvalue && null != tpv_billtype) {
            param.put("tpv_adjustvalue", this.getModel().getValue("tpv_adjustvalue")); //调整货值类型
            param.put("billtypenumber",tpv_billtype.getString("number")); //单据类型编码
            showParameter.setCustomParams(param);
        }
        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_selectbreakdown"));
        this.getView().showForm(showParameter);
    }

    /**
     * @Description: //回调，接收子页面传来的值
     * @param: e - [kd.bos.form.events.ClosedCallBackEvent]
     **/
    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        switch (actionId) {
            case "tpv_selectbreakdown":
                DynamicObjectCollection data = (DynamicObjectCollection) returnData;
                setValue(data);
                break;
            default:
                break;
        }
    }

    private void setValue(DynamicObjectCollection data) {
        if (data != null) {
            DynamicObjectCollection tpv_personinfor = data;
            this.getModel().deleteEntryData("tpv_costbreakdown");
            for (DynamicObject personinfor : tpv_personinfor) {
                int index = this.getModel().createNewEntryRow("tpv_costbreakdown");
                DynamicObject tpv_itemcode = personinfor.getDynamicObject("tpv_itemcode");  //商品编码
                if (null != tpv_itemcode) {
                    this.getView().getModel().setValue("tpv_itemcode", tpv_itemcode.getLong("id"),index);
                }
                DynamicObject tpv_conprodname = personinfor.getDynamicObject("tpv_conprodname");  //品名
                if (null != tpv_conprodname) {
                    this.getView().getModel().setValue("tpv_conprodname", tpv_conprodname.getLong("id"),index);
                }
                DynamicObject tpv_conorigin = personinfor.getDynamicObject("tpv_conorigin");  //产地
                if (null != tpv_conorigin) {
                    this.getView().getModel().setValue("tpv_conorigin", tpv_conorigin.getLong("id"),index);
                }
                DynamicObject tpv_costype = personinfor.getDynamicObject("tpv_costype");  //成本类型(货值/费用/返利)
                if (null != tpv_costype) {
                    this.getView().getModel().setValue("tpv_costype", tpv_costype.getLong("id"),index);
                }
                DynamicObject tpv_currency = personinfor.getDynamicObject("tpv_currency");  //币种
                if (null != tpv_currency) {
                    this.getView().getModel().setValue("tpv_currency", tpv_currency.getLong("id"),index);
                }
                DynamicObject tpv_soudocumtype = personinfor.getDynamicObject("tpv_soudocumtype");  //来源单据类型
                if (null != tpv_soudocumtype) {
                    this.getView().getModel().setValue("tpv_soudocumtype", tpv_soudocumtype.getString("number"),index);
                }
                DynamicObject tpv_tiggdoutype = personinfor.getDynamicObject("tpv_tiggdoutype");  //触发单据类型
                if (null != tpv_tiggdoutype) {
                    this.getView().getModel().setValue("tpv_tiggdoutype", tpv_tiggdoutype.getString("number"),index);
                }
                DynamicObject tpv_purconnum = personinfor.getDynamicObject("tpv_purconnum");  //采购合同号
                if (null != tpv_purconnum) {
                    this.getView().getModel().setValue("tpv_purconnum", tpv_purconnum.getLong("id"),index);
                }
                DynamicObject tpv_combinbun = personinfor.getDynamicObject("tpv_combinbun");  //组合号
                if (null != tpv_combinbun) {
                    this.getView().getModel().setValue("tpv_combinbun", tpv_combinbun.getLong("id"),index);
                }
                DynamicObject tpv_vendor = personinfor.getDynamicObject("tpv_vendor");  //供应商
                if (null != tpv_vendor) {
                    this.getView().getModel().setValue("tpv_vendor", tpv_vendor.getLong("id"),index);
                }
                DynamicObject tpv_logserpro = personinfor.getDynamicObject("tpv_logserpro");  //物流服务商
                if (null != tpv_logserpro) {
                    this.getView().getModel().setValue("tpv_logserpro", tpv_logserpro.getLong("id"),index);
                }
                DynamicObject tpv_saleconnum = personinfor.getDynamicObject("tpv_saleconnum");  //销售合同号
                if (null != tpv_saleconnum) {
                    this.getView().getModel().setValue("tpv_saleconnum", tpv_saleconnum.getLong("id"),index);
                }
                DynamicObject tpv_client = personinfor.getDynamicObject("tpv_client");  //客户
                if (null != tpv_client) {
                    this.getView().getModel().setValue("tpv_client", tpv_client.getLong("id"),index);
                }
                DynamicObject tpv_tradepropertys = personinfor.getDynamicObject("tpv_tradepropertys");  //贸易性质
                if (null != tpv_tradepropertys) {
                    this.getView().getModel().setValue("tpv_tradepropertys", tpv_tradepropertys.getLong("id"),index);
                }
                this.getModel().setValue("tpv_createtime",personinfor.getDate("tpv_createtime"),index); //创建时间
                this.getModel().setValue("tpv_modifytime",personinfor.getDate("tpv_modifytime"),index); //修改时间
                this.getModel().setValue("tpv_bluered",personinfor.getString("tpv_bluered"),index); //蓝/红
                this.getModel().setValue("tpv_costdirec",personinfor.getString("tpv_costdirec"),index); //成本方向
                this.getModel().setValue("tpv_ispointpriceed","A",index); //是否已点价
                this.getModel().setValue("tpv_tentauth",personinfor.getString("tpv_tentauth"),index); //暂估/真实
                this.getModel().setValue("tpv_origprice",personinfor.getBigDecimal("tpv_origprice"),index); //原币单价
                this.getModel().setValue("tpv_rate",personinfor.getBigDecimal("tpv_rate"),index); //税率
                this.getModel().setValue("tpv_origampintax",personinfor.getBigDecimal("tpv_origampintax"),index); //原币金额 （含税）
                this.getModel().setValue("tpv_origampnotax",personinfor.getBigDecimal("tpv_origampnotax"),index); //原币金额 （不含税）
                this.getModel().setValue("tpv_origamptax",personinfor.getBigDecimal("tpv_origamptax"),index); //原币金额 （税额）
                this.getModel().setValue("tpv_basampintax",personinfor.getBigDecimal("tpv_basampintax"),index); //本位币金额 （含税）
                this.getModel().setValue("tpv_basampnotax",personinfor.getBigDecimal("tpv_basampnotax"),index); //本位币金额 （不含税）
                this.getModel().setValue("tpv_basamptax",personinfor.getBigDecimal("tpv_basamptax"),index); //本位币金额 （税额）
                this.getModel().setValue("tpv_dollarintax",personinfor.getBigDecimal("tpv_dollarintax"),index); //美元金额 （含税）
                this.getModel().setValue("tpv_dollarnotax",personinfor.getBigDecimal("tpv_dollarnotax"),index); //美元金额 （不含税）
                this.getModel().setValue("tpv_dollartax",personinfor.getBigDecimal("tpv_dollartax"),index); //美元金额 （税额）
                this.getModel().setValue("tpv_soudocumnum",personinfor.getString("tpv_soudocumnum"),index); //来源单据号
                this.getModel().setValue("tpv_soudocumid",personinfor.getString("tpv_soudocumid"),index); //来源单据分录id
                this.getModel().setValue("tpv_tiggdounum",personinfor.getString("tpv_tiggdounum"),index); //触发单据号
                this.getModel().setValue("tpv_tiggdouid",personinfor.getString("tpv_tiggdouid"),index); //触发单据分录id
                this.getModel().setValue("tpv_storagenum",personinfor.getString("tpv_storagenum"),index); //入库单号
                this.getModel().setValue("tpv_storageid",personinfor.getString("tpv_storageid"),index); //入库单分录id
                this.getModel().setValue("tpv_supstoragenum",personinfor.getString("tpv_supstoragenum"),index); //上级入库单号
                this.getModel().setValue("tpv_supstorageid",personinfor.getString("tpv_supstorageid"),index); //上级入库单分录id
                this.getModel().setValue("tpv_movegoodsnum",personinfor.getString("tpv_movegoodsnum"),index); //货物流转单号
                this.getModel().setValue("tpv_movegoodsid",personinfor.getString("tpv_movegoodsid"),index); //货物流转单分录id
                this.getModel().setValue("tpv_msungoodsid",personinfor.getString("tpv_msungoodsid"),index); //货物流转单子分录id
                this.getModel().setValue("tpv_redqty",personinfor.getBigDecimal("tpv_redqty"),index); //可红冲数量
                this.getModel().setValue("tpv_elimination",personinfor.getString("tpv_elimination"),index); //冲销行ID
                this.getModel().setValue("tpv_drawback",personinfor.getString("tpv_drawback"),index); //是否退税
                this.getModel().setValue("tpv_refundrate",personinfor.getBigDecimal("tpv_refundrate"),index); //退税率
                this.getModel().setValue("tpv_adjustments",personinfor.getBigDecimal("tpv_adjustments"),index); //调整数量
            }
        }
    }

}
