package tpv.tpv_wm.tpv_cm.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.control.events.BeforeClickEvent;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;

/**
 * ClassName: FlexibleLimitedBaseEdit
 * Description:弹性额度设置插件(基础资料面板)
 * date: 2023/8/30 17:03
 *
 * @author: Guo jiaChen
 * @version:
 * @since JDK 1.8
 */
public class FlexibleLimitedBaseEdit extends AbstractBillPlugIn {
    private static final String BUTTON_SAVE = "tpv_btnsave";
    private static final String BUTTON_SAVE_NEW = "tpv_btnsaveandnew";


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(BUTTON_SAVE, BUTTON_SAVE_NEW);
    }

    @Override
    public void beforeClick(BeforeClickEvent evt) {
        super.beforeClick(evt);
        boolean sole = this.sole();
        if (sole) {
            evt.setCancel(true);
        }
    }

    /**
     * @param :
     * @return boolean
     * @author: chen
     * @date: 2023/11/19 16:59
     * @description: 是否失效
     */
    public boolean sole() {
        String value = (String) this.getModel().getValue("enable");
        DynamicObject[] query = BusinessDataServiceHelper.load("tpv_elasticlimit", "enable", null);
        for (DynamicObject initial : query) {
            String enable = (String) initial.get("enable");
            if ("1".equals(value) && "1".equals(enable)) {
                this.getView().showErrorNotification("已存在生效数据，不能添加!");
                return true;
            }
        }
        return false;
    }
}
