package tpv.tpv_wm.tpv_cm.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.FormOperate;

import java.util.*;

/**
 * WangShuGuang
 * 担保登记值更新
 */
public class GuaranteeFormPlugin extends AbstractBillPlugIn {
    @Override
    public void propertyChanged(PropertyChangedArgs e) {//触发时机：表单模型某个字段值改变的时候就会触发此事件//
        String propertyName = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        //监听原料成品对应关系字段，数量字段，商品编码字段
        if (propertyName.equals("tpv_startdate") || propertyName.equals("tpv_deadline")) {
            //监听原料成品对应关系改变
            judgeTime(cd);//原料成品对应关系改变计算方式改变
        }
        if (propertyName.equals("tpv_contractno")) {
            int selectedRowIndex = e.getChangeSet()[0].getRowIndex();
            DynamicObjectCollection paymentWaysCollection = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_bd_guarantee");
            List<DynamicObject> contractno = new ArrayList<>();
            for (DynamicObject dynamicObject : paymentWaysCollection) {
                contractno.add(dynamicObject.getDynamicObject("tpv_contractno"));
            }
            if (!contractno.isEmpty()) {
                Set<DynamicObject> set = new HashSet<>(contractno);
                if (set.size() < contractno.size()) {
                    this.getView().showMessage("同一个合同号不可出现多个,请重新填写");
                    this.getModel().setValue("tpv_contractno", null, selectedRowIndex);
                }
            }
        }
    }

    private void judgeTime(ChangeData cd) {
        Date startDate = (Date) this.getModel().getValue("tpv_startdate");
        Date endDate = (Date) this.getModel().getValue("tpv_deadline");
        if (startDate != null && endDate != null) {
            boolean before = endDate.before(startDate);
            if (before) {
                this.getView().showMessage("注意截止日期不能小于起止日期，请重新填写");
                this.getModel().setValue("tpv_deadline", null);
            }
        }
    }

    /**
     * 按钮操作执行前监听
     * 阻止删行
     *
     * @param args
     */
    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate operate = (FormOperate) args.getSource();
        String key = operate.getOperateKey();
        if (key.equals("submit")) {
            List<String> message = new ArrayList<>();
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            String tpvGuaranteescope = dataEntity.getString("tpv_guaranteescope");//担保范围
            DynamicObjectCollection tpvBdPaymentinfo = dataEntity.getDynamicObjectCollection("tpv_bd_paymentinfo");//担保人分录
            if (StringUtils.isNotEmpty(tpvGuaranteescope)) {
                if (StringUtils.equals(tpvGuaranteescope, "A")) {
                    DynamicObjectCollection tpvBdGuarantee = dataEntity.getDynamicObjectCollection("tpv_bd_guarantee");
                    if (tpvBdGuarantee.isEmpty()) {
                        message.add("当担保范围为[具体合同时]被担保合同分录至少有一行数据");
                    }
                }
            }
            if (!tpvBdPaymentinfo.isEmpty()) {
                for (DynamicObject dynamicObject : tpvBdPaymentinfo) {
                    int row = dynamicObject.getInt("Seq");
                    String tpvGuarantortype = dynamicObject.getString("tpv_guarantortype");//担保人类型
                    if (StringUtils.isNotEmpty(tpvGuarantortype)) {
                        if (StringUtils.equals(tpvGuarantortype, "A")) {
                            String tpvEnterprisename = dynamicObject.getString("tpv_enterprisename");//企业名称
                            if (StringUtils.isEmpty(tpvEnterprisename)) {
                                message.add("担保人分录第" + row + "行担保人类型为企业时企业名称必填");
                            }
                        } else if (StringUtils.equals(tpvGuarantortype, "B")) {
                            String tpvName = dynamicObject.getString("tpv_name");//姓名
                            String tpvIdcard = dynamicObject.getString("tpv_idcard");//身份证号
                            if (StringUtils.isEmpty(tpvName) || StringUtils.isEmpty(tpvIdcard)) {
                                message.add("担保人分录第" + row + "行担保人类型为个人时姓名和身份证号必填");
                            }
                        }
                    }
                }
            }
            if (!message.isEmpty()) {
                args.setCancel(true);
                this.getView().showMessage(String.join(",", message));
            }
        }
    }
}
