package tpv.tpv_wm.tpv_cm.java.formplugin.form;

import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.RefBillProp;
import kd.bos.form.field.RefBillEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.EventObject;
import java.util.List;

/**
 * @author l jw
 * @date 2023/9/22 15:54
 * @className PlanningBillPlugIn
 * @description 规划单表单插件
 */
public class PlanningFormPlugIn extends AbstractBillPlugIn implements BeforeF7SelectListener {
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();//获取分录的行下标
        DynamicObject dataEntity = changeData[0].getDataEntity();//获取值
        String propertyName = e.getProperty().getName();
        switch (name) {
            //高计单号
            case "tpv_highcoun":
                setIsFreeze(rowIndex);
                break;
            case "tpv_contractnu":
                contractnu(rowIndex);
                break;
            case  "tpv_documenttype":
                amout(rowIndex);
                break;
        }
    }

    /**
     *
     * @param rowIndex 设置必录
     */
    private void amout(int rowIndex) {
        String tpvDocumenttype = (String) this.getModel().getValue("tpv_documenttype");
        if ("A".equals(tpvDocumenttype)){
            RefBillEdit  textEdits = this.getView().getControl("tpv_purchasecontr");
            textEdits.setMustInput(true);
            RefBillProp textProps = (RefBillProp ) textEdits.getProperty();
            textProps.setMustInput(true);
            RefBillEdit  textEdit = this.getView().getControl("tpv_contractnu");
            textEdit.setMustInput(false);
            RefBillProp textProp = (RefBillProp ) textEdit.getProperty();
            textProp.setMustInput(false);
        }else {
            RefBillEdit  textEdit = this.getView().getControl("tpv_contractnu");
            textEdit.setMustInput(true);
            RefBillProp textProp = (RefBillProp ) textEdit.getProperty();
            textProp.setMustInput(true);
            RefBillEdit  textEdits = this.getView().getControl("tpv_purchasecontr");
            textEdits.setMustInput(false);
            RefBillProp textProps = (RefBillProp ) textEdits.getProperty();
            textProps.setMustInput(false);
        }

    }
    /**
     *
     * @param rowIndex 规划分录赋值
     */
    private void contractnu(int rowIndex) {
        DynamicObject tpvContractnu = (DynamicObject) this.getModel().getValue("tpv_contractnu");
        String string = tpvContractnu.getString("billno");
        String selectfields = DynamicObjectUtil.getSelectfields("tpv_dt_salescontract", false);
        //高低计单
        DynamicObject[] salescontract = BusinessDataServiceHelper.load("tpv_dt_salescontract", selectfields
                , new QFilter[]{new QFilter("billno",QCP.equals,string)});
        if (salescontract.length > 0) {
            for (int i = 0; i < salescontract.length; i++) {
                DynamicObject tpFreigro = salescontract[i];
                DynamicObject tpvDepartment = tpFreigro.getDynamicObject("tpv_department");//部门
                DynamicObject tpvCustomer = tpFreigro.getDynamicObject("tpv_customer");//客户
                DynamicObject tpvCurrency = tpFreigro.getDynamicObject("tpv_currency");//币别
                DynamicObject tpvOperator = tpFreigro.getDynamicObject("tpv_operator");//人员
                this.getModel().setValue("tpv_planforcustomers",tpvCustomer,rowIndex);
                this.getModel().setValue("tpv_currencyed",tpvCurrency,rowIndex);
                this.getModel().setValue("tpv_departmento",tpvDepartment,rowIndex);
                this.getModel().setValue("tpv_personnel",tpvOperator,rowIndex);
            }
        }
    }

    /**
     *
     * @param rowIndex 结算分录赋值
     */
    private void setIsFreeze(int rowIndex) {
        DynamicObject tpvHighcoun = (DynamicObject) this.getModel().getValue("tpv_highcoun");
        String string = tpvHighcoun.getString("billno");
        QFilter qFilter = new QFilter("billno", QCP.equals, string);
        qFilter.and("tpv_highjlowj", QCP.equals, "A");
        String selectfields = DynamicObjectUtil.getSelectfields("tpv_dt_highlowj", false);
        String entrySelectfields = DynamicObjectUtil.getEntrySelectfields(selectfields, "tpv_dt_highlowj", "tpv_dt_highlowj_si", false);
        //高低计单
        DynamicObject[] purchases = BusinessDataServiceHelper.load("tpv_dt_highlowj", entrySelectfields
                , new QFilter[]{qFilter});
        if (purchases.length > 0) {
            for (int i = 0; i < purchases.length; i++) {
                DynamicObject tpFreigro = purchases[i];
                DynamicObjectCollection tpvMaterialentry = tpFreigro.getDynamicObjectCollection("tpv_dt_highlowj_si");
                for (DynamicObject dynamicObject : tpvMaterialentry) {
                    BigDecimal tpvQuantity;//卷号数量合计
                    String tpvBusinesstype = dynamicObject.getString("tpv_businesstype");//业务类型
                    DynamicObject tpvSalescontract = dynamicObject.getDynamicObject("tpv_salescontract");//销售合同
                    DynamicObject tpvPurchasecontract = dynamicObject.getDynamicObject("tpv_purchasecontract");//采购合同
                    DynamicObject tpvClientele = dynamicObject.getDynamicObject("tpv_clientele");//客户
                    DynamicObject tpvCurrency = tpFreigro.getDynamicObject("tpv_currency");//币种
                    BigDecimal tpvNocavamount = dynamicObject.getBigDecimal("tpv_nocavamount");//未核销金额
                    DynamicObjectCollection tpvCmPlanningGh= (DynamicObjectCollection) this.getModel().getValue("tpv_cm_planning_gh");//分录数据
                    tpvQuantity=BigDecimal.ZERO;
                    for (DynamicObject subentrty:tpvCmPlanningGh){
                        tpvQuantity=tpvQuantity.add(subentrty.getBigDecimal("tpv_amount"));
                    }
                    BigDecimal tpvPlannedjssj = BigDecimal.ZERO;
                    if (tpvQuantity.compareTo(BigDecimal.ZERO) == 1) {
                        tpvPlannedjssj = tpvNocavamount.subtract(tpvQuantity);
                    } else {
                        tpvPlannedjssj = tpvNocavamount;
                    }
                    Date tpvBizdate = tpFreigro.getDate("tpv_bizdate");//结算日期
                    DynamicObject tpvOperator = tpFreigro.getDynamicObject("tpv_operator");//业务员
                    DynamicObject tpvDepartment = tpFreigro.getDynamicObject("tpv_department");//部门
                    this.getModel().setValue("tpv_businesstypes", tpvBusinesstype,rowIndex);
                    this.getModel().setValue("tpv_contractnumber", tpvSalescontract,rowIndex);//销售合同
                    this.getModel().setValue("tpv_purchasecontract", tpvPurchasecontract,rowIndex);
                    this.getModel().setValue("tpv_customerf", tpvClientele,rowIndex);
                    this.getModel().setValue("tpv_currencyf", tpvCurrency,rowIndex);
                    this.getModel().setValue("tpv_writtenoffs", tpvNocavamount,rowIndex);
                    this.getModel().setValue("tpv_plannedjssj", tpvPlannedjssj,rowIndex);
                    this.getModel().setValue("tpv_datef", tpvBizdate,rowIndex);
                    this.getModel().setValue("tpv_user", tpvOperator,rowIndex);
                    this.getModel().setValue("tpv_departmentf", tpvDepartment,rowIndex);
                }
            }
        }
    }

    /**
     *
     * @param e 字段过滤
     */
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        RefBillEdit tpvContractnu = (RefBillEdit) this.getView().getControl("tpv_contractnu");  //基础资料字段标识
        if (tpvContractnu!=null){
            tpvContractnu.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        }
        RefBillEdit tpvPurchasecontr = (RefBillEdit) this.getView().getControl("tpv_purchasecontr");  //基础资料字段标识
        if (tpvContractnu!=null){
            tpvPurchasecontr.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        }
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpvDepartments = dataEntity.getDynamicObject("tpv_departments");//部门
        DynamicObject org = dataEntity.getDynamicObject("org");//公司
        DynamicObject tpvCurrency = (DynamicObject) this.getModel().getValue("tpv_currency");//币种
        DynamicObject tpvTradeproperty = (DynamicObject) this.getModel().getValue("tpv_tradeproperty");//贸易性质
        if (tpvDepartments != null) {
            String deparments = tpvDepartments.getString("name");
            QFilters.add(new QFilter("tpv_department.name", QCP.equals, deparments));
        }
        if (org != null) {
            String string = org.getString("number");
            QFilters.add(new QFilter("org.number", QCP.equals, string));
        }
        if (tpvTradeproperty != null) {
            String number = tpvTradeproperty.getString("number");
            QFilters.add(new QFilter("tpv_tradeproperty.number",QCP.equals,number));
        }
        if(tpvCurrency!=null){
            String number = tpvCurrency.getString("number");
            QFilters.add(new QFilter("tpv_currency.number",QCP.equals,number));
        }
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }
}
