package tpv.tpv_wm.tpv_cm.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.EventObject;
import java.util.List;

/**
 * @ClassName: SpecialContractFormPlugin
 * @Description: 特殊合同表单插件
 * @author: zbh
 * @date: 2024-06-06
 */
public class SpecialContractFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_sapunum":
                sapuNum();
                break;
            case "tpv_docnum":
                EntryGrid entryGridHt = this.getControl("tpv_cm_tsht_trade");//商品明细
                int[] selectRowsHt = entryGridHt.getSelectRows();//获取选中的行号、
                if (selectRowsHt.length == 1) {
                    this.getModel().setValue("tpv_productname", null, selectRowsHt[0]);//商品名称
                    this.getModel().setValue("tpv_contractdates", null, selectRowsHt[0]);//签约日期
                    this.getModel().setValue("tpv_quantity", null, selectRowsHt[0]);//数量
                    this.getModel().setValue("tpv_countname", null, selectRowsHt[0]);//相对方
                    this.getModel().setValue("tpv_cousomer", null, selectRowsHt[0]);//客户
                    this.getModel().setValue("tpv_counterparty", null, selectRowsHt[0]);//供应商
                    this.getModel().setValue("tpv_departmentmx",null, selectRowsHt[0]);//部门
                    this.getModel().setValue("tpv_cur",null, selectRowsHt[0]);//币别
                    this.getModel().setValue("tpv_amount",null, selectRowsHt[0]);//含税金额
                }
                break;
        }
    }

    private void sapuNum() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        EntryGrid entryGridHt = this.getControl("tpv_cm_tsht_trade");//商品明细
        int[] selectRowsHt = entryGridHt.getSelectRows();//获取选中的行号
        if (selectRowsHt.length == 1) {
            DynamicObjectCollection tpvCmTshtTrade = dataEntity.getDynamicObjectCollection("tpv_cm_tsht_trade");
            String tpvDocnum = tpvCmTshtTrade.get(selectRowsHt[0]).getString("tpv_docnum");
            DynamicObject tpvSapunum = tpvCmTshtTrade.get(selectRowsHt[0]).getDynamicObject("tpv_sapunum");
            if ("tpv_bd_purcontrnum".equals(tpvDocnum) && tpvSapunum != null) {//采购
                boolean tpvDtSalescontract1 = QueryServiceHelper.exists("tpv_dt_purchase", tpvSapunum.getPkValue());
                if (tpvDtSalescontract1){
                    DynamicObject tpvDtPurchase = BusinessDataServiceHelper.loadSingle(tpvSapunum.getPkValue(), "tpv_dt_purchase");
                    Date tpvDateofcontracting = tpvDtPurchase.getDate("tpv_dateofcontracting");//签约日
                    DynamicObject tpvSupplier = tpvDtPurchase.getDynamicObject("tpv_supplier");
                    DynamicObjectCollection tpvMaterialentrys = tpvDtPurchase.getDynamicObjectCollection("tpv_materialentry");
                    String builder = "";
                    BigDecimal decimal = BigDecimal.ZERO;
                    BigDecimal taxprAmount = BigDecimal.ZERO;
                    for (DynamicObject tpvMaterialentry : tpvMaterialentrys) {
                        decimal = decimal.add(tpvMaterialentry.getBigDecimal("tpv_qty"));
                        taxprAmount = taxprAmount.add(tpvMaterialentry.getBigDecimal("tpv_taxpramount"));
                        String name = tpvMaterialentry.getDynamicObject("tpv_material").getString("name");
                        if (builder.length() == 0) {
                            builder = builder + name;
                        } else {
                            if (!builder.contains(name)) {
                                builder = builder + "," + name;
                            }
                        }
                    }
                    this.getModel().setValue("tpv_productname", builder, selectRowsHt[0]);//商品名称
                    this.getModel().setValue("tpv_contractdates", tpvDateofcontracting, selectRowsHt[0]);//签约日期
                    this.getModel().setValue("tpv_quantity", decimal, selectRowsHt[0]);//数量
                    this.getModel().setValue("tpv_counterparty", tpvSupplier, selectRowsHt[0]);//供应商
                    this.getModel().setValue("tpv_countname", tpvSupplier==null?"":tpvSupplier.get("name"), selectRowsHt[0]);//相对方
                    this.getModel().setValue("tpv_departmentmx",tpvDtPurchase.getDynamicObject("tpv_department"), selectRowsHt[0]);//部门
                    this.getModel().setValue("tpv_cur",tpvDtPurchase.getDynamicObject("tpv_currency"), selectRowsHt[0]);//币别
                    this.getModel().setValue("tpv_amount",taxprAmount, selectRowsHt[0]);//含税金额
                }
            }
            if ("tpv_bd_salescontract".equals(tpvDocnum) && tpvSapunum != null) {//销售
                DynamicObject tpvDtSalescontract = BusinessDataServiceHelper.loadSingle(tpvSapunum.getPkValue(), "tpv_dt_salescontract");
                Date tpvDateofcontracting = tpvDtSalescontract.getDate("tpv_signingdate");//签约日
                DynamicObject tpvCustomer = tpvDtSalescontract.getDynamicObject("tpv_customer");
                DynamicObjectCollection tpvMaterialentrys = tpvDtSalescontract.getDynamicObjectCollection("tpv_materialentry");
                String builder = "";
                BigDecimal decimal = BigDecimal.ZERO;
                BigDecimal taxprAmount = BigDecimal.ZERO;
                for (DynamicObject tpvMaterialentry : tpvMaterialentrys) {
                    decimal = decimal.add(tpvMaterialentry.getBigDecimal("tpv_qty"));
                    taxprAmount = taxprAmount.add(tpvMaterialentry.getBigDecimal("tpv_taxpramount"));
                    String name = tpvMaterialentry.getDynamicObject("tpv_material").getString("name");
                    if (builder.length() == 0) {
                        builder = builder + name;
                    } else {
                        if (!builder.contains(name)) {
                            builder = builder + "," + name;
                        }
                    }
                }
                this.getModel().setValue("tpv_productname", builder, selectRowsHt[0]);//商品名称
                this.getModel().setValue("tpv_contractdates", tpvDateofcontracting, selectRowsHt[0]);//签约日期
                this.getModel().setValue("tpv_quantity", decimal, selectRowsHt[0]);//数量
                this.getModel().setValue("tpv_cousomer", tpvCustomer, selectRowsHt[0]);//客户
                this.getModel().setValue("tpv_countname", tpvCustomer==null?"":tpvCustomer.get("name"), selectRowsHt[0]);//相对方
                this.getModel().setValue("tpv_departmentmx",tpvDtSalescontract.getDynamicObject("tpv_department"), selectRowsHt[0]);//部门
                this.getModel().setValue("tpv_cur",tpvDtSalescontract.getDynamicObject("tpv_currency"), selectRowsHt[0]);//币别
                this.getModel().setValue("tpv_amount",taxprAmount, selectRowsHt[0]);//含税金额
            }
            if ("".equals(tpvDocnum)||tpvSapunum == null) {
                this.getModel().setValue("tpv_productname", null, selectRowsHt[0]);//商品名称
                this.getModel().setValue("tpv_contractdates", null, selectRowsHt[0]);//签约日期
                this.getModel().setValue("tpv_quantity", null, selectRowsHt[0]);//数量
                this.getModel().setValue("tpv_countname", null, selectRowsHt[0]);//相对方
                this.getModel().setValue("tpv_cousomer", null, selectRowsHt[0]);//客户
                this.getModel().setValue("tpv_counterparty", null, selectRowsHt[0]);//供应商
                this.getModel().setValue("tpv_departmentmx",null, selectRowsHt[0]);//部门
                this.getModel().setValue("tpv_cur",null, selectRowsHt[0]);//币别
                this.getModel().setValue("tpv_amount",null, selectRowsHt[0]);//含税金额
            }
        }

    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit tpv_sapunum = (BasedataEdit) this.getView().getControl("tpv_sapunum");
        tpv_sapunum.addBeforeF7SelectListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        switch (name){
            case"tpv_sapunum":
                ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
                EntryGrid entryGridHt = this.getControl("tpv_cm_tsht_trade");//商品明细
                int[] selectRowsHt = entryGridHt.getSelectRows();//获取选中的行号
                List<QFilter> qFilters = new ArrayList<>();
                if (selectRowsHt.length == 1) {
                    DynamicObjectCollection tpvCmTshtTrade = dataEntity.getDynamicObjectCollection("tpv_cm_tsht_trade");
                    String tpvDocnum = tpvCmTshtTrade.get(selectRowsHt[0]).getString("tpv_docnum");//合同类型
                    if ("tpv_bd_purcontrnum".equals(tpvDocnum)){//采购合同号
                        qFilters.add(new QFilter("tpv_billkey", "=", "tpv_dt_purchase"));
                    }else if ("tpv_bd_salescontract".equals(tpvDocnum)){
                        String tpvContracttype = dataEntity.getString("tpv_contracttype");//单据类型
                        if ("A".equals(tpvContracttype)){
                            DynamicObject tpvCompany = dataEntity.getDynamicObject("tpv_company");
                            DynamicObject tpvDepartment = dataEntity.getDynamicObject("tpv_department");
                            if (tpvDepartment==null||tpvCompany==null){
                                this.getView().showTipNotification("请填写公司，部门");
                                e.setCancel(true);
                            }
                            List<String> list = new ArrayList<>();
                            list.add("tpv_dt_salescontract_CKXS");
                            list.add("tpv_dt_salescontract_ZKXS");
                            qFilters.add(new QFilter("tpv_documenttypes.number", "in", list));
                            if (tpvCompany!=null){
                                qFilters.add(new QFilter("tpv_company", "=", tpvCompany.getPkValue()));
                            }
                            if (tpvDepartment!=null){
                                qFilters.add(new QFilter("tpv_department", "=", tpvDepartment.getPkValue()));
                            }
                        }
                    }
                }
                showParameter.getListFilterParameter().setQFilters(qFilters);
                break;
        }
    }
}
