package tpv.tpv_wm.tpv_cm.java.formplugin.list;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.IFormView;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.list.BillList;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

/**
 * @Description: 成本处理 -列表插件 显示成本id
 * @Author LinRui
 * @Date 2024/6/6 19:15
 */
public class CostdisposeListPlugin extends AbstractListPlugin {

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        IFormView view = this.getView();
        String operateKey = e.getOperateKey();
        switch (operateKey) {
            case "costdisposeid":
                BillList billList = this.getControl("billlistap");
                ListSelectedRowCollection selectedRows = billList.getSelectedRows();
                if (selectedRows != null && selectedRows.size() > 0) {
                    for (ListSelectedRow tempData : selectedRows) {
                        DynamicObject dynamic = BusinessDataServiceHelper.loadSingle(tempData.getPrimaryKeyValue(), "tpv_cm_costdispose");
                        dynamic.set("tpv_viewfid", String.valueOf(dynamic.getLong("id")));
                        SaveServiceHelper.update(dynamic);
                    }
                    this.getView().invokeOperation("refresh");
                }
                break;
            default:
                break;
        }
    }
}
