package tpv.tpv_wm.tpv_cm.java.formplugin.list;

import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.list.IListView;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * ClassName: LawSuitBillListPlugin
 * Description: 诉讼案件 进展描述动态表单回填
 * date: 2023/11/4 15:22
 * author: Guo jiaChen
 */
public class LawSuitBillListPlugin extends AbstractListPlugin {
    @Override
    public void itemClick(ItemClickEvent evt) {
        String key = evt.getItemKey();
        List<Long> billId = this.getListBillId();
        if (billId.size() > 0) {
            DynamicObject dataEntity = BusinessDataServiceHelper.loadSingle(billId.get(0), "tpv_cm_ssaj");
            switch (key) {
                case "tpv_baritemap2":
                    if (billId.size() == 1) {
                        // 创建弹出动态表单页面对象
                        FormShowParameter showParameter = new FormShowParameter();
                        // 设置弹出页面的标识
                        showParameter.setFormId("tpv_cm_lawsuit");
                        // 状态
                        showParameter.setStatus(OperationStatus.ADDNEW);
                        // 设置页面关闭回调方法
                        showParameter.setCloseCallBack(new CloseCallBack(this, "baritemap2"));
                        // 设置弹出页面打开方式
                        showParameter.getOpenStyle().setShowType(ShowType.Modal);
                        // 打开动态表单
                        this.getView().showForm(showParameter);
                    } else if (billId.size() > 1) {
                        this.getView().showErrorNotification("请只选择一条数据进行回填！");
                    }
                    break;
                default:
                    break;
            }
        } else {
            //未选择列表数据时,提示用户
            this.getView().showErrorNotification("请先选择一条数据！");
        }
    }

    /**
     * @param values:
     * @return void
     * @author: chen
     * @date: 2023/11/19 0:21
     * @description: 获取返回的数据赋到单居体上
     */
    private void setInwardInfo(Map<String, Object> values) {

        List<Long> billId = this.getListBillId();
        DynamicObject dataEntity = BusinessDataServiceHelper.loadSingle(billId.get(0), "tpv_cm_ssaj");
        DynamicObjectCollection entryEntities = (DynamicObjectCollection) values.get("tpv_entryentity");
        DynamicObjectCollection billEntity = dataEntity.getDynamicObjectCollection("tpv_entryentity");
        if (entryEntities != null && billEntity != null) {
            for (DynamicObject entryEntity : entryEntities) {
                DynamicObject entity = billEntity.addNew();
                entity.set("tpv_description", entryEntity.get("tpv_description"));
                entity.set("tpv_recordpeopl", entryEntity.get("tpv_recordpeopl"));
                entity.set("tpv_jldatetime", entryEntity.get("tpv_jldatetime"));
                SaveServiceHelper.save(new DynamicObject[]{dataEntity});
            }
        }

    }

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        Object returnData = closedCallBackEvent.getReturnData();
        // 判断标识是否匹配，并验证返回值不为空，不验证返回值可能会报空指针
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "baritemap2")
                && null != closedCallBackEvent.getReturnData()) {
            // 这里返回对象为Object，可强转成相应的其他类型，
            // 单条数据可用String类型传输，返回多条数据可放入map中，也可使用json等方式传输
            HashMap<String, Object> values = (HashMap<String, Object>) returnData;
            this.setInwardInfo(values);
            this.getView().showSuccessNotification("保存成功!");
        }
    }

    /**
     * 获取单据id
     */
    private List<Long> getListBillId() {
        IListView view = (IListView) this.getView();
        ListSelectedRowCollection selectedRows = view.getSelectedRows();// 查询列表所勾选的数据
        List<Long> billId = new ArrayList<>();
        for (ListSelectedRow listSelectedRow : selectedRows) {
            Object pkId = listSelectedRow.getPrimaryKeyValue();// 遍历获得每条数据的内码
            if (!billId.contains((long) pkId)) {
                billId.add((long) pkId);
            }
        }
        return billId;
    }

}



