package tpv.tpv_wm.tpv_cm.java.opplugin.convert;

import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * @ClassName: AltimeterConvert
 * @Description: 高低计核销工作台下推插件(高低计->高低计核销)
 * @date: 2023/11/17 9:58
 * @author: Guo jiaChen
 */
public class AltimeterConvert extends AbstractConvertPlugIn {
    private static final String targetName = "tpv_cm_altverification";
    private static final String VerificationEntryDetail = "tpv_verificatedetail";
    private static final String SettleEntryDetail = "tpv_settledetail";
    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        OperateOption option = this.getOption();
        boolean has = option.containsVariable("type");
        if (has){
            ExtendedDataEntity[] entryentitiess = e.getTargetExtDataEntitySet().FindByEntityKey(targetName);
            for (ExtendedDataEntity dataEntity : entryentitiess) {
                //目标单
                DynamicObject targetBill = dataEntity.getDataEntity();
                String type = option.getVariableValue("type");//类型
                String settleAccount = option.getVariableValue("settleAccount");//结算方
                DynamicObject supplier = null;
                if (settleAccount != null) {
                       supplier = BusinessDataServiceHelper.loadSingle("bd_supplier", settleAccount, new QFilter[]{});
                }
                targetBill.set("tpv_verificationtype",type);
                targetBill.set("tpv_settleaccount",supplier);
                if (!type.equals("A")){
                    DynamicObjectCollection collection = targetBill.getDynamicObjectCollection(SettleEntryDetail);
                    for (int i = 0; i < collection.size(); i++) {
                        DynamicObject object = collection.get(i);
                        DataEntityPropertyCollection properties = object.getDynamicObjectType().getProperties();
                        DynamicObjectCollection subCollection = object.getDynamicObjectCollection(VerificationEntryDetail);
                        DataEntityPropertyCollection properties2 = subCollection.getDynamicObjectType().getProperties();
                        DynamicObject addNew = subCollection.addNew();
                        addNew.set("tpv_altimeternum1",object.get("tpv_altimeternum"));//高低计
                        addNew.set("tpv_salecontract1",object.get("tpv_salecontract"));//销售合同号
                        addNew.set("tpv_purcontract1",object.get("tpv_purcontract"));//采购合同号
                        addNew.set("tpv_customer1",object.get("tpv_customer"));//客户
                        addNew.set("tpv_supper1",object.get("tpv_supper"));//供应商
                        addNew.set("tpv_businesstype1",object.get("tpv_businesstype"));//业务类型
                        addNew.set("tpv_highorlow1",object.get("tpv_highorlow"));//高计/低计
                        addNew.set("tpv_material1",object.get("tpv_material"));//商品编码
                        addNew.set("tpv_prodname1",object.get("tpv_prodname"));//品名
                        addNew.set("tpv_description1",object.get("tpv_description"));//商品属性描述
                        addNew.set("tpv_tradepropertys1",object.get("tpv_tradepropertys"));//贸易性质
                        addNew.set("tpv_unit1",object.get("tpv_unit"));//计量单位
                        addNew.set("tpv_altverunmtax",object.get("tpv_unmtax"));//未核销金额（含税）
                        addNew.set("tpv_altverunm",object.get("tpv_unm"));//未核销金额（不含税）
                        addNew.set("tpv_intaxrate1",object.get("tpv_intaxrate"));//增值税率
                        object.set("tpv_amounttax",object.get("tpv_unmtax"));//核销金额（含税）
                        object.set("tpv_altveramt",object.get("tpv_unm"));//核销金额（不含税）
                        object.set("tpv_amountintax",object.getBigDecimal("tpv_unmtax").subtract(object.getBigDecimal("tpv_unm")));//核销金额（增值税额）
                        addNew.set("tpv_amounttax1",object.get("tpv_unmtax"));//核销金额（含税）
                        addNew.set("tpv_amountnotax1",object.get("tpv_unm"));//核销金额（不含税）
                        addNew.set("tpv_amountintax1",object.getBigDecimal("tpv_unmtax").subtract(object.getBigDecimal("tpv_unm")));//核销金额（增值税额）
                        addNew.set("tpv_dept1",object.get("tpv_dept"));//部门
                        addNew.set("tpv_user1",object.get("tpv_user"));//人员
                        addNew.set("tpv_firm1",object.get("tpv_firm"));//公司
                        addNew.set("tpv_srcbillentryid1",object.get("tpv_srcbillentryid"));//来源单据分录id
                        addNew.set("tpv_srcbillno1",object.get("tpv_srcbillno"));//来源单据分录id
                    }
                }
            }
        }
    }
}
