package tpv.tpv_wm.tpv_cm.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

/**
 * WangShuGuang
 * 客商黑名单校验
 */
public class BlacklistOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        String operationKey = e.getOperationKey();
        switch (operationKey) {
            //监听点击保存按钮
            case "save":
                amendTrue(e);
                break;
            case "delete":
                amendFalse(e);
                break;
            default:
                break;
        }
    }

    public void amendTrue(BeforeOperationArgs e) {
        DynamicObject[] entities = e.getDataEntities();
        for (DynamicObject bill : entities) {
            String tpvAsstacttypes = bill.getString("tpv_asstacttypes");
            DynamicObject dynamicObject = bill.getDynamicObject("tpv_receivabless");
            if (null != tpvAsstacttypes && null != dynamicObject) {
                Long materiaId = dynamicObject.getLong("id");
                if (tpvAsstacttypes.equals("bd_customer")) {
                    DynamicObject customer = (DynamicObject) BusinessDataServiceHelper.loadSingle(materiaId, "bd_customer");
                    customer.set("tpv_blacklist", true);
                    SaveServiceHelper.update(customer);
                } else if (tpvAsstacttypes.equals("bd_supplier")) {
                    DynamicObject supplier = (DynamicObject) BusinessDataServiceHelper.loadSingle(materiaId, "bd_supplier");
                    supplier.set("tpv_blacklist", true);
                    SaveServiceHelper.update(supplier);
                }
            }
        }
    }

    public void amendFalse(BeforeOperationArgs e) {
        DynamicObject[] entities = e.getDataEntities();
        for (DynamicObject bill : entities) {
            bill = BusinessDataServiceHelper.loadSingle(bill.getPkValue(), bill.getDynamicObjectType().getName());
            String tpvAsstacttypes = bill.getString("tpv_asstacttypes");
            DynamicObject dynamicObject = bill.getDynamicObject("tpv_receivabless");
            if (null != tpvAsstacttypes && null != dynamicObject) {
                Long materiaId = dynamicObject.getLong("id");
                if (tpvAsstacttypes.equals("bd_customer")) {
                    DynamicObject customer = (DynamicObject) BusinessDataServiceHelper.loadSingle(materiaId, "bd_customer");
                    customer.set("tpv_blacklist", false);
                    SaveServiceHelper.update(customer);
                } else if (tpvAsstacttypes.equals("bd_supplier")) {
                    DynamicObject supplier = (DynamicObject) BusinessDataServiceHelper.loadSingle(materiaId, "bd_supplier");
                    supplier.set("tpv_blacklist", false);
                    SaveServiceHelper.update(supplier);
                }
            }
        }
    }
}
