package tpv.tpv_wm.tpv_cm.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

/**
 * 合同模板反审核将合同条款中的是否调整改为否
 * @author zhangh
 *
 */
public class ContractTemplateUnAuditOp extends AbstractOperationServicePlugIn {
	
	@Override
	public void afterExecuteOperationTransaction(AfterOperationArgs e) {
		if (this.getOperationResult().isSuccess()) {
			DynamicObject[] dataEntity = e.getDataEntities();
			for (DynamicObject data : dataEntity) {
				data = BusinessDataServiceHelper.loadSingleFromCache(data.getPkValue(), data.getDataEntityType().getName());
				updateChangenum(data);
			}
		}
	}

	/**
	 * 反审核修改是否
	 * @param data
	 */
	private void updateChangenum(DynamicObject data) {
		data.set("tpv_newtemplate", false);
		DynamicObjectCollection tpv_clauseimport = data.getDynamicObjectCollection("tpv_contractterms");
		for (int i = 0; i < tpv_clauseimport.size(); i++) {
			DynamicObject clauseimport = tpv_clauseimport.get(i);
			clauseimport.set("tpv_adjust", false);
		}
		SaveServiceHelper.save(new DynamicObject[] {data});		
	}
}
