package tpv.tpv_wm.tpv_cm.java.opplugin.op;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import tpv.tpv_wm.tpv_cm.java.utils.CostHelper;

import java.util.List;

import static tpv.tpv_wm.tpv_cm.java.utils.CostHelper.getCostColKeys;

/**
 * @author lipan
 * @date 2023/11/16 11:37
 * @className CostOp
 * @description 2.0成本服务插件
 */
@Deprecated
public class CostOp extends AbstractOperationServicePlugIn {

    /**
     * 校验
     */
    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        String operationKey = e.getOperationKey();
        DynamicObject[] dataEntities = e.getDataEntities();
        for (DynamicObject dataEntity : dataEntities) {
            String name = dataEntity.getDataEntityType().getName();
        }
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        String operationKey = e.getOperationKey();//获取操作名称
        DynamicObject[] dataEntities = e.getDataEntities();
        for (DynamicObject dataEntity : dataEntities) {
            Long tpvSrcredid = 0l; //红冲前单据id
            String tpvSrcredbillno = ""; //红冲前单据编号
            String entityName = dataEntity.getDataEntityType().getName();//获取单据标识
            DynamicObject Data = BusinessDataServiceHelper.loadSingle(dataEntity.getPkValue(), entityName);
            if (!isFilter(entityName, operationKey, Data)) ////判断是否满足过滤条件
            {
                break;//代表没有满足过滤条件
            }
            switch (entityName + operationKey) {
                case "im_purinbillaudit"://采购入库单的成本处理
                case "im_purinbillcostsetop"://采购入库单的成本处理
                    String biztypenumber = ""; //业务类型
                    DynamicObject biztype = Data.getDynamicObject("biztype");
                    if (null != biztype) {
                        biztypenumber = biztype.getString("number");
                    }
                    if ("110".equals(biztypenumber) ||"1102".equals(biztypenumber) || "1103".equals(biztypenumber))  //【业务类型】=”110	物料类采购“、“1102物料类采购退补货“、”1103物料类采购退换货”
                    {
                        Createcostdispose(CostHelper.Estimatedreceived(dataEntity));//蓝字（货值入库暂估）
                        Createcostdispose(CostHelper.Estimationinboundexpenses(dataEntity));//蓝字（货物流转单费用暂估）
                        Createcostdispose(CostHelper.Estimationexpenses(dataEntity));//蓝字（入库单费用暂估）
                    }
                    if ("1101".equals(biztypenumber))  //【业务类型】=“1101	物料类采购退货”
                    {
                        Createcostdispose(CostHelper.ResultPurInGargoValue(dataEntity));//（退货入库货值）
                        Createcostdispose(CostHelper.ResultPurInoutboundredorblue(Data,entityName));//遍历生成出库（红字）遍历生成出库（蓝字）
                        Createcostdispose(CostHelper.ResultPurInSubordinates(Data,entityName));//遍历出库（红字）
                    }
                    break;
                case "tpv_dt_purinvomateraudit"://采购发票匹配单的成本处理
                case "tpv_dt_wbillcromateraudit"://货票对应单的成本处理
                case "tpv_dt_purinvomatertakeeffect"://采购发票匹配单的成本处理
                case "tpv_dt_wbillcromatertakeeffect"://货票对应单的成本处理
                    tpvSrcredid = Data.getLong("tpv_srcredid"); //红冲前id
                    tpvSrcredbillno = Data.getString("tpv_srcredbillno"); //红冲前单据编号
                    if (YEM.isNotEmpty(tpvSrcredid) && YEM.isNotEmpty(tpvSrcredbillno)) {
                        Createcostdispose(CostHelper.EstAndRealredorblue(Data,entityName)); //红冲单红蓝数据(直接copy红冲前单据生成的入库数据)
                        Createcostdispose(CostHelper.Traverseoutboundredorblue(Data,entityName));//遍历生成出库（红字）遍历生成出库（蓝字）
                        Createcostdispose(CostHelper.TraverseSubordinates(Data,entityName));//遍历出库（红字）
                    } else {
                        Createcostdispose(CostHelper.Redreceiptestimation(Data,entityName));//红冲（入库暂估）
                        Createcostdispose(CostHelper.Realbluefontstorage(Data,entityName));//生成蓝字入库真实
                        Createcostdispose(CostHelper.Traverseoutboundredorblue(Data,entityName));//遍历生成出库（红字）遍历生成出库（蓝字）
                        Createcostdispose(CostHelper.TraverseSubordinates(Data,entityName));//遍历出库（红字）
                    }
                    break;
                case "tpv_dt_costbillmataudit"://费用发票匹单的成本处理
                case "tpv_dt_costbillmattakeeffect"://费用发票匹单的成本处理
                    tpvSrcredid = Data.getLong("tpv_srcredid"); //红冲前id
                    tpvSrcredbillno = Data.getString("tpv_srcredbillno"); //红冲前单据编号
                    if (YEM.isNotEmpty(tpvSrcredid) && YEM.isNotEmpty(tpvSrcredbillno)) {
                        Createcostdispose(CostHelper.EstAndRealredorblue(Data,entityName)); //红冲单红蓝数据(直接copy红冲前单据生成的入库数据)
                        Createcostdispose(CostHelper.FeesTraverseoutboundredorblue(Data,entityName));//遍历生成出库（红字）遍历生成出库（蓝字）
                        Createcostdispose(CostHelper.FeesTraverseSubordinates(Data,entityName));//遍历出库（红字）
                    } else {
                        Createcostdispose(CostHelper.FeesRedreceiptestimation(Data,entityName));//红冲（入库暂估）
                        Createcostdispose(CostHelper.Realbluefontstorage(Data,entityName));//生成蓝字入库真实
                        Createcostdispose(CostHelper.FeesTraverseoutboundredorblue(Data,entityName));//遍历生成出库（红字）遍历生成出库（蓝字）
                        Createcostdispose(CostHelper.FeesTraverseSubordinates(Data,entityName));//遍历出库（红字）
                    }
                    break;
                case "im_transdirbillaudit"://直接调拨单的成本处理
                case "im_transdirbillcostsetop"://直接调拨单的成本处理
                    Createcostdispose(CostHelper.TransOutGoodsValue(Data,entityName));//调出货值成本
                    Createcostdispose(CostHelper.TransOutCost(Data,entityName));//调出费用成本
                    Createcostdispose(CostHelper.TransInGoodsValue(Data,entityName));//调入货值成本
                    Createcostdispose(CostHelper.TransInCostOld(Data,entityName));//调入费用成本 -原
                    Createcostdispose(CostHelper.TransInCostNew(dataEntity));//调入费用成本 -新
                    break;
                case "im_transoutbillaudit"://分步调出单的成本处理
                case "im_transoutbillcostsetop"://分步调出单的成本处理
                    Createcostdispose(CostHelper.TransOutGoodsValue(Data,entityName));//调出货值成本
                    Createcostdispose(CostHelper.TransOutCost(Data,entityName));//调出费用成本
                    break;
                case "im_transinbillaudit"://分步调入单的成本处理
                case "im_transinbillcostsetop"://分步调入单的成本处理
                    Createcostdispose(CostHelper.TransInGoodsValue(Data,entityName));//调入货值成本
                    Createcostdispose(CostHelper.TransInCostOld(Data,entityName));//调入费用成本 -原
                    Createcostdispose(CostHelper.TransInExpenses(dataEntity));//调入费用成本 -新
                    break;
                case "im_otheroutbillaudit"://其他出库单的成本处理
                case "im_otheroutbillcostsetop"://其他出库单的成本处理
                    Createcostdispose(CostHelper.OtherOutGoodsValue(Data,entityName));//生成蓝字（出库货值）、蓝字（出库费用）
                    break;
                case "im_otherinbillaudit"://其他入库单的成本处理
                case "im_otherinbillcostsetop"://其他入库单的成本处理
                    Createcostdispose(CostHelper.OtherInEstimatedreceived(dataEntity));//蓝字（货值入库暂估）
                    Createcostdispose(CostHelper.OtherInEstimationexpenses(dataEntity));//蓝字（入库单费用暂估）
                    break;
                case "sim_original_billaudit"://开票申请单
                case "sim_original_billcostsetop"://开票申请单
                    Createcostdispose(CostHelper.TransOutGoodsValue(Data,entityName));//蓝字（出库货值）
                    Createcostdispose(CostHelper.TransOutCost(Data,entityName));//蓝字（出库费用）
                    break;
                case "tpv_cm_costreplacementaudit"://串拣配成本置换单的成本处理
                case "tpv_cm_costreplacementcostsetop"://串拣配成本置换单的成本处理
                    Createcostdispose(CostHelper.CostExchangeRedOrBlue(Data,entityName));//红冲、生成蓝字
                    break;
                case "tpv_cm_costadjustmentsaudit"://成本调整单的成本处理
                case "tpv_cm_costadjustmentscostsetop"://成本调整单的成本处理
                    Createcostdispose(CostHelper.RedOldCostDispose(Data,entityName));//冲销原成本明细
                    Createcostdispose(CostHelper.BlueToCostDispose(dataEntity));//蓝字(生成新成本处理)
                    Createcostdispose(CostHelper.Traverseoutboundredorblue(Data,entityName));//遍历生成出库（红字）遍历生成出库（蓝字）
                    Createcostdispose(CostHelper.TraverseSubordinates(Data,entityName));//遍历出库（红字）
                    break;
                default:
                    break;
            }
        }
    }


    /**
     * 适用条件
     *
     * @param entityName   单据标识
     * @param operationKey 单据操作
     * @param dataEntity   单据实体
     * @return
     */
    public boolean isFilter(String entityName, String operationKey, DynamicObject Data) {
        switch (entityName + operationKey) {
            case "im_purinbillaudit"://采购入库单的成本处理
                DynamicObject biztype = Data.getDynamicObject("biztype");
                if(biztype!=null)
                {
                    String biztypenumber = biztype.getString("number");
                    if("110".equals(biztypenumber) ||"1102".equals(biztypenumber) || "1103".equals(biztypenumber) || "1101".equals(biztypenumber))
                    {
                        return true;
                    }
                    else {
                        return false;
                    }
                }
                break;
            default:
                break;
        }
        return true;
    }

    /**
     * 生成成本处理
     *
     * @param dataRow
     */
    public void Createcostdispose(DynamicObjectCollection dataRow) {
        if (dataRow != null) {
            for (DynamicObject dataRows : dataRow) {
                DynamicObject costdispose = BusinessDataServiceHelper.newDynamicObject("tpv_cm_costdispose");//成本处理
                List<String> costColKeys = getCostColKeys();
                if (costColKeys.size() > 0) {
                    for (String col : costColKeys) {
                        if (dataRows.containsProperty(col)  &&  dataRows.get(col) != null) {
                            costdispose.set(col, dataRows.get(col));
                        }
                    }
                }
                costdispose.set("billstatus","C");
                SaveServiceHelper.saveOperate("tpv_cm_costdispose",new DynamicObject[]{costdispose});
            }
        }
    }
}
