package tpv.tpv_wm.tpv_cm.java.opplugin.op;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description: 生成凭证、删除凭证 -服务插件 反写成本处理单的【生成凭证】、【凭证号】、【凭证ID】字段
 * @Author LinRui
 * @Date 2024/7/4 17:22
 */
public class CostdisposeGLVoucherOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_proof");
        fieldKeys.add("tpv_proofid");
        fieldKeys.add("tpv_proofnum");
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        String operationKey = e.getOperationKey();//获取操作名称
        DynamicObject[] dataEntities = e.getDataEntities();
        if (this.getOperationResult().isSuccess()) {
            List<Long> costdisposeids = new ArrayList<>();
            if ("generatevoucher".equals(operationKey)) {
                for (DynamicObject dataEntity : dataEntities) {
                    if (YEM.isNotEmpty(dataEntity.getLong("id"))) {
                        if (!costdisposeids.contains(dataEntity.getLong("id"))) {
                            costdisposeids.add(dataEntity.getLong("id"));
                        }
                    }
                }
                if (costdisposeids.size() > 0) {
                    DynamicObject[] aiDaptracker = BusinessDataServiceHelper.load("ai_daptracker", "sourcebillid,voucherid",
                            new QFilter[]{new QFilter("sourcebillid", QCP.in, costdisposeids)});
                    Map<Long, Long> aiDaptrackerMap = new HashMap<>();
                    List<Long> voucherids = new ArrayList<>();
                    if (aiDaptracker.length > 0) {
                        for (DynamicObject dynamicObject : aiDaptracker) {
                            aiDaptrackerMap.put(dynamicObject.getLong("sourcebillid"), dynamicObject.getLong("voucherid"));
                            if (!voucherids.contains(dynamicObject.getLong("voucherid"))) {
                                voucherids.add(dynamicObject.getLong("voucherid"));
                            }
                        }
                    }
                    if (voucherids.size() > 0) {
                        DynamicObject[] glVoucher = BusinessDataServiceHelper.load("gl_voucher", "id,billno",
                                new QFilter[]{new QFilter("id", QCP.in, voucherids)});
                        Map<Long, Map<String, Object>> costdisposeMap = new HashMap<>();
                        if (glVoucher.length > 0) {
                            for (DynamicObject dynamicObject : glVoucher) {
                                if (aiDaptrackerMap.values().contains(dynamicObject.getLong("id"))) {
                                    for (Map.Entry<Long, Long> longEntry : aiDaptrackerMap.entrySet()) {
                                        if (longEntry.getValue().equals(dynamicObject.getLong("id"))) {
                                            Map<String, Object> glVoucherMap = new HashMap<>();
                                            glVoucherMap.put("tpv_proofid", dynamicObject.getLong("id"));
                                            glVoucherMap.put("tpv_proofnum", dynamicObject.getString("billno"));
                                            costdisposeMap.put(longEntry.getKey(), glVoucherMap);
                                        }
                                    }
                                }
                            }
                        }
                        if (costdisposeMap.size() > 0) {
                            for (DynamicObject dataEntity : dataEntities) {
                                String entityName = dataEntity.getDataEntityType().getName();//获取单据标识
                                if (YEM.isNotEmpty(dataEntity.getLong("id"))) {
                                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(dataEntity.getPkValue(), entityName);
                                    dynamicObject.set("tpv_proof", true);
                                    if (costdisposeMap.containsKey(dataEntity.getLong("id"))) {
                                        dynamicObject.set("tpv_proofid", costdisposeMap.get(dataEntity.getLong("id")).get("tpv_proofid"));
                                        dynamicObject.set("tpv_proofnum", costdisposeMap.get(dataEntity.getLong("id")).get("tpv_proofnum"));
                                    }
                                    SaveServiceHelper.update(dynamicObject);
                                }
                            }
                        }
                    }

                }

            }
            if ("deletevoucher".equals(operationKey)) {
                for (DynamicObject dataEntity : dataEntities) {
                    String entityName = dataEntity.getDataEntityType().getName();//获取单据标识
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(dataEntity.getPkValue(), entityName);
                    dynamicObject.set("tpv_proof", false);
                    dynamicObject.set("tpv_proofnum", "");
                    dynamicObject.set("tpv_proofid", 0l);
                    SaveServiceHelper.update(dynamicObject);
                }
            }
        }
    }
}
