package tpv.tpv_wm.tpv_cm.java.opplugin.op;

import com.itopview.wm.utils.YEM;
import kd.bos.data.BusinessDataReader;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.botp.runtime.SourceBillReport;
import kd.bos.entity.datamodel.IRefrencedataProvider;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.exception.KDBizException;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.operation.DeleteServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import tpv.tpv_wm.tpv_cm.java.opplugin.validator.CostprocessingValidator;
import tpv.tpv_wm.tpv_cm.java.utils.CostHelperNew;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import static tpv.tpv_wm.tpv_cm.java.utils.CostHelper.Createcostdispose;

/**
 * 成本处理反方向
 *
 * @author LiuHB
 * @version 1.0
 */
public class CostprocessingOp extends AbstractOperationServicePlugIn {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_origin");
        fieldKeys.add("tpv_wareiformation");
        fieldKeys.add("tpv_dt_purinbill_j");
        fieldKeys.add("tpv_ishongc");
        fieldKeys.add("tpv_comeid");
        fieldKeys.add("tpv_dt_conmx");
//        fieldKeys.add("tpv_redgo");
        fieldKeys.add("tpv_dt_incomingenty");
        fieldKeys.add("tpv_warehousedept");
        fieldKeys.add("tpv_fentryid_in");
        fieldKeys.add("tpv_rkcomid");
        fieldKeys.add("tpv_purinentryid");


    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new CostprocessingValidator());
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        String operationKey = e.getOperationKey();//获取操作名称
        DynamicObject[] dataEntities = e.getDataEntities();
        for (DynamicObject dataEntity : dataEntities) {
            String entityName = dataEntity.getDataEntityType().getName();//获取单据标识
            DynamicObject data = BusinessDataServiceHelper.loadSingle(dataEntity.getPkValue(), entityName);
            switch (operationKey) {
                case "red"://采购发票匹配单红冲\货票对应单红冲
                    addBill(data,entityName);
//                    Createcostdispose(CostHelper.Traverseoutboundredorblue(dataEntity, entityName));//遍历生成出库（红字）遍历生成出库（蓝字）
//                    Createcostdispose(CostHelper.TraverseSubordinates(dataEntity, entityName));//遍历出库（红字）
                    break;
                case "redpunch"://费用发票匹配单红冲
                    addBill(data,entityName);
//                    Createcostdispose(CostHelper.FeesTraverseoutboundredorblue(dataEntity,entityName));//遍历生成出库（红字）遍历生成出库（蓝字）
//                    Createcostdispose(CostHelper.FeesTraverseSubordinates(dataEntity,entityName));//遍历出库（红字）
                    break;
                case "untakeeffect":
                case "unaudit":
                    triggerOperation(data, entityName);
                    break;
                default:
                    break;
            }
        }
    }

    private void addBill(DynamicObject data, String entityName) {
        if ("tpv_dt_purinvomater".equals(entityName)) {//采购发票匹配单
            redBill(data, entityName, "1932734821449117696");
        } else if ("tpv_dt_wbillcromater".equals(entityName)) {//货票对应单
            redBill(data, entityName, "1932757030867611648");
        } else if ("tpv_dt_costbillmat".equals(entityName)) {
            redBill(data, entityName, "1932749382881425408");
        }
    }

    private void redBill(DynamicObject data, String entityName, String ruleId) {
        List<String> tips = new ArrayList<>();
        List<ListSelectedRow> selectedRowsTwo = new ArrayList<>();
        ListSelectedRow listSelectedRowTwo = new ListSelectedRow(data.getLong("id"));//来源单据ID
        selectedRowsTwo.add(listSelectedRowTwo);
        PushArgs pushArgsTwo = new PushArgs();
        pushArgsTwo.setSourceEntityNumber(entityName); // 必选，源单标识
        pushArgsTwo.setTargetEntityNumber(entityName); // 必选，目标单标识
        pushArgsTwo.setAutoSave(true);//是否保存
        pushArgsTwo.setRuleId(ruleId); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
        pushArgsTwo.setBuildConvReport(true); // 是否输出详细错误报告
        pushArgsTwo.setSelectedRows(selectedRowsTwo); // 必选，设置需要下推的源单及分录内码
        ConvertOperationResult pushResultTwo = ConvertServiceHelper.push(pushArgsTwo);
        if (pushResultTwo.isSuccess()) {
            MainEntityType targetMainTypeOne = EntityMetadataCache
                    .getDataEntityType(pushArgsTwo.getTargetEntityNumber());
            List<DynamicObject> targetBillObjsOne = pushResultTwo
                    .loadTargetDataObjects(new IRefrencedataProvider() {
                        @Override
                        public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                            BusinessDataReader.loadRefence(objs, dType);
                        }
                    }, targetMainTypeOne);
            if (targetBillObjsOne.size() > 0) {
                DynamicObject targetBillObjOne = targetBillObjsOne.get(0);
                if (auditBill(targetBillObjOne, tips)) {
                    data.set("tpv_ishongc", true);
                    SaveServiceHelper.save(new DynamicObject[]{data});
                    //旧生成成本按钮操作
//                    OperationServiceHelper.executeOperate("takeeffect", entityName,
//                            new DynamicObject[]{targetBillObjOne}, YEM.getOption());
                } else {
                    if (tips.size() > 0) {
                        throw new KDBizException(String.join(",",tips));
                    }
                }
            }
        } else {
            addCovertMsg(entityName, pushResultTwo, tips);
        }
    }

    private void triggerOperation(DynamicObject dataEntity, String entityName) {
        List<String> list = new ArrayList<>();
        Map<String, String> fieldName = CostHelperNew.entryFieldName(entityName);
        switch (entityName) {
            case "im_otherinbill"://其他入库单
                deleteTouchBill(dataEntity, fieldName, list, entityName);
                break;
            case "im_purinbill"://采购入库单
                deleteTouchBill(dataEntity, fieldName, list, entityName);
                Createcostdispose(CostHelperNew.ResultPurInoutboundredorblue(dataEntity,entityName, "反审核", "遍历出库-生成红字、遍历出库-生成蓝字"));//遍历生成出库（红字）遍历生成出库（蓝字）
                Createcostdispose(CostHelperNew.ResultPurInSubordinates(dataEntity,entityName, "反审核", "遍历下级入库-生成红字、遍历下级入库-生成蓝字、遍历下级出库-生成红字、遍历下级出库-生成蓝字"));//遍历出库（红字）
                break;
            case "tpv_dt_purinvomater"://采购发票匹配单
            case "tpv_dt_wbillcromater"://货票对应单
                deleteTouchBill(dataEntity, fieldName, list, entityName);
                Createcostdispose(CostHelperNew.Traverseoutboundredorblue(dataEntity, entityName, "反审核", "遍历出库-生成红字、遍历出库-生成蓝字"));//遍历生成出库（红字）遍历生成出库（蓝字）
                Createcostdispose(CostHelperNew.TraverseSubordinates(dataEntity, entityName, "反审核", "遍历下级入库-生成红字、遍历下级入库-生成蓝字、遍历下级出库-生成红字、遍历下级出库-生成蓝字"));//遍历出库（红字）
                break;
            case "tpv_dt_costbillmat"://费用发票匹配单
                deleteTouchBill(dataEntity, fieldName, list, entityName);
                Createcostdispose(CostHelperNew.FeesTraverseoutboundredorblue(dataEntity,entityName, "反审核", "遍历出库-生成红字、遍历出库-生成蓝字"));//遍历生成出库（红字）遍历生成出库（蓝字）
                Createcostdispose(CostHelperNew.FeesTraverseSubordinates(dataEntity,entityName, "反审核", "遍历下级入库-生成红字、遍历下级入库-生成蓝字、遍历下级出库-生成红字、遍历下级出库-生成蓝字"));//遍历出库（红字）
                break;
            case "im_otheroutbill"://其他出库单
                deleteSourceBill(dataEntity, fieldName, list);
                break;
            case "im_transdirbill"://直接调拨单
                deleteTouchBill(dataEntity, fieldName, list, entityName);
                deleteSourceBill(dataEntity, fieldName, list);
                break;
            case "tpv_cm_costreplacement"://成本调整单
                deleteTouchBill(dataEntity, fieldName, list, entityName);
                break;
            case "sim_original_bill"://开票申请单
                deleteTouchBill(dataEntity, fieldName, list, entityName);
                break;
        }
    }


    /**
     * @Title: deleteTouchBill
     * @Descriptin: 根据【触发单据ID】删除对应成本明细行
     * @retrn: a
     */
    public void deleteTouchBill(DynamicObject dataEntity, Map<String, String> fieldName, List<String> list, String entityName) {
        DynamicObjectCollection billentrys = dataEntity.getDynamicObjectCollection(fieldName.get("entryfield"));
        for (DynamicObject billentry : billentrys) {
            String tpvFidIn = billentry.get("id").toString();//来源单据分录id
            list.add(tpvFidIn);
        }
        String id = String.valueOf(dataEntity.getLong("id"));
//        String billno = dataEntity.getString("billno");

        //这块是处理红冲后反审核的逻辑，修改源单的已红冲按钮，不是删除成本处理逻辑
        if ("tpv_dt_purinvomater".equals(entityName) | "tpv_dt_wbillcromater".equals(entityName)
                | "tpv_dt_costbillmat".equals(entityName)) {
            Long aLong = dataEntity.getLong("tpv_srcredid");
            if (YEM.isNotEmpty(aLong)) {
                QFilter qFilter = new QFilter("id",QCP.equals,aLong);
                DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(dataEntity.getDataEntityType().getName(), qFilter.toArray());
                dynamicObject.set("tpv_ishongc",false);
                SaveServiceHelper.save(new DynamicObject[]{dynamicObject});
            }
        }
//        dataEntity.set("tpv_ishongc", false);
//        SaveServiceHelper.save(new DynamicObject[]{dataEntity});
        //删除成本处理
        if ("tpv_dt_purinvomater".equals(entityName) | "tpv_dt_wbillcromater".equals(entityName)
                | "tpv_dt_costbillmat".equals(entityName) | "im_purinbill".equals(entityName)) {
            DeleteServiceHelper.delete("tpv_cm_costdispose", new QFilter[]{new QFilter("tpv_tiggdoubillid", QCP.equals, id)
                    .and(new QFilter("tpv_soudocumid", "in", list))});
        } else if ("im_otherinbill".equals(entityName) | "tpv_cm_costreplacement".equals(entityName)) {
            DeleteServiceHelper.delete("tpv_cm_costdispose", new QFilter[]{new QFilter("tpv_tiggdoubillid", QCP.equals, id)});
        } else if ("sim_original_bill".equals(entityName) | "im_otheroutbill".equals(entityName)) {
            DeleteServiceHelper.delete("tpv_cm_costdispose", new QFilter[]{new QFilter("tpv_soudocumid", "in", list)});
        }  else if ("im_transdirbill".equals(entityName)) {
            DeleteServiceHelper.delete("tpv_cm_costdispose", new QFilter[]{new QFilter("tpv_soudocumid", "in", list)
                    .or(new QFilter("tpv_tiggdoubillid", QCP.equals, id))});
        }
    }

    /**
     * @Title: deleteSourceBill
     * @Descripton: 根据【来源单据分录id】删除对应成本明细行
     * @reurn: a
     */
    public void deleteSourceBill(DynamicObject dataEntity, Map<String, String> fieldName, List<String> list) {
        DynamicObjectCollection billentrys = dataEntity.getDynamicObjectCollection(fieldName.get("entryfield"));
        for (DynamicObject billentry : billentrys) {
            String tpvFidIn = billentry.get("id").toString();//触发单据Id
            list.add(tpvFidIn);
        }
        DeleteServiceHelper.delete("tpv_cm_costdispose", new QFilter[]{new QFilter("tpv_soudocumid", "in", list)});
    }

    private boolean auditBill(DynamicObject targetBillObjOne, List<String> tips) {
        DynamicObjectType dynamicObjectType = targetBillObjOne.getDynamicObjectType();
        String entityName = dynamicObjectType.getDisplayName().getLocaleValue();
        String entityNumber = dynamicObjectType.getName();
        OperateOption optionOne = YEM.getOption();
        OperationResult saveOne = OperationServiceHelper.executeOperate("save", entityNumber,
                new DynamicObject[]{targetBillObjOne}, optionOne);
        if (saveOne.isSuccess()) {
            OperationResult submitOne = OperationServiceHelper.executeOperate("commitskip",
                    entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
            if (submitOne.isSuccess()) {
                OperationResult auditOne = OperationServiceHelper.executeOperate("audit",
                        entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
                if (auditOne.isSuccess()) {
                    return true;
                } else {
                    tips.add(String.format("【%s】审核失败。%s", entityName, YEM.getOpMsg(auditOne)));
                }
            } else {
                tips.add(String.format("【%s】提交失败。%s", entityName, YEM.getOpMsg(submitOne)));
            }
        } else {
            tips.add(String.format("【%s】保存失败。%s", entityName, YEM.getOpMsg(saveOne)));
        }
        return false;
    }

    private void addCovertMsg(String entityNumber, ConvertOperationResult pushResult, List<String> tips) {
        MainEntityType dataEntityType = YEM.getDataEntityType(entityNumber);
        String entityName = dataEntityType.getDisplayName().getLocaleValue();
        String msg = pushResult.getMessage();
        List<SourceBillReport> billReports = pushResult.getBillReports();
        for (int i = 0; i < billReports.size(); i++) {
            SourceBillReport sourceBillReport = billReports.get(i);
            msg = i == 0 ? msg + "。原因:" : msg;
            msg += String.format("%s、%s ", i + 1, sourceBillReport.getFailMessage());
        }
        tips.add(String.format("下推【%s】失败。%s ", entityName, msg));
        //this.getView().showMessage(String.format("下推【%s】失败。%s", entityName, msg));
    }
}







