package tpv.tpv_wm.tpv_cm.java.opplugin.op;

import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.List;


/**
 * 串拣配成本置换单-服务插件
 *
 * @author WangShuGuang
 * @description
 * @date 2023年11月22日
 */
public class CostrePlacOpPlugin extends AbstractOperationServicePlugIn {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_materialentry");
        fieldKeys.add("tpv_delivergoodsid");
        fieldKeys.add("tpv_qty");
    }

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        String operationKey = e.getOperationKey();
        switch (operationKey) {
            //监听点击保存按钮
            case "save":
                retrographyQty(e);
                break;
            case "delete":
                deleteQty(e);
                break;
            case "submit":
                retrographyQty(e);
                break;
            default:
                break;
        }
    }

    /**
     * 点击保存按钮反写发货单数量
     */
    public void retrographyQty(BeforeOperationArgs e) {
        DynamicObject[] entities = e.getDataEntities();
        for (DynamicObject entity : entities) {
            //获取单据体
            DynamicObjectCollection objectCollection = entity.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject tpvMaterialentry : objectCollection) {
                String tpvDelivergoodsid = tpvMaterialentry.getString("tpv_delivergoodsid");//销售发货单拣配库存子分录id
                long idF = Long.parseLong(tpvDelivergoodsid);
                BigDecimal tpvQty = tpvMaterialentry.getBigDecimal("tpv_qty");
                String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
                QFilter qFilter = new QFilter("tpv_materialentry.tpv_dt_salepick_in", QCP.equals, idF);
                DynamicObject tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
                tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle(tpvScBusinessnatures.getPkValue(),
                        tpvScBusinessnatures.getDynamicObjectType().getName());
                DynamicObjectCollection objectCollectionH = tpvScBusinessnatures.getDynamicObjectCollection("tpv_materialentry");
                for (DynamicObject dynamicObject : objectCollectionH) {
                    DynamicObjectCollection tpvDtSalepickIn = dynamicObject.getDynamicObjectCollection("tpv_dt_salepick_in");
                    for (DynamicObject object : tpvDtSalepickIn) {
                        long id = (Long) object.getPkValue();
                        if (id == idF) {
                            BigDecimal tpvAlreadycost = object.getBigDecimal("tpv_alreadycost");//已成本置换数量
                            BigDecimal andQty = tpvAlreadycost.add(tpvQty);//置换单数量与发货单数量累加
                            object.set("tpv_alreadycost", andQty);
                        }
                    }
                }
                SaveServiceHelper.update(tpvScBusinessnatures);//写入数据库
            }
        }
    }

    /**
     * 点击删除按钮反写发货单数量
     */
    public void deleteQty(BeforeOperationArgs e) {
        DynamicObject[] entities = e.getDataEntities();
        for (DynamicObject entity : entities) {
            //获取单据体
            DynamicObjectCollection objectCollection = entity.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject tpvMaterialentry : objectCollection) {
                String tpvDelivergoodsid = tpvMaterialentry.getString("tpv_delivergoodsid");//销售发货单拣配库存子分录id
                long idF = Long.parseLong(tpvDelivergoodsid);
                BigDecimal tpvQty = tpvMaterialentry.getBigDecimal("tpv_qty");
                String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
                QFilter qFilter = new QFilter("tpv_materialentry.tpv_dt_salepick_in", QCP.equals, idF);
                DynamicObject tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
                tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle(tpvScBusinessnatures.getPkValue(),
                        tpvScBusinessnatures.getDynamicObjectType().getName());
                DynamicObjectCollection objectCollectionH = tpvScBusinessnatures.getDynamicObjectCollection("tpv_materialentry");
                for (DynamicObject dynamicObject : objectCollectionH) {
                    DynamicObjectCollection tpvDtSalepickIn = dynamicObject.getDynamicObjectCollection("tpv_dt_salepick_in");
                    for (DynamicObject object : tpvDtSalepickIn) {
                        long id = (Long) object.getPkValue();
                        if (id == idF) {
                            BigDecimal tpvAlreadycost = object.getBigDecimal("tpv_alreadycost");//已成本置换数量
                            BigDecimal subtractQty = tpvAlreadycost.subtract(tpvQty);//发货单已成本置换数量减去成本置换单数量
                            object.set("tpv_alreadycost", subtractQty);
                        }
                    }
                }
                SaveServiceHelper.update(tpvScBusinessnatures);//写入数据库
            }
        }
    }
}
