package tpv.tpv_wm.tpv_cm.java.opplugin.op;

import kd.bos.db.DB;
import kd.bos.db.DBRoute;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.ext.fi.ai.AbstractDapWriteBackImpl;
import kd.bos.ext.fi.ai.Voucher;
import kd.bos.ext.fi.ai.VoucherOperation;
import kd.bos.logging.Log;
import kd.bos.logging.LogFactory;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @Description: DAP配置反写 -凭证反写成本处理单
 * @Author LinRui
 * @Date 2024/7/23 15:08
 */
public class TpvVoucherWriteBackCostBill extends AbstractDapWriteBackImpl {
    public TpvVoucherWriteBackCostBill() {
    }
    private static final Log log = LogFactory.getLog(TpvVoucherWriteBackCostBill.class);

    @Override
    public void writeBack(VoucherOperation operation, String billEntityNumber, Map<Long, Voucher> billToVch) {
        super.writeBack(operation, billEntityNumber, billToVch);
        MainEntityType mt = EntityMetadataCache.getDataEntityType(billEntityNumber);
        Set<Long> keySet = billToVch.keySet();
//        String field1 = "fk_tpv_proof"; //生成凭证
        String field2 = "fk_tpv_proofnum"; //凭证号
        String field3 = "fk_tpv_glvoucherfid"; //凭证ID
        if (VoucherOperation.Create.equals(operation)) {
            //#开始执行生成凭证反写:"
            log.info("AbstractDapWriteBackImpl#开始执行生成凭证反写:" + operation);
            Object vchStatusField = getVchEnableStatus();
            List<Object[]> params = new ArrayList<>();
            for (Long me : keySet) {
                //#生成凭证的单据ID
                Voucher voucher = billToVch.get(me);//凭证
                String voucherNo = voucher.getVoucherNo();
                long voucherId = voucher.getId();
                //这里处理的是一个单据只有一个凭证的时候，如果是多个凭证，可以先获取已经生成的凭证号，再拼接上字符串。
                Object[] param = new Object[] { vchStatusField , voucherNo, voucherId, me};//
                params.add(param);
                if (params.size() >= 10000) {
                    log.info("AbstractDapWriteBackImpl#开始执行生成凭证反写SQL");
                    log.info("AbstractDapWriteBackImpl#mt.getAlias()" + mt.getAlias());
                    log.info("AbstractDapWriteBackImpl#mt.getVchStatusField()" + getVchStatusField());
                    DB.executeBatch(this.getDBRoute(),
                            "update " + mt.getAlias() + " set " + getVchStatusField() + " = ? , "+ field2 +" = ? , "+ field3 +" = ? where fid = ?", params);
                    log.info("AbstractDapWriteBackImpl#结束执行生成凭证反写SQL");
                    params.clear();
                }
            }
            log.info("AbstractDapWriteBackImpl#最后#开始执行生成凭证反写SQL");
            log.info("AbstractDapWriteBackImpl#最后#mt.getAlias()" + mt.getAlias());
            log.info("AbstractDapWriteBackImpl#最后#mt.getVchStatusField()" + getVchStatusField());
            if (params.size() > 0) {
                DB.executeBatch(this.getDBRoute(),
                        "update " + mt.getAlias() + " set " + getVchStatusField() + " = ?  , "+ field2 +" = ? , "+ field3 +" = ? where fid = ?", params);
            }
            log.info("AbstractDapWriteBackImpl#最后#结束执行生成凭证反写SQL");
            //#最后#结束执行生成凭证反写SQL
        } else if (VoucherOperation.Delete.equals(operation)) {
            //#开始执行删除凭证反写
            Object vchDisableStatus = getVchDisableStatus();
            List<Object[]> params = new ArrayList<>();
            for (Long me : keySet) {
                log.info("AbstractDapWriteBackImpl#删除凭证的单据ID：" + me);
                //这里处理的是一个单据只有一个凭证的时候，如果是多个凭证，可以先获取已经生成的凭证号，再去掉本凭证之后的凭证号
                Object[] param = new Object[] {vchDisableStatus, "", 0l, me};// getVchDisableStatus
                params.add(param);
                if (params.size() >= 10000) {
                    log.info("AbstractDapWriteBackImpl#开始执行删除凭证反写SQL");
                    log.info("AbstractDapWriteBackImpl#mt.getAlias()" + mt.getAlias());
                    log.info("AbstractDapWriteBackImpl#mt.getVchStatusField()" + getVchStatusField());
                    DB.executeBatch(this.getDBRoute(),
                            "update " + mt.getAlias() + " set " + getVchStatusField() + " = ? , "+ field2 +" = ? , "+ field3 +" = ? where fid = ?", params);
                    params.clear();
                    log.info("AbstractDapWriteBackImpl#结束执行删除凭证反写SQL");
                }
            }
            log.info("AbstractDapWriteBackImpl#最后#开始执行删除凭证反写SQL");
            log.info("AbstractDapWriteBackImpl#最后#mt.getAlias()" + mt.getAlias());
            log.info("AbstractDapWriteBackImpl#最后#mt.getVchStatusField()" + getVchStatusField());
            if (params.size() > 0) {
                DB.executeBatch(this.getDBRoute(),
                        "update " + mt.getAlias() + " set " + getVchStatusField() + " = ? , "+ field2 +" = ? , "+ field3 +" = ? where fid = ?", params);
            }
            log.info("AbstractDapWriteBackImpl#最后#结束执行删除凭证反写SQL");
        }
    }
    @Override
    protected DBRoute getDBRoute() {
        return DBRoute.of("secd");
    }

    @Override
    protected String getVchStatusField() {
        String vchField = "fk_tpv_proof";
        return vchField;
    }

    @Override
    protected Object getVchEnableStatus() {
        Boolean rchValue = true;
        return rchValue;
    }

    @Override
    protected Object getVchDisableStatus() {
        Boolean disRchValue = false;
        return disRchValue;
    }

}
