package tpv.tpv_wm.tpv_cm.java.opplugin.validator;

import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * 成本处理反方向
 *
 * @author LiuHB
 * @version 1.0
 */
public class CostprocessingValidator extends AbstractValidator {
    @Override
    public void validate() {
        ExtendedDataEntity[] dataEntities = this.getDataEntities();
        String operationKey = this.getOperateKey();//获取操作名称
        for (int i = 0; i < dataEntities.length; i++) {
            ExtendedDataEntity bill = dataEntities[i];
            DynamicObject entity = bill.getDataEntity();
            String entityName = entity.getDataEntityType().getName();//获取单据标识
            switch (entityName + operationKey) {
                case "im_purinbillunaudit":  //采购入库单反审核/采购入库单(退货)
                    procurementInventory(entity, bill);
                    break;
                case "tpv_dt_costbillmatunaudit"://费用发票匹配单
                    expenseInvoices(entity, bill);
                    break;
                case "tpv_dt_costbillmatred"://费用发票匹配单红冲
                    expenseInvoicesred(entity, bill);
                    break;
                case "tpv_dt_purinvomaterunaudit"://采购发票匹配单
                    purchaseInvoices(entity, bill);
                    break;
                case "tpv_dt_purinvomaterred": //采购发票匹配单红冲
                    purchaseInvoicesred(entity, bill);
                    break;
                case "tpv_dt_wbillcromaterunaudit":  //货票对应单
                    transportCharge(entity, bill);
                    break;
                case "tpv_dt_wbillcromaterred"://货票对应单红冲
                    transportChargered(entity, bill);
                    break;
                case "im_otherinbillunaudit":  //其他入库单
                    otherInventory(entity, bill);
                    break;
                case "im_otheroutbillunaudit"://其他出库单
                    otheroutBoundshipments(entity, bill);
                    break;
                case "im_transdirbillunaudit": //直接调拨单
                    directAllocation(entity, bill);
                    break;
                case "sim_original_billunaudit": //开票单
                    invoicingBill(entity, bill);
                    break;
                case "tpv_cm_costadjustmentsunaudit"://成本调整单
                    costAdjustments(entity, bill);
                    break;
            }
        }
    }

    /**
     * 采购入库
     *
     * @param entity
     * @param bill
     */
    public void procurementInventory(DynamicObject entity, ExtendedDataEntity bill) {
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), entity.getDataEntityType().getName());
        DynamicObject biztype = entity.getDynamicObject("biztype");
        String biztypenum = biztype.getString("number");
        if ("110".equals(biztypenum) || "1102".equals(biztypenum) || "1103".equals(biztypenum) || "1101".equals(biztypenum)) {
            DynamicObjectCollection entryEntity = entity.getDynamicObjectCollection("billentry");
            for (DynamicObject billentry : entryEntity) {
                DynamicObjectCollection tpvDtPurinbillJ = billentry.getDynamicObjectCollection("tpv_dt_purinbill_j");
                for (DynamicObject dynamicObject : tpvDtPurinbillJ) {
                    int indexOf = tpvDtPurinbillJ.indexOf(dynamicObject);
                    indexOf = indexOf + 1;
                    //1
                    BigDecimal tpvQuantitypickeds = dynamicObject.getBigDecimal("tpv_quantitypickeds");
                    if (tpvQuantitypickeds.compareTo(BigDecimal.ZERO) > 0) {
                        this.addMessage(bill, "商品明细第" + indexOf + "行的规已拣配数量大于0不允许反审核");
                    }
                }
            }

            DynamicObjectCollection billentry = entity.getDynamicObjectCollection("billentry");
            for (DynamicObject dynamicObject : billentry) {
                int indexOf = entryEntity.indexOf(dynamicObject);
                indexOf = indexOf + 1;
                String purinentryid = "";
                String inboentid = "";
                String storageid = "";
                boolean tpvProof = true;
                String supstorageid = "";
                Long ids = dynamicObject.getLong("id");
                String entryid = ids.toString();
                //2
                String selectfields = DynamicObjectUtil.getSelectfields("tpv_dt_purinvomater", false);
                selectfields = DynamicObjectUtil.getEntrySelectfields(selectfields, "tpv_dt_purinvomater", "tpv_wareiformation", false);
                QFilter qFilter = new QFilter("billstatus", QCP.equals, "C");
                DynamicObject[] load = BusinessDataServiceHelper.load("tpv_dt_purinvomater", selectfields, qFilter.toArray());
                for (DynamicObject dynamicObjects : load) {
                    DynamicObjectCollection tpvWareiformation = dynamicObjects.getDynamicObjectCollection("tpv_wareiformation");
                    for (DynamicObject tpvWareiformations : tpvWareiformation) {
                        purinentryid = tpvWareiformations.getString("tpv_purinentryid");
                        if (entryid.equals(purinentryid)) {
                            this.addMessage(bill, "商品明细第" + indexOf + "行已被采购发票匹配单匹配过不允许反审核");
                        }
                    }
                }

                //4
                String selectfield = DynamicObjectUtil.getSelectfields("tpv_dt_costbillmat", false);
                selectfield = DynamicObjectUtil.getEntrySelectfields(selectfield, "tpv_dt_costbillmat", "tpv_matecost", false);
                QFilter qFilters = new QFilter("billstatus", QCP.equals, "C");
                DynamicObject[] loads = BusinessDataServiceHelper.load("tpv_dt_costbillmat", selectfield, qFilters.toArray());
                for (DynamicObject costbillmat : loads) {
                    DynamicObjectCollection tpvMatecost = costbillmat.getDynamicObjectCollection("tpv_matecost");
                    for (DynamicObject tpvMatecosts : tpvMatecost) {
                        inboentid = tpvMatecosts.getString("tpv_inboentid");
                        if (entryid.equals(inboentid)) {
                            this.addMessage(bill, "商品明细第" + indexOf + "行已被费用发票匹配单匹配过不允许反审核");
                        }
                    }

                }
                //6
                String selectfieldd = DynamicObjectUtil.getSelectfields("tpv_cm_costdispose", false);
                QFilter qFilterd = new QFilter("billstatus", QCP.equals, "C");
                DynamicObject[] costdispose = BusinessDataServiceHelper.load("tpv_cm_costdispose", selectfieldd, qFilterd.toArray());
                for (DynamicObject tpvcostdispose : costdispose) {
                    storageid = tpvcostdispose.getString("tpv_storageid");
                    if (entryid.equals(storageid)) {
                        DynamicObject[] aiDaptracker = BusinessDataServiceHelper.load("ai_daptracker", "sourcebillid,voucherid",
                                new QFilter[]{new QFilter("sourcebillid", QCP.equals, tpvcostdispose.getLong("id"))});
                        if (aiDaptracker.length > 0) {
                            this.addMessage(bill, "商品明细第" + indexOf + "行对应成本明细已生成凭证不允许反审核");
                        }
                    }
                }

                //3
                String selectfielda = DynamicObjectUtil.getSelectfields("tpv_dt_wbillcromater", false);
                selectfielda = DynamicObjectUtil.getEntrySelectfields(selectfielda, "tpv_dt_wbillcromater", "tpv_dt_incomingenty", false);
                QFilter qFilterda = new QFilter("billstatus", QCP.equals, "C");
                DynamicObject[] wbillcromater = BusinessDataServiceHelper.load("tpv_dt_wbillcromater", selectfielda, qFilterda.toArray());
                for (DynamicObject tpvwbillcromater : wbillcromater) {
                    for (DynamicObject tpvDtIncomingenty : tpvwbillcromater.getDynamicObjectCollection("tpv_dt_incomingenty")) {
                        String rkcomid = tpvDtIncomingenty.getString("tpv_rkcomid");
                        if (entryid.equals(rkcomid)) {
                            this.addMessage(bill, "商品明细第" + indexOf + "行已做过货票对应不允许反审核");
                        }
                    }
                }
                //5
                String selectfieldq = DynamicObjectUtil.getSelectfields("tpv_cm_costadjustments", false);
                selectfieldq = DynamicObjectUtil.getEntrySelectfields(selectfieldq, "tpv_cm_costadjustments", "tpv_costbreakdown", false);
                QFilter qFilterdq = new QFilter("billstatus", QCP.equals, "C");
                DynamicObject[] costadjustments = BusinessDataServiceHelper.load("tpv_cm_costadjustments", selectfieldq, qFilterdq.toArray());
                for (DynamicObject costadjustment : costadjustments) {
                    supstorageid = costadjustment.getString("tpv_supstorageid");
                    if (entryid.equals(supstorageid)) {
                        this.addMessage(bill, "商品明细第" + indexOf + "行被成本调整选择过不允许反审核");
                    }
                }
            }
        }
    }

    /**
     * 采购发票
     *
     *
     * @param entity
     * @param bill
     */
    public void purchaseInvoices(DynamicObject entity, ExtendedDataEntity bill) {
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), entity.getDataEntityType().getName());
        String billid = String.valueOf(entity.getLong("id"));
        boolean tpvIshongc = entity.getBoolean("tpv_ishongc");
        if (tpvIshongc) {
            this.addMessage(bill, "已红冲不允许反审核");
            return;
        }
        DynamicObjectCollection tpvContinformation = entity.getDynamicObjectCollection("tpv_continformation");
        for (DynamicObject dynamicObject : tpvContinformation) {
            int indexOf = tpvContinformation.indexOf(dynamicObject);
            indexOf = indexOf + 1;
            Long ids = dynamicObject.getLong("id");
            String entryid = ids.toString();
            //1
            String selectfielda = DynamicObjectUtil.getSelectfields("tpv_dt_wbillcromater", false);
            selectfielda = DynamicObjectUtil.getEntrySelectfields(selectfielda, "tpv_dt_wbillcromater", "tpv_dt_conmx", false);
            QFilter qFilterda = new QFilter("billstatus", QCP.equals, "C");
            qFilterda.and(new QFilter("tpv_dt_conmx.tpv_comeid", QCP.equals, entryid));
            DynamicObject[] load = BusinessDataServiceHelper.load("tpv_dt_wbillcromater", selectfielda, qFilterda.toArray());
            if (load.length > 0) {
                this.addMessage(bill, "合同信息 第" + indexOf + "行已经做过货票对应不允许反审核");
            }
        }
        DynamicObjectCollection entryEntity = entity.getDynamicObjectCollection("tpv_wareiformation");
        for (DynamicObject dynamicObject : entryEntity) {
            int indexOf = entryEntity.indexOf(dynamicObject);
            indexOf = indexOf + 1;
            String purinentryid  = dynamicObject.getString("tpv_purinentryid");//入库分录id
            Long ids = dynamicObject.getLong("id");
            String entryid = ids.toString();
            //2
            boolean purinReturnSelectRowBycostdis = purinReturnSelectRowBycostdis(bill, indexOf, entryid, "");
            //4
            boolean bycostdisToDAP = purinentryAndBillIdBycostdisToDAP(bill, billid, indexOf, purinentryid, "");
            if (purinReturnSelectRowBycostdis) {
                this.addMessage(bill, "入库信息分录 第" + indexOf + "行对应成本明细已生成凭证，对应成本处理行数据并且被采购入库退货单选中，不允许反审核！");
            }
            if (!purinReturnSelectRowBycostdis && bycostdisToDAP) {
                this.addMessage(bill, "入库明细分录 第" + indexOf + "行对应成本明细已生成凭证，不允许反审核！");
            }
        }
    }

    /**
     * 采购发票红冲
     *
     *
     * @param entity
     * @param bill
     */
    public void purchaseInvoicesred(DynamicObject entity, ExtendedDataEntity bill) {
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), entity.getDataEntityType().getName());
        String billid = String.valueOf(entity.getLong("id"));
        boolean tpvIshongc = entity.getBoolean("tpv_ishongc");
        long tpvSourcebillid = entity.getLong("tpv_sourcebillid");
        if (tpvSourcebillid > 0) {
            this.addMessage(bill, "来源单据id不为空不允许红冲！");
        }
        if (tpvIshongc) {
            this.addMessage(bill, "已红冲，不允许再次红冲！");
        }
        DynamicObjectCollection entryEntity = entity.getDynamicObjectCollection("tpv_continformation");
        for (DynamicObject dynamicObject : entryEntity) {
            int indexOf = entryEntity.indexOf(dynamicObject);
            indexOf = indexOf + 1;
            Long ids = dynamicObject.getLong("id");
            String entryid = ids.toString();
            //3
            String selectfielda = DynamicObjectUtil.getSelectfields("tpv_dt_wbillcromater", false);
            selectfielda = DynamicObjectUtil.getEntrySelectfields(selectfielda, "tpv_dt_wbillcromater", "tpv_dt_conmx", false);
            QFilter qFilterda = new QFilter("billstatus", QCP.equals, "C");
            qFilterda.and(new QFilter("tpv_dt_conmx.tpv_comeid", QCP.equals, entryid));
            qFilterda.and(new QFilter("tpv_ishongc", QCP.equals, true));
            DynamicObject[] load = BusinessDataServiceHelper.load("tpv_dt_wbillcromater", selectfielda, qFilterda.toArray());
            if (load.length > 0) {
                this.addMessage(bill, "合同明细 第" + indexOf + "行已经做过《货票对应》并且《货票对应单》已做红冲，不允许再次红冲！");
            }
        }
        //4
        DynamicObjectCollection entryEntitys = entity.getDynamicObjectCollection("tpv_wareiformation");
        for (DynamicObject dynamicObject : entryEntitys) {
            int indexOf = entryEntitys.indexOf(dynamicObject);
            indexOf = indexOf + 1;
            String purinentryid  = dynamicObject.getString("tpv_purinentryid");//入库分录id
            Long ids = dynamicObject.getLong("id");
            String entryid = ids.toString();
            //4.1
            boolean purinReturnSelectRowBycostdis = purinReturnSelectRowBycostdis(bill, indexOf, entryid, "");
            //4.2
            boolean bycostdisToDAP = purinentryAndBillIdBycostdisToDAP(bill, billid, indexOf, purinentryid, "");
            if (purinReturnSelectRowBycostdis) {
                this.addMessage(bill, "入库明细分录 第" + indexOf + "行对应成本明细已生成凭证，对应成本处理行数据并且被采购入库退货单选中，不允许红冲！");
            }
            if (!purinReturnSelectRowBycostdis && bycostdisToDAP) {
                this.addMessage(bill, "入库明细分录 第" + indexOf + "行对应成本明细已生成凭证，不允许红冲！");
            }
        }
    }

    /**
     * 费用发票
     *
     *
     * @param entity
     * @param bill
     */
    public void expenseInvoices(DynamicObject entity, ExtendedDataEntity bill) {
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), entity.getDataEntityType().getName());
        String billid = String.valueOf(entity.getLong("id"));
        Boolean ishongc = entity.getBoolean("tpv_ishongc");
        if (ishongc) {
            this.addMessage(bill, "已红冲不允许反审核");
            return;
        }
        DynamicObjectCollection entryEntitys = entity.getDynamicObjectCollection("tpv_matecost");
        for (DynamicObject matecost : entryEntitys) {
            int indexOf = entryEntitys.indexOf(matecost);
            indexOf = indexOf + 1;
            Long ids = matecost.getLong("id");
            String entryid = ids.toString();
            String purinentryid = matecost.getString("tpv_inboentid");
            //1
            boolean purinReturnSelectRowBycostdis = purinReturnSelectRowBycostdis(bill, indexOf, entryid, "");
            //3
            boolean bycostdisToDAP = purinentryAndBillIdBycostdisToDAP(bill, billid, indexOf, purinentryid, "");
            if (purinReturnSelectRowBycostdis) {
                this.addMessage(bill, "匹配入库/成本明细分录 第" + indexOf + "行对应成本明细已生成凭证，对应成本处理行数据并且被采购入库退货单选中，不允许反审核！");
            }
            if (!purinReturnSelectRowBycostdis && bycostdisToDAP) {
                this.addMessage(bill, "匹配入库/成本明细分录 第" + indexOf + "行对应成本明细已生成凭证，不允许反审核！");
            }
        }
    }

    /**
     * 费用发票红冲
     *
     * @param entity
     * @param bill
     */
    public void expenseInvoicesred(DynamicObject entity, ExtendedDataEntity bill) {
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), entity.getDataEntityType().getName());
        String billid = String.valueOf(entity.getLong("id"));
        boolean tpvIshongc = entity.getBoolean("tpv_ishongc");
        long tpvSourcebillid = entity.getLong("tpv_sourcebillid");
        if (tpvSourcebillid > 0) {
            this.addMessage(bill, "来源单据id不为空不允许红冲");
        }
        if (tpvIshongc) {
            this.addMessage(bill, "已红冲，不允许再次红冲！");
        }
        DynamicObjectCollection entryEntitys = entity.getDynamicObjectCollection("tpv_matecost");
        for (DynamicObject tpvwareiformation : entryEntitys) {
            int indexOf = entryEntitys.indexOf(tpvwareiformation);
            indexOf = indexOf + 1;
            Long ids = tpvwareiformation.getLong("id");
            String entryid = ids.toString();
            String purinentryid  = tpvwareiformation.getString("tpv_inboentid");//入库分录id
            //3
            boolean purinReturnSelectRowBycostdis = purinReturnSelectRowBycostdis(bill, indexOf, entryid, "");
            //4
            boolean bycostdisToDAP = purinentryAndBillIdBycostdisToDAP(bill, billid, indexOf, purinentryid, "");
            if (purinReturnSelectRowBycostdis) {
                this.addMessage(bill, "入库明细分录 第" + indexOf + "行对应成本明细已生成凭证，对应成本处理行数据并且被采购入库退货单选中，不允许红冲！");
            }
            if (!purinReturnSelectRowBycostdis && bycostdisToDAP) {
                this.addMessage(bill, "入库明细分录 第" + indexOf + "行对应成本明细已生成凭证，不允许红冲！");
            }
        }

    }

    /**
     * 货票对应
     *
     *
     * @param entity
     * @param bill
     */
    public void transportCharge(DynamicObject entity, ExtendedDataEntity bill) {
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), entity.getDataEntityType().getName());
        String billid = String.valueOf(entity.getLong("id"));
        boolean tpvredgo = entity.getBoolean("tpv_ishongc");
        if (tpvredgo) {
            this.addMessage(bill, "已红冲不允许反审核");
            return;
        }
        DynamicObjectCollection entryEntity = entity.getDynamicObjectCollection("tpv_dt_incomingenty");
        for (DynamicObject dynamicObject : entryEntity) {
            int indexOf = entryEntity.indexOf(dynamicObject);
            indexOf = indexOf + 1;
            Long ids = dynamicObject.getLong("id");
            String entryid = ids.toString();
            String purinentryid  = dynamicObject.getString("tpv_rkcomid");//入库分录id
            //1
            boolean purinReturnSelectRowBycostdis = purinReturnSelectRowBycostdis(bill, indexOf, entryid, "");
            //3
            boolean bycostdisToDAP = purinentryAndBillIdBycostdisToDAP(bill, billid, indexOf, purinentryid, "");
            if (purinReturnSelectRowBycostdis) {
                this.addMessage(bill, "入库明细分录 第" + indexOf + "行对应成本明细已生成凭证，对应成本处理行数据并且被采购入库退货单选中，不允许反审核！");
            }
            if (!purinReturnSelectRowBycostdis && bycostdisToDAP) {
                this.addMessage(bill, "入库明细分录 第" + indexOf + "行对应成本明细已生成凭证，不允许反审核！");
            }
        }
    }

    /**
     * 货票对应红冲
     *
     *
     * @param entity
     * @param bill
     */
    public void transportChargered(DynamicObject entity, ExtendedDataEntity bill) {
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), entity.getDataEntityType().getName());
        String billid = String.valueOf(entity.getLong("id"));
        boolean tpvredgo = entity.getBoolean("tpv_ishongc");
        long tpvSourcebillid = entity.getLong("tpv_sourcebillid");
        if (tpvSourcebillid > 0) {
            this.addMessage(bill, "来源单据id不为空不允许红冲");
        }
        if (tpvredgo) {
            this.addMessage(bill, "已红冲，不允许再次红冲！");
        }
        DynamicObjectCollection entryEntitys = entity.getDynamicObjectCollection("tpv_dt_incomingenty");
        for (DynamicObject dynamicObject : entryEntitys) {
            int indexOf = entryEntitys.indexOf(dynamicObject);
            indexOf = indexOf + 1;
            Long ids = dynamicObject.getLong("id");
            String entryid = ids.toString();
            String purinentryid  = dynamicObject.getString("tpv_rkcomid");//入库分录id
            //1
            boolean purinReturnSelectRowBycostdis = purinReturnSelectRowBycostdis(bill, indexOf, entryid, "");
            //3
            boolean bycostdisToDAP = purinentryAndBillIdBycostdisToDAP(bill, billid, indexOf, purinentryid, "");
            if (purinReturnSelectRowBycostdis) {
                this.addMessage(bill, "入库明细分录 第" + indexOf + "行对应成本明细已生成凭证，对应成本处理行数据并且被采购入库退货单选中，不允许红冲！");
            }
            if (!purinReturnSelectRowBycostdis && bycostdisToDAP) {
                this.addMessage(bill, "入库明细分录 第" + indexOf + "行对应成本明细已生成凭证，不允许红冲！");
            }
        }
    }

    /**
     * 其他出库
     *
     * @param entity
     * @param bill
     */
    public void otheroutBoundshipments(DynamicObject entity, ExtendedDataEntity bill) {
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), entity.getDataEntityType().getName());
        DynamicObjectCollection entryEntity = entity.getDynamicObjectCollection("billentry");
        for (DynamicObject dynamicObject : entryEntity) {
            int indexOf = entryEntity.indexOf(dynamicObject);
            indexOf = indexOf + 1;
            Long ids = dynamicObject.getLong("id");
            String entryid = ids.toString();
            boolean bycostdisSrcEntryidToDAP = entryidBycostdisSrcEntryidToDAP(bill, indexOf, entryid, "");
            if (bycostdisSrcEntryidToDAP) {
                this.addMessage(bill, "商品明细分录 第" + indexOf + "行对应成本明细已生成凭证，不允许反审核！");
            }
        }
    }

    /**
     * 其他入库
     *
     * @param entity
     * @param bill
     */
    public void otherInventory(DynamicObject entity, ExtendedDataEntity bill) {
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), entity.getDataEntityType().getName());
        String billid = String.valueOf(entity.getLong("id"));
        DynamicObjectCollection entryEntity = entity.getDynamicObjectCollection("billentry");
        for (DynamicObject dynamicObject : entryEntity) {
            int indexOf = entryEntity.indexOf(dynamicObject);
            indexOf = indexOf + 1;
            Long ids = dynamicObject.getLong("id");
            String entryid = ids.toString();
            BigDecimal tpvQuantitypicked = dynamicObject.getBigDecimal("tpv_quantitypicked");
            if (tpvQuantitypicked.compareTo(BigDecimal.ZERO) > 0) {
                this.addMessage(bill, "第" + indexOf + "行的规已拣配数量大于0不允许反审核");
            }
            //2
            boolean costadjustChoose = isCostadjustChoose(bill, billid, indexOf, entryid, "");
            //3
            boolean bycostdisToDAP = purinentryAndBillIdBycostdisToDAP(bill, billid, indexOf, entryid, "");
            if (costadjustChoose || bycostdisToDAP) {
                this.addMessage(bill, "商品明细分录 第" + indexOf + "行对应成本明细已生成凭证，不允许反审核！");
            }
        }

    }

    /**
     * 直接调拨
     *
     * @param entity
     * @param bill
     */
    public void directAllocation(DynamicObject entity, ExtendedDataEntity bill) {
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), entity.getDataEntityType().getName());
        String billid = String.valueOf(entity.getLong("id"));
        DynamicObjectCollection entryEntity = entity.getDynamicObjectCollection("billentry");
        for (DynamicObject dynamicObject : entryEntity) {
            int indexOf = entryEntity.indexOf(dynamicObject);
            indexOf = indexOf + 1;
            Long ids = dynamicObject.getLong("id");
            String entryid = ids.toString();
            BigDecimal tpvQuantitypicked = dynamicObject.getBigDecimal("tpv_quantitypicked");
            if (tpvQuantitypicked.compareTo(BigDecimal.ZERO) > 0) {
                this.addMessage(bill, "第" + indexOf + "行的规已拣配数量大于0不允许反审核");
            }
            //2
            boolean costadjustChoose = isCostadjustChoose(bill, billid, indexOf, entryid, "");
            //3
            boolean bycostdisSrcEntryidToDAP = entryidBycostdisSrcEntryidToDAP(bill, indexOf, entryid, "");
            boolean bycostdisToDAP = purinentryAndBillIdBycostdisToDAP(bill, billid, indexOf, entryid, "");
            if (!costadjustChoose && (bycostdisSrcEntryidToDAP || bycostdisToDAP)) {
                this.addMessage(bill, "入库信息 第" + indexOf + "行对应成本明细已生成凭证，不允许反审核！");
            }
            if (costadjustChoose) {
                this.addMessage(bill, "入库信息 第" + indexOf + "行对应成本明细已生成凭证，对应成本处理行数据并且被成本调整单选中，不允许反审核！");
            }
        }
    }

    /**
     * 开票单
     *
     * @param entity
     * @param bill
     */
    public void invoicingBill(DynamicObject entity, ExtendedDataEntity bill) {
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), entity.getDataEntityType().getName());
        DynamicObjectCollection entryEntity = entity.getDynamicObjectCollection("sim_original_bill_item");
        for (DynamicObject dynamicObject : entryEntity) {
            int indexOf = entryEntity.indexOf(dynamicObject);
            indexOf = indexOf + 1;
            Long ids = dynamicObject.getLong("id");
            String entryid = ids.toString();
            boolean bycostdisSrcEntryidToDAP = entryidBycostdisSrcEntryidToDAP(bill, indexOf, entryid, "");
            if (bycostdisSrcEntryidToDAP) {
                this.addMessage(bill, "商品明细分录 第" + indexOf + "行对应成本明细已生成凭证，不允许反审核！");
            }
        }
    }

    /**
     * 成本调整
     *
     * @param entity
     * @param bill
     */
    public void costAdjustments(DynamicObject entity, ExtendedDataEntity bill) {
        entity = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), entity.getDataEntityType().getName());
        String billno = entity.getString("billno");
        DynamicObjectCollection entryEntity = entity.getDynamicObjectCollection("tpv_costbreakdown");
        for (DynamicObject dynamicObject : entryEntity) {
            int indexOf = entryEntity.indexOf(dynamicObject);
            indexOf = indexOf + 1;
            Long ida = dynamicObject.getLong("id");
            String id = ida.toString();
            String selectfieldd = DynamicObjectUtil.getSelectfields("tpv_cm_costdispose", false);
            QFilter qFilterd = new QFilter("billstatus", QCP.equals, "C");
            qFilterd.and("tpv_tiggdounum", QCP.equals, billno);
            DynamicObject[] costdispose = BusinessDataServiceHelper.load("tpv_cm_costdispose", selectfieldd, qFilterd.toArray());
            for (DynamicObject tpvcostdispose : costdispose) {
                String storageid = tpvcostdispose.getString("tpv_storageid");
                if (id.equals(storageid)) {
                    DynamicObject[] aiDaptracker = BusinessDataServiceHelper.load("ai_daptracker", "sourcebillid,voucherid",
                            new QFilter[]{new QFilter("sourcebillid", QCP.equals, tpvcostdispose.getLong("id"))});
                    if (aiDaptracker.length > 0) {
                        this.addMessage(bill, "第" + indexOf + "行对应成本明细已生成凭证不允许反审核");
                    }
                }
            }
        }
    }

    /**
     * 查询入库信息分录对应行生成的成本明细是否已生成凭证
     * */
    private boolean purinentryAndBillIdBycostdisToDAP(ExtendedDataEntity bill, String billid, int indexOf, String purinentryid, String des) {
        String selectfieldd = DynamicObjectUtil.getSelectfields("tpv_cm_costdispose", false);
        QFilter qFilterd = new QFilter("billstatus", QCP.equals, "C");
        qFilterd.and("tpv_tiggdoubillid", QCP.equals, billid);
        qFilterd.and("tpv_storageid", QCP.equals, purinentryid);
        DynamicObject[] costdispose = BusinessDataServiceHelper.load("tpv_cm_costdispose", selectfieldd, qFilterd.toArray());
        List<Long> costdisposeids = new ArrayList<>();
        for (DynamicObject tpvcostdispose : costdispose) {
            Long id = tpvcostdispose.getLong("id");
            if (!costdisposeids.contains(id)) {
                costdisposeids.add(id);
            }
        }
        if (costdisposeids.size() > 0) {
            DynamicObject[] aiDaptracker = BusinessDataServiceHelper.load("ai_daptracker", "sourcebillid,voucherid",
                    new QFilter[]{new QFilter("sourcebillid", QCP.in, costdisposeids)});
            if (aiDaptracker.length > 0) {
                return true;
            }
        }
        return false;
    }

    /**
     * 查询来源分录行等于入库信息分录对应行的成本明细是否已生成凭证
     * */
    private boolean entryidBycostdisSrcEntryidToDAP(ExtendedDataEntity bill, int indexOf, String entryid, String des) {
        String selectfieldd = DynamicObjectUtil.getSelectfields("tpv_cm_costdispose", false);
        QFilter qFilterd = new QFilter("billstatus", QCP.equals, "C");
        qFilterd.and("tpv_soudocumid", QCP.equals, entryid);
        DynamicObject[] costdispose = BusinessDataServiceHelper.load("tpv_cm_costdispose", selectfieldd, qFilterd.toArray());
        List<Long> costdisposeids = new ArrayList<>();
        for (DynamicObject tpvcostdispose : costdispose) {
            Long id = tpvcostdispose.getLong("id");
            if (!costdisposeids.contains(id)) {
                costdisposeids.add(id);
            }
        }
        if (costdisposeids.size() > 0) {
            DynamicObject[] aiDaptracker = BusinessDataServiceHelper.load("ai_daptracker", "sourcebillid,voucherid",
                    new QFilter[]{new QFilter("sourcebillid", QCP.in, costdisposeids)});
            if (aiDaptracker.length > 0) {
                return true;
            }
        }
        return false;
    }

    /**
     * 根据成本触发单据id查询是否被采购入库退货单选中
     * 关键字段(采购入库单商品分录的选择成本处理单来源单据id)
     * */
    private boolean purinReturnSelectRowBycostdis(ExtendedDataEntity bill, int indexOf, String entryid, String des) {
        String selectfielde = DynamicObjectUtil.getSelectfields("tpv_cm_costdispose", false);
        QFilter qFilterde = new QFilter("billstatus", QCP.equals, "C");
        qFilterde.and("tpv_tiggdouid",QCP.equals, entryid);
        DynamicObject[] costdisposed = BusinessDataServiceHelper.load("tpv_cm_costdispose", selectfielde, qFilterde.toArray());
        List<Long> costdisposeids = new ArrayList<>();
        for (DynamicObject tpvcostdispose : costdisposed) {
            Long id = tpvcostdispose.getLong("id");
            if (!costdisposeids.contains(id)) {
                costdisposeids.add(id);
            }
        }
        if (costdisposeids.size() > 0) {
            String selectfieldp = DynamicObjectUtil.getSelectfields("im_purinbill", false);
            selectfieldp = DynamicObjectUtil.getEntrySelectfields(selectfieldp, "im_purinbill", "billentry", false);
            QFilter qFilterdp = new QFilter("billstatus", QCP.equals, "C");
            qFilterdp.and("biztype.number",QCP.equals,"1101");
            qFilterdp.and("billentry.tpv_costdisposeentryid",QCP.in, costdisposeids);
            DynamicObject[] purinbill = BusinessDataServiceHelper.load("im_purinbill", selectfieldp, qFilterdp.toArray());
            if (purinbill.length > 0) {
                return true;
            }
        }
        return false;
    }

    /**
     * 根据分录行生成的成本处理单被成本调整单选择过
     * */
    private boolean isCostadjustChoose(ExtendedDataEntity bill, String billid, int indexOf, String entryid, String des) {
        String selectfieldd = DynamicObjectUtil.getSelectfields("tpv_cm_costdispose", false);
        QFilter qFilterd = new QFilter("billstatus", QCP.equals, "C");
        qFilterd.and("tpv_tiggdoubillid", QCP.equals, billid);
        qFilterd.and("tpv_tiggdouid", QCP.equals, entryid);
        DynamicObject[] costdispose = BusinessDataServiceHelper.load("tpv_cm_costdispose", selectfieldd, qFilterd.toArray());
        List<String> costdisposeids = new ArrayList<>();
        for (DynamicObject tpvcostdispose : costdispose) {
            String id = String.valueOf(tpvcostdispose.getLong("id"));
            if (!costdisposeids.contains(id)) {
                costdisposeids.add(id);
            }
        }
        if (costdisposeids.size() > 0) {
            String selectfieldq = DynamicObjectUtil.getSelectfields("tpv_cm_costadjustments", false);
            selectfieldq = DynamicObjectUtil.getEntrySelectfields(selectfieldq, "tpv_cm_costadjustments", "tpv_costbreakdown", false);
            QFilter qFilterdq = new QFilter("billstatus", QCP.equals, "C");
            qFilterdq.and(new QFilter("tpv_costbreakdown.tpv_id", QCP.in, costdisposeids));
            DynamicObject[] costadjustments = BusinessDataServiceHelper.load("tpv_cm_costadjustments", selectfieldq, qFilterdq.toArray());
            if (costadjustments.length > 0) {
                return true;
            }
        }
        return false;
    }

}







