package tpv.tpv_wm.tpv_cm.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.FilterItemInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.sdk.plugin.Plugin;
import tpv.tpv_wm.tpv_cm.java.utils.CostDisposeRptUtils;

import java.util.List;

/**
 * @Description: 成本处理可红冲数量查询表
 * @Author LinRui
 * @Date 2023/11/16 20:02
 */
public class CostdisposeredRptQuery extends AbstractReportListDataPlugin implements Plugin {

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        FilterInfo filterInfo = param.getFilter();
        List<FilterItemInfo> tableHeadFilters = filterInfo.getTableHeadFilterItems();
        String whereFilter = "1 = 1";
        whereFilter = fieldWhereFilterList(tableHeadFilters, whereFilter);
        DataSet dataSet = CostDisposeRptUtils.getCostdisposeredRedQtyData();
        if (YEM.isNotEmpty(whereFilter)) {
            dataSet = dataSet.where(whereFilter);
        }
        return dataSet;
    }

    private static String fieldWhereFilterList(List<FilterItemInfo> tableHeadFilters, String whereFilter) {
        for (FilterItemInfo filterItemInfo : tableHeadFilters) {
            whereFilter = whereFilterMethod(filterItemInfo.getPropName(),filterItemInfo.getCompareType(),filterItemInfo.getValue(), whereFilter);
        }
        return whereFilter;

    }

    private static String whereFilterMethod(String propName, String compareType, Object value, String whereFilter) {
        switch (propName) {
            case "tpv_itemcode":case "tpv_conprodname":case "tpv_conorigin": case "tpv_currency":
            case "tpv_purconnum":case "tpv_combinbun":case "tpv_vendor":case "tpv_logserpro":
            case "tpv_saleconnum":case "tpv_client": case "tpv_tradeproperty":
            case "tpv_tiggdoutype":case "tpv_soudocumtype":case "tpv_costype":
                if ("=".equals(compareType) || "<>".equals(compareType)) {
                    whereFilter = String.format("%s and "+ propName +"name "+ compareType +" '%s'", whereFilter, value);
                }
                if ("like".equals(compareType.toLowerCase()) || "not like".equals(compareType.toLowerCase())) {
                    whereFilter = String.format("%s and LOWER("+ propName +"name) "+ compareType +" LOWER('%%%s%%')", whereFilter, value);
                }
                if ("notisnull".equals(compareType.toLowerCase())) {
                    whereFilter = String.format("%s and "+ propName +"name <> '%s'", whereFilter, "");
                }
                if ("isnull".equals(compareType.toLowerCase())) {
                    whereFilter = String.format("%s and "+ propName +"name = '%s'", whereFilter, "");
                }
                break;
            case "tpv_conspecation":case "tpv_conshader":case "tpv_soudocumnum":
            case "tpv_soudocumid":case "tpv_tiggdounum":case "tpv_tiggdouid":case "tpv_elimination":
            case "tpv_tiggdoubillid": case "tpv_storagenum":case "tpv_storageid":case "tpv_supstoragenum":
            case "tpv_supstorageid":case "tpv_movegoodsnum":case "tpv_movegoodsid":case "tpv_msungoodsid":
            case "tpv_billno":
                if ("=".equals(compareType) || "<>".equals(compareType)) {
                    whereFilter = String.format("%s and "+ propName +" "+ compareType +" '%s'", whereFilter, value);
                }
                if ("like".equals(compareType.toLowerCase()) || "not like".equals(compareType.toLowerCase())) {
                    whereFilter = String.format("%s and LOWER("+ propName +") "+ compareType +" LOWER('%%%s%%')", whereFilter, value);
                }
                if ("notisnull".equals(compareType.toLowerCase())) {
                    whereFilter = String.format("%s and "+ propName +" <> '%s'", whereFilter, "");
                }
                if ("isnull".equals(compareType.toLowerCase())) {
                    whereFilter = String.format("%s and "+ propName +" = '%s'", whereFilter, "");
                }
                break;
            case "tpv_quantity":case "tpv_origprice":case "tpv_rate":case "tpv_origampintax": case "tpv_origampnotax":
            case "tpv_origamptax":case "tpv_basampintax": case "tpv_basampnotax":case "tpv_basamptax":case "tpv_redqty":
            case "tpv_refundrate":case "tpv_id":
                if ("=".equals(compareType) || "<>".equals(compareType) || "<=".equals(compareType) || ">=".equals(compareType)
                        || ">".equals(compareType) || "<".equals(compareType)) {
                    whereFilter = String.format("%s and "+ propName +" "+ compareType +" %s", whereFilter, value);
                }
                break;
            case "tpv_bluered":case "tpv_costdirec":case "tpv_ispointpriceed":case "tpv_tentauth":
            case "tpv_drawback":
                if ("in".equals(compareType.toLowerCase())) {
                    String join = "";
                    if (value.toString().length() > 1) {
                        join = String.join(",", value.toString().substring(1, value.toString().length() - 1));
                    } else if (value.toString().length() == 1){
                        join = String.join(",", value.toString());
                    }

                    join = join.replace(", ", "','");
                    whereFilter = String.format("%s and "+ propName +" "+ compareType +" ('%s')", whereFilter, join);
                }
                break;
            default:
                break;
        }
        return whereFilter;
    }


}
