package tpv.tpv_wm.tpv_cm.java.utils;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @Description: 成本处理报表，返回数据帮助类
 * @Author LinRui
 * @Date 2023/11/17 17:19
 */
public class CostDisposeRptUtils {
    private static final String algoKey = CostDisposeRptUtils.class.getName();

    //成本处理可红冲数量查询表
    public static DataSet getCostdisposeredRedQtyData() {
        DataSet dataSet = getCostdisposeredRedQtyData(new ArrayList<>(), "", 0L, "", new ArrayList<>());
        return dataSet;
    }

    /**
     * @Description: //成本处理可红冲数量查询表
     * @param: storageid - [java.util.List<java.lang.String>] - 入库分录id
     * @param: tentauth - [java.lang.String] - 暂估/真实
     * @param: costype - [java.lang.String] - 成本类型
     * @param: costdirec - [java.lang.String] - 成本方向
     * @param: supstorageid - [java.util.List<java.lang.String>] - 上级入库单分录id
     * @return: kd.bos.algo.DataSet
     **/
    public static DataSet getCostdisposeredRedQtyData(List<String> storageid, String tentauth, long costype, String costdirec, List<String> supstorageid) {
        QFilter qFilters = new QFilter("billstatus", QCP.equals, "C");

        String selectFileds = "id,id tpv_id,billno,tpv_itemcode,tpv_itemcode.name,tpv_conprodname,tpv_conorigin,tpv_conspecation,tpv_bizdate," +
                "tpv_conshader,createtime,modifytime,tpv_bluered,tpv_costdirec,tpv_ispointpriceed,tpv_tentauth,tpv_costype," +
                "tpv_currency,tpv_origprice,tpv_rate,tpv_origampintax,tpv_origampnotax,tpv_origamptax,tpv_basampintax,tpv_basampnotax," +
                "tpv_basamptax,tpv_dollarintax,tpv_dollarnotax,tpv_dollartax,tpv_soudocumtype,tpv_soudocumnum,tpv_soudocumid," +
                "tpv_tiggdoutype,tpv_tiggdounum,tpv_tiggdouid,tpv_tiggdoubillid,tpv_storagenum,tpv_storageid,tpv_supstoragenum,tpv_supstorageid," +
                "tpv_movegoodsnum,tpv_movegoodsid,tpv_msungoodsid,tpv_quantity,tpv_elimination,tpv_purconnum,tpv_combinbun," +
                "tpv_vendor,tpv_logserpro,tpv_saleconnum,tpv_client,tpv_tradeproperty,tpv_drawback,tpv_refundrate,tpv_itemcode.name tpv_itemcodename," +
                "tpv_conprodname.number tpv_conprodnamename,tpv_conorigin.name tpv_conoriginname,tpv_currency.name tpv_currencyname," +
                "tpv_purconnum.tpv_name tpv_purconnumname,tpv_combinbun.name tpv_combinbunname,tpv_vendor.name tpv_vendorname," +
                "tpv_logserpro.name tpv_logserproname,tpv_saleconnum.name tpv_saleconnumname,tpv_client.name tpv_clientname," +
                "tpv_tradeproperty.name tpv_tradepropertyname,tpv_tiggdoutype.name tpv_tiggdoutypename,tpv_soudocumtype.name tpv_soudocumtypename," +
                "tpv_costype.name tpv_costypename";

        DataSet tpvCmCostdispose = ORM.create().queryDataSet(algoKey, "tpv_cm_costdispose", selectFileds, qFilters.toArray())
                .select(new String[]{"cast(id as String) id", "tpv_id", "billno tpv_billno", "tpv_itemcode", "tpv_conprodname",
                        "tpv_conorigin", "tpv_conspecation", "tpv_bizdate", "tpv_conshader", "createtime tpv_createtime",
                        "modifytime tpv_modifytime", "tpv_bluered", "tpv_costdirec", "tpv_ispointpriceed", "tpv_tentauth",
                        "tpv_costype", "tpv_currency", "tpv_origprice", "tpv_rate", "tpv_origampintax", "tpv_origampnotax",
                        "tpv_origamptax", "tpv_basampintax", "tpv_basampnotax", "tpv_basamptax", "tpv_dollarintax",
                        "tpv_dollarnotax", "tpv_dollartax", "tpv_soudocumtype", "tpv_soudocumnum", "tpv_soudocumid",
                        "tpv_tiggdoutype", "tpv_tiggdounum", "tpv_tiggdouid","tpv_tiggdoubillid", "tpv_storagenum", "tpv_storageid",
                        "tpv_supstoragenum", "tpv_supstorageid", "tpv_movegoodsnum", "tpv_movegoodsid", "tpv_msungoodsid","tpv_quantity",
                        "tpv_purconnum", "tpv_combinbun", "tpv_vendor", "tpv_logserpro", "tpv_saleconnum", "tpv_client",
                        "tpv_tradeproperty", "tpv_drawback", "tpv_refundrate","tpv_itemcodename","tpv_conprodnamename","tpv_conoriginname",
                        "tpv_currencyname","tpv_purconnumname","tpv_combinbunname","tpv_vendorname","tpv_logserproname","tpv_saleconnumname",
                        "tpv_clientname","tpv_tradepropertyname","tpv_tiggdoutypename","tpv_soudocumtypename","tpv_costypename"});
//        DataSet tpvEliminationId = tpvCmCostdispose.copy();
//        List<String> tpvElimination_s = new ArrayList<>();
//        for (Row row : tpvEliminationId) {
//            String tpvElimination = row.getString("tpv_elimination");
//            if (StringUtils.isNotBlank(tpvElimination)) {
//                tpvElimination_s.add(tpvElimination);
//            }
//        }
        DataSet redQty = ORM.create().queryDataSet(algoKey, "tpv_cm_costdispose", selectFileds, qFilters.toArray());
//        if (tpvElimination_s.size() > 0) {
//            redQty =
//                    redQty.where(String.format("id in (%s)", StringUtil.strip(tpvElimination_s.toString(), "[]"))).groupBy(new String[]{"id", "tpv_elimination"}).sum("tpv_quantity").finish().select("id redId", "tpv_quantity redQty");
//        } else {
//            redQty = redQty.select("id redId", "0 redQty");
//        }
        redQty = redQty.groupBy(new String[]{"tpv_elimination"}).sum("tpv_quantity").sum("tpv_origampintax").sum("tpv_origamptax").sum("tpv_basampintax").sum("tpv_basamptax")
                .finish().select("tpv_elimination", "tpv_quantity redQty","tpv_origampintax redOrigampintax","tpv_origamptax redOrigamptax","tpv_basampintax redBasampintax","tpv_basamptax redBasamptax");
        String[] selectFiled = new String[]{"id", "tpv_id", "tpv_billno", "tpv_itemcode", "tpv_conprodname",
                "tpv_conorigin", "tpv_conspecation", "tpv_bizdate", "tpv_conshader", "tpv_createtime",
                "tpv_modifytime", "tpv_bluered", "tpv_costdirec", "tpv_ispointpriceed", "tpv_tentauth",
                "tpv_costype", "tpv_currency", "tpv_origprice", "tpv_rate", "tpv_origampintax", "tpv_origampnotax",
                "tpv_origamptax", "tpv_basampintax", "tpv_basampnotax", "tpv_basamptax", "tpv_dollarintax",
                "tpv_dollarnotax", "tpv_dollartax", "tpv_soudocumtype", "tpv_soudocumnum", "tpv_soudocumid",
                "tpv_tiggdoutype", "tpv_tiggdounum", "tpv_tiggdouid","tpv_tiggdoubillid", "tpv_storagenum", "tpv_storageid",
                "tpv_supstoragenum", "tpv_supstorageid", "tpv_movegoodsnum", "tpv_movegoodsid", "tpv_msungoodsid","tpv_quantity",
                "tpv_quantity + redQty tpv_redqty","tpv_elimination", "tpv_purconnum", "tpv_combinbun", "tpv_vendor",
                "tpv_logserpro", "tpv_saleconnum", "tpv_client", "tpv_tradeproperty", "tpv_drawback",
                "tpv_refundrate","redOrigampintax","redOrigamptax","redBasampintax","redBasamptax","tpv_itemcodename","tpv_conprodnamename","tpv_conoriginname",
                "tpv_currencyname","tpv_purconnumname","tpv_combinbunname","tpv_vendorname","tpv_logserproname","tpv_saleconnumname",
                "tpv_clientname","tpv_tradepropertyname","tpv_tiggdoutypename","tpv_soudocumtypename","tpv_costypename"};

        DataSet pointprice =
                tpvCmCostdispose.where("tpv_bluered = 'A'").leftJoin(redQty).on("id", "tpv_elimination").select(selectFiled).finish();
        DataSet isPointprice = pointprice.where("tpv_ispointpriceed = 'A'").orderBy(new String[]{"tpv_createtime desc"});
        DataSet notPointprice = pointprice.where("tpv_ispointpriceed != 'A'").orderBy(new String[]{"tpv_createtime desc"});
        DataSet dataSet = isPointprice.union(notPointprice).select(new String[]{"tpv_id", "tpv_billno", "tpv_itemcode"
                , "tpv_conprodname", "tpv_conorigin", "tpv_conspecation", "tpv_bizdate", "tpv_conshader",
                "tpv_createtime", "tpv_modifytime", "tpv_bluered", "tpv_costdirec", "tpv_ispointpriceed",
                "tpv_tentauth", "tpv_costype", "tpv_currency", "tpv_origprice", "tpv_rate", "tpv_origampintax",
                "tpv_origampnotax", "tpv_origamptax", "tpv_basampintax", "tpv_basampnotax", "tpv_basamptax",
                "tpv_dollarintax", "tpv_dollarnotax", "tpv_dollartax", "tpv_soudocumtype", "tpv_soudocumnum",
                "tpv_soudocumid", "tpv_tiggdoutype", "tpv_tiggdounum", "tpv_tiggdouid","tpv_tiggdoubillid", "tpv_storagenum",
                "tpv_storageid", "tpv_supstoragenum", "tpv_supstorageid", "tpv_movegoodsnum", "tpv_movegoodsid",
                "tpv_msungoodsid","tpv_quantity", "tpv_redqty", "tpv_elimination", "tpv_purconnum", "tpv_combinbun", "tpv_vendor",
                "tpv_logserpro", "tpv_saleconnum", "tpv_client", "tpv_tradeproperty", "tpv_drawback", "tpv_refundrate",
                "redOrigampintax","redOrigamptax","redBasampintax","redBasamptax","tpv_itemcodename","tpv_conprodnamename","tpv_conoriginname",
                "tpv_currencyname","tpv_purconnumname","tpv_combinbunname","tpv_vendorname","tpv_logserproname","tpv_saleconnumname",
                "tpv_clientname","tpv_tradepropertyname","tpv_tiggdoutypename","tpv_soudocumtypename","tpv_costypename"});
        String whereFilter = "tpv_redqty > 0";
        // 入库分录id
        if (YEM.isNotEmpty(storageid)) {
            whereFilter = String.format("%s and tpv_storageid in ('%s')", whereFilter, String.join("','", storageid));
        }
        // 暂估/真实
        if (YEM.isNotEmpty(tentauth)) {
            whereFilter = String.format("%s and tpv_tentauth = '%s'", whereFilter, tentauth);
        }
        // 成本类型
        if (costype > 0) {
            whereFilter = String.format("%s and tpv_costype = %s ", whereFilter, costype);
        }
        // 成本方向
        // 入库	A
        //出库	B
        if (YEM.isNotEmpty(costdirec)) {
            whereFilter = String.format("%s and tpv_costdirec = '%s'", whereFilter, costdirec);
        }
        // 上级入库单分录id
        if (YEM.isNotEmpty(supstorageid)) {
            whereFilter = String.format("%s and tpv_supstorageid in ('%s')", whereFilter, String.join("','", supstorageid));
        }
        dataSet = dataSet.where(whereFilter);
        return dataSet;
    }

    /**
     * @Description: //成本汇总表查询报表(过滤条件不包含税率)
     * @param: storageid - [java.util.List<java.lang.String>] - 入库分录id
     * @param: logserproid - [long] - 物流服务商
     * @param: costypeid - [long] - 成本类型
     * @param: currencyid - [long] - 币别
     * @param: rate - [java.math.BigDecimal] - 税率%
     * @return: kd.bos.algo.DataSet
     **/
    public static DataSet getCostSummaryData(List<String> storageid, long logserproid, long costypeid,
                                             long currencyid) {
        DataSet dataSet = getCostSummaryData(storageid, logserproid, costypeid, currencyid, null);
        return dataSet;
    }

    /**
     * @Description: //成本汇总表查询报表(过滤条件包含税率)
     * @param: storageid - [java.util.List<java.lang.String>] - 入库分录id
     * @param: logserprosid - [long] - 物流服务商/供应商
     * @param: costypeid - [long] - 成本类型
     * @param: currencyid - [long] - 币别
     * @param: rate - [java.math.BigDecimal] - 税率%
     * @return: kd.bos.algo.DataSet
     **/
    public static DataSet getCostSummaryData(List<String> storageid, long logserprosid, long costypeid,
                                             long currencyid, BigDecimal rate) {
        QFilter qFilters = new QFilter("billstatus", QCP.equals, "C");

        String selectFileds = "id,billno,createtime,tpv_storageid," +
                "(case when tpv_costype = 1835686669391498240 then tpv_vendor " +
                "when tpv_costype != 1835686669391498240 then tpv_logserpro " +
                "when tpv_vendor = 0 and tpv_logserpro = 0 then null end) tpv_logserpros," +
                "tpv_costdirec,tpv_tentauth,tpv_costype,tpv_costype.number costypeName,tpv_currency,tpv_rate,tpv_origprice," +
//                "(case when tpv_bluered == 'B' then (-1) * tpv_origampintax else tpv_origampintax end) tpv_origampintax," +
//                "(case when tpv_bluered == 'B' then (-1) * tpv_origampnotax else tpv_origampnotax end) tpv_origampnotax," +
//                "(case when tpv_bluered == 'B' then (-1) * tpv_origamptax else tpv_origamptax end) tpv_origamptax," +
//                "(case when tpv_bluered == 'B' then (-1) * tpv_basampintax else tpv_basampintax end) tpv_basampintax," +
//                "(case when tpv_bluered == 'B' then (-1) * tpv_basampnotax else tpv_basampnotax end) tpv_basampnotax," +
//                "(case when tpv_bluered == 'B' then (-1) * tpv_basamptax else tpv_basamptax end) tpv_basamptax," +
//                "(case when tpv_bluered == 'B' then (-1) * tpv_dollarintax else tpv_dollarintax end) tpv_dollarintax," +
//                "(case when tpv_bluered == 'B' then (-1) * tpv_dollarnotax else tpv_dollarnotax end) tpv_dollarnotax," +
//                "(case when tpv_bluered == 'B' then (-1) * tpv_dollartax else tpv_dollartax end) tpv_dollartax," +
//                "(case when tpv_bluered == 'B' then (-1) * tpv_quantity else tpv_quantity end) tpv_quantity";
                "tpv_origampintax,tpv_origampnotax,tpv_origamptax,tpv_basampintax,tpv_basampnotax,tpv_basamptax,tpv_dollarintax," +
                "tpv_dollarnotax,tpv_dollartax,tpv_quantity";
        DataSet tpvCmCostdispose = ORM.create().queryDataSet(algoKey, "tpv_cm_costdispose", selectFileds,
                qFilters.toArray());
        // 入库(暂估)
        DataSet purEstimateOrReal = tpvCmCostdispose.copy().where("tpv_costdirec = 'A'")
                .select("id,billno,createtime,tpv_storageid,tpv_logserpros,tpv_costype,tpv_currency,tpv_rate," +
                        "(case when tpv_tentauth = 'A' then tpv_origampintax else 0.0 end) tpv_estorigampintax,(case when tpv_tentauth = 'A' then tpv_origampnotax else 0.0 end) tpv_estorigampnotax,(case when tpv_tentauth = 'A' then tpv_origamptax else 0.0 end) tpv_estorigamptax," +
                        "(case when tpv_tentauth = 'A' then tpv_basampintax else 0.0 end) tpv_estbasampintax,(case when tpv_tentauth = 'A' then tpv_basampnotax else 0.0 end) tpv_estbasampnotax,(case when tpv_tentauth = 'A' then tpv_basamptax else 0.0 end) tpv_estbasamptax," +
                        "(case when tpv_tentauth = 'A' then tpv_dollarintax else 0.0 end) tpv_estdollarintax,(case when tpv_tentauth = 'A' then tpv_dollarnotax else 0.0 end) tpv_estdollarnotax,(case when tpv_tentauth = 'A' then tpv_dollartax else 0.0 end) tpv_estdollartax,(case when tpv_tentauth = 'A' then tpv_quantity else 0.0 end) tpv_estqty," +
                        "(case when tpv_tentauth = 'B' then tpv_origampintax else 0.0 end) tpv_realorigampintax,(case when tpv_tentauth = 'B' then tpv_origampnotax else 0.0 end) tpv_realorigampnotax,(case when tpv_tentauth = 'B' then tpv_origamptax else 0.0 end) tpv_realorigamptax," +
                        "(case when tpv_tentauth = 'B' then tpv_basampintax else 0.0 end) tpv_realbasampintax,(case when tpv_tentauth = 'B' then tpv_basampnotax else 0.0 end) tpv_realbasampnotax,(case when tpv_tentauth = 'B' then tpv_basamptax else 0.0 end) tpv_realbasamptax," +
                        "(case when tpv_tentauth = 'B' then tpv_dollarintax else 0.0 end) tpv_realdollarintax,(case when tpv_tentauth = 'B' then tpv_dollarnotax else 0.0 end) tpv_realdollarnotax,(case when tpv_tentauth = 'B' then tpv_dollartax else 0.0 end) tpv_realdollartax,(case when tpv_tentauth = 'B' then tpv_quantity else 0.0 end) tpv_realqty");
        // 入库(汇总)
        DataSet purSummary = ORM.create().queryDataSet(algoKey, "tpv_cm_costdispose", selectFileds,
                new QFilter[]{new QFilter("billstatus", QCP.equals, "C")})
                .where("tpv_costdirec = 'A' and costypeName = 'FYXM150.1101'")
                .select("id,billno,tpv_storageid,tpv_logserpros,tpv_costype,tpv_quantity tpv_sumqty")
                .groupBy(new String[]{"tpv_storageid"})
                .sum("tpv_sumqty").finish();
        // 入库
//        ORM.create().toPlainDynamicObjectCollection(purLeft.copy())
        DataSet purLeft = purEstimateOrReal.groupBy(new String[]{"tpv_storageid","tpv_logserpros","tpv_costype","tpv_currency","tpv_rate"})
                .sum("tpv_estqty").sum("tpv_estorigampintax").sum("tpv_estorigampnotax").sum("tpv_estorigamptax")
                .sum("tpv_estbasampintax").sum("tpv_estbasampnotax").sum("tpv_estbasamptax")
                .sum("tpv_estdollarintax").sum("tpv_estdollarnotax").sum("tpv_estdollartax")
                .sum("tpv_realqty").sum("tpv_realorigampintax").sum("tpv_realorigampnotax")
                .sum("tpv_realorigamptax").sum("tpv_realbasampintax").sum("tpv_realbasampnotax")
                .sum("tpv_realbasamptax").sum("tpv_realdollarintax").sum("tpv_realdollarnotax").sum("tpv_realdollartax").finish();

        DataSet purWarehouse = purLeft.leftJoin(purSummary).on("tpv_storageid", "tpv_storageid")
                .select("tpv_storageid", "tpv_logserpros", "tpv_costype", "tpv_currency", "tpv_rate",
                        "tpv_estqty", "tpv_estorigampintax", "tpv_estorigampnotax", "tpv_estorigamptax",
                        "tpv_estbasampintax", "tpv_estbasampnotax", "tpv_estbasamptax", "tpv_estdollarintax",
                        "tpv_estdollarnotax", "tpv_estdollartax", "tpv_realqty", "tpv_realorigampintax", "tpv_realorigampnotax",
                        "tpv_realorigamptax", "tpv_realbasampintax", "tpv_realbasampnotax", "tpv_realbasamptax",
                        "tpv_realdollarintax", "tpv_realdollarnotax", "tpv_realdollartax", "tpv_sumqty",
                        "tpv_estorigampintax + tpv_realorigampintax tpv_sumorigampintax", "tpv_estorigampnotax + tpv_realorigampnotax tpv_sumorigampnotax",
                        "tpv_estorigamptax + tpv_realorigamptax tpv_sumorigamptax",
                        "tpv_estbasampintax + tpv_realbasampintax tpv_sumbasampintax", "tpv_estbasampnotax + tpv_realbasampnotax tpv_sumbasampnotax",
                        "tpv_estbasamptax + tpv_realbasamptax tpv_sumbasamptax",
                        "tpv_estdollarintax + tpv_realdollarintax tpv_sumdollarintax", "tpv_estdollarnotax + tpv_realdollarnotax tpv_sumdollarnotax",
                        "tpv_estdollartax + tpv_realdollartax tpv_sumdollartax").finish();
        // 出库
        DataSet outWarehouse = tpvCmCostdispose.copy().where("tpv_costdirec = 'B'")
                .select("id,billno,createtime,tpv_storageid,tpv_logserpros,tpv_costype,tpv_currency,tpv_rate," +
                        "tpv_origampintax tpv_outorigampintax,tpv_origampnotax tpv_outorigampnotax,tpv_origamptax tpv_outorigamptax," +
                        "tpv_basampintax tpv_outbasampintax,tpv_basampnotax tpv_outbasampnotax,tpv_basamptax tpv_outbasamptax," +
                        "tpv_dollarintax tpv_outdollarintax,tpv_dollarnotax tpv_outdollarnotax,tpv_dollartax tpv_outdollartax," +
                        "tpv_quantity tpv_outqty");
        outWarehouse = outWarehouse.groupBy(new String[]{"tpv_storageid","tpv_logserpros","tpv_costype","tpv_currency","tpv_rate"})
                .sum("tpv_outqty").sum("tpv_outorigampintax").sum("tpv_outorigampnotax").sum("tpv_outorigamptax")
                .sum("tpv_outbasampintax").sum("tpv_outbasampnotax").sum("tpv_outbasamptax")
                .sum("tpv_outdollarintax").sum("tpv_outdollarnotax").sum("tpv_outdollartax").finish();
        DataSet dataSet = purWarehouse.leftJoin(outWarehouse).on("tpv_storageid", "tpv_storageid").on("tpv_logserpros", "tpv_logserpros")
                .on("tpv_costype", "tpv_costype").on("tpv_currency", "tpv_currency").on("tpv_rate", "tpv_rate")
                .select("tpv_storageid", "tpv_logserpros", "tpv_costype", "tpv_currency", "tpv_rate",
                        "tpv_estqty", "tpv_estorigampintax", "tpv_estorigampnotax", "tpv_estorigamptax",
                        "tpv_estbasampintax", "tpv_estbasampnotax", "tpv_estbasamptax",
                        "tpv_estdollarintax", "tpv_estdollarnotax", "tpv_estdollartax", "tpv_realqty",
                        "tpv_realorigampintax", "tpv_realorigampnotax", "tpv_realorigamptax",
                        "tpv_realbasampintax", "tpv_realbasampnotax", "tpv_realbasamptax", "tpv_realdollarintax",
                        "tpv_realdollarnotax", "tpv_realdollartax", "tpv_sumqty", "tpv_sumorigampintax",
                        "tpv_sumorigampnotax", "tpv_sumorigamptax", "tpv_sumbasampintax", "tpv_sumbasampnotax",
                        "tpv_sumbasamptax", "tpv_sumdollarintax", "tpv_sumdollarnotax", "tpv_sumdollartax",
                        "tpv_outqty", "tpv_outorigampintax", "tpv_outorigampnotax",
                        "tpv_outorigamptax", "tpv_outbasampintax", "tpv_outbasampnotax",
                        "tpv_outbasamptax", "tpv_outdollarintax", "tpv_outdollarnotax",
                        "tpv_outdollartax").finish();
        String whereFilter = "1 = 1";
        if (logserprosid > 0) {
            whereFilter = String.format("%s and tpv_logserpros = %s", whereFilter, logserprosid);
        }
        dataSet = dataSet.where(whereFilter);
//        dataSet = dataSet.where(whereFilter).orderBy(new String[]{"createtime desc"}).groupBy(new String[]{"tpv_storageid", "tpv_logserpros", "tpv_costype", "tpv_currency", "tpv_rate"})
//                .sum("tpv_estqty").sum("tpv_estorigampintax").sum("tpv_estorigampnotax")
//                .sum("tpv_estorigamptax").sum("tpv_estbasampintax").sum("tpv_estbasampnotax").sum("tpv_estbasamptax")
//                .sum("tpv_estdollarintax").sum("tpv_estdollarnotax").sum("tpv_estdollartax")
//                .sum("tpv_realqty").sum("tpv_realorigampintax").sum("tpv_realorigampnotax")
//                .sum("tpv_realorigamptax").sum("tpv_realbasampintax").sum("tpv_realbasampnotax").sum("tpv_realbasamptax")
//                .sum("tpv_realdollarintax").sum("tpv_realdollarnotax").sum("tpv_realdollartax")
//                .sum("tpv_sumqty").sum("tpv_sumorigampintax").sum("tpv_sumorigampnotax")
//                .sum("tpv_sumorigamptax").sum("tpv_sumbasampintax").sum("tpv_sumbasampnotax").sum("tpv_sumbasamptax")
//                .sum("tpv_sumdollarintax").sum("tpv_sumdollarnotax").sum("tpv_sumdollartax")
//                .sum("tpv_outqty").sum("tpv_outorigampintax").sum("tpv_outorigampnotax")
//                .sum("tpv_outorigamptax").sum("tpv_outbasampintax").sum("tpv_outbasampnotax").sum("tpv_outbasamptax")
//                .sum("tpv_outdollarintax").sum("tpv_outdollarnotax").sum("tpv_outdollartax")
//                .finish();
        dataSet = dataSet.addField("(case when tpv_estqty is not null and tpv_estqty != 0 then tpv_estorigampintax / tpv_estqty else tpv_estorigampintax end) tpv_estorigprice", "tpv_estorigprice");
        dataSet = dataSet.addField("(case when tpv_estqty is not null and tpv_estqty != 0 then tpv_estbasampintax / tpv_estqty else tpv_estbasampintax end) tpv_estbasprice", "tpv_estbasprice");
        dataSet = dataSet.addField("(case when tpv_estqty is not null and tpv_estqty != 0 then tpv_estdollarintax / tpv_estqty else tpv_estdollarintax end) tpv_estdollprice", "tpv_estdollprice");
        dataSet = dataSet.addField("(case when tpv_realqty is not null and tpv_realqty != 0 then tpv_realorigampintax / tpv_realqty else tpv_realorigampintax end) tpv_realorigprice", "tpv_realorigprice");
        dataSet = dataSet.addField("(case when tpv_realqty is not null and tpv_realqty != 0 then tpv_realbasampintax / tpv_realqty else tpv_realbasampintax end) tpv_realbasprice", "tpv_realbasprice");
        dataSet = dataSet.addField("(case when tpv_realqty is not null and tpv_realqty != 0 then tpv_realdollarintax / tpv_realqty else tpv_realdollarintax end) tpv_realdollprice", "tpv_realdollprice");
        dataSet = dataSet.addField("(case when tpv_sumqty is not null and tpv_sumqty != 0 then tpv_sumorigampintax / tpv_sumqty else tpv_sumorigampintax end) tpv_sumorigprice", "tpv_sumorigprice");
        dataSet = dataSet.addField("(case when tpv_sumqty is not null and tpv_sumqty != 0 then tpv_sumbasampintax / tpv_sumqty else tpv_sumbasampintax end) tpv_sumbasprice", "tpv_sumbasprice");
        dataSet = dataSet.addField("(case when tpv_sumqty is not null and tpv_sumqty != 0 then tpv_sumdollarintax / tpv_sumqty else tpv_sumdollarintax end) tpv_sumdollprice", "tpv_sumdollprice");
        dataSet = dataSet.addField("(case when tpv_outqty is not null and tpv_outqty != 0 then tpv_outorigampintax / tpv_outqty else tpv_outorigampintax end) tpv_outorigprice", "tpv_outorigprice");
        dataSet = dataSet.addField("(case when tpv_outqty is not null and tpv_outqty != 0 then tpv_outbasampintax / tpv_outqty else tpv_outbasampintax end) tpv_outbasprice", "tpv_outbasprice");
        dataSet = dataSet.addField("(case when tpv_outqty is not null and tpv_outqty != 0 then tpv_outdollarintax / tpv_outqty else tpv_outdollarintax end) tpv_outdollprice", "tpv_outdollprice");

        // 入库分录id
        if (YEM.isNotEmpty(storageid)) {
            whereFilter = String.format("%s and tpv_storageid in ('%s')", whereFilter, String.join("','", storageid));
        }
        // 成本类型
        if (0L != costypeid) {
            whereFilter = String.format("%s and tpv_costype = %s ", whereFilter, costypeid);
        }
        // 币别
        if (0L != currencyid) {
            whereFilter = String.format("%s and tpv_currency = %s ", whereFilter, currencyid);
        }
        // 税率%
        if (null != rate) {
            rate = rate != null ? rate : BigDecimal.ZERO;
            whereFilter = String.format("%s and tpv_rate = %s ", whereFilter, rate);
        }
        dataSet = dataSet.where(whereFilter);
        return dataSet;
    }
}
