package tpv.tpv_wm.tpv_crm.java.api.entitys;

import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @Description: 客户额度使用情况表 返回对象参数
 * @Author LinRui
 * @Date 2024/2/22 16:27
 */
@ApiModel
public class CusCreditUseRptData implements Serializable {
    @ApiParam(value = "授信类型", example = "'总额度'")
    private String credittype;
    @ApiParam(value = "查询维度", example = "'全司'")
    private String orgcredit;
    @ApiParam(value = "客户集团", example = "''")
    private String cusgroup;
    @ApiParam(value = "客户", example = "''")
    private String customer;
    @ApiParam(value = "部门", example = "'钢铁产品五部-1组'")
    private String dept;
    @ApiParam(value = "签约(额度)", example = "0.00")
    private BigDecimal signingamt;
    @ApiParam(value = "签约(额度)文本", example = "'80000000.00(已失效)'")
    private String signingamtText;
    @ApiParam(value = "送货(额度)", example = "0.00")
    private BigDecimal shippingamt;
    @ApiParam(value = "送货(额度)文本", example = "'30000000.00(已失效)'")
    private String shippingamtText;
    @ApiParam(value = "签约(额度)", example = "0.00")
    private BigDecimal signinguseamt;
    @ApiParam(value = "签约(额度)文本", example = "'50000000.00(已失效)'")
    private String signinguseamtText;
    @ApiParam(value = "送货(理论占用)", example = "0.00")
    private BigDecimal shippinguseamt;
    @ApiParam(value = "送货(理论占用)文本", example = "'1581400.00(已失效)'")
    private String shippinguseamtText;
    @ApiParam(value = "签约(理论占用)", example = "0.00")
    private BigDecimal signingresidueamt;
    @ApiParam(value = "签约(理论占用)文本", example = "'0.00(已失效)'")
    private String signingresidueamtText;
    @ApiParam(value = "送货(理论占用)", example = "0.00")
    private BigDecimal shippingresidueamt;
    @ApiParam(value = "送货(理论占用)文本", example = "'-349800.00(已失效)'")
    private String shippingresidueamtText;

    public String getCredittype() {
        return credittype;
    }

    public void setCredittype(String credittype) {
        this.credittype = credittype;
    }

    public String getOrgcredit() {
        return orgcredit;
    }

    public void setOrgcredit(String orgcredit) {
        this.orgcredit = orgcredit;
    }

    public String getCusgroup() {
        return cusgroup;
    }

    public void setCusgroup(String cusgroup) {
        this.cusgroup = cusgroup;
    }

    public String getCustomer() {
        return customer;
    }

    public void setCustomer(String customer) {
        this.customer = customer;
    }

    public String getDept() {
        return dept;
    }

    public void setDept(String dept) {
        this.dept = dept;
    }

    public BigDecimal getSigningamt() {
        return signingamt;
    }

    public void setSigningamt(BigDecimal signingamt) {
        this.signingamt = signingamt;
    }

    public String getSigningamtText() {
        return signingamtText;
    }

    public void setSigningamtText(String signingamtText) {
        this.signingamtText = signingamtText;
    }

    public BigDecimal getShippingamt() {
        return shippingamt;
    }

    public void setShippingamt(BigDecimal shippingamt) {
        this.shippingamt = shippingamt;
    }

    public String getShippingamtText() {
        return shippingamtText;
    }

    public void setShippingamtText(String shippingamtText) {
        this.shippingamtText = shippingamtText;
    }

    public BigDecimal getSigninguseamt() {
        return signinguseamt;
    }

    public void setSigninguseamt(BigDecimal signinguseamt) {
        this.signinguseamt = signinguseamt;
    }

    public String getSigninguseamtText() {
        return signinguseamtText;
    }

    public void setSigninguseamtText(String signinguseamtText) {
        this.signinguseamtText = signinguseamtText;
    }

    public BigDecimal getShippinguseamt() {
        return shippinguseamt;
    }

    public void setShippinguseamt(BigDecimal shippinguseamt) {
        this.shippinguseamt = shippinguseamt;
    }

    public String getShippinguseamtText() {
        return shippinguseamtText;
    }

    public void setShippinguseamtText(String shippinguseamtText) {
        this.shippinguseamtText = shippinguseamtText;
    }

    public BigDecimal getSigningresidueamt() {
        return signingresidueamt;
    }

    public void setSigningresidueamt(BigDecimal signingresidueamt) {
        this.signingresidueamt = signingresidueamt;
    }

    public String getSigningresidueamtText() {
        return signingresidueamtText;
    }

    public void setSigningresidueamtText(String signingresidueamtText) {
        this.signingresidueamtText = signingresidueamtText;
    }

    public BigDecimal getShippingresidueamt() {
        return shippingresidueamt;
    }

    public void setShippingresidueamt(BigDecimal shippingresidueamt) {
        this.shippingresidueamt = shippingresidueamt;
    }

    public String getShippingresidueamtText() {
        return shippingresidueamtText;
    }

    public void setShippingresidueamtText(String shippingresidueamtText) {
        this.shippingresidueamtText = shippingresidueamtText;
    }
}
