package tpv.tpv_wm.tpv_crm.java.api.entitys;

import com.fasterxml.jackson.annotation.JsonFormat;
import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description: 供应商预付款单票占用 返回对象参数
 * @Author LinRui
 * @Date 2024/3/21 17:47
 */
@ApiModel
public class SupCreditOneConRptData implements Serializable {
    @ApiParam(value = "单票额度编号", example = "''")
    private String onevotebillno;
    @ApiParam(value = "名称", example = "''")
    private String ticketinfo;
    @JsonFormat(pattern = "yyyy-MM-dd hh:mm:ss")
    @ApiParam(value = "申请日期 格式yyyy-MM-dd hh:mm:ss", example = "''")
    private Date onevobizdate;
    @ApiParam(value = "申请人", example = "''")
    private String operator;
    @ApiParam(value = "申请人id", example = "''")
    private String operatorid;
    @ApiParam(value = "部门", example = "''")
    private String dept;
    @ApiParam(value = "部门id", example = "''")
    private String deptid;
    @ApiParam(value = "采购合同号", example = "''")
    private String purno;
    @JsonFormat(pattern = "yyyy-MM-dd hh:mm:ss")
    @ApiParam(value = "签约日期 格式yyyy-MM-dd hh:mm:ss", example = "''")
    private Date bizdate;
    @ApiParam(value = "现货(额度)", example = "0.00")
    private BigDecimal apspotpayquota;
    @ApiParam(value = "远期(额度)", example = "0.00")
    private BigDecimal apforwordquota;
    @ApiParam(value = "签约(占用增项)", example = "0.00")
    private BigDecimal addsigning;
    @ApiParam(value = "货后(占用增项)", example = "0.00")
    private BigDecimal addafter;
    @ApiParam(value = "现货(占用增项)", example = "0.00")
    private BigDecimal addspots;
    @ApiParam(value = "远期(占用增项)", example = "0.00")
    private BigDecimal addforward;
    @ApiParam(value = "占用减项", example = "0.00")
    private BigDecimal deduction;
    @ApiParam(value = "签约(占用余额)", example = "0.00")
    private BigDecimal residuesigning;
    @ApiParam(value = "货后(占用余额)", example = "0.00")
    private BigDecimal residueafter;
    @ApiParam(value = "现货(占用余额)", example = "0.00")
    private BigDecimal residuespots;
    @ApiParam(value = "远期(占用余额)", example = "0.00")
    private BigDecimal residueforward;
    @ApiParam(value = "现货(理论剩余额度)", example = "0.00")
    private BigDecimal leaveafter;
    @ApiParam(value = "远期(理论剩余额度)", example = "0.00")
    private BigDecimal leaveforward;
    @ApiParam(value = "现货(实际剩余额度)", example = "0.00")
    private BigDecimal fastleaveafter;
    @ApiParam(value = "远期(实际剩余额度)", example = "0.00")
    private BigDecimal fastleaveforward;

    public String getOnevotebillno() {
        return onevotebillno;
    }

    public void setOnevotebillno(String onevotebillno) {
        this.onevotebillno = onevotebillno;
    }

    public String getTicketinfo() {
        return ticketinfo;
    }

    public void setTicketinfo(String ticketinfo) {
        this.ticketinfo = ticketinfo;
    }

    public Date getOnevobizdate() {
        return onevobizdate;
    }

    public void setOnevobizdate(Date onevobizdate) {
        this.onevobizdate = onevobizdate;
    }

    public String getOperator() {
        return operator;
    }

    public void setOperator(String operator) {
        this.operator = operator;
    }

    public String getOperatorid() {
        return operatorid;
    }

    public void setOperatorid(String operatorid) {
        this.operatorid = operatorid;
    }

    public String getDept() {
        return dept;
    }

    public void setDept(String dept) {
        this.dept = dept;
    }

    public String getDeptid() {
        return deptid;
    }

    public void setDeptid(String deptid) {
        this.deptid = deptid;
    }

    public String getPurno() {
        return purno;
    }

    public void setPurno(String purno) {
        this.purno = purno;
    }

    public Date getBizdate() {
        return bizdate;
    }

    public void setBizdate(Date bizdate) {
        this.bizdate = bizdate;
    }

    public BigDecimal getApspotpayquota() {
        return apspotpayquota;
    }

    public void setApspotpayquota(BigDecimal apspotpayquota) {
        this.apspotpayquota = apspotpayquota;
    }

    public BigDecimal getApforwordquota() {
        return apforwordquota;
    }

    public void setApforwordquota(BigDecimal apforwordquota) {
        this.apforwordquota = apforwordquota;
    }

    public BigDecimal getAddsigning() {
        return addsigning;
    }

    public void setAddsigning(BigDecimal addsigning) {
        this.addsigning = addsigning;
    }

    public BigDecimal getAddafter() {
        return addafter;
    }

    public void setAddafter(BigDecimal addafter) {
        this.addafter = addafter;
    }

    public BigDecimal getAddspots() {
        return addspots;
    }

    public void setAddspots(BigDecimal addspots) {
        this.addspots = addspots;
    }

    public BigDecimal getAddforward() {
        return addforward;
    }

    public void setAddforward(BigDecimal addforward) {
        this.addforward = addforward;
    }

    public BigDecimal getDeduction() {
        return deduction;
    }

    public void setDeduction(BigDecimal deduction) {
        this.deduction = deduction;
    }

    public BigDecimal getResiduesigning() {
        return residuesigning;
    }

    public void setResiduesigning(BigDecimal residuesigning) {
        this.residuesigning = residuesigning;
    }

    public BigDecimal getResidueafter() {
        return residueafter;
    }

    public void setResidueafter(BigDecimal residueafter) {
        this.residueafter = residueafter;
    }

    public BigDecimal getResiduespots() {
        return residuespots;
    }

    public void setResiduespots(BigDecimal residuespots) {
        this.residuespots = residuespots;
    }

    public BigDecimal getResidueforward() {
        return residueforward;
    }

    public void setResidueforward(BigDecimal residueforward) {
        this.residueforward = residueforward;
    }

    public BigDecimal getLeaveafter() {
        return leaveafter;
    }

    public void setLeaveafter(BigDecimal leaveafter) {
        this.leaveafter = leaveafter;
    }

    public BigDecimal getLeaveforward() {
        return leaveforward;
    }

    public void setLeaveforward(BigDecimal leaveforward) {
        this.leaveforward = leaveforward;
    }

    public BigDecimal getFastleaveafter() {
        return fastleaveafter;
    }

    public void setFastleaveafter(BigDecimal fastleaveafter) {
        this.fastleaveafter = fastleaveafter;
    }

    public BigDecimal getFastleaveforward() {
        return fastleaveforward;
    }

    public void setFastleaveforward(BigDecimal fastleaveforward) {
        this.fastleaveforward = fastleaveforward;
    }
}
