package tpv.tpv_wm.tpv_crm.java.api.entitys;

import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @Description: 供应商额度使用情况表 返回对象参数
 * @Author LinRui
 * @Date 2024/2/22 16:27
 */
@ApiModel
public class SupCreditUseRptData implements Serializable {
    @ApiParam(value = "授信纬度", example = "'A'")
    private String credittype;
    @ApiParam(value = "查询维度", example = "'A'")
    private String orgcredit;
    @ApiParam(value = "授信纬度 -对应标题", example = "'集团额度'")
    private String credittypeText;
    @ApiParam(value = "查询维度 -对应标题", example = "'全司'")
    private String orgcreditText;
    @ApiParam(value = "供应商集团", example = "'邵测试供应商-钢厂01'")
    private String supgroup;
    @ApiParam(value = "供应商", example = "''")
    private String supplier;
    @ApiParam(value = "部门", example = "'钢铁产品五部-1组'")
    private String dept;
    @ApiParam(value = "签约(额度)", example = "0.00")
    private BigDecimal signingamt;
    @ApiParam(value = "签约(额度)文本", example = "'80000000.00(已失效)'")
    private String signingamtText;
    @ApiParam(value = "现货(额度)", example = "0.00")
    private BigDecimal afteramt;
    @ApiParam(value = "现货(额度)文本", example = "'30000000.00(已失效)'")
    private String afteramtText;
    @ApiParam(value = "远期(额度)", example = "0.00")
    private BigDecimal forwardamt;
    @ApiParam(value = "远期(额度)文本", example = "'50000000.00(已失效)'")
    private String forwardamtText;
    @ApiParam(value = "签约(理论占用)", example = "0.00")
    private BigDecimal addsigning;
    @ApiParam(value = "签约(理论占用)文本", example = "'1581400.00(已失效)'")
    private String addsigningText;
    @ApiParam(value = "现货(理论占用)", example = "0.00")
    private BigDecimal addafter;
    @ApiParam(value = "现货(理论占用)文本", example = "'0.00(已失效)'")
    private String addafterText;
    @ApiParam(value = "远期(理论占用)", example = "0.00")
    private BigDecimal addforward;
    @ApiParam(value = "远期(理论占用)文本", example = "'-349800.00(已失效)'")
    private String addforwardText;
    @ApiParam(value = "签约(理论剩余)", example = "0.00")
    private BigDecimal leavesigning;
    @ApiParam(value = "签约(理论剩余)文本", example = "'78418600.00(已失效)'")
    private String leavesigningText;
    @ApiParam(value = "现货(理论剩余)", example = "0.00")
    private BigDecimal leaveafter;
    @ApiParam(value = "现货(理论剩余)文本", example = "'30000000.00(已失效)'")
    private String leaveafterText;
    @ApiParam(value = "远期(理论剩余)", example = "0.00")
    private BigDecimal leaveforward;
    @ApiParam(value = "远期(理论剩余)文本", example = "'50349800.00(已失效)'")
    private String leaveforwardText;
    @ApiParam(value = "签约(实际剩余额度)", example = "0.00")
    private BigDecimal fastleavesigning;
    @ApiParam(value = "签约(实际剩余额度)文本", example = "'78418600.00(已失效)'")
    private String fastleavesigningText;
    @ApiParam(value = "现货(实际剩余额度)", example = "0.00")
    private BigDecimal fastleaveafter;
    @ApiParam(value = "现货(实际剩余额度)文本", example = "'30000000.00(已失效)'")
    private String fastleaveafterText;
    @ApiParam(value = "远期(实际剩余额度)", example = "0.00")
    private BigDecimal fastleaveforward;
    @ApiParam(value = "远期(实际剩余额度)文本", example = "'50349800.00(已失效)'")
    private String fastleaveforwardText;

    public String getCredittype() {
        return credittype;
    }

    public void setCredittype(String credittype) {
        this.credittype = credittype;
    }

    public String getOrgcredit() {
        return orgcredit;
    }

    public void setOrgcredit(String orgcredit) {
        this.orgcredit = orgcredit;
    }

    public String getCredittypeText() {
        return credittypeText;
    }

    public void setCredittypeText(String credittypeText) {
        this.credittypeText = credittypeText;
    }

    public String getOrgcreditText() {
        return orgcreditText;
    }

    public void setOrgcreditText(String orgcreditText) {
        this.orgcreditText = orgcreditText;
    }

    public String getSupgroup() {
        return supgroup;
    }

    public void setSupgroup(String supgroup) {
        this.supgroup = supgroup;
    }

    public String getSupplier() {
        return supplier;
    }

    public void setSupplier(String supplier) {
        this.supplier = supplier;
    }

    public String getDept() {
        return dept;
    }

    public void setDept(String dept) {
        this.dept = dept;
    }

    public BigDecimal getSigningamt() {
        return signingamt;
    }

    public void setSigningamt(BigDecimal signingamt) {
        this.signingamt = signingamt;
    }

    public String getSigningamtText() {
        return signingamtText;
    }

    public void setSigningamtText(String signingamtText) {
        this.signingamtText = signingamtText;
    }

    public BigDecimal getAfteramt() {
        return afteramt;
    }

    public void setAfteramt(BigDecimal afteramt) {
        this.afteramt = afteramt;
    }

    public String getAfteramtText() {
        return afteramtText;
    }

    public void setAfteramtText(String afteramtText) {
        this.afteramtText = afteramtText;
    }

    public BigDecimal getForwardamt() {
        return forwardamt;
    }

    public void setForwardamt(BigDecimal forwardamt) {
        this.forwardamt = forwardamt;
    }

    public String getForwardamtText() {
        return forwardamtText;
    }

    public void setForwardamtText(String forwardamtText) {
        this.forwardamtText = forwardamtText;
    }

    public BigDecimal getAddsigning() {
        return addsigning;
    }

    public void setAddsigning(BigDecimal addsigning) {
        this.addsigning = addsigning;
    }

    public String getAddsigningText() {
        return addsigningText;
    }

    public void setAddsigningText(String addsigningText) {
        this.addsigningText = addsigningText;
    }

    public BigDecimal getAddafter() {
        return addafter;
    }

    public void setAddafter(BigDecimal addafter) {
        this.addafter = addafter;
    }

    public String getAddafterText() {
        return addafterText;
    }

    public void setAddafterText(String addafterText) {
        this.addafterText = addafterText;
    }

    public BigDecimal getAddforward() {
        return addforward;
    }

    public void setAddforward(BigDecimal addforward) {
        this.addforward = addforward;
    }

    public String getAddforwardText() {
        return addforwardText;
    }

    public void setAddforwardText(String addforwardText) {
        this.addforwardText = addforwardText;
    }

    public BigDecimal getLeavesigning() {
        return leavesigning;
    }

    public void setLeavesigning(BigDecimal leavesigning) {
        this.leavesigning = leavesigning;
    }

    public String getLeavesigningText() {
        return leavesigningText;
    }

    public void setLeavesigningText(String leavesigningText) {
        this.leavesigningText = leavesigningText;
    }

    public BigDecimal getLeaveafter() {
        return leaveafter;
    }

    public void setLeaveafter(BigDecimal leaveafter) {
        this.leaveafter = leaveafter;
    }

    public String getLeaveafterText() {
        return leaveafterText;
    }

    public void setLeaveafterText(String leaveafterText) {
        this.leaveafterText = leaveafterText;
    }

    public BigDecimal getLeaveforward() {
        return leaveforward;
    }

    public void setLeaveforward(BigDecimal leaveforward) {
        this.leaveforward = leaveforward;
    }

    public String getLeaveforwardText() {
        return leaveforwardText;
    }

    public void setLeaveforwardText(String leaveforwardText) {
        this.leaveforwardText = leaveforwardText;
    }

    public BigDecimal getFastleavesigning() {
        return fastleavesigning;
    }

    public void setFastleavesigning(BigDecimal fastleavesigning) {
        this.fastleavesigning = fastleavesigning;
    }

    public String getFastleavesigningText() {
        return fastleavesigningText;
    }

    public void setFastleavesigningText(String fastleavesigningText) {
        this.fastleavesigningText = fastleavesigningText;
    }

    public BigDecimal getFastleaveafter() {
        return fastleaveafter;
    }

    public void setFastleaveafter(BigDecimal fastleaveafter) {
        this.fastleaveafter = fastleaveafter;
    }

    public String getFastleaveafterText() {
        return fastleaveafterText;
    }

    public void setFastleaveafterText(String fastleaveafterText) {
        this.fastleaveafterText = fastleaveafterText;
    }

    public BigDecimal getFastleaveforward() {
        return fastleaveforward;
    }

    public void setFastleaveforward(BigDecimal fastleaveforward) {
        this.fastleaveforward = fastleaveforward;
    }

    public String getFastleaveforwardText() {
        return fastleaveforwardText;
    }

    public void setFastleaveforwardText(String fastleaveforwardText) {
        this.fastleaveforwardText = fastleaveforwardText;
    }
}
