package tpv.tpv_wm.tpv_crm.java.api.openapi;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.openapi.common.custom.annotation.*;
import kd.bos.openapi.common.result.CustomApiResult;
import tpv.tpv_wm.tpv_crm.java.api.entitys.CusCreditBalanceConData;
import tpv.tpv_wm.tpv_crm.java.api.entitys.CusCreditBalanceConResult;
import tpv.tpv_wm.tpv_crm.java.api.entitys.QueryCusCreditBalanceConModel;
import tpv.tpv_wm.tpv_crm.java.utils.CusCreditLimitUtils;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.List;

/**
 * @Description: 开放查询接口，将参数传入非配供业务-可放货余额明细表，返回ResultData
 * @Author LinRui
 * @Date 2024/2/21 10:25
 */
@ApiController(value = "CusCreditBalanceCon", desc = "非配供业务-可放货余额明细表")
@ApiMapping("CusCreditBalanceCon")

@ApiErrorCodes({
        @ApiErrorCode(code = "404", desc = "路径访问错误")
})
public class CusCreditBalanceConController implements Serializable {
    @ApiPostMapping(value = "queryCusBalanceCon", desc = "查询非配供业务-可放货余额")
    public CustomApiResult<CusCreditBalanceConResult> queryCusBalanceCon(@NotNull @Valid @ApiRequestBody(value = "请输入参数") QueryCusCreditBalanceConModel conModel) {
        JSONArray jsonArray = CusCreditLimitUtils.resultBalanceConsData(conModel.getDepName(), conModel.getCustomerName(), conModel.getContractNo());
        List<CusCreditBalanceConData> list = JSONObject.parseArray(jsonArray.toJSONString(),CusCreditBalanceConData.class);
        CusCreditBalanceConResult data = new CusCreditBalanceConResult();
        data.setList(list);
        return CustomApiResult.success(data);
    }
}
