package tpv.tpv_wm.tpv_crm.java.api.openapi;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.openapi.common.custom.annotation.*;
import kd.bos.openapi.common.result.CustomApiResult;
import tpv.tpv_wm.tpv_crm.java.api.entitys.CusCreditBalanceKJData;
import tpv.tpv_wm.tpv_crm.java.api.entitys.CusCreditBalanceKJResult;
import tpv.tpv_wm.tpv_crm.java.api.entitys.QueryCusCreditBalanceKJModel;
import tpv.tpv_wm.tpv_crm.java.utils.CusCreditLimitUtils;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.List;

/**
 * @Description: 开放查询接口，将参数传入框架配供业务-可放货余额明细表，返回ResultData
 * @Author LinRui
 * @Date 2024/2/21 10:25
 */
@ApiController(value = "CusCreditBalanceKJ", desc = "框架配供业务-可放货余额明细表")
@ApiMapping("CusCreditBalanceKJ")

@ApiErrorCodes({
        @ApiErrorCode(code = "404", desc = "路径访问错误")
})
public class CusCreditBalanceKJController implements Serializable {
    @ApiPostMapping(value = "queryCusBalanceKJ", desc = "查询框架配供业务-可放货余额")
    public CustomApiResult<CusCreditBalanceKJResult> queryCusBalanceKJ(@NotNull @Valid @ApiRequestBody(value = "请输入参数") QueryCusCreditBalanceKJModel kjModel) {
        JSONArray jsonArray = CusCreditLimitUtils.resultBalanceKJsData(kjModel.getDepName(), kjModel.getCustomerName(), kjModel.getProject());
        List<CusCreditBalanceKJData> list = JSONObject.parseArray(jsonArray.toJSONString(),CusCreditBalanceKJData.class);
        CusCreditBalanceKJResult data = new CusCreditBalanceKJResult();
        data.setList(list);
        return CustomApiResult.success(data);
    }
}
