package tpv.tpv_wm.tpv_crm.java.api.openapi;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.openapi.common.custom.annotation.*;
import kd.bos.openapi.common.result.CustomApiResult;
import tpv.tpv_wm.tpv_crm.java.api.entitys.*;
import tpv.tpv_wm.tpv_crm.java.report.SupCreditUseRptQuery;
import tpv.tpv_wm.tpv_crm.java.utils.CusCreditLimitUtils;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.List;

/**
 * @Description: 开放查询接口，将参数传入项目配供业务-可放货余额明细表，返回ResultData
 * @Author LinRui
 * @Date 2024/2/21 10:24
 */
@ApiController(value = "CusCreditBalanceXM", desc = "项目配供业务-可放货余额明细表")
@ApiMapping("CusCreditBalanceXM")

@ApiErrorCodes({
        @ApiErrorCode(code = "404", desc = "路径访问错误")
})
public class CusCreditBalanceXMController implements Serializable {
    @ApiPostMapping(value = "queryCusBalanceXM", desc = "查询项目配供业务-可放货余额")
    public CustomApiResult<CusCreditBalanceXMResult> queryCusBalanceCon(@NotNull @Valid @ApiRequestBody(value = "请输入参数") QueryCusCreditBalanceXMModel xmModel) {
        JSONArray jsonArray = CusCreditLimitUtils.resultBalanceXMsData(xmModel.getDepName(), xmModel.getCustomerName(), xmModel.getProject());
        List<CusCreditBalanceXMData> list = JSONObject.parseArray(jsonArray.toJSONString(),CusCreditBalanceXMData.class);
        CusCreditBalanceXMResult data = new CusCreditBalanceXMResult();
        data.setList(list);
        return CustomApiResult.success(data);
    }
}
