package tpv.tpv_wm.tpv_crm.java.api.openapi;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.openapi.common.custom.annotation.*;
import kd.bos.openapi.common.result.CustomApiResult;
import tpv.tpv_wm.tpv_crm.java.api.entitys.*;
import tpv.tpv_wm.tpv_crm.java.utils.CusCreditLimitUtils;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.List;

/**
 * @Description: 开放查询接口，将参数传入客户额度使用情况表，返回ResultData
 * @Author LinRui
 * @Date 2023/10/21 20:55
 */
@ApiController(value = "CusCreditUsage", desc = "客户额度使用情况表")
@ApiMapping("CusCreditUsage")

@ApiErrorCodes({
        @ApiErrorCode(code = "404", desc = "路径访问错误")
})
public class CusCreditUsageResultController implements Serializable {
    @ApiPostMapping(value = "queryCusCreditUsage", desc = "查询客户额度使用情况表")
    public CustomApiResult<CusCreditUseRptResult> queryCusCreditUsage(@NotNull @Valid @ApiRequestBody(value = "请输入参数") QueryCusCreditUsageModel cusUsagemodel) {
        JSONArray jsonArray = CusCreditLimitUtils.resultData(cusUsagemodel.getCredittype(), cusUsagemodel.getOrgcredit(),
                cusUsagemodel.getCusgroup(), cusUsagemodel.getDept(), cusUsagemodel.getCustomer());
        List<CusCreditUseRptData> list = JSONObject.parseArray(jsonArray.toJSONString(),CusCreditUseRptData.class);
        CusCreditUseRptResult data = new CusCreditUseRptResult();
        data.setList(list);
        return CustomApiResult.success(data);
    }
}
