package tpv.tpv_wm.tpv_crm.java.api.openapi;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.openapi.common.custom.annotation.*;
import kd.bos.openapi.common.result.CustomApiResult;
import tpv.tpv_wm.tpv_crm.java.api.entitys.*;
import tpv.tpv_wm.tpv_crm.java.report.SupCreditOneConRptQuery;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.List;

/**
 * @Description: 供应商预付款单票占用，将参数传入供应商额度使用情况表，返回ResultData
 * @Author LinRui
 * @Date 2024/3/21 17:55
 */
@ApiController(value = "SupCreditOneCon", desc = "供应商预付款单票占用")
@ApiMapping("SupCreditOneCon")

@ApiErrorCodes({
        @ApiErrorCode(code = "404", desc = "路径访问错误")
})
public class SupCreditOneConController implements Serializable {
    @ApiPostMapping(value = "querySupCreditOneCon", desc = "查询供应商预付款单票占用")
    public CustomApiResult<SupCreditOneConRptResult> querySupCreditOneCon(@NotNull @Valid @ApiRequestBody(value = "请输入参数") QuerySupCreditOneConModel oneConModel) {
        JSONArray jsonArray = SupCreditOneConRptQuery.resultData(oneConModel.getDept(), oneConModel.getPurcontrnum());
        List<SupCreditOneConRptData> list = JSONObject.parseArray(jsonArray.toJSONString(),SupCreditOneConRptData.class);
        SupCreditOneConRptResult data = new SupCreditOneConRptResult();
        data.setList(list);
        return CustomApiResult.success(data);
    }
}
