package tpv.tpv_wm.tpv_crm.java.api.openapi;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.openapi.common.custom.annotation.*;
import kd.bos.openapi.common.result.CustomApiResult;
import tpv.tpv_wm.tpv_crm.java.api.entitys.QuerySupCreditUsageModel;
import tpv.tpv_wm.tpv_crm.java.api.entitys.SupCreditUseRptData;
import tpv.tpv_wm.tpv_crm.java.api.entitys.SupCreditUseRptResult;
import tpv.tpv_wm.tpv_crm.java.report.SupCreditUseRptQuery;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.List;

/**
 * @Description: 开放查询接口，将参数传入供应商额度使用情况表，返回ResultData
 * @Author LinRui
 * @Date 2023/10/21 20:55
 */
@ApiController(value = "SupCreditUsage", desc = "供应商额度使用情况表")
@ApiMapping("SupCreditUsage")

@ApiErrorCodes({
        @ApiErrorCode(code = "404", desc = "路径访问错误")
})
public class SupCreditUsageResultController implements Serializable {
    @ApiPostMapping(value = "querySupCreditUsage", desc = "查询供应商额度使用情况表")
    public CustomApiResult<SupCreditUseRptResult> querySupCreditUsage(@NotNull @Valid @ApiRequestBody(value = "请输入参数") QuerySupCreditUsageModel supUsagemodel) {
        JSONArray jsonArray = SupCreditUseRptQuery.resultData(supUsagemodel.getCredittype(), supUsagemodel.getOrgcredit(),
                supUsagemodel.getSupgroup(), supUsagemodel.getDept(), supUsagemodel.getSuppliers());
        List<SupCreditUseRptData> list = JSONObject.parseArray(jsonArray.toJSONString(),SupCreditUseRptData.class);
        SupCreditUseRptResult data = new SupCreditUseRptResult();
        data.setList(list);
        return CustomApiResult.success(data);
    }
}
