package tpv.tpv_wm.tpv_crm.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.util.EventObject;

/**
 * @Description: 供应商，客户额度申请 申请人带出部门
 * @Auther: zbh
 */
public class ApplicantDepFormPlugin extends AbstractBillPlugIn {

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String propertyName = e.getProperty().getName();// 获取字段
        ChangeData cd = e.getChangeSet()[0];//正在发生改变的数据

        switch (propertyName) {
            //监听申请人
            case "tpv_operator":
                auditorChange(cd);
                operator();
                break;
        }
    }

    /**
     * @Title: beginApplicant
     * @Descripton:   根据人员带出部门
     * @reurn: a
     */
    private void beginApplicant() {
        DynamicObject tpvApplicant = (DynamicObject) this.getModel().getValue("tpv_operator");
        long applierId = (long) tpvApplicant.getPkValue();
        this.getModel().setValue("tpv_department", UserServiceHelper.getUserMainOrgId(applierId));
    }

    /**
     * @Title: beginApplicant
     * @Descripton:   业务员有多个部门，将部门设置为空
     * @reurn: a
     */
    private void operator() {
        DynamicObject value = (DynamicObject) this.getModel().getValue("tpv_operator");
        if (value == null) {
            return;
        }
        Object number = value.get("number");
        DynamicObject single = BusinessDataServiceHelper.loadSingle("bos_user", "entryentity,dpt", new QFilter[]{new QFilter("number", QCP.equals, number)});
        DynamicObjectCollection entryentity = single.getDynamicObjectCollection("entryentity");
        if (entryentity.size() != 1) {
            this.getView().setEnable(true,"tpv_department");
            this.getModel().setValue("tpv_department", null);
        }
    }


    /**
     * @Title: beginApplicant
     * @Descripton: 申请人改变带出部门
     * @reurn: a
     */
    private void auditorChange(ChangeData cd) {
        // 申请人改变时校验申请组织
        if (cd.getNewValue() == null) {
            this.getModel().setValue("tpv_operator", null);
        } else {
            long applierId = (long) ((DynamicObject) cd.getNewValue()).getPkValue();
            if (this.getModel().getValue("tpv_operator") != null) {
                this.getModel().setValue("tpv_department", UserServiceHelper.getUserMainOrgId(applierId));
            }
        }
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        this.beginApplicant();
        operator();
    }

}
