package tpv.tpv_wm.tpv_crm.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.entity.ValueMapItem;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.ComboProp;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.ComboEdit;
import kd.bos.form.field.ComboItem;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.*;

/**
 * @author l jw
 * @version 1.0
 * 2@date 2023/8/25 10:52
 * 客户额度维护表单插件
 */
public class CustmainliFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit org = (BasedataEdit) this.getView().getControl("tpv_organization");
        org.addBeforeF7SelectListener((BeforeF7SelectListener) this);
    }

    /**
     * 根据所选择的类型进行过滤
     * @param e
     */
    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            //组织过滤
            case "tpv_organization":
                qFilterOrg(e);
                break;
            case "tpv_guaranums":
                qFilterThisOrgName(e);
                break;
        }
    }
    /**
     * @param e
     */
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        IDataModel model = this.getModel();
//        extracted(); //此方法作废，下推单据开发触发处理逻辑
        setTpvEffictivetypeTitle(); //设置有效期类型
//        DynamicObject[] load = BusinessDataServiceHelper.load("tpv_crm_custmain", "tpv_crm_cuslimit,tpv_crm_cuslimit.tpv_frozenstate", null);
//        if (load.length > 0) {
//            for (DynamicObject dynamicObject : load) {
//                DynamicObjectCollection dynamicObjects = dynamicObject.getDynamicObjectCollection("tpv_crm_cuslimit");
//                for (DynamicObject object : dynamicObjects) {
//                    object.set("tpv_frozenstate","B");
//                }
//            }
//        }
//        SaveServiceHelper.save(load);
    }

    private void extracted() {
        OperationStatus status = this.getView().getFormShowParameter().getStatus();
        String documentype = (String) this.getModel().getValue("tpv_documentype");
        if (null != documentype) {
            if ("B".equals(documentype)) {
                if (OperationStatus.ADDNEW == status) {
                    this.getView().setEnable(false, "tpv_documentype");
                }
                //设置下拉列表显示标题
                Map<String, Object> map = new HashMap<String, Object>();
                map.put("定期有效", "B");
                map.put("依存担保", "C");
                fillEntityCombo(map);
            }
            if ("A".equals(documentype)) {
                this.getModel().setValue("tpv_validtype", "A");
            }
        }
        Date date = new Date();
        Date tpvStartdates = (Date) this.getModel().getValue("tpv_startdates");//开始时间
        Date tpvDeadlines = (Date) this.getModel().getValue("tpv_deadlines");//结束时间
        if (tpvDeadlines != null) {
            if ((tpvStartdates.before(date) || date.equals(tpvStartdates)) && (tpvDeadlines.after(date) || date.equals(tpvDeadlines))) {
                this.getModel().setValue("tpv_invalids", false);
            } else {
                this.getModel().setValue("tpv_invalids", true);
            }
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs evt) {// 值更新事件
        super.propertyChanged(evt);
        ChangeData cd = evt.getChangeSet()[0];
        String name = evt.getProperty().getName();
        switch (name) {
            case "tpv_custom":
                customer(cd);
                break;
            case "tpv_quotatype":
                custonum(cd);
                break;
            case "tpv_orgcredit":
                clearOrg();
                break;
            case "tpv_documentype":
                setTpvEffictivetypeTitle();
                break;
        }
    }

    /**
     * 设置显示下拉标题
     */
    private void setTpvEffictivetypeTitle() {
        String tpv_billtype = (String) this.getModel().getValue("tpv_documentype");
        if ("A".equals(tpv_billtype)) {
            //设置下拉列表显示标题
            Map<String, Object> map = new HashMap<String, Object>();
            map.put("长期有效", "A");
            fillEntityCombo(map);
        } else if ("B".equals(tpv_billtype)) {
            //设置下拉列表显示标题
            Map<String, Object> map = new HashMap<String, Object>();
            map.put("定期有效", "B");
            map.put("依存担保", "C");
            fillEntityCombo(map);
        } else {
            Map<String, Object> map = new HashMap<String, Object>();
            map.put("长期有效", "A");
            map.put("定期有效", "B");
            map.put("依存担保", "C");
            fillEntityCombo(map);
        }
    }

    /**
     * @param map 下拉项值
     */
    private void fillEntityCombo(Map<String, Object> map) {
        ComboEdit mainentry = (ComboEdit) this.getView().getControl("tpv_validtype");
        if (map.size() > 0) {
            List<ComboItem> entryItems = this.buildEntryComboItems(map);
            mainentry.setComboItems(entryItems);
        } else {
            mainentry.setComboItems(null);
        }
    }

    /**
     * 设置过滤部门形态
     */
    private void clearOrg() {
        Map<String, Object> text = new HashMap<String, Object>();

        Object value = this.getModel().getValue("tpv_orgcredit");
        if (value.equals("A")) {
            text.put("zh_CN", "公司");
        }
        if (value.equals("B")) {
            text.put("zh_CN", "部门");
        }

        if (null != value) {
            this.getModel().setValue("tpv_organization", null);
        }
        this.getView().updateControlMetadata("tpv_organization", text);//参数1：单据体标识
        this.getView().updateView("tpv_organization");

    }

    /**
     * 客户类型重复
     * @param cd
     */
    private void custonum(ChangeData cd) {
        String custo = (String) cd.getNewValue();//获取改变的值
        int Index = cd.getRowIndex();
        Object oldValue = cd.getOldValue();
        DynamicObjectCollection entrys = this.getModel().getEntryEntity("tpv_crm_cuslimit");
        DynamicObject custom = (DynamicObject) this.getModel().getValue("tpv_custom", Index);//获取改变的行的客户
        for (DynamicObject entry : entrys) {
            DynamicObject tpvCustom = entry.getDynamicObject("tpv_custom");
            String tpvQuotatype = entry.getString("tpv_quotatype");
            int row = entry.getInt("Seq") - 1;
            if (row == Index) {
                return;
            }
            if (tpvCustom != null && tpvCustom.equals(custom)) {
                if (tpvQuotatype.equals(custo) && tpvCustom == custom) {
                    this.getView().showMessage("该客户类型重复，请修改！！！");
                    this.getModel().setValue("tpv_quotatype",String.valueOf(oldValue),Index);
                    this.getView().updateView("tpv_quotatype",Index);
                }
            }
        }
    }

    /**
     * 客户重复
     * @param cd
     */
    private void customer(ChangeData cd) {
        DynamicObject custom = (DynamicObject) cd.getNewValue();
        int a = cd.getRowIndex();
        DynamicObjectCollection entrys = this.getModel().getEntryEntity("tpv_crm_cuslimit");
        int i = 0;
        for (DynamicObject entry : entrys) {
            DynamicObject tpvCustom = entry.getDynamicObject("tpv_custom");
            if (custom == tpvCustom) {
                i = i + 1;
            }
            if (i > 2) {
                this.getView().showMessage("该客户已增加，请更改客户！！！");
                this.getModel().setValue("tpv_custom", null, a);
            }
        }
    }

    /**
     * 组织过滤
     *
     * @param e
     */
    private void qFilterOrg(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Object Credit = dataEntity.get("tpv_orgcredit");//公司/部门授信
        //获取下拉框的值
        ComboProp comboProp = (ComboProp) dataEntity.getDynamicObjectType().getProperties().get("tpv_orgcredit");
        List<ValueMapItem> comboData = comboProp.getComboItems();

        String credit = null;//创建变量,存储选中的下拉标题
        if (Credit == null) {
            return;
        }
        //遍历下拉框的数据,获取选中值的下拉标题
        for (ValueMapItem item : comboData) {
            if (Credit.equals(item.getValue())) {
                credit = item.getName().toString();
                break;
            }
        }
        //构造过滤条件(组织形态.名称=授信)
        QFilters.add(new QFilter("orgpattern.name", QCP.equals, credit)); //设置过滤条件：形态
        showParameter.getListFilterParameter().setQFilters(QFilters);

    }

    private void qFilterThisOrgName(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject org = dataEntity.getDynamicObject("tpv_organization");
        if (org == null) {
            return;
        }
        Long id = (Long) org.get("id");
        QFilters.add(new QFilter("tpv_organization", "=", id)); //设置过滤条件：组织
        QFilters.add(new QFilter("billstatus", "=", "C")); //单据状态：已审核
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    /**
     * @param entitys
     * @return
     */
    private List<ComboItem> buildEntryComboItems(Map<String, Object> entitys) {
        ArrayList<ComboItem> entryItems = new ArrayList<>();
        ComboItem blankItem = new ComboItem();
        blankItem.setValue("");
        blankItem.setCaption(new LocaleString());
        entryItems.add(blankItem);
        if (null != entitys && entitys.size() > 0) {
            for (Map.Entry entry : entitys.entrySet()) {
                String mapKey = (String) entry.getKey();
                String mapValue = (String) entry.getValue();
                ComboItem entryItem = new ComboItem();
                entryItem.setValue(mapValue);
                entryItem.setCaption(new LocaleString(mapKey));
                entryItems.add(entryItem);
//                this.getView().updateView();
            }
        }
        return entryItems;
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs afterDoOperationEventArgs) {
        super.afterDoOperation(afterDoOperationEventArgs);
        String operateKey = afterDoOperationEventArgs.getOperateKey();
        if ("save".equals(operateKey)) {
//            this.getView().invokeOperation("refresh");
            this.getView().updateView("tpv_crm_cuslimit.tpv_frozenstate");
        }
    }
}


