package tpv.tpv_wm.tpv_crm.java.formplugin.list;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.list.IListView;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description: 部门资金额度属性表 唯一生效
 * @Auther: zbh
 */
public class DelimitVerificationFormPlugin extends AbstractListPlugin {
    @Override
    public void beforeItemClick(BeforeItemClickEvent evt) {
        super.beforeItemClick(evt);
        //获取按标识名
        String key = evt.getItemKey();
        //获取所有选中单据
        List<Long> billId = this.getListBillId();
        if (!billId.isEmpty()) {
            //如果按钮为启用按钮，执行以下流程
            if ("tblenable".equals(key)) {
                if (billId.size() == 1) {
                    //加载选中的单据
                    DynamicObject selected = BusinessDataServiceHelper.loadSingle(billId.get(0), "tpv_sc_delimittab", "enable,tpv_department");
                    DynamicObject department = selected.getDynamicObject("tpv_department");
                    String enable = selected.getString("enable");
                    //加载遍历所有其他单据，将状态为启用的改为禁用
                    DynamicObject[] load = BusinessDataServiceHelper.load("tpv_sc_delimittab", "enable,tpv_department", null);
                    for (DynamicObject single : load) {
                        DynamicObject departments = (DynamicObject) single.get("tpv_department");
                        String enables = single.getString("enable");
                        if (department.equals(departments)) {
                            if ("1".equals(enables)) {
                                this.getView().showErrorNotification("已存在生效数据!");
                                evt.setCancel(true);
                            }
                        }
                    }
                } else {
                    this.getView().showErrorNotification("请只选择一条数据!");
                    evt.setCancel(true);
                }
                ((IListView) this.getView()).refresh();
            }
        }
    }

    /**
     * @Title: getListBillId
     * @Descriptin:  获取所有选中单据的Id
     * @retrn: a
     */
    private List<Long> getListBillId() {
        IListView view = (IListView) this.getView();
        //查询列表所勾选的数据
        ListSelectedRowCollection selectedRows = view.getSelectedRows();
        List<Long> billId = new ArrayList<>();
        for (ListSelectedRow row : selectedRows) {
            //获取每条数据的内码
            Long pkId = (Long) row.getPrimaryKeyValue();
            if (!billId.contains(pkId)) {
                billId.add(pkId);
            }
        }
        return billId;
    }
}
