package tpv.tpv_wm.tpv_crm.java.opplugin.op;


import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.*;

import static com.itopview.wm.utils.DateUtil.countDays;

/**
 * @author l jw
 * @date 2023/8/26 18:45
 * @className CustmainSaveOp
 * @description 客户额度维护保存服务插件
 */
public class CustmainSaveOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_frozenstate");
        fieldKeys.add("billno");
        fieldKeys.add("tpv_organization");
        fieldKeys.add("tpv_crm_cuslimit");
        fieldKeys.add("tpv_icreditperiod");
        fieldKeys.add("tpv_intadditgraces");
        fieldKeys.add("tpv_custom");
        e.setFieldKeys(fieldKeys);
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
    }

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        String key = e.getOperationKey();
        if ("save".equals(key)) {
//            Updatecombofield(e);
        }
    }

    /**
     * 180天没有该【客户】已审核的《销售出库单》则自动更新为“是”，根据《销售出库单》【业务日期】判断
     *
     * @param e 上下文擦参数
     */
    public void Updatecombofield(BeforeOperationArgs e) {
        DynamicObject[] dataEntities = e.getDataEntities();
        for (DynamicObject dataEntity : dataEntities) {
            DynamicObjectCollection tpvCrmCuslimit = dataEntity.getDynamicObjectCollection("tpv_crm_cuslimit");
            if (tpvCrmCuslimit.size() > 0) {
                for (int i = 0; i < tpvCrmCuslimit.size(); i++) {
                    DynamicObject cuslimit = tpvCrmCuslimit.get(i);
                    DynamicObject tpvCustom = cuslimit.getDynamicObject("tpv_custom");
                    if (tpvCustom != null) {
                        QFilter qFilter = new QFilter("customer.id", QCP.equals, tpvCustom.getLong("id"));
                        qFilter.and(new QFilter("billstatus", QCP.equals, "C"));
                        //根据时间降序，去最新的数据
                        DynamicObject[] imSaloutbill = BusinessDataServiceHelper.load("im_saloutbill", "id,billno,biztime"
                                , new QFilter[]{qFilter}, "biztime desc");
                        if (imSaloutbill.length == 0) {
                            cuslimit.set("tpv_frozenstate", "A");//是
                        }
                        if (imSaloutbill.length > 0) {
                            for (int j = 0; j < imSaloutbill.length; j++){
                                DynamicObject saloutbill = imSaloutbill[j];
                                if (saloutbill != null) {
                                    Date biztime = saloutbill.getDate("biztime");//销售出库业务日期
                                    String tpvValidtype = dataEntity.getString("tpv_validtype");
                                    Date createtime = dataEntity.getDate("createtime");
                                    Date tpvStartdates = dataEntity.getDate("tpv_startdates");
                                    if ("A".equals(tpvValidtype)) {
                                        if (countDays(biztime, createtime) >= 180) {
                                            cuslimit.set("tpv_frozenstate", "A");//是
                                        } else {
                                            cuslimit.set("tpv_frozenstate", "B");//否
                                        }
                                    }
                                    if ("B".equals(tpvValidtype) | "C".equals(tpvValidtype)) {
                                        if (countDays(biztime, tpvStartdates) >= 180) {
                                            cuslimit.set("tpv_frozenstate", "A");//是
                                        } else {
                                            cuslimit.set("tpv_frozenstate", "B");//否
                                        }
                                    }
                                }
                                break;
                            }
                        }

                    }
                }
            }
        }
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() {
                StringBuilder errorMsg = new StringBuilder("");
                ExtendedDataEntity[] bills = this.getDataEntities();
                if ("save".equals(this.getOperateKey()) && null != e.getDataEntities()) {
                    for (int i = 0; i < bills.length; ++i) {
                        ExtendedDataEntity bill = bills[i];
//                        onsubmitDate(bill);
                        errorMsg.append(validateIsOneEntrySuppliers(bill));
                        if (!errorMsg.toString().isEmpty()){
                            this.addMessage(bill,errorMsg.toString());
                        }
                    }
                }
            }

            /**
             * @Title: validateIsSuppliers
             * @Description: 校验{分录-供应商额度 }中供应商，只允许存在一个【供应商集团】下
             * @param:
             * @return: String
             */
            private String validateIsOneEntrySuppliers(ExtendedDataEntity bills) {
                DynamicObject dataEntity = bills.getDataEntity();
                String errorMsg = "";
                ArrayList<QFilter> ddFilters = new ArrayList<>();
                ddFilters.add(new QFilter("id", QCP.not_equals, dataEntity.getLong("id")));
                ddFilters.add(new QFilter("tpv_invalids", QCP.equals, false));
                DynamicObject[] load = BusinessDataServiceHelper.load("tpv_crm_custmain",
                        "id,tpv_cusgroup,tpv_crm_cuslimit,tpv_crm_cuslimit.tpv_custom", ddFilters.toArray(new QFilter[0]));
                Map<String,List<String>> mapSupBySupGroup = new HashMap<>();
                List<String> supGroupList = new ArrayList<>();
                if (load.length > 0) {
                    //查询历史数据
                    for (DynamicObject dynamicObject : load) {
                        String tpvSuppliergroup = dynamicObject.getString("tpv_cusgroup");
                        DynamicObjectCollection dynamicObjects = dynamicObject.getDynamicObjectCollection("tpv_crm_cuslimit");
                        if (dynamicObjects.size() > 0) {
                            for (DynamicObject object : dynamicObjects) {
                                DynamicObject tpvSuppliers = object.getDynamicObject("tpv_custom");
                                if (YEM.isNotEmpty(tpvSuppliers)) {
                                    String supId = tpvSuppliers.getString("id");
                                    if (!mapSupBySupGroup.containsKey(supId)) {
                                        supGroupList = new ArrayList<>();
                                        supGroupList.add(tpvSuppliergroup);
                                        mapSupBySupGroup.put(supId,supGroupList);
                                    } else {
                                        List<String> listSupGroup = mapSupBySupGroup.get(supId);
                                        if (!listSupGroup.contains(tpvSuppliergroup)) {
                                            listSupGroup.add(tpvSuppliergroup);
                                            mapSupBySupGroup.put(supId,listSupGroup);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    //校验本单供应商
                    DynamicObjectCollection tpvSupplierlimitSup = dataEntity.getDynamicObjectCollection("tpv_crm_cuslimit");
                    if (tpvSupplierlimitSup.size() > 0) {
                        String tpvSuppliergroup = dataEntity.getString("tpv_cusgroup");
                        Map<String,String> mapSup = new HashMap<>();
                        Map<String,String> mapSupName = new HashMap<>();
                        List<String> rows = new ArrayList<>();
                        for (int i = 0; i < tpvSupplierlimitSup.size(); i++) {
                            DynamicObject dynamicObject = tpvSupplierlimitSup.get(i);
                            DynamicObject tpvSuppliers = dynamicObject.getDynamicObject("tpv_custom");
                            if (YEM.isNotEmpty(tpvSuppliers)) {
                                String supId = tpvSuppliers.getString("id");
                                String supName = tpvSuppliers.getString("name");
                                if (!mapSup.containsKey(supId)) {
                                    mapSup.put(supId,tpvSuppliergroup);
                                    mapSupName.put(supId,supName);
                                }
                            }
                        }
                        if (mapSup.size() > 0) {
                            for (Map.Entry<String, String> supEntry : mapSup.entrySet()) {
                                if (mapSupBySupGroup.containsKey(supEntry.getKey())) {
                                    List<String> strings = mapSupBySupGroup.get(supEntry.getKey());
                                    if (strings.size() > 0) {
                                        if (strings.size() == 1) {
                                            if (!strings.contains(supEntry.getValue())) {
                                                if (mapSupName.containsKey(supEntry.getKey())) {
                                                    rows.add(mapSupName.get(supEntry.getKey()));
                                                } else {
                                                    rows.add(supEntry.getKey());
                                                }

                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if (rows.size() > 0) {
                            errorMsg = "查询所有历史数据，本单分录中: 客户 " + String.join(",", rows)
                                    + ",客户已存在请检查!\n";
                        }
                    }
                }
                return errorMsg;
            }

            /**
             * 保存是检查赊销账期和内部额外宽限期是否一致
             */
            private void onsubmitDate(ExtendedDataEntity dataEntities) {
                // 获取实体
                DynamicObject entity = dataEntities.getDataEntity();
                //获取赊销账期(天）的值
                DynamicObject org = entity.getDynamicObject("tpv_organization");//部门
                int icreditperiod = entity.getInt("tpv_icreditperiod");//赊销账期
                int intadditgraces = entity.getInt("tpv_intadditgraces");//内部额外宽限期
                DynamicObjectCollection entry = entity.getDynamicObjectCollection("tpv_crm_cuslimit");//单据体
                if (org == null) {
                    return;
                }
                if (entry.size()>0) {
                    for (DynamicObject entitys : entry) {
                        DynamicObject custom = entitys.getDynamicObject("tpv_custom");//客户
                        if (custom != null) {
                            QFilter qFilter = new QFilter("tpv_crm_cuslimit.tpv_custom", QCP.equals, custom.getLong("id"));//查询相同的
                            qFilter.and(new QFilter("tpv_organization.id", QCP.equals, org.getLong("id")));
                            qFilter.and(new QFilter("id", QCP.not_equals, entity.getLong("id")));
                            DynamicObject[] vatinvoice = BusinessDataServiceHelper.load("tpv_crm_custmain", "id,billno,tpv_icreditperiod,tpv_intadditgraces"
                                    , new QFilter[]{qFilter}, null);
                            if (vatinvoice.length > 0) {
                                for (int i = 0; i < vatinvoice.length; i++) {
                                    DynamicObject custmain = vatinvoice[i];
                                    int tpvIcreditperiod = custmain.getInt("tpv_icreditperiod");//赊销账期
                                    int tpvIntadditgraces = custmain.getInt("tpv_intadditgraces");//内部额外宽限期
                                    if (icreditperiod != tpvIcreditperiod) {//赊销账期
                                        this.addMessage(dataEntities, "同一部门下同一客户的【赊销账期】必须一致!");
                                        return;
                                    }
                                    if (intadditgraces != tpvIntadditgraces) {
                                        this.addMessage(dataEntities, "同一部门下同一客户的【内部额外宽限期】必须一致!");
                                        return;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        });
    }
}
