package tpv.tpv_wm.tpv_crm.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.form.CloseCallBack;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.ShowType;
import kd.bos.form.StyleCss;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.report.ReportList;
import kd.bos.report.ReportShowParameter;
import kd.bos.report.plugin.AbstractReportFormPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;

/**
 * 可放货余额表 表单插件
 */
public class CusCreditBalanceConRptFormPlugin extends AbstractReportFormPlugin implements Plugin, HyperLinkClickListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"tpv_salecontract_filter"});
        //报表列表超链接点击事件
        ReportList reportList = this.getControl("reportlistap");
        reportList.addHyperClickListener(this::hyperLinkClick);
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control c = (Control) evt.getSource();
        String key = c.getKey().toLowerCase();
        switch (key) {
            case "tpv_salecontract_filter":
                ListShowParameter parameter = ShowFormHelper.createShowListForm("tpv_dt_salescontract", false);
                parameter.getListFilterParameter().getQFilters().add(new QFilter("billstatus", QCP.equals, "C"));
                parameter.setCloseCallBack(new CloseCallBack(this, "tpv_salecontract_filter"));
                this.getView().showForm(parameter);
                break;
            default:
                break;
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);
        String key = e.getActionId();
        IDataModel model = this.getModel();
        Object returnData = e.getReturnData();
        if (null != returnData) {
            ListSelectedRow row = ((ListSelectedRowCollection) returnData).get(0);
            if (null != row) {
                Long primaryKeyValue = (Long) row.getPrimaryKeyValue();
                if (null != primaryKeyValue) {
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(primaryKeyValue, "tpv_dt_salescontract");
                    String tpv_contractnos = dynamicObject.getString("tpv_contractnos");
                    model.setValue("tpv_salecontract_filter", tpv_contractnos);
                }
            }
        }
    }

    @Override
    public void hyperLinkClick(HyperLinkClickEvent evt) {
        if ("tpv_creditlimit".equals(evt.getFieldName())) {
            //获取客户
            String tpv_customer = evt.getRowData().getString("tpv_customername");
            Long tpvCustomerId = evt.getRowData().getLong("tpv_customerid");
            //获取部门
            String tpv_dep = evt.getRowData().getString("tpv_deptname");
            long tpvDepartmentId = evt.getRowData().getLong("tpv_departmentid");
            QFilter qFilter = new QFilter("enable", QCP.equals, "1");
            if (tpvDepartmentId > 0l) {
                qFilter.and(new QFilter("id",QCP.equals,tpvDepartmentId));
            }
            DynamicObject bosAdminorgs = BusinessDataServiceHelper.loadSingle("bos_adminorg", qFilter.toArray());
            if (YEM.isNotEmpty(bosAdminorgs)) {
                DynamicObject orgpattern = bosAdminorgs.getDynamicObject("orgpattern");
                if (YEM.isNotEmpty(orgpattern)) {
                    String number = orgpattern.getString("number");
                    if ("OF-01".equals(number)) {
                        DynamicObjectCollection dynamicObjects = bosAdminorgs.getDynamicObjectCollection("structure");
                        if (dynamicObjects.size() > 0) {
                            for (DynamicObject dynamicObject : dynamicObjects) {
                                DynamicObject viewparent = dynamicObject.getDynamicObject("viewparent");
                                if (YEM.isNotEmpty(viewparent)) {
                                    tpvDepartmentId = viewparent.getLong("id");
                                }
                                break;
                            }
                        }
                    }
                }
            }
            String tpv_amt19 = evt.getRowData().getString("tpv_creditlimit"); //赊销额度 A：有、B：无
            if ("A".equals(tpv_amt19)) {
                //打开报表页面
                ReportShowParameter reportShowParameter = new ReportShowParameter();
                reportShowParameter.getOpenStyle().setShowType(ShowType.Modal);
                reportShowParameter.setFormId("tpv_cuscredituserpt");
                StyleCss styleCss = new StyleCss();
                styleCss.setHeight("800");
                styleCss.setWidth("1200");
                //设置弹出表单的样式，宽，高等
                reportShowParameter.getOpenStyle().setInlineStyleCss(styleCss);
                // 设置报表过滤条件
                ReportQueryParam reportQueryParam = new ReportQueryParam();
                FilterInfo filterInfo = new FilterInfo();
                filterInfo.addFilterItem("tpv_customer_filter", tpvCustomerId);
                filterInfo.addFilterItem("tpv_dep_filter", tpvDepartmentId);
                reportQueryParam.setFilter(filterInfo);
                reportShowParameter.setQueryParam(reportQueryParam);
                getView().showForm(reportShowParameter);
            }
        }
    }
}