package tpv.tpv_wm.tpv_crm.java.report;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.CloseCallBack;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.report.plugin.AbstractReportFormPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;

/**
 * 可放货余额表 表单插件
 */
public class CusCreditBalanceKJRptFormPlugin extends AbstractReportFormPlugin implements Plugin {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"tpv_project_filter"});
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control c = (Control) evt.getSource();
        String key = c.getKey().toLowerCase();
        switch (key) {
            case "tpv_project_filter":
                ListShowParameter parameter = ShowFormHelper.createShowListForm("tpv_pw_filing", false);
                QFilter qFilter = new QFilter("billstatus", QCP.equals, "C");
                qFilter.and(new QFilter("tpv_frameworkname", QCP.not_equals, "").or("tpv_framename", QCP.not_equals, ""));
                parameter.getListFilterParameter().getQFilters().add(qFilter);
                parameter.setCloseCallBack(new CloseCallBack(this, "tpv_project_filter"));
                this.getView().showForm(parameter);
                break;
            default:
                break;
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);
        String key = e.getActionId();
        IDataModel model = this.getModel();
        Object returnData = e.getReturnData();
        if (null != returnData) {
            ListSelectedRow row = ((ListSelectedRowCollection) returnData).get(0);
            if (null != row) {
                Long primaryKeyValue = (Long) row.getPrimaryKeyValue();
                if (null != primaryKeyValue) {
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(primaryKeyValue, "tpv_pw_filing");
                    String tpv_frameworkname = dynamicObject.getString("tpv_frameworkname");
                    String tpv_framename = dynamicObject.getString("tpv_framename");
                    DynamicObject tpvCustom = dynamicObject.getDynamicObject("tpv_custom");
                    if (StringUtils.isNotEmpty(tpv_frameworkname)) {
                        model.setValue("tpv_project_filter", tpv_frameworkname);
                    } else if (StringUtils.isNotEmpty(tpv_framename)) {
                        model.setValue("tpv_project_filter", tpv_framename);
                    }
                    model.setValue("tpv_customer_filter", tpvCustom);
                }
            }
        }
    }
}