package tpv.tpv_wm.tpv_crm.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.*;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;
import tpv.tpv_wm.tpv_crm.java.utils.CusCreditLimitUtils;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.util.ArrayList;
import java.util.Collection;

/**
 * @Description: 配供可放余额表-项目  -报表查询
 * @Author LinRui
 * @Date 2023/10/28 14:50
 */
public class CusCreditBalanceXMRptQuery extends AbstractReportListDataPlugin implements Plugin {

    private String algoKey = getClass().getName();

    public static final String[] FIELDS = {
            "tpv_orgname", "tpv_deptname", "tpv_customername", "tpv_projectabb", "tpv_contractno",
            "tpv_shippinginitamt", "tpv_shippingamt", "tpv_salesreturnamt", "tpv_invoicehightlow", "tpv_totalshipmentsamt",
            "tpv_amt6", "tpv_amt7", "tpv_collectinitamt", "tpv_collectcash", "tpv_collectnote",
            "tpv_collecthightlow", "tpv_collectpledgedamt", "tpv_collectrefundamt", "tpv_totalcollectamt", "tpv_paymentbalance",
            "tpv_unbanksinvoice", "tpv_banksinvoice", "tpv_financepayment", "tpv_creditlimit", "tpv_rcvdepositcash", "tpv_rcvdepositnote",
            "tpv_rcvdeposithightlow", "tpv_rcvdepositpledged", "tpv_rcvdepositrefundamt", "tpv_totalrcvdeposit",
            "tpv_finacebondsamt", "tpv_totalbalance", "tpv_customerid", "tpv_departmentid", "tpv_orgid", "tpv_cuscreditlimit"
    };
    private static final DataType[] DATATYPES = {
            DataType.StringType, DataType.StringType, DataType.StringType, DataType.StringType, DataType.StringType,
            DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType,
            DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType,
            DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType,
            DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType,
            DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType,
            DataType.BigDecimalType, DataType.BigDecimalType, DataType.LongType, DataType.LongType, DataType.LongType,DataType.BigDecimalType
    };

    @Override
    public DataSet query(ReportQueryParam reportQueryParam, Object o) throws Throwable {
        FilterInfo filter = reportQueryParam.getFilter();
        //项目
        String tpv_project_filter = null;
        if (null != filter.getFilterItem("tpv_project_filter").getValue()
                && !"".equals(filter.getFilterItem("tpv_project_filter").getValue().toString())) {
            tpv_project_filter = (String) filter.getFilterItem("tpv_project_filter").getValue();
        }
        //部门
        DynamicObject tpv_dep_filter = null;
        long depId = 0L;
        if (null != filter.getFilterItem("tpv_dep_filter").getValue()) {
            tpv_dep_filter = (DynamicObject) filter.getFilterItem("tpv_dep_filter").getValue();
            depId = tpv_dep_filter.getLong("id");
        }
        //客户
        DynamicObject tpv_customer_filter = null;
        long customerId = 0L;
        if (null != filter.getFilterItem("tpv_customer_filter").getValue()) {///
            tpv_customer_filter = (DynamicObject) filter.getFilterItem("tpv_customer_filter").getValue();
            customerId = tpv_customer_filter.getLong("id");
        }
        //项目
        DynamicObject tpv_project_f = null;
        Long projectId = 0L;
        if (null != filter.getFilterItem("tpv_project_f").getValue()) {///
            tpv_project_f = (DynamicObject) filter.getFilterItem("tpv_project_f").getValue();
            String projectName = tpv_project_f.getString("tpv_name");
            DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("tpv_pw_filing",
                    new QFilter[]{new QFilter("tpv_project", QCP.equals, projectName)});
            if (YEM.isNotEmpty(dynamicObject)) {
                projectId = dynamicObject.getLong("id");
            }
        }
        Collection<Object[]> coll = new ArrayList<>();
        RowMeta createRowMeta = RowMetaFactory.createRowMeta(FIELDS, DATATYPES);
        CollectionInput collectionInput = new CollectionInput(createRowMeta, coll);
        DataSet createDataSet = Algo.create(this.getClass().getName()).createDataSet(collectionInput);

        DynamicObjectCollection col_s = CusCreditLimitUtils.getDeliverableBalanceXM(depId, customerId, projectId);
        DynamicObjectType dynamicObjectType = col_s.getDynamicObjectType();
        DataEntityPropertyCollection properties = dynamicObjectType.getProperties();
        for (DynamicObject col : col_s) {
            Object[] tempData = new Object[FIELDS.length];
            tempData[0] = col.getString("orgName");//公司
            tempData[1] = col.getString("departmentName");//部门
            tempData[2] = col.getString("customerName");//销售客户
            tempData[3] = col.getString("tpv_projectabb");//项目号
//            tempData[4] = col.getString("contractNo");//销售合同号
//            tempData[5] = BigDecimal.ZERO;//发货总金额-初始化
            tempData[6] = col.getBigDecimal("shippingAmt");//发货总金额-发货总金额
//            tempData[7] = BigDecimal.ZERO;//发货总金额-销售退货总金额
            tempData[8] = col.getBigDecimal("invoicehightlow");//发货总金额-开票核销高低计单
            tempData[9] = col.getBigDecimal("totalshipmentsAmt");//发货总金额-总计金额
//            tempData[10] = BigDecimal.ZERO;//供应链金融-已融资
//            tempData[11] = BigDecimal.ZERO;//供应链金融-已还款
//            tempData[12] = BigDecimal.ZERO;//已收货款-初始化
            tempData[13] = col.getBigDecimal("collectcash");//已收货款-现款总金额
            tempData[14] = col.getBigDecimal("collectnote");//已收货款-票据总金额
            tempData[15] = col.getBigDecimal("collecthightlow");//已收货款-未核销高低计单 不含规划至保证金
            tempData[16] = col.getBigDecimal("collectpledgedAmt");//已收货款-质押货物金额
            tempData[17] = col.getBigDecimal("collectrefundamt");//已收货款-退款总金额
            tempData[18] = col.getBigDecimal("totalcollectAmt");//已收货款-总计金额
            tempData[19] = col.getBigDecimal("paymentbalance");//货款余额
            tempData[20] = col.getBigDecimal("unbanksinvoice");//未到期商业承兑汇票
            tempData[21] = col.getBigDecimal("banksinvoice");//含商业承兑汇票货款余额
            tempData[22] = col.getBigDecimal("financepayment");//财务货款余额
            tempData[23] = col.getString("creditlimit");//项目额度
            tempData[24] = col.getBigDecimal("rcvdepositcash");//已收保证金-现款总金额
            tempData[25] = col.getBigDecimal("rcvdepositnote");//已收保证金-票据总金额
            tempData[26] = col.getBigDecimal("rcvdeposithightlow");//已收保证金-未核销高低计单 规划至保证金
            tempData[27] = col.getBigDecimal("rcvdepositpledged");//已收保证金-质押货物金额
            tempData[28] = col.getBigDecimal("rcvdepositrefundamt");//已收保证金-退款总金额
            tempData[29] = col.getBigDecimal("totalrcvdeposit");//已收保证金-总计金额
            tempData[30] = col.getBigDecimal("finacebondsamt");//财务保证金余额
            tempData[31] = col.getBigDecimal("totalbalance");//总计余额
            tempData[32] = col.getLong("customerId");//客户id
            tempData[33] = col.getLong("departmentId");//部门id
            tempData[34] = col.getLong("orgId");//公司id
            tempData[35] = col.getString("cuscreditlimit");//额度余额
            coll.add(tempData);
        }
        String whereFilter="2=2";
        String whereStr = PersonnelDepUtils.createWhereStr(filter, "tpv_departmentid", "tpv_muldepartment");
        if (!"".equals(whereStr)){
            whereFilter=String.format("%s%s", whereFilter, whereStr);
        }
        return createDataSet.where(whereFilter);
    }
}