package tpv.tpv_wm.tpv_crm.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;
import tpv.tpv_wm.tpv_crm.java.utils.CusCreditLimitUtils;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

/**
 * @Description: 配供可放余额表-项目  -报表查询
 * @Author LinRui
 * @Date 2023/10/28 14:50
 */
public class CusCreditBalanceXMRptQuerys extends AbstractReportListDataPlugin implements Plugin {

    @Override
    public DataSet query(ReportQueryParam reportQueryParam, Object o) throws Throwable {
        FilterInfo filter = reportQueryParam.getFilter();
        //项目
        String tpv_project_filter = null;
        if (null != filter.getFilterItem("tpv_project_filter").getValue()
                && !"".equals(filter.getFilterItem("tpv_project_filter").getValue().toString())) {
            tpv_project_filter = (String) filter.getFilterItem("tpv_project_filter").getValue();
        }
        //部门
        DynamicObject tpv_dep_filter = null;
        long depId = 0L;
        if (null != filter.getFilterItem("tpv_dep_filter").getValue()) {
            tpv_dep_filter = (DynamicObject) filter.getFilterItem("tpv_dep_filter").getValue();
            depId = tpv_dep_filter.getLong("id");
        }
        //客户
        DynamicObject tpv_customer_filter = null;
        long customerId = 0L;
        if (null != filter.getFilterItem("tpv_customer_filter").getValue()) {///
            tpv_customer_filter = (DynamicObject) filter.getFilterItem("tpv_customer_filter").getValue();
            customerId = tpv_customer_filter.getLong("id");
        }
        //项目
        DynamicObject tpv_project_f = null;
        Long projectId = 0L;
        if (null != filter.getFilterItem("tpv_project_f").getValue()) {///
            tpv_project_f = (DynamicObject) filter.getFilterItem("tpv_project_f").getValue();
            String projectName = tpv_project_f.getString("tpv_name");
            DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("tpv_pw_filing",
                    new QFilter[]{new QFilter("tpv_project", QCP.equals, projectName)});
            if (YEM.isNotEmpty(dynamicObject)) {
                projectId = dynamicObject.getLong("id");
            }
        }
        String whereFilter="2=2";
        String whereStr = PersonnelDepUtils.createWhereStr(filter, "tpv_departmentid", "tpv_muldepartment");
        if (!"".equals(whereStr)){
            whereFilter=String.format("%s%s", whereFilter, whereStr);
        }
        DataSet balanceXMs = CusCreditLimitUtils.getDeliverableBalanceXMs(depId, customerId, projectId).where(whereFilter);
        return balanceXMs;
    }
}