package tpv.tpv_wm.tpv_crm.java.report;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.CloseCallBack;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.report.plugin.AbstractReportFormPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;

/**
 * 客户赊销额度-合同明细 表单插件
 */
public class CusCreditConRptFormPlugin extends AbstractReportFormPlugin implements Plugin {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"tpv_salecontract_filter"});
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control c = (Control) evt.getSource();
        String key = c.getKey().toLowerCase();
        switch (key) {
            case "tpv_salecontract_filter":
                ListShowParameter parameter = ShowFormHelper.createShowListForm("tpv_dt_salescontract", false);
                parameter.getListFilterParameter().getQFilters().add(new QFilter("billstatus", QCP.equals, "C"));
                parameter.setCloseCallBack(new CloseCallBack(this, "tpv_salecontract_filter"));
                this.getView().showForm(parameter);
                break;
            default:
                break;
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);
        String key = e.getActionId();
        IDataModel model = this.getModel();
        Object returnData = e.getReturnData();
        if (null != returnData) {
            ListSelectedRow row = ((ListSelectedRowCollection) returnData).get(0);
            if (null != row) {
                Long primaryKeyValue = (Long) row.getPrimaryKeyValue();
                if (null != primaryKeyValue) {
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(primaryKeyValue, "tpv_dt_salescontract");
                    String tpv_contractnos = dynamicObject.getString("tpv_contractnos");
                    model.setValue("tpv_salecontract_filter", tpv_contractnos);
                }
            }
        }
    }
}