package tpv.tpv_wm.tpv_crm.java.report;

import kd.bos.algo.*;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.sdk.plugin.Plugin;
import tpv.tpv_wm.tpv_crm.java.utils.CusCreditLimitUtils;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.util.ArrayList;
import java.util.Collection;

/**
 * 客户赊销额度-合同明细 取数插件
 */
public class CusCreditConRptQuery extends AbstractReportListDataPlugin implements Plugin {

    private String algoKey = getClass().getName();

    public static final String[] FIELDS = {"tpv_deptname", "tpv_customername", "tpv_contractno", "tpv_bizdate", "tpv_contractamt",
            "tpv_shippingamt", "tpv_e_actamt", "tpv_uncontractamt", "tpv_unshippingamt","tpv_departmentid","tpv_customerid"};
    private static final DataType[] DATATYPES = {DataType.StringType, DataType.StringType, DataType.StringType, DataType.DateType, DataType.BigDecimalType,
            DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType, DataType.BigDecimalType,DataType.LongType,DataType.LongType};

    @Override
    public DataSet query(ReportQueryParam reportQueryParam, Object o) throws Throwable {
        FilterInfo filter = reportQueryParam.getFilter();
        //部门
        DynamicObject tpv_dep_filter = null;
        long depId = 0L;
        if (null != filter.getFilterItem("tpv_dep_filter").getValue()) {
            tpv_dep_filter = (DynamicObject) filter.getFilterItem("tpv_dep_filter").getValue();
            depId = tpv_dep_filter.getLong("id");
        }
        //客户
        DynamicObject tpv_customer_filter = null;
        long customerId = 0L;
        if (null != filter.getFilterItem("tpv_customer_filter").getValue()) {
            tpv_customer_filter = (DynamicObject) filter.getFilterItem("tpv_customer_filter").getValue();
            customerId = tpv_customer_filter.getLong("id");
        }
//        //销售合同号
//        String tpv_salecontract_filter = null;
//        long contractId = 0L;
//        if (null != filter.getFilterItem("tpv_salecontract_filter").getValue()
//                && !"".equals(filter.getFilterItem("tpv_salecontract_filter").getValue().toString())) {
//            tpv_salecontract_filter = (String) filter.getFilterItem("tpv_salecontract_filter").getValue();
//            QFilter qFilter = new QFilter("tpv_contractnos", QCP.equals, tpv_salecontract_filter);
//            DynamicObject[] tpv_dt_salescontract_s = BusinessDataServiceHelper.load("tpv_dt_salescontract",
//                    "id,billno,tpv_contractnos,billstatus", new QFilter[]{qFilter});
//            if (null != tpv_dt_salescontract_s && tpv_dt_salescontract_s.length > 0) {
//                contractId = tpv_dt_salescontract_s[0].getLong("id");
//            }
//        }
        //销售合同号
        //String tpv_salecontract_filter = null;
        String contractNo = "";
        if (null != filter.getFilterItem("tpv_salecontract_filter").getValue()
                && !"".equals(filter.getFilterItem("tpv_salecontract_filter").getValue().toString())) {
            contractNo = (String) filter.getFilterItem("tpv_salecontract_filter").getValue();
        }
        //占用余额全部为0不显示
        boolean tpv_zero_filter = true;
        if (null != filter.getFilterItem("tpv_zero_filter").getValue()) {
            tpv_zero_filter = (boolean) filter.getFilterItem("tpv_zero_filter").getValue();
        }
        Collection<Object[]> coll = new ArrayList<>();
        RowMeta createRowMeta = RowMetaFactory.createRowMeta(FIELDS, DATATYPES);
        CollectionInput collectionInput = new CollectionInput(createRowMeta, coll);
        DataSet createDataSet = Algo.create(this.getClass().getName()).createDataSet(collectionInput);

        DynamicObjectCollection col_s = CusCreditLimitUtils.getCusCreditLimit(depId, customerId, contractNo, tpv_zero_filter);
        for (DynamicObject col : col_s) {
            Object[] tempData = new Object[FIELDS.length];
            tempData[0] = col.getString("departmentName");
            tempData[1] = col.getString("customerName");
            tempData[2] = col.getString("contractNo");
            tempData[3] = col.getDate("tpv_bizdate");
            tempData[4] = col.getBigDecimal("contractAmt");
            tempData[5] = col.getBigDecimal("shippingAmt");
            tempData[6] = col.getBigDecimal("e_actamt");
            tempData[7] = col.getBigDecimal("uncontractAmt");
            tempData[8] = col.getBigDecimal("unshippingAmt");
            tempData[9] = col.getLong("departmentId");
            tempData[10] = col.getLong("customerId");
            coll.add(tempData);
        }
        String whereFilter="2=2";
        String whereStr = PersonnelDepUtils.createWhereStr(filter, "tpv_departmentid", "tpv_muldepartment");
        if (!"".equals(whereStr)){
            whereFilter=String.format("%s%s", whereFilter, whereStr);
        }
        return createDataSet.where(whereFilter);
    }
}