package tpv.tpv_wm.tpv_crm.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.form.CloseCallBack;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.ShowType;
import kd.bos.form.StyleCss;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.report.ReportList;
import kd.bos.report.ReportShowParameter;
import kd.bos.report.plugin.AbstractReportFormPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;

/**
 * @Description: 供应商预付款单票占用-合同明细 -表单插件
 * @Author LinRui
 * @Date 2024/4/15 14:54
 */
public class SupCreditOneConRptFormPlugin extends AbstractReportFormPlugin implements Plugin, HyperLinkClickListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        //报表列表超链接点击事件
        ReportList reportList = this.getControl("reportlistap");
        reportList.addHyperClickListener(this::hyperLinkClick);
    }

    @Override
    public void hyperLinkClick(HyperLinkClickEvent evt) {
        if ("tpv_purno".equals(evt.getFieldName())) {
            String tpv_purno = evt.getRowData().getString("tpv_purno");
            if (YEM.isNotEmpty(tpv_purno)) {
                QFilter qFilter = new QFilter("tpv_contractnumber", QCP.equals, tpv_purno);
                DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", "id", qFilter.toArray());
                //跳转到指定单
                if(loadSingle!=null){
                    BillShowParameter showParameter = new BillShowParameter();
                    showParameter.setFormId("tpv_dt_purchase");
                    showParameter.setPkId(loadSingle.getPkValue());
                    showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
                    showParameter.setStatus(OperationStatus.VIEW);
                    this.getView().showForm(showParameter);
                }
            }
        }
    }
}
