package tpv.tpv_wm.tpv_crm.java.utils;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.*;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.util.StringUtils;
import tpv.tpv_wm.tpv_crm.java.report.SupCreditConRptQuery;

import java.math.BigDecimal;
import java.util.*;

public class CusCreditLimitUtils {

    private static final String algoKey = CusCreditLimitUtils.class.getName();

    /**
     * 客户赊销额度使用情况表
     *
     * @param tpv_cusgroup_f 客户集团
     * @param tpv_custom_f   客户ID
     * @param orgId_f        部门ID
     * @return
     */
    public static DataSet getCusCreditLimitUses(String tpv_orgcredit_filter, String tpv_credittype_filter, String tpv_cusgroup_f, long tpv_custom_f, long orgId_f) {
        //客户额度维护
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        qFilter1.and(new QFilter("tpv_crm_cuslimit.tpv_custom", QCP.is_notnull, ""));
        if (StringUtils.isNotEmpty(tpv_cusgroup_f)) {
            qFilter1.and(new QFilter("tpv_cusgroup", QCP.like, "%" +tpv_cusgroup_f + "%"));
        }
//        if (0L != orgId_f & YEM.isNotEmpty(tpv_orgcredit_filter)) {
//            qFilter1.and(new QFilter("tpv_organization", QCP.equals, orgId_f));
//        }
//        if (tpv_custom_f > 0l) {
//            qFilter1.and(new QFilter("tpv_crm_cuslimit.tpv_custom", QCP.equals, tpv_custom_f));
//        }

        // 单独授信
        DataSet queryNoTotal;
        if ("A".equals(tpv_orgcredit_filter)) {// 全司
            queryNoTotal = selectcustomerlimitsEntry(qFilter1.toArray(), new String[]{"tpv_customerid"});
        } else if ("B".equals(tpv_orgcredit_filter)) {// 部门
            queryNoTotal = selectcustomerlimitsEntry(qFilter1.toArray(), new String[]{"tpv_customerid", "tpv_departmentid"});
        } else if ((orgId_f > 0l & YEM.isNotEmpty(tpv_orgcredit_filter) & "B".equals(tpv_orgcredit_filter))
                | (orgId_f > 0l & YEM.isEmpty(tpv_orgcredit_filter))) {// 全司+部门
            queryNoTotal = selectcustomerlimitsEntry(new QFilter("tpv_orgcredit", QCP.equals, "A").and(qFilter1).toArray(),
                    new String[]{"tpv_customerid"}).union(
                    selectcustomerlimitsEntry(new QFilter("tpv_orgcredit", QCP.equals, "B").and(qFilter1)
                                    .and(new QFilter("tpv_organization", QCP.equals, orgId_f)).toArray(),
                            new String[]{"tpv_customerid", "tpv_departmentid"}));
        } else {// 全司+部门
            queryNoTotal = selectcustomerlimitsEntry(new QFilter("tpv_orgcredit", QCP.equals, "A").and(qFilter1).toArray(),
                    new String[]{"tpv_customerid"}).union(
                    selectcustomerlimitsEntry(new QFilter("tpv_orgcredit", QCP.equals, "B").and(qFilter1).toArray(),
                            new String[]{"tpv_customerid", "tpv_departmentid"}));
        }


        DataSet copy = queryNoTotal.copy();
        List<String> cusGroup = new ArrayList<>(); //过滤集团
        Boolean flagDep = true;
        Boolean flagCus = true;
        if (null != copy) {
            for (Row row : copy) {
                if (tpv_custom_f > 0l) {
                    if (YEM.isNotEmpty(row.getLong("tpv_departmentid")) & "B".equals(row.getString("tpv_orgcredit")) &
                            tpv_custom_f == row.getLong("tpv_customerid")) {
                        if (!cusGroup.contains(row.getString("tpv_cusgroup"))) {
                            cusGroup.add(row.getString("tpv_cusgroup"));
                        }
                    }
                    if (YEM.isEmpty(row.getLong("tpv_departmentid")) & "A".equals(row.getString("tpv_orgcredit")) &
                            tpv_custom_f == row.getLong("tpv_customerid")) {
                        if (!cusGroup.contains(row.getString("tpv_cusgroup"))) {
                            cusGroup.add(row.getString("tpv_cusgroup"));
                        }
                    }
                } else {
                    if (YEM.isNotEmpty(row.getLong("tpv_departmentid")) & "B".equals(row.getString("tpv_orgcredit")) & YEM.isNotEmpty(row.getLong("tpv_customerid"))) {
                        if (!cusGroup.contains(row.getString("tpv_cusgroup"))) {
                            cusGroup.add(row.getString("tpv_cusgroup"));
                        }
                    }
                }

                if (YEM.isNotEmpty(row.getLong("tpv_departmentid")) & orgId_f > 0) {
                    if (orgId_f == row.getLong("tpv_departmentid")) {
                        flagDep = false;
                    }
                }
                if (YEM.isNotEmpty(row.getLong("tpv_customerid")) & tpv_custom_f > 0l) {
                    if (tpv_custom_f == row.getLong("tpv_customerid")) {
                        flagCus = false;
                    }
                }
            }
        }
        if ((cusGroup.size() > 0 & orgId_f > 0) | (cusGroup.size() > 0 & tpv_custom_f > 0l)) {
            List<String> strings = new ArrayList<>();
            Arrays.stream(cusGroup.toArray()).forEach(x -> {
                String s = "'" + x + "'";
                strings.add("" + s + "");
            });
            String whereFilter = "1=1";
            whereFilter = String.format("%s and tpv_cusgroup in(%s)", whereFilter, String.join(",", strings));
            queryNoTotal = queryNoTotal.where(whereFilter);
        }
        if (flagDep & YEM.isEmpty(tpv_orgcredit_filter) & YEM.isEmpty(tpv_cusgroup_f) & YEM.isEmpty(tpv_credittype_filter) & cusGroup.size() == 0 & tpv_custom_f <= 0l
                & orgId_f > 0l) {
            queryNoTotal = selectcustomerlimitsEntry(new QFilter("tpv_orgcredit", QCP.equals, "A").and(qFilter1)
                            .and(new QFilter("tpv_organization", QCP.equals, orgId_f)).toArray(),
                    new String[]{"tpv_customerid"}).union(
                    selectcustomerlimitsEntry(new QFilter("tpv_orgcredit", QCP.equals, "B").and(qFilter1)
                                    .and(new QFilter("tpv_organization", QCP.equals, orgId_f)).toArray(),
                            new String[]{"tpv_customerid", "tpv_departmentid"}));
        }
        if (flagCus & YEM.isEmpty(tpv_orgcredit_filter) & YEM.isEmpty(tpv_cusgroup_f) & YEM.isEmpty(tpv_credittype_filter) & cusGroup.size() == 0 & tpv_custom_f > 0l) {
            queryNoTotal = selectcustomerlimitsEntry(new QFilter("tpv_orgcredit", QCP.equals, "A").and(qFilter1)
                            .and(new QFilter("tpv_crm_cuslimit.tpv_custom", QCP.equals, tpv_custom_f)).toArray(),
                    new String[]{"tpv_customerid"}).union(
                    selectcustomerlimitsEntry(new QFilter("tpv_orgcredit", QCP.equals, "B").and(qFilter1)
                                    .and(new QFilter("tpv_crm_cuslimit.tpv_custom", QCP.equals, tpv_custom_f)).toArray(),
                            new String[]{"tpv_customerid", "tpv_departmentid"}));
        }
        //总额度
        DataSet queryIsTotal = selectCustomerlimits(queryNoTotal);
        if (tpv_custom_f > 0l) {
            String whereFilter = "1=1";
            whereFilter = String.format("%s and tpv_customerid = %s", whereFilter, tpv_custom_f);
            queryNoTotal = queryNoTotal.where(whereFilter);
        }
        DataSet union = queryIsTotal.union(queryNoTotal).select(new String[]{"tpv_credittype", "tpv_orgcredit","tpv_departmentid", "tpv_dep",
                        "tpv_cusgroup", "tpv_customerid", "tpv_customer", "tpv_signingamt", "tpv_shippingamt",
                        "tpv_signinguseamt", "tpv_shippinguseamt", "tpv_signingresidueamt", "tpv_shippingresidueamt"})
                .select("tpv_credittype", "tpv_orgcredit", "tpv_departmentid", "tpv_dep", "tpv_cusgroup", "tpv_customerid", "tpv_customer",
                        "tpv_signingamt", "tpv_shippingamt", "tpv_signinguseamt", "tpv_shippinguseamt", "tpv_signingresidueamt", "tpv_shippingresidueamt",
                        "Round(tpv_signingamt,2) tpv_signingamts", "Round(tpv_shippingamt,2) tpv_shippingamts",
                        "Round(tpv_signinguseamt,2) tpv_signinguseamts", "Round(tpv_shippinguseamt,2) tpv_shippinguseamts",
                        "Round(tpv_signingresidueamt,2) tpv_signingresidueamts", "Round(tpv_shippingresidueamt,2) tpv_shippingresidueamts");
        DataSet orderBy = union.orderBy(new String[]{"tpv_cusgroup", "tpv_dep asc","tpv_customer asc"});
        if (YEM.isNotEmpty(tpv_credittype_filter)) {
            orderBy = orderBy.where(String.format("tpv_credittype = '%s'", tpv_credittype_filter));// 授信类型
        }
        return orderBy;
    }

    private static DataSet selectCustomerlimits(DataSet queryNoTotal) {
        DataSet customerlimits = ORM.create().queryDataSet(algoKey,"tpv_crm_custmain",
                        "id custmainId,tpv_documentype,tpv_orgcredit,tpv_organization.id departmentId,tpv_organization.name tpv_dep,tpv_invalids," +
                                "tpv_cusgroup,tpv_groupconamt,tpv_groupdelim", new QFilter[]{new QFilter("billstatus",QCP.equals,"C")})
                .select("tpv_documentype","tpv_orgcredit","departmentId tpv_departmentid","tpv_dep","tpv_invalids", "tpv_cusgroup",
                        "(case when tpv_invalids != true then tpv_groupconamt * 10000 else 0.0 end) tpv_groupconamt",
                        "(case when tpv_invalids != true then tpv_groupdelim * 10000 else 0.0 end) tpv_groupdelim");
        customerlimits = customerlimits.groupBy(new String[]{"tpv_orgcredit","tpv_departmentid","tpv_dep","tpv_cusgroup"})
                .sum("tpv_groupconamt").sum("tpv_groupdelim").finish();
        List<String> aliasList = RptUtil.getDataSetAliasList(queryNoTotal);
        aliasList.add("tpv_groupconamt");
        aliasList.add("tpv_groupdelim");
        DataSet dataSet = queryNoTotal.leftJoin(customerlimits).on("tpv_orgcredit","tpv_orgcredit").on("tpv_dep","tpv_dep")
                .on("tpv_departmentid","tpv_departmentid").on("tpv_cusgroup","tpv_cusgroup")
                .select(aliasList.toArray(new String[aliasList.size()])).finish();
        dataSet = RptUtil.zeroNullNums(dataSet);
        dataSet = dataSet.groupBy(new String[]{"tpv_orgcredit", "tpv_dep", "tpv_departmentid", "tpv_cusgroup", "'A' tpv_credittype",
                        "tpv_cusgroup", "tpv_groupconamt", "tpv_groupdelim"})
                .sum("tpv_signinguseamt").sum("tpv_shippinguseamt").finish();
        dataSet = dataSet.select(new String[]{"tpv_credittype", "tpv_orgcredit", "tpv_departmentid", "tpv_dep",
                "tpv_cusgroup","0l tpv_customerid", "null tpv_customer", "tpv_groupconamt tpv_signingamt", "tpv_groupdelim tpv_shippingamt",
                "tpv_signinguseamt", "tpv_shippinguseamt", "tpv_groupconamt - tpv_signinguseamt tpv_signingresidueamt",
                "tpv_groupdelim - tpv_shippinguseamt tpv_shippingresidueamt"});
        return dataSet;
    }

    private static DataSet selectcustomerlimitsEntry(QFilter[] qFilters, String[] keys) {
        DataSet customerlimitsEntry = ORM.create().queryDataSet(algoKey, "tpv_crm_custmain",
                        "id custmainId,tpv_documentype,tpv_orgcredit,tpv_organization.id departmentId,tpv_organization.name tpv_dep,tpv_invalids," +
                                "tpv_cusgroup,tpv_crm_cuslimit.tpv_custom.id customerId,tpv_crm_cuslimit.tpv_custom.name tpv_customName," +
                                "tpv_crm_cuslimit.tpv_quotatype tpv_quotatype,tpv_crm_cuslimit.tpv_limitamt tpv_limitamt,tpv_crm_cuslimit.tpv_frozenstate tpv_frozenstate",
                        qFilters)
                .select("tpv_documentype", "tpv_orgcredit", "tpv_dep", "tpv_cusgroup", "tpv_customName tpv_customer", "tpv_frozenstate", "tpv_invalids",
                        "departmentId tpv_departmentid","customerId tpv_customerid",
                        "(case when tpv_invalids != true and tpv_frozenstate in('B','') and tpv_quotatype == 'A' then tpv_limitamt * 10000 else 0.0 end) tpv_signingamt",
                        "(case when tpv_invalids != true and tpv_frozenstate in('B','') and tpv_quotatype == 'B' then tpv_limitamt * 10000 else 0.0 end) tpv_shippingamt",
                        "'B' tpv_credittype")
                .groupBy(new String[]{"tpv_orgcredit", "tpv_departmentid", "tpv_dep", "tpv_cusgroup", "tpv_customerid", "tpv_customer","tpv_credittype"})
                .sum("tpv_signingamt").sum("tpv_shippingamt").finish();

        DataSet query = queryLeftJoinUse(0L, 0L, 0L, true);
        GroupbyDataSet groupbyDataSet;
        if (keys == null) {
            groupbyDataSet = query.groupBy();
        } else {
            groupbyDataSet = query.groupBy(keys);
        }
        DataSet finish = groupbyDataSet.sum("tpv_uncontractamt").sum("tpv_unshippingamt")
                .finish(); // 查询供应商预付款占用-合同明细表
        JoinDataSet leftJoin = customerlimitsEntry.leftJoin(finish);
        for (String key : keys) {
            leftJoin.on(key, key);
        }
        DataSet select = leftJoin.select(new String[]{"tpv_credittype", "tpv_orgcredit", "tpv_departmentid", "tpv_dep",
                "tpv_cusgroup", "tpv_customerid", "tpv_customer", "tpv_signingamt", "tpv_shippingamt",
                "(case when tpv_uncontractamt != null then tpv_uncontractamt else 0.0 end) tpv_signinguseamt",
                "(case when tpv_unshippingamt != null then tpv_unshippingamt else 0.0 end) tpv_shippinguseamt"}).finish();
        select = select.select(new String[]{"tpv_credittype", "tpv_orgcredit", "tpv_departmentid", "tpv_dep",
                "tpv_cusgroup", "tpv_customerid", "tpv_customer", "tpv_signingamt", "tpv_shippingamt",
                "tpv_signinguseamt", "tpv_shippinguseamt", "tpv_signingamt - tpv_signinguseamt tpv_signingresidueamt",
                "tpv_shippingamt - tpv_shippinguseamt tpv_shippingresidueamt"});
        return select;
    }

    public static JSONObject cusadvanceupJsonObject(String tpv_orgcredit_f, String tpv_credittype_f,
                                                    String tpv_cusgroup_f, DynamicObject tpv_customer_f, DynamicObject tpv_dep_f) {
        JSONObject result = new JSONObject();
        DataSet cusCreditLimitUses = getCusCreditLimitUses(tpv_orgcredit_f, tpv_credittype_f, tpv_cusgroup_f,
                tpv_dep_f != null ? tpv_dep_f.getLong("id") : 0l, tpv_customer_f != null ? tpv_customer_f.getLong("id") : 0l);
        for (Row row : cusCreditLimitUses) {
            String tpvCredittype = row.getString("tpv_credittype"); //授信类型 【A总额度/B单独授信】
            String tpvOrgcredit = row.getString("tpv_orgcredit"); //查询维度 【A全司/B部门】
            String tpvCredittypeName = null, tpvOrgcreditName = null;
            // 授信类型tpv_credittype : 'A' 总额度 'B' 单独授信 查询维度tpv_orgcredit : 'A' 全司 'B' 部门
            boolean isTotal = "A".equals(tpvCredittype);
            if (isTotal) {
                tpvCredittypeName = "total";
            }
            if ("B".equals(tpvCredittype)) {
                tpvCredittypeName = "single";
            }
            if ("A".equals(tpvOrgcredit)) {
                tpvOrgcreditName = "_org";
            }
            if ("B".equals(tpvOrgcredit)) {
                tpvOrgcreditName = "_dept";
            }

            String concatName = tpvCredittypeName + tpvOrgcreditName; // allorg、alldept、singleorg、singledept

            JSONObject map = new JSONObject();
            BigDecimal tpvSigningamt = row.getBigDecimal("tpv_signingresidueamt");
            BigDecimal tpvAfteramt = row.getBigDecimal("tpv_shippingresidueamt");
            if (isTotal || tpvSigningamt.compareTo(BigDecimal.ZERO) > 0) {
                map.put("signingamt", tpvSigningamt); // 签约(实际剩余额度)fast_leave_signing
            }
            if (isTotal || tpvAfteramt.compareTo(BigDecimal.ZERO) > 0) {
                map.put("afteramt", tpvAfteramt); // 现货(实际剩余额度)fast_leave_after
            }
            result.put(concatName, map);
        }
        if (!result.containsKey("total_org")) {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("signingamt", BigDecimal.ZERO);
            jsonObject.put("afteramt", BigDecimal.ZERO);
            result.put("total_org", jsonObject);
        }
        if (!result.containsKey("total_dept")) {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("signingamt", BigDecimal.ZERO);
            jsonObject.put("afteramt", BigDecimal.ZERO);
            result.put("total_dept", jsonObject);
        }
        if (!result.containsKey("single_org")) {
            result.put("single_org", new JSONObject());
        }
        if (!result.containsKey("single_dept")) {
            result.put("single_dept", new JSONObject());
        }
        return result;
    }

    public static JSONArray resultData(String tpv_orgcredit_f, String tpv_credittype_f,
                                       String tpv_cusgroup_f, String tpv_dep_f, String tpv_customer_f) {
        String tpv_orgcredit_fs = "";
        String tpv_credittype_fs = "";
        if ("总额度".equals(tpv_credittype_f)) {
            tpv_credittype_fs = "A";
        } else if ("单独授信".equals(tpv_credittype_f)) {
            tpv_credittype_fs = "B";
        }
        if ("全司".equals(tpv_orgcredit_f)) {
            tpv_orgcredit_fs = "A";
        } else if ("部门".equals(tpv_orgcredit_f)) {
            tpv_orgcredit_fs = "B";
        }

        JSONArray result = new JSONArray();
        QFilter filters = new QFilter("status", QCP.equals, "C");
        filters.and("enable", QCP.equals, "1");
        DynamicObject[] bdCustomers = BusinessDataServiceHelper.load("bd_customer", "id,name,number", new QFilter[]{filters});
        Map<Long, String> cusMap = new HashMap<>();
        Map<String, Long> cusNameMap = new HashMap<>();
        Arrays.stream(bdCustomers).filter(x -> bdCustomers != null).forEach(x -> {
            Long id = x.getLong("id");
            if (!cusMap.containsKey(id)) {
                String name = x.getString("name");
                cusMap.put(id, name);
                cusNameMap.put(name, id);
            }
        });
        DynamicObject[] bosAdminorgs = BusinessDataServiceHelper.load("bos_adminorg", "id,name,number", new QFilter[]{filters});
        Map<Long, String> deptMap = new HashMap<>();
        Map<String, Long> deptNameMap = new HashMap<>();
        Arrays.stream(bosAdminorgs).filter(x -> bosAdminorgs != null).forEach(x -> {
            Long id = x.getLong("id");
            if (!deptMap.containsKey(id)) {
                String name = x.getString("name");
                deptMap.put(id, name);
                deptNameMap.put(name, id);
            }
        });
        Long tpv_dep_fs = deptNameMap.get(tpv_dep_f) != null ? deptNameMap.get(tpv_dep_f) : 0L;
        Long tpv_customer_fs = cusNameMap.get(tpv_customer_f) != null ? cusNameMap.get(tpv_customer_f) : 0L;
        if (YEM.isEmpty(tpv_customer_fs) | YEM.isEmpty(tpv_dep_fs)) {
            return result;
        }
        for (Row row : getCusCreditLimitUses(tpv_orgcredit_fs, tpv_credittype_fs, tpv_cusgroup_f, tpv_dep_fs, tpv_customer_fs)) {
            JSONObject jsonObject = new JSONObject(new LinkedHashMap<>());
            jsonObject.put("credittype", "A".equals(row.getString("tpv_credittype")) ? "总额度" : "单独授信");  //授信类型
            jsonObject.put("orgcredit", "A".equals(row.getString("tpv_orgcredit")) ? "全司" : "部门");  //查询维度
            jsonObject.put("dept", row.getString("tpv_dep"));  //部门
            jsonObject.put("deptid", row.getLong("tpv_departmentid"));  //部门id
            jsonObject.put("cusgroup", row.getString("tpv_cusgroup"));  //客户集团
            jsonObject.put("customer", row.getString("tpv_customer"));  //客户
            jsonObject.put("customerid", row.getLong("tpv_customerid"));  //客户id
            jsonObject.put("signingamt", BigDecimalUtils.ceil(row.getBigDecimal("tpv_signingamt").doubleValue(), 4));  //签约(额度)
            jsonObject.put("signingamtText", row.getString("tpv_signingamts"));  //签约(额度)
            jsonObject.put("shippingamt", BigDecimalUtils.ceil(row.getBigDecimal("tpv_shippingamt").doubleValue(), 4));  //送货(额度)
            jsonObject.put("shippingamtText", row.getString("tpv_shippingamts"));  //送货(额度)
            jsonObject.put("signinguseamt", BigDecimalUtils.ceil(row.getBigDecimal("tpv_signinguseamt").doubleValue(), 4));  //签约(理论占用)
            jsonObject.put("signinguseamtText", row.getString("tpv_signinguseamts"));  //签约(理论占用)
            jsonObject.put("shippinguseamt", BigDecimalUtils.ceil(row.getBigDecimal("tpv_shippinguseamt").doubleValue(), 4));  //送货(理论占用)
            jsonObject.put("shippinguseamtText", row.getString("tpv_shippinguseamts"));  //送货(理论占用)
            jsonObject.put("signingresidueamt", BigDecimalUtils.ceil(row.getBigDecimal("tpv_signingresidueamt").doubleValue(), 4));  //签约(理论剩余)
            jsonObject.put("signingresidueamtText", row.getString("tpv_signingresidueamts"));  //签约(额度)
            jsonObject.put("shippingresidueamt", BigDecimalUtils.ceil(row.getBigDecimal("tpv_shippingresidueamt").doubleValue(), 4));  //送货(理论剩余)
            jsonObject.put("shippingresidueamtText", row.getString("tpv_shippingresidueamts"));  //送货(额度)
            jsonObject.put("isfreezetext", row.getString("tpv_isfreezetext"));  //是否冻结或失效
            result.add(jsonObject);
        }
        return result;
    }

    /**
     * 客户赊销额度-合同明细
     *
     * @param depId      部门ID
     * @param customerId 客户ID
     * @param contractNo 合同号
     * @param isZeroHide 占用余额全部为0不显示
     * @return
     */
    public static DynamicObjectCollection getCusCreditLimit(long depId, long customerId, String contractNo, boolean isZeroHide) {
        //销售合同
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        qFilter1.and(new QFilter("tpv_isselloncredit", QCP.equals, true));  //【是否赊销】=“是”
        if (0L != depId) {
            qFilter1.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter1.and(new QFilter("tpv_customer.id", QCP.equals, customerId));
        }
        if (StringUtils.isNotEmpty(contractNo)) {
            qFilter1.and(new QFilter("tpv_contractnos", QCP.ILIKE, "%" + contractNo + "%"));
        }
        DataSet dataSet1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salescontract",
                        "id contractId,tpv_department.id departmentId,tpv_department.name departmentName," +
                                "tpv_customer.id customerId,tpv_customer.name customerName,tpv_contractnos contractNo,tpv_bizdate,tpv_paymentstatus," +
                                "tpv_materialentry.tpv_effectivequantity*tpv_materialentry.tpv_taxprice contractAmt",
                        new QFilter[]{qFilter1}, null)
                .groupBy(new String[]{"contractId", "departmentId", "departmentName", "customerId", "customerName",
                        "contractNo", "tpv_bizdate", "tpv_paymentstatus"})
                .sum("contractAmt")
                .finish();
        DataSet tpv_dt_salescontract_1 = dataSet1.copy();
        List<Long> manIds = new ArrayList<>();
        if (null != tpv_dt_salescontract_1) {
            for (Row row : tpv_dt_salescontract_1) {
                manIds.add(row.getLong("contractId"));
            }
        }
        //销售发货
        QFilter qFilter2 = new QFilter("billstatus", QCP.equals, "C");
        if (0L != depId) {
            qFilter2.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter2.and(new QFilter("tpv_customer.id", QCP.equals, customerId));
        }
        if (StringUtils.isNotEmpty(contractNo)) {
            qFilter1.and(new QFilter("tpv_contractnumber", QCP.ILIKE, "%" + contractNo + "%"));
        }
        DataSet tpv_dt_salesshipping = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salesshipping",
                "tpv_contractnumber,tpv_materialentry entryid,tpv_materialentry.tpv_cobillid tpv_cobillid," +
                        "tpv_materialentry.tpv_qty tpv_qty,tpv_materialentry.tpv_taxprice tpv_taxprice," +
                        "tpv_materialentry.tpv_cargobatchqty tpv_cargobatchqty",
                new QFilter[]{qFilter2}, null);
        DataSet copySalesshipping = tpv_dt_salesshipping.copy();
        List<Long> srcEntryid = new ArrayList<>();
        if (null != copySalesshipping) {
            for (Row row : copySalesshipping) {
                srcEntryid.add(row.getLong("entryid"));
            }
        }
        tpv_dt_salesshipping = RptUtil.zeroNullNums(tpv_dt_salesshipping);
        if (srcEntryid.size() > 0) {
            QFilter qFilterConvet = new QFilter("billstatus", QCP.equals, "C");
            qFilterConvet.and(new QFilter("tpv_materialentry.tpv_srcentryid",QCP.in,srcEntryid));
            DataSet salepricebill = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salepricebill",
                    "tpv_materialentry,tpv_materialentry.tpv_cobillid tpv_cobillid,tpv_materialentry.tpv_srcentryid tpv_srcentryid," +
                            "tpv_materialentry.tpv_qty_final tpv_qty_final",
                    new QFilter[]{qFilterConvet}, null);
            salepricebill = salepricebill.groupBy(new String[]{"tpv_srcentryid"}).sum("tpv_qty_final").finish();
            tpv_dt_salesshipping = tpv_dt_salesshipping.leftJoin(salepricebill).on("entryid","tpv_srcentryid")
                    .select("tpv_cobillid", "tpv_qty","tpv_qty_final","tpv_cargobatchqty","tpv_taxprice").finish();
            DataSet copy = tpv_dt_salesshipping.copy();
            DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(copy);
            for (DynamicObject dynamicObject : dynamicObjects) {
                System.out.println();
            }
            tpv_dt_salesshipping = RptUtil.zeroNullNums(tpv_dt_salesshipping);
            tpv_dt_salesshipping = tpv_dt_salesshipping.select("tpv_cobillid", "(tpv_qty - tpv_qty_final - tpv_cargobatchqty) * tpv_taxprice shippingAmt")
                    .groupBy(new String[]{"tpv_cobillid"})
                    .sum("shippingAmt")
                    .finish();
        } else {
            tpv_dt_salesshipping = tpv_dt_salesshipping.select("tpv_cobillid",
                            "(tpv_qty - tpv_cargobatchqty) * tpv_taxprice shippingAmt")
                    .groupBy(new String[]{"tpv_cobillid"})
                    .sum("shippingAmt")
                    .finish();
        }
        DataSet tpv_dt_salepricebill = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salepricebill",
                "tpv_materialentry,tpv_materialentry.tpv_cobillid tpv_cobillid,tpv_materialentry.tpv_srcentryid tpv_srcentryid," +
                        "tpv_materialentry.tpv_qty_final * tpv_materialentry.tpv_taxprice_final shippingAmt",
                new QFilter[]{qFilter2}, null);
        tpv_dt_salepricebill = tpv_dt_salepricebill.groupBy(new String[]{"tpv_cobillid"})
                .sum("shippingAmt")
                .finish();
        DataSet dataSet2 = tpv_dt_salesshipping.union(tpv_dt_salepricebill)
                .groupBy(new String[]{"tpv_cobillid"})
                .sum("shippingAmt")
                .finish();
        DataSet dataSet3 = dataSet1.leftJoin(dataSet2).on("contractId", "tpv_cobillid")
                .select("contractId", "departmentId", "departmentName", "customerId", "customerName",
                        "contractNo", "tpv_bizdate", "tpv_paymentstatus", "contractAmt", "shippingAmt")
                .finish();

        //占用减项  暂时为0，待可放余额表完成后，联查取值
        DataSet cuscreditBalance = getDeliverableBalanceConData(0L, 0L, manIds, false)
                .groupBy(new String[]{"contractId"}).sum("tpv_totalcollectamt").finish().select("contractId contractNo", "tpv_totalcollectamt e_actamt");

        DataSet dataSet4 = dataSet3.leftJoin(cuscreditBalance).on("contractId", "contractNo")
                .select("contractId", "departmentId", "departmentName", "customerId", "customerName",
                        "contractNo", "tpv_bizdate", "tpv_paymentstatus", "contractAmt", "shippingAmt", "(case when e_actamt == null then 0.0 else e_actamt end) e_actamt")
                .finish();
        //(签约)占用余额
        dataSet4 = dataSet4.select("contractId", "departmentId", "departmentName", "customerId", "customerName",
                "contractNo", "tpv_bizdate", "tpv_paymentstatus", "contractAmt", "shippingAmt", "e_actamt", "contractAmt - e_actamt uncontractAmt");
        //(送货)占用余额
        dataSet4 = dataSet4.select("contractId", "departmentId", "departmentName", "customerId", "customerName",
                        "contractNo", "tpv_bizdate", "tpv_paymentstatus", "contractAmt", "shippingAmt", "e_actamt", "uncontractAmt", "shippingAmt - e_actamt unshippingAmt")
                .orderBy(new String[]{"tpv_bizdate desc"});
        if (isZeroHide) {
            dataSet4 = dataSet4.where("uncontractAmt<>0 and unshippingAmt<>0");
        }
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(dataSet4);
        return col_s;
    }
    public static DataSet getCusCreditLimits(long depId, long customerId, long contractId, boolean isZeroHide) {
        //销售合同
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        qFilter1.and(new QFilter("tpv_isselloncredit", QCP.equals, true));  //【是否赊销】=“是”
        if (0L != depId) {
            qFilter1.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter1.and(new QFilter("tpv_customer.id", QCP.equals, customerId));
        }
        if (0L != contractId) {
            qFilter1.and(new QFilter("id", QCP.equals, contractId));
        }
        DataSet dataSet1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salescontract",
                        "id contractId,tpv_department.id departmentId,tpv_department.name departmentName," +
                                "tpv_customer.id customerId,tpv_customer.name customerName,tpv_contractnos contractNo,tpv_bizdate,tpv_paymentstatus," +
                                "tpv_materialentry.tpv_effectivequantity*tpv_materialentry.tpv_taxprice contractAmt",
                        new QFilter[]{qFilter1}, null)
                .groupBy(new String[]{"contractId", "departmentId", "departmentName", "customerId", "customerName",
                        "contractNo", "tpv_bizdate", "tpv_paymentstatus"})
                .sum("contractAmt")
                .finish();
        DataSet tpv_dt_salescontract_1 = dataSet1.copy();
        List<Long> manIds = new ArrayList<>();
        if (null != tpv_dt_salescontract_1) {
            for (Row row : tpv_dt_salescontract_1) {
                manIds.add(row.getLong("contractId"));
            }
        }
        //销售发货
        QFilter qFilter2 = new QFilter("billstatus", QCP.equals, "C");
        if (0L != depId) {
            qFilter2.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter2.and(new QFilter("tpv_customer.id", QCP.equals, customerId));
        }
        if (0L != contractId) {
            qFilter1.and(new QFilter("tpv_materialentry.tpv_cobillid", QCP.equals, contractId));
        }
        DataSet tpv_dt_salesshipping = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salesshipping",
                "tpv_contractnumber,tpv_materialentry entryid,tpv_materialentry.tpv_cobillid tpv_cobillid," +
                        "tpv_materialentry.tpv_qty tpv_qty,tpv_materialentry.tpv_taxprice tpv_taxprice," +
                        "tpv_materialentry.tpv_cargobatchqty tpv_cargobatchqty",
                new QFilter[]{qFilter2}, null);
        DataSet copySalesshipping = tpv_dt_salesshipping.copy();
        List<Long> srcEntryid = new ArrayList<>();
        if (null != copySalesshipping) {
            for (Row row : copySalesshipping) {
                srcEntryid.add(row.getLong("entryid"));
            }
        }
        tpv_dt_salesshipping = RptUtil.zeroNullNums(tpv_dt_salesshipping);
        if (srcEntryid.size() > 0) {
            QFilter qFilterConvet = new QFilter("billstatus", QCP.equals, "C");
            qFilterConvet.and(new QFilter("tpv_materialentry.tpv_srcentryid",QCP.in,srcEntryid));
            DataSet salepricebill = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salepricebill",
                    "tpv_materialentry,tpv_materialentry.tpv_cobillid tpv_cobillid,tpv_materialentry.tpv_srcentryid tpv_srcentryid," +
                            "tpv_materialentry.tpv_qty_final tpv_qty_final",
                    new QFilter[]{qFilterConvet}, null);
            tpv_dt_salesshipping = tpv_dt_salesshipping.leftJoin(salepricebill).on("entryid","tpv_srcentryid")
                    .select("tpv_cobillid", "tpv_qty","tpv_qty_final","tpv_cargobatchqty","tpv_taxprice").finish();
            tpv_dt_salesshipping = RptUtil.zeroNullNums(tpv_dt_salesshipping);
            tpv_dt_salesshipping = tpv_dt_salesshipping.select("tpv_cobillid", "(tpv_qty - tpv_qty_final - tpv_cargobatchqty) * tpv_taxprice shippingAmt")
                    .groupBy(new String[]{"tpv_cobillid"})
                    .sum("shippingAmt")
                    .finish();
        } else {
            tpv_dt_salesshipping = tpv_dt_salesshipping.select("tpv_cobillid",
                            "(tpv_qty - tpv_cargobatchqty) * tpv_taxprice shippingAmt")
                    .groupBy(new String[]{"tpv_cobillid"})
                    .sum("shippingAmt")
                    .finish();
        }
        DataSet tpv_dt_salepricebill = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salepricebill",
                "tpv_materialentry,tpv_materialentry.tpv_cobillid tpv_cobillid,tpv_materialentry.tpv_srcentryid tpv_srcentryid," +
                        "tpv_materialentry.tpv_qty_final * tpv_materialentry.tpv_taxprice_final shippingAmt",
                new QFilter[]{qFilter2}, null);
        tpv_dt_salepricebill = tpv_dt_salepricebill.groupBy(new String[]{"tpv_cobillid"})
                .sum("shippingAmt")
                .finish();
        DataSet dataSet2 = tpv_dt_salesshipping.union(tpv_dt_salepricebill)
                .groupBy(new String[]{"tpv_cobillid"})
                .sum("shippingAmt")
                .finish();
        DataSet dataSet3 = dataSet1.leftJoin(dataSet2).on("contractId", "tpv_cobillid")
                .select("contractId", "departmentId", "departmentName", "customerId", "customerName",
                        "contractNo", "tpv_bizdate", "tpv_paymentstatus", "contractAmt", "shippingAmt")
                .finish();

        //占用减项  暂时为0，待可放余额表完成后，联查取值
        DataSet cuscreditBalance = getDeliverableBalanceConData(0L, 0L, manIds, false)
                .groupBy(new String[]{"contractId"}).sum("tpv_totalcollectamt").finish().select("contractId contractNo", "tpv_totalcollectamt e_actamt");

        DataSet dataSet4 = dataSet3.leftJoin(cuscreditBalance).on("contractId", "contractNo")
                .select("contractId", "departmentId", "departmentName", "customerId", "customerName",
                        "contractNo", "tpv_bizdate", "tpv_paymentstatus", "contractAmt", "shippingAmt", "(case when e_actamt == null then 0.0 else e_actamt end) e_actamt")
                .finish();
        //(签约)占用余额
        dataSet4 = dataSet4.select("contractId", "departmentId", "departmentName", "customerId", "customerName",
                "contractNo", "tpv_bizdate", "tpv_paymentstatus", "contractAmt", "shippingAmt", "e_actamt", "contractAmt - e_actamt uncontractAmt");
        //(送货)占用余额
        dataSet4 = dataSet4.select("contractId", "departmentId","departmentId tpv_departmentid", "departmentName tpv_deptname",
                        "customerId tpv_customerid", "customerName tpv_customername", "contractNo tpv_contractno", "tpv_bizdate",
                        "tpv_paymentstatus", "contractAmt tpv_contractamt", "shippingAmt tpv_shippingamt", "e_actamt tpv_e_actamt",
                        "uncontractAmt tpv_uncontractamt", "shippingAmt - e_actamt tpv_unshippingamt")
                .orderBy(new String[]{"tpv_bizdate desc"});
        if (isZeroHide) {
            dataSet4 = dataSet4.where("tpv_uncontractamt <> 0 and tpv_unshippingamt <> 0");
        }
        return dataSet4;
    }
    /**
     * 将部门形态为小组的部门，换成上级部门，此方法用来为供应商额度使用情况表联查汇总占用余额数据
     * */
    public static DataSet queryLeftJoinUse(long depId, long customerId, long contractId, boolean isZeroHide) {
        DataSet mainDataSet = getCusCreditLimits(depId, customerId, contractId, isZeroHide);
        Map<Long, Long> parentDeptIds = mapParentDeptIds();
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        for (DynamicObject col : col_s) {
            Long tpvDep = col.getLong("tpv_departmentid");
            if (tpvDep.compareTo(0l) > 0) {
                if (parentDeptIds.containsKey(tpvDep)) {
                    Long aLong = parentDeptIds.get(tpvDep);
                    col.set("tpv_departmentid",aLong);
                }
            }
        }

        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(SupCreditConRptQuery.class.getName()).createDataSet(inputs);
        return createDataSet;
    }

    /**
     * @Description: //可放货余额表 -非配供业务
     * @param: depId - 部门
     * @param: customerId - 客户
     * @param: contractId - 销售合同id
     * @return: DataSet
     **/
    public static DynamicObjectCollection getDeliverableBalanceCon(long depId, long customerId, long contractId) {
        //销售合同
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        if (0L != contractId) {
            qFilter1.and(new QFilter("id", QCP.equals, contractId));
        }
        if (0L != depId) {
            qFilter1.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter1.and(new QFilter("tpv_customer.id", QCP.equals, customerId));
        }
        DataSet dataSet1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salescontract",
                "id contractId,org.id orgId,org.name orgName,tpv_bizdate," +
                        "tpv_documenttypes.id tpv_documenttypesId,tpv_documenttypes.name tpv_documenttypesName,tpv_documenttypes.number tpv_documenttypesNumber," +
                        "tpv_department.id departmentId,tpv_department.name departmentName," +
                        "tpv_customer.id customerId,tpv_customer.name customerName,tpv_contractnos contractNo",
                new QFilter[]{qFilter1}, null);
        List mainIds_s = new ArrayList();
        DataSet dataSet1_1 = dataSet1.copy();
        for (Row row : dataSet1_1) {
            mainIds_s.add(row.getLong("contractId"));
        }
        DataSet dataSet = leftJoinUtil(dataSet1, mainIds_s, "Con").orderBy(new String[]{"tpv_bizdate desc"});
        DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(dataSet);
        return dynamicObjects;
    }
    /**
     * 根据客户、公司、部门、项目号/销售合同号 ，进行分组汇总
     */
    public static DataSet getDeliverableBalanceCons(long depId, long customerId, long contractId) {
        //销售合同
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        if (0L != contractId) {
            qFilter1.and(new QFilter("id", QCP.equals, contractId));
        }
        if (0L != depId) {
            qFilter1.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter1.and(new QFilter("tpv_customer.id", QCP.equals, customerId));
        }
        DataSet dataSet1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salescontract",
                "id contractId,org.id orgId,org.name orgName,tpv_bizdate," +
                        "tpv_documenttypes.id tpv_documenttypesId,tpv_documenttypes.name tpv_documenttypesName,tpv_documenttypes.number tpv_documenttypesNumber," +
                        "tpv_department.id departmentId,tpv_department.name departmentName," +
                        "tpv_customer.id customerId,tpv_customer.name customerName,tpv_projectabb,tpv_contractnos contractNo",
                new QFilter[]{qFilter1}, null);
        List mainIds_s = new ArrayList();
        DataSet dataSet1_1 = dataSet1.copy();
        for (Row row : dataSet1_1) {
            mainIds_s.add(row.getLong("contractId"));
        }
        DataSet lefted = leftJoinUtil(dataSet1, mainIds_s, "Con").orderBy(new String[]{"tpv_bizdate desc"});
        lefted = lefted.groupBy(new String[]{"contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                        "customerId", "customerName", "contractNo", "creditlimit"})
                .sum("shippingAmt").sum("invoicehightlow").sum("totalshipmentsAmt").sum("collectpledgedAmt").sum("collectcash").sum("collectnote").sum("collecthightlow").sum("collectrefundamt")
                .sum("totalcollectAmt").sum("paymentbalance").sum("unbanksinvoice").sum("banksinvoice").sum("financepayment").sum("rcvdepositpledged").sum("rcvdepositcash")
                .sum("rcvdepositnote").sum("rcvdeposithightlow").sum("rcvdepositrefundamt")
                .sum("totalrcvdeposit").sum("totalbalance").sum("finacebondsamt").finish();
        lefted = lefted.select("contractId", "tpv_bizdate", "orgId tpv_orgid", "orgName tpv_orgname", "departmentId tpv_departmentid", "departmentName tpv_deptname",
                "customerId tpv_customerid", "customerName tpv_customername", "contractNo tpv_contractno", "shippingAmt tpv_shippingamt","invoicehightlow tpv_invoicehightlow",
                "totalshipmentsAmt tpv_totalshipmentsamt", "collectpledgedAmt tpv_collectpledgedamt ","collectcash tpv_collectcash","collectnote tpv_collectnote","collecthightlow tpv_collecthightlow",
                "collectrefundamt tpv_collectrefundamt", "totalcollectAmt tpv_totalcollectamt", "paymentbalance tpv_paymentbalance",
                "unbanksinvoice tpv_unbanksinvoice","banksinvoice tpv_banksinvoice","financepayment tpv_financepayment",
                "rcvdepositpledged tpv_rcvdepositpledged", "rcvdepositcash tpv_rcvdepositcash","rcvdepositnote tpv_rcvdepositnote","rcvdeposithightlow tpv_rcvdeposithightlow","rcvdepositrefundamt tpv_rcvdepositrefundamt",
                "totalrcvdeposit tpv_totalrcvdeposit", "creditlimit tpv_creditlimit","finacebondsamt tpv_finacebondsamt", "totalbalance tpv_totalbalance").orderBy(new String[]{"tpv_bizdate desc"});
        return lefted;
    }
    /**
     * 根据客户、公司、部门、项目号/销售合同号 ，进行分组汇总，接口
     */
    public static JSONArray resultBalanceConsData(String depName, String customerName, String contractNo) {
        JSONArray result = new JSONArray();
        Long contractId = 0L;
        if (YEM.isNotEmpty(contractNo)) {
            DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("tpv_dt_salescontract",
                    new QFilter[]{new QFilter("tpv_contractnos", QCP.equals, contractNo)});
            if (YEM.isNotEmpty(dynamicObject)) {
                contractId = dynamicObject.getLong("id");
            }
        }
        Map<String, Long> deptNameMap = idByDeptORCusName("deptName");
        Map<Long, String> deptMap = idByDeptORCusName("deptId");
        Map<String, Long> cusNameMap = idByDeptORCusName("cusName");
        Map<Long, String> cusMap = idByDeptORCusName("cusId");
        Long depId = deptNameMap.get(depName) != null ? deptNameMap.get(depName) : 0L;
        Long customerId = cusNameMap.get(customerName) != null ? cusNameMap.get(customerName) : 0L;
        for (Row row : getDeliverableBalanceCons(depId, customerId, contractId)) {
            JSONObject jsonObject = new JSONObject(new LinkedHashMap<>());
            jsonObject.put("orgname", row.getString("tpv_orgname"));  //公司名称
            jsonObject.put("deptname", row.getString("tpv_deptname"));  //部门名称
            jsonObject.put("customername", row.getString("tpv_customername"));  //销售客户
            jsonObject.put("contractno", row.getString("tpv_contractno"));  //销售合同号
            jsonObject.put("customerid", row.getLong("tpv_customerid"));  //客户ID
            jsonObject.put("departmentid", row.getString("tpv_departmentid"));  //部门ID
            jsonObject.put("orgid", row.getString("tpv_orgid"));  //公司ID
            jsonObject.put("shippingamt", row.getBigDecimal("tpv_shippingamt") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_shippingamt").doubleValue(), 4) : BigDecimal.ZERO);  //发货总金额
            jsonObject.put("totalshipmentsamt", row.getBigDecimal("tpv_totalshipmentsamt") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_totalshipmentsamt").doubleValue(), 4) : BigDecimal.ZERO);  //总计金额
            jsonObject.put("collectpledgedamt", row.getBigDecimal("tpv_collectpledgedamt") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_collectpledgedamt").doubleValue(), 4) : BigDecimal.ZERO);  //质押货物金额(已收货款)
            jsonObject.put("totalcollectamt", row.getBigDecimal("tpv_totalcollectamt") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_totalcollectamt").doubleValue(), 4) : BigDecimal.ZERO);  //总计金额(已收货款)
            jsonObject.put("paymentbalance", row.getBigDecimal("tpv_paymentbalance") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_paymentbalance").doubleValue(), 4) : BigDecimal.ZERO);  //货款余额
            jsonObject.put("rcvdepositpledged", row.getBigDecimal("tpv_rcvdepositpledged") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_rcvdepositpledged").doubleValue(), 4) : BigDecimal.ZERO);  //质押货物金额(已收保证金)
            jsonObject.put("totalrcvdeposit", row.getBigDecimal("tpv_totalrcvdeposit") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_totalrcvdeposit").doubleValue(), 4) : BigDecimal.ZERO);  //总计金额(已收保证金)
            jsonObject.put("totalbalance", row.getBigDecimal("tpv_totalbalance") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_totalbalance").doubleValue(), 4) : BigDecimal.ZERO);  //总计余额
            result.add(jsonObject);
        }
        return result;
    }
    /**
     * 合同明细 查已收贷款的总计金额
     */
    private static DataSet getDeliverableBalanceConData(long depId, long customerId, List<Long> mainIds_s, Boolean flag) {
        //销售合同
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        if (mainIds_s.size() > 0) {
            qFilter1.and(new QFilter("id", QCP.in, mainIds_s));
        }
        if (0L != depId) {
            qFilter1.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter1.and(new QFilter("tpv_customer.id", QCP.equals, customerId));
        }
        DataSet dataSet1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salescontract",
                "id contractId,org.id orgId,org.name orgName,tpv_bizdate," +
                        "tpv_documenttypes.id tpv_documenttypesId,tpv_documenttypes.name tpv_documenttypesName,tpv_documenttypes.number tpv_documenttypesNumber," +
                        "tpv_department.id departmentId,tpv_department.name departmentName," +
                        "tpv_customer.id customerId,tpv_customer.name customerName,tpv_contractnos contractNo",
                new QFilter[]{qFilter1}, null);
        DataSet leftshippingAmt = leftshippingAmt(dataSet1, mainIds_s, "Con");
        //============================================================================================
        //3供应链金融（暂无）
        //============================================================================================
        //4已收货款【总计金额】
        DataSet leftReceiveAmt = leftReceiveAmt(leftshippingAmt, mainIds_s, "Con");
        DataSet dataSet = leftReceiveAmt.select("contractId", "tpv_bizdate", "orgId tpv_orgid", "orgName tpv_orgname", "departmentId tpv_departmentid", "departmentName tpv_deptname",
                "customerId tpv_customerid", "customerName tpv_customername", "contractNo tpv_contractno", "shippingAmt tpv_shippingamt","invoicehightlow tpv_invoicehightlow",
                "totalshipmentsAmt tpv_totalshipmentsamt", "collectpledgedAmt tpv_collectpledgedamt ","collectcash tpv_collectcash","collectnote tpv_collectnote","collecthightlow tpv_collecthightlow",
                "collectrefundamt tpv_collectrefundamt","totalcollectAmt tpv_totalcollectamt").orderBy(new String[]{"tpv_bizdate desc"});
        return dataSet;
    }
    /**
     * 用于销售发货提交校验
     * */
    public static DataSet getBalanceConDataLimit(long depId, long customerId, long contractId) {
        //销售合同
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        if (contractId > 0) {
            qFilter1.and(new QFilter("id", QCP.equals, contractId));
        }
        if (0L != depId) {
            qFilter1.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter1.and(new QFilter("tpv_customer.id", QCP.equals, customerId));
        }
        DataSet dataSet1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salescontract",
                "id contractId,org.id orgId,org.name orgName,tpv_bizdate," +
                        "tpv_documenttypes.id tpv_documenttypesId,tpv_documenttypes.name tpv_documenttypesName,tpv_documenttypes.number tpv_documenttypesNumber," +
                        "tpv_department.id departmentId,tpv_department.name departmentName," +
                        "tpv_customer.id customerId,tpv_customer.name customerName,tpv_contractnos contractNo",
                new QFilter[]{qFilter1}, null);
        DataSet copy = dataSet1.copy();
        List<Long> mainIds_s = new ArrayList<>();
        for (Row row : copy) {
            mainIds_s.add(row.getLong("contractId"));
        }
        DataSet leftshippingAmt = leftshippingAmt(dataSet1, mainIds_s, "Con");
        //============================================================================================
        //3供应链金融（暂无）
        //============================================================================================
        //4已收货款【总计金额】
        DataSet leftReceiveAmt = leftReceiveAmt(leftshippingAmt, mainIds_s, "Con");
        leftReceiveAmt = leftReceiveAmt.groupBy(new String[]{"contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                        "customerId", "customerName", "contractNo"}).sum("paymentbalance").finish();
        leftReceiveAmt = leftReceiveAmt.select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                "customerId", "customerName", "contractNo","paymentbalance tpv_paymentbalance");
        return leftReceiveAmt;
    }

    /**
     * @Description: //可放货余额表 -项目配供业务
     * @param: depId - 部门
     * @param: customerId - 客户
     * @param: projectId - 项目建档id
     * @return: DataSet
     **/
    public static DynamicObjectCollection getDeliverableBalanceXM(long depId, long customerId, long projectId) {
        //建档管理
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        qFilter1.and(new QFilter("tpv_framename", QCP.equals, ""));  //框架简称
        qFilter1.and(new QFilter("tpv_project", QCP.not_equals, ""));  //项目简称
        //qFilter1.and(new QFilter("tpv_filetypes", QCP.equals, "")); //建档类型 -项目建档 2 标识tpv_item
        if (0L != projectId) {
            qFilter1.and(new QFilter("id", QCP.equals, projectId));
        }
        if (0L != depId) {
            qFilter1.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter1.and(new QFilter("tpv_custom.id", QCP.equals, customerId));
        }
        DataSet dataSet1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_pw_filing",
                "id contractId, tpv_bizdate,org.id orgId,org.name orgName,tpv_project tpv_projectabb," +
                        "tpv_department.id departmentId,tpv_department.name departmentName," +
                        "tpv_custom.id customerId,tpv_custom.name customerName",
                new QFilter[]{qFilter1}, null);
        List mainIds_s = new ArrayList();
        DataSet dataSet1_1 = dataSet1.copy();
        for (Row row : dataSet1_1) {
            mainIds_s.add(row.getLong("contractId"));
        }
        DataSet dataSet = leftJoinUtil(dataSet1, mainIds_s, "XM").orderBy(new String[]{"tpv_bizdate desc"});
        DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(dataSet);
        return dynamicObjects;
    }
    /**
     * 根据客户、公司、部门、项目号/销售合同号 ，进行分组汇总
     * */
    public static DataSet getDeliverableBalanceXMs(long depId, long customerId, Long projectId) {
        //建档管理
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        qFilter1.and(new QFilter("tpv_framename", QCP.equals, ""));  //框架简称
        qFilter1.and(new QFilter("tpv_project", QCP.not_equals, ""));  //项目简称
        //qFilter1.and(new QFilter("tpv_filetypes", QCP.equals, "")); //建档类型 -项目建档 2 标识tpv_item
        if (0L != projectId) {
            qFilter1.and(new QFilter("id", QCP.equals, projectId));
        }
        if (0L != depId) {
            qFilter1.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter1.and(new QFilter("tpv_custom.id", QCP.equals, customerId));
        }
        DataSet dataSet1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_pw_filing",
                "id contractId, tpv_bizdate,org.id orgId,org.name orgName,tpv_project tpv_projectabb," +
                        "tpv_department.id departmentId,tpv_department.name departmentName," +
                        "tpv_custom.id customerId,tpv_custom.name customerName",
                new QFilter[]{qFilter1}, null);
        List mainIds_s = new ArrayList();
        DataSet dataSet1_1 = dataSet1.copy();
        for (Row row : dataSet1_1) {
            mainIds_s.add(row.getLong("contractId"));
        }
        DataSet lefted = leftJoinUtil(dataSet1, mainIds_s, "XM").orderBy(new String[]{"tpv_bizdate desc"});
        lefted = lefted.groupBy(new String[]{"contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                        "customerId", "customerName", "tpv_projectabb"})
                .sum("shippingAmt").sum("invoicehightlow").sum("totalshipmentsAmt").sum("collectpledgedAmt").sum("collectcash").sum("collectnote").sum("collecthightlow")
                .sum("collectrefundamt").sum("totalcollectAmt").sum("paymentbalance").sum("unbanksinvoice").sum("banksinvoice")
                .sum("financepayment").sum("rcvdepositpledged").sum("rcvdepositcash").sum("rcvdepositnote").sum("rcvdeposithightlow").sum("rcvdepositrefundamt")
                .sum("totalrcvdeposit").sum("creditlimit").sum("cuscreditlimit").sum("finacebondsamt").sum("totalbalance").finish();
        lefted = lefted.select("contractId", "tpv_bizdate", "orgId tpv_orgid", "orgName tpv_orgname", "departmentId tpv_departmentid", "departmentName tpv_deptname",
                "customerId tpv_customerid", "customerName tpv_customername", "tpv_projectabb", "shippingAmt tpv_shippingamt","invoicehightlow tpv_invoicehightlow",
                "totalshipmentsAmt tpv_totalshipmentsamt", "collectpledgedAmt tpv_collectpledgedamt ","collectcash tpv_collectcash","collectnote tpv_collectnote","collecthightlow tpv_collecthightlow",
                "collectrefundamt tpv_collectrefundamt","totalcollectAmt tpv_totalcollectamt", "paymentbalance tpv_paymentbalance","unbanksinvoice tpv_unbanksinvoice","banksinvoice tpv_banksinvoice","financepayment tpv_financepayment",
                "rcvdepositpledged tpv_rcvdepositpledged","rcvdepositcash tpv_rcvdepositcash","rcvdepositnote tpv_rcvdepositnote","rcvdeposithightlow tpv_rcvdeposithightlow","rcvdepositrefundamt tpv_rcvdepositrefundamt",
                "totalrcvdeposit tpv_totalrcvdeposit", "creditlimit tpv_creditlimit","cuscreditlimit tpv_cuscreditlimit","finacebondsamt tpv_finacebondsamt",
                "totalbalance tpv_totalbalance").orderBy(new String[]{"tpv_bizdate desc"});
        return lefted;
    }
    /**
     * 根据客户、公司、部门、项目号/销售合同号 ，进行分组汇总，接口
     * */
    public static JSONArray resultBalanceXMsData(String depName, String customerName, String project) {
        JSONArray result = new JSONArray();
        Long projectId = 0L;
        if (YEM.isNotEmpty(project)) {
            DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("tpv_pw_filing",
                    new QFilter[]{new QFilter("tpv_project", QCP.equals, project)});
            if (YEM.isNotEmpty(dynamicObject)) {
                projectId = dynamicObject.getLong("id");
            }
        }
        Map<String, Long> deptNameMap = idByDeptORCusName("deptName");
        Map<Long, String> deptMap = idByDeptORCusName("deptId");
        Map<String, Long> cusNameMap = idByDeptORCusName("cusName");
        Map<Long, String> cusMap = idByDeptORCusName("cusId");
        Long depId = deptNameMap.get(depName) != null ? deptNameMap.get(depName) : 0L;
        Long customerId = cusNameMap.get(customerName) != null ? cusNameMap.get(customerName) : 0L;
        for (Row row : getDeliverableBalanceXMs(depId, customerId, projectId)) {
            JSONObject jsonObject = new JSONObject(new LinkedHashMap<>());
            jsonObject.put("orgname", row.getString("tpv_orgname"));  //公司名称
            jsonObject.put("deptname", row.getString("tpv_deptname"));  //部门名称
            jsonObject.put("customername", row.getString("tpv_customername"));  //项目方
            jsonObject.put("projectabb", row.getString("tpv_projectabb"));  //项目号
            jsonObject.put("customerid", row.getLong("tpv_customerid"));  //客户ID
            jsonObject.put("departmentid", row.getString("tpv_departmentid"));  //部门ID
            jsonObject.put("orgid", row.getString("tpv_orgid"));  //公司ID
            jsonObject.put("shippingamt", row.getBigDecimal("tpv_shippingamt") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_shippingamt").doubleValue(), 4) : BigDecimal.ZERO);  //发货总金额
            jsonObject.put("totalshipmentsamt", row.getBigDecimal("tpv_totalshipmentsamt") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_totalshipmentsamt").doubleValue(), 4) : BigDecimal.ZERO);  //总计金额
            jsonObject.put("collectpledgedamt", row.getBigDecimal("tpv_collectpledgedamt") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_collectpledgedamt").doubleValue(), 4) : BigDecimal.ZERO);  //质押货物金额(已收货款)
            jsonObject.put("totalcollectamt", row.getBigDecimal("tpv_totalcollectamt") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_totalcollectamt").doubleValue(), 4) : BigDecimal.ZERO);  //总计金额(已收货款)
            jsonObject.put("paymentbalance", row.getBigDecimal("tpv_paymentbalance") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_paymentbalance").doubleValue(), 4) : BigDecimal.ZERO);  //货款余额
            jsonObject.put("creditlimit", row.getBigDecimal("tpv_creditlimit") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_creditlimit").doubleValue(), 4) : BigDecimal.ZERO);  //赊销额度
            jsonObject.put("rcvdepositpledged", row.getBigDecimal("tpv_rcvdepositpledged") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_rcvdepositpledged").doubleValue(), 4) : BigDecimal.ZERO);  //质押货物金额(已收保证金)
            jsonObject.put("totalrcvdeposit", row.getBigDecimal("tpv_totalrcvdeposit") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_totalrcvdeposit").doubleValue(), 4) : BigDecimal.ZERO);  //总计金额(已收保证金)
            jsonObject.put("totalbalance", row.getBigDecimal("tpv_totalbalance") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_totalbalance").doubleValue(), 4) : BigDecimal.ZERO);  //总计余额
            result.add(jsonObject);
        }
        return result;
    }
    /**
     * 用于销售发货提交校验
     * */
    public static DataSet getBalanceXMLimit(long depId, long customerId, Long projectId) {
        //建档管理
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        qFilter1.and(new QFilter("tpv_framename", QCP.equals, ""));  //框架简称
        qFilter1.and(new QFilter("tpv_project", QCP.not_equals, ""));  //项目简称
        //qFilter1.and(new QFilter("tpv_filetypes", QCP.equals, "")); //建档类型 -项目建档 2 标识tpv_item
        if (0L != projectId) {
            qFilter1.and(new QFilter("id", QCP.equals, projectId));
        }
        if (0L != depId) {
            qFilter1.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter1.and(new QFilter("tpv_custom.id", QCP.equals, customerId));
        }
        DataSet dataSet1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_pw_filing",
                "id contractId, tpv_bizdate,org.id orgId,org.name orgName,tpv_project tpv_projectabb," +
                        "tpv_department.id departmentId,tpv_department.name departmentName," +
                        "tpv_custom.id customerId,tpv_custom.name customerName",
                new QFilter[]{qFilter1}, null);
        List mainIds_s = new ArrayList();
        DataSet dataSet1_1 = dataSet1.copy();
        for (Row row : dataSet1_1) {
            mainIds_s.add(row.getLong("contractId"));
        }
        DataSet leftshippingAmt = leftshippingAmt(dataSet1, mainIds_s, "XM");
        DataSet copy = leftshippingAmt.copy();
        List<Long> contractNoIdList = new ArrayList<>();
        if (null != copy) {
            for (Row row : copy) {
                contractNoIdList.add(row.getLong("contractNoId"));
            }
        }
        DataSet leftReceiveAmt = leftReceiveAmt(leftshippingAmt, contractNoIdList, "XM");
        DataSet leftUnBanksInvoice = leftUnBanksInvoice(contractNoIdList, "XM", leftReceiveAmt);
        DataSet leftApplyLimited = leftApplyLimited(mainIds_s, "XM", leftUnBanksInvoice);
        leftApplyLimited = leftApplyLimited.groupBy(new String[]{"contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                        "customerId", "customerName", "tpv_projectabb"}).sum("cuscreditlimit").finish();
        leftApplyLimited = leftApplyLimited.select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                "customerId", "customerName", "tpv_projectabb","cuscreditlimit tpv_cuscreditlimit");
        return leftApplyLimited;
    }

    /**
     * @Description: //可放货余额表 -框架配供业务
     * @param: depId - 部门
     * @param: customerId - 客户
     * @param: project - 项目
     * @return: DataSet
     **/
    public static DynamicObjectCollection getDeliverableBalanceKJ(long depId, long customerId, long projectId) {
        //建档管理
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        qFilter1.and(new QFilter("tpv_frameworkname", QCP.not_equals, ""));  //框架简称
        //qFilter1.and(new QFilter("tpv_filetypes", QCP.equals, "")); //建档类型 -框架建档 1 标识tpv_frame
        if (0L != projectId) {
            qFilter1.and(new QFilter("id", QCP.equals, projectId));
        }
        if (0L != depId) {
            qFilter1.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter1.and(new QFilter("tpv_custom.id", QCP.equals, customerId));
        }
        DataSet dataSet1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_pw_filing",
                "id contractId, tpv_bizdate,org.id orgId,org.name orgName,tpv_frameworkname tpv_projectabb," +
                        "tpv_department.id departmentId,tpv_department.name departmentName," +
                        "tpv_custom.id customerId,tpv_custom.name customerName",
                new QFilter[]{qFilter1}, null);
        List mainIds_s = new ArrayList();
        DataSet dataSet1_1 = dataSet1.copy();
        for (Row row : dataSet1_1) {
            mainIds_s.add(row.getLong("contractId"));
        }
        DataSet dataSet = leftJoinUtil(dataSet1, mainIds_s, "KJ").orderBy(new String[]{"tpv_bizdate desc"});
        DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(dataSet);
        return dynamicObjects;
    }
    /**
     * 根据客户、公司、部门、项目号/销售合同号 ，进行分组汇总
     * */
    public static DataSet getDeliverableBalanceKJs(long depId, long customerId, Long projectId) {
        //建档管理
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        qFilter1.and(new QFilter("tpv_frameworkname", QCP.not_equals, ""));  //框架简称
        //qFilter1.and(new QFilter("tpv_filetypes", QCP.equals, "")); //建档类型 -框架建档 1 标识tpv_frame
        if (0L != projectId) {
            qFilter1.and(new QFilter("id", QCP.equals, projectId));
        }
        if (0L != depId) {
            qFilter1.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter1.and(new QFilter("tpv_custom.id", QCP.equals, customerId));
        }
        DataSet dataSet1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_pw_filing",
                "id contractId, tpv_bizdate,org.id orgId,org.name orgName,tpv_frameworkname tpv_projectabb," +
                        "tpv_department.id departmentId,tpv_department.name departmentName," +
                        "tpv_custom.id customerId,tpv_custom.name customerName",
                new QFilter[]{qFilter1}, null);
        List mainIds_s = new ArrayList();
        DataSet dataSet1_1 = dataSet1.copy();
        for (Row row : dataSet1_1) {
            mainIds_s.add(row.getLong("contractId"));
        }
        DataSet lefted = leftJoinUtil(dataSet1, mainIds_s, "KJ").orderBy(new String[]{"tpv_bizdate desc"});
        lefted = lefted.groupBy(new String[]{"contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                        "customerId", "customerName", "tpv_projectabb"})
                .sum("shippingAmt").sum("invoicehightlow").sum("totalshipmentsAmt").sum("collectpledgedAmt").sum("collectcash").sum("collectnote").sum("collecthightlow")
                .sum("collectrefundamt").sum("totalcollectAmt").sum("paymentbalance").sum("unbanksinvoice").sum("banksinvoice").sum("financepayment").sum("rcvdepositpledged")
                .sum("rcvdepositcash").sum("rcvdepositnote").sum("rcvdeposithightlow").sum("rcvdepositrefundamt")
                .sum("totalrcvdeposit").sum("creditlimit").sum("cuscreditlimit").sum("finacebondsamt").sum("totalbalance").finish();
        lefted = lefted.select("contractId", "tpv_bizdate", "orgId tpv_orgid", "orgName tpv_orgname", "departmentId tpv_departmentid", "departmentName tpv_deptname",
                "customerId tpv_customerid", "customerName tpv_customername", "tpv_projectabb", "shippingAmt tpv_shippingamt","invoicehightlow tpv_invoicehightlow",
                "totalshipmentsAmt tpv_totalshipmentsamt", "collectpledgedAmt tpv_collectpledgedamt ","collectcash tpv_collectcash","collectnote tpv_collectnote","collecthightlow tpv_collecthightlow",
                "collectrefundamt tpv_collectrefundamt","totalcollectAmt tpv_totalcollectamt", "paymentbalance tpv_paymentbalance","unbanksinvoice tpv_unbanksinvoice","banksinvoice tpv_banksinvoice","financepayment tpv_financepayment",
                "rcvdepositpledged tpv_rcvdepositpledged","rcvdepositcash tpv_rcvdepositcash","rcvdepositnote tpv_rcvdepositnote","rcvdeposithightlow tpv_rcvdeposithightlow","rcvdepositrefundamt tpv_rcvdepositrefundamt",
                "totalrcvdeposit tpv_totalrcvdeposit", "creditlimit tpv_creditlimit","cuscreditlimit tpv_cuscreditlimit", "finacebondsamt tpv_finacebondsamt",
                "totalbalance tpv_totalbalance").orderBy(new String[]{"tpv_bizdate desc"});
        return lefted;
    }
    /**
     * 根据客户、公司、部门、项目号/销售合同号 ，进行分组汇总，接口
     * */
    public static JSONArray resultBalanceKJsData(String depName, String customerName, String project) {
        JSONArray result = new JSONArray();
        Long projectId = 0L;
        if (YEM.isNotEmpty(project)) {
            DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("tpv_pw_filing",
                    new QFilter[]{new QFilter("tpv_project", QCP.equals, project)});
            if (YEM.isNotEmpty(dynamicObject)) {
                projectId = dynamicObject.getLong("id");
            }
        }
        Map<String, Long> deptNameMap = idByDeptORCusName("deptName");
        Map<Long, String> deptMap = idByDeptORCusName("deptId");
        Map<String, Long> cusNameMap = idByDeptORCusName("cusName");
        Map<Long, String> cusMap = idByDeptORCusName("cusId");
        Long depId = deptNameMap.get(depName) != null ? deptNameMap.get(depName) : 0L;
        Long customerId = cusNameMap.get(customerName) != null ? cusNameMap.get(customerName) : 0L;
        for (Row row : getDeliverableBalanceKJs(depId, customerId, projectId)) {
            JSONObject jsonObject = new JSONObject(new LinkedHashMap<>());
            jsonObject.put("orgname", row.getString("tpv_orgname"));  //公司名称
            jsonObject.put("deptname", row.getString("tpv_deptname"));  //部门名称
            jsonObject.put("customername", row.getString("tpv_customername"));  //项目方
            jsonObject.put("projectabb", row.getString("tpv_projectabb"));  //项目号
            jsonObject.put("customerid", row.getLong("tpv_customerid"));  //客户ID
            jsonObject.put("departmentid", row.getString("tpv_departmentid"));  //部门ID
            jsonObject.put("orgid", row.getString("tpv_orgid"));  //公司ID
            jsonObject.put("shippingamt", row.getBigDecimal("tpv_shippingamt") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_shippingamt").doubleValue(), 4) : BigDecimal.ZERO);  //发货总金额
            jsonObject.put("totalshipmentsamt", row.getBigDecimal("tpv_totalshipmentsamt") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_totalshipmentsamt").doubleValue(), 4) : BigDecimal.ZERO);  //总计金额
            jsonObject.put("collectpledgedamt", row.getBigDecimal("tpv_collectpledgedamt") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_collectpledgedamt").doubleValue(), 4) : BigDecimal.ZERO);  //质押货物金额(已收货款)
            jsonObject.put("totalcollectamt", row.getBigDecimal("tpv_totalcollectamt") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_totalcollectamt").doubleValue(), 4) : BigDecimal.ZERO);  //总计金额(已收货款)
            jsonObject.put("paymentbalance", row.getBigDecimal("tpv_paymentbalance") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_paymentbalance").doubleValue(), 4) : BigDecimal.ZERO);  //货款余额
            jsonObject.put("creditlimit", row.getBigDecimal("tpv_creditlimit") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_creditlimit").doubleValue(), 4) : BigDecimal.ZERO);  //赊销额度
            jsonObject.put("rcvdepositpledged", row.getBigDecimal("tpv_rcvdepositpledged") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_rcvdepositpledged").doubleValue(), 4) : BigDecimal.ZERO);  //质押货物金额(已收保证金)
            jsonObject.put("totalrcvdeposit", row.getBigDecimal("tpv_totalrcvdeposit") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_totalrcvdeposit").doubleValue(), 4) : BigDecimal.ZERO);  //总计金额(已收保证金)
            jsonObject.put("totalbalance", row.getBigDecimal("tpv_totalbalance") != null ?
                    BigDecimalUtils.ceil(row.getBigDecimal("tpv_totalbalance").doubleValue(), 4) : BigDecimal.ZERO);  //总计余额
            result.add(jsonObject);
        }
        return result;
    }
    /**
     * 用于销售发货提交校验
     * */
    public static DataSet getBalanceKJLimit(long depId, long customerId, Long projectId) {
        //建档管理
        QFilter qFilter1 = new QFilter("billstatus", QCP.equals, "C");
        qFilter1.and(new QFilter("tpv_frameworkname", QCP.not_equals, ""));  //框架简称
        //qFilter1.and(new QFilter("tpv_filetypes", QCP.equals, "")); //建档类型 -框架建档 1 标识tpv_frame
        if (0L != projectId) {
            qFilter1.and(new QFilter("id", QCP.equals, projectId));
        }
        if (0L != depId) {
            qFilter1.and(new QFilter("tpv_department.id", QCP.equals, depId));
        }
        if (0L != customerId) {
            qFilter1.and(new QFilter("tpv_custom.id", QCP.equals, customerId));
        }
        DataSet dataSet1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_pw_filing",
                "id contractId, tpv_bizdate,org.id orgId,org.name orgName,tpv_frameworkname tpv_projectabb," +
                        "tpv_department.id departmentId,tpv_department.name departmentName," +
                        "tpv_custom.id customerId,tpv_custom.name customerName",
                new QFilter[]{qFilter1}, null);
        List mainIds_s = new ArrayList();
        DataSet dataSet1_1 = dataSet1.copy();
        for (Row row : dataSet1_1) {
            mainIds_s.add(row.getLong("contractId"));
        }
        DataSet leftshippingAmt = leftshippingAmt(dataSet1, mainIds_s, "XM");
        DataSet copy = leftshippingAmt.copy();
        List<Long> contractNoIdList = new ArrayList<>();
        if (null != copy) {
            for (Row row : copy) {
                contractNoIdList.add(row.getLong("contractNoId"));
            }
        }
        DataSet leftReceiveAmt = leftReceiveAmt(leftshippingAmt, contractNoIdList, "XM");
        DataSet leftUnBanksInvoice = leftUnBanksInvoice(contractNoIdList, "XM", leftReceiveAmt);
        DataSet leftApplyLimited = leftApplyLimited(mainIds_s, "XM", leftUnBanksInvoice);
        leftApplyLimited = leftApplyLimited.groupBy(new String[]{"contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                "customerId", "customerName", "tpv_projectabb"}).sum("cuscreditlimit").finish();
        leftApplyLimited = leftApplyLimited.select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                "customerId", "customerName", "tpv_projectabb","cuscreditlimit tpv_cuscreditlimit");
        return leftApplyLimited;
    }

    /**
     * @Description: //根据可放余额表主维度 -左连接查询
     * @param: depId - 部门
     * @param: customerId - 客户
     * @param: mainBillId - 主维度单据ID
     * @param: dataSet1 - 主维度数据
     * @param: mainIds_s - 主维度ID集合
     * @param: mainBill - 查询纬度
     * @return: kd.bos.algo.DataSet
     **/
    private static DataSet leftJoinUtil(DataSet dataSet1, List mainIds_s, String mainBill) {
        DataSet dataSet = dataSet1;
        if ("XM".equals(mainBill) || "KJ".equals(mainBill)) {
            DataSet leftshippingAmt = leftshippingAmt(dataSet1, mainIds_s, mainBill);
            DataSet copy = leftshippingAmt.copy();
            List<Long> contractNoIdList = new ArrayList<>();
            if (null != copy) {
                for (Row row : copy) {
                    contractNoIdList.add(row.getLong("contractNoId"));
                }
            }
            DataSet leftReceiveAmt = leftReceiveAmt(leftshippingAmt, contractNoIdList, mainBill);
            DataSet leftUnBanksInvoice = leftUnBanksInvoice(contractNoIdList, mainBill, leftReceiveAmt);
            DataSet leftApplyLimited = leftApplyLimited(mainIds_s, mainBill, leftUnBanksInvoice);
            DataSet leftReceiptBond = leftReceiptBond(leftApplyLimited, contractNoIdList, mainBill);
            DataSet leftFinaceBondsLimit = leftFinaceBondsLimit(contractNoIdList, mainBill, leftReceiptBond);
            DataSet leftFinancePayment = leftFinancePayment(contractNoIdList, mainBill, leftFinaceBondsLimit);
            List<String> aliasList = RptUtil.getDataSetAliasList(leftFinancePayment);
            aliasList.add("paymentbalance + totalrcvdeposit totalbalance");
            dataSet = leftFinancePayment.select(aliasList.toArray(new String[0]));
        }
        if ("Con".equals(mainBill)) {
            DataSet leftshippingAmt = leftshippingAmt(dataSet1, mainIds_s, mainBill);
            DataSet copy = leftshippingAmt.copy();
            List<Long> contractIds = new ArrayList<>();
            if (null != copy) {
                for (Row row : copy) {
                    contractIds.add(row.getLong("contractId"));
                }
            }
            DataSet leftReceiveAmt = leftReceiveAmt(leftshippingAmt, contractIds, mainBill);
            DataSet leftUnBanksInvoice = leftUnBanksInvoice(contractIds, mainBill, leftReceiveAmt);
            DataSet leftApplyLimited = leftApplyLimited(mainIds_s, mainBill, leftUnBanksInvoice);
            DataSet leftReceiptBond = leftReceiptBond(leftApplyLimited, contractIds, mainBill);
            DataSet leftFinaceBondsLimit = leftFinaceBondsLimit(contractIds, mainBill, leftReceiptBond);
            DataSet leftFinancePayment = leftFinancePayment(contractIds, mainBill, leftFinaceBondsLimit);
            List<String> aliasList = RptUtil.getDataSetAliasList(leftFinancePayment);
            aliasList.add("paymentbalance + totalrcvdeposit totalbalance");
            dataSet = leftFinancePayment.select(aliasList.toArray(new String[0]));
        }
        return dataSet;
    }

    /**
     * 8财务货款余额
     * */
    private static DataSet leftFinancePayment(List<Long> contractIdList, String mainBill, DataSet leftFinaceBondsLimit) {
        DataSet dataSet = leftFinaceBondsLimit;
        if ("XM".equals(mainBill) || "KJ".equals(mainBill)) {
            //8财务货款余额
            QFilter qFilter_1 = new QFilter("entries.account.number",QCP.in,new String[]{"2205010202","2205010102"});
            DataSet gl_voucher = voucherAcAssgrpByEntryId(qFilter_1, contractIdList).select("contractId","creditlocal financepayment");
            dataSet = dataSet.leftJoin(gl_voucher).on("contractNoId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt", "totalcollectAmt","paymentbalance",
                            "unbanksinvoice","banksinvoice","creditlimit","cuscreditlimit","rcvdepositpledged","rcvdepositcash","rcvdepositnote","rcvdeposithightlow","rcvdepositrefundamt",
                            "totalrcvdeposit","finacebondsamt", "financepayment").finish();
        }
        if ("Con".equals(mainBill)) {
            //8财务货款余额
            QFilter qFilter_2 = new QFilter("entries.account.number",QCP.in,new String[]{"2205010202","2205010102"});
            DataSet gl_voucher = voucherAcAssgrpByEntryId(qFilter_2, contractIdList).select("contractId","creditlocal financepayment");
            dataSet = dataSet.leftJoin(gl_voucher).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                    "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                    "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt", "totalcollectAmt","paymentbalance",
                    "unbanksinvoice","banksinvoice","creditlimit", "rcvdepositpledged", "rcvdepositcash","rcvdepositnote","rcvdeposithightlow","rcvdepositrefundamt",
                    "totalrcvdeposit","finacebondsamt","financepayment").finish();
        }
        return dataSet;
    }

    /**
     * 12财务保证金余额
     * */
    private static DataSet leftFinaceBondsLimit(List<Long> contractIdList, String mainBill, DataSet leftReceiptBond) {
        DataSet dataSet = leftReceiptBond;
        if ("XM".equals(mainBill) || "KJ".equals(mainBill)) {
            //12财务保证金余额
            QFilter qFilter_1 = new QFilter("entries.account.number",QCP.in,new String[]{"2205010101","2205010201"});
            DataSet gl_voucher = voucherAcAssgrpByEntryId(qFilter_1, contractIdList).select("contractId","creditlocal finacebondsamt");
            dataSet = dataSet.leftJoin(gl_voucher).on("contractNoId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt", "totalcollectAmt","paymentbalance",
                            "unbanksinvoice","banksinvoice","creditlimit","cuscreditlimit","rcvdepositpledged","rcvdepositcash","rcvdepositnote","rcvdeposithightlow",
                            "rcvdepositrefundamt","totalrcvdeposit","finacebondsamt").finish();
        }
        if ("Con".equals(mainBill)) {
            //12财务保证金余额
            QFilter qFilter_2 = new QFilter("entries.account.number",QCP.in,new String[]{"2205010101","2205010201"});
            DataSet gl_voucher = voucherAcAssgrpByEntryId(qFilter_2, contractIdList).select("contractId","creditlocal finacebondsamt");
            dataSet = dataSet.leftJoin(gl_voucher).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt", "totalcollectAmt","paymentbalance",
                            "unbanksinvoice","banksinvoice","creditlimit", "rcvdepositpledged", "rcvdepositcash","rcvdepositnote","rcvdeposithightlow","rcvdepositrefundamt",
                            "totalrcvdeposit","finacebondsamt").finish();
        }
        return dataSet;
    }

    /**
     * 11已收保证金
     * */
    private static DataSet leftReceiptBond(DataSet leftApplyLimited, List<Long> contractIdList, String mainBill) {
        DataSet dataSet = leftApplyLimited;
        if ("XM".equals(mainBill) || "KJ".equals(mainBill)) {
            /**
             * 11.1现款总金额  11.2票据总金额
             * */
            DataSet casRecbill = getCasRecbillRcvdeposit(contractIdList);
            /**
             * 11.3未核销高低计单 规划至保证金
             * */
            DataSet rcvdeposithightlow = getRcvdeposithightlow(contractIdList);
            /**
             * 11.6退款总金额
             * */
            DataSet rcvdepositrefundamt = getRcvdepositrefundamt(contractIdList);
            /**
             * 11.4质押货物金额
             * */
            QFilter qFilter_1 = new QFilter("billstatus", QCP.equals, "C");
            qFilter_1.and(new QFilter("tpv_stakepurpose", QCP.equals, "B"));
            if (contractIdList.size() > 0) {
                qFilter_1.and(new QFilter("tpv_salecontractno.id", QCP.in, contractIdList));
            }
            DataSet tpv_pledgereceipt = QueryServiceHelper.queryDataSet(algoKey, "tpv_pledgereceipt",
                    "id saleIda,tpv_salecontractno.id contractNoId,tpv_amount e_actamt1",
                    new QFilter[]{qFilter_1}, null);
            //11.4.1货物解押单
            DataSet tpv_pledgereceipt_1 = tpv_pledgereceipt.copy();
            List<Long> pledgerList = new ArrayList();
            for (Row row : tpv_pledgereceipt_1) {
                pledgerList.add(row.getLong("saleIda"));
            }
            QFilter qFilter_11 = new QFilter("billstatus", QCP.equals, "C");
            if (pledgerList.size() > 0) {
                qFilter_11.and(new QFilter("tpv_sourcebillid", QCP.in, pledgerList));
            }
            DataSet tpv_cargodecompression = QueryServiceHelper.queryDataSet(algoKey, "tpv_cargodecompression",
                    "tpv_sourcebillid saleIdb,tpv_amount e_actamt2",
                    new QFilter[]{qFilter_11}, null);

            DataSet pledgereceipt = tpv_pledgereceipt.leftJoin(tpv_cargodecompression).on("saleIda", "saleIdb")
                    .select("saleIda", "contractNoId", "e_actamt1-e_actamt2 rcvdepositpledged").finish()
                    .groupBy(new String[]{"contractNoId"})
                    .sum("rcvdepositpledged")
                    .finish();

            dataSet = dataSet.leftJoin(pledgereceipt).on("contractNoId", "contractNoId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId","contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt", "collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt", "totalcollectAmt",
                            "paymentbalance","unbanksinvoice","banksinvoice","creditlimit","cuscreditlimit","rcvdepositpledged").finish();
            dataSet = dataSet.leftJoin(casRecbill).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt",
                            "totalcollectAmt","paymentbalance", "unbanksinvoice","banksinvoice","creditlimit","cuscreditlimit",
                            "rcvdepositpledged","rcvdepositcash","rcvdepositnote").finish();
            dataSet = dataSet.leftJoin(rcvdeposithightlow).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt",
                            "totalcollectAmt","paymentbalance", "unbanksinvoice","banksinvoice","creditlimit","cuscreditlimit",
                            "rcvdepositpledged","rcvdepositcash","rcvdepositnote","rcvdeposithightlow").finish();
            dataSet = dataSet.leftJoin(rcvdepositrefundamt).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt",
                            "totalcollectAmt","paymentbalance", "unbanksinvoice","banksinvoice","creditlimit","cuscreditlimit",
                            "rcvdepositpledged","rcvdepositcash","rcvdepositnote","rcvdeposithightlow","rcvdepositrefundamt").finish();
            dataSet = RptUtil.zeroNullNums(dataSet);
            dataSet = dataSet.select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                    "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo", "shippingAmt","invoicehightlow",
                    "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt", "totalcollectAmt","paymentbalance",
                    "unbanksinvoice","banksinvoice","creditlimit","cuscreditlimit","rcvdepositpledged","rcvdepositcash","rcvdepositnote","rcvdeposithightlow","rcvdepositrefundamt",
                    "rcvdepositcash + rcvdepositnote + rcvdeposithightlow + rcvdepositrefundamt + rcvdepositpledged totalrcvdeposit");
        }
        if ("Con".equals(mainBill)) {
            /**
             * 11.1现款总金额  11.2票据总金额
             * */
            DataSet casRecbill = getCasRecbillRcvdeposit(contractIdList);
            /**
             * 11.3未核销高低计单 规划至保证金
             * */
            DataSet rcvdeposithightlow = getRcvdeposithightlow(contractIdList);
            /**
             * 11.6退款总金额
             * */
            DataSet rcvdepositrefundamt = getRcvdepositrefundamt(contractIdList);
            /**
             * 11.4质押货物金额
             * */
            QFilter qFilter_2 = new QFilter("billstatus", QCP.equals, "C");
            qFilter_2.and(new QFilter("tpv_stakepurpose", QCP.equals, "B"));
            DataSet tpv_pledgereceipt = QueryServiceHelper.queryDataSet(algoKey, "tpv_pledgereceipt",
                    "tpv_salecontractno.id contractId,tpv_amount e_actamt1",
                    new QFilter[]{qFilter_2}, null);
            //11.4.1货物解押单
            DataSet tpv_pledgereceipt_1 = tpv_pledgereceipt.copy();
            List<Long> pledgerList = new ArrayList();
            for (Row row : tpv_pledgereceipt_1) {
                pledgerList.add(row.getLong("contractId"));
            }
            QFilter qFilter_21 = new QFilter("billstatus", QCP.equals, "C");
            if (pledgerList.size() > 0) {
                qFilter_21.and(new QFilter("tpv_salecontractno.id", QCP.in, pledgerList));
            }
            DataSet tpv_cargodecompression = QueryServiceHelper.queryDataSet(algoKey, "tpv_cargodecompression",
                    "tpv_salecontractno.id contractId,tpv_amount e_actamt2",
                    new QFilter[]{qFilter_21}, null);
            DataSet pledgereceipt = tpv_pledgereceipt.leftJoin(tpv_cargodecompression).on("contractId", "contractId")
                    .select("contractId", "e_actamt1","e_actamt2").finish();
            pledgereceipt = RptUtil.zeroNullNums(pledgereceipt);
            pledgereceipt = pledgereceipt.select("contractId","e_actamt1 - e_actamt2 rcvdepositpledged")
                    .groupBy(new String[]{"contractId"})
                    .sum("rcvdepositpledged")
                    .finish();

            dataSet = dataSet.leftJoin(pledgereceipt).on("contractId", "contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt", "totalcollectAmt",
                            "paymentbalance","unbanksinvoice","banksinvoice","creditlimit", "rcvdepositpledged").finish();
            dataSet = dataSet.leftJoin(casRecbill).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt",
                            "totalcollectAmt","paymentbalance", "unbanksinvoice","banksinvoice","creditlimit",
                            "rcvdepositpledged", "rcvdepositcash","rcvdepositnote").finish();
            dataSet = dataSet.leftJoin(rcvdeposithightlow).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow", "collectrefundamt",
                            "totalcollectAmt","paymentbalance", "unbanksinvoice","banksinvoice","creditlimit",
                            "rcvdepositpledged", "rcvdepositcash","rcvdepositnote","rcvdeposithightlow").finish();
            dataSet = dataSet.leftJoin(rcvdepositrefundamt).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow", "collectrefundamt",
                            "totalcollectAmt","paymentbalance", "unbanksinvoice","banksinvoice","creditlimit",
                            "rcvdepositpledged", "rcvdepositcash","rcvdepositnote","rcvdeposithightlow","rcvdepositrefundamt").finish();
            dataSet = RptUtil.zeroNullNums(dataSet);
            dataSet = dataSet.select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                    "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                    "totalshipmentsAmt","collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt", "totalcollectAmt","paymentbalance",
                    "unbanksinvoice","banksinvoice","creditlimit", "rcvdepositpledged", "rcvdepositcash","rcvdepositnote","rcvdeposithightlow","rcvdepositrefundamt",
                    "rcvdepositcash + rcvdepositnote + rcvdeposithightlow + rcvdepositrefundamt + rcvdepositpledged totalrcvdeposit");
        }
        return dataSet;
    }

    private static DataSet getRcvdepositrefundamt(List<Long> contractIds) {
        //4.6退款总金额
        QFilter qFilter_1 = new QFilter("billstatus", QCP.in, new String[]{"B","C"});
        if (contractIds.size() > 0) {
            qFilter_1.and(new QFilter("shkd_payment_entry.shkd_salecontract.id", QCP.in, contractIds));
        }
        qFilter_1.and(new QFilter("shkd_e_paymenttype.number", QCP.in, new String[]{"0310","206"})); //付款类型：退回已收款的款项/退代收款
        DataSet paymentApplication = QueryServiceHelper.queryDataSet(algoKey, "shkd_payment_application",
                        "id billid,shkd_payment_entry,shkd_payment_entry.shkd_salecontract.id contractId,shkd_payment_entry.shkd_recid shkd_recid," +
                                "shkd_payment_entry.shkd_applyamount * shkd_exrate rcvdepositrefundamt",
                        new QFilter[]{qFilter_1}, null);
        DataSet copy = paymentApplication.copy();
        DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(copy);
        List<Long> ids = new ArrayList<>();
        for (DynamicObject dynamicObject : dynamicObjects) {
            if (!ids.contains(dynamicObject.getLong("shkd_recid"))) {
                ids.add(dynamicObject.getLong("shkd_recid"));
            }
        }
        //4.3收款单
        QFilter qFilter_12 = new QFilter("billstatus", QCP.not_equals, "A");
        if (ids.size() > 0) {
            qFilter_12.and(new QFilter("id", QCP.in, ids));
        }
        DataSet casRecbill = QueryServiceHelper.queryDataSet(algoKey, "cas_recbill",
                "id billid,receivingtype.number receivingtypenumber", new QFilter[]{qFilter_12}, null);
        paymentApplication = paymentApplication.leftJoin(casRecbill).on("shkd_recid","billid")
                .select(RptUtil.getDataSetFiledAlias(paymentApplication), new String[]{"receivingtypenumber"}).finish();
        paymentApplication = paymentApplication.where("receivingtypenumber = '02'");
        paymentApplication = paymentApplication.groupBy(new String[]{"contractId"}).sum("rcvdepositrefundamt").finish();
        return paymentApplication;
    }

    private static DataSet getRcvdeposithightlow(List<Long> contractIds) {
        QFilter qFilter_1 = new QFilter("billstatus", QCP.equals, "C");
        if (contractIds.size() > 0) {
            qFilter_1.and(new QFilter("tpv_settlement.tpv_programme.tpv_contractnu.id", QCP.in, contractIds));
        }
        qFilter_1.and(new QFilter("tpv_settlement.tpv_programme.tpv_contractnu.id", QCP.large_than, 0));
        qFilter_1.and(new QFilter("tpv_settlement.tpv_programme.tpv_documenttype", QCP.equals, "B"));
        qFilter_1.and(new QFilter("tpv_invalid", QCP.equals, false));
        //高低计规划单规划明细子分录
        DataSet rcvdeposithightlow = QueryServiceHelper.queryDataSet(algoKey, "tpv_cm_plannedbills",
                        "id billid,tpv_settlement,tpv_settlement.id entryid,tpv_settlement.tpv_programme.id subentryid," +
                                "tpv_settlement.tpv_programme.tpv_contractnu.id contractId," +
                                "tpv_settlement.tpv_programme.tpv_amount * tpv_settlement.tpv_entryratermb rcvdeposithightlow"
                        , new QFilter[]{qFilter_1}, null)
                .select("contractId","rcvdeposithightlow")
                .groupBy(new String[]{"contractId"}).sum("rcvdeposithightlow").finish();
        return rcvdeposithightlow;
    }

    private static DataSet getCasRecbillRcvdeposit(List<Long> contractIds) {
        //4.2现款总金额
        QFilter qFilter_1 = new QFilter("billstatus", QCP.equals, "D");
        if (contractIds.size() > 0) {
            qFilter_1.and(new QFilter("entry.shkd_salecontract.id", QCP.in, contractIds));
        }
        qFilter_1.and(new QFilter("settletype.number", QCP.not_in, new String[]{"JSFS06","JSFS07"})); //【结算方式】的类型 ≠ 银行承兑汇票/商业承兑汇票
        qFilter_1.and(new QFilter("receivingtype.number", QCP.in, new String[]{"02"})); //【收款类型】=保证金
        DataSet casRecbillNo = QueryServiceHelper.queryDataSet(algoKey, "cas_recbill",
                        "id billid,receivingtype.number receivingtypeNumber,entry,settletype.number settletypeNumber," +
                                "shkd_rmbexrate,entry.shkd_salecontract.id contractId,entry.e_receivableamt * shkd_rmbexrate rcvdepositcash",
                        new QFilter[]{qFilter_1}, null)
                .select("contractId","rcvdepositcash","0.0 rcvdepositnote")
                .groupBy(new String[]{"contractId"}).sum("rcvdepositcash").sum("rcvdepositnote").finish();
        //4.3票据总金额
        QFilter qFilter_12 = new QFilter("billstatus", QCP.equals, "D");
        if (contractIds.size() > 0) {
            qFilter_12.and(new QFilter("entry.shkd_salecontract.id", QCP.in, contractIds));
        }
        qFilter_12.and(new QFilter("settletype.number", QCP.in, new String[]{"JSFS06","JSFS07"})); //【结算方式】的类型 = 银行承兑汇票/商业承兑汇票
        qFilter_12.and(new QFilter("receivingtype.number", QCP.in, new String[]{"02"})); //【收款类型】=保证金
        qFilter_12.and(new QFilter("shkd_draftbillexpireda", QCP.less_equals, new Date())); //票据到期日 <= 当前系统时间
        DataSet casRecbillYes = QueryServiceHelper.queryDataSet(algoKey, "cas_recbill",
                        "id billid,receivingtype.number receivingtypeNumber,entry,settletype.number settletypeNumber," +
                                "shkd_rmbexrate,entry.shkd_salecontract.id contractId,entry.e_receivableamt * shkd_rmbexrate rcvdepositnote",
                        new QFilter[]{qFilter_12}, null)
                .select("contractId","rcvdepositnote","0.0 rcvdepositcash")
                .groupBy(new String[]{"contractId"}).sum("rcvdepositcash").sum("rcvdepositnote").finish();
        DataSet casRecbill = casRecbillNo.union(casRecbillYes)
                .groupBy(new String[]{"contractId"}).sum("rcvdepositcash").sum("rcvdepositnote").finish();
        return casRecbill;
    }

    /**
     * 9已申请额度 ——赊销/项目/框架
     * */
    private static DataSet leftApplyLimited(List mainIds_s, String mainBill, DataSet leftUnBanksInvoice) {
        DataSet dataSet = leftUnBanksInvoice;
        if ("XM".equals(mainBill) || "KJ".equals(mainBill)) {

            QFilter qFilter_1 = new QFilter("billstatus", QCP.equals, "C");
            if ("XM".equals(mainBill)) {
                //过滤单据状态 项目
                if (mainIds_s.size() <= 3000 & mainIds_s.size() > 0) {
                    qFilter_1.and(new QFilter("tpv_sourcebillid", QCP.in, mainIds_s));
                }
            } else if ("KJ".equals(mainBill)) {
                //过滤单据状态 框架
                if (mainIds_s.size() <= 3000 & mainIds_s.size() > 0) {
                    qFilter_1.and(new QFilter("tpv_sourcebillid", QCP.in, mainIds_s));
                }
            }
            DataSet tpv_pw_administrative = QueryServiceHelper.queryDataSet(algoKey, "tpv_pw_administrative",
                            "id saleIdb,tpv_sourcebillid contractId,tpv_endtime,tpv_projectmoney, (case when tpv_endtime >= now() then tpv_temporarylift else 0.0 end) tpv_temporarylift",
                            new QFilter[]{qFilter_1}, null)
                    .select("saleIdb", "contractId", "tpv_projectmoney + tpv_temporarylift projectmoney");
            dataSet = dataSet.leftJoin(tpv_pw_administrative).on("contractId", "contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId","contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt", "collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt", "totalcollectAmt",
                            "paymentbalance","unbanksinvoice","banksinvoice", "projectmoney creditlimit")
                    .finish();
            dataSet = RptUtil.zeroNullNums(dataSet);
            List<String> aliasList = RptUtil.getDataSetAliasList(dataSet);
            aliasList.add("creditlimit + paymentbalance cuscreditlimit");
            dataSet = dataSet.select(aliasList.toArray(new String[0]));
        }
        if ("Con".equals(mainBill)) {
            QFilter qFilter_2 = new QFilter("billstatus", QCP.equals, "C");
            qFilter_2.and(new QFilter("tpv_invalids",QCP.equals,true));
            DataSet tpv_crm_custmain = QueryServiceHelper.queryDataSet(algoKey, "tpv_crm_custmain",
                    "tpv_crm_cuslimit,tpv_crm_cuslimit.tpv_custom tpv_custom,'A' creditlimit",
                    new QFilter[]{qFilter_2}, null).groupBy(new String[]{"tpv_custom","creditlimit"}).finish();
            dataSet = dataSet.leftJoin(tpv_crm_custmain).on("customerId","tpv_custom")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                    "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                    "totalshipmentsAmt", "collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt", 
                    "totalcollectAmt","paymentbalance", "unbanksinvoice","banksinvoice","creditlimit").finish();
        }
        return dataSet;
    }

    /**
     * 6未到期商业承兑汇票  7含商业承兑票货款余额
     * */
    private static DataSet leftUnBanksInvoice(List<Long> contractIdList, String mainBill, DataSet leftReceiveAmt) {
        DataSet dataSet = leftReceiveAmt;
        if ("XM".equals(mainBill) || "KJ".equals(mainBill)) {
            //6未到期商业承兑汇票
            QFilter qFilter_1 = new QFilter("billstatus", QCP.equals, "D");
            if (contractIdList.size() > 0) {
                qFilter_1.and(new QFilter("entry.shkd_salecontract.id", QCP.in, contractIdList));
            }
            qFilter_1.and(new QFilter("settletype.number", QCP.equals, "JSFS06")); //【结算方式】的类型 = 商业承兑汇票
            qFilter_1.and(new QFilter("receivingtype.number", QCP.in, new String[]{"01"})); //【收款类型】=货款
            qFilter_1.and(new QFilter("shkd_draftbillexpireda", QCP.large_than, new Date())); //票据到期日 > 当前系统时间
            DataSet casRecbillYes = QueryServiceHelper.queryDataSet(algoKey, "cas_recbill",
                            "id billid,receivingtype.number receivingtypeNumber,entry,settletype.number settletypeNumber," +
                                    "shkd_rmbexrate,entry.shkd_salecontract.id contractId,entry.e_receivableamt * shkd_rmbexrate unbanksinvoice",
                            new QFilter[]{qFilter_1}, null)
                    .select("contractId","unbanksinvoice")
                    .groupBy(new String[]{"contractId"}).sum("unbanksinvoice").finish();
            dataSet = dataSet.leftJoin(casRecbillYes).on("contractNoId","contractId").select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId","contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt", "collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt", "totalcollectAmt",
                            "paymentbalance", "unbanksinvoice").finish();
        }
        if ("Con".equals(mainBill)) {
            //7含商业承兑汇票货款余额
            QFilter qFilter_2 = new QFilter("billstatus", QCP.equals, "D");
            if (contractIdList.size() > 0) {
                qFilter_2.and(new QFilter("entry.shkd_salecontract.id", QCP.in, contractIdList));
            }
            qFilter_2.and(new QFilter("settletype.number", QCP.equals, "JSFS06")); //【结算方式】的类型 = 商业承兑汇票
            qFilter_2.and(new QFilter("receivingtype.number", QCP.in, new String[]{"01"})); //【收款类型】=货款
            qFilter_2.and(new QFilter("shkd_draftbillexpireda", QCP.large_than, new Date())); //票据到期日 > 当前系统时间
            DataSet casRecbillYes = QueryServiceHelper.queryDataSet(algoKey, "cas_recbill",
                            "id billid,receivingtype.number receivingtypeNumber,entry,settletype.number settletypeNumber," +
                                    "shkd_rmbexrate,entry.shkd_salecontract.id contractId,entry.e_receivableamt * shkd_rmbexrate unbanksinvoice",
                            new QFilter[]{qFilter_2}, null)
                    .select("contractId","unbanksinvoice")
                    .groupBy(new String[]{"contractId"}).sum("unbanksinvoice").finish();
            dataSet = dataSet.leftJoin(casRecbillYes).on("contractId","contractId").select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                    "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow", "totalshipmentsAmt", "collectpledgedAmt",
                    "collectcash","collectnote","collecthightlow","collectrefundamt", "totalcollectAmt", "paymentbalance", "unbanksinvoice").finish();
        }
        dataSet = RptUtil.zeroNullNums(dataSet);
        dataSet = dataSet.addField("paymentbalance + unbanksinvoice banksinvoice","banksinvoice");
        return dataSet;
    }

    /**
     * 4已收货款【总计金额】 5货款余额
     * */
    private static DataSet leftReceiveAmt(DataSet leftshippingAmt, List<Long> contractIdList, String mainBill) {
        DataSet dataSet = leftshippingAmt;
        if ("XM".equals(mainBill) || "KJ".equals(mainBill)) {
            /**
             * 4.2现款总金额  4.3票据总金额
             * */
            DataSet casRecbill = getCasRecbillCollect(contractIdList);
            /**
             * 4.4未核销高低计单 -不含规划至保证金
             * */
            DataSet collecthightlow = getCollecthightlow(contractIdList);
            /**
             * 4.6退款总金额
             * */
            DataSet collectrefundamt = getCollectrefundamt(contractIdList);
            /**
             * 4.5质押货物金额
             * */
            QFilter qFilter_1 = new QFilter("billstatus", QCP.equals, "C");
            qFilter_1.and(new QFilter("tpv_stakepurpose", QCP.equals, "A"));
            if (contractIdList.size() > 0) {
                qFilter_1.and(new QFilter("tpv_salecontractno.id", QCP.in, contractIdList));
            }
            DataSet tpv_pledgereceipt = QueryServiceHelper.queryDataSet(algoKey, "tpv_pledgereceipt",
                    "id saleIda,tpv_salecontractno.id contractNoId,tpv_amount e_actamt1",
                    new QFilter[]{qFilter_1}, null);
            //4.5.1货物解押单
            DataSet tpv_pledgereceipt_1 = tpv_pledgereceipt.copy();
            List<Long> pledgerList = new ArrayList();
            for (Row row : tpv_pledgereceipt_1) {
                pledgerList.add(row.getLong("saleIda"));
            }
            QFilter qFilter_11 = new QFilter("billstatus", QCP.equals, "C");
            if (pledgerList.size() > 0) {
                qFilter_11.and(new QFilter("tpv_sourcebillid", QCP.in, pledgerList));
            }
            DataSet tpv_cargodecompression = QueryServiceHelper.queryDataSet(algoKey, "tpv_cargodecompression",
                    "tpv_sourcebillid saleIdb,tpv_amount e_actamt2",
                    new QFilter[]{qFilter_11}, null);

            DataSet pledgereceipt = tpv_pledgereceipt.leftJoin(tpv_cargodecompression).on("saleIda", "saleIdb")
                    .select("saleIda", "contractNoId", "e_actamt1-e_actamt2 collectpledgedAmt").finish()
                    .groupBy(new String[]{"contractNoId"})
                    .sum("collectpledgedAmt")
                    .finish();

            dataSet = leftshippingAmt.leftJoin(pledgereceipt).on("contractNoId", "contractNoId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId","contractNo","shippingAmt","invoicehightlow",
                            "totalshipmentsAmt", "collectpledgedAmt").finish();
            dataSet = dataSet.leftJoin(casRecbill).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt", "collectpledgedAmt","collectcash","collectnote").finish();
            dataSet = dataSet.leftJoin(collecthightlow).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt", "collectpledgedAmt","collectcash","collectnote","collecthightlow").finish();
            dataSet = dataSet.leftJoin(collectrefundamt).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt", "collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt").finish();
            dataSet = RptUtil.zeroNullNums(dataSet);
            dataSet = dataSet.select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                    "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo", "shippingAmt","invoicehightlow",
                    "totalshipmentsAmt", "collectpledgedAmt","collectcash","collectnote","collecthightlow","collectrefundamt",
                    "collectcash + collectnote + collecthightlow + collectrefundamt + collectpledgedAmt totalcollectAmt");
            /**
             * 5货款余额
             * */
            List<String> aliasList = RptUtil.getDataSetAliasList(dataSet);
            aliasList.add("totalcollectAmt - totalshipmentsAmt paymentbalance");
            dataSet = dataSet.select(aliasList.toArray(new String[0]));
        }
        if ("Con".equals(mainBill)) {
            /**
             * 4.2现款总金额  4.3票据总金额
             * */
            DataSet casRecbill = getCasRecbillCollect(contractIdList);
            /**
             * 4.4未核销高低计单 -不含规划至保证金
             * */
            DataSet collecthightlow = getCollecthightlow(contractIdList);
            /**
             * 4.6退款总金额
             * */
            DataSet collectrefundamt = getCollectrefundamt(contractIdList);
            /**
             * 4.5质押货物金额
             * */
            QFilter qFilter_2 = new QFilter("billstatus", QCP.equals, "C");
            qFilter_2.and(new QFilter("tpv_stakepurpose", QCP.equals, "A"));
            DataSet tpv_pledgereceipt = QueryServiceHelper.queryDataSet(algoKey, "tpv_pledgereceipt",
                    "tpv_salecontractno.id contractId,tpv_amount e_actamt1",
                    new QFilter[]{qFilter_2}, null);
            //4.5.1货物解押单
            DataSet tpv_pledgereceipt_1 = tpv_pledgereceipt.copy();
            List<Long> pledgerList = new ArrayList();
            for (Row row : tpv_pledgereceipt_1) {
                pledgerList.add(row.getLong("contractId"));
            }
            QFilter qFilter_21 = new QFilter("billstatus", QCP.equals, "C");
            if (pledgerList.size() > 0) {
                qFilter_21.and(new QFilter("tpv_salecontractno.id", QCP.in, pledgerList));
            }
            DataSet tpv_cargodecompression = QueryServiceHelper.queryDataSet(algoKey, "tpv_cargodecompression",
                    "tpv_salecontractno.id contractId,tpv_amount e_actamt2",
                    new QFilter[]{qFilter_21}, null);
            DataSet pledgereceipt = tpv_pledgereceipt.leftJoin(tpv_cargodecompression).on("contractId", "contractId")
                    .select("contractId", "e_actamt1","e_actamt2").finish();
            pledgereceipt = RptUtil.zeroNullNums(pledgereceipt);
            pledgereceipt = pledgereceipt.select("contractId","e_actamt1 - e_actamt2 collectpledgedAmt")
                    .groupBy(new String[]{"contractId"})
                    .sum("collectpledgedAmt")
                    .finish();
            dataSet = leftshippingAmt.leftJoin(pledgereceipt).on("contractId", "contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt", "collectpledgedAmt").finish();
            dataSet = dataSet.leftJoin(casRecbill).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt", "collectpledgedAmt", "collectcash","collectnote").finish();
            dataSet = dataSet.leftJoin(collecthightlow).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt", "collectpledgedAmt", "collectcash","collectnote","collecthightlow").finish();
            dataSet = dataSet.leftJoin(collectrefundamt).on("contractId","contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                            "totalshipmentsAmt", "collectpledgedAmt", "collectcash","collectnote","collecthightlow","collectrefundamt").finish();
            dataSet = RptUtil.zeroNullNums(dataSet);
            dataSet = dataSet.select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                    "customerId", "customerName", "contractNo", "shippingAmt","invoicehightlow",
                    "totalshipmentsAmt", "collectpledgedAmt", "collectcash","collectnote","collecthightlow","collectrefundamt",
                    "collectcash + collectnote + collecthightlow + collectrefundamt + collectpledgedAmt totalcollectAmt");
            /**
             * 5货款余额
             * */
            List<String> aliasList = RptUtil.getDataSetAliasList(dataSet);
            aliasList.add("totalcollectAmt - totalshipmentsAmt paymentbalance");
            dataSet = dataSet.select(aliasList.toArray(new String[0]));
        }

        return dataSet;
    }

    private static DataSet getCollectrefundamt(List<Long> contractIds) {
        //4.6退款总金额
        QFilter qFilter_1 = new QFilter("billstatus", QCP.in, new String[]{"B","C"});
        if (contractIds.size() > 0) {
            qFilter_1.and(new QFilter("shkd_payment_entry.shkd_salecontract.id", QCP.in, contractIds));
        }
        qFilter_1.and(new QFilter("shkd_e_paymenttype.number", QCP.in, new String[]{"0310","206"})); //付款类型：退回已收款的款项/退代收款
        DataSet paymentApplication = QueryServiceHelper.queryDataSet(algoKey, "shkd_payment_application",
                        "id billid,shkd_payment_entry,shkd_payment_entry.shkd_salecontract.id contractId,shkd_payment_entry.shkd_recid shkd_recid," +
                                "shkd_payment_entry.shkd_applyamount * shkd_exrate collectrefundamt",
                        new QFilter[]{qFilter_1}, null);
        DataSet copy = paymentApplication.copy();
        DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(copy);
        List<Long> ids = new ArrayList<>();
        for (DynamicObject dynamicObject : dynamicObjects) {
            if (!ids.contains(dynamicObject.getLong("shkd_recid"))) {
                ids.add(dynamicObject.getLong("shkd_recid"));
            }
        }
        //4.3收款单
        QFilter qFilter_12 = new QFilter("billstatus", QCP.not_equals, "A");
        if (ids.size() > 0) {
            qFilter_12.and(new QFilter("id", QCP.in, ids));
        }
        DataSet casRecbill = QueryServiceHelper.queryDataSet(algoKey, "cas_recbill",
                        "id billid,receivingtype.number receivingtypenumber", new QFilter[]{qFilter_12}, null);
        paymentApplication = paymentApplication.leftJoin(casRecbill).on("shkd_recid","billid")
                .select(RptUtil.getDataSetFiledAlias(paymentApplication), new String[]{"receivingtypenumber"}).finish();
        paymentApplication = paymentApplication.where("receivingtypenumber = '01'");
        paymentApplication = paymentApplication.groupBy(new String[]{"contractId"}).sum("collectrefundamt").finish();
        return paymentApplication;
    }

    private static DataSet getCollecthightlow(List<Long> contractIds) {
        //4.4已收货款的 未核销高低计单不含规划至保证金
        QFilter qFilter_1 = new QFilter("billstatus", QCP.equals, "C");
        if (contractIds.size() > 0) {
            qFilter_1.and(new QFilter("tpv_advconap.tpv_saleconums.id", QCP.in, contractIds));
        }
        qFilter_1.and(new QFilter("tpv_advconap.tpv_saleconums.id", QCP.large_than, 0));
        //高低计单
        DataSet hightlow = QueryServiceHelper.queryDataSet(algoKey, "tpv_cm_uneven",
                        "id billid,tpv_advconap,tpv_advconap.id entryid,tpv_advconap.tpv_saleconums.id contractId," +
                                "(case when tpv_unevened = 'A' then tpv_advconap.tpv_unwrittenqtys * tpv_exchangeratermb " +
                                "when tpv_unevened = 'B' then tpv_advconap.tpv_unwrittenqtys * (-1) * tpv_exchangeratermb else 0.0 end) collecthightlow"
                        , new QFilter[]{qFilter_1}, null)
                .select("contractId","collecthightlow")
                .groupBy(new String[]{"contractId"}).sum("collecthightlow").finish();
        QFilter qFilter_12 = new QFilter("billstatus", QCP.equals, "C");
        if (contractIds.size() > 0) {
            qFilter_12.and(new QFilter("tpv_settlement.tpv_saleconums.id", QCP.in, contractIds));
        }
        qFilter_12.and(new QFilter("tpv_settlement.tpv_saleconums.id", QCP.large_than, 0));
        qFilter_12.and(new QFilter("tpv_invalid", QCP.equals, false));
        //高低计规划单结算明细分录
        DataSet plannedbills_1 = QueryServiceHelper.queryDataSet(algoKey, "tpv_cm_plannedbills",
                        "id billid,tpv_settlement,tpv_settlement.id entryid,tpv_settlement.tpv_saleconums.id contractId," +
                                "tpv_settlement.tpv_plannedamt * tpv_settlement.tpv_entryratermb collecthightlow"
                        , new QFilter[]{qFilter_12}, null)
                .select("contractId","collecthightlow")
                .groupBy(new String[]{"contractId"}).sum("collecthightlow").finish();
        QFilter qFilter_13 = new QFilter("billstatus", QCP.equals, "C");
        if (contractIds.size() > 0) {
            qFilter_13.and(new QFilter("tpv_settlement.tpv_programme.tpv_contractnu.id", QCP.in, contractIds));
        }
        qFilter_13.and(new QFilter("tpv_settlement.tpv_programme.tpv_contractnu.id", QCP.large_than, 0));
        qFilter_13.and(new QFilter("tpv_settlement.tpv_programme.tpv_documenttype", QCP.equals, "A"));
        qFilter_13.and(new QFilter("tpv_invalid", QCP.equals, false));
        //高低计规划单规划明细子分录
        DataSet plannedbills_2 = QueryServiceHelper.queryDataSet(algoKey, "tpv_cm_plannedbills",
                        "id billid,tpv_settlement,tpv_settlement.id entryid,tpv_settlement.tpv_programme.id subentryid," +
                                "tpv_settlement.tpv_programme.tpv_contractnu.id contractId," +
                                "tpv_settlement.tpv_programme.tpv_amount * tpv_settlement.tpv_entryratermb collecthightlow"
                        , new QFilter[]{qFilter_13}, null)
                .select("contractId","collecthightlow")
                .groupBy(new String[]{"contractId"}).sum("collecthightlow").finish();
        DataSet collecthightlow = hightlow.union(plannedbills_1).union(plannedbills_2).groupBy(new String[]{"contractId"})
                .sum("collecthightlow").finish();
        return collecthightlow;
    }

    private static DataSet getCasRecbillCollect(List<Long> contractIds) {
        //4.2现款总金额
        QFilter qFilter_1 = new QFilter("billstatus", QCP.equals, "D");
        if (contractIds.size() > 0) {
            qFilter_1.and(new QFilter("entry.shkd_salecontract.id", QCP.in, contractIds));
        }
        qFilter_1.and(new QFilter("settletype.number", QCP.not_in, new String[]{"JSFS06","JSFS07"})); //【结算方式】的类型 ≠ 银行承兑汇票/商业承兑汇票
        qFilter_1.and(new QFilter("receivingtype.number", QCP.in, new String[]{"01"})); //【收款类型】=货款
        DataSet casRecbillNo = QueryServiceHelper.queryDataSet(algoKey, "cas_recbill",
                        "id billid,receivingtype.number receivingtypeNumber,entry,settletype.number settletypeNumber," +
                                "shkd_rmbexrate,entry.shkd_salecontract.id contractId,entry.e_receivableamt * shkd_rmbexrate collectcash",
                        new QFilter[]{qFilter_1}, null)
                .select("contractId","collectcash","0.0 collectnote")
                .groupBy(new String[]{"contractId"}).sum("collectcash").sum("collectnote").finish();
        //4.3票据总金额
        QFilter qFilter_12 = new QFilter("billstatus", QCP.equals, "D");
        if (contractIds.size() > 0) {
            qFilter_12.and(new QFilter("entry.shkd_salecontract.id", QCP.in, contractIds));
        }
        qFilter_12.and(new QFilter("settletype.number", QCP.in, new String[]{"JSFS06","JSFS07"})); //【结算方式】的类型 = 银行承兑汇票/商业承兑汇票
        qFilter_12.and(new QFilter("receivingtype.number", QCP.in, new String[]{"01"})); //【收款类型】=货款
        qFilter_12.and(new QFilter("shkd_draftbillexpireda", QCP.less_equals, new Date())); //票据到期日 <= 当前系统时间
        DataSet casRecbillYes = QueryServiceHelper.queryDataSet(algoKey, "cas_recbill",
                        "id billid,receivingtype.number receivingtypeNumber,entry,settletype.number settletypeNumber," +
                                "shkd_rmbexrate,entry.shkd_salecontract.id contractId,entry.e_receivableamt * shkd_rmbexrate collectnote",
                        new QFilter[]{qFilter_12}, null)
                .select("contractId","collectnote","0.0 collectcash")
                .groupBy(new String[]{"contractId"}).sum("collectcash").sum("collectnote").finish();
        DataSet casRecbill = casRecbillNo.union(casRecbillYes)
                .groupBy(new String[]{"contractId"}).sum("collectcash").sum("collectnote").finish();
        return casRecbill;
    }

    /**
     * 2发货总金额
     * */
    private static DataSet leftshippingAmt(DataSet dataSet1, List mainIds_s, String mainBill) {
        DataSet dataSet = dataSet1;
        /**
         * 框架建档 或者 项目建档
         * */
        if ("XM".equals(mainBill) || "KJ".equals(mainBill)) {
            /**
             * 2.2发货总金额
             * */
            QFilter qFilter_1 = new QFilter("billstatus", QCP.equals, "C");
            if (mainIds_s.size() <= 3000 & mainIds_s.size() > 0) {  //建档管理id【项目简称】
                qFilter_1.and(new QFilter("tpv_projectabrefs.id", QCP.in, mainIds_s)); //项目简称
            }
            //查询销售合同
            DataSet tpv_dt_salescontract = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salescontract",
                    "id contractNoId,tpv_contractnos contractNo,tpv_framebbrefs.id filingId,tpv_projectabrefs.id projectId", new QFilter[]{qFilter_1}, null);
            if ("XM".equals(mainBill)) {
                dataSet = dataSet.leftJoin(tpv_dt_salescontract).on("contractId", "projectId")
                        .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                                "customerId", "customerName", "tpv_projectabb", "contractNoId","contractNo").finish();
            }
            if ("KJ".equals(mainBill)) {
                dataSet = dataSet.leftJoin(tpv_dt_salescontract).on("contractId", "filingId")
                        .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                                "customerId", "customerName", "tpv_projectabb", "contractNoId","contractNo").finish();
            }
            //存放销售合同id集合
            QFilter qFilter_11 = new QFilter("billstatus", QCP.in, new String[]{"B","C"});
            List<Long> conIds_s = new ArrayList();
            //copy遍历，防止联查时迭代(关闭后再次遍历)报错
            DataSet tpv_dt_salescontract_1 = dataSet.copy();
            for (Row row : tpv_dt_salescontract_1) {
                if (YEM.isNotEmpty(row.getLong("contractNoId"))) {
                    if (!conIds_s.contains(row.getLong("contractNoId"))) {
                        conIds_s.add(row.getLong("contractNoId"));
                    }
                }
            }
            if (conIds_s.size() > 0) {  //销售合同id【销售合同号】
                qFilter_11.and(new QFilter("tpv_materialentry.tpv_cobillid", QCP.in, conIds_s));
            }
//            DataSet tpv_dt_salepricebill = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salepricebill",
//                    "id billid,tpv_contractnumber,tpv_materialentry,tpv_materialentry.tpv_cobillid contractNoId," +
//                            "tpv_materialentry.tpv_qty_final * tpv_materialentry.tpv_taxprice_final * tpv_exchangeratermb shippingAmt",
//                    new QFilter[]{qFilter_11}, null).groupBy(new String[]{"contractNoId"}).sum("shippingAmt").finish();
//            DataSet tpv_dt_salesshipping = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salesshipping",
//                    "id billid,tpv_contractnumber,tpv_materialentry,tpv_materialentry.tpv_cobillid contractNoId," +
//                            "(tpv_materialentry.tpv_qty - tpv_materialentry.tpv_confirmed - tpv_materialentry.tpv_cargobatchqty) * tpv_materialentry.tpv_taxprice * tpv_exchangeratermb shippingAmt",
//                    new QFilter[]{qFilter_11}, null).groupBy(new String[]{"contractNoId"}).sum("shippingAmt").finish();
//            DataSet union = tpv_dt_salepricebill.union(tpv_dt_salesshipping);
            DataSet tpv_dt_salesshipping = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salesshipping",
                    "id billid,tpv_contractnumber,tpv_materialentry,tpv_materialentry.tpv_cobillid contractNoId," +
                            "tpv_materialentry.tpv_qty tpv_qty, tpv_materialentry.tpv_invoiceqtyed tpv_invoiceqtyed," +
                            "tpv_materialentry.tpv_invoiceamted tpv_invoiceamted, tpv_materialentry.tpv_taxprice tpv_taxprice,tpv_exchangeratermb",
                    new QFilter[]{qFilter_11}, null);
            tpv_dt_salesshipping = RptUtil.zeroNullNums(tpv_dt_salesshipping);
            tpv_dt_salesshipping = tpv_dt_salesshipping.addField("((tpv_qty - tpv_invoiceqtyed) * tpv_taxprice) + tpv_invoiceamted shippingAmt", "shippingAmt");
            tpv_dt_salesshipping= tpv_dt_salesshipping.groupBy(new String[]{"contractNoId"}).sum("shippingAmt").finish();
            DataSet union = tpv_dt_salesshipping;
            dataSet = dataSet.leftJoin(union).on("contractNoId", "contractNoId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo", "shippingAmt").finish()
                    .groupBy(new String[]{"contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo"}).sum("shippingAmt").finish();

            /**
             *2.4开票核销高低计单
             */
            QFilter qFilter_12 = new QFilter("billstatus", QCP.in, new String[]{"B","C"});
            if (conIds_s.size() > 0) {  //销售合同id【销售合同号】
                qFilter_12.and(new QFilter("tpv_settledetail.tpv_salecontract.id", QCP.in, conIds_s));
            }
            qFilter_12.and(new QFilter("tpv_verificationtype", QCP.equals, "B"));
            DataSet tpvCmAltverification = QueryServiceHelper.queryDataSet(algoKey, "tpv_cm_altverification",
                            "id billid,tpv_verificationtype,tpv_settledetail,tpv_settledetail.tpv_salecontract contractNoId," +
                                    "tpv_settledetail.tpv_highorlow tpv_highorlow,tpv_settledetail.tpv_amounttax tpv_amounttax," +
                                    "tpv_settledetail.tpv_rmbrate tpv_rmbrate",
                            new QFilter[]{qFilter_12}, null)
                    .select("contractNoId", "(case when tpv_highorlow = 'B' then tpv_amounttax * tpv_rmbrate " +
                            "when tpv_highorlow = 'A' then ((-1) * tpv_amounttax * tpv_rmbrate) else 0.0 end) invoicehightlow")
                    .groupBy(new String[]{"contractNoId"}).sum("invoicehightlow").finish();
            dataSet = dataSet.leftJoin(tpvCmAltverification).on("contractNoId","contractNoId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "tpv_projectabb", "contractNoId", "contractNo", "shippingAmt",
                            "(case when invoicehightlow is not null then invoicehightlow else 0.0 end) invoicehightlow").finish();
            dataSet = dataSet.addField("shippingAmt + invoicehightlow totalshipmentsAmt", "totalshipmentsAmt");
        }
        /**
         * 销售合同
         * */
        if ("Con".equals(mainBill)) {
            /**
             * 2.2发货总金额
             * */
            QFilter qFilter_2 = new QFilter("billstatus", QCP.in, new String[]{"B","C"});
            if (mainIds_s.size() <= 3000 & mainIds_s.size() > 0) {  //销售合同id【销售合同号】
                qFilter_2.and(new QFilter("tpv_materialentry.tpv_cobillid", QCP.in, mainIds_s));
            }
//            DataSet tpv_dt_salepricebill = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salepricebill",
//                    "id billid,tpv_contractnumber,tpv_materialentry.tpv_cobillid contractId,tpv_materialentry," +
//                            "tpv_materialentry.tpv_qty_final * tpv_materialentry.tpv_taxprice_final shippingAmt",
//                    new QFilter[]{qFilter_2}, null).groupBy(new String[]{"contractId"}).sum("shippingAmt").finish();
//            DataSet tpv_dt_salesshipping = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salesshipping",
//                    "id billid,tpv_contractnumber,tpv_materialentry,tpv_materialentry.tpv_cobillid contractId," +
//                            "(tpv_materialentry.tpv_qty - tpv_materialentry.tpv_confirmed - tpv_materialentry.tpv_cargobatchqty) * tpv_materialentry.tpv_taxprice shippingAmt",
//                    new QFilter[]{qFilter_2}, null).groupBy(new String[]{"contractId"}).sum("shippingAmt").finish();
//            DataSet union = tpv_dt_salepricebill.union(tpv_dt_salesshipping);
            DataSet tpv_dt_salesshipping = QueryServiceHelper.queryDataSet(algoKey, "tpv_dt_salesshipping",
                    "id billid,tpv_contractnumber,tpv_materialentry,tpv_materialentry.tpv_cobillid contractId," +
                            "tpv_materialentry.tpv_qty tpv_qty, tpv_materialentry.tpv_invoiceqtyed tpv_invoiceqtyed," +
                            "tpv_materialentry.tpv_invoiceamted tpv_invoiceamted, tpv_materialentry.tpv_taxprice tpv_taxprice,tpv_exchangeratermb",
                    new QFilter[]{qFilter_2}, null);
            tpv_dt_salesshipping = RptUtil.zeroNullNums(tpv_dt_salesshipping);
            tpv_dt_salesshipping = tpv_dt_salesshipping.addField("((tpv_qty - tpv_invoiceqtyed) * tpv_taxprice) + tpv_invoiceamted shippingAmt", "shippingAmt");
            tpv_dt_salesshipping= tpv_dt_salesshipping.groupBy(new String[]{"contractId"}).sum("shippingAmt").finish();
            DataSet union = tpv_dt_salesshipping;
            dataSet = dataSet.leftJoin(union).on("contractId", "contractId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "contractNo", "shippingAmt").finish()
                    .groupBy(new String[]{"contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "contractNo",}).sum("shippingAmt").finish();

            /**
             *2.4开票核销高低计单
             */
            QFilter qFilter_12 = new QFilter("billstatus", QCP.in, new String[]{"B","C"});
            if (mainIds_s.size() <= 3000 & mainIds_s.size() > 0) {  //销售合同id【销售合同号】
                qFilter_2.and(new QFilter("tpv_settledetail.tpv_salecontract.id", QCP.in, mainIds_s));
            }
            qFilter_12.and(new QFilter("tpv_verificationtype", QCP.equals, "B"));
            DataSet tpvCmAltverification = QueryServiceHelper.queryDataSet(algoKey, "tpv_cm_altverification",
                            "id billid,tpv_verificationtype,tpv_settledetail,tpv_settledetail.tpv_salecontract contractNoId," +
                                    "tpv_settledetail.tpv_highorlow tpv_highorlow,tpv_settledetail.tpv_amounttax tpv_amounttax," +
                                    "tpv_settledetail.tpv_rmbrate tpv_rmbrate",
                            new QFilter[]{qFilter_12}, null)
                    .select("contractNoId", "(case when tpv_highorlow = 'B' then tpv_amounttax * tpv_rmbrate " +
                            "when tpv_highorlow = 'A' then ((-1) * tpv_amounttax * tpv_rmbrate) else 0.0 end) invoicehightlow")
                    .groupBy(new String[]{"contractNoId"}).sum("invoicehightlow").finish();
            dataSet = dataSet.leftJoin(tpvCmAltverification).on("contractId","contractNoId")
                    .select("contractId", "tpv_bizdate", "orgId", "orgName", "departmentId", "departmentName",
                            "customerId", "customerName", "contractNo", "shippingAmt",
                            "(case when invoicehightlow is not null then invoicehightlow else 0.0 end) invoicehightlow").finish();
            dataSet = dataSet.addField("shippingAmt + invoicehightlow totalshipmentsAmt", "totalshipmentsAmt");
        }
        return dataSet;
    }

    private static Map idByDeptORCusName(String desc) {
        QFilter filters = new QFilter("status", QCP.equals, "C");
        filters.and("enable", QCP.equals, "1");
        DynamicObject[] bdCustomers = BusinessDataServiceHelper.load("bd_customer", "id,name,number", new QFilter[]{filters});
        Map<Long, String> cusMap = new HashMap<>();
        Map<String, Long> cusNameMap = new HashMap<>();
        Arrays.stream(bdCustomers).filter(x -> bdCustomers != null).forEach(x -> {
            Long id = x.getLong("id");
            if (!cusMap.containsKey(id)) {
                String name = x.getString("name");
                cusMap.put(id, name);
                cusNameMap.put(name, id);
            }
        });
        DynamicObject[] bosAdminorgs = BusinessDataServiceHelper.load("bos_adminorg", "id,name,number", new QFilter[]{new QFilter("enable", QCP.equals, "1")});
        Map<Long, String> deptMap = new HashMap<>();
        Map<String, Long> deptNameMap = new HashMap<>();
        Arrays.stream(bosAdminorgs).filter(x -> bosAdminorgs != null).forEach(x -> {
            Long id = x.getLong("id");
            if (!deptMap.containsKey(id)) {
                String name = x.getString("name");
                deptMap.put(id, name);
                deptNameMap.put(name, id);
            }
        });
        if ("cusId".equals(desc)) return cusMap;
        if ("cusName".equals(desc)) return cusNameMap;
        if ("deptId".equals(desc)) return deptMap;
        if ("deptName".equals(desc))  return deptNameMap;
        return null;
    }
    private static Map<Long,Long> mapParentDeptIds(){
        Map<Long,Long> mapParentId = new HashMap<>();
        QFilter qFilter = new QFilter("enable", QCP.equals, "1");
        qFilter.and(new QFilter("orgpattern.number",QCP.equals,"OF-01"));
        DynamicObject[] bosAdminorgs = BusinessDataServiceHelper.load("bos_adminorg","id,structure,structure.viewparent", qFilter.toArray());
        if (bosAdminorgs.length > 0) {
            for (DynamicObject bosAdminorg : bosAdminorgs) {
                DynamicObjectCollection dynamicObjects = bosAdminorg.getDynamicObjectCollection("structure");
                if (dynamicObjects.size() > 0) {
                    for (DynamicObject dynamicObject : dynamicObjects) {
                        DynamicObject viewparent = dynamicObject.getDynamicObject("viewparent");
                        if (YEM.isNotEmpty(viewparent)) {
                            mapParentId.put(bosAdminorg.getLong("id"),viewparent.getLong("id"));
                        }
                    }
                }
            }
        }
        return mapParentId;
    }

    //获取凭证分录的核算维度销售合同号id和会计科目的编码
    private static DataSet voucherAcAssgrpByEntryId(QFilter qFilter,List<Long> contractIdList) {
        DataSet bos_flex_property = ORM.create().queryDataSet(algoKey,"bos_flex_property", "flexfield,valuesource", null);
        Map<String,Object>  valuesourceMap = new HashMap<>();
        for (Row row : bos_flex_property) {
            valuesourceMap.put(row.getString("flexfield"),row.getString("valuesource"));
        }
//        if (contractIdList.size() > 0) {
//            if (contractIdList.size() == 1) {
//                qFilter.and(new QFilter("entries.assgrp.value",QCP.like,"%" +contractIdList.get(0) + "%"));
//            }
//        }
        DataSet dataSet = ORM.create().queryDataSet(algoKey,"gl_voucher", "entries.id entriesid,entries.account.number accountnumber," +
                "entries.assgrp.value assgrpvalue,0l contractId,entries.creditlocal creditlocal", qFilter.toArray());//总账
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(dataSet);
        for (DynamicObject col : col_s) {
            String assgrpValue = col.getString("assgrpvalue");
            JSONObject jsonObject = JSONObject.parseObject(assgrpValue);
            if (null != jsonObject) {
                for (Map.Entry<String, Object> stringObjectEntry : jsonObject.entrySet()) {
                    if (valuesourceMap.size() > 0) {
                        String key = stringObjectEntry.getKey();
                        if (valuesourceMap.containsKey(key)) {
                            if ("tpv_bd_salescontract".equals(valuesourceMap.get(key))) {
                                col.set("contractId",stringObjectEntry.getValue());
                            }
                        }
                    }
                }
            }
        }

        RowMeta rowMeta = dataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        createDataSet = createDataSet.where("contractId > 0 and contractId is not null");
        dataSet = createDataSet.groupBy(new String[]{"contractId"}).sum("creditlocal").finish();
        return dataSet;
    }
}
