package tpv.tpv_wm.tpv_dt.java.api.entitys;


import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 农行链接贷开放接口实体类客户准入结果通知
 *
 * @author LiuHB
 * @version 1.0
 */
@ApiModel
public class AgriculAccessModel implements Serializable {

    @ApiParam(value = "产品编码", required = true)
    private String productId;

    @ApiParam(value = "商圈编码", required = false)
    private String busiGroupCode;

    @ApiParam(value = "核心企业组织机构代码", required = true)
    private String coreOrgCode;

    @ApiParam(value = "平台编码", required = true)
    private String sysCode;

    @ApiParam(value = "经销商农行编码", required = true)
    private String clientCode;

    @ApiParam(value = "经销商编码", required = true)
    private String srcId;

    @ApiParam(value = "经销商名称", required = true)
    private String entName;

    @ApiParam(value = "经销商社会信用代码证", required = true)
    private String orgCode;

    @ApiParam(value = "处理结果（状态）", required = true)
    private String code;

    @ApiParam(value = "描述信息（拒绝原因）", required = true)
    private String msg;

    @ApiParam(value = "准入生效日期", required = true)
    private String startDate;

    @ApiParam(value = "准入到期日", required = true)
    private String endDate;

    @ApiParam(value = "客户层级", required = true)
    private String grade;

    @ApiParam(value = "融资限额", required = true)
    private BigDecimal limitAmt;

    @ApiParam(value = "融资利率", required = true)
    private BigDecimal execRate;

    @ApiParam(value = "融资放款账户名称", required = true)
    private String recvName;

    @ApiParam(value = "融资放款账户号码", required = true)
    private String recvAcc;


    public String getProductId() {
        return productId;
    }

    public void setProductId(String productId) {
        this.productId = productId;
    }

    public String getBusiGroupCode() {
        return busiGroupCode;
    }

    public void setBusiGroupCode(String busiGroupCode) {
        this.busiGroupCode = busiGroupCode;
    }

    public String getCoreOrgCode() {
        return coreOrgCode;
    }

    public void setCoreOrgCode(String coreOrgCode) {
        this.coreOrgCode = coreOrgCode;
    }

    public String getSysCode() {
        return sysCode;
    }

    public void setSysCode(String sysCode) {
        this.sysCode = sysCode;
    }

    public String getClientCode() {
        return clientCode;
    }

    public void setClientCode(String clientCode) {
        this.clientCode = clientCode;
    }

    public String getSrcId() {
        return srcId;
    }

    public void setSrcId(String srcId) {
        this.srcId = srcId;
    }

    public String getEntName() {
        return entName;
    }

    public void setEntName(String entName) {
        this.entName = entName;
    }

    public String getOrgCode() {
        return orgCode;
    }

    public void setOrgCode(String orgCode) {
        this.orgCode = orgCode;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public String getStartDate() {
        return startDate;
    }

    public void setStartDate(String startDate) {
        this.startDate = startDate;
    }

    public String getEndDate() {
        return endDate;
    }

    public void setEndDate(String endDate) {
        this.endDate = endDate;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public BigDecimal getLimitAmt() {
        return limitAmt;
    }

    public void setLimitAmt(BigDecimal limitAmt) {
        this.limitAmt = limitAmt;
    }

    public BigDecimal getExecRate() {
        return execRate;
    }

    public void setExecRate(BigDecimal execRate) {
        this.execRate = execRate;
    }

    public String getRecvName() {
        return recvName;
    }

    public void setRecvName(String recvName) {
        this.recvName = recvName;
    }

    public String getRecvAcc() {
        return recvAcc;
    }

    public void setRecvAcc(String recvAcc) {
        this.recvAcc = recvAcc;
    }
}
