package tpv.tpv_wm.tpv_dt.java.api.entitys;


import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

/**
 * 农行链接贷开放接口实体类放款结果反馈
 *
 * @author LiuHB
 * @version 1.0
 */
@ApiModel
public class AgriculLoanModel implements Serializable {

    @ApiParam(value = "产品编码", required = true)
    private String productId;

    @ApiParam(value = "商圈编码", required = true)
    private String busiGroupCode;

    @ApiParam(value = "平台编码", required = true)
    private String sysCode;

    @ApiParam(value = "核心企业组织机构代码", required = true)
    private String coreOrgCOde;

    @ApiParam(value = "贷款申请编号（融资流水号）", required = true)
    private String loanApplyNo;

    @ApiParam(value = "外部融资申请编号", required = true)
    private String outApplyNo;

    @ApiParam(value = "放款状态", required = true)
    private String code;

    @ApiParam(value = "放款金额（本金）", required = true)
    private BigDecimal amount;

    @ApiParam(value = "起息日", required = true)
    private String startDate;

    @ApiParam(value = "到期日", required = true)
    private String loanEndDate;

    @ApiParam(value = "放款账号", required = true)
    private String recvAcc;
    @ApiParam(value = "融资利率（年化利率）", required = true)
    private BigDecimal execRate;
    @ApiParam(value = "融资利息", required = true)
    private BigDecimal interest;

    @ApiParam(value = "描述信息", required = true)
    private String msg;

    @ApiParam(value = "客户名称", required = true)
    private String entName;
    @ApiParam(value = "订单信息", required = true)
    private List<OrderModel> orderList;


    public String getProductId() {
        return productId;
    }

    public void setProductId(String productId) {
        this.productId = productId;
    }

    public String getBusiGroupCode() {
        return busiGroupCode;
    }

    public void setBusiGroupCode(String busiGroupCode) {
        this.busiGroupCode = busiGroupCode;
    }

    public String getSysCode() {
        return sysCode;
    }

    public void setSysCode(String sysCode) {
        this.sysCode = sysCode;
    }

    public String getCoreOrgCOde() {
        return coreOrgCOde;
    }

    public void setCoreOrgCOde(String coreOrgCOde) {
        this.coreOrgCOde = coreOrgCOde;
    }

    public String getLoanApplyNo() {
        return loanApplyNo;
    }

    public void setLoanApplyNo(String loanApplyNo) {
        this.loanApplyNo = loanApplyNo;
    }

    public String getOutApplyNo() {
        return outApplyNo;
    }

    public void setOutApplyNo(String outApplyNo) {
        this.outApplyNo = outApplyNo;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    public String getStartDate() {
        return startDate;
    }

    public void setStartDate(String startDate) {
        this.startDate = startDate;
    }

    public String getLoanEndDate() {
        return loanEndDate;
    }

    public void setLoanEndDate(String loanEndDate) {
        this.loanEndDate = loanEndDate;
    }

    public String getRecvAcc() {
        return recvAcc;
    }

    public void setRecvAcc(String recvAcc) {
        this.recvAcc = recvAcc;
    }

    public BigDecimal getExecRate() {
        return execRate;
    }

    public void setExecRate(BigDecimal execRate) {
        this.execRate = execRate;
    }

    public BigDecimal getInterest() {
        return interest;
    }

    public void setInterest(BigDecimal interest) {
        this.interest = interest;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public String getEntName() {
        return entName;
    }

    public void setEntName(String entName) {
        this.entName = entName;
    }

    public List<OrderModel> getOrderList() {
        return orderList;
    }

    public void setOrderList(List<OrderModel> orderList) {
        this.orderList = orderList;
    }
}
