package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;
import java.util.stream.Collectors;

/**
 * WangShuGuang
 * 动态回填
 */
public class AcceptbillEdit extends AbstractBillPlugIn {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("tpv_rawmessages");
    }

    @Override
    public void click(EventObject evt) {
        // TODO Auto-generated method stub
        super.click(evt);
        // 获取被点击的控件对象
        Control source = (Control) evt.getSource();
        if (StringUtils.equals(source.getKey(), "tpv_rawmessages")) {
            showInfoForm(this.getView());
        }
    }

    /**
     * 设置打开装柜信息动态表单
     */
    private void showInfoForm(IFormView view) {
        // 获取单据体
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        // 设置弹出页面的标识
        showParameter.setFormId("tpv_dt_acceptbilldtbd");
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_dt_material");
        showParameter.setCustomParam("tpv_dt_material", entity);
        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_rawmessages"));
        view.showForm(showParameter);
    }

    /**
     * @param e 回调，接收子页面传来的值。
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        switch (actionId) {
            case "tpv_rawmessages":
                DynamicObjectCollection data = (DynamicObjectCollection) returnData;
                setValue(data);
                break;
            default:
                break;
        }
    }

    private void setValue(DynamicObjectCollection data) {
        if (data != null) {
            List<String> name = new ArrayList<>();
            int lineNumber = 0;
            for (DynamicObject personinfor : data) {
                String string = personinfor.getString("tpv_commoditymaterial.name");
                name.add(string);
                int index = this.getModel().getEntryRowCount("tpv_materialentry");
                int lineRow = index - 1;
                lineNumber = lineRow;
            }
            if (name.size() == 1) {
                this.getModel().setValue("tpv_rawmessages", name, lineNumber);
            } else {
                this.getModel().setValue("tpv_rawmessages", name.stream().collect(Collectors.joining(",")), lineNumber);
            }
        }
    }
}