package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.events.ClosedCallBackEvent;

import java.math.BigDecimal;
import java.util.EventObject;
import java.util.Map;

/**
 * WangShuGuang
 * 验收单动态回填
 */
public class AcceptbillInforEdit extends AbstractBillPlugIn {
    /**
     * 获取到父页面传来的数据放入动态表单
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        Map<String, Object> map = this.getView().getFormShowParameter().getCustomParams();
        JSONArray tpv_personinfor = (JSONArray) map.get("tpv_dt_material");
        for (int i = 0; i < tpv_personinfor.size(); i++) {
            JSONObject parseObject = JSONObject.parseObject(JSONObject.toJSONString(tpv_personinfor.get(i)));
            int index = this.getModel().createNewEntryRow("tpv_entryentity");
            JSONObject tpv_commoditymaterial = parseObject.getJSONObject("tpv_commoditymaterial");
            if (tpv_commoditymaterial != null) {
                this.getModel().setValue("tpv_commoditymaterial", tpv_commoditymaterial.getLong("id"), index);
            }
            JSONObject tpv_commodityname = parseObject.getJSONObject("tpv_commodityname");
            if (tpv_commodityname != null) {
                this.getModel().setValue("tpv_commodityname", tpv_commodityname.getLong("id"), index);
            }
            JSONObject tpv_description = parseObject.getJSONObject("tpv_description");
            if (tpv_description != null) {
                this.getModel().setValue("tpv_description", tpv_description.getLong("id"), index);
            }
            JSONObject tpv_assist = parseObject.getJSONObject("tpv_assist");
            if (tpv_assist != null) {
                this.getModel().setValue("tpv_assist", parseObject.getString("tpv_assist"), index);
            }
            JSONObject tpv_measure = parseObject.getJSONObject("tpv_measure");
            if (tpv_measure != null) {
                this.getModel().setValue("tpv_measure", tpv_measure.getLong("id"), index);
            }
            JSONObject tpv_packaging = parseObject.getJSONObject("tpv_packaging");
            if (tpv_packaging != null) {
                this.getModel().setValue("tpv_packaging", tpv_packaging.getLong("id"), index);
            }
            String tpv_curly = parseObject.getString("tpv_curly");
            if (null != tpv_curly) {
                this.getModel().setValue("tpv_curly", parseObject.getString("tpv_curly"), index);
            }
            BigDecimal tpv_quantity = parseObject.getBigDecimal("tpv_quantity");
            if (tpv_quantity != null) {
                this.getModel().setValue("tpv_quantity", parseObject.getString("tpv_quantity"), index);
            }
            BigDecimal tpv_packagingbaseqty = parseObject.getBigDecimal("tpv_packagingbaseqty");
            if (tpv_packagingbaseqty != null) {
                this.getModel().setValue("tpv_packagingbaseqty", parseObject.getString("tpv_packagingbaseqty"), index);
            }
            BigDecimal tpv_univalence = parseObject.getBigDecimal("tpv_univalence");
            if (tpv_univalence != null) {
                this.getModel().setValue("tpv_univalence", parseObject.getString("tpv_univalence"), index);
            }
            BigDecimal tpv_money = parseObject.getBigDecimal("tpv_money");
            if (tpv_money != null) {
                this.getModel().setValue("tpv_money", parseObject.getString("tpv_money"), index);
            }
        }
    }

    /**
     * 注册按钮
     */
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok", "btncancel"});
    }

    @Override
    public void click(EventObject evt) {
        // TODO Auto-generated method stub
        super.click(evt);
        Map<String, Object> map = this.getView().getFormShowParameter().getCustomParams();
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok"://确认
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                EntryGrid tpvEntryentity = this.getControl("tpv_entryentity");
                int selectEows[] = tpvEntryentity.getSelectRows();
                DynamicObjectCollection dynamicObjects = this.getModel().getEntryEntity("tpv_entryentity");
                DynamicObjectCollection dynamicObjects1 = new DynamicObjectCollection();
                if (selectEows != null && selectEows.length > 0) {
                    for (int selectRow : selectEows) {
                        dynamicObjects1.add(dynamicObjects.get(selectRow));
                    }
                }
                /*
                DynamicObjectCollection dynamicObjects = dataEntity.getDynamicObjectCollection("tpv_entryentity");
                int row = this.getModel().getEntryCurrentRowIndex("tpv_entryentity");
                for (DynamicObject date : dynamicObjects) {
                    DynamicObject name= date.getDynamicObject(row+1);
                }*/
                this.getView().returnDataToParent(dynamicObjects1);
                this.getView().close();
                break;
            case "btncancel"://取消
                this.getView().close();
                break;
        }
    }

    /**
     * 回调，将数据返回父页面
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        switch (actionId) {
            case "tpv_rawmessages":
                DynamicObject data = (DynamicObject) returnData;
                setValue(data);
                break;
            default:
                break;
        }
    }

    /**
     * 将子页面拿到的值赋入
     */
    private void setValue(DynamicObject data) {
        if (data != null) {
            int rowIndex = this.getModel().getEntryCurrentRowIndex("tpv_dt_material");
            this.getModel().setValue("tpv_rawmessages", data.getString("tpv_commodityname"), rowIndex);
        }
    }
}
