package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.MessageTypes;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.plugin.AbstractFormPlugin;
import tpv.tpv_wm.tpv_cm.java.utils.CostDisposeRptUtils;

import java.math.BigDecimal;
import java.util.*;

/**
 * @Description: 退货成本选择-表单插件
 * @Author LinRui
 * @Date 2023/12/5 20:41
 */
public class CancelCostEdit extends AbstractFormPlugin {
    private static final String algoKey = CancelCostEdit.class.getName();
    private static final String entryKey = "tpv_entryentity";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok"});
        this.addItemClickListeners(new String[]{"tpv_advcontoolbarap"});
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        String entityId = this.getView().getParentView().getEntityId(); //单据标识
        if ("im_purinbill".equals(entityId)){
            FormShowParameter parameter = view.getFormShowParameter();
            BigDecimal tpvRedqty = BigDecimalUtils.toBigDecimal(parameter.getCustomParam("tpv_redqty")); //数量
            //Long tpvUnits = JSON.parseObject(JSON.toJSONString(parameter.getCustomParam("tpv_units")), Long.class);
            Long tpvUnits = toLong(parameter.getCustomParam("tpv_units"));
            model.setValue("tpv_mateqtysum", tpvRedqty);
            model.setValue("tpv_units", tpvUnits);
        }
        if ("tpv_cm_costadjustments".equals(entityId)) { //原本是共有一个弹框
//            this.getView().setVisible(false,"tpv_fieldsetpanelap"); //隐藏flex块
//            this.getView().setVisible(false,"tpv_checkrow"); //隐藏单据体列
//            Map<String,Object> map = new HashMap<>();
//            map.put("selchexkbox",true);
//            this.getView().updateControlMetadata(entryKey,map); //设置单据体选择列的显示隐藏
        }
        initData();
    }


    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String propertyName = e.getProperty().getName();
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        String entityId = this.getView().getParentView().getEntityId(); //单据标识
        if ("im_purinbill".equals(entityId)) {
            BigDecimal tpvMateqtysum = (BigDecimal) this.getModel().getValue("tpv_mateqtysum");
            BigDecimal tpvMateqtywait = (BigDecimal) this.getModel().getValue("tpv_mateqtywait");
            ChangeData[] changeSet = e.getChangeSet();
            int index = changeSet[0].getRowIndex();
            switch (propertyName) {
                case "tpv_checkrow":
                    Boolean tpvCheckrow = (Boolean) this.getModel().getValue("tpv_checkrow"); //复选框
                    if (tpvCheckrow) {
                        BigDecimal tpv_mateqty = (BigDecimal) model.getValue("tpv_adjustments");
                        if (tpv_mateqty.compareTo(BigDecimal.ZERO) == 0) {
                            BigDecimal tpv_mateqtyRow = tpvMateqtysum.subtract(tpvMateqtywait);
                            BigDecimal tpvRedqty = (BigDecimal) model.getValue("tpv_redqty", index);
                            if (tpv_mateqtyRow.compareTo(tpvRedqty) >= 0) {
                                model.setValue("tpv_adjustments", tpvRedqty, index);
                            } else {
                                model.setValue("tpv_adjustments", tpv_mateqtyRow, index);
                            }
                        }
                    } else {
                        model.setValue("tpv_adjustments", BigDecimal.ZERO, index);
                    }
                    break;
                case "tpv_adjustments":
                    BigDecimal tpv_mateqty = (BigDecimal) model.getValue("tpv_adjustments", index);
                    if (tpv_mateqty.compareTo(BigDecimal.ZERO) == 0) {
                        model.setValue("tpv_checkrow", false, index);
                    }
                    if (tpvMateqtysum.compareTo(tpvMateqtywait) < 0) {
                        BigDecimal oldValue = (BigDecimal) changeSet[0].getOldValue(); //记录值更新前的数据（旧数据）
                        view.showTipNotification("匹配数量合计不能大于待匹配数量");
                        model.setValue("tpv_adjustments", oldValue, index);
                    }
                    break;
            }
        }
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
                String entityId = this.getView().getParentView().getEntityId();
                if ("im_purinbill".equals(entityId)) {
                    purCancelCostOk();  //采购入库返回退货成本数据
                }
                if ("tpv_cm_costadjustments".equals(entityId)) {
                    adjustcancelCostok(); //成本调整返回明细数据
                }
                break;
            default:
                break;
        }
    }

    /**
     * 成本调整返回退货成本确认 通过校验并反写
     */
    private void adjustcancelCostok() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObjectCollection dataEntityss=new DynamicObjectCollection();
        List<String> indexRow = new ArrayList<>();
        //校验
        EntryGrid entry = view.getControl(entryKey);
        int selectRows[] = entry.getSelectRows();
        //获取单据体数据集合
        DynamicObjectCollection entity=this.getModel().getEntryEntity(entryKey);
        if(null != selectRows && selectRows.length > 0){
            for(int selectRow :selectRows){
                DynamicObject dynamicObject = entity.get(selectRow);  //获取选中行的单据体数据
                BigDecimal tpvRedqty = dynamicObject.getBigDecimal("tpv_redqty"); //可红冲数量
                BigDecimal tpvAdjustments = dynamicObject.getBigDecimal("tpv_adjustments"); //调整数量
                if (tpvAdjustments.compareTo(tpvRedqty) <= 0) {
                    dataEntityss.add(dynamicObject);
                } else {
                    indexRow.add(dynamicObject.getString("seq"));
                }
            }
            if (indexRow.size() > 0) {
                view.showTipNotification("第 "+String.join("、",indexRow)+" 行，调整数量大于可红冲数量，不允许回填数据！");
                return;
            }
        } else {
            view.showTipNotification("未选择数据。");
            return;
        }
        this.getView().returnDataToParent(dataEntityss);
        this.getView().close();
    }

    /**
     * 成本调整返回明细确认 通过校验并反写
     */
    private void purCancelCostOk() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        FormShowParameter parameter = view.getFormShowParameter();
        BigDecimal tpvRedqty = BigDecimalUtils.toBigDecimal(parameter.getCustomParam("tpv_redqty")); //数量
        BigDecimal tpvDocuqtyCeil = tpvRedqty.setScale(2, BigDecimal.ROUND_HALF_UP);
        DynamicObjectCollection entryEntity = model.getEntryEntity(entryKey);
        /**
         * 校验
         */
        BigDecimal sumQty = BigDecimal.ZERO;
        List<String> tips = new ArrayList<>();
        Map<Integer, DynamicObject> dynamicObjectList = new HashMap<>();
        boolean flagTo = false;
        for (DynamicObject row : entryEntity) {
            boolean tpvCheckrow = row.getBoolean("tpv_checkrow");
            if (tpvCheckrow) {
                flagTo = true;
                BigDecimal redqty = row.getBigDecimal("tpv_redqty"); //数量
                BigDecimal tpvMateqty = row.getBigDecimal("tpv_adjustments");// 匹配数量
                sumQty = sumQty.add(tpvMateqty);
                int seq = row.getInt("seq");
                if (tpvMateqty.compareTo(redqty) > 0) {
                    tips.add(String.format("第【%s】行，匹配数量大于当行可红冲数量。", seq));
                    continue;
                }
                if (tpvMateqty.compareTo(BigDecimal.ZERO) > 0) {
                    dynamicObjectList.put(row.getInt("seq"), row);
                }
                if (tpvMateqty.compareTo(tpvRedqty) > 0) {  //本行匹配数量不能大于选中销售发货的数量
                    tips.add(String.format("第【%s】行，本次红冲数量大于匹配数量。", seq));
                }
                if (tpvMateqty.compareTo(BigDecimal.ZERO) == 0) {  //本行匹配数量不能为0
                    tips.add(String.format("第【%s】行，本次红冲数量不能为空或值为0。", seq));
                }
            }
        }
        if (!flagTo) {
            this.getView().showTipNotification("至少选择分录中一行数据！");
            return;
        }
        if (entryEntity.size() != 0 && sumQty.compareTo(tpvRedqty) != 0) {
            tips.add("调整数量合计不等于匹配数量。调整数量合计必须等于" + tpvDocuqtyCeil + "");
        }
        if (tips.size() > 0) {
            String errMsg = "";
            int msgSeq = 1;
            for (String tip : tips) {
                errMsg += String.format("%s、%s%s", msgSeq++, tip, "\r\n");
            }
            view.showMessage("匹配数量有误，请检查。", errMsg, MessageTypes.Default);
            return;
        }
        /**
         * 回填携带数据
         */
        IFormView parentView = view.getParentView(); //父视图
        IDataModel parentModel = parentView.getModel(); //父模型
        int index = parentModel.getEntryCurrentRowIndex("billentry");  //获取选中行索引（传参携带）
        String tpv_pickbill_in = (String) parentModel.getValue("tpv_pickbill_in", index); //配货单据
        String tpv_billno_in = (String) parentModel.getValue("tpv_billno_in", index); //配货单号
        Long tpv_fid_in = toLong(parentModel.getValue("tpv_fid_in", index)); //采购单据ID
        Long tpv_fentryid_in = toLong(parentModel.getValue("tpv_fentryid_in", index)); //采购分录行ID
        Boolean flag = false;
        List<String> entrypriceBillno = new ArrayList<>();  //分录批次价格单号
        for (DynamicObject row : entryEntity) {
            if (row.getBigDecimal("tpv_adjustments").compareTo(BigDecimal.ZERO) > 0) {
                if (flag) {
                    parentModel.copyEntryRow("billentry", new int[]{index}, true);
                    int rowIndex = parentModel.getEntryRowCount("billentry") - 1;
                    parentModel.setValue("tpv_costdisposebillno", row.getString("tpv_billno"), rowIndex);  //选择成本处理单单据编号
                    parentModel.setValue("tpv_costdisposeentryid", row.getLong("tpv_id"), rowIndex);  //选择成本处理单来源单据id
                    parentModel.setValue("qty", row.getBigDecimal("tpv_adjustments"), rowIndex);  //本次可红冲数量
                    parentModel.setValue("priceandtax", row.getBigDecimal("tpv_origprice"), rowIndex);  //原币单价
                    parentModel.setValue("tpv_pickbill_in", tpv_pickbill_in, rowIndex);  //配货单据
                    parentModel.setValue("tpv_billno_in", tpv_billno_in, rowIndex);  //配货单号
                    parentModel.setValue("tpv_fid_in", tpv_fid_in, rowIndex);  //采购单据ID
                    parentModel.setValue("tpv_fentryid_in", tpv_fentryid_in, rowIndex);  //采购分录行ID
                    continue;
                }
                parentModel.setValue("tpv_costdisposebillno", row.getString("tpv_billno"), index);  //选择成本处理单单据编号
                parentModel.setValue("tpv_costdisposeentryid", row.getLong("tpv_id"), index);  //选择成本处理单来源单据id
                parentModel.setValue("qty", row.getBigDecimal("tpv_adjustments"), index);  //本次可红冲数量
                parentModel.setValue("priceandtax", row.getBigDecimal("tpv_origprice"), index);  //原币单价
                parentModel.setValue("tpv_pickbill_in", tpv_pickbill_in, index);  //配货单据
                parentModel.setValue("tpv_billno_in", tpv_billno_in, index);  //配货单号
                parentModel.setValue("tpv_fid_in", tpv_fid_in, index);  //采购单据ID
                parentModel.setValue("tpv_fentryid_in", tpv_fentryid_in, index);  //采购分录行ID
                flag = true;
            }
        }

        OperationResult saveOperate = parentView.invokeOperation("save", YEM.getOptionNoMsg());
        if (!saveOperate.isSuccess()) {
            view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
            return;
        }
        parentView.invokeOperation("refresh");
        view.sendFormAction(parentView);
        view.close();
    }

    /**
     * 加载商品分录批次选择后数据
     */
    private void initData() {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        FormShowParameter parameter = view.getFormShowParameter();
        String entityId = this.getView().getParentView().getEntityId(); //单据标识
        model.deleteEntryData(entryKey);
        String whereFilter = "1 = 1";
        if ("im_purinbill".equals(entityId)){
            whereFilter = String.format("%s and tpv_costdirec = '%s'", whereFilter, "A"); //成本方向: 入库
            whereFilter = String.format("%s and tpv_costype = %s", whereFilter, 1835686669391498240L); //成本类型: 货值
            int index = view.getParentView().getModel().getEntryCurrentRowIndex("billentry");
            long tpvSrcentryid = (long) view.getParentView().getModel().getValue("tpv_fentryid_in", index);
//            long tpvSrcentryid = toLong(parameter.getCustomParam("pkid")); //单据入库分录ID
            if (tpvSrcentryid > 0) {
                whereFilter = String.format("%s and tpv_storageid = '%s'", whereFilter, tpvSrcentryid);
            }
            String tpvTicketinventory = parameter.getCustomParam("tpv_ticketinventory");
            if ("A".equals(tpvTicketinventory)) {
                whereFilter = String.format("%s and tpv_tentauth = '%s'", whereFilter, "B"); //真实
            }
            if ("B".equals(tpvTicketinventory)) {
                whereFilter = String.format("%s and tpv_tentauth = '%s'", whereFilter, "A"); //暂估
            }
        }
        if ("tpv_cm_costadjustments".equals(entityId)){
            whereFilter = String.format("%s and tpv_tentauth = '%s'", whereFilter, "A"); //暂估
            String tpvAdjustvalue = parameter.getCustomParam("tpv_adjustvalue"); //调整货值类型
            String billtypenumber = parameter.getCustomParam("billtypenumber"); //调整货值类型
            if ("A".equals(tpvAdjustvalue) && "tpv_cm_costadjustments_HZ".equals(billtypenumber)) {
                whereFilter = String.format("%s and tpv_ispointpriceed = '%s'", whereFilter, "A"); //已点价为是
            }
        }

        DataSet dataSet = CostDisposeRptUtils.getCostdisposeredRedQtyData();
        if (YEM.isNotEmpty(whereFilter)) {
            dataSet = dataSet.where(whereFilter);
        }

        DynamicObjectType enrtyType = model.getEntryEntity(entryKey).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(dataSet);
        for (Row row : dataSet) {
            int index = model.createNewEntryRow(entryKey);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    static {

    }

    public Long toLong(Object longObj) {
        if (longObj == null) {
            return null;
        } else if (longObj instanceof Long) {
            return (Long) longObj;
        } else {
            return Long.valueOf(String.valueOf(longObj));
        }
    }

}
