package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.MessageTypes;
import kd.bos.form.control.Control;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * @Description: 货物批次选择-表单插件
 * @Author LinRui
 * @Date 2023/9/16 11:41
 */
public class CargobatchEdit extends AbstractFormPlugin {
    private static final String algoKey = CargobatchEdit.class.getName();
    private static final String entryKey = "tpv_entryentity";
    //查询字段
    private static List<String> fieldKeys_xsht = new ArrayList<>();// 销售合同
    private static List<String> fieldKeys_priceok = new ArrayList<>();// 销售价格确认单

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok"});
        this.addItemClickListeners(new String[]{"tpv_advcontoolbarap"});
    }


    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        FormShowParameter parameter = view.getFormShowParameter();
        BigDecimal tpvDocuqty = BigDecimalUtils.toBigDecimal(parameter.getCustomParam("tpv_qty")); //销售发货数量
        //Long tpvUnits = JSON.parseObject(JSON.toJSONString(parameter.getCustomParam("tpv_units")), Long.class);
        Long tpvUnits = toLong(parameter.getCustomParam("tpv_units"));
        model.setValue("tpv_mateqtysum", tpvDocuqty);
        model.setValue("tpv_units", tpvUnits);
        initData();
    }


    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String propertyName = e.getProperty().getName();
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        BigDecimal tpvMateqtysum = (BigDecimal) this.getModel().getValue("tpv_mateqtysum");
        BigDecimal tpvMateqtywait = (BigDecimal) this.getModel().getValue("tpv_mateqtywait");
        ChangeData[] changeSet = e.getChangeSet();
        int index = changeSet[0].getRowIndex();
        switch (propertyName) {
            case "tpv_checkrow":
                Boolean tpvCheckrow = (Boolean) this.getModel().getValue("tpv_checkrow");
                if (tpvCheckrow) {
                    BigDecimal tpv_mateqty = (BigDecimal) model.getValue("tpv_mateqty");
                    if (tpv_mateqty.compareTo(BigDecimal.ZERO) == 0) {
                        BigDecimal tpv_mateqtyRow = tpvMateqtysum.subtract(tpvMateqtywait);
                        BigDecimal tpvDocuqty = (BigDecimal) model.getValue("tpv_docuqty", index);
                        if (tpv_mateqtyRow.compareTo(tpvDocuqty) >= 0) {
                            model.setValue("tpv_mateqty", tpvDocuqty, index);
                        } else {
                            model.setValue("tpv_mateqty", tpv_mateqtyRow, index);
                        }
                    }
//                    else {
//                        BigDecimal tpv_mateqtyRow = tpvMateqtysum.subtract(tpvMateqtywait);
//                        tpv_mateqtyRow = tpv_mateqtyRow.add(tpv_mateqty);
//                        BigDecimal tpvDocuqty = (BigDecimal) model.getValue("tpv_docuqty", index);
//                        if (tpv_mateqtyRow.compareTo(tpvDocuqty) >= 0) {
//                            model.setValue("tpv_mateqty", tpvDocuqty, index);
//                        } else {
//                            model.setValue("tpv_mateqty", tpv_mateqtyRow, index);
//                        }
//                    }
                } else {
                    model.setValue("tpv_mateqty", BigDecimal.ZERO, index);
                }
                break;
            case "tpv_mateqty":
                BigDecimal tpv_mateqty = (BigDecimal) model.getValue("tpv_mateqty", index);
                if (tpv_mateqty.compareTo(BigDecimal.ZERO) == 0) {
                    model.setValue("tpv_checkrow", false, index);
                }
                if (tpvMateqtysum.compareTo(tpvMateqtywait) < 0) {
                    BigDecimal oldValue = (BigDecimal) changeSet[0].getOldValue(); //记录值更新前的数据（旧数据）
                    view.showTipNotification("匹配数量合计不能大于待匹配数量");
                    model.setValue("tpv_mateqty", oldValue, index);
                }
                break;
        }

    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
                cargobatchOk();
                break;
            default:
                break;
        }
    }

    /**
     * 货物批次确认 通过校验并反写
     */
    private void cargobatchOk() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        FormShowParameter parameter = view.getFormShowParameter();
        BigDecimal tpvDocuqty = BigDecimalUtils.toBigDecimal(parameter.getCustomParam("tpv_qty")); //销售发货数量
//        BigDecimal tpvDocuqtyCeil = BigDecimalUtils.ceil(tpvDocuqty.doubleValue(), 2);
        DynamicObjectCollection entryEntity = model.getEntryEntity(entryKey);
        /**
         * 校验
         */
        BigDecimal sumQty = BigDecimal.ZERO;
        List<String> tips = new ArrayList<>();
        Map<Integer, DynamicObject> dynamicObjectList = new HashMap<>();
        for (DynamicObject row : entryEntity) {
            String tpvDocument = row.getString("tpv_document"); //货物批次单据
            BigDecimal docuqty = row.getBigDecimal("tpv_docuqty"); //批次数量
            BigDecimal tpvMateqty = row.getBigDecimal("tpv_mateqty");// 匹配数量
            sumQty = sumQty.add(tpvMateqty);
            int seq = row.getInt("seq");
            if (tpvMateqty.compareTo(docuqty) > 0) {
                tips.add(String.format("第【%s】行，匹配数量大于当行批次数量。", seq));
                continue;
            }
            if (tpvMateqty.compareTo(BigDecimal.ZERO) > 0) {
                dynamicObjectList.put(row.getInt("seq"), row);
            }
            if (tpvMateqty.compareTo(tpvDocuqty) > 0) {  //本行匹配数量不能大于选中销售发货的数量
                tips.add(String.format("第【%s】行，匹配数量大于选中销售发货的数量。", seq));
            }
        }
        if (entryEntity.size() != 0 && sumQty.compareTo(tpvDocuqty) != 0) {
            tips.add("匹配总数量不等于销售数量。总数量合计必须等于" + tpvDocuqty + "");
        }
        if (tips.size() > 0) {
            String errMsg = "";
            int msgSeq = 1;
            for (String tip : tips) {
                errMsg += String.format("%s、%s%s", msgSeq++, tip, "\r\n");
            }
            view.showMessage("匹配数量有误，请检查。", errMsg, MessageTypes.Default);
            return;
        }
        /**
         * 销售发货反写
         */
        IFormView parentView = view.getParentView(); //父视图
        IDataModel parentModel = parentView.getModel(); //父模型
        int index = parentModel.getEntryCurrentRowIndex("tpv_materialentry");  //获取选中行索引（传参携带）
        Boolean flag = false;
        List<String> entrypriceBillno = new ArrayList<>();  //分录批次价格单号
        for (DynamicObject row : entryEntity) {
            if (row.getBigDecimal("tpv_mateqty").compareTo(BigDecimal.ZERO) > 0) {
                if (flag) {
                    parentModel.copyEntryRow("tpv_materialentry", new int[]{index}, true);
                    int rowIndex = parentModel.getEntryRowCount("tpv_materialentry") - 1;
                    parentModel.setValue("tpv_document", row.getString("tpv_document"), rowIndex);  //货物批次选择单据
                    parentModel.setValue("tpv_selectiondocu", row.getString("tpv_selectiondocu"), rowIndex);  //货物批次选择单据号
                    //parentModel.setValue("tpv_selectiondocuid", row.getLong("tpv_srcbillid"), rowIndex);  //货物批次选择单据ID
                    parentModel.setValue("tpv_qty", row.getBigDecimal("tpv_mateqty"), rowIndex);  //数量
                    parentModel.setValue("tpv_pickqty", row.getBigDecimal("tpv_mateqty"), rowIndex);  //待拣配数量
                    parentModel.setValue("tpv_taxprice", row.getBigDecimal("tpv_docuprice"), rowIndex);  //单价
                    if ("B".equals(row.getString("tpv_document"))) { //货物批次选择单据为销售价格确认单
                        parentModel.setValue("tpv_cargobatchqty", row.getBigDecimal("tpv_mateqty"), rowIndex);  //价格确认货物批次数量
                        entrypriceBillno.add(row.getString("tpv_selectiondocu"));
                    } else if ("A".equals(row.getString("tpv_document"))) {
                        parentModel.setValue("tpv_cargobatchqty", BigDecimal.ZERO, rowIndex);  //价格确认货物批次数量
                    }
                    continue;
                }
                parentModel.setValue("tpv_document", row.getString("tpv_document"), index);  //货物批次选择单据
                parentModel.setValue("tpv_selectiondocu", row.getString("tpv_selectiondocu"), index);  //货物批次选择单据号
                //parentModel.setValue("tpv_selectiondocuid", row.getLong("tpv_srcbillid"), index);  //货物批次选择单据ID
                parentModel.setValue("tpv_qty", row.getBigDecimal("tpv_mateqty"), index);  //数量
                parentModel.setValue("tpv_pickqty", row.getBigDecimal("tpv_mateqty"), index);  //待拣配数量
                parentModel.setValue("tpv_taxprice", row.getBigDecimal("tpv_docuprice"), index);  //单价
                if ("B".equals(row.getString("tpv_document"))) { //货物批次选择单据为销售价格确认单
                    parentModel.setValue("tpv_cargobatchqty", row.getBigDecimal("tpv_mateqty"), index);  //价格确认货物批次数量
                    entrypriceBillno.add(row.getString("tpv_selectiondocu"));
                } else if ("A".equals(row.getString("tpv_document"))) {
                    parentModel.setValue("tpv_cargobatchqty", BigDecimal.ZERO, index);  //价格确认货物批次数量
                }
                flag = true;
            }
        }

        DynamicObject dataEntity = parentModel.getDataEntity(true);
        OperationResult saveOperate = OperationServiceHelper.executeOperate("save", parentView.getEntityId(),
                new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());  //调用父视图界面的保存按钮校验【回填单据的界面】
        if (!saveOperate.isSuccess()) {
            view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
            return;
        }

        Map<String, Map<Long, BigDecimal>> salePriceBillMap = new HashMap<>(); //利用hashmap键不能重复，覆盖赋值

        DynamicObject[] saleShippPriceDatas = BusinessDataServiceHelper.load("tpv_dt_salesshipping",
                "id,billno,tpv_materialentry,tpv_materialentry.tpv_srcentryid,tpv_materialentry.tpv_cargobatchqty," +
                        "tpv_materialentry.tpv_selectiondocu,tpv_materialentry.tpv_coentryid",
                new QFilter[]{new QFilter("tpv_materialentry.tpv_selectiondocu", QCP.in, entrypriceBillno)});
        for (DynamicObject saleShippPriceData : saleShippPriceDatas) {
            DynamicObjectCollection tpvMaterialentry = saleShippPriceData.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject dynamicObject : tpvMaterialentry) {
                long tpvSrcentryid = dynamicObject.getLong("tpv_srcentryid");  //来源分录ID
                long tpvCoentryid = dynamicObject.getLong("tpv_coentryid");  //核心单分录ID
                BigDecimal tpvCargobatchqty = dynamicObject.getBigDecimal("tpv_cargobatchqty"); //价格确认货物批次数量
                String tpvSelectiondocu = dynamicObject.getString("tpv_selectiondocu");  //货物批次单号
                //long tpvSelectiondocuid = dynamicObject.getLong("tpv_selectiondocuid");  ////货物批次单据ID

                if (entrypriceBillno.contains(tpvSelectiondocu)) {
                    if (!salePriceBillMap.containsKey(tpvSelectiondocu)) {
                        Map<Long, BigDecimal> backPriceMap = new HashMap<>();
                        backPriceMap.put(tpvCoentryid, tpvCargobatchqty);
                        salePriceBillMap.put(tpvSelectiondocu, backPriceMap);
                    } else {
                        if (salePriceBillMap.containsKey(tpvSelectiondocu)) {
                            salePriceBillMap.entrySet().stream().forEach(x -> {
                                if (x.getKey().equals(tpvSelectiondocu)) {
                                    if (!x.getValue().containsKey(tpvCoentryid)) {
                                        x.getValue().put(tpvCoentryid, tpvCargobatchqty);
                                    } else {
                                        BigDecimal add = x.getValue().get(tpvCoentryid).add(tpvCargobatchqty);
                                        x.getValue().put(tpvCoentryid, add);
                                    }
                                }
                            });
                        }
                    }
                }
            }
        }

        Set<String> priceBillId = salePriceBillMap.keySet();
        DynamicObject[] tpvDtSalepricebills = BusinessDataServiceHelper.load("tpv_dt_salepricebill",
                "id,billno,tpv_materialentry,tpv_materialentry.tpv_srcentryid,tpv_materialentry.tpv_cargobatchqty",
                new QFilter[]{new QFilter("billno", QCP.in, priceBillId)});
        for (DynamicObject tpvDtSalepricebill : tpvDtSalepricebills) {
            DynamicObjectCollection tpvMaterialentry = tpvDtSalepricebill.getDynamicObjectCollection("tpv_materialentry");
            String billno = tpvDtSalepricebill.getString("billno");
            for (DynamicObject dynamicObject : tpvMaterialentry) {
                if (salePriceBillMap.containsKey(billno)) {
                    Long tpvSrcentryid = dynamicObject.getLong("tpv_srcentryid");
                    salePriceBillMap.get(billno).entrySet().stream().filter(x -> x.getKey() != null).forEach(x -> {
                        if (x.getKey().equals(tpvSrcentryid)) {
                            BigDecimal decimal = salePriceBillMap.get(billno).get(tpvSrcentryid);
                            dynamicObject.set("tpv_cargobatchqty", decimal);
                        }
                    });
                }
            }
        }
        SaveServiceHelper.save(tpvDtSalepricebills);
        parentView.invokeOperation("refresh");
        view.sendFormAction(parentView);
        view.close();
    }

    /**
     * 加载商品分录批次选择后数据
     */
    private void initData() {
        initAllFields();
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        FormShowParameter parameter = view.getFormShowParameter();
        Long tpvSrcentryid = toLong(parameter.getCustomParam("tpv_coentryid")); //核心单据分录ID
        String tpvDocument = parameter.getCustomParam("tpv_document"); //货物批次选择单据
        String tpvSelectiondocu = parameter.getCustomParam("tpv_selectiondocu"); //货物批次选择单据号
        BigDecimal tpvDocuqty = BigDecimalUtils.toBigDecimal(parameter.getCustomParam("tpv_qty"));// 数量
        BigDecimal tpvOverloadingrates = BigDecimalUtils.toBigDecimal(parameter.getCustomParam("tpv_overloadingrates")); //溢装率(%)
//        if ("A".equals(tpvDocument)) { //如果是货物批次单据销售合同，匹配数量不能大于数量*溢短装(%)/100+数量
//            tpvDocuqty = tpvDocuqty.multiply(tpvOverloadingrates).divide(new BigDecimal(100)).add(tpvDocuqty);
//        }
//        if ("B".equals(tpvDocument)) {
//            tpvDocuqty = BigDecimal.ZERO;
//        }
        model.deleteEntryData(entryKey);
        QFilter qFilter = new QFilter("billstatus", QCP.equals, "C");
        String whereFilter = "tpv_docuqty > 0";
        if (YEM.isNotEmpty(tpvSrcentryid)) {
            whereFilter = String.format("%s and tpv_srcentryid = %s", whereFilter, tpvSrcentryid);
        }
//        if (null != tpvSelectiondocu) {
//            whereFilter = String.format("%s and tpv_selectiondocu like '%%%s%%'", whereFilter, tpvSelectiondocu);
//        }

        DataSet salescontractEntity = ORM.create().queryDataSet(algoKey, "tpv_dt_salescontract", String.join(",", fieldKeys_xsht), qFilter.toArray(), null);
        DataSet salepriceEntity = ORM.create().queryDataSet(algoKey, "tpv_dt_salepricebill", String.join(",", fieldKeys_priceok), qFilter.toArray(), null);
        DataSet query = salescontractEntity.union(salepriceEntity);

        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(query);
        for (DynamicObject col : col_s) {
            String tpv_selectiondocu = col.getString("tpv_selectiondocu"); //货物批次选择单据号
            String tpv_document = col.getString("tpv_document"); //货物批次选择单据
            Long tpv_srcentryid = col.getLong("tpv_srcentryid");
            BigDecimal tpv_docuqty = col.getBigDecimal("tpv_docuqty"); //批次数量
            BigDecimal tpv_doumentbatchqty = col.getBigDecimal("tpv_doumentbatchqty"); //价格确认被关联发货数量
//            if ("A".equals(tpv_document)) {
//                BigDecimal tpvOverload = tpvOverloadingrates.divide(new BigDecimal(100));
//                tpv_docuqty = tpv_docuqty.multiply(tpvOverload).add(tpv_docuqty);
//            }

            if (tpvSelectiondocu.equals(tpv_selectiondocu) && tpvSrcentryid.equals(tpv_srcentryid)) {
                BigDecimal add = "B".equals(tpv_document) ?
                        tpv_docuqty.subtract(tpv_doumentbatchqty).add(tpvDocuqty) :
                        tpv_docuqty.add(tpv_doumentbatchqty).add(tpvDocuqty);
                col.set("tpv_docuqty", add);
            } else if ("".equals(tpvSelectiondocu) && tpvSrcentryid.equals(tpv_srcentryid)) {
                BigDecimal add = "B".equals(tpv_document) ? tpv_docuqty.subtract(tpv_doumentbatchqty) :
                        tpv_docuqty.add(tpv_doumentbatchqty).add(tpvDocuqty);
                col.set("tpv_docuqty", add);
            } else {
                BigDecimal add = "B".equals(tpv_document) ? tpv_docuqty.subtract(tpv_doumentbatchqty) :
                        tpv_docuqty.add(tpv_doumentbatchqty);
                col.set("tpv_docuqty", add);
            }
        }

        RowMeta rowMeta = query.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);

        if (YEM.isNotEmpty(whereFilter)) {
            createDataSet = createDataSet.where(whereFilter);
        }

        DynamicObjectType enrtyType = model.getEntryEntity(entryKey).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(createDataSet);
        for (Row row : createDataSet) {
            int index = model.createNewEntryRow(entryKey);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }

    }

    private static void initAllFields() {
        fieldKeys_xsht.clear();
        fieldKeys_priceok.clear();
        //fieldKey 为映射报表/动态表单分录字段标识  field_bill 为单据的标识
        addFields("tpv_srcbillid", "id");// 来源单据id
        addFields("tpv_srcentryid", "tpv_materialentry", "tpv_materialentry.tpv_srcentryid");// 来源单据分录id
        addFields("tpv_document", "'A'", "'B'");// 货物批次选择单据
        addFields("tpv_selectiondocu", "tpv_contractnos", "billno");// 货物批次选择单据号
        addFields("tpv_docuqty", "tpv_materialentry.tpv_effectivequantity"
                , "tpv_materialentry.tpv_qty_final");// 批次数量
        addFields("tpv_doumentbatchqty", "tpv_materialentry.tpv_iscargobatchqty-tpv_materialentry" +
                        ".tpv_conprice-tpv_materialentry.tpv_shippedquantity"
                , "tpv_materialentry.tpv_cargobatchqty");// 价格确认被关联发货数量
        addFields("tpv_docuprice", "tpv_materialentry.tpv_taxprice", "tpv_materialentry.tpv_taxprice_final");// 单价（含税）
        addFields("tpv_currency", "tpv_currency");// 币别
    }

    static {

    }

    //相同字段标识
    private static void addFields(String fieldKey, String fieldKey_bill) {
        fieldKeys_xsht.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_priceok.add(fieldKey_bill + " " + fieldKey);
    }

    // fieldKey_xsht 销售合同 和  fieldKey_priceok 销售价格确认单 字段
    private static void addFields(String fieldKey, String fieldKey_xsht, String fieldKey_priceok) {
        fieldKeys_xsht.add(fieldKey_xsht + " " + fieldKey);
        fieldKeys_priceok.add(fieldKey_priceok + " " + fieldKey);
    }

    public Long toLong(Object longObj) {
        if (longObj == null) {
            return null;
        } else if (longObj instanceof Long) {
            return (Long) longObj;
        } else {
            return Long.valueOf(String.valueOf(longObj));
        }
    }

}
