package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.math.BigDecimal;
import java.util.*;

/**
 * @Description: 冲销应收单号弹框 -表单插件
 * @Author LinRui
 * @date: 2024-05-27
 */
public class ChargeofffinarEdit extends AbstractFormPlugin {
    private static final String entry = "tpv_pactmessage";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        addClickListeners("btnok", "btncancel", "tpv_query");
    }

    /**
     * 动态表单打开  获取单据上的本次匹配金额等数据
     *
     * @param e
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = showParameter.getCustomParams();
        if (maps.size() > 0) {
            JSONObject tpv_costitem = maps.containsKey("tpv_costitem") ? (JSONObject) maps.get("tpv_costitem") : null;
            JSONObject tpv_wmcurrency = maps.containsKey("tpv_wmcurrency") ? (JSONObject) maps.get("tpv_wmcurrency") : null;
            JSONObject tpv_department = maps.containsKey("tpv_department") ? (JSONObject) maps.get("tpv_department") : null;
            if (null != tpv_costitem) this.getModel().setValue("tpv_expenseitems_f", tpv_costitem.getLong("id"));
            if (null != tpv_wmcurrency) this.getModel().setValue("tpv_current_f", tpv_wmcurrency.getLong("id"));
            if (null != tpv_department) this.getModel().setValue("tpv_department_f", tpv_department.getLong("id"));
        }
        initData(false);
    }

    /**
     * 按钮点击
     * @param evt
     */
    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control c = (Control) evt.getSource();
        String key = c.getKey().toLowerCase();
        switch (key) {
            case "btnok":
                returnEntryRowsData();
                break;
            case "btncancel":
                this.getView().close();
                break;
            case "tpv_query":
                IDataModel model = this.getModel();
                model.deleteEntryData(entry);
                initData(false);
                break;

        }
    }

    private void returnEntryRowsData() {
        IFormView view = this.getView();
//        IFormView parentView = this.getView().getParentView();
//        IDataModel parentModel = parentView.getModel();
//        parentModel.deleteEntryData(entry);
        DynamicObjectCollection collections = new DynamicObjectCollection();
        HashMap<String, DynamicObjectCollection> collectionHashMap = new HashMap<>();
        EntryGrid entryGrid = (EntryGrid) this.getView().getControl(entry);
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length > 0) {
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = this.getModel().getEntryRowEntity(entry, selectRow);
                collections.add(dynamicObject);
            }
            collectionHashMap.put("cols", collections);
        }
        if (collections.size() > 0) {
            view.returnDataToParent(collectionHashMap);
//                view.sendFormAction(parentView);
            view.close();
        } else {
            view.showTipNotification("未选择行数据！");
        }
    }

    /**
     * 初始化数据
     *
     * @param flag
     */
    private void initData(boolean flag) {
        IFormView view = this.getView();
        IDataModel model = view.getModel();
        ArrayList<QFilter> filters = new ArrayList<>();
        filters.add(new QFilter("billstatus", QCP.not_equals, "A"));//不为暂存
        DynamicObject tpv_department_f = (DynamicObject) model.getValue("tpv_department_f");//部门
        DynamicObject tpv_salesconnum_f = (DynamicObject) model.getValue("tpv_salesconnum_f");//销售合同号
        DynamicObject tpv_expenseitems_f = (DynamicObject) model.getValue("tpv_expenseitems_f");//费用项目
        DynamicObject tpv_current_f = (DynamicObject) model.getValue("tpv_current_f");//币别
        boolean tpv_chargeoffamt_f = (Boolean) model.getValue("tpv_chargeoffamt_f");//冲销金额为0不显示
        if (YEM.isNotEmpty(tpv_department_f)) {
            filters.add(new QFilter("shkd_saleentryentity.shkd_edept.id", QCP.equals, tpv_department_f.getLong("id")));
        }
        if (YEM.isNotEmpty(tpv_salesconnum_f)) {
            filters.add(new QFilter("shkd_saleentryentity.shkd_salecontracte.id", QCP.equals, tpv_salesconnum_f.getLong("id")));
        }
        if (YEM.isNotEmpty(tpv_expenseitems_f)) {
            String number = tpv_expenseitems_f.getString("number");
            if (YEM.isNotEmpty(tpv_current_f)) {
                if ("FYXM150.1142".equals(number)) {
                    filters.add(new QFilter("shkd_saleentryentity.shkd_fcurrency1", QCP.equals, tpv_current_f.getLong("id")));
                }
                if ("FYXM150.1152".equals(number)) {
                    filters.add(new QFilter("shkd_saleentryentity.shkd_fcurrency2", QCP.equals, tpv_current_f.getLong("id")));
                }
                if ("FYXM150.1220".equals(number)) {
                    filters.add(new QFilter("shkd_saleentryentity.shkd_fcurrency5", QCP.equals, tpv_current_f.getLong("id")));
                }
            }
            if (tpv_chargeoffamt_f) {
                if ("FYXM150.1142".equals(number)) {
                    filters.add(new QFilter("shkd_saleentryentity.shkd_freightnotfee", QCP.large_than, BigDecimal.ZERO));
                }
                if ("FYXM150.1152".equals(number)) {
                    filters.add(new QFilter("shkd_saleentryentity.shkd_insurancenotfee", QCP.large_than, BigDecimal.ZERO));
                }
                if ("FYXM150.1220".equals(number)) {
                    filters.add(new QFilter("shkd_saleentryentity.shkd_commissionnotfee", QCP.large_than, BigDecimal.ZERO));
                }
            }
        }
        DataSet dataSet = ORM.create().queryDataSet(this.getClass().getName(), "ar_finarbill",
                "id tpv_finarbillid1,billno tpv_finarbillno1,billstatus,bizdate tpv_finarbilldate1,asstact.id tpv_finarcustomer1," +
                        "shkd_saleentryentity,shkd_saleentryentity.id tpv_finarbillentryid1,null tpv_costitem1," +
                        "shkd_saleentryentity.shkd_salecontracte tpv_saleconum1,shkd_saleentryentity.shkd_buycontract tpv_purconum1," +
                        "shkd_saleentryentity.shkd_fcurrency1 freightnotcurr,shkd_saleentryentity.shkd_freightnotfee shkd_freightnotfee," +
                        "shkd_saleentryentity.shkd_internalshiprate internalshiprate," +
                        "shkd_saleentryentity.shkd_fcurrency2 insurancenotcurr,shkd_saleentryentity.shkd_insurancenotfee shkd_insurancenotfee," +
                        "shkd_saleentryentity.shkd_internalpremrate internalpremrate," +
                        "shkd_saleentryentity.shkd_fcurrency5 commissionnotcurr,shkd_saleentryentity.shkd_commissionnotfee shkd_commissionnotfee," +
                        "shkd_saleentryentity.shkd_commissionrate ccommissionrate"
                , filters.toArray(new QFilter[0]));
        if (YEM.isNotEmpty(tpv_expenseitems_f)) {
            String number = tpv_expenseitems_f.getString("number");
            if ("FYXM150.1142".equals(number)) {
                dataSet = dataSet.addField("freightnotcurr tpv_finarbillcurr1", "tpv_finarbillcurr1");
                dataSet = dataSet.addField("shkd_freightnotfee tpv_writtenoffamt1", "tpv_writtenoffamt1");
                dataSet = dataSet.addField("internalshiprate tpv_finarbillrmbrate1", "tpv_finarbillrmbrate1");
            }
            if ("FYXM150.1152".equals(number)) {
                dataSet = dataSet.addField("insurancenotcurr tpv_finarbillcurr1", "tpv_finarbillcurr1");
                dataSet = dataSet.addField("shkd_insurancenotfee tpv_writtenoffamt1", "tpv_writtenoffamt1");
                dataSet = dataSet.addField("internalpremrate tpv_finarbillrmbrate1", "tpv_finarbillrmbrate1");
            }
            if ("FYXM150.1220".equals(number)) {
                dataSet = dataSet.addField("commissionnotcurr tpv_finarbillcurr1", "tpv_finarbillcurr1");
                dataSet = dataSet.addField("shkd_commissionnotfee tpv_writtenoffamt1", "tpv_writtenoffamt1");
                dataSet = dataSet.addField("ccommissionrate tpv_finarbillrmbrate1", "tpv_finarbillrmbrate1");
            } else {
                dataSet = dataSet.addField("null tpv_finarbillcurr1", "tpv_finarbillcurr1");
                dataSet = dataSet.addField("0.0 tpv_writtenoffamt1", "tpv_writtenoffamt1");
                dataSet = dataSet.addField("0.0 tpv_finarbillrmbrate1", "tpv_finarbillrmbrate1");
            }
        } else {
            dataSet = dataSet.addField("null tpv_finarbillcurr1", "tpv_finarbillcurr1");
            dataSet = dataSet.addField("0.0 tpv_writtenoffamt1", "tpv_writtenoffamt1");
            dataSet = dataSet.addField("0.0 tpv_finarbillrmbrate1", "tpv_finarbillrmbrate1");
        }
        setInvoiceData(dataSet);
    }

    /**
     * @Title: setInvoiceData
     * @Description: 分录填充数据
     */
    private void setInvoiceData(DataSet dataSet) {
        IDataModel model = this.getModel();
        DynamicObject tpv_expenseitems_f = (DynamicObject) model.getValue("tpv_expenseitems_f");//费用项目
        model.deleteEntryData(entry);   //清除分录
        DynamicObjectType enrtyType = model.getEntryEntity(entry).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(dataSet);
        for (Row row : dataSet) {
            int index = model.createNewEntryRow(entry);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
        DynamicObjectCollection dynamicObjectCollection = this.getView().getModel().getDataEntity(true).getDynamicObjectCollection(entry);
        for (DynamicObject dynamicObject : dynamicObjectCollection) {
            dynamicObject.set("tpv_costitem1", tpv_expenseitems_f);
        }
        this.getView().updateView(entry);
    }
}
