package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.*;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.property.ComboProp;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.form.operate.botp.Push;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import org.apache.commons.lang3.StringUtils;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @ClassName CirculationGoodEdit
 * @Description 查询货物流转工作台信息
 * @Author yhj
 * @Date 2023/8/25 15:59
 * @Version 1.0
 */
public class CirculationGoodEdit1 extends AbstractFormPlugin implements HyperLinkClickListener {
    private static final String algoKey = CirculationGoodEdit.class.getName();
    private static List<String> fieldKeys_order = new ArrayList<>();// 采购合同
    private static List<String> fieldKeys_hwlz = new ArrayList<>();// 货物流转
    //设置全局静态变量
    private static final String STATEMENWORKENTITY = "tpv_circulationgoodentity";

    /**
     * @description: 设置监听按钮
     * @author yhj
     * @date 2023/9/4 10:51
     * @version 1.0
     */
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        // 侦听文本字段按钮点击事件
        this.addClickListeners("tpv_freigroambill");//货物流转单
        this.addClickListeners("tpv_purinbill");//入库单
        this.addClickListeners("tpv_transdirbill");//直接入库
        this.addClickListeners("tpv_query");//查询
        this.addClickListeners("tpv_enterkouqi");//入库齐
        this.addClickListeners("tpv_abolishenterkouqi");//取消入库齐
        this.addClickListeners("tpv_cargostatusbtn");//货权齐
        this.addClickListeners("tpv_nocargostatusbtn");//反货权齐
        EntryGrid entryGrid = this.getView().getControl("tpv_circulationgoodentity");
        entryGrid.addHyperClickListener(this);
    }

    /**
     * @description: 点击按钮下推
     * @author yhj
     * @date 2023/9/4 10:51
     * @version 1.0
     */
    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control source = (Control) evt.getSource();
        if (StringUtils.equals("tpv_query", source.getKey())) { //查询
            this.getModel().deleteEntryData("tpv_circulationgoodentity");
            circulation();//货物流转
            purchaseContract();//采购合同
            //extracted();//按日期排序
            return;
        }
        
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        QFilter[] qFilter = new QFilter[]{new QFilter("billstatus", QCP.equals, "C"), new QFilter("billno", QCP.equals, this.getModel().getValue("tpv_transfernumber"))};
        String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_freigroambill", "tpv_materialentry");
        DynamicObject[] queryHW = BusinessDataServiceHelper.load("tpv_dt_freigroambill", selectfieldsFast, qFilter);
        QFilter[] qFilters = new QFilter[]{new QFilter("billstatus", QCP.equals, "C"), new QFilter("tpv_contractnumber", QCP.equals, this.getModel().getValue("tpv_contractno"))};
        String selectfields = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_purchase", "tpv_materialentry");
        DynamicObject[] queryHT = BusinessDataServiceHelper.load("tpv_dt_purchase", selectfields, qFilters);
        QFilter[] qFilteres = new QFilter[]{new QFilter("billstatus", QCP.equals, "C"), new QFilter("billno", QCP.equals, this.getModel().getValue("tpv_sourcebillno"))};
        String selectfieldes = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_purchase", "tpv_materialentry");
        DynamicObject[] queryHTs = BusinessDataServiceHelper.load("tpv_dt_purchase", selectfieldes, qFilteres);
        QFilter[] qFilterese = new QFilter[]{new QFilter("billstatus", QCP.equals, "C"), new QFilter("tpv_contract", QCP.equals, this.getModel().getValue("tpv_sourcebillid"))};
        String selectfieldesr = DynamicObjectUtil.getSelectfieldsFast("im_purinbill", "billentry");
        DynamicObject[] queryRK = BusinessDataServiceHelper.load("im_purinbill", selectfieldesr, qFilterese);
        DynamicObject value = (DynamicObject) model.getValue("tpv_sourcebillkey");
        DynamicObject values = (DynamicObject) model.getValue("tpv_sourcebillkey");
        String tpvBillstatus = (String) model.getValue("tpv_billstatus");
        EntryGrid entry = view.getControl(STATEMENWORKENTITY);
        DynamicObjectCollection entity = this.getModel().getEntryEntity(STATEMENWORKENTITY);
        int selectRows[] = entry.getSelectRows();
        Boolean flag = true;
        Map<Long, DynamicObject> mapAs = new HashMap<>();
        Map<Long, DynamicObject> mapFlag = new HashMap<>();
        if (null != selectRows && selectRows.length > 0) {
            Boolean cargostatusFlag = false;
            List<String> purConList = new ArrayList<>();
            List<String> seqDes = new ArrayList<>();
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = entity.get(selectRow);
                mapAs.put(Long.valueOf(selectRow), dynamicObject);
                String tpvContractno = dynamicObject.getString("tpv_contractno");
                String tpvCargostatus = dynamicObject.getString("tpv_cargostatus");
                if (YEM.isNotEmpty(tpvCargostatus) && !"A".equals(tpvCargostatus)) {
                    int seqRow = selectRow + 1;
                    seqDes.add(String.valueOf(seqRow));
                    cargostatusFlag = true;
                }
                purConList.add(tpvContractno);
            }
            if (StringUtils.equals("tpv_cargostatusbtn", source.getKey())) {
                if (!cargostatusFlag) {
                    purConList = purConList.stream().distinct().collect(Collectors.toList());
                    if (purConList.size() > 0) {
                        DynamicObject[] dataSetPurCon = BusinessDataServiceHelper.load("tpv_dt_purchase", "id,tpv_contractnumber,tpv_cargostatus",
                                new QFilter[]{new QFilter("tpv_contractnumber", QCP.in, purConList)});
                        for (DynamicObject dynamicObject : dataSetPurCon) {
                            dynamicObject.set("tpv_cargostatus", "B");
                        }
                        SaveServiceHelper.save(dataSetPurCon);
                        view.showSuccessNotification("修改成功！");
                        for (int i = 0; i < selectRows.length; i++) {
                            this.getModel().setValue("tpv_cargostatus","B",i);
                        }
//                        this.getView().updateView("tpv_circulationgoodentity"); //不生效，试着用这个刷新，或者清除分录重新查库赋值
                    }
                } else {
                    view.showTipNotification("选中行，第 " + String.join(",", seqDes) + " 行，货物状态不为空，请重新选择！");
                    return;
                }
            }
            if (StringUtils.equals("tpv_nocargostatusbtn", source.getKey())) {
                purConList = purConList.stream().distinct().collect(Collectors.toList());
                if (purConList.size() > 0) {
                    DynamicObject[] dataSetPurCon = BusinessDataServiceHelper.load( "tpv_dt_purchase", "id,tpv_contractnumber,tpv_cargostatus",
                            new QFilter[]{new QFilter("tpv_contractnumber", QCP.in, purConList)});
                    for (DynamicObject dynamicObject : dataSetPurCon) {
                        dynamicObject.set("tpv_cargostatus","A");
                    }
                    SaveServiceHelper.save(dataSetPurCon);
                    view.showSuccessNotification("修改成功！");
                    for (int i = 0; i < selectRows.length; i++) {
                        this.getModel().setValue("tpv_cargostatus","A",i);
                    }
//                    this.getView().updateView("tpv_circulationgoodentity"); //不生效，试着用这个刷新，或者清除分录重新查库赋值
                }
            }

        } else {
            view.showTipNotification("未选择数据。");
            return;
        }
        if (null != mapAs && mapAs.size() > 0) {
            for (Map.Entry<Long, DynamicObject> dynamicObjects : mapAs.entrySet()) {
                DynamicObject dynamicObject1 = dynamicObjects.getValue();
                DynamicObject tpvOrg = dynamicObject1.getDynamicObject("tpv_sourcebillkey");
                String tpvDepartment = dynamicObject1.getString("tpv_contractno");
                String tpvDelivery = dynamicObject1.getString("tpv_delivery");
                if (null == mapFlag || mapFlag.size() == 0) {
                    mapFlag.put(dynamicObjects.getKey(), dynamicObjects.getValue());
                } else {
                    if (null != mapFlag && mapFlag.size() > 0) {
                        for (Map.Entry<Long, DynamicObject> object : mapFlag.entrySet()) {
                            DynamicObject object1 = object.getValue();
                            DynamicObject tpvOrg2 = object1.getDynamicObject("tpv_sourcebillkey");
                            String tpvDepartment2 = object1.getString("tpv_contractno");
                            String tpvDelivery2 = object1.getString("tpv_delivery");
                            if ((!tpvDepartment.equals(tpvDepartment2) && tpvOrg.equals(tpvOrg2)) || (!tpvOrg.equals(tpvOrg2)) || (!tpvDelivery.equals(tpvDelivery2))){
                                flag = false;
                            }
                        }
                    }
                }
            }
        }
        if (flag) {
            if (value != null || values != null) {
                String number = value.getString("number");
                String numbers = values.getString("number");
                if (StringUtils.equals("tpv_purinbill", source.getKey())) {
                    if (!"C".equals(tpvBillstatus)) {
                        view.showTipNotification("请选择单据状态为“已审核”的数据！");
                        return;
                    }
                    if (!number.equals("tpv_dt_freigroambill")) {
                        view.showTipNotification("请选择源单据为货物流转的数据！");
                        return;
                    }
                }
                if (StringUtils.equals("tpv_transdirbill", source.getKey())) {
                    if (!"C".equals(tpvBillstatus)) {
                        view.showTipNotification("请选择单据状态为“已审核”的数据！");
                        return;
                    }
                    if (!number.equals("tpv_dt_purchase")) {
                        view.showTipNotification("请选择源单据为采购合同的数据！");
                        return;
                    }
                }
                if (StringUtils.equals("tpv_freigroambill", source.getKey())) {
                    if (!"C".equals(tpvBillstatus)) {
                        view.showTipNotification("请选择单据状态为“已审核”的数据！");
                        return;
                    }
                }
                String tpvContractno = (String) model.getValue("tpv_contractno");
                String tpvDelivery = (String) model.getValue("tpv_delivery");
                BigDecimal sumQty = BigDecimal.ZERO;
                BigDecimal sumEffectiveqty = BigDecimal.ZERO;
                BigDecimal cgSumEffectiveqty = BigDecimal.ZERO;
                Boolean ifdelivbill = false;
                Map<Long, DynamicObject> mapList = new HashMap<>();
                Map<Object, BigDecimal> mapt = new HashMap<>();
                if (null != selectRows && selectRows.length > 0) {
                    Long time = 0L;
                    for (int selectRow : selectRows) {
                        mapt.put(this.getModel().getValue("tpv_srcbillsubentityid", selectRow), (BigDecimal) model.getValue("tpv_currentflows", selectRow));
                        DynamicObject dynamicObject = entity.get(selectRow);
                        Long tpvDepartment = dynamicObject.getLong("tpv_sourcebillid");
                        mapList.put(time++, dynamicObject);
                    }
                    for (DynamicObject obj : queryHW) {
                        DynamicObjectCollection entryes = obj.getDynamicObjectCollection("tpv_materialentry");
                        for (DynamicObject entityes : entryes) {
                            sumQty = sumQty.add(entityes.getBigDecimal("tpv_qty"));
                        }
                        ifdelivbill = obj.getBoolean("tpv_ifdelivbill");
                        if (StringUtils.equals("tpv_purinbill", source.getKey())) {
                            if (number.equals("tpv_dt_freigroambill")) {
                                if (tpvContractno.equals(obj.getString("tpv_purcontnum")) && (obj.getString("tpv_delivery").equals(tpvDelivery) || (tpvDelivery != null || !"".equals(tpvDelivery.trim())))) {
                                    DynamicObjectCollection entryEntity = model.getEntryEntity("tpv_circulationgoodentity");
                                    List<ListSelectedRow> selectedRows = new ArrayList<>();
                                    if (entryEntity != null) {
                                        for (DynamicObject row : mapList.values()) {
                                            ListSelectedRow listSelectedRow = new ListSelectedRow(row.getLong("tpv_sourcebillid"));
                                            listSelectedRow.setEntryEntityKey("tpv_materialentry");
                                            listSelectedRow.setEntryPrimaryKeyValue(row.getLong("tpv_srcbillsubentityid"));
                                            selectedRows.add(listSelectedRow);
                                        }
                                    }
                                    PushArgs pushArgs = new PushArgs();
                                    pushArgs.setSourceEntityNumber("tpv_dt_freigroambill");
                                    pushArgs.setTargetEntityNumber("im_purinbill");
                                    pushArgs.addCustomParam("longList", JSONObject.toJSONString(mapt));
                                    pushArgs.setBuildConvReport(true);
                                    pushArgs.setRuleId("1739218844582465536");
                                    pushArgs.setAutoSave(true);
                                    pushArgs.setSelectedRows(selectedRows);
                                    ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
                                    Set<Object> targetBillIds = pushResult.getTargetBillIds();
                                    if (pushResult.isSuccess()) {
                                        Push.showTargetBill(view, pushArgs, pushResult, false);
                                    } else {
                                        Push.showReport(view, pushArgs, pushResult);
                                    }
                                }
                            }
                        }
                        if (StringUtils.equals("tpv_freigroambill", source.getKey())) {
                            if (number.equals("tpv_dt_freigroambill")) {
                                if (tpvContractno.equals(obj.getString("tpv_purcontnum")) && (obj.getString("tpv_delivery").equals(tpvDelivery) || (tpvDelivery != null || !"".equals(tpvDelivery.trim())))) {
                                    DynamicObjectCollection entryEntity = model.getEntryEntity("tpv_circulationgoodentity");
                                    List<ListSelectedRow> selectedRows = new ArrayList<>();
                                    if (entryEntity != null) {
                                        for (DynamicObject row : mapList.values()) {
                                            ListSelectedRow listSelectedRow = new ListSelectedRow(row.getLong("tpv_sourcebillid"));//单据id
                                            listSelectedRow.setEntryEntityKey("tpv_materialentry");
                                            listSelectedRow.setEntryPrimaryKeyValue(row.getLong("tpv_srcbillsubentityid"));
                                            selectedRows.add(listSelectedRow);
                                        }
                                    }
                                    PushArgs pushArgs = new PushArgs();
                                    pushArgs.setSourceEntityNumber("tpv_dt_freigroambill");
                                    pushArgs.setTargetEntityNumber("tpv_dt_freigroambill");
                                    pushArgs.addCustomParam("longList", JSONObject.toJSONString(mapt));
                                    pushArgs.setBuildConvReport(true);
                                    pushArgs.setRuleId("1741229034123087872");
                                    pushArgs.setAutoSave(true);
                                    pushArgs.setSelectedRows(selectedRows);
                                    ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
                                    Set<Object> targetBillIds = pushResult.getTargetBillIds();
                                    if (pushResult.isSuccess()) {
                                        Push.showTargetBill(view, pushArgs, pushResult, false);
                                    } else {
                                        Push.showReport(view, pushArgs, pushResult);
                                    }
                                }
                            }
                        }
                    }
                    for (DynamicObject obj : queryHT) {
                        if (StringUtils.equals("tpv_freigroambill", source.getKey())) {
                            if (numbers.equals("tpv_dt_purchase")) {
                                if (tpvContractno.equals(obj.getString("tpv_contractnumber"))) {
                                    DynamicObjectCollection entryEntity = model.getEntryEntity("tpv_circulationgoodentity");
                                    List<ListSelectedRow> selectedRows = new ArrayList<>();
                                    if (entryEntity != null) {
                                        for (DynamicObject row : mapList.values()) {
                                            long tpvSourcebillid = row.getLong("tpv_sourcebillid");
                                            long id = obj.getLong("id");
                                            ListSelectedRow listSelectedRow = new ListSelectedRow(tpvSourcebillid);
                                            listSelectedRow.setEntryEntityKey("tpv_materialentry");
                                            listSelectedRow.setEntryPrimaryKeyValue(row.getLong("tpv_srcbillsubentityid"));
                                            selectedRows.add(listSelectedRow);
                                        }
                                    }
                                    PushArgs pushArgs = new PushArgs();
                                    pushArgs.setSourceEntityNumber("tpv_dt_purchase");
                                    pushArgs.setTargetEntityNumber("tpv_dt_freigroambill");
                                    pushArgs.addCustomParam("longList", JSONObject.toJSONString(mapt));
                                    Map<String, BigDecimal> maps = new HashMap<>();
                                    maps.put("tpvHw", BigDecimal.valueOf(1));
                                    pushArgs.addCustomParam("tpvHw", JSONObject.toJSONString(maps));
                                    Map<String, BigDecimal> mapes = new HashMap<>();
                                    mapes.put("tpvZj", BigDecimal.valueOf(15));
                                    pushArgs.addCustomParam("tpvZj", JSONObject.toJSONString(mapes));
                                    pushArgs.setBuildConvReport(true);
                                    pushArgs.setRuleId("1738526298017422336");
                                    pushArgs.setAutoSave(true);
                                    pushArgs.setSelectedRows(selectedRows);
                                    ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
                                    Set<Object> targetBillIds = pushResult.getTargetBillIds();
                                    if (pushResult.isSuccess()) {
                                        Push.showTargetBill(view, pushArgs, pushResult, false);
                                    } else {
                                        Push.showReport(view, pushArgs, pushResult);
                                    }
                                }
                            }
                        }
                        if (StringUtils.equals("tpv_transdirbill", source.getKey())) {
                            if (numbers.equals("tpv_dt_purchase")) {
                                if (tpvContractno.equals(obj.getString("tpv_contractnumber"))) {
                                    DynamicObjectCollection entryEntity = this.getModel().getEntryEntity("tpv_circulationgoodentity");
                                    List<ListSelectedRow> selectedRows = new ArrayList<>();
                                    if (entryEntity != null) {
                                        for (DynamicObject row : mapList.values()) {
                                            ListSelectedRow listSelectedRow = new ListSelectedRow(row.getLong("tpv_sourcebillid"));//单据id
                                            listSelectedRow.setEntryEntityKey("tpv_materialentry");
                                            listSelectedRow.setEntryPrimaryKeyValue(row.getLong("tpv_srcbillsubentityid"));
                                            selectedRows.add(listSelectedRow);
                                        }
                                    }
                                    PushArgs pushArgs = new PushArgs();
                                    pushArgs.setSourceEntityNumber("tpv_dt_purchase");
                                    pushArgs.setTargetEntityNumber("tpv_dt_freigroambill");
                                    pushArgs.addCustomParam("longList", JSONObject.toJSONString(mapt));
                                    Map<String, BigDecimal> maps = new HashMap<>();
                                    maps.put("tpvZj", BigDecimal.valueOf(10));
                                    pushArgs.addCustomParam("tpvZj", JSONObject.toJSONString(maps));
                                    Map<String, BigDecimal> mapes = new HashMap<>();
                                    mapes.put("tpvHw", BigDecimal.valueOf(5));
                                    pushArgs.addCustomParam("tpvHw", JSONObject.toJSONString(mapes));
                                    pushArgs.setBuildConvReport(true);
                                    pushArgs.setRuleId("1738526298017422336");
                                    pushArgs.setAutoSave(true);
                                    pushArgs.setSelectedRows(selectedRows);
                                    ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
                                    Set<Object> targetBillIds = pushResult.getTargetBillIds();
                                    if (pushResult.isSuccess()) {
                                        Push.showTargetBill(view, pushArgs, pushResult, false);
                                    } else {
                                        Push.showReport(view, pushArgs, pushResult);
                                    }
                                }
                            }
                        }
                    }
                    for (DynamicObject obj : queryHTs) {
                        DynamicObjectCollection entryes = obj.getDynamicObjectCollection("tpv_materialentry");
                        for (DynamicObject entityes : entryes) {
                            sumEffectiveqty = sumEffectiveqty.add(entityes.getBigDecimal("tpv_effectiveqty"));
                        }
                    }
                    for (DynamicObject obu : queryRK) {
                        DynamicObjectCollection entryeas = obu.getDynamicObjectCollection("billentry");
                        for (DynamicObject ent : entryeas) {
                            cgSumEffectiveqty = cgSumEffectiveqty.add(ent.getBigDecimal("qty"));
                        }
                    }
                    if (StringUtils.equals("tpv_abolishenterkouqi", source.getKey())) {
                        if (numbers.equals("tpv_dt_freigroambill")) {
                            if (sumEffectiveqty.compareTo(sumQty) == 0 && ifdelivbill == true || sumEffectiveqty.compareTo(cgSumEffectiveqty) == 0) {
                                for (DynamicObject obj : queryHT) {
                                    if (obj.getString("tpv_cargostatus").equals("C")) {
                                        obj.set("tpv_cargostatus", "B");
                                        SaveServiceHelper.update(obj);
                                    }
                                }
//                                view.showTipNotification("满足货权齐条件");
                            } else {
                                for (DynamicObject obj : queryHT) {
                                    if (obj.getString("tpv_cargostatus").equals("C")) {
                                        obj.set("tpv_cargostatus", "A");
                                        SaveServiceHelper.update(obj);
                                    }
                                }
//                                view.showTipNotification("不满足货权齐条件");
                            }
                            view.showSuccessNotification("修改成功！");
                        } else {
                            view.showTipNotification("请选择源单据为货物流转的数据！");
                        }
                    }
                    if (StringUtils.equals("tpv_enterkouqi", source.getKey())) {
                        if (numbers.equals("tpv_dt_freigroambill")) {
                            for (DynamicObject obj : queryHT) {
                                obj.set("tpv_cargostatus", "C");
                                SaveServiceHelper.update(obj);
                            }
                            view.showSuccessNotification("修改成功！");
                        } else {
                            view.showTipNotification("请选择源单据为货物流转的数据！");
                        }
                    }
                } else {
                    view.showTipNotification("未选择数据。");
                    return;
                }
            }
        } else {
            view.showTipNotification("所选分录，行对应的数据不一致，不允许生成！");
        }
    }

    /**
     * @description: 获取货物流转工作台数据
     * @author yhj
     * @date 2023/9/4 10:51
     * @version 1.0
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        this.getModel().deleteEntryData("tpv_circulationgoodentity");
//        circulation();//货物流转
//        purchaseContract();//采购合同
        init(true);
        //extracted();
    }

    private void extracted() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection entry = dataEntity.getDynamicObjectCollection("tpv_circulationgoodentity");
        for (int i = 0; i < entry.size() - 1; i++) {
            for (int j = 0; j < entry.size() - 1 - i; j++) {
                Date date = entry.get(j).getDate("tpv_bizdate");
                Date date1 = entry.get(j + 1).getDate("tpv_bizdate");
                if (date1 != null && date != null) {
                    if (date.before(date1)) {
                        this.getModel().moveEntryRowDown("tpv_circulationgoodentity", j);
                    }
                }
            }
        }
        this.getView().updateView("tpv_circulationgoodentity");
    }

    /**
     * @description: 获取已审核采购合同数据
     * @author yhj
     * @date 2023/9/4 10:51
     * @version 1.0
     */
    private void purchaseContract() {
        IDataModel model = this.getModel();
        DynamicObject value = (DynamicObject) this.getModel().getValue("tpv_supplierf");
        String contractnosf = (String) this.getModel().getValue("tpv_contractnosf");
        String vehiclenamef = (String) this.getModel().getValue("tpv_vehiclenamef");
        String tpvCargostatusf = (String) this.getModel().getValue("tpv_cargostatusf");
        DynamicObject logistics = (DynamicObject) this.getModel().getValue("tpv_logisticsfieldserv");
        DynamicObject department = (DynamicObject) this.getModel().getValue("tpv_department");
        DynamicObject conmerchan = (DynamicObject) this.getModel().getValue("tpv_conmerchan");
        DynamicObject operatorht = (DynamicObject) this.getModel().getValue("tpv_operatorht");
        Date startdate = (Date) this.getModel().getValue("tpv_startdate");
        Date enddate = (Date) this.getModel().getValue("tpv_enddate");
        List<QFilter> list = new ArrayList<>();
        list.add(new QFilter("billstatus", QCP.equals, "C"));
        if (value != null) {
            long id = value.getLong("id");
            list.add(new QFilter("tpv_supplier", QCP.equals, id));
        }
        if (contractnosf != null && contractnosf != "") {
            list.add(new QFilter("tpv_contractnumber", QCP.ILIKE, "%" + contractnosf + "%"));
        }
        if (vehiclenamef != null && vehiclenamef != "") {
            list.add(new QFilter("tpv_circulation", QCP.not_equals, ""));
        }
        if (department != null) {
            long id = department.getLong("id");
            list.add(new QFilter("tpv_department", QCP.equals, id));
        }
        if (logistics != null) {
            long id = logistics.getLong("id");
            list.add(new QFilter("tpv_logisticsfieldserv", QCP.equals, id));
        }
        if (conmerchan != null) {
            long id = conmerchan.getLong("id");
            list.add(new QFilter("tpv_documentarys", QCP.equals, id));
        }
        if (operatorht != null) {
            long id = operatorht.getLong("id");
            list.add(new QFilter("tpv_operator", QCP.equals, id));
        }
        if (startdate != null) {
            list.add(new QFilter("tpv_dateofcontracting", QCP.large_equals, DateUtil.getStartOfDay(startdate)));
        }
        if (enddate != null) {
            list.add(new QFilter("tpv_dateofcontracting", QCP.less_equals, DateUtil.getEndOfDay(enddate)));
        }
        if (YEM.isNotEmpty(tpvCargostatusf)) {
            list.add(new QFilter("tpv_cargostatus", QCP.equals, tpvCargostatusf));
        }
        QFilter qFilter = PersonnelDepUtils.departmentQFilter(model, "tpv_muldepartment", "tpv_department");
        if (qFilter!=null){
            list.add(qFilter);
        }
        String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_purchase", "tpv_materialentry");
        DynamicObject[] queryCG = BusinessDataServiceHelper.load("tpv_dt_purchase", selectfieldsFast, list.toArray(new QFilter[]{}));
        DynamicObject purchase = BusinessDataServiceHelper.loadSingle("bos_entityobject", "id", new QFilter[]{new QFilter("number", QCP.equals, "tpv_dt_purchase")});
        for (DynamicObject obj : queryCG) {
            DynamicObjectCollection entry = obj.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject entity : entry) {
                if (obj != null) {
                    Long tpvSrcbillid = obj.getLong("id");
                    Long tpvSeq = entity.getLong("Seq");
                    Object tpvSrcen = entity.getPkValue();
                    BigDecimal tpvQty = entity.getBigDecimal("tpv_qty");

//                    BigDecimal tpvOverfillrate = BigDecimalUtils.toBigDecimal(obj.getBigDecimal("tpv_overfillrate"))
//                            .divide(new BigDecimal("100"));
//                    tpvQty = tpvQty.multiply(BigDecimal.ONE.add(tpvOverfillrate));

//                    BigDecimal tpvOverfillqty = BigDecimalUtils.toBigDecimal(entity.getBigDecimal("tpv_overfillqty"));
                    Long srcentryid = entity.getLong("tpv_srcentryid");
                    BigDecimal tpvFlowquantity = BigDecimalUtils.toBigDecimal(entity.getBigDecimal("tpv_flowquantity"));
                    BigDecimal tpvCalcuconforwardqty = BigDecimalUtils.toBigDecimal(entity.getBigDecimal("tpv_calcuconforwardqty"));
                    BigDecimal tpvBalancequantity = BigDecimalUtils.toBigDecimal(entity.getBigDecimal("tpv_balancequantity"));
//                    BigDecimal sub = BigDecimalUtils.sub(tpvQty, tpvFlowquantity, 2);
//                    BigDecimal subOne = BigDecimalUtils.sub(sub, tpvCalcuconforwardqty, 2);
//                    BigDecimal qty = BigDecimalUtils.sub(subOne, tpvBalancequantity, 2);
                    BigDecimal qty = tpvQty.subtract(tpvFlowquantity).subtract(tpvCalcuconforwardqty).subtract(tpvBalancequantity);
                    DynamicObject tpvMaterial = entity.getDynamicObject("tpv_material");
                    DynamicObject tpvProdname = entity.getDynamicObject("tpv_prodname");
                    DynamicObject tpvOrigin = entity.getDynamicObject("tpv_origin");
                    DynamicObject tpvTransportstyles = obj.getDynamicObject("tpv_transportstyles");
                    DynamicObject tpvLogisticsfieldserv = obj.getDynamicObject("tpv_logisticsfieldserv");
                    String billstatus = obj.getString("billstatus");
                    Boolean magnitude = (Boolean) model.getValue("tpv_magnitude");
                    if (magnitude) {
                        if (qty.compareTo(BigDecimal.ZERO) == 1) {
                            int newEntryRow = this.getModel().createNewEntryRow("tpv_circulationgoodentity");
                            model.setValue("tpv_sourcebillid", tpvSrcbillid, newEntryRow);
                            model.setValue("tpv_serial", tpvSeq, newEntryRow);
                            model.setValue("tpv_srcbillsubentityid", tpvSrcen, newEntryRow);
                            model.setValue("tpv_srcentryid", srcentryid, newEntryRow);
                            model.setValue("tpv_contdelinode", obj.getString("tpv_contractdelinode"), newEntryRow);
                            model.setValue("tpv_supplier", obj.getDynamicObject("tpv_supplier"), newEntryRow);
                            model.setValue("tpv_sourcebillkey", purchase, newEntryRow);
                            model.setValue("tpv_contractno", obj.getString("tpv_contractnumber"), newEntryRow);
                            model.setValue("tpv_bizdate", obj.getDate("tpv_dateofcontracting"), newEntryRow);//签约日期
                            model.setValue("tpv_cargostatus", obj.getString("tpv_cargostatus") , newEntryRow);
                            if (billstatus != null) {
                                model.setValue("tpv_billstatus", billstatus, newEntryRow);
                            }
                            if (tpvMaterial != null) {
                                model.setValue("tpv_material", tpvMaterial, newEntryRow);
                            }
                            if (tpvProdname != null) {
                                model.setValue("tpv_prodname", tpvProdname, newEntryRow);
                            }
                            model.setValue("tpv_specation", entity.getString("tpv_specation"), newEntryRow);
                            model.setValue("tpv_shader", entity.getString("tpv_shader"), newEntryRow);
                            if (tpvOrigin != null) {
                                model.setValue("tpv_origin", tpvOrigin, newEntryRow);
                            }
                            if (tpvTransportstyles != null) {
                                model.setValue("tpv_transportstyles", tpvTransportstyles, newEntryRow);
                            }
                            model.setValue("tpv_qty", qty, newEntryRow);
                            if (tpvLogisticsfieldserv != null) {
                                model.setValue("tpv_logistics", tpvLogisticsfieldserv, newEntryRow);
                            }
                        }
                    } else {

                        int newEntryRow = this.getModel().createNewEntryRow("tpv_circulationgoodentity");
                        model.setValue("tpv_sourcebillid", tpvSrcbillid, newEntryRow);
                        model.setValue("tpv_serial", tpvSeq, newEntryRow);
                        model.setValue("tpv_srcbillsubentityid", tpvSrcen, newEntryRow);
                        model.setValue("tpv_srcentryid", srcentryid, newEntryRow);
                        model.setValue("tpv_contdelinode", obj.getString("tpv_contractdelinode"), newEntryRow);
                        model.setValue("tpv_supplier", obj.getDynamicObject("tpv_supplier"), newEntryRow);
                        model.setValue("tpv_sourcebillkey", purchase, newEntryRow);
                        model.setValue("tpv_contractno", obj.getString("tpv_contractnumber"), newEntryRow);
                        model.setValue("tpv_bizdate", obj.getDate("tpv_bizdate"), newEntryRow);
                        model.setValue("tpv_cargostatus", obj.getString("tpv_cargostatus") , newEntryRow);
                        if (billstatus != null) {
                            model.setValue("tpv_billstatus", billstatus, newEntryRow);
                        }
                        if (tpvMaterial != null) {
                            model.setValue("tpv_material", tpvMaterial, newEntryRow);
                        }
                        if (tpvProdname != null) {
                            model.setValue("tpv_prodname", tpvProdname, newEntryRow);
                        }
                        model.setValue("tpv_specation", entity.getString("tpv_specation"), newEntryRow);
                        model.setValue("tpv_shader", entity.getString("tpv_shader"), newEntryRow);
                        if (tpvOrigin != null) {
                            model.setValue("tpv_origin", tpvOrigin, newEntryRow);
                        }
                        if (tpvTransportstyles != null) {
                            model.setValue("tpv_transportstyles", tpvTransportstyles, newEntryRow);
                        }
                        model.setValue("tpv_unit", entity.getDynamicObject("tpv_unit"), newEntryRow);
                        model.setValue("tpv_qty", qty, newEntryRow);
                        if (tpvLogisticsfieldserv != null) {
                            model.setValue("tpv_logistics", tpvLogisticsfieldserv, newEntryRow);
                        }

                    }
                }
            }
        }
    }


    /**
     * @description: 获取已审核货物流转数据
     * @author yhj
     * @date 2023/9/4 10:51
     * @version 1.0
     */
    private void circulation() {
        IDataModel model = this.getModel();
        DynamicObject value = (DynamicObject) this.getModel().getValue("tpv_supplierf");
        String contractnosf = (String) this.getModel().getValue("tpv_contractnosf");
        String vehiclenamef = (String) this.getModel().getValue("tpv_vehiclenamef");
        DynamicObject department = (DynamicObject) this.getModel().getValue("tpv_department");
        DynamicObject logistics = (DynamicObject) this.getModel().getValue("tpv_logisticsfieldserv");
        DynamicObject conmerchan = (DynamicObject) this.getModel().getValue("tpv_conmerchan");
        DynamicObject operatorht = (DynamicObject) this.getModel().getValue("tpv_operatorht");
        Date startdate = (Date) this.getModel().getValue("tpv_startdate");
        Date enddate = (Date) this.getModel().getValue("tpv_enddate");
        List<QFilter> list = new ArrayList<>();
        list.add(new QFilter("billstatus", QCP.equals, "C"));
        if (value != null) {
            long id = value.getLong("id");
            list.add(new QFilter("tpv_supplier", QCP.equals, id));
        }
        if (logistics != null) {
            long id = logistics.getLong("id");
            list.add(new QFilter("tpv_logistics", QCP.equals, id));
        }
        if (contractnosf != null && contractnosf != "") {
            list.add(new QFilter("tpv_purcontnum", QCP.ILIKE, "%" + contractnosf + "%"));
        }
        if (vehiclenamef != null && vehiclenamef != "") {
            list.add(new QFilter("billno", QCP.like, "%" + vehiclenamef + "%"));
        }
        if (department != null) {
            long id = department.getLong("id");
            list.add(new QFilter("tpv_department", QCP.equals, id));
        }
        if (conmerchan != null) {
            long id = conmerchan.getLong("id");
            list.add(new QFilter("tpv_conmerchan", QCP.equals, id));
        }
        if (operatorht != null) {
            long id = operatorht.getLong("id");
            list.add(new QFilter("tpv_operator", QCP.equals, id));
        }
        if (startdate != null) {
            list.add(new QFilter("tpv_signingdates", QCP.large_equals, DateUtil.getStartOfDay(startdate)));
        }
        if (enddate != null) {
            list.add(new QFilter("tpv_signingdates", QCP.less_equals, DateUtil.getEndOfDay(enddate)));
        }
        QFilter qFilter = PersonnelDepUtils.departmentQFilter(model, "tpv_muldepartment", "tpv_department");
        if (qFilter!=null){
            list.add(qFilter);
        }
        String selectStrxs = DynamicObjectUtil.getSelectfields("tpv_dt_freigroambill", false);
        selectStrxs = DynamicObjectUtil.getEntrySelectfields(selectStrxs,"tpv_dt_freigroambill","tpv_materialentry","tpv_dt_freigroambill_f");
        selectStrxs = DynamicObjectUtil.getEntrySelectfields(selectStrxs,"tpv_dt_freigroambill","tpv_materialentry");
        DynamicObject[] queryHW = BusinessDataServiceHelper.load("tpv_dt_freigroambill", selectStrxs, list.toArray(new QFilter[]{}));
        DynamicObject freigroamBill = BusinessDataServiceHelper.loadSingle("bos_entityobject", "id", new QFilter[]{new QFilter("number", QCP.equals, "tpv_dt_freigroambill")});
        for (DynamicObject obj : queryHW) {
            DynamicObjectCollection entry = obj.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject entity : entry) {
                if (obj != null) {
                    BigDecimal moneys=BigDecimal.ZERO;//物流费用
                    DynamicObjectCollection freigroam = entity.getDynamicObjectCollection("tpv_dt_freigroambill_f");
                    for (DynamicObject objs :freigroam) {
                        moneys= moneys.add(objs.getBigDecimal("tpv_moneys"));
                    }
                    Long bigintid = obj.getLong("tpv_corebillid");
                    Long tpvSrcbillid = obj.getLong("id");
                    Long tpvSeq = entity.getLong("Seq");
                    Object tpvSrcen = entity.getPkValue();
                    Long srcentryid = entity.getLong("tpv_srcentryid");
                    String sourcebillno = obj.getString("tpv_sourcebillno");
                    BigDecimal tpvQty = entity.getBigDecimal("tpv_qty");
                    BigDecimal tpvReperoomqty = BigDecimalUtils.toBigDecimal(entity.getBigDecimal("tpv_reperoomqty"));
                    BigDecimal tpvDirecroomtqty = BigDecimalUtils.toBigDecimal(entity.getBigDecimal("tpv_direcroomtqty"));
//                    BigDecimal sub = BigDecimalUtils.sub(tpvQty, tpvReperoomqty, 2);
//                    BigDecimal qty = BigDecimalUtils.sub(sub, tpvDirecroomtqty, 2);
                    BigDecimal qty = tpvQty.subtract(tpvReperoomqty).subtract(tpvDirecroomtqty);

                    DynamicObject tpvMaterial = entity.getDynamicObject("tpv_material");
                    Object tpv_customtags = entity.get("tpv_customtags");
                    DynamicObject tpvProdname = entity.getDynamicObject("tpv_prodname");
                    DynamicObject tpvOrigin = entity.getDynamicObject("tpv_origin");
                    DynamicObject tpvTransportstyles = obj.getDynamicObject("tpv_transportstyles");
                    DynamicObject tpvCustcarrier = obj.getDynamicObject("tpv_custcarrier");
                    DynamicObject tpvLogistics = obj.getDynamicObject("tpv_logistics");
                    DynamicObject tpvPortofload = obj.getDynamicObject("tpv_portofload");
                    DynamicObject tpvDestports = obj.getDynamicObject("tpv_destports");
                    String billstatus = obj.getString("billstatus");//单据状态
                    Boolean magnitude = (Boolean) model.getValue("tpv_magnitude");
                    if (magnitude) {
                        if (qty.compareTo(BigDecimal.ZERO) == 1) {
                            int newEntryRow = this.getModel().createNewEntryRow("tpv_circulationgoodentity");
                            model.setValue("tpv_bigintid", bigintid, newEntryRow);
                            model.setValue("tpv_sourcebillid", tpvSrcbillid, newEntryRow);
                            model.setValue("tpv_serial", tpvSeq, newEntryRow);
                            model.setValue("tpv_srcentryid", srcentryid, newEntryRow);
                            model.setValue("tpv_wlmontotals", moneys, newEntryRow);
                            model.setValue("tpv_srcbillsubentityid", tpvSrcen, newEntryRow);
                            model.setValue("tpv_sourcebillno", sourcebillno, newEntryRow);
                            model.setValue("tpv_supplier", obj.getDynamicObject("tpv_supplier"), newEntryRow);
                            model.setValue("tpv_contractno", obj.getString("tpv_purcontnum"), newEntryRow);
                            model.setValue("tpv_contdelinode", obj.getString("tpv_contdelinode"), newEntryRow);
                            model.setValue("tpv_transfernumber", obj.getString("billno"), newEntryRow);
                            model.setValue("tpv_transferdate", obj.getDate("tpv_bizdate"), newEntryRow);
                            model.setValue("tpv_bizdate", obj.getDate("tpv_signingdates"), newEntryRow);//签约日期
                            if (tpvMaterial != null) {
                                model.setValue("tpv_material", tpvMaterial, newEntryRow);
                            }
                            if (billstatus != null) {
                                model.setValue("tpv_billstatus", billstatus, newEntryRow);
                            }
                            if (tpvProdname != null) {
                                model.setValue("tpv_prodname", tpvProdname, newEntryRow);
                            }
                            model.setValue("tpv_specation", entity.getString("tpv_specation"), newEntryRow);
                            model.setValue("tpv_shader", entity.getString("tpv_shader"), newEntryRow);
                            if (tpvOrigin != null) {
                                model.setValue("tpv_origin", tpvOrigin, newEntryRow);
                            }
                            model.setValue("tpv_delivery", obj.getString("tpv_delivery"), newEntryRow);
                            if (tpvTransportstyles != null) {
                                model.setValue("tpv_transportstyles", tpvTransportstyles, newEntryRow);
                            }
                            if (tpvCustcarrier != null) {
                                model.setValue("tpv_custcarrier", tpvCustcarrier, newEntryRow);
                            }
                            model.setValue("tpv_carshipname", obj.getString("tpv_carshipname"), newEntryRow);
                            model.setValue("tpv_begindate", obj.getString("tpv_begindate"), newEntryRow);
                            model.setValue("tpv_finishdate", obj.getString("tpv_finishdate"), newEntryRow);
                            model.setValue("tpv_unit", entity.getDynamicObject("tpv_unit"), newEntryRow);
                            model.setValue("tpv_qty", qty, newEntryRow);
                            model.setValue("tpv_roamlevel", entity.getInt("tpv_roamlevel"), newEntryRow);
                            model.setValue("tpv_roamaction", obj.getString("tpv_roamaction"), newEntryRow);
                            model.setValue("tpv_ifdelivbill", obj.getBoolean("tpv_ifdelivbill"), newEntryRow);
                            if (tpvLogistics != null) {
                                model.setValue("tpv_logistics", tpvLogistics, newEntryRow);
                            }
                            if (tpvPortofload != null) {
                                model.setValue("tpv_portofload", tpvPortofload, newEntryRow);
                            }
                            if (tpvDestports != null) {
                                model.setValue("tpv_destports", tpvDestports, newEntryRow);
                            }
                            model.setValue("tpv_free",tpv_customtags, newEntryRow);
                            model.setValue("tpv_portofloadinfor", obj.getString("tpv_portofloadinfor"), newEntryRow);
                            model.setValue("tpv_destportsinfor", obj.getString("tpv_destportsinfor"), newEntryRow);
                            model.setValue("tpv_sourcebillkey", freigroamBill, newEntryRow);
                        }
                    } else {

                        int newEntryRow = this.getModel().createNewEntryRow("tpv_circulationgoodentity");
                        model.setValue("tpv_bigintid", bigintid, newEntryRow);
                        model.setValue("tpv_sourcebillid", tpvSrcbillid, newEntryRow);
                        model.setValue("tpv_serial", tpvSeq, newEntryRow);
                        model.setValue("tpv_srcentryid", srcentryid, newEntryRow);
                        model.setValue("tpv_wlmontotals", moneys, newEntryRow);
                        model.setValue("tpv_srcbillsubentityid", tpvSrcen, newEntryRow);
                        model.setValue("tpv_sourcebillno", sourcebillno, newEntryRow);
                        model.setValue("tpv_supplier", obj.getDynamicObject("tpv_supplier"), newEntryRow);
                        model.setValue("tpv_contractno", obj.getString("tpv_purcontnum"), newEntryRow);
                        model.setValue("tpv_contdelinode", obj.getString("tpv_contdelinode"), newEntryRow);
                        model.setValue("tpv_transfernumber", obj.getString("billno"), newEntryRow);
                        model.setValue("tpv_transferdate", obj.getDate("tpv_bizdate"), newEntryRow);
                        model.setValue("tpv_bizdate", obj.getDate("tpv_cgdate"), newEntryRow);
                        if (tpvMaterial != null) {
                            model.setValue("tpv_material", tpvMaterial, newEntryRow);
                        }
                        if (billstatus != null) {
                            model.setValue("tpv_billstatus", billstatus, newEntryRow);
                        }
                        if (tpvProdname != null) {
                            model.setValue("tpv_prodname", tpvProdname, newEntryRow);
                        }
                        model.setValue("tpv_specation", entity.getString("tpv_specation"), newEntryRow);
                        model.setValue("tpv_shader", entity.getString("tpv_shader"), newEntryRow);
                        if (tpvOrigin != null) {
                            model.setValue("tpv_origin", tpvOrigin, newEntryRow);
                        }
                        model.setValue("tpv_delivery", obj.getString("tpv_delivery"), newEntryRow);
                        if (tpvTransportstyles != null) {
                            model.setValue("tpv_transportstyles", tpvTransportstyles, newEntryRow);
                        }
                        if (tpvCustcarrier != null) {
                            model.setValue("tpv_custcarrier", tpvCustcarrier, newEntryRow);
                        }
                        model.setValue("tpv_carshipname", obj.getString("tpv_carshipname"), newEntryRow);
                        model.setValue("tpv_begindate", obj.getString("tpv_begindate"), newEntryRow);
                        model.setValue("tpv_finishdate", obj.getString("tpv_finishdate"), newEntryRow);
                        model.setValue("tpv_qty", qty, newEntryRow);
                        model.setValue("tpv_roamlevel", entity.getInt("tpv_roamlevel"), newEntryRow);
                        model.setValue("tpv_roamaction", obj.getString("tpv_roamaction"), newEntryRow);
                        model.setValue("tpv_ifdelivbill", obj.getBoolean("tpv_ifdelivbill"), newEntryRow);
                        model.setValue("tpv_free",tpv_customtags, newEntryRow);
                        if (tpvLogistics != null) {
                            model.setValue("tpv_logistics", tpvLogistics, newEntryRow);
                        }
                        if (tpvPortofload != null) {
                            model.setValue("tpv_portofload", tpvPortofload, newEntryRow);
                        }
                        if (tpvDestports != null) {
                            model.setValue("tpv_destports", tpvDestports, newEntryRow);
                        }
                        model.setValue("tpv_portofloadinfor", obj.getString("tpv_portofloadinfor"), newEntryRow);
                        model.setValue("tpv_destportsinfor", obj.getString("tpv_destportsinfor"), newEntryRow);
                        model.setValue("tpv_sourcebillkey", freigroamBill, newEntryRow);
                    }


                }
            }
        }
    }

    private void init(boolean b) {
        IDataModel model = this.getModel();
        DynamicObject supplierf = (DynamicObject) this.getModel().getValue("tpv_supplierf");
        String contractnosf = (String) this.getModel().getValue("tpv_contractnosf");
        String vehiclenamef = (String) this.getModel().getValue("tpv_vehiclenamef");
        String tpvCargostatusf = (String) this.getModel().getValue("tpv_cargostatusf");
        DynamicObject department = (DynamicObject) this.getModel().getValue("tpv_department");
        DynamicObject logistics = (DynamicObject) this.getModel().getValue("tpv_logisticsfieldserv");
        DynamicObject conmerchan = (DynamicObject) this.getModel().getValue("tpv_conmerchan");
        DynamicObject operatorht = (DynamicObject) this.getModel().getValue("tpv_operatorht");
        Date startdate = (Date) this.getModel().getValue("tpv_startdate");
        Date enddate = (Date) this.getModel().getValue("tpv_enddate");
        String whereFilter = "1 == 1";
        if (supplierf != null) {
            long id = supplierf.getLong("id");
            whereFilter = String.format("%s and tpv_supplier = %s", whereFilter, id);
        }
        if (logistics != null) {
            long id = logistics.getLong("id");
            whereFilter = String.format("%s and tpv_logistics = %s", whereFilter, id);
        }
//        if (contractnosf != null && contractnosf != "") {
//            whereFilter = String.format("%s and ", whereFilter, "");
//        }
//        if (vehiclenamef != null && vehiclenamef != "") {
//            whereFilter = String.format("%s and ", whereFilter, "");
//        }
//        if (tpvCargostatusf != null && tpvCargostatusf != "") {
//            whereFilter = String.format("%s and ", whereFilter, "");
//        }
//        if (startdate != null) {
//            whereFilter = String.format("%s and ", whereFilter, "");
//        }
//        if (enddate != null) {
//            whereFilter = String.format("%s and ", whereFilter, "");
//        }
        List<QFilter> list = new ArrayList<>();
        list.add(new QFilter("billstatus", QCP.equals, "C"));
        if (department != null) {
            long id = department.getLong("id");
            list.add(new QFilter("tpv_department", QCP.equals, id));
        }
        if (conmerchan != null) {
            long id = conmerchan.getLong("id");
            list.add(new QFilter("tpv_conmerchan", QCP.equals, id));
        }
        if (operatorht != null) {
            long id = operatorht.getLong("id");
            list.add(new QFilter("tpv_operator", QCP.equals, id));
        }
        QFilter qFilter = PersonnelDepUtils.departmentQFilter(model, "tpv_muldepartment", "tpv_department");
        if (qFilter!=null){
            list.add(qFilter);
        }
        initAllFields();
        DataSet tpv_dt_freigroambill = ORM.create().queryDataSet(algoKey, "tpv_dt_freigroambill", String.join(",", fieldKeys_hwlz), list.toArray(new QFilter[0]));
        DataSet tpv_dt_purchase = ORM.create().queryDataSet(algoKey, "tpv_dt_purchase", String.join(",", fieldKeys_order), list.toArray(new QFilter[0]));
        DataSet dataSet = tpv_dt_freigroambill.union(tpv_dt_purchase);
        dataSet = dataSet.where(whereFilter);
        dataSet = RptUtil.zeroNullNums(dataSet);
        dataSet = dataSet.addField("(case when tpv_source == 'A' then qty - tpv_balancequantity - tpv_calcuconforwardqty - tpv_flowquantity " +
                "when tpv_source == 'B' then qty - tpv_direcroomtqty - tpv_reperoomqty else 0.0 end) tpv_qty","tpv_qty");
        dataSet = dataSet.orderBy(new String[]{"date desc","tpv_serial asc"});
        DynamicObjectType enrtyType = model.getEntryEntity("tpv_circulationgoodentity").getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(dataSet);
        for (Row row : dataSet) {
            int index = model.createNewEntryRow("tpv_circulationgoodentity");
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    private static void initAllFields() {
        fieldKeys_order.clear();
        fieldKeys_hwlz.clear();
        addFields("tpv_sourcebillkey","'tpv_dt_purchase'","'tpv_dt_freigroambill'"); //源单据
        addFields("tpv_source","'A'","'B'"); //源单据
        addFields("tpv_billstatus","billstatus","billstatus"); //单据状态
        addFields("tpv_supplier","tpv_supplier","tpv_supplier"); //供应商
        addFields("tpv_contractno","tpv_contractnumber","tpv_purcontnum"); //合同号
        addFields("tpv_cargostatus","tpv_cargostatus",null); //合同货物状态
        addFields("tpv_contdelinode",null,"tpv_contdelinode"); //约定交货节点
        addFields("tpv_transfernumber",null,"billno"); //货物流转单号
        addFields("tpv_bizdate","tpv_dateofcontracting","tpv_cgdate"); //采购合同签约日期
        addFields("tpv_transferdate",null,"tpv_bizdate"); //货物流转单业务日期
        addFields("tpv_material","tpv_materialentry.tpv_material","tpv_materialentry.tpv_material"); //商品
        addFields("tpv_prodname","tpv_materialentry.tpv_prodname","tpv_materialentry.tpv_prodname"); //品名
        addFields("tpv_specation","tpv_materialentry.tpv_specation","tpv_materialentry.tpv_specation"); //规格
        addFields("tpv_shader","tpv_materialentry.tpv_shader","tpv_materialentry.tpv_shader"); //材质
        addFields("tpv_free",null,"tpv_materialentry.tpv_customtags"); //自定标签
        addFields("tpv_origin","tpv_materialentry.tpv_origin","tpv_materialentry.tpv_origin"); //产地
        addFields("tpv_delivery",null,"tpv_delivery"); //交货标识
        addFields("tpv_transportstyles","tpv_transportstyles","tpv_transportstyles"); //运输方式
        addFields("tpv_custcarrier",null,"tpv_custcarrier"); //保管/承运方
        addFields("tpv_carshipname",null,"tpv_custcarrier"); //车船名
        addFields("tpv_begindate",null,null); //开始日期
        addFields("tpv_finishdate",null,null); //到达日期
        addFields("tpv_unit","tpv_materialentry.tpv_unit","tpv_materialentry.tpv_unit"); //计量单位
        addFields("qty","tpv_materialentry.tpv_qty","tpv_materialentry.tpv_qty"); //当前数量
        addFields("tpv_direcroomtqty","0.0","tpv_materialentry.tpv_direcroomtqty"); //
        addFields("tpv_reperoomqty","0.0","tpv_materialentry.tpv_reperoomqty"); //
        addFields("tpv_balancequantity","tpv_materialentry.tpv_balancequantity","0.0"); //
        addFields("tpv_calcuconforwardqty","tpv_materialentry.tpv_calcuconforwardqty","0.0"); //
        addFields("tpv_flowquantity","tpv_materialentry.tpv_flowquantity","0.0"); //
        addFields("tpv_wlmontotals","0.0","0.0"); //物流费用合计
        addFields("tpv_currentflows","0.0","0.0"); //本次流转数量
        addFields("tpv_roamlevel",null,"tpv_materialentry.tpv_roamlevel"); //流转级次
        addFields("tpv_roamaction",null,"tpv_roamaction"); //流转动作
        addFields("tpv_ifdelivbill",null,"tpv_ifdelivbill"); //是否交货单据
        addFields("tpv_logistics","tpv_logisticsfieldserv","tpv_logistics"); //物流外勤
        addFields("tpv_portofload",null,"tpv_logistics"); //起运地
        addFields("tpv_destports",null,"tpv_logistics"); //目的地
        addFields("tpv_portofloadinfor",null,"tpv_portofloadinfor"); //起运地描述
        addFields("tpv_destportsinfor",null,"tpv_destportsinfor"); //目的地描述
        addFields("tpv_sourcebillid","id","id"); //单据ID
        addFields("tpv_bigintid","id","tpv_corebillid"); //合同ID
        addFields("tpv_srcbillsubentityid","tpv_materialentry.id","tpv_materialentry.id"); //单据分录ID
        addFields("tpv_serial","tpv_materialentry.seq","tpv_materialentry.seq"); //分录序号
        addFields("tpv_srcentryid",null,"tpv_materialentry.tpv_srcentryid"); //来源单据分录id
        addFields("tpv_sourcebillno",null,"tpv_sourcebillno"); //来源单据编码
        addFields("date","auditdate","auditdate"); //来源单据编码
    }

    private static void addFields(String fieldKey, String fieldKey_Ht, String fieldKey_HW) {
        fieldKeys_order.add(fieldKey_Ht + " " + fieldKey);
        fieldKeys_hwlz.add(fieldKey_HW + " " + fieldKey);
    }

    /**
     * @description: 获取下拉列表的标题
     * @author yhj
     * @date 2023/9/4 10:51
     * @version 1.0
     * obs 标识
     * obj 标识所在单据或分录的数据包
     */
    private static String extracted(DynamicObject obj, String obs) {
        MainEntityType mainEntityType = (MainEntityType) obj.getDataEntityType();
        DataEntityPropertyCollection properties = mainEntityType.getProperties();
        ComboProp comboUnitProp = (ComboProp) properties.get(obs);
        String comb = comboUnitProp.getItemByName(obj.getString(obs));
        return comb;
    }

    /**
     * @param e
     * @return
     * @description 点击超链接
     * @author yhj
     * @date 2023/10/8 10:34
     */
    @Override
    public void hyperLinkClick(HyperLinkClickEvent e) {
        int index = e.getRowIndex();
        Long billno = 0L;
        DynamicObject tpvSourcebillkey = (DynamicObject) this.getModel().getValue("tpv_sourcebillkey", index);
        String tpvSourcebillkeyString = tpvSourcebillkey.getString("number");
        if ("tpv_contractno".equals(e.getFieldName())) {
            if ("tpv_dt_freigroambill".equals(tpvSourcebillkeyString)) {
                billno = (Long) this.getModel().getValue("tpv_bigintid", index);
            }
            if ("tpv_dt_purchase".equals(tpvSourcebillkeyString)) {
                billno = (Long) this.getModel().getValue("tpv_sourcebillid", index);
            }
            DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", "id",
                    new QFilter[]{new QFilter("id", QCP.equals, billno)});
            if (loadSingle != null) {
                BillShowParameter showParameter = new BillShowParameter();
                showParameter.setFormId("tpv_dt_purchase");
                showParameter.setPkId(loadSingle.getPkValue());
                showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
                showParameter.setStatus(OperationStatus.VIEW);
                this.getView().showForm(showParameter);
            }
        }
        if ("tpv_transfernumber".equals(e.getFieldName())) {
            Long billnos = (Long) this.getModel().getValue("tpv_sourcebillid", index);
            DynamicObject loadSingles = BusinessDataServiceHelper.loadSingle("tpv_dt_freigroambill", "id",
                    new QFilter[]{new QFilter("id", QCP.equals, billnos)});
            if (loadSingles != null) {
                BillShowParameter showParameter = new BillShowParameter();
                showParameter.setFormId("tpv_dt_freigroambill");
                showParameter.setPkId(loadSingles.getPkValue());
                showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
                showParameter.setStatus(OperationStatus.VIEW);
                this.getView().showForm(showParameter);
            }
        }
    }

}
