package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * @author l jw
 * @date 2023/9/19 18:30
 * @className CklogisPlugin
 * @description 出口物流工作台插件
 */
public class CklogisEdit extends AbstractBillPlugIn {
    private static final String ENTRY_SALE = "tpv_entryentity1";//采购装运情况分录
    private String pageId = "";

    public String getPageId() {
        return pageId;
    }

    public void setPageId(String pageId) {
        this.pageId = pageId;
    }


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        String[] itemListener = {"tpv_advcontoolbarap4"};
        this.addItemClickListeners(itemListener);
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs afterDoOperationEventArgs) {
        super.afterDoOperation(afterDoOperationEventArgs);
        String key = afterDoOperationEventArgs.getOperateKey();
        if ("save".equals(key)){

        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();

        switch (key) {
            case "tpv_addentrys"://销售增行
                saleQuery();
                break;
            default:
                break;
        }
    }

    /**
     * 销售合同
     */
    private void saleQuery() {
        QFilter[] qFilter = new QFilter[]{new QFilter("billstatus", QCP.equals, "C"),
                new QFilter("tpv_combinationnumber.number", QCP.equals, this.getModel().getValue("number")),
                new QFilter("tpv_customer.tpv_enterprise",QCP.equals,false)};
        DynamicObject[] queryCG = BusinessDataServiceHelper.load("tpv_dt_salescontract", "tpv_materialentry,tpv_combinationnumber.number,tpv_qty,tpv_customer,tpv_contractnos,tpv_portofloading,tpv_destinationport,tpv_unit", qFilter);
        IDataModel model = this.getModel();
        if (queryCG.length > 0){
            int[] ints = this.getModel().batchCreateNewEntryRow(ENTRY_SALE, queryCG.length);//货物流转分录
            int i =0;
            for (DynamicObject obj : queryCG) {
                DynamicObjectCollection collection = obj.getDynamicObjectCollection("tpv_materialentry");
                Integer sum = calculate(collection,"tpv_qty");//计算总数
                DynamicObject customer = obj.getDynamicObject("tpv_customer");
                DynamicObject portofloading = obj.getDynamicObject("tpv_portofloading");//起运港
                DynamicObject destinationport = obj.getDynamicObject("tpv_destinationport");//目的港
                String contractnos = obj.getString("tpv_contractnos");
                model.setValue("tpv_salenumber", contractnos, ints[i]);//销售合同号
                model.setValue("tpv_customer", customer, ints[i]);//客户
                model.setValue("tpv_startports", portofloading, ints[i]);//起运港
                model.setValue("tpv_endports", destinationport, ints[i]);//目的港
                model.setValue("tpv_units", customer, ints[i]);//单位
                model.setValue("tpv_startnums", sum, ints[i]);//起运数量
                ++i;
            }
        }else {
            this.getView().showTipNotification("暂无数据可以添加!");
        }

    }
    private Integer calculate(DynamicObjectCollection collection, String name) {
        AtomicInteger sum = new AtomicInteger();
        collection.stream().forEach(dyObj->{
            sum.addAndGet(dyObj.getInt(name));
        });
        return sum.get();
    }

}
