package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.entity.OrmLocaleValue;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * @author l jw
 * @date 2023/9/19 18:28
 * @className CklogistilcsEdit
 * @description 出口物流工作台查询插件
 */
public class CklogistilcsEdit extends AbstractBillPlugIn implements RowClickEventListener {
    private final static String ENTRY_FIRST = "tpv_wms_cklogistics_cg";//工作台分录
    private final static String ENTRY_HAND = "tpv_cklogistics_jdqk";//交单
    private HashMap<String, Integer> entryIndex = new HashMap<>();//分录下标
    private ArrayList<HashMap<String, Object>> entryList = new ArrayList<>();//工作台数据

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        String[] listener = {"tpv_advcontoolbarapif"};
        String[] itemListener = {"tpv_advcontoolbarapif", "tpv_advconbaritemap"};
        this.addClickListeners(listener);
        this.addItemClickListeners(itemListener);
        EntryGrid entryGrid = this.getView().getControl("tpv_wms_cklogistics_cg");
        entryGrid.addRowClickListener(this);
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        RowClickEventListener.super.entryRowClick(evt);
        //获取点击行号
        int row = evt.getRow();
        if (row < 0) {
            return;
        }
        openContainerFrom(row); //采销装运情况
        arrivalAndHand(row);//到单,交单情况
    }

    private void arrivalAndHand(int row) {
        ArrayList<String> purNum = new ArrayList<>();//采购
        ArrayList<String> saleNum = new ArrayList<>();//销售
        HashMap<Object, String> map_p = new HashMap<>();
        HashMap<Object, String> map_s = new HashMap<>();
        this.getModel().deleteEntryData(ENTRY_HAND);
        DynamicObject object = this.getModel().getEntryEntity(ENTRY_FIRST).get(row);
        String groupnumber = object.getString("tpv_groupnumber");
        DynamicObject[] purchases = BusinessDataServiceHelper.load("tpv_dt_purchase", "billno,tpv_contractnumber", new QFilter[]{new QFilter("tpv_combinationnumber.number", QCP.equals, groupnumber)});
        DynamicObject[] sale = BusinessDataServiceHelper.load("tpv_dt_salescontract", "billno,tpv_contractnos", new QFilter[]{new QFilter("tpv_combinationnumber.number", QCP.equals, groupnumber)});
        if (purchases.length <= 0) {
            return;
        }
        Arrays.stream(purchases).forEach(pur -> {
            String contractnumber = pur.getString("tpv_contractnumber");//从采购合同中拿到合同号
            String billno = pur.getString("billno");//编码
            purNum.add(billno);
            map_p.put(billno, contractnumber);
        });
        if (sale.length <= 0) {
            return;
        }
        Arrays.stream(sale).forEach(sal -> {
            String contractnumber = sal.getString("tpv_contractnos");//销售合同中的合同号
            String billno = sal.getString("billno");//编码
            saleNum.add(billno);
            map_s.put(billno, contractnumber);
        });
        handDetail(saleNum, map_s);//交单情况
    }


    /**
     * 交单情况分录填充
     *
     * @param billnos
     * @param map
     */
    private void handDetail(List billnos, HashMap<Object, String> map) {
        List<String> srcbillno = new ArrayList<>();
        HashMap<Object, String> maps = new HashMap<>();
        StringBuilder builder = new StringBuilder();
        //货物流转单编号
        for (Object billno : billnos) {
            QFilter qFilterar = new QFilter("tpv_sourcebillno", QCP.equals, billno);
            DynamicObject[] sales = BusinessDataServiceHelper.load("tpv_dt_freigroambill", "billno,tpv_arrpreno,tpv_materialentry,tpv_srcbillno"
                    , new QFilter[]{qFilterar});
            for (DynamicObject sale : sales) {
                String tpvSrcbillno = sale.getString("billno");//
                srcbillno.add(tpvSrcbillno);
                maps.put(tpvSrcbillno, map.get(billno));
                builder.append(tpvSrcbillno).append(",");
            }

        }
        for (Object billno : srcbillno) {
            int i = 0;
            BigDecimal count = BigDecimal.ZERO;//数量
            QFilter qFilters = new QFilter("tpv_sourcebillno", QCP.equals, billno);
            qFilters.and("billstatus", QCP.equals, "C");
            DynamicObject[] arrivaldetais = BusinessDataServiceHelper.load("tpv_es_exportdelivery", "tpv_customer,tpv_amount,tpv_unit,tpv_surrenderdate1,tpv_materialentry,tpv_srcbillno"
                    , new QFilter[]{qFilters});
            if (arrivaldetais.length <= 0) {
                return;
            }
            int[] ints = this.getModel().batchCreateNewEntryRow(ENTRY_HAND, arrivaldetais.length);
            for (DynamicObject sale : arrivaldetais) {
                DynamicObjectCollection maters = sale.getDynamicObjectCollection("tpv_materialentry");
                DynamicObject object = null;
                OrmLocaleValue unit = null;
                if (maters.size() > 0) {
                    object = maters.get(0);
                    unit = (OrmLocaleValue) object.get("tpv_unit.name");
                }
                if (maters.size() != 0) {
                    for (DynamicObject mater : arrivaldetais) {
                        BigDecimal tpyQty = mater.getBigDecimal("tpv_amount");//
                        if (BigDecimal.ZERO.compareTo(tpyQty) != 0) {
                            count = tpyQty.add(count);
                        }
                    }
                }
                DynamicObject customer = sale.getDynamicObject("tpv_customer");
                BigDecimal amount = sale.getBigDecimal("tpv_amount");
                Date surrenderdate1 = sale.getDate("tpv_surrenderdate1");
                this.getModel().setValue("tpv_salescontract", maps.get(billno), ints[i]);//销售合同号
                this.getModel().setValue("tpv_customers", customer, ints[i]);//客户
                this.getModel().setValue("tpv_surrenderdocument", clearComma(builder), ints[i]);//到单单据
                this.getModel().setValue("tpv_deliveries", count, ints[i]);//到单数量
                this.getModel().setValue("tpv_unit", null == unit ? "" : unit.getLocaleValue_zh_CN(), ints[i]);//到单
                this.getModel().setValue("tpv_ordertobepaid", amount, ints[i]);//到单金额
                this.getModel().setValue("tpv_paythesingleday", surrenderdate1, ints[i]);//到单日期
            }
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        query();//查询数据
        bindData();//绑定数据
        int rowCount = this.getModel().getEntryEntity(ENTRY_FIRST).getRowCount();
        if (rowCount > 0) {
            openContainerFrom(0);//打开工作台分录
            arrivalAndHand(0);//打开到单交单情况
        } else {
            BillShowParameter showParameter = new BillShowParameter();
            showParameter.setStatus(OperationStatus.EDIT);
            showParameter.getOpenStyle().setShowType(ShowType.InContainer);
            showParameter.getOpenStyle().setTargetKey("tpv_flexpanelapoi");
            showParameter.setSendToClient(true);
            showParameter.setFormId("tpv_logistics");
            this.getView().showForm(showParameter);
        }
    }

    private void bindData() {
        if (entryList.size() > 0) {
            int i = 0;
            for (HashMap<String, Object> value : entryList) {
                int newEntryRow = this.getModel().createNewEntryRow(ENTRY_FIRST);
                IDataModel object = this.getModel();
                object.setValue("tpv_mark", value.get("tpv_mark"),newEntryRow);//备注
                object.setValue("tpv_combinationfs", value.get("tpv_combinationfs"),newEntryRow);//组合号
                object.setValue("tpv_diversion", value.get("tpv_diversion"),newEntryRow);//出采
                object.setValue("tpv_saless", value.get("tpv_saless"),newEntryRow);//出销
                object.setValue("tpv_reminings", value.get("tpv_reminings"),newEntryRow);//转采
                object.setValue("tpv_resellings", value.get("tpv_resellings"),newEntryRow);//转销
                object.setValue("tpv_purchaser", value.get("tpv_purchaser"),newEntryRow);//原始采购商
                object.setValue("tpv_endcustomer", value.get("tpv_endcustomer"),newEntryRow);//最终客户
                object.setValue("tpv_priceterms", value.get("tpv_priceterms"),newEntryRow);//价格条款
                object.setValue("tpv_commodity", value.get("tpv_commodity"),newEntryRow);//商品
                object.setValue("tpv_qty", value.get("tpv_qty"),newEntryRow);//数量
                object.setValue("tpv_currency", value.get("tpv_currency"),newEntryRow);//币种
                object.setValue("tpv_inbound", value.get("tpv_inbound"),newEntryRow);//累计入库数
                object.setValue("tpv_numberofbills", value.get("tpv_numberofbills"),newEntryRow);//累计开单数
                object.setValue("tpv_remaining", value.get("tpv_remaining"),newEntryRow);//剩余数量
                object.setValue("tpv_periodterms", value.get("tpv_periodterms"),newEntryRow);//回款期条款
                object.setValue("tpv_paymentperiod", value.get("tpv_paymentperiod"),newEntryRow);//最迟回款期
                object.setValue("tpv_remittance", value.get("tpv_remittance"),newEntryRow);//累计收汇金额
                object.setValue("tpv_whetherinorder", value.get("tpv_whetherinorder"),newEntryRow);//是否款齐
                object.setValue("tpv_backoffice", value.get("tpv_backoffice"),newEntryRow);//跟单内勤
                object.setValue("tpv_completed", value.get("tpv_completed"),newEntryRow);//装运完结
                object.setValue("tpv_overdue", value.get("tpv_overdue"),newEntryRow);//是否逾期
                object.setValue("tpv_groupnumber", value.get("tpv_groupnumber"),newEntryRow);//组合号编码(隐藏)
            }
            this.getView().updateView(ENTRY_FIRST); //更新单据体
        } else {
            this.getView().showTipNotification("出口物流工作台暂无数据!");
        }
        extracted();
    }

    private void extracted() {
        DynamicObjectCollection tpv_wms_cklogistics = (DynamicObjectCollection) this.getModel().getValue("tpv_wms_cklogistics_cg");
        List bil = new ArrayList();
        for (DynamicObject tpv_wms_cklogistics_cg : tpv_wms_cklogistics) {
            String combinationfs = tpv_wms_cklogistics_cg.getString("tpv_combinationfs");//组合号
            QFilter qFilterss = new QFilter("billstatus", QCP.equals, "C");//单据已审核
            qFilterss.and("tpv_combinationnumber.name", QCP.equals, combinationfs);//来源单据编码为本单组合号的
            qFilterss.and("tpv_tradeproperty.name", QCP.in, "%出口%");//贸易型质为出口的
            DynamicObject[] tp_freigroambill = BusinessDataServiceHelper.load("tpv_dt_purchase", "billno"
                    , new QFilter[]{qFilterss});
            if (tp_freigroambill.length > 0) {
                for (int h = 0; h < tp_freigroambill.length; h++) {
                    DynamicObject tp_freigro = tp_freigroambill[h];
                    bil.add(tp_freigro.getString("billno"));

                }
            }
        }
        QFilter qFilteres = new QFilter("tpv_sourcebillno", QCP.in, bil);
        String selectfields = DynamicObjectUtil.getSelectfields("tpv_dt_freigroambill", false);
        String entrySelectfields = DynamicObjectUtil.getEntrySelectfields(selectfields, "tpv_dt_freigroambill", "tpv_materialentry", false);
        DynamicObject[] tpv_dt_freigroambill = BusinessDataServiceHelper.load("tpv_dt_freigroambill", entrySelectfields
                , new QFilter[]{qFilteres});
        if (tpv_dt_freigroambill.length > 0) {
            for (int j = 0; j < tpv_dt_freigroambill.length; j++) {
                DynamicObject dt_freigroambill = tpv_dt_freigroambill[j];
                String billno = dt_freigroambill.getString("billno");//单据编号
                String tpv_purcontnum = dt_freigroambill.getString("tpv_purcontnum");//采购合同号
                DynamicObject tpv_supplier = dt_freigroambill.getDynamicObject("tpv_supplier");//供应商
                String tpv_roamaction = dt_freigroambill.getString("tpv_roamaction");//流转动作
                DynamicObject tpv_destports = dt_freigroambill.getDynamicObject("tpv_destports");//目的地
                DynamicObject tpv_destportscust = dt_freigroambill.getDynamicObject("tpv_destportscust");//保管方
                String tpv_comment = dt_freigroambill.getString("tpv_comment");//备注
                DynamicObjectCollection tpvMaterialentry = dt_freigroambill.getDynamicObjectCollection("tpv_materialentry");
                for (DynamicObject dynamicObject : tpvMaterialentry) {
                    int entryRow = this.getModel().createNewEntryRow("tpv_cklogistics_cgdh");
                    DynamicObject tpv_material = dynamicObject.getDynamicObject("tpv_material");//商品编码
                    BigDecimal tpv_qty = dynamicObject.getBigDecimal("tpv_qty");//数量
                    DynamicObject tpv_unit = dynamicObject.getDynamicObject("tpv_unit");//数量单位
                    if (tpv_qty.compareTo(BigDecimal.ZERO) == 1) {
                        this.getModel().setValue("tpv_productids", tpv_material, entryRow);
                        this.getModel().setValue("tpv_commoditys", tpv_material, entryRow);
                        this.getModel().setValue("tpv_quantity", tpv_qty, entryRow);
                        this.getModel().setValue("tpv_quantityunits", tpv_unit, entryRow);
                        this.getModel().setValue("tpv_circulationtracking", billno, entryRow);
                        this.getModel().setValue("tpv_contractnumbers", tpv_purcontnum, entryRow);
                        this.getModel().setValue("tpv_vendor", tpv_supplier, entryRow);
                        this.getModel().setValue("tpv_flowaction", tpv_roamaction, entryRow);
                        this.getModel().setValue("tpv_destination", tpv_destports, entryRow);
                        this.getModel().setValue("tpv_destportscust", tpv_destportscust, entryRow);
                        this.getModel().setValue("tpv_remarks", tpv_comment, entryRow);
                    }
                }
            }
        }
    }

    /**
     * 单据打开初始化界面
     */
    private void openContainerFrom(int index) {
        DynamicObjectCollection entity = this.getModel().getEntryEntity(ENTRY_FIRST);
        if (entity.size() == 0) {
            this.getView().showTipNotification("暂无数据!");
        } else {
            String groupNum = entity.get(index).getString("tpv_groupnumber");//获取组合号
            BillShowParameter showParameter = new BillShowParameter();
            showParameter.setStatus(OperationStatus.EDIT);
            showParameter.getOpenStyle().setShowType(ShowType.InContainer);
            showParameter.getOpenStyle().setTargetKey("tpv_flexpanelapoi");
            showParameter.setSendToClient(true);
            showParameter.setFormId("tpv_logistics");
            DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle("tpv_bd_combination", "id",
                    new QFilter[]{new QFilter("number", QCP.equals, groupNum)});
            showParameter.setPkId(loadSingle.getPkValue());
            this.getView().showForm(showParameter);
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();
        switch (key) {
            case "tpv_addmark":
                if (isSelect()) {
                    addMark(); //判断是否有选中数据
                }
                break;
            case "tpv_query"://查询
                query();
                bindData();//绑定数据
                openContainerFrom(0);//打开工作台分录
                arrivalAndHand(0); //打开到单交单情况
                break;
            default:
                break;
        }
    }

    /**
     * 查询数据
     */
    private void query() {
        ArrayList<String> bustype = new ArrayList<>();//业务类型
        ArrayList<String> combinationNum = new ArrayList<>();//组合号
        IDataModel model = this.getModel();
        model.deleteEntryData(ENTRY_FIRST);//清空分录
        ArrayList<String> combName = new ArrayList<>();//组合号
        //业务类型
        DynamicObject[] bustypes = BusinessDataServiceHelper.load("tpv_bd_bustypes", "name"
                , new QFilter[]{new QFilter("group.name", QCP.equals, "出口")});
        for (DynamicObject dynamicObject : bustypes) {
            String string = dynamicObject.getString("name");
            bustype.add(string);
            //组合号
        }
        DynamicObject[] combinations = BusinessDataServiceHelper.load("tpv_bd_combination", "name,number,tpv_remarkree"
                , new QFilter[]{new QFilter("tpv_businesstype.name", QCP.in, bustype)});
        if (combinations.length > 0) {
            for (DynamicObject object : combinations) {
                String name = object.getString("number");
                combName.add(name);   //组合号编码
            }
            for (DynamicObject object : combinations) {
                String number = object.getString("number");//组合号编码
                String remar = object.getString("tpv_remarkree");//备注
                String combination = object.getString("name");//组合号名称
                combinationNum.add(combination);
                //采购合同过滤字段
            }
        }
        String purchaseFiled = "billno,tpv_contractnumber,tpv_tradeproperty.name,tpv_countryoforigin.name,tpv_supplier,tpv_supplier.tpv_sfjtnbqy,tpv_documentarys.name,tpv_priceterms.name,tpv_currency.name,tpv_dt_purchase_yq,tpv_overduedefinition,tpv_paymentstatus,tpv_whetheitisshipped,tpv_bizdate,tpv_durationofthecontr,tpv_materialentry,tpv_prodname,tpv_qty";
        //销售合同过滤字段
        String saleFiled = "billno,tpv_customer.name,tpv_customer.tpv_enterprise,tpv_contractnos,tpv_paymentstatus,tpv_tradeproperty.name,tpv_overduedefinition.name,tpv_dt_salescontract_y,tpv_bizdate,tpv_contractnos";
        //采购合同
        DynamicObject[] purchases = BusinessDataServiceHelper.load("tpv_dt_purchase", purchaseFiled,
                new QFilter[]{new QFilter("tpv_combinationnumber.name", QCP.in, combinationNum),
                        new QFilter("tpv_supplier.tpv_sfjtnbqy", QCP.equals, false),
                        new QFilter("billstatus", QCP.equals, "C")});
        //销售合同
        DynamicObject[] sale = BusinessDataServiceHelper.load("tpv_dt_salescontract", saleFiled,
                new QFilter[]{new QFilter("tpv_combinationnumber.name", QCP.in, combinationNum),
                        new QFilter("tpv_customer.tpv_enterprise", QCP.equals, false),
                        new QFilter("billstatus", QCP.equals, "C")});
        for (DynamicObject object : combinations) {
            String number = object.getString("number");//组合号编码
            String remar = object.getString("tpv_remarkree");//备注
            //单据体赋值
            HashMap<String, Object> map = new HashMap<>();
            map.put("tpv_mark", remar);//备注
            map.put("groupnumber", number);//组合号编码
            map.put("tpv_combinationfs", combinationNum);//组合号
            map.put("tpv_diversion", reminings(purchases));//出采 Y
            map.put("tpv_saless", saless(sale));//出销 Y
            map.put("tpv_reminings", diversion(purchases));//转采 Y
            map.put("tpv_resellings", resell(sale));//转销 Y
            map.put("tpv_purchaser", originPurchase(purchases));//原采购商 Y
            map.put("tpv_priceterms", priceClause(purchases));//价格条款 Y
            map.put("tpv_currency", currency(purchases));//币别 Y
            map.put("tpv_endcustomer", finalCustomer(sale));//最终客户
            map.put("tpv_commodity", commodity(purchases));//商品 Y
            map.put("tpv_qty", count(purchases));//数量 Y
            BigDecimal reNum = (BigDecimal) repertoryNum(purchases);
            map.put("tpv_inbound", reNum);//累计入库数
            BigDecimal allNum = (BigDecimal) allBillNum(sale);
            map.put("tpv_numberofbills", allNum);//累计开单数
            map.put("tpv_remaining", BigDecimalUtils.sub(reNum, allNum, 2));//剩余数量(累计入库数-累计开单数)
            map.put("tpv_periodterms", patbackitem(sale));//回款期条款 Y
            map.put("tpv_paymentperiod", lastpayback(sale));//最迟回款期 Y
            map.put("tpv_remittance", allrateamount(sale));//累计收汇金额
            map.put("tpv_whetherinorder", ifamountok(sale));//是否款齐
            map.put("tpv_backoffice", documentwork(purchases));//跟单内勤
            map.put("tpv_completed", shipover(purchases));//装运完结
            map.put("tpv_overdue", islate(purchases));//是否逾期
            map.put("tpv_groupnumber", number);//组合号编码
            entryList.add(map);
        }
    }


    /**
     * 是否逾期
     *
     * @param purchases
     * @return
     */
    private Object islate(DynamicObject[] purchases) {
//        for (DynamicObject whetheitisshipped : purchases) {
//            String number = whetheitisshipped.getString("number");
//            QFilter qFilter = new QFilter("tpv_sourcebillno", QCP.equals, number);
//            qFilter.and("billstatus", QCP.equals, "C");
//            qFilter.and("",QCP.equals,true);//装运完结等于完结的
//            DynamicObject[] vatinvoice = BusinessDataServiceHelper.load("tpv_dt_freigroambill", "id,billno，createtime"
//                    , new QFilter[]{qFilter}, null);
//            if (vatinvoice.length > 0) {
//                for (int i = 0; i < vatinvoice.length; i++) {
//                    DynamicObject custmain = vatinvoice[i];
//                    Date a = custmain.getDate("起运日期");
//                    Date b = custmain.getDate("最迟装运日期");
//                    Date date = new Date();
//                    Date c = a;
//                    int year = date.getDay() - 7;
//                    c.setDate(year);
//                    if (a.compareTo(b)<0) {
//                       return "A";
//                    }
//                    if (a.compareTo(b)>0) {
//                        return "B";
//                    }
//                    if (c.compareTo(date)<0) {
//                        return "C";
//                    }
//                    if (c.compareTo(date)>0) {
//                        return "D";
//                    }
//                    if (c.compareTo(date)<0 || c.compareTo(date) == 0) {
//                        return "E";
//                    }
//                }
//            }
//        }

        return null;
    }

    /**
     * 装运完结
     *
     * @param purchases
     * @return
     */
    private Object shipover(DynamicObject[] purchases) {
        int isFlag = 0;
        for (DynamicObject whetheitisshipped : purchases) {
            boolean aBoolean = whetheitisshipped.getBoolean("tpv_whetheitisshipped");  //是否装运齐
            if (!aBoolean) {
                isFlag++;
            }
        }
        if (isFlag == 0) {
            return "A";
        } else {
            return "B";
        }

    }

    /**
     * 跟单内勤
     *
     * @param purchases
     * @return
     */
    private Object documentwork(DynamicObject[] purchases) {
        StringBuilder nbasedata = new StringBuilder();
        for (DynamicObject countryoforigin : purchases) {
            String documentarys = countryoforigin.getString("tpv_documentarys.name");
            if (documentarys != null) {
                nbasedata.append(documentarys).append(",");
            }
        }
        return clearComma(nbasedata);
    }

    /**
     * 是否款齐
     *
     * @param sale
     * @return
     */
    private Object ifamountok(DynamicObject[] sale) {
        boolean isFlag = true;
        for (DynamicObject ismoney : sale) {
            String paymentstatus = ismoney.getString("tpv_paymentstatus");
            if (paymentstatus != "B") {
                isFlag = false;
                break;
            }
        }
        return isFlag;
    }

    /**
     * 累计收汇金额
     *
     * @param sale
     * @return
     */
    private Object allrateamount(DynamicObject[] sale) {
        return null;
    }

    /**
     * 最迟回款期
     *
     * @param sale
     * @return
     */
    private Object lastpayback(DynamicObject[] sale) {
        StringBuilder lastpay = new StringBuilder();
        for (DynamicObject last : sale) {
            String contractnumber = last.getString("tpv_contractnos");
            Date bizdate = last.getDate("tpv_bizdate");
            String formatDate = DateUtil.formatDate(bizdate);
            String lasttime = contractnumber + ":" + formatDate;
            lastpay.append(lasttime).append(",");
        }
        return clearComma(lastpay);
    }

    /**
     * 回款期条款
     *
     * @param sale
     * @return
     */
    private Object patbackitem(DynamicObject[] sale) {
        StringBuilder overduedefinitionname = new StringBuilder();
        for (DynamicObject cumsingular : sale) {
            DynamicObjectCollection entrys = cumsingular.getDynamicObjectCollection("tpv_dt_salescontract_y");
            for (DynamicObject entity : entrys) {
                String overduedefinition = entity.getString("tpv_overduedefinition.name");
                overduedefinitionname.append(overduedefinition).append(",");
            }
        }
        return clearComma(overduedefinitionname);
    }


    /**
     * 累计开单数
     *
     * @return
     */
    private Object allBillNum(DynamicObject[] sale) {
        BigDecimal sunnum = BigDecimal.ZERO;//总数量
        List<String> srcbillno = new ArrayList<>();
        List list = new ArrayList<>();
        for (int j = 0; j < sale.length; j++) {
            Object id = sale[j].get("billno");
            list.add(id);
        }
        //销售合同
        for (Object billno : list) {
            DynamicObject[] sales = BusinessDataServiceHelper.load("tpv_dt_salescontract", "billno,tpv_materialentry,tpv_srcbillno", new QFilter[]{new QFilter("tpv_materialentry.tpv_srcbillno", QCP.equals, billno)});
            for (DynamicObject sale1 : sales) {
                String tpvSrcbillno = sale1.getString("billno");//数量
                srcbillno.add(tpvSrcbillno);
            }
        }
        //销售发货
        for (String billno : srcbillno) {
            DynamicObject[] salesshipping = BusinessDataServiceHelper.load("tpv_dt_salesshipping", "tpv_materialentry,tpv_qty,tpv_customer",
                    new QFilter[]{new QFilter("tpv_materialentry.tpv_srcbillno", QCP.equals, billno)});
            for (DynamicObject sales : salesshipping) {
                DynamicObjectCollection materialentry = sales.getDynamicObjectCollection("tpv_materialentry");
                for (DynamicObject mater : materialentry) {
                    sunnum = sunnum.add(mater.getBigDecimal("tpv_qty"));//数量
                }
            }
        }
        return sunnum;
    }

    /**
     * 累计入库数
     *
     * @return
     */
    private Object repertoryNum(DynamicObject[] purchases) {
        BigDecimal sunnum = BigDecimal.ZERO;//总数量
        List<String> srcbillno = new ArrayList<>();
        List list = new ArrayList<>();
        for (int j = 0; j < purchases.length; j++) {
            Object id = purchases[j].get("billno");
            list.add(id);
        }
        //货物流转单
        for (Object billno : list) {
            DynamicObject[] sales = BusinessDataServiceHelper.load("tpv_dt_freigroambill", "billno,tpv_materialentry,tpv_srcbillno", new QFilter[]{new QFilter("tpv_materialentry.tpv_srcbillno", QCP.equals, billno)});
            for (DynamicObject sale : sales) {
                String tpvSrcbillno = sale.getString("billno");//数量
                srcbillno.add(tpvSrcbillno);
            }
        }
        for (Object billno : srcbillno) {
            DynamicObject[] sales = BusinessDataServiceHelper.load("im_purinbill", "billentry,srcbillnumber,qty", new QFilter[]{new QFilter("tpv_materialentry.tpv_srcbillno", QCP.equals, billno)});
            for (DynamicObject sale : sales) {
                DynamicObjectCollection materialentry = sale.getDynamicObjectCollection("billentry");
                if (materialentry.size() != 0) {
                    for (DynamicObject mater : materialentry) {
                        sunnum = sunnum.add(mater.getBigDecimal("qty"));//数量
                    }
                }
            }
        }
        return sunnum;
    }

    /**
     * 数量
     *
     * @param purchases
     * @return
     */
    private Object count(DynamicObject[] purchases) {
        BigDecimal sum = BigDecimal.ZERO;//总数量
        for (DynamicObject amount : purchases) {
            DynamicObjectCollection entrys = amount.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject entity : entrys) {
                sum = sum.add(entity.getBigDecimal("tpv_qty"));
            }
        }
        return sum;
    }

    /**
     * 商品
     *
     * @return
     */
    private Object commodity(DynamicObject[] purchases) {
        StringBuilder commodity = new StringBuilder();
        for (DynamicObject purchase : purchases) {
            DynamicObjectCollection collection = purchase.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject object : collection) {
                commodity.append(object.getString("tpv_prodname.group.name")).append(",");
            }
        }
        return clearComma(commodity);
    }

    /**
     * 最终客户
     *
     * @param sale
     * @return
     */
    private Object finalCustomer(DynamicObject[] sale) {
        StringBuilder customer = new StringBuilder();
        for (DynamicObject bill : sale) {
            customer.append(bill.getString("tpv_customer.name")).append(",");
        }
        return clearComma(customer);
    }

    /**
     * 币别
     *
     * @param purchases
     * @return
     */
    private Object currency(DynamicObject[] purchases) {
        StringBuilder currencyname = new StringBuilder();
        for (DynamicObject purchase : purchases) {
            DynamicObject supplier = purchase.getDynamicObject("tpv_supplier");  //供应商
            String currency = purchase.getString("tpv_currency.name");  //币别
            if (supplier != null) {
                if (true) {
                    if (currency != null) {
                        currencyname.append(currency).append(",");
                    }
                }
            }
        }
        return clearComma(currencyname);
    }

    /**
     * 价格条款
     *
     * @param purchases
     * @return
     */
    private Object priceClause(DynamicObject[] purchases) {
        StringBuilder pricetermsname = new StringBuilder();
        for (DynamicObject purchase : purchases) {
            DynamicObject supplier = purchase.getDynamicObject("tpv_supplier");  //供应商
            String priceterms = purchase.getString("tpv_priceterms.name");  //价格条款
            if (supplier != null) {
                if (true) {
                    if (priceterms != null) {
                        pricetermsname.append(priceterms).append(",");
                    }
                }
            }
        }
        return clearComma(pricetermsname);
    }

    /**
     * 原始供应商
     *
     * @param purchases
     * @return
     */
    private Object originPurchase(DynamicObject[] purchases) {
        StringBuilder suppliername = new StringBuilder();
        for (DynamicObject purchase : purchases) {
            DynamicObject supplier = purchase.getDynamicObject("tpv_supplier");  //供应商
            if (supplier != null) {
                String sname = supplier.getString("name");
                if (true) {
                    if (sname != null) {
                        suppliername.append(sname).append(",");
                    }
                }
            }
        }
        return clearComma(suppliername);

    }

    /**
     * 转销
     *
     * @param sale
     * @return
     */
    private Object resell(DynamicObject[] sale) {
        StringBuilder nbasedata = new StringBuilder();
        for (DynamicObject object : sale) {
            String tname = object.getString("tpv_tradeproperty.name");
            String contractnumber = object.getString("tpv_contractnos");
            if (tname != null) {
                if ("国内贸易".equals(tname)) {
                    nbasedata.append(contractnumber).append(",");
                }
            }
        }
        return clearComma(nbasedata);
    }

    /**
     * 转采
     *
     * @return
     */
    private Object diversion(DynamicObject[] purchases) {
        StringBuilder nbasedata = new StringBuilder();
        for (DynamicObject object : purchases) {
            String tname = object.getString("tpv_tradeproperty.name");
            String contractnumber = object.getString("tpv_contractnumber");

            if (tname != null) {
                if ("国内贸易".equals(tname)) {
                    nbasedata.append(contractnumber).append(",");
                }
            }
        }
        return clearComma(nbasedata);
    }

    /**
     * 出销
     *
     * @param sale
     * @return
     */
    private Object saless(DynamicObject[] sale) {
        StringBuilder nbasedata = new StringBuilder();
        for (DynamicObject object : sale) {
            String tname = object.getString("tpv_tradeproperty.name");
            String contractnumber = object.getString("tpv_contractnos");
            if (tname != null) {
                if ("出口业务".equals(tname)) {
                    nbasedata.append(contractnumber).append(",");
                }
            }
        }
        return clearComma(nbasedata);
    }

    /**
     * 出采
     *
     * @return
     */
    private Object reminings(DynamicObject[] purchases) {
        StringBuilder nbasedata = new StringBuilder();
        for (DynamicObject object : purchases) {
            String tname = object.getString("tpv_tradeproperty.name");
            String contractnumber = object.getString("tpv_contractnumber");
            if (tname != null) {
                if ("出口业务".equals(tname)) {
                    nbasedata.append(contractnumber).append(",");
                }
            }
        }
        return clearComma(nbasedata);
    }

    /**
     * 去除最后的,
     *
     * @param builder
     */
    public String clearComma(StringBuilder builder) {
        //去除最后的，
        if (0 < builder.length()) {
            String string = builder.toString();
            return StringUtils.substring(string, 0, string.length() - 1);
        }
        return null;
    }

    /**
     * 是否已选择数据
     *
     * @return
     */
    private boolean isSelect() {
        //获取分录选中行
        EntryGrid entryGrid = this.getControl(ENTRY_FIRST);
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length == 0) {
            this.getView().showTipNotification("请先选择一条数据!");
            return false;
        } else {
            entryIndex.put(ENTRY_FIRST, selectRows[0]);
            return true;

        }
    }

    /**
     * 添加备注
     */
    private void addMark() {
        //创建动态表达页面对象
        FormShowParameter showParameter = new FormShowParameter();
        //设置页面ID
        showParameter.setFormId("tpv_wms_mark");
        //状态
        showParameter.setStatus(OperationStatus.ADDNEW);
        //设置回调
        showParameter.setCloseCallBack(new CloseCallBack(this, "mark"));
        // 设置弹出页面打开方式
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        // 打开动态表单
        this.getView().showForm(showParameter);
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
        String returnData = (String) closedCallBackEvent.getReturnData();
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "mark") && null != returnData) {
            this.getModel().setValue("tpv_mark", returnData, entryIndex.get(ENTRY_FIRST));
        }
        String groupnumber = (String) getModel().getValue("tpv_groupnumber");
        DynamicObject[] remarkr = BusinessDataServiceHelper.load("tpv_bd_combination", "tpv_remarkree",
                new QFilter[]{new QFilter("number", QCP.equals, groupnumber)});
        if (remarkr.length > 0) {
            for (int i = 0; i < remarkr.length; i++) {
                String tpv_mark = (String) this.getModel().getValue("tpv_mark");
                if (tpv_mark != null) {
                    remarkr[i].set("tpv_remarkree", tpv_mark);
                    SaveServiceHelper.update(remarkr);
                }
            }
        }
    }
}
