package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.itopview.wm.utils.YEM;
import kd.bos.coderule.api.CodeRuleInfo;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.coderule.CodeRuleServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.Date;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * @ClassName: CurfactorEdit
 * @Description: 期现要素修正
 * @author: zbh
 * @date: 2024-08-22
 */
public class CurfactorEdit extends AbstractFormPlugin {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok"});
    }


    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IFormView parentView = this.getView().getParentView();
        IDataModel parentModel = parentView.getModel();
        String tpvHedgetype = (String) parentModel.getValue("tpv_hedgetype");
        if (!"B".equals(tpvHedgetype)){
            this.getView().setVisible(false,"tpv_deliveryform","tpv_deliveryto");
        }
        IDataModel model = this.getModel();
        DataEntityPropertyCollection properties = model.getDataEntityType().getProperties();
        for (IDataEntityProperty property : properties) {
            String propName = property.getName();
            if (parentModel.getProperty(propName) != null) {
                Object propValue = parentModel.getValue(propName);
                if (propValue instanceof DynamicObject) {
                    DynamicObject obj = (DynamicObject) propValue;
                    model.setValue(propName, obj.getPkValue());
                } else {
                    model.setValue(propName, propValue);
                }
            }
        }
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
                this.btnOk();
                break;
        }
    }

    private void btnOk() {
        IFormView parentView = this.getView().getParentView();
        IDataModel parentModel = parentView.getModel();
        Map<String, String> fieldName = entryFieldName(parentModel.getDataEntityType().getName());
        DynamicObject tpvTmCashforlog = BusinessDataServiceHelper.newDynamicObject("tpv_tm_cashforlog");
        Date date = new Date();

        CodeRuleInfo codeRule = CodeRuleServiceHelper.getCodeRule("tpv_tm_cashforlog", tpvTmCashforlog, null);
        String billno = CodeRuleServiceHelper.getNumber(codeRule, tpvTmCashforlog);

        tpvTmCashforlog.set("billno", billno);//单机编号
        tpvTmCashforlog.set("tpv_chanoperator", YEM.getCurrentUserId());//修改人
        tpvTmCashforlog.set("tpv_bizdate", date);//修改日期
        tpvTmCashforlog.set("tpv_changbill", parentModel.getDataEntityType().getName());

        DynamicObject tpvPolicynumber = (DynamicObject) parentModel.getValue(fieldName.get("tpv_strategynum"));//合同 策略号
        DynamicObject policynumber = (DynamicObject) this.getModel().getValue("tpv_policynumber");
        tpvTmCashforlog.set("tpv_changbillnum", parentModel.getValue(fieldName.get("tpv_contractnos")));//修改单据编号
        tpvTmCashforlog.set("tpv_policynumber", policynumber);//策略号
        StringBuilder tpvChange = new StringBuilder();
        if (policynumber == null && tpvPolicynumber == null) {
            tpvTmCashforlog.set("tpv_policychan", "2");//策略变更
        } else if ((policynumber == null && tpvPolicynumber != null) || (policynumber != null && tpvPolicynumber == null)) {
            tpvTmCashforlog.set("tpv_policychan", "1");//策略变更
            if (policynumber == null && tpvPolicynumber != null){
                tpvChange.append("策略号：").append(tpvPolicynumber.getString("name")).append("→").append("").append("\n");
            } else if (policynumber != null && tpvPolicynumber == null) {
                tpvChange.append("策略号：").append("").append("→").append(policynumber.getString("name")).append("\n");
            }
        }else {
            long id1 = policynumber.getLong("id");
            long id2 = tpvPolicynumber.getLong("id");
            if (id1==id2){
                tpvTmCashforlog.set("tpv_policychan", "2");//策略变更
            }else {
                tpvTmCashforlog.set("tpv_policychan", "1");//策略变更
                tpvChange.append("策略号：").append(tpvPolicynumber.getString("name")).append("→").append(policynumber.getString("name")).append("\n");
            }
        }

        BigDecimal tpvPadjustment = (BigDecimal) this.getModel().getValue("tpv_padjustment");//基价调整
        BigDecimal tpv_policynumber = (BigDecimal) parentModel.getValue("tpv_padjustment");//基价调整
        if (tpvPadjustment.compareTo(tpv_policynumber)!=0){
            tpvChange.append("基价调整：").append(tpv_policynumber).append("→").append(tpvPadjustment).append("\n");
        }
        BigDecimal tpvBaseprice = (BigDecimal) this.getModel().getValue("tpv_baseprice");//基价价格
        BigDecimal tpv_baseprice = (BigDecimal) parentModel.getValue("tpv_baseprice");//基价价格
        if (tpvBaseprice.compareTo(tpv_baseprice)!=0){
            tpvChange.append("基价调整：").append(tpv_baseprice).append("→").append(tpvBaseprice).append("\n");
        }
        DynamicObject tpvSalesarea = (DynamicObject) this.getModel().getValue("tpv_salesarea");//销售大区
        DynamicObject tpv_salesarea = (DynamicObject)parentModel.getValue(fieldName.get("tpv_salesregion"));//销售大区
        if (tpvSalesarea == null && tpv_salesarea != null){
            tpvChange.append("销售大区：").append(tpv_salesarea.getString("name")).append("→").append("").append("\n");
        } else if (tpvSalesarea != null && tpv_salesarea == null) {
            tpvChange.append("销售大区：").append("").append("→").append(tpvSalesarea.getString("name")).append("\n");
        }else if (tpvSalesarea != null && tpv_salesarea != null){
            long id1 = tpvSalesarea.getLong("id");
            long id2 = tpv_salesarea.getLong("id");
            if (id1!=id2){
                tpvChange.append("销售大区：").append(tpv_salesarea.getString("name")).append("→").append(tpvSalesarea.getString("name")).append("\n");
            }
        }
        DynamicObject tpvBasepriceitems = (DynamicObject) this.getModel().getValue("tpv_basepriceitems");//基价商品
        DynamicObject tpv_basepriceitems = (DynamicObject) parentModel.getValue(fieldName.get("tpv_basegoods"));//基价商品
        if (tpvBasepriceitems == null && tpv_basepriceitems != null){
            tpvChange.append("基价商品：").append(tpv_basepriceitems.getString("name")).append("→").append("").append("\n");
        } else if (tpvBasepriceitems != null && tpv_basepriceitems == null) {
            tpvChange.append("基价商品：").append("").append("→").append(tpvBasepriceitems.getString("name")).append("\n");
        }else if (tpvBasepriceitems != null && tpv_basepriceitems != null){
            long id1 = tpvBasepriceitems.getLong("id");
            long id2 = tpv_basepriceitems.getLong("id");
            if (id1!=id2){
                tpvChange.append("基价商品：").append(tpv_basepriceitems.getString("name")).append("→").append(tpvBasepriceitems.getString("name")).append("\n");
            }
        }

        Date tpvDeliveryform = (Date) this.getModel().getValue("tpv_deliveryform");//交货期从
        Date tpv_deliveryform = (Date) parentModel.getValue("tpv_deliveryform");//交货期从
       if (tpvDeliveryform!=tpv_deliveryform){
           tpvChange.append("交货期从：").append(tpv_deliveryform).append("→").append(tpvDeliveryform).append("\n");
       }
        Date tpvDeliveryto = (Date) this.getModel().getValue("tpv_deliveryto");//交货期至
        Date tpv_deliveryto = (Date) parentModel.getValue("tpv_deliveryto");//交货期至
        if (tpvDeliveryto!=tpv_deliveryto){
            tpvChange.append("交货期至：").append(tpv_deliveryto).append("→").append(tpvDeliveryto).append("\n");
        }

        DynamicObject[] claimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", "billno,tpv_strategyname,tpv_region,tpv_basegoods,tpv_contractbaseprice", new QFilter[]{new QFilter("tpv_datasourcesid", "=", parentModel.getValue("id").toString())});
        StringBuilder builder = new StringBuilder();
        for (DynamicObject claimdetail : claimdetails) {
            claimdetail.set("tpv_strategyname",policynumber);//策略名称
            claimdetail.set("tpv_region",tpv_salesarea);//大区
            claimdetail.set("tpv_basegoods",tpv_salesarea);//基价商品
            claimdetail.set("tpv_contractbaseprice",tpv_baseprice);//合同基价
//            claimdetail.set("","");
            if (builder.length() == 0) {
                builder.append(claimdetail.getString("billno"));
            } else {
                builder.append(",").append(claimdetail.getString("billno"));
            }
        }

        tpvTmCashforlog.set("tpv_claimdetails", builder);//对应认领明细单号
        tpvTmCashforlog.set("billstatus", "A");//单据状态
        tpvTmCashforlog.set("tpv_change",tpvChange);//修改内容
        tpvTmCashforlog.set("tpv_version", "1");//版本号
        tpvTmCashforlog.set("org", YEM.getCurrentOrgId());//版本号
        SaveServiceHelper.save(new DynamicObject[]{tpvTmCashforlog});
        SaveServiceHelper.save(claimdetails);

        IFormView view = this.getView();
        IDataModel model = this.getModel();
        parentView.getPageCache().put("TplCallBackEdit", String.valueOf(true));
        DataEntityPropertyCollection properties = model.getDataEntityType().getProperties();
        for (IDataEntityProperty property : properties) {
            String propName = property.getName();
            if (parentModel.getProperty(propName) != null) {
                Object propValue = model.getValue(propName);
                if (propValue instanceof DynamicObject) {
                    DynamicObject obj = (DynamicObject) propValue;
                    parentModel.setValue(propName, obj.getPkValue());
                } else {
                    parentModel.setValue(propName, propValue);
                }
            }
        }
        view.sendFormAction(parentView);
        //view.returnDataToParent("tpv_dy_ok");
        view.close();
    }
    public static Map<String, String> entryFieldName(String entityName) {
        Map<String, String> map = new HashMap<>();
        String contractnos="";//合同号
        String strategynum="";//策略号
        String alesarea="";//销售大区
        String basepriceitems="";//基价商品
        switch (entityName) {
            case"tpv_dt_salescontract"://销售合同(原始)
                strategynum="tpv_strategynum";
                alesarea="tpv_salesregion";
                basepriceitems="tpv_basegoods";
                contractnos="tpv_contractnos";
                break;
            case"tpv_dt_purchase"://采购合同(原始)
                strategynum="tpv_policynumber";
                alesarea="tpv_salesarea";
                basepriceitems="tpv_basepriceitems";
                contractnos="tpv_contractnumber";
                break;
        }
        map.put("tpv_strategynum", strategynum); //策略号
        map.put("tpv_salesregion", alesarea); //销售大区
        map.put("tpv_basegoods", basepriceitems); //基价商品
        map.put("tpv_contractnos", contractnos); //合同号
        return map;
    }
}
