package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;


import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.data.BusinessDataReader;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.botp.runtime.SourceBillReport;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.IRefrencedataProvider;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.IFormView;
import kd.bos.form.MessageTypes;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.ProgressBar;
import kd.bos.form.control.events.ProgressEvent;
import kd.bos.form.control.events.ProgresssListener;
import kd.bos.form.events.ClientCallBackEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.logging.Log;
import kd.bos.logging.LogFactory;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;

import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 直运工作台进度栏
 * WangShuGuang
 */
public class DirectconsEdit extends AbstractFormPlugin implements ProgresssListener {

    private final String TPV_DT_PURCHASE = "tpv_dt_purchase";//采购合同标识

    private final String TPV_DT_FREIGROAMBILL = "tpv_dt_freigroambill";//货物流转单标识

    private final String TPV_DT_PURINBILL = "im_purinbill";//采购入库单标识

    private final String IM_OTHEROUTBILL = "im_otheroutbill";//其他出库单

    private final String IM_OTHERINBILL = "im_otherinbill";//其他入库单

    private final String TPV_DT_SALESSHIPPING = "tpv_dt_salesshipping";//销售发货

    private final String IM_SALOUTBILL = "im_saloutbill";//销售出库

    @Override
    public void registerListener(EventObject e) {
        ProgressBar progressBar = this.getControl("tpv_progressbarap");
        progressBar.addProgressListener(this);
    }

    @Override
    public void onProgress(ProgressEvent progressEvent) {
        ProgressBar progressBar = this.getControl("tpv_progressbarap");
        progressBar.stop();
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
//        ProgressBar progressBar = this.getControl("tpv_progressbarap");
//        progressBar.start();
        this.getView().addClientCallBack("tpv_callback");
    }

    @Override
    public void clientCallBack(ClientCallBackEvent e) {
        super.clientCallBack(e);
        switch (e.getName()) {
            case "tpv_callback":
                IFormView view = this.getView().getParentView();
                // 获取单据体选中行
                EntryGrid entryGrid = view.getControl("tpv_sonentryentity");
                int[] selectRows = entryGrid.getSelectRows();
                //获取单据主实体
                DynamicObject dataEntity = view.getModel().getDataEntity(true);
                //获取分录数据
                DynamicObjectCollection tpvSonentryentity = view.getModel().getEntryEntity("tpv_sonentryentity");
                pushOperation(tpvSonentryentity, selectRows, dataEntity);
                break;
        }
    }

    private void pushOperation(DynamicObjectCollection tpvSonentryentity, int[] selectRows, DynamicObject dataEntity) {
        List<String> tips = new ArrayList<>();
        List<ListSelectedRow> selectedRowsPur = new ArrayList<>();//合同下推行集合
        List<ListSelectedRow> selectedRowsHWLZ = new ArrayList<>();//货物流转下推行集合
//        List<ListSelectedRow> selectedRowsOut = new ArrayList<>();//采购入库下推其他出库
//        List<ListSelectedRow> selectedRowsIn = new ArrayList<>();//采购入库下推其他入库
        List<Long> selectedRowsOutId = new ArrayList<>();//需要推其他出库单的底表分录id集合
        List<Long> selectedRowsInId = new ArrayList<>();//需要推其他入库单的底表分录id集合
        List<Map<String, Object>> pushParam = new ArrayList<>();
        Long tpv_fentryid_zy = dataEntity.getLong("tpv_fentryid_zy");//采购分录行ID
        Long tpv_fid_zy = dataEntity.getLong("tpv_fid_zy");//采购单据ID
        String tpvFatherpickbill = dataEntity.getString("tpv_pickbill_zy");//配货单据
        ListSelectedRow listSelectedRowPur = new ListSelectedRow(tpv_fid_zy);//来源单据ID
        listSelectedRowPur.setEntryEntityKey("tpv_materialentry");//来源单据单据体标识
        listSelectedRowPur.setEntryPrimaryKeyValue(tpv_fentryid_zy);//来源单据分录ID
        //如果 【父配货单据】=“采购合同”，则《采购合同》→直运《货物流转单》→直运《采购入库单》
        //如果 【父配货单据】=“货物流转单”，则《货物流转单》→直运《入库单》
        if (StringUtils.equals(tpvFatherpickbill, TPV_DT_PURCHASE)) {
            //父配货单据为采购合同时
            selectedRowsPur.add(listSelectedRowPur);
        } else if (StringUtils.equals(tpvFatherpickbill, TPV_DT_FREIGROAMBILL)) {
            //父配货单据为货物流转单时
            selectedRowsHWLZ.add(listSelectedRowPur);
        }
        Long zyEntryId = dataEntity.getLong("id");
        QFilter qFilter = new QFilter("tpv_materialentry.tpv_dt_salepick_zy.id", QCP.equals, zyEntryId);
        String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_salesshipping");
        DynamicObject tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
        DynamicObject tpvEntrepot = tpvScBusinessnatures.getDynamicObject("tpv_entrepot");//发货仓库
        DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(tpvScBusinessnatures.getLong("id"), "tpv_dt_salesshipping");
        List<Map<String, Object>> feesInfoParams = feesInfoParams(loadSingle, zyEntryId); //费用信息分录
        for (int selectRow : selectRows) {
            DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
            Map<String, Object> dateMap = new HashMap<>(); //pushParam 下推传参
            BigDecimal tpvPurchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");//采提数量
            BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");//销提数量
            BigDecimal tpvGaplimit = dynamicObject.getBigDecimal("tpv_gaplimit");//差额
            BigDecimal abs = tpvGaplimit.abs();
            if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && tpvDestroyquantity.compareTo(BigDecimal.ZERO) != 0) {
                Long tpv_materials = YEM.isNotEmpty(dynamicObject.getDynamicObject("tpv_materials"))
                        ? dynamicObject.getDynamicObject("tpv_materials").getLong("id") : 0L;
                dateMap.put("tpv_materials", tpv_materials);//商品
                Long tpv_prodnames = YEM.isNotEmpty(dynamicObject.getDynamicObject("tpv_prodnames"))
                        ? dynamicObject.getDynamicObject("tpv_prodnames").getLong("id") : 0L;
                dateMap.put("tpv_prodnames", tpv_prodnames);//品名
                dateMap.put("tpv_customtagss", dynamicObject.getString("tpv_customtagss"));//自定标签
                dateMap.put("tpv_purchasequantity", tpvPurchasequantity);//采提数量
                dateMap.put("tpv_destroyquantity", tpvDestroyquantity);//销提数量
                dateMap.put("tpv_shaders", dynamicObject.getString("tpv_shaders"));//材质
                dateMap.put("tpv_specations", dynamicObject.getString("tpv_specations"));//规格
                Long tpv_origins = YEM.isNotEmpty(dynamicObject.getDynamicObject("tpv_origins"))
                        ? dynamicObject.getDynamicObject("tpv_origins").getLong("id") : 0L;
                dateMap.put("tpv_origins", tpv_origins);//产地
                dateMap.put("tpv_ofpackages", dynamicObject.getBigDecimal("tpv_ofpackages"));//包装数量
                dateMap.put("tpv_directconsignmentid", dynamicObject.getLong("id"));//底表分录id
                dateMap.put("tpv_fentryid_zy", dataEntity.getLong("tpv_fentryid_zy"));//采购分录行ID
                dateMap.put("tpv_entrytaxprice", dynamicObject.getBigDecimal("tpv_entrytaxprice"));//商品分录含税单价
                if (tpvGaplimit.compareTo(BigDecimal.ZERO) != 0) {
                    dateMap.put("tpv_gaplimit", abs);//差额
                } else {
                    dateMap.put("tpv_gaplimit", BigDecimal.ZERO);//差额
                }
                pushParam.add(dateMap);
                int number = tpvPurchasequantity.compareTo(tpvDestroyquantity);
                if (number > 0) {
                    selectedRowsOutId.add((Long) dynamicObject.getPkValue());
                }
                if (number < 0) {
                    selectedRowsInId.add((Long) dynamicObject.getPkValue());
                }
            }
        }

        if (selectedRowsHWLZ.size() > 0) {
            pushHWLZToPurIn(tpvSonentryentity, dataEntity, tpvEntrepot, selectedRowsHWLZ, selectRows,
                    selectedRowsInId, selectedRowsOutId, JSONObject.toJSONString(pushParam), feesInfoParams, tips);
        }
        if (selectedRowsPur.size() > 0) {
            pushPurConToPurIn(selectedRowsPur, selectRows, tpvSonentryentity, tpvEntrepot, pushParam, feesInfoParams, dataEntity,
                    selectedRowsInId, selectedRowsOutId, tips);
        }
//        Map<String, String> returnDataMap = new HashMap<>();
        if (tips.size() > 0) {
            String errMsg = "";
            int msgSeq = 1;
            for (String tip : tips) {
                errMsg += String.format("%s、%s%s", msgSeq++, tip, "\r\n");
            }
            this.getView().getParentView().showMessage("存在异常单据，详情如下。", errMsg, MessageTypes.Default);
//            returnDataMap.put("isSucess","No");
        } else {
            this.getView().getParentView().showSuccessNotification("出入库成功！");
        }
//        returnDataMap.put("isSucess","Yes");
//        this.getView().returnDataToParent(returnDataMap);
        this.getView().sendFormAction(this.getView().getParentView());
        this.getView().close();
    }

    /**
     * 采购合同下推 货物流转单 下推货物流转单
     * */
    private void pushPurConToPurIn(List<ListSelectedRow> listSelectedRows, int[] selectRows, DynamicObjectCollection tpvSonentryentity, DynamicObject tpvEntrepot,
                                   List<Map<String, Object>> pushParam, List<Map<String, Object>> feesInfoParams, DynamicObject dataEntity,
                                   List<Long> selectedRowsInId, List<Long> selectedRowsOutId, List<String> tips) {
        //父配货单据为采购合同时
        String sourceEntityNumber = TPV_DT_PURCHASE;//采购合同
        String targetEntityNumber = TPV_DT_FREIGROAMBILL;//货物流转单标识
        String ruleId = "1794891423833659392";
        PushArgs pushArgs = new PushArgs();
        pushArgs.setSourceEntityNumber(sourceEntityNumber); // 必选，源单标识
        pushArgs.setTargetEntityNumber(targetEntityNumber); // 必选，目标单标识
        pushArgs.addCustomParam("tpv_longList", JSONObject.toJSONString(pushParam));
        pushArgs.addCustomParam("tpv_longList_id", String.valueOf(dataEntity.getLong("tpv_fentryid_zy")));
        pushArgs.setRuleId(ruleId); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
        pushArgs.setBuildConvReport(true); // 是否输出详细错误报告
        pushArgs.setSelectedRows(listSelectedRows); // 必选，设置需要下推的源单及分录内码
        ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
        if (pushResult.isSuccess()) {
            MainEntityType targetMainType = EntityMetadataCache
                    .getDataEntityType(pushArgs.getTargetEntityNumber());
            List<DynamicObject> targetBillObjs = pushResult
                    .loadTargetDataObjects(new IRefrencedataProvider() {
                        @Override
                        public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                            BusinessDataReader.loadRefence(objs, dType);
                        }
                    }, targetMainType);
            if (targetBillObjs.size() > 0) {
                DynamicObject targetBillObj = targetBillObjs.get(0);
                targetBillObj.set("tpv_approva",true);
                targetBillObj.set("tpv_makeway","B");
                //下游单赋值仓库和产地
                setWarehouse(targetBillObj, tpvEntrepot, tpvSonentryentity);
                if (auditBill(targetBillObj, tips)) {
                    DynamicObjectCollection objectCollectionS = targetBillObj.getDynamicObjectCollection("tpv_materialentry");
                    List<Object> objectList = new ArrayList<>();
                    for (DynamicObject dynamicObject : objectCollectionS) {
                        objectList.add(dynamicObject.get("id"));
                    }
                    /**
                     * 货物流转推采购入库
                     */
                    List<ListSelectedRow> selectedRowsSo = new ArrayList<>();
                    Long pkValue = (Long) targetBillObj.getPkValue();
                    for (Object o : objectList) {
                        ListSelectedRow listSelectedRow = new ListSelectedRow(pkValue);//来源单据ID
                        listSelectedRow.setEntryEntityKey("tpv_materialentry");//来源单据单据体标识
                        listSelectedRow.setEntryPrimaryKeyValue(o);//来源单据分录ID
                        selectedRowsSo.add(listSelectedRow);
                    }
                    pushHWLZToPurIn(tpvSonentryentity, dataEntity, tpvEntrepot, selectedRowsSo, selectRows,
                            selectedRowsInId, selectedRowsOutId, "",  feesInfoParams, tips);
                }
            }
        } else {
            addCovertMsg(targetEntityNumber, pushResult, tips);
        }
    }
    /**
     * 货物流转单 下推采购入库单
     * */
    private void pushHWLZToPurIn(DynamicObjectCollection tpvSonentryentity, DynamicObject dataEntity, DynamicObject tpvEntrepot, List<ListSelectedRow> listSelectedRows,
                                 int[] selectRows, List<Long> selectedRowsInId, List<Long> selectedRowsOutId, String pushParamStr, List<Map<String, Object>> feesInfoParams,
                                 List<String> tips) {
        PushArgs pushArgsSo = new PushArgs();
        pushArgsSo.setSourceEntityNumber(TPV_DT_FREIGROAMBILL); // 必选，源单标识selectedRowsOut
        pushArgsSo.setTargetEntityNumber(TPV_DT_PURINBILL); // 必选，目标单标识
        pushArgsSo.setRuleId("1796759229428710400"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
        pushArgsSo.setBuildConvReport(true); // 是否输出详细错误报告
        pushArgsSo.addCustomParam("tpv_longList", pushParamStr);
//        pushArgsSo.addCustomParam("tpv_longList_feesinfo", feesInfoParams);
        pushArgsSo.addCustomParam("tpv_longList_id", String.valueOf(dataEntity.getLong("tpv_fentryid_zy")));
        pushArgsSo.setSelectedRows(listSelectedRows); // 必选，设置需要下推的源单及分录内码
        ConvertOperationResult pushResultSo = ConvertServiceHelper.push(pushArgsSo);
        if (pushResultSo.isSuccess()) {
            MainEntityType targetMainTypeS = EntityMetadataCache
                    .getDataEntityType(pushArgsSo.getTargetEntityNumber());
            List<DynamicObject> targetBillObjsS = pushResultSo
                    .loadTargetDataObjects(new IRefrencedataProvider() {
                        @Override
                        public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                            BusinessDataReader.loadRefence(objs, dType);
                        }
                    }, targetMainTypeS);
            if (targetBillObjsS.size() > 0) {
                DynamicObject hwDynamic = targetBillObjsS.get(0);
                hwDynamic.set("tpv_approva",true);
                //otherInbillentry，留存其他入库数据，将一并插入销售发货拣配库存子分录里，作出库
                DynamicObject otherInDynamic = null;
                DynamicObjectCollection otherInbillentry = new DynamicObjectCollection();
                //采购入库复制仓库
                setWarehouse(hwDynamic, tpvEntrepot, tpvSonentryentity);
                feesInfoSubEntryAdd(feesInfoParams, hwDynamic);


                if (auditBill(hwDynamic, tips)) {
                    // 1.将入库单号插入底表分录的入库单号字段
                    //2。判断销提数量和采提数量之间的值在进行下一步下推
                    setEntryRowInAndOutBillno(tpvSonentryentity, selectRows);
                    if (selectedRowsInId.size() > 0) {
                        //自动盘盈入库（做《其他入库单》）
                        //采购入库下推其他入库
                        otherInDynamic = pushInventoryPofitIn(tpvSonentryentity, selectRows, selectedRowsInId, hwDynamic, tips);
                    }
                    if (selectedRowsOutId.size() > 0) {
                        //则自动盘亏出库（自动选择刚才的《入库单》做盘亏类型的《其他出库单》
                        //采购入库下推其他出库
                        pushInventoryLossIn(tpvSonentryentity, selectRows, selectedRowsOutId, hwDynamic, tips);
                    }
                    QFilter qFilter = new QFilter("tpv_materialentry.tpv_dt_salepick_zy", QCP.equals, dataEntity.getLong("id"));
                    DynamicObject queryOne = QueryServiceHelper.queryOne("tpv_dt_salesshipping",
                            "id,tpv_materialentry.id entryid,tpv_materialentry.tpv_dt_salepick_zy.id subentryzyid", new QFilter[]{qFilter});
                    DynamicObject tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", new QFilter[]{qFilter});
                    Map<Long, DynamicObject> enetryMap = tpvSonentryentity.stream().collect(Collectors.toMap(x -> x.getLong("id"), y -> y));

                    DynamicObjectCollection objectCollectionH = tpvScBusinessnatures.getDynamicObjectCollection("tpv_materialentry");
                    DynamicObjectCollection billentry = hwDynamic.getDynamicObjectCollection("billentry");
                    if (YEM.isNotEmpty(otherInDynamic)) {
                        otherInbillentry = otherInDynamic.getDynamicObjectCollection("billentry");
                    }
                    List<Object> objectList = new ArrayList<>();
                    for (DynamicObject dynamicObjectH : objectCollectionH) {
                        DynamicObjectCollection qtpvDtSalepickZy = dynamicObjectH.getDynamicObjectCollection("tpv_dt_salepick_in");
                        Long pkValue1 = (Long) dynamicObjectH.getPkValue();
                        if (String.valueOf(queryOne.getLong("entryid")).equals(pkValue1.toString())) {
                            for (DynamicObject object : billentry) {
                                DynamicObject dynamicObject1 = qtpvDtSalepickZy.addNew();
                                long tpvDirectconsignmentid = object.getLong("tpv_directconsignmentid");
                                DynamicObject enerty = enetryMap.get(tpvDirectconsignmentid);
                                if (null != enerty) {
                                    BigDecimal tpvPurchasequantity = enerty.getBigDecimal("tpv_purchasequantity");//采提数量
                                    BigDecimal tpvDestroyquantity = enerty.getBigDecimal("tpv_destroyquantity");//销提数量
                                    BigDecimal qty = tpvPurchasequantity.compareTo(tpvDestroyquantity) > 0 ? tpvDestroyquantity : tpvPurchasequantity;
                                    dynamicObject1.set("tpv_pickqty_in", qty);//本次配货数量
                                    dynamicObject1.set("tpv_pickqtyrecord_in", qty);//本次配货数量(记录)
                                    BigDecimal tpvEntrytaxprice = BigDecimalUtils.toBigDecimal(enerty.getBigDecimal("tpv_entrytaxprice"));
                                    BigDecimal taxamt = tpvEntrytaxprice.multiply(qty).setScale(2, BigDecimal.ROUND_HALF_UP);
                                    dynamicObject1.set("tpv_taxprice_in", tpvEntrytaxprice);//含税单价
                                    dynamicObject1.set("tpv_taxpramount_in", taxamt);//含税金额
                                    dynamicObject1.set("tpv_taxpricerecord_in", tpvEntrytaxprice);//含税单价（记录）
                                }
                                dynamicObject1.set("id", ORM.create().genLongId(dynamicObject1.getDataEntityType()));
                                dynamicObject1.set("tpv_pickbill_in", "im_purinbill");//配货单据为采购入库
                                dynamicObject1.set("tpv_billno_in", hwDynamic.getString("billno"));//单据编号
                                dynamicObject1.set("tpv_warehouse_in", object.getDynamicObject("warehouse"));//仓库
                                if (YEM.isNotEmpty(object.getDynamicObject("material"))) {
                                    dynamicObject1.set("tpv_material_in", object.getDynamicObject("material")
                                            .get("masterid"));//商品编码
                                }
                                dynamicObject1.set("tpv_department_in", hwDynamic.getDynamicObject("bizdept"));//部门
                                if (YEM.isNotEmpty(hwDynamic.getDynamicObject("tpv_combinationnumber"))) {
                                    dynamicObject1.set("tpv_strategy_in", hwDynamic.getDynamicObject("tpv_combinationnumber")
                                            .getDynamicObject("tpv_strategy"));//策略号
                                }
                                dynamicObject1.set("tpv_tradeproperty_in", hwDynamic.getDynamicObject("tpv_tradeproperty"));//贸易性质
                                dynamicObject1.set("tpv_supplier_in", hwDynamic.getDynamicObject("supplier"));//供应商
                                dynamicObject1.set("tpv_combination_in", hwDynamic.getDynamicObject("tpv_combinationnumber"));//组合号
                                dynamicObject1.set("tpv_pickbilltype_in", hwDynamic.getDynamicObject("billtype"));//单据类型

                                dynamicObject1.set("tpv_prodname_in", object.getDynamicObject("tpv_prodname"));//品名
                                dynamicObject1.set("tpv_specation_in", object.getString("tpv_specation"));//规格
                                dynamicObject1.set("tpv_customtags_in", object.getString("tpv_customtags"));//自定标签
                                dynamicObject1.set("tpv_shader_in", object.getString("tpv_shader"));//材质
                                dynamicObject1.set("tpv_origin_in", object.getDynamicObject("tpv_origin"));//产地
                                dynamicObject1.set("tpv_measure", object.getDynamicObject("unit"));//计量单位
                                dynamicObject1.set("tpv_packagingunit_in", object.getDynamicObject("tpv_packagingunit"));//包装单位
                                dynamicObject1.set("tpv_packnum_in", object.getBigDecimal("tpv_packnum"));//本次配货包装数量
                                dynamicObject1.set("tpv_picknumrecord_in", object.getBigDecimal("tpv_packnum"));//本次配货包装数量(记录)
                                dynamicObject1.set("tpv_fid_in", hwDynamic.getPkValue());//采购单据id
                                dynamicObject1.set("tpv_fentryid_in", object.getPkValue());//采购分录行ID
                                dynamicObject1.set("tpv_fcoentryid_in", object.getLong("conbillentryid"));//采购合同行ID
                                dynamicObject1.set("tpv_contractmark", YEM.isNotEmpty(object.getDynamicObject("tpv_contractnumber"))
                                        ? object.getDynamicObject("tpv_contractnumber").getString("tpv_name") : "");//合同号
                                //根据直运实提工作台底表表头的实提完毕赋值插入
                                dynamicObject1.set("tpv_practicalok_in", dataEntity.getBoolean("tpv_practicalok_zy"));
                                dynamicObject1.set("tpv_directconsignmentid", object.getLong("tpv_directconsignmentid"));//直运工作台底表分录id
                                if (dynamicObjectH.getBigDecimal("tpv_confirmed").compareTo(BigDecimal.ZERO) != 0) {
                                    //如果父分录以价格确认数量不为空
                                    dynamicObject1.set("tpv_thequantity", dynamicObjectH.getBigDecimal("tpv_confirmed"));//采购合同行ID
                                }
                                objectList.add(dynamicObject1.getPkValue());
                            }
                            for (DynamicObject object : otherInbillentry) {
                                DynamicObject dynamicObject1 = qtpvDtSalepickZy.addNew();
                                long tpvDirectconsignmentid = object.getLong("tpv_directconsignmentid");
                                DynamicObject enerty = enetryMap.get(tpvDirectconsignmentid);
                                if (null != enerty) {
                                    BigDecimal qty = object.getBigDecimal("qty");
                                    dynamicObject1.set("tpv_pickqty_in", qty);//本次配货数量
                                    dynamicObject1.set("tpv_pickqtyrecord_in", qty);//本次配货数量(记录)
                                    BigDecimal tpvEntrytaxprice = BigDecimalUtils.toBigDecimal(enerty.getBigDecimal("tpv_entrytaxprice"));
                                    BigDecimal taxamt = tpvEntrytaxprice.multiply(qty).setScale(2, BigDecimal.ROUND_HALF_UP);
                                    dynamicObject1.set("tpv_taxprice_in", tpvEntrytaxprice);//含税单价
                                    dynamicObject1.set("tpv_taxpramount_in", taxamt);//含税金额
                                    dynamicObject1.set("tpv_taxpricerecord_in", tpvEntrytaxprice);//含税单价（记录）
                                }
                                dynamicObject1.set("id", ORM.create().genLongId(dynamicObject1.getDataEntityType()));
                                dynamicObject1.set("tpv_pickbill_in", "im_otherinbill");//配货单据为采购入库
                                dynamicObject1.set("tpv_billno_in", otherInDynamic.getString("billno"));//单据编号
                                if (YEM.isNotEmpty(object.getDynamicObject("material"))) {
                                    dynamicObject1.set("tpv_material_in", object.getDynamicObject("material")
                                            .get("masterid"));//商品编码
                                }
                                dynamicObject1.set("tpv_department_in", otherInDynamic.getDynamicObject("bizdept"));//部门
                                if (YEM.isNotEmpty(object.getDynamicObject("tpv_contractnumber"))) {
                                    dynamicObject1.set("tpv_supplier_in", object.getDynamicObject("tpv_contractnumber")
                                            .getDynamicObject("tpv_supplier"));//供应商
                                    dynamicObject1.set("tpv_tradeproperty_in", object.getDynamicObject("tpv_contractnumber")
                                            .getDynamicObject("tpv_tradenature"));//贸易性质
                                    dynamicObject1.set("tpv_strategy_in", object.getDynamicObject("tpv_contractnumber")
                                            .getDynamicObject("tpv_tacticsnum"));//策略号
                                }
                                dynamicObject1.set("tpv_combination_in", object.getDynamicObject("tpv_combination"));//组合号
                                dynamicObject1.set("tpv_pickbilltype_in", otherInDynamic.getDynamicObject("billtype"));//单据类型

                                dynamicObject1.set("tpv_warehouse_in", object.getDynamicObject("warehouse"));//仓库
                                dynamicObject1.set("tpv_prodname_in", object.getDynamicObject("tpv_prodname"));//品名
                                dynamicObject1.set("tpv_specation_in", object.getString("tpv_specation"));//规格
                                dynamicObject1.set("tpv_customtags_in", object.getString("tpv_customtags"));//自定标签
                                dynamicObject1.set("tpv_shader_in", object.getString("tpv_shader"));//材质
                                dynamicObject1.set("tpv_origin_in", object.getDynamicObject("tpv_origin"));//产地
                                dynamicObject1.set("tpv_measure", object.getDynamicObject("unit"));//计量单位
                                dynamicObject1.set("tpv_packagingunit_in", object.getDynamicObject("tpv_packagingunit"));//包装单位
                                dynamicObject1.set("tpv_packnum_in", object.getBigDecimal("tpv_packnum"));//包装数量
                                dynamicObject1.set("tpv_picknumrecord_in", object.getBigDecimal("tpv_packnum"));//本次配货包装数量(记录)
                                dynamicObject1.set("tpv_fid_in", otherInDynamic.getPkValue());//采购单据id
                                dynamicObject1.set("tpv_fentryid_in", object.getPkValue());//采购分录行ID
                                dynamicObject1.set("tpv_contractmark", YEM.isNotEmpty(object.getDynamicObject("tpv_contractnumber"))
                                        ? object.getDynamicObject("tpv_contractnumber").getString("tpv_name") : "");//合同号
                                dynamicObject1.set("tpv_practicalok_in", dataEntity.getBoolean("tpv_practicalok_zy"));//实提完毕
                                //dynamicObject1.set("tpv_fcoentryid_in", object.getLong("conbillentryid"));//采购合同行ID
                                dynamicObject1.set("tpv_directconsignmentid", object.getLong("tpv_directconsignmentid"));//直运工作台底表分录id
                                if (dynamicObjectH.getBigDecimal("tpv_confirmed").compareTo(BigDecimal.ZERO) != 0) {
                                    //如果父分录以价格确认数量不为空
                                    dynamicObject1.set("tpv_thequantity", dynamicObjectH.getBigDecimal("tpv_confirmed"));//采购合同行ID
                                }
                                objectList.add(dynamicObject1.getPkValue());
                            }
                            OperationResult saveT = OperationServiceHelper.executeOperate("save", TPV_DT_SALESSHIPPING,
                                    new DynamicObject[]{tpvScBusinessnatures}, YEM.getOption());
                            List<ListSelectedRow> selectedRowsTwo = new ArrayList<>();
                            if (saveT.isSuccess()) {
                                //自动根据《销售发货单》｛拣配库存子分录｝生成《销售出库单》
                                Long pkValueTwo = (Long) tpvScBusinessnatures.getPkValue();
                                if (objectList.size() > 0) {
                                    for (Object object : objectList) {
                                        ListSelectedRow listSelectedRowTwo = new ListSelectedRow(pkValueTwo);//来源单据ID
                                        listSelectedRowTwo.setSubEntryEntityKey("tpv_dt_salepick_in");//来源单据单据体标识
                                        listSelectedRowTwo.setSubEntryPrimaryKeyValue(object);//来源单据分录ID
                                        selectedRowsTwo.add(listSelectedRowTwo);
                                    }
                                }
                            }
                            PushArgs pushArgsTwo = new PushArgs();
                            pushArgsTwo.setSourceEntityNumber(TPV_DT_SALESSHIPPING); // 必选，源单标识
                            pushArgsTwo.setTargetEntityNumber(IM_SALOUTBILL); // 必选，目标单标识
                            pushArgsTwo.setRuleId("1798694713818135552"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
                            pushArgsTwo.setBuildConvReport(true); // 是否输出详细错误报告
                            pushArgsTwo.setSelectedRows(selectedRowsTwo); // 必选，设置需要下推的源单及分录内码
                            ConvertOperationResult pushResultTwo = ConvertServiceHelper.push(pushArgsTwo);
                            if (pushResultTwo.isSuccess()) {
                                MainEntityType targetMainTypeOne = EntityMetadataCache
                                        .getDataEntityType(pushArgsTwo.getTargetEntityNumber());
                                List<DynamicObject> targetBillObjsOne = pushResultTwo
                                        .loadTargetDataObjects(new IRefrencedataProvider() {
                                            @Override
                                            public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                                                BusinessDataReader.loadRefence(objs, dType);
                                            }
                                        }, targetMainTypeOne);
                                if (targetBillObjsOne.size() > 0) {
                                    DynamicObject targetBillObjOne = targetBillObjsOne.get(0);
//                                    targetBillObjOne.set("tpv_approva",true);
                                    //直运推过来的全都默认 【单行出库】
                                    DynamicObjectCollection dynamicObjects = targetBillObjOne.getDynamicObjectCollection("billentry");
                                    for (DynamicObject dynamicObject : dynamicObjects) {
                                        dynamicObject.set("tpv_isrowout",true);
                                    }
                                    if (auditBill(targetBillObjOne, tips)) {
                                        setEntryRowInAndOutBillno(tpvSonentryentity, selectRows);
                                    }
                                }
                            } else {
                                addCovertMsg(IM_SALOUTBILL, pushResultTwo, tips);
                            }
                        }
                    }
                }
            }
        } else {
            addCovertMsg(TPV_DT_PURINBILL, pushResultSo, tips);
        }
    }

    /**
     * 费用子分录信息，携带至采购入库单费用信息子分录
     * */
    private static void feesInfoSubEntryAdd(List<Map<String, Object>> feesInfoParams, DynamicObject hwDynamic) {
        QFilter qFilterfee = new QFilter("enable", QCP.equals, "1");
        DynamicObject[] er_expenseitemedit = BusinessDataServiceHelper.load("er_expenseitemedit", "id", qFilterfee.toArray());
        DynamicObject[] bd_supplier = BusinessDataServiceHelper.load("bd_supplier","id", qFilterfee.toArray());
        DynamicObject[] bd_currency = BusinessDataServiceHelper.load("bd_currency","id", qFilterfee.toArray());
        Map<Long, DynamicObject> mapExpenseitem = new HashMap<>();
        if (er_expenseitemedit.length > 0) {
            for (DynamicObject dynamicObject : er_expenseitemedit) {
                mapExpenseitem.put(dynamicObject.getLong("id"), dynamicObject);
            }
        }
        Map<Long, DynamicObject> mapSupplier = new HashMap<>();
        if (bd_supplier.length > 0) {
            for (DynamicObject dynamicObject : bd_supplier) {
                mapSupplier.put(dynamicObject.getLong("id"), dynamicObject);
            }
        }
        Map<Long, DynamicObject> mapCurrency = new HashMap<>();
        if (bd_currency.length > 0) {
            for (DynamicObject dynamicObject : bd_currency) {
                mapCurrency.put(dynamicObject.getLong("id"), dynamicObject);
            }
        }
        DynamicObjectCollection objectCollection = hwDynamic.getDynamicObjectCollection("billentry");
        for (int i = 0; i < objectCollection.size(); i++) {
            DynamicObject dynamicObject = objectCollection.get(i);
            DynamicObjectCollection tpv_dt_purinbill_f = dynamicObject.getDynamicObjectCollection("tpv_dt_purinbill_f");
            if (feesInfoParams.size() > 0) {
                for (Map<String, Object> parseObject : feesInfoParams) {
                    DynamicObject addNew = tpv_dt_purinbill_f.addNew();
                    addNew.set("tpv_costitem", mapExpenseitem.containsKey(parseObject.get("tpv_expenseitems"))
                            ? mapExpenseitem.get(parseObject.get("tpv_expenseitems")) : null);
                    addNew.set("tpv_supplier", mapSupplier.containsKey(parseObject.get("tpv_providers"))
                            ? mapSupplier.get(parseObject.get("tpv_providers")) : null);
                    addNew.set("tpv_reimbursement", mapCurrency.containsKey(parseObject.get("tpv_costcurrencyes"))
                            ? mapCurrency.get(parseObject.get("tpv_costcurrencyes")) : null);
                    addNew.set("tpv_chargequantity", dynamicObject.getBigDecimal("qty"));
                    addNew.set("tpv_univalence", BigDecimalUtils.toBigDecimal(parseObject.get("tpv_unitprices")));
                    addNew.set("tpv_amt", dynamicObject.getBigDecimal("qty").multiply(BigDecimalUtils.toBigDecimal(parseObject.get("tpv_unitprices"))));
                    addNew.set("tpv_taxrate", BigDecimalUtils.toBigDecimal(parseObject.get("tpv_taxrate")));
                    addNew.set("tpv_desc", parseObject.get("tpv_desc"));
                    addNew.set("tpv_costrate", BigDecimal.ONE);
                }
            }
        }
    }

    /**
     * 采购入库下推 其他出库单 盘亏
     * */
    private void pushInventoryLossIn(DynamicObjectCollection tpvSonentryentity, int[] selectRows, List<Long> selectedRowsOutId, DynamicObject hwDynamic, List<String> tips) {
        List<ListSelectedRow> selectedRowsSoBig = new ArrayList<>();
        DynamicObjectCollection objectCollection = hwDynamic.getDynamicObjectCollection("billentry");
        List<Object> list = new ArrayList<>();
        for (DynamicObject dynamicObject : objectCollection) {
            for (Long longS : selectedRowsOutId) {
                if (longS.equals(dynamicObject.getLong("tpv_directconsignmentid"))) {
                    list.add(dynamicObject.getPkValue());
                }
            }
        }
        if (list.size() > 0) {
            for (Object object : list) {
                ListSelectedRow listSelectedRowBig = new ListSelectedRow(hwDynamic.getPkValue());//来源单据ID
                listSelectedRowBig.setEntryEntityKey("billentry");//来源单据单据体标识
                listSelectedRowBig.setEntryPrimaryKeyValue(object);//来源单据分录ID
                selectedRowsSoBig.add(listSelectedRowBig);
            }
        }
        PushArgs pushArgsSo = new PushArgs();
        pushArgsSo.setSourceEntityNumber(TPV_DT_PURINBILL); // 必选，源单标识
        pushArgsSo.setTargetEntityNumber(IM_OTHEROUTBILL); // 必选，目标单标识
        pushArgsSo.setRuleId("1802873477284251648"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
        pushArgsSo.setBuildConvReport(true); // 是否输出详细错误报告
        pushArgsSo.setSelectedRows(selectedRowsSoBig); // 必选，设置需要下推的源单及分录内码
        ConvertOperationResult pushResultSoBig = ConvertServiceHelper.push(pushArgsSo);
        if (pushResultSoBig.isSuccess()) {
            MainEntityType mainEntityTypeBig = EntityMetadataCache
                    .getDataEntityType(pushArgsSo.getTargetEntityNumber());
            List<DynamicObject> dynamicObjectsBig = pushResultSoBig
                    .loadTargetDataObjects(new IRefrencedataProvider() {
                        @Override
                        public void fillReferenceData(Object[] objects, IDataEntityType iDataEntityType) {
                            BusinessDataReader.loadRefence(objects, iDataEntityType);
                        }
                    }, mainEntityTypeBig);
            if (dynamicObjectsBig.size() > 0) {
                DynamicObject dynamicObjectBig = dynamicObjectsBig.get(0);
                dynamicObjectBig.set("tpv_approva",true);
                if (auditBill(dynamicObjectBig, tips)) {
                    //将其他出库单的单据编号插入底表盘亏单号中
                    setEntryRowInAndOutBillno(tpvSonentryentity, selectRows);
                }
            }
        } else {
            addCovertMsg(IM_OTHEROUTBILL, pushResultSoBig, tips);
        }
    }
    /**
     * 采购入库下推 其他入库单 盘盈
     * */
    private DynamicObject pushInventoryPofitIn(DynamicObjectCollection tpvSonentryentity, int[] selectRows, List<Long> selectedRowsInId, DynamicObject hwDynamic, List<String> tips) {
        List<ListSelectedRow> selectedRowsSoBig = new ArrayList<>();
        DynamicObjectCollection objectCollection = hwDynamic.getDynamicObjectCollection("billentry");
        List<Object> list = new ArrayList<>();
        for (DynamicObject dynamicObject : objectCollection) {
            for (Long longS : selectedRowsInId) {
                if (longS.equals(dynamicObject.getLong("tpv_directconsignmentid"))) {
                    list.add(dynamicObject.getPkValue());
                }
            }
        }
        if (list.size() > 0) {
            for (Object o : list) {
                ListSelectedRow listSelectedRowBig = new ListSelectedRow(hwDynamic.getPkValue());//来源单据ID
                listSelectedRowBig.setEntryEntityKey("billentry");//来源单据单据体标识
                listSelectedRowBig.setEntryPrimaryKeyValue(o);//来源单据分录ID
                selectedRowsSoBig.add(listSelectedRowBig);
            }
        }
        PushArgs pushArgsSo = new PushArgs();
        pushArgsSo.setSourceEntityNumber(TPV_DT_PURINBILL); // 必选，源单标识
        pushArgsSo.setTargetEntityNumber(IM_OTHERINBILL); // 必选，目标单标识
        pushArgsSo.setRuleId("1802872035223816192"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
        pushArgsSo.setBuildConvReport(true); // 是否输出详细错误报告
        pushArgsSo.setSelectedRows(selectedRowsSoBig); // 必选，设置需要下推的源单及分录内码
        ConvertOperationResult pushResultSoBig = ConvertServiceHelper.push(pushArgsSo);
        if (pushResultSoBig.isSuccess()) {
            MainEntityType mainEntityTypeBig = EntityMetadataCache
                    .getDataEntityType(pushArgsSo.getTargetEntityNumber());
            List<DynamicObject> dynamicObjectsBig = pushResultSoBig
                    .loadTargetDataObjects(new IRefrencedataProvider() {
                        @Override
                        public void fillReferenceData(Object[] objects, IDataEntityType iDataEntityType) {
                            BusinessDataReader.loadRefence(objects, iDataEntityType);
                        }
                    }, mainEntityTypeBig);
            if (dynamicObjectsBig.size() > 0) {
                DynamicObject dynamicObjectBig = dynamicObjectsBig.get(0);
                dynamicObjectBig.set("tpv_approva",true);
                if (auditBill(dynamicObjectBig, tips)) {
                    //将其他入库单的单据编号插入底表盘盈单号中
                    setEntryRowInAndOutBillno(tpvSonentryentity, selectRows);
                    return dynamicObjectBig;
                }
            }
        } else {
            addCovertMsg(IM_OTHERINBILL, pushResultSoBig, tips);
        }
        return null;
    }
    /**
     * 生成出入库单，分录赋值单据编号
     * */
    public void setEntryRowInAndOutBillno(DynamicObjectCollection tpvSonentryentity, int[] selectRows) {
        IFormView parentView = this.getView().getParentView();
        IDataModel parentViewModel = parentView.getModel();
        for (int selectRow : selectRows) {
            DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
            BigDecimal tpvPurchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");//采提数量
            BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");//采提数量
            String tpvFatherpickbill = dynamicObject.getString("tpv_fatherpickbill"); //父配货单据
            Long id = (Long) dynamicObject.getPkValue();
            if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && tpvDestroyquantity.compareTo(BigDecimal.ZERO) != 0) {
                //货物流转单 ——父配货单据为采购合同，会有下推货物流转单动作，判断是否存在已生成货物流转单数据
                if ("tpv_dt_purchase".equals(tpvFatherpickbill)) {
                    DynamicObject tpv_dt_freigroambill = BusinessDataServiceHelper.loadSingle("tpv_dt_freigroambill", "billno",
                            new QFilter("tpv_materialentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    if (null != tpv_dt_freigroambill) {
                        //插入货物流转单号
                        parentViewModel.setValue("tpv_freigroambillno", tpv_dt_freigroambill.getString("billno"), selectRow);
                        dynamicObject.set("tpv_freigroambillno", tpv_dt_freigroambill.getString("billno"));
                    } else {
                        parentViewModel.setValue("tpv_freigroambillno", null, selectRow);
                        dynamicObject.set("tpv_freigroambillno", null);
                    }
                }
                //采购入库
                DynamicObject tpv_dt_purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id,billno",
                        new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                //销售出库
                DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno," +
                                "billentry,billentry.tpv_isrowout,billentry.tpv_directconsignmentid",
                        new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                int bigSmal = tpvPurchasequantity.compareTo(tpvDestroyquantity);
                if (bigSmal == 0) {
                    //销提数量等于采提数量查询采购入库单号和销售出库单号
                    setEntryBillno(dynamicObject, selectRow, tpv_dt_purinbill, im_saloutbill);
                }
                if (bigSmal > 0) {
                    //采提数量大于销提数量时查询入库单号 出库单号 盘亏单号
                    //其他出库
                    DynamicObject im_otheroutbill = BusinessDataServiceHelper.loadSingle("im_otheroutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    setEntryBillno(dynamicObject, selectRow, tpv_dt_purinbill, im_saloutbill);
                    if (null != im_otheroutbill) {
                        //插入盘亏单号
                        parentViewModel.setValue("tpv_lossodd", im_otheroutbill.getString("billno"), selectRow);
                        dynamicObject.set("tpv_lossodd", im_otheroutbill.getString("billno"));
                    } else {
                        parentViewModel.setValue("tpv_lossodd", null, selectRow);
                        dynamicObject.set("tpv_lossodd", null);
                    }
                }
                if (bigSmal < 0) {
                    //采提数量小于销提数量时查询入库单号 出库单号 盘盈单号
                    //其他入库
                    DynamicObject im_otherinbill = BusinessDataServiceHelper.loadSingle("im_otherinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    setEntryBillno(dynamicObject, selectRow, tpv_dt_purinbill, im_saloutbill);
                    if (null != im_otherinbill) {
                        //插入出库单号
                        parentViewModel.setValue("tpv_profitodd", im_otherinbill.getString("billno"), selectRow);
                        dynamicObject.set("tpv_profitodd", im_otherinbill.getString("billno"));
                    } else {
                        parentViewModel.setValue("tpv_profitodd", null, selectRow);
                        dynamicObject.set("tpv_profitodd", null);
                    }
                }
                parentView.updateView("tpv_sonbill", selectRow);
                parentView.updateView("tpv_sonbillnos", selectRow);
                parentView.updateView("tpv_godownentry", selectRow);
                parentView.updateView("tpv_deliveryorder", selectRow);
                parentView.updateView("tpv_lossodd", selectRow);
                parentView.updateView("tpv_profitodd", selectRow);
                parentView.updateView("tpv_freigroambillno", selectRow);
            }
        }
//        SaveServiceHelper.save(new DynamicObject[]{parentViewModel.getDataEntity(true)});
    }
    /**
     * 赋值编号
     * */
    private void setEntryBillno(DynamicObject dynamicObject, int selectRow, DynamicObject tpv_dt_purinbill, DynamicObject im_saloutbill) {
        IFormView parentView = this.getView().getParentView();
        IDataModel parentViewModel = parentView.getModel();
        if (null != tpv_dt_purinbill) {
            //插入子配货单据
            parentViewModel.setValue("tpv_sonbill", "im_purinbill", selectRow);
            dynamicObject.set("tpv_sonbill","im_purinbill");
            //插入子配货单据编号
            parentViewModel.setValue("tpv_sonbillnos", tpv_dt_purinbill.getString("billno"), selectRow);
            dynamicObject.set("tpv_sonbillnos",tpv_dt_purinbill.getString("billno"));
            //插入入库单号
            parentViewModel.setValue("tpv_godownentry", tpv_dt_purinbill.getString("billno"), selectRow);
            dynamicObject.set("tpv_godownentry",tpv_dt_purinbill.getString("billno"));
        } else {
            //插入子配货单据
            parentViewModel.setValue("tpv_sonbill", null, selectRow);
            dynamicObject.set("tpv_sonbill",null);
            //插入子配货单据编号
            parentViewModel.setValue("tpv_sonbillnos", null, selectRow);
            dynamicObject.set("tpv_sonbillnos",null);
            parentViewModel.setValue("tpv_godownentry", null, selectRow);
            dynamicObject.set("tpv_godownentry",null);
        }
        if (null != im_saloutbill) {
            //插入出库单号
            parentViewModel.setValue("tpv_deliveryorder", im_saloutbill.getString("billno"), selectRow);
            dynamicObject.set("tpv_deliveryorder",im_saloutbill.getString("billno"));
            DynamicObjectCollection dynamicObjects = im_saloutbill.getDynamicObjectCollection("billentry");
            for (DynamicObject object : dynamicObjects) {
                Long id = object.getLong("tpv_directconsignmentid"); //出库直运底表id
                Long ids = dynamicObject.getLong("id");
                if (id.compareTo(ids) == 0) {
                    parentViewModel.setValue("tpv_isrowout", object.getBoolean("tpv_isrowout"), selectRow);
                    dynamicObject.set("tpv_isrowout",object.getBoolean("tpv_isrowout"));
                    break;
                }
            }
        } else {
            parentViewModel.setValue("tpv_deliveryorder", null, selectRow);
            dynamicObject.set("tpv_deliveryorder",null);
            parentViewModel.setValue("tpv_isrowout", false, selectRow);
            dynamicObject.set("tpv_isrowout",false);
        }
    }
    /**
     * 下推携带赋值仓库
     * */
    public void setWarehouse(DynamicObject targetBillObj, DynamicObject tpvEntrepot, DynamicObjectCollection tpvSonentryentity) {
        String targetBillKey = targetBillObj.getDynamicObjectType().getName();
        Map<Long, DynamicObject> enetryMap = tpvSonentryentity.stream().collect(Collectors.toMap(x -> x.getLong("id"), y -> y));
        //采购入库赋值仓库
        if (StringUtils.equals(targetBillKey, TPV_DT_PURINBILL)) {
            targetBillObj.set("tpv_warehouseentry", tpvEntrepot);
            DynamicObjectCollection objectCollection1 = targetBillObj.getDynamicObjectCollection("billentry");
            for (DynamicObject dynamicObject : objectCollection1) {
                dynamicObject.set("warehouse", tpvEntrepot);
                long tpvDirectconsignmentid = dynamicObject.getLong("tpv_directconsignmentid");
                DynamicObject enerty = enetryMap.get(tpvDirectconsignmentid);
                if (null != enerty) {
                    dynamicObject.set("tpv_origin", enerty.getDynamicObject("tpv_origins"));//产地
                }
            }
        }
        //货物流转单赋值仓库
        if (StringUtils.equals(targetBillKey, TPV_DT_FREIGROAMBILL)) {
            targetBillObj.set("tpv_warehouses", tpvEntrepot);
            DynamicObjectCollection objectCollection1 = targetBillObj.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject dynamicObject : objectCollection1) {
                dynamicObject.set("tpv_warehouse", tpvEntrepot);
                long tpvDirectconsignmentid = dynamicObject.getLong("tpv_directconsignmentid");
                DynamicObject enerty = enetryMap.get(tpvDirectconsignmentid);
                if (null != enerty) {
                    dynamicObject.set("tpv_origin", enerty.getDynamicObject("tpv_origins"));//产地
                }
            }
        }
    }
    /**
     * 费用子分录信息，携带至采购入库单费用信息子分录
     * */
    private static List<Map<String, Object>> feesInfoParams(DynamicObject tpvScBusinessnatures, Long zyEntryId) {
        DynamicObjectCollection tpv_materialentry = tpvScBusinessnatures.getDynamicObjectCollection("tpv_materialentry");
        List<Map<String, Object>> feesInfoList = new ArrayList<>();
        for (DynamicObject materialentry : tpv_materialentry) {
            DynamicObjectCollection tpv_dt_salepick_zy = materialentry.getDynamicObjectCollection("tpv_dt_salepick_zy");
            for (DynamicObject salepick_zy : tpv_dt_salepick_zy) {
                if (zyEntryId.compareTo(salepick_zy.getLong("id")) == 0) {
                    for (DynamicObject dynamicObject : materialentry.getDynamicObjectCollection("tpv_dt_dcostinform_f")) {
                        boolean tpvIsbringinwarehouse = dynamicObject.getBoolean("tpv_isbringinwarehouse");
                        if (tpvIsbringinwarehouse) {
                            Map<String, Object> map = new HashMap<>();
                            map.put("tpv_expenseitems", YEM.isNotEmpty(dynamicObject.getDynamicObject("tpv_expenseitems"))
                                    ? dynamicObject.getDynamicObject("tpv_expenseitems").getLong("id") : 0l); //费用项目
                            map.put("tpv_providers", YEM.isNotEmpty(dynamicObject.getDynamicObject("tpv_providers"))
                                    ? dynamicObject.getDynamicObject("tpv_providers").getLong("id") : 0l); //物流服务商
                            map.put("tpv_costcurrencyes", YEM.isNotEmpty(dynamicObject.getDynamicObject("tpv_costcurrencyes"))
                                    ? dynamicObject.getDynamicObject("tpv_costcurrencyes").getLong("id") : 0l); //费用币别
                            map.put("tpv_unitprices", dynamicObject.getBigDecimal("tpv_unitprices")); //单价
                            map.put("tpv_taxrate", dynamicObject.getBigDecimal("tpv_taxrate")); //税率
                            map.put("tpv_desc", dynamicObject.getString("tpv_desc")); //备注
                            feesInfoList.add(map);
                        }
                    }
                }
            }
        }
        return feesInfoList;
    }

    private void addCovertMsg(String entityNumber, ConvertOperationResult pushResult, List<String> tips) {
        MainEntityType dataEntityType = YEM.getDataEntityType(entityNumber);
        String entityName = dataEntityType.getDisplayName().getLocaleValue();
        String msg = pushResult.getMessage();
        List<SourceBillReport> billReports = pushResult.getBillReports();
        for (int i = 0; i < billReports.size(); i++) {
            SourceBillReport sourceBillReport = billReports.get(i);
            msg = i == 0 ? msg + "。原因:" : msg;
            msg += String.format("%s、%s ", i + 1, sourceBillReport.getFailMessage());
        }
        tips.add(String.format("下推【%s】失败。%s ", entityName, msg));
    }

    /**
     * 审核单据
     *
     * @param targetBillObjOne
     * @param tips
     * @return
     */
    private boolean auditBill(DynamicObject targetBillObjOne, List<String> tips) {
        DynamicObjectType dynamicObjectType = targetBillObjOne.getDynamicObjectType();
        String entityName = dynamicObjectType.getDisplayName().getLocaleValue();
        String entityNumber = dynamicObjectType.getName();
        OperateOption optionOne = YEM.getOption();
        OperationResult saveOne = OperationServiceHelper.executeOperate("save", entityNumber,
                new DynamicObject[]{targetBillObjOne}, optionOne);
        if (saveOne.isSuccess()) {
            OperationResult submitOne = OperationServiceHelper.executeOperate("commitskip",
                    entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
            if (submitOne.isSuccess()) {
                if ("im_saloutbill".equals(entityNumber) || "im_otheroutbill".equals(entityNumber)) {
                    return true;
                } else {
                    OperationResult auditOne = OperationServiceHelper.executeOperate("audit",
                            entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
                    if (auditOne.isSuccess()) {
                        return true;
                    } else {
                        Log log = LogFactory.getLog(this.getClass().getName());
                        log.error(String.format("【%s】审核失败。%s", entityName, auditOne));
                        tips.add(String.format("【%s】审核失败。%s", entityName, YEM.getOpMsg(auditOne)));
                    }
                }
            } else {
                tips.add(String.format("【%s】提交失败。%s", entityName, YEM.getOpMsg(submitOne)));
            }
        } else {
            tips.add(String.format("【%s】保存失败。%s", entityName, YEM.getOpMsg(saveOne)));
        }
        return false;
    }
}
