package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.form.IFormView;
import kd.bos.form.MessageTypes;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.ProgressBar;
import kd.bos.form.control.events.ProgressEvent;
import kd.bos.form.control.events.ProgresssListener;
import kd.bos.form.events.ClientCallBackEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * @ClassName: DirectconsExtractEdit
 * @Description:
 * @author: zbh
 * @date: 2024-07-04
 */
public class DirectconsExtractEdit extends AbstractFormPlugin implements ProgresssListener{
    private final String TPV_DT_PURCHASE = "tpv_dt_purchase";//采购合同标识

    private final String TPV_DT_FREIGROAMBILL = "tpv_dt_freigroambill";//货物流转单标识

    private final String TPV_DT_PURINBILL = "im_purinbill";//采购入库单标识

    private final String IM_OTHEROUTBILL = "im_otheroutbill";//其他出库单

    private final String IM_OTHERINBILL = "im_otherinbill";//其他入库单

    private final String TPV_DT_SALESSHIPPING = "tpv_dt_salesshipping";//销售发货

    private final String IM_SALOUTBILL = "im_saloutbill";//销售出库

    @Override
    public void registerListener(EventObject e) {
        ProgressBar progressBar = this.getControl("tpv_progressbarap");
        progressBar.addProgressListener(this);
    }

    @Override
    public void onProgress(ProgressEvent progressEvent) {
        ProgressBar progressBar = this.getControl("tpv_progressbarap");
        progressBar.stop();
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        this.getView().addClientCallBack("tpv_callback");
    }

    @Override
    public void clientCallBack(ClientCallBackEvent e) {
        super.clientCallBack(e);
        switch (e.getName()) {
            case "tpv_callback":
                IFormView view = this.getView().getParentView();
                // 获取单据体选中行
                EntryGrid entryGrid = view.getControl("tpv_sonentryentity");
                int[] selectRows = entryGrid.getSelectRows();
                //获取单据主实体
                DynamicObject dataEntity = view.getModel().getDataEntity(true);
                //获取分录数据
                DynamicObjectCollection tpvSonentryentity = view.getModel().getEntryEntity("tpv_sonentryentity");
                pushOperation(tpvSonentryentity, selectRows, dataEntity);
                break;
        }
    }

    private void pushOperation(DynamicObjectCollection tpvSonentryentity, int[] selectRows, DynamicObject dataEntity) {
        List<String> tips = new ArrayList<>();
        List<ListSelectedRow> selectedRowsPur = new ArrayList<>();//合同下推行集合
        List<ListSelectedRow> selectedRowsHWLZ = new ArrayList<>();//货物流转下推行集合
//        List<ListSelectedRow> selectedRowsOut = new ArrayList<>();//采购入库下推其他出库
//        List<ListSelectedRow> selectedRowsIn = new ArrayList<>();//采购入库下推其他入库
        List<Long> selectedRowsOutId = new ArrayList<>();//需要推其他出库单的底表分录id集合
        List<Long> selectedRowsInId = new ArrayList<>();//需要推其他入库单的底表分录id集合
        List<Map<String, Object>> pushParam = new ArrayList<>();

        Long tpv_fentryid_zy = dataEntity.getLong("tpv_fentryid_zy");//采购分录行ID
        Long tpv_fid_zy = dataEntity.getLong("tpv_fid_zy");//采购单据ID
        String tpvFatherpickbill = dataEntity.getString("tpv_pickbill_zy");//配货单据
        ListSelectedRow listSelectedRowPur = new ListSelectedRow(tpv_fid_zy);//来源单据ID
        listSelectedRowPur.setEntryEntityKey("tpv_materialentry");//来源单据单据体标识
        listSelectedRowPur.setEntryPrimaryKeyValue(tpv_fentryid_zy);//来源单据分录ID
        //如果 【父配货单据】=“采购合同”，则《采购合同》→直运《货物流转单》→直运《采购入库单》
        //如果 【父配货单据】=“货物流转单”，则《货物流转单》→直运《入库单》
        if (StringUtils.equals(tpvFatherpickbill, TPV_DT_PURCHASE)) {
            //父配货单据为采购合同时
            selectedRowsPur.add(listSelectedRowPur);
        } else if (StringUtils.equals(tpvFatherpickbill, TPV_DT_FREIGROAMBILL)) {
            //父配货单据为货物流转单时
            selectedRowsHWLZ.add(listSelectedRowPur);
        }
        Long zyEntryId = dataEntity.getLong("id");
        QFilter qFilter = new QFilter("tpv_materialentry.tpv_dt_salepick_zy.id", QCP.equals, zyEntryId);
        String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_salesshipping");
        DynamicObject tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
        DynamicObject tpvEntrepot = tpvScBusinessnatures.getDynamicObject("tpv_entrepot");//发货仓库
        DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(tpvScBusinessnatures.getLong("id"), "tpv_dt_salesshipping");
//        List<Map<String, Object>> feesInfoParams = feesInfoParams(loadSingle, zyEntryId); //费用信息分录
        for (int selectRow : selectRows) {
            DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
            Map<String, Object> dateMap = new HashMap<>(); //pushParam 下推传参
            BigDecimal tpvPurchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");//采提数量
            BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");//销提数量
            BigDecimal tpvGaplimit = dynamicObject.getBigDecimal("tpv_gaplimit");//差额
            BigDecimal abs = tpvGaplimit.abs();
            if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && tpvDestroyquantity.compareTo(BigDecimal.ZERO) != 0) {
                Long tpv_materials = YEM.isNotEmpty(dynamicObject.getDynamicObject("tpv_materials"))
                        ? dynamicObject.getDynamicObject("tpv_materials").getLong("id") : 0L;
                dateMap.put("tpv_materials", tpv_materials);//商品
                Long tpv_prodnames = YEM.isNotEmpty(dynamicObject.getDynamicObject("tpv_prodnames"))
                        ? dynamicObject.getDynamicObject("tpv_prodnames").getLong("id") : 0L;
                dateMap.put("tpv_prodnames", tpv_prodnames);//品名
                dateMap.put("tpv_purchasequantity", tpvPurchasequantity);//采提数量
                dateMap.put("tpv_destroyquantity", tpvDestroyquantity);//销提数量
                dateMap.put("tpv_shaders", dynamicObject.getString("tpv_shaders"));//材质
                dateMap.put("tpv_specations", dynamicObject.getString("tpv_specations"));//规格
                Long tpv_origins = YEM.isNotEmpty(dynamicObject.getDynamicObject("tpv_origins"))
                        ? dynamicObject.getDynamicObject("tpv_origins").getLong("id") : 0L;
                dateMap.put("tpv_origins", tpv_origins);//产地
                dateMap.put("tpv_ofpackages", dynamicObject.getBigDecimal("tpv_ofpackages"));//包装数量
                dateMap.put("tpv_directconsignmentid", dynamicObject.getLong("id"));//底表分录id
                dateMap.put("tpv_fentryid_zy", dataEntity.getLong("tpv_fentryid_zy"));//采购分录行ID
                if (tpvGaplimit.compareTo(BigDecimal.ZERO) != 0) {
                    dateMap.put("tpv_gaplimit", abs);//差额
                } else {
                    dateMap.put("tpv_gaplimit", BigDecimal.ZERO);//差额
                }
                pushParam.add(dateMap);

                int number = tpvPurchasequantity.compareTo(tpvDestroyquantity);
                if (number > 0) {
                    selectedRowsOutId.add((Long) dynamicObject.getPkValue());
                }
                if (number < 0) {
                    selectedRowsInId.add((Long) dynamicObject.getPkValue());
                }
            }
        }

        if (selectedRowsHWLZ.size() > 0) {
//            pushHWLZToPurIn(tpvSonentryentity, dataEntity, tpvEntrepot, selectedRowsHWLZ, selectRows,
//                    selectedRowsInId, selectedRowsOutId, JSONObject.toJSONString(pushParam), feesInfoParams, tips);
        }
        if (selectedRowsPur.size() > 0) {
//            pushPurConToPurIn(selectedRowsPur, selectRows, tpvSonentryentity, tpvEntrepot, pushParam, feesInfoParams, dataEntity,
//                    selectedRowsInId, selectedRowsOutId, tips);
        }
//        Map<String, String> returnDataMap = new HashMap<>();
        if (tips.size() > 0) {
            String errMsg = "";
            int msgSeq = 1;
            for (String tip : tips) {
                errMsg += String.format("%s、%s%s", msgSeq++, tip, "\r\n");
            }
            this.getView().getParentView().showMessage("存在异常单据，详情如下。", errMsg, MessageTypes.Default);
//            returnDataMap.put("isSucess","No");
        } else {
            this.getView().getParentView().showSuccessNotification("出入库成功！");
        }
//        returnDataMap.put("isSucess","Yes");
//        this.getView().returnDataToParent(returnDataMap);
        this.getView().sendFormAction(this.getView().getParentView());
        this.getView().close();
    }
}
