package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.util.StringUtils;
import tpv.tpv_wm.tpv_dt.java.report.FeeSettleWorkRptQuery;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Description 费用结算工作台  -表单插件
 * @Author LinRui
 * Date 2023/8/24 16:26
 **/
public class FeeSettleWorkEdit extends AbstractFormPlugin implements HyperLinkClickListener {

    private static final String STATEMENWORKENTITY = "tpv_statemenworkentity";  //费用结算工作台分录
    private static final String KEY_APPEND_BILL = "tpv_dt_statemenbill"; //费用结算单标识

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"tpv_query", "tpv_createsettlebill", "btnok", "btncancel"});  //查询按钮    生成结算单按钮  确认 取消
        EntryGrid grid = (EntryGrid) this.getControl("tpv_statemenworkentity");
        grid.addHyperClickListener(this);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        initData(true);  //单据打开初始化界面数据
    }

    /**
     * 单据打开初始化界面数据
     **/
    private void initData(boolean flag) {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        FormShowParameter parameter = view.getFormShowParameter();

        Long tpv_logisticsprof = toLong(parameter.getCustomParam("tpv_supplier"));
        //控制打开动态表单是，显示按钮区 取消和确认  点击补录时显示，直接预览打开不显示 代码操控
        String enable = parameter.getCustomParam("flag");
        this.getView().setVisible(false, "operatepanel");  //隐藏按钮区
        if ("true".equals(enable)) {
            this.getView().setVisible(true, "operatepanel"); //显示按钮区
            this.getView().setVisible(false, "tpv_createsettlebill"); //隐藏生成结算单按钮
            this.getView().setEnable(false, "tpv_logisticsprof");
        }

        model.deleteEntryData(STATEMENWORKENTITY);

        DynamicObject dataEntity = model.getDataEntity(true);
        //判断是否是点击补录传过来的过滤参数
        if ("true".equals(enable)) {
            model.setValue("tpv_logisticsprof", tpv_logisticsprof); //物流服务商
        } else {
            DynamicObject tpvLogisticsprof = dataEntity.getDynamicObject("tpv_logisticsprof");
            if (null != tpvLogisticsprof) {
                tpv_logisticsprof = dataEntity.getDynamicObject("tpv_logisticsprof").getLong("id");
            }
        }
        String whereFilter = "1 = 1";
        //组合号
        DynamicObject tpv_combinationf = dataEntity.getDynamicObject("tpv_combinationf");
        if (YEM.isNotEmpty(tpv_combinationf)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_combinationnumber = %s", whereFilter, tpv_combinationf.getPkValue());
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_combinationnumber = %s", whereFilter, tpv_combinationf.getPkValue());
            }
        }
        //采购合同号
        String tpv_contractnosf = dataEntity.getString("tpv_contractnosf");
        if (YEM.isNotEmpty(tpv_contractnosf)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and LOWER(tpv_contractnos) LIKE LOWER('%%%s%%')", whereFilter, tpv_contractnosf);
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s LOWER(tpv_contractnos) LIKE LOWER('%%%s%%')", whereFilter, tpv_contractnosf);
            }
        }
        //采购供应商
        DynamicObject tpv_supplierf = dataEntity.getDynamicObject("tpv_supplierf");
        if (YEM.isNotEmpty(tpv_supplierf)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_supplier = %s", whereFilter, tpv_supplierf.getPkValue());
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_supplier = %s", whereFilter, tpv_supplierf.getPkValue());
            }
        }
        //销售合同号
        String tpv_salecontractnosf = dataEntity.getString("tpv_salecontractnosf");
        if (YEM.isNotEmpty(tpv_salecontractnosf)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and LOWER(tpv_salecontractnos) LIKE LOWER('%%%s%%')", whereFilter, tpv_salecontractnosf);
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s LOWER(tpv_salecontractnos) LIKE LOWER('%%%s%%')", whereFilter, tpv_salecontractnosf);
            }
        }
        //业务日期从
        Date tpv_startdatef = dataEntity.getDate("tpv_startdatef");
        if (null != tpv_startdatef) {
            Date dayStartTime = getDayStartTime(tpv_startdatef);
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(dayStartTime);
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_bizdate >= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_bizdate >= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
            }
        } else if (null == tpv_startdatef) {
            whereFilter = String.format("%s %s", whereFilter, "");
        }
        //业务日期到
        Date tpv_enddatef = dataEntity.getDate("tpv_enddatef");
        if (null != tpv_enddatef) {
            Date dayEndTime = getDayEndTime(tpv_enddatef);
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(dayEndTime);
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_bizdate <= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_bizdate <= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
            }
        } else if (null == tpv_enddatef) {
            whereFilter = String.format("%s %s", whereFilter, "");
        }
        // 物流服务商
        //DynamicObject tpv_logisticsprof = dataEntity.getDynamicObject("tpv_logisticsprof");
        if (YEM.isNotEmpty(tpv_logisticsprof)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_logisticspro = %s", whereFilter, tpv_logisticsprof);
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_logisticspro = %s", whereFilter, tpv_logisticsprof);
            }
        }
        //车船名
        String tpv_vehiclenamef = dataEntity.getString("tpv_vehiclenamef");
        if (YEM.isNotEmpty(tpv_vehiclenamef)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_vehiclename like '%%%s%%'", whereFilter, tpv_vehiclenamef);
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_vehiclename like '%%%s%%'", whereFilter, tpv_vehiclenamef);
            }
        }
        // 费用项目
        DynamicObject tpv_expenseitemf = dataEntity.getDynamicObject("tpv_expenseitemf");
        if (YEM.isNotEmpty(tpv_expenseitemf)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_expenseitem = %s", whereFilter, tpv_expenseitemf.getPkValue());
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_expenseitem = %s", whereFilter, tpv_expenseitemf.getPkValue());
            }
        }
        // 来源单据
        DynamicObject tpv_sourcebillf = dataEntity.getDynamicObject("tpv_sourcebillf");
        if (null != tpv_sourcebillf) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_sourcebillkey = %s", whereFilter, "'" + tpv_sourcebillf.getString("number") + "'");
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_sourcebillkey = %s", whereFilter, "'" + tpv_sourcebillf.getString("number") + "'");
            }
        } else if (null == tpv_sourcebillf) {
            whereFilter = String.format("%s %s", whereFilter, "");
        }
        //部门
        String whereStr = PersonnelDepUtils.createWhereStrForm(model, "tpv_muldepartment", "tpv_department");
        if (!"".equals(whereStr)) {
            whereFilter = String.format("%s%s", whereFilter, whereStr);
        }
        if ("true".equals(enable)) {
            Long org = toLong(parameter.getCustomParam("org"));
            Long tpvCurrency = toLong(parameter.getCustomParam("tpv_currency"));
            Long tpvDepartment = toLong(parameter.getCustomParam("tpv_department"));
            if (YEM.isNotEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_org = %s", whereFilter, org);
            } else {
                whereFilter = String.format("%s tpv_org = %s", whereFilter, org);
            }
            whereFilter = String.format("%s and tpv_feecurrency = %s", whereFilter, tpvCurrency);
            whereFilter = String.format("%s and tpv_department = %s", whereFilter, tpvDepartment);
            whereFilter = String.format("%s and tpv_settlebillno is null", whereFilter);
        }

        DataSet query = FeeSettleWorkRptQuery.query(whereFilter, null);  //saleId 关联父分录表的外键id

        DynamicObjectType enrtyType = model.getEntryEntity(STATEMENWORKENTITY).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow(STATEMENWORKENTITY);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "tpv_createsettlebill":
                verifyDataEntityCreate(); //校验数据，生成结算单
                break;
            case "tpv_query":
                initData(false);
                break;
            case "btnok":
                backData();
                break;
            default:
                break;
        }
    }

    /**
     * 补录回填选中行数据
     **/
    private void backData() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObjectCollection dataEntityss = new DynamicObjectCollection();
        //校验
        EntryGrid entry = view.getControl(STATEMENWORKENTITY);
        int selectRows[] = entry.getSelectRows();
        //获取单据体数据集合
        DynamicObjectCollection entity = this.getModel().getEntryEntity(STATEMENWORKENTITY);
        if (null != selectRows && selectRows.length > 0) {
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = entity.get(selectRow);  //获取选中行的单据体数据
                String tpv_settlebillno = dynamicObject.getString("tpv_settlebillno");
                if (StringUtils.isEmpty(tpv_settlebillno)) {
                    dataEntityss.add(dynamicObject);
                } else {
                    view.showTipNotification("已有生成的下游费用结算单，不允许回填数据！");
                    return;
                }
            }
        } else {
            view.showTipNotification("未选择数据。");
            return;
        }
        this.getView().returnDataToParent(dataEntityss);
        this.getView().close();
    }

    /**
     * 通过校验数据是否一致，生成结算单
     */
    private void verifyDataEntityCreate() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        Boolean flag = true;
        //校验
        EntryGrid entry = view.getControl(STATEMENWORKENTITY);
        int selectRows[] = entry.getSelectRows();
        //获取单据体数据集合
        DynamicObjectCollection entity = this.getModel().getEntryEntity(STATEMENWORKENTITY);
        Map<Long, DynamicObject> map = new HashMap<>();
        if (null != selectRows && selectRows.length > 0) {
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = entity.get(selectRow);  //获取选中行的单据体数据
                map.put(Long.valueOf(selectRow), dynamicObject);
            }
        } else {
            view.showTipNotification("未选择数据。");
            return;
        }

        Map<Long, DynamicObject> mapFlag = new HashMap<>();
        List<String> settleSeqList = new ArrayList();
        if (null != map && map.size() > 0) {
            for (Map.Entry<Long, DynamicObject> dynamicObject : map.entrySet()) {
                DynamicObject dynamicObject1 = dynamicObject.getValue();
                String tpvSettlebillno = dynamicObject1.getString("tpv_settlebillno");//结算单号
                if (null != tpvSettlebillno && "" != tpvSettlebillno) {
                    String settleSeq = dynamicObject1.getString("seq");
                    settleSeqList.add(settleSeq);
                }
                DynamicObject tpvOrg = dynamicObject1.getDynamicObject("tpv_org"); //公司
                DynamicObject tpvDepartment = dynamicObject1.getDynamicObject("tpv_department"); //部门
                DynamicObject tpvLogisticspro = dynamicObject1.getDynamicObject("tpv_logisticspro"); //物流服务商
                DynamicObject tpvCurrency = dynamicObject1.getDynamicObject("tpv_feecurrency"); //币别
                if (null == mapFlag || mapFlag.size() == 0) {
                    mapFlag.put(dynamicObject.getKey(), dynamicObject.getValue());
                } else {
                    if (null != mapFlag && mapFlag.size() > 0) {
                        for (Map.Entry<Long, DynamicObject> object : mapFlag.entrySet()) {
                            DynamicObject object1 = object.getValue();
                            DynamicObject tpvOrg2 = object1.getDynamicObject("tpv_org"); //公司
                            DynamicObject tpvDepartment2 = object1.getDynamicObject("tpv_department"); //部门
                            DynamicObject tpvLogisticspro2 = object1.getDynamicObject("tpv_logisticspro"); //物流服务商
                            DynamicObject tpvCurrency2 = object1.getDynamicObject("tpv_feecurrency"); //币别
                            if (tpvOrg != tpvOrg2 || tpvDepartment != tpvDepartment2 || tpvLogisticspro != tpvLogisticspro2 || tpvCurrency != tpvCurrency2) {
                                flag = false;
                            }
                        }
                    }
                }
            }
            if (settleSeqList.size() > 0) {
                view.showTipNotification("分录选中行 " + String.join(",", settleSeqList.toString()) + " 已生成结算单，不允许再次生成！");
                return;
            }
        }

        if (flag) {
            //创建弹出单据页面对象，并赋值
            BillShowParameter billShowParameter = new BillShowParameter();
            //设置弹出子单据页面的标识
            billShowParameter.setFormId(KEY_APPEND_BILL);

            //设置弹出子单据页面的打开方式
            billShowParameter.setStatus(OperationStatus.EDIT);
            //跳转指定单据的分录如果没有绑定关键字段(单据里点击单据体分录，右边状态栏底下有个关键字段设置)，那么保存时会清空数据
            billShowParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection dynamicObjectCollection = new DynamicObjectCollection();
            for (Map.Entry<Long, DynamicObject> dynamicObjectEntry : map.entrySet()) {
                dynamicObjectCollection.add(dynamicObjectEntry.getValue());
            }
            //DynamicObjectCollection tpv_statemenworkentity = dataEntity.getDynamicObjectCollection(STATEMENWORKENTITY);
            billShowParameter.setCustomParam("tpv_statemenworkentity", dynamicObjectCollection);

//            Map<String, Object> mapData = this.showInfoForm();
//            // 存入获取到的动态表单数据
//            billShowParameter.setCustomParams(mapData);

            //设置弹出子单据页面的样式，高600宽800
//            StyleCss inlineStyleCss = new StyleCss();
//            inlineStyleCss.setHeight("600");
//            inlineStyleCss.setWidth("800");
//            billShowParameter.getOpenStyle().setInlineStyleCss(inlineStyleCss);
//            //设置子页面关闭回调对象，回调本插件，标识为常量KEY_LEAVE_DAYS对应的值
//            billShowParameter.setCloseCallBack(new CloseCallBack(this, "tpv_createsettlebill"));
            //弹窗子页面和父页面绑定
            this.getView().showForm(billShowParameter);
        } else {
            view.showTipNotification("所选分录，行对应的数据（币别、公司、物流服务商、或者币别）不一致，不允许生成费用结算单！");
        }
    }

    public Long toLong(Object longObj) {
        if (longObj == null) {
            return null;
        } else if (longObj instanceof Long) {
            return (Long) longObj;
        } else {
            return Long.valueOf(String.valueOf(longObj));
        }
    }

    /**
     * 获取日期的结束时间
     */
    public static Date getDayEndTime(Date date) {
        if (date == null) {
            return null;
        } else {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(date);
            calendar.set(calendar.get(1), calendar.get(2), calendar.get(5), 23, 59, 59);
            calendar.set(14, 999);
            return calendar.getTime();
        }
    }

    /**
     * 获取该日期的开始时间
     */
    public static Date getDayStartTime(Date date) {
        if (date == null) {
            return null;
        } else {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(date);
            calendar.set(calendar.get(1), calendar.get(2), calendar.get(5), 0, 0, 0);
            calendar.set(14, 0);
            return calendar.getTime();
        }
    }

    @Override
    public void hyperLinkClick(HyperLinkClickEvent evt) {
        IDataModel model = this.getModel();
        String fieldName = evt.getFieldName();
        int rowIndex = evt.getRowIndex();
        switch (fieldName) {
            case "tpv_sourcebillno":
                DynamicObject tpv_srcbill = (DynamicObject) model.getValue("tpv_sourcebillkey", rowIndex);
                String tpv_sourcebillno = (String) model.getValue("tpv_sourcebillno", rowIndex);
                String tpv_srcbillsNumebr = "";
                if (null != tpv_srcbill) {
                    tpv_srcbillsNumebr = tpv_srcbill.getString("number");
                }
                DynamicObject loadSingles = BusinessDataServiceHelper.loadSingle(tpv_srcbillsNumebr, "id",
                        new QFilter[]{new QFilter("billno", QCP.equals, tpv_sourcebillno)});
                if (loadSingles != null) {
                    showBill(tpv_srcbillsNumebr, loadSingles.getPkValue());
                }
                break;
            case "tpv_contractnos":
                String tpv_contractnos = (String) model.getValue("tpv_contractnos", rowIndex);
                DynamicObject loadSinglec = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", "id",
                        new QFilter[]{new QFilter("tpv_contractnumber", QCP.equals, tpv_contractnos)});
                //跳转采购合同
                if (loadSinglec != null) {
                    showBill("tpv_dt_purchase", loadSinglec.getPkValue());
                }
                break;
            case "tpv_settlebillno":
                String tpv_settlebillno = (String) model.getValue("tpv_settlebillno", rowIndex);
                DynamicObject loadSinglee = BusinessDataServiceHelper.loadSingle("tpv_dt_statemenbill", "id",
                        new QFilter[]{new QFilter("billno", QCP.equals, tpv_settlebillno)});
                //费用结算单
                if (loadSinglee != null) {
                    showBill("tpv_dt_statemenbill", loadSinglee.getPkValue());
                }
                break;
            case "tpv_salecontractnos":
                String tpv_salecontractnos = (String) model.getValue("tpv_salecontractnos", rowIndex);
                DynamicObject loadSinglesa = BusinessDataServiceHelper.loadSingle("tpv_dt_salescontract", "id",
                        new QFilter[]{new QFilter("tpv_contractnos", QCP.equals, tpv_salecontractnos)});
                //跳转销售合同
                if (loadSinglesa != null) {
                    showBill("tpv_dt_salescontract", loadSinglesa.getPkValue());
                }
                break;
            default:
                break;
        }
    }

    private void showBill(String formkey, Object formid) {
        if (YEM.isNotEmpty(formkey) || YEM.isNotEmpty(formid)) {
            BillShowParameter showParameter = new BillShowParameter();
            showParameter.setFormId(formkey);
            showParameter.setPkId(formid);
            showParameter.setStatus(OperationStatus.VIEW);
            showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
            this.getView().showForm(showParameter);
        }
    }
}
