package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.data.BusinessDataReader;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.botp.runtime.SourceBillReport;
import kd.bos.entity.datamodel.IRefrencedataProvider;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.IFormView;
import kd.bos.form.MessageTypes;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.ProgressBar;
import kd.bos.form.control.events.ProgressEvent;
import kd.bos.form.control.events.ProgresssListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * 库存拣配工作台进度栏
 * WangShuGuang
 */
public class InventorEdit extends AbstractFormPlugin implements ProgresssListener {
    private final String TPV_DT_PURCHASE = "tpv_dt_purchase";//采购合同标识

    private final String TPV_DT_FREIGROAMBILL = "tpv_dt_freigroambill";//货物流转单标识

    private final String TPV_DT_PURINBILL = "im_purinbill";//采购入库单标识

    private final String IM_OTHEROUTBILL = "im_otheroutbill";//其他出库单

    private final String IM_OTHERINBILL = "im_otherinbill";//其他入库单

    private final String TPV_DT_SALESSHIPPING = "tpv_dt_salesshipping";//销售发货

    private final String IM_SALOUTBILL = "im_saloutbill";//销售出库

    @Override
    public void registerListener(EventObject e) {
        ProgressBar progressBar = this.getControl("tpv_progressbarap");
        progressBar.addProgressListener(this);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        ProgressBar progressBar = this.getControl("tpv_progressbarap");
        progressBar.start();
    }

    @Override
    public void onProgress(ProgressEvent progressEvent) {
        ProgressBar progressBar = this.getControl("tpv_progressbarap");
        progressBar.stop();
        IFormView view = this.getView().getParentView();
        List<String> tips = new ArrayList<>();
        // 获取单据体选中行
        EntryGrid entryGridS = view.getControl("tpv_sonentryentity");
        int[] selectRowsS = entryGridS.getSelectRows();
        //获取单据主实体
        DynamicObject dataEntitysS = view.getModel().getDataEntity(true);
        //获取分录数据
        DynamicObjectCollection detailedinformationS = dataEntitysS.getDynamicObjectCollection("tpv_sonentryentity");
        Long a = (Long) view.getModel().getValue("id");
        QFilter qFilter = new QFilter("tpv_materialentry.tpv_dt_salepick_in", QCP.equals, a);
        String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
        DynamicObject tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
        Long pkValueTwo = (Long) tpvScBusinessnatures.getPkValue();
        BigDecimal qty = BigDecimal.ZERO;
        BigDecimal qtyShopp = BigDecimal.ZERO;
        Map<Long, Map<String, Object>> mapt = new HashMap<>();
        List<Map<String, Object>> pushParam = new ArrayList<>();
        for (int rowsS : selectRowsS) {
            Map<String, Object> map1 = new HashMap<>();
            DynamicObject dynamicObject = detailedinformationS.get(rowsS);
            long pkValueS = dynamicObject.getLong("id");
            qty = qty.add(dynamicObject.getBigDecimal("tpv_destroyquantity"));
            qtyShopp = qtyShopp.add(dynamicObject.getBigDecimal("tpv_destroyquantity"));
            map1.put("tpv_destroyquantity", dynamicObject.getBigDecimal("tpv_destroyquantity"));//数量
            map1.put("tpv_ofpackages", dynamicObject.getBigDecimal("tpv_ofpackages"));//包装数量
            map1.put("tpv_shaders", dynamicObject.getString("tpv_shaders"));//材质
            map1.put("tpv_specations", dynamicObject.getString("tpv_specations"));//规格
            map1.put("tpv_prodnames", dynamicObject.getLong("tpv_prodnames.id"));//品名
            map1.put("tpv_origins", dynamicObject.getLong("tpv_origins.id"));//产地
            map1.put("tpv_materials", dynamicObject.getLong("tpv_materials.id"));
            map1.put("tpv_directconsignmentid", pkValueS);//底表分录id
            pushParam.add(map1);
        }
        List<ListSelectedRow> selectedRowsTwo = new ArrayList<>();
        ListSelectedRow listSelectedRowTwo = new ListSelectedRow(pkValueTwo);//来源单据ID
        listSelectedRowTwo.setSubEntryEntityKey("tpv_dt_salepick_in");//来源单据单据体标识
        listSelectedRowTwo.setSubEntryPrimaryKeyValue(a);//来源单据分录ID
        selectedRowsTwo.add(listSelectedRowTwo);
        PushArgs pushArgsTwo = new PushArgs();
        pushArgsTwo.addCustomParam("tpv_longList", JSONObject.toJSONString(pushParam));
        pushArgsTwo.addCustomParam("tpv_longList_id", String.valueOf(a));
        pushArgsTwo.setSourceEntityNumber(TPV_DT_SALESSHIPPING); // 必选，源单标识
        pushArgsTwo.setTargetEntityNumber(IM_SALOUTBILL); // 必选，目标单标识
        pushArgsTwo.setAutoSave(true);//是否保存
        pushArgsTwo.setRuleId("1798694713818135552"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
        pushArgsTwo.setBuildConvReport(true); // 是否输出详细错误报告
        pushArgsTwo.setSelectedRows(selectedRowsTwo); // 必选，设置需要下推的源单及分录内码
        ConvertOperationResult pushResultTwo = ConvertServiceHelper.push(pushArgsTwo);
        if (pushResultTwo.isSuccess()) {
            MainEntityType targetMainTypeOne = EntityMetadataCache
                    .getDataEntityType(pushArgsTwo.getTargetEntityNumber());
            List<DynamicObject> targetBillObjsOne = pushResultTwo
                    .loadTargetDataObjects(new IRefrencedataProvider() {
                        @Override
                        public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                            BusinessDataReader.loadRefence(objs, dType);
                        }
                    }, targetMainTypeOne);
            if (targetBillObjsOne.size() > 0) {
                DynamicObject targetBillObjOne = targetBillObjsOne.get(0);
                if (auditBill(targetBillObjOne, tips)) {
                    DynamicObjectCollection billentry = targetBillObjOne.getDynamicObjectCollection("billentry");
                    /*for (DynamicObject dynamicObject : billentry) {
                        BigDecimal qtyOne = dynamicObject.getBigDecimal("qty");//数量
                        BigDecimal priceandtax = dynamicObject.getBigDecimal("priceandtax");//含税单价
                        BigDecimal exchangerate = targetBillObjOne.getBigDecimal("exchangerate");//汇率
                        BigDecimal taxrate = dynamicObject.getBigDecimal("taxrate");//税率%
                        if (qtyOne.compareTo(BigDecimal.ZERO) != 0 && priceandtax.compareTo(BigDecimal.ZERO) != 0) {
                            //计算价税合计
                            BigDecimal amountandtax = qtyOne.multiply(priceandtax);
                            dynamicObject.set("amountandtax", amountandtax);//价税合计
                            if (exchangerate.compareTo(BigDecimal.ZERO) != 0) {
                                BigDecimal curamountandtax = amountandtax.multiply(exchangerate);
                                dynamicObject.set("curamountandtax", curamountandtax);//价税合计(本位币)
                            }
                            if (null != taxrate) {
                                //计算金额
                                BigDecimal divide = taxrate.divide(new BigDecimal(100), 2, RoundingMode.HALF_UP);//( 税率% / 100 )
                                BigDecimal add = divide.add(BigDecimal.ONE);//( 1 + 税率% / 100 )
                                BigDecimal amount = amountandtax.divide(add, 2, RoundingMode.HALF_UP);
                                dynamicObject.set("amount", amount);//金额
                                if (exchangerate.compareTo(BigDecimal.ZERO) != 0){
                                    BigDecimal curamount = amount.multiply(exchangerate);
                                    dynamicObject.set("curamount", curamount);//金额(本位币)
                                }
                                //税额 = 价税合计 * ( 税率% / 100 ) / ( 1 + 税率% / 100 )
                                BigDecimal taxamount = amountandtax.multiply(divide).divide(add, 2, RoundingMode.HALF_UP);//税额
                                dynamicObject.set("taxamount",taxamount);
                                //税额本位币等于税额*汇率
                                dynamicObject.set("curtaxamount",taxamount.multiply(exchangerate));
                            }
                            SaveServiceHelper.update(dynamicObject);
                        }
                    }*/
                    selectMust();
                }
            }
        } else {
            addCovertMsg(IM_SALOUTBILL, pushResultTwo, tips);
        }
        if (tips.size() > 0) {
            String errMsg = "";
            int msgSeq = 1;
            for (String tip : tips) {
                errMsg += String.format("%s、%s%s", msgSeq++, tip, "\r\n");
            }
            view.showMessage("存在异常单据，详情如下。", errMsg, MessageTypes.Default);
        } else {
            view.showSuccessNotification("出入库成功！");
        }
        this.getView().close();
    }

    private void addCovertMsg(String entityNumber, ConvertOperationResult pushResult, List<String> tips) {
        MainEntityType dataEntityType = YEM.getDataEntityType(entityNumber);
        String entityName = dataEntityType.getDisplayName().getLocaleValue();
        String msg = pushResult.getMessage();
        List<SourceBillReport> billReports = pushResult.getBillReports();
        for (int i = 0; i < billReports.size(); i++) {
            SourceBillReport sourceBillReport = billReports.get(i);
            msg = i == 0 ? msg + "。原因:" : msg;
            msg += String.format("%s、%s ", i + 1, sourceBillReport.getFailMessage());
        }
        tips.add(String.format("下推【%s】失败。%s ", entityName, msg));
    }

    public void selectMust() {
        IFormView view = this.getView().getParentView();
        DynamicObjectCollection tpvSonentryentity = view.getModel().getEntryEntity("tpv_sonentryentity");
        for (DynamicObject dynamicObject : tpvSonentryentity) {
            BigDecimal tpvPurchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");//采提数量
            BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");//采提数量
            int seq = dynamicObject.getInt("Seq");
            int seqSmale = seq - 1;
            Long id = (Long) dynamicObject.getPkValue();
            if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && tpvDestroyquantity.compareTo(BigDecimal.ZERO) != 0) {
                int bigSmal = tpvPurchasequantity.compareTo(tpvDestroyquantity);
                if (bigSmal == 0) {
                    //销提数量等于采提数量查询采购入库单号和销售出库单号
                    //采购入库
                    DynamicObject tpv_dt_purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //销售出库
                    DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    /*if (null != tpv_dt_purinbill) {
                        //插入入库单号
                        this.getModel().setValue("tpv_godownentry", tpv_dt_purinbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_godownentry", null, seqSmale);
                    }*/
                    if (null != im_saloutbill) {
                        //插入出库单号
                        view.getModel().setValue("tpv_deliveryorder", im_saloutbill.getString("billno"), seqSmale);
                    } else {
                        view.getModel().setValue("tpv_deliveryorder", null, seqSmale);
                    }
                }
                if (bigSmal > 0) {
                    //采提数量大于销提数量时查询入库单号 出库单号 盘亏单号
                    //采购入库
                    DynamicObject tpv_dt_purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //销售出库
                    DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //其他出库
                    DynamicObject im_otheroutbill = BusinessDataServiceHelper.loadSingle("im_otheroutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    if (null != im_saloutbill) {
                        //插入出库单号
                        view.getModel().setValue("tpv_deliveryorder", im_saloutbill.getString("billno"), seqSmale);
                    } else {
                        view.getModel().setValue("tpv_deliveryorder", null, seqSmale);
                    }
                    if (null != im_otheroutbill) {
                        //插入盘亏单号
                        view.getModel().setValue("tpv_lossodd", im_otheroutbill.getString("billno"), seqSmale);
                    } else {
                        view.getModel().setValue("tpv_lossodd", null, seqSmale);
                    }
                }
                if (bigSmal < 0) {
                    //采提数量小于销提数量时查询入库单号 出库单号 盘盈单号
                    //采购入库
                    DynamicObject tpv_dt_purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //销售出库
                    DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //其他入库
                    DynamicObject im_otherinbill = BusinessDataServiceHelper.loadSingle("im_otherinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    if (null != tpv_dt_purinbill) {
                        view.getModel().setValue("tpv_sonbill", "im_purinbill", seqSmale);
                        view.getModel().setValue("tpv_sonbillnos", tpv_dt_purinbill.getString("billno"), seqSmale);
                    } else {
                        // this.getModel().setValue("tpv_godownentry", null, seqSmale);
                    }
                    if (null != im_saloutbill) {
                        //插入出库单号
                        view.getModel().setValue("tpv_deliveryorder", im_saloutbill.getString("billno"), seqSmale);
                    } else {
                        view.getModel().setValue("tpv_deliveryorder", null, seqSmale);
                    }
                    if (null != im_otherinbill) {
                        //插入出库单号
                        view.getModel().setValue("tpv_profitodd", im_otherinbill.getString("billno"), seqSmale);
                    } else {
                        view.getModel().setValue("tpv_profitodd", null, seqSmale);
                    }
                }
            }
        }
    }

    private boolean auditBill(DynamicObject targetBillObjOne, List<String> tips) {
        DynamicObjectType dynamicObjectType = targetBillObjOne.getDynamicObjectType();
        String entityName = dynamicObjectType.getDisplayName().getLocaleValue();
        String entityNumber = dynamicObjectType.getName();
        OperateOption optionOne = YEM.getOption();
        OperationResult saveOne = OperationServiceHelper.executeOperate("save", entityNumber,
                new DynamicObject[]{targetBillObjOne}, optionOne);
        if (saveOne.isSuccess()) {
            OperationResult submitOne = OperationServiceHelper.executeOperate("submit",
                    entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
            if (submitOne.isSuccess()) {
                OperationResult auditOne = OperationServiceHelper.executeOperate("audit",
                        entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
                if (auditOne.isSuccess()) {
                    return true;
                } else {
                    tips.add(String.format("【%s】审核失败。%s", entityName, YEM.getOpMsg(auditOne)));
                }
            } else {
                tips.add(String.format("【%s】提交失败。%s", entityName, YEM.getOpMsg(submitOne)));
            }
        } else {
            tips.add(String.format("【%s】保存失败。%s", entityName, YEM.getOpMsg(saveOne)));
        }
        return false;
    }
}
