package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.data.BusinessDataReader;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.botp.runtime.SourceBillReport;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.IRefrencedataProvider;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.IFormView;
import kd.bos.form.MessageTypes;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.ProgressBar;
import kd.bos.form.control.events.ProgressEvent;
import kd.bos.form.control.events.ProgresssListener;
import kd.bos.form.events.ClientCallBackEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;

import java.util.*;

/**
 * 库存免拣配工作台进度栏
 * WangShuGuang
 */
public class InventorNoEdit extends AbstractFormPlugin implements ProgresssListener {

    private final String TPV_DT_SALESSHIPPING = "tpv_dt_salesshipping";//销售发货

    private final String IM_SALOUTBILL = "im_saloutbill";//销售出库

    @Override
    public void registerListener(EventObject e) {
        ProgressBar progressBar = this.getControl("tpv_progressbarap");
        progressBar.addProgressListener(this);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
//        ProgressBar progressBar = this.getControl("tpv_progressbarap");
//        progressBar.start();
        this.getView().addClientCallBack("tpv_callback");
    }

    @Override
    public void onProgress(ProgressEvent progressEvent) {
        ProgressBar progressBar = this.getControl("tpv_progressbarap");
        progressBar.stop();
    }

    @Override
    public void clientCallBack(ClientCallBackEvent e) {
        super.clientCallBack(e);
        switch (e.getName()) {
            case "tpv_callback":
                Map<String, Object> customParams = this.getView().getFormShowParameter().getCustomParams();
                if (customParams.size() > 0) {
                    //工作台父分录选中行存在多个单子，即可启动这块
                    List<Long> list = new ArrayList<>();
//                String entryids = customParams.containsKey("entryids") ? (String) customParams.get("entryids") : "";
//                if (YEM.isNotEmpty(entryids)) {
//                    JSONArray jsonArray = JSONArray.parseArray(entryids);
//                    for (Object o : jsonArray) {
//                        if (!list.contains(Long.valueOf(o.toString()))) {
//                            list.add(Long.valueOf(o.toString()));
//                        }
//                    }
//                }
                    List<Long> idlist = new ArrayList<>();
                    String ids = customParams.containsKey("ids") ? (String) customParams.get("ids") : "";
                    if (YEM.isNotEmpty(ids)) {
                        JSONArray jsonArray = JSONArray.parseArray(ids);
                        for (Object o : jsonArray) {
                            if (!idlist.contains(Long.valueOf(o.toString()))) {
                                idlist.add(Long.valueOf(o.toString()));
                            }
                        }
                    }
                    List<Long> subentryidlist = new ArrayList<>();
                    String subentryids = customParams.containsKey("subentryids") ? (String) customParams.get("subentryids"): "";
                    if (YEM.isNotEmpty(subentryids)) {
                        JSONArray jsonArray = JSONArray.parseArray(subentryids);
                        for (Object o : jsonArray) {
                            if (!subentryidlist.contains(Long.valueOf(o.toString()))) {
                                subentryidlist.add(Long.valueOf(o.toString()));
                            }
                        }
                    }
                    String pushParam = customParams.containsKey("subentryqty") ? (String) customParams.get("subentryqty") : "";
                    pushParam = pushParam != null ? pushParam : "";
                    batchRowShippingToOutBill(list, idlist, subentryidlist, pushParam);

                } else {
                    rowShippingToOutBill(); //工作台父分录选中一行，在显示区选中子分录单行出库的逻辑在这方法里，暂时单据打开是没有设置customer参数
                }
                break;
        }
    }
    //选择多行父分录，批量出库操作
    private void batchRowShippingToOutBill(List<Long> list, List<Long> idlist, List<Long> sublist, String pushParam) {
        IFormView parentView = this.getView().getParentView();
        List<String> tips = new ArrayList<>();
        pushSaleOutbill(parentView, tips, pushParam, idlist, sublist, false);
    }

    //选择单行父分录，对拣配子分录，单行出库操作(子分录可多选)
    private void rowShippingToOutBill() {
        IFormView parentView = this.getView().getParentView();
        List<String> tips = new ArrayList<>();
        // 获取单据体选中行
        EntryGrid entryGridS = parentView.getControl("tpv_sonentryentity");
        int[] selectRowsS = entryGridS.getSelectRows();
        //获取单据主实体
        DynamicObject dataEntitysS = parentView.getModel().getDataEntity(true);
        //获取分录数据
        DynamicObjectCollection detailedinformationS = dataEntitysS.getDynamicObjectCollection("tpv_sonentryentity");
        Long a = (Long) parentView.getModel().getValue("id");
        QFilter qFilter = new QFilter("tpv_materialentry", QCP.equals, a);
        String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
        DynamicObject tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
        List<Long> idlist = new ArrayList<>(); //存单据id
        Long pkValueTwo = (Long) tpvScBusinessnatures.getPkValue();
        List<Map<String, Object>> pushParam = new ArrayList<>();
        List<Long> subEntryidList = new ArrayList<>();
        for (int rowsS : selectRowsS) {
            Map<String, Object> map1 = new HashMap<>();
            DynamicObject dynamicObject = detailedinformationS.get(rowsS);
            long pkValueS = dynamicObject.getLong("id");
            map1.put("tpv_destroyquantity", dynamicObject.getBigDecimal("tpv_destroyquantity"));
            map1.put("tpv_fpackagereal", dynamicObject.getBigDecimal("tpv_fpackagereal"));
            map1.put("tpv_directconsignmentid", pkValueS);//底表分录id
            map1.put("tpv_isrowout", true);//点击【+单行出库】按钮
            map1.put("insubentry", "yes");//是库存实提工作台推出库
            pushParam.add(map1);
            subEntryidList.add(pkValueS);
        }
        String jsonString = JSONObject.toJSONString(pushParam); //传参转格式addCustomParam<String,String> value -> jsonString
        idlist.add(pkValueTwo);
        pushSaleOutbill(parentView, tips, jsonString, idlist, subEntryidList, true);
    }

    private void pushSaleOutbill(IFormView parentView, List<String> tips, String pushParam, List<Long> billIds, List<Long> pushSubEntryid, Boolean flag) {
        if (billIds.size() > 0) {
            for (Long billId : billIds) {
                List<ListSelectedRow> selectedRowsTwo = new ArrayList<>();
                if (pushSubEntryid.size() > 0) {
                    for (Long aLong : pushSubEntryid) {
                        ListSelectedRow listSelectedRowTwo = new ListSelectedRow(billId);//来源单据ID
                        listSelectedRowTwo.setSubEntryEntityKey("tpv_dt_salepick_in");//来源单据单据体标识
                        listSelectedRowTwo.setSubEntryPrimaryKeyValue(aLong);//来源单据分录ID
                        selectedRowsTwo.add(listSelectedRowTwo);
                    }
                }
                PushArgs pushArgsTwo = new PushArgs();
                pushArgsTwo.addCustomParam("longList", pushParam);
                pushArgsTwo.setSourceEntityNumber(TPV_DT_SALESSHIPPING); // 必选，源单标识
                pushArgsTwo.setTargetEntityNumber(IM_SALOUTBILL); // 必选，目标单标识
                pushArgsTwo.setAutoSave(true);//是否保存
                pushArgsTwo.setRuleId("1798694713818135552"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
                pushArgsTwo.setBuildConvReport(true); // 是否输出详细错误报告
                pushArgsTwo.setSelectedRows(selectedRowsTwo); // 必选，设置需要下推的源单及分录内码
                ConvertOperationResult pushResultTwo = ConvertServiceHelper.push(pushArgsTwo);
                if (pushResultTwo.isSuccess()) {
                    MainEntityType targetMainTypeOne = EntityMetadataCache
                            .getDataEntityType(pushArgsTwo.getTargetEntityNumber());
                    List<DynamicObject> targetBillObjsOne = pushResultTwo
                            .loadTargetDataObjects(new IRefrencedataProvider() {
                                @Override
                                public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                                    BusinessDataReader.loadRefence(objs, dType);
                                }
                            }, targetMainTypeOne);
                    if (targetBillObjsOne.size() > 0) {
                        DynamicObject targetBillObjOne = targetBillObjsOne.get(0);
                        if (auditBill(targetBillObjOne, tips)) {
                            setEntryRowOutBillno(flag, targetBillObjOne);
                        }
                    }
                } else {
                    addCovertMsg(IM_SALOUTBILL, pushResultTwo, tips);
                }
            }
        }
        if (tips.size() > 0) {
            String errMsg = "";
            int msgSeq = 1;
            for (String tip : tips) {
                errMsg += String.format("%s、%s%s", msgSeq++, tip, "\r\n");
            }
            parentView.showMessage("存在异常单据，详情如下。", errMsg, MessageTypes.Default);
        } else {
            parentView.showSuccessNotification("出入库成功！");
        }
        this.getView().sendFormAction(this.getView().getParentView());
        this.getView().close();
    }

    public void setEntryRowOutBillno(Boolean flag, DynamicObject targetBillObjOne) {
        if (flag) {
            IFormView parentView = this.getView().getParentView(); //【单行出库】按钮
            IDataModel parentViewModel = parentView.getModel();
            DynamicObjectCollection tpvSonentryentity = parentViewModel.getEntryEntity("tpv_sonentryentity");
            EntryGrid entryGrid = parentView.getControl("tpv_sonentryentity");
            int[] selectRows = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                Long id = (Long) dynamicObject.getPkValue();
                //销售出库
                DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno",
                        new QFilter("billentry.tpv_srcbillsubentryid", QCP.equals, id).toArray());
                if (null != im_saloutbill) {
                    //插入出库单号
                    parentView.getModel().setValue("tpv_deliveryorder", im_saloutbill.getString("billno"), selectRow);
                } else {
                    parentView.getModel().setValue("tpv_deliveryorder", null, selectRow);
                }
                if (flag) {
                    //单行拣配
                    parentView.getModel().setValue("tpv_isrowout",true, selectRow);
                }

            }
//            SaveServiceHelper.save(new DynamicObject[]{parentViewModel.getDataEntity(true)});
        } else {
            List<Long> srcEntryIdList = new ArrayList<>();  //【批量出库】不显示子分录数据 这个方法可以删除，原先是物理存值，存出库单号，现在实时查询
            DynamicObjectCollection billentry = targetBillObjOne.getDynamicObjectCollection("billentry");
            for (DynamicObject dynamicObject : billentry) {
                long directconsignmentid = dynamicObject.getLong("tpv_srcbillsubentryid");
                srcEntryIdList.add(directconsignmentid);
            }
            if (srcEntryIdList.size() > 0) {
                QFilter qFilter = new QFilter("tpv_sonentryentity.id",QCP.in,srcEntryIdList);
                DynamicObject[] load = BusinessDataServiceHelper.load("tpv_dt_configuranew", "id,tpv_sonentryentity," +
                        "tpv_sonentryentity.tpv_deliveryorder,tpv_sonentryentity.tpv_isrowout tpv_isrowout", qFilter.toArray());
                if (load.length > 0) {
                    for (DynamicObject dynamicObject : load) {
                        DynamicObjectCollection tpvSonentryentity = dynamicObject.getDynamicObjectCollection("tpv_sonentryentity");
                        for (DynamicObject object : tpvSonentryentity) {
                            object.set("tpv_deliveryorder",targetBillObjOne.getString("billno"));
                        }
                    }
                }
//                SaveServiceHelper.update(load);
            }

        }

    }

    private void addCovertMsg(String entityNumber, ConvertOperationResult pushResult, List<String> tips) {
        MainEntityType dataEntityType = YEM.getDataEntityType(entityNumber);
        String entityName = dataEntityType.getDisplayName().getLocaleValue();
        String msg = pushResult.getMessage();
        List<SourceBillReport> billReports = pushResult.getBillReports();
        for (int i = 0; i < billReports.size(); i++) {
            SourceBillReport sourceBillReport = billReports.get(i);
            msg = i == 0 ? msg + "。原因:" : msg;
            msg += String.format("%s、%s ", i + 1, sourceBillReport.getFailMessage());
        }
        tips.add(String.format("下推【%s】失败。%s ", entityName, msg));
        //this.getView().showMessage(String.format("下推【%s】失败。%s", entityName, msg));
    }

    private boolean auditBill(DynamicObject targetBillObjOne, List<String> tips) {
        DynamicObjectType dynamicObjectType = targetBillObjOne.getDynamicObjectType();
        String entityName = dynamicObjectType.getDisplayName().getLocaleValue();
        String entityNumber = dynamicObjectType.getName();
        OperateOption optionOne = YEM.getOption();
        //option.setVariableValue("linkage", Boolean.toString(true));
        OperationResult saveOne = OperationServiceHelper.executeOperate("save", entityNumber,
                new DynamicObject[]{targetBillObjOne}, optionOne);
        if (saveOne.isSuccess()) {
            OperationResult submitOne = OperationServiceHelper.executeOperate("submit",
                    entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
            if (submitOne.isSuccess()) {
                OperationResult auditOne = OperationServiceHelper.executeOperate("audit",
                        entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
                if (auditOne.isSuccess()) {
                    return true;
                } else {
                    tips.add(String.format("【%s】审核失败。%s", entityName, YEM.getOpMsg(auditOne)));
                }
            } else {
                tips.add(String.format("【%s】提交失败。%s", entityName, YEM.getOpMsg(submitOne)));
            }
        } else {
            tips.add(String.format("【%s】保存失败。%s", entityName, YEM.getOpMsg(saveOne)));
        }
        return false;
    }
}
