package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.dt.report.InventoryNewRptQuery;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.RptUtil;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.earlywarn.kit.StringUtil;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;

/**
 * 库存拣配实提工作台(新)-表单插件
 *
 * @author WangShuGuang
 * @description
 * @date 2024年3月7日
 */
public class InventoryNewEdit extends AbstractFormPlugin implements RowClickEventListener, HyperLinkClickListener {

    private static final String entryKey_1 = "tpv_entryentity";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");//商品明细
        this.addItemClickListeners("tpv_toolbarap");
        entryGrid.addHyperClickListener(this);
        this.addClickListeners("tpv_selects");
        entryGrid.addRowClickListener(this);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        initData();
        showFlexpanelap();
    }

    //打开内嵌页面
    private void showFlexpanelap() {
        BillShowParameter showParameter = new BillShowParameter();
        showParameter.setStatus(OperationStatus.VIEW);
        showParameter.getOpenStyle().setShowType(ShowType.InContainer);
        //容器表示
        showParameter.getOpenStyle().setTargetKey("tpv_flexpanelap");
        showParameter.setSendToClient(true);
        //单据标识
        showParameter.setFormId("tpv_dt_configuranew");
        //主键
//        DynamicObject newCostdispose = BusinessDataServiceHelper.newDynamicObject("tpv_dt_configuranew");
        showParameter.setPkId(null);
        this.getView().showForm(showParameter);
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control source = (Control) evt.getSource();
        // 点击确认按钮
        if (StringUtils.equals(source.getKey(), "tpv_selects")) {
            initData();
            showFlexpanelap();
        }
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        EntryGrid entryGrid = (EntryGrid) evt.getSource();
        if (StringUtils.equals("tpv_entryentity", entryGrid.getKey())) {
            EntryGrid tpvEntryentity = this.getControl("tpv_entryentity");
            int[] selectRows = tpvEntryentity.getSelectRows();//获取选中的行号
            if (selectRows.length > 0) {
                if (selectRows.length > 1) {
                    showFlexpanelap();
                } else if(selectRows.length == 1) {
                    embedded(selectRows);
                }
            } else {
                showFlexpanelap();
            }
        }
    }

    //批量出库
    public void batchEmbedded(int[] selectRows) {
        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_entryentity");//商品明细
        if (entity.size() > 0) {
            List<String> islogisticsListValid = new ArrayList<>();
            List<String> outqtyValid = new ArrayList<>();
            List<String> isrowoutValid = new ArrayList<>();
            List<Long> entryids = new ArrayList<>();
            List<Long> ids = new ArrayList<>();
            for (int selectRow : selectRows) {
                String tpv_sourceid = (String) this.getModel().getValue("tpv_sourceid", selectRow);
                String tpv_seleid = (String) this.getModel().getValue("tpv_seleid", selectRow);
                Boolean tpv_islogistics = (Boolean) this.getModel().getValue("tpv_islogistics", selectRow); //需物流确认
                Boolean tpv_logisticsok = (Boolean) this.getModel().getValue("tpv_logisticsok", selectRow); //物流确认
                BigDecimal tpv_issuedquantitys = (BigDecimal) this.getModel().getValue("tpv_issuedquantitys", selectRow); //已出库数量
                entryids.add(Long.valueOf(tpv_sourceid));
                if (!ids.contains(tpv_seleid)) {
                    ids.add(Long.valueOf(tpv_seleid));
                }
                if (tpv_islogistics || !tpv_logisticsok) {
                    islogisticsListValid.add(String.valueOf(selectRow + 1));
                }
                if (tpv_issuedquantitys.compareTo(BigDecimal.ZERO) != 0) {
                    outqtyValid.add(String.valueOf(selectRow + 1));
                }
            }
            List<Map<String, Object>> subEntryList = new ArrayList<>();
            List<Long> subEntryids = new ArrayList<>();
            //查询库存子分录数据，根据父分录id过滤
            QFilter qFilter = new QFilter("id",QCP.in,entryids); //父分录的行id
            DynamicObjectCollection tpvDtConfiguranew = QueryServiceHelper.query("tpv_dt_configuranew", "id," +
                    "tpv_sonentryentity,tpv_sonentryentity.id insubentryid,tpv_sonentryentity.tpv_pickqty_in tpv_inqty," +
                    "tpv_sonentryentity.tpv_destroyquantity tpv_destroyquantity", qFilter.toArray());
            //查询库存子分录数据，根据父分录id过滤
            QFilter qFilterOut = new QFilter("billentry.id",QCP.large_than, 0);
            qFilterOut.and(new QFilter("billentry.tpv_srcbillsubentryid", QCP.large_than, 0));
            DynamicObjectCollection imSaloutbill = QueryServiceHelper.query("im_saloutbill", "id," +
                    "billentry,billentry.id entryid,billentry.tpv_srcbillsubentryid pickinsubentryid," +
                    "billentry.tpv_isrowout tpv_isrowout", qFilterOut.toArray());
            Map<Long, Boolean> isrowoutMap = new HashMap<>();
            for (DynamicObject dynamicObject : imSaloutbill) {
                isrowoutMap.put(dynamicObject.getLong("pickinsubentryid"), dynamicObject.getBoolean("tpv_isrowout"));
            }
            for (DynamicObject dynamicObject : tpvDtConfiguranew) {
                Map<String, Object> subEntryMap = new HashMap<>();
                Long insubentryid = dynamicObject.getLong("insubentryid");
                if (!subEntryids.contains(insubentryid)) {
                    subEntryids.add(insubentryid);
                }
                if (isrowoutMap.size() > 0) {
                    boolean tpvIsrowout = isrowoutMap.containsKey(insubentryid) ? isrowoutMap.get(insubentryid) : false;
                    if (tpvIsrowout) {
                        isrowoutValid.add(String.valueOf(insubentryid));
                    }
                }
                subEntryMap.put("tpv_isrowout", false);
                subEntryMap.put("tpv_destroyquantity", dynamicObject.getBigDecimal("tpv_destroyquantity"));
                subEntryMap.put("tpv_directconsignmentid", dynamicObject.getString("insubentryid"));
                subEntryMap.put("insubentry", "yes");//是库存实提工作台推出库
                subEntryList.add(subEntryMap);
            }
            if (islogisticsListValid.size() > 0) {
                this.getView().showTipNotification("“存在需物流确认的发货明细行，通常是因为实提相比开单超出了浮动范围，请联系物流确认”");
            }
            if (isrowoutValid.size() > 0) {
                this.getView().showTipNotification("存在对拣配明细进行过物流代点单行出库的发货单，后续的其他拣配明细均需请物流代点");
            }
            if (outqtyValid.size() > 0) {
                this.getView().showTipNotification("存在已出库的数据，请检查！");
            }
            if (islogisticsListValid.size() > 0 || isrowoutValid.size() > 0 || outqtyValid.size() > 0) {
                return;
            }
            QFilter qFilterSalout = new QFilter("billentry.tpv_srcbillsubentryid",QCP.in,subEntryids);
            DynamicObjectCollection im_saloutbill = QueryServiceHelper.query("im_saloutbill", "id,billentry,billentry.id entryid," +
                    "billentry.tpv_srcbillsubentryid insubentryid", qFilterSalout.toArray());
            if (im_saloutbill.size() > 0) {
                this.getView().showTipNotification("查库操作！！选中父分录行，存在对应子分录已有出库数据，请单行父分录检查！去源单列表查找是否是否有下游销售出库单，子分录点【+单行出库】操作(可选多行)！");
                return;
            }
            // 创建弹出动态表单页面对象
            FormShowParameter showParameter = new FormShowParameter();
            // 设置弹出页面的标识
            showParameter.setFormId("tpv_dt_inventorysnew");
            // 状态
            showParameter.setStatus(OperationStatus.ADDNEW);
            // 传参
            showParameter.setCustomParam("ids", ids.size() > 0 ? JSONObject.toJSONString(ids) : "");
            showParameter.setCustomParam("subentryids", subEntryids.size() > 0 ? JSONObject.toJSONString(subEntryids) : "");
            showParameter.setCustomParam("subentryqty", subEntryList.size() > 0 ? JSONObject.toJSONString(subEntryList) : "");
            // 设置页面关闭回调方法
            // CloseCallBack参数：回调插件，回调标识
            showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_designate"));
            // 设置弹出页面打开方式
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            // 打开动态表单
            this.getView().showForm(showParameter);
        }
    }
    public void embedded(int[] selectRows) {
        int tpvEntryentity = selectRows[0];
        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_entryentity");//商品明细
        if (entity.size() > 0) {
            DynamicObject dynamicObject = entity.get(tpvEntryentity);//数据
            BillShowParameter showParameter = new BillShowParameter();
            showParameter.setStatus(OperationStatus.EDIT);
            showParameter.getOpenStyle().setShowType(ShowType.InContainer);
            //容器表示
            showParameter.getOpenStyle().setTargetKey("tpv_flexpanelap");
            showParameter.setSendToClient(true);
            //单据标识
            showParameter.setFormId("tpv_dt_configuranew");
            //主键
            showParameter.setPkId(dynamicObject.getLong("tpv_sourceid"));
            this.getView().showForm(showParameter);
        }
    }

    @Override
    public void hyperLinkClick(HyperLinkClickEvent e) {
        // TODO Auto-generated method stub
        int index = e.getRowIndex();
        if ("tpv_shipments".equals(e.getFieldName())) {
            //发货单号
            String tpvFatherpickbill = "tpv_dt_salesshipping";//销售发货
            String tpvBillnos = (String) this.getModel().getValue("tpv_shipments", index);//发货单号
            DynamicObject random = BusinessDataServiceHelper.loadSingle(tpvFatherpickbill, "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvBillnos)});
            if (null != random) {
                skipMethod(tpvFatherpickbill, random.getPkValue());
            }
        }
        if ("tpv_market".equals(e.getFieldName())) {
            //销售合同号
            String tpvSonbill = "tpv_dt_salescontract";//销售合同
            String tpvSonbillnos = (String) this.getModel().getValue("tpv_market", index);//销售合同号
            DynamicObject random = BusinessDataServiceHelper.loadSingle(tpvSonbill, "id",
                    new QFilter[]{new QFilter("tpv_contractnos", QCP.equals, tpvSonbillnos)});
            if (null != random) {
                skipMethod(tpvSonbill, random.getPkValue());
            }
        }
        if ("tpv_billno_zy".equals(e.getFieldName())) {
            //单据编号
            String tpvGodownentry = (String) this.getModel().getValue("tpv_billno_zy", index);//单据编号
            String tpvPickbillZy = (String) this.getModel().getValue("tpv_pickbill_zy", index);//配货单据
            DynamicObject im_Purinbill = BusinessDataServiceHelper.loadSingle(tpvPickbillZy, "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvGodownentry)});
            if (null != im_Purinbill) {
                skipMethod(tpvPickbillZy, im_Purinbill.getPkValue());
            }
        }
    }

    public void skipMethod(String formId, Object object) {
        BillShowParameter showParameter = new BillShowParameter();
        showParameter.setFormId(formId);
        showParameter.setPkId(object);
        showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
        showParameter.setStatus(OperationStatus.VIEW);
        this.getView().showForm(showParameter);
    }

    /**
     * 加载数据
     */
    private void initData() {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        String whereFilter = "1=1";
        model.deleteEntryData(entryKey_1);
        //库存为直运
        String tpv_filternumber = dataEntity.getString("tpv_filternumber");//单据编号
        String tpv_marketnumber = dataEntity.getString("tpv_marketnumber");//销售合同号
        Boolean tpv_practical = dataEntity.getBoolean("tpv_practical");//实提完毕
        String tpv_blending = dataEntity.getString("tpv_blending");//是否免拣配
        DynamicObject tpvCustomerup = dataEntity.getDynamicObject("tpv_customerup");//客户
        if (null != tpvCustomerup) {
            long id = tpvCustomerup.getLong("id");
            whereFilter = String.format("%s and tpv_customer = %s", whereFilter, id);
        }
        if (StringUtil.isNotEmpty(tpv_filternumber)) {
            whereFilter = String.format("%s and tpv_shipments like %s", whereFilter, "'%" + tpv_filternumber + "%'");
        }
        if (StringUtil.isNotEmpty(tpv_marketnumber)) {
            whereFilter = String.format("%s and tpv_market like %s", whereFilter, "'%" + tpv_marketnumber + "%'");
        }
        if (tpv_practical) {
            whereFilter = String.format("%s and tpv_realsubmit = %s", whereFilter, false);
        }
        if (StringUtil.isNotEmpty(tpv_blending)) {
            if (tpv_blending.equals("A")) {
                whereFilter = String.format("%s and tpv_nopicking = %s", whereFilter, true);
            } else {
                whereFilter = String.format("%s and tpv_nopicking = %s", whereFilter, false);
            }
        }
        String whereStrForm = PersonnelDepUtils.createWhereStrForm(model, "tpv_muldepartment", "tpv_department");
        if (!"".equals(whereStrForm)){
            whereFilter=String.format("%s%s", whereFilter, whereStrForm);
        }
        whereFilter = String.format("%s and tpv_inventorytype = %s", whereFilter, "'A'");
        whereFilter = String.format("%s and tpv_nopicking = %s", whereFilter, "false");
        whereFilter = String.format("%s and tpv_sourceid != %s", whereFilter, 0);
        DataSet query = InventoryNewRptQuery.query(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity(entryKey_1).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow(entryKey_1);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }

        HashMap<Long, DynamicObject> materialMap = new HashMap<>();
        DynamicObject[] bdMaterials = BusinessDataServiceHelper.load("bd_material", "id,shkd_floatingentry,shkd_floatpercentage", null);

        for (DynamicObject bdMaterial : bdMaterials) {
            materialMap.put(bdMaterial.getLong("id"),bdMaterial);
        }
        Boolean isFlag=false;
        DynamicObjectCollection tpvEntryentitys = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_entryentity");
        for (DynamicObject tpvEntryentity : tpvEntryentitys) {
            DynamicObject tpvMaterial = tpvEntryentity.getDynamicObject("tpv_material");
            BigDecimal tpvQty = tpvEntryentity.getBigDecimal("tpv_qty");//数量
            BigDecimal tpvDestroyquantitysum = tpvEntryentity.getBigDecimal("tpv_destroyquantitysum");//销提数量
            BigDecimal tpvPacknum = tpvEntryentity.getBigDecimal("tpv_packnum");//包装数量
            BigDecimal tpvFpackagerealsum = tpvEntryentity.getBigDecimal("tpv_fpackagerealsum");//实提包装数
            BigDecimal percent = tpvDestroyquantitysum.subtract(tpvQty).divide(tpvQty, 2, RoundingMode.HALF_UP).abs();
            if (tpvMaterial!=null){
                DynamicObject material = materialMap.get(tpvMaterial.getLong("id"));
                DynamicObjectCollection shkdFloatingentrys = material.getDynamicObjectCollection("shkd_floatingentry");
                for (DynamicObject shkdFloatingentry : shkdFloatingentrys) {
                    BigDecimal shkdFloatpercentage = shkdFloatingentry.getBigDecimal("shkd_floatpercentage");
                    if (shkdFloatpercentage.compareTo(percent)==0){
                        isFlag=true;
                    }
                }
            }
            if (tpvPacknum.compareTo(BigDecimal.ZERO)!=0 && tpvFpackagerealsum.compareTo(BigDecimal.ZERO)!=0 && tpvFpackagerealsum.compareTo(tpvPacknum)!=0){
                isFlag=true;
            }
            tpvEntryentity.set("tpv_islogistics",isFlag);
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        //
        super.itemClick(evt);
        String key = evt.getItemKey();
        // 获取单据体选中行
        EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");
        int[] selectRows = entryGrid.getSelectRows();
        //监听实提完毕
        if (StringUtils.equals("tpv_practicalok", key)) {
            practicalok(selectRows);
        }
        if (StringUtils.equals("tpv_select", key)) {
            initData();
            showFlexpanelap();
        }
        //批量出库
        if (StringUtils.equals("tpv_appearentersumbtn", key)) {
            if (selectRows.length > 0) {
                Map<String,String> map = new HashMap<>();
                if (selectRows.length > 1) {
                    showFlexpanelap();
                }
                if (selectRows.length == 1) {
                    embedded(selectRows);
                }
                for (int selectRow : selectRows) {
                    String tpv_seleid = (String) this.getModel().getValue("tpv_seleid", selectRow);//发货单据id
                    map.put(tpv_seleid,tpv_seleid);
                }
                if (map.size() > 1) {
                    this.getView().showTipNotification("选择分录行中存在不是同一条发货单的分录！");
                } else if(map.size() == 1) {
                    batchEmbedded(selectRows);
                    if (selectRows.length == 1) {
                        embedded(selectRows);
                    }
                }
            } else {
                this.getView().showTipNotification("请先选中分录行，在进行批量出库！");
            }
        }
        //批量物流确认
        if (StringUtils.equals("tpv_logisticsoksumbtn", key)) {
            batchLogisValidation("tpv_destroyquantity", "tpv_destroysure", "批量物流确认成功！");
        }
        //批量反物流确认
        if (StringUtils.equals("tpv_unlogisticsoksumbtn", key)) {
            batchUnLogisValidation("tpv_unissuedquanti", "tpv_destroysure", "批量反物流确认成功！");
        }
    }

    private void practicalok(int[] selectRows) {
        List<String> rowsNoPass = new ArrayList<>();
        for (int selectRow : selectRows) {
            DynamicObjectCollection tpvEntryentity = this.getModel().getEntryEntity("tpv_entryentity");
            DynamicObject dynamicObject = tpvEntryentity.get(selectRow);
            String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_configuranew", "tpv_sonentryentity");
            long tpvSourceid = dynamicObject.getLong("tpv_sourceid");
            if (tpvSourceid > 0) {
                QFilter qFilter = new QFilter("id", "=", tpvSourceid);
                DynamicObject[] cdmreceivablebill = BusinessDataServiceHelper.load("tpv_dt_configuranew", selectfieldsFast
                        , new QFilter[]{qFilter}, null);
                for (DynamicObject object : cdmreceivablebill) {
                    boolean flag = true;
                    DynamicObjectCollection tpvSonentryentity = object.getDynamicObjectCollection("tpv_sonentryentity");
                    for (DynamicObject sonentryentity : tpvSonentryentity) {
                        boolean tpvDestroysure = sonentryentity.getBoolean("tpv_destroysure");
                        if (!tpvDestroysure) {
                            flag = false;
                            break;
                        }
                    }
                    if (!flag) {
                        rowsNoPass.add(String.valueOf(selectRow + 1));
                        break;
                    }

                }
            }
        }
        if (rowsNoPass.size() > 0) {
            this.getView().showMessage("选中上分分录第 " + String.join("、", rowsNoPass) + "行对应下方分录存在未销提确认行数据，请检查！");
        } else {
            for (int selectRow : selectRows) {
                DynamicObjectCollection tpvEntryentity = this.getModel().getEntryEntity("tpv_entryentity");
                DynamicObject dynamicObject = tpvEntryentity.get(selectRow);
                String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_configuranew", "tpv_sonentryentity");
                long tpvSourceid = dynamicObject.getLong("tpv_sourceid");
                if (tpvSourceid > 0) {
                    QFilter qFilter = new QFilter("id", "=", tpvSourceid);
                    DynamicObject[] cdmreceivablebill = BusinessDataServiceHelper.load("tpv_dt_configuranew", selectfieldsFast
                            , new QFilter[]{qFilter}, null);
                    BigDecimal qty = BigDecimal.ZERO;
                    BigDecimal packnum = BigDecimal.ZERO;
                    for (DynamicObject object : cdmreceivablebill) {
                        DynamicObjectCollection tpvSonentryentity = object.getDynamicObjectCollection("tpv_sonentryentity");
                        for (DynamicObject sonentryentity : tpvSonentryentity) {
                            qty = qty.add(sonentryentity.getBigDecimal("tpv_destroyquantity"));
                            packnum = packnum.add(sonentryentity.getBigDecimal("tpv_fpackagereal"));
                        }
                        object.set("tpv_qty", qty);
                        object.set("tpv_packnum", packnum);
                        object.set("tpv_practicalok", true);
                        SaveServiceHelper.update(object);//写入数据库
                    }
                    this.getView().getModel().setValue("tpv_realsubmit", true, selectRow);
                    this.getView().getModel().setValue("tpv_qty", qty, selectRow);
                    this.getView().getModel().setValue("tpv_packnum", packnum, selectRow);
                    String whereFilter = "1 = 1";
                    whereFilter = String.format("%s and tpv_sourceid = %s", whereFilter, Long.valueOf(tpvSourceid));
                    DataSet query = InventoryNewRptQuery.query(whereFilter);
                    DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(query);
                    //根据销售发货库存拣配直运子分录的id查询
                    for (DynamicObject dataRow : dynamicObjects) {
                        this.getView().getModel().setValue("tpv_destroyquantitysum", dataRow.getBigDecimal("tpv_destroyquantitysum"), selectRow);
                        this.getView().getModel().setValue("tpv_fpackagerealsum", dataRow.getBigDecimal("tpv_fpackagerealsum"), selectRow);
                        this.getView().getModel().setValue("tpv_issuedquantitys", dataRow.getBigDecimal("tpv_issuedquantitys"), selectRow);
                        this.getView().getModel().setValue("tpv_unissuedquanti", dataRow.getBigDecimal("tpv_unissuedquanti"), selectRow);
                        this.getView().getModel().setValue("tpv_logisticsok", dataRow.getBoolean("tpv_logisticsok"), selectRow);
                        break;
                    }
                }
            }
        }
    }

    private void batchUnLogisValidation(String unOutqty, String tpv_destroysure, String message) {
        // 获取单据体选中行
        EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");
        int[] selectRows = entryGrid.getSelectRows();
        List<String> rowsNoPass = new ArrayList<>();
        List<String> isOutNoPass = new ArrayList<>();
        for (int selectRow : selectRows) {
            DynamicObjectCollection tpvEntryentity = this.getModel().getEntryEntity("tpv_entryentity");
            DynamicObject dynamicObject = tpvEntryentity.get(selectRow);
            BigDecimal tpvUnissuedquanti = dynamicObject.getBigDecimal("tpv_unissuedquanti");
            BigDecimal tpvIssuedquantitys = dynamicObject.getBigDecimal("tpv_issuedquantitys");
            if (null != tpvIssuedquantitys) {
                if (tpvIssuedquantitys.compareTo(BigDecimal.ZERO) != 0) {
                    rowsNoPass.add(String.valueOf(selectRow + 1));
                }
            }
        }
        if (rowsNoPass.size() > 0) {
            this.getView().showTipNotification("存在已出库的行，该行不能再取消物流确认。如实提情况有误，请沟通并撤销出库单。");
        } else {
            for (int selectRow : selectRows) {
                this.getModel().setValue("tpv_logisticsok", false,selectRow);
                this.getView().showSuccessNotification(message);
            }
            if (selectRows.length == 1) {
                embedded(selectRows);
            }
        }
    }

    private void batchLogisValidation(String realsubmitqty, String tpv_destroysure, String message) {
        // 获取单据体选中行
        EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");
        int[] selectRows = entryGrid.getSelectRows();
        List<String> rowsNoPass = new ArrayList<>();
        for (int selectRow : selectRows) {
            DynamicObjectCollection tpvEntryentity = this.getModel().getEntryEntity("tpv_entryentity");
            DynamicObject dynamicObject = tpvEntryentity.get(selectRow);
            String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_configuranew", "tpv_sonentryentity");
            long tpvSourceid = dynamicObject.getLong("tpv_sourceid");
            QFilter qFilter = new QFilter("id", "=", tpvSourceid);
            DynamicObject[] cdmreceivablebill = BusinessDataServiceHelper.load("tpv_dt_configuranew",
                    selectfieldsFast, new QFilter[]{qFilter}, null);
            for (DynamicObject object : cdmreceivablebill) {
                DynamicObjectCollection tpvSonentryentity = object.getDynamicObjectCollection("tpv_sonentryentity");
                for (DynamicObject dynamic : tpvSonentryentity) {
                    BigDecimal quantity = dynamic.getBigDecimal(realsubmitqty);
                    boolean tpvDestroysure = dynamic.getBoolean("tpv_destroysure");
                    if (quantity.compareTo(BigDecimal.ZERO) == 0 || tpvDestroysure) {
                        if (!rowsNoPass.contains(String.valueOf(selectRow + 1))) {
                            rowsNoPass.add(String.valueOf(selectRow + 1));
                        }
                    }
                }
            }
        }
        if (rowsNoPass.size() > 0) {
            this.getView().showTipNotification("分录第" + String.join("、", rowsNoPass) + "行，存在对应子分录未填写数量或者存在已确认实提！");
        } else {
            for (int selectRow : selectRows) {
                this.getModel().setValue("tpv_logisticsok", true,selectRow);
                this.getView().showSuccessNotification(message);
            }
            if (selectRows.length == 1) {
                embedded(selectRows);
            }
        }
    }
}
