package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.itopview.wm.dt.report.NoInventoryRptQuery;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.earlywarn.kit.StringUtil;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.EventObject;
import java.util.List;

/**
 * 库存免拣配实提工作台-表单插件
 *
 * @author WangShuGuang
 * @description
 * @date 2023年9月16日
 */
public class InventoryNoFormPlugin extends AbstractFormPlugin implements RowClickEventListener {

    private static final String entryKey_1 = "tpv_entryentity";

    /**
     * 实提完毕后反写销售发货单数量字段
     *
     * @param e
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        // TODO Auto-generated method stub
        super.propertyChanged(e);
        String propertyName = e.getProperty().getName();
        //监听实提完毕
        if (propertyName.equals("tpv_realsubmit")) {
            OperateOption option = YEM.getOption();
            //获取单据体控件
            EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");
            //获取选中行，数组为行号，从0开始int[]
            int selectRows[] = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                //拿到当前直运分录id
                String tpv_srcentryid = (String) this.getModel().getValue("tpv_srcentryid", selectRow);
                String tpv_sourceid = (String) this.getModel().getValue("tpv_sourceid", selectRow);
                long number = Long.parseLong(tpv_srcentryid);
                long numberTpvSourceid = Long.parseLong(tpv_sourceid);
                //拿到工作台上的数量字段
                BigDecimal tpv_qty = (BigDecimal) this.getModel().getValue("tpv_qty", selectRow);
                //用id查询底表
                DynamicObject tpv_dt_noconfiguration = BusinessDataServiceHelper.loadSingle("tpv_dt_noconfiguration", "id,tpv_sonentryentity,tpv_destroyquantity",
                        new QFilter("id", QCP.equals, numberTpvSourceid).toArray());
                //用id查询销售发货单数据
                String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
                DynamicObject tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter("tpv_materialentry", QCP.equals, number).toArray());
                /*DynamicObject tpv_dt_salesshipping = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", "id,tpv_materialentry,tpv_dt_salepick_in,tpv_qty,billno",
                        new QFilter("tpv_materialentry", QCP.equals, number).toArray());*/
                //拿到底表分录数据
                if (null != tpv_dt_noconfiguration) {
                    DynamicObjectCollection tpv_sonentryentity = tpv_dt_noconfiguration.getDynamicObjectCollection("tpv_sonentryentity");
                    if (tpv_sonentryentity.size() > 0) {
                        BigDecimal qty = BigDecimal.ZERO;
                        for (DynamicObject dynamicObject : tpv_sonentryentity) {
                            //计算底表分录销提数量之和
                            qty = qty.add(dynamicObject.getBigDecimal("tpv_destroyquantity"));
                        }
                        tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle(tpvScBusinessnatures.getPkValue(),
                                tpvScBusinessnatures.getDynamicObjectType().getName());
                        DynamicObjectCollection tpv_materialentry = tpvScBusinessnatures.getDynamicObjectCollection("tpv_materialentry");
                        for (DynamicObject dynamicObject : tpv_materialentry) {
                            long id = (Long) dynamicObject.getPkValue();
                            if (id == number) {
                                //拿到销售发货单原本数量
                                BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_qty");
                                //用原本数量减去直运工作台数量
                                BigDecimal subtract = tpvDestroyquantity.subtract(tpv_qty);
                                //用减去的数量加上底表销提数量合集在插入销售发货单
                                dynamicObject.set("tpv_qty", subtract.add(qty));
                                SaveServiceHelper.update(dynamicObject);// 写入数据库
                                //调销售发货单保存方法
                                OperationResult saveT = OperationServiceHelper.executeOperate("save", "tpv_dt_salesshipping",
                                        new DynamicObject[]{tpvScBusinessnatures}, option);
                            }
                        }
                        for (DynamicObject dynamicObject : tpv_materialentry) {
                            DynamicObjectCollection objectCollection = dynamicObject.getDynamicObjectCollection("tpv_dt_salepick_in");
                            for (DynamicObject object : objectCollection) {
                                DynamicObjectCollection tpv_sonentryentit = tpv_dt_noconfiguration.getDynamicObjectCollection("tpv_sonentryentity");
                                for (DynamicObject dynamicObject1 : tpv_sonentryentit) {
                                    if (object.getLong("id") == dynamicObject1.getLong("id")){
                                        object.set("tpv_pickqty_in",dynamicObject1.getBigDecimal("tpv_destroyquantity"));
                                        SaveServiceHelper.update(object);// 写入数据库
                                        OperationResult saveT = OperationServiceHelper.executeOperate("save", "tpv_dt_salesshipping",
                                                new DynamicObject[]{tpvScBusinessnatures}, option);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");//商品明细
        this.addItemClickListeners("tpv_toolbarap");
        this.addClickListeners("tpv_selects");
        entryGrid.addRowClickListener(this);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        initData();
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control source = (Control) evt.getSource();
        // 点击确认按钮
        if (StringUtils.equals(source.getKey(), "tpv_selects")) {
            initData();
        }
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        EntryGrid entryGrid = (EntryGrid) evt.getSource();
        if (StringUtils.equals("tpv_entryentity", entryGrid.getKey())) {
            //int tpvEntryentity = this.getModel().getEntryCurrentRowIndex("tpv_entryentity");
            embedded();
        }
    }

    public void embedded() {
        int tpvEntryentity = this.getModel().getEntryCurrentRowIndex("tpv_entryentity");
        if (tpvEntryentity >= 0) {
            DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_entryentity");//商品明细
            if (entity.size() > 0) {
                DynamicObject dynamicObject = entity.get(tpvEntryentity);//数据
                dynamicObject.getLong("tpv_sourceid");
                BillShowParameter showParameter = new BillShowParameter();
                showParameter.setStatus(OperationStatus.EDIT);
                showParameter.setCustomParam("tpv_srcentryid", dynamicObject.getString("tpv_seleid"));
                showParameter.getOpenStyle().setShowType(ShowType.InContainer);
                //容器表示
                showParameter.getOpenStyle().setTargetKey("tpv_flexpanelap");
                showParameter.setSendToClient(true);
                //单据标识
                showParameter.setFormId("tpv_dt_noconfiguration");
                //主键
                showParameter.setPkId(dynamicObject.getLong("tpv_sourceid"));
                this.getView().showForm(showParameter);
            }
        }
    }

    /**
     * 表单打开默认内嵌
     *
     * @param e
     */
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        //int tpvEntryentity = this.getModel().getEntryCurrentRowIndex("tpv_entryentity");
        embedded();
    }

    /**
     * 加载数据
     */
    private void initData() {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        String whereFilter = "1=1";
        model.deleteEntryData(entryKey_1);
        //库存为直运
        String tpv_filternumber = dataEntity.getString("tpv_filternumber");//单据编号
        String tpv_marketnumber = dataEntity.getString("tpv_marketnumber");//销售合同号
        Boolean tpv_practical = dataEntity.getBoolean("tpv_practical");//实提完毕
        String tpv_blending = dataEntity.getString("tpv_blending");//是否免拣配
        if (StringUtil.isNotEmpty(tpv_filternumber)) {
            whereFilter = String.format("%s and tpv_shipments like %s", whereFilter, "'%" + tpv_filternumber + "%'");
        }
        if (StringUtil.isNotEmpty(tpv_marketnumber)) {
            whereFilter = String.format("%s and tpv_market like %s", whereFilter, "'%" + tpv_marketnumber + "%'");
        }
        if (tpv_practical){
            whereFilter = String.format("%s and tpv_realsubmit = %s", whereFilter, false);
        }
        if (StringUtil.isNotEmpty(tpv_blending)) {
            if (tpv_blending.equals("A")) {
                whereFilter = String.format("%s and tpv_nopicking = %s", whereFilter, true);
            } else {
                whereFilter = String.format("%s and tpv_nopicking = %s", whereFilter, false);
            }
        }
        whereFilter = String.format("%s and tpv_inventorytype = %s", whereFilter, "'A'");
        whereFilter = String.format("%s and tpv_nopicking = %s", whereFilter, "true");
        whereFilter = String.format("%s and tpv_sourceid != %s", whereFilter, 0);
        DataSet query = NoInventoryRptQuery.query(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity(entryKey_1).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow(entryKey_1);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        //
        super.itemClick(evt);
        String key = evt.getItemKey();
        //监听物流确认采购实提按钮
        if (StringUtils.equals("tpv_practicalok", key)) {
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");
            int[] selectRows = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                DynamicObjectCollection tpvEntryentity = this.getModel().getEntryEntity("tpv_entryentity");
                DynamicObject dynamicObject = tpvEntryentity.get(selectRow);
                long tpvSourceid = dynamicObject.getLong("tpv_sourceid");
                QFilter qFilter = new QFilter("id", "=", tpvSourceid);
                DynamicObject[] cdmreceivablebill = null;
                cdmreceivablebill = BusinessDataServiceHelper.load("tpv_dt_noconfiguration", "id,tpv_practicalok"
                        , new QFilter[]{qFilter}, null);
                for (DynamicObject object : cdmreceivablebill) {
                    object.set("tpv_practicalok", true);
                    SaveServiceHelper.update(object);//写入数据库
                    this.getModel().setValue("tpv_realsubmit", true, selectRow);
                }
                //initData();
            }
        }
        if (StringUtils.equals("tpv_select", key)) {
            initData();
        }
    }
}
