package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DateUtil;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.control.events.BeforeClickEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.math.BigDecimal;
import java.util.*;

/**
 * 匹配入库分录赋值
 *
 * @author LiuHB
 * @version 1.0
 */
public class MatcentryEdit extends AbstractFormPlugin {

    private static final String warehouseEntryDetail = "tpv_contractinfo";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        addClickListeners("btnok", "btncancel", "tpv_query");
    }

    /**
     * 动态表单打开  获取单据上的本次匹配金额等数据
     *
     * @param e
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        IDataModel parentModel = this.getView().getParentView().getModel();
        DynamicObject tpvDepartment = (DynamicObject) parentModel.getValue("tpv_department");//费用 部门
        this.getModel().setValue("tpv_orgdepart",tpvDepartment);
        Map<String, Object> maps = showParameter.getCustomParams();
        Set<String> mapkey = maps.keySet();
        Long tpvBillunit = (Long) maps.get("tpv_billunit");
//        this.getModel().setValue("tpv_invoicedept", tpvBillunit);
        initData(false);
        DynamicObjectCollection tpvContractinfo = this.getModel().getEntryEntity("tpv_contractinfo");
        for (DynamicObject dynamicObject : tpvContractinfo) {
            String tpvNumorinb = dynamicObject.getString("tpv_inboentid");
            if (maps != null) {
                for (Map.Entry<String, Object> stringObjectEntry : maps.entrySet()) {
                    if (stringObjectEntry.getKey().equals(tpvNumorinb)) {
                        JSONObject jsonObject = JSONObject.parseObject(String.valueOf(stringObjectEntry.getValue()));
                        BigDecimal tpvTaxmatamt = jsonObject.getBigDecimal("tpv_taxmatamt");
                        BigDecimal tpvVatnomatamt = jsonObject.getBigDecimal("tpv_vatnomatamt");
                        BigDecimal tpvTaxnomatamt = jsonObject.getBigDecimal("tpv_taxnomatamt");
                        BigDecimal tpvrated = jsonObject.getBigDecimal("tpv_rated");
//                        dynamicObject.set("tpv_choose", true);
                        dynamicObject.set("tpv_taxmatamt", tpvTaxmatamt);
                        dynamicObject.set("tpv_taxnomatamt", tpvTaxnomatamt);
                        dynamicObject.set("tpv_vatnomatamt", tpvVatnomatamt);
                        dynamicObject.set("tpv_rate", tpvrated);

                    }
                }
            }
        }

    }

    /**
     * 按钮点击
     * @param evt
     */
    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control c = (Control) evt.getSource();
        String key = c.getKey().toLowerCase();
        this.getModel().getDataEntity(true);

        switch (key) {
            case "btnok":
                returnmessage();
                break;
            case "btncancel":
                this.getView().close();
                break;
            case "tpv_query":
                IDataModel model = this.getModel();
                model.deleteEntryData("tpv_contractinfo");
                initData(false);
                break;

        }
    }

    /**
     * 根据本次匹配金额（含税）以及税率计算增值税额，不含税金额
     *
     * @param e
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        BigDecimal taxnoinclamt = BigDecimal.ZERO;
        BigDecimal taxinclamt = (BigDecimal) this.getModel().getValue("tpv_taxmatamt");//本次匹配金额（含税）
        BigDecimal rate = (BigDecimal) this.getModel().getValue("tpv_rate");//税率%
        String propertyName = e.getProperty().getName();
        if ("tpv_taxmatamt".equals(propertyName) || "tpv_rate".equals(propertyName)) {
            if (taxinclamt.compareTo(BigDecimal.ZERO) == 0 || rate.compareTo(BigDecimal.ZERO) == 0) {
                return;
            } else {
                int i = 100;
                int b = 1;
                BigDecimal bigDecimalb = new BigDecimal(b);
                BigDecimal bigDecimali = new BigDecimal(i);
                BigDecimal divide = rate.divide(bigDecimali);
                BigDecimal add = divide.add(bigDecimalb);
                BigDecimal divides = taxinclamt.divide(add, 11, BigDecimal.ROUND_HALF_UP);
                BigDecimal vatamt = divides.multiply(divide);
                vatamt = vatamt.setScale(2,BigDecimal.ROUND_HALF_UP);
                taxnoinclamt = taxinclamt.subtract(vatamt);
                this.getModel().setValue("tpv_vatnomatamt", vatamt);
                this.getModel().setValue("tpv_taxnomatamt", taxnoinclamt);
            }
        }


    }

    /**
     * 返回到单据的信息
     */
    public void returnmessage() {
        List<Map<String, Object>> list = new ArrayList<>();
        Boolean flag = false;
        DynamicObjectCollection tpvAdvconap = this.getModel().getEntryEntity("tpv_contractinfo");
        for (DynamicObject dynamicObject : tpvAdvconap) {
            HashMap<String, Object> hashMap = new HashMap<>();
            DynamicObject tpvDepartment = null;
            long departmentid = 0L;
            Long tpvPurcontnum = 0L;
            String tpvNumorinb = "";
            DynamicObject tpvSupplier = null;
            long supplierid = 0L;
            DynamicObject tpvItemcode = null;
            long itemcodeid = 0L;
            String itemcodename = "";
            DynamicObject conprodname = null;
            long conprodnameid = 0L;
            String tpvConshader = "";
            DynamicObject tpvConorigin = null;
            long conoriginid = 0L;
            String tpvConspecation = "";
            BigDecimal tpvConqty = BigDecimal.ZERO;
            BigDecimal tpvContractamt = BigDecimal.ZERO;
            DynamicObject tpvCurrency = null;
            long currencyid = 0L;
            BigDecimal tpvExchangerate = BigDecimal.ZERO;
            DynamicObject tpvExraterate = null;
            long exraterateid = 0L;
            String tpvInboentid = "";
            BigDecimal tpvTaxinclamt = dynamicObject.getBigDecimal("tpv_taxmatamt");
            BigDecimal tpvRate = dynamicObject.getBigDecimal("tpv_rate");
            BigDecimal tpvTaxnoinclamt = dynamicObject.getBigDecimal("tpv_taxnomatamt");
            BigDecimal tpvVatamt = dynamicObject.getBigDecimal("tpv_vatnomatamt");
            tpvDepartment = dynamicObject.getDynamicObject("tpv_department");
            if (tpvDepartment != null) {
                departmentid = tpvDepartment.getLong("id");
            }
            DynamicObject tpvPurcontnums = dynamicObject.getDynamicObject("tpv_purcontnumsd");
            if(tpvPurcontnums != null){
                 tpvPurcontnum = tpvPurcontnums.getLong("id");

            }
            tpvNumorinb = dynamicObject.getString("tpv_numorinb");
            tpvSupplier = dynamicObject.getDynamicObject("tpv_supplier");
            if (tpvSupplier != null) {
                supplierid = tpvSupplier.getLong("id");
            }
            tpvItemcode = dynamicObject.getDynamicObject("tpv_itemcode");
            if (tpvItemcode != null) {
                itemcodeid = tpvItemcode.getLong("id");
                itemcodename = tpvItemcode.getString("name");
            }
            conprodname = dynamicObject.getDynamicObject("tpv_conprodname");
            if (conprodname != null) {
                conprodnameid = conprodname.getLong("id");
            }
            tpvConshader = dynamicObject.getString("tpv_conshader");
            tpvConorigin = dynamicObject.getDynamicObject("tpv_conorigin");
            if (tpvConorigin != null) {
                conoriginid = tpvConorigin.getLong("id");
            }
            tpvConspecation = dynamicObject.getString("tpv_conspecation");
            tpvConqty = dynamicObject.getBigDecimal("tpv_conqty");
            tpvContractamt = dynamicObject.getBigDecimal("tpv_contractamt");
            tpvCurrency = dynamicObject.getDynamicObject("tpv_currency");
            if (tpvCurrency != null) {
                currencyid = tpvCurrency.getLong("id");
            }


            tpvExchangerate = dynamicObject.getBigDecimal("tpv_exchangerate");
            tpvExraterate = dynamicObject.getDynamicObject("tpv_exraterate");
            if (tpvExraterate != null) {
                exraterateid = tpvExraterate.getLong("id");
            }
            tpvInboentid = dynamicObject.getString("tpv_inboentid");
            boolean tpvChoose = dynamicObject.getBoolean("tpv_choose");
            //判断数据是否选择，选择后进行回填
            if (tpvChoose) {
                flag = true; //判断是否有选择行
                hashMap.put("tpv_taxmatamt", tpvTaxinclamt);
                hashMap.put("tpv_taxnomatamt", tpvTaxnoinclamt);
                hashMap.put("tpv_vatnomatamt", tpvVatamt);
                hashMap.put("tpv_departmet", departmentid);//部门
                hashMap.put("tpv_purchnumd", tpvPurcontnum);//采购合同号
                hashMap.put("tpv_inbordnum", tpvNumorinb);//入库单号
                hashMap.put("tpv_vendors", supplierid);//供应商
                hashMap.put("tpv_itemcode", itemcodeid);//物料编码
                hashMap.put("tpv_conprodname", conprodnameid);//品名
                hashMap.put("tpv_conshader", tpvConshader);//材质
                hashMap.put("tpv_conorigin", conoriginid);//产地
                hashMap.put("tpv_conspecation", tpvConspecation);//规格
                hashMap.put("tpv_conqty", tpvConqty);//数量
                hashMap.put("tpv_contractamo", tpvContractamt);//金额
                hashMap.put("tpv_currency", currencyid);//币别
                hashMap.put("tpv_exraterate", exraterateid);//汇率表
                hashMap.put("tpv_exchangerate", tpvExchangerate);//汇率
                hashMap.put("tpv_inboentid", tpvInboentid);//入库分录id
                hashMap.put("tpv_rate", tpvRate);
                list.add(hashMap);
            }
        }
        if (flag) {
            this.getView().returnDataToParent(list);
            this.getView().close();
        } else {
            this.getView().showTipNotification("未选择行数据！");
        }
    }

    /**
     * 初始化数据
     *
     * @param b
     */
    private void initData(boolean b) {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        IDataModel parentModel = view.getParentView().getModel();
        ArrayList<String> entryIDs = new ArrayList<>();
        long contractnumid = 0L;
        ArrayList<QFilter> filters = new ArrayList<>();
        filters.add(new QFilter("billstatus", QCP.equals, "C"));//已审核
        DynamicObject supplier = (DynamicObject) model.getValue("tpv_invoicedept");//供应商
        DynamicObject org = (DynamicObject) model.getValue("tpv_orgdepart");//部门
        DynamicObject contractnum = (DynamicObject) model.getValue("tpv_purconnume");//采购合同号
        if(contractnum!= null){
             contractnumid = contractnum.getLong("id");
        }

        DynamicObject tpvCompany = (DynamicObject) parentModel.getValue("tpv_company");//费用 公司

        String purinbillno = (String) model.getValue("tpv_inbordnum");//入库单号
        Date startDate = (Date) model.getValue("tpv_invocestartdate");//业务日期从
        Date endDate = (Date) model.getValue("tpv_invoceenddate");//业务日期至

        if (tpvCompany!=null){
            filters.add(new QFilter("org", QCP.equals, tpvCompany.getPkValue()));//部门
        }
        if (null != supplier) {
            long supID = supplier.getLong("id");//供应商id
            filters.add(new QFilter("supplier", QCP.equals, supID));//供应商
        }
        if (null !=purinbillno) {
            filters.add(new QFilter("billno", QCP.like,"%" + purinbillno + "%"));//入库单号
        }
        if (null != org) {
            long orgID = org.getLong("id");//部门id
            filters.add(new QFilter("bizdept", QCP.equals, orgID));//部门
        }
        if (null !=contractnum) {
            filters.add(new QFilter("billentry.tpv_contractnumber.id", QCP.equals, contractnumid));//采购合同号
        }
        if (null != startDate) {
            filters.add(new QFilter("biztime", QCP.large_equals, DateUtil.getStartOfDay(startDate)));//业务日期从
        }
        if (null != endDate) {
            filters.add(new QFilter("biztime", QCP.less_equals, DateUtil.getEndOfDay(endDate)));//业务日期至
        }

        DataSet queryDataSet = ORM.create().queryDataSet(this.getClass().getName(), "im_purinbill",
                "id,billno,billstatus,bizdept,tpv_purcontnum,billentry" +
                        ",billentry.material.masterid,billentry.tpv_prodname,supplier,billentry.tpv_contractnumber.id" +//tpv_material
                        ",billentry.tpv_shader,billentry.tpv_origin,billentry.qty,billentry.tpv_specation,billentry.amountandtax,currency,exratetable,exchangerate"
                , filters.toArray(new QFilter[0]));
        DataSet selected = queryDataSet.select("id", "billno", "billentry.tpv_contractnumber.id contractnumber", "supplier", "bizdept department"
                , "billentry.material.masterid masterid", "billentry entryID", "billentry.tpv_prodname prodname"
                , "billentry.tpv_shader shader", "billentry.tpv_origin origin", "billentry.qty qty", "billentry.tpv_specation specation"
                , "billentry.amountandtax taxpramount", "currency", "exratetable", "exchangerate");
        //分录填充数据
        if (selected.isEmpty()) {
            this.getModel().deleteEntryData(warehouseEntryDetail);
            return;
        }
        this.getModel().deleteEntryData(warehouseEntryDetail);
        DataSet copy = selected.copy();
        for (Row row : selected) {
            entryIDs.add(row.getString("entryID"));
        }
        setInvoiceData(copy, entryIDs);
    }

    /**
     * 获取单据数据填值
     *
     * @param queryDataSet
     */
    private void setInvoiceData(DataSet queryDataSet, ArrayList<String> entryIDS) {
        IDataModel model = this.getModel();
        HashMap<String, BigDecimal> matchedQty = getMatchedQty(entryIDS);//获取已匹配数量等
        int[] index = this.getModel().batchCreateNewEntryRow(warehouseEntryDetail, entryIDS.size());
        int i = 0;
        for (Row row : queryDataSet) {
            String entryID = row.getString("entryID");//入库分录ID
            model.setValue("tpv_department", row.getLong("department"), index[i]);//部门
            model.setValue("tpv_purcontnumsd", row.getLong("contractnumber"), index[i]);//采购合同号
            model.setValue("tpv_numorinb", row.getString("billno"), index[i]);//入库单号
            model.setValue("tpv_supplier", row.getLong("supplier"), index[i]);//供应商
            model.setValue("tpv_itemcode", row.getLong("masterid"), index[i]);//物料编码
            model.setValue("tpv_conprodname", row.getString("prodname"), index[i]);//品名
            model.setValue("tpv_conshader", row.getString("shader"), index[i]);//材质
            model.setValue("tpv_conorigin", row.getLong("origin"), index[i]);//产地
            model.setValue("tpv_conspecation", row.getString("specation"), index[i]);//规格
            model.setValue("tpv_conqty", row.getBigDecimal("qty"), index[i]);//数量
            model.setValue("tpv_contractamt", row.getBigDecimal("taxpramount"), index[i]);//金额
            model.setValue("tpv_currency", row.getLong("currency"), index[i]);//币别
            model.setValue("tpv_exraterate", row.getLong("exratetable"), index[i]);//汇率表
            model.setValue("tpv_exchangerate", row.getLong("exchangerate"), index[i]);//汇率
            model.setValue("tpv_inboentid", entryID, index[i]);//入库分录id

            i++;
        }

    }

    /**
     * @Title: getMatchedQty
     * @Description: 获取已匹配数量等信息
     * @param:
     * @return: a
     */
    private HashMap<String, BigDecimal> getMatchedQty(ArrayList<String> entryIDS) {
        ArrayList<QFilter> filters = new ArrayList<>();
        filters.add(new QFilter("tpv_wareiformation.tpv_purinentryid", QCP.in, entryIDS));//单据编号
        HashMap<String, BigDecimal> map = new HashMap<>();
        DataSet load = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_purinvomater",
                "id,tpv_wareiformation,tpv_wareiformation.tpv_purinentryid,tpv_wareiformation.tpv_rkcurmatchqty"
                , filters.toArray(new QFilter[0]));
        DataSet executeSql = load.executeSql("select tpv_wareiformation.tpv_purinentryid ,sum(tpv_wareiformation.tpv_rkcurmatchqty) rkcurmatchqty GROUP BY tpv_wareiformation.tpv_purinentryid");

        DataSet loads = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_wbillcromater",
                "id,tpv_dt_incomingenty,tpv_dt_incomingenty.tpv_bcmonnumrk,tpv_dt_incomingenty.tpv_rkcomid"
                , null);
        DataSet executeSqls = loads.executeSql("select tpv_dt_incomingenty.tpv_rkcomid ,sum(tpv_dt_incomingenty.tpv_bcmonnumrk) rkcurmatchqty GROUP BY tpv_dt_incomingenty.tpv_rkcomid");
        executeSql.print(true);
        executeSqls.print(true);
        for (Row row : executeSql) {
            BigDecimal decimal = row.getBigDecimal("rkcurmatchqty");
            String purinentryid = row.getString("tpv_wareiformation.tpv_purinentryid");
            map.put(purinentryid, decimal);
        }
        for (Row row : executeSqls) {
            BigDecimal decimal = row.getBigDecimal("rkcurmatchqty");
            String purinentryid = row.getString("tpv_dt_incomingenty.tpv_rkcomid");
            map.put(purinentryid, null == map.get(purinentryid) ? decimal : map.get(purinentryid).add(decimal));
        }
        return map;
    }
    @Override
    public void beforeClick(BeforeClickEvent evt) {
        super.beforeClick(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
//                DynamicObjectCollection tpvSelectinvoiceinfo = this.getView().getModel().getEntryEntity("tpv_contractinfo");
//                for (DynamicObject dynamicObject : tpvSelectinvoiceinfo) {
//                    int indexOf = tpvSelectinvoiceinfo.indexOf(dynamicObject);
//                    indexOf = indexOf + 1;
//                    BigDecimal tpv_taxmatamt = dynamicObject.getBigDecimal("tpv_taxmatamt");
//                    boolean tpvChoose = dynamicObject.getBoolean("tpv_choose");
//                    if(tpvChoose) {
//                        if (tpv_taxmatamt.compareTo(BigDecimal.ZERO) == 0) {
//
//                            evt.setCancel(true);
//                            this.getView().showTipNotification("采购入库信息第" + indexOf + "行的本次匹配金额(含税)未填");
//                        }
//                    }
//                }
                break;
        }

    }

}

