package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.control.events.BeforeClickEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * 匹配成本
 *
 * @author LiuHB
 * @version 1.0
 */
public class MatchcostEdit extends AbstractFormPlugin {

    private static final String warehouseEntryDetail = "tpv_stanalysis";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        addClickListeners("btnok", "btncancel", "tpv_query");
    }

    /**
     * 动态表单打开获取单据上的本次匹配金额等数据
     *
     * @param e
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = showParameter.getCustomParams();
        Set<String> mapkey = maps.keySet();
        Long tpvBillunit = (Long) maps.get("tpv_billunit");
        this.getModel().setValue("tpv_invoicedept", tpvBillunit);
        Long tpvCostitem = (Long) maps.get("tpv_costitem");
        this.getModel().setValue("tpv_costitemf", tpvCostitem);
        IDataModel parentModel = this.getView().getParentView().getModel();
        DynamicObject tpvDepartment = (DynamicObject) parentModel.getValue("tpv_department");//费用 部门
        this.getModel().setValue("tpv_departmentf", tpvDepartment);
        initData(false);
        DynamicObjectCollection tpvContractinfo = this.getModel().getEntryEntity("tpv_stanalysis");
        for (DynamicObject dynamicObject : tpvContractinfo) {
            String tpvNumorinb = dynamicObject.getString("tpv_cosbreakid");
            if (maps != null) {
                for (Map.Entry<String, Object> stringObjectEntry : maps.entrySet()) {
                    if (stringObjectEntry.getKey().equals(tpvNumorinb)) {
                        JSONObject jsonObject = JSONObject.parseObject(String.valueOf(stringObjectEntry.getValue()));
                        BigDecimal tpvTaxmatamt = jsonObject.getBigDecimal("tpv_taxmatamt");
                        BigDecimal tpvVatnomatamt = jsonObject.getBigDecimal("tpv_vatnomatamt");
                        BigDecimal tpvTaxnomatamt = jsonObject.getBigDecimal("tpv_taxnomatamt");
                        BigDecimal tpvrated = jsonObject.getBigDecimal("tpv_rated");
//                        dynamicObject.set("tpv_choose", true);
                        dynamicObject.set("tpv_taxmatamt", tpvTaxmatamt);
                        dynamicObject.set("tpv_taxnomatamt", tpvTaxnomatamt);
                        dynamicObject.set("tpv_vatnomatamt", tpvVatnomatamt);
                        dynamicObject.set("tpv_rate", tpvrated);
                    }
                }
            }
        }

    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control c = (Control) evt.getSource();
        String key = c.getKey().toLowerCase();
        this.getModel().getDataEntity(true);

        switch (key) {
            case "btnok":
                returnmessage();
                break;
            case "btncancel":
                this.getView().close();
                break;
            case "tpv_query":
                IDataModel model = this.getModel();
                model.deleteEntryData("tpv_stanalysis");
                initData(false);
                break;

        }
    }

    /**
     * 返回到单据的信息
     */
    public void returnmessage() {
        List<Map<String, Object>> list = new ArrayList<>();
        Boolean flag = false;
        DynamicObjectCollection tpvAdvconap = this.getModel().getEntryEntity("tpv_stanalysis");
        for (DynamicObject dynamicObject : tpvAdvconap) {
            HashMap<String, Object> hashMap = new HashMap<>();
            DynamicObject tpvDepartment = null;
            long departmentid = 0L;
            Long tpvPurcontnum = 0L;
            String tpvNumorinb = "";
            DynamicObject tpvSupplier = null;
            long supplierid = 0L;
            DynamicObject tpvItemcode = null;
            long itemcodeid = 0L;
            String itemcodename = "";
            DynamicObject conprodname = null;
            long conprodnameid = 0L;
            String tpvConshader = "";
            DynamicObject tpvConorigin = null;
            long conoriginid = 0L;
            String tpvConspecation = "";
            BigDecimal tpvConqty = BigDecimal.ZERO;
            BigDecimal tpvContractamt = BigDecimal.ZERO;
            DynamicObject tpvCurrency = null;
            long currencyid = 0L;
            BigDecimal tpvExchangerate = BigDecimal.ZERO;
            DynamicObject tpvExraterate = null;
            long exraterateid = 0L;
            String tpvInboentid = "";
            String cosbreakid = "";
            DynamicObject tpvTypecost = null;
            long tpvTypecostid = 0L;
            BigDecimal tpvTaxinclamt = dynamicObject.getBigDecimal("tpv_taxmatamt");
            BigDecimal tpvRate = dynamicObject.getBigDecimal("tpv_rate");
            BigDecimal tpvTaxnoinclamt = dynamicObject.getBigDecimal("tpv_taxnomatamt");
            BigDecimal tpvVatamt = dynamicObject.getBigDecimal("tpv_vatnomatamt");
            tpvDepartment = dynamicObject.getDynamicObject("tpv_department");
            if (tpvDepartment != null) {
                departmentid = tpvDepartment.getLong("id");
            }
            DynamicObject tpvPurcontnums = dynamicObject.getDynamicObject("tpv_purcontnumsd");
            if(tpvPurcontnums != null){
                tpvPurcontnum = tpvPurcontnums.getLong("id");

            }
            tpvNumorinb = dynamicObject.getString("tpv_numorinb");
            tpvSupplier = dynamicObject.getDynamicObject("tpv_supplier");
            if (tpvSupplier != null) {
                supplierid = tpvSupplier.getLong("id");
            }
            tpvItemcode = dynamicObject.getDynamicObject("tpv_itemcode");
            if (tpvItemcode != null) {
                itemcodeid = tpvItemcode.getLong("id");
                itemcodename = tpvItemcode.getString("name");
            }
            conprodname = dynamicObject.getDynamicObject("tpv_conprodname");
            if (conprodname != null) {
                conprodnameid = conprodname.getLong("id");
            }
            tpvConshader = dynamicObject.getString("tpv_conshader");
            tpvConorigin = dynamicObject.getDynamicObject("tpv_conorigin");
            if (tpvConorigin != null) {
                conoriginid = tpvConorigin.getLong("id");
            }
            tpvConspecation = dynamicObject.getString("tpv_conspecation");
            tpvConqty = dynamicObject.getBigDecimal("tpv_quantity");
            tpvContractamt = dynamicObject.getBigDecimal("tpv_contractamt");
            tpvCurrency = dynamicObject.getDynamicObject("tpv_currency");
            if (tpvCurrency != null) {
                currencyid = tpvCurrency.getLong("id");
            }
//            if (tpvExchangerate.compareTo(BigDecimal.ZERO) != 0) {
//                tpvExchangerate = dynamicObject.getBigDecimal("tpv_exchangerate");
//            }
//            tpvExraterate = dynamicObject.getDynamicObject("tpv_exraterate");
            if (tpvExraterate != null) {
                exraterateid = tpvExraterate.getLong("id");
            }
             tpvTypecost = dynamicObject.getDynamicObject("tpv_typecost");
            if(null != tpvTypecost){
                 tpvTypecostid = tpvTypecost.getLong("id");
            }
            tpvInboentid = dynamicObject.getString("tpv_inboentid");
            cosbreakid = dynamicObject.getString("tpv_cosbreakid");
            boolean tpvChoose = dynamicObject.getBoolean("tpv_choose");
            if (tpvChoose) {
                flag = true; //判断是否有选择行
                hashMap.put("tpv_typecost", tpvTypecostid);
                hashMap.put("tpv_cosbreakid", cosbreakid);
                hashMap.put("tpv_taxmatamt", tpvTaxinclamt);
                hashMap.put("tpv_taxnomatamt", tpvTaxnoinclamt);
                hashMap.put("tpv_vatnomatamt", tpvVatamt);
                hashMap.put("tpv_departmet", departmentid);//部门
                hashMap.put("tpv_purchnumd", tpvPurcontnum);//采购合同号
                hashMap.put("tpv_inbordnum", tpvNumorinb);//入库单号
                hashMap.put("tpv_vendors", supplierid);//供应商
                hashMap.put("tpv_itemcode", itemcodeid);//物料编码
                hashMap.put("tpv_conprodname", conprodnameid);//品名
                hashMap.put("tpv_conshader", tpvConshader);//材质
                hashMap.put("tpv_conorigin", conoriginid);//产地
                hashMap.put("tpv_conspecation", tpvConspecation);//规格
                hashMap.put("tpv_conqty", tpvConqty);//数量
                hashMap.put("tpv_contractamo", tpvContractamt);//金额
                hashMap.put("tpv_currency", currencyid);//币别
                hashMap.put("tpv_exraterate", exraterateid);//汇率表
                hashMap.put("tpv_exchangerate", tpvExchangerate);//汇率
                hashMap.put("tpv_inboentid", tpvInboentid);//入库分录id
                hashMap.put("tpv_rate", tpvRate);
                list.add(hashMap);
            }
        }
        if (flag) {
            this.getView().returnDataToParent(list);
            this.getView().close();
        } else {
            this.getView().showTipNotification("未选择行数据！");
        }
    }

    /**
     * 初始化数据
     *
     * @param b
     */
    private void initData(boolean b) {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        long contractnumid = 0L;
        ArrayList<QFilter> filters = new ArrayList<>();
        filters.add(new QFilter("billstatus", QCP.equals, "C"));//已审核
        DynamicObject supplier = (DynamicObject) model.getValue("tpv_invoicedept");//物流服务商
        DynamicObject departmentf = (DynamicObject) model.getValue("tpv_departmentf");//部门
        DynamicObject contractnum = (DynamicObject) model.getValue("tpv_purconnume");//采购合同号
        if(contractnum!= null){
            contractnumid = contractnum.getLong("id");
        }
        String purinbillno = (String) model.getValue("tpv_purinbillno");//入库单号
        Date startDate = (Date) model.getValue("tpv_invocestartdate");//业务日期从
        Date endDate = (Date) model.getValue("tpv_invoceenddate");//业务日期至

        FormShowParameter showParameter = this.getView().getFormShowParameter();
        DynamicObject tpvCostitemf = (DynamicObject) model.getValue("tpv_costitemf");//费用项目
        if (YEM.isNotEmpty(tpvCostitemf)) {
            filters.add(new QFilter("tpv_costype.id", QCP.equals, tpvCostitemf.getLong("id")));//费用项目
        }
        if (null != supplier) {
            long supID = supplier.getLong("id");//供应商id
            filters.add(new QFilter("tpv_logserpro", QCP.equals, supID));//物流服务商
        }
        if (!"".equals(purinbillno)) {
            filters.add(new QFilter("tpv_storagenum", QCP.equals, purinbillno));//入库单号
        }
        IDataModel parentModel = this.getView().getParentView().getModel();
        DynamicObject tpv_company = (DynamicObject) parentModel.getValue("tpv_company");//费用 公司
        if (null != tpv_company) {
            long tpvCompanyID = tpv_company.getLong("id");//公司id
            filters.add(new QFilter("org", QCP.equals, tpvCompanyID));//公司
        }
        if (null != departmentf) {
            long departmentfID = departmentf.getLong("id");//部门id
            filters.add(new QFilter("tpv_department", QCP.equals, departmentfID));//部门
        }
        if (null !=contractnum) {
            filters.add(new QFilter("tpv_purconnum.id", QCP.equals, contractnumid));//采购合同号
        }
        if (null != startDate) {
            filters.add(new QFilter("tpv_bizdate", QCP.large_equals, DateUtil.getStartOfDay(startDate)));//业务日期从
        }
        if (null != endDate) {
            filters.add(new QFilter("tpv_bizdate", QCP.less_equals, DateUtil.getEndOfDay(endDate)));//业务日期至
        }
        filters.add(new QFilter("tpv_tentauth",QCP.equals,"A"));
        filters.add(new QFilter("tpv_costype.id",QCP.not_equals,1835686669391498240L));
        filters.add(new QFilter("tpv_costdirec",QCP.equals,"A"));
        filters.add(new QFilter("tpv_supstorageid",QCP.equals,""));
        DynamicObjectCollection tpvDtCostbillm = QueryServiceHelper.query("tpv_dt_costbillmat", "tpv_matecost,tpv_matecost.tpv_costbreaid tpv_costbreaid",
                new QFilter[]{new QFilter("tpv_matecost.tpv_costbreaid", QCP.not_equals, "")});
        List<Long> ids = new ArrayList<>();
        for (DynamicObject dynamicObject : tpvDtCostbillm) {
            String tpvCostbreaid = dynamicObject.getString("tpv_costbreaid");
            if (YEM.isNotEmpty(tpvCostbreaid)) {
                if (!ids.contains(Long.valueOf(tpvCostbreaid))) {
                    ids.add(Long.valueOf(tpvCostbreaid));
                }
            }
        }
        if (ids.size() > 0) {
            filters.add(new QFilter("id",QCP.not_in, ids));
        }
        DataSet queryDataSet = ORM.create().queryDataSet(this.getClass().getName(), "tpv_cm_costdispose", "id,billno,billstatus,org,tpv_department,tpv_purconnum," +
                "tpv_storagenum,tpv_vendor,tpv_logserpro,tpv_itemcode,tpv_conprodname,tpv_conorigin,tpv_conspecation," +
                "tpv_conshader,tpv_quantity,tpv_origampintax,tpv_basampnotax,tpv_basamptax,tpv_storageid,tpv_currency,tpv_bizdate," +
                "tpv_rate,tpv_tentauth,tpv_costype.id,tpv_costype.number,tpv_costdirec,tpv_soudocumnum"
                , filters.toArray(new QFilter[0]));
        DataSet selected = queryDataSet.select("id", "billno", "tpv_purconnum contractnumber", "tpv_vendor supplier","org",
                "tpv_department department", "tpv_logserpro logserpro", "tpv_itemcode itemcode", "tpv_conprodname conprodname",
                "tpv_conorigin conorigin", "tpv_conspecation conspecation", "tpv_conshader conshader",
                "tpv_bizdate bizdate", "tpv_quantity quantity", "tpv_origampintax origampintax", "tpv_basampnotax basampnotax",
                "tpv_basamptax basamptax", "tpv_storageid storageid", "tpv_currency currency","tpv_storagenum storagenum","tpv_rate rate",
                "tpv_tentauth tentauth","tpv_costype.id costypeid","tpv_costype.number costypenumber","tpv_costdirec costdirec","tpv_soudocumnum soudocumnum"
        );

        selected.print(true);

        if (!selected.isEmpty()) {
            setInvoiceData(selected);
        }
    }

    /**
     * 获取单据数据填值
     *
     * @param queryDataSet
     */
    private void setInvoiceData(DataSet queryDataSet) {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        IDataModel parentModel = view.getParentView().getModel();
        Long id = (Long) parentModel.getDataEntity().getPkValue();

        for (Row row : queryDataSet) {
            int tpvStanalysis = this.getModel().createNewEntryRow("tpv_stanalysis");
            model.setValue("tpv_logserpros", row.getLong("logserpro"), tpvStanalysis);//物流服务商
            model.setValue("tpv_department", row.getLong("department"), tpvStanalysis);//部门
            model.setValue("tpv_purcontnumsd", row.getLong("contractnumber"), tpvStanalysis);//采购合同号
            model.setValue("tpv_numorinb", row.getString("storagenum"), tpvStanalysis);//入库单号
            model.setValue("tpv_supplier", row.getLong("supplier"), tpvStanalysis);//供应商
            model.setValue("tpv_itemcode", row.getLong("itemcode"), tpvStanalysis);//物料编码
            model.setValue("tpv_conprodname", row.getString("conprodname"), tpvStanalysis);//品名
            model.setValue("tpv_conshader", row.getString("conshader"), tpvStanalysis);//材质
            model.setValue("tpv_conorigin", row.getLong("conorigin"), tpvStanalysis);//产地
            model.setValue("tpv_conspecation", row.getString("conspecation"), tpvStanalysis);//规格
            model.setValue("tpv_quantity", row.getBigDecimal("quantity"), tpvStanalysis);//数量
            model.setValue("tpv_contractamt", row.getBigDecimal("origampintax"), tpvStanalysis);//金额
            model.setValue("tpv_currency", row.getLong("currency"),tpvStanalysis);//币别
            model.setValue("tpv_inboentid", row.getString("storageid"),tpvStanalysis);//入库分录id
            model.setValue("tpv_cosbreakid", row.getString("id"),tpvStanalysis);//成本处理id
            model.setValue("tpv_typecost", row.getString("costypeid"),tpvStanalysis);
            BigDecimal rate = null != row.getBigDecimal("rate") ? row.getBigDecimal("rate") :BigDecimal.ZERO;
            model.setValue("tpv_rate", rate, tpvStanalysis);
        }
    }

    /**
     * 根据本次匹配金额（含税）以及税率计算增值税额，不含税金额
     *
     * @param e
     */
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        BigDecimal taxnoinclamt = BigDecimal.ZERO;
        BigDecimal taxinclamt = (BigDecimal) this.getModel().getValue("tpv_taxmatamt");//本次匹配金额（含税）
        BigDecimal rate = (BigDecimal) this.getModel().getValue("tpv_rate");//税率%
        String propertyName = e.getProperty().getName();
        if ("tpv_taxmatamt".equals(propertyName) || "tpv_rate".equals(propertyName)) {
            if (taxinclamt.compareTo(BigDecimal.ZERO) == 0 || rate.compareTo(BigDecimal.ZERO) == 0) {
                return;
            } else {
                int i = 100;
                int b = 1;
                BigDecimal bigDecimalb = new BigDecimal(b);
                BigDecimal bigDecimali = new BigDecimal(i);
                BigDecimal divide = rate.divide(bigDecimali);//【税率】/100
                BigDecimal add = divide.add(bigDecimalb);//（1+【税率】/100)
                BigDecimal divides = taxinclamt.divide(add, 4, BigDecimal.ROUND_DOWN);//【含税金额】/（1+【税率】/100）
                BigDecimal vatamt = divides.multiply(divide);//增值税额
                taxnoinclamt = taxinclamt.subtract(vatamt);//不含税金额
                this.getModel().setValue("tpv_vatnomatamt", vatamt);
                this.getModel().setValue("tpv_taxnomatamt", taxnoinclamt);
            }
        }


    }

    @Override
    public void beforeClick(BeforeClickEvent evt) {
        super.beforeClick(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
//                DynamicObjectCollection tpvSelectinvoiceinfo = this.getView().getModel().getEntryEntity("tpv_stanalysis");
//                for (DynamicObject dynamicObject : tpvSelectinvoiceinfo) {
//                    int indexOf = tpvSelectinvoiceinfo.indexOf(dynamicObject);
//                    indexOf = indexOf + 1;
//                    BigDecimal tpv_taxmatamt = dynamicObject.getBigDecimal("tpv_taxmatamt");
//                    boolean tpvChoose = dynamicObject.getBoolean("tpv_choose");
//                    if(tpvChoose) {
//                        if (tpv_taxmatamt.compareTo(BigDecimal.ZERO) == 0) {
//                            evt.setCancel(true);
//                            this.getView().showTipNotification("成本明细信息第" + indexOf + "行的本次匹配金额(含税)未填");
//                        }
//
//                    }
//                }
                break;
        }

    }
}
