package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.coderule.api.CodeRuleInfo;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.CloseCallBack;
import kd.bos.form.MessageBoxResult;
import kd.bos.form.ShowType;
import kd.bos.form.StyleCss;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.BeforeClickEvent;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.events.MessageBoxClosedEvent;
import kd.bos.mvc.form.FormView;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.coderule.CodeRuleServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import org.apache.commons.lang3.StringUtils;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.math.BigDecimal;
import java.util.*;

/**
 * @ClassName: PicWorkbenchFromPlugin
 * @Description: 采购货票对应工作台
 * @author: zbh
 * @date: 2023-10-30
 */
public class PicWorkbenchEdit extends AbstractBillPlugIn implements RowClickEventListener {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_flexpanelap11");
        this.addClickListeners("tpv_inquire", "tpv_priceconfirmbill");
        EntryGrid tpv_constractmx = this.getView().getControl("tpv_constractmx");
        tpv_constractmx.addRowClickListener(this);
        EntryGrid tpv_entryentity = this.getView().getControl("tpv_entryentity");
        tpv_entryentity.addRowClickListener(this);
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        RowClickEventListener.super.entryRowClick(evt);
        String source = ((Control) evt.getSource()).getKey();
        EntryGrid entryGridHt = this.getControl("tpv_constractmx");//商品明细
        int[] selectRowsHt = entryGridHt.getSelectRows();//获取选中的行号
        if ("tpv_constractmx".equals(source)) {
            if (selectRowsHt.length <= 0) {
                this.getModel().deleteEntryData("tpv_entryentity");
            }
            boolean isFlag = false;
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection tpvConstractmx = dataEntity.getDynamicObjectCollection("tpv_constractmx");
            if (selectRowsHt.length > 0) {
                if (selectRowsHt.length == 1) {
                    DynamicObject dynamicObject = tpvConstractmx.get(selectRowsHt[0]);
                    int index = this.getModel().getEntryCurrentRowIndex("tpv_constractmx");
                    DynamicObject dynamicObjectHt = this.getModel().getEntryRowEntity("tpv_constractmx", index);
                    BigDecimal tpvBcmunber = dynamicObjectHt.getBigDecimal("tpv_bcmunber");
                    if (null != tpvBcmunber) {
                        if (tpvBcmunber.compareTo(BigDecimal.ZERO) <= 0) {
                            BigDecimal tpvTax = tpvConstractmx.get(index).getBigDecimal("tpv_tax") != null
                                    ? (BigDecimal) this.getModel().getValue("tpv_tax") : BigDecimal.ZERO;
                            BigDecimal tpvMomatched = tpvConstractmx.get(index).getBigDecimal("tpv_momatched") != null
                                    ? (BigDecimal) this.getModel().getValue("tpv_momatched") : BigDecimal.ZERO;
                            this.getModel().setValue("tpv_bcmunber", tpvMomatched, selectRowsHt[0]);//本次匹配数量
                            if (tpvTax.compareTo(BigDecimal.ZERO) <= 0) {
                                this.getModel().setValue("tpv_tax", 13, selectRowsHt[0]);//税率
                            }
                            String tpvPurchasenum = dynamicObject.getString("tpv_purchasenum");//采购合同号
                            this.selectDy(tpvPurchasenum, isFlag, dynamicObject, "qfilterRKByHT");
                        }
                    }
                }
            } else {
                this.selectDy("", true, null, "");
                return;
            }
        }
        if ("tpv_entryentity".equals(source)) {
            int index = this.getModel().getEntryCurrentRowIndex("tpv_entryentity");
            boolean tpvCheckbox = (boolean) this.getModel().getValue("tpv_checkbox", index);
            if (!tpvCheckbox) {
                this.getModel().setValue("tpv_checkbox", true, index);
            }
        }
    }

    @Override
    public void beforeClick(BeforeClickEvent evt) {
        super.beforeClick(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "tpv_priceconfirmbill":
                this.priceconfirmbill(evt);
                break;
            case "tpv_inquire":
                this.selectDy("", true, null, "");
                break;
        }
    }

    /*

     */

    /**
     * @Title: priceconfirmbill
     * @Descripton: 点击匹配按钮生成货票对应单
     * @reurn: a
     */
    private void priceconfirmbill(BeforeClickEvent evt) {
        boolean isFlag = false;
        EntryGrid constractMx = this.getControl("tpv_constractmx"); //合同
        int[] conRows = constractMx.getSelectRows();
        if (conRows.length == 0) {
            this.getView().showTipNotification("请在认领至合同的发票明细分录选择数据！");
            evt.setCancel(true);
            return;
        }
        DynamicObjectCollection dynamicObjects = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_entryentity");
        boolean flagOne = true;
        List<Integer> rows = new ArrayList<>();
        if (dynamicObjects.size() > 0) {
            for (int i = 0; i < dynamicObjects.size(); i++) {
                DynamicObject dynamicObjectRk = this.getModel().getEntryRowEntity("tpv_entryentity", i);
                boolean tpvCheckbox = dynamicObjectRk.getBoolean("tpv_checkbox");
                if (tpvCheckbox) {
                    rows.add(i);
                    flagOne = false;
                }
            }
        }
        if (flagOne) {
            this.getView().showTipNotification("请在入库明细选择数据！");
            evt.setCancel(true);
            return;
        }
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvConstractmx = dataEntity.getDynamicObjectCollection("tpv_constractmx"); //合同
        DynamicObjectCollection tpvEntryentity = dataEntity.getDynamicObjectCollection("tpv_entryentity");//入库明细

        DynamicObject loadSingle = tpvConstractmx.get(conRows[0]);
        BigDecimal tpvBcmunberHt = tpvConstractmx.get(conRows[0]).getBigDecimal("tpv_bcmunber");//合同本次匹配数量
        BigDecimal tpvBcmunberRk = BigDecimal.ZERO;//入库本次匹配数量
        String purchaseNum = loadSingle.getString("tpv_purchasenum");//采购合同号
        List<String> overshootRows = new ArrayList<>();
        for (int enRow : rows) {
            DynamicObject load = tpvEntryentity.get(enRow);
            BigDecimal tpvBamatnum = tpvEntryentity.get(enRow).getBigDecimal("tpv_bamatnum") != null
                    ? tpvEntryentity.get(enRow).getBigDecimal("tpv_bamatnum") : BigDecimal.ZERO; //本次匹配数量
            BigDecimal tpvMatchednumn = tpvEntryentity.get(enRow).getBigDecimal("tpv_matchednumn") != null
                    ? tpvEntryentity.get(enRow).getBigDecimal("tpv_matchednumn") : BigDecimal.ZERO; //未匹配数量
            tpvBcmunberRk = tpvBcmunberRk.add(tpvBamatnum);
            String tpvPurchaseNumrk = load.getString("tpv_purchasenumrk");
            if (!(tpvPurchaseNumrk.equals(purchaseNum))) {
                isFlag = true;
            }
            if (tpvBamatnum.compareTo(tpvMatchednumn) > 0) {
                int over = enRow + 1;
                overshootRows.add(String.valueOf(over));
            }
        }
        if (isFlag) {
            this.getView().showTipNotification("认领至合同的发票明细与入库明细的采购合同号不一致，请重新选择！");
            evt.setCancel(true);
            return;
        }

        BigDecimal bcHtNum = BigDecimal.ZERO; //本次匹配数量
        BigDecimal bcnHtNum = BigDecimal.ZERO;//本次未匹配数量
        BigDecimal inumberrkNum = BigDecimal.ZERO;//采购入库数量
        BigDecimal berrkNum = BigDecimal.ZERO;//已匹配数量

        DynamicObject tpvDtWbillcromater = BusinessDataServiceHelper.newDynamicObject("tpv_dt_wbillcromater");//生成货票对应单
        DynamicObjectCollection tpvConmx = tpvDtWbillcromater.getDynamicObjectCollection("tpv_dt_conmx");
        CodeRuleInfo codeRule = CodeRuleServiceHelper.getCodeRule("tpv_dt_wbillcromater", tpvDtWbillcromater, null);
        String billno = CodeRuleServiceHelper.getNumber(codeRule, tpvDtWbillcromater);
        tpvDtWbillcromater.set("creator", YEM.getCurrentUserId());
        tpvDtWbillcromater.set("billno", billno);
        tpvDtWbillcromater.set("tpv_bizdate", Calendar.getInstance().getTime());
        tpvDtWbillcromater.set("org", tpvConstractmx.get(conRows[0]).getDynamicObject("tpv_orggs"));//公司
        tpvDtWbillcromater.set("tpv_operator", tpvConstractmx.get(conRows[0]).getDynamicObject("tpv_useywy"));//业务员
        tpvDtWbillcromater.set("tpv_department", tpvConstractmx.get(conRows[0]).getDynamicObject("tpv_dempatments"));  //部门
        tpvDtWbillcromater.set("billstatus", "A");  //状态
//        inumberrkNum=loadSingle.getBigDecimal("tpv_conmun");//合同匹配数量
        bcHtNum = loadSingle.getBigDecimal("tpv_bcmunber");//本次合同匹配数量
        bcnHtNum = loadSingle.getBigDecimal("tpv_momatched");//本次为合同未匹配数量
        if (null == bcHtNum || bcHtNum.compareTo(new BigDecimal("0")) == 0) {
            this.getView().showErrorNotification("本次匹配数量为空,请检查!");
            evt.setCancel(true);
            return;
        }
        if (null == bcHtNum || bcHtNum.compareTo(bcnHtNum) > 0) {
            this.getView().showErrorNotification("认领至合同的发票明细选中行，本次匹配数量大于未匹配数量!");
            evt.setCancel(true);
            return;
        }
        if (overshootRows.size() > 0) {
            this.getView().showTipNotification("入库分录选中行中，第 " + String.join(",", overshootRows) + "行 的本次匹配数量大于未匹配数量！");
            evt.setCancel(true);
            return;
        }
        if (tpvBcmunberHt.compareTo(tpvBcmunberRk) != 0) {
            this.getView().showTipNotification("入库分录本次匹配数量的汇总值不等于合同分录的本次匹配数量！");
            evt.setCancel(true);
            return;
        }


        for (int enRow : rows) {
            String tpvRkcomeid = tpvEntryentity.get(enRow).getString("tpv_rkcomeid");
            inumberrkNum = inumberrkNum.add(tpvEntryentity.get(enRow).getBigDecimal("tpv_inumberrk"));
            DynamicObject[] dtWbillcromaters = BusinessDataServiceHelper.load("tpv_dt_wbillcromater", "tpv_dt_incomingenty,tpv_bcmonnumrk", new QFilter[]{new QFilter("tpv_dt_incomingenty.tpv_rkcomid", "=", tpvRkcomeid)});
            for (DynamicObject dtWbillcromater : dtWbillcromaters) {
                DynamicObjectCollection tpvDtIncomingentys = dtWbillcromater.getDynamicObjectCollection("tpv_dt_incomingenty");
                for (DynamicObject tpvDtIncomingenty : tpvDtIncomingentys) {
                    berrkNum = berrkNum.add(tpvDtIncomingenty.getBigDecimal("tpv_bcmonnumrk"));
                }
            }
            DynamicObject[] tpvDTpurinvomaters = BusinessDataServiceHelper.load("tpv_dt_purinvomater", "tpv_wareiformation,tpv_rkcurmatchqty", new QFilter[]{new QFilter("tpv_wareiformation.tpv_purinentryid", "=", tpvRkcomeid), new QFilter("billstatus", "=", "C")});
            for (DynamicObject tpvDTpurinvomater : tpvDTpurinvomaters) {
                DynamicObjectCollection tpvWareiformations = tpvDTpurinvomater.getDynamicObjectCollection("tpv_wareiformation");
                for (DynamicObject tpvWareiformation : tpvWareiformations) {
                    berrkNum = berrkNum.add(tpvWareiformation.getBigDecimal("tpv_rkcurmatchqty"));
                }
            }
            bcHtNum = bcHtNum.add(tpvEntryentity.get(enRow).getBigDecimal("tpv_bamatnum"));//本次匹配数量
        }
        bcnHtNum = inumberrkNum.subtract(berrkNum).add(bcnHtNum);
//        if (bcHtNum.compareTo(bcnHtNum) > 0) {
//            FormShowParameter showParameter = new FormShowParameter();
//            showParameter.setStatus(OperationStatus.ADDNEW);
//            showParameter.getOpenStyle().setShowType(ShowType.Modal);
//            showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_priceconfirmbill"));
//            showParameter.setSendToClient(true);
//            showParameter.setFormId("tpv_dt_softnotice");
//            this.getView().showForm(showParameter);

        //弹出操作框
//            ConfirmCallBackListener confirmCallBackListener = new ConfirmCallBackListener("tpv_priceconfirmbill", this);
//            //设置页面确认框，参数为：标题，选项框类型，回调监听
//            this.getView().showConfirm("【本次匹配数量】>【未匹配数量】，是否继续匹配？", MessageBoxOptions.OKCancel, confirmCallBackListener);
//        } else {
        tJournaHt(tpvConmx, loadSingle);
        DynamicObjectCollection tpvDtIncomingenty = tpvDtWbillcromater.getDynamicObjectCollection("tpv_dt_incomingenty");
        boolean flag = false;
        for (int enRow : rows) {
            if (null == tpvEntryentity.get(enRow).getBigDecimal("tpv_bamatnum") || tpvEntryentity.get(enRow).getBigDecimal("tpv_bamatnum").compareTo(new BigDecimal("0")) == 0) {
                this.getView().showErrorNotification("本次匹配数量为空,请检查!");
                evt.setCancel(true);
                flag = true;
                return;
            }
            tJournaRk(tpvDtIncomingenty, tpvEntryentity, enRow);
        }
        if (!flag) {
            SaveServiceHelper.save(new DynamicObject[]{tpvDtWbillcromater});
            this.getView().showSuccessNotification("匹配成功！");
            Object pkValue = tpvDtWbillcromater.getPkValue();
            openBill(pkValue);
        }
        this.selectDy("", true, null, "");
//        }
    }

    /**
     * 选择框回调函数
     *
     * @param messageBoxClosedEvent
     */
    @Override
    public void confirmCallBack(MessageBoxClosedEvent messageBoxClosedEvent) {
        super.confirmCallBack(messageBoxClosedEvent);
        //判断是否是对应确认框的点击回调事件
        if (StringUtils.equals("tpv_priceconfirmbill", messageBoxClosedEvent.getCallBackId())) {
            if (MessageBoxResult.Yes.equals(messageBoxClosedEvent.getResult())) {
                EntryGrid constractmx = this.getControl("tpv_constractmx"); //合同
                int[] conRows = constractmx.getSelectRows();
                EntryGrid entryentity = this.getControl("tpv_entryentity"); //入库
                int[] enRows = entryentity.getSelectRows();
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                DynamicObjectCollection tpvConstractmx = dataEntity.getDynamicObjectCollection("tpv_constractmx"); //合同
                DynamicObject loadSingle = tpvConstractmx.get(conRows[0]);

//                DynamicObject entity= BusinessDataServiceHelper.newDynamicObject("tpv_dt_wbillcromater");

                DynamicObjectCollection tpvEntryentity = dataEntity.getDynamicObjectCollection("tpv_entryentity");//入库明细
                DynamicObject tpvDtWbillcromater = BusinessDataServiceHelper.newDynamicObject("tpv_dt_wbillcromater");//生成货票对应单
                CodeRuleInfo codeRule = CodeRuleServiceHelper.getCodeRule("tpv_dt_wbillcromater", tpvDtWbillcromater, null);
                String billno = CodeRuleServiceHelper.getNumber(codeRule, tpvDtWbillcromater);
                DynamicObjectCollection tpvConmx = tpvDtWbillcromater.getDynamicObjectCollection("tpv_dt_conmx");
                tpvDtWbillcromater.set("billno", billno);
                tpvDtWbillcromater.set("tpv_bizdate", Calendar.getInstance().getTime());
                tpvDtWbillcromater.set("org", tpvConstractmx.get(conRows[0]).getDynamicObject("tpv_orggs"));//公司
                tpvDtWbillcromater.set("tpv_operator", tpvConstractmx.get(conRows[0]).getDynamicObject("tpv_useywy"));//业务员
                tpvDtWbillcromater.set("tpv_department", tpvConstractmx.get(conRows[0]).getDynamicObject("tpv_dempatments"));  //部门
                tpvDtWbillcromater.set("billstatus", "A");  //状态
//                tpvDtWbillcromater.set("tpv_sourcebillid", tpvConstractmx.get(conRows[0]).getLong("tpv_srcid"));  //来源id
                tJournaHt(tpvConmx, loadSingle);
                DynamicObjectCollection tpvDtIncomingenty = tpvDtWbillcromater.getDynamicObjectCollection("tpv_dt_incomingenty");
                for (int enRow : enRows) {
                    tJournaRk(tpvDtIncomingenty, tpvEntryentity, enRow);
                }
                SaveServiceHelper.save(new DynamicObject[]{tpvDtWbillcromater});
                Object pkValue = tpvDtWbillcromater.getPkValue();
                openBill(pkValue);
                this.getView().showSuccessNotification("匹配成功！");
                this.selectDy("", true, null, "");
            }
        } else if (MessageBoxResult.Cancel.equals(messageBoxClosedEvent.getResult())) {
            // 点击取消的相关处理逻辑。。。。
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
    }

    /**
     * 打开生成的货票对应单
     *
     * @param pkValue
     */
    public void openBill(Object pkValue) {
        BillShowParameter billShowParameter = new BillShowParameter();
        billShowParameter.setFormId("tpv_dt_wbillcromater");
        billShowParameter.setStatus(OperationStatus.EDIT);
        billShowParameter.getOpenStyle().setShowType(ShowType.Modal);
        StyleCss inlineStyleCss = new StyleCss();
        billShowParameter.getOpenStyle().setInlineStyleCss(inlineStyleCss);
        billShowParameter.setPkId(pkValue);
        billShowParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
        billShowParameter.setCloseCallBack(new CloseCallBack(this, "tpv_dt_wbillcromater"));
        this.getView().showForm(billShowParameter);
    }

    /**
     * @param tpvConmx,loadSingle
     * @Title: tJournaHt
     * @Descripton: 合同分录填充
     * @reurn: a
     */
    public void tJournaHt(DynamicObjectCollection tpvConmx, DynamicObject loadSingle) {
        DynamicObject aNew = tpvConmx.addNew();
        aNew.set("tpv_fpnumber", loadSingle.getString("tpv_cgnumber"));//发票匹配单单据编号
        aNew.set("tpv_suppliers", loadSingle.getDynamicObject("tpv_suppliers"));//供应商
        aNew.set("tpv_purchasenum", loadSingle.getString("tpv_purchasenum"));//采购合同号
        aNew.set("tpv_material", loadSingle.getDynamicObject("tpv_material"));//物料编码
        aNew.set("tpv_conprodname", loadSingle.getDynamicObject("tpv_conprodname"));//品名
        aNew.set("tpv_conshader", loadSingle.getString("tpv_conshader"));//材质
        aNew.set("tpv_contax", loadSingle.getBigDecimal("tpv_tax"));//税率
        aNew.set("tpv_conorigin", loadSingle.getDynamicObject("tpv_conorigin"));//产地
        aNew.set("tpv_conspecation", loadSingle.getString("tpv_conspecation"));//规格
        aNew.set("tpv_bcmtnum", loadSingle.getBigDecimal("tpv_bcmunber"));//本次匹配数量
        aNew.set("tpv_conppnum", loadSingle.getBigDecimal("tpv_bcmunber"));//合同匹配数量
        aNew.set("tpv_conppnumtax", loadSingle.getBigDecimal("tpv_bcmoneytax"));//合同匹配金额（含税）
        aNew.set("tpv_conppmon", loadSingle.getBigDecimal("tpv_bcmoney"));//合同匹配金额（不含税）
        aNew.set("tpv_conppmontx", loadSingle.getBigDecimal("tpv_bcmoneytx"));//合同匹配金额（税额）
        aNew.set("tpv_bcmtmontax", loadSingle.getBigDecimal("tpv_bcmoneytax"));//本次匹配金额（含税）
        aNew.set("tpv_bcmtmon", loadSingle.getBigDecimal("tpv_bcmoney"));//本次匹配金额（不含税）
        aNew.set("tpv_bcmtmontx", loadSingle.getBigDecimal("tpv_bcmoneytx"));//本次匹配金额（税额）
        aNew.set("tpv_comeid", loadSingle.getString("tpv_comeid"));//来源分录id
        aNew.set("tpv_conunit", loadSingle.getDynamicObject("tpv_conunit"));//来源分录id
    }

    /**
     * @param tpvDtIncomingenty,tpvEntryentity,enRow
     * @Title: tJournaHt
     * @Descripton: 入库分录填充
     * @reurn: a
     */
    public void tJournaRk(DynamicObjectCollection tpvDtIncomingenty, DynamicObjectCollection tpvEntryentity, int enRow) {
        DynamicObject conmx = tpvDtIncomingenty.addNew();
        conmx.set("tpv_inconumrk", tpvEntryentity.get(enRow).getString("tpv_cgnumberrk"));//入库单号
        conmx.set("tpv_suppliersrk", tpvEntryentity.get(enRow).getDynamicObject("tpv_suppliersrk"));//供应商
        conmx.set("tpv_purchasenumrk", tpvEntryentity.get(enRow).getString("tpv_purchasenumrk"));//采购合同号
        conmx.set("tpv_materialrks", tpvEntryentity.get(enRow).getDynamicObject("tpv_materiel"));//物料编码
        conmx.set("tpv_materialnamerks", tpvEntryentity.get(enRow).getString("tpv_materielname"));//物料名称
        conmx.set("tpv_conprodnamerk", tpvEntryentity.get(enRow).getDynamicObject("tpv_conprodnamerk"));//品名
        conmx.set("tpv_conshaderrk", tpvEntryentity.get(enRow).getString("tpv_conshaderrk"));//材质
        conmx.set("tpv_conoriginrk", tpvEntryentity.get(enRow).getDynamicObject("tpv_conoriginrk"));//产地
        conmx.set("tpv_conspecationrk", tpvEntryentity.get(enRow).getString("tpv_conspecationrk"));//规格
        conmx.set("tpv_numberrk", tpvEntryentity.get(enRow).getBigDecimal("tpv_inumberrk"));//数量
        conmx.set("tpv_bcmonnumrk", tpvEntryentity.get(enRow).getBigDecimal("tpv_bamatnum"));//本次匹配数量
        conmx.set("tpv_taxrk", tpvEntryentity.get(enRow).getBigDecimal("tpv_taxtk"));//税率
        conmx.set("tpv_bcmtmontaxrk", tpvEntryentity.get(enRow).getBigDecimal("tpv_bcmontax"));//
        conmx.set("tpv_bcmtmonrk", tpvEntryentity.get(enRow).getBigDecimal("tpv_bamatmon"));//
        conmx.set("tpv_bcmtmontxrk", tpvEntryentity.get(enRow).getBigDecimal("tpv_bcmatmmtax"));//
        conmx.set("tpv_currency", tpvEntryentity.get(enRow).getDynamicObject("tpv_currency"));//
        conmx.set("tpv_taxtable", tpvEntryentity.get(enRow).getDynamicObject("tpv_basedatatable"));//
        conmx.set("tpv_taxrkhl", tpvEntryentity.get(enRow).getBigDecimal("tpv_taxhl"));//
        conmx.set("tpv_rkcomid", tpvEntryentity.get(enRow).getString("tpv_rkcomeid"));//入库单分录id
        conmx.set("tpv_rkunit", tpvEntryentity.get(enRow).getDynamicObject("tpv_rkunit"));//计量单位
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        int indexRk = this.getModel().getEntryCurrentRowIndex("tpv_entryentity");
        int indexHt = this.getModel().getEntryCurrentRowIndex("tpv_entryentity");
        switch (name) {
            case "tpv_bcmunber":
            case "tpv_tax":
                bCnumber();
                break;
            case "tpv_bamatnum":
            case "tpv_taxtk":
                bAmatnum();
                break;
            case "tpv_checkbox":
                checkboxSetValue(indexRk, indexHt);
                break;
            default:
                break;
        }
    }

    private void checkboxSetValue(int indexRk, int indexHt) {
        DynamicObject dynamicObjectRk = this.getModel().getEntryRowEntity("tpv_entryentity", indexRk);
        boolean tpvCheckbox = dynamicObjectRk.getBoolean("tpv_checkbox");
        if (tpvCheckbox) {
            BigDecimal tpvBamatnum = dynamicObjectRk.getBigDecimal("tpv_bamatnum") == null ? BigDecimal.ZERO : dynamicObjectRk.getBigDecimal("tpv_bamatnum");
            if (tpvBamatnum.compareTo(BigDecimal.ZERO) == 0) {
                BigDecimal tpvMatchednumn = dynamicObjectRk.getBigDecimal("tpv_matchednumn") != null
                        ? dynamicObjectRk.getBigDecimal("tpv_matchednumn") : BigDecimal.ZERO;
                this.getModel().setValue("tpv_bamatnum", tpvMatchednumn, indexRk);//本次匹配数量
                DynamicObject dynamicObjectHt = this.getModel().getEntryRowEntity("tpv_constractmx", indexHt);
                BigDecimal tpvTax = dynamicObjectHt.getBigDecimal("tpv_tax") != null
                        ? (BigDecimal) this.getModel().getValue("tpv_tax") : new BigDecimal("13");
                this.getModel().setValue("tpv_taxtk", tpvTax, indexRk);//税率
            }
            tailDifferenceAmtNew();
        } else {
            this.getModel().setValue("tpv_bamatnum", BigDecimal.ZERO, indexRk);//本次匹配数量
            this.getModel().setValue("tpv_taxtk", BigDecimal.ZERO, indexRk);//税率
            tailDifferenceAmtNew();
        }
    }

    private void tailDifferenceAmtNew() {
        EntryGrid entryGridHt = this.getControl("tpv_constractmx");//商品明细
        int[] selectRowsHt = entryGridHt.getSelectRows();//获取选中的行号
        if (selectRowsHt.length == 1) {
            DynamicObject htEntityDy = this.getModel().getEntryRowEntity("tpv_constractmx", selectRowsHt[0]);
            BigDecimal tpvBcmunber = htEntityDy.getBigDecimal("tpv_bcmunber"); //合同分录 -本次匹配数量
            DynamicObjectCollection tpvEntryentity = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_entryentity");
            if (tpvEntryentity.size() > 0) {
                List<Integer> rows = new ArrayList<>();
                BigDecimal sumRkQty = BigDecimal.ZERO;
                for (int i = 0; i < tpvEntryentity.size(); i++) {
                    DynamicObject dynamicObjectRk = this.getModel().getEntryRowEntity("tpv_entryentity", i);
                    boolean tpvCheckbox = dynamicObjectRk.getBoolean("tpv_checkbox");
                    if (tpvCheckbox) {
                        BigDecimal tpvBamatnums = dynamicObjectRk.getBigDecimal("tpv_bamatnum");
                        sumRkQty = sumRkQty.add(tpvBamatnums);
                        rows.add(i);
                    }
                }
                if (sumRkQty.compareTo(tpvBcmunber) == 0) {
                    Collections.sort(rows);
                    BigDecimal sumRkInTaxAmt = BigDecimal.ZERO;
                    BigDecimal sumRkNoTaxAmt = BigDecimal.ZERO;
                    BigDecimal sumRkTaxAmt = BigDecimal.ZERO;
                    int length = 0;
                    if (rows.size() > 0) {
                        for (Integer row : rows) {
                            DynamicObject dynamicObject = this.getModel().getEntryRowEntity("tpv_entryentity", row);
                            BigDecimal tpvBamatnums = dynamicObject.getBigDecimal("tpv_bamatnum");
                            BigDecimal tpvBcmontax = dynamicObject.getBigDecimal("tpv_bcmontax");
                            BigDecimal tpvBamatmon = dynamicObject.getBigDecimal("tpv_bamatmon");
                            BigDecimal tpvBcmatmmtax = dynamicObject.getBigDecimal("tpv_bcmatmmtax");
                            sumRkQty = sumRkQty.add(tpvBamatnums);
                            if (length == rows.size() - 1) {
                                break;
                            }
                            sumRkInTaxAmt = sumRkInTaxAmt.add(tpvBcmontax);
                            sumRkNoTaxAmt = sumRkNoTaxAmt.add(tpvBamatmon);
                            sumRkTaxAmt = sumRkTaxAmt.add(tpvBcmatmmtax);
                            length++;
                        }
                        BigDecimal tpvBcmoneytax = htEntityDy.getBigDecimal("tpv_bcmoneytax").setScale(2, BigDecimal.ROUND_HALF_UP); //合同分录 -本次匹配金额(含税)
                        BigDecimal tpvBcmoney = htEntityDy.getBigDecimal("tpv_bcmoney").setScale(2, BigDecimal.ROUND_HALF_UP); //合同分录 -本次匹配金额(不含税)
                        BigDecimal tpvBcmoneytx = htEntityDy.getBigDecimal("tpv_bcmoneytx").setScale(2, BigDecimal.ROUND_HALF_UP); //合同分录 -本次匹配金额(税额)
                        BigDecimal tpv_bcmontax = tpvBcmoneytax.subtract(sumRkInTaxAmt);
                        BigDecimal tpv_bamatmon = tpvBcmoney.subtract(sumRkNoTaxAmt);
                        BigDecimal tpv_bcmatmmtax = tpvBcmoneytx.subtract(sumRkTaxAmt);
                        this.getModel().setValue("tpv_bcmontax", tpv_bcmontax.setScale(2, BigDecimal.ROUND_HALF_UP), rows.get(rows.size() - 1));//含税
                        this.getModel().setValue("tpv_bamatmon", tpv_bamatmon.setScale(2, BigDecimal.ROUND_HALF_UP), rows.get(rows.size() - 1));//不含税
                        this.getModel().setValue("tpv_bcmatmmtax", tpv_bcmatmmtax.setScale(2, BigDecimal.ROUND_HALF_UP), rows.get(rows.size() - 1));//税额
                    }
                }
            }
        }
    }

    /**
     * @Title: tJournaHt
     * @Descripton: 合同分录根据本次匹配数量计算金额
     * @reurn: a
     */
    private void bCnumber() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        EntryGrid entryGrid = this.getControl("tpv_constractmx");
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length == 0) {
            return;
        }
        int rowIndex = this.getModel().getEntryCurrentRowIndex("tpv_constractmx");
        DynamicObjectCollection collection = dataEntity.getDynamicObjectCollection("tpv_constractmx");
        DynamicObject loadSingle = collection.get(selectRows[0]);
        BigDecimal tpvBcmunber = loadSingle.getBigDecimal("tpv_bcmunber");//本次匹配数量
        BigDecimal tpvMomatched = loadSingle.getBigDecimal("tpv_momatched");//未匹配数量
        BigDecimal tpvNomatmoneytax = loadSingle.getBigDecimal("tpv_nomatmoneytax");//未匹配金额（含税）
        BigDecimal tpvNimatmontx = loadSingle.getBigDecimal("tpv_nimatmontx");//未匹配金额（税额）
        BigDecimal tpvTax = loadSingle.getBigDecimal("tpv_tax");//税率
        BigDecimal one = BigDecimal.ONE;
        BigDecimal oneHandred = BigDecimalUtils.one_handred;
//        if (tpvTax.compareTo(BigDecimal.ZERO) == 0) {
//            this.getModel().beginInit();
//            this.getModel().setValue("tpv_tax", 13,selectRows[0]);//不含税
//            this.getModel().endInit();
//            this.getView().updateView("tpv_constractmx");
////            return;
//        }
        if (tpvMomatched.compareTo(tpvBcmunber) != 0) {
            if (tpvMomatched.compareTo(BigDecimal.ZERO) == 0) {
                return;
            }
            tpvMomatched = tpvMomatched.compareTo(BigDecimal.ZERO) > 0 ? tpvMomatched : BigDecimal.ONE;
            //本次匹配金额(含税) = 未匹配金额(含税) / 未匹配数量 * 本次匹配数量
            BigDecimal price = tpvNomatmoneytax.divide(tpvMomatched, 11, BigDecimal.ROUND_HALF_UP);
            BigDecimal tpvBcmoneytax = price.multiply(tpvBcmunber).setScale(2, BigDecimal.ROUND_HALF_UP);
            this.getModel().setValue("tpv_bcmoneytax", tpvBcmoneytax, rowIndex);//本次匹配金额（含税）
            BigDecimal bet = one.add(tpvTax.divide(oneHandred));
            BigDecimal tpvBcmoneytx = tpvBcmoneytax.divide(bet, 11, BigDecimal.ROUND_HALF_UP);
            tpvBcmoneytx = tpvBcmoneytx.multiply(tpvTax.divide(oneHandred)).setScale(2, BigDecimal.ROUND_HALF_UP);
            this.getModel().setValue("tpv_bcmoneytx", tpvBcmoneytx, rowIndex);//本次匹配金额（税额）
        } else {
            this.getModel().setValue("tpv_bcmoneytx", tpvNimatmontx, rowIndex);//本次匹配金额（税额）
            this.getModel().setValue("tpv_bcmoneytax", tpvNomatmoneytax, rowIndex);//本次匹配金额（含税）
        }
        BigDecimal tpvBcmoneytax = (BigDecimal) this.getModel().getValue("tpv_bcmoneytax"); //本次匹配金额
        BigDecimal tpvBcmoneytx = (BigDecimal) this.getModel().getValue("tpv_bcmoneytx"); //本次匹配金额（税额）
        this.getModel().setValue("tpv_bcmoney", tpvBcmoneytax.subtract(tpvBcmoneytx), rowIndex);//本次匹配金额（不含税）
        DynamicObjectCollection tpvEntryentity = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_entryentity");
        if (tpvEntryentity.size() > 0) {
            List<Integer> rows = new ArrayList<>();
            for (int i = 0; i < tpvEntryentity.size(); i++) {
                DynamicObject dynamicObjectRk = this.getModel().getEntryRowEntity("tpv_entryentity", i);
                boolean tpvCheckbox = dynamicObjectRk.getBoolean("tpv_checkbox");
                if (tpvCheckbox) {
                    setRkPice(this.getModel().getDataEntity(true), i);
                    rows.add(i);
                }
            }
            if (rows.size() > 0) {
                tailDifferenceAmtNew();
            }
        }
    }

    /**
     * @Title: tJournaHt
     * @Descripton: 入库分录根据本次匹配数量计算金额
     * @reurn: a
     */
    private void bAmatnum() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection collection = dataEntity.getDynamicObjectCollection("tpv_entryentity");//入庫
        int index = this.getModel().getEntryCurrentRowIndex("tpv_entryentity");
        setRkPice(dataEntity, index);
    }

    private void setRkPice(DynamicObject dataEntity, int index) {
        DynamicObjectCollection constractmx = dataEntity.getDynamicObjectCollection("tpv_constractmx");//合同
        EntryGrid entryGrid = this.getControl("tpv_constractmx");
        int[] htEntityRows = entryGrid.getSelectRows();
        if (htEntityRows.length == 1) {
            DynamicObject htEntityDy = constractmx.get(htEntityRows[0]);
            BigDecimal tpvBcmunber = htEntityDy.getBigDecimal("tpv_bcmunber"); //合同分录 -本次匹配数量
            BigDecimal tpvBcmoneytax = htEntityDy.getBigDecimal("tpv_bcmoneytax"); //合同分录 -本次匹配金额(含税)
            BigDecimal tpvBcmoney = htEntityDy.getBigDecimal("tpv_bcmoney"); //合同分录 -本次匹配金额(不含税)
            BigDecimal tpvBcmoneytx = htEntityDy.getBigDecimal("tpv_bcmoneytx"); //合同分录 -本次匹配金额(税额)
            BigDecimal bcprice = tpvBcmunber.compareTo(BigDecimal.ZERO) != 0
                    ? tpvBcmoneytax.divide(tpvBcmunber, 11, BigDecimal.ROUND_HALF_UP) : BigDecimal.ZERO;
            DynamicObject rkEntityDy = this.getModel().getEntryRowEntity("tpv_entryentity", index);
            BigDecimal bcmontax = bcprice.multiply(rkEntityDy.getBigDecimal("tpv_bamatnum")); // 入库分录 -本次匹配金额(含税)
            this.getModel().setValue("tpv_bcmontax", bcmontax.setScale(2, BigDecimal.ROUND_HALF_UP), index);//本次匹配金额(含税)
            BigDecimal tax = rkEntityDy.getBigDecimal("tpv_taxtk");// 入库分录 -税率
            BigDecimal one = BigDecimal.ONE;
            BigDecimal oneHandred = BigDecimalUtils.one_handred;
            BigDecimal bet = tax.divide(oneHandred);
            BigDecimal beRate = bcmontax.divide((one.add(tax.divide(oneHandred))), 11, BigDecimal.ROUND_HALF_UP);
            beRate = beRate.multiply(bet);
            this.getModel().setValue("tpv_bcmatmmtax", beRate.setScale(2, BigDecimal.ROUND_HALF_UP), index);//税额
            BigDecimal tpvBcmonTaxs = rkEntityDy.getBigDecimal("tpv_bcmontax").divide(one, 2, BigDecimal.ROUND_HALF_UP);//含税
            BigDecimal tpvBcmatmmTaxs = rkEntityDy.getBigDecimal("tpv_bcmatmmtax").divide(one, 2, BigDecimal.ROUND_HALF_UP);//税额
            BigDecimal tpvBamatmons = tpvBcmonTaxs.subtract(tpvBcmatmmTaxs);
            this.getModel().setValue("tpv_bamatmon", tpvBamatmons.setScale(2, BigDecimal.ROUND_HALF_UP), index);//不含税
            tailDifferenceAmtNew();
        }
    }

    /**
     * @Title: tJournaHt
     * @Descripton: 根据过滤条件查询对应的采购货票匹配单和入库单
     * @reurn: a
     */
    private void selectDy(String tpvPurchasenumber, boolean isFlag, DynamicObject htRowDynamic, String desc) {
        if (isFlag) {
            this.getModel().deleteEntryData("tpv_constractmx");
        }
//        this.getModel().deleteEntryData("tpv_entryentity");
        List<QFilter> list = new ArrayList<>();
        list.add(new QFilter("billstatus", "=", "C"));
        list.add(new QFilter("tpv_ishongc", QCP.not_equals, true));
//        list.add(new QFilter("tpv_srcredid", QCP.equals, 0));
        List<String> listPur = new ArrayList<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        if (YEM.isEmpty(tpvPurchasenumber)) {
            tpvPurchasenumber = dataEntity.getString("tpv_purchasenumber");  //采购合同号
        }
        if (YEM.isNotEmpty(tpvPurchasenumber)) {
            list.add(new QFilter("tpv_continformation.tpv_connums", QCP.ftlike, "%" + tpvPurchasenumber + "%"));
        }
        String tpvWarehousenumber = dataEntity.getString("tpv_warehousenumber");  //入库单号
        DynamicObject tpvSupplier = dataEntity.getDynamicObject("tpv_supplier");  //供应商
        DynamicObject tpvOrg = dataEntity.getDynamicObject("tpv_org");  //公司
        DynamicObject tpvDepartment = dataEntity.getDynamicObject("tpv_department");  //部门
        DynamicObjectCollection tpvMuldepartment = dataEntity.getDynamicObjectCollection("tpv_muldepartment");//部门

        List<Long> listCol = new ArrayList<>();
        if (tpvMuldepartment != null) {
            for (DynamicObject baseData : tpvMuldepartment) {
                listCol.add(baseData.getLong("fbasedataid.id"));
            }
        }

        Long tpvDepartmentPk = 0L;
        if (tpvDepartment != null) {
            tpvDepartmentPk = (Long) tpvDepartment.getPkValue();
        }

        Map<String, BigDecimal> rateMap = new HashMap<>();
        if (isFlag) {
            //采购发票匹配单
            String selectfields = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_purinvomater",
                    "tpv_continformation", "tpv_wareiformation", "tpv_invoiceinfoentry");
            DynamicObject[] tpvDtPurinvomaters = BusinessDataServiceHelper.load("tpv_dt_purinvomater", selectfields,
                    list.toArray(new QFilter[]{})); //采购发票匹配单
            for (DynamicObject tpvDtPurinvomater : tpvDtPurinvomaters) {
                if (tpvDtPurinvomater.getBoolean("tpv_ishongc") || YEM.isNotEmpty(tpvDtPurinvomater.getLong("tpv_srcredid"))) {
                    continue;
                }
                DynamicObjectCollection tpvContinformation = tpvDtPurinvomater.getDynamicObjectCollection("tpv_continformation");
                for (DynamicObject loadSingle : tpvContinformation) {
                    String connums = loadSingle.getString("tpv_connums");//采购合同号
                    DynamicObject tpvWarehouSupplier = loadSingle.getDynamicObject("tpv_consupplier"); //供应商
                    DynamicObject tpvWarehouseDept = loadSingle.getDynamicObject("tpv_condept");//部门
                    Long tpvWarehouseDeptPk = 0L;
                    if (tpvWarehouseDept != null) {
                        tpvWarehouseDeptPk = (Long) tpvWarehouseDept.getPkValue();
                    }

                    String tpvOrggs = loadSingle.getString("tpv_conorgs");//公司
//                    if (tpvPurchasenumber != "" && tpvPurchasenumber != null) {
//                        if (!connums.equals(tpvPurchasenumber)) {
//                            continue;
//                        }
//                    }
                    if (tpvWarehouSupplier != tpvSupplier && tpvSupplier != null) {
                        continue;
                    }
                    if (listCol.size() != 0 && !listCol.contains(tpvWarehouseDeptPk)) {
                        continue;
                    }
                    if (!tpvDepartmentPk.equals(tpvWarehouseDeptPk) && tpvDepartment != null) {
                        continue;
                    }
                    if (tpvOrggs != "" && tpvOrggs != null && tpvOrg != null) {
                        Object id = tpvOrg.get("id");
                        if (!tpvOrggs.equals(tpvOrg.get("id").toString())) {
                            continue;
                        }
                    }
                    if ((tpvOrggs == "" || tpvOrggs == null) && tpvOrg != null) {
                        continue;
                    }
                    int row = this.getModel().createNewEntryRow("tpv_constractmx");//
                    this.getModel().setValue("tpv_dempatments", loadSingle.getDynamicObject("tpv_condept"), row);  //部门
                    this.getModel().setValue("tpv_cgnumber", tpvDtPurinvomater.getString("billno"), row);  //发票匹配单单据编号
//                    this.getModel().setValue("tpv_srcid", tpvDtPurinvomater.getLong("id"), row);  //发票匹配单id
                    this.getModel().setValue("tpv_suppliers", loadSingle.getDynamicObject("tpv_consupplier"), row);  //供应商
                    this.getModel().setValue("tpv_purchasenum", loadSingle.getString("tpv_connums"), row);  //采购合同号
                    this.getModel().setValue("tpv_material", loadSingle.getDynamicObject("tpv_material"), row);  //物料编码
                    this.getModel().setValue("tpv_conprodname", loadSingle.getDynamicObject("tpv_conprodname"), row);  //品名
                    this.getModel().setValue("tpv_conshader", loadSingle.getString("tpv_conshader"), row);  //材质
                    this.getModel().setValue("tpv_conorigin", loadSingle.getDynamicObject("tpv_conorigin"), row);  //产地
                    this.getModel().setValue("tpv_conspecation", loadSingle.getString("tpv_conspecation"), row);  //规格
                    this.getModel().setValue("tpv_conmun", loadSingle.getBigDecimal("tpv_curmatchqty"), row);  //合同匹配数量
                    this.getModel().setValue("tpv_conmoneytax", loadSingle.getBigDecimal("tpv_curmatchamo"), row);  //合同匹配金额（含税）
                    this.getModel().setValue("tpv_amountfieldntax", loadSingle.getBigDecimal("tpv_curamountnotax"), row);  //合同匹配金额（不含税）
                    this.getModel().setValue("tpv_contmoneytx", loadSingle.getBigDecimal("tpv_curamountintax"), row);  //合同匹配金额（税额）
                    this.getModel().setValue("tpv_comeid", loadSingle.getString("tpv_conentryid"), row);  //来源分录id1
                    this.getModel().setValue("tpv_orggs", loadSingle.getString("tpv_conorgs"), row);  //公司
                    this.getModel().setValue("tpv_useywy", loadSingle.getString("tpv_conusers"), row);  //业务员
                    this.getModel().setValue("tpv_tax", loadSingle.getBigDecimal("tpv_httaxrate"), row);  //税率
                    this.getModel().setValue("tpv_conunit", loadSingle.get("tpv_conunit"), row);  //税率
//                    rateMap.put(loadSingle.getString("tpv_connums"),loadSingle.getBigDecimal("tpv_httaxrate") != null
//                            ? loadSingle.getBigDecimal("tpv_httaxrate") :BigDecimal.ZERO);
                    listPur.add(loadSingle.getString("tpv_conentryid"));
                }
            }
            DynamicObject[] tpvDtWwbillcromater = BusinessDataServiceHelper.load("tpv_dt_wbillcromater", "tpv_dt_conmx,tpv_comeid,tpv_bcmtnum,tpv_bcmtmontax,tpv_bcmtmon,tpv_bcmtmontx",
                    new QFilter[]{new QFilter("tpv_dt_conmx.tpv_comeid", "in", listPur)}); //货票对应单
            int rowCount = this.getModel().getEntryRowCount("tpv_constractmx");
            for (int i = 0; i < rowCount; i++) {
                BigDecimal bcmtNum = BigDecimal.ZERO;     //已匹配数量
                BigDecimal bcmtMonTax = BigDecimal.ZERO; //已匹配金额（含税）
                BigDecimal bcmtMon = BigDecimal.ZERO;  //已匹配金额（不含税
                BigDecimal bcmtMontx = BigDecimal.ZERO;  //已匹配金额（税额）
                for (DynamicObject loadSingle : tpvDtWwbillcromater) {
                    DynamicObjectCollection tpvDtConmx = loadSingle.getDynamicObjectCollection("tpv_dt_conmx");
                    for (DynamicObject dtConmx : tpvDtConmx) {
                        String string = dtConmx.getString("tpv_comeid");
                        if (YEM.isNotEmpty(string)) {
                            if (listPur.get(i).equals(string)) {
                                bcmtNum = bcmtNum.add(dtConmx.getBigDecimal("tpv_bcmtnum"));
                                bcmtMonTax = bcmtMonTax.add(dtConmx.getBigDecimal("tpv_bcmtmontax"));
                                bcmtMon = bcmtMon.add(dtConmx.getBigDecimal("tpv_bcmtmon"));
                                bcmtMontx = bcmtMontx.add(dtConmx.getBigDecimal("tpv_bcmtmontx"));
                            }
                        }

                    }
                }
                this.getModel().setValue("tpv_matched", bcmtNum, i);  //已匹配数量
                this.getModel().setValue("tpv_matchedtax", bcmtMonTax, i);//已匹配金额（含税）
                this.getModel().setValue("tpv_matchedtaxn", bcmtMon, i);  //已匹配金额（不含税）
                this.getModel().setValue("tpv_matchedtx", bcmtMontx, i);  //已匹配金额（税额）
                this.getModel().setValue("tpv_momatched", bcmtMontx, i);  //未匹配数量
            }

            DynamicObjectCollection tpvConstractmx = dataEntity.getDynamicObjectCollection("tpv_constractmx");
            for (int i = 0; i < tpvConstractmx.size(); i++) {
                BigDecimal tpvConmun = tpvConstractmx.get(i).getBigDecimal("tpv_conmun");//合同匹配数量
                BigDecimal tpvConmoneytax = tpvConstractmx.get(i).getBigDecimal("tpv_conmoneytax");//合同匹配金额（含税）
                BigDecimal tpvAmountfieldntax = tpvConstractmx.get(i).getBigDecimal("tpv_amountfieldntax");//合同匹配金额（不含税）
                BigDecimal tpvContmoneytx = tpvConstractmx.get(i).getBigDecimal("tpv_contmoneytx");//合同匹配金额（税额）
                BigDecimal tpvMatched = tpvConstractmx.get(i).getBigDecimal("tpv_matched");//已匹配数量
                BigDecimal tpvMatchedtax = tpvConstractmx.get(i).getBigDecimal("tpv_matchedtax");//已匹配金额（含税）
                BigDecimal tpvMatchedtaxn = tpvConstractmx.get(i).getBigDecimal("tpv_matchedtaxn");//已匹配金额（不含税）
                BigDecimal tpvMatchedtx = tpvConstractmx.get(i).getBigDecimal("tpv_matchedtx");//已匹配金额（税额）
                this.getModel().setValue("tpv_momatched", tpvConmun.subtract(tpvMatched), i);  //未匹配数量
//                this.getModel().setValue("tpv_bcmunber", tpvConmun.subtract(tpvMatched), i);  //本次匹配数量
                this.getModel().setValue("tpv_nomatmoneytax", tpvConmoneytax.subtract(tpvMatchedtax), i);//未匹配金额（含税）
                this.getModel().setValue("tpv_nomatmoneynt", tpvAmountfieldntax.subtract(tpvMatchedtaxn), i);  //未匹配金额（不含税）
                this.getModel().setValue("tpv_nimatmontx", tpvContmoneytx.subtract(tpvMatchedtx), i);  //未匹配金额（税额）
                this.getModel().setValue("tpv_bcmoneytax", tpvConmoneytax.subtract(tpvMatchedtax), i);//本次匹配金额（含税）
                this.getModel().setValue("tpv_bcmoney", tpvAmountfieldntax.subtract(tpvMatchedtaxn), i);  //本次匹配金额（不含税）
                this.getModel().setValue("tpv_bcmoneytx", tpvContmoneytx.subtract(tpvMatchedtx), i);  //本次匹配金额（税额）
            }
        } else {
            List<String> listRk = new ArrayList<>();
            List<QFilter> qFilters = new ArrayList<>();
            if (tpvPurchasenumber != "") {
                qFilters.add(new QFilter("tpv_purcontnum", QCP.ftlike, "%" + tpvPurchasenumber + "%"));
            }
            if (tpvWarehousenumber != "") {
                qFilters.add(new QFilter("billno", QCP.ftlike, "%" + tpvWarehousenumber + "%"));
            }
            if (tpvSupplier != null) {
                qFilters.add(new QFilter("supplier.id", "=", tpvSupplier.get("id")));
            }
            if (tpvOrg != null) {
                qFilters.add(new QFilter("org.id", "=", tpvOrg.get("id")));
            }
            if (tpvDepartment != null) {
                qFilters.add(new QFilter("bizdept.id", "=", tpvDepartment.get("id")));
            }

            QFilter qFilter = PersonnelDepUtils.departmentQFilter(this.getModel(), "tpv_muldepartment", "bizdept.id");
            if (qFilter != null) {
                qFilters.add(qFilter);
            }
            qFilters.add(new QFilter("billstatus", "=", "C"));
            QFilter[] filter = new QFilter[qFilters.size() + 1];
            //采购入库单
            DynamicObject[] imPurinbills = BusinessDataServiceHelper.load("im_purinbill",
                    "billentry,unit,material,materialname,bizdept,billno,supplier,qty,currency," +
                            "exchangerate,exratetable,tpv_purcontnum,tpv_prodname,tpv_shader,tpv_origin,tpv_specation"
                    , qFilters.toArray(filter));
            DynamicObjectCollection entryentitys = dataEntity.getDynamicObjectCollection("tpv_entryentity");//商品明细
            this.getModel().deleteEntryData("tpv_entryentity");
            for (DynamicObject imPurinbill : imPurinbills) {
                DynamicObjectCollection billentry = imPurinbill.getDynamicObjectCollection("billentry");//商品明细
                for (DynamicObject loadSingle : billentry) {
                    if ("qfilterRKByHT".equals(desc) && null != htRowDynamic) {
//                    DynamicObject tpvDempatments = htRowDynamic.getDynamicObject("tpv_dempatments");
//                    DynamicObject tpvSuppliers = htRowDynamic.getDynamicObject("tpv_suppliers");
                        DynamicObject tpvMaterial = htRowDynamic.getDynamicObject("tpv_material");
//                    DynamicObject tpvConprodname = htRowDynamic.getDynamicObject("tpv_conprodname");
//                    DynamicObject tpvConorigin = htRowDynamic.getDynamicObject("tpv_conorigin");
//                    String tpvConshader = htRowDynamic.getString("tpv_conshader");
//                    String tpvConspecation = htRowDynamic.getString("tpv_conspecation");

//                    if (YEM.isNotEmpty(tpvDempatments) && YEM.isNotEmpty(imPurinbill.getDynamicObject("bizdept"))) {
//                        long tpvDempatmentsid = tpvDempatments.getLong("id");
//                        long bizdeptid = imPurinbill.getDynamicObject("bizdept").getLong("id");
//                        if (tpvDempatmentsid != bizdeptid) {
//                            continue;
//                        }
//                    } else if (YEM.isNotEmpty(tpvDempatments) && YEM.isEmpty(imPurinbill.getDynamicObject("bizdept"))){
//                        continue;
//                    } else if (YEM.isEmpty(tpvDempatments) && YEM.isNotEmpty(imPurinbill.getDynamicObject("bizdept"))){
//                        continue;
//                    }
//                    if (YEM.isNotEmpty(tpvSuppliers) && YEM.isNotEmpty(imPurinbill.getDynamicObject("supplier"))) {
//                        long tpvSuppliersid = tpvSuppliers.getLong("id");
//                        long supplierid = imPurinbill.getDynamicObject("supplier").getLong("id");
//                        if (tpvSuppliersid != supplierid) {
//                            continue;
//                        }
//                    } else if (YEM.isNotEmpty(tpvSuppliers) && YEM.isEmpty(imPurinbill.getDynamicObject("supplier"))) {
//                        continue;
//                    } else if (YEM.isEmpty(tpvSuppliers) && YEM.isNotEmpty(imPurinbill.getDynamicObject("supplier"))) {
//                        continue;
//                    }
                        if (YEM.isNotEmpty(tpvMaterial) && YEM.isNotEmpty(loadSingle.getDynamicObject("material"))) {
                            long tpvMaterialid = tpvMaterial.getLong("id");
                            long materialid = loadSingle.getDynamicObject("material").getDynamicObject("masterid").getLong("id");
                            if (tpvMaterialid != materialid) {
                                continue;
                            }
                        } else if (YEM.isNotEmpty(tpvMaterial) && YEM.isEmpty(loadSingle.getDynamicObject("material"))) {
                            continue;
                        } else if (YEM.isEmpty(tpvMaterial) && YEM.isNotEmpty(loadSingle.getDynamicObject("material"))) {
                            continue;
                        }
//                    if (YEM.isNotEmpty(tpvConprodname) && YEM.isNotEmpty(loadSingle.getDynamicObject("tpv_prodname"))) {
//                        long tpvConprodnameid = tpvConprodname.getLong("id");
//                        long tpv_prodnameid = loadSingle.getDynamicObject("tpv_prodname").getLong("id");
//                        if (tpvConprodnameid != tpv_prodnameid) {
//                            continue;
//                        }
//                    } else if (YEM.isNotEmpty(tpvConprodname) && YEM.isEmpty(loadSingle.getDynamicObject("tpv_prodname"))) {
//                        continue;
//                    } else if (YEM.isEmpty(tpvConprodname) && YEM.isNotEmpty(loadSingle.getDynamicObject("tpv_prodname"))) {
//                        continue;
//                    }
//                    if (YEM.isNotEmpty(tpvConorigin) && YEM.isNotEmpty(loadSingle.getDynamicObject("tpv_origin"))) {
//                        long tpvConoriginid = tpvConorigin.getLong("id");
//                        long tpv_originid = loadSingle.getDynamicObject("tpv_origin").getLong("id");
//                        if (tpvConoriginid != tpv_originid) {
//                            continue;
//                        }
//                    } else if (YEM.isNotEmpty(tpvConorigin) && YEM.isEmpty(loadSingle.getDynamicObject("tpv_origin"))) {
//                        continue;
//                    } else if (YEM.isEmpty(tpvConorigin) && YEM.isNotEmpty(loadSingle.getDynamicObject("tpv_origin"))) {
//                        continue;
//                    }
//                    if (!tpvConshader.equals(loadSingle.getString("tpv_shader")) ||
//                            !tpvConspecation.equals(loadSingle.getString("tpv_specation"))) {
//                        continue;
//                    }
                    }
                    int row = this.getModel().createNewEntryRow("tpv_entryentity");
                    this.getModel().setValue("tpv_dempatmentsrk", imPurinbill.getDynamicObject("bizdept"), row);  //部门
                    this.getModel().setValue("tpv_cgnumberrk", imPurinbill.getString("billno"), row);  //入库单号
                    this.getModel().setValue("tpv_suppliersrk", imPurinbill.getDynamicObject("supplier"), row);  //供应商
                    this.getModel().setValue("tpv_purchasenumrk", imPurinbill.getString("tpv_purcontnum"), row);  //采购合同号
                    this.getModel().setValue("tpv_conprodnamerk", loadSingle.getDynamicObject("tpv_prodname"), row);  //品名
                    DynamicObject dynamicObject = loadSingle.getDynamicObject("material");
                    this.getModel().setValue("tpv_materiel", YEM.isNotEmpty(loadSingle.getDynamicObject("material"))
                            ? loadSingle.getDynamicObject("material").getDynamicObject("masterid") : null, row);  //物料编码
//                this.getModel().setValue("tpv_materielname", loadSingle.getString("materialname"), row);  //物料名称
                    this.getModel().setValue("tpv_conshaderrk", loadSingle.getString("tpv_shader"), row);  //材质
                    this.getModel().setValue("tpv_conoriginrk", loadSingle.getDynamicObject("tpv_origin"), row);  //产地
                    this.getModel().setValue("tpv_conspecationrk", loadSingle.getString("tpv_specation"), row);  //规格
                    this.getModel().setValue("tpv_inumberrk", loadSingle.getBigDecimal("qty"), row);  //数量
                    this.getModel().setValue("tpv_rkcomeid", loadSingle.get("id"), row);  //来源分录id1
                    this.getModel().setValue("tpv_currency", imPurinbill.getDynamicObject("currency"), row);  //币别
                    this.getModel().setValue("tpv_basedatatable", imPurinbill.getDynamicObject("exratetable"), row);  //汇率表
                    this.getModel().setValue("tpv_taxhl", imPurinbill.getBigDecimal("exchangerate"), row);  //汇率
                    this.getModel().setValue("tpv_rkunit", loadSingle.get("unit"), row);  //汇率
//                this.getModel().setValue("tpv_taxtk", rateMap.containsKey(imPurinbill.getString("tpv_purcontnum"))
//                        ? rateMap.get(imPurinbill.getString("tpv_purcontnum")) : BigDecimal.ZERO, row);  //税率
                    listRk.add((String) loadSingle.get("id").toString());
                }
            }

            DynamicObject[] tpvDtPur = BusinessDataServiceHelper.load("tpv_dt_purinvomater", "tpv_continformation,tpv_wareiformation,tpv_purinentryid,tpv_rkcurmatchqty",
                    new QFilter[]{new QFilter("tpv_wareiformation.tpv_purinentryid", "in", listRk)}); //采购发票匹配单
            DynamicObject[] wbillCromater = BusinessDataServiceHelper.load("tpv_dt_wbillcromater", "tpv_dt_incomingenty,tpv_dt_incomingenty.tpv_rkcomid,tpv_bcmonnumrk",
                    new QFilter[]{new QFilter("tpv_dt_incomingenty.tpv_rkcomid", "in", listRk)}
            ); //货票对应单

            int rowRk = this.getModel().getEntryRowCount("tpv_entryentity");
            for (int i = 0; i < rowRk; i++) {
                BigDecimal bcmtNum = BigDecimal.ZERO;     //已匹配数量
                for (DynamicObject loadSingle : tpvDtPur) {
                    DynamicObjectCollection tpvDtConmx = loadSingle.getDynamicObjectCollection("tpv_wareiformation");
                    for (DynamicObject dtConmx : tpvDtConmx) {
                        String purinentryId = dtConmx.getString("tpv_purinentryid");
                        if (listRk.get(i).equals(purinentryId)) {
                            bcmtNum = bcmtNum.add(dtConmx.getBigDecimal("tpv_rkcurmatchqty"));
                        }
                    }
                }
                for (DynamicObject loadSingle : wbillCromater) {
                    DynamicObjectCollection tpvDtConmx = loadSingle.getDynamicObjectCollection("tpv_dt_incomingenty");
                    for (DynamicObject dtConmx : tpvDtConmx) {
                        String string = dtConmx.getString("tpv_rkcomid");
                        if (listRk.get(i).equals(string)) {
                            bcmtNum = bcmtNum.add(dtConmx.getBigDecimal("tpv_bcmonnumrk"));
                        }
                    }
                }
                this.getModel().setValue("tpv_matchedmunrk", bcmtNum, i);  //已匹配数量
            }
            DynamicObjectCollection tpvEntryentity = dataEntity.getDynamicObjectCollection("tpv_entryentity");
            for (int i = 0; i < tpvEntryentity.size(); i++) {
                BigDecimal tpvInumberrk = tpvEntryentity.get(i).getBigDecimal("tpv_inumberrk");//数量
                BigDecimal tpvMatchedmunrk = tpvEntryentity.get(i).getBigDecimal("tpv_matchedmunrk");//已匹配数量
                this.getModel().setValue("tpv_matchednumn", tpvInumberrk.subtract(tpvMatchedmunrk), i);//未匹配数量
//            this.getModel().setValue("tpv_bamatnum", tpvInumberrk.subtract(tpvMatchedmunrk), i);//本次匹配数量
            }
        }

        //处理未匹配数大于零过滤处理逻辑
        DynamicObjectCollection constracTmx = dataEntity.getDynamicObjectCollection("tpv_constractmx");
        DynamicObjectCollection entryEntity = dataEntity.getDynamicObjectCollection("tpv_entryentity");
        List<Integer> listCon = new ArrayList<>();
        List<Integer> listEn = new ArrayList<>();
        for (int i = 0; i < constracTmx.size(); i++) {
            BigDecimal tpvMomatched = constracTmx.get(i).getBigDecimal("tpv_momatched");
            if (tpvMomatched.compareTo(BigDecimal.ZERO) == 0) {
                listCon.add(i);
            }
        }
        for (int i = 0; i < entryEntity.size(); i++) {
            BigDecimal tpvMomatched = entryEntity.get(i).getBigDecimal("tpv_matchednumn");
            if (tpvMomatched.compareTo(BigDecimal.ZERO) == 0) {
                listEn.add(i);
            }
        }
        int[] con = new int[listCon.size()];
        int[] en = new int[listEn.size()];
        for (int i = 0; i < listCon.size(); i++) {
            con[i] = listCon.get(i);
        }
        for (int i = 0; i < listEn.size(); i++) {
            en[i] = listEn.get(i);
        }
        Boolean value = (Boolean) this.getModel().getValue("tpv_zero");
        if (value) {
            if (con.length > 0) {
                this.getModel().deleteEntryRows("tpv_constractmx", con);
            }
            if (en.length > 0) {
                this.getModel().deleteEntryRows("tpv_entryentity", en);
            }
            //清除单据体所有选中行
            if (isFlag) {
                ((FormView) this.getView()).getClientProxy().invokeControlMethod("tpv_constractmx", "clearSelRows");
            }
            ((FormView) this.getView()).getClientProxy().invokeControlMethod("tpv_entryentity", "clearSelRows");
        }
        if (!isFlag) {
//            bAmatnum();
        }
    }
}