package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.itopview.wm.dt.report.PickShipsRptQuery;
import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.MessageTypes;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 拣配-表单插件
 *
 * @author longh
 * @description
 * @date 2023年8月16日
 */
@Deprecated
public class PickShipsEdit extends AbstractFormPlugin {

    private final String TPV_DT_SALESSHIPPING = "tpv_dt_salesshipping";//销售发货1

    private final String MULTIBILL = "multibill";//其他出库单2

    private final String TPV_DT_NOCONFIGURATION = "tpv_dt_noconfiguration";//库存免拣配业务底表3

    private final String TPV_DT_INVENTORYCONFIGURA = "tpv_dt_inventoryconfigura";//库存拣配业务实提工作台5
    private final String IM_PURINBILL = "im_purinbill";//采购入库单6

    private final String TPV_DT_RELEVANCEDEALGS = "tpv_dt_relevancedealgs";//关联交易转货单7
    private static final String entryKey_1 = "tpv_treeentryentity";
    private static final String entryKey_2 = "tpv_entryentity";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok", "tpv_query", "tpv_deleteentry"});
        this.addItemClickListeners(new String[]{"tpv_advcontoolbarap"});
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        initData(true);
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
                pickOk();
                break;
            case "tpv_query":
                initData(false);
                break;
            default:
                break;
        }
    }

    /**
     * 拣配确认 通过校验并反写
     */
    private void pickOk() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        FormShowParameter parameter = view.getFormShowParameter();
        String picktype = parameter.getCustomParam("picktype");
        Long saleId = toLong(parameter.getCustomParam("pkid"));
        Long org = toLong(parameter.getCustomParam("org"));
        Long tpv_material = toLong(parameter.getCustomParam("tpv_material"));
        BigDecimal tpv_qty = BigDecimalUtils.toBigDecimal(parameter.getCustomParam("tpv_qty"));// 销售发货数量
        DynamicObjectCollection entryEntity = model.getEntryEntity(entryKey_2);
        String according = null;
        /**
         * 校验
         */
        /*
         * if (entryEntity.size() == 0) { view.showTipNotification("无配货信息。"); return; }
         */
        DynamicObject dataEntity = model.getDataEntity(true);
        if (StringUtils.equals(picktype, TPV_DT_SALESSHIPPING)) {
            according = parameter.getCustomParam("tpv_yesnoinseries");
        }
        String whereFilter = "tpv_qty > 0";
        // 物料
        if (YEM.isNotEmpty(tpv_material)) {
            whereFilter = String.format("%s and tpv_material = %s", whereFilter, tpv_material);
        }
        // 公司
        if (YEM.isNotEmpty(org)) {
            whereFilter = String.format("%s and tpv_org = %s", whereFilter, org);
        }
        // 组合号
        if (StringUtils.isNotEmpty(according)) {
            DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
            if (YEM.isNotEmpty(tpv_combination_f)) {
                whereFilter = String.format("%s and tpv_combination != %s", whereFilter, tpv_combination_f.getPkValue());
            }
        } else {
            DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
            if (YEM.isNotEmpty(tpv_combination_f)) {
                whereFilter = String.format("%s and tpv_combination = %s", whereFilter, tpv_combination_f.getPkValue());
            }
        }
        // 库存/直运
        String tpv_inventorytype_f = dataEntity.getString("tpv_inventorytype_f");
        if (YEM.isNotEmpty(tpv_inventorytype_f)) {
            whereFilter = String.format("%s and tpv_inventorytype = '%s'", whereFilter, tpv_inventorytype_f);
        }
        DataSet query = PickShipsRptQuery.query(whereFilter, picktype, saleId);
        DynamicObjectCollection data = ORM.create().toPlainDynamicObjectCollection(query);

        BigDecimal sumQty = BigDecimal.ZERO;
        List<String> tips = new ArrayList<>();
        for (DynamicObject row : entryEntity) {
            long tpv_fentryid1 = row.getLong("tpv_fentryid1");
            long tpv_vid1 = row.getLong("tpv_vid1");
            String tpv_pickbill1 = row.getString("tpv_pickbill1");
            BigDecimal tpv_pickqty1 = row.getBigDecimal("tpv_pickqty1");//本次配货数量
            sumQty = sumQty.add(tpv_pickqty1);
            int seq = row.getInt("seq");
            if (tpv_pickqty1.compareTo(BigDecimal.ZERO) <= 0) {
                tips.add(String.format("配货处理第【%s】行，本次配货数量为零。", seq));
                continue;
            }
            Map<Long, List<DynamicObject>> map = data.stream()
                    .filter(x -> tpv_pickbill1.equals(x.getString("tpv_pickbill")))
                    .collect(Collectors.groupingBy(x -> x.getLong("tpv_fentryid")));
            List<DynamicObject> dyObjs = map.get(tpv_fentryid1);
            BigDecimal canPickQty = BigDecimal.ZERO;//可配数量
            if (dyObjs != null) {
                for (DynamicObject obj : dyObjs) {
                    long tpv_vid = obj.getLong("tpv_vid");
                    if (tpv_vid == tpv_vid1) {
                        canPickQty = obj.getBigDecimal("tpv_maxqty");
                    }
                }
            }
            if (tpv_pickqty1.compareTo(canPickQty) > 0) {
                tips.add(String.format("配货处理第【%s】行，本次配货数量大于最大可配数量。", seq));
            }
        }
        if (!IM_PURINBILL.equals(picktype) && !MULTIBILL.equals(picktype) && entryEntity.size() != 0 && sumQty.compareTo(tpv_qty) == 1) {
            tips.add("本次配货总数量大于销售数量。");
        }
        if (tips.size() > 0) {
            String errMsg = "";
            int msgSeq = 1;
            for (String tip : tips) {
                errMsg += String.format("%s、%s%s", msgSeq++, tip, "\r\n");
            }
            view.showMessage("配货信息有误，请检查。", errMsg, MessageTypes.Default);
            return;
        }
        /**
         * 销售发货反写
         */
        OperationResult saveOperate = null;
        IFormView parentView = view.getParentView();
        IDataModel parentModel = parentView.getModel();
        String entityId = parentView.getEntityId();
        dataEntity = parentModel.getDataEntity(true);
        String name = null;
        int pitchOn = 0;
        if (TPV_DT_SALESSHIPPING.equals(picktype)) {
            int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_materialentry");
            pitchOn = entryCurrentRowIndex;
            // DynamicObject entryRowEntity =
            // parentModel.getEntryRowEntity("tpv_materialentry", entryCurrentRowIndex);
            DynamicObject entryRowEntity = dataEntity.getDynamicObjectCollection("tpv_materialentry")
                    .get(entryCurrentRowIndex);
            String subEnd = "A".equals(tpv_inventorytype_f) ? "_in" : "_zy";
            name = subEnd;
            DynamicObjectCollection subEntry = entryRowEntity.getDynamicObjectCollection("tpv_dt_salepick" + subEnd);
            DataEntityPropertyCollection properties = subEntry.getDynamicObjectType().getProperties();
            DynamicObjectType dyType2 = entryEntity.getDynamicObjectType();
            DataEntityPropertyCollection properties2 = dyType2.getProperties();
            subEntry.clear();
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                DynamicObject addNew = subEntry.addNew();
                for (IDataEntityProperty property : properties2) {
                    String proKey = property.getName();
                    String key = YEM.substringBeforeLast(proKey, "1");
                    if (properties.containsKey(key + subEnd)) {
                        addNew.set(key + subEnd, row.get(proKey));
                        if (subEnd.equals("_in")) {
                            addNew.set("tpv_pickqtyrecord_in", row.get("tpv_pickqty1"));
                            addNew.set("tpv_picknumrecord_in", row.get("tpv_qtypacknum1"));
                            addNew.set("tpv_priceokqty", entryRowEntity.getBigDecimal("tpv_cargobatchqty"));
                            addNew.set("tpv_measure", entryRowEntity.getDynamicObject("tpv_unit"));
                            addNew.set("tpv_contractmark", row.get("tpv_purcontnum1"));
                            if (StringUtils.isNotEmpty(according)) {
                                addNew.set("tpv_loansign", true);
                            }
                            //addNew.set("tpv_pickqtyrecord_in",row.get("tpv_pickqty1"));
                        } else if (subEnd.equals("_zy")) {
                            addNew.set("tpv_pickqtyrecord_zy", row.get("tpv_pickqty1"));
                            addNew.set("tpv_picknumrecord_zy", row.get("tpv_qtypacknum1"));
                            addNew.set("tpv_ofmeasure", entryRowEntity.getDynamicObject("tpv_unit"));
                            //addNew.set("tpv_pickqtyrecord_zy",row.get("tpv_pickqty1"));
                        }
                    }
                }
                addNew.set("seq", i + 1);
            }
            saveOperate = OperationServiceHelper.executeOperate("save", entityId, new DynamicObject[]{dataEntity},
                    YEM.getOptionNoMsg());
        } else if (TPV_DT_NOCONFIGURATION.equals(picktype)) {
            BigDecimal tpv_cargobatchqty = BigDecimalUtils.toBigDecimal(parameter.getCustomParam("tpv_cargobatchqty"));// 销售发货数量
            String subEnd = "A".equals(tpv_inventorytype_f) ? "_in" : "_zy";
            DynamicObjectCollection tpvSonentryentity = parentModel.getEntryEntity("tpv_sonentryentity");
            DataEntityPropertyCollection properties = tpvSonentryentity.getDynamicObjectType().getProperties();
            DynamicObjectType threeType = entryEntity.getDynamicObjectType();
            DataEntityPropertyCollection properties2 = threeType.getProperties();
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                DynamicObject addNew = tpvSonentryentity.addNew();
                for (IDataEntityProperty property : properties2) {
                    String proKey = property.getName();
                    String key = YEM.substringBeforeLast(proKey, "1");
                    if (properties.containsKey(key + subEnd)) {
                        addNew.set(key + subEnd, row.get(proKey));
                        Object object = row.get("tpv_fid1");
                        addNew.set("tpv_fatherid", row.get("tpv_fid1"));
                        addNew.set("tpv_material_in", row.getDynamicObject("tpv_material1"));// 商品
                        addNew.set("tpv_prodname_in", row.getDynamicObject("tpv_prodname1"));// 品名
                        addNew.set("tpv_shader_in", row.get("tpv_shader1"));// 材质
                        addNew.set("tpv_origin_in", row.get("tpv_origin1"));// 产地
                        addNew.set("tpv_volumenumber_in", row.get("tpv_volumenumber1"));// 卷号
                        addNew.set("tpv_pickbill_in", row.get("tpv_pickbill1"));// 父配货单据
                        addNew.set("tpv_billno_in", row.get("tpv_billno1"));// 父配货单据编号
                        addNew.set("tpv_sonbill", row.get("tpv_pickbill1"));// 子配货单据
                        addNew.set("tpv_sonbillnos", row.get("tpv_billno1"));// 子配货单据编号
                        addNew.set("tpv_fid_in", row.get("tpv_fid1"));// 采购单据ID
                        addNew.set("tpv_vid_in", row.get("tpv_vid1"));//卷号分录ID
                        addNew.set("tpv_pickqtyrecord_in", row.get("tpv_pickqty1"));
                        addNew.set("tpv_destroyquantity", row.get("tpv_pickqty1"));
                        addNew.set("tpv_priceokqty", tpv_cargobatchqty);
                    }
                }
                addNew.set("seq", i + 1);
            }
            saveOperate = OperationServiceHelper.executeOperate("save", entityId, new DynamicObject[]{dataEntity},
                    YEM.getOptionNoMsg());
        } else if (MULTIBILL.equals(picktype)) {
            parentModel.deleteEntryData("billentry");
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                int index = parentModel.createNewEntryRow("billentry");
                parentModel.setValue("tpv_prodname", row.get("tpv_prodname1"), index);// 品名
                DynamicObject tpv_material1 = row.getDynamicObject("tpv_material1");
                if (tpv_material1 != null) {
                    tpv_material1 = BusinessDataServiceHelper.loadSingle("bd_materialinventoryinfo",
                            new QFilter("masterid", QCP.equals, tpv_material1.getPkValue()).toArray());
                }
                parentModel.setValue("material", tpv_material1, index);// 商品编码
                parentModel.setValue("tpv_specation", row.get("tpv_specation1"), index);// 规格
                parentModel.setValue("tpv_shader", row.get("tpv_shader1"), index);// 材质
                parentModel.setValue("tpv_origin", row.get("tpv_origin1"), index);// 产地
                parentModel.setValue("unit", row.get("tpv_unit1"), index);// 计量单位
                parentModel.setValue("qty", row.get("tpv_pickqty1"), index);// 数量
                parentModel.setValue("baseunit", row.get("tpv_unit1"), index);// 基本单位
                parentModel.setValue("baseqty", row.get("tpv_pickqty1"), index);// 基本数量
                parentModel.setValue("tpv_packagingunit", row.get("tpv_packagingunit1"), index);// 包装单位
                // parentModel.setValue("tpv_packnum", row.get(""), index);//包装数量
                parentModel.setValue("im_transdirbill".equals(entityId) ? "outwarehouse" : "warehouse",
                        row.get("tpv_warehouse1"), index);// 仓库
                parentModel.setValue("tpv_pickbill_in", row.get("tpv_pickbill1"), index);// 配货单据
                parentModel.setValue("tpv_billno_in", row.get("tpv_billno1"), index);// 单据编号
                parentModel.setValue("tpv_volumenumber_in", row.get("tpv_volumenumber1"), index);// 卷号
                parentModel.setValue("tpv_fid_in", row.get("tpv_fid1"), index);// 采购单据ID
                parentModel.setValue("tpv_fentryid_in", row.get("tpv_fentryid1"), index);// 采购分录行ID
                parentModel.setValue("tpv_fcoentryid_in", row.get("tpv_fcoentryid1"), index);// 采购合同行ID
                parentModel.setValue("tpv_vid_in", row.get("tpv_vid1"), index);//卷号分录ID
                saveOperate = parentView.invokeOperation("save", YEM.getOptionNoMsg());
            }
        } else if (TPV_DT_INVENTORYCONFIGURA.equals(picktype)) {
            //库存拣配业务实提工作台
            int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_entryentity");
            DynamicObject entryRowEntity = parentModel.getEntryRowEntity("tpv_entryentity", entryCurrentRowIndex);
            String tpvSrcentryid = entryRowEntity.getString("tpv_srcentryid");
            long srcentryid = Long.parseLong(tpvSrcentryid);
            QFilter qFilter = new QFilter("tpv_materialentry", QCP.equals, srcentryid);
            String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
            DynamicObject billHead = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
            ;//需查询
            billHead = BusinessDataServiceHelper.loadSingle(billHead.getPkValue(),
                    billHead.getDynamicObjectType().getName());
            DynamicObject rowS = null;
            DynamicObjectCollection objectCollection = billHead.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject dynamicObject : objectCollection) {
                long id = (Long) dynamicObject.get("id");
                if (id == srcentryid) {
                    rowS = dynamicObject;
                }
            }
            String subEnd = "A".equals(tpv_inventorytype_f) ? "_in" : "_zy";
            DynamicObjectCollection subEntry = rowS.getDynamicObjectCollection("tpv_dt_salepick" + subEnd);
            DataEntityPropertyCollection properties = subEntry.getDynamicObjectType().getProperties();
            DynamicObjectType dyType2 = objectCollection.getDynamicObjectType();
            DataEntityPropertyCollection properties2 = dyType2.getProperties();
            //subEntry.clear();
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                DynamicObject addNew = subEntry.addNew();
                for (IDataEntityProperty property : properties2) {
                    String proKey = property.getName();
                    String key = YEM.substringBeforeLast(proKey, "1");
                    if (properties.containsKey(key + subEnd)) {
                        //addNew.set(key + subEnd, row.get(proKey));
                        //addNew.set("tpv_fatherid", row.get("tpv_fid1"));
                        addNew.set("tpv_material_in", row.getDynamicObject("tpv_material1"));// 商品
                        addNew.set("tpv_specation_in", row.get("tpv_specation1"));// 规格
                        addNew.set("tpv_prodname_in", row.getDynamicObject("tpv_prodname1"));// 品名
                        addNew.set("tpv_shader_in", row.get("tpv_shader1"));// 材质
                        addNew.set("tpv_origin_in", row.get("tpv_origin1"));// 产地
                        addNew.set("tpv_volumenumber_in", row.get("tpv_volumenumber1"));// 卷号
                        addNew.set("tpv_pickbill_in", row.get("tpv_pickbill1"));// 父配货单据
                        addNew.set("tpv_billno_in", row.get("tpv_billno1"));// 父配货单据编号
                        addNew.set("tpv_measure", row.get("tpv_unit1"));// 计量单位
                        addNew.set("tpv_pickqty_in", row.get("tpv_pickqty1"));// 数量
                        addNew.set("tpv_pickqtyrecord_in", row.get("tpv_pickqty1"));// 数量记录
                        addNew.set("tpv_priceokqty", rowS.get("tpv_cargobatchqty"));// 数量价格确认
                        //addNew.set("tpv_packagingunit", row.get("tpv_packagingunit1"));// 包装单位
                        addNew.set("im_transdirbill".equals(entityId) ? "outwarehouse" : "tpv_warehouse_in",
                                row.get("tpv_warehouse1"));// 仓库
                        addNew.set("tpv_fid_in", row.get("tpv_fid1"));// 采购单据ID
                        addNew.set("tpv_fentryid_in", row.get("tpv_fentryid1"));// 采购分录行ID
                        addNew.set("tpv_fcoentryid_in", row.get("tpv_fcoentryid1"));// 采购合同行ID
                        addNew.set("tpv_vid_in", row.get("tpv_vid1"));//卷号分录ID
                        addNew.set("tpv_department_in", row.get("tpv_department1"));// 部门
                        addNew.set("tpv_supplier_in", row.get("tpv_supplier1"));// 供应商
                        addNew.set("tpv_tradeproperty_in", row.get("tpv_tradeproperty1"));// 贸易性质
                        addNew.set("tpv_combination_in", row.get("tpv_combination1"));//组合号
                        addNew.set("tpv_strategy_in", row.get("tpv_strategy1"));//策略号
                        addNew.set("tpv_pickbilltype_in", row.get("tpv_pickbilltype1"));//单据类型
                    }
                }
                addNew.set("seq", i + 1);
            }
            saveOperate = OperationServiceHelper.executeOperate("save", entityId, new DynamicObject[]{billHead},
                    YEM.getOptionNoMsg());
        } else if (IM_PURINBILL.equals(picktype)) {
            //采购入库
            //parentModel.deleteEntryData("billentry");
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                int index = parentModel.createNewEntryRow("billentry");
                parentModel.setValue("tpv_prodname", row.get("tpv_prodname1"), index);// 品名
                DynamicObject tpv_material1 = row.getDynamicObject("tpv_material1");
                if (tpv_material1 != null) {
                    tpv_material1 = BusinessDataServiceHelper.loadSingle("bd_materialinventoryinfo",
                            new QFilter("masterid", QCP.equals, tpv_material1.getPkValue()).toArray());
                }
                BigDecimal object = (BigDecimal) row.get("tpv_pickqty1");
                BigDecimal tpv_pickqty1 = object.negate();
                //row.set("tpv_pickqty1",tpv_pickqty1);
                parentModel.setValue("material", tpv_material1, index);// 商品编码
                parentModel.setValue("tpv_specation", row.get("tpv_specation1"), index);// 规格
                parentModel.setValue("tpv_shader", row.get("tpv_shader1"), index);// 材质
                parentModel.setValue("tpv_origin", row.get("tpv_origin1"), index);// 产地
                parentModel.setValue("unit", row.get("tpv_unit1"), index);// 计量单位
                parentModel.setValue("qty", row.get("tpv_pickqty1"), index);// 数量
                parentModel.setValue("baseunit", row.get("tpv_unit1"), index);// 基本单位
                parentModel.setValue("baseqty", row.get("tpv_pickqty1"), index);// 基本数量
                parentModel.setValue("tpv_packagingunit", row.get("tpv_packagingunit1"), index);//包装单位
                // parentModel.setValue("tpv_packnum", row.get(""), index);//包装数量
                parentModel.setValue("im_transdirbill".equals(entityId) ? "outwarehouse" : "warehouse",
                        row.get("tpv_warehouse1"), index);// 仓库
                parentModel.setValue("tpv_corebillid", row.get("tpv_fcoid1"), index);//合同号id
                parentModel.setValue("tpv_pickbill_in", row.get("tpv_pickbill1"), index);// 配货单据
                parentModel.setValue("tpv_billno_in", row.get("tpv_billno1"), index);// 单据编号
                parentModel.setValue("tpv_volumenumber_in", row.get("tpv_volumenumber1"), index);// 卷号
                parentModel.setValue("tpv_fid_in", row.get("tpv_fid1"), index);// 采购单据ID
                parentModel.setValue("tpv_fentryid_in", row.get("tpv_fentryid1"), index);// 采购分录行ID
                parentModel.setValue("tpv_fcoentryid_in", row.get("tpv_fcoentryid1"), index);// 采购合同行ID
                parentModel.setValue("tpv_vid_in", row.get("tpv_vid1"), index);//卷号分录ID
                saveOperate = parentView.invokeOperation("save", YEM.getOptionNoMsg());
            }
        } else if (TPV_DT_RELEVANCEDEALGS.equals(picktype)) {
            //关联交易转货单
            int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_dt_goodstransfe_zh");
            DynamicObject entryRowEntity = dataEntity.getDynamicObjectCollection("tpv_dt_goodstransfe_zh")
                    .get(entryCurrentRowIndex);
            DynamicObjectCollection subEntry = entryRowEntity.getDynamicObjectCollection("tpv_dt_transferdist_ph");
            DataEntityPropertyCollection properties = subEntry.getDynamicObjectType().getProperties();
            DynamicObjectType dyType2 = entryEntity.getDynamicObjectType();
            DataEntityPropertyCollection properties2 = dyType2.getProperties();
            subEntry.clear();
            for (int i = 0; i < entryEntity.size(); i++) {
                DynamicObject row = entryEntity.get(i);
                DynamicObject addNew = subEntry.addNew();
                for (IDataEntityProperty property : properties2) {
                    addNew.set("tpv_prodnames", row.get("tpv_prodname1"));// 品名
                    DynamicObject tpv_material1 = row.getDynamicObject("tpv_material1");
                    if (tpv_material1 != null) {
                        tpv_material1 = BusinessDataServiceHelper.loadSingle("bd_materialinventoryinfo",
                                new QFilter("masterid", QCP.equals, tpv_material1.getPkValue()).toArray());
                    }
                    addNew.set("tpv_contractmark", row.get("tpv_purcontnum1"));//合同号
                    addNew.set("tpv_materials", row.get("tpv_material1"));// 商品编码
                    addNew.set("tpv_specations", row.get("tpv_specation1"));// 规格
                    addNew.set("tpv_shaders", row.get("tpv_shader1"));// 材质
                    addNew.set("tpv_origins", row.get("tpv_origin1"));// 产地
                    addNew.set("tpv_ofmeasure", row.get("tpv_unit1"));// 计量单位
                    addNew.set("tpv_departments", row.get("tpv_department1"));//部门
                    addNew.set("tpv_suppliers", row.get("tpv_supplier1"));//供应商
                    addNew.set("tpv_tradepropertys", row.get("tpv_tradeproperty1"));//贸易性质
                    addNew.set("tpv_combinations", row.get("tpv_combination1"));//组合号
                    addNew.set("tpv_strategys", row.get("tpv_strategy1"));//策略号
                    addNew.set("tpv_pickbilltypes", row.get("tpv_pickbilltype1"));//单据类型
                    addNew.set("tpv_pickqty", row.get("tpv_pickqty1"));// 本次配货数量
                    addNew.set("tpv_warehouse", row.get("tpv_warehouse1.id"));// 仓库
                    //parentModel.setValue("tpv_corebillid", row.get("tpv_fcoid1"), index);//合同号id
                    addNew.set("tpv_pickbill", row.get("tpv_pickbill1"));// 配货单据
                    addNew.set("tpv_billnos", row.get("tpv_billno1"));// 单据编号
                    addNew.set("tpv_volumenumber", row.get("tpv_volumenumber1"));// 卷号
                    addNew.set("tpv_fids", row.get("tpv_fid1"));// 采购单据ID
                    addNew.set("tpv_fentryids", row.get("tpv_fentryid1"));// 采购分录行ID
                    addNew.set("tpv_fcoentryids", row.get("tpv_fcoentryid1"));// 采购合同行ID
                    addNew.set("tpv_vids", row.get("tpv_vid1"));//卷号分录ID
                }
                addNew.set("seq", i + 1);
            }
            saveOperate = OperationServiceHelper.executeOperate("save", entityId, new DynamicObject[]{dataEntity},
                    YEM.getOptionNoMsg());
        }
        if (saveOperate == null || !saveOperate.isSuccess()) {
            view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
            return;
        }
        parentView.invokeOperation("refresh");
        String entityId1 = parentView.getEntityId();//杰伟代码优化，需要表单插件写
        if (entityId1.equals("tpv_dt_salesshipping")) {
            String billno = (String) parentModel.getValue("billno");
            if (billno.length() > 4) {
                String substring = billno.substring(0, 4);
                if ("XSFH".equals(substring)) {
                    parentView.setEnable(false, "tpv_entrepot");
                    parentView.setEnable(false, pitchOn, "tpv_origin");  //锁定分录字段
                    parentView.setEnable(false, pitchOn, "tpv_shader");  //锁定分录字段
                    parentView.setEnable(false, pitchOn, "tpv_specation");  //锁定分录字段
                }
            }
        }
        view.sendFormAction(parentView);
        view.close();
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        switch (itemKey) {
            case "tpv_deleteentry":
                deleteEntry();
                break;
            default:
                break;
        }
    }

    /**
     * 配货记录撤销
     */
    private void deleteEntry() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        EntryGrid entry = view.getControl(entryKey_2);
        int selectRows = entry.getSelectRows().length;
        if (selectRows < 1) {
            view.showTipNotification("未选择数据。");
        } else {
            int[] indexs = entry.getSelectRows();
            for (int index : indexs) {
                int tpv_seq1 = (int) model.getValue("tpv_seq1", index);
                if (tpv_seq1 > 0) {
                    model.beginInit();
                    model.setValue("tpv_focus", false, tpv_seq1 - 1);
                    model.endInit();
                    view.updateView("tpv_focus", tpv_seq1 - 1);
                }
            }
            model.deleteEntryRows(entryKey_2, indexs);
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();
        String key = e.getProperty().getName();
        switch (key) {
            case "tpv_focus":
                pickFocus(rowIndex);
                break;
            default:
                break;
        }
    }

    /**
     * 选中调整配货信息
     */
    private void pickFocus(int rowIndex) {
        pickFocus(rowIndex, null);
    }

    private void pickFocus(int rowIndex, BigDecimal tpv_pickqty) {
        IFormView view = this.getView();
        IFormView parentView = view.getParentView();
        IDataModel parentModel = parentView.getModel();
        IDataModel model = this.getModel();
        DynamicObject row = model.getEntryRowEntity(entryKey_1, rowIndex);
        DataEntityPropertyCollection properties = row.getDynamicObjectType().getProperties();
        DynamicObjectCollection entry2 = model.getEntryEntity(entryKey_2);
        DataEntityPropertyCollection properties2 = entry2.getDynamicObjectType().getProperties();
        String entityId = parentView.getEntityId();
        String just = null;
        int seq = row.getInt("seq");
        if (row.getBoolean("tpv_focus")) {
            List<Integer> seqs = entry2.stream().map(x -> x.getInt("tpv_seq1")).collect(Collectors.toList());
            if (!seqs.contains(seq)) {
                int index = model.createNewEntryRow(entryKey_2);
                for (IDataEntityProperty property : properties) {
                    String key = property.getName();
                    if (properties2.containsKey(key + "1")) {
                        model.setValue(key + "1", row.get(key), index);
                    }
                }
                model.setValue("tpv_seq1", seq, index);
                if (entityId.equals("tpv_dt_salesshipping")) {
                    int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_materialentry");
                    DynamicObject dataEntity = parentModel.getDataEntity(true);
                    DynamicObject entryRowEntity = dataEntity.getDynamicObjectCollection("tpv_materialentry")
                            .get(entryCurrentRowIndex);
                    just = entityId;
                    //拣配下方分录得本次配货数量
                    BigDecimal total = BigDecimal.ZERO;
                    //获取销售发货商品分录数量
                    BigDecimal tpvQty = entryRowEntity.getBigDecimal("tpv_qty");
                    //获取拣配上方分录可配数量
                    BigDecimal tpvQty1 = row.getBigDecimal("tpv_qty");
                    if (entry2.size() > 0) {
                        for (DynamicObject dynamicObject : entry2) {
                            total = total.add(dynamicObject.getBigDecimal("tpv_pickqty1"));
                        }
                    }
                    if (total.compareTo(BigDecimal.ZERO) == 0) {
                        int message = tpvQty.compareTo(tpvQty1);
                        if (message > 0) {
                            model.setValue("tpv_pickqty1", tpvQty1, index);
                        } else {
                            model.setValue("tpv_pickqty1", tpvQty, index);
                        }
                    } else if (total.compareTo(BigDecimal.ZERO) != 0) {
                        //用销售发货商品分录数量减去拣配下方分录得本次配货数量
                        BigDecimal subtract = tpvQty.subtract(total);
                        int messageOne = subtract.compareTo(tpvQty1);
                        if (messageOne > 0) {
                            model.setValue("tpv_pickqty1", tpvQty1, index);
                        } else {
                            model.setValue("tpv_pickqty1", tpvQty, index);
                        }
                    }
                }
                if (null == just) {
                    if (YEM.isNotEmpty(tpv_pickqty)) {
                        model.setValue("tpv_pickqty1", tpv_pickqty, index);
                    }
                }
            }
        } else {
            for (int i = 0; i < entry2.size(); i++) {
                DynamicObject row2 = entry2.get(i);
                if (seq == row2.getInt("tpv_seq1")) {
                    model.deleteEntryRow(entryKey_2, i);
                }
            }
        }
    }

    /**
     * 加载拣配数据
     *
     * @param b
     */
    private void initData(boolean b) {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        FormShowParameter parameter = view.getFormShowParameter();
        String picktype = parameter.getCustomParam("picktype");
        Long saleId = toLong(parameter.getCustomParam("pkid"));
        Long tpv_warehouse = 0L;
        if (MULTIBILL.equals(picktype)) {
            tpv_warehouse = toLong(parameter.getCustomParam("tpv_warehouse"));
        }
        Long org = toLong(parameter.getCustomParam("org"));
        String tpv_inventorytype = parameter.getCustomParam("tpv_inventorytype");
        Long tpv_material = toLong(parameter.getCustomParam("tpv_material"));
        String tpv_specation = parameter.getCustomParam("tpv_specation");
        String tpv_shader = parameter.getCustomParam("tpv_shader");
        Long tpv_origin = toLong(parameter.getCustomParam("tpv_origin"));
        Long tpv_prodname = toLong(parameter.getCustomParam("tpv_prodname"));
        Long tpv_combina = toLong(parameter.getCustomParam("tpv_combina"));
        String panduan = null;

        // 查询是否变更单
        // DynamicObject parentDataEntity =
        // view.getParentView().getModel().getDataEntity(true);
        // IDataEntityType dataEntityType = parentDataEntity.getDataEntityType();
        // String entityNumber = dataEntityType.getName();// 源单标识
        // NewVersionHelper vHelper = new NewVersionHelper(entityNumber);
        // if (vHelper.isChanged()) {
        //
        // }

        model.setValue("tpv_inventorytype_f", tpv_inventorytype);
        if (b) {
            if (tpv_warehouse != 0L) {
                model.setValue("tpv_warehouse_f", tpv_warehouse);
            }
            model.setValue("tpv_specation_f", tpv_specation);
            model.setValue("tpv_shader_f", tpv_shader);
            model.setValue("tpv_origin_f", tpv_origin);
            model.setValue("tpv_prodname_f", tpv_prodname);
            model.setValue("tpv_combination_f", tpv_combina);
        }

        model.deleteEntryData(entryKey_1);
        model.deleteEntryData(entryKey_2);

        DynamicObject dataEntity = model.getDataEntity(true);
        if (StringUtils.equals(picktype, TPV_DT_SALESSHIPPING)) {
            panduan = parameter.getCustomParam("tpv_yesnoinseries");
        }
        String whereFilter = "tpv_qty > 0";
        // 物料
        if (YEM.isNotEmpty(tpv_material)) {
            whereFilter = String.format("%s and tpv_material = %s", whereFilter, tpv_material);
        }
        // 公司
        if (YEM.isNotEmpty(org)) {
            whereFilter = String.format("%s and tpv_org = %s", whereFilter, org);
        }
        if (MULTIBILL.equals(picktype)) {
            Long outdept = toLong(parameter.getCustomParam("outdept"));
            whereFilter = String.format("%s and bizdept = %s", whereFilter, outdept);
        }
        // 组合号
        if (StringUtils.isNotEmpty(panduan)) {
            DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
            if (YEM.isNotEmpty(tpv_combination_f)) {
                whereFilter = String.format("%s and tpv_combination != %s", whereFilter, tpv_combination_f.getPkValue());
            }
        } else {
            DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
            if (YEM.isNotEmpty(tpv_combination_f)) {
                whereFilter = String.format("%s and tpv_combination = %s", whereFilter, tpv_combination_f.getPkValue());
            }
        }
        /*// 组合号
        DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
        if (YEM.isNotEmpty(tpv_combination_f)) {
            whereFilter = String.format("%s and tpv_combination = %s", whereFilter, tpv_combination_f.getPkValue());
        }*/
        // 仓库
        DynamicObject tpv_warehouse_f = dataEntity.getDynamicObject("tpv_warehouse_f");
        if (YEM.isNotEmpty(tpv_warehouse_f)) {
            whereFilter = String.format("%s and tpv_warehouse = %s", whereFilter, tpv_warehouse_f.getPkValue());
        }
        // 库存/直运
        String tpv_inventorytype_f = dataEntity.getString("tpv_inventorytype_f");
        if (YEM.isNotEmpty(tpv_inventorytype_f)) {
            whereFilter = String.format("%s and tpv_inventorytype = '%s'", whereFilter, tpv_inventorytype_f);
        }
        // 品名
        DynamicObject tpv_prodname_f = dataEntity.getDynamicObject("tpv_prodname_f");
        if (YEM.isNotEmpty(tpv_prodname_f)) {
            whereFilter = String.format("%s and tpv_prodname = %s", whereFilter, tpv_prodname_f.getPkValue());
        }
        // 规格
        String tpv_specation_f = dataEntity.getString("tpv_specation_f");
        if (YEM.isNotEmpty(tpv_specation_f)) {
            whereFilter = String.format("%s and tpv_specation like '%s'", whereFilter, tpv_specation_f);
        }
        // 材质
        String tpv_shader_f = dataEntity.getString("tpv_shader_f");
        if (YEM.isNotEmpty(tpv_shader_f)) {
            whereFilter = String.format("%s and tpv_shader like '%s'", whereFilter, tpv_shader_f);
        }
        // 产地
        DynamicObject tpv_origin_f = dataEntity.getDynamicObject("tpv_origin_f");
        if (YEM.isNotEmpty(tpv_origin_f)) {
            whereFilter = String.format("%s and tpv_origin = %s", whereFilter, tpv_origin_f.getPkValue());
        }
        //配货单据为采购入库
        String mes = "im_purinbill";
        if (IM_PURINBILL.equals(picktype)) {
            whereFilter = String.format("%s and tpv_pickbill = '%s'", whereFilter, mes);
            saleId = 0L;
        }
        //LinRui begin
        Long tpv_department = toLong(parameter.getCustomParam("tpv_department"));
        if (null != tpv_department || tpv_department > 0) {
            whereFilter = String.format("%s and tpv_department = '%s'", whereFilter, tpv_department);
        }
        //LingRui end
        DataSet query = PickShipsRptQuery.query(whereFilter, picktype, saleId);

        IFormView parentView = view.getParentView();
        IDataModel parentModel = parentView.getModel();
        String subEnd = "A".equals(tpv_inventorytype_f) ? "_in" : "_zy";
        DynamicObjectCollection subEntry;
        if (TPV_DT_SALESSHIPPING.equals(picktype)) {
            int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_materialentry");
            DynamicObject entryRowEntity = parentModel.getEntryRowEntity("tpv_materialentry", entryCurrentRowIndex);
            subEntry = entryRowEntity.getDynamicObjectCollection("tpv_dt_salepick" + subEnd);
        } else if (TPV_DT_NOCONFIGURATION.equals(picktype)) {
            subEntry = parentModel.getEntryEntity("tpv_sonentryentity");
        } else if (TPV_DT_INVENTORYCONFIGURA.equals(picktype)) {
            int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_entryentity");
            DynamicObject entryRowEntity = parentModel.getEntryRowEntity("tpv_entryentity", entryCurrentRowIndex);
            String tpv_srcentryid = entryRowEntity.getString("tpv_srcentryid");
            long srcentryid = Long.parseLong(tpv_srcentryid);
            QFilter qFilter = new QFilter("tpv_materialentry", QCP.equals, srcentryid);
            String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
            DynamicObject billHead = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
            ;//需查询
            billHead = BusinessDataServiceHelper.loadSingle(billHead.getPkValue(),
                    billHead.getDynamicObjectType().getName());
            DynamicObject rowS = null;
            DynamicObjectCollection objectCollection = billHead.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject dynamicObject : objectCollection) {
                long id = (Long) dynamicObject.get("id");
                if (id == srcentryid) {
                    rowS = dynamicObject;
                }
            }
            subEntry = rowS.getDynamicObjectCollection("tpv_dt_salepick" + subEnd);
        } else if (TPV_DT_RELEVANCEDEALGS.equals(picktype)) {
            subEntry = parentModel.getEntryEntity("tpv_dt_transferdist_ph");
        } else {
            subEntry = parentModel.getEntryEntity("billentry");
        }
        DynamicObjectType enrtyType = model.getEntryEntity(entryKey_1).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            String tpv_pickbill = row.getString("tpv_pickbill");
            long tpv_fentryid = row.getLong("tpv_fentryid");
            long tpv_vid = row.getLong("tpv_vid");
            int index = model.createNewEntryRow(entryKey_1);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
            if (IM_PURINBILL.equals(picktype) || TPV_DT_NOCONFIGURATION.equals(picktype)) {
                continue;
            }
            for (DynamicObject subRow : subEntry) {
                if (TPV_DT_RELEVANCEDEALGS.equals(picktype)) {
                    //关联交易转货单拣配
                    if (tpv_pickbill.equals(subRow.getString("tpv_pickbill"))
                            && tpv_fentryid == subRow.getLong("tpv_fentryids")
                            && tpv_vid == subRow.getLong("tpv_vids")) {
                        model.beginInit();
                        model.setValue("tpv_focus", true, index);
                        model.endInit();
                        view.updateView("tpv_focus", index);
                        pickFocus(index, subRow.getBigDecimal("tpv_pickqty"));
                    }
                } else {
                    if (tpv_pickbill.equals(subRow.getString("tpv_pickbill" + subEnd))
                            && tpv_fentryid == subRow.getLong("tpv_fentryid" + subEnd)
                            && tpv_vid == subRow.getLong("tpv_vid" + subEnd)) {
                        model.beginInit();
                        model.setValue("tpv_focus", true, index);
                        model.endInit();
                        view.updateView("tpv_focus", index);
                        if (TPV_DT_INVENTORYCONFIGURA.equals(picktype) || TPV_DT_NOCONFIGURATION.equals(picktype)) {
                            pickFocus(index, subRow.getBigDecimal(TPV_DT_INVENTORYCONFIGURA.equals(picktype) ? "tpv_pickqty" + subEnd : "tpv_pickqty_in"));
                        } else {
                            pickFocus(index, subRow.getBigDecimal(TPV_DT_SALESSHIPPING.equals(picktype) ? "tpv_pickqty" + subEnd : "qty"));
                        }
                    }
                }
            }
        }
    }

    public Long toLong(Object longObj) {
        if (longObj == null) {
            return null;
        } else if (longObj instanceof Long) {
            return (Long) longObj;
        } else {
            return Long.valueOf(String.valueOf(longObj));
        }
    }

}
