package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.form.operate.botp.Push;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.permission.api.HasPermOrgResult;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import tpv.tpv_wm.tpv_dt.java.report.PurPriceRptQuery;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.util.*;
import java.util.stream.Collectors;

/**
 * 采购价格确认工作台-表单插件
 * @description
 * @author GX
 */
public class PurPriceDeskEdit extends AbstractFormPlugin implements HyperLinkClickListener{
	
	@Override
	public void afterCreateNewData(EventObject e) {
		super.afterCreateNewData(e);
		initData();
	}
	
	/**
     * @param e
     * 注册按钮
     */
	@Override
	public void registerListener(EventObject e) {
		super.registerListener(e);
		this.addClickListeners(new String[] { "tpv_inquire", "tpv_priceconfirmbill" });
		EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");
        entryGrid.addHyperClickListener(this);
	}
	
	@Override
	public void click(EventObject evt) {
		super.click(evt);
		String key = ((Control) evt.getSource()).getKey();
		switch (key) {
		case "tpv_inquire":
			initData();
			break;
		case "tpv_priceconfirmbill":
			pushBill();
			break;
		default:
			break;
		}
	}
	
	/**
	 * 下推销售价格确认单
	 */
	private void pushBill() {
		IFormView view = this.getView();
		IDataModel model = this.getModel();
		EntryGrid entry = view.getControl("tpv_entryentity");
		int[] selectRows = entry.getSelectRows();
		if (selectRows.length == 0) {
			view.showTipNotification("未选择数据。");
			return;
		}
		String tpv_source = "";
		Map<String, DynamicObject> map = new HashMap<>();
		Map<String, DynamicObject> map1 = new HashMap<>();
		for (int i : selectRows) {
			DynamicObject entryRowEntity = model.getEntryRowEntity("tpv_entryentity", i);//1777602861132177409
			tpv_source = entryRowEntity.getString("tpv_source");// 来源单据
			Long tpv_srcentryid=entryRowEntity.getLong("tpv_srcentryid");//单据分录id1797870881377123328   1797870881377123329
			String tpv_mainbillid = entryRowEntity.getString("tpv_billno");// 合同号
			map1.put(tpv_source + tpv_mainbillid, entryRowEntity);
			map.put(tpv_source+tpv_srcentryid, entryRowEntity);
		}
		if (map1.size() > 1) {
			view.showTipNotification("来源或合同号不同，无法进行价格确认。");
			return;
		}
		String sourceEntityNumber = "";
		String targetEntityNumber = "";
		String ruleId = "";
		switch (tpv_source) {
		case "A"://采购合同下推货物流转确认单
			sourceEntityNumber = "tpv_dt_purchase";
			targetEntityNumber = "tpv_dt_freigroambill";
			ruleId = "1774814860857598976";
			break;
		case "B"://货物流转下推货物流转确认单
			sourceEntityNumber = "tpv_dt_freigroambill";
			targetEntityNumber = "tpv_dt_freigroambill";
			ruleId = "1775438734511059968";
			break;
		case "C"://采购入库下推货物流转确认单
			sourceEntityNumber = "im_purinbill";
			targetEntityNumber = "tpv_dt_freigroambill";
			ruleId = "1775455429728416768";
			break;
//		case "D":
//			view.showTipNotification("来源为货物流转价格确认，无法操作。");
//			return;
		default:
			break;
		}
		List<ListSelectedRow> selectedRows = new ArrayList<>();
		for (DynamicObject row : map.values()) {
			ListSelectedRow listSelectedRow = new ListSelectedRow(row.getLong("tpv_srcbillid"));//来源单据ID
			if("C".equals(row.get("tpv_source"))) {
				listSelectedRow.setEntryEntityKey("billentry");
				listSelectedRow.setEntryPrimaryKeyValue(row.getLong("tpv_srcentryid"));//来源单据分录ID
			}else {
				listSelectedRow.setEntryEntityKey("tpv_materialentry");
				listSelectedRow.setEntryPrimaryKeyValue(row.getLong("tpv_srcentryid"));//来源单据分录ID
			}
			selectedRows.add(listSelectedRow);
		}
		PushArgs pushArgs = new PushArgs();
		pushArgs.setSourceEntityNumber(sourceEntityNumber); // 必选，源单标识
		pushArgs.setTargetEntityNumber(targetEntityNumber); // 必选，目标单标识
		// pushArgs.setHasRight(false); // 可选，传入true，不检查目标单新增权
		// pushArgs.setAppId("pur"); // 可选，传入目标单验权使用的应用编码
		// pushArgs.setAutoSave(false);//是否保存
		pushArgs.setRuleId(ruleId); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
		pushArgs.setBuildConvReport(true); // 是否输出详细错误报告
		pushArgs.setSelectedRows(selectedRows); // 必选，设置需要下推的源单及分录内码
		ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
		if (pushResult.isSuccess()) {
			Push.showTargetBill(view, pushArgs, pushResult, false);
		} else {
			Push.showReport(view, pushArgs, pushResult);
		}
	}
	
	/**
	 * 加载数据
	 */
	private void initData() {
		IDataModel model = this.getModel();
		DynamicObject dataEntity = model.getDataEntity(true);
		String whereFilter = "1=1";
		String tpv_sources=dataEntity.getString("tpv_sources");//来源
		if (YEM.isNotEmpty(tpv_sources)) {
			whereFilter = String.format("%s and tpv_source = '%s'", whereFilter, tpv_sources);
		}
		String tpv_srcbillnos=dataEntity.getString("tpv_srcbillnos");//来源单据编号
		if (YEM.isNotEmpty(tpv_srcbillnos)) {
			whereFilter = String.format("%s and tpv_srcbillno like %s", whereFilter, "'%" + tpv_srcbillnos + "%'");
		}
		String tpv_billnos=dataEntity.getString("tpv_billnos");//合同号
		if (YEM.isNotEmpty(tpv_billnos)) {
			whereFilter = String.format("%s and tpv_billno like %s", whereFilter, "'%" + tpv_billnos+ "%'");
		}
		DynamicObject tpv_customers=dataEntity.getDynamicObject("tpv_customers");//客户
		if (YEM.isNotEmpty(tpv_customers)) {
			whereFilter = String.format("%s and tpv_customer = %s", whereFilter, tpv_customers.getPkValue());
		}
		String whereStr = PersonnelDepUtils.createWhereStrForm(model, "tpv_muldepartment", "tpv_department");
		if (!"".equals(whereStr)){
			whereFilter=String.format("%s%s", whereFilter, whereStr);
		}
		DynamicObject tpv_departments=dataEntity.getDynamicObject("tpv_departments");//部门
		if (YEM.isNotEmpty(tpv_departments)) {
			whereFilter = String.format("%s and tpv_department = %s", whereFilter, tpv_departments.getPkValue());
		}
		String tpv_priceconfirms=dataEntity.getString("tpv_priceconfirms");//价格确认
		if (YEM.isNotEmpty(tpv_priceconfirms)) {
			whereFilter = String.format("%s and tpv_priceconfirm = %s", whereFilter, tpv_priceconfirms);
		}
		// 公司
		DynamicObject tpv_orgs = dataEntity.getDynamicObject("tpv_orgs");
		if (YEM.isNotEmpty(tpv_orgs)) {
			whereFilter = String.format("%s and tpv_org = %s", whereFilter, tpv_orgs.getPkValue());
		} else {
			HasPermOrgResult userChangeAbleOrg = YEM.getUserChangeAbleOrg();
			if (!userChangeAbleOrg.hasAllOrgPerm()) {
				List<String> ids = YEM.getUserChangeAbleOrgIds().stream().map(x -> String.valueOf(x))
						.collect(Collectors.toList());
				whereFilter = String.format("%s and tpv_org in (%s)", whereFilter, String.join(",", ids));
			}
		}
		// 组合号
		DynamicObject tpv_combinationnumbers = dataEntity.getDynamicObject("tpv_combinationnumbers");
		if (YEM.isNotEmpty(tpv_combinationnumbers)) {
			whereFilter = String.format("%s and tpv_combinationnumber = %s", whereFilter, tpv_combinationnumbers.getPkValue());
		}
		model.deleteEntryData("tpv_entryentity");
		DataSet query = PurPriceRptQuery.query(whereFilter);
		DynamicObjectType enrtyType = model.getEntryEntity("tpv_entryentity").getDynamicObjectType();
		DataEntityPropertyCollection properties = enrtyType.getProperties();
		List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
		for (Row row : query) {
			int index = model.createNewEntryRow("tpv_entryentity");
			for (IDataEntityProperty property : properties) {
				String key = property.getName();
				if (dataSetAliasList.contains(key)) {	
						model.setValue(key, row.get(key), index);
				}
			}
		}
	}
	


	@Override
	public void hyperLinkClick(HyperLinkClickEvent e) {
		// TODO Auto-generated method stub
		if ("tpv_billno".equals(e.getFieldName())){
			int index=e.getRowIndex();
			String billno =(String)this.getModel().getValue("tpv_billno",index);
	        DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", "id",
	                new QFilter[]{new QFilter("tpv_contractnumber", QCP.equals, billno)});
	        //跳转到指定单
			if(loadSingle!=null){
				BillShowParameter showParameter = new BillShowParameter();
				showParameter.setFormId("tpv_dt_purchase");
				showParameter.setPkId(loadSingle.getPkValue());
				showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
				showParameter.setStatus(OperationStatus.VIEW);
				this.getView().showForm(showParameter);
			}
        }
		//LinRui begin
		if ("tpv_srcbillno".equals(e.getFieldName())) {
			int index=e.getRowIndex();
			String tpv_source = (String) this.getModel().getValue("tpv_source", index);
			String tpv_srcbillKey = "";
			switch (tpv_source) {
				case "A":
					tpv_srcbillKey = "tpv_dt_purchase";
					break;
				case "B":
					tpv_srcbillKey = "tpv_dt_freigroambill";
					break;
				case "C":
					tpv_srcbillKey = "im_purinbill";
					break;
			}
			Object tpv_srcbillid = this.getModel().getValue("tpv_srcbillid");
			showBill(tpv_srcbillKey, tpv_srcbillid);
		}
		//LinRui end
	}
	//LinRui begin
	private void showBill(String formkey, Object formid) {
		if (YEM.isNotEmpty(formkey) || YEM.isNotEmpty(formid)) {
			BillShowParameter showParameter = new BillShowParameter();
			showParameter.setFormId(formkey);
			showParameter.setPkId(formid);
			showParameter.setStatus(OperationStatus.VIEW);
			showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
			this.getView().showForm(showParameter);
		}
	}
}
