package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.itopview.wm.dt.report.PracticalRptQuery;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.earlywarn.kit.StringUtil;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;


/**
 * 直运实提工作台-表单插件
 *
 * @author WangShuGuang
 * @description
 * @date 2023年9月16日
 */
public class PutForwardEdit extends AbstractFormPlugin implements RowClickEventListener, HyperLinkClickListener {

    private static final String entryKey_1 = "tpv_entryentity";


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");//商品明细
        entryGrid.addHyperClickListener(this);
        this.addItemClickListeners("tpv_batchsales");
        this.addClickListeners("tpv_selects");
//        this.addClickListeners("tpv_batchsalesbtn");
//        this.addClickListeners("tpv_batchorderbtn");
        entryGrid.addRowClickListener(this);
    }

    @Override
    public void hyperLinkClick(HyperLinkClickEvent e) {
        // TODO Auto-generated method stub
        int index = e.getRowIndex();
        if ("tpv_shipments".equals(e.getFieldName())) {
            //发货单号
            String tpvFatherpickbill = "tpv_dt_salesshipping";//销售发货
            String tpvBillnos = (String) this.getModel().getValue("tpv_shipments", index);//发货单号
            DynamicObject random = BusinessDataServiceHelper.loadSingle(tpvFatherpickbill, "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvBillnos)});
            if (null != random) {
                skipMethod(tpvFatherpickbill, random.getPkValue());
            }
        }
        if ("tpv_market".equals(e.getFieldName())) {
            //销售合同号
            String tpvSonbill = "tpv_dt_salescontract";//销售合同
            String tpvSonbillnos = (String) this.getModel().getValue("tpv_market", index);//销售合同号
            DynamicObject random = BusinessDataServiceHelper.loadSingle(tpvSonbill, "id",
                    new QFilter[]{new QFilter("tpv_contractnos", QCP.equals, tpvSonbillnos)});
            if (null != random) {
                skipMethod(tpvSonbill, random.getPkValue());
            }
        }
        if ("tpv_billno_zy".equals(e.getFieldName())) {
            //单据编号
            String tpvGodownentry = (String) this.getModel().getValue("tpv_billno_zy", index);//单据编号
            String tpvPickbillZy = (String) this.getModel().getValue("tpv_pickbill_zy", index);//配货单据
            DynamicObject im_Purinbill = BusinessDataServiceHelper.loadSingle(tpvPickbillZy, "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvGodownentry)});
            if (null != im_Purinbill) {
                skipMethod(tpvPickbillZy, im_Purinbill.getPkValue());
            }
        }
        if("tpv_contract".equals(e.getFieldName())){
            //单据编号
            String tpvGodownentry = (String) this.getModel().getValue("tpv_billno_zy", index);//单据编号
            String tpvPickbillZy = (String) this.getModel().getValue("tpv_pickbill_zy", index);//配货单据
            DynamicObject im_Purinbill = BusinessDataServiceHelper.loadSingle(tpvPickbillZy, "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvGodownentry)});
            if (null != im_Purinbill) {
                skipMethod(tpvPickbillZy, im_Purinbill.getPkValue());
            }
        }
    }

    public void skipMethod(String formId, Object object) {
        BillShowParameter showParameter = new BillShowParameter();
        showParameter.setFormId(formId);
        showParameter.setPkId(object);
        showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
        showParameter.setStatus(OperationStatus.VIEW);
        this.getView().showForm(showParameter);
    }

    /**
     * 实提完毕后反写销售发货单数量字段
     *
     * @param e
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        // TODO Auto-generated method stub
        super.propertyChanged(e);
        String propertyName = e.getProperty().getName();
        int index = this.getModel().getEntryCurrentRowIndex("");
        //监听实提完毕
        if (propertyName.equals("tpv_realsubmit")) {
            OperateOption option = YEM.getOption();
            //获取单据体控件
            EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");
            //获取选中行，数组为行号，从0开始int[]
            int selectRows[] = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                //拿到当前直运分录id
                String tpv_srcentryid = (String) this.getModel().getValue("tpv_srcentryid", selectRow);
                String tpv_sourceid = (String) this.getModel().getValue("tpv_sourceid", selectRow);
                long number = Long.parseLong(tpv_srcentryid);
                long numberTpvSourceid = Long.parseLong(tpv_sourceid);
                //拿到工作台上的数量字段
//                BigDecimal tpv_qty = (BigDecimal) this.getModel().getValue("tpv_qty", selectRow);
                String selectfields = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_blendingepibenthic", "tpv_sonentryentity");
                //用id查询底表
                DynamicObject tpv_dt_blendingepibenthic = BusinessDataServiceHelper.loadSingle("tpv_dt_blendingepibenthic", selectfields,
                        new QFilter("id", QCP.equals, numberTpvSourceid).toArray());
                //用id查询销售发货单数据
                String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
                DynamicObject tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter("tpv_materialentry", QCP.equals, number).toArray());
            /*DynamicObject tpv_dt_salesshipping = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", "id,tpv_materialentry,tpv_dt_salepick_in,tpv_qty,billno",
                    new QFilter("tpv_materialentry", QCP.equals, number).toArray());*/
                //拿到底表分录数据
                if (null != tpv_dt_blendingepibenthic) {
                    BigDecimal tpv_qty = tpv_dt_blendingepibenthic.getBigDecimal("tpv_pickqty_zy");
                    DynamicObjectCollection tpv_sonentryentity = tpv_dt_blendingepibenthic.getDynamicObjectCollection("tpv_sonentryentity");
                    if (tpv_sonentryentity.size() > 0) {
                        BigDecimal qty = BigDecimal.ZERO;
                        for (DynamicObject dynamicObject : tpv_sonentryentity) {
                            //计算底表分录销提数量之和
                            boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                            if (tpvDestroysure) {
                                qty = qty.add(dynamicObject.getBigDecimal("tpv_destroyquantity"));
                            }
                        }

                        if (tpv_qty.compareTo(BigDecimal.ZERO) != 0 && qty.compareTo(tpv_qty) >= 0) {
                            //反写逻辑是：先将直运底表分录中销提确认的数量累加，用源销售发货单直运子分录本次数量减去工作台上方分录行数量，再加上累计数量，与源子分录数量的差值计算到商品父分录
                            tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle(tpvScBusinessnatures.getPkValue(),
                                    tpvScBusinessnatures.getDynamicObjectType().getName());
                            DynamicObjectCollection tpv_materialentry = tpvScBusinessnatures.getDynamicObjectCollection("tpv_materialentry");
                            for (DynamicObject dynamicObject : tpv_materialentry) {
                                long id = (Long) dynamicObject.getPkValue();
                                if (id == number) {
                                    BigDecimal sumqty = BigDecimal.ZERO;
                                    DynamicObjectCollection dynamicObjects = dynamicObject.getDynamicObjectCollection("tpv_dt_salepick_zy");
                                    for (DynamicObject object : dynamicObjects) {
                                        long pkValue = (Long) object.getPkValue();
                                        //拿到销售发货单原本直运子分录数量
                                        BigDecimal tpvDestroyquantity = object.getBigDecimal("tpv_pickqty_zy");
                                        if (pkValue == numberTpvSourceid) {
                                            //用原本数量减去直运工作台数量
                                            BigDecimal subtractTpvQty = tpvDestroyquantity.subtract(tpv_qty);
                                            //用减去的数量加上底表销提数量合集在插入销售发货单
                                            BigDecimal addNumbers = subtractTpvQty.add(qty);
                                            object.set("tpv_pickqty_zy", addNumbers);
                                            sumqty = sumqty.add(addNumbers);
                                        } else {
                                            sumqty = sumqty.add(tpvDestroyquantity);
                                        }
                                    }
                                    dynamicObject.set("tpv_qty", sumqty);
                                    SaveServiceHelper.update(dynamicObject);// 写入数据库
                                }
                            }
                            //调销售发货单保存方法
                            OperationResult saveT = OperationServiceHelper.executeOperate("save", "tpv_dt_salesshipping",
                                    new DynamicObject[]{tpvScBusinessnatures}, option);
                        }
                    }
                }
            }
            if (selectRows.length == 1) {
                embedded(selectRows);
            }
        }
    }

    /**
     * 修改父分录选择行数据：采提数量、销提数量、已出库数量、未出库数量
     * */
    private void updateParentEntryRowData() {
        IFormView view = this.getView();
        int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
        String tpv_zySubEntryid =  (String) view.getModel().getValue("tpv_sourceid", tpvEntryentity);
        if (YEM.isNotEmpty(tpv_zySubEntryid)) {
            String whereFilter = "1 = 1";
            whereFilter = String.format("%s and tpv_sourceid = %s", whereFilter, Long.valueOf(tpv_zySubEntryid));
            DataSet query = PracticalRptQuery.query(whereFilter);
            DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(query);
            //根据销售发货库存拣配直运子分录的id查询
            for (DynamicObject dynamicObject : dynamicObjects) {
                view.getModel().setValue("tpv_qty", dynamicObject.getBigDecimal("tpv_qty"), tpvEntryentity);
                view.getModel().setValue("tpv_destroyquantitysum", dynamicObject.getBigDecimal("tpv_destroyquantitysum"), tpvEntryentity);
                view.getModel().setValue("tpv_purchasequantitysum", dynamicObject.getBigDecimal("tpv_purchasequantitysum"), tpvEntryentity);
                view.getModel().setValue("tpv_issuedquantitys", dynamicObject.getBigDecimal("tpv_issuedquantitys"), tpvEntryentity);
                view.getModel().setValue("tpv_unissuedquanti", dynamicObject.getBigDecimal("tpv_unissuedquanti"), tpvEntryentity);
                break;
            }
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        initData();
        showFlexpanelap();
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        EntryGrid entryGrid = (EntryGrid) evt.getSource();
        if (StringUtils.equals("tpv_entryentity", entryGrid.getKey())) {
            EntryGrid tpvEntryentity = this.getControl("tpv_entryentity");
            int[] selectRows = tpvEntryentity.getSelectRows();//获取选中的行号
            if (selectRows.length > 0 & selectRows.length == 1) {
                embedded(selectRows);
            } else {
                showFlexpanelap();
            }
        }
    }

    public void embedded(int[] selectRows) {
        int tpvEntryentity = selectRows[0];
        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_entryentity");//商品明细
        if (entity.size() > 0) {
            updateParentEntryRowData(); //实提下方分录改值后重新查库，选中单行直运上方分录

            DynamicObject dynamicObject = entity.get(tpvEntryentity);//数据
            BillShowParameter showParameter = new BillShowParameter();
            showParameter.setCustomParam("tpv_sourceid", dynamicObject.getString("tpv_sourceid"));
            showParameter.setCustomParam("tpv_realsubmit", dynamicObject.getBoolean("tpv_realsubmit")); //实提完毕
            showParameter.setCustomParam("tpv_isautoinsales", dynamicObject.getBoolean("tpv_isautoinsales")); //自动带入销提
            showParameter.setCustomParam("tpv_isautoinorder", dynamicObject.getBoolean("tpv_isautoinorder")); //自动带入采提
            BigDecimal tpv_qty = dynamicObject.getBigDecimal("tpv_qty") != null
                    ? dynamicObject.getBigDecimal("tpv_qty") : BigDecimal.ZERO;
            showParameter.setCustomParam("tpv_qty", tpv_qty); //数量
            BigDecimal tpv_packnum = dynamicObject.getBigDecimal("tpv_packnum") != null
                    ? dynamicObject.getBigDecimal("tpv_packnum") : BigDecimal.ZERO;
            showParameter.setCustomParam("tpv_packnum", tpv_packnum); //包装数量
            showParameter.setStatus(OperationStatus.EDIT);
            showParameter.getOpenStyle().setShowType(ShowType.InContainer);
            //容器表示
            showParameter.getOpenStyle().setTargetKey("tpv_flexpanelap");
            showParameter.setSendToClient(true);
            //单据标识
            showParameter.setFormId("tpv_dt_blendingepibenthic");
            //主键
            showParameter.setPkId(dynamicObject.getLong("tpv_sourceid"));
            this.getView().showForm(showParameter);
        }
    }

    //打开内嵌页面
    private void showFlexpanelap() {
        BillShowParameter showParameter = new BillShowParameter();
        showParameter.setStatus(OperationStatus.VIEW);
        showParameter.getOpenStyle().setShowType(ShowType.InContainer);
        //容器表示
        showParameter.getOpenStyle().setTargetKey("tpv_flexpanelap");
        showParameter.setSendToClient(true);
        //单据标识
        showParameter.setFormId("tpv_dt_blendingepibenthic");
        //主键
//        DynamicObject newCostdispose = BusinessDataServiceHelper.newDynamicObject("tpv_dt_blendingepibenthic");
        showParameter.setPkId(null);
        this.getView().showForm(showParameter);
    }

    /**
     * 加载数据
     */
    private void initData() {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        String whereFilter = "1=1";
        model.deleteEntryData(entryKey_1);
        //库存为直运
        String tpv_filternumber = dataEntity.getString("tpv_filternumber");//单据编号
        String tpv_marketnumber = dataEntity.getString("tpv_marketnumber");//销售合同号
        Boolean tpv_practical = dataEntity.getBoolean("tpv_practical");//实提完毕
        String tpv_blending = dataEntity.getString("tpv_blending");//是否免拣配
        DynamicObject tpvCustomerup = dataEntity.getDynamicObject("tpv_customerup");//客户
        if (StringUtil.isNotEmpty(tpv_filternumber)) {
            whereFilter = String.format("%s and tpv_shipments like %s", whereFilter, "'%" + tpv_filternumber + "%'");
        }
        if (StringUtil.isNotEmpty(tpv_marketnumber)) {
            whereFilter = String.format("%s and tpv_market like %s", whereFilter, "'%" + tpv_marketnumber + "%'");
        }
        if (null != tpvCustomerup) {
            long id = tpvCustomerup.getLong("id");
            whereFilter = String.format("%s and tpv_customer = %s", whereFilter, id);
        }
        if (tpv_practical) {
            whereFilter = String.format("%s and tpv_realsubmit = %s", whereFilter, false);
        }
        if (StringUtil.isNotEmpty(tpv_blending)) {
            if (tpv_blending.equals("A")) {
                whereFilter = String.format("%s and tpv_nopicking = %s", whereFilter, true);
            } else {
                whereFilter = String.format("%s and tpv_nopicking = %s", whereFilter, false);
            }
        }
        String whereStrForm = PersonnelDepUtils.createWhereStrForm(model, "tpv_muldepartment", "tpv_department");
        if (!"".equals(whereStrForm)){
            whereFilter=String.format("%s%s", whereFilter, whereStrForm);
        }
        whereFilter = String.format("%s and tpv_inventorytype = %s", whereFilter, "'B'");
        whereFilter = String.format("%s and tpv_sourceid != %s", whereFilter, 0);
        DataSet query = PracticalRptQuery.query(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity(entryKey_1).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow(entryKey_1);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        //
        super.itemClick(evt);
        String key = evt.getItemKey();
        //监听物流确认采购实提按钮
        if (StringUtils.equals("tpv_practicalok", key)) {
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");
            int[] selectRows = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                DynamicObjectCollection tpvEntryentity = this.getModel().getEntryEntity("tpv_entryentity");
                DynamicObject dynamicObject = tpvEntryentity.get(selectRow);
                long tpvSourceid = dynamicObject.getLong("tpv_sourceid");
                QFilter qFilter = new QFilter("id", "=", tpvSourceid);
                DynamicObject[] cdmreceivablebill = null;
                cdmreceivablebill = BusinessDataServiceHelper.load("tpv_dt_blendingepibenthic", "id,tpv_practicalok_zy", new QFilter[]{qFilter}, null);
                for (DynamicObject object : cdmreceivablebill) {
                    object.set("tpv_practicalok_zy", true);
                    SaveServiceHelper.update(object);//写入数据库
                    this.getModel().setValue("tpv_realsubmit", true, selectRow);
                }
                //initData();
            }
        }
        if (StringUtils.equals("tpv_select", key)) {
            initData();
            showFlexpanelap();
        }
        if (StringUtils.equals("tpv_batchorderbtn", key)) {//批量确认采提
            batchValidation("tpv_batchorderbtn","tpv_purchasequantity", "tpv_purchasesuer", "【采购数量】", "批量确认采提成功！");
        }
        if (StringUtils.equals("tpv_batchsalesbtn", key)) {//批量确认销提
            batchValidation("tpv_batchsalesbtn","tpv_destroyquantity", "tpv_destroysure", "【销提数量】", "批量确认销提成功！");
        }
    }

    private void batchValidation(String key,String realsubmitqty, String tpv_destroysure, String qtyfield, String message) {
        // 获取单据体选中行
        EntryGrid entryGrid = this.getView().getControl("tpv_entryentity");
        int[] selectRows = entryGrid.getSelectRows();
        List<String> rowsNoPass = new ArrayList<>();
        List<String> keyPass = new ArrayList<>();
        for (int selectRow : selectRows) {
            DynamicObjectCollection tpvEntryentity = this.getModel().getEntryEntity("tpv_entryentity");
            DynamicObject dynamicObject = tpvEntryentity.get(selectRow);
            String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_blendingepibenthic", "tpv_sonentryentity");
            long tpvSourceid = dynamicObject.getLong("tpv_sourceid");
            QFilter qFilter = new QFilter("id", "=", tpvSourceid);
            DynamicObject[] cdmreceivablebill = BusinessDataServiceHelper.load("tpv_dt_blendingepibenthic",
                    selectfieldsFast, new QFilter[]{qFilter}, null);
            for (DynamicObject object : cdmreceivablebill) {
                DynamicObjectCollection tpvSonentryentity = object.getDynamicObjectCollection("tpv_sonentryentity");
                for (DynamicObject dynamic : tpvSonentryentity) {
                    BigDecimal quantity = dynamic.getBigDecimal(realsubmitqty);
                    boolean tpvPurchasesuer = dynamic.getBoolean("tpv_purchasesuer");//采提确认
                    boolean tpvDestroysure = dynamic.getBoolean("tpv_destroysure");//销提确认
                    if (tpvPurchasesuer &&"tpv_batchorderbtn".equals(key)){
                        keyPass.add(String.valueOf(selectRow + 1));
                    } else if (tpvDestroysure &&"tpv_batchsalesbtn".equals(key)) {
                        keyPass.add(String.valueOf(selectRow + 1));
                    }
                    if (quantity.compareTo(BigDecimal.ZERO) == 0) {

                        if (!rowsNoPass.contains(String.valueOf(selectRow + 1))) {
                            rowsNoPass.add(String.valueOf(selectRow + 1));
                        }
                    }
                }
            }
        }

        if (rowsNoPass.size() > 0 ||keyPass.size() > 0) {
            if (rowsNoPass.size() > 0){
                this.getView().showTipNotification("第" + String.join("、", rowsNoPass) + "行，存在对应子分录" + qtyfield + "未填写！");
            }
            if (keyPass.size() > 0){
                this.getView().showTipNotification("第" + String.join("、", keyPass) + "行，对应子分录存在已确认实提！");
            }
        } else {
            for (int selectRow : selectRows) {
                DynamicObjectCollection tpvEntryentity = this.getModel().getEntryEntity("tpv_entryentity");
                DynamicObject dynamicObject = tpvEntryentity.get(selectRow);
                String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_blendingepibenthic", "tpv_sonentryentity");
                long tpvSourceid = dynamicObject.getLong("tpv_sourceid");
                QFilter qFilter = new QFilter("id", "=", tpvSourceid);
                DynamicObject[] cdmreceivablebill = BusinessDataServiceHelper.load("tpv_dt_blendingepibenthic",
                        selectfieldsFast, new QFilter[]{qFilter}, null);
                for (DynamicObject object : cdmreceivablebill) {
                    DynamicObjectCollection tpvSonentryentity = object.getDynamicObjectCollection("tpv_sonentryentity");
                    for (DynamicObject dynamic : tpvSonentryentity) {
                        dynamic.set(tpv_destroysure, true);
                    }
                }
                SaveServiceHelper.update(cdmreceivablebill);//写入数据库
            }
            if (selectRows.length == 1) {
                embedded(selectRows);
            }
            this.getView().showSuccessNotification(message);
        }
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control source = (Control) evt.getSource();
        // 点击确认按钮
        if (StringUtils.equals(source.getKey(), "tpv_selects")) {
            initData();
            showFlexpanelap();
        }
    }
}
