package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.form.operate.botp.Push;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.permission.api.HasPermOrgResult;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import tpv.tpv_wm.tpv_dt.java.report.SalePriceRptQuery;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 销售价格确认工作台-表单插件
 *
 * @author longh
 * @description
 * @date 2023年9月4日
 */
public class SalePriceDeskEdit extends AbstractFormPlugin implements HyperLinkClickListener {
    private static final String entryKey_1 = "tpv_entryentity";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"tpv_query", "tpv_push"});
        EntryGrid grid = (EntryGrid) this.getControl(entryKey_1);
        grid.addHyperClickListener(this);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        initData();
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "tpv_push":
                pushBill();
                break;
            case "tpv_query":
                initData();
                break;
            default:
                break;
        }
    }

    /**
     * 下推销售价格确认单
     */
    private void pushBill() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        EntryGrid entry = view.getControl(entryKey_1);
        int[] selectRows = entry.getSelectRows();
        if (selectRows.length == 0) {
            view.showTipNotification("未选择数据。");
            return;
        }
        String tpv_srcbill = "";
        Map<String, DynamicObject> map = new HashMap<>();
        Map<String, DynamicObject> mapc = new HashMap<>();
        for (int i : selectRows) {
            DynamicObject entryRowEntity = model.getEntryRowEntity(entryKey_1, i);
            tpv_srcbill = entryRowEntity.getString("tpv_srcbill");// 来源
            long tpv_mainbillid = entryRowEntity.getLong("tpv_mainbillid");// 销售合同ID
            long tpv_srcentryid = entryRowEntity.getLong("tpv_srcentryid");// 来源单据分录ID
            long tpv_srcsubid = entryRowEntity.getLong("tpv_srcsubid");// 来源单据子分录ID
            map.put(tpv_srcbill + tpv_mainbillid, entryRowEntity);
            mapc.put(tpv_srcbill + tpv_mainbillid + tpv_srcentryid + tpv_srcsubid, entryRowEntity);
        }
        if (map.size() > 1) {
            view.showTipNotification("来源或合同号不同，无法进行价格确认。");
            return;
        }
        String sourceEntityNumber = "";
        String targetEntityNumber = "";
        String ruleId = "";
        switch (tpv_srcbill) {
            case "A":
                sourceEntityNumber = "tpv_dt_salescontract";
                targetEntityNumber = "tpv_dt_salepricebill";
                ruleId = "1771833177053120512";
                break;
            case "B":
                sourceEntityNumber = "tpv_dt_salesshipping";
                targetEntityNumber = "tpv_dt_salepricebill";
                ruleId = "1774711593821588480";
                break;
            case "C":
                sourceEntityNumber = "tpv_dt_salesshipping";
                targetEntityNumber = "tpv_dt_salepricebill";
                ruleId = "1774712644008200192";
                break;
            case "D":
                view.showTipNotification("来源为销售价格确认，无法操作。");
                return;
            default:
                break;
        }
        List<ListSelectedRow> selectedRows = new ArrayList<>();
        Map<Long, String> mapPurCon = new HashMap<>();
        for (DynamicObject row : mapc.values()) {
            ListSelectedRow listSelectedRow = new ListSelectedRow(row.getLong("tpv_srcbillid"));
            listSelectedRow.setEntryEntityKey("tpv_materialentry");
            listSelectedRow.setEntryPrimaryKeyValue(row.getLong("tpv_srcentryid"));
            mapPurCon.put((Long) row.getLong("tpv_srcentryid"), (String) row.getString("tpv_purbillno"));
            if ("C".equals(tpv_srcbill)) {
                listSelectedRow.setSubEntryEntityKey("tpv_dt_salepick_in");
                listSelectedRow.setSubEntryPrimaryKeyValue(row.getLong("tpv_srcsubid"));
                mapPurCon.put((Long) row.getLong("tpv_srcsubid"), (String) row.getString("tpv_purbillno"));
            }
            selectedRows.add(listSelectedRow);
        }
        PushArgs pushArgs = new PushArgs();
        pushArgs.setSourceEntityNumber(sourceEntityNumber); // 必选，源单标识
        pushArgs.setTargetEntityNumber(targetEntityNumber); // 必选，目标单标识
        pushArgs.addCustomParam("longList", JSONObject.toJSONString(mapPurCon)); //传工作台选中行数据
        // pushArgs.setHasRight(false); // 可选，传入true，不检查目标单新增权
        // pushArgs.setAppId("pur"); // 可选，传入目标单验权使用的应用编码
        // pushArgs.setAutoSave(false);//是否保存
        pushArgs.setRuleId(ruleId); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
        pushArgs.setBuildConvReport(true); // 是否输出详细错误报告
        pushArgs.setSelectedRows(selectedRows); // 必选，设置需要下推的源单及分录内码
        ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
        if (pushResult.isSuccess()) {
            Push.showTargetBill(view, pushArgs, pushResult, false);
        } else {
            Push.showReport(view, pushArgs, pushResult);
        }
    }

    /**
     * 加载数据
     */
    private void initData() {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        String whereFilter = "1=1";
        // 公司
        DynamicObject tpv_org_f = dataEntity.getDynamicObject("tpv_org_f");
        if (YEM.isNotEmpty(tpv_org_f)) {
            whereFilter = String.format("%s and tpv_org = %s", whereFilter, tpv_org_f.getPkValue());
        } else {
            HasPermOrgResult userChangeAbleOrg = YEM.getUserChangeAbleOrg();
            if (!userChangeAbleOrg.hasAllOrgPerm()) {
                List<String> ids = YEM.getUserChangeAbleOrgIds().stream().map(x -> String.valueOf(x))
                        .collect(Collectors.toList());
                whereFilter = String.format("%s and tpv_org in (%s)", whereFilter, String.join(",", ids));
            }
        }
        // 组合号
        DynamicObject tpv_combination_f = dataEntity.getDynamicObject("tpv_combination_f");
        if (YEM.isNotEmpty(tpv_combination_f)) {
            whereFilter = String.format("%s and tpv_combination = %s", whereFilter, tpv_combination_f.getPkValue());
        }
        // 来源单据
        String tpv_srcbill_f = dataEntity.getString("tpv_srcbill_f");
        if (YEM.isNotEmpty(tpv_srcbill_f)) {
            whereFilter = String.format("%s and tpv_srcbill like '%%%s%%'", whereFilter, tpv_srcbill_f);
        }
        // 来源单据号
        String tpv_srcbillno_f = dataEntity.getString("tpv_srcbillno_f");
        if (YEM.isNotEmpty(tpv_srcbillno_f)) {
            whereFilter = String.format("%s and tpv_srcbillno like '%%%s%%'", whereFilter, tpv_srcbillno_f);
        }
        // 合同号
        String tpv_contractno_f = dataEntity.getString("tpv_contractno_f");
        if (YEM.isNotEmpty(tpv_contractno_f)) {
            whereFilter = String.format("%s and LOWER(tpv_contractno) LIKE LOWER('%%%s%%')", whereFilter, tpv_contractno_f);
        }
        // 客户
        DynamicObject tpv_customer_f = dataEntity.getDynamicObject("tpv_customer_f");
        if (YEM.isNotEmpty(tpv_customer_f)) {
            whereFilter = String.format("%s and tpv_customer = %s", whereFilter, tpv_customer_f.getPkValue());
        }
        // 部门
        DynamicObject tpv_department_f = dataEntity.getDynamicObject("tpv_department_f");
        if (YEM.isNotEmpty(tpv_department_f)) {
            whereFilter = String.format("%s and tpv_department = %s", whereFilter, tpv_department_f.getPkValue());
        }
        String whereStr = PersonnelDepUtils.createWhereStrForm(model, "tpv_muldepartment", "tpv_department");
        if (!"".equals(whereStr)){
            whereFilter=String.format("%s%s", whereFilter, whereStr);
        }
        // 显示价格确认
        Boolean tpv_issaleprice_f = dataEntity.getBoolean("tpv_issaleprice_f");
        if (tpv_issaleprice_f) {
            whereFilter = String.format("%s and tpv_srcbill != 'D'", whereFilter);
        }
        Date tpvSaletime = dataEntity.getDate("tpv_saletime");
        if (tpvSaletime!=null){
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvSaletime);
            whereFilter = String.format("%s and tpv_bizdate >= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        Date tpvEndtime = dataEntity.getDate("tpv_endtime");
        if(tpvEndtime!=null){
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvEndtime);
            whereFilter = String.format("%s and tpv_bizdate <= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        //来源单据 多选下拉
        String tpvSrcbillF2 = (String) model.getValue("tpv_srcbill_f2");
        if (YEM.isNotEmpty(tpvSrcbillF2)) {
            String substring = tpvSrcbillF2.replace(",", "");
            String[] split = substring.split("");
            List<String> strings = new ArrayList<>();
            Arrays.stream(split).forEach(x -> {
                String s = "'" + x + "'";
                strings.add("" + s + "");
            });
            whereFilter = String.format("%s and tpv_srcbill in (%s)", whereFilter, String.join(",", strings));
        }
        model.deleteEntryData(entryKey_1);
        DataSet query = SalePriceRptQuery.query(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity(entryKey_1).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow(entryKey_1);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    @Override
    public void hyperLinkClick(HyperLinkClickEvent evt) {
        IDataModel model = this.getModel();
        String fieldName = evt.getFieldName();
        int rowIndex = evt.getRowIndex();
        switch (fieldName) {
            case "tpv_srcbillno":
                String tpv_srcbill = (String) model.getValue("tpv_srcbill", rowIndex);
                String tpv_srcbillKey = "";
                switch (tpv_srcbill) {
                    case "A":
                        tpv_srcbillKey = "tpv_dt_salescontract";
                        break;
                    case "B":
                    case "C":
                        tpv_srcbillKey = "tpv_dt_salesshipping";
                        break;
                    case "D":
                        tpv_srcbillKey = "tpv_dt_salepricebill";
                        break;
                }
                Object tpv_srcbillid = model.getValue("tpv_srcbillid", rowIndex);
                showBill(tpv_srcbillKey, tpv_srcbillid);
                break;
            default:
                break;
        }
    }
    private void showBill(String formkey, Object formid) {
        if (YEM.isNotEmpty(formkey) || YEM.isNotEmpty(formid)) {
            BillShowParameter showParameter = new BillShowParameter();
            showParameter.setFormId(formkey);
            showParameter.setPkId(formid);
            showParameter.setStatus(OperationStatus.VIEW);
            showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
            this.getView().showForm(showParameter);
        }
    }
}
