package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;


import com.itopview.wm.utils.BigDecimalUtils;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;
import kd.bos.form.plugin.AbstractFormPlugin;

import java.math.BigDecimal;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * 录入含税金额分摊 -费用发票
 *
 * @author LiuHB
 * @version 1.0
 */
public class VatamtFeesEdit extends AbstractFormPlugin {
    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("btnok", "btncancel");
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control source = (Control) evt.getSource();
        switch (source.getKey()) {
            case "btnok":
                HashMap<String, Object> hashMap = new HashMap<>();
                BigDecimal tpvTaxinclamt = (BigDecimal) this.getModel().getValue("tpv_taxinclamt");
//                BigDecimal tpvRate = (BigDecimal) this.getModel().getValue("tpv_rate");
                BigDecimal tpvTaxnoinclamt = (BigDecimal) this.getModel().getValue("tpv_taxnoinclamt");
                BigDecimal tpvVatamt = (BigDecimal) this.getModel().getValue("tpv_vatamt");
                hashMap.put("tpv_taxinclamt", tpvTaxinclamt);
//                hashMap.put("tpv_rate", tpvRate);
                hashMap.put("tpv_taxnoinclamt", tpvTaxnoinclamt);
                hashMap.put("tpv_vatamt", tpvVatamt);
                this.getView().returnDataToParent(hashMap);
                this.getView().close();
                break;
            case "btncancel":
                this.getView().close();
                break;

        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = showParameter.getCustomParams();
        BigDecimal tpvTaxinclamt = BigDecimal.ZERO;
        BigDecimal tpvDytaxrates = BigDecimal.ZERO;
        BigDecimal tpvTaxnoinclamt = BigDecimal.ZERO;
        BigDecimal tpvVatamt = BigDecimal.ZERO;
        BigDecimal tpvTaxamount = BigDecimal.ZERO;
        if (maps.size() > 0) {
            tpvTaxinclamt = BigDecimalUtils.toBigDecimal(maps.get("tpv_taxinclamt")); //含税金额(暂时作废)
            tpvTaxnoinclamt = BigDecimalUtils.toBigDecimal(maps.get("tpv_taxnoinclamt")); //不含税金额(暂时作废)
            tpvVatamt = BigDecimalUtils.toBigDecimal(maps.get("tpv_vatamt")); //增值税额(暂时作废)
            tpvDytaxrates = BigDecimalUtils.toBigDecimal(maps.get("tpv_dytaxrates")); //税率%
            tpvTaxamount = BigDecimalUtils.toBigDecimal(maps.get("tpv_taxamount")); //含税金额

            BigDecimal rateH = tpvDytaxrates.divide(new BigDecimal(100));
            BigDecimal oneH = BigDecimal.ONE.add(rateH);
            tpvVatamt = tpvTaxamount.divide(oneH,10,BigDecimal.ROUND_HALF_UP);
            tpvVatamt = tpvVatamt.multiply(rateH).setScale(2, BigDecimal.ROUND_HALF_UP);
            tpvTaxnoinclamt = tpvTaxamount.subtract(tpvVatamt);
        }
        this.getModel().setValue("tpv_taxinclamt", tpvTaxamount);
        this.getModel().setValue("tpv_dytaxrates", tpvDytaxrates);
        this.getModel().setValue("tpv_taxnoinclamt", tpvTaxnoinclamt);
        this.getModel().setValue("tpv_vatamt", tpvVatamt);
    }
}
