package tpv.tpv_wm.tpv_dt.java.formplugin.dynamic;


import com.itopview.wm.utils.BigDecimalUtils;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;
import kd.bos.form.plugin.AbstractFormPlugin;

import java.math.BigDecimal;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * ClassName: VatamtPurInvoiceEdit
 * Description: 录入含税金额分摊 -采购发票
 * date: 2023/10/27 18:24
 *
 * @author: Guo jiaChen
 */
public class VatamtPurInvoiceEdit extends AbstractFormPlugin {
    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("btnok", "btncancel");
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control source = (Control) evt.getSource();
        switch (source.getKey()) {
            case "btnok":
                HashMap<String, Object> hashMap = new HashMap<>();
                BigDecimal tpvAmounttax = (BigDecimal) this.getModel().getValue("tpv_amounttax");
//                BigDecimal tpvRate = (BigDecimal) this.getModel().getValue("tpv_rate");
                BigDecimal tpvAmountnotax = (BigDecimal) this.getModel().getValue("tpv_amountnotax");
                BigDecimal tpvIncreasetax = (BigDecimal) this.getModel().getValue("tpv_increasetax");
                hashMap.put("tpv_amounttax", tpvAmounttax);
//                hashMap.put("tpv_rate", tpvRate);
                hashMap.put("tpv_amountnotax", tpvAmountnotax);
                hashMap.put("tpv_increasetax", tpvIncreasetax);
                this.getView().returnDataToParent(hashMap);
                this.getView().close();
                break;
            case "btncancel":
                this.getView().close();
                break;

        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = showParameter.getCustomParams();
        BigDecimal tpvAmounttax = BigDecimal.ZERO;
        BigDecimal tpvDytaxrates = BigDecimal.ZERO;
        BigDecimal tpvAmountnotax = BigDecimal.ZERO;
        BigDecimal tpvIncreasetax = BigDecimal.ZERO;
        BigDecimal tpvTaxamount = BigDecimal.ZERO;
        if (maps.size() > 0) {
            tpvAmounttax = BigDecimalUtils.toBigDecimal(maps.get("tpv_amounttax")); //含税金额(暂时作废)
            tpvDytaxrates = BigDecimalUtils.toBigDecimal(maps.get("tpv_dytaxrates")); //税率%
            tpvTaxamount = BigDecimalUtils.toBigDecimal(maps.get("tpv_taxamount")); //含税金额

            BigDecimal rateH = tpvDytaxrates.divide(new BigDecimal(100));

            BigDecimal oneH = BigDecimal.ONE.add(rateH);

            tpvIncreasetax = tpvTaxamount.divide(oneH,10,BigDecimal.ROUND_HALF_UP);
            tpvIncreasetax = tpvIncreasetax.multiply(rateH).setScale(2, BigDecimal.ROUND_HALF_UP);
//            tpvIncreasetax = BigDecimalUtils.toBigDecimal(maps.get("tpv_increasetax")); //增值税额

//            tpvAmountnotax = BigDecimalUtils.toBigDecimal(maps.get("tpv_amountnotax")); //不含税金额
            tpvAmountnotax = tpvTaxamount.subtract(tpvIncreasetax);
        }
        this.getModel().setValue("tpv_amounttax", tpvTaxamount);
        this.getModel().setValue("tpv_dytaxrates", tpvDytaxrates);
        this.getModel().setValue("tpv_amountnotax", tpvAmountnotax);
        this.getModel().setValue("tpv_increasetax", tpvIncreasetax);
    }
}
