package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import com.itopview.wm.dt.report.PracticalRptQuery;
import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.*;
import kd.bos.form.operate.FormOperate;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;
import java.util.Map;

/**
 * @Description: 实提工作台底表表单插件
 * @Author LinRui
 */
public class BlendingeFormPlugin extends AbstractFormPlugin implements HyperLinkClickListener {

    private final String TPV_DT_PURCHASE = "tpv_dt_purchase";//采购合同标识

    private final String TPV_DT_FREIGROAMBILL = "tpv_dt_freigroambill";//货物流转单标识

    private final String TPV_DT_PURINBILL = "im_purinbill";//采购入库单标识

    private final String IM_OTHEROUTBILL = "im_otheroutbill";//其他出库单

    private final String IM_OTHERINBILL = "im_otherinbill";//其他入库单

    private final String TPV_DT_SALESSHIPPING = "tpv_dt_salesshipping";//销售发货

    private final String IM_SALOUTBILL = "im_saloutbill";//销售出库

    /**
     * 单据打开查出入库单号
     *
     * @param e
     */
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        showEntryData(); //显示分录数据
        setEntryRowInAndOutBillno(); //实时查询赋值下游单据编号
    }

    private void showEntryData() {
        Boolean ifFlag = false;
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvSonentryentitys = dataEntity.getDynamicObjectCollection("tpv_sonentryentity");
        Map<String, Object> customParams = this.getView().getFormShowParameter().getCustomParams();
        if (customParams.size() > 0) {
            String tpv_sourceid = (String) customParams.get("tpv_sourceid");
            Boolean tpv_realsubmit = (Boolean) customParams.get("tpv_realsubmit");
            Boolean tpv_isautoinorder = (Boolean) customParams.get("tpv_isautoinorder");
            Boolean tpv_isautoinsales = (Boolean) customParams.get("tpv_isautoinsales");
            BigDecimal tpv_qty = BigDecimalUtils.toBigDecimal(customParams.get("tpv_qty"));
            BigDecimal tpv_packnum = BigDecimalUtils.toBigDecimal(customParams.get("tpv_packnum"));
            if (tpvSonentryentitys.size() > 0) {
                if (YEM.isNotEmpty(tpv_sourceid)) {
                    BigDecimal tpvQty = BigDecimalUtils.toBigDecimal(customParams.get("tpv_qty"));
                    BigDecimal bigDecimal = BigDecimal.ZERO;
                    for (DynamicObject tpvSonentryentity : tpvSonentryentitys) {
                        String tpvFatherid = tpvSonentryentity.getString("tpv_fatherid");
                        BigDecimal tpv_destroyquantity = YEM.isNotEmpty(tpvSonentryentity.getBigDecimal("tpv_destroyquantity"))
                                ? tpvSonentryentity.getBigDecimal("tpv_destroyquantity") : BigDecimal.ZERO;
                        if (tpv_sourceid.equals(tpvFatherid)){
                            bigDecimal.add(tpv_destroyquantity);
                        }
                    }
                    if (bigDecimal.compareTo(tpvQty) >= 0) {
                        ifFlag = true;
                    }
                    if (ifFlag){
                        this.getView().setEnable(false, "tb_new");
                        this.getView().setEnable(false, "tpv_copyentryrow");
                    }else {
                        this.getView().setEnable(true, "tb_new");
                        this.getView().setEnable(true, "tpv_copyentryrow");
                    }
                }
            }
            if (YEM.isNotEmpty(tpv_realsubmit) && tpv_realsubmit) {
                this.getView().setEnable(false, "tb_new");
                this.getView().setEnable(false, "tpv_copyentryrow");
            }
            if (YEM.isNotEmpty(tpv_sourceid)) {
                //用id查询底表
                QFilter qFilter = new QFilter("tpv_sonentryentity.tpv_fatherid", QCP.equals, tpv_sourceid);
                qFilter.and("tpv_sonentryentity.id", QCP.large_than, 0);
                DynamicObjectCollection query = QueryServiceHelper.query("tpv_dt_blendingepibenthic", "id",
                        qFilter.toArray());
                if (query.size() == 0 && (tpv_isautoinsales || tpv_isautoinorder)) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sonentryentity");
                    addRowCopySetValue(newEntryRow);
                    //自动带入采提/自动带入销提默认一行数据
                    this.getModel().setValue("tpv_ofpackages",tpv_packnum,newEntryRow);
                    if (YEM.isNotEmpty(tpv_isautoinorder) && tpv_isautoinorder) {
                        this.getModel().setValue("tpv_purchasequantity",tpv_qty,newEntryRow);
//                        this.getModel().setValue("tpv_purchasesuer",true,newEntryRow);
                    }
                    if (YEM.isNotEmpty(tpv_isautoinsales) && tpv_isautoinsales) {
                        this.getModel().setValue("tpv_destroyquantity",tpv_qty,newEntryRow);
//                        this.getModel().setValue("tpv_destroysure",true,newEntryRow);
//                        this.getModel().setValue("tpv_practicalok_zy", true);
//                        DynamicObject dataEntityS = this.getModel().getDataEntity(true);
//                        dataEntityS.set("tpv_practicalok_zy", true);
//                        IFormView view = this.getView().getParentView();
//                        int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
//                        view.getModel().setValue("tpv_realsubmit", true, tpvEntryentity);
//                        this.getView().sendFormAction(view);
                    }
                    if ((YEM.isNotEmpty(tpv_isautoinorder) && tpv_isautoinorder) || (YEM.isNotEmpty(tpv_isautoinsales) && tpv_isautoinsales)) {
                        this.getModel().setValue("tpv_ofpackages",tpv_packnum,newEntryRow);
                        SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});//写入数据库
                    }
                } else if (query.size() == 0) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sonentryentity");
                    addRowCopySetValue(newEntryRow);
                    this.getModel().setValue("tpv_ofpackages",tpv_packnum,newEntryRow);
                }
            }
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        // TODO Auto-generated method stub
        super.propertyChanged(e);
        String propertyName = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];//正在发生改变的数据
        int rowIndex = cd.getRowIndex();
        if ("tpv_destroysure".equals(propertyName)) {
            //判断数量实提完毕自动打勾
            DynamicObjectCollection tpvSonentryentityS = this.getModel().getEntryEntity("tpv_sonentryentity");
            BigDecimal qty = BigDecimal.ZERO;
            BigDecimal packageqty = BigDecimal.ZERO;
            if (tpvSonentryentityS.size() >= 0) {
                for (DynamicObject dynamicObject : tpvSonentryentityS) {
                    //销提数量
                    boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                    if (tpvDestroysure) {
                        BigDecimal tpv_destroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                        qty = qty.add(tpv_destroyquantity);
                    }
                    BigDecimal tpvOfpackages = dynamicObject.getBigDecimal("tpv_ofpackages");
                    packageqty = packageqty.add(tpvOfpackages);
                }
            }
//            huifudata();
            BigDecimal tpv_pickqty_zy = (BigDecimal) this.getModel().getValue("tpv_pickqty_zy");
            if (tpv_pickqty_zy.compareTo(BigDecimal.ZERO) != 0) {
                int resultsale = qty.compareTo(tpv_pickqty_zy);
                int resultpack = qty.compareTo(tpv_pickqty_zy);
                if (resultsale >= 0 || resultpack >= 0) {
                    this.getModel().setValue("tpv_practicalok_zy", true);
                    DynamicObject dataEntityS = this.getModel().getDataEntity(true);
                    dataEntityS.set("tpv_practicalok_zy", true);
                    SaveServiceHelper.update(dataEntityS);//写入数据库
                    IFormView view = this.getView().getParentView();
                    int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
                    view.getModel().setValue("tpv_realsubmit", true, tpvEntryentity);
                    this.getView().sendFormAction(view);
                } else {
                    this.getModel().setValue("tpv_practicalok_zy", false);
                    DynamicObject dataEntityS = this.getModel().getDataEntity(true);
                    dataEntityS.set("tpv_practicalok_zy", false);
                    SaveServiceHelper.update(dataEntityS);//写入数据库
                    IFormView view = this.getView().getParentView();
                    int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
                    view.getModel().setValue("tpv_realsubmit", false, tpvEntryentity);
                    this.getView().sendFormAction(view);
                }
            }
        }
        if ("tpv_purchasequantity".equals(propertyName)) {
            BigDecimal oldValue = (BigDecimal) cd.getOldValue();
            BigDecimal newValue = (BigDecimal) this.getModel().getValue("tpv_purchasequantity", rowIndex);
            if (YEM.isNotEmpty(oldValue)) {
                if (oldValue.compareTo(newValue) != 0) {
                    SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
                    updateParentEntryRowData();
                }
            } else if (YEM.isEmpty(oldValue) && YEM.isNotEmpty(newValue)) {
                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
                updateParentEntryRowData();
            }
        }
        if ("tpv_destroyquantity".equals(propertyName)) {
            BigDecimal oldValue = (BigDecimal) cd.getOldValue();
            BigDecimal newValue = (BigDecimal) this.getModel().getValue("tpv_destroyquantity", rowIndex);
            if (YEM.isNotEmpty(oldValue)) {
                if (oldValue.compareTo(newValue) != 0) {
                    SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
                    updateParentEntryRowData();
                }
            } else if (YEM.isEmpty(oldValue) && YEM.isNotEmpty(newValue)) {
                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
                updateParentEntryRowData();
            }

        }
    }

    private void huifudata() {
        //拿到当前直运分录id
        IFormView parentView = this.getView().getParentView();
        IDataModel parentViewModel = parentView.getModel();
        int index = parentViewModel.getEntryCurrentRowIndex("tpv_entryentity");
        String tpv_srcentryid = (String)parentViewModel.getValue("tpv_srcentryid", index);
        String tpv_sourceid = (String) parentViewModel.getValue("tpv_sourceid", index);
        long number = Long.parseLong(tpv_srcentryid);
        long numberTpvSourceid = Long.parseLong(tpv_sourceid);
        long id = this.getModel().getDataEntity(true).getLong("id");
        String selectfieldsFast = "id,tpv_materialentry,tpv_dt_salepick_zy,tpv_dt_salepick_zy.tpv_pickqty_zy,tpv_materialentry.tpv_qty";
        DynamicObject tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter("tpv_materialentry.tpv_dt_salepick_zy", QCP.equals, id).toArray());
        DynamicObjectCollection tpv_materialentry = tpvScBusinessnatures.getDynamicObjectCollection("tpv_materialentry");
        for (DynamicObject dynamicObject : tpv_materialentry) {
            long ids = (Long) dynamicObject.getPkValue();
            if (ids == number) {
                dynamicObject.set("tpv_qty",new BigDecimal("10"));
                DynamicObjectCollection dynamicObjects = dynamicObject.getDynamicObjectCollection("tpv_dt_salepick_zy");
                for (DynamicObject object : dynamicObjects) {
                    long pkValue = (Long) object.getPkValue();
                    if (pkValue == numberTpvSourceid) {
                        object.set("tpv_pickqty_zy",new BigDecimal("10"));
                    }
                }
                SaveServiceHelper.update(dynamicObject);
            }
        }
    }

    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"advcontoolbarap"});
        this.addClickListeners("newentry"); // 监听确认和取消按钮
        this.addClickListeners("tb_new");
        this.addItemClickListeners("advcontoolbarap");
        EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
        entryGrid.addHyperClickListener(this);
    }

    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        super.afterAddRow(e);
        String name = e.getEntryProp().getName();
        RowDataEntity[] rowIndex = e.getRowDataEntities();
        if (StringUtils.equals("tpv_sonentryentity", name)) {
            outCoefficient(rowIndex);
        }
    }

    /**
     * 增行时表头系数赋值到分录
     */
    private void outCoefficient(RowDataEntity[] dataentuty) {
        for (RowDataEntity rowdata : dataentuty) {
            int row = rowdata.getRowIndex();
            addRowCopySetValue(row);
        }
    }

    /**
     * 增行赋值一堆父分录选择行数据
     * */
    private void addRowCopySetValue(int row) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpvMaterialZy = (DynamicObject) this.getModel().getValue("tpv_material_zy");//商品
        DynamicObject tpvProdnameZy = (DynamicObject) this.getModel().getValue("tpv_prodname_zy");//品名
        String tpvShaderZy = (String) this.getModel().getValue("tpv_shader_zy");//材质
        String tpvSpecationZy = (String) this.getModel().getValue("tpv_specation_zy");//规格
        DynamicObject tpvOriginZy = (DynamicObject) this.getModel().getValue("tpv_origin_zy");//产地
        String tpvPickbillZy = (String) this.getModel().getValue("tpv_pickbill_zy");//配货单据
        String tpvBillnoZy = (String) this.getModel().getValue("tpv_billno_zy");//单据编号
        DynamicObject tpvSupplierZy = (DynamicObject) this.getModel().getValue("tpv_supplier_zy");//供应商
        Long tpvFidZy = (Long) this.getModel().getValue("tpv_fid_zy");//采购单据id
        String tpvCustomtagsZy = (String) this.getModel().getValue("tpv_customtags_zy");//自定标签
        if (null != tpvMaterialZy) {
            this.getModel().setValue("tpv_materials", tpvMaterialZy, row);
            DynamicObject auxptyunit = tpvMaterialZy.getDynamicObject("auxptyunit");//辅助单位
            if (null == auxptyunit) {
                this.getView().setEnable(false, row, "tpv_ofpackages");//锁定分录包装数量字段
            }
        }
        if (null != tpvProdnameZy) {
            this.getModel().setValue("tpv_prodnames", tpvProdnameZy, row);
        }
        if (null != tpvPickbillZy && "" != tpvPickbillZy) {
            this.getModel().setValue("tpv_fatherpickbill", tpvPickbillZy, row);

        }
        if (null != tpvBillnoZy && "" != tpvBillnoZy) {
            this.getModel().setValue("tpv_billnos", tpvBillnoZy, row);
        }
        if (null != tpvSupplierZy) {
            this.getModel().setValue("tpv_suppliers", tpvSupplierZy, row);
        }
        if (null != tpvShaderZy && "" != tpvShaderZy) {
            this.getModel().setValue("tpv_shaders", tpvShaderZy, row);
        }
        if (null != tpvSpecationZy && "" != tpvSpecationZy) {
            this.getModel().setValue("tpv_specations", tpvSpecationZy, row);
        }
        if (null != tpvOriginZy) {
            this.getModel().setValue("tpv_origins", tpvOriginZy, row);
        }
        if (null != tpvFidZy && tpvFidZy > 0L) {  //添加采购合同号
            DynamicObject random = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", "id,tpv_contractnumber",
                    new QFilter[]{new QFilter("id", QCP.equals, Long.valueOf(tpvFidZy))});
            if (null != random) {
                this.getModel().setValue("tpv_purcontract", random.getString("tpv_contractnumber"), row);
            }
        }
        Long blendingepiBenthicId = (Long) this.getModel().getValue("tpv_dt_blendingepibenthic.id");
        this.getModel().setValue("tpv_fatherid", blendingepiBenthicId, row);
        if (null != tpvCustomtagsZy && "" != tpvCustomtagsZy) {
            this.getModel().setValue("tpv_customtagss", tpvCustomtagsZy, row);
        }

        IDataModel parentModel = this.getView().getParentView().getModel();
        int rowIndex = parentModel.getEntryCurrentRowIndex("tpv_entryentity");
        DynamicObject rowEntity = parentModel.getEntryRowEntity("tpv_entryentity", rowIndex);
        DynamicObject tpvCurrency = rowEntity.getDynamicObject("tpv_currency");
        BigDecimal tpvTaxprice = rowEntity.getBigDecimal("tpv_taxprice");
        this.getModel().setValue("tpv_entrycurrency", tpvCurrency, row);
        this.getModel().setValue("tpv_entrytaxprice", tpvTaxprice, row);
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        super.itemClick(evt);
        String key = evt.getItemKey();
        // 获取单据体选中行
        EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
        int[] selectRows = entryGrid.getSelectRows();
        List<String> nopassSeqList = new ArrayList<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvSonentryentity = this.getModel().getEntryEntity("tpv_sonentryentity");
//        DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(dataEntity.getPkValue(), dataEntity.getDataEntityType().getName());
//        DynamicObjectCollection tpvSonentryentity = loadSingle.getDynamicObjectCollection("tpv_sonentryentity");
        //监听物流确认采购实提按钮
        if (StringUtils.equals("tpv_advconbaritemap", key)) {
            ordersValidation(selectRows, nopassSeqList, tpvSonentryentity, dataEntity);
        }
        //监听反物流确认采购实提按钮
        if (StringUtils.equals("tpv_advconbaritemapno", key)) {
            if (selectRows.length > 0) {
                nopassSeqList = new ArrayList<>();
                for (int selectRow : selectRows) {
                    String tpv_sonbill= (String) this.getModel().getValue("tpv_sonbill", selectRow);
                    String tpv_sonbillnos = (String) this.getModel().getValue("tpv_sonbillnos", selectRow);
                    String tpv_godownentry = (String) this.getModel().getValue("tpv_godownentry", selectRow);
                    String tpv_deliveryorder = (String) this.getModel().getValue("tpv_deliveryorder", selectRow);
                    String tpv_lossodd = (String) this.getModel().getValue("tpv_lossodd", selectRow);
                    String tpv_profitodd = (String) this.getModel().getValue("tpv_profitodd", selectRow);
                    if (YEM.isNotEmpty(tpv_sonbill) || YEM.isNotEmpty(tpv_sonbillnos) || YEM.isNotEmpty(tpv_godownentry)
                            || YEM.isNotEmpty(tpv_deliveryorder) || YEM.isNotEmpty(tpv_lossodd) || YEM.isNotEmpty(tpv_profitodd)) {
                        nopassSeqList.add(String.valueOf(selectRow + 1));
                    }
                }
                if (nopassSeqList.size() > 0) {
                    this.getView().showMessage("分录第 " + String.join("、", nopassSeqList) + "行已做过+出入库操作，不允许反物流确认");
                } else {
                    for (int selectRow : selectRows) {
                        this.getModel().setValue("tpv_purchasesuer", false, selectRow);
                        DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                        dynamicObject.set("tpv_purchasesuer", false);
                        SaveServiceHelper.update(dynamicObject);
                        this.getView().updateView("tpv_sonentryentity.tpv_purchasesuer", selectRow);
                    }
                }
            } else {
                this.getView().showTipNotification("请先选中行数据！");
            }
        }
        //监听物流确认销售实提按钮
        if (StringUtils.equals("tpv_advconbaritemap1", key)) {
            salesValidation(selectRows, nopassSeqList, tpvSonentryentity, dataEntity);
        }
        //监听反物流确认销售实提按钮
        if (StringUtils.equals("tpv_advconbaritemap1no", key)) {
            if (selectRows.length > 0) {
                nopassSeqList = new ArrayList<>();
                for (int selectRow : selectRows) {
                    String tpv_sonbill= (String) this.getModel().getValue("tpv_sonbill", selectRow);
                    String tpv_sonbillnos = (String) this.getModel().getValue("tpv_sonbillnos", selectRow);
                    String tpv_godownentry = (String) this.getModel().getValue("tpv_godownentry", selectRow);
                    String tpv_deliveryorder = (String) this.getModel().getValue("tpv_deliveryorder", selectRow);
                    String tpv_lossodd = (String) this.getModel().getValue("tpv_lossodd", selectRow);
                    String tpv_profitodd = (String) this.getModel().getValue("tpv_profitodd", selectRow);
                    if (YEM.isNotEmpty(tpv_sonbill) || YEM.isNotEmpty(tpv_sonbillnos) || YEM.isNotEmpty(tpv_godownentry)
                            || YEM.isNotEmpty(tpv_deliveryorder) || YEM.isNotEmpty(tpv_lossodd) || YEM.isNotEmpty(tpv_profitodd)) {
                        nopassSeqList.add(String.valueOf(selectRow + 1));
                    }
                }
                if (nopassSeqList.size() > 0) {
                    this.getView().showMessage("分录第 " + String.join("、", nopassSeqList) + "行已做过+出入库操作，不允许反物流确认");
                } else {
                    for (int selectRow : selectRows) {
                        this.getModel().setValue("tpv_destroysure", false, selectRow);
                        DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                        dynamicObject.set("tpv_destroysure", false);
                        SaveServiceHelper.update(dynamicObject);
                        this.getView().updateView("tpv_sonentryentity.tpv_destroysure", selectRow);
                    }
                }
            }else {
                this.getView().showTipNotification("请先选中行再点击");
            }
        }
        //监听+出入库单按钮
        if (StringUtils.equals("tpv_appearenter", key)) {
            toInOutValidation(selectRows, nopassSeqList, tpvSonentryentity, dataEntity);
        }
    }

    private void ordersValidation(int[] selectRows, List<String> nopassSeqList, DynamicObjectCollection tpvSonentryentity, DynamicObject dataEntity) {
        if (selectRows.length > 0) {
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                BigDecimal tpvPurchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");
                if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) == 0) {
                    nopassSeqList.add(String.valueOf(selectRow + 1));
                }
            }
            if (nopassSeqList.size() > 0) {
                this.getView().showMessage("请填写分录第 " + String.join("、", nopassSeqList) + "行采提数量后，再点击物流确认采购实提按钮");
            } else {
                //获取单据体控件
                for (int selectRow : selectRows) {
                    this.getModel().setValue("tpv_purchasesuer", true, selectRow);
                    DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                    dynamicObject.set("tpv_purchasesuer", true);
                    this.getView().updateView("tpv_purchasesuer", selectRow);
                }
                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
                updateParentEntryRowData();
            }
        } else {
            this.getView().showTipNotification("请先选中行，再点击物流确认采购实提按钮");
        }
    }

    private void salesValidation(int[] selectRows, List<String> nopassSeqList, DynamicObjectCollection tpvSonentryentity, DynamicObject dataEntity) {
        if (selectRows.length > 0) {
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                if (tpvDestroyquantity.compareTo(BigDecimal.ZERO) == 0) {
                    nopassSeqList.add(String.valueOf(selectRow + 1));
                }
            }
            if (nopassSeqList.size() > 0) {
                this.getView().showMessage("请填写分录第" + String.join("、", nopassSeqList) + "行销提数量后，再点击物流确认销售实提按钮");
            } else {
                //获取单据体控件
                for (int selectRow : selectRows) {
                    this.getModel().setValue("tpv_destroysure", true, selectRow);
                    DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                    dynamicObject.set("tpv_destroysure", true);
                    this.getView().updateView("tpv_destroysure", selectRow);
                }
                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
                //判断数量实提完毕自动打勾
                BigDecimal qty = BigDecimal.ZERO;
                if (tpvSonentryentity.size() >= 0) {
                    for (DynamicObject dynamicObject : tpvSonentryentity) {
                        BigDecimal tpv_destroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                        boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                        if (tpvDestroysure) {
                            qty = qty.add(tpv_destroyquantity);
                        }
                    }
                }
                BigDecimal tpv_pickqty_zy = dataEntity.getBigDecimal("tpv_pickqty_zy");
                if (qty.compareTo(BigDecimal.ZERO) != 0 && tpv_pickqty_zy.compareTo(BigDecimal.ZERO) != 0) {
                    int result = qty.compareTo(tpv_pickqty_zy);
                    if (result >= 0) {
                        dataEntity.set("tpv_practicalok_zy", true);
                        SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});//写入数据库
                        IFormView view = this.getView().getParentView();
                        int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
                        view.getModel().setValue("tpv_realsubmit", true, tpvEntryentity);
                        this.getView().sendFormAction(view);
//                        this.getView().invokeOperation("refresh");
                        this.getView().setEnable(false, "tb_new");
                        this.getView().setEnable(false, "tpv_copyentryrow");
                    } else {
                        this.getView().setEnable(true, "tb_new");
                        this.getView().setEnable(true, "tpv_copyentryrow");
                    }
                }
                updateParentEntryRowData();
            }
        } else {
            this.getView().showTipNotification("请先选中行，再点击物流确认销售实提");
        }
    }


    private void toInOutValidation(int[] selectRows, List<String> nopassSeqList, DynamicObjectCollection tpvSonentryentity, DynamicObject dataEntity) {
        List<Long> entryIds = new ArrayList<>();
        if (selectRows.length > 0) {
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                boolean tpvPurchasesuer = dynamicObject.getBoolean("tpv_purchasesuer");
                boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                String tpvGodownentry = dynamicObject.getString("tpv_godownentry"); //入库单号
                String tpvDeliveryorder = dynamicObject.getString("tpv_deliveryorder"); //出库单号
                String tpvFatherpickbill = dynamicObject.getString("tpv_fatherpickbill"); //父配货单据
                long pkValueS = (long) dynamicObject.getPkValue();
                //采购入库
                DynamicObjectCollection tpv_dt_purinbill = QueryServiceHelper.query("im_purinbill", "billno",
                        new QFilter("billentry.tpv_directconsignmentid", QCP.equals, pkValueS).toArray());
                //其他出库
                DynamicObjectCollection im_otheroutbill = QueryServiceHelper.query("im_otheroutbill", "billno",
                        new QFilter("billentry.tpv_directconsignmentid", QCP.equals, pkValueS).toArray());
                //其他入库
                DynamicObjectCollection im_otherinbill = QueryServiceHelper.query("im_otherinbill", "billno",
                        new QFilter("billentry.tpv_directconsignmentid", QCP.equals, pkValueS).toArray());
                //销售出库
                DynamicObjectCollection im_saloutbill = QueryServiceHelper.query("im_saloutbill", "billno",
                        new QFilter("billentry.tpv_directconsignmentid", QCP.equals, pkValueS).toArray());
                //货物流转单 ——父配货单据为采购合同，会有下推货物流转单动作，判断是否存在已生成货物流转单数据
                DynamicObjectCollection tpv_dt_freigroambill = new DynamicObjectCollection();
                if ("tpv_dt_purchase".equals(tpvFatherpickbill)) {
                    tpv_dt_freigroambill = QueryServiceHelper.query("tpv_dt_freigroambill", "billno",
                            new QFilter("tpv_materialentry.tpv_directconsignmentid", QCP.equals, pkValueS).toArray());
                }
                StringBuffer desc = new StringBuffer();
                if (!tpvPurchasesuer) { desc.append("采提确认为否、");}
                if (!tpvDestroysure) { desc.append("销提确认为否、");}
                if (YEM.isNotEmpty(tpvGodownentry)) { desc.append("入库单号不为空、");}
                if (YEM.isNotEmpty(tpvDeliveryorder)) { desc.append("出库单号不为空、");}
                StringBuffer str = new StringBuffer();
                //判断每行分录是否已经+出入库单
                if ("tpv_dt_purchase".equals(tpvFatherpickbill)) {
                    if (tpv_dt_freigroambill.size() > 0) {//采购·入库
                        str = new StringBuffer();
                        for (DynamicObject object : tpv_dt_purinbill) {
                            str.append(object.getString("billno") + "、");
                        }
                        desc.append("存在下游货物流转单" + str + ";");
                    }
                }
                if (tpv_dt_purinbill.size() > 0) {//采购·入库
                    str = new StringBuffer();
                    for (DynamicObject object : tpv_dt_purinbill) {
                        str.append(object.getString("billno") + "、");
                    }
                    desc.append("存在下游采购入库单" + str + ";");
                }
                if (im_otheroutbill.size() > 0) {//其他出库
                    str = new StringBuffer();
                    for (DynamicObject object : im_otheroutbill) {
                        str.append(object.getString("billno"));
                    }
                    desc.append("存在下游其他出库" +str + ";");
                }
                if (im_otherinbill.size() > 0) {//其他入库
                    str = new StringBuffer();
                    for (DynamicObject object : im_otherinbill) {
                        str.append(object.getString("billno"));
                    }
                    desc.append("存在下游其他入库" + str + ";");
                }
                if (im_saloutbill.size() > 0) {//销售出库
                    str = new StringBuffer();
                    for (DynamicObject object : im_saloutbill) {
                        str.append(object.getString("billno"));
                    }
                    desc.append("存在下游销售出库" + str + ";");
                }
                if (YEM.isNotEmpty(desc.toString())) {
                    int message = 1 + selectRow;
                    nopassSeqList.add("第" + message + "行 " + desc + "不可+出入库单");
                }
                if (YEM.isNotEmpty(dynamicObject.getLong("id")) && dynamicObject.getLong("id") != 0L) {
                    entryIds.add(dynamicObject.getLong("id"));
                }
            }
            if (nopassSeqList.size() > 0) {
                String result = String.join("", nopassSeqList);
                this.getView().showMessage(result);
            } else {
                // 创建弹出动态表单页面对象
                FormShowParameter showParameter = new FormShowParameter();
                // 设置弹出页面的标识
                showParameter.setFormId("tpv_dt_directconschedule");
                // 状态
                showParameter.setStatus(OperationStatus.ADDNEW);
//            showParameter.setShowClose(false); //不显示右上角查
                // 设置页面关闭回调方法
                // CloseCallBack参数：回调插件，回调标识
                showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_designate"));
                // 设置弹出页面打开方式
                showParameter.getOpenStyle().setShowType(ShowType.Modal);
                // 打开动态表单
                this.getView().showForm(showParameter);
            }
        } else {
            this.getView().showTipNotification("请先选中行，再点击+出入库单");
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent evt) {
        super.closedCallBack(evt);
        if (StringUtils.equals(evt.getActionId(), "tpv_designate")) { //+出入库操作后刷新父分录选中行
            updateParentEntryRowData();
        }
    }

    /**
     * 修改父分录选择行数据：采提数量、销提数量、已出库数量、未出库数量
     * */
    private void updateParentEntryRowData() {
        IFormView view = this.getView().getParentView();
        int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
        String tpv_zySubEntryid =  (String) view.getModel().getValue("tpv_sourceid", tpvEntryentity);
        if (YEM.isNotEmpty(tpv_zySubEntryid)) {
            String whereFilter = "1 = 1";
            whereFilter = String.format("%s and tpv_sourceid = %s", whereFilter, Long.valueOf(tpv_zySubEntryid));
            DataSet query = PracticalRptQuery.query(whereFilter);
            DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(query);
            //根据销售发货库存拣配直运子分录的id查询
            for (DynamicObject dynamicObject : dynamicObjects) {
                view.getModel().setValue("tpv_destroyquantitysum", dynamicObject.getBigDecimal("tpv_destroyquantitysum"), tpvEntryentity);
                view.getModel().setValue("tpv_purchasequantitysum", dynamicObject.getBigDecimal("tpv_purchasequantitysum"), tpvEntryentity);
                view.getModel().setValue("tpv_issuedquantitys", dynamicObject.getBigDecimal("tpv_issuedquantitys"), tpvEntryentity);
                view.getModel().setValue("tpv_unissuedquanti", dynamicObject.getBigDecimal("tpv_unissuedquanti"), tpvEntryentity);
                break;
            }
            this.getView().sendFormAction(view);
        }
    }

    /**
     * 分录赋值单据编号
     * */
    public void setEntryRowInAndOutBillno(DynamicObjectCollection tpvSonentryentity, int[] selectRows) {
        for (int selectRow : selectRows) {
            DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
            BigDecimal tpvPurchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");//采提数量
            BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");//采提数量
            Long id = (Long) dynamicObject.getPkValue();
            if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && tpvDestroyquantity.compareTo(BigDecimal.ZERO) != 0) {
                //采购入库
                DynamicObject tpv_dt_purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id,billno",
                        new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                //销售出库
                DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno," +
                                "billentry,billentry.tpv_isrowout,billentry.tpv_directconsignmentid",
                        new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                int bigSmal = tpvPurchasequantity.compareTo(tpvDestroyquantity);
                if (bigSmal == 0) {
                    //销提数量等于采提数量查询采购入库单号和销售出库单号
                    setEntryBillno(dynamicObject, tpv_dt_purinbill, im_saloutbill);
                }
                if (bigSmal > 0) {
                    //采提数量大于销提数量时查询入库单号 出库单号 盘亏单号
                    //其他出库
                    DynamicObject im_otheroutbill = BusinessDataServiceHelper.loadSingle("im_otheroutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    setEntryBillno(dynamicObject, tpv_dt_purinbill, im_saloutbill);
                    if (null != im_otheroutbill) {
                        //插入盘亏单号
                        dynamicObject.set("tpv_lossodd", im_otheroutbill.getString("billno"));
                    } else {
                        dynamicObject.set("tpv_lossodd", null);
                    }
                }
                if (bigSmal < 0) {
                    //采提数量小于销提数量时查询入库单号 出库单号 盘盈单号
                    //其他入库
                    DynamicObject im_otherinbill = BusinessDataServiceHelper.loadSingle("im_otherinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    setEntryBillno(dynamicObject, tpv_dt_purinbill, im_saloutbill);
                    if (null != im_otherinbill) {
                        //插入出库单号
                        dynamicObject.set("tpv_profitodd", im_otherinbill.getString("billno"));
                    } else {
                        dynamicObject.set("tpv_profitodd", null);
                    }
                }
            }
        }
//        SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
        //获取单据体控件
        EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
        for (int selectRow : selectRows) {
            this.getView().updateView("tpv_sonentryentity",selectRow);
            this.getModel().beginInit();
            entryGrid.selectRows(selectRow);
            this.getModel().endInit();
        }
    }
    public void setEntryRowInAndOutBillno() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvSonentryentity = dataEntity.getDynamicObjectCollection("tpv_sonentryentity");
        for (int i = 0; i < tpvSonentryentity.size(); i++) {
            DynamicObject dynamicObject = tpvSonentryentity.get(i);
            BigDecimal tpvPurchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");//采提数量
            BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");//采提数量
            String tpvFatherpickbill = dynamicObject.getString("tpv_fatherpickbill"); //父配货单据
            Long id = (Long) dynamicObject.getPkValue();
            if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && tpvDestroyquantity.compareTo(BigDecimal.ZERO) != 0 && id > 0) {
                //货物流转单 ——父配货单据为采购合同，会有下推货物流转单动作，判断是否存在已生成货物流转单数据
                if ("tpv_dt_purchase".equals(tpvFatherpickbill)) {
                    DynamicObject tpv_dt_freigroambill = BusinessDataServiceHelper.loadSingle("tpv_dt_freigroambill", "billno",
                            new QFilter("tpv_materialentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    if (null != tpv_dt_freigroambill) {
                        //插入货物流转单号
                        dynamicObject.set("tpv_freigroambillno", tpv_dt_freigroambill.getString("billno"));
                    } else {
                        dynamicObject.set("tpv_freigroambillno", null);
                    }
                }
                //采购入库
                DynamicObject tpv_dt_purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id,billno",
                        new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                //销售出库
                DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno," +
                                "billentry,billentry.tpv_isrowout,billentry.tpv_directconsignmentid",
                        new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                int bigSmal = tpvPurchasequantity.compareTo(tpvDestroyquantity);
                if (bigSmal == 0) {
                    //销提数量等于采提数量查询采购入库单号和销售出库单号
                    setEntryBillno(dynamicObject, tpv_dt_purinbill, im_saloutbill);
                }
                if (bigSmal > 0) {
                    //采提数量大于销提数量时查询入库单号 出库单号 盘亏单号
                    //其他出库
                    DynamicObject im_otheroutbill = BusinessDataServiceHelper.loadSingle("im_otheroutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    setEntryBillno(dynamicObject, tpv_dt_purinbill, im_saloutbill);
                    if (null != im_otheroutbill) {
                        //插入盘亏单号
                        dynamicObject.set("tpv_lossodd", im_otheroutbill.getString("billno"));
                    } else {
                        dynamicObject.set("tpv_lossodd", null);
                    }
                }
                if (bigSmal < 0) {
                    //采提数量小于销提数量时查询入库单号 出库单号 盘盈单号
                    //其他入库
                    DynamicObject im_otherinbill = BusinessDataServiceHelper.loadSingle("im_otherinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    setEntryBillno(dynamicObject, tpv_dt_purinbill, im_saloutbill);
                    if (null != im_otherinbill) {
                        //插入出库单号
                        dynamicObject.set("tpv_profitodd", im_otherinbill.getString("billno"));
                    } else {
                        dynamicObject.set("tpv_profitodd", null);
                    }
                }
                this.getView().updateView("tpv_sonentryentity");
            }
        }
    }
    /**
     * 赋值编号
     * */
    private void setEntryBillno(DynamicObject dynamicObject, DynamicObject tpv_dt_purinbill, DynamicObject im_saloutbill) {
        if (null != tpv_dt_purinbill) {
            //插入子配货单据
            dynamicObject.set("tpv_sonbill","im_purinbill");
            //插入子配货单据编号
            dynamicObject.set("tpv_sonbillnos",tpv_dt_purinbill.getString("billno"));
            //插入入库单号
            dynamicObject.set("tpv_godownentry",tpv_dt_purinbill.getString("billno"));
        } else {
            //插入子配货单据
            dynamicObject.set("tpv_sonbill",null);
            //插入子配货单据编号
            dynamicObject.set("tpv_sonbillnos",null);
            dynamicObject.set("tpv_godownentry",null);
        }
        if (null != im_saloutbill) {
            //插入出库单号
            dynamicObject.set("tpv_deliveryorder",im_saloutbill.getString("billno"));
            DynamicObjectCollection dynamicObjects = im_saloutbill.getDynamicObjectCollection("billentry");
            for (DynamicObject object : dynamicObjects) {
                Long id = object.getLong("tpv_directconsignmentid"); //出库直运底表id
                Long ids = dynamicObject.getLong("id");
                if (id.compareTo(ids) == 0) {
                    dynamicObject.set("tpv_isrowout",object.getBoolean("tpv_isrowout"));
                    break;
                }
            }

        } else {
            dynamicObject.set("tpv_deliveryorder",null);
        }
    }

    /**
     * 监听保存按钮之后
     *
     * @param e
     */
    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String key = e.getOperateKey();
        if (key.equals("deleteentry")) {
            OperationResult saveOperate = OperationServiceHelper.executeOperate("save", this.getView().getEntityId(),
                    new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
            if (!saveOperate.isSuccess()) {
                this.getView().showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
                return;
            }
            updateParentEntryRowData();
        }
        if (key.equals("save")) {
            DynamicObjectCollection tpvSonentryentity = this.getModel().getEntryEntity("tpv_sonentryentity");
            BigDecimal qty = BigDecimal.ZERO;
//            BigDecimal salesqty = BigDecimal.ZERO;
//            BigDecimal orderqty = BigDecimal.ZERO;
            if (tpvSonentryentity.size() >= 0) {
                for (int i = 0; i < tpvSonentryentity.size(); i++) {
                    DynamicObject dynamicObject = tpvSonentryentity.get(i);
                    BigDecimal tpv_destroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                    BigDecimal tpv_purchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");
                    qty = qty.add(tpv_destroyquantity);
                    //直接查库
//                    salesqty = salesqty.add(tpv_destroyquantity);
//                    orderqty = salesqty.add(tpv_purchasequantity);
                }
            }
            updateParentEntryRowData();

            BigDecimal tpv_pickqty_zy = (BigDecimal) this.getModel().getValue("tpv_pickqty_zy");
            if (qty.compareTo(BigDecimal.ZERO) != 0 && tpv_pickqty_zy.compareTo(BigDecimal.ZERO) != 0) {
                int result = qty.compareTo(tpv_pickqty_zy);
                if (result >= 0) {
                    this.getModel().setValue("tpv_practicalok_zy", true);
                    DynamicObject dataEntity = this.getModel().getDataEntity(true);
                    dataEntity.set("tpv_practicalok_zy", true);
//                    SaveServiceHelper.update(this.getModel().getDataEntity(true));//写入数据库
                    OperationResult saveOperate = OperationServiceHelper.executeOperate("save", this.getView().getEntityId(), new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
                    if (!saveOperate.isSuccess()) {
                        this.getView().showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
                        return;
                    }
//                    this.getView().invokeOperation("refresh");
                }
            }
        }
    }

    /**
     * 按钮操作执行前监听
     * 阻止删行
     *
     * @param args
     */
    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate operate = (FormOperate) args.getSource();
        String key = operate.getOperateKey();
        if (key.equals("deleteentry")) {
            //获取单据体控件
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            //获取选中行，数组为行号，从0开始int[]
            int selectRows[] = entryGrid.getSelectRows();
            //获取单据体数据集合
            DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_sonentryentity");
            if (selectRows != null && selectRows.length > 0) {
                for (int selectRow : selectRows) {
                    int sreak = selectRow + 1;
                    DynamicObject dynamicObject = entity.get(selectRow);  //获取选中行的单据体数据
                    boolean tpvPurchasesuer = dynamicObject.getBoolean("tpv_purchasesuer");
                    boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                    String tpvGodownentry = dynamicObject.getString("tpv_godownentry");
                    String tpvDeliveryorder = dynamicObject.getString("tpv_deliveryorder");
                    if (tpvPurchasesuer || tpvDestroysure || YEM.isNotEmpty(tpvGodownentry) || YEM.isNotEmpty(tpvDeliveryorder)) {
                        args.setCancel(true);
                        this.getView().showErrorNotification("第" + sreak + "行分录采提确认、销提确认任意一个为“是”，或入库单号、出库单号任意一个有值，不允许删除");
                    }
                }
            }
        }
        //监听保存
        if (key.equals("save")) {
            //获取单据体控件
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            //获取选中行，数组为行号，从0开始int[]
            int selectRows[] = entryGrid.getSelectRows();
            if (selectRows.length > 0) {
                for (int selectRow : selectRows) {
                    int selectRowAnd = selectRow + 1;
                    DynamicObjectCollection tpvSonentryentity = this.getModel().getEntryEntity("tpv_sonentryentity");
                    DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                    BigDecimal tpvPurchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");
                    BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                    Boolean tpvPurchasesuer = dynamicObject.getBoolean("tpv_purchasesuer");
                    Boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                    if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) == 0 && tpvDestroyquantity.compareTo(BigDecimal.ZERO) == 0) {
                        args.setCancel(true);
                        this.getView().showErrorNotification("第" + selectRowAnd + "行请填写采提数量或销提数量任意一个再点击保存");
                    }
                    if (tpvPurchasesuer && tpvDestroysure) {
                        args.setCancel(true);
                        if (tpvPurchasesuer && tpvDestroysure) {
                            this.getView().showErrorNotification("第" + selectRowAnd + "行数据采提确认、销提确认已勾选不可保存");
                        } else if (tpvPurchasesuer) {
                            this.getView().showErrorNotification("第" + selectRowAnd + "行数据采提确认已勾选不可保存");
                        } else if (tpvDestroysure) {
                            this.getView().showErrorNotification("第" + selectRowAnd + "行数据销提确认已勾选不可保存");
                        }
                    }
                }
            } else {
                args.setCancel(true);
                this.getView().showErrorNotification("请先选中分录行再点击保存");
            }
        }
    }

    @Override
    public void hyperLinkClick(HyperLinkClickEvent e) {
        // TODO Auto-generated method stub
        int index = e.getRowIndex();
        if ("tpv_billnos".equals(e.getFieldName())) {
            //父配货单据编号
            String tpvFatherpickbill = (String) this.getModel().getValue("tpv_fatherpickbill", index);//父配货单据
            showToBill("tpv_billnos", index, tpvFatherpickbill, "billno");
        }
        if ("tpv_sonbillnos".equals(e.getFieldName())) {
            //子配货单据编号
            String tpvSonbill = (String) this.getModel().getValue("tpv_sonbill", index);//子配货单据
            showToBill("tpv_sonbillnos", index, tpvSonbill, "billno");
        }
        if ("tpv_godownentry".equals(e.getFieldName())) {
            //入库单号
            showToBill("tpv_godownentry", index, "im_purinbill", "billno");
        }
        if ("tpv_deliveryorder".equals(e.getFieldName())) {
            //出库单号
            showToBill("tpv_deliveryorder", index, "im_saloutbill", "billno");
        }
        if ("tpv_profitodd".equals(e.getFieldName())) {
            //盘盈单号
            showToBill("tpv_profitodd", index, "im_otherinbill", "billno");
        }
        if ("tpv_lossodd".equals(e.getFieldName())) {
            //盘亏单号
            showToBill("tpv_lossodd", index, "im_otheroutbill", "billno");
        }
        if ("tpv_purcontract".equals(e.getFieldName())) {
            showToBill("tpv_purcontract", index, "tpv_dt_purchase", "tpv_contractnumber");
        }
        if ("tpv_freigroambillno".equals(e.getFieldName())) {
            showToBill("tpv_freigroambillno", index, "tpv_dt_freigroambill", "billno");
        }
    }

    private void showToBill(String tpv_godownentry, int index, String im_purinbill, String billno) {
        String tpvGodownentry = (String) this.getModel().getValue(tpv_godownentry, index);//入库单号
        DynamicObject im_Purinbill = BusinessDataServiceHelper.loadSingle(im_purinbill, "id",
                new QFilter[]{new QFilter(billno, QCP.equals, tpvGodownentry)});
        if (null != im_Purinbill) {
            skipMethod(im_purinbill, im_Purinbill.getPkValue());
        }
    }

    public void skipMethod(String formId, Object object) {
        BillShowParameter showParameter = new BillShowParameter();
        showParameter.setFormId(formId);
        showParameter.setPkId(object);
        showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
        showParameter.setStatus(OperationStatus.VIEW);
        this.getView().showForm(showParameter);
    }
}
