package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.ComboProp;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * @ClassName 组合号动态查询
 * @Description TODO
 * @Author yang
 * @Date 2023/8/10 11:46
 * @Version 1.0
 */
public class CombinationFormPlugin extends AbstractFormPlugin implements BeforeF7SelectListener{
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        purchaseContract();//采购合同
        salesContract();//销售合同
        perControl();//记事筏
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit tpv_awardtype = (BasedataEdit) this.getView().getControl("tpv_awardtype");
        tpv_awardtype.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        BasedataEdit tpv_departments = (BasedataEdit) this.getView().getControl("tpv_departments");
        tpv_departments.addBeforeF7SelectListener((BeforeF7SelectListener) this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_awardtype":  //提奖类型
                qFilterThisBusinesstype(e);  //过滤当前业务类型
                break;
            case"tpv_departments":
                qFilterThisDepartments(e);
                break;
        }
    }

    private void qFilterThisDepartments(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        List<Long> list = new ArrayList<>();
        DynamicObject[] bosAdminorgs = BusinessDataServiceHelper.load("bos_adminorg", "structure,viewparent", null);
        for (DynamicObject bosAdminorg : bosAdminorgs) {
            DynamicObjectCollection structures = bosAdminorg.getDynamicObjectCollection("structure");
            for (DynamicObject structure : structures) {
                DynamicObject viewparent = structure.getDynamicObject("viewparent");
                if (viewparent!=null){
                    list.add(viewparent.getLong("id"));
                }
            }
        }
        QFilters.add(new QFilter("id", "not in", list));
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    private void qFilterThisBusinesstype(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpv_businesstype = dataEntity.getDynamicObject("tpv_businesstype");
        if (YEM.isEmpty(tpv_businesstype)) return;
        Long id = (Long) tpv_businesstype.get("id");
        QFilters.add(new QFilter("tpv_usebusinesstype.fbasedataid.id", QCP.in, id)); //设置过滤条件：业务类型
        QFilters.add(new QFilter("enable", "=", "1")); //使用状态：可用
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    private void purchaseContract() {
        QFilter[] qFilter = new QFilter[]{new QFilter("billstatus", QCP.equals, "C"),
                new QFilter("tpv_combinationnumber.number", QCP.equals, this.getModel().getValue("number")) };
        String selectStrcg = DynamicObjectUtil.getSelectfields("tpv_dt_purchase", false);
        selectStrcg = DynamicObjectUtil.getEntrySelectfields(selectStrcg,"tpv_dt_purchase","tpv_materialentry",false);
        DynamicObject[] queryCG = BusinessDataServiceHelper.load("tpv_dt_purchase", selectStrcg,qFilter);
        IDataModel model = this.getModel();
        for (DynamicObject obj : queryCG) {
            DynamicObjectCollection entry = obj.getDynamicObjectCollection("tpv_materialentry");
            BigDecimal sumQty = BigDecimal.ZERO;//数量
            BigDecimal price = BigDecimal.ZERO;//单价
            BigDecimal amt = BigDecimal.ZERO;//金额
            String name="";
            String reamrk="";
            for (DynamicObject entity:entry) {
                DynamicObject tpvMaterial = entity.getDynamicObject("tpv_material");//商品
                name = tpvMaterial.getString("name");//名称
                sumQty = entity.getBigDecimal("tpv_qty");//数量
                price = entity.getBigDecimal("tpv_taxprice");//单价
                amt = entity.getBigDecimal("tpv_taxpramount");//金额
                reamrk = entity.getString("tpv_remark");//备注
                List <String> list=new ArrayList();//下拉列表值
                list.add("tpv_contractstatus");
                list.add("tpv_paymentstatus");
                list.add("tpv_incomingticket");
                list.add("tpv_settlementstatus");
                list.add("tpv_cargostatus");
                list.add("tpv_doublesignature");
                list.add("tpv_originalstatus");
                list.add("tpv_insurancestatus");
                String unitName="";
                for (int i = 0; i < list.size(); i++) {
                    MainEntityType mainEntityType = (MainEntityType) obj.getDataEntityType();//获取主实体
                    DataEntityPropertyCollection properties = mainEntityType.getProperties();//获取属性
                    ComboProp comboUnitProp = (ComboProp) properties.get(list.get(i));//获取字段的数据模型
                    String comb = comboUnitProp.getItemByName(obj.getString(list.get(i)));//根据value获取key（标题）
                    if("".equals(unitName)){//循环拼接
                        unitName=comb;
                    }
                    unitName=unitName+","+comb;
                }
                int newEntryRow = this.getModel().createNewEntryRow("tpv_bd_combination_b");//货物流转分录
                model.setValue("tpv_contractnum", obj.getString("billno"), newEntryRow);//合同号
                model.setValue("tpv_supplier", obj.getDynamicObject("tpv_supplier"), newEntryRow);//供应商
                model.setValue("tpv_stateset", unitName, newEntryRow);//状态
                model.setValue("tpv_commodity", tpvMaterial, newEntryRow);//商品编码
                model.setValue("tpv_materialname", name, newEntryRow);//商品名称
                model.setValue("tpv_qty", sumQty, newEntryRow);//数量
                model.setValue("tpv_unitprice", price, newEntryRow);//单价
                model.setValue("tpv_unitamount", amt, newEntryRow);//金额
                model.setValue("tpv_remark", reamrk, newEntryRow);//备注
                model.setValue("tpv_contractype", obj.getDynamicObject("tpv_document").getString("name"), newEntryRow);//合同类型
                model.setValue("tpv_touchingman", obj.getDynamicObject("creator"), newEntryRow);//制单人
                model.setValue("tpv_extracttype", obj.getDynamicObject("tpv_typeofreward"), newEntryRow);//提奖类型
            }
        }
    }

    private void salesContract() {
        QFilter[] qFilter = new QFilter[]{new QFilter("billstatus", QCP.equals, "C"),
                new QFilter("tpv_combinationnumber.number", QCP.equals, this.getModel().getValue("number")),
               new QFilter("tpv_combinationnumber", QCP.not_equals, 0L)};
        String selectStrxs = DynamicObjectUtil.getSelectfields("tpv_dt_salescontract", false);
        selectStrxs = DynamicObjectUtil.getEntrySelectfields(selectStrxs,"tpv_dt_salescontract","tpv_materialentry",false);
        DynamicObject[] queryXS = BusinessDataServiceHelper.load("tpv_dt_salescontract", selectStrxs,qFilter);
        IDataModel model = this.getModel();
        for (DynamicObject obj : queryXS) {
            DynamicObjectCollection entry = obj.getDynamicObjectCollection("tpv_materialentry");
            BigDecimal sumQty = BigDecimal.ZERO;//数量
            BigDecimal price = BigDecimal.ZERO;//单价
            BigDecimal amt = BigDecimal.ZERO;//金额
            String name="";
            String reamrk="";
            for (DynamicObject entity:entry) {
                DynamicObject tpvMaterial = entity.getDynamicObject("tpv_material");//商品
                name = tpvMaterial.getString("name");//名称
                sumQty = entity.getBigDecimal("tpv_qty");//数量
                price = entity.getBigDecimal("tpv_taxprice");//单价
                amt = entity.getBigDecimal("tpv_taxpramount");//金额
                reamrk = entity.getString("tpv_remarks");//备注
                List <String> list=new ArrayList();
                list.add("tpv_contractstatus");
                list.add("tpv_paymentstatus");
                list.add("tpv_cometicketstatus");
                list.add("tpv_settlementstatus");
                list.add("tpv_cargostatus");
                list.add("tpv_doublestatus");
                list.add("tpv_originalstatus");
                list.add("tpv_insurancestatus");
                String unitName="";
                for (int i = 0; i < list.size(); i++) {
                    MainEntityType mainEntityType = (MainEntityType) obj.getDataEntityType();//获取主实体
                    DataEntityPropertyCollection properties = mainEntityType.getProperties();//获取属性
                    ComboProp comboUnitProp = (ComboProp) properties.get(list.get(i));//获取字段的数据模型
                    String comb = comboUnitProp.getItemByName(obj.getString(list.get(i)));//根据value获取key（标题）
                    if("".equals(unitName)){//循环拼接
                        unitName=comb;
                    }
                    unitName=unitName+","+comb;
                }
                int newEntryRow = this.getModel().createNewEntryRow("tpv_bd_combination_c");//销售合同分录
                model.setValue("tpv_contractnums", obj.getString("billno"), newEntryRow);//合同号
                DynamicObject tpvSupplier = obj.getDynamicObject("tpv_supplier");
                model.setValue("tpv_suppliers", tpvSupplier, newEntryRow);//供应商
                model.setValue("tpv_statesets", unitName, newEntryRow);//状态
                model.setValue("tpv_commoditys", tpvMaterial, newEntryRow);//商品编码
                model.setValue("tpv_materialnames", name, newEntryRow);//商品名称
                model.setValue("tpv_qtys", sumQty, newEntryRow);//数量
                model.setValue("tpv_unitprices", price, newEntryRow);//单价
                model.setValue("tpv_unitamounts", amt, newEntryRow);//金额
                model.setValue("tpv_remarks", reamrk, newEntryRow);//备注
                model.setValue("tpv_contractypes", obj.getDynamicObject("tpv_documenttypes").getString("name"), newEntryRow);//合同类型
                model.setValue("tpv_touchingmans", obj.getDynamicObject("creator"), newEntryRow);//制单人
                model.setValue("tpv_extracttypes", obj.getDynamicObject("tpv_awardtype"), newEntryRow);//提奖类型
            }
        }
    }
    
    /**
     * GX
     * 控制记事筏分录可见性
     */
    private void perControl() {
       Long uid=UserServiceHelper.getCurrentUserId();//获取当前用户id
       Long oid=RequestContext.get().getOrgId();//获取当前部门
       DynamicObject dataEntity = this.getModel().getDataEntity(true);
       DynamicObjectCollection bd_combination=dataEntity.getDynamicObjectCollection("tpv_bd_combination_a");//记事筏分录
       DynamicObjectCollection controlcombination=new DynamicObjectCollection();//可见的数据
       if(bd_combination!=null) {
    	   for(DynamicObject combination:bd_combination) {
        	   String visiblescope=combination.getString("tpv_visiblescope");//可选范围
        	   DynamicObject recordmanid=combination.getDynamicObject("tpv_recordman");//记录人
        	   if(visiblescope!=null&&recordmanid!=null) {
        		   Long reid=recordmanid.getLong("id");//记录人id
            	   if("A".equals(visiblescope)) {//个人
            		   if(reid.equals(uid)) {
            			   controlcombination.add(combination);
            		   }
            	   }if("B".equals(visiblescope)) {
            		   String selectFieid2 = DynamicObjectUtil.getSelectfields("bos_user", false);// 获取单据头所有字段标识
                       selectFieid2 = DynamicObjectUtil.getEntrySelectfields(selectFieid2,"bos_user", "entryentity",
                               false);// 获取分录所有字段标识
                		DynamicObject[] bills = BusinessDataServiceHelper.load("bos_user", selectFieid2, new QFilter[] {new QFilter("id",QCP.equals,reid)});
                	   for(DynamicObject entry:bills) {
                		   DynamicObjectCollection entryentity=entry.getDynamicObjectCollection("entryentity");
                		   for(DynamicObject entrty:entryentity) {
                			   Long dptid=entrty.getLong("dpt.id");//部门id
                    		   if(dptid.equals(oid)) {
                    			   controlcombination.add(combination);
                    		   }   
                		   }
                       }
                   }if("C".equals(visiblescope)){
                	   controlcombination.add(combination);
                   }	  
    	        }else {
    	        	return;
    	        }
    	   }
    	   this.getModel().deleteEntryData("tpv_bd_combination_a");
    	   for (DynamicObject personinfor : controlcombination) {
				int index = this.getModel().createNewEntryRow("tpv_bd_combination_a");
				this.getModel().setValue("tpv_incidentclass", personinfor.getString("tpv_incidentclass"),index);
				this.getModel().setValue("tpv_describe", personinfor.getString("tpv_describe"),index);
				this.getModel().setValue("tpv_visiblescope", personinfor.getString("tpv_visiblescope"),index);
				this.getModel().setValue("tpv_recordman", personinfor.getDynamicObject("tpv_recordman"),index);
				this.getModel().setValue("tpv_date", personinfor.getDate("tpv_date"),index);
    	   }
       }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        switch (name){
            case"tpv_strategy":
                tpvStrategy();
                break;
        }
    }

    private void tpvStrategy() {
        DynamicObject tpvStrategy = (DynamicObject) this.getModel().getValue("tpv_strategy");
        if (tpvStrategy!=null){
            this.getModel().deleteEntryData("tpv_splitdepartment");
            DynamicObject tpvBdStrategy = BusinessDataServiceHelper.loadSingle(tpvStrategy.getPkValue(), "tpv_bd_strategy");
            DynamicObjectCollection tpvSplitdepartments= tpvBdStrategy.getDynamicObjectCollection("tpv_splitdepartment");
            for (DynamicObject tpvSplitdepartment : tpvSplitdepartments) {
                int row = this.getModel().createNewEntryRow("tpv_splitdepartment");
                this.getModel().setValue("tpv_departmententry",tpvSplitdepartment.get("tpv_departmententry"),row);
                this.getModel().setValue("tpv_allocationmethod",tpvSplitdepartment.get("tpv_allocationmethod"),row);
                this.getModel().setValue("tpv_servicefeeunitprice",tpvSplitdepartment.get("tpv_servicefeeunitprice"),row);
                this.getModel().setValue("tpv_apercentage",tpvSplitdepartment.get("tpv_apercentage"),row);
            }
        }else {
            this.getModel().deleteEntryData("tpv_splitdepartment");
        }
    }
}