package tpv.tpv_wm.tpv_dt.java.formplugin.form;


import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.data.BusinessDataReader;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.botp.runtime.SourceBillReport;
import kd.bos.entity.datamodel.IRefrencedataProvider;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.form.operate.FormOperate;
import kd.bos.form.operate.botp.Push;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;
import java.util.Map;

/**
 * 库存拣配业务底表表单插件
 * WangShuGuang
 */
public class ConfiguraFormPlugin extends AbstractFormPlugin implements HyperLinkClickListener {


    private final String IM_OTHEROUTBILL = "im_otheroutbill";//其他出库单

    private final String IM_OTHERINBILL = "im_otherinbill";//其他入库

    private final String TPV_DT_SALESSHIPPING = "tpv_dt_salesshipping";//销售发货

    private final String IM_SALOUTBILL = "im_saloutbill";//销售出库

    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"advcontoolbarap"});
        this.addClickListeners("newentry"); // 监听确认和取消按钮
        this.addClickListeners("tb_new");
        this.addClickListeners("tpv_save");
        this.addItemClickListeners("advcontoolbarap");
        EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
        entryGrid.addHyperClickListener(this);
    }

    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        super.afterAddRow(e);
        String name = e.getEntryProp().getName();
        RowDataEntity[] rowIndex = e.getRowDataEntities();
        if (StringUtils.equals("tpv_sonentryentity", name)) {
            outCoefficient(rowIndex);
        }
    }

    @Override
    public void beforeItemClick(BeforeItemClickEvent evt) {
        super.beforeItemClick(evt);
        String itemKey = evt.getItemKey();
        if ("tb_del".equals(itemKey)){
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            SaveServiceHelper.save(new DynamicObject[]{dataEntity});
        }
    }
    /**
     * 单据打开查出入库单号
     *
     * @param e
     */
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
//        DynamicObject dataEntity = this.getModel().getDataEntity(true);
//        DynamicObjectCollection tpvSonentryentity = dataEntity.getDynamicObjectCollection("tpv_sonentryentity");
//        if (tpvSonentryentity.size()==0){
//            this.getModel().createNewEntryRow("tpv_sonentryentity");
//        }
//        selectMust();
        mufAdd();
    }

    public void mufAdd(){
        Boolean ifFlag=true;
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvSonentryentitys = dataEntity.getDynamicObjectCollection("tpv_sonentryentity");
        if (tpvSonentryentitys.size()==0){
            this.getView().setEnable(true, "tb_new");
        }
        for (DynamicObject tpvSonentryentity : tpvSonentryentitys) {
            boolean tpvDestroysure = tpvSonentryentity.getBoolean("tpv_destroysure");
            if (!tpvDestroysure){
                ifFlag=false;
            }
        }
        if (ifFlag){
            this.getView().setEnable(false, "tb_new");
        }else {
            this.getView().setEnable(true, "tb_new");
        }
    }
    /**
     * 监听销提数量字段
     *
     * @param e
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        // TODO Auto-generated method stub
        super.propertyChanged(e);
        String propertyName = e.getProperty().getName();
        mufAdd();
        if (propertyName.equals("tpv_destroyquantity")) {
            IFormView view = this.getView().getParentView();
            int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
            DynamicObject tpvEntryentity1 = view.getModel().getEntryRowEntity("tpv_entryentity", tpvEntryentity);
            //获取库存拣配工作台数量
            BigDecimal tpvDestroyquantity1 = tpvEntryentity1.getBigDecimal("tpv_qty");
            //获取分录数据
            DynamicObject dataEntitys = this.getModel().getDataEntity(true);
            DynamicObjectCollection detailedinformation = dataEntitys.getDynamicObjectCollection("tpv_sonentryentity");
            BigDecimal qtyShopp = BigDecimal.ZERO;
            for (DynamicObject dynamicObject : detailedinformation) {
                BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                qtyShopp = qtyShopp.add(tpvDestroyquantity);
            }
            int message = tpvDestroyquantity1.compareTo(qtyShopp);
            if (message < 0) {
                EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
                int[] selectRows = entryGrid.getSelectRows();
                for (int selectRow : selectRows) {
                    this.getModel().setValue("tpv_destroyquantity", null, selectRow);
                }
                this.getView().showMessage("分录销提数量汇总不得大于上方数量值");
            }
        }
    }

    /**
     * 增行时表头系数赋值到分录
     */
    private void outCoefficient(RowDataEntity[] dataentuty) {
        for (RowDataEntity rowdata : dataentuty) {
            int row = rowdata.getRowIndex();
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObject tpvMaterialZy = (DynamicObject) this.getModel().getValue("tpv_material_in");//商品
            DynamicObject tpvProdnameZy = (DynamicObject) this.getModel().getValue("tpv_prodname_in");//品名
            String tpvShaderZy = (String) this.getModel().getValue("tpv_shader_in");//材质
            String tpvSpecationZy = (String) this.getModel().getValue("tpv_specation_in");//规格
            DynamicObject tpvOriginZy = (DynamicObject) this.getModel().getValue("tpv_origin_in");//产地
            String tpvPickbillZy = (String) this.getModel().getValue("tpv_pickbill_in");//配货单据
            String tpvBillnoZy = (String) this.getModel().getValue("tpv_billno_in");//单据编号
            DynamicObject tpvSupplierZy = (DynamicObject) this.getModel().getValue("tpv_supplier_in");//供应商
            Long tpvFidZy = (Long) this.getModel().getValue("tpv_fid_in");//采购单据id
            if (null != tpvMaterialZy) {
                this.getModel().setValue("tpv_materials", tpvMaterialZy, row);
                DynamicObject auxptyunit = tpvMaterialZy.getDynamicObject("auxptyunit");//辅助单位
                if (null == auxptyunit) {
                    this.getView().setEnable(false, row, "tpv_ofpackages");//锁定分录包装数量字段
                }
            }
            if (null != tpvProdnameZy) {
                this.getModel().setValue("tpv_prodnames", tpvProdnameZy, row);
            }
            if (null != tpvPickbillZy && "" != tpvPickbillZy) {
                this.getModel().setValue("tpv_fatherpickbill", tpvPickbillZy, row);
                this.getModel().setValue("tpv_sonbill", tpvPickbillZy, row);//子配货单据
            }
            if (null != tpvBillnoZy && "" != tpvBillnoZy) {
                this.getModel().setValue("tpv_billnos", tpvBillnoZy, row);
                this.getModel().setValue("tpv_sonbillnos", tpvBillnoZy, row);//子配货单据编号
            }
            if (null != tpvSupplierZy) {
                this.getModel().setValue("tpv_suppliers", tpvSupplierZy, row);
            }
            if (null != tpvShaderZy && "" != tpvShaderZy) {
                this.getModel().setValue("tpv_shaders", tpvShaderZy, row);
            }
            if (null != tpvSpecationZy && "" != tpvSpecationZy) {
                this.getModel().setValue("tpv_specations", tpvSpecationZy, row);
            }
            if (null != tpvOriginZy) {
                this.getModel().setValue("tpv_origins", tpvOriginZy, row);
            }
            if (null != tpvFidZy && tpvFidZy > 0L) {  //添加采购合同号
                DynamicObject random = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", "id,tpv_contractnumber",
                        new QFilter[]{new QFilter("id", QCP.equals, Long.valueOf(tpvFidZy))});
                if (null != random) {
                    this.getModel().setValue("tpv_purcontract", random.getString("tpv_contractnumber"), row);
                }
            }
            Long configurabottomId = (Long) this.getModel().getValue("tpv_dt_configurabottom.id");
            this.getModel().setValue("tpv_fatherid", configurabottomId, row);
        }
    }

    public void selectMust() {
        DynamicObjectCollection tpvSonentryentity = this.getView().getModel().getEntryEntity("tpv_sonentryentity");
        for (DynamicObject dynamicObject : tpvSonentryentity) {
            BigDecimal tpvPurchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");//采提数量
            BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");//采提数量
            int seq = dynamicObject.getInt("Seq");
            int seqSmale = seq - 1;
            Long id = (Long) dynamicObject.getPkValue();
            if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && tpvDestroyquantity.compareTo(BigDecimal.ZERO) != 0) {
                int bigSmal = tpvPurchasequantity.compareTo(tpvDestroyquantity);
                if (bigSmal == 0) {
                    //销提数量等于采提数量查询采购入库单号和销售出库单号
                    //采购入库
                    DynamicObject tpv_dt_purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //销售出库
                    DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    /*if (null != tpv_dt_purinbill) {
                        //插入入库单号
                        this.getModel().setValue("tpv_godownentry", tpv_dt_purinbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_godownentry", null, seqSmale);
                    }*/
                    if (null != im_saloutbill) {
                        //插入出库单号
                        this.getModel().setValue("tpv_deliveryorder", im_saloutbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_deliveryorder", null, seqSmale);
                    }
                }
                if (bigSmal > 0) {
                    //采提数量大于销提数量时查询入库单号 出库单号 盘亏单号
                    //采购入库
                    DynamicObject tpv_dt_purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //销售出库
                    DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //其他出库
                    DynamicObject im_otheroutbill = BusinessDataServiceHelper.loadSingle("im_otheroutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                   /* if (null != tpv_dt_purinbill) {
                        //插入入库单号
                        this.getModel().setValue("tpv_godownentry", tpv_dt_purinbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_godownentry", null, seqSmale);
                    }*/
                    if (null != im_saloutbill) {
                        //插入出库单号
                        this.getModel().setValue("tpv_deliveryorder", im_saloutbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_deliveryorder", null, seqSmale);
                    }
                    if (null != im_otheroutbill) {
                        //插入盘亏单号
                        this.getModel().setValue("tpv_lossodd", im_otheroutbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_lossodd", null, seqSmale);
                    }
                }
                if (bigSmal < 0) {
                    //采提数量小于销提数量时查询入库单号 出库单号 盘盈单号
                    //采购入库
                    DynamicObject tpv_dt_purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //销售出库
                    DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //其他入库
                    DynamicObject im_otherinbill = BusinessDataServiceHelper.loadSingle("im_otherinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    if (null != tpv_dt_purinbill) {
                        this.getModel().setValue("tpv_sonbill", "im_purinbill", seqSmale);
                        this.getModel().setValue("tpv_sonbillnos", tpv_dt_purinbill.getString("billno"), seqSmale);
                        //插入入库单号
                        //this.getModel().setValue("tpv_godownentry", tpv_dt_purinbill.getString("billno"), seqSmale);
                    } else {
                        // this.getModel().setValue("tpv_godownentry", null, seqSmale);
                    }
                    if (null != im_saloutbill) {
                        //插入出库单号
                        this.getModel().setValue("tpv_deliveryorder", im_saloutbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_deliveryorder", null, seqSmale);
                    }
                    if (null != im_otherinbill) {
                        //插入出库单号
                        this.getModel().setValue("tpv_profitodd", im_otherinbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_profitodd", null, seqSmale);
                    }
                }
            }
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        //
        super.itemClick(evt);
        String key = evt.getItemKey();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvSonentryentity = this.getView().getModel().getEntryEntity("tpv_sonentryentity");
        if (StringUtils.equals("tpv_advconbaritemap1", key)) {
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            int[] selectRows = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                if (tpvDestroyquantity.compareTo(BigDecimal.ZERO) != 0) {
                    this.getModel().setValue("tpv_destroysure", true, selectRow);
                    dynamicObject.set("tpv_destroysure", true);
                    //SaveServiceHelper.save(new DynamicObject[] {dynamicObject});
                    SaveServiceHelper.update(dynamicObject);
                    OperateOption optionOne = YEM.getOption();
                    OperationResult saveOneS = OperationServiceHelper.executeOperate("save", "tpv_dt_configurabottom",
                            new DynamicObject[]{dataEntity}, optionOne);
                    this.getView().updateView("tpv_sonentryentity.tpv_destroysure", selectRow);
                } else {
                    this.getView().showMessage("请填写销提数量后再点击物流确认销售实提按钮");
                }
            }
            //判断数量实提完毕自动打勾
            DynamicObjectCollection tpvSonentryentityS = this.getModel().getEntryEntity("tpv_sonentryentity");
            BigDecimal qty = BigDecimal.ZERO;
            if (tpvSonentryentityS.size() >= 0) {
                for (int selectRow : selectRows) {
                    DynamicObject dynamicObject = tpvSonentryentityS.get(selectRow);
                    //销提数量
                    BigDecimal tpv_destroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                    qty = qty.add(tpv_destroyquantity);
                }
            }
            BigDecimal tpv_qty = (BigDecimal) this.getModel().getValue("tpv_pickqty_in");
            if (qty.compareTo(BigDecimal.ZERO) != 0 && tpv_qty.compareTo(BigDecimal.ZERO) != 0) {
                int result = qty.compareTo(tpv_qty);
                if (result >= 0) {
                    this.getModel().setValue("tpv_practicalok_in", true);
                    DynamicObject dataEntityS = this.getModel().getDataEntity(true);
                    dataEntityS.set("tpv_practicalok_in", true);
                    SaveServiceHelper.update(dataEntityS);//写入数据库
                    IFormView view = this.getView().getParentView();
                    int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
                    view.getModel().setValue("tpv_realsubmit", true, tpvEntryentity);
                    this.getView().sendFormAction(view);
                } else {
                    this.getModel().setValue("tpv_practicalok_in", false);
                    DynamicObject dataEntityS = this.getModel().getDataEntity(true);
                    dataEntityS.set("tpv_practicalok_in", false);
                    SaveServiceHelper.update(dataEntityS);//写入数据库
                    IFormView view = this.getView().getParentView();
                    int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
                    view.getModel().setValue("tpv_realsubmit", false, tpvEntryentity);
                    this.getView().sendFormAction(view);
                }
            }
        }
        if (StringUtils.equals("tpv_advconbaritemap1no", key)) {
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            int[] selectRows = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                this.getModel().setValue("tpv_destroysure", false, selectRow);
                DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                dynamicObject.set("tpv_destroysure", false);
                SaveServiceHelper.update(dynamicObject);
                this.getView().updateView("tpv_sonentryentity.tpv_destroysure", selectRow);
            }
        }
        if (StringUtils.equals("tpv_appearenter", key)) {
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            int[] selectRows = entryGrid.getSelectRows();
            //获取单据主实体
            DynamicObject dataEntitys = this.getModel().getDataEntity(true);
            DynamicObject tpv_dt_configurabottom = BusinessDataServiceHelper.loadSingle("tpv_dt_configurabottom", "id,tpv_sonentryentity",
                    new QFilter("id", QCP.equals, dataEntitys.getLong("id")).toArray());
            tpv_dt_configurabottom = BusinessDataServiceHelper.loadSingle(tpv_dt_configurabottom.getPkValue(),
                    tpv_dt_configurabottom.getDynamicObjectType().getName());
            //获取分录数据
            DynamicObjectCollection detailedinformation = tpv_dt_configurabottom.getDynamicObjectCollection("tpv_sonentryentity");
            List<String> strings = new ArrayList<>();
            if (detailedinformation.size() > 0){
                if (selectRows.length > 0){
                    for (int selectRow : selectRows) {
                        int message = 1 + selectRow;
                        DynamicObject dynamicObject = detailedinformation.get(selectRow);
                        boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                        String tpvDeliveryorder = (String)this.getModel().getValue("tpv_deliveryorder",selectRow);
                        //String tpvDeliveryorder = dynamicObject.getString("tpv_deliveryorder");
                        if (!tpvDestroysure) {
                            strings.add("第" + message + "行销提确认为否不可+出入库单");
                        }
                        if (YEM.isNotEmpty(tpvDeliveryorder)) {
                            strings.add("第" + message + "行出库单号不为空不可+出入库单");
                        }
                    }
                } else {
                    strings.add("请先选中行再点击+出入库单");
                }
                String result = String.join(", ", strings);
                if (strings.size() > 0) {
                    this.getView().showMessage(result);
                } else {
                    // 创建弹出动态表单页面对象
                    FormShowParameter showParameter = new FormShowParameter();
                    // 设置弹出页面的标识
                    showParameter.setFormId("tpv_dt_inventoryschedule");
                    // 状态
                    showParameter.setStatus(OperationStatus.ADDNEW);
                    // 设置页面关闭回调方法
                    // CloseCallBack参数：回调插件，回调标识
                    showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_designate"));
                    // 设置弹出页面打开方式
                    showParameter.getOpenStyle().setShowType(ShowType.Modal);
                    // 打开动态表单
                    this.getView().showForm(showParameter);
                /*List<String> tips = new ArrayList<>();
                // 获取单据体选中行
                EntryGrid entryGridS = this.getView().getControl("tpv_sonentryentity");
                int[] selectRowsS = entryGridS.getSelectRows();
                //获取单据主实体
                DynamicObject dataEntitysS = this.getModel().getDataEntity(true);
                //获取分录数据
                DynamicObjectCollection detailedinformationS = dataEntitysS.getDynamicObjectCollection("tpv_sonentryentity");
                Long a = (Long) this.getModel().getValue("id");
                QFilter qFilter = new QFilter("tpv_materialentry.tpv_dt_salepick_in", QCP.equals, a);
                String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
                DynamicObject tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
                Long pkValueTwo = (Long) tpvScBusinessnatures.getPkValue();
                BigDecimal qty = BigDecimal.ZERO;
                BigDecimal qtyShopp = BigDecimal.ZERO;
                Map<String, Object> map1 = new HashMap<>();
                Map<Long, Map<String, Object>> mapt = new HashMap<>();
                List<Map<String, Object>> pushParam = new ArrayList<>();
                for (int rowsS : selectRowsS) {
                    DynamicObject dynamicObject = detailedinformationS.get(rowsS);
                    long pkValueS = dynamicObject.getLong("id");
                    qty = qty.add(dynamicObject.getBigDecimal("tpv_destroyquantity"));
                    qtyShopp = qtyShopp.add(dynamicObject.getBigDecimal("tpv_destroyquantity"));
                    map1.put("tpv_materials", dynamicObject.getBigDecimal("tpv_destroyquantity"));//数量
                    BigDecimal tpvOfpackages = dynamicObject.getBigDecimal("tpv_ofpackages");
                    map1.put("tpv_ofpackages", dynamicObject.getBigDecimal("tpv_ofpackages"));//包装数量
                    map1.put("tpv_shaders", dynamicObject.getString("tpv_shaders"));//材质
                    map1.put("tpv_specations", dynamicObject.getString("tpv_specations"));//规格
                    map1.put("tpv_prodnames", dynamicObject.getLong("tpv_prodnames.id"));//品名
                    map1.put("tpv_origins", dynamicObject.getLong("tpv_origins.id"));//产地
                    map1.put("tpv_directconsignmentid", pkValueS);//底表分录id
                    pushParam.add(map1);
                }
                List<ListSelectedRow> selectedRowsTwo = new ArrayList<>();
                ListSelectedRow listSelectedRowTwo = new ListSelectedRow(pkValueTwo);//来源单据ID
                listSelectedRowTwo.setSubEntryEntityKey("tpv_dt_salepick_in");//来源单据单据体标识
                listSelectedRowTwo.setSubEntryPrimaryKeyValue(a);//来源单据分录ID
                selectedRowsTwo.add(listSelectedRowTwo);
                PushArgs pushArgsTwo = new PushArgs();
                pushArgsTwo.addCustomParam("tpv_longList", JSONObject.toJSONString(pushParam));
                pushArgsTwo.addCustomParam("tpv_longList_id", String.valueOf(a));
                pushArgsTwo.setSourceEntityNumber(TPV_DT_SALESSHIPPING); // 必选，源单标识
                pushArgsTwo.setTargetEntityNumber(IM_SALOUTBILL); // 必选，目标单标识
                pushArgsTwo.setAutoSave(true);//是否保存
                pushArgsTwo.setRuleId("1798694713818135552"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
                pushArgsTwo.setBuildConvReport(true); // 是否输出详细错误报告
                pushArgsTwo.setSelectedRows(selectedRowsTwo); // 必选，设置需要下推的源单及分录内码
                ConvertOperationResult pushResultTwo = ConvertServiceHelper.push(pushArgsTwo);
                if (pushResultTwo.isSuccess()) {
                    MainEntityType targetMainTypeOne = EntityMetadataCache
                            .getDataEntityType(pushArgsTwo.getTargetEntityNumber());
                    List<DynamicObject> targetBillObjsOne = pushResultTwo
                            .loadTargetDataObjects(new IRefrencedataProvider() {
                                @Override
                                public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                                    BusinessDataReader.loadRefence(objs, dType);
                                }
                            }, targetMainTypeOne);
                    if (targetBillObjsOne.size() > 0) {
                        DynamicObject targetBillObjOne = targetBillObjsOne.get(0);
                        if (auditBill(targetBillObjOne, tips)) {
                            selectMust();
                        }
                    }
                } else {
                    addCovertMsg(IM_SALOUTBILL, pushResultTwo, tips);
                }
                if (tips.size() > 0) {
                    String errMsg = "";
                    int msgSeq = 1;
                    for (String tip : tips) {
                        errMsg += String.format("%s、%s%s", msgSeq++, tip, "\r\n");
                    }
                    this.getView().showMessage("存在异常单据，详情如下。", errMsg, MessageTypes.Default);
                } else {
                    this.getView().showSuccessNotification("出入库成功！");
                }*/


                /*Map<Long, Map<String, Object>> mapt = new HashMap<>();
                Map<String, Object> map1 = new HashMap<>();
                // 获取单据体选中行
                int tpvSonentryentity1 = this.getModel().getEntryCurrentRowIndex("tpv_sonentryentity");
                DynamicObject dynamicObject = tpvSonentryentity.get(tpvSonentryentity1);
                BigDecimal tpvGaplimit = dynamicObject.getBigDecimal("tpv_gaplimit");
                BigDecimal tpvPurchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");//采提数量
                BigDecimal tpv_destroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");//销提数量
                BigDecimal tpv_gaplimit = dynamicObject.getBigDecimal("tpv_gaplimit");//差额
                BigDecimal tpv_pickqty_in = (BigDecimal) this.getModel().getValue("tpv_pickqty_in");//本次配货数量*/
                /*if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && tpv_destroyquantity.compareTo(BigDecimal.ZERO) != 0) {
                    Map<String, Long> map = new HashMap<>();
                    Map<String, String> mapString = new HashMap<>();
                    Long tpv_fentryid_zy = (Long) dataEntity.getPkValue();
                    map1.put("tpv_materials", dynamicObject.getLong("tpv_materials.id"));//商品
                    map1.put("tpv_prodnames", dynamicObject.getLong("tpv_prodnames.id"));//品名
                    map1.put("tpv_gaplimit", tpv_gaplimit);//差额
                    map1.put("tpv_shaders", dynamicObject.getString("tpv_shaders"));//材质
                    map1.put("tpv_specations", dynamicObject.getString("tpv_specations"));//规格
                    map1.put("tpv_origins", dynamicObject.getLong("tpv_origins.id"));//产地
                    map1.put("tpv_ofpackages", dynamicObject.getBigDecimal("tpv_ofpackages"));//包装数量
                    mapt.put(tpv_fentryid_zy, map1);
                    int message = tpvPurchasequantity.compareTo(tpv_destroyquantity);
                    //当采提数量和销提数量都不为空时
                    *//*if (!tpvPurchasequantity.equals(tpv_destroyquantity)) {
                        //当采提数量和销提数量不相等时
                        if (message > 0) {
                            Map<String, Object> customParams = this.getView().getFormShowParameter().getCustomParams();
                            String tpv_srcentryid = (String) customParams.get("tpv_srcentryid");
                            Long num = Long.valueOf(tpv_srcentryid);
                            tpv_pickqty_in = tpv_pickqty_in.add(tpvGaplimit);
                            dataEntity.set("tpv_pickqty_in", tpv_pickqty_in);
                            SaveServiceHelper.update(dataEntity);
                            //当父配货单据为采购入库 用采购入库下推其他出库
                            //Long tpv_fid_in = (Long) this.getModel().getValue("tpv_fid_in");//采购单据ID
                            //Long tpv_fentryid_in = (Long) this.getModel().getValue("tpv_fentryid_in");//采购单据分录行ID
                            map.put("tpv_fid_in", num);
                            map.put("tpv_fentryid_in", tpv_fentryid_zy);
                            mapString.put("sourceS", TPV_DT_SALESSHIPPING);//来源单据标识
                            mapString.put("targetS", IM_OTHEROUTBILL);//目标单据标识
                            mapString.put("billentry", "tpv_materialentry");//来源单据标识
                            mapString.put("ruleId", "1783684561188698112");
                            pushMethod(map, mapString, mapt, message);
                        }
                        if (message < 0) {
                            Map<String, Object> customParams = this.getView().getFormShowParameter().getCustomParams();
                            String tpv_srcentryid = (String) customParams.get("tpv_srcentryid");
                            Long num = Long.valueOf(tpv_srcentryid);
                            //当父配货单据为采购入库 用采购入库下推其他出库
                            //Long tpv_fid_in = (Long) this.getModel().getValue("tpv_fid_in");//采购单据ID
                            //Long tpv_fentryid_in = (Long) this.getModel().getValue("tpv_fentryid_in");//采购单据分录行ID
                            map.put("tpv_fid_in", num);
                            map.put("tpv_fentryid_in", tpv_fentryid_zy);
                            mapString.put("sourceS", TPV_DT_SALESSHIPPING);//来源单据标识
                            mapString.put("targetS", IM_OTHERINBILL);//目标单据标识
                            mapString.put("billentry", "tpv_materialentry");//来源单据标识
                            mapString.put("ruleId", "1783700246862290944");
                            pushMethod(map, mapString, mapt, message);
                        }
                    }*//*
                }*/
                }
            }
        }

    }

    private void addCovertMsg(String entityNumber, ConvertOperationResult pushResult, List<String> tips) {
        MainEntityType dataEntityType = YEM.getDataEntityType(entityNumber);
        String entityName = dataEntityType.getDisplayName().getLocaleValue();
        String msg = pushResult.getMessage();
        List<SourceBillReport> billReports = pushResult.getBillReports();
        for (int i = 0; i < billReports.size(); i++) {
            SourceBillReport sourceBillReport = billReports.get(i);
            msg = i == 0 ? msg + "。原因:" : msg;
            msg += String.format("%s、%s ", i + 1, sourceBillReport.getFailMessage());
        }
        tips.add(String.format("下推【%s】失败。%s ", entityName, msg));
        //this.getView().showMessage(String.format("下推【%s】失败。%s", entityName, msg));
    }

    private boolean auditBill(DynamicObject targetBillObjOne, List<String> tips) {
        DynamicObjectType dynamicObjectType = targetBillObjOne.getDynamicObjectType();
        String entityName = dynamicObjectType.getDisplayName().getLocaleValue();
        String entityNumber = dynamicObjectType.getName();
        OperateOption optionOne = YEM.getOption();
        //option.setVariableValue("linkage", Boolean.toString(true));
        OperationResult saveOne = OperationServiceHelper.executeOperate("save", entityNumber,
                new DynamicObject[]{targetBillObjOne}, optionOne);
        if (saveOne.isSuccess()) {
            OperationResult submitOne = OperationServiceHelper.executeOperate("submit",
                    entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
            if (submitOne.isSuccess()) {
                OperationResult auditOne = OperationServiceHelper.executeOperate("audit",
                        entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
                if (auditOne.isSuccess()) {
//		            this.getView().showMessage(String.format("《%s》审核成功", entityName));
                    return true;
                } else {
                    tips.add(String.format("【%s】审核失败。%s", entityName, YEM.getOpMsg(auditOne)));
                    //this.getView().showMessage(String.format("【%s】审核失败。%s", entityName, YEM.getOpMsg(auditOne)));
                }
            } else {
                tips.add(String.format("【%s】提交失败。%s", entityName, YEM.getOpMsg(submitOne)));
                //this.getView().showMessage(String.format("【%s】提交失败。%s", entityName, YEM.getOpMsg(submitOne)));
            }
        } else {
            tips.add(String.format("【%s】保存失败。%s", entityName, YEM.getOpMsg(saveOne)));
            //this.getView().showMessage(String.format("【%s】保存失败。%s", entityName, YEM.getOpMsg(saveOne)));
        }
        return false;
    }

    /**
     * 下推方法
     */
    public void pushMethod(Map<String, Long> map, Map<String, String> mapString, Map<Long, Map<String, Object>> mapt, int message) {
        // 获取单据体选中行
        int tpvSonentryentity = this.getModel().getEntryCurrentRowIndex("tpv_sonentryentity");
        //获取分录数据
        DynamicObject dynamicObjectSter = this.getModel().getEntryRowEntity("tpv_sonentryentity", tpvSonentryentity);
        long pkValueS = (Long) dynamicObjectSter.getPkValue();
        Map<String, Object> customParams = this.getView().getFormShowParameter().getCustomParams();
        IFormView view = this.getView().getParentView();
        String tpv_seleid = (String) view.getModel().getValue("tpv_srcentryid", view.getModel().getEntryCurrentRowIndex("tpv_entryentity"));
        OperateOption option = YEM.getOption();
        Long a = (Long) this.getModel().getValue("id");
        QFilter qFilter = new QFilter("tpv_materialentry.tpv_dt_salepick_in", QCP.equals, a);
        String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_dt_salesshipping");
        DynamicObject tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle("tpv_dt_salesshipping", selectfieldsFast, new QFilter[]{qFilter});
        List<String> tips = new ArrayList<>();
        Long tpvFidIn = map.get("tpv_fid_in");//来源单据ID
        Long tpvFentryidIn = map.get("tpv_fentryid_in");//来源单据分录ID
        List<ListSelectedRow> selectedRows = new ArrayList<>();
        ListSelectedRow listSelectedRow = new ListSelectedRow(tpvFidIn);//来源单据ID
        listSelectedRow.setEntryEntityKey(mapString.get("billentry"));//来源单据父单据体标识
        listSelectedRow.setEntryPrimaryKeyValue(tpv_seleid);//来源单据父分录ID
        listSelectedRow.setSubEntryEntityKey("tpv_dt_salepick_in");
        listSelectedRow.setSubEntryPrimaryKeyValue(tpvFentryidIn);
        selectedRows.add(listSelectedRow);
        PushArgs pushArgs = new PushArgs();
        pushArgs.setSourceEntityNumber(mapString.get("sourceS")); // 必选，源单标识
        pushArgs.addCustomParam("tpv_longList", JSONObject.toJSONString(mapt));
        pushArgs.setTargetEntityNumber(mapString.get("targetS")); // 必选，目标单标识
        //pushArgs.addCustomParam("tpv_longList", JSONObject.toJSONString(mapt));
        // pushArgs.setHasRight(false); // 可选，传入true，不检查目标单新增权
        // pushArgs.setAppId("pur"); // 可选，传入目标单验权使用的应用编码
        pushArgs.setAutoSave(true);//是否保存
        pushArgs.setRuleId(mapString.get("ruleId")); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
        pushArgs.setBuildConvReport(true); // 是否输出详细错误报告
        pushArgs.setSelectedRows(selectedRows); // 必选，设置需要下推的源单及分录内码
        ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
        if (pushResult.isSuccess()) {
            MainEntityType targetMainType = EntityMetadataCache
                    .getDataEntityType(pushArgs.getTargetEntityNumber());
            List<DynamicObject> targetBillObjs = pushResult
                    .loadTargetDataObjects(new IRefrencedataProvider() {
                        @Override
                        public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                            BusinessDataReader.loadRefence(objs, dType);
                        }
                    }, targetMainType);
            if (targetBillObjs.size() > 0) {
                DynamicObject dynamicObject = targetBillObjs.get(0);
                DynamicObjectType dynamicObjectType = dynamicObject.getDynamicObjectType();
                String entityName = dynamicObjectType.getDisplayName().getLocaleValue();
                String entityNumber = dynamicObjectType.getName();
                OperateOption optionOne = YEM.getOption();
                //option.setVariableValue("linkage", Boolean.toString(true));
                OperationResult saveOne = OperationServiceHelper.executeOperate("save", entityNumber,
                        new DynamicObject[]{dynamicObject}, optionOne);
                if (saveOne.isSuccess()) {
                    OperationResult submitOne = OperationServiceHelper.executeOperate("submit",
                            entityNumber, new Object[]{dynamicObject.getPkValue()}, optionOne);
                    if (submitOne.isSuccess()) {
                        OperationResult auditOne = OperationServiceHelper.executeOperate("audit",
                                entityNumber, new Object[]{dynamicObject.getPkValue()}, optionOne);
                        if (auditOne.isSuccess()) {
                            if (mapString.get("targetS").equals(IM_OTHEROUTBILL)) {
                                this.getModel().setValue("tpv_lossodd", dynamicObject.getString("billno"), tpvSonentryentity);
                                dynamicObjectSter.set("tpv_lossodd", dynamicObject.getString("billno"));
                                SaveServiceHelper.update(dynamicObjectSter);
                                this.getView().updateView("tpv_sonentryentity");
                            }
                            if (mapString.get("targetS").equals(IM_OTHERINBILL)) {
                                this.getModel().setValue("tpv_profitodd", dynamicObject.getString("billno"), tpvSonentryentity);
                                dynamicObjectSter.set("tpv_profitodd", dynamicObject.getString("billno"));
                                SaveServiceHelper.update(dynamicObjectSter);
                                this.getView().updateView("tpv_sonentryentity");
                            }
                            if (message < 0) {
                                if (QueryServiceHelper.exists("tpv_dt_salesshipping", tpvScBusinessnatures.getPkValue())) {
                                    tpvScBusinessnatures = BusinessDataServiceHelper.loadSingle(tpvScBusinessnatures.getPkValue(),
                                            tpvScBusinessnatures.getDynamicObjectType().getName());
                                    DynamicObjectCollection objectCollection = tpvScBusinessnatures.getDynamicObjectCollection("tpv_materialentry");
                                    DynamicObjectCollection billentry = dynamicObject.getDynamicObjectCollection("billentry");
                                    for (DynamicObject dynamicObjectS : objectCollection) {
                                        DynamicObjectCollection qtpvDtSalepickZy = dynamicObjectS.getDynamicObjectCollection("tpv_dt_salepick_in");
                                        Long pkValue1 = (Long) dynamicObjectS.getPkValue();
                                        if (StringUtils.equals(tpv_seleid, pkValue1.toString())) {
                                            DynamicObject dynamicObject1 = qtpvDtSalepickZy.addNew();
                                            for (DynamicObject object : billentry) {
                                                dynamicObject1.set("tpv_pickbill_in", "im_purinbill");//配货单据为采购入库
                                                dynamicObject1.set("tpv_billno_in", dynamicObject.getString("billno"));//单据编号
                                                dynamicObject1.set("tpv_material_in", object.getDynamicObject("material"));//商品编码
                                                dynamicObject1.set("tpv_prodname_in", object.getDynamicObject("tpv_prodname"));//品名
                                                dynamicObject1.set("tpv_specation_in", object.getString("tpv_specation"));//规格
                                                dynamicObject1.set("tpv_shader_in", object.getString("tpv_shader"));//材质
                                                dynamicObject1.set("tpv_origin_in", object.getDynamicObject("tpv_origin"));//产地
                                                dynamicObject1.set("tpv_measure", object.getDynamicObject("unit"));//计量单位
                                                dynamicObject1.set("tpv_fpackages", object.getBigDecimal("tpv_packnum"));//包装数量
                                                dynamicObject1.set("tpv_fid_in", dynamicObject.getPkValue());//采购单据id
                                                dynamicObject1.set("tpv_fentryid_in", object.getPkValue());//采购分录行ID
                                                //dynamicObject1.set("tpv_fcoentryid_in", object.getLong("conbillentryid"));//采购合同行ID
                                                if (dynamicObjectS.getBigDecimal("tpv_confirmed").compareTo(BigDecimal.ZERO) != 0) {
                                                    //如果父分录以价格确认数量不为空
                                                    dynamicObject1.set("tpv_thequantity", dynamicObjectS.getBigDecimal("tpv_confirmed"));
                                                }
                                            }
                                            OperationResult saveT = OperationServiceHelper.executeOperate("save", TPV_DT_SALESSHIPPING,
                                                    new DynamicObject[]{tpvScBusinessnatures}, option);
                                            //自动根据《销售发货单》｛拣配库存子分录｝生成《销售出库单》
                                            List<ListSelectedRow> selectedRowsTwo = new ArrayList<>();
                                            Long pkValueTwo = (Long) tpvScBusinessnatures.getPkValue();
                                            ListSelectedRow listSelectedRowTwo = new ListSelectedRow(pkValueTwo);//来源单据ID
                                            listSelectedRowTwo.setEntryEntityKey("tpv_materialentry");//来源单据单据体标识
                                            listSelectedRowTwo.setEntryPrimaryKeyValue(pkValue1);//来源单据分录ID
                                            listSelectedRowTwo.setSubEntryEntityKey("tpv_dt_salepick_in");
                                            listSelectedRowTwo.setSubEntryPrimaryKeyValue(dynamicObject1.getPkValue());
                                            selectedRowsTwo.add(listSelectedRowTwo);
                                            PushArgs pushArgsTwo = new PushArgs();
                                            pushArgsTwo.setSourceEntityNumber(TPV_DT_SALESSHIPPING); // 必选，源单标识
                                            pushArgsTwo.setTargetEntityNumber(IM_SALOUTBILL); // 必选，目标单标识
                                            // pushArgs.setHasRight(false); // 可选，传入true，不检查目标单新增权
                                            // pushArgs.setAppId("pur"); // 可选，传入目标单验权使用的应用编码
                                            pushArgsTwo.setAutoSave(true);//是否保存
                                            pushArgsTwo.setRuleId("1742221711249559552"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
                                            pushArgsTwo.setBuildConvReport(true); // 是否输出详细错误报告
                                            pushArgsTwo.setSelectedRows(selectedRowsTwo); // 必选，设置需要下推的源单及分录内码
                                            ConvertOperationResult pushResultTwo = ConvertServiceHelper.push(pushArgsTwo);
                                            if (pushResultTwo.isSuccess()) {
                                                MainEntityType targetMainTypeOne = EntityMetadataCache
                                                        .getDataEntityType(pushArgsTwo.getTargetEntityNumber());
                                                List<DynamicObject> targetBillObjsOne = pushResultTwo
                                                        .loadTargetDataObjects(new IRefrencedataProvider() {
                                                            @Override
                                                            public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                                                                BusinessDataReader.loadRefence(objs, dType);
                                                            }
                                                        }, targetMainTypeOne);
                                                if (targetBillObjsOne.size() > 0) {
                                                    DynamicObject targetBillObjOne = targetBillObjsOne.get(0);
                                                    DynamicObjectType targetBillObjOneS = targetBillObjOne.getDynamicObjectType();
                                                    String entityNameS = targetBillObjOneS.getDisplayName().getLocaleValue();
                                                    String entityNumberS = targetBillObjOneS.getName();
                                                    DynamicObjectCollection objectCollection2 = targetBillObjOne.getDynamicObjectCollection("billentry");
                                                    for (DynamicObject dynamicObjectSo : objectCollection2) {
                                                        dynamicObjectSo.set("tpv_directconsignmentid", pkValueS);
                                                    }
                                                    OperationResult saveOneS = OperationServiceHelper.executeOperate("save", entityNumberS,
                                                            new DynamicObject[]{targetBillObjOne}, optionOne);
                                                    if (saveOneS.isSuccess()) {
                                                        OperationResult submitOneS = OperationServiceHelper.executeOperate("submit",
                                                                entityNumberS, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
                                                        if (submitOneS.isSuccess()) {
                                                            OperationResult auditOneS = OperationServiceHelper.executeOperate("audit",
                                                                    entityNumberS, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
                                                            if (auditOneS.isSuccess()) {
                                                                dynamicObjectSter.set("tpv_deliveryorder", targetBillObjOne.getString("billno"));
                                                                SaveServiceHelper.update(dynamicObjectSter);
                                                                this.getView().showMessage(String.format("《%s》审核成功", entityNameS));
                                                            } else {
                                                                //tips.add(String.format("【%s】审核失败。%s", entityNameS, YEM.getOpMsg(submitOne)));
                                                                this.getView().showMessage(String.format("【%s】审核失败。%s", entityNameS, YEM.getOpMsg(submitOne)));
                                                            }
                                                        } else {
                                                            //tips.add(String.format("【%s】提交失败。%s", entityNameS, YEM.getOpMsg(submitOne)));
                                                            this.getView().showMessage(String.format("【%s】提交失败。%s", entityNameS, YEM.getOpMsg(submitOne)));
                                                        }
                                                    } else {
                                                        //tips.add(String.format("【%s】保存失败。%s", entityNameS, YEM.getOpMsg(saveOne)));
                                                        this.getView().showMessage(String.format("【%s】保存失败。%s", entityNameS, YEM.getOpMsg(saveOne)));
                                                    }
                                                }
                                            } else {
                                                Push.showReport(this.getView(), pushArgsTwo, pushResultTwo);
                                            }
                                        }
                                    }
                                }
                            }
                            this.getView().showMessage(String.format("《%s》审核成功", entityName));
                        } else {
                            //tips.add(String.format("【%s】审核失败。%s", entityName, YEM.getOpMsg(auditOne)));
                            this.getView().showMessage(String.format("【%s】审核失败。%s", entityName, YEM.getOpMsg(auditOne)));
                        }
                    } else {
                        //tips.add(String.format("【%s】提交失败。%s", entityName, YEM.getOpMsg(submitOne)));
                        this.getView().showMessage(String.format("【%s】提交失败。%s", entityName, YEM.getOpMsg(submitOne)));
                    }
                } else {
                    //tips.add(String.format("【%s】保存失败。%s", entityName, YEM.getOpMsg(saveOne)));
                    this.getView().showMessage(String.format("【%s】保存失败。%s", entityName, YEM.getOpMsg(saveOne)));
                }
            }
        } else {
            Push.showReport(this.getView(), pushArgs, pushResult);
        }
    }

    /**
     * 按钮操作执行前监听
     * 阻止删行
     *
     * @param args
     */
    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate operate = (FormOperate) args.getSource();
        String key = operate.getOperateKey();
        if (key.equals("deleteentry")) {
            //获取单据体控件
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            //获取选中行，数组为行号，从0开始int[]
            int selectRows[] = entryGrid.getSelectRows();
            //获取单据体数据集合
            DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_sonentryentity");
            if (selectRows != null && selectRows.length > 0) {
                for (int selectRow : selectRows) {
                    DynamicObject dynamicObject = entity.get(selectRow);  //获取选中行的单据体数据
                    boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                    String tpvDeliveryorder = dynamicObject.getString("tpv_deliveryorder");
                    if (tpvDestroysure || YEM.isNotEmpty(tpvDeliveryorder)) {
                        args.setCancel(true);
                        this.getView().showErrorNotification("第" + selectRow + 1 + "行分录销提确认为是或出库单号有值时不允许删除不可删除");
                    }
                }
            }
        }
        //监听保存
        if (key.equals("save")) {
            DynamicObjectCollection tpvSonentryentity = this.getModel().getEntryEntity("tpv_sonentryentity");
            for (DynamicObject dynamicObject : tpvSonentryentity) {
                BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                if (tpvDestroyquantity.compareTo(BigDecimal.ZERO) == 0) {
                    args.setCancel(true);
                    this.getView().showErrorNotification("第" + dynamicObject.getInt("Seq") + "行请填写销提数量再点击保存");
                }
            }
        }
    }

    /**
     * 监听保存按钮之后
     *
     * @param e
     */
    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String key = e.getOperateKey();
        if (key.equals("save")) {
            DynamicObjectCollection tpvSonentryentity = this.getModel().getEntryEntity("tpv_sonentryentity");
            BigDecimal qty = BigDecimal.ZERO;
            if (tpvSonentryentity.size() >= 0) {
                for (int i = 0; i < tpvSonentryentity.size(); i++) {
                    DynamicObject dynamicObject = tpvSonentryentity.get(i);
                    BigDecimal tpv_destroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                    qty = qty.add(tpv_destroyquantity);
                }
            }
            BigDecimal tpv_pickqty_zy = (BigDecimal) this.getModel().getValue("tpv_pickqty_in");
            if (qty.compareTo(BigDecimal.ZERO) != 0 && tpv_pickqty_zy.compareTo(BigDecimal.ZERO) != 0) {
                int result = qty.compareTo(tpv_pickqty_zy);
                if (result < 0) {
                    this.getModel().setValue("tpv_practicalok_in", false);
                    DynamicObject dataEntityS = this.getModel().getDataEntity(true);
                    dataEntityS.set("tpv_practicalok_in", false);
                    SaveServiceHelper.update(dataEntityS);//写入数据库
                    IFormView view = this.getView().getParentView();
                    int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
                    view.getModel().setValue("tpv_realsubmit", false, tpvEntryentity);
                    this.getView().sendFormAction(view);
                }
            }
        }
        if (key.equals("deleteentry")) {
            this.getView().invokeOperation("save");
        }
    }
    @Override
    public void hyperLinkClick(HyperLinkClickEvent e) {
        // TODO Auto-generated method stub
        int index = e.getRowIndex();
        if ("tpv_billnos".equals(e.getFieldName())) {
            //父配货单据编号
            String tpvFatherpickbill = (String) this.getModel().getValue("tpv_fatherpickbill", index);//父配货单据
            String tpvBillnos = (String) this.getModel().getValue("tpv_billnos", index);//父配货单据编号
            DynamicObject random = BusinessDataServiceHelper.loadSingle(tpvFatherpickbill, "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvBillnos)});
            if (null != random) {
                skipMethod(tpvFatherpickbill, random.getPkValue());
            }
        }
        if ("tpv_sonbillnos".equals(e.getFieldName())) {
            //子配货单据编号
            String tpvSonbill = (String) this.getModel().getValue("tpv_sonbill", index);//子配货单据
            String tpvSonbillnos = (String) this.getModel().getValue("tpv_sonbillnos", index);//子配货单据编号
            DynamicObject random = BusinessDataServiceHelper.loadSingle(tpvSonbill, "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvSonbillnos)});
            if (null != random) {
                skipMethod(tpvSonbill, random.getPkValue());
            }
        }
        if ("tpv_godownentry".equals(e.getFieldName())) {
            //入库单号
            String tpvGodownentry = (String) this.getModel().getValue("tpv_godownentry", index);//入库单号
            DynamicObject im_Purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvGodownentry)});
            if (null != im_Purinbill) {
                skipMethod("im_purinbill", im_Purinbill.getPkValue());
            }
        }
        if ("tpv_deliveryorder".equals(e.getFieldName())) {
            //出库单号
            String tpvDeliveryorder = (String) this.getModel().getValue("tpv_deliveryorder", index);//出库单号
            DynamicObject imSaloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvDeliveryorder)});
            if (null != imSaloutbill) {
                skipMethod("im_saloutbill", imSaloutbill.getPkValue());
            }
        }
        if ("tpv_profitodd".equals(e.getFieldName())) {
            //盘盈单号
            String tpvProfitodd = (String) this.getModel().getValue("tpv_profitodd", index);//盘盈单号
            DynamicObject imOPtheroutbill = BusinessDataServiceHelper.loadSingle("im_otherinbill", "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvProfitodd)});
            if (null != imOPtheroutbill) {
                skipMethod("im_otherinbill", imOPtheroutbill.getPkValue());
            }
        }
        if ("tpv_lossodd".equals(e.getFieldName())) {
            //盘亏单号
            String tpvLossodd = (String) this.getModel().getValue("tpv_lossodd", index);//盘亏单号
            DynamicObject imOtherinbill = BusinessDataServiceHelper.loadSingle("im_otheroutbill", "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvLossodd)});
            if (null != imOtherinbill) {
                skipMethod("im_otheroutbill", imOtherinbill.getPkValue());
            }
        }
        if ("tpv_purcontract".equals(e.getFieldName())) {
            String tpvContractmark = (String) this.getModel().getValue("tpv_purcontract", index);//采购合同号
            DynamicObject random = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", "id",
                    new QFilter[]{new QFilter("tpv_contractnumber", QCP.equals, tpvContractmark)});
            if (null != random) {
                skipMethod("tpv_dt_purchase", random.getPkValue());
            }
        }
    }

    public void skipMethod(String formId, Object object) {
        BillShowParameter showParameter = new BillShowParameter();
        showParameter.setFormId(formId);
        showParameter.setPkId(object);
        showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
        showParameter.setStatus(OperationStatus.VIEW);
        this.getView().showForm(showParameter);
    }
}
