package tpv.tpv_wm.tpv_dt.java.formplugin.form;


import com.itopview.wm.dt.report.InventoryNewRptQuery;
import com.itopview.wm.dt.utils.PickShipsHelper;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.*;
import kd.bos.form.operate.FormOperate;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * 库存拣配业务底表(新)表单插件
 * WangShuGuang
 */
public class ConfiguraNewFormPlugin extends AbstractFormPlugin implements HyperLinkClickListener {


    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        //给分录父id和子配货单据赋值
        assignMent();
        //查询出库单号
        setEntryRowOutBillno();
//        selectMust(); //暂时作废，未维护
    }

    private void setEntryRowOutBillno() {
        DynamicObjectCollection tpvSonentryentity = this.getView().getModel().getEntryEntity("tpv_sonentryentity");
        List<Long> ids = new ArrayList<>();
        for (int i = 0; i < tpvSonentryentity.size(); i++) {
            DynamicObject dynamicObject = tpvSonentryentity.get(i);
            Long id = (Long) dynamicObject.getPkValue();
            if (!ids.contains(id)) {
                ids.add(id);
            }
        }
        if (ids.size() > 0) {
            QFilter qFilter = new QFilter("billentry.tpv_srcbillsubentryid", QCP.in, ids);
            DynamicObjectCollection imSaloutbill = QueryServiceHelper.query("im_saloutbill", "id,billno," +
                    "billentry,billentry.tpv_srcbillsubentryid tpv_srcbillsubentryid,billentry.tpv_isrowout tpv_isrowout", qFilter.toArray());
            Map<Long, HashMap<String, Object>> outbillnosMap = new HashMap<>();
            if (imSaloutbill.size() > 0) {
                for (DynamicObject dynamicObject : imSaloutbill) {
                    HashMap<String, Object> map = new HashMap<>();
                    long aLong = dynamicObject.getLong("tpv_srcbillsubentryid");
                    String billno = dynamicObject.getString("billno");
                    boolean tpvIsrowout = dynamicObject.getBoolean("tpv_isrowout");
                    map.put("billno", billno);
                    map.put("tpv_isrowout", tpvIsrowout);
                    outbillnosMap.put(aLong, map);
                }
            }
            for (int i = 0; i < tpvSonentryentity.size(); i++) {
                DynamicObject dynamicObject = tpvSonentryentity.get(i);
                Long id = (Long) dynamicObject.getPkValue();
                if (outbillnosMap.containsKey(id)) {
                    //插入出库单号
                    this.getModel().setValue("tpv_deliveryorder", outbillnosMap.get(id).get("billno"), i);
                    //单行拣配
                    this.getModel().setValue("tpv_isrowout", outbillnosMap.get(id).get("tpv_isrowout"), i);
                }
            }
        }
    }

    private void assignMent() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvSonentryentity = dataEntity.getDynamicObjectCollection("tpv_sonentryentity");
        if (!tpvSonentryentity.isEmpty()) {
            for (DynamicObject dynamicObject : tpvSonentryentity) {
                dynamicObject.set("tpv_fatherid", dataEntity.getLong("id"));
                dynamicObject.set("tpv_sonbill", dynamicObject.getString("tpv_pickbill_in"));
                dynamicObject.set("tpv_sonbillnos", dynamicObject.getString("tpv_billno_in"));
                this.getView().updateView("tpv_sonentryentity");
            }
        }
    }

    @Override
    public void beforeItemClick(BeforeItemClickEvent evt) {
        super.beforeItemClick(evt);
        String itemKey = evt.getItemKey();
        if ("tb_del".equals(itemKey)) {
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            SaveServiceHelper.save(new DynamicObject[]{dataEntity});
        }
    }

    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"advcontoolbarap"});
        this.addClickListeners("newentry"); // 监听确认和取消按钮
        this.addClickListeners("tb_new");
        this.addClickListeners("tpv_save");
        this.addItemClickListeners("advcontoolbarap");
        EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
        entryGrid.addHyperClickListener(this);
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        List<String> nopassSeqList = new ArrayList<>();
        DynamicObjectCollection tpvSonentryentity = dataEntity.getDynamicObjectCollection("tpv_sonentryentity");
        if (StringUtils.equals(key, "tpv_advconbaritemap")) {
            //补拣配逻辑
            pickingLogic();
        }
        if (StringUtils.equals("tpv_advconbaritemap1", key)) {
            nopassSeqList = new ArrayList<>();
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            int[] selectRows = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                if (tpvDestroyquantity.compareTo(BigDecimal.ZERO) == 0) {
                    nopassSeqList.add(String.valueOf(selectRow + 1));
                }
            }
            if (nopassSeqList.size() > 0) {
                this.getView().showMessage("选中行第" + String.join("、", nopassSeqList) + "行，未填写销提数量，请填写后再点击【物流确认销售实提】按钮");
            } else {
                for (int selectRow : selectRows) {
                    DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                    BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                    if (tpvDestroyquantity.compareTo(BigDecimal.ZERO) != 0) {
                        this.getModel().setValue("tpv_destroysure", true, selectRow);
                        dynamicObject.set("tpv_destroysure", true);
                        OperateOption optionOne = YEM.getOption();
                        OperationResult saveOneS = OperationServiceHelper.executeOperate("save", "tpv_dt_configuranew",
                                new DynamicObject[]{dataEntity}, optionOne);
                        SaveServiceHelper.update(dynamicObject);
                        this.getView().updateView("tpv_sonentryentity.tpv_destroysure", selectRow);
                    }
                }
                //判断数量实提完毕自动打勾
                updateRealsubmit(selectRows);
                updateParentEntryRowData();
            }

        }
        if (StringUtils.equals("tpv_advconbaritemap1no", key)) {
            nopassSeqList = new ArrayList<>();
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            int[] selectRows = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                String tpvDeliveryorder = dynamicObject.getString("tpv_deliveryorder"); //出库单号
                if (YEM.isNotEmpty(tpvDeliveryorder)) {
                    nopassSeqList.add(String.valueOf(selectRow + 1));
                }
            }
            if (nopassSeqList.size() > 0) {
                this.getView().showMessage("选中行第" + String.join("、", nopassSeqList) + "行，已出库，请重新选择其他行在操作【反物流确认销售实提】按钮");
            } else {
                for (int selectRow : selectRows) {
                    this.getModel().setValue("tpv_destroysure", false, selectRow);
                    DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                    dynamicObject.set("tpv_destroysure", false);
                    SaveServiceHelper.update(dynamicObject);
                    this.getView().updateView("tpv_sonentryentity.tpv_destroysure", selectRow);
                }
                //判断数量实提完毕自动打勾
                updateRealsubmit(selectRows);
                updateParentEntryRowData();
            }
        }
        if (StringUtils.equals("tpv_appearenter", key)) {
            nopassSeqList = new ArrayList<>();
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            int[] selectRows = entryGrid.getSelectRows();
            //获取单据主实体
            DynamicObject dataEntitys = this.getModel().getDataEntity(true);
            //获取分录数据
            DynamicObject tpv_dt_noconfiguration = BusinessDataServiceHelper.loadSingle("tpv_dt_configuranew", "id,tpv_sonentryentity",
                    new QFilter("id", QCP.equals, dataEntitys.getLong("id")).toArray());
            tpv_dt_noconfiguration = BusinessDataServiceHelper.loadSingle(tpv_dt_noconfiguration.getPkValue(),
                    tpv_dt_noconfiguration.getDynamicObjectType().getName());
            DynamicObjectCollection detailedinformation = tpv_dt_noconfiguration.getDynamicObjectCollection("tpv_sonentryentity");
            List<String> strings = new ArrayList<>();
            if (detailedinformation.size() > 0) {
                if (selectRows.length > 0) {
                    for (int selectRow : selectRows) {
                        Boolean isFalg = false;

                        DynamicObject dynamicObject = detailedinformation.get(selectRow);
                        DynamicObjectCollection tpvEntryentity = this.getView().getParentView().getModel().getDataEntity(true).getDynamicObjectCollection("tpv_entryentity");
                        int index = this.getView().getParentView().getModel().getEntryCurrentRowIndex("tpv_entryentity");

                        if (index>=0){
                            isFalg=tpvEntryentity.get(index).getBoolean("tpv_islogistics");
                        }
                        boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                        String tpvDeliveryorder = (String) this.getModel().getValue("tpv_deliveryorder", selectRow);
                        //String tpvDeliveryorder = dynamicObject.getString("tpv_deliveryorder");
                        long pkValueS = (long) dynamicObject.getPkValue();
                        //销售出库
                        DynamicObjectCollection im_saloutbill = QueryServiceHelper.query("im_saloutbill", "billno",
                                new QFilter("billentry.tpv_srcbillsubentryid", QCP.equals, pkValueS).toArray());
                        StringBuffer desc = new StringBuffer();
                        if (!tpvDestroysure &&!isFalg) {
                            desc.append("销提确认为否、");
                        }
                        StringBuffer str = new StringBuffer();
                        if (im_saloutbill.size() > 0) {//销售出库
                            str = new StringBuffer();
                            for (DynamicObject object : im_saloutbill) {
                                str.append(object.getString("billno"));
                            }
                            desc.append("存在下游销售出库" + str + ";");
                        }
                        if (YEM.isNotEmpty(desc.toString())) {
                            int message = 1 + selectRow;
                            nopassSeqList.add("第" + message + "行 " + desc + "不可+出库");
                        }
                    }
                    if (nopassSeqList.size() > 0) {
                        String result = String.join("", nopassSeqList);
                        this.getView().showMessage(result);
                    } else {
                        // 创建弹出动态表单页面对象
                        FormShowParameter showParameter = new FormShowParameter();
                        // 设置弹出页面的标识
                        showParameter.setFormId("tpv_dt_inventorysnew");
                        // 状态
                        showParameter.setStatus(OperationStatus.ADDNEW);
                        // 设置页面关闭回调方法
                        // CloseCallBack参数：回调插件，回调标识
                        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_designate"));
                        // 设置弹出页面打开方式
                        showParameter.getOpenStyle().setShowType(ShowType.Modal);
                        // 打开动态表单
                        this.getView().showForm(showParameter);
                    }
                } else {
                    strings.add("请先选中行再点击+出入库单");
                }
            }
        }
    }

    /**
     * 判断数量实提完毕自动打勾
     */
    private void updateRealsubmit(int[] selectRows) {
        DynamicObjectCollection tpvSonentryentityS = this.getModel().getEntryEntity("tpv_sonentryentity");
        BigDecimal qty = BigDecimal.ZERO;
        BigDecimal qtynum = BigDecimal.ZERO;
        if (tpvSonentryentityS.size() >= 0) {
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = tpvSonentryentityS.get(selectRow);
                //销提数量
                boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                if (tpvDestroysure) {
                    BigDecimal tpv_destroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                    BigDecimal tpv_fpackagereal = dynamicObject.getBigDecimal("tpv_fpackagereal");
                    qty = qty.add(tpv_destroyquantity);
                    qtynum = qtynum.add(tpv_fpackagereal);
                }
            }
        }
        BigDecimal tpv_qty = (BigDecimal) this.getModel().getValue("tpv_qty");
        BigDecimal tpv_packnum = (BigDecimal) this.getModel().getValue("tpv_packnum");
        int result1 = qty.compareTo(tpv_qty);
        int result2 = qtynum.compareTo(tpv_packnum);
        if (result1 >= 0 || result2 >= 0) {
            this.getModel().setValue("tpv_practicalok", true);
            DynamicObject dataEntityS = this.getModel().getDataEntity(true);
            dataEntityS.set("tpv_practicalok", true);
            if (tpvSonentryentityS.size() > 0) {
                for (int i = 0; i < tpvSonentryentityS.size(); i++) {
                    DynamicObject tpvSonentryentity = tpvSonentryentityS.get(i);
                    boolean tpvDestroysure = tpvSonentryentity.getBoolean("tpv_destroysure");
                    if (tpvDestroysure) {
                        BigDecimal tpv_destroyquantity = tpvSonentryentity.getBigDecimal("tpv_destroyquantity");
                        BigDecimal tpv_fpackagereal = tpvSonentryentity.getBigDecimal("tpv_fpackagereal");
                        tpvSonentryentity.set("tpv_pickqty_in", tpv_destroyquantity);
                        tpvSonentryentity.set("tpv_packnum_in", tpv_fpackagereal);
                        tpvSonentryentity.set("tpv_practicalok_in", true);
                        this.getView().updateView("tpv_pickqty_in", i);
                        this.getView().updateView("tpv_packnum_in", i);
                        this.getView().updateView("tpv_practicalok_in", i);
                    }
                }
            }
            this.getModel().setValue("tpv_qty", qty);
            dataEntityS.set("tpv_qty", qty);
            this.getModel().setValue("tpv_packnum", tpv_packnum);
            dataEntityS.set("tpv_packnum", tpv_packnum);
            SaveServiceHelper.update(this.getModel().getDataEntity(true));//写入数据库
            IFormView view = this.getView().getParentView();
            int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
            view.getModel().setValue("tpv_realsubmit", true, tpvEntryentity);
            view.getModel().setValue("tpv_qty", qty, tpvEntryentity);
            view.getModel().setValue("tpv_packnum", tpv_packnum, tpvEntryentity);
            this.getView().sendFormAction(view);
        } else {
            this.getModel().setValue("tpv_practicalok", false);
            DynamicObject dataEntityS = this.getModel().getDataEntity(true);
            dataEntityS.set("tpv_practicalok", false);
            if (tpvSonentryentityS.size() > 0) {
                for (int i = 0; i < tpvSonentryentityS.size(); i++) {
                    DynamicObject tpvSonentryentity = tpvSonentryentityS.get(i);
                    boolean tpvDestroysure = tpvSonentryentity.getBoolean("tpv_destroysure");
                    if (tpvDestroysure) {
                        tpvSonentryentity.set("tpv_practicalok_in", false);
                        this.getView().updateView("tpv_practicalok_in", i);
                    }

                }
            }
            SaveServiceHelper.update(this.getModel().getDataEntity(true));//写入数据库
            IFormView view = this.getView().getParentView();
            int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
            view.getModel().setValue("tpv_realsubmit", false, tpvEntryentity);
            this.getView().sendFormAction(view);
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent evt) {
        super.closedCallBack(evt);
        if (StringUtils.equals(evt.getActionId(), "tpv_designate")) { //+出入库操作后刷新父分录选中行
            updateParentEntryRowData();
        }
    }

    /**
     * 修改父分录选择行数据：销提数量、已出库数量、未出库数量
     */
    private void updateParentEntryRowData() {
        IFormView view = this.getView().getParentView();
        int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
        String tpv_zySubEntryid = (String) view.getModel().getValue("tpv_sourceid", tpvEntryentity);
        if (YEM.isNotEmpty(tpv_zySubEntryid)) {
            String whereFilter = "1 = 1";
            whereFilter = String.format("%s and tpv_sourceid = %s", whereFilter, Long.valueOf(tpv_zySubEntryid));
            DataSet query = InventoryNewRptQuery.query(whereFilter);
            DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(query);
            //根据销售发货库存拣配直运子分录的id查询
            for (DynamicObject dynamicObject : dynamicObjects) {
                view.getModel().setValue("tpv_destroyquantitysum", dynamicObject.getBigDecimal("tpv_destroyquantitysum"), tpvEntryentity);
                view.getModel().setValue("tpv_fpackagerealsum", dynamicObject.getBigDecimal("tpv_fpackagerealsum"), tpvEntryentity);
                view.getModel().setValue("tpv_issuedquantitys", dynamicObject.getBigDecimal("tpv_issuedquantitys"), tpvEntryentity);
                view.getModel().setValue("tpv_unissuedquanti", dynamicObject.getBigDecimal("tpv_unissuedquanti"), tpvEntryentity);
                view.getModel().setValue("tpv_logisticsok", dynamicObject.getBoolean("tpv_logisticsok"), tpvEntryentity);
                break;
            }
            this.getView().sendFormAction(view);
        }
    }

    private void pickingLogic() {
        IFormView parentView = this.getView().getParentView();
        EntryGrid entryGrid = parentView.getControl("tpv_entryentity");
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length > 0) {
            PickShipsHelper.pickClick(this.getView());
        } else {
            parentView.showErrorNotification("请先选中上方分录行进行补拣配");
        }
    }

    @Override
    public void hyperLinkClick(HyperLinkClickEvent e) {
        // TODO Auto-generated method stub
        int index = e.getRowIndex();
        if ("tpv_billno_in".equals(e.getFieldName())) {
            //父配货单据编号
            String tpvFatherpickbill = (String) this.getModel().getValue("tpv_pickbill_in", index);//父配货单据
            String tpvBillnos = (String) this.getModel().getValue("tpv_billno_in", index);//父配货单据编号
            DynamicObject random = BusinessDataServiceHelper.loadSingle(tpvFatherpickbill, "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvBillnos)});
            if (null != random) {
                skipMethod(tpvFatherpickbill, random.getPkValue());
            }
        }
        if ("tpv_sonbillnos".equals(e.getFieldName())) {
            //子配货单据编号
            String tpvSonbill = (String) this.getModel().getValue("tpv_sonbill", index);//子配货单据
            String tpvSonbillnos = (String) this.getModel().getValue("tpv_sonbillnos", index);//子配货单据编号
            DynamicObject random = BusinessDataServiceHelper.loadSingle(tpvSonbill, "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvSonbillnos)});
            if (null != random) {
                skipMethod(tpvSonbill, random.getPkValue());
            }
        }
        if ("tpv_deliveryorder".equals(e.getFieldName())) {
            //出库单号
            String tpvDeliveryorder = (String) this.getModel().getValue("tpv_deliveryorder", index);//出库单号
            DynamicObject imSaloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvDeliveryorder)});
            if (null != imSaloutbill) {
                skipMethod("im_saloutbill", imSaloutbill.getPkValue());
            }
        }
        if ("tpv_contractmark".equals(e.getFieldName())) {
            String tpvContractmark = (String) this.getModel().getValue("tpv_contractmark", index);//采购合同号
            DynamicObject random = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", "id",
                    new QFilter[]{new QFilter("tpv_contractnumber", QCP.equals, tpvContractmark)});
            if (null != random) {
                skipMethod("tpv_dt_purchase", random.getPkValue());
            }
        }
    }

    public void skipMethod(String formId, Object object) {
        BillShowParameter showParameter = new BillShowParameter();
        showParameter.setFormId(formId);
        showParameter.setPkId(object);
        showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
        showParameter.setStatus(OperationStatus.VIEW);
        this.getView().showForm(showParameter);
    }

    public void selectMust() {
        DynamicObjectCollection tpvSonentryentity = this.getView().getModel().getEntryEntity("tpv_sonentryentity");
        for (DynamicObject dynamicObject : tpvSonentryentity) {
            BigDecimal tpvPurchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");//采提数量
            BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");//采提数量
            int seq = dynamicObject.getInt("Seq");
            int seqSmale = seq - 1;
            Long id = (Long) dynamicObject.getPkValue();
            if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && tpvDestroyquantity.compareTo(BigDecimal.ZERO) != 0) {
                int bigSmal = tpvPurchasequantity.compareTo(tpvDestroyquantity);
                if (bigSmal == 0) {
                    //销售出库
                    DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno",
                            new QFilter("billentry.tpv_srcbillsubentryid", QCP.equals, id).toArray());
                    if (null != im_saloutbill) {
                        //插入出库单号
                        this.getModel().setValue("tpv_deliveryorder", im_saloutbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_deliveryorder", null, seqSmale);
                    }
                }
            }
        }
    }

    /**
     * 监听销提数量字段
     *
     * @param e
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        // TODO Auto-generated method stub
        super.propertyChanged(e);
        String propertyName = e.getProperty().getName();
        int rowIndex = this.getModel().getEntryCurrentRowIndex("tpv_sonentryentity");
        if ("tpv_destroyquantity".equals(propertyName)) {
            DynamicObject dynamicObject = this.getModel().getEntryRowEntity("tpv_sonentryentity", rowIndex);
            BigDecimal pickqty = dynamicObject.getBigDecimal("tpv_pickqty_in");
            BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
            if (pickqty.compareTo(tpvDestroyquantity) < 0) {
                this.getView().showTipNotification("本行销提数量大于本行数量，请重新填写，可以通过补拣配增加实提数量");
                this.getModel().beginInit();
                this.getModel().setValue("tpv_destroyquantity", BigDecimal.ZERO, rowIndex);
                this.getModel().endInit();
                this.getView().updateView("tpv_destroyquantity", rowIndex);
            }
        }
        if ("tpv_fpackagereal".equals(propertyName)) {
            DynamicObject dynamicObject = this.getModel().getEntryRowEntity("tpv_sonentryentity", rowIndex);
            BigDecimal pickqty = dynamicObject.getBigDecimal("tpv_packnum_in");
            BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_fpackagereal");
            if (pickqty.compareTo(tpvDestroyquantity) < 0) {
                this.getView().showTipNotification("本行实提包装数量大于本行包装数量，请重新填写，可以通过补拣配增加实提数量");
                this.getModel().beginInit();
                this.getModel().setValue("tpv_fpackagereal", BigDecimal.ZERO, rowIndex);
                this.getModel().endInit();
                this.getView().updateView("tpv_fpackagereal", rowIndex);
            }
        }
        SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
    }

    /**
     * 按钮操作执行前监听
     * 阻止删行
     *
     * @param args
     */
    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate operate = (FormOperate) args.getSource();
        String key = operate.getOperateKey();
        List<String> nopassSeqList = new ArrayList<>();
        if (key.equals("deleteentry")) {
            nopassSeqList = new ArrayList<>();
            //获取单据体控件
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            //获取选中行，数组为行号，从0开始int[]
            int selectRows[] = entryGrid.getSelectRows();
            //获取单据体数据集合
            DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_sonentryentity");
            if (selectRows != null && selectRows.length > 0) {
                for (int selectRow : selectRows) {
                    DynamicObject dynamicObject = entity.get(selectRow);  //获取选中行的单据体数据
                    boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                    String tpvDeliveryorder = dynamicObject.getString("tpv_deliveryorder");
                    boolean tpvFillpicksign = dynamicObject.getBoolean("tpv_fillpicksign");
                    if (tpvDestroysure || YEM.isNotEmpty(tpvDeliveryorder) || !tpvFillpicksign) {
                        nopassSeqList.add(String.valueOf(selectRow + 1));
                    }
                }
                if (nopassSeqList.size() > 0) {
                    args.setCancel(true);
                    this.getView().showErrorNotification("第" + String.join(",", nopassSeqList) + "行分录销提确认为是或出库单号有值，" +
                            "再或者不是补拣配数据时不允许删除不可删除");
                }
            }
        }
        //监听保存
        if (key.equals("save")) {
            nopassSeqList = new ArrayList<>();
            DynamicObjectCollection tpvSonentryentity = this.getModel().getEntryEntity("tpv_sonentryentity");
            for (DynamicObject dynamicObject : tpvSonentryentity) {
                BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                BigDecimal tpvPacknumIn = dynamicObject.getBigDecimal("tpv_packnum_in");
                BigDecimal tpvFpackagereal = dynamicObject.getBigDecimal("tpv_fpackagereal");
                if (tpvPacknumIn.compareTo(BigDecimal.ZERO) != 0) {
                    if (tpvDestroyquantity.compareTo(BigDecimal.ZERO) == 0 || tpvFpackagereal.compareTo(BigDecimal.ZERO) == 0) {
                        nopassSeqList.add("第" + dynamicObject.getInt("Seq") + "行销提数量或实提包装数量未填写");
                    }
                } else {
                    if (tpvDestroyquantity.compareTo(BigDecimal.ZERO) == 0) {
                        nopassSeqList.add("第" + dynamicObject.getInt("Seq") + "行销提数量未填写");
                    }
                }
            }
            if (nopassSeqList.size() > 0) {
                args.setCancel(true);
                this.getView().showMessage(String.join(",", nopassSeqList) + "\r\n 请填写后，再点击保存！");
            }
        }
    }

    /**
     * 监听保存按钮之后
     *
     * @param e
     */
    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String key = e.getOperateKey();
        if (key.equals("save")) {
            DynamicObjectCollection tpvSonentryentityS = this.getModel().getEntryEntity("tpv_sonentryentity");
            if (tpvSonentryentityS.size() > 0) {
                int[] rows = new int[tpvSonentryentityS.size()];
                for (int i = 0; i < tpvSonentryentityS.size(); i++) {
                    rows[i] = i;
                }
//                updateRealsubmit(rows);
                updateParentEntryRowData();
            }
        }
        if (key.equals("deleteentry")) {
            this.getView().invokeOperation("save");
            updateParentEntryRowData();
        }
    }
}
