package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import com.itopview.wm.dt.report.NoInventoryRptQuery;
import com.itopview.wm.dt.utils.PickShipsHelper;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.*;
import kd.bos.form.operate.FormOperate;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * 库存免拣配业务底表表单插件
 * WangShuGuang
 */
public class ConfiguraNoFormPlugin extends AbstractFormPlugin implements HyperLinkClickListener {

    private final String TPV_SONENTRYENTITY = "tpv_sonentryentity";//单据体标识
    private final String IM_OTHEROUTBILL = "im_otheroutbill";//其他出库单

    private final String IM_OTHERINBILL = "im_otherinbill";//其他入库

    private final String TPV_DT_SALESSHIPPING = "tpv_dt_salesshipping";//销售发货

    private final String IM_SALOUTBILL = "im_saloutbill";//销售出库

    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"advcontoolbarap"});
        this.addClickListeners("newentry"); // 监听确认和取消按钮
        EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
        entryGrid.addHyperClickListener(this);
    }

    /**
     * 监听销提数量字段
     *
     * @param e
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        // TODO Auto-generated method stub
        super.propertyChanged(e);
        String propertyName = e.getProperty().getName();
        int rowIndex = this.getModel().getEntryCurrentRowIndex("tpv_sonentryentity");
        if ("tpv_destroyquantity".equals(propertyName)) {
            IFormView view = this.getView().getParentView();
            int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
            DynamicObject tpvEntryentity1 = view.getModel().getEntryRowEntity("tpv_entryentity", tpvEntryentity);
            //获取库存拣配工作台数量
            BigDecimal tpv_qty = tpvEntryentity1.getBigDecimal("tpv_qty");
            //获取分录数据
            DynamicObject dataEntitys = this.getModel().getDataEntity(true);
            DynamicObjectCollection detailedinformation = dataEntitys.getDynamicObjectCollection("tpv_sonentryentity");
            BigDecimal qtyShopp = BigDecimal.ZERO;
            for (DynamicObject dynamicObject : detailedinformation) {
                BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                qtyShopp = qtyShopp.add(tpvDestroyquantity);
            }
            int numbers = tpv_qty.compareTo(qtyShopp);
            if (numbers < 0) {
                this.getModel().setValue("tpv_destroyquantity", BigDecimal.ZERO, rowIndex);
                this.getView().showMessage("分录销提数量汇总不得大于上方数量值");
            }
        }
    }

    /**
     * 单据打开查出入库单号
     *
     * @param e
     */
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
//        selectMust(); //暂时作废，未维护
//        packLock();
        assignMent();
        setEntryRowOutBillno();
    }

    private void setEntryRowOutBillno() {
        DynamicObjectCollection tpvSonentryentity = this.getView().getModel().getEntryEntity("tpv_sonentryentity");
        List<Long> ids = new ArrayList<>();
        for (int i = 0; i < tpvSonentryentity.size(); i++) {
            DynamicObject dynamicObject = tpvSonentryentity.get(i);
            Long id = (Long) dynamicObject.getPkValue();
            if (!ids.contains(id)) {
                ids.add(id);
            }
        }
        if (ids.size() > 0) {
            QFilter qFilter = new QFilter("billentry.tpv_srcbillsubentryid", QCP.in, ids);
            DynamicObjectCollection imSaloutbill = QueryServiceHelper.query("im_saloutbill", "id,billno," +
                            "billentry,billentry.tpv_srcbillsubentryid tpv_srcbillsubentryid,billentry.tpv_isrowout tpv_isrowout", qFilter.toArray());
            Map<Long, HashMap<String, Object>> outbillnosMap = new HashMap<>();
            if (imSaloutbill.size() > 0) {
                for (DynamicObject dynamicObject : imSaloutbill) {
                    HashMap<String, Object> map = new HashMap<>();
                    long aLong = dynamicObject.getLong("tpv_srcbillsubentryid");
                    String billno = dynamicObject.getString("billno");
                    boolean tpvIsrowout = dynamicObject.getBoolean("tpv_isrowout");
                    map.put("billno",billno);
                    map.put("tpv_isrowout",tpvIsrowout);
                    outbillnosMap.put(aLong, map);
                }
            }
            for (int i = 0; i < tpvSonentryentity.size(); i++) {
                DynamicObject dynamicObject = tpvSonentryentity.get(i);
                Long id = (Long) dynamicObject.getPkValue();
                if (outbillnosMap.containsKey(id)) {
                    //插入出库单号
                    this.getModel().setValue("tpv_deliveryorder", outbillnosMap.get(id).get("billno"), i);
                    //单行拣配
                    this.getModel().setValue("tpv_isrowout",outbillnosMap.get(id).get("tpv_isrowout"), i);
                }
            }
        }
    }
    private void assignMent() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvSonentryentity = dataEntity.getDynamicObjectCollection("tpv_sonentryentity");
        if (!tpvSonentryentity.isEmpty()) {
            for (DynamicObject dynamicObject : tpvSonentryentity) {
                dynamicObject.set("tpv_fatherid", dataEntity.getLong("id"));
                dynamicObject.set("tpv_sonbill", dynamicObject.getString("tpv_pickbill_in"));
                dynamicObject.set("tpv_sonbillnos", dynamicObject.getString("tpv_billno_in"));
                this.getView().updateView("tpv_sonentryentity");
            }
        }
    }
    @Override
    public void beforeItemClick(BeforeItemClickEvent evt) {
        super.beforeItemClick(evt);
        String itemKey = evt.getItemKey();
        if ("tb_del".equals(itemKey)) {
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            SaveServiceHelper.save(new DynamicObject[]{dataEntity});
        }
    }

    public void packLock() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpv_sonentryentity = dataEntity.getDynamicObjectCollection(TPV_SONENTRYENTITY);
        for (DynamicObject dynamicObject : tpv_sonentryentity) {
            String tpv_deliveryorder = dynamicObject.getString("tpv_deliveryorder");
            if (StringUtils.isEmpty(tpv_deliveryorder)) {
                int seq = dynamicObject.getInt("Seq") - 1;
                DynamicObject tpv_material_in = dynamicObject.getDynamicObject("tpv_material_in");
                if (YEM.isNotEmpty(tpv_material_in)) {
                    DynamicObject auxptyunit = tpv_material_in.getDynamicObject("auxptyunit");
                    if (null == auxptyunit) {
                        //锁定分录字段
                        this.getView().setEnable(false, seq, "tpv_ofpackages");//锁定分录包装数量字段
                    }
                }
            }
        }
    }

    //分录增行事件
    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        if (StringUtils.equals("tpv_sonentryentity", e.getEntryProp().getName())) {
            RowDataEntity[] rowIndex = e.getRowDataEntities();
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection tpvSonentryentity = dataEntity.getDynamicObjectCollection("tpv_sonentryentity");
            for (RowDataEntity index : rowIndex) {
                int row = index.getRowIndex();
                DynamicObject tpvSonentryentityOne = tpvSonentryentity.get(row);
            }
        }
    }

    public void selectMust() {
        DynamicObjectCollection tpvSonentryentity = this.getView().getModel().getEntryEntity("tpv_sonentryentity");
        for (DynamicObject dynamicObject : tpvSonentryentity) {
            BigDecimal tpvPurchasequantity = dynamicObject.getBigDecimal("tpv_purchasequantity");//采提数量
            BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");//采提数量
            int seq = dynamicObject.getInt("Seq");
            int seqSmale = seq - 1;
            Long id = (Long) dynamicObject.getPkValue();
            if (tpvDestroyquantity.compareTo(BigDecimal.ZERO) != 0) {
                int bigSmal = tpvPurchasequantity.compareTo(tpvDestroyquantity);
                if (bigSmal == 0) {
                    //销提数量等于采提数量查询采购入库单号和销售出库单号
                    //采购入库
                    DynamicObject tpv_dt_purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //销售出库
                    DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    /*if (null != tpv_dt_purinbill) {
                        //插入入库单号
                        this.getModel().setValue("tpv_godownentry", tpv_dt_purinbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_godownentry", null, seqSmale);
                    }*/
                    if (null != im_saloutbill) {
                        //插入出库单号
                        this.getModel().setValue("tpv_deliveryorder", im_saloutbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_deliveryorder", null, seqSmale);
                    }
                }
                if (bigSmal > 0) {
                    //采提数量大于销提数量时查询入库单号 出库单号 盘亏单号
                    //采购入库
                    DynamicObject tpv_dt_purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //销售出库
                    DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //其他出库
                    DynamicObject im_otheroutbill = BusinessDataServiceHelper.loadSingle("im_otheroutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    /*if (null != tpv_dt_purinbill) {
                        //插入入库单号
                        this.getModel().setValue("tpv_godownentry", tpv_dt_purinbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_godownentry", null, seqSmale);
                    }*/
                    if (null != im_saloutbill) {
                        //插入出库单号
                        this.getModel().setValue("tpv_deliveryorder", im_saloutbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_deliveryorder", null, seqSmale);
                    }
                    if (null != im_otheroutbill) {
                        //插入盘亏单号
                        this.getModel().setValue("tpv_lossodd", im_otheroutbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_lossodd", null, seqSmale);
                    }
                }
                if (bigSmal < 0) {
                    //采提数量小于销提数量时查询入库单号 出库单号 盘盈单号
                    //采购入库
                    DynamicObject tpv_dt_purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //销售出库
                    DynamicObject im_saloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    //其他入库
                    DynamicObject im_otherinbill = BusinessDataServiceHelper.loadSingle("im_otherinbill", "id,billno",
                            new QFilter("billentry.tpv_directconsignmentid", QCP.equals, id).toArray());
                    if (null != tpv_dt_purinbill) {
                        this.getModel().setValue("tpv_sonbill", "im_purinbill", seq);
                        this.getModel().setValue("tpv_sonbillnos", tpv_dt_purinbill.getString("billno"), seqSmale);
                        //插入入库单号
                        //this.getModel().setValue("tpv_godownentry", tpv_dt_purinbill.getString("billno"), seqSmale);
                    } else {
                        //this.getModel().setValue("tpv_godownentry", null, seqSmale);
                    }
                    if (null != im_saloutbill) {
                        //插入出库单号
                        this.getModel().setValue("tpv_deliveryorder", im_saloutbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_deliveryorder", null, seqSmale);
                    }
                    if (null != im_otherinbill) {
                        //插入出库单号
                        this.getModel().setValue("tpv_profitodd", im_otherinbill.getString("billno"), seqSmale);
                    } else {
                        this.getModel().setValue("tpv_profitodd", null, seqSmale);
                    }
                }
            }
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        //
        super.itemClick(evt);
        String key = evt.getItemKey();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        List<String> nopassSeqList = new ArrayList<>();
        DynamicObjectCollection tpvSonentryentity = dataEntity.getDynamicObjectCollection("tpv_sonentryentity");
        //监听拣配
        if (StringUtils.equals("tpv_configuration", key)) {
            PickShipsHelper.pickClick(this.getView());
        }
        if (StringUtils.equals("tpv_advconbaritemap1", key)) {
            nopassSeqList = new ArrayList<>();
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            int[] selectRows = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                if (tpvDestroyquantity.compareTo(BigDecimal.ZERO) == 0) {
                    nopassSeqList.add(String.valueOf(selectRow + 1));
                }
            }
            if (nopassSeqList.size() > 0) {
                this.getView().showMessage("选中行第" + String.join("、", nopassSeqList) + "行，未填写销提数量，请填写后再点击【物流确认销售实提】按钮");
            } else {
                for (int selectRow : selectRows) {
                    DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                    BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                    if (tpvDestroyquantity.compareTo(BigDecimal.ZERO) != 0) {
                        this.getModel().setValue("tpv_destroysure", true, selectRow);
                        dynamicObject.set("tpv_destroysure", true);
                        OperateOption optionOne = YEM.getOption();
                        OperationResult saveOneS = OperationServiceHelper.executeOperate("save", "tpv_dt_noconfiguration",
                                new DynamicObject[]{dataEntity}, optionOne);
                        SaveServiceHelper.update(dynamicObject);
                        this.getView().updateView("tpv_sonentryentity.tpv_destroysure", selectRow);
                    }
                }
                //判断数量实提完毕自动打勾
                updateRealsubmit(selectRows);
                updateParentEntryRowData();
            }
        }
        if (StringUtils.equals("tpv_advconbaritemap1no", key)) {
            nopassSeqList = new ArrayList<>();
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            int[] selectRows = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                String tpvDeliveryorder = dynamicObject.getString("tpv_deliveryorder"); //出库单号
                if (YEM.isNotEmpty(tpvDeliveryorder)) {
                    nopassSeqList.add(String.valueOf(selectRow + 1));
                }
            }
            if (nopassSeqList.size() > 0) {
                this.getView().showMessage("选中行第" + String.join("、", nopassSeqList) + "行，已出库，请重新选择在操作【+出库】按钮");
            } else {
                for (int selectRow : selectRows) {
                    this.getModel().setValue("tpv_destroysure", false, selectRow);
                    DynamicObject dynamicObject = tpvSonentryentity.get(selectRow);
                    dynamicObject.set("tpv_destroysure", false);
                    SaveServiceHelper.update(dynamicObject);
                    this.getView().updateView("tpv_sonentryentity.tpv_destroysure", selectRow);
                }
                //判断数量实提完毕自动打勾
                updateRealsubmit(selectRows);
                updateParentEntryRowData();
            }
        }
        if (StringUtils.equals("tpv_appearenter", key)) {
            nopassSeqList = new ArrayList<>();
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            int[] selectRows = entryGrid.getSelectRows();
            //获取单据主实体
            DynamicObject dataEntitys = this.getModel().getDataEntity(true);
            //获取分录数据
            DynamicObject tpv_dt_noconfiguration = BusinessDataServiceHelper.loadSingle("tpv_dt_noconfiguration", "id,tpv_sonentryentity",
                    new QFilter("id", QCP.equals, dataEntitys.getLong("id")).toArray());
            tpv_dt_noconfiguration = BusinessDataServiceHelper.loadSingle(tpv_dt_noconfiguration.getPkValue(),
                    tpv_dt_noconfiguration.getDynamicObjectType().getName());
            DynamicObjectCollection detailedinformation = tpv_dt_noconfiguration.getDynamicObjectCollection("tpv_sonentryentity");
            List<String> strings = new ArrayList<>();
            if (detailedinformation.size() > 0) {
                if (selectRows.length > 0) {
                    for (int selectRow : selectRows) {
                        DynamicObject dynamicObject = detailedinformation.get(selectRow);
                        boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                        String tpvDeliveryorder = (String) this.getModel().getValue("tpv_deliveryorder", selectRow);
                        //String tpvDeliveryorder = dynamicObject.getString("tpv_deliveryorder");
                        long pkValueS = (long) dynamicObject.getPkValue();
                        //销售出库
                        DynamicObjectCollection im_saloutbill = QueryServiceHelper.query("im_saloutbill", "billno",
                                new QFilter("billentry.tpv_srcbillsubentryid", QCP.equals, pkValueS).toArray());
                        StringBuffer desc = new StringBuffer();
                        if (!tpvDestroysure) { desc.append("销提确认为否、");}
                        StringBuffer str = new StringBuffer();
                        if (im_saloutbill.size() > 0) {//销售出库
                            str = new StringBuffer();
                            for (DynamicObject object : im_saloutbill) {
                                str.append(object.getString("billno"));
                            }
                            desc.append("存在下游销售出库" + str + ";");
                        }
                        if (YEM.isNotEmpty(desc.toString())) {
                            int message = 1 + selectRow;
                            nopassSeqList.add("第" + message + "行 " + desc + "不可+出库");
                        }
                    }
                    if (nopassSeqList.size() > 0) {
                        String result = String.join("", nopassSeqList);
                        this.getView().showMessage(result);
                    } else {
                        // 创建弹出动态表单页面对象
                        FormShowParameter showParameter = new FormShowParameter();
                        // 设置弹出页面的标识
                        showParameter.setFormId("tpv_dt_inventoryno");
                        // 状态
                        showParameter.setStatus(OperationStatus.ADDNEW);
                        // 设置页面关闭回调方法
                        // CloseCallBack参数：回调插件，回调标识
                        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_designate"));
                        // 设置弹出页面打开方式
                        showParameter.getOpenStyle().setShowType(ShowType.Modal);
                        // 打开动态表单
                        this.getView().showForm(showParameter);
                    }
                } else {
                    strings.add("请先选中行再点击+出入库单");
                }
            }
        }
    }
    /**
     * 判断数量实提完毕自动打勾
     * */
    private void updateRealsubmit(int[] selectRows) {
        DynamicObjectCollection tpvSonentryentityS = this.getModel().getEntryEntity("tpv_sonentryentity");
        BigDecimal qty = BigDecimal.ZERO;
        BigDecimal qtynum = BigDecimal.ZERO;
        if (tpvSonentryentityS.size() >= 0) {
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = tpvSonentryentityS.get(selectRow);
                //销提数量
                boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                if (tpvDestroysure) {
                    BigDecimal tpv_destroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                    BigDecimal tpv_fpackagereal = dynamicObject.getBigDecimal("tpv_fpackagereal");
                    qty = qty.add(tpv_destroyquantity);
                    qtynum = qtynum.add(tpv_fpackagereal);
                }
            }
        }
        BigDecimal tpv_qty = (BigDecimal) this.getModel().getValue("tpv_qty");
        BigDecimal tpv_packnum = (BigDecimal) this.getModel().getValue("tpv_packnum");
        int result1 = qty.compareTo(tpv_qty);
        int result2 = qtynum.compareTo(tpv_packnum);
        if (result1 >= 0 || result2 >= 0) {
            this.getModel().setValue("tpv_practicalok", true);
            DynamicObject dataEntityS = this.getModel().getDataEntity(true);
            dataEntityS.set("tpv_practicalok", true);
            this.getModel().setValue("tpv_qty", qty);
            dataEntityS.set("tpv_qty", qty);
            this.getModel().setValue("tpv_packnum", tpv_packnum);
            dataEntityS.set("tpv_packnum", tpv_packnum);
            SaveServiceHelper.update(dataEntityS);//写入数据库
            IFormView view = this.getView().getParentView();
            int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
            view.getModel().setValue("tpv_realsubmit", true, tpvEntryentity);
            view.getModel().setValue("tpv_qty", qty, tpvEntryentity);
            view.getModel().setValue("tpv_packnum", tpv_packnum, tpvEntryentity);
            this.getView().sendFormAction(view);
        } else {
            this.getModel().setValue("tpv_practicalok", false);
            DynamicObject dataEntityS = this.getModel().getDataEntity(true);
            dataEntityS.set("tpv_practicalok", false);
            SaveServiceHelper.update(dataEntityS);//写入数据库
            IFormView view = this.getView().getParentView();
            int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
            view.getModel().setValue("tpv_realsubmit", false, tpvEntryentity);
            this.getView().sendFormAction(view);
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent evt) {
        super.closedCallBack(evt);
        if (StringUtils.equals(evt.getActionId(), "tpv_designate")) { //+出入库操作后刷新父分录选中行
            updateParentEntryRowData();
        }
    }

    /**
     * 修改父分录选择行数据：销提数量、已出库数量、未出库数量
     * */
    private void updateParentEntryRowData() {
        IFormView view = this.getView().getParentView();
        int tpvEntryentity = view.getModel().getEntryCurrentRowIndex("tpv_entryentity");
        String tpv_zySubEntryid =  (String) view.getModel().getValue("tpv_sourceid", tpvEntryentity);
        if (YEM.isNotEmpty(tpv_zySubEntryid)) {
            String whereFilter = "1 = 1";
            whereFilter = String.format("%s and tpv_sourceid = %s", whereFilter, Long.valueOf(tpv_zySubEntryid));
            DataSet query = NoInventoryRptQuery.query(whereFilter);
            DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(query);
            //根据销售发货库存拣配直运子分录的id查询
            for (DynamicObject dynamicObject : dynamicObjects) {
                view.getModel().setValue("tpv_destroyquantitysum", dynamicObject.getBigDecimal("tpv_destroyquantitysum"), tpvEntryentity);
                view.getModel().setValue("tpv_issuedquantitys", dynamicObject.getBigDecimal("tpv_issuedquantitys"), tpvEntryentity);
                view.getModel().setValue("tpv_unissuedquanti", dynamicObject.getBigDecimal("tpv_unissuedquanti"), tpvEntryentity);
                view.getModel().setValue("tpv_logisticsok", dynamicObject.getBoolean("tpv_logisticsok"), tpvEntryentity);
                break;
            }
            this.getView().sendFormAction(view);
        }
    }

    /**
     * 按钮操作执行前监听
     * 阻止删行
     *
     * @param args
     */
    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate operate = (FormOperate) args.getSource();
        String key = operate.getOperateKey();
        List<String> nopassSeqList = new ArrayList<>();
        if (key.equals("deleteentry")) {
            nopassSeqList = new ArrayList<>();
            //获取单据体控件
            EntryGrid entryGrid = this.getView().getControl("tpv_sonentryentity");
            //获取选中行，数组为行号，从0开始int[]
            int selectRows[] = entryGrid.getSelectRows();
            //获取单据体数据集合
            DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_sonentryentity");
            if (selectRows != null && selectRows.length > 0) {
                for (int selectRow : selectRows) {
                    DynamicObject dynamicObject = entity.get(selectRow);  //获取选中行的单据体数据
                    boolean tpvDestroysure = dynamicObject.getBoolean("tpv_destroysure");
                    String tpvDeliveryorder = dynamicObject.getString("tpv_deliveryorder");
                    if (tpvDestroysure || YEM.isNotEmpty(tpvDeliveryorder)) {
                        nopassSeqList.add(String.valueOf(selectRow + 1));
                    }
                }
                if (nopassSeqList.size() > 0) {
                    args.setCancel(true);
                    this.getView().showErrorNotification("第" + String.join(",", nopassSeqList) + "行分录销提确认为是或出库单号有值时不允许删除不可删除");
                }
            }
        }
        //监听保存
        if (key.equals("save")) {
            nopassSeqList = new ArrayList<>();
            DynamicObjectCollection tpvSonentryentity = this.getModel().getEntryEntity("tpv_sonentryentity");
            for (DynamicObject dynamicObject : tpvSonentryentity) {
                BigDecimal tpvDestroyquantity = dynamicObject.getBigDecimal("tpv_destroyquantity");
                BigDecimal tpvPacknumIn = dynamicObject.getBigDecimal("tpv_packnum_in");
                BigDecimal tpvFpackagereal = dynamicObject.getBigDecimal("tpv_fpackagereal");
                if (tpvPacknumIn.compareTo(BigDecimal.ZERO) != 0) {
                    if (tpvDestroyquantity.compareTo(BigDecimal.ZERO) == 0 || tpvFpackagereal.compareTo(BigDecimal.ZERO) == 0) {
                        nopassSeqList.add("第" + dynamicObject.getInt("Seq") + "行销提数量或实提包装数量未填写");
                    }
                } else {
                    if (tpvDestroyquantity.compareTo(BigDecimal.ZERO) == 0) {
                        nopassSeqList.add("第" + dynamicObject.getInt("Seq") + "行销提数量未填写");
                    }
                }
            }
            if (nopassSeqList.size() > 0) {
                args.setCancel(true);
                this.getView().showMessage(String.join(",",nopassSeqList) + "\r\n 请填写后，再点击保存！");
            }
        }
    }

    /**
     * 监听保存按钮之后
     *
     * @param e
     */
    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String key = e.getOperateKey();
        if (key.equals("save")) {
            DynamicObjectCollection tpvSonentryentityS = this.getModel().getEntryEntity("tpv_sonentryentity");
            if (tpvSonentryentityS.size() > 0) {
                int[] rows = new int[tpvSonentryentityS.size()];
                for (int i = 0; i < tpvSonentryentityS.size(); i++) {
                    rows[i] = i;
                }
                updateRealsubmit(rows);
                updateParentEntryRowData();
            }
        }
        if (key.equals("deleteentry")) {
            this.getView().invokeOperation("save");
            updateParentEntryRowData();
        }
        packLock();
    }

    @Override
    public void hyperLinkClick(HyperLinkClickEvent e) {
        // TODO Auto-generated method stub
        int index = e.getRowIndex();
        if ("tpv_billno_in".equals(e.getFieldName())) {
            //父配货单据编号
            String tpvFatherpickbill = (String) this.getModel().getValue("tpv_pickbill_in", index);//父配货单据
            String tpvBillnos = (String) this.getModel().getValue("tpv_billno_in", index);//父配货单据编号
            DynamicObject random = BusinessDataServiceHelper.loadSingle(tpvFatherpickbill, "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvBillnos)});
            if (null != random) {
                skipMethod(tpvFatherpickbill, random.getPkValue());
            }
        }
        if ("tpv_sonbillnos".equals(e.getFieldName())) {
            //子配货单据编号
            String tpvSonbill = (String) this.getModel().getValue("tpv_sonbill", index);//子配货单据
            String tpvSonbillnos = (String) this.getModel().getValue("tpv_sonbillnos", index);//子配货单据编号
            DynamicObject random = BusinessDataServiceHelper.loadSingle(tpvSonbill, "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvSonbillnos)});
            if (null != random) {
                skipMethod(tpvSonbill, random.getPkValue());
            }
        }
        if ("tpv_godownentry".equals(e.getFieldName())) {
            //入库单号
            String tpvGodownentry = (String) this.getModel().getValue("tpv_godownentry", index);//入库单号
            DynamicObject im_Purinbill = BusinessDataServiceHelper.loadSingle("im_purinbill", "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvGodownentry)});
            if (null != im_Purinbill) {
                skipMethod("im_purinbill", im_Purinbill.getPkValue());
            }
        }
        if ("tpv_deliveryorder".equals(e.getFieldName())) {
            //出库单号
            String tpvDeliveryorder = (String) this.getModel().getValue("tpv_deliveryorder", index);//出库单号
            DynamicObject imSaloutbill = BusinessDataServiceHelper.loadSingle("im_saloutbill", "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvDeliveryorder)});
            if (null != imSaloutbill) {
                skipMethod("im_saloutbill", imSaloutbill.getPkValue());
            }
        }
        if ("tpv_profitodd".equals(e.getFieldName())) {
            //盘盈单号
            String tpvProfitodd = (String) this.getModel().getValue("tpv_profitodd", index);//盘盈单号
            DynamicObject imOPtheroutbill = BusinessDataServiceHelper.loadSingle("im_otherinbill", "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvProfitodd)});
            if (null != imOPtheroutbill) {
                skipMethod("im_otherinbill", imOPtheroutbill.getPkValue());
            }
        }
        if ("tpv_lossodd".equals(e.getFieldName())) {
            //盘亏单号
            String tpvLossodd = (String) this.getModel().getValue("tpv_lossodd", index);//盘亏单号
            DynamicObject imOtherinbill = BusinessDataServiceHelper.loadSingle("im_otheroutbill", "id",
                    new QFilter[]{new QFilter("billno", QCP.equals, tpvLossodd)});
            if (null != imOtherinbill) {
                skipMethod("im_otheroutbill", imOtherinbill.getPkValue());
            }
        }
        if ("tpv_contractmark".equals(e.getFieldName())) {
            String tpvContractmark = (String) this.getModel().getValue("tpv_contractmark", index);//采购合同号
            DynamicObject random = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", "id",
                    new QFilter[]{new QFilter("tpv_contractnumber", QCP.equals, tpvContractmark)});
            if (null != random) {
                skipMethod("tpv_dt_purchase", random.getPkValue());
            }
        }
    }

    public void skipMethod(String formId, Object object) {
        BillShowParameter showParameter = new BillShowParameter();
        showParameter.setFormId(formId);
        showParameter.setPkId(object);
        showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
        showParameter.setStatus(OperationStatus.VIEW);
        this.getView().showForm(showParameter);
    }
}
