package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.util.EventObject;
import java.util.List;

/**
 *@Description: 销售价格确认单、货物流转单 选择根据合同名过滤出的认领明细单
 *@Project: zhck
 *@Package: tpv.tpv_wm.tpv_dt.java.formplugin.form.ContractClaimDetailFilterFormPlugin
 *@Date: 2024/04/02 15:10
 *@Author: Heisenberg Wenbei He
 *@Version: 1.0
 */
public class ContractClaimDetailFilterFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit settlement = this.getControl("tpv_settlement_edit");
        settlement.addBeforeF7SelectListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent beforeF7SelectEvent) {
        switch (beforeF7SelectEvent.getProperty().getName()) {
            case "tpv_settlement_edit":
                this.addFilter(beforeF7SelectEvent);
                break;
            default:
                break;
        }
    }

    /**
     * @param beforeF7SelectEvent:
     * @author: Heisenberg
     * @date: 2024/4/2 16:03
     * @description: 销售价格确认单、货物流转单 认领明细单 F7 添加过滤
     */
    private void addFilter(BeforeF7SelectEvent beforeF7SelectEvent) {
        ListShowParameter parameter = (ListShowParameter) beforeF7SelectEvent.getFormShowParameter();
        List<QFilter> qFilters = parameter.getListFilterParameter().getQFilters();
        switch (this.getModel().getDataEntityType().getName()) {

            // 销售价格确认单
            case "tpv_dt_salepricebill":
                String contractnumber = (String) this.getModel().getValue("tpv_contractnumber");
                qFilters.add(new QFilter("tpv_sacontractnum.tpv_name", QCP.equals, contractnumber));
                break;

            // 货物流转单
            case "tpv_dt_freigroambill":
                String purcontnum = (String) this.getModel().getValue("tpv_purcontnum");
                qFilters.add(new QFilter("tpv_prcontractnum.tpv_name", QCP.equals, purcontnum));
                break;
            default:
                break;
        }
    }
}
