package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.ArrayList;
import java.util.EventObject;

/**
 *
 *采购合同号销售合同号基础资料过滤
 * @author LiuHB
 * @version 1.0
 */
public class CostInformFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit unita = (BasedataEdit) this.getView().getControl("tpv_purconum");
        BasedataEdit unitb = (BasedataEdit) this.getView().getControl("tpv_saleconum");
        BasedataEdit operator = (BasedataEdit) this.getView().getControl("tpv_department");
        unita.addBeforeF7SelectListener(this);
        unitb.addBeforeF7SelectListener(this);
        operator.addBeforeF7SelectListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent beforeF7SelectEvent) {
        String name = beforeF7SelectEvent.getProperty().getName();
        switch (name) {
            case "tpv_purconum":
                qFilterThisbilltypea(beforeF7SelectEvent);
                break;
            case "tpv_saleconum":
                qFilterThisbilltypeb(beforeF7SelectEvent);
                break;
            case "tpv_department":
                this.addOrgFilter(beforeF7SelectEvent);
                break;
            default:
                break;
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
//        if ("tpv_operator".equals(name)) {
//            long id = (long) ((DynamicObject) e.getChangeSet()[0].getNewValue()).getPkValue();
//            DynamicObject user = BusinessDataServiceHelper.loadSingle("bos_user",
//                    new QFilter[]{new QFilter("id", QCP.equals, id)});
//            DynamicObjectCollection collection = user.getDynamicObjectCollection("entryentity");
//            ArrayList<Long> ids = new ArrayList<>();
//            for (DynamicObject object : collection) {
//                Long dptId = (Long) object.getDynamicObject("dpt").getPkValue();
//                ids.add(dptId);
//            }
//            if (ids.size() > 1) {
//                this.getModel().setValue("tpv_department", null);
//            }
//        }
    }

    private void addOrgFilter(BeforeF7SelectEvent evt) {
//        ListShowParameter showParameter = (ListShowParameter) evt.getFormShowParameter();
//        long id = (long) ((DynamicObject) this.getModel().getValue("tpv_operator")).getPkValue();
//        DynamicObject user = BusinessDataServiceHelper.loadSingle("bos_user",
//                new QFilter[]{new QFilter("id", QCP.equals, id)});
//        DynamicObjectCollection collection = user.getDynamicObjectCollection("entryentity");
//        ArrayList<Long> ids = new ArrayList<>();
//        for (DynamicObject object : collection) {
//            Long dptId = (Long) object.getDynamicObject("dpt").getPkValue();
//            ids.add(dptId);
//        }
//        showParameter.getListFilterParameter().setFilter(new QFilter("id", QCP.in, ids));
    }

    private void qFilterThisbilltypeb(BeforeF7SelectEvent evt) {
        ListShowParameter showParameter = (ListShowParameter) evt.getFormShowParameter();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection dabilltype = dataEntity.getDynamicObjectCollection("tpv_pactmessage");
        Long companyid = 0L;
        Long departmentid = 0L;

        if (null != dabilltype) {
            DynamicObject company = (DynamicObject) this.getModel().getValue("tpv_company");
            DynamicObject department = (DynamicObject) this.getModel().getValue("tpv_department");
            if (null != company) {
                companyid = company.getLong("id");
                showParameter.getListFilterParameter().setFilter(new QFilter("org.id", QCP.equals, companyid));
            }
            if (null != department) {
                departmentid = department.getLong("id");
                showParameter.getListFilterParameter().setFilter(new QFilter("tpv_department.id", QCP.equals, departmentid));
            }
        }

    }


    private void qFilterThisbilltypea(BeforeF7SelectEvent evt) {
        ListShowParameter showParameter = (ListShowParameter) evt.getFormShowParameter();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection dabilltype = dataEntity.getDynamicObjectCollection("tpv_pactmessage");
        Long companyid = 0L;
        Long departmentid = 0L;

        if (null != dabilltype) {
            DynamicObject company = (DynamicObject) this.getModel().getValue("tpv_company");
            DynamicObject department = (DynamicObject) this.getModel().getValue("tpv_department");
            if (null != company) {
                companyid = company.getLong("id");
                showParameter.getListFilterParameter().setFilter(new QFilter("org.id", QCP.equals, companyid));
            }
            if (null != department) {
                departmentid = department.getLong("id");
                showParameter.getListFilterParameter().setFilter(new QFilter("tpv_department.id", QCP.equals, departmentid));
            }
        }
    }
}
