package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import com.alibaba.nacos.common.utils.StringUtils;
import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.resource.ResManager;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.BeforeDeleteRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.validate.ValidateResultCollection;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.Toolbar;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.operate.FormOperate;
import kd.bos.isc.util.misc.StringUtil;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.DeleteServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.fi.ap.vo.CloudInvoiceResultVO;
import kd.fi.arapcommon.util.JsonUtils;
import kd.pccs.concs.common.constant.OperationConst;
import tpv.tpv_wm.tpv_dt.java.formplugin.dynamic.InvoiceMatchBillEdit;

import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 费用发票
 *
 * @author LiuHB
 * @version 1.0
 */
public class CostbillmatFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {
    private final static String KEY_MBAR = "tbmain";
    private static BigDecimal taxnoinclamt = BigDecimal.ZERO;
    private static BigDecimal vatamt = BigDecimal.ZERO;
    private static BigDecimal rate = BigDecimal.ZERO;
    private static BigDecimal taxinclamt = BigDecimal.ZERO;
    private static String TPV_PACTMESSAGE = "tpv_pactmessage"; //合同分录
    private static String TPV_MATECOST = "tpv_matecost"; //入库分录

    /**
     * 监听按钮
     *
     * @param e
     */
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        Toolbar ambar = this.getView().getControl(KEY_MBAR);
        Toolbar bmbar = this.getView().getControl("tpv_advcontoolbarap2");
        Toolbar cmbar = this.getView().getControl("tpv_advcontoolbarap3");
        Toolbar dmbar = this.getView().getControl("tpv_advcontoolbarap1");
        BasedataEdit tpv_costitem = (BasedataEdit) this.getView().getControl("tpv_costitem");
        tpv_costitem.addBeforeF7SelectListener(this);
        BasedataEdit tpv_operator = (BasedataEdit) this.getView().getControl("tpv_operator");
        tpv_operator.addBeforeF7SelectListener(this);
        ambar.addItemClickListener(this);
        bmbar.addItemClickListener(this);
        cmbar.addItemClickListener(this);
        dmbar.addItemClickListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent evt) {
        String name = evt.getProperty().getName();
        switch (name) {
            case "tpv_operator":
                operatorF7(evt, name);
                break;
            case "tpv_costitem":
                String entityName = this.getModel().getDataEntityType().getName();
                QFilter qFilterEr = new QFilter("enable", QCP.equals, "1");
                qFilterEr.and(new QFilter("billtype.number", QCP.equals, entityName));
                DynamicObject[] load = BusinessDataServiceHelper.load("er_expenseitembill", "expenseitem,billtype", qFilterEr.toArray());
                List<Long> ids = new ArrayList<>();
                if (load.length > 0) {
                    for (DynamicObject dynamicObject : load) {
                        DynamicObject expenseitem = dynamicObject.getDynamicObject("expenseitem");
                        if (YEM.isNotEmpty(expenseitem)) {
                            ids.add(expenseitem.getLong("id"));
                        }
                    }
                }
                QFilter qFilter = new QFilter("enable", QCP.equals, "1");
                if (ids.size() > 0) {
                    qFilter.and(new QFilter("id", QCP.in, ids));
                } else {
                    qFilter.and(new QFilter("id", QCP.less_than, 0l));
                }
                ListShowParameter showParameter = (ListShowParameter) evt.getFormShowParameter();
                showParameter.getTreeFilterParameter().getQFilters().add(qFilter);
                showParameter.getListFilterParameter().getQFilters().add(qFilter);
                break;
        }
    }

    private void operatorF7(BeforeF7SelectEvent e, String key) {
        DynamicObject tpvCompany = (DynamicObject) this.getModel().getValue("tpv_company");
        if (tpvCompany != null) {
            List<QFilter> QFilters = new ArrayList();
            ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
            DynamicObject[] bosOrg = BusinessDataServiceHelper.load("bos_org_orgrelation_dept", "toorg", new QFilter[]{new QFilter("fromorg", "=", tpvCompany.getPkValue())});
            List<Long> listOrg = Arrays.stream(bosOrg)
                    .map(org -> org.getDynamicObject("toorg"))
                    .filter(Objects::nonNull)
                    .map(toorg -> toorg.getLong("id"))
                    .collect(Collectors.toList());
            CloseCallBack closeCallBack = new CloseCallBack(this, key);
            showParameter.setCloseCallBack(closeCallBack);
            QFilters.add(new QFilter("entryentity.dpt", "in", listOrg));
            showParameter.getListFilterParameter().setQFilters(QFilters);
        } else {
            e.setCancel(true);
//            this.getView().showTipNotification("请先选择公司！");
        }

    }

    /**
     * 按钮点击判断弹出动态表单
     *
     * @param evt
     */
    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        List<String> notInputs = new ArrayList<>();
        Map<String, Object> param = new HashMap<>();
        OperationResult saveOperate;
        String itemKey = evt.getItemKey();
        switch (itemKey) {
            case "tpv_grathinvoicebtn":
                showInvCollect("ap_invcollect", "invCollectCustom");//采集发票按钮
                break;
            case "tpv_matchinvoicebtn":  //匹配实体发票信息
                notInputs = new ArrayList<>();
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_company");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_billunit");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_invoicetype");
                if (notInputs.size() > 0) {
                    view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
                } else {
//                    saveOperate = OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
//                            new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
                    OperationResult operationResult = this.getView().invokeOperation("save", YEM.getOptionNoMsg());
                    if (operationResult.isSuccess()) {
                        matchInvoice("tpv_dt_matchbill", "invoce", true);
                    }
                }
                break;
            case "tpv_matedegression":  //修正已有暂估费用成本
                notInputs = new ArrayList<>();
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_company");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_billunit");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_costitem");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_department");
                if (notInputs.size() > 0) {
                    view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
                } else {
                    saveOperate = OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
                            new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
                    if (saveOperate.isSuccess()) {
                        FormShowParameter showParameter = new FormShowParameter();
                        showParameter.setStatus(OperationStatus.ADDNEW);
                        showParameter.getOpenStyle().setShowType(ShowType.Modal);
                        showParameter.setFormId("tpv_dt_matccost");
                        Map<String, Object> cos = this.costapproach();
                        showParameter.setCustomParams(cos);
                        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_matedegression"));
                        this.getView().showForm(showParameter);
                    }
                }
                break;
            case "tpv_matestorage":  //新增入库明细费用成本
                notInputs = new ArrayList<>();
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_company");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_billunit");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_department");
                if (notInputs.size() > 0) {
                    view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
                } else {
                    saveOperate = OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
                            new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
                    if (saveOperate.isSuccess()) {
                        FormShowParameter showParameters = new FormShowParameter();
                        showParameters.setStatus(OperationStatus.ADDNEW);
                        showParameters.getOpenStyle().setShowType(ShowType.Modal);
                        showParameters.setFormId("tpv_dt_matcentry");
                        Map<String, Object> maps = this.journalizing();
                        showParameters.setCustomParams(maps);
                        showParameters.setCloseCallBack(new CloseCallBack(this, "tpv_matestorage"));
                        this.getView().showForm(showParameters);
                    }
                }
                break;
            case "tpv_baritemap":  //录入含税金额分摊
                FormShowParameter showParameterz = new FormShowParameter();
                showParameterz.setStatus(OperationStatus.ADDNEW);
                showParameterz.getOpenStyle().setShowType(ShowType.Modal);
                showParameterz.setFormId("tpv_dt_entertaxinc");
                Map<String, Object> map = this.showInfoForm();
                showParameterz.setCustomParams(map);
                showParameterz.setCloseCallBack(new CloseCallBack(this, "tpv_baritemap"));
                this.getView().showForm(showParameterz);
                break;
            case "tpv_chargeofffinarbtn":  //【冲销应收单号】按钮
                notInputs = new ArrayList<>();
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_company");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_costitem");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_department");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_wmcurrency");
                if (notInputs.size() > 0) {
                    view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
                } else {
                    saveOperate = OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
                            new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
                    if (saveOperate.isSuccess()) {
                        FormShowParameter showParameters = new FormShowParameter();
                        showParameters.setStatus(OperationStatus.ADDNEW);
                        showParameters.getOpenStyle().setShowType(ShowType.Modal);
                        showParameters.setFormId("tpv_dt_chargeofffinar");
                        Map<String, Object> maps = this.chargeofffinar();
                        showParameters.setCustomParams(maps);
                        showParameters.setCloseCallBack(new CloseCallBack(this, "tpv_chargeofffinarbtn"));
                        this.getView().showForm(showParameters);
                    }
                }
                break;
            case "tpv_taxmatpricesbtn": //批量录入本次匹配单价(含税)
                priceOrRateClick("tpv_taxmatpricesinfo", "tpv_taxmatpricesbtn");
                break;
            case "tpv_ratedsbtn": //批量录入本次匹配税率%
                priceOrRateClick("tpv_ratedsinfo", "tpv_ratedsbtn");
                break;
            default:
                break;
        }
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
//        this.getModel().getDataEntity(true);
//        String billNo = (String) this.getModel().getValue("billno");
//        BigDecimal matchedQty = BigDecimal.ZERO;
//        BigDecimal matchamoalltax = BigDecimal.ZERO;
//        BigDecimal matchamonoalltax = BigDecimal.ZERO;
//        BigDecimal matchamoinalltax = BigDecimal.ZERO;
//        DynamicObjectCollection invoiceEntry = this.getModel().getEntryEntity("tpv_invoiceinfoentry");
//        HashMap<String, HashMap<String, BigDecimal>> dataMap = getMatchedQty(billNo);//获取已匹配数量等
//        for (DynamicObject object : invoiceEntry) {
//            String invoiceNum = object.getString("tpv_invocenum");
//            BigDecimal pricetaxtotal = object.getBigDecimal("tpv_taxamount");
//            BigDecimal amount = object.getBigDecimal("tpv_notaxamount");
//            BigDecimal tax = object.getBigDecimal("tpv_amountincrease");
//            if (dataMap.get(invoiceNum) != null) {
//                HashMap<String, BigDecimal> decimalHashMap = dataMap.get(invoiceNum);
//                matchedQty = decimalHashMap.get("curmactchallqty");//已匹配数量
//                matchamoalltax = decimalHashMap.get("curmatchamoalltax");//已匹配金额(含税)
//                matchamonoalltax = decimalHashMap.get("curmatchamonoalltax");//已匹配金额(不含税)
//                matchamoinalltax = decimalHashMap.get("curmatchamoinalltax");//已匹配金额(增值税额)
//                object.set("tpv_invoicmate", matchedQty);//已匹配数量
//                object.set("tpv_matchamotax", matchamoalltax);//已匹配金额(含税)
//                object.set("tpv_matchamonotax", matchamonoalltax);//已匹配金额(不含税)
//                object.set("tpv_matchamointax", matchamoinalltax);//已匹配金额(增值税)
//                object.set("tpv_unmatchamotax", pricetaxtotal.subtract(matchamoalltax));//未匹配金额(含税)
//                object.set("tpv_numatchamonotax", amount.subtract(matchamonoalltax));//未匹配金额(不含税)
//                object.set("tpv_unmatchamointax", tax.subtract(matchamoinalltax));//未匹配金额(增值税额)
//
//            }
//            this.getView().updateView("tpv_invoiceinfoentry");
//        }

    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        this.setCurrencyAndExchangeTable();
        this.setExchangeRate();
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs evt) {
        super.afterDoOperation(evt);
        String key = evt.getOperateKey();
        if ("redpunch".equals(key)) {
            this.getView().invokeOperation("refresh");
        }
        if ("untakeeffect".equals(key)) {

        }
    }

    /**
     * 默认本位币、汇率表加载，根据（核算组织本位币设置）
     */
    private void setCurrencyAndExchangeTable() {
        DynamicObject org = (DynamicObject) this.getModel().getValue("org");
        if (org != null) {
            DynamicObject bd_accountingsys_base = BusinessDataServiceHelper.loadSingle("bd_accountingsys_base",
                    "id,basecurrrency,exratetable", new QFilter[]{new QFilter("baseacctorg", QCP.equals, org.getPkValue())});
            if (bd_accountingsys_base != null) {
                DynamicObject basecurrrency = bd_accountingsys_base.getDynamicObject("basecurrrency");
                DynamicObject exratetable = bd_accountingsys_base.getDynamicObject("exratetable");
                this.getModel().setValue("tpv_wmcurrencybase", basecurrrency);
                this.getModel().setValue("tpv_wmexratetable", exratetable);
            }
        }
    }

    /**
     * 汇率获取
     */
    private void setExchangeRate() {
        Object tpv_exratetable = this.getModel().getValue("tpv_wmexratetable");
        Object tpv_currency = this.getModel().getValue("tpv_wmcurrency");
        Object tpv_currencybase = this.getModel().getValue("tpv_wmcurrencybase");
        Date tpv_exratedate = (Date) this.getModel().getValue("tpv_wmexratedate");
        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
        BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
        this.getModel().setValue("tpv_wmexchangeratermb", exchangeRateCny);
        this.getModel().setValue("tpv_wmexchangerateusd", exchangeRateUsd);
        this.getModel().setValue("tpv_wmexchangerate", exchangeRate);
    }

    private void priceOrRateClick(String formId, String callBack) {
        EntryGrid entryGrid = this.getView().getControl("tpv_matecost");
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length > 0) {
            FormShowParameter showParameter = new FormShowParameter();
            showParameter.setStatus(OperationStatus.ADDNEW);
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            showParameter.setFormId(formId);
            showParameter.setCloseCallBack(new CloseCallBack(this, callBack));
            this.getView().showForm(showParameter);
        } else {
            this.getView().showTipNotification("请先选中分录行，在进行操作");
        }
    }

    /**
     * 采集发票弹框
     *
     * @param name
     * @param actionID
     */
    private void showInvCollect(String name, String actionID) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        long orgPk = RequestContext.get().getOrgId();
        FormShowParameter parameter = new FormShowParameter();
        Map<String, Object> map = new HashMap<>();
        DynamicObject tpvCompany = dataEntity.getDynamicObject("tpv_company");
        map.put("tpv_company", tpvCompany);
        map.put("fp", "fy");
        parameter.setCustomParams(map);
        parameter.getOpenStyle().setShowType(ShowType.Modal);
        parameter.getCustomParams().put("orgPk", YEM.isNotEmpty(tpvCompany) ? tpvCompany.getLong("id") : 0l);
        parameter.setFormId(name);
        parameter.setCloseCallBack(new CloseCallBack(this, actionID));
        this.getView().showForm(parameter);
    }

    /**
     * @Title: matchInvoice
     * @Description: 匹配发票信息
     * @param:
     * @return: a
     */
    private void matchInvoice(String name, String actionID, boolean b) {

        FormShowParameter showParameter = new FormShowParameter();

        showParameter.setFormId(name);

        showParameter.setStatus(OperationStatus.ADDNEW);

        showParameter.setCustomParams(setInfo(b));

        showParameter.setCloseCallBack(new CloseCallBack(this, actionID));

        showParameter.getOpenStyle().setShowType(ShowType.Modal);

        this.getView().showForm(showParameter);

    }

    /**
     * @Title: setInfo
     * @Description:
     * @param:
     * @return: a
     */
    private Map<String, Object> setInfo(boolean b) {
        HashMap<String, Object> map = new HashMap<>();
        DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_invoiceinfoentry");
        String sourceId = "";
        for (DynamicObject object : entity) {
            sourceId += object.getString("tpv_sourceid") + ",";
        }
        map.put("sourceID", sourceId);
        map.put("supplier", this.getModel().getValue("tpv_billunit"));
        if (b) {
            DynamicObjectCollection invoiceinfoentry = this.getModel().getEntryEntity("tpv_invoiceinfoentry");
            map.put("invoiceEntry", invoiceinfoentry);
        }
        return map;
    }

    /**
     * 动态表单回填单据字段
     */

    private void setInwardInfoc(Map<String, Object> value) {
        if (value.size() > 0) {
            BigDecimal tpvTaxinclamt = BigDecimalUtils.toBigDecimal(value.get("tpv_taxinclamt"));
            BigDecimal tpvTaxnoinclamt = BigDecimalUtils.toBigDecimal(value.get("tpv_taxnoinclamt"));
            BigDecimal tpvVatamt = BigDecimalUtils.toBigDecimal(value.get("tpv_vatamt"));
            this.getModel().setValue("tpv_taxinclamt", tpvTaxinclamt);
            this.getModel().setValue("tpv_taxnoinclamt", tpvTaxnoinclamt);
            this.getModel().setValue("tpv_vatamt", tpvVatamt);
            this.getView().updateView("tpv_taxinclamt");
            this.getView().updateView("tpv_taxnoinclamt");
            this.getView().updateView("tpv_vatamt");
            sumtotal();
            DynamicObject dataEntity = this.getView().getModel().getDataEntity(true);
            OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
                    new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
        }
    }


    private void setInwardInfob(List<Map<String, Object>> value) {
        IDataModel model = this.getModel();
//        model.deleteEntryData("tpv_matecost");
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpvCostitem = dataEntity.getDynamicObject("tpv_costitem");
        DynamicObject taxrated = null;
        BigDecimal taxrated_taxrate = BigDecimal.ZERO;
        if (YEM.isNotEmpty(tpvCostitem)) {
            BigDecimal taxrate = tpvCostitem.getBigDecimal("taxrate");
            if (null != taxrate) {
                DynamicObject[] load = BusinessDataServiceHelper.load("bd_taxrate", "id,taxrate", new QFilter[]{new QFilter("enable", QCP.equals, "1")
                        .and(new QFilter("taxrate", QCP.equals, taxrate))}, "activedate desc", 1);
                if (load.length > 0) {
                    for (DynamicObject dynamicObject : load) {
                        taxrated = dynamicObject;
                        taxrated_taxrate = dynamicObject.getBigDecimal("taxrate");
                    }
                }
            }
        }
        for (Map<String, Object> values : value) {
            DynamicObjectCollection tpvMatecost = this.getModel().getEntryEntity("tpv_matecost");
            int rowIndex = this.getModel().createNewEntryRow("tpv_matecost");
            this.getModel().setValue("tpv_matchtype", "A", rowIndex);
            this.getModel().setValue("tpv_taxmatamt", values.get("tpv_taxmatamt"), rowIndex);
            this.getModel().setValue("tpv_rkratedd", taxrated, rowIndex);
            this.getModel().setValue("tpv_rated", taxrated_taxrate, rowIndex);
            this.getModel().setValue("tpv_taxnomatamt", values.get("tpv_taxnomatamt"), rowIndex);// 本次匹配
            this.getModel().setValue("tpv_vatnomatamt", values.get("tpv_vatnomatamt"), rowIndex);
            this.getModel().setValue("tpv_departmet", values.get("tpv_departmet"), rowIndex);//部门
            this.getModel().setValue("tpv_purchnumds", values.get("tpv_purchnumd"), rowIndex);//采购合同号
            this.getModel().setValue("tpv_inbordnum", values.get("tpv_inbordnum"), rowIndex);//入库单号
            this.getModel().setValue("tpv_vendors", values.get("tpv_vendors"), rowIndex);//供应商
            this.getModel().setValue("tpv_itemcode", values.get("tpv_itemcode"), rowIndex);//物料编码
            this.getModel().setValue("tpv_conprodname", values.get("tpv_conprodname"), rowIndex);//品名
            this.getModel().setValue("tpv_conshader", values.get("tpv_conshader"), rowIndex);//材质
            this.getModel().setValue("tpv_conorigin", values.get("tpv_conorigin"), rowIndex);//产地
            this.getModel().setValue("tpv_conspecation", values.get("tpv_conspecation"), rowIndex);//规格
            this.getModel().setValue("tpv_conqty", values.get("tpv_conqty"), rowIndex);//数量
            this.getModel().setValue("tpv_contractamo", values.get("tpv_contractamo"), rowIndex);//金额
            this.getModel().setValue("tpv_currency", values.get("tpv_currency"), rowIndex);//币别
            this.getModel().setValue("tpv_inboentid", values.get("tpv_inboentid"), rowIndex);//入库分录id



        }
        OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
                new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
    }


    private void setInwardInfoa(List<Map<String, Object>> value) {//成本
        IDataModel model = this.getModel();
//        model.deleteEntryData("tpv_matecost");//清空分录
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Map<String, DynamicObject> taxrateMap = new HashMap<>();
        DynamicObject[] load = BusinessDataServiceHelper.load("bd_taxrate", "id,taxrate", new QFilter[]{new QFilter("enable", QCP.equals, "1")
                .and(new QFilter("taxrate", QCP.large_equals, 0))});
        if (load.length > 0) {
            for (DynamicObject dynamicObject : load) {
                taxrateMap.put(dynamicObject.getBigDecimal("taxrate").stripTrailingZeros().toPlainString(), dynamicObject);
            }
        }
        for (Map<String, Object> values : value) {
            DynamicObjectCollection tpvMatecost = this.getModel().getEntryEntity("tpv_matecost");
            int rowIndex = this.getModel().createNewEntryRow("tpv_matecost");
            this.getModel().setValue("tpv_matchtype", "B", rowIndex);
            this.getModel().setValue("tpv_taxmatamt", values.get("tpv_taxmatamt"), rowIndex);
            this.getModel().setValue("tpv_rkratedd", taxrateMap.containsKey(BigDecimalUtils.toBigDecimal(values.get("tpv_rate")).stripTrailingZeros().toPlainString())
                    ? taxrateMap.get(BigDecimalUtils.toBigDecimal(values.get("tpv_rate")).stripTrailingZeros().toPlainString()) : null, rowIndex);
            this.getModel().setValue("tpv_rated", taxrateMap.containsKey(BigDecimalUtils.toBigDecimal(values.get("tpv_rate")).stripTrailingZeros().toPlainString())
                    ? values.get("tpv_rate") : BigDecimal.ZERO, rowIndex);
            this.getModel().setValue("tpv_ratecost", taxrateMap.containsKey(BigDecimalUtils.toBigDecimal(values.get("tpv_rate")).stripTrailingZeros().toPlainString())
                    ? values.get("tpv_rate") : BigDecimal.ZERO, rowIndex);
            this.getModel().setValue("tpv_taxnomatamt", values.get("tpv_taxnomatamt"), rowIndex);
            this.getModel().setValue("tpv_vatnomatamt", values.get("tpv_vatnomatamt"), rowIndex);
            this.getModel().setValue("tpv_departmet", values.get("tpv_departmet"), rowIndex);//部门
            this.getModel().setValue("tpv_purchnumds", values.get("tpv_purchnumd"), rowIndex);//采购合同号
            this.getModel().setValue("tpv_inbordnum", values.get("tpv_inbordnum"), rowIndex);//入库单号
            this.getModel().setValue("tpv_vendors", values.get("tpv_vendors"), rowIndex);//供应商
            this.getModel().setValue("tpv_itemcode", values.get("tpv_itemcode"), rowIndex);//物料编码
            this.getModel().setValue("tpv_conprodname", values.get("tpv_conprodname"), rowIndex);//品名
            this.getModel().setValue("tpv_conshader", values.get("tpv_conshader"), rowIndex);//材质
            this.getModel().setValue("tpv_conorigin", values.get("tpv_conorigin"), rowIndex);//产地
            this.getModel().setValue("tpv_conspecation", values.get("tpv_conspecation"), rowIndex);//规格
            this.getModel().setValue("tpv_conqty", values.get("tpv_conqty"), rowIndex);//数量
            this.getModel().setValue("tpv_contractamo", values.get("tpv_contractamo"), rowIndex);//金额
            this.getModel().setValue("tpv_currency", values.get("tpv_currency"), rowIndex);//币别
            this.getModel().setValue("tpv_inboentid", values.get("tpv_inboentid"), rowIndex);//入库分录id
            this.getModel().setValue("tpv_costbreaid", values.get("tpv_cosbreakid"), rowIndex);//成本明细分录id
            this.getModel().setValue("tpv_typecost", values.get("tpv_typecost"), rowIndex);//成本类型
//            this.getModel().setValue("");
        }
        OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
                new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
    }

    /**
     * 动态表单关闭回调事件
     */

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
        Object returnData = closedCallBackEvent.getReturnData();
        String actionId = closedCallBackEvent.getActionId();
        switch (actionId) {
            case "tpv_operator":
                operatorCallBack(closedCallBackEvent);
                break;
            default:
                break;
        }
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_baritemap") && null != closedCallBackEvent.getReturnData()) {
            Map<String, Object> value = (Map<String, Object>) returnData;
            this.setInwardInfoc(value);
            return;
        }
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_matestorage") && null != closedCallBackEvent.getReturnData()) {

            List<Map<String, Object>> value = (List<Map<String, Object>>) returnData;
            this.setInwardInfob(value);
            return;
        }
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_matedegression") && null != closedCallBackEvent.getReturnData()) {

            List<Map<String, Object>> value = (List<Map<String, Object>>) returnData;
            this.setInwardInfoa(value);
            return;
        }
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "invCollectCustom") && null != closedCallBackEvent.getReturnData()) {
            invCollectCustom(returnData);
            return;
        }
        if (closedCallBackEvent.getReturnData() instanceof HashMap) {
            HashMap<String, DynamicObjectCollection> returnDatas = (HashMap<String, DynamicObjectCollection>) closedCallBackEvent.getReturnData();
            if (StringUtils.equals(closedCallBackEvent.getActionId(), "invoce") && (returnDatas != null && returnDatas.get("cols").size() > 0)) {
                invoice(returnDatas);
            }
            if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_chargeofffinarbtn") && (returnDatas != null && returnDatas.get("cols").size() > 0)) {
                chargeofffinar(returnDatas);
            }
        }
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_taxmatpricesbtn") && null != closedCallBackEvent.getReturnData()) {
            BigDecimal data = returnData != null ? (BigDecimal) returnData : BigDecimal.ZERO;
            this.getModel().getDataEntity(true);
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_matecost");
            int[] selectRows = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                this.getModel().setValue("tpv_taxmatprice", data, selectRow);
                this.getView().updateView("tpv_taxmatprice", selectRow);
            }
            OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
                    new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
            return;
        }
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_ratedsbtn") && null != closedCallBackEvent.getReturnData()) {
            Map<String, Object> value = (Map<String, Object>) returnData;
            BigDecimal taxrate = BigDecimalUtils.toBigDecimal(value.get("taxrate"));
            Long rated = (Long) value.get("rated");
            DynamicObject bd_taxrate = null;
            if (YEM.isNotEmpty(rated) && rated > 0l) {
                bd_taxrate = BusinessDataServiceHelper.loadSingle(rated, "bd_taxrate");
            }
            this.getModel().getDataEntity(true);
            // 获取单据体选中行
            EntryGrid entryGrid = this.getView().getControl("tpv_matecost");
            int[] selectRows = entryGrid.getSelectRows();
            for (int selectRow : selectRows) {
                this.getModel().setValue("tpv_rkratedd", bd_taxrate, selectRow);
                this.getModel().setValue("tpv_rated", taxrate, selectRow);
                this.getView().updateView("tpv_rkratedd", selectRow);
                this.getView().updateView("tpv_rated", selectRow);
            }
            OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
                    new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
            return;
        }
    }

//    private void setPriceOrRates(String tpv_priceOrRates, Object returnData) {
//        BigDecimal data = returnData != null ? (BigDecimal) returnData : BigDecimal.ZERO;
//        this.getModel().getDataEntity(true);
//        // 获取单据体选中行
//        EntryGrid entryGrid = this.getView().getControl("tpv_matecost");
//        int[] selectRows = entryGrid.getSelectRows();
//        for (int selectRow : selectRows) {
//            this.getModel().setValue(tpv_priceOrRates, data, selectRow);
//            this.getView().updateView(tpv_priceOrRates, selectRow);
//        }
//        OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
//                new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
//    }

    private void operatorCallBack(ClosedCallBackEvent e) {
        IDataModel model = this.getModel();
        ListSelectedRowCollection selectedRows = (ListSelectedRowCollection) e.getReturnData();
        if (selectedRows != null && selectedRows.size() > 0) {
            ListSelectedRow selectedRow = selectedRows.get(0);
            long userId = (long) selectedRow.getPrimaryKeyValue();//人员id
            long userEntryId = (long) selectedRow.getEntryPrimaryKeyValue();//部门分录id
            DynamicObject tpvDepartment = (DynamicObject) this.getModel().getValue("tpv_department");
            model.beginInit();
            model.setValue("tpv_operator", userId);
            DynamicObjectCollection entry = getUserDepts(userId);
            for (DynamicObject row : entry) {
                if (userEntryId == row.getLong("id")) {
                    if (tpvDepartment==null ||row.get("org")==null){
                        this.getModel().deleteEntryData("tpv_matecost");
                    }else if (!(tpvDepartment.getLong("id")== (long) row.get("org"))){
                        this.getModel().deleteEntryData("tpv_matecost");
                    }
                    model.setValue("tpv_department", row.get("org"));
                    this.getView().updateView("tpv_matecost");
                }
            }
            model.endInit();
            this.getView().updateView("tpv_operator");
            this.getView().updateView("tpv_department");
        }
    }

    private static DynamicObjectCollection getUserDepts(long userId) {
        QFilter qFilter = new QFilter("user", QCP.equals, userId);
//        qFilter.and(new QFilter("org.orgpattern.number", QCP.equals, "Orgform06"));
        return QueryServiceHelper.query("bos_userposition", "id,org", qFilter.toArray());
    }


    private void chargeofffinar(HashMap<String, DynamicObjectCollection> data) {
        DynamicObjectCollection collection = this.getModel().getEntryEntity("tpv_pactmessage");
        DataEntityPropertyCollection properties = collection.getDynamicObjectType().getProperties();
        DynamicObjectCollection collections = data.get("cols");
        DataEntityPropertyCollection selectedProperties = collections.getDynamicObjectType().getProperties();
        for (int i = 0; i < collections.size(); i++) {
            int newEntryRow = this.getModel().createNewEntryRow("tpv_pactmessage");
            DynamicObject row = collections.get(i);
            for (IDataEntityProperty property : selectedProperties) {
                String proKey = property.getName();
                String subKey = subKey(proKey);
                if ("tpv_writtenoffamt1".equals(proKey)) {
                    this.getModel().setValue("tpv_amtatch", row.get(proKey), newEntryRow);
                    this.getModel().setValue(subKey(proKey), row.get(proKey), newEntryRow);
                } else if (properties.containsKey(subKey)) {
                    this.getModel().setValue(subKey, row.get(proKey), newEntryRow);
                }
            }
        }
        this.getView().updateView("tpv_pactmessage");
        OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
                new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
    }

    private void invCollectCustom(Object returnData) {
        IFormView view = this.getView();
        List<String> tipNotification = new ArrayList<>();
        CloudInvoiceResultVO resultVO = (CloudInvoiceResultVO) JsonUtils.jsonToObj(String.valueOf(returnData), CloudInvoiceResultVO.class);
        if (resultVO != null && !resultVO.isEmpty()) {
            List<String> hasExistInvoices = resultVO.getHasExistInvoices();
            if (hasExistInvoices.isEmpty()) {
                List<String> hasRemoveSerialNos = resultVO.getHasRemoveSerialNos();
                DynamicObjectCollection invoices = QueryServiceHelper.query("ap_invoice", "id,billno,invoicecode,invoiceno,serialno", new QFilter[]{new QFilter("serialno", "in", hasRemoveSerialNos)});
                List<Long> id = invoices.stream().map(item -> item.getLong("id")).collect(Collectors.toList());
                OperationResult submitResult = OperationServiceHelper.executeOperate(OperationConst.SUBMIT, "ap_invoice", id.toArray(), OperateOption.create());
                OperationResult auditResult = OperationServiceHelper.executeOperate(OperationConst.AUDIT, "ap_invoice", id.toArray(), OperateOption.create());
                if (submitResult != null && !submitResult.isSuccess()) {
                    tipNotification.add("收票单提交失败," + YEM.getOpMsg(submitResult) + "\n");
                }
                if (auditResult != null && !auditResult.isSuccess()) {
                    tipNotification.add("收票单审核失败," + YEM.getOpMsg(auditResult) + "\n");
                }
                ValidateResultCollection validateResult = submitResult.getValidateResult();
                HashSet<Object> errorPkIds = validateResult.getErrorPkIds();
                List<String> stringList = setInvoiceDetail(hasRemoveSerialNos);//分录赋值
                if (!stringList.isEmpty()) {
                    tipNotification.add("发票号:" + StringUtil.join(stringList, ",") + " 已存在,不允许重复添加!");
                }
                invoices.stream()
                        .filter(item -> hasExistInvoices.contains(item.getString("serialno")))
                        .forEach(item -> tipNotification.add(String.format(ResManager.loadKDString("发票号码%1$s,发票代码%2$s：发票已存在，不允许采集。", "InvoiceList4Cloud_2"
                                , "fi-ap-formplugin", new Object[0]), item.getString("invoiceno"), item.getString("invoicecode"))));
                if (!tipNotification.isEmpty()) {
                    view.showTipNotification(tipNotification.toString());
                }
            }
        }
    }

    private List<String> setInvoiceDetail(List<String> hasRemoveSerialNos) {
        DynamicObjectCollection collection = this.getModel().getEntryEntity("tpv_invoiceinfoentry");
        Set<String> sourceID = collection.stream().map(col -> col.getString("tpv_sourceid")).collect(Collectors.toSet());
        List<String> invoiceNos = new ArrayList<>();

        IDataModel model = this.getModel();
        ArrayList<QFilter> filters = new ArrayList<>();
        filters.add(new QFilter("billstatus", QCP.equals, "C"));//已审核
        filters.add(new QFilter("serialno", QCP.in, hasRemoveSerialNos));//发票流水号
        String selelctFiles =
                "id  id," +
                        "billno billno," +
                        "billstatus billstatus," +
                        "invoiceno invoiceno," +
                        "receivablessupp.id supplier," +
                        "entry.quantity quantity," +
                        "issuedate  issuedate," +
                        "pricetaxtotal pricetaxtotal," +
                        "amount amount," +
                        "tax tax";// 查询字段
        DataSet dataSet = QueryServiceHelper.queryDataSet(this.getClass().getName(), "ap_invoice", selelctFiles,
                        filters.toArray(new QFilter[0]), null)
                .executeSql("SELECT billno,id, invoiceno, supplier, issuedate,pricetaxtotal, amount, tax, sum(quantity) AS sumqty " +
                        "GROUP BY billno,invoiceno, supplier, issuedate, pricetaxtotal, amount, tax,id");
        HashMap<String, HashMap<String, BigDecimal>> dataMap = InvoiceMatchBillEdit.getMatchedQty(this.getClass().getName(), "");//获取已匹配数量等
        for (Row row : dataSet) {
            Long pkid = row.getLong("id");//来源单id
            String invoiceno = row.getString("invoiceno");
            if (sourceID.contains(pkid)) {
                invoiceNos.add(invoiceno);
                continue;
            }
            Date issuedate = row.getDate("issuedate");
            BigDecimal taxRate = InvoiceMatchBillEdit.getTaxRate(this.getClass().getName(), invoiceno);
            BigDecimal sumqty = row.getBigDecimal("sumqty");
            BigDecimal pricetaxtotal = row.getBigDecimal("pricetaxtotal");//含税金额
            BigDecimal amount = row.getBigDecimal("amount");//不含税金额
            BigDecimal tax = row.getBigDecimal("tax");//增值税额

            BigDecimal matchedQty = BigDecimal.ZERO;
            BigDecimal matchamoalltax = BigDecimal.ZERO;
            BigDecimal matchamonoalltax = BigDecimal.ZERO;
            BigDecimal matchamoinalltax = BigDecimal.ZERO;
            if (dataMap.get(pkid.toString()) != null) {
                HashMap<String, BigDecimal> map = dataMap.get(pkid.toString());
                matchedQty = map.get("curmactchallqty");//已匹配数量
                matchamoalltax = map.get("curmatchamoalltax");//已匹配金额(含税)
                matchamonoalltax = map.get("curmatchamonoalltax");//已匹配金额(不含税)
                matchamoinalltax = map.get("curmatchamoinalltax");//已匹配金额(增值税额)
                BigDecimal subtract = sumqty.subtract(matchedQty);
            }
            int i = model.createNewEntryRow("tpv_invoiceinfoentry");
            model.setValue("tpv_invocenum", invoiceno, i);//发票号
            model.setValue("tpv_invoicsupplier", toLong(row.getLong("supplier")), i);//供应商
            model.setValue("tpv_invoicqty", sumqty, i);//数量
            model.setValue("tpv_invoicmate", matchedQty, i);//已匹配数量
            model.setValue("tpv_unmatchqty", sumqty.subtract(matchedQty), i);//未匹配数量
//            model.setValue("tpv_issuedate", issuedate, i);//开票日期
            model.setValue("tpv_taxamount", pricetaxtotal, i);//含税金额
            model.setValue("tpv_notaxamount", amount, i);//不含税金额
            model.setValue("tpv_amountincrease", tax, i);//增值税额
            model.setValue("tpv_matchamotax", matchamoalltax, i);//已匹配金额(含税)
            model.setValue("tpv_matchamonotax", matchamonoalltax, i);//已匹配金额(不含税)
            model.setValue("tpv_matchamointax", matchamoinalltax, i);//已匹配金额(增值税)
            model.setValue("tpv_unmatchamotax", pricetaxtotal.subtract(matchamoalltax), i);//未匹配金额(含税)
            model.setValue("tpv_numatchamonotax", amount.subtract(matchamonoalltax), i);//未匹配金额(不含税)
            model.setValue("tpv_unmatchamointax", tax.subtract(matchamoinalltax), i);//未匹配金额(增值税额)
            model.setValue("tpv_taxrate", taxRate, i);//税率
            model.setValue("tpv_sourceid", pkid, i);//来源id
        }
        return invoiceNos;
    }

    /**
     * 为发票分录进行循环赋值
     *
     * @param data
     */
    private void invoice(HashMap<String, DynamicObjectCollection> data) {
        DynamicObjectCollection collection = this.getModel().getEntryEntity("tpv_invoiceinfoentry");
        DataEntityPropertyCollection properties = collection.getDynamicObjectType().getProperties();
        DynamicObjectCollection collections = data.get("cols");
        DataEntityPropertyCollection selectedProperties = collections.getDynamicObjectType().getProperties();
        this.getModel().deleteEntryData("tpv_invoiceinfoentry");
        int[] ints = this.getModel().batchCreateNewEntryRow("tpv_invoiceinfoentry", collections.size());
        for (int i = 0; i < collections.size(); i++) {
            DynamicObject row = collections.get(i);
            long fsourcebillid=0L;
            for (IDataEntityProperty property : selectedProperties) {
                String proKey = property.getName();
                String subKey = subKey(proKey);
                if ("tpv_taxrate".equals(proKey)) {
                    this.getModel().setValue(proKey, row.get(proKey), ints[i]);
                }
                if (properties.containsKey(subKey)) {
                    this.getModel().setValue(subKey, row.get(proKey), ints[i]);
                }
                if ("tpv_sourceid1".equals(proKey)){
                    fsourcebillid= row.getLong(proKey);
                }
            }
            if (fsourcebillid!=0){
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                PurchaseInvoiceMatchFromPlugin.botpAttachmentpanel(dataEntity,"attachmentpanel",fsourcebillid,"ap_invoice","tpv_dt");
            }
        }
        this.getView().updateView("tpv_invoiceinfoentry");
//        OperationResult operationResult = OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
//                new Object[]{this.getModel().getDataEntity(true).getPkValue()}, YEM.getOptionNoMsg());
        OperationResult operationResult = this.getView().invokeOperation("save", YEM.getOptionNoMsg());
        this.getView().invokeOperation("refresh");
    }

    @Override
    public void beforeDeleteRow(BeforeDeleteRowEventArgs e) {
        super.beforeDeleteRow(e);
        String name = e.getEntryProp().getName();
        switch (name){
            case"tpv_invoiceinfoentry":
                EntryGrid control = this.getControl("tpv_invoiceinfoentry");
                int[] selectRows = control.getSelectRows();
                DynamicObjectCollection tpvInvoiceinfoentry = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_invoiceinfoentry");
                for (int selectRow : selectRows) {
                    String tpvSourceid = tpvInvoiceinfoentry.get(selectRow).getString("tpv_sourceid");
                    DeleteServiceHelper.delete("bos_attachment",new QFilter[]{new QFilter("fentryinterid","=",tpvSourceid)});
                }
//                DynamicObject dataEntity = this.getModel().getDataEntity(true);
//                OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
//                        new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
                OperationResult operationResult = this.getView().invokeOperation("save", YEM.getOptionNoMsg());
                this.getView().invokeOperation("refresh");
                break;
        }
    }

    /**
     * @Title: subKey
     * @Description:
     * @param: 截取字符串
     * @return: a
     */
    private String subKey(String proKey) {
        if (null != proKey && proKey.length() > 0) {
            return proKey.substring(0, proKey.length() - 1);
        } else {
            return "";
        }
    }

    /**
     * 单据值更新触发事件
     *
     * @param e
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String propertyName = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];//正在发生改变的数据
        Long departmentid = 0L;
        Long supplierid = 0L;
        Long customerid = 0L;
        if ("tpv_billunit".equals(propertyName)) {
            this.getModel().deleteEntryData("tpv_invoiceinfoentry");
        }
        if ("tpv_company".equals(propertyName)){
            this.getModel().deleteEntryData("tpv_matecost");
        }
        if ("tpv_purconum".equals(propertyName)) {
            int index = this.getModel().getEntryCurrentRowIndex(TPV_PACTMESSAGE);
            DynamicObject tpvPurconum = (DynamicObject) this.getModel().getValue("tpv_purconum");
            if (null != tpvPurconum) {
                Long id = tpvPurconum.getLong("id");
                QFilter qFilter = new QFilter("id", QCP.equals, id);
                DynamicObject[] load = BusinessDataServiceHelper.load("tpv_dt_purchase",
                        "id,tpv_department,tpv_supplier,tpv_materialentry,tpv_materialentry.tpv_qty", qFilter.toArray());
                for (DynamicObject dynamicObject : load) {
                    DynamicObject department = dynamicObject.getDynamicObject("tpv_department");
                    DynamicObject supplier = dynamicObject.getDynamicObject("tpv_supplier");
                    if (department != null) {
                        departmentid = department.getLong("id");
                    }
                    if (supplier != null) {
                        supplierid = supplier.getLong("id");
                    }
                    DynamicObjectCollection dynamicObjects = dynamicObject.getDynamicObjectCollection("tpv_materialentry");
                    BigDecimal addQty = BigDecimal.ZERO;
                    if (dynamicObjects.size() > 0) {
                        for (DynamicObject object : dynamicObjects) {
                            BigDecimal bigDecimal = YEM.isNotEmpty(object.getBigDecimal("tpv_qty"))
                                    ? object.getBigDecimal("tpv_qty") : BigDecimal.ZERO;
                            addQty = addQty.add(bigDecimal);
                        }
                    }
                    this.getModel().setValue("tpv_coninfoqty", addQty, index);
                    this.getModel().setValue("tpv_departme", departmentid);
                    this.getModel().setValue("tpv_vendor", supplierid);
                }
            }
            return;
        }
        if ("tpv_saleconum".equals(propertyName)) {
            int index = this.getModel().getEntryCurrentRowIndex(TPV_PACTMESSAGE);
            DynamicObject tpvPurconum = (DynamicObject) this.getModel().getValue("tpv_saleconum");
            if (null != tpvPurconum) {
//                String selectfields = DynamicObjectUtil.getSelectfields("tpv_bd_salescontract", false);
                Long id = tpvPurconum.getLong("id");
                QFilter qFilter = new QFilter("id", QCP.equals, id);
                DynamicObject[] load = BusinessDataServiceHelper.load("tpv_dt_salescontract",
                        "id,tpv_department,tpv_customer,tpv_materialentry,tpv_materialentry.tpv_qty", qFilter.toArray());
                for (DynamicObject dynamicObject : load) {
                    DynamicObject department = dynamicObject.getDynamicObject("tpv_department");
                    DynamicObject customer = dynamicObject.getDynamicObject("tpv_customer");
                    if (department != null) {
                        departmentid = department.getLong("id");
                    }
                    if (customer != null) {
                        customerid = customer.getLong("id");
                    }
                    DynamicObjectCollection dynamicObjects = dynamicObject.getDynamicObjectCollection("tpv_materialentry");
                    BigDecimal addQty = BigDecimal.ZERO;
                    if (dynamicObjects.size() > 0) {
                        for (DynamicObject object : dynamicObjects) {
                            BigDecimal bigDecimal = YEM.isNotEmpty(object.getBigDecimal("tpv_qty"))
                                    ? object.getBigDecimal("tpv_qty") : BigDecimal.ZERO;
                            addQty = addQty.add(bigDecimal);
                        }
                    }
                    this.getModel().setValue("tpv_coninfoqty", addQty, index);
                    this.getModel().setValue("tpv_departme", departmentid);
                    this.getModel().setValue("tpv_client", customerid);
                }
            }
            return;
        }
        if ("tpv_natfees".equals(propertyName)) {
            String natfees = (String) this.getModel().getValue("tpv_natfees");
            if (!"B".equals(natfees)) {
                int index = this.getModel().getEntryCurrentRowIndex("tpv_pactmessage");
                this.getModel().setValue("tpv_invotitle", "A");
                this.getView().setEnable(false, index, "tpv_invotitle");//设置锁定字段
            }
            if ("B".equals(natfees) | YEM.isEmpty(natfees)) {
                int index = this.getModel().getEntryCurrentRowIndex("tpv_pactmessage");
                this.getView().setEnable(true, index, "tpv_invotitle");
            }
        }
        if ("tpv_costitem".equals(propertyName)) {
            DynamicObjectCollection tpvInvoiceinfoentry = this.getModel().getEntryEntity("tpv_invoiceinfoentry");
            DynamicObjectCollection tpvMatecost = this.getModel().getEntryEntity("tpv_matecost");
            if (tpvInvoiceinfoentry.size() > 0) { //发票信息分录
                this.getModel().deleteEntryData("tpv_invoiceinfoentry");
                this.getView().updateView("tpv_invoiceinfoentry");
            }
            if (tpvMatecost.size() > 0) { //匹配入库/成本明细分录
                if ("B".equals(tpvMatecost.get(0).getString("tpv_matchtype"))) { //匹配类型
                    this.getModel().deleteEntryData("tpv_matecost");
                    this.getView().updateView("tpv_matecost");
                }
            }
            if (tpvInvoiceinfoentry.size() > 0 || tpvMatecost.size() > 0) {
                OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
                        new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
            }
        }
        if ("tpv_invoicetype".equals(propertyName)) {
            DynamicObjectCollection tpvInvoiceinfoentry = this.getModel().getEntryEntity("tpv_invoiceinfoentry");
            if (tpvInvoiceinfoentry.size() > 0) { //发票信息分录
                this.getModel().deleteEntryData("tpv_invoiceinfoentry");
                this.getView().updateView("tpv_invoiceinfoentry");
                OperationServiceHelper.executeOperate("save", "tpv_dt_costbillmat",
                        new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
            }
        }
        if ("tpv_wmexratetable".equals(propertyName) | "tpv_wmexratedate".equals(propertyName) | "tpv_wmcurrency".equals(propertyName)
                | "tpv_wmcurrencybase".equals(propertyName)) {
            this.setExchangeRate();
        }
    }

    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        super.afterAddRow(e);
        String name = e.getEntryProp().getName();
        RowDataEntity[] rowIndex = e.getRowDataEntities();
        DynamicObject tpvCostitem = this.getModel().getDataEntity(true).getDynamicObject("tpv_costitem");
        DynamicObject taxrated = null;
        BigDecimal taxrated_taxrate = BigDecimal.ZERO;
        if (YEM.isNotEmpty(tpvCostitem)) {
            BigDecimal taxrate = tpvCostitem.getBigDecimal("taxrate");
            if (null != taxrate) {
                DynamicObject[] load = BusinessDataServiceHelper.load("bd_taxrate", "id,taxrate", new QFilter[]{new QFilter("enable", QCP.equals, "1")
                        .and(new QFilter("taxrate", QCP.equals, taxrate))}, "activedate desc", 1);
                if (load.length > 0) {
                    for (DynamicObject dynamicObject : load) {
                        taxrated = dynamicObject;
                        taxrated_taxrate = dynamicObject.getBigDecimal("taxrate");
                    }
                }
            }
        }
        if (StringUtils.equals("tpv_newentrycon", name)) {
            for (RowDataEntity rdata : rowIndex) {
                int i = rdata.getRowIndex();
                this.getModel().setValue("tpv_ratedd", taxrated, i);
                this.getModel().setValue("tpv_ratea", taxrated_taxrate, i);
            }
        }
    }

    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate operate = (FormOperate) args.getSource();
        String key = operate.getOperateKey();
        if ("newentry_aps".equals(key)) {
            DynamicObject tpvDepartment = (DynamicObject) this.getModel().getValue("tpv_department");
            DynamicObject tpvCostitem = (DynamicObject) this.getModel().getValue("tpv_costitem");
            if (YEM.isEmpty(tpvDepartment) || YEM.isEmpty(tpvCostitem)) {
                args.setCancel(true);
                this.getView().showTipNotification("部门或者费用项目未填写，请检查填写后在操作！");
            }
        }
    }

    //向分摊弹框传值
    private Map<String, Object> showInfoForm() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Map<String, Object> map = new HashMap<>();
        BigDecimal tpvTaxrate = BigDecimal.ZERO;
        BigDecimal tpvTaxamount = BigDecimal.ZERO;
        BigDecimal tpv_taxinclamt = dataEntity.getBigDecimal("tpv_taxinclamt");
        BigDecimal tpv_taxnoinclamt = dataEntity.getBigDecimal("tpv_taxnoinclamt");
        BigDecimal tpv_vatamt = dataEntity.getBigDecimal("tpv_vatamt");
        map.put("tpv_taxinclamt", tpv_taxinclamt); //(暂时作废)
        map.put("tpv_taxnoinclamt", tpv_taxnoinclamt); //(暂时作废)
        map.put("tpv_vatamt", tpv_vatamt); //(暂时作废)
        DynamicObject tpvInvoicetype = dataEntity.getDynamicObject("tpv_invoicetype");
        boolean flag = true;
        if (YEM.isNotEmpty(tpvInvoicetype)) {
            String number = tpvInvoicetype.getString("number");
            //当【发票类型】= 增值税电子普通发票 / 增值税电子普通发票（通行费）/  数电票（普通发票）/  增值税普通发票 / 增值税普通发票（卷票）时
            if ("1".equals(number) || "15".equals(number) || "26".equals(number) || "3".equals(number) || "5".equals(number)) {
                flag = false;
            }
        }
        DynamicObjectCollection dynamicObjects = dataEntity.getDynamicObjectCollection("tpv_invoiceinfoentry");
        if (flag) {
            for (DynamicObject dynamicObject : dynamicObjects) {
                tpvTaxrate = dynamicObject.getBigDecimal("tpv_taxrate");
                break;
            }
        }
        for (DynamicObject dynamicObject : dynamicObjects) {
            tpvTaxamount = tpvTaxamount.add(dynamicObject.getBigDecimal("tpv_curmatchamotax").setScale(2, BigDecimal.ROUND_HALF_UP));
        }
        map.put("tpv_dytaxrates", tpvTaxrate);
        map.put("tpv_taxamount", tpvTaxamount);
        return map;
    }

    //向匹配入库弹框传值
    public Map<String, Object> journalizing() {
        Map<String, Object> map = new HashMap<>();
        DynamicObject billunit = null;
        long billunitid = 0L;
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        billunit = dataEntity.getDynamicObject("tpv_billunit");
        if (billunit != null) {
            billunitid = billunit.getLong("id");
            map.put("tpv_billunit", billunitid);
            DynamicObjectCollection tpvMatecost = dataEntity.getDynamicObjectCollection("tpv_matecost");
            for (DynamicObject dynamicObject : tpvMatecost) {
                String tpvInbordnum = dynamicObject.getString("tpv_inboentid");
                map.put(tpvInbordnum, dynamicObject);
            }
        }
        return map;
    }

    //向匹配成本弹框传值
    public Map<String, Object> costapproach() {
        Map<String, Object> map = new HashMap<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject billunit = dataEntity.getDynamicObject("tpv_billunit");
        if (billunit != null) {
            map.put("tpv_billunit", billunit.getLong("id"));
            DynamicObjectCollection tpvMatecost = dataEntity.getDynamicObjectCollection("tpv_matecost");
            for (DynamicObject dynamicObject : tpvMatecost) {
                String tpvInbordnum = dynamicObject.getString("tpv_costbreaid");
                map.put(tpvInbordnum, dynamicObject);
            }
        }
        DynamicObject tpv_costitem = dataEntity.getDynamicObject("tpv_costitem");
        if (tpv_costitem != null) {
            map.put("tpv_costitem", tpv_costitem.getLong("id"));
        }
        return map;
    }

    //向冲销应收单号弹框传值
    private Map<String, Object> chargeofffinar() {
        Map<String, Object> map = new HashMap<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpvCostitem = dataEntity.getDynamicObject("tpv_costitem");
        DynamicObject tpvDepartment = dataEntity.getDynamicObject("tpv_department");
        DynamicObject tpvWmcurrency = dataEntity.getDynamicObject("tpv_wmcurrency");
        if (YEM.isNotEmpty(tpvCostitem)) map.put("tpv_costitem", tpvCostitem);
        if (YEM.isNotEmpty(tpvDepartment)) map.put("tpv_department", tpvDepartment);
        if (YEM.isNotEmpty(tpvWmcurrency)) map.put("tpv_wmcurrency", tpvWmcurrency);
        return map;
    }

    /**
     * 分摊含税金额
     */
    private void sumtotal() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        BigDecimal amountTax = dataEntity.getBigDecimal("tpv_taxinclamt");//含税
        if (amountTax == null) {
            amountTax = new BigDecimal(0);
        }
//        BigDecimal amountnotax = dataEntity.getBigDecimal("tpv_taxnoinclamt");//不含税
//        BigDecimal increasetax = dataEntity.getBigDecimal("tpv_vatamt");//增值税

        BigDecimal consum = dataEntity.getBigDecimal("tpv_consum");//合同分录数量汇总
        BigDecimal waresum = dataEntity.getBigDecimal("tpv_waresum");//入库分录数量汇总
        BigDecimal allNums = consum.add(waresum);
        if (allNums.compareTo(BigDecimal.ZERO) == 0) {
            return;
        }
        dataEntity = this.getModel().getDataEntity(true);
        DynamicObject bd_taxrate = BusinessDataServiceHelper.loadSingle("bd_taxrate", "id,taxrate", new QFilter[]{new QFilter("enable", QCP.equals, "1")
                .and(new QFilter("number", QCP.equals, "0"))});
        DynamicObject tpvInvoicetype = dataEntity.getDynamicObject("tpv_invoicetype");
        boolean flag = false;
        if (YEM.isNotEmpty(tpvInvoicetype)) {
            String number = tpvInvoicetype.getString("number");
            //当【发票类型】= 增值税电子普通发票 / 增值税电子普通发票（通行费）/  数电票（普通发票）/  增值税普通发票 / 增值税普通发票（卷票）时
            if ("1".equals(number) || "15".equals(number) || "26".equals(number) || "3".equals(number) || "5".equals(number)) {
                flag = true;
            }
        }
        DynamicObjectCollection contractEntry = dataEntity.getDynamicObjectCollection(TPV_PACTMESSAGE);
        DynamicObjectCollection warehouseEntry = dataEntity.getDynamicObjectCollection(TPV_MATECOST);
        if (warehouseEntry.size() == 0 && contractEntry.size() == 0) {
            return;
        }
        if (warehouseEntry.size() == 0) {
            //入库数据为空，给合同分录处理尾差
            for (DynamicObject object : contractEntry) {
                BigDecimal tpvRate = BigDecimalUtils.toBigDecimal(object.getBigDecimal("tpv_ratea"));
                if (flag) {
                    tpvRate = BigDecimal.ZERO;
                    object.set("tpv_ratedd", bd_taxrate); //税率(基础资料)
                    object.set("tpv_ratea", tpvRate); //税率
                }
                BigDecimal curmatchqty = object.getBigDecimal("tpv_coninfoqty");//数量
                BigDecimal prop = curmatchqty.divide(allNums, 10, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvTaxmatamt = amountTax.multiply(prop).setScale(2, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvNoTaxmatamt = BigDecimal.ZERO;
                BigDecimal tpvInTaxmatamt = BigDecimal.ZERO;
                tpvInTaxmatamt = new BigDecimal("1").add(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvTaxmatamt.divide(tpvInTaxmatamt, 11,BigDecimal.ROUND_HALF_UP);
                tpvInTaxmatamt = tpvInTaxmatamt.multiply(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvInTaxmatamt.setScale(2,BigDecimal.ROUND_HALF_UP);
                tpvNoTaxmatamt = tpvTaxmatamt.subtract(tpvInTaxmatamt.setScale(2, BigDecimal.ROUND_HALF_UP));

                object.set("tpv_amtatch", tpvTaxmatamt);//含税
                object.set("tpv_vatamtmatch", tpvNoTaxmatamt);//不含税
                object.set("tpv_vatmatamt", tpvInTaxmatamt); //增值税
                BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                object.set("tpv_taxmatpricecon",tpvTaxmatprice);//单价(含税)
            }
            this.getView().updateView(TPV_PACTMESSAGE);
            handleAmount(true, contractEntry.size() - 1, "ht");
        } else if (contractEntry.size() == 0) {
            for (DynamicObject object : warehouseEntry) {
                BigDecimal tpvRate = BigDecimalUtils.toBigDecimal(object.getBigDecimal("tpv_rated"));
                if (flag) {
                    tpvRate = BigDecimal.ZERO;
                    object.set("tpv_rkratedd", bd_taxrate); //税率(基础资料)
                    object.set("tpv_rated", tpvRate); //税率
                }
                BigDecimal curmatchqty = object.getBigDecimal("tpv_conqty");//数量
                BigDecimal prop = curmatchqty.divide(allNums, 10, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvTaxmatamt = amountTax.multiply(prop).setScale(2, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvNoTaxmatamt = BigDecimal.ZERO;
                BigDecimal tpvInTaxmatamt = BigDecimal.ZERO;
                tpvInTaxmatamt = new BigDecimal("1").add(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvTaxmatamt.divide(tpvInTaxmatamt, 11,BigDecimal.ROUND_HALF_UP);
                tpvInTaxmatamt = tpvInTaxmatamt.multiply(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvInTaxmatamt.setScale(2,BigDecimal.ROUND_HALF_UP);
                tpvNoTaxmatamt = tpvTaxmatamt.subtract(tpvInTaxmatamt.setScale(2, BigDecimal.ROUND_HALF_UP));

                object.set("tpv_taxmatamt", tpvTaxmatamt);//含税
                object.set("tpv_taxnomatamt", tpvNoTaxmatamt);//不含税
                object.set("tpv_vatnomatamt", tpvInTaxmatamt); //增值税
                BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                object.set("tpv_taxmatprice",tpvTaxmatprice);//单价(含税)
            }
            this.getView().updateView(TPV_MATECOST);
            handleAmount(true, warehouseEntry.size() - 1, "rk");
        } else {
            //在合同处理尾差
            for (DynamicObject object : contractEntry) {
                BigDecimal tpvRate = BigDecimalUtils.toBigDecimal(object.getBigDecimal("tpv_ratea"));
                if (flag) {
                    tpvRate = BigDecimal.ZERO;
                    object.set("tpv_ratedd", bd_taxrate); //税率(基础资料)
                    object.set("tpv_ratea", tpvRate); //税率
                }
                BigDecimal curmatchqty = object.getBigDecimal("tpv_coninfoqty");//数量
                BigDecimal prop = curmatchqty.divide(allNums, 10, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvTaxmatamt = amountTax.multiply(prop).setScale(2, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvNoTaxmatamt = BigDecimal.ZERO;
                BigDecimal tpvInTaxmatamt = BigDecimal.ZERO;
                tpvInTaxmatamt = new BigDecimal("1").add(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvTaxmatamt.divide(tpvInTaxmatamt, 11,BigDecimal.ROUND_HALF_UP);
                tpvInTaxmatamt = tpvInTaxmatamt.multiply(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvInTaxmatamt.setScale(2,BigDecimal.ROUND_HALF_UP);
                tpvNoTaxmatamt = tpvTaxmatamt.subtract(tpvInTaxmatamt.setScale(2, BigDecimal.ROUND_HALF_UP));

                object.set("tpv_amtatch", tpvTaxmatamt);//含税
                object.set("tpv_vatamtmatch", tpvNoTaxmatamt);//不含税
                object.set("tpv_vatmatamt", tpvInTaxmatamt); //增值税
                BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                object.set("tpv_taxmatpricecon",tpvTaxmatprice);//单价(含税)
            }
            this.getView().updateView(TPV_PACTMESSAGE);
            for (DynamicObject object : warehouseEntry) {
                BigDecimal tpvRate = BigDecimalUtils.toBigDecimal(object.getBigDecimal("tpv_rated"));
                if (flag) {
                    tpvRate = BigDecimal.ZERO;
                    object.set("tpv_rkratedd", bd_taxrate); //税率(基础资料)
                    object.set("tpv_rated", tpvRate); //税率
                }
                BigDecimal curmatchqty = object.getBigDecimal("tpv_conqty");//数量
                BigDecimal prop = curmatchqty.divide(allNums, 10, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvTaxmatamt = amountTax.multiply(prop).setScale(2, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvNoTaxmatamt = BigDecimal.ZERO;
                BigDecimal tpvInTaxmatamt = BigDecimal.ZERO;
                tpvInTaxmatamt = new BigDecimal("1").add(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvTaxmatamt.divide(tpvInTaxmatamt, 11,BigDecimal.ROUND_HALF_UP);
                tpvInTaxmatamt = tpvInTaxmatamt.multiply(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvInTaxmatamt.setScale(2,BigDecimal.ROUND_HALF_UP);
                tpvNoTaxmatamt = tpvTaxmatamt.subtract(tpvInTaxmatamt.setScale(2, BigDecimal.ROUND_HALF_UP));

                object.set("tpv_taxmatamt", tpvTaxmatamt);//含税
                object.set("tpv_taxnomatamt", tpvNoTaxmatamt);//不含税
                object.set("tpv_vatnomatamt", tpvInTaxmatamt); //增值税
                BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                object.set("tpv_taxmatprice",tpvTaxmatprice);//单价(含税)
            }
            this.getView().updateView(TPV_MATECOST);
            handleAmount(false, contractEntry.size() - 1, "");
        }
    }

    /**
     * @param b:
     * @param i1:
     * @return void
     * @author: chen
     * @date: 2023/11/18 19:17
     * @description: 处理尾差
     */
    private void handleAmount(boolean b, int i1, String entry) {

        IDataModel model = this.getModel();
        BigDecimal amounttax = (BigDecimal) model.getValue("tpv_taxinclamt");
        if (amounttax == null) {
            amounttax = new BigDecimal(0);
        }
        BigDecimal amountnotax = (BigDecimal) model.getValue("tpv_taxnoinclamt");
        BigDecimal amountintax = (BigDecimal) model.getValue("tpv_vatamt");
        if (b & "ht".equals(entry)) {
            BigDecimal contaxsum = BigDecimal.ZERO;
            BigDecimal connotaxsum = BigDecimal.ZERO;
            BigDecimal conintaxsum = BigDecimal.ZERO;
            DynamicObjectCollection conCols = model.getEntryEntity(TPV_PACTMESSAGE);
            for (int i = 0; i < conCols.size(); i++) {
                DynamicObject object = conCols.get(i);
                if (i == conCols.size() - 1) {
                    contaxsum = contaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    connotaxsum = connotaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    conintaxsum = conintaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    object.set("tpv_amtatch", amounttax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(contaxsum));
                    object.set("tpv_vatamtmatch", amountnotax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(connotaxsum));
                    object.set("tpv_vatmatamt", amountintax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(conintaxsum));
                    BigDecimal curmatchqty = object.getBigDecimal("tpv_coninfoqty");//数量
                    BigDecimal tpvTaxmatamt = object.getBigDecimal("tpv_amtatch");
                    BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                    object.set("tpv_taxmatpricecon",tpvTaxmatprice);//单价(含税)
                }
                contaxsum = contaxsum.add(object.getBigDecimal("tpv_amtatch"));
                connotaxsum = connotaxsum.add(object.getBigDecimal("tpv_vatamtmatch"));
                conintaxsum = conintaxsum.add(object.getBigDecimal("tpv_vatmatamt"));
            }
            this.getView().updateView(TPV_PACTMESSAGE);
        } else if (b & "rk".equals(entry)) {
            BigDecimal rktaxsum = BigDecimal.ZERO;
            BigDecimal rknotaxsum = BigDecimal.ZERO;
            BigDecimal rkintaxsum = BigDecimal.ZERO;
            DynamicObjectCollection wareCols = model.getEntryEntity(TPV_MATECOST);
            for (int i = 0; i < wareCols.size(); i++) {
                DynamicObject object = wareCols.get(i);
                if (i == wareCols.size() - 1) {
                    rktaxsum = rktaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    rknotaxsum = rknotaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    rkintaxsum = rkintaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    object.set("tpv_taxmatamt", amounttax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(rktaxsum));
                    object.set("tpv_taxnomatamt", amountnotax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(rknotaxsum));
                    object.set("tpv_vatnomatamt", amountintax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(rkintaxsum));
                    BigDecimal curmatchqty = object.getBigDecimal("tpv_conqty");//数量
                    BigDecimal tpvTaxmatamt = object.getBigDecimal("tpv_taxmatamt");
                    BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                    object.set("tpv_taxmatprice",tpvTaxmatprice);//单价(含税)
                }
                rktaxsum = rktaxsum.add(object.getBigDecimal("tpv_taxmatamt"));
                rknotaxsum = rknotaxsum.add(object.getBigDecimal("tpv_taxnomatamt"));
                rkintaxsum = rkintaxsum.add(object.getBigDecimal("tpv_vatnomatamt"));
            }
            this.getView().updateView(TPV_MATECOST);
        } else {
            BigDecimal contaxsum = BigDecimal.ZERO;
            BigDecimal connotaxsum = BigDecimal.ZERO;
            BigDecimal conintaxsum = BigDecimal.ZERO;
            DynamicObjectCollection conCols = model.getEntryEntity(TPV_PACTMESSAGE);
            DynamicObjectCollection wareCols = model.getEntryEntity(TPV_MATECOST);
            for (int i = 0; i < conCols.size(); i++) {
                DynamicObject object = conCols.get(i);
                contaxsum = contaxsum.add(object.getBigDecimal("tpv_amtatch"));
                connotaxsum = connotaxsum.add(object.getBigDecimal("tpv_vatamtmatch"));
                conintaxsum = conintaxsum.add(object.getBigDecimal("tpv_vatmatamt"));
            }
            for (int i = 0; i < wareCols.size(); i++) {
                DynamicObject object = wareCols.get(i);
                if (i == wareCols.size() - 1) {
                    contaxsum = contaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    connotaxsum = connotaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    conintaxsum = conintaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    object.set("tpv_taxmatamt", amounttax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(contaxsum));
                    object.set("tpv_taxnomatamt", amountnotax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(connotaxsum));
                    object.set("tpv_vatnomatamt", amountintax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(conintaxsum));
                    BigDecimal curmatchqty = object.getBigDecimal("tpv_conqty");//数量
                    BigDecimal tpvTaxmatamt = object.getBigDecimal("tpv_taxmatamt");
                    BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                    object.set("tpv_taxmatprice",tpvTaxmatprice);//单价(含税)
                }
                contaxsum = contaxsum.add(object.getBigDecimal("tpv_taxmatamt"));
                connotaxsum = connotaxsum.add(object.getBigDecimal("tpv_taxnomatamt"));
                conintaxsum = conintaxsum.add(object.getBigDecimal("tpv_vatnomatamt"));
            }
            this.getView().updateView(TPV_PACTMESSAGE);
        }
    }

    /**
     * @Title: getMatchedQty
     * @Description: 获取已匹配数量
     * @param:
     * @return: a
     */
    public HashMap<String, HashMap<String, BigDecimal>> getMatchedQty(String billno) {
        ArrayList<QFilter> filters = new ArrayList<>();
        filters.add(new QFilter("billno", QCP.not_equals, billno));//单据编号
        HashMap<String, HashMap<String, BigDecimal>> map = new HashMap<>();
        DataSet load = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_costbillmat", "id,billno,tpv_invoiceinfoentry.tpv_invocenum,tpv_invoiceinfoentry.tpv_curmactchqtys" + ",tpv_invoiceinfoentry.tpv_curmatchamotax,tpv_invoiceinfoentry.tpv_curmatchamonotax,tpv_invoiceinfoentry.tpv_curmatchamointax", filters.toArray(new QFilter[0]));
        DataSet selected = load.select("id", "billno", "tpv_invoiceinfoentry.tpv_invocenum invocenum", "tpv_invoiceinfoentry.tpv_curmactchqtys curmactchqty", "tpv_invoiceinfoentry.tpv_curmatchamotax curmatchamotax", "tpv_invoiceinfoentry.tpv_curmatchamonotax curmatchamonotax", "tpv_invoiceinfoentry.tpv_curmatchamointax curmatchamointax");
        DataSet executeSql = selected.executeSql("select invocenum ,sum(curmactchqty) curmactchallqty ,sum(curmatchamotax) curmatchamoalltax" + ",sum(curmatchamonotax) curmatchamonoalltax,sum(curmatchamointax) curmatchamoinalltax GROUP BY invocenum");
        for (Row row : executeSql) {
            HashMap<String, BigDecimal> maps = new HashMap<>();
            maps.put("curmactchallqty", row.getBigDecimal("curmactchallqty"));
            maps.put("curmatchamoalltax", row.getBigDecimal("curmatchamoalltax"));
            maps.put("curmatchamonoalltax", row.getBigDecimal("curmatchamonoalltax"));
            maps.put("curmatchamoinalltax", row.getBigDecimal("curmatchamoinalltax"));
            map.put(row.getString("invocenum"), maps);
        }
        return map;
    }

    public Long toLong(Object longObj) {
        if (longObj == null) {
            return null;
        } else if (longObj instanceof Long) {
            return (Long) longObj;
        } else {
            return Long.valueOf(String.valueOf(longObj));
        }
    }

}
