package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.sys.utils.MetaPropertyHelper;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;

import java.math.BigDecimal;
import java.util.*;

/**
 * @Description: 费用结算单 表单插件 单据打开 传入 费用结算工作台选中行数据 【触发事件：费用结算工作台点击生成结算单按钮】
 * @Author LinRui
 * @Date 2023/8/31 19:47
 */
public class FeeSettleFormPlugin extends AbstractBillPlugIn {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"tpv_costinformations"});
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        Map<String, Object> map = this.getView().getFormShowParameter().getCustomParams();
        JSONArray tpvStatemenworkEntity = (JSONArray) map.get("tpv_statemenworkentity");
        DynamicObjectCollection newpersoninfor = this.getModel().getEntryEntity("tpv_dt_statemenbill_di");
        newpersoninfor.clear();
        if (null != tpvStatemenworkEntity) {
            for (int i = 0; i < tpvStatemenworkEntity.size(); i++) {
                JSONObject parseObject = tpvStatemenworkEntity.getJSONObject(i);
                int index = this.getModel().createNewEntryRow("tpv_dt_statemenbill_di");
                JSONObject tpvOrg = parseObject.getJSONObject("tpv_org");  //组织
                if (null != tpvOrg) {
                    this.getView().getModel().setValue("org", tpvOrg.getLong("id"));
                    this.getView().getModel().setValue("tpv_company", tpvOrg.getLong("id"));
                }
                JSONObject tpvDepartment = parseObject.getJSONObject("tpv_department");  //部门
                if (null != tpvDepartment) {
                    this.getView().getModel().setValue("tpv_department", tpvDepartment.getLong("id"));
                }
//                JSONObject tpvOperator = parseObject.getJSONObject("tpv_operator");  //业务员
//                if (null != tpvOperator) {
//                    this.getView().getModel().setValue("tpv_operator", tpvOperator.getLong("id"));
//                }
                JSONObject tpvLogisticspro = parseObject.getJSONObject("tpv_logisticspro");  //物流服务商
                if (null != tpvLogisticspro) {
                    this.getView().getModel().setValue("tpv_supplier", tpvLogisticspro.getLong("id"));
                }
                JSONObject tpvCurrency = parseObject.getJSONObject("tpv_feecurrency");  //币别
                if (null != tpvCurrency) {
                    this.getView().getModel().setValue("tpv_currency", tpvCurrency.getLong("id"));
                }
                JSONObject tpvExpenseitem = parseObject.getJSONObject("tpv_expenseitem");  //费用项目
                if (null != tpvExpenseitem) {
                    this.getView().getModel().setValue("tpv_expenseitem", tpvExpenseitem.getLong("id"), index);
                }
                JSONObject tpvNaturetrade = parseObject.getJSONObject("tpv_tradeproperty");  //贸易性质
                if (null != tpvNaturetrade) {
                    this.getView().getModel().setValue("tpv_naturetrade", tpvNaturetrade.getLong("id"), index);
                }
                JSONObject tpvCombinationnumber = parseObject.getJSONObject("tpv_combinationnumber");  //组合号
                if (null != tpvCombinationnumber) {
                    this.getView().getModel().setValue("tpv_combinationnum", tpvCombinationnumber.getLong("id"), index);
                }
                JSONObject tpvPursupporlier = parseObject.getJSONObject("tpv_supplier");  //采购供应商
                if (null != tpvPursupporlier) {
                    this.getView().getModel().setValue("tpv_pursupporlier", tpvPursupporlier.getLong("id"), index);
                }
                JSONObject tpvSourcebillkey = parseObject.getJSONObject("tpv_sourcebillkey");  //单据
                if (null != tpvSourcebillkey) {
                    JSONObject jsonObject = tpvSourcebillkey.getJSONObject("name");
                    if (null != jsonObject) {
                        this.getView().getModel().setValue("tpv_typedocumentorigin", jsonObject.getString("zh_CN"), index);
                    }
                    this.getView().getModel().setValue("tpv_srcbillkeys", tpvSourcebillkey.getString("number"), index);
                }
                BigDecimal zero = BigDecimal.ZERO;
                BigDecimal tpvBillableqty = parseObject.getBigDecimal("tpv_billableqty"); //计费数量
                BigDecimal tpvPrice = parseObject.getBigDecimal("tpv_price");  //单价
                BigDecimal tpvTaxrate = parseObject.getBigDecimal("tpv_taxrate");  //税率
                BigDecimal tpvAmount = parseObject.getBigDecimal("tpv_amount");  //金额
                String tpvSourcebillno = parseObject.getString("tpv_sourcebillno"); //单据编号
                Long tpvFid = parseObject.getLong("tpv_fid");  //来源单据ID
                Long tpvEntryid = parseObject.getLong("tpv_entryid");  //来源单据分录ID
                Long tpvSubentryid = parseObject.getLong("tpv_subentryid");  //来源单据子分录ID
                this.getModel().setValue("tpv_billablequantity", tpvBillableqty, index);
                this.getModel().setValue("tpv_unitprice", tpvPrice, index);  //单价
                this.getModel().setValue("tpv_taxrate", tpvTaxrate, index);  //税率
                this.getModel().setValue("tpv_money", tpvAmount, index);  //金额
                BigDecimal tpvSettleamount = tpvBillableqty.multiply(tpvPrice);
                BigDecimal tpvCompdisc = tpvAmount.subtract(tpvAmount);
                this.getModel().setValue("tpv_settlenumber", tpvBillableqty, index);  //结算数量
                this.getModel().setValue("tpv_settleprice", tpvPrice, index);  //结算单价
                this.getModel().setValue("tpv_settleamount", tpvSettleamount, index);  //结算金额
                this.getModel().setValue("tpv_compdisc", tpvCompdisc, index);  //较暂估差异
                this.getModel().setValue("tpv_srcbillno", tpvSourcebillno, index);  //来源单据号
                this.getModel().setValue("tpv_srcbillid", tpvFid, index);  //来源单据ID
                this.getModel().setValue("tpv_srcentryid", tpvEntryid, index);  //来源单据分录ID
                this.getModel().setValue("tpv_srcsubentryid", tpvSubentryid, index);  //来源单据子分录ID
                this.getModel().setValue("tpv_purcontractnuum", parseObject.getString("tpv_contractnos"), index);  //采购合同号
                this.getModel().setValue("tpv_salecontractnuum", parseObject.getString("tpv_salecontractnos"), index);  //销售合同号
                this.getModel().setValue("tpv_remark", parseObject.getString("tpv_remark"), index);

            }
        } else if (null == tpvStatemenworkEntity) {
            return;
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();
        if (StringUtils.equals("tpv_byelection", key)) {
            IFormView view = this.getView();
            IDataModel model = view.getModel();
            DynamicObject dataEntity = model.getDataEntity(true);

            FormShowParameter showParameter = new FormShowParameter();
            showParameter.setStatus(OperationStatus.ADDNEW);
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            showParameter.setFormId("tpv_dt_feesettlework");
            //点击分录补录按钮前校验过滤数据
            List<String> notInputs = new ArrayList<>();
            Map<String, Object> param = new HashMap<>();
            param.put("flag", "true");
            param.put("org", getNotNull(notInputs, dataEntity, "org"));
            param.put("tpv_supplier", getNotNull(notInputs, dataEntity, "tpv_supplier"));
            param.put("tpv_currency", getNotNull(notInputs, dataEntity, "tpv_currency"));
            param.put("tpv_department", getNotNull(notInputs, dataEntity, "tpv_department"));
            if (notInputs.size() > 0) {
                view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
            } else {
                OperationResult saveOperate = view.invokeOperation("save", YEM.getOptionNoMsg());
                if (!saveOperate.isSuccess()) {
                    view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
                    return;
                }
                showParameter.setCustomParams(param);
                showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_byelection"));
                view.showForm(showParameter);
            }
        }
    }

    /**
     * @Description: //回调，接收子页面传来的值
     * @param: e - [kd.bos.form.events.ClosedCallBackEvent]
     **/
    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        switch (actionId) {
            case "tpv_byelection":
                DynamicObjectCollection data = (DynamicObjectCollection) returnData;
                setValue(data);
                break;
            default:
                break;
        }
    }

    private void setValue(DynamicObjectCollection data) {
        if (data != null) {
            DynamicObjectCollection tpv_personinfor = data;
//            this.getModel().deleteEntryData("tpv_dt_statemenbill_di");
            for (DynamicObject personinfor : tpv_personinfor) {
                int index = this.getModel().createNewEntryRow("tpv_dt_statemenbill_di");
                DynamicObject tpvExpenseitem = personinfor.getDynamicObject("tpv_expenseitem");  //费用项目
                if (null != tpvExpenseitem) {
                    this.getView().getModel().setValue("tpv_expenseitem", tpvExpenseitem.getLong("id"), index);
                }
                DynamicObject tpvNaturetrade = personinfor.getDynamicObject("tpv_tradeproperty");  //贸易性质
                if (null != tpvNaturetrade) {
                    this.getView().getModel().setValue("tpv_naturetrade", tpvNaturetrade.getLong("id"), index);
                }
                DynamicObject tpvCombinationnumber = personinfor.getDynamicObject("tpv_combinationnumber");  //组合号
                if (null != tpvCombinationnumber) {
                    this.getView().getModel().setValue("tpv_combinationnum", tpvCombinationnumber.getLong("id"), index);
                }
                DynamicObject tpvPursupporlier = personinfor.getDynamicObject("tpv_supplier");  //采购供应商
                if (null != tpvPursupporlier) {
                    this.getView().getModel().setValue("tpv_pursupporlier", tpvPursupporlier.getLong("id"), index);
                }
                DynamicObject tpvSourcebillkey = personinfor.getDynamicObject("tpv_sourcebillkey");  //单据
                if (null != tpvSourcebillkey) {
                    String billName = tpvSourcebillkey.getString("name");
                    if (null != billName) {
                        this.getView().getModel().setValue("tpv_typedocumentorigin", billName, index);
                    }
                    this.getView().getModel().setValue("tpv_srcbillkeys", tpvSourcebillkey.getString("number"), index);
                }
                BigDecimal tpvBillableqty = personinfor.getBigDecimal("tpv_billableqty"); //计费数量
                BigDecimal tpvPrice = personinfor.getBigDecimal("tpv_price");  //单价
                BigDecimal tpvTaxrate = personinfor.getBigDecimal("tpv_taxrate");  //税率
                BigDecimal tpvAmount = personinfor.getBigDecimal("tpv_amount");  //金额
                String tpvSourcebillno = personinfor.getString("tpv_sourcebillno"); //单据编号
                Long tpvFid = personinfor.getLong("tpv_fid");  //来源单据ID
                Long tpvEntryid = personinfor.getLong("tpv_entryid");  //来源单据分录ID
                Long tpvSubentryid = personinfor.getLong("tpv_subentryid");  //来源单据子分录ID
                this.getModel().setValue("tpv_billablequantity", tpvBillableqty, index); //计费数量
                this.getModel().setValue("tpv_unitprice", tpvPrice, index);  //单价
                this.getModel().setValue("tpv_taxrate", tpvTaxrate, index);  //税率
                this.getModel().setValue("tpv_money", tpvAmount, index);  //金额
                BigDecimal tpvSettleamount = tpvBillableqty.multiply(tpvPrice);
                BigDecimal tpvCompdisc = tpvTaxrate.subtract(tpvAmount);
                this.getModel().setValue("tpv_settlenumber", tpvBillableqty, index);  //结算数量
                this.getModel().setValue("tpv_settleprice", tpvPrice, index);  //结算单价
                this.getModel().setValue("tpv_settleamount", tpvSettleamount, index);  //结算金额
                this.getModel().setValue("tpv_compdisc", tpvCompdisc, index);  //较暂估差异
                this.getModel().setValue("tpv_srcbillno", tpvSourcebillno, index);  //来源单据号
                this.getModel().setValue("tpv_srcbillid", tpvFid, index);  //来源单据ID
                this.getModel().setValue("tpv_srcentryid", tpvEntryid, index);  //来源单据分录ID
                this.getModel().setValue("tpv_srcsubentryid", tpvSubentryid, index);  //来源单据子分录ID
                this.getModel().setValue("tpv_purcontractnuum", personinfor.getString("tpv_contractnos"), index);  //采购合同号
                this.getModel().setValue("tpv_remark", personinfor.getString("tpv_remark"), index);
            }
        }
    }

    private Object getNotNull(List<String> list, DynamicObject dt, String fieldKey) {
        String name = MetaPropertyHelper.getEntityLangName(this.getView().getEntityId(), fieldKey);
        Object propValue = dt.get(fieldKey);
        if (propValue == null) {
            list.add(name);
        } else if (propValue instanceof BigDecimal && ((BigDecimal) propValue).compareTo(BigDecimal.ZERO) == 0) {
            list.add(name);
        } else if (propValue instanceof String && ((String) propValue).isEmpty()) {
            list.add(name);
        } else if (propValue instanceof Integer && ((Integer) propValue).intValue() == 0) {
            list.add(name);
        } else if (propValue instanceof Long && ((Long) propValue).longValue() == 0L) {
            list.add(name);
        } else if (propValue instanceof DynamicObjectCollection && ((DynamicObjectCollection) propValue).size() == 0) {
            list.add(name);
        }
        if (propValue instanceof DynamicObject) {
            propValue = ((DynamicObject) propValue).getPkValue();
        }
        return propValue;
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();
        String key = e.getProperty().getName();
        switch (key) {
            case "":
                break;
            default:
                break;
        }
    }

}
