package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.control.EntryGrid;

import java.math.BigDecimal;
import java.math.RoundingMode;


/**
 * WangShuGuang
 * 验收单值更新
 */
public class MaterialTypeFormPlugin extends AbstractBillPlugIn {

    @Override
    public void propertyChanged(PropertyChangedArgs e) {//触发时机：表单模型某个字段值改变的时候就会触发此事件//
        String propertyName = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        //监听原料成品对应关系字段，数量字段，商品编码字段
        if (propertyName.equals("tpv_combofield") || propertyName.equals("tpv_material") || propertyName.equals("tpv_qty")) {
            //监听原料成品对应关系改变
            amountCollect(cd);//原料成品对应关系改变计算方式改变
        }
    }

    private void amountCollect(ChangeData cd) {
        //拿到原料成品对应关系值
        String combofield = (String) this.getModel().getValue("tpv_combofield");
        //判空
        if (null != combofield) {
            //获得分录
            DynamicObjectCollection material = this.getModel().getEntryEntity("tpv_dt_material");
            DynamicObjectCollection materialentry = this.getModel().getEntryEntity("tpv_materialentry");
            BigDecimal materialMoney = BigDecimal.ZERO;
            BigDecimal quanTity = BigDecimal.ZERO;
            BigDecimal rawMoney = BigDecimal.ZERO;
            EntryGrid entrySaww = (EntryGrid) getControl("tpv_materialentry");
            //循环分录 计算每行原料单价的汇总
            for (DynamicObject entry : material) {
                BigDecimal univaLence = entry.getBigDecimal("tpv_money");
                rawMoney = univaLence;
                if (univaLence.compareTo(BigDecimal.ZERO) != 0) {
                    materialMoney = materialMoney.add(entry.getBigDecimal("tpv_money"));
                }
            }
            if (combofield.equals("A")) {
                for (int i = 0; i < materialentry.size(); i++) {
                    quanTity = quanTity.add(materialentry.get(i).getBigDecimal("tpv_qty"));
                }
                if (quanTity.compareTo(BigDecimal.ZERO) != 0 && rawMoney.compareTo(BigDecimal.ZERO) != 0) {
                    for (int i = 0; i < materialentry.size(); i++) {
                        BigDecimal multiplys = materialMoney.divide(quanTity, 2, RoundingMode.HALF_UP);
                        this.getModel().setValue("tpv_price", multiplys, i);
                    }
                }
            } else if (combofield.equals("B")) {
                for (int i = 0; i < materialentry.size(); i++) {
                    quanTity = materialentry.get(i).getBigDecimal("tpv_qty");
                    if (quanTity.compareTo(BigDecimal.ZERO) != 0 && rawMoney.compareTo(BigDecimal.ZERO) != 0) {
                        BigDecimal multiply = materialMoney.divide(quanTity, 2, RoundingMode.HALF_UP);
                        this.getModel().setValue("tpv_price", multiply, i);
                    }
                }
            }
        }
    }
}
