package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import com.itopview.wm.dt.utils.PickShipsHelper;
import com.itopview.wm.sys.formplugin.form.Tpl1BillPlugIn;
import com.itopview.wm.sys.utils.MetaPropertyHelper;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.BeforeImportEntryEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.*;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.control.events.SelectRowsEventListener;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.plugin.importentry.resolving.ImportEntryData;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * @Description: 采购入库单 -表单插件
 * @Author LinRui
 * @Date 2023/12/8 11:23
 */
public class PurInBillFormPlugin extends AbstractBillPlugIn implements SelectRowsEventListener, RowClickEventListener, BeforeF7SelectListener {
    private static final String importEntryKey = "tpv_dt_purinbill_j_hide";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"tpv_tbmainentry", "tbmain", "tpv_advcontoolbarap1"});
        EntryGrid entryGrid = this.getControl("billentry");
        entryGrid.addSelectRowsListener(this);
        entryGrid.addRowClickListener(this);
        BasedataEdit tpv_costitem = (BasedataEdit) this.getView().getControl("tpv_costitem");
        tpv_costitem.addBeforeF7SelectListener(this);
        BasedataEdit tpv_operator = (BasedataEdit) this.getView().getControl("tpv_operator");
        tpv_operator.addBeforeF7SelectListener(this);
        ((BasedataEdit) this.getControl("tpv_approvalprocess")).addBeforeF7SelectListener(this);
        ((BasedataEdit) this.getControl("tpv_prodname")).addBeforeF7SelectListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent evt) {
        String name = evt.getProperty().getName();
        String entityId = this.getModel().getDataEntityType().getName();
        switch (name) {
            case "tpv_costitem":
                String entityName = this.getModel().getDataEntityType().getName();
                QFilter qFilterEr = new QFilter("enable", QCP.equals, "1");
                qFilterEr.and(new QFilter("billtype.number", QCP.equals, entityName));
                DynamicObject[] load = BusinessDataServiceHelper.load("er_expenseitembill", "expenseitem,billtype", qFilterEr.toArray());
                List<Long> ids = new ArrayList<>();
                if (load.length > 0) {
                    for (DynamicObject dynamicObject : load) {
                        DynamicObject expenseitem = dynamicObject.getDynamicObject("expenseitem");
                        if (YEM.isNotEmpty(expenseitem)) {
                            ids.add(expenseitem.getLong("id"));
                        }
                    }
                }
                QFilter qFilter = new QFilter("enable", QCP.equals, "1");
                if (ids.size() > 0) {
                    qFilter.and(new QFilter("id", QCP.in, ids));
                } else {
                    qFilter.and(new QFilter("id", QCP.less_than, 0l));
                }
                ListShowParameter showParameter = (ListShowParameter) evt.getFormShowParameter();
                showParameter.getTreeFilterParameter().getQFilters().add(qFilter);
                showParameter.getListFilterParameter().getQFilters().add(qFilter);
                break;
            case "tpv_operator":
                operatorF7(evt, name);
                break;
            case "tpv_approvalprocess":
                Tpl1BillPlugIn.whethertopublish(evt, entityId);
                break;
            case "tpv_prodname":
                prodName(evt);
                break;
            default:
                break;
        }
    }

    private void prodName(BeforeF7SelectEvent e) {
        EntryGrid entryGridHt = this.getControl("billentry");//商品明细分录
        int[] selectRowsHt = entryGridHt.getSelectRows();//获取选中的行号
        if (selectRowsHt.length == 1) {
            DynamicObject tpvMaterial = this.getModel().getDataEntity(true).getDynamicObjectCollection("billentry").get(selectRowsHt[0]).getDynamicObject("material");
            if (tpvMaterial != null) {
                ListShowParameter showMaterial = (ListShowParameter) e.getFormShowParameter();
                List<QFilter> QMaterial = new ArrayList<QFilter>();
                QMaterial.add(new QFilter("group", QCP.equals, tpvMaterial.getPkValue()));
                showMaterial.getListFilterParameter().setQFilters(QMaterial);
            }
        }
    }

    private void operatorF7(BeforeF7SelectEvent e, String key) {
        FormShowParameter showParameter = e.getFormShowParameter();
        CloseCallBack closeCallBack = new CloseCallBack(this, key);
        showParameter.setCloseCallBack(closeCallBack);
    }

    private void operatorCallBack(ClosedCallBackEvent e) {
        IDataModel model = this.getModel();
        ListSelectedRowCollection selectedRows = (ListSelectedRowCollection) e.getReturnData();
        if (selectedRows != null && selectedRows.size() > 0) {
            ListSelectedRow selectedRow = selectedRows.get(0);
            long userId = (long) selectedRow.getPrimaryKeyValue();//人员id
            long userEntryId = (long) selectedRow.getEntryPrimaryKeyValue();//部门分录id
            model.beginInit();
            model.setValue("tpv_operator", userId);
            DynamicObjectCollection entry = getUserDepts(userId);
            for (DynamicObject row : entry) {
                if (userEntryId == row.getLong("id")) {
                    model.setValue("bizdept", row.get("org"));
                    model.setValue("dept", row.get("org"));
                }
            }
            model.endInit();
            this.getView().updateView("tpv_operator");
            this.getView().updateView("bizdept");
            this.getView().updateView("dept");
        }
    }

    private static DynamicObjectCollection getUserDepts(long userId) {
        QFilter qFilter = new QFilter("user", QCP.equals, userId);
//        qFilter.and(new QFilter("org.orgpattern.number", QCP.equals, "Orgform06"));
        return QueryServiceHelper.query("bos_userposition", "id,org", qFilter.toArray());
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        switch (itemKey) {
            case "tpv_cancelcost": // 成本选择
                cancelCostClick();
                break;
            case "tpv_bulkentrybutton": //客户额度使用情况查询
                showInfoForm(this.getView());
                break;
            case "bar_save": // 保存
            case "bar_submit": // 提交
            case "bar_unsubmit": // 撤销
            case "bar_audit": // 审核
            case "bar_unaudit": // 反审核
                this.getView().setEnable(false, "tpv_advconbaritemap4"); //卷号批量导入
                break;
            default:
                break;
        }
    }

    /**
     * 设置打开批量录入金额动态表单
     */
    private void showInfoForm(IFormView view) {
        // 获取单据体
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId("tpv_bulkentryexpenses");
        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_bulkentrybutton"));
        view.showForm(showParameter);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        BillShowParameter showParameter = (BillShowParameter) this.getView().getFormShowParameter();
        Object purinreturn = showParameter.getCustomParam("purinreturn");
        if (YEM.isNotEmpty(purinreturn)) {
            String value = String.valueOf(purinreturn);
            if ("purinreturn".equals(value)) {
                DynamicObject bdBiztype = BusinessDataServiceHelper.loadSingle("bd_biztype",
                        new QFilter[]{new QFilter("number", QCP.equals, "1101")});
                DynamicObject imInvscheme = BusinessDataServiceHelper.loadSingle("im_invscheme",
                        new QFilter[]{new QFilter("number", QCP.equals, "1101")});
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                dataEntity.set("biztype", bdBiztype);
                dataEntity.set("invscheme", imInvscheme);
                this.getView().updateView("biztype");
                this.getView().updateView("invscheme");
            }
        }
        this.getModel().setValue("dept", null);
        this.getModel().setValue("bizdept", null);
    }

    @Override
    public void afterBindData(EventObject e) {
        IFormView view = this.getView();
        IDataModel model = view.getModel();
        BillShowParameter showParameter = (BillShowParameter) this.getView().getFormShowParameter();
        Object purinreturn = showParameter.getCustomParam("purinreturn");
        if (YEM.isNotEmpty(purinreturn)) {
            String value = String.valueOf(purinreturn);
            if ("purinreturn".equals(value)) {
                this.getView().setEnable(false, "billtype");
                this.getView().setEnable(false, "biztype");
            }

        }
        DynamicObjectCollection tpv_materialentry = model.getDataEntity(true).getDynamicObjectCollection("billentry");//商品分录
//        if (tpv_materialentry.size() > 0) {
//            for (int i = 0; i < tpv_materialentry.size(); i++) {
//                DynamicObject dynamicObject = tpv_materialentry.get(i);
//                Boolean tpv_richardinputsx = dynamicObject.getBoolean("tpv_richardinputsx");//按理计输入
//                if(tpv_richardinputsx){
//                    this.getView().setEnable(false,i,"qty");
//                }
//            }
//        }

        boolean tpvRichardinput = (boolean) model.getValue("tpv_richardinput");
        String tpv_sourceofcoeff = (String) model.getValue("tpv_sourceofcoeff");
        if (tpvRichardinput) {
            this.getView().setEnable(true, "tpv_countthetable");
            this.getView().setEnable(true, "tpv_customization");
            this.getView().setEnable(true, "tpv_coefficients");
            if (tpv_materialentry.size() > 0) {
                for (int i = 0; i < tpv_materialentry.size(); i++) {
//                    this.getView().setEnable(false, i, "qty");
                    this.getView().setEnable(true, i, "tpv_coefficients"); //系数
                }
            }
        } else {
            this.getView().setEnable(false, "tpv_countthetable");
            this.getView().setEnable(false, "tpv_customization");
            this.getView().setEnable(false, "tpv_coefficients");
            if (tpv_materialentry.size() > 0) {
                for (int i = 0; i < tpv_materialentry.size(); i++) {
//                    this.getView().setEnable(true, i, "qty");
                    this.getView().setEnable(false, i, "tpv_coefficients"); //系数
                }
            }
        }
        if (!"B".equals(tpv_sourceofcoeff)) {
            this.getView().setEnable(false, "tpv_coefficient");
        } else if ("B".equals(tpv_sourceofcoeff)) {
            this.getView().setEnable(true, "tpv_coefficient");
        }

        EntryGrid entryGrid = this.getControl("billentry");//商品明细
        int[] selectRowsEntry = entryGrid.getSelectRows();//获取选中的行号
        if (selectRowsEntry.length <= 0) {
//            this.getModel().beginInit();
//            this.getModel().setValue("tpv_richardinput", false);
//            this.getModel().setValue("tpv_sourceofcoeff", "NULL");
//            this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
//            this.getModel().endInit();
//            this.getView().setEnable(false,"tpv_countthetable");
//            this.getView().setEnable(false,"tpv_customization");
//            this.getView().setEnable(false,"tpv_coefficient");
            view.setEnable(false, "tpv_advconbaritemap4"); //卷号批量导入
        }
        boolean invokeRefresh = invokeRefresh(view);
        if (invokeRefresh) {
            DynamicObjectCollection billEntry = model.getEntryEntity("billentry");
            DynamicObjectCollection hideCollection = model.getEntryEntity(importEntryKey);//卷号管理(隐藏)
            if (hideCollection.isEmpty()) {
                return;
            }
            String selectRows = view.getPageCache().get("selectRows");
            String[] rowIndex = selectRows.split(",");
            if (selectRows.isEmpty()) {
                for (DynamicObject item : billEntry) {
                    for (DynamicObject object : hideCollection) {
                        DynamicObjectCollection collection = item.getDynamicObjectCollection("tpv_dt_purinbill_j");
                        DynamicObject dynamicObject = collection.addNew();
                        dynamicObject.set("tpv_reelnumber", object.getString("tpv_reelnumbers"));
                        dynamicObject.set("tpv_quantity", object.getBigDecimal("tpv_quantitys"));
                        dynamicObject.set("tpv_remark", object.getString("tpv_remarks"));
                    }
                }
            } else {
                for (String selectRow : rowIndex) {
                    DynamicObject entry = billEntry.get(Integer.valueOf(selectRow));
                    for (DynamicObject object : hideCollection) {
                        DynamicObjectCollection collection = entry.getDynamicObjectCollection("tpv_dt_purinbill_j");
                        DynamicObject dynamicObject = collection.addNew();
                        dynamicObject.set("tpv_reelnumber", object.getString("tpv_reelnumbers"));
                        dynamicObject.set("tpv_quantity", object.getBigDecimal("tpv_quantitys"));
                        dynamicObject.set("tpv_remark", object.getString("tpv_remarks"));
                    }
                }
            }
            model.deleteEntryData(importEntryKey);
            view.updateView("tpv_dt_purinbill_j");
        }
    }

    private boolean invokeRefresh(IFormView view) {
        IPageCache pageCache = view.getPageCache();
        String tpv_imp_refresh = pageCache.get(importEntryKey);
        if (tpv_imp_refresh != null && Boolean.valueOf(tpv_imp_refresh)) {
            pageCache.remove(importEntryKey);
            return true;
        }
        return false;
    }

    @Override
    public void beforeImportEntry(BeforeImportEntryEventArgs e) {
        Map<String, List<ImportEntryData>> source = (Map<String, List<ImportEntryData>>) e.getSource();
        IFormView view = this.getView();
        IPageCache pageCache = view.getPageCache();
        if (source.containsKey(importEntryKey)) {//卷号管理(隐藏)
            List<ImportEntryData> entries = source.get(importEntryKey);
            if (entries.isEmpty()) {
                return;
            }
            pageCache.put(importEntryKey, "true");
            EntryGrid entryGrid = view.getControl("billentry");
            DynamicObjectCollection billEntry = this.getModel().getEntryEntity("billentry");
            entryGrid.addSelectRowsListener(this);
            int[] selectRows = entryGrid.getSelectRows();
            pageCache.put("selectRows", StringUtils.join(selectRows, ','));
            OperationServiceHelper.executeOperate("save", this.getModel().getDataEntityType().getName(), new DynamicObject[]{this.getModel().getDataEntity(true)});
        }
    }

    /**
     * @param e 回调，接收子页面传来的值。
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        switch (actionId) {
            case "tpv_bulkentrybutton":
                DynamicObjectCollection data = (DynamicObjectCollection) returnData;
                setValue(data);
                break;
            case "tpv_operator":
                operatorCallBack(e);
                break;
            default:
                break;
        }
    }

    private void setValue(DynamicObjectCollection data) {
        if (data != null && data.size() > 0) {
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("billentry");//商品明细分录
            for (int i = 0; materialentry.size() > i; i++) {
                DynamicObject dynamicObject = materialentry.get(i);
                BigDecimal tpvQty = dynamicObject.getBigDecimal("qty");
                DynamicObjectCollection dynamicObjects = dynamicObject.getDynamicObjectCollection("tpv_dt_purinbill_f");
                for (DynamicObject freigroambill : data) {
                    DynamicObject addNewDy = dynamicObjects.addNew();
                    addNewDy.set("tpv_costitem", freigroambill.getDynamicObject("tpv_expenseitems"));
                    addNewDy.set("tpv_supplier", freigroambill.getDynamicObject("tpv_supplierf"));
                    addNewDy.set("tpv_reimbursement", freigroambill.getDynamicObject("tpv_costcurrencys"));
                    addNewDy.set("tpv_chargequantity", tpvQty);
                    addNewDy.set("tpv_univalence", freigroambill.getBigDecimal("tpv_unitprices"));
                    BigDecimal tpvMoneys = tpvQty.multiply(freigroambill.getBigDecimal("tpv_unitprices"));
                    addNewDy.set("tpv_amt", tpvMoneys.setScale(2, BigDecimal.ROUND_HALF_UP));
                    addNewDy.set("tpv_taxrate", freigroambill.getBigDecimal("tpv_taxrates"));
                    addNewDy.set("tpv_desc", freigroambill.getString("tpv_comments"));
                    DynamicObject tpv_currency = freigroambill.getDynamicObject("tpv_costcurrencys");
                    if (YEM.isNotEmpty(tpv_currency)) {
                        Object tpv_exratetable = this.getModel().getValue("exratetable");
                        Object tpv_currencybase = this.getModel().getValue("currency"); //本位币
                        Date tpv_exratedate = (Date) this.getModel().getValue("exratedate");
                        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
                        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
                        BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
                        addNewDy.set("tpv_costrate", exchangeRate);
                    }
                }
            }
            this.getView().updateView("tpv_dt_purinbill_f");
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String key = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        switch (key) {
            case "tpv_reimbursement":
                this.setExchangeRate();
                break;
            case "exratetable":
            case "exratedate":
            case "currency":
                setSubEntryExchangeRate();
                break;
            case "material"://物料编码
            case "tpv_specation"://规格
            case "tpv_shader"://材质
            case "tpv_origin"://产地
            case "tpv_richardinput"://按理计输入
            case "tpv_packnum"://包装数量
            case "tpv_sourceofcoeff"://系数来源
//                changeCoefficient(cd,key);
                changeCoefficientNew(cd, key);
                break;
            case "tpv_coefficient"://商品明细表头-系数
            case "tpv_coefficients"://商品明细-系数
//                setRowsCoefficient(cd);
                setRowsCoefficientNew(cd, key);
                break;
            case "tpv_entrepot":
            case "bizdept":
            case "supplier":
                entrepot(cd); //业务类型为退货是值更新清空拣配分录数据
                break;
            default:
                break;
        }
    }

    private void setRowsCoefficient(ChangeData cd) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        BigDecimal tpv_coefficient = dataEntity.getBigDecimal("tpv_coefficient");//表头系数
        EntryGrid entryGrid = this.getControl("billentry");//商品明细
        int selectRows[] = entryGrid.getSelectRows();//获取选中的行号
        if (selectRows.length > 0) {
            List<String> seqFalse = new ArrayList<>();
            List<String> seqtrue = new ArrayList<>(); //按理计表
            List<String> seqtrueA = new ArrayList<>(); //按理计表
            List<String> seqtrueB = new ArrayList<>(); //自定义
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = this.getModel().getEntryRowEntity("billentry", selectRow);
                boolean tpvRichardinputsx = dynamicObject.getBoolean("tpv_richardinputsx"); //按理计输入
                String tpv_sourceofcoeffsx = dynamicObject.getString("tpv_sourceofcoeffsx"); //系数来源
                if (!tpvRichardinputsx) {
                    seqFalse.add(dynamicObject.getString("seq"));
                }
                if (tpvRichardinputsx) {
                    seqtrue.add(dynamicObject.getString("seq"));
                }
                if ("A".equals(tpv_sourceofcoeffsx)) {
                    seqtrueA.add(dynamicObject.getString("seq"));
                }
                if ("B".equals(tpv_sourceofcoeffsx)) {
                    seqtrueB.add(dynamicObject.getString("seq"));
                }
            }
            if (seqFalse.size() > 0 & seqtrue.size() > 0) {
                this.getView().showTipNotification("选择行存在按理输入行和不按理计输入行！请重新选中行！");
                this.getModel().beginInit();
                this.getModel().setValue("tpv_coefficient", cd.getOldValue());
                this.getModel().endInit();
                this.getView().updateView("tpv_coefficient");
                return;
            } else if (seqtrueA.size() > 0 & seqtrueB.size() > 0) {
                this.getView().showTipNotification("选择行存在按理计表计算和按自定义计算！请重新选中行！");
                this.getModel().beginInit();
                this.getModel().setValue("tpv_coefficient", cd.getOldValue());
                this.getModel().endInit();
                this.getView().updateView("tpv_coefficient");
                return;
            }
        }
        for (int row : selectRows) {
            this.getModel().setValue("tpv_coefficients", tpv_coefficient, row);
        }
    }

    private void setRowsCoefficientNew(ChangeData cd, String keyName) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        BigDecimal tpv_coefficient = dataEntity.getBigDecimal("tpv_coefficient");//表头系数
        DynamicObjectCollection tpvMaterialentry = dataEntity.getDynamicObjectCollection("billentry");
        if ("tpv_coefficient".equals(keyName)) {
            if (tpvMaterialentry.size() > 0) {
                for (int i = 0; i < tpvMaterialentry.size(); i++) {
                    this.getModel().setValue("tpv_coefficients", tpv_coefficient, i);
                    BigDecimal tpvPacknum = tpvMaterialentry.get(i).getBigDecimal("tpv_packnum");
                    BigDecimal qty = tpv_coefficient.multiply(tpvPacknum);
                    this.getModel().setValue("qty", qty, i);
                    this.getView().updateView("qty", i);
                }
            }
        }
        if ("tpv_coefficients".equals(keyName)) {
            int index = this.getModel().getEntryCurrentRowIndex("billentry");
            BigDecimal tpvCoefficients = (BigDecimal) this.getModel().getValue("tpv_coefficients", index);
            BigDecimal tpvPacknum = tpvMaterialentry.get(index).getBigDecimal("tpv_packnum");
            BigDecimal qty = tpvCoefficients.multiply(tpvPacknum);
            this.getModel().setValue("qty", qty, index);
            this.getView().updateView("qty", index);
        }
    }

    private void entrepot(ChangeData cd) {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObject biztype = dataEntity.getDynamicObject("biztype");
        if (YEM.isNotEmpty(biztype)) {
            String number = biztype.getString("number");
            if ("1101".equals(number)) {
                DynamicObjectCollection billentry = dataEntity.getDynamicObjectCollection("billentry");
                for (DynamicObject dynamicObject : billentry) {
                    DynamicObjectCollection tpvDtPurinbillJ = dynamicObject.getDynamicObjectCollection("tpv_dt_purinbill_j");
                    tpvDtPurinbillJ.clear();
                    DynamicObjectCollection tpvDtPurinbillF = dynamicObject.getDynamicObjectCollection("tpv_dt_purinbill_f");
                    tpvDtPurinbillF.clear();
                }
                billentry.clear();
                OperationServiceHelper.executeOperate("save", dataEntity.getDataEntityType().getName(),
                        new DynamicObject[]{model.getDataEntity(true)}, YEM.getOption());
                this.getView().updateView("billentry");
                this.getView().updateView("tpv_dt_purinbill_j");
                this.getView().updateView("tpv_dt_purinbill_f");
            }
        }
    }

    private void setSubEntryExchangeRate() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection billentry = dataEntity.getDynamicObjectCollection("billentry");
        if (billentry.size() > 0) {
            for (int i = 0; i < billentry.size(); i++) {
                DynamicObject dynamicObject = billentry.get(i);
                DynamicObjectCollection tpvDtPurinbillF = dynamicObject.getDynamicObjectCollection("tpv_dt_purinbill_f");
                if (tpvDtPurinbillF.size() > 0) {
                    this.getModel().setEntryCurrentRowIndex("billentry", i);
                    for (int i1 = 0; i1 < tpvDtPurinbillF.size(); i1++) {
                        DynamicObject object = tpvDtPurinbillF.get(i1);
                        DynamicObject tpv_currency = object.getDynamicObject("tpv_reimbursement");
                        if (null != tpv_currency) {
                            Object tpv_exratetable = this.getModel().getValue("exratetable");
                            Object tpv_currencybase = this.getModel().getValue("currency"); //本位币
                            Date tpv_exratedate = (Date) this.getModel().getValue("exratedate");
                            BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
                            BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
                            BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
                            this.getModel().setValue("tpv_costrate", exchangeRate, i1);
                        }
                    }
                }
            }
        }
    }

    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        super.afterAddRow(e);
        String name = e.getEntryProp().getName();
        int i = 0;
        RowDataEntity[] rowdata = e.getRowDataEntities();
        for (RowDataEntity rdata : rowdata) {
            i = rdata.getRowIndex();
        }
        switch (name) {
            case "tpv_dt_purinbill_f"://费用分录
                EntryGrid entryGrid = this.getControl("billentry");//商品明细
                int selectRows[] = entryGrid.getSelectRows();//获取选中的行号
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                DynamicObjectCollection billentry = dataEntity.getDynamicObjectCollection("billentry");//商品分录
                int entryCurrentRowIndex = this.getModel().getEntryCurrentRowIndex("billentry");
//                for (int row : selectRows) {
                DynamicObject billentryRow = billentry.get(entryCurrentRowIndex);
                DynamicObjectCollection tpvDtPurinbill = billentryRow.getDynamicObjectCollection("tpv_dt_purinbill_f");//费用分录
                for (DynamicObject dynamicObject : tpvDtPurinbill) {
                    DynamicObject tpv_currency = dynamicObject.getDynamicObject("tpv_reimbursement");  //结算币别
                    if (null != tpv_currency) {
                        Object tpv_exratetable = this.getModel().getValue("exratetable");
                        Object tpv_currencybase = this.getModel().getValue("currency"); //本位币
                        Date tpv_exratedate = (Date) this.getModel().getValue("exratedate");
                        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
                        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
                        BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
                        this.getModel().setValue("tpv_costrate", exchangeRate, i);
                    }
                }
//                }
                break;
            case "billentry": //给理计赋值
                if (StringUtils.equals("billentry", name)) {
                    outCoefficient(rowdata);
                }
                break;
        }
    }

    /**
     * 汇率获取
     */
    private void setExchangeRate() {
        int index = this.getModel().getEntryCurrentRowIndex("tpv_dt_purinbill_f");
        Object tpv_exratetable = this.getModel().getValue("exratetable");
        Object tpv_currency = this.getModel().getValue("tpv_reimbursement", index);  //结算币别
        Object tpv_currencybase = this.getModel().getValue("currency"); //本位币
        Date tpv_exratedate = (Date) this.getModel().getValue("exratedate");
        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
        BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
        this.getModel().setValue("tpv_costrate", exchangeRate, index);
    }

    private void cancelCostClick() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        EntryGrid entry = view.getControl("billentry");
        int selectRows = entry.getSelectRows().length;
        if (selectRows > 1) {
            view.showTipNotification("只能选择一行数据进行操作。");
        }
        if (selectRows == 0) {
            view.showTipNotification("未选择数据。");
        }
        if (selectRows == 1) {
            int index = entry.getSelectRows()[0];
            DynamicObject row = model.getEntryRowEntity("billentry", index);
            OperationResult saveOperate = view.invokeOperation("save", YEM.getOptionNoMsg());
            if (!saveOperate.isSuccess()) {
                view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
                return;
            }
//            SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
            BigDecimal qty = row.getBigDecimal("qty");
            if (qty.compareTo(BigDecimal.ZERO) == 0) {
                view.showTipNotification("该行数量不能为0！");
                return;
            }
            FormShowParameter showParameter = new FormShowParameter();
            showParameter.setStatus(OperationStatus.ADDNEW);
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            showParameter.setFormId("tpv_cm_costbreakdown"); //选择退货成本弹出框

            List<String> notInputs = new ArrayList<>();
            Map<String, Object> param = new HashMap<>();
            param.put("pkid", row.getLong("tpv_fentryid_in"));
            param.put("tpv_itemcode", PickShipsHelper.getNotNull(view, notInputs, row, "material")); // 物料
            if ("null".equals(String.valueOf(this.getModel().getValue("tpv_ticketinventory")))) { //三个值判断 null、A、B
                String name = MetaPropertyHelper.getEntityLangName(view.getEntityId(), "tpv_ticketinventory");
                notInputs.add(name);
            }
            param.put("tpv_ticketinventory", String.valueOf(this.getModel().getValue("tpv_ticketinventory")));// 【退已到票库存 A/退未到票库存 B】
            param.put("tpv_redqty", PickShipsHelper.getNotNull(view, notInputs, row, "qty")); // 数量
            DynamicObject tpvUnit = (DynamicObject) row.get("unit");
            Long tpvUnitLong = 0L;
            if (null != tpvUnit) {
                tpvUnitLong = tpvUnit.getLong("id");
            }
            param.put("tpv_units", tpvUnitLong); // 计量单位
            if (notInputs.size() > 0) {
                view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
            } else {
                showParameter.setCustomParams(param);
                view.showForm(showParameter);
            }
        }
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        RowClickEventListener.super.entryRowClick(evt);
        EntryGrid entryGrid = this.getControl("billentry");
        // 获取选中行，数组为行号，从0开始
        int[] selectRows = entryGrid.getSelectRows();
//        selectRowChangecoeffic(selectRows);
        String billstatus = (String) this.getModel().getValue("billstatus");
        if (!"B".equals(billstatus) | !"C".equals(billstatus)) {
            if (selectRows.length > 0) this.getView().setEnable(true, "tpv_advconbaritemap4");
            else this.getView().setEnable(false, "tpv_advconbaritemap4");

        }
    }

    private void selectRowChangecoeffic(int[] selectRows) {
        if (selectRows.length > 0) {
            if (selectRows.length == 1) {
                DynamicObjectCollection entity = this.getModel().getDataEntity(true).getDynamicObjectCollection("billentry");//商品明细
                DynamicObject dynamicObject = entity.get(selectRows[0]);//数据
                Boolean tpv_richardinputsx = dynamicObject.getBoolean("tpv_richardinputsx");//按理计（分录隐藏）
                String tpv_sourceofcoeffsx = dynamicObject.getString("tpv_sourceofcoeffsx");//系数来源（隐藏）
                BigDecimal tpv_coefficient = dynamicObject.getBigDecimal("tpv_coefficients");//系数
                if (tpv_richardinputsx && tpv_sourceofcoeffsx.equals("B")) {
                    this.getModel().beginInit();
                    this.getModel().setValue("tpv_richardinput", tpv_richardinputsx);
                    this.getModel().setValue("tpv_sourceofcoeff", tpv_sourceofcoeffsx);
                    this.getModel().setValue("tpv_coefficient", tpv_coefficient);
                    this.getModel().endInit();
                    this.getView().setEnable(true, "tpv_richardinput");
                    this.getView().setEnable(true, "tpv_countthetable");
                    this.getView().setEnable(true, "tpv_customization");
                    this.getView().setEnable(true, "tpv_coefficient");
                }
                if (tpv_richardinputsx && tpv_sourceofcoeffsx.equals("A")) {
                    this.getModel().beginInit();
                    this.getModel().setValue("tpv_richardinput", tpv_richardinputsx);
                    this.getModel().setValue("tpv_sourceofcoeff", tpv_sourceofcoeffsx);
                    this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
                    this.getModel().endInit();
                    this.getView().setEnable(true, "tpv_richardinput");
                    this.getView().setEnable(true, "tpv_countthetable");
                    this.getView().setEnable(true, "tpv_customization");
                    this.getView().setEnable(false, "tpv_coefficient");
                }
                if (!tpv_richardinputsx) {
                    this.getModel().beginInit();
                    this.getModel().setValue("tpv_richardinput", tpv_richardinputsx);
                    this.getModel().setValue("tpv_sourceofcoeff", "NULL");
                    this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
                    this.getModel().endInit();
                    this.getView().setEnable(true, "tpv_richardinput");
                    this.getView().setEnable(false, "tpv_countthetable");
                    this.getView().setEnable(false, "tpv_customization");
                    this.getView().setEnable(false, "tpv_coefficient");
                }
            }
        } else {
            this.getModel().beginInit();
            this.getModel().setValue("tpv_richardinput", false);
            this.getModel().setValue("tpv_sourceofcoeff", "NULL");
            this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
            this.getModel().endInit();
            this.getView().setEnable(false, "tpv_countthetable");
            this.getView().setEnable(false, "tpv_customization");
            this.getView().setEnable(false, "tpv_coefficient");
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection tpv_materialentry = dataEntity.getDynamicObjectCollection("billentry");//商品分录
            if (tpv_materialentry.size() > 0) {
                for (int i = 0; i < tpv_materialentry.size(); i++) {
                    DynamicObject dynamicObject = tpv_materialentry.get(i);
                    Boolean tpv_richardinputsx = dynamicObject.getBoolean("tpv_richardinputsx");//按理计输入
                    if (tpv_richardinputsx) {
//                        this.getView().setEnable(false,i,"qty");
                    }
                }
            }
        }
        this.getView().updateView("tpv_richardinput");
        this.getView().updateView("tpv_sourceofcoeff");
        this.getView().updateView("tpv_coefficient");
    }

    /**
     * 增行时表头系数赋值到分录
     */
    private void outCoefficient(RowDataEntity[] dataentuty) {
        for (RowDataEntity rowdata : dataentuty) {
            int row = rowdata.getRowIndex();
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            String sourceofcoeff = (String) this.getModel().getValue("tpv_sourceofcoeff");//系数来源
            BigDecimal tpv_coefficient = dataEntity.getBigDecimal("tpv_coefficient");
            DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("billentry");//商品明细
            Boolean richardinput = dataEntity.getBoolean("tpv_richardinput");//按理计输入
            this.getModel().setValue("tpv_richardinputsx", richardinput, row);
            this.getModel().setValue("tpv_sourceofcoeffsx", sourceofcoeff, row);
            this.getModel().setValue("tpv_coefficients", tpv_coefficient, row);
            Long mid = 0l;//商品明细物料
            Long oid = 0l;//商品明细产地
            if (richardinput) {
//                this.getView().setEnable(false, row, "qty"); //数量
                this.getView().setEnable(true, row, "tpv_coefficients"); //系数
            } else {
//                this.getView().setEnable(true, row, "qty"); //数量
                this.getView().setEnable(false, row, "tpv_coefficients"); //系数
            }
            if ("A".equals(sourceofcoeff) && materialentry.size() > 0) {
                DynamicObject material = (DynamicObject) this.getModel().getValue("material", row);//物料
                if (material != null) {
                    mid = material.getLong("id");
                }
                String specation = (String) this.getModel().getValue("tpv_specation", row);//规格
                String shader = (String) this.getModel().getValue("tpv_shader", row);//材质
                DynamicObject origin = (DynamicObject) this.getModel().getValue("tpv_origin", row);//产地
                if (origin != null) {
                    oid = origin.getLong("id");
                }
                if (mid != 0 && specation != null && shader != null && oid != 0) {
                    String selectFieid = DynamicObjectUtil.getSelectfields("tpv_rationalization", false);// 获取单据头所有字段标识
                    selectFieid = DynamicObjectUtil.getEntrySelectfields(selectFieid, "tpv_rationalization", "tpv_rationalization_lj",
                            false);// 获取分录所有字段标识
                    DynamicObject[] suitUsers = BusinessDataServiceHelper.load("tpv_rationalization", selectFieid, new QFilter[]{
                            (new QFilter("tpv_rationalization_lj.tpv_material.id", QCP.equals, mid)
                                    .and(new QFilter("tpv_rationalization_lj.tpv_specation", QCP.equals, specation))
                                    .and(new QFilter("tpv_rationalization_lj.tpv_shader", QCP.equals, shader))
                                    .and(new QFilter("tpv_rationalization_lj.tpv_origin.id", QCP.equals, oid)))
                    });
                    if (suitUsers.length > 0) {
                        for (DynamicObject entrty : suitUsers) {
                            DynamicObjectCollection rationalization = entrty.getDynamicObjectCollection("tpv_rationalization_lj");
                            for (DynamicObject entity : rationalization) {
                                Long mater = entity.getLong("tpv_material.id");
                                String speca = entity.getString("tpv_specation");
                                String shade = entity.getString("tpv_shader");
                                Long orig = entity.getLong("tpv_origin.id");
                                if (mater.equals(mid) && speca.equals(specation) && shade.equals(shader) && orig.equals(oid)) {
                                    BigDecimal coefficients = entity.getBigDecimal("tpv_tonnum");
                                    this.getModel().setValue("tpv_coefficients", coefficients, row);
                                    break;
                                } else {
                                    this.getModel().setValue("tpv_coefficients", null, row);
                                }
                            }
                        }
                    } else {
                        this.getModel().setValue("tpv_coefficients", null, row);
                    }
                } else {
                    this.getModel().setValue("tpv_coefficients", null, row);
                }
            }
        }
    }

    /**
     * 表头系数，物料，规格，材质，改变时赋值分录系数
     */
    private void changeCoefficient(ChangeData cd, String keyName) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        String sourceofcoeff = (String) this.getModel().getValue("tpv_sourceofcoeff");//系数来源
        Boolean richardinput = (Boolean) this.getModel().getValue("tpv_richardinput");//按理计输入
        DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("billentry");//商品明细
        EntryGrid entryGrid = this.getControl("billentry");//商品明细
        int selectRows[] = entryGrid.getSelectRows();//获取选中的行号
        if (selectRows.length > 0) {
            List<String> seqFalse = new ArrayList<>();
            List<String> seqtrue = new ArrayList<>(); //按理计表
            List<String> seqtrueA = new ArrayList<>(); //按理计表
            List<String> seqtrueB = new ArrayList<>(); //自定义
            for (int selectRow : selectRows) {
                DynamicObject dynamicObject = this.getModel().getEntryRowEntity("billentry", selectRow);
                boolean tpvRichardinputsx = dynamicObject.getBoolean("tpv_richardinputsx"); //按理计输入
                String tpv_sourceofcoeffsx = dynamicObject.getString("tpv_sourceofcoeffsx"); //系数来源
                if (!tpvRichardinputsx) {
                    seqFalse.add(dynamicObject.getString("seq"));
                }
                if (tpvRichardinputsx) {
                    seqtrue.add(dynamicObject.getString("seq"));
                }
                if ("A".equals(tpv_sourceofcoeffsx)) {
                    seqtrueA.add(dynamicObject.getString("seq"));
                }
                if ("B".equals(tpv_sourceofcoeffsx)) {
                    seqtrueB.add(dynamicObject.getString("seq"));
                }
            }
            if (seqFalse.size() > 0 & seqtrue.size() > 0) {
                this.getView().showTipNotification("选择行存在按理输入行和不按理计输入行！请重新选中行！");
                this.getModel().beginInit();
                this.getModel().setValue(keyName, cd.getOldValue());
                this.getModel().endInit();
                this.getView().updateView(keyName);
                this.getView().setEnable(false, "tpv_richardinput");
                this.getView().setEnable(false, "tpv_countthetable");
                this.getView().setEnable(false, "tpv_customization");
                this.getView().setEnable(false, "tpv_coefficient");
                return;
            } else if (seqtrueA.size() > 0 & seqtrueB.size() > 0) {
                this.getView().showTipNotification("选择行存在按理计表计算和按自定义计算！请重新选中行！");
                this.getModel().beginInit();
                this.getModel().setValue(keyName, cd.getOldValue());
                this.getModel().endInit();
                this.getView().updateView(keyName);
                this.getView().setEnable(false, "tpv_richardinput");
                this.getView().setEnable(false, "tpv_countthetable");
                this.getView().setEnable(false, "tpv_customization");
                this.getView().setEnable(false, "tpv_coefficient");
                return;
            }
            for (int selectRow : selectRows) {
                String tpvSourceofcoeffsx = (String) this.getModel().getValue("tpv_sourceofcoeffsx", selectRow);
                if (richardinput & "tpv_richardinput".equals(keyName) & "NULL".equals(tpvSourceofcoeffsx)) {
                    this.getModel().beginInit();
                    this.getModel().setValue("tpv_sourceofcoeff", "A");
                    this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
                    this.getModel().endInit();
                    this.getModel().setValue("tpv_sourceofcoeffsx", "A", selectRow);
                    this.getModel().setValue("tpv_richardinputsx", richardinput, selectRow);
                    this.getModel().setValue("tpv_coefficients", BigDecimal.ZERO, selectRow);
                    this.getView().setEnable(true, "tpv_countthetable");
                    this.getView().setEnable(true, "tpv_customization");
//                    this.getView().setEnable(false,selectRow,"qty");
                    this.getView().updateView("tpv_sourceofcoeff");
                    this.getView().updateView("tpv_coefficient");
                }
                if (!richardinput & "tpv_richardinput".equals(keyName)) {
                    this.getModel().beginInit();
                    this.getModel().setValue("tpv_sourceofcoeff", "NULL");
                    this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
                    this.getModel().endInit();
                    this.getModel().setValue("tpv_sourceofcoeffsx", null, selectRow);
                    this.getModel().setValue("tpv_richardinputsx", richardinput, selectRow);
                    this.getModel().setValue("tpv_coefficients", BigDecimal.ZERO, selectRow);
                    this.getView().setEnable(false, "tpv_countthetable");
                    this.getView().setEnable(false, "tpv_customization");
//                    this.getView().setEnable(true,selectRow,"qty");
                    this.getView().updateView("tpv_sourceofcoeff");
                    this.getView().updateView("tpv_coefficient");
                }
                if (!"tpv_richardinput".equals(keyName)) {
                    this.getModel().setValue("tpv_sourceofcoeffsx", sourceofcoeff, selectRow);
                    if ("B".equals(sourceofcoeff)) {
                        this.getView().setEnable(true, "tpv_coefficient");
                    }
                    if ("A".equals(sourceofcoeff)) {
                        this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
                        this.getView().setEnable(false, "tpv_coefficient");
                    }
                }
            }
        } else {
            if (richardinput & "tpv_richardinput".equals(keyName)) {
                this.getModel().beginInit();
                this.getModel().setValue("tpv_sourceofcoeff", "A");
                this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
                this.getModel().endInit();
                this.getView().setEnable(true, "tpv_countthetable");
                this.getView().setEnable(true, "tpv_customization");
                this.getView().setEnable(false, "tpv_coefficient");
            }
            if (!richardinput & "tpv_richardinput".equals(keyName)) {
                this.getModel().beginInit();
                this.getModel().setValue("tpv_sourceofcoeff", "NULL");
                this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
                this.getModel().endInit();
                this.getView().setEnable(false, "tpv_countthetable");
                this.getView().setEnable(false, "tpv_customization");
                this.getView().setEnable(false, "tpv_coefficient");
            }
            if ("tpv_sourceofcoeff".equals(keyName)) {
                if ("A".equals(sourceofcoeff)) {
                    this.getModel().beginInit();
                    this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
                    this.getModel().endInit();
                    this.getView().setEnable(false, "tpv_coefficient");
                }
                if ("B".equals(sourceofcoeff)) this.getView().setEnable(true, "tpv_coefficient");
            }
            this.getView().updateView("tpv_sourceofcoeff");
            this.getView().updateView("tpv_coefficient");
        }
        Long mid = 0l;//商品明细物料
        Long oid = 0l;//商品明细产地
        if (selectRows != null && selectRows.length > 0) {
            for (int rowIndex : selectRows) {
                Boolean richardinputs = (Boolean) this.getModel().getValue("tpv_richardinputsx", rowIndex);////按理计输入
                String sourceofcoeffs = (String) this.getModel().getValue("tpv_sourceofcoeffsx", rowIndex);//系数来源
                if (richardinputs) {
//                    this.getView().setEnable(false, rowIndex, "qty"); //数量
                    this.getView().setEnable(false, rowIndex, "tpv_coefficients"); //系数
                    BigDecimal packnum = (BigDecimal) this.getModel().getValue("tpv_packnum", rowIndex);//包装数量
                    BigDecimal coefficients = (BigDecimal) this.getModel().getValue("tpv_coefficients", rowIndex);//系数
                    if (packnum.compareTo(BigDecimal.ZERO) > 0 && coefficients.compareTo(BigDecimal.ZERO) > 0) {
                        this.getModel().setValue("qty", packnum.multiply(coefficients), rowIndex);
                    } else {
                        this.getModel().setValue("qty", BigDecimal.ZERO, rowIndex);
                    }
                } else {
//                    this.getView().setEnable(true, rowIndex, "qty"); //数量
                    this.getView().setEnable(true, rowIndex, "tpv_coefficients"); //系数
                }
                if ("A".equals(sourceofcoeffs) && materialentry.size() > 0) {
                    DynamicObject material = (DynamicObject) this.getModel().getValue("material", rowIndex);//物料
                    if (material != null) {
                        DynamicObject masterid = material.getDynamicObject("masterid");
                        if (YEM.isNotEmpty(masterid)) {
                            mid = material.getLong("id");
                        }
                    }
                    String specation = (String) this.getModel().getValue("tpv_specation", rowIndex);//规格
                    String shader = (String) this.getModel().getValue("tpv_shader", rowIndex);//材质
                    DynamicObject origin = (DynamicObject) this.getModel().getValue("tpv_origin", rowIndex);//产地
                    if (origin != null) {
                        oid = origin.getLong("id");
                    }
                    if (mid != 0 && specation != null && shader != null && oid != 0) {
                        String selectFieid = DynamicObjectUtil.getSelectfields("tpv_rationalization", false);// 获取单据头所有字段标识
                        selectFieid = DynamicObjectUtil.getEntrySelectfields(selectFieid, "tpv_rationalization", "tpv_rationalization_lj",
                                false);// 获取分录所有字段标识
                        DynamicObject[] suitUsers = BusinessDataServiceHelper.load("tpv_rationalization", selectFieid, new QFilter[]{
                                (new QFilter("tpv_rationalization_lj.tpv_material.id", QCP.equals, mid)
                                        .and(new QFilter("tpv_rationalization_lj.tpv_specation", QCP.equals, specation))
                                        .and(new QFilter("tpv_rationalization_lj.tpv_shader", QCP.equals, shader))
                                        .and(new QFilter("tpv_rationalization_lj.tpv_origin.id", QCP.equals, oid)))
                        });
                        if (suitUsers.length > 0) {
                            for (DynamicObject entrty : suitUsers) {
                                DynamicObjectCollection rationalization = entrty.getDynamicObjectCollection("tpv_rationalization_lj");
                                for (DynamicObject entity : rationalization) {
                                    Long mater = entity.getLong("tpv_material.id");
                                    String speca = entity.getString("tpv_specation");
                                    String shade = entity.getString("tpv_shader");
                                    Long orig = entity.getLong("tpv_origin.id");
                                    if (mater.equals(mid) && speca.equals(specation) && shade.equals(shader) && orig.equals(oid)) {
                                        BigDecimal coefficients = entity.getBigDecimal("tpv_tonnum");
                                        this.getModel().setValue("tpv_coefficients", coefficients, rowIndex);
                                        break;
                                    } else {
                                        this.getModel().setValue("tpv_coefficients", null, rowIndex);
                                    }
                                }
                            }
                        } else {
                            this.getModel().setValue("tpv_coefficients", null, rowIndex);
                        }
                    } else {
                        this.getModel().setValue("tpv_coefficients", null, rowIndex);
                    }
                }
            }
        }
    }

    private void changeCoefficientNew(ChangeData cd, String keyName) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        String sourceofcoeff = (String) this.getModel().getValue("tpv_sourceofcoeff");//系数来源
        Boolean richardinput = (Boolean) this.getModel().getValue("tpv_richardinput");//按理计输入
        DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("billentry");//商品明细
        if (richardinput & "tpv_richardinput".equals(keyName)) {
            this.getModel().beginInit();
            this.getModel().setValue("tpv_sourceofcoeff", "NULL");
            this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
            this.getModel().endInit();
            this.getView().setEnable(true, "tpv_countthetable");
            this.getView().setEnable(true, "tpv_customization");
            this.getView().setEnable(false, "tpv_coefficient");
        }
        if (!richardinput & "tpv_richardinput".equals(keyName)) {
            this.getModel().beginInit();
            this.getModel().setValue("tpv_sourceofcoeff", "NULL");
            this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
            this.getModel().endInit();
            this.getView().setEnable(false, "tpv_countthetable");
            this.getView().setEnable(false, "tpv_customization");
            this.getView().setEnable(false, "tpv_coefficient");
        }
        if ("tpv_sourceofcoeff".equals(keyName)) {
            if (!"B".equals(sourceofcoeff)) {
                this.getModel().beginInit();
                this.getModel().setValue("tpv_coefficient", BigDecimal.ZERO);
                this.getModel().endInit();
                this.getView().setEnable(false, "tpv_coefficient");
            }
            if ("B".equals(sourceofcoeff)) this.getView().setEnable(true, "tpv_coefficient");
        }
        if ("tpv_sourceofcoeff".equals(keyName) || "tpv_richardinput".equals(keyName)) {
            this.getView().updateView("tpv_sourceofcoeff");
            this.getView().updateView("tpv_coefficient");
        }
        Long mid = 0l;//商品明细物料
        Long oid = 0l;//商品明细产地
        if (materialentry.size() > 0) {
            for (int i = 0; i < materialentry.size(); i++) {
                int rowIndex = i;
                if (!"tpv_sourceofcoeff".equals(keyName) & !"tpv_richardinput".equals(keyName)) {
                    int index = this.getModel().getEntryCurrentRowIndex("billentry");
                    if (index != rowIndex) {
                        continue;
                    }
                }
                if (richardinput) {
//                    this.getView().setEnable(false, rowIndex, "qty"); //数量
                    this.getView().setEnable(true, rowIndex, "tpv_coefficients"); //系数
                    BigDecimal packnum = (BigDecimal) this.getModel().getValue("tpv_packnum", rowIndex);//包装数量
                    BigDecimal coefficients = (BigDecimal) this.getModel().getValue("tpv_coefficients", rowIndex);//系数
                    if (packnum.compareTo(BigDecimal.ZERO) > 0 && coefficients.compareTo(BigDecimal.ZERO) > 0) {
                        this.getModel().setValue("qty", packnum.multiply(coefficients), rowIndex);
                    } else {
                        this.getModel().setValue("qty", BigDecimal.ZERO, rowIndex);
                    }
                } else {
//                    this.getView().setEnable(true, rowIndex, "qty"); //数量
                    this.getView().setEnable(false, rowIndex, "tpv_coefficients"); //系数
                    this.getModel().setValue("tpv_coefficients", BigDecimal.ZERO, rowIndex);
                    this.getModel().setValue("tpv_richardinputsx", richardinput, rowIndex);
                    this.getModel().setValue("tpv_sourceofcoeffsx", null, rowIndex);
                    continue;
//                    this.getView().updateView("tpv_coefficients", rowIndex);
//                    this.getView().updateView("tpv_sourceofcoeffsx", rowIndex);
                }
                if ("A".equals(sourceofcoeff)) {
                    DynamicObject material = (DynamicObject) this.getModel().getValue("material", rowIndex);//物料
                    if (material != null) {
                        DynamicObject masterid = material.getDynamicObject("masterid");
                        if (YEM.isNotEmpty(masterid)) {
                            mid = material.getLong("id");
                        }
                    }
                    String specation = (String) this.getModel().getValue("tpv_specation", rowIndex);//规格
                    String shader = (String) this.getModel().getValue("tpv_shader", rowIndex);//材质
                    DynamicObject origin = (DynamicObject) this.getModel().getValue("tpv_origin", rowIndex);//产地
                    if (origin != null) {
                        oid = origin.getLong("id");
                    }
                    if (mid != 0 && specation != null && shader != null && oid != 0) {
                        String selectFieid = DynamicObjectUtil.getSelectfields("tpv_rationalization", false);// 获取单据头所有字段标识
                        selectFieid = DynamicObjectUtil.getEntrySelectfields(selectFieid, "tpv_rationalization", "tpv_rationalization_lj",
                                false);// 获取分录所有字段标识
                        DynamicObject[] suitUsers = BusinessDataServiceHelper.load("tpv_rationalization", selectFieid, new QFilter[]{
                                (new QFilter("tpv_rationalization_lj.tpv_material.id", QCP.equals, mid)
                                        .and(new QFilter("tpv_rationalization_lj.tpv_specation", QCP.equals, specation))
                                        .and(new QFilter("tpv_rationalization_lj.tpv_shader", QCP.equals, shader))
                                        .and(new QFilter("tpv_rationalization_lj.tpv_origin.id", QCP.equals, oid)))
                        });
                        if (suitUsers.length > 0) {
                            for (DynamicObject entrty : suitUsers) {
                                DynamicObjectCollection rationalization = entrty.getDynamicObjectCollection("tpv_rationalization_lj");
                                for (DynamicObject entity : rationalization) {
                                    Long mater = entity.getLong("tpv_material.id");
                                    String speca = entity.getString("tpv_specation");
                                    String shade = entity.getString("tpv_shader");
                                    Long orig = entity.getLong("tpv_origin.id");
                                    if (mater.equals(mid) && speca.equals(specation) && shade.equals(shader) && orig.equals(oid)) {
                                        BigDecimal coefficients = entity.getBigDecimal("tpv_tonnum");
                                        this.getModel().setValue("tpv_coefficients", coefficients, rowIndex);
                                        break;
                                    } else {
                                        this.getModel().setValue("tpv_coefficients", null, rowIndex);
                                    }
                                }
                            }
                        } else {
                            this.getModel().setValue("tpv_coefficients", null, rowIndex);
                        }
                    } else {
                        this.getModel().setValue("tpv_coefficients", null, rowIndex);
                    }
                    this.getModel().setValue("tpv_sourceofcoeffsx", sourceofcoeff, rowIndex);
                } else if ("B".equals(sourceofcoeff)) {
                    this.getModel().setValue("tpv_sourceofcoeffsx", sourceofcoeff, rowIndex);
                } else {
                    this.getModel().setValue("tpv_sourceofcoeffsx", null, rowIndex);
                }
            }
        }
    }
}
