package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import com.alibaba.druid.util.StringUtils;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;

import java.math.BigDecimal;

/**
 * 采购合同(货款状态值更新)
 * WangShuGuang
 */
public class PurchaseFreightFormPlugin extends AbstractBillPlugIn {
    @Override
    public void propertyChanged(PropertyChangedArgs e) {//触发时机：表单模型某个字段值改变的时候就会触发此事件//
        String propertyName = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        //监听定量类型,定量方式,合同金额，和付款总金额
        if (propertyName.equals("tpv_pricingtype") || propertyName.equals("tpv_rationtype") || propertyName.equals("tpv_amount") || propertyName.equals("tpv_paymentamount")) {
            paymentState(cd);
        }
    }

    private void paymentState(ChangeData cd) {// 获取单据体
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvDtPurchase = this.getView().getModel().getEntryEntity("tpv_dt_purchase_jhqb");
        //定价类型
        String tpvPricingtype = (String) this.getModel().getValue("tpv_pricingtype");
        //定量方式
        String tpvRationtype = (String) this.getModel().getValue("tpv_rationtype");
        //合同金额
        BigDecimal tpvAmount = (BigDecimal) this.getModel().getValue("tpv_amount");
        //定义付款总金额
        BigDecimal paymentCollet = null;
        if (tpvDtPurchase.size() > 0 && !StringUtils.isEmpty(tpvPricingtype) && !StringUtils.isEmpty(tpvRationtype) && tpvAmount.compareTo(BigDecimal.ZERO) != 0) {
            for (int i = 0; i < tpvDtPurchase.size(); i++) {
                //得到单据体数据
                DynamicObject detailedinformations = tpvDtPurchase.get(i);
                //得到分录付款金额之和
                paymentCollet.add(detailedinformations.getBigDecimal("tpv_paymentamount"));
            }
            //判断分录付款金额是否为空
            if (null != paymentCollet) {
                int judge = paymentCollet.compareTo(tpvAmount);
                //[定价类型]“固定价”且[定量方式]等于“表列数量”:付款总金额大于等于合同金额触发;
                if (tpvPricingtype.equals("A") && tpvRationtype.equals("A") && judge >= 0) {
                    this.getModel().setValue("tpv_paymentstatus", "B");
                }
            }
        }
    }
}
