package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.OperationStatus;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.resource.ResManager;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.datamodel.events.BeforeDeleteRowEventArgs;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.validate.ValidateResultCollection;
import kd.bos.fileservice.FileItem;
import kd.bos.fileservice.FileService;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.isc.util.misc.StringUtil;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.DeleteServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.util.FileNameUtils;
import kd.fi.ap.vo.CloudInvoiceResultVO;
import kd.fi.arapcommon.util.JsonUtils;
import kd.pccs.concs.common.constant.OperationConst;
import tpv.tpv_wm.tpv_dt.java.formplugin.dynamic.InvoiceMatchBillEdit;

import java.io.InputStream;
import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

import static com.itopview.wm.utils.FileUtil.replaceSpeSymbol;
import static kd.isc.iscb.platform.core.util.FileUtil.replaceSpeChar;

/**
 * ClassName: PurchaseInvoiceMatchFromPlugin
 * Description: 采购发票匹配单插件
 * date: 2023/10/27 18:24
 *
 * @author: Guo jiaChen
 */
public class PurchaseInvoiceMatchFromPlugin extends AbstractFormPlugin implements BeforeF7SelectListener {
    private final static String INVOICE_Entry = "tpv_invoiceinfoentry";//发票
    private final static String CONTRACT_Entry = "tpv_continformation";//合同
    private final static String WAREHOUSE_Entry = "tpv_wareiformation";//入库

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_matchinvoicebtn", "tpv_toolbarap2", "tpv_toolbaraps", "tpv_toolbarap1", "tbmain");
        BasedataEdit tpv_operator = (BasedataEdit) this.getView().getControl("tpv_operator");
        tpv_operator.addBeforeF7SelectListener(this);
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        includedAmount();
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        this.setCurrencyAndExchangeTable();
        this.setExchangeRate();
    }


    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String key = e.getProperty().getName();
        switch (key) {
            case "tpv_wmexratetable":
            case "tpv_wmexratedate":
            case "tpv_wmcurrency":
            case "tpv_wmcurrencybase":
                this.setExchangeRate();
                break;
            case "tpv_rkcurmatchqty":
                tpvRkcurmatchqty();
                break;
            case "tpv_invoicetype":
                DynamicObjectCollection tpvInvoiceinfoentry = this.getModel().getEntryEntity("tpv_invoiceinfoentry");
                if (tpvInvoiceinfoentry.size() > 0) { //发票信息分录
                    this.getModel().deleteEntryData("tpv_invoiceinfoentry");
                    this.getView().updateView("tpv_invoiceinfoentry");
                    OperationServiceHelper.executeOperate("save", "tpv_dt_purinvomater",
                            new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
                }
                break;
            case "tpv_company":
                this.getModel().deleteEntryData("tpv_wareiformation");//入库信息分录
                this.getModel().deleteEntryData("tpv_continformation");//合同信息分录
                this.getModel().deleteEntryData("tpv_invoiceinfoentry");//发票信息分录
                break;
        }
    }

    private void tpvRkcurmatchqty() {
        EntryGrid constractMx = this.getControl("tpv_wareiformation"); //入库信息分录
        int[] conRows = constractMx.getSelectRows();
        DynamicObjectCollection tpvWareiformation = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_wareiformation");
        for (int conRow : conRows) {
            BigDecimal tpvQty = tpvWareiformation.get(conRow).getBigDecimal("tpv_qty");//数量
            BigDecimal tpvRkmatchqty = tpvWareiformation.get(conRow).getBigDecimal("tpv_rkmatchqty");//已匹配数量
            BigDecimal tpvRkcurmatchqty = tpvWareiformation.get(conRow).getBigDecimal("tpv_rkcurmatchqty");//本次匹配数量
            if (tpvQty.subtract(tpvRkmatchqty).compareTo(tpvRkcurmatchqty) < 0) {
                this.getModel().setValue("tpv_rkcurmatchqty", null, conRow);
                this.getView().showTipNotification("入库信息第" + (conRow + 1) + "行的本次匹配数量大于【数量】-【已匹配数量】");
            }
        }
    }

    /**
     * 默认本位币、汇率表加载，根据（核算组织本位币设置）
     */
    private void setCurrencyAndExchangeTable() {
        DynamicObject org = (DynamicObject) this.getModel().getValue("org");
        if (org != null) {
            DynamicObject bd_accountingsys_base = BusinessDataServiceHelper.loadSingle("bd_accountingsys_base",
                    "id,basecurrrency,exratetable", new QFilter[]{new QFilter("baseacctorg", QCP.equals, org.getPkValue())});
            if (bd_accountingsys_base != null) {
                DynamicObject basecurrrency = bd_accountingsys_base.getDynamicObject("basecurrrency");
                DynamicObject exratetable = bd_accountingsys_base.getDynamicObject("exratetable");
                this.getModel().setValue("tpv_wmcurrencybase", basecurrrency);
                this.getModel().setValue("tpv_wmexratetable", exratetable);
            }
        }
    }

    /**
     * 汇率获取
     */
    private void setExchangeRate() {
        Object tpv_exratetable = this.getModel().getValue("tpv_wmexratetable");
        Object tpv_currency = this.getModel().getValue("tpv_wmcurrency");
        Object tpv_currencybase = this.getModel().getValue("tpv_wmcurrencybase");
        Date tpv_exratedate = (Date) this.getModel().getValue("tpv_wmexratedate");
        BigDecimal exchangeRateCny = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 1L, tpv_exratedate);
        BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, tpv_currency, 6L, tpv_exratedate);
        BigDecimal exchangeRate = YEM.getExchangeRate(tpv_exratetable, tpv_currency, tpv_currencybase, tpv_exratedate);
        this.getModel().setValue("tpv_wmexchangeratermb", exchangeRateCny);
        this.getModel().setValue("tpv_wmexchangerateusd", exchangeRateUsd);
        this.getModel().setValue("tpv_wmexchangerate", exchangeRate);
    }

    private void includedAmount() {
//        DynamicObject dataEntity = this.getModel().getDataEntity();
//        DynamicObjectCollection tpvContinformation = dataEntity.getDynamicObjectCollection("tpv_continformation");//合同
//        DynamicObjectCollection tpvWareiformation = dataEntity.getDynamicObjectCollection("tpv_wareiformation");//入库
//        BigDecimal tpvRkcurmatchamo=BigDecimal.ZERO;//入库含税
//        BigDecimal tpvCurmatchamo=BigDecimal.ZERO;//合同含税
//        BigDecimal tpvRkcurmatchamonotax=BigDecimal.ZERO;//入库不含税
//        BigDecimal tpvCuramountnotax=BigDecimal.ZERO;//合同不含税
//        BigDecimal tpvRkcurmatchamointax=BigDecimal.ZERO;//入库增值
//        BigDecimal tpvCuramountintax=BigDecimal.ZERO;//合同增值
//        for (DynamicObject obj:tpvContinformation) {
//            BigDecimal tpv_curmatchamo = obj.getBigDecimal("tpv_curmatchamo");
//            BigDecimal tpv_curamountnotax = obj.getBigDecimal("tpv_curamountnotax");
//            BigDecimal tpv_curamountintax = obj.getBigDecimal("tpv_curamountintax");
//            if (YEM.isNotEmpty(tpv_curmatchamo) || YEM.isNotEmpty(tpv_curamountnotax) ||  YEM.isNotEmpty(tpv_curamountintax)) {
//                tpvCuramountnotax=tpvCuramountnotax.add(obj.getBigDecimal("tpv_curamountnotax"));
//                tpvCuramountintax=tpvCuramountintax.add(obj.getBigDecimal("tpv_curamountintax"));
//                tpvCurmatchamo=tpvCurmatchamo.add(obj.getBigDecimal("tpv_curmatchamo"));
//            }
//        }
//        for (DynamicObject obs:tpvWareiformation) {
//            BigDecimal tpv_rkcurmatchamo = obs.getBigDecimal("tpv_rkcurmatchamo");
//            BigDecimal tpv_rkcurmatchamonotax = obs.getBigDecimal("tpv_rkcurmatchamonotax");
//            BigDecimal tpv_rkcurmatchamointax = obs.getBigDecimal("tpv_rkcurmatchamointax");
//            if (YEM.isNotEmpty(tpv_rkcurmatchamo) || YEM.isNotEmpty(tpv_rkcurmatchamonotax) ||  YEM.isNotEmpty(tpv_rkcurmatchamointax)) {
//                tpvRkcurmatchamo=tpvRkcurmatchamo.add(obs.getBigDecimal("tpv_rkcurmatchamo"));
//                tpvRkcurmatchamonotax=tpvRkcurmatchamonotax.add(obs.getBigDecimal("tpv_rkcurmatchamonotax"));
//                tpvRkcurmatchamointax=tpvRkcurmatchamointax.add(obs.getBigDecimal("tpv_rkcurmatchamointax"));
//            }
//        }
//        BigDecimal sumAmt=tpvCurmatchamo.add(tpvRkcurmatchamo);
//        BigDecimal sumNoamt=tpvRkcurmatchamonotax.add(tpvCuramountnotax);
//        BigDecimal sumInAmt=tpvRkcurmatchamointax.add(tpvCuramountintax);
//        if (YEM.isNotEmpty(sumAmt) && YEM.isNotEmpty(sumNoamt) &&  YEM.isNotEmpty(sumInAmt)) {
//            dataEntity.set("tpv_amounttax",sumAmt);//含税
//            dataEntity.set("tpv_amounttax",sumNoamt);//不含税
//            dataEntity.set("tpv_amounttax",sumInAmt);//增值税
//            this.getModel().setValue("tpv_amounttax",sumAmt);
//            this.getModel().setValue("tpv_amountnotax",sumNoamt);
//            this.getModel().setValue("tpv_increasetax",sumInAmt);
//            SaveServiceHelper.update(dataEntity);
//            this.getView().updateView("tpv_dt_purinvomater");
//        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        List<String> notInputs = new ArrayList<>();
        String key = evt.getItemKey();
        OperationResult saveOperate;
        switch (key) {
            case "tpv_grathinvoicebtn":
                notInputs = new ArrayList<>();
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_company");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_invoicedept");
                if (notInputs.size() > 0) {
                    view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
                } else {
                    showInvCollect("ap_invcollect", "invCollectCustom");//采集发票按钮
                }
                break;
            case "tpv_matchinvoicebtn":
                notInputs = new ArrayList<>();
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_company");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_invoicedept");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_invoicetype");
                if (notInputs.size() > 0) {
                    view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
                } else {
//                    saveOperate = OperationServiceHelper.executeOperate("save", "tpv_dt_purinvomater",
//                            new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
                    OperationResult operationResult = this.getView().invokeOperation("save", YEM.getOptionNoMsg());
                    if (operationResult.isSuccess()) {
                        matchInvoice("tpv_dt_matchinvoce", "invoce", "tpv_matchinvoicebtn");//匹配发票按钮
                    }
                }
                break;
            case "tpv_matchcontractbtn":
                notInputs = new ArrayList<>();
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_invoicedept");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_department");
                if (notInputs.size() > 0) {
                    view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
                } else {
                    saveOperate = OperationServiceHelper.executeOperate("save", "tpv_dt_purinvomater",
                            new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
                    if (saveOperate.isSuccess()) {
                        matchInvoice("tpv_dt_matcontract", "contract", "tpv_matchcontractbtn");//匹配合同按钮
                    }
                }
                break;
            case "tpv_matchwarehousebtn":
                notInputs = new ArrayList<>();
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_invoicedept");
                YEM.getNotNull(view, notInputs, dataEntity, "tpv_department");
                if (notInputs.size() > 0) {
                    view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
                } else {
                    saveOperate = OperationServiceHelper.executeOperate("save", "tpv_dt_purinvomater",
                            new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
                    if (saveOperate.isSuccess()) {
                        matchInvoice("tpv_dt_matchwarehouse", "warehouse", "tpv_matchwarehousebtn");//匹配入库按钮
                    }
                }
                break;
            case "tpv_amotaxdivide":
                matchInvoice("tpv_dt_amotaxdivide", "amotaxdivide", "tpv_amotaxdivide");//录入含税金额分摊按钮
                break;
            case "tpv_taxmatpricesbtn":
                priceOrRateClick("tpv_taxmatpricesinfo", "tpv_taxmatpricesbtn", "tpv_wareiformation");
                break;
            case "tpv_taxmatpricesconbtn":
                priceOrRateClick("tpv_taxmatpricesinfo", "tpv_taxmatpricesconbtn", "tpv_continformation");
                break;
            default:
                break;
        }
    }

    private void priceOrRateClick(String formId, String callBack, String entryname) {
        EntryGrid entryGrid = this.getView().getControl(entryname);
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length > 0) {
            FormShowParameter showParameter = new FormShowParameter();
            showParameter.setStatus(OperationStatus.ADDNEW);
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            showParameter.setFormId(formId);
            showParameter.setCloseCallBack(new CloseCallBack(this, callBack));
            this.getView().showForm(showParameter);
        } else {
            this.getView().showTipNotification("请先选中分录行，在进行操作");
        }
    }

    private void setPrice(String tpv_price, Object returnData, String entryname) {
        BigDecimal data = returnData != null ? (BigDecimal) returnData : BigDecimal.ZERO;
        this.getModel().getDataEntity(true);
        // 获取单据体选中行
        EntryGrid entryGrid = this.getView().getControl(entryname);
        int[] selectRows = entryGrid.getSelectRows();
        for (int selectRow : selectRows) {
            this.getModel().setValue(tpv_price, data, selectRow);
            this.getView().updateView(tpv_price, selectRow);
        }
        OperationServiceHelper.executeOperate("save", "tpv_dt_purinvomater",
                new DynamicObject[]{this.getModel().getDataEntity(true)}, YEM.getOptionNoMsg());
    }

    /**
     * @param :
     * @return void
     * @author: chen
     * @date: 2023/12/18 10:55
     * @description:
     */
    private void showInvCollect(String name, String actionID) {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        long orgPk = RequestContext.get().getOrgId();
        FormShowParameter parameter = new FormShowParameter();
        Map<String, Object> map = new HashMap<>();
        DynamicObject tpvCompany = dataEntity.getDynamicObject("tpv_company");
        map.put("tpv_company", tpvCompany);
        map.put("fp", "cg");
        parameter.setCustomParams(map);
        parameter.getOpenStyle().setShowType(ShowType.Modal);
        parameter.getCustomParams().put("orgPk", YEM.isNotEmpty(tpvCompany) ? tpvCompany.getLong("id") : 0l);
        parameter.setFormId(name);
        parameter.setCloseCallBack(new CloseCallBack(this, actionID));
        this.getView().showForm(parameter);
    }

    /**
     * @param name:
     * @param actionID:
     * @param controlName:
     * @return void
     * @author: chen
     * @date: 2023/11/19 16:41
     * @description: 匹配发票信息弹框 ,弹框后，已匹配金额 = 已匹配金额-本次匹配金额 ，确认后，再加起来：已匹配金额-本次匹配金额
     */
    private void matchInvoice(String name, String actionID, String controlName) {
        //创建动态表达页面对象
        FormShowParameter showParameter = new FormShowParameter();
        //设置页面ID
        showParameter.setFormId(name);
        //状态
        showParameter.setStatus(OperationStatus.ADDNEW);
        //传参
        showParameter.setCustomParams(setInfo(controlName));
        //设置回调
        showParameter.setCloseCallBack(new CloseCallBack(this, actionID));
        // 设置弹出页面打开方式
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        // 打开动态表单
        this.getView().showForm(showParameter);

    }

    /**
     * @param controlName:
     * @return Map<String, Object>
     * @author: chen
     * @date: 2023/11/19 16:42
     * @description: 动态表单传参
     */
    private Map<String, Object> setInfo(String controlName) {
        HashMap<String, Object> map = new HashMap<>();
        if ("tpv_matchinvoicebtn".equals(controlName) || "tpv_matchcontractbtn".equals(controlName)
                || "tpv_matchwarehousebtn".equals(controlName)) {
            DynamicObjectCollection entity = this.getModel().getEntryEntity(INVOICE_Entry);
            String sourceId = "";
            for (DynamicObject object : entity) {
                sourceId += object.getString("tpv_sourceid") + ",";
            }
            map.put("sourceID", sourceId);
            map.put("supplier", this.getModel().getValue("tpv_invoicedept"));
            if ("tpv_matchinvoicebtn".equals(controlName)) {
                DynamicObjectCollection invoiceinfoentry = this.getModel().getEntryEntity(INVOICE_Entry);
                map.put("invoiceEntry", invoiceinfoentry);
            }
        }
        if ("tpv_amotaxdivide".equals(controlName)) {
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            BigDecimal tpvTaxrate = BigDecimal.ZERO;
            BigDecimal tpvTaxamount = BigDecimal.ZERO;
            BigDecimal tpvAmounttax = dataEntity.getBigDecimal("tpv_amounttax");
            BigDecimal tpvAmountnotax = dataEntity.getBigDecimal("tpv_amountnotax");
            BigDecimal tpvIncreasetax = dataEntity.getBigDecimal("tpv_increasetax");
            map.put("tpv_amounttax", tpvAmounttax); //(暂时作废)
            map.put("tpv_amountnotax", tpvAmountnotax); //(暂时作废)
            map.put("tpv_increasetax", tpvIncreasetax); //(暂时作废)
            DynamicObject tpvInvoicetype = dataEntity.getDynamicObject("tpv_invoicetype");
            boolean flag = true;
            if (YEM.isNotEmpty(tpvInvoicetype)) {
                String number = tpvInvoicetype.getString("number");
                //当【发票类型】= 增值税电子普通发票 / 增值税电子普通发票（通行费）/  数电票（普通发票）/  增值税普通发票 / 增值税普通发票（卷票）时
                if ("1".equals(number) || "15".equals(number) || "26".equals(number) || "3".equals(number) || "5".equals(number)) {
                    flag = false;
                }
            }
            DynamicObjectCollection dynamicObjects = dataEntity.getDynamicObjectCollection("tpv_invoiceinfoentry");
            if (flag) {
                for (DynamicObject dynamicObject : dynamicObjects) {
                    tpvTaxrate = dynamicObject.getBigDecimal("tpv_taxrate");
                    break;
                }
            }
            for (DynamicObject dynamicObject : dynamicObjects) {
                tpvTaxamount = tpvTaxamount.add(dynamicObject.getBigDecimal("tpv_curmatchamotax").setScale(2, BigDecimal.ROUND_HALF_UP));
            }
            map.put("tpv_dytaxrates", tpvTaxrate);
            map.put("tpv_taxamount", tpvTaxamount);
        }
        return map;
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
        String actionId = closedCallBackEvent.getActionId();
        if ("amotaxdivide".equals(actionId) && null != closedCallBackEvent.getReturnData()) {
            Object returnData = closedCallBackEvent.getReturnData();
            Map<String, Object> value = (Map<String, Object>) returnData;
            setInwardInfoc(value);
        } else if ("tpv_taxmatpricesconbtn".equals(actionId) && null != closedCallBackEvent.getReturnData()) {
            setPrice("tpv_taxmatpricecon", closedCallBackEvent.getReturnData(), "tpv_continformation");
        } else if ("tpv_taxmatpricesbtn".equals(actionId) && null != closedCallBackEvent.getReturnData()) {
            setPrice("tpv_taxmatprice", closedCallBackEvent.getReturnData(), "tpv_wareiformation");
        } else {
            if ("invCollectCustom".equals(actionId)) {
                Object returnData = closedCallBackEvent.getReturnData();
                invCollectCustom(returnData);
            } else {
                if (closedCallBackEvent.getReturnData() instanceof HashMap) {
                    HashMap<String, DynamicObjectCollection> returnData = (HashMap<String, DynamicObjectCollection>) closedCallBackEvent.getReturnData();
                    if (returnData != null && returnData.get("cols").size() > 0) {
                        switch (actionId) {
                            case "invoce":
                                invoice(returnData);
                                break;
                            case "contract":
                                contract(returnData);
                                break;
                            case "warehouse":
                                warehouse(returnData);
                                break;
                            default:
                                break;
                        }
                    }
                }
            }
        }
        String action = closedCallBackEvent.getActionId();
        switch (action) {
            case "tpv_operator":
                operatorCallBack(closedCallBackEvent);
                break;
            default:
                break;
        }
    }

    private void operatorCallBack(ClosedCallBackEvent e) {
        IDataModel model = this.getModel();
        ListSelectedRowCollection selectedRows = (ListSelectedRowCollection) e.getReturnData();
        if (selectedRows != null && selectedRows.size() > 0) {
            ListSelectedRow selectedRow = selectedRows.get(0);
            long userId = (long) selectedRow.getPrimaryKeyValue();//人员id
            long userEntryId = (long) selectedRow.getEntryPrimaryKeyValue();//部门分录id
            DynamicObject tpvDepartment = (DynamicObject) this.getModel().getValue("tpv_department");
            model.beginInit();
            model.setValue("tpv_operator", userId);
            DynamicObjectCollection entry = getUserDepts(userId);
            for (DynamicObject row : entry) {
                if (userEntryId == row.getLong("id")) {
                    if (tpvDepartment != row.get("org")) {
                        this.getModel().deleteEntryData("tpv_wareiformation");//入库信息分录
                        this.getModel().deleteEntryData("tpv_continformation");//合同信息分录
                    } else if (!(tpvDepartment.getLong("id") == (long) row.get("org"))) {
                        this.getModel().deleteEntryData("tpv_wareiformation");//入库信息分录
                        this.getModel().deleteEntryData("tpv_continformation");//合同信息分录
                    }
                    this.getView().updateView("tpv_wareiformation");
                    this.getView().updateView("tpv_continformation");
                    model.setValue("tpv_department", row.get("org"));
                }
            }
            model.endInit();
            this.getView().updateView("tpv_operator");
            this.getView().updateView("tpv_department");

        }
    }

    private static DynamicObjectCollection getUserDepts(long userId) {
        QFilter qFilter = new QFilter("user", QCP.equals, userId);
//        qFilter.and(new QFilter("org.orgpattern.number", QCP.equals, "Orgform06"));
        return QueryServiceHelper.query("bos_userposition", "id,org", qFilter.toArray());
    }

    private void setInwardInfoc(Map<String, Object> value) {
        if (value.size() > 0) {
            BigDecimal tpvAmounttax = BigDecimalUtils.toBigDecimal(value.get("tpv_amounttax"));
            BigDecimal tpvAmountnotax = BigDecimalUtils.toBigDecimal(value.get("tpv_amountnotax"));
            BigDecimal tpvIncreasetax = BigDecimalUtils.toBigDecimal(value.get("tpv_increasetax"));
            this.getModel().setValue("tpv_amounttax", tpvAmounttax);
            this.getModel().setValue("tpv_amountnotax", tpvAmountnotax);
            this.getModel().setValue("tpv_increasetax", tpvIncreasetax);
            this.getView().updateView("tpv_amounttax");
            this.getView().updateView("tpv_amountnotax");
            this.getView().updateView("tpv_increasetax");
            amoTaxDivide();
            DynamicObject dataEntity = this.getView().getModel().getDataEntity(true);
            OperationServiceHelper.executeOperate("save", "tpv_dt_purinvomater",
                    new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
        }
    }

    /**
     * @param returnData:
     * @return void
     * @author: chen
     * @date: 2023/12/18 10:59
     * @description: 采集发票功能
     */
    private void invCollectCustom(Object returnData) {
        IFormView view = this.getView();
        List<String> tipNotification = new ArrayList<>();
        CloudInvoiceResultVO resultVO = (CloudInvoiceResultVO) JsonUtils.jsonToObj(String.valueOf(returnData), CloudInvoiceResultVO.class);
        if (resultVO != null && !resultVO.isEmpty()) {
            List<String> hasExistInvoices = resultVO.getHasExistInvoices();
            if (hasExistInvoices.isEmpty()) {
                List<String> hasRemoveSerialNos = resultVO.getHasRemoveSerialNos();
                DynamicObjectCollection invoices = QueryServiceHelper.query("ap_invoice", "id,billno,invoicecode,invoiceno,serialno", new QFilter[]{new QFilter("serialno", "in", hasRemoveSerialNos)});
                List<Long> id = invoices.stream().map(item -> item.getLong("id")).collect(Collectors.toList());
                OperationResult submitResult = OperationServiceHelper.executeOperate(OperationConst.SUBMIT, "ap_invoice", id.toArray(), OperateOption.create());
                OperationResult auditResult = OperationServiceHelper.executeOperate(OperationConst.AUDIT, "ap_invoice", id.toArray(), OperateOption.create());
                if (submitResult != null && !submitResult.isSuccess()) {
                    tipNotification.add("收票单提交失败," + YEM.getOpMsg(submitResult) + "\n");
                }
                if (auditResult != null && !auditResult.isSuccess()) {
                    tipNotification.add("收票单审核失败," + YEM.getOpMsg(auditResult) + "\n");
                }
                ValidateResultCollection validateResult = submitResult.getValidateResult();
                HashSet<Object> errorPkIds = validateResult.getErrorPkIds();
                List<String> stringList = setInvoiceDetail(hasRemoveSerialNos);//分录赋值
                if (!stringList.isEmpty()) {
                    tipNotification.add("发票号:" + StringUtil.join(stringList, ",") + " 已存在,不允许重复添加!");
                }
                invoices.stream()
                        .filter(item -> hasExistInvoices.contains(item.getString("serialno")))
                        .forEach(item -> tipNotification.add(String.format(ResManager.loadKDString("发票号码%1$s,发票代码%2$s：发票已存在，不允许采集。", "InvoiceList4Cloud_2"
                                , "fi-ap-formplugin", new Object[0]), item.getString("invoiceno"), item.getString("invoicecode"))));
                if (!tipNotification.isEmpty()) {
                    view.showTipNotification(tipNotification.toString());
                }
            }
        }
    }

    /**
     * @param hasRemoveSerialNos:
     * @return void
     * @author: chen
     * @date: 2023/12/18 17:24
     * @description: 采集发票后向分录赋值
     */
    private List<String> setInvoiceDetail(List<String> hasRemoveSerialNos) {
        //获取分录已经存在的数据
        DynamicObjectCollection collection = this.getModel().getEntryEntity(INVOICE_Entry);
        Set<String> sourceID = collection.stream().map(col -> col.getString("tpv_sourceid")).collect(Collectors.toSet());
        List<String> invoiceNos = new ArrayList<>();

        IDataModel model = this.getModel();
        ArrayList<QFilter> filters = new ArrayList<>();
        filters.add(new QFilter("billstatus", QCP.equals, "C"));//已审核
        filters.add(new QFilter("serialno", QCP.in, hasRemoveSerialNos));//发票流水号
        DataSet queryDataSet = ORM.create().queryDataSet(this.getClass().getName(), "ap_invoice",
                "id,billno,billstatus,invoiceno,receivablessupp.id,entry.quantity,issuedate,pricetaxtotal,amount,tax"
                , filters.toArray(new QFilter[0]));
        DataSet select = queryDataSet.select("id", "billno", "invoiceno", "receivablessupp.id supplier", "entry.quantity quantity", "issuedate", "pricetaxtotal", "amount", "tax");
        DataSet executeSql = select.executeSql("SELECT billno,id, invoiceno, supplier, issuedate,pricetaxtotal, amount, tax, sum(quantity) AS sumqty " +
                "GROUP BY billno,invoiceno, supplier, issuedate, pricetaxtotal, amount, tax,id");
        HashMap<String, HashMap<String, BigDecimal>> dataMap = InvoiceMatchBillEdit.getMatchedQty(this.getClass().getName(), "");//获取已匹配数量等
        for (Row row : executeSql) {
            Long pkid = row.getLong("id");//来源单id
            String invoiceno = row.getString("invoiceno");
            if (sourceID.contains(pkid)) {
                invoiceNos.add(invoiceno);
                continue;
            }
            Date issuedate = row.getDate("issuedate");
            BigDecimal taxRate = InvoiceMatchBillEdit.getTaxRate(this.getClass().getName(), invoiceno);
            BigDecimal sumqty = row.getBigDecimal("sumqty");
            BigDecimal pricetaxtotal = row.getBigDecimal("pricetaxtotal");//含税金额
            BigDecimal amount = row.getBigDecimal("amount");//不含税金额
            BigDecimal tax = row.getBigDecimal("tax");//增值税额

            BigDecimal matchedQty = BigDecimal.ZERO;
            BigDecimal matchamoalltax = BigDecimal.ZERO;
            BigDecimal matchamonoalltax = BigDecimal.ZERO;
            BigDecimal matchamoinalltax = BigDecimal.ZERO;
            if (dataMap.get(pkid.toString()) != null) {
                HashMap<String, BigDecimal> map = dataMap.get(pkid.toString());
                matchedQty = map.get("curmactchallqty");//已匹配数量
                matchamoalltax = map.get("curmatchamoalltax");//已匹配金额(含税)
                matchamonoalltax = map.get("curmatchamonoalltax");//已匹配金额(不含税)
                matchamoinalltax = map.get("curmatchamoinalltax");//已匹配金额(增值税额)
                BigDecimal subtract = sumqty.subtract(matchedQty);
            }
            int i = model.createNewEntryRow("tpv_invoiceinfoentry");
            model.setValue("tpv_invocenum", invoiceno, i);//发票号
            model.setValue("tpv_invoicsupplier", toLong(row.getLong("supplier")), i);//供应商
            model.setValue("tpv_invoicqty", sumqty, i);//数量
            model.setValue("tpv_invoicmate", matchedQty, i);//已匹配数量
            model.setValue("tpv_unmatchqty", sumqty.subtract(matchedQty), i);//未匹配数量
//            model.setValue("tpv_issuedate", issuedate, i);//开票日期
            model.setValue("tpv_taxamount", pricetaxtotal, i);//含税金额
            model.setValue("tpv_notaxamount", amount, i);//不含税金额
            model.setValue("tpv_amountincrease", tax, i);//增值税额
            model.setValue("tpv_matchamotax", matchamoalltax, i);//已匹配金额(含税)
            model.setValue("tpv_matchamonotax", matchamonoalltax, i);//已匹配金额(不含税)
            model.setValue("tpv_matchamointax", matchamoinalltax, i);//已匹配金额(增值税)
            model.setValue("tpv_unmatchamotax", pricetaxtotal.subtract(matchamoalltax), i);//未匹配金额(含税)
            model.setValue("tpv_numatchamonotax", amount.subtract(matchamonoalltax), i);//未匹配金额(不含税)
            model.setValue("tpv_unmatchamointax", tax.subtract(matchamoinalltax), i);//未匹配金额(增值税额)
            model.setValue("tpv_taxrate", taxRate, i);//税率
            model.setValue("tpv_sourceid", pkid, i);//来源id
        }
        return invoiceNos;
    }

    /**
     * @param :
     * @return void
     * @author: chen
     * @date: 2023/11/19 16:42
     * @description: 含税金额分摊
     */
    private void amoTaxDivide() {
        IDataModel model = this.getModel();
        BigDecimal amountTax = (BigDecimal) model.getValue("tpv_amounttax");//含税
        if (amountTax == null) {
            amountTax = new BigDecimal(0);
        }
//        BigDecimal amountnotax = (BigDecimal) model.getValue("tpv_amountnotax");//不含税
//        BigDecimal increasetax = (BigDecimal) model.getValue("tpv_increasetax");//增值税
        BigDecimal consum = (BigDecimal) model.getValue("tpv_consum");//合同分录数量汇总
        BigDecimal waresum = (BigDecimal) model.getValue("tpv_waresum");//入库分录数量汇总
        BigDecimal allNums = consum.add(waresum);
        if (allNums.compareTo(new BigDecimal("0")) == 0) {
            return;
        }
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObject tpvInvoicetype = dataEntity.getDynamicObject("tpv_invoicetype");
        boolean flag = false;
        if (YEM.isNotEmpty(tpvInvoicetype)) {
            String number = tpvInvoicetype.getString("number");
            //当【发票类型】= 增值税电子普通发票 / 增值税电子普通发票（通行费）/  数电票（普通发票）/  增值税普通发票 / 增值税普通发票（卷票）时
            if ("1".equals(number) || "15".equals(number) || "26".equals(number) || "3".equals(number) || "5".equals(number)) {
                flag = true;
            }
        }
        DynamicObjectCollection contractEntry = model.getEntryEntity(CONTRACT_Entry);
        DynamicObjectCollection warehouseEntry = model.getEntryEntity(WAREHOUSE_Entry);
        if (warehouseEntry.size() == 0 && contractEntry.size() == 0) {
            return;
        }
        if (warehouseEntry.size() == 0) {
            //在入库处理尾差
            for (DynamicObject object : contractEntry) {
                BigDecimal tpvRate = BigDecimalUtils.toBigDecimal(object.getBigDecimal("tpv_httaxrate"));
                if (flag) {
                    tpvRate = BigDecimal.ZERO;
                    object.set("tpv_httaxrate", tpvRate); //税率
                }
                BigDecimal curmatchqty = object.getBigDecimal("tpv_curmatchqty");//本次匹配数量
                BigDecimal prop = curmatchqty.divide(allNums, 10, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvTaxmatamt = amountTax.multiply(prop).setScale(2, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvNoTaxmatamt = BigDecimal.ZERO;
                BigDecimal tpvInTaxmatamt = BigDecimal.ZERO;
                tpvInTaxmatamt = new BigDecimal("1").add(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvTaxmatamt.divide(tpvInTaxmatamt, 11,BigDecimal.ROUND_HALF_UP);
                tpvInTaxmatamt = tpvInTaxmatamt.multiply(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvInTaxmatamt.setScale(2,BigDecimal.ROUND_HALF_UP);
                tpvNoTaxmatamt = tpvTaxmatamt.subtract(tpvInTaxmatamt.setScale(2, BigDecimal.ROUND_HALF_UP));

                object.set("tpv_curmatchamo", tpvTaxmatamt);//含税
                object.set("tpv_curamountnotax", tpvNoTaxmatamt);//不含税
                object.set("tpv_curamountintax", tpvInTaxmatamt); //增值税

                BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                object.set("tpv_taxmatpricecon", tpvTaxmatprice);//单价(含税)
            }
            this.getView().updateView(CONTRACT_Entry);
            handleAmount(true, contractEntry.size() - 1, "ht");
        } else if (contractEntry.size() == 0) {
            for (DynamicObject object : warehouseEntry) {
                BigDecimal tpvRate = BigDecimalUtils.toBigDecimal(object.getBigDecimal("tpv_rktaxrate"));
                if (flag) {
                    tpvRate = BigDecimal.ZERO;
                    object.set("tpv_rktaxrate", tpvRate); //税率
                }
                BigDecimal curmatchqty = object.getBigDecimal("tpv_rkcurmatchqty");//本次匹配数量
                BigDecimal prop = curmatchqty.divide(allNums, 10, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvTaxmatamt = amountTax.multiply(prop).setScale(2, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvNoTaxmatamt = BigDecimal.ZERO;
                BigDecimal tpvInTaxmatamt = BigDecimal.ZERO;
                tpvInTaxmatamt = new BigDecimal("1").add(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvTaxmatamt.divide(tpvInTaxmatamt, 11,BigDecimal.ROUND_HALF_UP);
                tpvInTaxmatamt = tpvInTaxmatamt.multiply(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvInTaxmatamt.setScale(2,BigDecimal.ROUND_HALF_UP);
                tpvNoTaxmatamt = tpvTaxmatamt.subtract(tpvInTaxmatamt.setScale(2, BigDecimal.ROUND_HALF_UP));

                object.set("tpv_rkcurmatchamo", tpvTaxmatamt);//含税
                object.set("tpv_rkcurmatchamonotax", tpvNoTaxmatamt);//不含税
                object.set("tpv_rkcurmatchamointax", tpvInTaxmatamt); //增值税

                BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                object.set("tpv_taxmatprice", tpvTaxmatprice);//单价(含税)
            }
            this.getView().updateView(WAREHOUSE_Entry);
            handleAmount(true, warehouseEntry.size() - 1, "rk");
        } else {
            //在合同处理尾差
            for (DynamicObject object : contractEntry) {
                BigDecimal tpvRate = BigDecimalUtils.toBigDecimal(object.getBigDecimal("tpv_httaxrate"));
                if (flag) {
                    tpvRate = BigDecimal.ZERO;
                    object.set("tpv_httaxrate", tpvRate); //税率
                }
                BigDecimal curmatchqty = object.getBigDecimal("tpv_curmatchqty");//本次匹配数量
                BigDecimal prop = curmatchqty.divide(allNums, 10, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvTaxmatamt = amountTax.multiply(prop).setScale(2, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvNoTaxmatamt = BigDecimal.ZERO;
                BigDecimal tpvInTaxmatamt = BigDecimal.ZERO;
                tpvInTaxmatamt = new BigDecimal("1").add(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvTaxmatamt.divide(tpvInTaxmatamt, 11,BigDecimal.ROUND_HALF_UP);
                tpvInTaxmatamt = tpvInTaxmatamt.multiply(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvInTaxmatamt.setScale(2,BigDecimal.ROUND_HALF_UP);
                tpvNoTaxmatamt = tpvTaxmatamt.subtract(tpvInTaxmatamt.setScale(2, BigDecimal.ROUND_HALF_UP));

                object.set("tpv_curmatchamo", tpvTaxmatamt);//含税
                object.set("tpv_curamountnotax", tpvNoTaxmatamt);//不含税
                object.set("tpv_curamountintax", tpvInTaxmatamt); //增值税
            }
            this.getView().updateView(CONTRACT_Entry);
            for (DynamicObject object : warehouseEntry) {
                BigDecimal tpvRate = BigDecimalUtils.toBigDecimal(object.getBigDecimal("tpv_rktaxrate"));
                if (flag) {
                    tpvRate = BigDecimal.ZERO;
                    object.set("tpv_rktaxrate", tpvRate); //税率
                }
                BigDecimal curmatchqty = object.getBigDecimal("tpv_rkcurmatchqty");//本次匹配数量
                BigDecimal prop = curmatchqty.divide(allNums, 10, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvTaxmatamt = amountTax.multiply(prop).setScale(2, BigDecimal.ROUND_HALF_UP);
                BigDecimal tpvNoTaxmatamt = BigDecimal.ZERO;
                BigDecimal tpvInTaxmatamt = BigDecimal.ZERO;
                tpvInTaxmatamt = new BigDecimal("1").add(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvTaxmatamt.divide(tpvInTaxmatamt, 11,BigDecimal.ROUND_HALF_UP);
                tpvInTaxmatamt = tpvInTaxmatamt.multiply(tpvRate.divide(new BigDecimal("100")));
                tpvInTaxmatamt = tpvInTaxmatamt.setScale(2,BigDecimal.ROUND_HALF_UP);
                tpvNoTaxmatamt = tpvTaxmatamt.subtract(tpvInTaxmatamt.setScale(2, BigDecimal.ROUND_HALF_UP));

                object.set("tpv_rkcurmatchamo", tpvTaxmatamt);//含税
                object.set("tpv_rkcurmatchamonotax", tpvNoTaxmatamt);//不含税
                object.set("tpv_rkcurmatchamointax", tpvInTaxmatamt); //增值税

                BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                object.set("tpv_taxmatprice", tpvTaxmatprice);//单价(含税)
            }
            this.getView().updateView(WAREHOUSE_Entry);
            handleAmount(false, contractEntry.size() - 1, "");
        }
    }

    /**
     * @param b:
     * @param i1:
     * @return void
     * @author: chen
     * @date: 2023/11/18 19:17
     * @description: 处理尾差
     */
    private void handleAmount(boolean b, int i1, String entry) {

        IDataModel model = this.getModel();
        BigDecimal amounttax = (BigDecimal) model.getValue("tpv_amounttax");
        if (amounttax == null) {
            amounttax = new BigDecimal(0);
        }
        BigDecimal amountnotax = (BigDecimal) model.getValue("tpv_amountnotax");
        BigDecimal amountintax = (BigDecimal) model.getValue("tpv_increasetax");
        if (b & "ht".equals(entry)) {
            BigDecimal contaxsum = BigDecimal.ZERO;
            BigDecimal connotaxsum = BigDecimal.ZERO;
            BigDecimal conintaxsum = BigDecimal.ZERO;
            DynamicObjectCollection conCols = model.getEntryEntity(CONTRACT_Entry);
            for (int i = 0; i < conCols.size(); i++) {
                DynamicObject object = conCols.get(i);
                if (i == conCols.size() - 1) {
                    contaxsum = contaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    connotaxsum = connotaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    conintaxsum = conintaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    object.set("tpv_curmatchamo", amounttax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(contaxsum));
                    object.set("tpv_curamountnotax", amountnotax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(connotaxsum));
                    object.set("tpv_curamountintax", amountintax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(conintaxsum));
                    BigDecimal curmatchqty = object.getBigDecimal("tpv_curmatchqty");//数量
                    BigDecimal tpvTaxmatamt = object.getBigDecimal("tpv_curmatchamo");
                    BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                    object.set("tpv_taxmatpricecon", tpvTaxmatprice);//单价(含税)
                }
                contaxsum = contaxsum.add(object.getBigDecimal("tpv_curmatchamo"));
                connotaxsum = connotaxsum.add(object.getBigDecimal("tpv_curamountnotax"));
                conintaxsum = conintaxsum.add(object.getBigDecimal("tpv_curamountintax"));
            }
            this.getView().updateView(CONTRACT_Entry);
        } else if (b & "rk".equals(entry)) {
            BigDecimal rktaxsum = BigDecimal.ZERO;
            BigDecimal rknotaxsum = BigDecimal.ZERO;
            BigDecimal rkintaxsum = BigDecimal.ZERO;
            DynamicObjectCollection wareCols = model.getEntryEntity(WAREHOUSE_Entry);
            for (int i = 0; i < wareCols.size(); i++) {
                DynamicObject object = wareCols.get(i);
                if (i == wareCols.size() - 1) {
                    rktaxsum = rktaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    rknotaxsum = rknotaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    rkintaxsum = rkintaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    object.set("tpv_rkcurmatchamo", amounttax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(rktaxsum));
                    object.set("tpv_rkcurmatchamonotax", amountnotax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(rknotaxsum));
                    object.set("tpv_rkcurmatchamointax", amountintax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(rkintaxsum));
                    BigDecimal curmatchqty = object.getBigDecimal("tpv_rkcurmatchqty");//数量
                    BigDecimal tpvTaxmatamt = object.getBigDecimal("tpv_rkcurmatchamo");
                    BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                    object.set("tpv_taxmatprice", tpvTaxmatprice);//单价(含税)
                }
                rktaxsum = rktaxsum.add(object.getBigDecimal("tpv_rkcurmatchamo"));
                rknotaxsum = rknotaxsum.add(object.getBigDecimal("tpv_rkcurmatchamonotax"));
                rkintaxsum = rkintaxsum.add(object.getBigDecimal("tpv_rkcurmatchamointax"));
            }
            this.getView().updateView(WAREHOUSE_Entry);
        } else {
            BigDecimal contaxsum = BigDecimal.ZERO;
            BigDecimal connotaxsum = BigDecimal.ZERO;
            BigDecimal conintaxsum = BigDecimal.ZERO;
            DynamicObjectCollection conCols = model.getEntryEntity(CONTRACT_Entry);
            DynamicObjectCollection wareCols = model.getEntryEntity(WAREHOUSE_Entry);
            for (int i = 0; i < wareCols.size(); i++) {
                DynamicObject object = wareCols.get(i);
                contaxsum = contaxsum.add(object.getBigDecimal("tpv_rkcurmatchamo"));
                connotaxsum = connotaxsum.add(object.getBigDecimal("tpv_rkcurmatchamonotax"));
                conintaxsum = conintaxsum.add(object.getBigDecimal("tpv_rkcurmatchamointax"));
            }
            for (int i = 0; i < conCols.size(); i++) {
                DynamicObject object = conCols.get(i);
                if (i == conCols.size() - 1) {
                    contaxsum = contaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    connotaxsum = connotaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    conintaxsum = conintaxsum.setScale(2, BigDecimal.ROUND_HALF_UP);
                    object.set("tpv_curmatchamo", amounttax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(contaxsum));
                    object.set("tpv_curamountnotax", amountnotax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(connotaxsum));
                    object.set("tpv_curamountintax", amountintax.setScale(2, BigDecimal.ROUND_HALF_UP).subtract(conintaxsum));
                    BigDecimal curmatchqty = object.getBigDecimal("tpv_curmatchqty");//数量
                    BigDecimal tpvTaxmatamt = object.getBigDecimal("tpv_curmatchamo");
                    BigDecimal tpvTaxmatprice = tpvTaxmatamt.divide(curmatchqty, 11, BigDecimal.ROUND_HALF_UP);
                    object.set("tpv_taxmatpricecon", tpvTaxmatprice);//单价(含税)
                }
                contaxsum = contaxsum.add(object.getBigDecimal("tpv_curmatchamo"));
                connotaxsum = connotaxsum.add(object.getBigDecimal("tpv_curamountnotax"));
                conintaxsum = conintaxsum.add(object.getBigDecimal("tpv_curamountintax"));
            }
            this.getView().updateView(CONTRACT_Entry);
        }
    }

    @Override
    public void beforeDeleteRow(BeforeDeleteRowEventArgs e) {
        super.beforeDeleteRow(e);
        String name = e.getEntryProp().getName();
        switch (name){
            case"tpv_invoiceinfoentry":
                EntryGrid control = this.getControl("tpv_invoiceinfoentry");
                int[] selectRows = control.getSelectRows();
                DynamicObjectCollection tpvInvoiceinfoentry = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_invoiceinfoentry");
                for (int selectRow : selectRows) {
                    String tpvSourceid = tpvInvoiceinfoentry.get(selectRow).getString("tpv_sourceid");
                    DeleteServiceHelper.delete("bos_attachment",new QFilter[]{new QFilter("fentryinterid","=",tpvSourceid)});
                }
//                DynamicObject dataEntity = this.getModel().getDataEntity(true);
//                OperationServiceHelper.executeOperate("save", "tpv_dt_purinvomater",
//                        new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
                OperationResult operationResult = this.getView().invokeOperation("save", YEM.getOptionNoMsg());
                this.getView().invokeOperation("refresh");
                break;
        }
    }

    /**
     * @param returnData:
     * @return void
     * @author: chen
     * @date: 2023/11/19 16:44
     * @description: 入库信息填充
     */
    private void warehouse(HashMap<String, DynamicObjectCollection> returnData) {
        DynamicObjectCollection collection = this.getModel().getEntryEntity(WAREHOUSE_Entry);
        DataEntityPropertyCollection properties = collection.getDynamicObjectType().getProperties();
        DynamicObjectCollection collections = returnData.get("cols");
        DataEntityPropertyCollection selectedProperties = collections.getDynamicObjectType().getProperties();
        IdentityHashMap<String, Integer> rkMap = new IdentityHashMap<>();

        for (int i = 0; i < collections.size(); i++) {
            DynamicObject row = collections.get(i);
            String tpvPurinentryid1 = row.getString("tpv_purinentryid1");
//            if (rkMap.containsKey(tpvPurinentryid1)) {

//            } else {
            int newEntryRow = this.getModel().createNewEntryRow(WAREHOUSE_Entry);
            for (IDataEntityProperty property : selectedProperties) {
                String proKey = property.getName();
                String subKey = subKey(proKey);
                if (properties.containsKey(subKey)) {
                    this.getModel().setValue(subKey, row.get(proKey), newEntryRow);
                }
//                }
            }
            if (collection.size() > 0) {
                DynamicObjectCollection collectionS = this.getModel().getEntryEntity(WAREHOUSE_Entry);
                for (int j = 0; j < collectionS.size(); j++) {
                    DynamicObject dynamicObject = collectionS.get(j);
                    String tpvPurinentryid = dynamicObject.getString("tpv_purinentryid");
                    rkMap.put(tpvPurinentryid, j);
                }
            }

//            for (IDataEntityProperty property : selectedProperties) {
//                String proKey = property.getName();
//                String subKey = subKey(proKey);
//                if (properties.containsKey(subKey)) {
//                    if ("tpv_rkmatchqty".equals(subKey)&&rkMap.size()!=0){
//                        this.getModel().setValue(subKey, row.get(proKey), rkMap.get(tpvPurinentryid1));
//                    }
//                }
//            }
            Set<Map.Entry<String, Integer>> entries = rkMap.entrySet();
            for (Map.Entry<String, Integer> entry : entries) {
                Integer value = entry.getValue();
                this.getModel().setValue("tpv_rkmatchqty", row.get("tpv_rkmatchqty1"), value);
            }
        }

        this.getView().updateView(WAREHOUSE_Entry);
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        OperationServiceHelper.executeOperate("save", "tpv_dt_purinvomater",
                new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
    }

    /**
     * @param returnData:
     * @return void
     * @author: chen
     * @date: 2023/11/19 16:44
     * @description: 合同信息填充
     */
    private void contract(HashMap<String, DynamicObjectCollection> returnData) {
        DynamicObjectCollection collection = this.getModel().getEntryEntity(CONTRACT_Entry);
        DataEntityPropertyCollection properties = collection.getDynamicObjectType().getProperties();
        DynamicObjectCollection collections = returnData.get("cols");
        DataEntityPropertyCollection selectedProperties = collections.getDynamicObjectType().getProperties();
        Map<String, Integer> conMap = new HashMap<>();
        if (collection.size() > 0) {
            for (int i = 0; i < collection.size(); i++) {
                DynamicObject dynamicObject = collection.get(i);
                String tpv_conentryid = dynamicObject.getString("tpv_conentryid");
                conMap.put(tpv_conentryid, i);
            }
        }
        for (int i = 0; i < collections.size(); i++) {
            DynamicObject row = collections.get(i);
            String tpvConentryid1 = row.getString("tpv_conentryid1");
            if (conMap.containsKey(tpvConentryid1)) {
                for (IDataEntityProperty property : selectedProperties) {
                    String proKey = property.getName();
                    String subKey = subKey(proKey);
                    if (properties.containsKey(subKey)) {
                        this.getModel().setValue(subKey, row.get(proKey), conMap.get(tpvConentryid1));
                    } else if ("tpv_taxrate".equals(subKey)) {
                        this.getModel().setValue("tpv_httaxrate", row.get(proKey), conMap.get(tpvConentryid1));
                    }
                }
            } else {
                int newEntryRow = this.getModel().createNewEntryRow(CONTRACT_Entry);
                for (IDataEntityProperty property : selectedProperties) {
                    String proKey = property.getName();
                    String subKey = subKey(proKey);
                    if (properties.containsKey(subKey)) {
                        this.getModel().setValue(subKey, row.get(proKey), newEntryRow);
                    } else if ("tpv_taxrate".equals(subKey)) {
                        this.getModel().setValue("tpv_httaxrate", row.get(proKey), newEntryRow);
                    }
                }
            }
        }
        this.getView().updateView(CONTRACT_Entry);
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        OperationServiceHelper.executeOperate("save", "tpv_dt_purinvomater",
                new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());

//        this.getModel().getDataEntity(true);
//        DynamicObjectCollection collection = this.getModel().getEntryEntity(CONTRACT_Entry);
//        DataEntityPropertyCollection properties = collection.getDynamicObjectType().getProperties();
//        DynamicObjectCollection collections = returnData.get("cols");
//        DataEntityPropertyCollection selectedProperties = collections.getDynamicObjectType().getProperties();
//        this.getModel().deleteEntryData(CONTRACT_Entry);
//        int[] ints = this.getModel().batchCreateNewEntryRow(CONTRACT_Entry, collections.size());
//        for (int i = 0; i < collections.size(); i++) {
//            DynamicObject row = collections.get(i);
//            for (IDataEntityProperty property : selectedProperties) {
//                String proKey = property.getName();
//                String subKey = subKey(proKey);
//                if (properties.containsKey(subKey)) {
//                    this.getModel().setValue(subKey, row.get(proKey), ints[i]);
//                }
//                else if ("tpv_taxrate".equals(subKey)) {
//                    this.getModel().setValue("tpv_httaxrate", row.get(proKey), ints[i]);
//                }
//            }
//        }
    }

    /**
     * @param data:
     * @return void
     * @author: chen
     * @date: 2023/11/19 16:44
     * @description: 发票信息填充
     */
    private void invoice(HashMap<String, DynamicObjectCollection> data) {
        DynamicObjectCollection collection = this.getModel().getEntryEntity(INVOICE_Entry);
        DataEntityPropertyCollection properties = collection.getDynamicObjectType().getProperties();
        DynamicObjectCollection collections = data.get("cols");
        DataEntityPropertyCollection selectedProperties = collections.getDynamicObjectType().getProperties();
        this.getModel().deleteEntryData(INVOICE_Entry);
        int[] ints = this.getModel().batchCreateNewEntryRow(INVOICE_Entry, collections.size());
        for (int i = 0; i < collections.size(); i++) {
            DynamicObject row = collections.get(i);
            long fsourcebillid=0L;
            for (IDataEntityProperty property : selectedProperties) {
                String proKey = property.getName();
                String subKey = subKey(proKey);
                if ("tpv_taxrate".equals(proKey)) {
                    this.getModel().setValue(proKey, row.get(proKey), ints[i]);
                }
                if (properties.containsKey(subKey)) {
                    this.getModel().setValue(subKey, row.get(proKey), ints[i]);
                }
                if ("tpv_sourceid1".equals(proKey)){
                    fsourcebillid= row.getLong(proKey);
                }
            }
            if (fsourcebillid!=0){
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                botpAttachmentpanel(dataEntity,"attachmentpanel",fsourcebillid,"ap_invoice","tpv_dt");

            }
        }
        this.getView().updateView(INVOICE_Entry);
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
//        OperationServiceHelper.executeOperate("save", "tpv_dt_purinvomater",
//                new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
        OperationResult operationResult = this.getView().invokeOperation("save", YEM.getOptionNoMsg());
        this.getView().invokeOperation("refresh");
    }


    /**
     * @param proKey:
     * @return String
     * @author: chen
     * @date: 2023/11/19 16:45
     * @description: 截取字符串
     */
    private String subKey(String proKey) {
        if (null != proKey && proKey.length() > 0) {
            return proKey.substring(0, proKey.length() - 1);
        } else {
            return "";
        }
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs evt) {
        super.afterDoOperation(evt);
        String operateKey = evt.getOperateKey();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        if ("audit".equals(operateKey)) {
//            DynamicObjectCollection tpvContinformation = dataEntity.getDynamicObjectCollection("tpv_continformation"); //合同信息
//            DynamicObjectCollection tpvWareiformation = dataEntity.getDynamicObjectCollection("tpv_wareiformation"); //入库信息
//            DynamicObjectCollection tpvContwareinfoentry = dataEntity.getDynamicObjectCollection("tpv_contwareinfoentry");
//            tpvContwareinfoentry.clear();
//            this.getView().updateView("tpv_contwareinfoentry");
//            DynamicObject[] objects = BusinessDataServiceHelper.load("tpv_bd_purcontrnum", "id,billno,tpv_name,tpv_currency", null);
//            Map<String, DynamicObject> map = new HashMap<>();
//            if (objects.length > 0) {
//                for (DynamicObject object : objects) {
//                    map.put(object.getString("tpv_name"), object);
//                }
//            }
//            dataEntity = this.getModel().getDataEntity(true);
//            if (tpvContinformation.size() > 0) {
//                for (DynamicObject dynamicObject : tpvContinformation) {
//                    //获取隐藏分录数据
//                    DynamicObjectCollection tpvContwareinfoentrys = dataEntity.getDynamicObjectCollection("tpv_contwareinfoentry");
//                    DynamicObject tpvContwareinfoRow = tpvContwareinfoentrys.addNew();
//                    tpvContwareinfoRow.set("tpv_cwdept", dynamicObject.getDynamicObject("tpv_condept")); //部门
//                    tpvContwareinfoRow.set("tpv_cwpurcontrnum", map.containsKey(dynamicObject.getString("tpv_connums"))
//                            ? map.get(dynamicObject.getString("tpv_connums")).getLong("id") : 0l); //采购合同号
//                    tpvContwareinfoRow.set("tpv_cwsupplier", dynamicObject.getDynamicObject("tpv_consupplier")); //供应商
//                    tpvContwareinfoRow.set("tpv_cwmaterial", dynamicObject.getDynamicObject("tpv_material")); //物料编码
//                    tpvContwareinfoRow.set("tpv_cwprodname", dynamicObject.getDynamicObject("tpv_conprodname")); //品名
//                    tpvContwareinfoRow.set("tpv_cwshader", dynamicObject.getString("tpv_conshader")); //材质
//                    tpvContwareinfoRow.set("tpv_cworigin", dynamicObject.getDynamicObject("tpv_conorigin")); //产地
//                    tpvContwareinfoRow.set("tpv_cwspecation", dynamicObject.getString("tpv_conspecation")); //规格
//                    tpvContwareinfoRow.set("tpv_cwqty", dynamicObject.getBigDecimal("tpv_conqty")); //数量
//                    tpvContwareinfoRow.set("tpv_cwamount", dynamicObject.getBigDecimal("tpv_contractamo")); //金额
//                    tpvContwareinfoRow.set("tpv_cwmatchqty", dynamicObject.getBigDecimal("tpv_curmatchqty")); //本次匹配数量
//                    tpvContwareinfoRow.set("tpv_cwmatchamo", dynamicObject.getBigDecimal("tpv_curmatchamo")); //本次匹配金额(含税)
//                    tpvContwareinfoRow.set("tpv_cwamountnotax", dynamicObject.getBigDecimal("tpv_curamountnotax")); //本次匹配金额(不含税)
//                    tpvContwareinfoRow.set("tpv_cwamountintax", dynamicObject.getBigDecimal("tpv_curamountintax")); //本次匹配金额(增值税额)
//                    tpvContwareinfoRow.set("tpv_cwentryid", dynamicObject.getPkValue()); //分录id
//                    tpvContwareinfoRow.set("tpv_conorwareentryid", dynamicObject.getString("tpv_conentryid")); //合同分录ID
//                    tpvContwareinfoRow.set("tpv_cwtaxrate", dynamicObject.getBigDecimal("tpv_httaxrate")); //税率%
//                    tpvContwareinfoRow.set("tpv_cwcurrency", map.containsKey(dynamicObject.getString("tpv_connums"))
//                            ? map.get(dynamicObject.getString("tpv_connums")).getDynamicObject("tpv_currency") : 0l); //币别
//                    tpvContwareinfoRow.set("tpv_matchtype", "A"); //匹配类型
//                }
//            }
//            if (tpvWareiformation.size() > 0) {
//                for (DynamicObject dynamicObject : tpvWareiformation) {
//                    //获取隐藏分录数据
//                    DynamicObjectCollection tpvContwareinfoentrys = dataEntity.getDynamicObjectCollection("tpv_contwareinfoentry");
//                    DynamicObject tpvContwareinfoRow = tpvContwareinfoentrys.addNew();
//                    tpvContwareinfoRow.set("tpv_cwdept", dynamicObject.getDynamicObject("tpv_warehousedept")); //部门
//                    tpvContwareinfoRow.set("tpv_cwpurcontrnum", map.containsKey(dynamicObject.getString("tpv_connum"))
//                            ? map.get(dynamicObject.getString("tpv_connum")).getLong("id") : 0l); //采购合同号
//                    tpvContwareinfoRow.set("tpv_cwwarenum", dynamicObject.getString("tpv_warenum")); //入库单号
//                    tpvContwareinfoRow.set("tpv_cwsupplier", dynamicObject.getDynamicObject("tpv_warehousupplier")); //供应商
//                    tpvContwareinfoRow.set("tpv_cwmaterial", dynamicObject.getDynamicObject("tpv_warehousmaterial")); //物料编码
//                    tpvContwareinfoRow.set("tpv_cwprodname", dynamicObject.getDynamicObject("tpv_prodname")); //品名
//                    tpvContwareinfoRow.set("tpv_cwshader", dynamicObject.getString("tpv_shader")); //材质
//                    tpvContwareinfoRow.set("tpv_cworigin", dynamicObject.getDynamicObject("tpv_origin")); //产地
//                    tpvContwareinfoRow.set("tpv_cwspecation", dynamicObject.getString("tpv_specation")); //规格
//                    tpvContwareinfoRow.set("tpv_cwqty", dynamicObject.getBigDecimal("tpv_qty")); //数量
//                    tpvContwareinfoRow.set("tpv_cwamount", dynamicObject.getBigDecimal("tpv_warehouseamt")); //金额
//                    tpvContwareinfoRow.set("tpv_cwmatchqty", dynamicObject.getBigDecimal("tpv_rkcurmatchqty")); //本次匹配数量
//                    tpvContwareinfoRow.set("tpv_cwmatchamo", dynamicObject.getBigDecimal("tpv_rkcurmatchamo")); //本次匹配金额(含税)
//                    tpvContwareinfoRow.set("tpv_cwamountnotax", dynamicObject.getBigDecimal("tpv_rkcurmatchamonotax")); //本次匹配金额(不含税)
//                    tpvContwareinfoRow.set("tpv_cwamountintax", dynamicObject.getBigDecimal("tpv_rkcurmatchamointax")); //本次匹配金额(增值税额)
//                    tpvContwareinfoRow.set("tpv_cwentryid", dynamicObject.getPkValue()); //分录id
//                    tpvContwareinfoRow.set("tpv_conorwareentryid", dynamicObject.getString("tpv_purinentryid")); //入库分录id
//                    tpvContwareinfoRow.set("tpv_cwtaxrate", dynamicObject.getBigDecimal("tpv_rktaxrate")); //税率%
//                    tpvContwareinfoRow.set("tpv_cwrate", dynamicObject.getBigDecimal("tpv_rate")); //汇率
//                    tpvContwareinfoRow.set("tpv_cwcurrency", dynamicObject.getDynamicObject("tpv_currency")); //币别
//                    tpvContwareinfoRow.set("tpv_cwratetable", dynamicObject.getDynamicObject("tpv_ratetable")); //汇率表
//                    tpvContwareinfoRow.set("tpv_cwmatchqtyed", dynamicObject.getBigDecimal("tpv_rkmatchqty")); //已匹配数量
//                    tpvContwareinfoRow.set("tpv_matchtype", "B"); //匹配类型
//                }
//            }
//            SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
//            this.getView().updateView("tpv_contwareinfoentry");
//            this.getModel().setDataChanged(false); //不触发操作动态修改字段值提示
        }
        if ("unaudit".equals(operateKey)) {
//            DynamicObjectCollection tpvContwareinfoentrys = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_contwareinfoentry");
//            tpvContwareinfoentrys.clear();
//            this.getView().updateView("tpv_contwareinfoentry");
//            this.getModel().setDataChanged(false); //不触发操作动态修改字段值提示
        }
        if ("red".equals(operateKey)) {
            this.getView().invokeOperation("refresh");
        }
    }

    public Long toLong(Object longObj) {
        if (longObj == null) {
            return null;
        } else if (longObj instanceof Long) {
            return (Long) longObj;
        } else {
            return Long.valueOf(String.valueOf(longObj));
        }
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_operator":
                operatorF7(e, name);
                break;
        }
    }

    private void operatorF7(BeforeF7SelectEvent e, String key) {
        DynamicObject tpvCompany = (DynamicObject) this.getModel().getValue("tpv_company");
        if (tpvCompany != null) {
            List<QFilter> QFilters = new ArrayList();
            ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
            DynamicObject[] bosOrg = BusinessDataServiceHelper.load("bos_org_orgrelation_dept", "toorg", new QFilter[]{new QFilter("fromorg", "=", tpvCompany.getPkValue())});
            List<Long> listOrg = Arrays.stream(bosOrg)
                    .map(org -> org.getDynamicObject("toorg"))
                    .filter(Objects::nonNull)
                    .map(toorg -> toorg.getLong("id"))
                    .collect(Collectors.toList());
            CloseCallBack closeCallBack = new CloseCallBack(this, key);
            showParameter.setCloseCallBack(closeCallBack);
            QFilters.add(new QFilter("entryentity.dpt", "in", listOrg));
            showParameter.getListFilterParameter().setQFilters(QFilters);
        } else {
            e.setCancel(true);
//            this.getView().showTipNotification("请先选择公司！");
        }

    }


    /**
     * @param bill
     *            携带至的单据对象
     * @param attachKey
     *            附件面板标识
     * @param fsourcebillid
     *            附件来源对象ID
     * @param sourcebillform
     *            附件来源对象
     * @param appId
     *            所属应用编码 例：tp_is
     */
    public static void botpAttachmentpanel(DynamicObject bill, String attachKey, Long fsourcebillid,
                                           String sourcebillform, String appId) {
        Object pkId = bill.getPkValue();
        if ((Long) pkId == 0L) {
            return;
        }
        String formId = bill.getDataEntityType().getName();
        List<Map<String, Object>> listMapAttachments = AttachmentServiceHelper.getAttachmentsByExport(sourcebillform,
                fsourcebillid);
        for (Map<String, Object> attach : listMapAttachments) {
            String Dodurl = (String) attach.get("url");
            String fileName = (String) attach.get("name");
            FileService service = FileServiceFactory.getAttachmentFileService();
            // 根据原url获取引入文件流
            InputStream in = service.getInputStream(Dodurl);

            String tenantId = RequestContext.get().getTenantId();
            String accountId = RequestContext.get().getAccountId();
            String uuid = UUID.randomUUID().toString().replace("-", "");
            // 生产相对Url
            String path = FileNameUtils.getAttachmentFileName(tenantId, accountId, appId, formId,
                    replaceSpeChar(String.valueOf(pkId)), uuid + "/" + replaceSpeSymbol(fileName));
            FileItem fileItem = new FileItem(fileName, path, in);
            fileItem.setCreateNewFileWhenExists(true);
            // 上传至文件服务器
            String turl = service.upload(fileItem);

            // 文件保存至附件
            ORM orm = ORM.create();
            DynamicObject dynamicObject = orm.newDynamicObject("bos_attachment");
            Long id = Long.valueOf(orm.genLongId("bos_attachment"));
            dynamicObject.set("id", id);
            dynamicObject.set("FNUMBER", attach.get("uid"));
            dynamicObject.set("FBillType", formId);
            dynamicObject.set("FInterID", pkId);
            dynamicObject.set("FModifyTime", new Date());
            dynamicObject.set("fcreatetime", new Date());
            dynamicObject.set("FaliasFileName", fileName);
            dynamicObject.set("FAttachmentName", fileName);
            dynamicObject.set("FExtName", fileName != null ? fileName.substring(fileName.lastIndexOf(46) + 1) : "");
            dynamicObject.set("FATTACHMENTSIZE", attach.get("size"));
            dynamicObject.set("FFileId", turl);
            dynamicObject.set("FCREATEMEN", RequestContext.get().getUserId());
            dynamicObject.set("FMODIFYMEN", RequestContext.get().getUserId());
            dynamicObject.set("fattachmentpanel", attachKey);
            dynamicObject.set("fbillstatus", "1");
            dynamicObject.set("fentryinterid", fsourcebillid);
            orm.insert(dynamicObject);
        }
    }
}
