package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import com.itopview.wm.dt.utils.PickShipsHelper;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.IFormView;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.EventObject;


/**
 * @author WangShuGuang
 * @version 1.0
 * @description: 关联交易转货单表单插件
 * @date 2023/12/4 14:51
 */
public class RelevanceFormPlugin extends AbstractBillPlugIn {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"tpv_advcontoolbarap", "tpv_dt_transferdist_ph"});
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {//触发时机：表单模型某个字段值改变的时候就会触发此事件//
        String propertyName = e.getProperty().getName();
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();
        if (propertyName.equals("tpv_transfertaxprice") || propertyName.equals("tpv_transferqty") || propertyName.equals("tpv_trantaxamount")) {
            calculateQty(propertyName, rowIndex);
        } else if (propertyName.equals("tpv_pickqty")) {
            addPickQty();
        } else if(propertyName.equals("tpv_pickqty")){

        }
    }

    public void addPickQty() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvDtGoodstransfeZh = dataEntity.getDynamicObjectCollection("tpv_dt_goodstransfe_zh");
        for (DynamicObject dynamicObject : tpvDtGoodstransfeZh) {
            BigDecimal tpvAlreadydistributqty = BigDecimal.ZERO;
            DynamicObjectCollection tpvDtTransferdist_ph = dynamicObject.getDynamicObjectCollection("tpv_dt_transferdist_ph");
            if (!tpvDtTransferdist_ph.isEmpty()) {
                for (DynamicObject tpvDtTransferdistPh : tpvDtTransferdist_ph) {
                    tpvAlreadydistributqty = tpvAlreadydistributqty.add(tpvDtTransferdistPh.getBigDecimal("tpv_pickqty"));//本次配货数量汇总
                }
                dynamicObject.set("tpv_alreadydistributqty", tpvAlreadydistributqty);
                SaveServiceHelper.update(dynamicObject);//写入数据库
                this.getView().updateView("tpv_dt_goodstransfe_zh");
            }
        }
    }

    public void calculateQty(String name, int rowIndex) {
        //获取分录选中行
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvDtGoodstransfeZh = dataEntity.getDynamicObjectCollection("tpv_dt_goodstransfe_zh");
        DynamicObject dynamicObject = tpvDtGoodstransfeZh.get(rowIndex);
        if (StringUtils.equals(name, "tpv_transfertaxprice") || StringUtils.equals(name, "tpv_transferqty")) {
            //转货含税单价发生变化
            BigDecimal tpvTransferqty = dynamicObject.getBigDecimal("tpv_transferqty");//转货数量
            BigDecimal tpvTransfertaxprice = dynamicObject.getBigDecimal("tpv_transfertaxprice");//转货含税单价
//            if (tpvTransferqty.compareTo(BigDecimal.ZERO) != 0 || tpvTransfertaxprice.compareTo(BigDecimal.ZERO) != 0) {
                BigDecimal tpvTrantaxamount = tpvTransfertaxprice.multiply(tpvTransferqty);
                this.getModel().beginInit();
                this.getModel().setValue("tpv_trantaxamount", tpvTrantaxamount, rowIndex);
                this.getModel().endInit();
                this.getView().updateView("tpv_trantaxamount", rowIndex);
//            }
        } else if (StringUtils.equals(name, "tpv_trantaxamount")) {
            //转货含税金额发生变化
            BigDecimal tpvTransferqty = dynamicObject.getBigDecimal("tpv_transferqty");//转货数量
            BigDecimal tpvTrantaxamount = dynamicObject.getBigDecimal("tpv_trantaxamount");//转货含税单价
            if (tpvTransferqty.compareTo(BigDecimal.ZERO) != 0) {
                BigDecimal tpvTransfertaxprice = tpvTrantaxamount.divide(tpvTransferqty, 8, RoundingMode.HALF_UP);
                this.getModel().beginInit();
                this.getModel().setValue("tpv_transfertaxprice", tpvTransfertaxprice, rowIndex);
                this.getModel().endInit();
                this.getView().updateView("tpv_transfertaxprice", rowIndex);
            } else {
                this.getModel().beginInit();
                this.getModel().setValue("tpv_transfertaxprice", BigDecimal.ZERO, rowIndex);
                this.getModel().endInit();
                this.getView().updateView("tpv_transfertaxprice", rowIndex);
            }
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        switch (itemKey) {
            case "tpv_pick":
                PickShipsHelper.pickClick(this.getView());
                break;
            default:
                break;
        }
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs afterDoOperationEventArgs) {
        super.afterDoOperation(afterDoOperationEventArgs);
        String key = afterDoOperationEventArgs.getOperateKey();
        if ("refresh".equals(key)){
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection tpvDtGoodstransfeZhs = dataEntity.getDynamicObjectCollection("tpv_dt_goodstransfe_zh");
            for (int i = 0; i < tpvDtGoodstransfeZhs.size(); i++) {
                DynamicObjectCollection tpvDtTransferdistPhs = tpvDtGoodstransfeZhs.get(i).getDynamicObjectCollection("tpv_dt_transferdist_ph");
                BigDecimal decimal = BigDecimal.ZERO;
                for (int j = 0; j < tpvDtTransferdistPhs.size(); j++) {
                    decimal=decimal.add(tpvDtTransferdistPhs.get(j).getBigDecimal("tpv_pickqty"));
                }
               this.getModel().setValue("tpv_alreadydistributqty",decimal,i);
            }
        }
    }
}
