package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;

import java.math.BigDecimal;
import java.util.EventObject;

/**
 * @Description: 销售价格确认单 -表单插件
 * @Author LinRui
 * @Date 2023/9/19 21:31
 */
public class SalepriceFormPlugin extends AbstractBillPlugIn {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"tpv_tbmainentry"});
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        switch (itemKey) {
            case "tpv_purpricevol":  //按采购作价赋值
                purPriceVolClick();
                break;
            default:
                break;
        }
    }

    private void purPriceVolClick() {
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId("tpv_dt_purprices");
        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_purpricevol"));
        this.getView().showForm(showParameter);
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        switch (actionId) {
            case "tpv_purpricevol":
                BigDecimal data = returnData != null ? (BigDecimal) returnData : BigDecimal.ZERO;
                setValue(data);
                break;
            default:
                break;
        }
    }

    private void setValue(BigDecimal data) {
        if (data.compareTo(BigDecimal.ZERO) > 0) {
            int tpvMaterialentry = this.getModel().getEntryRowCount("tpv_materialentry");
            for (int i = 0; i < tpvMaterialentry; i++) {
                BigDecimal tpv_purprice = (BigDecimal) this.getModel().getValue("tpv_purprice", i) != null ? (BigDecimal) this.getModel().getValue("tpv_purprice", i) : BigDecimal.ZERO;
                BigDecimal tpv_taxprice_final = tpv_purprice.add(data);
                this.getModel().setValue("tpv_taxprice_final", tpv_taxprice_final, i);
            }
            this.getView().updateView("tpv_materialentry");
        }
    }
}
