package tpv.tpv_wm.tpv_dt.java.formplugin.form;

import com.itopview.wm.dt.utils.PickShipsHelper;
import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.RowDataEntity;
import kd.bos.entity.datamodel.events.AfterAddRowEventArgs;
import kd.bos.entity.datamodel.events.AfterDeleteRowEventArgs;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.property.AmountProp;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.form.*;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.AmountEdit;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.RefBillEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.operate.FormOperate;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.report.ReportShowParameter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.util.StringUtils;

import java.math.BigDecimal;
import java.util.*;

/**
 * @author l jw
 * @version 1.0
 * @description: 销售发货表表单插件
 * @date 2023/8/10 14:51
 */
public class SalesshippingFormPlugin extends AbstractBillPlugIn implements RowClickEventListener, BeforeF7SelectListener {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"tpv_tbmainentry", "tbmain", "tpv_costinformations"});
        EntryGrid entryGrid = this.getView().getControl("tpv_materialentry");
        entryGrid.addRowClickListener(this);
        BasedataEdit tpv_combina = (BasedataEdit) this.getView().getControl("tpv_combina");
        tpv_combina.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        BasedataEdit tpv_reward = (BasedataEdit) this.getView().getControl("tpv_reward");
        tpv_reward.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        RefBillEdit tpv_lc = (RefBillEdit) this.getView().getControl("tpv_lc");
        tpv_lc.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        BasedataEdit tpvProdname = (BasedataEdit) this.getView().getControl("tpv_prodname");
        tpvProdname.addBeforeF7SelectListener((BeforeF7SelectListener) this);
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        IFormView view = this.getView();
        setQtyEnableByPick(view);
        setQtyEnableByPrice(view);
        Object sourcebillid = this.getModel().getValue("tpv_sourcebillid");
        if (YEM.isNotEmpty(sourcebillid)) {
            this.getView().setEnable(false, "tpv_billtype");
        }
        seConfig();
        setCombian();
    }


    private void setCombian() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject tpvBilltype = dataEntity.getDynamicObject("tpv_billtype");
        DynamicObject tpvCombination = null;
        if ("tpv_dt_salesshipping_LS".equals(tpvBilltype.getString("number"))) {
            DynamicObjectCollection tpvMaterialentrys = dataEntity.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject tpvMaterialentry : tpvMaterialentrys) {
                DynamicObjectCollection tpvDtSalepickZy = tpvMaterialentry.getDynamicObjectCollection("tpv_dt_salepick_zy");
                if (tpvDtSalepickZy.size() == 0) {
                    DynamicObjectCollection tpvDtSalepickIn = tpvMaterialentry.getDynamicObjectCollection("tpv_dt_salepick_in");
                    if (tpvDtSalepickIn.size() != 0) {
                        tpvCombination = tpvDtSalepickIn.get(0).getDynamicObject("tpv_combination_in");
                    }
                } else {
                    tpvCombination = tpvDtSalepickZy.get(0).getDynamicObject("tpv_combination_zy");
                }
            }
            if (null != tpvCombination) {
                this.getModel().setValue("tpv_combina", tpvCombination);
            }
        }
        if (null == tpvCombination) {
            this.getView().setEnable(true, "tpv_combina");
        }
    }

    @Override
    public void afterDeleteRow(AfterDeleteRowEventArgs e) {
        super.afterDeleteRow(e);
        String name = e.getEntryProp().getName();
        switch (name) {
            case "tpv_materialentry":
                setCombian();
//                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
                break;
        }
    }

    @Override
    public void afterAddRow(AfterAddRowEventArgs e) {
        super.afterAddRow(e);
        String name = e.getEntryProp().getName();
        RowDataEntity[] rowdata = e.getRowDataEntities();
        switch (name) {
            case "tpv_dt_dcostinform_f"://费用分录
                for (RowDataEntity rdata : rowdata) {
                    int i = rdata.getRowIndex();
                    DynamicObject dataEntity = this.getModel().getDataEntity(true);
                    String tpvInventorytype = dataEntity.getString("tpv_inventorytype");
                    DynamicObjectCollection tpvMaterialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品分录
                    int entryCurrentRowIndex = this.getModel().getEntryCurrentRowIndex("tpv_materialentry");
                    DynamicObject entryRow = tpvMaterialentry.get(entryCurrentRowIndex);
                    DynamicObjectCollection tpvDtDcostinformF = entryRow.getDynamicObjectCollection("tpv_dt_dcostinform_f");//费用分录
                    for (DynamicObject dynamicObject : tpvDtDcostinformF) {
                        if (YEM.isNotEmpty(tpvInventorytype)) {
                            if ("B".equals(tpvInventorytype)) {
                                this.getModel().setValue("tpv_isbringinwarehouse", true, i); //是否带入入库
                            }
                        }
                    }
                }
                break;
            case "tpv_materialentry"://费用分录
                for (RowDataEntity rdata : rowdata) {
                    int i = rdata.getRowIndex();
                    this.getModel().setValue("tpv_pickqty", this.getModel().getValue("tpv_qty"), i);
                    this.getModel().setValue("tpv_pickpackqty", this.getModel().getValue("tpv_packnum"), i);
                }
                break;
            default:
                break;
        }
    }

    public void seConfig() {
        IDataModel model = this.getModel();
        String tpvInventorytype = (String) this.getModel().getValue("tpv_inventorytype");
        Boolean tpvNopicking = (Boolean) this.getModel().getValue("tpv_nopicking");
        if (tpvNopicking && "A".equals(tpvInventorytype)) {
            return;
        }
        DynamicObjectCollection tpvMaterialentry = model.getEntryEntity("tpv_materialentry");
        for (int i = 0; i < tpvMaterialentry.size(); i++) {
            boolean isFlag = true;
            DynamicObjectCollection tpvDtSalepickZy = tpvMaterialentry.get(i).getDynamicObjectCollection("tpv_dt_salepick_zy");
            DynamicObjectCollection tpvDtSalepickIn = tpvMaterialentry.get(i).getDynamicObjectCollection("tpv_dt_salepick_in");

            if (tpvDtSalepickZy.size() != 0 && tpvDtSalepickZy.size() != 0) {
                for (DynamicObject dynamicObject : tpvDtSalepickZy) {
                    boolean practicalOk = dynamicObject.getBoolean("tpv_practicalok_zy");
                    if (!practicalOk) {
                        isFlag = false;
                    }
                }
                for (DynamicObject dynamicObject : tpvDtSalepickIn) {
                    boolean practicalOk = dynamicObject.getBoolean("tpv_practicalok_in");
                    if (!practicalOk) {
                        isFlag = false;
                    }
                }
            } else if (tpvDtSalepickZy.size() == 0 && tpvDtSalepickIn.size() != 0) {
                for (DynamicObject dynamicObject : tpvDtSalepickIn) {
                    boolean practicalOk = dynamicObject.getBoolean("tpv_practicalok_in");
                    if (!practicalOk) {
                        isFlag = false;
                    }
                }
            } else if (tpvDtSalepickZy.size() != 0 && tpvDtSalepickIn.size() == 0) {
                for (DynamicObject dynamicObject : tpvDtSalepickZy) {
                    boolean practicalOk = dynamicObject.getBoolean("tpv_practicalok_zy");
                    if (!practicalOk) {
                        isFlag = false;
                    }
                }
            } else if (tpvDtSalepickZy.size() == 0 && tpvDtSalepickZy.size() == 0) {
                isFlag = false;
            }
            DynamicObject dynamicObject = tpvMaterialentry.get(i);
            boolean aBoolean = dynamicObject.getBoolean("tpv_practicalok");
            if (!aBoolean) {
                this.getModel().setValue("tpv_practicalok", isFlag, i);
            }
            this.getModel().setValue("tpv_actuallymentioned", isFlag, i);
        }
    }

    /**
     * 货物批次后设置数量锁定
     *
     * @param view
     */
    private void setQtyEnableByPrice(IFormView view) {
        String entryKey = "tpv_materialentry";
        IDataModel model = view.getModel();
        DynamicObjectCollection entryEntity = model.getEntryEntity(entryKey);
        boolean tpvRichardinput = (boolean) model.getValue("tpv_richardinput"); //按理计输入
        for (int i = 0; i < entryEntity.size(); i++) {
            DynamicObject row = entryEntity.get(i);
            String tpv_selectiondocu = row.getString("tpv_selectiondocu") == null ? "" : row.getString("tpv_selectiondocu");
            String tpvDocument = row.getString("tpv_document");
            if (StringUtils.isNotEmpty(tpv_selectiondocu)) {
                if (!"A".equals(tpvDocument)) {
                    this.getView().setEnable(false, i, "tpv_qty");
                }
            } else if (StringUtils.isEmpty(tpv_selectiondocu) && !tpvRichardinput) {
                this.getView().setEnable(true, i, "tpv_qty");
            }
        }
    }

    /**
     * 拣配后设置数量锁定
     *
     * @param view
     */
    public static void setQtyEnableByPick(IFormView view) {
        // String entityKey = view.getEntityId();
        String entryKey = "tpv_materialentry";
        String qtyKey = "tpv_qty";
        String packnumKey = "tpv_packnum";
        // String materialKey = "tpv_material";
        IDataModel model = view.getModel();
        DynamicObjectCollection entryEntity = model.getEntryEntity(entryKey);
        for (int i = 0; i < entryEntity.size(); i++) {
            DynamicObject row = entryEntity.get(i);
            DynamicObjectCollection salepick_zy = row.getDynamicObjectCollection("tpv_dt_salepick_zy");
            DynamicObjectCollection salepick_in = row.getDynamicObjectCollection("tpv_dt_salepick_in");
            if (salepick_zy.size() > 0 || salepick_in.size() > 0) {
                view.setEnable(false, i, qtyKey);
                view.setEnable(false, i, packnumKey);
                DynamicObject tpvBilltype = (DynamicObject) model.getValue("tpv_billtype");
                String number = tpvBilltype.getString("number");
                if ("tpv_dt_salesshipping_LS".equals(number)) {
                    view.setEnable(false, i, "tpv_prodname");
                }
                view.setEnable(false, "tpv_inventorytype");
                view.setEnable(false, "tpv_combina");
                view.setEnable(false, "tpv_pickqtybox");
                view.setEnable(false, "tpv_pickamtbox");
            }
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();
        switch (name) {
            case "tpv_inventorytype":
                inventoryTypeChanged(changeData);
                DynamicObjectCollection tpvMaterialentry = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_materialentry");
                if (tpvMaterialentry.size() > 0) {
                    for (int i = 0; i < tpvMaterialentry.size(); i++) {
                        DynamicObject dynamicObject = tpvMaterialentry.get(i);
                        dynamicObject.set("tpv_pickqty", dynamicObject.getBigDecimal("tpv_qty"));
                        dynamicObject.set("tpv_pickpackqty", dynamicObject.getBigDecimal("tpv_packnum"));
                        this.getView().updateView("tpv_pickqty", i);
                        this.getView().updateView("tpv_pickpackqty", i);
                    }
                }
                break;
            case "tpv_whether":
            case "tpv_business":
                business(changeData);
                break;
            case "tpv_combina":
//                combina(changeData);
                break;
            case "tpv_qty":
            case "tpv_packnum":
                setPickOrPackqty(rowIndex, name);
                break;
            default:
                break;
        }
    }

    private void setPickOrPackqty(int rowIndex, String name) {
        String tpv_inventorytype = (String) this.getModel().getValue("tpv_inventorytype");
        BigDecimal qty = BigDecimalUtils.toBigDecimal(this.getModel().getValue(name, rowIndex));
        BigDecimal QtySum = BigDecimal.ZERO;
        DynamicObjectCollection tpvMaterialentry = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_materialentry");
        if (tpvMaterialentry.size() > 0) {
            DynamicObject entryRowEntity = this.getModel().getEntryRowEntity("tpv_materialentry", rowIndex);
            if ("A".equals(tpv_inventorytype)) {
                String pickNameSub = "tpv_qty".equals(name) ? "tpv_pickqty_in" : "tpv_packnum_in";
                DynamicObjectCollection tpvDtSalepickIn = entryRowEntity.getDynamicObjectCollection("tpv_dt_salepick_in");
                for (DynamicObject dynamicObject : tpvDtSalepickIn) {
                    QtySum = QtySum.add(BigDecimalUtils.toBigDecimal(dynamicObject.get(pickNameSub)));
                }
            } else if ("B".equals(tpv_inventorytype)) {
                String pickNameSub = "tpv_qty".equals(name) ? "tpv_pickqty_zy" : "tpv_packnum_zy";
                DynamicObjectCollection tpvDtSalepickZy = entryRowEntity.getDynamicObjectCollection("tpv_dt_salepick_zy");
                for (DynamicObject dynamicObject : tpvDtSalepickZy) {
                    QtySum = QtySum.add(BigDecimalUtils.toBigDecimal(dynamicObject.get(pickNameSub)));
                }
            }
            BigDecimal pickqty = qty.subtract(QtySum);
            String pickName = "tpv_qty".equals(name) ? "tpv_pickqty" : "tpv_pickpackqty";
            this.getModel().setValue(pickName, pickqty, rowIndex);
        }
    }

    private void business(ChangeData[] changeData) {
        Boolean tpv_whether = (Boolean) this.getModel().getValue("tpv_whether");
        DynamicObject tpv_business = (DynamicObject) this.getModel().getValue("tpv_business");
        String number = null;
        if (null != tpv_business) {
            number = tpv_business.getString("number");

        }
        if ("YWLX-230902-0001".equals(number) || tpv_whether) {
            AmountEdit textEdit = this.getView().getControl("tpv_thirdpartyprice");
            textEdit.setMustInput(true);
            AmountProp textProp = (AmountProp) textEdit.getProperty();
            textProp.setMustInput(true);
        } else {
            AmountEdit textEdit = this.getView().getControl("tpv_thirdpartyprice");
            textEdit.setMustInput(false);
            AmountProp textProp = (AmountProp) textEdit.getProperty();
            textProp.setMustInput(false);
        }
    }

    //LinRui 根据组合号过滤提奖类型
    private void combina(ChangeData[] changeData) {
//        DynamicObject tpv_business = (DynamicObject) this.getModel().getValue("tpv_business");
//        DynamicObject tpvBilltype = (DynamicObject) this.getModel().getValue("tpv_billtype");
//        String tpvBilltypeNumber = tpvBilltype != null ? tpvBilltype.getString("number") : "";
////        if (null != tpv_business && "tpv_dt_salesshipping_LS".equals(tpvBilltypeNumber)) {
//        if (null != tpv_business) {
//            Long tpvBusinessId = tpv_business.getLong("id");
//            DynamicObject[] load = BusinessDataServiceHelper.load("tpv_bd_extracttype", "id,number,tpv_usebusinesstype,tpv_extractratio",
//                    new QFilter[]{new QFilter("tpv_usebusinesstype.fbasedataid.id", QCP.in, tpvBusinessId)});
//            if (load.length == 1) {
//                for (DynamicObject dynamicObject : load) {
//                    this.getModel().setValue("tpv_reward", dynamicObject);
//                    this.getView().setEnable(false, "tpv_reward");
//                }
//            }
//            if (load.length > 1) {
//                this.getModel().setValue("tpv_reward", null);
//                this.getView().setEnable(true, "tpv_reward");
//            }
//        }
    }

    /**
     * 库存/直运-修改校验
     *
     * @param changeData
     * @author longh
     */
    private void inventoryTypeChanged(ChangeData[] changeData) {
        IDataModel model = this.getModel();
        String oldValue = (String) changeData[0].getOldValue();
        if (YEM.isNotEmpty(oldValue)) {
            String subEnd = "A".equals(oldValue) ? "_in" : "_zy";
            int count = model.getEntryRowCount("tpv_dt_salepick" + subEnd);
            if (count > 0) {
                model.setValue("tpv_inventorytype", oldValue);
                this.getView().showTipNotification("已有拣配信息，不允许修改。");
            }
        }
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        IFormView view = this.getView();
        // String operateKey = e.getOperateKey();
        OperationResult operationResult = e.getOperationResult();
        if (operationResult != null && operationResult.isSuccess()) {
            setQtyEnableByPick(view);
        }
    }

    @Override
    public void beforeItemClick(BeforeItemClickEvent evt) {
        super.beforeItemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        EntryGrid entry = this.getView().getControl("tpv_materialentry");
        int selectRows[] = entry.getSelectRows();
        switch (itemKey) {
            case "tpv_advconbaritemap":
                //获取单据体数据集合
                DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_materialentry");
                Map<Long, DynamicObject> map = new HashMap<>();
                if (null != selectRows && selectRows.length > 0) {
                    for (int selectRow : selectRows) {
                        DynamicObject dynamicObject = entity.get(selectRow);  //获取选中行的单据体数据
                        map.put(Long.valueOf(selectRow), dynamicObject);
                    }
                } else {
                    this.getView().showTipNotification("未选择行数据。");
                    return;
                }
                List<String> settleSeqList = new ArrayList();
                if (null != map && map.size() > 0) {
                    for (Map.Entry<Long, DynamicObject> dynamicObject : map.entrySet()) {
                        DynamicObject dynamicObject1 = dynamicObject.getValue();
                        int tpvDtSalepickZy = dynamicObject1.getDynamicObjectCollection("tpv_dt_salepick_zy").size();
                        int tpvDtSalepickIn = dynamicObject1.getDynamicObjectCollection("tpv_dt_salepick_in").size();
                        String tpv_selectiondocu = dynamicObject1.getString("tpv_selectiondocu");//货物批次单号
                        String tpvDocument = dynamicObject1.getString("tpv_document");
                        if (StringUtils.isNotEmpty(tpv_selectiondocu)) {
                            if (!"A".equals(tpvDocument) || tpvDtSalepickZy > 0 || tpvDtSalepickIn > 0) {
                                String settleSeq = dynamicObject1.getString("seq");
                                settleSeqList.add(settleSeq);
                            }
                        }
                    }
                    if (settleSeqList.size() > 0) {
                        evt.setCancel(true);
                        this.getView().showTipNotification("分录选中行 " + String.join(",", settleSeqList.toString()) + " 已货物批次价格确认或已拣配，不允许再次复制！");
                    }
                }
                break;
            case "tpv_deleteentry_1":
                if (selectRows.length > 0) {
                    DynamicObject dataEntity = this.getModel().getDataEntity(true);
                    Boolean flag = false;
                    for (int selectRow : selectRows) {
                        DynamicObject dynamicObject = this.getModel().getEntryRowEntity("tpv_materialentry", selectRow);
                        String tpvInventorytype = dataEntity.getString("tpv_inventorytype");
                        if ("A".equals(tpvInventorytype)) {  //库存
                            DynamicObjectCollection tpvDtSalepickIn = dynamicObject.getDynamicObjectCollection("tpv_dt_salepick_in");
                            if (tpvDtSalepickIn.size() > 0) {
                                flag = true;
                                break;
                            }
                        }
                        if ("B".equals(tpvInventorytype)) {  //直运
                            DynamicObjectCollection tpvDtSalepickZy = dynamicObject.getDynamicObjectCollection("tpv_dt_salepick_zy");
                            if (tpvDtSalepickZy.size() > 0) {
                                flag = true;
                                break;
                            }
                        }
                    }
                    if (flag) {
                        evt.setCancel(true);
                        this.getView().showTipNotification("【拣配信息-采购合同（直运时必选）】子分录或【拣配信息-库存】子分录存在数据，不允许删除！\r\n 可选中父分录，点击拣配弹框可配信息分录取消勾选确认");
                    }
                }
                break;
            default:
                break;
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        String rpt = "";
        Long cusId = 0L;
        Long deptId = 0L;
        DynamicObject tpv_customer = (DynamicObject) this.getModel().getValue("tpv_customer");
        if (null != tpv_customer) {
            cusId = tpv_customer.getLong("id");
        }
        DynamicObject tpv_department = (DynamicObject) this.getModel().getValue("tpv_department");
        if (null != tpv_department) {
            deptId = tpv_department.getLong("id");
        }
        switch (itemKey) {
            case "tpv_pick":
                IFormView view = this.getView();
                IDataModel model = this.getModel();
                DynamicObject tpvBilltype = (DynamicObject) model.getValue("tpv_billtype");
                String number = tpvBilltype.getString("number");
                DynamicObject dataEntity = model.getDataEntity(true);
                EntryGrid entry = view.getControl("tpv_materialentry");
                int selectRows = entry.getSelectRows().length;
//                if (selectRows == 1 && !"tpv_dt_salesshipping_LS".equals(number)) {
//                    int index = entry.getSelectRows()[0];
//                    DynamicObject row = model.getEntryRowEntity("tpv_materialentry", index);
//                    QFilter qFilter = new QFilter("tpv_materialentry.tpv_srcbillid", QCP.equals, row.getLong("tpv_srcbillid"));
//                    DynamicObject[] tpvDtSalepricebill = BusinessDataServiceHelper.load("tpv_dt_salepricebill", "id,billno", qFilter.toArray());
//                    if (tpvDtSalepricebill.length == 0) {
//                        row.set("tpv_selectiondocu", row.getString("tpv_srccontractnos"));
//                        row.set("tpv_document", "A");
//                        this.getModel().setValue("tpv_selectiondocu", row.getString("tpv_srccontractnos"), index);
//                        this.getModel().setValue("tpv_document", "A", index);
//                        this.getView().updateView("tpv_selectiondocu", index);
//                        this.getView().updateView("tpv_document", index);
//                    }
//                    if (null == row.getString("tpv_selectiondocu") || "".equals(row.getString("tpv_selectiondocu"))) {
//                        view.showTipNotification("第 " + row.get("seq") + "行 未货物批次选择，或者货物批次单号为空，不允许拣配。");
//                        return;
//                    }
//                }
                DynamicObjectCollection tpvMaterialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");
                List<String> nopassSeqs1 = new ArrayList<>();
                List<String> nopassSeqs2 = new ArrayList<>();
                List<String> nopassSeqs3 = new ArrayList<>();
                if (!"tpv_dt_salesshipping_LS".equals(number)) {
                    for (DynamicObject row : tpvMaterialentry) {
                        int index = Integer.valueOf(row.getString("seq"));
                        index = index - 1;
                        QFilter qFilter = new QFilter("tpv_materialentry.tpv_srcbillid", QCP.equals, row.getLong("tpv_srcbillid"));
                        DynamicObject[] tpvDtSalepricebill = BusinessDataServiceHelper.load("tpv_dt_salepricebill", "id,billno", qFilter.toArray());
                        if (tpvDtSalepricebill.length == 0) {
                            row.set("tpv_selectiondocu", row.getString("tpv_srccontractnos"));
                            row.set("tpv_document", "A");
                            this.getModel().setValue("tpv_selectiondocu", row.getString("tpv_srccontractnos"), index);
                            this.getModel().setValue("tpv_document", "A", index);
                            this.getView().updateView("tpv_selectiondocu", index);
                            this.getView().updateView("tpv_document", index);
                        }
                        if (null == row.getString("tpv_selectiondocu") || "".equals(row.getString("tpv_selectiondocu"))) {
                            nopassSeqs1.add(row.getString("seq"));
                        }
                        DynamicObject tpvProdname = row.getDynamicObject("tpv_prodname");
                        DynamicObject tpvMaterial = row.getDynamicObject("tpv_material");
                        if (YEM.isEmpty(tpvProdname) || YEM.isEmpty(tpvMaterial)) {
                            nopassSeqs2.add(row.getString("seq"));
                        }
                        boolean tpvPickqtybox = dataEntity.getBoolean("tpv_pickqtybox");
                        if (!tpvPickqtybox) {
                            BigDecimal qty = row.getBigDecimal("tpv_qty");
                            if (qty.compareTo(BigDecimal.ZERO) == 0) {
                                nopassSeqs3.add(row.getString("seq"));
                            }
                        }
                    }
                    if (nopassSeqs1.size() > 0) {
                        view.showTipNotification("第 " + String.join(",", nopassSeqs1) + "行 未货物批次选择，或者货物批次单号为空，不允许拣配。");
                        return;
                    }
                    if (nopassSeqs2.size() > 0) {
                        view.showTipNotification("第 " + String.join(",", nopassSeqs2) + "行 品名或物料为空，不允许拣配。");
                        return;
                    }
                    if (nopassSeqs3.size() > 0) {
                        view.showTipNotification("第 " + String.join(",", nopassSeqs3) + "行 数量不允许为零，不允许拣配。");
                        return;
                    }
                }

                PickShipsHelper.pickClick(this.getView());
                break;
            case "tpv_inseriespick": //串拣配
                OperationResult saveOperate = this.getView().invokeOperation("save", YEM.getOptionNoMsg());
                DynamicObject dataEntityInseries = this.getModel().getDataEntity(true);
                dataEntityInseries.set("tpv_yesnoinseries", "1");
                SaveServiceHelper.update(dataEntityInseries);// 写入数据库
                PickShipsHelper.pickClick(this.getView());
                break;
            case "tpv_cargobatch": // 货物批次选择
                cargobatchClick();
                break;
            case "tpv_contractinquiries": //合同可放货余额查询
                rpt = "tpv_cuscreditbalancerpta";
                cusCreditRptDataSet(rpt, cusId, deptId);
                break;
            case "tpv_projectqueries": //项目可放货余额查询
                rpt = "tpv_cuscreditbalancerptb";
                String tpvProject = (String) this.getModel().getValue("tpv_project"); //项目简称
                DynamicObject tpv_pw_filing_XM = BusinessDataServiceHelper.loadSingle("tpv_pw_filing", new QFilter[]{new QFilter("tpv_project", QCP.equals, tpvProject)});
                if (YEM.isNotEmpty(tpv_pw_filing_XM)) {
                    cusId = tpv_pw_filing_XM.getLong("id");
                } else {
                    cusId = 0l;
                }
                cusCreditRptDataSet(rpt, cusId, 0l);
                break;
            case "tpv_frameworkqueries": //框架可放货余额查询
                rpt = "tpv_cuscreditbalancerptc";
                String tpvAbbreviation = (String) this.getModel().getValue("tpv_abbreviation"); //框架简称
                DynamicObject tpv_pw_filing_KJ = BusinessDataServiceHelper.loadSingle("tpv_pw_filing", new QFilter[]{new QFilter("tpv_frameworkname", QCP.equals, tpvAbbreviation)});
                if (YEM.isNotEmpty(tpv_pw_filing_KJ)) {
                    cusId = tpv_pw_filing_KJ.getLong("id");
                } else {
                    cusId = 0l;
                }
                cusCreditRptDataSet(rpt, cusId, 0l);
                break;
            case "tpv_customerinquiries": //客户额度使用情况查询
                rpt = "tpv_cuscredituserpt";
                QFilter qFilter = new QFilter("enable", QCP.equals, "1");
                if (YEM.isNotEmpty(tpv_department)) {
                    qFilter.and(new QFilter("id", QCP.equals, tpv_department.getLong("id")));
                }
                DynamicObject bosAdminorgs = BusinessDataServiceHelper.loadSingle("bos_adminorg", qFilter.toArray());
                if (YEM.isNotEmpty(bosAdminorgs) & YEM.isNotEmpty(tpv_department)) {
                    DynamicObject orgpattern = bosAdminorgs.getDynamicObject("orgpattern");
                    if (YEM.isNotEmpty(orgpattern)) {
                        String deptNumber = orgpattern.getString("number");
                        if ("OF-01".equals(deptNumber)) {
                            DynamicObjectCollection dynamicObjects = bosAdminorgs.getDynamicObjectCollection("structure");
                            if (dynamicObjects.size() > 0) {
                                for (DynamicObject dynamicObject : dynamicObjects) {
                                    DynamicObject viewparent = dynamicObject.getDynamicObject("viewparent");
                                    if (YEM.isNotEmpty(viewparent)) {
                                        deptId = viewparent.getLong("id");
                                    }
                                    break;
                                }
                            }
                        }
                    }
                }
                cusCreditRptDataSet(rpt, cusId, deptId);
                break;
            case "tpv_bulkentrybutton":
                showInfoForm(this.getView());
                break;
            default:
                break;
        }
    }

    /**
     * @param e 回调，接收子页面传来的值。
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        switch (actionId) {
            case "tpv_bulkentrybutton":
                DynamicObjectCollection data = (DynamicObjectCollection) returnData;
                setValue(data);
                break;
            default:
                break;
        }
    }

    private void setValue(DynamicObjectCollection data) {
        if (data != null && data.size() > 0) {
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            String tpvInventorytype = dataEntity.getString("tpv_inventorytype");
            DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");//商品明细分录
            for (int i = 0; materialentry.size() > i; i++) {
                DynamicObject dynamicObject = materialentry.get(i);
                BigDecimal tpvQty = dynamicObject.getBigDecimal("tpv_qty");
                DynamicObjectCollection dynamicObjects = dynamicObject.getDynamicObjectCollection("tpv_dt_dcostinform_f");
                for (DynamicObject freigroambill : data) {
                    DynamicObject addNewDy = dynamicObjects.addNew();
                    addNewDy.set("tpv_comtype", "A");
                    addNewDy.set("tpv_expenseitems", freigroambill.getDynamicObject("tpv_expenseitems"));
                    addNewDy.set("tpv_providers", freigroambill.getDynamicObject("tpv_supplierf"));
                    addNewDy.set("tpv_costcurrencyes", freigroambill.getDynamicObject("tpv_costcurrencys"));
                    addNewDy.set("tpv_billablequantitys", tpvQty);
                    addNewDy.set("tpv_unitprices", freigroambill.getBigDecimal("tpv_unitprices"));
                    BigDecimal tpvMoneys = tpvQty.multiply(freigroambill.getBigDecimal("tpv_unitprices"));
                    addNewDy.set("tpv_moneys", tpvMoneys.setScale(2, BigDecimal.ROUND_HALF_UP));
                    addNewDy.set("tpv_taxrate", freigroambill.getBigDecimal("tpv_taxrates"));
                    addNewDy.set("tpv_desc", freigroambill.getString("tpv_comments"));
                    if (YEM.isNotEmpty(tpvInventorytype)) {
                        if ("B".equals(tpvInventorytype)) {
                            addNewDy.set("tpv_isbringinwarehouse", true); //是否带入入库
                        }
                    }
                }
            }
            this.getView().updateView("tpv_dt_dcostinform_f");
        }
    }

    /**
     * 设置打开批量录入金额动态表单
     */
    private void showInfoForm(IFormView view) {
        // 获取单据体
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);

        showParameter.setFormId("tpv_dt_salesdelivery");
        Map<String, Object> map = new HashMap<>();
        map.put("tpv_inventorytype", view.getModel().getValue("tpv_inventorytype"));
        showParameter.setCustomParams(map);
        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_bulkentrybutton"));
        view.showForm(showParameter);
    }

    private void cusCreditRptDataSet(String rptbill, Long tpvCustomerId, Long tpvDepartmentId) {
        //打开报表页面
        ReportShowParameter reportShowParameter = new ReportShowParameter();
        reportShowParameter.getOpenStyle().setShowType(ShowType.Modal);
        reportShowParameter.setFormId(rptbill);
        StyleCss styleCss = new StyleCss();
        styleCss.setHeight("720");
        styleCss.setWidth("1200");
        //设置弹出表单的样式，宽，高等
        reportShowParameter.getOpenStyle().setInlineStyleCss(styleCss);
        // 设置报表过滤条件
        ReportQueryParam reportQueryParam = new ReportQueryParam();
        FilterInfo filterInfo = new FilterInfo();
        if ("tpv_cuscreditbalancerptb".equals(rptbill) || "tpv_cuscreditbalancerptc".equals(rptbill)) {
            filterInfo.addFilterItem("tpv_project_f", tpvCustomerId);
        }
        filterInfo.addFilterItem("tpv_customer_filter", tpvCustomerId);
        filterInfo.addFilterItem("tpv_dep_filter", tpvDepartmentId);
        reportQueryParam.setFilter(filterInfo);
        reportShowParameter.setQueryParam(reportQueryParam);
        getView().showForm(reportShowParameter);
    }

    /**
     * 按钮操作执行前监听
     * 阻止复制行
     *
     * @param args
     */
    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate operate = (FormOperate) args.getSource();
        String key = operate.getOperateKey();
        if ("refresh".equals(key)) {
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            Boolean flag = false;
            DynamicObjectCollection tpv_materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");
            String tpvInventorytype = dataEntity.getString("tpv_inventorytype");
            if ("A".equals(tpvInventorytype)) {  //库存
                for (int i = 0; i < tpv_materialentry.size(); i++) {
                    DynamicObjectCollection tpvDtSalepickIn = tpv_materialentry.get(i).getDynamicObjectCollection("tpv_dt_salepick_in");
                    if (tpvDtSalepickIn.size() > 0) {
                        flag = true;
                        break;
                    }
                }
            }
            if ("B".equals(tpvInventorytype)) {  //直运
                for (int i = 0; i < tpv_materialentry.size(); i++) {
                    DynamicObjectCollection tpvDtSalepickZy = tpv_materialentry.get(i).getDynamicObjectCollection("tpv_dt_salepick_zy");
                    if (tpvDtSalepickZy.size() > 0) {
                        flag = true;
                        break;
                    }
                }
            }
            if (flag) {
                this.getView().setEnable(false, "tpv_inventorytype");
                this.getView().setEnable(false, "tpv_entrepot");
                this.getView().setEnable(false, "tpv_pickqtybox");
                this.getView().setEnable(false, "tpv_pickamtbox");
            } else {
                this.getView().setEnable(true, "tpv_inventorytype");
                this.getView().setEnable(true, "tpv_entrepot");
                this.getView().setEnable(true, "tpv_pickqtybox");
                this.getView().setEnable(true, "tpv_pickamtbox");
            }
        }
    }

    /**
     * @author: LinRui
     * @Description: //货物批次选择
     **/
    private void cargobatchClick() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        EntryGrid entry = view.getControl("tpv_materialentry");
        int selectRows = entry.getSelectRows().length;
        if (selectRows > 1) {
            view.showTipNotification("只能选择一行数据进行操作。");
        }
        if (selectRows == 0) {
            view.showTipNotification("未选择数据。");
        }
        if (selectRows == 1) {
            int index = entry.getSelectRows()[0];
            DynamicObject row = model.getEntryRowEntity("tpv_materialentry", index);
            DynamicObject tpvBilltype = (DynamicObject) this.getModel().getValue("tpv_billtype");
            BigDecimal tpvOverloadingrates = BigDecimal.ZERO;
            if (!"tpv_dt_salesshipping_LS".equals(tpvBilltype.getString("number"))) {
                DynamicObject tpvDtSalescontract = BusinessDataServiceHelper.loadSingle(row.getLong("tpv_cobillid"), "tpv_dt_salescontract");
                tpvOverloadingrates = tpvDtSalescontract.getBigDecimal("tpv_overloadingrates"); //溢装率(%)
            }

            if (row.getDynamicObjectCollection("tpv_dt_salepick_zy").size() > 0
                    || row.getDynamicObjectCollection("tpv_dt_salepick_in").size() > 0) {
                view.showTipNotification("第 " + row.get("seq") + " 已拣配过，不允许再次批次选择。");
                return;
            }
//			if (YEM.isNotEmpty(row.getString("tpv_document")) || YEM.isNotEmpty(row.getString("tpv_selectiondocu"))) {
//				view.showTipNotification("第 " + row.get("seq") + " 行已成功操作过一下货物批次选择，不允许再次批次选择。");
//				return;
//			}

            OperationResult saveOperate = view.invokeOperation("save", YEM.getOptionNoMsg());
            if (!saveOperate.isSuccess()) {
                view.showTipNotification("自动保存失败。" + YEM.getOpMsg(saveOperate));
                return;
            }
            FormShowParameter showParameter = new FormShowParameter();
            showParameter.setStatus(OperationStatus.ADDNEW);
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            showParameter.setFormId("tpv_dt_cargobatchs");

            List<String> notInputs = new ArrayList<>();
            Map<String, Object> param = new HashMap<>();
            param.put("pkid", row.getPkValue());
            param.put("tpv_material", PickShipsHelper.getNotNull(view, notInputs, row, "tpv_material")); // 物料
            param.put("tpv_qty", PickShipsHelper.getNotNull(view, notInputs, row, "tpv_qty")); // 数量
            param.put("tpv_cobillno", row.get("tpv_cobillno")); // 核心单据编码
            param.put("tpv_cobillid", row.get("tpv_cobillid")); // 核心单据ID
            param.put("tpv_coentryid", row.get("tpv_coentryid")); // 核心单据分录ID
            param.put("tpv_srcbillkey", row.get("tpv_srcbillkey")); // 来源单据标识
            param.put("tpv_srcbillno", row.get("tpv_srcbillno")); // 来源单据编码
            param.put("tpv_srcbillid", row.get("tpv_srcbillid")); // 来源单据ID
            param.put("tpv_srcentryid", row.get("tpv_srcentryid")); // 来源单据分录ID
            DynamicObject tpvUnit = (DynamicObject) row.get("tpv_unit");
            Long tpvUnitLong = 0L;
            if (null != tpvUnit) {
                tpvUnitLong = tpvUnit.getLong("id");
            }
            param.put("tpv_units", tpvUnitLong); // 计量单位
            param.put("tpv_document", row.get("tpv_document")); // 货物批次选择单据
            param.put("tpv_selectiondocu", row.get("tpv_selectiondocu")); // 货物批次选择单据号
            param.put("tpv_overloadingrates", tpvOverloadingrates); // 核心单据的溢装率(%)
            if (notInputs.size() > 0) {
                view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
            } else {
                showParameter.setCustomParams(param);
                view.showForm(showParameter);
            }
        }
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        RowClickEventListener.super.entryRowClick(evt);
        int row = evt.getRow();
        DynamicObject rowData = this.getModel().getEntryRowEntity("tpv_materialentry", row);
        boolean tpvRichardinput = (boolean) this.getModel().getValue("tpv_richardinput");
        if (null != rowData) {
            String tpvDocument = rowData.getString("tpv_document");
            String tpv_selectiondocu = rowData.getString("tpv_selectiondocu") == null ? "" : rowData.getString("tpv_selectiondocu");
            if (StringUtils.isNotEmpty(tpv_selectiondocu)) {
                if (!"A".equals(tpvDocument)) {
                    this.getView().setEnable(false, "tpv_advconbaritemap");
                    this.getView().setEnable(false, row, "tpv_qty");
                }
            } else {
                this.getView().setEnable(true, "tpv_advconbaritemap");
                if (!tpvRichardinput) {
                    this.getView().setEnable(true, row, "tpv_qty");
                }
            }
        } else {
            return;
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        this.getView().setEnable(false, "tpv_reward");
        Date tpvBizdate = (Date) this.getModel().getValue("tpv_bizdate");
        Date addDate = DateUtil.addDays(tpvBizdate, 15);
        this.getModel().setValue("tpv_termval", addDate);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_reward":
                DynamicObject tpv_business = (DynamicObject) this.getModel().getValue("tpv_business");
                ListShowParameter showParameterrd = (ListShowParameter) e.getFormShowParameter();
                List<QFilter> QFiltersrd = new ArrayList<QFilter>();
                if (tpv_business == null) {
                    return;
                }
                Long tpv_businessId = (Long) tpv_business.get("id");
                QFiltersrd.add(new QFilter("tpv_usebusinesstype.fbasedataid.id", QCP.in, tpv_businessId)); //设置过滤条件：适用业务类型
                showParameterrd.getListFilterParameter().setQFilters(QFiltersrd);
                break;
            case "tpv_combina":
                DynamicObject tpv_department = (DynamicObject) this.getModel().getValue("tpv_department");
                ListShowParameter showParameterna = (ListShowParameter) e.getFormShowParameter();
                List<QFilter> QFiltersna = new ArrayList<QFilter>();
                if (tpv_department == null) {
                    return;
                }
                Long tpv_departmentId = (Long) tpv_department.get("id");
                QFiltersna.add(new QFilter("tpv_departments.id", QCP.equals, tpv_departmentId)); //设置过滤条件：部门
                showParameterna.getListFilterParameter().setQFilters(QFiltersna);
                break;
            case "tpv_lc":
//                DynamicObject tpvDepartment = (DynamicObject) this.getModel().getValue("tpv_department");//部门
//                DynamicObject tpvCompany = (DynamicObject) this.getModel().getValue("tpv_company");//公司
//                ListShowParameter showParameterLc = (ListShowParameter) e.getFormShowParameter();
//                List<QFilter> QFiltersLc = new ArrayList<QFilter>();
//                if (tpvDepartment != null) {
//                    Long department = (Long) tpvDepartment.get("id");
//                    QFiltersLc.add(new QFilter("tpv_department.id", QCP.equals, department)); //设置过滤条件：部门
//                }
//                if (tpvCompany != null) {
//                    Long tpvCompanyId = (Long) tpvCompany.get("id");
//                    QFiltersLc.add(new QFilter("org.id", QCP.equals, tpvCompanyId)); //设置过滤条件：部门
//                }
//                showParameterLc.getListFilterParameter().setQFilters(QFiltersLc);
                break;
            case "tpv_comewl":
                Date tpvBizdate = (Date) this.getModel().getValue("tpv_bizdate");
                ListShowParameter showParameternawl = (ListShowParameter) e.getFormShowParameter();
                List<QFilter> QFilterswl = new ArrayList<QFilter>();
                QFilterswl.add(new QFilter("tpv_validfrom", QCP.less_equals, tpvBizdate)); //有效期从
                QFilterswl.add(new QFilter("tpv_validuntil", QCP.large_equals, tpvBizdate)); //有效期至
                QFilterswl.add(new QFilter("billstatus", QCP.equals, "C")); //已审核
                showParameternawl.getListFilterParameter().setQFilters(QFilterswl);
                break;
            case "tpv_prodname":
                DynamicObject tpvBilltype = (DynamicObject) this.getModel().getValue("tpv_billtype");
                if (tpvBilltype != null && !"tpv_dt_salesshipping_LS".equals(tpvBilltype.getString("number"))) {
                    EntryGrid entryGridHt = this.getControl("tpv_materialentry");//商品明细分录
                    int[] selectRowsHt = entryGridHt.getSelectRows();//获取选中的行号
                    if (selectRowsHt.length == 1) {
                        DynamicObject tpvMaterial = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_materialentry").get(selectRowsHt[0]).getDynamicObject("tpv_material");
                        if (tpvMaterial != null) {
                            ListShowParameter showMaterial = (ListShowParameter) e.getFormShowParameter();
                            List<QFilter> QMaterial = new ArrayList<QFilter>();
                            QMaterial.add(new QFilter("group", QCP.equals, tpvMaterial.getPkValue()));
                            showMaterial.getListFilterParameter().setQFilters(QMaterial);
                        }
                    }
                }


                break;
            default:
                break;
        }
    }
}