package tpv.tpv_wm.tpv_dt.java.formplugin.list;

import com.itopview.wm.utils.YEM;
import kd.bos.bill.BillShowParameter;
import kd.bos.form.events.SetFilterEvent;
import kd.bos.list.ListShowParameter;
import kd.bos.list.events.BeforeShowBillFormEvent;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.util.EventObject;

/**
 * @Description: 采购入库单 -列表插件  根据菜单入口参赋默认值，菜单列表打开
 * @Author LinRui
 * @Date 2024/4/24 19:27
 */
public class TpvPurInBillTpyeListPlugin extends AbstractListPlugin {

    @Override
    public void beforeShowBill(BeforeShowBillFormEvent e) {
        super.beforeShowBill(e);
        ListShowParameter listShowParameter = (ListShowParameter) this.getView().getFormShowParameter();
        Object purinreturn = listShowParameter.getCustomParam("purinreturn");
        if (YEM.isNotEmpty(purinreturn)) {
            BillShowParameter parameter = e.getParameter();
            parameter.setCustomParam("purinreturn",String.valueOf(purinreturn));
        }
    }

    @Override
    public void beforeBindData(EventObject e) {
        super.beforeBindData(e);
        ListShowParameter listShowParameter = (ListShowParameter) this.getView().getFormShowParameter();
        Object purinreturn = listShowParameter.getCustomParam("purinreturn");
        if (YEM.isNotEmpty(purinreturn)) {
            this.getView().setVisible(true,"tblnew");
        } else {
            this.getView().setVisible(false,"tblnew");
        }
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
//        ListShowParameter listShowParameter = (ListShowParameter) this.getView().getFormShowParameter();
//        Object purinreturn = listShowParameter.getCustomParam("purinreturn");
//        if (YEM.isNotEmpty(purinreturn)) {
//            this.getView().setVisible(false,"tblnew");
//        } else {
//            this.getView().setVisible(true,"tblnew");
//        }
    }

    @Override
    public void setFilter(SetFilterEvent e) {
        super.setFilter(e);
        ListShowParameter listShowParameter = (ListShowParameter) this.getView().getFormShowParameter();
        Object purinreturn = listShowParameter.getCustomParam("purinreturn");
        QFilter qFilter = null;
        if (YEM.isNotEmpty(purinreturn)) {
            if ("purinreturn".equals(String.valueOf(purinreturn))) {
                qFilter = new QFilter("biztype.number", QCP.equals,"1101");
            }
        } else {
            qFilter = new QFilter("biztype.number", QCP.not_equals,"1101");
        }
        if (null != qFilter) {
            e.getQFilters().add(qFilter);
        }
    }
}
