package tpv.tpv_wm.tpv_dt.java.formplugin.list;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.list.BillList;
import kd.bos.list.IListView;
import kd.bos.list.ListGridView;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * @ClassName: WbenchPurList
 * @Description: 国际证代开证工作台插件
 * @author: zbh
 * @date: 2023-11-07
 */
public class WbenchPurListPlugin extends AbstractListPlugin {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("toolbar", "toolbarap");
    }

    @Override
    public void beforeItemClick(BeforeItemClickEvent evt) {
        super.beforeItemClick(evt);
        String key = evt.getItemKey();
        switch (key) {
            case "tpv_push":
                push(evt);
                break;
        }
    }

    /**
     * @Title: push
     * @Descriptin: 点击的时候校检供应商+公司+币种+部门+贸易性质+价格条款相同且【可开证金额】>0
     * @retrn: a
     */
    private void push(BeforeItemClickEvent evt) {
        String formId = ((IListView) this.getView()).getBillFormId();

        BillList billList = this.getControl("billlistap");
        ListGridView billLists = this.getControl("gridview");
        ListSelectedRowCollection selectedRows = billList.getSelectedRows();
        if (selectedRows != null && selectedRows.size() > 0) {
            List<DynamicObject> dynamicObjects = new ArrayList<>();
            for (ListSelectedRow tempData : selectedRows) {
                DynamicObject dynamic = BusinessDataServiceHelper.loadSingle(tempData.getPrimaryKeyValue(), "tpv_dt_purchase");
                dynamicObjects.add(dynamic);
            }
            //供应商+公司+币种+部门+贸易性质+价格条款相同且【可开证金额】>0
            for (DynamicObject pur : dynamicObjects) {
                DynamicObject tpvSupplier = pur.getDynamicObject("tpv_supplier");//供应商
                DynamicObject org = pur.getDynamicObject("org");//公司
                DynamicObject tpvCurrency = pur.getDynamicObject("tpv_currency");//币种
                DynamicObject tpvDepartment = pur.getDynamicObject("tpv_department");//部门
                DynamicObject tpvTradeproperty = pur.getDynamicObject("tpv_tradeproperty");//贸易性质
                DynamicObject tpvPriceterms = pur.getDynamicObject("tpv_priceterms");//价格条款
                BigDecimal tpvMoneykzed = pur.getBigDecimal("tpv_moneykzed");//可开证金额
                if (tpvMoneykzed.compareTo(BigDecimal.ZERO) <= 0) {
                    this.getView().showErrorNotification("可开证金额小于0不允许生成！");
                    evt.setCancel(true);
                    return;
                }
                for (DynamicObject purX : dynamicObjects) {
                    DynamicObject tpvSupplierX = purX.getDynamicObject("tpv_supplier");//供应商
                    StringBuilder builder = new StringBuilder();
                    Boolean isFlag = false;
                    if (tpvSupplier != tpvSupplierX) {
                        if (builder.length() == 0) {
                            builder.append("供应商");
                        } else {
                            builder.append("，供应商");
                        }
                        isFlag = true;
                    }
                    DynamicObject orgX = purX.getDynamicObject("org");//公司
                    if (orgX != org) {
                        if (builder.length() == 0) {
                            builder.append("公司");
                        } else {
                            builder.append("，公司");
                        }
                        isFlag = true;
                    }
                    DynamicObject tpvCurrencyX = purX.getDynamicObject("tpv_currency");//币种
                    if (tpvCurrencyX != tpvCurrency) {
                        if (builder.length() == 0) {
                            builder.append("币种");
                        } else {
                            builder.append("，币种");
                        }
                        isFlag = true;
                    }
                    DynamicObject tpvDepartmentX = purX.getDynamicObject("tpv_department");//部门
                    if (tpvDepartment != tpvDepartmentX) {
                        if (builder.length() == 0) {
                            builder.append("部门");
                        } else {
                            builder.append("，部门");
                        }
                        isFlag = true;
                    }
                    DynamicObject tpvTradepropertyX = purX.getDynamicObject("tpv_tradeproperty");//贸易性质
                    if (tpvTradepropertyX != tpvTradeproperty) {
                        if (builder.length() == 0) {
                            builder.append("贸易性质");
                        } else {
                            builder.append("，贸易性质");
                        }
                        isFlag = true;
                    }
                    DynamicObject tpvPricetermsX = purX.getDynamicObject("tpv_priceterms");//价格条款
                    if (tpvPricetermsX != tpvPriceterms) {
                        if (builder.length() == 0) {
                            builder.append("价格条款");
                        } else {
                            builder.append("，价格条款");
                        }
                        isFlag = true;
                    }
                    if (isFlag) {
                        this.getView().showErrorNotification(builder + "不同不允许合并生成！");
                        evt.setCancel(true);
                        return;
                    }
                    BigDecimal tpvMoneykzedX = purX.getBigDecimal("tpv_moneykzed");//可开证金额
                    if (tpvMoneykzedX.compareTo(BigDecimal.ZERO) <= 0) {
                        this.getView().showErrorNotification("可开证金额小于0不允许合并生成！");
                        evt.setCancel(true);
                        return;
                    }
                }
            }
        }
    }
}
