package tpv.tpv_wm.tpv_dt.java.opplugin.convert;

import com.itopview.wm.utils.DateUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;

import java.util.Date;

/**
 *@Description: 协议到采购、销售合同 签约时间计算
 *@Project: zhck
 *@Package: tpv.tpv_wm.tpv_dt.java.opplugin.convert.AggmentToSaleOrderConvert
 *@Date: 2024/04/17 20:07
 *@Author: Heisenberg Wenbei He
 *@Version: 1.0
 */
public class AggmentToSaleOrderConvert extends AbstractConvertPlugIn {

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] extendedDataEntities = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        for (ExtendedDataEntity entity : extendedDataEntities) {

            DynamicObject dataEntity = entity.getDataEntity();
            String sign = "";
            String symbol = "";

            switch (dataEntity.getDataEntityType().getName()) {

                // 销售合同
                case "tpv_dt_salescontract":
                    sign = "tpv_usedate"; //合同有效期限
                    symbol = "tpv_signingdate"; //签约日期
                    break;

                // 采购合同
                case "tpv_dt_purchase":
                    sign = "tpv_durationofthecontr"; //合同有效期限
                    symbol = "tpv_dateofcontracting"; //签约日期
                    break;
                default:
                    break;
            }

            if (!sign.isEmpty()) {
                addDate(dataEntity, sign, symbol);
            }
        }
    }

    private static void addDate(DynamicObject dataEntity, String sign, String symbol) {
        Date bizdate = dataEntity.getDate("tpv_bizdate");
        if (bizdate != null) {
            dataEntity.set(symbol, bizdate);
            Date date = DateUtil.addDays(bizdate, -1);
            int year = date.getYear() + 1;
            date.setYear(year);
            dataEntity.set(sign, date);//合同有效日期
        } else {
            dataEntity.set(sign, null);//合同有效日期
        }
    }
}
