package tpv.tpv_wm.tpv_dt.java.opplugin.convert;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName 实提工作台货物流转下推采购入库改数据
 * @Description TODO
 * @Author WangShuGuang
 * @Date 2023/9/21
 * @Version 1.0
 */
public class CargoConvert extends AbstractConvertPlugIn {

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        OperateOption option = this.getOption();
        boolean contains = option.containsVariable("tpv_longList");
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            if (contains) {
                String list = this.getOption().getVariableValue("tpv_longList");
                Long tpv_fentryid_zy = Long.valueOf(this.getOption().getVariableValue("tpv_longList_id"));
                if (YEM.isNotEmpty(list)) {
                    JSONArray jsonArray = JSONObject.parseArray(list);
                    List<DynamicObject> indexDyObjects = new ArrayList<>();
                    DynamicObjectCollection objectCollection = dataEntity.getDynamicObjectCollection("billentry");
                    for (int i = 0; i < objectCollection.size(); i++) {
                        DynamicObject dynamicObject = objectCollection.get(i);
                        if (tpv_fentryid_zy.compareTo(dynamicObject.getLong("mainbillentryid")) != 0) {
                            indexDyObjects.add(dynamicObject);
                        }
                    }
                    if (indexDyObjects.size() > 0) {
                        for (DynamicObject index : indexDyObjects) {
                            objectCollection.remove(index);
                        }
                    }
                    DynamicObjectCollection dynamicObjects = objectCollection;
                    for (int i = 0; i < dynamicObjects.size(); i++) {
                        DynamicObject dynamicObject = dynamicObjects.get(i);
                        for (int j = 0; j < jsonArray.size(); j++) {
                            JSONObject jsonObject = jsonArray.getJSONObject(j);
                            if (tpv_fentryid_zy.compareTo(dynamicObject.getLong("mainbillentryid")) == 0) {
                                if (j == 0) {
                                    dynamicObject.set("tpv_packnum", jsonObject.get("tpv_ofpackages"));//包装数量
                                    dynamicObject.set("material", jsonObject.get("tpv_materials"));//商品
                                    dynamicObject.set("tpv_prodname", jsonObject.get("tpv_prodnames"));//品名
                                    dynamicObject.set("tpv_shader", jsonObject.get("tpv_shaders"));//材质
                                    dynamicObject.set("tpv_specation", jsonObject.get("tpv_specations"));//规格
                                    Long tpvOriginsId = (Long)jsonObject.get("tpv_origins");
                                    QFilter qFilterZh = new QFilter("tpv_bd_origin.id", QCP.equals, tpvOriginsId);
                                    String selectfields = DynamicObjectUtil.getSelectfields("tpv_bd_origin");
                                    DynamicObject tpvBdOrigin = BusinessDataServiceHelper.loadSingle("tpv_bd_origin", selectfields, new QFilter[]{qFilterZh});
                                    dynamicObject.set("tpv_origin", tpvBdOrigin);//产地
                                    BigDecimal tpvPurchasequantity = jsonObject.getBigDecimal("tpv_purchasequantity");//采提数量
                                    BigDecimal priceandtax = dynamicObject.getBigDecimal("priceandtax");//含税单价
                                    BigDecimal exchangerate = dataEntity.getBigDecimal("exchangerate");//汇率
                                    BigDecimal taxrate = dynamicObject.getBigDecimal("taxrate");//税率
                                    if (priceandtax.compareTo(BigDecimal.ZERO) != 0 ){
                                        //数量 不等于 0 and 商品明细.含税单价 不等于 0
                                        //价税合计 = 含税单价 * 数量
                                        BigDecimal amountandtax = priceandtax.multiply(tpvPurchasequantity);//价税合计
                                        dynamicObject.set("amountandtax",amountandtax);//价税合计
                                        if (exchangerate.compareTo(BigDecimal.ZERO) != 0){
                                            //价税合计(本位币) = 价税合计 * 汇率
                                            BigDecimal curamountandtax  = amountandtax.multiply(exchangerate);//价税合计
                                            dynamicObject.set("curamountandtax",curamountandtax);//价税合计(本位币)
                                        }
                                        if (null != taxrate){
                                            //税额 = 价税合计 / ( 1 + 税率% / 100 ) * 税率% / 100
                                            BigDecimal taxAmount = amountandtax.divide(BigDecimal.ONE.add(taxrate.divide(new BigDecimal("100"), 11, RoundingMode.HALF_UP)), 2, RoundingMode.HALF_UP)
                                                    .multiply(taxrate.divide(new BigDecimal("100")));//税额
                                            taxAmount = taxAmount.setScale(2,BigDecimal.ROUND_HALF_UP);
                                            dynamicObject.set("taxamount",taxAmount);//税额
                                            //金额 = 价税合计 / ( 1 + 税率% / 100 )
                                            BigDecimal taxAmountS = taxrate.divide(new BigDecimal("100")).add(BigDecimal.ONE); // 计算税率的倍数
                                            BigDecimal netAmount = amountandtax.divide(taxAmountS, 2, BigDecimal.ROUND_HALF_UP); // 保留两位小数//金额
                                            dynamicObject.set("amount",netAmount);//金额

                                            if (exchangerate.compareTo(BigDecimal.ZERO) != 0){
                                                //税额(本位币) = 税额 * 汇率
                                                BigDecimal curtaxamount = taxAmount.multiply(exchangerate);
                                                dynamicObject.set("curtaxamount",curtaxamount);//税额(本位币)
                                                //金额(本位币) = 金额 * 汇率
                                                BigDecimal curamount = netAmount.multiply(exchangerate);
                                                dynamicObject.set("curamount",curamount);//金额(本位币)
                                            }
                                        }
                                    }
                                    BigDecimal tpvDestroyquantity = jsonObject.getBigDecimal("tpv_destroyquantity");//销提数量
                                    BigDecimal qty = tpvPurchasequantity.compareTo(tpvDestroyquantity) > 0 ? tpvDestroyquantity : tpvPurchasequantity;
                                    dynamicObject.set("qty", tpvPurchasequantity);//数量
                                    dynamicObject.set("baseqty", tpvPurchasequantity);//基本数量
                                    String tpvGaplimit = jsonObject.getString("tpv_gaplimit");
                                    BigDecimal tpvGapLimit = new BigDecimal(tpvGaplimit);
                                    BigDecimal tpvGapLimitAbs = tpvGapLimit.abs();
                                    dynamicObject.set("tpv_gaplimit", tpvGapLimitAbs);//差额
                                    //dynamicObject.set("qty", jsonObject.get("tpv_destroyquantity"));//销提数量
                                    dynamicObject.set("tpv_directconsignmentid", jsonObject.get("tpv_directconsignmentid"));//分录id
                                } else {
                                    DynamicObject dynamicObjectS = new DynamicObject(dynamicObject.getDynamicObjectType());
                                    DynamicObjectUtil.copyDynamicObject(dynamicObject, dynamicObjectS);
                                    dynamicObjectS.set("tpv_packnum", jsonObject.get("tpv_ofpackages"));//包装数量
                                    dynamicObjectS.set("material", jsonObject.get("tpv_materials"));//商品
                                    dynamicObjectS.set("tpv_prodname", jsonObject.get("tpv_prodnames"));//品名
                                    dynamicObjectS.set("tpv_shader", jsonObject.get("tpv_shaders"));//材质
                                    dynamicObjectS.set("tpv_specation", jsonObject.get("tpv_specations"));//规格
                                    Long tpvOriginsId = (Long)jsonObject.get("tpv_origins");
                                    QFilter qFilterZh = new QFilter("tpv_bd_origin.id", QCP.equals, tpvOriginsId);
                                    String selectfields = DynamicObjectUtil.getSelectfields("tpv_bd_origin");
                                    DynamicObject tpvBdOrigin = BusinessDataServiceHelper.loadSingle("tpv_bd_origin", selectfields, new QFilter[]{qFilterZh});
                                    dynamicObjectS.set("tpv_origin", tpvBdOrigin);//产地
                                    BigDecimal tpvPurchasequantity = jsonObject.getBigDecimal("tpv_purchasequantity");//采提数量
                                    BigDecimal tpvDestroyquantity = jsonObject.getBigDecimal("tpv_destroyquantity");//销提数量
                                    BigDecimal priceandtax = dynamicObjectS.getBigDecimal("priceandtax");//含税单价
                                    BigDecimal exchangerate = dataEntity.getBigDecimal("exchangerate");//汇率
                                    BigDecimal taxrate = dynamicObjectS.getBigDecimal("taxrate");//税率
                                    if (priceandtax.compareTo(BigDecimal.ZERO) != 0 ){
                                        //数量 不等于 0 and 商品明细.含税单价 不等于 0
                                        //价税合计 = 含税单价 * 数量
                                        BigDecimal amountandtax = priceandtax.multiply(tpvPurchasequantity);//价税合计
                                        dynamicObjectS.set("amountandtax",amountandtax);//价税合计
                                        if (exchangerate.compareTo(BigDecimal.ZERO) != 0){
                                            //价税合计(本位币) = 价税合计 * 汇率
                                            BigDecimal curamountandtax  = amountandtax.multiply(exchangerate);//价税合计
                                            dynamicObjectS.set("curamountandtax",curamountandtax);//价税合计(本位币)
                                        }
                                        if (null != taxrate){
                                            //税额 = 价税合计 / ( 1 + 税率% / 100 ) * 税率% / 100
                                            BigDecimal taxAmount = amountandtax.divide(BigDecimal.ONE.add(taxrate.divide(new BigDecimal("100"), 11, RoundingMode.HALF_UP)), 2, RoundingMode.HALF_UP)
                                                    .multiply(taxrate.divide(new BigDecimal("100")));//税额
                                            taxAmount = taxAmount.setScale(2,BigDecimal.ROUND_HALF_UP);
                                            dynamicObjectS.set("taxamount",taxAmount);//税额
                                            //金额 = 价税合计 / ( 1 + 税率% / 100 )
                                            BigDecimal taxAmountS = taxrate.divide(new BigDecimal("100")).add(BigDecimal.ONE); // 计算税率的倍数
                                            BigDecimal netAmount = amountandtax.divide(taxAmountS, 2, BigDecimal.ROUND_HALF_UP); // 保留两位小数//金额
                                            dynamicObjectS.set("amount",netAmount);//金额

                                            if (exchangerate.compareTo(BigDecimal.ZERO) != 0){
                                                //税额(本位币) = 税额 * 汇率
                                                BigDecimal curtaxamount = taxAmount.multiply(exchangerate);
                                                dynamicObjectS.set("curtaxamount",curtaxamount);//税额(本位币)
                                                //金额(本位币) = 金额 * 汇率
                                                BigDecimal curamount = netAmount.multiply(exchangerate);
                                                dynamicObjectS.set("curamount",curamount);//金额(本位币)
                                            }
                                        }
                                    }
                                    BigDecimal qty = tpvPurchasequantity.compareTo(tpvDestroyquantity) > 0 ? tpvDestroyquantity : tpvPurchasequantity;
                                    dynamicObjectS.set("qty", tpvPurchasequantity);//数量
                                    dynamicObjectS.set("baseqty", tpvPurchasequantity);//基本数量
                                    //dynamicObjectS.set("qty", jsonObject.get("tpv_purchasequantity"));//采提数量
                                    String tpvGaplimit = jsonObject.getString("tpv_gaplimit");
                                    BigDecimal tpvGapLimit = new BigDecimal(tpvGaplimit);
                                    BigDecimal tpvGapLimitAbs = tpvGapLimit.abs();
                                    dynamicObjectS.set("tpv_gaplimit", tpvGapLimitAbs);//差额
                                    //dynamicObject.set("qty", jsonObject.get("tpv_destroyquantity"));//销提数量
                                    dynamicObjectS.set("tpv_directconsignmentid", jsonObject.get("tpv_directconsignmentid"));//分录id
                                    objectCollection.add(i++, dynamicObjectS);
                                }
                            }
                        }
                    }
                }
            }
        }
    }

}
