package tpv.tpv_wm.tpv_dt.java.opplugin.convert;

import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterBuildQueryParemeterEventArgs;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.entity.botp.plugin.args.AfterGetSourceDataEventArgs;

import java.math.BigDecimal;
import java.util.List;
import java.util.Set;


/**
 * @ClassName 标准下推改数量
 * @Description TODO
 * @Author yhj
 * @Date 2023/8/28 16:14
 * @Version 1.0
 */
public class FlowConvert extends AbstractConvertPlugIn {
    @Override
    public void afterBuildQueryParemeter(AfterBuildQueryParemeterEventArgs e) {
        e.addSrcField("tpv_baseqty");
    }
    /**
     * @description: 修改上游单数据
     * @author yhj
     * @date 2023/11/13 11:58
     * @version 1.0
     */
    @Override
    public void afterGetSourceData(AfterGetSourceDataEventArgs e) {
        super.afterGetSourceData(e);
        OperateOption option = this.getOption();
        boolean contains = option.containsVariable("longList");
        List<DynamicObject> sourceEntryData = e.getSourceRows();
        String name = this.getSrcMainType().getName();
        if (contains) {
            String List = this.getOption().getVariableValue("longList");
            JSONObject jsonObjects = JSONObject.parseObject(List);
            Set<String> strings = jsonObjects.keySet();
            for (String key : strings) {
                for (DynamicObject putStorage : sourceEntryData) {
                    Long pkId = (Long) e.getFldProperties().get("tpv_materialentry.id").getValue(putStorage);
                    String pkIds = String.valueOf(pkId);
                    if (pkIds.equals(key)) {
                        if (jsonObjects.getBigDecimal(String.valueOf(pkId)) != null && jsonObjects.getBigDecimal(String.valueOf(pkId)).compareTo(BigDecimal.ZERO) > 0) {
                            if (name.equals("tpv_dt_freigroambill")) {//货物流转
                                if (e.getFldProperties().get("tpv_baseqty") != null || e.getFldProperties().get("tpv_qty") != null) {
                                    BigDecimal tinnum = (BigDecimal) e.getFldProperties().get("tpv_tinnum").getValue(putStorage);
                                    BigDecimal alreroamnum = (BigDecimal) e.getFldProperties().get("tpv_alreroamnum").getValue(putStorage);
                                    e.getFldProperties().get("tpv_qty").setValue(putStorage, jsonObjects.getBigDecimal(String.valueOf(pkId))
                                            .add(tinnum).add(alreroamnum));
                                    e.getFldProperties().get("tpv_baseqty").setValue(putStorage, jsonObjects.getBigDecimal(String.valueOf(pkId))
                                            .add(tinnum).add(alreroamnum));
                                }
                            } else {
                                if (e.getFldProperties().get("tpv_baseqty") != null || e.getFldProperties().get("tpv_qty") != null) {
                                    BigDecimal flowedquantity = (BigDecimal) e.getFldProperties().get("tpv_flowedquantity").getValue(putStorage);
                                    e.getFldProperties().get("tpv_qty").setValue(putStorage, jsonObjects.getBigDecimal(String.valueOf(pkId))
                                            .add(flowedquantity));
                                    e.getFldProperties().get("tpv_baseqty").setValue(putStorage, jsonObjects.getBigDecimal(String.valueOf(pkId))
                                            .add(flowedquantity));
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    /**
     * @description: 修改下游单数据
     * @author yhj
     * @date 2023/11/13 11:58
     * @version 1.0
     */
    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        String nameOne = "tpv_dt_freigroambill";//货物流转
        boolean tpvZjVariable = this.getOption().containsVariable("tpvZj");
        boolean tpvHwVariable = this.getOption().containsVariable("tpvHw");
        if (tpvZjVariable && tpvHwVariable) {
            String tpvZj = this.getOption().getVariableValue("tpvZj");//直接入库按钮
            String tpvHw = this.getOption().getVariableValue("tpvHw");//货物流转按钮
            //目标单为货物流转
            ExtendedDataEntity[] entryentitiess = e.getTargetExtDataEntitySet().FindByEntityKey(nameOne);
            if (nameOne.equals("tpv_dt_freigroambill")) {
                for (ExtendedDataEntity entryentity : entryentitiess) {
                    //目标单
                    DynamicObject targetBill = entryentity.getDataEntity();
                    if (null != tpvZj) {
                        JSONObject jsonObjects = JSONObject.parseObject(tpvZj);
                        JSONObject jsonObjectes = JSONObject.parseObject(tpvHw);
                        if (jsonObjects.getBigDecimal("tpvZj").compareTo(BigDecimal.TEN) == 0) {
                            targetBill.set("tpv_directstorage", true);
                            targetBill.set("tpv_roamaction", "I");
                            targetBill.set("tpv_makeway", "B");//自动下推
                        }
                        if (jsonObjectes.getBigDecimal("tpvHw").compareTo(BigDecimal.ONE) == 0) {
                            targetBill.set("tpv_directstorage", false);
                        }
                    }
                }
            }
        }
    }
}

