package tpv.tpv_wm.tpv_dt.java.opplugin.convert;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;

import java.math.BigDecimal;
import java.math.RoundingMode;

/**
 * @ClassName 实提工作台销售发货下推销售出库改数据
 * @Description TODO
 * @Author WangShuGuang
 * @Date 2023/9/21
 * @Version 1.0
 */
public class MarketConvert extends AbstractConvertPlugIn {

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        OperateOption option = this.getOption();
        boolean contains = option.containsVariable("tpv_longList");
        boolean longList = option.containsVariable("longList");
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            if (longList) {
                String List = this.getOption().getVariableValue("longList");
                JSONArray jsonArray = JSONObject.parseArray(List);
                DynamicObjectCollection objectCollection = dataEntity.getDynamicObjectCollection("billentry");
                for (int i = 0; i < objectCollection.size(); i++) {
                    DynamicObject dynamicObject = objectCollection.get(i);
                    for (int j = 0; j < jsonArray.size(); j++) {
                        JSONObject jsonObject = jsonArray.getJSONObject(j);
                        long directconsignmentid = 0l;
                        if (!jsonObject.containsKey("insubentry")) {
                            directconsignmentid = dynamicObject.getLong("tpv_directconsignmentid");
                        } else if (jsonObject.containsKey("insubentry")) {
                            directconsignmentid = dynamicObject.getLong("tpv_srcbillsubentryid");
                        }
                        long aLong = Long.valueOf(jsonObject.get("tpv_directconsignmentid").toString());
                        if (directconsignmentid == aLong) {
                            BigDecimal qtyOne = jsonObject.getBigDecimal("tpv_destroyquantity");//数量
                            BigDecimal priceandtax = dynamicObject.getBigDecimal("priceandtax");//含税单价
                            BigDecimal exchangerate = dataEntity.getBigDecimal("exchangerate");//汇率
                            BigDecimal taxrate = dynamicObject.getBigDecimal("taxrate");//税率%
                            if (qtyOne.compareTo(BigDecimal.ZERO) != 0 && priceandtax.compareTo(BigDecimal.ZERO) != 0) {
                                //计算价税合计
                                BigDecimal amountandtax = qtyOne.multiply(priceandtax);
                                dynamicObject.set("amountandtax", amountandtax);//价税合计
                                if (exchangerate.compareTo(BigDecimal.ZERO) != 0) {
                                    BigDecimal curamountandtax = amountandtax.multiply(exchangerate);
                                    dynamicObject.set("curamountandtax", curamountandtax);//价税合计(本位币)
                                }
                                if (null != taxrate) {
                                    //计算金额
                                    BigDecimal divide = taxrate.divide(new BigDecimal(100), 2, RoundingMode.HALF_UP);//( 税率% / 100 )
                                    BigDecimal add = divide.add(BigDecimal.ONE);//( 1 + 税率% / 100 )
                                    BigDecimal amount = amountandtax.divide(add, 2, RoundingMode.HALF_UP);
                                    dynamicObject.set("amount", amount);//金额
                                    if (exchangerate.compareTo(BigDecimal.ZERO) != 0) {
                                        BigDecimal curamount = amount.multiply(exchangerate);
                                        dynamicObject.set("curamount", curamount);//金额(本位币)
                                    }
                                    //税额 = 价税合计 * ( 税率% / 100 ) / ( 1 + 税率% / 100 )
                                    BigDecimal taxamount = amountandtax.multiply(divide).divide(add, 2, RoundingMode.HALF_UP);//税额
                                    dynamicObject.set("taxamount", taxamount);
                                    //税额本位币等于税额*汇率
                                    dynamicObject.set("curtaxamount", taxamount.multiply(exchangerate));
                                }
                            }
                            dynamicObject.set("qty", jsonObject.get("tpv_destroyquantity"));//数量
                            dynamicObject.set("tpv_packnum", jsonObject.get("tpv_fpackagereal"));//数量
                            dynamicObject.set("tpv_directconsignmentid", jsonObject.get("tpv_directconsignmentid"));//分录id
                            if (jsonObject.containsKey("tpv_isrowout")) {
                                dynamicObject.set("tpv_isrowout", jsonObject.get("tpv_isrowout"));//分录id
                            }
                        }
                    }
                }
            }
            if (contains) { //库存拣配旧实提工作台(下方逻辑弃用)，暂未维护修改，若使用，则检查逻辑
                String List = this.getOption().getVariableValue("tpv_longList");
                Long tpv_fentryid_zy = Long.valueOf(this.getOption().getVariableValue("tpv_longList_id"));
                JSONArray jsonArray = JSONObject.parseArray(List);
                DynamicObjectCollection objectCollection = dataEntity.getDynamicObjectCollection("billentry");
                for (DynamicObject dynamicObject : objectCollection) {
                    for (int i = 0; i < jsonArray.size(); i++) {
                        JSONObject jsonObject = jsonArray.getJSONObject(i);
                        if (i == 0) {
                            BigDecimal qtyOne = jsonObject.getBigDecimal("tpv_destroyquantity");//数量
                            BigDecimal priceandtax = dynamicObject.getBigDecimal("priceandtax");//含税单价
                            BigDecimal exchangerate = dataEntity.getBigDecimal("exchangerate");//汇率
                            BigDecimal taxrate = dynamicObject.getBigDecimal("taxrate");//税率%
                            if (qtyOne.compareTo(BigDecimal.ZERO) != 0 && priceandtax.compareTo(BigDecimal.ZERO) != 0) {
                                //计算价税合计
                                BigDecimal amountandtax = qtyOne.multiply(priceandtax);
                                dynamicObject.set("amountandtax", amountandtax);//价税合计
                                if (exchangerate.compareTo(BigDecimal.ZERO) != 0) {
                                    BigDecimal curamountandtax = amountandtax.multiply(exchangerate);
                                    dynamicObject.set("curamountandtax", curamountandtax);//价税合计(本位币)
                                }
                                if (null != taxrate) {
                                    //计算金额
                                    BigDecimal divide = taxrate.divide(new BigDecimal(100), 2, RoundingMode.HALF_UP);//( 税率% / 100 )
                                    BigDecimal add = divide.add(BigDecimal.ONE);//( 1 + 税率% / 100 )
                                    BigDecimal amount = amountandtax.divide(add, 2, RoundingMode.HALF_UP);
                                    dynamicObject.set("amount", amount);//金额
                                    if (exchangerate.compareTo(BigDecimal.ZERO) != 0) {
                                        BigDecimal curamount = amount.multiply(exchangerate);
                                        dynamicObject.set("curamount", curamount);//金额(本位币)
                                    }
                                    //税额 = 价税合计 * ( 税率% / 100 ) / ( 1 + 税率% / 100 )
                                    BigDecimal taxamount = amountandtax.multiply(divide).divide(add, 2, RoundingMode.HALF_UP);//税额
                                    dynamicObject.set("taxamount", taxamount);
                                    //税额本位币等于税额*汇率
                                    dynamicObject.set("curtaxamount", taxamount.multiply(exchangerate));
                                }
                            }
                            dynamicObject.set("qty", jsonObject.get("tpv_destroyquantity"));//数量
                            dynamicObject.set("tpv_packnum", jsonObject.get("tpv_ofpackages"));//包装数量
                            dynamicObject.set("tpv_prodname", jsonObject.get("tpv_prodnames"));//品名
                            dynamicObject.set("tpv_shader", jsonObject.get("tpv_shaders"));//材质
                            dynamicObject.set("tpv_specation", jsonObject.get("tpv_specations"));//规格
                            dynamicObject.set("tpv_origin", jsonObject.get("tpv_origins"));//产地
                            dynamicObject.set("material", jsonObject.get("tpv_materials"));//商品
                            dynamicObject.set("tpv_directconsignmentid", jsonObject.get("tpv_directconsignmentid"));//分录id
                        } else {
                            DynamicObject dynamicObjectS = new DynamicObject(dynamicObject.getDynamicObjectType());
                            DynamicObjectUtil.copyDynamicObject(dynamicObject, dynamicObjectS);
                            BigDecimal qtyOne = jsonObject.getBigDecimal("tpv_destroyquantity");//数量
                            BigDecimal priceandtax = dynamicObjectS.getBigDecimal("priceandtax");//含税单价
                            BigDecimal exchangerate = dataEntity.getBigDecimal("exchangerate");//汇率
                            BigDecimal taxrate = dynamicObjectS.getBigDecimal("taxrate");//税率%
                            if (qtyOne.compareTo(BigDecimal.ZERO) != 0 && priceandtax.compareTo(BigDecimal.ZERO) != 0) {
                                //计算价税合计
                                BigDecimal amountandtax = qtyOne.multiply(priceandtax);
                                dynamicObjectS.set("amountandtax", amountandtax);//价税合计
                                if (exchangerate.compareTo(BigDecimal.ZERO) != 0) {
                                    BigDecimal curamountandtax = amountandtax.multiply(exchangerate);
                                    dynamicObjectS.set("curamountandtax", curamountandtax);//价税合计(本位币)
                                }
                                if (null != taxrate) {
                                    //计算金额
                                    BigDecimal divide = taxrate.divide(new BigDecimal(100), 2, RoundingMode.HALF_UP);//( 税率% / 100 )
                                    BigDecimal add = divide.add(BigDecimal.ONE);//( 1 + 税率% / 100 )
                                    BigDecimal amount = amountandtax.divide(add, 2, RoundingMode.HALF_UP);
                                    dynamicObjectS.set("amount", amount);//金额
                                    if (exchangerate.compareTo(BigDecimal.ZERO) != 0) {
                                        BigDecimal curamount = amount.multiply(exchangerate);
                                        dynamicObjectS.set("curamount", curamount);//金额(本位币)
                                    }
                                    //税额 = 价税合计 * ( 税率% / 100 ) / ( 1 + 税率% / 100 )
                                    BigDecimal taxamount = amountandtax.multiply(divide).divide(add, 2, RoundingMode.HALF_UP);//税额
                                    dynamicObjectS.set("taxamount", taxamount);
                                    //税额本位币等于税额*汇率
                                    dynamicObjectS.set("curtaxamount", taxamount.multiply(exchangerate));
                                }
                            }
                            dynamicObjectS.set("qty", jsonObject.get("tpv_destroyquantity"));//数量
                            dynamicObjectS.set("tpv_packnum", jsonObject.get("tpv_ofpackages"));//包装数量
                            dynamicObjectS.set("tpv_prodname", jsonObject.get("tpv_prodnames"));//品名
                            dynamicObjectS.set("tpv_shader", jsonObject.get("tpv_shaders"));//材质
                            dynamicObjectS.set("tpv_specation", jsonObject.get("tpv_specations"));//规格
                            dynamicObjectS.set("tpv_origin", jsonObject.get("tpv_origins"));//产地
                            dynamicObjectS.set("material", jsonObject.get("tpv_materials"));//商品
                            dynamicObjectS.set("tpv_directconsignmentid", jsonObject.get("tpv_directconsignmentid"));//分录id
                            objectCollection.add(i++, dynamicObjectS);
                        }
                    }
                    break;
                }
            }
        }
    }
    /*@Override
    public void afterGetSourceData(AfterGetSourceDataEventArgs e) {
        super.afterGetSourceData(e);
        OperateOption option = this.getOption();
        boolean contains = option.containsVariable("tpv_longList");
        List<DynamicObject> sourceEntryData = e.getSourceRows();
        if (contains) {
            Map<String, Object> innerMap = new HashMap<>();
            String List = this.getOption().getVariableValue("tpv_longList");
            JSONObject jsonObjects = JSONObject.parseObject(List);
            Set<String> keys = jsonObjects.keySet();
            Long myLong = new Long(0);
            for (String keyss : keys) {
                Long outerKey = Long.parseLong(keyss);
                myLong = outerKey;
                JSONObject innerJsonObject = jsonObjects.getJSONObject(keyss);
                Set<String> innerKeys = innerJsonObject.keySet();
                for (String innerKey : innerKeys) {
                    innerMap.put(innerKey, innerJsonObject.get(innerKey));
                }
            }
            for (DynamicObject putStorage : sourceEntryData) {
                Long pkId = (Long) e.getFldProperties().get("tpv_materialentry.tpv_dt_salepick_in.id").getValue(putStorage);
                if (myLong.equals(pkId)) {
                    e.getFldProperties().get("tpv_pickqty_in").setValue(putStorage, innerMap.get("tpv_materials"));//销提数量
                    //e.getFldProperties().get("tpv_packnum_in").setValue(putStorage, innerMap.get("tpv_ofpackages"));//包装数量
                }
            }
        }
    }*/
}
