package tpv.tpv_wm.tpv_dt.java.opplugin.convert;

import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;


/**
 * @Description: 价格确认单工作台标准下推改合同号
 * @Author LinRui
 * @Date 2023/10/31 19:04
 */
public class PriceConvert extends AbstractConvertPlugIn {
    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        OperateOption option = this.getOption();
        boolean contains = option.containsVariable("longList");
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            if (contains) {
                String List = this.getOption().getVariableValue("longList");
                JSONObject jsonObject = JSONObject.parseObject(List);
                DynamicObjectCollection objectCollection = dataEntity.getDynamicObjectCollection("tpv_materialentry");
                for (DynamicObject dynamicObject : objectCollection) {
                    Long tpvSrcsubid = dynamicObject.getLong("tpv_srcsubid"); //来源销售发货拣配库存子分录ID
                    if (jsonObject.containsKey(tpvSrcsubid)) {
                        dynamicObject.set("tpv_purbillno", jsonObject.get(tpvSrcsubid));//采购合同号
                    }
                }
            }
        }
    }
}

