package tpv.tpv_wm.tpv_dt.java.opplugin.convert;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;


/**
 * @ClassName 实提工作台采购合同下推货物流转改数据
 * @Description TODO
 * @Author WangShuGuang
 * @Date 2023/9/21-
 * @Version 1.0
 */
public class ProcurementConvert extends AbstractConvertPlugIn {

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        OperateOption option = this.getOption();
        boolean tpvLongList = option.containsVariable("tpv_longList");
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            if (tpvLongList) {
                String List = this.getOption().getVariableValue("tpv_longList");
                Long tpv_fentryid_zy = Long.valueOf(this.getOption().getVariableValue("tpv_longList_id"));
                JSONArray jsonArray = JSONObject.parseArray(List);
                java.util.List<DynamicObject> indexDyObjects = new ArrayList<>();
                DynamicObjectCollection objectCollection = dataEntity.getDynamicObjectCollection("tpv_materialentry");
                for (int i = 0; i < objectCollection.size(); i++) {
                    DynamicObject dynamicObject = objectCollection.get(i);
                    if (tpv_fentryid_zy.compareTo(dynamicObject.getLong("tpv_coentryid")) != 0) {
                        indexDyObjects.add(dynamicObject);
                    }
                }
                if (indexDyObjects.size() > 0) {
                    for (DynamicObject index : indexDyObjects) {
                        objectCollection.remove(index);
                    }
                }
                for (int i = 0; i < objectCollection.size(); i++) {
                    DynamicObject dynamicObject = objectCollection.get(i);
                    for (int j = 0; j < jsonArray.size(); j++) {
                        JSONObject jsonObject = jsonArray.getJSONObject(j);
                        if (tpv_fentryid_zy.equals(dynamicObject.getLong("tpv_coentryid"))) {
                            if (j == 0) {
                                BigDecimal tpvExchangerealrate = dataEntity.getBigDecimal("tpv_exchangerealrate");//当天汇率
                                BigDecimal tpvNottaxamount = dynamicObject.getBigDecimal("tpv_nottaxamount");//不含税金额
                                BigDecimal tpvPurchasequantity = jsonObject.getBigDecimal("tpv_purchasequantity");//数量
                                boolean tpvInputamount = dataEntity.getBoolean("tpv_inputamount");//录入金额
                                BigDecimal tpvTaxpramount = dynamicObject.getBigDecimal("tpv_taxpramount");//含税金额
                                BigDecimal tpvTaxprice = dynamicObject.getBigDecimal("tpv_taxprice");//含税单价
                                BigDecimal tpvVatrates = dynamicObject.getBigDecimal("tpv_vatrates");//增值税率%
                                if (tpvExchangerealrate.compareTo(BigDecimal.ZERO) != 0 && tpvNottaxamount.compareTo(BigDecimal.ZERO) != 0) {
                                    //当天汇率 <> 0 and 不含税金额 <> 0
                                    //不含税金额本位币 = 不含税金额 * 当天汇率
                                    dynamicObject.set("tpv_nottaxstancoin", tpvNottaxamount.multiply(tpvExchangerealrate));
                                }
                                if (tpvExchangerealrate.compareTo(BigDecimal.ZERO) != 0 && tpvTaxpramount.compareTo(BigDecimal.ZERO) != 0) {
                                    //当天汇率 <> 0 and 含税金额 <> 0
                                    //含税金额本位币 = 含税金额 * 当天汇率
                                    dynamicObject.set("tpv_taxstancoin", tpvTaxpramount.multiply(tpvExchangerealrate));
                                }
                                if (tpvVatrates.compareTo(BigDecimal.ZERO) != 0 && tpvTaxprice.compareTo(BigDecimal.ZERO) != 0) {
                                    //含税单价 <> 0 and 增值税率% <> 0
                                    //不含税单价 = 含税单价 / ( 1 + 增值税率% / 100 )
                                    BigDecimal tax = tpvVatrates.divide(new BigDecimal("100")); // 将百分比转换为小数
                                    BigDecimal tpv_price = tpvTaxprice.divide(tax.add(new BigDecimal("1")), 2, RoundingMode.HALF_UP);
                                    dynamicObject.set("tpv_price", tpv_price);//不含税单价
                                }
                                if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && tpvTaxpramount.compareTo(BigDecimal.ZERO) != 0 && tpvInputamount) {
                                    //含税金额 <> 0 and 数量 <> 0 and 录入金额 = true
                                    //含税单价 = 含税金额 / 数量
                                    BigDecimal tpv_taxprice = tpvTaxpramount.divide(tpvPurchasequantity, 2, RoundingMode.HALF_UP);
                                    dynamicObject.set("tpv_taxprice", tpv_taxprice);
                                    if (tpvVatrates.compareTo(BigDecimal.ZERO) != 0) {
                                        //含税单价 <> 0 and 增值税率% <> 0
                                        //不含税单价 = 含税单价 / ( 1 + 增值税率% / 100 )
                                        BigDecimal tax = tpvVatrates.divide(new BigDecimal("100")); // 将百分比转换为小数
                                        BigDecimal tpv_price = tpv_taxprice.divide(tax.add(new BigDecimal("1")), 2, RoundingMode.HALF_UP);
                                        dynamicObject.set("tpv_price", tpv_price);//不含税单价
                                    }
                                }
                                if (tpvVatrates.compareTo(BigDecimal.ZERO) != 0 && tpvTaxpramount.compareTo(BigDecimal.ZERO) != 0) {
                                    //含税金额 <> 0 and 增值税率% <> null
                                    //不含税金额 = 含税金额 / ( 1 + 增值税率% / 100 )
                                    // 计算不含税金额
                                    BigDecimal tax = tpvVatrates.divide(new BigDecimal("100")); // 将百分比转换为小数
                                    BigDecimal preTaxAmount = tpvTaxpramount.divide(tax.add(new BigDecimal("1")), 2, RoundingMode.HALF_UP);
                                    dynamicObject.set("tpv_nottaxamount", preTaxAmount);//不含税金额
                                    if (tpvExchangerealrate.compareTo(BigDecimal.ZERO) != 0) {
                                        //当天汇率 <> 0 and 不含税金额 <> 0
                                        //不含税金额本位币 = 不含税金额 * 当天汇率
                                        dynamicObject.set("tpv_nottaxstancoin", preTaxAmount.multiply(tpvExchangerealrate));//不含税金额本位币
                                    }
                                    //含税金额 <> 0 and 增值税率% <> 0
                                    //增值税额 = 含税金额 / ( 1 + 增值税率% / 100 ) * 增值税率% / 100
                                    BigDecimal exclusiveAmount = tpvTaxpramount.divide(tpvVatrates.add(BigDecimal.ONE), 2, RoundingMode.HALF_UP)
                                            .multiply(tpvVatrates).divide(BigDecimal.valueOf(100), 2, RoundingMode.HALF_UP);
                                    dynamicObject.set("tpv_vatmoney", exclusiveAmount);//增值税额
                                }
                                if (tpvTaxprice.compareTo(BigDecimal.ZERO) != 0 && tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && !tpvInputamount) {
                                    //含税单价 <> 0 and 数量 <> 0 and 录入金额 = false
                                    //含税金额 = 含税单价 * 数量
                                    BigDecimal tpv_taxpramount = tpvTaxprice.multiply(tpvPurchasequantity);//含税金额
                                    dynamicObject.set("tpv_taxpramount", tpv_taxpramount);
                                    if (tpvExchangerealrate.compareTo(BigDecimal.ZERO) != 0) {
                                        //当天汇率 <> 0 and 含税金额 <> 0
                                        //含税金额本位币 = 含税金额 * 当天汇率
                                        dynamicObject.set("tpv_taxstancoin", tpv_taxpramount.multiply(tpvExchangerealrate));//含税金额本位币
                                    }
                                    if (tpvVatrates.compareTo(BigDecimal.ZERO) != 0) {
                                        //不含税金额 = 含税金额 / ( 1 + 增值税率% / 100 )
                                        // 计算不含税金额
                                        BigDecimal tax = tpvVatrates.divide(new BigDecimal("100")); // 将百分比转换为小数
                                        BigDecimal preTaxAmount = tpv_taxpramount.divide(tax.add(new BigDecimal("1")), 2, RoundingMode.HALF_UP);
                                        dynamicObject.set("tpv_nottaxamount", preTaxAmount);//不含税金额
                                        if (tpvExchangerealrate.compareTo(BigDecimal.ZERO) != 0) {
                                            //当天汇率 <> 0 and 不含税金额 <> 0
                                            //不含税金额本位币 = 不含税金额 * 当天汇率
                                            dynamicObject.set("tpv_nottaxstancoin", preTaxAmount.multiply(tpvExchangerealrate));//不含税金额本位币
                                        }
                                        //含税金额 <> 0 and 增值税率% <> 0
                                        //增值税额 = 含税金额 / ( 1 + 增值税率% / 100 ) * 增值税率% / 100
                                        BigDecimal exclusiveAmount = tpv_taxpramount.divide(tpvVatrates.add(BigDecimal.ONE), 2, RoundingMode.HALF_UP)
                                                .multiply(tpvVatrates).divide(BigDecimal.valueOf(100), 2, RoundingMode.HALF_UP);
                                        dynamicObject.set("tpv_vatmoney", exclusiveAmount);//增值税额
                                    }
                                }
                                dynamicObject.set("tpv_packnum", jsonObject.get("tpv_ofpackages"));//包装数量
                                dynamicObject.set("tpv_material", jsonObject.get("tpv_materials"));//商品
                                dynamicObject.set("tpv_prodname", jsonObject.get("tpv_prodnames"));//品名
                                dynamicObject.set("tpv_shader", jsonObject.get("tpv_shaders"));//材质
                                dynamicObject.set("tpv_specation", jsonObject.get("tpv_specations"));//规格
                                dynamicObject.set("tpv_origin", jsonObject.get("tpv_origins"));//产地
                                dynamicObject.set("tpv_customtags", jsonObject.get("tpv_customtagss"));//自定标签
                                dynamicObject.set("tpv_qty", tpvPurchasequantity);//采提数量
                                String tpvGaplimit = jsonObject.getString("tpv_gaplimit");
                                BigDecimal tpvGapLimit = new BigDecimal(tpvGaplimit);
                                BigDecimal tpvGapLimitAbs = tpvGapLimit.abs();
                                dynamicObject.set("tpv_gaplimit", tpvGapLimitAbs);//差额
                                //dynamicObject.set("tpv_qty", jsonObject.get("tpv_destroyquantity"));//销提数量
                                dynamicObject.set("tpv_directconsignmentid", jsonObject.get("tpv_directconsignmentid"));//分录id
                            } else {
                                DynamicObject dynamicObjectS = new DynamicObject(dynamicObject.getDynamicObjectType());
                                DynamicObjectUtil.copyDynamicObject(dynamicObject, dynamicObjectS);
                                BigDecimal tpvExchangerealrate = dataEntity.getBigDecimal("tpv_exchangerealrate");//当天汇率
                                BigDecimal tpvNottaxamount = dynamicObject.getBigDecimal("tpv_nottaxamount");//不含税金额
                                BigDecimal tpvPurchasequantity = jsonObject.getBigDecimal("tpv_purchasequantity");//数量
                                boolean tpvInputamount = dataEntity.getBoolean("tpv_inputamount");//录入金额
                                BigDecimal tpvTaxpramount = dynamicObject.getBigDecimal("tpv_taxpramount");//含税金额
                                BigDecimal tpvTaxprice = dynamicObject.getBigDecimal("tpv_taxprice");//含税单价
                                BigDecimal tpvVatrates = dynamicObject.getBigDecimal("tpv_vatrates");//增值税率%
                                if (tpvExchangerealrate.compareTo(BigDecimal.ZERO) != 0 && tpvNottaxamount.compareTo(BigDecimal.ZERO) != 0) {
                                    //当天汇率 <> 0 and 不含税金额 <> 0
                                    //不含税金额本位币 = 不含税金额 * 当天汇率
                                    dynamicObjectS.set("tpv_nottaxstancoin", tpvNottaxamount.multiply(tpvExchangerealrate));
                                }
                                if (tpvExchangerealrate.compareTo(BigDecimal.ZERO) != 0 && tpvTaxpramount.compareTo(BigDecimal.ZERO) != 0) {
                                    //当天汇率 <> 0 and 含税金额 <> 0
                                    //含税金额本位币 = 含税金额 * 当天汇率
                                    dynamicObjectS.set("tpv_taxstancoin", tpvTaxpramount.multiply(tpvExchangerealrate));
                                }
                                if (tpvVatrates.compareTo(BigDecimal.ZERO) != 0 && tpvTaxprice.compareTo(BigDecimal.ZERO) != 0) {
                                    //含税单价 <> 0 and 增值税率% <> 0
                                    //不含税单价 = 含税单价 / ( 1 + 增值税率% / 100 )
                                    BigDecimal tax = tpvVatrates.divide(new BigDecimal("100")); // 将百分比转换为小数
                                    BigDecimal tpv_price = tpvTaxprice.divide(tax.add(new BigDecimal("1")), 2, RoundingMode.HALF_UP);
                                    dynamicObjectS.set("tpv_price", tpv_price);//不含税单价
                                }
                                if (tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && tpvTaxpramount.compareTo(BigDecimal.ZERO) != 0 && tpvInputamount) {
                                    //含税金额 <> 0 and 数量 <> 0 and 录入金额 = true
                                    //含税单价 = 含税金额 / 数量
                                    BigDecimal tpv_taxprice = tpvTaxpramount.divide(tpvPurchasequantity, 2, RoundingMode.HALF_UP);
                                    dynamicObjectS.set("tpv_taxprice", tpv_taxprice);
                                    if (tpvVatrates.compareTo(BigDecimal.ZERO) != 0) {
                                        //含税单价 <> 0 and 增值税率% <> 0
                                        //不含税单价 = 含税单价 / ( 1 + 增值税率% / 100 )
                                        BigDecimal tax = tpvVatrates.divide(new BigDecimal("100")); // 将百分比转换为小数
                                        BigDecimal tpv_price = tpv_taxprice.divide(tax.add(new BigDecimal("1")), 2, RoundingMode.HALF_UP);
                                        dynamicObjectS.set("tpv_price", tpv_price);//不含税单价
                                    }
                                }
                                if (tpvVatrates.compareTo(BigDecimal.ZERO) != 0 && tpvTaxpramount.compareTo(BigDecimal.ZERO) != 0) {
                                    //含税金额 <> 0 and 增值税率% <> null
                                    //不含税金额 = 含税金额 / ( 1 + 增值税率% / 100 )
                                    // 计算不含税金额
                                    BigDecimal tax = tpvVatrates.divide(new BigDecimal("100")); // 将百分比转换为小数
                                    BigDecimal preTaxAmount = tpvTaxpramount.divide(tax.add(new BigDecimal("1")), 2, RoundingMode.HALF_UP);
                                    dynamicObjectS.set("tpv_nottaxamount", preTaxAmount);//不含税金额
                                    if (tpvExchangerealrate.compareTo(BigDecimal.ZERO) != 0) {
                                        //当天汇率 <> 0 and 不含税金额 <> 0
                                        //不含税金额本位币 = 不含税金额 * 当天汇率
                                        dynamicObjectS.set("tpv_nottaxstancoin", preTaxAmount.multiply(tpvExchangerealrate));//不含税金额本位币
                                    }
                                    //含税金额 <> 0 and 增值税率% <> 0
                                    //增值税额 = 含税金额 / ( 1 + 增值税率% / 100 ) * 增值税率% / 100
                                    BigDecimal exclusiveAmount = tpvTaxpramount.divide(tpvVatrates.add(BigDecimal.ONE), 2, RoundingMode.HALF_UP)
                                            .multiply(tpvVatrates).divide(BigDecimal.valueOf(100), 2, RoundingMode.HALF_UP);
                                    dynamicObjectS.set("tpv_vatmoney", exclusiveAmount);//增值税额
                                }
                                if (tpvTaxprice.compareTo(BigDecimal.ZERO) != 0 && tpvPurchasequantity.compareTo(BigDecimal.ZERO) != 0 && !tpvInputamount) {
                                    //含税单价 <> 0 and 数量 <> 0 and 录入金额 = false
                                    //含税金额 = 含税单价 * 数量
                                    BigDecimal tpv_taxpramount = tpvTaxprice.multiply(tpvPurchasequantity);//含税金额
                                    dynamicObjectS.set("tpv_taxpramount", tpv_taxpramount);
                                    if (tpvExchangerealrate.compareTo(BigDecimal.ZERO) != 0) {
                                        //当天汇率 <> 0 and 含税金额 <> 0
                                        //含税金额本位币 = 含税金额 * 当天汇率
                                        dynamicObjectS.set("tpv_taxstancoin", tpv_taxpramount.multiply(tpvExchangerealrate));//含税金额本位币
                                    }
                                    if (tpvVatrates.compareTo(BigDecimal.ZERO) != 0) {
                                        //不含税金额 = 含税金额 / ( 1 + 增值税率% / 100 )
                                        // 计算不含税金额
                                        BigDecimal tax = tpvVatrates.divide(new BigDecimal("100")); // 将百分比转换为小数
                                        BigDecimal preTaxAmount = tpv_taxpramount.divide(tax.add(new BigDecimal("1")), 2, RoundingMode.HALF_UP);
                                        dynamicObjectS.set("tpv_nottaxamount", preTaxAmount);//不含税金额
                                        if (tpvExchangerealrate.compareTo(BigDecimal.ZERO) != 0) {
                                            //当天汇率 <> 0 and 不含税金额 <> 0
                                            //不含税金额本位币 = 不含税金额 * 当天汇率
                                            dynamicObjectS.set("tpv_nottaxstancoin", preTaxAmount.multiply(tpvExchangerealrate));//不含税金额本位币
                                        }
                                        //含税金额 <> 0 and 增值税率% <> 0
                                        //增值税额 = 含税金额 / ( 1 + 增值税率% / 100 ) * 增值税率% / 100
                                        BigDecimal exclusiveAmount = tpv_taxpramount.divide(tpvVatrates.add(BigDecimal.ONE), 2, RoundingMode.HALF_UP)
                                                .multiply(tpvVatrates).divide(BigDecimal.valueOf(100), 2, RoundingMode.HALF_UP);
                                        dynamicObjectS.set("tpv_vatmoney", exclusiveAmount);//增值税额
                                    }
                                }
                                dynamicObjectS.set("tpv_packnum", jsonObject.get("tpv_ofpackages"));//包装数量
                                dynamicObjectS.set("tpv_material", jsonObject.get("tpv_materials"));//商品
                                dynamicObjectS.set("tpv_prodname", jsonObject.get("tpv_prodnames"));//品名
                                dynamicObjectS.set("tpv_shader", jsonObject.get("tpv_shaders"));//材质
                                dynamicObjectS.set("tpv_specation", jsonObject.get("tpv_specations"));//规格
                                dynamicObjectS.set("tpv_origin", jsonObject.get("tpv_origins"));//产地
                                dynamicObjectS.set("tpv_qty", jsonObject.get("tpv_purchasequantity"));//采提数量
                                //dynamicObject.set("tpv_qty", jsonObject.get("tpv_destroyquantity"));//销提数量
                                String tpvGaplimit = jsonObject.getString("tpv_gaplimit");
                                BigDecimal tpvGapLimit = new BigDecimal(tpvGaplimit);
                                BigDecimal tpvGapLimitAbs = tpvGapLimit.abs();
                                dynamicObjectS.set("tpv_gaplimit", tpvGapLimitAbs);//差额
                                dynamicObjectS.set("tpv_directconsignmentid", jsonObject.get("tpv_directconsignmentid"));//分录id
                                objectCollection.add(i++, dynamicObjectS);
                            }
                        }
                    }
                }
                BigDecimal tpvExchangerate = dataEntity.getBigDecimal("tpv_exchangerate");//汇率
                BigDecimal tpvExchangeratermb = dataEntity.getBigDecimal("tpv_exchangeratermb");//折RMB汇率
                BigDecimal tpvExchangerateusd = dataEntity.getBigDecimal("tpv_exchangerateusd");//折USD汇率
                BigDecimal tpv_amount = BigDecimal.ZERO;
                for (int i = 0; i < objectCollection.size(); i++) {
                    DynamicObject dynamicObject = objectCollection.get(i);
                    tpv_amount = tpv_amount.add(dynamicObject.getBigDecimal("tpv_taxpramount").setScale(2, BigDecimal.ROUND_DOWN));
                }
                dataEntity.set("tpv_amount",tpv_amount);//金额原币
                dataEntity.set("tpv_amountbase",tpv_amount.multiply(tpvExchangerate));//金额本位币
                dataEntity.set("tpv_amountrmb",tpv_amount.multiply(tpvExchangeratermb));//折RMB金额
                dataEntity.set("tpv_amountusd",tpv_amount.multiply(tpvExchangerateusd));//折USD金额
            }
        }
    }
}
