package tpv.tpv_wm.tpv_dt.java.opplugin.convert;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.entity.botp.plugin.args.AfterGetSourceDataEventArgs;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @ClassName: PurchaseToBizapplyConvert
 * @Description: 采购合同下推开证申请插件
 * @author: zbh
 * @date: 2023-11-06
 */
public class PurchaseToBizapplyConvert extends AbstractConvertPlugIn {

    List listId = new ArrayList();

    @Override
    public void afterGetSourceData(AfterGetSourceDataEventArgs e) {
        super.afterGetSourceData(e);
        List<DynamicObject> sourceRows = e.getSourceRows();
        for (DynamicObject dynamicObject : sourceRows) {
            Object id = dynamicObject.get("id");
            listId.add(id);
        }
    }

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        List<DynamicObject> purLists = new ArrayList<>();
        for (int i = 0; i < listId.size(); i++) {
            DynamicObject pur = BusinessDataServiceHelper.loadSingle(listId.get(i), "tpv_dt_purchase");
            purLists.add(pur);
        }
        if (purLists.size() != 0) {
            BigDecimal count = BigDecimal.ZERO;//数量
            BigDecimal money = BigDecimal.ZERO;//开证金额
            String materialName = "";
            boolean isFlag = false;
            for (DynamicObject purList : purLists) {
                DynamicObjectCollection tpvMaterialentry = purList.getDynamicObjectCollection("tpv_materialentry");
                DynamicObjectCollection dtPurchases = purList.getDynamicObjectCollection("tpv_dt_purchase_u");
                for (DynamicObject materialentry : tpvMaterialentry) {
                    String tpvMaterial = materialentry.getString("tpv_material.name");
                    if (materialName.length() == 0) {
                        if (!materialName.contains(tpvMaterial)) {
                            materialName = materialName + tpvMaterial;
                        }
                    } else {
                        if (!materialName.contains(tpvMaterial)) {
                            materialName = materialName + "," + tpvMaterial;
                        }
                    }
                    BigDecimal tpvQty = materialentry.getBigDecimal("tpv_qty");
                    count = count.add(tpvQty);
                }
                for (DynamicObject dtPurchase : dtPurchases) {
                    String tpvPayment = dtPurchase.getString("tpv_payment.number");
                    if ("JSFS12".equals(tpvPayment) || "JSFS13".equals(tpvPayment)) {
                        isFlag = "JSFS12".equals(tpvPayment) ? false : true;
                        BigDecimal tpvFigure = dtPurchase.getBigDecimal("tpv_figure");
                        money = money.add(tpvFigure);
                    }
                }
            }
            DynamicObject exrateTable = BusinessDataServiceHelper.loadSingle("bd_exratetable", new QFilter[]{new QFilter("number", "=", "ERT-23"),new QFilter("enable","=","1")});
            for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
                DynamicObject dataEntity = extendedDataEntity.getDataEntity();
                DynamicObject tpvCurrency = purLists.get(0).getDynamicObject("tpv_currency");
                dataEntity.set("tpv_supplier", purLists.get(0).getDynamicObject("tpv_supplier")); //供应商
                dataEntity.set("tpv_typetrade", purLists.get(0).getDynamicObject("tpv_tradeproperty"));//贸易性质
                dataEntity.set("currency", tpvCurrency); //开证币别
                dataEntity.set("tpv_overfillrate", purLists.get(0).getBigDecimal("tpv_overfillrate"));//溢装率
                dataEntity.set("tpv_shorate", purLists.get(0).getBigDecimal("tpv_shortloadingrate"));//短装率

                BigDecimal exchangeRateCny = YEM.getExchangeRate(exrateTable, tpvCurrency, 1L, new Date());
                BigDecimal exchangeRateUsd = YEM.getExchangeRate(exrateTable, tpvCurrency, 6L, new Date());

                dataEntity.set("tpv_gradename", materialName);//商品名称
                dataEntity.set("tpv_tosum", count);//数量
                dataEntity.set("amount", money);//可开证
                dataEntity.set("isnationalcard", isFlag);//是否国际证
                dataEntity.set("tpv_transport", purLists.get(0).getDynamicObject("tpv_transportstyles"));//运输方式
                dataEntity.set("tpv_pritem", purLists.get(0).getDynamicObject("tpv_priceterms"));//价格条款
                dataEntity.set("tpv_bustype", "A");//价格条款
                DynamicObjectCollection tpvContractdetail = dataEntity.getDynamicObjectCollection("tpv_contractdetail");
                BigDecimal decimal = BigDecimal.ZERO;
                for (DynamicObject purList : purLists) {
                    DynamicObject aNew = tpvContractdetail.addNew();
                    aNew.set("tpv_purnumbers", purList.getString("tpv_contractnumber"));//合同号
                    aNew.set("tpv_tjtype", purList.getDynamicObject("tpv_typeofreward"));//提奖类型
                    aNew.set("tpv_combinationnum", purList.getDynamicObject("tpv_combinationnumber"));//组合号
                    aNew.set("tpv_naturetrade", purList.getDynamicObject("tpv_tradeproperty"));//贸易性质
                    aNew.set("tpv_businesstype", purList.getDynamicObject("tpv_businesstype"));//业务类型
                    decimal=decimal.add(purList.getBigDecimal("tpv_moneykzed"));
                    aNew.set("tpv_kzappmon", purList.getBigDecimal("tpv_moneykzed"));//开证申请金额
                    aNew.set("tpv_purcurrency", purList.getDynamicObject("tpv_currency"));//币别
                    aNew.set("tpv_purmoney", purList.getBigDecimal("tpv_amount"));//合同金额
                    aNew.set("tpv_purdepartment", purList.getDynamicObject("tpv_department"));//合同部门
                    aNew.set("tpv_pruper", purList.getDynamicObject("tpv_operator"));//合同业务员
                }

                dataEntity.set("tpv_rate",exchangeRateCny);//汇率
                dataEntity.set("tpv_amountfields",exchangeRateCny.multiply(decimal));//开证申请折RMB金额
                dataEntity.set("tpv_kzsqusdrate",exchangeRateUsd);//开证申请折USD汇率
                dataEntity.set("tpv_kzsqusdmon",exchangeRateUsd.multiply(decimal));//开证申请折USD金额
            }
        }
    }
}
