package tpv.tpv_wm.tpv_dt.java.opplugin.convert;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName 关联交易转货单货物流转下推采购入库改数据
 * @Description TODO
 * @Author WangShuGuang
 * @Date 2023/12/6
 * @Version 1.0
 */
public class RelevanceConvert extends AbstractConvertPlugIn {

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        OperateOption option = this.getOption();
        boolean contains = option.containsVariable("tpv_longListZh");
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            if (contains) {
                String List = this.getOption().getVariableValue("tpv_longListZh");
                JSONArray jsonArray = JSONObject.parseArray(List);
                JSONObject o = (JSONObject) jsonArray.get(0);
                DynamicObject load = BusinessDataServiceHelper.loadSingle(o.getLong("tpv_fids"), o.getString("tpv_pickbill"));
                String fieldName = "";
                switch (o.getString("tpv_pickbill")) {
                    case "im_purinbill":
                    case "im_otherinbill":
                    case "im_transinbill":
                    case "im_transdirbill":
                        fieldName = "biztime";
                        break;
                    case "tpv_dt_purchase":
                    case "tpv_dt_freigroambill":
                        fieldName = "tpv_bizdate";
                        break;
                    default:
                        break;
                }
                dataEntity.set("biztime",load.getDate(fieldName));//业务日期
                DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(o.getLong("tpv_warehouse"), "bd_warehouse");
                dataEntity.set("tpv_warehouseentry",loadSingle);//入库仓库
                DynamicObjectCollection objectCollection = dataEntity.getDynamicObjectCollection("billentry");
                List<DynamicObject> indexDyObjects = new ArrayList<>();
                for (int i = 0; i < objectCollection.size(); i++) {
                    DynamicObject dynamicObject = objectCollection.get(i);
                    Long purinfids = dynamicObject.getLong("tpv_purinfids"); //配货单id
                    Long purinfentryids = dynamicObject.getLong("tpv_purinfentryids"); //配货单分录id
                    for (int j = 0; j < jsonArray.size(); j++) {
                        JSONObject jsonObject = (JSONObject) jsonArray.get(j);
                        if (jsonObject.getLong("tpv_fids").equals(purinfids) && jsonObject.getLong("tpv_fentryids").equals(purinfentryids)) {
                            dynamicObject.set("tpv_prodname", jsonObject.getLong("tpv_prodnames"));//品名
                            dynamicObject.set("material", jsonObject.getLong("tpv_materials"));//商品
                            dynamicObject.set("tpv_specation", jsonObject.get("tpv_specations"));//规格
                            dynamicObject.set("tpv_shader", jsonObject.get("tpv_shaders"));//材质
                            dynamicObject.set("tpv_origin", jsonObject.getLong("tpv_origins"));//产地
                            dynamicObject.set("unit", jsonObject.getLong("tpv_ofmeasure"));//计量单位
                            dynamicObject.set("qty", jsonObject.get("tpv_pickqty"));//数量
                            dynamicObject.set("priceandtax", jsonObject.get("tpv_transfertaxprice"));//含税单价
                            //amountandtax = priceandtax * qty  价税合计 = 含税单价 * 数量
                            BigDecimal priceandtax = dynamicObject.getBigDecimal("priceandtax");
                            BigDecimal amountandtax = dynamicObject.getBigDecimal("qty").multiply(priceandtax != null ? priceandtax : BigDecimal.ZERO);
                            dynamicObject.set("amountandtax", amountandtax);//价税合计
                            //curamountandtax = amountandtax * exchangerate 价税合计(本位币) = 价税合计 * 汇率
                            BigDecimal exchangerate = dataEntity.getBigDecimal("exchangerate");
                            BigDecimal curamountandtax = amountandtax.multiply(exchangerate != null ? exchangerate : BigDecimal.ZERO);
                            dynamicObject.set("curamountandtax", curamountandtax);//价税合计(本位币)
                            //taxamount = amountandtax / ( 1 + taxrate / 100 ) * taxrate / 100 税额 = 价税合计 / ( 1 + 税率% / 100 ) * 税率% / 100
                            BigDecimal taxrate = dynamicObject.getBigDecimal("taxrate");
                            BigDecimal taxamount = BigDecimal.ZERO;
                            taxamount = new BigDecimal("1").add(taxrate.divide(new BigDecimal("100")));
                            BigDecimal taxamount1 = amountandtax.divide(taxamount, BigDecimal.ROUND_CEILING);
                            taxamount = taxamount1.multiply(taxrate.divide(new BigDecimal("100")));
                            dynamicObject.set("taxamount", taxamount);//税额
                            //amount = amountandtax / ( 1 + taxrate / 100 ) 金额 = 价税合计 / ( 1 + 税率% / 100 )
                            dynamicObject.set("amount", taxamount1);//金额
                            //curtaxamount = taxamount * exchangerate 税额(本位币) = 税额 * 汇率
                            BigDecimal curtaxamount = taxamount.multiply(exchangerate != null ? exchangerate : BigDecimal.ZERO);
                            dynamicObject.set("curtaxamount", curtaxamount);//税额(本位币)
                            //curamount = amount * exchangerate 金额(本位币) = 金额 * 汇率
                            BigDecimal curamount = taxamount1.multiply(exchangerate != null ? exchangerate : BigDecimal.ZERO);
                            dynamicObject.set("curamount", curamount);//金额(本位币)

                            dynamicObject.set("baseqty", jsonObject.get("tpv_pickqty"));//基本数量
                            dynamicObject.set("tpv_quantitypicked", jsonObject.get("tpv_pickqty"));//已拣配数量
                            dynamicObject.set("tpv_packnum", jsonObject.get("tpv_ofpackagesqty"));//包装数量
                            dynamicObject.set("warehouse", loadSingle);//入库仓库
                            dynamicObject.set("tpv_fentryid_in", jsonObject.get("tpv_fentryids"));//采购分录行ID
                            dynamicObject.set("tpv_fid_in", jsonObject.get("tpv_fids"));//采购单据ID
                            dynamicObject.set("tpv_fcoentryid_in", jsonObject.get("tpv_fcoentryids"));//采购合同行ID
                            dynamicObject.set("tpv_fcoid_in", jsonObject.get("tpv_fcoids"));//采购合同ID
                            dynamicObject.set("tpv_vid_in", jsonObject.get("tpv_vids"));//卷号分录ID
                            dynamicObject.set("tpv_pickbill_in", jsonObject.get("tpv_pickbill"));//配货单据
                            dynamicObject.set("tpv_billno_in", jsonObject.get("tpv_billnos"));//配货单号
                            dynamicObject.set("tpv_volumenumber_in", jsonObject.get("tpv_volumenumber"));//卷号

                        } else {
                            continue;
                        }
                    }
                }
            }
        }
    }
}
