package tpv.tpv_wm.tpv_dt.java.opplugin.convert;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.BigDecimalUtils;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.entity.botp.plugin.args.AfterGetSourceDataEventArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassName 关联交易转货单销售合同下推销售发货改数据
 * @Description TODO
 * @Author WangShuGuang
 * @Date 2023/12/6
 * @Version 1.0
 */
public class RelevanceDeliverConvert extends AbstractConvertPlugIn {

    @Override
    public void afterGetSourceData(AfterGetSourceDataEventArgs e) {
        super.afterGetSourceData(e);
        OperateOption option = this.getOption();
        boolean contains = option.containsVariable("tpv_longListZh");
        List<DynamicObject> sourceEntryData = e.getSourceRows();
        String name = this.getSrcMainType().getName();
        if (contains) {
            String List = this.getOption().getVariableValue("tpv_longListZh");
            JSONArray jsonArray = JSONObject.parseArray(List);
            for (DynamicObject putStorage : sourceEntryData) {
                Long pkId = (Long) e.getFldProperties().get("tpv_materialentry.id").getValue(putStorage);
//                String pkIds = String.valueOf(pkId);
                for (int j = 0; j < jsonArray.size(); j++) {
                    JSONObject jsonObject = (JSONObject) jsonArray.get(j);
                    if (jsonObject.getLong("saleConEntryId").equals(pkId)) {
                        BigDecimal taxprice = jsonObject.getBigDecimal("tpv_transfertaxprice");
                        e.getFldProperties().get("tpv_taxprice").setValue(putStorage, taxprice); //含税单价
                    }
                }
            }
        }
    }

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        OperateOption option = this.getOption();
        boolean contains = option.containsVariable("tpv_longListZh");
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            if (contains) {
                String List = this.getOption().getVariableValue("tpv_longListZh");
                JSONArray jsonArray = JSONObject.parseArray(List);
                JSONObject o = (JSONObject) jsonArray.get(0);
                DynamicObject tpvDtRelevancedealgs = BusinessDataServiceHelper.loadSingle(o.getLong("billId"),"tpv_dt_relevancedealgs");
                Map<Long,DynamicObject> mapLoadSingle = new HashMap<>();
                if (null != tpvDtRelevancedealgs) {
                    dataEntity.set("tpv_bizdate", tpvDtRelevancedealgs.getDate("tpv_bizdate"));
                    DynamicObjectCollection dynamicObjects = tpvDtRelevancedealgs.getDynamicObjectCollection("tpv_dt_goodstransfe_zh");
                    if (dynamicObjects.size() > 0) {
                        for (DynamicObject dynamicObject : dynamicObjects) {
                            DynamicObjectCollection objects = dynamicObject.getDynamicObjectCollection("tpv_dt_transferdist_ph");
                            if (objects.size() > 0) {
                                for (DynamicObject object : objects) {
                                    mapLoadSingle.put(object.getLong("id"),object);
                                }
                            }
                        }
                    }
                }
                dataEntity.set("tpv_inventorytype", "A");
                dataEntity.set("tpv_entrepot", mapLoadSingle.containsKey(o.getLong("id"))
                        ? mapLoadSingle.get(o.getLong("id")).getDynamicObject("tpv_warehouse")
                        : 0L);
                DynamicObjectCollection objectCollection = dataEntity.getDynamicObjectCollection("tpv_materialentry");
                List<DynamicObject> indexDyObjects = new ArrayList<>();
                for (int i = 0; i < objectCollection.size(); i++) {
                    DynamicObject dynamicObject = objectCollection.get(i);
                    DynamicObjectCollection tpvDtSalepickDn = dynamicObject.getDynamicObjectCollection("tpv_dt_salepick_in");
                    BigDecimal qtyParent = BigDecimal.ZERO;
                    int count = 0;
                    Long mainbillentryid = dynamicObject.getLong("tpv_coentryid"); //核心单据分录id
                    for (int j = 0; j < jsonArray.size(); j++) {
                        JSONObject jsonObject = (JSONObject) jsonArray.get(j);
                        if (jsonObject.getLong("saleConEntryId").equals(mainbillentryid)) {
                            count = 1;
                            if (count > 0) {
                                if (mapLoadSingle.containsKey(jsonObject.getLong("id"))) {
                                    DynamicObject object = mapLoadSingle.get(jsonObject.getLong("id"));
                                    DynamicObject addNew = tpvDtSalepickDn.addNew();
                                    addNew.set("tpv_material_in", object.getDynamicObject("tpv_materials"));//商品编码
                                    addNew.set("tpv_prodname_in", object.getDynamicObject("tpv_prodnames"));//品名
                                    addNew.set("tpv_specation_in", jsonObject.get("tpv_specations"));//规格
                                    addNew.set("tpv_shader_in", jsonObject.get("tpv_shaders"));//材质
                                    addNew.set("tpv_origin_in", object.getDynamicObject("tpv_origins"));//产地
                                    addNew.set("tpv_measure", object.getDynamicObject("tpv_ofmeasure"));//计量单位
                                    addNew.set("tpv_pickqty_in", jsonObject.get("tpv_pickqty"));//本次配货数量
                                    qtyParent = qtyParent.add(BigDecimalUtils.toBigDecimal(jsonObject.get("tpv_pickqty")));
                                    addNew.set("tpv_fpackages", jsonObject.get("tpv_ofpackagesqty"));//包装数量
                                    addNew.set("tpv_packnum_in", jsonObject.get("tpv_ofpackagesqty"));//本次配货包装数量
                                    addNew.set("tpv_warehouse_in", object.getDynamicObject("tpv_warehouse"));//仓库
                                    addNew.set("tpv_fentryid_in", jsonObject.get("tpv_fentryids"));//采购分录行ID
                                    addNew.set("tpv_fid_in", jsonObject.get("tpv_fids"));//采购单据ID
                                    addNew.set("tpv_fcoentryid_in", jsonObject.get("tpv_fcoentryids"));//采购合同行ID
                                    addNew.set("tpv_fcoid_in", jsonObject.get("tpv_fcoids"));//采购合同ID
                                    addNew.set("tpv_vid_in", jsonObject.get("tpv_vids"));//卷号分录ID
                                    addNew.set("tpv_pickbill_in", jsonObject.get("tpv_pickbill"));//配货单据
                                    addNew.set("tpv_billno_in", jsonObject.get("tpv_billnos"));//配货单号
                                    addNew.set("tpv_volumenumber_in", jsonObject.get("tpv_volumenumber"));//卷号

                                    addNew.set("tpv_department_in", object.getDynamicObject("tpv_departments"));//部门
                                    addNew.set("tpv_supplier_in", object.getDynamicObject("tpv_suppliers"));//供应商
                                    addNew.set("tpv_tradeproperty_in", object.getDynamicObject("tpv_tradepropertys"));//贸易性质
                                    addNew.set("tpv_combination_in", object.getDynamicObject("tpv_combinations"));//组合号
                                    addNew.set("tpv_strategy_in", object.getDynamicObject("tpv_strategys"));//策略号
                                    addNew.set("tpv_pickbilltype_in", object.getDynamicObject("tpv_pickbilltypes"));//单据类型
                                    addNew.set("tpv_thequantity", object.getBigDecimal("tpv_byheprice"));//已价格确认数量
                                    addNew.set("tpv_contractmark", object.getString("tpv_contractmark"));//合同号
                                    addNew.set("tpv_practicalok_in", object.getBoolean("tpv_practicalok"));//实提完毕
                                }
                            }
                        }
                    }
                    dynamicObject.set("tpv_qty",qtyParent);
                    //tpv_taxpramount = tpv_taxprice * tpv_qty  含税金额 = 含税单价 * 数量
                    BigDecimal taxprice = dynamicObject.getBigDecimal("tpv_taxprice");
                    BigDecimal taxpramount = dynamicObject.getBigDecimal("tpv_qty").multiply(taxprice != null ? taxprice : BigDecimal.ZERO);
                    dynamicObject.set("tpv_taxpramount", taxpramount);//含税金额
                    //tpv_price = tpv_taxprice / ( 1 + tpv_vatrates / 100 ) 不含税单价 = 含税单价 / ( 1 + 增值税率% / 100 )
                    BigDecimal price = BigDecimal.ZERO;
                    BigDecimal vatrates = dynamicObject.getBigDecimal("tpv_vatrates"); //增值税率%
                    price = new BigDecimal("1").add(vatrates.divide(new BigDecimal("100")));
                    price = taxprice.divide(price, BigDecimal.ROUND_CEILING);
                    dynamicObject.set("tpv_price", price); //不含税单价
                    BigDecimal nottaxamount  = price.multiply(dynamicObject.getBigDecimal("tpv_qty"));
                    dynamicObject.set("tpv_nottaxamount", nottaxamount); //不含税金额
                    if (count == 0) {
                        indexDyObjects.add(dynamicObject);
                    }
                }
                if (indexDyObjects.size() > 0) {
                    for (DynamicObject index : indexDyObjects) {
                        objectCollection.remove(index);
                    }
                }
            }
        }
    }
}
