package tpv.tpv_wm.tpv_dt.java.opplugin.convert;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName 关联交易转货单采购合同下推货物流转改数据
 * @Description TODO
 * @Author WangShuGuang
 * @Date 2023/12/6
 * @Version 1.0
 */
public class RelevanceFreigroConvert extends AbstractConvertPlugIn {

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        OperateOption option = this.getOption();
        boolean contains = option.containsVariable("tpv_longListZh");
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            if (contains) {
                String List = this.getOption().getVariableValue("tpv_longListZh");
                JSONArray jsonArray = JSONObject.parseArray(List);
                JSONObject o = (JSONObject) jsonArray.get(0);
                DynamicObject load = BusinessDataServiceHelper.loadSingle(o.getLong("tpv_fids"), o.getString("tpv_pickbill"));
                String fieldName = "";
                switch (o.getString("tpv_pickbill")) {
                    case "im_purinbill":
                    case "im_otherinbill":
                    case "im_transinbill":
                    case "im_transdirbill":
                        fieldName = "biztime";
                        break;
                    case "tpv_dt_purchase":
                    case "tpv_dt_freigroambill":
                        fieldName = "tpv_bizdate";
                        break;
                    default:
                        break;
                }
                dataEntity.set("tpv_bizdate", load.getDate(fieldName));//业务日期
                DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(o.getLong("tpv_warehouse"), "bd_warehouse");
                dataEntity.set("tpv_warehouses", loadSingle);//仓库
                DynamicObjectCollection objectCollection = dataEntity.getDynamicObjectCollection("tpv_materialentry");
                List<DynamicObject> indexDyObjects = new ArrayList<>();
                for (int i = 0; i < objectCollection.size(); i++) {
                    DynamicObject dynamicObject = objectCollection.get(i);
                    Boolean flag = false;
                    Long coentryid = dynamicObject.getLong("tpv_coentryid"); //核心单据分录id
                    for (int j = 0; j < jsonArray.size(); j++) {
                        JSONObject jsonObject = (JSONObject) jsonArray.get(j);
                        if (jsonObject.getLong("purConEntryId").equals(coentryid)) {
                            if (j == 0) {
                                dynamicObject.set("tpv_prodname", jsonObject.getLong("tpv_prodnames"));//品名
                                dynamicObject.set("tpv_material", jsonObject.getLong("tpv_materials"));//商品
                                dynamicObject.set("tpv_specation", jsonObject.get("tpv_specations"));//规格
                                dynamicObject.set("tpv_shader", jsonObject.get("tpv_shaders"));//材质
                                dynamicObject.set("tpv_origin", jsonObject.getLong("tpv_origins"));//产地
                                dynamicObject.set("tpv_unit", jsonObject.getLong("tpv_ofmeasure"));//计量单位
                                dynamicObject.set("tpv_qty", jsonObject.get("tpv_pickqty"));//数量
                                dynamicObject.set("tpv_baseunit", jsonObject.getLong("tpv_ofmeasure"));//计量单位
                                dynamicObject.set("tpv_baseqty", jsonObject.get("tpv_pickqty"));//基本数量
                                dynamicObject.set("tpv_taxprice", jsonObject.get("tpv_transfertaxprice"));//含税单价
                                //2、tpv_taxpramount = tpv_taxprice * tpv_qty  含税金额 = 含税单价 * 数量
                                BigDecimal taxprice = dynamicObject.getBigDecimal("tpv_taxprice");
                                BigDecimal taxpramount = dynamicObject.getBigDecimal("tpv_qty").multiply(taxprice != null ? taxprice : BigDecimal.ZERO);
                                dynamicObject.set("tpv_taxpramount", taxpramount);//含税金额
                                //7、tpv_taxstancoin =  tpv_taxpramount * tpv_exchangerealrate 含税金额(本位币) = 含税金额 * 汇率
                                BigDecimal exchangerealrate = dataEntity.getBigDecimal("tpv_exchangerealrate");
                                BigDecimal taxstancoin = taxpramount.multiply(exchangerealrate != null ? exchangerealrate : BigDecimal.ZERO);
                                dynamicObject.set("tpv_taxstancoin", taxstancoin);//含税金额(本位币)
                                //5、tpv_vatmoney = tpv_taxpramount / ( 1 + tpv_vatrates / 100 ) * tpv_vatrates / 100 增值税额 = 含税金额 / ( 1 + 增值税率% / 100 ) * 增值税率% / 100
                                BigDecimal vatrates = dynamicObject.getBigDecimal("tpv_vatrates");
                                BigDecimal vatmoney = BigDecimal.ZERO;
                                vatmoney = new BigDecimal("1").add(vatrates.divide(new BigDecimal("100")));
                                BigDecimal vatmoney1 = taxpramount.divide(vatmoney, BigDecimal.ROUND_CEILING);
                                vatmoney = vatmoney1.multiply(vatrates.divide(new BigDecimal("100")));
                                dynamicObject.set("tpv_vatmoney", vatmoney);//增值税额
                                //4、tpv_price = tpv_taxprice / ( 1 + tpv_vatrates / 100 ) 不含税单价 = 含税单价 / ( 1 + 增值税率% / 100 )
                                BigDecimal price = BigDecimal.ZERO;
                                price = new BigDecimal("1").add(vatrates.divide(new BigDecimal("100")));
                                price = taxprice.divide(price, BigDecimal.ROUND_CEILING);
                                dynamicObject.set("tpv_price", price);//不含税单价
                                //3、tpv_nottaxamount = tpv_taxpramount / ( 1 +  tpv_vatrates / 100 ) 不含税金额 = 含税金额 / ( 1 + 增值税率% / 100 )
                                dynamicObject.set("tpv_nottaxamount", vatmoney1);//不含税金额dynamicObject.getD
                                //6、tpv_nottaxstancoin = tpv_nottaxamount * tpv_exchangerealrate 不含税金额(本位币) = 不含税金额 * 汇率
                                BigDecimal nottaxstancoin = vatmoney1.multiply(exchangerealrate != null ? exchangerealrate : BigDecimal.ZERO);
                                dynamicObject.set("tpv_nottaxstancoin", nottaxstancoin);//不含税金额(本位币)

                                dynamicObject.set("tpv_packnum", jsonObject.get("tpv_ofpackagesqty"));//包装数量
                                dynamicObject.set("tpv_warehouse", loadSingle);//入库仓库
                                dynamicObject.set("tpv_purinfentryids", jsonObject.get("tpv_fentryids"));//采购分录行ID
                                dynamicObject.set("tpv_purinfids", jsonObject.get("tpv_fids"));//采购单据ID
                                flag = true;
                            } else {
                                DynamicObject dynamicObjectS = new DynamicObject(dynamicObject.getDynamicObjectType());
                                DynamicObjectUtil.copyDynamicObject(dynamicObject, dynamicObjectS);
                                dynamicObjectS.set("tpv_prodname", jsonObject.getLong("tpv_prodnames"));//品名
                                dynamicObjectS.set("tpv_material", jsonObject.getLong("tpv_materials"));//商品
                                dynamicObjectS.set("tpv_specation", jsonObject.get("tpv_specations"));//规格
                                dynamicObjectS.set("tpv_shader", jsonObject.get("tpv_shaders"));//材质
                                dynamicObjectS.set("tpv_origin", jsonObject.getLong("tpv_origins"));//产地
                                dynamicObjectS.set("tpv_unit", jsonObject.getLong("tpv_ofmeasure"));//计量单位
                                dynamicObjectS.set("tpv_qty", jsonObject.get("tpv_pickqty"));//数量
                                dynamicObjectS.set("tpv_baseunit", jsonObject.getLong("tpv_ofmeasure"));//计量单位
                                dynamicObject.set("tpv_baseqty", jsonObject.get("tpv_pickqty"));//基本数量
                                dynamicObject.set("tpv_taxprice", jsonObject.get("tpv_transfertaxprice"));//含税单价
                                //2、tpv_taxpramount = tpv_taxprice * tpv_qty  含税金额 = 含税单价 * 数量
                                BigDecimal taxprice = dynamicObject.getBigDecimal("tpv_taxprice");
                                BigDecimal taxpramount = dynamicObject.getBigDecimal("tpv_qty").multiply(taxprice != null ? taxprice : BigDecimal.ZERO);
                                dynamicObjectS.set("tpv_taxpramount", taxpramount);//含税金额
                                //7、tpv_taxstancoin =  tpv_taxpramount * tpv_exchangerealrate 含税金额(本位币) = 含税金额 * 汇率
                                BigDecimal exchangerealrate = dataEntity.getBigDecimal("tpv_exchangerealrate");
                                BigDecimal taxstancoin = taxpramount.multiply(exchangerealrate != null ? exchangerealrate : BigDecimal.ZERO);
                                dynamicObjectS.set("tpv_taxstancoin", taxstancoin);//含税金额(本位币)
                                //5、tpv_vatmoney = tpv_taxpramount / ( 1 + tpv_vatrates / 100 ) * tpv_vatrates / 100 增值税额 = 含税金额 / ( 1 + 增值税率% / 100 ) * 增值税率% / 100
                                BigDecimal vatrates = dynamicObject.getBigDecimal("tpv_vatrates");
                                BigDecimal vatmoney = BigDecimal.ZERO;
                                vatmoney = new BigDecimal("1").add(vatrates.divide(new BigDecimal("100")));
                                BigDecimal vatmoney1 = taxpramount.divide(vatmoney, 11,BigDecimal.ROUND_HALF_UP);
                                vatmoney = vatmoney1.multiply(vatrates.divide(new BigDecimal("100")));
                                vatmoney = vatmoney.setScale(2,BigDecimal.ROUND_HALF_UP);
                                dynamicObjectS.set("tpv_vatmoney", vatmoney);//增值税额
                                //4、tpv_price = tpv_taxprice / ( 1 + tpv_vatrates / 100 ) 不含税单价 = 含税单价 / ( 1 + 增值税率% / 100 )
                                BigDecimal price = BigDecimal.ZERO;
                                price = new BigDecimal("1").add(vatrates.divide(new BigDecimal("100")));
                                price = taxprice.divide(price, BigDecimal.ROUND_CEILING);
                                dynamicObjectS.set("tpv_price", price);//不含税单价
                                //3、tpv_nottaxamount = tpv_taxpramount / ( 1 +  tpv_vatrates / 100 ) 不含税金额 = 含税金额 / ( 1 + 增值税率% / 100 )
                                dynamicObjectS.set("tpv_nottaxamount", vatmoney1);//不含税金额
                                //6、tpv_nottaxstancoin = tpv_nottaxamount * tpv_exchangerealrate 不含税金额(本位币) = 不含税金额 * 汇率
                                BigDecimal nottaxstancoin = vatmoney1.multiply(exchangerealrate != null ? exchangerealrate : BigDecimal.ZERO);
                                dynamicObjectS.set("tpv_nottaxstancoin", nottaxstancoin);//不含税金额(本位币)

                                dynamicObjectS.set("tpv_packnum", jsonObject.get("tpv_ofpackagesqty"));//包装数量
                                dynamicObjectS.set("tpv_warehouse", loadSingle);//入库仓库
                                dynamicObjectS.set("tpv_purinfentryids", jsonObject.get("tpv_fentryids"));//采购分录行ID
                                dynamicObjectS.set("tpv_purinfids", jsonObject.get("tpv_fids"));//采购单据ID
                                objectCollection.add(i++, dynamicObjectS);
                            }
                        } else {
                            continue;
                        }
                    }
                    if (!flag) {
                        indexDyObjects.add(dynamicObject);
                    }
                }
                if (indexDyObjects.size() > 0) {
                    for (DynamicObject index : indexDyObjects) {
                        objectCollection.remove(index);
                    }
                }
            }
        }
    }
}
