package tpv.tpv_wm.tpv_dt.java.opplugin.convert;

import com.itopview.wm.utils.BigDecimalUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicProperty;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.entity.botp.plugin.args.AfterGetSourceDataEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description: 销售合同下推销售发货 -下推插件
 * @Author LinRui
 * @Date 2023/9/20 20:56
 */
@Deprecated
public class SaleConToShippConvert extends AbstractConvertPlugIn {

    @Override
    public void afterGetSourceData(AfterGetSourceDataEventArgs e) {
        super.afterGetSourceData(e);
        List<DynamicObject> sourceRows = e.getSourceRows();
        Map<String, DynamicProperty> fldProperties = e.getFldProperties();
        //写法1  String id = sourceData.getString(fldProperties.get("id"));
        //写法2  Object id1 = fldProperties.get("id").getValue(sourceData);

        List<Long> srcentryidlist = new ArrayList();
        Long id = null;
        for (DynamicObject putStorage : sourceRows) {
            id = (Long) fldProperties.get("id").getValue(putStorage);
            Long pkId = (Long) fldProperties.get("tpv_materialentry.id").getValue(putStorage);
            srcentryidlist.add(pkId); //分录ID
        }
        if (sourceRows.size() == 0) {
            return;
        }
        QFilter qFilterSrcbillid = new QFilter("tpv_sourcebillid", QCP.equals, id);
        DynamicObject[] tpvDtSalepricebills = BusinessDataServiceHelper.load("tpv_dt_salepricebill",
                "id,billno,tpv_materialentry,tpv_materialentry.tpv_taxprice_final,tpv_materialentry.tpv_qty_final," +
                        "tpv_materialentry.tpv_cargobatchqty,tpv_materialentry.tpv_srcbillid,tpv_materialentry" +
                        ".tpv_srcentryid",
                new QFilter[]{qFilterSrcbillid});
        //利用hashmap键不能重复，覆盖赋值
        Map<Long, BigDecimal> mapPriceSum = new HashMap<>(); //计算下游所有价格确认数量（价格确认数-已关联发货确认数）
        Map<Long, List<String>> mapIsPriceCount = new HashMap<>();  //有且只有一张价格确认单有剩余数量
        BigDecimal zero = BigDecimal.ZERO;
        List<String> listPriceBillno = new ArrayList<>();
        Map<String, HashMap<Long, BigDecimal>> taxpriceMapSrcbillno = new HashMap<>();
        HashMap<Long, BigDecimal> taxpriceMap = new HashMap<>();  //确认含税单价
        //遍历合同关联下游价格确认单数据
        for (DynamicObject tpvDtSalepricebill : tpvDtSalepricebills) {
            String billno = tpvDtSalepricebill.getString("billno"); //单据编号
            DynamicObjectCollection materialentryRowBill = tpvDtSalepricebill.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject materialentryRowData : materialentryRowBill) {
                Long tpvSrcentryid = materialentryRowData.getLong("tpv_srcentryid"); //来源单据分录ID
                BigDecimal tpvTaxpriceFinal = materialentryRowData.getBigDecimal("tpv_taxprice_final");//确认含税单价
                if (srcentryidlist.contains(tpvSrcentryid)) {
                    BigDecimal tpvQtyFinal = materialentryRowData.getBigDecimal("tpv_qty_final"); //确认数量
                    BigDecimal tpvCargobatchqty = materialentryRowData.getBigDecimal("tpv_cargobatchqty"); //发货关联价格确认数量
                    BigDecimal divide = tpvQtyFinal.subtract(tpvCargobatchqty); //剩余价格确认数量
                    if (!mapPriceSum.containsKey(tpvSrcentryid)) { //判断所有价格确认单分录行来源分录ID是否一致
                        zero = BigDecimal.ZERO;
                        zero = zero.add(divide);
                        mapPriceSum.put(tpvSrcentryid, zero);  //合计剩余价格确认数量
                    } else {
                        BigDecimal decimal = mapPriceSum.get(tpvSrcentryid);
                        zero = decimal.add(divide);
                        mapPriceSum.put(tpvSrcentryid, zero);
                    }
                    if (divide.compareTo(BigDecimal.ZERO) > 0) { //剩余价格确认数量大于零
                        if (!mapIsPriceCount.containsKey(tpvSrcentryid)) {
                            listPriceBillno = new ArrayList<>();
                            listPriceBillno.add(billno);
                            mapIsPriceCount.put(tpvSrcentryid, listPriceBillno);
                        } else {
                            for (Long aLong : mapIsPriceCount.keySet()) {
                                if (aLong.equals(tpvSrcentryid)) {
                                    List<String> strings = mapIsPriceCount.get(tpvSrcentryid);
                                    strings.add(billno);
                                }
                            }

                        }
                    }
                }

                if (!taxpriceMapSrcbillno.containsKey(billno)) {
                    taxpriceMap = new HashMap<>();
                    taxpriceMap.put(tpvSrcentryid, tpvTaxpriceFinal);
                    taxpriceMapSrcbillno.put(billno, taxpriceMap);
                } else {
                    for (String s : taxpriceMapSrcbillno.keySet()) {
                        if (s.equals(billno)) {
                            taxpriceMap.put(tpvSrcentryid, tpvTaxpriceFinal);
                        }
                    }
                }
            }
        }
        Map<Long, BigDecimal> entryids = new HashMap<>();
        DynamicObject tpvDtSalescontract = BusinessDataServiceHelper.loadSingle(id, "tpv_dt_salescontract");
        for (DynamicObject tpvMaterialentry : tpvDtSalescontract.getDynamicObjectCollection("tpv_materialentry")) {
            Long entryid = tpvMaterialentry.getLong("id");
            BigDecimal tpv_conprice = tpvMaterialentry.getBigDecimal("tpv_conprice"); //已价格确认数量
            BigDecimal tpv_iscargobatchqty = tpvMaterialentry.getBigDecimal("tpv_iscargobatchqty"); //价格确认被发货关联数量
            BigDecimal tpv_shippedquantity = tpvMaterialentry.getBigDecimal("tpv_shippedquantity"); //已发货数量
            BigDecimal tpv_unshippedquantity = BigDecimalUtils.toBigDecimal(tpvMaterialentry.getBigDecimal("tpv_unshippedquantity")); //未发货数量
            if (mapPriceSum.containsKey(entryid)) {
                if (tpv_unshippedquantity.subtract(mapPriceSum.get(entryid)).compareTo(BigDecimal.ZERO) <= 0) {
                    if (mapIsPriceCount.containsKey(entryid)) {
                        if (mapIsPriceCount.get(entryid).size() == 1) {
                            String docuBillno = mapIsPriceCount.get(entryid).get(0);
                            if (taxpriceMapSrcbillno.containsKey(docuBillno)) {
                                for (Map.Entry<Long, BigDecimal> longBigDecimalEntry : taxpriceMapSrcbillno.get(docuBillno).entrySet()) {
                                    if (longBigDecimalEntry.getKey().equals(entryid)) {
                                        BigDecimal value = longBigDecimalEntry.getValue();
                                        entryids.put(entryid, value);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        for (DynamicObject putStorage : sourceRows) {
            Long pkId = (Long) e.getFldProperties().get("tpv_materialentry.id").getValue(putStorage);
            if (entryids.size() > 0) {
                for (Long aLong : entryids.keySet()) {
                    if (aLong.equals(pkId)) {
                        BigDecimal taxprice = entryids.get(aLong);
                        fldProperties.get("tpv_taxprice").setValue(putStorage, taxprice); //含税单价
                        //tpv_price = tpv_taxprice / ( 1 + tpv_vatrates / 100 ) 不含税单价 = 含税单价 / ( 1 + 增值税率% / 100 )
                        BigDecimal price = BigDecimal.ZERO;
                        BigDecimal vatrates = (BigDecimal) e.getFldProperties().get("tpv_vatrates").getValue(putStorage); //增值税率%
                        price = new BigDecimal("1").add(vatrates.divide(new BigDecimal("100")));
                        price = taxprice.divide(price, BigDecimal.ROUND_CEILING);
                        fldProperties.get("tpv_price").setValue(putStorage, price); //不含税单价
                    }
                }
            }

        }

    }

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        String name = this.getSrcMainType().getName();
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");
            long tpvSourcebillid = dataEntity.getLong("tpv_sourcebillid");
            List<Long> srcentryidlist = new ArrayList();
            //遍历目标单分录
            for (DynamicObject materialentryRowData : materialentry) {
                //String tpvSrcbillno = materialentryRowData.getString("tpv_srcbillno"); //来源单据编号
                //long tpvSrcbillid = materialentryRowData.getLong("tpv_srcbillid"); //来源单据ID
                long tpvSrcentryid = materialentryRowData.getLong("tpv_srcentryid"); //来源单据分录ID
                srcentryidlist.add(tpvSrcentryid); //下推销售发货单分录的来源分录ID
            }
            QFilter qFilterSrcbillid = new QFilter("tpv_sourcebillid", QCP.equals, tpvSourcebillid);
            DynamicObject[] tpvDtSalepricebills = BusinessDataServiceHelper.load("tpv_dt_salepricebill",
                    "id,billno,tpv_materialentry,tpv_materialentry.tpv_taxprice_final,tpv_materialentry" +
                            ".tpv_qty_final,tpv_materialentry.tpv_cargobatchqty,tpv_materialentry.tpv_srcbillid," +
                            "tpv_materialentry.tpv_srcentryid",
                    new QFilter[]{qFilterSrcbillid});
            //利用hashmap键不能重复，覆盖赋值
            Map<Long, BigDecimal> mapPriceSum = new HashMap<>(); //计算下游所有价格确认数量（价格确认数-已关联发货确认数）
            Map<Long, List<String>> mapIsPriceCount = new HashMap<>();  //有且只有一张价格确认单有剩余数量
            BigDecimal zero = BigDecimal.ZERO;
            List<String> listPriceBillno = new ArrayList<>();
            //遍历合同关联下游价格确认单数据
            for (DynamicObject tpvDtSalepricebill : tpvDtSalepricebills) {
                String billno = tpvDtSalepricebill.getString("billno"); //单据编号
                DynamicObjectCollection materialentryRowBill = tpvDtSalepricebill.getDynamicObjectCollection("tpv_materialentry");
                for (DynamicObject materialentryRowData : materialentryRowBill) {
                    Long tpvSrcentryid = materialentryRowData.getLong("tpv_srcentryid"); //来源单据分录ID
                    if (srcentryidlist.contains(tpvSrcentryid)) {
                        BigDecimal tpvQtyFinal = materialentryRowData.getBigDecimal("tpv_qty_final"); //确认数量
                        BigDecimal tpvCargobatchqty = materialentryRowData.getBigDecimal("tpv_cargobatchqty"); //发货关联价格确认数量
                        BigDecimal divide = tpvQtyFinal.subtract(tpvCargobatchqty); //剩余价格确认数量
                        if (!mapPriceSum.containsKey(tpvSrcentryid)) { //判断所有价格确认单分录行来源分录ID是否一致
                            zero = BigDecimal.ZERO;
                            zero = zero.add(divide);
                            mapPriceSum.put(tpvSrcentryid, zero);  //合计剩余价格确认数量
                        } else {
                            BigDecimal decimal = mapPriceSum.get(tpvSrcentryid);
                            zero = decimal.add(divide);
                            mapPriceSum.put(tpvSrcentryid, zero);
                        }
                        if (divide.compareTo(BigDecimal.ZERO) > 0) { //剩余价格确认数量大于零
                            if (!mapIsPriceCount.containsKey(tpvSrcentryid)) {
                                listPriceBillno = new ArrayList<>();
                                listPriceBillno.add(billno);
                                mapIsPriceCount.put(tpvSrcentryid, listPriceBillno);
                            } else {
                                for (Long aLong : mapIsPriceCount.keySet()) {
                                    if (aLong.equals(tpvSrcentryid)) {
                                        List<String> strings = mapIsPriceCount.get(tpvSrcentryid);
                                        strings.add(billno);
                                    }
                                }

                            }
                        }
                    }
                }
            }

            //再次遍历目标单分录
            for (DynamicObject materialentryRowData : materialentry) {
                String tpvSrcbillno = materialentryRowData.getString("tpv_srcbillno"); //来源单据编号
                String tpvContractnos = materialentryRowData.getString("tpv_srccontractnos"); //来源合同号
                //long tpvSrcbillid = materialentryRowData.getLong("tpv_srcbillid"); //来源单据ID
                long tpvSrcentryid = materialentryRowData.getLong("tpv_srcentryid"); //来源单据分录ID
                BigDecimal tpvQty = materialentryRowData.getBigDecimal("tpv_qty"); //数量
                if (mapPriceSum.containsKey(tpvSrcentryid)) {
                    if (tpvQty.subtract(mapPriceSum.get(tpvSrcentryid)).compareTo(tpvQty) == 0) {
                        materialentryRowData.set("tpv_document", "A"); //销售合同
                        materialentryRowData.set("tpv_selectiondocu", tpvContractnos); //销售合同号
                    } else if (tpvQty.subtract(mapPriceSum.get(tpvSrcentryid)).compareTo(BigDecimal.ZERO) <= 0) {
                        if (mapIsPriceCount.containsKey(tpvSrcentryid)) {
                            if (mapIsPriceCount.get(tpvSrcentryid).size() == 1) {
                                String docuBillno = mapIsPriceCount.get(tpvSrcentryid).get(0);
                                materialentryRowData.set("tpv_document", "B"); //销售价格确认单
                                materialentryRowData.set("tpv_cargobatchqty", tpvQty); //价格确认货物批次数量
                                materialentryRowData.set("tpv_selectiondocu", docuBillno); //销售价格确认单编号
                            }
                        }
                    }
                } else {
                    materialentryRowData.set("tpv_document", "A"); //销售合同
                    materialentryRowData.set("tpv_selectiondocu", tpvContractnos); //销售合同号
                }
            }
        }
    }
}
