package tpv.tpv_wm.tpv_dt.java.opplugin.convert;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @ClassName: SalesRecbillConvert
 * @Description: 销售合同（期货交割销售）下推收款处理 携带人民币折美元汇率
 * @author: zbh
 * @date: 2024-08-06
 */
public class SalesRecbillConvert extends AbstractConvertPlugIn {
    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet entitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] entitys = entitySet.FindByEntityKey(this.getTgtMainType().toString());
        for (int i = 0; i < entitys.length; ++i) {
            ExtendedDataEntity extend = entitys[i];
            DynamicObject bill = extend.getDataEntity();
            Date tpv_exratedate = (Date)bill.get("bizdate");
            Object tpv_exratetable =bill.get("exratetable");
            BigDecimal actrecamt =bill.getBigDecimal("actrecamt");
            BigDecimal exchangeRateUsd = YEM.getExchangeRate(tpv_exratetable, 1L, 6L, tpv_exratedate);
            bill.set("shkd_usdexrate",exchangeRateUsd);
            bill.set("shkd_usdamount",exchangeRateUsd.multiply(actrecamt));
        }
    }
}
