package tpv.tpv_wm.tpv_dt.java.opplugin.convert;

import com.itopview.wm.utils.BigDecimalUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.ExtendedDataEntitySet;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description: 下推开票申请， 将上游费用分录信息携带 -下推插件
 * @Author LinRui
 * @Date 2024/5/30 15:36
 */
public class TpvToInvoiceOriginalConvert extends AbstractConvertPlugIn {

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntitySet targetExtDataEntitySet = e.getTargetExtDataEntitySet();
        ExtendedDataEntity[] findByEntityKey = targetExtDataEntitySet.FindByEntityKey(this.getTgtMainType().getName());
        String name = this.getSrcMainType().getName();
        for (ExtendedDataEntity extendedDataEntity : findByEntityKey) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("sim_original_bill_item");
            List<Long> srcEntryidlist = new ArrayList();
            //遍历目标单分录
            for (DynamicObject materialentryRowData : materialentry) {
                Long tpvSrcentryid = materialentryRowData.getLong("tpv_srcinparenentrytid"); //来源库存子分录对应父分录id
                srcEntryidlist.add(tpvSrcentryid); //下推开票申请单分录的来源库存子分录ID
            }

            QFilter qFilter = new QFilter("tpv_materialentry.id", QCP.in, srcEntryidlist);
            DynamicObjectCollection tpvDtSalesshipping = QueryServiceHelper.query("tpv_dt_salesshipping",
                    "id,billno,tpv_materialentry,tpv_materialentry.id entryid,tpv_materialentry.tpv_dt_dcostinform_f subentryid," +
                            "tpv_materialentry.tpv_dt_dcostinform_f.tpv_expenseitems tpv_expenseitems," +
                            "tpv_materialentry.tpv_dt_dcostinform_f.tpv_expenseitems.number expenseitemsnumber," +
                            "tpv_materialentry.tpv_dt_dcostinform_f.tpv_costcurrencyes tpv_costcurrencyes," +
                            "tpv_materialentry.tpv_dt_dcostinform_f.tpv_moneys tpv_moneys",
                    new QFilter[]{qFilter});
            Map<Long, Map<String, Object>> map = new HashMap<>();
            Map<Long, String> expenseitemsMap = new HashMap<>();
            for (DynamicObject dynamicObject : tpvDtSalesshipping) {
                Long entryid = dynamicObject.getLong("entryid");
                Long tpvExpenseitems = dynamicObject.getLong("tpv_expenseitems");
                String expenseitemsnumber = dynamicObject.getString("expenseitemsnumber");
                Long tpvCostcurrencyes = dynamicObject.getLong("tpv_costcurrencyes");
                BigDecimal tpvMoneys = dynamicObject.getBigDecimal("tpv_moneys");
                if ("FYXM150.1142".equals(expenseitemsnumber) || "FYXM150.1152".equals(expenseitemsnumber) || "FYXM150.1220".equals(expenseitemsnumber)) {
                    if (!map.containsKey(entryid)) {
                        Map<String, Object> objectMap = new HashMap<>();
                        objectMap.put("tpv_expenseitems", tpvExpenseitems);
                        objectMap.put("tpv_costcurrencyes", tpvCostcurrencyes);
                        objectMap.put("tpv_moneys", tpvMoneys);
                        map.put(entryid, objectMap);
                        expenseitemsMap.put(tpvExpenseitems, expenseitemsnumber);
                    } else {
                        Map<String, Object> objectMap = map.get(entryid);
                        if (tpvExpenseitems.compareTo(Long.valueOf(objectMap.get("tpv_expenseitems").toString())) == 0 &&
                                tpvCostcurrencyes.compareTo(Long.valueOf(objectMap.get("tpv_costcurrencyes").toString())) == 0) {
                            BigDecimal tpvMoneys1 = BigDecimalUtils.toBigDecimal(objectMap.get("tpv_moneys"));
                            tpvMoneys1.add(tpvMoneys);
                            objectMap.put("tpv_moneys", tpvMoneys1);
                        } else {
                            objectMap.put("tpv_expenseitems", tpvExpenseitems);
                            objectMap.put("tpv_costcurrencyes", tpvCostcurrencyes);
                            objectMap.put("tpv_moneys", tpvMoneys);
                            expenseitemsMap.put(tpvExpenseitems, expenseitemsnumber);
                        }
                        map.put(entryid, objectMap);
                    }
                }
            }

            QFilter qFilterx = new QFilter("enable", QCP.equals, "1");
            DynamicObject[] bd_currency = BusinessDataServiceHelper.load("bd_currency","id", qFilterx.toArray());
            Map<Long, DynamicObject> mapCurrency = new HashMap<>();
            if (bd_currency.length > 0) {
                for (DynamicObject dynamicObject : bd_currency) {
                    mapCurrency.put(dynamicObject.getLong("id"), dynamicObject);
                }
            }

            //再次遍历目标单分录
            for (DynamicObject materialentryRowData : materialentry) {
                Long tpvSrcentryid = materialentryRowData.getLong("tpv_srcentryid"); //来源单据分录ID
                BigDecimal num = materialentryRowData.getBigDecimal("num");
                if (map.containsKey(tpvSrcentryid)) {
                    Map<String, Object> objectMap = map.get(tpvSrcentryid);
                    Long tpvExpenseitems = Long.valueOf(objectMap.get("tpv_expenseitems").toString());
                    Long tpvCostcurrencyes = Long.valueOf(objectMap.get("tpv_costcurrencyes").toString());
                    BigDecimal tpvMoneys = BigDecimalUtils.toBigDecimal(objectMap.get("tpv_moneys"));
                    if (expenseitemsMap.containsKey(tpvExpenseitems)) {
                        String number = expenseitemsMap.get(tpvExpenseitems);
                        if ("FYXM150.1142".equals(number)) { //国际运费
                            setEntryDy(num, tpvMoneys, tpvCostcurrencyes, materialentryRowData, "tpv_interfreightprice",
                                    "tpv_interfreightcurr", "tpv_interfreightamt", "tpv_interfreightrate", mapCurrency);
                        }
                        if ("FYXM150.1152".equals(number)) { //国际保险费
                            setEntryDy(num, tpvMoneys, tpvCostcurrencyes, materialentryRowData,  "tpv_interinsureprice",
                                    "tpv_interinsurecurr", "tpv_interinsureamt","tpv_interinsurerate", mapCurrency);
                        }
                        if ("FYXM150.1220".equals(number)) { //佣金
                            setEntryDy(num, tpvMoneys, tpvCostcurrencyes, materialentryRowData, "tpv_commissionprice",
                                    "tpv_commissioncurr", "tpv_interinsureamt","tpv_commissionrate", mapCurrency);
                        }
                    }
                }
            }
        }
    }

    private static void setEntryDy(BigDecimal num, BigDecimal tpvMoneys, Long tpvCostcurrencyes, DynamicObject materialentryRowData, String priceField,
                                   String currField,String amtField,String rateField,Map<Long, DynamicObject> mapCurrency) {
        materialentryRowData.set(currField, mapCurrency.containsKey(tpvCostcurrencyes) ? mapCurrency.get(tpvCostcurrencyes) : null);
        materialentryRowData.set(amtField, tpvMoneys);
        if (null != num && num.compareTo(BigDecimal.ZERO) != 0) {
            BigDecimal price = tpvMoneys.divide(num, BigDecimal.ROUND_HALF_UP);
            materialentryRowData.set(priceField, price);
        } else {
            BigDecimal price = tpvMoneys.divide(BigDecimal.ONE, BigDecimal.ROUND_HALF_UP);
            materialentryRowData.set(priceField, price);
        }
        materialentryRowData.set(rateField, BigDecimal.ONE);
    }
}
