package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import tpv.tpv_wm.tpv_iscb.java.api.sealstewardapi.SealStewardClient;
import tpv.tpv_wm.tpv_iscb.java.api.sealstewardapi.SealStewardClientHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author: ERRCODE Wenbei He
 * @Project: zhck
 * @Package: com.itopview.wm.dt.opplugin.op.ERRCODEOrModifyUserOnSealOp
 * @Date: 11:08 2023/10/30
 * @Description: 审核、启用禁用调用批量添加或修改接口
 * @Version: 1.0
 */
public class BatchAddOrModifyUsersOnSealOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("name"); // name
        fieldKeys.add("phone"); // mobile cellphone
        fieldKeys.add("number"); // code
        fieldKeys.add("email"); // mail_address
        fieldKeys.add("password"); // password
        fieldKeys.add("usertypes"); // position
        fieldKeys.add("idcard"); // uid
        fieldKeys.add("dpt"); // department_id
        fieldKeys.add("entryentity"); // 单据体
        fieldKeys.add("status"); // is_enable
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        ArrayList<SealStewardClientHelper.UserForSeal> users = new ArrayList<>();
        if (null != e.getDataEntities()) {
            int status = "disable".equals(e.getOperationKey()) ? 0 : 1;
            for (DynamicObject dataEntity : e.getDataEntities()) {
                users.add(this.getUserInfo(dataEntity, status));
            }
            SealStewardClient.batchAddOrModifyUsersForSeal(users);
        }
    }

    private SealStewardClientHelper.UserForSeal getUserInfo(DynamicObject user, int status) {
        SealStewardClientHelper.UserForSeal userForSeal = new SealStewardClientHelper.UserForSeal();
        ArrayList<String> positions = new ArrayList<>();
        userForSeal.setName(user.getString("name"));
        userForSeal.setMobile(user.getString("phone"));
        userForSeal.setCode(user.getString("number"));
        userForSeal.setMail_address(user.getString("email"));
        userForSeal.setPassword(user.getString("password"));
        for (DynamicObject row : user.getDynamicObjectCollection("usertypes")) {
            DynamicObject fbasedataid = row.getDynamicObject("fbasedataid");
            positions.add(fbasedataid.getString("name"));
        }
        userForSeal.setPosition(String.join(",", positions));
        userForSeal.setUid(user.getString("phone"));
        userForSeal.setDepartment_id("KDdaifenpei");
        userForSeal.setIs_enable(status);
        userForSeal.setCellphone(user.getString("phone"));
        return userForSeal;
    }
}

