package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import tpv.tpv_wm.tpv_iscb.java.api.sealstewardapi.SealStewardClient;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author: Heisenberg Wenbei He
 * @Project: zhck
 * @Package: com.itopview.wm.dt.opplugin.op.BatchDeleteUserForSealOp
 * @Date: 09:47 2023/10/30
 * @Description: 反审核调用批量删除接口
 * @Version: 1.0
 */
public class BatchDeleteUserOnSealOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("number");
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        ArrayList<String> userIds = new ArrayList<>();
        if (("unaudit".equals(e.getOperationKey()) && null != e.getDataEntities())) {
            for (DynamicObject dataEntity : e.getDataEntities()) {
                userIds.add((String) dataEntity.get("number"));
            }
            int i = this.batchDeleteUserOnSeal(userIds);
        }
    }

    private int batchDeleteUserOnSeal(List<String> userIds) {
        String join = String.join(",", userIds);
        return SealStewardClient.batchDeleteUsersForSeal(String.join(",", userIds));
    }
}
