package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import com.itopview.wm.sys.utils.NewVersionHelper;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.List;

/**
 * @ClassName: BizClaimdetailsAuditOp
 * @Description: 合同版本变更之后，如果有变更【大区】【基价商品】【策略号】则需要将合同下所有《认领明细单》对应字段需同步更新； 采购合同
 * @author: zbh
 * @date: 2024-08-22
 */
public class BizClaimdetailsAuditOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_salesarea");//销售大区
        fieldKeys.add("tpv_basepriceitems");//基价商品
        fieldKeys.add("tpv_policynumber");//策略号
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        String key = e.getOperationKey();
        //判断具体操作
        switch (key) {
            case "audit":
                //监控按钮
                clickAudit(e,"tpv_dt_purchase","tpv_salesarea","tpv_basepriceitems","tpv_policynumber");
                break;
        }
    }

    public static void clickAudit(AfterOperationArgs e, String entityName, String salesarea, String basepriceitems, String policynumber) {
        DynamicObject[] entities = e.getDataEntities();
        //获取表单数据包
        for (DynamicObject entity : entities) {
            NewVersionHelper vHelper = new NewVersionHelper(entityName);
            if (vHelper.isChanged()) {
                return;
            }
            DynamicObject tpvSalesarea = entity.getDynamicObject(salesarea);//销售大区
            DynamicObject tpvBasepriceitems = entity.getDynamicObject(basepriceitems);//基价商品
            DynamicObject tpvPolicynumber = entity.getDynamicObject(policynumber);//策略号
            DynamicObject[] claimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", "billno,tpv_region,tpv_basegoods,tpv_strategyname",
                    new QFilter[]{new QFilter("tpv_datasourcesid", "=", entity.get("tpv_masterid").toString())});
            for (DynamicObject claimdetail : claimdetails) {
                claimdetail.set("tpv_region",tpvSalesarea);
                claimdetail.set("tpv_basegoods",tpvBasepriceitems);
                claimdetail.set("tpv_strategyname",tpvPolicynumber);
            }
            SaveServiceHelper.save(claimdetails);
        }

    }
}
