package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;

import java.util.List;

import static tpv.tpv_wm.tpv_dt.java.opplugin.op.BizClaimdetailsAuditOp.clickAudit;

/**
 * @ClassName: BizSaleAuditOp
 * @Description: 合同版本变更之后，如果有变更【大区】【基价商品】【策略号】则需要将合同下所有《认领明细单》对应字段需同步更新 销售合同
 * @author: zbh
 * @date: 2024-08-23
 */
public class BizSaleAuditOp extends AbstractOperationServicePlugIn {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_salesregion");//销售大区
        fieldKeys.add("tpv_basepricegoods");//基价商品
        fieldKeys.add("tpv_strategynum");//策略号
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        String key = e.getOperationKey();
        //判断具体操作
        switch (key) {
            case "audit":
                //监控按钮
                clickAudit(e,"tpv_dt_salescontract", "tpv_salesregion", "tpv_basepricegoods", "tpv_strategynum");
                break;
        }
    }
}
