package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import tpv.tpv_wm.tpv_dt.java.opplugin.validator.ConditionExistenceSubmitValidator;

import java.util.List;

/**
 *@Description: 满足条件时，关联期现认领明细分录存在分录行
 *@Project: zhck
 *@Package: tpv.tpv_wm.tpv_dt.java.opplugin.op.ConditionExistenceSubmitOp
 *@Date: 2024/04/02 10:03
 *@Author: Heisenberg Wenbei He
 *@Version: 1.0
 */
public class ConditionExistenceSubmitOp extends AbstractOperationServicePlugIn {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();

        // 销售价格确认单 是否点价
        fieldKeys.add("tpv_isvertex");

        // 销售价格确认单 关联期现认领明细
        fieldKeys.add("tpv_settlemententity");

        // 货物流转单 是否点价
        fieldKeys.add("tpv_whetherprice");

        // 货物流转单 单据类型
        fieldKeys.add("tpv_billtype");

        // 货物流转单 单据类型 关联期现认领明细
        fieldKeys.add("tpv_settlemententry");
        fieldKeys.add("tpv_begindate");
        fieldKeys.add("tpv_finishdate");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new ConditionExistenceSubmitValidator());
    }
}
