package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

/**
 * @ClassName: CostBillmatAuditOp
 * @Description: 合并分录
 * @author: zbh
 * @date: 2024-05-16
 */
public class CostBillmatAuditOp extends AbstractOperationServicePlugIn {

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        String key = e.getOperationKey();
        DynamicObject[] entities = e.getDataEntities();
        for (DynamicObject entity : entities) {
            DynamicObject tpvDtCostbillmat = BusinessDataServiceHelper.loadSingle(entity.getPkValue(), "tpv_dt_costbillmat");
            switch (key) {
                case "audit":
                    merge(tpvDtCostbillmat);
                    break;
                case "unaudit":
                    unMerge(tpvDtCostbillmat);
                    break;
            }
        }
    }

    public void unMerge(DynamicObject entity) {
        DynamicObjectCollection tpvDtMerge = entity.getDynamicObjectCollection("tpv_dt_merge");
        tpvDtMerge.clear();
        SaveServiceHelper.save(new DynamicObject[]{entity});
    }

    public void merge(DynamicObject entity) {

        DynamicObjectCollection tpvPactmessage = entity.getDynamicObjectCollection("tpv_pactmessage");//合同明细分录
        DynamicObjectCollection tpvMatecost = entity.getDynamicObjectCollection("tpv_matecost");//匹配入库/成本明细
        DynamicObjectCollection tpvDtMerge = entity.getDynamicObjectCollection("tpv_dt_merge");//入库/合同信息分录
        for (DynamicObject dynamicObject : tpvPactmessage) {
            DynamicObject addNew = tpvDtMerge.addNew();
            addNew.set("tpv_departmebh", dynamicObject.get("tpv_departme"));//部门
            addNew.set("tpv_purconumhb", dynamicObject.get("tpv_purconum"));//采购合同号
            addNew.set("tpv_vendorhb", dynamicObject.get("tpv_vendor"));//供应商
            addNew.set("tpv_saleconumhb", dynamicObject.get("tpv_saleconum"));//销售合同号
            addNew.set("tpv_clienthb", dynamicObject.get("tpv_client"));//客户
            addNew.set("tpv_coninfoqtyhb", dynamicObject.get("tpv_coninfoqty"));//数量
            addNew.set("tpv_amtatchhb", dynamicObject.get("tpv_amtatch"));//本次匹配金额（含税）
            addNew.set("tpv_ratedhb", dynamicObject.getBigDecimal("tpv_ratea"));//税率%
            addNew.set("tpv_rateddhb", dynamicObject.get("tpv_ratedd"));//税率
            addNew.set("tpv_vatamtmatchhb", dynamicObject.get("tpv_vatamtmatch"));//本次匹配金额（不含税）
            addNew.set("tpv_vatmatamthb", dynamicObject.get("tpv_vatmatamt"));//本次匹配金额（增值税额）
            addNew.set("tpv_natfeeshb", dynamicObject.get("tpv_natfees"));//费用性质
            addNew.set("tpv_invotitlehb", dynamicObject.get("tpv_invotitle"));//发票抬头
        }
        for (DynamicObject dynamicObject : tpvMatecost) {
            DynamicObject addNew = tpvDtMerge.addNew();
            addNew.set("tpv_matchtypehb", dynamicObject.get("tpv_matchtype"));//匹配类型
            addNew.set("tpv_departmebh", dynamicObject.get("tpv_departmet"));//部门
            addNew.set("tpv_purconumhb", dynamicObject.get("tpv_purchnumds"));//采购合同号
            addNew.set("tpv_inbordnumhb", dynamicObject.get("tpv_inbordnum"));//入库单号
            addNew.set("tpv_vendorhb", dynamicObject.get("tpv_vendors"));//供应商
            addNew.set("tpv_itemcodehb", dynamicObject.get("tpv_itemcode"));//物料名称
            addNew.set("tpv_conprodnamehb", dynamicObject.get("tpv_conprodname"));//品名
            addNew.set("tpv_conshaderhb", dynamicObject.get("tpv_conshader"));//材质
            addNew.set("tpv_conoriginhb", dynamicObject.get("tpv_conorigin"));//产地
            addNew.set("tpv_conspecationhb", dynamicObject.get("tpv_conspecation"));//规格
            addNew.set("tpv_coninfoqtyhb", dynamicObject.get("tpv_conqty"));//数量
            addNew.set("tpv_contractamohb", dynamicObject.get("tpv_contractamo"));//金额
            addNew.set("tpv_amtatchhb", dynamicObject.get("tpv_taxmatamt"));//本次匹配金额（含税）
            addNew.set("tpv_vatamtmatchhb", dynamicObject.get("tpv_taxnomatamt"));//本次匹配金额（不含税）
            addNew.set("tpv_vatmatamthb", dynamicObject.get("tpv_vatnomatamt"));//本次匹配金额（增值税额）
            addNew.set("tpv_ratedhb", dynamicObject.getBigDecimal("tpv_rated"));//税率%
            addNew.set("tpv_rateddhb", dynamicObject.get("tpv_rkratedd"));//税率
            addNew.set("tpv_inboentidhb", dynamicObject.get("tpv_inboentid"));//入库分录id
            addNew.set("tpv_costbreaidhb", dynamicObject.get("tpv_costbreaid"));//成本明细id
            addNew.set("tpv_typecosthb", dynamicObject.get("tpv_typecost"));//成本类型
            addNew.set("tpv_currencyhb", dynamicObject.get("tpv_currency"));//币别
        }
        SaveServiceHelper.save(new DynamicObject[]{entity});
    }
}
