package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author: Heisenberg Wenbei He
 * @Project: zhck
 * @Package: com.itopview.wm.dt.opplugin.op.DeleteReverseWriteContractOp
 * @Date: 19:27 2023/10/30
 * @Description: 被《采购合同》引用后，合同保存反写【采购合同号】；删除后，清空【采购合同号】字段
 * @Version: 1.0
 */
public class DeleteReverseWriteContractOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_applicationform");
        fieldKeys.add("tpv_contractnumber");
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        if ("delete".equals(e.getOperationKey()) && null != e.getDataEntities()) {
            ArrayList<DynamicObject> list = new ArrayList<>();
            for (DynamicObject dataEntity : e.getDataEntities()) {
                DynamicObject applicationform = dataEntity.getDynamicObject("tpv_applicationform");
                if (applicationform != null) {
                    DynamicObject bdSupticket = BusinessDataServiceHelper.loadSingle
                            (applicationform.getPkValue(), "tpv_bd_supticket");
                    bdSupticket.set("tpv_proconnum", null);
                    list.add(bdSupticket);
                }
            }
            SaveServiceHelper.save(list.toArray(new DynamicObject[0]));
        }
    }
}
