package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;

import java.math.BigDecimal;
import java.util.List;

/**
 * ClassName: PurchaseInvoiceMatchOp
 * Description: 采购发票匹配单校验插件
 * date: 2023/11/4 15:22
 *
 * @author: Guo jiaChen
 */
public class PurchaseInvoiceMatchOp extends AbstractOperationServicePlugIn {
    private final static String INVOICE_Entry = "tpv_invoiceinfoentry";//发票
    private final static String CONTRACT_Entry = "tpv_continformation";//合同
    private final static String WAREHOUSE_Entry = "tpv_wareiformation";//入库

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() {
                ExtendedDataEntity[] dataEntities = this.dataEntities;
                //提交校验
                if ("submit".equals(this.getOperateKey()) || "commitskip".equals(this.getOperateKey())) {
                    for (int i = 0; i < dataEntities.length; i++) {
                        ExtendedDataEntity extend = dataEntities[i];
                        DynamicObject entity = extend.getDataEntity();
                        BigDecimal invoiceNum = new BigDecimal("0");
                        BigDecimal contractNum = new BigDecimal("0");
                        BigDecimal warehouseNum = new BigDecimal("0");
                        BigDecimal curmatchamotax = new BigDecimal("0");//本次匹配金额(含税)
                        BigDecimal curmatchamonotax = new BigDecimal("0");//本次匹配金额(不含税)
                        BigDecimal curmatchamointax = new BigDecimal("0");//本次匹配金额(增值税额)
                        DynamicObjectCollection invoiceEntry = entity.getDynamicObjectCollection(INVOICE_Entry);
                        for (DynamicObject object : invoiceEntry) {
//                            invoiceNum = invoiceNum.add(object.getBigDecimal("tpv_curmactchqtys"));
                            curmatchamotax = curmatchamotax.add(object.getBigDecimal("tpv_curmatchamotax").setScale(2,BigDecimal.ROUND_HALF_UP));
                            curmatchamonotax = curmatchamonotax.add(object.getBigDecimal("tpv_curmatchamonotax").setScale(2,BigDecimal.ROUND_HALF_UP));
                            curmatchamointax = curmatchamointax.add(object.getBigDecimal("tpv_curmatchamointax").setScale(2,BigDecimal.ROUND_HALF_UP));
                        }
//                        DynamicObjectCollection contractEntry = entity.getDynamicObjectCollection(CONTRACT_Entry);
//                        for (DynamicObject object : contractEntry) {
//                            contractNum = contractNum.add(object.getBigDecimal("tpv_curmatchqty"));
//                        }
//                        DynamicObjectCollection warehouseEntry = entity.getDynamicObjectCollection(WAREHOUSE_Entry);
//                        for (DynamicObject object : warehouseEntry) {
//                            warehouseNum = warehouseNum.add(object.getBigDecimal("tpv_rkcurmatchqty"));
//                        }
//                        if (invoiceNum.compareTo(contractNum.add(warehouseNum)) != 0){
//                            this.addMessage(extend,"发票信息本次匹配数量不等于合同和入库的本次匹配数量之和,请检查!!!");
//                        }

                        BigDecimal tpvAmounttax = entity.getBigDecimal("tpv_amounttax") != null
                                ? entity.getBigDecimal("tpv_amounttax") : BigDecimal.ZERO;
                        BigDecimal tpvAmountnotax = entity.getBigDecimal("tpv_amountnotax") != null
                                ? entity.getBigDecimal("tpv_amountnotax") : BigDecimal.ZERO;
                        BigDecimal tpvincreasetax = entity.getBigDecimal("tpv_increasetax") != null
                                ? entity.getBigDecimal("tpv_increasetax") : BigDecimal.ZERO;
                        int result = curmatchamotax.compareTo(tpvAmounttax);
                        int resultOne = tpvAmountnotax.compareTo(curmatchamonotax);
                        int resultTwo = tpvincreasetax.compareTo(curmatchamointax);
                        DynamicObject tpvInvoicetype = entity.getDynamicObject("tpv_invoicetype");
                        boolean flag = true;
                        if (YEM.isNotEmpty(tpvInvoicetype)) {
                            String number = tpvInvoicetype.getString("number");
                            //当【发票类型】= 增值税电子普通发票 / 增值税电子普通发票（通行费）/  数电票（普通发票）/  增值税普通发票 / 增值税普通发票（卷票）时
                            if ("1".equals(number) || "15".equals(number) || "26".equals(number) || "3".equals(number) || "5".equals(number)) {
                                flag = false;
                            }
                        }
                        if(result != 0){
                            this.addMessage(extend,"业务单据分配金额（含税）之和必须等于发票金额(含税)之和！");
                        }
                        if(resultOne != 0 && flag){
                            this.addMessage(extend,"业务单据分配金额（不含税）之和必须等于发票金额(不含税)之和！");
                        }
                        if(resultTwo != 0 && flag){
                            this.addMessage(extend,"业务单据分配金额（增值税额）之和必须等于发票金额(增值税额)之和！");
                        }
//                        if (YEM.isNotEmpty(curmatchamotax) && YEM.isNotEmpty(curmatchamonotax) &&  YEM.isNotEmpty(curmatchamointax)
//                        && YEM.isNotEmpty(tpvAmounttax) && YEM.isNotEmpty(tpvAmountnotax) &&  YEM.isNotEmpty(tpvincreasetax)) {
//                            int result = curmatchamotax.compareTo(tpvAmounttax);
//                            int resultOne = tpvAmountnotax.compareTo(curmatchamonotax);
//                            int resultTwo = tpvincreasetax.compareTo(curmatchamointax);
//                            if(result != 0){
//                                this.addMessage(extend,"业务单据分配金额（含税）之和必须等于发票金额(含税)之和！");
//                            }
//                            if(resultOne != 0){
//                                this.addMessage(extend,"业务单据分配金额（不含税）之和必须等于发票金额(不含税)之和！");
//                            }
//                            if(resultTwo != 0){
//                                this.addMessage(extend,"业务单据分配金额（增值税额）之和必须等于发票金额(增值税额)之和！");
//                            }
//                        }
                    }
                }
                // TODO 审核校验
                if ("audit".equals(this.getOperateKey())){

                }
            }
        });
    }

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();

        keys.add("tpv_invoiceinfoentry");
        keys.add("tpv_continformation");
        keys.add("tpv_wareiformation");
        keys.add("tpv_curmactchqtys");
        keys.add("tpv_curmatchqty");
        keys.add("tpv_rkcurmatchqty");
        keys.add("tpv_curmatchamointax");
        keys.add("tpv_curmatchamonotax");
        keys.add("tpv_curmatchamotax");
        keys.add("tpv_increasetax");
        keys.add("tpv_amountnotax");
        keys.add("tpv_amounttax");
        keys.add("tpv_invoicetype");
        e.setFieldKeys(keys);
    }
}
