package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.YEM;
import kd.bos.data.BusinessDataReader;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.botp.runtime.SourceBillReport;
import kd.bos.entity.datamodel.IRefrencedataProvider;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.exception.KDBizException;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author WangShuGuang
 * @version 1.0
 * @description: 关联交易转货单审核服务插件
 * @date 2023/12/6 10:22
 */
public class RelevanceAuditOp extends AbstractOperationServicePlugIn implements Plugin {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_purchaseid");
        fieldKeys.add("tpv_marketid");
        fieldKeys.add("tpv_dt_goodstransfe_zh");
        fieldKeys.add("tpv_dt_transferdist_ph");
        fieldKeys.add("tpv_bizdate");
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        if ("audit".equals(e.getOperationKey()) && null != e.getDataEntities()) {
            for (DynamicObject dataEntity : e.getDataEntities()) {
                long tpvPurchaseid = dataEntity.getLong("tpv_purchaseid");//采购合同id
                long tpvMarketid = dataEntity.getLong("tpv_marketid");//销售合同id
                DynamicObjectCollection tpvDtGoodstransfeZh = dataEntity.getDynamicObjectCollection("tpv_dt_goodstransfe_zh");//父单据体
                List<Long> marketEnertyIdList = new ArrayList<>();
                List<Long> purchaseEnertyIdList = new ArrayList<>();
                List<String> tips = new ArrayList<>();
                Map<Long, List<Map<String, Object>>> createPurInBill = new HashMap<>();
                for (DynamicObject dynamicObject : tpvDtGoodstransfeZh) {
                    purchaseEnertyIdList.add(dynamicObject.getLong("tpv_purchaseenertyid"));
                    marketEnertyIdList.add(dynamicObject.getLong("tpv_marketenertyid"));
                    DynamicObjectCollection tpvDtTransferdistPh = dynamicObject.getDynamicObjectCollection("tpv_dt_transferdist_ph");
                    if (!tpvDtTransferdistPh.isEmpty()) {
                        for (DynamicObject obj : tpvDtTransferdistPh) {
                            if (null != obj.getDynamicObject("tpv_warehouse")) {
//                                Long aLong = obj.getDynamicObject("tpv_warehouse").getLong("id");
                                Long aLong = obj.getLong("tpv_fids");
                                if (!createPurInBill.containsKey(aLong)) {
                                    List<Map<String, Object>> subEntryRows = new ArrayList<>();
                                    Map<String, Object> dateMap = new HashMap<>();
                                    dateMap.put("id", obj.getPkValue());
                                    dateMap.put("billId", dataEntity.getPkValue());
                                    dateMap.put("purConEntryId", dynamicObject.getLong("tpv_purchaseenertyid"));
                                    dateMap.put("saleConEntryId", dynamicObject.getLong("tpv_marketenertyid"));
                                    dateMap.put("tpv_transfertaxprice", dynamicObject.getBigDecimal("tpv_transfertaxprice")); //转货含税单价
                                    dateMap.put("tpv_volumenumber", obj.getString("tpv_volumenumber"));//卷号
                                    dateMap.put("tpv_purchaseid", tpvPurchaseid);//采购合同id
                                    dateMap.put("tpv_pickqty", obj.getBigDecimal("tpv_pickqty"));//本次配货数量
                                    dateMap.put("tpv_warehouse", obj.getLong("tpv_warehouse.id"));//仓库
                                    dateMap.put("tpv_pickbill", obj.getString("tpv_pickbill"));//配货单据
                                    dateMap.put("tpv_billnos", obj.getString("tpv_billnos"));//单据编号
                                    dateMap.put("tpv_materials", obj.getLong("tpv_materials.id"));//商品编码
                                    dateMap.put("tpv_prodnames", obj.getLong("tpv_prodnames.id"));//品名
                                    dateMap.put("tpv_specations", obj.getString("tpv_specations"));//规格
                                    dateMap.put("tpv_shaders", obj.getString("tpv_shaders"));//材质
                                    dateMap.put("tpv_origins", obj.getLong("tpv_origins.id"));//产地
                                    dateMap.put("tpv_ofmeasure", obj.getLong("tpv_ofmeasure.id"));//计量单位
                                    dateMap.put("tpv_ofpackagesqty", obj.getBigDecimal("tpv_ofpackagesqty"));//包装数量
                                    dateMap.put("tpv_fids", obj.getLong("tpv_fids"));//采购单据ID
                                    dateMap.put("tpv_fentryids", obj.getLong("tpv_fentryids"));//采购分录行ID
                                    dateMap.put("tpv_fcoentryids", obj.getLong("tpv_fcoentryids"));//采购合同行ID
                                    dateMap.put("tpv_fcoids", obj.getLong("tpv_fcoids"));//采购合同ID
                                    dateMap.put("tpv_vids", obj.getLong("tpv_vids"));//卷号分录ID
                                    dateMap.put("tpv_contractmark", obj.getString("tpv_contractmark"));//合同号
                                    dateMap.put("tpv_practicalok", obj.getBoolean("tpv_practicalok"));//实提完毕
                                    subEntryRows.add(dateMap);
                                    createPurInBill.put(aLong, subEntryRows);
                                } else {
                                    for (Long keyId : createPurInBill.keySet()) {
                                        if (keyId.equals(aLong)) {
                                            List<Map<String, Object>> maps = createPurInBill.get(keyId);
                                            Map<String, Object> dateMap = new HashMap<>();
                                            dateMap.put("id", obj.getPkValue());
                                            dateMap.put("billId", dataEntity.getPkValue());
                                            dateMap.put("purConEntryId", dynamicObject.getLong("tpv_purchaseenertyid"));
                                            dateMap.put("saleConEntryId", dynamicObject.getLong("tpv_marketenertyid"));
                                            dateMap.put("tpv_transfertaxprice", dynamicObject.getBigDecimal("tpv_transfertaxprice")); //转货含税单价
                                            dateMap.put("tpv_volumenumber", obj.getString("tpv_volumenumber"));//卷号
                                            dateMap.put("tpv_purchaseid", tpvPurchaseid);//采购合同id
                                            dateMap.put("tpv_pickqty", obj.getBigDecimal("tpv_pickqty"));//本次配货数量
                                            dateMap.put("tpv_warehouse", obj.getLong("tpv_warehouse.id"));//仓库
                                            dateMap.put("tpv_pickbill", obj.getString("tpv_pickbill"));//配货单据
                                            dateMap.put("tpv_billnos", obj.getString("tpv_billnos"));//单据编号
                                            dateMap.put("tpv_materials", obj.getLong("tpv_materials.id"));//商品编码
                                            dateMap.put("tpv_prodnames", obj.getLong("tpv_prodnames.id"));//品名
                                            dateMap.put("tpv_specations", obj.getString("tpv_specations"));//规格
                                            dateMap.put("tpv_shaders", obj.getString("tpv_shaders"));//材质
                                            dateMap.put("tpv_origins", obj.getLong("tpv_origins.id"));//产地
                                            dateMap.put("tpv_ofmeasure", obj.getLong("tpv_ofmeasure.id"));//计量单位
                                            dateMap.put("tpv_ofpackagesqty", obj.getBigDecimal("tpv_ofpackagesqty"));//包装数量
                                            dateMap.put("tpv_fids", obj.getLong("tpv_fids"));//采购单据ID
                                            dateMap.put("tpv_fentryids", obj.getLong("tpv_fentryids"));//采购分录行ID
                                            dateMap.put("tpv_fcoentryids", obj.getLong("tpv_fcoentryids"));//采购合同行ID
                                            dateMap.put("tpv_fcoids", obj.getLong("tpv_fcoids"));//采购合同ID
                                            dateMap.put("tpv_vids", obj.getLong("tpv_vids"));//卷号分录ID
                                            dateMap.put("tpv_contractmark", obj.getString("tpv_contractmark"));//合同号
                                            dateMap.put("tpv_practicalok", obj.getBoolean("tpv_practicalok"));//实提完毕
                                            maps.add(dateMap);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                //销售合同生成销售发货单
                generateShipments(marketEnertyIdList, tpvMarketid, tips, createPurInBill, dataEntity);
                //采购合同下推货物流转单
                generateFreigroam(purchaseEnertyIdList, tpvPurchaseid, tips, createPurInBill, dataEntity);

            }
        }
    }

    /**
     * @Description: //销售合同生成销售发货单，再由销售发货单生成销售出库单，销售发货单单库存拣配子分录数据来源关联交易转货单子分录，根据仓库分组生成
     * @param: marketEnertyIdList - [java.util.List<java.lang.Long>] 销售合同分录id集合
     * @param: tpvMarketid - [long] 销售合同id
     * @param: tips - [java.util.List<java.lang.String>] 校验操作是否成功，提示错误原因
     * @param: createPurInBill - [java.util.Map<java.lang.Long] 生成销售合同库存拣配子分录数据
     **/
    public void generateShipments(List<Long> marketEnertyIdList, long tpvMarketid, List<String> tips, Map<Long,
            List<Map<String, Object>>> createPurInBill, DynamicObject dataEntity) {
        //销售合同下推销售发货单
        List<ListSelectedRow> selectedRowsSo = new ArrayList<>();
        for (Long l : marketEnertyIdList) {
            ListSelectedRow listSelectedRow = new ListSelectedRow(tpvMarketid);//来源单据ID
            listSelectedRow.setEntryEntityKey("tpv_materialentry");//来源单据单据体标识
            listSelectedRow.setEntryPrimaryKeyValue(l);//来源单据分录ID
            selectedRowsSo.add(listSelectedRow);
        }
        if (createPurInBill.keySet().size() > 0) {
            for (Map.Entry<Long, List<Map<String, Object>>> longListEntry : createPurInBill.entrySet()) {
                List<Map<String, Object>> value = longListEntry.getValue();
                PushArgs pushArgs = new PushArgs();
                pushArgs.setSourceEntityNumber("tpv_dt_salescontract"); // 必选，源单标识
                pushArgs.setTargetEntityNumber("tpv_dt_salesshipping"); // 必选，目标单标识
                pushArgs.setAutoSave(true);//是否保存
                pushArgs.setRuleId("1746319519590172672"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
                pushArgs.setBuildConvReport(true); // 是否输出详细错误报告
                pushArgs.addCustomParam("tpv_longListZh", JSONObject.toJSONString(value));
                pushArgs.setSelectedRows(selectedRowsSo); // 必选，设置需要下推的源单及分录内码
                ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
                if (pushResult.isSuccess()) {
                    MainEntityType targetMainType = EntityMetadataCache
                            .getDataEntityType(pushArgs.getTargetEntityNumber());
                    List<DynamicObject> targetBillObjs = pushResult
                            .loadTargetDataObjects(new IRefrencedataProvider() {
                                @Override
                                public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                                    BusinessDataReader.loadRefence(objs, dType);
                                }
                            }, targetMainType);
                    if (targetBillObjs.size() > 0) {
                        DynamicObject targetBillObj = targetBillObjs.get(0);
                        if (auditBill(targetBillObj, tips)) {
                            //销售发货单审核成功之后生成销售出库单
                            List<Object> objectList = new ArrayList<>();
                            DynamicObjectCollection objectCollection = targetBillObj.getDynamicObjectCollection("tpv_materialentry");
                            for (DynamicObject dynamicObject : objectCollection) {
                                DynamicObjectCollection tpv_dt_salepick_in = dynamicObject.getDynamicObjectCollection("tpv_dt_salepick_in");
                                if (!tpv_dt_salepick_in.isEmpty()) {
                                    for (DynamicObject object : tpv_dt_salepick_in) {
                                        objectList.add(object.getPkValue());
                                    }
                                }
                            }
                            List<ListSelectedRow> selectedRows = new ArrayList<>();
                            Long pkValue = (Long) targetBillObj.getPkValue();
                            if (objectList.size() > 0) {
                                for (Object object : objectList) {
                                    ListSelectedRow listSelectedRowTwo = new ListSelectedRow(pkValue);//来源单据ID
                                    listSelectedRowTwo.setSubEntryEntityKey("tpv_dt_salepick_in");//来源单据单据体标识
                                    listSelectedRowTwo.setSubEntryPrimaryKeyValue(object);//来源单据分录ID
                                    selectedRows.add(listSelectedRowTwo);
                                }
                            }
                            PushArgs pushArgsTwo = new PushArgs();
                            pushArgsTwo.setSourceEntityNumber("tpv_dt_salesshipping"); // 必选，源单标识
                            pushArgsTwo.setTargetEntityNumber("im_saloutbill"); // 必选，目标单标识
                            pushArgsTwo.setAutoSave(true);//是否保存
                            pushArgsTwo.setRuleId("1798694713818135552"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
                            pushArgsTwo.setBuildConvReport(true); // 是否输出详细错误报告
                            pushArgsTwo.setSelectedRows(selectedRows); // 必选，设置需要下推的源单及分录内码
                            ConvertOperationResult pushResultTwo = ConvertServiceHelper.push(pushArgsTwo);
                            if (pushResultTwo.isSuccess()) {
                                MainEntityType targetMain = EntityMetadataCache
                                        .getDataEntityType(pushArgsTwo.getTargetEntityNumber());
                                List<DynamicObject> targetBill = pushResultTwo
                                        .loadTargetDataObjects(new IRefrencedataProvider() {
                                            @Override
                                            public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                                                BusinessDataReader.loadRefence(objs, dType);
                                            }
                                        }, targetMain);
                                if (targetBill.size() > 0) {
                                    DynamicObject targetBillOne = targetBill.get(0);
                                    targetBillOne.set("biztime", dataEntity.getDate("tpv_bizdate"));
                                    auditBill(targetBillOne, tips);
                                }
                            } else {
                                addCovertMsg("im_saloutbill", pushResultTwo, tips);
                            }
                        }
                    }
                } else {
                    addCovertMsg("tpv_dt_salesshipping", pushResult, tips);
                }
            }
        }
    }

    /**
     * @Description: //采购合同生成货物流转单，再由货物流转单生成采购入库单，入库单分录数据来源关联交易转货单子分录，根据仓库分组生成
     * @param: purchaseEnertyIdList - [java.util.List<java.lang.Long>] 采购合同分录id集合
     * @param: tpvPurchaseid - [long] 采购合同id
     * @param: tips - [java.util.List<java.lang.String>] 校验操作是否成功，提示错误原因
     * @param: createPurInBill - [java.util.Map<java.lang.Long] 生成入库单数据
     * @return: void
     **/
    public void generateFreigroam(List<Long> purchaseEnertyIdList, long tpvPurchaseid, List<String> tips,
                                  Map<Long, List<Map<String, Object>>> createPurInBill, DynamicObject dataEntity) {
        List<ListSelectedRow> selectedRowsSo = new ArrayList<>();
        for (Long l : purchaseEnertyIdList) {
            ListSelectedRow listSelectedRow = new ListSelectedRow(tpvPurchaseid);//来源单据ID
            listSelectedRow.setEntryEntityKey("tpv_materialentry");//来源单据单据体标识
            listSelectedRow.setEntryPrimaryKeyValue(l);//来源单据分录ID
            selectedRowsSo.add(listSelectedRow);
        }
        if (createPurInBill.keySet().size() > 0) {
            for (Map.Entry<Long, List<Map<String, Object>>> longListEntry : createPurInBill.entrySet()) {
                List<Map<String, Object>> value = longListEntry.getValue();
                PushArgs pushArgsSo = new PushArgs();
                pushArgsSo.setSourceEntityNumber("tpv_dt_purchase"); // 必选，源单标识
                pushArgsSo.setTargetEntityNumber("tpv_dt_freigroambill"); // 必选，目标单标识
                pushArgsSo.addCustomParam("tpv_longListZh", JSONObject.toJSONString(value));
                pushArgsSo.setAutoSave(true);//是否保存
                pushArgsSo.setRuleId("1738526298017422336"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
                pushArgsSo.setBuildConvReport(true); // 是否输出详细错误报告
                pushArgsSo.setSelectedRows(selectedRowsSo); // 必选，设置需要下推的源单及分录内码
                ConvertOperationResult pushResultSo = ConvertServiceHelper.push(pushArgsSo);
                if (pushResultSo.isSuccess()) {
                    MainEntityType targetMainType = EntityMetadataCache
                            .getDataEntityType(pushArgsSo.getTargetEntityNumber());
                    List<DynamicObject> targetBillObjs = pushResultSo
                            .loadTargetDataObjects(new IRefrencedataProvider() {
                                @Override
                                public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                                    BusinessDataReader.loadRefence(objs, dType);
                                }
                            }, targetMainType);
                    if (targetBillObjs.size() > 0) {
                        DynamicObject targetBillObj = targetBillObjs.get(0);
                        targetBillObj.set("tpv_bizdate", dataEntity.getDate("tpv_bizdate"));
                        if (auditBill(targetBillObj, tips)) {
                            //货物流转单审核成功后在推采购入库单
                            List<ListSelectedRow> listSelectedRows = new ArrayList<>();
                            Long pkValue = (Long) targetBillObj.getPkValue();
                            DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(pkValue, targetBillObj.getDynamicObjectType());
                            DynamicObjectCollection tpvMaterialentry = dynamicObject.getDynamicObjectCollection("tpv_materialentry");
                            for (DynamicObject object : tpvMaterialentry) {
                                ListSelectedRow listSelectedRow = new ListSelectedRow(pkValue);//来源单据ID
                                listSelectedRow.setEntryEntityKey("tpv_materialentry");//来源单据单据体标识
                                listSelectedRow.setEntryPrimaryKeyValue(object.getLong("id"));//来源单据分录ID
                                listSelectedRows.add(listSelectedRow);
                            }
                            PushArgs pushArgs = new PushArgs();
                            pushArgs.setSourceEntityNumber("tpv_dt_freigroambill"); // 必选，源单标识
                            pushArgs.setTargetEntityNumber("im_purinbill"); // 必选，目标单标识
                            pushArgs.addCustomParam("tpv_longListZh", JSONObject.toJSONString(value));
                            pushArgs.setAutoSave(true);//是否保存
                            pushArgs.setRuleId("1739218844582465536"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
                            pushArgs.setBuildConvReport(true); // 是否输出详细错误报告
                            pushArgs.setSelectedRows(listSelectedRows); // 必选，设置需要下推的源单及分录内码
                            ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
                            if (pushResult.isSuccess()) {
                                MainEntityType targetMain = EntityMetadataCache
                                        .getDataEntityType(pushArgs.getTargetEntityNumber());
                                List<DynamicObject> targetBill = pushResult
                                        .loadTargetDataObjects(new IRefrencedataProvider() {
                                            @Override
                                            public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                                                BusinessDataReader.loadRefence(objs, dType);
                                            }
                                        }, targetMain);
                                if (targetBill.size() > 0) {
                                    DynamicObject targetBillOne = targetBill.get(0);
                                    targetBillOne.set("biztime", dataEntity.getDate("tpv_bizdate"));
                                    auditBill(targetBillOne, tips);
                                }
                            } else {
                                addCovertMsg("im_purinbill", pushResult, tips);
                            }
                        }
                    }
                } else {
                    addCovertMsg("tpv_dt_freigroambill", pushResultSo, tips);
                }
            }
        }

    }


    private void addCovertMsg(String entityNumber, ConvertOperationResult pushResult, List<String> tips) {
        MainEntityType dataEntityType = YEM.getDataEntityType(entityNumber);
        String entityName = dataEntityType.getDisplayName().getLocaleValue();
        String msg = pushResult.getMessage();
        List<SourceBillReport> billReports = pushResult.getBillReports();
        for (int i = 0; i < billReports.size(); i++) {
            SourceBillReport sourceBillReport = billReports.get(i);
            msg = i == 0 ? msg + "。原因:" : msg;
            msg += String.format("%s、%s ", i + 1, sourceBillReport.getFailMessage());
        }
        tips.add(String.format("下推【%s】失败。%s ", entityName, msg));
        throw new KDBizException(String.format("下推【%s】失败。%s", entityName, msg));
    }

    /**
     * 审核单据
     *
     * @param targetBillObjOne
     * @param tips
     * @return
     */
    private boolean auditBill(DynamicObject targetBillObjOne, List<String> tips) {
        DynamicObjectType dynamicObjectType = targetBillObjOne.getDynamicObjectType();
        String entityName = dynamicObjectType.getDisplayName().getLocaleValue();
        String entityNumber = dynamicObjectType.getName();
        OperateOption optionOne = YEM.getOption();
        //option.setVariableValue("linkage", Boolean.toString(true));
        OperationResult saveOne = OperationServiceHelper.executeOperate("save", entityNumber,
                new DynamicObject[]{targetBillObjOne}, optionOne);
        if (saveOne.isSuccess()) {
            OperationResult submitOne = OperationServiceHelper.executeOperate("commitskip",
                    entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
            if (submitOne.isSuccess()) {
                OperationResult auditOne = OperationServiceHelper.executeOperate("audit",
                        entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
                if (auditOne.isSuccess()) {
                    return true;
                } else {
                    tips.add(String.format("【%s】审核失败。%s", entityName, YEM.getOpMsg(auditOne)));
                    throw new KDBizException(String.format("【%s】审核失败。%s", entityName, YEM.getOpMsg(auditOne)));
                }
            } else {
                tips.add(String.format("【%s】提交失败。%s", entityName, YEM.getOpMsg(submitOne)));
                throw new KDBizException(String.format("【%s】提交失败。%s", entityName, YEM.getOpMsg(submitOne)));
            }
        } else {
            tips.add(String.format("【%s】保存失败。%s", entityName, YEM.getOpMsg(saveOne)));
            throw new KDBizException(String.format("【%s】保存失败。%s", entityName, YEM.getOpMsg(saveOne)));
        }
    }
}
