package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.List;

/**
 * @ClassName: RelevancedealgsSubmitOp
 * @Description: 关联转货交易单提交校检数量
 * @author: zbh
 * @date: 2024-01-09
 */
public class RelevancedealgsSubmitOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("tpv_dt_goodstransfe_zh");
        keys.add("tpv_transferqty");
        keys.add("tpv_dt_transferdist_ph");
        keys.add("tpv_pickqty");
        keys.add("tpv_alreadydistributqty");

    }

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
//        String key = e.getOperationKey();
//        DynamicObject[] entities = e.getDataEntities();
//        for (int i = 0; i < entities.length; i++) {
//            DynamicObjectCollection tpvDtGoodstransfeZhs = entities[i].getDynamicObjectCollection("tpv_dt_goodstransfe_zh");
//            for (DynamicObject tpvDtGoodstransfeZh : tpvDtGoodstransfeZhs) {
//                DynamicObjectCollection tpvDtTransferdistPhs = tpvDtGoodstransfeZh.getDynamicObjectCollection("tpv_dt_transferdist_ph");
//                BigDecimal sum = BigDecimal.ZERO;
//                for (DynamicObject tpvDtTransferdistPh : tpvDtTransferdistPhs) {
//                    sum=sum.add(tpvDtTransferdistPh.getBigDecimal("tpv_pickqty"));
//                }
//                tpvDtGoodstransfeZhs.get(i).set("tpv_alreadydistributqty",sum);
//                SaveServiceHelper.update(entities[i]);
//            }
//
//        }
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        DynamicObject[] entities = e.getDataEntities();
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() {
                ExtendedDataEntity[] bills = this.getDataEntities();
                String key = this.getOperateKey();
                for (int i = 0; i < bills.length; i++) {
                    switch (key) {
                        case "submit":
                            synergySup(bills[i]);
                            break;
                        default:
                            break;
                    }
                }
            }

            public void synergySup(ExtendedDataEntity bill){
                DynamicObject dataEntity = bill.getDataEntity();
                DynamicObjectCollection tpvDtGoodstransfeZhs = dataEntity.getDynamicObjectCollection("tpv_dt_goodstransfe_zh");
                for (int i = 0; i < tpvDtGoodstransfeZhs.size(); i++) {
                    BigDecimal tpvTransferqty =  tpvDtGoodstransfeZhs.get(i).getBigDecimal("tpv_transferqty");
                    DynamicObjectCollection tpvDtTransferdistPhs =tpvDtGoodstransfeZhs.get(i).getDynamicObjectCollection("tpv_dt_transferdist_ph");
                    BigDecimal sum = BigDecimal.ZERO;
                    for (DynamicObject tpvDtTransferdistPh : tpvDtTransferdistPhs) {
                        sum=sum.add(tpvDtTransferdistPh.getBigDecimal("tpv_pickqty"));
                    }
                    if (tpvTransferqty.compareTo(sum)!=0){
                        this.addMessage(bill, "转货商品明细的第"+(i+1)+"行的转货数量不等于转货商品配货明细的本次配货数量的汇总！");
                    }
                }
            }
        });
    }
}
