package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.data.BusinessDataReader;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.botp.runtime.SourceBillReport;
import kd.bos.entity.datamodel.IRefrencedataProvider;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.exception.KDBizException;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description: 销售发货单审核校验，审核时，同步实提工作台
 * @Author LinRui
 * @Date 2023/11/8 10:14
 */
public class SaleShippingAuditOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_isautosalesout"); //自动销售出库
        fieldKeys.add("tpv_isautoinorder"); //自动带入采购实提
        fieldKeys.add("tpv_isautoinsales"); //自动带入销售实提
        fieldKeys.add("tpv_materialentry"); //商品分录
        fieldKeys.add("tpv_dt_salepick_zy"); //拣配信息-采购合同（直运时必选）
        fieldKeys.add("tpv_dt_salepick_in"); //拣配信息-库存
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        DynamicObject[] bills = e.getDataEntities();
        for (int i = 0; i < bills.length; ++i) {
            DynamicObject bill = bills[i];
            DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(bill.getPkValue(), bill.getDataEntityType().getName());
            boolean tpvIsautosalesout = dynamicObject.getBoolean("tpv_isautosalesout");
            boolean tpvIsautoinorder = dynamicObject.getBoolean("tpv_isautoinorder");
            boolean tpvIsautoinsales = dynamicObject.getBoolean("tpv_isautoinsales");
            List<Long> entryIds = new ArrayList<>();
            DynamicObjectCollection tpvMaterialentry = dynamicObject.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject object : tpvMaterialentry) {
                if (!entryIds.contains(object.getLong("id"))) {
                    entryIds.add(object.getLong("id"));
                }
            }
            if (tpvIsautosalesout) {
                updateWorkInPick(dynamicObject);  //同步实提工作台底表子分录数据
            }
            if (tpvIsautoinsales) {
                String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_configuranew", "tpv_sonentryentity");
                QFilter qFilter2 = new QFilter("tpv_sonentryentity.id", QCP.large_than, 0);
                if (entryIds.size() > 0) {
                    qFilter2.and(new QFilter("id", QCP.in, entryIds));
                }
                DynamicObject[] load = BusinessDataServiceHelper.load("tpv_dt_configuranew",selectfieldsFast,qFilter2.toArray());
                for (DynamicObject object : load) {
                    BigDecimal qty = object.getBigDecimal("tpv_qty");
                    BigDecimal packQty = object.getBigDecimal("tpv_packnum");
                    BigDecimal zyQty = BigDecimal.ZERO;
                    BigDecimal zyPackQty = BigDecimal.ZERO;
                    DynamicObjectCollection tpvSonentryentity = object.getDynamicObjectCollection("tpv_sonentryentity");
                    for (DynamicObject entryentity : tpvSonentryentity) {
                        zyQty = zyQty.add(entryentity.getBigDecimal("tpv_pickqty_in"));
                        zyPackQty = zyPackQty.add(entryentity.getBigDecimal("tpv_packnum_in"));
                        entryentity.set("tpv_destroyquantity",entryentity.getBigDecimal("tpv_pickqty_in")); //销提数量
                        entryentity.set("tpv_fpackagereal",entryentity.getBigDecimal("tpv_packnum_in")); //实提包装数量
                        entryentity.set("tpv_destroysure",true); //销提确认
                    }
                    if (qty.compareTo(zyQty) <= 0 || packQty.compareTo(zyPackQty) <= 0) {
                        object.set("tpv_practicalok", true); //实提完毕
                    }
                }
                SaveServiceHelper.save(load);
            }
            if (tpvIsautoinorder) {
//                String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_configuranew", "tpv_sonentryentity");
//                QFilter qFilter2 = new QFilter("tpv_sonentryentity.id", QCP.large_than, 0);
//                if (entryIds.size() > 0) {
//                    qFilter2.and(new QFilter("id", QCP.in, entryIds));
//                }
//                DynamicObject[] load = BusinessDataServiceHelper.load("tpv_dt_configuranew",selectfieldsFast,qFilter2.toArray());
//                for (DynamicObject object : load) {
//                    DynamicObjectCollection tpvSonentryentity = object.getDynamicObjectCollection("tpv_sonentryentity");
//                    for (DynamicObject entryentity : tpvSonentryentity) {
//                        entryentity.set("tpv_purchasequantity",entryentity.getBigDecimal("tpv_pickqty_in")); //采提数量
//                    }
//                }
//                SaveServiceHelper.save(load);
            }
        }
    }


    private void updateWorkInPick(DynamicObject bill) {
        DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(bill.getPkValue(), bill.getDataEntityType().getName());
        boolean tpvIsautosalesout = dynamicObject.getBoolean("tpv_isautosalesout");
        if (tpvIsautosalesout) {
            List<Long> entryIds = new ArrayList<>();
            DynamicObjectCollection tpvMaterialentry = dynamicObject.getDynamicObjectCollection("tpv_materialentry");
            for (DynamicObject object : tpvMaterialentry) {
                if (!entryIds.contains(object.getLong("id"))) {
                    entryIds.add(object.getLong("id"));
                }
            }
            List<Long> idlist = new ArrayList<>(); //单据id
            List<Long> subEntryidlist = new ArrayList<>(); //库存子分录id
            List<Map<String, Object>> subEntryList = new ArrayList<>(); //下推销提数量 默认等于数量
            //查询库存子分录数据，根据父分录id过滤
            QFilter qFilter1 = new QFilter("tpv_sonentryentity.id", QCP.large_than, 0);
            if (entryIds.size() > 0) {
                qFilter1.and(new QFilter("id", QCP.in, entryIds));
            }
            DynamicObjectCollection tpvDtConfiguranew = QueryServiceHelper.query("tpv_dt_configuranew", "id," +
                    "tpv_sonentryentity,tpv_sonentryentity.id insubentryid,tpv_sonentryentity.tpv_pickqty_in tpv_inqty,tpv_sonentryentity.tpv_packnum_in tpv_inpacknum," +
                    "tpv_sonentryentity.tpv_destroyquantity tpv_destroyquantity,tpv_sonentryentity.tpv_fpackagereal tpv_fpackagereal"
                    , qFilter1.toArray());
            for (DynamicObject entryentity : tpvDtConfiguranew) {
                Map<String, Object> subEntryMap = new HashMap<>();
                Long insubentryid = entryentity.getLong("insubentryid");
                if (!subEntryidlist.contains(insubentryid)) {
                    subEntryidlist.add(insubentryid);
                }
                subEntryMap.put("tpv_destroyquantity", entryentity.getBigDecimal("tpv_inqty"));
                subEntryMap.put("tpv_fpackagereal", entryentity.getBigDecimal("tpv_inpacknum"));
                subEntryMap.put("tpv_directconsignmentid", insubentryid);
                subEntryMap.put("insubentry", "yes");
                subEntryList.add(subEntryMap);
            }
            idlist.add(dynamicObject.getLong("id"));
            String pushParam = subEntryList.size() > 0 ? JSONObject.toJSONString(subEntryList) : "";
            pushSaleOutbill(idlist, entryIds, subEntryidlist, pushParam);
        }
    }

    private void pushSaleOutbill(List<Long> billIds, List<Long> entryIds, List<Long> pushSubEntryid, String pushParam) {
        List<String> tips = new ArrayList<>();
        if (billIds.size() > 0) {
            for (Long billId : billIds) {
                List<ListSelectedRow> selectedRowsTwo = new ArrayList<>();
                if (pushSubEntryid.size() > 0) {
                    for (Long aLong : pushSubEntryid) {
                        ListSelectedRow listSelectedRowTwo = new ListSelectedRow(billId);//来源单据ID
                        listSelectedRowTwo.setSubEntryEntityKey("tpv_dt_salepick_in");//来源单据单据体标识
                        listSelectedRowTwo.setSubEntryPrimaryKeyValue(aLong);//来源单据分录ID
                        selectedRowsTwo.add(listSelectedRowTwo);
                    }
                }
                PushArgs pushArgsTwo = new PushArgs();
                pushArgsTwo.addCustomParam("longList", pushParam);
                pushArgsTwo.setSourceEntityNumber("tpv_dt_salesshipping"); // 必选，源单标识
                pushArgsTwo.setTargetEntityNumber("im_saloutbill"); // 必选，目标单标识
                pushArgsTwo.setAutoSave(true);//是否保存
                pushArgsTwo.setRuleId("1798694713818135552"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
                pushArgsTwo.setBuildConvReport(true); // 是否输出详细错误报告
                pushArgsTwo.setSelectedRows(selectedRowsTwo); // 必选，设置需要下推的源单及分录内码
                ConvertOperationResult pushResultTwo = ConvertServiceHelper.push(pushArgsTwo);
                if (pushResultTwo.isSuccess()) {
                    MainEntityType targetMainTypeOne = EntityMetadataCache
                            .getDataEntityType(pushArgsTwo.getTargetEntityNumber());
                    List<DynamicObject> targetBillObjsOne = pushResultTwo
                            .loadTargetDataObjects(new IRefrencedataProvider() {
                                @Override
                                public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                                    BusinessDataReader.loadRefence(objs, dType);
                                }
                            }, targetMainTypeOne);
                    if (targetBillObjsOne.size() > 0) {
                        DynamicObject targetBillObjOne = targetBillObjsOne.get(0);
                        if (auditBill(targetBillObjOne, tips)) {
                            if (pushSubEntryid.size() > 0) {
                                Map<Long,String> setOutBillnoByZyEntryIdsMap = new HashMap<>();
                                QFilter qFilter3 = new QFilter("billentry.id", QCP.large_than, 0);
                                qFilter3.and(new QFilter("billentry.tpv_directconsignmentid", QCP.in, pushSubEntryid));
                                DynamicObjectCollection imSaloutbill = QueryServiceHelper.query("im_saloutbill",
                                        "id,billno,billentry,billentry.id entryid,billentry.tpv_directconsignmentid zysubentryid", qFilter3.toArray());
                                for (DynamicObject entity : imSaloutbill) {
                                    setOutBillnoByZyEntryIdsMap.put(entity.getLong("zysubentryid"), entity.getString("billno"));
                                }
                                if (setOutBillnoByZyEntryIdsMap.size() > 0) {
                                    String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast("tpv_dt_configuranew", "tpv_sonentryentity");
                                    QFilter qFilter2 = new QFilter("tpv_sonentryentity.id", QCP.large_than, 0);
                                    if (entryIds.size() > 0) {
                                        qFilter2.and(new QFilter("id", QCP.in, entryIds));
                                    }
                                    DynamicObject[] load = BusinessDataServiceHelper.load("tpv_dt_configuranew", selectfieldsFast, qFilter2.toArray());
                                    for (DynamicObject object : load) {
                                        BigDecimal qty = object.getBigDecimal("tpv_qty");
                                        BigDecimal packQty = object.getBigDecimal("tpv_packnum");
                                        BigDecimal zyQty = BigDecimal.ZERO;
                                        BigDecimal zyPackQty = BigDecimal.ZERO;
                                        DynamicObjectCollection tpvSonentryentity = object.getDynamicObjectCollection("tpv_sonentryentity");
                                        for (DynamicObject entryentity : tpvSonentryentity) {
                                            zyQty = zyQty.add(entryentity.getBigDecimal("tpv_pickqty_in"));
                                            zyPackQty = zyPackQty.add(entryentity.getBigDecimal("tpv_packnum_in"));
                                            entryentity.set("tpv_destroyquantity",entryentity.getBigDecimal("tpv_pickqty_in")); //销提数量
                                            entryentity.set("tpv_fpackagereal",entryentity.getBigDecimal("tpv_packnum_in")); //实提包装数量
                                            entryentity.set("tpv_destroysure",true); //销提确认
//                                            if (setOutBillnoByZyEntryIdsMap.keySet().contains(entryentity.getLong("id"))) {
//                                                entryentity.set("tpv_deliveryorder",setOutBillnoByZyEntryIdsMap.get(entryentity.getLong("id"))); //出库单号
//                                            }
                                        }
                                        if (qty.compareTo(zyQty) <= 0 || packQty.compareTo(zyPackQty) <= 0) {
                                            object.set("tpv_practicalok", true);
                                        }
                                    }
                                    SaveServiceHelper.save(load);
                                }
                            }
                        }
                    }
                } else {
                    addCovertMsg("im_saloutbill", pushResultTwo, tips);
                }
            }
        }
        if (tips.size() > 0) {
            String errMsg = "";
            int msgSeq = 1;
            for (String tip : tips) {
                errMsg += String.format("%s、%s%s", msgSeq++, tip, "\r\n");
            }
            throw new KDBizException("同步失败，备方案：手动删除下游单，反审核后，重新审核。\r\n 存在异常单据，详情如下。\r\n" + errMsg);
        }
    }
    private void addCovertMsg(String entityNumber, ConvertOperationResult pushResult, List<String> tips) {
        MainEntityType dataEntityType = YEM.getDataEntityType(entityNumber);
        String entityName = dataEntityType.getDisplayName().getLocaleValue();
        String msg = pushResult.getMessage();
        List<SourceBillReport> billReports = pushResult.getBillReports();
        for (int i = 0; i < billReports.size(); i++) {
            SourceBillReport sourceBillReport = billReports.get(i);
            msg = i == 0 ? msg + "。原因:" : msg;
            msg += String.format("%s、%s ", i + 1, sourceBillReport.getFailMessage());
        }
        tips.add(String.format("下推【%s】失败。%s ", entityName, msg));
    }

    private boolean auditBill(DynamicObject targetBillObjOne, List<String> tips) {
        DynamicObjectType dynamicObjectType = targetBillObjOne.getDynamicObjectType();
        String entityName = dynamicObjectType.getDisplayName().getLocaleValue();
        String entityNumber = dynamicObjectType.getName();
        OperateOption optionOne = YEM.getOption();
        //option.setVariableValue("linkage", Boolean.toString(true));
        OperationResult saveOne = OperationServiceHelper.executeOperate("save", entityNumber,
                new DynamicObject[]{targetBillObjOne}, optionOne);
        if (saveOne.isSuccess()) {
            OperationResult submitOne = OperationServiceHelper.executeOperate("submit",
                    entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
            if (submitOne.isSuccess()) {
                OperationResult auditOne = OperationServiceHelper.executeOperate("audit",
                        entityNumber, new Object[]{targetBillObjOne.getPkValue()}, optionOne);
                if (auditOne.isSuccess()) {
                    return true;
                } else {
                    tips.add(String.format("【%s】审核失败。%s", entityName, YEM.getOpMsg(auditOne)));
                }
            } else {
                tips.add(String.format("【%s】提交失败。%s", entityName, YEM.getOpMsg(submitOne)));
            }
        } else {
            tips.add(String.format("【%s】保存失败。%s", entityName, YEM.getOpMsg(saveOne)));
        }
        return false;
    }
}
