package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import tpv.tpv_wm.tpv_dt.java.opplugin.validator.SaleShippingSubmitValidator;

import java.util.List;

/**
 * @Description: 销售发货单提交校验，校验可放余额表额度
 * @Author LinRui
 * @Date 2023/11/8 10:14
 */
public class SaleShippingSubmitOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_department");
        fieldKeys.add("tpv_customer");
        fieldKeys.add("tpv_billtype");
        fieldKeys.add("tpv_abbreviation");
        fieldKeys.add("tpv_project");
        fieldKeys.add("tpv_contractnumber");
        fieldKeys.add("tpv_amount");  //金额原币
        fieldKeys.add("tpv_materialentry");  //分录标识
        fieldKeys.add("tpv_qty");  //数量
        fieldKeys.add("tpv_cobillid");  //核心单据ID
        fieldKeys.add("tpv_coentryid");  //核心单据分录ID
        fieldKeys.add("tpv_taxpramount");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new SaleShippingSubmitValidator());
    }
}
