package tpv.tpv_wm.tpv_dt.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.hr.haos.business.util.QFilterEval;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.stream.Stream;

/**
 * @author 金亮
 * @date 2024/4/24 14:12
 * @relevantfile 历史数据赋值（同步） : 1.将商品分录第一行中的【商品编号】的编码和分类 赋值给【实物商品物料分类】和【实物商品物料编码】
 *                                 2.合同名称 = 合同号
 * @description
 * @versions 1.0
 */
public class SalesContractOp extends AbstractOperationServicePlugIn {
    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        String key = e.getOperationKey();
        DynamicObject[] entities = e.getDataEntities();
        DynamicObject billOne = entities[0];
        String billName = billOne.getDataEntityType().getName();

        if (key.equals("materialfielddelivery")) {
            ArrayList<Long> IDlist = new ArrayList<>();//存储物料的id
            QFilter qFilter = new QFilter("billno", QCP.not_equals, "");
            DynamicObject[] billArr = BusinessDataServiceHelper.load(billName, "id,tpv_materialentry.tpv_material,tpv_commoditycod,tpv_commodityclassify", new QFilter[]{qFilter});//销售合同/采购合同/协议
            int length = billArr.length;
            if (billArr == null || billArr.length == 0) {
                return;
            }
            for (DynamicObject bill : billArr) {
                DynamicObjectCollection tpvMaterialentry = bill.getDynamicObjectCollection("tpv_materialentry");//商品分录
                if (tpvMaterialentry == null || tpvMaterialentry.size() == 0) {
                    continue;
                }
                DynamicObject entity = tpvMaterialentry.get(0);
                DynamicObject tpvMaterial = entity.getDynamicObject("tpv_material");//商品编号
                if (tpvMaterial == null) {
                    continue;
                }
                String number = tpvMaterial.getString("number");
                bill.set("tpv_commoditycod", number);//赋值 物料编码***
                long aLongId = tpvMaterial.getLong("id");//物料id
                IDlist.add(aLongId);
            }
            QFilter qFiltera = new QFilter("material.id", QCP.in, IDlist);
            qFiltera.and(new QFilter("standard.number", QCP.equals, "JBFLBZ"));
            DynamicObject[] materialClassArr = BusinessDataServiceHelper.load("bd_materialgroupdetail", "id,group,material", new QFilter[]{qFiltera});
            int materialClassArrlength = materialClassArr.length;
            if (materialClassArr== null || materialClassArr.length==0) {
                return;
            }
            HashMap<Long, String> map = new HashMap<>();//存储物料id 和对应的分类名称
            for (DynamicObject  materialClass : materialClassArr) {
                DynamicObject material = materialClass.getDynamicObject("material");//物料
                DynamicObject group = materialClass.getDynamicObject("group");//分组
                if (material==null || group==null){
                    continue;
                }
                String name = group.getString("name");
                Long id = material.getLong("id");
                map.put(id,name);
            }
            for (DynamicObject bill : billArr) {
                DynamicObjectCollection tpvMaterialentry = bill.getDynamicObjectCollection("tpv_materialentry");//商品分录
                if (tpvMaterialentry == null || tpvMaterialentry.size() == 0) {
                    continue;
                }
                DynamicObject entity = tpvMaterialentry.get(0);
                DynamicObject tpvMaterial = entity.getDynamicObject("tpv_material");//商品编号
                if (tpvMaterial == null) {
                    continue;
                }
                long aLongId = tpvMaterial.getLong("id");//物料id
                bill.set("tpv_commodityclassify",map.get(aLongId));//赋值 物料分类名称
            }
            SaveServiceHelper.save(billArr);
        } else if (key.equals("name")) {//合同名称同步
            // 查询出表中所有单据编号不为空的数据
            QFilter qFilter = new QFilter("billno", QCP.not_equals, "");
            DynamicObject[] billArr = BusinessDataServiceHelper.load(billName, "id,tpv_contractnos,name", new QFilter[]{qFilter});//销售合同/采购合同/协议
            for (DynamicObject bill : billArr) {
                String tpvContractnos = bill.getString("tpv_contractnos");
                if(tpvContractnos.length() > 50){
                    bill.set("name", tpvContractnos.substring(0,45));
                }else{
                    bill.set("name", tpvContractnos);
                }
            }
            SaveServiceHelper.save(billArr);
        }

    }
}
