package tpv.tpv_wm.tpv_dt.java.opplugin.validator;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;
import tpv.tpv_wm.tpv_cm.java.utils.CostDisposeRptUtils;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @author LiuHB
 * @version 1.0
 */
public class CostBillmatValidator extends AbstractValidator {

    @Override
    public void validate() {
        ExtendedDataEntity[] dataEntities = this.getDataEntities();
        String operationKey = this.getOperateKey();//获取操作名称
        for (int i = 0; i < dataEntities.length; i++) {
            ExtendedDataEntity bill = dataEntities[i];
            DynamicObject entity = bill.getDataEntity();
            String entityName = entity.getDataEntityType().getName();//获取单据标识
            switch (operationKey) {
                case "submit":
                case "commitskip":
                    amountincluding(entity, bill); //本次含税金额的校验
                    finalamount(entity, bill); //冲销金额的校验
                    redqtycost(entity, bill); //成本红冲表暂估成本的校验
                    break;
            }
        }
    }

    private void redqtycost(DynamicObject entity, ExtendedDataEntity bill) {
        DynamicObject tpvCostitem = entity.getDynamicObject("tpv_costitem");
        long costitemLong = 0l;
        if (YEM.isNotEmpty(tpvCostitem)) {
            costitemLong = tpvCostitem.getLong("id");
        }
        DynamicObjectCollection tpvMatecost = entity.getDynamicObjectCollection("tpv_matecost");
        List<String> tpvInboentids = new ArrayList<>();
        for (DynamicObject dynamicObject : tpvMatecost) {
            String tpvInboentid = dynamicObject.getString("tpv_inboentid");
            if (!tpvInboentids.contains(tpvInboentid)) {
                tpvInboentids.add(tpvInboentid);
            }
        }
        if (tpvInboentids.size() > 0) {
            String whereFilter = "1 =1";
            if (costitemLong > 0l && tpvInboentids.size() > 0) {
                whereFilter = String.format("%s and tpv_costype = %s", whereFilter, costitemLong);
                whereFilter = String.format("%s and tpv_storageid in ('%s')", whereFilter, String.join("','", tpvInboentids));
                whereFilter = String.format("%s and tpv_redqty > 0", whereFilter);
                DataSet dataSet = CostDisposeRptUtils.getCostdisposeredRedQtyData().where(whereFilter);
                DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(dataSet.copy());
                List<Long> contractnoIds = new ArrayList<>();
                for (DynamicObject dynamicObject : dynamicObjects) {
                    BigDecimal tpvRedqty = dynamicObject.getBigDecimal("tpv_redqty");
                    String tpvCostdirec = dynamicObject.getString("tpv_costdirec");
                    if (tpvRedqty.compareTo(BigDecimal.ZERO) != 0 && "A".equals(tpvCostdirec)) {
                        Long tpvSaleconnum = dynamicObject.getLong("tpv_saleconnum");
                        if (!contractnoIds.contains(tpvSaleconnum)) {
                            contractnoIds.add(tpvSaleconnum);
                        }
                    }
                }
                if (contractnoIds.size() > 0) {
                    QFilter qFilterSalesCon = new QFilter("id", QCP.in, contractnoIds);
                    DynamicObjectCollection querySalesCon = QueryServiceHelper.query("tpv_dt_salescontract",
                            "id,billno,tpv_contractnos", qFilterSalesCon.toArray());
                    List<String> contractnos = new ArrayList<>();
                    if (querySalesCon.size() > 0) {
                        for (DynamicObject dynamicObject : querySalesCon) {
                            String tpvContractnos = dynamicObject.getString("tpv_contractnos");
                            if (!contractnos.contains(tpvContractnos)) {
                                contractnos.add(tpvContractnos);
                            }
                        }
                    }
                    if (contractnos.size() > 0) {
                        this.addWarningMessage(bill, "合同号：" + String.join("、", contractnos) + "存在未冲销的暂估成本，是否确认直接计入费用？");
                    }
                }
            }
        }
    }

    private void finalamount(DynamicObject entity, ExtendedDataEntity bill) {
        DynamicObject tpvCostitem = entity.getDynamicObject("tpv_costitem");
        if (YEM.isNotEmpty(tpvCostitem)) {
            String number = tpvCostitem.getString("number");
            DynamicObjectCollection dynamicObjectCollection = entity.getDynamicObjectCollection("tpv_pactmessage");
            List<Long> list = new ArrayList<>();
            for (DynamicObject dynamicObject : dynamicObjectCollection) {
                DynamicObject tpvSaleconum = dynamicObject.getDynamicObject("tpv_saleconum");
                if (YEM.isNotEmpty(tpvSaleconum)) {
                    if (!list.contains(tpvSaleconum.getLong("id"))) {
                        list.add(tpvSaleconum.getLong("id"));
                    }
                }
            }
            if (list.size() > 0) {
                QFilter qFilter = new QFilter("shkd_saleentryentity.shkd_salecontracte.id", QCP.in, list);
                DynamicObjectCollection query = QueryServiceHelper.query("ar_finarbill",
                        "id,billno,shkd_saleentryentity,shkd_saleentryentity.shkd_salecontracte.id shkd_salecontracte," +
                                "shkd_saleentryentity.shkd_freightnotfee shkd_freightnotfee,shkd_saleentryentity.shkd_insurancenotfee shkd_insurancenotfee," +
                                "shkd_saleentryentity.shkd_commissionnotfee shkd_commissionnotfee", qFilter.toArray());
                List<Long> contractnoIds = new ArrayList<>();
                if (query.size() > 0) {
                    for (DynamicObject dynamicObject : query) {
                        Long shkdSalecontracte = dynamicObject.getLong("shkd_salecontracte");
                        if ("FYXM150.1142".equals(number)) {
                            BigDecimal shkdFreightnotfee = dynamicObject.getBigDecimal("shkd_freightnotfee");
                            if (shkdFreightnotfee.compareTo(BigDecimal.ZERO) == 0) {
                                if (!contractnoIds.contains(shkdSalecontracte)) {
                                    contractnoIds.add(shkdSalecontracte);
                                }
                            }
                        }
                        if ("FYXM150.1152".equals(number)) {
                            BigDecimal shkdInsurancenotfee = dynamicObject.getBigDecimal("shkd_insurancenotfee");
                            if (shkdInsurancenotfee.compareTo(BigDecimal.ZERO) == 0) {
                                if (!contractnoIds.contains(shkdSalecontracte)) {
                                    contractnoIds.add(shkdSalecontracte);
                                }
                            }
                        }
                        if ("FYXM150.1220".equals(number)) {
                            BigDecimal shkdCommissionnotfee = dynamicObject.getBigDecimal("shkd_commissionnotfee");
                            if (shkdCommissionnotfee.compareTo(BigDecimal.ZERO) == 0) {
                                if (!contractnoIds.contains(shkdSalecontracte)) {
                                    contractnoIds.add(shkdSalecontracte);
                                }
                            }
                        }
                    }
                }
                if (contractnoIds.size() > 0) {
                    QFilter qFilterSalesCon = new QFilter("id", QCP.in, contractnoIds);
                    DynamicObjectCollection querySalesCon = QueryServiceHelper.query("tpv_dt_salescontract",
                            "id,billno,tpv_contractnos", qFilterSalesCon.toArray());
                    List<String> contractnos = new ArrayList<>();
                    if (querySalesCon.size() > 0) {
                        for (DynamicObject dynamicObject : querySalesCon) {
                            String tpvContractnos = dynamicObject.getString("tpv_contractnos");
                            if (!contractnos.contains(tpvContractnos)) {
                                contractnos.add(tpvContractnos);
                            }
                        }
                    }
                    if (contractnos.size() > 0) {
                        this.addMessage(bill, "合同号：" + String.join("、", contractnos) + "存在未冲销的预提费用，请先进行冲销");
                    }
                }
            }
        }
    }

    private void amountincluding(DynamicObject entity, ExtendedDataEntity bill) {
        // 发票信息本次匹配金额含税汇总
        BigDecimal tpvTaxinclamt = entity.getBigDecimal("tpv_invoceamtsum");
        // 合同明细含税金额汇总
        BigDecimal tpvInvoceamt = entity.getBigDecimal("tpv_invoceamt");
        // 匹配入库/成本明细含税金额汇总
        BigDecimal tpvMatchamt = entity.getBigDecimal("tpv_matchamt");

        // 含税金额表头汇总
        BigDecimal taxinclamt = BigDecimal.ZERO;
        taxinclamt = entity.getBigDecimal("tpv_taxinclamt");
        // 不含税金额表头汇总
        BigDecimal taxnoinclamt = BigDecimal.ZERO;
        taxnoinclamt = entity.getBigDecimal("tpv_taxnoinclamt");
        // 增值税额表头汇总
        BigDecimal vatamt = BigDecimal.ZERO;
        vatamt = entity.getBigDecimal("tpv_vatamt");

        // 发票信息本次匹配金额不含税汇总(隐藏)
        BigDecimal withouTaxAmount = BigDecimal.ZERO;
        withouTaxAmount = entity.getBigDecimal("tpv_withouttaxamount");
        // 发票信息本次匹配金额增值税汇总(隐藏)
        BigDecimal addTaxAmount = BigDecimal.ZERO;
        addTaxAmount = entity.getBigDecimal("tpv_addtaxamount");
        // 发票信息本次匹配金额含税汇总(隐藏)
        BigDecimal invoceamtsum = BigDecimal.ZERO;
        invoceamtsum = entity.getBigDecimal("tpv_invoceamtsum");
        DynamicObject tpvInvoicetype = entity.getDynamicObject("tpv_invoicetype");
        boolean flag = true;
        if (YEM.isNotEmpty(tpvInvoicetype)) {
            String number = tpvInvoicetype.getString("number");
            //当【发票类型】= 增值税电子普通发票 / 增值税电子普通发票（通行费）/  数电票（普通发票）/  增值税普通发票 / 增值税普通发票（卷票）时
            if ("1".equals(number) || "15".equals(number) || "26".equals(number) || "3".equals(number) || "5".equals(number)) {
                flag = false;
            }
        }
        if (taxinclamt.compareTo(invoceamtsum) != 0) {
            this.addErrorMessage(bill, "业务单据分配金额（含税）之和必须等于发票金额(含税)之和！！");
        }
        if (taxnoinclamt.compareTo(withouTaxAmount) != 0 && flag) {
            this.addErrorMessage(bill, "业务单据分配金额（不含税）之和必须等于发票金额(不含税)之和！");
        }
        if (vatamt.compareTo(addTaxAmount) != 0 && flag) {
            this.addErrorMessage(bill, "业务单据分配金额（增值税额）之和必须等于发票金额(增值税额)之和！");
        }

    }
}
