package tpv.tpv_wm.tpv_dt.java.opplugin.validator;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.sys.utils.NewVersionHelper;
import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import tpv.tpv_wm.tpv_crm.java.utils.CusCreditLimitUtils;

import java.math.BigDecimal;
import java.util.*;

/**
 * @Description: 销售合同提交校检插件
 * @Auther: zbh
 */
public class SaleContractSubmitValidator extends AbstractValidator {

    @Override
    public void validate() {
        ExtendedDataEntity[] bills = this.getDataEntities();
        String key = this.getOperateKey();
        for (int i = 0; i < bills.length; i++) {
            switch (key) {
                case "submit":
                    submitSupplychain(bills[i], bills);
                    subThirdparty(bills[i], bills);
                    proportionSub(bills[i], bills);
                    cutomerNameSup(bills[i], bills);
                    dateofconTracting(bills[i], bills);
                    // LinRui begin
                    ExtendedDataEntity extend = dataEntities[i];
                    DynamicObject entity = extend.getDataEntity();
                    boolean tpvIsselloncredit = entity.getBoolean("tpv_isselloncredit");
                    if (tpvIsselloncredit) {
                        cusreditConVal(entity, extend); //销售合同客户额度校验
                    }
                    // LinRui end
                    break;
                case "audit":
                    break;
                default:
                    break;
            }
        }
    }

    private void dateofconTracting(ExtendedDataEntity bill, ExtendedDataEntity[] bills) {
        DynamicObject dataEntity = bill.getDataEntity();
        Date tpvDateofcontracting = dataEntity.getDate("tpv_signingdate");
        Date dateTract = new Date();
        if (dateTract.before(tpvDateofcontracting)){
            this.addMessage(bill,"签约日期大于系统日期！");
        }
    }

    /**
     * 销售同提交校验 -当剩余签约额度不足时提示：“xxxxx”;
     *
     * @param entity
     * @param extend
     */
    private void cusreditConVal(DynamicObject entity, ExtendedDataEntity extend) {
        DynamicObject tpvDepartment = entity.getDynamicObject("tpv_department");
        DynamicObject tpvCustomer = entity.getDynamicObject("tpv_customer");
        BigDecimal tpvAmount = entity.getBigDecimal("tpv_amount");
        if (YEM.isEmpty(tpvDepartment) & YEM.isEmpty(tpvCustomer)) {
            return;
        }
        QFilter qFilter = new QFilter("enable", QCP.equals, "1");
        if (YEM.isNotEmpty(tpvDepartment)) {
            qFilter.and(new QFilter("id",QCP.equals,tpvDepartment.getLong("id")));
        }
        DynamicObject bosAdminorgs = BusinessDataServiceHelper.loadSingle("bos_adminorg", qFilter.toArray());
        if (YEM.isNotEmpty(bosAdminorgs)) {
            DynamicObject orgpattern = bosAdminorgs.getDynamicObject("orgpattern");
            if (YEM.isNotEmpty(orgpattern)) {
                String number = orgpattern.getString("number");
                if ("OF-01".equals(number)) {
                    DynamicObjectCollection dynamicObjects = bosAdminorgs.getDynamicObjectCollection("structure");
                    if (dynamicObjects.size() > 0) {
                        for (DynamicObject dynamicObject : dynamicObjects) {
                            DynamicObject viewparent = dynamicObject.getDynamicObject("viewparent");
                            if (YEM.isNotEmpty(viewparent)) {
                                tpvDepartment = viewparent;
                            }
                            break;
                        }
                    }
                }
            }
        }
        boolean flag = false;
        if (YEM.isNotEmpty(tpvDepartment)) {
            QFilter qFilter1 = new QFilter("billstatus",QCP.in,new String[]{"B","C"});
            qFilter1.and(new QFilter("tpv_organization.id",QCP.equals,tpvDepartment.getLong("id")));
            DynamicObject[] load = BusinessDataServiceHelper.load("tpv_crm_custmain", "id", qFilter1.toArray());
            if (load.length > 0) {
                flag = true;
            }
        }
        JSONObject jsonObject = CusCreditLimitUtils.cusadvanceupJsonObject(null, null, null, tpvDepartment, tpvCustomer);
        String jsonString = jsonObject.toJSONString();
        if (jsonObject.size() > 0) {
            Map<String, BigDecimal> map = new HashMap<>();
            for (Map.Entry<String, Object> entry : jsonObject.entrySet()) {
                for (Map.Entry<String, Object> objectEntry : jsonObject.getJSONObject(entry.getKey()).entrySet()) {
                    if ("signingamt".equals(objectEntry.getKey())) {
                        BigDecimal signingamt = (BigDecimal) objectEntry.getValue() == null ? BigDecimal.ZERO : (BigDecimal) objectEntry.getValue();
                        map.put(entry.getKey(), signingamt);
                    }
                }
            }
            BigDecimal sum = BigDecimal.ZERO;
            sum = sum.add(tpvAmount);
            BigDecimal singleOrgAmt = BigDecimal.ZERO;
            BigDecimal totalOrgAmt = BigDecimal.ZERO;
            BigDecimal singleDeptAmt = BigDecimal.ZERO;
            BigDecimal totalDeptAmt = BigDecimal.ZERO;
            for (Map.Entry<String, BigDecimal> stringBigDecimalEntry : map.entrySet()) {
                if ("single_org".equals(stringBigDecimalEntry.getKey())) {
                    singleOrgAmt = singleOrgAmt.add(stringBigDecimalEntry.getValue());
                }
                if ("single_dept".equals(stringBigDecimalEntry.getKey())) {
                    singleDeptAmt = singleDeptAmt.add(stringBigDecimalEntry.getValue());
                }
                if ("total_org".equals(stringBigDecimalEntry.getKey())) {
                    totalOrgAmt = totalOrgAmt.add(stringBigDecimalEntry.getValue());
                }
                if ("total_dept".equals(stringBigDecimalEntry.getKey())) {
                    totalDeptAmt = totalDeptAmt.add(stringBigDecimalEntry.getValue());
                }
            }
            if (flag) {
                if (sum.compareTo(singleDeptAmt) > 0 && sum.compareTo(totalDeptAmt) <= 0) {
                    this.addWarningMessage(extend, "合同金额原币超额，已大于根据【部门】、【客户】维度关联客户赊销额度使用情况表数据部门单独授信的剩余签约额度");
                }
                if (sum.compareTo(totalDeptAmt) > 0) {
                    this.addWarningMessage(extend, "合同金额原币超额，已大于根据【部门】、【客户】维度关联客户赊销额度使用情况表数据部门总额度的剩余签约额度");
                }
            }
            if (sum.compareTo(singleOrgAmt) > 0 && sum.compareTo(totalOrgAmt) <= 0) {
                this.addWarningMessage(extend, "合同金额原币超额，已大于根据【客户】维度关联客户赊销额度使用情况表数据全司单独授信的剩余签约额度");
            }
            if (sum.compareTo(totalOrgAmt) > 0) {
                this.addWarningMessage(extend, "合同金额原币超额，已大于根据【客户】维度关联客户赊销额度使用情况表数据全司总额度的剩余签约额度");
            }
        }
    }

    /**
     * 收款计划分录的比例之和是否为100 LinRui新加必填校验
     *
     * @param bill
     * @param bills
     */
    private void proportionSub(ExtendedDataEntity bill, ExtendedDataEntity[] bills) {
        DynamicObject dataEntity = bill.getDataEntity();
        DynamicObjectCollection tpvPaymentplans = dataEntity.getDynamicObjectCollection("tpv_paymentplans");
        List<String> bonddayMust = new ArrayList<>();
        List<String> bondtypeMust = new ArrayList<>();
        BigDecimal decimal = BigDecimal.ZERO;
        if (tpvPaymentplans.size() == 0) {
            this.addMessage(bill, "收款计划“比例(%)”不允许为空！");
        }
        for (DynamicObject tpvPaymentplan : tpvPaymentplans) {
            BigDecimal proportion = tpvPaymentplan.getBigDecimal("tpv_proportion");
            decimal = decimal.add(proportion);
            String tpvNatureofpayment = tpvPaymentplan.getString("tpv_natureofpayment"); //款项性质
            String tpvDaytype = tpvPaymentplan.getString("tpv_daytype"); //保证金应收日类型
            Date tpvCollectiondate = tpvPaymentplan.getDate("tpv_collectiondate");
            if ("A".equals(tpvNatureofpayment)) {
                if (YEM.isEmpty(tpvDaytype)) { //保证金
                    bondtypeMust.add(tpvPaymentplan.getString("seq"));
                }
            }
            if ("A".equals(tpvDaytype)) { //固定日期
                if (null == tpvCollectiondate) {
                    bonddayMust.add(tpvPaymentplan.getString("seq"));
                }
            }
        }
        if (decimal.compareTo(BigDecimalUtils.one_handred) != 0) {
            this.addMessage(bill, "收款计划“比例(%)”必须等于100");
        }
        if (bonddayMust.size() > 0) {
            this.addMessage(bill, "收款计划分录中，第 " + String.join(",",bonddayMust) + "行 的【保证金应收日】必填");
        }
        if (bondtypeMust.size() > 0) {
            this.addMessage(bill, "收款计划分录中，第 " + String.join(",",bondtypeMust) + " 的【保证金应收日类型】必填");
        }
    }

    /*
   {合并审批-分录}存在任意一行的【供应商】与本《销售合同》【客户】重名时，单据不允许提交，阻止语“采销两端存在同一客商，不允许同时提交审批，请检查。”；
    */
    private void cutomerNameSup(ExtendedDataEntity extendedDataEntity, ExtendedDataEntity[] operateKey) {
        String entityNumber = this.getEntityKey();
        NewVersionHelper vHelper = new NewVersionHelper(entityNumber);
        if (vHelper.isChanged()) {
            return;
        }
        DynamicObject dataEntity = extendedDataEntity.getDataEntity();
        DynamicObject customer = dataEntity.getDynamicObject("tpv_customer");
        if (customer == null) {
            return;
        }
        String cusname = customer.getString("name");
        DynamicObjectCollection approvaltogether = dataEntity.getDynamicObjectCollection("tpv_approvaltogether");
        for (DynamicObject approval : approvaltogether) {
            String supname = "";
            DynamicObject supplier = approval.getDynamicObject("tpv_supplier_apt");
            if (supplier != null) {
                supname = supplier.getString("name");
            }
            if (cusname.equals(supname)) {
                this.addMessage(extendedDataEntity, "采销两端存在同一客商，不允许同时提交审批，请检查！");
            }
        }
    }

    /*
    是否第三方销售为"是"时，校验《第三方客户备案》中是否存在当前【部门】对本【客户】的生效状态的单据，如无，则不允许提交，
     */
    private void subThirdparty(ExtendedDataEntity dataEntities, ExtendedDataEntity[] bills) {
        DynamicObject dataEntity = dataEntities.getDataEntity();
        Boolean thirdparty = dataEntity.getBoolean("tpv_thirdparty"); //是否第三方销售
        if (thirdparty) {
            DynamicObject customer = dataEntity.getDynamicObject("tpv_customer");//客户
            if (customer == null) {
                return;
            }
            Object id = customer.get("id");
            DynamicObject[] load = BusinessDataServiceHelper.load("tpv_cm_thirdclirecor", "", new QFilter[]{new QFilter("billstatus", QCP.equals, "C"), new QFilter("tpv_customer.id", QCP.equals, id)});
            if (0 == load.length) {
                this.addMessage(dataEntities, "当前客户在贵部门未进行第三方客户备案，请先申请备案。");
            }
        }
    }

    /*
     【是否供应链金融】=“是”时，校验《链捷贷客户合作审批单》中是否存在当前【客户】的生效状态的单据，如无，则不允许提交，
     */
    private void submitSupplychain(ExtendedDataEntity dataEntities, ExtendedDataEntity[] bills) {
        DynamicObject dataEntity = dataEntities.getDataEntity();
        Boolean supplychain = dataEntity.getBoolean("tpv_supplychain");//是否供应链金融
        if (supplychain) {
            DynamicObject customer = dataEntity.getDynamicObject("tpv_customer");//客户
            if (customer == null) {
                return;
            }
            Object id = customer.get("id");
            DynamicObject[] load = BusinessDataServiceHelper.load("tpv_dt_chaijieloancus", "billstatus", new QFilter[]{new QFilter("billstatus", QCP.equals, 'C'), new QFilter("tpv_customer.id", QCP.equals, id)});
            if (0 == load.length) {
                this.addMessage(dataEntities, "供应链金融业务下，客户必须先通过《链捷贷客户合作审批单》备案。");
            }
        }
    }
}
