package tpv.tpv_wm.tpv_dt.java.report;

import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.time.Duration;
import java.time.Instant;
import java.util.*;

import static kd.macc.aca.algox.costcalc.action.AbstractActSingleCheckAction.algoKey;

/**
 * 集港库存明细表
 * WangShuGuang
 */
public class CongreGationQueryRpt extends AbstractReportListDataPlugin {
    @Override
    public DataSet query(ReportQueryParam reportQueryParam, Object o) throws Throwable {
        // 初始化过滤条件
        //合同号
        String Contract = null;
        //货物流转单号
        String Goodsodd = null;
        //商品编号
        String Commodity = null;
        FilterInfo filterInfo = reportQueryParam.getFilter();
        Contract = filterInfo.getString("tpv_contract");
        Goodsodd = filterInfo.getString("tpv_goodsodd");
        Commodity = filterInfo.getString("tpv_commodity");
        // 过滤条件集合
        List<QFilter> QFilterList = new ArrayList<>();
        //流转动作=“集港”
        QFilterList.add(new QFilter("tpv_roamaction", QCP.equals, "D"));
        if (null != Contract && !Contract.equals("")) {
            QFilterList.add(new QFilter("tpv_purcontnum", QCP.ILIKE, "%" + Contract + "%"));
        }
        if (null != Goodsodd && !Goodsodd.equals("")) {
            QFilterList.add(new QFilter("billno", QCP.like, "%" + Goodsodd + "%"));
        }
        if (null != Commodity && !Commodity.equals("")) {
            QFilterList.add(new QFilter("tpv_materialentry.tpv_material.number", QCP.like, "%" + Commodity + "%"));
        }
        QFilter whereStrQF = PersonnelDepUtils.createWhereStrQF(filterInfo, "tpv_department", "tpv_muldepartment");
        if (whereStrQF!=null){
            QFilterList.add(whereStrQF);
        }
        DataSet work = this.queryWork(QFilterList);
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(work);
        RowMeta rowMeta = work.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);

            // 获取当前日期和时间
            Calendar calendar = Calendar.getInstance();
            Date currentDate = calendar.getTime();
            // 将时分秒设置为 00:00:00
            calendar.set(Calendar.HOUR_OF_DAY, 0);
            calendar.set(Calendar.MINUTE, 0);
            calendar.set(Calendar.SECOND, 0);
            calendar.set(Calendar.MILLISECOND, 0);
            Date resultDate = calendar.getTime();
            Date tpvTurnaroundtime = col.getDate("tpv_finishdate");
            if (null != resultDate && null != tpvTurnaroundtime) {
                Instant resultDateInstant = resultDate.toInstant();
                Instant timeInstant = tpvTurnaroundtime.toInstant();
                Duration duration = Duration.between(timeInstant, resultDateInstant);
                long days = duration.toDays();
                col.set("tpv_turnaroundtime", null);
                col.set("tpv_turnaroundtime", days);
            } else {
                col.set("tpv_turnaroundtime", null);
            }
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        return createDataSet;
    }

    private DataSet queryWork(List<QFilter> list) {
        // 定义查询字段名
        String selectFiles = "tpv_purcontnum tpv_contractodd,"//采购合同号
                + "billno tpv_goodswanderodd,"//货物流转单号
                + "tpv_materialentry.tpv_material.number tpv_commodityodd,"//商品编码
                + "tpv_materialentry.tpv_material.name tpv_materialname,"//商品名称
                + "tpv_materialentry.tpv_specation tpv_specation,"//规格
                + "tpv_materialentry.tpv_unit tpv_unit,"//计量单位
                + "tpv_materialentry.tpv_qty tpv_quantity,"//数量
                + "tpv_mindetime tpv_turnaroundtime,"//数量
                + "tpv_finishdate";//留港时长
        DataSet queryDataSet = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_freigroambill", selectFiles, list.toArray(new QFilter[0])).select(new String[]{"tpv_contractodd", "tpv_goodswanderodd", "tpv_commodityodd", "tpv_materialname", "tpv_specation",
                "tpv_unit", "tpv_quantity", "tpv_finishdate", "tpv_turnaroundtime"});
        return queryDataSet;
    }
}
