package tpv.tpv_wm.tpv_dt.java.report;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.form.control.Control;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.report.ReportList;
import kd.bos.report.plugin.AbstractReportFormPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;

/**
 * @author LiuHB
 * @version 1.0
 * 报表列表查询
 */
public class CushisdetailsFormPlugin extends AbstractReportFormPlugin implements RowClickEventListener {
    private static final String listKey = "reportlistap";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        ReportList list = (ReportList) this.getControl(listKey);
        list.addRowClickListener(this);
        list.addHyperClickListener((evt) -> {
            int rowIndex = this.getModel().getEntryCurrentRowIndex(listKey);
            DynamicObject rowData = list.getReportModel().getRowData(rowIndex);
            String pkid;
            switch (evt.getFieldName()) {
                case "tpv_reportlistap":
                    pkid = rowData.getString("tpv_salescontnum");
                    break;
                default:
                    return;
            }
        });
    }

    @Override
    public void afterQuery(ReportQueryParam queryParam) {
        super.afterQuery(queryParam);
        this.getView().setVisible(true, "tpv_reportlistap");
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        RowClickEventListener.super.entryRowClick(evt);
        Control ce = (Control) evt.getSource();
        String entryname = ce.getKey();
        if (listKey.equals(entryname)) {
            ReportList mainList = (ReportList) this.getControl(listKey);
            int rowIndex = this.getModel().getEntryCurrentRowIndex(listKey);
            DynamicObject rowData = mainList.getReportModel().getRowData(rowIndex);
            QFilter qFilter = new QFilter("billno", QCP.equals, rowData.getString("tpv_ordernum"));
            DynamicObject bill = BusinessDataServiceHelper.loadSingle("tpv_dt_salescontract", "billno,tpv_contractnos,tpv_materialentry.tpv_qty", qFilter.toArray());
            submitTask("tpv_reportlistap",bill);
        }
    }
    private void submitTask(String key, DynamicObject rowData) {
        ReportList list = (ReportList) this.getControl(key);
        if (list != null) {
            //CushisdetailsaPlugin plugin = new CushisdetailsaPlugin();
            //String string = rowData.getString("tpv_ordernum");
            //DataSet bikk = plugin.query(string);
            list.submitTask(this.getQueryParam(), rowData);
        }
    }
}