package tpv.tpv_wm.tpv_dt.java.report;

import kd.bos.algo.DataSet;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;

import java.util.Date;

/**
 * @author LiuHB
 * @version 1.0
 * 查询客户历史订单详情
 */
public class CushisdetailsPlugin extends AbstractReportListDataPlugin {
    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        FilterInfo filterInfo = param.getFilter();//获取所有的过滤条件
        Date datestatime = filterInfo.getDate("tpv_datestatime");//开始时间
        Date dateovertime = filterInfo.getDate("tpv_dateovertime");//结束时间
        DynamicObject custom = filterInfo.getDynamicObject("tpv_custom");//客户
        String quantitpage = filterInfo.getString("tpv_quantitpage");//每页数量
        String pagenum = filterInfo.getString("tpv_pagenum");//页码
        int pageNo = Integer.parseInt(quantitpage);
        int page = Integer.parseInt(pagenum);
        QFilter QFilter = new QFilter("tpv_signingdate" , QCP.large_equals, datestatime);
        QFilter.and( "tpv_usedate",QCP.less_equals, dateovertime);
        QFilter.and("tpv_customer.name",QCP.equals,custom.getString("name"));
        String selelctFiles =
                        "billno  tpv_ordernum," +
                        "billno tpv_orderdes," +
                        "tpv_amount tpv_amount," +
                        "billstatus tpv_statusd," +
                        "tpv_bizdate tpv_ordercreatdate," +
                        "tpv_supplier.name tpv_supplier," +
                        "tpv_supplier.id  tpv_suppliercode," +
                        "tpv_materialentry.tpv_qty tpv_total," +
                        "tpv_signingdate tpv_datastartime," +
                        "tpv_usedate tpv_dataovertime,"+
                        "billno  tpv_quanpages,"+
                        "billno  tpv_page";// 查询字段
        DataSet dataSet = QueryServiceHelper.queryDataSet(this.getClass().getName(), "tpv_dt_salescontract", selelctFiles,
                        null, null)
                .updateField("tpv_quanpages",quantitpage)//修改
                .updateField("tpv_page",pagenum)
                .groupBy(new String[]{"tpv_ordernum", "tpv_orderdes", "tpv_amount", "tpv_statusd", "tpv_ordercreatdate", "tpv_supplier",
                        "tpv_suppliercode", "tpv_datastartime", "tpv_dataovertime","tpv_quanpages","tpv_page"})//分组
                .sum("tpv_total").finish()//合计
                .limit(Integer.valueOf("" + page + ""), Integer.valueOf("" + pageNo + ""));
        return dataSet;
    }
}

