package tpv.tpv_wm.tpv_dt.java.report;

import kd.bos.algo.*;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;

import java.util.Date;

/**
 * @author LiuHB
 * @version 1.0
 * 查询客户历史订单详情
 */
public class CushisdetailsRptQuery extends AbstractReportListDataPlugin {
    /**
     * 查询单据数据返回到报表
     *
     * @param param
     * @param o
     * @return
     * @throws Throwable
     */
    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        FilterInfo filterInfo = param.getFilter();
        Date datestatime = filterInfo.getDate("tpv_datestatime");
        Date dateovertime = filterInfo.getDate("tpv_dateovertime");
        DynamicObject custom = filterInfo.getDynamicObject("tpv_custom");
        String quantitpage = filterInfo.getString("tpv_quantitpage");
        String pagenum = filterInfo.getString("tpv_pagenum");
        int pageNo = Integer.parseInt(quantitpage);
        int page = Integer.parseInt(pagenum);
        QFilter QFilter = new QFilter("tpv_signingdate", QCP.large_equals, datestatime);
        QFilter.and("tpv_usedate", QCP.less_equals, dateovertime);
        QFilter.and("tpv_customer.name", QCP.equals, custom.getString("name"));
        String selelctFiles = "billno  tpv_ordernum," + "billno tpv_orderdes," + "tpv_amount tpv_amount," + "billstatus tpv_statusd," + "tpv_bizdate tpv_ordercreatdate," + "tpv_supplier.name tpv_supplier," + "tpv_supplier.id  tpv_suppliercode," + "tpv_materialentry.tpv_qty tpv_total," + "tpv_signingdate tpv_datastartime," + "tpv_usedate tpv_dataovertime," + "billno  tpv_quanpages," + "billno  tpv_page";
        DataSet dataSet = QueryServiceHelper.queryDataSet(this.getClass().getName(), "tpv_dt_salescontract", selelctFiles, null, null).updateField("tpv_quanpages", quantitpage)
                .updateField("tpv_page", pagenum).groupBy(new String[]{"tpv_ordernum", "tpv_orderdes", "tpv_amount", "tpv_statusd", "tpv_ordercreatdate", "tpv_supplier", "tpv_suppliercode", "tpv_datastartime", "tpv_dataovertime", "tpv_quanpages", "tpv_page"})
                .sum("tpv_total").finish()
                .limit(Integer.valueOf("" + page + ""), Integer.valueOf("" + pageNo + ""));
        return dataSet;
    }
}

