package tpv.tpv_wm.tpv_dt.java.report;

import kd.bos.algo.DataSet;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author LiuHB
 * @version 1.0
 * 查询客户历史订单分页
 */
public class CusthisorderRptQuery extends AbstractReportListDataPlugin {
    /**
     * 查询单据数据返回到报表
     *
     * @param param
     * @param o
     * @return
     * @throws Throwable
     */
    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        FilterInfo filterInfo = param.getFilter();
        Date datestatime = filterInfo.getDate("tpv_datestatime");
        Date dateovertime = filterInfo.getDate("tpv_dateovertime");
        DynamicObject custom = filterInfo.getDynamicObject("tpv_custom");
        String quantitpage = filterInfo.getString("tpv_quantitpage");
        String pagenum = filterInfo.getString("tpv_pagenum");
        int pageNo = Integer.parseInt(quantitpage);
        int page = Integer.parseInt(pagenum);
        QFilter QFilter = new QFilter("tpv_signingdate", QCP.large_equals, datestatime);
        QFilter.and("tpv_usedate", QCP.less_equals, dateovertime);
        QFilter.and("tpv_customer.name", QCP.equals, custom.getString("name"));

        String selelctFiles = "tpv_approvaltogether.tpv_supplier_apt.number   tpv_suppcode," + "tpv_approvaltogether.tpv_supplier_apt.societycreditcode  tpv_socredcode," + "tpv_signingdate tpv_datastartime," + "tpv_usedate tpv_dataovertime," + "billno  tpv_quanpages," + "billno  tpv_page";
        ;
        DataSet dataSet = QueryServiceHelper.queryDataSet(this.getClass().getName(), "tpv_dt_salescontract", selelctFiles, null, null).updateField("tpv_quanpages", quantitpage).updateField("tpv_page", pagenum).limit(Integer.valueOf("" + page + ""), Integer.valueOf("" + pageNo + ""));
        return dataSet;
    }
}
