package tpv.tpv_wm.tpv_dt.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import tpv.tpv_wm.tpv_cm.java.utils.CostDisposeRptUtils;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.util.ArrayList;
import java.util.Collection;

/**
 * @ClassName: DeliveryDetaRptQuery
 * @Description: K发货拣配明细
 * @author: zbh
 * @date: 2024-05-14
 */
public class DeliveryDetaRptQuery extends AbstractReportListDataPlugin {

    private static final String algoKey = UnderaChievementRptQuery.class.getName();

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        String whereFilter = createWhereStr(param);
//        DataSet instockDataSet = query(whereFilter);
        DataSet mainDataSet = mainDataSet(whereFilter);
        return mainDataSet;
    }


//    public static DataSet query(String whereFilter) {
//
//        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
//        RowMeta rowMeta = mainDataSet.getRowMeta();
//        int fieldCount = rowMeta.getFieldCount();
//        Collection<Object[]> collection = new ArrayList<>();
//        for (int i = 0; i < col_s.size(); i++) {
//            DynamicObject col = col_s.get(i);
//            Object[] obj = new Object[fieldCount];
//            for (int j = 0; j < fieldCount; j++) {
//                obj[j] = col.get(j);
//            }
//            collection.add(obj);
//        }
//        CollectionInput inputs = new CollectionInput(rowMeta, collection);
//        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
//        return createDataSet;
//    }

    private static DataSet mainDataSet(String whereFilter) {
        String selelctFiles = "billno  tpv_billno,tpv_bizdate,tpv_customer,tpv_entrepot,tpv_department,tpv_inventorytype,tpv_nopicking," +
                "creator tpv_creator,tpv_tradeproperty,tpv_contractnumber,tpv_contractdate,tpv_currency,tpv_combina,tpv_business," +
                "tpv_materialentry.tpv_dt_salepick_in.tpv_prodname_in tpv_prodname_in,tpv_materialentry.tpv_dt_salepick_in.tpv_prodname_in tpv_origin_in,tpv_materialentry.tpv_dt_salepick_in.tpv_shader_in tpv_shader_in," +
                "tpv_materialentry.tpv_dt_salepick_in.tpv_specation_in tpv_specation_in,tpv_materialentry.tpv_dt_salepick_in.tpv_pickqty_in tpv_pickqty_in,tpv_materialentry.tpv_dt_salepick_in.tpv_packnum_in tpv_packnum_in," +
                "tpv_materialentry.tpv_dt_salepick_in.tpv_measure tpv_measure,tpv_materialentry.tpv_taxprice tpv_taxprice,tpv_materialentry.tpv_taxpramount tpv_taxpramount," +
                "tpv_materialentry.tpv_dt_salepick_in.tpv_billno_in tpv_pickbill,tpv_materialentry.tpv_dt_salepick_in.tpv_fentryid_in fentryid,tpv_materialentry.tpv_dt_salepick_in.tpv_fcoentryid_in fidIn";
        DataSet dataSet = ORM.create().queryDataSet(algoKey, "tpv_dt_salesshipping", selelctFiles,
                null, null);//根据单据编号查询 销售发货
        DataSet tpvDtPurchase = ORM.create().queryDataSet(algoKey, "tpv_dt_purchase", "tpv_materialentry.id id,tpv_contractnumber tpv_contractmark,tpv_dateofcontracting tpv_contractdatecg,tpv_supplier",
                new QFilter[]{new QFilter("billstatus","=","C")},null).where("id !=0");//采购合同

        DataSet fidIn = dataSet.leftJoin(tpvDtPurchase).on("fidIn", "id").select( "tpv_billno", "tpv_bizdate", "tpv_customer", "tpv_entrepot", "tpv_department", "tpv_inventorytype", "tpv_nopicking",
                "tpv_creator", "tpv_tradeproperty", "tpv_contractdate", "tpv_currency", "tpv_combina", "tpv_business",
                "tpv_contractmark", "tpv_contractdatecg", "tpv_supplier", "tpv_prodname_in", "tpv_origin_in", "tpv_shader_in",
                "tpv_specation_in", "tpv_pickqty_in","tpv_pickbill", "tpv_packnum_in","fentryid", "tpv_measure", "tpv_taxprice", "tpv_taxpramount","tpv_contractnumber").finish();
        DataSet salescontract =ORM.create().queryDataSet(algoKey, "tpv_dt_salescontract", "tpv_internalserv,tpv_contractnos tpv_contractnumber",
                null, null);//根据单据编号查询 销售合同
        DataSet finish = fidIn.leftJoin(salescontract).on("tpv_contractnumber", "tpv_contractnumber").select("tpv_billno", "tpv_bizdate", "tpv_customer", "tpv_entrepot", "tpv_department", "tpv_inventorytype", "tpv_nopicking",
                "tpv_creator", "tpv_tradeproperty", "tpv_contractnumber", "tpv_contractdate", "tpv_currency", "tpv_combina", "tpv_business",
                "tpv_contractmark", "tpv_contractdatecg", "tpv_supplier", "tpv_internalserv", "tpv_prodname_in", "tpv_origin_in", "tpv_shader_in",
                "tpv_specation_in", "tpv_pickbill","fentryid","tpv_pickqty_in", "tpv_packnum_in", "tpv_measure", "tpv_taxprice", "tpv_taxpramount").finish();
        DataSet otherinbill = ORM.create().queryDataSet(algoKey, "im_otherinbill", "billno tpv_rknum,biztime tpv_rkdate,billentry.amount tpv_rkprice,billentry.id id",
                null, null).groupBy(new String[]{"tpv_rknum","tpv_rkdate","tpv_rkprice","id"}).finish();;//根据单据编号查询 采购入库单;//根据单据编号查询 其他入库单
        DataSet tpvDtPurinbill = ORM.create().queryDataSet(algoKey, "im_purinbill", "billno tpv_rknum,biztime tpv_rkdate,billentry.actualtaxprice tpv_rkprice,billentry.id id",
                null, null).groupBy(new String[]{"tpv_rknum","tpv_rkdate","tpv_rkprice","id"}).finish();;//根据单据编号查询 采购入库单
        DataSet union = otherinbill.union(tpvDtPurinbill);
        DataSet finished = finish.leftJoin(union).on("fentryid", "id").select("tpv_billno", "tpv_bizdate", "tpv_customer", "tpv_entrepot", "tpv_department", "tpv_inventorytype", "tpv_nopicking",
                "tpv_creator", "tpv_tradeproperty", "tpv_contractnumber", "tpv_contractdate", "tpv_currency", "tpv_combina", "tpv_business",
                "tpv_contractmark", "tpv_contractdatecg", "tpv_supplier", "tpv_internalserv", "tpv_prodname_in", "tpv_origin_in", "tpv_shader_in",
                "tpv_specation_in", "tpv_pickqty_in", "tpv_packnum_in", "tpv_measure", "id tpv_rknumid","tpv_taxprice", "tpv_taxprice*tpv_pickqty_in tpv_taxpramount", "tpv_rknum","tpv_rkdate","tpv_rkprice").finish();

        DataSet dataSetD = finished;
        if (YEM.isNotEmpty(whereFilter)) {
            dataSetD = dataSetD.where(whereFilter);
        }
        return dataSetD;
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        String tpvSalenum = filterInfo.getString("tpv_salenum");//发货单号
        if (YEM.isNotEmpty(tpvSalenum)){
            whereFilter = String.format("%s and tpv_billno like '%%%s%%'", whereFilter, String.join(",", tpvSalenum));
        }
        DynamicObject tpvSalecustomer = filterInfo.getDynamicObject("tpv_salecustomer");//销售客户
        if (tpvSalecustomer!=null){
            whereFilter = String.format("%s and tpv_customer = %s", whereFilter, tpvSalecustomer.getPkValue());
        }
        DynamicObject tpvWarehouse = filterInfo.getDynamicObject("tpv_warehouse");//仓库
        if (tpvWarehouse!=null){
            whereFilter = String.format("%s and tpv_entrepot = %s", whereFilter, tpvWarehouse.getPkValue());
        }
        DynamicObject tpvAdminorg = filterInfo.getDynamicObject("tpv_adminorg");//部门
        if (tpvAdminorg!=null){
            whereFilter = String.format("%s and tpv_department = %s", whereFilter, tpvAdminorg.getPkValue());
        }
        String tpvInven = filterInfo.getString("tpv_inven");//存库/直运
        if (YEM.isNotEmpty(tpvInven)){
            whereFilter = String.format("%s and tpv_inventorytype ='%s'", whereFilter, String.join(",", tpvInven));
        }
        DynamicObject tpvCreatorfil = filterInfo.getDynamicObject("tpv_creatorfil");//发货制单人
        if (tpvCreatorfil!=null){
            whereFilter = String.format("%s and tpv_creator = %s", whereFilter, tpvCreatorfil.getPkValue());
        }
        DynamicObject tpvTradepropertyfil = filterInfo.getDynamicObject("tpv_tradepropertyfil");//贸易性质
        if (tpvTradepropertyfil!=null){
            whereFilter = String.format("%s and tpv_tradeproperty = %s", whereFilter, tpvTradepropertyfil.getPkValue());
        }
        String tpvSale = filterInfo.getString("tpv_sale");//销售合同
        if (YEM.isNotEmpty(tpvSale)){
            whereFilter = String.format("%s and tpv_contractnumber like '%%%s%%'", whereFilter, String.join(",", tpvSale));
        }
        DynamicObject tpvCurrencyfil = filterInfo.getDynamicObject("tpv_currencyfil");//币种
        if (tpvCurrencyfil!=null){
            whereFilter = String.format("%s and tpv_currency = %s", whereFilter, tpvCurrencyfil.getPkValue());
        }
        DynamicObject tpvInternalservfil = filterInfo.getDynamicObject("tpv_internalservfil");//跟单内勤
        if (tpvInternalservfil!=null){
            whereFilter = String.format("%s and tpv_internalserv = %s", whereFilter, tpvInternalservfil.getPkValue());
        }
        DynamicObject tpvCombinafil = filterInfo.getDynamicObject("tpv_combinafil");//计奖卡
        if (tpvCombinafil!=null){
            whereFilter = String.format("%s and tpv_combina = %s", whereFilter, tpvCombinafil.getPkValue());
        }
        DynamicObject tpvBusinessfil = filterInfo.getDynamicObject("tpv_businessfil");//业务类型
        if (tpvBusinessfil!=null){
            whereFilter = String.format("%s and tpv_business = %s", whereFilter, tpvBusinessfil.getPkValue());
        }
        String tpvContractmarkfil = filterInfo.getString("tpv_contractmarkfil");//采购合同号
        if (YEM.isNotEmpty(tpvContractmarkfil)){
            whereFilter = String.format("%s and tpv_contractmark like '%%%s%%'", whereFilter, String.join(",", tpvContractmarkfil));
        }
        DynamicObject tpvSupplierfil = filterInfo.getDynamicObject("tpv_supplierfil");//供应商
        if (tpvSupplierfil!=null){
            whereFilter = String.format("%s and tpv_supplier = %s", whereFilter, tpvSupplierfil.getPkValue());
        }
        String tpvRknumfil = filterInfo.getString("tpv_rknumfil");//入库单号
        if (YEM.isNotEmpty(tpvRknumfil)){
            whereFilter = String.format("%s and tpv_rknum like '%%%s%%'", whereFilter, String.join(",", tpvRknumfil));
        }
        DynamicObject tpvProdname = filterInfo.getDynamicObject("tpv_prodname");//品名
        if (tpvProdname!=null){
            whereFilter = String.format("%s and tpv_prodname_in = %s", whereFilter, tpvProdname.getPkValue());
        }
        String whereStr = PersonnelDepUtils.createWhereStr(filterInfo,"tpv_department", "tpv_muldepartment");
        if (!"".equals(whereStr)){
            whereFilter=String.format("%s%s", whereFilter, whereStr);
        }
        return whereFilter;
    }
}
