package tpv.tpv_wm.tpv_dt.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;

/**
 * @ClassName: InvscheRptQuery
 * @Description: 成本外费用明细表
 * @author: zbh
 * @date: 2024-05-27
 */
public class DetailedcosRptQuery extends AbstractReportListDataPlugin {

    private static final String algoKey = DetailedcosRptQuery.class.getName();

    public static DataSet query(String whereFilter, ReportQueryParam param) {
        DataSet mainDataSet = mainDataSet().where(whereFilter);

        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        return createDataSet;
    }

    public static DataSet mainDataSet() {
        String selelctFiles = "billno tpv_billno,tpv_department tpv_departme,tpv_costitem,tpv_billunit,tpv_pactmessage.tpv_purconum tpv_purconum,tpv_pactmessage.tpv_vendor tpv_vendor," +
                "tpv_pactmessage.tpv_saleconum tpv_saleconum,tpv_pactmessage.tpv_client tpv_client,tpv_pactmessage.tpv_amtatch tpv_amtatch,tpv_pactmessage.tpv_vatamtmatch tpv_vatamtmatch,tpv_pactmessage.tpv_ratedd tpv_ratedd";
        DataSet tpvDtCostbillmat = ORM.create().queryDataSet(algoKey, "tpv_dt_costbillmat", selelctFiles, null);
        DataSet tpvDtSalescontract = ORM.create().queryDataSet(algoKey, "tpv_dt_salescontract", "id,tpv_combinationnumber,tpv_contractnos", null);
        tpvDtCostbillmat = tpvDtCostbillmat.leftJoin(tpvDtSalescontract).on("tpv_saleconum", "id").select(new String[]{"tpv_billno", "tpv_departme", "tpv_costitem", "tpv_billunit", "tpv_purconum", "tpv_vendor",
                "tpv_saleconum", "tpv_client", "tpv_amtatch", "tpv_vatamtmatch", "tpv_ratedd", "tpv_combinationnumber","tpv_contractnos"}).finish();
        DataSet tpvBdCombination = ORM.create().queryDataSet(algoKey, "tpv_bd_combination", "id,tpv_splitdepartment.tpv_departmententry tpv_condepartment,tpv_splitdepartment.tpv_apercentage tpv_conpro,name tpv_comstring", null);
        tpvDtCostbillmat = tpvDtCostbillmat.leftJoin(tpvBdCombination).on("tpv_combinationnumber", "id").select(new String[]{"tpv_billno", "tpv_departme", "tpv_costitem", "tpv_billunit", "tpv_purconum", "tpv_vendor",
                "tpv_saleconum", "tpv_client", "tpv_amtatch", "tpv_vatamtmatch", "tpv_ratedd", "tpv_combinationnumber", "tpv_condepartment", "tpv_conpro", "(tpv_vatamtmatch*tpv_conpro)*(-1) tpv_conamount", "tpv_comstring","tpv_contractnos"}).finish().where("tpv_contractnos <> null");
        return tpvDtCostbillmat;
    }

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        String whereFilter = createWhereStr(param);
        DataSet instockDataSet = query(whereFilter, param);
        return instockDataSet;
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        boolean tpvOndep = filterInfo.getBoolean("tpv_ondep");//仅看需跨部门分成
        String tpvName = filterInfo.getString("tpv_name");//计奖卡
        String tpvContractnums = filterInfo.getString("tpv_contractnums");//销售合同
        DynamicObject tpvCustomerrep = filterInfo.getDynamicObject("tpv_customerrep");//销售合同
        DynamicObject tpvOrg = filterInfo.getDynamicObject("tpv_org");//业务组织
        DynamicObject tpvDepartmentl = filterInfo.getDynamicObject("tpv_departmentl");
        if (tpvOndep) {
            whereFilter = String.format("%s and tpv_departme <> %s", whereFilter,
                    String.join(",", "tpv_condepartment"));
        }
        if (YEM.isNotEmpty(tpvName)) {
            whereFilter = String.format("%s and tpv_comstring like '%%%s%%'", whereFilter, tpvName);
        }
        if (YEM.isNotEmpty(tpvContractnums)){
            whereFilter = String.format("%s and tpv_contractnos like '%%%s%%'", whereFilter,tpvContractnums);
        }
        if (tpvCustomerrep!=null){
            whereFilter = String.format("%s and tpv_contractnos = %s", whereFilter,tpvCustomerrep.getPkValue());
        }
        if (tpvOrg!=null){
            whereFilter = String.format("%s and tpv_departme = %s", whereFilter,tpvOrg.getPkValue());
        }
        if (tpvDepartmentl!=null){
            whereFilter = String.format("%s and tpv_condepartment = %s", whereFilter,tpvDepartmentl.getPkValue());
        }
        return whereFilter;
    }
}
