package tpv.tpv_wm.tpv_dt.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.permission.PermissionServiceHelper;
import kd.bos.util.StringUtils;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Description 费用结算工作台  -查询插件
 * @Author LinRui
 * Date 2023/8/24 16:26
 **/
public class FeeSettleWorkRptQuery extends AbstractReportListDataPlugin {
    private static final String algoKey = FeeSettleWorkRptQuery.class.getName();

    //查询字段
    private static List<String> fieldKeys_hwlz = new ArrayList<>();// 货物流转
    private static List<String> fieldKeys_purin = new ArrayList<>();// 采购入库
    private static List<String> fieldKeys_otherin = new ArrayList<>();// 其他入库
    private static List<String> fieldKeys_transin = new ArrayList<>();// 分步调入
    private static List<String> fieldKeys_transdir = new ArrayList<>();// 直接调拨
    private static List<String> fieldKeys_saleship = new ArrayList<>();// 销售发货

    @Override
    public DataSet query(ReportQueryParam param, Object obj) throws Throwable {
        String whereFilter = createWhereStr(param);
        DataSet instockDataSet = query(whereFilter);
        return instockDataSet;
    }

    public static DataSet query(String whereFilter) {
        return query(whereFilter, null);
    }

    public static DataSet query(String whereFilter, Long saleId) {
        DataSet mainDataSet = mainDataSet(whereFilter);
        //DataSet rows = ORM.create().queryDataSet(algoKey, "","",new QFilter[]{},null );
        return mainDataSet;
    }

    private static DataSet mainDataSet(String whereFilter) {
        initAllFields();

        //查询对应的单据主实体,过滤条件-标识跟单据主实体编号
        DynamicObject[] billName = BusinessDataServiceHelper.load("bos_billmainentity", "id"
                , new QFilter[]{new QFilter("number", QCP.in, new String[]{"tpv_dt_freigroambill", "im_purinbill", "im_otherinbill",
                        "im_transinbill", "im_transdirbill", "tpv_dt_salesshipping"})});
        Map<String, String> namemap = new HashMap<>();
        for (DynamicObject dynameobj : billName) {
            String number = dynameobj.getString("number");
            if ("tpv_dt_freigroambill".equals(number)) {
                namemap.put("tpv_dt_freigroambill", number);
            }
            if ("im_purinbill".equals(number)) {
                namemap.put("im_purinbill", number);
            }
            if ("im_otherinbill".equals(number)) {
                namemap.put("im_otherinbill", number);
            }
            if ("im_transinbill".equals(number)) {
                namemap.put("im_transinbill", number);
            }
            if ("im_transdirbill".equals(number)) {
                namemap.put("im_transdirbill", number);
            }
            if ("tpv_dt_salesshipping".equals(number)) {
                namemap.put("tpv_dt_salesshipping", number);
            }
        }
//        List<Long> userChangeAbleOrgIds = YEM.getUserChangeAbleOrgIds();

        QFilter qFilterHWLZ = new QFilter("billstatus", QCP.equals, "C");
        qFilterHWLZ.and(new QFilter("tpv_materialentry.tpv_dt_freigroambill_f.id",QCP.large_than,0));
        qFilterHWLZ.and(new QFilter("tpv_materialentry.tpv_dt_freigroambill_f.tpv_expenseitems.id",QCP.large_than,0));
//        DynamicObject[] bosUsers = BusinessDataServiceHelper.load("bos_user", "id,name,number", new QFilter[]{new QFilter("enable", QCP.equals,"1")});
//        for (DynamicObject bosUser : bosUsers) {
//            QFilter qFilterhw = PermissionServiceHelper.getDataPermission(bosUser.getLong("id"), "tpv_dt", "tpv_dt_freigroambill", userChangeAbleOrgIds);
//            if (null != qFilterhw) {
//                qFilterHWLZ.and(qFilterhw);
//            }
//        }
        QFilter qFilterhw = PermissionServiceHelper.getDataPermission(YEM.getCurrentUserId(), "tpv_dt", "tpv_dt_freigroambill");
        if (null != qFilterhw) {
            qFilterHWLZ.and(qFilterhw);
        }
        DataSet freigroambill = ORM.create().queryDataSet(algoKey, "tpv_dt_freigroambill",
                String.join(",", fieldKeys_hwlz), qFilterHWLZ.toArray()).select(new String[]{"tpv_fid", "tpv_entryid", "tpv_subentryid", "tpv_bizdate", "tpv_org", "tpv_department", "tpv_supplier",
                "tpv_vehiclename", "tpv_sourcebillno", "'" + namemap.get("tpv_dt_freigroambill") + "' tpv_sourcebillkey", "tpv_contractnos", "tpv_logisticspro", "tpv_tradeproperty", "tpv_combinationnumber", "tpv_expenseitem", "tpv_feecurrency", "tpv_billableqty", "tpv_price", "tpv_taxrate", "tpv_amount"});

        QFilter qFilterPurin = new QFilter("billstatus", QCP.equals, "C");
        qFilterPurin.and(new QFilter("billentry.tpv_dt_purinbill_f.id",QCP.large_than,0));
        qFilterPurin.and(new QFilter("billentry.tpv_dt_purinbill_f.tpv_costitem.id",QCP.large_than,0));
        QFilter qFilterpurin = PermissionServiceHelper.getDataPermission(YEM.getCurrentUserId(), "tpv_dt", "im_purinbill");
        if (null != qFilterpurin) {
            qFilterPurin.and(qFilterpurin);
        }
        DataSet im_purinbill = ORM.create().queryDataSet(algoKey, "im_purinbill",
                String.join(",", fieldKeys_purin), qFilterPurin.toArray()).select(new String[]{"tpv_fid", "tpv_entryid", "tpv_subentryid", "tpv_bizdate", "tpv_org", "tpv_department", "tpv_supplier",
                "tpv_vehiclename", "tpv_sourcebillno", "'" + namemap.get("im_purinbill") + "' tpv_sourcebillkey", "tpv_contractnos", "tpv_logisticspro", "tpv_tradeproperty", "tpv_combinationnumber", "tpv_expenseitem", "tpv_feecurrency", "tpv_billableqty", "tpv_price", "tpv_taxrate", "tpv_amount"});

        QFilter qFilterOtherin = new QFilter("billstatus", QCP.equals, "C");
        qFilterOtherin.and(new QFilter("billentry.tpv_im_otherinbill_f.id",QCP.large_than,0));
        qFilterOtherin.and(new QFilter("billentry.tpv_im_otherinbill_f.tpv_costitem.id",QCP.large_than,0));
        QFilter qFilterotherin = PermissionServiceHelper.getDataPermission(YEM.getCurrentUserId(), "tpv_dt", "im_otherinbill");
        if (null != qFilterotherin) {
            qFilterOtherin.and(qFilterotherin);
        }
        DataSet im_otherinbill = ORM.create().queryDataSet(algoKey, "im_otherinbill",
                String.join(",", fieldKeys_otherin), qFilterOtherin.toArray()).select(new String[]{"tpv_fid", "tpv_entryid", "tpv_subentryid", "tpv_bizdate", "tpv_org", "tpv_department", "tpv_supplier",
                "tpv_vehiclename", "tpv_sourcebillno", "'" + namemap.get("im_otherinbill") + "' tpv_sourcebillkey", "tpv_contractnos", "tpv_logisticspro", "tpv_tradeproperty", "tpv_combinationnumber", "tpv_expenseitem", "tpv_feecurrency", "tpv_billableqty", "tpv_price", "tpv_taxrate", "tpv_amount"});

        QFilter qFilterTransin = new QFilter("billstatus", QCP.equals, "C");
        qFilterTransin.and(new QFilter("billentry.tpv_dt_transinbill_f.id",QCP.large_than,0));
        qFilterTransin.and(new QFilter("billentry.tpv_dt_transinbill_f.tpv_costitem.id",QCP.large_than,0));
        QFilter qFiltertransin = PermissionServiceHelper.getDataPermission(YEM.getCurrentUserId(), "tpv_dt", "im_transinbill");
        if (null != qFiltertransin) {
            qFilterTransin.and(qFiltertransin);
        }
        DataSet im_transinbill = ORM.create().queryDataSet(algoKey, "im_transinbill",
                String.join(",", fieldKeys_transin), qFilterTransin.toArray()).select(new String[]{"tpv_fid", "tpv_entryid", "tpv_subentryid", "tpv_bizdate", "tpv_org", "tpv_department", "tpv_supplier",
                "tpv_vehiclename", "tpv_sourcebillno", "'" + namemap.get("im_transinbill") + "' tpv_sourcebillkey", "tpv_contractnos", "tpv_logisticspro", "tpv_tradeproperty", "tpv_combinationnumber", "tpv_expenseitem", "tpv_feecurrency", "tpv_billableqty", "tpv_price", "tpv_taxrate", "tpv_amount"});

        QFilter qFilterTransdir = new QFilter("billstatus", QCP.equals, "C");
        qFilterTransdir.and(new QFilter("billentry.tpv_dt_transdirbill_f.id",QCP.large_than,0));
        qFilterTransdir.and(new QFilter("billentry.tpv_dt_transdirbill_f.tpv_costitem.id",QCP.large_than,0));
        QFilter qFiltertransdir = PermissionServiceHelper.getDataPermission(YEM.getCurrentUserId(), "tpv_dt", "im_transdirbill");
        if (null != qFiltertransdir) {
            qFilterTransdir.and(qFiltertransdir);
        }
        DataSet im_transdirbill = ORM.create().queryDataSet(algoKey, "im_transdirbill",
                String.join(",", fieldKeys_transdir), qFilterTransdir.toArray()).select(new String[]{"tpv_fid", "tpv_entryid", "tpv_subentryid", "tpv_bizdate", "tpv_org", "tpv_department", "tpv_supplier",
                "tpv_vehiclename", "tpv_sourcebillno", "'" + namemap.get("im_transdirbill") + "' tpv_sourcebillkey", "tpv_contractnos", "tpv_logisticspro", "tpv_tradeproperty", "tpv_combinationnumber", "tpv_expenseitem", "tpv_feecurrency", "tpv_billableqty", "tpv_price", "tpv_taxrate", "tpv_amount"});

        QFilter qFilterSaleship = new QFilter("billstatus", QCP.equals, "C");
        qFilterSaleship.and(new QFilter("tpv_materialentry.tpv_dt_dcostinform_f.id",QCP.large_than,0));
        qFilterSaleship.and(new QFilter("tpv_materialentry.tpv_dt_dcostinform_f.tpv_expenseitems.id",QCP.large_than,0));
        qFilterSaleship.and(new QFilter("tpv_materialentry.tpv_dt_dcostinform_f.tpv_isbringinwarehouse",QCP.equals,false));
        QFilter qFiltersaleship = PermissionServiceHelper.getDataPermission(YEM.getCurrentUserId(), "tpv_dt", "tpv_dt_salesshipping");
        if (null != qFiltersaleship) {
            qFilterSaleship.and(qFiltersaleship);
        }
        DataSet salesshipping = ORM.create().queryDataSet(algoKey, "tpv_dt_salesshipping",
                String.join(",", fieldKeys_saleship), qFilterSaleship.toArray()).select(new String[]{"tpv_fid", "tpv_entryid", "tpv_subentryid", "tpv_bizdate", "tpv_org", "tpv_department", "tpv_supplier",
                "tpv_vehiclename", "tpv_sourcebillno", "'" + namemap.get("tpv_dt_salesshipping") + "' tpv_sourcebillkey", "tpv_contractnos", "tpv_logisticspro", "tpv_tradeproperty", "tpv_combinationnumber", "tpv_expenseitem", "tpv_feecurrency", "tpv_billableqty", "tpv_price", "tpv_taxrate", "tpv_amount"});

        DataSet dataSet = freigroambill.union(im_purinbill).union(im_otherinbill).union(im_transinbill)
                .union(im_transdirbill).union(salesshipping);

        //查询结算单数据
        DataSet statemenbill = ORM.create().queryDataSet(algoKey, "tpv_dt_statemenbill",
                "id,billno tpv_settlebillno,tpv_bizdate tpv_settledate,tpv_sourcebillkey,tpv_sourcebillno,tpv_dt_statemenbill_di.tpv_settlenumber tpv_settleqty,tpv_dt_statemenbill_di.tpv_settleprice tpv_settleprice" +
                        ",tpv_dt_statemenbill_di.tpv_settleamount tpv_settleamount,tpv_dt_statemenbill_di.tpv_taxrate tpv_settletaxrate,tpv_dt_statemenbill_di.tpv_compdisc tpv_compdisc,tpv_dt_statemenbill_di.tpv_remark tpv_remark" +
                        ",tpv_dt_statemenbill_di.tpv_srcbillid tpv_sourcebillid,tpv_dt_statemenbill_di.tpv_srcentryid tpv_srcbillentityid,tpv_dt_statemenbill_di.tpv_srcsubentryid tpv_srcbillsubentityid"
                , null);
        dataSet = dataSet.leftJoin(statemenbill).on("tpv_subentryid", "tpv_srcbillsubentityid").select(new String[]{"tpv_fid", "tpv_entryid", "tpv_subentryid", "tpv_bizdate", "tpv_org", "tpv_department", "tpv_supplier",
                "tpv_sourcebillno", "tpv_sourcebillkey", "tpv_contractnos", "tpv_logisticspro", "tpv_tradeproperty", "tpv_combinationnumber", "tpv_expenseitem", "tpv_feecurrency", "tpv_billableqty", "tpv_price", "tpv_taxrate", "tpv_amount",
                "tpv_vehiclename", "tpv_settlebillno", "tpv_settledate", "tpv_settleqty", "tpv_settleprice", "tpv_settleamount", "tpv_settletaxrate", "tpv_compdisc", "tpv_remark", "tpv_sourcebillid", "tpv_srcbillsubentityid"}).finish();

        if (YEM.isNotEmpty(whereFilter)) {
            dataSet = dataSet.where(whereFilter);
        }

        return dataSet.orderBy(new String[]{"tpv_bizdate desc"});
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        //组合号
        DynamicObject tpv_combinationf = filterInfo.getDynamicObject("tpv_combinationf");
        if (YEM.isNotEmpty(tpv_combinationf)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_combinationnumber = %s", whereFilter, tpv_combinationf.getPkValue());
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_combinationnumber = %s", whereFilter, tpv_combinationf.getPkValue());
            }

        }
        //采购合同号
        String tpv_contractnosf = filterInfo.getString("tpv_contractnosf");
        if (YEM.isNotEmpty(tpv_contractnosf)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and LOWER(tpv_contractnos) LIKE LOWER('%%%s%%')", whereFilter, tpv_contractnosf);
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s LOWER(tpv_contractnos) LIKE LOWER('%%%s%%')", whereFilter, tpv_contractnosf);
            }
        }
        //采购供应商
        DynamicObject tpv_supplierf = filterInfo.getDynamicObject("tpv_supplierf");
        if (YEM.isNotEmpty(tpv_supplierf)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_supplier = %s", whereFilter, tpv_supplierf.getPkValue());
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_supplier = %s", whereFilter, tpv_supplierf.getPkValue());
            }
        }
        //销售合同号
        String tpv_salecontractnosf = filterInfo.getString("tpv_salecontractnosf");
        if (YEM.isNotEmpty(tpv_salecontractnosf)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and LOWER(tpv_salecontractnos) LIKE LOWER('%%%s%%')", whereFilter, tpv_salecontractnosf);
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s LOWER(tpv_salecontractnos) LIKE LOWER('%%%s%%')", whereFilter, tpv_salecontractnosf);
            }
        }
        //业务日期从
        Date tpv_startdatef = filterInfo.getDate("tpv_startdatef");
        if (null != tpv_startdatef) {
            Date dayStartTime = getDayStartTime(tpv_startdatef);
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(dayStartTime);
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_bizdate >= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_bizdate >= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
            }
        } else if (null == tpv_startdatef) {
            whereFilter = String.format("%s %s", whereFilter, "");
        }
        //业务日期到
        Date tpv_enddatef = filterInfo.getDate("tpv_enddatef");
        if (null != tpv_enddatef) {
            Date dayEndTime = getDayEndTime(tpv_enddatef);
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(dayEndTime);
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_bizdate <= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_bizdate <= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
            }
        } else if (null == tpv_enddatef) {
            whereFilter = String.format("%s %s", whereFilter, "");
        }
        // 物流服务商
        DynamicObject tpv_logisticsprof = filterInfo.getDynamicObject("tpv_logisticsprof");
        if (YEM.isNotEmpty(tpv_logisticsprof)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_logisticspro = %s", whereFilter, tpv_logisticsprof.getPkValue());
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_logisticspro = %s", whereFilter, tpv_logisticsprof.getPkValue());
            }
        }
        //车船名
        String tpv_vehiclenamef = filterInfo.getString("tpv_vehiclenamef");
        if (YEM.isNotEmpty(tpv_vehiclenamef)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_vehiclenamef like '%%%s%%' %s", whereFilter, tpv_vehiclenamef);
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_vehiclenamef like '%%%s%%' %s", whereFilter, tpv_vehiclenamef);
            }
        }
        // 费用项目
        DynamicObject tpv_expenseitemf = filterInfo.getDynamicObject("tpv_expenseitemf");
        if (YEM.isNotEmpty(tpv_expenseitemf)) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_expenseitem = %s", whereFilter, tpv_expenseitemf.getPkValue());
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_expenseitem = %s", whereFilter, tpv_expenseitemf.getPkValue());
            }
        }
        // 来源单据
        DynamicObject tpv_sourcebillf = filterInfo.getDynamicObject("tpv_sourcebillf");
        if (null != tpv_sourcebillf) {
            if (!StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s and tpv_sourcebillkey = %s", whereFilter, "'" + tpv_sourcebillf.getString("number") + "'");
            } else if (StringUtils.isEmpty(whereFilter)) {
                whereFilter = String.format("%s tpv_sourcebillkey = %s", whereFilter, "'" + tpv_sourcebillf.getString("number") + "'");
            }
        } else if (null == tpv_sourcebillf) {
            whereFilter = String.format("%s %s", whereFilter, "");
        }
        return whereFilter;
    }

    private static void initAllFields() {
        fieldKeys_hwlz.clear();
        fieldKeys_purin.clear();
        fieldKeys_otherin.clear();
        fieldKeys_transin.clear();
        fieldKeys_transdir.clear();
        fieldKeys_saleship.clear();
        //fieldKey 为映射报表/动态表单分录字段标识  field_bill 为单据的标识
        addFields("tpv_fid", "id");// id
        addFields("tpv_entryid", "tpv_materialentry", "billentry"); //entryid
        addFields("tpv_subentryid", "tpv_materialentry.tpv_dt_freigroambill_f", "billentry.tpv_dt_purinbill_f",
                "billentry.tpv_im_otherinbill_f", "billentry.tpv_dt_transinbill_f", "billentry.tpv_dt_transdirbill_f",
                "tpv_materialentry.tpv_dt_dcostinform_f"); //subentryid
        addFields("tpv_bizdate", "tpv_bizdate", "biztime");// 业务日期
        addFields("tpv_org", "org");// 公司
        addFields("tpv_department", "tpv_department", "bizdept", "bizdept", "dept", "dept", "tpv_department");// 部门
        addFields("tpv_supplier", "tpv_supplier", "supplier", "supplier", "null", "null", "null");// 采购供应商
		/*addFields("tpv_sourcebillkey", "tpv_dt_freigroambill","tpv_dt_purinbill","tpv_im_otherinbill",
				"tpv_dt_transinbill","tpv_dt_transdirbill");//单据标识*/
        addFields("tpv_sourcebillno", "billno");//单据编号
        addFields("tpv_contractnos", "tpv_purcontnum", "billentry.tpv_contractnumber.tpv_name", "billentry.tpv_contractnumber.tpv_name",
                "billentry.tpv_contractnumber.tpv_name", "billentry.tpv_contractnumber.tpv_name", "''");//采购合同号
        addFields("tpv_logisticspro", "tpv_materialentry.tpv_dt_freigroambill_f.tpv_providers", "billentry.tpv_dt_purinbill_f.tpv_supplier", "billentry.tpv_im_otherinbill_f.tpv_supplier",
                "billentry.tpv_dt_transinbill_f.tpv_supplier", "billentry.tpv_dt_transdirbill_f.tpv_supplier", "tpv_materialentry.tpv_dt_dcostinform_f.tpv_providers");//物流服务商
        addFields("tpv_tradeproperty", "tpv_tradeproperty", "tpv_tradeproperty",
                "billentry.tpv_contractnumber.tpv_tradenature", "billentry.tpv_contractnumber.tpv_tradenature", "billentry.tpv_contractnumber.tpv_tradenature",
                "tpv_tradeproperty");// 贸易性质
        addFields("tpv_combinationnumber", "tpv_combinationnumber", "tpv_combinationnumber", "billentry.tpv_contractnumber.tpv_groupnum",
                "billentry.tpv_contractnumber.tpv_groupnum", "billentry.tpv_contractnumber.tpv_groupnum", "tpv_combina");// 组合号
        addFields("tpv_expenseitem", "tpv_materialentry.tpv_dt_freigroambill_f.tpv_expenseitems", "billentry.tpv_dt_purinbill_f.tpv_costitem",
                "billentry.tpv_im_otherinbill_f.tpv_costitem", "billentry.tpv_dt_transinbill_f.tpv_costitem", "billentry.tpv_dt_transdirbill_f.tpv_costitem",
                "tpv_materialentry.tpv_dt_dcostinform_f.tpv_expenseitems");//费用项目
        addFields("tpv_vehiclename", "tpv_carshipname", "null", "null", "null", "null", "null");//车船名
//		addFields("tpv_feecurrency", "tpv_materialentry.tpv_dt_freigroambill_f.tpv_costcurrencys", "billentry.tpv_dt_purinbill_f.tpv_reimbursement",
//						"billentry.tpv_im_otherinbill_f.tpv_reimbursement", "billentry.tpv_dt_transinbill_f.tpv_reimbursement", "billentry.tpv_dt_transdirbill_f.tpv_reimbursement");//币别
        addFields("tpv_feecurrency", "tpv_materialentry.tpv_dt_freigroambill_f.tpv_costcurrency", "billentry.tpv_dt_purinbill_f.tpv_reimbursement",
                "billentry.tpv_im_otherinbill_f.tpv_reimbursement", "billentry.tpv_dt_transinbill_f.tpv_reimbursement", "billentry.tpv_dt_transdirbill_f.tpv_reimbursement",
                "tpv_materialentry.tpv_dt_dcostinform_f.tpv_costcurrencyes");
        addFields("tpv_billableqty", "tpv_materialentry.tpv_dt_freigroambill_f.tpv_billablequantitys", "billentry.tpv_dt_purinbill_f.tpv_chargequantity",
                "billentry.tpv_im_otherinbill_f.tpv_chargequantity", "billentry.tpv_dt_transinbill_f.tpv_chargequantity", "billentry.tpv_dt_transdirbill_f.tpv_chargequantity",
                "tpv_materialentry.tpv_dt_dcostinform_f.tpv_billablequantitys");//计费数量
        addFields("tpv_price", "tpv_materialentry.tpv_dt_freigroambill_f.tpv_unitprices", "billentry.tpv_dt_purinbill_f.tpv_univalence",
                "billentry.tpv_im_otherinbill_f.tpv_univalence", "billentry.tpv_dt_transinbill_f.tpv_univalence", "billentry.tpv_dt_transdirbill_f.tpv_univalence",
                "tpv_materialentry.tpv_dt_dcostinform_f.tpv_unitprices");//单价
        addFields("tpv_taxrate", "tpv_materialentry.tpv_dt_freigroambill_f.tpv_taxrates", "billentry.tpv_dt_purinbill_f.tpv_taxrate",
                "billentry.tpv_im_otherinbill_f.tpv_taxrate", "billentry.tpv_dt_transinbill_f.tpv_taxrate", "billentry.tpv_dt_transdirbill_f.tpv_taxrate",
                "tpv_materialentry.tpv_dt_dcostinform_f.tpv_taxrate");//税率
        addFields("tpv_amount", "tpv_materialentry.tpv_dt_freigroambill_f.tpv_moneys", "billentry.tpv_dt_purinbill_f.tpv_amt",
                "billentry.tpv_im_otherinbill_f.tpv_amt", "billentry.tpv_dt_transinbill_f.tpv_amt", "billentry.tpv_dt_transdirbill_f.tpv_amt",
                "tpv_materialentry.tpv_dt_dcostinform_f.tpv_moneys");//金额
        addFields("tpv_salecontractnos", "''", "''", "''", "''", "''",
                "tpv_materialentry.tpv_srccontractnos");//销售合同号
    }

    static {

    }

    //相同字段标识
    private static void addFields(String fieldKey, String fieldKey_bill) {
        fieldKeys_hwlz.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_purin.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_otherin.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_transin.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_transdir.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_saleship.add(fieldKey_bill + " " + fieldKey);
    }

    // fieldKey_bill 开发商tpv 和  fieldKey_in 系统 字段标识
    private static void addFields(String fieldKey, String fieldKey_bill, String fieldKey_in) {
        fieldKeys_hwlz.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_saleship.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_purin.add(fieldKey_in + " " + fieldKey);
        fieldKeys_otherin.add(fieldKey_in + " " + fieldKey);
        fieldKeys_transin.add(fieldKey_in + " " + fieldKey);
        fieldKeys_transdir.add(fieldKey_in + " " + fieldKey);
    }

    //不同单据的各自使用的字段标识
    private static void addFields(String fieldKey, String fieldKey_hwlz, String fieldKey_purin,
                                  String fieldKey_otherin, String fieldKey_transin, String fieldKey_transdir, String fieldKey_saleship) {
        fieldKeys_hwlz.add(fieldKey_hwlz + " " + fieldKey);
        fieldKeys_purin.add(fieldKey_purin + " " + fieldKey);
        fieldKeys_otherin.add(fieldKey_otherin + " " + fieldKey);
        fieldKeys_transin.add(fieldKey_transin + " " + fieldKey);
        fieldKeys_transdir.add(fieldKey_transdir + " " + fieldKey);
        fieldKeys_saleship.add(fieldKey_saleship + " " + fieldKey);
    }

    /**
     * 获取日期的结束时间
     */
    public static Date getDayEndTime(Date date) {
        if (date == null) {
            return null;
        } else {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(date);
            calendar.set(calendar.get(1), calendar.get(2), calendar.get(5), 23, 59, 59);
            calendar.set(14, 999);
            return calendar.getTime();
        }
    }

    /**
     * 获取该日期的开始时间
     */
    public static Date getDayStartTime(Date date) {
        if (date == null) {
            return null;
        } else {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(date);
            calendar.set(calendar.get(1), calendar.get(2), calendar.get(5), 0, 0, 0);
            calendar.set(14, 0);
            return calendar.getTime();
        }
    }
}
