package tpv.tpv_wm.tpv_dt.java.report;

import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QFilter;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;

/**
 * @ClassName: GaudetailsRptQuery
 * @Description: 高低计明细表
 * @author: zbh
 * @date: 2024-05-28
 */
public class GaudetailsRptQuery extends AbstractReportListDataPlugin {
    private static final String algoKey = GaudetailsRptQuery.class.getName();

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        String whereFilter = createWhereStr(param);
        DataSet instockDataSet = query(whereFilter, param);
        return instockDataSet;
    }
    public static DataSet query(String whereFilter, ReportQueryParam param) {
        DataSet mainDataSet = mainDataSet().where(whereFilter);

        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        return createDataSet;
    }

    public static DataSet mainDataSet() {
        String selelctFiles = "tpv_department tpv_departme,billno tpv_uneven,tpv_bizdated tpv_bizdated,tpv_clearparty,tpv_unevened,tpv_advconap.tpv_purconums tpv_purconum," +
                "tpv_advconap.tpv_saleconums tpv_saleconum,tpv_notaxamount,tpv_advconap.tpv_unwrittenqtys tpv_unwrittenqtys,tpv_advconap.id entiId";
        DataSet tpvCmUneven = ORM.create().queryDataSet(algoKey, "tpv_cm_uneven", selelctFiles, null);

        DataSet tpvDtPurchase = ORM.create().queryDataSet(algoKey, "tpv_dt_purchase", "id,tpv_contractnumber tpv_purconums,tpv_combinationnumber tpv_com,tpv_supplier tpv_suppler", null);
        tpvCmUneven=tpvCmUneven.leftJoin(tpvDtPurchase).on("tpv_purconum","id").select(new String[]{"tpv_departme","tpv_uneven","tpv_bizdated","tpv_clearparty","tpv_unevened",
        "tpv_purconum","tpv_com","tpv_notaxamount","tpv_purconums","tpv_suppler","tpv_saleconum","entiId","tpv_unwrittenqtys"}).finish();
        DataSet tpvDtSalescontract = ORM.create().queryDataSet(algoKey, "tpv_dt_salescontract", "id,tpv_contractnos tpv_saleconums,tpv_customer,tpv_combinationnumber tpv_comstr", null);
        tpvCmUneven=tpvCmUneven.leftJoin(tpvDtSalescontract).on("tpv_saleconum","id").select(new String[]{"tpv_departme","tpv_uneven","tpv_bizdated","tpv_clearparty","tpv_unevened",
                "tpv_purconum","(case when tpv_com=null then tpv_comstr else tpv_com end) tpv_com","(case when tpv_unevened='A' then -1 else 1 end)*tpv_notaxamount tpv_notaxamount","tpv_purconums","tpv_suppler",
                "tpv_saleconums","tpv_customer","entiId","tpv_unwrittenqtys"}).finish();
        DataSet tpvBdCombination = ORM.create().queryDataSet(algoKey, "tpv_bd_combination", "id,tpv_splitdepartment.tpv_departmententry tpv_condepartment,tpv_splitdepartment.tpv_apercentage tpv_conpro,name tpv_comstring", null);
        tpvCmUneven=tpvCmUneven.leftJoin(tpvBdCombination).on("tpv_com","id").select(new String[]{"tpv_departme","tpv_uneven","tpv_bizdated","tpv_clearparty","tpv_unevened",
                "tpv_purconum","tpv_comstring","tpv_notaxamount","tpv_purconums","tpv_suppler","tpv_saleconums","tpv_customer","tpv_condepartment","tpv_conpro","entiId","tpv_unwrittenqtys"}).finish();
        DataSet tpvCmAltverification = ORM.create().queryDataSet(algoKey, "tpv_cm_altverification", "tpv_settledetail.tpv_srcbillentryid tpv_srcid,tpv_settledetail.tpv_amountverificatehid tpv_amountver", null);
        tpvCmAltverification=tpvCmAltverification.addField("Cast(tpv_srcid as Long) tpv_src", "tpv_src");
        tpvCmUneven=tpvCmUneven.leftJoin(tpvCmAltverification).on("entiId","tpv_src").select(new String[]{"tpv_departme","tpv_uneven","tpv_bizdated","tpv_clearparty","tpv_unevened",
                "tpv_purconum","tpv_comstring","tpv_notaxamount","tpv_purconums","tpv_suppler","tpv_saleconums","tpv_customer","tpv_condepartment","tpv_conpro","(tpv_unwrittenqtys+tpv_amountver)*(case when tpv_unevened='A' then -1 else 1 end) tpv_cancelqty",
        "(tpv_unwrittenqtys+tpv_amountver)*(case when tpv_unevened='A' then -1 else 1 end)*tpv_conpro tpv_conamount"}).finish();
        return tpvCmUneven;
    }
    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        DynamicObject tpvOrg = filterInfo.getDynamicObject("tpv_org");//业务部门
        DynamicObject tpvDepartmentl = filterInfo.getDynamicObject("tpv_departmentl");//分成部门
        String tpvName = filterInfo.getString("tpv_name");//计奖卡号
        String tpvUnevennum = filterInfo.getString("tpv_unevennum");//高低计单
        Date tpvStartsigstart = filterInfo.getDate("tpv_startsigstart");//高低计开始日期
        Date tpvStartsigend = filterInfo.getDate("tpv_startsigend");//高低计结束日期
        String tpvUnevendg = filterInfo.getString("tpv_unevendg");//高/低
        String tpvPurchase = filterInfo.getString("tpv_purchase");//采购合同
        DynamicObject tpvSupplerpur = filterInfo.getDynamicObject("tpv_supplerpur");//供应商
        String tpvSalenum = filterInfo.getString("tpv_salenum");//销售合同
        DynamicObject tpvCustomerrep = filterInfo.getDynamicObject("tpv_customerrep");//客户
        boolean tpvOndep = filterInfo.getBoolean("tpv_ondep");//仅看需跨部门分成
        String tpvClearpartygl = filterInfo.getString("tpv_clearpartygl");//高低计类型

        if (YEM.isNotEmpty(tpvClearpartygl)){
            whereFilter = String.format("%s and tpv_clearparty like '%%%s%%'", whereFilter, tpvClearpartygl);
        }
        if (tpvOndep){
            whereFilter = String.format("%s and tpv_departme <> %s", whereFilter,
                    String.join(",", "tpv_condepartment"));
        }
        if (tpvOrg!=null){
            whereFilter = String.format("%s and tpv_departme = %s", whereFilter, tpvOrg.getPkValue());
        }
        if (tpvDepartmentl!=null){
            whereFilter = String.format("%s and tpv_condepartment = %s", whereFilter, tpvDepartmentl.getPkValue());
        }
        if (YEM.isNotEmpty(tpvName)){
            whereFilter = String.format("%s and tpv_comstring like '%%%s%%'", whereFilter, tpvName);
        }
        if (YEM.isNotEmpty(tpvUnevennum)){
            whereFilter = String.format("%s and tpv_uneven like '%%%s%%'", whereFilter, tpvUnevennum);
        }
        if (tpvStartsigstart!=null){
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvStartsigstart);
            whereFilter = String.format("%s and tpv_bizdated >= to_date('" + format+ "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        if (tpvStartsigend!=null){
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvStartsigend);
            whereFilter = String.format("%s and tpv_bizdated <= to_date('" + format+ "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        if (YEM.isNotEmpty(tpvUnevendg)){
            whereFilter = String.format("%s and tpv_unevened like '%%%s%%'", whereFilter, tpvUnevendg);
        }
        if (YEM.isNotEmpty(tpvPurchase)){
            whereFilter = String.format("%s and tpv_purconums like '%%%s%%'", whereFilter, tpvPurchase);
        }
        if (tpvSupplerpur!=null){
            whereFilter = String.format("%s and tpv_suppler = %s", whereFilter, tpvSupplerpur.getPkValue());
        }
        if (YEM.isNotEmpty(tpvSalenum)){
            whereFilter = String.format("%s and tpv_saleconums like '%%%s%%'", whereFilter, tpvSalenum);
        }
        if (tpvCustomerrep!=null){
            whereFilter = String.format("%s and tpv_customer = %s", whereFilter, tpvCustomerrep.getPkValue());
        }
        String whereStr = PersonnelDepUtils.createWhereStr(filterInfo,"tpv_departme", "tpv_muldepartment");
        if (!"".equals(whereStr)){
            whereFilter=String.format("%s%s", whereFilter, whereStr);
        }
        return whereFilter;
    }
}
