package tpv.tpv_wm.tpv_dt.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QFilter;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

/**
 * @ClassName: InputscheRptQuery
 * @Description: 进项税明细表
 * @author: zbh
 * @date: 2024-05-28
 */
public class InputscheRptQuery extends AbstractReportListDataPlugin {
    private static final String algoKey = SumProfitRptQuery.class.getName();

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        String whereFilter = createWhereStr(param);
        DataSet instockDataSet = query(whereFilter, param);
        return instockDataSet;
    }

    public static DataSet query(String whereFilter, ReportQueryParam param) {
        DataSet mainDataSet = mainDataSet().where(whereFilter);

        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        return createDataSet;
    }

    public static DataSet mainDataSet() {
        QFilter qFilter_1 = new QFilter("billstatus", "=", "C");
        String selelctFiles = "tpv_department,billno tpv_costbillmat,tpv_costitem,tpv_billunit,tpv_dt_merge.tpv_purconumhb tpv_purconumhb,tpv_dt_merge.tpv_vendorhb tpv_vendorhb,tpv_dt_merge.tpv_saleconumhb tpv_saleconumhb," +
                "tpv_dt_merge.tpv_clienthb tpv_clienthb,tpv_dt_merge.tpv_inbordnumhb tpv_inbordnumhb,tpv_dt_merge.tpv_conprodnamehb tpv_prodname,tpv_dt_merge.tpv_conoriginhb tpv_origin,tpv_dt_merge.tpv_conshaderhb tpv_shader," +
                "tpv_dt_merge.tpv_conspecationhb tpv_specation,tpv_dt_merge.tpv_coninfoqtyhb tpv_qty,tpv_invoicedate tpv_date,tpv_dt_merge.tpv_amtatchhb tpv_taxpramount,tpv_dt_merge.tpv_vatamtmatchhb tpv_nottaxamount," +
                "tpv_dt_merge.tpv_rateddhb tpv_rate,tpv_dt_merge.tpv_vatmatamthb tpv_common";
        DataSet tpvDtCostbillmat = ORM.create().queryDataSet(algoKey, "tpv_dt_costbillmat", selelctFiles, qFilter_1.toArray());

        QFilter qFilter_2 = new QFilter("billstatus", "=", "C");
        String selelctFilesPur = "tpv_department,billno tpv_costbillmat,tpv_srcredid tpv_costitem,tpv_invoicedept tpv_billunit,tpv_contwareinfoentry.tpv_cwpurcontrnum tpv_purconumhb," +
                "tpv_contwareinfoentry.tpv_cwsupplier tpv_vendorhb,tpv_contwareinfoentry.tpv_based tpv_saleconumhb,tpv_contwareinfoentry.tpv_cwsupplier tpv_clienthb,tpv_contwareinfoentry.tpv_cwwarenum tpv_inbordnumhb," +
                "tpv_contwareinfoentry.tpv_cwprodname tpv_prodname,tpv_contwareinfoentry.tpv_cworigin tpv_origin,tpv_contwareinfoentry.tpv_cwshader tpv_shader,tpv_contwareinfoentry.tpv_cwspecation tpv_specation,tpv_contwareinfoentry.tpv_cwqty tpv_qty," +
                "tpv_invoicedate tpv_date,tpv_contwareinfoentry.tpv_cwmatchamo tpv_taxpramount,tpv_contwareinfoentry.tpv_cwamountnotax tpv_nottaxamount,tpv_contwareinfoentry.tpv_cwtaxrate tpv_rate,tpv_contwareinfoentry.tpv_cwamountintax tpv_common";
        DataSet tpvDtPurinvomater = ORM.create().queryDataSet(algoKey, "tpv_dt_purinvomater", selelctFilesPur, qFilter_2.toArray());
        DataSet finished = tpvDtCostbillmat.union(tpvDtPurinvomater);
        DataSet tpvDtPurchase = ORM.create().queryDataSet(algoKey, "tpv_dt_purchase", "tpv_combinationnumber,id,tpv_contractnumber", null);
        finished = finished.leftJoin(tpvDtPurchase).on("tpv_purconumhb", "id").select(new String[]{"tpv_department", "tpv_costbillmat", "tpv_costitem", "tpv_billunit", "tpv_contractnumber tpv_purconumhb",
                "tpv_vendorhb", "tpv_saleconumhb", "tpv_clienthb", "tpv_inbordnumhb", "tpv_prodname", "tpv_origin", "tpv_shader", "tpv_specation", "tpv_qty", "tpv_combinationnumber tpv_comstring", "tpv_date",
                "tpv_taxpramount", "tpv_nottaxamount", "tpv_rate", "tpv_common"}).finish();
        DataSet tpvDtSalescontract = ORM.create().queryDataSet(algoKey, "tpv_dt_salescontract", "tpv_contractnos,id,tpv_combinationnumber", null);
        finished = finished.leftJoin(tpvDtSalescontract).on("tpv_saleconumhb", "id").select(new String[]{"tpv_department", "tpv_costbillmat", "tpv_costitem", "tpv_billunit", "tpv_purconumhb",
                "tpv_vendorhb", "tpv_contractnos tpv_saleconumhb", "tpv_clienthb", "tpv_inbordnumhb", "tpv_prodname", "tpv_origin", "tpv_shader", "tpv_specation", "tpv_qty", "(case when tpv_comstring=null then tpv_combinationnumber else tpv_comstring end) tpv_comstring",
                "tpv_date", "tpv_taxpramount", "tpv_nottaxamount", "tpv_rate", "tpv_common"}).finish();
        DataSet tpvBdCombination = ORM.create().queryDataSet(algoKey, "tpv_bd_combination", "id,tpv_splitdepartment.tpv_departmententry tpv_condepartment,tpv_splitdepartment.tpv_apercentage tpv_conpro,name", null);
        finished = finished.leftJoin(tpvBdCombination).on("tpv_comstring", "id").select(new String[]{"tpv_department", "tpv_costbillmat", "tpv_costitem", "tpv_billunit", "tpv_purconumhb",
                "tpv_vendorhb", "tpv_saleconumhb", "tpv_clienthb", "tpv_inbordnumhb", "tpv_prodname", "tpv_origin", "tpv_shader", "tpv_specation", "tpv_qty", "name tpv_comstring", "tpv_condepartment", "tpv_conpro", "tpv_date",
                "tpv_taxpramount", "tpv_nottaxamount", "tpv_rate", "tpv_common", "(case when tpv_qty=0 then 0 else tpv_taxpramount/tpv_qty end) tpv_taxprice", "tpv_common*tpv_conpro tpv_conamount"}).finish();
        return finished;
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        DynamicObject tpvOrg = filterInfo.getDynamicObject("tpv_org");//业务部门
        DynamicObject tpvDep = filterInfo.getDynamicObject("tpv_dep");//分成部门
        String tpvName = filterInfo.getString("tpv_name");//计奖卡
        String tpvBillno = filterInfo.getString("tpv_billno");//发票匹配单号
        DynamicObject tpvCostitemgl = filterInfo.getDynamicObject("tpv_costitemgl");//费用项目
        DynamicObject tpvBillunitgl = filterInfo.getDynamicObject("tpv_billunitgl");//开票方
        String tpvPurconum = filterInfo.getString("tpv_purconum");//销售合同
        String tpvSaleconum = filterInfo.getString("tpv_saleconum");//采购合同
        DynamicObject tpvSuppler = filterInfo.getDynamicObject("tpv_suppler");//供应商
        Date tpvBegin = filterInfo.getDate("tpv_begin");//发票匹配开始
        Date tpvEnd = filterInfo.getDate("tpv_end");//发票匹配结束
        boolean tpvOndep = filterInfo.getBoolean("tpv_ondep");//仅看需跨部门分成
        if (tpvOrg != null) {
            whereFilter = String.format("%s and tpv_department = %s", whereFilter, tpvOrg.getPkValue());
        }
        if (tpvDep != null) {
            whereFilter = String.format("%s and tpv_condepartment = %s", whereFilter, tpvDep.getPkValue());
        }
        if (YEM.isNotEmpty(tpvName)) {
            whereFilter = String.format("%s and tpv_comstring like '%%%s%%'", whereFilter, tpvName);
        }
        if (YEM.isNotEmpty(tpvBillno)) {
            whereFilter = String.format("%s and tpv_costbillmat like '%%%s%%'", whereFilter, tpvBillno);
        }
        if (tpvCostitemgl != null) {
            whereFilter = String.format("%s and tpv_costitem = %s", whereFilter, tpvCostitemgl.getPkValue());
        }
        if (tpvBillunitgl != null) {
            whereFilter = String.format("%s and tpv_billunit = %s", whereFilter, tpvBillunitgl.getPkValue());
        }
        if (YEM.isNotEmpty(tpvPurconum)) {
            whereFilter = String.format("%s and tpv_saleconumhb like '%%%s%%'", whereFilter, tpvPurconum);
        }
        if (YEM.isNotEmpty(tpvSaleconum)) {
            whereFilter = String.format("%s and tpv_purconumhb like '%%%s%%'", whereFilter, tpvSaleconum);
        }
        if (tpvSuppler != null) {
            whereFilter = String.format("%s and tpv_vendorhb = %s", whereFilter, tpvSuppler.getPkValue());
        }
        if (tpvBegin != null) {
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvBegin);
            whereFilter = String.format("%s and tpv_date >= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        if (tpvEnd != null) {
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvEnd);
            whereFilter = String.format("%s and tpv_date <= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        if (tpvOndep) {
            whereFilter = String.format("%s and tpv_department <> %s", whereFilter,
                    String.join(",", "tpv_condepartment"));
        }
        return whereFilter;
    }
}
