package tpv.tpv_wm.tpv_dt.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;

/**
 * @ClassName: InvscheRptQuery
 * @Description: 销项发票明细表
 * @author: zbh
 * @date: 2024-05-27
 */
public class InvscheRptQuery extends AbstractReportListDataPlugin {
    private static final String algoKey = InvscheRptQuery.class.getName();

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        String whereFilter = createWhereStr(param);
        DataSet instockDataSet = query(whereFilter, param);
        return instockDataSet;
    }

    public static DataSet query(String whereFilter, ReportQueryParam param) {
        DataSet mainDataSet = mainDataSet().where(whereFilter);

        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        return createDataSet;
    }

    public static DataSet mainDataSet() {
        List<String> listStatus = new ArrayList<>();
        listStatus.add("C");
        listStatus.add("D");
        QFilter qFilter_1 = new QFilter("billstatus", "in", listStatus);
        String selelctFiles = "billno tpv_billno,tpv_reqdepartment tpv_department,sim_original_bill_item.id tpv_itemid,sim_original_bill_item.tpv_salescontract tpv_salescontract," +
                "sim_original_bill_item.tpv_delivernumd delivernumd,billdate tpv_billdate,sim_original_bill_item.tpv_combonum tpv_combonum,sim_original_bill_item.tpv_prodname tpv_prodname," +
                "sim_original_bill_item.tpv_shader tpv_shader,sim_original_bill_item.tpv_origin tpv_origin,sim_original_bill_item.tpv_specation tpv_specation,sim_original_bill_item.num tpv_num," +
                "sim_original_bill_item.taxunitprice tpv_taxprice,sim_original_bill_item.taxamount tpv_taxpramount,sim_original_bill_item.unitprice tpv_price,sim_original_bill_item.amount tpv_nottaxamount";
        DataSet simOriginalBill = ORM.create().queryDataSet(algoKey, "sim_original_bill", selelctFiles, qFilter_1.toArray());

        DataSet tpvDtSalesshipping = ORM.create().queryDataSet(algoKey, "tpv_dt_salesshipping", "id,billno tpv_delivernumd,tpv_bizdate tpv_deliverdate", null);
        simOriginalBill = simOriginalBill.leftJoin(tpvDtSalesshipping).on("delivernumd", "id").select(new String[]{"tpv_billno", "tpv_department", "tpv_itemid", "tpv_salescontract",
                "tpv_delivernumd", "tpv_billdate", "tpv_combonum", "tpv_deliverdate", "tpv_prodname", "tpv_shader", "tpv_origin", "tpv_specation", "tpv_num", "tpv_taxprice",
                "tpv_taxpramount", "tpv_price", "tpv_nottaxamount"}).finish();
        QFilter qFilter_3 = new QFilter("billstatus", "=", "C");

        DataSet tpvDtSalescontract = ORM.create().queryDataSet(algoKey, "tpv_dt_salescontract", "id,tpv_signingdate,tpv_customer,tpv_materialentry.tpv_packnum tpv_packnum,tpv_contractnos tpv_connum", qFilter_3.toArray());
        simOriginalBill = simOriginalBill.leftJoin(tpvDtSalescontract).on("tpv_salescontract", "id").select(new String[]{"tpv_billno", "tpv_department", "tpv_itemid", "tpv_salescontract",
                "tpv_delivernumd", "tpv_billdate", "tpv_combonum", "tpv_signingdate", "tpv_deliverdate", "tpv_customer", "tpv_prodname", "tpv_shader", "tpv_origin", "tpv_specation", "tpv_num", "tpv_taxprice",
                "tpv_taxpramount", "tpv_price", "tpv_nottaxamount", "tpv_packnum", "tpv_connum"}).finish();
        DataSet tpvCmCostdispose = ORM.create().queryDataSet(algoKey, "tpv_cm_costdispose", "tpv_origampnotax tpv_taxpricecost,tpv_soudocumid", null)
                .groupBy(new String[]{"tpv_soudocumid"}).sum("tpv_taxpricecost").finish();
        tpvCmCostdispose = tpvCmCostdispose.addField("Cast(tpv_soudocumid as Long) tpv_soudocum", "tpv_soudocum");
        simOriginalBill = simOriginalBill.leftJoin(tpvCmCostdispose).on("tpv_itemid", "tpv_soudocum").select(new String[]{"tpv_billno", "tpv_department", "tpv_itemid", "tpv_salescontract",
                "tpv_delivernumd", "tpv_billdate", "tpv_combonum", "tpv_signingdate", "tpv_deliverdate", "tpv_customer", "tpv_prodname", "tpv_shader", "tpv_origin", "tpv_specation", "tpv_num", "tpv_taxprice",
                "tpv_taxpramount", "tpv_price", "tpv_nottaxamount", "tpv_packnum", "tpv_taxpricecost", "tpv_connum"}).finish();
        DataSet tpvBdCombination = ORM.create().queryDataSet(algoKey, "tpv_bd_combination", "id,tpv_splitdepartment.tpv_departmententry tpv_condepartment,tpv_splitdepartment.tpv_apercentage tpv_conpro,name tpv_comstring", null);
        simOriginalBill = simOriginalBill.leftJoin(tpvBdCombination).on("tpv_combonum", "id").select(new String[]{"tpv_billno", "tpv_department", "tpv_itemid", "tpv_salescontract",
                "tpv_delivernumd", "tpv_billdate", "tpv_combonum", "tpv_signingdate", "tpv_deliverdate", "tpv_customer", "tpv_prodname", "tpv_shader", "tpv_origin", "tpv_specation", "tpv_num", "tpv_taxprice",
                "tpv_taxpramount", "tpv_price", "tpv_nottaxamount", "tpv_packnum", "tpv_taxpricecost", "(case when tpv_taxpricecost=null then tpv_nottaxamount else tpv_nottaxamount-tpv_taxpricecost end ) tpv_pricepro", "tpv_conpro", "tpv_condepartment", "(case when tpv_taxpricecost=null then tpv_nottaxamount else tpv_nottaxamount-tpv_taxpricecost end )*tpv_conpro tpv_conamount",
                "tpv_comstring", "tpv_connum"}).finish();
        return simOriginalBill;
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        boolean tpvOndep = filterInfo.getBoolean("tpv_ondep");//仅看需跨部门分成
        String tpvName = filterInfo.getString("tpv_name");//计奖卡号
        DynamicObject tpvDepartmentl = filterInfo.getDynamicObject("tpv_departmentl");//分成部门
        String tpvContractnums = filterInfo.getString("tpv_contractnums");//销售合同号
        DynamicObject tpvOrg = filterInfo.getDynamicObject("tpv_org");//业务组织
        DynamicObject tpvCustomerrep = filterInfo.getDynamicObject("tpv_customerrep");//销售客户
        String tpvSimnal = filterInfo.getString("tpv_simnal");//销售发票（开票申请）
        String tpvSalesshipping = filterInfo.getString("tpv_salesshipping");//发货单号
        Date tpvStartsigstart = filterInfo.getDate("tpv_startsigstart");//签约日期开始
        Date tpvStartsigend = filterInfo.getDate("tpv_startsigend");//签约日期结束
        Date tpvStartsm = filterInfo.getDate("tpv_startsm");//开票开始日期
        Date tpvEndsm = filterInfo.getDate("tpv_endsm");//开票结束日期
        Date tpvStartsaless = filterInfo.getDate("tpv_startsaless");//发货日期开始
        Date tpvEndsaless = filterInfo.getDate("tpv_endsaless");//发货日期结束
        if (tpvOndep) {
            whereFilter = String.format("%s and tpv_department <> %s", whereFilter,
                    String.join(",", "tpv_condepartment"));
        }
        if (YEM.isNotEmpty(tpvName)) {
            whereFilter = String.format("%s and tpv_comstring like '%%%s%%'", whereFilter, tpvName);
        }
        if (tpvDepartmentl != null) {
            whereFilter = String.format("%s and tpv_condepartment = %s", whereFilter, tpvDepartmentl.getPkValue());
        }
        if (YEM.isNotEmpty(tpvContractnums)) {
            whereFilter = String.format("%s and tpv_connum like '%%%s%%'", whereFilter, tpvContractnums);
        }
        if (tpvOrg!=null){
            whereFilter = String.format("%s and tpv_department = %s", whereFilter, tpvOrg.getPkValue());
        }
        if (tpvCustomerrep!=null){
            whereFilter = String.format("%s and tpv_customer = %s", whereFilter, tpvCustomerrep.getPkValue());
        }
        if (YEM.isNotEmpty(tpvSimnal)){
            whereFilter = String.format("%s and tpv_billno like '%%%s%%'", whereFilter, tpvSimnal);
        }
        if (YEM.isNotEmpty(tpvSalesshipping)){
            whereFilter = String.format("%s and tpv_delivernumd like '%%%s%%'", whereFilter, tpvSalesshipping);
        }
        if (tpvStartsigstart!=null){
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvStartsigstart);
            whereFilter = String.format("%s and tpv_signingdate >= to_date('" + format+ "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        if (tpvStartsigend!=null){
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvStartsigend);
            whereFilter = String.format("%s and tpv_signingdate <= to_date('" + format+ "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        if (tpvStartsm!=null){
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvStartsm);
            whereFilter = String.format("%s and tpv_billdate >= to_date('" + format+ "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        if (tpvEndsm!=null){
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvEndsm);
            whereFilter = String.format("%s and tpv_billdate <= to_date('" + format+ "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        if (tpvStartsaless!=null){
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvStartsaless);
            whereFilter = String.format("%s and tpv_deliverdate >= to_date('" + format+ "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        if (tpvEndsaless!=null){
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvEndsaless);
            whereFilter = String.format("%s and tpv_deliverdate <= to_date('" + format+ "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        return whereFilter;
    }
}
