package tpv.tpv_wm.tpv_dt.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

/**
 * @ClassName: LogisticsproRptQuery
 * @Description: 物流服务商在手货物表
 * @author: zbh
 * @date: 2024-05-15
 */
public class LogisticsproRptQuery extends AbstractReportListDataPlugin {
    @Override
    public DataSet query(ReportQueryParam reportQueryParam, Object o) throws Throwable {
        FilterInfo filter = reportQueryParam.getFilter();
        String tpvFreigroambill = filter.getString("tpv_freigroambill");
        QFilter qFilter = new QFilter("billstatus", QCP.equals, "C");//查询单据状态为已审核的
        if (YEM.isNotEmpty(tpvFreigroambill)){
            qFilter.and("billno", QCP.ftlike, "%"+tpvFreigroambill+"%");
        }
        String selelctFiles = "tpv_custcarrier,tpv_materialentry.tpv_material tpv_material,tpv_materialentry.tpv_prodname tpv_prodname,tpv_materialentry.tpv_origin tpv_origin," +
                "tpv_materialentry.tpv_shader tpv_shader,tpv_materialentry.tpv_specation tpv_specation,tpv_materialentry.tpv_customtags tpv_customtags,tpv_materialentry.tpv_unit tpv_unit," +
                "tpv_materialentry.tpv_qty tpv_qty,tpv_materialentry.tpv_packagingunit tpv_packagingunit,tpv_materialentry.tpv_packnum tpv_packnum,tpv_materialentry.tpv_taxprice tpv_taxprice," +
                "tpv_materialentry.tpv_taxpramount tpv_taxpramount,billno tpv_billno,tpv_bizdate,tpv_delivery,tpv_corebillid id,tpv_materialentry.tpv_reperoomqty qty,tpv_currency.name tpv_qcur";
        DataSet dataSet = QueryServiceHelper.queryDataSet(this.getClass().getName(), "tpv_dt_freigroambill", selelctFiles,
                qFilter.toArray(), null).where("tpv_qty > qty");//货物流转单
        DataSet purchase = QueryServiceHelper.queryDataSet(this.getClass().getName(), "tpv_dt_purchase", "id,tpv_contractnumber tpv_purcontnum,tpv_supplier,tpv_department,tpv_documentarys tpv_operatorht,tpv_logisticsfieldserv tpv_conmerchan",
                null, null);//采购合同
        DataSet materialgroupdetail = QueryServiceHelper.queryDataSet(this.getClass().getName(), "bd_materialgroupdetail", "material,group tpv_materialgroup",
                null, null);//物料分类标准页签
        DataSet finish = dataSet.leftJoin(purchase).on("id", "id").select("tpv_custcarrier", "tpv_material", "tpv_prodname", "tpv_origin", "tpv_shader", "tpv_specation", "tpv_customtags", "tpv_unit"
                , "tpv_qty", "tpv_packagingunit", "tpv_packnum", "tpv_taxprice", "tpv_taxpramount", "tpv_billno", "tpv_bizdate", "tpv_delivery", "tpv_purcontnum"
                , "tpv_supplier", "tpv_department", "tpv_operatorht", "tpv_conmerchan","tpv_qcur").finish();
        DataSet finished = finish.leftJoin(materialgroupdetail).on("tpv_material", "material").select("tpv_custcarrier", "tpv_material", "tpv_prodname", "tpv_origin", "tpv_shader", "tpv_specation", "tpv_customtags", "tpv_unit"
                , "tpv_qty", "tpv_packagingunit", "tpv_packnum", "tpv_taxprice", "tpv_taxpramount", "tpv_billno", "tpv_bizdate", "tpv_delivery", "tpv_purcontnum"
                , "tpv_supplier", "tpv_department", "tpv_operatorht", "tpv_conmerchan","tpv_materialgroup","tpv_qcur").finish();

        String whereFilter = "1 = 1";
        String whereStr = PersonnelDepUtils.createWhereStr(filter,"tpv_department", "tpv_muldepartment");
        if (!"".equals(whereStr)){
            whereFilter=String.format("%s%s", whereFilter, whereStr);
        }
        return finished.where(whereFilter);
    }
}

