package tpv.tpv_wm.tpv_dt.java.report;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.util.EventObject;

/**
 * @ClassName: PersonnelDepFormPlugin
 * @Description: 全部报表和工作台
 *1、增加字段【部门】（只允许选择最末级节点）
 *（1）缺省值
 *①如果当前登陆人在《人员》{部门信息}中分录行【兼职】=“否”的数据行中【部门】，在《部门属性管理》中【业务属性】=“职能部门”，则默认选中所有【部门】；
 *②如果当前登陆人在《人员》{部门信息}中分录行【兼职】=“否”的数据行中【部门】在《部门属性管理》中【业务属性】≠“职能部门”，则默认选中当前【部门】以及下级部门所有的部门；且只显示当前【部门】以及下级部门所有的部门
 * @author: zbh
 * @date: 2024-07-09
 */
public class PersonnelDepFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit tpv_operator = (BasedataEdit) this.getView().getControl("tpv_muldepartment");
        tpv_operator.addBeforeF7SelectListener(this);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        PersonnelDepUtils.departmentDef(this.getModel(),"tpv_muldepartment");
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name){
            case"tpv_muldepartment":
                PersonnelDepUtils.departmentF(e);
                break;
        }
    }
}
