package tpv.tpv_wm.tpv_dt.java.report;

import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 可拣配查询
 *
 * @author longh
 * @description 查询插件
 * @date 2023年8月17日
 */
@Deprecated
public class PickShipsRptQuery extends AbstractReportListDataPlugin {

    private static final String algoKey = PickShipsRptQuery.class.getName();
    private static List<String> fieldKeys_order = new ArrayList<>();// 采购合同
    private static List<String> fieldKeys_hwlz = new ArrayList<>();// 货物流转
    private static List<String> fieldKeys_purin = new ArrayList<>();// 采购入库
    private static List<String> fieldKeys_otherin = new ArrayList<>();// 其他入库
    private static List<String> fieldKeys_transin = new ArrayList<>();// 分步调入
    private static List<String> fieldKeys_transdir = new ArrayList<>();// 直接调拨

    @Override
    public DataSet query(ReportQueryParam param, Object obj) throws Throwable {
        String whereFilter = createWhereStr(param);
        DataSet instockDataSet = query(whereFilter);
        return instockDataSet;
    }

    public static DataSet query(String whereFilter) {
        return query(whereFilter, null, null);
    }

    public static DataSet query(String whereFilter, String picktype, Long exceptId) {
        Map<String, Map<Long, List<DynamicObject>>> pickMap = pickDataCols(picktype, exceptId);
        DataSet mainDataSet = mainDataSet(whereFilter);
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        for (DynamicObject col : col_s) {
            String tpv_pickbill = col.getString("tpv_pickbill");
            long tpv_fentryid = col.getLong("tpv_fentryid");
            long tpv_vid = col.getLong("tpv_vid");
            BigDecimal tpv_pickqty_s = BigDecimal.ZERO;
            Map<Long, List<DynamicObject>> map = pickMap.get(tpv_pickbill);
            if (map != null) {
                List<DynamicObject> list = map.get(tpv_fentryid);
                if (list != null) {
                    for (DynamicObject obj : list) {
                        long tpv_vid1 = obj.getLong("tpv_vid");
                        if (tpv_vid == tpv_vid1) {
                            tpv_pickqty_s = BigDecimalUtils.add(tpv_pickqty_s, obj.getBigDecimal("tpv_pickqty_s"), 10);
                        }
                    }
                }
            }
            BigDecimal qty = col.getBigDecimal("tpv_qty");
            BigDecimal tpv_qty = BigDecimal.ZERO;
            BigDecimal tpv_maxqty = BigDecimal.ZERO;
            if (YEM.isEmpty(tpv_vid)) {
                BigDecimal tpv_pickedqty = col.getBigDecimal("tpv_pickedqty");
                BigDecimal tpv_pickedqty_s = col.getBigDecimal("tpv_pickedqty_s");
                BigDecimal tpv_overfillrate = col.getBigDecimal("tpv_overfillrate");
                tpv_qty = qty.subtract(tpv_pickedqty).subtract(tpv_pickedqty_s).subtract(tpv_pickqty_s);
                tpv_maxqty = qty.subtract(tpv_pickedqty)
                        .multiply(BigDecimal.ONE.add(tpv_overfillrate.divide(BigDecimalUtils.one_handred)))
                        .subtract(tpv_pickedqty_s).subtract(tpv_pickqty_s);
            } else {
                BigDecimal tpv_vqty = col.getBigDecimal("tpv_vqty");
                BigDecimal tpv_vqtys = col.getBigDecimal("tpv_vqtys");
                tpv_qty = tpv_vqty.subtract(tpv_vqtys).subtract(tpv_pickqty_s);
                tpv_maxqty = tpv_qty;
            }
            col.set("tpv_qty", tpv_qty);// 可配数量
            col.set("tpv_maxqty", tpv_maxqty);// 最大可配数量
            // col.set("tpv_packnum",
            // tpv_qty.multiply(col.getBigDecimal("tpv_coefficients")));// 可配包装数量
        }

        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        return Algo.create(algoKey).createDataSet(inputs).where("tpv_qty > 0");
    }

    public static Map<String, Map<Long, List<DynamicObject>>> pickDataCols() {
        return pickDataCols(null, null);
    }

    public static Map<String, Map<Long, List<DynamicObject>>> pickDataCols(String picktype, Long exceptId) {
        DataSet pickDataSet = pickDataSet(picktype, exceptId);
        DynamicObjectCollection pickData = ORM.create().toPlainDynamicObjectCollection(pickDataSet);
        Map<String, Map<Long, List<DynamicObject>>> pickMap = pickData.stream()
                .filter(x -> YEM.isNotEmpty(x.getString("tpv_pickbill")))
                .filter(x -> YEM.isNotEmpty(x.getLong("tpv_fentryid"))).collect(Collectors.groupingBy(
                        x -> x.getString("tpv_pickbill"), Collectors.groupingBy(x -> x.getLong("tpv_fentryid"))));
        return pickMap;
    }

    private static DataSet mainDataSet(String whereFilter) {
        initAllFields();

        QFilter qFilter = new QFilter("billstatus", QCP.equals, "C");

        DataSet purchase = ORM.create().queryDataSet(algoKey, "tpv_dt_purchase", String.join(",", fieldKeys_order),
                qFilter.toArray());
        DataSet freigroambill = ORM.create().queryDataSet(algoKey, "tpv_dt_freigroambill",
                String.join(",", fieldKeys_hwlz), qFilter.toArray());
        DataSet im_purinbill = ORM.create().queryDataSet(algoKey, "im_purinbill", String.join(",", fieldKeys_purin),
                qFilter.toArray());
        DataSet im_otherinbill = ORM.create().queryDataSet(algoKey, "im_otherinbill",
                String.join(",", fieldKeys_otherin), qFilter.toArray());
        DataSet im_transinbill = ORM.create().queryDataSet(algoKey, "im_transinbill",
                String.join(",", fieldKeys_transin), qFilter.toArray());
        DataSet im_transdirbill = ORM.create().queryDataSet(algoKey, "im_transdirbill",
                String.join(",", fieldKeys_transdir), qFilter.toArray());

        DataSet dataSet = purchase.union(freigroambill).union(im_purinbill).union(im_otherinbill).union(im_transinbill)
                .union(im_transdirbill);

        if (YEM.isNotEmpty(whereFilter)) {
            dataSet = dataSet.where(whereFilter);
        }

        return dataSet.orderBy(new String[]{"tpv_bizdate desc"});
    }

    public static DataSet pickDataSet(String picktype, Long exceptId) {
        QFilter[] qFilter = null;
        QFilter[] qFilter1 = null;
        QFilter[] qFilterSeven = null;
        if (YEM.isNotEmpty(exceptId)) {
            if ("tpv_dt_salesshipping".equals(picktype)) {
                qFilter = new QFilter("tpv_materialentry", QCP.not_equals, exceptId).toArray();
            } else if ("multibill".equals(picktype)) {
                qFilter1 = new QFilter("id", QCP.not_equals, exceptId).toArray();
            } else if ("tpv_dt_noconfiguration".equals(picktype)) {
                qFilter = new QFilter("id", QCP.not_equals, exceptId).toArray();
            } else if ("tpv_dt_relevancedealgs".equals(picktype)) {
                qFilterSeven = new QFilter("tpv_dt_goodstransfe_zh", QCP.not_equals, exceptId).and("billstatus", QCP.not_equals, "C").toArray();
            }
        }
        List<String> fieldKeys = new ArrayList<>();
        fieldKeys.add("tpv_materialentry.tpv_dt_salepick_zy.tpv_pickbill_zy tpv_pickbill");// 配货单据
        fieldKeys.add("tpv_materialentry.tpv_dt_salepick_zy.tpv_fentryid_zy tpv_fentryid");// 采购分录行ID
        fieldKeys.add("tpv_materialentry.tpv_dt_salepick_zy.tpv_pickqty_zy tpv_pickqty_s");// 本次配货数量
        fieldKeys.add("tpv_materialentry.tpv_dt_salepick_zy.tpv_vid_zy tpv_vid");// 卷号分录ID
        fieldKeys.add("'B' tpv_iskc");// 直运
        DataSet dataSet_zy = ORM.create().queryDataSet(algoKey, "tpv_dt_salesshipping", String.join(",", fieldKeys),
                qFilter);

        fieldKeys.clear();
        fieldKeys.add("tpv_materialentry.tpv_dt_salepick_in.tpv_pickbill_in tpv_pickbill");//配货单据
        fieldKeys.add("tpv_materialentry.tpv_dt_salepick_in.tpv_fentryid_in tpv_fentryid");//采购分录行ID
        fieldKeys.add("tpv_materialentry.tpv_dt_salepick_in.tpv_pickqty_in tpv_pickqty_s");//本次配货数量
        fieldKeys.add("tpv_materialentry.tpv_dt_salepick_in.tpv_vid_in tpv_vid");// 卷号分录ID
        fieldKeys.add("'A' tpv_iskc");//库存
        DataSet dataSet_in = ORM.create().queryDataSet(algoKey, "tpv_dt_salesshipping", String.join(",", fieldKeys),
                qFilter);

        fieldKeys.clear();
        fieldKeys.add("billentry.tpv_pickbill_in tpv_pickbill");// 配货单据
        fieldKeys.add("billentry.tpv_fentryid_in tpv_fentryid");// 采购分录行ID
        fieldKeys.add("billentry.qty tpv_pickqty_s");// 本次配货数量
        fieldKeys.add("billentry.tpv_vid_in tpv_vid");// 卷号分录ID
        fieldKeys.add("'A' tpv_iskc");// 库存
        DataSet im_transdirbill = ORM.create().queryDataSet(algoKey, "im_transdirbill", String.join(",", fieldKeys),
                qFilter1);
        DataSet im_otheroutbill = ORM.create().queryDataSet(algoKey, "im_otheroutbill", String.join(",", fieldKeys),
                qFilter1);
        DataSet im_transoutbill = ORM.create().queryDataSet(algoKey, "im_transoutbill", String.join(",", fieldKeys),
                qFilter1);
        fieldKeys.clear();
        fieldKeys.add("billentry.tpv_pickbill_in tpv_pickbill");// 配货单据
        fieldKeys.add("billentry.tpv_fentryid_in tpv_fentryid");// 采购分录行ID
        fieldKeys.add("billentry.qty tpv_pickqty_s");// 本次配货数量
        fieldKeys.add("billentry.tpv_vid_in tpv_vid");// 卷号分录ID
        fieldKeys.add("'A' tpv_iskc");// 库存
        DataSet im_purinbill = ORM.create().queryDataSet(algoKey, "im_purinbill", String.join(",", fieldKeys),
                qFilter1);
        fieldKeys.clear();
        fieldKeys.add("tpv_sonentryentity.tpv_pickbills tpv_pickbill");// 配货单据
        fieldKeys.add("tpv_sonentryentity.tpv_fentryid_in tpv_fentryid");// 采购分录行ID
        fieldKeys.add("tpv_sonentryentity.tpv_pickqty_in tpv_pickqty_s");// 本次配货数量
        fieldKeys.add("tpv_sonentryentity.tpv_vid_in tpv_vid");// 卷号分录ID
        fieldKeys.add("'A' tpv_iskc");// 库存
        DataSet tpv_dt_noconfiguration = ORM.create().queryDataSet(algoKey, "tpv_dt_noconfiguration", String.join(",", fieldKeys),
                qFilter1);
        //关联交易转货单
        fieldKeys.clear();
        fieldKeys.add("tpv_dt_goodstransfe_zh.tpv_dt_transferdist_ph.tpv_pickbill tpv_pickbill");// 配货单据
        fieldKeys.add("tpv_dt_goodstransfe_zh.tpv_dt_transferdist_ph.tpv_fentryids tpv_fentryid");// 采购分录行ID
        fieldKeys.add("tpv_dt_goodstransfe_zh.tpv_dt_transferdist_ph.tpv_pickqty tpv_pickqty_s");// 本次配货数量
        fieldKeys.add("tpv_dt_goodstransfe_zh.tpv_dt_transferdist_ph.tpv_vids tpv_vid");// 卷号分录ID
        fieldKeys.add("'A' tpv_iskc");//库存
        DataSet tpv_dt_relevancedealgs = ORM.create().queryDataSet(algoKey, "tpv_dt_relevancedealgs", String.join(",", fieldKeys),
                qFilterSeven);
        DataSet select = im_purinbill.select("tpv_pickbill", "tpv_fentryid", " ABs(tpv_pickqty_s) tpv_pickqty_s", "tpv_vid", "tpv_iskc");
        return dataSet_zy.union(dataSet_in).union(im_transdirbill).union(im_otheroutbill).union(im_transoutbill).union(im_purinbill).union(tpv_dt_noconfiguration).union(tpv_dt_relevancedealgs);
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "tpv_qty > 0";
        // 公司
        DynamicObjectCollection tpv_org_f = filterInfo.getDynamicObjectCollection("tpv_org_f");
        if (YEM.isNotEmpty(tpv_org_f)) {
            whereFilter = String.format("%s and tpv_org in (%s)", whereFilter,
                    String.join(",", RptUtil.getBaseDataPkIdStrList(tpv_org_f)));
        }
        // 组合号
        DynamicObject tpv_combination_f = filterInfo.getDynamicObject("tpv_combination_f");
        if (YEM.isNotEmpty(tpv_combination_f)) {
            whereFilter = String.format("%s and tpv_combination = %s", whereFilter, tpv_combination_f.getPkValue());
        }
        // 仓库
        DynamicObject tpv_warehouse_f = filterInfo.getDynamicObject("tpv_warehouse_f");
        if (YEM.isNotEmpty(tpv_warehouse_f)) {
            whereFilter = String.format("%s and tpv_warehouse = %s", whereFilter, tpv_warehouse_f.getPkValue());
        }
        // 库存/直运
        String tpv_inventorytype_f = filterInfo.getString("tpv_inventorytype_f");
        if (YEM.isNotEmpty(tpv_inventorytype_f)) {
            whereFilter = String.format("%s and tpv_inventorytype = '%s'", whereFilter, tpv_inventorytype_f);
        }
        // 品名
        DynamicObject tpv_prodname_f = filterInfo.getDynamicObject("tpv_prodname_f");
        if (YEM.isNotEmpty(tpv_prodname_f)) {
            whereFilter = String.format("%s and tpv_prodname = %s", whereFilter, tpv_prodname_f.getPkValue());
        }
        // 规格
        String tpv_specation_f = filterInfo.getString("tpv_specation_f");
        if (YEM.isNotEmpty(tpv_specation_f)) {
            whereFilter = String.format("%s and tpv_specation = '%s'", whereFilter, tpv_specation_f);
        }
        // 材质
        String tpv_shader_f = filterInfo.getString("tpv_shader_f");
        if (YEM.isNotEmpty(tpv_shader_f)) {
            whereFilter = String.format("%s and tpv_shader = '%s'", whereFilter, tpv_shader_f);
        }
        // 产地
        DynamicObject tpv_origin_f = filterInfo.getDynamicObject("tpv_origin_f");
        if (YEM.isNotEmpty(tpv_origin_f)) {
            whereFilter = String.format("%s and tpv_origin = %s", whereFilter, tpv_origin_f.getPkValue());
        }
        return whereFilter;
    }

    private static void initAllFields() {
        fieldKeys_order.clear();
        fieldKeys_hwlz.clear();
        fieldKeys_purin.clear();
        fieldKeys_otherin.clear();
        fieldKeys_transin.clear();
        fieldKeys_transdir.clear();
        addFields("tpv_fid", "id");// id
        addFields("tpv_fentryid", "tpv_materialentry", "billentry");// 分录id
        addFields("tpv_fcoid", "id", "tpv_materialentry.tpv_cobillid", "billentry.mainbillid", null, null, null);// 分录id
        addFields("tpv_purcontnum", "tpv_contractnumber", "tpv_purcontnum", "tpv_purcontnum", null, null, null);// 合同号
        addFields("tpv_bizdate", "tpv_bizdate", "biztime");// 业务日期
        addFields("tpv_org", "org");// 公司
        addFields("bizdept", null,null,"bizdept",null,null,null);// 公司
        addFields("tpv_department", "tpv_department", "tpv_department", "bizdept", "bizdept", "dept", "dept");// 部门
        addFields("tpv_supplier", "tpv_supplier", "tpv_supplier", "supplier", "supplier", "null", "null");// 供应商
        addFields("tpv_tradeproperty", "tpv_tradeproperty", "tpv_tradeproperty", "tpv_tradeproperty",
                "tpv_tradeproperty", "null", "null");// 贸易性质
        addFields("tpv_combination", "tpv_combinationnumber", "tpv_combinationnumber", "tpv_combinationnumber", "null",
                "null", "null");// 组合号
        addFields("tpv_strategy", "tpv_policynumber", "tpv_combinationnumber.tpv_strategy",
                "tpv_combinationnumber.tpv_strategy", "null", "null", "null");// 策略号
        addFields("tpv_inventorytype", "'B'", "'A'");// 库存/直运
        addFields("tpv_pickbill", "'tpv_dt_purchase'", "'tpv_dt_freigroambill'", "'im_purinbill'", "'im_otherinbill'",
                "'im_transinbill'", "'im_transdirbill'");// 配货单据
        addFields("tpv_billno", "billno");// 单据编号
        addFields("tpv_material", "tpv_materialentry.tpv_material", "billentry.material.masterid");// 商品名称
        addFields("tpv_prodname", "tpv_materialentry.tpv_prodname", "billentry.tpv_prodname");// 品名
        addFields("tpv_specation", "tpv_materialentry.tpv_specation", "billentry.tpv_specation");// 规格
        addFields("tpv_shader", "tpv_materialentry.tpv_shader", "billentry.tpv_shader");// 材质
        addFields("tpv_origin", "tpv_materialentry.tpv_origin", "billentry.tpv_origin");// 产地
        addFields("tpv_unit", "tpv_materialentry.tpv_unit", "billentry.unit");// 计量单位
        addFields("tpv_qty", "tpv_materialentry.tpv_qty", "billentry.qty");// 可配数量
        // addFields("tpv_packagingunit", "tpv_materialentry.tpv_packagingunit",
        // "billentry.tpv_packagingunit");// 包装单位
        addFields("tpv_coefficients", "tpv_materialentry.tpv_coefficients", "billentry.tpv_coefficients");// 系数
        addFields("tpv_warehouse", "null", "tpv_materialentry.tpv_warehouse", "billentry.warehouse",
                "billentry.warehouse", "billentry.warehouse", "billentry.warehouse");// 仓库
        // 采购合同:【已计协平数量】+【已计合同结转数量】+【手动流转数量】+【已拣配数量（查表扣减）】
        // 货物流转单:【手动流转数量】+【已拣配数量（查表扣减）】
        // 采购入库单:【已拣配数量（查表扣减）】+ 【已退库数量】 +【已仓单质押数量】
        // 其他入库：【已拣配数量（查表扣减）】
        // 分步调入：【已拣配数量（查表扣减）】
        // 直接调拨单：【已拣配数量（查表扣减）】
        addFields("tpv_pickedqty", "(tpv_materialentry.tpv_balancequantity+tpv_materialentry.tpv_calcuconforwardqty)",
                "0.0", "0.0", "0.0", "0.0", "0.0");// 不可配数量
        addFields("tpv_pickedqty_s", "tpv_materialentry.tpv_flowquantity", "tpv_materialentry.tpv_reperoomqty",
                "(billentry.returnqty+billentry.tpv_pledged)", "0.0", "0.0", "0.0");// 不可配数量（不计溢短）
        addFields("tpv_overfillrate", "tpv_overfillrate", "tpv_materialentry.tpv_overfillrate", "0.0", "0.0", "0.0",
                "0.0");// 溢装率
        addFields("tpv_maxqty", "0.0", "0.0", "0.0", "0.0", "0.0", "0.0");// 最大可配数量
        addFields("tpv_volumenumber", "''", "''", "billentry.tpv_dt_purinbill_j.tpv_reelnumber", "''", "''", "''");// 卷号
        addFields("tpv_vid", "null", "null", "billentry.tpv_dt_purinbill_j", "null", "null", "null");// 卷号分录ID
        addFields("tpv_vqty", "null", "null", "billentry.tpv_dt_purinbill_j.tpv_quantity", "null", "null", "null");// 卷号分录数量
        addFields("tpv_vqtys", "null", "null",
                // 采购入库单卷号分录:【已拣配数量（查表扣减）】+ 【已退库数量】 +【已仓单质押数量】
                "(billentry.tpv_dt_purinbill_j.tpv_returnqtys+billentry.tpv_dt_purinbill_j.tpv_pledgeds)", "null",
                "null", "null");// 卷号分录不可配数量汇总
        addFields("tpv_pickbilltype", "tpv_document", "null", "billtype", "billtype", "billtype", "billtype");// 单据类型
    }

    static {

    }

    private static void addFields(String fieldKey, String fieldKey_bill) {
        fieldKeys_order.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_hwlz.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_purin.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_otherin.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_transin.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_transdir.add(fieldKey_bill + " " + fieldKey);
    }

    private static void addFields(String fieldKey, String fieldKey_bill, String fieldKey_in) {
        fieldKeys_order.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_hwlz.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_purin.add(fieldKey_in + " " + fieldKey);
        fieldKeys_otherin.add(fieldKey_in + " " + fieldKey);
        fieldKeys_transin.add(fieldKey_in + " " + fieldKey);
        fieldKeys_transdir.add(fieldKey_in + " " + fieldKey);
    }

    private static void addFields(String fieldKey, String fieldKey_order, String fieldKey_hwlz, String fieldKey_purin,
                                  String fieldKey_otherin, String fieldKey_transin, String fieldKey_transdir) {
        fieldKeys_order.add(fieldKey_order + " " + fieldKey);
        fieldKeys_hwlz.add(fieldKey_hwlz + " " + fieldKey);
        fieldKeys_purin.add(fieldKey_purin + " " + fieldKey);
        fieldKeys_otherin.add(fieldKey_otherin + " " + fieldKey);
        fieldKeys_transin.add(fieldKey_transin + " " + fieldKey);
        fieldKeys_transdir.add(fieldKey_transdir + " " + fieldKey);
    }

}
