package tpv.tpv_wm.tpv_dt.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

/**
 * 销售价格确认工作台
 *
 * @author longh
 * @description 查询插件
 * @date 2023年9月4日
 */
public class SalePriceRptQuery extends AbstractReportListDataPlugin {
    private static final String algoKey = SalePriceRptQuery.class.getName();
    private static List<String> fieldKeys_order = new ArrayList<>();// 销售合同
    private static List<String> fieldKeys_ship = new ArrayList<>();// 销售发货
    private static List<String> fieldKeys_shipSubEntry = new ArrayList<>();// 销售发货子分录
    private static List<String> fieldKeys_price = new ArrayList<>();// 销售价格确认单

    private static List<String> fieldKeys_orders = new ArrayList<>();// 销售合同
    private static List<String> fieldKeys_ships = new ArrayList<>();// 销售发货
    private static List<String> fieldKeys_prices = new ArrayList<>();// 销售价格确认单

    @Override
    public DataSet query(ReportQueryParam param, Object obj) throws Throwable {
        String whereFilter = createWhereStr(param);
        DataSet instockDataSet = query(whereFilter);
        return instockDataSet;
    }

    public static DataSet query(String whereFilter) {
        DataSet mainDataSet = mainDataSet(whereFilter);
//        Map<Long, String> purcontractnumber = purContractNumber();
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        for (DynamicObject col : col_s) {
//            String tpv_srcbill = col.getString("tpv_srcbill"); //来源单据
//            long tpv_srcbillid = col.getLong("tpv_srcbillid");
//            long tpv_srcentryid = col.getLong("tpv_srcentryid");
//            long tpv_purbillid = col.getLong("tpv_purbillid"); //采购合同单据id
//            long tpv_srcsubid = col.getLong("tpv_srcsubid"); //子分录ID
            BigDecimal tpvQty = col.getBigDecimal("tpv_qty"); //数量
            BigDecimal tpvSubtractqty = col.getBigDecimal("tpv_subtractqty"); //不可确认的数量
            col.set("tpv_qty", tpvQty.subtract(tpvSubtractqty));
//			if (tpv_srcsubid > 0) {
//				col.set("tpv_srcbill","C");
//			}
//            if (tpv_purbillid > 0) {
//                if (purcontractnumber.containsKey(tpv_purbillid)) {
//                    purcontractnumber.entrySet().stream().forEach(x -> {
//                        if (x.getKey().equals(tpv_purbillid)) {
//                            col.set("tpv_purbillno", x.getValue()); //采购合同号
//                        }
//                    });
//                }
//            }
        }

        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        return createDataSet.where("tpv_qty > 0").orderBy(new String[]{"tpv_bizdate desc"});
    }

    private static DataSet mainDataSet(String whereFilter) {
        initAllFields();
        QFilter[] qFilters = new QFilter[]{new QFilter("billstatus", QCP.equals, "C")};
        DataSet tpv_dt_salescontract = ORM.create().queryDataSet(algoKey, "tpv_dt_salescontract",
                String.join(",", fieldKeys_order), qFilters);
        //发货非库存
        QFilter[] qFilterShip = new QFilter[]{new QFilter("billstatus", QCP.equals, "C"),
                new QFilter("tpv_materialentry.tpv_dt_salepick_in",QCP.less_equals,0)};
        DataSet tpv_dt_salesshipping = ORM.create().queryDataSet(algoKey, "tpv_dt_salesshipping",
                String.join(",", fieldKeys_ship), qFilterShip);
        //发货库存
        QFilter[] qFilterShipSubEntry = new QFilter[]{new QFilter("billstatus", QCP.equals, "C")};
        DataSet tpv_dt_salesshippingSubEntry = ORM.create().queryDataSet(algoKey, "tpv_dt_salesshipping",
                String.join(",", fieldKeys_shipSubEntry), qFilterShipSubEntry);
        //价格确认单
        DataSet tpv_dt_salepricebill = ORM.create().queryDataSet(algoKey, "tpv_dt_salepricebill",
                String.join(",", fieldKeys_price), qFilters);

        DataSet dataSet = tpv_dt_salescontract.union(tpv_dt_salesshipping).union(tpv_dt_salesshippingSubEntry).union(tpv_dt_salepricebill);

        DataSet tpv_dt_salescontracts = ORM.create().queryDataSet(algoKey, "tpv_dt_salescontract",
                "id,billno,tpv_upwarddiscount,tpv_pointpricecontract,tpv_pricingperiodt,tpv_postpricingrule,tpv_pricetype,tpv_isvertex,tpv_contractnos tpv_contractno,tpv_strategynum tpv_strategy,tpv_combinationnumber tpv_combination",
                new QFilter[]{new QFilter("billstatus", QCP.equals, "C")});
        dataSet = dataSet.leftJoin(tpv_dt_salescontracts).on("tpv_mainbillid", "id").select(new String[]{"tpv_srcbillid", "tpv_srcentryid", "tpv_srcsubid", "tpv_mainbillid", "tpv_mainentryid",
                "tpv_srcbill", "tpv_srcbillno", "tpv_bizdate", "tpv_org", "tpv_department", "tpv_customer", "tpv_combination", "tpv_strategy", "tpv_contractno", "tpv_isvertex", "tpv_pricetype", "tpv_postpricingrule",
                "tpv_pricingperiodt", "tpv_pointpricecontract", "tpv_upwarddiscount", "tpv_material", "tpv_prodname", "tpv_specation", "tpv_shader", "tpv_origin", "tpv_unit", "tpv_qtys tpv_qty", "tpv_subtractqty", "tpv_taxprice",
                "tpv_guideprice", "tpv_purinno","tpv_purbillno", "tpv_purprice", "tpv_salepricetype", "tpv_saleprice", "tpv_taxfinalprice", "tpv_finalqty", "tpv_taxamtprice"}).finish();
//        DataSet im_purinbill = ORM.create().queryDataSet(algoKey, "im_purinbill", "id,billno,tpv_purcontnum tpv_purbillno", new QFilter[]{new QFilter("billstatus", QCP.equals, "C")});
//        dataSet = dataSet.leftJoin(im_purinbill).on("tpv_purinno", "billno").select(new String[]{"tpv_srcbillid", "tpv_srcentryid", "tpv_srcsubid", "tpv_mainbillid", "tpv_mainentryid",
//                "tpv_srcbill", "tpv_srcbillno", "tpv_bizdate", "tpv_org", "tpv_department", "tpv_customer", "tpv_combination", "tpv_strategy", "tpv_contractno", "tpv_isvertex", "tpv_pricetype", "tpv_postpricingrule",
//                "tpv_pricingperiodt", "tpv_pointpricecontract", "tpv_upwarddiscount", "tpv_material", "tpv_prodname", "tpv_specation", "tpv_shader", "tpv_origin", "tpv_unit", "tpv_qtys tpv_qty", "tpv_subtractqty", "tpv_taxprice",
//                "tpv_guideprice", "tpv_purbillno", "tpv_purinno", "tpv_purprice", "tpv_salepricetype", "tpv_saleprice", "tpv_taxfinalprice", "tpv_finalqty", "tpv_taxamtprice"}).finish();

        if (YEM.isNotEmpty(whereFilter)) {
            dataSet = dataSet.where(whereFilter);
        }

        return dataSet;
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        // 公司
        DynamicObject tpv_org_f = filterInfo.getDynamicObject("tpv_org_f");
        if (YEM.isNotEmpty(tpv_org_f)) {
            whereFilter = String.format("%s and tpv_org = %s", whereFilter, tpv_org_f.getPkValue());
        }
        // 组合号
        DynamicObject tpv_combination_f = filterInfo.getDynamicObject("tpv_combination_f");
        if (YEM.isNotEmpty(tpv_combination_f)) {
            whereFilter = String.format("%s and tpv_combination = %s", whereFilter, tpv_combination_f.getPkValue());
        }
        // 来源单据
        String tpv_srcbill_f = filterInfo.getString("tpv_srcbill_f");
        if (YEM.isNotEmpty(tpv_srcbill_f)) {
            whereFilter = String.format("%s and tpv_srcbill like '%%%s%%' %s", whereFilter, tpv_srcbill_f);
        }
        // 来源单据号
        String tpv_srcbillno_f = filterInfo.getString("tpv_srcbillno_f");
        if (YEM.isNotEmpty(tpv_srcbillno_f)) {
            whereFilter = String.format("%s and tpv_srcbillno like '%%%s%%' %s", whereFilter, tpv_srcbillno_f);
        }
        // 合同号
        String tpv_contractno_f = filterInfo.getString("tpv_contractno_f");
        if (YEM.isNotEmpty(tpv_contractno_f)) {
            whereFilter = String.format("%s and LOWER(tpv_contractno) LIKE LOWER('%%%s%%') %s", whereFilter, tpv_contractno_f);
        }
        // 客户
        DynamicObject tpv_customer_f = filterInfo.getDynamicObject("tpv_customer_f");
        if (YEM.isNotEmpty(tpv_customer_f)) {
            whereFilter = String.format("%s and tpv_customer = %s", whereFilter, tpv_customer_f.getPkValue());
        }
        // 部门
        DynamicObject tpv_department_f = filterInfo.getDynamicObject("tpv_department_f");
        if (YEM.isNotEmpty(tpv_department_f)) {
            whereFilter = String.format("%s and tpv_department = %s", whereFilter, tpv_department_f.getPkValue());
        }
        // 显示价格确认
        Boolean tpv_issaleprice_f = filterInfo.getBoolean("tpv_issaleprice_f");
        if (tpv_issaleprice_f) {
            whereFilter = String.format("%s and tpv_srcbill != 'D'", whereFilter);
        }
        //来源单据 多选下拉
        String tpvSrcbillF2 = (String) filterInfo.getValue("tpv_srcbill_f2");
        if (YEM.isNotEmpty(tpvSrcbillF2)) {
            String substring = tpvSrcbillF2.replace(",", "");
            String[] split = substring.split("");
            List<String> strings = new ArrayList<>();
            Arrays.stream(split).forEach(x -> {
                String s = "'" + x + "'";
                strings.add("" + s + "");
            });
            whereFilter = String.format("%s and tpv_srcbill in (%s)", whereFilter, String.join(",", strings));
        }
        return whereFilter;
    }

    private static void initAllFields() {
        fieldKeys_order.clear();
        fieldKeys_ship.clear();
        fieldKeys_shipSubEntry.clear();
        fieldKeys_price.clear();
        addFields("tpv_srcbillid", "id");// 来源单据ID
        addFields("tpv_srcentryid", "tpv_materialentry");// 来源单据分录ID
        addFields("tpv_srcsubid", "0l", "0l", "tpv_materialentry.tpv_dt_salepick_in", "0l");// 来源单据子分录ID
        addFields("tpv_mainbillid", "id", "tpv_materialentry.tpv_cobillid","tpv_materialentry.tpv_cobillid", "tpv_materialentry.tpv_cobillid");// 销售合同ID
        addFields("tpv_mainentryid", "tpv_materialentry", "tpv_materialentry.tpv_coentryid","tpv_materialentry.tpv_coentryid",
                "tpv_materialentry.tpv_coentryid");// 销售合同分录ID
        addFields("tpv_srcbill", "'A'", "'B'","'C'", "'D'");// 来源单据
        addFields("tpv_srcbillno", "billno");// 来源单据号
        addFields("tpv_bizdate", "tpv_bizdate");// 业务日期
        addFields("tpv_org", "org");// 公司
        addFields("tpv_department", "tpv_department");// 部门
        addFields("tpv_customer", "tpv_customer");// 客户
//		addFields("tpv_combination", "tpv_combinationnumber", "tpv_combina", "tpv_combina");// 组合号
//		addFields("tpv_strategy", "tpv_strategynum", "tpv_policyber", "tpv_policyber");// 策略号
//		addFields("tpv_contractno", "tpv_contractnos", "tpv_contractnumber", "tpv_contractnumber");// 合同号
//		addFields("tpv_isvertex", "tpv_isvertex", "null", "tpv_isvertex");// 是否点价
//		addFields("tpv_pricetype", "tpv_pricetype", "tpv_pricingtypes", "tpv_pricetype");// 定价类型
//		addFields("tpv_postpricingrule", "tpv_postpricingrule", "null", "tpv_postpricingrule");// 后定价规则
//		addFields("tpv_pricingperiodt", "tpv_pricingperiodt", "null", "tpv_pricingperiodt");// 点价期限
//		addFields("tpv_pointpricecontract", "tpv_pointpricecontract", "null", "tpv_pointpricecontract");// 点价合约
//		addFields("tpv_upwarddiscount", "tpv_upwarddiscount", "0.0", "tpv_upwarddiscount");// 升贴水
        addFields("tpv_material", "tpv_materialentry.tpv_material","tpv_materialentry.tpv_material","tpv_materialentry.tpv_dt_salepick_in.tpv_material_in","tpv_materialentry.tpv_material");// 商品名称
        addFields("tpv_prodname", "tpv_materialentry.tpv_prodname","tpv_materialentry.tpv_prodname","tpv_materialentry.tpv_dt_salepick_in.tpv_prodname_in","tpv_materialentry.tpv_prodname");// 品名
        addFields("tpv_specation", "tpv_materialentry.tpv_specation","tpv_materialentry.tpv_specation","tpv_materialentry.tpv_dt_salepick_in.tpv_specation_in","tpv_materialentry.tpv_specation");// 规格
        addFields("tpv_shader", "tpv_materialentry.tpv_shader","tpv_materialentry.tpv_shader","tpv_materialentry.tpv_dt_salepick_in.tpv_shader_in","tpv_materialentry.tpv_shader");// 材质
        addFields("tpv_origin", "tpv_materialentry.tpv_origin","tpv_materialentry.tpv_origin","tpv_materialentry.tpv_dt_salepick_in.tpv_origin_in","tpv_materialentry.tpv_origin");// 产地
        addFields("tpv_unit", "tpv_materialentry.tpv_unit","tpv_materialentry.tpv_unit","tpv_materialentry.tpv_dt_salepick_in.tpv_measure","tpv_materialentry.tpv_unit");// 计量单位
        addFields("tpv_qtys", "tpv_materialentry.tpv_effectivequantity", "tpv_materialentry.tpv_qty","tpv_materialentry.tpv_dt_salepick_in.tpv_pickqty_in",
                "tpv_materialentry.tpv_qty_final");// 数量
        addFields("tpv_subtractqty", "tpv_materialentry.tpv_conprice+tpv_materialentry.tpv_shippedquantity-tpv_materialentry.tpv_iscargobatchqty"
                , "tpv_materialentry.tpv_confirmed + tpv_materialentry.tpv_cargobatchqty","tpv_materialentry.tpv_dt_salepick_in.tpv_thequantity + tpv_materialentry.tpv_cargobatchqty"
                , "0.0");// 不可确认的数量
        addFields("tpv_taxprice", "tpv_materialentry.tpv_taxprice");// 原单含税单价
        addFields("tpv_guideprice", "tpv_materialentry.tpv_salesguideprice", "tpv_materialentry.tpv_thirdpartyprice","tpv_materialentry.tpv_thirdpartyprice",
                "0.0");// 销售指导价
//		addFields("tpv_purbillno", "''");// 采购合同号
        addFields("tpv_purinno", "''", "''","tpv_materialentry.tpv_dt_salepick_in.tpv_billno_in", "''");// 入库单号
        addFields("tpv_purbillno", "''", "''","tpv_materialentry.tpv_dt_salepick_in.tpv_contractmark", "''");// 合同号
        addFields("tpv_purprice", "0.0");// 采购作价（采购确认价格）
        addFields("tpv_salepricetype", "''");// 销售作价类型
        addFields("tpv_saleprice", "''");// 销售作价
        addFields("tpv_taxfinalprice", "0.0", "0.0","0.0", "tpv_materialentry.tpv_taxprice_final");// 销售确认单价
        addFields("tpv_finalqty", "0.0", "0.0","0.0", "tpv_materialentry.tpv_qty_final");// 销售确认数量
        addFields("tpv_taxamtprice", "0.0", "0.0","0.0", "tpv_materialentry.tpv_taxamt_final");// 销售确认价格
//		addFields("tpv_purbillid", "0l","tpv_materialentry.tpv_dt_salepick_in.tpv_fid_in","0l");// 采购单据ID
    }

    static {

    }

    private static void addFields(String fieldKey, String fieldKey_bill) {
        fieldKeys_order.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_ship.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_shipSubEntry.add(fieldKey_bill + " " + fieldKey);
        fieldKeys_price.add(fieldKey_bill + " " + fieldKey);
    }

    private static void addFields(String fieldKey, String fieldKey_order, String fieldKey_ship,String fieldKey_shipSubEntry, String fieldKey_price) {
        fieldKeys_order.add(fieldKey_order + " " + fieldKey);
        fieldKeys_ship.add(fieldKey_ship + " " + fieldKey);
        fieldKeys_shipSubEntry.add(fieldKey_shipSubEntry + " " + fieldKey);
        fieldKeys_price.add(fieldKey_price + " " + fieldKey);
    }

}
