package tpv.tpv_wm.tpv_dt.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import scala.annotation.meta.param;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

/**
 * @ClassName: StatemenFundsRptQuery
 * @Description: 资金明细表
 * @author: zbh
 * @date: 2024-06-11
 */
public class StatemenFundsRptQuery extends AbstractReportListDataPlugin {
    private static final String algoKey = StatemenFundsRptQuery.class.getName();

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        String whereFilter = createWhereStr(param);
        DataSet instockDataSet = query(whereFilter, param);
        return instockDataSet;
    }

    public static DataSet query(String whereFilter, ReportQueryParam param) {
        DataSet mainDataSet = mainDataSet().where(whereFilter);

        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        return createDataSet;
    }

    public static DataSet mainDataSet() {

        DataSet tpvDtSalescontract = ORM.create().queryDataSet(algoKey, "tpv_dt_salescontract", "id,tpv_combinationnumber tpv_comstrings,tpv_contractnos tpv_saleconumhb,tpv_customer tpv_clienthb,tpv_signingdate", null);
        DataSet tpvDtPurchase =ORM.create().queryDataSet(algoKey, "tpv_dt_purchase","id,tpv_combinationnumber tpv_comstrings,tpv_contractnumber tpv_purconumhb,tpv_supplier tpv_vendorhb,tpv_dateofcontracting tpv_purcdate",null);
        DataSet tpvBdCombination = ORM.create().queryDataSet(algoKey, "tpv_bd_combination", "id,tpv_splitdepartment.tpv_departmententry tpv_condepartment,tpv_splitdepartment.tpv_apercentage tpv_conpro,name tpv_comstring", null);

        DataSet tpvBdCombinationRe = tpvBdCombination.copy();

//        tpvDtSalescontract=tpvDtSalescontract.leftJoin(tpvBdCombination).on("tpv_comstring","id").select(new String[]{"tpv_comstring","tpv_saleconumhb","tpv_clienthb","tpv_signingdate","tpv_condepartment","tpv_conpro"}).finish();


        DataSet tpvDtSalescontractRe = tpvDtSalescontract.copy();
        DataSet tpvDtPurchaseRe = tpvDtPurchase.copy();

        DataSet casRecbill = ORM.create().queryDataSet(algoKey, "cas_recbill",
                "shkd_dept tpv_department,entry.shkd_salecontract salecontract,billno tpv_recbill,bizdate tpv_recbilldate,payername tpv_customer," +
                        "currency tpv_currency,shkd_rmbamount tpv_countamountrmb,actrecamt tpv_countamount,entry.shkd_purcontract purcontract,'A' tpv_cerep,'' tpv_paybill,'' tpv_payeename",
                null);//收款处理

        casRecbill = casRecbill.leftJoin(tpvDtSalescontract).on("salecontract", "id").select(new String[]{"tpv_department", "tpv_recbill", "tpv_recbilldate","tpv_paybill","tpv_payeename", "tpv_customer", "tpv_currency", "tpv_countamountrmb", "tpv_countamount",
                "tpv_comstrings", "tpv_saleconumhb","tpv_clienthb","tpv_signingdate","tpv_cerep","purcontract"}).finish();

        casRecbill=casRecbill.leftJoin(tpvDtPurchase).on("purcontract","id").select(new String[]{"tpv_department", "tpv_recbill", "tpv_recbilldate","tpv_paybill","tpv_payeename", "tpv_customer", "tpv_currency", "tpv_countamountrmb", "tpv_countamount",
                "tpv_comstrings", "tpv_saleconumhb","tpv_clienthb","tpv_signingdate","tpv_cerep","tpv_purconumhb","tpv_vendorhb","tpv_purcdate"}).finish();

        casRecbill=casRecbill.leftJoin(tpvBdCombination).on("tpv_comstrings","id").select(new String[]{"tpv_department", "tpv_recbill", "tpv_recbilldate","tpv_paybill","tpv_payeename", "tpv_customer", "tpv_currency", "tpv_countamountrmb", "tpv_countamount",
               "tpv_saleconumhb","tpv_clienthb","tpv_signingdate","tpv_cerep","tpv_purconumhb","tpv_vendorhb","tpv_purcdate","tpv_condepartment","tpv_conpro","tpv_comstring","tpv_conpro*tpv_countamount/100 tpv_conamount"}).finish();

        DataSet casPaybill =ORM.create().queryDataSet(algoKey,"cas_paybill",
                "shkd_dept tpv_department,entry.shkd_salecontract salecontract,billno tpv_paybill,bizdate tpv_recbilldate,payeename tpv_payeename,"+
                 "currency tpv_currency,shkd_rmbamount tpv_countamountrmb,actpayamt tpv_countamount,entry.shkd_purcontract purcontract,'B' tpv_cerep,'' tpv_recbill,'' tpv_customer",
                null);//付款处理

        casPaybill=casPaybill.leftJoin(tpvDtSalescontractRe).on("salecontract","id").select(new String[]{"tpv_department","tpv_paybill", "tpv_recbill","tpv_payeename", "tpv_recbilldate", "tpv_customer", "tpv_currency", "tpv_countamountrmb", "tpv_countamount",
                "tpv_comstrings", "tpv_saleconumhb","tpv_clienthb","tpv_signingdate","tpv_cerep","purcontract"}).finish();

        casPaybill=casPaybill.leftJoin(tpvDtPurchaseRe).on("purcontract","id").select(new String[]{"tpv_department", "tpv_recbill", "tpv_recbilldate","tpv_paybill","tpv_payeename", "tpv_customer", "tpv_currency", "tpv_countamountrmb", "tpv_countamount",
                "tpv_comstrings", "tpv_saleconumhb","tpv_clienthb","tpv_signingdate","tpv_cerep","tpv_purconumhb","tpv_vendorhb","tpv_purcdate"}).finish();

        casPaybill=casPaybill.leftJoin(tpvBdCombinationRe).on("tpv_comstrings","id").select(new String[]{"tpv_department", "tpv_recbill", "tpv_recbilldate","tpv_paybill","tpv_payeename", "tpv_customer", "tpv_currency", "tpv_countamountrmb", "tpv_countamount",
                "tpv_saleconumhb","tpv_clienthb","tpv_signingdate","tpv_cerep","tpv_purconumhb","tpv_vendorhb","tpv_purcdate","tpv_condepartment","tpv_conpro","tpv_comstring","tpv_conpro*tpv_countamount/100 tpv_conamount"}).finish();

        DataSet repay = casRecbill.union(casPaybill);

        return repay;
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        DynamicObject tpvRepdep = filterInfo.getDynamicObject("tpv_repdep");//业务部门
        if (tpvRepdep!=null){
            whereFilter = String.format("%s and tpv_department = %s", whereFilter, tpvRepdep.getPkValue());
        }
        DynamicObject tpvCondep = filterInfo.getDynamicObject("tpv_condep");//分成部门
        if (tpvCondep!=null){
            whereFilter = String.format("%s and tpv_condepartment = %s", whereFilter, tpvCondep.getPkValue());
        }
        String tpvConbation = filterInfo.getString("tpv_conbation");//计奖卡号
        if (YEM.isNotEmpty(tpvConbation)){
            whereFilter = String.format("%s and tpv_comstring like '%%%s%%'", whereFilter, tpvConbation);
        }
        String tpvSalenumber = filterInfo.getString("tpv_salenumber");//销售合同
        if (YEM.isNotEmpty(tpvSalenumber)){
            whereFilter = String.format("%s and tpv_saleconumhb like '%%%s%%'", whereFilter, tpvSalenumber);
        }
        DynamicObject tpvCustom = filterInfo.getDynamicObject("tpv_custom");//销售客户
        if (tpvCustom!=null){
            whereFilter = String.format("%s and tpv_clienthb = %s", whereFilter, tpvCustom.getPkValue());
        }
        String tpvPurnumber = filterInfo.getString("tpv_purnumber");//采购合同
        if (YEM.isNotEmpty(tpvPurnumber)){
            whereFilter = String.format("%s and tpv_purconumhb like '%%%s%%'", whereFilter, tpvPurnumber);
        }
        DynamicObject tpvSupplier = filterInfo.getDynamicObject("tpv_supplier");//供应商
        if (tpvSupplier!=null){
            whereFilter = String.format("%s and tpv_vendorhb = %s", whereFilter, tpvSupplier.getPkValue());
        }
        String tpvCere = filterInfo.getString("tpv_cere");//收付方向
        if (YEM.isNotEmpty(tpvCere)){
            whereFilter = String.format("%s and tpv_cerep like '%%%s%%'", whereFilter, tpvCere);
        }
        String tpvPay = filterInfo.getString("tpv_pay");//付款单号
        if (YEM.isNotEmpty(tpvPay)){
            whereFilter = String.format("%s and tpv_paybill like '%%%s%%'", whereFilter, tpvPay);
        }
        String tpvRec = filterInfo.getString("tpv_rec");//收款单号
        if (YEM.isNotEmpty(tpvRec)){
            whereFilter = String.format("%s and tpv_recbill like '%%%s%%'", whereFilter, tpvRec);
        }
        Date tpvStart = filterInfo.getDate("tpv_start");//收款日期从
        if (tpvStart!=null){
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvStart);
            whereFilter = String.format("%s and tpv_recbilldate >= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        Date tpvEnd = filterInfo.getDate("tpv_end");//收款日期到
        if (tpvStart!=null){
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String format = str.format(tpvEnd);
            whereFilter = String.format("%s and tpv_recbilldate >= to_date('" + format + "','yyyy-MM-dd HH:mm:ss') ", whereFilter);
        }
        DynamicObject tpvCur = filterInfo.getDynamicObject("tpv_cur");//币种
        if (tpvCur!=null){
            whereFilter = String.format("%s and tpv_currency = %s", whereFilter, tpvCur.getPkValue());
        }
        boolean tpvOndep = filterInfo.getBoolean("tpv_ondep");//仅看需跨部门分成
        if (tpvOndep){
            whereFilter = String.format("%s and tpv_condepartment <> %s", whereFilter,
                    String.join(",", "tpv_department"));
        }
        return whereFilter;
    }
}
