package tpv.tpv_wm.tpv_dt.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import tpv.tpv_wm.tpv_cm.java.utils.CostDisposeRptUtils;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.util.*;

/**
 * @ClassName: UnderaChievementRptQuery
 * @Description: 销售未达表
 * @author: zbh
 * @date: 2024-05-18
 */
public class UnderaChievementRptQuery extends AbstractReportListDataPlugin {
    private static final String algoKey = UnderaChievementRptQuery.class.getName();

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        String whereFilter = createWhereStr(param);
        DataSet instockDataSet = query(whereFilter);
        return instockDataSet;
    }


    public static DataSet query(String whereFilter) {
        DataSet mainDataSet = mainDataSet(whereFilter);
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        return createDataSet;
    }

    private static DataSet mainDataSet(String whereFilter) {
//        QFilter qFilters_1 = new QFilter("billstatus", QCP.equals, "C");
        String selectfields = "billstatus tpv_billstatus,tpv_materialentry.tpv_dt_salepick_in.id saleid,tpv_isstrandpick tpv_loansign,tpv_whether,tpv_company," +
                "tpv_department,tpv_operator,creator tpv_creater,tpv_bizdate,billno tpv_billno,tpv_billtype,tpv_customer,tpv_contractnumber,tpv_reward,tpv_sourcebillid," +
                "tpv_materialentry.tpv_dt_salepick_in.tpv_billno_in tpv_billno_zy,tpv_materialentry.tpv_dt_salepick_in.tpv_pickbill_in tpv_pickbill," +
                "tpv_materialentry.tpv_dt_salepick_in.tpv_invoiceqty tpv_invoiceqty,tpv_materialentry.tpv_dt_salepick_in.tpv_pickqty_in tpv_pickqty_in," +
                "tpv_materialentry.tpv_dt_salepick_in.tpv_taxprice_in tpv_taxprice_in,tpv_materialentry.tpv_dt_salepick_in.tpv_contractmark tpv_contractmark," +
                "tpv_materialentry.tpv_dt_salepick_in.tpv_warehouse_in tpv_warehouse_zy,tpv_materialentry.tpv_dt_salepick_in.tpv_prodname_in tpv_prodname," +
                "tpv_materialentry.tpv_dt_salepick_in.tpv_specation_in tpv_specation_in,tpv_materialentry.tpv_dt_salepick_in.tpv_shader_in tpv_shader_in," +
                "tpv_materialentry.tpv_dt_salepick_in.tpv_origin_in.name tpv_origin_in,tpv_materialentry.tpv_dt_salepick_in.tpv_material_in tpv_material_in," +
                "tpv_currency," +
                "tpv_materialentry.tpv_dt_salepick_in.tpv_invoiceamt tpv_invoicedam_zy,tpv_materialentry.tpv_vatrates tpv_vatrates," +
                "tpv_materialentry.tpv_dt_salepick_in.tpv_taxpramount_in tpv_taxpramount_in,tpv_exchangeratermb,tpv_materialentry.tpv_dt_salepick_in.tpv_fentryid_in tpv_fentryid_in";
        DataSet tpvDtSalesshipping = ORM.create().queryDataSet(algoKey, "tpv_dt_salesshipping", selectfields, null);//已开票和未开票的
        tpvDtSalesshipping = tpvDtSalesshipping.groupBy(new String[]{"tpv_billstatus", "tpv_loansign", "tpv_whether",
                        "tpv_company", "tpv_department", "tpv_operator", "tpv_creater", "tpv_bizdate", "tpv_billno", "tpv_billtype", "tpv_customer", "tpv_contractnumber", "tpv_reward",
                        "tpv_billno_zy", "tpv_pickbill", "'A' tpv_identification", "tpv_invoiceqty tpv_pickqty_zy", "tpv_taxprice_in tpv_taxprice_zy", "tpv_sourcebillid", "saleid"
                        , "tpv_contractmark", "tpv_warehouse_zy", "tpv_prodname", "tpv_specation_in", "tpv_shader_in", "tpv_origin_in", "tpv_material_in", "tpv_currency", "tpv_currency tpv_currencycb",
                        "tpv_taxpramount_in-tpv_invoicedam_zy tpv_invoicedam_zy", "tpv_taxprice_in-tpv_taxprice_in*tpv_vatrates/100 tpv_taxprice", "(tpv_taxpramount_in-tpv_invoicedam_zy)-(tpv_taxpramount_in-tpv_invoicedam_zy)*tpv_vatrates/100 tpv_invoicedam",
                        "tpv_exchangeratermb", "tpv_fentryid_in","tpv_vatrates"})
                .groupConcat("concat(tpv_origin_in,tpv_shader_in,tpv_specation_in)", "tpv_materialdes").finish();
        DataSet tpvDtSales = ORM.create().queryDataSet(algoKey, "tpv_dt_salesshipping", selectfields,
                new QFilter[]{new QFilter("tpv_materialentry.tpv_dt_salepick_in.tpv_invoiceqty", ">", 0)});//剩余未开票的
        tpvDtSales = tpvDtSales.groupBy(new String[]{"tpv_billstatus", "tpv_loansign", "tpv_whether",
                        "tpv_company", "tpv_department", "tpv_operator", "tpv_creater", "tpv_bizdate", "tpv_billno", "tpv_billtype", "tpv_customer", "tpv_contractnumber", "tpv_reward",
                        "tpv_billno_zy", "tpv_pickbill", "'B' tpv_identification", "tpv_pickqty_in-tpv_invoiceqty tpv_pickqty_zy",
                        "(case when tpv_pickqty_in-tpv_invoiceqty=0 then 0 else tpv_taxprice_in/(tpv_pickqty_in-tpv_invoiceqty) end) tpv_taxprice_zy",
                        "tpv_sourcebillid", "saleid", "tpv_contractmark", "tpv_warehouse_zy", "tpv_prodname", "tpv_specation_in", "tpv_shader_in", "tpv_origin_in",
                        "tpv_material_in", "tpv_currency", "tpv_currency tpv_currencycb", "tpv_invoicedam_zy", "(case when tpv_pickqty_in-tpv_invoiceqty=0 then 0 else tpv_taxprice_in/(tpv_pickqty_in-tpv_invoiceqty) end)-(case when tpv_pickqty_in-tpv_invoiceqty=0 then 0 else tpv_taxprice_in/(tpv_pickqty_in-tpv_invoiceqty) end)*tpv_vatrates/100 tpv_taxprice",
                        "tpv_invoicedam_zy-tpv_invoicedam_zy*tpv_vatrates/100 tpv_invoicedam", "tpv_exchangeratermb", "tpv_fentryid_in","tpv_vatrates"})
                .groupConcat("concat(tpv_origin_in,tpv_shader_in,tpv_specation_in)", "tpv_materialdes").finish();
        tpvDtSalesshipping = tpvDtSalesshipping.union(tpvDtSales);
        DataSet tpvDtSalescontract = ORM.create().queryDataSet(algoKey, "tpv_dt_salescontract", "id tpv_salenumber,tpv_settlementstatus,tpv_combinationnumber tpv_combination", null);
        tpvDtSalesshipping = tpvDtSalesshipping.leftJoin(tpvDtSalescontract).on("tpv_sourcebillid", "tpv_salenumber").select("tpv_billstatus", "tpv_loansign", "tpv_whether",
                "tpv_company", "tpv_department", "tpv_operator", "tpv_creater", "tpv_bizdate", "tpv_billno", "tpv_billtype", "tpv_customer", "tpv_contractnumber", "tpv_reward",
                "tpv_billno_zy", "tpv_identification","tpv_pickbill", "(case when saleid=0 then false else true end) tpv_collocation", "tpv_combination", "tpv_settlementstatus"
                , "tpv_contractmark", "tpv_warehouse_zy", "tpv_prodname", "tpv_materialdes", "tpv_material_in", "tpv_currency", "tpv_currencycb", "tpv_invoicedam_zy",
                "tpv_taxprice", "tpv_invoicedam", "tpv_exchangeratermb", "tpv_taxprice_zy", "tpv_fentryid_in","tpv_vatrates","tpv_pickqty_zy","tpv_salenumber").finish();

        DataSet imPurinbill = ORM.create().queryDataSet(algoKey, "im_purinbill", "billno,supplier tpv_supplier_zy", null);
        tpvDtSalesshipping = tpvDtSalesshipping.leftJoin(imPurinbill).on("tpv_billno_zy", "billno").select(new String[]{"tpv_billstatus", "tpv_loansign", "tpv_whether",
                "tpv_company", "tpv_department", "tpv_identification","tpv_operator", "tpv_creater", "tpv_bizdate", "tpv_billno", "tpv_billtype", "tpv_customer", "tpv_contractnumber", "tpv_reward",
                "tpv_billno_zy", "tpv_pickbill","tpv_pickqty_zy", "tpv_collocation", "tpv_combination", "tpv_settlementstatus", "tpv_contractmark", "tpv_supplier_zy", "tpv_warehouse_zy",
                "tpv_prodname", "tpv_materialdes", "tpv_material_in", "tpv_currency", "tpv_currencycb", "tpv_invoicedam_zy", "tpv_taxprice", "tpv_invoicedam", "tpv_exchangeratermb",
                "tpv_taxprice_zy", "tpv_fentryid_in","tpv_vatrates","tpv_salenumber"}).finish();
        DataSet tpvDtPurchase = ORM.create().queryDataSet(algoKey, "tpv_dt_purchase", "tpv_contractnumber,tpv_typeofreward,tpv_contractstatusx,tpv_combinationnumber tpv_combination_in", null);
        tpvDtSalesshipping = tpvDtSalesshipping.leftJoin(tpvDtPurchase).on("tpv_contractmark", "tpv_contractnumber").select("tpv_billstatus", "tpv_loansign", "tpv_whether",
                "tpv_company", "tpv_department","tpv_identification", "tpv_operator", "tpv_creater", "tpv_bizdate", "tpv_billno", "tpv_billtype", "tpv_customer", "tpv_contractnumber", "tpv_reward",
                "tpv_billno_zy", "tpv_pickbill", "tpv_pickqty_zy","tpv_collocation", "tpv_combination", "tpv_settlementstatus", "tpv_contractmark", "tpv_supplier_zy", "tpv_typeofreward", "tpv_contractstatusx",
                "tpv_combination_in", "tpv_warehouse_zy", "tpv_prodname", "tpv_materialdes", "tpv_material_in", "tpv_currency", "tpv_currencycb", "tpv_invoicedam_zy", "tpv_taxprice",
                "tpv_invoicedam", "tpv_exchangeratermb", "tpv_taxprice_zy", "tpv_fentryid_in","tpv_vatrates","tpv_salenumber").finish();
        DataSet materialgroupdetail = ORM.create().queryDataSet(algoKey, "bd_materialgroupdetail", "material,group tpv_materialname",
                null);//物料分类标准页签
        tpvDtSalesshipping = tpvDtSalesshipping.leftJoin(materialgroupdetail).on("tpv_material_in", "material").select(new String[]{"tpv_billstatus", "tpv_loansign", "tpv_whether",
                "tpv_company", "tpv_department", "tpv_identification","tpv_operator", "tpv_creater", "tpv_bizdate", "tpv_billno", "tpv_billtype", "tpv_customer", "tpv_contractnumber", "tpv_reward",
                "tpv_billno_zy", "tpv_pickbill", "tpv_pickqty_zy","tpv_collocation", "tpv_combination", "tpv_settlementstatus", "tpv_contractmark", "tpv_supplier_zy", "tpv_typeofreward", "tpv_contractstatusx",
                "tpv_combination_in", "tpv_warehouse_zy", "tpv_prodname", "tpv_materialdes", "tpv_materialname", "tpv_currency", "tpv_currencycb", "tpv_invoicedam_zy", "tpv_taxprice",
                "tpv_invoicedam", "tpv_taxprice_zy", "tpv_exchangeratermb*tpv_taxprice_zy tpv_includingtax", "tpv_exchangeratermb*tpv_invoicedam_zy tpv_amounttax", "tpv_exchangeratermb*tpv_taxprice tpv_unincludingtax",
                "tpv_exchangeratermb*tpv_invoicedam tpv_unamounttax", "tpv_fentryid_in","tpv_vatrates","tpv_salenumber"}).finish();

        //成本类型为货值的id
        DynamicObject expenseitemedit = BusinessDataServiceHelper.loadSingle("er_expenseitemedit", new QFilter[]{new QFilter("name", "=", "货值")});
        DataSet costsumrpt = CostDisposeRptUtils.getCostSummaryData(new ArrayList<>(), 0L, expenseitemedit == null ? 0L : expenseitemedit.getLong("id"), 0L)
                .groupBy(new String[]{"tpv_storageid"}).sum("tpv_sumorigprice").sum("tpv_sumbasprice").finish();//成本汇总表
        costsumrpt=costsumrpt.addField("Cast(tpv_storageid as Long) tpv_storage", "tpv_storage");
        tpvDtSalesshipping = tpvDtSalesshipping.leftJoin(costsumrpt).on("tpv_fentryid_in", "tpv_storage").select(new String[]{"tpv_billstatus", "tpv_loansign", "tpv_whether",
                "tpv_company", "tpv_department", "tpv_identification","tpv_operator", "tpv_creater", "tpv_bizdate", "tpv_billno", "tpv_billtype", "tpv_customer", "tpv_contractnumber", "tpv_reward",
                "tpv_billno_zy", "tpv_pickbill", "tpv_pickqty_zy","tpv_collocation", "tpv_combination", "tpv_settlementstatus", "tpv_contractmark", "tpv_supplier_zy", "tpv_typeofreward", "tpv_contractstatusx",
                "tpv_combination_in", "tpv_warehouse_zy", "tpv_prodname", "tpv_materialdes", "tpv_materialname", "tpv_currency", "tpv_currencycb", "tpv_invoicedam_zy", "tpv_taxprice",
                "tpv_invoicedam", "tpv_taxprice_zy", "tpv_includingtax", "tpv_amounttax", "tpv_unincludingtax", "tpv_unamounttax", "tpv_fentryid_in", "tpv_sumorigprice tpv_taxprice_cb",
                "tpv_sumbasprice tpv_includingtax_cb", "tpv_sumorigprice*tpv_pickqty_zy tpv_invoicedam_cb", "tpv_sumbasprice-tpv_sumbasprice*tpv_vatrates/100 tpv_taxpricecb", "tpv_sumorigprice*tpv_pickqty_zy-tpv_sumorigprice*tpv_pickqty_zy*tpv_vatrates/100 tpv_invoicedamcb",
                "tpv_sumbasprice*tpv_pickqty_zy tpv_amounttax_cb","tpv_sumbasprice-tpv_sumbasprice*tpv_vatrates/100 tpv_unincludingtax_cb","tpv_sumbasprice*tpv_pickqty_zy-tpv_sumbasprice*tpv_pickqty_zy*tpv_vatrates/100 tpv_unamounttax_cb","tpv_salenumber"}).finish();
        tpvDtSalesshipping = tpvDtSalesshipping.groupBy(new String[]{"tpv_billstatus", "tpv_loansign", "tpv_whether",
                "tpv_company", "tpv_department", "tpv_identification","tpv_operator", "tpv_creater", "tpv_bizdate", "tpv_billno", "tpv_billtype", "tpv_customer", "tpv_contractnumber", "tpv_reward",
                "tpv_billno_zy", "tpv_pickbill","tpv_pickqty_zy", "tpv_collocation", "tpv_combination", "tpv_settlementstatus", "tpv_contractmark", "tpv_supplier_zy", "tpv_typeofreward", "tpv_contractstatusx",
                "tpv_combination_in", "tpv_warehouse_zy", "tpv_prodname", "tpv_materialdes", "tpv_materialname", "tpv_currency", "tpv_currencycb", "tpv_invoicedam_zy", "tpv_taxprice",
                "tpv_invoicedam", "tpv_taxprice_zy", "tpv_includingtax", "tpv_amounttax", "tpv_unincludingtax", "tpv_unamounttax", "tpv_fentryid_in", "tpv_taxprice_cb",
                "tpv_includingtax_cb", "tpv_invoicedam_cb", "tpv_taxpricecb", "tpv_invoicedamcb","tpv_amounttax_cb","tpv_unincludingtax_cb","tpv_unamounttax_cb","tpv_unamounttax-tpv_unamounttax_cb tpv_profit","tpv_salenumber"}).finish();
        DataSet bosBilltype = ORM.create().queryDataSet(algoKey, "bos_billtype", "id,name tpv_typename", null);
        tpvDtSalesshipping=tpvDtSalesshipping.leftJoin(bosBilltype).on("tpv_billtype","id").select(new String[]{"tpv_billstatus", "tpv_loansign", "tpv_whether",
                "tpv_company", "tpv_department", "tpv_identification","tpv_operator", "tpv_creater", "tpv_bizdate", "tpv_billno", "tpv_customer", "tpv_contractnumber", "tpv_reward",
                "tpv_billno_zy", "tpv_pickbill","tpv_pickqty_zy", "tpv_collocation", "tpv_combination", "tpv_settlementstatus", "tpv_contractmark", "tpv_supplier_zy", "tpv_typeofreward", "tpv_contractstatusx",
                "tpv_combination_in", "tpv_warehouse_zy", "tpv_prodname", "tpv_materialdes", "tpv_materialname", "tpv_currency", "tpv_currencycb", "tpv_invoicedam_zy", "tpv_taxprice",
                "tpv_invoicedam", "tpv_taxprice_zy", "tpv_includingtax", "tpv_amounttax", "tpv_unincludingtax", "tpv_unamounttax", "tpv_fentryid_in", "tpv_taxprice_cb",
                "tpv_includingtax_cb", "tpv_invoicedam_cb", "tpv_taxpricecb", "tpv_invoicedamcb","tpv_amounttax_cb","tpv_unincludingtax_cb","tpv_unamounttax_cb","tpv_unamounttax-tpv_unamounttax_cb tpv_profit","tpv_typename",
                "tpv_salenumber"}).finish();
        DataSet tpvBdCombination = ORM.create().queryDataSet(algoKey, "tpv_bd_combination", "id,name tpv_comb", null);
        tpvDtSalesshipping=tpvDtSalesshipping.leftJoin(tpvBdCombination).on("tpv_combination","id").select(new String[]{"tpv_billstatus", "tpv_loansign", "tpv_whether",
                "tpv_company", "tpv_department", "tpv_identification","tpv_operator", "tpv_creater", "tpv_bizdate", "tpv_billno", "tpv_customer", "tpv_contractnumber", "tpv_reward",
                "tpv_billno_zy", "tpv_pickbill","tpv_pickqty_zy", "tpv_collocation", "tpv_combination", "tpv_settlementstatus", "tpv_contractmark", "tpv_supplier_zy", "tpv_typeofreward", "tpv_contractstatusx",
                "tpv_combination_in", "tpv_warehouse_zy", "tpv_prodname", "tpv_materialdes", "tpv_materialname", "tpv_currency", "tpv_currencycb", "tpv_invoicedam_zy", "tpv_taxprice",
                "tpv_invoicedam", "tpv_taxprice_zy", "tpv_includingtax", "tpv_amounttax", "tpv_unincludingtax", "tpv_unamounttax", "tpv_fentryid_in", "tpv_taxprice_cb",
                "tpv_includingtax_cb", "tpv_invoicedam_cb", "tpv_taxpricecb", "tpv_invoicedamcb","tpv_amounttax_cb","tpv_unincludingtax_cb","tpv_unamounttax_cb","tpv_unamounttax-tpv_unamounttax_cb tpv_profit","tpv_typename",
                "tpv_comb","tpv_salenumber"}).finish();
        DataSet dataSet = tpvDtSalesshipping;
        if (YEM.isNotEmpty(whereFilter)) {
            dataSet = dataSet.where(whereFilter);
        }
        return dataSet;
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        String tpvStatus = filterInfo.getString("tpv_status");//状态
        String tpvCation = filterInfo.getString("tpv_cation");//标识
        Boolean tpvCol = filterInfo.getBoolean("tpv_col");//拣配
        Boolean tpvLoans = filterInfo.getBoolean("tpv_loans");//串拣配
        DynamicObject tpvOrg = filterInfo.getDynamicObject("tpv_org");//公司
        DynamicObject tpvDep = filterInfo.getDynamicObject("tpv_dep");//部门
        DynamicObject tpvPeople = filterInfo.getDynamicObject("tpv_people");//业务员
        String tpvBill = filterInfo.getString("tpv_bill");//发货单号
        String tpvSalenum = filterInfo.getString("tpv_salenum");//销售合同号
        String tpvConfing = filterInfo.getString("tpv_confing");//销售合同业务管理卡号
        if (YEM.isNotEmpty(tpvConfing)){
            whereFilter = String.format("%s and tpv_comb like '%%%s%%'", whereFilter, String.join(",", tpvConfing));
        }
        if (YEM.isNotEmpty(tpvStatus)){
            whereFilter = String.format("%s and tpv_billstatus ='%s'", whereFilter, String.join(",", tpvStatus));
        }
        if (YEM.isNotEmpty(tpvCation)){
            whereFilter = String.format("%s and tpv_identification ='%s'", whereFilter, String.join(",", tpvCation));
        }
        if (tpvCol){
            whereFilter = String.format("%s and tpv_collocation = %s", whereFilter, tpvCol);
        }
        if (tpvLoans){
            whereFilter = String.format("%s and tpv_loans = %s", whereFilter, tpvLoans);
        }
        if (tpvOrg!=null){
            whereFilter = String.format("%s and tpv_company = %s", whereFilter, tpvOrg.getPkValue());
        }
        if (tpvDep!=null){
            whereFilter = String.format("%s and tpv_department = %s", whereFilter, tpvDep.getPkValue());
        }
        if (tpvPeople!=null){
            whereFilter = String.format("%s and tpv_operator = %s", whereFilter, tpvPeople.getPkValue());
        }
        if (YEM.isNotEmpty(tpvBill)){
            whereFilter = String.format("%s and tpv_billno like '%%%s%%'", whereFilter, tpvBill);
        }
        if (YEM.isNotEmpty(tpvSalenum)){
            whereFilter = String.format("%s and tpv_contractnumber like '%%%s%%'", whereFilter, tpvSalenum);
        }
        String whereStr = PersonnelDepUtils.createWhereStr(filterInfo,"tpv_department", "tpv_muldepartment");
        if (!"".equals(whereStr)){
            whereFilter=String.format("%s%s", whereFilter, whereStr);
        }
        return whereFilter;
    }

}
