package tpv.tpv_wm.tpv_dt.java.utils;

import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.report.FilterInfo;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName: PersonnelDepUtils
 * @Description: 全部报表和工作台
 * 1、增加字段【部门】（只允许选择最末级节点）
 * （1）缺省值
 * ①如果当前登陆人在《人员》{部门信息}中分录行【兼职】=“否”的数据行中【部门】，在《部门属性管理》中【业务属性】=“职能部门”，则默认选中所有【部门】；
 * ②如果当前登陆人在《人员》{部门信息}中分录行【兼职】=“否”的数据行中【部门】在《部门属性管理》中【业务属性】≠“职能部门”，则默认选中当前【部门】以及下级部门所有的部门；且只显示当前【部门】以及下级部门所有的部门
 * @author: zbh
 * @date: 2024-07-08
 */
public class PersonnelDepUtils {

    /**
     * 增加字段【部门】（只允许选择最末级节点）
     * 如果当前登陆人在《人员》{部门信息}中分录行【兼职】=“否”的数据行中【部门】在《部门属性管理》中【业务属性】≠“职能部门”，且只显示当前【部门】以及下级部门所有的部门
     *
     * @param e
     */
    public static void departmentF(BeforeF7SelectEvent e) {
        ListShowParameter showParameterrd = (ListShowParameter) e.getFormShowParameter();

        List<QFilter> QFiltersrd = new ArrayList();
        Long isPartJob = depIsPartJob();
        Boolean isFlag = orgduty(isPartJob);

        List<Long> depLongs = new ArrayList<>();
        depLongs.add(isPartJob);
        DynamicObject[] bosAdminorgs = BusinessDataServiceHelper.load("bos_adminorg", "structure,viewparent", null);
        for (DynamicObject bosAdminorg : bosAdminorgs) {
            DynamicObjectCollection structures = bosAdminorg.getDynamicObjectCollection("structure");
            for (DynamicObject structure : structures) {
                DynamicObject viewparent = structure.getDynamicObject("viewparent");
                if (viewparent != null && viewparent.getLong("id") == isPartJob) {
                    depLongs.add(bosAdminorg.getLong("id"));
                }
            }
        }
        if (!isFlag) {
            QFiltersrd.add(new QFilter("id", QCP.in, depLongs));
        }
        showParameterrd.getListFilterParameter().setQFilters(QFiltersrd);
    }

    /**
     * ①如果当前登陆人在《人员》{部门信息}中分录行【兼职】=“否”的数据行中【部门】，在《部门属性管理》中【业务属性】=“职能部门”，则默认选中所有【部门】；
     * ②如果当前登陆人在《人员》{部门信息}中分录行【兼职】=“否”的数据行中【部门】在《部门属性管理》中【业务属性】≠“职能部门”，则默认选中当前【部门】以及下级部门所有的部门
     *
     * @param model      IDataModel
     * @param department 单据上部门（多选基础资料）字段的标识
     */
    public static void departmentDef(IDataModel model, String department) {

        Long dpt = depIsPartJob();
        Boolean isFlag = orgduty(dpt);

        DynamicObject[] bosAdminorgs = BusinessDataServiceHelper.load("bos_adminorg", "structure,viewparent,orgpattern",
                null
        );

        DynamicObjectCollection muldepartment = new DynamicObjectCollection();
        DynamicObjectType dynamicObjectType = model.getDataEntity(true).getDynamicObjectCollection(department).getDynamicObjectType();

        if (isFlag) {
            for (DynamicObject bosAdminorg : bosAdminorgs) {
                DynamicObject newDepartAdm = new DynamicObject(dynamicObjectType);
                newDepartAdm.set("fbasedataId", bosAdminorg);
                muldepartment.add(newDepartAdm);
            }
        } else {
            for (DynamicObject bosAdminorg : bosAdminorgs) {
                if (dpt == bosAdminorg.getLong("id")) {
                    DynamicObject newDepartORG = new DynamicObject(dynamicObjectType);
                    newDepartORG.set("fbasedataId", bosAdminorg);
                    muldepartment.add(newDepartORG);
                }
                DynamicObjectCollection structures = bosAdminorg.getDynamicObjectCollection("structure");
                for (DynamicObject structure : structures) {
                    DynamicObject viewparent = structure.getDynamicObject("viewparent");
                    if (viewparent != null && dpt == viewparent.getLong("id")) {
                        DynamicObject newDepartAdm = new DynamicObject(dynamicObjectType);
                        newDepartAdm.set("fbasedataId", bosAdminorg);
                        muldepartment.add(newDepartAdm);
                    }
                }
            }
        }
        if (muldepartment.size() != 0) {
            model.setValue(department, muldepartment);
        }
    }

    /**
     * 当前登录人在{部门信息}中分录行【兼职】=“否”的数据行中【部门】id
     *
     * @return
     */
    public static Long depIsPartJob() {
        DynamicObject bosUser = BusinessDataServiceHelper.loadSingleFromCache(YEM.getCurrentUserId(), "bos_user");
        DynamicObjectCollection entryentitys = bosUser.getDynamicObjectCollection("entryentity");//部门分录
        Long dpt = 0L;
        for (DynamicObject entryentity : entryentitys) {
            boolean ispartjob = entryentity.getBoolean("ispartjob");//兼职
            DynamicObject depart = entryentity.getDynamicObject("dpt");//部门
            if (!ispartjob && depart != null) {
                dpt = depart.getLong("id");
            }
        }
        return dpt;
    }

    /**
     * 判断当前部门在《部门属性管理》中【业务属性】是否为“职能部门”
     *
     * @param dpt 部门id
     * @return
     */
    public static Boolean orgduty(Long dpt) {
        Boolean isFlag = false;
        if (dpt != 0) {
            DynamicObject bosOrgDutyrelation = BusinessDataServiceHelper.loadSingle("bos_org_dutyrelation",
                    new QFilter[]{new QFilter("org", "=", dpt)});//部门属性管理
            if (bosOrgDutyrelation != null) {
                DynamicObject orgduty = bosOrgDutyrelation.getDynamicObject("orgduty");//业务属性
                String number = orgduty.getString("number");
                if ("ZHKC001".equals(number)) {
                    isFlag = true;
                } else {
                    isFlag = false;
                }
            }
        }
        return isFlag;
    }

    /**
     * @param filterInfo
     * @param departme      过滤部门标识
     * @param muldepartment 表头过滤条件部门标识（多选基础资料）
     */
    public static String createWhereStr(FilterInfo filterInfo, String departme, String muldepartment) {
        DynamicObjectCollection tpvMuldepartment = filterInfo.getDynamicObjectCollection(muldepartment);//部门多选基础资料
        String whereFilter = "";
        if (YEM.isNotEmpty(tpvMuldepartment)) {
            whereFilter = String.format("%s and " + departme + " in (%s)", whereFilter,
                    String.join(",", RptUtil.getBaseDataPkIdStrList(tpvMuldepartment)));
        } else {
            return "";
        }
        return whereFilter;
    }

    /**
     *
     * @param filterInfo
     * @param departme  过滤单据的部门标识
     * @param muldepartment  当前单据的部门标识（多选基础资料）
     * @return
     */
    public static QFilter createWhereStrQF(FilterInfo filterInfo, String departme, String muldepartment) {
        DynamicObjectCollection muldepartments = filterInfo.getDynamicObjectCollection(muldepartment);//部门多选基础资料
        if (muldepartments.size() != 0) {
            List<Long> depList = new ArrayList<>();
            for (DynamicObject muldepar : muldepartments) {
                depList.add(muldepar.getLong("id"));
            }
            return new QFilter(departme, "in", depList);
        }
        return null;
    }
    /**
     * @param model
     * @param muldepartment 当前单据的部门标识（多选基础资料）
     * @param dept          过滤单据的部门标识
     * @return
     */
    public static String createWhereStrForm(IDataModel model, String muldepartment, String dept) {
        DynamicObjectCollection muldepartments = (DynamicObjectCollection) model.getValue(muldepartment);
        String whereFilter = "";
        if (YEM.isNotEmpty(muldepartment) && muldepartments.size() != 0) {
            whereFilter = String.format("%s and " + dept + " in (%s)", whereFilter,
                    String.join(",", getBaseCollectionPkIdStrList(muldepartments)));
        } else {
            return "";
        }
        return whereFilter;
    }

    /**
     * @param model
     * @param tpvMuldepartment 当前单据的部门标识（多选基础资料）
     * @param dep              过滤单据的部门标识
     * @return
     */
    public static QFilter departmentQFilter(IDataModel model, String tpvMuldepartment, String dep) {
        DynamicObjectCollection muldepartments = (DynamicObjectCollection) model.getValue(tpvMuldepartment);
        if (muldepartments.size() != 0) {
            List<Long> depList = new ArrayList<>();
            for (DynamicObject muldepartment : muldepartments) {
                depList.add(muldepartment.getLong("fbasedataid.id"));
            }
            return new QFilter(dep, "in", depList);
        }
        return null;
    }

    public static List<String> getBaseCollectionPkIdStrList(DynamicObjectCollection col) {
        List<String> list = new ArrayList<>();
        if (col != null) {
            for (DynamicObject baseData : col) {
                list.add(baseData.getString("fbasedataid.id"));
            }
        }
        return list;
    }
}
