package tpv.tpv_wm.tpv_iscb.java.api.ant;

import cn.com.antcloud.api.AntFinTechApiClient;
import cn.com.antcloud.api.AntFinTechProfile;
import cn.com.antcloud.api.riskplus.v1_0.request.ExecCompanyGuardRequest;
import cn.com.antcloud.api.riskplus.v1_0.request.QueryGeneralRequest;
import cn.com.antcloud.api.riskplus.v1_0.response.ExecCompanyGuardResponse;
import cn.com.antcloud.api.riskplus.v1_0.response.QueryGeneralResponse;
import com.alibaba.fastjson.JSON;
import com.itopview.wm.sys.utils.Api;
import com.itopview.wm.sys.utils.ApiHelper;
import com.itopview.wm.sys.utils.ApiLog;
import kd.bos.dataentity.utils.StringUtils;

public class GetPublicSentimentList {

    private static final String ENDPOINT = "https://openapi.antchain.antgroup.com";
    private static final String ACCESS_KEY = "ACZQLV1pmNyoYgZn";
    private static final String SECRET_KEY = "XiGkbR4LxJSbV4TDBv7nhisThHh1Lpgr";
    private static final String PRODUCT_INSTANCE_ID = "rbb-prod";

    public static String testFunc(String name) throws InterruptedException {
        String queryGeneralResponse = testOpenAPIGeneralQuery("{ \"keyword\": " + "\"" + name + "\"" + "}", true);
//        System.out.println(queryGeneralResponse);
        return queryGeneralResponse;
    }

    /**
     * 参保人数
     *
     * @param name
     * @return
     * @throws InterruptedException
     */
    public static String employeeNum(String name) throws InterruptedException {
        String queryGeneralResponse = numberOfInsuredPersons("{ \"keyword\": " + "\"" + name + "\"" + "}");
//        System.out.println(queryGeneralResponse);
        return queryGeneralResponse;
    }

    /**
     * 工商信息
     *
     * @param name
     * @return
     * @throws InterruptedException
     */
    public static String enterPrise(String name) throws InterruptedException {
        String queryGeneralResponse = testOpenAPIGeneralQuery("{ \"keyword\": " + "\"" + name + "\"" + "}", false);
//        System.out.println(queryGeneralResponse);
        return queryGeneralResponse;
    }

    /**
     * A级纳税人接口
     *
     * @param name
     * @return
     * @throws InterruptedException
     */
    public static String enterPriseYear(String name) throws InterruptedException {
        String queryGeneralResponse = testOpenAPIGeneralYear("{\"keyword\": " + "\"" + name + "\"" + ",\"offset\": 0,\"limit\": 10}");
//        System.out.println(queryGeneralResponse);
        return queryGeneralResponse;
    }


    public static String testOpenAPIGeneralQuery(String queryParameters, Boolean messageType) throws InterruptedException {
        AntFinTechProfile antFinTechProfile = AntFinTechProfile.getProfile(ENDPOINT, ACCESS_KEY, SECRET_KEY);
        AntFinTechApiClient antFinTechApiClient = new AntFinTechApiClient(antFinTechProfile);
        QueryGeneralRequest request = new QueryGeneralRequest();
        request.setProductInstanceId(PRODUCT_INSTANCE_ID);
        ApiHelper apiHelper = new ApiHelper("Antapi");
        ApiLog log = null;
        if (messageType) {
            Api api = apiHelper.getApi("rbb.company.search");
            log = apiHelper.log(api);
            //企业查询
            request.setQueryname("rbb.company.search");
        } else {
            Api api = apiHelper.getApi("Industrialand");
            log = apiHelper.log(api);
            //工商信息
            request.setQueryname("rbb.company.basic.business.info");
        }
        request.setQueryparas(queryParameters);
        QueryGeneralResponse execute = antFinTechApiClient.execute(request);
        String resultCode = execute.getResultCode();
        if (!messageType && !StringUtils.equals("OK", resultCode)) {
            log.setSuccess(false);
            log.setRequestData(JSON.toJSONString(request));
            String resultMsg = execute.getResultMsg();
            log.setErrorMsg(resultMsg);
            log.write();
        }
        String result = JSON.parseObject(((QueryGeneralResponse) antFinTechApiClient.execute(request)).getData()).get("queryResult").toString();
        if (messageType) {
            log.setSuccess(true);
            log.setRequestData(JSON.toJSONString(request));
            log.setResponseData(result);
            log.write();
        } else {
            if (StringUtils.equals("OK", resultCode)) {
                log.setSuccess(true);
                log.setRequestData(JSON.toJSONString(request));
                log.setResponseData(result);
                log.write();
            }
        }
        return result;
    }

    /**
     * 参保人数
     *
     * @param queryParameters
     * @return
     * @throws InterruptedException
     */
    public static String numberOfInsuredPersons(String queryParameters) throws InterruptedException {
        AntFinTechProfile antFinTechProfile = AntFinTechProfile.getProfile(ENDPOINT, ACCESS_KEY, SECRET_KEY);
        AntFinTechApiClient antFinTechApiClient = new AntFinTechApiClient(antFinTechProfile);
        QueryGeneralRequest request = new QueryGeneralRequest();
        request.setProductInstanceId(PRODUCT_INSTANCE_ID);
        request.setQueryname("rbb.api.company.basic.org.annual");
        request.setQueryparas(queryParameters);
        QueryGeneralResponse execute = antFinTechApiClient.execute(request);
        String resultCode = execute.getResultCode();
        ApiHelper apiHelper = new ApiHelper("Antapi");
        Api api = apiHelper.getApi("Numberofinsuredpersons");
        ApiLog log = apiHelper.log(api);
        if (!resultCode.equals("OK")) {
            log.setSuccess(false);
            log.setRequestData(JSON.toJSONString(request));
            String resultMsg = execute.getResultMsg();
            log.setErrorMsg(resultMsg);
            log.write();
        }
        String result = JSON.parseObject(((QueryGeneralResponse) antFinTechApiClient.execute(request)).getData()).get("queryResult").toString();
        if (resultCode.equals("OK")) {
            log.setSuccess(true);
            log.setRequestData(JSON.toJSONString(request));
            log.setResponseData(result);
            log.write();
        }
        return result;
    }

    /**
     * A级纳税人
     *
     * @param queryParameters
     * @return
     * @throws InterruptedException
     */
    public static String testOpenAPIGeneralYear(String queryParameters) throws InterruptedException {
        AntFinTechProfile antFinTechProfile = AntFinTechProfile.getProfile(ENDPOINT, ACCESS_KEY, SECRET_KEY);
        AntFinTechApiClient antFinTechApiClient = new AntFinTechApiClient(antFinTechProfile);
        QueryGeneralRequest request = new QueryGeneralRequest();
        request.setProductInstanceId(PRODUCT_INSTANCE_ID);
        request.setQueryname("rbb.api.company.basic.fd.tax.pay.taxes");
        request.setQueryparas(queryParameters);
        String jsonString = JSON.toJSONString(request);
        QueryGeneralResponse execute = antFinTechApiClient.execute(request);
        String resultCode = execute.getResultCode();
        ApiHelper apiHelper = new ApiHelper("Antapi");
        Api api = apiHelper.getApi("Ataxpayer");
        ApiLog log = apiHelper.log(api);
        if (!StringUtils.equals("OK", resultCode)) {
            log.setSuccess(false);
            log.setRequestData(jsonString);
            String resultMsg = execute.getResultMsg();
            log.setErrorMsg(resultMsg);
            log.write();
        }
        String result = JSON.parseObject(((QueryGeneralResponse) antFinTechApiClient.execute(request)).getData()).get("queryResult").toString();
        if (StringUtils.equals("OK", resultCode)) {
            log.setSuccess(true);
            log.setRequestData(jsonString);
            log.setResponseData(result);
            log.write();
        }
        return result;
    }

    /**
     * 企业准入
     *
     * @param
     * @return
     * @throws InterruptedException
     */
    public static String enterpriseAdmittance(String name, String ruleld) throws InterruptedException {
        AntFinTechProfile antFinTechProfile = AntFinTechProfile.getProfile(ENDPOINT
                , ACCESS_KEY, SECRET_KEY);
        AntFinTechApiClient antFinTechApiClient = new AntFinTechApiClient(antFinTechProfile);
        ExecCompanyGuardRequest req = new ExecCompanyGuardRequest();
        req.setKeyword(name);//名称
        req.setRuleId(Long.parseLong(ruleld));
        req.setProductInstanceId(PRODUCT_INSTANCE_ID);
        req.setParams("{}");
        ExecCompanyGuardResponse resp = antFinTechApiClient.execute(req);
        String results = resp.getDecision();
        String jsonString = JSON.toJSONString(resp);
        String resultCode = resp.getResultCode();
        ApiHelper apiHelper = new ApiHelper("Antapi");
        Api api = apiHelper.getApi("Antenterpriseaccess");
        ApiLog log = apiHelper.log(api);
        if (StringUtils.equals("OK", resultCode)) {
            log.setSuccess(true);
            log.setRequestData(JSON.toJSONString(req));
            log.setResponseData(jsonString);
            log.write();
            return results;
        } else {
            log.setSuccess(false);
            log.setRequestData(JSON.toJSONString(req));
            String resultMsg = resp.getResultMsg();
            log.setErrorMsg(resultMsg);
            log.write();
            return "NO";
        }
        //String s = JSON.parseObject(((ExecCompanyGuardResponse) antFinTechApiClient.execute(resp)).getData()).get("queryResult").toString();
    }
}
