package tpv.tpv_wm.tpv_iscb.java.api.fadada;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.sys.utils.Api;
import com.itopview.wm.sys.utils.ApiHelper;
import com.itopview.wm.sys.utils.ApiLog;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.HttpHelper;
import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.entity.MainEntityType;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.mime.MultipartEntityBuilder;
import tpv.tpv_wm.tpv_iscb.java.api.fadada.entitys.*;

import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.security.MessageDigest;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.util.*;
import java.util.concurrent.atomic.AtomicReference;

/**
 * 法大大接口-文件签署
 *
 * @author lib
 */
public class ContractSignUtil {

    private static HashMap<String, Long> tokenMap;
    private static String lastToken; // 上次调用方法时的Token

    static {
        tokenMap = new HashMap<>();
    }



    /**
     * 创建签署任务先签
     */
    public CustomApiResult<Map<String, String>> creatSignTask(ContractSignTask contractSignTask) {
        // 校验
        CustomApiResult<Map<String, String>> result = beforSignCheck(contractSignTask);
        if (!result.isStatus())
            return result;
        // 获取附件信息
        String signFileName = contractSignTask.getSignFileName();
        InputStream inputStream = contractSignTask.getInputStream();
        if (inputStream == null) {
            DynamicObject srcEntity = contractSignTask.getSrcEntity();
            List<Map<String, Object>> attachments = AttachmentServiceHelper.getAttachments(
                    srcEntity.getDataEntityType().getName(), srcEntity.getLong("id"), "attachmentpanel", true);
            Map<String, Object> mostNewAttach = getMostNewAttach(attachments, signFileName);
            if (mostNewAttach == null)
                return CustomApiResult.fail("1", "签署异常:找不到附件【" + signFileName + "】");
            String url = (String) mostNewAttach.get("url");
            //String url = "http://192.168.251.47:8022/ierp/attachment/download.do?path=41ec5cf50c2d48fbaed8c0f91b56e4e8&access_token=1565115649955464192_OdXe4iPn4s5OvFUphZgqkXDC4PBiokzBpjp642r6wF7LFPZGuuZCcm072OrHEGT1kVhSj7i2Wn56ZKYkd6H1xCm5t7y13f3uquvr&fullfilename=内贸销售合同模板A(无章_预审)_1.pdf";
//		String urlTop="http://192.168.251.47:8022/ierp";
//		String domainContextUrl = UrlService.getDomainContextUrl();
//		url = url.replace(domainContextUrl, urlTop);;
            inputStream = getInputStream(url);
        }
        // 获取token
        JSONObject body = JSON.parseObject(getToken());
        int code = body.getInteger("code");
        if (body == null || code != 0) {
            String msg = "签署异常:获取token失败!";
            if (body != null)
                msg = msg + body.getString("message");
            return CustomApiResult.fail("2", msg);
        }
        Map<String, String> header = new HashMap<>();
        header.put("Authorization", "bearer " + body.getJSONObject("data").get("accessToken"));
        // header.put("Authorization", "bearer MAhflnPeDxKlD1xksbs7eLhNTeU");

        JSONObject param = new JSONObject();
        param.put("fileName", signFileName);
        MultipartEntityBuilder builder = MultipartEntityBuilder.create();
        builder.addTextBody("fileName", signFileName, ContentType.DEFAULT_TEXT.withCharset("UTF-8"));
        builder.addBinaryBody("file", inputStream, ContentType.MULTIPART_FORM_DATA, signFileName);
        String uploadResult = toHttp("upload", header, param.toJSONString(), builder);
        JSONObject parseObject = JSON.parseObject(uploadResult);
        code = parseObject.getInteger("code");
        if (parseObject == null || code != 0) {
            String msg = "签署异常:文件上传失败!";
            if (parseObject != null)
                msg = msg + parseObject.getString("message");
            return CustomApiResult.fail("3", msg);
        }
        String fileId = parseObject.getJSONObject("data").getString("fileId");
        // String fileId = "20231114_contractPdf_379659200189984768";
        contractSignTask.setFileId(fileId);
        // 创建 并提交签署任务
        CustomApiResult<Map<String, String>> creatContractSign = creatContractSign(contractSignTask, header);
        //Map<String, String> data = creatContractSign.getData();
        if (creatContractSign.isStatus()) {
            CustomApiResult<Map<String, String>> SignLink = SignLink(creatContractSign, contractSignTask, header);
            return SignLink;
        } else {
            return creatContractSign;
        }
    }


    public CustomApiResult<Map<String, String>> signLinkTask(String docld, String sealstatus, ContractSignTask contractSignTask) {
        String selectfields = DynamicObjectUtil.getSelectfields("tpv_iscb_signtaskinfo");
        // 查询签署任务信息
        DynamicObject[] load = BusinessDataServiceHelper.load("tpv_iscb_signtaskinfo", selectfields, new QFilter[]{
                new QFilter("tpv_signtaskid", QCP.equals, docld)
        });
        if (load.length > 0) {
            if ("D".equals(sealstatus)) {
                DynamicObject signInfo = load[0];
                String companyNotifyNos = signInfo.getString("tpv_usserialnumber");
                ApiHelper apiHelper = new ApiHelper("fadada");
                if (YEM.isNotEmpty(companyNotifyNos)) {
                    String SenderAccountId = apiHelper.getParam("SenderAccountId");
                    SignLink signLink = new SignLink();
                    JSONObject body = JSON.parseObject(getToken());
                    int codes = body.getInteger("code");
                    if (body == null || codes != 0) {
                        String msg = "签署异常:获取token失败!";
                        if (body != null)
                            msg = msg + body.getString("message");
                        return CustomApiResult.fail("2", msg);
                    }
                    Map<String, String> header = new HashMap<>();
                    header.put("Authorization", "bearer " + body.getJSONObject("data").get("accessToken"));
                    signLink.setDocId(docld);
                    signLink.setNotifyNo(companyNotifyNos);
                    signLink.setSignerAccountId(SenderAccountId);
                    String params = JSONObject.toJSONString(signLink);
                    String http = toHttp("getSignUrl", header, params);
                    JSONObject parseObject = JSON.parseObject(http);
                    int code = parseObject.getInteger("code");
                    if (code == 0) {
                        // 成功
                        Map<String, String> map = new HashMap<>();
                        @SuppressWarnings("unchecked")
                        Map<String, Object> object = (Map<String, Object>) parseObject.get("data");
                        String url = (String) object.get("url");
                        map.put("url", url);
                        signInfo.set("tpv_url", url);
                        SaveServiceHelper.save(new DynamicObject[]{signInfo});
//                        contractSignTask.setUrl(url);
//                        // 保存签署任务信息
//                        saveSignInfo(contractSignTask);
                        return CustomApiResult.success(map);
                    } else {
                        // 失败
                        return CustomApiResult.fail("001", parseObject.getString("message"));
                    }
                }
            }
        }
        return CustomApiResult.success(null);
    }


    private CustomApiResult<Map<String, String>> SignLink(CustomApiResult<Map<String, String>> creatContractSign, ContractSignTask contractSignTask, Map<String, String> header) {
        Map<String, String> data = creatContractSign.getData();
        String sealstatus = contractSignTask.getSealstatus();
        if ("D".equals(sealstatus)) {
            String id = data.get("docId");
            String selectfields = DynamicObjectUtil.getSelectfields("tpv_iscb_signtaskinfo");
            // 查询签署任务信息
            DynamicObject[] load = BusinessDataServiceHelper.load("tpv_iscb_signtaskinfo", selectfields, new QFilter[]{
                    new QFilter("tpv_signtaskid", QCP.equals, id)
            });
            DynamicObject signInfo = load[0];
            String companyNotifyNos = data.get("companyNotifyNo");
            if (YEM.isNotEmpty(companyNotifyNos)) {
                String SenderAccountId = data.get("SenderAccountId");
                SignLink signLink = new SignLink();
                signLink.setDocId(id);
                signLink.setNotifyNo(companyNotifyNos);
                signLink.setSignerAccountId(SenderAccountId);
                String params = JSONObject.toJSONString(signLink);
                String http = toHttp("getSignUrl", header, params);
                JSONObject parseObject = JSON.parseObject(http);
                int code = parseObject.getInteger("code");
                if (code == 0) {
                    // 成功
                    Map<String, String> map = data;
                    @SuppressWarnings("unchecked")
                    Map<String, Object> object = (Map<String, Object>) parseObject.get("data");
                    String url = (String) object.get("url");
                    map.put("url", url);
                    signInfo.set("tpv_url", url);
                    //contractSignTask.setUrl(url);
                    // 保存签署任务信息
                    //saveSignInfo(contractSignTask);
                    SaveServiceHelper.save(new DynamicObject[]{signInfo});
                    return CustomApiResult.success(map);
                } else {
                    // 失败
                    return CustomApiResult.fail("001", parseObject.getString("message"));
                }
            }
        }
        return CustomApiResult.success(data);
    }

    public CustomApiResult<Map<String, String>> documentRevocation(String docld) {
        JSONObject body = JSON.parseObject(getToken());
        int codes = body.getInteger("code");
        if (body == null || codes != 0) {
            String msg = "签署异常:获取token失败!";
            if (body != null)
                msg = msg + body.getString("message");
            return CustomApiResult.fail("2", msg);
        }
        Map<String, String> header = new HashMap<>();
        header.put("Authorization", "bearer " + body.getJSONObject("data").get("accessToken"));
        Withdrawal withdrawal =new Withdrawal();
        withdrawal.setDocId(docld);
        String params = JSONObject.toJSONString(withdrawal);
        String http = toHttp("cancel", header, params);
        JSONObject parseObject = JSON.parseObject(http);
        int code = parseObject.getInteger("code");
        if (code == 0) {
            // 成功
            Map<String, String> map = new HashMap<>();
            map.put("message", "操作成功");
            return CustomApiResult.success(map);
        } else {
            // 失败
            return CustomApiResult.fail("001", parseObject.getString("message"));
        }
    }

    private InputStream getInputStream(String url) {
        InputStream inputStream = null;
        try {
            URLConnection urlConnection = new URL(url).openConnection();
            HttpURLConnection httpURLConnection = (HttpURLConnection) urlConnection;
            httpURLConnection.setConnectTimeout(1000 * 5);
            httpURLConnection.setDoOutput(true);
            httpURLConnection.setDoInput(true);
            httpURLConnection.setUseCaches(false);
            httpURLConnection.setRequestProperty("Connection", "Keep-Alive");
            httpURLConnection.setRequestProperty("Charset", "UTF-8");
            httpURLConnection.connect();

            inputStream = httpURLConnection.getInputStream();
        } catch (Exception e1) {
            e1.printStackTrace();
        }
        return inputStream;
    }

    /**
     * 校验 - 1、文件类型校验：PDF文件 2、已存在签署任务校验 3、客商签署配置
     *
     * @param contractSignTask
     */
    private CustomApiResult<Map<String, String>> beforSignCheck(ContractSignTask contractSignTask) {
        Map<String, String> result = new HashMap<>();
        // 验证是否是pdf文件
        String signFileName = contractSignTask.getSignFileName();
        String[] split = signFileName.split("[.]");
        if (!"pdf".equals(split[split.length - 1]))
            return CustomApiResult.fail("5", "只能选择PDF类型文件进行签署");

        // 已存在签署任务校验

        // 查询客商签署配置

        // 校验通过
        result.put("result", "0");
        return CustomApiResult.success(result);
    }

    /**
     * 获取最新附件信息
     */
    private Map<String, Object> getMostNewAttach(List<Map<String, Object>> attachs, String fileName) {
        AtomicReference<Map<String, Object>> map = new AtomicReference<>();
        AtomicReference<Instant> temp = new AtomicReference<>();
        attachs.forEach(attach -> {
            if (attach.get("name").toString().equals(fileName)) {
                try {
                    Instant lastModified = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss")
                            .parse(attach.get("lastModified").toString()).toInstant();
                    if (temp.get() == null) {
                        temp.set(lastModified);
                        map.set(attach);
                    } else {
                        if (temp.get().isBefore(lastModified)) {
                            temp.set(lastModified);
                            map.set(attach);
                        }
                    }
                } catch (ParseException e) {
                    e.printStackTrace();
                }
            }
        });
        return map.get();
    }

    /**
     * 获取ToKen
     */
    public static String getToken() {
        String result = "";
        if (lastToken != null && tokenMap.containsKey(lastToken)) {
            long timestamp = tokenMap.get(lastToken);
            long currentTime = System.currentTimeMillis();
            long difference = currentTime - timestamp;
            if (difference < 60000) { // 一分钟的毫秒数
                // 如果时间差小于一分钟，返回缓存中的Token
                return lastToken;
            } else {
                // 如果时间差大于一分钟，重新获取Token并更新缓存
                ApiHelper apiHelper = new ApiHelper("fadada");
                if (apiHelper.isExist()) {
                    String appId = apiHelper.getParam("appid");// appid
                    String appKey = apiHelper.getParam("appkey");// appKey
                    SimpleDateFormat format = new SimpleDateFormat("yyyyMMddHHmmss");
                    Date date = new Date();
                    String sign = format.format(date) + appKey;
                    // 对appkey进行加密
                    sign = SHA256Encrypt(sign);
                    JSONObject httpParam = new JSONObject();
                    httpParam.put("appId", appId);
                    httpParam.put("sign", sign);
                    httpParam.put("timestamp", format.format(date));
                    result = toHttp("token", null, httpParam.toString());
                    lastToken = result; // 更新lastToken
                    tokenMap.put(lastToken, System.currentTimeMillis()); // 存储时间戳
                }
            }
        } else {
            //缓存中没有Token
            ApiHelper apiHelper = new ApiHelper("fadada");
            if (apiHelper.isExist()) {
                String appId = apiHelper.getParam("appid");// appid
                String appKey = apiHelper.getParam("appkey");// appKey
                SimpleDateFormat format = new SimpleDateFormat("yyyyMMddHHmmss");
                Date date = new Date();
                String sign = format.format(date) + appKey;
                // 对appkey进行加密
                sign = SHA256Encrypt(sign);
                JSONObject httpParam = new JSONObject();
                httpParam.put("appId", appId);
                httpParam.put("sign", sign);
                httpParam.put("timestamp", format.format(date));
                result = toHttp("token", null, httpParam.toString());
                lastToken = result; // 更新lastToken
                tokenMap.put(lastToken, System.currentTimeMillis()); // 存储时间戳
            }
        }
        return result;
    }

    /**
     * 创建签署任务
     */
    private CustomApiResult<Map<String, String>> creatContractSign(ContractSignTask contractSignTask,
                                                                   Map<String, String> header) {
        ContractSign contractSign = new ContractSign();
        // 签署主题 即文件名称
        String signFileName = contractSignTask.getSignFileName();
        contractSign.setDocTitle(signFileName);
        // 签署文档列表
        List<SignDocs> list = new ArrayList<>();
        SignDocs SignDocs = new SignDocs();
        SignDocs.setFileId(contractSignTask.getFileId());
        list.add(SignDocs);
        contractSign.setDocList(list);
        contractSign.setIsAutoArchive(1);
        // 发起方公司名称
        ApiHelper apiHelper = new ApiHelper("fadada");
        // contractSign.setCompanyName(apiHelper.getParam("companyName"));
        // 发起方公司id
        contractSign.setCompanyId(apiHelper.getParam("companyId"));
        // 签署回调地址
        contractSign.setNotifyUrl(apiHelper.getParam("notifyUrl"));
        // 发起方标识
        contractSign.setSenderAccountId(apiHelper.getParam("SenderAccountId"));
        // 发起人手机号
        // contractSign.setSenderMobile(apiHelper.getParam("senderMobile"));
        // 参与方列表
        List<SignParticipant> signParticipants = new ArrayList<>();
        String companyName = contractSignTask.getCompanyName();
        String companyNotifyNos = "";
        if (!YEM.isEmpty(companyName)) {
            SignParticipant company = new SignParticipant();// 参与方-公司
            // company.setCompanyName(apiHelper.getParam("companyName"));// 参与方名称
            company.setCompanyId(apiHelper.getParam("companyId"));// 参与方ID
            company.setPriority(2);// 签署顺序
            company.setSignType(0);// 手动签
            company.setIsSendNotify(1);// 发送通知
            company.setAutoSignNotifyType(3);// 签署前通知
            company.setSignerName(apiHelper.getParam("SignerName"));// 我方签署人名称
            company.setMobile(apiHelper.getParam("Mobile"));// 我方签署人手机号
            String companyNotifyNo = "company_" + apiHelper.getParam("companyId") + "_" + UUID.randomUUID().toString();// 避免重复，需要加uuid
            companyNotifyNos = companyNotifyNo;
            company.setNotifyNo(companyNotifyNo);// 签署回调流水号
            contractSignTask.setCompanyNotifyNo(companyNotifyNo);
            // contractSignTask.setIsAutoSign(false);

            if (contractSignTask.getIsAutoSign()) {// 自动签
                company.setAutoSignNotifyType(2);// 签署完成通知
                company.setIsPosition(1);// 指定签署位置
                company.setSignType(1);// 系统自动免验证签
                SignDocInfo signDocInfo = new SignDocInfo();
                signDocInfo.setFileId(contractSignTask.getFileId());
                if (contractSignTask.getIsCompanySign()) {//是否企业章
                    List<CompanySeal> companySeals = new ArrayList<>();
                    CompanySeal companySeal = new CompanySeal();
                    companySeal.setSealId(contractSignTask.getSealId());// 印章ID
                    if (contractSignTask.getIsKeyWord()) {//关键字定位
                        companySeal.setKeyWord(contractSignTask.getKeyWord()); // 定位关键字
                        companySeal.setKeyWordPolicy(0);// 定位关键字策略0：所有关键字签章 （默认）； 1：第一个关键字签章 ； 2：最后一个关键字签章；
                    } else {//坐标定位
                        companySeal.setLocateCoordinates(contractSignTask.getLocateCoordinates());//签章坐标
                    }
                    companySeals.add(companySeal);
                    signDocInfo.setCompanySealDTO(companySeals);
                }
                if (contractSignTask.getIsAcrossSign()) {//是否骑缝章
                    AcrossSeal acrossSeal = new AcrossSeal();// 骑缝章信息
                    acrossSeal.setSealId(contractSignTask.getAccessSealId());// 骑缝章ID
                    acrossSeal.setAcrossSealY(contractSignTask.getAcrossSealY());// 骑缝章盖章y坐标
                    acrossSeal.setPageType(contractSignTask.getPageType());// 骑缝章应用页面
                    acrossSeal.setCustomPage(contractSignTask.getCustomPage());// 骑缝章盖章页数
                    signDocInfo.setAcrossSealDTO(acrossSeal);
                }
                List<SignDocInfo> signDocInfos = new ArrayList<>();
                signDocInfos.add(signDocInfo);
                company.setDocSignInfoDTO(signDocInfos);
            }
            signParticipants.add(company);
        }
        // 添加参与方-客商
        if (!YEM.isEmpty(contractSignTask.getTraderName())) {
            //查询客商签署配置
            SignParticipant trader = new SignParticipant();// 参与方-公司
            trader.setSignerAccountId(contractSignTask.getSignerAccountId());//对方签署人
            //trader.setCompanyName(contractSignTask.getTraderName());// 参与方名称
            trader.setCompanyId(contractSignTask.getTraderId());// 参与方ID
            trader.setSignType(0);// 手动免验证签
            trader.setIsSendNotify(1);// 发送通知
            trader.setAutoSignNotifyType(3);// 签署前通知
            String traderNotifyNo = "trader_" + contractSignTask.getTraderId() + "_" + UUID.randomUUID().toString();
            trader.setNotifyNo(traderNotifyNo);// 签署回调流水号
            // 是否我方先签
            if (contractSignTask.getIsFristSign()) {
                trader.setPriority(3);//我方先签
            } else {
                trader.setPriority(1);//对方先签
            }
            contractSignTask.setTraderNotifyNo(traderNotifyNo);

            if (YEM.isNotEmpty(apiHelper.getParam("traderReadFinalPage"))) {
                // 是否所有文件需阅读至末页才可提交，0：否 （默认）；1：是
                trader.setIsReadFinalPage(Integer.valueOf(apiHelper.getParam("traderReadFinalPage")));
            }
            if (YEM.isNotEmpty(apiHelper.getParam("traderReadingTime"))) {
                //阅读多久后才可提交签署，默认为0，可设置秒数范围，1-60秒
                trader.setReadingTime(Integer.valueOf(apiHelper.getParam("traderReadingTime")));
            }
            signParticipants.add(trader);

        }
        contractSign.setSignerInfos(signParticipants);
        // 提交签署任务
        String params = JSONObject.toJSONString(contractSign);
        String http = toHttp("createAndPush", header, params);
        JSONObject parseObject = JSON.parseObject(http);
        int code = parseObject.getInteger("code");
        if (code == 0) {
            // 成功
            Map<String, String> map = new HashMap<>();
            @SuppressWarnings("unchecked")
            Map<String, Object> object = (Map<String, Object>) parseObject.get("data");
            String docId = (String) object.get("docId");
            JSONArray signUrl = (JSONArray) object.get("signUrlList");
//			Map<String, String> urls = (Map<String, String>) signUrl.get(0);
//			String shortUrl = urls.get("shortUrl");
            map.put("docId", docId);
            map.put("SenderAccountId", contractSign.getSenderAccountId());
            map.put("companyNotifyNo", companyNotifyNos);
            map.put("sceneInfo", contractSignTask.getSceneInfo());
            contractSignTask.setSignTaskId(docId);
            for (int i = 0; i < signUrl.size(); i++) {
                JSONObject jsonObjects = signUrl.getJSONObject(i);
                int priority = jsonObjects.getInteger("priority");
                if (priority == 2) {
                    map.put("signUrl", jsonObjects.getString("shortUrl"));
                    map.put("signUrlList", signUrl.toJSONString());
                    contractSignTask.setShortUrl(jsonObjects.getString("shortUrl"));
                } else {
                    contractSignTask.setOthershortUrl(jsonObjects.getString("shortUrl"));
                }
            }
            // 保存签署任务信息
            saveSignInfo(contractSignTask);
            return CustomApiResult.success(map);
        } else {
            // 失败
            return CustomApiResult.fail("001", parseObject.getString("message"));
        }

    }

    /**
     * 保存签署任务信息
     */
    private void saveSignInfo(ContractSignTask contractSignTask) {
        DynamicObject newDynamicObject = BusinessDataServiceHelper.newDynamicObject("tpv_iscb_signtaskinfo");
        newDynamicObject.set("tpv_signtaskid", contractSignTask.getSignTaskId());
        newDynamicObject.set("tpv_bills", contractSignTask.getSrcEntity().getDataEntityType().getName());
        newDynamicObject.set("tpv_billsid", contractSignTask.getSrcEntity().getLong("id"));
        String tpvAppid = ((MainEntityType) contractSignTask.getSrcEntity().getDataEntityType()).getAppId();
        IDataEntityType dType = contractSignTask.getSrcEntity().getDataEntityType();
        DynamicObject propValue = null;
        for (IDataEntityProperty property : dType.getProperties()) {
            String name = property.getName();
            if ("creator".equals(name)) {
                propValue = (DynamicObject) contractSignTask.getSrcEntity().get(property);
            }
        }
        long id = propValue.getLong("id");
        newDynamicObject.set("tpv_creators", id);
        newDynamicObject.set("tpv_appid", tpvAppid);
        newDynamicObject.set("tpv_time", new Date());
        newDynamicObject.set("tpv_signfilename", contractSignTask.getSignFileName());
        newDynamicObject.set("tpv_signfileid", contractSignTask.getFileId());
        newDynamicObject.set("tpv_companyname", contractSignTask.getCompanyName());
        ApiHelper apiHelper = new ApiHelper("fadada");
        newDynamicObject.set("tpv_companyid", apiHelper.getParam("companyId"));
        newDynamicObject.set("tpv_usserialnumber", contractSignTask.getCompanyNotifyNo());
        newDynamicObject.set("tpv_tradername", contractSignTask.getTraderName());
        newDynamicObject.set("tpv_traderid", contractSignTask.getTraderId());
        newDynamicObject.set("tpv_serialnumber", contractSignTask.getTraderNotifyNo());
        newDynamicObject.set("tpv_printids", contractSignTask.getPrintid());
        newDynamicObject.set("tpv_asynchronousrow", contractSignTask.getAsynchronousrow());
        Boolean isFristSign = contractSignTask.getIsFristSign();
        String companyName = contractSignTask.getCompanyName();
        String traderName = contractSignTask.getTraderName();
        // 签署顺序： A:我方单签 B:对方单签 C:双签 我方先签 D: 双签对方先签
//		String tpv_signorder = "";// 签署顺序
//		if (YEM.isEmpty(companyName) || YEM.isEmpty(traderName)) {
//			if (YEM.isEmpty(companyName))
//				tpv_signorder = "B";// 对方先签
//			if (YEM.isEmpty(traderName))
//				tpv_signorder = "A";// 我方先签
//		} else {
//			if (isFristSign) {
//				tpv_signorder = "C";// 双签 我方先签
//			} else {
//				tpv_signorder = "D";// 双签 对方先签
//			}
//		}
        newDynamicObject.set("tpv_shorturl", contractSignTask.getShortUrl());
        newDynamicObject.set("tpv_othershorturl", contractSignTask.getOthershortUrl());
        newDynamicObject.set("tpv_url", contractSignTask.getUrl());
        newDynamicObject.set("tpv_signorder", contractSignTask.getSceneInfo());
        SaveServiceHelper.save(new DynamicObject[]{newDynamicObject});

    }

    /**
     * 客商备案表同步按钮管理员接口
     *
     * @return
     */
    public static String getCompany(String apiNumber, Map<String, String> header, String params) {
        if (!header.isEmpty()){
            return toHttp(apiNumber,header,params);
        } else {
            //调用获取ToKen方法
            String token = getToken();
            JSONObject body = JSON.parseObject(token);
            if (null != body) {
                int code = body.getInteger("code");
                String bearer = "bearer ";
                String authoriztion;
                if (body != null && code == 0) {
                    Object object = body.get("data");
                    Map<String, String> dataToKen = (Map<String, String>) object;
                    authoriztion = bearer + dataToKen.get("accessToken");
                    Map<String, String> headerS = getHeaderForSeal(authoriztion);
                    return toHttp(apiNumber,headerS,params);
                } else {
                    return "token失败";
                }
            }
        }
        return "";
    }

    private static Map<String, String> getHeaderForSeal(String authoriztion) {
        Map<String, String> header = new HashMap<>();
        header.put("Authorization", authoriztion);
        return header;
    }


    private static String toHttp(String apiNumber, Map<String, String> header, String params) {
        ApiHelper apiHelper = new ApiHelper("fadada");
        if (apiHelper.isExist()) {
            String url = apiHelper.getParam("url");
            Api api = apiHelper.getApi(apiNumber);
            if (api.isExist()) {
                String apiUrl = api.getUrl();
                String httpUrl = url + apiUrl;
                String httpmethod = api.getHttpmethod();
                ApiLog log = apiHelper.log(api);
                String httpGet = "";
                String requestData = "";
                try {
                    if ("0".equals(httpmethod)) {
                        if (params == null) {
                            params = "";
                        }
                        httpGet = HttpHelper.httpGet(httpUrl + params, header);
                        requestData = httpUrl;
                    }
                    if ("1".equals(httpmethod)) {
                        httpGet = HttpHelper.httpPost(httpUrl, header, params);
                        requestData = params;
                    }
                    JSONObject jsonObject = JSONObject.parseObject(httpGet);
                    Integer code = jsonObject.getInteger("code");
                    String message = jsonObject.getString("message");
                    if (code == 0) {
                        log.setSuccess(true);
                    } else {
                        log.setSuccess(false);
                        log.setErrorMsg(message);
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    log.setErrorMsg(YEM.exceptionToStr(e));
                    log.setSuccess(false);
                }
                log.setRequestData(requestData);
                log.setResponseData(httpGet);
                log.write();
                return httpGet;
            }
        }
        return "";
    }

    private String toHttp(String apiNumber, Map<String, String> header, String params, MultipartEntityBuilder builder) {
        ApiHelper apiHelper = new ApiHelper("fadada");
        if (apiHelper.isExist()) {
            String url = apiHelper.getParam("url");
            Api api = apiHelper.getApi(apiNumber);
            if (api.isExist()) {
                String apiUrl = api.getUrl();
                String httpUrl = url + apiUrl;
                ApiLog log = apiHelper.log(api);
                String httpGet = "";
                try {
                    httpGet = HttpHelper.httpPost(httpUrl, header, builder);
                    JSONObject jsonObject = JSONObject.parseObject(httpGet);
                    Integer code = jsonObject.getInteger("code");
                    String message = jsonObject.getString("message");
                    if (code == 0) {
                        log.setSuccess(true);
                    } else {
                        log.setSuccess(false);
                        log.setErrorMsg(message);
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    log.setSuccess(false);
                    log.setErrorMsg(YEM.exceptionToStr(e));
                }
                log.setRequestData(params);
                log.setResponseData(httpGet);
                log.write();
                return httpGet;
            }
        }
        return "";
    }

    /**
     * SHA256 加密
     */
    private static String SHA256Encrypt(String sign) {
        try {
            // 创建SHA256加密对象
            MessageDigest digest = MessageDigest.getInstance("SHA-256");
            // 使用SHA256加密算法对输入数据进行加密
            byte[] hash = digest.digest(sign.getBytes("UTF-8"));
            // 将字节数组转换为十六进制字符串
            StringBuilder hexString = new StringBuilder();
            for (byte b : hash) {
                String hex = Integer.toHexString(0xff & b);
                if (hex.length() == 1) {
                    hexString.append('0');
                }
                hexString.append(hex);
            }
            String result = hexString.toString();
            // 转大写
            result = result.toUpperCase();
            return result;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "";
    }
}
