package tpv.tpv_wm.tpv_iscb.java.api.fadada.openapi;


import static com.itopview.wm.utils.AttachmentUtil.uploadAttachmentPanels;
import static com.itopview.wm.utils.FileUtil.base64FileSize;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Base64;
import java.util.Date;
import java.util.Map;
import java.util.Set;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alipay.api.internal.util.file.IOUtils;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;

import kd.bos.bill.IBillWebApiPlugin;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.fileservice.FileItem;
import kd.bos.fileservice.FileService;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.logging.Log;
import kd.bos.logging.LogFactory;
import kd.bos.openapi.common.custom.annotation.ApiController;
import kd.bos.openapi.common.custom.annotation.ApiErrorCode;
import kd.bos.openapi.common.custom.annotation.ApiErrorCodes;
import kd.bos.openapi.common.custom.annotation.ApiMapping;
import kd.bos.openapi.common.custom.annotation.ApiPostMapping;
import kd.bos.openapi.common.custom.annotation.ApiRequestBody;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.url.UrlService;

/**
 * @Description: 法大大签署回调 开放接口，返回ResultData
 * @Author lib
 * @Date 2023/10/21 20:55
 */
@ApiController(value = "SignNotiFy", desc = "法大大签署回调")
@ApiMapping("/fdada")

@ApiErrorCodes({
        @ApiErrorCode(code = "404", desc = "路径访问错误")
})
public class SignNotiFyController implements IBillWebApiPlugin {
    @ApiPostMapping(value = "signNotify", desc = "签署回调")
    public CustomApiResult<Map<String, Object>> signNotify(@ApiRequestBody(value = "参数") Map<String, Object> body) {
        Log log = LogFactory.getLog(SignNotiFyController.class);
        log.info("法大大签署回调:" + body.toString());
        String docId = body.get("docId").toString();
        String selectfields = DynamicObjectUtil.getSelectfields("tpv_iscb_signtaskinfo");
        // 查询签署任务信息
        DynamicObject[] load = BusinessDataServiceHelper.load("tpv_iscb_signtaskinfo", selectfields, new QFilter[]{
                new QFilter("tpv_signtaskid", QCP.equals, docId)
        });
        JSONObject jsonObject = new JSONObject();
        if (load.length > 0) {
            DynamicObject signInfo = load[0];
            String downloadUrl = body.get("downloadUrl").toString();
            String viewUrl = body.get("viewUrl").toString();
            int contractStatus = (int) body.get("contractStatus");
            if (!downloadUrl.isEmpty()) {
                JSONArray signUrl = (JSONArray) body.get("signList");
                signInfo.set("tpv_viewurl", viewUrl);
                signInfo.set("tpv_downloadurl", downloadUrl);
                for (int i = 0; i < signUrl.size(); i++) {
                    JSONObject jsonObjects = signUrl.getJSONObject(i);
                    int priority = jsonObjects.getInteger("priority");
                    signInfo.set("tpv_signstatus", contractStatus);//签署状态
                    if (priority == 2) {
                        signInfo.set("tpv_signaturestate", jsonObjects.getInteger("signStatus"));//我方签署状态
                        signInfo.set("tpv_mysignatory", jsonObjects.getString("signerAccountId"));//我方签署人id
                        signInfo.set("tpv_usserialnumber", jsonObjects.getString("notifyNo"));//我方回调流水
                        signInfo.set("tpv_priority", priority);//我方优先级
                    } else {
                        signInfo.set("tpv_othersignature", jsonObjects.getInteger("signStatus"));//对方签署状态
                        signInfo.set("tpv_othersignatory", jsonObjects.getString("signerAccountId"));//对方签署人id
                        signInfo.set("tpv_serialnumber", jsonObjects.getString("notifyNo"));//对方回调流水
                        signInfo.set("tpv_otherpriority", priority);//对方优先级
                    }
                }
                SaveServiceHelper.save(new DynamicObject[]{signInfo});
                DynamicObject tpvBills = signInfo.getDynamicObject("tpv_bills");//单据
                String tpvBillsid = signInfo.getString("tpv_billsid");//单据内码
                Long tpvBillsids = Long.valueOf(tpvBillsid);
                String number = tpvBills.getString("number");//单据标识
                QFilter[] qFilter = new QFilter[]{new QFilter("id", QCP.equals, tpvBillsids)};
                String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast(number);
                DynamicObject[] queryDj = BusinessDataServiceHelper.load(number, selectfieldsFast, qFilter);
                String tpvSignorder = signInfo.getString("tpv_signorder");//场景
                String tpvSignfilename = signInfo.getString("tpv_signfilename");//附件名称
                String tpvSealstatus = "";//用印状态
                String tpvDownloadurl = signInfo.getString("tpv_downloadurl");//下载地址
                String tpvAppid = signInfo.getString("tpv_appid");//应用标识
                String select = DynamicObjectUtil.getSelectfieldsFast("bos_user");
                DynamicObject[] user = BusinessDataServiceHelper.load("bos_user", select, new QFilter[]{
                        new QFilter("name", QCP.equals, "机器人")
                });
                String status = "";
                if (tpvSignorder == null) {
                    status = "A";
                } else {
                    if (tpvSignorder.equals("B")) {//本方线上单签
                        status = "D";
                    }
                    if (tpvSignorder.equals("C")) {//对方线上单签
                        status = "E";
                    }
                    if (tpvSignorder.equals("D")) {//双方线上签署我方先
                        status = "D";
                    }
                    if (tpvSignorder.equals("E")) {//双方线上签署对方先
                        status = "E";
                    }
                }
                DynamicObject users = user[0];
                Long cretor = users.getLong("id");
                String url = "";
                String attachmentKey = "attachmentpanel";
                if ("F".equals(tpvSignorder)) {//自动签
                    if (signInfo.getInt("tpv_signstatus") == 2) {//签署状态
                        if (!signInfo.getBoolean("tpv_havesigned")) {
                            signInfo.set("tpv_havesigned", true);
                            String urls = "";
                            InputStream stream = getInputStream(tpvDownloadurl);
                            try {
                                urls = url(tpvAppid, number, tpvBillsid, tpvSignfilename, stream);
                            } catch (IOException e) {
                                throw new RuntimeException(e);
                            }
                            InputStream inputStream = FileServiceFactory.getAttachmentFileService().getInputStream(urls);
                            ByteArrayOutputStream bytestream = new ByteArrayOutputStream();
                            byte[] buffer = new byte[1024];
                            byte[] input = new byte[]{};
                            try {
                                int ch;
                                while ((ch = inputStream.read(buffer)) != -1) {
                                    bytestream.write(buffer, 0, ch);
                                }
                                input = bytestream.toByteArray();
                                bytestream.close();
                            } catch (IOException e) {
                                throw new RuntimeException(e);
                            }
                            String attachmentfile = Base64.getEncoder().encodeToString(input);
                            DynamicObject[] iscb_asynchronous = null;
                            DynamicObject entry = null;
                            Long asynchronousid = signInfo.getLong("tpv_printids");//打印id
                            int row = signInfo.getInt("tpv_asynchronousrow");//打印分录行号
                            String selectfield = DynamicObjectUtil.getSelectfields("tpv_iscb_asynchronous", false);
                            selectfield = DynamicObjectUtil.getEntrySelectfields(selectfield, "tpv_iscb_asynchronous", "tpv_iscb_asynchr_cl", false);
                            QFilter qFilterx = new QFilter("id", QCP.equals, asynchronousid);
                            iscb_asynchronous = BusinessDataServiceHelper.load("tpv_iscb_asynchronous", selectfield, qFilterx.toArray());
                            iscb_asynchronous[0].set("tpv_atcontent", attachmentfile);//当前内容
                            iscb_asynchronous[0].set("tpv_yataskinfoid", asynchronousid);//易氩任务底表id
                            entry = iscb_asynchronous[0].getDynamicObjectCollection("tpv_iscb_asynchr_cl").get(row - 1);
                            entry.set("tpv_state", "A");//状态完成
                            if ("".equals(attachmentfile) || attachmentfile != null) {
                                signInfo.set("tpv_havesigned", true);
                                SaveServiceHelper.save(new DynamicObject[]{signInfo});
                            }
                            SaveServiceHelper.update(iscb_asynchronous);
                        }
                    }
                }
                if ("B".equals(tpvSignorder)) {//我方对方单签
                    if (signInfo.getInt("tpv_signstatus") == 2) {//签署状态
                        if (!signInfo.getBoolean("tpv_havesigned")) {
                            signInfo.set("tpv_havesigned", true);
                            upload(tpvBillsid, number, "签-" + tpvSignfilename, tpvDownloadurl, tpvAppid, attachmentKey, cretor);
                            extracted(queryDj, tpvSignfilename, tpvSealstatus);
                            extracted(queryDj, tpvSignfilename, tpvSealstatus, true);
                            SaveServiceHelper.save(new DynamicObject[]{signInfo});
                        }
                    } else {
                        anomaly(queryDj, tpvSignfilename);
                    }
                    if (signInfo.getInt("tpv_signstatus") == 4) {  //签署状态（已撤销）
                        // if (!signInfo.getBoolean("tpv_havesigned")) {
                        //signInfo.set("tpv_havesigned",true);
                        OhterSignature(queryDj, tpvSignfilename, tpvSealstatus, status);
                        SaveServiceHelper.save(new DynamicObject[]{signInfo});
                        //}
                    }
                }
                if ("C".equals(tpvSignorder)) {//对方单签
                    if (signInfo.getInt("tpv_signstatus") == 2) {  //签署状态
                        if (!signInfo.getBoolean("tpv_havesigned")) {
                            signInfo.set("tpv_havesigned", true);
                            upload(tpvBillsid, number, "签-" + tpvSignfilename, tpvDownloadurl, tpvAppid, attachmentKey, cretor);
                            OhterSignature(queryDj, tpvSignfilename, tpvSealstatus);
                            OhterSignature(queryDj, tpvSignfilename, tpvSealstatus, true);
                            SaveServiceHelper.save(new DynamicObject[]{signInfo});
                        }
                    } else {
                        anomaly(queryDj, tpvSignfilename);
                    }
                    if (signInfo.getInt("tpv_signstatus") == 4) {  //签署状态（已撤销）
                        // if (!signInfo.getBoolean("tpv_havesigned")) {
                        //signInfo.set("tpv_havesigned",true);
                        OhterSignature(queryDj, tpvSignfilename, tpvSealstatus, status);
                        SaveServiceHelper.save(new DynamicObject[]{signInfo});
                        //}
                    }
                }
                if ("D".equals(tpvSignorder)) {//双签我方先
                    if (signInfo.getInt("tpv_signstatus") == 2) {  //签署状态
                        if (!signInfo.getBoolean("tpv_havesigned")) {
                            signInfo.set("tpv_havesigned", true);
                            upload(tpvBillsid, number, "双签-" + tpvSignfilename, tpvDownloadurl, tpvAppid, attachmentKey, cretor);
                            meOhterSignature(queryDj, tpvSignfilename, tpvSealstatus);
                            meOhterSignature(queryDj, tpvSignfilename, tpvSealstatus, true);
                            SaveServiceHelper.save(new DynamicObject[]{signInfo});
                        }
                    } else {
                        anomaly(queryDj, tpvSignfilename);//异常
                    }
                    if ("0".equals(signInfo.getString("tpv_signaturestate"))) { //我方完成，对方未完
                        if ("3".equals(signInfo.getString("tpv_othersignature"))) {
                            myExtracted(queryDj, tpvSignfilename, tpvSealstatus);//待对方
                        }
                    }
                    if (signInfo.getInt("tpv_signstatus") == 4) {  //签署状态（已撤销）
                        // if (!signInfo.getBoolean("tpv_havesigned")) {
                        //signInfo.set("tpv_havesigned",true);
                        OhterSignature(queryDj, tpvSignfilename, tpvSealstatus, status);
                        SaveServiceHelper.save(new DynamicObject[]{signInfo});
                        //}
                    }
                }
                if ("E".equals(tpvSignorder)) {//双签对方先
                    if (signInfo.getInt("tpv_signstatus") == 2) {  //签署状态
                        if (!signInfo.getBoolean("tpv_havesigned")) {
                            signInfo.set("tpv_havesigned", true);
                            upload(tpvBillsid, number, "双签-" + tpvSignfilename, tpvDownloadurl, tpvAppid, attachmentKey, cretor);
                            BothOhterSignature(queryDj, tpvSignfilename, tpvSealstatus);
                            BothOhterSignature(queryDj, tpvSignfilename, tpvSealstatus, true);
                            SaveServiceHelper.save(new DynamicObject[]{signInfo});
                        }
                    } else {
                        anomaly(queryDj, tpvSignfilename);
                    }
                    if ("0".equals(signInfo.getString("tpv_othersignature"))) { //对方完成，我方未完
                        if ("3".equals(signInfo.getString("tpv_signaturestate"))) {
                            otherExtracted(queryDj, tpvSignfilename, tpvSealstatus);
                        }
                    }
                    if (signInfo.getInt("tpv_signstatus") == 4) {  //签署状态（已撤销）
                        // if (!signInfo.getBoolean("tpv_havesigned")) {
                        //signInfo.set("tpv_havesigned",true);
                        OhterSignature(queryDj, tpvSignfilename, tpvSealstatus, status);
                        SaveServiceHelper.save(new DynamicObject[]{signInfo});
                        //}
                    }
                }
                jsonObject.put("code", 0);
                jsonObject.put("message", "成功");
                return CustomApiResult.success(jsonObject);
            } else {
                jsonObject.put("code", 1);
                jsonObject.put("message", "URL不能为空");
                return CustomApiResult.success(jsonObject);
            }
        }
//        jsonObject.put("code", "2");
//        jsonObject.put("msg", "找不到签署信息");
        return CustomApiResult.success(jsonObject);
    }

    private void upload(String tpvBillsid, String number, String tpvSignfilename, String tpvDownloadurl, String tpvAppid, String attachmentKey, Long cretor) {
        String url;
        InputStream stream = getInputStream(tpvDownloadurl);
        try {
            url = url(tpvAppid, number, tpvBillsid, tpvSignfilename, stream);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        String encreptURL = AttachmentServiceHelper.getEncreptURL(UrlService.getAttachmentFullUrl(url));
        InputStream attStream = getInputStream(encreptURL);
        double size = 0d;
        byte[] bytes = null;
        try {
            bytes = IOUtils.toByteArray(attStream);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        if (bytes != null) {
            String base64String = Base64.getEncoder().encodeToString(bytes);
            size = base64FileSize(base64String);
        }
        uploadAttachmentPanels(number, tpvBillsid, attachmentKey, tpvSignfilename, url, cretor, (int) size);
    }

    private static void otherExtracted(DynamicObject[] queryDj, String tpvSignfilename, String tpvSealstatus) {
        if (queryDj.length > 0) {
            DynamicObject query = queryDj[0];
            String tpvAttachmentconTag = query.getString("tpv_attachmentcon_tag");
            JSONObject json = JSONObject.parseObject(tpvAttachmentconTag);
            if (json != null) {
                Set<String> strings = json.keySet();
                if (strings.size() > 0 && null != strings) {
                    for (String names : strings) {
                        if (json != null) {
                            JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                            if (tpv_sourcebillkey != null) {
                                if (names.equals(tpvSignfilename)) {
                                    tpvSealstatus = (String) tpv_sourcebillkey.get("tpv_sealstatus");
                                }
                            }
                            if (!"D".equals(tpvSealstatus)) {
                                JSONObject attJson = json.containsKey(tpvSignfilename) ? json.getJSONObject(tpvSignfilename) : new JSONObject();
                                attJson.put("tpv_sealstatus", "D");
                                json.put(tpvSignfilename, attJson);
                                query.set("tpv_attachmentcon_tag", json);
                                SaveServiceHelper.update(query);
                            }
                        }
                    }
                }
            }
        }
    }

    private static void myExtracted(DynamicObject[] queryDj, String tpvSignfilename, String tpvSealstatus) {
        if (queryDj.length > 0) {
            DynamicObject query = queryDj[0];
            String tpvAttachmentconTag = query.getString("tpv_attachmentcon_tag");
            JSONObject json = JSONObject.parseObject(tpvAttachmentconTag);
            if (json != null) {
                Set<String> strings = json.keySet();
                if (strings.size() > 0 && null != strings) {
                    for (String names : strings) {
                        if (json != null) {
                            JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                            if (tpv_sourcebillkey != null) {
                                if (names.equals(tpvSignfilename)) {
                                    tpvSealstatus = (String) tpv_sourcebillkey.get("tpv_sealstatus");
                                }
                            }
                            if (!"F".equals(tpvSealstatus)) {
                                JSONObject attJson = json.containsKey(tpvSignfilename) ? json.getJSONObject(tpvSignfilename) : new JSONObject();
                                attJson.put("tpv_sealstatus", "F");
                                json.put(tpvSignfilename, attJson);
                                query.set("tpv_attachmentcon_tag", json);
                                SaveServiceHelper.update(query);
                            }
                        }
                    }
                }
            }
        }
    }

    //异常
    private static void anomaly(DynamicObject[] queryHW, String tpvSignfilename) {
        if (queryHW.length > 0) {
            DynamicObject query = queryHW[0];
            String tpvAttachmentconTag = query.getString("tpv_attachmentcon_tag");
            JSONObject json = JSONObject.parseObject(tpvAttachmentconTag);
            if (json != null) {
                Set<String> strings = json.keySet();
                JSONObject sealJson = new JSONObject();
                if (strings.size() > 0 && null != strings) {
                    for (String names : strings) {
                        if (json != null) {
                            JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                            if (tpv_sourcebillkey != null) {
                                if (names.equals(tpvSignfilename)) {
                                    JSONObject attJson = json.containsKey(tpvSignfilename) ? json.getJSONObject(tpvSignfilename) : new JSONObject();
                                    attJson.put("tpv_sealstatus", "L");
                                    json.put(tpvSignfilename, attJson);
                                    query.set("tpv_attachmentcon_tag", json);
                                    SaveServiceHelper.update(query);
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    //双方我先
    public void meOhterSignature(DynamicObject[] queryHW, String tpvSignfilename, String tpvSealstatus) {
        meOhterSignature(queryHW, tpvSignfilename, tpvSealstatus, false);
    }

    private static void meOhterSignature(DynamicObject[] queryHW, String tpvSignfilename, String tpvSealstatus, Boolean bill) {
        String tpvInquiry = "";//预审标记
        if (queryHW.length > 0) {
            DynamicObject query = queryHW[0];
            String tpvAttachmentconTag = query.getString("tpv_attachmentcon_tag");
            JSONObject json = JSONObject.parseObject(tpvAttachmentconTag);
            if (json != null) {
                if (bill) {
                    Set<String> strings = json.keySet();
                    if (strings.size() > 0 && null != strings) {
                        for (String names : strings) {
                            if (json != null) {
                                JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                                if (tpv_sourcebillkey != null) {
                                    if (names.equals(tpvSignfilename)) {
                                        tpvInquiry = (String) tpv_sourcebillkey.get("tpv_inquiry");
                                    }
                                }

                            }
                        }
                    }
                    JSONObject attJson = new JSONObject();
                    attJson.put("tpv_lock", true);
                    attJson.put("tpv_sealstatus", "M");//返回件
                    attJson.put("tpv_signaturestatus", "C");
                    attJson.put("tpv_printingmethod", "D");
                    attJson.put("tpv_uplink", "1821094233772156928");
                    attJson.put("tpv_inquiry", tpvInquiry);
                    json.put("双签-" + tpvSignfilename, attJson);
                    query.set("tpv_attachmentcon_tag", json);
                    SaveServiceHelper.update(query);
                } else {
                    Set<String> strings = json.keySet();
                    if (strings.size() > 0 && null != strings) {
                        for (String names : strings) {
                            if (json != null) {
                                JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                                if (tpv_sourcebillkey != null) {
                                    if (names.equals(tpvSignfilename)) {
                                        JSONObject attJson = json.containsKey(tpvSignfilename) ? json.getJSONObject(tpvSignfilename) : new JSONObject();
                                        tpvSealstatus = (String) tpv_sourcebillkey.get("tpv_sealstatus");
                                        if (!"G".equals(tpvSealstatus)) {
                                            attJson.put("tpv_sealstatus", "G");
                                            attJson.put("tpv_printingmethod", "D");
                                            json.put(tpvSignfilename, attJson);
                                            query.set("tpv_attachmentcon_tag", json);
                                            SaveServiceHelper.update(query);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            SaveServiceHelper.update(query);
        }
    }


    //双方对方先
    public void BothOhterSignature(DynamicObject[] queryHW, String tpvSignfilename, String tpvSealstatus) {
        BothOhterSignature(queryHW, tpvSignfilename, tpvSealstatus, false);
    }

    private static void BothOhterSignature(DynamicObject[] queryHW, String tpvSignfilename, String tpvSealstatus, Boolean bill) {
        String tpvInquiry = "";//预审标记
        if (queryHW.length > 0) {
            DynamicObject query = queryHW[0];
            String tpvAttachmentconTag = query.getString("tpv_attachmentcon_tag");
            JSONObject json = JSONObject.parseObject(tpvAttachmentconTag);
            if (json != null) {
                if (bill) {
                    Set<String> strings = json.keySet();
                    if (strings.size() > 0 && null != strings) {
                        for (String names : strings) {
                            if (json != null) {
                                JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                                if (tpv_sourcebillkey != null) {
                                    if (names.equals(tpvSignfilename)) {
                                        tpvInquiry = (String) tpv_sourcebillkey.get("tpv_inquiry");
                                    }
                                }

                            }
                        }
                    }
                    JSONObject attJson = new JSONObject();
                    attJson.put("tpv_lock", true);
                    attJson.put("tpv_sealstatus", "M");//返回件
                    attJson.put("tpv_signaturestatus", "C");
                    attJson.put("tpv_printingmethod", "E");
                    attJson.put("tpv_uplink", "1821094233772156928");
                    attJson.put("tpv_inquiry", tpvInquiry);
                    json.put("双签-" + tpvSignfilename, attJson);
                    query.set("tpv_attachmentcon_tag", json);
                    SaveServiceHelper.update(query);
                } else {
                    Set<String> strings = json.keySet();
                    if (strings.size() > 0 && null != strings) {
                        for (String names : strings) {
                            if (json != null) {
                                JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                                if (tpv_sourcebillkey != null) {
                                    if (names.equals(tpvSignfilename)) {
                                        JSONObject attJson = json.containsKey(tpvSignfilename) ? json.getJSONObject(tpvSignfilename) : new JSONObject();
                                        tpvSealstatus = (String) tpv_sourcebillkey.get("tpv_sealstatus");
                                        if (!"G".equals(tpvSealstatus)) {
                                            attJson.put("tpv_sealstatus", "G");
                                            attJson.put("tpv_printingmethod", "E");
                                            json.put(tpvSignfilename, attJson);
                                            query.set("tpv_attachmentcon_tag", json);
                                            SaveServiceHelper.update(query);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            SaveServiceHelper.update(query);
        }
    }


    //对方单签
    public void OhterSignature(DynamicObject[] queryHW, String tpvSignfilename, String tpvSealstatus) {
        OhterSignature(queryHW, tpvSignfilename, tpvSealstatus, false);
    }

    private static void OhterSignature(DynamicObject[] queryHW, String tpvSignfilename, String tpvSealstatus, Boolean bill) {
        String tpvInquiry = "";//预审标记
        String tpvSignaturestatus = "";//签章情况
        if (queryHW.length > 0) {
            DynamicObject query = queryHW[0];
            String tpvAttachmentconTag = query.getString("tpv_attachmentcon_tag");
            JSONObject json = JSONObject.parseObject(tpvAttachmentconTag);
            if (json != null) {
                if (bill) {
                    Set<String> strings = json.keySet();
                    if (strings.size() > 0 && null != strings) {
                        for (String names : strings) {
                            if (json != null) {
                                JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                                if (tpv_sourcebillkey != null) {
                                    if (names.equals(tpvSignfilename)) {
                                        tpvInquiry = (String) tpv_sourcebillkey.get("tpv_inquiry");
                                        tpvSignaturestatus = (String) tpv_sourcebillkey.get("tpv_signaturestatus");
                                    }
                                }

                            }
                        }
                    }
                    JSONObject attJson = new JSONObject();
                    if (YEM.isNotEmpty(tpvSignaturestatus)) {
                        if ("A".equals(tpvSignaturestatus)) {
                            tpvSignaturestatus = "C";
                        } else {
                            tpvSignaturestatus = "B";
                        }
                    }
                    attJson.put("tpv_lock", true);
                    attJson.put("tpv_signaturestatus", "B");
                    attJson.put("tpv_sealstatus", "M");
                    attJson.put("tpv_printingmethod", "C");
                    attJson.put("tpv_uplink", "1821094233772156928");
                    attJson.put("tpv_inquiry", tpvInquiry);
                    json.put("签-" + tpvSignfilename, attJson);
                    query.set("tpv_attachmentcon_tag", json);
                    SaveServiceHelper.update(query);
                } else {
                    Set<String> strings = json.keySet();
                    if (strings.size() > 0 && null != strings) {
                        for (String names : strings) {
                            if (json != null) {
                                JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                                if (tpv_sourcebillkey != null) {
                                    if (names.equals(tpvSignfilename)) {
                                        JSONObject attJson = json.containsKey(tpvSignfilename) ? json.getJSONObject(tpvSignfilename) : new JSONObject();
                                        tpvSealstatus = (String) tpv_sourcebillkey.get("tpv_sealstatus");
                                        if (!"G".equals(tpvSealstatus)) {
                                            attJson.put("tpv_sealstatus", "G");
                                            attJson.put("tpv_printingmethod", "C");
                                            json.put(tpvSignfilename, attJson);
                                            query.set("tpv_attachmentcon_tag", json);
                                            SaveServiceHelper.update(query);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            SaveServiceHelper.update(query);
        }
    }

    //对方单签，已撤回
    public void OhterSignature(DynamicObject[] queryHW, String tpvSignfilename, String tpvSealstatus, String status) {
        if (queryHW.length > 0) {
            DynamicObject query = queryHW[0];
            String tpvAttachmentconTag = query.getString("tpv_attachmentcon_tag");
            JSONObject json = JSONObject.parseObject(tpvAttachmentconTag);
            if (json != null) {
                Set<String> strings = json.keySet();
                if (strings.size() > 0 && null != strings) {
                    for (String names : strings) {
                        if (json != null) {
                            JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                            if (tpv_sourcebillkey != null) {
                                if (names.equals(tpvSignfilename)) {
                                    JSONObject attJson = json.containsKey(tpvSignfilename) ? json.getJSONObject(tpvSignfilename) : new JSONObject();
                                    attJson.put("tpv_sealstatus", status);
                                    json.put(tpvSignfilename, attJson);
                                    query.set("tpv_attachmentcon_tag", json);
                                    SaveServiceHelper.update(query);
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    //
    private static void autoExtracted(DynamicObject[] queryHW, String tpvSignfilename, String tpvSealstatus, Boolean bill) {
        String tpvInquiry = "";//预审标记
        String tpvSignaturestatus = "";//签章情况
        if (queryHW.length > 0) {
            DynamicObject query = queryHW[0];
            String tpvAttachmentconTag = query.getString("tpv_attachmentcon_tag");
            JSONObject json = JSONObject.parseObject(tpvAttachmentconTag);
            if (json != null) {
                if (bill) {
                    JSONObject attJson = new JSONObject();
                    attJson.put("tpv_lock", true);
                    attJson.put("tpv_sealstatus", "K");//自动签完成
                    attJson.put("tpv_signaturestatus", "A");
                    attJson.put("tpv_inquiry", tpvInquiry);
                    json.put("签-" + tpvSignfilename, attJson);
                    query.set("tpv_attachmentcon_tag", json);
                    SaveServiceHelper.update(query);
                }
//                else {
//                    Set<String> strings = json.keySet();
//                    if (strings.size() > 0 && null != strings) {
//                        for (String names : strings) {
//                            if (json != null) {
//                                JSONObject tpv_sourcebillkey = json.getJSONObject(names);
//                                if (tpv_sourcebillkey != null) {
//                                    if (names.equals(tpvSignfilename)) {
//                                        JSONObject attJson = json.containsKey(tpvSignfilename) ? json.getJSONObject(tpvSignfilename) : new JSONObject();
//                                        tpvSealstatus = (String) tpv_sourcebillkey.get("tpv_sealstatus");
//                                        if (!"G".equals(tpvSealstatus)) {
//                                            attJson.put("tpv_sealstatus", "G");
//                                            attJson.put("tpv_printingmethod", "B");
//                                            json.put(tpvSignfilename, attJson);
//                                            query.set("tpv_attachmentcon_tag", json);
//                                            SaveServiceHelper.update(query);
//                                        }
//                                    }
//                                }
//
//                            }
//                        }
//                    }
//                }
            }
            SaveServiceHelper.update(query);
        }
    }

    //我方单签
    public void extracted(DynamicObject[] queryHW, String tpvSignfilename, String tpvSealstatus) {
        extracted(queryHW, tpvSignfilename, tpvSealstatus, false);
    }

    private static void extracted(DynamicObject[] queryHW, String tpvSignfilename, String tpvSealstatus, Boolean bill) {
        String tpvInquiry = "";//预审标记
        String tpvSignaturestatus = "";//签章情况
        if (queryHW.length > 0) {
            DynamicObject query = queryHW[0];
            String tpvAttachmentconTag = query.getString("tpv_attachmentcon_tag");
            JSONObject json = JSONObject.parseObject(tpvAttachmentconTag);
            if (json != null) {
                if (bill) {
                    Set<String> strings = json.keySet();
                    if (strings.size() > 0 && null != strings) {
                        for (String names : strings) {
                            if (json != null) {
                                JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                                if (tpv_sourcebillkey != null) {
                                    if (names.equals(tpvSignfilename)) {
                                        tpvInquiry = (String) tpv_sourcebillkey.get("tpv_inquiry");
                                        tpvSignaturestatus = (String) tpv_sourcebillkey.get("tpv_signaturestatus");
                                    }
                                }

                            }
                        }
                    }
                    JSONObject attJson = new JSONObject();
                    if (YEM.isNotEmpty(tpvSignaturestatus)) {
                        if ("B".equals(tpvSignaturestatus)) {
                            tpvSignaturestatus = "B";
                        } else {
                            tpvSignaturestatus = "A";
                        }
                    }
                    attJson.put("tpv_lock", true);
                    attJson.put("tpv_signaturestatus", "A");
                    attJson.put("tpv_sealstatus", "M");
                    attJson.put("tpv_printingmethod", "B");
                    attJson.put("tpv_uplink", "1821094233772156928");
                    attJson.put("tpv_inquiry", tpvInquiry);
                    json.put("签-" + tpvSignfilename, attJson);
                    query.set("tpv_attachmentcon_tag", json);
                    SaveServiceHelper.update(query);
                } else {
                    Set<String> strings = json.keySet();
                    if (strings.size() > 0 && null != strings) {
                        for (String names : strings) {
                            if (json != null) {
                                JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                                if (tpv_sourcebillkey != null) {
                                    if (names.equals(tpvSignfilename)) {
                                        JSONObject attJson = json.containsKey(tpvSignfilename) ? json.getJSONObject(tpvSignfilename) : new JSONObject();
                                        tpvSealstatus = (String) tpv_sourcebillkey.get("tpv_sealstatus");
                                        if (!"G".equals(tpvSealstatus)) {
                                            attJson.put("tpv_sealstatus", "G");
                                            attJson.put("tpv_printingmethod", "B");
                                            json.put(tpvSignfilename, attJson);
                                            query.set("tpv_attachmentcon_tag", json);
                                            SaveServiceHelper.update(query);
                                        }
                                    }
                                }

                            }
                        }
                    }
                }
            }
            SaveServiceHelper.update(query);
        }
    }

    private InputStream getInputStream(String url) {
        InputStream inputStream = null;
        try {
            URLConnection urlConnection = new URL(url).openConnection();
            HttpURLConnection httpURLConnection = (HttpURLConnection) urlConnection;
            httpURLConnection.setConnectTimeout(1000 * 5);
            httpURLConnection.setDoOutput(true);
            httpURLConnection.setDoInput(true);
            httpURLConnection.setUseCaches(false);
            httpURLConnection.setRequestProperty("Connection", "Keep-Alive");
            httpURLConnection.setRequestProperty("Charset", "UTF-8");
            httpURLConnection.connect();

            inputStream = httpURLConnection.getInputStream();
        } catch (Exception e1) {
            e1.printStackTrace();
        }
        return inputStream;
    }

    /**
     * 获取url
     *
     * @param appId    应用标识
     * @param formId   单据标识
     * @param pkId     单据内码
     * @param fileName 文件名
     * @param stream   接口返回的base64转的文件流
     * @return url
     * @throws IOException
     */
    private static String url(String appId, String formId, String pkId, String fileName, InputStream stream) throws IOException {
        Date today = new Date();
        DateFormat df = new SimpleDateFormat("yyyyMM");
        String NewDateStr = df.format(today);
        String attachmentPath = "/" + RequestContext.get().getTenantId() + "/" + RequestContext.get().getAccountId()
                + "/" + NewDateStr + "/" + appId + "/" + formId + "/" + pkId + "/attachments/";
        FileService fs = FileServiceFactory.getAttachmentFileService();
        String path = attachmentPath + fileName;
        FileItem fi = new FileItem(fileName, path, stream);//"接口返回的base64转的文件流")
        fi.setCreateNewFileWhenExists(true);
        String url = fs.upload(fi);
        return url;
    }

    public static String getbase64(String url) {
        InputStream inputStream = null;
        String base64 = "";
        byte input[] = null;
        try {
            URLConnection urlConnection = new URL(url).openConnection();
            HttpURLConnection httpURLConnection = (HttpURLConnection) urlConnection;
            httpURLConnection.setConnectTimeout(1000 * 5);
            httpURLConnection.setDoOutput(true);
            httpURLConnection.setDoInput(true);
            httpURLConnection.setUseCaches(false);
            httpURLConnection.setRequestProperty("Connection", "Keep-Alive");
            httpURLConnection.setRequestProperty("Charset", "UTF-8");
            httpURLConnection.connect();

            inputStream = httpURLConnection.getInputStream();
            ByteArrayOutputStream bytestream = new ByteArrayOutputStream();
            byte[] buffer = new byte[1024];
            int ch;
            while ((ch = inputStream.read(buffer)) != -1) {
                bytestream.write(buffer, 0, ch);
            }
            input = bytestream.toByteArray();
            bytestream.close();
            base64 = Base64.getEncoder().encodeToString(input);

        } catch (Exception e1) {
            e1.printStackTrace();
        }
        return base64;
    }
}
