package tpv.tpv_wm.tpv_iscb.java.api.sealstewardapi;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.openapi.common.custom.annotation.*;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import java.util.Date;
import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.HashMap;
import java.util.Set;

/**
 * @Author: Heisenberg Wenbei He
 * @Project: zhck
 * @Package: com.itopview.wm.dt.api.sealStewardApi.sealStewardApi
 * @Date: 18:49 2023/10/26
 * @Description: 章管家回调用印结果
 * @Version: 1.0
 */
@ApiController(value = "applicationForSeal", desc = "章管家回调用印结果")
@ApiMapping("tpv/applicationForSeal")

@ApiErrorCodes({
        @ApiErrorCode(code = "404", desc = "路径访问错误")
})
public class SealStewardsApiController implements Serializable {
    @ApiPostMapping(value = "updateSealStatus", desc = "章管家回调用印结果")
    public CustomApiResult<SealStewardResponseApiModel> updateSealStatus(
            @NotNull @Valid @ApiRequestBody(value = "请输入参数") SealStewardRequestClientModel model) {
        SealStewardResponseApiModel responseApiModel = new SealStewardResponseApiModel();

        String id = model.getId();
        int recordStatus = model.getRecord_status();

        String selectfields = DynamicObjectUtil.getSelectfields("tpv_iscb_steward", false);
        QFilter qFilter = new QFilter("tpv_serialnumber", QCP.equals, id);
        // qFilter.and("tpv_serialnumber", QCP.equals, tpv_serialnumber);
        DynamicObject[] load = BusinessDataServiceHelper.load("tpv_iscb_steward", selectfields, qFilter.toArray());
        if (load.length > 0) {
            Date newData =new Date();
            DynamicObject signInfo = load[0];
            DynamicObject tpvBills = signInfo.getDynamicObject("tpv_sourcebills");//单据
            String tpvBillsid = signInfo.getString("tpv_billsid");//单据内码
            String tpvAttacname = signInfo.getString("tpv_attacname");
            signInfo.set("tpv_status", recordStatus);
            signInfo.set("tpv_syntonytime",newData);
            SaveServiceHelper.save(new DynamicObject[]{signInfo});
            Long tpvBillsids = Long.valueOf(tpvBillsid);
            QFilter[] qFilters = new QFilter[]{new QFilter("id", QCP.equals, tpvBillsids)};
            String number = tpvBills.getString("number");//单据标识
            String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast(number);
            DynamicObject[] queryDj = BusinessDataServiceHelper.load(number, selectfieldsFast, qFilters);
            extracted(queryDj, recordStatus, tpvAttacname);
        }
        responseApiModel.setErrcode(0);
        responseApiModel.setErrmsg("请求成功!");

        return CustomApiResult.success(responseApiModel);
    }

    private static void extracted(DynamicObject[] queryHW, int recordStatus, String tpvAttacname) {
        if (queryHW.length > 0) {
            DynamicObject query = queryHW[0];
            String tpvAttachmentconTag = query.getString("tpv_attachmentcon_tag");
            JSONObject json = JSONObject.parseObject(tpvAttachmentconTag);
            if (json != null) {
                Set<String> strings = json.keySet();
                if (strings.size() > 0 && null != strings) {
                    for (String names : strings) {
                        if (json != null) {
                            JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                            if (tpv_sourcebillkey != null) {
                                if (names.equals(tpvAttacname)) {
                                    JSONObject attJson = json.containsKey(tpvAttacname) ? json.getJSONObject(tpvAttacname) : new JSONObject();
                                    if (recordStatus == 2) {
                                        attJson.put("tpv_sealstatus", "H");
                                    } else {
                                        attJson.put("tpv_sealstatus", "P");
                                    }
                                    json.put(tpvAttacname, attJson);
                                    query.set("tpv_attachmentcon_tag", json);
                                    SaveServiceHelper.update(query);
                                }
                            }
                        }
                    }
                }
            }
        }
    }

}
