package tpv.tpv_wm.tpv_iscb.java.api.shipnewsapi;

import java.util.HashMap;
import java.util.Map;

/**
 * @Author: Heisenberg Wenbei He
 * @Project: zhkc
 * @Package: com.itopview.wm.dt.task.ShipTypeCodeConveter
 * @Date: 09:12 2023/09/15
 * @Description: 、船舶类型代号转船舶类型名称
 * @Version: 7.0
 */
public final class ShipNewsTypeCodeConverter {
    private ShipNewsTypeCodeConverter() {
    }

    private static Map<Integer, String> shipTypes;

    static {
        shipTypes = new HashMap<>();
        shipTypes.put(50, "引航船");
        shipTypes.put(51, "搜救船");
        shipTypes.put(52, "拖轮");
        shipTypes.put(53, "港口供应船");
        shipTypes.put(54, "载有防污染装置和设备的船舶");
        shipTypes.put(55, "执法艇");
        shipTypes.put(56, "备用-用于当地船舶的任务分配");
        shipTypes.put(57, "备用-用于当地船舶的任务分配");
        shipTypes.put(58, "医疗船 (如 1949 年日内瓦公约及附加条款所规定)");
        shipTypes.put(59, "符合 18 号决议 (Mob-83) 的船舶");
        shipTypes.put(30, "捕捞");
        shipTypes.put(31, "拖引");
        shipTypes.put(32, "拖引并且船长 > 200m 或船宽 > 25m");
        shipTypes.put(33, "疏浚或水下作业");
        shipTypes.put(34, "潜水作业");
        shipTypes.put(35, "参与军事行动");
        shipTypes.put(36, "帆船航行");
        shipTypes.put(37, "娱乐船");
        shipTypes.put(100, "集装箱");
        shipTypes.put(90, "其他类型的船舶");
    }

    public static String getShipType(int shipTypeCode) {
        String result;
        if (shipTypes.containsKey(shipTypeCode)) {
            result = shipTypes.get(shipTypeCode);
        } else if (shipTypeCode >= 20 && shipTypeCode <= 29) {
            result = "地效应船";
        } else if (shipTypeCode >= 40 && shipTypeCode <= 49) {
            result = "高速船";
        } else if (shipTypeCode >= 60 && shipTypeCode <= 69) {
            result = "客船";
        } else if (shipTypeCode >= 70 && shipTypeCode <= 79) {
            result = "货船";
        } else if (shipTypeCode >= 80 && shipTypeCode <= 89) {
            result = "油轮";
        } else {
            result = "未知船舶类型";
        }
        return result;
    }
}
