package tpv.tpv_wm.tpv_iscb.java.api.xiaoyi;

import com.itopview.wm.sys.api.yargonpdfapi.model.*;
import com.itopview.wm.sys.utils.Api;
import com.itopview.wm.sys.utils.ApiHelper;
import com.itopview.wm.sys.utils.ApiLog;
import com.itopview.wm.utils.HttpHelper;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.IBillWebApiPlugin;
import kd.bos.openapi.common.result.CustomApiResult;
import net.sf.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

/**
 * 易氩接口
 * @author LiuHB
 * @version 1.0
 */
public class PdfFileController implements IBillWebApiPlugin {

    /**
     * 1API-Y1向易氩传递原附件并要求生成PDF
     * @param pdfFileModel
     * @return
     */
    public static CustomApiResult<Map> pdfFile(PdfFileModel pdfFileModel) {
        ApiHelper apiHelper = new ApiHelper("hwapp.enrobot");
        JSONObject pdfFile = null;
        String code = "";
        if (apiHelper.isExist()) {
            Api api = apiHelper.getApi("creatpdf");
            if (api.isExist()) {
                String url = api.getUrl();
                ApiLog log = apiHelper.log(api);
                HashMap<String, String> headers = new HashMap<>();
                headers.put("Message-Reference", "a");
                headers.put("Message-Reference-Date", "");
                headers.put("Accept-Language", "chi");
                headers.put("Authorization", "a");
                String httpPost = "";

                try {
                    httpPost = HttpHelper.httpPost(url, headers, pdfFileModel.toString());
                    // 解析json数据
                    pdfFile = JSONObject.fromObject(httpPost);
                    // 获取状态码
                    code = pdfFile.getString("code");
                    //如果 code==000，log.setSuccess(true);不等于log.setSuccess(false);
//                    pdfFile.put("code","000");

                } catch (Exception e) {
                    e.printStackTrace();
                    log.setErrorMsg(YEM.exceptionToStr(e));
                } finally {
                    if ("000".equals(code)) {
                        log.setRequestData(pdfFileModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(true);
                        log.write();
                        return CustomApiResult.success(pdfFile);
                    } else {
                        log.setRequestData(pdfFileModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(false);
                        log.write();
                        return CustomApiResult.fail("500", "FALL");
                    }
                }
            }
        }
        return CustomApiResult.fail("500", "接口未登记");
    }

    /**
     * 文本PDF→图片PDF接口
     *
     * @param imagePdfModel
     * @return
     */
    public static CustomApiResult<Map> imagepdf(ImagePdfModel imagePdfModel) {
        ApiHelper apiHelper = new ApiHelper("hwapp.enrobot");
        JSONObject imagePdf = null;
        String code = "";
        if (apiHelper.isExist()) {
            Api api = apiHelper.getApi("imagePdf");
            if (api.isExist()) {
                String url = api.getUrl();
                ApiLog log = apiHelper.log(api);
                HashMap<String, String> headers = new HashMap<>();
                headers.put("Message-Reference", "a");
                headers.put("Message-Reference-Date", "");
                headers.put("Accept-Language", "chi");
                headers.put("Authorization", "a");
                String httpPost = "";
                try {
                    httpPost = HttpHelper.httpPost(url, headers, imagePdfModel.toString());
                    // 解析json数据
                    imagePdf = JSONObject.fromObject(httpPost);
                    // 获取状态码
                    code = imagePdf.getString("code");

                    if ("000".equals("code")) {
                        String pdfFileName = imagePdf.getString("pdfFileName");
                        String pdfBase64 = imagePdf.getString("pdfBase64");

                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    log.setErrorMsg(YEM.exceptionToStr(e));
                } finally {
                    if ("000".equals(code)) {
                        log.setRequestData(imagePdfModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(true);
                        log.write();
                        return CustomApiResult.success(imagePdf);
                    } else {
                        log.setRequestData(imagePdfModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(false);
                        log.write();
                        return CustomApiResult.fail("500", "FALL");
                    }
                }
            }
        }
        return CustomApiResult.fail("500", "接口未登记");
    }


    /**
     * 合同比对接口
     *
     * @param pactContrastModel
     * @return
     */

    public static CustomApiResult<Map> actContrast(PactContrastModel pactContrastModel) {
        ApiHelper apiHelper = new ApiHelper("hwapp.enrobot");
        JSONObject pactContrast = null;
        String code = "";
        if (apiHelper.isExist()) {
            Api api = apiHelper.getApi("actContrast");
            if (api.isExist()) {
                String url = api.getUrl();
                ApiLog log = apiHelper.log(api);
                HashMap<String, String> headers = new HashMap<>();
                headers.put("Message-Reference", "a");
                headers.put("Message-Reference-Date", "");
                headers.put("Accept-Language", "chi");
                headers.put("Authorization", "a");
                String httpPost = "";
                try {
                    httpPost = HttpHelper.httpPost(url, headers, pactContrastModel.toString());
                    // 解析json数据
                    pactContrast = JSONObject.fromObject(httpPost);
                    // 获取状态码
                    code = pactContrast.getString("code");

//                    if ("000".equals("code")) {
//                        String pdfFileName = pactContrast.getString("pdfFileName");
//                        String pdfBase64 = pactContrast.getString("pdfBase64");
//
//                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    log.setErrorMsg(YEM.exceptionToStr(e));
                } finally {
                    if ("000".equals(code)) {
                        log.setRequestData(pactContrastModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(true);
                        log.write();
                        return CustomApiResult.success(pactContrast);
                    } else {
                        log.setRequestData(pactContrastModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(false);
                        log.write();
                        return CustomApiResult.fail("500", "FALL");
                    }
                }
            }
        }
        return CustomApiResult.fail("500", "接口未登记");
    }


    /**
     * 添加用户接口
     *
     * @param addUserModel
     * @return
     */
    public static CustomApiResult<Map> addUserByCode(AddUserModel addUserModel) {
        ApiHelper apiHelper = new ApiHelper("hwapp.enrobot");
        JSONObject addUser = null;
        String code = "";
        if (apiHelper.isExist()) {
            Api api = apiHelper.getApi("addUserByCode");
            if (api.isExist()) {
                String url = api.getUrl();
                ApiLog log = apiHelper.log(api);
                HashMap<String, String> headers = new HashMap<>();
                headers.put("Message-Reference", "a");
                headers.put("Message-Reference-Date", "");
                headers.put("Accept-Language", "chi");
                headers.put("Authorization", "a");
                String httpPost = "";
                try {
                    httpPost = HttpHelper.httpPost(url, headers, addUserModel.toString());
                    // 解析json数据
                    addUser = JSONObject.fromObject(httpPost);
                    // 获取状态码
                    code = addUser.getString("code");
//                    if ("000".equals("code")) {
//                        String pdfFileName = addUser.getString("pdfFileName");
//                        String pdfBase64 = addUser.getString("pdfBase64");
//
//                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    log.setErrorMsg(YEM.exceptionToStr(e));
                } finally {
                    if ("000".equals(code)) {
                        log.setRequestData(addUserModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(true);
                        log.write();
                        return CustomApiResult.success(addUser);
                    } else {
                        log.setRequestData(addUserModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(false);
                        log.write();
                        return CustomApiResult.fail("500", "FALL");
                    }
                }
            }
        }
        return CustomApiResult.fail("500", "接口未登记");
    }

    /**
     * 禁用用户接口
     *
     * @param invalidUserModel
     * @return
     */
    public static CustomApiResult<Map> invalidUser(InvalidUserModel invalidUserModel) {
        ApiHelper apiHelper = new ApiHelper("hwapp.enrobot");
        JSONObject invalidUser = null;
        String code = "";
        if (apiHelper.isExist()) {
            Api api = apiHelper.getApi("invalidUser");
            if (api.isExist()) {
                String url = api.getUrl();
                ApiLog log = apiHelper.log(api);
                HashMap<String, String> headers = new HashMap<>();
                headers.put("Message-Reference", "a");
                headers.put("Message-Reference-Date", "");
                headers.put("Accept-Language", "chi");
                headers.put("Authorization", "a");
                String httpPost = "";
                try {
                    httpPost = HttpHelper.httpPost(url, headers, invalidUserModel.toString());
                    // 解析json数据
                    invalidUser = JSONObject.fromObject(httpPost);
                    // 获取状态码
                    code = invalidUser.getString("code");
//                    if ("000".equals("code")) {
//                        String pdfFileName = invalidUser.getString("pdfFileName");
//                        String pdfBase64 = invalidUser.getString("pdfBase64");
//                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    log.setErrorMsg(YEM.exceptionToStr(e));
                } finally {
                    if ("000".equals(code)) {
                        log.setRequestData(invalidUserModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(true);
                        log.write();
                        return CustomApiResult.success(invalidUser);
                    } else {
                        log.setRequestData(invalidUserModel.toString());
                        log.setResponseData(httpPost);
                        log.setSuccess(false);
                        log.write();
                        return CustomApiResult.fail("500", "FALL");
                    }
                }
            }
        }
        return CustomApiResult.fail("500", "接口未登记");
    }


    /**
     * 抓取回传接口(开放)
     *
     * @param grabPostbackModel
     * @return
     */
    public static CustomApiResult<Map> GrabPostback(GrabPostbackModel grabPostbackModel) {

        return CustomApiResult.fail("500", "接口未登记");
    }

}


