package tpv.tpv_wm.tpv_iscb.java.api.xiaoyi;

import static com.itopview.wm.utils.AttachmentUtil.uploadAttachmentPanel;
import static com.itopview.wm.utils.FileUtil.base64FileSize;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;

import kd.bos.bill.OperationStatus;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.fileservice.FileItem;
import kd.bos.fileservice.FileService;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.openapi.common.custom.annotation.ApiController;
import kd.bos.openapi.common.custom.annotation.ApiMapping;
import kd.bos.openapi.common.custom.annotation.ApiPostMapping;
import kd.bos.openapi.common.custom.annotation.ApiRequestBody;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

@ApiController(value = "tpv_xiaoyi", desc = "xiaoyi")
@ApiMapping("/tpv/xiaoyi")
public class XiaoyiController implements Serializable {
    private static final long serialVersionUID = 1L;

    @ApiPostMapping(value = "sendPdfFile", desc = "pdf回调")
    public CustomApiResult<Map<String, Object>> sendPdfFile(@NotNull @Valid @ApiRequestBody(value = "参数") Map<String, Object> map) {
        Map maps = (Map) map.get("params");
        DynamicObject[] iscb_asynchronous =null;
        DynamicObject entry=null;
        String dybase64 ="";
        String sealapply_id = (String) maps.get("sealapply_id");//用印申请ID
        String attachment_id = (String) maps.get("attachment_id");//附件ID
        String tpv_filebase64 = (String) maps.get("base64");//Pdf的base64串
        Map<String, Object> resultData = new HashMap<>();
        resultData.put("resultCode", "0");
        resultData.put("resultMsg", "接收成功！");

        String selectfields = DynamicObjectUtil.getSelectfields("tpv_iscb_yataskinfo", false);
        QFilter qFilter = new QFilter("tpv_filestatus", QCP.equals, "A");
        qFilter.and("tpv_sealapplyid", QCP.equals, sealapply_id);
        DynamicObject[] load = BusinessDataServiceHelper.load("tpv_iscb_yataskinfo", selectfields, qFilter.toArray());
        if(load.length != 0) {
            for (DynamicObject yataskinfo : load) {
                yataskinfo.set("tpv_filebase64_tag", tpv_filebase64);
                yataskinfo.set("tpv_filestatus", "B");
                Date date = new Date();
                yataskinfo.set("tpv_syntonytime", date);
                String tpvBillsid = yataskinfo.getString("tpv_billsid");//单据内码
                String tpvAppid = yataskinfo.getString("tpv_appid");//单据内码
                Long tpvCurruserid = yataskinfo.getLong("tpv_curruserid");//操作人
                Long tpvBillsids = Long.valueOf(tpvBillsid);
                String tpvStatus = yataskinfo.getString("tpv_status");//
                String method = yataskinfo.getString("tpv_method");//
                DynamicObject tpvBills = yataskinfo.getDynamicObject("tpv_sourcebills");//单据
                String number = tpvBills.getString("number");//单据标识
                String attacNameTwo = yataskinfo.getString("tpv_attacname");//附件名称
                String attacName = yataskinfo.getString("tpv_attacname");//附件名称.pdf
                int i = attacName.lastIndexOf(".");
                attacName = attacName.substring(0, i);
                attacName = attacName+".pdf";
                String operate = yataskinfo.getString("tpv_operate");//执行操作
                String tpvSerialnumber = yataskinfo.getString("tpv_serialnumber");//预审序列号
                String tpvDigitnumber = yataskinfo.getString("tpv_digitnumber");//预审码
                QFilter[] qFilters = new QFilter[]{new QFilter("id", QCP.equals, tpvBillsids)};
                String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast(number);
                DynamicObject[] queryDj = BusinessDataServiceHelper.load(number, selectfieldsFast, qFilters);
                byte[] bytes = Base64.getDecoder().decode(tpv_filebase64);
                double size = base64FileSize(tpv_filebase64);
                int sizes= (int) size;
                ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream(bytes);
                String url = "";
                try {
                    url = url(tpvAppid, tpvBillsid, number, attacName, byteArrayInputStream);
                } catch (IOException e) {
                    String message = e.getMessage();
                    if (!"".equals(message)) {
                        resultData.put("resultMsg", message);
                    }
                    throw new RuntimeException(e);
                }
                if ("A".equals(operate)) {//打印
                    if(load.length>0){
                        Long asynchronousid=yataskinfo.getLong("tpv_asynchronousid");//打印id
                        int row=yataskinfo.getInt("tpv_asynchronousrow");//打印分录行号
                        String selectfield = DynamicObjectUtil.getSelectfields("tpv_iscb_asynchronous", false);
                        selectfield=DynamicObjectUtil.getEntrySelectfields(selectfield,"tpv_iscb_asynchronous","tpv_iscb_asynchr_cl",false);
                        QFilter qFilterx = new QFilter("id", QCP.equals, asynchronousid);
                        iscb_asynchronous = BusinessDataServiceHelper.load("tpv_iscb_asynchronous", selectfield, qFilterx.toArray());
                        iscb_asynchronous[0].set("tpv_atcontent",tpv_filebase64);//当前内容
                        iscb_asynchronous[0].set("tpv_yataskinfoid",asynchronousid);//易氩任务底表id
                        entry=iscb_asynchronous[0].getDynamicObjectCollection("tpv_iscb_asynchr_cl").get(row-1);
                        entry.set("tpv_state","A");//状态完成
                    }
                        SaveServiceHelper.update(iscb_asynchronous);
                }
                if ("B".equals(operate)) {//预审
                    uploadAttachmentPanel(number, tpvBillsid, "attachmentpanel",  "预审件-" +attacName, url, tpvCurruserid,sizes);
                    extracted(queryDj, attacName, attacNameTwo,tpvStatus,tpvSerialnumber,tpvDigitnumber,method);
                    extracted(queryDj, attacName, attacNameTwo,true, tpvStatus,tpvSerialnumber,tpvDigitnumber,method);
                    SaveServiceHelper.save(queryDj);
                }
            }
        }else{
            resultData.put("resultMsg","未查找到对应单据");
        }
        SaveServiceHelper.save(load);
        return CustomApiResult.success(resultData);
    }

    /**
     * 获取url
     *
     * @param appId    应用标识
     * @param formId   单据标识
     * @param pkId     单据内码
     * @param fileName 文件名
     * @param stream   接口返回的base64转的文件流
     * @return url
     * @throws IOException
     */
    private static String url(String appId, String formId, String pkId, String fileName, InputStream stream) throws IOException {
        Date today = new Date();
        DateFormat df = new SimpleDateFormat("yyyyMM");
        String NewDateStr = df.format(today);
        String attachmentPath = "/" + RequestContext.get().getTenantId() + "/" + RequestContext.get().getAccountId()
                + "/" + NewDateStr + "/" + appId + "/" + formId + "/" + pkId + "/attachments/";
        FileService fs = FileServiceFactory.getAttachmentFileService();
        String path = attachmentPath + fileName;
        FileItem fi = new FileItem(fileName, path, stream);//"接口返回的base64转的文件流")
        fi.setCreateNewFileWhenExists(true);
        String url = fs.upload(fi);
        return url;
    }

    //预审
    public void extracted(DynamicObject[] queryHW,String tpvSignfilename, String attacNameTwo,String tpvStatus,String tpvDigitnumber,String tpvSerialnumber,String method) {
        extracted(queryHW, tpvSignfilename,attacNameTwo, false,tpvStatus,tpvDigitnumber,tpvSerialnumber,method);
    }

    private static void extracted(DynamicObject[] queryHW, String tpvSignfilename,  String attacNameTwo,Boolean bill,String tpvStatus,String tpvDigitnumber,String tpvSerialnumber,String method) {
        if (queryHW.length > 0) {
            DynamicObject query = queryHW[0];
            String printingmethod="";
            String tpvAttachmentconTag = query.getString("tpv_attachmentcon_tag");
            JSONObject json = JSONObject.parseObject(tpvAttachmentconTag);
            if (json != null) {
                if (bill) {
                    JSONObject attJson = new JSONObject();
                    attJson.put("tpv_inquiry", "B");
                    attJson.put("tpv_sealstatus",tpvStatus);
                    attJson.put("tpv_printingmethod",method);
                    attJson.put("tpvDigitnumber",tpvDigitnumber);//预审码
                    attJson.put("tpvSerialnumber",tpvSerialnumber);//预审序列号
                    json.put("预审件-" + tpvSignfilename, attJson);
                    attJson.put("attachmentnames", tpvSignfilename);
                    attJson.put("attacNameTwo", attacNameTwo);
                    query.set("tpv_attachmentcon_tag", json);
                    SaveServiceHelper.update(query);
                } else {
                    Set<String> strings = json.keySet();
                    if (strings.size() > 0 && null != strings) {
                        for (String names : strings) {
                            if (json != null) {
                                JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                                if (tpv_sourcebillkey != null) {
                                    if (names.equals(attacNameTwo)) {
                                        JSONObject attJson = json.containsKey(attacNameTwo) ? json.getJSONObject(attacNameTwo) : new JSONObject();
                                        attJson.put("tpv_inquiry", "B");
                                        json.put(attacNameTwo, attJson);
                                        query.set("tpv_attachmentcon_tag", json);
                                        SaveServiceHelper.update(query);
                                    }
                                }
                            }
                        }
                    }
                }
            }
            SaveServiceHelper.update(query);
        }
    }

    private static void previewUrl(IFormView view, String previewUrl) {
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.EDIT);
        showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
        showParameter.setFormId("bos_printpreview");//打印预览页面
        showParameter.setCustomParam("src", previewUrl);
        view.showForm(showParameter);
    }
}
