package tpv.tpv_wm.tpv_iscb.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.sys.api.yargonpdfapi.PdfFileController;
import com.itopview.wm.sys.api.yargonpdfapi.model.PdfFileModel;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.OperationStatus;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.property.BasedataProp;
import kd.bos.entity.property.TextProp;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.TextEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import org.apache.commons.lang3.StringUtils;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.util.*;

/**
 * @ClassName 欢迎用印动态表单插件
 * @Description TODO
 * @Author yhj
 * @Date 2023/10/16 18:15
 * @Version 1.0
 */
public class PrintingFunctionEdit extends AbstractFormPlugin implements BeforeF7SelectListener {
    /**
     * @param null
     * @return
     * @ClassName 监听按钮
     * @Description TODO
     * @author yhj
     * @date 2023/11/17 14:42
     */
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        // 侦听文本字段按钮点击事件
        this.addClickListeners("btnok", "btncancel", "tpv_othersignatory", "tpv_preview");
        BasedataEdit fieldEdit = this.getView().getControl("tpv_selectstamp");
        fieldEdit.addBeforeF7SelectListener(this);
    }

    /**
     * @param null
     * @return
     * @ClassName 设置必录
     * @Description TODO
     * @author yhj
     * @date 2023/11/17 14:42
     */
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        IDataModel parentModel = this.getView().getParentView().getModel();
        String propertyName = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        ChangeData changeData = e.getChangeSet()[0];
        int rowIndex = changeData.getRowIndex();
        IFormView parentView = this.getView().getParentView(); //父视图
        switch (propertyName) {
            case "tpv_sealstatus":
                // 获取用印方式
                String sealstatus = (String) model.getValue("tpv_sealstatus");
                String identification = parentView.getEntityId();
                DynamicObject org = (DynamicObject) parentModel.getValue("org");
                Long id = org.getLong("id");//公司名称
                if (YEM.isNotEmpty(sealstatus)) {
                    if (!"F".equals(sealstatus)) {
                        BasedataEdit edit = this.getView().getControl("tpv_selectstamp");//印章
                        edit.setMustInput(true);
                        BasedataProp property = (BasedataProp) edit.getProperty();
                        property.setMustInput(true);
                    } else {
                        BasedataEdit edit = this.getView().getControl("tpv_selectstamp");//印章
                        edit.setMustInput(false);
                        BasedataProp property = (BasedataProp) edit.getProperty();
                        property.setMustInput(false);
                    }
                    //对方企业名称
                    if ("C".equals(sealstatus) || "D".equals(sealstatus) || "E".equals(sealstatus)) {
                        this.getView().setVisible(true, "tpv_othercompanyname", "tpv_othersignatory");
                        TextEdit edit = this.getView().getControl("tpv_othercompanyname");
                        edit.setMustInput(true);
                        TextProp property = (TextProp) edit.getProperty();
                        property.setMustInput(true);
                        TextEdit edits = this.getView().getControl("tpv_othersignatory");
                        edits.setMustInput(true);
                        TextProp propertys = (TextProp) edits.getProperty();
                        propertys.setMustInput(true);
                        DataEntityPropertyCollection parentProperties = parentModel.getDataEntityType().getProperties();
                        String customerName = "";
                        Long customerid = 0l;
                        if (parentProperties.containsKey("tpv_customer")) {
                            DynamicObject customer = (DynamicObject) parentModel.getValue("tpv_customer");//客户
                            customerName = customer != null ? customer.getString("name") : "";
                            customerid = customer != null ? customer.getLong("id") : 0l;
                        }
                        String supplierName = "";
                        Long supplierid = 0l;
                        if (parentProperties.containsKey("tpv_supplier")) {
                            DynamicObject Supplier = (DynamicObject) parentModel.getValue("tpv_supplier");//供应商
                            supplierName = Supplier != null ? Supplier.getString("name") : "";
                            supplierid = Supplier != null ? Supplier.getLong("id") : 0l;
                        }
                        String finallyName = YEM.isNotEmpty(customerName) ? customerName : supplierName;
                        model.setValue("tpv_othercompanyname", finallyName);
                        List<QFilter> list = new ArrayList<>();
                        list.add(new QFilter("billstatus", QCP.equals, "C"));
                        if (customerid > 0l) {
                            list.add(new QFilter("tpv_correspondent", QCP.equals, customerid));
                        }
                        if (supplierid > 0l) {
                            list.add(new QFilter("tpv_correspondent", QCP.equals, supplierid));
                        }
                        if (customerid <= 0l && supplierid <= 0l) {
                            return;
                        }
                        String selectfields = DynamicObjectUtil.getSelectfieldsFast("tpv_iscb_docket", "tpv_iscb_docket_adm", "tpv_iscb_docket_os");//人员
                        DynamicObject queryUser = BusinessDataServiceHelper.loadSingle("tpv_iscb_docket", selectfields, list.toArray(new QFilter[]{}));//线上备案
                        if (queryUser != null) {
                            DynamicObjectCollection tpvIscbDocketOs = queryUser.getDynamicObjectCollection("tpv_iscb_docket_os");
                            for (DynamicObject obj : tpvIscbDocketOs) {
                                String tpvAuthentication = obj.getString("tpv_authentication");
                                if (tpvIscbDocketOs.size() > 0) {
                                    if (tpvIscbDocketOs.size() == 1) {
                                        if (!"".equals(tpvAuthentication)) {
                                            if ("1".equals(tpvAuthentication)) {
                                                String signatory = obj.getString("tpv_signatory");
                                                String tpvFddcompanyids = queryUser.getString("tpv_fddcompanyid");
                                                String tpvSignatorymailbox = obj.getString("tpv_signatorymailbox");//电话
                                                String tpvSignatorytel = obj.getString("tpv_signatoryid");
                                                model.setValue("tpv_othersignatory", signatory);
                                                model.setValue("tpv_fddcompanyid", tpvFddcompanyids);
                                                model.setValue("tpv_signphone", tpvSignatorymailbox);
                                                model.setValue("tpv_signatorymailbox", tpvSignatorytel);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    } else {
                        TextEdit edit = this.getView().getControl("tpv_othercompanyname");
                        edit.setMustInput(false);
                        TextProp property = (TextProp) edit.getProperty();
                        property.setMustInput(false);
                        TextEdit edits = this.getView().getControl("tpv_othersignatory");
                        edits.setMustInput(false);
                        TextProp propertys = (TextProp) edits.getProperty();
                        propertys.setMustInput(false);
                        this.getView().setVisible(false, "tpv_othercompanyname", "tpv_othersignatory");
                    }
                    if ("A".equals(sealstatus)) { //印控仪
                        String selectFieids = DynamicObjectUtil.getSelectfieldsFast("tpv_iscb_seal", "tpv_advconap", "tpv_companies");
                        DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_iscb_seal", selectFieids, new QFilter[]{
                                new QFilter("tpv_companies.tpv_firm", QCP.equals, id),
                                new QFilter("tpv_advconap.tpv_billts.number", QCP.equals, identification),
                                new QFilter("tpv_sealuse", QCP.equals, "B")});
                        if (bills.length == 1) {
                            for (DynamicObject bill : bills) {
                                Long exid = bill.getLong("id");
                                this.getModel().setValue("tpv_selectstamp", exid);
                            }
                        }
                    }
                    if ("B".equals(sealstatus) | "C".equals(sealstatus) || "D".equals(sealstatus) || "E".equals(sealstatus)) {
                        String selectFieids = DynamicObjectUtil.getSelectfieldsFast("tpv_iscb_seal", "tpv_advconap", "tpv_companies");
                        DynamicObject[] bills = BusinessDataServiceHelper.load("tpv_iscb_seal", selectFieids, new QFilter[]{
                                new QFilter("tpv_companies.tpv_firm", QCP.equals, id),
                                new QFilter("tpv_advconap.tpv_billts.number", QCP.equals, identification),
                                new QFilter("tpv_sealuse", QCP.equals, "A")});
                        if (bills.length == 1) {
                            for (DynamicObject bill : bills) {
                                Long exid = bill.getLong("id");
                                this.getModel().setValue("tpv_selectstamp", exid);
                            }
                        }
                    }
                }
                break;

//                case "tpv_zooms":
//                    int tpvZoom = (int) model.getValue("tpv_zooms");
//                    String checkRange = checkRange(tpvZoom);
//                    if ("内容缩放允许范围80-100".equals(checkRange) ) {
//                        view.showMessage(checkRange);
//                    }
//                    break;
            default:
                break;
        }

    }
    public  String checkRange(int number) {
        if (number >= 80 && number <= 100) {
            return "";
        } else {
            return "内容缩放允许范围80-100";
        }
    }
    /**
     * @param null
     * @return
     * @ClassName 点击按钮
     * @Description TODO
     * @author yhj
     * @date 2023/11/17 14:42
     */
    @Override
    public void click(EventObject evt) {
        super.click(evt);
        IDataModel model = this.getModel();
        IDataModel ParentModel = this.getView().getParentView().getModel();
        Control source = (Control) evt.getSource();
        IFormView parentView = this.getView().getParentView(); //父视图
        IDataModel parentModel = parentView.getModel(); //父模型
//        int index = parentModel.getEntryCurrentRowIndex("tpv_materialentry");  //获取选中行索引（传参携带）
//        String attachmentname = (String) parentModel.getValue("tpv_attachmentname", index);
        String sealstatus = (String) model.getValue("tpv_sealstatus");//用印方式
        Date tpvBizdate = (Date) parentModel.getValue("tpv_bizdate");//日期

        DynamicObject dataEntity = parentModel.getDataEntity();//单据实体
        int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_attachmentdetail");
        String attachmentcon = (String) parentModel.getValue("tpv_attachmentcon_tag");//附件表格内容
        String attachmentName = (String) parentModel.getValue("tpv_attachmentname", entryCurrentRowIndex);
        String billno = (String) parentModel.getValue("billno");
        int tpvZooms = (int) model.getValue("tpv_zooms");
        String contentScaling = String.valueOf(tpvZooms);
        DynamicObject creator = (DynamicObject) parentModel.getValue("creator");
        String creatorName = creator != null ? creator.getString("name") : "";//创建人

        DataEntityPropertyCollection parentProperties = parentModel.getDataEntityType().getProperties();
        String departmentName = "";
        if (parentProperties.containsKey("tpv_department")) {
            DynamicObject department = (DynamicObject) parentModel.getValue("tpv_department");
            departmentName = department != null ? department.getString("name") : "";//部门内码
        }
        String orgName = "";
        if (parentProperties.containsKey("org")) {
            DynamicObject org = (DynamicObject) parentModel.getValue("org");//公司
            orgName = org != null ? org.getString("name") : "";//公司名称
        }
        //客户名称
        String customerName = "";
        Long customerid = 0l;
        if (parentProperties.containsKey("tpv_customer")) {
            DynamicObject customer = (DynamicObject) parentModel.getValue("tpv_customer");//客户
            customerName = customer != null ? customer.getString("name") : "";
            customerid = customer != null ? customer.getLong("id") : 0l;
        }
        //供应商名称
        String supplierName = "";
        Long supplierid = 0l;
        if (parentProperties.containsKey("tpv_supplier")) {
            DynamicObject Supplier = (DynamicObject) parentModel.getValue("tpv_supplier");//供应商
            supplierName = Supplier != null ? Supplier.getString("name") : "";
            supplierid = Supplier != null ? Supplier.getLong("id") : 0l;
        }
        //最终名称
        String finallyName = YEM.isNotEmpty(customerName) ? customerName : supplierName;

        String currUserName = RequestContext.get().getUserName();
        JSONObject json = JSONObject.parseObject(attachmentcon);
        DynamicObject tpvSelectstamp = (DynamicObject) model.getValue("tpv_selectstamp");//印章
        long sealId = tpvSelectstamp != null ? tpvSelectstamp.getLong("id") : 0L;
        ;//印章id
        String uid = "";//附件id
        if (json != null) {
            Set<String> strings = json.keySet();
            if (strings.size() > 0 && null != strings) {
                for (String names : strings) {
                    if (json != null) {
                        JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                        if (tpv_sourcebillkey != null) {
                            if (names.equals(attachmentName)) {
                                uid = (String) tpv_sourcebillkey.get("uid");// 附件id
                            }
                        }
                    }
                }
            }
        }
        if (StringUtils.equals("btnok", source.getKey())) {
            // 获取用印方式
            FormShowParameter showParameter = this.getView().getFormShowParameter();
            Integer tpv_assist = new Integer(0);
            Map<String, Object> maps = new HashMap<>();
            maps = showParameter.getCustomParams();//获取map表
            JSONObject tpv_personinfor = (JSONObject) maps.get("entryRowEntity");
            if (tpv_personinfor != null) {
                tpv_assist = tpv_personinfor.getInteger("seq") - 1;
            }
            HashMap<String, Object> hashMap = new HashMap<>();
            // 获取选择印章
            DynamicObject selectstamp = (DynamicObject) model.getValue("tpv_selectstamp");
            //签署人电话
            String tpvSignphone = (String) model.getValue("tpv_signphone");
            // 获取对方企业名称
            String othercompanyname = (String) model.getValue("tpv_othercompanyname");
            // 获取预审码位置
            String precencodelocation = (String) model.getValue("tpv_precencodelocation");
            //对方公司id
            String tpvFddcompanyid = (String) model.getValue("tpv_fddcompanyid");
            // 获取对方签署人
            String othersignatory = (String) model.getValue("tpv_othersignatory");
            // 获取内容缩放%
            String contentscaling = contentScaling;
            //签署人id
            String tpvSignatorymailbox = (String) model.getValue("tpv_signatorymailbox");
            Boolean substitute = (Boolean) model.getValue("tpv_substitute");
            if (sealstatus != null) {
                hashMap.put("sealstatus", sealstatus);
            }
            if (selectstamp != null) {
                hashMap.put("selectstamp", selectstamp.getLong("id"));
                hashMap.put("selectstampname", selectstamp.getString("name"));
                hashMap.put("selectstampfddid", selectstamp.getString("tpv_fddid"));
                hashMap.put("selectstampzgjid", selectstamp.getString("tpv_zgjid"));
            }
            if (othercompanyname != null) {
                hashMap.put("othercompanyname", othercompanyname);
            }
            if (precencodelocation != null) {
                hashMap.put("precencodelocation", precencodelocation);
            }
            if (othersignatory != null) {
                hashMap.put("othersignatory", othersignatory);
            }
            if (contentscaling != null) {
                hashMap.put("contentscaling", contentscaling);
            }
            if (tpv_assist != null) {
                hashMap.put("aLong", tpv_assist);
            }
            if (substitute) {
                hashMap.put("substitute", substitute);
            } else {
                hashMap.put("substitute", substitute);
            }
            if (attachmentName != null) {
                hashMap.put("attachmentname", attachmentName);
            }
            if (tpvSignphone != null) {
                hashMap.put("tpvSignphone", tpvSignphone);
            }
            if (tpvFddcompanyid != null) {
                hashMap.put("tpvFddcompanyid", tpvFddcompanyid);
            }
            if (tpvSignatorymailbox != null) {
                hashMap.put("tpvSignatorymailbox", tpvSignatorymailbox);
            }
            hashMap.put("tpv_sealstatus", "B");
            this.getView().returnDataToParent(hashMap);//将数据传给父页面
            this.getView().close();
        } else if (StringUtils.equals(source.getKey(), "btncancel")) {
            this.getView().returnDataToParent(null);
            this.getView().close();
        }

        if (StringUtils.equals("tpv_othersignatory", source.getKey())) {
            List<QFilter> list = new ArrayList<>();
            list.add(new QFilter("billstatus", QCP.equals, "C"));
            if (customerid > 0l) {
//                list.add(new QFilter("tpv_asstacttype", QCP.equals, "bd_customer"));
                list.add(new QFilter("tpv_correspondent", QCP.equals, customerid));
            }
            if (supplierid > 0l) {
//                list.add(new QFilter("tpv_asstacttype", QCP.equals, "bd_supplier"));
                list.add(new QFilter("tpv_correspondent", QCP.equals, supplierid));
            }
            if (customerid <= 0l && supplierid <= 0l) {
                return;
            }
            String selectfields = DynamicObjectUtil.getSelectfieldsFast("tpv_iscb_docket", "tpv_iscb_docket_os");//人员
            DynamicObject queryUser = BusinessDataServiceHelper.loadSingle("tpv_iscb_docket", selectfields, list.toArray(new QFilter[]{}));//线上备案
            if (queryUser != null) {
                String tpvFddcompanyids = queryUser.getString("tpv_fddcompanyid");
                model.setValue("tpv_fddcompanyid", tpvFddcompanyids);
                DynamicObjectCollection tpvIscbDocketOs = queryUser.getDynamicObjectCollection("tpv_iscb_docket_os");
                List<String> tpvSignatoryidList = new ArrayList<>();
                for (DynamicObject obj : tpvIscbDocketOs) {
                    String tpvSignatoryid = obj.getString("tpv_signatoryid");
                    tpvSignatoryidList.add(tpvSignatoryid);
                }
                if (tpvSignatoryidList.size() > 0) {
                    // 创建弹出动态表单页面对象
                    FormShowParameter showParameter = new FormShowParameter();
                    // 设置弹出页面的标识
                    showParameter.setFormId("tpv_iscb_signatory");
                    // 状态
                    showParameter.setStatus(OperationStatus.ADDNEW);
                    Map<String, Object> map = new HashMap<>();
                    map.put("signatoryidKey", tpvSignatoryidList);
                    showParameter.setCustomParams(map);
                    // 设置页面关闭回调方法
                    // CloseCallBack参数：回调插件，回调标识
                    showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_othersignatory"));
                    // 设置弹出页面打开方式
                    showParameter.getOpenStyle().setShowType(ShowType.Modal);
                    // 打开动态表单
                    this.getView().showForm(showParameter);
                }
            }
        }
        if (StringUtils.equals("tpv_preview", source.getKey())) {
            PdfFileModel inputVo = new PdfFileModel();
            inputVo.setQr_page("2");// 二维码页面:0：无 1：首页 2：每页 免码用印传0，默认传2
            String select = DynamicObjectUtil.getSelectfields("tpv_iscb_preapproval");
            // 查询预审码信息
            DynamicObject[] load = BusinessDataServiceHelper.load("tpv_iscb_preapproval", select, new QFilter[]{
                    new QFilter("tpv_locationname", QCP.equals, model.getValue("tpv_precencodelocation"))
            });
            String tpvXhcoord = "";//X坐标(横向纸张)
            String tpvXzcoord = "";//(纵向纸张)
            if (load.length > 0) {
                DynamicObject signInfo = load[0];
                tpvXhcoord = signInfo.getString("tpv_xhcoords");
                tpvXzcoord = signInfo.getString("tpv_xzcoords");
            }
            inputVo.setQr_location(tpvXzcoord);// 二维码坐标(像素): x1,y1
            inputVo.setQr_size("80");// 二维码尺寸:75
            inputVo.setSrcEntity(dataEntity);
            long dataEntityid = (long) dataEntity.getLong("id");//id
            long dataid = (long) dataEntity.getPkValue();//id
            inputVo.setQr_text("仅预览，未预审");// 二维码内容
            inputVo.setAttachment_id(uid);// 附件id
            inputVo.setOrientation("1");// 1：纵向 2：横向：按[申请用印-高级]中结果传
            inputVo.setContract_no(billno);// 附件所在单据号的外码
            inputVo.setVprepare_uid(creatorName);// 匹配小易用户编码显示：单据制单人String.valueOf(creatorId)
            inputVo.setDepartment_id(departmentName);// 匹配小易部门编码显示：大部门内码
            inputVo.setSeal_ids(String.valueOf(sealId));// 按corpbcode传矿产合同章或航工合同章的印章id
            inputVo.setCorpbcode(orgName);// 公司名称-我司抬头
            inputVo.setGrantor_uid(currUserName);// 批准用印人
            inputVo.setCode(finallyName);// 客商名称
            inputVo.setTpv_operate("C");
            inputVo.setTpv_sourcebillscode(billno);
            inputVo.setRemark("公司本部内贸销售合同开发测试20231122的附件，由金蝶操作。");// 备注
            String identification = parentView.getEntityId();
            String ids = String.valueOf(dataEntity.getPkValue());
            String filuid = "";
            String filurl = "";
            List<Map<String, Object>> atts = AttachmentServiceHelper.getAttachments(identification, ids, "attachmentpanel", true);
            for (Map<String, Object> att : atts) {
                filuid = (String) att.get("uid");
                if (uid.equals(filuid)) {
                    filurl = (String) att.get("url");
                }
            }
            long currUserId = RequestContext.get().getCurrUserId();
            inputVo.setCurruserid(currUserId);
            String filurlBase64 = getbase64(filurl);
            inputVo.setFile_b64(filurlBase64);// 源文件doc（x）、文字pdf、xls（x）的base64
            inputVo.setFile_name(attachmentName);// 源文件名:doc（x）、文字pdf、xls（x）
            inputVo.setResize_percent(contentScaling);//缩放百分比
            inputVo.setRotate("1");// 0：不开启自动翻转,1：开启自动翻转,默认1
            inputVo.setQr_locationx(tpvXhcoord);// 二维码坐标(像素): x1,y1
            inputVo.setScode_text("PREVIEW");// 字符码
            inputVo.setScode_page("2");// 字符码页面: 1：首页 2：每页 3：末页 默认传2
            inputVo.setScode_size("10");// 字符码尺寸:75像素
            inputVo.setScode_location("qru");// 字符码坐标
            inputVo.setScode_locationx("380,380");// 第二套字符码坐标
            CustomApiResult<Map> mapCustomApiResult = PdfFileController.pdfFile(inputVo);
            if (mapCustomApiResult.isStatus()) {
                Map data = mapCustomApiResult.getData();
                Map tpvSealapplyids = (Map) data.get("data");
                String tpvSealapplyid = tpvSealapplyids.get("tpv_sealapplyid").toString();
                FormShowParameter showParameter = new FormShowParameter();
                showParameter.setStatus(OperationStatus.ADDNEW);
                showParameter.getOpenStyle().setShowType(ShowType.Modal);
                showParameter.setFormId("tpv_iscb_progressbar");//进度动态表单
                Map<String, Object> map = new HashMap<>();
                map.put("tpvSealapplyid", tpvSealapplyid);
                showParameter.setCustomParams(map);
                this.getView().showForm(showParameter);
            } else {
                String message = mapCustomApiResult.getMessage();
                this.getView().showMessage("调用接口失败! " + message);
            }
        }
    }

    /**
     * @param null
     * @return
     * @description 基础资料打开过滤
     * @author yhj
     * @date 2023/11/17 14:42
     */
    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        IFormView parentView = this.getView().getParentView(); //父视图
        IDataModel parentModel = parentView.getModel(); //父模型
        DynamicObject org = (DynamicObject) parentModel.getValue("org");
        Long id = org.getLong("id");//公司名称
        String identification = parentView.getEntityId();
        switch (name) {
            case "tpv_selectstamp":
                ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
                List<QFilter> QFilters = new ArrayList<QFilter>();
                String value = (String) this.getModel().getValue("tpv_sealstatus");
                if (value != null) {
                    if (value.equals("A")) {
                        QFilters.add(new QFilter("tpv_sealuse", QCP.equals, "B"));
                    } else {
                        QFilters.add(new QFilter("tpv_sealuse", QCP.equals, "A"));
                    }
                }
                if (org != null) {
                    QFilters.add(new QFilter("tpv_companies.tpv_firm", QCP.equals, id));
                }
                if (identification != null) {
                    QFilters.add(new QFilter("tpv_advconap.tpv_billts.number", QCP.equals, identification));
                }
                showParameter.getListFilterParameter().setQFilters(QFilters);
                break;
            default:
                break;
        }
    }

    /**
     * 动态表单关闭回调事件
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        // super.closedCallBack(closedCallBackEvent);
        Object returnData = closedCallBackEvent.getReturnData();
        // 判断标识是否匹配，并验证返回值不为空，不验证返回值可能会报空指针
        if (org.apache.commons.lang3.StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_othersignatory")
                && null != closedCallBackEvent.getReturnData()) {
            // 这里返回对象为Object，可强转成相应的其他类型，
            // 单条数据可用String类型传输，返回多条数据可放入map中，也可使用json等方式传输
            HashMap<String, Object> values = (HashMap<String, Object>) returnData;
            this.setInwardInfo(values);
        }
    }

    /**
     * @param null
     * @return
     * @description 修改动态表单内容
     * @author yhj
     * @date 2023/11/17 14:42
     */
    private void setInwardInfo(HashMap<String, Object> values) {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        model.setValue("tpv_othersignatory", values.get("tpvSignatory"));//签署人姓名
        model.setValue("tpv_signphone", values.get("tpvSignatorymailbox"));//签署人电话
        model.setValue("tpv_signatorymailbox", values.get("tpvsignphone"));//签署人id
    }

    /**
     * @param null
     * @return
     * @description 打开初始化
     * @author yhj
     * @date 2023/11/17 14:42
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IDataModel model = this.getModel();
        IDataModel ParentModel = this.getView().getParentView().getModel();
        IFormView parentView = this.getView().getParentView(); //父视图
        IDataModel parentModel = parentView.getModel(); //父模型

        DataEntityPropertyCollection parentProperties = parentModel.getDataEntityType().getProperties();
        String customerName = "";
        Long customerid = 0l;
        if (parentProperties.containsKey("tpv_customer")) {
            DynamicObject customer = (DynamicObject) parentModel.getValue("tpv_customer");//客户
            customerName = customer != null ? customer.getString("name") : "";
            customerid = customer != null ? customer.getLong("id") : 0l;
            if (YEM.isNotEmpty(customerName)) {
                model.setValue("tpv_customer", customer);//客户
                model.setValue("tpv_othercompanyname", customerName);
            }
        }
        String supplierName = "";
        Long supplierid = 0l;
        if (parentProperties.containsKey("tpv_supplier")) {
            DynamicObject Supplier = (DynamicObject) parentModel.getValue("tpv_supplier");//供应商
            supplierName = Supplier != null ? Supplier.getString("name") : "";
            supplierid = Supplier != null ? Supplier.getLong("id") : 0l;
            if (YEM.isNotEmpty(supplierName)) {
                model.setValue("tpv_supplier", Supplier);//供应商
                model.setValue("tpv_othercompanyname", supplierName);
            }
        }

        List<QFilter> list = new ArrayList<>();
        list.add(new QFilter("billstatus", QCP.equals, "C"));
        if (customerid > 0l) {
            list.add(new QFilter("tpv_correspondent", QCP.equals, customerid));
        }
        if (supplierid > 0l) {
            list.add(new QFilter("tpv_correspondent", QCP.equals, supplierid));
        }
        if (customerid <= 0l && supplierid <= 0l) {
            this.getView().setEnable(false, "tpv_radiofield3", "tpv_radiofield4", "tpv_radiofield2");
            return;
        }
        String selectfields = DynamicObjectUtil.getSelectfieldsFast("tpv_iscb_docket", "tpv_iscb_docket_adm", "tpv_iscb_docket_os");//人员
        DynamicObject[] queryUser = BusinessDataServiceHelper.load("tpv_iscb_docket", selectfields, list.toArray(new QFilter[]{}));//线上备案
        if (queryUser.length > 0 && "3".equals(queryUser[0].getString("tpv_enterprise"))) {
            if ("A".equals(queryUser[0].getString("tpv_requirement"))) {
                this.getView().setEnable(false, "tpv_radiofield3");
            }
        } else {
            this.getView().setEnable(false, "tpv_radiofield3", "tpv_radiofield4", "tpv_radiofield2");
        }
    }

    /**
     * @param null
     * @return
     * @description 转base64
     * @author yhj
     * @date 2023/11/17 14:42
     */
    public static String getbase64(String url) {
        InputStream inputStream = null;
        String base64 = "";
        byte input[] = null;
        try {
            URLConnection urlConnection = new URL(url).openConnection();
            HttpURLConnection httpURLConnection = (HttpURLConnection) urlConnection;
            httpURLConnection.setConnectTimeout(1000 * 5);
            httpURLConnection.setDoOutput(true);
            httpURLConnection.setDoInput(true);
            httpURLConnection.setUseCaches(false);
            httpURLConnection.setRequestProperty("Connection", "Keep-Alive");
            httpURLConnection.setRequestProperty("Charset", "UTF-8");
            httpURLConnection.connect();

            inputStream = httpURLConnection.getInputStream();
            ByteArrayOutputStream bytestream = new ByteArrayOutputStream();
            byte[] buffer = new byte[1024];
            int ch;
            while ((ch = inputStream.read(buffer)) != -1) {
                bytestream.write(buffer, 0, ch);
            }
            input = bytestream.toByteArray();
            bytestream.close();
            base64 = Base64.getEncoder().encodeToString(input);

        } catch (Exception e1) {
            e1.printStackTrace();
        }
        return base64;
    }
}