package tpv.tpv_wm.tpv_iscb.java.formplugin.dynamic;

import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.OperationStatus;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.BizDataEventArgs;
import kd.bos.fileservice.FileItem;
import kd.bos.fileservice.FileService;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Label;
import kd.bos.form.control.ProgressBar;
import kd.bos.form.control.events.ProgressEvent;
import kd.bos.form.control.events.ProgresssListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.url.UrlService;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Base64;
import java.util.Date;
import java.util.EventObject;
import java.util.Map;

/**
 * @ClassName 进度条
 * @Description （用印申请预览）
 * @Author yhj
 * @Date 2023/11/29 21:35
 * @Version 1.0
 */
public class ProgressBarEdit extends AbstractFormPlugin implements ProgresssListener {

	@Override
	public void registerListener(EventObject e) {
		ProgressBar progressBar = this.getControl("tpv_progressbarap");
		progressBar.addProgressListener(this);
	}

	@Override
	public void onProgress(ProgressEvent progressEvent) {
		ProgressBar progressBar = this.getControl("tpv_progressbarap");
		FormShowParameter showParameter = this.getView().getFormShowParameter();
		Map<String, Object> maps = showParameter.getCustomParams();
		String tpvSealapplyid = (String) maps.get("tpvSealapplyid");
		if(YEM.isEmpty(tpvSealapplyid)) {
			this.getView().showTipNotification("用印申请id为空。");
			return;
		}
		String selectfields = DynamicObjectUtil.getSelectfields("tpv_iscb_yataskinfo", false);
		QFilter qFilter = new QFilter("tpv_sealapplyid", QCP.equals, tpvSealapplyid);
		DynamicObject[] load = BusinessDataServiceHelper.load("tpv_iscb_yataskinfo", selectfields, qFilter.toArray());
		Date dateDb = null;
		if (load.length > 0) {
			DynamicObject signInfo = load[0];
			String tpvAttachmentconTag = signInfo.getString("tpv_filebase64_tag");
			dateDb = signInfo.getDate("tpv_bizdate");
			if (YEM.isNotEmpty(tpvAttachmentconTag)) {
				byte[] bytes = Base64.getDecoder().decode(tpvAttachmentconTag);
				String tpvAppid = signInfo.getString("tpv_appid");// 单据内码
				String tpvBillsid = signInfo.getString("tpv_billsid");// 单据内码
				String attacName = signInfo.getString("tpv_attacname");// 附件名称
				int i = attacName.lastIndexOf(".");
				attacName = attacName.substring(0, i);
				attacName = attacName + ".pdf";
				DynamicObject tpvBills = signInfo.getDynamicObject("tpv_sourcebills");// 单据
				String number = tpvBills.getString("number");// 单据标识
				ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream(bytes);
				String url = "";
				try {
					url = url(tpvAppid, tpvBillsid, number, attacName, byteArrayInputStream);
				} catch (IOException e) {
					throw new RuntimeException(e);
				}
				String previewUrl = UrlService.getAttachmentPreviewUrl(url);
				if (YEM.isNotEmpty(previewUrl)) {
					previewUrl(this.getView().getParentView(), previewUrl);
					this.getView().sendFormAction(this.getView().getParentView());
					this.getView().close();
				}
				progressBar.stop();
			}
		}
		Date date = new Date();
		Long diff = date.getTime() - dateDb.getTime();
		int ss = (int) (diff / 1000);
		Label richTextEditor = this.getView().getControl("tpv_labelap");
		int endtime = 15;
		if (ss > endtime && this.getView() != null) {
			richTextEditor.setText("请求超时，请联系管理员！");
			if (progressBar != null) {
				progressBar.stop();
			}
		}
	}

	@Override
	public void createNewData(BizDataEventArgs e) {
		ProgressBar progressBar = this.getControl("tpv_progressbarap");
		progressBar.setPercent(0);
		progressBar.start();
	}

	private static String url(String appId, String formId, String pkId, String fileName, InputStream stream)
			throws IOException {
		Date today = new Date();
		DateFormat df = new SimpleDateFormat("yyyyMM");
		String NewDateStr = df.format(today);
		String attachmentPath = "/" + RequestContext.get().getTenantId() + "/" + RequestContext.get().getAccountId()
				+ "/" + NewDateStr + "/" + appId + "/" + formId + "/" + pkId + "/attachments/";
		FileService fs = FileServiceFactory.getAttachmentFileService();
		String path = attachmentPath + fileName;
		FileItem fi = new FileItem(fileName, path, stream);// "接口返回的base64转的文件流")
		fi.setCreateNewFileWhenExists(true);
		String url = fs.upload(fi);
		return url;
	}

	private void previewUrl(IFormView view, String previewUrl) {
		FormShowParameter showParameter = new FormShowParameter();
		showParameter.setStatus(OperationStatus.EDIT);
		showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
		showParameter.setFormId("bos_printpreview");// 打印预览页面
		showParameter.setCustomParam("src", previewUrl);
		view.showForm(showParameter);
	}

}
