package tpv.tpv_wm.tpv_iscb.java.formplugin.dynamic;

import com.alibaba.nacos.common.utils.StringUtils;
import com.itopview.wm.utils.YEM;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.BizDataEventArgs;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.IPageCache;
import kd.bos.form.control.ProgressBar;
import kd.bos.form.control.events.ProgressEvent;
import kd.bos.form.control.events.ProgresssListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.mvc.cache.PageCache;
import kd.bos.threads.ThreadPools;

import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

import static com.itopview.wm.sys.utils.PrintHelper.getAttachDateil;

/**
 * 进度条
 * @author LiuHB
 * @version 1.0
 */
public class ProgressEdit extends AbstractFormPlugin implements ProgresssListener {
	private final static String CACHEKEY_PROGRESS = "ProgressEdit";
	private final static String CACHEKEY_STARTPROPGRESS = "startprogress";

	public static int TIMEOUT = 0;

	@Override
	public void registerListener(EventObject e) {
		this.addItemClickListeners("bar_print");
		ProgressBar progressBar = this.getControl("tpv_progressbarap");
		progressBar.addProgressListener(this);
	}

	class MyTask implements Runnable {
		private RequestContext rc;
		String pageId;

		public MyTask(RequestContext rc, String pageId) {
			this.rc = rc;
			this.pageId = pageId;

		}


		@Override
		public void run() {
			RequestContext.set(rc);
			cacheProcess(this.pageId, TIMEOUT);
		}

	}

	private void cacheProcess(String pageId, int progress) {
		PageCache pageCache = new PageCache(pageId);
		pageCache.put(CACHEKEY_PROGRESS, String.valueOf(progress));


	}

	@Override
	public void createNewData(BizDataEventArgs e) {
		doApiTask();
	}

	private void doApiTask() {
		IFormView view = this.getView();
		IDataModel model = this.getModel();
		// 标记任务已经开始
		this.getPageCache().put(CACHEKEY_STARTPROPGRESS, "true");
		view.setVisible(true, "tpv_progressbarap");
		ProgressBar progressBar = this.getControl("tpv_progressbarap");
		progressBar.setPercent(0);
		progressBar.start();
		view.getPageCache().put(CACHEKEY_PROGRESS, "0");
		MyTask myTask = new MyTask(RequestContext.get(), view.getPageId());
		ThreadPools.executeOnce(CACHEKEY_PROGRESS, myTask);
	}


	/**
	 * 停止进度
	 */
	private void doStop() {
		// 更新缓存中的任务启动标志 = false：异步任务进程会定时读取这个标志，停止任务
		this.getPageCache().put(CACHEKEY_STARTPROPGRESS, "false");
		this.getView().close();
	}

	private boolean isStop(PageCache pageCache) {
		String startProgress = pageCache.get(CACHEKEY_STARTPROPGRESS);
		return (StringUtils.isNotBlank(startProgress)
				&& startProgress.equals("false"));
	}


	@Override
	public void onProgress(ProgressEvent e) {
		FormShowParameter showParameter = this.getView().getFormShowParameter();
		Map<String, Object> maps = new HashMap<>();
		maps = showParameter.getCustomParams();
		Long pkId=(Long)maps.get("pkId");
		Long ID=(Long) maps.get("ID");
		String filePath=(String) maps.get("filePath");
		String pdfFileName=(String) maps.get("pdfFileName");
		String entityId=(String) maps.get("entityId");
		String tplId=(String) maps.get("tplId");
		String billon=(String) maps.get("billon");
		String creator=(String) maps.get("creator");
		String department=(String) maps.get("department");
		String org=(String) maps.get("org");
		try {
			getAttachDateil(this.getView(),pkId,ID,filePath,pdfFileName,entityId,tplId,billon,creator,department,org);
		} catch (Exception ex) {
			throw new RuntimeException(ex);
		}
		String startProgress = this.getPageCache().get(CACHEKEY_STARTPROPGRESS);
		if (StringUtils.isBlank(startProgress)){
// 未开始：设置进度为0
			e.setProgress(0);
			e.setText("未开始");
			return;
		}
		int progress = 0;
		String text = "进行中...";
		IPageCache pageCache = this.getPageCache();
		String cache_progress = pageCache.get(CACHEKEY_PROGRESS);
//        String key = pageCache.get("key");
		if (YEM.isNotEmpty(cache_progress)) {
			progress = Integer.valueOf(cache_progress);
		}
		while (progress < 100) {
			pageCache.put(CACHEKEY_PROGRESS, String.valueOf(++progress));

		}
		if (progress >= 100) {
			ProgressBar progressBar = this.getControl("tpv_progressbarap");
//            progressBar.stop();
//            调用查询方法

			e.setProgress(99);
			pageCache.remove(CACHEKEY_PROGRESS);
		} else {
			e.setProgress(progress);
			System.out.println();
		}
	}

}




