package tpv.tpv_wm.tpv_iscb.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.OperationStatus;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.BizDataEventArgs;
import kd.bos.fileservice.FileItem;
import kd.bos.fileservice.FileService;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Label;
import kd.bos.form.control.ProgressBar;
import kd.bos.form.control.events.ProgressEvent;
import kd.bos.form.control.events.ProgresssListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.url.UrlService;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @ClassName 进度条
 * @Description （用印申请预览）
 * @Author yhj
 * @Date 2023/11/29 21:35
 * @Version 1.0
 */
public class ProgressSignatureEdit extends AbstractFormPlugin implements ProgresssListener {
	private static Date currentDate= new Date() ;
	private static boolean hasExecuted = false; ;

	@Override
	public void registerListener(EventObject e) {
		ProgressBar progressBar = this.getControl("tpv_progressbarap");
		progressBar.addProgressListener(this);
	}

	@Override
	public void onProgress(ProgressEvent progressEvent) {
		ProgressBar progressBar = this.getControl("tpv_progressbarap");
		FormShowParameter showParameter = this.getView().getFormShowParameter();
		Map<String, Object> maps = showParameter.getCustomParams();
		String docld = (String) maps.get("docld");
		if(YEM.isEmpty(docld)) {
			this.getView().showTipNotification("docld为空。");
			return;
		}
		String selectfields = DynamicObjectUtil.getSelectfields("tpv_iscb_signtaskinfo", false);
		QFilter qFilter = new QFilter("tpv_signtaskid", QCP.equals, docld);
		DynamicObject[] load = BusinessDataServiceHelper.load("tpv_iscb_signtaskinfo", selectfields, qFilter.toArray());
		Date dateDb = null;
		if (load.length > 0) {
			DynamicObject signInfo = load[0];
			DynamicObject tpvBills = signInfo.getDynamicObject("tpv_bills");//单据
			String tpvBillsid = signInfo.getString("tpv_billsid");//单据内码
			Long tpvBillsids = Long.valueOf(tpvBillsid);
			String number = tpvBills.getString("number");//单据标识
			QFilter[] qFilters = new QFilter[]{new QFilter("id", QCP.equals, tpvBillsids)};
			String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast(number);
			DynamicObject[] queryDj = BusinessDataServiceHelper.load(number, selectfieldsFast, qFilters);
			String tpvSignorder = signInfo.getString("tpv_signorder");//场景
			String tpvSignfilename = signInfo.getString("tpv_signfilename");//附件名称
			String status = "";
			if (tpvSignorder == null) {
				status = "A";
			} else {
				if (tpvSignorder.equals("B")) {//本方线上单签
					status = "D";
				}
				if (tpvSignorder.equals("C")) {//对方线上单签
					status = "E";
				}
				if (tpvSignorder.equals("D")) {//双方线上签署我方先
					status = "D";
				}
				if (tpvSignorder.equals("E")) {//双方线上签署对方先
					status = "E";
				}
			}
			if (signInfo.getInt("tpv_signstatus") == 4) {  //签署状态（已撤销）
				OhterSignature(queryDj, tpvSignfilename, status);
				this.getView().returnDataToParent(1);
				IFormView parentView = this.getView().getParentView();
				parentView.invokeOperation( "refresh");
				this.getView().sendFormAction(parentView);
				this.getView().close();
				progressBar.stop();
			}
		}
//		Date newDate = new Date();
//			if (!hasExecuted) {
//				// 执行你的代码
//				hasExecuted = true;
//				Calendar calendar = Calendar.getInstance();
//				calendar.setTime(currentDate);
//				calendar.add(Calendar.MINUTE, 3); // 增加三分钟
//				currentDate = calendar.getTime();
//			}
//		// 使用 Calendar 对象进行时间操作
////		Date date = new Date();
////		Long diff = date.getTime() - dateDb.getTime();
////		int ss = (int) (diff / 1000);
////		Label richTextEditor = this.getView().getControl("tpv_labelap");
////		int endtime = 180;
//		long timeDiff = newDate.getTime() - currentDate.getTime();
//		DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//		String strDate = dateFormat.format(newDate);
//		String endDate = dateFormat.format(currentDate);
//		Label richTextEditor = this.getView().getControl("tpv_labelap");
//		if (strDate.equals(endDate)) {
//			hasExecuted = false;
//			richTextEditor.setText("请求超时，请联系管理员！");
//			if (progressBar != null) {
//				hasExecuted = false;
//				progressBar.stop();
//			}
//		}
	}

	@Override
	public void createNewData(BizDataEventArgs e) {
		ProgressBar progressBar = this.getControl("tpv_progressbarap");
		progressBar.setPercent(0);
		progressBar.start();
	}

	public void OhterSignature(DynamicObject[] queryHW, String tpvSignfilename, String status) {
		if (queryHW.length > 0) {
			DynamicObject query = queryHW[0];
			String tpvAttachmentconTag = query.getString("tpv_attachmentcon_tag");
			JSONObject json = JSONObject.parseObject(tpvAttachmentconTag);
			if (json != null) {
				Set<String> strings = json.keySet();
				if (strings.size() > 0 && null != strings) {
					for (String names : strings) {
						if (json != null) {
							JSONObject tpv_sourcebillkey = json.getJSONObject(names);
							if (tpv_sourcebillkey != null) {
								if (names.equals(tpvSignfilename)) {
									JSONObject attJson = json.containsKey(tpvSignfilename) ? json.getJSONObject(tpvSignfilename) : new JSONObject();
									attJson.put("tpv_sealstatus", status);
									json.put(tpvSignfilename, attJson);
									query.set("tpv_attachmentcon_tag", json);
									SaveServiceHelper.update(query);
								}
							}
						}
					}
				}
			}
		}
	}

}
