package tpv.tpv_wm.tpv_iscb.java.formplugin.dynamic;

import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import org.apache.commons.lang3.StringUtils;

import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * @ClassName SignatoryEdit
 * @Description 回填签署人
 * @Author yhj
 * @Date 2023/11/3 15:46
 * @Version 1.0
 */
public class SignatoryEdit extends AbstractBillPlugIn {
    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addClickListeners("btncancel", "btnok");  //监听取消和确定按钮
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        IDataModel model = this.getModel();
        Control source = (Control) evt.getSource();
        if (StringUtils.equals(source.getKey(), "btnok")) {
            HashMap<String, Object> hashMap = new HashMap<>();
            //如果被点击控件为确认，则获取页面相关控件值，组装数据传入returnData返回给父页面，最后关闭页面
            String tpvSignatory = (String) model.getValue("tpv_signatory");
            //签署人电话
            String tpvSignphone = (String) model.getValue("tpv_signatorymailbox");
            //签署人id
            String tpvSignatorymailbox = (String) model.getValue("tpv_signatorytel");
            // 判断获得的各项数据
            if (tpvSignatory != null) {
                hashMap.put("tpvSignatory", tpvSignatory);
            }
            if (tpvSignphone != null) {
                hashMap.put("tpvsignphone", tpvSignphone);
            }
            if (tpvSignatorymailbox != null) {
                hashMap.put("tpvSignatorymailbox", tpvSignatorymailbox);
            }
            this.getView().returnDataToParent(hashMap);//将数据传给父页面
            this.getView().close();
        } else if (StringUtils.equals(source.getKey(), "btncancel")) {
            //被点击控件为取消则设置返回值为空并关闭页面（在页面关闭回调方法中必须验证返回值不为空，否则会报空指针）
            this.getView().returnDataToParent(null);
            this.getView().close();
        }
    }


    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IDataModel model = this.getModel();
//        String whereFilter = "1=1";
//        DataSet query = SignatoryRptQuery.query(whereFilter);
//        for (Row row : query) {
//            int newEntryRow = this.getModel().createNewEntryRow("tpv_iscb_signatory_sig");//分录
//            model.setValue("tpv_signatory", row.getString("tpv_signatory"), newEntryRow);//签署人
//            model.setValue("tpv_signatorytel", row.getString("tpv_signatorytel"), newEntryRow);//签署人电话
//            model.setValue("tpv_signatorymailbox", row.getString("tpv_signatorymailbox"), newEntryRow);//签署人Id
//            model.setValue("tpv_authentication", row.getString("tpv_authentication"), newEntryRow);//实名认证标识
//        }
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> customParams = showParameter.getCustomParams();
        Object signatoryidKey = customParams.get("signatoryidKey");
        if (null != signatoryidKey) {
            QFilter qFilter = new QFilter("billstatus", QCP.equals, "C");
            qFilter.and(new QFilter("tpv_iscb_docket_os.tpv_authentication", QCP.equals, "1"));
            qFilter.and(new QFilter("tpv_iscb_docket_os.tpv_signatoryid", QCP.in, signatoryidKey));
            DataSet tpv_iscb_docket = ORM.create().queryDataSet(this.getClass().getName(), "tpv_iscb_docket",
                    "tpv_iscb_docket_os.tpv_signatory tpv_signatory,tpv_iscb_docket_os.tpv_signatorymailbox tpv_signatorytel," +
                            "tpv_iscb_docket_os.tpv_signatoryid tpv_signatorymailbox,tpv_iscb_docket_os.tpv_authentication tpv_authentication"
                    , qFilter.toArray()).distinct();
            if (!tpv_iscb_docket.isEmpty()) {
                for (Row row : tpv_iscb_docket) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_iscb_signatory_sig");//分录
                    model.setValue("tpv_signatory", row.getString("tpv_signatory"), newEntryRow);//签署人
                    model.setValue("tpv_signatorytel", row.getString("tpv_signatorytel"), newEntryRow);//签署人电话
                    model.setValue("tpv_signatorymailbox", row.getString("tpv_signatorymailbox"), newEntryRow);//签署人Id
                    model.setValue("tpv_authentication", row.getString("tpv_authentication"), newEntryRow);//实名认证标识
                }
            }
        }

    }

}
