package tpv.tpv_wm.tpv_iscb.java.formplugin.dynamic;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import org.apache.commons.lang3.StringUtils;
import tpv.tpv_wm.tpv_iscb.java.api.fadada.ContractSignUtil;

import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

/**
 * @ClassName 待对方签署（撤回）
 * @Description TODO
 * @Author yhj
 * @Date 2023/12/22 17:15
 * @Version 1.0
 */
public class WithdrawSignEdit extends AbstractFormPlugin {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        // 侦听文本字段按钮点击事件
        this.addClickListeners("btnok", "btncancel");
    }

    /**
     * @param null
     * @return
     * @description 点击按钮
     * @author yhj
     * @date 2023/11/19 23:55
     */
    @Override
    public void click(EventObject evt) {
        super.click(evt);
        IFormView view = this.getView();
        IFormView parentView = view.getParentView(); //父视图
        IDataModel parentModel = parentView.getModel(); //父模型
        Control source = (Control) evt.getSource();
        DynamicObject dataEntity = parentModel.getDataEntity();
        int entryCurrentRowIndex = parentModel.getEntryCurrentRowIndex("tpv_attachmentdetail");
        String attachmentcon = (String) parentModel.getValue("tpv_attachmentcon_tag");//附件表格内容
        String attachmentName = (String) parentModel.getValue("tpv_attachmentname", entryCurrentRowIndex);
        String status = "";//新文件的用印状态
        String sealWay = (String) parentModel.getValue("tpv_printingmethod", entryCurrentRowIndex);//用印方式
        QFilter[] qFilter = new QFilter[]{new QFilter("id", QCP.equals, dataEntity.getPkValue())};
        String identification = parentView.getEntityId();
        String selectfieldsFast = DynamicObjectUtil.getSelectfieldsFast(identification);
        DynamicObject[] queryDj = BusinessDataServiceHelper.load(identification, selectfieldsFast, qFilter);
        //判断新文件的用印状态
        if (sealWay == null) {
            status = "A";
        } else {
            if (sealWay.equals("F")) {//仅预审
                status = "O";
            }
            if (sealWay.equals("A")) {//印控仪
                status = "C";
            }
            if (sealWay.equals("B")) {//本方线上单签
                status = "D";
            }
            if (sealWay.equals("C")) {//对方线上单签
                status = "E";
            }
            if (sealWay.equals("D")) {//双方线上签署我方先
                status = "D";
            }
            if (sealWay.equals("E")) {//双方线上签署对方先
                status = "E";
            }
        }
        String docld = "";
        JSONObject json = JSONObject.parseObject(attachmentcon);
        if (json != null) {
            Set<String> strings = json.keySet();
            if (strings.size() > 0 && null != strings) {
                for (String names : strings) {
                    if (json != null) {
                        JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                        String attachmentnames = tpv_sourcebillkey.getString("attacNameTwo");
                        if (tpv_sourcebillkey != null) {
                            if (names.equals(attachmentName)) {
                                docld = (String) tpv_sourcebillkey.get("docId");// 附件名称
                            }
                        }
                    }
                }
            }
        }
        if (StringUtils.equals("btnok", source.getKey())) {
            ContractSignUtil contractSignUtil = new ContractSignUtil();
            CustomApiResult<Map<String, String>> documented = contractSignUtil.documentRevocation(docld);
            if (documented.isStatus()) {
                Map<String, Object> map = new HashMap<>();
                map.put("docld", docld);
                extracted(attachmentcon, queryDj, attachmentName, status);
                view.returnDataToParent(map);
            } else {
                view.showMessage(documented.getMessage());
            }

            view.close();
        } else if (StringUtils.equals(source.getKey(), "btncancel")) {
            view.returnDataToParent(null);
            view.close();
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {//子界面关闭时，触发父界面的closedCallBack事件
        //super.closedCallBack(closedCallBackEvent);
        Object returnData = closedCallBackEvent.getReturnData();//子页面返回数据
        //判断标识是否匹配，并验证返回值不为空，不验证返回值可能会报空指针
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "btnok") && null != closedCallBackEvent.getReturnData()) {
            OperationResult saveResult = this.getView().invokeOperation("refresh", YEM.getOptionNoMsg());
            this.getView().close();
        }
    }

    private static void extracted(String attachmentcon, DynamicObject[] queryDj, String tpvAttacname, String status) {
        JSONObject json = JSONObject.parseObject(attachmentcon);
        DynamicObject query = queryDj[0];
        if (json != null) {
            Set<String> strings = json.keySet();
            if (strings.size() > 0 && null != strings) {
                for (String names : strings) {
                    if (json != null) {
                        JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                        if (tpv_sourcebillkey != null) {
                            if (names.equals(tpvAttacname)) {
                                JSONObject attJson = json.containsKey(tpvAttacname) ? json.getJSONObject(tpvAttacname) : new JSONObject();
                                attJson.put("tpv_sealstatus", "X");
                                json.put(tpvAttacname, attJson);
                                query.set("tpv_attachmentcon_tag", json);
                                SaveServiceHelper.update(query);
                            }
                        }
                    }
                }
            }
        }
    }
}
