package tpv.tpv_wm.tpv_iscb.java.formplugin.form;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

import com.itopview.wm.sys.api.yargonpdfapi.model.ImagePdfModel;
import com.itopview.wm.sys.api.yargonpdfapi.PdfFileController;
import com.itopview.wm.sys.utils.MetaPropertyHelper;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.operate.AbstractOperate;
import com.fasterxml.jackson.core.JsonProcessingException;

import static kd.fi.bcm.common.json.JacksonUtils.objectMapper;

/**
 * ER内容方案插件
 *
 * @author LiuHB
 * @version 1.0
 */
public class DetailsFormPlugIn extends AbstractBillPlugIn {

    @Override
    public void afterBindData(EventObject e) {
        String largeText = (String) this.getModel().getValue("tpv_data_tag");
        this.getModel().setValue("tpv_data", largeText);
        ImagePdfModel imagePdfModel = new ImagePdfModel();
        imagePdfModel.setPdfFileName("1223");
        imagePdfModel.setPdfBase64("kajshdjkashdjkahsjkd");
        try {
            String json = objectMapper.writeValueAsString(imagePdfModel);
        } catch (JsonProcessingException ex) {
            throw new RuntimeException(ex);
        }
        PdfFileController.imagepdf(imagePdfModel);
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"tpv_billcol"});

    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        switch (itemKey) {
            case "tpv_test":
                showTest();
                break;
            default:
                break;
        }
    }

    private void showTest() {
        IFormView view = this.getView();
        DynamicObject requireBill = MetaPropertyHelper.getAndCheckF7Value(view, "tpv_requirebill");
        if (requireBill != null) {
            FormShowParameter showParameter = new FormShowParameter();
            showParameter.setStatus(OperationStatus.ADDNEW);
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            showParameter.setFormId("tpv_iscb_apptosetstest");
            view.showForm(showParameter);
        }
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "tpv_billcol":
                this.clickBillCol(key, "tpv_requirebill");
                break;
        }
    }

    private void clickBillCol(String key, String baseCol) {
        DynamicObject requireBill = MetaPropertyHelper.getAndCheckF7Value(this.getView(), baseCol);
        if (requireBill != null) {
            this.beforeSave();
            String formKey = requireBill.getString("number");
            List<String> entityKeys = new ArrayList<String>();
            entityKeys.add(formKey);
            MetaPropertyHelper.showPropertySelect(this, key, formKey, true, entityKeys);
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_requirebill":
                this.requireBillChanged(e);
                break;
        }
    }

    private void requireBillChanged(PropertyChangedArgs e) {
        this.getModel().deleteEntryData("tpv_colsmap");
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);
        String key = e.getActionId();
        IDataModel model = this.getModel();
        switch (key) {
            case "tpv_billcol":
                MetaPropertyHelper.callBackEntryData(model, e, "tpv_colsmap", "tpv_billcolno", "tpv_billcol", false);
                break;
        }
    }

    public void beforeDoOperation(BeforeDoOperationEventArgs e) {
        super.beforeDoOperation(e);
        String key = ((AbstractOperate) e.getSource()).getOperateKey();
        switch (key) {
            case "save":
            case "submit":
                this.beforeSave();
                break;
        }
    }

    private void beforeSave() {
        Object richTextEditor = this.getModel().getValue("tpv_data");

    }

}
