package tpv.tpv_wm.tpv_iscb.java.formplugin.form;


import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.sys.api.yargonpdfapi.PdfFileController;
import com.itopview.wm.sys.api.yargonpdfapi.model.PdfFileModel;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.property.ComboProp;
import kd.bos.fileservice.FileItem;
import kd.bos.fileservice.FileService;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.AttachmentPanel;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.BeforeAttachmentRemoveEvent;
import kd.bos.form.control.events.BeforeAttachmentRemoveListener;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.form.control.events.UploadListener;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.openapi.common.result.CustomApiResult;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.DeleteServiceHelper;
import org.apache.commons.lang3.StringUtils;
import org.jetbrains.annotations.NotNull;
import tpv.tpv_wm.tpv_iscb.java.api.fadada.ContractSignUtil;
import tpv.tpv_wm.tpv_iscb.java.api.fadada.entitys.ContractSignTask;
import tpv.tpv_wm.tpv_iscb.java.api.sealstewardapi.BottomTableModel;
import tpv.tpv_wm.tpv_iscb.java.api.sealstewardapi.SealStewardClient;
import tpv.tpv_wm.tpv_iscb.java.api.sealstewardapi.SealStewardClientHelper;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.atomic.AtomicReference;


/**
 * @ClassName 法大大和章管家按钮功能
 * @Description TODO
 * @Author yhj
 * @Date 2023/10/16 18:15
 * @Version 1.0
 */
public class FddAndZgjFunctionFormPlugin extends AbstractBillPlugIn implements UploadListener, BeforeAttachmentRemoveListener {
    private static final String KEY_ATT_TAG = "tpv_attachmentcon_tag";
    private static final String KEY_ATT_PANEL = "attachmentpanel";
    private static Map<String, List<Map<String, Object>>> newAttachmentData = new HashMap<String, List<Map<String, Object>>>();

    /**
     * @return
     * @description 监听按钮
     * @author yhj
     * @date 2023/11/17 14:42
     */
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        // 侦听文本字段按钮点击事件
        this.addItemClickListeners("tpv_toolbarap", "tpv_bsignonline","tpv_withdraw");
        AttachmentPanel attachmentPanel = this.getView().getControl("attachmentpanel");
        attachmentPanel.addUploadListener(this);
        attachmentPanel.addBeforeRemoveListener(this);

    }


    /**
     * @return
     * @description 点击按钮
     * @author yhj
     * @date 2023/11/17 14:421822390359892689920
     */
    @Override
    public void beforeItemClick(BeforeItemClickEvent evt) {
        super.beforeItemClick(evt);
        IDataModel model = this.getModel();
        String itemKey = evt.getItemKey();
        IFormView view = this.getView();
        Date tpvBizdate = (Date) model.getValue("tpv_bizdate");//日期
        if (null == tpvBizdate) {
            this.getView().showTipNotification("业务日期未填写！请先填写业务日期");
            evt.setCancel(true);
        }
        int entryCurrentRowIndex = this.getModel().getEntryCurrentRowIndex("tpv_attachmentdetail");
        String attachmentcon = (String) this.getModel().getValue("tpv_attachmentcon_tag");
        String attachmentName = (String) this.getModel().getValue("tpv_attachmentname", entryCurrentRowIndex);
        String sceneInfo = (String) model.getValue("tpv_printingmethod", entryCurrentRowIndex);//场景
        DataEntityPropertyCollection selectedProperties = this.getModel().getDataEntityType().getProperties();
        String orgName = "";
        if (selectedProperties.containsKey("org")) {
            DynamicObject org = (DynamicObject) model.getValue("org");//公司
            orgName = org != null ? org.getString("name") : "";//公司名称
        }
        //客户名称
        String customerName = "";
        if (selectedProperties.containsKey("tpv_customer")) {
            DynamicObject customer = (DynamicObject) model.getValue("tpv_customer");//客户
            customerName = customer != null ? customer.getString("name") : "";
        }
        //供应商名称
        String supplierName = "";
        if (selectedProperties.containsKey("tpv_supplier")) {
            DynamicObject Supplier = (DynamicObject) model.getValue("tpv_supplier");//供应商
            supplierName = Supplier != null ? Supplier.getString("name") : "";
        }
        //最终名称
        String finallyName = YEM.isNotEmpty(customerName) ? customerName : supplierName;

        DynamicObject dataEntity = model.getDataEntity(true);
        String sealstatus = (String) model.getValue("tpv_sealstatus", entryCurrentRowIndex);//用印状态
        DynamicObjectCollection entryRows = this.getModel().getEntryEntity("tpv_attachmentdetail");
//        EntryGrid entry = this.getView().getControl("tpv_attachmentdetail");//获取分录控件
        String departmentName = "";
        if (selectedProperties.containsKey("org")) {
            DynamicObject department = (DynamicObject) model.getValue("tpv_department");
            if (department != null) {
                departmentName = department.getString("name");//部门内码
            }
        }
        DynamicObject creator = (DynamicObject) model.getValue("creator");
        String creatorName = creator != null ? creator.getString("name") : "";//创建人
        String currUserName = RequestContext.get().getUserName();//操作人
        //获取印章id
        JSONObject jsons = JSONObject.parseObject(attachmentcon);
        if (jsons != null) {
            Set<String> strings = jsons.keySet();
            Long sealId = 0L;//印章ID
            Long sealIdSrc = 0L;//原件印章ID
            String designation = "";//附件名称
            String fddId = "";//fdd印章ID
            String tpvSignatorymailbox = "";//对方签署人ID
            String tpvFddcompanyid = "";//对方企业Id
            Long fjid = 0L;
            String uid = "";//附件id

            String serialNumbers = "";//预审序列号
            String contentscaling = "";// 缩放比例
            String locationName = "";// 预审码位置
            String attachmentnameSrc = null;
            if (strings.size() > 0 && null != strings) {
                for (String names : strings) {
                    if (jsons != null) {
                        JSONObject tpv_sourcebillkey = jsons.getJSONObject(names);
                        if (tpv_sourcebillkey != null) {
                            if (names.equals(attachmentName)) {
                                attachmentnameSrc = tpv_sourcebillkey.getString("attacNameTwo");
                                JSONObject tpvSeal = tpv_sourcebillkey.getJSONObject("seal");
                                if (tpvSeal != null) {
                                    sealId = (Long) tpvSeal.get("selectstamp");// 印章id
                                    fddId = (String) tpvSeal.get("selectstampfddid");// 法大大印章id
                                    tpvFddcompanyid = (String) tpvSeal.get("tpvFddcompanyid");// 签署人id
                                    designation = (String) tpv_sourcebillkey.get("name");// 附件名称
                                    tpvSignatorymailbox = (String) tpvSeal.get("tpvSignatorymailbox");// 对方签署人id
                                    uid = (String) tpv_sourcebillkey.get("uid");
                                    serialNumbers = (String) tpv_sourcebillkey.get("serialNumber");
                                    contentscaling = (String) tpvSeal.get("contentscaling");// 缩放比例
                                    locationName = (String) tpvSeal.get("precencodelocation");// 预审码位置
                                }
                            }
                        }
                    }
                }
                for (String names : strings) {
                    if (names.equals(attachmentnameSrc)) {
                        JSONObject data = jsons.getJSONObject(attachmentnameSrc);//预审件里原件名称
                        if (data != null) {
                            JSONObject seal = (JSONObject) data.get("seal");// 印章id
                            if (seal != null) {
                                sealIdSrc = (Long) seal.get("selectstamp");
                            }
                        }
                    }
                }
            }
            //当前登录人是否有权
            RequestContext rc = RequestContext.get();
            Long userId = rc.getCurrUserId();
            QFilter[] qFilteres = new QFilter[]{new QFilter("tpv_staff", QCP.equals, userId)};
            String selectfieldsFasts = DynamicObjectUtil.getSelectfieldsFast("tpv_iscb_sealmanager", "tpv_iscb_sealmana_yz");
            DynamicObject queryYZ = BusinessDataServiceHelper.loadSingle("tpv_iscb_sealmanager", selectfieldsFasts, qFilteres);//印章管理员
            List<Long> enableSealIds = new ArrayList<>();
            if (queryYZ != null) {
                DynamicObjectCollection tpvEntryentity = queryYZ.getDynamicObjectCollection("tpv_iscb_sealmana_yz");
                for (DynamicObject obs : tpvEntryentity) {
                    DynamicObject tpvSeal = obs.getDynamicObject("tpv_seal");
                    if(tpvSeal != null) {
                        enableSealIds.add(tpvSeal.getLong("id"));
                    }
                }
            }
            QFilter[] qFilte = new QFilter[]{new QFilter("id", QCP.equals, userId)};
            String selectfields = DynamicObjectUtil.getSelectfieldsFast("bos_user");//人员
            DynamicObject[] queryUser = BusinessDataServiceHelper.load("bos_user", selectfields, qFilte);//印章管理员
            if (StringUtils.equals("tpv_bsignonline", itemKey) | StringUtils.equals("tpv_applyforprint", itemKey)
                    | StringUtils.equals("tpv_prelim", itemKey) | StringUtils.equals("tpv_quashprelim", itemKey) |
                    StringUtils.equals("tpv_approvalprinting", itemKey) | StringUtils.equals("tpv_withdrawal", itemKey) |
                    StringUtils.equals("tpv_invitationsign", itemKey) | StringUtils.equals("tpv_bsignonline", itemKey)
                    | StringUtils.equals("tpv_quashprint", itemKey)| StringUtils.equals("tpv_withdraw", itemKey)) {
                if (StringUtils.equals("tpv_bsignonline", itemKey)) {
                    if(isHasRight(view, queryYZ, sealIdSrc, enableSealIds)) {
                        Long passwordprints = 0L;
                        passwordprints = queryYZ.getLong("tpv_passwordprints");
                        if (passwordprints > 5) {
                            view.showMessage("当前用户今日密码错误超过5次，已锁定，请联系管理员。");
                        } else {
                            DynamicObject dynamicObject = entryRows.get(entryCurrentRowIndex);  //获取选中行的单据体数据
                            String inquiry = dynamicObject.getString("tpv_inquiry");//预审标记
                            String tpvSealstatus = dynamicObject.getString("tpv_sealstatus");//用印状态
                            String tpvPrintingmethod = dynamicObject.getString("tpv_printingmethod");//用印方式
                            String tpvSignaturestatus = dynamicObject.getString("tpv_signaturestatus");//签章情况
                            HashMap<String, Object> value = new HashMap<>();
                            value.put("tpv_sealstatus", "D");
                            HashMap<String, Object> mapAs = new HashMap<>();
                            mapAs.put("tpv_sealstatus", "D");
                            //进入线上签】（双方线上签署-对方先）
                            if (tpvPrintingmethod != null && tpvPrintingmethod.equals("E")) {
                                if (tpvSealstatus != null && tpvSealstatus.equals("D")) {
                                    if (inquiry != null && inquiry.equals("B")) {
                                        FormShowParameter showParameter = new FormShowParameter();
                                        // 设置弹出页面的标识
                                        showParameter.setFormId("tpv_iscb_enterpassword");
                                        Map<String, Object> map = this.showInfoForms();
                                        // 存入获取到的动态表单数据
                                        showParameter.setCustomParams(map);
                                        // 状态
                                        showParameter.setStatus(OperationStatus.ADDNEW);
                                        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_bsignonline"));
                                        // 设置弹出页面打开方式
                                        // MainNewTabPage
                                        showParameter.getOpenStyle().setShowType(ShowType.Modal);
                                        // 打开动态表单
                                        this.getView().showForm(showParameter);
                                        extracted(model, view, attachmentName, value);
                                    } else {
                                        view.showMessage("选中的文件的【用印状态】必须=待我方签署  且 【预审标记】必须=已预审 且【签章情况】≠我方单签or双签，请检查。");
                                    }
                                } else {
                                    view.showMessage("选中的文件的【用印状态】必须=待我方签署  且 【预审标记】必须=已预审 且【签章情况】≠我方单签or双签，请检查。");
                                }
                            }
                            //进入线上签】（双方线上签署-我方先）
                            if (tpvPrintingmethod != null && tpvPrintingmethod.equals("D")) {
                                if (tpvSealstatus != null && tpvSealstatus.equals("D")) {
                                    if (inquiry != null && inquiry.equals("B")) {

                                        FormShowParameter showParameter = new FormShowParameter();
                                        // 设置弹出页面的标识
                                        showParameter.setFormId("tpv_iscb_enterpassword");
                                        Map<String, Object> map = this.showInfoForms();
                                        showParameter.setCustomParams(map);
                                        // 状态
                                        showParameter.setStatus(OperationStatus.ADDNEW);
                                        showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_bsignonline"));
                                        // 设置弹出页面打开方式
                                        showParameter.getOpenStyle().setShowType(ShowType.Modal);
                                        // 打开动态表单
                                        this.getView().showForm(showParameter);
                                        extracted(model, view, attachmentName, mapAs);
                                    } else {
                                        view.showMessage("选中的文件的【用印状态】必须=待我方签署 且 【预审标记】必须=已预审 且【签章情况】≠我方单签or双签，请检查。");
                                    }
                                } else {
                                    view.showMessage("选中的文件的【用印状态】必须=待我方签署 且 【预审标记】必须=已预审 且【签章情况】≠我方单签or双签，请检查。");
                                }
                            }
                            //进入线上签】（本方线上单签）
                            if (tpvPrintingmethod != null && tpvPrintingmethod.equals("B")) {
                                if (inquiry != null && inquiry.equals("B")) {
                                    FormShowParameter showParameter = new FormShowParameter();
                                    // 设置弹出页面的标识
                                    showParameter.setFormId("tpv_iscb_enterpassword");
                                    Map<String, Object> map = this.showInfoForms();
                                    // 存入获取到的动态表单数据
                                    showParameter.setCustomParams(map);
                                    // 状态
                                    showParameter.setStatus(OperationStatus.ADDNEW);
                                    showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_bsignonline"));
                                    // 设置弹出页面打开方式
                                    showParameter.getOpenStyle().setShowType(ShowType.Modal);
                                    // 打开动态表单
                                    this.getView().showForm(showParameter);
                                } else {
                                    view.showMessage("选中的文件的【用印状态】必须=待我方签署 且 该文件未经预审，或已被重新上传，请签署时注意核验！");
                                }
                            }
                        }
                    }
                }
                //撤回签署
                if (StringUtils.equals("tpv_withdraw", itemKey)) {
                    if(isHasRight(view, queryYZ, sealIdSrc, enableSealIds)) {
                        Long passwordprints = 0L;
                        passwordprints = queryYZ.getLong("tpv_passwordprints");
                        if (passwordprints > 5) {
                            view.showMessage("当前用户今日密码错误超过5次，已锁定，请联系管理员。");
                        } else {
                            DynamicObject dynamicObject = entryRows.get(entryCurrentRowIndex);  //获取选中行的单据体数据
                            String tpvSealstatus = dynamicObject.getString("tpv_sealstatus");//用印状态
                            String tpvPrintingmethod = dynamicObject.getString("tpv_printingmethod");//用印方式
                            if (YEM.isNotEmpty(tpvSealstatus) && "G".equals(tpvSealstatus)) {
                                view.showMessage("文件已经签署完成，无法撤回，请线下沟通并考虑通过补充协议撤销！");
                            }else {
                                if ("F".equals(tpvSealstatus)) {//待对方签署
                                    FormShowParameter showParameter = new FormShowParameter();
                                    // 设置弹出页面的标识
                                    showParameter.setFormId("tpv_iscb_withdrawsign");
                                    Map<String, Object> map = this.showInfoForms();
                                    // 存入获取到的动态表单数据
                                    //showParameter.setCustomParams(map);
                                    // 状态
                                    showParameter.setStatus(OperationStatus.ADDNEW);
                                    showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_withdraw"));
                                    // 设置弹出页面打开方式
                                    showParameter.getOpenStyle().setShowType(ShowType.Modal);
                                    // 打开动态表单
                                    this.getView().showForm(showParameter);
                                }
                                if ("D".equals(tpvSealstatus) && (YEM.isNotEmpty(tpvPrintingmethod) && "E".equals(tpvPrintingmethod))) {//待我方签署
                                    FormShowParameter showParameter = new FormShowParameter();
                                    // 设置弹出页面的标识
                                    showParameter.setFormId("tpv_iscb_withdrawalpend");
                                    Map<String, Object> map = this.showInfoForms();
                                    // 存入获取到的动态表单数据
                                   // showParameter.setCustomParams(map);
                                    // 状态
                                    showParameter.setStatus(OperationStatus.ADDNEW);
                                    showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_withdraw"));
                                    // 设置弹出页面打开方式
                                    showParameter.getOpenStyle().setShowType(ShowType.Modal);
                                    // 打开动态表单
                                    this.getView().showForm(showParameter);
                                }
                            }
                        }
                    }
                }
                String name = getString(entryCurrentRowIndex, attachmentcon);
                if (StringUtils.equals("tpv_applyforprint", itemKey)) {
                    OperationResult saveResult = view.invokeOperation("save", YEM.getOptionNoMsg());
                    if (saveResult.isSuccess()) {
                        EntryGrid control = view.getControl("tpv_attachmentdetail");
                        control.selectRows(entryCurrentRowIndex);
                        if (name.equals("jpeg") || name.equals("jpg") || name.equals("png") || name.equals("doc")
                                || name.equals("docx") || name.equals("wps") || name.equals("pdf")
                                || name.equals("xls") || name.equals("xlsx")) {
                            FormShowParameter showParameter = new FormShowParameter();
                            // 设置弹出页面的标识
                            showParameter.setFormId("tpv_dt_printingfunction");
                            Map<String, Object> map = this.showInfoForm();
                            // 存入获取到的动态表单数据
                            showParameter.setCustomParams(map);
                            // 状态
                            showParameter.setStatus(OperationStatus.ADDNEW);
                            // 设置页面关闭回调方法
                            // CloseCallBack参数：回调插件，回调标识
                            showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_applyforprint"));
                            // 设置弹出页面打开方式
                            showParameter.getOpenStyle().setShowType(ShowType.Modal);
                            // 打开动态表单
                            this.getView().showForm(showParameter);
                        } else {
                            this.getView().showMessage("支持文件格式有【.jpeg, .jpg, .png, .doc, .docx, .wps, .pdf, .xls, .xlsx】，请检查文件格式。");
                        }
                    }
                }
                //撤回申请
                if (StringUtils.equals("tpv_quashprint", itemKey)) {
                    JSONObject jso = JSONObject.parseObject(attachmentcon);
                    Set<String> keys = jsons.keySet();
                    String designations = "";//附件名称
                    if (strings.size() > 0 && null != keys) {
                        for (String names : keys) {
                            if (jso != null) {
                                JSONObject tpv_sourcebillkey = jso.getJSONObject(names);
                                if (tpv_sourcebillkey != null) {
                                    if (names.equals(attachmentName)) {
                                        designations = (String) tpv_sourcebillkey.get("attachmentnames");// 附件名称
                                    }
                                }
                            }
                        }
                    }
                    if (designations != null && !"".equals(designations)) {
                        view.showMessage("已产生后续预审文件，请联系业务管理员先撤销预审再重新申请");
                    } else {
                        HashMap<String, Object> value = new HashMap<>();
                        value.put("tpv_sealstatus", "");
                        value.put("tpv_printingmethod", "");
                        extracted(model, view, attachmentName, value);
                    }
                }

                if (StringUtils.equals("tpv_prelim", itemKey)) {  //预审
                    long id = 0L;
                    String status = "";//新文件的用印状态
                    String appId = model.getDataEntityType().getAppId(); //获取当前单据所在的应用标识
                    String formId = model.getDataEntityType().getName();//获取当前单据标识
                    String pkId = String.valueOf(model.getDataEntity().getPkValue());//单据内码
                    String attachmentKey = "attachmentpanel";
                    String fileName = (String) model.getValue("tpv_attachmentname", entryCurrentRowIndex);//文件名称
                    String sealWay = (String) model.getValue("tpv_printingmethod", entryCurrentRowIndex);//用印方式
                    //判断新文件的用印状态
                    if (sealWay == null) {
                        status = "A";
                    } else {
                        if (sealWay.equals("F")) {//仅预审
                            status = "O";
                        }
                        if (sealWay.equals("A")) {//印控仪
                            status = "C";
                        }
                        if (sealWay.equals("B")) {//本方线上单签
                            status = "D";
                        }
                        if (sealWay.equals("C")) {//对方线上单签
                            status = "E";
                        }
                        if (sealWay.equals("D")) {//双方线上签署我方先
                            status = "D";
                        }
                        if (sealWay.equals("E")) {//双方线上签署对方先
                            status = "E";
                        }
                    }
                    String select = DynamicObjectUtil.getSelectfields("tpv_iscb_preapproval");
                    // 查询预审码信息
                    DynamicObject[] load = BusinessDataServiceHelper.load("tpv_iscb_preapproval", select, new QFilter[]{
                            new QFilter("tpv_locationname", QCP.equals, locationName)
                    });
                    String tpvXhcoord = "";//X坐标(横向纸张)
                    String tpvXzcoord = "";//(纵向纸张)
                    if (load.length > 0) {
                        DynamicObject signInfo = load[0];
                        tpvXhcoord = signInfo.getString("tpv_xhcoords");
                        tpvXzcoord = signInfo.getString("tpv_xzcoords");
                    }
                    PdfFileModel inputVo = new PdfFileModel();
                    String digitNumber = SealStewardClientHelper.generateUniqueSixDigitNumber();//预审字符码
                    String serialNumber = SealStewardClientHelper.generatePreApprovalNumber(tpvBizdate);//预审序列号
                    inputVo.setQr_page("2");// 二维码页面:0：无 1：首页 2：每页 免码用印传0，默认传2
                    inputVo.setQr_location(tpvXzcoord);// 二维码坐标(像素): x1,y1
                    inputVo.setQr_size("80");// 二维码尺寸:75
                    inputVo.setSrcEntity(dataEntity);
                    inputVo.setStatus(status);
                    inputVo.setMethod(sealWay);
                    inputVo.setQr_text("{$YS}" + serialNumber);// 二维码内容
                    inputVo.setAttachment_id(uid);// 附件id
                    inputVo.setOrientation("1");// 1：纵向 2：横向：按[申请用印-高级]中结果传
                    inputVo.setContract_no((String) model.getValue("billno"));// 附件所在单据号的外码
                    inputVo.setVprepare_uid(creatorName);// 匹配小易用户编码显示：单据制单人String.valueOf(creatorId)
                    inputVo.setDepartment_id(departmentName);// 匹配小易部门编码显示：大部门内码
                    inputVo.setSeal_ids(String.valueOf(sealId));// 按corpbcode传矿产合同章或航工合同章的印章id
                    inputVo.setCorpbcode(orgName);// 公司名称-我司抬头
                    inputVo.setGrantor_uid(currUserName);// 批准用印人
                    inputVo.setCode(finallyName);// 客商名称
                    inputVo.setTpv_operate("B");
                    inputVo.setTpv_sourcebillscode((String) model.getValue("billno"));
                    inputVo.setRemark("公司本部内贸销售合同开发测试20231122的附件，由金蝶操作。");// 备注
                    String identification = this.getView().getEntityId();
                    String ids = String.valueOf(this.getModel().getDataEntity().getPkValue());
                    String filuid = "";
                    String filurl = "";
                    List<Map<String, Object>> atts = AttachmentServiceHelper.getAttachments(identification, ids, "attachmentpanel", true);
                    for (Map<String, Object> att : atts) {
                        filuid = (String) att.get("uid");
                        if (uid.equals(filuid)) {
                            filurl = (String) att.get("url");
                        }
                    }
                    long currUserId = RequestContext.get().getCurrUserId();
                    inputVo.setCurruserid(currUserId);
                    String filurlBase64 = getbase64(filurl);
                    inputVo.setFile_b64(filurlBase64);// 源文件doc（x）、文字pdf、xls（x）的base64
                    inputVo.setFile_name(fileName);// 源文件名:doc（x）、文字pdf、xls（x）
                    inputVo.setResize_percent(contentscaling);//缩放百分比
                    inputVo.setRotate("1");// 0：不开启自动翻转,1：开启自动翻转,默认1
                    inputVo.setQr_locationx(tpvXhcoord);// 二维码坐标(像素): x1,y1
                    inputVo.setScode_text(digitNumber);// 字符码
                    inputVo.setScode_page("2");// 字符码页面: 1：首页 2：每页 3：末页 默认传2
                    inputVo.setScode_size("10");// 字符码尺寸:75像素
                    inputVo.setScode_location("qru");// 字符码坐标
                    inputVo.setScode_locationx("380,380");// 第二套字符码坐标
                    CustomApiResult<Map> mapCustomApiResult = PdfFileController.pdfFile(inputVo);
                    if (mapCustomApiResult.isStatus()) {
                        HashMap<String, Object> value = new HashMap<>();
                        value.put("tpv_inquiry", "C");
                        value.put("tpv_sealstatus", "B");
                        value.put("tpv_charactercode", digitNumber);
                        value.put("tpv_pretrialcode", serialNumber);
                        extracted(model, view, attachmentName, value);
                    }else {
                        String message = mapCustomApiResult.getMessage();
                        view.showMessage("调用接口失败! " + message);
                    }
                }
                //撤回预审
                if (StringUtils.equals("tpv_quashprelim", itemKey)) {
                    JSONObject jsos = JSONObject.parseObject(attachmentcon);
                    Set<String> keySet = jsons.keySet();
                    String designationes = "";//附件名称
                    String status = "";//原文件的用印状态
                    String newStatus = "";//新文件的用印状态
                    String printingmethod = "";//新文件的用印状态
                    String attacName = attachmentName;//附件名称
                    int i = attacName.lastIndexOf(".");
                    attacName = attacName.substring(0, i);
                    attacName = "预审件-" + attacName + ".pdf";
                    String id = "";
                    Boolean satus=false;
                    if (strings.size() > 0 && null != keySet) {
                        for (String names : keySet) {
                            if (jsos != null) {
                                JSONObject tpv_sourcebillkey = jsos.getJSONObject(names);
                                if (tpv_sourcebillkey != null) {
                                    if (names.equals(attachmentName)) {
                                        designationes = (String) tpv_sourcebillkey.get("name");// 附件名称
                                        status = (String) tpv_sourcebillkey.get("tpv_sealstatus");// 附件状态
                                        printingmethod = (String) tpv_sourcebillkey.get("tpv_printingmethod");//
                                    }
                                    if (names.equals(attacName)) {
                                        satus=true;
                                        id = tpv_sourcebillkey.getString("uid");// 附件id  status
                                        newStatus = (String) tpv_sourcebillkey.get("tpv_sealstatus");// 附件状态
                                    }
                                }
                            }
                        }
                    }
                    if (satus) {
                        if ("B".equals(status) && ("C".equals(newStatus) || "D".equals(newStatus) || "E".equals(newStatus) || "O".equals(newStatus)) ) {
                            QFilter[] qFilters = new QFilter[]{new QFilter("fnumber", QCP.equals, id)};
                            DeleteServiceHelper.delete("bos_attachment", qFilters);
                            HashMap<String, Object> value = new HashMap<>();
                            value.put("tpv_inquiry", "A");
                            extracted(model, view, attachmentName, value);
                        }else {
                            view.showMessage("撤回预审失败，后级文件已产生签署流程，对后级文件撤回签署后才能撤回预审");
                        }
                    } else {
                        view.showMessage("撤回预审失败，该文件未生成预审件，请稍候刷新再试，超过3分钟仍未见预审件请联系信息技术部");
                    }
                }

                //批准印控
                if (StringUtils.equals("tpv_approvalprinting", itemKey)) {
                    String fileName = (String) model.getValue("tpv_attachmentname", entryCurrentRowIndex);//文件名称
                    String phone = "";
                    String zgjFileName = "";
                    Long sealIds = 0L;
                    String applicationId = "";//ZGJ印章ID
                    String attacName = attachmentName;//附件名称
                    int i = attacName.lastIndexOf(".");
                    attacName = attacName.substring(0, i);
                    attacName = "预审件-" + attacName + ".pdf";
                    if(isHasRight(view, queryYZ, sealIdSrc, enableSealIds)) {
                        for (DynamicObject obj : queryUser) {
                            phone = obj.getString("phone");
                            phone = "15664888536";
                        }
                        JSONObject jsones = JSONObject.parseObject(attachmentcon);
                        Set<String> keys = jsons.keySet();
                        if (strings.size() > 0 && null != keys) {
                            for (String names : keys) {
                                if (jsones != null) {
                                    JSONObject tpv_sourcebillkey = jsones.getJSONObject(names);
                                    String attachmentnames = tpv_sourcebillkey.getString("attacNameTwo");
                                    if (tpv_sourcebillkey != null) {
                                        if (names.equals(attachmentName)) {
                                            JSONObject tpvSeal = jsones.getJSONObject(attachmentnames);//预审件里原件名称
                                            if (tpvSeal != null) {
                                                JSONObject seal = (JSONObject) tpvSeal.get("seal");// 印章id
                                                if (seal != null) {
                                                    sealIds = (Long) seal.get("selectstamp");
                                                    applicationId = (String) seal.get("selectstampzgjid");// 章管家印章id
                                                    serialNumbers = tpvSeal.getString("tpv_pretrialcode");
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        BottomTableModel bottomTableModel =new BottomTableModel();
                        bottomTableModel.setTpvSerialnumber(serialNumbers);
                        bottomTableModel.setSrcEntity(dataEntity);
                        bottomTableModel.setFileName(fileName);
                        bottomTableModel.setTpvSourcebillscode((String) model.getValue("billno"));
                        List<tpv.tpv_wm.tpv_iscb.java.api.sealstewardapi.SealStewardClientHelper.SealSteward> sealStewardsList = SealStewardClient.applicationForSeal(tpvBizdate, applicationId, serialNumbers, attachmentName, phone,bottomTableModel);
                        if (sealStewardsList != null && !sealStewardsList.isEmpty()) {
                            AtomicReference<String> sealResultUrl = new AtomicReference<>();
                            Optional.ofNullable(sealStewardsList)
                                    .map(u -> {
                                        u.stream().findFirst().map(n -> {
                                            sealResultUrl.set(n.getSealResultUrl());
                                            return n;
                                        });
                                        return u;
                                    });
                            String resultUrl = sealResultUrl.get();
                            view.showMessage("批准印控成功");
                            //文件的【用印状态】更新为“印控就绪”
                            HashMap<String, Object> value = new HashMap<>();
                            value.put("tpv_sealstatus", "P");
                            value.put("resultUrl", resultUrl);
                            value.put("serialNumber", serialNumbers);
                            extracted(model, view, attachmentName, value);
                        } else {
                            view.showMessage("批准印控失败,请联系信息技术部。");
                        }
                    }
                }

                //撤回批准
                if (StringUtils.equals("tpv_withdrawal", itemKey)) {
                    if(isHasRight(view, queryYZ, sealIdSrc, enableSealIds)) {
                        String serialNumber = "";
                        JSONObject json = JSONObject.parseObject(attachmentcon);
                        Set<String> str = jsons.keySet();
                        if (strings.size() > 0 && null != strings) {
                            for (String names : str) {
                                if (json != null) {
                                    JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                                    if (tpv_sourcebillkey != null) {
                                        if (names.equals(attachmentName)) {
                                            serialNumber = (String) tpv_sourcebillkey.get("serialNumber");// 用印申请id                          }
                                        }
                                    }
                                }
                            }
                            int errcode = SealStewardClient.withdrawOfApplicationForSeal(serialNumber);
                            if (errcode == 0) {
                                //文件的【用印状态】更新为“印控就绪”
                                HashMap<String, Object> value = new HashMap<>();
                                value.put("tpv_sealstatus", "C");
                                extracted(model, view, attachmentName, value);
                                view.showMessage("撤销成功");
                            } else {
                                view.showMessage("撤销失败，对应附件可能已被用印，请注意立即沟通");
                            }
                        }
                    }
                }
                if (StringUtils.equals("tpv_invitationsign", itemKey)) {  //邀请签署  对方线上单签  双方线上签署-对方先
                    if(isHasRight(view, queryYZ, sealIdSrc, enableSealIds)) {
                        JSONObject jsones = JSONObject.parseObject(attachmentcon);
                        Set<String> keys = jsons.keySet();
                        if (strings.size() > 0 && null != keys) {
                            for (String names : keys) {
                                if (jsones != null) {
                                    JSONObject tpv_sourcebillkey = jsones.getJSONObject(names);
                                    String attachmentnames = tpv_sourcebillkey.getString("attacNameTwo");
                                    if (tpv_sourcebillkey != null) {
                                        if (names.equals(attachmentName)) {
                                            JSONObject tpvSeal = jsones.getJSONObject(attachmentnames);//预审件里原件名称
                                            if (tpvSeal != null) {
                                                JSONObject seal = (JSONObject) tpvSeal.get("seal");// 印章id
                                                if (seal != null) {
                                                    tpvSignatorymailbox = (String) seal.get("tpvSignatorymailbox");// 对方签署人id
                                                    fddId = (String) seal.get("selectstampfddid");// 法大大印章id
                                                    tpvFddcompanyid = (String) seal.get("tpvFddcompanyid");// 签署人id
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        ContractSignTask contractSignTask = new ContractSignTask();
                        if ("".equals(sceneInfo) || sceneInfo != null) {
                            if ("C".equals(sceneInfo)) { //对方线上单签
                                contractSignTask.setSignFileName(attachmentName);
                                contractSignTask.setSrcEntity(dataEntity);
                                contractSignTask.setTraderName(finallyName);
                                contractSignTask.setTraderId(tpvFddcompanyid);
                                contractSignTask.setIsFristSign(false);
                                contractSignTask.setSignerAccountId(tpvSignatorymailbox);
                                contractSignTask.setIsAutoSign(false);
                                contractSignTask.setSealId(fddId);
                                contractSignTask.setSceneInfo(sceneInfo);

                            } else {  // 双方线上签署-对方先
                                contractSignTask.setSignFileName(attachmentName);
                                contractSignTask.setSrcEntity(dataEntity);
                                contractSignTask.setCompanyName(orgName);
                                contractSignTask.setTraderName(finallyName);
                                contractSignTask.setTraderId(tpvFddcompanyid);
                                contractSignTask.setIsAutoSign(false);
                                contractSignTask.setSealId(fddId);
                                contractSignTask.setSignerAccountId(tpvSignatorymailbox);
                                contractSignTask.setIsFristSign(false);
                                contractSignTask.setSceneInfo(sceneInfo);
                                contractSignTask.setSealstatus(sealstatus);
                            }
                        }
                        ContractSignUtil contractSignUtil = new ContractSignUtil();
                        CustomApiResult<Map<String, String>> mapCustomApiResult = contractSignUtil.creatSignTask(contractSignTask);
                        if (mapCustomApiResult.isStatus()) {
                            Map<String, String> data = mapCustomApiResult.getData();
                            String docId = data.get("docId");
                            HashMap<String, Object> value = new HashMap<>();
                            value.put("tpv_sealstatus", "F");
                            value.put("tpv_inquiry", "B");
                            value.put("docId", docId);
                            if ("E".equals(data.get("sceneInfo"))) { //双签对方先
                                value.put("tpv_printingmethod", "E");
                            }
                            if ("C".equals(data.get("sceneInfo"))) { //单签对方先
                                value.put("tpv_printingmethod", "C");
                            }
                            extracted(model, view, attachmentName, value);
                        } else {
                            String errorCode = mapCustomApiResult.getErrorCode();
                            String message = mapCustomApiResult.getMessage();
                            view.showMessage("邀请签署失败," + "返回码:" + errorCode + ",描述信息:"
                                    + message + ",请联系信息技术部。");
                        }
                    }
                }
            }
        }
    }


    private boolean isHasRight(IFormView view, DynamicObject queryYZ, Long sealIdSrc, List<Long> enableSealIds) {
        if (queryYZ != null) {
            if(enableSealIds.contains(sealIdSrc)) {
                return true;
            }else {
                view.showMessage("当前登录人对于本附件申请的印章没有管理权");
            }
        } else {
            view.showMessage("当前登录人不是印章管理员");
        }
        return false;
    }

    /**
     * @param null
     * @return
     * @description 回填申请用印弹框内容
     * @author yhj
     * @date 2023/11/17 14:42
     */
    private Map<String, Object> showInfoForms() {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        long id = 0L;
        int entryCurrentRowIndex = this.getModel().getEntryCurrentRowIndex("tpv_attachmentdetail");
        String attachmentcon = (String) this.getModel().getValue("tpv_attachmentcon_tag");
        String attachmentName = (String) this.getModel().getValue("tpv_attachmentname", entryCurrentRowIndex);
        String sceneInfo = (String) model.getValue("tpv_printingmethod", entryCurrentRowIndex);//场景
        String sealstatus = (String) model.getValue("tpv_sealstatus", entryCurrentRowIndex);//用印状态
        DataEntityPropertyCollection selectedProperties = this.getModel().getDataEntityType().getProperties();
        String orgName = "";
        if (selectedProperties.containsKey("org")) {
            DynamicObject org = (DynamicObject) model.getValue("org");//公司
            orgName = org != null ? org.getString("name") : "";//公司名称
        }
        //客户名称
        String customerName = "";
        Long customerid = 0l;
        if (selectedProperties.containsKey("tpv_customer")) {
            DynamicObject customer = (DynamicObject) model.getValue("tpv_customer");//客户
            customerName = customer != null ? customer.getString("name") : "";
            customerid = customer != null ? customer.getLong("id") : 0l;
        }
        //供应商名称
        String supplierName = "";
        Long supplierid = 0l;
        if (selectedProperties.containsKey("tpv_supplier")) {
            DynamicObject Supplier = (DynamicObject) model.getValue("tpv_supplier");//供应商
            supplierName = Supplier != null ? Supplier.getString("name") : "";
            supplierid = Supplier != null ? Supplier.getLong("id") : 0l;
        }
        //最终名称
        String finallyName = YEM.isNotEmpty(customerName) ? customerName : supplierName;
        DynamicObject dataEntity = model.getDataEntity(true);
        JSONObject jsons = JSONObject.parseObject(attachmentcon);
        String fddId = "";//fdd印章ID
        String tpvSignatorymailbox = "";//对方签署人ID
        String tpvFddcompanyid = "";//对方企业Id
        //String docld="";//应用标识
        if (jsons != null) {
            Set<String> strings = jsons.keySet();
            if (strings.size() > 0 && null != strings) {
                for (String names : strings) {
                    if (jsons != null) {
                        JSONObject tpv_sourcebillkey = jsons.getJSONObject(names);
                        if (tpv_sourcebillkey != null) {
                            if (names.equals(attachmentName)) {
                                JSONObject tpvSeal = tpv_sourcebillkey.getJSONObject("seal");
                                if (tpvSeal != null) {
                                    fddId = (String) tpvSeal.get("selectstampfddid");// 法大大印章id
                                    tpvFddcompanyid = (String) tpvSeal.get("tpvFddcompanyid");// 签署人id
                                    tpvSignatorymailbox = (String) tpvSeal.get("tpvSignatorymailbox");// 对方签署人id
                                    //docld = (String) tpv_sourcebillkey.get("docId");// 附件名称
                                }
                            }
                        }
                    }
                }
            }
        }
        if (YEM.isNotEmpty(customerName)) {
            //最终名称id
            id = YEM.isNotEmpty(customerName) ? customerid : supplierid;
        }
        Map<String, Object> map = new HashMap<>();
        if (attachmentcon != null) {
            map.put("attachmentcon", attachmentcon);
        }
        if (attachmentName != null) {
            map.put("attachmentName", attachmentName);
        }
        if (YEM.isNotEmpty(finallyName)) {
            map.put("customerName", finallyName);
        }
        if (fddId != null) {
            map.put("fddId", fddId);
        }
        if (sceneInfo != null) {
            map.put("sceneInfo", sceneInfo);
        }
        if (YEM.isNotEmpty(orgName)) {
            map.put("orgName", orgName);
        }
        if (id != 0L) {
            map.put("id", id);
        }
        if (dataEntity != null) {
            map.put("dataEntity", dataEntity);
        }
        if (tpvFddcompanyid != null) {
            map.put("tpvFddcompanyid", tpvFddcompanyid);
        }
        if (tpvSignatorymailbox != null) {
            map.put("tpvSignatorymailbox", tpvSignatorymailbox);
        }
        if (sealstatus != null) {
            map.put("sealstatus", sealstatus);
        }
        return map;
    }

    /**
     * 获取url
     *
     * @param appId    应用标识
     * @param formId   单据标识
     * @param pkId     单据内码
     * @param fileName 文件名
     * @param stream   接口返回的base64转的文件流
     * @return url
     * @throws IOException
     */
    private static String url(String appId, String formId, String pkId, String fileName, String stream) throws
            IOException {
        Date today = new Date();
        File file = new File(stream);
        DateFormat df = new SimpleDateFormat("yyyyMM");
        String NewDateStr = df.format(today);
        String attachmentPath = "/" + RequestContext.get().getTenantId() + "/" + RequestContext.get().getAccountId()
                + "/" + NewDateStr + "/" + appId + "/" + formId + "/" + pkId + "/attachments/";
        FileService fs = FileServiceFactory.getAttachmentFileService();
        String path = attachmentPath + fileName;
        FileItem fi = new FileItem(fileName, path, new FileInputStream(stream));//"接口返回的base64转的文件流")
        fi.setCreateNewFileWhenExists(true);
        String url = fs.upload(fi);
        return url;
    }

    /**
     * @param null
     * @return
     * @description 截取附件名称后缀
     * @author yhj
     * @date 2023/11/17 14:42
     */
    @NotNull
    private String getString(int entryCurrentRowIndex, String attachmentcon) {
        String attachmentName = (String) this.getModel().getValue("tpv_attachmentname", entryCurrentRowIndex);
        JSONObject object = JSONObject.parseObject(attachmentcon);
        String name = "";
        if (object != null) {
            Set<String> strings = object.keySet();
            if (strings.size() > 0 && null != strings) {
                for (String key : strings) {
                    if (object != null) {
                        JSONObject tpv_sourcebillkey = object.getJSONObject(key);
                        if (tpv_sourcebillkey != null) {
                            String names = (String) tpv_sourcebillkey.get("name");
                            if (attachmentName.equals(names)) {
                                int i = names.lastIndexOf(".");
                                name = names.substring(i + 1);
                            }
                        }
                    }
                }
            }
        }
        return name;
    }

    /**
     * @param null
     * @return
     * @description 发送附件表格内容
     * @author yhj
     * @date 2023/11/17 14:42
     */
    private Map<String, Object> showInfoForm() {
        int entryCurrentRowIndex = this.getModel().getEntryCurrentRowIndex("tpv_attachmentdetail");
        DynamicObject entryRowEntity = this.getModel().getEntryRowEntity("tpv_attachmentdetail", entryCurrentRowIndex);
        Map<String, Object> map = new HashMap<>();
        if (entryRowEntity != null) {
            map.put("entryRowEntity", entryRowEntity);
        }
        return map;
    }

    /**
     * @param null
     * @return
     * @description 关闭回调修改本单内容
     * @author yhj
     * @date 2023/11/17 14:42
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {//子界面关闭时，触发父界面的closedCallBack事件
        //super.closedCallBack(closedCallBackEvent);
        Object returnData = closedCallBackEvent.getReturnData();//子页面返回数据
        //判断标识是否匹配，并验证返回值不为空，不验证返回值可能会报空指针
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_applyforprint") && null != closedCallBackEvent.getReturnData()) {
            //这里返回对象为Object，可强转成相应的其他类型，
            //单条数据可用String类型传输，返回多条数据可放入map中，也可使用json等方式传输
            HashMap<String, Object> values = (HashMap<String, Object>) returnData;
            this.setInwardInfo(values);
        }
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_bsignonline") && null != closedCallBackEvent.getReturnData()) {
            //这里返回对象为Object，可强转成相应的其他类型，
            //单条数据可用String类型传输，返回多条数据可放入map中，也可使用json等方式传输
            HashMap<String, Object> values = (HashMap<String, Object>) returnData;

//            this.setInwardInfos(values);
            this.getView().openUrl((String) values.get("url"));
        }
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_withdraw") && null != closedCallBackEvent.getReturnData()) {
            OperationResult saveResult = this.getView().invokeOperation("refresh", YEM.getOptionNoMsg());
            HashMap<String, Object> values = (HashMap<String, Object>) returnData;
            FormShowParameter showParameter = new FormShowParameter();
            showParameter.setStatus(OperationStatus.ADDNEW);
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            showParameter.setFormId("tpv_iscb_signature");//进度动态表单
            Map<String, Object> map = new HashMap<>();
            map.put("docld", values.get("docld"));
            showParameter.setCustomParams(map);
            this.getView().showForm(showParameter);
        }
    }

    /**
     * @param null
     * @return
     * @description 弹出法大大
     * @author yhj
     * @date 2023/11/17 14:42
     */
    private void setInwardInfos(HashMap<String, Object> values) {
        //跳转法大大
        FormShowParameter BillShowParameter = new FormShowParameter();
        BillShowParameter.setCustomParams(values);
        BillShowParameter.setFormId("tpv_iscb_lawpage");
        BillShowParameter.setStatus(OperationStatus.ADDNEW);
        BillShowParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);//打开方式
        this.getView().showForm(BillShowParameter);
    }

    /**
     * @param null
     * @return
     * @description 申请用印赋值
     * @author yhj
     * @date 2023/11/17 14:42
     */
    private void setInwardInfo(HashMap<String, Object> values) {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        int entryCurrentRowIndex = model.getEntryCurrentRowIndex("tpv_attachmentdetail");
        String attachmentName = (String) model.getValue("tpv_attachmentname", entryCurrentRowIndex);
        String tpv_sealstatus = "B";
        String tpvPrintingmethod = (String) values.get("sealstatus");
        HashMap<String, Object> value = new HashMap<>();
        value.put("seal", values);
        value.put("tpv_sealstatus", tpv_sealstatus);
        value.put("tpv_printingmethod", tpvPrintingmethod);
        extracted(model, view, attachmentName, value);
    }

    /**
     * @param null
     * @return
     * @description 公共方法 修改附件表格内容
     * @author yhj
     * @date 2023/11/17 14:42
     */
    public void extracted(IDataModel model, IFormView view, String attachmentName, HashMap<String, Object> value) {
        extracted(model, view, attachmentName, value, false);
    }

    public void extracted(IDataModel model, IFormView view, String attachmentName, HashMap<String, Object> values, boolean bill) {
        String attachmentcon = (String) model.getValue("tpv_attachmentcon_tag");
        JSONObject jsons = JSONObject.parseObject(attachmentcon);
        if (jsons != null) {
            if (bill) {
                JSONObject attJson = new JSONObject();
                Set<String> strings1 = values.keySet();
                for (String keys : strings1) {
                    attJson.put(keys, values.get(keys));
                }
                jsons.put(attachmentName, attJson);
            } else {
                Set<String> strings = jsons.keySet();
                if (strings.size() > 0 && null != strings) {
                    for (String name : strings) {
                        if (jsons != null) {
                            JSONObject tpv_sourcebillkey = jsons.getJSONObject(name);
                            if (tpv_sourcebillkey != null) {
                                if (name.equals(attachmentName)) {
                                    JSONObject attJson = jsons.containsKey(name) ? jsons.getJSONObject(name) : new JSONObject();
                                    Set<String> strings1 = values.keySet();
                                    for (String keys : strings1) {
                                        attJson.put(keys, values.get(keys));
                                    }
                                    jsons.put(name, attJson);
                                }
                            }
                        }
                    }
                }
            }
            model.setValue(KEY_ATT_TAG, jsons.toJSONString());
        }
        view.invokeOperation("save", YEM.getOptionNoMsg());
        view.invokeOperation("refresh");
    }

    public static String getbase64(String url) {
        InputStream inputStream = null;
        String base64 = "";
        byte input[] = null;
        try {
            URLConnection urlConnection = new URL(url).openConnection();
            HttpURLConnection httpURLConnection = (HttpURLConnection) urlConnection;
            httpURLConnection.setConnectTimeout(1000 * 5);
            httpURLConnection.setDoOutput(true);
            httpURLConnection.setDoInput(true);
            httpURLConnection.setUseCaches(false);
            httpURLConnection.setRequestProperty("Connection", "Keep-Alive");
            httpURLConnection.setRequestProperty("Charset", "UTF-8");
            httpURLConnection.connect();

            inputStream = httpURLConnection.getInputStream();
            ByteArrayOutputStream bytestream = new ByteArrayOutputStream();
            byte[] buffer = new byte[1024];
            int ch;
            while ((ch = inputStream.read(buffer)) != -1) {
                bytestream.write(buffer, 0, ch);
            }
            input = bytestream.toByteArray();
            bytestream.close();
            base64 = Base64.getEncoder().encodeToString(input);

        } catch (Exception e1) {
            e1.printStackTrace();
        }
        return base64;
    }

    private String pullDown(DynamicObject obj, String obs) { //获取下拉列表v,获取标题方法
        MainEntityType mainEntityType = this.getModel().getDataEntityType();//获取主实体
        DataEntityPropertyCollection properties = mainEntityType.getProperties();//获取属性
        ComboProp comboUnitProp = (ComboProp) properties.get(obs);//获取字段的数据模型
        String comb = comboUnitProp.getItemByName(obj.getString(obs));//根据value获取key（标题）
        return comb;
    }

    /**
     * 文件删除时触发，可以在此事件取消后续处理
     */
    @Override
    public void beforeAttachmentRemove(BeforeAttachmentRemoveEvent e) {
        Map<String, Object> attachemnt = e.getAttachemnt();
        String uid = (String) attachemnt.get("uid");
        String attachmentcon = (String) this.getModel().getValue("tpv_attachmentcon_tag");
        JSONObject json = JSONObject.parseObject(attachmentcon);
        if (json != null) {
            Set<String> strings = json.keySet();
            if (strings.size() > 0 && null != strings) {
                for (String names : strings) {
                    if (json != null) {
                        JSONObject tpv_sourcebillkey = json.getJSONObject(names);
                        String jsonUid = (String) tpv_sourcebillkey.get("uid");
                        Boolean lock = (Boolean) tpv_sourcebillkey.get("tpv_lock");
                        String sealStatus = (String) tpv_sourcebillkey.get("tpv_sealstatus");
                        if (tpv_sourcebillkey != null) {
                            if (jsonUid.equals(uid)) {
                                if (YEM.isNotEmpty(lock) && lock) {
                                    e.setMsg("该文件已锁定");
                                    e.setCancel(true);
                                }
                                if ("B".equals(sealStatus)) {
                                    e.setMsg("申请用印之后的附件不允许删除");
                                    e.setCancel(true);
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        switch (name) {
            case "tpv_printingmethod"://用印方式
            case "tpv_sealstatus"://用印状态
            case "tpv_signaturestatus"://签章情况
            case "tpv_lock"://锁定
                updataJson(name, cd);//修改json
                break;
            default:
                break;
        }
    }

    private void updataJson(String key, ChangeData cd) {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        int entryCurrentRowIndex = model.getEntryCurrentRowIndex("tpv_attachmentdetail");
        String attachmentName = (String) model.getValue("tpv_attachmentname", entryCurrentRowIndex);
        HashMap<String, Object> value = new HashMap<>();
        value.put(key, cd.getNewValue());
        updataExtracted(model, view, attachmentName, value, false);
    }

    public void updataExtracted(IDataModel model, IFormView view, String attachmentName, HashMap<String, Object> values, boolean bill) {
        DynamicObject dataEntity = model.getDataEntity();
        String attachmentcon = (String) model.getValue("tpv_attachmentcon_tag");
        JSONObject jsons = JSONObject.parseObject(attachmentcon);
        if (jsons != null) {
            if (bill) {
                JSONObject attJson = new JSONObject();
                Set<String> strings1 = values.keySet();
                for (String keys : strings1) {
                    attJson.put(keys, values.get(keys));
                }
                jsons.put(attachmentName, attJson);
            } else {
                Set<String> strings = jsons.keySet();
                if (strings.size() > 0 && null != strings) {
                    for (String name : strings) {
                        if (jsons != null) {
                            JSONObject tpv_sourcebillkey = jsons.getJSONObject(name);
                            if (tpv_sourcebillkey != null) {
                                if (name.equals(attachmentName)) {
                                    JSONObject attJson = jsons.containsKey(name) ? jsons.getJSONObject(name) : new JSONObject();
                                    Set<String> strings1 = values.keySet();
                                    for (String keys : strings1) {
                                        attJson.put(keys, values.get(keys));
                                    }
                                    jsons.put(name, attJson);
                                }
                            }
                        }
                    }
                }
            }
            model.setValue(KEY_ATT_TAG, jsons.toJSONString());
        }
    }

}
