package tpv.tpv_wm.tpv_iscb.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.util.EventObject;

/**
 * 印章插件
 *
 * @author LiuHB
 * @version 1.0
 */
public class SealFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit unit = (BasedataEdit) this.getView().getControl("tpv_dabilltype");
        unit.addBeforeF7SelectListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_dabilltype":
                qFilterThisbilltype(e);
                break;
        }
    }

    /**
     * 过滤单据类型基础资料
     *
     * @param e
     */
    private void qFilterThisbilltype(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection dabilltype = dataEntity.getDynamicObjectCollection("tpv_advconap");
        String number = "";
        for (DynamicObject dynamicObject : dabilltype) {
            if (null != dabilltype) {
                DynamicObject billts = dynamicObject.getDynamicObject("tpv_billts");
                if (billts != null) {
                    number = billts.getString("number");
                    showParameter.getListFilterParameter().setFilter(new QFilter("number", QCP.like, "%" + number + "%"));
                }
            }
        }
    }
}