package tpv.tpv_wm.tpv_iscb.java.formplugin.form;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.sys.utils.RuleSettingsHelper;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QFilter;
import kd.scmc.sbs.common.util.FormUtil;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * 套打件处理策略-表单插件
 * @description 表单插件
 * @author GX
 */
public class StrategyFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"tpv_callcond"});
        BasedataEdit tpv_longtermag = (BasedataEdit) this.getView().getControl("tpv_printemplates");
        tpv_longtermag.addBeforeF7SelectListener((BeforeF7SelectListener)this);
    }


    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_printemplates"://采购合同号
                qFilterprintemplate(e);  //过滤当前供应商
                break;
            default:
                break;
        }
    }

    private void qFilterprintemplate(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter)e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObject thiscustomer=dataEntity.getDynamicObject("tpv_printbillxs");//打印模板所在单据
        if (thiscustomer == null) {
            return;
        }
        Object id = thiscustomer.get("id");
        QFilters.add(new QFilter("billformid.id", "=", id)); //设置过滤条件：客户
        QFilters.add(new QFilter("enable", "=", "1")); //单据状态：已审核
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }


    private static final String KEY_VCHECK = "tpv_tpl_versioncheckrule";//版本变更【校验规则】单据标识

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "tpv_callcond" ://调用条件
                DynamicObject printbillxs=(DynamicObject) this.getView().getModel().getValue("tpv_printbillxs");//打印模板所在单据
                if (printbillxs!=null){
                    String formkey=printbillxs.getString("number");
                    RuleSettingsHelper.showRuleSettings(this, formkey, "tpv_iscb_strategy_in", "tpv_callcond", "tpv_checkjson");
                }else {
                    this.getView().showTipNotification("请先选择【打印模板所在单据】！");
                }
                break;
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);
        String key = e.getActionId();
        switch (key) {
            case KEY_VCHECK :
                this.callBack4CheckRule(e);
                break;
        }
    }

    private void callBack4CheckRule(ClosedCallBackEvent e) {
        String actionId = e.getActionId();
        Object returnData = e.getReturnData();
        if(actionId != null && returnData != null) {
            IDataModel model = this.getModel();
            JSONObject jsonObj = (JSONObject) returnData;
            int rowIndex = model.getEntryCurrentRowIndex("tpv_iscb_strategy_in");
            model.setValue("tpv_callcond", jsonObj.getString("tpv_desc"), rowIndex);
            model.setValue("tpv_checkjson", jsonObj.toJSONString(), rowIndex);
        }
    }


    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        ChangeData cd = e.getChangeSet()[0];
        switch (name) {
            case "tpv_yyprocrulexs"://易氩处理规则
            case "tpv_fddprocrulexs"://FDD处理规则
                controlLock(cd);
                break;
            default:
                break;
        }
    }

    private void controlLock(ChangeData cd){
        int row=cd.getRowIndex();
        DynamicObject yyprocrulexs=(DynamicObject) this.getView().getModel().getValue("tpv_yyprocrulexs", row);//易氩处理规则
        DynamicObject fddprocrulexs=(DynamicObject) this.getView().getModel().getValue("tpv_fddprocrulexs", row);//FDD处理规则
        if (row!=0&&fddprocrulexs!=null){
            DynamicObject yyproc=(DynamicObject) this.getView().getModel().getValue("tpv_yyprocrulexs", row-1);//易氩处理规则
            if (yyproc!=null){
                this.getView().getModel().setValue("tpv_fddprocrulexs",null,row);
                this.getView().showTipNotification("法大大规则之前不能有易氩规则，这会导致运行失败！");
                return;
            }
        }
        if (yyprocrulexs!=null){
            this.getView().setEnable(false, row, "tpv_fddprocrulexs");//FDD处理规则
            this.getView().setEnable(false, row, "tpv_seal");//印章
        }else {
            this.getView().setEnable(true, row, "tpv_fddprocrulexs");//FDD处理规则
            this.getView().setEnable(true, row, "tpv_seal");//印章
        }
        if (fddprocrulexs!=null){
            this.getView().setEnable(false, row, "tpv_yyprocrulexs");//易氩处理规则
        }else {
            this.getView().setEnable(true, row, "tpv_yyprocrulexs");//易氩处理规则
        }
    }
}
