package tpv.tpv_wm.tpv_iscb.java.formplugin.form;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.sys.utils.Api;
import com.itopview.wm.sys.utils.ApiHelper;
import com.itopview.wm.sys.utils.ApiLog;
import com.itopview.wm.utils.HttpHelper;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import tpv.tpv_wm.tpv_iscb.java.api.fadada.ContractSignUtil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassName 线上双签客商备案单同步按钮
 * @Description TODO
 * @Author WangShuGuang
 * @Date 2023/11/14
 * @Version 1.0
 */
public class SynchronizationFormPlugin extends AbstractBillPlugIn {


    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();
        if (key.equals("tpv_synchronization")) {
            //判断是否为同步按钮
            acquireMessage();
        }
    }

    private void acquireMessage() {
        OperateOption option = YEM.getOption();
        ContractSignUtil contractSignUtil = new ContractSignUtil();
        String token;
        //获取单据主实体
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        this.getModel().deleteEntryData("tpv_iscb_docket_adm");
        //this.getModel().deleteEntryData("tpv_iscb_docket_os");
        //获取往来方信息
        DynamicObject tpvCorrespondent = dataEntity.getDynamicObject("tpv_correspondent");
        String tpvFddcompanyid = dataEntity.getString("tpv_fddcompanyid");//FDDcompanyId
        if (null != tpvCorrespondent || StringUtils.isNotEmpty(tpvFddcompanyid)) {
            String name = null;
            //获取名称
            if (null != tpvCorrespondent) {
                name = tpvCorrespondent.getString("name");
            }
            ApiHelper apiHelper = new ApiHelper("fadada");
            if (apiHelper.isExist()) {
                String url = apiHelper.getParam("url");
                Api getCompany = apiHelper.getApi("getCompany");
                ApiLog log = apiHelper.log(getCompany);
                Api getAccount = apiHelper.getApi("getAccount");
                ApiLog logCompany = apiHelper.log(getAccount);
                //拿到名称调用法大大接口查询企业接口
                String getCompanyUrl = url + getCompany.getUrl();
                //调用获取ToKen方法
                token = ContractSignUtil.getToken();
                JSONObject body = JSON.parseObject(token);
                if (null != body) {
                    int code = body.getInteger("code");
                    String bearer = "bearer ";
                    String authoriztion;
                    Map<String, String> abbrData = new HashMap<>();
                    if (body != null && code == 0) {
                        Object object = body.get("data");
                        Map<String, String> dataToKen = (Map<String, String>) object;
                        authoriztion = bearer + dataToKen.get("accessToken");
                        Map<String, String> header = getHeaderForSeal(authoriztion);
                        String response = null;
                        List<String> clientName = new ArrayList<>();
                        List<String> clientId = new ArrayList<>();
                        Map<String, String> verifyStatusId = new HashMap<>();
                        List<String> fddCompanyId = new ArrayList<>();
                        List<String> isCerditList = new ArrayList<>();
                        try {
                            if (StringUtils.isNotEmpty(tpvFddcompanyid)) {
                                getCompanyUrl = getCompanyUrl + "?companyId=" + tpvFddcompanyid;
                            } else {
                                getCompanyUrl = getCompanyUrl + "?companyName=" + name;
                            }
                            response = HttpHelper.httpGet(getCompanyUrl, header);
                            JSONObject jsonObject = JSONObject.parseObject(response);
                            Integer code1 = jsonObject.getInteger("code");
                            String message = jsonObject.getString("message");
                            JSONArray dataArray = jsonObject.getJSONArray("data");
                            if (code1 == 0) {
                                log.setSuccess(true);
                            } else {
                                log.setSuccess(false);
                                log.setErrorMsg(message);
                            }
                            log.setRequestData(getCompanyUrl);
                            log.setResponseData(response);
                            if (dataArray.size() > 0) {
                                for (int i = 0; i < dataArray.size(); i++) {
                                    JSONObject dataObject = dataArray.getJSONObject(i);
                                    JSONArray adminInfoArray = dataObject.getJSONArray("adminInfo");
                                    for (int i1 = 0; i1 < adminInfoArray.size(); i1++) {
                                        JSONObject adminInfo = adminInfoArray.getJSONObject(i1);
                                        //管理员姓名
                                        String userName = adminInfo.getString("userName");
                                        //管理员id
                                        String accountId = adminInfo.getString("accountId");
                                        //实名认证标识
                                        String verifyStatus = adminInfo.getString("verifyStatus");
                                        String companyId = dataObject.getString("companyId");//企业在当前系统的唯一标识
                                        String isCerdit = dataObject.getString("isCerdit");//认证状态
                                        isCerditList.add(isCerdit);
                                        fddCompanyId.add(companyId);
                                        verifyStatusId.put(userName, verifyStatus);
                                        clientName.add(userName);
                                        clientId.add(accountId);
                                        abbrData.put(userName, accountId);
                                    }
                                }
                            } else {
                                this.getView().showErrorNotification("未查询到该企业信息");
                            }
                        } catch (Exception e) {
                            e.printStackTrace();
                            log.setSuccess(false);
                            log.setErrorMsg(YEM.exceptionToStr(e));
                        }
                        log.write();
                        if (!clientName.isEmpty()) {
                            for (String stringId : fddCompanyId) {
                                this.getModel().setValue("tpv_fddcompanyid", stringId);
                            }
                            for (String isCerdito : isCerditList) {
                                this.getModel().setValue("tpv_enterprise", isCerdito);
                            }
                            if (clientName.size() == 1) {
                                //说明管理员信息只有一个
                                DynamicObjectCollection entryentityxs = dataEntity.getDynamicObjectCollection("tpv_iscb_docket_adm");
                                // 新增行数据，赋值
                                DynamicObject entityxs = entryentityxs.addNew();
                                for (String nameFor : clientName) {
                                    for (Map.Entry<String, String> entry : abbrData.entrySet()) {
                                        if (entry.getKey().equals(nameFor)) {
                                            entityxs.set("tpv_managerid", entry.getValue());
                                        }
                                    }
                                    for (Map.Entry<String, String> entry : verifyStatusId.entrySet()) {
                                        if (entry.getKey().equals(nameFor)) {
                                            entityxs.set("tpv_authentidentifier", entry.getValue());
                                        }
                                    }
                                    entityxs.set("tpv_adminname", nameFor);
                                    SaveServiceHelper.update(entityxs);//写入数据库
                                    this.getView().showSuccessNotification("同步成功");
                                    this.getView().updateView("tpv_iscb_docket_adm");
                                }
                            } else {
                                //说明管理员信息有多个
                                for (int i = 0; i < clientName.size(); i++) {
                                    DynamicObjectCollection entryentityxs = dataEntity.getDynamicObjectCollection("tpv_iscb_docket_adm");
                                    // 新增行数据，赋值
                                    DynamicObject entityxs = entryentityxs.addNew();
                                    for (Map.Entry<String, String> entry : abbrData.entrySet()) {
                                        if (entry.getKey().equals(clientName.get(i))) {
                                            entityxs.set("tpv_managerid", entry.getValue());
                                        }
                                    }
                                    for (Map.Entry<String, String> entry : verifyStatusId.entrySet()) {
                                        if (entry.getKey().equals(clientName.get(i))) {
                                            entityxs.set("tpv_authentidentifier", entry.getValue());
                                        }
                                    }
                                    entityxs.set("tpv_adminname", clientName.get(i));
                                    SaveServiceHelper.update(entityxs);//写入数据库
                                    if (i + 1 == clientName.size()) {
                                        this.getView().showSuccessNotification("管理员同步成功");
                                    }
                                    this.getView().updateView("tpv_iscb_docket_adm");
                                }
                            }
                            for (int i = 0; i < clientId.size(); i++) {
                                String id = clientId.get(i);
                                //获取Token
                                //String accountToken = ContractSignUtil.getToken();
                                JSONObject accountBody = JSON.parseObject(token);
                                int accountCode = accountBody.getInteger("code");
                                if (accountBody != null && accountCode == 0) {
                                    String accountBearer = "bearer ";
                                    Object accountObject = accountBody.get("data");
                                    Map<String, String> accountDataToKen = (Map<String, String>) accountObject;
                                    String accountAuthoriztion = accountBearer + accountDataToKen.get("accessToken");
                                    Map<String, String> accountHeader = getHeaderForSeal(accountAuthoriztion);
                                    //调用查询用户详情接口
                                    String getAccountUrl = url + getAccount.getUrl();
                                    getAccountUrl = getAccountUrl + "?accountId=" + id;
                                    try {
                                        String accountResponse = HttpHelper.httpGet(getAccountUrl, accountHeader);
                                        JSONObject accountJsonObject = JSONObject.parseObject(accountResponse);
                                        Integer code1 = accountJsonObject.getInteger("code");
                                        String message = accountJsonObject.getString("message");
                                        JSONArray accountDataArray = accountJsonObject.getJSONArray("data");
                                        if (!accountDataArray.isEmpty()) {
                                            JSONObject dataObj = accountDataArray.getJSONObject(0);
                                            String userName = dataObj.getString("userName");
                                            String mobile = dataObj.getString("mobile");
                                            DynamicObjectCollection admEntryentityxs = dataEntity.getDynamicObjectCollection("tpv_iscb_docket_adm");
                                            if (!admEntryentityxs.isEmpty()) {
                                                for (DynamicObject admEntryentityx : admEntryentityxs) {
                                                    if (admEntryentityx.getString("tpv_adminname").equals(userName)) {
                                                        admEntryentityx.set("tpv_admphone", mobile);
                                                        SaveServiceHelper.update(admEntryentityx);// 写入数据库
                                                        this.getView().updateView("tpv_iscb_docket_adm");
                                                    }
                                                }
                                            }
                                        }
                                        if (code1 == 0) {
                                            logCompany.setSuccess(true);
                                        } else {
                                            logCompany.setSuccess(false);
                                            logCompany.setErrorMsg(message);
                                        }
                                        logCompany.setRequestData(getAccountUrl);
                                        logCompany.setResponseData(accountResponse);
                                    } catch (Exception e) {
                                        e.printStackTrace();
                                        logCompany.setSuccess(false);
                                        logCompany.setErrorMsg(YEM.exceptionToStr(e));
                                    }
                                    logCompany.write();
                                } else {
                                    this.getView().showMessage("获取token失败!");
                                }
                            }
                            DynamicObjectCollection objectCollection1 = dataEntity.getDynamicObjectCollection("tpv_iscb_docket_os");//获取签署人分录
                            if (!objectCollection1.isEmpty()) {
                                for (int i = 0; i < objectCollection1.size(); i++) {
                                    List<String> companyIdList = new ArrayList<>();
                                    DynamicObject dynamicObject = objectCollection1.get(i);
                                    String getAccountUrl = url + getAccount.getUrl();
                                    String tpvSignatory = dynamicObject.getString("tpv_signatory");//签署人
                                    String tpvSignatorymailbox = dynamicObject.getString("tpv_signatorymailbox");//签署人电话
                                    if (StringUtils.isNotEmpty(tpvSignatory) && StringUtils.isNotEmpty(tpvSignatorymailbox)) {
                                        getAccountUrl = getAccountUrl + "?userName=" + tpvSignatory + "&mobile=" + tpvSignatorymailbox;
                                    } else if (StringUtils.isNotEmpty(tpvSignatory)) {
                                        getAccountUrl = getAccountUrl + "?userName=" + tpvSignatory;
                                    } else if (StringUtils.isNotEmpty(tpvSignatorymailbox)) {
                                        getAccountUrl = getAccountUrl + "?mobile=" + tpvSignatorymailbox;
                                    }
                                    //获取Token
                                    // String accountToken = ContractSignUtil.getToken();
                                    JSONObject accountBody = JSON.parseObject(token);
                                    int accountCode = accountBody.getInteger("code");
                                    if (accountBody != null && accountCode == 0) {
                                        String accountBearer = "bearer ";
                                        Object accountObject = accountBody.get("data");
                                        Map<String, String> accountDataToKen = (Map<String, String>) accountObject;
                                        String accountAuthoriztion = accountBearer + accountDataToKen.get("accessToken");
                                        Map<String, String> accountHeader = getHeaderForSeal(accountAuthoriztion);
                                        //调用查询用户详情接口
                                        try {
                                            String accountResponse = HttpHelper.httpGet(getAccountUrl, accountHeader);
                                            JSONObject accountJsonObject = JSONObject.parseObject(accountResponse);
                                            Integer code1 = accountJsonObject.getInteger("code");
                                            String message = accountJsonObject.getString("message");
                                            JSONArray accountDataArray = accountJsonObject.getJSONArray("data");
                                            if (!accountDataArray.isEmpty()) {
                                                JSONObject dataObj = accountDataArray.getJSONObject(0);
                                                JSONArray companyInfo = dataObj.getJSONArray("companyInfo");
                                                for (int i1 = 0; i1 < companyInfo.size(); i1++) {
                                                    JSONObject adminInfo = companyInfo.getJSONObject(i1);
                                                    companyIdList.add(adminInfo.getString("companyId"));//企业id放入List
                                                }
                                                if (!companyIdList.isEmpty() && !fddCompanyId.isEmpty()) {
                                                    for (String item : fddCompanyId) {
                                                        if (companyIdList.contains(item)) {
                                                            dynamicObject.set("tpv_ourcompany", true);
                                                        } else {
                                                            dynamicObject.set("tpv_ourcompany", false);
                                                        }
                                                    }
                                                }
                                                String userName = dataObj.getString("userName");
                                                String accountId = dataObj.getString("accountId");
                                                String verifyStatus = dataObj.getString("verifyStatus");
                                                boolean ban = clientName.stream().anyMatch(s -> s.contains(userName));
                                                if (ban) {
                                                    dynamicObject.set("tpv_administrator", true);
                                                }
                                                dynamicObject.set("tpv_signatoryid", accountId);
                                                dynamicObject.set("tpv_authentication", verifyStatus);
                                                if (i + 1 == objectCollection1.size()) {
                                                    this.getView().showSuccessNotification("签署人同步成功");
                                                }
                                                SaveServiceHelper.update(dynamicObject);// 写入数据库
                                                this.getView().updateView("tpv_iscb_docket_os");
                                            } else {
                                                this.getView().showMessage("未查询到该签署人信息!");
                                            }
                                            if (code1 == 0) {
                                                logCompany.setSuccess(true);
                                            } else {
                                                logCompany.setSuccess(false);
                                                logCompany.setErrorMsg(message);
                                            }
                                            logCompany.setRequestData(getAccountUrl);
                                            logCompany.setResponseData(accountResponse);
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                            logCompany.setSuccess(false);
                                            logCompany.setErrorMsg(YEM.exceptionToStr(e));
                                        }
                                        logCompany.write();
                                    } else {
                                        this.getView().showMessage("获取token失败!");
                                    }
                                }
                            }
                        }
                    } else {
                        this.getView().showMessage("获取token失败!");
                    }
                }
            }
        } else {
            this.getView().showMessage("请先填写往来方或者输入FDDcompanyId再点击同步按钮!");
        }
        OperationResult saveT = OperationServiceHelper.executeOperate("save", "tpv_iscb_docket",
                new DynamicObject[]{dataEntity}, option);
    }

    private static Map<String, String> getHeaderForSeal(String authoriztion) {
        Map<String, String> header = new HashMap<>();
        header.put("Authorization", authoriztion);
        return header;
    }
}
