package tpv.tpv_wm.tpv_iscb.java.report;

import com.itopview.wm.dt.report.DispatchRptQuery;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.FilterInfo;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * @ClassName 签署人数据
 * @Description TODO
 * @Author yhj
 * @Date 2023/11/6 17:37
 * @Version 1.0
 */
public class SignatoryRptQuery extends AbstractReportListDataPlugin {
    private static List<String> fieldKeys_ship = new ArrayList<>();// 管理员
    private static List<String> fieldKeys_transgo = new ArrayList<>();// 签署人

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        String whereFilter = createWhereStr(param);
        DataSet instockDataSet = query(whereFilter);
        return instockDataSet;
    }

    private String createWhereStr(ReportQueryParam param) {
        FilterInfo filterInfo = param.getFilter();
        String whereFilter = "1 = 1";
        return whereFilter;
    }

    private static DataSet mainDataSet(String whereFilter) {
        initAllField();
        DataSet tpv_dt_salesshipping = ORM.create().queryDataSet(SignatoryRptQuery.class.getName(), "tpv_iscb_docket",
                String.join(",", fieldKeys_ship), null);
        DataSet im_transoutbill = ORM.create().queryDataSet(SignatoryRptQuery.class.getName(), "tpv_iscb_docket",
                String.join(",", fieldKeys_transgo), null);
        DataSet result = tpv_dt_salesshipping.union(im_transoutbill).distinct();
        return result.where("tpv_authentication = '1'");
    }

    private static void initAllField() {
        fieldKeys_ship.clear();
        fieldKeys_transgo.clear();
        addFields("tpv_signatory", "tpv_iscb_docket_adm.tpv_adminname", "tpv_iscb_docket_os.tpv_signatory");// 签署人姓名
        addFields("tpv_signatorytel", "tpv_iscb_docket_adm.tpv_admphone", "tpv_iscb_docket_os.tpv_signatorymailbox");// 签署人电话
        addFields("tpv_signatorymailbox", "tpv_iscb_docket_adm.tpv_managerid", "tpv_iscb_docket_os.tpv_signatoryid");// 签署人Id
        addFields("tpv_authentication", "tpv_iscb_docket_adm.tpv_authentidentifier", "tpv_iscb_docket_os.tpv_authentication");// 实名认证标识
    }

    private static void addFields(String fieldKey, String a, String b) {
        fieldKeys_ship.add(a + " " + fieldKey);
        fieldKeys_transgo.add(b + " " + fieldKey);
    }

    public static DataSet query(String whereFilter) {
        DataSet mainDataSet = mainDataSet(whereFilter);
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(DispatchRptQuery.class.getName()).createDataSet(inputs);
        return createDataSet;
    }

}
