package tpv.tpv_wm.tpv_sc.java.api.entitys;

import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @Description: 资金占用实时查询表 返回对象参数
 * @Author LinRui
 * @Date 2024/2/22 16:27
 */
@ApiModel
public class FundsUsedTimeRptData implements Serializable {

    @ApiParam(value = "公司名称", example = "'中航国际矿产资源有限公司'")
    private String orgname;
    @ApiParam(value = "部门名称", example = "'管理班子'")
    private String deptname;
    @ApiParam(value = "公司ID", example = "''")
    private String orgid;
    @ApiParam(value = "部门ID", example = "''")
    private String deptid;
    @ApiParam(value = "期初占用(现款)", example = "0.00")
    private BigDecimal cashinitoccup;
    @ApiParam(value = "收现款(现款)", example = "0.00")
    private BigDecimal putcash;
    @ApiParam(value = "付现款(现款)", example = "0.00")
    private BigDecimal paycash;
    @ApiParam(value = "占用余额(现款)", example = "0.00")
    private BigDecimal cashbalanceoccup;
    @ApiParam(value = "期初占用(银承)", example = "0.00")
    private BigDecimal bankinitoccup;
    @ApiParam(value = "应收票据(银承)", example = "0.00")
    private BigDecimal notereceivable;
    @ApiParam(value = "应付票据(银承)", example = "0.00")
    private BigDecimal notepayable;
    @ApiParam(value = "占用余额(银承)", example = "0.00")
    private BigDecimal bankbalanceoccup;
    @ApiParam(value = "期初占用(供应链产品)", example = "0.00")
    private BigDecimal scmproinitoccup;
    @ApiParam(value = "增加(供应链产品)", example = "0.00")
    private BigDecimal scmprorec;
    @ApiParam(value = "减少(供应链产品)", example = "0.00")
    private BigDecimal scmpropay;
    @ApiParam(value = "占用余额(供应链产品)", example = "0.00")
    private BigDecimal scmprobalanceoccup;
    @ApiParam(value = "期初占用(供应链金融)", example = "0.00")
    private BigDecimal scmfininitoccup;
    @ApiParam(value = "增加(供应链金融)", example = "0.00")
    private BigDecimal scmfinadd;
    @ApiParam(value = "减少(供应链金融)", example = "0.00")
    private BigDecimal scmfinless;
    @ApiParam(value = "占用余额(供应链金融)", example = "0.00")
    private BigDecimal scmfinbalanceoccup;
    @ApiParam(value = "国内证余额", example = "0.00")
    private BigDecimal chinaamt;
    @ApiParam(value = "国际证余额", example = "0.00")
    private BigDecimal interamt;
    @ApiParam(value = "押汇余额", example = "0.00")
    private BigDecimal trloanamt;
    @ApiParam(value = "期初占用(商业承兑汇票（应收）)", example = "0.00")
    private BigDecimal bareceiveinitoccup;
    @ApiParam(value = "增加(商业承兑汇票（应收）)", example = "0.00")
    private BigDecimal bareceiveadd;
    @ApiParam(value = "减少(商业承兑汇票（应收）)", example = "0.00")
    private BigDecimal bareceiveless;
    @ApiParam(value = "占用余额(商业承兑汇票（应收）)", example = "0.00")
    private BigDecimal bareceiveoccup;
    @ApiParam(value = "期初占用(商业承兑汇票（应付）)", example = "0.00")
    private BigDecimal bapayinitoccup;
    @ApiParam(value = "增加(商业承兑汇票（应付）)", example = "0.00")
    private BigDecimal bapayadd;
    @ApiParam(value = "减少(商业承兑汇票（应付）)", example = "0.00")
    private BigDecimal bapayless;
    @ApiParam(value = "占用余额(商业承兑汇票（应付）)", example = "0.00")
    private BigDecimal bapayoccup;
    @ApiParam(value = "预占用(银承)", example = "0.00")
    private BigDecimal bankadvance;
    @ApiParam(value = "预占用(国内证)", example = "0.00")
    private BigDecimal chinaamtadvance;
    @ApiParam(value = "预占用(国际证)", example = "0.00")
    private BigDecimal interamtadvance;
    @ApiParam(value = "预占用(押汇)", example = "0.00")
    private BigDecimal trloanadvance;
    @ApiParam(value = "占用合计1", example = "0.00")
    private BigDecimal onesumamt;
    @ApiParam(value = "占用合计2", example = "0.00")
    private BigDecimal twosumamt;
    @ApiParam(value = "占用合计3", example = "0.00")
    private BigDecimal threesumamt;
    @ApiParam(value = "占用合计4", example = "0.00")
    private BigDecimal foursumamt;
    @ApiParam(value = "当前资金额度", example = "0.00")
    private BigDecimal nowfundsamt;
    @ApiParam(value = "剩余可用额度", example = "0.00")
    private BigDecimal leaveableamt;
    @ApiParam(value = "剩余可用额度（总共）", example = "0.00")
    private BigDecimal leaveablesum;

    public String getOrgname() {
        return orgname;
    }

    public void setOrgname(String orgname) {
        this.orgname = orgname;
    }

    public String getDeptname() {
        return deptname;
    }

    public void setDeptname(String deptname) {
        this.deptname = deptname;
    }

    public String getOrgid() {
        return orgid;
    }

    public void setOrgid(String orgid) {
        this.orgid = orgid;
    }

    public String getDeptid() {
        return deptid;
    }

    public void setDeptid(String deptid) {
        this.deptid = deptid;
    }

    public BigDecimal getCashinitoccup() {
        return cashinitoccup;
    }

    public void setCashinitoccup(BigDecimal cashinitoccup) {
        this.cashinitoccup = cashinitoccup;
    }

    public BigDecimal getPutcash() {
        return putcash;
    }

    public void setPutcash(BigDecimal putcash) {
        this.putcash = putcash;
    }

    public BigDecimal getPaycash() {
        return paycash;
    }

    public void setPaycash(BigDecimal paycash) {
        this.paycash = paycash;
    }

    public BigDecimal getCashbalanceoccup() {
        return cashbalanceoccup;
    }

    public void setCashbalanceoccup(BigDecimal cashbalanceoccup) {
        this.cashbalanceoccup = cashbalanceoccup;
    }

    public BigDecimal getBankinitoccup() {
        return bankinitoccup;
    }

    public void setBankinitoccup(BigDecimal bankinitoccup) {
        this.bankinitoccup = bankinitoccup;
    }

    public BigDecimal getNotereceivable() {
        return notereceivable;
    }

    public void setNotereceivable(BigDecimal notereceivable) {
        this.notereceivable = notereceivable;
    }

    public BigDecimal getNotepayable() {
        return notepayable;
    }

    public void setNotepayable(BigDecimal notepayable) {
        this.notepayable = notepayable;
    }

    public BigDecimal getBankbalanceoccup() {
        return bankbalanceoccup;
    }

    public void setBankbalanceoccup(BigDecimal bankbalanceoccup) {
        this.bankbalanceoccup = bankbalanceoccup;
    }

    public BigDecimal getScmproinitoccup() {
        return scmproinitoccup;
    }

    public void setScmproinitoccup(BigDecimal scmproinitoccup) {
        this.scmproinitoccup = scmproinitoccup;
    }

    public BigDecimal getScmprorec() {
        return scmprorec;
    }

    public void setScmprorec(BigDecimal scmprorec) {
        this.scmprorec = scmprorec;
    }

    public BigDecimal getScmpropay() {
        return scmpropay;
    }

    public void setScmpropay(BigDecimal scmpropay) {
        this.scmpropay = scmpropay;
    }

    public BigDecimal getScmprobalanceoccup() {
        return scmprobalanceoccup;
    }

    public void setScmprobalanceoccup(BigDecimal scmprobalanceoccup) {
        this.scmprobalanceoccup = scmprobalanceoccup;
    }

    public BigDecimal getScmfininitoccup() {
        return scmfininitoccup;
    }

    public void setScmfininitoccup(BigDecimal scmfininitoccup) {
        this.scmfininitoccup = scmfininitoccup;
    }

    public BigDecimal getScmfinadd() {
        return scmfinadd;
    }

    public void setScmfinadd(BigDecimal scmfinadd) {
        this.scmfinadd = scmfinadd;
    }

    public BigDecimal getScmfinless() {
        return scmfinless;
    }

    public void setScmfinless(BigDecimal scmfinless) {
        this.scmfinless = scmfinless;
    }

    public BigDecimal getScmfinbalanceoccup() {
        return scmfinbalanceoccup;
    }

    public void setScmfinbalanceoccup(BigDecimal scmfinbalanceoccup) {
        this.scmfinbalanceoccup = scmfinbalanceoccup;
    }

    public BigDecimal getChinaamt() {
        return chinaamt;
    }

    public void setChinaamt(BigDecimal chinaamt) {
        this.chinaamt = chinaamt;
    }

    public BigDecimal getInteramt() {
        return interamt;
    }

    public void setInteramt(BigDecimal interamt) {
        this.interamt = interamt;
    }

    public BigDecimal getTrloanamt() {
        return trloanamt;
    }

    public void setTrloanamt(BigDecimal trloanamt) {
        this.trloanamt = trloanamt;
    }

    public BigDecimal getBareceiveinitoccup() {
        return bareceiveinitoccup;
    }

    public void setBareceiveinitoccup(BigDecimal bareceiveinitoccup) {
        this.bareceiveinitoccup = bareceiveinitoccup;
    }

    public BigDecimal getBareceiveadd() {
        return bareceiveadd;
    }

    public void setBareceiveadd(BigDecimal bareceiveadd) {
        this.bareceiveadd = bareceiveadd;
    }

    public BigDecimal getBareceiveless() {
        return bareceiveless;
    }

    public void setBareceiveless(BigDecimal bareceiveless) {
        this.bareceiveless = bareceiveless;
    }

    public BigDecimal getBareceiveoccup() {
        return bareceiveoccup;
    }

    public void setBareceiveoccup(BigDecimal bareceiveoccup) {
        this.bareceiveoccup = bareceiveoccup;
    }

    public BigDecimal getBapayinitoccup() {
        return bapayinitoccup;
    }

    public void setBapayinitoccup(BigDecimal bapayinitoccup) {
        this.bapayinitoccup = bapayinitoccup;
    }

    public BigDecimal getBapayadd() {
        return bapayadd;
    }

    public void setBapayadd(BigDecimal bapayadd) {
        this.bapayadd = bapayadd;
    }

    public BigDecimal getBapayless() {
        return bapayless;
    }

    public void setBapayless(BigDecimal bapayless) {
        this.bapayless = bapayless;
    }

    public BigDecimal getBapayoccup() {
        return bapayoccup;
    }

    public void setBapayoccup(BigDecimal bapayoccup) {
        this.bapayoccup = bapayoccup;
    }

    public BigDecimal getBankadvance() {
        return bankadvance;
    }

    public void setBankadvance(BigDecimal bankadvance) {
        this.bankadvance = bankadvance;
    }

    public BigDecimal getChinaamtadvance() {
        return chinaamtadvance;
    }

    public void setChinaamtadvance(BigDecimal chinaamtadvance) {
        this.chinaamtadvance = chinaamtadvance;
    }

    public BigDecimal getInteramtadvance() {
        return interamtadvance;
    }

    public void setInteramtadvance(BigDecimal interamtadvance) {
        this.interamtadvance = interamtadvance;
    }

    public BigDecimal getTrloanadvance() {
        return trloanadvance;
    }

    public void setTrloanadvance(BigDecimal trloanadvance) {
        this.trloanadvance = trloanadvance;
    }

    public BigDecimal getOnesumamt() {
        return onesumamt;
    }

    public void setOnesumamt(BigDecimal onesumamt) {
        this.onesumamt = onesumamt;
    }

    public BigDecimal getTwosumamt() {
        return twosumamt;
    }

    public void setTwosumamt(BigDecimal twosumamt) {
        this.twosumamt = twosumamt;
    }

    public BigDecimal getThreesumamt() {
        return threesumamt;
    }

    public void setThreesumamt(BigDecimal threesumamt) {
        this.threesumamt = threesumamt;
    }

    public BigDecimal getFoursumamt() {
        return foursumamt;
    }

    public void setFoursumamt(BigDecimal foursumamt) {
        this.foursumamt = foursumamt;
    }

    public BigDecimal getNowfundsamt() {
        return nowfundsamt;
    }

    public void setNowfundsamt(BigDecimal nowfundsamt) {
        this.nowfundsamt = nowfundsamt;
    }

    public BigDecimal getLeaveableamt() {
        return leaveableamt;
    }

    public void setLeaveableamt(BigDecimal leaveableamt) {
        this.leaveableamt = leaveableamt;
    }

    public BigDecimal getLeaveablesum() {
        return leaveablesum;
    }

    public void setLeaveablesum(BigDecimal leaveablesum) {
        this.leaveablesum = leaveablesum;
    }
}
