package tpv.tpv_wm.tpv_sc.java.api.openapi;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.openapi.common.custom.annotation.*;
import kd.bos.openapi.common.result.CustomApiResult;
import tpv.tpv_wm.tpv_sc.java.api.entitys.FundsUsedTimeModel;
import tpv.tpv_wm.tpv_sc.java.api.entitys.FundsUsedTimeRptData;
import tpv.tpv_wm.tpv_sc.java.api.entitys.FundsUsedTimeRptResult;
import tpv.tpv_wm.tpv_sc.java.report.FundsUsedTimeQueryRpt;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.List;

/**
 * @Description: 开放查询接口，将参数传入资金占用实时查询表，返回ResultData
 * @Author LinRui
 * @Date 2023/10/21 20:55
 */
@ApiController(value = "FundsUsedTime", desc = "资金占用实时查询表")
@ApiMapping("FundsUsedTime")

@ApiErrorCodes({
        @ApiErrorCode(code = "404", desc = "路径访问错误")
})
public class FundsUsedTimeResultController implements Serializable {
    @ApiPostMapping(value = "queryFundsUsedTime", desc = "资金占用实时查询表")
    public CustomApiResult<FundsUsedTimeRptResult> queryFundsUsedTime(@NotNull @Valid @ApiRequestBody(value = "请输入参数") FundsUsedTimeModel fundsTimemodel) {
        JSONArray jsonArray = FundsUsedTimeQueryRpt.queryDatas(fundsTimemodel.getOrgname(), fundsTimemodel.getDeptname(), fundsTimemodel.getDateStr());
        List<FundsUsedTimeRptData> list = JSONObject.parseArray(jsonArray.toJSONString(),FundsUsedTimeRptData.class);
        FundsUsedTimeRptResult data = new FundsUsedTimeRptResult();
        data.setList(list);
        return CustomApiResult.success(data);
    }
}
