package tpv.tpv_wm.tpv_sc.java.formplugin.dynamic;

import java.math.BigDecimal;
import java.util.*;

import com.alibaba.nacos.shaded.org.checkerframework.checker.nullness.qual.NonNull;
import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.operate.Save;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import org.apache.commons.lang3.StringUtils;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.control.Control;

/**
 * @author LiuHB
 * @version 1.0
 * 返回数据给手续费结算单已经押汇融资结算单
 */
@NonNull
public class DynamicFormPlugin extends AbstractBillPlugIn {
    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        // 监听动态表单按钮
        this.addClickListeners("btnok", "btncancel");
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);

        // 获取被点击的控件对象
        Control source = (Control) evt.getSource();
        ArrayList<HashMap<String, Object>> list = new ArrayList<>();
        Long typelettercreditsId = null;
        Long currencyId = null;
        Long bankId = null;
        Long operatorId = null;
        Long beneficiaryaId = null;
        Long financvarId = null;
        String lettercrednoId = null;
        String beneficiaryaname = null;
        Long interexpiteId =null;
        String interexpitename =null;
        String contractnum = null;
        //是否结算
        String settlement = null;
        //获取内部费用项目
        DynamicObject interexpitem = (DynamicObject) this.getModel().getValue("tpv_interexpitem");
        //获取id
        if(interexpitem!=null) {
            interexpiteId = interexpitem.getLong("id");
            //获取编码
            interexpitename = interexpitem.getString("name");
        }
//        //获取内部费率
//        DynamicObject interiorfeesrate = BusinessDataServiceHelper.loadSingle(interexpiteId,"tpv_sc_infeesrate");
        // 如果被点击控件为确认，则获取页面相关控件值，组装数据传入returnData返回给父页面，最后关闭页面
        if (StringUtils.equals("btnok", source.getKey())) {
            if (interexpiteId != null) {
                if (interexpitename.equals("国内证开证")  || interexpitename.equals("国际信用证开证")) {

                    //String selectfields = DynamicObjectUtil.getSelectfields("lc_lettercredit", false);
                    //获取分录
                    String entrySelectfields = DynamicObjectUtil.getSelectfieldsFast("lc_lettercredit", "entrys", "feedetail");
//                    String entrySelectfields = DynamicObjectUtil.getEntrySelectfields(selectfields, "lc_lettercredit", "entrys",false);
//                    获取不到 DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(1587056690472210432L, "lc_lettercredit",entrySelectfields);//LCKZ-20230822-1002
                    DynamicObject[] load = BusinessDataServiceHelper.load("lc_lettercredit", entrySelectfields, null);//new QFilter[]{new QFilter("billno", QCP.equals, "LCKZ-20230912-1005")}
                    if (load != null) {
                        for (DynamicObject dynamicObject : load) {
                            HashMap<String, Object> hashMap = new HashMap<>();
                            DynamicObjectCollection entrys = dynamicObject.getDynamicObjectCollection("entrys");
                            DynamicObjectCollection feedetail = dynamicObject.getDynamicObjectCollection("feedetail");
                            for (DynamicObject object : feedetail) {
                                BigDecimal excrate = object.getBigDecimal("excrate");
                                hashMap.put("tpv_exchrate", excrate);
                            }
                            for (DynamicObject dd : entrys) {
                                //合同号
                                contractnum = dd.getString("contractnum");

                                hashMap.put("tpv_contractnum", contractnum);
                                break;
                            }
//                      1)开证手续费结算前提
//                      ①、每次点击按钮生成开证手续费，都按照公司+部门+信用证号+内部费用项目检查该“信用证状态”为‘已登记’的信用证，是否已经生成过“开证手续费”类型的开证手续费：
//                      ②、如果当前开出的信用证且已经生成过开证手续费，且手续费行数>=1，系统不再生成调整的手续费，即系统对一笔信用证开证，只做一次费用调整；
//                      ③、开证类型的手续费<1行，且溢短装金额>=原生成的开证手续费最大的溢短装金额时，重新扫描生成的“收费”金额大于历史生成的手续费汇总金额存在差额，则生成一行类型为“调整”的并且金额为差额的一行手续费。
//                        类型
//                        溢短装率
//                        是否代开
//                        费率:①、按照开证确认状态的开证公司+银行+信用证类型+是否代开+天数（有效期-开证日期），匹配以上<开证手续费费率定义>表中启用状态下，开证日期前，最新启用日期的费率；
//                            ②、天数：天数为空或小于等于30天，按照30天匹配，大于30天小于等于60，按照60天匹配，大于60天，按照90天匹配，详见资金各项费率定义。
//                        收费:溢短装金额*费率，四舍五入取两位小数位金额；
//                        汇率:取开证确认的“折人民币汇率”；
//                        费用(CNY):收费*汇率，四舍五入取两位小数位金额；
//                              ⑦、如果匹配的手续费定义设置了“最低收费金额USD”，计算得到的“收费”金额（且当前开证币种为USD时）与“最低收费金额USD”比较，取大值；
//                        快递费
//                        折人民币汇率

//                            是否结算
                            settlement = dynamicObject.getString("tpv_settlement");
//
                            //原单单据编号
                            String oribillno = dynamicObject.getString("billno");
                            //业务联系人
                            DynamicObject operator = dynamicObject.getDynamicObject("bizcontactor");
                            if(operator!=null) {
                                operatorId = operator.getLong("id");
                            }
                            //获取部门
                            List<Long> department = UserServiceHelper.getOrgsUserJoin(operatorId);
                            //开证行
                            DynamicObject bank = dynamicObject.getDynamicObject("bank");
                            if(bank!=null) {
                                bankId = bank.getLong("id");
                            }
                            //币别
                            DynamicObject currency = dynamicObject.getDynamicObject("currency");
                            if(currency!=null) {
                                currencyId = currency.getLong("id");
                            }
                            //金额
                            BigDecimal amt = dynamicObject.getBigDecimal("amount");
                            //溢短装率
//                          //溢装上限
//                            String upperstr = dynamicObject.getString("upperstr");
//                                BigDecimal decimal = new BigDecimal(upperstr);
//                                BigDecimal nums = new BigDecimal("1");
//                                BigDecimal sum = nums.add(decimal);
//                                //溢短装金额
//                                BigDecimal excshortamt = amount.multiply(sum);

                            //信用证号
                            String lettercredno = dynamicObject.getString("creditno");
                            //是否代开
//                            String Ifissued = interiorfeesrate.getString("tpv_ifissued");
                            //信用证类型
                            DynamicObject typelettercredits = dynamicObject.getDynamicObject("credittype");
                            if( typelettercredits!=null) {
                                typelettercreditsId = typelettercredits.getLong("id");
                            }
                            //远期天数
                            Integer longdays = dynamicObject.getInt("forwarddays");
                            //信用证状态
                            String creditstatus = dynamicObject.getString("creditstatus");
                            //费率
//                           //收费
//                           BigDecimal charge = excshortamt.multiply(费率);
//                           hashMap.put("tpv_charge",charge);
                            //汇率
//                           //费用(CNY)
//                           BigDecimal cost = 收费.multiply(汇率);
//                           hashMap.put("tpv_cost",cost);
                            //受益人
                            String beneficiary = dynamicObject.getString("benefiterother");
                            //快递费
                            //凭证号

                            if (creditstatus.equals("done_register") && settlement.equals("B")) {
                                //是否结算
                                dynamicObject.set("tpv_settlement","A");
                                SaveServiceHelper.save(load);
                                //原单单据
                                hashMap.put("tpv_oridocument", "lc_lettercredit");
                                //原单单据编号
                                hashMap.put("tpv_oribillno",oribillno);
                                //部门
                                hashMap.put("tpv_department",department);
                                //原单据业务员
                                hashMap.put("tpv_operator",operatorId);
                                //内部费用项目
                                hashMap.put("tpv_interexpitem",interexpiteId);
                                //银行
                                hashMap.put("tpv_bank",bankId);
                                //币种
                                hashMap.put("tpv_currency",currencyId);
                                //金额
                                hashMap.put("tpv_amt",amt);
                                //溢短装率
//                                hashMap.put("tpv_overshortrate",);
                                //溢短装金额
//                                hashMap.put("tpv_excshortamt",);
                                //信用证号
                                hashMap.put("tpv_lettercredno",lettercredno);
                                //是否代开
//                                hashMap.put("tpv_makeoutinvoices",);
                                //信用证类型
                                hashMap.put("tpv_typelettercredits",typelettercreditsId);
                                //远期天数
                                hashMap.put("tpv_longdays",longdays);
                                //合同号
//                                hashMap.put("tpv_contractnum",);
                                //费率
//                                hashMap.put("tpv_rate",);
                                //收费
//                                hashMap.put("tpv_charge",);
                                //汇率
//                                hashMap.put("tpv_exchrate",);
                                //费用（CNY）
//                                hashMap.put("tpv_cost",);
                                //受益人
                                hashMap.put("tpv_beneficiarya",beneficiary);
                                //快递费
                                hashMap.put("tpv_expressfee","20.0");
                                //凭证号
                                hashMap.put("tpv_voucherno","1231243");
                                list.add(hashMap);
                            }
                        }
                    } else {
                        this.getView().showMessage("开证处理数据为空");
                    }
                }
                if (interexpitename .equals("交单议付") ) {
                    String selectfields = DynamicObjectUtil.getSelectfields("lc_present", false);
                    String entrySelectfields = DynamicObjectUtil.getEntrySelectfields(selectfields, "lc_present", "entrys", false);
                    DynamicObject[] load = BusinessDataServiceHelper.load("lc_present", entrySelectfields, null);
                    if (load != null) {
                        for (DynamicObject dynamicObject : load) {
                            HashMap<String, Object> hashMap = new HashMap<>();
//                        类型
//                        溢短装率
//                        溢短装金额:金额*（1+溢装上限比例）；
//                        是否代开
//                        合同号
//                        费率:①　按照公司+结算方式+银行匹配最新的合计费率。
//                        收费:金额*费率，四舍五入取两位小数位金额；
//                        汇率:按照交单日对应月份最后一个工作日12点后出现的第一个现汇卖出价取数；
//                        费用(CNY):收费*汇率，四舍五入取两位小数位金额；
//                         ⑦、如果匹配的手续费定义设置了“最低收费金额USD”，计算得到的“收费”金额（且当前开证币种为USD时）与“最低收费金额USD”比较，取大值；
//                        快递费

                            //=============================================================================================================================
                            //是否结算
                            settlement = dynamicObject.getString("tpv_settlement");

                            //单据状态
                            String billstatus = dynamicObject.getString("billstatus");
                            //原单单据编号
                            String oribillno = dynamicObject.getString("billno");
                            //业务联系人
                            DynamicObject operator = dynamicObject.getDynamicObject("bizcontactor");
                            if(operator!=null) {
                                operatorId = operator.getLong("id");
                            }
                            //获取部门
                            List<Long> department = UserServiceHelper.getOrgsUserJoin(operatorId);
                            //开证行
                            DynamicObject bank = dynamicObject.getDynamicObject("presendbank");
                            if(bank!=null) {
                                bankId = bank.getLong("id");
                            }
                            //币别
                            DynamicObject currency = dynamicObject.getDynamicObject("currency");
                            if(currency!=null) {
                                currencyId = currency.getLong("id");
                            }
                            //金额
                            BigDecimal amt = dynamicObject.getBigDecimal("arrivalamount");
                            //溢短装率
//                          //溢装上限
//                            String upperstr = dynamicObject.getString("upperstr");
//                                BigDecimal decimal = new BigDecimal(upperstr);
//                                BigDecimal nums = new BigDecimal("1");
//                                BigDecimal sum = nums.add(decimal);
//                                //溢短装金额
//                                BigDecimal excshortamt = amount.multiply(sum);

                            //信用证号
                            DynamicObject lettercredno = dynamicObject.getDynamicObject("lettercredit");
                            if(lettercredno!=null){
                                lettercrednoId = lettercredno.getString("number");

                            }

                            //是否代开
//                            String Ifissued = interiorfeesrate.getString("tpv_ifissued");
                            //信用证类型
                            DynamicObject typelettercredits = dynamicObject.getDynamicObject("credittype");
                            if( typelettercredits!=null) {
                                typelettercreditsId = typelettercredits.getLong("id");
                            }
                            //远期天数
                            Integer longdays = dynamicObject.getInt("forwarddays");
                            //合同号
                            //信用证状态
//                            String creditstatus = dynamicObject.getString("creditstatus");

                            //费率
//                           //收费
//                           BigDecimal charge = excshortamt.multiply(费率);
//                           hashMap.put("tpv_charge",charge);
                            //汇率
//                           //费用(CNY)
//                           BigDecimal cost = 收费.multiply(汇率);
//                           hashMap.put("tpv_cost",cost);
                            //受益人
                            DynamicObject beneficiarya = dynamicObject.getDynamicObject("org");
                            if(beneficiarya!=null){
                                beneficiaryaId = beneficiarya.getLong("Id");
                                beneficiaryaname = beneficiarya.getString("name");
                            }
                            //快递费
                            //凭证号

//=============================================================================================================================
                            if (billstatus.equals("C") && settlement.equals("B")) {

                                dynamicObject.set("tpv_settlement","A");
                                SaveServiceHelper.save(load);
                                //原单单据
                                hashMap.put("tpv_oridocument", "lc_present");
                                //原单单据编号
                                hashMap.put("tpv_oribillno", oribillno);
                                //部门
//                                hashMap.put("tpv_department",department);
                                //原单据业务员
//                                hashMap.put("tpv_operator",);
                                //内部费用项目
                                hashMap.put("tpv_interexpitem", interexpiteId);
                                //银行
                                hashMap.put("tpv_bank", bankId);
                                //币种
//                                hashMap.put("tpv_currency",);
                                //金额
                                hashMap.put("tpv_amt", amt);
                                //溢短装率
//                                hashMap.put("tpv_overshortrate",);
                                //溢短装金额
//                                hashMap.put("tpv_excshortamt",);
                                //信用证号
                                hashMap.put("tpv_lettercredno",lettercrednoId);
                                //是否代开
//                                hashMap.put("tpv_makeoutinvoices",);
                                //信用证类型
                                hashMap.put("tpv_typelettercredits", typelettercreditsId);
                                //远期天数
                                hashMap.put("tpv_longdays", longdays);
                                //合同号
//                                hashMap.put("tpv_contractnum",);
                                //费率
//                                hashMap.put("tpv_rate",);
                                //收费
//                                hashMap.put("tpv_charge",);
                                //汇率
//                                hashMap.put("tpv_exchrate",);
                                //费用（CNY）
//                                hashMap.put("tpv_cost",);
                                //受益人
                                hashMap.put("tpv_beneficiarya", beneficiaryaname);
                                //快递费
//                                hashMap.put("tpv_expressfee",);
                                //凭证号
//                                hashMap.put("tpv_voucherno",);
                                list.add(hashMap);
                            }
                        }
                    } else {
                        this.getView().showMessage("交单处理数据为空");
                    }
                }
                if (interexpitename.equals("开证+后期融资")) {
                    String selectfields = DynamicObjectUtil.getSelectfields("cfm_loancontractbill", false);
                    String entrySelectfields = DynamicObjectUtil.getEntrySelectfields(selectfields, "cfm_loancontractbill", "tradefin_entry", false);
                    DynamicObject[] load = BusinessDataServiceHelper.load("cfm_loancontractbill", entrySelectfields, null);
                    if (load != null) {
                        for (DynamicObject dynamicObject : load) {
                            HashMap<String, Object> hashMap = new HashMap<>();
                            DynamicObjectCollection tradefinentry = dynamicObject.getDynamicObjectCollection("tradefin_entry");
                            for (DynamicObject dd : tradefinentry) {
                                //受益人
                                contractnum = dd.getString("e_tf_beneficiary");
                                //this.getView().showMessage(contractnum);
                                hashMap.put("tpv_contractnum", contractnum);
                                break;
                            }
//                        1)开证与后期融资费结算前提
//                          ①、开证状态为“已开证”；
//                          ②、开证申请“信用证类型”为‘即期信用证’；
//                          ③、开证“是否代开”为‘否’；
//                          ④、该信用证在融资申请中，且融资部门等于开证申请部门；
//                        银行
//                        启用
//                        启用日期:信用证开证日期前最新的启用日期的费率；
//                        信用证状态
//                        原单据业务员
//                        类型
//                        溢短装率
//                        溢短装金额
//                        信用证号
//                        是否代开
//                        信用证类型
//                        远期天数:合同状态为“已结清”的【银行借款合同-合同执行-还款信息】界面Σ（实际还款日-融资起始日）*还贷本金金额/融资总金额，四舍五入取整；
//                        费率:
//                          ①、按照公司+启用+启用日期+天数匹配；
//                          ②、启用日期：按照信用证开证日期前最新的启用日期的费率；
//                          ③、天数：天数大于60天，取61天的费率，小于等于60天，按照60天内的费率，
//                        收费：溢短装金额*费率，四舍五入两位小数金额；
//                        汇率：开证汇率按照开证日期取开证确认的折人民币汇率；
//                        费用(CNY)：收费*汇率，四舍五入两位小数金额
//                        快递费
//================================================================================================================================
                            //是否结算
                            settlement = dynamicObject.getString("tpv_settlement");
                            //单据编号
                            String billstatus = dynamicObject.getString("billstatus");
                            //原单单据编号
                            String oribillno = dynamicObject.getString("billno");
                            //业务联系人
//                            DynamicObject operator = dynamicObject.getDynamicObject("bizcontactor");
//                            if(operator!=null) {
//                                operatorId = operator.getLong("id");
//                            }
                            //获取部门
                            // List<Long> department = UserServiceHelper.getOrgsUserJoin(operatorId);
                            //开证行
//                            DynamicObject bank = dynamicObject.getDynamicObject("presendbank");
//                            if(bank!=null) {
//                                bankId = bank.getLong("id");
//                            }
                            //币别
                            DynamicObject currency = dynamicObject.getDynamicObject("currency");
                            if(currency!=null) {
                                currencyId = currency.getLong("id");
                            }
                            //金额
                            BigDecimal amt = dynamicObject.getBigDecimal("amount");
                            //溢短装率
//                          //溢装上限
//                            String upperstr = dynamicObject.getString("upperstr");
//                                BigDecimal decimal = new BigDecimal(upperstr);
//                                BigDecimal nums = new BigDecimal("1");
//                                BigDecimal sum = nums.add(decimal);
//                                //溢短装金额
//                                BigDecimal excshortamt = amount.multiply(sum);

                            //信用证号
//                            String lettercredno = dynamicObject.getString("lettercredit");
                            //是否代开
//                            String Ifissued = interiorfeesrate.getString("tpv_ifissued");
                            //信用证类型
//                            DynamicObject typelettercredits = dynamicObject.getDynamicObject("credittype");
//                            if( typelettercredits!=null) {
//                                typelettercreditsId = typelettercredits.getLong("id");
//                            }
                            //远期天数
                            //Integer longdays = dynamicObject.getInt("forwarddays");
                            //合同号
                            contractnum = dynamicObject.getString("contractno");
                            //合同状态
                            String contractstatus = dynamicObject.getString("contractstatus");
                            //信用证状态
//                            String creditstatus = dynamicObject.getString("creditstatus");
                            //费率
//                          //收费
//                           BigDecimal charge = excshortamt.multiply(费率);
//                           hashMap.put("tpv_charge",charge);
                            //汇率
//                          //费用(CNY)
//                           BigDecimal cost = 收费.multiply(汇率);
//                           hashMap.put("tpv_cost",cost);
                            //受益人
                            DynamicObject beneficiarya = dynamicObject.getDynamicObject("org");
                            if(beneficiarya!=null){
                                beneficiaryaId = beneficiarya.getLong("Id");
                            }
                            //快递费
                            //凭证号
//==================================================================================================================================

                            if (contractstatus.equals("D") && settlement.equals("B")) {
                                //结算
                                dynamicObject.set("tpv_settlement","A");
                                SaveServiceHelper.save(load);
                                //原单单据
                                hashMap.put("tpv_oridocument","cfm_loancontractbill");
                                //原单单据编号
                                hashMap.put("tpv_oribillno",oribillno);
                                //部门
//                                hashMap.put("tpv_department",department);
                                //原单据业务员
//                                hashMap.put("tpv_operator",);
                                //内部费用项目
                                hashMap.put("tpv_interexpitem",interexpiteId);
                                //银行
//                                hashMap.put("tpv_bank",bank);
                                //币种
                                hashMap.put("tpv_currency",currencyId);
                                //金额
                                hashMap.put("tpv_amt",amt);
                                //溢短装率
//                                hashMap.put("tpv_overshortrate",overshortrate);
                                //溢短装金额
//                                hashMap.put("tpv_excshortamt",excshortamt);
                                //信用证号
//                                hashMap.put("tpv_lettercredno",lettercredno);
                                //是否代开
//                                hashMap.put("tpv_makeoutinvoices",makeoutinvoices);
                                //信用证类型
                                hashMap.put("tpv_typelettercredits",typelettercreditsId);
                                //远期天数
//                                hashMap.put("tpv_longdays",longdays);
                                //合同号
                                hashMap.put("tpv_contractnum",contractnum);
                                //费率
//                                hashMap.put("tpv_rate",rate);
                                //收费
//                                hashMap.put("tpv_charge",charge);
                                //汇率
//                                hashMap.put("tpv_exchrate",exchrate);
                                //费用（CNY）
//                                hashMap.put("tpv_cost",cost);
                                //受益人
//                                hashMap.put("tpv_beneficiarya",beneficiarya);
                                //快递费
//                                hashMap.put("tpv_expressfee",expressfe);
                                //凭证号
//                                hashMap.put("tpv_voucherno",voucherno);
                                list.add(hashMap);
                            }
                        }
                    } else {
                        this.getView().showMessage("借款合同数据为空");
                    }
                }
                if (interexpitename.equals("进口托收") ) {
                    String selectfields = DynamicObjectUtil.getSelectfields("cas_paybill", false);
                    String entrySelectfields = DynamicObjectUtil.getEntrySelectfields(selectfields, "cas_paybill", "entry", false);
                    DynamicObject[] load = BusinessDataServiceHelper.load("cas_paybill", entrySelectfields, null);//new QFilter[]{new QFilter("billno", QCP.equals, "PV-202308-030003")}
                    if (load != null) {
                        for (DynamicObject dynamicObject : load) {
                            HashMap<String, Object> hashMap = new HashMap<>();
                            DynamicObjectCollection entry = dynamicObject.getDynamicObjectCollection("entry");
                            for (DynamicObject dd : entry) {
//                            //合同号
//                            String contractnum = dd.getString("contractnumber");
//                            hashMap.put("tpv_contractnum",contractnum);
//                            break;
                            }
                            //                        原单据业务员
                            //                        类型
                            //                        银行
                            //                        溢短装率
                            //                        溢短装金额
                            //                        信用证号
                            //                        是否代开
                            //                        信用证类型
                            //                        远期天数
                            //                        费率:　按照公司+结算方式+银行匹配最新的合计费率；
                            //                        收费:原币金额*费率；
                            //                        汇率:实付日期当天12点后的第一个牌价的现汇卖出价汇率；
                            //                        费用(CNY):收费*汇率， 四舍五入取两位金额，最低不能少于800，最高为单笔1500（按照以上费率定义处的最大值判断取值）。
                            //                        受益人
                            //                        快递费
//====================================================================================================================================
                            //是否结算
                            settlement = dynamicObject.getString("tpv_settlement");
                            //结算方式
                            DynamicObject settletype = dynamicObject.getDynamicObject("settletype");
                            String settletypename = settletype.getString("name");

                            String billstatus = dynamicObject.getString("billstatus");
                            //原单单据编号
                            String oribillno = dynamicObject.getString("billno");
                            //业务联系人
//                            DynamicObject operator = dynamicObject.getDynamicObject("bizcontactor");
//                            if(operator!=null) {
//                                operatorId = operator.getLong("id");
//                            }
                            //获取部门
                            // List<Long> department = UserServiceHelper.getOrgsUserJoin(operatorId);
                            //开证行
                            DynamicObject bank = dynamicObject.getDynamicObject("applyorg");
                            if(bank!=null) {
                                bankId = bank.getLong("id");
                            }
                            //币别
                            DynamicObject currency =  dynamicObject.getDynamicObject("currency");
                            if(currency!=null) {
                                currencyId = currency.getLong("id");
                            }
                            //金额
                            BigDecimal amt = dynamicObject.getBigDecimal("actpayamt");
                            //溢短装率
//                          //溢装上限
//                            String upperstr = dynamicObject.getString("upperstr");
//                                BigDecimal decimal = new BigDecimal(upperstr);
//                                BigDecimal nums = new BigDecimal("1");
//                                BigDecimal sum = nums.add(decimal);
//                                //溢短装金额
//                                BigDecimal excshortamt = amount.multiply(sum);

                            //信用证号
//                            String lettercredno = dynamicObject.getString("lettercredit");
                            //是否代开
//                            String Ifissued = interiorfeesrate.getString("tpv_ifissued");
                            //信用证类型
//                            DynamicObject typelettercredits = dynamicObject.getDynamicObject("credittype");
//                            if( typelettercredits!=null) {
//                                typelettercreditsId = typelettercredits.getLong("id");
//                            }
                            //远期天数
//                            Integer longdays = dynamicObject.getInt("forwarddays");
                            //合同号
                            contractnum = dynamicObject.getString("contractno");
                            //信用证状态
//                            String creditstatus = dynamicObject.getString("creditstatus");
                            //费率
//                           //收费
                            //汇率
//                           //费用(CNY)
                            //受益人
                            DynamicObject beneficiarya = dynamicObject.getDynamicObject("org");
                            if(beneficiarya!=null){
                                beneficiaryaId = beneficiarya.getLong("Id");
                            }
                            //快递费
                            //凭证号
                            String vouchernum = dynamicObject.getString("vouchernum");

//=======================================================================================================================================
                            if (billstatus.equals("D") && settletypename.equals("DA") || settletypename.equals("DP") && settlement.equals("B")) {
//                              hashMap.put("org", applyorgId);
                                //结算
                                dynamicObject.set("tpv_settlement","A");
                                SaveServiceHelper.save(load);
                                //原单单据
                                hashMap.put("tpv_oridocument", "cas_paybill");
                                //原单单据编号
                                hashMap.put("tpv_oribillno",oribillno);
                                //部门
//                                hashMap.put("tpv_department",department);
                                //原单据业务员
//                                hashMap.put("tpv_operator",operator);
                                //内部费用项目
                                hashMap.put("tpv_interexpitem",interexpiteId);
                                //银行
//                                hashMap.put("tpv_bank",bank);
                                //币种
                                hashMap.put("tpv_currency",currencyId);
                                //金额
                                hashMap.put("tpv_amt",amt);
                                //溢短装率
//                                hashMap.put("tpv_overshortrate",overshortrate);
                                //溢短装金额
//                                hashMap.put("tpv_excshortamt",excshortamt);
                                //信用证号
//                                hashMap.put("tpv_lettercredno",lettercredno);
                                //是否代开
//                                hashMap.put("tpv_makeoutinvoices",makeoutinvoices);
                                //信用证类型
//                                hashMap.put("tpv_typelettercredits",typelettercredits);
                                //远期天数
                                hashMap.put("tpv_longdays","60");
                                //合同号
                                hashMap.put("tpv_contractnum","132134123123");
                                //费率
//                                hashMap.put("tpv_rate",rate);
                                //收费
//                                hashMap.put("tpv_charge",charge);
                                //汇率
//                                hashMap.put("tpv_exchrate",exchrate);
                                //费用（CNY）
//                                hashMap.put("tpv_cost",cost);
                                //受益人
//                                hashMap.put("tpv_beneficiarya",beneficiarya);
                                //快递费
//                                hashMap.put("tpv_expressfee",expressfee);
                                //凭证号
                                hashMap.put("tpv_voucherno","123124324");
                                list.add(hashMap);
                            }
                        }
                    } else {
                        this.getView().showMessage("付款处理数据为空");
                    }
                }
                if (interexpitename .equals("融资")) {
                    String selectfields = DynamicObjectUtil.getSelectfields("cfm_loancontractbill", false);
                    String entrySelectfields = DynamicObjectUtil.getEntrySelectfields(selectfields, "cfm_loancontractbill", "tradefin_entry", false);
                    DynamicObject[] load = BusinessDataServiceHelper.load("cfm_loancontractbill", entrySelectfields, null);
                    if (load != null) {
                        for (DynamicObject dynamicObject : load) {
                            HashMap<String, Object> hashMap = new HashMap<>();
                            DynamicObjectCollection entrys = dynamicObject.getDynamicObjectCollection("tradefin_entry");
                            for (DynamicObject dd : entrys) {
                                //合同号
                                contractnum = dd.getString("contractnum");
                                //this.getView().showMessage(contractnum);
                                hashMap.put("tpv_contractnum", contractnum);
                                break;
                            }
//                        (1)押汇融资结算前提
//                        ①　银行借款合同中融资品种二级为“国外采购”和“国外销售”；
//                        ①　合同金额=银行借款金额；、‘
//                        信用证号
//                        金额(USD)
//                        实际还款日
//                        天数
//                        实际LIBOR
//                        系数:　按照公司+融资品种+开证国别最新的合计费率；
//                        应收利率
//                        应收利息(USD):合同金额*（LIBOR系数+系数）*（结清还款日-融资起始日）/360，四舍五入取两位小数位金额
//                        汇率：按照结清融资当日12点后出现的第一个现汇卖出价取数； --待确认
//                        应收利息(CNY):应收利息*汇率，四舍五入取两位小数位金额
//                        母证开证国
//                        银行借款金额
//                        融资银行
//==========================================================================================================================

                            //是否结算
                            settlement = dynamicObject.getString("tpv_settlement");
                            //合同状态
                            String contractstatus = dynamicObject.getString("contractstatus");
                            //部门
//                           List<Long> department = UserServiceHelper.getOrgsUserJoin(bizcontactorId);
                            //融资申请编号
                            String finapplinum = dynamicObject.getString("billno");
                            //融资银行
                            //合同号
                            contractnum = dynamicObject.getString("contractno");
                            //借款金额
                            BigDecimal amtusd = dynamicObject.getBigDecimal("amount");
                            //起息日
                            Date date = dynamicObject.getDate("startintdate");
                            //融资品种
                            DynamicObject financvar = dynamicObject.getDynamicObject("finproduct");
                            if(financvar!=null) {
                                financvarId = financvar.getLong("Id");
                            }
                            //实际还款日
                            //天数
                            //实际LIBOR
                            //系数
                            //应收利率
                            //应收利息（USD）
                            //汇率
                            //应收利息（CNY）
                            //母证开证国
                            //凭证号
//======================================================================================================================================

                            //合同状态为已结清
                            if (contractstatus.equals("D") && settlement.equals("B")) {
                                dynamicObject.set("tpv_settlement","A");
                                SaveServiceHelper.save(load);
                                //部门
//                                hashMap.put("tpv_department",department);
                                //融资申请单号
                                hashMap.put("tpv_finapplinum",finapplinum);
                                //融资银行
//                                hashMap.put("tpv_bank",bank);
                                //信用证号
                                hashMap.put("tpv_lettercredno","123123");
                                //合同号
                                hashMap.put("tpv_contractnum",contractnum);
                                //金额（USD）
                                hashMap.put("tpv_amtusd",amtusd);
                                //起息日/付汇日
                                hashMap.put("tpv_date",date);
                                //融资品种
                                hashMap.put("tpv_financvar",financvarId);
                                //实际还款日
//                                hashMap.put("tpv_repaymentdate",repaymentdate);
                                //天数
                                hashMap.put("tpv_days","60");
                                //实际LIBOR
//                                hashMap.put("tpv_realibor",realibor);
                                //系数
//                                hashMap.put("tpv_coefficient",coefficient);
                                //应收利率
//                                hashMap.put("tpv_recelibor",recelibor);
                                //应收利息（USD）
//                                hashMap.put("tpv_reinterestusd",reinterestusd);
                                //汇率
//                                hashMap.put("tpv_exchrate",exchrate);
                                //应收利息（CNY）
//                                hashMap.put("tpv_reinterestcny",reinterestcny);
                                //母证开证国
//                                hashMap.put("tpv_country",country);
                                //凭证号
                                hashMap.put("tpv_voucherno","123456");
                                list.add(hashMap);
                            }
                        }
                    } else {
                        this.getView().showMessage("借款合同数据为空");
                    }
                }

                this.getView().returnDataToParent(list);
                this.getView().close();

            } else if (StringUtils.equals("btncancel", source.getKey())) {
                // 被点击控件为取消则设置返回值为空并关闭页面（在页面关闭回调方法中必须验证返回值不为空，否则会报空指针）
                this.getView().returnDataToParent(null);
                this.getView().close();
            }
        }
    }
}






