package tpv.tpv_wm.tpv_sc.java.formplugin.dynamic;

import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.property.ComboProp;
import kd.bos.form.IFormView;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.scm.common.util.DynamicObjectUtil;
import org.json.JSONObject;

import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @ClassName FundsusedEdit
 * @Description 资金占用
 * @Author yhj
 * @Date 2023/9/20 17:14
 * @Version 1.0
 */
public class FundsusedEdit extends AbstractBillPlugIn {
    private static DateFormat format = new SimpleDateFormat("yyyy");
    private static DateFormat formats = new SimpleDateFormat("yyyy-MM-dd");

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_advcontoolbarap");
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        super.itemClick(evt);
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        String key = evt.getItemKey();
        if (StringUtils.equals("tpv_advconbaritemap", key)) {//生成部门资金占用明细
            DynamicObjectCollection tpvScFundsusedAa = this.getModel().getEntryEntity("tpv_sc_fundsused_aa");
            if (tpvScFundsusedAa.size() > 0) {
                this.getModel().deleteEntryData("tpv_sc_fundsused_aa");
            }
            utilize();
            this.getView().updateView("tpv_sc_fundsused_aa");
            DynamicObjectCollection scFundsusedAa = dataEntity.getDynamicObjectCollection("tpv_sc_fundsused_aa");
            LinkedHashMap<String, List<Integer>> map = new LinkedHashMap();
            List<DynamicObject> dynamicObjectList = new ArrayList<>();
            for (int i = 0; i < scFundsusedAa.size(); i++) {
                dynamicObjectList.add(scFundsusedAa.get(i));
            }
            scFundsusedAa.clear();
            for (DynamicObject sc : dynamicObjectList) {
                int i = dynamicObjectList.indexOf(sc);
                Date date = sc.getDate("tpv_businessdate");
                long companys = sc.getDynamicObject("tpv_companys").getLong("id");
                long depertment = sc.getDynamicObject("tpv_depertment").getLong("id");
                String keys = date + "_" + companys + "_" + depertment;
                List<Integer> list;
                if (map.containsKey(keys)) {
                    list = map.get(keys);
                } else {
                    list = new ArrayList<>();
                }
                list.add(i);
                map.put(keys, list);

            }
            Set<Map.Entry<String, List<Integer>>> entrySet = map.entrySet();

            SaveServiceHelper.update(dataEntity);//写入数据库
            for (Map.Entry<String, List<Integer>> stringListEntry : entrySet) {
                DynamicObject addNew = scFundsusedAa.addNew();
                List<Integer> value = stringListEntry.getValue();
                Map<String, BigDecimal> maps = new HashMap<>();

                for (int i = 0; i <= 28; i++) {
                    maps.put("val" + i, BigDecimal.ZERO);
                }
                String listEntryKey = stringListEntry.getKey();
                String[] split = listEntryKey.split("_");
                String time = split[0];
                String company = split[1];
                String depertments = split[2];
                SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
                Date date=null;
                try {
                     date = dateFormat.parse(time);
                } catch (ParseException e) {
                    System.err.println("日期解析失败：" + e.getMessage());
                }
                Long com= Long.valueOf(company);
                Long demt=Long.valueOf(depertments);
                QFilter FilterOne = new QFilter("id", QCP.equals, com);
                String Fieid = DynamicObjectUtil.getSelectfields("bos_org", false);
                DynamicObject coms = BusinessDataServiceHelper.loadSingle("bos_org", Fieid, FilterOne.toArray());//公司
                QFilter FilterTwo = new QFilter("id", QCP.equals, demt);
                String Fieids = DynamicObjectUtil.getSelectfields("bos_adminorg", false);
                DynamicObject demts = BusinessDataServiceHelper.loadSingle("bos_adminorg", Fieids, FilterTwo.toArray());//公司
                addNew.set("tpv_businessdate",date);
                addNew.set("tpv_companys",coms);
                addNew.set("tpv_depertment",demts);
                for (Integer integer : value) {
                    DynamicObject object = dynamicObjectList.get(integer);
                    maps.put("val1", maps.get("val1").add(object.getBigDecimal("tpv_add")));//1
                    maps.put("val2", maps.get("val2").add(object.getBigDecimal("tpv_reduce")));//2
                    maps.put("val3", maps.get("val3").add(object.getBigDecimal("tpv_occupied")));//3
                    maps.put("val4", maps.get("val4").add(object.getBigDecimal("tpv_interest")));//4
                    maps.put("val5", maps.get("val5").add(object.getBigDecimal("tpv_increase")));//5
                    maps.put("val6", maps.get("val6").add(object.getBigDecimal("tpv_decrease")));//6
                    maps.put("val7", maps.get("val7").add(object.getBigDecimal("tpv_occupyamt")));//7
                    maps.put("val8", maps.get("val8").add(object.getBigDecimal("tpv_interests")));//28
                    maps.put("val9", maps.get("val9").add(object.getBigDecimal("tpv_augment")));//28
                    maps.put("val10", maps.get("val10").add(object.getBigDecimal("tpv_lessen")));//28
                    maps.put("val11", maps.get("val11").add(object.getBigDecimal("tpv_holdamt")));//28
                    maps.put("val12", maps.get("val12").add(object.getBigDecimal("tpv_accrual")));//28
                    maps.put("val13", maps.get("val13").add(object.getBigDecimal("tpv_applyamt")));//28
                    maps.put("val14", maps.get("val14").add(object.getBigDecimal("tpv_profit")));//28
                    maps.put("val15", maps.get("val15").add(object.getBigDecimal("tpv_enhance")));//28
                    maps.put("val16", maps.get("val16").add(object.getBigDecimal("tpv_little")));//28
                    maps.put("val17", maps.get("val17").add(object.getBigDecimal("tpv_useamt")));//28
                    maps.put("val18", maps.get("val18").add(object.getBigDecimal("tpv_return")));//28
                    maps.put("val19", maps.get("val19").add(object.getBigDecimal("tpv_plus")));//28
                    maps.put("val20", maps.get("val20").add(object.getBigDecimal("tpv_few")));//28
                    maps.put("val21", maps.get("val21").add(object.getBigDecimal("tpv_needamt")));//28
                    maps.put("val22", maps.get("val22").add(object.getBigDecimal("tpv_gain")));//28
                    maps.put("val23", maps.get("val23").add(object.getBigDecimal("tpv_byamt")));//28
                    maps.put("val24", maps.get("val24").add(object.getBigDecimal("tpv_sharp")));//28
                    maps.put("val25", maps.get("val25").add(object.getBigDecimal("tpv_aug")));//28
                    maps.put("val26", maps.get("val26").add(object.getBigDecimal("tpv_minus")));//28
                    maps.put("val27", maps.get("val27").add(object.getBigDecimal("tpv_accamt")));//28
                    maps.put("val28", maps.get("val28").add(object.getBigDecimal("tpv_favourable")));//28
                }
                addNew.set("tpv_add", maps.get("val1"));
                addNew.set("tpv_reduce", maps.get("val2"));
                addNew.set("tpv_occupied", maps.get("val3"));
                addNew.set("tpv_interest", maps.get("val4"));
                addNew.set("tpv_increase", maps.get("val5"));
                addNew.set("tpv_decrease", maps.get("val6"));
                addNew.set("tpv_occupyamt", maps.get("val7"));
                addNew.set("tpv_interests", maps.get("val8"));
                addNew.set("tpv_augment", maps.get("val9"));
                addNew.set("tpv_lessen", maps.get("val10"));
                addNew.set("tpv_holdamt", maps.get("val11"));
                addNew.set("tpv_accrual", maps.get("val12"));
                addNew.set("tpv_applyamt", maps.get("val13"));
                addNew.set("tpv_profit", maps.get("val14"));
                addNew.set("tpv_enhance", maps.get("val15"));
                addNew.set("tpv_little", maps.get("val16"));
                addNew.set("tpv_useamt", maps.get("val17"));
                addNew.set("tpv_return", maps.get("val18"));
                addNew.set("tpv_plus", maps.get("val19"));
                addNew.set("tpv_few", maps.get("val20"));
                addNew.set("tpv_needamt", maps.get("val21"));
                addNew.set("tpv_gain", maps.get("val22"));
                addNew.set("tpv_byamt", maps.get("val23"));
                addNew.set("tpv_sharp", maps.get("val24"));
                addNew.set("tpv_aug", maps.get("val25"));
                addNew.set("tpv_minus", maps.get("val26"));
                addNew.set("tpv_accamt", maps.get("val27"));
                addNew.set("tpv_favourable", maps.get("val28"));

            }
            SaveServiceHelper.update(dataEntity);//写入数据库
            dateSort();
           // this.getView().updateView("tpv_sc_fundsused_aa");
        }
        if (StringUtils.equals("tpv_advconbaritemaps", key)) {//删除部门资金占用明细
            DynamicObjectCollection tpvScFundsusedAas = this.getModel().getEntryEntity("tpv_sc_fundsused_aa");
            if (tpvScFundsusedAas.size() > 0) {
                this.getModel().deleteEntryData("tpv_sc_fundsused_aa");
            }
        }
    }

    private void utilize() {
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        DynamicObject org = (DynamicObject) model.getValue("org");
        Date year = (Date) model.getValue("tpv_year");
        String month = (String) model.getValue("tpv_month");
        String bizdate = formatDate(year);
        String joint = bizdate + "-" + month + "-" + "01";
        Date years = parseDate(joint);
        Date time = new Date();
        Date times = new Date();
        if (YEM.isNotEmpty(years)) {
            time = DateUtil.getMonthFirstDay(years);
            times = DateUtil.getMonthEndDay(years);
        }
        QFilter qFilter1 = new QFilter("enable", QCP.equals, "1");
        QFilter qFilterOne=null;
        if (org != null) {
            long id = org.getLong("id");
            qFilter1.and(new QFilter("createorg.id", QCP.equals, id));
            if (year != null) {
                qFilter1.and(new QFilter("tpv_enddate", QCP.large_equals, time));
                qFilter1.and(new QFilter("tpv_lastdate", QCP.less_equals, times));
                qFilterOne = new QFilter("bizdate", QCP.large_equals, time);
                qFilterOne.and(new QFilter("bizdate", QCP.less_equals, times));
            }
            BigDecimal interest = BigDecimal.ZERO;
            BigDecimal income = BigDecimal.ZERO;
            BigDecimal percent = BigDecimal.valueOf(100);
            BigDecimal period = BigDecimal.ZERO;
            String selectfieldsFast = com.itopview.wm.utils.DynamicObjectUtil.getSelectfieldsFast("gl_voucher", "entries");
            DynamicObject[] queryZZ = BusinessDataServiceHelper.load("gl_voucher", selectfieldsFast, qFilterOne.toArray());//总账
            if (YEM.isNotEmpty(queryZZ)) {
                for (DynamicObject bill : queryZZ) {
                    DynamicObjectCollection voucher = bill.getDynamicObjectCollection("entries");
                    for (DynamicObject bills : voucher) {
                        DynamicObject assgrp = bills.getDynamicObject("assgrp");
                        if (YEM.isNotEmpty(assgrp)) {
                            QFilter filter;
                            String assgrpValue = assgrp.getString("value");
                            JSONObject jsonObject = new JSONObject(assgrpValue);
                            // 获取键
                            String key = jsonObject.keys().next();
                            filter = new QFilter("flexfield", QCP.equals, key);
                            DynamicObject flexPropertyValue = QueryServiceHelper.queryOne("bos_flex_property", "valuesource", filter.toArray());
                            String bdEntity = flexPropertyValue.getString("valuesource");
                            Object bkValue = jsonObject.get(key);
                            DynamicObject bdValue = BusinessDataServiceHelper.loadSingle(bkValue, bdEntity);
                            DynamicObject account = bills.getDynamicObject("account");
                            String number = account.getString("number");//会计科目编码
                            if (YEM.isNotEmpty(number)) {
                                switch (number) {
                                    case "1001":
                                    case "1002":
                                        // 现款
                                        qFilter1.and(new QFilter("tpv_interestclass.number", QCP.equals, "01"));
                                        QFilter[] array = qFilter1.toArray();
                                        String selectFieid2 = DynamicObjectUtil.getSelectfields("tpv_zjzyll", false);
                                        DynamicObject queryXK = BusinessDataServiceHelper.loadSingle("tpv_zjzyll", selectFieid2, array);////资金利用
                                        if (YEM.isNotEmpty(queryXK)) {
                                            DynamicObject tpvDepertment = queryXK.getDynamicObject("tpv_depertment");
                                            QFilter[] qFilters = new QFilter[]{new QFilter("tpv_sc_adjustment.tpv_depertment", QCP.equals, tpvDepertment.getLong("id")),
                                                    new QFilter("createorg.id", QCP.equals, id),//创建组织和公司一致
                                                    new QFilter("tpv_category.number", QCP.not_equals, null)};//计息类别不等于空
                                            String selectFieids = DynamicObjectUtil.getSelectfields("tpv_sc_adjustment", false);
                                            DynamicObject[] queryZY = BusinessDataServiceHelper.load("tpv_sc_adjustment", selectFieids, qFilters);//资金调整
                                            for (DynamicObject var : queryZY) {
                                                DynamicObject tpvCategory = var.getDynamicObject("tpv_category");
                                                if ("现款".equals(tpvCategory.getString("name"))) {  //计息类别等于现款
                                                    income = income.add(var.getBigDecimal("tpv_income"));
                                                }
                                            }
                                            cash(model, income, percent, period, queryXK, tpvDepertment, queryZY, bill, bills, bdValue);
                                        }
                                        break;

                                    case "112101":
                                        // 应收票据（银承）
                                        qFilter1.and(new QFilter("tpv_interestclass.name", QCP.equals, "应收票据（银承）"));
                                        QFilter[] arrays = qFilter1.toArray();
                                        //String selectFieids = DynamicObjectUtil.getSelectfields("tpv_zjzyll", false);
                                        DynamicObject queryYC = BusinessDataServiceHelper.loadSingle("tpv_zjzyll", "tpv_depertment,tpv_deoccupyrate,tpv_dayrate", arrays);////资金利用
                                        if (YEM.isNotEmpty(queryYC)) {
                                            DynamicObject tpvDepertment = queryYC.getDynamicObject("tpv_depertment");
                                            QFilter[] qFilters = new QFilter[]{new QFilter("tpv_sc_adjustment.tpv_depertment", QCP.equals, tpvDepertment.getLong("id")),
                                                    new QFilter("createorg.id", QCP.equals, id),//创建组织和公司一致
                                                    new QFilter("tpv_category.number", QCP.not_equals, null)};//计息类别不等于空
                                            String selectFieidh = DynamicObjectUtil.getSelectfields("tpv_sc_adjustment", false);
                                            DynamicObject[] yc = BusinessDataServiceHelper.load("tpv_sc_adjustment", "tpv_category,tpv_income", qFilters);//资金调整
                                            for (DynamicObject vars : yc) {
                                                DynamicObject tpvCategory = vars.getDynamicObject("tpv_category");
                                                if ("应收票据（银承）".equals(tpvCategory.getString("name"))) {  //计息类别等于现款
                                                    income = income.add(vars.getBigDecimal("tpv_income"));
                                                }
                                            }
                                            notesReceiv(model, income, percent, period, queryYC, tpvDepertment, yc, bill, bills, bdValue);
                                        }
                                        break;
//                                case "220101":
//                                    // 应付票据（银承）
//                                    qFilter1.and(new QFilter("tpv_interestclass.number", QCP.equals, "002"));
//                                    QFilter[] arrayes = qFilter1.toArray();
//                                    String selectFieidf = DynamicObjectUtil.getSelectfields("tpv_zjzyll", false);
//                                    DynamicObject queryYCF = BusinessDataServiceHelper.loadSingle("tpv_zjzyll", selectFieidf, arrayes);////资金利用
//                                    if (YEM.isNotEmpty(queryYCF)) {
//                                        DynamicObject tpvDepertment = queryYCF.getDynamicObject("tpv_depertment");
//                                        QFilter[] qFilters = new QFilter[]{new QFilter("tpv_sc_adjustment.tpv_depertment", QCP.equals, tpvDepertment.getLong("id")),
//                                                new QFilter("createorg.id", QCP.equals, id),//创建组织和公司一致
//                                                new QFilter("tpv_category.number", QCP.not_equals, null)};//计息类别不等于空
//                                        String selectFieidh = DynamicObjectUtil.getSelectfields("tpv_sc_adjustment", false);
//                                        DynamicObject[] ycf = BusinessDataServiceHelper.load("tpv_sc_adjustment", selectFieidh, qFilters);//资金调整
//                                        for (DynamicObject varq : ycf) {
//                                            DynamicObject tpvCategory = varq.getDynamicObject("tpv_category");
//                                            if ("应付票据（银承）".equals(tpvCategory.getString("name"))) {  //计息类别等于现款
//                                                income = income.add(varq.getBigDecimal("tpv_income"));
//                                            }
//                                        }
                                    // notesPay(model, income, percent, period, queryYCF, tpvDepertment, ycf, bill, bills, bdValue);
//                                    }
//                                    break;
//                                case "112102":
//                                    // 应收票据（商票）
//                                    qFilter1.and(new QFilter("tpv_interestclass.number", QCP.equals, "004"));
//                                    QFilter[] arrayus = qFilter1.toArray();
//                                    String selectFieidp = DynamicObjectUtil.getSelectfields("tpv_zjzyll", false);
//                                    DynamicObject querySP = BusinessDataServiceHelper.loadSingle("tpv_zjzyll", selectFieidp, arrayus);////资金利用
//                                    if (YEM.isNotEmpty(querySP)) {
//                                        DynamicObject tpvDepertment = querySP.getDynamicObject("tpv_depertment");
//                                        QFilter[] qFilters = new QFilter[]{new QFilter("tpv_sc_adjustment.tpv_depertment", QCP.equals, tpvDepertment.getLong("id")),
//                                                new QFilter("createorg.id", QCP.equals, id),//创建组织和公司一致
//                                                new QFilter("tpv_category.number", QCP.not_equals, null)};//计息类别不等于空
//                                        String selectFieidh = DynamicObjectUtil.getSelectfields("tpv_sc_adjustment", false);
//                                        DynamicObject[] sp = BusinessDataServiceHelper.load("tpv_sc_adjustment", selectFieidh, qFilters);//资金调整
//                                        for (DynamicObject varu : sp) {
//                                            DynamicObject tpvCategory = varu.getDynamicObject("tpv_category");
//                                            if ("应收票据（商票）".equals(tpvCategory.getString("name"))) {  //计息类别等于现款
//                                                income = income.add(varu.getBigDecimal("tpv_income"));
//                                            }
//                                            notesReceivable(model, income, percent, period, querySP, tpvDepertment, sp, bill, bills, bdValue);
//                                        }
//                                    }
//                                    break;
//                                case "220102":
//                                    // 应付票据（商票）
//                                    qFilter1.and(new QFilter("tpv_interestclass.number", QCP.equals, "005"));
//                                    QFilter[] arrayux = qFilter1.toArray();
//                                    String selectFieidj = DynamicObjectUtil.getSelectfields("tpv_zjzyll", false);
//                                    DynamicObject querySPF = BusinessDataServiceHelper.loadSingle("tpv_zjzyll", selectFieidj, arrayux);////资金利用
//                                    if (YEM.isNotEmpty(querySPF)) {
//                                        DynamicObject tpvDepertment = querySPF.getDynamicObject("tpv_depertment");
//                                        QFilter[] qFilters = new QFilter[]{new QFilter("tpv_sc_adjustment.tpv_depertment", QCP.equals, tpvDepertment.getLong("id")),
//                                                new QFilter("createorg.id", QCP.equals, id),//创建组织和公司一致
//                                                new QFilter("tpv_category.number", QCP.not_equals, null)};//计息类别不等于空
//                                        String selectFieidh = DynamicObjectUtil.getSelectfields("tpv_sc_adjustment", false);
//                                        DynamicObject[] spf = BusinessDataServiceHelper.load("tpv_sc_adjustment", selectFieidh, qFilters);//资金调整
//                                        for (DynamicObject vart : spf) {
//                                            DynamicObject tpvCategory = vart.getDynamicObject("tpv_category");
//                                            if ("应付票据（商票）".equals(tpvCategory.getString("name"))) {  //计息类别等于现款
//                                                income = income.add(vart.getBigDecimal("tpv_income"));
//                                            }
//                                            notesPayable(model, income, percent, period, querySPF, tpvDepertment, spf, bill, bills, bdValue);
//                                        }
//                                    }
//                                    break;
//                                case "11220103":
//                                    // 供应链票据
//                                    qFilter1.and(new QFilter("tpv_interestclass.number", QCP.equals, "006"));
//                                    QFilter[] arrayul = qFilter1.toArray();
//                                    String selectFieidgl = DynamicObjectUtil.getSelectfields("tpv_zjzyll", false);
//                                    DynamicObject queryGYL = BusinessDataServiceHelper.loadSingle("tpv_zjzyll", selectFieidgl, arrayul);////资金利用
//                                    if (YEM.isNotEmpty(queryGYL)) {
//                                        DynamicObject tpvDepertment = queryGYL.getDynamicObject("tpv_depertment");
//                                        QFilter[] qFilters = new QFilter[]{new QFilter("tpv_sc_adjustment.tpv_depertment", QCP.equals, tpvDepertment.getLong("id")),
//                                                new QFilter("createorg.id", QCP.equals, id),//创建组织和公司一致
//                                                new QFilter("tpv_category.number", QCP.not_equals, null)};//计息类别不等于空
//                                        String selectFieidh = DynamicObjectUtil.getSelectfields("tpv_sc_adjustment", false);
//                                        DynamicObject[] gyl = BusinessDataServiceHelper.load("tpv_sc_adjustment", selectFieidh, qFilters);//资金调整
//                                        for (DynamicObject varv : gyl) {
//                                            DynamicObject tpvCategory = varv.getDynamicObject("tpv_category");
//                                            if ("应付票据（商票）".equals(tpvCategory.getString("name"))) {  //计息类别等于现款
//                                                income = income.add(varv.getBigDecimal("tpv_income"));
//                                            }
//                                            supplyChainNote(model, income, percent, period, queryGYL, tpvDepertment, gyl, bill, bills, bdValue);
//                                        }
//                                    }
//                                    break;

                                }
                            }
                        }
                    }
                }
            }
        }
    }


    // 供应链票据
    private void supplyChainNote(IDataModel model, BigDecimal income, BigDecimal percent, BigDecimal
            period, DynamicObject billus, DynamicObject tpvDepertment, DynamicObject[] queryZY, DynamicObject
                                         bill, DynamicObject bills, DynamicObject bdValue) {
        BigDecimal interest;
        if (bdValue.getLong("id") == (tpvDepertment.getLong("id"))) {
            BigDecimal debitlocal = bills.getBigDecimal("debitlocal");//借方
            BigDecimal creditlocal = bills.getBigDecimal("creditlocal");//贷方
            int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_fundsused_aa");//财务分录
            model.setValue("tpv_aug", debitlocal, newEntryRow);
            model.setValue("tpv_minus", creditlocal, newEntryRow);
            model.setValue("tpv_companys", bill.getDynamicObject("org").getLong("id"), newEntryRow);
            BigDecimal ccupied = period.add(debitlocal).subtract(creditlocal).add(income);
            for (DynamicObject vars : queryZY) {  //特殊利息，先算占用金额
                DynamicObject tpvCategorys = vars.getDynamicObject("tpv_category");
                if ("03".equals(tpvCategorys.getString("number")) || "05".equals(tpvCategorys.getString("number"))) {    //计息类别等于应付票据（银承）
                    ccupied = period.add(creditlocal).subtract(debitlocal).add(income);
                    model.setValue("tpv_accamt", ccupied, newEntryRow);
                }
            }
            BigDecimal dayrate = billus.getBigDecimal("tpv_dayrate");//日利率
            dayrate = dayrate.divide(percent);
            BigDecimal deoccupyrate = billus.getBigDecimal("tpv_deoccupyrate");//负占用利率(%)
            deoccupyrate = deoccupyrate.divide(percent);
            if (ccupied.compareTo(BigDecimal.ZERO) > 0) {
                interest = ccupied.multiply(dayrate);
                model.setValue("tpv_favourable", interest, newEntryRow);
            }
            if (ccupied.compareTo(BigDecimal.ZERO) < 0) {
                interest = ccupied.multiply(deoccupyrate);
                model.setValue("tpv_favourable", interest, newEntryRow);
            }
            model.setValue("tpv_accamt", ccupied, newEntryRow);
            model.setValue("tpv_businessdate", bill.getDate("bizdate"), newEntryRow);
            model.setValue("tpv_depertment", bdValue.getLong("id"), newEntryRow);
        }
    }

    // 应收票据（银承）
    private void notesReceiv(IDataModel model, BigDecimal income, BigDecimal percent, BigDecimal
            period, DynamicObject billus, DynamicObject tpvDepertment, DynamicObject[] queryZY, DynamicObject
                                     bill, DynamicObject bills, DynamicObject bdValue) {
        BigDecimal interest;
        if (bdValue.getLong("id") == (tpvDepertment.getLong("id"))) {
            BigDecimal debitlocal = bills.getBigDecimal("debitlocal");//借方
            BigDecimal creditlocal = bills.getBigDecimal("creditlocal");//贷方
            int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_fundsused_aa");//财务分录
            model.setValue("tpv_increase", debitlocal, newEntryRow);
            model.setValue("tpv_decrease", creditlocal, newEntryRow);
            model.setValue("tpv_companys", bill.getDynamicObject("org").getLong("id"), newEntryRow);
            BigDecimal ccupied = period.add(debitlocal).subtract(creditlocal).add(income);
            for (DynamicObject vars : queryZY) {  //特殊利息，先算占用金额
                DynamicObject tpvCategorys = vars.getDynamicObject("tpv_category");
                if ("03".equals(tpvCategorys.getString("number")) || "05".equals(tpvCategorys.getString("number"))) {    //计息类别等于应付票据（银承）
                    ccupied = period.add(creditlocal).subtract(debitlocal).add(income);
                    model.setValue("tpv_occupyamt", ccupied, newEntryRow);
                }
            }
            BigDecimal dayrate = billus.getBigDecimal("tpv_dayrate");//日利率
            dayrate = dayrate.divide(percent);
            BigDecimal deoccupyrate = billus.getBigDecimal("tpv_deoccupyrate");//负占用利率(%)
            deoccupyrate = deoccupyrate.divide(percent);
            if (ccupied.compareTo(BigDecimal.ZERO) > 0) {
                interest = ccupied.multiply(dayrate);
                model.setValue("tpv_interests", interest, newEntryRow);
            }
            if (ccupied.compareTo(BigDecimal.ZERO) < 0) {
                interest = ccupied.multiply(deoccupyrate);
                model.setValue("tpv_interests", interest, newEntryRow);
            }
            model.setValue("tpv_occupyamt", ccupied, newEntryRow);
            model.setValue("tpv_businessdate", bill.getDate("bizdate"), newEntryRow);
            model.setValue("tpv_depertment", bdValue.getLong("id"), newEntryRow);
        }
    }

    // 应付票据（银承）
    private void notesPay(IDataModel model, BigDecimal income, BigDecimal percent, BigDecimal period, DynamicObject
            billus, DynamicObject tpvDepertment, DynamicObject[] queryZY, DynamicObject bill, DynamicObject
                                  bills, DynamicObject bdValue) {
        BigDecimal interest;
        if (bdValue.getLong("id") == (tpvDepertment.getLong("id"))) {
            BigDecimal debitlocal = bills.getBigDecimal("debitlocal");//借方
            BigDecimal creditlocal = bills.getBigDecimal("creditlocal");//贷方
            int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_fundsused_aa");//财务分录
            model.setValue("tpv_augment", debitlocal, newEntryRow);
            model.setValue("tpv_lessen", creditlocal, newEntryRow);
            model.setValue("tpv_companys", bill.getDynamicObject("org").getLong("id"), newEntryRow);
            BigDecimal ccupied = period.add(debitlocal).subtract(creditlocal).add(income);
            for (DynamicObject vars : queryZY) {  //特殊利息，先算占用金额
                DynamicObject tpvCategorys = vars.getDynamicObject("tpv_category");
                if ("03".equals(tpvCategorys.getString("number")) || "05".equals(tpvCategorys.getString("number"))) {    //计息类别等于应付票据（银承）
                    ccupied = period.add(creditlocal).subtract(debitlocal).add(income);
                    model.setValue("tpv_holdamt", ccupied, newEntryRow);
                }
            }
            BigDecimal dayrate = billus.getBigDecimal("tpv_dayrate");//日利率
            dayrate = dayrate.divide(percent);
            BigDecimal deoccupyrate = billus.getBigDecimal("tpv_deoccupyrate");//负占用利率(%)
            deoccupyrate = deoccupyrate.divide(percent);
            if (ccupied.compareTo(BigDecimal.ZERO) > 0) {
                interest = ccupied.multiply(dayrate);
                model.setValue("tpv_accrual", interest, newEntryRow);
            }
            if (ccupied.compareTo(BigDecimal.ZERO) < 0) {
                interest = ccupied.multiply(deoccupyrate);
                model.setValue("tpv_accrual", interest, newEntryRow);
            }
            model.setValue("tpv_holdamt", ccupied, newEntryRow);
            model.setValue("tpv_businessdate", bill.getDate("bizdate"), newEntryRow);
            model.setValue("tpv_depertment", bdValue.getLong("id"), newEntryRow);
        }
    }

    // 应付票据（商票）
    private void notesPayable(IDataModel model, BigDecimal income, BigDecimal percent, BigDecimal
            period, DynamicObject billus, DynamicObject tpvDepertment, DynamicObject[] queryZY, DynamicObject
                                      bill, DynamicObject bills, DynamicObject bdValue) {
        BigDecimal interest;
        if (bdValue.getLong("id") == (tpvDepertment.getLong("id"))) {
            BigDecimal debitlocal = bills.getBigDecimal("debitlocal");//借方
            BigDecimal creditlocal = bills.getBigDecimal("creditlocal");//贷方
            int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_fundsused_aa");//财务分录
            model.setValue("tpv_plus", debitlocal, newEntryRow);
            model.setValue("tpv_few", creditlocal, newEntryRow);
            model.setValue("tpv_companys", bill.getDynamicObject("org").getLong("id"), newEntryRow);
            BigDecimal ccupied = period.add(debitlocal).subtract(creditlocal).add(income);
            for (DynamicObject vars : queryZY) {  //特殊利息，先算占用金额
                DynamicObject tpvCategorys = vars.getDynamicObject("tpv_category");
                if ("03".equals(tpvCategorys.getString("number")) || "05".equals(tpvCategorys.getString("number"))) {    //计息类别等于应付票据（银承）
                    ccupied = period.add(creditlocal).subtract(debitlocal).add(income);
                    model.setValue("tpv_needamt", ccupied, newEntryRow);
                }
            }
            BigDecimal dayrate = billus.getBigDecimal("tpv_dayrate");//日利率
            dayrate = dayrate.divide(percent);
            BigDecimal deoccupyrate = billus.getBigDecimal("tpv_deoccupyrate");//负占用利率(%)
            deoccupyrate = deoccupyrate.divide(percent);
            if (ccupied.compareTo(BigDecimal.ZERO) > 0) {
                interest = ccupied.multiply(dayrate);
                model.setValue("tpv_gain", interest, newEntryRow);
            }
            if (ccupied.compareTo(BigDecimal.ZERO) < 0) {
                interest = ccupied.multiply(deoccupyrate);
                model.setValue("tpv_gain", interest, newEntryRow);
            }
            model.setValue("tpv_needamt", ccupied, newEntryRow);
            model.setValue("tpv_businessdate", bill.getDate("bizdate"), newEntryRow);
            model.setValue("tpv_depertment", bdValue.getLong("id"), newEntryRow);
        }
    }

    // 应收票据（商票）
    private void notesReceivable(IDataModel model, BigDecimal income, BigDecimal percent, BigDecimal
            period, DynamicObject billus, DynamicObject tpvDepertment, DynamicObject[] queryZY, DynamicObject
                                         bill, DynamicObject bills, DynamicObject bdValue) {
        BigDecimal interest;
        if (bdValue.getLong("id") == (tpvDepertment.getLong("id"))) {
            BigDecimal debitlocal = bills.getBigDecimal("debitlocal");//借方
            BigDecimal creditlocal = bills.getBigDecimal("creditlocal");//贷方
            int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_fundsused_aa");//财务分录
            model.setValue("tpv_enhance", debitlocal, newEntryRow);
            model.setValue("tpv_little", creditlocal, newEntryRow);
            model.setValue("tpv_companys", bill.getDynamicObject("org").getLong("id"), newEntryRow);
            BigDecimal ccupied = period.add(debitlocal).subtract(creditlocal).add(income);
            for (DynamicObject vars : queryZY) {  //特殊利息，先算占用金额
                DynamicObject tpvCategorys = vars.getDynamicObject("tpv_category");
                if ("03".equals(tpvCategorys.getString("number")) || "05".equals(tpvCategorys.getString("number"))) {    //计息类别等于应付票据（银承）
                    ccupied = period.add(creditlocal).subtract(debitlocal).add(income);
                    model.setValue("tpv_useamt", ccupied, newEntryRow);
                }
            }
            BigDecimal dayrate = billus.getBigDecimal("tpv_dayrate");//日利率
            dayrate = dayrate.divide(percent);
            BigDecimal deoccupyrate = billus.getBigDecimal("tpv_deoccupyrate");//负占用利率(%)
            deoccupyrate = deoccupyrate.divide(percent);
            if (ccupied.compareTo(BigDecimal.ZERO) > 0) {
                interest = ccupied.multiply(dayrate);
                model.setValue("tpv_return", interest, newEntryRow);
            }
            if (ccupied.compareTo(BigDecimal.ZERO) < 0) {
                interest = ccupied.multiply(deoccupyrate);
                model.setValue("tpv_return", interest, newEntryRow);
            }
            model.setValue("tpv_useamt", ccupied, newEntryRow);
            model.setValue("tpv_businessdate", bill.getDate("bizdate"), newEntryRow);
            model.setValue("tpv_depertment", bdValue.getLong("id"), newEntryRow);
        }
    }

    //现款
    private void cash(IDataModel model, BigDecimal income, BigDecimal percent, BigDecimal period, DynamicObject
            billus, DynamicObject tpvDepertment, DynamicObject[] queryZY, DynamicObject bill, DynamicObject
                              bills, DynamicObject bdValue) {
        BigDecimal interest;
        if (bdValue.getLong("id") == (tpvDepertment.getLong("id"))) {
            BigDecimal debitlocal = bills.getBigDecimal("debitlocal");//借方
            BigDecimal creditlocal = bills.getBigDecimal("creditlocal");//贷方
            int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_fundsused_aa");//财务分录
            model.setValue("tpv_add", debitlocal, newEntryRow);
            model.setValue("tpv_reduce", creditlocal, newEntryRow);
            model.setValue("tpv_companys", bill.getDynamicObject("org").getLong("id"), newEntryRow);
            BigDecimal ccupied = period.add(debitlocal).subtract(creditlocal).add(income);
            for (DynamicObject vars : queryZY) {  //特殊利息，先算占用金额
                DynamicObject tpvCategorys = vars.getDynamicObject("tpv_category");
                if ("03".equals(tpvCategorys.getString("number")) || "05".equals(tpvCategorys.getString("number"))) {    //计息类别等于应付票据（银承）
                    ccupied = period.add(creditlocal).subtract(debitlocal).add(income);
                    model.setValue("tpv_occupied", ccupied, newEntryRow);
                }
            }
            BigDecimal dayrate = billus.getBigDecimal("tpv_dayrate");//日利率
            dayrate = dayrate.divide(percent);
            BigDecimal deoccupyrate = billus.getBigDecimal("tpv_deoccupyrate");//负占用利率(%)
            deoccupyrate = deoccupyrate.divide(percent);
            if (ccupied.compareTo(BigDecimal.ZERO) > 0) {
                interest = ccupied.multiply(dayrate);
                model.setValue("tpv_interest", interest, newEntryRow);
            }
            if (ccupied.compareTo(BigDecimal.ZERO) < 0) {
                interest = ccupied.multiply(deoccupyrate);
                model.setValue("tpv_interest", interest, newEntryRow);
            }
            model.setValue("tpv_occupied", ccupied, newEntryRow);
            model.setValue("tpv_businessdate", bill.getDate("bizdate"), newEntryRow);
            model.setValue("tpv_depertment", bdValue.getLong("id"), newEntryRow);
        }
    }

    public static String formatDate(Date date) {
        String datestr = "";
        if (date != null) {
            datestr = format.format(date);
        }
        return datestr;
    }

    /**
     * @description: 获取下拉列表的标题
     * @author yhj
     * @date 2023/9/4 10:51
     * @version 1.0
     * obs 标识
     * obj 标识所在单据或分录的数据包
     */
    private static String extracted(DynamicObject obj, String obs) { //获取下拉列表v,获取标题方法
        MainEntityType mainEntityType = (MainEntityType) obj.getDataEntityType();//获取主实体
        DataEntityPropertyCollection properties = mainEntityType.getProperties();//获取属性
        ComboProp comboUnitProp = (ComboProp) properties.get(obs);//获取字段的数据模型
        String comb = comboUnitProp.getItemByName(obj.getString(obs));//根据value获取key（标题）
        return comb;
    }

    /**
     * 字符串转时间 格式yyyy-MM-dd
     *
     * @param datestr
     * @return
     */
    public static Date parseDate(String datestr) {
        Date date = null;
        if (datestr != null && !datestr.isEmpty() && !"null".equals(datestr)) {
            try {
                date = formats.parse(datestr);
            } catch (ParseException e) {
                e.printStackTrace();
            }
        }
        return date;
    }

    private void dateSort() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection entry = dataEntity.getDynamicObjectCollection("tpv_sc_fundsused_aa");
        for (int i = 0; i < entry.size() - 1; i++) {
            for (int j = 0; j < entry.size() - 1 - i; j++) {
                Date date = entry.get(j).getDate("tpv_businessdate");
                Date date1 = entry.get(j + 1).getDate("tpv_businessdate");
                if (date1 != null && date != null) {
                    if (date.after(date1)) {
                        this.getModel().moveEntryRowDown("tpv_sc_fundsused_aa", j);
                    }
                }
            }
        }
        this.getView().updateView("tpv_sc_fundsused_aa");
    }
}
