package tpv.tpv_wm.tpv_sc.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.time.*;
import java.util.Calendar;
import java.util.Date;
import java.util.EventObject;

/**
 * @author l j w
 * @version 1.0
 * @description: 资金收支计划考核表表单插件
 * 实际流出/流入合计赋值
 * @date 2023/8/11 11:32
 */

public class ActualinflowsFromPlug extends AbstractBillPlugIn {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("tpv_dataacquisition");
    }


    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String key = e.getOperateKey();
        //获取所选部门
//        String department = (String) this.getModel().getValue("tpv_department");
//        if (department == null){
//            this.getView().showMessage("部门为空，请选择后重试！");
//            return;
//        }

        if ("dataacquisition".equals(key)) {
            //获取年
            Date annual = (Date) this.getModel().getValue("tpv_annual");

            if (annual == null) {
                this.getView().showMessage("年度为空，请选择后重试！");
                return;
            }
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(annual);    //放入Date类型数据
            //获取业务所选择的时间

            String months = (String) this.getModel().getValue("tpv_month");
            if (months == null) {
                this.getView().showMessage("月份为空，请选择后重试！");
                return;
            }
            int month = Integer.valueOf((String) this.getModel().getValue("tpv_month")).intValue();
            //获取数据主实体
            DynamicObject dataEntitys = this.getModel().getDataEntity(true);
            //获取明细信息分录数据
            DynamicObjectCollection detailedinformation = dataEntitys.getDynamicObjectCollection("tpv_fundingassess_zjjh");
            //循环单据体数据
            for (int j = 0; j < detailedinformation.size(); j++) {
                //得到单据体数据
                DynamicObject detailedinformations = detailedinformation.get(j);
                //获取到大类的值
                String largecategories = detailedinformations.getString("tpv_largecategories");
                if (largecategories == null) {
                    this.getView().showMessage("大类为空，请选择后重试！");
                    return;
                }
                //判断大类的值是否为现款
                if ("A".equals(largecategories)) {
                    //查询收款处理单据的数据中的字段值是否为所需要的数据
                    QFilter qFilter = new QFilter("settletype.number", QCP.in, "'JSFS01','JSFS02','JSFS03','JSFS04'");
                    //查询收款处理单据中的部门是否为所选部门
//                    qFilter.and(new QFilter("entry.e_settleorg",QCP.in,department));
                    //查询收款处理单据是否为已审核
//                    //查询月资金计划单据中的收支方向为收款的所有单据
//                    qFilter.add(new QFilter("tpv_incomeexpenses",QCP.in,"A");
//                    //查询月资金计划单据中的收支方向为付款的所有单据
//                    qFilter.and(new QFilter("tpv_incomeexpenses",QCP.in,"B"));
                    qFilter.and(new QFilter("billstatus", QCP.in, "C"));
                    //查询收款处理单据中业务日期是否为所需条件时间内
                    qFilter.and(new QFilter("bizdate", QCP.large_equals, getBeginTime(Calendar.YEAR, month)));
                    qFilter.and(new QFilter("bizdate", QCP.less_equals, getEndTime(Calendar.YEAR, month)));
                    //获取到收款处理中的折本位币的数据
                    DynamicObject[] recbill = BusinessDataServiceHelper.load("cas_recbill", "id,billno,localamt"
                            , new QFilter[]{qFilter}, null);
                    //获取月资金计划单中的原币金额数据
//                    DynamicObject[] original = BusinessDataServiceHelper.load("tpv_sc_capitalmonth", "id,billno,tpv_original"
//                            , new QFilter[]{qFilter}, null);
                    //获取到付款处理中的付款金额折本位币
                    DynamicObject[] paybill = BusinessDataServiceHelper.load("cas_paybill", "id,billno,localamt"
                            , new QFilter[]{qFilter}, null);
                    //获取的数据
//                    BigDecimal tpv_sc_capitalmonth = BigDecimal.ZERO;
//                    BigDecimal sc_capitalmonth = BigDecimal.ZERO;
                    BigDecimal localamt = BigDecimal.ZERO;
                    BigDecimal processing = BigDecimal.ZERO;
                    //判断获取的数据是否有值
                    if (recbill.length > 0) {
                        //循环数据
                        for (int i = 0; i < recbill.length; i++) {
                            //获取到所有的数据
                            DynamicObject recbills = recbill[i];
                            //所有的数据的值相加
                            localamt = localamt.add(recbills.getBigDecimal("localamt"));
                        }
                    }
                    //判断获取的数据是否有值
                    if (paybill.length > 0) {
                        //循环数据
                        for (int i = 0; i < paybill.length; i++) {
                            //获取到所有的数据
                            DynamicObject paybills = paybill[i];
                            //所有的值相加
                            processing = processing.add(paybills.getBigDecimal("localamt"));
                        }
                    }
//                    if (original.length > 0){
//                        if (original.equals('A')){
//                            for (int i = 0; i<original.length; i++){
//                                DynamicObject originals = original[i];
//                                sc_capitalmonth = sc_capitalmonth.add(originals.getBigDecimal("tpv_original"));
//                            }
//                        }
//                        if (original.equals('B')){
//                            for (int i = 0; i<original.length; i++){
//                                DynamicObject originalss = original[i];
//                                tpv_sc_capitalmonth = tpv_sc_capitalmonth.add(originalss.getBigDecimal("tpv_original"));
//                            }
//                        }
//
//                    }
                    //给单据体中的实际流出合计赋值
                    detailedinformations.set("tpv_actualinflows", localamt);
                    //给分录中的实际流入合计赋值
                    detailedinformations.set("tpv_actualoutflow", processing);
//                    //给分录中的预计流入合计赋值
//                    detailedinformations.set("tpv_expectedinflows",sc_capitalmonth);
//                    //给分录中的预计流出合计赋值
//                    detailedinformations.set("tpv_expectedoutflow",tpv_sc_capitalmonth);
                }
            }
            this.getView().updateView("tpv_detailedinformation");
        }
    }

    //获取某年某月的第一天
    public String getFirstDayOfMonth(String month) {
        int years = Integer.parseInt(month.substring(0, 4));  //截取出年份，并将其转化为int
        int month1 = Integer.parseInt(month.substring(5, 7));    //截去除月份，并将其转为int

        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.YEAR, years);    //设置年份
        cal.set(Calendar.MONTH, month1 - 1);  //设置月份
        int firstDay = cal.getActualMinimum(Calendar.DAY_OF_MONTH); //获取某月最小天数
        cal.set(Calendar.DAY_OF_MONTH, firstDay);   //设置日历中月份的最小天数
        //格式化日期
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String firstDayOfMonth = sdf.format(cal.getTime());
        return firstDayOfMonth;

    }

    //获取某年某月最后一天
    public static String getLastDayOfMonth(String month) {
        int year = Integer.parseInt(month.substring(0, 4));  //截取出年份，并将其转化为int
        int month1 = Integer.parseInt(month.substring(5, 7));    //截去除月份，并将其转为int


        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.YEAR, year);    //设置年份
        cal.set(Calendar.MONTH, month1 - 1);  //设置月份
        int lastDay = cal.getActualMaximum(Calendar.DAY_OF_MONTH);  //获取某月最大天数
        cal.set(Calendar.DAY_OF_MONTH, lastDay);    //设置日历中月份的最大天数
        //格式化日期
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String lastDayOfMonth = sdf.format(cal.getTime());
        return lastDayOfMonth;
    }

    public static Date getBeginTime(int year, int month) {
        YearMonth yearMonth = YearMonth.of(year, month);
        LocalDate localDate = yearMonth.atDay(1);
        LocalDateTime startOfDay = localDate.atStartOfDay();
        ZonedDateTime zonedDateTime = startOfDay.atZone(ZoneId.of("Asia/Shanghai"));

        return Date.from(zonedDateTime.toInstant());
    }

    public static Date getEndTime(int year, int month) {
        YearMonth yearMonth = YearMonth.of(year, month);
        LocalDate endOfMonth = yearMonth.atEndOfMonth();
        LocalDateTime localDateTime = endOfMonth.atTime(23, 59, 59, 999);
        ZonedDateTime zonedDateTime = localDateTime.atZone(ZoneId.of("Asia/Shanghai"));
        return Date.from(zonedDateTime.toInstant());
    }



}