package tpv.tpv_wm.tpv_sc.java.formplugin.form;


import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.entity.MulBasedataDynamicObjectCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.operate.FormOperate;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * WangShuGuang
 * 资金月计划单
 */
public class CapitalMonthFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {
    private final static String KEY_MULBASEDATAFIELD = "tpv_assesscompany";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit tpv_basedatafield = this.getControl("tpv_businesstypes");
        tpv_basedatafield.addBeforeF7SelectListener(this);
        this.addClickListeners("tpv_gaindata");
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {//触发时机：表单模型某个字段值改变的时候就会触发此事件//
        String propertyName = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        //监听原币金额系统获取和手动输入
        if (propertyName.equals("tpv_originalcurrency") || propertyName.equals("tpv_original")) {
            DynamicObjectCollection tpvScDetail = this.getModel().getEntryEntity("tpv_sc_detail");
            for (int i = 0; i < tpvScDetail.size(); i++) {
                DynamicObject dynamicObject = tpvScDetail.get(i);
                BigDecimal tpvOriginalcurrency = dynamicObject.getBigDecimal("tpv_originalcurrency");
                BigDecimal tpvOriginal = dynamicObject.getBigDecimal("tpv_original");
                if (tpvOriginalcurrency.compareTo(BigDecimal.ZERO) != 0 && tpvOriginal.compareTo(BigDecimal.ZERO) != 0) {
                    if (tpvOriginalcurrency.compareTo(tpvOriginal) != 0) {
                        this.getModel().setValue("tpv_adjustment", true, i);
                    } else {
                        this.getModel().setValue("tpv_adjustment", false, i);
                    }
                }
            }
        }
    }

    /**
     * 按钮操作执行前监听
     *
     * @param args
     */
    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate operate = (FormOperate) args.getSource();
        String key = operate.getOperateKey();
        if (key.equals("deleteentry")) {
            //获取单据体控件
            EntryGrid entryGrid = this.getView().getControl("tpv_sc_detail");
            //获取选中行，数组为行号，从0开始int[]
            int selectRows[] = entryGrid.getSelectRows();
            //获取单据体数据集合
            DynamicObjectCollection entity = this.getModel().getEntryEntity("tpv_sc_detail");
            if (selectRows != null && selectRows.length > 0) {
                for (int selectRow : selectRows) {
                    DynamicObject dynamicObject = entity.get(selectRow);  //获取选中行的单据体数据
                    String tpvDatasourcetype = dynamicObject.getString("tpv_datasourcetype");
                    if (!tpvDatasourcetype.equals("B")) {
                        args.setCancel(true);
                        this.getView().showErrorNotification("不可删除数据来源类型为自动获取的分录行");
                    }
                }
            }
        }
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String key = e.getOperateKey();
        // 获取实际流出/入合计
        if (key.equals("gaindata")) {
            //拿到当前单据的过滤条件
            //参与考核的公司
            List<String> issue = new ArrayList<>();
            MulBasedataDynamicObjectCollection assessCompany = (MulBasedataDynamicObjectCollection) this.getModel().getValue("tpv_assesscompany");
            if (assessCompany.size() < 1) {
                issue.add("参与考核的公司为空，请选择后重试");
            }
            //部门
            DynamicObject departMent = (DynamicObject) this.getModel().getValue("tpv_department");
            //申报月份
            String tpvMonth = (String) this.getModel().getValue("tpv_month");
            //申报年份
            Date tpvDeclareyears = (Date) this.getModel().getValue("tpv_declareyears");
            if (tpvMonth == null) {
                issue.add("申报月份为空，请选择后重试");
            }
            if (tpvDeclareyears == null) {
                issue.add("申报年份为空，请选择后重试");
            }
            if (departMent == null) {
                issue.add("部门为空，请选择后重试");
            }
            if (issue.size() > 0) {
                String result = String.join(", ", issue);
                this.getView().showMessage(result);
                return;
            }
            //拿到年份
            Calendar calendarYrea = Calendar.getInstance();
            calendarYrea.setTime(tpvDeclareyears); // 设置日期为要提取年份的日期
            int year = calendarYrea.get(Calendar.YEAR); // 获取年份

            // 创建 Calendar 对象并设置年份和月份
            int month = Integer.parseInt(tpvMonth);
            Calendar calendar = Calendar.getInstance();
            calendar.set(Calendar.YEAR, year);
            calendar.set(Calendar.MONTH, month - 1); // Calendar 类中的月份从0开始，所以需要减去1

            // 获取指定月份的第一天和最后一天
            Calendar firstDay = Calendar.getInstance();
            firstDay.set(year, month - 1, 1, 0, 0, 0); // 设置为指定月份的1号0点0分0秒

            Calendar lastDay = Calendar.getInstance();
            lastDay.set(year, month - 1, lastDay.getActualMaximum(Calendar.DAY_OF_MONTH), 23, 59, 59); // 设置为指定月份的最后一天23点59分59秒

            // 转换为日期类型
            Date firstDate = firstDay.getTime();
            Date lastDate = lastDay.getTime();
            QFilter qFilter = new QFilter("draftbillexpiredate", ">=", firstDate);
            qFilter.and(new QFilter("draftbillexpiredate", "<=", lastDate));
            DynamicObjectCollection rows = (DynamicObjectCollection) this.getModel().getValue(KEY_MULBASEDATAFIELD);
            List<Long> idS = new ArrayList<>();
            List<String> numBer = new ArrayList<>();
            DynamicObject[] tpvScBusinessnatures = BusinessDataServiceHelper.load("tpv_sc_businessnature", "id,number", null);
            Map<String, Long> map = new HashMap<>();
            for (DynamicObject tpvScBusinessnature : tpvScBusinessnatures) {
                map.put(tpvScBusinessnature.getString("number"), tpvScBusinessnature.getLong("id"));
            }
            //票据类型为纸质银行承兑汇票，电子银行承兑汇票
            numBer.add("101");
            numBer.add("102");
            for (DynamicObject row : rows) {
                DynamicObject basedataObj = (DynamicObject) row.getDynamicObject("fbasedataid");
                Long basedataId = (Long) basedataObj.getPkValue();
                idS.add(basedataId);
            }
            qFilter.and(new QFilter("company.id", QCP.in, idS));
            qFilter.and(new QFilter("draftbilltype.number", QCP.in, numBer));
            qFilter.and(new QFilter("draftbillstatus", QCP.equals, "registered"));
            DynamicObject[] cdmreceivablebill = null;
            cdmreceivablebill = BusinessDataServiceHelper.load("cdm_receivablebill", "id,currency,amount,draftbillexpiredate"
                    , new QFilter[]{qFilter}, null);
            //业务性质为银承到期金额收款
            if (cdmreceivablebill.length > 0) {
                for (DynamicObject object : cdmreceivablebill) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_detail");
                    Date draftbillexpiredate = object.getDate("draftbillexpiredate");
                    BigDecimal amount = object.getBigDecimal("amount");
                    DynamicObject currency = object.getDynamicObject("currency");
                    //赋值业务性质为银承到期
                    this.getModel().setValue("tpv_businesstypes", map.get("D"), newEntryRow);
                    this.getModel().setValue("tpv_incomeexpenses", "A", newEntryRow);
                    this.getModel().setValue("tpv_datasourcetype", "A", newEntryRow);
                    this.getModel().setValue("tpv_receiptpayment", calculateDate(draftbillexpiredate), newEntryRow);
                    this.getModel().setValue("tpv_currencyfield", currency, newEntryRow);
                    this.getModel().setValue("tpv_originalcurrency", amount, newEntryRow);
                    this.getModel().setValue("tpv_original", amount, newEntryRow);
                }
            }
            //业务性质为银承到期金额付款
            DynamicObject[] cdmPayablebill = null;
            cdmPayablebill = BusinessDataServiceHelper.load("cdm_payablebill", "id,currency,amount,draftbillexpiredate"
                    , new QFilter[]{qFilter}, null);
            if (cdmPayablebill.length > 0) {
                for (DynamicObject object : cdmPayablebill) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_detail");
                    BigDecimal amount = object.getBigDecimal("amount");
                    DynamicObject currency = object.getDynamicObject("currency");
                    Date draftbillexpiredate = object.getDate("draftbillexpiredate");
                    this.getModel().setValue("tpv_businesstypes", map.get("D"), newEntryRow);
                    this.getModel().setValue("tpv_incomeexpenses", "B", newEntryRow);
                    this.getModel().setValue("tpv_datasourcetype", "A", newEntryRow);
                    this.getModel().setValue("tpv_receiptpayment", calculateDate(draftbillexpiredate), newEntryRow);
                    this.getModel().setValue("tpv_currencyfield", currency, newEntryRow);
                    this.getModel().setValue("tpv_originalcurrency", amount, newEntryRow);
                    this.getModel().setValue("tpv_original", amount, newEntryRow);
                }
            }
            //业务性质为征税保函到期金额
            QFilter qFiltergm = new QFilter("expiredate", ">=", firstDate);
            qFiltergm.and(new QFilter("expiredate", "<=", lastDate));
            DynamicObjectCollection rowsgm = (DynamicObjectCollection) this.getModel().getValue(KEY_MULBASEDATAFIELD);
            List<Long> idSgm = new ArrayList<>();
            for (DynamicObject row : rowsgm) {
                DynamicObject basedataObj = (DynamicObject) row.getDynamicObject("fbasedataid");
                Long basedataId = (Long) basedataObj.getPkValue();
                idSgm.add(basedataId);
            }
            //qFilter.and(new QFilter("org.id", QCP.in, idS));
            //qFilter.and(new QFilter("draftbillstatus", QCP.equals, "registered"));
            DynamicObject[] gmReceiveletter = BusinessDataServiceHelper.load("gm_receiveletter", "id,currency,amount,expiredate"
                    , new QFilter[]{qFiltergm}, null);
            if (gmReceiveletter.length > 0) {
                for (DynamicObject object : gmReceiveletter) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_detail");
                    BigDecimal amount = object.getBigDecimal("amount");
                    DynamicObject currency = object.getDynamicObject("currency");
                    Date expiredate = object.getDate("expiredate");
                    this.getModel().setValue("tpv_receiptpayment", calculateDate(expiredate), newEntryRow);
                    //赋值业务性质为征税保函到期金额
                    this.getModel().setValue("tpv_businesstypes", map.get("E"), newEntryRow);
                    this.getModel().setValue("tpv_incomeexpenses", "A", newEntryRow);
                    this.getModel().setValue("tpv_datasourcetype", "A", newEntryRow);
                    this.getModel().setValue("tpv_currencyfield", currency, newEntryRow);
                    this.getModel().setValue("tpv_originalcurrency", amount, newEntryRow);
                    this.getModel().setValue("tpv_original", amount, newEntryRow);
                }
            }
            QFilter qFilterre = new QFilter("expiredate", ">=", firstDate);
            qFilterre.and(new QFilter("expiredate", "<=", lastDate));
            DynamicObjectCollection rowsre = (DynamicObjectCollection) this.getModel().getValue(KEY_MULBASEDATAFIELD);
            List<Long> idSre = new ArrayList<>();
            for (DynamicObject row : rowsre) {
                DynamicObject basedataObj = (DynamicObject) row.getDynamicObject("fbasedataid");
                Long basedataId = (Long) basedataObj.getPkValue();
                idSre.add(basedataId);
            }
            //qFilterre.and(new QFilter("org.id", QCP.in, idS));
            //qFilter.and(new QFilter("draftbillstatus", QCP.equals, "registered"));
            DynamicObject[] gReceiveletter = null;
            gReceiveletter = BusinessDataServiceHelper.load("gm_letterofguarantee", "id,currency,amount,expiredate"
                    , new QFilter[]{qFilterre}, null);
            if (gReceiveletter.length > 0) {
                for (DynamicObject object : gReceiveletter) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_detail");
                    BigDecimal amount = object.getBigDecimal("amount");
                    DynamicObject currency = object.getDynamicObject("currency");
                    Date expiredate = object.getDate("expiredate");
                    this.getModel().setValue("tpv_receiptpayment", calculateDate(expiredate), newEntryRow);
                    this.getModel().setValue("tpv_businesstypes", map.get("E"), newEntryRow);
                    this.getModel().setValue("tpv_incomeexpenses", "B", newEntryRow);
                    this.getModel().setValue("tpv_datasourcetype", "A", newEntryRow);
                    this.getModel().setValue("tpv_currencyfield", currency, newEntryRow);
                    this.getModel().setValue("tpv_originalcurrency", amount, newEntryRow);
                    this.getModel().setValue("tpv_original", amount, newEntryRow);
                }
            }
            //银行提款处理
            QFilter qFilterrecfm = new QFilter("expiredate", ">=", firstDate);
            qFilterre.and(new QFilter("expiredate", "<=", lastDate));
            DynamicObjectCollection rowsrcfme = (DynamicObjectCollection) this.getModel().getValue(KEY_MULBASEDATAFIELD);
            List<Long> idSrecfm = new ArrayList<>();
            for (DynamicObject row : rowsrcfme) {
                DynamicObject basedataObj = (DynamicObject) row.getDynamicObject("fbasedataid");
                Long basedataId = (Long) basedataObj.getPkValue();
                idSrecfm.add(basedataId);
            }
            DynamicObject[] gmLetterofguarantee = null;
            gmLetterofguarantee = BusinessDataServiceHelper.load("cfm_loanbill", "id,contractcny,expiredate,drawamount"
                    , new QFilter[]{qFilterrecfm}, null);
            if (gmLetterofguarantee.length > 0) {
                for (DynamicObject object : gmLetterofguarantee) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_detail");
                    BigDecimal amount = object.getBigDecimal("drawamount");
                    DynamicObject currency = object.getDynamicObject("contractcny");
                    Date expiredate = object.getDate("expiredate");
                    this.getModel().setValue("tpv_receiptpayment", calculateDate(expiredate), newEntryRow);
                    this.getModel().setValue("tpv_businesstypes", map.get("F"), newEntryRow);
                    this.getModel().setValue("tpv_incomeexpenses", "B", newEntryRow);
                    this.getModel().setValue("tpv_datasourcetype", "A", newEntryRow);
                    this.getModel().setValue("tpv_currencyfield", currency, newEntryRow);
                    this.getModel().setValue("tpv_originalcurrency", amount, newEntryRow);
                    this.getModel().setValue("tpv_original", amount, newEntryRow);
                }
            }
            //业务性质为E信通到期
            QFilter qFiltercdm = new QFilter("draftbillexpiredate", ">=", firstDate);
            qFiltercdm.and(new QFilter("draftbillexpiredate", "<=", lastDate));
            DynamicObjectCollection rowscdm = (DynamicObjectCollection) this.getModel().getValue(KEY_MULBASEDATAFIELD);
            List<Long> idScdm = new ArrayList<>();
            for (DynamicObject row : rowscdm) {
                DynamicObject basedataObj = (DynamicObject) row.getDynamicObject("fbasedataid");
                Long basedataId = (Long) basedataObj.getPkValue();
                idScdm.add(basedataId);
            }
            qFiltercdm.and(new QFilter("company.id", QCP.in, idScdm));
            qFiltercdm.and(new QFilter("draftbilltype.number", QCP.equals, "CDMT-723A8F3D"));
            //票据状态等于已登记时
            qFiltercdm.and(new QFilter("draftbillstatus", QCP.equals, "registered"));
            DynamicObject[] cdmReceivablebill = null;
            cdmReceivablebill = BusinessDataServiceHelper.load("cdm_receivablebill", "id,currency,amount,draftbillexpiredate"
                    , new QFilter[]{qFiltercdm}, null);
            if (cdmReceivablebill.length > 0) {
                for (DynamicObject object : cdmReceivablebill) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_detail");
                    BigDecimal amount = object.getBigDecimal("amount");
                    DynamicObject currency = object.getDynamicObject("currency");
                    Date expiredate = object.getDate("draftbillexpiredate");
                    this.getModel().setValue("tpv_receiptpayment", calculateDate(expiredate), newEntryRow);
                    this.getModel().setValue("tpv_businesstypes", map.get("G"), newEntryRow);
                    this.getModel().setValue("tpv_incomeexpenses", "A", newEntryRow);
                    this.getModel().setValue("tpv_datasourcetype", "A", newEntryRow);
                    this.getModel().setValue("tpv_currencyfield", currency, newEntryRow);
                    this.getModel().setValue("tpv_originalcurrency", amount, newEntryRow);
                }
            }
            DynamicObject[] cdmPayablebills = null;
            cdmPayablebills = BusinessDataServiceHelper.load("cdm_payablebill", "id,currency,amount,draftbillexpiredate"
                    , new QFilter[]{qFiltercdm}, null);
            if (cdmPayablebills.length > 0) {
                for (DynamicObject object : cdmPayablebills) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_detail");
                    BigDecimal amount = object.getBigDecimal("amount");
                    DynamicObject currency = object.getDynamicObject("currency");
                    Date expiredate = object.getDate("draftbillexpiredate");
                    this.getModel().setValue("tpv_receiptpayment", calculateDate(expiredate), newEntryRow);
                    this.getModel().setValue("tpv_businesstypes", map.get("G"), newEntryRow);
                    this.getModel().setValue("tpv_incomeexpenses", "B", newEntryRow);
                    this.getModel().setValue("tpv_datasourcetype", "A", newEntryRow);
                    this.getModel().setValue("tpv_currencyfield", currency, newEntryRow);
                    this.getModel().setValue("tpv_originalcurrency", amount, newEntryRow);
                }
            }
            //业务性质为国内证到期金额
            QFilter qFilterlc = new QFilter("endpaydate", ">=", firstDate);
            qFilterlc.and(new QFilter("endpaydate", "<=", lastDate));
            DynamicObjectCollection rowslc = (DynamicObjectCollection) this.getModel().getValue(KEY_MULBASEDATAFIELD);
            List<Long> idSlc = new ArrayList<>();
            for (DynamicObject row : rowslc) {
                DynamicObject basedataObj = (DynamicObject) row.getDynamicObject("fbasedataid");
                Long basedataId = (Long) basedataObj.getPkValue();
                idSlc.add(basedataId);
            }
            //qFilter.and(new QFilter("company.id", QCP.in, idS));
            //是否国际证
            //qFilterlc.and(new QFilter("draftbillstatus", QCP.equals, "registered"));
            DynamicObject[] lcPresent = null;
            lcPresent = BusinessDataServiceHelper.load("lc_present", "id,currency,todoamount,endpaydate"
                    , new QFilter[]{qFilterlc}, null);
            if (lcPresent.length > 0) {
                for (DynamicObject object : lcPresent) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_detail");
                    BigDecimal amount = object.getBigDecimal("todoamount");
                    DynamicObject currency = object.getDynamicObject("currency");
                    Date expiredate = object.getDate("endpaydate");
                    this.getModel().setValue("tpv_receiptpayment", calculateDate(expiredate), newEntryRow);
                    this.getModel().setValue("tpv_businesstypes", map.get("H"), newEntryRow);
                    this.getModel().setValue("tpv_incomeexpenses", "A", newEntryRow);
                    this.getModel().setValue("tpv_datasourcetype", "A", newEntryRow);
                    this.getModel().setValue("tpv_currencyfield", currency, newEntryRow);
                    this.getModel().setValue("tpv_originalcurrency", amount, newEntryRow);
                }
            }
            DynamicObject[] lcArrival = null;
            lcArrival = BusinessDataServiceHelper.load("lc_arrival", "id,currency,todoamount,endpaydate"
                    , new QFilter[]{qFilterlc}, null);
            if (lcArrival.length > 0) {
                for (DynamicObject object : lcArrival) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_detail");
                    BigDecimal amount = object.getBigDecimal("todoamount");
                    DynamicObject currency = object.getDynamicObject("currency");
                    Date expiredate = object.getDate("endpaydate");
                    this.getModel().setValue("tpv_receiptpayment", calculateDate(expiredate), newEntryRow);
                    this.getModel().setValue("tpv_businesstypes", map.get("H"), newEntryRow);
                    this.getModel().setValue("tpv_incomeexpenses", "B", newEntryRow);
                    this.getModel().setValue("tpv_datasourcetype", "A", newEntryRow);
                    this.getModel().setValue("tpv_currencyfield", currency, newEntryRow);
                    this.getModel().setValue("tpv_originalcurrency", amount, newEntryRow);
                }
            }
            //业务性质为商票到期金额
            QFilter qFilterbill = new QFilter("draftbillexpiredate", ">=", firstDate);
            qFilterbill.and(new QFilter("draftbillexpiredate", "<=", lastDate));
            DynamicObjectCollection rowsbill = (DynamicObjectCollection) this.getModel().getValue(KEY_MULBASEDATAFIELD);
            List<Long> idSbill = new ArrayList<>();
            List<String> numBerbill = new ArrayList<>();
            //票据类型
            numBerbill.add("103");
            numBerbill.add("104");
            for (DynamicObject row : rowsbill) {
                DynamicObject basedataObj = (DynamicObject) row.getDynamicObject("fbasedataid");
                Long basedataId = (Long) basedataObj.getPkValue();
                idSbill.add(basedataId);
            }
            qFilterbill.and(new QFilter("company.id", QCP.in, idS));
            qFilterbill.and(new QFilter("draftbilltype.number", QCP.in, numBerbill));
            //票据状态等于已登记时
            qFilterbill.and(new QFilter("draftbillstatus", QCP.equals, "registered"));
            DynamicObject[] cdmReceivablebills = null;
            cdmReceivablebills = BusinessDataServiceHelper.load("cdm_receivablebill", "id,currency,amount,draftbillexpiredate"
                    , new QFilter[]{qFilterbill}, null);
            if (cdmReceivablebills.length > 0) {
                for (DynamicObject object : cdmReceivablebills) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_detail");
                    BigDecimal amount = object.getBigDecimal("amount");
                    DynamicObject currency = object.getDynamicObject("currency");
                    Date expiredate = object.getDate("draftbillexpiredate");
                    this.getModel().setValue("tpv_receiptpayment", calculateDate(expiredate), newEntryRow);
                    this.getModel().setValue("tpv_businesstypes", map.get("I"), newEntryRow);
                    this.getModel().setValue("tpv_incomeexpenses", "A", newEntryRow);
                    this.getModel().setValue("tpv_datasourcetype", "A", newEntryRow);
                    this.getModel().setValue("tpv_currencyfield", currency, newEntryRow);
                    this.getModel().setValue("tpv_originalcurrency", amount, newEntryRow);
                }
            }
            DynamicObject[] cdmPayablebillst = null;
            cdmPayablebillst = BusinessDataServiceHelper.load("cdm_payablebill", "id,currency,amount,draftbillexpiredate"
                    , new QFilter[]{qFilterbill}, null);
            if (cdmPayablebillst.length > 0) {
                for (DynamicObject object : cdmPayablebillst) {
                    int newEntryRow = this.getModel().createNewEntryRow("tpv_sc_detail");
                    BigDecimal amount = object.getBigDecimal("amount");
                    DynamicObject currency = object.getDynamicObject("currency");
                    Date expiredate = object.getDate("draftbillexpiredate");
                    this.getModel().setValue("tpv_receiptpayment", calculateDate(expiredate), newEntryRow);
                    this.getModel().setValue("tpv_businesstypes", map.get("I"), newEntryRow);
                    this.getModel().setValue("tpv_incomeexpenses", "B", newEntryRow);
                    this.getModel().setValue("tpv_datasourcetype", "A", newEntryRow);
                    this.getModel().setValue("tpv_currencyfield", currency, newEntryRow);
                    this.getModel().setValue("tpv_originalcurrency", amount, newEntryRow);
                }
            }
        }
    }


    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String key = e.getProperty().getName();
        if (key.equals("tpv_businesstypes")) {
            int row = this.getModel().getEntryCurrentRowIndex("tpv_sc_detail");
            String tpv_datasourcetype = this.getModel().getValue("tpv_datasourcetype", row).toString();
            QFilter qfter = null;
            if (tpv_datasourcetype.equals("A")) {//自动
                qfter = new QFilter("tpv_isvoluntarily", QCP.equals, true);
            }
            if (tpv_datasourcetype.equals("B")) {
                qfter = new QFilter("tpv_ismanual", QCP.in, true);
            }
            if (qfter != null) {
                ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
                showParameter.getListFilterParameter().setFilter(qfter);
            }
        }
    }

    public static String calculateDate(Date date) {
        // 将 Date 转换为 Calendar
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);

        // 获取当前月份的第一天
        calendar.set(Calendar.DAY_OF_MONTH, 1);
        int firstDayOfWeek = calendar.get(Calendar.DAY_OF_WEEK);

        // 计算当前月份的第一周开始的日期
        int offset = (firstDayOfWeek - Calendar.SUNDAY) % 7;
        calendar.add(Calendar.DAY_OF_MONTH, -offset);
        Date firstWeekStartDate = calendar.getTime();

        // 计算当前日期是第几周
        long diff = date.getTime() - firstWeekStartDate.getTime();
        int weekOfMonth = (int) (diff / (7 * 24 * 60 * 60 * 1000)) + 1;
        return Integer.toString(weekOfMonth);
    }
}
