package tpv.tpv_wm.tpv_sc.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.control.events.BeforeClickEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * @Description:部门资金额度部门唯一 基础资料过滤
 * @Auther: zbh
 */
public class DelimittabFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

    private static final String BUTTON_SAVE = "tpv_btnsave";
    private static final String BUTTON_SAVENEW = "tpv_btnsaveandnew";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);

        this.addClickListeners(BUTTON_SAVE, BUTTON_SAVENEW);
        BasedataEdit org =this.getView().getControl("tpv_department");
        org.addBeforeF7SelectListener(this);
    }
    @Override
    public void beforeClick(BeforeClickEvent evt) {
        super.beforeClick(evt);
        boolean sole = this.sole();
        if (sole) {
            evt.setCancel(true);
        }
    }

    /*
         */

    /**
     * @Title: sole
     * @Descripton:   存在唯一一条生效数据
     * @reurn: a
     */
    public boolean sole() {

        DynamicObject department = (DynamicObject) this.getModel().getValue("tpv_department");//部门
        String enab = (String) this.getModel().getValue("enable");//是否生效
        //查询数据
        DynamicObject[] queryYX = BusinessDataServiceHelper.load("tpv_sc_delimittab", "tpv_department,enable", null);

        for (DynamicObject initial : queryYX) {
            DynamicObject departmens = initial.getDynamicObject("tpv_department");
            if (department.equals(departmens)) {
                String enable = (String) initial.get("enable");
                if ("1".equals(enab) && "1".equals(enable)) {
                    this.getView().showErrorNotification("已存在生效数据!");
                    return true;
                }
            }
        }
        return false;
    }
    /*
      基础资料过滤
     */
    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            //组织过滤
            case "tpv_department":
                qFilterOrg(e);
                break;
        }

    }

    /**
     * @Title: qFilterOrg
     * @Descripton: 对组织进行过滤
     * @reurn: a
     */
    private void qFilterOrg(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        //构造过滤条件(组织形态.名称=授信)
        QFilters.add(new QFilter("orgpattern.name", QCP.equals, "部门")); //设置过滤条件：形态
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }
}
