package tpv.tpv_wm.tpv_sc.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;

import java.util.Date;

/**
 * ClassName: DeptFundLimitEdit
 * Description:  部门资金临时额度表单插件
 * date: 2023/9/4 16:26
 *
 * @author: Guo jiaChen
 * @version:
 * @since JDK 1.8
 */
public class DeptFundLimitFormPlugin extends AbstractBillPlugIn {
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String key = e.getProperty().getName();
        switch (key) {
            case "tpv_quiotastdate":
            case "tpv_quotaenddate":
                judgeTime(key);
        }
    }

    /**
     * 判断起始日期是否小于截至日期
     */
    private void judgeTime(String key) {

        Date endDate = (Date) this.getModel().getValue("tpv_quotaenddate");//截至日期
        Date startDate = (Date) this.getModel().getValue("tpv_quiotastdate");//起始日期
        if (startDate != null && endDate != null) {
            if (startDate.compareTo(endDate) >= 0) {
                this.getView().showTipNotification("额度使用截至日期不能小于起始日期,请重新选择!");
                if ("tpv_quiotastdate".equals(key)) {
                    this.getModel().setValue("tpv_quiotastdate", null);
                } else {
                    this.getModel().setValue("tpv_quotaenddate", null);
                }

            }
        }
    }
}