package tpv.tpv_wm.tpv_sc.java.formplugin.form;

import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.IFormView;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.permission.api.HasPermOrgResult;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import tpv.tpv_wm.tpv_sc.java.report.DeptFundsPoolQueryRpt;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @Description: 部门资金池 -表单插件
 * @Author LinRui
 * @Date 2024/2/27 14:52
 */
public class DeptFundsPoolFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {
    private static final String algoKey = DeptFundsPoolFormPlugin.class.getName();
    private static final String entryKey_2 = "tpv_sc_fundspool_tol"; //资金汇总
    private static final String entryKey_1 = "tpv_sc_fundspool_info"; //资金明细
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_advcontoolbarap");
        BasedataEdit tpv_departmentf = this.getControl("tpv_departmentf");//部门
        tpv_departmentf.addBeforeF7SelectListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_departmentf":
                //过滤资金占用利率本月维护的部门
                break;
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        switch (itemKey) {
            case "tpv_depfundsuse":
                int i = depfundsuseClick();
                if(i == 1) entryRecalculate(); //资金明细分录重新计算
                if(i == 1) entryTotalData(); //资金汇总分录汇总资金明细分录数据
                break;
            case "tpv_depfundsdel":
                this.getModel().deleteEntryData(entryKey_1);
                this.getModel().deleteEntryData(entryKey_2);
                break;
            default:
                break;
        }
    }

    private void entryTotalData() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        OperationResult saveOperate = OperationServiceHelper.executeOperate("save", this.getView().getEntityId(), new DynamicObject[]{dataEntity}, YEM.getOptionNoMsg());
        if (saveOperate.isSuccess()) {
            String selectfields = "tpv_sc_fundspool_info,tpv_sc_fundspool_info.tpv_businessdate tpv_businessdate," +
                    "tpv_sc_fundspool_info.tpv_companys tpv_companyss," +
                    "tpv_sc_fundspool_info.tpv_departments tpv_departmentss," +
                    "tpv_sc_fundspool_info.tpv_cashaddamt tpv_cashaddamts," +
                    "tpv_sc_fundspool_info.tpv_cashlessamt tpv_cashlessamts," +
                    "tpv_sc_fundspool_info.tpv_cashoccupamt tpv_cashoccupamts," +
                    "tpv_sc_fundspool_info.tpv_cashinamt tpv_cashinamts," +
                    "tpv_sc_fundspool_info.tpv_receiveaddamt tpv_receiveaddamts," +
                    "tpv_sc_fundspool_info.tpv_receivelessamt tpv_receivelessamts," +
                    "tpv_sc_fundspool_info.tpv_receiveoccupamt tpv_receiveoccupamts," +
                    "tpv_sc_fundspool_info.tpv_receiveinamt tpv_receiveinamts," +
                    "tpv_sc_fundspool_info.tpv_payaddamt tpv_payaddamts," +
                    "tpv_sc_fundspool_info.tpv_paylessamt tpv_paylessamts," +
                    "tpv_sc_fundspool_info.tpv_payoccupamt tpv_payoccupamts," +
                    "tpv_sc_fundspool_info.tpv_payinamt tpv_payinamts," +
                    "tpv_sc_fundspool_info.tpv_cprcvaddamt tpv_cprcvaddamts," +
                    "tpv_sc_fundspool_info.tpv_cprcvlessamt tpv_cprcvlessamts," +
                    "tpv_sc_fundspool_info.tpv_cprcvoccupamt tpv_cprcvoccupamts," +
                    "tpv_sc_fundspool_info.tpv_cprcvinamt tpv_cprcvinamts," +
                    "tpv_sc_fundspool_info.tpv_cppayaddamt tpv_cppayaddamts," +
                    "tpv_sc_fundspool_info.tpv_cppaylessamt tpv_cppaylessamts," +
                    "tpv_sc_fundspool_info.tpv_cppayoccupamt tpv_cppayoccupamts," +
                    "tpv_sc_fundspool_info.tpv_cppayinamt tpv_cppayinamts," +
                    "tpv_sc_fundspool_info.tpv_scmproaddamt tpv_scmproaddamts," +
                    "tpv_sc_fundspool_info.tpv_scmprolessamt tpv_scmprolessamts," +
                    "tpv_sc_fundspool_info.tpv_scmprooccupamt tpv_scmprooccupamts," +
                    "tpv_sc_fundspool_info.tpv_scmproinamt tpv_scmproinamts," +
                    "tpv_sc_fundspool_info.tpv_chinaaddamt tpv_chinaaddamts," +
                    "tpv_sc_fundspool_info.tpv_chinalessamt tpv_chinalessamts," +
                    "tpv_sc_fundspool_info.tpv_chinaoccupamt tpv_chinaoccupamts," +
                    "tpv_sc_fundspool_info.tpv_chinainamt tpv_chinainamts";
            DataSet dataSet = ORM.create().queryDataSet(algoKey, "tpv_sc_deptfundspool", selectfields,
                    new QFilter[]{new QFilter("id", QCP.equals, dataEntity.getPkValue()),
                            new QFilter("tpv_sc_fundspool_info", QCP.large_than, 0)});
            dataSet = dataSet.addField("to_char(tpv_businessdate,'yyyy-MM') tpv_days","tpv_days");
            dataSet = dataSet.groupBy(new String[]{"tpv_companyss","tpv_departmentss","tpv_days"})
                    .sum("tpv_cashaddamts").sum("tpv_cashlessamts").sum("tpv_cashoccupamts").sum("tpv_cashinamts")
                    .sum("tpv_receiveaddamts").sum("tpv_receivelessamts").sum("tpv_receiveoccupamts").sum("tpv_receiveinamts")
                    .sum("tpv_payaddamts").sum("tpv_paylessamts").sum("tpv_payoccupamts").sum("tpv_payinamts")
                    .sum("tpv_cprcvaddamts").sum("tpv_cprcvlessamts").sum("tpv_cprcvoccupamts").sum("tpv_cprcvinamts")
                    .sum("tpv_cppayaddamts").sum("tpv_cppaylessamts").sum("tpv_cppayoccupamts").sum("tpv_cppayinamts")
                    .sum("tpv_scmproaddamts").sum("tpv_scmprolessamts").sum("tpv_scmprooccupamts").sum("tpv_scmproinamts")
                    .sum("tpv_chinaaddamts").sum("tpv_chinalessamts").sum("tpv_chinaoccupamts").sum("tpv_chinainamts")
                    .finish();
            IDataModel model = this.getModel();
            model.deleteEntryData(entryKey_2);
            DynamicObjectType enrtyType = model.getEntryEntity(entryKey_2).getDynamicObjectType();
            DataEntityPropertyCollection properties = enrtyType.getProperties();
            List<String> dataSetAliasList = RptUtil.getDataSetAliasList(dataSet);
            for (Row row : dataSet) {
                int index = model.createNewEntryRow(entryKey_2);
                for (IDataEntityProperty property : properties) {
                    String key = property.getName();
                    if (dataSetAliasList.contains(key)) {
                        model.setValue(key, row.get(key), index);
                    }
                }
            }
        } else {
            this.getModel().deleteEntryData(entryKey_1);
            this.getModel().deleteEntryData(entryKey_2);
            this.getView().showTipNotification("自动保存失败。请检验重新生成数据" + YEM.getOpMsg(saveOperate));
        }
    }

    private void entryRecalculate() {
        IDataModel model = getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        Date tpvYear = dataEntity.getDate("tpv_year");
        String tpvMonth = dataEntity.getString("tpv_month");
        Map<String,Map<String, BigDecimal>> map = new HashMap<>();
        Date dayStartTime = null;
        Date dayEndTime = null;
        if (YEM.isNotEmpty(tpvMonth) && null != tpvYear) {
            int i = monthConvertInt(tpvMonth);
            Calendar ca = Calendar.getInstance();
            ca.setTime(tpvYear);
            ca.set(2, i - 1);
            Date monthFirstDay = DateUtil.getMonthFirstDay(ca.getTime()); //当前 年 当前 月的第一天
            Date monthToEndDay = DateUtil.getMonthEndDay(ca.getTime()); //当前 年 当前 月的最后一天
            dayStartTime = getDayStartTime(monthFirstDay);
            dayEndTime = getDayEndTime(monthToEndDay);
        }
        DataSet tpv_sc_deptfundspool = ORM.create().queryDataSet(algoKey, "tpv_sc_deptfundspool", "tpv_sc_fundspool_info.tpv_departments deptid",
                new QFilter[]{new QFilter("id", QCP.not_equals, dataEntity.getPkValue()),
                        new QFilter("billstatus", QCP.equals, "C"),
                        new QFilter("tpv_sc_fundspool_info.tpv_businessdate", QCP.large_than, dayStartTime),
                        new QFilter("tpv_sc_fundspool_info.tpv_businessdate", QCP.less_equals, dayEndTime)}).distinct();
        List<Long> deptIdList = new ArrayList<>();
        for (Row row : tpv_sc_deptfundspool) {
            deptIdList.add(row.getLong("deptid"));
        }

        if (YEM.isNotEmpty(tpvMonth) && null != tpvYear) {
            int i = monthConvertInt(tpvMonth);
            Calendar ca = Calendar.getInstance();
            ca.setTime(tpvYear);
            ca.set(2, i - 2);
            ca.set(5, ca.getActualMaximum(5));
            Date monthToEndDay = ca.getTime(); //当前 年 当前 月的最后一天
            dayStartTime = getDayStartTime(monthToEndDay);
            dayEndTime = getDayEndTime(monthToEndDay);
        }
        if (YEM.isNotEmpty(dayStartTime) && YEM.isNotEmpty(dayEndTime)) {
            String selectfields = "tpv_sc_fundspool_info,tpv_sc_fundspool_info.tpv_businessdate tpv_businessdate," +
                    "tpv_sc_fundspool_info.tpv_companys tpv_companys," +
                    "tpv_sc_fundspool_info.tpv_departments tpv_departments," +
                    "tpv_sc_fundspool_info.tpv_cashoccupamt tpv_cashoccupamt," +
                    "tpv_sc_fundspool_info.tpv_receiveoccupamt tpv_receiveoccupamt," +
                    "tpv_sc_fundspool_info.tpv_payoccupamt tpv_payoccupamt," +
                    "tpv_sc_fundspool_info.tpv_cprcvoccupamt tpv_cprcvoccupamt," +
                    "tpv_sc_fundspool_info.tpv_cppayoccupamt tpv_cppayoccupamt," +
                    "tpv_sc_fundspool_info.tpv_scmprooccupamt tpv_scmprooccupamt," +
                    "tpv_sc_fundspool_info.tpv_chinaoccupamt tpv_chinaoccupamt";
            List<QFilter> qFilter = new ArrayList<>();
            qFilter.add(new QFilter("billstatus", QCP.equals, "C"));
            qFilter.add(new QFilter("tpv_sc_fundspool_info.tpv_businessdate", QCP.large_equals, dayStartTime));
            qFilter.add(new QFilter("tpv_sc_fundspool_info.tpv_businessdate", QCP.less_equals, dayEndTime));
            qFilter.add(new QFilter("tpv_sc_fundspool_info",QCP.large_than,0));
            DataSet dataSet = ORM.create().queryDataSet(algoKey, "tpv_sc_deptfundspool", selectfields , qFilter.toArray(new QFilter[qFilter.size()]));
            dataSet = dataSet.select("tpv_businessdate", "tpv_companys", "tpv_departments", "tpv_cashoccupamt", "tpv_receiveoccupamt",
                    "tpv_payoccupamt", "tpv_cprcvoccupamt", "tpv_cppayoccupamt", "tpv_scmprooccupamt", "tpv_chinaoccupamt",
                    "to_char(tpv_businessdate,'yyyy-MM-dd') tpv_day");
            dataSet = dataSet.groupBy(new String[]{"tpv_companys", "tpv_departments","tpv_day"})
                    .sum("tpv_cashoccupamt").sum("tpv_receiveoccupamt").sum("tpv_payoccupamt").sum("tpv_cprcvoccupamt")
                    .sum("tpv_cppayoccupamt").sum("tpv_scmprooccupamt").sum("tpv_chinaoccupamt").finish();
            for (Row row : dataSet) {
                Map<String,BigDecimal> decimalMap = new HashMap<>();
                String tpvCompanys = row.getString("tpv_companys");
                String tpvDepertment = row.getString("tpv_departments");
                BigDecimal tpvOccupied = row.getBigDecimal("tpv_cashoccupamt") != null ? row.getBigDecimal("tpv_cashoccupamt") : BigDecimal.ZERO;
                BigDecimal tpvOccupyamt = row.getBigDecimal("tpv_receiveoccupamt") != null ? row.getBigDecimal("tpv_receiveoccupamt") : BigDecimal.ZERO;
                BigDecimal tpvHoldamt = row.getBigDecimal("tpv_payoccupamt") != null ? row.getBigDecimal("tpv_payoccupamt") : BigDecimal.ZERO;
                BigDecimal tpvUseamt = row.getBigDecimal("tpv_cprcvoccupamt") != null ? row.getBigDecimal("tpv_cprcvoccupamt") : BigDecimal.ZERO;
                BigDecimal tpvNeedamt = row.getBigDecimal("tpv_cppayoccupamt") != null ? row.getBigDecimal("tpv_cppayoccupamt") : BigDecimal.ZERO;
                BigDecimal tpvAccamt = row.getBigDecimal("tpv_scmprooccupamt") != null ? row.getBigDecimal("tpv_scmprooccupamt") : BigDecimal.ZERO;
                BigDecimal tpvChinaoccupamt = row.getBigDecimal("tpv_chinaoccupamt") != null ? row.getBigDecimal("tpv_chinaoccupamt") : BigDecimal.ZERO;
                String strOrgDept = tpvCompanys + tpvDepertment;
                decimalMap.put("tpv_cashoccupamt",tpvOccupied);decimalMap.put("tpv_receiveoccupamt",tpvOccupyamt);
                decimalMap.put("tpv_payoccupamt",tpvHoldamt);decimalMap.put("tpv_cprcvoccupamt",tpvUseamt);
                decimalMap.put("tpv_cppayoccupamt",tpvNeedamt);decimalMap.put("tpv_scmprooccupamt",tpvAccamt);
                decimalMap.put("tpv_chinaoccupamt",tpvChinaoccupamt);
                map.put(strOrgDept,decimalMap);
            }
        }
        DynamicObjectCollection entryData = this.getModel().getEntryEntity(entryKey_1);
        List<Integer> rowIdList = new ArrayList<>();
        if (entryData.size() > 0) {
            for (int i = 0; i < entryData.size(); i++) {
                DynamicObject dynamicObject = entryData.get(i);
                BigDecimal tpv_cashinamt = BigDecimal.ZERO;  BigDecimal tpv_receiveinamt = BigDecimal.ZERO;
                BigDecimal tpv_payinamt = BigDecimal.ZERO;  BigDecimal tpv_cprcvinamt = BigDecimal.ZERO;
                BigDecimal tpv_cppayinamt = BigDecimal.ZERO;  BigDecimal tpv_scmproinamt = BigDecimal.ZERO;
                BigDecimal tpv_chinainamt = BigDecimal.ZERO;

                BigDecimal tpv_cashaddamt = dynamicObject.getBigDecimal("tpv_cashaddamt");//增加(现款)
                BigDecimal tpv_cashlessamt = dynamicObject.getBigDecimal("tpv_cashlessamt");//减少(现款)
                BigDecimal tpvCashaddrate = dynamicObject.getBigDecimal("tpv_cashaddrate"); //日利率(%)
                BigDecimal tpvCashlessrate = dynamicObject.getBigDecimal("tpv_cashlessrate"); //负占用利率(%)
                BigDecimal tpv_cashoccupamt = dynamicObject.getBigDecimal("tpv_cashoccupamt");

                BigDecimal tpv_receiveaddamt = dynamicObject.getBigDecimal("tpv_receiveaddamt");//增加(应收票据（银承）)
                BigDecimal tpv_receivelessamt = dynamicObject.getBigDecimal("tpv_receivelessamt");//减少(应收票据（银承）)
                BigDecimal tpvReceiveaddrate = dynamicObject.getBigDecimal("tpv_receiveaddrate"); //日利率(%)
                BigDecimal tpvReceivelessrate = dynamicObject.getBigDecimal("tpv_receivelessrate"); //负占用利率(%)
                BigDecimal tpv_receiveoccupamt = dynamicObject.getBigDecimal("tpv_receiveoccupamt");

                BigDecimal tpv_payaddamt = dynamicObject.getBigDecimal("tpv_payaddamt");//增加(应付票据（银承）)
                BigDecimal tpv_paylessamt = dynamicObject.getBigDecimal("tpv_paylessamt");//减少(应付票据（银承）)
                BigDecimal tpvPayaddrate = dynamicObject.getBigDecimal("tpv_payaddrate"); //日利率(%)
                BigDecimal tpvPaylessrate = dynamicObject.getBigDecimal("tpv_paylessrate"); //负占用利率(%)
                BigDecimal tpv_payoccupamt = dynamicObject.getBigDecimal("tpv_payoccupamt");

                BigDecimal tpv_cprcvaddamt = dynamicObject.getBigDecimal("tpv_cprcvaddamt");//增加(应收票据（商票）)
                BigDecimal tpv_cprcvlessamt = dynamicObject.getBigDecimal("tpv_cprcvlessamt");//减少(应收票据（商票）)
                BigDecimal tpvCprcvddrate = dynamicObject.getBigDecimal("tpv_cprcvddrate"); //日利率(%)
                BigDecimal tpvCprcvlessrate = dynamicObject.getBigDecimal("tpv_cprcvlessrate"); //负占用利率(%)
                BigDecimal tpv_cprcvoccupamt = dynamicObject.getBigDecimal("tpv_cprcvoccupamt");

                BigDecimal tpv_cppayaddamt = dynamicObject.getBigDecimal("tpv_cppayaddamt");//增加(应付票据（商票）)
                BigDecimal tpv_cppaylessamt = dynamicObject.getBigDecimal("tpv_cppaylessamt");//减少(应付票据（商票）)
                BigDecimal tpvCppayaddrate = dynamicObject.getBigDecimal("tpv_cppayaddrate"); //日利率(%)
                BigDecimal tpvCppaylessrate = dynamicObject.getBigDecimal("tpv_cppaylessrate"); //负占用利率(%)
                BigDecimal tpv_cppayoccupamt = dynamicObject.getBigDecimal("tpv_cppayoccupamt");

                BigDecimal tpv_scmproaddamt = dynamicObject.getBigDecimal("tpv_scmproaddamt");//增加(供应链票据)
                BigDecimal tpv_scmprolessamt = dynamicObject.getBigDecimal("tpv_scmprolessamt");//减少(供应链票据)
                BigDecimal tpvScmproaddrate = dynamicObject.getBigDecimal("tpv_scmproaddrate"); //日利率(%)
                BigDecimal tpvScmprolessrate = dynamicObject.getBigDecimal("tpv_scmprolessrate"); //负占用利率(%)
                BigDecimal tpv_scmprooccupamt = dynamicObject.getBigDecimal("tpv_scmprooccupamt");

                BigDecimal tpv_chinaaddamt = dynamicObject.getBigDecimal("tpv_chinaaddamt");//增加(国内证占用费)
                BigDecimal tpv_chinalessamt = dynamicObject.getBigDecimal("tpv_chinalessamt");//减少(国内证占用费)
                BigDecimal tpvChinaaddrate = dynamicObject.getBigDecimal("tpv_chinaaddrate"); //日利率(%)
                BigDecimal tpvChinalessrate = dynamicObject.getBigDecimal("tpv_chinalessrate"); //负占用利率(%)
                BigDecimal tpv_chinaoccupamt = dynamicObject.getBigDecimal("tpv_chinaoccupamt");

                Date tpvBusinessdate = dynamicObject.getDate("tpv_businessdate");
                SimpleDateFormat strDay = new SimpleDateFormat("yyyy-MM-dd");
                String format = strDay.format(tpvBusinessdate);
                String[] split = format.split("-");
                DynamicObject tpvCompanys = dynamicObject.getDynamicObject("tpv_companys");
                DynamicObject tpvDepartments = dynamicObject.getDynamicObject("tpv_departments");
                String tpvCompanysId = "";
                String tpvDepartmentsId = "";
                if (YEM.isNotEmpty(tpvCompanys)) {
                    tpvCompanysId = tpvCompanys.getString("id");
                }
                if (YEM.isNotEmpty(tpvDepartments)) {
                    tpvDepartmentsId = tpvDepartments.getString("id");
                    Long deptid = Long.valueOf(tpvDepartmentsId);
                    if (deptIdList.contains(deptid)) {
                        rowIdList.add(i);
                    }
                }
                String strOrgDept = tpvCompanysId + tpvDepartmentsId;
                if ("01".equals(split[2]) && map.containsKey(strOrgDept)) {
                    tpv_cashoccupamt = tpv_cashaddamt.subtract(tpv_cashlessamt).add(tpv_cashoccupamt).add(map.get(strOrgDept).get("tpv_cashoccupamt"));
                    tpv_cashinamt = tpv_cashoccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_cashoccupamt.multiply(tpvCashaddrate)
                            : tpv_cashoccupamt.multiply(tpvCashlessrate);
                    tpv_receiveoccupamt = tpv_receiveaddamt.subtract(tpv_receivelessamt).add(tpv_receiveoccupamt).add(map.get(strOrgDept).get("tpv_receiveoccupamt"));
                    tpv_receiveinamt = tpv_receiveoccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_receiveoccupamt.multiply(tpvReceiveaddrate)
                            : tpv_receiveoccupamt.multiply(tpvReceivelessrate);
                    tpv_payoccupamt = tpv_paylessamt.subtract(tpv_payaddamt).add(tpv_payoccupamt).add(map.get(strOrgDept).get("tpv_payoccupamt"));
                    tpv_payinamt = tpv_payoccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_payoccupamt.multiply(tpvPayaddrate)
                            : tpv_payoccupamt.multiply(tpvPaylessrate);
                    tpv_cprcvoccupamt = tpv_cprcvaddamt.subtract(tpv_cprcvlessamt).add(tpv_cprcvoccupamt).add(map.get(strOrgDept).get("tpv_cprcvoccupamt"));
                    tpv_cprcvinamt = tpv_cprcvoccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_cprcvoccupamt.multiply(tpvCprcvddrate)
                            : tpv_cprcvoccupamt.multiply(tpvCprcvlessrate);
                    tpv_cppayoccupamt = tpv_cppaylessamt.subtract(tpv_cppayaddamt).add(tpv_cppayoccupamt).add(map.get(strOrgDept).get("tpv_cppayoccupamt"));
                    tpv_cppayinamt = tpv_cppayoccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_cppayoccupamt.multiply(tpvCppayaddrate)
                            : tpv_cppayoccupamt.multiply(tpvCppaylessrate);
                    tpv_scmprooccupamt = tpv_scmproaddamt.subtract(tpv_scmprolessamt).add(tpv_scmprooccupamt).add(map.get(strOrgDept).get("tpv_scmprooccupamt"));
                    tpv_scmproinamt = tpv_scmprooccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_scmprooccupamt.multiply(tpvScmproaddrate)
                            : tpv_scmprooccupamt.multiply(tpvScmprolessrate);
                    tpv_chinaoccupamt = tpv_chinaaddamt.subtract(tpv_chinalessamt).add(tpv_chinaoccupamt).add(map.get(strOrgDept).get("tpv_chinaoccupamt"));
                    tpv_chinainamt = tpv_chinaoccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_chinaoccupamt.multiply(tpvChinaaddrate)
                            : tpv_chinaoccupamt.multiply(tpvChinalessrate);
                } else {
                    if (i != 0) {
                        int indexUp = i - 1;
                        DynamicObject tpvCompanysN = (DynamicObject) this.getModel().getValue("tpv_companys",indexUp);
                        DynamicObject tpvDepartmentsN =  (DynamicObject) this.getModel().getValue("tpv_departments",indexUp);
                        String tpvCompanysNId = "";
                        String tpvDepartmentsNId = "";
                        if (YEM.isNotEmpty(tpvCompanysN)) {
                            tpvCompanysNId = tpvCompanysN.getString("id");
                        }
                        if (YEM.isNotEmpty(tpvDepartmentsN)) {
                            tpvDepartmentsNId = tpvDepartmentsN.getString("id");
                        }
                        String strOrgDeptN = tpvCompanysNId + tpvDepartmentsNId;
                        if (strOrgDeptN.equals(strOrgDept)) {
                            tpv_cashoccupamt = (BigDecimal) this.getModel().getValue("tpv_cashoccupamt",indexUp);
                            tpv_receiveoccupamt = (BigDecimal) this.getModel().getValue("tpv_receiveoccupamt",indexUp);
                            tpv_payoccupamt = (BigDecimal) this.getModel().getValue("tpv_payoccupamt",indexUp);
                            tpv_cprcvoccupamt = (BigDecimal) this.getModel().getValue("tpv_cprcvoccupamt",indexUp);
                            tpv_cppayoccupamt = (BigDecimal) this.getModel().getValue("tpv_cppayoccupamt",indexUp);
                            tpv_scmprooccupamt = (BigDecimal) this.getModel().getValue("tpv_scmprooccupamt",indexUp);
                            tpv_chinaoccupamt = (BigDecimal) this.getModel().getValue("tpv_chinaoccupamt",indexUp);
                        }
                    }
                    tpv_cashoccupamt = tpv_cashaddamt.subtract(tpv_cashlessamt).add(tpv_cashoccupamt).add(tpv_cashoccupamt);
                    tpv_cashinamt = tpv_cashoccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_cashoccupamt.multiply(tpvCashaddrate)
                            : tpv_cashoccupamt.multiply(tpvCashlessrate);
                    tpv_receiveoccupamt = tpv_receiveaddamt.subtract(tpv_receivelessamt).add(tpv_receiveoccupamt).add(tpv_receiveoccupamt);
                    tpv_receiveinamt = tpv_receiveoccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_receiveoccupamt.multiply(tpvReceiveaddrate)
                            : tpv_receiveoccupamt.multiply(tpvReceivelessrate);
                    tpv_payoccupamt = tpv_paylessamt.subtract(tpv_payaddamt).add(tpv_payoccupamt).add(tpv_payoccupamt);
                    tpv_payinamt = tpv_payoccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_payoccupamt.multiply(tpvPayaddrate)
                            : tpv_payoccupamt.multiply(tpvPaylessrate);
                    tpv_cprcvoccupamt = tpv_cprcvaddamt.subtract(tpv_cprcvlessamt).add(tpv_cprcvoccupamt).add(tpv_cprcvoccupamt);
                    tpv_cprcvinamt = tpv_cprcvoccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_cprcvoccupamt.multiply(tpvCprcvddrate)
                            : tpv_cprcvoccupamt.multiply(tpvCprcvlessrate);
                    tpv_cppayoccupamt = tpv_cppaylessamt.subtract(tpv_cppayaddamt).add(tpv_cppayoccupamt).add(tpv_cppayoccupamt);
                    tpv_cppayinamt = tpv_cppayoccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_cppayoccupamt.multiply(tpvCppayaddrate)
                            : tpv_cppayoccupamt.multiply(tpvCppaylessrate);
                    tpv_scmprooccupamt = tpv_scmproaddamt.subtract(tpv_scmprolessamt).add(tpv_scmprooccupamt).add(tpv_scmprooccupamt);
                    tpv_scmproinamt = tpv_scmprooccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_scmprooccupamt.multiply(tpvScmproaddrate)
                            : tpv_scmprooccupamt.multiply(tpvScmprolessrate);
                    tpv_chinaoccupamt = tpv_chinaaddamt.subtract(tpv_chinalessamt).add(tpv_chinaoccupamt).add(tpv_chinaoccupamt);
                    tpv_chinainamt = tpv_chinaoccupamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_chinaoccupamt.multiply(tpvChinaaddrate)
                            : tpv_chinaoccupamt.multiply(tpvChinalessrate);
                }
                this.getModel().setValue("tpv_cashoccupamt",tpv_cashoccupamt,i); //占用金额(现款)
                this.getModel().setValue("tpv_cashinamt",tpv_cashinamt,i); //利息(现款)
                this.getModel().setValue("tpv_receiveoccupamt",tpv_receiveoccupamt,i); //占用金额(应收票据（银承）)
                this.getModel().setValue("tpv_receiveinamt",tpv_receiveinamt,i); //利息(应收票据（银承）)
                this.getModel().setValue("tpv_payoccupamt",tpv_payoccupamt,i); //占用金额(应付票据（银承）)
                this.getModel().setValue("tpv_payinamt",tpv_payinamt,i); //利息(应付票据（银承）)
                this.getModel().setValue("tpv_cprcvoccupamt",tpv_cprcvoccupamt,i); //占用金额(应收票据（商票）)
                this.getModel().setValue("tpv_cprcvinamt",tpv_cprcvinamt,i); //利息(应收票据（商票）)
                this.getModel().setValue("tpv_cppayoccupamt",tpv_cppayoccupamt,i); //占用金额(应付票据（商票）)
                this.getModel().setValue("tpv_cppayinamt",tpv_cppayinamt,i); //利息(应付票据（商票）)
                this.getModel().setValue("tpv_scmprooccupamt",tpv_scmprooccupamt,i); //占用金额(供应链票据)
                this.getModel().setValue("tpv_scmproinamt",tpv_scmproinamt,i); //利息(供应链票据)
                this.getModel().setValue("tpv_chinaoccupamt",tpv_chinaoccupamt,i); //占用金额(国内证占用费)
                this.getModel().setValue("tpv_chinainamt",tpv_chinainamt,i); //利息(国内证占用费)
            }
            int[] rowIds = rowIdList.stream().mapToInt(Integer::intValue).toArray();
            this.getModel().deleteEntryRows(entryKey_1, rowIds);
            this.getView().updateView();
        }
    }

    private int depfundsuseClick() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        List<String> notInputs = new ArrayList<>();
        YEM.getNotNull(view, notInputs, dataEntity, "tpv_company");
        YEM.getNotNull(view, notInputs, dataEntity, "tpv_year");
        YEM.getNotNull(view, notInputs, dataEntity, "tpv_month");
        if (notInputs.size() > 0) {
            view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
            return 0;
        } else {
            depfundsuseData();
        }
        return 1;
    }

    private void depfundsuseData() {
        IFormView view = this.getView();
        IDataModel model = view.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        String whereFilter = "1=1";
        //公司
        DynamicObject tpvCompany = dataEntity.getDynamicObject("tpv_company");
        if (null != tpvCompany){
            whereFilter = String.format("%s and tpv_companys = %s", whereFilter, tpvCompany.getLong("id"));
        }
        else {
            HasPermOrgResult userChangeAbleOrg = YEM.getUserChangeAbleOrg();
            if (!userChangeAbleOrg.hasAllOrgPerm()) {
                List<String> ids = YEM.getUserChangeAbleOrgIds().stream().map(x -> String.valueOf(x))
                        .collect(Collectors.toList());
                whereFilter = String.format("%s and tpv_companys in (%s)", whereFilter, String.join(",", ids));
            }
        }
        DynamicObject tpvDepartmentf = dataEntity.getDynamicObject("tpv_departmentf");
        if (null != tpvDepartmentf){
            whereFilter = String.format("%s and tpv_departments = %s", whereFilter, tpvDepartmentf.getLong("id"));
        }
        Date tpvYear = dataEntity.getDate("tpv_year");
        SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String tpvMonth = dataEntity.getString("tpv_month");
        String format =  "》";
        if (YEM.isNotEmpty(tpvMonth) && null != tpvYear) {
            int i = monthConvertInt(tpvMonth);
            Calendar ca = Calendar.getInstance();
            ca.setTime(tpvYear);
            ca.set(2, i - 1);
            Date monthFirstDay = DateUtil.getMonthFirstDay(ca.getTime());
            Date monthToEndDay = DateUtil.getMonthEndDay(ca.getTime()); //当前 年 当前 月的最后一天
            Date dayStartTime = getDayStartTime(monthFirstDay);
            Date dayEndTime = getDayEndTime(monthToEndDay);
            String formatStart =  str.format(dayStartTime);
            String formatEnd =  str.format(dayEndTime);
            format = format + formatStart + "》" + formatEnd;
            whereFilter = String.format("%s and tpv_businessdate >= to_date('" + formatStart + "','yyyy-MM-dd HH:mm:ss')", whereFilter);
            whereFilter = String.format("%s and tpv_businessdate <= to_date('" + formatEnd + "','yyyy-MM-dd HH:mm:ss')", whereFilter);
        }
        whereFilter = whereFilter + format;
        DataSet query = DeptFundsPoolQueryRpt.query(whereFilter);
        model.deleteEntryData(entryKey_1);   //清除分录
        model.deleteEntryData(entryKey_2);   //清除分录
        DynamicObjectType enrtyType = model.getEntryEntity(entryKey_1).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow(entryKey_1);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    /**
     * @Description: //将月份数值转为整数
     * @param: month
     **/
    private int monthConvertInt(String month) {
        if (YEM.isNotEmpty(month)) {
            int i = 0;
            switch (month) {
                case "Jan": i = 1;break; case "Feb": i = 2;break; case "Mar": i = 3;break;
                case "Apr": i = 4;break; case "May": i = 5;break; case "Jun": i = 6;break;
                case "Jul": i = 7;break; case "Aug": i = 8;break; case "Sep": i = 9;break;
                case "Oct": i = 10;break; case "Nov": i = 11;break; case "Dec": i = 12;break;
                default:
                    break;
            }
            return i;
        }
        return 0;
    }

    /**
     * 获取日期的结束时间
     */
    public static Date getDayEndTime(Date date) {
        if (date == null) {
            return null;
        } else {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(date);
            calendar.set(calendar.get(1), calendar.get(2), calendar.get(5), 23, 59, 59);
            calendar.set(14, 999);
            return calendar.getTime();
        }
    }

    /**
     * 获取该日期的开始时间
     */
    public static Date getDayStartTime(Date date) {
        if (date == null) {
            return null;
        } else {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(date);
            calendar.set(calendar.get(1), calendar.get(2), calendar.get(5), 0, 0, 0);
            calendar.set(14, 0);
            return calendar.getTime();
        }
    }

}
