package tpv.tpv_wm.tpv_sc.java.formplugin.form;

import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

/**
 * @Description: 部门比例 -表单插件
 * @Author LinRui
 * @Date 2024/3/12 16:37
 */
public class DeptProportionFormPlugin extends AbstractBillPlugIn {
    @Override
    public void propertyChanged(PropertyChangedArgs evt) {// 值更新事件
        super.propertyChanged(evt);
        IDataModel model = this.getModel();
        String name = evt.getProperty().getName();
        switch (name) {
            case "tpv_department":
                DynamicObject tpvDepartment = (DynamicObject) model.getValue("tpv_department");
                if (YEM.isNotEmpty(tpvDepartment)) {
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("tpv_sc_delimittab", "tpv_caplimat",
                            new QFilter[]{new QFilter("tpv_department.id", QCP.equals, tpvDepartment.getPkValue())});
                    if (YEM.isNotEmpty(dynamicObject)) {
                        String tpvCaplimat = dynamicObject.getString("tpv_caplimat");
                        this.getModel().setValue("tpv_caplimat",tpvCaplimat);
                    } else {
                        this.getModel().setValue("tpv_caplimat",null);
                    }
                } else {
                    this.getModel().setValue("tpv_caplimat",null);
                }
                break;
        }
    }
}
