package tpv.tpv_wm.tpv_sc.java.formplugin.form;

import com.itopview.wm.utils.DateUtil;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;

import static kd.taxc.itp.common.util.date.DateUtils.isEffectiveDate;

/**
 * @Description: 资金占用明细（资金）
 * @Auther: zbh
 */
public class DetailsFundsFromBillPlug extends AbstractBillPlugIn {

    private final static String TPV_DETAILSUSEDS = "tpv_detailsuseds";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_advcontoolbarap");
    }

    @Override
    public void beforeItemClick(BeforeItemClickEvent evt) {
        super.beforeItemClick(evt);
        super.itemClick(evt);
        String itemKey = evt.getItemKey();
        if (itemKey.equals("tpv_del")) {
            return;
        }
        Date year = (Date) this.getModel().getValue("tpv_year"); //部门资金生成年份
        if (year == null) {
            this.getView().showTipNotification("请输入部门资金生成年份！");
            evt.setCancel(true);
        }
        String mon = (String) this.getModel().getValue("tpv_month");//部门资金生成月份;
        if (mon != null) {
            if (mon.isEmpty()) {
                this.getView().showTipNotification("请输入部门资金生成月份！");
                evt.setCancel(true);
            }
        } else {
            this.getView().showTipNotification("请输入部门资金生成月份！");
            evt.setCancel(true);
        }
//        DynamicObject company = (DynamicObject) this.getModel().getValue("tpv_company");//公司
//        if (company == null) {
//            this.getView().showTipNotification("请输入公司");
//            evt.setCancel(true);
//        }
//        DynamicObject type = (DynamicObject) this.getModel().getValue("tpv_type"); //类型
//        if (type == null) {
//            this.getView().showTipNotification("请输入类型");
//            evt.setCancel(true);
//        }
//        DynamicObject guarantystyle = (DynamicObject) this.getModel().getValue("tpv_guarantystyle");//担保方式
//        if (guarantystyle == null) {
//            this.getView().showTipNotification("请输入担保方式");
//            evt.setCancel(true);
//        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey();
        switch (itemKey) {
            case "tpv_add":
//                addDetails();
                addDetailsCapitallimit();
                break;
            case "tpv_del":
                delDetails();
                break;
        }
    }

    public void addDetailsCapitallimit() {
        this.getModel().deleteEntryData(TPV_DETAILSUSEDS);   //清除分录

        QFilter orgdutyQfilter = new QFilter("enable", QCP.equals, "1");
        orgdutyQfilter.and(new QFilter("orgduty.number", QCP.in, new String[]{"ZHKC002"}));
        DataSet orgduty = ORM.create().queryDataSet("bos_org_dutyrelation", "bos_org_dutyrelation", "org.id tpv_depid",
                orgdutyQfilter.toArray());
        DataSet copyOrgduty = orgduty.copy();
        List<Long> orgdutyIds = new ArrayList<>();
        for (Row row : copyOrgduty) {
            if (!orgdutyIds.contains(row.getLong("tpv_depid"))) {
                orgdutyIds.add(row.getLong("tpv_depid"));
            }
        }

        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        Date year = (Date) this.getModel().getValue("tpv_year"); //部门资金生成年份
        String mon = (String) this.getModel().getValue("tpv_month");//部门资金生成月份;
        Integer month = null;
        if (mon != null) {
            if (!mon.isEmpty()) {
                month = Integer.valueOf(mon);
            }
        }
        DynamicObject company = (DynamicObject) this.getModel().getValue("tpv_company");//公司
        DynamicObject tpvDepartment = (DynamicObject) this.getModel().getValue("tpv_department");//公司
        DynamicObject type = (DynamicObject) this.getModel().getValue("tpv_type"); //类型
        String mguarantystyle = (String) this.getModel().getValue("tpv_guarantystylea");//担保方式
        Date yearFirst = null;
        if (year != null) {
            yearFirst = DateUtil.getYearFirst(year); //当前年的第一天
        }
        Date monthEndDay = null;
        if (month != null && year != null) {
            year.setMonth(month - 1);
            monthEndDay = DateUtil.getMonthEndDay(year); //当前年当前月的最后一天
        }
        List<String> typeList = new ArrayList<>();
        typeList.add("I");
        typeList.add("J");
        QFilter qFilter = new QFilter("tpv_datetime", QCP.large_equals, yearFirst);
        qFilter.and(new QFilter("tpv_datetime", QCP.less_equals, monthEndDay));
        qFilter.and(new QFilter("tpv_type", "in", typeList));
        if (company!=null){
            qFilter.and(new QFilter("tpv_org.id", QCP.less_equals, company.getPkValue()));
        }
        if (tpvDepartment!=null){
            qFilter.and(new QFilter("tpv_department.id", QCP.less_equals, tpvDepartment.getPkValue()));
        }
        if (orgdutyIds.size() > 0) {
            qFilter.and(new QFilter("tpv_department.id", QCP.in, orgdutyIds));
        } else {
            qFilter.and(new QFilter("tpv_department.id", QCP.less_than, 0));
        }
        DynamicObject[] openlimits = BusinessDataServiceHelper.load("tpv_sc_capitallimit",
                "tpv_datetime,tpv_orignalamount,tpv_triggerdate,tpv_triggerdate,tpv_triggerbillno,tpv_triggerbillid,tpv_corenum,tpv_coreid,tpv_operation,tpv_salenum,tpv_purnum",
                qFilter.toArray(), "tpv_datetime"); //部门资金额度底表 开证
        DynamicObjectCollection entryEntity = this.getModel().getEntryEntity(TPV_DETAILSUSEDS);

        IdentityHashMap<String, DynamicObject> map = new IdentityHashMap<>();
        List<String> corenumLists = new ArrayList<>();
//        HashMap<String, DynamicObject> map = new HashMap<>();//核心号 对象
        for (DynamicObject openlimit : openlimits) {
            String tpvCorenum = openlimit.getString("tpv_corenum");
            map.put(tpvCorenum, openlimit);
            if (!corenumLists.contains(tpvCorenum)) {
                corenumLists.add(tpvCorenum);
            }
        }

        for (String corenumList : corenumLists) {
            List<DynamicObject> dyValue = new ArrayList<>();
            for (Map.Entry<String, DynamicObject> entry : map.entrySet()) {
                String key = entry.getKey();
                if (corenumList.equals(key)) {
                    DynamicObject dynamicObject = entry.getValue();
                    dyValue.add(dynamicObject);
                }
            }
            HashMap<Date, DynamicObject> time = new HashMap<>();

            List<Date> date = new ArrayList<>();

            for (DynamicObject object : dyValue) {
                Date tpvTriggerdate = object.getDate("tpv_triggerdate");
                time.put(tpvTriggerdate, object);
            }

            Iterator<Date> iterator = time.keySet().iterator();
            while (iterator.hasNext()) {
                Date key = iterator.next();
                date.add(key);
            }

            //按时间进行升序
            Collections.sort(date, new Comparator<Date>() {
                @Override
                public int compare(Date dateF, Date dateE) {
                    return dateF.compareTo(dateE);
                }
            });
            List<DynamicObject> endValue = new ArrayList<>();
            for (Date day : date) {
                endValue.add(time.get(day));
            }

            for (int i = 0; i < endValue.size(); i++) {
                DynamicObject lcLettercredit = BusinessDataServiceHelper.loadSingle("lc_lettercredit",
                        "isnationalcard,tpv_lettercty,tpv_kzbank,creditno,tpv_guaranteetype,tpv_guarantee",
                        new QFilter[]{new QFilter("billno", "=", endValue.get(i).getString("tpv_corenum"))});

                String creditno = ""; //信用证/保函号码/合同号
                String tpvLettercty = ""; //信用证类型
                String tpvKzbankName = "";//开证/融资银行
                String tpvGuarantee = "";//担保方式
                DynamicObject tpvKzbank = null;
                Boolean isnationalcard = false;
                if (lcLettercredit != null) {
                    tpvGuarantee = lcLettercredit.getString("tpv_guarantee");
                    creditno = lcLettercredit.getString("creditno");
                    tpvLettercty = lcLettercredit.getString("tpv_lettercty");
                    tpvKzbank = lcLettercredit.getDynamicObject("tpv_kzbank");
                    isnationalcard = lcLettercredit.getBoolean("isnationalcard");
                }
                if(mguarantystyle!=null){
                    if (!tpvGuarantee.equals(mguarantystyle)) {
                        break;
                    }
                }
                if (tpvKzbank != null) {
                    tpvKzbankName = tpvKzbank.getString("name");
                }
                Calendar instance = Calendar.getInstance();
                instance.setTime(monthEndDay);
                BigDecimal mouthDay = BigDecimal.valueOf(instance.get(Calendar.DATE));//月份天数
                Date tpvTriggerdate = endValue.get(i).getDate("tpv_triggerdate");//开始日期
                Date endDate = null;//终止日期
                endValue.get(i).getString("tpv_operation");
                BigDecimal tpvOrignalamount = endValue.get(i).getBigDecimal("tpv_orignalamount");//占用金额
                if (endValue.size() == 1) {
                    endDate = monthEndDay;
                } else if (i < (endValue.size() - 1)) {
                    endDate = endValue.get(i + 1).getDate("tpv_triggerdate");
                } else {
                    endDate = monthEndDay;
                }
                BigDecimal days = BigDecimal.valueOf(DateUtil.countActualDays(tpvTriggerdate, endDate));//占用天数
                DynamicObject tpvJxlb = null;//类型
                DynamicObject addNew = entryEntity.addNew();
                BigDecimal bigDecimal = tpvOrignalamount.multiply(days).divide(mouthDay, RoundingMode.HALF_UP);////日均占用额度（原币币）
                addNew.set("tpv_guarantee", mguarantystyle);//担保方式
                addNew.set("tpv_amountocc", tpvOrignalamount);//占用金额
                addNew.set("tpv_starttime", tpvTriggerdate);//开始日期
                addNew.set("tpv_endtime", endDate);//终止日期
                addNew.set("tpv_dateocc", days);  //占用天数

                //类型
                addNew.set("tpv_dailyocc", bigDecimal);//日均占用额度（原币币）
                addNew.set("tpv_dailyoccb", bigDecimal);//日均占用额度（本位币）//TODO
                if (isnationalcard) {
                    tpvJxlb = BusinessDataServiceHelper.loadSingle("tpv_jxlb", "", new QFilter[]{new QFilter("number", "=", "080")});
                } else {
                    tpvJxlb = BusinessDataServiceHelper.loadSingle("tpv_jxlb", "", new QFilter[]{new QFilter("number", "=", "090")});
                }
                addNew.set("tpv_types", tpvJxlb);//类型

                addNew.set("tpv_number", creditno);//信用证/保函号码/合同号
                addNew.set("tpv_lettercty", tpvLettercty);//类型（信用证类型   ）
                addNew.set("tpv_snumber", endValue.get(i).getString("tpv_corenum"));//申请单号（单据编号）
                addNew.set("tpv_statustype", endValue.get(i).getString("tpv_triggerbillno"));//业务单据类型
                addNew.set("tpv_pucnumber", endValue.get(i).getString("tpv_purnum"));//采购合同号
                addNew.set("tpv_salenumber", endValue.get(i).getString("tpv_salenum"));//销售合同号
                addNew.set("tpv_bankbizclf", tpvKzbankName);//开证/融资银行
                addNew.set("tpv_bank", tpvKzbank);//开证/融资银行
            }
        }

        QFilter filter = new QFilter("billstatus", "=", "C");
        if (mguarantystyle==null){
            filter.and(new QFilter("guarantee", "=", ""));
        }else {
            filter.and(new QFilter("guarantee", "=", mguarantystyle));
        }

        if (company!=null){
            filter.and(new QFilter("org.id", "=", company.getPkValue()));
        }
        filter.and(new QFilter("bizdate", QCP.large_equals, yearFirst));
        filter.and(new QFilter("bizdate", QCP.less_equals, monthEndDay));
        DynamicObject[] cfmLoancontractbills = BusinessDataServiceHelper.load("cfm_loancontractbill",
                "creditorg,contractno,notrepayamount,bizdate,guarantee,lenderapplyno,amount,finproduct,contractname,billno,textcreditor,notdrawamount,drawamount,repayamount",
                filter.toArray());//银行借款合同
        for (DynamicObject cfmLoancontractbill : cfmLoancontractbills) {
            String guarantee = cfmLoancontractbill.getString("guarantee");
            String billno = cfmLoancontractbill.getString("billno");//申请单号（单据编号）
            String contractname = cfmLoancontractbill.getString("contractname");//合同名称
            Date bizdate = cfmLoancontractbill.getDate("bizdate");
            DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("cfm_loancontractbill_f7", "",
                    new QFilter[]{new QFilter("name", "=", contractname)});
            Object pkValue = 1;
            if (dynamicObject != null) {
                pkValue = dynamicObject.getPkValue();
            }

            DynamicObject addNew = entryEntity.addNew();
            DynamicObject finproduct = cfmLoancontractbill.getDynamicObject("finproduct");
            DynamicObject creditorg = cfmLoancontractbill.getDynamicObject("creditorg");
            String finproductName = "";//融资品种  类型
            String creditorgName = "";//开证/融资银行

            String contractno = cfmLoancontractbill.getString("contractno");//信用证/保函号码/合同号
            if (finproduct != null) {
                finproductName = finproduct.getString("name");
            }
            if (creditorg != null) {
                creditorgName = creditorg.getString("name");
            }
            DynamicObject[] cfmRepaymentbill = BusinessDataServiceHelper.load("cfm_repaymentbill",
                    "modifytime"
//                    ,null
                    , new QFilter[]{new QFilter("loancontractbill.id", "=", pkValue)}
                    , "modifytime"
            );//借款合同
            DynamicObject[] cfmLoanbill = BusinessDataServiceHelper.load("cfm_loanbill",
                    "modifytime"
//                    ,null
                    , new QFilter[]{new QFilter("loancontractbill.id", "=", pkValue)}
                    , "modifytime"
            );//借款合同
            Date timeTk = null;//提款处理最后更新时间
            Date timeHk = null;//还款款处理最后更新时间
            Date startDate = null;//开始日期
            Date endDate = null;//终止日期
            if (cfmRepaymentbill.length != 0 && cfmLoanbill.length != 0) {
                timeTk = cfmRepaymentbill[cfmRepaymentbill.length - 1].getDate("modifytime");//提款处理最后更新时间
                timeHk = cfmLoanbill[cfmLoanbill.length - 1].getDate("modifytime");//还款款处理最后更新时间
//                timeTk = dateTk.get(dateTk.size() - 1); //提款处理最后更新时间
//                timeHk = dateHk.get(dateHk.size() - 1); //还款款处理最后更新时间
            }

            if (timeTk == null && timeHk != null) {
                startDate = timeHk;
            } else if (timeTk != null && timeHk == null) {
                startDate = timeTk;
            } else if (timeTk != null && timeHk != null) {
                if (timeTk.before(timeHk)) {
                    startDate = timeHk;
                } else {
                    startDate = timeTk;
                }
            } else {
                startDate = bizdate;
            }
            //monthEndDay  当月的最后一天
            if (timeTk != null && timeHk != null) {
                if (timeTk.before(timeHk)) {//2
                    if (timeHk.before(monthEndDay)) {
                        endDate = timeHk;
                    } else {
                        endDate = monthEndDay;
                    }
                } else if (timeHk.before(timeTk)) {//1
                    if (timeTk.before(monthEndDay)) {
                        endDate = timeHk;
                    } else {
                        endDate = monthEndDay;
                    }
                }
            } else if (timeTk == null && timeHk != null) {
                if (timeHk.before(monthEndDay)) {
                    endDate = timeHk;
                } else {
                    endDate = monthEndDay;
                }
            } else if (timeTk != null && timeHk == null) {
                if (timeTk.before(monthEndDay)) {
                    endDate = timeTk;
                } else {
                    endDate = monthEndDay;
                }
            } else {
                endDate = monthEndDay;
            }

            BigDecimal days = BigDecimal.valueOf(DateUtil.countActualDays(startDate, endDate));//占用天数
            Calendar instance = Calendar.getInstance();
            instance.setTime(monthEndDay);
            BigDecimal mouthDay = BigDecimal.ZERO;

            BigDecimal drawamount = cfmLoancontractbill.getBigDecimal("drawamount");//已提款金额
            BigDecimal notdrawamount = cfmLoancontractbill.getBigDecimal("notdrawamount");//可提款金额
            BigDecimal repayamount = cfmLoancontractbill.getBigDecimal("repayamount");//已还本金
            BigDecimal notrepayamount = cfmLoancontractbill.getBigDecimal("notrepayamount");//未还本金
            if (notrepayamount.compareTo(BigDecimal.ZERO) == 0) {
                mouthDay = BigDecimal.valueOf(instance.get(Calendar.DATE));//月份天数
            } else {
                mouthDay = BigDecimal.valueOf(instance.get(Calendar.DATE)).add(BigDecimal.ONE);
            }
            BigDecimal subtract = notdrawamount.subtract(drawamount).subtract(repayamount);
            BigDecimal tpvDailyocc = subtract.multiply(days).divide(mouthDay, RoundingMode.HALF_UP);
            DynamicObject tpvJxlb = BusinessDataServiceHelper.loadSingle("tpv_jxlb", "", new QFilter[]{new QFilter("number", "=", "100")});
            addNew.set("tpv_guarantee", mguarantystyle);//担保方式 ？
            addNew.set("tpv_amountocc", subtract);//占用金额

            addNew.set("tpv_starttime", startDate);//开始日期

            addNew.set("tpv_endtime", endDate);//终止日期
            addNew.set("tpv_dateocc", days);  //占用天数

            addNew.set("tpv_types", tpvJxlb);//类型
            addNew.set("tpv_dailyocc", tpvDailyocc);//日均占用额度（原币币）
            addNew.set("tpv_dailyoccb", tpvDailyocc);//日均占用额度（本位币）//TODO

            addNew.set("tpv_number", contractno);//信用证/保函号码/合同号
            addNew.set("tpv_lettercty", finproductName);//融资品种  类型
            addNew.set("tpv_snumber", billno);//申请单号（单据编号）
            addNew.set("tpv_statustype", cfmLoancontractbill.getString("billno"));//业务单据类型
            addNew.set("tpv_pucnumber", null);//采购合同号
            addNew.set("tpv_salenumber", null);//销售合同号
            addNew.set("tpv_bankbizclf", cfmLoancontractbill.getString("textcreditor"));//开证/融资银行
            addNew.set("tpv_bank", creditorg);//开证/融资银行
        }
        this.getView().updateView(TPV_DETAILSUSEDS);
    }

    /**
     * @Title: addDetails
     * @Descripton: 添加分录
     * @reurn: a
     */
    private void addDetails() {
        this.getModel().deleteEntryData("tpv_detailsuseds");   //清除分录
        Date year = (Date) this.getModel().getValue("tpv_year"); //部门资金生成年份
        String mon = (String) this.getModel().getValue("tpv_month");//部门资金生成月份;
        Integer month = null;
        if (mon != null) {
            if (!mon.isEmpty()) {
                month = Integer.valueOf(mon);
            }
        }
        DynamicObject company = (DynamicObject) this.getModel().getValue("tpv_company");//公司
        DynamicObject type = (DynamicObject) this.getModel().getValue("tpv_type"); //类型
        DynamicObject guarantystyle = (DynamicObject) this.getModel().getValue("tpv_guarantystyle");//担保方式

        String mguarantystyle = (String) this.getModel().getValue("tpv_guarantystylea");//担保方式

        Date yearFirst = null;
        if (year != null) {
            yearFirst = DateUtil.getYearFirst(year); //当前年的第一天
        }
        Date monthEndDay = null;
        if (month != null && year != null) {
            year.setMonth(month - 1);
            monthEndDay = DateUtil.getMonthEndDay(year); //当前年当前月的最后一天
        }
        DynamicObject[] load = BusinessDataServiceHelper.load("tpv_middletable",
                "tpv_datetime,tpv_amountf,tpv_combo,tpv_textf,tpv_cnumber",
                new QFilter[]{new QFilter("tpv_datetime", QCP.large_equals, yearFirst),
                        new QFilter("tpv_datetime", QCP.less_equals, monthEndDay)
                        , new QFilter("tpv_combo", QCP.equals, "A")
                }, "tpv_datetime"); //开证

        List<String> list = new ArrayList(); //单据编号
        List<DynamicObject> numberOp = new ArrayList(); //开证
        for (int i = 0; i < load.length; i++) {
            String text = load[i].getString("tpv_textf");
            list.add(text);
            numberOp.add(load[i]);
        }

        DynamicObject[] loadArrsa = BusinessDataServiceHelper.load("tpv_middletable", "tpv_datetime,tpv_amountf,tpv_combo,tpv_textf,tpv_cnumber",
                new QFilter[]{new QFilter("tpv_datetime", QCP.large_equals, yearFirst)
                        , new QFilter("tpv_datetime", QCP.less_equals, monthEndDay)
                        , new QFilter("tpv_combo", QCP.equals, "E")
                }, "tpv_datetime"); //到单

        DynamicObject[] loadPaya = BusinessDataServiceHelper.load("tpv_middletable", "tpv_datetime,tpv_amountf,tpv_combo,tpv_textf,tpv_cnumber",
                new QFilter[]{new QFilter("tpv_datetime", QCP.large_equals, yearFirst)
                        , new QFilter("tpv_datetime", QCP.less_equals, monthEndDay)
                        , new QFilter("tpv_combo", QCP.equals, "F")
                }, "tpv_datetime"); //付款

        DynamicObject[] loadBiza = BusinessDataServiceHelper.load("tpv_middletable", "tpv_datetime,tpv_amountf,tpv_combo,tpv_textf,tpv_cnumber",
                new QFilter[]{new QFilter("tpv_datetime", QCP.large_equals, yearFirst)
                        , new QFilter("tpv_datetime", QCP.less_equals, monthEndDay)
                        , new QFilter("tpv_combo", QCP.equals, "D")
                }, "tpv_datetime"); //改证      信用证号等于开证的单据编号

        List<String> comboa = new ArrayList<>();
        comboa.add("B");
        comboa.add("C");
        DynamicObject[] loadLea = BusinessDataServiceHelper.load("tpv_middletable", "tpv_datetime,tpv_amountf,tpv_combo,tpv_textf,tpv_cnumber",
                new QFilter[]{new QFilter("tpv_datetime", QCP.large_equals, yearFirst)
                        , new QFilter("tpv_datetime", QCP.less_equals, monthEndDay)
                        , new QFilter("tpv_combo", QCP.in, comboa)
                }, "tpv_datetime"); //闭卷 撤证


        List<DynamicObject> arrYear = new ArrayList();   //到单期初
        List<DynamicObject> payYear = new ArrayList();   //付款期初
        List<DynamicObject> bizYear = new ArrayList();   //改证期初
        List<String> arrYearNumber = new ArrayList();   //到单期初编号
        List<String> payYearNumber = new ArrayList();   //付款期初编号
        List<String> bizYearNumber = new ArrayList();   //改证期初编号
        for (DynamicObject loadSingle : loadArrsa) {
            String string = loadSingle.getString("tpv_textf");
            if (!list.contains(string)) {
                arrYearNumber.add(string);
                arrYear.add(loadSingle);
            }
        }
        for (DynamicObject loadSingle : loadPaya) {
            String string = loadSingle.getString("tpv_textf");
            if (!list.contains(string)) {
                payYearNumber.add(string);
                payYear.add(loadSingle);
            }
        }
        for (DynamicObject loadSingle : loadBiza) {
            String string = loadSingle.getString("tpv_textf");
            if (!list.contains(string)) {
                bizYearNumber.add(string);
                bizYear.add(loadSingle);
            }
        }

        DynamicObject[] arrYeared = BusinessDataServiceHelper.load("tpv_middletable", "tpv_datetime,tpv_amountf,tpv_combo,tpv_textf,tpv_cnumber",
                new QFilter[]{new QFilter("tpv_textf", QCP.in, arrYearNumber)
                        , new QFilter("tpv_combo", QCP.equals, "A")
                }, "tpv_datetime"); //到单期初 的开证
        DynamicObject[] payYeared = BusinessDataServiceHelper.load("tpv_middletable", "tpv_datetime,tpv_amountf,tpv_combo,tpv_textf,tpv_cnumber",
                new QFilter[]{new QFilter("tpv_textf", QCP.in, payYearNumber)
                        , new QFilter("tpv_combo", QCP.equals, "A")
                }, "tpv_datetime"); //付款期初  的开证
        DynamicObject[] bizYeared = BusinessDataServiceHelper.load("tpv_middletable", "tpv_datetime,tpv_amountf,tpv_combo,tpv_textf,tpv_cnumber",
                new QFilter[]{new QFilter("tpv_textf", QCP.in, bizYearNumber)
                        , new QFilter("tpv_combo", QCP.equals, "A")
                }, "tpv_datetime"); //改证期初   的开证
        List<DynamicObject> listYearOp = new ArrayList();
        List<String> listYearOpnumber = new ArrayList();  //开证编号

        for (DynamicObject loadSingle : arrYeared) {
            if (!listYearOpnumber.contains(loadSingle.getString("tpv_textf"))) {
                listYearOp.add(loadSingle);
                listYearOpnumber.add(loadSingle.getString("tpv_textf"));
            }
        }
        for (DynamicObject loadSingle : payYeared) {
            if (!listYearOpnumber.contains(loadSingle.getString("tpv_textf"))) {
                listYearOp.add(loadSingle);
                listYearOpnumber.add(loadSingle.getString("tpv_textf"));
            }
        }
        for (DynamicObject loadSingle : bizYeared) {
            if (!listYearOpnumber.contains(loadSingle.getString("tpv_textf"))) {
                listYearOp.add(loadSingle);
                listYearOpnumber.add(loadSingle.getString("tpv_textf"));
            }
        }
        DynamicObject[] arrYearedOp = BusinessDataServiceHelper.load("tpv_middletable", "tpv_datetime,tpv_amountf,tpv_combo,tpv_textf,tpv_cnumber",
                new QFilter[]{new QFilter("tpv_textf", QCP.in, listYearOpnumber)
                        , new QFilter("tpv_combo", QCP.equals, "E")
                }, "tpv_datetime"); //到单

        DynamicObject[] payYearedOp = BusinessDataServiceHelper.load("tpv_middletable", "tpv_datetime,tpv_amountf,tpv_combo,tpv_textf,tpv_cnumber",
                new QFilter[]{new QFilter("tpv_datetime", QCP.large_equals, yearFirst)
                        , new QFilter("tpv_datetime", QCP.less_equals, monthEndDay)
                        , new QFilter("tpv_combo", QCP.equals, "F")
                }, "tpv_datetime"); //付款

        DynamicObject[] bizYearedOp = BusinessDataServiceHelper.load("tpv_middletable", "tpv_datetime,tpv_amountf,tpv_combo,tpv_textf,tpv_cnumber",
                new QFilter[]{new QFilter("tpv_datetime", QCP.large_equals, yearFirst)
                        , new QFilter("tpv_datetime", QCP.less_equals, monthEndDay)
                        , new QFilter("tpv_combo", QCP.equals, "D")
                }, "tpv_datetime"); //改证      信用证号等于开证的单据编号

        List<String> comboaOp = new ArrayList<>();
        comboaOp.add("B");
        comboaOp.add("C");
        DynamicObject[] leYearedOp = BusinessDataServiceHelper.load("tpv_middletable", "tpv_datetime,tpv_amountf,tpv_combo,tpv_textf,tpv_cnumber",
                new QFilter[]{new QFilter("tpv_datetime", QCP.large_equals, yearFirst)
                        , new QFilter("tpv_datetime", QCP.less_equals, monthEndDay)
                        , new QFilter("tpv_combo", QCP.in, comboa)
                }, "tpv_datetime"); //闭卷 撤证

        addRow(listYearOp, arrYearedOp, payYearedOp, bizYearedOp, leYearedOp, yearFirst, monthEndDay);
        addRow(numberOp, loadArrsa, loadPaya, loadBiza, loadLea, yearFirst, monthEndDay);


        DynamicObject[] bankHt = BusinessDataServiceHelper.load("cfm_loancontractbill", "dl_modifytime,finproduct,billno,guarantee,contractno,notdrawamount,drawamount,repayamount",
                new QFilter[]{new QFilter("startdate", QCP.large_equals, yearFirst)
                        , new QFilter("startdate", QCP.less_equals, monthEndDay)
                });//银行贷款合同
        List<String> numberHt = new ArrayList<>();  //银行贷款合同编号
        for (DynamicObject loadSingle : bankHt) {
            numberHt.add(loadSingle.getString("billno"));
        }

        DynamicObject[] bankTkQ = BusinessDataServiceHelper.load("cfm_loanbill", "loancontractbill,modifytime",
                null, "modifytime");  //提款
        List<DynamicObject> numberTkQ = new ArrayList<>();  //银行贷款合同编号
        for (DynamicObject loadSingle : bankTkQ) {
            if (numberHt.contains(loadSingle.getString("loancontractbill.number"))) {
                numberTkQ.add(loadSingle);
            }
        }

        DynamicObject[] bankHkQ = BusinessDataServiceHelper.load("cfm_repaymentbill", "loancontractbill.number,modifytime",
                null, "modifytime"); //还款

        List<DynamicObject> numberHkQ = new ArrayList<>();  //银行贷款合同编号
        for (DynamicObject loadSingle : bankHkQ) {
            if (numberHt.contains(loadSingle.getString("loancontractbill.number"))) {
                numberHkQ.add(loadSingle);
            }
        }
        int rowCount = this.getModel().getEntryRowCount("tpv_detailsuseds");
        if (bankHt.length == 0 && load.length == 0 && listYearOp.size() == 0) {
            this.getView().showTipNotification("暂无数据！");
            return;
        }
        if (bankHt.length != 0) {
            this.getModel().batchCreateNewEntryRow("tpv_detailsuseds", bankHt.length);
        }

        for (int i = 0; i < bankHt.length; i++) {
            List<Date> dateTk = new ArrayList<>();  //提款处理最后更新时间
            List<Date> dateHk = new ArrayList<>();  //还款款处理最后更新时间

            for (DynamicObject loadSingle : bankTkQ) {
                if (bankHt[i].getString("billno").equals(loadSingle.getString("loancontractbill.number"))) {
                    dateTk.add(loadSingle.getDate("modifytime"));
                }
            }
            for (DynamicObject loadSingle : numberHkQ) {
                if (bankHt[i].getString("billno").equals(loadSingle.getString("loancontractbill.number"))) {
                    dateHk.add(loadSingle.getDate("modifytime"));
                }
            }
            Date timeTk = null;
            Date timeHk = null;
            if (dateTk.size() != 0 && dateHk.size() != 0) {
                timeTk = dateTk.get(dateTk.size() - 1); //提款处理最后更新时间
                timeHk = dateHk.get(dateHk.size() - 1); //还款款处理最后更新时间
            }

            Date timeSk = null;
            Date timeEk = null;
            if (timeTk != null && timeHk != null) {
                if (timeTk.before(timeTk)) {
                    timeSk = timeTk;
                } else {
                    timeSk = timeHk;
                }
                //monthEndDay 月份的最后一天
                if (isEffectiveDate(timeTk, timeHk, monthEndDay)) {
                    timeEk = timeHk;
                }
                if (isEffectiveDate(timeHk, timeTk, monthEndDay)) {
                    timeEk = timeTk;
                }
                if (timeEk == null) {
                    timeEk = monthEndDay;
                }
            }

            String guarantee = bankHt[i].getString("guarantee");//担保方式
            String contractNo = bankHt[i].getString("contractno");//合同号
            String billNo = bankHt[i].getString("billno");//合同单据编号
            DynamicObject finProduct = bankHt[i].getDynamicObject("finproduct");//合同号
            BigDecimal notdrawAmount = bankHt[i].getBigDecimal("notdrawamount");//可提款金额
            BigDecimal drawAmount = bankHt[i].getBigDecimal("drawamount");//已提款金额
            BigDecimal repayAmount = bankHt[i].getBigDecimal("repayamount");//已还本金
            BigDecimal tpvAmountocc = notdrawAmount.subtract(drawAmount).subtract(repayAmount);//占用金额

            this.getModel().setValue("tpv_guarantystyles", null, rowCount + i);//担保方式
            this.getModel().setValue("tpv_amountocc", tpvAmountocc, rowCount + i);//占用金额
            this.getModel().setValue("tpv_starttime", timeSk, rowCount + i);//开始日期
            this.getModel().setValue("tpv_endtime", timeEk, rowCount + i);//终止日期
            this.getModel().setValue("tpv_types", null, rowCount + i);//类型 -
            this.getModel().setValue("tpv_number", contractNo, rowCount + i);//信用证/保函号码/合同号
            this.getModel().setValue("tpv_typses", finProduct.getString("name"), rowCount + i);//类型
            this.getModel().setValue("tpv_snumber", billNo, rowCount + i);//申请单号（单据编号）
            this.getModel().setValue("tpv_statustype", null, rowCount + i);//业务单据类型
            this.getModel().setValue("tpv_pucnumber", null, rowCount + i);//采购合同号
            this.getModel().setValue("tpv_salenumber", null, rowCount + i);//销售合同号
            this.getModel().setValue("tpv_bank", null, rowCount + i);//开证/融资银行
        }

        DynamicObject dataEntitys = this.getModel().getDataEntity(true);
        DynamicObjectCollection detailsusedss = dataEntitys.getDynamicObjectCollection("tpv_detailsuseds");
        List<Integer> listRow = new ArrayList<>();

        int rowCounts = detailsusedss.getRowCount();
        for (int i = 0; i < rowCounts; i++) {
            Date tpvStarttime = detailsusedss.get(i).getDate("tpv_starttime");
            Date tpv_endtime = detailsusedss.get(i).getDate("tpv_endtime");


            if (tpvStarttime != null) {
                if (!isEffectiveDate(tpvStarttime, yearFirst, monthEndDay)) {
                    listRow.add(i);
                }
                if (tpv_endtime == null) {
                    this.getModel().setValue("tpv_endtime", monthEndDay, i);
                }

            }
        }
        int[] array = new int[listRow.size()];
        for (int i = 0; i < listRow.size(); i++) {
            //list.get(i)是通过索引值获取集合中的元素
            array[i] = listRow.get(i);
        }
        this.getModel().deleteEntryRows("tpv_detailsuseds", array);

        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection detailSuseds = dataEntity.getDynamicObjectCollection("tpv_detailsuseds");
        for (int i = 0; i < detailSuseds.size(); i++) {

            Date tpvStarttime = detailSuseds.get(i).getDate("tpv_starttime");
            Date tpvEndtime = detailSuseds.get(i).getDate("tpv_endtime");
            BigDecimal tpvAmountocc = detailSuseds.get(i).getBigDecimal("tpv_amountocc"); //金额
            BigDecimal tpvDateocc = new BigDecimal(0);
            if (tpvEndtime != null && tpvStarttime != null) {
                this.getModel().setValue("tpv_dateocc", DateUtil.countActualDays(tpvStarttime, tpvEndtime) - 1, i);
                tpvDateocc = detailSuseds.get(i).getBigDecimal("tpv_dateocc");//占用日期
            }
            if (tpvDateocc.compareTo(BigDecimal.ZERO) > 0 && tpvAmountocc.compareTo(BigDecimal.ZERO) > 0) {
                int day = monthEndDay.getDate();
                BigDecimal decimal = BigDecimal.valueOf(day);
                this.getModel().setValue("tpv_dailyocc", (tpvAmountocc.multiply(tpvDateocc)).divide(decimal, BigDecimal.ROUND_HALF_UP), i);
                this.getModel().setValue("tpv_dailyoccb", (tpvAmountocc.multiply(tpvDateocc)).divide(decimal, BigDecimal.ROUND_HALF_UP), i);
            }
        }
    }

    /**
     * @Title: addRow
     * @Descripton: 数据按时间排序 load:开证  loadarrsa:到单  loadpaya:付款 loadbiza:改证 loadlea:闭卷 撤证
     * @reurn: a
     */
    private void addRow(List<DynamicObject> load, DynamicObject[] loadarrsa, DynamicObject[] loadpaya, DynamicObject[] loadbiza, DynamicObject[] loadlea, Date yearFirst, Date monthEndDay) {
        for (int i = 0; i < load.size(); i++) {

            String text = load.get(i).getString("tpv_textf");     //开证处理

            List<DynamicObject> loadarrs = new ArrayList();   //到单
            List<DynamicObject> loadpay = new ArrayList();   //付款
            List<DynamicObject> loadbiz = new ArrayList();   //改证
            List<DynamicObject> loadle = new ArrayList();   //闭卷 撤证
            for (DynamicObject loadSingle : loadarrsa) {
                String string = loadSingle.getString("tpv_textf");
                if (text.equals(string)) {
                    loadarrs.add(loadSingle);
                }
            }
            for (DynamicObject loadSingle : loadpaya) {
                String string = loadSingle.getString("tpv_textf");
                if (text.equals(string)) {
                    loadpay.add(loadSingle);
                }
            }
            for (DynamicObject loadSingle : loadbiza) {
                String string = loadSingle.getString("tpv_textf");
                if (text.equals(string)) {
                    loadbiz.add(loadSingle);
                }
            }
            for (DynamicObject loadSingle : loadlea) {
                String string = loadSingle.getString("tpv_textf");
                if (text.equals(string)) {
                    loadle.add(loadSingle);
                }
            }

            HashMap<Date, DynamicObject> time = new HashMap();
            time.put(load.get(i).getDate("tpv_datetime"), load.get(i));

            for (DynamicObject loads : loadarrs) {
                time.put(loads.getDate("tpv_datetime"), loads);
            }

            for (DynamicObject loads : loadpay) {
                time.put(loads.getDate("tpv_datetime"), loads);
            }

            for (DynamicObject loads : loadbiz) {
                time.put(loads.getDate("tpv_datetime"), loads);
            }

            for (DynamicObject loads : loadle) {
                time.put(loads.getDate("tpv_datetime"), loads);
            }

            List<Date> date = new ArrayList<>();   //开证处理的时间
            List<DynamicObject> loads = new ArrayList();  //按时间排序的开证处理流程
            Iterator<Date> iterator = time.keySet().iterator();
            while (iterator.hasNext()) {
                Date key = iterator.next();
                date.add(key);
            }
            //按时间进行升序
            Collections.sort(date, new Comparator<Date>() {
                @Override
                public int compare(Date dateF, Date dateE) {
                    return dateF.compareTo(dateE);
                }
            });
            for (Date day : date) {
                loads.add(time.get(day));
            }
            addEntity(loads, yearFirst, monthEndDay);
        }
    }

    /**
     * @Title: addEntity
     * @Descripton: 数据的填充
     * @reurn: a
     */
    private void addEntity(List<DynamicObject> loads, Date yearFirst, Date monthEndDay) {

        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvDetailsuseds = dataEntity.getDynamicObjectCollection("tpv_detailsuseds");
        BigDecimal let = BigDecimal.ZERO;  //开证金额
        BigDecimal biz = BigDecimal.ZERO;  //改证金额
        BigDecimal arr = BigDecimal.ZERO;  //到单总金额
        BigDecimal pay = BigDecimal.ZERO;  //付款总金额
        for (int n = 0; n < loads.size(); n++) {

            this.getModel().createNewEntryRow("tpv_detailsuseds");
            int rowIndex = tpvDetailsuseds.getRowCount();
            int lastRow = rowIndex - 1;

            this.getModel().setValue("tpv_starttime", loads.get(n).getDate("tpv_datetime"), lastRow);
            if ("A".equals(loads.get(n).getString("tpv_combo"))) {
                this.getModel().setValue("tpv_snumber", loads.get(n).getString("tpv_textf"), lastRow);
                this.getModel().setValue("tpv_amountocc", loads.get(n).getBigDecimal("tpv_amountf"), lastRow);
                let = loads.get(n).getBigDecimal("tpv_amountf");
            }
            if ("B".equals(loads.get(n).getString("tpv_combo")) || "C".equals(loads.get(n).getString("tpv_combo"))) {
                this.getModel().setValue("tpv_snumber", loads.get(n).getString("tpv_textf"), lastRow);
                this.getModel().setValue("tpv_sign", "true", lastRow);
            }
            if ("D".equals(loads.get(n).getString("tpv_combo"))) {
                this.getModel().setValue("tpv_amountocc", loads.get(n).getBigDecimal("tpv_amountf"), lastRow);
                if (let.compareTo(loads.get(n).getBigDecimal("tpv_amountf")) <= 0 && arr.compareTo(loads.get(n).getBigDecimal("tpv_amountf")) <= 0) {
                    let = loads.get(n).getBigDecimal("tpv_amountf");
                    this.getModel().setValue("tpv_snumber", loads.get(n).getString("tpv_textf"), lastRow);
                } else {
                    this.getModel().setValue("tpv_sign", "true", lastRow);
//                    this.getModel().deleteEntryRow("tpv_detailsuseds", n + 1);
                }
            }
            if ("E".equals(loads.get(n).getString("tpv_combo"))) {
                this.getModel().setValue("tpv_snumber", loads.get(n).getString("tpv_textf"), lastRow);
                BigDecimal tpvAmountf = loads.get(n).getBigDecimal("tpv_amountf");
                arr = arr.add(tpvAmountf);
                if (arr.compareTo(let) > 0) {
                    this.getModel().setValue("tpv_amountocc", arr, lastRow);
                } else {
                    this.getModel().setValue("tpv_sign", "true", lastRow);
                }
            }
            if ("F".equals(loads.get(n).getString("tpv_combo"))) {
                this.getModel().setValue("tpv_snumber", loads.get(n).getString("tpv_textf"), lastRow);
                BigDecimal tpvAmountf = loads.get(n).getBigDecimal("tpv_amountf");  //付款金额
                pay = pay.add(tpvAmountf);
                if (arr.compareTo(let) > 0) {  //到单总金额大于开证金额
                    BigDecimal multiply = arr.subtract(pay);
                    this.getModel().setValue("tpv_amountocc", multiply, lastRow);
                } else {
                    BigDecimal multiply = let.subtract(pay);
                    this.getModel().setValue("tpv_amountocc", multiply, lastRow);
                }
            }
            this.getModel().setValue("tpv_number", null, lastRow);//信用证/保函号码/合同号
            this.getModel().setValue("tpv_typses", null, lastRow);//类型
            this.getModel().setValue("tpv_snumber", null, lastRow);//申请单号（单据编号）
            this.getModel().setValue("tpv_statustype", null, lastRow);//业务单据类型
            this.getModel().setValue("tpv_pucnumber", null, lastRow);//采购合同号
            this.getModel().setValue("tpv_salenumber", null, lastRow);//销售合同号
            this.getModel().setValue("tpv_bank", null, lastRow);//开证/融资银行

            DynamicObject dataEntitys = this.getModel().getDataEntity(true);
            DynamicObjectCollection detailSuseds = dataEntitys.getDynamicObjectCollection("tpv_detailsuseds");
            int rowCount = detailSuseds.getRowCount();
            for (int k = 0; k < rowCount; k++) {
                rowCount = detailSuseds.getRowCount();
                BigDecimal tpvAmountocc = detailSuseds.get(k).getBigDecimal("tpv_amountocc");
                String tpvSign = detailSuseds.get(k).getString("tpv_sign");
                if ("true".equals(tpvSign)) {
                    this.getModel().deleteEntryRow("tpv_detailsuseds", k);
                }
            }
            if (lastRow != 0 && n != 0) {
                this.getModel().setValue("tpv_endtime", loads.get(n).getDate("tpv_datetime"), lastRow - 1);
            }

        }
    }

    /**
     * @Title: delDetails
     * @Descriptin: 删除分录
     * @retrn: a
     */
    private void delDetails() {
        this.getModel().deleteEntryData(TPV_DETAILSUSEDS);   //清除分录
    }
}