package tpv.tpv_wm.tpv_sc.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.math.BigDecimal;

/**
 * @author ljw
 * @version 1.0
 * @description: 资金收支计划考核表表单插件
 * 罚金和说明赋值
 * @date 2023/8/11 11:32
 */

public class FundingassessmentAbstractBillPlugIn extends AbstractBillPlugIn {
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();

        switch (name) {
            case "tpv_flowvariance"://检测净流量差异
                BigDecimal flowvariance = (BigDecimal) this.getModel().getValue("tpv_flowvariance");//获取到净流量差异
                BigDecimal projectedfunds = (BigDecimal) this.getModel().getValue("tpv_projectedfunds");//获取到预计资金净流量
                BigDecimal variancerate = (BigDecimal) this.getModel().getValue("tpv_variancerate");//获取到差异率
                QFilter qFilter = new QFilter("tpv_standard.number", QCP.equals, "'number'");//查询基础资料中的编码
                DynamicObject dataEntity = this.getModel().getDataEntity(true);
                DynamicObject creatorDObj = (DynamicObject) this.getModel().getValue("tpv_standard");//标准差异率
                if (null != creatorDObj){
                    BigDecimal differenceratio = (BigDecimal) creatorDObj.getBigDecimal("tpv_differenceratio");
                    BigDecimal difference = (BigDecimal) creatorDObj.getBigDecimal("tpv_difference");
                    //进行赋值
                    if (flowvariance.compareTo(difference) == -1) {
                        this.getModel().setValue("tpv_fine", 0);//给罚金赋值 tpv_fine
                    } else if (variancerate.compareTo(differenceratio) == -1) {
                        this.getModel().setValue("tpv_fine", 0);
                    } else {
                        BigDecimal fine = flowvariance.abs().divide(projectedfunds.abs(), 2, BigDecimal.ROUND_HALF_UP);
                        fine = fine.subtract(differenceratio);
                        fine = fine.multiply(new BigDecimal(0.01));
                        fine = fine.multiply(projectedfunds.abs());
                        this.getModel().setValue("tpv_fine", fine);
                    }
                    String str = "";
                    if (flowvariance.compareTo(difference) == -1) {
                        BigDecimal illustrate = difference.subtract(flowvariance);
                        String a = illustrate.toString();
                        a = "差异金额小于" + a;
                        str += a;
                    }
                    if (variancerate.compareTo(differenceratio) == -1) {
                        BigDecimal illustrates = differenceratio.subtract(variancerate);
                        String b = illustrates.toString();
                        b = "差异率小于" + b;
                        str += b;
                    }
                    if (str != null) {
                        this.getModel().setValue("tpv_illustrate", str);//给说明赋值 tpv_illustrate
                    }
                }
        }
    }
}