package tpv.tpv_wm.tpv_sc.java.formplugin.form;

import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * @Description: 部门资金额度(测算) -表单插件
 * @Author LinRui
 * @Date 2024/7/16 17:36
 */
public class FundsLimtMeasFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent beforeF7SelectEvent) {

    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String propertyName = e.getProperty().getName();// 获取字段
        switch (propertyName) {
            case "tpv_company":
                this.getModel().deleteEntryData("tpv_entryentity");
                DynamicObject tpvCompany = (DynamicObject) this.getModel().getValue("tpv_company");
                if (YEM.isNotEmpty(tpvCompany)) {
                    QFilter orgdutyQfilter = new QFilter("enable", QCP.equals, "1");
                    orgdutyQfilter.and(new QFilter("orgduty.number", QCP.in, new String[]{"ZHKC002"}));
                    DynamicObject[] orgduty = BusinessDataServiceHelper.load("bos_org_dutyrelation", "org",
                            orgdutyQfilter.toArray());
                    List<Long> orgdutyIds = new ArrayList<>();
                    if (orgduty.length > 0) {
                        for (DynamicObject dynamicObject : orgduty) {
                            if (YEM.isNotEmpty(dynamicObject.getDynamicObject("org"))) {
                                if (!orgdutyIds.contains(dynamicObject.getDynamicObject("org").getLong("id"))) {
                                    orgdutyIds.add(dynamicObject.getDynamicObject("org").getLong("id"));
                                }
                            }
                        }
                    }

                    QFilter demtsQfilter = new QFilter("fromorg.id", QCP.equals, tpvCompany.getLong("id"));
                    demtsQfilter.and(new QFilter("toorg.orgpattern.number", QCP.equals, "Orgform06"));
                    if (orgdutyIds.size() > 0) {
                        demtsQfilter.and(new QFilter("toorg.id", QCP.in, orgdutyIds));
                    } else {
                        return;
                    }
                    DynamicObject[] demts = BusinessDataServiceHelper.load( "bos_org_orgrelation_dept", "toorg,fromorg",
                            demtsQfilter.toArray(), "toorg.number asc");
                    if (demts.length > 0) {
                        for (DynamicObject demt : demts) {
                            int newEntryRow = this.getView().getModel().createNewEntryRow("tpv_entryentity");
                            this.getModel().setValue("tpv_departments", demt.getDynamicObject("toorg"), newEntryRow);
                        }
                    }
                }
                break;
        }
    }

}
