package tpv.tpv_wm.tpv_sc.java.formplugin.form;

import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.dataentity.metadata.dynamicobject.DynamicObjectType;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.ConfirmCallBackListener;
import kd.bos.form.IFormView;
import kd.bos.form.MessageBoxOptions;
import kd.bos.form.MessageBoxResult;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.MessageBoxClosedEvent;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import tpv.tpv_wm.tpv_sc.java.report.FundsUsedsQueryRpt;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Description: 资金占用明细（财务） -表单插件
 * @Author LinRui
 * @Date 2024/2/27 14:52
 */
public class FundsUsedsFormPlugin extends AbstractBillPlugIn {
    private static final String entryKey_1 = "tpv_sc_fundsused_aa";
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tpv_advcontoolbarap","tbmain");
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey().toLowerCase();
        switch (itemKey) {
            case "tpv_depfundsuse":
                depfundsuseClick(); //返回凭证数据
                entryRecalculate(); //分录重新计算
                break;
            case "tpv_depfundsdel":
                this.getModel().deleteEntryData(entryKey_1);
                break;
            default:
                break;
        }
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String key = e.getOperateKey();
        if (StringUtils.equals("tpv_initbtn", key)) { //资金初始化操作，赋值
            //作废操作前让用户选择是否继续作废操作，在用户点击确认框上的按钮后，系统会调用confirmCallBack方法
            ConfirmCallBackListener confirmCallBackListener = new ConfirmCallBackListener("tpv_initbtn", this);
            //设置页面确认框，参数为：标题，选项框类型，回调监听
            this.getView().showConfirm("是否将本单作为资金初始化数据？", MessageBoxOptions.YesNo, confirmCallBackListener);
        }
    }

    @Override
    public void confirmCallBack(MessageBoxClosedEvent messageBoxClosedEvent) {
        super.confirmCallBack(messageBoxClosedEvent);
        super.confirmCallBack(messageBoxClosedEvent);
        //判断是否是对应确认框的点击回调事件
        if (StringUtils.equals("tpv_initbtn", messageBoxClosedEvent.getCallBackId())) {
            if (MessageBoxResult.Yes.equals(messageBoxClosedEvent.getResult())) {
                //如果点击确认按钮，则把设置初始化复选框
                this.getModel().setValue("tpv_isinitcheck", true);
            } else if (MessageBoxResult.No.equals(messageBoxClosedEvent.getResult())) {
                // 点击否的相关处理逻辑。。。。
            }
        }
    }

    private void entryRecalculate() {
        IDataModel model = getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        Date tpvYear = dataEntity.getDate("tpv_year");
        String tpvMonth = dataEntity.getString("tpv_month");
        Map<String,Map<String,BigDecimal>> map = new HashMap<>();
        Date dayStartTime = null;
        Date dayEndTime = null;
        if (YEM.isNotEmpty(tpvMonth) && null != tpvYear) {
            int i = monthConvertInt(tpvMonth);
            Calendar ca = Calendar.getInstance();
            ca.setTime(tpvYear);
            ca.set(2, i - 2);
            ca.set(5, ca.getActualMaximum(5));
            Date monthToEndDay = ca.getTime(); //当前 年 当前 月的最后一天
            dayStartTime = getDayStartTime(monthToEndDay);
            dayEndTime = getDayEndTime(monthToEndDay);
        }
        if (YEM.isNotEmpty(dayStartTime) && YEM.isNotEmpty(dayEndTime)) {
            String selectfields = "tpv_sc_fundsused_aa,tpv_sc_fundsused_aa.tpv_businessdate tpv_businessdate," +
                    "tpv_sc_fundsused_aa.tpv_companys tpv_companys," +
                    "tpv_sc_fundsused_aa.tpv_depertment tpv_depertment," +
                    "tpv_sc_fundsused_aa.tpv_occupied tpv_occupied," +
                    "tpv_sc_fundsused_aa.tpv_occupyamt tpv_occupyamt," +
                    "tpv_sc_fundsused_aa.tpv_holdamt tpv_holdamt," +
                    "tpv_sc_fundsused_aa.tpv_useamt tpv_useamt," +
                    "tpv_sc_fundsused_aa.tpv_needamt tpv_needamt," +
                    "tpv_sc_fundsused_aa.tpv_accamt tpv_accamt";
            List<QFilter> qFilter = new ArrayList<>();
            qFilter.add(new QFilter("billstatus", QCP.equals, "C"));
            qFilter.add(new QFilter("tpv_sc_fundsused_aa.tpv_businessdate", QCP.large_equals, dayStartTime));
            qFilter.add(new QFilter("tpv_sc_fundsused_aa.tpv_businessdate", QCP.less_equals, dayEndTime));
            qFilter.add(new QFilter("tpv_sc_fundsused_aa",QCP.large_than,0));
            DataSet dataSet = ORM.create().queryDataSet("tpv_sc_fundsused", "tpv_sc_fundsused", selectfields , qFilter.toArray(new QFilter[qFilter.size()]));
            dataSet = dataSet.select("tpv_businessdate", "tpv_companys", "tpv_depertment", "tpv_occupied", "tpv_occupyamt",
                    "tpv_holdamt", "tpv_useamt", "tpv_needamt", "tpv_accamt", "to_char(tpv_businessdate,'yyyy-MM-dd') tpv_day");
            dataSet = dataSet.groupBy(new String[]{"tpv_companys", "tpv_depertment","tpv_day"})
                    .sum("tpv_occupied").sum("tpv_occupyamt").sum("tpv_holdamt").sum("tpv_useamt")
                    .sum("tpv_needamt").sum("tpv_accamt").finish();
            for (Row row : dataSet) {
                Map<String,BigDecimal> decimalMap = new HashMap<>();
                String tpvCompanys = row.getString("tpv_companys");
                String tpvDepertment = row.getString("tpv_depertment");
                BigDecimal tpvOccupied = row.getBigDecimal("tpv_occupied") != null ? row.getBigDecimal("tpv_occupied") : BigDecimal.ZERO;
                BigDecimal tpvOccupyamt = row.getBigDecimal("tpv_occupyamt") != null ? row.getBigDecimal("tpv_occupyamt") : BigDecimal.ZERO;
                BigDecimal tpvHoldamt = row.getBigDecimal("tpv_holdamt") != null ? row.getBigDecimal("tpv_holdamt") : BigDecimal.ZERO;
                BigDecimal tpvUseamt = row.getBigDecimal("tpv_useamt") != null ? row.getBigDecimal("tpv_useamt") : BigDecimal.ZERO;
                BigDecimal tpvNeedamt = row.getBigDecimal("tpv_needamt") != null ? row.getBigDecimal("tpv_needamt") : BigDecimal.ZERO;
                BigDecimal tpvAccamt = row.getBigDecimal("tpv_accamt") != null ? row.getBigDecimal("tpv_accamt") : BigDecimal.ZERO;
                String strOrgDept = tpvCompanys + tpvDepertment;
                decimalMap.put("tpv_occupied",tpvOccupied);decimalMap.put("tpv_occupyamt",tpvOccupyamt);
                decimalMap.put("tpv_holdamt",tpvHoldamt);decimalMap.put("tpv_useamt",tpvUseamt);
                decimalMap.put("tpv_needamt",tpvNeedamt);decimalMap.put("tpv_accamt",tpvAccamt);
                map.put(strOrgDept,decimalMap);
            }
        }
        DynamicObjectCollection entryData = this.getModel().getEntryEntity(entryKey_1);
        if (entryData.size() > 0) {
//            BigDecimal tpv_occupiedN = BigDecimal.ZERO;  BigDecimal tpv_occupyamtN = BigDecimal.ZERO;
//            BigDecimal tpv_holdamtN = BigDecimal.ZERO;  BigDecimal tpv_useamtN = BigDecimal.ZERO;
//            BigDecimal tpv_needamtN = BigDecimal.ZERO;  BigDecimal tpv_accamtN = BigDecimal.ZERO;

            for (int i = 0; i < entryData.size(); i++) {
                DynamicObject dynamicObject = entryData.get(i);
                BigDecimal tpv_occupied = BigDecimal.ZERO;  BigDecimal tpv_interest = BigDecimal.ZERO;
                BigDecimal tpv_occupyamt = BigDecimal.ZERO;  BigDecimal tpv_interests = BigDecimal.ZERO;
                BigDecimal tpv_holdamt = BigDecimal.ZERO;  BigDecimal tpv_accrual = BigDecimal.ZERO;
                BigDecimal tpv_useamt = BigDecimal.ZERO;  BigDecimal tpv_return = BigDecimal.ZERO;
                BigDecimal tpv_needamt = BigDecimal.ZERO;  BigDecimal tpv_gain = BigDecimal.ZERO;
                BigDecimal tpv_accamt = BigDecimal.ZERO;  BigDecimal tpv_favourable = BigDecimal.ZERO;

                BigDecimal tpvAdd = dynamicObject.getBigDecimal("tpv_add");//增加(现款)
                BigDecimal tpvReduce = dynamicObject.getBigDecimal("tpv_reduce");//减少(现款)
                BigDecimal tpvCashaddrate = dynamicObject.getBigDecimal("tpv_cashaddrate"); //日利率(%)
                BigDecimal tpvCashlessrate = dynamicObject.getBigDecimal("tpv_cashlessrate"); //负占用利率(%)
                BigDecimal tpvOccupied = dynamicObject.getBigDecimal("tpv_occupied"); //占用金额初始值，存放【资金占用调整】调整收入金额

                BigDecimal tpvIncrease = dynamicObject.getBigDecimal("tpv_increase");//增加(应收票据（银承）)
                BigDecimal tpvDecrease = dynamicObject.getBigDecimal("tpv_decrease");//减少(应收票据（银承）)
                BigDecimal tpvReceiveaddrate = dynamicObject.getBigDecimal("tpv_receiveaddrate"); //日利率(%)
                BigDecimal tpvReceivelessrate = dynamicObject.getBigDecimal("tpv_receivelessrate"); //负占用利率(%)
                BigDecimal tpvOccupyamt = dynamicObject.getBigDecimal("tpv_occupyamt"); //占用金额初始值0

                BigDecimal tpvAugment = dynamicObject.getBigDecimal("tpv_augment");//增加(应付票据（银承）)
                BigDecimal tpvLessen = dynamicObject.getBigDecimal("tpv_lessen");//减少(应付票据（银承）)
                BigDecimal tpvPayaddrate = dynamicObject.getBigDecimal("tpv_payaddrate"); //日利率(%)
                BigDecimal tpvPaylessrate = dynamicObject.getBigDecimal("tpv_paylessrate"); //负占用利率(%)
                BigDecimal tpvHoldamt = dynamicObject.getBigDecimal("tpv_holdamt"); //占用金额初始值0

                BigDecimal tpvEnhance = dynamicObject.getBigDecimal("tpv_enhance");//增加(应收票据（商票）)
                BigDecimal tpvLittle = dynamicObject.getBigDecimal("tpv_little");//减少(应收票据（商票）)
                BigDecimal tpvCprcvddrate = dynamicObject.getBigDecimal("tpv_cprcvddrate"); //日利率(%)
                BigDecimal tpvCprcvlessrate = dynamicObject.getBigDecimal("tpv_cprcvlessrate"); //负占用利率(%)
                BigDecimal tpvUseamt = dynamicObject.getBigDecimal("tpv_useamt"); //占用金额初始值0

                BigDecimal tpvPlus = dynamicObject.getBigDecimal("tpv_plus");//增加(应付票据（商票）)
                BigDecimal tpvFew = dynamicObject.getBigDecimal("tpv_few");//减少(应付票据（商票）)
                BigDecimal tpvCppayaddrate = dynamicObject.getBigDecimal("tpv_cppayaddrate"); //日利率(%)
                BigDecimal tpvCppaylessrate = dynamicObject.getBigDecimal("tpv_cppaylessrate"); //负占用利率(%)
                BigDecimal tpvNeedamt = dynamicObject.getBigDecimal("tpv_needamt"); //占用金额初始值0

                BigDecimal tpvAug = dynamicObject.getBigDecimal("tpv_aug");//增加(供应链票据)
                BigDecimal tpvMinus = dynamicObject.getBigDecimal("tpv_minus");//减少(供应链票据)
                BigDecimal tpvScmproaddrate = dynamicObject.getBigDecimal("tpv_scmproaddrate"); //日利率(%)
                BigDecimal tpvScmprolessrate = dynamicObject.getBigDecimal("tpv_scmprolessrate"); //负占用利率(%)
                BigDecimal tpvAccamt = dynamicObject.getBigDecimal("tpv_accamt"); //占用金额初始值0

                Date tpvBusinessdate = dynamicObject.getDate("tpv_businessdate");
                SimpleDateFormat strDay = new SimpleDateFormat("yyyy-MM-dd");
                String format = strDay.format(tpvBusinessdate);
                String[] split = format.split("-");
                DynamicObject tpvCompanys = dynamicObject.getDynamicObject("tpv_companys");
                DynamicObject tpvDepertment = dynamicObject.getDynamicObject("tpv_depertment");
                String tpvCompanysId = "";
                String tpvDepertmentId = "";
                if (YEM.isNotEmpty(tpvCompanys)) {
                    tpvCompanysId = tpvCompanys.getString("id");
                }
                if (YEM.isNotEmpty(tpvDepertment)) {
                    tpvDepertmentId = tpvDepertment.getString("id");
                }
                String strOrgDept = tpvCompanysId + tpvDepertmentId;
                if ("01".equals(split[2]) && map.containsKey(strOrgDept)) {
                    tpv_occupied = tpvReduce.subtract(tpvAdd).subtract(tpvOccupied).add(map.get(strOrgDept).get("tpv_occupied")); //现款
                    tpv_interest = tpv_occupied.compareTo(BigDecimal.ZERO) >= 0 ? tpv_occupied.multiply(tpvCashaddrate)
                            : tpv_occupied.multiply(tpvCashlessrate);
                    tpv_occupyamt = tpvDecrease.subtract(tpvIncrease).subtract(tpvOccupyamt).add(map.get(strOrgDept).get("tpv_occupyamt")); //应收票据（银承）
                    tpv_interests = tpv_occupyamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_occupyamt.multiply(tpvReceiveaddrate)
                            : tpv_occupyamt.multiply(tpvReceivelessrate);
                    tpv_holdamt = tpvAugment.subtract(tpvLessen).subtract(tpvHoldamt).add(map.get(strOrgDept).get("tpv_holdamt")); //应付票据（银承）
                    tpv_accrual = tpv_holdamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_holdamt.multiply(tpvPayaddrate)
                            : tpv_holdamt.multiply(tpvPaylessrate);
                    tpv_useamt = tpvLittle.subtract(tpvEnhance).subtract(tpvUseamt).add(map.get(strOrgDept).get("tpv_useamt")); //应收票据（商票）
                    tpv_return = tpv_useamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_useamt.multiply(tpvCprcvddrate)
                            : tpv_useamt.multiply(tpvCprcvlessrate);
                    tpv_needamt = tpvPlus.subtract(tpvFew).subtract(tpvNeedamt).add(map.get(strOrgDept).get("tpv_needamt")); //应付票据（商票）
                    tpv_gain = tpv_needamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_needamt.multiply(tpvCppayaddrate)
                            : tpv_needamt.multiply(tpvCppaylessrate);
                    tpv_accamt = tpvMinus.subtract(tpvAug).subtract(tpvAccamt).add(map.get(strOrgDept).get("tpv_accamt")); //供应链票据
                    tpv_favourable = tpv_accamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_accamt.multiply(tpvScmproaddrate)
                            : tpv_accamt.multiply(tpvScmprolessrate);
                } else {
                    if (i != 0) {
                        int indexUp = i - 1;
                        DynamicObject tpvCompanysN = (DynamicObject) this.getModel().getValue("tpv_companys",indexUp);
                        DynamicObject tpvDepertmentN =  (DynamicObject) this.getModel().getValue("tpv_depertment",indexUp);
                        String tpvCompanysNId = "";
                        String tpvDepertmentNId = "";
                        if (YEM.isNotEmpty(tpvCompanysN)) {
                            tpvCompanysNId = tpvCompanysN.getString("id");
                        }
                        if (YEM.isNotEmpty(tpvDepertmentN)) {
                            tpvDepertmentNId = tpvDepertmentN.getString("id");
                        }
                        String strOrgDeptN = tpvCompanysNId + tpvDepertmentNId;
                        if (strOrgDeptN.equals(strOrgDept)) {
                            tpv_occupied = (BigDecimal) this.getModel().getValue("tpv_occupied",indexUp);
                            tpv_occupyamt = (BigDecimal) this.getModel().getValue("tpv_occupyamt",indexUp);
                            tpv_holdamt = (BigDecimal) this.getModel().getValue("tpv_holdamt",indexUp);
                            tpv_useamt = (BigDecimal) this.getModel().getValue("tpv_useamt",indexUp);
                            tpv_needamt = (BigDecimal) this.getModel().getValue("tpv_needamt",indexUp);
                            tpv_accamt = (BigDecimal) this.getModel().getValue("tpv_accamt",indexUp);
                        }
                    }
                    tpv_occupied = tpvReduce.subtract(tpvAdd).add(tpv_occupied).subtract(tpvOccupied);
                    tpv_interest = tpv_occupied.compareTo(BigDecimal.ZERO) >= 0 ? tpv_occupied.multiply(tpvCashaddrate)
                            : tpv_occupied.multiply(tpvCashlessrate);
                    tpv_occupyamt = tpvDecrease.subtract(tpvIncrease).add(tpv_occupyamt).subtract(tpvOccupyamt);
                    tpv_interests = tpv_occupyamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_occupyamt.multiply(tpvReceiveaddrate)
                            : tpv_occupyamt.multiply(tpvReceivelessrate);
                    tpv_holdamt = tpvAugment.subtract(tpvLessen).add(tpv_holdamt).subtract(tpvHoldamt);
                    tpv_accrual = tpv_holdamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_holdamt.multiply(tpvPayaddrate)
                            : tpv_holdamt.multiply(tpvPaylessrate);
                    tpv_useamt = tpvLittle.subtract(tpvEnhance).add(tpv_useamt).subtract(tpvUseamt);
                    tpv_return = tpv_useamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_useamt.multiply(tpvCprcvddrate)
                            : tpv_useamt.multiply(tpvCprcvlessrate);
                    tpv_needamt = tpvPlus.subtract(tpvFew).add(tpv_needamt).subtract(tpvNeedamt);
                    tpv_gain = tpv_needamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_needamt.multiply(tpvCppayaddrate)
                            : tpv_needamt.multiply(tpvCppaylessrate);
                    tpv_accamt = tpvMinus.subtract(tpvAug).add(tpv_accamt).subtract(tpvAccamt);
                    tpv_favourable = tpv_accamt.compareTo(BigDecimal.ZERO) >= 0 ? tpv_accamt.multiply(tpvScmproaddrate)
                            : tpv_accamt.multiply(tpvScmprolessrate);
                }
                this.getModel().setValue("tpv_occupied",tpv_occupied,i); //占用金额(现款)
                this.getModel().setValue("tpv_interest",tpv_interest,i); //利息(现款)
                this.getModel().setValue("tpv_occupyamt",tpv_occupyamt,i); //占用金额(应收票据（银承）)
                this.getModel().setValue("tpv_interests",tpv_interests,i); //利息(应收票据（银承）)
                this.getModel().setValue("tpv_holdamt",tpv_holdamt,i); //占用金额(应付票据（银承）)
                this.getModel().setValue("tpv_accrual",tpv_accrual,i); //利息(应付票据（银承）)
                this.getModel().setValue("tpv_useamt",tpv_useamt,i); //占用金额(应收票据（商票）)
                this.getModel().setValue("tpv_return",tpv_return,i); //利息(应收票据（商票）)
                this.getModel().setValue("tpv_needamt",tpv_needamt,i); //占用金额(应付票据（商票）)
                this.getModel().setValue("tpv_gain",tpv_gain,i); //利息(应付票据（商票）)
                this.getModel().setValue("tpv_accamt",tpv_accamt,i); //占用金额(供应链票据)
                this.getModel().setValue("tpv_favourable",tpv_favourable,i); //利息(供应链票据)
            }
        }
    }

    private void depfundsuseClick() {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        List<String> notInputs = new ArrayList<>();
        YEM.getNotNull(view, notInputs, dataEntity, "tpv_company");
        YEM.getNotNull(view, notInputs, dataEntity, "tpv_year");
        YEM.getNotNull(view, notInputs, dataEntity, "tpv_month");
        if (notInputs.size() > 0) {
            view.showTipNotification(String.format("请先填写【%s】。", String.join("、", notInputs)));
        } else {
            Date tpvYear = dataEntity.getDate("tpv_year");
            DynamicObject tpvCompany = dataEntity.getDynamicObject("tpv_company");
            String tpvMonth = dataEntity.getString("tpv_month");
            int monthed = monthConvertInt(tpvMonth);
            if (monthed == 1) {
                monthed = 12;
                tpvYear = DateUtil.getLastMonthDay(tpvYear);
            } else {
                monthed = monthed - 1;
            }
            String convertmonth = IntConvertmonth(monthed);
            QFilter qFilter = new QFilter("billstatus", QCP.equals, "C");
            qFilter.and(new QFilter("tpv_company", QCP.equals, tpvCompany.getLong("id")));
            qFilter.and(new QFilter("tpv_year", QCP.equals, tpvYear));
            qFilter.and(new QFilter("tpv_month", QCP.equals, convertmonth));
            DynamicObject[] load = BusinessDataServiceHelper.load(dataEntity.getDataEntityType().getName(), "id,tpv_year,tpv_company,tpv_month", qFilter.toArray());
            boolean tpvIsinitcheck = (boolean) this.getModel().getValue("tpv_isinitcheck");
            if (load.length == 0 && !tpvIsinitcheck) {
                Calendar calendar = Calendar.getInstance();
                calendar.setTime(tpvYear);
                this.getView().showTipNotification("公司为 " + calendar.get(Calendar.YEAR)  + "年" + monthed + "月的资金占用未审核，本月资金占用不能生成，请检查！");
            } else {
                depfundsuseData();
            }
        }
    }

    private void depfundsuseData() {
        IFormView view = this.getView();
        IDataModel model = view.getModel();
        model.deleteEntryData(entryKey_1);   //清除分录
        DynamicObject dataEntity = model.getDataEntity(true);
        String format =  "》";
        String whereFilter = "1=1";
        //公司
        DynamicObject tpvCompany = dataEntity.getDynamicObject("tpv_company");
        if (null != tpvCompany){
            format = format + tpvCompany.getLong("id") + "》";
            whereFilter = String.format("%s and createorgid = %s", whereFilter, tpvCompany.getLong("id"));
        }
        Date tpvYear = dataEntity.getDate("tpv_year");
        SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String tpvMonth = dataEntity.getString("tpv_month");
        if (YEM.isNotEmpty(tpvMonth) && null != tpvYear) {
            int i = monthConvertInt(tpvMonth);
            Calendar ca = Calendar.getInstance();
            ca.setTime(tpvYear);
            ca.set(2, i - 1);
            Date monthFirstDay = DateUtil.getMonthFirstDay(ca.getTime());//当前 年 当前 月的第一天
            Date monthToEndDay = DateUtil.getMonthEndDay(ca.getTime()); //当前 年 当前 月的最后一天
            Date dayStartTime = getDayStartTime(monthFirstDay);
            Date dayEndTime = getDayEndTime(monthToEndDay);
            String formatStart =  str.format(dayStartTime);
            String formatEnd =  str.format(dayEndTime);
            format = format + formatStart + "》" + formatEnd;
            whereFilter = String.format("%s and bizdate >= to_date('" + formatStart + "','yyyy-MM-dd HH:mm:ss')", whereFilter);
            whereFilter = String.format("%s and bizdate <= to_date('" + formatEnd + "','yyyy-MM-dd HH:mm:ss')", whereFilter);
        }
        whereFilter = whereFilter + format;
        DataSet query = FundsUsedsQueryRpt.query(whereFilter);
        DynamicObjectType enrtyType = model.getEntryEntity(entryKey_1).getDynamicObjectType();
        DataEntityPropertyCollection properties = enrtyType.getProperties();
        List<String> dataSetAliasList = RptUtil.getDataSetAliasList(query);
        for (Row row : query) {
            int index = model.createNewEntryRow(entryKey_1);
            for (IDataEntityProperty property : properties) {
                String key = property.getName();
                if (dataSetAliasList.contains(key)) {
                    model.setValue(key, row.get(key), index);
                }
            }
        }
    }

    /**
     * @Description: //将月份数值转为整数
     * @param: month
     **/
    private int monthConvertInt(String month) {
        if (YEM.isNotEmpty(month)) {
            int i = 0;
            switch (month) {
                case "Jan": i = 1;break; case "Feb": i = 2;break; case "Mar": i = 3;break;
                case "Apr": i = 4;break; case "May": i = 5;break; case "Jun": i = 6;break;
                case "Jul": i = 7;break; case "Aug": i = 8;break; case "Sep": i = 9;break;
                case "Oct": i = 10;break; case "Nov": i = 11;break; case "Dec": i = 12;break;
                default:
                    break;
            }
            return i;
        }
        return 0;
    }

    /**
     * @Description: //将月份数值转为整数
     * @param: month
     **/
    private static String IntConvertmonth(int month) {
        if (YEM.isNotEmpty(month)) {
            String monthValue = "";
            switch (month) {
                case 1: monthValue = "Jan";break; case 2: monthValue = "Feb";break; case 3: monthValue = "Mar";break;
                case 4: monthValue = "Apr";break; case 5: monthValue = "May";break; case 6: monthValue = "Jun";break;
                case 7: monthValue = "Jul";break; case 8: monthValue = "Aug";break; case 9: monthValue = "Sep";break;
                case 10: monthValue = "Oct";break; case 11: monthValue = "Nov";break; case 12: monthValue = "Dec";break;
                default:
                    break;
            }
            return monthValue;
        }
        return null;
    }

    /**
     * 获取日期的结束时间
     */
    public static Date getDayEndTime(Date date) {
        if (date == null) {
            return null;
        } else {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(date);
            calendar.set(calendar.get(1), calendar.get(2), calendar.get(5), 23, 59, 59);
            calendar.set(14, 999);
            return calendar.getTime();
        }
    }

    /**
     * 获取该日期的开始时间
     */
    public static Date getDayStartTime(Date date) {
        if (date == null) {
            return null;
        } else {
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(date);
            calendar.set(calendar.get(1), calendar.get(2), calendar.get(5), 0, 0, 0);
            calendar.set(14, 0);
            return calendar.getTime();
        }
    }

}
