package tpv.tpv_wm.tpv_sc.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.IFormView;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.util.EventObject;

/**
 * @author ljw
 * @version 1.0
 * @description:期货出/入金申请单 期货公司带出对方账户和对方银行
 * @date 2023/8/11 21:32
 */
public class FuturesapplicationAbstractBillPlugIn extends AbstractBillPlugIn implements BeforeF7SelectListener {
    @Override
    //值更新
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        //获取银行信息的单据体
        String name = e.getProperty().getName();
        ChangeData[] changeData = e.getChangeSet();
        int rowIndex = changeData[0].getRowIndex();
        switch (name) {
            case "tpv_futurescompanies":
                DynamicObject futurescompanies = (DynamicObject) this.getModel().getValue("tpv_futurescompanies");//获取期货公司
                if (futurescompanies != null) {
                    DynamicObjectCollection entrys = futurescompanies.getDynamicObjectCollection("entry_bank");// 获取银行信息的单据体
                    for (DynamicObject entry : entrys) {// 循环单据体
                        DynamicObject bank = entry.getDynamicObject("bank");//获取到对方账户的值
                        String isdefaultBank = entry.getString("isdefault_bank");
                        String bankaccount = entry.getString("bankaccount");//对方银行
                        if ("true".equals(isdefaultBank)) {
                            if (bank != null) {
                                this.getModel().setValue("tpv_counterparty", bank);//对对方账户进行赋值
                            } else {
                                this.getModel().setValue("tpv_counterparty", null);// 对对方账户进行赋值
                            }
                            if (bankaccount != null){
                                this.getModel().setValue("tpv_theotherbank",bankaccount);
                            }else {
                                this.getModel().setValue("tpv_theotherbank",null);
                            }
                        }
                    }
                } else {
                    this.getModel().setValue("tpv_counterparty", null);
                }
        }
    }

    /**
     * 根据所选部门过滤显示采购合同号和采购销售号
     *对方账户根据期货公司过滤
     * @param e
     */
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit supplies = this.getControl("tpv_purchasecontract");//采购合同号
        supplies.addBeforeF7SelectListener(this);
        BasedataEdit alescontract = this.getControl("tpv_salescontract");//采购销售号
        alescontract.addBeforeF7SelectListener(this);
        BasedataEdit counterparty = this.getControl("tpv_counterparty");//对方账户
        alescontract.addBeforeF7SelectListener(this);
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String key = e.getProperty().getName();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        IDataModel model = this.getModel();
        IFormView view = this.getView();
        DynamicObject tpv_department = dataEntity.getDynamicObject("tpv_department");
        DynamicObject org = dataEntity.getDynamicObject("org");
        DynamicObject futurescompanies = dataEntity.getDynamicObject("tpv_futurescompanies");
        if (tpv_department != null || org != null) {
            QFilter qFilter = new QFilter("billstatus",QCP.equals, "C");
            if (tpv_department != null){
                 qFilter.and(new QFilter("tpv_department", QCP.equals, tpv_department.getLong("id")));
            }
            if (org != null ){
                qFilter.and(new QFilter("org", QCP.equals, org.getLong("id")));
            }
            if ("tpv_purchasecontract".equals(key)) {
                ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
                showParameter.getListFilterParameter().getQFilters().add(qFilter);

            }
            if ("tpv_salescontract".equals(key)) {
                ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
                showParameter.getListFilterParameter().getQFilters().add(qFilter);
            }
        }
        if (futurescompanies != null){
            QFilter qFilter = new QFilter("tpv_bd_supplier_ext.number",QCP.equals, futurescompanies.getString("number"));
            if ("tpv_futurescompanies".equals(key)){
                ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
                showParameter.getListFilterParameter().getQFilters().add(qFilter);
            }
        }
    }
}
