package tpv.tpv_wm.tpv_sc.java.formplugin.list;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.control.events.BeforeItemClickEvent;
import kd.bos.list.IListView;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.ArrayList;

/**
 * ClassName: DeptFundLimit
 * Description:部门资金临时额度插件(列表)
 * date: 2023/8/30 16:20
 *
 * @author: chen
 * @version:
 * @since JDK 1.8
 */
public class DeptFundLimitListPlugin extends AbstractListPlugin {
    private static final String BUTTON_DISABLE = "tpv_tbldisable";
    private static final String BUTTON_ENABLE = "tblenable";
    @Override
    public void beforeItemClick(BeforeItemClickEvent evt) {
        super.beforeItemClick(evt);
        String key = evt.getItemKey();
        IListView listview = (IListView) this.getView();
        String formId = ((IListView) this.getView()).getBillFormId();// 获取单据标识
        ListSelectedRowCollection selectedRows = listview.getSelectedRows();//获取选中行
        //禁用
        if (BUTTON_DISABLE.equals(key)){
            ArrayList<DynamicObject> updateRows = new ArrayList<>();
            for (ListSelectedRow row : selectedRows) {
                Object primaryKeyValue = row.getPrimaryKeyValue();//获取单据的PKid
                DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(primaryKeyValue, formId);
                //修改禁用
                loadSingle.set("tpv_forbidden",true);
                // 将修改后的数据存入集合
                updateRows.add(loadSingle);
            }
            if (updateRows.size() > 0) {
                // 保存修改后的数据
                SaveServiceHelper.update(updateRows.toArray(new DynamicObject[]{}));
            }
            ((IListView) this.getView()).refresh();
        }
        //启用
        if (BUTTON_ENABLE.equals(key)){
            ArrayList<DynamicObject> updateRows = new ArrayList<>();
            for (ListSelectedRow row : selectedRows) {
                Object primaryKeyValue = row.getPrimaryKeyValue();//获取单据的PKid
                DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(primaryKeyValue, formId);
                //修改启用
                loadSingle.set("tpv_forbidden",false);
                // 将修改后的数据存入集合
                updateRows.add(loadSingle);
            }
            if (updateRows.size() > 0) {
                // 保存修改后的数据
                SaveServiceHelper.update(updateRows.toArray(new DynamicObject[]{}));
            }
            ((IListView) this.getView()).refresh();
        }
    }
}
