package tpv.tpv_wm.tpv_sc.java.formplugin.list;

import com.alibaba.druid.util.StringUtils;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.list.BillList;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.coderule.CodeRuleServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @author LiuHB
 * @version 1.0
 * 点击生成结算按钮生成押汇融资结算单
 */
public class InterExpensesIIListPlugin extends AbstractListPlugin {
    private final static String KEY_MBAR = "tbmain";//工具栏

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("tbmain", "advcontoolbarap");
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey();
        if (StringUtils.equals("tpv_settinfor", itemKey)) {

            FormShowParameter showParameter = new FormShowParameter();

            showParameter.setFormId("tpv_sc_backfillplugin");

            showParameter.setStatus(OperationStatus.ADDNEW);

            showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_settinfor"));

            showParameter.getOpenStyle().setShowType(ShowType.Modal);

            this.getView().showForm(showParameter);
        }
    }

    public void setbillfinansett(ArrayList<HashMap<String, Object>> list) {
        for (HashMap<String, Object> hashMap : list) {
            DynamicObject data = BusinessDataServiceHelper.newDynamicObject("tpv_sc_billfinansett");
            String number = CodeRuleServiceHelper.getNumber("tpv_sc_billfinansett", data, null);
            Long currentUserId = UserServiceHelper.getCurrentUserId();
            //日期
            //时间格式
            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd ");
            //获取当前时间
            Date date = new Date(System.currentTimeMillis());
            //当前用户所属组织
            Long mainOrgId = UserServiceHelper.getUserMainOrgId(currentUserId);

            data.set("billstatus", "A");
            data.set("billno", number);
            //公司
            data.set("org", mainOrgId);
            //部门
            data.set("tpv_department", hashMap.get("tpv_department"));
            //融资申请单号
            data.set("tpv_finapplinum", hashMap.get("tpv_finapplinum"));
            //融资银行
            data.set("tpv_bank", hashMap.get("tpv_bank"));
            //信用证号
            data.set("tpv_lettercredno", hashMap.get("tpv_lettercredno"));
            //合同号
            data.set("tpv_contractnum", hashMap.get("tpv_contractnum"));
            //金额（USD）
            data.set("tpv_amtusd", hashMap.get("tpv_amtusd"));
            //起息日/付汇日
            data.set("tpv_date", hashMap.get("tpv_date"));
            //融资品种
            data.set("tpv_financvar", hashMap.get("tpv_financvar"));
            //实际还款日
            data.set("tpv_repaymentdate", hashMap.get("tpv_repaymentdate"));
            //天数
            data.set("tpv_days", hashMap.get("tpv_days"));
            //实际LIBOR
            data.set("tpv_realibor", hashMap.get("tpv_realibor"));
            //系数
            data.set("tpv_coefficient", hashMap.get("tpv_coefficient"));
            //应收利率
            data.set("tpv_recelibor", hashMap.get("tpv_recelibor"));
            //应收利息（USD）
            data.set("tpv_reinterestusd", hashMap.get("tpv_reinterestusd"));
            //汇率
            data.set("tpv_exchrate", hashMap.get("tpv_exchrate"));
            //应收利息（CNY）
            data.set("tpv_reinterestcny", hashMap.get("tpv_reinterestcny"));
            //母证开证国
            data.set("tpv_country", hashMap.get("tpv_country"));
            //凭证号
            data.set("tpv_voucherno", hashMap.get("tpv_voucherno"));
            SaveServiceHelper.save(new DynamicObject[]{data});//保存
            ((BillList) this.getControl("billlistap")).refresh();
        }
    }

    /**
     * 动态表单关闭回调事件
     */

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {

        Object returnData = closedCallBackEvent.getReturnData();

        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_settinfor")
                && null != closedCallBackEvent.getReturnData()) {

            ArrayList<HashMap<String, Object>> list = (ArrayList<HashMap<String, Object>>) returnData;

            this.setbillfinansett(list);
        }
    }
}
