package tpv.tpv_wm.tpv_sc.java.formplugin.list;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.list.BillList;
import kd.bos.list.IListView;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * @author LiuHB
 * @version 1.0
 * @date 2023/8/22 9:31
 * 1'根据业务员带出部门
 */
public class ProcureListPlugin extends AbstractBillPlugIn {

    // 值更新事件
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);

        String propertyName = e.getProperty().getName();

        String formId = ((IListView) this.getView()).getBillFormId() ;
        BillList billList = this.getControl("billlistap");

        ListSelectedRowCollection ListSelectedRows = billList.getSelectedRows();

        if (ListSelectedRows != null && ListSelectedRows.size() > 0) {
            List<DynamicObject> ListSelectedRowd = new ArrayList<DynamicObject>();
            DynamicObject tempRowData = null;
            for (ListSelectedRow tempRowDataId : ListSelectedRows) {

                tempRowData = BusinessDataServiceHelper.loadSingle(tempRowDataId.getPrimaryKeyValue(), formId);
                if ("tpv_operator".equals(propertyName) || "tpv_department".equals(propertyName)) {
                    DynamicObject operator = tempRowData.getDynamicObject("tpv_operator");
                    DynamicObject department = tempRowData.getDynamicObject("tpv_department");
                    Long operatorId = operator.getLong("Id");
                    Long departmentId = operator.getLong("Id");
                    if (!UserServiceHelper.getOrgsUserJoin(operatorId).contains(operatorId)) {
                        this.getModel().setValue("tpv_department", UserServiceHelper.getUserMainOrgId(operatorId));
                    } else {
                        return;
                    }
                }
            }
        }
    }
}