package tpv.tpv_wm.tpv_sc.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import tpv.tpv_wm.tpv_sc.java.formplugin.form.MoreDeptFundsUse;

import java.util.*;

/**
 * @ClassName: MdepFundsuseSaveOp
 * @Description: 多部门资金占用 单据保存时，检查公司+年+月，已经存在资金占用，提醒“已经存在XX公司XX年XX月的资金占用，编号为XXXX，不可重复生成！”,不可继续。"
 * @author: zbh
 * @date: 2024-07-16
 */
public class MdepFundsuseSaveOp extends AbstractOperationServicePlugIn {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("tpv_year");
        keys.add("tpv_month");
        keys.add("tpv_companys");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new AbstractValidator() {
            @Override
            public void validate() {
                ExtendedDataEntity[] dataEntities = this.getDataEntities();
                for (ExtendedDataEntity dataEntity : dataEntities) {
                    saveOrgValidators(dataEntity);
                }
            }
            public void saveOrgValidators(ExtendedDataEntity dataEntity) {
                DynamicObject entity = dataEntity.getDataEntity();
                Date tpvYear = entity.getDate("tpv_year");
                if (tpvYear==null){
                    return;
                }
                Calendar ca = Calendar.getInstance();
                ca.setTime(tpvYear);
                int year = ca.get(2);
                String tpvMonth = entity.getString("tpv_month");
                int monthed = MoreDeptFundsUse.monthConvertInt(tpvMonth);
                List<Long> entyList = new ArrayList<>();
                Map<Long, String> hashMap = new HashMap<>();
                DynamicObjectCollection tpvCompanys = entity.getDynamicObjectCollection("tpv_companys");
                for (DynamicObject tpvCompany : tpvCompanys) {
                    DynamicObject fbasedataid = tpvCompany.getDynamicObject("fbasedataid");
                    hashMap.put(fbasedataid.getLong("id"),fbasedataid.getString("name"));
                    entyList.add(tpvCompany.getLong("fbasedataid.id"));
                }
                DynamicObject[] tpvScMdepfundsuses = BusinessDataServiceHelper.load("tpv_sc_mdepfundsuse", "tpv_companys,billno",
                        new QFilter[]{new QFilter("tpv_year", "=", tpvYear),
                                new QFilter("tpv_month", "=", tpvMonth),
                                new QFilter("id", QCP.not_equals, entity.getPkValue())});
                for (DynamicObject tpvScMdepfundsus : tpvScMdepfundsuses) {
                    DynamicObjectCollection companys = tpvScMdepfundsus.getDynamicObjectCollection("tpv_companys");
                    for (DynamicObject company : companys) {
                        long companyLong = company.getLong("fbasedataid.id");
                        if (hashMap.containsKey(companyLong)){
                            this.addErrorMessage(dataEntity, "已经存在"+hashMap.get(companyLong)+""+year+"年"+monthed+"月的资金占用，编号为"+tpvScMdepfundsus.getString("billno")+"，不可重复生成！");
                        }
                    }
                }
            }
        });
    }
}
