package tpv.tpv_wm.tpv_sc.java.report;

import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Description: 部门资金池 -报表查询插件
 * @Author LinRui
 * @Date 2024/2/1 11:40
 */
public class DeptFundsPoolQueryRpt extends AbstractReportListDataPlugin {

    private static final String algoKey = DeptFundsPoolQueryRpt.class.getName();

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        return null;
    }

    public static DataSet query(String whereFilters) {
        DataSet mainDataSet = mainDataSet(whereFilters);
        String dayStartTime = splitWhereFilter(whereFilters,1);
        String dayEndTime = splitWhereFilter(whereFilters,2);
        Date startTime = DateUtil.parseDateHms(dayStartTime);
        Date endTime = DateUtil.parseDateHms(dayEndTime);
        Map<String,Map<String,BigDecimal>> fundsUsedRate = fundsUsedRate(startTime, endTime);
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        for (DynamicObject col : col_s) {
            if (fundsUsedRate.size() > 0) {
                for (String key : fundsUsedRate.keySet()) {
                    String[] split = key.split("》");
                    if (col.getString("tpv_companys").equals(split[0])
                            && col.getString("tpv_departments").equals(split[1])) {
                        if (col.getDate("tpv_businessdate").compareTo(DateUtil.parseDateHms(split[2])) >= 0
                                && col.getDate("tpv_businessdate").compareTo(DateUtil.parseDateHms(split[3])) <= 0) {
                            BigDecimal tpv_dayrate = fundsUsedRate.get(key).get("tpv_dayrate");
                            BigDecimal tpv_deoccupyrate = fundsUsedRate.get(key).get("tpv_deoccupyrate");
                            if ("010".equals(split[4])) {
                                col.set("tpv_cashaddrate",tpv_dayrate);
                                col.set("tpv_cashlessrate",tpv_deoccupyrate);
                            }
                            if ("020".equals(split[4])) {
                                col.set("tpv_receiveaddrate",tpv_dayrate);
                                col.set("tpv_receivelessrate",tpv_deoccupyrate);
                            }
                            if ("030".equals(split[4])) {
                                col.set("tpv_payaddrate",tpv_dayrate);
                                col.set("tpv_paylessrate",tpv_deoccupyrate);
                            }
                            if ("040".equals(split[4])) {
                                col.set("tpv_cprcvddrate",tpv_dayrate);
                                col.set("tpv_cprcvlessrate",tpv_deoccupyrate);
                            }
                            if ("050".equals(split[4])) {
                                col.set("tpv_cppayaddrate",tpv_dayrate);
                                col.set("tpv_cppaylessrate",tpv_deoccupyrate);
                            }
                            if ("060".equals(split[4])) {
                                col.set("tpv_scmproaddrate",tpv_dayrate);
                                col.set("tpv_scmprolessrate",tpv_deoccupyrate);
                            }
                            if ("080".equals(split[4])) {
                                col.set("tpv_chinaaddrate",tpv_dayrate);
                                col.set("tpv_chinalessrate",tpv_deoccupyrate);
                            }
                        }
                    }
                }
            }
        }
        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        return createDataSet.orderBy(new String[]{"tpv_companys","tpv_departments","tpv_day","tpv_businessdate",
                "tpv_businessdate asc"});
    }

    private static DataSet mainDataSet(String whereFilters) {
        String whereFilter = splitWhereFilter(whereFilters,0);
        String dayStartTime = splitWhereFilter(whereFilters,1);
        String dayEndTime = splitWhereFilter(whereFilters,2);
        Date startTime = DateUtil.parseDateHms(dayStartTime);
        Date endTime = DateUtil.parseDateHms(dayEndTime);

        QFilter orgdutyQfilter = new QFilter("enable", QCP.equals, "1");
        orgdutyQfilter.and(new QFilter("orgduty.number", QCP.in, new String[]{"ZHKC002"}));
        DataSet orgduty = ORM.create().queryDataSet(algoKey, "bos_org_dutyrelation", "org.id tpv_depid",
                orgdutyQfilter.toArray());
        DataSet copyOrgduty = orgduty.copy();
        List<Long> orgdutyIds = new ArrayList<>();
        for (Row row : copyOrgduty) {
            if (!orgdutyIds.contains(row.getLong("tpv_depid"))) {
                orgdutyIds.add(row.getLong("tpv_depid"));
            }
        }
        
        List<QFilter> qFilter = new ArrayList<>();
        qFilter.add(new QFilter("billstatus", QCP.equals, "C"));
        qFilter.add(new QFilter("tpv_bizdate", QCP.large_equals, startTime));
        qFilter.add(new QFilter("tpv_bizdate", QCP.less_equals, endTime));
        if (orgdutyIds.size() > 0) {
            qFilter.add(new QFilter("tpv_department.id", QCP.in, orgdutyIds));
        } else {
            qFilter.add(new QFilter("tpv_department.id", QCP.less_than, 0));
        }
        DataSet tpv_dt_purchase = ORM.create().queryDataSet(algoKey, "tpv_dt_purchase", "id,tpv_contractnumber," +
                        "tpv_company,tpv_department,tpv_bizdate,tpv_typeofreward,tpv_percentageofprizes,tpv_combinationnumber.id comid," +
                        "tpv_combinationnumber.tpv_finishcheckbox combox,tpv_combinationnumber.tpv_finishdatetime comfinshtime",
                qFilter.toArray(new QFilter[qFilter.size()]));
        DataSet tpv_dt_salescontract = ORM.create().queryDataSet(algoKey, "tpv_dt_salescontract", "id,tpv_contractnos," +
                        "tpv_company,tpv_department,tpv_bizdate,tpv_awardtype,tpv_awardratio,tpv_combinationnumber.id comid," +
                        "tpv_combinationnumber.tpv_finishcheckbox combox,tpv_combinationnumber.tpv_finishdatetime comfinshtime",
                qFilter.toArray(new QFilter[qFilter.size()]));

        DataSet purchaseF = tpv_dt_purchase.where("combox == true");
        DataSet purchaseY = tpv_dt_purchase.where("combox == true " +
                "and comfinshtime >= to_date('"+dayStartTime+"','yyyy-MM-dd HH:mm:ss') " +
                "and comfinshtime <= to_date('"+dayEndTime+"','yyyy-MM-dd HH:mm:ss')");
        DataSet salescontractF = tpv_dt_salescontract.where("combox == true");
        DataSet salescontractY = tpv_dt_salescontract.where("combox == true " +
                "and comfinshtime >= to_date('"+dayStartTime+"','yyyy-MM-dd HH:mm:ss') " +
                "and comfinshtime <= to_date('"+dayEndTime+"','yyyy-MM-dd HH:mm:ss')");

        DataSet cas_paybill = ORM.create().queryDataSet(algoKey, "cas_paybill", "id,entry,settletype.number settlenumber,createtime,bizdate," +
                        "entry.shkd_purcontract purcontract,entry.shkd_salecontract salescontract,entry.e_payableamt e_payableamt",
                new QFilter[]{new QFilter("billstatus", QCP.equals, "D")});
        DataSet cas_recbill = ORM.create().queryDataSet(algoKey, "cas_recbill", "id,entry,settletype.number settlenumber,createtime,bizdate," +
                        "entry.shkd_purcontract purcontract,entry.shkd_salecontract salescontract,entry.e_receivableamt e_receivableamt",
                new QFilter[]{new QFilter("billstatus", QCP.equals, "D")});
        DataSet cdm_receivablebill = ORM.create().queryDataSet(algoKey, "cdm_receivablebill", "id,shkd_billdetailtap," +
                        "draftbilltype.number draftnumber,draftbillstatus,createtime,bizdate,shkd_billdetailtap.shkd_purcontractid purcontract," +
                        "shkd_billdetailtap.shkd_salecontractid salescontract,shkd_billdetailtap.shkd_occupy_amount shkd_occupy_amount",
                new QFilter[]{new QFilter("billstatus", QCP.not_equals, "A")});
        DataSet lc_lettercredit = ORM.create().queryDataSet(algoKey,"lc_lettercredit","id lcid,billno lcbillno,amountscaleupper,tpv_contractdetail," +
                        "tpv_contractdetail.tpv_purnumbers purcontract,createtime,bizdate",
                new QFilter[]{new QFilter("billstatus", QCP.not_equals, "A")});

        DataSet purcontractData = purcontractData(purchaseF, purchaseY, cas_paybill, cas_recbill, cdm_receivablebill, lc_lettercredit);
        DataSet salescontractData = salescontractData(salescontractF, salescontractY, cas_paybill, cas_recbill, cdm_receivablebill);
        DataSet dataSet = purcontractData.union(salescontractData);
        dataSet = dataSet.groupBy(new String[]{"tpv_companys","tpv_departments","comid","tpv_day","to_date(tpv_day,'yyyy-MM-dd') tpv_businessdate","tpv_awardtype","tpv_awardratio"})
                .sum("tpv_cashaddamt").sum("tpv_cashlessamt").sum("tpv_receiveaddamt").sum("tpv_receivelessamt")
                .sum("tpv_payaddamt").sum("tpv_paylessamt").sum("tpv_cprcvaddamt").sum("tpv_cprcvlessamt")
                .sum("tpv_cppayaddamt").sum("tpv_cppaylessamt").sum("tpv_scmproaddamt").sum("tpv_scmprolessamt")
                .sum("tpv_chinaaddamt").sum("tpv_chinalessamt").finish();
        if (YEM.isNotEmpty(whereFilter)) {
            dataSet = dataSet.where(whereFilter);
        }
        dataSet = dataSet.select("tpv_companys","tpv_departments","tpv_day","tpv_businessdate",
                "tpv_cashaddamt","tpv_cashlessamt","0.0 tpv_cashaddrate","0.0 tpv_cashlessrate", //现款
                "tpv_receiveaddamt","tpv_receivelessamt","0.0 tpv_receiveaddrate","0.0 tpv_receivelessrate", //应收票据（银承）
                "tpv_payaddamt","tpv_paylessamt","0.0 tpv_payaddrate","0.0 tpv_paylessrate", //应付票据（银承）
                "tpv_cprcvaddamt","tpv_cprcvlessamt","0.0 tpv_cprcvddrate","0.0 tpv_cprcvlessrate", //应收票据（商票）
                "tpv_cppayaddamt","tpv_cppaylessamt","0.0 tpv_cppayaddrate","0.0 tpv_cppaylessrate", //应付票据（商票）
                "tpv_scmproaddamt","tpv_scmprolessamt","0.0 tpv_scmproaddrate","0.0 tpv_scmprolessrate", //供应链票据
                "tpv_chinaaddamt","tpv_chinalessamt","0.0 tpv_chinaaddrate","0.0 tpv_chinalessrate" //国内占用费
            );
    return dataSet;
    }

    private static DataSet salescontractData(DataSet salescontractF, DataSet salescontractY, DataSet cas_paybill, DataSet cas_recbill,
                                             DataSet cdm_receivablebill) {
        String[] paybill = new String[]{"id","tpv_contractnos","tpv_company","tpv_department","comid","tpv_bizdate",
                "tpv_awardtype","tpv_awardratio","(case when settlenumber = 'JSFS01' or settlenumber = 'JSFS02' or " +
                "settlenumber = 'JSFS03' or settlenumber = 'JSFS04' or settlenumber = 'JSFS05' or settlenumber = 'JSFS17' " +
                "then e_payableamt else 0.0 end) tpv_cashaddamt"};
        DataSet cas_paybillF = salescontractF.leftJoin(cas_paybill).on("id","salescontract")
                .select(paybill).finish();
        DataSet cas_paybillY = salescontractY.leftJoin(cas_paybill).on("id","salescontract")
                .select(paybill,new String[]{"(case when comfinshtime < createtime then 'Yes' else 'No' end) above"})
                .finish().where("above == 'Yes'");
        cas_paybillY = cas_paybillY.select(RptUtil.getDataSetFiledAlias(cas_paybillF));
        DataSet dataSet1 = cas_paybillF.union(cas_paybillY);

        String[] recbill = new String[]{"id","tpv_contractnos","tpv_company","tpv_department","comid","tpv_bizdate",
                "tpv_awardtype","tpv_awardratio","(case when settlenumber = 'JSFS01' or settlenumber = 'JSFS02' or " +
                "settlenumber = 'JSFS03' or settlenumber = 'JSFS04' or settlenumber = 'JSFS05' or settlenumber = 'JSFS17' " +
                "then e_receivableamt else 0.0 end) tpv_cashlessamt"};
        DataSet cas_recbillF = salescontractF.leftJoin(cas_recbill).on("id","salescontract")
                .select(recbill).finish();
        DataSet cas_recbillY = salescontractY.leftJoin(cas_recbill).on("id","salescontract")
                .select(recbill,new String[]{"(case when comfinshtime < createtime then 'Yes' else 'No' end) above"})
                .finish().where("above == 'Yes'");
        cas_recbillY = cas_recbillY.select(RptUtil.getDataSetFiledAlias(cas_recbillF));
        DataSet dataSet2 = cas_recbillF.union(cas_recbillY);

        String[] receivablebill = new String[]{"id","tpv_contractnos","tpv_company","tpv_department","comid","tpv_bizdate","tpv_awardtype","tpv_awardratio",
                "(case when (draftnumber = '101' or draftnumber = '102') and (draftbillstatus = 'registered') then shkd_occupy_amount else 0.0 end) tpv_receiveaddamt", //增加(应收票据（银承）)
                "(case when (draftnumber = '101' or draftnumber = '102') and (draftbillstatus = 'endorsed' or draftbillstatus = 'discounted' or draftbillstatus = 'collected') " +
                        "then shkd_occupy_amount else 0.0 end) tpv_receivelessamt", //减少(应收票据（银承）)
                "(case when (draftnumber = '101' or draftnumber = '102') and (draftbillstatus = 'registered') then shkd_occupy_amount else 0.0 end) tpv_payaddamt", //增加(应付票据（银承）)
                "(case when (draftnumber = '101' or draftnumber = '102') and (draftbillstatus = 'pledged') then shkd_occupy_amount else 0.0 end) tpv_paylessamt", //减少(应付票据（银承）)
                "(case when (draftnumber = '103' or draftnumber = '104') and (draftbillstatus = 'registered') then shkd_occupy_amount else 0.0 end) tpv_cprcvaddamt", //增加(应收票据（商票）)
                "(case when (draftnumber = '103' or draftnumber = '104') and (draftbillstatus = 'endorsed' or draftbillstatus = 'discounted' or draftbillstatus = 'collected') " +
                        "then shkd_occupy_amount else 0.0 end) tpv_cprcvlessamt", //减少(应收票据（商票）)
                "(case when (draftnumber = '103' or draftnumber = '104') and (draftbillstatus = 'registered') then shkd_occupy_amount else 0.0 end) tpv_cppayaddamt", //增加(应付票据（商票）)
                "(case when (draftnumber = '103' or draftnumber = '104') and (draftbillstatus = 'pledged') then shkd_occupy_amount else 0.0 end) tpv_cppaylessamt", //减少(应付票据（商票）)
                "(case when (draftnumber = 'CDMT-723A8F3D' or draftnumber = 'CDMT-AA25C0C4' or draftnumber = 'CDMT-CE86E12E' or draftnumber = 'CDMT-FF14AE76') " +
                        "and (draftbillstatus = 'registered') then shkd_occupy_amount else 0.0 end) tpv_scmproaddamt", //增加(供应链票据)
                "(case when (draftnumber = 'CDMT-723A8F3D' or draftnumber = 'CDMT-AA25C0C4' or draftnumber = 'CDMT-CE86E12E' or draftnumber = 'CDMT-FF14AE76') " +
                        "and (draftbillstatus = 'endorsed' or draftbillstatus = 'discounted' or draftbillstatus = 'collected') " +
                        "then shkd_occupy_amount else 0.0 end) tpv_scmprolessamt"};
        DataSet cdm_receivablebillF = salescontractF.leftJoin(cdm_receivablebill).on("id","salescontract")
                .select(receivablebill) //减少(供应链票据)
                .finish();
        DataSet cdm_receivablebillY = salescontractY.leftJoin(cdm_receivablebill).on("id","salescontract")
                .select(receivablebill,new String[]{"(case when comfinshtime >= createtime then 'Yes' else 'No' end) above"})
                .finish().where("above == 'Yes'");
        cdm_receivablebillY = cdm_receivablebillY.select(RptUtil.getDataSetFiledAlias(cdm_receivablebillF));
        DataSet dataSet3 = cdm_receivablebillF.union(cdm_receivablebillY);
        DataSet dataSet = dataSet1.leftJoin(dataSet2).on("id", "id")
                .select("id","tpv_contractnos","tpv_company tpv_companys","tpv_department tpv_departments","comid","tpv_bizdate",
                        "tpv_awardtype","tpv_awardratio","tpv_cashaddamt","tpv_cashlessamt").finish();
        dataSet = dataSet.leftJoin(dataSet3).on("id","id")
                .select("id","tpv_companys","tpv_departments","comid","to_char(tpv_bizdate,'yyyy-MM-dd') tpv_day", "tpv_awardtype","tpv_awardratio",
                        "tpv_cashaddamt","tpv_cashlessamt", "tpv_receiveaddamt","tpv_receivelessamt",
                        "tpv_payaddamt","tpv_paylessamt","tpv_cprcvaddamt","tpv_cprcvlessamt","tpv_cppayaddamt",
                        "tpv_cppaylessamt","tpv_scmproaddamt","tpv_scmprolessamt","0.0 tpv_chinaaddamt","0.0 tpv_chinalessamt").finish();
        return dataSet;
    }

    private static DataSet purcontractData(DataSet purchaseF, DataSet purchaseY, DataSet cas_paybill, DataSet cas_recbill,
                                           DataSet cdm_receivablebill, DataSet lc_lettercredit) {
        String[] paybill = new String[]{"id","tpv_contractnumber","tpv_company","tpv_department","comid","tpv_bizdate",
                "tpv_typeofreward","tpv_percentageofprizes","(case when settlenumber = 'JSFS01' or settlenumber = 'JSFS02' or " +
                "settlenumber = 'JSFS03' or settlenumber = 'JSFS04' or settlenumber = 'JSFS05' or settlenumber = 'JSFS17' " +
                "then e_payableamt else 0.0 end) tpv_cashaddamt"};
        DataSet cas_paybillF = purchaseF.leftJoin(cas_paybill).on("id","purcontract")
                .select(paybill).finish();
        DataSet cas_paybillY = purchaseY.leftJoin(cas_paybill).on("id","purcontract")
                .select(paybill,new String[]{"(case when comfinshtime < createtime then 'Yes' else 'No' end) above"})
                .finish().where("above == 'Yes'");
        cas_paybillY = cas_paybillY.select(RptUtil.getDataSetFiledAlias(cas_paybillF));
        DataSet dataSet1 = cas_paybillF.union(cas_paybillY);

        String[] recbill = new String[]{"id","tpv_contractnumber","tpv_company","tpv_department","comid","tpv_bizdate",
                "tpv_typeofreward","tpv_percentageofprizes","(case when settlenumber = 'JSFS01' or settlenumber = 'JSFS02' or " +
                "settlenumber = 'JSFS03' or settlenumber = 'JSFS04' or settlenumber = 'JSFS05' or settlenumber = 'JSFS17' " +
                "then e_receivableamt else 0.0 end) tpv_cashlessamt"};
        DataSet cas_recbillF = purchaseF.leftJoin(cas_recbill).on("id","purcontract")
                .select(recbill).finish();
        DataSet cas_recbillY = purchaseY.leftJoin(cas_recbill).on("id","purcontract")
                .select(recbill,new String[]{"(case when comfinshtime < createtime then 'Yes' else 'No' end) above"})
                .finish().where("above == 'Yes'");
        cas_recbillY = cas_recbillY.select(RptUtil.getDataSetFiledAlias(cas_recbillF));
        DataSet dataSet2 = cas_recbillF.union(cas_recbillY);

        String[] receivablebill = new String[]{"id","tpv_contractnumber","tpv_company","tpv_department","comid","tpv_bizdate","tpv_typeofreward","tpv_percentageofprizes",
                "(case when (draftnumber = '101' or draftnumber = '102') and (draftbillstatus = 'registered') then shkd_occupy_amount else 0.0 end) tpv_receiveaddamt", //增加(应收票据（银承）)
                "(case when (draftnumber = '101' or draftnumber = '102') and (draftbillstatus = 'endorsed' or draftbillstatus = 'discounted' or draftbillstatus = 'collected') " +
                        "then shkd_occupy_amount else 0.0 end) tpv_receivelessamt", //减少(应收票据（银承）)
                "(case when (draftnumber = '101' or draftnumber = '102') and (draftbillstatus = 'registered') then shkd_occupy_amount else 0.0 end) tpv_payaddamt", //增加(应付票据（银承）)
                "(case when (draftnumber = '101' or draftnumber = '102') and (draftbillstatus = 'pledged') then shkd_occupy_amount else 0.0 end) tpv_paylessamt", //减少(应付票据（银承）)
                "(case when (draftnumber = '103' or draftnumber = '104') and (draftbillstatus = 'registered') then shkd_occupy_amount else 0.0 end) tpv_cprcvaddamt", //增加(应收票据（商票）)
                "(case when (draftnumber = '103' or draftnumber = '104') and (draftbillstatus = 'endorsed' or draftbillstatus = 'discounted' or draftbillstatus = 'collected') " +
                        "then shkd_occupy_amount else 0.0 end) tpv_cprcvlessamt", //减少(应收票据（商票）)
                "(case when (draftnumber = '103' or draftnumber = '104') and (draftbillstatus = 'registered') then shkd_occupy_amount else 0.0 end) tpv_cppayaddamt", //增加(应付票据（商票）)
                "(case when (draftnumber = '103' or draftnumber = '104') and (draftbillstatus = 'pledged') then shkd_occupy_amount else 0.0 end) tpv_cppaylessamt", //减少(应付票据（商票）)
                "(case when (draftnumber = 'CDMT-723A8F3D' or draftnumber = 'CDMT-AA25C0C4' or draftnumber = 'CDMT-CE86E12E' or draftnumber = 'CDMT-FF14AE76') " +
                        "and (draftbillstatus = 'registered') then shkd_occupy_amount else 0.0 end) tpv_scmproaddamt", //增加(供应链票据)
                "(case when (draftnumber = 'CDMT-723A8F3D' or draftnumber = 'CDMT-AA25C0C4' or draftnumber = 'CDMT-CE86E12E' or draftnumber = 'CDMT-FF14AE76') " +
                        "and (draftbillstatus = 'endorsed' or draftbillstatus = 'discounted' or draftbillstatus = 'collected') " +
                        "then shkd_occupy_amount else 0.0 end) tpv_scmprolessamt"};
        DataSet cdm_receivablebillF = purchaseF.leftJoin(cdm_receivablebill).on("id","purcontract")
                .select(receivablebill) //减少(供应链票据)
                .finish();
        DataSet cdm_receivablebillY = purchaseY.leftJoin(cdm_receivablebill).on("id","purcontract")
                .select(receivablebill,new String[]{"(case when comfinshtime >= createtime then 'Yes' else 'No' end) above"})
                .finish().where("above == 'Yes'");
        cdm_receivablebillY = cdm_receivablebillY.select(RptUtil.getDataSetFiledAlias(cdm_receivablebillF));
        DataSet dataSet3 = cdm_receivablebillF.union(cdm_receivablebillY);

        String[] lettercredit = new String[]{"id","tpv_contractnumber","tpv_company","tpv_department","comid","tpv_bizdate",
                "tpv_typeofreward","tpv_percentageofprizes","lcid","lcbillno"};
        DataSet lc_lettercreditF = purchaseF.leftJoin(lc_lettercredit).on("tpv_contractnumber","purcontract")
                .select(lettercredit).finish();
        DataSet lc_lettercreditY = purchaseY.leftJoin(lc_lettercredit).on("tpv_contractnumber","purcontract")
                .select(lettercredit,new String[]{"(case when comfinshtime >= createtime then 'Yes' else 'No' end) above"})
                .finish().where("above == 'Yes'");
        lc_lettercreditY = lc_lettercreditY.select(RptUtil.getDataSetFiledAlias(lc_lettercreditF));
        DataSet dataSet4 = lc_lettercreditF.union(lc_lettercreditY);
        DataSet lcCopy = dataSet4.copy();
        List<Long> lcIdList = new ArrayList<>();
        for (Row row : lcCopy) {
            lcIdList.add(row.getLong("lcid"));
        }
        DataSet lc_arrival = ORM.create().queryDataSet(algoKey,"lc_arrival","id lcvalid,billno lcvalbillno,lettercredit.id lettercreditid",
                new QFilter[]{new QFilter("billstatus", QCP.equals, "C"),
                        new QFilter("lettercredit.id",QCP.large_than,0),
                        new QFilter("lettercredit.id",QCP.in,lcIdList)});
        DataSet lcvalCopy = lc_arrival.copy();
        List<Long> lcvalIdList = new ArrayList<>();
        for (Row row : lcvalCopy) {
            lcvalIdList.add(row.getLong("lcvalid"));
        }
        DataSet cas_paybill_lc = ORM.create().queryDataSet(algoKey,"cas_paybill","id paylcid,billno paylcbillno,sourcebillid,actpayamt",
                        new QFilter[]{new QFilter("billstatus", QCP.equals, "C"),
                                new QFilter("sourcebillid", QCP.large_than, 0),
                                new QFilter("sourcebillid", QCP.in, lcvalIdList)})
                .groupBy(new String[]{"sourcebillid"}).sum("actpayamt").finish();
        lc_arrival = lc_arrival.leftJoin(cas_paybill_lc).on("lcvalid","sourcebillid")
                .select("lettercreditid","lcvalid","actpayamt").finish()
                .groupBy(new String[]{"lettercreditid"}).sum("actpayamt").finish();

        dataSet4 = dataSet4.leftJoin(lc_arrival).on("lcid","lettercreditid")
                .select(RptUtil.getDataSetFiledAlias(dataSet4),new String[]{"actpayamt"}).finish();
        DataSet tpv_sc_capitallimit = ORM.create().queryDataSet(algoKey,"tpv_sc_capitallimit","id,billno,tpv_addorsub," +
                        "tpv_type,tpv_purnum,tpv_coreid,tpv_orignalamount",
                new QFilter[]{new QFilter("tpv_coreid", QCP.large_than, 0),
                        new QFilter("tpv_coreid", QCP.in, lcIdList)});
        List<String> aliasList9 = RptUtil.getDataSetAliasList(dataSet4);
        aliasList9.add("(case when tpv_type = 'J' and tpv_addorsub = 'A' then tpv_orignalamount else 0.0 end) tpv_chinaaddamt");
        aliasList9.add("(case when tpv_type = 'J' and tpv_addorsub = 'B' then tpv_orignalamount else 0.0 end) tpv_chinalessamt)");
        dataSet4 = dataSet4.leftJoin(tpv_sc_capitallimit).on("lcid","tpv_coreid")
                .select(aliasList9.toArray(new String[0])).finish();

        DataSet dataSet = dataSet1.leftJoin(dataSet2).on("id", "id")
                .select("id","tpv_contractnumber","tpv_company tpv_companys","tpv_department tpv_departments","comid","tpv_bizdate",
                        "tpv_typeofreward tpv_awardtype","tpv_percentageofprizes tpv_awardratio ","tpv_cashaddamt","tpv_cashlessamt").finish();
        dataSet = dataSet.leftJoin(dataSet3).on("id","id")
                .select("id","tpv_companys","tpv_departments","comid","to_char(tpv_bizdate,'yyyy-MM-dd') tpv_day", "tpv_awardtype","tpv_awardratio",
                        "tpv_cashaddamt","tpv_cashlessamt","tpv_receiveaddamt","tpv_receivelessamt",
                        "tpv_payaddamt","tpv_paylessamt","tpv_cprcvaddamt","tpv_cprcvlessamt","tpv_cppayaddamt",
                        "tpv_cppaylessamt","tpv_scmproaddamt","tpv_scmprolessamt").finish();
        dataSet = dataSet.leftJoin(dataSet4).on("id","id")
                .select(RptUtil.getDataSetFiledAlias(dataSet),new String[]{"tpv_chinaaddamt","tpv_chinalessamt"}).finish();
        return dataSet;
    }

    //获取资金占用利率数据
    private static Map fundsUsedRate(Date startTime, Date endTime) {
        List<QFilter> qFilter = new ArrayList<>();
        qFilter.add(new QFilter("enable", QCP.equals, "1"));
        qFilter.add(new QFilter("tpv_enddate", QCP.large_equals, startTime));
        qFilter.add(new QFilter("tpv_enddate", QCP.less_equals, endTime));
        DataSet fundsUseRate = ORM.create().queryDataSet(algoKey, "tpv_zjzyll", "createorg.id org,tpv_depertment.id dept," +
                        "tpv_interestclass.number tpv_interestclass," + //计息类别
                        "tpv_begindate, tpv_enddate," +
                        "tpv_dayrate," + //日利率(%)
                        "tpv_deoccupyrate", //负占用利率(%)
                qFilter.toArray(new QFilter[qFilter.size()]));
        Map<String,Map<String, BigDecimal>> map = new HashMap<>();
        for (Row row : fundsUseRate) {
            String org = row.getString("org");
            String dept = row.getString("dept");
            Date tpvBegindate = row.getDate("tpv_begindate");
            Date tpvEnddate = row.getDate("tpv_enddate");
            String tpvInterestclass = row.getString("tpv_interestclass");
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String formatBegin = str.format(tpvBegindate);
            String formatEnd = str.format(tpvEnddate);
            String key = org + "》" + dept + "》" + formatBegin + "》" + formatEnd + "》" + tpvInterestclass;
            BigDecimal tpvDayrate = row.getBigDecimal("tpv_dayrate").divide(new BigDecimal("100"),4, BigDecimal.ROUND_DOWN);
            BigDecimal tpvDeoccupyrate = row.getBigDecimal("tpv_deoccupyrate").divide(new BigDecimal("100"),4, BigDecimal.ROUND_DOWN);
            Map<String, BigDecimal> value = new HashMap<>();
            value.put("tpv_dayrate",tpvDayrate);
            value.put("tpv_deoccupyrate",tpvDeoccupyrate);
            map.put(key,value);
        }
        return map;
    }

    private static String splitWhereFilter(String whereFilter, int value) {
        String[] split = whereFilter.split("》");
        if (split.length > 0) {
            int i = 0;
            for (String object : split) {
                if (i == 0 && value == 0) whereFilter = object; //where条件
                else if (i == 1 && value == 1) whereFilter = object; //开始日期
                else if (i == 2 && value == 2) whereFilter = object; //结束日期
                i++;
            }
        }
        return whereFilter;
    }

}
