package tpv.tpv_wm.tpv_sc.java.report;

import com.alibaba.fastjson.JSONObject;
import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Description: 资金占用明细（财务） -报表查询插件
 * @Author LinRui
 * @Date 2024/2/1 11:40
 */
public class FundsUsedsQueryRpt extends AbstractReportListDataPlugin {

    private static final String algoKey = FundsUsedsQueryRpt.class.getName();

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        return null;
    }

    public static DataSet query(String whereFilters) {
        DataSet mainDataSet = mainDataSet(whereFilters);
        String orgId = splitWhereFilter(whereFilters,1);
        String dayStartTime = splitWhereFilter(whereFilters,2);
        String dayEndTime = splitWhereFilter(whereFilters,3);
        Date startTime = DateUtil.parseDateHms(dayStartTime);
        Date endTime = DateUtil.parseDateHms(dayEndTime);
        Map<String,Map<String,BigDecimal>> fundsUsedRate = fundsUsedRate(startTime, endTime);
        Map<String,Map<String,Object>> voucher = voucherAcAssgrpByEntryId(startTime, endTime, orgId);
        Map<Long, Long> parentDeptIds = mapParentDeptIds();
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        for (DynamicObject col : col_s) {
            if (voucher.size() > 0) {
                String entries = col.getString("entriesid");
                if (voucher.containsKey(entries)) {
                    String account = (String) voucher.get(entries).get("account");
                    Long assgrp = (Long) voucher.get(entries).get("assgrp");
                    col.set("accountnumber",account);
                    col.set("assgrpid",assgrp);
                }
            }
            if (col.getString("accountnumber").length() >= 4) {
                if ("1001".equals(col.getString("accountnumber").substring(0,4))
                        || "1002".equals(col.getString("accountnumber").substring(0,4))) { //现款
                    col.set("tpv_add",col.getBigDecimal("debitlocal")); //借方(增加)
                    col.set("tpv_reduce",col.getBigDecimal("creditlocal")); //贷方(减少)
                }
            }
            if (col.getString("accountnumber").length() >= 6) {
                if ("112101".equals(col.getString("accountnumber").substring(0,6))) { //应收票据（银承）
                    col.set("tpv_increase", col.getBigDecimal("debitlocal")); //借方(增加)
                    col.set("tpv_decrease", col.getBigDecimal("creditlocal")); //贷方(减少)
                }
            }
            if (col.getString("accountnumber").length() >= 6) {
                if ("220101".equals(col.getString("accountnumber").substring(0,6))) { //应付票据（银承）
                    col.set("tpv_lessen", col.getBigDecimal("debitlocal")); //借方(减少)
                    col.set("tpv_augment", col.getBigDecimal("creditlocal")); //贷方(增加)
                }
            }
            if (col.getString("accountnumber").length() >= 6) {
                if ("112102".equals(col.getString("accountnumber").substring(0,6))) { //应收票据（商票）
                    col.set("tpv_enhance", col.getBigDecimal("debitlocal")); //借方(增加)
                    col.set("tpv_little", col.getBigDecimal("creditlocal")); //贷方(减少)
                }
            }
            if (col.getString("accountnumber").length() >= 6) {
                if ("220102".equals(col.getString("accountnumber").substring(0,6))) { //应付票据（商票）
                    col.set("tpv_few", col.getBigDecimal("debitlocal")); //借方(减少)
                    col.set("tpv_plus", col.getBigDecimal("creditlocal")); //贷方(增加)
                }
            }
            if (col.getString("accountnumber").length() >= 8) {
                if ("11220103".equals(col.getString("accountnumber").substring(0,8))) { //供应链票据
                    col.set("tpv_aug",col.getBigDecimal("debitlocal")); //借方(增加)
                    col.set("tpv_minus",col.getBigDecimal("creditlocal")); //贷方(减少)
                }
            }
        }
        //切换大部门
        for (DynamicObject col : col_s) {
            if (parentDeptIds.containsKey(col.getLong("assgrpid"))) {
                col.set("assgrpid", parentDeptIds.get(col.getLong("assgrpid")));
            }
        }
        DataSet createDataSet = RptUtil.getToCreateNewDataSet(algoKey, mainDataSet, col_s);

        createDataSet = createDataSet.groupBy(new String[]{"createorgid","assgrpid","tpv_day"})
                .sum("tpv_add").sum("tpv_reduce").sum("tpv_increase").sum("tpv_decrease")
                .sum("tpv_augment").sum("tpv_lessen").sum("tpv_enhance").sum("tpv_little")
                .sum("tpv_plus").sum("tpv_few").sum("tpv_aug").sum("tpv_minus")
                .finish();
        createDataSet = createDataSet.select("createorgid tpv_companys","assgrpid tpv_depertment","tpv_day","tpv_add","tpv_reduce","tpv_increase","tpv_decrease",
                "tpv_augment","tpv_lessen","tpv_enhance","tpv_little","tpv_plus","tpv_few","tpv_aug","tpv_minus","0.0 tpv_cashaddrate","0.0 tpv_cashlessrate",
                "0.0 tpv_receiveaddrate","0.0 tpv_receivelessrate","0.0 tpv_payaddrate","0.0 tpv_paylessrate","0.0 tpv_cprcvddrate",
                "0.0 tpv_cprcvlessrate","0.0 tpv_cppayaddrate","0.0 tpv_cppaylessrate","0.0 tpv_scmproaddrate","0.0 tpv_scmprolessrate",
                "0.0 tpv_occupied","0.0 tpv_occupyamt","0.0 tpv_holdamt", "0.0 tpv_useamt","0.0 tpv_needamt","0.0 tpv_accamt");

//        DynamicObjectCollection collection = ORM.create().toPlainDynamicObjectCollection(createDataSet.copy());
//        for (DynamicObject dynamicObject : collection) {
//            if (dynamicObject.getBigDecimal("tpv_occupied").compareTo(new BigDecimal("-231679.71")) == 0) {
//                System.out.println();
//            }
//        }
        int days = DateUtil.getDay(endTime);
        List<Long> deptBigList = new ArrayList<>();
        if (parentDeptIds.size() > 0) {
            for (Map.Entry<Long, Long> longEntry : parentDeptIds.entrySet()) {
                if (!deptBigList.contains(longEntry.getValue())) {
                    deptBigList.add(longEntry.getValue());
                }
            }
        }
        QFilter orgdutyQfilter = new QFilter("enable", QCP.equals, "1");
        orgdutyQfilter.and(new QFilter("orgduty.number", QCP.in, new String[]{"ZHKC002"}));
        DataSet orgduty = ORM.create().queryDataSet(algoKey, "bos_org_dutyrelation", "org.id tpv_depid",
                orgdutyQfilter.toArray());
        DataSet copyOrgduty = orgduty.copy();
        List<Long> orgdutyIds = new ArrayList<>();
        for (Row row : copyOrgduty) {
            if (!orgdutyIds.contains(row.getLong("tpv_depid"))) {
                orgdutyIds.add(row.getLong("tpv_depid"));
            }
        }

        QFilter demtsQfilter = new QFilter("fromorg.id", QCP.equals, Long.valueOf(orgId));
        if (deptBigList.size() >0) {
            demtsQfilter.and(new QFilter("toorg.id", QCP.in, deptBigList));
        }
        if (orgdutyIds.size() > 0) {
            demtsQfilter.and(new QFilter("toorg.id", QCP.in, orgdutyIds));
        }
        DataSet demts = ORM.create().queryDataSet(algoKey, "bos_org_orgrelation_dept", "toorg tpv_depertment, fromorg tpv_companys",
                demtsQfilter.toArray());

        demts = demts.addField("'' tpv_day","tpv_day").addField("now()","tpv_businessdate");
        DynamicObjectCollection demtsDynamicObjects = ORM.create().toPlainDynamicObjectCollection(demts);
        for (int i = 0; i < demtsDynamicObjects.size(); i++) {
            DynamicObject dynamicObject = demtsDynamicObjects.get(i);
            Date date = endTime;
            for (int j = 1; j <= days; j++) {
                if (j == 1) {
                    dynamicObject.set("tpv_day", DateUtil.formatDate(endTime));
                    dynamicObject.set("tpv_businessdate", endTime);
                } else {
                    date = DateUtil.addDays(date, -1);
                    DynamicObject dyNew = new DynamicObject(dynamicObject.getDynamicObjectType());
                    dyNew.set("tpv_depertment", dynamicObject.get("tpv_depertment"));
                    dyNew.set("tpv_companys", dynamicObject.get("tpv_companys"));
                    dyNew.set("tpv_day", DateUtil.formatDate(date));
                    dyNew.set("tpv_businessdate", date);
                    demtsDynamicObjects.add(i++, dyNew);
                }
            }
        }
        demts = RptUtil.getToCreateNewDataSet(algoKey, demts, demtsDynamicObjects);
        List<String> aliasList = RptUtil.getDataSetAliasList(createDataSet);
        aliasList.remove("tpv_companys");
        aliasList.remove("tpv_depertment");
        aliasList.remove("tpv_day");
        createDataSet = demts.leftJoin(createDataSet).on("tpv_companys","tpv_companys").on("tpv_depertment","tpv_depertment")
                .on("tpv_day","tpv_day")
                .select(RptUtil.getDataSetFiledAlias(demts),aliasList.toArray(new String[aliasList.size()])).finish();
        //查询资金占用调整数据，按日期、公司、部门分组，计算按计息类别求和汇总
        List<QFilter> qFilter = new ArrayList<>();
        qFilter.add(new QFilter("enable", QCP.equals, "1"));
        DataSet tpv_sc_adjustment = ORM.create().queryDataSet(algoKey, "tpv_sc_adjustment", "createorg.id org,tpv_depertment.id dept," +
                "tpv_category.number tpv_category, tpv_date, tpv_income", qFilter.toArray(new QFilter[qFilter.size()]));
        tpv_sc_adjustment = tpv_sc_adjustment.select("org","dept","tpv_category","to_char(tpv_date,'yyyy-MM-dd') tpv_day","tpv_income");
        tpv_sc_adjustment = tpv_sc_adjustment.select("org","dept","tpv_day",
                "(case when tpv_category = 'KC00001' then tpv_income else 0.0 end) income_cash", //现款
                "(case when tpv_category = 'KC00010' then tpv_income else 0.0 end) income_receive", //应收票据（银承）
                "(case when tpv_category = 'KC00005' then tpv_income else 0.0 end) income_pay", //应付票据（银承）
                "(case when tpv_category = 'KC00030' then tpv_income else 0.0 end) income_cprcv", //应收票据（商票）
                "(case when tpv_category = 'KC00025' then tpv_income else 0.0 end) income_cppay", //应付票据（商票）
                "(case when tpv_category = 'KC00040' then tpv_income else 0.0 end) income_scmpro"); //供应链票据
        tpv_sc_adjustment = tpv_sc_adjustment.groupBy(new String[]{"org","dept","tpv_day"})
                .sum("income_cash")
                .sum("income_receive").sum("income_pay").sum("income_cprcv")
                .sum("income_cppay").sum("income_scmpro").finish();
        createDataSet = createDataSet.leftJoin(tpv_sc_adjustment).on("tpv_companys","org").on("tpv_depertment","dept").on("tpv_day","tpv_day")
                .select("tpv_companys","tpv_depertment","tpv_day","tpv_businessdate","tpv_add","tpv_reduce","tpv_increase",
                        "tpv_decrease","tpv_augment","tpv_lessen","tpv_enhance", "tpv_little","tpv_plus","tpv_few","tpv_aug","tpv_minus",
                        "income_cash tpv_occupied", "income_receive tpv_occupyamt","income_pay tpv_holdamt", "income_cprcv tpv_useamt",
                        "income_cppay tpv_needamt","income_scmpro tpv_accamt",
                        "tpv_cashaddrate","tpv_cashlessrate", "tpv_receiveaddrate","tpv_receivelessrate","tpv_payaddrate",
                        "tpv_paylessrate","tpv_cprcvddrate", "tpv_cprcvlessrate","tpv_cppayaddrate","tpv_cppaylessrate",
                        "tpv_scmproaddrate","tpv_scmprolessrate", "0.0 tpv_applyamt", "0.0 tpv_profit", "0.0 tpv_byamt","0.0 tpv_sharp")
                .finish(); //商票 tpv_byamt(占用) tpv_sharp(利息); 银承 tpv_applyamt(占用) tpv_profit(利息)
        DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(createDataSet);
        //资金占用利率增、负赋值
        for (DynamicObject col : dynamicObjects) {
            if (fundsUsedRate.size() > 0) {
                for (String key : fundsUsedRate.keySet()) {
                    String[] split = key.split("》");
                    if (col.getString("tpv_companys").equals(split[0])
                            && col.getString("tpv_depertment").equals(split[1])) {
                        if (col.getDate("tpv_businessdate").compareTo(DateUtil.parseDateHms(split[2])) >= 0
                                && col.getDate("tpv_businessdate").compareTo(DateUtil.parseDateHms(split[3])) <= 0) {
                            BigDecimal tpv_dayrate = fundsUsedRate.get(key).get("tpv_dayrate");
                            BigDecimal tpv_deoccupyrate = fundsUsedRate.get(key).get("tpv_deoccupyrate");
                            if ("KC00001".equals(split[4])) {
                                col.set("tpv_cashaddrate",tpv_dayrate);
                                col.set("tpv_cashlessrate",tpv_deoccupyrate);
                            }
                            if ("KC00010".equals(split[4])) {
                                col.set("tpv_receiveaddrate",tpv_dayrate);
                                col.set("tpv_receivelessrate",tpv_deoccupyrate);
                            }
                            if ("KC00005".equals(split[4])) {
                                col.set("tpv_payaddrate",tpv_dayrate);
                                col.set("tpv_paylessrate",tpv_deoccupyrate);
                            }
                            if ("KC00030".equals(split[4])) {
                                col.set("tpv_cprcvddrate",tpv_dayrate);
                                col.set("tpv_cprcvlessrate",tpv_deoccupyrate);
                            }
                            if ("KC00025".equals(split[4])) {
                                col.set("tpv_cppayaddrate",tpv_dayrate);
                                col.set("tpv_cppaylessrate",tpv_deoccupyrate);
                            }
                            if ("KC00040".equals(split[4])) {
                                col.set("tpv_scmproaddrate",tpv_dayrate);
                                col.set("tpv_scmprolessrate",tpv_deoccupyrate);
                            }
                        }
                    }
                }
            }
        }
        createDataSet = RptUtil.getToCreateNewDataSet(algoKey, createDataSet, dynamicObjects);
        return createDataSet.orderBy(new String[]{"tpv_depertment", "tpv_businessdate"});
    }



    private static Map<Long,Long> mapParentDeptIds(){
        Map<Long,Long> mapParentId = new HashMap<>();
        QFilter qFilter = new QFilter("enable", QCP.equals, "1");
//        qFilter.and(new QFilter("number",QCP.equals,"Org-01-001-019-001"));
        qFilter.and(new QFilter("orgpattern.number",QCP.in,new String[]{"OF-01","Orgform06"}));
        DynamicObject[] bosAdminorgs = BusinessDataServiceHelper.load("bos_adminorg","id,orgpattern,structure,structure.viewparent", qFilter.toArray());
        if (bosAdminorgs.length > 0) {
            for (DynamicObject bosAdminorg : bosAdminorgs) {
                DynamicObject orgpattern = bosAdminorg.getDynamicObject("orgpattern");
                if (YEM.isNotEmpty(orgpattern)) {
                    String number = orgpattern.getString("number");
                    if ("OF-01".equals(number)) { //小组只会对应一个部门
                        DynamicObjectCollection dynamicObjects = bosAdminorg.getDynamicObjectCollection("structure");
                        if (dynamicObjects.size() > 0) {
                            for (DynamicObject dynamicObject : dynamicObjects) {
                                DynamicObject viewparent = dynamicObject.getDynamicObject("viewparent");
                                if (YEM.isNotEmpty(viewparent)) {
                                    mapParentId.put(bosAdminorg.getLong("id"),viewparent.getLong("id"));
                                }
                                break;
                            }
                        }
                    } else if ("Orgform06".equals(number)) {
                        mapParentId.put(bosAdminorg.getLong("id"),bosAdminorg.getLong("id"));
                    }
                }
            }
        }
        return mapParentId;
    }

    private static DataSet mainDataSet(String whereFilters) {
        String whereFilter = splitWhereFilter(whereFilters,0);
        String orgId = splitWhereFilter(whereFilters,1);
        String dayStartTime = splitWhereFilter(whereFilters,2);
        String dayEndTime = splitWhereFilter(whereFilters,3);
        Date startTime = DateUtil.parseDateHms(dayStartTime);
        Date endTime = DateUtil.parseDateHms(dayEndTime);

        String selectfieldsg = "id,org.id createorgid,org.name createorgname,entries,entries.id entriesid," +
//                "entries.assgrp assgrp," + //核算维度
//                "entries.account.number account," + //科目
                "entries.debitlocal debitlocal," + //借方
                "entries.creditlocal creditlocal," + //贷方
                "entries.shkd_ywrq bizdate";
        List<QFilter> qFilterg = new ArrayList<>();
        qFilterg.add(new QFilter("booktype.number", QCP.equals, "100001")); //主帐薄
        qFilterg.add(new QFilter("org.id", QCP.equals, Long.valueOf(orgId)));
        qFilterg.add(new QFilter("entries.shkd_ywrq", QCP.large_equals, startTime));
        qFilterg.add(new QFilter("entries.shkd_ywrq", QCP.less_equals, endTime));
        DataSet dataSet = ORM.create().queryDataSet(algoKey, "gl_voucher", selectfieldsg, qFilterg.toArray(new QFilter[qFilterg.size()]));
        dataSet = dataSet.select("createorgid","createorgname","entriesid","bizdate",
                "(case when debitlocal != null then debitlocal else 0.0 end) debitlocal",
                "(case when creditlocal != null then creditlocal else 0.0 end) creditlocal",
                "0.0 tpv_add","0.0 tpv_reduce","0.0 tpv_interest", //现款
                "0.0 tpv_increase","0.0 tpv_decrease","0.0 tpv_interests", //应收票据（银承）
                "0.0 tpv_augment","0.0 tpv_lessen","0.0 tpv_accrual", //应付票据（银承）
                "0.0 tpv_enhance","0.0 tpv_little","0.0 tpv_return", //应收票据（商票）
                "0.0 tpv_plus","0.0 tpv_few","0.0 tpv_gain", //应付票据（商票）
                "0.0 tpv_aug","0.0 tpv_minus","0.0 tpv_favourable", //供应链票据
                "0.0 tpv_addrate","0.0 tpv_lessrate","'' accountnumber","0l assgrpid","'no' ismaintenance", //ismaintenance 是否在维护中
                "to_char(bizdate,'yyyy-MM-dd') tpv_day");

        if (YEM.isNotEmpty(whereFilter)) {
            dataSet = dataSet.where(whereFilter);
        }
        return dataSet;
    }

    //获取凭证分录的核算维度部门id和会计科目的编码
    private static Map voucherAcAssgrpByEntryId(Date startTime, Date endTime, String orgId) {
        Map<String,Map<String,Object>> map = new HashMap<>();
        DataSet bos_flex_property = ORM.create().queryDataSet(algoKey,"bos_flex_property", "flexfield,valuesource", null);
        Map<String,Object>  valuesourceMap = new HashMap<>();
        for (Row row : bos_flex_property) {
            valuesourceMap.put(row.getString("flexfield"),row.getString("valuesource"));
        }
        QFilter qFilterOne = new QFilter("entries.shkd_ywrq", QCP.large_equals, startTime);
        qFilterOne.and(new QFilter("entries.shkd_ywrq", QCP.less_equals, endTime));
        qFilterOne.and(new QFilter("org.id", QCP.equals, Long.valueOf(orgId)));
        qFilterOne.and(new QFilter("booktype.number", QCP.equals, "100001")); //主帐薄
        //qFilterOne.and(new QFilter("billstatus", QCP.equals, "C"));
        DataSet dataSet = ORM.create().queryDataSet(algoKey,"gl_voucher", "entries.id entriesid,entries.account.number accountnumber," +
                "entries.assgrp.value assgrpvalue,0l assgrpId,entries.creditlocal creditlocal", qFilterOne.toArray());//总账
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(dataSet);
        for (DynamicObject col : col_s) {
            Map<String,Object> map_value = new HashMap<>();
            String assgrpValue = col.getString("assgrpvalue");
            JSONObject jsonObject = JSONObject.parseObject(assgrpValue);
            if (null != jsonObject) {
                for (Map.Entry<String, Object> stringObjectEntry : jsonObject.entrySet()) {
                    if (valuesourceMap.size() > 0) {
                        String key = stringObjectEntry.getKey();
                        if (valuesourceMap.containsKey(key)) {
                            if ("bos_adminorg".equals(valuesourceMap.get(key))) {
                                col.set("assgrpId",stringObjectEntry.getValue());
                                map_value.put("assgrp",stringObjectEntry.getValue());
                                map_value.put("account",col.getString("accountnumber"));
                                map.put(String.valueOf(col.getLong("entriesid")),map_value);
                            }
                        }
                    }
                }
            }
        }
        return map;
    }

    //获取资金占用利率数据
    private static Map fundsUsedRate(Date startTime, Date endTime) {
        List<QFilter> qFilter = new ArrayList<>();
        qFilter.add(new QFilter("enable", QCP.equals, "1"));
//        qFilter.add(new QFilter("tpv_enddate", QCP.large_equals, startTime));
//        qFilter.add(new QFilter("tpv_enddate", QCP.less_equals, endTime));
        DataSet fundsUseRate = ORM.create().queryDataSet(algoKey, "tpv_zjzyll", "createorg.id org,tpv_depertment.id dept," +
                "tpv_interestclass.number tpv_interestclass," + //计息类别
                "tpv_begindate, tpv_enddate," +
                "tpv_dayrate," + //日利率(%)
                "tpv_deoccupyrate", //负占用利率(%)
                qFilter.toArray(new QFilter[qFilter.size()]));
        Map<String,Map<String, BigDecimal>> map = new HashMap<>();
        for (Row row : fundsUseRate) {
            String org = row.getString("org");
            String dept = row.getString("dept");
            Date tpvBegindate = row.getDate("tpv_begindate");
            Date tpvEnddate = row.getDate("tpv_enddate");
            String tpvInterestclass = row.getString("tpv_interestclass");
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String formatBegin = str.format(tpvBegindate);
            String formatEnd = str.format(tpvEnddate);
            String key = org + "》" + dept + "》" + formatBegin + "》" + formatEnd + "》" + tpvInterestclass;
            BigDecimal tpvDayrate = row.getBigDecimal("tpv_dayrate").divide(new BigDecimal("100"),11, BigDecimal.ROUND_DOWN);
            BigDecimal tpvDeoccupyrate = row.getBigDecimal("tpv_deoccupyrate").divide(new BigDecimal("100"),11, BigDecimal.ROUND_DOWN);
            Map<String, BigDecimal> value = new HashMap<>();
            value.put("tpv_dayrate",tpvDayrate);
            value.put("tpv_deoccupyrate",tpvDeoccupyrate);
            map.put(key,value);
        }
        return map;
    }

    private static String splitWhereFilter(String whereFilter, int value) {
        String[] split = whereFilter.split("》");
        if (split.length > 0) {
            int i = 0;
            for (String object : split) {
                if (i == 0 && value == 0) whereFilter = object; //where条件
                else if (i == 1 && value == 1) whereFilter = object; //公司id
                else if (i == 2 && value == 2) whereFilter = object; //开始日期
                else if (i == 3 && value == 3) whereFilter = object; //结束日期

                i++;
            }
        }
        return whereFilter;
    }
}
