package tpv.tpv_wm.tpv_sc.java.report;

import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * @Description: 担保费分摊 -报表查询插件
 * @Author LinRui
 * @Date 2024/2/5 11:44
 */
public class GuaraFeeShareQueryRpt extends AbstractReportListDataPlugin {

    private static final String algoKey = GuaraFeeShareQueryRpt.class.getName();

    @Override
    public DataSet query(ReportQueryParam reportQueryParam, Object o) throws Throwable {
        return null;
    }

    public static DataSet query(String whereFilter) {
        DataSet mainDataSet = mainDataSet(whereFilter);
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        for (DynamicObject col : col_s) {

        }
        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        return createDataSet;
    }

    private static DataSet mainDataSet(String whereFilter) {
        QFilter orgdutyQfilter = new QFilter("enable", QCP.equals, "1");
        orgdutyQfilter.and(new QFilter("orgduty.number", QCP.in, new String[]{"ZHKC002"}));
        DataSet orgduty = ORM.create().queryDataSet(algoKey, "bos_org_dutyrelation", "org.id tpv_depid",
                orgdutyQfilter.toArray());
        DataSet copyOrgduty = orgduty.copy();
        List<Long> orgdutyIds = new ArrayList<>();
        for (Row row : copyOrgduty) {
            if (!orgdutyIds.contains(row.getLong("tpv_depid"))) {
                orgdutyIds.add(row.getLong("tpv_depid"));
            }
        }

        String selectfields = "id,tpv_year,tpv_entryentity,tpv_entryentity.tpv_entryorgs tpv_entryorgs," +
                "tpv_entryentity.tpv_depertment tpv_depertment," +
                "tpv_entryentity.tpv_endtime tpv_endtime," +
                "tpv_entryentity.tpv_occupied tpv_occupied," +  //现款占用（日）
                "tpv_entryentity.tpv_applyamt tpv_applyamt," +  //票据占用（日）
                "tpv_entryentity.tpv_byamt tpv_byamt," +  //国内证额度占用（日）
                "tpv_entryentity.tpv_accamt tpv_accamt," +  //国际证额度占用（日）
                "tpv_entryentity.tpv_dateocc tpv_totalday";  //汇总（日）
        List<QFilter> qFilter = new ArrayList<>();
        qFilter.add(new QFilter("billstatus", QCP.equals, "C"));
        if (orgdutyIds.size() > 0) {
            qFilter.add(new QFilter("tpv_entryentity.tpv_depertment", QCP.in, orgdutyIds));
        } else {
            qFilter.add(new QFilter("tpv_entryentity.tpv_depertment", QCP.less_than, 0));
        }
        DataSet dataSet = ORM.create().queryDataSet(algoKey, "tpv_sc_depdayfundsuse", selectfields, qFilter.toArray(new QFilter[qFilter.size()]));
        if (YEM.isNotEmpty(whereFilter)) {
            dataSet = dataSet.where(whereFilter);
        }
        dataSet = dataSet.groupBy(new String[]{"tpv_entryorgs","tpv_depertment"})
                .sum("tpv_occupied").sum("tpv_applyamt").sum("tpv_byamt").sum("tpv_accamt")
                .sum("tpv_totalday").finish();
        dataSet = dataSet.select("tpv_entryorgs","tpv_depertment","tpv_occupied / 10000 tpv_occupiedsum","tpv_applyamt / 10000 tpv_accamtsum",
                "tpv_byamt / 10000 tpv_chinaamtsum","tpv_accamt / 10000 tpv_intamtsum","(case when tpv_totalday > 0 then tpv_totalday else 1 end) totalday");
        dataSet = dataSet.select("tpv_entryorgs","tpv_depertment","tpv_occupiedsum","tpv_accamtsum", "tpv_chinaamtsum","tpv_intamtsum",
                "(tpv_occupiedsum + tpv_accamtsum + tpv_chinaamtsum + tpv_intamtsum) tpv_totaldaysum",
                "(tpv_occupiedsum + tpv_accamtsum + tpv_chinaamtsum + tpv_intamtsum) / totalday tpv_sharescale");
        return dataSet;
    }

}
