package tpv.tpv_wm.tpv_sc.java.report;

import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.Algo;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.algo.RowMeta;
import kd.bos.algo.input.CollectionInput;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.report.AbstractReportListDataPlugin;
import kd.bos.entity.report.ReportQueryParam;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Description: 多部门资金占用 -报表查询插件
 * @Author LinRui
 * @Date 2024/2/1 11:40
 */
public class MoreDeptfundsUseQueryRpt extends AbstractReportListDataPlugin {

    private static final String algoKey = MoreDeptfundsUseQueryRpt.class.getName();

    @Override
    public DataSet query(ReportQueryParam param, Object o) throws Throwable {
        return null;
    }

    public static DataSet query(String whereFilters, Date dayStartTime, Date dayEndTime) {
        DataSet mainDataSet = mainDataSet(whereFilters);
//        String dayStartTime = splitWhereFilter(whereFilters,1);
//        String dayEndTime = splitWhereFilter(whereFilters,2);
//        Date startTime = DateUtil.parseDateHms(dayStartTime);
//        Date endTime = DateUtil.parseDateHms(dayEndTime);
        Map<String, Map<String, BigDecimal>> fundsUsedRate = fundsUsedRate(dayStartTime, dayEndTime);
        Map<Long, Long> parentDeptIds = mapParentDeptIds();
        DynamicObjectCollection col_s = ORM.create().toPlainDynamicObjectCollection(mainDataSet);
        for (DynamicObject col : col_s) {
            for (String key : fundsUsedRate.keySet()) {//1955166085019874304
                String[] split = key.split("》");
                if (("".equals(split[0]) || true) && col.getString("tpv_depertment").equals(split[1])
                        && col.getDate("day").compareTo(DateUtil.parseDateHms(split[2])) >= 0
                        && col.getDate("day").compareTo(DateUtil.parseDateHms(split[3])) <= 0) {
                    BigDecimal tpv_dayrate = fundsUsedRate.get(key).get("tpv_dayrate");
                    BigDecimal tpv_deoccupyrate = fundsUsedRate.get(key).get("tpv_deoccupyrate");
                    if ("KC00001".equals(split[4])) {//现款
                        col.set("tpv_cashaddrate", tpv_dayrate);
                        col.set("tpv_cashlessrate", tpv_deoccupyrate);
                    }
                    if ("KC00010".equals(split[4])) {//应收票据（银承）
                        col.set("tpv_receiveaddrate", tpv_dayrate);
                        col.set("tpv_receivelessrate", tpv_deoccupyrate);
                    }
                    if ("KC00005".equals(split[4])) {//应付票据（银承）
                        col.set("tpv_payaddrate", tpv_dayrate);
                        col.set("tpv_paylessrate", tpv_deoccupyrate);
                    }
                    if ("KC00030".equals(split[4])) {//应收票据（商票）
                        col.set("tpv_cprcvddrate", tpv_dayrate);
                        col.set("tpv_cprcvlessrate", tpv_deoccupyrate);
                    }
                    if ("KC00025".equals(split[4])) {//应付票据（商票）
                        col.set("tpv_cppayaddrate", tpv_dayrate);
                        col.set("tpv_cppaylessrate", tpv_deoccupyrate);
                    }
                    if ("KC00040".equals(split[4])) {//供应链票据
                        col.set("tpv_scmproaddrate", tpv_dayrate);
                        col.set("tpv_scmprolessrate", tpv_deoccupyrate);
                    }
                }
            }
        }

        //切换大部门
        for (DynamicObject col : col_s) {
            if (parentDeptIds.containsKey(col.getLong("tpv_depertment"))) {
                col.set("tpv_depertment", parentDeptIds.get(col.getLong("tpv_depertment")));
            }
        }

        RowMeta rowMeta = mainDataSet.getRowMeta();
        int fieldCount = rowMeta.getFieldCount();
        Collection<Object[]> collection = new ArrayList<>();
        for (int i = 0; i < col_s.size(); i++) {
            DynamicObject col = col_s.get(i);
            Object[] obj = new Object[fieldCount];
            for (int j = 0; j < fieldCount; j++) {
                obj[j] = col.get(j);
            }
            collection.add(obj);
        }
        CollectionInput inputs = new CollectionInput(rowMeta, collection);
        DataSet createDataSet = Algo.create(algoKey).createDataSet(inputs);
        createDataSet = createDataSet.select("tpv_depertment", "tpv_day",
                "tpv_cashoccupamt", "tpv_receiveoccupamt", "tpv_payoccupamt", "tpv_bankoccupamt", "tpv_cprcvoccupamt",
                "tpv_cppayoccupamt", "tpv_cpoccupamt", "tpv_scmprooccupamt", "tpv_scmfinoccupamt",
                "(case when tpv_cashoccupamt >= 0.0 then tpv_cashoccupamt * tpv_cashaddrate else tpv_cashoccupamt * tpv_cashlessrate end) tpv_cashinamt",
                "(case when tpv_receiveoccupamt >= 0.0 then tpv_receiveoccupamt * tpv_receiveaddrate else tpv_receiveoccupamt * tpv_receivelessrate end) tpv_receiveinamt",
                "(case when tpv_payoccupamt >= 0.0 then tpv_payoccupamt * tpv_payaddrate else tpv_payoccupamt * tpv_paylessrate end) tpv_payinamt",
                "(case when tpv_cprcvoccupamt >= 0.0 then tpv_cprcvoccupamt * tpv_cprcvddrate else tpv_cprcvoccupamt * tpv_cprcvlessrate end) tpv_cprcvinamt",
                "(case when tpv_cppayoccupamt >= 0.0 then tpv_cppayoccupamt * tpv_cppayaddrate else tpv_cppayoccupamt * tpv_cppaylessrate end) tpv_cppayinamt",
                "(case when tpv_scmprooccupamt >= 0.0 then tpv_scmprooccupamt * tpv_scmproaddrate else tpv_scmprooccupamt * tpv_scmprolessrate end) tpv_scmproinamt",
                "(case when tpv_scmfinoccupamt >= 0.0 then tpv_scmfinoccupamt * 0.0 else tpv_scmfinoccupamt * 0.0 end) tpv_scmfininamt",
                "(case when tpv_chinaoccupamt >= 0.0 then tpv_chinaoccupamt * 0.0 else tpv_chinaoccupamt * 0.0 end) tpv_chinainamt",
                "tpv_scmfinoccadd","tpv_scmfinoccsub","tpv_chinaoccadd","tpv_chinaoccsub",
                "tpv_cashoadd","tpv_cashosub","tpv_receiveoadd","tpv_receiveosub","tpv_payoccuadd","tpv_payoccusub","tpv_cprcvoccadd","tpv_cprcvoccsub",
                "tpv_cppayoccadd","tpv_cppayoccsub","tpv_scmproocadd","tpv_scmproocsub");
        createDataSet = createDataSet.select("tpv_depertment", "tpv_day",
                "tpv_cashoccupamt", "tpv_receiveoccupamt", "tpv_payoccupamt", "tpv_bankoccupamt", "tpv_cprcvoccupamt",
                "tpv_cppayoccupamt", "tpv_cpoccupamt", "tpv_scmprooccupamt", "tpv_scmfinoccupamt",
                "tpv_cashinamt", "tpv_receiveinamt", "tpv_payinamt", "tpv_cprcvinamt", "tpv_cppayinamt", "tpv_scmproinamt",
                "tpv_scmfininamt", "tpv_chinainamt", "(tpv_receiveinamt + tpv_payinamt) tpv_bankinamt", "(tpv_cprcvinamt + tpv_cppayinamt) tpv_cpinamt",
                "tpv_scmfinoccadd","tpv_scmfinoccsub","tpv_chinaoccadd","tpv_chinaoccsub",
                "tpv_cashoadd","tpv_cashosub","tpv_receiveoadd","tpv_receiveosub","tpv_payoccuadd","tpv_payoccusub","tpv_cprcvoccadd","tpv_cprcvoccsub",
                "tpv_cppayoccadd","tpv_cppayoccsub","tpv_scmproocadd","tpv_scmproocsub");
        QFilter qFiltero = new QFilter("orgpattern.number", QCP.in, new String[]{"Orgform02", "Orgform03"}); //形态：公司、分公司
        qFiltero.and(new QFilter("enable", QCP.equals, "1"));
        DataSet bos_org = ORM.create().queryDataSet(algoKey, "bos_org", "id oid,number onumber,name oname", qFiltero.toArray());

        QFilter orgdutyQfilter = new QFilter("enable", QCP.equals, "1");
        orgdutyQfilter.and(new QFilter("orgduty.number", QCP.in, new String[]{"ZHKC002"}));
        DataSet orgduty = ORM.create().queryDataSet(algoKey, "bos_org_dutyrelation", "org.id tpv_depid",
                orgdutyQfilter.toArray());
        DataSet copyOrgduty = orgduty.copy();
        List<Long> orgdutyIds = new ArrayList<>();
        for (Row row : copyOrgduty) {
            if (!orgdutyIds.contains(row.getLong("tpv_depid"))) {
                orgdutyIds.add(row.getLong("tpv_depid"));
            }
        }

        QFilter qFilterd = new QFilter("orgpattern.number", QCP.equals, "Orgform06"); //形态：部门
        qFilterd.and(new QFilter("enable", QCP.equals, "1"));
        if (orgdutyIds.size() > 0) {
            qFilterd.and(new QFilter("id", QCP.in, orgdutyIds));
        } else {
            qFilterd.and(new QFilter("id", QCP.less_than, 0));
        }
        DataSet bos_adminorg = ORM.create().queryDataSet(algoKey, "bos_adminorg", "id did,number dnumber,name dname,structure.viewparent.id porgid", qFilterd.toArray());

        DataSet dataSetbos = bos_org.leftJoin(bos_adminorg).on("oid", "porgid").select("oid", "did", "onumber", "dnumber", "oname", "dname").finish();;
        createDataSet = dataSetbos.leftJoin(createDataSet).on("did", "tpv_depertment")
                .select("did tpv_depertment", "tpv_day",
                        "tpv_cashoccupamt", "tpv_receiveoccupamt", "tpv_payoccupamt", "tpv_bankoccupamt", "tpv_cprcvoccupamt",
                        "tpv_cppayoccupamt", "tpv_cpoccupamt", "tpv_scmprooccupamt", "tpv_scmfinoccupamt",
                        "tpv_cashinamt", "tpv_receiveinamt", "tpv_payinamt", "tpv_cprcvinamt", "tpv_cppayinamt", "tpv_scmproinamt",
                        "tpv_scmfininamt", "tpv_chinainamt", "tpv_bankinamt", "tpv_cpinamt",
                        "tpv_scmfinoccadd","tpv_scmfinoccsub","tpv_chinaoccadd","tpv_chinaoccsub",
                        "tpv_cashoadd","tpv_cashosub","tpv_receiveoadd","tpv_receiveosub","tpv_payoccuadd","tpv_payoccusub","tpv_cprcvoccadd","tpv_cprcvoccsub",
                        "tpv_cppayoccadd","tpv_cppayoccsub","tpv_scmproocadd","tpv_scmproocsub").finish().where("tpv_depertment > 0");
        return createDataSet.orderBy(new String[]{"tpv_depertment", "tpv_day asc"});
    }

    private static DataSet mainDataSet(String whereFilters) {
        String whereFilter = splitWhereFilter(whereFilters, 0);
        String selectfields = "id,tpv_year,tpv_month,tpv_company,tpv_sc_fundsused_aa,tpv_sc_fundsused_aa.tpv_businessdate tpv_businessdate," +
                "tpv_sc_fundsused_aa.tpv_companys tpv_companys,tpv_sc_fundsused_aa.tpv_depertment tpv_depertment," +
                "tpv_sc_fundsused_aa.tpv_depertment.createtime tpv_createtime," +
                "tpv_sc_fundsused_aa.tpv_add tpv_cashoadd,"+ //现款(占用金额)  增加
                "tpv_sc_fundsused_aa.tpv_reduce tpv_cashosub,"+ //现款(占用金额)  减少
                "tpv_sc_fundsused_aa.tpv_occupied tpv_cashoccupamt," + //现款(占用金额)
                "tpv_sc_fundsused_aa.tpv_increase tpv_receiveoadd,"+ //应收票据（银承）增加
                "tpv_sc_fundsused_aa.tpv_increase tpv_receiveosub,"+ //应收票据（银承）减少
                "tpv_sc_fundsused_aa.tpv_occupyamt tpv_receiveoccupamt," + //应收票据（银承）
                "tpv_sc_fundsused_aa.tpv_augment tpv_payoccuadd,"+//应付票据（银承） 增加
                "tpv_sc_fundsused_aa.tpv_lessen tpv_payoccusub,"+//应付票据（银承） 减少
                "tpv_sc_fundsused_aa.tpv_holdamt tpv_payoccupamt," + //应付票据（银承）
                "tpv_sc_fundsused_aa.tpv_applyamt tpv_bankoccupamt," + //银承(占用金额)
                "tpv_sc_fundsused_aa.tpv_enhance tpv_cprcvoccadd,"+//应收票据（商票） 增加
                "tpv_sc_fundsused_aa.tpv_little tpv_cprcvoccsub,"+//应收票据（商票） 减少
                "tpv_sc_fundsused_aa.tpv_useamt tpv_cprcvoccupamt," + //应收票据（商票）
                "tpv_sc_fundsused_aa.tpv_plus tpv_cppayoccadd,"+//应付票据（商票）  增加
                "tpv_sc_fundsused_aa.tpv_few tpv_cppayoccsub,"+//应付票据（商票）  减少
                "tpv_sc_fundsused_aa.tpv_needamt tpv_cppayoccupamt," + //应付票据（商票）
                "tpv_sc_fundsused_aa.tpv_byamt tpv_cpoccupamt," + //商票(占用金额)
                "tpv_sc_fundsused_aa.tpv_aug tpv_scmproocadd,"+//供应链票据(占用金额 增加
                "tpv_sc_fundsused_aa.tpv_minus tpv_scmproocsub,"+//供应链票据(占用金额 减少
                "tpv_sc_fundsused_aa.tpv_accamt tpv_scmprooccupamt"; //供应链票据(占用金额)
        List<QFilter> qFilter = new ArrayList<>();
        qFilter.add(new QFilter("billstatus", QCP.equals, "C"));
        DataSet dataSet = ORM.create().queryDataSet(algoKey, "tpv_sc_fundsused", selectfields, qFilter.toArray(new QFilter[qFilter.size()]));
        dataSet = dataSet.addField("0.0 tpv_scmfinoccupamt", "tpv_scmfinoccupamt");
        dataSet = dataSet.addField("0.0 tpv_chinaoccupamt", "tpv_chinaoccupamt");
        dataSet = dataSet.addField("0.0 tpv_scmfinoccadd", "tpv_scmfinoccadd");
        dataSet = dataSet.addField("0.0 tpv_scmfinoccsub", "tpv_scmfinoccsub");
        dataSet = dataSet.addField("0.0 tpv_chinaoccadd", "tpv_chinaoccadd");
        dataSet = dataSet.addField("0.0 tpv_chinaoccsub", "tpv_chinaoccsub");
        dataSet = dataSet.addField("'' tpv_day", "tpv_day");
        dataSet = dataSet.select("tpv_companys", "tpv_depertment", "tpv_businessdate", "to_char(tpv_businessdate,'yyyy-MM-dd') tpv_day",
                "tpv_cashoccupamt", "tpv_receiveoccupamt", "tpv_payoccupamt", "tpv_bankoccupamt", "tpv_cprcvoccupamt", "tpv_cppayoccupamt",
                "tpv_cpoccupamt", "tpv_scmprooccupamt", "tpv_scmfinoccupamt", "tpv_chinaoccupamt",//增加，减少
                "tpv_cashoadd","tpv_cashosub","tpv_receiveoadd","tpv_receiveosub","tpv_payoccuadd","tpv_payoccusub","tpv_cprcvoccadd","tpv_cprcvoccsub",
                "tpv_cppayoccadd","tpv_cppayoccsub","tpv_scmproocadd","tpv_scmproocsub",
                "tpv_scmfinoccadd","tpv_scmfinoccsub","tpv_chinaoccadd","tpv_chinaoccsub");

        String selectfields2 = "id,tpv_deptfundyear tpv_year,tpv_deptfundmonth tpv_month,tpv_company,tpv_entryentity," +
                "tpv_entryentity.tpv_businessdates tpv_businessdate," +
                "tpv_entryentity.tpv_companys.id tpv_companys," +
                "tpv_entryentity.tpv_dept.id tpv_depertment," +
                "tpv_entryentity.tpv_dept.createtime tpv_createtime," +
                "tpv_entryentity.tpv_supincrease tpv_scmfinoccadd," +//供应链金融 增加
                "tpv_entryentity.tpv_supdecrease tpv_scmfinoccsub," +//供应链金融 减少
                "tpv_entryentity.tpv_supamount tpv_scmfinoccupamt," +//供应链金融
                "tpv_entryentity.tpv_increase tpv_chinaoccadd,"+//国内占用费 增加
                "tpv_entryentity.tpv_decrease tpv_chinaoccsub,"+//国内占用费 减少
                "tpv_entryentity.tpv_amount tpv_chinaoccupamt";//国内占用费
        DataSet tpv_sc_supfunddetails = ORM.create().queryDataSet(algoKey, "tpv_sc_supfunddetails", selectfields2, qFilter.toArray(new QFilter[qFilter.size()]));

        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_scmproocsub", "tpv_scmproocsub");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_scmproocadd", "tpv_scmproocadd");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_cppayoccsub", "tpv_cppayoccsub");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_cppayoccadd", "tpv_cppayoccadd");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_cprcvoccsub", "tpv_cprcvoccsub");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_cprcvoccadd", "tpv_cprcvoccadd");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_payoccusub", "tpv_payoccusub");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_payoccuadd", "tpv_payoccuadd");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_receiveosub", "tpv_receiveosub");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_receiveoadd", "tpv_receiveoadd");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_cashosub", "tpv_cashosub");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_cashoadd", "tpv_cashoadd");

        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_cashoccupamt", "tpv_cashoccupamt");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_receiveoccupamt", "tpv_receiveoccupamt");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_payoccupamt", "tpv_payoccupamt");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_bankoccupamt", "tpv_bankoccupamt");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_cprcvoccupamt", "tpv_cprcvoccupamt");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_cppayoccupamt", "tpv_cppayoccupamt");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_cpoccupamt", "tpv_cpoccupamt");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("0.0 tpv_scmprooccupamt", "tpv_scmprooccupamt");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.addField("'' tpv_day", "tpv_day");
        tpv_sc_supfunddetails = tpv_sc_supfunddetails.select("tpv_companys", "tpv_depertment", "tpv_businessdate", "to_char(tpv_businessdate,'yyyy-MM-dd') tpv_day",
                "tpv_cashoccupamt", "tpv_receiveoccupamt", "tpv_payoccupamt", "tpv_bankoccupamt", "tpv_cprcvoccupamt", "tpv_cppayoccupamt",
                "tpv_cpoccupamt", "tpv_scmprooccupamt", "tpv_scmfinoccupamt", "tpv_chinaoccupamt",
                "tpv_scmfinoccadd","tpv_scmfinoccsub","tpv_chinaoccadd","tpv_chinaoccsub",
                "tpv_cashoadd","tpv_cashosub","tpv_receiveoadd","tpv_receiveosub","tpv_payoccuadd","tpv_payoccusub","tpv_cprcvoccadd","tpv_cprcvoccsub",
                "tpv_cppayoccadd","tpv_cppayoccsub","tpv_scmproocadd","tpv_scmproocsub");
        dataSet = dataSet.union(tpv_sc_supfunddetails);

        if (YEM.isNotEmpty(whereFilter)) {
            dataSet = dataSet.where(whereFilter);
        }
        dataSet = dataSet.groupBy(new String[]{"tpv_depertment", "tpv_day"})
                .sum("tpv_cashoccupamt").sum("tpv_receiveoccupamt").sum("tpv_payoccupamt")
                .sum("tpv_bankoccupamt").sum("tpv_cprcvoccupamt").sum("tpv_cppayoccupamt")
                .sum("tpv_cpoccupamt").sum("tpv_scmprooccupamt").sum("tpv_scmfinoccupamt")
                .sum("tpv_chinaoccupamt").sum("tpv_scmfinoccadd").sum("tpv_scmfinoccsub")
                .sum("tpv_chinaoccadd").sum("tpv_chinaoccsub").sum("tpv_cashoadd").sum("tpv_cashosub")
                .sum("tpv_receiveoadd").sum("tpv_receiveosub").sum("tpv_payoccuadd").sum("tpv_payoccusub")
                .sum("tpv_cprcvoccadd").sum("tpv_cprcvoccsub").sum("tpv_cppayoccadd").sum("tpv_cppayoccsub")
                .sum("tpv_scmproocadd").sum("tpv_scmproocsub").finish();
        dataSet = dataSet.select("tpv_depertment", "tpv_day", "to_date(tpv_day,'yyyy-MM-dd') day",
                "tpv_cashoccupamt", "0.0 tpv_cashaddrate", "0.0 tpv_cashlessrate", //现款
                "tpv_receiveoccupamt", "0.0 tpv_receiveaddrate", "0.0 tpv_receivelessrate", //应收票据（银承）
                "tpv_payoccupamt", "0.0 tpv_payaddrate", "0.0 tpv_paylessrate", //应付票据（银承）
                "tpv_cprcvoccupamt", "0.0 tpv_cprcvddrate", "0.0 tpv_cprcvlessrate", //应收票据（商票）
                "tpv_cppayoccupamt", "0.0 tpv_cppayaddrate", "0.0 tpv_cppaylessrate", //应付票据（商票）
                "tpv_scmprooccupamt", "0.0 tpv_scmproaddrate", "0.0 tpv_scmprolessrate", //供应链票据
                "tpv_bankoccupamt", "tpv_cpoccupamt", "tpv_scmfinoccupamt", "tpv_chinaoccupamt",
                "tpv_scmfinoccadd","tpv_scmfinoccsub","tpv_chinaoccadd","tpv_chinaoccsub",
                "tpv_cashoadd","tpv_cashosub","tpv_receiveoadd","tpv_receiveosub","tpv_payoccuadd","tpv_payoccusub","tpv_cprcvoccadd","tpv_cprcvoccsub",
                "tpv_cppayoccadd","tpv_cppayoccsub","tpv_scmproocadd","tpv_scmproocsub"
        );
        return dataSet;
    }

    //获取资金占用利率数据
    private static Map fundsUsedRate(Date startTime, Date endTime) {
        List<QFilter> qFilter = new ArrayList<>();
        qFilter.add(new QFilter("enable", QCP.equals, "1"));
        qFilter.add(new QFilter("tpv_begindate", QCP.less_equals, startTime));
        qFilter.add(new QFilter("tpv_enddate", QCP.large_equals, endTime));
        qFilter.add(new QFilter("createorg.number", QCP.equals, "Org-00001"));//中航国际矿产资源有限公司
        DataSet fundsUseRate = ORM.create().queryDataSet(algoKey, "tpv_zjzyll", "createorg.id org,tpv_depertment.id dept," +
                        "tpv_interestclass.number tpv_interestclass," + //计息类别
                        "tpv_begindate, tpv_enddate," +
                        "tpv_dayrate," + //日利率(%)
                        "tpv_deoccupyrate", //负占用利率(%)
                qFilter.toArray(new QFilter[qFilter.size()]));
        Map<String, Map<String, BigDecimal>> map = new HashMap<>();
        for (Row row : fundsUseRate) {
            String org = row.getString("org");
            String dept = row.getString("dept");
            Date tpvBegindate = row.getDate("tpv_begindate");
            Date tpvEnddate = row.getDate("tpv_enddate");
            String tpvInterestclass = row.getString("tpv_interestclass");
            SimpleDateFormat str = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String formatBegin = str.format(tpvBegindate);
            String formatEnd = str.format(tpvEnddate);
            String key = org + "》" + dept + "》" + formatBegin + "》" + formatEnd + "》" + tpvInterestclass;
            BigDecimal tpvDayrate = row.getBigDecimal("tpv_dayrate").divide(new BigDecimal("100"), 4, BigDecimal.ROUND_DOWN);
            BigDecimal tpvDeoccupyrate = row.getBigDecimal("tpv_deoccupyrate").divide(new BigDecimal("100"), 4, BigDecimal.ROUND_DOWN);
            Map<String, BigDecimal> value = new HashMap<>();
            value.put("tpv_dayrate", tpvDayrate);
            value.put("tpv_deoccupyrate", tpvDeoccupyrate);
            map.put(key, value);
        }
        return map;
    }

    private static String splitWhereFilter(String whereFilter, int value) {
        String[] split = whereFilter.split("》");
        if (split.length > 0) {
            int i = 0;
            for (String object : split) {
                if (i == 0 && value == 0) whereFilter = object; //where条件
                else if (i == 1 && value == 1) whereFilter = object; //开始日期
                else if (i == 2 && value == 2) whereFilter = object; //结束日期
                i++;
            }
        }
        return whereFilter;
    }

    private static Map<Long, Long> mapParentDeptIds() {
        Map<Long, Long> mapParentId = new HashMap<>();
        QFilter qFilter = new QFilter("enable", QCP.equals, "1");
//        qFilter.and(new QFilter("number",QCP.equals,"Org-01-001-019-001"));
        qFilter.and(new QFilter("orgpattern.number", QCP.in, new String[]{"OF-01", "Orgform06"}));
        DynamicObject[] bosAdminorgs = BusinessDataServiceHelper.load("bos_adminorg", "id,orgpattern,structure,structure.viewparent", qFilter.toArray());
        if (bosAdminorgs.length > 0) {
            for (DynamicObject bosAdminorg : bosAdminorgs) {
                DynamicObject orgpattern = bosAdminorg.getDynamicObject("orgpattern");
                if (YEM.isNotEmpty(orgpattern)) {
                    String number = orgpattern.getString("number");
                    if ("OF-01".equals(number)) { //小组只会对应一个部门
                        DynamicObjectCollection dynamicObjects = bosAdminorg.getDynamicObjectCollection("structure");
                        if (dynamicObjects.size() > 0) {
                            for (DynamicObject dynamicObject : dynamicObjects) {
                                DynamicObject viewparent = dynamicObject.getDynamicObject("viewparent");
                                if (YEM.isNotEmpty(viewparent)) {
                                    mapParentId.put(bosAdminorg.getLong("id"), viewparent.getLong("id"));
                                }
                                break;
                            }
                        }
                    } else if ("Orgform06".equals(number)) {
                        mapParentId.put(bosAdminorg.getLong("id"), bosAdminorg.getLong("id"));
                    }
                }
            }
        }
        return mapParentId;
    }

}
