package tpv.tpv_wm.tpv_sys.java.api.entitys;

import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

/**
 * 易氩接口实体类
 * 合同比对接口
 *
 * @author LiuHB
 * @version 1.0
 */
@ApiModel
public class PactContrastModel implements Serializable {
    @ApiParam(value = "单据号", required = true)
    private String billCode;
    @ApiParam(value = "部门编码", required = true)
    private String groupCode;
    @ApiParam(value = "当前登录操作人的用户编码", required = true)
    private String userCode;
    @ApiParam(value = "比对类型（值参考<合同比对种类>）", required = true)
    private String diffType;
    @ApiParam(value = "我司抬头")
    private String companyFoo;
    @ApiParam(value = "客户名称", required = true)
    private String companyBar;
    @ApiParam(value = "我司章分类编码")
    private String companyFooTypeCode;
    @ApiParam(value = "客户章分类编码", required = true)
    private String companyBarTypeCode;
    @ApiParam(value = "原件路径")
    private String orgPath;
    @ApiParam(value = "签件路径（关键信息比对或者只比章等单文件比对类型时，可以不设）")
    private String tarPath;
    @ApiParam(value = "原件base64")
    private String orgB64;
    @ApiParam(value = "签件base64", required = true)
    private String tarB64;
    @ApiParam(value = "原件名")
    private String orgName;
    @ApiParam(value = "签件名", required = true)
    private String tarName;
    @ApiParam(value = "路径编码")
    private String pathCode;
    @ApiParam(value = "关键信息", required = true)
    private List<Map> keywords;
    @ApiParam(value = "单据类型")
    private String sheetCode;
    @ApiParam(value = "单据内码")
    private String billiCode;

    public String getBillCode() {
        return billCode;
    }

    public void setBillCode(String billCode) {
        this.billCode = billCode;
    }

    public String getGroupCode() {
        return groupCode;
    }

    public void setGroupCode(String groupCode) {
        this.groupCode = groupCode;
    }

    public String getUserCode() {
        return userCode;
    }

    public void setUserCode(String userCode) {
        this.userCode = userCode;
    }

    public String getDiffType() {
        return diffType;
    }

    public void setDiffType(String diffType) {
        this.diffType = diffType;
    }

    public String getCompanyFoo() {
        return companyFoo;
    }

    public void setCompanyFoo(String companyFoo) {
        this.companyFoo = companyFoo;
    }

    public String getCompanyBar() {
        return companyBar;
    }

    public void setCompanyBar(String companyBar) {
        this.companyBar = companyBar;
    }

    public String getCompanyFooTypeCode() {
        return companyFooTypeCode;
    }

    public void setCompanyFooTypeCode(String companyFooTypeCode) {
        this.companyFooTypeCode = companyFooTypeCode;
    }

    public String getCompanyBarTypeCode() {
        return companyBarTypeCode;
    }

    public void setCompanyBarTypeCode(String companyBarTypeCode) {
        this.companyBarTypeCode = companyBarTypeCode;
    }

    public String getOrgPath() {
        return orgPath;
    }

    public void setOrgPath(String orgPath) {
        this.orgPath = orgPath;
    }

    public String getTarPath() {
        return tarPath;
    }

    public void setTarPath(String tarPath) {
        this.tarPath = tarPath;
    }

    public String getOrgB64() {
        return orgB64;
    }

    public void setOrgB64(String orgB64) {
        this.orgB64 = orgB64;
    }

    public String getTarB64() {
        return tarB64;
    }

    public void setTarB64(String tarB64) {
        this.tarB64 = tarB64;
    }

    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public String getTarName() {
        return tarName;
    }

    public void setTarName(String tarName) {
        this.tarName = tarName;
    }

    public String getPathCode() {
        return pathCode;
    }

    public void setPathCode(String pathCode) {
        this.pathCode = pathCode;
    }

    public List<Map> getKeywords() {
        return keywords;
    }

    public void setKeywords(List<Map> keywords) {
        this.keywords = keywords;
    }

    public String getSheetCode() {
        return sheetCode;
    }

    public void setSheetCode(String sheetCode) {
        this.sheetCode = sheetCode;
    }

    public String getBilliCode() {
        return billiCode;
    }

    public void setBilliCode(String billiCode) {
        this.billiCode = billiCode;
    }

    @Override
    public String toString() {
        return "PactContrastModel{" +
                "billCode='" + billCode + '\'' +
                ", groupCode='" + groupCode + '\'' +
                ", userCode='" + userCode + '\'' +
                ", diffType='" + diffType + '\'' +
                ", companyFoo='" + companyFoo + '\'' +
                ", companyBar='" + companyBar + '\'' +
                ", companyFooTypeCode='" + companyFooTypeCode + '\'' +
                ", companyBarTypeCode='" + companyBarTypeCode + '\'' +
                ", orgPath='" + orgPath + '\'' +
                ", tarPath='" + tarPath + '\'' +
                ", orgB64='" + orgB64 + '\'' +
                ", tarB64='" + tarB64 + '\'' +
                ", orgName='" + orgName + '\'' +
                ", tarName='" + tarName + '\'' +
                ", pathCode='" + pathCode + '\'' +
                ", keywords=" + keywords +
                ", sheetCode='" + sheetCode + '\'' +
                ", billiCode='" + billiCode + '\'' +
                '}';
    }
}
