package tpv.tpv_wm.tpv_sys.java.api.entitys;

import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

import java.io.Serializable;

/**
 * 易氩接口实体类
 * API-Y1向易氩传递原附件并要求生成PDF
 *
 * @author LiuHB
 * @version 1.0
 */
@ApiModel
public class PdfFileModel implements Serializable {

    @ApiParam(value = "二维码页面", required = true)
    private String qr_page;
    @ApiParam(value = "二维码坐标", required = true)
    private String qr_location;
    @ApiParam(value = "二维码尺寸", required = true)
    private String qr_size;
    @ApiParam(value = "二维码内容", required = true)
    private String qr_text;
    @ApiParam(value = "用印申请ID", required = true)
    private String sealapply_id;
    @ApiParam(value = "附件ID", required = true)
    private String attachment_id;
    @ApiParam(value = "单据编号")
    private String contract_no;
    @ApiParam(value = "制单人")
    private String vprepare_uid;
    @ApiParam(value = "大部门")
    private String department_id;
    @ApiParam(value = "纸张方向")
    private String orientation;
    @ApiParam(value = "批准用印人")
    private String grantor_uid;
    @ApiParam(value = "印章id")
    private String seal_ids;
    @ApiParam(value = "我司抬头")
    private String corpbcode;
    @ApiParam(value = "客户名称")
    private String code;
    @ApiParam(value = "备注")
    private String remark;
    @ApiParam(value = "源文件", required = true)
    private String file_b64;
    @ApiParam(value = "源文件名", required = true)
    private String file_name;
    @ApiParam(value = "缩放比率")
    private String resize_percent;

    public String getQr_page() {
        return qr_page;
    }

    public void setQr_page(String qr_page) {
        this.qr_page = qr_page;
    }

    public String getQr_location() {
        return qr_location;
    }

    public void setQr_location(String qr_location) {
        this.qr_location = qr_location;
    }

    public String getQr_size() {
        return qr_size;
    }

    public void setQr_size(String qr_size) {
        this.qr_size = qr_size;
    }

    public String getQr_text() {
        return qr_text;
    }

    public void setQr_text(String qr_text) {
        this.qr_text = qr_text;
    }

    public String getSealapply_id() {
        return sealapply_id;
    }

    public void setSealapply_id(String sealapply_id) {
        this.sealapply_id = sealapply_id;
    }

    public String getAttachment_id() {
        return attachment_id;
    }

    public void setAttachment_id(String attachment_id) {
        this.attachment_id = attachment_id;
    }

    public String getContract_no() {
        return contract_no;
    }

    public void setContract_no(String contract_no) {
        this.contract_no = contract_no;
    }

    public String getVprepare_uid() {
        return vprepare_uid;
    }

    public void setVprepare_uid(String vprepare_uid) {
        this.vprepare_uid = vprepare_uid;
    }

    public String getDepartment_id() {
        return department_id;
    }

    public void setDepartment_id(String department_id) {
        this.department_id = department_id;
    }

    public String getOrientation() {
        return orientation;
    }

    public void setOrientation(String orientation) {
        this.orientation = orientation;
    }

    public String getGrantor_uid() {
        return grantor_uid;
    }

    public void setGrantor_uid(String grantor_uid) {
        this.grantor_uid = grantor_uid;
    }

    public String getSeal_ids() {
        return seal_ids;
    }

    public void setSeal_ids(String seal_ids) {
        this.seal_ids = seal_ids;
    }

    public String getCorpbcode() {
        return corpbcode;
    }

    public void setCorpbcode(String corpbcode) {
        this.corpbcode = corpbcode;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getFile_b64() {
        return file_b64;
    }

    public void setFile_b64(String file_b64) {
        this.file_b64 = file_b64;
    }

    public String getFile_name() {
        return file_name;
    }

    public void setFile_name(String file_name) {
        this.file_name = file_name;
    }

    public String getResize_percent() {
        return resize_percent;
    }

    public void setResize_percent(String resize_percent) {
        this.resize_percent = resize_percent;
    }

    @Override
    public String toString() {
        return "PdfFileModel{" +
                "qr_page='" + qr_page + '\'' +
                ", qr_location='" + qr_location + '\'' +
                ", qr_size='" + qr_size + '\'' +
                ", qr_text='" + qr_text + '\'' +
                ", sealapply_id='" + sealapply_id + '\'' +
                ", attachment_id='" + attachment_id + '\'' +
                ", contract_no='" + contract_no + '\'' +
                ", vprepare_uid='" + vprepare_uid + '\'' +
                ", department_id='" + department_id + '\'' +
                ", orientation='" + orientation + '\'' +
                ", grantor_uid='" + grantor_uid + '\'' +
                ", seal_ids='" + seal_ids + '\'' +
                ", corpbcode='" + corpbcode + '\'' +
                ", ccode='" + code + '\'' +
                ", remark='" + remark + '\'' +
                ", file_b64='" + file_b64 + '\'' +
                ", file_name='" + file_name + '\'' +
                ", resize_percent='" + resize_percent + '\'' +
                '}';
    }
}
