package tpv.tpv_wm.tpv_sys.java.formplugin.dynamic;

import com.itopview.wm.sys.formplugin.dynamic.ApptoSetsTestEdit;
import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityProperty;
import kd.bos.dataentity.metadata.clr.DataEntityPropertyCollection;
import kd.bos.entity.ValueMapItem;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.property.*;
import kd.bos.form.CloseCallBack;
import kd.bos.form.IFormView;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;

import java.util.*;

/**
 * ER内容方案测试插件
 *
 * @author LiuHB
 * @version 1.0
 */
public class DetailsTestEdit extends AbstractFormPlugin {
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        IFormView view = this.getView();
        IFormView parentView = view.getParentView();
        String tpvRichtexteditorap = (String) parentView.getModel().getValue("tpv_data");
        this.getModel().setValue("tpv_richtexteditorap", tpvRichtexteditorap);
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"tpv_billno"});
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "tpv_billno":
                this.billnoClick();
        }
    }

    private void billnoClick() {
        IFormView view = this.getView();
        IFormView parentView = view.getParentView();
        IDataModel parentModel = parentView.getModel();
        DynamicObject tpv_requirebill = (DynamicObject) parentModel.getValue("tpv_requirebill");
        if (tpv_requirebill != null) {
            String billkey = tpv_requirebill.getString("number");
            ListShowParameter createShowListForm = ShowFormHelper.createShowListForm(billkey, false, 0);
            createShowListForm.setCloseCallBack(new CloseCallBack(this, "billnoClick"));
            view.showForm(createShowListForm);
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        String actionId = closedCallBackEvent.getActionId();
        Object returnData = closedCallBackEvent.getReturnData();
        switch (actionId) {
            case "billnoClick":
                billF7CallBack(returnData);
                break;
            default:
                break;
        }
    }

    private void billF7CallBack(Object returnData) {
        IFormView view = this.getView();
        IDataModel model = this.getModel();
        IFormView parentView = view.getParentView();
        IDataModel parentModel = parentView.getModel();

        DynamicObject tpv_requirebill = (DynamicObject) parentModel.getValue("tpv_requirebill");

        if (returnData instanceof ListSelectedRowCollection) {
            ListSelectedRowCollection selectRows = (ListSelectedRowCollection) returnData;
            if (selectRows != null && selectRows.size() > 0) {

                String billkey = tpv_requirebill.getString("number");
                String billNo = selectRows.get(0).getBillNo();
                Object pkId = selectRows.get(0).getPrimaryKeyValue();
                DynamicObject tplId = parentModel.getDataEntity(true);

                String newText = ApptoSetsTestEdit.bulidRichText(tplId, pkId, billkey);

                this.getModel().setValue("tpv_richtexteditorap", newText);
                model.setValue("tpv_billno", billNo);
            }
        }
    }

    public static String bulidRichText(Object tplId, Object pkId, String billkey) {
        if (QueryServiceHelper.exists("tpv_iscb_details", tplId)) {
            DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(tplId, "tpv_iscb_details");

            return ApptoSetsTestEdit.bulidRichText(loadSingle, pkId, billkey);
        }
        return "";

    }

}


