package tpv.tpv_wm.tpv_sys.java.formplugin.form;

import com.itopview.wm.utils.YEM;
import kd.bd.master.helper.GroupStandardHelper;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.resource.ResManager;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.IFormView;
import kd.bos.form.IPageCache;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.BeforeClosedEvent;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.FormOperate;
import kd.bos.form.operate.MutexHelper;
import kd.bos.logging.Log;
import kd.bos.logging.LogFactory;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.util.StringUtils;

import java.util.EventObject;

/**
 * 模板快速修改
 *
 * @author WangShuGuang
 * @version 1.0
 */
public class ChangeFormPlugin extends AbstractBillPlugIn {

    private static final Log log = LogFactory.getLog(ChangeFormPlugin.class);

    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate operate = (FormOperate) args.getSource();
        String operateKey = operate.getOperateKey();
        GroupStandardHelper.pageCacheSetValue(this.getModel(), this.getPageCache(), operate);
        if ("change".equals(operateKey)) {
            doChange(args, this.getModel(), this.getView(), this.getPageCache());
        } else if (!operateKey.equals("save") && !"close".equals(operateKey)){
            String change = this.getPageCache().get("change");
            if (StringUtils.isNotEmpty(change) && Boolean.parseBoolean(change)) {
                this.getView().showErrorNotification("快速修改时本按钮不可点击");
                args.setCancel(true);
            }
        } else {
            String param = this.getPageCache().get("change");
            if (StringUtils.isNotEmpty(param) && Boolean.parseBoolean(param)) {
                operate.getOption().setVariableValue("change", "true");
            } else {
                operate.getOption().setVariableValue("change", "false");
            }
        }
    }

    public static void doChange(BeforeDoOperationEventArgs args, IDataModel model, IFormView view, IPageCache pageCache) {
        DynamicObject data = model.getDataEntity();
        boolean lock = MutexHelper.require(view, data.getDynamicObjectType().getName(), data.getPkValue(), "change", false, new StringBuilder());
        if (lock) {
            args.setCancel(true);
            //Long useOrgId = getUseOrg(view);
            Long currentOrgId = YEM.getCurrentOrgId();
            DynamicObject createorg = data.getDynamicObject("createorg");//组织
            String status = data.getString("status");//单据状态
            String enable = data.getString("enable");//使用状态
            if ("C".equals(status) && "1".equals(enable)) {
                if (createorg != null && !currentOrgId.equals(createorg.getLong("id"))) {
                    view.showErrorNotification(ResManager.loadKDString("当前组织不是基础数据的创建组织，快速修改失败。", "MasterDataHelper_1", "bd-master-business", new Object[0]));
                    args.setCancel(true);
                } else {
                    pageCache.put("change", "true");
                    pageCache.put("id", data.getDataEntityType().getName() + "-" + data.getString("id"));
                    data.set("status", "A");
                    //view.setVisible(Boolean.FALSE, new String[]{"bar_new", "bar_del", "bar_modify", "bar_submit", "bar_audit", "bar_submitandnew", "tpv_push", "tpv_draw", "tpv_track", "tpv_bizfile", "tpv_bizaction", "tpv_print", "bar_more", "tpv_refresh"});
                    view.updateView();
                    DynamicObject object = BusinessDataServiceHelper.loadSingle(data.getPkValue(), data.getDynamicObjectType().getName());
                    object.set("status", "A");
                    SaveServiceHelper.update(object);
                }
            } else {
                view.showErrorNotification(ResManager.loadKDString("必须是已审核且可用的数据才可以快速修改。", "MasterDataHelper_0", "bd-master-business", new Object[0]));
                args.setCancel(true);
            }
        }
    }

    public static void recoverVisible(IFormView view) {
        view.setVisible(Boolean.TRUE, new String[]{"bar_new"});
        view.setVisible(Boolean.TRUE, new String[]{"bar_del"});
        view.setVisible(Boolean.TRUE, new String[]{"bar_modify"});
        view.setVisible(Boolean.TRUE, new String[]{"bar_submit"});
        view.setVisible(Boolean.TRUE, new String[]{"bar_audit"});
        view.setVisible(Boolean.TRUE, new String[]{"bar_submitandnew"});
        view.setVisible(Boolean.TRUE, new String[]{"tpv_draw"});
        view.setVisible(Boolean.TRUE, new String[]{"tpv_track"});
        view.setVisible(Boolean.TRUE, new String[]{"tpv_bizfile"});
        view.setVisible(Boolean.TRUE, new String[]{"tpv_bizaction"});
        view.setVisible(Boolean.TRUE, new String[]{"tpv_print"});
        view.setVisible(Boolean.TRUE, new String[]{"bar_more"});
        view.setVisible(Boolean.TRUE, new String[]{"tpv_refresh"});
        view.updateView();
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();
        String param = this.getPageCache().get("change");
        if ("bar_close".equals(key) && StringUtils.isNotEmpty(param) && Boolean.parseBoolean(param)) {
            restoreData(this.getModel(), this.getPageCache());
        }
    }

    @Override
    public void beforeClosed(BeforeClosedEvent e) {
        super.beforeClosed(e);
        String param = this.getPageCache().get("change");
        if (StringUtils.isNotEmpty(param) && Boolean.parseBoolean(param)) {
            restoreData(this.getModel(), this.getPageCache());
        }

    }

    @Override
    public void pageRelease(EventObject e) {
        super.pageRelease(e);
        String param = this.getPageCache().get("change");
        if (StringUtils.isNotEmpty(param) && Boolean.parseBoolean(param)) {
            restoreData(this.getModel(), this.getPageCache());
        }
    }

    public static void restoreData(IDataModel model, IPageCache pageCache) {
        Long pk = 0L;
        String dynamicObjectType = "";
        String id = pageCache.get("id");
        String[] object;
        if (kd.bos.dataentity.utils.StringUtils.isNotEmpty(id)) {
            object = id.split("-");
            if (object != null && object.length >= 1) {
                dynamicObjectType = object[0];
                pk = Long.parseLong(object[1]);
            }
        }

        if (pk != 0L) {
            object = null;

            try {
                DynamicObject objectS = BusinessDataServiceHelper.loadSingle(pk, dynamicObjectType);
                objectS.set("billstatus", "C");
                SaveServiceHelper.update(objectS);
            } catch (Exception var7) {
                log.error(var7.getLocalizedMessage());
            }
        }

        pageCache.remove("change");
    }
}
