package tpv.tpv_wm.tpv_tm.java.api.entitys;

import com.fasterxml.jackson.annotation.JsonFormat;
import kd.bos.openapi.common.custom.annotation.ApiModel;
import kd.bos.openapi.common.custom.annotation.ApiParam;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description: 成交记录单 -入参数据
 * @Author LinRui
 * @Date 2024/3/11 17:51
 */
@ApiModel
public class DealrecordModel implements Serializable {
    @ApiParam(value = "主码", required = false, example = "''")
    private String fid;
    @ApiParam(value = "单据号", required = false, example = "''")
    private String fbillno;
    @ApiParam(value = "状态", required = false, example = "'A'")
    private String status;
    @ApiParam(value = "用户ID", required = false, example = "''")
    private String userid;
    @ApiParam(value = "合约代码", required = false, example = "''")
    private String instrumentid;
    @ApiParam(value = "买卖方向 ELL:卖出;BUY:买入", required = false, example = "'BUY'")
    private String direction;
    @ApiParam(value = "开平标志 OPEN:开仓;CLOSE:平仓;CLOSE_TODAY:平仓;CLOSE_YESTERDAY:平仓;", required = false, example = "'OPEN'")
    private String offset;
    @ApiParam(value = "投保标志 SPECULATION:投机;ARBITRAGE:套利;HEDGE:保值;MARKET_MAKER 做市;COVERED:备兑;10:买入交割;20:卖出交割;", required = false, example = "'MARKET_MAKER'")
    private String hedge_type;
    @ApiParam(value = "成交手数", required = false, example = "0")
    private Integer volume;
    @ApiParam(value = "成交吨数", required = false, example = "0")
    private Integer weight;
    @ApiParam(value = "成交单价", required = false, example = "0.00")
    private BigDecimal price;
    @JsonFormat(pattern = "yyyy-MM-dd hh:mm:ss")
    @ApiParam(value = "成交时点 格式yyyy-MM-dd hh:mm:ss", required = false, example = "")
    private Date tradedatetime;
    @ApiParam(value = "手续费", required = false, example = "0.00")
    private BigDecimal commission;
    @ApiParam(value = "品种名", required = false, example = "''")
    private String productid;
    @ApiParam(value = "合约类型", required = false, example = "''")
    private String insclass;
    @ApiParam(value = "合约乘数", required = false, example = "0")
    private Integer volumemultiple;
    @JsonFormat(pattern = "yyyy-MM-dd hh:mm:ss")
    @ApiParam(value = "交易时间 格式yyyy-MM-dd hh:mm:ss", required = false, example = "")
    private Date timestamp1;

    public String getFid() {
        return fid;
    }

    public void setFid(String fid) {
        this.fid = fid;
    }

    public String getFbillno() {
        return fbillno;
    }

    public void setFbillno(String fbillno) {
        this.fbillno = fbillno;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getUserid() {
        return userid;
    }

    public void setUserid(String userid) {
        this.userid = userid;
    }

    public String getInstrumentid() {
        return instrumentid;
    }

    public void setInstrumentid(String instrumentid) {
        this.instrumentid = instrumentid;
    }

    public String getDirection() {
        return direction;
    }

    public void setDirection(String direction) {
        this.direction = direction;
    }

    public String getOffset() {
        return offset;
    }

    public void setOffset(String offset) {
        this.offset = offset;
    }

    public String getHedge_type() {
        return hedge_type;
    }

    public void setHedge_type(String hedge_type) {
        this.hedge_type = hedge_type;
    }

    public Integer getVolume() {
        return volume;
    }

    public void setVolume(Integer volume) {
        this.volume = volume;
    }

    public Integer getWeight() {
        return weight;
    }

    public void setWeight(Integer weight) {
        this.weight = weight;
    }

    public BigDecimal getPrice() {
        return price;
    }

    public void setPrice(BigDecimal price) {
        this.price = price;
    }

    public Date getTradedatetime() {
        return tradedatetime;
    }

    public void setTradedatetime(Date tradedatetime) {
        this.tradedatetime = tradedatetime;
    }

    public BigDecimal getCommission() {
        return commission;
    }

    public void setCommission(BigDecimal commission) {
        this.commission = commission;
    }

    public String getProductid() {
        return productid;
    }

    public void setProductid(String productid) {
        this.productid = productid;
    }

    public String getInsclass() {
        return insclass;
    }

    public void setInsclass(String insclass) {
        this.insclass = insclass;
    }

    public Integer getVolumemultiple() {
        return volumemultiple;
    }

    public void setVolumemultiple(Integer volumemultiple) {
        this.volumemultiple = volumemultiple;
    }

    public Date getTimestamp1() {
        return timestamp1;
    }

    public void setTimestamp1(Date timestamp1) {
        this.timestamp1 = timestamp1;
    }
}
