package tpv.tpv_wm.tpv_tm.java.formplugin.dynamic;

import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.coderule.api.CodeRuleInfo;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.coderule.CodeRuleServiceHelper;
import kd.bos.servicehelper.operation.DeleteServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * @ClassName: CalRemarksEdit
 * @Description: 点击后，如果《认领明细》为“审核状态”则弹窗，如右图：【确定】后生成《取消认领审批单》且
 * 更改原《认领明细》【红冲标志】修改为“被红冲”并且将弹窗备注内容赋值至《取消认领审批单》【备注】中，如果《认领明细》为“暂存”状态，则直接删除；
 * @author: zbh
 * @date: 2024-04-07
 */
public class CalRemarksEdit extends AbstractBillPlugIn {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok"});
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
                this.btnOk();
                break;
        }
    }

    private void btnOk() {
        IFormView view = this.getView();
        IDataModel model = view.getModel();
        IFormView parentView = view.getParentView();
        IDataModel parentmodel = parentView.getModel();
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = showParameter.getCustomParams();
        List<Long> idList = (List<Long>) maps.get("idList");


        String selectfields = DynamicObjectUtil.getSelectfields("tpv_tm_claimdetails", false);
        DynamicObject tpvTmUnclaimdetails = BusinessDataServiceHelper.newDynamicObject("tpv_tm_unclaimdetails");
        CodeRuleInfo codeRule = CodeRuleServiceHelper.getCodeRule("tpv_tm_unclaimdetails", tpvTmUnclaimdetails, null);
        String billno = CodeRuleServiceHelper.getNumber(codeRule, tpvTmUnclaimdetails);
        tpvTmUnclaimdetails.set("billno", billno);
        tpvTmUnclaimdetails.set("billstatus", "A");
        tpvTmUnclaimdetails.set("tpv_operator", YEM.getCurrentUserId());
        tpvTmUnclaimdetails.set("tpv_company", YEM.getCurrentOrgId());
        tpvTmUnclaimdetails.set("tpv_department", UserServiceHelper.getUserMainOrgId(YEM.getCurrentUserId()));
        tpvTmUnclaimdetails.set("tpv_bizdate", new Date());
        tpvTmUnclaimdetails.set("tpv_canremark", model.getValue("tpv_canremark"));
        tpvTmUnclaimdetails.set("org", YEM.getCurrentOrgId());
        tpvTmUnclaimdetails.set("tpv_version", 1);
        tpvTmUnclaimdetails.set("tpv_sourcebillkey", "tpv_tm_claimdetails");
//        tpvTmUnclaimdetails.set("tpv_sourcebillno", tmClaimdetail.get("billno"));
//        tpvTmUnclaimdetails.set("tpv_sourcebillid", tmClaimdetail.getPkValue());
        DynamicObject[] tmClaimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", selectfields, new QFilter[]{new QFilter("id", "in", idList)});
        for (DynamicObject tmClaimdetail : tmClaimdetails) {
            String billstatus = tmClaimdetail.getString("billstatus");
            if ("C".equals(billstatus)) {
                tmClaimdetail.set("tpv_redflush", "A");
                DynamicObjectCollection tpvTmUnclaimdeMx = tpvTmUnclaimdetails.getDynamicObjectCollection("tpv_tm_unclaimde_mx");
                DynamicObject addNew = tpvTmUnclaimdeMx.addNew();
                long genLongId = ORM.create().genLongId(addNew.getDataEntityType());
                addNew.set("id", genLongId);
                addNew.set("Seq", 1);
                addNew.set("tpv_canremarkun", model.getValue("tpv_canremark"));
                addNew.set("tpv_claimlogo", tmClaimdetail.get("tpv_claimlogo"));//认领标志
                addNew.set("tpv_redflush", tmClaimdetail.get("tpv_redflush"));//红冲标志
                addNew.set("tpv_orderprice", tmClaimdetail.get("tpv_orderprice"));//是否点价
                addNew.set("tpv_ponumbers", tmClaimdetail.get("tpv_ponumbers"));//点价单号
                addNew.set("tpv_categories", tmClaimdetail.get("tpv_categories"));//业务大类
                addNew.set("tpv_coverup", tmClaimdetail.get("tpv_coverup"));//是否代客套保
                addNew.set("tpv_contracttype", tmClaimdetail.get("tpv_contracttype"));//合同类型
                addNew.set("tpv_sacontractnum", tmClaimdetail.get("tpv_sacontractnum"));//销售合同号
                addNew.set("tpv_contractcus", tmClaimdetail.get("tpv_contractcus"));//合同客户
                addNew.set("tpv_prcontractnum", tmClaimdetail.get("tpv_prcontractnum"));//采购合同号
                addNew.set("tpv_contractsup", tmClaimdetail.get("tpv_contractsup"));//合同供应商
                addNew.set("tpv_combination", tmClaimdetail.get("tpv_combination"));//组合号
                addNew.set("tpv_hedgetype", tmClaimdetail.get("tpv_hedgetype"));//套保类型
                addNew.set("tpv_strategyname", tmClaimdetail.get("tpv_strategyname"));//策略名称
                addNew.set("tpv_warehouse", tmClaimdetail.get("tpv_warehouse"));//是否移仓认领
                addNew.set("tpv_basegoods", tmClaimdetail.get("tpv_basegoods"));//基价商品
                addNew.set("tpv_contractbaseprice", tmClaimdetail.get("tpv_contractbaseprice"));//合同基价
                addNew.set("tpv_strategiccli", tmClaimdetail.get("tpv_strategiccli"));//策略客户
                addNew.set("tpv_operators", tmClaimdetail.get("tpv_operators"));//业务员
                addNew.set("tpv_region", tmClaimdetail.get("tpv_region"));//大区
                addNew.set("tpv_recordnum", tmClaimdetail.get("tpv_recordnum"));//记录号
                addNew.set("tpv_contractool", tmClaimdetail.get("tpv_contractool"));//记录合约
                addNew.set("tpv_dealprice", tmClaimdetail.get("tpv_dealprice"));//成交价格
                addNew.set("tpv_dealton", tmClaimdetail.get("tpv_dealton"));//交易吨数
                addNew.set("tpv_tradeway", tmClaimdetail.get("tpv_tradeway"));//交易方向
                addNew.set("tpv_openclosesign", tmClaimdetail.get("tpv_openclosesign"));//开平
                addNew.set("tpv_dealdate", tmClaimdetail.get("tpv_dealdate"));//成交时间
                addNew.set("tpv_dealdateday", tmClaimdetail.get("tpv_dealdateday"));//交易日
                addNew.set("tpv_account", tmClaimdetail.get("tpv_account"));//账户

                DynamicObjectCollection tpvAmcunit = tmClaimdetail.getDynamicObjectCollection("tpv_amcunit");
                DynamicObjectCollection material = addNew.getDynamicObjectCollection("tpv_amcunit");
                DynamicObjectCollection tpv_material = new DynamicObjectCollection();
                for (DynamicObject entry : tpvAmcunit) {
                    DynamicObject newMaterial = new DynamicObject(material.getDynamicObjectType());
                    newMaterial.set("fbasedataId", entry.get("fbasedataId"));
                    tpv_material.add(newMaterial);
                }
                if (tpv_material.size() != 0) {
                    addNew.set("tpv_amcunit", tpv_material);//账户管理单元

                }

                DynamicObjectCollection tpvClaimablesnapin = tmClaimdetail.getDynamicObjectCollection("tpv_claimablesnapin");
                DynamicObjectCollection claimablesnapin = addNew.getDynamicObjectCollection("tpv_claimablesnapinqx");
                DynamicObjectCollection tpv_claimablesnapin = new DynamicObjectCollection();
                for (DynamicObject entry : tpvClaimablesnapin) {
                    DynamicObject newMaterial = new DynamicObject(claimablesnapin.getDynamicObjectType());
                    newMaterial.set("fbasedataId", entry.get("fbasedataId"));
                    tpv_claimablesnapin.add(newMaterial);
                }
                addNew.set("tpv_claimablesnapinqx", tpv_claimablesnapin);//认领管理单元
                addNew.set("tpv_processingfee", tmClaimdetail.get("tpv_processingfee"));//手续费
                addNew.set("tpv_srcbillway", tmClaimdetail.get("tpv_srcbillway"));//数据来源
                addNew.set("tpv_departments", tmClaimdetail.get("tpv_departments"));//认领部门
                addNew.set("tpv_people", tmClaimdetail.get("tpv_people"));//人员
                addNew.set("tpv_superiornums", tmClaimdetail.get("tpv_superiornums"));//上级单据号
                addNew.set("tpv_datetime", tmClaimdetail.get("tpv_datetime"));//认领时间
                addNew.set("tpv_datasourcess", tmClaimdetail.get("tpv_datasourcess"));//数据来源
                addNew.set("tpv_datasourcesnum", tmClaimdetail.get("tpv_datasourcesnum"));//来源单据号
                addNew.set("tpv_datasourcesid", tmClaimdetail.get("tpv_datasourcesid"));//来源单据id
                SaveServiceHelper.save(new DynamicObject[]{tpvTmUnclaimdetails});
                SaveServiceHelper.save(new DynamicObject[]{tmClaimdetail});
                DynamicObject tpvTmUnclaimdetails1 = BusinessDataServiceHelper.loadSingle(tpvTmUnclaimdetails.getPkValue(), "tpv_tm_unclaimdetails");
                OperationServiceHelper.executeOperate("submit",
                        "tpv_tm_unclaimdetails", new Object[]{tpvTmUnclaimdetails1.getPkValue()}, YEM.getOption());
            } else {
                DynamicObject[] tpvTmClaimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", "", new QFilter[]{new QFilter("id", "=", tmClaimdetail.getPkValue())});
                Object[] objects = new Object[tpvTmClaimdetails.length];
                for (int i = 0; i < tpvTmClaimdetails.length; i++) {
                    objects[i] = tpvTmClaimdetails[i].getPkValue();
                }
                OperationServiceHelper.executeOperate("delete",
                        "tpv_tm_claimdetails", objects, YEM.getOption());
            }
        }
        String key = (String) maps.get("key");
        String tpvSourceid="";
        if ("tpv_tm_iniactivehed".equals(key)){
            tpvSourceid="tpv_sourceid";
        }else {
            tpvSourceid="tpv_sourceiddk";
        }
        if ("tpv_calin".equals(key)){
            tpvSourceid="tpv_sourceid";
        }
        DynamicObject dataEntity = parentmodel.getDataEntity(true);
        String name = dataEntity.getDataEntityType().getName();
        if (!"tpv_tm_policyclaim".equals(name)){
            DynamicObjectCollection collection = dataEntity.getDynamicObjectCollection(key);
            List<DynamicObject> deleteRows = new ArrayList();
            for (DynamicObject dynamicObject : collection) {
                long aLong = dynamicObject.getLong(tpvSourceid);
                if (idList.contains(aLong)){
                    deleteRows.add(dynamicObject);
                }
            }
            for (DynamicObject deleteRow : deleteRows) {
                collection.remove(deleteRow);
            }
            parentView.invokeOperation("save");
        }
        parentView.invokeOperation("refresh");
        parentView.invokeOperation("donothing");
        this.getView().sendFormAction(parentView);
    }
}
