package tpv.tpv_wm.tpv_tm.java.formplugin.dynamic;

import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.DynamicObjectUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.coderule.api.CodeRuleInfo;
import kd.bos.data.BusinessDataReader;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.IRefrencedataProvider;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.*;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.coderule.CodeRuleServiceHelper;
import kd.bos.servicehelper.operation.DeleteServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import org.apache.commons.lang3.StringUtils;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @ClassName: ClaipopupEdit
 * @Description: 认领弹窗表单插件
 * @author: zbh
 * @date: 2024-04-02
 */
public class ClaipopupEdit extends AbstractBillPlugIn implements BeforeF7SelectListener {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        addClickListeners("tpv_advcontoolbarap", "tpv_newrecord", "tpv_delrecord", "tpv_expcla");
        addItemClickListeners("tpv_advcontoolbarap", "tpv_newrecord", "tpv_delrecord", "tpv_expcla");
        this.addClickListeners(new String[]{"btnok"});
//        BasedataEdit tpv_pointpricecontract = this.getView().getControl("tpv_breedname");//品种名
//        tpv_pointpricecontract.addBeforeF7SelectListener(this);
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey();
        switch (itemKey) {
            case "tpv_newrecord":
                newrecord();
                break;
            case "tpv_delrecord":
                delrecord();
                break;
            case "tpv_expcla":
                expcla();
                break;
        }
    }

    private void expcla() {
        EntryGrid entryGrid = this.getControl("tpv_detail");
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length == 0) {
            this.getView().showTipNotification("请选择一条数据！");
            return;
        }
        IFormView view = this.getView();
        ListShowParameter parameter = ShowFormHelper.createShowListForm("tpv_tm_snapdebaseedit", true);
        parameter.getListFilterParameter().getQFilters().add(new QFilter("billstatus", QCP.equals, "C"));
//        parameter.getListFilterParameter().getQFilters();
        parameter.setCloseCallBack(new CloseCallBack(this, "tpv_expcla"));
        view.showForm(parameter);
    }

    public void delrecord() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvDetail = dataEntity.getDynamicObjectCollection("tpv_detail");
        EntryGrid entryGrid = this.getControl("tpv_detail");
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length == 0) {
            this.getView().showTipNotification("请选择一条数据！");
            return;
        }

        List list = new ArrayList();
        for (int selectRow : selectRows) {
            BigDecimal decimal = BigDecimal.ZERO;
            long tpvSrcid = tpvDetail.get(selectRow).getLong("tpv_srcid");
            BigDecimal tpvQuanclaimed = tpvDetail.get(selectRow).getBigDecimal("tpv_quanclaimed");
            if (tpvQuanclaimed.compareTo(BigDecimal.ZERO) > 0) {
                list.add(selectRow + 1);
            } else {
                for (DynamicObject dynamicObject : tpvDetail) {
                    long tpvSrcid1 = dynamicObject.getLong("tpv_srcid");
                    if (tpvSrcid == tpvSrcid1) {
                        decimal = decimal.add(dynamicObject.getBigDecimal("tpv_quanclaimed"));
                    }
                }
                if (decimal.compareTo(BigDecimal.ZERO) > 0) {
                    list.add(selectRow + 1);
                }
            }
        }
        if (list.size() > 0) {
            this.getView().showTipNotification("选中行包含已认领或其对应的成交记录单已被认领！");
            return;
        }

        for (int selectRow : selectRows) {
            int delete = DeleteServiceHelper.delete("tpv_tm_dealrecord", new QFilter[]{
                    new QFilter("tpv_srcid", "=", tpvDetail.get(selectRow).getLong("tpv_srcid"))
                    , new QFilter("tpv_claimcqqty", "=", 0)
                    , new QFilter("tpv_claimnbqty", "=", 0)
                    , new QFilter("tpv_srcbillway", "=", tpvDetail.get(selectRow).getString("tpv_datasources"))
            });
            int i = selectRow + 1;
            if (delete == 0) {
                this.getView().showTipNotification("第" + i + "行不满足删除条件");
            } else {
                this.getView().showSuccessNotification("第" + i + "行删除成功！");
            }
        }
        String tpvSedmatching = (String) this.getModel().getValue("tpv_sedmatching");//是否二次匹配
        if ("1".equals(tpvSedmatching)) {
            sedMatching();
        } else {
            detail();
        }

    }

    public void newrecord() {
        IFormView view = this.getView();
        FormShowParameter parameter = new FormShowParameter();
        parameter.setStatus(OperationStatus.ADDNEW);
        parameter.getOpenStyle().setShowType(ShowType.Modal);
        Map<String, Object> map = new HashMap<>();
        parameter.setCustomParams(map);
        parameter.setFormId("tpv_tm_newrecord");
        parameter.setCloseCallBack(new CloseCallBack(this, "tpv_claim"));
        view.showForm(parameter);
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_tradingrange":
            case "tpv_contract":
            case "tpv_dateform":
            case "tpv_dateto":
            case "tpv_direction":
            case "tpv_breedname":
            case "tpv_hidematch":
            case "tpv_adminiunit":
                String tpvSedmatching = (String) this.getModel().getValue("tpv_sedmatching");//是否二次匹配
                if ("1".equals(tpvSedmatching)) {
                    sedMatching();
                } else {
                    detail();
                }
                ;
                break;
        }

    }

    /*
    管理单元 多选基础资料（不可编辑，默认=《策略号》中“管理单元定义”）
     */
    private void tradingrange() {
        String name = this.getView().getParentView().getModel().getDataEntityType().getName();
        Map<String, String> fieldName = entryFieldName(name);
        DynamicObject bdStrategy = null;
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = showParameter.getCustomParams();
        Object tpvSedmatching = maps.get("tpv_sedmatching");
        if (tpvSedmatching != null) {
            this.getModel().setValue("tpv_sedmatching", "1");
        }
        if ("tpv_tm_policyclaim".equals(name)) {
            Long key = (Long) maps.get("tpv_strategyid");
            if (key != null) {
                boolean tpvBdStrategy = QueryServiceHelper.exists("tpv_bd_strategy", new QFilter[]{new QFilter("id", "=", key)});
                if (tpvBdStrategy) {
                    bdStrategy = BusinessDataServiceHelper.loadSingle(key, "tpv_bd_strategy");
                }
            }
            this.getModel().setValue("tpv_come", name);
        } else {
            DynamicObject tpvStrategynum = (DynamicObject) this.getView().getParentView().getModel().getValue(fieldName.get("tpv_strategynum"));
            if (tpvStrategynum != null) {
                bdStrategy = BusinessDataServiceHelper.loadSingle(tpvStrategynum.getPkValue(), "tpv_bd_strategy");
            }
        }

        if (bdStrategy != null) {

            DynamicObject dataEntity = this.getModel().getDataEntity(true);

            DynamicObjectCollection tpvBdStrategyXt = bdStrategy.getDynamicObjectCollection("tpv_bd_strategy_hy");//合约
            DynamicObjectCollection tpvBdSrategy = bdStrategy.getDynamicObjectCollection("tpv_bd_strategy_xt");//管理单元
            DynamicObjectCollection usersForDisplay = new DynamicObjectCollection();

            DynamicObjectCollection tpvDreedname = dataEntity.getDynamicObjectCollection("tpv_breedname");
            DynamicObjectCollection tpv_breedname = new DynamicObjectCollection();
            for (DynamicObject dynamicObject : tpvBdStrategyXt) {
                DynamicObjectCollection tpvContractcounts = dynamicObject.getDynamicObjectCollection("tpv_contractcounts");
                for (DynamicObject tpvContractcount : tpvContractcounts) {
                    DynamicObject newMaterial = new DynamicObject(tpvDreedname.getDynamicObjectType());
                    newMaterial.set("fbasedataId", tpvContractcount.get("fbasedataId"));
                    tpv_breedname.add(newMaterial);
                }
            }

            DynamicObjectCollection material = dataEntity.getDynamicObjectCollection("tpv_adminiunit");
            DynamicObjectCollection tpv_material = new DynamicObjectCollection();
            for (DynamicObject entry : tpvBdSrategy) {
                DynamicObject newMaterial = new DynamicObject(material.getDynamicObjectType());
                if (entry.getDynamicObject("tpv_termdefinition") != null) {
                    newMaterial.set("fbasedataId", entry.getDynamicObject("tpv_termdefinition"));
                    tpv_material.add(newMaterial);
                }
            }

            if (tpv_breedname.size() != 0) {
                this.getModel().setValue("tpv_breedname", tpv_breedname);
            }
            if (tpv_material.size() != 0) {
                this.getModel().setValue("tpv_adminiunit", tpv_material);
            }
        }
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        tradingrange();
        String tpvSedmatching = (String) this.getModel().getValue("tpv_sedmatching");//是否二次匹配
        if ("1".equals(tpvSedmatching)) {
            sedMatching();
        } else {
            detail();
        }
    }

    private void sedMatching() {
        this.getModel().deleteEntryData("tpv_detail");
        String billno = (String) this.getView().getParentView().getModel().getValue("billno");
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvAdminiunits = dataEntity.getDynamicObjectCollection("tpv_adminiunit");//管理单元
        BigDecimal tpvTradingrange = dataEntity.getBigDecimal("tpv_tradingrange");//成交价格范围
        DynamicObject tpvContract = dataEntity.getDynamicObject("tpv_contract");//合约
        Date tpvDateform = dataEntity.getDate("tpv_dateform");//交易日期从
        Date tpvDateto = dataEntity.getDate("tpv_dateto");//交易日期至
        String tpvDirection = dataEntity.getString("tpv_direction");//方向

        QFilter qFilter = new QFilter("billstatus", "=", "C");//单据状态
        qFilter.and(new QFilter("tpv_datasourcesnum", "=", billno));
        if (YEM.isNotEmpty(tpvDirection)) {
            qFilter.and(new QFilter("tpv_tradeway", "=", tpvDirection));//方向
        }
        if (tpvDateform != null) {
            Date startDate = DateUtil.getStartOrEndDate(tpvDateform, false);
            qFilter.and(new QFilter("tpv_dealdateday", QCP.large_equals, startDate));//交易日期从
        }
        if (tpvDateto != null) {
            Date endDate = DateUtil.getStartOrEndDate(tpvDateto, true);
            qFilter.and(new QFilter("tpv_dealdateday", QCP.less_equals, endDate));//交易日期至
        }
        if (tpvContract != null) {
            qFilter.and(new QFilter("tpv_contractool.id", "in", tpvContract.getPkValue()));//合约池
        }
        List<Long> list = new ArrayList<>();
        for (DynamicObject tpvAdminiunit : tpvAdminiunits) {
            list.add(tpvAdminiunit.getDynamicObject("fbasedataid").getLong("id"));
        }
        String selectfields = DynamicObjectUtil.getSelectfields("tpv_tm_claimdetails", false);
        List<DynamicObject> dyList = new ArrayList<>();

        DynamicObject[] tpvTmDealrecordes = BusinessDataServiceHelper.load("tpv_tm_claimdetails", selectfields, qFilter.toArray());

        for (DynamicObject tpvTmDealrecorde : tpvTmDealrecordes) {
            DynamicObjectCollection tpvClaimablesnapin = tpvTmDealrecorde.getDynamicObjectCollection("tpv_claimablesnapin");
            if (tpvClaimablesnapin != null) {
                List<Long> claimIds = tpvClaimablesnapin.stream().map(tpvTmSnapdebaseedit -> tpvTmSnapdebaseedit.getDynamicObject("fbasedataid").getLong("id")).collect(Collectors.toList());
                boolean hasSameElement = claimIds.stream().anyMatch(list::contains) || list.stream().anyMatch(claimIds::contains);
                if (tpvClaimablesnapin.size() == 0 || hasSameElement) {
                    dyList.add(tpvTmDealrecorde);
                }
            }
        }

        DynamicObject[] tmClaimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", selectfields, null);
        for (DynamicObject tmClaimdetail : dyList) {
            int row = this.getModel().createNewEntryRow("tpv_detail");
            this.getModel().setValue("tpv_remcons", tmClaimdetail.getDynamicObject("tpv_contractool"), row);//记录合约
            this.getModel().setValue("tpv_tranprices", tmClaimdetail.getBigDecimal("tpv_dealprice"), row);//成交价格
            this.getModel().setValue("tpv_numtran", tmClaimdetail.getBigDecimal("tpv_dealton"), row);//交易吨数
//            this.getModel().setValue("tpv_quanclaimed", claimcqqty, row);//已认领数量
            this.getModel().setValue("tpv_tradingdirec", tmClaimdetail.getString("tpv_tradeway"), row);//买卖方向
            this.getModel().setValue("tpv_tradingday", tmClaimdetail.getDate("tpv_dealdateday"), row);//交易日
            this.getModel().setValue("tpv_amcunit", tmClaimdetail.get("tpv_amcunit"), row);//账户归属 ？
            this.getModel().setValue("tpv_claim", tmClaimdetail.get("tpv_claimablesnapin"), row);//可认领 ？
//            this.getModel().setValue("tpv_datasources", tmClaimdetail.getString("tpv_srcbillway"), row);//数据来源
            this.getModel().setValue("tpv_varietyname", tmClaimdetail.getDynamicObject("tpv_contractool") != null ? tmClaimdetail.getDynamicObject("tpv_contractool").getString("name") : null, row);//品种名
            this.getModel().setValue("tpv_createtime", tmClaimdetail.getDate("createtime"), row);//创建时间
            this.getModel().setValue("tpv_servicecharge", tmClaimdetail.getBigDecimal("tpv_processingfee"), row);//手续费
            this.getModel().setValue("tpv_sourceid", tmClaimdetail.get("id"), row);//来源单据id
            this.getModel().setValue("tpv_billno", tmClaimdetail.get("billno"), row);//来源单据编号
            this.getModel().setValue("tpv_srcid", tmClaimdetail.get("tpv_datasourcesid"), row);//源单id
        }

        DynamicObjectCollection entry = this.getModel().getEntryEntity("tpv_detail");
        for (int i = 0; i < entry.size() - 1; i++) {
            for (int j = 0; j < entry.size() - 1 - i; j++) {
                BigDecimal date = entry.get(j).getBigDecimal("tpv_tranprices").subtract(tpvTradingrange).abs();
                BigDecimal date1 = entry.get(j + 1).getBigDecimal("tpv_tranprices").subtract(tpvTradingrange).abs();
                if (date1.compareTo(date) < 0) {
                    this.getModel().moveEntryRowDown("tpv_detail", j);
                }
            }
        }
        this.getView().updateView("tpv_detail");

    }

    public void detail() {
        this.getModel().deleteEntryData("tpv_detail");
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvAdminiunits = dataEntity.getDynamicObjectCollection("tpv_adminiunit");//管理单元
        BigDecimal tpvTradingrange = dataEntity.getBigDecimal("tpv_tradingrange");//成交价格范围
        DynamicObject tpvContract = dataEntity.getDynamicObject("tpv_contract");//合约
        Date tpvDateform = dataEntity.getDate("tpv_dateform");//交易日期从
        Date tpvDateto = dataEntity.getDate("tpv_dateto");//交易日期至
        String tpvDirection = dataEntity.getString("tpv_direction");//方向
        DynamicObjectCollection tpvBreedname = dataEntity.getDynamicObjectCollection("tpv_breedname");//品种名
        List<String> arrayList = tpvBreedname.stream().map(addNew -> ((DynamicObject) addNew.get("fbasedataid")).getString("name")).collect(Collectors.toList());
        String selectfields = DynamicObjectUtil.getSelectfields("tpv_tm_dealrecord", false);
        QFilter qFilter = new QFilter("billstatus", "=", "C");//单据状态
        QFilter qFilterNs = new QFilter("billstatus", "=", "C");//单据状态
        if (YEM.isNotEmpty(tpvDirection)) {
            qFilter.and(new QFilter("tpv_tradeway", "=", tpvDirection));//方向
            qFilterNs.and(new QFilter("tpv_tradeway", "=", tpvDirection));//方向
        }
        if (tpvDateform != null) {
            Date startDate = DateUtil.getStartOrEndDate(tpvDateform, false);
            qFilter.and(new QFilter("tpv_dealdate", QCP.large_equals, startDate));//交易日期从
            qFilterNs.and(new QFilter("tpv_dealdate", QCP.large_equals, startDate));//交易日期从
        }
        if (tpvDateto != null) {
            Date endDate = DateUtil.getStartOrEndDate(tpvDateto, true);
            qFilter.and(new QFilter("tpv_dealdate", QCP.less_equals, endDate));//交易日期至
            qFilterNs.and(new QFilter("tpv_dealdate", QCP.less_equals, endDate));//交易日期至
        }
        if (arrayList.size() != 0) {
            qFilter.and(new QFilter("tpv_varietyname", "in", arrayList));//品种名
            qFilterNs.and(new QFilter("tpv_varietyname", "in", arrayList));//品种名
        }
        if (tpvContract != null) {
            qFilter.and(new QFilter("tpv_contractool.id", "in", tpvContract.getPkValue()));//合约池
            qFilterNs.and(new QFilter("tpv_contractool.id", "in", tpvContract.getPkValue()));//合约池
        }
//        DynamicObject[] tpvTmSnapdebaseedits = BusinessDataServiceHelper.load("tpv_tm_snapdebaseedit", "", null);
//        List<Long> longs = Arrays.stream(tpvTmSnapdebaseedits).map(tpvTmSnapdebaseedit -> tpvTmSnapdebaseedit.getLong("id")).collect(Collectors.toList());
//        qFilterNs.and(new QFilter("tpv_claimablesnapin.fbasedataid.id", "not in", longs));
//        DynamicObject[] tpvTmDealrecordsNs = BusinessDataServiceHelper.load("tpv_tm_dealrecord", selectfields, qFilterNs.toArray());//【管理单元】为空
//        DynamicObject[] tpvTmDealrecords = null;
        List<Long> list = new ArrayList<>();
        for (DynamicObject tpvAdminiunit : tpvAdminiunits) {
            list.add(tpvAdminiunit.getDynamicObject("fbasedataid").getLong("id"));
        }
//        if (tpvAdminiunits.size() > 0) {
//
//            qFilter.and(new QFilter("tpv_claimablesnapin.fbasedataid.id", "in", list));
//            tpvTmDealrecords = BusinessDataServiceHelper.load("tpv_tm_dealrecord", selectfields, qFilter.toArray());//过滤【管理单元】和【管理单元】为空的《成交记录单》数据；
//        }

        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = new HashMap<>();
        maps = showParameter.getCustomParams();

        IFormView view = this.getView();
        IFormView parentView = view.getParentView();
        IDataModel parentmodel = parentView.getModel();
        DynamicObject parentDataEntity = parentmodel.getDataEntity(true);
        String name = parentDataEntity.getDynamicObjectType().getName();
        if (maps != null && "tpv_tm_policyclaim".equals(name)) {
            String tpvStrateg = (String) maps.get("tpv_strateg");//来源单据
            Boolean tpv_filter = (Boolean) maps.get("tpv_filter");//是否添加过滤
            Long tpv_strategyid = (Long) maps.get("tpv_strategyid");//来源单据id
            if (tpv_filter) {
                if ("tpv_bd_strategy".equals(tpvStrateg)) {
                    QFilter filter = new QFilter("tpv_strategyname", "=", tpv_strategyid);
                    DynamicObject[] tmClaimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", "tpv_tradeway", filter.toArray(), "tpv_dealdate asc");
                    if (tmClaimdetails.length != 0) {
                        String tpvTradeway = tmClaimdetails[0].getString("tpv_tradeway");
                        qFilter.and(new QFilter("tpv_tradeway", QCP.not_equals, tpvTradeway));
                    }
                } else if ("tpv_cushedgemagereq".equals(tpvStrateg)) {
                    QFilter filter = new QFilter("tpv_cushedgemagereq", "=", tpv_strategyid);
                    DynamicObject[] tmClaimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", "tpv_tradeway", filter.toArray(), "tpv_dealdate asc");
                    if (tmClaimdetails.length != 0) {
                        String tpvTradeway = tmClaimdetails[0].getString("tpv_tradeway");
                        qFilter.and(new QFilter("tpv_tradeway", QCP.equals, tpvTradeway));
                    }
                }
            }
        }

        List<DynamicObject> dyList = new ArrayList<>();
        DynamicObject[] tpvTmDealrecordes = BusinessDataServiceHelper.load("tpv_tm_dealrecord", selectfields, qFilter.toArray());
        for (DynamicObject tpvTmDealrecorde : tpvTmDealrecordes) {
            String tpvSrcbillway = tpvTmDealrecorde.getString("tpv_srcbillway");
            DynamicObjectCollection tpvClaimablesnapin = tpvTmDealrecorde.getDynamicObjectCollection("tpv_claimablesnapin");
            if (tpvClaimablesnapin != null) {
                List<Long> claimIds = tpvClaimablesnapin.stream().map(tpvTmSnapdebaseedit -> tpvTmSnapdebaseedit.getDynamicObject("fbasedataid").getLong("id")).collect(Collectors.toList());
                boolean hasSameElement = claimIds.stream().anyMatch(list::contains) || list.stream().anyMatch(claimIds::contains);
                if ("B".equals(tpvSrcbillway) || tpvClaimablesnapin.size() == 0 || hasSameElement) {
                    dyList.add(tpvTmDealrecorde);
                }
            }
        }

//        if (tpvTmDealrecords != null) {
//            for (DynamicObject tpvTmDealrecord : tpvTmDealrecords) {
//                dyList.add(tpvTmDealrecord);
//            }
//        }
//        for (DynamicObject tpvTmDealrecordsN : tpvTmDealrecordsNs) {
//            dyList.add(tpvTmDealrecordsN);
//        }
        Boolean tpvHidematch = (Boolean) this.getModel().getValue("tpv_hidematch");
        for (DynamicObject tpvTmDealrecord : dyList) {
            BigDecimal claimcqqty = tpvTmDealrecord.getBigDecimal("tpv_claimcqqty").add(tpvTmDealrecord.getBigDecimal("tpv_claimnbqty"));//已认领数量
            BigDecimal tpvDealton = tpvTmDealrecord.getBigDecimal("tpv_dealton");//交易数量
            if (claimcqqty.compareTo(tpvDealton) == 0 && tpvHidematch) {
                continue;
            }
            int row = this.getModel().createNewEntryRow("tpv_detail");
            this.getModel().setValue("tpv_remcons", tpvTmDealrecord.getDynamicObject("tpv_contractool"), row);//记录合约
            this.getModel().setValue("tpv_tranprices", tpvTmDealrecord.getBigDecimal("tpv_dealprice"), row);//成交价格
            this.getModel().setValue("tpv_numtran", tpvDealton, row);//交易数量
            this.getModel().setValue("tpv_quanclaimed", claimcqqty, row);//已认领数量
            this.getModel().setValue("tpv_tradingdirec", tpvTmDealrecord.getString("tpv_tradeway"), row);//买卖方向
            this.getModel().setValue("tpv_tradingday", tpvTmDealrecord.getDate("tpv_dealdate"), row);//交易日
            this.getModel().setValue("tpv_amcunit", tpvTmDealrecord.get("tpv_amcunit"), row);//账户归属 ？
            this.getModel().setValue("tpv_claim", tpvTmDealrecord.get("tpv_claimablesnapin"), row);//可认领 ？
            this.getModel().setValue("tpv_datasources", tpvTmDealrecord.getString("tpv_srcbillway"), row);//数据来源
            this.getModel().setValue("tpv_varietyname", tpvTmDealrecord.getString("tpv_varietyname"), row);//品种名
            this.getModel().setValue("tpv_createtime", tpvTmDealrecord.getDate("createtime"), row);//创建时间
            this.getModel().setValue("tpv_servicecharge", tpvTmDealrecord.getBigDecimal("tpv_processingfee"), row);//手续费
            this.getModel().setValue("tpv_sourceid", tpvTmDealrecord.get("id"), row);//来源单据id
            this.getModel().setValue("tpv_billno", tpvTmDealrecord.get("billno"), row);//来源单据编号
            this.getModel().setValue("tpv_srcid", tpvTmDealrecord.get("tpv_srcid"), row);//源单id
        }

        DynamicObjectCollection entry = this.getModel().getEntryEntity("tpv_detail");
        for (int i = 0; i < entry.size() - 1; i++) {
            for (int j = 0; j < entry.size() - 1 - i; j++) {
                BigDecimal date = entry.get(j).getBigDecimal("tpv_tranprices").subtract(tpvTradingrange).abs();
                BigDecimal date1 = entry.get(j + 1).getBigDecimal("tpv_tranprices").subtract(tpvTradingrange).abs();
                if (date1.compareTo(date) < 0) {
                    this.getModel().moveEntryRowDown("tpv_detail", j);
                }
            }
        }
        this.getView().updateView("tpv_detail");
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
                String tpvSedmatching = (String) this.getModel().getValue("tpv_sedmatching");//是否二次匹配
                if ("1".equals(tpvSedmatching)) {
                    this.btnOkSedmat();
                } else {
                    this.btnOk();
                }
                break;
        }
    }

    private void btnOkSedmat() {
        IFormView view = this.getView();
        IDataModel model = view.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObjectCollection tpvDetails = dataEntity.getDynamicObjectCollection("tpv_detail");

        IFormView parentView = view.getParentView();
        IDataModel parentmodel = parentView.getModel();
        DynamicObject parentDataEntity = parentmodel.getDataEntity(true);
        String name = parentDataEntity.getDataEntityType().getName();
        EntryGrid entryGrid = this.getControl("tpv_detail");
        int[] selectRows = entryGrid.getSelectRows();

        if (selectRows.length == 0) {
            this.getView().showTipNotification("请先选择明细分录中的一行数据！");
            return;
        }

        Boolean isFlag = false;
        Boolean isFlagNum = false;
        StringBuilder builder = new StringBuilder();//本次认领数量·吨 必录
        StringBuilder builderNum = new StringBuilder();//数量

        for (int i = 0; i < selectRows.length; i++) {
            BigDecimal tpvClaimquan = tpvDetails.get(selectRows[i]).getBigDecimal("tpv_claimquan");//本次认领数量·吨
            BigDecimal tpvNumtran = tpvDetails.get(selectRows[i]).getBigDecimal("tpv_numtran");//交易数量


            if (tpvClaimquan.compareTo(tpvNumtran) > 0) {
                isFlagNum = true;
                if (builderNum.length() == 0) {
                    builderNum.append(selectRows[i] + 1);
                } else {
                    builderNum.append("," + (selectRows[i] + 1));
                }
            }
            if (tpvClaimquan.compareTo(BigDecimal.ZERO) == 0) {
                isFlag = true;
                if (builder.length() == 0) {
                    builder.append(selectRows[i] + 1);
                } else {
                    builder.append("," + (selectRows[i] + 1));
                }
            }
        }
        if (isFlag) {
            this.getView().showTipNotification("请填写选中行第" + builder + "行的本次认领数量·吨");
            return;
        }
        if (isFlagNum) {
            this.getView().showTipNotification("选择行第" + builderNum + "行的认领数量大于交易数量！");
            return;
        }
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = new HashMap<>();
        maps = showParameter.getCustomParams();
        String key = (String) maps.get("key");
        for (int selectRow : selectRows) {
            long tpvSourceid = tpvDetails.get(selectRow).getLong("tpv_sourceid");
            BigDecimal tpvClaimquan = tpvDetails.get(selectRow).getBigDecimal("tpv_claimquan");
            DynamicObject tpvTmClaimdetails = BusinessDataServiceHelper.loadSingle(tpvSourceid, "tpv_tm_claimdetails");
            BigDecimal tpvDealton = tpvTmClaimdetails.getBigDecimal("tpv_dealton");

            tpvTmClaimdetails.set("tpv_dealton", tpvDealton.subtract(tpvClaimquan));
            SaveServiceHelper.save(new DynamicObject[]{tpvTmClaimdetails});
            List<ListSelectedRow> selectedRowsTwo = new ArrayList<>();
            ListSelectedRow listSelectedRowTwo = new ListSelectedRow(tpvSourceid);//来源单据ID
            selectedRowsTwo.add(listSelectedRowTwo);
            PushArgs pushArgsTwo = new PushArgs();
            pushArgsTwo.setSourceEntityNumber("tpv_tm_claimdetails");
            pushArgsTwo.setTargetEntityNumber("tpv_tm_claimdetails");
            pushArgsTwo.setAutoSave(true);//是否保存
            pushArgsTwo.setRuleId("2025368940766612480"); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
            pushArgsTwo.setBuildConvReport(true); // 是否输出详细错误报告
            pushArgsTwo.setSelectedRows(selectedRowsTwo); // 必选，设置需要下推的源单及分录内码
            ConvertOperationResult pushResultTwo = ConvertServiceHelper.push(pushArgsTwo);

            if (pushResultTwo.isSuccess()) {
                MainEntityType targetMainTypeOne = EntityMetadataCache
                        .getDataEntityType(pushArgsTwo.getTargetEntityNumber());
                List<DynamicObject> targetBillObjsOne = pushResultTwo
                        .loadTargetDataObjects(new IRefrencedataProvider() {
                            @Override
                            public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                                BusinessDataReader.loadRefence(objs, dType);
                            }
                        }, targetMainTypeOne);
                if (targetBillObjsOne.size() > 0) {
                    DynamicObject targetBillObjOne = targetBillObjsOne.get(0);
                    targetBillObjOne.set("tpv_dealton", tpvClaimquan);
                    OperationServiceHelper.executeOperate("save", "tpv_tm_claimdetails",
                            new DynamicObject[]{targetBillObjOne}, YEM.getOption());
                }
            }

            Map<String, String> fieldName = entryFieldName(name);
            if (key.contains("dk")) {
                DynamicObjectCollection tpvTmActivehed = parentDataEntity.getDynamicObjectCollection("tpv_tm_activehed");
                DynamicObject addNew = tpvTmActivehed.addNew();
                addNew.set("tpv_recordnum", tpvDetails.get(selectRow).get("tpv_billno"));//记录号
                addNew.set("tpv_contractool", tpvDetails.get(selectRow).get("tpv_remcons"));//合约代码
                addNew.set("tpv_tranprice", tpvDetails.get(selectRow).get("tpv_tranprices"));//成交价格
                addNew.set("tpv_numbertran", tpvDetails.get(selectRow).get("tpv_claimquan"));//交易吨数
                addNew.set("tpv_tradingday", tpvDetails.get(selectRow).get("tpv_tradingday"));//交易日
                addNew.set("tpv_tradingtime", tpvDetails.get(selectRow).get("tpv_tradingday"));//成交时点
                addNew.set("tpv_wareclaim", "tpv_removeclaim".equals(key) ? true : false);//是否移仓认领
                addNew.set("tpv_sourceiddk", tpvDetails.get(selectRow).get("tpv_srcid"));//来源单据id
                addNew.set("tpv_tradingdirecdk", tpvDetails.get(selectRow).get("tpv_tradingdirec"));//买卖方向
                String tpvContractnos = parentDataEntity.getString(fieldName.get("tpv_contractnos"));
                DynamicObject[] tpvTmPassivityhedgings = BusinessDataServiceHelper.load("tpv_tm_passivityhedging", "", new QFilter[]{new QFilter("tpv_tm_agentcontract.tpv_contractnumber", "=", tpvContractnos)});
                if (tpvTmPassivityhedgings.length == 1) {
                    addNew.set("tpv_passivityhedging", tpvTmPassivityhedgings[0]);
                }
            } else {
                DynamicObjectCollection tpvTmActivehed = parentDataEntity.getDynamicObjectCollection("tpv_tm_iniactivehed");
                DynamicObject addNew = tpvTmActivehed.addNew();
                addNew.set("tpv_inirecordnum", tpvDetails.get(selectRow).get("tpv_billno"));//记录号
                addNew.set("tpv_inicontractool", tpvDetails.get(selectRow).get("tpv_remcons"));//合约代码
                addNew.set("tpv_initranprice", tpvDetails.get(selectRow).get("tpv_tranprices"));//成交价格
                addNew.set("tpv_ininumbertran", tpvDetails.get(selectRow).get("tpv_claimquan"));//交易吨数
                addNew.set("tpv_initradingday", tpvDetails.get(selectRow).get("tpv_tradingday"));//交易日
                addNew.set("tpv_initradingtime", tpvDetails.get(selectRow).get("tpv_tradingday"));//成交时点
                addNew.set("tpv_iniwareclaim", "tpv_removeclaim".equals(key) ? true : false);//是否移仓认领
                addNew.set("tpv_sourceid", tpvDetails.get(selectRow).get("tpv_srcid"));//来源单据id
                addNew.set("tpv_initradingdirec", tpvDetails.get(selectRow).get("tpv_tradingdirec"));//买卖方向
            }

            parentView.invokeOperation("save");
            parentView.invokeOperation("refresh");
            this.getView().sendFormAction(parentView);
            this.getView().close();
        }
    }

    private void btnOk() {
        IFormView view = this.getView();
        IDataModel model = view.getModel();
        DynamicObject dataEntity1 = model.getDataEntity(true);
        DynamicObjectCollection tpvDetail = dataEntity1.getDynamicObjectCollection("tpv_detail");

        IFormView parentView = view.getParentView();
        IDataModel parentmodel = parentView.getModel();
        DynamicObject parentDataEntity = parentmodel.getDataEntity(true);
        String name = parentDataEntity.getDynamicObjectType().getName();
        if ("tpv_tm_policyclaim".equals(name)) {
            StringBuilder stringBuilder = new StringBuilder();
            DynamicObject tpvBaseprice = (DynamicObject) this.getModel().getValue("tpv_baseprice");//基价商品
            DynamicObject tpvRegion = (DynamicObject) this.getModel().getValue("tpv_region");//大区
            DynamicObject tpvCombination = (DynamicObject) this.getModel().getValue("tpv_combination");//组合号
            DynamicObject tpvUser = (DynamicObject) this.getModel().getValue("tpv_user");//业务员
            if (tpvBaseprice == null) {
                stringBuilder(stringBuilder, "基价商品");
            }
            if (tpvRegion == null) {
                stringBuilder(stringBuilder, "大区");
            }
            if (tpvCombination == null) {
                stringBuilder(stringBuilder, "组合号");
            }
            if (tpvUser == null) {
                stringBuilder(stringBuilder, "业务员");
            }
            if (stringBuilder.length() != 0) {
                this.getView().showTipNotification("请填写" + stringBuilder + "!");
                return;
            }
        }
        EntryGrid entryGrid = this.getControl("tpv_detail");
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length == 0) {
            this.getView().showTipNotification("请先选择明细分录中的一行数据！");
            return;
        }
        StringBuilder builder = new StringBuilder();//本次认领数量·吨 必录
        StringBuilder builderNum = new StringBuilder();//数量
        Boolean isFlag = false;
        Boolean isFlagNum = false;
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection details = dataEntity.getDynamicObjectCollection("tpv_detail");
        Map<String, String> fieldName = entryFieldName(name);
        for (int i = 0; i < selectRows.length; i++) {
            BigDecimal tpvClaimquan = details.get(selectRows[i]).getBigDecimal("tpv_claimquan");//本次认领数量·吨
            Long tpvSourceid = details.get(selectRows[i]).getLong("tpv_sourceid");//来源单据id
            DynamicObject dealrecord = BusinessDataServiceHelper.loadSingle(tpvSourceid, "tpv_tm_dealrecord");
            BigDecimal tpvDealton = dealrecord.getBigDecimal("tpv_dealton");//成交吨数
            BigDecimal tpvClaimcqqty = dealrecord.getBigDecimal("tpv_claimcqqty");//已认领数量(苍穹)
            BigDecimal tpvClaimnbqty = dealrecord.getBigDecimal("tpv_claimnbqty");//已认领数量(南北)

            if (tpvClaimquan.add(tpvClaimcqqty).add(tpvClaimnbqty).compareTo(tpvDealton) > 0) {
                isFlagNum = true;
                if (builderNum.length() == 0) {
                    builderNum.append(selectRows[i] + 1);
                } else {
                    builderNum.append("," + (selectRows[i] + 1));
                }
            }
            if (tpvClaimquan.compareTo(BigDecimal.ZERO) == 0) {
                isFlag = true;
                if (builder.length() == 0) {
                    builder.append(selectRows[i] + 1);
                } else {
                    builder.append("," + (selectRows[i] + 1));
                }
            }
        }

        if (isFlag) {
            this.getView().showTipNotification("请填写选中行第" + builder + "行的本次认领数量·吨");
            return;
        }
        if (isFlagNum) {
            this.getView().showTipNotification("选择行第" + builderNum + "行的认领数量大于可认领数量！");
            return;
        }

        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = new HashMap<>();
        maps = showParameter.getCustomParams();
        String key = (String) maps.get("key");
        for (int selectRow : selectRows) {

            BigDecimal tpvClaimquan = details.get(selectRow).getBigDecimal("tpv_claimquan");//本次认领数量·吨
            BigDecimal tpvQuanclaimed = details.get(selectRow).getBigDecimal("tpv_quanclaimed");//已认领数量
            BigDecimal tpvServicecharge = details.get(selectRow).getBigDecimal("tpv_servicecharge");//手续费
            BigDecimal tpvNumtran = details.get(selectRow).getBigDecimal("tpv_numtran");//交易数量
            Long tpvSource = details.get(selectRow).getLong("tpv_sourceid");//来源单据i

            BigDecimal tpvProcessingfee = BigDecimal.ZERO;
            if (tpvClaimquan.add(tpvQuanclaimed).compareTo(tpvNumtran) == 0) {
                BigDecimal tatal = BigDecimal.ZERO;
                DynamicObject[] tmClaimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", "tpv_processingfee", new QFilter[]{new QFilter("tpv_datasourcesid", "=", tpvSource.toString())});
                for (DynamicObject tmClaimdetail : tmClaimdetails) {
                    tatal.add(tmClaimdetail.getBigDecimal("tpv_processingfee"));
                }
                tpvProcessingfee = tpvServicecharge.subtract(tatal);
            } else {
                tpvProcessingfee = tpvClaimquan.divide(tpvNumtran, 2, RoundingMode.HALF_UP).multiply(tpvServicecharge);
            }

            DynamicObject tmClaimdetails = ORM.create().newDynamicObject("tpv_tm_claimdetails");
            long genLongId = ORM.create().genLongId(tmClaimdetails.getDataEntityType());
            tmClaimdetails.set("id",genLongId);
            CodeRuleInfo codeRule = CodeRuleServiceHelper.getCodeRule("tpv_tm_claimdetails", tmClaimdetails, null);
            String billno = CodeRuleServiceHelper.getNumber(codeRule, tmClaimdetails);
            tmClaimdetails.set("billno", billno);//单据编号
            tmClaimdetails.set("billstatus", "A");//单据状态

            tmClaimdetails.set("tpv_basegoods", dataEntity.getDynamicObject("tpv_baseprice"));//基价商品
            tmClaimdetails.set("tpv_region", dataEntity.getDynamicObject("tpv_region"));//大区
            tmClaimdetails.set("tpv_combination", dataEntity.getDynamicObject("tpv_combination"));//组合号
            tmClaimdetails.set("tpv_operators", dataEntity.getDynamicObject("tpv_user"));//人员

            tmClaimdetails.set("tpv_operator", YEM.getCurrentUserId());//业务员
            tmClaimdetails.set("tpv_company", YEM.getCurrentOrgId());//公司
            tmClaimdetails.set("org", YEM.getCurrentOrgId());//公司
            tmClaimdetails.set("tpv_version", 1);//版本号
            DynamicObject tpvUser = dataEntity.getDynamicObject("tpv_user");
            tmClaimdetails.set("tpv_department", UserServiceHelper.getUserMainOrgId(YEM.getCurrentUserId()));//部门
            tmClaimdetails.set("tpv_bizdate", new Date());//业务日期
            tmClaimdetails.set("tpv_claimlogo", "A");//认领标志
//            tmClaimdetails.set("tpv_redflush", "A");//红冲标志
            tmClaimdetails.set("tpv_orderprice", null);//是否点价
//            tmClaimdetails.set("tpv_ponumbers",null);//点价单号
            tmClaimdetails.set("tpv_categories", "A");//业务大类
//            tmClaimdetails.set("tpv_coverup",null);//是否代客套保

            tmClaimdetails.set("tpv_recordnum", tpvDetail.get(selectRow).get("tpv_billno"));//记录号  成交记录单的单据编号
            tmClaimdetails.set("tpv_contractool", tpvDetail.get(selectRow).get("tpv_remcons"));//记录合约
            tmClaimdetails.set("tpv_dealprice", tpvDetail.get(selectRow).get("tpv_tranprices"));//成交价格
            tmClaimdetails.set("tpv_dealton", tpvDetail.get(selectRow).get("tpv_claimquan"));//交易吨数
            tmClaimdetails.set("tpv_claimdetails", tpvDetail.get(selectRow).get("tpv_claimquan"));//本次认领数量
            tmClaimdetails.set("tpv_tradeway", tpvDetail.get(selectRow).get("tpv_tradingdirec"));//交易方向
//            tmClaimdetails.set("tpv_openclosesign",tpvDetail.get(selectRow).get(""));//开平
            tmClaimdetails.set("tpv_dealdate", tpvDetail.get(selectRow).get("tpv_tradingday"));//成交时间
            tmClaimdetails.set("tpv_dealdateday", tpvDetail.get(selectRow).get("tpv_tradingday"));//交易日
//            tmClaimdetails.set("tpv_account",tpvDetail.get(selectRow).get(""));//账户
            tmClaimdetails.set("tpv_amcunit", tpvDetail.get(selectRow).get("tpv_amcunit"));//账户管理单元
            tmClaimdetails.set("tpv_processingfee", tpvProcessingfee);//手续费


            tmClaimdetails.set("tpv_srcbillway", "B");//数据来源
            tmClaimdetails.set("createtime", new Date());//创建时间
            tmClaimdetails.set("tpv_datetime", new Date());//认领时间
            tmClaimdetails.set("tpv_coverup", key.contains("dk") ? true : false);//是否代客套保
            tmClaimdetails.set("creator", YEM.getCurrentUserId());//创建人
            Object tpvSourceid = tpvDetail.get(selectRow).get("tpv_sourceid");
            DynamicObject tpvTmDealrecord = BusinessDataServiceHelper.loadSingle(tpvSourceid, "tpv_tm_dealrecord");
            BigDecimal tpvClaimcqqty = tpvTmDealrecord.getBigDecimal("tpv_claimcqqty");
            tpvTmDealrecord.set("tpv_claimcqqty", tpvDetail.get(selectRow).getBigDecimal("tpv_claimquan").add(tpvClaimcqqty));
            tmClaimdetails.set("tpv_account", tpvTmDealrecord.get("tpv_account"));//账户
            tmClaimdetails.set("tpv_openclosesign", tpvTmDealrecord.get("tpv_openclosesign"));//开平
            tmClaimdetails.set("tpv_dealrecord", tpvSourceid);//成交记录单id
            tmClaimdetails.set("tpv_approvalandshare", true);//协同审批&扩大共享
            Object id = 0L;
            if ("tpv_tm_policyclaim".equals(name)) {//策略认领工作台
                id = policyclaim(parentmodel, tmClaimdetails, tpvDetail, selectRow, key, maps, id);
            } else if ("tpv_tm_positionorder".equals(name)) {//头寸业务单
                id = positionorder(parentmodel, tmClaimdetails, key, id);
            } else if ("tpv_tm_conttranform".equals(name)) {//合同结转单被动套保 合同结转单主动套保
                id = conttranform(parentmodel, tmClaimdetails, key, id);
            } else if ("tpv_dt_purchase".equals(name) || "tpv_dt_salescontract".equals(name)) {//采购合同 销售合同
                id = purOrSale(parentmodel, tmClaimdetails, name, key, id);
            } else if ("tpv_tm_kyoping".equals(name)) {//协平单
                id = kyoping(parentmodel, tmClaimdetails, name, key, id);
            } else if ("tpv_dt_salesshipping".equals(name)) {//销售发货单
                id = salesShipping(parentmodel, tmClaimdetails, name, key, id);
            }
            if (!"tpv_tm_policyclaim".equals(name)) {
                if (key.contains("dk")) {
                    DynamicObjectCollection tpvTmActivehed = parentDataEntity.getDynamicObjectCollection("tpv_tm_activehed");
                    DynamicObject addNew = tpvTmActivehed.addNew();
                    addNew.set("tpv_recordnum", tpvDetail.get(selectRow).get("tpv_billno"));//记录号
                    addNew.set("tpv_contractool", tpvDetail.get(selectRow).get("tpv_remcons"));//合约代码
                    addNew.set("tpv_tranprice", tpvDetail.get(selectRow).get("tpv_tranprices"));//成交价格
                    addNew.set("tpv_numbertran", tpvDetail.get(selectRow).get("tpv_claimquan"));//交易吨数
                    addNew.set("tpv_tradingday", tpvDetail.get(selectRow).get("tpv_tradingday"));//交易日
                    addNew.set("tpv_tradingtime", tpvDetail.get(selectRow).get("tpv_tradingday"));//成交时点
                    addNew.set("tpv_wareclaim", "tpv_removeclaim".equals(key) ? true : false);//是否移仓认领
                    addNew.set("tpv_sourceiddk", genLongId);//来源单据id
                    addNew.set("tpv_tradingdirecdk", tpvDetail.get(selectRow).get("tpv_tradingdirec"));//买卖方向
                    if ("tpv_dt_salescontract".equals(name) || "tpv_dt_purchase".equals(name)) {
                        String tpvContractnos = parentDataEntity.getString(fieldName.get("tpv_contractnos"));
                        DynamicObject[] tpvTmPassivityhedgings = BusinessDataServiceHelper.load("tpv_tm_passivityhedging", "", new QFilter[]{new QFilter("tpv_tm_agentcontract.tpv_contractnumber", "=", tpvContractnos)});
                        if (tpvTmPassivityhedgings.length == 1) {
                            addNew.set("tpv_passivityhedging", tpvTmPassivityhedgings[0]);
                        }
                    }
                } else {
                    DynamicObjectCollection tpvTmActivehed = parentDataEntity.getDynamicObjectCollection("tpv_tm_iniactivehed");
                    DynamicObject addNew = tpvTmActivehed.addNew();
                    addNew.set("tpv_inirecordnum", tpvDetail.get(selectRow).get("tpv_billno"));//记录号
                    addNew.set("tpv_inicontractool", tpvDetail.get(selectRow).get("tpv_remcons"));//合约代码
                    addNew.set("tpv_initranprice", tpvDetail.get(selectRow).get("tpv_tranprices"));//成交价格
                    addNew.set("tpv_ininumbertran", tpvDetail.get(selectRow).get("tpv_claimquan"));//交易吨数
                    addNew.set("tpv_initradingday", tpvDetail.get(selectRow).get("tpv_tradingday"));//交易日
                    addNew.set("tpv_initradingtime", tpvDetail.get(selectRow).get("tpv_tradingday"));//成交时点
                    addNew.set("tpv_iniwareclaim", "tpv_removeclaim".equals(key) ? true : false);//是否移仓认领
                    addNew.set("tpv_sourceid", genLongId);//来源单据id
                    addNew.set("tpv_initradingdirec", tpvDetail.get(selectRow).get("tpv_tradingdirec"));//买卖方向
                }
            }
            SaveServiceHelper.save(new DynamicObject[]{tpvTmDealrecord});
            SaveServiceHelper.save(new DynamicObject[]{tmClaimdetails});
        }
        parentView.invokeOperation("save",YEM.getOptionNoMsg());
        parentView.invokeOperation("refresh");
        this.getView().sendFormAction(parentView);
        this.getView().close();
    }

    public void stringBuilder(StringBuilder stringBuilder, String basePrice) {
        if (stringBuilder.length() == 0) {
            stringBuilder.append(basePrice);
        } else {
            stringBuilder.append("，" + basePrice);
        }
    }

    private Long kyoping(IDataModel parentmodel, DynamicObject tmClaimdetails, String name, String key, Object id) {
        Map<String, String> fieldName = entryFieldName(name);
        DynamicObject dataEntity = parentmodel.getDataEntity(true);

        String tpvCorebillno = dataEntity.getString("tpv_corebillno");//来源单据id
        String tpvSourcebillkey = dataEntity.getString("tpv_sourcebillkey");//来源单据标识
        DynamicObject tpvCombinationnum = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_combinationnum"));//组合号
        DynamicObject tpvDepartment = (DynamicObject) parentmodel.getValue("tpv_department");//部门
        DynamicObject tpvOperator = (DynamicObject) parentmodel.getValue("tpv_operator");//业务员
        DynamicObject bdStrategy = BusinessDataServiceHelper.loadSingle("tpv_bd_strategy", new QFilter[]{new QFilter("name", QCP.ftlike, "%" + name + "%")});

        if (YEM.isNotEmpty(tpvCorebillno) && "tpv_dt_purchase".equals(tpvSourcebillkey)) {//采购
            DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(tpvCorebillno, tpvSourcebillkey);
            tmClaimdetails.set("tpv_contractsup", loadSingle == null ? null : loadSingle.get("tpv_supplier"));//合同供应商 1
            tmClaimdetails.set("tpv_prcontractnum", loadSingle);//采购合同号
        }
        tmClaimdetails.set("tpv_contracttype", "协平单");//合同类型
        tmClaimdetails.set("tpv_combination", tpvCombinationnum);//组合号
        tmClaimdetails.set("tpv_strategyname", bdStrategy);//策略名称
        tmClaimdetails.set("tpv_hedgetype", bdStrategy == null ? null : bdStrategy.get("tpv_hedgetype"));//套保类型
        tmClaimdetails.set("tpv_departments", tpvDepartment);//认领部门
        tmClaimdetails.set("tpv_people", tpvOperator);//人员
        tmClaimdetails.set("tpv_superiornums", tpvCorebillno);//上级单据号
        tmClaimdetails.set("tpv_datasourcess", name);//数据来源
        tmClaimdetails.set("tpv_datasourcesnum", dataEntity.get("billno"));//来源单据号
        tmClaimdetails.set("tpv_datasourcesid", dataEntity.getPkValue());//来源单据id
        tmClaimdetails.set("tpv_warehouse", key.contains("tpv_removeclaim") ? true : false);//是否移仓认领
        id = dataEntity.getPkValue();
        departmentAps(bdStrategy,tpvDepartment,tmClaimdetails);
        return (Long) dataEntity.getPkValue();
    }

    private Long purOrSale(IDataModel parentmodel, DynamicObject tmClaimdetails, String name, String key, Object id) {
        Map<String, String> fieldName = entryFieldName(name);
        DynamicObject dataEntity = parentmodel.getDataEntity(true);

        DynamicObject tpvCombinationnum = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_combinationnum"));//组合号
        DynamicObject tpvStrategynum = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_strategynum"));//策略号
        DynamicObject tpvDepartment = (DynamicObject) parentmodel.getValue("tpv_department");//部门
        DynamicObject tpvOperator = (DynamicObject) parentmodel.getValue("tpv_operator");//业务员
        DynamicObject tpvBasegoods = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_basegoods"));//基价商品
        BigDecimal tpvBaseprices = (BigDecimal) parentmodel.getValue(fieldName.get("tpv_baseprices"));//基价价格

        if ("tpv_dt_purchase".equals(name)) {//采购
            tmClaimdetails.set("tpv_contracttype", dataEntity.get("tpv_document.name"));//合同类型
            tmClaimdetails.set("tpv_prcontractnum", dataEntity);//采购合同号
            tmClaimdetails.set("tpv_contractsup", dataEntity.get("tpv_supplier"));//合同供应商
        } else if ("tpv_dt_salescontract".equals(name)) {//销售
            tmClaimdetails.set("tpv_contracttype", dataEntity.get("tpv_documenttypes.name"));//合同类型
            tmClaimdetails.set("tpv_sacontractnum", dataEntity);//销售合同号
            tmClaimdetails.set("tpv_contractcus", dataEntity.get("tpv_customer"));//合同客户
        }
        tmClaimdetails.set("tpv_combination", tpvCombinationnum);//组合号
        tmClaimdetails.set("tpv_hedgetype", tpvStrategynum == null ? null : tpvStrategynum.get("tpv_hedgetype"));//套保类型
        tmClaimdetails.set("tpv_strategyname", tpvStrategynum);//策略名称
        tmClaimdetails.set("tpv_basegoods", tpvBasegoods);//基价商品
        tmClaimdetails.set("tpv_contractbaseprice", tpvBaseprices);//合同基价
        tmClaimdetails.set("tpv_departments", tpvDepartment);//认领部门
        tmClaimdetails.set("tpv_people", tpvOperator);//人员
        tmClaimdetails.set("tpv_superiornums", dataEntity.get("billno"));//上级单据号
        tmClaimdetails.set("tpv_datasourcess", name);//数据来源
        tmClaimdetails.set("tpv_datasourcesnum", dataEntity.get("billno"));//来源单据号
        tmClaimdetails.set("tpv_datasourcesid", dataEntity.getPkValue());//来源单据id
        tmClaimdetails.set("tpv_warehouse", key.contains("tpv_removeclaim") ? true : false);//是否移仓认领
        departmentAps(tpvStrategynum,tpvDepartment,tmClaimdetails);
        id = dataEntity.getPkValue();
        return (Long) dataEntity.getPkValue();
    }

    private Long salesShipping(IDataModel parentmodel, DynamicObject tmClaimdetails, String name, String key, Object id) {
        Map<String, String> fieldName = entryFieldName(name);
        DynamicObject dataEntity = parentmodel.getDataEntity(true);
        DynamicObject tpvCombinationnum = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_combinationnum"));//组合号
        DynamicObject tpvStrategynum = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_strategynum"));//策略号
        DynamicObject tpvDepartment = (DynamicObject) parentmodel.getValue("tpv_department");//部门
        DynamicObject tpvOperator = (DynamicObject) parentmodel.getValue("tpv_operator");//业务员
        DynamicObject tpvBasegoods = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_basegoods"));//基价商品
        BigDecimal tpvBaseprices = (BigDecimal) parentmodel.getValue(fieldName.get("tpv_baseprices"));//基价价格

        tmClaimdetails.set("tpv_combination", tpvCombinationnum);//组合号
        tmClaimdetails.set("tpv_hedgetype", tpvStrategynum == null ? null : tpvStrategynum.get("tpv_hedgetype"));//套保类型
        tmClaimdetails.set("tpv_strategyname", tpvStrategynum);//策略名称
        tmClaimdetails.set("tpv_basegoods", tpvBasegoods);//基价商品
        tmClaimdetails.set("tpv_contractbaseprice", tpvBaseprices);//合同基价
        tmClaimdetails.set("tpv_departments", tpvDepartment);//认领部门
        tmClaimdetails.set("tpv_people", tpvOperator);//人员
        tmClaimdetails.set("tpv_superiornums", dataEntity.get("billno"));//上级单据号
        tmClaimdetails.set("tpv_datasourcess", name);//数据来源
        tmClaimdetails.set("tpv_datasourcesnum", dataEntity.get("billno"));//来源单据号
        tmClaimdetails.set("tpv_datasourcesid", dataEntity.getPkValue());//来源单据id
        tmClaimdetails.set("tpv_warehouse", key.contains("tpv_removeclaim") ? true : false);//是否移仓认领
        id = dataEntity.getPkValue();
        departmentAps(tpvStrategynum,tpvDepartment,tmClaimdetails);
        return (Long) dataEntity.getPkValue();
    }

    private Long conttranform(IDataModel parentmodel, DynamicObject tmClaimdetails, String key, Object id) {
        Map<String, String> fieldName = entryFieldName(key);
        String tpvSourcebillkey = (String) parentmodel.getValue("tpv_sourcebillkey");//来源单据标识
        Long tpvSourcebillid = (Long) parentmodel.getValue("tpv_sourcebillid");//来源单据id
        String tpvSourcebillno = (String) parentmodel.getValue("billno");//来源单据号
        DynamicObject tpvCombinationnum = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_combinationnum"));//组合号
        String tpvHedgetype = (String) parentmodel.getValue("tpv_hedgetypesale");//套保类型
        DynamicObject tpvSalesregion = (DynamicObject) parentmodel.getValue("tpv_salesregion");//大区

        DynamicObject tpvStrategynum = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_strategynum"));//策略号
        DynamicObject tpvDepartment = (DynamicObject) parentmodel.getValue("tpv_department");//部门
        DynamicObject tpvOperator = (DynamicObject) parentmodel.getValue("tpv_operator");//业务员
        DynamicObject tpvBasegoods = (DynamicObject) parentmodel.getValue("tpv_basegoods");//基价商品
        BigDecimal tpvBaseprices = (BigDecimal) parentmodel.getValue("tpv_baseprices");//基价价格
        DynamicObject tpvSalenumsale = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_salenumsale"));//基价商品  tpv_salenumsale
        tmClaimdetails.set("tpv_combination", tpvCombinationnum);//组合号
        tmClaimdetails.set("tpv_hedgetype", tpvHedgetype);//套保类型
        tmClaimdetails.set("tpv_strategyname", tpvStrategynum);//策略名称
        tmClaimdetails.set("tpv_basegoods", tpvBasegoods);//基价商品
        tmClaimdetails.set("tpv_region", tpvSalesregion);//大区
        tmClaimdetails.set("tpv_contractbaseprice", tpvBaseprices);//合同基价
        tmClaimdetails.set("tpv_departments", tpvDepartment);//认领部门
        tmClaimdetails.set("tpv_sacontractnum", tpvSalenumsale);//销售合同号
        tmClaimdetails.set("tpv_contractcus", tpvSalenumsale == null ? null : tpvSalenumsale.get("tpv_customer"));//合同客户
        tmClaimdetails.set("tpv_people", tpvOperator);//人员
        tmClaimdetails.set("tpv_superiornums", tpvSourcebillno);//上级单据号
        tmClaimdetails.set("tpv_datasourcess", "tpv_tm_conttranform");//数据来源
        tmClaimdetails.set("tpv_datasourcesnum", tpvSourcebillno);//来源单据号
        tmClaimdetails.set("tpv_datasourcesid", parentmodel.getDataEntity(true).getPkValue());//来源单据id
        tmClaimdetails.set("tpv_coverup", false);//是否代客套保
        tmClaimdetails.set("tpv_pursale", key);//合同结转
        departmentAps(tpvStrategynum,tpvDepartment,tmClaimdetails);
        id = parentmodel.getDataEntity(true).getPkValue();
        return (Long) parentmodel.getDataEntity(true).getPkValue();
    }

    private Long policyclaim(IDataModel parentmodel, DynamicObject tmClaimdetails, DynamicObjectCollection tpvDetail, int selectRow, String key, Map<String, Object> maps, Object id) {
        DynamicObject tpvStrategynum = (DynamicObject) parentmodel.getValue("tpv_strategynum");//策略号
        String tpvStrateg = (String) maps.get("tpv_strateg");
        int index = parentmodel.getEntryCurrentRowIndex("tpv_westrategy");
        DynamicObject dynamicObject = parentmodel.getEntryRowEntity("tpv_westrategy", index);
        if (dynamicObject != null) {
            long tpvStrategyid = dynamicObject.getLong("tpv_strategyid");
            if ("tpv_bd_strategy".equals(tpvStrateg)) {
                DynamicObject tpvBdStrategy = BusinessDataServiceHelper.loadSingle(tpvStrategyid, "tpv_bd_strategy");
                tmClaimdetails.set("tpv_strategiccli", tpvBdStrategy == null ? null : tpvBdStrategy.get("tpv_client"));//策略客户
                tmClaimdetails.set("tpv_hedgetype", tpvBdStrategy == null ? null : tpvBdStrategy.get("tpv_hedgetype"));//套保类型
            } else if ("tpv_cushedgemagereq".equals(tpvStrateg)) {//代客套保管理申请单
                tmClaimdetails.set("tpv_cushedgemagereq", tpvStrategyid);//是否移仓认领
            }
        }
//        tmClaimdetails.set("tpv_operators", tpvStrategynum == null ? null : tpvStrategynum.get("tpv_operator"));//业务员
//        tmClaimdetails.set("tpv_region", tpvStrategynum == null ? null : tpvStrategynum.get("tpv_spotarea"));//大区
        tmClaimdetails.set("tpv_warehouse", "tpv_removeclaim".equals(key) ? true : false);//是否移仓认领
        tmClaimdetails.set("tpv_strategyname", dynamicObject == null ? null : dynamicObject.getLong("tpv_strategyid"));//策略名称
        tmClaimdetails.set("tpv_departments", UserServiceHelper.getUserMainOrgId(YEM.getCurrentUserId()));//认领部门
        tmClaimdetails.set("tpv_people", YEM.getCurrentUserId());//人员
//        tmClaimdetails.set("tpv_superiornums",  tpvDetail.get(selectRow).get("tpv_sourcebillno"));//上级单据号
        tmClaimdetails.set("tpv_datasourcess", "tpv_tm_policyclaim");//数据来源
        tmClaimdetails.set("tpv_datasourcesnum", tpvDetail.get(selectRow).get("tpv_billno"));//来源单据号
        tmClaimdetails.set("tpv_datasourcesid", tpvDetail.get(selectRow).get("tpv_sourceid"));//来源单据id
        return tpvDetail.get(selectRow).getLong("tpv_sourceid");
    }


    private Long positionorder(IDataModel parentmodel, DynamicObject tmClaimdetails, String key, Object id) {
        String tpvSourcebillkey = (String) parentmodel.getValue("tpv_sourcebillkey");//来源单据标识
        Long tpvSourcebillid = (Long) parentmodel.getValue("tpv_sourcebillid");//来源单据id
        String tpvSourcebillno = (String) parentmodel.getValue("billno");//来源单据号
        DynamicObject tpvCombinationnum = (DynamicObject) parentmodel.getValue("tpv_combinationnum");//组合号
        String tpvHedgetype = (String) parentmodel.getValue("tpv_hedgetype");//套保类型

        DynamicObject tpvStrategynum = (DynamicObject) parentmodel.getValue("tpv_strategynum");//策略号
        DynamicObject tpvDepartment = (DynamicObject) parentmodel.getValue("tpv_department");//部门
        DynamicObject tpvOperator = (DynamicObject) parentmodel.getValue("tpv_operator");//业务员
        DynamicObject tpvBasegoods = (DynamicObject) parentmodel.getValue("tpv_basegoods");//基价商品
        BigDecimal tpvBaseprices = (BigDecimal) parentmodel.getValue("tpv_baseprices");//基价价格

        if ("tpv_dt_purchase".equals(tpvSourcebillkey)) {//采购
            tmClaimdetails.set("tpv_contracttype", "采购合同");//合同类型
            tmClaimdetails.set("tpv_prcontractnum", tpvSourcebillid);//采购合同号
            DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(tpvSourcebillid, tpvSourcebillkey);
            tmClaimdetails.set("tpv_contractsup", loadSingle == null ? null : loadSingle.get("tpv_supplier"));//合同供应商
        } else if ("tpv_dt_salescontract".equals(tpvSourcebillkey)) {//销售
            tmClaimdetails.set("tpv_contracttype", "销售合同");//合同类型
            tmClaimdetails.set("tpv_sacontractnum", tpvSourcebillid);//销售合同号
            DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(tpvSourcebillid, tpvSourcebillkey);
            tmClaimdetails.set("tpv_contractcus", loadSingle == null ? null : loadSingle.get("tpv_customer"));//合同客户
        }
        tmClaimdetails.set("tpv_combination", tpvCombinationnum);//组合号
        tmClaimdetails.set("tpv_hedgetype", tpvHedgetype);//套保类型
        tmClaimdetails.set("tpv_strategyname", tpvStrategynum);//策略名称
        tmClaimdetails.set("tpv_basegoods", tpvBasegoods);//基价商品
        tmClaimdetails.set("tpv_contractbaseprice", tpvBaseprices);//合同基价
        tmClaimdetails.set("tpv_departments", tpvDepartment);//认领部门
        tmClaimdetails.set("tpv_people", tpvOperator);//人员
        tmClaimdetails.set("tpv_superiornums", parentmodel.getDataEntity(true).get("tpv_sourcebillno"));//上级单据号
        tmClaimdetails.set("tpv_datasourcess", "tpv_tm_positionorder");//数据来源
        tmClaimdetails.set("tpv_datasourcesnum", tpvSourcebillno);//来源单据号
        tmClaimdetails.set("tpv_datasourcesid", tpvSourcebillid);//来源单据id
        tmClaimdetails.set("tpv_warehouse", "tpv_removeclaim".equals(key) ? true : false);//是否移仓认领
        id = tpvSourcebillid;
        departmentAps(tpvStrategynum,tpvDepartment,tmClaimdetails);
        return tpvSourcebillid;
    }

    /**
     *
     * @param tpvStrategynum 策略名称
     * @param tpvDepartment  部门
     * @param tmClaimdetails 认领明细单
     */
    public void departmentAps(DynamicObject tpvStrategynum, DynamicObject tpvDepartment, DynamicObject tmClaimdetails){
        List<DynamicObject> dynamicObjects = new ArrayList<>();
        if (tpvDepartment!=null){
            dynamicObjects.add(tpvDepartment);
        }
        if (tpvStrategynum!=null){
            DynamicObject tpvBdStrategy = BusinessDataServiceHelper.loadSingle(tpvStrategynum.getPkValue(), "tpv_bd_strategy");
            DynamicObjectCollection tpvBdStrategyXt = tpvBdStrategy.getDynamicObjectCollection("tpv_bd_strategy_xt");
            for (DynamicObject dynamicObject : tpvBdStrategyXt) {
                DynamicObject tpvTermdefinition = dynamicObject.getDynamicObject("tpv_termdefinition");
                if (tpvTermdefinition!=null){
                    DynamicObject tpvTmSnapdefinition = BusinessDataServiceHelper.loadSingle(tpvTermdefinition.getPkValue(), "tpv_tm_snapdefinition");
                    DynamicObjectCollection tpvTmSnapdefiniB = tpvTmSnapdefinition.getDynamicObjectCollection("tpv_tm_snapdefini_b");
                    for (DynamicObject tmSnapdefiniB : tpvTmSnapdefiniB) {
                        DynamicObject tpvBranch = tmSnapdefiniB.getDynamicObject("tpv_branch");
                        if (tpvBranch!=null){
                            dynamicObjects.add(tpvBranch);
                        }
                    }
                }
            }
        }
        DynamicObjectCollection tpvApprovalsetting = tmClaimdetails.getDynamicObjectCollection("tpv_approvalsetting");
        for (DynamicObject dynamicObject : dynamicObjects) {
            DynamicObject addNew = tpvApprovalsetting.addNew();
            addNew.set("tpv_department_aps",dynamicObject);
            addNew.set("tpv_queryable",true);
        }

    }
    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
        EntryGrid entryGrid = this.getControl("tpv_detail");
        int[] selectRows = entryGrid.getSelectRows();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvDetail = dataEntity.getDynamicObjectCollection("tpv_detail");
        Object returnData = closedCallBackEvent.getReturnData();
        // 判断标识是否匹配，并验证返回值不为空，不验证返回值可能会报空指针
        if (StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_expcla") && null != closedCallBackEvent.getReturnData()) {
            ListSelectedRowCollection datas = (ListSelectedRowCollection) returnData;
            List<Long> idList = new ArrayList();
            for (ListSelectedRow data : datas) {
                Long primaryKeyValue = (Long) data.getPrimaryKeyValue();
                idList.add(primaryKeyValue);
            }
            DynamicObject[] usersForDisplay = BusinessDataServiceHelper.load("tpv_tm_snapdebaseedit", "", new QFilter[]{new QFilter("id", "in", idList)});
            if (usersForDisplay.length == 0) {
                return;
            }
            for (int selectRow : selectRows) {
                DynamicObject tmDealrecord = BusinessDataServiceHelper.loadSingle(tpvDetail.get(selectRow).get("tpv_sourceid"), "tpv_tm_dealrecord");
                DynamicObjectCollection tpvClaimablesnapin = tmDealrecord.getDynamicObjectCollection("tpv_claimablesnapin");
                DynamicObjectCollection fourBookColl = new DynamicObjectCollection();
                for (DynamicObject dynamicObject : usersForDisplay) {
                    DynamicObject tempDyObj = new DynamicObject(tpvClaimablesnapin.getDynamicObjectType());
                    tempDyObj.set("fbasedataid", dynamicObject);
                    fourBookColl.add(tempDyObj);
                }
                tmDealrecord.set("tpv_claimablesnapin", fourBookColl);
                SaveServiceHelper.save(new DynamicObject[]{tmDealrecord});
            }
        }
        String tpvSedmatching = (String) this.getModel().getValue("tpv_sedmatching");//是否二次匹配
        if ("1".equals(tpvSedmatching)) {
            sedMatching();
        } else {
            detail();
        }
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs afterDoOperationEventArgs) {
        super.afterDoOperation(afterDoOperationEventArgs);
        String key = afterDoOperationEventArgs.getOperateKey();//+新建开平记录向弹窗传递空操作用来触发单据体的刷新
        if ("donothing".equals(key)) {
            String tpvSedmatching = (String) this.getModel().getValue("tpv_sedmatching");//是否二次匹配
            if ("1".equals(tpvSedmatching)) {
                sedMatching();
            } else {
                detail();
            }
        }
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
        }
    }


    public static Map<String, String> entryFieldName(String entityName) {
        Map<String, String> map = new HashMap<>();
        String tpv_strategynum = "";//策略号
        String tpv_salesregion = "";//销售大区
        String tpv_basegoods = "";//基价商品
        String tpv_baseprices = "";//基价价格
        String tpv_combinationnum = "";//组合号
        String tpv_salenumsale = "";//对应销售合同号
        String contractnos = "";//合同号
        switch (entityName) {
            case "tpv_dt_purchase": //采购合同
                tpv_strategynum = "tpv_policynumber";
                tpv_salesregion = "tpv_salesarea";
                tpv_basegoods = "tpv_basepriceitems";
                tpv_baseprices = "tpv_baseprice";
                contractnos = "tpv_contractnumber";
                tpv_combinationnum = "tpv_combinationnumber";//组合号
                break;
            case "tpv_dt_salescontract"://销售合同(原始)
                tpv_strategynum = "tpv_strategynum";
                tpv_salesregion = "tpv_salesregion";
                tpv_basegoods = "tpv_basegoods";
                tpv_baseprices = "tpv_baseprices";
                tpv_combinationnum = "tpv_combinationnumber";//组合号
                contractnos = "tpv_contractnos";
                break;
            case "tpv_claimdk"://合同结转单  代客套保 认领
                tpv_strategynum = "tpv_salestrategynum";
                tpv_combinationnum = "tpv_combinationsale";
                tpv_salenumsale = "tpv_salenumsale";
                break;
            case "tpv_claim"://合同结转单  主动套保 认领
                tpv_strategynum = "tpv_strategynum";
                tpv_combinationnum = "tpv_combinationnum";
                tpv_salenumsale = "tpv_salenum";
                break;
            case "tpv_tm_conttranform"://合同结转单
                tpv_strategynum = "tpv_salestrategynum";
                break;
            case "tpv_tm_kyoping"://协平单
                tpv_strategynum = "tpv_policynum";//策略号
                tpv_combinationnum = "tpv_combinationnumber";//组合号
                break;
            case "tpv_tm_positionorder"://头寸业务单
                tpv_strategynum = "tpv_strategynum";
                tpv_salesregion = "tpv_salesregion";
                tpv_basegoods = "tpv_basegoods";
                tpv_baseprices = "tpv_baseprices";
                tpv_combinationnum = "tpv_combinationnum";//组合号
                break;
            case "tpv_dt_salesshipping"://销售发货单
                tpv_strategynum = "tpv_policyber";
                tpv_salesregion = "tpv_salesregion";
                tpv_basegoods = "tpv_basegoods";
                tpv_baseprices = "tpv_baseprices";
                tpv_combinationnum = "tpv_combina";
                contractnos = "tpv_contractnumber";
                break;
        }
        map.put("tpv_strategynum", tpv_strategynum); //策略号
        map.put("tpv_salesregion", tpv_salesregion); //销售大区
        map.put("tpv_basegoods", tpv_basegoods); //基价商品
        map.put("tpv_baseprices", tpv_baseprices); //基价价格
        map.put("tpv_combinationnum", tpv_combinationnum); //组合号（计将卡）
        map.put("tpv_salenumsale", tpv_salenumsale); //对应销售合同号
        map.put("tpv_contractnos", contractnos); //合同号
        return map;
    }
}
