package tpv.tpv_wm.tpv_tm.java.formplugin.dynamic;

import com.alibaba.druid.util.StringUtils;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;

import java.math.BigDecimal;
import java.util.Date;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;


/**
 * ZYF
 * 策略号 （维护批复信息） 动态表单回填
 */
public class DatabackfillEdit extends AbstractBillPlugIn {


    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("btncancel", "btnok");
    }


    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        if (name.equals("tpv_validuntilapp") || name.equals("tpv_validuntilfrom")) {
            //批复有效期至
            Date tpv_validuntilapp = (Date) this.getModel().getValue("tpv_validuntilapp");
            if (tpv_validuntilapp == null) {
                return;
            }
            //批复有效期从
            Date tpv_validuntilfrom = (Date) this.getModel().getValue("tpv_validuntilfrom");
            if (tpv_validuntilfrom == null) {
                return;
            }
            if (tpv_validuntilapp.compareTo(tpv_validuntilfrom) >= 0) {
                this.getView().showErrorNotification("【批复有效期至】日期必须大于【批复有效期从】日期！");
                this.getModel().setValue("tpv_validuntilapp", null);
            }
        }
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Map<String, Object> map = new HashMap<>();
        Control source = (Control) evt.getSource();
        if (StringUtils.equals(source.getKey(), "btnok")) {
            //批复额度（吨）
            BigDecimal tpv_replylimit = (BigDecimal) this.getModel().getValue("tpv_replylimit");
            //批复预警值（元）
            BigDecimal tpv_pearlywarningvalue = (BigDecimal) this.getModel().getValue("tpv_pearlywarningvalue");
            //批复止损值（元）
            BigDecimal tpv_pstoplossvalue = (BigDecimal) this.getModel().getValue("tpv_pstoplossvalue");
            //批复有效期从
            Date tpv_validuntilfrom = (Date) this.getModel().getValue("tpv_validuntilfrom");
            //批复有效期至
            Date tpv_validuntilapp = (Date) this.getModel().getValue("tpv_validuntilapp");

            if (tpv_validuntilapp != null && tpv_validuntilfrom != null) {
                if (tpv_validuntilapp.compareTo(tpv_validuntilfrom) <= 0) {
                    this.getView().showErrorNotification("【批复有效期至】日期必须大于【批复有效期从】日期！");
                    this.getModel().setValue("tpv_validuntilapp", null);
                    return;
                }
            }

            map.put("tpv_replylimit", tpv_replylimit);
            map.put("tpv_pearlywarningvalue", tpv_pearlywarningvalue);
            map.put("tpv_pstoplossvalue", tpv_pstoplossvalue);
            map.put("tpv_validuntilfrom", tpv_validuntilfrom);
            map.put("tpv_validuntilapp", tpv_validuntilapp);
            this.getView().returnDataToParent(map);
            this.getView().close();
        } else if (StringUtils.equals(source.getKey(), "btncancel")) {
            this.getView().returnDataToParent(null);
            this.getView().close();
        }
    }

    /**
     * 打开动态表单之后获取原单数据
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        //打开动态表单
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> map = showParameter.getCustomParams();
        if (!map.isEmpty()) {
            Object tpv_replylimit = map.get("tpv_replylimit");
            Object tpv_pearlywarningvalue = map.get("tpv_pearlywarningvalue");
            Object tpv_pstoplossvalue = map.get("tpv_pstoplossvalue");
            Object tpv_validuntilfrom = map.get("tpv_validuntilfrom");
            Object tpv_validuntilapp = map.get("tpv_validuntilapp");


            this.getModel().setValue("tpv_replylimit", tpv_replylimit);
            this.getModel().setValue("tpv_pearlywarningvalue", tpv_pearlywarningvalue);
            this.getModel().setValue("tpv_pstoplossvalue", tpv_pstoplossvalue);
            this.getModel().setValue("tpv_validuntilfrom", tpv_validuntilfrom);
            this.getModel().setValue("tpv_validuntilapp", tpv_validuntilapp);
        }
    }
}
