package tpv.tpv_wm.tpv_tm.java.formplugin.dynamic;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import org.apache.commons.lang3.StringUtils;

import java.math.BigDecimal;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;


/**
 * WangShuGuang
 * 修改可套保数量动态表单
 */
public class ModificationEdit extends AbstractBillPlugIn {

    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addClickListeners("btncancel", "btnok"); //监听确认和取消按钮
    }

    @Override
    public void click(EventObject evt) {
        // TODO Auto-generated method stub
        super.click(evt);
        // 获取被点击的控件对象
        Control source = (Control) evt.getSource();
        // 点击确认按钮
        if (StringUtils.equals(source.getKey(), "btnok")) {
            HashMap<String, Object> dataBaseMap = new HashMap<>();
            // 如果被点击控件为确认，则获取页面相关控件值，组装数据传入returnData返回给父页面，最后关闭页面
            // 获取结算方式(套保)
            BigDecimal tpvCanqty = (BigDecimal) this.getModel().getValue("tpv_canqty");
            if (tpvCanqty.compareTo(BigDecimal.ZERO) != 0) {
                dataBaseMap.put("tpv_canqty", tpvCanqty);
            }
            FormShowParameter showParameter = this.getView().getFormShowParameter();
            Map<String, Object> gainDataMap = new HashMap<>();
            gainDataMap = showParameter.getCustomParams();

            String tpvContractnumber = (String) gainDataMap.get("tpv_contractnumber");
            String tpvSalorpur = (String) gainDataMap.get("tpv_salorpur");
//            if ("tpv_dt_purchase".equals(tpvSalorpur)){//采购合同
//                DynamicObject dtPurchase = BusinessDataServiceHelper.loadSingle(tpvSalorpur, new QFilter[]{new QFilter("tpv_contractnumber", "=", tpvContractnumber)});
//                dtPurchase.set("tpv_wehgua",true);
//                SaveServiceHelper.save(new DynamicObject[]{dtPurchase});
//            }
//            if ("tpv_dt_salescontract".equals(tpvSalorpur)){//销售合同(原始)
//                DynamicObject dtSalescontract = BusinessDataServiceHelper.loadSingle(tpvSalorpur, new QFilter[]{new QFilter("tpv_contractnos", "=", tpvContractnumber)});
//                dtSalescontract.set("tpv_wehgua",true);
//                SaveServiceHelper.save(new DynamicObject[]{dtSalescontract});
//            }
            this.getView().returnDataToParent(dataBaseMap);
            this.getView().close();
        } else if (StringUtils.equals(source.getKey(), "btncancel")) {
            // 被点击控件为取消则设置返回值为空并关闭页面（在页面关闭回调方法中必须验证返回值不为空，否则会报空指针）
            this.getView().returnDataToParent(null);
            this.getView().close();
        }
    }

    /**
     * 打开动态表单之后获取原单数据
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        // TODO Auto-generated method stub
        super.afterCreateNewData(e);
        // 打开动态表单
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> gainDataMap = new HashMap<>();
        gainDataMap = showParameter.getCustomParams();
        BigDecimal tpvCanqty = (BigDecimal) gainDataMap.get("tpv_canqty");//
        this.getModel().setValue("tpv_canqty", tpvCanqty);
    }
}
