package tpv.tpv_wm.tpv_tm.java.formplugin.dynamic;

import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.coderule.api.CodeRuleInfo;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.coderule.CodeRuleServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * @ClassName: NewnCompanyEdit
 * @Description: 新建并认领非我司点价记录
 * @author: zbh
 * @date: 2024-04-09
 */
public class NewnCompanyEdit extends AbstractBillPlugIn implements BeforeF7SelectListener {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok"});
        BasedataEdit tpv_breedname = this.getView().getControl("tpv_remcons");//品种名
        tpv_breedname.addBeforeF7SelectListener(this);
    }


    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_remcons"://品种名
                qFilterThisOrgCombin(e);
                break;
        }
    }

    private void qFilterThisOrgCombin(BeforeF7SelectEvent e) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<>();
        Date tpvBizdate = (Date) this.getModel().getValue("tpv_tradingday");
        if (tpvBizdate != null) {
            Date startOrEndDate = DateUtil.getStartOrEndDate(tpvBizdate, false);
            QFilters.add(new QFilter("tpv_effectivedate", ">=", startOrEndDate));
        }
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
                this.btnOk();
                break;
            case "btncancel":
                this.getView().returnDataToParent(null);
                this.getView().close();
                break;
        }
    }

    private void btnOk() {


        StringBuilder builder = new StringBuilder();
        DynamicObject remcons = (DynamicObject) this.getModel().getValue("tpv_remcons");//记录合约
        Date tradingday = (Date) this.getModel().getValue("tpv_tradingday");//交易日
        BigDecimal price = (BigDecimal) this.getModel().getValue("tpv_price");//单价
        BigDecimal tonssold = (BigDecimal) this.getModel().getValue("tpv_tonssold");//成交吨数
        if (remcons==null){
            stringBuilder(builder,"记录合约");
        }
        if (tradingday==null){
            stringBuilder(builder,"交易日");
        }
        if (price.compareTo(BigDecimal.ZERO)==0){
            stringBuilder(builder,"单价");
        }
        if (tonssold.compareTo(BigDecimal.ZERO)==0){
            stringBuilder(builder,"成交吨数");
        }
        if (builder.length()!=0){
            this.getView().showTipNotification("请填写"+builder+"!");
            return;
        }

        Object tpvRemcons = this.getModel().getValue("tpv_remcons");//记录合约
        Object tpvTradingday = this.getModel().getValue("tpv_tradingday");//交易日
        Object tpvPrice = this.getModel().getValue("tpv_price");//单价
        Object tpvTonssold = this.getModel().getValue("tpv_tonssold");//单价
        DynamicObject tpvTmDealrecord = ORM.create().newDynamicObject("tpv_tm_dealrecord");

        CodeRuleInfo codeRule = CodeRuleServiceHelper.getCodeRule("tpv_tm_dealrecord", tpvTmDealrecord, null);
        String billno = CodeRuleServiceHelper.getNumber(codeRule, tpvTmDealrecord);

        tpvTmDealrecord.set("tpv_operator", YEM.getCurrentUserId());//业务员
        tpvTmDealrecord.set("billstatus", "C");//单据状态
        tpvTmDealrecord.set("billno", billno);//单据编号
        tpvTmDealrecord.set("tpv_company", YEM.getCurrentOrgId());//公司
        tpvTmDealrecord.set("org", YEM.getCurrentOrgId());//组织
        tpvTmDealrecord.set("tpv_version", 1);//版本号
        tpvTmDealrecord.set("tpv_department", UserServiceHelper.getUserMainOrgId(YEM.getCurrentUserId()));//部门
        tpvTmDealrecord.set("tpv_bizdate", new Date());//业务日期
        tpvTmDealrecord.set("tpv_account", null);//账户
        tpvTmDealrecord.set("tpv_contractool", tpvRemcons);//合约池
        tpvTmDealrecord.set("tpv_tradeway", null);//买卖方向
        tpvTmDealrecord.set("tpv_openclosesign", null);//开平标志
        tpvTmDealrecord.set("tpv_deallots", null);//成交手数
        tpvTmDealrecord.set("tpv_dealton", tpvTonssold);//成交吨数
        tpvTmDealrecord.set("tpv_dealprice", tpvPrice);//成交价格
        tpvTmDealrecord.set("tpv_dealdate", tpvTradingday);//成交时间
        tpvTmDealrecord.set("tpv_processingfee", null);//手续费
        tpvTmDealrecord.set("tpv_varietyname", null);//品种名
        tpvTmDealrecord.set("tpv_contracmul", null);//合约乘数
        tpvTmDealrecord.set("tpv_recorddate", new Date());//记录时间
        tpvTmDealrecord.set("tpv_amcunit", null);//账户归属管理单元
        tpvTmDealrecord.set("tpv_srcbillway", "B");//数据来源
        tpvTmDealrecord.set("tpv_insuresign", "UPSTREAM");//投保标志
        tpvTmDealrecord.set("tpv_claimablesnapin", null);//可认领管理单元
        tpvTmDealrecord.set("tpv_claimcqqty", null);//已认领数量(苍穹)
        tpvTmDealrecord.set("tpv_claimnbqty", null);//已认领数量(南北)
        SaveServiceHelper.save(new DynamicObject[]{tpvTmDealrecord});

        DynamicObject dealrecord = BusinessDataServiceHelper.loadSingle(tpvTmDealrecord.getPkValue(), "tpv_tm_dealrecord");
        IFormView view = this.getView();
        IFormView parentView = view.getParentView();
        IDataModel parentmodel = parentView.getModel();
        DynamicObject parentDataEntity = parentmodel.getDataEntity(true);
        String name = parentDataEntity.getDynamicObjectType().getName();
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> maps = showParameter.getCustomParams();
        String key = (String) maps.get("key");

        DynamicObject tmClaimdetails = ORM.create().newDynamicObject("tpv_tm_claimdetails");
        CodeRuleInfo codeRules = CodeRuleServiceHelper.getCodeRule("tpv_tm_claimdetails", tmClaimdetails, null);
        String billnos = CodeRuleServiceHelper.getNumber(codeRules, tmClaimdetails);
        tmClaimdetails.set("billno", billnos);//单据编号
        tmClaimdetails.set("billstatus", "C");//单据状态

//        tmClaimdetails.set("tpv_basegoods", dataEntity.getDynamicObject("tpv_baseprice"));//基价商品
//        tmClaimdetails.set("tpv_region", dataEntity.getDynamicObject("tpv_region"));//大区
//        tmClaimdetails.set("tpv_combination", dataEntity.getDynamicObject("tpv_combination"));//组合号
//        tmClaimdetails.set("tpv_operators", dataEntity.getDynamicObject("tpv_user"));//人员

        tmClaimdetails.set("tpv_operator", YEM.getCurrentUserId());//业务员
        tmClaimdetails.set("tpv_company", YEM.getCurrentOrgId());//公司
        tmClaimdetails.set("org", YEM.getCurrentOrgId());//公司
        tmClaimdetails.set("tpv_version", 1);//版本号
        tmClaimdetails.set("tpv_department", UserServiceHelper.getUserMainOrgId(YEM.getCurrentUserId()));//部门
        tmClaimdetails.set("tpv_bizdate", new Date());//业务日期
        tmClaimdetails.set("tpv_claimlogo", "A");//认领标志
//        tmClaimdetails.set("tpv_redflush", "A");//红冲标志
        tmClaimdetails.set("tpv_orderprice", null);//是否点价
//            tmClaimdetails.set("tpv_ponumbers",null);//点价单号
        tmClaimdetails.set("tpv_categories", "A");//业务大类
//            tmClaimdetails.set("tpv_coverup",null);//是否代客套保

        tmClaimdetails.set("tpv_recordnum", dealrecord.get("billno"));//记录号  成交记录单的单据编号
        tmClaimdetails.set("tpv_contractool", dealrecord.get("tpv_contractool"));//记录合约
        tmClaimdetails.set("tpv_dealprice", dealrecord.get("tpv_dealprice"));//成交价格
        tmClaimdetails.set("tpv_dealton", dealrecord.get("tpv_dealton"));//交易吨数
        tmClaimdetails.set("tpv_tradeway", dealrecord.get("tpv_tradeway"));//交易方向
//            tmClaimdetails.set("tpv_openclosesign",tpvDetail.get(selectRow).get(""));//开平
        tmClaimdetails.set("tpv_dealdate",dealrecord.get("tpv_dealdate"));//成交时间
        tmClaimdetails.set("tpv_dealdateday",dealrecord.get("tpv_recorddate"));//交易日
//            tmClaimdetails.set("tpv_account",tpvDetail.get(selectRow).get(""));//账户
        tmClaimdetails.set("tpv_amcunit", dealrecord.get("tpv_amcunit"));//账户管理单元
        tmClaimdetails.set("tpv_processingfee", dealrecord.get("tpv_processingfee"));//手续费


        tmClaimdetails.set("tpv_srcbillway", "B");//数据来源
        tmClaimdetails.set("createtime", new Date());//创建时间
        tmClaimdetails.set("tpv_datetime", new Date());//认领时间
        tmClaimdetails.set("tpv_coverup", key.contains("dk") ? true : false);//是否代客套保
        tmClaimdetails.set("creator", YEM.getCurrentUserId());//创建人
        if ("tpv_tm_positionorder".equals(name)) {//头寸业务单
            positionorder(parentmodel, tmClaimdetails, key);
        } else if ("tpv_dt_purchase".equals(name) || "tpv_dt_salescontract".equals(name)) {//采购合同 销售合同
            purOrSale(parentmodel, tmClaimdetails, name, key);
        } else if ("tpv_tm_kyoping".equals(name)) {//协平单
            kyoping(parentmodel, tmClaimdetails, name, key);
        }
        SaveServiceHelper.save(new DynamicObject[]{tpvTmDealrecord});
        SaveServiceHelper.save(new DynamicObject[]{tmClaimdetails});

        this.getView().returnDataToParent("success" );
        this.getView().close();
    }

    private void positionorder(IDataModel parentmodel, DynamicObject tmClaimdetails, String key) {
        String tpvSourcebillkey = (String) parentmodel.getValue("tpv_sourcebillkey");//来源单据标识
        Long tpvSourcebillid = (Long) parentmodel.getValue("tpv_sourcebillid");//来源单据id
        String tpvSourcebillno = (String) parentmodel.getValue("billno");//来源单据号
        DynamicObject tpvCombinationnum = (DynamicObject) parentmodel.getValue("tpv_combinationnum");//组合号
        String tpvHedgetype = (String) parentmodel.getValue("tpv_hedgetype");//套保类型

        DynamicObject tpvStrategynum = (DynamicObject) parentmodel.getValue("tpv_strategynum");//策略号
        DynamicObject tpvDepartment = (DynamicObject) parentmodel.getValue("tpv_department");//部门
        DynamicObject tpvOperator = (DynamicObject) parentmodel.getValue("tpv_operator");//业务员
        DynamicObject tpvBasegoods = (DynamicObject) parentmodel.getValue("tpv_basegoods");//基价商品
        BigDecimal tpvBaseprices = (BigDecimal) parentmodel.getValue("tpv_baseprices");//基价价格

        if ("tpv_dt_purchase".equals(tpvSourcebillkey)) {//采购
            tmClaimdetails.set("tpv_contracttype", "采购合同");//合同类型
            tmClaimdetails.set("tpv_prcontractnum", tpvSourcebillid);//采购合同号
            DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(tpvSourcebillid, tpvSourcebillkey);
            tmClaimdetails.set("tpv_contractsup", loadSingle == null ? null : loadSingle.get("tpv_supplier"));//合同供应商
        } else if ("tpv_dt_salescontract".equals(tpvSourcebillkey)) {//销售
            tmClaimdetails.set("tpv_contracttype", "销售合同");//合同类型
            tmClaimdetails.set("tpv_sacontractnum", tpvSourcebillid);//销售合同号
            DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(tpvSourcebillid, tpvSourcebillkey);
            tmClaimdetails.set("tpv_contractcus", loadSingle == null ? null : loadSingle.get("tpv_customer"));//合同客户
        }
        tmClaimdetails.set("tpv_combination", tpvCombinationnum);//组合号
        tmClaimdetails.set("tpv_hedgetype", tpvHedgetype);//套保类型
        tmClaimdetails.set("tpv_strategyname", tpvStrategynum);//策略名称
        tmClaimdetails.set("tpv_basegoods", tpvBasegoods);//基价商品
        tmClaimdetails.set("tpv_contractbaseprice", tpvBaseprices);//合同基价
        tmClaimdetails.set("tpv_departments", tpvDepartment);//认领部门
        tmClaimdetails.set("tpv_people", tpvOperator);//人员
        tmClaimdetails.set("tpv_superiornums", parentmodel.getDataEntity(true).get("tpv_sourcebillno"));//上级单据号
        tmClaimdetails.set("tpv_datasourcess", "tpv_tm_positionorder");//数据来源
        tmClaimdetails.set("tpv_datasourcesnum", tpvSourcebillno);//来源单据号
        tmClaimdetails.set("tpv_datasourcesid", tpvSourcebillid);//来源单据id
        tmClaimdetails.set("tpv_warehouse", "tpv_removeclaim".equals(key) ? true : false);//是否移仓认领
    }
    private void purOrSale(IDataModel parentmodel, DynamicObject tmClaimdetails, String name, String key) {
        Map<String, String> fieldName = entryFieldName(name);
        DynamicObject dataEntity = parentmodel.getDataEntity(true);

        DynamicObject tpvCombinationnum = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_combinationnum"));//组合号
        DynamicObject tpvStrategynum = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_strategynum"));//策略号
        DynamicObject tpvDepartment = (DynamicObject) parentmodel.getValue("tpv_department");//部门
        DynamicObject tpvOperator = (DynamicObject) parentmodel.getValue("tpv_operator");//业务员
        DynamicObject tpvBasegoods = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_basegoods"));//基价商品
        BigDecimal tpvBaseprices = (BigDecimal) parentmodel.getValue(fieldName.get("tpv_baseprices"));//基价价格

        if ("tpv_dt_purchase".equals(name)) {//采购
            tmClaimdetails.set("tpv_contracttype", "采购合同");//合同类型
            tmClaimdetails.set("tpv_prcontractnum", dataEntity);//采购合同号
            tmClaimdetails.set("tpv_contractsup", dataEntity.get("tpv_supplier"));//合同供应商
        } else if ("tpv_dt_salescontract".equals(name)) {//销售
            tmClaimdetails.set("tpv_contracttype", "销售合同");//合同类型
            tmClaimdetails.set("tpv_sacontractnum", dataEntity);//销售合同号
            tmClaimdetails.set("tpv_contractcus", dataEntity.get("tpv_customer"));//合同客户
        }
        tmClaimdetails.set("tpv_combination", tpvCombinationnum);//组合号
        tmClaimdetails.set("tpv_hedgetype", tpvStrategynum == null ? null : tpvStrategynum.get("tpv_hedgetype"));//套保类型
        tmClaimdetails.set("tpv_strategyname", tpvStrategynum);//策略名称
        tmClaimdetails.set("tpv_basegoods", tpvBasegoods);//基价商品
        tmClaimdetails.set("tpv_contractbaseprice", tpvBaseprices);//合同基价
        tmClaimdetails.set("tpv_departments", tpvDepartment);//认领部门
        tmClaimdetails.set("tpv_people", tpvOperator);//人员
        tmClaimdetails.set("tpv_superiornums", dataEntity.get("billno"));//上级单据号
        tmClaimdetails.set("tpv_datasourcess", name);//数据来源
        tmClaimdetails.set("tpv_datasourcesnum", dataEntity.get("billno"));//来源单据号
        tmClaimdetails.set("tpv_datasourcesid", dataEntity.getPkValue());//来源单据id
        tmClaimdetails.set("tpv_warehouse", key.contains("tpv_removeclaim") ? true : false);//是否移仓认领
    }
    private void kyoping(IDataModel parentmodel, DynamicObject tmClaimdetails, String name, String key) {
        Map<String, String> fieldName = entryFieldName(name);
        DynamicObject dataEntity = parentmodel.getDataEntity(true);

        String tpvCorebillno = dataEntity.getString("tpv_corebillno");//来源单据id
        String tpvSourcebillkey = dataEntity.getString("tpv_sourcebillkey");//来源单据标识
        DynamicObject tpvCombinationnum = (DynamicObject) parentmodel.getValue(fieldName.get("tpv_combinationnum"));//组合号
        DynamicObject tpvDepartment = (DynamicObject) parentmodel.getValue("tpv_department");//部门
        DynamicObject tpvOperator = (DynamicObject) parentmodel.getValue("tpv_operator");//业务员
        DynamicObject bdStrategy = BusinessDataServiceHelper.loadSingle("tpv_bd_strategy", new QFilter[]{new QFilter("name", QCP.ftlike, "%" + name + "%")});

        if (YEM.isNotEmpty(tpvCorebillno) && "tpv_dt_purchase".equals(tpvSourcebillkey)) {//采购
            DynamicObject loadSingle = BusinessDataServiceHelper.loadSingle(tpvCorebillno, tpvSourcebillkey);
            tmClaimdetails.set("tpv_contractsup", loadSingle == null ? null : loadSingle.get("tpv_supplier"));//合同供应商 1
            tmClaimdetails.set("tpv_prcontractnum", loadSingle);//采购合同号
        }
        tmClaimdetails.set("tpv_contracttype", "协平单");//合同类型
        tmClaimdetails.set("tpv_combination", tpvCombinationnum);//组合号
        tmClaimdetails.set("tpv_strategyname", bdStrategy);//策略名称
        tmClaimdetails.set("tpv_hedgetype", bdStrategy == null ? null : bdStrategy.get("tpv_hedgetype"));//套保类型
        tmClaimdetails.set("tpv_departments", tpvDepartment);//认领部门
        tmClaimdetails.set("tpv_people", tpvOperator);//人员
        tmClaimdetails.set("tpv_superiornums", tpvCorebillno);//上级单据号
        tmClaimdetails.set("tpv_datasourcess", name);//数据来源
        tmClaimdetails.set("tpv_datasourcesnum", dataEntity.get("billno"));//来源单据号
        tmClaimdetails.set("tpv_datasourcesid", dataEntity.getPkValue());//来源单据id
        tmClaimdetails.set("tpv_warehouse", key.contains("tpv_removeclaim") ? true : false);//是否移仓认领
    }

    public static Map<String, String> entryFieldName(String entityName) {
        Map<String, String> map = new HashMap<>();
        String tpv_strategynum = "";//策略号
        String tpv_salesregion = "";//销售大区
        String tpv_basegoods = "";//基价商品
        String tpv_baseprices = "";//基价价格
        String tpv_combinationnum = "";//组合号
        String tpv_salenumsale = "";//对应销售合同号
        switch (entityName) {
            case "tpv_dt_purchase": //采购合同
                tpv_strategynum = "tpv_policynumber";
                tpv_salesregion = "tpv_salesarea";
                tpv_basegoods = "tpv_basepriceitems";
                tpv_baseprices = "tpv_baseprice";
                tpv_combinationnum = "tpv_combinationnumber";//组合号
                break;
            case "tpv_dt_salescontract"://销售合同(原始)
                tpv_strategynum = "tpv_strategynum";
                tpv_salesregion = "tpv_salesregion";
                tpv_basegoods = "tpv_basegoods";
                tpv_baseprices = "tpv_baseprices";
                tpv_combinationnum = "tpv_combinationnumber";//组合号
                break;
            case "tpv_claimdk"://合同结转单  代客套保 认领
                tpv_strategynum = "tpv_salestrategynum";
                tpv_combinationnum = "tpv_combinationsale";
                tpv_salenumsale = "tpv_salenumsale";
                break;
            case "tpv_claim"://合同结转单  主动套保 认领
                tpv_strategynum = "tpv_strategynum";
                tpv_combinationnum = "tpv_combinationnum";
                tpv_salenumsale = "tpv_salenum";
                break;
            case "tpv_tm_conttranform"://合同结转单
                tpv_strategynum = "tpv_salestrategynum";
                break;
            case "tpv_tm_kyoping"://协平单
                tpv_strategynum = "tpv_policynum";//策略号
                tpv_combinationnum = "tpv_combinationnumber";//组合号
                break;
            case "tpv_tm_positionorder":
                tpv_strategynum = "tpv_strategynum";
                tpv_salesregion = "tpv_salesregion";
                tpv_basegoods = "tpv_basegoods";
                tpv_baseprices = "tpv_baseprices";
                tpv_combinationnum = "tpv_combinationnum";//组合号
                break;
        }
        map.put("tpv_strategynum", tpv_strategynum); //策略号
        map.put("tpv_salesregion", tpv_salesregion); //销售大区
        map.put("tpv_basegoods", tpv_basegoods); //基价商品
        map.put("tpv_baseprices", tpv_baseprices); //基价价格
        map.put("tpv_combinationnum", tpv_combinationnum); //组合号
        map.put("tpv_salenumsale", tpv_salenumsale); //对应销售合同号
        return map;
    }
    public void stringBuilder(StringBuilder stringBuilder, String basePrice){
        if (stringBuilder.length()==0){
            stringBuilder.append(basePrice);
        }else {
            stringBuilder.append("，"+basePrice);
        }
    }
}
