package tpv.tpv_wm.tpv_tm.java.formplugin.dynamic;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.form.FormShowParameter;
import kd.bos.form.control.Control;
import org.apache.commons.lang3.StringUtils;

import java.util.Date;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * WangShuGuang
 * 周期价格确认动态表单
 */
public class PeriodPriceEdit extends AbstractBillPlugIn {

    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addClickListeners("btnok", "btncancel"); //监听确认和取消按钮
    }

    @Override
    public void click(EventObject evt) {
        // TODO Auto-generated method stub
        super.click(evt);
        // 获取被点击的控件对象
        Control source = (Control) evt.getSource();
        // 点击确认按钮
        if (StringUtils.equals(source.getKey(), "btnok")) {
            HashMap<String, Object> dataBaseMap = new HashMap<>();
            // 如果被点击控件为确认，则获取页面相关控件值，组装数据传入returnData返回给父页面，最后关闭页面
            // 获取结算方式(套保)
            String tpvSettleway = (String) this.getModel().getValue("tpv_settleway");
            // 获取规则
            String tpvRule = (String) this.getModel().getValue("tpv_rule");
            // 获取定价周期开始日
            Date tpvPricingstart = (Date) this.getModel().getValue("tpv_pricingstart");
            // 获取定价周期终止日
            Date tpvPricingend = (Date) this.getModel().getValue("tpv_pricingend");
            if (StringUtils.isNotBlank(tpvSettleway)) {
                dataBaseMap.put("tpv_settleway", tpvSettleway);
            }else {
                this.getView().showMessage("请填写【结算方式(套保)】");
                return;
            }
            if (StringUtils.isNotBlank(tpvRule)) {
                dataBaseMap.put("tpv_rule", tpvRule);
            }
            if (null != tpvPricingstart) {
                dataBaseMap.put("tpv_pricingstart", tpvPricingstart);
            }
            if (null != tpvPricingend) {
                dataBaseMap.put("tpv_pricingend", tpvPricingend);
            }
            if (StringUtils.isNotBlank(tpvSettleway) && "B".equals(tpvSettleway)) {
                if (null == tpvPricingend && null == tpvPricingstart && StringUtils.isBlank(tpvRule)) {
                    this.getView().showMessage("请填写[规则],[定价周期开始日],[定价周期终止日]字段再点击确定");
                    return;
                } else if (null == tpvPricingend && null == tpvPricingstart && StringUtils.isNotBlank(tpvRule)) {
                    this.getView().showMessage("请填写[定价周期开始日],[定价周期终止日]字段再点击确定");
                    return;
                } else if (null == tpvPricingend && null != tpvPricingstart && StringUtils.isBlank(tpvRule)) {
                    this.getView().showMessage("请填写[规则],[定价周期终止日]字段再点击确定");
                    return;
                } else if (null != tpvPricingend && null == tpvPricingstart && StringUtils.isBlank(tpvRule)) {
                    this.getView().showMessage("请填写[规则],[定价周期开始日]字段再点击确定");
                    return;
                } else if (null == tpvPricingend && null != tpvPricingstart && StringUtils.isNotBlank(tpvRule)) {
                    this.getView().showMessage("请填写[定价周期终止日]字段再点击确定");
                    return;
                } else if (null != tpvPricingend && null == tpvPricingstart && StringUtils.isNotBlank(tpvRule)) {
                    this.getView().showMessage("请填写[定价周期开始日]字段再点击确定");
                    return;
                } else if (null != tpvPricingend && null != tpvPricingstart && StringUtils.isBlank(tpvRule)) {
                    this.getView().showMessage("请填写[规则]字段再点击确定");
                    return;
                }
            }
            this.getView().returnDataToParent(dataBaseMap);
            this.getView().close();
        } else if (StringUtils.equals(source.getKey(), "btncancel")) {
            // 被点击控件为取消则设置返回值为空并关闭页面（在页面关闭回调方法中必须验证返回值不为空，否则会报空指针）
            this.getView().returnDataToParent(null);
            this.getView().close();
        }
    }

    /**
     * 打开动态表单之后获取原单数据
     */
    @Override
    public void afterCreateNewData(EventObject e) {
        // TODO Auto-generated method stub
        super.afterCreateNewData(e);
        // 打开动态表单
        FormShowParameter showParameter = this.getView().getFormShowParameter();
        Map<String, Object> gainDataMap = new HashMap<>();
        gainDataMap = showParameter.getCustomParams();
        String tpvSettleway = (String) gainDataMap.get("tpv_settleway");//
        String tpvRule = (String) gainDataMap.get("tpv_rule");//
        this.getModel().setValue("tpv_settleway", tpvSettleway);
        this.getModel().setValue("tpv_rule", tpvRule);
        this.getModel().setValue("tpv_pricingstart", gainDataMap.get("tpv_pricingstart"));
        this.getModel().setValue("tpv_pricingend", gainDataMap.get("tpv_pricingend"));
    }
}
