package tpv.tpv_wm.tpv_tm.java.formplugin.dynamic;

import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.EventObject;

/**
 * @ClassName 仓单质押动态查询
 * @Description TODO
 * @Author yang
 * @Date 2023/8/8 18:00
 * @Version 1.0
 */
public class PledgeEdit extends AbstractFormPlugin {
    /**
     * @return
     * @description 初始化
     * @author yhj
     * @date 2023/11/17 14:42
     * @param    null
     */
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        IDataModel model = this.getView().getModel();
        String value = (String) model.getValue("billstatus");
        if ("C".equals(value)) {
            dyNamic();//动态展示仓单解押数据
        }
    }
    /**
     * @return
     * @description 动态赋值
     * @author yhj
     * @date 2023/11/17 14:42
     * @param    null
     */
    private void dyNamic() {
        String value = (String) this.getModel().getValue("billno");
        QFilter[] qFilter = new QFilter[] {new QFilter("billstatus", QCP.equals, "C"),
                new QFilter("tpv_sourcebillno", QCP.equals, value)};
        String selectStrjy = DynamicObjectUtil.getSelectfields("tpv_dt_salescontract", false);
        selectStrjy = DynamicObjectUtil.getEntrySelectfields(selectStrjy,"tpv_tm_storagerelmort","tpv_materialentry",false);
        DynamicObject[] queryJY = BusinessDataServiceHelper.load("tpv_tm_storagerelmort", selectStrjy,qFilter);
        IDataModel model = this.getModel();
        for (DynamicObject obj:queryJY) {
            DynamicObjectCollection entry = obj.getDynamicObjectCollection("tpv_materialentry");
            BigDecimal sumQty = BigDecimal.ZERO;
            for (DynamicObject entity:entry) {
                sumQty = sumQty.add(entity.getBigDecimal("tpv_qty"));
            }
            int newEntryRow = this.getModel().createNewEntryRow("tpv_entryentity");//货物流转分录
            model.setValue("tpv_releasecode", obj.getString("billno"), newEntryRow);//解押编号
            model.setValue("tpv_releasedate", obj.getDate("tpv_bizdate"), newEntryRow);//解押日期
            model.setValue("tpv_releasenum", sumQty, newEntryRow);//解押数量
        }
    }
}
