package tpv.tpv_wm.tpv_tm.java.formplugin.dynamic;

import com.itopview.wm.utils.*;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.control.events.RowClickEvent;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import tpv.tpv_wm.tpv_dt.java.utils.PersonnelDepUtils;

import java.math.BigDecimal;
import java.util.*;

/**
 * @ClassName: PolicyclaimEdit
 * @Description: 策略认领工作台表单插件
 * @author: zbh
 * @date: 2024-04-07
 */
public class PolicyclaimEdit extends AbstractFormPlugin implements RowClickEventListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        addClickListeners("tpv_canclaim", "tpv_advcontoolbarap", "tpv_inquire", "tpv_claim", "tpv_advcontoolbarap1", "tpv_inquirecl");
        addItemClickListeners("tpv_canclaim", "tpv_advcontoolbarap", "tpv_inquire", "tpv_claim", "tpv_advcontoolbarap1", "tpv_inquirecl");
        this.addClickListeners(new String[]{"tpv_inquire", "tpv_claim"});

        EntryGrid entryGrid = this.getView().getControl("tpv_westrategy");//待匹配策略号
        entryGrid.addRowClickListener(this);
    }


    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        claim();
        calin(0);
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_strategynum":
            case "tpv_stratetype":
            case "tpv_basegoods":
            case "tpv_salesregion":
            case "tpv_operator":
            case "tpv_creator":
            case "tpv_trategytext":
//                claim();
//                calin(0);
                break;
        }

    }

    private void calin(long tpvStrategyid) {//交易记录认领明细
        this.getModel().deleteEntryData("tpv_calin");
        String selectfields = DynamicObjectUtil.getSelectfields("tpv_tm_claimdetails", false);
        IDataModel model = this.getModel();
        QFilter qFilter = new QFilter("billstatus", QCP.in, new String[]{"A", "B", "C"});//方向  策略号
        qFilter.and(new QFilter("tpv_redflush", QCP.not_in, new String[]{"A", "B"}));
        DynamicObject tpvOperator = (DynamicObject) model.getValue("tpv_operator");//业务员
        if (tpvOperator != null) {
            qFilter.and(new QFilter("tpv_operator.id", "=", tpvOperator.getPkValue()));//业务员
        }
        DynamicObject creator = (DynamicObject) model.getValue("tpv_creator");//制单人
        if (creator != null) {
            qFilter.and(new QFilter("creator.id", "=", creator.getPkValue()));
        }
        DynamicObject tpvBasegoods = (DynamicObject) model.getValue("tpv_basegoods");//基价商品
        if (tpvBasegoods != null) {
            qFilter.and(new QFilter("tpv_basegoods.id", "=", tpvBasegoods.getPkValue()));
        }
        DynamicObject tpvSalesregion = (DynamicObject) model.getValue("tpv_salesregion");//大区
        if (tpvSalesregion != null) {
            qFilter.and(new QFilter("tpv_region.id", "=", tpvSalesregion.getPkValue()));
        }
        EntryGrid entryGrid = this.getControl("tpv_westrategy");
        int[] selectRows = entryGrid.getSelectRows();
        DynamicObjectCollection tpvWestrategy =this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_westrategy");
        if (selectRows.length!=0){
            String tpvStrateg = tpvWestrategy.get(selectRows[0]).getString("tpv_strateg");
            if ("tpv_bd_strategy".equals(tpvStrateg)){
                if (tpvStrategyid != 0) {
                    qFilter.and(new QFilter("tpv_strategyname.id", "=", tpvStrategyid));
                }
            }else if ("tpv_cushedgemagereq".equals(tpvStrateg)){
                if (tpvStrategyid != 0) {
                    qFilter.and(new QFilter("tpv_cushedgemagereq.id", "=", tpvStrategyid));
                }
            }
        }
        QFilter deparQFilter = PersonnelDepUtils.departmentQFilter(model, "tpv_muldepartment", "tpv_department");
        if (deparQFilter != null) {
            qFilter.and(deparQFilter);
        }
        DynamicObject[] tmClaimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", selectfields, qFilter.toArray(), "createtime desc");
        for (DynamicObject tmClaimdetail : tmClaimdetails) {
            int row = this.getModel().createNewEntryRow("tpv_calin");
            this.getModel().setValue("tpv_srcbillway", tmClaimdetail.get("tpv_srcbillway"), row);//数据来源
            this.getModel().setValue("tpv_recordnum", tmClaimdetail.get("tpv_recordnum"), row);//记录号
            this.getModel().setValue("tpv_contractool", tmClaimdetail.get("tpv_contractool"), row);//合约代码
            this.getModel().setValue("tpv_dealprice", tmClaimdetail.get("tpv_dealprice"), row);//成交价格
            this.getModel().setValue("tpv_dealton", tmClaimdetail.get("tpv_dealton"), row);//交易数量
            this.getModel().setValue("tpv_claimdetails", tmClaimdetail.get("tpv_claimdetails"), row);//本次认领数量
            this.getModel().setValue("tpv_region", tmClaimdetail.get("tpv_region"), row);//大区
            this.getModel().setValue("tpv_basegoodss", tmClaimdetail.get("tpv_basegoods"), row);//基价商品
            this.getModel().setValue("tpv_operators", tmClaimdetail.get("tpv_operators"), row);//策略业务员
            this.getModel().setValue("tpv_tradeway", tmClaimdetail.get("tpv_tradeway"), row);//交易方向
            this.getModel().setValue("tpv_dealdateday", tmClaimdetail.get("tpv_dealdateday"), row);//交易日
            this.getModel().setValue("tpv_dealdate", tmClaimdetail.get("tpv_dealdate"), row);//成交时点
            this.getModel().setValue("tpv_warehouse", tmClaimdetail.get("tpv_warehouse"), row);//是否移仓
            this.getModel().setValue("tpv_hedgetypes", tmClaimdetail.get("tpv_hedgetype"), row);//套保类型
            this.getModel().setValue("tpv_creators", tmClaimdetail.get("creator"), row);//创建人
            this.getModel().setValue("tpv_datefi", tmClaimdetail.get("createtime"), row);//匹配时间
            this.getModel().setValue("tpv_sourceid", tmClaimdetail.getPkValue(), row);//来源单据id
            this.getModel().setValue("tpv_billno", tmClaimdetail.get("billno"), row);//来源单据编号
        }
    }

    private void claim() {//待匹配策略号
        this.getModel().deleteEntryData("tpv_westrategy");
        IDataModel model = this.getModel();
        QFilter qFilter = new QFilter("tpv_whetherhedged", "=", true);//方向  策略号
        QFilter qFilterCus = new QFilter("tpv_iotraders.tpv_iotype", "=", "bd_customer");//代客套保
        qFilter.and("status", "=", "C");
        qFilterCus.and("billstatus", "=", "C");
        String tpvTrategytext = (String) model.getValue("tpv_trategytext");//策略号
        if (YEM.isNotEmpty(tpvTrategytext)) {
            qFilter.and(new QFilter("name", QCP.ftlike, "%" + tpvTrategytext + "%"));//策略号
        }
//        DynamicObject tpvBasegoods = (DynamicObject) model.getValue("tpv_basegoods");//基价商品
//        if (tpvBasegoods != null) {
//            qFilter.and(new QFilter("tpv_whetherhedged.id", "=", tpvBasegoods.getPkValue()));
//        }
        DynamicObject tpvOperator = (DynamicObject) model.getValue("tpv_operator");//业务员
        if (tpvOperator != null) {
            qFilter.and(new QFilter("tpv_operator.id", "=", tpvOperator.getPkValue()));
            qFilterCus.and(new QFilter("tpv_operator.id", "=", tpvOperator.getPkValue()));
        }
        DynamicObject creator = (DynamicObject) model.getValue("tpv_creator");//创建人
        if (creator != null) {
            qFilter.and(new QFilter("creator.id", "=", creator.getPkValue()));
            qFilterCus.and(new QFilter("creator.id", "=", creator.getPkValue()));
        }
        DynamicObject tpvSalesregion = (DynamicObject) model.getValue("tpv_salesregion");//大区
        if (tpvSalesregion != null) {
            qFilter.and(new QFilter("tpv_spotarea.fbasedataid", "=", tpvSalesregion.getPkValue()));
        }

        QFilter departmentQFilter = PersonnelDepUtils.departmentQFilter(model, "tpv_muldepartment", "tpv_departmentorg");
        if (departmentQFilter != null) {
            qFilter.and(departmentQFilter);
        }
        QFilter deparQFilter = PersonnelDepUtils.departmentQFilter(model, "tpv_muldepartment", "tpv_department");
        if (deparQFilter != null) {
            qFilterCus.and(deparQFilter);
        }
        String tpvStratetype = (String) model.getValue("tpv_stratetype");//策略类型
        if ("".equals(tpvStratetype) || "A".equals(tpvStratetype) || tpvStratetype == null) {
            String selectfields = DynamicObjectUtil.getSelectfields("tpv_bd_strategy", false);
            DynamicObject[] tpvBdStrategies = BusinessDataServiceHelper.load("tpv_bd_strategy", selectfields, qFilter.toArray());
            List<Long> ids = new ArrayList<>();
            for (DynamicObject tpvBdStrategy : tpvBdStrategies) {
                ids.add(tpvBdStrategy.getLong("id"));
            }
            DataSet purchase = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_purchase", "id,tpv_contractnumber,tpv_policynumber.id policyid," +
                            "tpv_policynumber.number policynumber,tpv_materialentry,tpv_materialentry.tpv_qty qty",
                    new QFilter[]{new QFilter("tpv_contractstatusx", QCP.in, new String[]{"A", "B", "C", "D", "F", "G"})
                            .and(new QFilter("tpv_policynumber.id", QCP.in, ids))}).select("policyid policyid","qty purqty","0.0 saleqty");
            DataSet salescontract = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_salescontract", "id,tpv_contractnos,tpv_strategynum.id strategyid," +
                            "tpv_strategynum.number strategynum,tpv_materialentry,tpv_materialentry.tpv_qty qty",
                    new QFilter[]{new QFilter("tpv_contractstatus", QCP.in, new String[]{"A","B","C","D","G","H"})
                            .and(new QFilter("tpv_strategynum.id", QCP.in, ids))}).select("strategyid policyid","qty saleqty","0.0 purqty");
            DataSet dataSet = purchase.union(salescontract).groupBy(new String[]{"policyid"}).sum("saleqty").sum("purqty").finish();
            dataSet = RptUtil.zeroNullNums(dataSet);
            dataSet = dataSet.addField("(purqty - saleqty) qty", "qty");
            Map<Long, BigDecimal> map = new HashMap<>();
            if (!dataSet.isEmpty()) {
                for (Row row : dataSet) {
                    if (!map.containsKey(row.getLong("policyid"))) {
                        map.put(row.getLong("policyid"), row.getBigDecimal("qty").setScale(2, BigDecimal.ROUND_HALF_UP).abs());
                    }
                }
            }
            for (DynamicObject tpvBdStrategy : tpvBdStrategies) {
                int row = this.getModel().createNewEntryRow("tpv_westrategy");
                String tpvValidfrom = "";
                if (tpvBdStrategy.getDate("tpv_validfrom") != null) {
                    String tpv_validfrom = DateUtil.formatDate(tpvBdStrategy.getDate("tpv_validfrom"), DateUtil.FORMAT_YMD);
                    tpvValidfrom = tpvValidfrom + tpv_validfrom;//有效期从
                }
                String tpvValiduntil = "";
                if (tpvBdStrategy.getDate("tpv_validuntil") != null) {
                    String tpv_validfrom = DateUtil.formatDate(tpvBdStrategy.getDate("tpv_validuntil"), DateUtil.FORMAT_YMD);
                    tpvValiduntil = tpvValiduntil + tpv_validfrom;//有效期至
                }
                Long id = tpvBdStrategy.getLong("id");
                BigDecimal tpvReplylimit = BigDecimalUtils.toBigDecimal(tpvBdStrategy.getBigDecimal("tpv_replylimit")).setScale(2, BigDecimal.ROUND_HALF_UP);
                if (map.containsKey(id)) {
                    BigDecimal qty = BigDecimalUtils.toBigDecimal(map.get(id));
                    this.getModel().setValue("tpv_openposition", tpvReplylimit.subtract(qty), row);//可开仓量
                    this.getModel().setValue("tpv_positionnums", qty, row);//持仓量
                }
                this.getModel().setValue("tpv_name", tpvBdStrategy.get("name"), row);//策略名称
                this.getModel().setValue("tpv_hedgetype", tpvBdStrategy.get("tpv_hedgetype"), row);//套保类型
                this.getModel().setValue("tpv_replylimit", tpvBdStrategy.get("tpv_replylimit"), row);//批复额度（吨）
                this.getModel().setValue("tpv_valdate", tpvValidfrom + "~" + tpvValiduntil, row);//有效期限
                this.getModel().setValue("tpv_tclientext", tpvBdStrategy.getDynamicObject("tpv_client") == null ? "" : tpvBdStrategy.getDynamicObject("tpv_client").getString("name"), row);//客户
                this.getModel().setValue("tpv_department", tpvBdStrategy.get("tpv_departmentorg"), row);//部门
                this.getModel().setValue("tpv_org", tpvBdStrategy.get("createorg"), row);//公司
                this.getModel().setValue("tpv_strategyid", tpvBdStrategy.getLong("id"), row);//来源id
                this.getModel().setValue("tpv_strateg", "tpv_bd_strategy", row);//来源id
                this.getModel().setValue("tpv_filter", tpvBdStrategy.getDate("tpv_swaplegdatato")!=null?tpvBdStrategy.getDate("tpv_swaplegdatato").compareTo(new Date())>0:false, row);//来源id
            }
        }

        if ("".equals(tpvStratetype) || "B".equals(tpvStratetype) || tpvStratetype == null) {//bd_customer bd_supplier
            String selectfields = DynamicObjectUtil.getSelectfields("tpv_cushedgemagereq", false);
            String entrySelectfield = DynamicObjectUtil.getEntrySelectfields(selectfields, "tpv_cushedgemagereq", "tpv_iotraders", false);
            DynamicObject[] tpvBdStrategies = BusinessDataServiceHelper.load("tpv_cushedgemagereq", entrySelectfield,
                    qFilterCus.toArray());
            for (DynamicObject tpvBdStrategy : tpvBdStrategies) {
                DynamicObjectCollection tpvIotraders = tpvBdStrategy.getDynamicObjectCollection("tpv_iotraders");
                StringBuilder builder = new StringBuilder();
                for (DynamicObject tpvIotrader : tpvIotraders) {
                    String tpvIotype = tpvIotrader.getString("tpv_iotype");
                    if ("bd_customer".equals(tpvIotype)) {
                        DynamicObject tpvAsstact = tpvIotrader.getDynamicObject("tpv_asstact");
                        if (tpvAsstact != null) {
                            if (builder.length() == 0) {
                                builder.append(tpvAsstact.getString("name"));
                            } else {
                                builder.append("," + tpvAsstact.getString("name"));
                            }
                        }
                    }
                }
                int row = this.getModel().createNewEntryRow("tpv_westrategy");
                this.getModel().setValue("tpv_name", tpvBdStrategy.get("billno"), row);//策略名称
                this.getModel().setValue("tpv_tclientext", builder, row);//客户
                this.getModel().setValue("tpv_department", tpvBdStrategy.get("tpv_department"), row);//部门
                this.getModel().setValue("tpv_org", tpvBdStrategy.get("tpv_company"), row);//公司
                this.getModel().setValue("tpv_strategyid", tpvBdStrategy.getLong("id"), row);//公司
                this.getModel().setValue("tpv_strateg", "tpv_cushedgemagereq", row);//公司
                this.getModel().setValue("tpv_filter", !"star".equals(tpvBdStrategy.getString("tpv_enable")), row);//公司

            }
        }
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs afterDoOperationEventArgs) {
        super.afterDoOperation(afterDoOperationEventArgs);
        String key = afterDoOperationEventArgs.getOperateKey();//+新建开平记录向弹窗传递空操作用来触发单据体的刷新
        if ("donothing".equals(key)) {
            DynamicObject dataEntity = this.getModel().getDataEntity(true);
            DynamicObjectCollection tpvWestrategy = dataEntity.getDynamicObjectCollection("tpv_westrategy");
            EntryGrid entryGrid = this.getControl("tpv_westrategy");
            int[] selectRows = entryGrid.getSelectRows();
            if (selectRows.length == 0) {
                calin(0);
            } else {
                String name = tpvWestrategy.get(selectRows[0]).getString("tpv_name");
                long tpvStrategyid = tpvWestrategy.get(selectRows[0]).getLong("tpv_strategyid");
                calin(tpvStrategyid);
            }
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey();
        switch (itemKey) {
            case "tpv_canclaim":
                canClaim();
                break;
            case "tpv_inquire"://认领
                claim("tpv_claim");
                break;
            case "tpv_claim"://移仓认领
                claim("tpv_removeclaim");
                break;

        }
    }

    @Override
    public void entryRowClick(RowClickEvent evt) {
        int row = evt.getRow();
        if (row < 0) {
            calin(0);
            return;
        }
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvWestrategy = dataEntity.getDynamicObjectCollection("tpv_westrategy");
        String name = tpvWestrategy.get(row).getString("tpv_name");
        long tpvStrategyid = tpvWestrategy.get(row).getLong("tpv_strategyid");
        calin(tpvStrategyid);

    }

    public void canClaim() {
        IFormView view = this.getView();
        FormShowParameter parameter = new FormShowParameter();
        parameter.setStatus(OperationStatus.ADDNEW);
        parameter.getOpenStyle().setShowType(ShowType.Modal);
        Map<String, Object> map = new HashMap<>();
        EntryGrid entryGrid = this.getControl("tpv_calin");
        DynamicObject dataEntity = view.getModel().getDataEntity(true);
        DynamicObjectCollection tpvTmIniactivehed = dataEntity.getDynamicObjectCollection("tpv_calin");
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length == 0) {
            this.getView().showTipNotification("请选择一条数据！");
            return;
        }
        List<Long> idList = new ArrayList<>();
        for (int selectRow : selectRows) {
            idList.add(tpvTmIniactivehed.get(selectRow).getLong("tpv_sourceid"));
        }
        DynamicObject[] claimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", "tpv_redflush", new QFilter[]{new QFilter("id", "in", idList)});
        Boolean isFlag = false;
        for (DynamicObject claimdetail : claimdetails) {
            String tpvRedflush = claimdetail.getString("tpv_redflush");
            if (YEM.isNotEmpty(tpvRedflush)) {
                isFlag = true;
            }
        }
        if (isFlag) {
            this.getView().showTipNotification("选择的认领明细正在红冲中或已被红冲，请查询！");
            return;
        }
        map.put("idList", idList);
        parameter.setCustomParams(map);
        parameter.setFormId("tpv_tm_calremarks");
        parameter.setCloseCallBack(new CloseCallBack(this, "tpv_canclaim"));
        view.showForm(parameter);
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "tpv_inquire"://认领
                claim("tpv_claim");
                break;
            case "tpv_claim"://移仓认领
                claim("tpv_removeclaim");
                break;
            case "tpv_inquirecl"://查询
                claim();
                calin(0);
                break;
        }
    }

    public void claim(String key) {
        IFormView view = this.getView();
        FormShowParameter parameter = new FormShowParameter();
        parameter.setStatus(OperationStatus.ADDNEW);
        parameter.getOpenStyle().setShowType(ShowType.Modal);
        Map<String, Object> map = new HashMap<>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        EntryGrid entryGrid = this.getControl("tpv_westrategy");
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length != 0) {
            map.put("tpv_strategyid", dataEntity.getDynamicObjectCollection("tpv_westrategy").get(selectRows[0]).getLong("tpv_strategyid"));
            map.put("tpv_strateg", dataEntity.getDynamicObjectCollection("tpv_westrategy").get(selectRows[0]).getString("tpv_strateg"));
            map.put("tpv_filter", dataEntity.getDynamicObjectCollection("tpv_westrategy").get(selectRows[0]).getBoolean("tpv_filter"));
        } else {
            this.getView().showTipNotification("请选择策略号");
            return;
        }
        map.put("key", key);
        parameter.setCustomParams(map);
        parameter.setFormId("tpv_tm_claipopup");
        parameter.setCloseCallBack(new CloseCallBack(this, "tpv_claim"));
        view.showForm(parameter);
    }
}
