package tpv.tpv_wm.tpv_tm.java.formplugin.dynamic;

import com.itopview.wm.utils.YEM;
import kd.bos.coderule.api.CodeRuleInfo;
import kd.bos.dataentity.entity.CloneUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.tree.TreeNode;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.control.Control;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.ORM;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.coderule.CodeRuleServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.math.BigDecimal;
import java.util.Date;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * @ClassName: TmNewrecordEdit
 * @Description: 新建开平记录
 * 点击后弹出弹窗《新建开平记录》，确认后根据填写信息生成2条已审核的《成交记录单》，
 * 1条【买卖方向】=“买入”，1条【买卖方向】=“卖出”，【数据来源】=“手工新建”；（做一个标记，这两条数据具有关联性）
 * @author: zbh
 * @date: 2024-04-07
 */
public class TmNewrecordEdit extends AbstractFormPlugin {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"btnok"});
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control) evt.getSource()).getKey();
        switch (key) {
            case "btnok":
                this.btnOk();
                break;
        }
    }

    private void btnOk() {

        StringBuilder builder = new StringBuilder();
        DynamicObject remcons = (DynamicObject) this.getModel().getValue("tpv_remcons");//记录合约


        Date tradingday = (Date) this.getModel().getValue("tpv_tradingday");//交易日
        BigDecimal price = (BigDecimal) this.getModel().getValue("tpv_price");//单价
        BigDecimal tonssold = (BigDecimal) this.getModel().getValue("tpv_tonssold");//成交吨数
        if (remcons == null) {
            stringBuilder(builder, "记录合约");
        }
        if (tradingday == null) {
            stringBuilder(builder, "交易日");
        }
        if (price.compareTo(BigDecimal.ZERO) == 0) {
            stringBuilder(builder, "单价");
        }
        if (tonssold.compareTo(BigDecimal.ZERO) == 0) {
            stringBuilder(builder, "成交吨数");
        }
        if (builder.length() != 0) {
            this.getView().showTipNotification("请填写" + builder + "!");
            return;
        }
        IFormView parentView = this.getView().getParentView();
        IDataModel model = this.getModel();
        Object tpvRemcons = model.getValue("tpv_remcons");//记录合约

        DynamicObject parent = remcons.getDynamicObject("parent");

        Object tpvTradingday = model.getValue("tpv_tradingday");//交易日
        Object tpvPrice = model.getValue("tpv_price");//单价
        Object tpvTonssold = model.getValue("tpv_tonssold");//成交吨数
        DynamicObject tmClaimdetailSall = ORM.create().newDynamicObject("tpv_tm_dealrecord");

        CodeRuleInfo codeRule = CodeRuleServiceHelper.getCodeRule("tpv_tm_dealrecord", tmClaimdetailSall, null);
        String billno = CodeRuleServiceHelper.getNumber(codeRule, tmClaimdetailSall);
        IDataEntityType dataEntityType = tmClaimdetailSall.getDataEntityType();
        tmClaimdetailSall.set("billno", billno);//单据编号
        tmClaimdetailSall.set("tpv_tradeway", "BUY");//买入
        if (parent != null) {
            tmClaimdetailSall.set("tpv_varietyname", parent.getString("name"));
        } else {
            tmClaimdetailSall.set("tpv_varietyname", remcons.getString("name"));
        }
        tmClaimdetailSall.set("tpv_srcbillway", "B");//数据来源
        tmClaimdetailSall.set("billstatus", "C");//单据状态
        tmClaimdetailSall.set("tpv_operator", YEM.getCurrentUserId());//业务员
        tmClaimdetailSall.set("tpv_company", YEM.getCurrentOrgId());//公司
        tmClaimdetailSall.set("org", YEM.getCurrentOrgId());//组织
        tmClaimdetailSall.set("tpv_bizdate", new Date());//业务日期
        tmClaimdetailSall.set("tpv_contractool", tpvRemcons);//合约池
        tmClaimdetailSall.set("tpv_dealdate", tpvTradingday);//成交时间
        tmClaimdetailSall.set("tpv_dealprice", tpvPrice);//成交价格
        tmClaimdetailSall.set("tpv_dealton", tpvTonssold);//成交吨数
        tmClaimdetailSall.set("tpv_claimcqqty", 0);//已认领数量(苍穹)
        tmClaimdetailSall.set("tpv_claimnbqty", 0);//已认领数量(南北)
        tmClaimdetailSall.set("tpv_version", 1);//版本号
        tmClaimdetailSall.set("tpv_department", UserServiceHelper.getUserMainOrgId(YEM.getCurrentUserId()));//部门
        long genLongId = ORM.create().genLongId(dataEntityType);
        tmClaimdetailSall.set("tpv_srcid", genLongId);//源单id
        tmClaimdetailSall.set("creator", YEM.getCurrentUserId());//创建人

        DynamicObject tmClaimdetailBuy = ORM.create().newDynamicObject("tpv_tm_dealrecord");
        CodeRuleInfo codeRulBuy = CodeRuleServiceHelper.getCodeRule("tpv_tm_dealrecord", tmClaimdetailBuy, null);
        String billnoBuy = CodeRuleServiceHelper.getNumber(codeRulBuy, tmClaimdetailBuy);
        tmClaimdetailBuy.set("billno", billnoBuy);//卖出
        tmClaimdetailBuy.set("tpv_tradeway", "SELL");//卖出
        if (parent != null) {
            tmClaimdetailBuy.set("tpv_varietyname", parent.getString("name"));
        } else {
            tmClaimdetailBuy.set("tpv_varietyname", remcons.getString("name"));
        }
        tmClaimdetailBuy.set("tpv_srcbillway", "B");//数据来源
        tmClaimdetailBuy.set("billstatus", "C");//单据状态
        tmClaimdetailBuy.set("tpv_operator", YEM.getCurrentUserId());//业务员
        tmClaimdetailBuy.set("tpv_company", YEM.getCurrentOrgId());//公司
        tmClaimdetailBuy.set("tpv_bizdate", new Date());//业务日期
        tmClaimdetailBuy.set("tpv_contractool", tpvRemcons);//合约池
        tmClaimdetailBuy.set("tpv_dealdate", tpvTradingday);//成交时间
        tmClaimdetailBuy.set("tpv_dealprice", tpvPrice);//成交价格
        tmClaimdetailBuy.set("tpv_dealton", tpvTonssold);//成交吨数
        tmClaimdetailBuy.set("tpv_claimcqqty", 0);//已认领数量(苍穹)
        tmClaimdetailBuy.set("tpv_claimnbqty", 0);//已认领数量(南北)
        tmClaimdetailBuy.set("tpv_srcid", genLongId);//源单id
        tmClaimdetailBuy.set("creator", YEM.getCurrentUserId());//创建人
        tmClaimdetailBuy.set("tpv_version", 1);//版本号
        tmClaimdetailBuy.set("tpv_department", UserServiceHelper.getUserMainOrgId(YEM.getCurrentUserId()));//部门
        tmClaimdetailBuy.set("org", YEM.getCurrentOrgId());//组织

        SaveServiceHelper.save(new DynamicObject[]{tmClaimdetailSall});
        SaveServiceHelper.save(new DynamicObject[]{tmClaimdetailBuy});
        parentView.invokeOperation("donothing");
        this.getView().close();
        this.getView().sendFormAction(parentView);
    }

    public void stringBuilder(StringBuilder stringBuilder, String basePrice) {
        if (stringBuilder.length() == 0) {
            stringBuilder.append(basePrice);
        } else {
            stringBuilder.append("，" + basePrice);
        }
    }
}
