package tpv.tpv_wm.tpv_tm.java.formplugin.form;

import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.form.ConfirmCallBackListener;
import kd.bos.form.MessageBoxOptions;
import kd.bos.form.MessageBoxResult;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.MessageBoxClosedEvent;
import kd.bos.servicehelper.user.UserServiceHelper;

import java.util.Calendar;
import java.util.EventObject;

/**
 * @Description: 代客套保管理申请单 -表单插件
 * @Author LinRui
 * @Date 2024/8/23 16:14
 */
public class CushedReqFormPlugin extends AbstractBillPlugIn {

    //单据中的工具栏标识
    private static final String KEY_TOOlBAR = "tbmain";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        //监听工具栏按钮点击事件
        this.addItemClickListeners(KEY_TOOlBAR);
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs args) {
        super.afterDoOperation(args);
        String operateKey = args.getOperateKey();
        Object billno = this.getModel().getValue("billno");
        //工具栏上的所有按钮的点击都会激活itemClick方法，需要开发人员实现不同按钮的逻辑
        if (StringUtils.equals("donothing_del", operateKey)) {
            //作废操作前让用户选择是否继续作废操作，在用户点击确认框上的按钮后，系统会调用confirmCallBack方法
            ConfirmCallBackListener confirmCallBackListener = new ConfirmCallBackListener("donothing_del", this);
            //设置页面确认框，参数为：标题，选项框类型，回调监听
            this.getView().showConfirm("是否需要作废代客套保申请单"+billno+"？", MessageBoxOptions.YesNo, confirmCallBackListener);
        }
        if (StringUtils.equals("donothing_star", operateKey)) {
            //作废操作前让用户选择是否继续作废操作，在用户点击确认框上的按钮后，系统会调用confirmCallBack方法
            ConfirmCallBackListener confirmCallBackListener = new ConfirmCallBackListener("donothing_star", this);
            //设置页面确认框，参数为：标题，选项框类型，回调监听
            this.getView().showConfirm("是否需要启用代客套保申请单"+billno+"？", MessageBoxOptions.YesNo, confirmCallBackListener);
        }
        if (StringUtils.equals("donothing_end", operateKey)) {
            //作废操作前让用户选择是否继续作废操作，在用户点击确认框上的按钮后，系统会调用confirmCallBack方法
            ConfirmCallBackListener confirmCallBackListener = new ConfirmCallBackListener("donothing_end", this);
            //设置页面确认框，参数为：标题，选项框类型，回调监听
            this.getView().showConfirm("是否需要停用代客套保申请单"+billno+"？", MessageBoxOptions.YesNo, confirmCallBackListener);
        }
    }

    /**
     * 选择框回调函数
     *
     * @param messageBoxClosedEvent
     */
    @Override
    public void confirmCallBack(MessageBoxClosedEvent messageBoxClosedEvent) {
        super.confirmCallBack(messageBoxClosedEvent);
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection tpvTmAgentcontract = dataEntity.getDynamicObjectCollection("tpv_operationalentry");
        //判断是否是对应确认框的点击回调事件
        if (StringUtils.equals("donothing_del", messageBoxClosedEvent.getCallBackId())) {
            if (MessageBoxResult.Yes.equals(messageBoxClosedEvent.getResult())) {
                dataEntity.set("tpv_enable", "del");
                DynamicObject dynamicObject = tpvTmAgentcontract.addNew();
                dynamicObject.set("tpv_operationalstate", "del");
                dynamicObject.set("tpv_operationaluser", UserServiceHelper.getCurrentUserId());
                dynamicObject.set("tpv_operationaldate", Calendar.getInstance().getTime());
                this.getView().invokeOperation("save", YEM.getOptionNoMsg());
//                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
            } else if (MessageBoxResult.No.equals(messageBoxClosedEvent.getResult())) {
                // 点击否的相关处理逻辑。。。。
            }
        }
        if (StringUtils.equals("donothing_star", messageBoxClosedEvent.getCallBackId())) {
            if (MessageBoxResult.Yes.equals(messageBoxClosedEvent.getResult())) {
                dataEntity.set("tpv_enable", "star");
                DynamicObject dynamicObject = tpvTmAgentcontract.addNew();
                dynamicObject.set("tpv_operationalstate", "star");
                dynamicObject.set("tpv_operationaluser", UserServiceHelper.getCurrentUserId());
                dynamicObject.set("tpv_operationaldate", Calendar.getInstance().getTime());
                this.getView().invokeOperation("save", YEM.getOptionNoMsg());
//                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
            } else if (MessageBoxResult.No.equals(messageBoxClosedEvent.getResult())) {
                // 点击否的相关处理逻辑。。。。
            }
        }
        if (StringUtils.equals("donothing_end", messageBoxClosedEvent.getCallBackId())) {
            if (MessageBoxResult.Yes.equals(messageBoxClosedEvent.getResult())) {
                dataEntity.set("tpv_enable", "end");
                DynamicObject dynamicObject = tpvTmAgentcontract.addNew();
                dynamicObject.set("tpv_operationalstate", "end");
                dynamicObject.set("tpv_operationaluser", UserServiceHelper.getCurrentUserId());
                dynamicObject.set("tpv_operationaldate", Calendar.getInstance().getTime());
                this.getView().invokeOperation("save", YEM.getOptionNoMsg());
//                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity(true)});
            } else if (MessageBoxResult.No.equals(messageBoxClosedEvent.getResult())) {
                // 点击否的相关处理逻辑。。。。
            }
        }
    }
}
