package tpv.tpv_wm.tpv_tm.java.formplugin.form;

import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;

/**
 * @ClassName: DealrecordFormPugin
 * @Description: 成交记录单
 * @author: zbh
 * @date: 2024-07-23
 */
public class DealrecordFormPugin extends AbstractBillPlugIn {

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        this.getModel().setValue("tpv_company", YEM.getCurrentOrgId());
        this.getModel().setValue("org", YEM.getCurrentOrgId());
        this.getModel().setValue("tpv_operator", YEM.getCurrentUserId());
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_account":
                tpvAccount();
                break;
            case "tpv_contractool":
                tpvContractool();
                break;
        }
    }

    private void tpvContractool() {
        DynamicObject tpvAccount = (DynamicObject) this.getModel().getValue("tpv_contractool");
        if (tpvAccount != null) {
            DynamicObject parent = tpvAccount.getDynamicObject("parent");
            if (parent == null) {
                String name = tpvAccount.getString("name");
                this.getModel().setValue("tpv_varietyname", name);
            } else {
                DynamicObject parents = parent;
                DynamicObject[] tpvTmContractools = BusinessDataServiceHelper.load("tpv_tm_contractool", "name,parent", null);
                for (DynamicObject tpvTmCon : tpvTmContractools) {
                    for (DynamicObject tpvTmContractool : tpvTmContractools) {
                        long aLong = parents.getLong("id");
                        long id = tpvTmContractool.getLong("id");
                        if (aLong == id) {
                            DynamicObject object = tpvTmContractool.getDynamicObject("parent");
                            if (object == null) {
                                this.getModel().setValue("tpv_varietyname", tpvTmContractool.getString("name"));
                                return;
                            } else {
                                parents = object;
                            }
                        }
                    }
                }
            }
        } else {
            this.getModel().setValue("tpv_varietyname", null);
        }
    }

    private void tpvAccount() {
        DynamicObject tpvAccount = (DynamicObject) this.getModel().getValue("tpv_account");
        if (tpvAccount == null) {
            this.getModel().setValue("tpv_amcunit", null);
            this.getModel().setValue("tpv_claimablesnapin", null);
            return;
        }
        DynamicObjectCollection tpvAmcunit = (DynamicObjectCollection) this.getModel().getValue("tpv_amcunit");
        DynamicObject tpvTmFutureaccount = BusinessDataServiceHelper.loadSingle(tpvAccount.getPkValue(), "tpv_tm_futureaccount");
        DynamicObjectCollection tpvAdministrative = tpvTmFutureaccount.getDynamicObjectCollection("tpv_administrative");
        DynamicObjectCollection tpv_material = new DynamicObjectCollection();

        for (DynamicObject entry : tpvAdministrative) {
            DynamicObject newMaterial = new DynamicObject(tpvAmcunit.getDynamicObjectType());
            newMaterial.set("fbasedataId", entry.get("fbasedataId")); //集合或数组
            tpv_material.add(newMaterial);
        }
        if (tpv_material.size() != 0) {
            this.getModel().setValue("tpv_amcunit", tpv_material);
            this.getModel().setValue("tpv_claimablesnapin", tpv_material);
        }
    }
}
