package tpv.tpv_wm.tpv_tm.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.EventObject;

/**
 * @author 金亮
 * @date 2024/4/23 17:00
 * @relevantfile 期货账户申请单变更（tpv_tm_futureaccount_inh）
 * @description 创建新版本时，如果上个版本【单据类型】 ≠ ‘停用申请’，则创建的新版本的【单据类型】=“停用申请”。
 *               变更后生效后，源单未更新单据类型为“停用申请”，变更单单据类型也未变为“停用申请”
 * @versions 1.0
 */
public class FutureaccountInhFormPlugin extends AbstractBillPlugIn {
    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        String billstatus = (String) this.getModel().getValue("billstatus");//单据状态
        if (!billstatus.equals("A")){
            return;
        }
        long tpvMasterid = (long) this.getModel().getValue("tpv_masterid");//主数据内码
        if (tpvMasterid == 0) {
            return;
        }
        DynamicObject bill = BusinessDataServiceHelper.loadSingle(tpvMasterid, "tpv_tm_futureaccount");
        if (bill == null){
            return;
        }
        String tpvItemtype = bill.getString("tpv_itemtype");//单据类型
        if (!tpvItemtype.equals("B")){
            this.getModel().setValue("tpv_itemtype","B");
        }else{
            this.getModel().setValue("tpv_itemtype","C");
        }
    }
}
