package tpv.tpv_wm.tpv_tm.java.formplugin.form;


import com.itopview.wm.utils.DateUtil;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.*;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.events.HyperLinkClickEvent;
import kd.bos.form.events.HyperLinkClickListener;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.fi.cas.helper.OperateServiceHelper;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 被动套保申请单-表单插件
 *
 * @author WangShuGuang
 * @description
 * @date 2023年12月1日
 */
public class PassivityHedgFormPlugin extends AbstractBillPlugIn implements HyperLinkClickListener, BeforeF7SelectListener {

    @Override
    public void propertyChanged(PropertyChangedArgs e) {//触发时机：表单模型某个字段值改变的时候就会触发此事件//
        String propertyName = e.getProperty().getName();
        ChangeData cd = e.getChangeSet()[0];
        if (propertyName.equals("tpv_signdatestart") || propertyName.equals("tpv_signdateend")) {
            judgeTime(cd);
        }
    }

    // 监听页面按钮点击
    @Override
    public void registerListener(EventObject e) {
        // TODO Auto-generated method stub
        super.registerListener(e);
        this.addItemClickListeners(new String[]{"tpv_advcontoolbarap12"});
        EntryGrid entryGrid = this.getView().getControl("tpv_tm_agentcontract");
        entryGrid.addHyperClickListener(this);
        BasedataEdit tpvMultipoint = this.getView().getControl("tpv_multipoint");
        tpvMultipoint.addBeforeF7SelectListener(this);
        BasedataEdit tpvBear = this.getView().getControl("tpv_bear");
        tpvBear.addBeforeF7SelectListener(this);
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        // TODO Auto-generated method stub
        //
        super.itemClick(evt);
        String key = evt.getItemKey();
        if (key.equals("tpv_periodprice")) {
            //+周期价格确认
            periodPrice(true);
        }
        if (key.equals("tpv_modification")) {
            //+修改可套保数量
            periodPrice(false);
        }
        if (key.equals("tpv_purchase")) {

            //+采购合同
            billnoClick("A");
        }
        if (key.equals("tpv_salescontract")) {
            //+销售合同
            billnoClick("B");
        }
        if (key.equals("tpv_maxhomesales")) {
            //+第三方销售合同
            billnoClick("C");
        }
    }

    private void billnoClick(String message) {
        IFormView view = this.getView();
        IDataModel model = view.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        DynamicObjectCollection tpvTmAgentcontract = dataEntity.getDynamicObjectCollection("tpv_tm_agentcontract");
        DynamicObjectCollection tpvTmContract = dataEntity.getDynamicObjectCollection("tpv_tm_contract");
        DynamicObjectCollection tpvTmBear = dataEntity.getDynamicObjectCollection("tpv_tm_bear");
        if (StringUtils.equals(message, "A")) {
            List<String> strings = tpvTmAgentcontract.stream().filter(s -> s.getString("tpv_salorpur").equals("tpv_dt_purchase")).map(s -> s.getString("tpv_contractnumber")).collect(Collectors.toList());
            ListShowParameter createShowListForm = ShowFormHelper.createShowListForm("tpv_dt_purchase", true, 0);
            createShowListForm.setCloseCallBack(new CloseCallBack(this, "billnoClick"));
            QFilter qFilter = new QFilter("billstatus", QCP.equals, "C");
            qFilter.and("tpv_contractnumber", QCP.not_in, strings);
            if (tpvTmContract.size() > 0) {
                qFilter.and("tpv_multipoint", QCP.equals, "");
            }
            if (tpvTmBear.size() > 0) {
                qFilter.and("tpv_bear", QCP.equals, "");
            }
            qFilter.and("tpv_wehgua", QCP.equals, false);
            createShowListForm.getListFilterParameter().setFilter(qFilter);
            view.showForm(createShowListForm);
        } else if (StringUtils.equals(message, "B")) {
            List<String> strings = tpvTmAgentcontract.stream().filter(s -> s.getString("tpv_salorpur").equals("tpv_dt_salescontract")).map(s -> s.getString("tpv_contractnumber")).collect(Collectors.toList());
            ListShowParameter createShowListForm = ShowFormHelper.createShowListForm("tpv_dt_salescontract", true, 0);
            createShowListForm.setCloseCallBack(new CloseCallBack(this, "salescontract"));
            QFilter qFilter = new QFilter("tpv_ourcustomers", QCP.equals, 0L);
//            qFilter.and("tpv_homesales", QCP.equals, "");
            qFilter.and("billstatus", QCP.equals, "C");//单据状态
            qFilter.and("tpv_contractnos", QCP.not_in, strings);
            if (tpvTmContract.size() > 0) {
                qFilter.and("tpv_multipoint", QCP.equals, "");
            }
            if (tpvTmBear.size() > 0) {
                qFilter.and("tpv_bear", QCP.equals, "");
            }
            qFilter.and("tpv_wehgua", QCP.equals, false);
            qFilter.and("tpv_thirdparty", QCP.equals, false);
            createShowListForm.getListFilterParameter().setFilter(qFilter);
            view.showForm(createShowListForm);
        } else {
            List<String> strings = tpvTmAgentcontract.stream().filter(s -> s.getString("tpv_salorpur").equals("tpv_dt_salescontract")).map(s -> s.getString("tpv_contractnumber")).collect(Collectors.toList());
            ListShowParameter createShowListForm = ShowFormHelper.createShowListForm("tpv_dt_salescontract", true, 0);
            createShowListForm.setCloseCallBack(new CloseCallBack(this, "salescontractTow"));
            QFilter qFilter = new QFilter("tpv_ourcustomers", QCP.not_equals, 0L);
//            qFilter.and("tpv_homesales", QCP.not_equals, "");
            qFilter.and("billstatus", QCP.equals, "C");//单据状态
            qFilter.and("tpv_contractnos", QCP.not_in, strings);
            if (tpvTmContract.size() > 0) {
                qFilter.and("tpv_multipoint", QCP.equals, "");
            }
            if (tpvTmBear.size() > 0) {
                qFilter.and("tpv_bear", QCP.equals, "");
            }
            qFilter.and("tpv_wehgua", QCP.equals, false);
            qFilter.and("tpv_thirdparty", QCP.equals, true);
            createShowListForm.getListFilterParameter().setFilter(qFilter);
            view.showForm(createShowListForm);
        }
    }

    public void periodPrice(Boolean judge) {
        EntryGrid entryGrid = this.getControl("tpv_tm_agentcontract");
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length==0){
            this.getView().showTipNotification("请先选择一条数据！");
            return;
        }
        // 获取单据体选中行
        int tmAgentcontract =selectRows[0];
        //获取分录数据
        DynamicObject tpvTmAgentcontract = this.getModel().getEntryRowEntity("tpv_tm_agentcontract", tmAgentcontract);// 获取单据体选中行
        if (null != tpvTmAgentcontract) {
            String tpvPricingtype = tpvTmAgentcontract.getString("tpv_pricingtype");//定价类型
            if (judge) {
                if (StringUtils.equals("B", tpvPricingtype)) {
                    //【定价类型】=“后定价”时可操作
                    showParameter(tpvTmAgentcontract, true);
                } else {
                    this.getView().showMessage("合同结算方式为后定价时可发起定价，请注意！");
                }
            } else {
                showParameter(tpvTmAgentcontract, false);
            }
        }
    }

    /**
     * 周期价格确认动态回填
     */
    public void showParameter(DynamicObject dynamicObject, Boolean judge) {
        // 创建弹出动态表单页面对象
        FormShowParameter showParameter = new FormShowParameter();
        Map<String, Object> map = new HashMap<>();
        // 设置弹出页面的标识
        if (judge) {
            showParameter.setFormId("tpv_tm_periodprice");
            map = this.showInfoForm(dynamicObject, true);
            // CloseCallBack参数：回调插件，回调标识
            showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_designate"));
        } else {
            showParameter.setFormId("tpv_tm_modification");//修改可套保数量动态表单
            map = this.showInfoForm(dynamicObject, false);
            // CloseCallBack参数：回调插件，回调标识
            showParameter.setCloseCallBack(new CloseCallBack(this, "tpv_designatefalse"));
        }
        // 存入获取到的动态表单数据
        showParameter.setCustomParams(map);
        // 状态
        showParameter.setStatus(OperationStatus.ADDNEW);
        // 设置页面关闭回调方法
        // 设置弹出页面打开方式
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        // 打开动态表单
        this.getView().showForm(showParameter);
    }

    /**
     * 动表单获取原单据字段
     */
    private Map<String, Object> showInfoForm(DynamicObject dynamicObject, Boolean judge) {
        // 创建集合保存需要获取的字段值
        Map<String, Object> map = new HashMap<>();
        if (judge) {
            // 获取结算方式（套保）
            String tpvSettleway = dynamicObject.getString("tpv_settleway");
            // 获取规则
            String tpvRule = dynamicObject.getString("tpv_rule");
            // 获取定价周期开始日
            Date tpvPricingstart = dynamicObject.getDate("tpv_pricingstart");
            // 获取定价周期终止日
            Date tpvPricingend = dynamicObject.getDate("tpv_pricingend");
            // 判断获得的各项数据
            if (StringUtils.isNotEmpty(tpvSettleway)) {
                map.put("tpv_settleway", tpvSettleway);
            }
            if (StringUtils.isNotEmpty(tpvRule)) {
                map.put("tpv_rule", tpvRule);
            }
            if (null != tpvPricingstart) {
                map.put("tpv_pricingstart", tpvPricingstart);
            }
            if (null != tpvPricingend) {
                map.put("tpv_pricingend", tpvPricingend);
            }
        } else {
            BigDecimal tpvCanqty = dynamicObject.getBigDecimal("tpv_canqty");//可套保数量
            String tpvContractnumber = dynamicObject.getString("tpv_contractnumber");//合同号
            String tpvSalorpur = dynamicObject.getString("tpv_salorpur");//采销合同
            if (tpvCanqty.compareTo(BigDecimal.ZERO) != 0) {
                map.put("tpv_canqty", tpvCanqty);
            }
            if (StringUtils.isNotEmpty(tpvContractnumber)) {
                map.put("tpv_contractnumber", tpvContractnumber);
            }
            if (StringUtils.isNotEmpty(tpvSalorpur)) {
                map.put("tpv_salorpur", tpvSalorpur);
            }
        }
        return map;
    }

    /**
     * 动态表单回填单据字段
     */
    private void setInwardInfo(Map<String, Object> values, Boolean judge) {
        IDataModel model = this.getModel();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        EntryGrid entryGrid = this.getControl("tpv_tm_agentcontract");
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length==0){
            this.getView().showTipNotification("分行选择行为空！");
            return;
        }
        int tmAgentcontract = selectRows[0];
        if (judge) {
            model.setValue("tpv_settleway", values.get("tpv_settleway"), tmAgentcontract);
            model.setValue("tpv_rule", values.get("tpv_rule"), tmAgentcontract);
            model.setValue("tpv_pricingstart", values.get("tpv_pricingstart"), tmAgentcontract);
            model.setValue("tpv_pricingend", values.get("tpv_pricingend"), tmAgentcontract);
        } else {
            model.setValue("tpv_canqty", values.get("tpv_canqty"), tmAgentcontract);
        }
        this.getView().invokeOperation("save");
        //SaveServiceHelper.update(dynamicObject);// 写入数据库
        this.getView().updateView("tpv_tm_agentcontract");
    }

    /**
     * 动态表单关闭回调事件
     */
    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        //获取单据主实体
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        // super.closedCallBack(closedCallBackEvent);
        Object returnData = closedCallBackEvent.getReturnData();
        // 判断标识是否匹配，并验证返回值不为空，不验证返回值可能会报空指针
        if (org.apache.commons.lang3.StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_designate")
                && null != closedCallBackEvent.getReturnData()) {
            // 这里返回对象为Object，可强转成相应的其他类型，
            // 单条数据可用String类型传输，返回多条数据可放入map中，也可使用json等方式传输
            HashMap<String, Object> values = (HashMap<String, Object>) returnData;
            this.setInwardInfo(values, true);
        }
        if (org.apache.commons.lang3.StringUtils.equals(closedCallBackEvent.getActionId(), "tpv_designatefalse")
                && null != closedCallBackEvent.getReturnData()) {
            // 这里返回对象为Object，可强转成相应的其他类型，
            // 单条数据可用String类型传输，返回多条数据可放入map中，也可使用json等方式传输
            HashMap<String, Object> values = (HashMap<String, Object>) returnData;
            this.setInwardInfo(values, false);
        }
        if (org.apache.commons.lang3.StringUtils.equals(closedCallBackEvent.getActionId(), "billnoClick")) {
            Object returnDataS = closedCallBackEvent.getReturnData();
            if (null != returnDataS) {
                ListSelectedRowCollection row = ((ListSelectedRowCollection) returnData);
                if (null != row) {
                    for (ListSelectedRow listSelectedRow : row) {
                        Long primaryKeyValue = (Long) listSelectedRow.getPrimaryKeyValue();
                        if (null != primaryKeyValue) {
                            DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(primaryKeyValue, "tpv_dt_purchase");
                            DynamicObjectCollection objectCollection = dataEntity.getDynamicObjectCollection("tpv_tm_agentcontract");
                            DynamicObject tpvtmAgentcontract = objectCollection.addNew();
                            tpvtmAgentcontract.set("tpv_contractnumber", dynamicObject.getString("tpv_contractnumber"));//合同号
                            tpvtmAgentcontract.set("tpv_contractkey", "pur");//合同名称
                            tpvtmAgentcontract.set("tpv_contractbillid", dynamicObject.getLong("id"));//合同id
                            tpvtmAgentcontract.set("tpv_contractstate", dynamicObject.getString("billstatus"));//合同状态
                            tpvtmAgentcontract.set("tpv_contracttype", dynamicObject.getDynamicObject("tpv_document"));//合同类型
                            tpvtmAgentcontract.set("tpv_typeofreward", dynamicObject.getDynamicObject("tpv_typeofreward"));//提奖类型
                            tpvtmAgentcontract.set("tpv_clientsupplier", dynamicObject.getString("tpv_suppliername"));//客户/供应商
                            tpvtmAgentcontract.set("tpv_dateofcontracting", dynamicObject.getDate("tpv_dateofcontracting"));//签约日期
                            tpvtmAgentcontract.set("tpv_pricingtype", dynamicObject.getString("tpv_pricingtype"));//定价类型
                            tpvtmAgentcontract.set("tpv_operators", dynamicObject.getDynamicObject("tpv_operator"));//业务员
                            tpvtmAgentcontract.set("tpv_salorpur", "tpv_dt_purchase");//合同类型
                            //tpvtmAgentcontract.set("tpv_basedatafield", dynamicObject.getDynamicObject("tpv_document"));//
                            DynamicObjectCollection tpvMaterialentry = dynamicObject.getDynamicObjectCollection("tpv_materialentry");
                            List<String> materialName = new ArrayList<>();
                            BigDecimal taxpramount = BigDecimal.ZERO;//含税金额
                            BigDecimal qty = BigDecimal.ZERO;//数量
                            for (DynamicObject object : tpvMaterialentry) {
                                materialName.add(object.getString("tpv_material.name"));
                                taxpramount = taxpramount.add(object.getBigDecimal("tpv_taxpramount"));
                                qty = qty.add(object.getBigDecimal("tpv_qty"));
                            }
                            tpvtmAgentcontract.set("tpv_materialname", materialName.stream()
                                    .distinct()
                                    .collect(Collectors.joining(",")));//商品
                            if (taxpramount.compareTo(BigDecimal.ZERO) != 0 && qty.compareTo(BigDecimal.ZERO) != 0) {
                                tpvtmAgentcontract.set("tpv_averageprice", taxpramount.divide(qty, 4, RoundingMode.HALF_UP));
                            } else {
                                tpvtmAgentcontract.set("tpv_averageprice", BigDecimal.ZERO);
                            }
                            tpvtmAgentcontract.set("tpv_amountunit", taxpramount);
                            SaveServiceHelper.update(tpvtmAgentcontract);// 写入数据库
                            this.getView().updateView("tpv_tm_agentcontract");
                        }
                    }
                }
            }
            OperateServiceHelper.execOperate("save", "tpv_tm_passivityhedging",
                    new DynamicObject[]{this.getModel().getDataEntity(true)}, OperateOption.create());
        }
        if (org.apache.commons.lang3.StringUtils.equals(closedCallBackEvent.getActionId(), "salescontract")
                || org.apache.commons.lang3.StringUtils.equals(closedCallBackEvent.getActionId(), "salescontractTow")) {
            Object returnDataS = closedCallBackEvent.getReturnData();
            if (null != returnDataS) {
                ListSelectedRowCollection row = ((ListSelectedRowCollection) returnData);
                if (null != row) {
                    for (ListSelectedRow listSelectedRow : row) {
                        Long primaryKeyValue = (Long) listSelectedRow.getPrimaryKeyValue();
                        if (null != primaryKeyValue) {
                            DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle(primaryKeyValue, "tpv_dt_salescontract");
                            DynamicObjectCollection objectCollection = dataEntity.getDynamicObjectCollection("tpv_tm_agentcontract");
                            DynamicObject tpvtmAgentcontract = objectCollection.addNew();
                            tpvtmAgentcontract.set("tpv_contractnumber", dynamicObject.getString("tpv_contractnos"));//合同号
                            tpvtmAgentcontract.set("tpv_contractkey", "sale");//合同名称
                            tpvtmAgentcontract.set("tpv_contractbillid", dynamicObject.getLong("id"));//合同id
                            tpvtmAgentcontract.set("tpv_contractstate", dynamicObject.getString("billstatus"));//合同状态
                            tpvtmAgentcontract.set("tpv_contracttype", dynamicObject.getDynamicObject("tpv_documenttypes"));//合同类型
                            tpvtmAgentcontract.set("tpv_typeofreward", dynamicObject.getDynamicObject("tpv_awardtype"));//提奖类型
                            tpvtmAgentcontract.set("tpv_clientsupplier", dynamicObject.getString("tpv_customername"));//客户/供应商
                            tpvtmAgentcontract.set("tpv_dateofcontracting", dynamicObject.getDate("tpv_signingdate"));//签约日期
                            tpvtmAgentcontract.set("tpv_pricingtype", dynamicObject.getString("tpv_pricetype"));//定价类型
                            tpvtmAgentcontract.set("tpv_operators", dynamicObject.getDynamicObject("tpv_operator"));//业务员
                            tpvtmAgentcontract.set("tpv_homesales", dynamicObject.getString("tpv_homesales"));//本家销售合同(第三方销售原合同)
                            tpvtmAgentcontract.set("tpv_salorpur", "tpv_dt_salescontract");//合同类型
                            //tpvtmAgentcontract.set("tpv_basedatafield", dynamicObject.getDynamicObject("tpv_documenttypes"));//
                            DynamicObjectCollection tpvMaterialentry = dynamicObject.getDynamicObjectCollection("tpv_materialentry");
                            List<String> materialName = new ArrayList<>();
                            BigDecimal taxpramount = BigDecimal.ZERO;//含税金额
                            BigDecimal qty = BigDecimal.ZERO;//数量
                            for (DynamicObject object : tpvMaterialentry) {
                                materialName.add(object.getString("tpv_material.name"));
                                taxpramount = taxpramount.add(object.getBigDecimal("tpv_taxpramount"));
                                qty = qty.add(object.getBigDecimal("tpv_qty"));
                            }
                            tpvtmAgentcontract.set("tpv_materialname", materialName.stream()
                                    .distinct()
                                    .collect(Collectors.joining(",")));//商品
                            if (taxpramount.compareTo(BigDecimal.ZERO) != 0 && qty.compareTo(BigDecimal.ZERO) != 0) {
                                tpvtmAgentcontract.set("tpv_averageprice", taxpramount.divide(qty, 4, RoundingMode.HALF_UP));
                            } else {
                                tpvtmAgentcontract.set("tpv_averageprice", BigDecimal.ZERO);
                            }
                            tpvtmAgentcontract.set("tpv_amountunit", taxpramount);
                            SaveServiceHelper.update(tpvtmAgentcontract);// 写入数据库
                            this.getView().updateView("tpv_tm_agentcontract");
                        }
                    }
                }
            }
            OperateServiceHelper.execOperate("save", "tpv_tm_passivityhedging",
                    new DynamicObject[]{this.getModel().getDataEntity(true)}, OperateOption.create());
        }
    }

    private void judgeTime(ChangeData cd) {
        Date startDate = (Date) this.getModel().getValue("tpv_signdatestart");
        Date endDate = (Date) this.getModel().getValue("tpv_signdateend");
        if (startDate != null && endDate != null) {
            boolean before = endDate.before(startDate);
            if (before) {
                this.getView().showMessage("注意签约时间到不能小于签约时间从，请重新填写");
                this.getModel().setValue("tpv_signdateend", null);
            }
        }
    }

    //监听超链
    @Override
    public void hyperLinkClick(HyperLinkClickEvent e) {
        // TODO Auto-generated method stub
        if ("tpv_contractnumber".equals(e.getFieldName())) {
            int index = e.getRowIndex();
            String billno = (String) this.getModel().getValue("tpv_contractnumber", index);
            if (StringUtils.isNotBlank(billno)) {
                DynamicObject tpv_Purchase = BusinessDataServiceHelper.loadSingle("tpv_dt_purchase", "id",
                        new QFilter[]{new QFilter("tpv_contractnumber", QCP.equals, billno)});
                DynamicObject tpv_Salescontract = BusinessDataServiceHelper.loadSingle("tpv_dt_salescontract", "id",
                        new QFilter[]{new QFilter("tpv_contractnos", QCP.equals, billno)});
                //跳转到指定借款单
                if (null != tpv_Purchase) {
                    BillShowParameter showParameter = new BillShowParameter();
                    showParameter.setFormId("tpv_dt_purchase");
                    showParameter.setPkId(tpv_Purchase.getPkValue());
                    showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
                    showParameter.setStatus(OperationStatus.VIEW);
                    this.getView().showForm(showParameter);
                } else if (null != tpv_Salescontract) {
                    BillShowParameter showParameter = new BillShowParameter();
                    showParameter.setFormId("tpv_dt_salescontract");
                    showParameter.setPkId(tpv_Salescontract.getPkValue());
                    showParameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
                    showParameter.setStatus(OperationStatus.VIEW);
                    this.getView().showForm(showParameter);
                }
            }
        }
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_multipoint"://多头买入
            case "tpv_bear"://空头卖出
                multiPoint(e);
                break;
        }
    }

    public void multiPoint(BeforeF7SelectEvent e) {
        DynamicObject[] tpvTmContractools = BusinessDataServiceHelper.load("tpv_tm_contractool", "parent", null);
        List<Long> listId = new ArrayList<>();
        for (DynamicObject tpvTmContractool : tpvTmContractools) {
            Boolean isFlag = true;
            long id = tpvTmContractool.getLong("id");
            for (DynamicObject tmContractool : tpvTmContractools) {
                DynamicObject idParent = tmContractool.getDynamicObject("parent");
                if (idParent != null) {
                    long aLong = idParent.getLong("id");
                    if (id == aLong) {
                        isFlag = false;
                    }
                }
            }
            if (isFlag) {
                listId.add(id);
            }
        }
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<>();
        Date tpvBizdate = (Date) this.getModel().getValue("tpv_bizdate");
        QFilters.add(new QFilter("id", "in", listId));
        if (tpvBizdate != null) {
            Date startOrEndDate = DateUtil.getStartOrEndDate(tpvBizdate, false);
            QFilters.add(new QFilter("tpv_effectivedate", ">=", startOrEndDate));
        }
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }
}
