package tpv.tpv_wm.tpv_tm.java.formplugin.form;

import com.itopview.wm.utils.YEM;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.data.BusinessDataReader;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.metadata.IDataEntityType;
import kd.bos.dataentity.utils.StringUtils;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.IRefrencedataProvider;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IFormView;
import kd.bos.form.ShowType;
import kd.bos.form.control.EntryGrid;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.RefBillEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;

import java.math.BigDecimal;
import java.util.*;

/**
 * @ClassName: PositionOrderFormPlugin
 * @Description: 套保信息表单插件
 * @author: zbh
 * @date: 2024-04-02
 */
public class PositionOrderFormPlugin extends AbstractBillPlugIn implements BeforeF7SelectListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        addClickListeners("tpv_advcontool", "tpv_advcontoolbarap2", "tpv_claim", "tpv_removeclaim", "tpv_canclaim", "tpv_addclaim", "tpv_claimdk", "tpv_canclaimdk", "tpv_advancandk", "tpv_advancandk", "tpv_generatedk", "tpv_advancan", "tpv_sedmatching", "tpv_generate");
        addItemClickListeners("tpv_advcontool", "tpv_claim", "tpv_advcontoolbarap2", "tpv_removeclaim", "tpv_canclaim", "tpv_addclaim", "tpv_claimdk", "tpv_canclaimdk", "tpv_advancandk", "tpv_advancandk", "tpv_generatedk", "tpv_advancan", "tpv_sedmatching", "tpv_generate");
        String name = this.getModel().getDataEntity(true).getDynamicObjectType().getName();
        if ("tpv_dt_salescontract".equals(name) || "tpv_dt_purchase".equals(name)) {
            RefBillEdit tpv_passivityhedging = (RefBillEdit) this.getView().getControl("tpv_passivityhedging");
            tpv_passivityhedging.addBeforeF7SelectListener((BeforeF7SelectListener) this);
        }
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        String type = this.getModel().getDataEntity(true).getDynamicObjectType().getName();
        String constract = "";
        if ("tpv_dt_salescontract".equals(type)) {//销售合同
            constract = "tpv_contractnos";
        }
        if ("tpv_dt_purchase".equals(type)) {//销售合同
            constract = "tpv_contractnumber";
        }
        switch (name) {
            case "tpv_passivityhedging"://被动套保申请单
                passivityhedging(e, constract, type);
                break;
            default:
                break;
        }
    }

    private void passivityhedging(BeforeF7SelectEvent e, String constract, String type) {
        ListShowParameter showParameter = (ListShowParameter) e.getFormShowParameter();
        List<QFilter> QFilters = new ArrayList<QFilter>();
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        String string = dataEntity.getString(constract);
        QFilters.add(new QFilter("tpv_tm_agentcontract.tpv_contractnumber", "=", string));
        QFilters.add(new QFilter("tpv_tm_agentcontract.tpv_salorpur", "=", type));
        showParameter.getListFilterParameter().setQFilters(QFilters);
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String itemKey = evt.getItemKey();
        switch (itemKey) {
            case "tpv_claim":
            case "tpv_claimdk":
                claim(itemKey);
                break;
            case "tpv_removeclaim":
            case "tpv_removeclaimdk":
                claim(itemKey);
                break;
            case "tpv_canclaim":
            case "tpv_canclaimdk":
                canClaim(itemKey);
                break;
            case "tpv_addclaim":
            case "tpv_addclaimdk":
                addClaim(itemKey);
                break;
            case "tpv_generate":
            case "tpv_generatedk"://生成点价单
                tpvGenerate(itemKey);
                break;
            case "tpv_advancan":
            case "tpv_advancandk"://生成预售解除单
                tpvAdvancan(itemKey);
                break;
            case "tpv_modify"://修改是否轮库
                showForm("tpv_tm_modify", "tpv_modify");
                break;
            case "tpv_curfactor"://期现要素修正
                showForm("tpv_tm_curfactor", "tpv_curfactor");
                break;
            case "tpv_sedmatching":// 二次匹配
            case "tpv_sedmatchingdk":// 二次匹配 代客
                sedmatching(itemKey);
                break;
        }
    }

    private void sedmatching(String itemKey) {
        this.getView().invokeOperation("save", YEM.getOptionNoMsg());
        this.getView().invokeOperation("refresh");
        IFormView view = this.getView();
        FormShowParameter parameter = new FormShowParameter();
        parameter.setStatus(OperationStatus.ADDNEW);
        parameter.getOpenStyle().setShowType(ShowType.Modal);
        Map<String, Object> map = new HashMap<>();
        map.put("key", itemKey);
        map.put("tpv_sedmatching", "tpv_sedmatching");
        parameter.setCustomParams(map);
        parameter.setFormId("tpv_tm_claipopup");
        parameter.setCloseCallBack(new CloseCallBack(this, "tpv_claim"));
        view.showForm(parameter);
    }

    private void showForm(String a, String b) {//a:动态表单标识，b:回调标识
        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setStatus(OperationStatus.ADDNEW);
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setFormId(a);
        showParameter.setCloseCallBack(new CloseCallBack(this, b));
        this.getView().showForm(showParameter);
    }

    private void tpvAdvancan(String itemKey) {
        String enty = "";
        String tpvAdvandk = "";
        if (itemKey.contains("dk")) {//代客套保
            enty = "tpv_tm_activehed";
            tpvAdvandk = "tpv_advandk";
        } else {//主动套保
            enty = "tpv_tm_iniactivehed";
            tpvAdvandk = "tpv_iniadvan";
        }
        EntryGrid entryGrid = this.getControl(enty);
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length == 0) {
            this.getView().showTipNotification("请先选择分录中的一行数据！");
            return;
        }
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection collection = dataEntity.getDynamicObjectCollection(enty);
        for (int selectRow : selectRows) {
            String tpvInpricenumdk = collection.get(selectRow).getString(tpvAdvandk);
            if (YEM.isNotEmpty(tpvInpricenumdk)) {
                this.getView().showTipNotification("选择行中包含已下推协平单的数据！");
                return;
            }
        }
        for (int selectRow : selectRows) {
            DynamicObject data = collection.get(selectRow);
            PushArgs pushArgs = new PushArgs();
            pushArgs.setSourceEntityNumber(dataEntity.getDataEntityType().getName());
            pushArgs.setTargetEntityNumber("tpv_tm_kyoping");//协平单
            pushArgs.setBuildConvReport(true); // 是否输出详细错误报告
            List<ListSelectedRow> selectedRows = new ArrayList<>();
            ListSelectedRow listSelectedRow = new ListSelectedRow(dataEntity.getLong("id"));//单据id
            listSelectedRow.setEntryEntityKey(enty);
            listSelectedRow.setEntryPrimaryKeyValue(data.getLong("id"));
            selectedRows.add(listSelectedRow);
//            ListSelectedRow srcBill1 = new ListSelectedRow(data.getPkValue());
//            selectedRows.add(srcBill1);
            pushArgs.setRuleId(""); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则;
            pushArgs.setSelectedRows(selectedRows); // 必选，设置需要下推的源单及分录内码
            pushArgs.setAutoSave(true);//是否保存
            ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
            MainEntityType targetMainType = EntityMetadataCache.getDataEntityType("tpv_tm_kyoping");
            List<DynamicObject> targetBillObjs = pushResult.loadTargetDataObjects(new IRefrencedataProvider() {
                @Override
                public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                    BusinessDataReader.loadRefence(objs, dType);
                }
            }, targetMainType);
            OperationResult saveOperate = OperationServiceHelper.executeOperate("save", "tpv_tm_kyoping",
                    targetBillObjs.toArray(new DynamicObject[0]), OperateOption.create());
        }
    }

    private void tpvGenerate(String itemKey) {
        String enty = "";
        String tpvInpricenumdk = "";
        String tpvInitradingdirec = "";
        if (itemKey.contains("dk")) {//代客套保
            enty = "tpv_tm_activehed";
            tpvInpricenumdk = "tpv_inpricenumdk";
            tpvInitradingdirec = "tpv_tradingdirecdk";
        } else {//主动套保
            enty = "tpv_tm_iniactivehed";
            tpvInpricenumdk = "tpv_inipricenum";
            tpvInitradingdirec = "tpv_initradingdirec";
        }
        EntryGrid entryGrid = this.getControl(enty);
        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length == 0) {
            this.getView().showTipNotification("请先选择分录中的一行数据！");
            return;
        }
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        DynamicObjectCollection collection = dataEntity.getDynamicObjectCollection(enty);
        Boolean isInpricenum = false;
        Boolean isTradingd = false;
        for (int selectRow : selectRows) {
            String tpvInpricenum = collection.get(selectRow).getString(tpvInpricenumdk);
            String initradingdirec = collection.get(selectRow).getString(tpvInitradingdirec);
            if (YEM.isNotEmpty(tpvInpricenum)) {
                isInpricenum = true;
            }
            if ("A".equals(initradingdirec)) {//需选择分录且控制选择的分录中【交易方向】 =“买入”
                isTradingd = true;
            }
        }
        if (isInpricenum) {
            this.getView().showTipNotification("选择行中包含已下推点价单的数据！");
            return;
        }
        if (isTradingd) {
            this.getView().showTipNotification("选择行中包含交易方向未卖出的数据！");
            return;
        }
        for (int selectRow : selectRows) {
            DynamicObject data = collection.get(selectRow);
            PushArgs pushArgs = new PushArgs();
            pushArgs.setSourceEntityNumber(dataEntity.getDataEntityType().getName());
            pushArgs.setTargetEntityNumber("avic_valence");//点价单
            pushArgs.setBuildConvReport(true); // 是否输出详细错误报告
            List<ListSelectedRow> selectedRows = new ArrayList<>();
            ListSelectedRow listSelectedRow = new ListSelectedRow(dataEntity.getLong("id"));//单据id
            listSelectedRow.setEntryEntityKey(enty);
            listSelectedRow.setEntryPrimaryKeyValue(data.getLong("id"));
            selectedRows.add(listSelectedRow);
            pushArgs.setRuleId(""); // 可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
            pushArgs.setSelectedRows(selectedRows); // 必选，设置需要下推的源单及分录内码
            pushArgs.setAutoSave(true);//是否保存
            ConvertOperationResult pushResult = ConvertServiceHelper.push(pushArgs);
            MainEntityType targetMainType = EntityMetadataCache.getDataEntityType("avic_valence");
            List<DynamicObject> targetBillObjs = pushResult.loadTargetDataObjects(new IRefrencedataProvider() {
                @Override
                public void fillReferenceData(Object[] objs, IDataEntityType dType) {
                    BusinessDataReader.loadRefence(objs, dType);
                }
            }, targetMainType);
            OperationResult saveOperate = OperationServiceHelper.executeOperate("save", "avic_valence",
                    targetBillObjs.toArray(new DynamicObject[0]), OperateOption.create());
        }

    }


    public void addClaim(String key) {
        this.getView().invokeOperation("save", YEM.getOptionNoMsg());
        this.getView().invokeOperation("refresh");
        IFormView view = this.getView();
        FormShowParameter parameter = new FormShowParameter();
        parameter.setStatus(OperationStatus.ADDNEW);
        parameter.getOpenStyle().setShowType(ShowType.Modal);
        Map<String, Object> map = new HashMap<>();
        map.put("key", key);
        parameter.setCustomParams(map);
        parameter.setFormId("tpv_tm_newncompany");
        parameter.setCloseCallBack(new CloseCallBack(this, "tpv_addclaim"));
        view.showForm(parameter);
    }

    public void canClaim(String itemKey) {
        IFormView view = this.getView();
        FormShowParameter parameter = new FormShowParameter();
        parameter.setStatus(OperationStatus.ADDNEW);
        parameter.getOpenStyle().setShowType(ShowType.Modal);
        Map<String, Object> map = new HashMap<>();
        EntryGrid entryGrid = null;
        if ("tpv_canclaim".equals(itemKey)) {
            entryGrid = this.getControl("tpv_tm_iniactivehed");
        } else {
            entryGrid = this.getControl("tpv_tm_activehed");
        }

        DynamicObject dataEntity = view.getModel().getDataEntity(true);
        DynamicObjectCollection tpvTmIniactivehed = null;
        String key = "";
        if ("tpv_canclaim".equals(itemKey)) {
            key = "tpv_tm_iniactivehed";
            tpvTmIniactivehed = dataEntity.getDynamicObjectCollection("tpv_tm_iniactivehed");
        } else {
            key = "tpv_tm_activehed";
            tpvTmIniactivehed = dataEntity.getDynamicObjectCollection("tpv_tm_activehed");
        }

        int[] selectRows = entryGrid.getSelectRows();
        if (selectRows.length == 0) {
            this.getView().showTipNotification("请选择一条数据！");
            return;
        }
        List<Long> idList = new ArrayList<>();
        for (int selectRow : selectRows) {
            if ("tpv_canclaim".equals(itemKey)) {
                idList.add(tpvTmIniactivehed.get(selectRow).getLong("tpv_sourceid"));
            } else {
                idList.add(tpvTmIniactivehed.get(selectRow).getLong("tpv_sourceiddk"));
            }

        }
        map.put("idList", idList);
        map.put("key", key);
        parameter.setCustomParams(map);
        parameter.setFormId("tpv_tm_calremarks");
        parameter.setCloseCallBack(new CloseCallBack(this, "tpv_canclaim"));
        view.showForm(parameter);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
//        iniactivehed();
//        transportation();
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
//        iniactivehed();
//        transportation();
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        String name = dataEntity.getDataEntityType().getName();
        DynamicObjectCollection tpvTmIniactivehed = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_tm_iniactivehed");
        if ("tpv_tm_positionorder".equals(name)) {
            if (tpvTmIniactivehed.size() != 0) {
                this.getView().setEnable(false, new String[]{"tpv_rotation", "tpv_salesregion", "tpv_strategynum", "tpv_basegoods"});
            } else {
                this.getView().setEnable(true, new String[]{"tpv_rotation", "tpv_salesregion", "tpv_strategynum", "tpv_basegoods"});
            }
        }
        if ("tpv_tm_conttranform".equals(name)) {
            ConttranFormPlugin.baseprices(model);
        }
    }


    /**
     * 根据《认领明细单》中【来源单据号】=【单据编号】查询【红冲标志】≠“已红冲”   且   【认领标志】=“认领”的《认领明细单》
     */
    public void iniactivehed() {

        String name = this.getModel().getDataEntity(true).getDataEntityType().getName();
        this.getModel().deleteEntryData("tpv_tm_iniactivehed");
        String billno = (String) this.getModel().getValue("billno");
        QFilter filter = new QFilter("tpv_datasourcesnum", "=", billno);
//        filter.and(new QFilter("tpv_redflush", "=", "A"));
        filter.and(new QFilter("tpv_redflush", QCP.not_in, new String[]{"A", "B"}));
        filter.and(new QFilter("tpv_claimlogo", "=", "A"));
        filter.and(new QFilter("tpv_coverup", "=", false));
        if ("tpv_tm_conttranform".equals(name)) {
            filter.and(new QFilter("tpv_pursale", "=", "tpv_claim"));
        }
        DynamicObject[] tpvTmClaimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails",
                "tpv_recordnum,tpv_contractool,tpv_dealprice,tpv_claimdetails,tpv_dealton,tpv_tradeway,tpv_dealdateday,tpv_dealdate,tpv_warehouse",
                filter.toArray());

        for (DynamicObject tpvTmClaimdetail : tpvTmClaimdetails) {
            int row = this.getModel().createNewEntryRow("tpv_tm_iniactivehed");
            this.getModel().setValue("tpv_inirecordnum", tpvTmClaimdetail.getString("tpv_recordnum"), row);//记录号
            this.getModel().setValue("tpv_inicontractool", tpvTmClaimdetail.getDynamicObject("tpv_contractool."), row);//合约代码
            this.getModel().setValue("tpv_initranprice", tpvTmClaimdetail.getBigDecimal("tpv_dealprice"), row);//成交价格
            this.getModel().setValue("tpv_ininumbertran", tpvTmClaimdetail.getBigDecimal("tpv_dealton"), row);//交易数量
            this.getModel().setValue("tpv_initradingday", tpvTmClaimdetail.getDate("tpv_dealdateday"), row);//交易日
            this.getModel().setValue("tpv_initradingtime", tpvTmClaimdetail.getDate("tpv_dealdate"), row);//成交时点
            this.getModel().setValue("tpv_iniwareclaim", tpvTmClaimdetail.getBoolean("tpv_warehouse"), row);//是否移仓认领
            this.getModel().setValue("tpv_sourceid", tpvTmClaimdetail.getLong("id"), row);//来源单据id
            if ("tpv_tm_positionorder".equals(name) || "tpv_dt_purchase".equals(name) || "tpv_dt_salescontract".equals(name)) {
                this.getModel().setValue("tpv_tradingdirec", tpvTmClaimdetail.get("tpv_tradeway"), row);//买卖方向
            }
        }
        DynamicObject[] tpvTmClaimcoverup = null;
        QFilter qFilter = new QFilter("tpv_datasourcesnum", "=", billno);
//        qFilter.and(new QFilter("tpv_redflush", "=", "A"));
        filter.and(new QFilter("tpv_redflush", QCP.not_in, new String[]{"A", "B"}));
        qFilter.and(new QFilter("tpv_claimlogo", "=", "A"));
        if ("tpv_dt_purchase".equals(name) || "tpv_dt_salescontract".equals(name) || "tpv_tm_kyoping".equals(name)) {
            qFilter.and(new QFilter("tpv_coverup", "=", true));
            tpvTmClaimcoverup = BusinessDataServiceHelper.load("tpv_tm_claimdetails",
                    "tpv_recordnum,tpv_contractool,tpv_dealprice,tpv_dealton,tpv_tradeway,tpv_dealdateday,tpv_dealdate,tpv_warehouse",
                    qFilter.toArray());
            this.getModel().deleteEntryData("tpv_tm_activehed");
            if (tpvTmClaimcoverup == null) {
                return;
            }
            for (DynamicObject tpvTmClaimdetail : tpvTmClaimcoverup) {
                int row = this.getModel().createNewEntryRow("tpv_tm_activehed");
                this.getModel().setValue("tpv_recordnum", tpvTmClaimdetail.getString("tpv_recordnum"), row);//记录号
                this.getModel().setValue("tpv_contractool", tpvTmClaimdetail.getDynamicObject("tpv_contractool."), row);//合约代码
                this.getModel().setValue("tpv_tranprice", tpvTmClaimdetail.getBigDecimal("tpv_dealprice"), row);//成交价格
                this.getModel().setValue("tpv_numbertran", tpvTmClaimdetail.getBigDecimal("tpv_dealton"), row);//交易数量
                this.getModel().setValue("tpv_tradingday", tpvTmClaimdetail.getDate("tpv_dealdateday"), row);//交易日
                this.getModel().setValue("tpv_tradingtime", tpvTmClaimdetail.getDate("tpv_dealdate"), row);//成交时点
                this.getModel().setValue("tpv_wareclaim", tpvTmClaimdetail.getBoolean("tpv_warehouse"), row);//是否移仓认领
                this.getModel().setValue("tpv_sourceiddk", tpvTmClaimdetail.getLong("id"), row);//来源单据id
            }
        } else if ("tpv_tm_conttranform".equals(name)) {
            qFilter.and(new QFilter("tpv_pursale", "=", "tpv_claimdk"));
            qFilter.and(new QFilter("tpv_coverup", "=", false));
            tpvTmClaimcoverup = BusinessDataServiceHelper.load("tpv_tm_claimdetails",
                    "tpv_recordnum,tpv_contractool,tpv_dealprice,tpv_dealton,tpv_tradeway,tpv_dealdateday,tpv_dealdate,tpv_warehouse",
                    qFilter.toArray());
            this.getModel().deleteEntryData("tpv_tm_activehed");
            if (tpvTmClaimcoverup == null) {
                return;
            }
            for (DynamicObject tpvTmClaimdetail : tpvTmClaimcoverup) {
                int row = this.getModel().createNewEntryRow("tpv_tm_activehed");
                this.getModel().setValue("tpv_recordnum", tpvTmClaimdetail.getString("tpv_recordnum"), row);//记录号
                this.getModel().setValue("tpv_contractool", tpvTmClaimdetail.getDynamicObject("tpv_contractool."), row);//合约代码
                this.getModel().setValue("tpv_tranprice", tpvTmClaimdetail.getBigDecimal("tpv_dealprice"), row);//成交价格
                this.getModel().setValue("tpv_numbertran", tpvTmClaimdetail.getBigDecimal("tpv_dealton"), row);//交易数量
                this.getModel().setValue("tpv_tradingday", tpvTmClaimdetail.getDate("tpv_dealdateday"), row);//交易日
                this.getModel().setValue("tpv_tradingtime", tpvTmClaimdetail.getDate("tpv_dealdate"), row);//成交时点
                this.getModel().setValue("tpv_wareclaim", tpvTmClaimdetail.getBoolean("tpv_warehouse"), row);//是否移仓认领
                this.getModel().setValue("tpv_sourceiddk", tpvTmClaimdetail.getLong("id"), row);//来源单据id
            }
        }
    }

    @Override
    public void beforePropertyChanged(PropertyChangedArgs e) {
        super.beforePropertyChanged(e);

    }


    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        ChangeData changeData = e.getChangeSet()[0];
        Object oldValue = changeData.getOldValue();
        switch (name) {
            case "tpv_rotationen":
            case "tpv_mulpolicy":
                rotation();
                rotationenPurSale();
                break;
            case "tpv_transportation"://运杂费
            case "tpv_baseprices"://合同基价
            case "tpv_padjustment"://基价调整
            case "tpv_whetherprice"://是否点价 采
            case "tpv_isvertex"://是否点价 销
            case "tpv_literdiscount"://升贴水 采
            case "tpv_upwarddiscount"://升贴水 销
//                transportation();
                whetherprice();
                whetherpriceShip();
                break;
            case "tpv_policynumber"://策略号 采购合同
            case "tpv_policyber"://策略号 销售发货
            case "tpv_strategynum"://策略号 销售合同
//                policyber(oldValue, name);
                break;
        }
    }
    private void whetherpriceShip() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        String name = dataEntity.getDataEntityType().getName();
        if ("tpv_dt_salesshipping".equals(name)) {
            String billno = dataEntity.getString("billno");
            BigDecimal tpvBaseprice = dataEntity.getBigDecimal("tpv_baseprices");//基价价格
            BigDecimal tpvPadjustment = dataEntity.getBigDecimal("tpv_padjustment");//基价调整
            BigDecimal price = BigDecimal.ZERO;//价格
            BigDecimal tatal = BigDecimal.ZERO;//数量
            tpvBaseprice = tpvBaseprice != null ? tpvBaseprice : BigDecimal.ZERO;
            tpvPadjustment = tpvPadjustment != null ? tpvPadjustment : BigDecimal.ZERO;
            DynamicObject[] tmClaimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", "tpv_dealton,tpv_dealprice", new QFilter[]{new QFilter("tpv_tradeway", "=", "SELL"),
                    new QFilter("tpv_warehouse", "=", true), new QFilter("tpv_datasourcesnum", "=", billno),new QFilter("tpv_redflush","=","")});
            for (DynamicObject tmClaimdetail : tmClaimdetails) {
                BigDecimal tpvDealton = tmClaimdetail.getBigDecimal("tpv_dealton");//交易吨数
                BigDecimal tpvDealprice = tmClaimdetail.getBigDecimal("tpv_dealprice");//成交价格
                price = price.add(tpvDealton.multiply(tpvDealprice));
                tatal = tatal.add(tpvDealton);
            }
            if (tatal.compareTo(BigDecimal.ZERO) != 0) {
                this.getModel().setValue("tpv_basis", tpvBaseprice.add(tpvPadjustment).subtract(price.divide(tatal, BigDecimal.ROUND_HALF_UP)));
            } else {
                this.getModel().setValue("tpv_basis", tpvBaseprice.add(tpvPadjustment));
            }
        }
    }
    private void whetherprice() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        String name = dataEntity.getDataEntityType().getName();
        if ("tpv_dt_purchase".equals(name) || "tpv_dt_salescontract".equals(name)) {
            Map<String, String> fieldName = entryFieldName(name);
            boolean tpvWhetherprice = dataEntity.getBoolean(fieldName.get("tpvIsvertex"));//是否点价
            String billno = dataEntity.getString("billno");
            if (tpvWhetherprice) {
                BigDecimal tpvLiterdiscount = dataEntity.getBigDecimal(fieldName.get("upwarddiscount"));//升贴水
                this.getModel().setValue("tpv_basis", tpvLiterdiscount);
            } else {
                BigDecimal tpvMiscellcharges = dataEntity.getBigDecimal(fieldName.get("upwarddiscount"));//暂估运杂费
                BigDecimal tpvBaseprice = dataEntity.getBigDecimal("tpv_baseprices");//基价价格
                BigDecimal tpvPadjustment = dataEntity.getBigDecimal("tpv_padjustment");//基价调整
                BigDecimal price = BigDecimal.ZERO;//价格
                BigDecimal tatal = BigDecimal.ZERO;//数量
                tpvMiscellcharges = tpvMiscellcharges != null ? tpvMiscellcharges : BigDecimal.ZERO;
                tpvBaseprice = tpvBaseprice != null ? tpvBaseprice : BigDecimal.ZERO;
                tpvPadjustment = tpvPadjustment != null ? tpvPadjustment : BigDecimal.ZERO;
                DynamicObject[] tmClaimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", "tpv_dealton,tpv_dealprice", new QFilter[]{new QFilter("tpv_tradeway", "=", "SELL"),
                        new QFilter("tpv_warehouse", "=", true), new QFilter("tpv_datasourcesnum", "=", billno),new QFilter("tpv_redflush","=","")});
                for (DynamicObject tmClaimdetail : tmClaimdetails) {
                    BigDecimal tpvDealton = tmClaimdetail.getBigDecimal("tpv_dealton");//交易吨数
                    BigDecimal tpvDealprice = tmClaimdetail.getBigDecimal("tpv_dealprice");//成交价格
                    price = price.add(tpvDealton.multiply(tpvDealprice));
                    tatal = tatal.add(tpvDealton);
                }
                if (tatal.compareTo(BigDecimal.ZERO) != 0) {
                    this.getModel().setValue("tpv_basis", tpvMiscellcharges.add(tpvBaseprice).add(tpvPadjustment).subtract(price.divide(tatal, BigDecimal.ROUND_HALF_UP)));
                } else {
                    this.getModel().setValue("tpv_basis", tpvMiscellcharges.add(tpvBaseprice).add(tpvPadjustment));
                }
            }
        }
    }

    private void policyber(Object oldValue, String name) {
        DynamicObject policyber = (DynamicObject) this.getModel().getValue(name);
        if (policyber != null) {
            List<Long> claimList = new ArrayList<>();
            List<Long> policyberList = new ArrayList<>();
            DynamicObject[] claimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", "tpv_claimablesnapin", new QFilter[]{new QFilter("tpv_datasourcesid", "=", this.getModel().getDataEntity(true).getPkValue().toString()),new QFilter("tpv_redflush","=","")});
            if (claimdetails.length == 0) {
                return;
            }
            for (DynamicObject claimdetail : claimdetails) {
                DynamicObjectCollection tpvClaimablesnapins = claimdetail.getDynamicObjectCollection("tpv_claimablesnapin");
                for (DynamicObject tpvClaimablesnapin : tpvClaimablesnapins) {
                    claimList.add(tpvClaimablesnapin.getDynamicObject("fbasedataid").getLong("id"));
                }
            }
            DynamicObject strategys = BusinessDataServiceHelper.loadSingle("tpv_bd_strategy", new QFilter[]{new QFilter("id", "=", policyber.getPkValue())});
            DynamicObjectCollection tpvBdStrategyXts = strategys.getDynamicObjectCollection("tpv_bd_strategy_xt");//协同部门
            for (DynamicObject tpvBdStrategyXt : tpvBdStrategyXts) {
                DynamicObject tpvTermdefinition = tpvBdStrategyXt.getDynamicObject("tpv_termdefinition");
                if (tpvTermdefinition != null) {
                    policyberList.add(tpvTermdefinition.getLong("id"));
                }
            }
            boolean anied=false;
            if (claimList.size()==0 ||policyberList.size()==0) {
                anied=true;
            }else {
               anied = policyberList.stream().anyMatch(policyberList::contains);
            }
            if (anied) {
                this.getView().showTipNotification("已认领的交易记录与该策略的管理单元冲突，请先取消认领再修改!");
                this.getModel().beginInit();
                this.getModel().setValue(name, oldValue);
                this.getModel().endInit();
                this.getView().updateView(name);
            }
        }
    }


    /**
     * 自动计算，
     * 1、当【归属合同】=“采购合同”时=【运杂费】+【合同基价】-（主动套保分录中【交易方向】=“卖出”的数据的【成交价格】加权平均值，
     * 2、当【归属合同】=“销售合同”时=【运杂费】+【合同基价】-（主动套保分录中【交易方向】=“卖入”的数据的【成交价格】加权平均值,
     */
//    private void transportation() {
//        DynamicObject dataEntity = this.getModel().getDataEntity(true);
//        String name = dataEntity.getDataEntityType().getName();
//        if (!"tpv_tm_positionorder".equals(name) && !("tpv_dt_purchase".equals(name) || "tpv_dt_salescontract".equals(name))) {
//            return;
//        }
////        String tpvSource = dataEntity.getString("tpv_source");
//        BigDecimal tpvTransportation = dataEntity.getBigDecimal("tpv_transportation");
//        BigDecimal tpvBaseprices = dataEntity.getBigDecimal("tpv_baseprices");
//        DynamicObjectCollection tpvTmIniactivehed = dataEntity.getDynamicObjectCollection("tpv_tm_iniactivehed");
//
//        BigDecimal price = BigDecimal.ZERO;//价格
//        BigDecimal tatal = BigDecimal.ZERO;//数量
//        BigDecimal purCount = BigDecimal.ZERO;//采购权重
//        BigDecimal saleCount = BigDecimal.ZERO;//销售权重
//
//        for (DynamicObject dynamicObject : tpvTmIniactivehed) {
//            BigDecimal tpvInitranprice = dynamicObject.getBigDecimal("tpv_initranprice");//成交价格
//            BigDecimal tpvIninumbertran = dynamicObject.getBigDecimal("tpv_ininumbertran");//交易数量
//            String tpvTradingdirec = dynamicObject.getString("tpv_tradingdirec");//交易数量
////            if ("A".equals(tpvSource)) {//采购合同
//                if ("SELL".equals(tpvTradingdirec)) {
//                    price = price.add(tpvInitranprice);
//                    tatal = tatal.add(tpvIninumbertran);
//                    purCount = tatal.multiply(price);
//                }
////            } else if ("B".equals(tpvSource)) {//销售合同
//                if ("BUY".equals(tpvTradingdirec)) {
//                    price = price.add(tpvInitranprice);
//                    tatal = tatal.add(tpvIninumbertran);
//                    saleCount = tatal.multiply(price);
////                }
//            }
//        }
////        if (price.compareTo(BigDecimal.ZERO) == 0 || tatal.compareTo(BigDecimal.ZERO) == 0 || purCount.compareTo(BigDecimal.ZERO) == 0 || saleCount.compareTo(BigDecimal.ZERO) == 0) {
////            this.getModel().setValue("tpv_basis", tpvTransportation.add(tpvBaseprices));
////        } else {
////        if ("tpv_dt_purchase".equals(tpvSource)) {//采购合同
////            this.getModel().setValue("tpv_basis", tpvTransportation.add(tpvBaseprices).subtract(purCount.divide(tatal.compareTo(BigDecimal.ZERO) == 0 ? BigDecimal.ONE : tatal, 2, BigDecimal.ROUND_HALF_UP)));
////        } else if ("B".equals(tpvSource)) {//销售合同
////            this.getModel().setValue("tpv_basis", tpvTransportation.add(tpvBaseprices).subtract(saleCount.divide(tatal.compareTo(BigDecimal.ZERO) == 0 ? BigDecimal.ONE : tatal, 2, BigDecimal.ROUND_HALF_UP)));
////        }
////        }
//    }

    /**
     * 【是否多个策略】由是改为否时，需校验下游没有《头寸业务单》；
     * 【是否多个策略】由否改为是时，需校验｛主动套保-分录｝为空（即查不出来值）；
     */
    private void rotationenPurSale() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        String name = dataEntity.getDataEntityType().getName();
        if ("tpv_dt_purchase".equals(name) || "tpv_dt_salescontract".equals(name)) {
            String tpvRotationenr = (String) this.getModel().getValue("tpv_rotationen");
            Boolean tpvRotation = (Boolean) this.getModel().getValue("tpv_mulpolicy");

            if (!tpvRotation) {//由是变成否
                String billno = dataEntity.getString("billno");
                DynamicObject[] tmPositionorder = BusinessDataServiceHelper.load("tpv_tm_positionorder", "", new QFilter[]{new QFilter("tpv_sourcebillno", "=", billno)});
                if (tmPositionorder.length != 0) {
                    this.getView().showTipNotification("下游存在头寸业务单，不允许修改！");
                    this.getModel().setValue("tpv_mulpolicy", !tpvRotation);
                    this.getView().updateView("tpv_mulpolicy");
                }
            } else if (tpvRotation) {//由否变成是
                DynamicObjectCollection tpvTmActivehed = dataEntity.getDynamicObjectCollection("tpv_tm_iniactivehed");
                if (tpvTmActivehed.size() != 0) {
                    this.getModel().setValue("tpv_mulpolicy", !tpvRotation);
                    this.getView().showTipNotification("主动套保-分录所有数据取消认领后才允许编辑");
                    this.getView().updateView("tpv_mulpolicy");
                }
            }
        }
    }

    /**
     * 手工录入，枚举（是、否），默认=”否“，
     * 1、=”是“时，隐藏{主动套保-分录}；
     * 2、如果{主动套保-分录}已存在数据则不允许编辑该字段，（提示语：主动套保-分录所有数据取消认领后才允许编辑；）
     */
    public void rotation() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        String name = dataEntity.getDataEntityType().getName();
        if (!"tpv_tm_positionorder".equals(name)) {
            return;
        }
        DynamicObjectCollection tpvTmActivehed = dataEntity.getDynamicObjectCollection("tpv_tm_iniactivehed");
        if (tpvTmActivehed.size() != 0) {
            String tpvRotationenr = (String) this.getModel().getValue("tpv_rotationenr");
            this.getModel().setValue("tpv_rotationen", tpvRotationenr);
            this.getView().showErrorNotification("主动套保-分录所有数据取消认领后才允许编辑");
            //this.getView().updateView("tpv_rotationen");
        } else {
            this.getModel().setValue("tpv_rotationenr", this.getModel().getValue("tpv_rotationen"));
            this.getView().updateView("tpv_rotationenr");
        }
    }

    public void claim(String key) {
        this.getView().invokeOperation("save", YEM.getOptionNoMsg());
        this.getView().invokeOperation("refresh");
        IFormView view = this.getView();
        FormShowParameter parameter = new FormShowParameter();
        parameter.setStatus(OperationStatus.ADDNEW);
        parameter.getOpenStyle().setShowType(ShowType.Modal);
        Map<String, Object> map = new HashMap<>();
        map.put("key", key);
        parameter.setCustomParams(map);
        parameter.setFormId("tpv_tm_claipopup");
        parameter.setCloseCallBack(new CloseCallBack(this, "tpv_claim"));
        view.showForm(parameter);
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String key = e.getOperateKey();
        IDataModel model = this.getModel();
        DynamicObject dataEntity = model.getDataEntity(true);
        String name = dataEntity.getDataEntityType().getName();
        switch (key) {
            case "donothing":
//                iniactivehed();
                DynamicObjectCollection tpvTmIniactivehed = this.getModel().getDataEntity(true).getDynamicObjectCollection("tpv_tm_iniactivehed");
                if ("tpv_tm_positionorder".equals(name)) {
                    if (tpvTmIniactivehed.size() != 0) {
                        this.getView().setEnable(false, new String[]{"tpv_rotation", "tpv_salesregion", "tpv_strategynum", "tpv_basegoods"});
                    } else {
                        this.getView().setEnable(true, new String[]{"tpv_rotation", "tpv_salesregion", "tpv_strategynum", "tpv_basegoods"});
                    }
                }
                whetherprice();
                whetherpriceShip();
                break;
        }
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);
        String actionId = e.getActionId();
        if (actionId.equals("tpv_addclaim")) {
            String returnData = (String) e.getReturnData();
            if (returnData != null) {
                if (returnData.equals("success")) {
                    this.getView().showSuccessNotification("生成成功！！！");
                }
            }
        }
        if (StringUtils.equals(e.getActionId(), "tpv_modify")) {
            this.getView().invokeOperation("save", YEM.getOptionNoMsg());
        }
        whetherprice();
        whetherpriceShip();
    }

    public static Map<String, String> entryFieldName(String entityName) {
        Map<String, String> map = new HashMap<>();
        String tpvIsvertex = "";//是否点价
        String miscellcharges = "";//运杂费
        String upwarddiscount = "";//升贴水
        switch (entityName) {
            case "tpv_dt_salescontract"://销售合同(原始)
                tpvIsvertex = "tpv_isvertex";
                miscellcharges = "tpv_miscellcharges";
                upwarddiscount = "tpv_upwarddiscount";
                break;
            case "tpv_dt_purchase"://采购合同(原始)
                tpvIsvertex = "tpv_whetherprice";
                miscellcharges = "tpv_freightexpenses";
                upwarddiscount = "tpv_literdiscount";
                break;
        }
        map.put("tpvIsvertex", tpvIsvertex); //是否点价
        map.put("miscellcharges", miscellcharges); //运杂费
        map.put("upwarddiscount", upwarddiscount); //升贴水
        return map;
    }
}
