package tpv.tpv_wm.tpv_tm.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

/**
 * @author 金亮
 * @date 2024/4/24 16:47
 * @relevantfile  销售合同（tpv_dt_salescontract）
 * @description  单据保存的时候：将商品分录第一行中的【商品编号】的编码和分类 赋值给【实物商品物料分类】和【实物商品物料编码】
 * @versions 1.0
 */
public class SalesContractFormPlugin extends AbstractBillPlugIn {
    @Override
    public void afterDoOperation(AfterDoOperationEventArgs e) {
        super.afterDoOperation(e);
        String key = e.getOperateKey();
        if (key.equals("save") || key.equals("submit")){
            boolean success = e.getOperationResult().isSuccess();
            if (success){
                IDataModel model = this.getModel();
                DynamicObject dataEntity = model.getDataEntity(true);
                DynamicObjectCollection materialentry = dataEntity.getDynamicObjectCollection("tpv_materialentry");
                if (materialentry ==null || materialentry.size()==0){
                    return;
                }
                DynamicObject material = (DynamicObject) model.getValue("tpv_material", 0);//商品编号
                if (material == null){
                    model.setValue("tpv_commoditycodj",null);//实物商品物料编码
                    model.setValue("tpv_commodityclassifyj",null);//实物商品物料分类
                    return;
                }
                model.setValue("tpv_commoditycodj",material); //实物商品物料编码
                //查询物料分类
                QFilter qFiltera = new QFilter("material.id", QCP.in, material.getLong("id"));
                qFiltera.and(new QFilter("standard.number", QCP.equals, "JBFLBZ"));
                DynamicObject materialClass = BusinessDataServiceHelper.loadSingle("bd_materialgroupdetail", "id,group,material", new QFilter[]{qFiltera});
                DynamicObject group = materialClass.getDynamicObject("group");//分组
                model.setValue("tpv_commodityclassifyj",group);//实物商品物料分类
                SaveServiceHelper.save(new DynamicObject[]{dataEntity});
            }
        }

    }
}
