package tpv.tpv_wm.tpv_tm.java.formplugin.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * @ClassName: SnapdefinitionFormPlugin
 * @Description: 管理单元定义
 * @author: zbh
 * @date: 2024-07-23
 */
public class SnapdefinitionFormPlugin extends AbstractFormPlugin implements BeforeF7SelectListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit tpv_branch = this.getControl("tpv_branch");
        tpv_branch.addBeforeF7SelectListener(this);
        ;
    }

    @Override
    public void beforeF7Select(BeforeF7SelectEvent e) {
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_branch":
                tpvBranchF7(e);
                break;
        }
    }

    private void tpvBranchF7(BeforeF7SelectEvent e) {
        ListShowParameter showParameterrd = (ListShowParameter) e.getFormShowParameter();

        List<QFilter> QFiltersrd = new ArrayList();

        List<Long> depLongs = new ArrayList<>();
        DynamicObject[] bosAdminorgs = BusinessDataServiceHelper.load("bos_adminorg", "structure,viewparent", null);
        for (DynamicObject bosAdminorg : bosAdminorgs) {
            DynamicObjectCollection structures = bosAdminorg.getDynamicObjectCollection("structure");
            for (DynamicObject structure : structures) {
                DynamicObject viewparent = structure.getDynamicObject("viewparent");
                if (viewparent!=null){
                    depLongs.add(viewparent.getLong("id"));

                }
            }
        }
        QFiltersrd.add(new QFilter("id", QCP.not_in, depLongs));
        showParameterrd.getListFilterParameter().setQFilters(QFiltersrd);
    }
}
