package tpv.tpv_wm.tpv_tm.java.formplugin.list;

import com.itopview.wm.utils.YEM;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.report.CellStyle;
import kd.bos.list.BillList;
import kd.bos.list.IListColumn;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * @Description: 基价商品价格 -列表插件
 * @Author LinRui
 * @Date 2024/8/26 16:16
 */
public class BasisMarketPriceListPlugin  extends AbstractListPlugin {

    //根据单据状态更改单据颜色
    @Override
    public void afterBindData(EventObject e) {
        // TODO Auto-generated method stub
        super.afterBindData(e);
        // 获取单据列表控件
        BillList billList = this.getControl("billlistap");
        //获取页面显示的字段列表
        List<IListColumn> showListColums = billList.getShowListColumns();
        //获取当前页的数据
        ListSelectedRowCollection rowCollection = billList.getCurrentListAllRowCollection();
        for (ListSelectedRow listSelectedRow : rowCollection) {
            //获取行号
            int rowKey = listSelectedRow.getRowKey();
            //获取主键
            Long primaryKeyValue = (Long) listSelectedRow.getPrimaryKeyValue();
            Long entryPrimaryKeyValue = (Long) listSelectedRow.getEntryPrimaryKeyValue();
            //获取行所有行数据 数据库内码 使用缓存
            List<CellStyle> cellStyles = new ArrayList<>();
            CellStyle cellStyle = new CellStyle();
            //获取行所有行数据 数据库内码 使用缓存
            DynamicObject loadSingleFromCache = BusinessDataServiceHelper.loadSingleFromCache(primaryKeyValue, "tpv_tm_basismarketprice");
            for (DynamicObject dynamicObject : loadSingleFromCache.getDynamicObjectCollection("tpv_tm_marketprice")) {
                long aLong = dynamicObject.getLong("id");
                if (YEM.isNotEmpty(entryPrimaryKeyValue)) {
                    if (entryPrimaryKeyValue.longValue() == aLong) {
                        //获取状态值
                        boolean exeResult = dynamicObject.getBoolean("tpv_changestyle");
                        //插入行号
                        cellStyle.setRow(rowKey);
                        if (exeResult) {
                            cellStyle.setBackColor("#FFF3CA");
                            //获取行所有字段名称 并吧.name 变成_name
                            for (IListColumn iListColumn : showListColums) {
                                if (dynamicObject.getDataEntityType().getProperties()
                                        .containsKey(YEM.substringBeforeLast(iListColumn.getListFieldKey().toString(), "."))) {
                                    if (iListColumn.getListFieldKey().toString().contains(".")) {
                                        String obj = iListColumn.getListFieldKey().toString().replace(".", "_");
                                        cellStyle.setFieldKey(obj);
                                        cellStyles.add(cellStyle);
                                        billList.setCellStyle(cellStyles);
                                    } else {
                                        cellStyle.setFieldKey(iListColumn.getListFieldKey());
                                        cellStyles.add(cellStyle);
                                        billList.setCellStyle(cellStyles);
                                    }
                                }
                            }
                        }
                    }
                }
            }

            billList.setCellStyle(cellStyles);
        }
    }
}
