package tpv.tpv_wm.tpv_tm.java.opplugin.op;

import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description: 基价商品价格 -服务插件
 * @Author LinRui
 * @Date 2024/8/28 17:44
 */
public class BasisMarketPriceServiceOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_tm_marketprice"); //分录
        fieldKeys.add("tpv_bizdate"); //申请日期
        fieldKeys.add("tpv_region"); //大区
        fieldKeys.add("tpv_basecommodity"); //基价商品
        fieldKeys.add("tpv_unitprice"); //单价
        fieldKeys.add("tpv_changestyle");
        fieldKeys.add("createtime"); //创建时间
    }

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);

    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        String key = e.getOperationKey();
        switch (key) {
            case "save":
                DynamicObject[] bills1 = e.getDataEntities();
                for (int i = 0; i < bills1.length; ++i) {
                    DynamicObject bill = bills1[i];
                    DynamicObjectCollection tpvTmMarketprice = bill.getDynamicObjectCollection("tpv_tm_marketprice");
                    Map<Long, Map<Long, BigDecimal>> map = new HashMap<>();
                    for (DynamicObject dynamicObject : tpvTmMarketprice) {
                        DynamicObject tpvRegion = dynamicObject.getDynamicObject("tpv_region");
                        if (YEM.isNotEmpty(tpvRegion)) {
                            if (!map.containsKey(tpvRegion.getLong("id"))) {
                                Map<Long, BigDecimal> entryIdMap = new HashMap<>();
                                entryIdMap.put(dynamicObject.getLong("id"),
                                        BigDecimalUtils.toBigDecimal(dynamicObject.getBigDecimal("tpv_unitprice")));
                                map.put(tpvRegion.getLong("id"),entryIdMap);
                            } else {
                                map.get(tpvRegion.getLong("id")).put(dynamicObject.getLong("id"),
                                        BigDecimalUtils.toBigDecimal(dynamicObject.getBigDecimal("tpv_unitprice")));
                            }
                        }
                    }
                    QFilter qFilter = new QFilter("id", QCP.not_equals, bill.getLong("id"));
                    qFilter.and(new QFilter("createtime", QCP.less_than,bill.getDate("createtime")));
//                    qFilter.and(new QFilter("tpv_tm_marketprice.tpv_region.id", QCP.in, Arrays.asList(map.keySet())));
                    DataSet dataSet = ORM.create().queryDataSet(this.getClass().getName(), bill.getDataEntityType().getName(),
                                    "id,createtime,tpv_bizdate,tpv_tm_marketprice entryid,tpv_tm_marketprice.tpv_unitprice tpv_unitprice," +
                                            "tpv_tm_marketprice.tpv_region.id tpv_region,tpv_tm_marketprice.tpv_basecommodity.id tpv_basecommodity"
                                    , qFilter.toArray()).groupBy(new String[]{"tpv_region"}).maxP("createtime","tpv_unitprice").finish()
                            .select("tpv_region","tpv_unitprice");
                    dataSet = RptUtil.zeroNullNums(dataSet);
//                    DynamicObjectCollection dynamicObjects = ORM.create().toPlainDynamicObjectCollection(dataSet.copy());
                    Map<Long, BigDecimal> priceMap = new HashMap<>();
                    for (Row row : dataSet) {
                        priceMap.put(row.getLong("tpv_region"), row.getBigDecimal("tpv_unitprice"));
                    }
                    for (DynamicObject dynamicObject : tpvTmMarketprice) {
                        DynamicObject tpvRegion = dynamicObject.getDynamicObject("tpv_region");
                        if (YEM.isNotEmpty(tpvRegion)) {
                            if (priceMap.containsKey(tpvRegion.getLong("id")) && map.containsKey(tpvRegion.getLong("id"))) {
                                BigDecimal price = priceMap.get(tpvRegion.getLong("id"));
                                Map<Long, BigDecimal> entryIdMap = map.get(tpvRegion.getLong("id"));
                                if (entryIdMap.containsKey(dynamicObject.getLong("id"))) {
                                    BigDecimal tpv_unitprice = entryIdMap.get(dynamicObject.getLong("id"));
                                    BigDecimal nums = tpv_unitprice.subtract(price).abs();
                                    if (nums.compareTo(new BigDecimal("50")) >= 0) {
                                        dynamicObject.set("tpv_changestyle", true);
                                    } else {
                                        dynamicObject.set("tpv_changestyle", false);
                                    }
                                }
                            }
                        }
                    }
                    SaveServiceHelper.save(new DynamicObject[]{bill});
                }
                break;
            case "submit":case "audit":
                DynamicObject[] bills2 = e.getDataEntities();
                for (int i = 0; i < bills2.length; ++i) {
                    DynamicObject bill = bills2[i];
                    OperationServiceHelper.executeOperate("save", bill.getDataEntityType().getName(),
                            new DynamicObject[]{bill}, YEM.getOptionNoMsg());
                }
                break;
            default:
                break;
        }
    }
}
