package tpv.tpv_wm.tpv_tm.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.math.BigDecimal;
import java.util.List;

/**
 * @ClassName: ClaimdetailsDeleteOp
 * @Description: 认领明细单
 * 删除反写认领数量
 * @author: zbh
 * @date: 2024-07-30
 */
public class ClaimdetailsDeleteOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_dealrecord");
        fieldKeys.add("tpv_dealton");
    }

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        String key = e.getOperationKey();
        switch (key) {
            case "delete":
                delete(e);
                break;
        }
    }

    private void delete(BeforeOperationArgs e) {
        DynamicObject[] entities = e.getDataEntities();
        for (DynamicObject entity : entities) {
            long tpvDealrecord = entity.getLong("tpv_dealrecord");
            if (tpvDealrecord!=0){
                BigDecimal tpvDealton = entity.getBigDecimal("tpv_dealton");//交易吨数
                DynamicObject tpvTmDealrecord = BusinessDataServiceHelper.loadSingle(tpvDealrecord, "tpv_tm_dealrecord");
                BigDecimal tpvClaimcqqty = tpvTmDealrecord.getBigDecimal("tpv_claimcqqty");//已认领数量(苍穹)
                tpvTmDealrecord.set("tpv_claimcqqty",tpvClaimcqqty.subtract(tpvDealton));
                SaveServiceHelper.save(new DynamicObject[]{tpvTmDealrecord});
            }
        }
    }
}
