package tpv.tpv_wm.tpv_tm.java.opplugin.op;

import com.itopview.wm.utils.BigDecimalUtils;
import com.itopview.wm.utils.RptUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.orm.ORM;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.operation.OperationServiceHelper;

import java.math.BigDecimal;
import java.util.List;

/**
 * @Description: 合同结转单 -提交插件
 * @Author LinRui
 * @Date 2024/8/27 14:11
 */
public class ConttranSubmitOp  extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("tpv_strategynum");
        keys.add("tpv_positionnumspur");
        keys.add("tpv_openpositionpur");
        keys.add("tpv_salestrategynum");
        keys.add("tpv_positionnumssale");
        keys.add("tpv_openpositionsale");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
    }

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        DynamicObject[] bills = e.getDataEntities();
        for (int i = 0; i < bills.length; ++i) {
            DynamicObject bill = bills[i];
            setPositionQty("tpv_strategynum", "tpv_positionnumspur", "tpv_openpositionpur", bill);
            setPositionQty("tpv_salestrategynum", "tpv_positionnumssale", "tpv_openpositionsale", bill);
            OperationServiceHelper.executeOperate("save", bill.getDataEntityType().getName(),
                    new DynamicObject[]{bill}, YEM.getOptionNoMsg());
        }
    }

    private void setPositionQty(String name, String positionnumsKey, String openpositionKey, DynamicObject bill) {
        DynamicObject tpvStrategynum = bill.getDynamicObject(name);
        if (YEM.isNotEmpty(tpvStrategynum)) {
            long id = tpvStrategynum.getLong("id");
            DataSet purchase = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_purchase", "id,tpv_contractnumber,tpv_policynumber.id policyid," +
                            "tpv_policynumber.number policynumber,tpv_materialentry,tpv_materialentry.tpv_qty qty",
                    new QFilter[]{new QFilter("tpv_contractstatusx", QCP.in, new String[]{"A", "B", "C", "D", "F", "G"})
                            .and(new QFilter("tpv_policynumber.id", QCP.in, id))}).select("policyid policyid","qty purqty","0.0 saleqty");
            DataSet salescontract = ORM.create().queryDataSet(this.getClass().getName(), "tpv_dt_salescontract", "id,tpv_contractnos,tpv_strategynum.id strategyid," +
                            "tpv_strategynum.number strategynum,tpv_materialentry,tpv_materialentry.tpv_qty qty",
                    new QFilter[]{new QFilter("tpv_contractstatus", QCP.in, new String[]{"A","B","C","D","G","H"})
                            .and(new QFilter("tpv_strategynum.id", QCP.in, id))}).select("strategyid policyid","qty saleqty","0.0 purqty");
            DataSet dataSet = purchase.union(salescontract).groupBy(new String[]{"policyid"}).sum("saleqty").sum("purqty").finish();
            dataSet = RptUtil.zeroNullNums(dataSet);
            dataSet = dataSet.addField("(purqty - saleqty) qty", "qty");
            BigDecimal qty = BigDecimal.ZERO;
            if (!dataSet.isEmpty()) {
                for (Row row : dataSet) {
                    qty = row.getBigDecimal("qty").setScale(2, BigDecimal.ROUND_HALF_UP).abs();
                }
            }
            BigDecimal tpvReplylimit = BigDecimalUtils.toBigDecimal(tpvStrategynum.getBigDecimal("tpv_replylimit")).setScale(2, BigDecimal.ROUND_HALF_UP);
            bill.set(positionnumsKey,qty);
            bill.set(openpositionKey,tpvReplylimit.subtract(qty));
        } else {
            bill.set(positionnumsKey, BigDecimal.ZERO);
            bill.set(openpositionKey, BigDecimal.ZERO);
        }
    }
}
