package tpv.tpv_wm.tpv_tm.java.opplugin.op;

import com.itopview.wm.utils.DynamicObjectUtil;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.List;


/**
 * 期货交易下单人撤销申请-服务插件
 *
 * @author WangShuGuang
 * @description
 * @date 2023年11月30日
 */
public class FuturesrevoOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_tm_personnel");
        fieldKeys.add("tpv_sourceid");
    }

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        String operationKey = e.getOperationKey();
        switch (operationKey) {
            //监听点击保存按钮
            case "save":
                alterState(e, true);
                break;
            case "delete":
                alterState(e, false);
                break;
            case "submit":
                alterState(e, true);
                break;
            default:
                break;
        }
    }

    /**
     * 点击保存按钮反写上游单分录状态为撤销
     */
    public void alterState(BeforeOperationArgs e, Boolean b) {
        DynamicObject[] entities = e.getDataEntities();
        for (DynamicObject entity : entities) {
            //获取单据体
            DynamicObjectCollection objectCollection = entity.getDynamicObjectCollection("tpv_tm_personnel");
            for (DynamicObject dynamicObject : objectCollection) {
                long tpvSourceid = dynamicObject.getLong("tpv_sourceid");
                String selectfieldsFast = DynamicObjectUtil.getSelectfields("tpv_tm_futuresdeal");
                QFilter qFilter = new QFilter("tpv_tm_placepeople", QCP.equals, tpvSourceid);
                DynamicObject tpvTmFuturesdeal = BusinessDataServiceHelper.loadSingle("tpv_tm_futuresdeal", selectfieldsFast, new QFilter[]{qFilter});
                if (null != tpvTmFuturesdeal) {
                    tpvTmFuturesdeal = BusinessDataServiceHelper.loadSingle(tpvTmFuturesdeal.getPkValue(),
                            tpvTmFuturesdeal.getDynamicObjectType().getName());
                    DynamicObjectCollection objectCollectionH = tpvTmFuturesdeal.getDynamicObjectCollection("tpv_tm_placepeople");
                    for (DynamicObject object : objectCollectionH) {
                        long id = object.getLong("id");
                        if (id == tpvSourceid) {
                            if (b) {
                                object.set("tpv_state", "B");
                            } else {
                                object.set("tpv_state", "A");
                            }
                        }
                    }
                    SaveServiceHelper.update(tpvTmFuturesdeal);//写入数据库
                }
            }
        }
    }
}
