package tpv.tpv_wm.tpv_tm.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @ClassName: PassivityhedgingAuditOpPlugin
 * @Description: 被动套保申请单审核反写对应合同是否代客套保
 * @author: zbh
 * @date: 2024-05-09
 */
public class PassivityhedgingAuditOpPlugin  extends AbstractOperationServicePlugIn {

    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        String key = e.getOperationKey();
        switch (key){
            case"audit":
                canWehgua(e,key);
                break;
            case"unaudit":
                canWehgua(e,key);
                break;
        }
    }
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add("tpv_tm_agentcontract");
        fieldKeys.add("tpv_contractnumber");
        fieldKeys.add("tpv_salorpur");
    }
    public void canWehgua(AfterOperationArgs e, String key) {
        DynamicObject[] entities = e.getDataEntities();
        for (DynamicObject entity : entities) {
            DynamicObjectCollection tpvTmAgentcontract = entity.getDynamicObjectCollection("tpv_tm_agentcontract");
            List<String> saleList = tpvTmAgentcontract.stream().filter(s -> s.getString("tpv_salorpur").equals("tpv_dt_salescontract")).map(s -> s.getString("tpv_contractnumber")).collect(Collectors.toList());
            List<String> purcList  = tpvTmAgentcontract.stream().filter(s -> s.getString("tpv_salorpur").equals("tpv_dt_purchase")).map(s -> s.getString("tpv_contractnumber")).collect(Collectors.toList());
            DynamicObject[] salescontract = BusinessDataServiceHelper.load("tpv_dt_salescontract", "tpv_wehgua", new QFilter[]{new QFilter("tpv_contractnos", "in", saleList)});
            for (DynamicObject dynamicObject : salescontract) {
                dynamicObject.set("tpv_wehgua", key.equals("audit")?true:false);
            }
            DynamicObject[] purchase = BusinessDataServiceHelper.load("tpv_dt_purchase", "tpv_wehgua", new QFilter[]{new QFilter("tpv_contractnumber", "in", purcList)});
            for (DynamicObject dynamicObject : purchase) {
                dynamicObject.set("tpv_wehgua", key.equals("audit")?true:false);
            }
            SaveServiceHelper.save(purchase);
            SaveServiceHelper.save(salescontract);
        }
    }
}
