package tpv.tpv_wm.tpv_tm.java.opplugin.op;

import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import tpv.tpv_wm.tpv_tm.java.opplugin.validator.StrategyValidator;

import java.util.List;

/**
 *@Description: 基础资料《策略号》 提交时校验 分录- 分成部门 中 分成比例 为 100%
 *@Project: zhck
 *@Package: tpv.tpv_wm.tpv_tm.java.opplugin.op.StrategyOpPlugin
 *@Date: 2024/04/08 11:18
 *@Author: Heisenberg Wenbei He
 *@Version: 1.0
 */
public class StrategyOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();

        // 分成部门 - 分录标识
        fieldKeys.add("tpv_splitdepartment");
        // 分成部门 -> 分成比例（%）
        fieldKeys.add("tpv_apercentage");
        // 分成部门 -> 分成方式
        fieldKeys.add("tpv_allocationmethod");

        // 套保期现从
        fieldKeys.add("tpv_swaplegdate");
        // 套保期现到
        fieldKeys.add("tpv_swaplegdatato");

        // 有效期从
        fieldKeys.add("tpv_validfrom");
        // 有效期至
        fieldKeys.add("tpv_validuntil");

        // 批复有效期从
        fieldKeys.add("tpv_validuntilfrom");
        // 批复有效期至
        fieldKeys.add("tpv_validuntilapp");
        //协同部门
        fieldKeys.add("tpv_bd_strategy_xt");
        //协同比例（%）
        fieldKeys.add("tpv_proportion");
        fieldKeys.add("tpv_cooperate");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new StrategyValidator());
    }
}
