package tpv.tpv_wm.tpv_tm.java.task;

import com.itopview.wm.utils.DateUtil;
import com.itopview.wm.utils.YEM;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.exception.KDException;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.schedule.executor.AbstractTask;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

import java.util.Date;
import java.util.Map;

/**
 * @ClassName: ClaimdetailsAuditTask
 * @Description:1、确认后生成暂存《认领明细单》，第二天凌晨（如凌晨1点）将前一天的《认领明细单》自动审核。
 * @author: zbh
 * @date: 2024-04-12
 */
public class ClaimdetailsAuditTask extends AbstractTask {
    @Override
    public void execute(RequestContext requestContext, Map<String, Object> map) throws KDException {
        Date date = new Date();
        Date addDays = DateUtil.addDays(date, -1);
        DynamicObject[] tmClaimdetails = BusinessDataServiceHelper.load("tpv_tm_claimdetails", "billno,billstatus", new QFilter[]{new QFilter("createtime", QCP.less_equals, date), new QFilter("createtime", QCP.large_equals, addDays)});

        for (DynamicObject tmClaimdetail : tmClaimdetails) {
//            OperationResult submitOne = OperationServiceHelper.executeOperate("submit",
//                    "tpv_tm_claimdetails", new Object[]{tmClaimdetail.getPkValue()}, YEM.getOption());
//            if (submitOne.isSuccess()) {
                tmClaimdetail.set("billstatus","C");
//            }
        }
        SaveServiceHelper.save(tmClaimdetails);
    }
}
