package tpv.tpv_wm.tpv_wms.java.formplugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.BillShowParameter;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.control.EntryGrid;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;

import java.math.BigDecimal;
import java.util.EventObject;

/**
 * @ClassName: WobbleFromPlugin
 * @Description: 物流合同/指令
 * @author: zbh
 * @date: 2024-07-03
 */
public class WobbleFromPlugin extends AbstractBillPlugIn {

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        BillShowParameter showParameter = (BillShowParameter) this.getView().getFormShowParameter();
        OperationStatus status = showParameter.getStatus(); //获取单据状态
        if (OperationStatus.ADDNEW.equals(status)) {
            String formId = showParameter.getFormId(); //获取单据标识
            if ("tpv_wms_wlzlhe_zl".equals(formId)) {
                this.getModel().setValue("tpv_costship", true);
            }
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String name = e.getProperty().getName();
        switch (name) {
            case "tpv_sapunum":
                sapuNum();
                break;
            case "tpv_docnum":
                EntryGrid entryGridHt = this.getControl("tpv_wms_wlzlhe_goods");//商品明细
                int[] selectRowsHt = entryGridHt.getSelectRows();//获取选中的行号、
                if (selectRowsHt.length == 1) {
                    this.getModel().setValue("tpv_tradenames", null, selectRowsHt[0]);//商品名称
                    this.getModel().setValue("tpv_quantity", null, selectRowsHt[0]);//数量
                    this.getModel().setValue("tpv_legwork", null, selectRowsHt[0]);//物流外勤
                }
                break;
        }
    }

    private void sapuNum() {
        DynamicObject dataEntity = this.getModel().getDataEntity(true);
        EntryGrid entryGridHt = this.getControl("tpv_wms_wlzlhe_goods");//商品明细
        int[] selectRowsHt = entryGridHt.getSelectRows();//获取选中的行号

        if (selectRowsHt.length == 1) {
            DynamicObjectCollection tpvCmTshtTrade = dataEntity.getDynamicObjectCollection("tpv_wms_wlzlhe_goods");
            String tpvDocnum = tpvCmTshtTrade.get(selectRowsHt[0]).getString("tpv_docnum");
            DynamicObject tpvSapunum = tpvCmTshtTrade.get(selectRowsHt[0]).getDynamicObject("tpv_sapunum");
            if ("tpv_bd_purcontrnum".equals(tpvDocnum) && tpvSapunum != null) {//采购
                boolean tpvDtSalescontract1 = QueryServiceHelper.exists("tpv_dt_purchase", tpvSapunum.getPkValue());
                if (tpvDtSalescontract1) {
                    DynamicObject tpvDtPurchase = BusinessDataServiceHelper.loadSingle(tpvSapunum.getPkValue(), "tpv_dt_purchase");
                    DynamicObjectCollection tpvMaterialentrys = tpvDtPurchase.getDynamicObjectCollection("tpv_materialentry");
                    String builder = "";
                    BigDecimal tpvQty = BigDecimal.ZERO;
                    for (DynamicObject tpvMaterialentry : tpvMaterialentrys) {
                        tpvQty = tpvQty.add(tpvMaterialentry.getBigDecimal("tpv_qty"));
                        String name = tpvMaterialentry.getDynamicObject("tpv_material").getString("name");
                        if (builder.length() == 0) {
                            builder = builder + name;
                        } else {
                            if (!builder.contains(name)) {
                                builder = builder + "," + name;
                            }
                        }
                    }
                    this.getModel().setValue("tpv_tradenames", builder, selectRowsHt[0]);//商品名称
                    this.getModel().setValue("tpv_quantity", tpvQty, selectRowsHt[0]);//数量
                    this.getModel().setValue("tpv_legwork", tpvDtPurchase.getDynamicObject("tpv_logisticsfieldserv"), selectRowsHt[0]);//物流外勤
                }

            }
            if ("tpv_bd_salescontract".equals(tpvDocnum) && tpvSapunum != null) {//销售
                DynamicObject tpvDtSalescontract = BusinessDataServiceHelper.loadSingle(tpvSapunum.getPkValue(), "tpv_dt_salescontract");
                DynamicObjectCollection tpvMaterialentrys = tpvDtSalescontract.getDynamicObjectCollection("tpv_materialentry");
                String builder = "";
                BigDecimal tpvQty = BigDecimal.ZERO;
                for (DynamicObject tpvMaterialentry : tpvMaterialentrys) {
                    tpvQty = tpvQty.add(tpvMaterialentry.getBigDecimal("tpv_qty"));
                    String name = tpvMaterialentry.getDynamicObject("tpv_material").getString("name");
                    if (builder.length() == 0) {
                        builder = builder + name;
                    } else {
                        if (!builder.contains(name)) {
                            builder = builder + "," + name;
                        }
                    }
                }

                this.getModel().setValue("tpv_tradenames", builder, selectRowsHt[0]);//商品名称
                this.getModel().setValue("tpv_quantity", tpvQty, selectRowsHt[0]);//数量
                this.getModel().setValue("tpv_legwork", tpvDtSalescontract.getDynamicObject("tpv_logisticspersonnel"), selectRowsHt[0]);//物流外勤
            }

            if ("".equals(tpvDocnum)||tpvSapunum == null) {
                this.getModel().setValue("tpv_tradenames", null, selectRowsHt[0]);//商品名称
                this.getModel().setValue("tpv_quantity", null, selectRowsHt[0]);//数量
                this.getModel().setValue("tpv_legwork", null, selectRowsHt[0]);//物流外勤
            }
        }
    }
}
