package tpv.tpv_wm.tpv_wms.java.opplugin.op;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.drp.dbd.opplugin.payconfig.Validator;

import java.util.List;

/**
 * @ClassName: LogisticsSubmitOp
 * @Description: 物流合同/指令 提交服务插件
 * @author: zbh
 * @date: 2024-05-30
 */
public class LogisticsSubmitOp extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> keys = e.getFieldKeys();
        keys.add("tpv_costship");
        keys.add("tpv_wms_wlzlhe_goods");
    }

    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        super.onAddValidators(e);
        e.addValidator(new Validator() {
            @Override
            public void validate() {
                ExtendedDataEntity[] bills = this.getDataEntities();
                String key = this.getOperateKey();
                for (int i = 0; i < bills.length; i++) {
                    switch (key) {
                        case "submit":
                            submitSupplychain(bills[i]);
                            break;
                        default:
                            break;
                    }
                }
            }

            public void submitSupplychain(ExtendedDataEntity bill) {
                DynamicObject dataEntity = bill.getDataEntity();
                boolean tpvCostship = dataEntity.getBoolean("tpv_costship");
                DynamicObjectCollection tpvGoods = dataEntity.getDynamicObjectCollection("tpv_wms_wlzlhe_goods");
                if (tpvCostship && tpvGoods.size() == 0) {
                    this.addErrorMessage(bill, "【自动估入发货费用】为是，请至少指定一个销售合同到货物明细列表中");
                }
            }
        });
    }
}
