package com.itopview.wm.cm.customplugin;

import com.itopview.wm.utils.BigDecimalUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 计息策略POC1应收金额
 */
@YemImplementation("Poc1ableYemInterface")
public class Poc1ableYemInterface implements YemInterface {
    @Override
    public BigDecimal getBigDecimal(Map map) {
        BigDecimal amt = BigDecimal.ZERO;
        long contract_id = (long) map.get("contract_id");
        if(0L != contract_id){
            DynamicObject contract = BusinessDataServiceHelper.loadSingle(contract_id,"tpv_dt_purchase");
            BigDecimal tpv_amount = contract.getBigDecimal("tpv_amount");//本销售合同的原币金额
            BigDecimal con_qty_s = BigDecimal.ZERO;//本销售合同数量
            DynamicObjectCollection tpv_materialentry_s = contract.getDynamicObjectCollection("tpv_materialentry");
            for(DynamicObject tpv_materialentry : tpv_materialentry_s){
                con_qty_s = BigDecimalUtils.add(con_qty_s,tpv_materialentry.getBigDecimal("tpv_qty"),10);
            }
            BigDecimal tpv_agreedinsrate = contract.getBigDecimal("tpv_agreedinsrate");//约定保比（%）
            tpv_agreedinsrate = BigDecimalUtils.div(tpv_agreedinsrate,BigDecimalUtils.one_handred,10);
            DynamicObject tpv_combinationnumber = contract.getDynamicObject("tpv_combinationnumber");//组合号
            BigDecimal qty_s = BigDecimal.ZERO;//同组合内入库单的入库数量合计
            if(null != tpv_combinationnumber){
                tpv_combinationnumber = BusinessDataServiceHelper.loadSingle(tpv_combinationnumber.getPkValue(),tpv_combinationnumber.getDynamicObjectType().getName());
                DynamicObjectCollection tpv_bd_combination_b_s = tpv_combinationnumber.getDynamicObjectCollection("tpv_bd_combination_b");
                List tpv_contractnum_s = new ArrayList();
                for(DynamicObject tpv_bd_combination_b : tpv_bd_combination_b_s){
                    tpv_contractnum_s.add(tpv_bd_combination_b.getString("tpv_contractnum"));
                }
                QFilter qFilter1 = new QFilter("billno", QCP.in,tpv_contractnum_s);
                DynamicObject [] tpv_dt_purchase_s =  BusinessDataServiceHelper.load("tpv_dt_purchase","id,billno",new QFilter[]{qFilter1});
                List tpv_dt_purchase_id_s = new ArrayList();
                for(DynamicObject tpv_dt_purchase_ : tpv_dt_purchase_s){
                    tpv_dt_purchase_id_s.add(tpv_dt_purchase_.getLong("id"));
                }
                QFilter qFilter2 = new QFilter("billentry.mainbillid", QCP.in,tpv_dt_purchase_id_s);
                DynamicObject [] im_purinbill_s =  BusinessDataServiceHelper.load("im_purinbill",
                        "id,billno,billentry.qty",new QFilter[]{qFilter2});
                for(DynamicObject im_purinbill : im_purinbill_s){
                    DynamicObjectCollection billentry_s = im_purinbill.getDynamicObjectCollection("billentry");
                    for(DynamicObject billentry : billentry_s){
                        qty_s = BigDecimalUtils.add(qty_s,billentry.getBigDecimal("qty"),10);
                    }
                }
            }
            //同组合内     ∑入库单的入库数量 * 本销售合同的原币金额/∑本销售合同数量 * （1-约定保比/100）
            amt = BigDecimalUtils.multiply(qty_s,tpv_amount,10);
            amt = BigDecimalUtils.div(amt,con_qty_s,10);
            amt = BigDecimalUtils.multiply(amt,BigDecimalUtils.sub(BigDecimalUtils.one,tpv_agreedinsrate,10),10);
        }
        return amt;
    }

    @Override
    public boolean getBoolean(Map map) {
        return false;
    }

    @Override
    public String getString(Map map) {
        return null;
    }

    @Override
    public Date getDate(Map map) {
        return null;
    }

    @Override
    public long getLong(Map map) {
        return 0;
    }

    @Override
    public Map getMap(Map map) {
        return null;
    }

    @Override
    public List getList(Map map) {
        return null;
    }
}
