package com.itopview.wm.cm.customplugin;

import com.itopview.wm.utils.BigDecimalUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 计息策略POC1已收金额
 */
@YemImplementation("Poc1edYemInterface")
public class Poc1edYemInterface implements YemInterface {
    @Override
    public BigDecimal getBigDecimal(Map map) {
        BigDecimal amt = BigDecimal.ZERO;
        long contract_id = (long) map.get("contract_id");
        if(0L != contract_id){
            DynamicObject contract = BusinessDataServiceHelper.loadSingle(contract_id,"tpv_dt_salescontract");
            BigDecimal tpv_appointmarginrate = contract.getBigDecimal("tpv_appointmarginrate");//约定保比（%）
            tpv_appointmarginrate = BigDecimalUtils.div(tpv_appointmarginrate,BigDecimalUtils.one_handred,10);
            BigDecimal tpv_amount = BigDecimal.ZERO;//销售发货开单金额
            QFilter qFilter1 = new QFilter("tpv_materialentry.tpv_cobillid", QCP.equals,contract_id);
            DynamicObject [] tpv_dt_salesshipping_s =  BusinessDataServiceHelper.load("tpv_dt_salesshipping",
                    "id,billno,tpv_amount",new QFilter[]{qFilter1});
            for(DynamicObject tpv_dt_salesshipping : tpv_dt_salesshipping_s){
                tpv_amount = BigDecimalUtils.add(tpv_amount,tpv_dt_salesshipping.getBigDecimal("tpv_amount"),10);
            }
            amt = BigDecimalUtils.multiply(tpv_amount,BigDecimalUtils.sub(BigDecimalUtils.one,tpv_appointmarginrate,10),10);
        }
        return amt;
    }

    @Override
    public boolean getBoolean(Map map) {
        return false;
    }

    @Override
    public String getString(Map map) {
        return null;
    }

    @Override
    public Date getDate(Map map) {
        return null;
    }

    @Override
    public long getLong(Map map) {
        return 0;
    }

    @Override
    public Map getMap(Map map) {
        return null;
    }

    @Override
    public List getList(Map map) {
        return null;
    }
}
