package com.itopview.wm.cm.customplugin;

import com.itopview.wm.utils.BigDecimalUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 计息策略POC2应收金额
 */
@YemImplementation("Poc2ableYemInterface")
public class Poc2ableYemInterface implements YemInterface {
    @Override
    public BigDecimal getBigDecimal(Map map) {
        BigDecimal amt = BigDecimal.ZERO;
        long contract_id = (long) map.get("contract_id");
        if(0L != contract_id){
            DynamicObject contract = BusinessDataServiceHelper.loadSingle(contract_id,"tpv_dt_purchase");
            DynamicObject tpv_combinationnumber = contract.getDynamicObject("tpv_combinationnumber");//组合号
            if(null != tpv_combinationnumber){
                tpv_combinationnumber = BusinessDataServiceHelper.loadSingle(tpv_combinationnumber.getPkValue(),tpv_combinationnumber.getDynamicObjectType().getName());
                DynamicObjectCollection tpv_bd_combination_b_s = tpv_combinationnumber.getDynamicObjectCollection("tpv_bd_combination_b");
                List tpv_contractnum_s = new ArrayList();
                for(DynamicObject tpv_bd_combination_b : tpv_bd_combination_b_s){
                    tpv_contractnum_s.add(tpv_bd_combination_b.getString("tpv_contractnum"));
                }
                QFilter qFilter1 = new QFilter("billno", QCP.in,tpv_contractnum_s);
                DynamicObject [] tpv_dt_purchase_s =  BusinessDataServiceHelper.load("tpv_dt_purchase","id,billno",new QFilter[]{qFilter1});
                List tpv_dt_purchase_id_s = new ArrayList();
                for(DynamicObject tpv_dt_purchase_ : tpv_dt_purchase_s){
                    tpv_dt_purchase_id_s.add(tpv_dt_purchase_.getLong("id"));
                }
                QFilter qFilter2 = new QFilter("entry.e_corebillid", QCP.in,tpv_dt_purchase_id_s);
//                qFilter2.and(new QFilter("paymenttype.number", QCP.equals,"").or(new QFilter("paymenttype.number", QCP.equals,"")));
                DynamicObject [] cas_paybill_s =  BusinessDataServiceHelper.load("cas_paybill",
                        "id,billno,entry.e_actamt",new QFilter[]{qFilter2});
                for(DynamicObject cas_paybill : cas_paybill_s){
                    DynamicObjectCollection entry_s = cas_paybill.getDynamicObjectCollection("entry");
                    for(DynamicObject entry : entry_s){
                        amt = BigDecimalUtils.add(amt,entry.getBigDecimal("e_actamt"),10);
                    }
                }
            }
        }
        return amt;
    }

    @Override
    public boolean getBoolean(Map map) {
        return false;
    }

    @Override
    public String getString(Map map) {
        return null;
    }

    @Override
    public Date getDate(Map map) {
        return null;
    }

    @Override
    public long getLong(Map map) {
        return 0;
    }

    @Override
    public Map getMap(Map map) {
        return null;
    }

    @Override
    public List getList(Map map) {
        return null;
    }
}
