package com.itopview.wm.cm.customplugin;

import com.itopview.wm.utils.BigDecimalUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 计息策略POC2已收金额
 */
@YemImplementation("Poc2edYemInterface")
public class Poc2edYemInterface implements YemInterface {
    @Override
    public BigDecimal getBigDecimal(Map map) {
        BigDecimal amt = BigDecimal.ZERO;
        long contract_id = (long) map.get("contract_id");
        if(0L != contract_id){
            DynamicObject contract = BusinessDataServiceHelper.loadSingle(contract_id,"tpv_dt_salescontract");
            QFilter qFilter1 = new QFilter("entry.e_corebillid", QCP.equals,contract_id+"");
            DynamicObject [] cas_recbill_s =  BusinessDataServiceHelper.load("cas_recbill",
                    "id,billno,entry.e_actamt",new QFilter[]{qFilter1});
            for(DynamicObject cas_recbill : cas_recbill_s){
                DynamicObjectCollection entry_s = cas_recbill.getDynamicObjectCollection("entry");
                for(DynamicObject entry : entry_s){
                    amt = BigDecimalUtils.add(amt,entry.getBigDecimal("e_actamt"),10);
                }
            }
        }
        return amt;
    }

    @Override
    public boolean getBoolean(Map map) {
        return false;
    }

    @Override
    public String getString(Map map) {
        return null;
    }

    @Override
    public Date getDate(Map map) {
        return null;
    }

    @Override
    public long getLong(Map map) {
        return 0;
    }

    @Override
    public Map getMap(Map map) {
        return null;
    }

    @Override
    public List getList(Map map) {
        return null;
    }
}
