package com.itopview.wm.cm.customplugin;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @ClassName: Poc3ableYemInterface
 * @Description: 应收项目来源：按本销售合同所在组合内的采购合同，从付款处理取这些采购合同的付款记录，需取的款项类型见下图，作为应收项目来源。
 * @author: zbh
 * @date: 2024-05-22
 */
@YemImplementation("Poc3ableYemInterface")
public class Poc3ableYemInterface implements YemInterface {

    @Override
    public BigDecimal getBigDecimal(Map map) {
        BigDecimal amt = BigDecimal.ZERO;
        long contract_id = (long) map.get("contract_id");
        if (0L != contract_id) {
            DynamicObject salesContract = BusinessDataServiceHelper.loadSingle(contract_id, "tpv_dt_purchase");
            DynamicObject tpvCombinationnumber = salesContract.getDynamicObject("tpv_combinationnumber");
            DynamicObject[] purChase = BusinessDataServiceHelper.load("tpv_dt_purchase", "id", new QFilter[]{new QFilter("tpv_combinationnumber.id", "=", tpvCombinationnumber.getPkValue())});
            List<Long> purIds = Arrays.stream(purChase).map(x -> x.getLong("id")).collect(Collectors.toList());
            List<String> listName = new ArrayList<>();
            listName.add("付采购合同保证金");
            listName.add("国外采购货款-应付");
            listName.add("国外采购货款-预付");
            listName.add("国内采购货款-先货后款");
            listName.add("国内采购货款-远期预付");
            listName.add("国内采购货款-现货预付");
            listName.add("国内采购货款-尾款后提货");
            DynamicObject[] expenseitemedit = BusinessDataServiceHelper.load("er_expenseitemedit", "id", new QFilter[]{new QFilter("name", "in", listName)});
            List<Long> expenIds = Arrays.stream(expenseitemedit).map(x -> x.getLong("id")).collect(Collectors.toList());
            DynamicObject[] casPaybills = BusinessDataServiceHelper.load("cas_paybill", "entry,shkd_con_amount,e_expenseitem,shkd_purcontract", new QFilter[]{new QFilter("entry.shkd_purcontract.id", "in", purIds), new QFilter("entry.e_expenseitem", "in", expenIds)});
            for (DynamicObject casPaybill : casPaybills) {
                DynamicObjectCollection entrys = casPaybill.getDynamicObjectCollection("entry");
                for (DynamicObject entry : entrys) {
                    DynamicObject eExpenseitem = entry.getDynamicObject("e_expenseitem");
                    DynamicObject shkdPurcontract = entry.getDynamicObject("shkd_purcontract");
                    if (eExpenseitem == null && shkdPurcontract == null) {
                        continue;
                    }
                    if (expenIds.contains(eExpenseitem.getLong("id")) && purIds.contains(shkdPurcontract.getLong("id"))) {
                        amt = amt.add(entry.getBigDecimal("shkd_con_amount"));
                    }
                }
            }
        }
        return amt;
    }

    @Override
    public boolean getBoolean(Map map) {
        return false;
    }

    @Override
    public String getString(Map map) {
        return null;
    }

    @Override
    public Date getDate(Map map) {
        return null;
    }

    @Override
    public long getLong(Map map) {
        return 0;
    }

    @Override
    public Map getMap(Map map) {
        return null;
    }

    @Override
    public List getList(Map map) {
        return null;
    }
}
